#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 11899
#define SYMBOL_COUNT 270
#define ALIAS_COUNT 13
#define TOKEN_COUNT 144
#define EXTERNAL_TOKEN_COUNT 22
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  sym__line_break2 = 1,
  sym__simple_symbol2 = 2,
  sym__string_start2 = 3,
  sym__symbol_start2 = 4,
  sym__subshell_start2 = 5,
  sym__regex_start2 = 6,
  sym__string_array_start2 = 7,
  sym__symbol_array_start2 = 8,
  sym__heredoc_body_start2 = 9,
  sym__string_content2 = 10,
  sym__heredoc_content2 = 11,
  sym__string_end2 = 12,
  sym_heredoc_end2 = 13,
  sym_heredoc_beginning2 = 14,
  sym__block_ampersand2 = 15,
  sym__splat_star2 = 16,
  sym__unary_minus2 = 17,
  sym__binary_minus2 = 18,
  sym__binary_star2 = 19,
  sym__singleton_class_left_angle_left_langle2 = 20,
  sym__identifier_hash_key2 = 21,
  anon_sym___END__ = 22,
  sym_uninterpreted = 23,
  anon_sym_BEGIN = 24,
  anon_sym_LBRACE = 25,
  anon_sym_RBRACE = 26,
  anon_sym_END = 27,
  anon_sym_def = 28,
  anon_sym_LPAREN = 29,
  anon_sym_RPAREN = 30,
  anon_sym_DOT = 31,
  anon_sym_COLON_COLON = 32,
  anon_sym_COMMA = 33,
  anon_sym_PIPE = 34,
  anon_sym_SEMI = 35,
  anon_sym_STAR = 36,
  anon_sym_STAR_STAR = 37,
  anon_sym_AMP = 38,
  anon_sym_COLON = 39,
  anon_sym_EQ = 40,
  anon_sym_class = 41,
  anon_sym_LT = 42,
  anon_sym_module = 43,
  anon_sym_end = 44,
  anon_sym_return = 45,
  anon_sym_yield = 46,
  anon_sym_break = 47,
  anon_sym_next = 48,
  sym_redo = 49,
  sym_retry = 50,
  anon_sym_if = 51,
  anon_sym_unless = 52,
  anon_sym_while = 53,
  anon_sym_until = 54,
  anon_sym_rescue = 55,
  anon_sym_for = 56,
  anon_sym_in = 57,
  anon_sym_do = 58,
  anon_sym_case = 59,
  anon_sym_when = 60,
  anon_sym_elsif = 61,
  anon_sym_else = 62,
  anon_sym_then = 63,
  anon_sym_begin = 64,
  anon_sym_ensure = 65,
  anon_sym_EQ_GT = 66,
  anon_sym_LBRACK = 67,
  anon_sym_RBRACK = 68,
  anon_sym_COLON_COLON2 = 69,
  anon_sym_AMP_DOT = 70,
  anon_sym_LPAREN2 = 71,
  anon_sym_PLUS_EQ = 72,
  anon_sym_DASH_EQ = 73,
  anon_sym_STAR_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_SLASH_EQ = 76,
  anon_sym_PIPE_PIPE_EQ = 77,
  anon_sym_PIPE_EQ = 78,
  anon_sym_AMP_AMP_EQ = 79,
  anon_sym_AMP_EQ = 80,
  anon_sym_PERCENT_EQ = 81,
  anon_sym_GT_GT_EQ = 82,
  anon_sym_LT_LT_EQ = 83,
  anon_sym_CARET_EQ = 84,
  anon_sym_QMARK = 85,
  anon_sym_COLON2 = 86,
  anon_sym_DOT_DOT = 87,
  anon_sym_DOT_DOT_DOT = 88,
  anon_sym_and = 89,
  anon_sym_or = 90,
  anon_sym_PIPE_PIPE = 91,
  anon_sym_AMP_AMP = 92,
  anon_sym_LT_LT = 93,
  anon_sym_GT_GT = 94,
  anon_sym_EQ_EQ = 95,
  anon_sym_BANG_EQ = 96,
  anon_sym_EQ_EQ_EQ = 97,
  anon_sym_LT_EQ_GT = 98,
  anon_sym_EQ_TILDE = 99,
  anon_sym_BANG_TILDE = 100,
  anon_sym_LT_EQ = 101,
  anon_sym_GT = 102,
  anon_sym_GT_EQ = 103,
  anon_sym_CARET = 104,
  anon_sym_PLUS = 105,
  anon_sym_SLASH = 106,
  anon_sym_PERCENT = 107,
  anon_sym_defined_QMARK = 108,
  anon_sym_not = 109,
  anon_sym_BANG = 110,
  anon_sym_TILDE = 111,
  sym_constant = 112,
  sym_identifier = 113,
  sym_instance_variable = 114,
  sym_class_variable = 115,
  sym_global_variable = 116,
  anon_sym_DASH = 117,
  anon_sym_PLUS_AT = 118,
  anon_sym_DASH_AT = 119,
  anon_sym_LBRACK_RBRACK = 120,
  anon_sym_LBRACK_RBRACK_EQ = 121,
  anon_sym_BQUOTE = 122,
  anon_sym_undef = 123,
  anon_sym_alias = 124,
  sym_comment = 125,
  sym_integer = 126,
  sym_float = 127,
  sym_complex = 128,
  anon_sym_r = 129,
  sym_super = 130,
  anon_sym_true = 131,
  anon_sym_TRUE = 132,
  anon_sym_false = 133,
  anon_sym_FALSE = 134,
  sym_self = 135,
  anon_sym_nil = 136,
  anon_sym_NIL = 137,
  sym_character = 138,
  anon_sym_POUND_LBRACE = 139,
  aux_sym_SLASH_BSLASHs_PLUS_SLASH = 140,
  sym_escape_sequence = 141,
  anon_sym_LBRACK2 = 142,
  anon_sym_DASH_GT = 143,
  sym_program = 144,
  sym__statements = 145,
  sym__top_level_statement = 146,
  sym_begin_block = 147,
  sym_end_block = 148,
  sym__statement = 149,
  sym_method = 150,
  sym_singleton_method = 151,
  sym__method_rest = 152,
  sym_method_parameters = 153,
  sym_lambda_parameters = 154,
  sym_block_parameters = 155,
  sym__formal_parameter = 156,
  sym__simple_formal_parameter = 157,
  sym_destructured_parameter = 158,
  sym_splat_parameter = 159,
  sym_hash_splat_parameter = 160,
  sym_block_parameter = 161,
  sym_keyword_parameter = 162,
  sym_optional_parameter = 163,
  sym_class = 164,
  sym_superclass = 165,
  sym_singleton_class = 166,
  sym_module = 167,
  sym_return = 168,
  sym_yield = 169,
  sym_break = 170,
  sym_next = 171,
  sym_if_modifier = 172,
  sym_unless_modifier = 173,
  sym_while_modifier = 174,
  sym_until_modifier = 175,
  sym_rescue_modifier = 176,
  sym_while = 177,
  sym_until = 178,
  sym_for = 179,
  sym_in = 180,
  sym__do = 181,
  sym_case = 182,
  sym_when = 183,
  sym_pattern = 184,
  sym_if = 185,
  sym_unless = 186,
  sym_elsif = 187,
  sym_else = 188,
  sym__then = 189,
  sym__if_tail = 190,
  sym_begin = 191,
  sym_ensure = 192,
  sym_rescue = 193,
  sym_exceptions = 194,
  sym_exception_variable = 195,
  sym__body_statement = 196,
  sym__arg = 197,
  sym__primary = 198,
  sym_parenthesized_statements = 199,
  sym_element_reference = 200,
  sym_scope_resolution = 201,
  sym_call = 202,
  sym_method_call = 203,
  sym_argument_list = 204,
  sym_argument_list_with_parens = 205,
  sym__argument_list_with_parens = 206,
  sym__argument_list_with_trailing_comma = 207,
  sym__argument = 208,
  sym_splat_argument = 209,
  sym_hash_splat_argument = 210,
  sym_block_argument = 211,
  sym_do_block = 212,
  sym_block = 213,
  sym_assignment = 214,
  sym_operator_assignment = 215,
  sym_conditional = 216,
  sym_range = 217,
  sym_binary = 218,
  sym_unary = 219,
  sym_right_assignment_list = 220,
  sym__arg_or_splat_arg = 221,
  sym_left_assignment_list = 222,
  sym__mlhs = 223,
  sym__simple_mlhs = 224,
  sym_destructured_left_assignment = 225,
  sym_rest_assignment = 226,
  sym__lhs = 227,
  sym__variable = 228,
  sym_operator = 229,
  sym__method_name = 230,
  sym_setter = 231,
  sym_undef = 232,
  sym_alias = 233,
  sym_rational = 234,
  sym_true = 235,
  sym_false = 236,
  sym_nil = 237,
  sym_chained_string = 238,
  sym_interpolation = 239,
  sym_string = 240,
  sym_subshell = 241,
  sym_string_array = 242,
  sym_symbol_array = 243,
  sym_symbol = 244,
  sym_regex = 245,
  sym_heredoc_body = 246,
  sym__literal_contents = 247,
  sym_array = 248,
  sym_hash = 249,
  sym__hash_items = 250,
  sym_pair = 251,
  sym_lambda = 252,
  sym_empty_statement = 253,
  sym__terminator = 254,
  aux_sym__statements_repeat1 = 255,
  aux_sym_method_parameters_repeat1 = 256,
  aux_sym_lambda_parameters_repeat1 = 257,
  aux_sym_block_parameters_repeat1 = 258,
  aux_sym_case_repeat1 = 259,
  aux_sym_when_repeat1 = 260,
  aux_sym_exceptions_repeat1 = 261,
  aux_sym_call_repeat1 = 262,
  aux_sym_argument_list_repeat1 = 263,
  aux_sym_undef_repeat1 = 264,
  aux_sym_chained_string_repeat1 = 265,
  aux_sym_string_array_repeat1 = 266,
  aux_sym_symbol_array_repeat1 = 267,
  aux_sym_heredoc_body_repeat1 = 268,
  aux_sym__literal_contents_repeat1 = 269,
  anon_alias_sym_DQUOTE = 270,
  anon_alias_sym_PERCENTi_LPAREN = 271,
  anon_alias_sym_PERCENTw_LPAREN = 272,
  anon_alias_sym_RPAREN = 273,
  anon_alias_sym_STAR = 274,
  anon_alias_sym_DASH = 275,
  anon_alias_sym_SLASH = 276,
  anon_alias_sym_COLON_DQUOTE = 277,
  anon_alias_sym_LT_LT = 278,
  anon_alias_sym_BQUOTE = 279,
  alias_sym_bare_string = 280,
  alias_sym_bare_symbol = 281,
  alias_sym_symbol = 282,
};

static const char *ts_symbol_names[] = {
  [sym__line_break2] = "_line_break",
  [sym__simple_symbol2] = "_simple_symbol",
  [sym__string_start2] = "_string_start",
  [sym__symbol_start2] = "_symbol_start",
  [sym__subshell_start2] = "_subshell_start",
  [sym__regex_start2] = "_regex_start",
  [sym__string_array_start2] = "_string_array_start",
  [sym__symbol_array_start2] = "_symbol_array_start",
  [sym__heredoc_body_start2] = "_heredoc_body_start",
  [sym__string_content2] = "_string_content",
  [sym__heredoc_content2] = "_heredoc_content",
  [sym__string_end2] = "_string_end",
  [sym_heredoc_end2] = "heredoc_end",
  [sym_heredoc_beginning2] = "heredoc_beginning",
  [sym__block_ampersand2] = "_block_ampersand",
  [sym__splat_star2] = "_splat_star",
  [sym__unary_minus2] = "_unary_minus",
  [sym__binary_minus2] = "_binary_minus",
  [sym__binary_star2] = "_binary_star",
  [sym__singleton_class_left_angle_left_langle2] = "_singleton_class_left_angle_left_langle",
  [sym__identifier_hash_key2] = "_identifier_hash_key",
  [ts_builtin_sym_end] = "END",
  [anon_sym___END__] = "__END__",
  [sym_uninterpreted] = "uninterpreted",
  [anon_sym_BEGIN] = "BEGIN",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_END] = "END",
  [anon_sym_def] = "def",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_DOT] = ".",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_COMMA] = ",",
  [anon_sym_PIPE] = "|",
  [anon_sym_SEMI] = ";",
  [anon_sym_STAR] = "*",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_AMP] = "&",
  [anon_sym_COLON] = ":",
  [anon_sym_EQ] = "=",
  [anon_sym_class] = "class",
  [anon_sym_LT] = "<",
  [anon_sym_module] = "module",
  [anon_sym_end] = "end",
  [anon_sym_return] = "return",
  [anon_sym_yield] = "yield",
  [anon_sym_break] = "break",
  [anon_sym_next] = "next",
  [sym_redo] = "redo",
  [sym_retry] = "retry",
  [anon_sym_if] = "if",
  [anon_sym_unless] = "unless",
  [anon_sym_while] = "while",
  [anon_sym_until] = "until",
  [anon_sym_rescue] = "rescue",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_do] = "do",
  [anon_sym_case] = "case",
  [anon_sym_when] = "when",
  [anon_sym_elsif] = "elsif",
  [anon_sym_else] = "else",
  [anon_sym_then] = "then",
  [anon_sym_begin] = "begin",
  [anon_sym_ensure] = "ensure",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_COLON_COLON2] = "::",
  [anon_sym_AMP_DOT] = "&.",
  [anon_sym_LPAREN2] = "(",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PIPE_PIPE_EQ] = "||=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_AMP_AMP_EQ] = "&&=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_QMARK] = "?",
  [anon_sym_COLON2] = ":",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym_DOT_DOT_DOT] = "...",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_EQ_EQ_EQ] = "===",
  [anon_sym_LT_EQ_GT] = "<=>",
  [anon_sym_EQ_TILDE] = "=~",
  [anon_sym_BANG_TILDE] = "!~",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_GT] = ">",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_CARET] = "^",
  [anon_sym_PLUS] = "+",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_defined_QMARK] = "defined?",
  [anon_sym_not] = "not",
  [anon_sym_BANG] = "!",
  [anon_sym_TILDE] = "~",
  [sym_constant] = "constant",
  [sym_identifier] = "identifier",
  [sym_instance_variable] = "instance_variable",
  [sym_class_variable] = "class_variable",
  [sym_global_variable] = "global_variable",
  [anon_sym_DASH] = "-",
  [anon_sym_PLUS_AT] = "+@",
  [anon_sym_DASH_AT] = "-@",
  [anon_sym_LBRACK_RBRACK] = "[]",
  [anon_sym_LBRACK_RBRACK_EQ] = "[]=",
  [anon_sym_BQUOTE] = "`",
  [anon_sym_undef] = "undef",
  [anon_sym_alias] = "alias",
  [sym_comment] = "comment",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_complex] = "complex",
  [anon_sym_r] = "r",
  [sym_super] = "super",
  [anon_sym_true] = "true",
  [anon_sym_TRUE] = "TRUE",
  [anon_sym_false] = "false",
  [anon_sym_FALSE] = "FALSE",
  [sym_self] = "self",
  [anon_sym_nil] = "nil",
  [anon_sym_NIL] = "NIL",
  [sym_character] = "character",
  [anon_sym_POUND_LBRACE] = "#{",
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = "/\\s+/",
  [sym_escape_sequence] = "escape_sequence",
  [anon_sym_LBRACK2] = "[",
  [anon_sym_DASH_GT] = "->",
  [sym_program] = "program",
  [sym__statements] = "_statements",
  [sym__top_level_statement] = "_top_level_statement",
  [sym_begin_block] = "begin_block",
  [sym_end_block] = "end_block",
  [sym__statement] = "_statement",
  [sym_method] = "method",
  [sym_singleton_method] = "singleton_method",
  [sym__method_rest] = "_method_rest",
  [sym_method_parameters] = "method_parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym_block_parameters] = "block_parameters",
  [sym__formal_parameter] = "_formal_parameter",
  [sym__simple_formal_parameter] = "_simple_formal_parameter",
  [sym_destructured_parameter] = "destructured_parameter",
  [sym_splat_parameter] = "splat_parameter",
  [sym_hash_splat_parameter] = "hash_splat_parameter",
  [sym_block_parameter] = "block_parameter",
  [sym_keyword_parameter] = "keyword_parameter",
  [sym_optional_parameter] = "optional_parameter",
  [sym_class] = "class",
  [sym_superclass] = "superclass",
  [sym_singleton_class] = "singleton_class",
  [sym_module] = "module",
  [sym_return] = "return",
  [sym_yield] = "yield",
  [sym_break] = "break",
  [sym_next] = "next",
  [sym_if_modifier] = "if_modifier",
  [sym_unless_modifier] = "unless_modifier",
  [sym_while_modifier] = "while_modifier",
  [sym_until_modifier] = "until_modifier",
  [sym_rescue_modifier] = "rescue_modifier",
  [sym_while] = "while",
  [sym_until] = "until",
  [sym_for] = "for",
  [sym_in] = "in",
  [sym__do] = "_do",
  [sym_case] = "case",
  [sym_when] = "when",
  [sym_pattern] = "pattern",
  [sym_if] = "if",
  [sym_unless] = "unless",
  [sym_elsif] = "elsif",
  [sym_else] = "else",
  [sym__then] = "_then",
  [sym__if_tail] = "_if_tail",
  [sym_begin] = "begin",
  [sym_ensure] = "ensure",
  [sym_rescue] = "rescue",
  [sym_exceptions] = "exceptions",
  [sym_exception_variable] = "exception_variable",
  [sym__body_statement] = "_body_statement",
  [sym__arg] = "_arg",
  [sym__primary] = "_primary",
  [sym_parenthesized_statements] = "parenthesized_statements",
  [sym_element_reference] = "element_reference",
  [sym_scope_resolution] = "scope_resolution",
  [sym_call] = "call",
  [sym_method_call] = "method_call",
  [sym_argument_list] = "argument_list",
  [sym_argument_list_with_parens] = "argument_list_with_parens",
  [sym__argument_list_with_parens] = "_argument_list_with_parens",
  [sym__argument_list_with_trailing_comma] = "_argument_list_with_trailing_comma",
  [sym__argument] = "_argument",
  [sym_splat_argument] = "splat_argument",
  [sym_hash_splat_argument] = "hash_splat_argument",
  [sym_block_argument] = "block_argument",
  [sym_do_block] = "do_block",
  [sym_block] = "block",
  [sym_assignment] = "assignment",
  [sym_operator_assignment] = "operator_assignment",
  [sym_conditional] = "conditional",
  [sym_range] = "range",
  [sym_binary] = "binary",
  [sym_unary] = "unary",
  [sym_right_assignment_list] = "right_assignment_list",
  [sym__arg_or_splat_arg] = "_arg_or_splat_arg",
  [sym_left_assignment_list] = "left_assignment_list",
  [sym__mlhs] = "_mlhs",
  [sym__simple_mlhs] = "_simple_mlhs",
  [sym_destructured_left_assignment] = "destructured_left_assignment",
  [sym_rest_assignment] = "rest_assignment",
  [sym__lhs] = "_lhs",
  [sym__variable] = "_variable",
  [sym_operator] = "operator",
  [sym__method_name] = "_method_name",
  [sym_setter] = "setter",
  [sym_undef] = "undef",
  [sym_alias] = "alias",
  [sym_rational] = "rational",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_nil] = "nil",
  [sym_chained_string] = "chained_string",
  [sym_interpolation] = "interpolation",
  [sym_string] = "string",
  [sym_subshell] = "subshell",
  [sym_string_array] = "string_array",
  [sym_symbol_array] = "symbol_array",
  [sym_symbol] = "symbol",
  [sym_regex] = "regex",
  [sym_heredoc_body] = "heredoc_body",
  [sym__literal_contents] = "_literal_contents",
  [sym_array] = "array",
  [sym_hash] = "hash",
  [sym__hash_items] = "_hash_items",
  [sym_pair] = "pair",
  [sym_lambda] = "lambda",
  [sym_empty_statement] = "empty_statement",
  [sym__terminator] = "_terminator",
  [aux_sym__statements_repeat1] = "_statements_repeat1",
  [aux_sym_method_parameters_repeat1] = "method_parameters_repeat1",
  [aux_sym_lambda_parameters_repeat1] = "lambda_parameters_repeat1",
  [aux_sym_block_parameters_repeat1] = "block_parameters_repeat1",
  [aux_sym_case_repeat1] = "case_repeat1",
  [aux_sym_when_repeat1] = "when_repeat1",
  [aux_sym_exceptions_repeat1] = "exceptions_repeat1",
  [aux_sym_call_repeat1] = "call_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_undef_repeat1] = "undef_repeat1",
  [aux_sym_chained_string_repeat1] = "chained_string_repeat1",
  [aux_sym_string_array_repeat1] = "string_array_repeat1",
  [aux_sym_symbol_array_repeat1] = "symbol_array_repeat1",
  [aux_sym_heredoc_body_repeat1] = "heredoc_body_repeat1",
  [aux_sym__literal_contents_repeat1] = "_literal_contents_repeat1",
  [anon_alias_sym_DQUOTE] = "\"",
  [anon_alias_sym_PERCENTi_LPAREN] = "%i(",
  [anon_alias_sym_PERCENTw_LPAREN] = "%w(",
  [anon_alias_sym_RPAREN] = ")",
  [anon_alias_sym_STAR] = "*",
  [anon_alias_sym_DASH] = "-",
  [anon_alias_sym_SLASH] = "/",
  [anon_alias_sym_COLON_DQUOTE] = ":\"",
  [anon_alias_sym_LT_LT] = "<<",
  [anon_alias_sym_BQUOTE] = "`",
  [alias_sym_bare_string] = "bare_string",
  [alias_sym_bare_symbol] = "bare_symbol",
  [alias_sym_symbol] = "symbol",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__line_break2] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_symbol2] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__symbol_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__subshell_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__regex_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__string_array_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__symbol_array_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_body_start2] = {
    .visible = false,
    .named = true,
  },
  [sym__string_content2] = {
    .visible = false,
    .named = true,
  },
  [sym__heredoc_content2] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end2] = {
    .visible = false,
    .named = true,
  },
  [sym_heredoc_end2] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_beginning2] = {
    .visible = true,
    .named = true,
  },
  [sym__block_ampersand2] = {
    .visible = false,
    .named = true,
  },
  [sym__splat_star2] = {
    .visible = false,
    .named = true,
  },
  [sym__unary_minus2] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_minus2] = {
    .visible = false,
    .named = true,
  },
  [sym__binary_star2] = {
    .visible = false,
    .named = true,
  },
  [sym__singleton_class_left_angle_left_langle2] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_hash_key2] = {
    .visible = false,
    .named = true,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym___END__] = {
    .visible = true,
    .named = false,
  },
  [sym_uninterpreted] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_BEGIN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_END] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_end] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_next] = {
    .visible = true,
    .named = false,
  },
  [sym_redo] = {
    .visible = true,
    .named = true,
  },
  [sym_retry] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unless] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_until] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_rescue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elsif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_begin] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ensure] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_defined_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [sym_constant] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_instance_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_class_variable] = {
    .visible = true,
    .named = true,
  },
  [sym_global_variable] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK_RBRACK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_complex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_r] = {
    .visible = true,
    .named = false,
  },
  [sym_super] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TRUE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_FALSE] = {
    .visible = true,
    .named = false,
  },
  [sym_self] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_nil] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_NIL] = {
    .visible = true,
    .named = false,
  },
  [sym_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_POUND_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK2] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [sym_program] = {
    .visible = true,
    .named = true,
  },
  [sym__statements] = {
    .visible = false,
    .named = true,
  },
  [sym__top_level_statement] = {
    .visible = false,
    .named = true,
  },
  [sym_begin_block] = {
    .visible = true,
    .named = true,
  },
  [sym_end_block] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_method] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_method] = {
    .visible = true,
    .named = true,
  },
  [sym__method_rest] = {
    .visible = false,
    .named = true,
  },
  [sym_method_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_formal_parameter] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_block_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_optional_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_class] = {
    .visible = true,
    .named = true,
  },
  [sym_superclass] = {
    .visible = true,
    .named = true,
  },
  [sym_singleton_class] = {
    .visible = true,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym_return] = {
    .visible = true,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_break] = {
    .visible = true,
    .named = true,
  },
  [sym_next] = {
    .visible = true,
    .named = true,
  },
  [sym_if_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_unless_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_until_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_while] = {
    .visible = true,
    .named = true,
  },
  [sym_until] = {
    .visible = true,
    .named = true,
  },
  [sym_for] = {
    .visible = true,
    .named = true,
  },
  [sym_in] = {
    .visible = true,
    .named = true,
  },
  [sym__do] = {
    .visible = false,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_when] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_if] = {
    .visible = true,
    .named = true,
  },
  [sym_unless] = {
    .visible = true,
    .named = true,
  },
  [sym_elsif] = {
    .visible = true,
    .named = true,
  },
  [sym_else] = {
    .visible = true,
    .named = true,
  },
  [sym__then] = {
    .visible = false,
    .named = true,
  },
  [sym__if_tail] = {
    .visible = false,
    .named = true,
  },
  [sym_begin] = {
    .visible = true,
    .named = true,
  },
  [sym_ensure] = {
    .visible = true,
    .named = true,
  },
  [sym_rescue] = {
    .visible = true,
    .named = true,
  },
  [sym_exceptions] = {
    .visible = true,
    .named = true,
  },
  [sym_exception_variable] = {
    .visible = true,
    .named = true,
  },
  [sym__body_statement] = {
    .visible = false,
    .named = true,
  },
  [sym__arg] = {
    .visible = false,
    .named = true,
  },
  [sym__primary] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_statements] = {
    .visible = true,
    .named = true,
  },
  [sym_element_reference] = {
    .visible = true,
    .named = true,
  },
  [sym_scope_resolution] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_method_call] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list_with_parens] = {
    .visible = true,
    .named = true,
  },
  [sym__argument_list_with_parens] = {
    .visible = false,
    .named = true,
  },
  [sym__argument_list_with_trailing_comma] = {
    .visible = false,
    .named = true,
  },
  [sym__argument] = {
    .visible = false,
    .named = true,
  },
  [sym_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_hash_splat_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_block_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_do_block] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional] = {
    .visible = true,
    .named = true,
  },
  [sym_range] = {
    .visible = true,
    .named = true,
  },
  [sym_binary] = {
    .visible = true,
    .named = true,
  },
  [sym_unary] = {
    .visible = true,
    .named = true,
  },
  [sym_right_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__arg_or_splat_arg] = {
    .visible = false,
    .named = true,
  },
  [sym_left_assignment_list] = {
    .visible = true,
    .named = true,
  },
  [sym__mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_mlhs] = {
    .visible = false,
    .named = true,
  },
  [sym_destructured_left_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_rest_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__variable] = {
    .visible = false,
    .named = true,
  },
  [sym_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__method_name] = {
    .visible = false,
    .named = true,
  },
  [sym_setter] = {
    .visible = true,
    .named = true,
  },
  [sym_undef] = {
    .visible = true,
    .named = true,
  },
  [sym_alias] = {
    .visible = true,
    .named = true,
  },
  [sym_rational] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_nil] = {
    .visible = true,
    .named = true,
  },
  [sym_chained_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_subshell] = {
    .visible = true,
    .named = true,
  },
  [sym_string_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol_array] = {
    .visible = true,
    .named = true,
  },
  [sym_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym_regex] = {
    .visible = true,
    .named = true,
  },
  [sym_heredoc_body] = {
    .visible = true,
    .named = true,
  },
  [sym__literal_contents] = {
    .visible = false,
    .named = true,
  },
  [sym_array] = {
    .visible = true,
    .named = true,
  },
  [sym_hash] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_items] = {
    .visible = false,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__terminator] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_lambda_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_case_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_when_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_exceptions_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_call_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_undef_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_chained_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_symbol_array_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_heredoc_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__literal_contents_repeat1] = {
    .visible = false,
    .named = false,
  },
  [anon_alias_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_PERCENTi_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_PERCENTw_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_COLON_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_alias_sym_BQUOTE] = {
    .visible = true,
    .named = false,
  },
  [alias_sym_bare_string] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_bare_symbol] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_symbol] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[34][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = anon_alias_sym_DQUOTE,
    [1] = anon_alias_sym_DQUOTE,
  },
  [2] = {
    [0] = anon_alias_sym_COLON_DQUOTE,
    [1] = anon_alias_sym_DQUOTE,
  },
  [3] = {
    [0] = anon_alias_sym_BQUOTE,
    [1] = anon_alias_sym_BQUOTE,
  },
  [4] = {
    [0] = anon_alias_sym_SLASH,
    [1] = anon_alias_sym_SLASH,
  },
  [5] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [1] = anon_alias_sym_RPAREN,
  },
  [6] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [1] = anon_alias_sym_RPAREN,
  },
  [7] = {
    [0] = anon_alias_sym_DASH,
  },
  [8] = {
    [0] = anon_alias_sym_DQUOTE,
    [2] = anon_alias_sym_DQUOTE,
  },
  [9] = {
    [0] = anon_alias_sym_COLON_DQUOTE,
    [2] = anon_alias_sym_DQUOTE,
  },
  [10] = {
    [0] = anon_alias_sym_BQUOTE,
    [2] = anon_alias_sym_BQUOTE,
  },
  [11] = {
    [0] = anon_alias_sym_SLASH,
    [2] = anon_alias_sym_SLASH,
  },
  [12] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [2] = anon_alias_sym_RPAREN,
  },
  [13] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [1] = alias_sym_bare_string,
    [2] = anon_alias_sym_RPAREN,
  },
  [14] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [2] = anon_alias_sym_RPAREN,
  },
  [15] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [1] = alias_sym_bare_symbol,
    [2] = anon_alias_sym_RPAREN,
  },
  [16] = {
    [1] = anon_alias_sym_DASH,
  },
  [17] = {
    [1] = anon_alias_sym_STAR,
  },
  [18] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [3] = anon_alias_sym_RPAREN,
  },
  [19] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [2] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [20] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [1] = alias_sym_bare_string,
    [3] = anon_alias_sym_RPAREN,
  },
  [21] = {
    [1] = alias_sym_bare_string,
  },
  [22] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [3] = anon_alias_sym_RPAREN,
  },
  [23] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [2] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [24] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [1] = alias_sym_bare_symbol,
    [3] = anon_alias_sym_RPAREN,
  },
  [25] = {
    [1] = alias_sym_bare_symbol,
  },
  [26] = {
    [0] = alias_sym_symbol,
  },
  [27] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [2] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [28] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [1] = alias_sym_bare_string,
    [4] = anon_alias_sym_RPAREN,
  },
  [29] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [2] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [30] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [1] = alias_sym_bare_symbol,
    [4] = anon_alias_sym_RPAREN,
  },
  [31] = {
    [1] = anon_alias_sym_LT_LT,
  },
  [32] = {
    [0] = anon_alias_sym_PERCENTw_LPAREN,
    [2] = alias_sym_bare_string,
    [5] = anon_alias_sym_RPAREN,
  },
  [33] = {
    [0] = anon_alias_sym_PERCENTi_LPAREN,
    [2] = alias_sym_bare_symbol,
    [5] = anon_alias_sym_RPAREN,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_BANG_TILDE);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead == '{')
        ADVANCE(6);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_POUND_LBRACE);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(7);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(sym_global_variable);
      if (lookahead == '-')
        ADVANCE(9);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      if (lookahead == '!' ||
          lookahead == '\"' ||
          lookahead == '$' ||
          lookahead == '&' ||
          lookahead == '\'' ||
          ('*' <= lookahead && lookahead <= ',') ||
          ('.' <= lookahead && lookahead <= '@') ||
          lookahead == '\\' ||
          lookahead == '`' ||
          lookahead == '~')
        ADVANCE(11);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('_' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(10);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(sym_global_variable);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(sym_global_variable);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(12);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(16);
      if (lookahead == '.')
        ADVANCE(18);
      if (lookahead == '=')
        ADVANCE(19);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_AMP_AMP_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_AMP_DOT);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_LPAREN2);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(anon_sym_PLUS_AT);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '@')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_DASH_AT);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      if (lookahead == '.')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_DOT_DOT_DOT);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '=')
        ADVANCE(36);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(38);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(39);
      END_STATE();
    case 40:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      END_STATE();
    case 45:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(45);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(46);
      END_STATE();
    case 47:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(47);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(48);
      END_STATE();
    case 49:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(49);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(50);
      END_STATE();
    case 51:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(52);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 54:
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(53);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_COLON_COLON2);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(59);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      if (lookahead == '>')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_LT_EQ_GT);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      if (lookahead == '=')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_EQ_EQ_EQ);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_EQ_TILDE);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(70);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(71);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(sym_character);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == '-')
        ADVANCE(75);
      if (lookahead == '{')
        ADVANCE(80);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 75:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_character);
      if (lookahead == 'C' ||
          lookahead == 'M')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == '-')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_character);
      END_STATE();
    case 80:
      if (lookahead == '}')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(80);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(sym_character);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(81);
      END_STATE();
    case 82:
      if (lookahead == '@')
        ADVANCE(83);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 83:
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_class_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(84);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(sym_instance_variable);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(85);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(88);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(sym_constant);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'G')
        ADVANCE(89);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(90);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(91);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_BEGIN);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'N')
        ADVANCE(94);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'D')
        ADVANCE(95);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_END);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'A')
        ADVANCE(97);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > 'A') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(98);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'S')
        ADVANCE(99);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(100);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_FALSE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'I')
        ADVANCE(102);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'L')
        ADVANCE(103);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_NIL);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'R')
        ADVANCE(105);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'U')
        ADVANCE(106);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(sym_constant);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead == 'E')
        ADVANCE(107);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_TRUE);
      if (lookahead == '!')
        ADVANCE(87);
      if (lookahead == '?')
        ADVANCE(87);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(92);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 109:
      if (lookahead == '\n')
        SKIP(110);
      END_STATE();
    case 110:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(26);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(37);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(109);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(44);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^'))
        ADVANCE(126);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_LBRACK2);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(117);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_BQUOTE);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(121);
      if (lookahead == '|')
        ADVANCE(122);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      if (lookahead == '=')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE_EQ);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '!')
        ADVANCE(127);
      if (lookahead == '?')
        ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          (lookahead < ' ' || lookahead > '/') &&
          (lookahead < ':' || lookahead > '@') &&
          (lookahead < '[' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym_identifier);
      END_STATE();
    case 128:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(155);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(128);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'i')
        ADVANCE(133);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym_complex);
      END_STATE();
    case 134:
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'b')
        ADVANCE(45);
      if (lookahead == 'd')
        ADVANCE(47);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'x')
        ADVANCE(49);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (lookahead == 'O' ||
          lookahead == 'o')
        ADVANCE(51);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 137:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(43);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(137);
      if (lookahead == '.')
        ADVANCE(38);
      if (lookahead == '_')
        ADVANCE(54);
      if (lookahead == 'i')
        ADVANCE(133);
      if (lookahead == '8' ||
          lookahead == '9')
        ADVANCE(138);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(40);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(139);
      END_STATE();
    case 140:
      if (lookahead == ':')
        ADVANCE(113);
      END_STATE();
    case 141:
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 142:
      if (lookahead == 'e')
        ADVANCE(143);
      END_STATE();
    case 143:
      if (lookahead == 'g')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'i')
        ADVANCE(145);
      END_STATE();
    case 145:
      if (lookahead == 'n')
        ADVANCE(146);
      END_STATE();
    case 146:
      if (lookahead == '\n')
        ADVANCE(147);
      if (lookahead == '\r')
        ADVANCE(146);
      if (lookahead != 0)
        ADVANCE(146);
      END_STATE();
    case 147:
      if (lookahead == '=')
        ADVANCE(148);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 148:
      if (lookahead == 'e')
        ADVANCE(149);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 149:
      if (lookahead == 'n')
        ADVANCE(150);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 150:
      if (lookahead == 'd')
        ADVANCE(151);
      if (lookahead != 0)
        ADVANCE(147);
      END_STATE();
    case 151:
      if (lookahead == '\n')
        ADVANCE(152);
      if (lookahead == '\r')
        ADVANCE(153);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 153:
      if (lookahead == '\n')
        ADVANCE(152);
      END_STATE();
    case 154:
      if (lookahead == '\\')
        ADVANCE(73);
      if (lookahead != 0 &&
          lookahead != '\t' &&
          lookahead != '\n' &&
          lookahead != '\r' &&
          lookahead != ' ')
        ADVANCE(79);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(128);
      END_STATE();
    case 156:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 157:
      if (lookahead == '=')
        ADVANCE(3);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 161:
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_SLASH);
      END_STATE();
    case 165:
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(167);
      if (lookahead == '=')
        ADVANCE(61);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 168:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(69);
      if (lookahead == '>')
        ADVANCE(170);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(173);
      END_STATE();
    case 173:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '|')
        ADVANCE(176);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 177:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(177);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        ADVANCE(179);
      if (lookahead == 'u')
        ADVANCE(180);
      if (lookahead == 'x')
        ADVANCE(186);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(188);
      if (lookahead != 0)
        ADVANCE(179);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 180:
      if (lookahead == '{')
        ADVANCE(181);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(183);
      END_STATE();
    case 181:
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 182:
      if (lookahead == '}')
        ADVANCE(179);
      if (lookahead == ' ' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(182);
      END_STATE();
    case 183:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(184);
      END_STATE();
    case 184:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(185);
      END_STATE();
    case 185:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 186:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(187);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(179);
      END_STATE();
    case 188:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(189);
      END_STATE();
    case 189:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(179);
      END_STATE();
    case 190:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        ADVANCE(178);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 191:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(191);
      END_STATE();
    case 192:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(193);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(192);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(192);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(196);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(194);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 195:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(162);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 197:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(197);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 198:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '~')
        ADVANCE(4);
      END_STATE();
    case 199:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 200:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '@')
        ADVANCE(28);
      END_STATE();
    case 201:
      if (lookahead == '.')
        ADVANCE(202);
      END_STATE();
    case 202:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 203:
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == 'b')
        ADVANCE(142);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 204:
      if (lookahead == ']')
        ADVANCE(205);
      END_STATE();
    case 205:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK);
      if (lookahead == '=')
        ADVANCE(206);
      END_STATE();
    case 206:
      ACCEPT_TOKEN(anon_sym_LBRACK_RBRACK_EQ);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(197);
      END_STATE();
    case 208:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(209);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 211:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(212);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(211);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 212:
      if (lookahead == '\n')
        SKIP(211);
      END_STATE();
    case 213:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(215);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(213);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 214:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 215:
      if (lookahead == '\n')
        SKIP(213);
      END_STATE();
    case 216:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(217);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(216);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(216);
      END_STATE();
    case 218:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(220);
      END_STATE();
    case 220:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(220);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(222);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(221);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 222:
      if (lookahead == '\n')
        SKIP(221);
      END_STATE();
    case 223:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(223);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(223);
      END_STATE();
    case 225:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(226);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(225);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 226:
      if (lookahead == '\n')
        SKIP(225);
      END_STATE();
    case 227:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 228:
      if (lookahead == '*')
        ADVANCE(23);
      if (lookahead == '=')
        ADVANCE(25);
      END_STATE();
    case 229:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      END_STATE();
    case 230:
      if (lookahead == '=')
        ADVANCE(231);
      END_STATE();
    case 231:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 232:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(64);
      if (lookahead == '~')
        ADVANCE(67);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(234);
      END_STATE();
    case 234:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(234);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 235:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(235);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(235);
      END_STATE();
    case 237:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 238:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 239:
      if (lookahead == '\n')
        SKIP(240);
      END_STATE();
    case 240:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(239);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(240);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 241:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(242);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(241);
      END_STATE();
    case 242:
      if (lookahead == '\n')
        SKIP(241);
      END_STATE();
    case 243:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(244);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(243);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(243);
      END_STATE();
    case 245:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(245);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 247:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(250);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(247);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&')
        ADVANCE(160);
      END_STATE();
    case 249:
      if (lookahead == '.')
        ADVANCE(33);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(247);
      END_STATE();
    case 251:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(253);
      END_STATE();
    case 253:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(253);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 254:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(257);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 255:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 256:
      if (lookahead == '=')
        ADVANCE(231);
      if (lookahead == '>')
        ADVANCE(135);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(132);
      END_STATE();
    case 257:
      if (lookahead == '\n')
        SKIP(258);
      END_STATE();
    case 258:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(257);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(258);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 259:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 260:
      if (lookahead == '\n')
        SKIP(261);
      END_STATE();
    case 261:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(260);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(261);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 262:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 263:
      if (lookahead == '\n')
        SKIP(264);
      END_STATE();
    case 264:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(263);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(264);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 265:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(173);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 266:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(268);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASHs_PLUS_SLASH);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '#')
        ADVANCE(271);
      if (lookahead == '=')
        ADVANCE(273);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '#')
        ADVANCE(271);
      if (lookahead == '=')
        ADVANCE(273);
      if (lookahead == '\\')
        ADVANCE(285);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(270);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(271);
      if (lookahead != 0)
        ADVANCE(271);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'b')
        ADVANCE(274);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'e')
        ADVANCE(275);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'g')
        ADVANCE(276);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'i')
        ADVANCE(277);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == 'n')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '\r')
        ADVANCE(278);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(278);
      if (lookahead != 0)
        ADVANCE(278);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == '=')
        ADVANCE(280);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'e')
        ADVANCE(281);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'n')
        ADVANCE(282);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(279);
      if (lookahead == 'd')
        ADVANCE(283);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(279);
      if (lookahead != 0)
        ADVANCE(279);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\r')
        ADVANCE(284);
      if (lookahead == '\t' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(272);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(sym_uninterpreted);
      if (lookahead == '\n')
        ADVANCE(270);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ')
        ADVANCE(272);
      if (lookahead != 0)
        ADVANCE(272);
      END_STATE();
    case 286:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(287);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(286);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 287:
      if (lookahead == '\n')
        SKIP(286);
      END_STATE();
    case 288:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_COLON2);
      if (lookahead == ':')
        ADVANCE(56);
      END_STATE();
    case 290:
      if (lookahead == '\n')
        SKIP(291);
      END_STATE();
    case 291:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(290);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(291);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_COLON2);
      END_STATE();
    case 293:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 294:
      if (lookahead == '\n')
        SKIP(295);
      END_STATE();
    case 295:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(295);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 296:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 297:
      if (lookahead == '\n')
        SKIP(298);
      END_STATE();
    case 298:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 299:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        SKIP(301);
      END_STATE();
    case 301:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 302:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(303);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(302);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 303:
      if (lookahead == '\n')
        SKIP(302);
      END_STATE();
    case 304:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(298);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 305:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 306:
      if (lookahead == '\n')
        SKIP(307);
      END_STATE();
    case 307:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(307);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 308:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(309);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(308);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 309:
      if (lookahead == '\n')
        SKIP(308);
      END_STATE();
    case 310:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(312);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(310);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 312:
      if (lookahead == '\n')
        SKIP(310);
      END_STATE();
    case 313:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(314);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(313);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 314:
      if (lookahead == '\n')
        SKIP(313);
      END_STATE();
    case 315:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        SKIP(317);
      END_STATE();
    case 317:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(316);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(317);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 318:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(319);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        SKIP(320);
      END_STATE();
    case 320:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(319);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(320);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 321:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        SKIP(323);
      END_STATE();
    case 323:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(322);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(323);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 324:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(325);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 325:
      if (lookahead == '\n')
        SKIP(326);
      END_STATE();
    case 326:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(325);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(326);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 327:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(329);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 328:
      if (lookahead == '\n')
        SKIP(329);
      END_STATE();
    case 329:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(328);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(329);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 330:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(332);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 331:
      if (lookahead == '.')
        ADVANCE(18);
      END_STATE();
    case 332:
      if (lookahead == '\n')
        SKIP(333);
      END_STATE();
    case 333:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(332);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(333);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 334:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 335:
      if (lookahead == '\n')
        SKIP(336);
      END_STATE();
    case 336:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(335);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(336);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 337:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(338);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 338:
      if (lookahead == '\n')
        SKIP(339);
      END_STATE();
    case 339:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(338);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(339);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 340:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(341);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 341:
      if (lookahead == '\n')
        SKIP(342);
      END_STATE();
    case 342:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(341);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(342);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 343:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(344);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 344:
      if (lookahead == '\n')
        SKIP(345);
      END_STATE();
    case 345:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(344);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(345);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 346:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 348:
      if (lookahead == '\n')
        SKIP(349);
      END_STATE();
    case 349:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(347);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(348);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(349);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 350:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 351:
      if (lookahead == '\n')
        SKIP(352);
      END_STATE();
    case 352:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(351);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(352);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 353:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 354:
      if (lookahead == '\n')
        SKIP(355);
      END_STATE();
    case 355:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(354);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(355);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 356:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(357);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(356);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 357:
      if (lookahead == '\n')
        SKIP(356);
      END_STATE();
    case 358:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 359:
      if (lookahead == '\n')
        SKIP(360);
      END_STATE();
    case 360:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 361:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 362:
      if (lookahead == '\n')
        SKIP(363);
      END_STATE();
    case 363:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 364:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(359);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(360);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 365:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(366);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 366:
      if (lookahead == '\n')
        SKIP(367);
      END_STATE();
    case 367:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(366);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(367);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 368:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(369);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 369:
      if (lookahead == '\n')
        SKIP(370);
      END_STATE();
    case 370:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(369);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(370);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 371:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(362);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(363);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 372:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(373);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(372);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 373:
      if (lookahead == '\n')
        SKIP(372);
      END_STATE();
    case 374:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(375);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(376);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 375:
      if (lookahead == '\n')
        SKIP(376);
      END_STATE();
    case 376:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(375);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(376);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 377:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(378);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(379);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(377);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 378:
      if (lookahead == '>')
        ADVANCE(66);
      if (lookahead == 'b')
        ADVANCE(142);
      END_STATE();
    case 379:
      if (lookahead == '\n')
        SKIP(377);
      END_STATE();
    case 380:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(381);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(380);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 381:
      if (lookahead == '\n')
        SKIP(380);
      END_STATE();
    case 382:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(383);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(382);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 383:
      if (lookahead == '\n')
        SKIP(382);
      END_STATE();
    case 384:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(385);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(384);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 385:
      if (lookahead == '\n')
        SKIP(384);
      END_STATE();
    case 386:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(387);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(386);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 387:
      if (lookahead == '\n')
        SKIP(386);
      END_STATE();
    case 388:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 389:
      if (lookahead == '\n')
        SKIP(390);
      END_STATE();
    case 390:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 391:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(392);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 392:
      if (lookahead == '\n')
        SKIP(393);
      END_STATE();
    case 393:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(392);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(393);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 394:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 395:
      if (lookahead == '\n')
        SKIP(396);
      END_STATE();
    case 396:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 397:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 398:
      if (lookahead == '\n')
        SKIP(399);
      END_STATE();
    case 399:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 400:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(401);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(400);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 401:
      if (lookahead == '\n')
        SKIP(400);
      END_STATE();
    case 402:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(395);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(396);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 403:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 404:
      if (lookahead == '\n')
        SKIP(405);
      END_STATE();
    case 405:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 406:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 407:
      if (lookahead == '\n')
        SKIP(408);
      END_STATE();
    case 408:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 409:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(410);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(409);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 410:
      if (lookahead == '\n')
        SKIP(409);
      END_STATE();
    case 411:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 412:
      if (lookahead == '\n')
        SKIP(413);
      END_STATE();
    case 413:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(412);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(413);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 414:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(415);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(414);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 415:
      if (lookahead == '\n')
        SKIP(414);
      END_STATE();
    case 416:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 417:
      if (lookahead == '\n')
        SKIP(418);
      END_STATE();
    case 418:
      if (lookahead == '!')
        ADVANCE(198);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(199);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(200);
      if (lookahead == '-')
        ADVANCE(30);
      if (lookahead == '.')
        ADVANCE(201);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '[')
        ADVANCE(204);
      if (lookahead == '\\')
        SKIP(417);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '`')
        ADVANCE(118);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(418);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 419:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(420);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(419);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 420:
      if (lookahead == '\n')
        SKIP(419);
      END_STATE();
    case 421:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 422:
      if (lookahead == '\n')
        SKIP(423);
      END_STATE();
    case 423:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 424:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(425);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(426);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 425:
      if (lookahead == '\n')
        SKIP(426);
      END_STATE();
    case 426:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(425);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(426);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 427:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(422);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(423);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 428:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(429);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(428);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 429:
      if (lookahead == '\n')
        SKIP(428);
      END_STATE();
    case 430:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 431:
      if (lookahead == '\n')
        SKIP(432);
      END_STATE();
    case 432:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(431);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(432);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 433:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(434);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(435);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 434:
      if (lookahead == '\n')
        SKIP(435);
      END_STATE();
    case 435:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(434);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(435);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 436:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(437);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(436);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 437:
      if (lookahead == '\n')
        SKIP(436);
      END_STATE();
    case 438:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 439:
      if (lookahead == '\n')
        SKIP(440);
      END_STATE();
    case 440:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(439);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(440);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 441:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(442);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(443);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 442:
      if (lookahead == '\n')
        SKIP(443);
      END_STATE();
    case 443:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(442);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(443);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 444:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(445);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 445:
      if (lookahead == '\n')
        SKIP(446);
      END_STATE();
    case 446:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(445);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(446);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 447:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(448);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(449);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 448:
      if (lookahead == '\n')
        SKIP(449);
      END_STATE();
    case 449:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(448);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(449);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 450:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(451);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(452);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 451:
      if (lookahead == '\n')
        SKIP(452);
      END_STATE();
    case 452:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(451);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(452);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 453:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(454);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(453);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 454:
      if (lookahead == '\n')
        SKIP(453);
      END_STATE();
    case 455:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 456:
      if (lookahead == '\n')
        SKIP(457);
      END_STATE();
    case 457:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 458:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(459);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(460);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 459:
      if (lookahead == '\n')
        SKIP(460);
      END_STATE();
    case 460:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(459);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(460);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 461:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(462);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(463);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 462:
      if (lookahead == '\n')
        SKIP(463);
      END_STATE();
    case 463:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(462);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(463);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 464:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(465);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(466);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 465:
      if (lookahead == '\n')
        SKIP(466);
      END_STATE();
    case 466:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(465);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(466);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 467:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(468);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(469);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 468:
      if (lookahead == '\n')
        SKIP(469);
      END_STATE();
    case 469:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(468);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(469);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 470:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(471);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(472);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 471:
      if (lookahead == '\n')
        SKIP(472);
      END_STATE();
    case 472:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(471);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(472);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 473:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(474);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(473);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 474:
      if (lookahead == '\n')
        SKIP(473);
      END_STATE();
    case 475:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(476);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(477);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 476:
      if (lookahead == '\n')
        SKIP(477);
      END_STATE();
    case 477:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(476);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(477);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 478:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(479);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(480);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 479:
      if (lookahead == '\n')
        SKIP(480);
      END_STATE();
    case 480:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(479);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(480);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 481:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ':')
        ADVANCE(238);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(482);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(483);
      END_STATE();
    case 482:
      if (lookahead == '\n')
        SKIP(483);
      END_STATE();
    case 483:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '\\')
        SKIP(482);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(483);
      END_STATE();
    case 484:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(485);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 485:
      if (lookahead == '\n')
        SKIP(486);
      END_STATE();
    case 486:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(485);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(486);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 487:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(488);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(489);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 488:
      if (lookahead == '\n')
        SKIP(489);
      END_STATE();
    case 489:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(488);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(489);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 490:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 491:
      if (lookahead == '\n')
        SKIP(492);
      END_STATE();
    case 492:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 493:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 494:
      if (lookahead == '\n')
        SKIP(495);
      END_STATE();
    case 495:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 496:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(491);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(492);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 497:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 498:
      if (lookahead == '\n')
        SKIP(499);
      END_STATE();
    case 499:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 500:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(137);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(214);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(501);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(500);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 501:
      if (lookahead == '\n')
        SKIP(500);
      END_STATE();
    case 502:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(503);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 503:
      if (lookahead == '\n')
        SKIP(504);
      END_STATE();
    case 504:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(503);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(504);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 505:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 506:
      if (lookahead == '\n')
        SKIP(507);
      END_STATE();
    case 507:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 508:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 509:
      if (lookahead == '\n')
        SKIP(510);
      END_STATE();
    case 510:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 511:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(512);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(513);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 512:
      if (lookahead == '\n')
        SKIP(513);
      END_STATE();
    case 513:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(512);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(513);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 514:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(515);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(516);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 515:
      if (lookahead == '\n')
        SKIP(516);
      END_STATE();
    case 516:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(515);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(516);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 517:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(518);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(519);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 518:
      if (lookahead == '\n')
        SKIP(519);
      END_STATE();
    case 519:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(518);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(519);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 520:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 521:
      if (lookahead == '\n')
        SKIP(522);
      END_STATE();
    case 522:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 523:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(521);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(522);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 524:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(525);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(524);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 525:
      if (lookahead == '\n')
        SKIP(524);
      END_STATE();
    case 526:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'B')
        ADVANCE(86);
      if (lookahead == 'E')
        ADVANCE(93);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(527);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(526);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 527:
      if (lookahead == '\n')
        SKIP(526);
      END_STATE();
    case 528:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(529);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(528);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 529:
      if (lookahead == '\n')
        SKIP(528);
      END_STATE();
    case 530:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(389);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(390);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 531:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(532);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(533);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 532:
      if (lookahead == '\n')
        SKIP(533);
      END_STATE();
    case 533:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(532);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(533);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 534:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(535);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(536);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 535:
      if (lookahead == '\n')
        SKIP(536);
      END_STATE();
    case 536:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(535);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(536);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 537:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(538);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(539);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 538:
      if (lookahead == '\n')
        SKIP(539);
      END_STATE();
    case 539:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(538);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(539);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 540:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(541);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(542);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 541:
      if (lookahead == '\n')
        SKIP(542);
      END_STATE();
    case 542:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(541);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(542);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 543:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(407);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(408);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 544:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 545:
      if (lookahead == '\n')
        SKIP(546);
      END_STATE();
    case 546:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(545);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(546);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 547:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(548);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(547);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 548:
      if (lookahead == '\n')
        SKIP(547);
      END_STATE();
    case 549:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(550);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(549);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 550:
      if (lookahead == '\n')
        SKIP(549);
      END_STATE();
    case 551:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(552);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(553);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 552:
      if (lookahead == '\n')
        SKIP(553);
      END_STATE();
    case 553:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(552);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(553);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 554:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(555);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(554);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 555:
      if (lookahead == '\n')
        SKIP(554);
      END_STATE();
    case 556:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(557);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(558);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 557:
      if (lookahead == '\n')
        SKIP(558);
      END_STATE();
    case 558:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(557);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(558);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 559:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(560);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(561);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 560:
      if (lookahead == '\n')
        SKIP(561);
      END_STATE();
    case 561:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(560);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(561);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 562:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(563);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(564);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 563:
      if (lookahead == '\n')
        SKIP(564);
      END_STATE();
    case 564:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(563);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(564);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 565:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(301);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 566:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 567:
      if (lookahead == '\n')
        SKIP(568);
      END_STATE();
    case 568:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(567);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(568);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 569:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 570:
      if (lookahead == '\n')
        SKIP(571);
      END_STATE();
    case 571:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 572:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(570);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(571);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 573:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 574:
      if (lookahead == '\n')
        SKIP(575);
      END_STATE();
    case 575:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 576:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(456);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(457);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 577:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(248);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(249);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(578);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(577);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 578:
      if (lookahead == '\n')
        SKIP(577);
      END_STATE();
    case 579:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(580);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(581);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 580:
      if (lookahead == '\n')
        SKIP(581);
      END_STATE();
    case 581:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(580);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(581);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 582:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(583);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 583:
      if (lookahead == '\n')
        SKIP(584);
      END_STATE();
    case 584:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(583);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(584);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 585:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 586:
      if (lookahead == '\n')
        SKIP(587);
      END_STATE();
    case 587:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 588:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 589:
      if (lookahead == '\n')
        SKIP(590);
      END_STATE();
    case 590:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 591:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(586);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(587);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 592:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 593:
      if (lookahead == '\n')
        SKIP(594);
      END_STATE();
    case 594:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(593);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(594);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 595:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 596:
      if (lookahead == '\n')
        SKIP(597);
      END_STATE();
    case 597:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(596);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(597);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 598:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(398);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(399);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 599:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(600);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(599);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 600:
      if (lookahead == '\n')
        SKIP(599);
      END_STATE();
    case 601:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(602);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(603);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 602:
      if (lookahead == '\n')
        SKIP(603);
      END_STATE();
    case 603:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(602);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(603);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 604:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 605:
      if (lookahead == '\n')
        SKIP(606);
      END_STATE();
    case 606:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 607:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(608);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(609);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 608:
      if (lookahead == '\n')
        SKIP(609);
      END_STATE();
    case 609:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(608);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(609);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 610:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(611);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(612);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 611:
      if (lookahead == '\n')
        SKIP(612);
      END_STATE();
    case 612:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(611);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(612);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 613:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(494);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(495);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 614:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(498);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(499);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 615:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(616);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(617);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 616:
      if (lookahead == '\n')
        SKIP(617);
      END_STATE();
    case 617:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(616);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(617);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 618:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(619);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(620);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 619:
      if (lookahead == '\n')
        SKIP(620);
      END_STATE();
    case 620:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(619);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(620);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 621:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(622);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(623);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 622:
      if (lookahead == '\n')
        SKIP(623);
      END_STATE();
    case 623:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(622);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(623);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 624:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(625);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(626);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 625:
      if (lookahead == '\n')
        SKIP(626);
      END_STATE();
    case 626:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(625);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(626);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 627:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(628);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(629);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 628:
      if (lookahead == '\n')
        SKIP(629);
      END_STATE();
    case 629:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(628);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(629);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 630:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(506);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(507);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 631:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 632:
      if (lookahead == '\n')
        SKIP(633);
      END_STATE();
    case 633:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(632);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(633);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 634:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(509);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(510);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 635:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(636);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(637);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 636:
      if (lookahead == '\n')
        SKIP(637);
      END_STATE();
    case 637:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(636);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(637);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 638:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(639);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(638);
      if ((lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 639:
      if (lookahead == '\n')
        SKIP(638);
      END_STATE();
    case 640:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(404);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(405);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 641:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(642);
      if (lookahead == ']')
        ADVANCE(115);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(641);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 642:
      if (lookahead == '\n')
        SKIP(641);
      END_STATE();
    case 643:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(644);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(643);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 644:
      if (lookahead == '\n')
        SKIP(643);
      END_STATE();
    case 645:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(646);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(647);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 646:
      if (lookahead == '\n')
        SKIP(647);
      END_STATE();
    case 647:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(646);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(647);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 648:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(649);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(650);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 649:
      if (lookahead == '\n')
        SKIP(650);
      END_STATE();
    case 650:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(649);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(650);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 651:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 652:
      if (lookahead == '\n')
        SKIP(653);
      END_STATE();
    case 653:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 654:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 655:
      if (lookahead == '\n')
        SKIP(656);
      END_STATE();
    case 656:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 657:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(22);
      if (lookahead == '+')
        ADVANCE(255);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(256);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(652);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(653);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 658:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 659:
      if (lookahead == '\n')
        SKIP(660);
      END_STATE();
    case 660:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 661:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(655);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(656);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 662:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(55);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(659);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(660);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 663:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(168);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(589);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(590);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 664:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(574);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(575);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 665:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(666);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(667);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 666:
      if (lookahead == '\n')
        SKIP(667);
      END_STATE();
    case 667:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(13);
      if (lookahead == '&')
        ADVANCE(15);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(228);
      if (lookahead == '+')
        ADVANCE(229);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(230);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(58);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(68);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(666);
      if (lookahead == '^')
        ADVANCE(116);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(120);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(667);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 668:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(669);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(670);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 669:
      if (lookahead == '\n')
        SKIP(670);
      END_STATE();
    case 670:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(669);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(124);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(670);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`')
        ADVANCE(126);
      END_STATE();
    case 671:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(672);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(673);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 672:
      if (lookahead == '\n')
        SKIP(673);
      END_STATE();
    case 673:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(672);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(673);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 674:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(63);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(605);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(606);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 675:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(676);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(677);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 676:
      if (lookahead == '\n')
        SKIP(677);
      END_STATE();
    case 677:
      if (lookahead == '!')
        ADVANCE(157);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == ')')
        ADVANCE(21);
      if (lookahead == '*')
        ADVANCE(161);
      if (lookahead == '+')
        ADVANCE(163);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == ':')
        ADVANCE(292);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(232);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(171);
      if (lookahead == '\\')
        SKIP(676);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(677);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 678:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ':')
        ADVANCE(165);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(679);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(680);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 679:
      if (lookahead == '\n')
        SKIP(680);
      END_STATE();
    case 680:
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '&')
        ADVANCE(331);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '.')
        ADVANCE(311);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '\\')
        SKIP(679);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(680);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 681:
      if (lookahead == '!')
        ADVANCE(129);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(130);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(140);
      if (lookahead == ';')
        ADVANCE(57);
      if (lookahead == '=')
        ADVANCE(141);
      if (lookahead == '?')
        ADVANCE(154);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(682);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(208);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(681);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 682:
      if (lookahead == '\n')
        SKIP(681);
      END_STATE();
    case 683:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(20);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(289);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(108);
      if (lookahead == '\\')
        SKIP(684);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(685);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    case 684:
      if (lookahead == '\n')
        SKIP(685);
      END_STATE();
    case 685:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(7);
      if (lookahead == '$')
        ADVANCE(8);
      if (lookahead == '%')
        ADVANCE(158);
      if (lookahead == '&')
        ADVANCE(159);
      if (lookahead == '(')
        ADVANCE(111);
      if (lookahead == '*')
        ADVANCE(195);
      if (lookahead == '+')
        ADVANCE(131);
      if (lookahead == ',')
        ADVANCE(29);
      if (lookahead == '-')
        ADVANCE(134);
      if (lookahead == '.')
        ADVANCE(32);
      if (lookahead == '/')
        ADVANCE(164);
      if (lookahead == '0')
        ADVANCE(136);
      if (lookahead == ':')
        ADVANCE(112);
      if (lookahead == '<')
        ADVANCE(166);
      if (lookahead == '=')
        ADVANCE(203);
      if (lookahead == '>')
        ADVANCE(169);
      if (lookahead == '?')
        ADVANCE(72);
      if (lookahead == '@')
        ADVANCE(82);
      if (lookahead == 'F')
        ADVANCE(96);
      if (lookahead == 'N')
        ADVANCE(101);
      if (lookahead == 'T')
        ADVANCE(104);
      if (lookahead == '[')
        ADVANCE(114);
      if (lookahead == '\\')
        SKIP(684);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '{')
        ADVANCE(119);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '~')
        ADVANCE(125);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ')
        SKIP(685);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(138);
      if (('A' <= lookahead && lookahead <= 'Z'))
        ADVANCE(92);
      if (lookahead != 0 &&
          (lookahead < ' ' || lookahead > '^') &&
          lookahead != '`' &&
          (lookahead < '{' || lookahead > '~'))
        ADVANCE(126);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == '_')
        ADVANCE(1);
      if (lookahead == 'a')
        ADVANCE(8);
      if (lookahead == 'b')
        ADVANCE(15);
      if (lookahead == 'c')
        ADVANCE(24);
      if (lookahead == 'd')
        ADVANCE(32);
      if (lookahead == 'e')
        ADVANCE(41);
      if (lookahead == 'f')
        ADVANCE(53);
      if (lookahead == 'i')
        ADVANCE(60);
      if (lookahead == 'm')
        ADVANCE(63);
      if (lookahead == 'n')
        ADVANCE(69);
      if (lookahead == 'o')
        ADVANCE(77);
      if (lookahead == 'r')
        ADVANCE(79);
      if (lookahead == 's')
        ADVANCE(93);
      if (lookahead == 't')
        ADVANCE(101);
      if (lookahead == 'u')
        ADVANCE(108);
      if (lookahead == 'w')
        ADVANCE(120);
      if (lookahead == 'y')
        ADVANCE(127);
      END_STATE();
    case 1:
      if (lookahead == '_')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'E')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 'N')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'D')
        ADVANCE(5);
      END_STATE();
    case 5:
      if (lookahead == '_')
        ADVANCE(6);
      END_STATE();
    case 6:
      if (lookahead == '_')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym___END__);
      END_STATE();
    case 8:
      if (lookahead == 'l')
        ADVANCE(9);
      if (lookahead == 'n')
        ADVANCE(13);
      END_STATE();
    case 9:
      if (lookahead == 'i')
        ADVANCE(10);
      END_STATE();
    case 10:
      if (lookahead == 'a')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 's')
        ADVANCE(12);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 13:
      if (lookahead == 'd')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 15:
      if (lookahead == 'e')
        ADVANCE(16);
      if (lookahead == 'r')
        ADVANCE(20);
      END_STATE();
    case 16:
      if (lookahead == 'g')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 'i')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'n')
        ADVANCE(19);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_begin);
      END_STATE();
    case 20:
      if (lookahead == 'e')
        ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == 'a')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == 'k')
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 24:
      if (lookahead == 'a')
        ADVANCE(25);
      if (lookahead == 'l')
        ADVANCE(28);
      END_STATE();
    case 25:
      if (lookahead == 's')
        ADVANCE(26);
      END_STATE();
    case 26:
      if (lookahead == 'e')
        ADVANCE(27);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 28:
      if (lookahead == 'a')
        ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 's')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 's')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 32:
      if (lookahead == 'e')
        ADVANCE(33);
      if (lookahead == 'o')
        ADVANCE(40);
      END_STATE();
    case 33:
      if (lookahead == 'f')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_def);
      if (lookahead == 'i')
        ADVANCE(35);
      END_STATE();
    case 35:
      if (lookahead == 'n')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 'e')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 'd')
        ADVANCE(38);
      END_STATE();
    case 38:
      if (lookahead == '?')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(anon_sym_defined_QMARK);
      END_STATE();
    case 40:
      ACCEPT_TOKEN(anon_sym_do);
      END_STATE();
    case 41:
      if (lookahead == 'l')
        ADVANCE(42);
      if (lookahead == 'n')
        ADVANCE(47);
      END_STATE();
    case 42:
      if (lookahead == 's')
        ADVANCE(43);
      END_STATE();
    case 43:
      if (lookahead == 'e')
        ADVANCE(44);
      if (lookahead == 'i')
        ADVANCE(45);
      END_STATE();
    case 44:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 45:
      if (lookahead == 'f')
        ADVANCE(46);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_elsif);
      END_STATE();
    case 47:
      if (lookahead == 'd')
        ADVANCE(48);
      if (lookahead == 's')
        ADVANCE(49);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_end);
      END_STATE();
    case 49:
      if (lookahead == 'u')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 'r')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'e')
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_ensure);
      END_STATE();
    case 53:
      if (lookahead == 'a')
        ADVANCE(54);
      if (lookahead == 'o')
        ADVANCE(58);
      END_STATE();
    case 54:
      if (lookahead == 'l')
        ADVANCE(55);
      END_STATE();
    case 55:
      if (lookahead == 's')
        ADVANCE(56);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 58:
      if (lookahead == 'r')
        ADVANCE(59);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 60:
      if (lookahead == 'f')
        ADVANCE(61);
      if (lookahead == 'n')
        ADVANCE(62);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 63:
      if (lookahead == 'o')
        ADVANCE(64);
      END_STATE();
    case 64:
      if (lookahead == 'd')
        ADVANCE(65);
      END_STATE();
    case 65:
      if (lookahead == 'u')
        ADVANCE(66);
      END_STATE();
    case 66:
      if (lookahead == 'l')
        ADVANCE(67);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 69:
      if (lookahead == 'e')
        ADVANCE(70);
      if (lookahead == 'i')
        ADVANCE(73);
      if (lookahead == 'o')
        ADVANCE(75);
      END_STATE();
    case 70:
      if (lookahead == 'x')
        ADVANCE(71);
      END_STATE();
    case 71:
      if (lookahead == 't')
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_next);
      END_STATE();
    case 73:
      if (lookahead == 'l')
        ADVANCE(74);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_nil);
      END_STATE();
    case 75:
      if (lookahead == 't')
        ADVANCE(76);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 77:
      if (lookahead == 'r')
        ADVANCE(78);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_r);
      if (lookahead == 'e')
        ADVANCE(80);
      END_STATE();
    case 80:
      if (lookahead == 'd')
        ADVANCE(81);
      if (lookahead == 's')
        ADVANCE(83);
      if (lookahead == 't')
        ADVANCE(87);
      END_STATE();
    case 81:
      if (lookahead == 'o')
        ADVANCE(82);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(sym_redo);
      END_STATE();
    case 83:
      if (lookahead == 'c')
        ADVANCE(84);
      END_STATE();
    case 84:
      if (lookahead == 'u')
        ADVANCE(85);
      END_STATE();
    case 85:
      if (lookahead == 'e')
        ADVANCE(86);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_rescue);
      END_STATE();
    case 87:
      if (lookahead == 'r')
        ADVANCE(88);
      if (lookahead == 'u')
        ADVANCE(90);
      END_STATE();
    case 88:
      if (lookahead == 'y')
        ADVANCE(89);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(sym_retry);
      END_STATE();
    case 90:
      if (lookahead == 'r')
        ADVANCE(91);
      END_STATE();
    case 91:
      if (lookahead == 'n')
        ADVANCE(92);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 93:
      if (lookahead == 'e')
        ADVANCE(94);
      if (lookahead == 'u')
        ADVANCE(97);
      END_STATE();
    case 94:
      if (lookahead == 'l')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'f')
        ADVANCE(96);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(sym_self);
      END_STATE();
    case 97:
      if (lookahead == 'p')
        ADVANCE(98);
      END_STATE();
    case 98:
      if (lookahead == 'e')
        ADVANCE(99);
      END_STATE();
    case 99:
      if (lookahead == 'r')
        ADVANCE(100);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(sym_super);
      END_STATE();
    case 101:
      if (lookahead == 'h')
        ADVANCE(102);
      if (lookahead == 'r')
        ADVANCE(105);
      END_STATE();
    case 102:
      if (lookahead == 'e')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'n')
        ADVANCE(104);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 105:
      if (lookahead == 'u')
        ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == 'e')
        ADVANCE(107);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 108:
      if (lookahead == 'n')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'd')
        ADVANCE(110);
      if (lookahead == 'l')
        ADVANCE(113);
      if (lookahead == 't')
        ADVANCE(117);
      END_STATE();
    case 110:
      if (lookahead == 'e')
        ADVANCE(111);
      END_STATE();
    case 111:
      if (lookahead == 'f')
        ADVANCE(112);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 113:
      if (lookahead == 'e')
        ADVANCE(114);
      END_STATE();
    case 114:
      if (lookahead == 's')
        ADVANCE(115);
      END_STATE();
    case 115:
      if (lookahead == 's')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_unless);
      END_STATE();
    case 117:
      if (lookahead == 'i')
        ADVANCE(118);
      END_STATE();
    case 118:
      if (lookahead == 'l')
        ADVANCE(119);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_until);
      END_STATE();
    case 120:
      if (lookahead == 'h')
        ADVANCE(121);
      END_STATE();
    case 121:
      if (lookahead == 'e')
        ADVANCE(122);
      if (lookahead == 'i')
        ADVANCE(124);
      END_STATE();
    case 122:
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 124:
      if (lookahead == 'l')
        ADVANCE(125);
      END_STATE();
    case 125:
      if (lookahead == 'e')
        ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 127:
      if (lookahead == 'i')
        ADVANCE(128);
      END_STATE();
    case 128:
      if (lookahead == 'e')
        ADVANCE(129);
      END_STATE();
    case 129:
      if (lookahead == 'l')
        ADVANCE(130);
      END_STATE();
    case 130:
      if (lookahead == 'd')
        ADVANCE(131);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 128, .external_lex_state = 2},
  [2] = {.lex_state = 156, .external_lex_state = 3},
  [3] = {.lex_state = 177, .external_lex_state = 4},
  [4] = {.lex_state = 177, .external_lex_state = 4},
  [5] = {.lex_state = 177, .external_lex_state = 4},
  [6] = {.lex_state = 177, .external_lex_state = 4},
  [7] = {.lex_state = 190, .external_lex_state = 4},
  [8] = {.lex_state = 190, .external_lex_state = 4},
  [9] = {.lex_state = 192, .external_lex_state = 2},
  [10] = {.lex_state = 128, .external_lex_state = 5},
  [11] = {.lex_state = 128},
  [12] = {.lex_state = 194, .external_lex_state = 6},
  [13] = {.lex_state = 128},
  [14] = {.lex_state = 197, .external_lex_state = 7},
  [15] = {.lex_state = 209, .external_lex_state = 2},
  [16] = {.lex_state = 197},
  [17] = {.lex_state = 211, .external_lex_state = 8},
  [18] = {.lex_state = 213, .external_lex_state = 9},
  [19] = {.lex_state = 216, .external_lex_state = 10},
  [20] = {.lex_state = 216, .external_lex_state = 9},
  [21] = {.lex_state = 218, .external_lex_state = 11},
  [22] = {.lex_state = 218, .external_lex_state = 11},
  [23] = {.lex_state = 218, .external_lex_state = 11},
  [24] = {.lex_state = 218, .external_lex_state = 11},
  [25] = {.lex_state = 221, .external_lex_state = 2},
  [26] = {.lex_state = 221, .external_lex_state = 2},
  [27] = {.lex_state = 192, .external_lex_state = 2},
  [28] = {.lex_state = 192, .external_lex_state = 2},
  [29] = {.lex_state = 223, .external_lex_state = 9},
  [30] = {.lex_state = 221, .external_lex_state = 12},
  [31] = {.lex_state = 128, .external_lex_state = 12},
  [32] = {.lex_state = 192, .external_lex_state = 2},
  [33] = {.lex_state = 192, .external_lex_state = 2},
  [34] = {.lex_state = 192, .external_lex_state = 2},
  [35] = {.lex_state = 225, .external_lex_state = 7},
  [36] = {.lex_state = 225, .external_lex_state = 7},
  [37] = {.lex_state = 156, .external_lex_state = 3},
  [38] = {.lex_state = 227, .external_lex_state = 3},
  [39] = {.lex_state = 227, .external_lex_state = 3},
  [40] = {.lex_state = 227, .external_lex_state = 3},
  [41] = {.lex_state = 235, .external_lex_state = 13},
  [42] = {.lex_state = 237},
  [43] = {.lex_state = 241},
  [44] = {.lex_state = 243},
  [45] = {.lex_state = 245, .external_lex_state = 8},
  [46] = {.lex_state = 211, .external_lex_state = 8},
  [47] = {.lex_state = 245, .external_lex_state = 8},
  [48] = {.lex_state = 211, .external_lex_state = 8},
  [49] = {.lex_state = 247, .external_lex_state = 3},
  [50] = {.lex_state = 251, .external_lex_state = 3},
  [51] = {.lex_state = 254, .external_lex_state = 11},
  [52] = {.lex_state = 213},
  [53] = {.lex_state = 213},
  [54] = {.lex_state = 213},
  [55] = {.lex_state = 259, .external_lex_state = 3},
  [56] = {.lex_state = 262, .external_lex_state = 14},
  [57] = {.lex_state = 265, .external_lex_state = 14},
  [58] = {.lex_state = 221, .external_lex_state = 2},
  [59] = {.lex_state = 192, .external_lex_state = 15},
  [60] = {.lex_state = 177, .external_lex_state = 4},
  [61] = {.lex_state = 156, .external_lex_state = 3},
  [62] = {.lex_state = 192, .external_lex_state = 15},
  [63] = {.lex_state = 156, .external_lex_state = 3},
  [64] = {.lex_state = 192, .external_lex_state = 15},
  [65] = {.lex_state = 156, .external_lex_state = 3},
  [66] = {.lex_state = 192, .external_lex_state = 15},
  [67] = {.lex_state = 156, .external_lex_state = 3},
  [68] = {.lex_state = 221, .external_lex_state = 2},
  [69] = {.lex_state = 190, .external_lex_state = 4},
  [70] = {.lex_state = 266, .external_lex_state = 15},
  [71] = {.lex_state = 190, .external_lex_state = 4},
  [72] = {.lex_state = 156, .external_lex_state = 3},
  [73] = {.lex_state = 190, .external_lex_state = 4},
  [74] = {.lex_state = 266, .external_lex_state = 15},
  [75] = {.lex_state = 247, .external_lex_state = 3},
  [76] = {.lex_state = 269},
  [77] = {.lex_state = 286, .external_lex_state = 2},
  [78] = {.lex_state = 288, .external_lex_state = 16},
  [79] = {.lex_state = 177, .external_lex_state = 4},
  [80] = {.lex_state = 177, .external_lex_state = 4},
  [81] = {.lex_state = 177, .external_lex_state = 4},
  [82] = {.lex_state = 177, .external_lex_state = 4},
  [83] = {.lex_state = 190, .external_lex_state = 4},
  [84] = {.lex_state = 190, .external_lex_state = 4},
  [85] = {.lex_state = 177, .external_lex_state = 17},
  [86] = {.lex_state = 192, .external_lex_state = 2},
  [87] = {.lex_state = 237},
  [88] = {.lex_state = 194, .external_lex_state = 6},
  [89] = {.lex_state = 156, .external_lex_state = 3},
  [90] = {.lex_state = 197, .external_lex_state = 7},
  [91] = {.lex_state = 209, .external_lex_state = 2},
  [92] = {.lex_state = 197},
  [93] = {.lex_state = 192, .external_lex_state = 2},
  [94] = {.lex_state = 216, .external_lex_state = 10},
  [95] = {.lex_state = 216, .external_lex_state = 9},
  [96] = {.lex_state = 293, .external_lex_state = 18},
  [97] = {.lex_state = 293, .external_lex_state = 18},
  [98] = {.lex_state = 293, .external_lex_state = 18},
  [99] = {.lex_state = 293, .external_lex_state = 18},
  [100] = {.lex_state = 221, .external_lex_state = 2},
  [101] = {.lex_state = 221, .external_lex_state = 2},
  [102] = {.lex_state = 192, .external_lex_state = 2},
  [103] = {.lex_state = 192, .external_lex_state = 2},
  [104] = {.lex_state = 223, .external_lex_state = 9},
  [105] = {.lex_state = 221, .external_lex_state = 12},
  [106] = {.lex_state = 128, .external_lex_state = 12},
  [107] = {.lex_state = 192, .external_lex_state = 2},
  [108] = {.lex_state = 192, .external_lex_state = 2},
  [109] = {.lex_state = 192, .external_lex_state = 2},
  [110] = {.lex_state = 296, .external_lex_state = 18},
  [111] = {.lex_state = 288, .external_lex_state = 16},
  [112] = {.lex_state = 299, .external_lex_state = 16},
  [113] = {.lex_state = 299, .external_lex_state = 16},
  [114] = {.lex_state = 299, .external_lex_state = 16},
  [115] = {.lex_state = 235, .external_lex_state = 13},
  [116] = {.lex_state = 237},
  [117] = {.lex_state = 302, .external_lex_state = 16},
  [118] = {.lex_state = 156, .external_lex_state = 16},
  [119] = {.lex_state = 304, .external_lex_state = 18},
  [120] = {.lex_state = 237, .external_lex_state = 19},
  [121] = {.lex_state = 213},
  [122] = {.lex_state = 299, .external_lex_state = 16},
  [123] = {.lex_state = 305, .external_lex_state = 20},
  [124] = {.lex_state = 194},
  [125] = {.lex_state = 194, .external_lex_state = 19},
  [126] = {.lex_state = 237, .external_lex_state = 19},
  [127] = {.lex_state = 286, .external_lex_state = 2},
  [128] = {.lex_state = 308, .external_lex_state = 8},
  [129] = {.lex_state = 177, .external_lex_state = 4},
  [130] = {.lex_state = 192, .external_lex_state = 2},
  [131] = {.lex_state = 308, .external_lex_state = 8},
  [132] = {.lex_state = 310, .external_lex_state = 8},
  [133] = {.lex_state = 310, .external_lex_state = 8},
  [134] = {.lex_state = 156, .external_lex_state = 3},
  [135] = {.lex_state = 310},
  [136] = {.lex_state = 310, .external_lex_state = 8},
  [137] = {.lex_state = 192, .external_lex_state = 2},
  [138] = {.lex_state = 156, .external_lex_state = 3},
  [139] = {.lex_state = 313, .external_lex_state = 9},
  [140] = {.lex_state = 315, .external_lex_state = 11},
  [141] = {.lex_state = 315, .external_lex_state = 11},
  [142] = {.lex_state = 315, .external_lex_state = 11},
  [143] = {.lex_state = 315, .external_lex_state = 11},
  [144] = {.lex_state = 192, .external_lex_state = 2},
  [145] = {.lex_state = 192, .external_lex_state = 2},
  [146] = {.lex_state = 192, .external_lex_state = 2},
  [147] = {.lex_state = 225, .external_lex_state = 7},
  [148] = {.lex_state = 209},
  [149] = {.lex_state = 209, .external_lex_state = 8},
  [150] = {.lex_state = 209, .external_lex_state = 8},
  [151] = {.lex_state = 302, .external_lex_state = 3},
  [152] = {.lex_state = 318, .external_lex_state = 11},
  [153] = {.lex_state = 213},
  [154] = {.lex_state = 313},
  [155] = {.lex_state = 313},
  [156] = {.lex_state = 321, .external_lex_state = 3},
  [157] = {.lex_state = 324, .external_lex_state = 14},
  [158] = {.lex_state = 327, .external_lex_state = 11},
  [159] = {.lex_state = 330},
  [160] = {.lex_state = 177, .external_lex_state = 4},
  [161] = {.lex_state = 177, .external_lex_state = 4},
  [162] = {.lex_state = 177, .external_lex_state = 4},
  [163] = {.lex_state = 177, .external_lex_state = 4},
  [164] = {.lex_state = 190, .external_lex_state = 4},
  [165] = {.lex_state = 190, .external_lex_state = 4},
  [166] = {.lex_state = 194, .external_lex_state = 6},
  [167] = {.lex_state = 197, .external_lex_state = 7},
  [168] = {.lex_state = 209, .external_lex_state = 2},
  [169] = {.lex_state = 197},
  [170] = {.lex_state = 216, .external_lex_state = 10},
  [171] = {.lex_state = 216, .external_lex_state = 9},
  [172] = {.lex_state = 334, .external_lex_state = 21},
  [173] = {.lex_state = 334, .external_lex_state = 21},
  [174] = {.lex_state = 334, .external_lex_state = 21},
  [175] = {.lex_state = 334, .external_lex_state = 21},
  [176] = {.lex_state = 221, .external_lex_state = 2},
  [177] = {.lex_state = 221, .external_lex_state = 2},
  [178] = {.lex_state = 192, .external_lex_state = 2},
  [179] = {.lex_state = 192, .external_lex_state = 2},
  [180] = {.lex_state = 223, .external_lex_state = 9},
  [181] = {.lex_state = 221, .external_lex_state = 12},
  [182] = {.lex_state = 128, .external_lex_state = 12},
  [183] = {.lex_state = 330},
  [184] = {.lex_state = 337},
  [185] = {.lex_state = 337},
  [186] = {.lex_state = 337},
  [187] = {.lex_state = 235, .external_lex_state = 13},
  [188] = {.lex_state = 237},
  [189] = {.lex_state = 330},
  [190] = {.lex_state = 340, .external_lex_state = 21},
  [191] = {.lex_state = 337},
  [192] = {.lex_state = 343, .external_lex_state = 22},
  [193] = {.lex_state = 192, .external_lex_state = 2},
  [194] = {.lex_state = 197},
  [195] = {.lex_state = 346, .external_lex_state = 23},
  [196] = {.lex_state = 330},
  [197] = {.lex_state = 346, .external_lex_state = 23},
  [198] = {.lex_state = 334, .external_lex_state = 21},
  [199] = {.lex_state = 350, .external_lex_state = 23},
  [200] = {.lex_state = 350, .external_lex_state = 23},
  [201] = {.lex_state = 192, .external_lex_state = 2},
  [202] = {.lex_state = 192, .external_lex_state = 2},
  [203] = {.lex_state = 192, .external_lex_state = 2},
  [204] = {.lex_state = 237},
  [205] = {.lex_state = 197},
  [206] = {.lex_state = 192, .external_lex_state = 2},
  [207] = {.lex_state = 353, .external_lex_state = 11},
  [208] = {.lex_state = 353, .external_lex_state = 11},
  [209] = {.lex_state = 353, .external_lex_state = 11},
  [210] = {.lex_state = 353, .external_lex_state = 11},
  [211] = {.lex_state = 356, .external_lex_state = 13},
  [212] = {.lex_state = 192, .external_lex_state = 2},
  [213] = {.lex_state = 192, .external_lex_state = 2},
  [214] = {.lex_state = 192, .external_lex_state = 2},
  [215] = {.lex_state = 358, .external_lex_state = 11},
  [216] = {.lex_state = 299, .external_lex_state = 3},
  [217] = {.lex_state = 299, .external_lex_state = 3},
  [218] = {.lex_state = 299, .external_lex_state = 3},
  [219] = {.lex_state = 361, .external_lex_state = 3},
  [220] = {.lex_state = 156, .external_lex_state = 3},
  [221] = {.lex_state = 364, .external_lex_state = 11},
  [222] = {.lex_state = 156, .external_lex_state = 3},
  [223] = {.lex_state = 262, .external_lex_state = 3},
  [224] = {.lex_state = 365, .external_lex_state = 3},
  [225] = {.lex_state = 213},
  [226] = {.lex_state = 368, .external_lex_state = 3},
  [227] = {.lex_state = 371, .external_lex_state = 14},
  [228] = {.lex_state = 156, .external_lex_state = 3},
  [229] = {.lex_state = 156, .external_lex_state = 3},
  [230] = {.lex_state = 156, .external_lex_state = 3},
  [231] = {.lex_state = 192, .external_lex_state = 2},
  [232] = {.lex_state = 218, .external_lex_state = 11},
  [233] = {.lex_state = 218, .external_lex_state = 11},
  [234] = {.lex_state = 218, .external_lex_state = 11},
  [235] = {.lex_state = 218, .external_lex_state = 11},
  [236] = {.lex_state = 192, .external_lex_state = 2},
  [237] = {.lex_state = 192, .external_lex_state = 2},
  [238] = {.lex_state = 192, .external_lex_state = 2},
  [239] = {.lex_state = 225, .external_lex_state = 7},
  [240] = {.lex_state = 128, .external_lex_state = 8},
  [241] = {.lex_state = 247, .external_lex_state = 3},
  [242] = {.lex_state = 254, .external_lex_state = 11},
  [243] = {.lex_state = 213},
  [244] = {.lex_state = 259, .external_lex_state = 3},
  [245] = {.lex_state = 262, .external_lex_state = 14},
  [246] = {.lex_state = 128, .external_lex_state = 8},
  [247] = {.lex_state = 192, .external_lex_state = 2},
  [248] = {.lex_state = 218, .external_lex_state = 11},
  [249] = {.lex_state = 218, .external_lex_state = 11},
  [250] = {.lex_state = 218, .external_lex_state = 11},
  [251] = {.lex_state = 218, .external_lex_state = 11},
  [252] = {.lex_state = 192, .external_lex_state = 2},
  [253] = {.lex_state = 192, .external_lex_state = 2},
  [254] = {.lex_state = 192, .external_lex_state = 2},
  [255] = {.lex_state = 247, .external_lex_state = 3},
  [256] = {.lex_state = 254, .external_lex_state = 11},
  [257] = {.lex_state = 213},
  [258] = {.lex_state = 259, .external_lex_state = 3},
  [259] = {.lex_state = 262, .external_lex_state = 14},
  [260] = {.lex_state = 247, .external_lex_state = 3},
  [261] = {.lex_state = 209, .external_lex_state = 2},
  [262] = {.lex_state = 372, .external_lex_state = 9},
  [263] = {.lex_state = 374, .external_lex_state = 21},
  [264] = {.lex_state = 128},
  [265] = {.lex_state = 156},
  [266] = {.lex_state = 337},
  [267] = {.lex_state = 192, .external_lex_state = 2},
  [268] = {.lex_state = 218, .external_lex_state = 11},
  [269] = {.lex_state = 218, .external_lex_state = 11},
  [270] = {.lex_state = 218, .external_lex_state = 11},
  [271] = {.lex_state = 218, .external_lex_state = 11},
  [272] = {.lex_state = 192, .external_lex_state = 2},
  [273] = {.lex_state = 192, .external_lex_state = 2},
  [274] = {.lex_state = 192, .external_lex_state = 2},
  [275] = {.lex_state = 247, .external_lex_state = 3},
  [276] = {.lex_state = 254, .external_lex_state = 11},
  [277] = {.lex_state = 213},
  [278] = {.lex_state = 259, .external_lex_state = 3},
  [279] = {.lex_state = 262, .external_lex_state = 14},
  [280] = {.lex_state = 128},
  [281] = {.lex_state = 177, .external_lex_state = 17},
  [282] = {.lex_state = 192, .external_lex_state = 2},
  [283] = {.lex_state = 128, .external_lex_state = 12},
  [284] = {.lex_state = 218, .external_lex_state = 11},
  [285] = {.lex_state = 218, .external_lex_state = 11},
  [286] = {.lex_state = 218, .external_lex_state = 11},
  [287] = {.lex_state = 218, .external_lex_state = 11},
  [288] = {.lex_state = 377, .external_lex_state = 24},
  [289] = {.lex_state = 128, .external_lex_state = 12},
  [290] = {.lex_state = 128, .external_lex_state = 2},
  [291] = {.lex_state = 192, .external_lex_state = 2},
  [292] = {.lex_state = 192, .external_lex_state = 2},
  [293] = {.lex_state = 192, .external_lex_state = 2},
  [294] = {.lex_state = 225, .external_lex_state = 7},
  [295] = {.lex_state = 128},
  [296] = {.lex_state = 128, .external_lex_state = 8},
  [297] = {.lex_state = 128, .external_lex_state = 8},
  [298] = {.lex_state = 128},
  [299] = {.lex_state = 128},
  [300] = {.lex_state = 128},
  [301] = {.lex_state = 156, .external_lex_state = 3},
  [302] = {.lex_state = 247, .external_lex_state = 3},
  [303] = {.lex_state = 254, .external_lex_state = 11},
  [304] = {.lex_state = 213},
  [305] = {.lex_state = 259, .external_lex_state = 3},
  [306] = {.lex_state = 262, .external_lex_state = 14},
  [307] = {.lex_state = 128, .external_lex_state = 2},
  [308] = {.lex_state = 247, .external_lex_state = 3},
  [309] = {.lex_state = 247, .external_lex_state = 3},
  [310] = {.lex_state = 380, .external_lex_state = 3},
  [311] = {.lex_state = 382, .external_lex_state = 8},
  [312] = {.lex_state = 384, .external_lex_state = 8},
  [313] = {.lex_state = 225, .external_lex_state = 7},
  [314] = {.lex_state = 177, .external_lex_state = 4},
  [315] = {.lex_state = 225, .external_lex_state = 7},
  [316] = {.lex_state = 386, .external_lex_state = 7},
  [317] = {.lex_state = 225, .external_lex_state = 7},
  [318] = {.lex_state = 156, .external_lex_state = 3},
  [319] = {.lex_state = 388, .external_lex_state = 25},
  [320] = {.lex_state = 177, .external_lex_state = 4},
  [321] = {.lex_state = 177, .external_lex_state = 4},
  [322] = {.lex_state = 177, .external_lex_state = 4},
  [323] = {.lex_state = 177, .external_lex_state = 4},
  [324] = {.lex_state = 190, .external_lex_state = 4},
  [325] = {.lex_state = 190, .external_lex_state = 4},
  [326] = {.lex_state = 192, .external_lex_state = 2},
  [327] = {.lex_state = 192, .external_lex_state = 2},
  [328] = {.lex_state = 192, .external_lex_state = 2},
  [329] = {.lex_state = 237},
  [330] = {.lex_state = 194, .external_lex_state = 6},
  [331] = {.lex_state = 197, .external_lex_state = 7},
  [332] = {.lex_state = 209, .external_lex_state = 2},
  [333] = {.lex_state = 197},
  [334] = {.lex_state = 192, .external_lex_state = 2},
  [335] = {.lex_state = 216, .external_lex_state = 10},
  [336] = {.lex_state = 216, .external_lex_state = 9},
  [337] = {.lex_state = 391, .external_lex_state = 26},
  [338] = {.lex_state = 391, .external_lex_state = 26},
  [339] = {.lex_state = 391, .external_lex_state = 26},
  [340] = {.lex_state = 391, .external_lex_state = 26},
  [341] = {.lex_state = 221, .external_lex_state = 2},
  [342] = {.lex_state = 221, .external_lex_state = 2},
  [343] = {.lex_state = 192, .external_lex_state = 2},
  [344] = {.lex_state = 192, .external_lex_state = 2},
  [345] = {.lex_state = 223, .external_lex_state = 9},
  [346] = {.lex_state = 221, .external_lex_state = 12},
  [347] = {.lex_state = 128, .external_lex_state = 12},
  [348] = {.lex_state = 156, .external_lex_state = 3},
  [349] = {.lex_state = 192, .external_lex_state = 2},
  [350] = {.lex_state = 192, .external_lex_state = 2},
  [351] = {.lex_state = 192, .external_lex_state = 2},
  [352] = {.lex_state = 394, .external_lex_state = 26},
  [353] = {.lex_state = 388, .external_lex_state = 25},
  [354] = {.lex_state = 397, .external_lex_state = 25},
  [355] = {.lex_state = 397, .external_lex_state = 25},
  [356] = {.lex_state = 397, .external_lex_state = 25},
  [357] = {.lex_state = 235, .external_lex_state = 13},
  [358] = {.lex_state = 237},
  [359] = {.lex_state = 400, .external_lex_state = 25},
  [360] = {.lex_state = 388, .external_lex_state = 25},
  [361] = {.lex_state = 402, .external_lex_state = 26},
  [362] = {.lex_state = 235, .external_lex_state = 19},
  [363] = {.lex_state = 391, .external_lex_state = 19},
  [364] = {.lex_state = 213},
  [365] = {.lex_state = 403, .external_lex_state = 25},
  [366] = {.lex_state = 406, .external_lex_state = 27},
  [367] = {.lex_state = 235},
  [368] = {.lex_state = 409, .external_lex_state = 2},
  [369] = {.lex_state = 411},
  [370] = {.lex_state = 337},
  [371] = {.lex_state = 337},
  [372] = {.lex_state = 128},
  [373] = {.lex_state = 414, .external_lex_state = 12},
  [374] = {.lex_state = 237},
  [375] = {.lex_state = 128},
  [376] = {.lex_state = 156},
  [377] = {.lex_state = 156, .external_lex_state = 3},
  [378] = {.lex_state = 128, .external_lex_state = 5},
  [379] = {.lex_state = 128, .external_lex_state = 2},
  [380] = {.lex_state = 245, .external_lex_state = 8},
  [381] = {.lex_state = 192, .external_lex_state = 2},
  [382] = {.lex_state = 192, .external_lex_state = 2},
  [383] = {.lex_state = 192, .external_lex_state = 2},
  [384] = {.lex_state = 192, .external_lex_state = 2},
  [385] = {.lex_state = 192, .external_lex_state = 2},
  [386] = {.lex_state = 192, .external_lex_state = 2},
  [387] = {.lex_state = 192, .external_lex_state = 2},
  [388] = {.lex_state = 192, .external_lex_state = 2},
  [389] = {.lex_state = 192, .external_lex_state = 2},
  [390] = {.lex_state = 192, .external_lex_state = 2},
  [391] = {.lex_state = 192, .external_lex_state = 2},
  [392] = {.lex_state = 192, .external_lex_state = 2},
  [393] = {.lex_state = 192, .external_lex_state = 2},
  [394] = {.lex_state = 192, .external_lex_state = 2},
  [395] = {.lex_state = 192, .external_lex_state = 2},
  [396] = {.lex_state = 192, .external_lex_state = 2},
  [397] = {.lex_state = 192, .external_lex_state = 2},
  [398] = {.lex_state = 416, .external_lex_state = 28},
  [399] = {.lex_state = 235, .external_lex_state = 13},
  [400] = {.lex_state = 197},
  [401] = {.lex_state = 299, .external_lex_state = 3},
  [402] = {.lex_state = 177, .external_lex_state = 4},
  [403] = {.lex_state = 177, .external_lex_state = 4},
  [404] = {.lex_state = 177, .external_lex_state = 4},
  [405] = {.lex_state = 177, .external_lex_state = 4},
  [406] = {.lex_state = 190, .external_lex_state = 4},
  [407] = {.lex_state = 190, .external_lex_state = 4},
  [408] = {.lex_state = 192, .external_lex_state = 2},
  [409] = {.lex_state = 192, .external_lex_state = 2},
  [410] = {.lex_state = 192, .external_lex_state = 2},
  [411] = {.lex_state = 237},
  [412] = {.lex_state = 419, .external_lex_state = 6},
  [413] = {.lex_state = 197, .external_lex_state = 7},
  [414] = {.lex_state = 209, .external_lex_state = 2},
  [415] = {.lex_state = 192, .external_lex_state = 2},
  [416] = {.lex_state = 216, .external_lex_state = 10},
  [417] = {.lex_state = 216, .external_lex_state = 9},
  [418] = {.lex_state = 364, .external_lex_state = 11},
  [419] = {.lex_state = 364, .external_lex_state = 11},
  [420] = {.lex_state = 364, .external_lex_state = 11},
  [421] = {.lex_state = 364, .external_lex_state = 11},
  [422] = {.lex_state = 221, .external_lex_state = 2},
  [423] = {.lex_state = 221, .external_lex_state = 2},
  [424] = {.lex_state = 192, .external_lex_state = 2},
  [425] = {.lex_state = 192, .external_lex_state = 2},
  [426] = {.lex_state = 223, .external_lex_state = 9},
  [427] = {.lex_state = 414, .external_lex_state = 12},
  [428] = {.lex_state = 221, .external_lex_state = 12},
  [429] = {.lex_state = 128, .external_lex_state = 12},
  [430] = {.lex_state = 356, .external_lex_state = 13},
  [431] = {.lex_state = 192, .external_lex_state = 2},
  [432] = {.lex_state = 192, .external_lex_state = 2},
  [433] = {.lex_state = 192, .external_lex_state = 2},
  [434] = {.lex_state = 358, .external_lex_state = 11},
  [435] = {.lex_state = 299, .external_lex_state = 3},
  [436] = {.lex_state = 235, .external_lex_state = 13},
  [437] = {.lex_state = 237},
  [438] = {.lex_state = 421, .external_lex_state = 3},
  [439] = {.lex_state = 299, .external_lex_state = 3},
  [440] = {.lex_state = 364, .external_lex_state = 11},
  [441] = {.lex_state = 227, .external_lex_state = 3},
  [442] = {.lex_state = 424, .external_lex_state = 3},
  [443] = {.lex_state = 424, .external_lex_state = 3},
  [444] = {.lex_state = 227, .external_lex_state = 3},
  [445] = {.lex_state = 213},
  [446] = {.lex_state = 421, .external_lex_state = 3},
  [447] = {.lex_state = 427, .external_lex_state = 14},
  [448] = {.lex_state = 192, .external_lex_state = 29},
  [449] = {.lex_state = 428, .external_lex_state = 9},
  [450] = {.lex_state = 192, .external_lex_state = 2},
  [451] = {.lex_state = 262, .external_lex_state = 14},
  [452] = {.lex_state = 192, .external_lex_state = 2},
  [453] = {.lex_state = 197},
  [454] = {.lex_state = 194},
  [455] = {.lex_state = 430, .external_lex_state = 18},
  [456] = {.lex_state = 430, .external_lex_state = 18},
  [457] = {.lex_state = 430, .external_lex_state = 18},
  [458] = {.lex_state = 430, .external_lex_state = 18},
  [459] = {.lex_state = 192, .external_lex_state = 2},
  [460] = {.lex_state = 192, .external_lex_state = 2},
  [461] = {.lex_state = 192, .external_lex_state = 2},
  [462] = {.lex_state = 225, .external_lex_state = 7},
  [463] = {.lex_state = 225, .external_lex_state = 7},
  [464] = {.lex_state = 433, .external_lex_state = 16},
  [465] = {.lex_state = 433, .external_lex_state = 16},
  [466] = {.lex_state = 433, .external_lex_state = 16},
  [467] = {.lex_state = 194},
  [468] = {.lex_state = 194},
  [469] = {.lex_state = 436, .external_lex_state = 16},
  [470] = {.lex_state = 288, .external_lex_state = 16},
  [471] = {.lex_state = 438, .external_lex_state = 18},
  [472] = {.lex_state = 213},
  [473] = {.lex_state = 441, .external_lex_state = 16},
  [474] = {.lex_state = 444, .external_lex_state = 20},
  [475] = {.lex_state = 265, .external_lex_state = 14},
  [476] = {.lex_state = 177, .external_lex_state = 4},
  [477] = {.lex_state = 156, .external_lex_state = 3},
  [478] = {.lex_state = 156, .external_lex_state = 3},
  [479] = {.lex_state = 156, .external_lex_state = 3},
  [480] = {.lex_state = 194},
  [481] = {.lex_state = 156, .external_lex_state = 3},
  [482] = {.lex_state = 192, .external_lex_state = 15},
  [483] = {.lex_state = 266, .external_lex_state = 15},
  [484] = {.lex_state = 156, .external_lex_state = 3},
  [485] = {.lex_state = 177, .external_lex_state = 4},
  [486] = {.lex_state = 266, .external_lex_state = 15},
  [487] = {.lex_state = 190, .external_lex_state = 4},
  [488] = {.lex_state = 156, .external_lex_state = 3},
  [489] = {.lex_state = 192, .external_lex_state = 15},
  [490] = {.lex_state = 266, .external_lex_state = 15},
  [491] = {.lex_state = 156, .external_lex_state = 3},
  [492] = {.lex_state = 177, .external_lex_state = 4},
  [493] = {.lex_state = 266, .external_lex_state = 15},
  [494] = {.lex_state = 241},
  [495] = {.lex_state = 192, .external_lex_state = 2},
  [496] = {.lex_state = 211, .external_lex_state = 8},
  [497] = {.lex_state = 447, .external_lex_state = 11},
  [498] = {.lex_state = 447, .external_lex_state = 11},
  [499] = {.lex_state = 447, .external_lex_state = 11},
  [500] = {.lex_state = 447, .external_lex_state = 11},
  [501] = {.lex_state = 192, .external_lex_state = 2},
  [502] = {.lex_state = 192, .external_lex_state = 2},
  [503] = {.lex_state = 192, .external_lex_state = 2},
  [504] = {.lex_state = 225, .external_lex_state = 7},
  [505] = {.lex_state = 194},
  [506] = {.lex_state = 237, .external_lex_state = 8},
  [507] = {.lex_state = 237, .external_lex_state = 8},
  [508] = {.lex_state = 436, .external_lex_state = 3},
  [509] = {.lex_state = 450, .external_lex_state = 11},
  [510] = {.lex_state = 213},
  [511] = {.lex_state = 441, .external_lex_state = 3},
  [512] = {.lex_state = 444, .external_lex_state = 14},
  [513] = {.lex_state = 265, .external_lex_state = 20},
  [514] = {.lex_state = 192, .external_lex_state = 15},
  [515] = {.lex_state = 288, .external_lex_state = 16},
  [516] = {.lex_state = 192, .external_lex_state = 15},
  [517] = {.lex_state = 288, .external_lex_state = 16},
  [518] = {.lex_state = 192, .external_lex_state = 15},
  [519] = {.lex_state = 288, .external_lex_state = 16},
  [520] = {.lex_state = 192, .external_lex_state = 15},
  [521] = {.lex_state = 288, .external_lex_state = 16},
  [522] = {.lex_state = 190, .external_lex_state = 4},
  [523] = {.lex_state = 266, .external_lex_state = 15},
  [524] = {.lex_state = 288, .external_lex_state = 16},
  [525] = {.lex_state = 190, .external_lex_state = 4},
  [526] = {.lex_state = 266, .external_lex_state = 15},
  [527] = {.lex_state = 453},
  [528] = {.lex_state = 221, .external_lex_state = 2},
  [529] = {.lex_state = 177, .external_lex_state = 17},
  [530] = {.lex_state = 302, .external_lex_state = 16},
  [531] = {.lex_state = 455, .external_lex_state = 20},
  [532] = {.lex_state = 192, .external_lex_state = 2},
  [533] = {.lex_state = 288, .external_lex_state = 16},
  [534] = {.lex_state = 194},
  [535] = {.lex_state = 194, .external_lex_state = 19},
  [536] = {.lex_state = 192, .external_lex_state = 2},
  [537] = {.lex_state = 288, .external_lex_state = 16},
  [538] = {.lex_state = 310},
  [539] = {.lex_state = 310, .external_lex_state = 8},
  [540] = {.lex_state = 288, .external_lex_state = 16},
  [541] = {.lex_state = 209},
  [542] = {.lex_state = 304, .external_lex_state = 18},
  [543] = {.lex_state = 192, .external_lex_state = 2},
  [544] = {.lex_state = 197},
  [545] = {.lex_state = 458, .external_lex_state = 26},
  [546] = {.lex_state = 458, .external_lex_state = 26},
  [547] = {.lex_state = 458, .external_lex_state = 26},
  [548] = {.lex_state = 458, .external_lex_state = 26},
  [549] = {.lex_state = 192, .external_lex_state = 2},
  [550] = {.lex_state = 192, .external_lex_state = 2},
  [551] = {.lex_state = 192, .external_lex_state = 2},
  [552] = {.lex_state = 461, .external_lex_state = 25},
  [553] = {.lex_state = 461, .external_lex_state = 25},
  [554] = {.lex_state = 461, .external_lex_state = 25},
  [555] = {.lex_state = 436, .external_lex_state = 25},
  [556] = {.lex_state = 464, .external_lex_state = 25},
  [557] = {.lex_state = 438, .external_lex_state = 26},
  [558] = {.lex_state = 213},
  [559] = {.lex_state = 441, .external_lex_state = 25},
  [560] = {.lex_state = 467, .external_lex_state = 27},
  [561] = {.lex_state = 192, .external_lex_state = 2},
  [562] = {.lex_state = 346, .external_lex_state = 23},
  [563] = {.lex_state = 346, .external_lex_state = 23},
  [564] = {.lex_state = 350, .external_lex_state = 23},
  [565] = {.lex_state = 350, .external_lex_state = 23},
  [566] = {.lex_state = 192, .external_lex_state = 2},
  [567] = {.lex_state = 192, .external_lex_state = 2},
  [568] = {.lex_state = 192, .external_lex_state = 2},
  [569] = {.lex_state = 237},
  [570] = {.lex_state = 192, .external_lex_state = 2},
  [571] = {.lex_state = 470, .external_lex_state = 26},
  [572] = {.lex_state = 470, .external_lex_state = 26},
  [573] = {.lex_state = 470, .external_lex_state = 26},
  [574] = {.lex_state = 470, .external_lex_state = 26},
  [575] = {.lex_state = 356, .external_lex_state = 13},
  [576] = {.lex_state = 192, .external_lex_state = 2},
  [577] = {.lex_state = 192, .external_lex_state = 2},
  [578] = {.lex_state = 192, .external_lex_state = 2},
  [579] = {.lex_state = 296, .external_lex_state = 26},
  [580] = {.lex_state = 361, .external_lex_state = 25},
  [581] = {.lex_state = 304, .external_lex_state = 26},
  [582] = {.lex_state = 288, .external_lex_state = 16},
  [583] = {.lex_state = 305, .external_lex_state = 25},
  [584] = {.lex_state = 361, .external_lex_state = 25},
  [585] = {.lex_state = 213},
  [586] = {.lex_state = 368, .external_lex_state = 25},
  [587] = {.lex_state = 371, .external_lex_state = 27},
  [588] = {.lex_state = 288, .external_lex_state = 16},
  [589] = {.lex_state = 288, .external_lex_state = 16},
  [590] = {.lex_state = 288, .external_lex_state = 16},
  [591] = {.lex_state = 128, .external_lex_state = 8},
  [592] = {.lex_state = 128, .external_lex_state = 8},
  [593] = {.lex_state = 247, .external_lex_state = 3},
  [594] = {.lex_state = 247, .external_lex_state = 3},
  [595] = {.lex_state = 128},
  [596] = {.lex_state = 247, .external_lex_state = 3},
  [597] = {.lex_state = 128},
  [598] = {.lex_state = 128},
  [599] = {.lex_state = 128},
  [600] = {.lex_state = 128},
  [601] = {.lex_state = 128},
  [602] = {.lex_state = 288, .external_lex_state = 16},
  [603] = {.lex_state = 128, .external_lex_state = 2},
  [604] = {.lex_state = 302, .external_lex_state = 16},
  [605] = {.lex_state = 302, .external_lex_state = 16},
  [606] = {.lex_state = 473, .external_lex_state = 16},
  [607] = {.lex_state = 288, .external_lex_state = 16},
  [608] = {.lex_state = 288, .external_lex_state = 16},
  [609] = {.lex_state = 235, .external_lex_state = 19},
  [610] = {.lex_state = 235},
  [611] = {.lex_state = 409, .external_lex_state = 2},
  [612] = {.lex_state = 414, .external_lex_state = 12},
  [613] = {.lex_state = 128},
  [614] = {.lex_state = 288, .external_lex_state = 16},
  [615] = {.lex_state = 192, .external_lex_state = 2},
  [616] = {.lex_state = 192, .external_lex_state = 2},
  [617] = {.lex_state = 192, .external_lex_state = 2},
  [618] = {.lex_state = 192, .external_lex_state = 2},
  [619] = {.lex_state = 192, .external_lex_state = 2},
  [620] = {.lex_state = 192, .external_lex_state = 2},
  [621] = {.lex_state = 192, .external_lex_state = 2},
  [622] = {.lex_state = 192, .external_lex_state = 2},
  [623] = {.lex_state = 192, .external_lex_state = 2},
  [624] = {.lex_state = 192, .external_lex_state = 2},
  [625] = {.lex_state = 192, .external_lex_state = 2},
  [626] = {.lex_state = 192, .external_lex_state = 2},
  [627] = {.lex_state = 192, .external_lex_state = 2},
  [628] = {.lex_state = 416, .external_lex_state = 28},
  [629] = {.lex_state = 235, .external_lex_state = 13},
  [630] = {.lex_state = 197},
  [631] = {.lex_state = 397, .external_lex_state = 25},
  [632] = {.lex_state = 177, .external_lex_state = 4},
  [633] = {.lex_state = 177, .external_lex_state = 4},
  [634] = {.lex_state = 177, .external_lex_state = 4},
  [635] = {.lex_state = 177, .external_lex_state = 4},
  [636] = {.lex_state = 190, .external_lex_state = 4},
  [637] = {.lex_state = 190, .external_lex_state = 4},
  [638] = {.lex_state = 192, .external_lex_state = 2},
  [639] = {.lex_state = 192, .external_lex_state = 2},
  [640] = {.lex_state = 192, .external_lex_state = 2},
  [641] = {.lex_state = 237},
  [642] = {.lex_state = 419, .external_lex_state = 6},
  [643] = {.lex_state = 197, .external_lex_state = 7},
  [644] = {.lex_state = 209, .external_lex_state = 2},
  [645] = {.lex_state = 192, .external_lex_state = 2},
  [646] = {.lex_state = 216, .external_lex_state = 10},
  [647] = {.lex_state = 216, .external_lex_state = 9},
  [648] = {.lex_state = 304, .external_lex_state = 26},
  [649] = {.lex_state = 304, .external_lex_state = 26},
  [650] = {.lex_state = 304, .external_lex_state = 26},
  [651] = {.lex_state = 304, .external_lex_state = 26},
  [652] = {.lex_state = 221, .external_lex_state = 2},
  [653] = {.lex_state = 221, .external_lex_state = 2},
  [654] = {.lex_state = 192, .external_lex_state = 2},
  [655] = {.lex_state = 192, .external_lex_state = 2},
  [656] = {.lex_state = 223, .external_lex_state = 9},
  [657] = {.lex_state = 414, .external_lex_state = 12},
  [658] = {.lex_state = 221, .external_lex_state = 12},
  [659] = {.lex_state = 128, .external_lex_state = 12},
  [660] = {.lex_state = 356, .external_lex_state = 13},
  [661] = {.lex_state = 192, .external_lex_state = 2},
  [662] = {.lex_state = 192, .external_lex_state = 2},
  [663] = {.lex_state = 192, .external_lex_state = 2},
  [664] = {.lex_state = 296, .external_lex_state = 26},
  [665] = {.lex_state = 397, .external_lex_state = 25},
  [666] = {.lex_state = 235, .external_lex_state = 13},
  [667] = {.lex_state = 237},
  [668] = {.lex_state = 421, .external_lex_state = 25},
  [669] = {.lex_state = 397, .external_lex_state = 25},
  [670] = {.lex_state = 304, .external_lex_state = 26},
  [671] = {.lex_state = 299, .external_lex_state = 16},
  [672] = {.lex_state = 421, .external_lex_state = 25},
  [673] = {.lex_state = 421, .external_lex_state = 25},
  [674] = {.lex_state = 299, .external_lex_state = 16},
  [675] = {.lex_state = 213},
  [676] = {.lex_state = 421, .external_lex_state = 25},
  [677] = {.lex_state = 427, .external_lex_state = 27},
  [678] = {.lex_state = 192, .external_lex_state = 29},
  [679] = {.lex_state = 192, .external_lex_state = 2},
  [680] = {.lex_state = 455, .external_lex_state = 20},
  [681] = {.lex_state = 156, .external_lex_state = 3},
  [682] = {.lex_state = 194},
  [683] = {.lex_state = 194, .external_lex_state = 6},
  [684] = {.lex_state = 211, .external_lex_state = 8},
  [685] = {.lex_state = 194},
  [686] = {.lex_state = 308, .external_lex_state = 8},
  [687] = {.lex_state = 192, .external_lex_state = 15},
  [688] = {.lex_state = 192, .external_lex_state = 2},
  [689] = {.lex_state = 475, .external_lex_state = 18},
  [690] = {.lex_state = 475, .external_lex_state = 18},
  [691] = {.lex_state = 475, .external_lex_state = 18},
  [692] = {.lex_state = 475, .external_lex_state = 18},
  [693] = {.lex_state = 192, .external_lex_state = 2},
  [694] = {.lex_state = 192, .external_lex_state = 2},
  [695] = {.lex_state = 192, .external_lex_state = 2},
  [696] = {.lex_state = 302, .external_lex_state = 16},
  [697] = {.lex_state = 478, .external_lex_state = 18},
  [698] = {.lex_state = 213},
  [699] = {.lex_state = 321, .external_lex_state = 16},
  [700] = {.lex_state = 324, .external_lex_state = 20},
  [701] = {.lex_state = 308, .external_lex_state = 8},
  [702] = {.lex_state = 225, .external_lex_state = 7},
  [703] = {.lex_state = 411},
  [704] = {.lex_state = 254, .external_lex_state = 8},
  [705] = {.lex_state = 254, .external_lex_state = 8},
  [706] = {.lex_state = 128},
  [707] = {.lex_state = 481, .external_lex_state = 8},
  [708] = {.lex_state = 128, .external_lex_state = 2},
  [709] = {.lex_state = 254, .external_lex_state = 8},
  [710] = {.lex_state = 302, .external_lex_state = 3},
  [711] = {.lex_state = 484, .external_lex_state = 21},
  [712] = {.lex_state = 192, .external_lex_state = 2},
  [713] = {.lex_state = 192, .external_lex_state = 2},
  [714] = {.lex_state = 192, .external_lex_state = 2},
  [715] = {.lex_state = 237},
  [716] = {.lex_state = 192, .external_lex_state = 2},
  [717] = {.lex_state = 487, .external_lex_state = 11},
  [718] = {.lex_state = 487, .external_lex_state = 11},
  [719] = {.lex_state = 487, .external_lex_state = 11},
  [720] = {.lex_state = 487, .external_lex_state = 11},
  [721] = {.lex_state = 192, .external_lex_state = 2},
  [722] = {.lex_state = 192, .external_lex_state = 2},
  [723] = {.lex_state = 192, .external_lex_state = 2},
  [724] = {.lex_state = 490, .external_lex_state = 11},
  [725] = {.lex_state = 493, .external_lex_state = 3},
  [726] = {.lex_state = 496, .external_lex_state = 11},
  [727] = {.lex_state = 324, .external_lex_state = 3},
  [728] = {.lex_state = 493, .external_lex_state = 3},
  [729] = {.lex_state = 213},
  [730] = {.lex_state = 497, .external_lex_state = 3},
  [731] = {.lex_state = 493, .external_lex_state = 14},
  [732] = {.lex_state = 302, .external_lex_state = 3},
  [733] = {.lex_state = 302, .external_lex_state = 3},
  [734] = {.lex_state = 302, .external_lex_state = 8},
  [735] = {.lex_state = 156, .external_lex_state = 3},
  [736] = {.lex_state = 209, .external_lex_state = 2},
  [737] = {.lex_state = 209, .external_lex_state = 8},
  [738] = {.lex_state = 192, .external_lex_state = 2},
  [739] = {.lex_state = 192, .external_lex_state = 2},
  [740] = {.lex_state = 192, .external_lex_state = 2},
  [741] = {.lex_state = 192, .external_lex_state = 2},
  [742] = {.lex_state = 192, .external_lex_state = 2},
  [743] = {.lex_state = 192, .external_lex_state = 2},
  [744] = {.lex_state = 192, .external_lex_state = 2},
  [745] = {.lex_state = 192, .external_lex_state = 2},
  [746] = {.lex_state = 192, .external_lex_state = 2},
  [747] = {.lex_state = 192, .external_lex_state = 2},
  [748] = {.lex_state = 192, .external_lex_state = 2},
  [749] = {.lex_state = 192, .external_lex_state = 2},
  [750] = {.lex_state = 192, .external_lex_state = 2},
  [751] = {.lex_state = 192, .external_lex_state = 2},
  [752] = {.lex_state = 192, .external_lex_state = 2},
  [753] = {.lex_state = 192, .external_lex_state = 2},
  [754] = {.lex_state = 192, .external_lex_state = 2},
  [755] = {.lex_state = 192, .external_lex_state = 2},
  [756] = {.lex_state = 192, .external_lex_state = 2},
  [757] = {.lex_state = 192, .external_lex_state = 2},
  [758] = {.lex_state = 237},
  [759] = {.lex_state = 192, .external_lex_state = 2},
  [760] = {.lex_state = 496, .external_lex_state = 11},
  [761] = {.lex_state = 496, .external_lex_state = 11},
  [762] = {.lex_state = 496, .external_lex_state = 11},
  [763] = {.lex_state = 496, .external_lex_state = 11},
  [764] = {.lex_state = 192, .external_lex_state = 2},
  [765] = {.lex_state = 192, .external_lex_state = 2},
  [766] = {.lex_state = 192, .external_lex_state = 2},
  [767] = {.lex_state = 490, .external_lex_state = 11},
  [768] = {.lex_state = 497, .external_lex_state = 3},
  [769] = {.lex_state = 496, .external_lex_state = 11},
  [770] = {.lex_state = 321, .external_lex_state = 3},
  [771] = {.lex_state = 321, .external_lex_state = 3},
  [772] = {.lex_state = 213},
  [773] = {.lex_state = 497, .external_lex_state = 3},
  [774] = {.lex_state = 497, .external_lex_state = 14},
  [775] = {.lex_state = 192, .external_lex_state = 29},
  [776] = {.lex_state = 313},
  [777] = {.lex_state = 500, .external_lex_state = 9},
  [778] = {.lex_state = 192, .external_lex_state = 2},
  [779] = {.lex_state = 324, .external_lex_state = 14},
  [780] = {.lex_state = 343, .external_lex_state = 22},
  [781] = {.lex_state = 192, .external_lex_state = 15},
  [782] = {.lex_state = 330},
  [783] = {.lex_state = 192, .external_lex_state = 15},
  [784] = {.lex_state = 330},
  [785] = {.lex_state = 192, .external_lex_state = 15},
  [786] = {.lex_state = 330},
  [787] = {.lex_state = 192, .external_lex_state = 15},
  [788] = {.lex_state = 330},
  [789] = {.lex_state = 190, .external_lex_state = 4},
  [790] = {.lex_state = 266, .external_lex_state = 15},
  [791] = {.lex_state = 330},
  [792] = {.lex_state = 190, .external_lex_state = 4},
  [793] = {.lex_state = 266, .external_lex_state = 15},
  [794] = {.lex_state = 330},
  [795] = {.lex_state = 194},
  [796] = {.lex_state = 194, .external_lex_state = 19},
  [797] = {.lex_state = 192, .external_lex_state = 2},
  [798] = {.lex_state = 330},
  [799] = {.lex_state = 310},
  [800] = {.lex_state = 310, .external_lex_state = 8},
  [801] = {.lex_state = 330},
  [802] = {.lex_state = 209},
  [803] = {.lex_state = 484, .external_lex_state = 21},
  [804] = {.lex_state = 192, .external_lex_state = 2},
  [805] = {.lex_state = 346, .external_lex_state = 23},
  [806] = {.lex_state = 346, .external_lex_state = 23},
  [807] = {.lex_state = 350, .external_lex_state = 23},
  [808] = {.lex_state = 350, .external_lex_state = 23},
  [809] = {.lex_state = 192, .external_lex_state = 2},
  [810] = {.lex_state = 192, .external_lex_state = 2},
  [811] = {.lex_state = 237},
  [812] = {.lex_state = 192, .external_lex_state = 2},
  [813] = {.lex_state = 356, .external_lex_state = 13},
  [814] = {.lex_state = 296, .external_lex_state = 26},
  [815] = {.lex_state = 361, .external_lex_state = 25},
  [816] = {.lex_state = 330},
  [817] = {.lex_state = 334, .external_lex_state = 19},
  [818] = {.lex_state = 340, .external_lex_state = 19},
  [819] = {.lex_state = 371, .external_lex_state = 27},
  [820] = {.lex_state = 330},
  [821] = {.lex_state = 330},
  [822] = {.lex_state = 330},
  [823] = {.lex_state = 128, .external_lex_state = 8},
  [824] = {.lex_state = 128, .external_lex_state = 8},
  [825] = {.lex_state = 247, .external_lex_state = 3},
  [826] = {.lex_state = 247, .external_lex_state = 3},
  [827] = {.lex_state = 128},
  [828] = {.lex_state = 247, .external_lex_state = 3},
  [829] = {.lex_state = 128},
  [830] = {.lex_state = 128},
  [831] = {.lex_state = 128},
  [832] = {.lex_state = 128},
  [833] = {.lex_state = 128},
  [834] = {.lex_state = 330},
  [835] = {.lex_state = 128, .external_lex_state = 2},
  [836] = {.lex_state = 330},
  [837] = {.lex_state = 330},
  [838] = {.lex_state = 235, .external_lex_state = 19},
  [839] = {.lex_state = 235},
  [840] = {.lex_state = 409, .external_lex_state = 2},
  [841] = {.lex_state = 414, .external_lex_state = 12},
  [842] = {.lex_state = 128},
  [843] = {.lex_state = 337},
  [844] = {.lex_state = 416, .external_lex_state = 28},
  [845] = {.lex_state = 235, .external_lex_state = 13},
  [846] = {.lex_state = 197},
  [847] = {.lex_state = 192, .external_lex_state = 2},
  [848] = {.lex_state = 192, .external_lex_state = 2},
  [849] = {.lex_state = 192, .external_lex_state = 2},
  [850] = {.lex_state = 237},
  [851] = {.lex_state = 419, .external_lex_state = 6},
  [852] = {.lex_state = 192, .external_lex_state = 2},
  [853] = {.lex_state = 502, .external_lex_state = 26},
  [854] = {.lex_state = 502, .external_lex_state = 26},
  [855] = {.lex_state = 502, .external_lex_state = 26},
  [856] = {.lex_state = 502, .external_lex_state = 26},
  [857] = {.lex_state = 192, .external_lex_state = 2},
  [858] = {.lex_state = 192, .external_lex_state = 2},
  [859] = {.lex_state = 192, .external_lex_state = 2},
  [860] = {.lex_state = 296, .external_lex_state = 26},
  [861] = {.lex_state = 505, .external_lex_state = 25},
  [862] = {.lex_state = 337},
  [863] = {.lex_state = 340, .external_lex_state = 19},
  [864] = {.lex_state = 340, .external_lex_state = 19},
  [865] = {.lex_state = 337},
  [866] = {.lex_state = 213},
  [867] = {.lex_state = 421, .external_lex_state = 25},
  [868] = {.lex_state = 505, .external_lex_state = 27},
  [869] = {.lex_state = 343, .external_lex_state = 22},
  [870] = {.lex_state = 247, .external_lex_state = 3},
  [871] = {.lex_state = 346, .external_lex_state = 23},
  [872] = {.lex_state = 192, .external_lex_state = 2},
  [873] = {.lex_state = 128, .external_lex_state = 8},
  [874] = {.lex_state = 128, .external_lex_state = 2},
  [875] = {.lex_state = 197},
  [876] = {.lex_state = 192, .external_lex_state = 2},
  [877] = {.lex_state = 192, .external_lex_state = 2},
  [878] = {.lex_state = 192, .external_lex_state = 2},
  [879] = {.lex_state = 237},
  [880] = {.lex_state = 419, .external_lex_state = 6},
  [881] = {.lex_state = 192, .external_lex_state = 2},
  [882] = {.lex_state = 470, .external_lex_state = 26},
  [883] = {.lex_state = 470, .external_lex_state = 26},
  [884] = {.lex_state = 470, .external_lex_state = 26},
  [885] = {.lex_state = 470, .external_lex_state = 26},
  [886] = {.lex_state = 192, .external_lex_state = 2},
  [887] = {.lex_state = 192, .external_lex_state = 2},
  [888] = {.lex_state = 192, .external_lex_state = 2},
  [889] = {.lex_state = 296, .external_lex_state = 26},
  [890] = {.lex_state = 508, .external_lex_state = 25},
  [891] = {.lex_state = 334, .external_lex_state = 19},
  [892] = {.lex_state = 340, .external_lex_state = 19},
  [893] = {.lex_state = 213},
  [894] = {.lex_state = 421, .external_lex_state = 25},
  [895] = {.lex_state = 508, .external_lex_state = 27},
  [896] = {.lex_state = 156, .external_lex_state = 3},
  [897] = {.lex_state = 128, .external_lex_state = 2},
  [898] = {.lex_state = 192, .external_lex_state = 2},
  [899] = {.lex_state = 511, .external_lex_state = 11},
  [900] = {.lex_state = 511, .external_lex_state = 11},
  [901] = {.lex_state = 511, .external_lex_state = 11},
  [902] = {.lex_state = 511, .external_lex_state = 11},
  [903] = {.lex_state = 192, .external_lex_state = 2},
  [904] = {.lex_state = 192, .external_lex_state = 2},
  [905] = {.lex_state = 192, .external_lex_state = 2},
  [906] = {.lex_state = 365, .external_lex_state = 3},
  [907] = {.lex_state = 213},
  [908] = {.lex_state = 259, .external_lex_state = 3},
  [909] = {.lex_state = 365, .external_lex_state = 14},
  [910] = {.lex_state = 365, .external_lex_state = 3},
  [911] = {.lex_state = 361, .external_lex_state = 3},
  [912] = {.lex_state = 361, .external_lex_state = 14},
  [913] = {.lex_state = 192, .external_lex_state = 2},
  [914] = {.lex_state = 514, .external_lex_state = 11},
  [915] = {.lex_state = 365, .external_lex_state = 3},
  [916] = {.lex_state = 192, .external_lex_state = 2},
  [917] = {.lex_state = 192, .external_lex_state = 2},
  [918] = {.lex_state = 237},
  [919] = {.lex_state = 192, .external_lex_state = 2},
  [920] = {.lex_state = 358, .external_lex_state = 11},
  [921] = {.lex_state = 361, .external_lex_state = 3},
  [922] = {.lex_state = 361, .external_lex_state = 3},
  [923] = {.lex_state = 361, .external_lex_state = 3},
  [924] = {.lex_state = 371, .external_lex_state = 14},
  [925] = {.lex_state = 192, .external_lex_state = 2},
  [926] = {.lex_state = 192, .external_lex_state = 2},
  [927] = {.lex_state = 192, .external_lex_state = 2},
  [928] = {.lex_state = 237},
  [929] = {.lex_state = 156, .external_lex_state = 3},
  [930] = {.lex_state = 192, .external_lex_state = 2},
  [931] = {.lex_state = 517, .external_lex_state = 26},
  [932] = {.lex_state = 517, .external_lex_state = 26},
  [933] = {.lex_state = 517, .external_lex_state = 26},
  [934] = {.lex_state = 517, .external_lex_state = 26},
  [935] = {.lex_state = 192, .external_lex_state = 2},
  [936] = {.lex_state = 192, .external_lex_state = 2},
  [937] = {.lex_state = 192, .external_lex_state = 2},
  [938] = {.lex_state = 520, .external_lex_state = 26},
  [939] = {.lex_state = 302, .external_lex_state = 25},
  [940] = {.lex_state = 523, .external_lex_state = 26},
  [941] = {.lex_state = 209, .external_lex_state = 19},
  [942] = {.lex_state = 302, .external_lex_state = 19},
  [943] = {.lex_state = 213},
  [944] = {.lex_state = 497, .external_lex_state = 25},
  [945] = {.lex_state = 493, .external_lex_state = 27},
  [946] = {.lex_state = 209},
  [947] = {.lex_state = 361, .external_lex_state = 3},
  [948] = {.lex_state = 361, .external_lex_state = 3},
  [949] = {.lex_state = 156, .external_lex_state = 3},
  [950] = {.lex_state = 192, .external_lex_state = 2},
  [951] = {.lex_state = 192, .external_lex_state = 2},
  [952] = {.lex_state = 192, .external_lex_state = 2},
  [953] = {.lex_state = 192, .external_lex_state = 2},
  [954] = {.lex_state = 192, .external_lex_state = 2},
  [955] = {.lex_state = 192, .external_lex_state = 2},
  [956] = {.lex_state = 192, .external_lex_state = 2},
  [957] = {.lex_state = 192, .external_lex_state = 2},
  [958] = {.lex_state = 192, .external_lex_state = 2},
  [959] = {.lex_state = 192, .external_lex_state = 2},
  [960] = {.lex_state = 192, .external_lex_state = 2},
  [961] = {.lex_state = 192, .external_lex_state = 2},
  [962] = {.lex_state = 192, .external_lex_state = 2},
  [963] = {.lex_state = 416, .external_lex_state = 28},
  [964] = {.lex_state = 235, .external_lex_state = 13},
  [965] = {.lex_state = 197},
  [966] = {.lex_state = 192, .external_lex_state = 2},
  [967] = {.lex_state = 192, .external_lex_state = 2},
  [968] = {.lex_state = 237},
  [969] = {.lex_state = 419, .external_lex_state = 6},
  [970] = {.lex_state = 192, .external_lex_state = 2},
  [971] = {.lex_state = 414, .external_lex_state = 12},
  [972] = {.lex_state = 356, .external_lex_state = 13},
  [973] = {.lex_state = 358, .external_lex_state = 11},
  [974] = {.lex_state = 421, .external_lex_state = 3},
  [975] = {.lex_state = 299, .external_lex_state = 3},
  [976] = {.lex_state = 421, .external_lex_state = 3},
  [977] = {.lex_state = 421, .external_lex_state = 3},
  [978] = {.lex_state = 299, .external_lex_state = 3},
  [979] = {.lex_state = 427, .external_lex_state = 14},
  [980] = {.lex_state = 177, .external_lex_state = 17},
  [981] = {.lex_state = 262, .external_lex_state = 3},
  [982] = {.lex_state = 524, .external_lex_state = 13},
  [983] = {.lex_state = 365, .external_lex_state = 3},
  [984] = {.lex_state = 192, .external_lex_state = 29},
  [985] = {.lex_state = 192, .external_lex_state = 2},
  [986] = {.lex_state = 361, .external_lex_state = 14},
  [987] = {.lex_state = 247, .external_lex_state = 3},
  [988] = {.lex_state = 192, .external_lex_state = 2},
  [989] = {.lex_state = 192, .external_lex_state = 2},
  [990] = {.lex_state = 192, .external_lex_state = 2},
  [991] = {.lex_state = 237},
  [992] = {.lex_state = 192, .external_lex_state = 2},
  [993] = {.lex_state = 353, .external_lex_state = 11},
  [994] = {.lex_state = 353, .external_lex_state = 11},
  [995] = {.lex_state = 353, .external_lex_state = 11},
  [996] = {.lex_state = 353, .external_lex_state = 11},
  [997] = {.lex_state = 192, .external_lex_state = 2},
  [998] = {.lex_state = 192, .external_lex_state = 2},
  [999] = {.lex_state = 192, .external_lex_state = 2},
  [1000] = {.lex_state = 358, .external_lex_state = 11},
  [1001] = {.lex_state = 361, .external_lex_state = 3},
  [1002] = {.lex_state = 364, .external_lex_state = 11},
  [1003] = {.lex_state = 262, .external_lex_state = 3},
  [1004] = {.lex_state = 361, .external_lex_state = 3},
  [1005] = {.lex_state = 213},
  [1006] = {.lex_state = 368, .external_lex_state = 3},
  [1007] = {.lex_state = 371, .external_lex_state = 14},
  [1008] = {.lex_state = 247, .external_lex_state = 3},
  [1009] = {.lex_state = 247, .external_lex_state = 3},
  [1010] = {.lex_state = 254, .external_lex_state = 8},
  [1011] = {.lex_state = 177, .external_lex_state = 17},
  [1012] = {.lex_state = 192, .external_lex_state = 2},
  [1013] = {.lex_state = 192, .external_lex_state = 2},
  [1014] = {.lex_state = 192, .external_lex_state = 2},
  [1015] = {.lex_state = 192, .external_lex_state = 2},
  [1016] = {.lex_state = 192, .external_lex_state = 2},
  [1017] = {.lex_state = 128, .external_lex_state = 12},
  [1018] = {.lex_state = 128, .external_lex_state = 12},
  [1019] = {.lex_state = 192, .external_lex_state = 2},
  [1020] = {.lex_state = 192, .external_lex_state = 2},
  [1021] = {.lex_state = 192, .external_lex_state = 2},
  [1022] = {.lex_state = 192, .external_lex_state = 2},
  [1023] = {.lex_state = 192, .external_lex_state = 2},
  [1024] = {.lex_state = 192, .external_lex_state = 2},
  [1025] = {.lex_state = 192, .external_lex_state = 2},
  [1026] = {.lex_state = 192, .external_lex_state = 2},
  [1027] = {.lex_state = 192, .external_lex_state = 2},
  [1028] = {.lex_state = 192, .external_lex_state = 2},
  [1029] = {.lex_state = 192, .external_lex_state = 2},
  [1030] = {.lex_state = 192, .external_lex_state = 2},
  [1031] = {.lex_state = 192, .external_lex_state = 2},
  [1032] = {.lex_state = 192, .external_lex_state = 2},
  [1033] = {.lex_state = 192, .external_lex_state = 2},
  [1034] = {.lex_state = 237},
  [1035] = {.lex_state = 192, .external_lex_state = 2},
  [1036] = {.lex_state = 364, .external_lex_state = 11},
  [1037] = {.lex_state = 364, .external_lex_state = 11},
  [1038] = {.lex_state = 364, .external_lex_state = 11},
  [1039] = {.lex_state = 364, .external_lex_state = 11},
  [1040] = {.lex_state = 192, .external_lex_state = 2},
  [1041] = {.lex_state = 192, .external_lex_state = 2},
  [1042] = {.lex_state = 192, .external_lex_state = 2},
  [1043] = {.lex_state = 358, .external_lex_state = 11},
  [1044] = {.lex_state = 421, .external_lex_state = 3},
  [1045] = {.lex_state = 364, .external_lex_state = 11},
  [1046] = {.lex_state = 424, .external_lex_state = 3},
  [1047] = {.lex_state = 424, .external_lex_state = 3},
  [1048] = {.lex_state = 213},
  [1049] = {.lex_state = 421, .external_lex_state = 3},
  [1050] = {.lex_state = 427, .external_lex_state = 14},
  [1051] = {.lex_state = 192, .external_lex_state = 29},
  [1052] = {.lex_state = 192, .external_lex_state = 2},
  [1053] = {.lex_state = 262, .external_lex_state = 14},
  [1054] = {.lex_state = 128, .external_lex_state = 2},
  [1055] = {.lex_state = 128, .external_lex_state = 2},
  [1056] = {.lex_state = 247, .external_lex_state = 3},
  [1057] = {.lex_state = 192, .external_lex_state = 2},
  [1058] = {.lex_state = 192, .external_lex_state = 2},
  [1059] = {.lex_state = 192, .external_lex_state = 2},
  [1060] = {.lex_state = 237},
  [1061] = {.lex_state = 192, .external_lex_state = 2},
  [1062] = {.lex_state = 353, .external_lex_state = 11},
  [1063] = {.lex_state = 353, .external_lex_state = 11},
  [1064] = {.lex_state = 353, .external_lex_state = 11},
  [1065] = {.lex_state = 353, .external_lex_state = 11},
  [1066] = {.lex_state = 192, .external_lex_state = 2},
  [1067] = {.lex_state = 192, .external_lex_state = 2},
  [1068] = {.lex_state = 192, .external_lex_state = 2},
  [1069] = {.lex_state = 358, .external_lex_state = 11},
  [1070] = {.lex_state = 361, .external_lex_state = 3},
  [1071] = {.lex_state = 364, .external_lex_state = 11},
  [1072] = {.lex_state = 262, .external_lex_state = 3},
  [1073] = {.lex_state = 361, .external_lex_state = 3},
  [1074] = {.lex_state = 213},
  [1075] = {.lex_state = 368, .external_lex_state = 3},
  [1076] = {.lex_state = 371, .external_lex_state = 14},
  [1077] = {.lex_state = 247, .external_lex_state = 3},
  [1078] = {.lex_state = 247, .external_lex_state = 3},
  [1079] = {.lex_state = 192, .external_lex_state = 2},
  [1080] = {.lex_state = 192, .external_lex_state = 2},
  [1081] = {.lex_state = 192, .external_lex_state = 2},
  [1082] = {.lex_state = 192, .external_lex_state = 2},
  [1083] = {.lex_state = 192, .external_lex_state = 2},
  [1084] = {.lex_state = 192, .external_lex_state = 2},
  [1085] = {.lex_state = 192, .external_lex_state = 2},
  [1086] = {.lex_state = 192, .external_lex_state = 2},
  [1087] = {.lex_state = 192, .external_lex_state = 2},
  [1088] = {.lex_state = 192, .external_lex_state = 2},
  [1089] = {.lex_state = 192, .external_lex_state = 2},
  [1090] = {.lex_state = 192, .external_lex_state = 2},
  [1091] = {.lex_state = 128, .external_lex_state = 2},
  [1092] = {.lex_state = 192, .external_lex_state = 2},
  [1093] = {.lex_state = 192, .external_lex_state = 2},
  [1094] = {.lex_state = 192, .external_lex_state = 2},
  [1095] = {.lex_state = 237},
  [1096] = {.lex_state = 419, .external_lex_state = 6},
  [1097] = {.lex_state = 192, .external_lex_state = 2},
  [1098] = {.lex_state = 364, .external_lex_state = 11},
  [1099] = {.lex_state = 364, .external_lex_state = 11},
  [1100] = {.lex_state = 364, .external_lex_state = 11},
  [1101] = {.lex_state = 364, .external_lex_state = 11},
  [1102] = {.lex_state = 192, .external_lex_state = 2},
  [1103] = {.lex_state = 192, .external_lex_state = 2},
  [1104] = {.lex_state = 192, .external_lex_state = 2},
  [1105] = {.lex_state = 358, .external_lex_state = 11},
  [1106] = {.lex_state = 421, .external_lex_state = 3},
  [1107] = {.lex_state = 364, .external_lex_state = 11},
  [1108] = {.lex_state = 227, .external_lex_state = 3},
  [1109] = {.lex_state = 424, .external_lex_state = 3},
  [1110] = {.lex_state = 424, .external_lex_state = 3},
  [1111] = {.lex_state = 213},
  [1112] = {.lex_state = 421, .external_lex_state = 3},
  [1113] = {.lex_state = 427, .external_lex_state = 14},
  [1114] = {.lex_state = 192, .external_lex_state = 29},
  [1115] = {.lex_state = 192, .external_lex_state = 2},
  [1116] = {.lex_state = 262, .external_lex_state = 14},
  [1117] = {.lex_state = 128, .external_lex_state = 2},
  [1118] = {.lex_state = 192, .external_lex_state = 2},
  [1119] = {.lex_state = 192, .external_lex_state = 2},
  [1120] = {.lex_state = 192, .external_lex_state = 2},
  [1121] = {.lex_state = 237},
  [1122] = {.lex_state = 192, .external_lex_state = 2},
  [1123] = {.lex_state = 470, .external_lex_state = 26},
  [1124] = {.lex_state = 470, .external_lex_state = 26},
  [1125] = {.lex_state = 470, .external_lex_state = 26},
  [1126] = {.lex_state = 470, .external_lex_state = 26},
  [1127] = {.lex_state = 192, .external_lex_state = 2},
  [1128] = {.lex_state = 192, .external_lex_state = 2},
  [1129] = {.lex_state = 192, .external_lex_state = 2},
  [1130] = {.lex_state = 296, .external_lex_state = 26},
  [1131] = {.lex_state = 508, .external_lex_state = 25},
  [1132] = {.lex_state = 304, .external_lex_state = 26},
  [1133] = {.lex_state = 340, .external_lex_state = 19},
  [1134] = {.lex_state = 340, .external_lex_state = 19},
  [1135] = {.lex_state = 213},
  [1136] = {.lex_state = 421, .external_lex_state = 25},
  [1137] = {.lex_state = 508, .external_lex_state = 27},
  [1138] = {.lex_state = 192, .external_lex_state = 2},
  [1139] = {.lex_state = 128, .external_lex_state = 8},
  [1140] = {.lex_state = 223, .external_lex_state = 9},
  [1141] = {.lex_state = 247, .external_lex_state = 3},
  [1142] = {.lex_state = 192, .external_lex_state = 2},
  [1143] = {.lex_state = 192, .external_lex_state = 2},
  [1144] = {.lex_state = 192, .external_lex_state = 2},
  [1145] = {.lex_state = 237},
  [1146] = {.lex_state = 192, .external_lex_state = 2},
  [1147] = {.lex_state = 353, .external_lex_state = 11},
  [1148] = {.lex_state = 353, .external_lex_state = 11},
  [1149] = {.lex_state = 353, .external_lex_state = 11},
  [1150] = {.lex_state = 353, .external_lex_state = 11},
  [1151] = {.lex_state = 192, .external_lex_state = 2},
  [1152] = {.lex_state = 192, .external_lex_state = 2},
  [1153] = {.lex_state = 192, .external_lex_state = 2},
  [1154] = {.lex_state = 358, .external_lex_state = 11},
  [1155] = {.lex_state = 361, .external_lex_state = 3},
  [1156] = {.lex_state = 364, .external_lex_state = 11},
  [1157] = {.lex_state = 262, .external_lex_state = 3},
  [1158] = {.lex_state = 361, .external_lex_state = 3},
  [1159] = {.lex_state = 213},
  [1160] = {.lex_state = 368, .external_lex_state = 3},
  [1161] = {.lex_state = 371, .external_lex_state = 14},
  [1162] = {.lex_state = 247, .external_lex_state = 3},
  [1163] = {.lex_state = 247, .external_lex_state = 3},
  [1164] = {.lex_state = 192, .external_lex_state = 2},
  [1165] = {.lex_state = 192, .external_lex_state = 2},
  [1166] = {.lex_state = 192, .external_lex_state = 2},
  [1167] = {.lex_state = 192, .external_lex_state = 2},
  [1168] = {.lex_state = 192, .external_lex_state = 2},
  [1169] = {.lex_state = 192, .external_lex_state = 2},
  [1170] = {.lex_state = 192, .external_lex_state = 2},
  [1171] = {.lex_state = 192, .external_lex_state = 2},
  [1172] = {.lex_state = 192, .external_lex_state = 2},
  [1173] = {.lex_state = 192, .external_lex_state = 2},
  [1174] = {.lex_state = 192, .external_lex_state = 2},
  [1175] = {.lex_state = 192, .external_lex_state = 2},
  [1176] = {.lex_state = 128},
  [1177] = {.lex_state = 192, .external_lex_state = 29},
  [1178] = {.lex_state = 192, .external_lex_state = 2},
  [1179] = {.lex_state = 262, .external_lex_state = 14},
  [1180] = {.lex_state = 192, .external_lex_state = 29},
  [1181] = {.lex_state = 128},
  [1182] = {.lex_state = 128},
  [1183] = {.lex_state = 526, .external_lex_state = 2},
  [1184] = {.lex_state = 177, .external_lex_state = 17},
  [1185] = {.lex_state = 247, .external_lex_state = 3},
  [1186] = {.lex_state = 192, .external_lex_state = 2},
  [1187] = {.lex_state = 192, .external_lex_state = 2},
  [1188] = {.lex_state = 192, .external_lex_state = 2},
  [1189] = {.lex_state = 237},
  [1190] = {.lex_state = 192, .external_lex_state = 2},
  [1191] = {.lex_state = 353, .external_lex_state = 11},
  [1192] = {.lex_state = 353, .external_lex_state = 11},
  [1193] = {.lex_state = 353, .external_lex_state = 11},
  [1194] = {.lex_state = 353, .external_lex_state = 11},
  [1195] = {.lex_state = 192, .external_lex_state = 2},
  [1196] = {.lex_state = 192, .external_lex_state = 2},
  [1197] = {.lex_state = 192, .external_lex_state = 2},
  [1198] = {.lex_state = 358, .external_lex_state = 11},
  [1199] = {.lex_state = 361, .external_lex_state = 3},
  [1200] = {.lex_state = 364, .external_lex_state = 11},
  [1201] = {.lex_state = 262, .external_lex_state = 3},
  [1202] = {.lex_state = 361, .external_lex_state = 3},
  [1203] = {.lex_state = 213},
  [1204] = {.lex_state = 368, .external_lex_state = 3},
  [1205] = {.lex_state = 371, .external_lex_state = 14},
  [1206] = {.lex_state = 192, .external_lex_state = 2},
  [1207] = {.lex_state = 192, .external_lex_state = 2},
  [1208] = {.lex_state = 353, .external_lex_state = 11},
  [1209] = {.lex_state = 353, .external_lex_state = 11},
  [1210] = {.lex_state = 353, .external_lex_state = 11},
  [1211] = {.lex_state = 353, .external_lex_state = 11},
  [1212] = {.lex_state = 216, .external_lex_state = 9},
  [1213] = {.lex_state = 192, .external_lex_state = 2},
  [1214] = {.lex_state = 192, .external_lex_state = 2},
  [1215] = {.lex_state = 192, .external_lex_state = 2},
  [1216] = {.lex_state = 128, .external_lex_state = 2},
  [1217] = {.lex_state = 305, .external_lex_state = 8},
  [1218] = {.lex_state = 128, .external_lex_state = 8},
  [1219] = {.lex_state = 528, .external_lex_state = 3},
  [1220] = {.lex_state = 364, .external_lex_state = 11},
  [1221] = {.lex_state = 353, .external_lex_state = 8},
  [1222] = {.lex_state = 213},
  [1223] = {.lex_state = 368, .external_lex_state = 3},
  [1224] = {.lex_state = 361, .external_lex_state = 14},
  [1225] = {.lex_state = 192, .external_lex_state = 2},
  [1226] = {.lex_state = 414, .external_lex_state = 12},
  [1227] = {.lex_state = 218, .external_lex_state = 11},
  [1228] = {.lex_state = 218, .external_lex_state = 11},
  [1229] = {.lex_state = 218, .external_lex_state = 11},
  [1230] = {.lex_state = 218, .external_lex_state = 11},
  [1231] = {.lex_state = 192, .external_lex_state = 2},
  [1232] = {.lex_state = 192, .external_lex_state = 2},
  [1233] = {.lex_state = 192, .external_lex_state = 2},
  [1234] = {.lex_state = 225, .external_lex_state = 7},
  [1235] = {.lex_state = 128},
  [1236] = {.lex_state = 128, .external_lex_state = 8},
  [1237] = {.lex_state = 128, .external_lex_state = 8},
  [1238] = {.lex_state = 247, .external_lex_state = 3},
  [1239] = {.lex_state = 254, .external_lex_state = 11},
  [1240] = {.lex_state = 213},
  [1241] = {.lex_state = 259, .external_lex_state = 3},
  [1242] = {.lex_state = 262, .external_lex_state = 14},
  [1243] = {.lex_state = 128, .external_lex_state = 2},
  [1244] = {.lex_state = 192, .external_lex_state = 2},
  [1245] = {.lex_state = 218, .external_lex_state = 11},
  [1246] = {.lex_state = 218, .external_lex_state = 11},
  [1247] = {.lex_state = 218, .external_lex_state = 11},
  [1248] = {.lex_state = 218, .external_lex_state = 11},
  [1249] = {.lex_state = 192, .external_lex_state = 2},
  [1250] = {.lex_state = 192, .external_lex_state = 2},
  [1251] = {.lex_state = 192, .external_lex_state = 2},
  [1252] = {.lex_state = 225, .external_lex_state = 7},
  [1253] = {.lex_state = 128},
  [1254] = {.lex_state = 128, .external_lex_state = 8},
  [1255] = {.lex_state = 128, .external_lex_state = 8},
  [1256] = {.lex_state = 247, .external_lex_state = 3},
  [1257] = {.lex_state = 254, .external_lex_state = 11},
  [1258] = {.lex_state = 213},
  [1259] = {.lex_state = 259, .external_lex_state = 3},
  [1260] = {.lex_state = 262, .external_lex_state = 14},
  [1261] = {.lex_state = 247, .external_lex_state = 3},
  [1262] = {.lex_state = 247, .external_lex_state = 3},
  [1263] = {.lex_state = 254, .external_lex_state = 8},
  [1264] = {.lex_state = 156, .external_lex_state = 3},
  [1265] = {.lex_state = 128},
  [1266] = {.lex_state = 128},
  [1267] = {.lex_state = 128},
  [1268] = {.lex_state = 128, .external_lex_state = 2},
  [1269] = {.lex_state = 128, .external_lex_state = 8},
  [1270] = {.lex_state = 192, .external_lex_state = 2},
  [1271] = {.lex_state = 192, .external_lex_state = 2},
  [1272] = {.lex_state = 192, .external_lex_state = 2},
  [1273] = {.lex_state = 192, .external_lex_state = 2},
  [1274] = {.lex_state = 192, .external_lex_state = 2},
  [1275] = {.lex_state = 192, .external_lex_state = 2},
  [1276] = {.lex_state = 192, .external_lex_state = 2},
  [1277] = {.lex_state = 192, .external_lex_state = 2},
  [1278] = {.lex_state = 192, .external_lex_state = 2},
  [1279] = {.lex_state = 192, .external_lex_state = 2},
  [1280] = {.lex_state = 192, .external_lex_state = 2},
  [1281] = {.lex_state = 192, .external_lex_state = 2},
  [1282] = {.lex_state = 192, .external_lex_state = 2},
  [1283] = {.lex_state = 192, .external_lex_state = 2},
  [1284] = {.lex_state = 192, .external_lex_state = 2},
  [1285] = {.lex_state = 192, .external_lex_state = 2},
  [1286] = {.lex_state = 192, .external_lex_state = 2},
  [1287] = {.lex_state = 192, .external_lex_state = 2},
  [1288] = {.lex_state = 192, .external_lex_state = 2},
  [1289] = {.lex_state = 192, .external_lex_state = 2},
  [1290] = {.lex_state = 237},
  [1291] = {.lex_state = 192, .external_lex_state = 2},
  [1292] = {.lex_state = 364, .external_lex_state = 11},
  [1293] = {.lex_state = 364, .external_lex_state = 11},
  [1294] = {.lex_state = 364, .external_lex_state = 11},
  [1295] = {.lex_state = 364, .external_lex_state = 11},
  [1296] = {.lex_state = 192, .external_lex_state = 2},
  [1297] = {.lex_state = 192, .external_lex_state = 2},
  [1298] = {.lex_state = 192, .external_lex_state = 2},
  [1299] = {.lex_state = 358, .external_lex_state = 11},
  [1300] = {.lex_state = 421, .external_lex_state = 3},
  [1301] = {.lex_state = 364, .external_lex_state = 11},
  [1302] = {.lex_state = 424, .external_lex_state = 3},
  [1303] = {.lex_state = 424, .external_lex_state = 3},
  [1304] = {.lex_state = 213},
  [1305] = {.lex_state = 421, .external_lex_state = 3},
  [1306] = {.lex_state = 427, .external_lex_state = 14},
  [1307] = {.lex_state = 192, .external_lex_state = 29},
  [1308] = {.lex_state = 192, .external_lex_state = 2},
  [1309] = {.lex_state = 262, .external_lex_state = 14},
  [1310] = {.lex_state = 156, .external_lex_state = 3},
  [1311] = {.lex_state = 225, .external_lex_state = 7},
  [1312] = {.lex_state = 384, .external_lex_state = 8},
  [1313] = {.lex_state = 225, .external_lex_state = 7},
  [1314] = {.lex_state = 192, .external_lex_state = 15},
  [1315] = {.lex_state = 225, .external_lex_state = 7},
  [1316] = {.lex_state = 211, .external_lex_state = 8},
  [1317] = {.lex_state = 530, .external_lex_state = 27},
  [1318] = {.lex_state = 192, .external_lex_state = 15},
  [1319] = {.lex_state = 388, .external_lex_state = 25},
  [1320] = {.lex_state = 192, .external_lex_state = 15},
  [1321] = {.lex_state = 388, .external_lex_state = 25},
  [1322] = {.lex_state = 192, .external_lex_state = 15},
  [1323] = {.lex_state = 388, .external_lex_state = 25},
  [1324] = {.lex_state = 192, .external_lex_state = 15},
  [1325] = {.lex_state = 388, .external_lex_state = 25},
  [1326] = {.lex_state = 190, .external_lex_state = 4},
  [1327] = {.lex_state = 266, .external_lex_state = 15},
  [1328] = {.lex_state = 388, .external_lex_state = 25},
  [1329] = {.lex_state = 190, .external_lex_state = 4},
  [1330] = {.lex_state = 266, .external_lex_state = 15},
  [1331] = {.lex_state = 192, .external_lex_state = 2},
  [1332] = {.lex_state = 531, .external_lex_state = 26},
  [1333] = {.lex_state = 531, .external_lex_state = 26},
  [1334] = {.lex_state = 531, .external_lex_state = 26},
  [1335] = {.lex_state = 531, .external_lex_state = 26},
  [1336] = {.lex_state = 192, .external_lex_state = 2},
  [1337] = {.lex_state = 192, .external_lex_state = 2},
  [1338] = {.lex_state = 192, .external_lex_state = 2},
  [1339] = {.lex_state = 400, .external_lex_state = 25},
  [1340] = {.lex_state = 534, .external_lex_state = 26},
  [1341] = {.lex_state = 213},
  [1342] = {.lex_state = 537, .external_lex_state = 25},
  [1343] = {.lex_state = 540, .external_lex_state = 27},
  [1344] = {.lex_state = 400, .external_lex_state = 25},
  [1345] = {.lex_state = 400, .external_lex_state = 25},
  [1346] = {.lex_state = 543, .external_lex_state = 27},
  [1347] = {.lex_state = 192, .external_lex_state = 2},
  [1348] = {.lex_state = 388, .external_lex_state = 25},
  [1349] = {.lex_state = 194},
  [1350] = {.lex_state = 194, .external_lex_state = 19},
  [1351] = {.lex_state = 192, .external_lex_state = 2},
  [1352] = {.lex_state = 388, .external_lex_state = 25},
  [1353] = {.lex_state = 310},
  [1354] = {.lex_state = 310, .external_lex_state = 8},
  [1355] = {.lex_state = 388, .external_lex_state = 25},
  [1356] = {.lex_state = 209},
  [1357] = {.lex_state = 544, .external_lex_state = 26},
  [1358] = {.lex_state = 400, .external_lex_state = 25},
  [1359] = {.lex_state = 192, .external_lex_state = 2},
  [1360] = {.lex_state = 346, .external_lex_state = 23},
  [1361] = {.lex_state = 346, .external_lex_state = 23},
  [1362] = {.lex_state = 350, .external_lex_state = 23},
  [1363] = {.lex_state = 350, .external_lex_state = 23},
  [1364] = {.lex_state = 192, .external_lex_state = 2},
  [1365] = {.lex_state = 192, .external_lex_state = 2},
  [1366] = {.lex_state = 192, .external_lex_state = 2},
  [1367] = {.lex_state = 237},
  [1368] = {.lex_state = 192, .external_lex_state = 2},
  [1369] = {.lex_state = 192, .external_lex_state = 2},
  [1370] = {.lex_state = 192, .external_lex_state = 2},
  [1371] = {.lex_state = 192, .external_lex_state = 2},
  [1372] = {.lex_state = 394, .external_lex_state = 26},
  [1373] = {.lex_state = 406, .external_lex_state = 25},
  [1374] = {.lex_state = 388, .external_lex_state = 25},
  [1375] = {.lex_state = 406, .external_lex_state = 25},
  [1376] = {.lex_state = 406, .external_lex_state = 25},
  [1377] = {.lex_state = 213},
  [1378] = {.lex_state = 403, .external_lex_state = 25},
  [1379] = {.lex_state = 406, .external_lex_state = 27},
  [1380] = {.lex_state = 388, .external_lex_state = 25},
  [1381] = {.lex_state = 388, .external_lex_state = 25},
  [1382] = {.lex_state = 388, .external_lex_state = 25},
  [1383] = {.lex_state = 128, .external_lex_state = 8},
  [1384] = {.lex_state = 128, .external_lex_state = 8},
  [1385] = {.lex_state = 247, .external_lex_state = 3},
  [1386] = {.lex_state = 247, .external_lex_state = 3},
  [1387] = {.lex_state = 128},
  [1388] = {.lex_state = 247, .external_lex_state = 3},
  [1389] = {.lex_state = 128},
  [1390] = {.lex_state = 128},
  [1391] = {.lex_state = 128},
  [1392] = {.lex_state = 128},
  [1393] = {.lex_state = 128},
  [1394] = {.lex_state = 388, .external_lex_state = 25},
  [1395] = {.lex_state = 128, .external_lex_state = 2},
  [1396] = {.lex_state = 400, .external_lex_state = 25},
  [1397] = {.lex_state = 400, .external_lex_state = 25},
  [1398] = {.lex_state = 547, .external_lex_state = 25},
  [1399] = {.lex_state = 388, .external_lex_state = 25},
  [1400] = {.lex_state = 388, .external_lex_state = 25},
  [1401] = {.lex_state = 235, .external_lex_state = 19},
  [1402] = {.lex_state = 235},
  [1403] = {.lex_state = 409, .external_lex_state = 2},
  [1404] = {.lex_state = 414, .external_lex_state = 12},
  [1405] = {.lex_state = 128},
  [1406] = {.lex_state = 388, .external_lex_state = 25},
  [1407] = {.lex_state = 192, .external_lex_state = 2},
  [1408] = {.lex_state = 192, .external_lex_state = 2},
  [1409] = {.lex_state = 192, .external_lex_state = 2},
  [1410] = {.lex_state = 192, .external_lex_state = 2},
  [1411] = {.lex_state = 192, .external_lex_state = 2},
  [1412] = {.lex_state = 192, .external_lex_state = 2},
  [1413] = {.lex_state = 192, .external_lex_state = 2},
  [1414] = {.lex_state = 192, .external_lex_state = 2},
  [1415] = {.lex_state = 192, .external_lex_state = 2},
  [1416] = {.lex_state = 192, .external_lex_state = 2},
  [1417] = {.lex_state = 192, .external_lex_state = 2},
  [1418] = {.lex_state = 192, .external_lex_state = 2},
  [1419] = {.lex_state = 192, .external_lex_state = 2},
  [1420] = {.lex_state = 416, .external_lex_state = 28},
  [1421] = {.lex_state = 235, .external_lex_state = 13},
  [1422] = {.lex_state = 197},
  [1423] = {.lex_state = 192, .external_lex_state = 2},
  [1424] = {.lex_state = 192, .external_lex_state = 2},
  [1425] = {.lex_state = 192, .external_lex_state = 2},
  [1426] = {.lex_state = 237},
  [1427] = {.lex_state = 419, .external_lex_state = 6},
  [1428] = {.lex_state = 192, .external_lex_state = 2},
  [1429] = {.lex_state = 402, .external_lex_state = 26},
  [1430] = {.lex_state = 402, .external_lex_state = 26},
  [1431] = {.lex_state = 402, .external_lex_state = 26},
  [1432] = {.lex_state = 402, .external_lex_state = 26},
  [1433] = {.lex_state = 414, .external_lex_state = 12},
  [1434] = {.lex_state = 192, .external_lex_state = 2},
  [1435] = {.lex_state = 192, .external_lex_state = 2},
  [1436] = {.lex_state = 192, .external_lex_state = 2},
  [1437] = {.lex_state = 394, .external_lex_state = 26},
  [1438] = {.lex_state = 403, .external_lex_state = 25},
  [1439] = {.lex_state = 402, .external_lex_state = 26},
  [1440] = {.lex_state = 397, .external_lex_state = 25},
  [1441] = {.lex_state = 403, .external_lex_state = 25},
  [1442] = {.lex_state = 403, .external_lex_state = 25},
  [1443] = {.lex_state = 397, .external_lex_state = 25},
  [1444] = {.lex_state = 213},
  [1445] = {.lex_state = 403, .external_lex_state = 25},
  [1446] = {.lex_state = 403, .external_lex_state = 27},
  [1447] = {.lex_state = 156, .external_lex_state = 3},
  [1448] = {.lex_state = 235},
  [1449] = {.lex_state = 235, .external_lex_state = 13},
  [1450] = {.lex_state = 192, .external_lex_state = 29},
  [1451] = {.lex_state = 192, .external_lex_state = 2},
  [1452] = {.lex_state = 543, .external_lex_state = 27},
  [1453] = {.lex_state = 156, .external_lex_state = 3},
  [1454] = {.lex_state = 237},
  [1455] = {.lex_state = 194},
  [1456] = {.lex_state = 286, .external_lex_state = 2},
  [1457] = {.lex_state = 197},
  [1458] = {.lex_state = 128},
  [1459] = {.lex_state = 411},
  [1460] = {.lex_state = 302},
  [1461] = {.lex_state = 337},
  [1462] = {.lex_state = 337},
  [1463] = {.lex_state = 337},
  [1464] = {.lex_state = 237},
  [1465] = {.lex_state = 156, .external_lex_state = 3},
  [1466] = {.lex_state = 128},
  [1467] = {.lex_state = 128, .external_lex_state = 12},
  [1468] = {.lex_state = 414, .external_lex_state = 2},
  [1469] = {.lex_state = 549, .external_lex_state = 2},
  [1470] = {.lex_state = 192, .external_lex_state = 2},
  [1471] = {.lex_state = 156, .external_lex_state = 3},
  [1472] = {.lex_state = 197},
  [1473] = {.lex_state = 156},
  [1474] = {.lex_state = 269},
  [1475] = {.lex_state = 211, .external_lex_state = 8},
  [1476] = {.lex_state = 128, .external_lex_state = 2},
  [1477] = {.lex_state = 245, .external_lex_state = 8},
  [1478] = {.lex_state = 247, .external_lex_state = 3},
  [1479] = {.lex_state = 247, .external_lex_state = 3},
  [1480] = {.lex_state = 247, .external_lex_state = 3},
  [1481] = {.lex_state = 247, .external_lex_state = 3},
  [1482] = {.lex_state = 247, .external_lex_state = 3},
  [1483] = {.lex_state = 247, .external_lex_state = 3},
  [1484] = {.lex_state = 247, .external_lex_state = 3},
  [1485] = {.lex_state = 247, .external_lex_state = 3},
  [1486] = {.lex_state = 247, .external_lex_state = 3},
  [1487] = {.lex_state = 247, .external_lex_state = 3},
  [1488] = {.lex_state = 247, .external_lex_state = 3},
  [1489] = {.lex_state = 177, .external_lex_state = 4},
  [1490] = {.lex_state = 192, .external_lex_state = 2},
  [1491] = {.lex_state = 551, .external_lex_state = 18},
  [1492] = {.lex_state = 551, .external_lex_state = 18},
  [1493] = {.lex_state = 551, .external_lex_state = 18},
  [1494] = {.lex_state = 551, .external_lex_state = 18},
  [1495] = {.lex_state = 192, .external_lex_state = 2},
  [1496] = {.lex_state = 192, .external_lex_state = 2},
  [1497] = {.lex_state = 192, .external_lex_state = 2},
  [1498] = {.lex_state = 554, .external_lex_state = 16},
  [1499] = {.lex_state = 556, .external_lex_state = 18},
  [1500] = {.lex_state = 213},
  [1501] = {.lex_state = 559, .external_lex_state = 16},
  [1502] = {.lex_state = 562, .external_lex_state = 20},
  [1503] = {.lex_state = 247, .external_lex_state = 3},
  [1504] = {.lex_state = 247, .external_lex_state = 3},
  [1505] = {.lex_state = 247, .external_lex_state = 3},
  [1506] = {.lex_state = 247, .external_lex_state = 3},
  [1507] = {.lex_state = 247, .external_lex_state = 3},
  [1508] = {.lex_state = 177, .external_lex_state = 17},
  [1509] = {.lex_state = 327, .external_lex_state = 11},
  [1510] = {.lex_state = 356, .external_lex_state = 13},
  [1511] = {.lex_state = 327, .external_lex_state = 11},
  [1512] = {.lex_state = 327, .external_lex_state = 11},
  [1513] = {.lex_state = 416, .external_lex_state = 28},
  [1514] = {.lex_state = 227, .external_lex_state = 3},
  [1515] = {.lex_state = 235, .external_lex_state = 19},
  [1516] = {.lex_state = 235},
  [1517] = {.lex_state = 327, .external_lex_state = 11},
  [1518] = {.lex_state = 565, .external_lex_state = 14},
  [1519] = {.lex_state = 192, .external_lex_state = 15},
  [1520] = {.lex_state = 299, .external_lex_state = 3},
  [1521] = {.lex_state = 192, .external_lex_state = 15},
  [1522] = {.lex_state = 299, .external_lex_state = 3},
  [1523] = {.lex_state = 192, .external_lex_state = 15},
  [1524] = {.lex_state = 299, .external_lex_state = 3},
  [1525] = {.lex_state = 192, .external_lex_state = 15},
  [1526] = {.lex_state = 299, .external_lex_state = 3},
  [1527] = {.lex_state = 190, .external_lex_state = 4},
  [1528] = {.lex_state = 266, .external_lex_state = 15},
  [1529] = {.lex_state = 299, .external_lex_state = 3},
  [1530] = {.lex_state = 190, .external_lex_state = 4},
  [1531] = {.lex_state = 266, .external_lex_state = 15},
  [1532] = {.lex_state = 227, .external_lex_state = 3},
  [1533] = {.lex_state = 177, .external_lex_state = 4},
  [1534] = {.lex_state = 177, .external_lex_state = 4},
  [1535] = {.lex_state = 177, .external_lex_state = 4},
  [1536] = {.lex_state = 177, .external_lex_state = 4},
  [1537] = {.lex_state = 190, .external_lex_state = 4},
  [1538] = {.lex_state = 190, .external_lex_state = 4},
  [1539] = {.lex_state = 192, .external_lex_state = 2},
  [1540] = {.lex_state = 194, .external_lex_state = 6},
  [1541] = {.lex_state = 197, .external_lex_state = 7},
  [1542] = {.lex_state = 209, .external_lex_state = 2},
  [1543] = {.lex_state = 216, .external_lex_state = 10},
  [1544] = {.lex_state = 216, .external_lex_state = 9},
  [1545] = {.lex_state = 254, .external_lex_state = 11},
  [1546] = {.lex_state = 254, .external_lex_state = 11},
  [1547] = {.lex_state = 254, .external_lex_state = 11},
  [1548] = {.lex_state = 254, .external_lex_state = 11},
  [1549] = {.lex_state = 221, .external_lex_state = 2},
  [1550] = {.lex_state = 221, .external_lex_state = 2},
  [1551] = {.lex_state = 192, .external_lex_state = 2},
  [1552] = {.lex_state = 192, .external_lex_state = 2},
  [1553] = {.lex_state = 223, .external_lex_state = 9},
  [1554] = {.lex_state = 221, .external_lex_state = 12},
  [1555] = {.lex_state = 128, .external_lex_state = 12},
  [1556] = {.lex_state = 192, .external_lex_state = 2},
  [1557] = {.lex_state = 192, .external_lex_state = 2},
  [1558] = {.lex_state = 192, .external_lex_state = 2},
  [1559] = {.lex_state = 227, .external_lex_state = 3},
  [1560] = {.lex_state = 235, .external_lex_state = 13},
  [1561] = {.lex_state = 237},
  [1562] = {.lex_state = 424, .external_lex_state = 3},
  [1563] = {.lex_state = 227, .external_lex_state = 3},
  [1564] = {.lex_state = 254, .external_lex_state = 11},
  [1565] = {.lex_state = 213},
  [1566] = {.lex_state = 424, .external_lex_state = 3},
  [1567] = {.lex_state = 424, .external_lex_state = 14},
  [1568] = {.lex_state = 424, .external_lex_state = 3},
  [1569] = {.lex_state = 194, .external_lex_state = 6},
  [1570] = {.lex_state = 421, .external_lex_state = 3},
  [1571] = {.lex_state = 421, .external_lex_state = 14},
  [1572] = {.lex_state = 192, .external_lex_state = 2},
  [1573] = {.lex_state = 192, .external_lex_state = 2},
  [1574] = {.lex_state = 299, .external_lex_state = 3},
  [1575] = {.lex_state = 566, .external_lex_state = 11},
  [1576] = {.lex_state = 566, .external_lex_state = 11},
  [1577] = {.lex_state = 566, .external_lex_state = 11},
  [1578] = {.lex_state = 566, .external_lex_state = 11},
  [1579] = {.lex_state = 192, .external_lex_state = 2},
  [1580] = {.lex_state = 192, .external_lex_state = 2},
  [1581] = {.lex_state = 192, .external_lex_state = 2},
  [1582] = {.lex_state = 569, .external_lex_state = 11},
  [1583] = {.lex_state = 194},
  [1584] = {.lex_state = 286, .external_lex_state = 2},
  [1585] = {.lex_state = 436, .external_lex_state = 3},
  [1586] = {.lex_state = 572, .external_lex_state = 11},
  [1587] = {.lex_state = 213},
  [1588] = {.lex_state = 573, .external_lex_state = 3},
  [1589] = {.lex_state = 576, .external_lex_state = 14},
  [1590] = {.lex_state = 194},
  [1591] = {.lex_state = 194, .external_lex_state = 19},
  [1592] = {.lex_state = 192, .external_lex_state = 2},
  [1593] = {.lex_state = 299, .external_lex_state = 3},
  [1594] = {.lex_state = 310},
  [1595] = {.lex_state = 310, .external_lex_state = 8},
  [1596] = {.lex_state = 299, .external_lex_state = 3},
  [1597] = {.lex_state = 209},
  [1598] = {.lex_state = 424, .external_lex_state = 3},
  [1599] = {.lex_state = 192, .external_lex_state = 2},
  [1600] = {.lex_state = 346, .external_lex_state = 23},
  [1601] = {.lex_state = 346, .external_lex_state = 23},
  [1602] = {.lex_state = 350, .external_lex_state = 23},
  [1603] = {.lex_state = 350, .external_lex_state = 23},
  [1604] = {.lex_state = 299, .external_lex_state = 3},
  [1605] = {.lex_state = 299, .external_lex_state = 3},
  [1606] = {.lex_state = 299, .external_lex_state = 3},
  [1607] = {.lex_state = 299, .external_lex_state = 3},
  [1608] = {.lex_state = 128, .external_lex_state = 8},
  [1609] = {.lex_state = 128, .external_lex_state = 8},
  [1610] = {.lex_state = 247, .external_lex_state = 3},
  [1611] = {.lex_state = 247, .external_lex_state = 3},
  [1612] = {.lex_state = 128},
  [1613] = {.lex_state = 227, .external_lex_state = 3},
  [1614] = {.lex_state = 128},
  [1615] = {.lex_state = 128, .external_lex_state = 12},
  [1616] = {.lex_state = 414, .external_lex_state = 2},
  [1617] = {.lex_state = 247, .external_lex_state = 3},
  [1618] = {.lex_state = 128},
  [1619] = {.lex_state = 128},
  [1620] = {.lex_state = 128},
  [1621] = {.lex_state = 128},
  [1622] = {.lex_state = 128},
  [1623] = {.lex_state = 299, .external_lex_state = 3},
  [1624] = {.lex_state = 128, .external_lex_state = 2},
  [1625] = {.lex_state = 227, .external_lex_state = 3},
  [1626] = {.lex_state = 209, .external_lex_state = 19},
  [1627] = {.lex_state = 209},
  [1628] = {.lex_state = 421, .external_lex_state = 3},
  [1629] = {.lex_state = 421, .external_lex_state = 3},
  [1630] = {.lex_state = 299, .external_lex_state = 3},
  [1631] = {.lex_state = 299, .external_lex_state = 3},
  [1632] = {.lex_state = 299, .external_lex_state = 3},
  [1633] = {.lex_state = 235, .external_lex_state = 19},
  [1634] = {.lex_state = 235},
  [1635] = {.lex_state = 409, .external_lex_state = 2},
  [1636] = {.lex_state = 128},
  [1637] = {.lex_state = 299, .external_lex_state = 3},
  [1638] = {.lex_state = 192, .external_lex_state = 2},
  [1639] = {.lex_state = 192, .external_lex_state = 2},
  [1640] = {.lex_state = 192, .external_lex_state = 2},
  [1641] = {.lex_state = 192, .external_lex_state = 2},
  [1642] = {.lex_state = 192, .external_lex_state = 2},
  [1643] = {.lex_state = 192, .external_lex_state = 2},
  [1644] = {.lex_state = 192, .external_lex_state = 2},
  [1645] = {.lex_state = 192, .external_lex_state = 2},
  [1646] = {.lex_state = 192, .external_lex_state = 2},
  [1647] = {.lex_state = 192, .external_lex_state = 2},
  [1648] = {.lex_state = 192, .external_lex_state = 2},
  [1649] = {.lex_state = 192, .external_lex_state = 2},
  [1650] = {.lex_state = 192, .external_lex_state = 2},
  [1651] = {.lex_state = 419, .external_lex_state = 6},
  [1652] = {.lex_state = 299, .external_lex_state = 3},
  [1653] = {.lex_state = 409, .external_lex_state = 2},
  [1654] = {.lex_state = 227, .external_lex_state = 3},
  [1655] = {.lex_state = 177, .external_lex_state = 17},
  [1656] = {.lex_state = 424, .external_lex_state = 3},
  [1657] = {.lex_state = 524, .external_lex_state = 13},
  [1658] = {.lex_state = 424, .external_lex_state = 3},
  [1659] = {.lex_state = 192, .external_lex_state = 29},
  [1660] = {.lex_state = 192, .external_lex_state = 2},
  [1661] = {.lex_state = 421, .external_lex_state = 14},
  [1662] = {.lex_state = 192, .external_lex_state = 2},
  [1663] = {.lex_state = 192, .external_lex_state = 2},
  [1664] = {.lex_state = 192, .external_lex_state = 2},
  [1665] = {.lex_state = 192, .external_lex_state = 2},
  [1666] = {.lex_state = 192, .external_lex_state = 2},
  [1667] = {.lex_state = 577, .external_lex_state = 3},
  [1668] = {.lex_state = 380, .external_lex_state = 3},
  [1669] = {.lex_state = 577, .external_lex_state = 3},
  [1670] = {.lex_state = 213},
  [1671] = {.lex_state = 259, .external_lex_state = 3},
  [1672] = {.lex_state = 313},
  [1673] = {.lex_state = 247, .external_lex_state = 3},
  [1674] = {.lex_state = 262, .external_lex_state = 14},
  [1675] = {.lex_state = 436, .external_lex_state = 16},
  [1676] = {.lex_state = 579, .external_lex_state = 18},
  [1677] = {.lex_state = 192, .external_lex_state = 2},
  [1678] = {.lex_state = 192, .external_lex_state = 2},
  [1679] = {.lex_state = 192, .external_lex_state = 2},
  [1680] = {.lex_state = 237},
  [1681] = {.lex_state = 192, .external_lex_state = 2},
  [1682] = {.lex_state = 582, .external_lex_state = 26},
  [1683] = {.lex_state = 582, .external_lex_state = 26},
  [1684] = {.lex_state = 582, .external_lex_state = 26},
  [1685] = {.lex_state = 582, .external_lex_state = 26},
  [1686] = {.lex_state = 192, .external_lex_state = 2},
  [1687] = {.lex_state = 192, .external_lex_state = 2},
  [1688] = {.lex_state = 192, .external_lex_state = 2},
  [1689] = {.lex_state = 585, .external_lex_state = 26},
  [1690] = {.lex_state = 588, .external_lex_state = 25},
  [1691] = {.lex_state = 591, .external_lex_state = 26},
  [1692] = {.lex_state = 444, .external_lex_state = 25},
  [1693] = {.lex_state = 467, .external_lex_state = 25},
  [1694] = {.lex_state = 213},
  [1695] = {.lex_state = 573, .external_lex_state = 25},
  [1696] = {.lex_state = 588, .external_lex_state = 27},
  [1697] = {.lex_state = 436, .external_lex_state = 16},
  [1698] = {.lex_state = 436, .external_lex_state = 16},
  [1699] = {.lex_state = 237},
  [1700] = {.lex_state = 237},
  [1701] = {.lex_state = 237},
  [1702] = {.lex_state = 225, .external_lex_state = 7},
  [1703] = {.lex_state = 177, .external_lex_state = 4},
  [1704] = {.lex_state = 192, .external_lex_state = 2},
  [1705] = {.lex_state = 192, .external_lex_state = 2},
  [1706] = {.lex_state = 192, .external_lex_state = 2},
  [1707] = {.lex_state = 192, .external_lex_state = 2},
  [1708] = {.lex_state = 192, .external_lex_state = 2},
  [1709] = {.lex_state = 192, .external_lex_state = 2},
  [1710] = {.lex_state = 192, .external_lex_state = 2},
  [1711] = {.lex_state = 192, .external_lex_state = 2},
  [1712] = {.lex_state = 192, .external_lex_state = 2},
  [1713] = {.lex_state = 192, .external_lex_state = 2},
  [1714] = {.lex_state = 192, .external_lex_state = 2},
  [1715] = {.lex_state = 192, .external_lex_state = 2},
  [1716] = {.lex_state = 192, .external_lex_state = 2},
  [1717] = {.lex_state = 192, .external_lex_state = 2},
  [1718] = {.lex_state = 192, .external_lex_state = 2},
  [1719] = {.lex_state = 192, .external_lex_state = 2},
  [1720] = {.lex_state = 192, .external_lex_state = 2},
  [1721] = {.lex_state = 416, .external_lex_state = 28},
  [1722] = {.lex_state = 235, .external_lex_state = 13},
  [1723] = {.lex_state = 197},
  [1724] = {.lex_state = 192, .external_lex_state = 2},
  [1725] = {.lex_state = 192, .external_lex_state = 2},
  [1726] = {.lex_state = 192, .external_lex_state = 2},
  [1727] = {.lex_state = 237},
  [1728] = {.lex_state = 419, .external_lex_state = 6},
  [1729] = {.lex_state = 192, .external_lex_state = 2},
  [1730] = {.lex_state = 591, .external_lex_state = 26},
  [1731] = {.lex_state = 591, .external_lex_state = 26},
  [1732] = {.lex_state = 591, .external_lex_state = 26},
  [1733] = {.lex_state = 591, .external_lex_state = 26},
  [1734] = {.lex_state = 414, .external_lex_state = 12},
  [1735] = {.lex_state = 356, .external_lex_state = 13},
  [1736] = {.lex_state = 192, .external_lex_state = 2},
  [1737] = {.lex_state = 192, .external_lex_state = 2},
  [1738] = {.lex_state = 192, .external_lex_state = 2},
  [1739] = {.lex_state = 585, .external_lex_state = 26},
  [1740] = {.lex_state = 573, .external_lex_state = 25},
  [1741] = {.lex_state = 591, .external_lex_state = 26},
  [1742] = {.lex_state = 433, .external_lex_state = 16},
  [1743] = {.lex_state = 441, .external_lex_state = 25},
  [1744] = {.lex_state = 441, .external_lex_state = 25},
  [1745] = {.lex_state = 433, .external_lex_state = 16},
  [1746] = {.lex_state = 213},
  [1747] = {.lex_state = 573, .external_lex_state = 25},
  [1748] = {.lex_state = 573, .external_lex_state = 27},
  [1749] = {.lex_state = 192, .external_lex_state = 29},
  [1750] = {.lex_state = 192, .external_lex_state = 2},
  [1751] = {.lex_state = 444, .external_lex_state = 20},
  [1752] = {.lex_state = 190, .external_lex_state = 4},
  [1753] = {.lex_state = 156, .external_lex_state = 3},
  [1754] = {.lex_state = 156, .external_lex_state = 3},
  [1755] = {.lex_state = 177, .external_lex_state = 4},
  [1756] = {.lex_state = 266, .external_lex_state = 15},
  [1757] = {.lex_state = 156, .external_lex_state = 3},
  [1758] = {.lex_state = 266, .external_lex_state = 15},
  [1759] = {.lex_state = 177, .external_lex_state = 4},
  [1760] = {.lex_state = 266, .external_lex_state = 15},
  [1761] = {.lex_state = 156, .external_lex_state = 3},
  [1762] = {.lex_state = 156, .external_lex_state = 3},
  [1763] = {.lex_state = 177, .external_lex_state = 4},
  [1764] = {.lex_state = 266, .external_lex_state = 15},
  [1765] = {.lex_state = 156, .external_lex_state = 3},
  [1766] = {.lex_state = 266, .external_lex_state = 15},
  [1767] = {.lex_state = 177, .external_lex_state = 4},
  [1768] = {.lex_state = 266, .external_lex_state = 15},
  [1769] = {.lex_state = 436, .external_lex_state = 3},
  [1770] = {.lex_state = 192, .external_lex_state = 2},
  [1771] = {.lex_state = 192, .external_lex_state = 2},
  [1772] = {.lex_state = 192, .external_lex_state = 2},
  [1773] = {.lex_state = 237},
  [1774] = {.lex_state = 192, .external_lex_state = 2},
  [1775] = {.lex_state = 592, .external_lex_state = 11},
  [1776] = {.lex_state = 592, .external_lex_state = 11},
  [1777] = {.lex_state = 592, .external_lex_state = 11},
  [1778] = {.lex_state = 592, .external_lex_state = 11},
  [1779] = {.lex_state = 192, .external_lex_state = 2},
  [1780] = {.lex_state = 192, .external_lex_state = 2},
  [1781] = {.lex_state = 192, .external_lex_state = 2},
  [1782] = {.lex_state = 569, .external_lex_state = 11},
  [1783] = {.lex_state = 588, .external_lex_state = 3},
  [1784] = {.lex_state = 444, .external_lex_state = 3},
  [1785] = {.lex_state = 467, .external_lex_state = 3},
  [1786] = {.lex_state = 213},
  [1787] = {.lex_state = 573, .external_lex_state = 3},
  [1788] = {.lex_state = 588, .external_lex_state = 14},
  [1789] = {.lex_state = 436, .external_lex_state = 3},
  [1790] = {.lex_state = 436, .external_lex_state = 3},
  [1791] = {.lex_state = 237, .external_lex_state = 8},
  [1792] = {.lex_state = 211, .external_lex_state = 8},
  [1793] = {.lex_state = 286, .external_lex_state = 2},
  [1794] = {.lex_state = 237, .external_lex_state = 8},
  [1795] = {.lex_state = 192, .external_lex_state = 2},
  [1796] = {.lex_state = 192, .external_lex_state = 2},
  [1797] = {.lex_state = 192, .external_lex_state = 2},
  [1798] = {.lex_state = 192, .external_lex_state = 2},
  [1799] = {.lex_state = 192, .external_lex_state = 2},
  [1800] = {.lex_state = 192, .external_lex_state = 2},
  [1801] = {.lex_state = 192, .external_lex_state = 2},
  [1802] = {.lex_state = 192, .external_lex_state = 2},
  [1803] = {.lex_state = 192, .external_lex_state = 2},
  [1804] = {.lex_state = 192, .external_lex_state = 2},
  [1805] = {.lex_state = 192, .external_lex_state = 2},
  [1806] = {.lex_state = 192, .external_lex_state = 2},
  [1807] = {.lex_state = 192, .external_lex_state = 2},
  [1808] = {.lex_state = 192, .external_lex_state = 2},
  [1809] = {.lex_state = 192, .external_lex_state = 2},
  [1810] = {.lex_state = 192, .external_lex_state = 2},
  [1811] = {.lex_state = 192, .external_lex_state = 2},
  [1812] = {.lex_state = 192, .external_lex_state = 2},
  [1813] = {.lex_state = 192, .external_lex_state = 2},
  [1814] = {.lex_state = 192, .external_lex_state = 2},
  [1815] = {.lex_state = 237},
  [1816] = {.lex_state = 192, .external_lex_state = 2},
  [1817] = {.lex_state = 572, .external_lex_state = 11},
  [1818] = {.lex_state = 572, .external_lex_state = 11},
  [1819] = {.lex_state = 572, .external_lex_state = 11},
  [1820] = {.lex_state = 572, .external_lex_state = 11},
  [1821] = {.lex_state = 192, .external_lex_state = 2},
  [1822] = {.lex_state = 192, .external_lex_state = 2},
  [1823] = {.lex_state = 192, .external_lex_state = 2},
  [1824] = {.lex_state = 569, .external_lex_state = 11},
  [1825] = {.lex_state = 573, .external_lex_state = 3},
  [1826] = {.lex_state = 572, .external_lex_state = 11},
  [1827] = {.lex_state = 441, .external_lex_state = 3},
  [1828] = {.lex_state = 441, .external_lex_state = 3},
  [1829] = {.lex_state = 213},
  [1830] = {.lex_state = 573, .external_lex_state = 3},
  [1831] = {.lex_state = 573, .external_lex_state = 14},
  [1832] = {.lex_state = 192, .external_lex_state = 29},
  [1833] = {.lex_state = 192, .external_lex_state = 2},
  [1834] = {.lex_state = 444, .external_lex_state = 14},
  [1835] = {.lex_state = 265, .external_lex_state = 20},
  [1836] = {.lex_state = 288, .external_lex_state = 16},
  [1837] = {.lex_state = 288, .external_lex_state = 16},
  [1838] = {.lex_state = 288, .external_lex_state = 16},
  [1839] = {.lex_state = 288, .external_lex_state = 16},
  [1840] = {.lex_state = 192, .external_lex_state = 15},
  [1841] = {.lex_state = 266, .external_lex_state = 15},
  [1842] = {.lex_state = 288, .external_lex_state = 16},
  [1843] = {.lex_state = 177, .external_lex_state = 4},
  [1844] = {.lex_state = 266, .external_lex_state = 15},
  [1845] = {.lex_state = 288, .external_lex_state = 16},
  [1846] = {.lex_state = 192, .external_lex_state = 15},
  [1847] = {.lex_state = 266, .external_lex_state = 15},
  [1848] = {.lex_state = 288, .external_lex_state = 16},
  [1849] = {.lex_state = 177, .external_lex_state = 4},
  [1850] = {.lex_state = 266, .external_lex_state = 15},
  [1851] = {.lex_state = 194},
  [1852] = {.lex_state = 453},
  [1853] = {.lex_state = 177, .external_lex_state = 17},
  [1854] = {.lex_state = 436, .external_lex_state = 25},
  [1855] = {.lex_state = 288, .external_lex_state = 16},
  [1856] = {.lex_state = 194},
  [1857] = {.lex_state = 302, .external_lex_state = 16},
  [1858] = {.lex_state = 225, .external_lex_state = 7},
  [1859] = {.lex_state = 128, .external_lex_state = 2},
  [1860] = {.lex_state = 288, .external_lex_state = 16},
  [1861] = {.lex_state = 436, .external_lex_state = 25},
  [1862] = {.lex_state = 595, .external_lex_state = 26},
  [1863] = {.lex_state = 192, .external_lex_state = 2},
  [1864] = {.lex_state = 192, .external_lex_state = 2},
  [1865] = {.lex_state = 192, .external_lex_state = 2},
  [1866] = {.lex_state = 237},
  [1867] = {.lex_state = 192, .external_lex_state = 2},
  [1868] = {.lex_state = 582, .external_lex_state = 26},
  [1869] = {.lex_state = 582, .external_lex_state = 26},
  [1870] = {.lex_state = 582, .external_lex_state = 26},
  [1871] = {.lex_state = 582, .external_lex_state = 26},
  [1872] = {.lex_state = 192, .external_lex_state = 2},
  [1873] = {.lex_state = 192, .external_lex_state = 2},
  [1874] = {.lex_state = 192, .external_lex_state = 2},
  [1875] = {.lex_state = 585, .external_lex_state = 26},
  [1876] = {.lex_state = 588, .external_lex_state = 25},
  [1877] = {.lex_state = 591, .external_lex_state = 26},
  [1878] = {.lex_state = 467, .external_lex_state = 25},
  [1879] = {.lex_state = 467, .external_lex_state = 25},
  [1880] = {.lex_state = 213},
  [1881] = {.lex_state = 573, .external_lex_state = 25},
  [1882] = {.lex_state = 588, .external_lex_state = 27},
  [1883] = {.lex_state = 436, .external_lex_state = 25},
  [1884] = {.lex_state = 436, .external_lex_state = 25},
  [1885] = {.lex_state = 192, .external_lex_state = 2},
  [1886] = {.lex_state = 192, .external_lex_state = 2},
  [1887] = {.lex_state = 192, .external_lex_state = 2},
  [1888] = {.lex_state = 192, .external_lex_state = 2},
  [1889] = {.lex_state = 192, .external_lex_state = 2},
  [1890] = {.lex_state = 192, .external_lex_state = 2},
  [1891] = {.lex_state = 192, .external_lex_state = 2},
  [1892] = {.lex_state = 192, .external_lex_state = 2},
  [1893] = {.lex_state = 192, .external_lex_state = 2},
  [1894] = {.lex_state = 192, .external_lex_state = 2},
  [1895] = {.lex_state = 192, .external_lex_state = 2},
  [1896] = {.lex_state = 192, .external_lex_state = 2},
  [1897] = {.lex_state = 416, .external_lex_state = 28},
  [1898] = {.lex_state = 235, .external_lex_state = 13},
  [1899] = {.lex_state = 197},
  [1900] = {.lex_state = 192, .external_lex_state = 2},
  [1901] = {.lex_state = 192, .external_lex_state = 2},
  [1902] = {.lex_state = 192, .external_lex_state = 2},
  [1903] = {.lex_state = 237},
  [1904] = {.lex_state = 419, .external_lex_state = 6},
  [1905] = {.lex_state = 192, .external_lex_state = 2},
  [1906] = {.lex_state = 591, .external_lex_state = 26},
  [1907] = {.lex_state = 591, .external_lex_state = 26},
  [1908] = {.lex_state = 591, .external_lex_state = 26},
  [1909] = {.lex_state = 591, .external_lex_state = 26},
  [1910] = {.lex_state = 414, .external_lex_state = 12},
  [1911] = {.lex_state = 192, .external_lex_state = 2},
  [1912] = {.lex_state = 192, .external_lex_state = 2},
  [1913] = {.lex_state = 192, .external_lex_state = 2},
  [1914] = {.lex_state = 585, .external_lex_state = 26},
  [1915] = {.lex_state = 573, .external_lex_state = 25},
  [1916] = {.lex_state = 591, .external_lex_state = 26},
  [1917] = {.lex_state = 461, .external_lex_state = 25},
  [1918] = {.lex_state = 441, .external_lex_state = 25},
  [1919] = {.lex_state = 441, .external_lex_state = 25},
  [1920] = {.lex_state = 461, .external_lex_state = 25},
  [1921] = {.lex_state = 213},
  [1922] = {.lex_state = 573, .external_lex_state = 25},
  [1923] = {.lex_state = 573, .external_lex_state = 27},
  [1924] = {.lex_state = 192, .external_lex_state = 29},
  [1925] = {.lex_state = 192, .external_lex_state = 2},
  [1926] = {.lex_state = 467, .external_lex_state = 27},
  [1927] = {.lex_state = 247, .external_lex_state = 3},
  [1928] = {.lex_state = 128, .external_lex_state = 8},
  [1929] = {.lex_state = 128, .external_lex_state = 2},
  [1930] = {.lex_state = 288, .external_lex_state = 16},
  [1931] = {.lex_state = 128, .external_lex_state = 2},
  [1932] = {.lex_state = 361, .external_lex_state = 25},
  [1933] = {.lex_state = 361, .external_lex_state = 27},
  [1934] = {.lex_state = 361, .external_lex_state = 25},
  [1935] = {.lex_state = 361, .external_lex_state = 25},
  [1936] = {.lex_state = 192, .external_lex_state = 2},
  [1937] = {.lex_state = 361, .external_lex_state = 25},
  [1938] = {.lex_state = 361, .external_lex_state = 25},
  [1939] = {.lex_state = 361, .external_lex_state = 25},
  [1940] = {.lex_state = 388, .external_lex_state = 25},
  [1941] = {.lex_state = 209, .external_lex_state = 19},
  [1942] = {.lex_state = 209},
  [1943] = {.lex_state = 361, .external_lex_state = 25},
  [1944] = {.lex_state = 361, .external_lex_state = 25},
  [1945] = {.lex_state = 388, .external_lex_state = 25},
  [1946] = {.lex_state = 192, .external_lex_state = 2},
  [1947] = {.lex_state = 192, .external_lex_state = 2},
  [1948] = {.lex_state = 192, .external_lex_state = 2},
  [1949] = {.lex_state = 192, .external_lex_state = 2},
  [1950] = {.lex_state = 192, .external_lex_state = 2},
  [1951] = {.lex_state = 192, .external_lex_state = 2},
  [1952] = {.lex_state = 192, .external_lex_state = 2},
  [1953] = {.lex_state = 192, .external_lex_state = 2},
  [1954] = {.lex_state = 192, .external_lex_state = 2},
  [1955] = {.lex_state = 192, .external_lex_state = 2},
  [1956] = {.lex_state = 192, .external_lex_state = 2},
  [1957] = {.lex_state = 192, .external_lex_state = 2},
  [1958] = {.lex_state = 192, .external_lex_state = 2},
  [1959] = {.lex_state = 177, .external_lex_state = 17},
  [1960] = {.lex_state = 305, .external_lex_state = 25},
  [1961] = {.lex_state = 524, .external_lex_state = 13},
  [1962] = {.lex_state = 361, .external_lex_state = 25},
  [1963] = {.lex_state = 192, .external_lex_state = 29},
  [1964] = {.lex_state = 192, .external_lex_state = 2},
  [1965] = {.lex_state = 361, .external_lex_state = 27},
  [1966] = {.lex_state = 128, .external_lex_state = 12},
  [1967] = {.lex_state = 128, .external_lex_state = 2},
  [1968] = {.lex_state = 128, .external_lex_state = 2},
  [1969] = {.lex_state = 128, .external_lex_state = 2},
  [1970] = {.lex_state = 128, .external_lex_state = 8},
  [1971] = {.lex_state = 128},
  [1972] = {.lex_state = 128},
  [1973] = {.lex_state = 128},
  [1974] = {.lex_state = 288, .external_lex_state = 16},
  [1975] = {.lex_state = 128},
  [1976] = {.lex_state = 128},
  [1977] = {.lex_state = 128},
  [1978] = {.lex_state = 288, .external_lex_state = 16},
  [1979] = {.lex_state = 288, .external_lex_state = 16},
  [1980] = {.lex_state = 235},
  [1981] = {.lex_state = 288, .external_lex_state = 16},
  [1982] = {.lex_state = 194},
  [1983] = {.lex_state = 286, .external_lex_state = 2},
  [1984] = {.lex_state = 288, .external_lex_state = 16},
  [1985] = {.lex_state = 128},
  [1986] = {.lex_state = 128, .external_lex_state = 12},
  [1987] = {.lex_state = 414, .external_lex_state = 2},
  [1988] = {.lex_state = 288, .external_lex_state = 16},
  [1989] = {.lex_state = 302, .external_lex_state = 16},
  [1990] = {.lex_state = 302, .external_lex_state = 16},
  [1991] = {.lex_state = 302, .external_lex_state = 16},
  [1992] = {.lex_state = 302, .external_lex_state = 16},
  [1993] = {.lex_state = 302, .external_lex_state = 16},
  [1994] = {.lex_state = 302, .external_lex_state = 16},
  [1995] = {.lex_state = 436, .external_lex_state = 25},
  [1996] = {.lex_state = 554, .external_lex_state = 16},
  [1997] = {.lex_state = 302, .external_lex_state = 16},
  [1998] = {.lex_state = 302, .external_lex_state = 16},
  [1999] = {.lex_state = 302, .external_lex_state = 16},
  [2000] = {.lex_state = 302, .external_lex_state = 16},
  [2001] = {.lex_state = 302, .external_lex_state = 16},
  [2002] = {.lex_state = 304, .external_lex_state = 18},
  [2003] = {.lex_state = 356, .external_lex_state = 13},
  [2004] = {.lex_state = 304, .external_lex_state = 18},
  [2005] = {.lex_state = 304, .external_lex_state = 18},
  [2006] = {.lex_state = 416, .external_lex_state = 28},
  [2007] = {.lex_state = 299, .external_lex_state = 16},
  [2008] = {.lex_state = 235, .external_lex_state = 19},
  [2009] = {.lex_state = 235},
  [2010] = {.lex_state = 304, .external_lex_state = 18},
  [2011] = {.lex_state = 598, .external_lex_state = 27},
  [2012] = {.lex_state = 192, .external_lex_state = 15},
  [2013] = {.lex_state = 397, .external_lex_state = 25},
  [2014] = {.lex_state = 192, .external_lex_state = 15},
  [2015] = {.lex_state = 397, .external_lex_state = 25},
  [2016] = {.lex_state = 192, .external_lex_state = 15},
  [2017] = {.lex_state = 397, .external_lex_state = 25},
  [2018] = {.lex_state = 192, .external_lex_state = 15},
  [2019] = {.lex_state = 397, .external_lex_state = 25},
  [2020] = {.lex_state = 190, .external_lex_state = 4},
  [2021] = {.lex_state = 266, .external_lex_state = 15},
  [2022] = {.lex_state = 397, .external_lex_state = 25},
  [2023] = {.lex_state = 190, .external_lex_state = 4},
  [2024] = {.lex_state = 266, .external_lex_state = 15},
  [2025] = {.lex_state = 194, .external_lex_state = 6},
  [2026] = {.lex_state = 421, .external_lex_state = 25},
  [2027] = {.lex_state = 421, .external_lex_state = 27},
  [2028] = {.lex_state = 421, .external_lex_state = 25},
  [2029] = {.lex_state = 421, .external_lex_state = 25},
  [2030] = {.lex_state = 192, .external_lex_state = 2},
  [2031] = {.lex_state = 421, .external_lex_state = 25},
  [2032] = {.lex_state = 194},
  [2033] = {.lex_state = 286, .external_lex_state = 2},
  [2034] = {.lex_state = 194},
  [2035] = {.lex_state = 194, .external_lex_state = 19},
  [2036] = {.lex_state = 192, .external_lex_state = 2},
  [2037] = {.lex_state = 397, .external_lex_state = 25},
  [2038] = {.lex_state = 310},
  [2039] = {.lex_state = 310, .external_lex_state = 8},
  [2040] = {.lex_state = 397, .external_lex_state = 25},
  [2041] = {.lex_state = 209},
  [2042] = {.lex_state = 421, .external_lex_state = 25},
  [2043] = {.lex_state = 192, .external_lex_state = 2},
  [2044] = {.lex_state = 346, .external_lex_state = 23},
  [2045] = {.lex_state = 346, .external_lex_state = 23},
  [2046] = {.lex_state = 350, .external_lex_state = 23},
  [2047] = {.lex_state = 350, .external_lex_state = 23},
  [2048] = {.lex_state = 397, .external_lex_state = 25},
  [2049] = {.lex_state = 397, .external_lex_state = 25},
  [2050] = {.lex_state = 397, .external_lex_state = 25},
  [2051] = {.lex_state = 397, .external_lex_state = 25},
  [2052] = {.lex_state = 128, .external_lex_state = 8},
  [2053] = {.lex_state = 128, .external_lex_state = 8},
  [2054] = {.lex_state = 247, .external_lex_state = 3},
  [2055] = {.lex_state = 247, .external_lex_state = 3},
  [2056] = {.lex_state = 128},
  [2057] = {.lex_state = 299, .external_lex_state = 16},
  [2058] = {.lex_state = 128},
  [2059] = {.lex_state = 128, .external_lex_state = 12},
  [2060] = {.lex_state = 414, .external_lex_state = 2},
  [2061] = {.lex_state = 247, .external_lex_state = 3},
  [2062] = {.lex_state = 128},
  [2063] = {.lex_state = 128},
  [2064] = {.lex_state = 128},
  [2065] = {.lex_state = 128},
  [2066] = {.lex_state = 128},
  [2067] = {.lex_state = 397, .external_lex_state = 25},
  [2068] = {.lex_state = 128, .external_lex_state = 2},
  [2069] = {.lex_state = 397, .external_lex_state = 25},
  [2070] = {.lex_state = 209, .external_lex_state = 19},
  [2071] = {.lex_state = 209},
  [2072] = {.lex_state = 421, .external_lex_state = 25},
  [2073] = {.lex_state = 421, .external_lex_state = 25},
  [2074] = {.lex_state = 397, .external_lex_state = 25},
  [2075] = {.lex_state = 397, .external_lex_state = 25},
  [2076] = {.lex_state = 397, .external_lex_state = 25},
  [2077] = {.lex_state = 235, .external_lex_state = 19},
  [2078] = {.lex_state = 235},
  [2079] = {.lex_state = 409, .external_lex_state = 2},
  [2080] = {.lex_state = 128},
  [2081] = {.lex_state = 397, .external_lex_state = 25},
  [2082] = {.lex_state = 192, .external_lex_state = 2},
  [2083] = {.lex_state = 192, .external_lex_state = 2},
  [2084] = {.lex_state = 192, .external_lex_state = 2},
  [2085] = {.lex_state = 192, .external_lex_state = 2},
  [2086] = {.lex_state = 192, .external_lex_state = 2},
  [2087] = {.lex_state = 192, .external_lex_state = 2},
  [2088] = {.lex_state = 192, .external_lex_state = 2},
  [2089] = {.lex_state = 192, .external_lex_state = 2},
  [2090] = {.lex_state = 192, .external_lex_state = 2},
  [2091] = {.lex_state = 192, .external_lex_state = 2},
  [2092] = {.lex_state = 192, .external_lex_state = 2},
  [2093] = {.lex_state = 192, .external_lex_state = 2},
  [2094] = {.lex_state = 192, .external_lex_state = 2},
  [2095] = {.lex_state = 419, .external_lex_state = 6},
  [2096] = {.lex_state = 397, .external_lex_state = 25},
  [2097] = {.lex_state = 409, .external_lex_state = 2},
  [2098] = {.lex_state = 299, .external_lex_state = 16},
  [2099] = {.lex_state = 177, .external_lex_state = 17},
  [2100] = {.lex_state = 421, .external_lex_state = 25},
  [2101] = {.lex_state = 524, .external_lex_state = 13},
  [2102] = {.lex_state = 421, .external_lex_state = 25},
  [2103] = {.lex_state = 192, .external_lex_state = 29},
  [2104] = {.lex_state = 192, .external_lex_state = 2},
  [2105] = {.lex_state = 421, .external_lex_state = 27},
  [2106] = {.lex_state = 192, .external_lex_state = 2},
  [2107] = {.lex_state = 192, .external_lex_state = 2},
  [2108] = {.lex_state = 470, .external_lex_state = 18},
  [2109] = {.lex_state = 470, .external_lex_state = 18},
  [2110] = {.lex_state = 470, .external_lex_state = 18},
  [2111] = {.lex_state = 470, .external_lex_state = 18},
  [2112] = {.lex_state = 192, .external_lex_state = 2},
  [2113] = {.lex_state = 192, .external_lex_state = 2},
  [2114] = {.lex_state = 192, .external_lex_state = 2},
  [2115] = {.lex_state = 302, .external_lex_state = 16},
  [2116] = {.lex_state = 473, .external_lex_state = 16},
  [2117] = {.lex_state = 302, .external_lex_state = 16},
  [2118] = {.lex_state = 213},
  [2119] = {.lex_state = 299, .external_lex_state = 16},
  [2120] = {.lex_state = 156, .external_lex_state = 20},
  [2121] = {.lex_state = 302, .external_lex_state = 16},
  [2122] = {.lex_state = 455, .external_lex_state = 20},
  [2123] = {.lex_state = 156, .external_lex_state = 3},
  [2124] = {.lex_state = 177, .external_lex_state = 17},
  [2125] = {.lex_state = 194, .external_lex_state = 6},
  [2126] = {.lex_state = 194, .external_lex_state = 19},
  [2127] = {.lex_state = 211, .external_lex_state = 8},
  [2128] = {.lex_state = 308, .external_lex_state = 8},
  [2129] = {.lex_state = 302, .external_lex_state = 16},
  [2130] = {.lex_state = 192, .external_lex_state = 2},
  [2131] = {.lex_state = 192, .external_lex_state = 2},
  [2132] = {.lex_state = 192, .external_lex_state = 2},
  [2133] = {.lex_state = 237},
  [2134] = {.lex_state = 192, .external_lex_state = 2},
  [2135] = {.lex_state = 192, .external_lex_state = 2},
  [2136] = {.lex_state = 192, .external_lex_state = 2},
  [2137] = {.lex_state = 192, .external_lex_state = 2},
  [2138] = {.lex_state = 520, .external_lex_state = 26},
  [2139] = {.lex_state = 493, .external_lex_state = 25},
  [2140] = {.lex_state = 324, .external_lex_state = 25},
  [2141] = {.lex_state = 493, .external_lex_state = 25},
  [2142] = {.lex_state = 213},
  [2143] = {.lex_state = 497, .external_lex_state = 25},
  [2144] = {.lex_state = 493, .external_lex_state = 27},
  [2145] = {.lex_state = 302, .external_lex_state = 16},
  [2146] = {.lex_state = 302, .external_lex_state = 16},
  [2147] = {.lex_state = 192, .external_lex_state = 2},
  [2148] = {.lex_state = 192, .external_lex_state = 2},
  [2149] = {.lex_state = 310},
  [2150] = {.lex_state = 192, .external_lex_state = 2},
  [2151] = {.lex_state = 192, .external_lex_state = 2},
  [2152] = {.lex_state = 192, .external_lex_state = 2},
  [2153] = {.lex_state = 192, .external_lex_state = 2},
  [2154] = {.lex_state = 192, .external_lex_state = 2},
  [2155] = {.lex_state = 192, .external_lex_state = 2},
  [2156] = {.lex_state = 192, .external_lex_state = 2},
  [2157] = {.lex_state = 192, .external_lex_state = 2},
  [2158] = {.lex_state = 192, .external_lex_state = 2},
  [2159] = {.lex_state = 192, .external_lex_state = 2},
  [2160] = {.lex_state = 192, .external_lex_state = 2},
  [2161] = {.lex_state = 192, .external_lex_state = 2},
  [2162] = {.lex_state = 192, .external_lex_state = 2},
  [2163] = {.lex_state = 237},
  [2164] = {.lex_state = 192, .external_lex_state = 2},
  [2165] = {.lex_state = 523, .external_lex_state = 26},
  [2166] = {.lex_state = 523, .external_lex_state = 26},
  [2167] = {.lex_state = 523, .external_lex_state = 26},
  [2168] = {.lex_state = 523, .external_lex_state = 26},
  [2169] = {.lex_state = 192, .external_lex_state = 2},
  [2170] = {.lex_state = 192, .external_lex_state = 2},
  [2171] = {.lex_state = 192, .external_lex_state = 2},
  [2172] = {.lex_state = 520, .external_lex_state = 26},
  [2173] = {.lex_state = 497, .external_lex_state = 25},
  [2174] = {.lex_state = 523, .external_lex_state = 26},
  [2175] = {.lex_state = 321, .external_lex_state = 25},
  [2176] = {.lex_state = 321, .external_lex_state = 25},
  [2177] = {.lex_state = 213},
  [2178] = {.lex_state = 497, .external_lex_state = 25},
  [2179] = {.lex_state = 497, .external_lex_state = 27},
  [2180] = {.lex_state = 192, .external_lex_state = 29},
  [2181] = {.lex_state = 192, .external_lex_state = 2},
  [2182] = {.lex_state = 324, .external_lex_state = 20},
  [2183] = {.lex_state = 156, .external_lex_state = 3},
  [2184] = {.lex_state = 128, .external_lex_state = 12},
  [2185] = {.lex_state = 302},
  [2186] = {.lex_state = 254, .external_lex_state = 8},
  [2187] = {.lex_state = 254, .external_lex_state = 8},
  [2188] = {.lex_state = 254, .external_lex_state = 8},
  [2189] = {.lex_state = 237},
  [2190] = {.lex_state = 599, .external_lex_state = 12},
  [2191] = {.lex_state = 192, .external_lex_state = 2},
  [2192] = {.lex_state = 156, .external_lex_state = 3},
  [2193] = {.lex_state = 197},
  [2194] = {.lex_state = 128, .external_lex_state = 2},
  [2195] = {.lex_state = 192, .external_lex_state = 2},
  [2196] = {.lex_state = 192, .external_lex_state = 2},
  [2197] = {.lex_state = 192, .external_lex_state = 2},
  [2198] = {.lex_state = 237},
  [2199] = {.lex_state = 192, .external_lex_state = 2},
  [2200] = {.lex_state = 601, .external_lex_state = 26},
  [2201] = {.lex_state = 601, .external_lex_state = 26},
  [2202] = {.lex_state = 601, .external_lex_state = 26},
  [2203] = {.lex_state = 601, .external_lex_state = 26},
  [2204] = {.lex_state = 192, .external_lex_state = 2},
  [2205] = {.lex_state = 192, .external_lex_state = 2},
  [2206] = {.lex_state = 192, .external_lex_state = 2},
  [2207] = {.lex_state = 520, .external_lex_state = 26},
  [2208] = {.lex_state = 604, .external_lex_state = 25},
  [2209] = {.lex_state = 337, .external_lex_state = 19},
  [2210] = {.lex_state = 337, .external_lex_state = 19},
  [2211] = {.lex_state = 213},
  [2212] = {.lex_state = 497, .external_lex_state = 25},
  [2213] = {.lex_state = 604, .external_lex_state = 27},
  [2214] = {.lex_state = 192, .external_lex_state = 2},
  [2215] = {.lex_state = 607, .external_lex_state = 11},
  [2216] = {.lex_state = 607, .external_lex_state = 11},
  [2217] = {.lex_state = 607, .external_lex_state = 11},
  [2218] = {.lex_state = 607, .external_lex_state = 11},
  [2219] = {.lex_state = 192, .external_lex_state = 2},
  [2220] = {.lex_state = 192, .external_lex_state = 2},
  [2221] = {.lex_state = 192, .external_lex_state = 2},
  [2222] = {.lex_state = 493, .external_lex_state = 3},
  [2223] = {.lex_state = 213},
  [2224] = {.lex_state = 321, .external_lex_state = 3},
  [2225] = {.lex_state = 610, .external_lex_state = 14},
  [2226] = {.lex_state = 493, .external_lex_state = 3},
  [2227] = {.lex_state = 493, .external_lex_state = 3},
  [2228] = {.lex_state = 613, .external_lex_state = 14},
  [2229] = {.lex_state = 192, .external_lex_state = 2},
  [2230] = {.lex_state = 493, .external_lex_state = 3},
  [2231] = {.lex_state = 192, .external_lex_state = 2},
  [2232] = {.lex_state = 192, .external_lex_state = 2},
  [2233] = {.lex_state = 237},
  [2234] = {.lex_state = 192, .external_lex_state = 2},
  [2235] = {.lex_state = 490, .external_lex_state = 11},
  [2236] = {.lex_state = 493, .external_lex_state = 3},
  [2237] = {.lex_state = 493, .external_lex_state = 3},
  [2238] = {.lex_state = 493, .external_lex_state = 3},
  [2239] = {.lex_state = 493, .external_lex_state = 14},
  [2240] = {.lex_state = 493, .external_lex_state = 3},
  [2241] = {.lex_state = 493, .external_lex_state = 3},
  [2242] = {.lex_state = 192, .external_lex_state = 2},
  [2243] = {.lex_state = 192, .external_lex_state = 2},
  [2244] = {.lex_state = 192, .external_lex_state = 2},
  [2245] = {.lex_state = 192, .external_lex_state = 2},
  [2246] = {.lex_state = 192, .external_lex_state = 2},
  [2247] = {.lex_state = 192, .external_lex_state = 2},
  [2248] = {.lex_state = 192, .external_lex_state = 2},
  [2249] = {.lex_state = 192, .external_lex_state = 2},
  [2250] = {.lex_state = 192, .external_lex_state = 2},
  [2251] = {.lex_state = 192, .external_lex_state = 2},
  [2252] = {.lex_state = 192, .external_lex_state = 2},
  [2253] = {.lex_state = 192, .external_lex_state = 2},
  [2254] = {.lex_state = 192, .external_lex_state = 2},
  [2255] = {.lex_state = 192, .external_lex_state = 2},
  [2256] = {.lex_state = 192, .external_lex_state = 2},
  [2257] = {.lex_state = 237},
  [2258] = {.lex_state = 192, .external_lex_state = 2},
  [2259] = {.lex_state = 490, .external_lex_state = 11},
  [2260] = {.lex_state = 497, .external_lex_state = 3},
  [2261] = {.lex_state = 497, .external_lex_state = 3},
  [2262] = {.lex_state = 497, .external_lex_state = 3},
  [2263] = {.lex_state = 497, .external_lex_state = 14},
  [2264] = {.lex_state = 324, .external_lex_state = 3},
  [2265] = {.lex_state = 524, .external_lex_state = 13},
  [2266] = {.lex_state = 493, .external_lex_state = 3},
  [2267] = {.lex_state = 192, .external_lex_state = 29},
  [2268] = {.lex_state = 192, .external_lex_state = 2},
  [2269] = {.lex_state = 613, .external_lex_state = 14},
  [2270] = {.lex_state = 302, .external_lex_state = 8},
  [2271] = {.lex_state = 209, .external_lex_state = 2},
  [2272] = {.lex_state = 209, .external_lex_state = 8},
  [2273] = {.lex_state = 302, .external_lex_state = 3},
  [2274] = {.lex_state = 302, .external_lex_state = 3},
  [2275] = {.lex_state = 302, .external_lex_state = 3},
  [2276] = {.lex_state = 302, .external_lex_state = 3},
  [2277] = {.lex_state = 302, .external_lex_state = 3},
  [2278] = {.lex_state = 302, .external_lex_state = 3},
  [2279] = {.lex_state = 302, .external_lex_state = 3},
  [2280] = {.lex_state = 302, .external_lex_state = 3},
  [2281] = {.lex_state = 302, .external_lex_state = 3},
  [2282] = {.lex_state = 302, .external_lex_state = 3},
  [2283] = {.lex_state = 302, .external_lex_state = 3},
  [2284] = {.lex_state = 554, .external_lex_state = 16},
  [2285] = {.lex_state = 302, .external_lex_state = 3},
  [2286] = {.lex_state = 302, .external_lex_state = 3},
  [2287] = {.lex_state = 302, .external_lex_state = 3},
  [2288] = {.lex_state = 302, .external_lex_state = 3},
  [2289] = {.lex_state = 302, .external_lex_state = 3},
  [2290] = {.lex_state = 192, .external_lex_state = 2},
  [2291] = {.lex_state = 318, .external_lex_state = 11},
  [2292] = {.lex_state = 318, .external_lex_state = 11},
  [2293] = {.lex_state = 318, .external_lex_state = 11},
  [2294] = {.lex_state = 318, .external_lex_state = 11},
  [2295] = {.lex_state = 192, .external_lex_state = 2},
  [2296] = {.lex_state = 192, .external_lex_state = 2},
  [2297] = {.lex_state = 192, .external_lex_state = 2},
  [2298] = {.lex_state = 321, .external_lex_state = 3},
  [2299] = {.lex_state = 318, .external_lex_state = 11},
  [2300] = {.lex_state = 213},
  [2301] = {.lex_state = 321, .external_lex_state = 3},
  [2302] = {.lex_state = 321, .external_lex_state = 14},
  [2303] = {.lex_state = 321, .external_lex_state = 3},
  [2304] = {.lex_state = 497, .external_lex_state = 3},
  [2305] = {.lex_state = 614, .external_lex_state = 14},
  [2306] = {.lex_state = 192, .external_lex_state = 2},
  [2307] = {.lex_state = 321, .external_lex_state = 3},
  [2308] = {.lex_state = 497, .external_lex_state = 3},
  [2309] = {.lex_state = 497, .external_lex_state = 3},
  [2310] = {.lex_state = 192, .external_lex_state = 2},
  [2311] = {.lex_state = 192, .external_lex_state = 2},
  [2312] = {.lex_state = 192, .external_lex_state = 2},
  [2313] = {.lex_state = 192, .external_lex_state = 2},
  [2314] = {.lex_state = 192, .external_lex_state = 2},
  [2315] = {.lex_state = 192, .external_lex_state = 2},
  [2316] = {.lex_state = 192, .external_lex_state = 2},
  [2317] = {.lex_state = 192, .external_lex_state = 2},
  [2318] = {.lex_state = 192, .external_lex_state = 2},
  [2319] = {.lex_state = 192, .external_lex_state = 2},
  [2320] = {.lex_state = 192, .external_lex_state = 2},
  [2321] = {.lex_state = 192, .external_lex_state = 2},
  [2322] = {.lex_state = 192, .external_lex_state = 2},
  [2323] = {.lex_state = 321, .external_lex_state = 3},
  [2324] = {.lex_state = 524, .external_lex_state = 13},
  [2325] = {.lex_state = 321, .external_lex_state = 3},
  [2326] = {.lex_state = 192, .external_lex_state = 29},
  [2327] = {.lex_state = 192, .external_lex_state = 2},
  [2328] = {.lex_state = 614, .external_lex_state = 14},
  [2329] = {.lex_state = 192, .external_lex_state = 2},
  [2330] = {.lex_state = 192, .external_lex_state = 2},
  [2331] = {.lex_state = 192, .external_lex_state = 2},
  [2332] = {.lex_state = 192, .external_lex_state = 2},
  [2333] = {.lex_state = 192, .external_lex_state = 2},
  [2334] = {.lex_state = 302, .external_lex_state = 3},
  [2335] = {.lex_state = 302, .external_lex_state = 3},
  [2336] = {.lex_state = 213},
  [2337] = {.lex_state = 321, .external_lex_state = 3},
  [2338] = {.lex_state = 302, .external_lex_state = 3},
  [2339] = {.lex_state = 324, .external_lex_state = 14},
  [2340] = {.lex_state = 343, .external_lex_state = 22},
  [2341] = {.lex_state = 330},
  [2342] = {.lex_state = 330},
  [2343] = {.lex_state = 330},
  [2344] = {.lex_state = 330},
  [2345] = {.lex_state = 192, .external_lex_state = 15},
  [2346] = {.lex_state = 266, .external_lex_state = 15},
  [2347] = {.lex_state = 330},
  [2348] = {.lex_state = 177, .external_lex_state = 4},
  [2349] = {.lex_state = 266, .external_lex_state = 15},
  [2350] = {.lex_state = 330},
  [2351] = {.lex_state = 192, .external_lex_state = 15},
  [2352] = {.lex_state = 266, .external_lex_state = 15},
  [2353] = {.lex_state = 330},
  [2354] = {.lex_state = 177, .external_lex_state = 4},
  [2355] = {.lex_state = 266, .external_lex_state = 15},
  [2356] = {.lex_state = 330},
  [2357] = {.lex_state = 194},
  [2358] = {.lex_state = 302, .external_lex_state = 16},
  [2359] = {.lex_state = 225, .external_lex_state = 7},
  [2360] = {.lex_state = 128, .external_lex_state = 2},
  [2361] = {.lex_state = 330},
  [2362] = {.lex_state = 247, .external_lex_state = 3},
  [2363] = {.lex_state = 128, .external_lex_state = 8},
  [2364] = {.lex_state = 128, .external_lex_state = 2},
  [2365] = {.lex_state = 330},
  [2366] = {.lex_state = 128, .external_lex_state = 2},
  [2367] = {.lex_state = 192, .external_lex_state = 2},
  [2368] = {.lex_state = 615, .external_lex_state = 26},
  [2369] = {.lex_state = 615, .external_lex_state = 26},
  [2370] = {.lex_state = 615, .external_lex_state = 26},
  [2371] = {.lex_state = 615, .external_lex_state = 26},
  [2372] = {.lex_state = 192, .external_lex_state = 2},
  [2373] = {.lex_state = 192, .external_lex_state = 2},
  [2374] = {.lex_state = 192, .external_lex_state = 2},
  [2375] = {.lex_state = 361, .external_lex_state = 25},
  [2376] = {.lex_state = 618, .external_lex_state = 26},
  [2377] = {.lex_state = 213},
  [2378] = {.lex_state = 259, .external_lex_state = 25},
  [2379] = {.lex_state = 365, .external_lex_state = 27},
  [2380] = {.lex_state = 361, .external_lex_state = 25},
  [2381] = {.lex_state = 192, .external_lex_state = 2},
  [2382] = {.lex_state = 361, .external_lex_state = 25},
  [2383] = {.lex_state = 337, .external_lex_state = 19},
  [2384] = {.lex_state = 209, .external_lex_state = 19},
  [2385] = {.lex_state = 209},
  [2386] = {.lex_state = 192, .external_lex_state = 2},
  [2387] = {.lex_state = 177, .external_lex_state = 17},
  [2388] = {.lex_state = 334, .external_lex_state = 19},
  [2389] = {.lex_state = 524, .external_lex_state = 13},
  [2390] = {.lex_state = 340, .external_lex_state = 19},
  [2391] = {.lex_state = 128, .external_lex_state = 12},
  [2392] = {.lex_state = 128, .external_lex_state = 2},
  [2393] = {.lex_state = 128, .external_lex_state = 2},
  [2394] = {.lex_state = 128, .external_lex_state = 2},
  [2395] = {.lex_state = 128, .external_lex_state = 8},
  [2396] = {.lex_state = 128},
  [2397] = {.lex_state = 128},
  [2398] = {.lex_state = 128},
  [2399] = {.lex_state = 330},
  [2400] = {.lex_state = 128},
  [2401] = {.lex_state = 128},
  [2402] = {.lex_state = 128},
  [2403] = {.lex_state = 330},
  [2404] = {.lex_state = 330},
  [2405] = {.lex_state = 235},
  [2406] = {.lex_state = 337},
  [2407] = {.lex_state = 194},
  [2408] = {.lex_state = 286, .external_lex_state = 2},
  [2409] = {.lex_state = 337},
  [2410] = {.lex_state = 128},
  [2411] = {.lex_state = 128, .external_lex_state = 12},
  [2412] = {.lex_state = 414, .external_lex_state = 2},
  [2413] = {.lex_state = 337},
  [2414] = {.lex_state = 484, .external_lex_state = 21},
  [2415] = {.lex_state = 356, .external_lex_state = 13},
  [2416] = {.lex_state = 484, .external_lex_state = 21},
  [2417] = {.lex_state = 484, .external_lex_state = 21},
  [2418] = {.lex_state = 416, .external_lex_state = 28},
  [2419] = {.lex_state = 337},
  [2420] = {.lex_state = 235, .external_lex_state = 19},
  [2421] = {.lex_state = 235},
  [2422] = {.lex_state = 484, .external_lex_state = 21},
  [2423] = {.lex_state = 621, .external_lex_state = 25},
  [2424] = {.lex_state = 177, .external_lex_state = 4},
  [2425] = {.lex_state = 177, .external_lex_state = 4},
  [2426] = {.lex_state = 177, .external_lex_state = 4},
  [2427] = {.lex_state = 177, .external_lex_state = 4},
  [2428] = {.lex_state = 190, .external_lex_state = 4},
  [2429] = {.lex_state = 190, .external_lex_state = 4},
  [2430] = {.lex_state = 192, .external_lex_state = 2},
  [2431] = {.lex_state = 194, .external_lex_state = 6},
  [2432] = {.lex_state = 197, .external_lex_state = 7},
  [2433] = {.lex_state = 209, .external_lex_state = 2},
  [2434] = {.lex_state = 216, .external_lex_state = 10},
  [2435] = {.lex_state = 216, .external_lex_state = 9},
  [2436] = {.lex_state = 624, .external_lex_state = 26},
  [2437] = {.lex_state = 624, .external_lex_state = 26},
  [2438] = {.lex_state = 624, .external_lex_state = 26},
  [2439] = {.lex_state = 624, .external_lex_state = 26},
  [2440] = {.lex_state = 221, .external_lex_state = 2},
  [2441] = {.lex_state = 221, .external_lex_state = 2},
  [2442] = {.lex_state = 192, .external_lex_state = 2},
  [2443] = {.lex_state = 192, .external_lex_state = 2},
  [2444] = {.lex_state = 223, .external_lex_state = 9},
  [2445] = {.lex_state = 221, .external_lex_state = 12},
  [2446] = {.lex_state = 128, .external_lex_state = 12},
  [2447] = {.lex_state = 192, .external_lex_state = 2},
  [2448] = {.lex_state = 192, .external_lex_state = 2},
  [2449] = {.lex_state = 192, .external_lex_state = 2},
  [2450] = {.lex_state = 621, .external_lex_state = 25},
  [2451] = {.lex_state = 235, .external_lex_state = 13},
  [2452] = {.lex_state = 237},
  [2453] = {.lex_state = 627, .external_lex_state = 25},
  [2454] = {.lex_state = 618, .external_lex_state = 26},
  [2455] = {.lex_state = 213},
  [2456] = {.lex_state = 424, .external_lex_state = 25},
  [2457] = {.lex_state = 627, .external_lex_state = 27},
  [2458] = {.lex_state = 627, .external_lex_state = 25},
  [2459] = {.lex_state = 505, .external_lex_state = 25},
  [2460] = {.lex_state = 630, .external_lex_state = 27},
  [2461] = {.lex_state = 192, .external_lex_state = 2},
  [2462] = {.lex_state = 604, .external_lex_state = 25},
  [2463] = {.lex_state = 627, .external_lex_state = 25},
  [2464] = {.lex_state = 192, .external_lex_state = 2},
  [2465] = {.lex_state = 192, .external_lex_state = 2},
  [2466] = {.lex_state = 237},
  [2467] = {.lex_state = 192, .external_lex_state = 2},
  [2468] = {.lex_state = 296, .external_lex_state = 26},
  [2469] = {.lex_state = 505, .external_lex_state = 25},
  [2470] = {.lex_state = 505, .external_lex_state = 25},
  [2471] = {.lex_state = 505, .external_lex_state = 25},
  [2472] = {.lex_state = 505, .external_lex_state = 27},
  [2473] = {.lex_state = 505, .external_lex_state = 25},
  [2474] = {.lex_state = 505, .external_lex_state = 25},
  [2475] = {.lex_state = 192, .external_lex_state = 2},
  [2476] = {.lex_state = 192, .external_lex_state = 2},
  [2477] = {.lex_state = 192, .external_lex_state = 2},
  [2478] = {.lex_state = 192, .external_lex_state = 2},
  [2479] = {.lex_state = 192, .external_lex_state = 2},
  [2480] = {.lex_state = 192, .external_lex_state = 2},
  [2481] = {.lex_state = 192, .external_lex_state = 2},
  [2482] = {.lex_state = 192, .external_lex_state = 2},
  [2483] = {.lex_state = 192, .external_lex_state = 2},
  [2484] = {.lex_state = 192, .external_lex_state = 2},
  [2485] = {.lex_state = 192, .external_lex_state = 2},
  [2486] = {.lex_state = 192, .external_lex_state = 2},
  [2487] = {.lex_state = 192, .external_lex_state = 2},
  [2488] = {.lex_state = 337},
  [2489] = {.lex_state = 340, .external_lex_state = 19},
  [2490] = {.lex_state = 524, .external_lex_state = 13},
  [2491] = {.lex_state = 340, .external_lex_state = 19},
  [2492] = {.lex_state = 192, .external_lex_state = 29},
  [2493] = {.lex_state = 192, .external_lex_state = 2},
  [2494] = {.lex_state = 630, .external_lex_state = 27},
  [2495] = {.lex_state = 343, .external_lex_state = 22},
  [2496] = {.lex_state = 128, .external_lex_state = 2},
  [2497] = {.lex_state = 247, .external_lex_state = 3},
  [2498] = {.lex_state = 128, .external_lex_state = 2},
  [2499] = {.lex_state = 156, .external_lex_state = 3},
  [2500] = {.lex_state = 346, .external_lex_state = 23},
  [2501] = {.lex_state = 192, .external_lex_state = 2},
  [2502] = {.lex_state = 615, .external_lex_state = 26},
  [2503] = {.lex_state = 615, .external_lex_state = 26},
  [2504] = {.lex_state = 615, .external_lex_state = 26},
  [2505] = {.lex_state = 615, .external_lex_state = 26},
  [2506] = {.lex_state = 192, .external_lex_state = 2},
  [2507] = {.lex_state = 192, .external_lex_state = 2},
  [2508] = {.lex_state = 192, .external_lex_state = 2},
  [2509] = {.lex_state = 508, .external_lex_state = 25},
  [2510] = {.lex_state = 213},
  [2511] = {.lex_state = 424, .external_lex_state = 25},
  [2512] = {.lex_state = 631, .external_lex_state = 27},
  [2513] = {.lex_state = 508, .external_lex_state = 25},
  [2514] = {.lex_state = 508, .external_lex_state = 25},
  [2515] = {.lex_state = 634, .external_lex_state = 27},
  [2516] = {.lex_state = 192, .external_lex_state = 2},
  [2517] = {.lex_state = 508, .external_lex_state = 25},
  [2518] = {.lex_state = 508, .external_lex_state = 25},
  [2519] = {.lex_state = 192, .external_lex_state = 2},
  [2520] = {.lex_state = 192, .external_lex_state = 2},
  [2521] = {.lex_state = 237},
  [2522] = {.lex_state = 192, .external_lex_state = 2},
  [2523] = {.lex_state = 296, .external_lex_state = 26},
  [2524] = {.lex_state = 508, .external_lex_state = 25},
  [2525] = {.lex_state = 508, .external_lex_state = 25},
  [2526] = {.lex_state = 508, .external_lex_state = 25},
  [2527] = {.lex_state = 508, .external_lex_state = 27},
  [2528] = {.lex_state = 508, .external_lex_state = 25},
  [2529] = {.lex_state = 508, .external_lex_state = 25},
  [2530] = {.lex_state = 192, .external_lex_state = 2},
  [2531] = {.lex_state = 192, .external_lex_state = 2},
  [2532] = {.lex_state = 192, .external_lex_state = 2},
  [2533] = {.lex_state = 192, .external_lex_state = 2},
  [2534] = {.lex_state = 192, .external_lex_state = 2},
  [2535] = {.lex_state = 192, .external_lex_state = 2},
  [2536] = {.lex_state = 192, .external_lex_state = 2},
  [2537] = {.lex_state = 192, .external_lex_state = 2},
  [2538] = {.lex_state = 192, .external_lex_state = 2},
  [2539] = {.lex_state = 192, .external_lex_state = 2},
  [2540] = {.lex_state = 192, .external_lex_state = 2},
  [2541] = {.lex_state = 192, .external_lex_state = 2},
  [2542] = {.lex_state = 192, .external_lex_state = 2},
  [2543] = {.lex_state = 334, .external_lex_state = 19},
  [2544] = {.lex_state = 524, .external_lex_state = 13},
  [2545] = {.lex_state = 340, .external_lex_state = 19},
  [2546] = {.lex_state = 192, .external_lex_state = 29},
  [2547] = {.lex_state = 192, .external_lex_state = 2},
  [2548] = {.lex_state = 634, .external_lex_state = 27},
  [2549] = {.lex_state = 156, .external_lex_state = 3},
  [2550] = {.lex_state = 365, .external_lex_state = 3},
  [2551] = {.lex_state = 365, .external_lex_state = 3},
  [2552] = {.lex_state = 365, .external_lex_state = 3},
  [2553] = {.lex_state = 365, .external_lex_state = 3},
  [2554] = {.lex_state = 365, .external_lex_state = 3},
  [2555] = {.lex_state = 192, .external_lex_state = 2},
  [2556] = {.lex_state = 192, .external_lex_state = 2},
  [2557] = {.lex_state = 192, .external_lex_state = 2},
  [2558] = {.lex_state = 192, .external_lex_state = 2},
  [2559] = {.lex_state = 192, .external_lex_state = 2},
  [2560] = {.lex_state = 192, .external_lex_state = 2},
  [2561] = {.lex_state = 192, .external_lex_state = 2},
  [2562] = {.lex_state = 192, .external_lex_state = 2},
  [2563] = {.lex_state = 192, .external_lex_state = 2},
  [2564] = {.lex_state = 192, .external_lex_state = 2},
  [2565] = {.lex_state = 192, .external_lex_state = 2},
  [2566] = {.lex_state = 192, .external_lex_state = 2},
  [2567] = {.lex_state = 192, .external_lex_state = 29},
  [2568] = {.lex_state = 192, .external_lex_state = 2},
  [2569] = {.lex_state = 365, .external_lex_state = 14},
  [2570] = {.lex_state = 365, .external_lex_state = 3},
  [2571] = {.lex_state = 361, .external_lex_state = 3},
  [2572] = {.lex_state = 361, .external_lex_state = 3},
  [2573] = {.lex_state = 192, .external_lex_state = 2},
  [2574] = {.lex_state = 361, .external_lex_state = 3},
  [2575] = {.lex_state = 192, .external_lex_state = 2},
  [2576] = {.lex_state = 361, .external_lex_state = 3},
  [2577] = {.lex_state = 524, .external_lex_state = 13},
  [2578] = {.lex_state = 361, .external_lex_state = 3},
  [2579] = {.lex_state = 192, .external_lex_state = 2},
  [2580] = {.lex_state = 635, .external_lex_state = 26},
  [2581] = {.lex_state = 635, .external_lex_state = 26},
  [2582] = {.lex_state = 635, .external_lex_state = 26},
  [2583] = {.lex_state = 635, .external_lex_state = 26},
  [2584] = {.lex_state = 192, .external_lex_state = 2},
  [2585] = {.lex_state = 192, .external_lex_state = 2},
  [2586] = {.lex_state = 192, .external_lex_state = 2},
  [2587] = {.lex_state = 302, .external_lex_state = 25},
  [2588] = {.lex_state = 478, .external_lex_state = 26},
  [2589] = {.lex_state = 213},
  [2590] = {.lex_state = 321, .external_lex_state = 25},
  [2591] = {.lex_state = 610, .external_lex_state = 27},
  [2592] = {.lex_state = 302, .external_lex_state = 25},
  [2593] = {.lex_state = 302, .external_lex_state = 25},
  [2594] = {.lex_state = 613, .external_lex_state = 27},
  [2595] = {.lex_state = 192, .external_lex_state = 2},
  [2596] = {.lex_state = 302, .external_lex_state = 25},
  [2597] = {.lex_state = 192, .external_lex_state = 2},
  [2598] = {.lex_state = 192, .external_lex_state = 2},
  [2599] = {.lex_state = 237},
  [2600] = {.lex_state = 192, .external_lex_state = 2},
  [2601] = {.lex_state = 520, .external_lex_state = 26},
  [2602] = {.lex_state = 493, .external_lex_state = 25},
  [2603] = {.lex_state = 493, .external_lex_state = 25},
  [2604] = {.lex_state = 493, .external_lex_state = 25},
  [2605] = {.lex_state = 493, .external_lex_state = 27},
  [2606] = {.lex_state = 302, .external_lex_state = 25},
  [2607] = {.lex_state = 302, .external_lex_state = 25},
  [2608] = {.lex_state = 192, .external_lex_state = 2},
  [2609] = {.lex_state = 192, .external_lex_state = 2},
  [2610] = {.lex_state = 192, .external_lex_state = 2},
  [2611] = {.lex_state = 192, .external_lex_state = 2},
  [2612] = {.lex_state = 192, .external_lex_state = 2},
  [2613] = {.lex_state = 192, .external_lex_state = 2},
  [2614] = {.lex_state = 192, .external_lex_state = 2},
  [2615] = {.lex_state = 192, .external_lex_state = 2},
  [2616] = {.lex_state = 192, .external_lex_state = 2},
  [2617] = {.lex_state = 192, .external_lex_state = 2},
  [2618] = {.lex_state = 192, .external_lex_state = 2},
  [2619] = {.lex_state = 192, .external_lex_state = 2},
  [2620] = {.lex_state = 192, .external_lex_state = 2},
  [2621] = {.lex_state = 192, .external_lex_state = 2},
  [2622] = {.lex_state = 192, .external_lex_state = 2},
  [2623] = {.lex_state = 237},
  [2624] = {.lex_state = 192, .external_lex_state = 2},
  [2625] = {.lex_state = 520, .external_lex_state = 26},
  [2626] = {.lex_state = 497, .external_lex_state = 25},
  [2627] = {.lex_state = 497, .external_lex_state = 25},
  [2628] = {.lex_state = 497, .external_lex_state = 25},
  [2629] = {.lex_state = 497, .external_lex_state = 27},
  [2630] = {.lex_state = 156, .external_lex_state = 3},
  [2631] = {.lex_state = 209},
  [2632] = {.lex_state = 356, .external_lex_state = 13},
  [2633] = {.lex_state = 192, .external_lex_state = 29},
  [2634] = {.lex_state = 192, .external_lex_state = 2},
  [2635] = {.lex_state = 613, .external_lex_state = 27},
  [2636] = {.lex_state = 361, .external_lex_state = 3},
  [2637] = {.lex_state = 361, .external_lex_state = 3},
  [2638] = {.lex_state = 361, .external_lex_state = 3},
  [2639] = {.lex_state = 361, .external_lex_state = 3},
  [2640] = {.lex_state = 361, .external_lex_state = 3},
  [2641] = {.lex_state = 361, .external_lex_state = 3},
  [2642] = {.lex_state = 365, .external_lex_state = 3},
  [2643] = {.lex_state = 554, .external_lex_state = 16},
  [2644] = {.lex_state = 361, .external_lex_state = 3},
  [2645] = {.lex_state = 361, .external_lex_state = 3},
  [2646] = {.lex_state = 361, .external_lex_state = 3},
  [2647] = {.lex_state = 361, .external_lex_state = 3},
  [2648] = {.lex_state = 361, .external_lex_state = 3},
  [2649] = {.lex_state = 514, .external_lex_state = 11},
  [2650] = {.lex_state = 356, .external_lex_state = 13},
  [2651] = {.lex_state = 514, .external_lex_state = 11},
  [2652] = {.lex_state = 514, .external_lex_state = 11},
  [2653] = {.lex_state = 416, .external_lex_state = 28},
  [2654] = {.lex_state = 299, .external_lex_state = 3},
  [2655] = {.lex_state = 235, .external_lex_state = 19},
  [2656] = {.lex_state = 235},
  [2657] = {.lex_state = 514, .external_lex_state = 11},
  [2658] = {.lex_state = 421, .external_lex_state = 3},
  [2659] = {.lex_state = 421, .external_lex_state = 3},
  [2660] = {.lex_state = 192, .external_lex_state = 2},
  [2661] = {.lex_state = 299, .external_lex_state = 3},
  [2662] = {.lex_state = 194},
  [2663] = {.lex_state = 286, .external_lex_state = 2},
  [2664] = {.lex_state = 421, .external_lex_state = 3},
  [2665] = {.lex_state = 299, .external_lex_state = 3},
  [2666] = {.lex_state = 128},
  [2667] = {.lex_state = 128, .external_lex_state = 12},
  [2668] = {.lex_state = 414, .external_lex_state = 2},
  [2669] = {.lex_state = 299, .external_lex_state = 3},
  [2670] = {.lex_state = 209, .external_lex_state = 19},
  [2671] = {.lex_state = 209},
  [2672] = {.lex_state = 192, .external_lex_state = 2},
  [2673] = {.lex_state = 299, .external_lex_state = 3},
  [2674] = {.lex_state = 177, .external_lex_state = 17},
  [2675] = {.lex_state = 421, .external_lex_state = 3},
  [2676] = {.lex_state = 524, .external_lex_state = 13},
  [2677] = {.lex_state = 421, .external_lex_state = 3},
  [2678] = {.lex_state = 156, .external_lex_state = 3},
  [2679] = {.lex_state = 177, .external_lex_state = 17},
  [2680] = {.lex_state = 262, .external_lex_state = 3},
  [2681] = {.lex_state = 177, .external_lex_state = 17},
  [2682] = {.lex_state = 156, .external_lex_state = 3},
  [2683] = {.lex_state = 524, .external_lex_state = 21},
  [2684] = {.lex_state = 262, .external_lex_state = 3},
  [2685] = {.lex_state = 365, .external_lex_state = 3},
  [2686] = {.lex_state = 361, .external_lex_state = 3},
  [2687] = {.lex_state = 156, .external_lex_state = 3},
  [2688] = {.lex_state = 361, .external_lex_state = 3},
  [2689] = {.lex_state = 361, .external_lex_state = 3},
  [2690] = {.lex_state = 361, .external_lex_state = 14},
  [2691] = {.lex_state = 192, .external_lex_state = 2},
  [2692] = {.lex_state = 511, .external_lex_state = 11},
  [2693] = {.lex_state = 511, .external_lex_state = 11},
  [2694] = {.lex_state = 511, .external_lex_state = 11},
  [2695] = {.lex_state = 511, .external_lex_state = 11},
  [2696] = {.lex_state = 192, .external_lex_state = 2},
  [2697] = {.lex_state = 192, .external_lex_state = 2},
  [2698] = {.lex_state = 192, .external_lex_state = 2},
  [2699] = {.lex_state = 361, .external_lex_state = 3},
  [2700] = {.lex_state = 213},
  [2701] = {.lex_state = 259, .external_lex_state = 3},
  [2702] = {.lex_state = 365, .external_lex_state = 14},
  [2703] = {.lex_state = 361, .external_lex_state = 3},
  [2704] = {.lex_state = 361, .external_lex_state = 3},
  [2705] = {.lex_state = 361, .external_lex_state = 14},
  [2706] = {.lex_state = 192, .external_lex_state = 2},
  [2707] = {.lex_state = 361, .external_lex_state = 3},
  [2708] = {.lex_state = 192, .external_lex_state = 2},
  [2709] = {.lex_state = 192, .external_lex_state = 2},
  [2710] = {.lex_state = 237},
  [2711] = {.lex_state = 192, .external_lex_state = 2},
  [2712] = {.lex_state = 358, .external_lex_state = 11},
  [2713] = {.lex_state = 361, .external_lex_state = 3},
  [2714] = {.lex_state = 361, .external_lex_state = 3},
  [2715] = {.lex_state = 361, .external_lex_state = 3},
  [2716] = {.lex_state = 371, .external_lex_state = 14},
  [2717] = {.lex_state = 361, .external_lex_state = 3},
  [2718] = {.lex_state = 361, .external_lex_state = 3},
  [2719] = {.lex_state = 192, .external_lex_state = 2},
  [2720] = {.lex_state = 192, .external_lex_state = 2},
  [2721] = {.lex_state = 192, .external_lex_state = 2},
  [2722] = {.lex_state = 192, .external_lex_state = 2},
  [2723] = {.lex_state = 192, .external_lex_state = 2},
  [2724] = {.lex_state = 192, .external_lex_state = 2},
  [2725] = {.lex_state = 192, .external_lex_state = 2},
  [2726] = {.lex_state = 192, .external_lex_state = 2},
  [2727] = {.lex_state = 192, .external_lex_state = 2},
  [2728] = {.lex_state = 192, .external_lex_state = 2},
  [2729] = {.lex_state = 192, .external_lex_state = 2},
  [2730] = {.lex_state = 192, .external_lex_state = 2},
  [2731] = {.lex_state = 192, .external_lex_state = 2},
  [2732] = {.lex_state = 192, .external_lex_state = 2},
  [2733] = {.lex_state = 192, .external_lex_state = 2},
  [2734] = {.lex_state = 237},
  [2735] = {.lex_state = 192, .external_lex_state = 2},
  [2736] = {.lex_state = 358, .external_lex_state = 11},
  [2737] = {.lex_state = 421, .external_lex_state = 3},
  [2738] = {.lex_state = 421, .external_lex_state = 3},
  [2739] = {.lex_state = 421, .external_lex_state = 3},
  [2740] = {.lex_state = 427, .external_lex_state = 14},
  [2741] = {.lex_state = 262, .external_lex_state = 3},
  [2742] = {.lex_state = 524, .external_lex_state = 13},
  [2743] = {.lex_state = 361, .external_lex_state = 3},
  [2744] = {.lex_state = 192, .external_lex_state = 29},
  [2745] = {.lex_state = 192, .external_lex_state = 2},
  [2746] = {.lex_state = 361, .external_lex_state = 14},
  [2747] = {.lex_state = 254, .external_lex_state = 8},
  [2748] = {.lex_state = 128, .external_lex_state = 12},
  [2749] = {.lex_state = 177, .external_lex_state = 17},
  [2750] = {.lex_state = 247, .external_lex_state = 3},
  [2751] = {.lex_state = 247, .external_lex_state = 3},
  [2752] = {.lex_state = 247, .external_lex_state = 3},
  [2753] = {.lex_state = 247, .external_lex_state = 3},
  [2754] = {.lex_state = 247, .external_lex_state = 3},
  [2755] = {.lex_state = 192, .external_lex_state = 2},
  [2756] = {.lex_state = 156, .external_lex_state = 3},
  [2757] = {.lex_state = 218, .external_lex_state = 11},
  [2758] = {.lex_state = 218, .external_lex_state = 11},
  [2759] = {.lex_state = 218, .external_lex_state = 11},
  [2760] = {.lex_state = 218, .external_lex_state = 11},
  [2761] = {.lex_state = 221, .external_lex_state = 2},
  [2762] = {.lex_state = 128, .external_lex_state = 12},
  [2763] = {.lex_state = 192, .external_lex_state = 2},
  [2764] = {.lex_state = 192, .external_lex_state = 2},
  [2765] = {.lex_state = 192, .external_lex_state = 2},
  [2766] = {.lex_state = 225, .external_lex_state = 7},
  [2767] = {.lex_state = 128},
  [2768] = {.lex_state = 128, .external_lex_state = 8},
  [2769] = {.lex_state = 128, .external_lex_state = 8},
  [2770] = {.lex_state = 128},
  [2771] = {.lex_state = 247, .external_lex_state = 3},
  [2772] = {.lex_state = 254, .external_lex_state = 11},
  [2773] = {.lex_state = 213},
  [2774] = {.lex_state = 259, .external_lex_state = 3},
  [2775] = {.lex_state = 262, .external_lex_state = 14},
  [2776] = {.lex_state = 128, .external_lex_state = 2},
  [2777] = {.lex_state = 128, .external_lex_state = 12},
  [2778] = {.lex_state = 247, .external_lex_state = 3},
  [2779] = {.lex_state = 247, .external_lex_state = 3},
  [2780] = {.lex_state = 247, .external_lex_state = 3},
  [2781] = {.lex_state = 247, .external_lex_state = 3},
  [2782] = {.lex_state = 247, .external_lex_state = 3},
  [2783] = {.lex_state = 247, .external_lex_state = 3},
  [2784] = {.lex_state = 554, .external_lex_state = 16},
  [2785] = {.lex_state = 247, .external_lex_state = 3},
  [2786] = {.lex_state = 247, .external_lex_state = 3},
  [2787] = {.lex_state = 247, .external_lex_state = 3},
  [2788] = {.lex_state = 247, .external_lex_state = 3},
  [2789] = {.lex_state = 247, .external_lex_state = 3},
  [2790] = {.lex_state = 192, .external_lex_state = 2},
  [2791] = {.lex_state = 254, .external_lex_state = 11},
  [2792] = {.lex_state = 254, .external_lex_state = 11},
  [2793] = {.lex_state = 254, .external_lex_state = 11},
  [2794] = {.lex_state = 254, .external_lex_state = 11},
  [2795] = {.lex_state = 192, .external_lex_state = 2},
  [2796] = {.lex_state = 192, .external_lex_state = 2},
  [2797] = {.lex_state = 192, .external_lex_state = 2},
  [2798] = {.lex_state = 424, .external_lex_state = 3},
  [2799] = {.lex_state = 254, .external_lex_state = 11},
  [2800] = {.lex_state = 213},
  [2801] = {.lex_state = 424, .external_lex_state = 3},
  [2802] = {.lex_state = 424, .external_lex_state = 14},
  [2803] = {.lex_state = 424, .external_lex_state = 3},
  [2804] = {.lex_state = 421, .external_lex_state = 3},
  [2805] = {.lex_state = 421, .external_lex_state = 14},
  [2806] = {.lex_state = 192, .external_lex_state = 2},
  [2807] = {.lex_state = 424, .external_lex_state = 3},
  [2808] = {.lex_state = 421, .external_lex_state = 3},
  [2809] = {.lex_state = 421, .external_lex_state = 3},
  [2810] = {.lex_state = 192, .external_lex_state = 2},
  [2811] = {.lex_state = 192, .external_lex_state = 2},
  [2812] = {.lex_state = 192, .external_lex_state = 2},
  [2813] = {.lex_state = 192, .external_lex_state = 2},
  [2814] = {.lex_state = 192, .external_lex_state = 2},
  [2815] = {.lex_state = 192, .external_lex_state = 2},
  [2816] = {.lex_state = 192, .external_lex_state = 2},
  [2817] = {.lex_state = 192, .external_lex_state = 2},
  [2818] = {.lex_state = 192, .external_lex_state = 2},
  [2819] = {.lex_state = 192, .external_lex_state = 2},
  [2820] = {.lex_state = 192, .external_lex_state = 2},
  [2821] = {.lex_state = 192, .external_lex_state = 2},
  [2822] = {.lex_state = 192, .external_lex_state = 2},
  [2823] = {.lex_state = 424, .external_lex_state = 3},
  [2824] = {.lex_state = 524, .external_lex_state = 13},
  [2825] = {.lex_state = 424, .external_lex_state = 3},
  [2826] = {.lex_state = 192, .external_lex_state = 29},
  [2827] = {.lex_state = 192, .external_lex_state = 2},
  [2828] = {.lex_state = 421, .external_lex_state = 14},
  [2829] = {.lex_state = 192, .external_lex_state = 2},
  [2830] = {.lex_state = 192, .external_lex_state = 2},
  [2831] = {.lex_state = 192, .external_lex_state = 2},
  [2832] = {.lex_state = 192, .external_lex_state = 2},
  [2833] = {.lex_state = 192, .external_lex_state = 2},
  [2834] = {.lex_state = 528, .external_lex_state = 3},
  [2835] = {.lex_state = 528, .external_lex_state = 3},
  [2836] = {.lex_state = 213},
  [2837] = {.lex_state = 259, .external_lex_state = 3},
  [2838] = {.lex_state = 247, .external_lex_state = 3},
  [2839] = {.lex_state = 262, .external_lex_state = 14},
  [2840] = {.lex_state = 192, .external_lex_state = 2},
  [2841] = {.lex_state = 156, .external_lex_state = 3},
  [2842] = {.lex_state = 218, .external_lex_state = 11},
  [2843] = {.lex_state = 218, .external_lex_state = 11},
  [2844] = {.lex_state = 218, .external_lex_state = 11},
  [2845] = {.lex_state = 218, .external_lex_state = 11},
  [2846] = {.lex_state = 192, .external_lex_state = 2},
  [2847] = {.lex_state = 192, .external_lex_state = 2},
  [2848] = {.lex_state = 192, .external_lex_state = 2},
  [2849] = {.lex_state = 225, .external_lex_state = 7},
  [2850] = {.lex_state = 128},
  [2851] = {.lex_state = 128, .external_lex_state = 8},
  [2852] = {.lex_state = 128, .external_lex_state = 8},
  [2853] = {.lex_state = 128},
  [2854] = {.lex_state = 247, .external_lex_state = 3},
  [2855] = {.lex_state = 254, .external_lex_state = 11},
  [2856] = {.lex_state = 213},
  [2857] = {.lex_state = 259, .external_lex_state = 3},
  [2858] = {.lex_state = 262, .external_lex_state = 14},
  [2859] = {.lex_state = 128, .external_lex_state = 2},
  [2860] = {.lex_state = 192, .external_lex_state = 2},
  [2861] = {.lex_state = 511, .external_lex_state = 11},
  [2862] = {.lex_state = 511, .external_lex_state = 11},
  [2863] = {.lex_state = 511, .external_lex_state = 11},
  [2864] = {.lex_state = 511, .external_lex_state = 11},
  [2865] = {.lex_state = 192, .external_lex_state = 2},
  [2866] = {.lex_state = 192, .external_lex_state = 2},
  [2867] = {.lex_state = 192, .external_lex_state = 2},
  [2868] = {.lex_state = 361, .external_lex_state = 3},
  [2869] = {.lex_state = 213},
  [2870] = {.lex_state = 259, .external_lex_state = 3},
  [2871] = {.lex_state = 365, .external_lex_state = 14},
  [2872] = {.lex_state = 361, .external_lex_state = 3},
  [2873] = {.lex_state = 361, .external_lex_state = 3},
  [2874] = {.lex_state = 361, .external_lex_state = 14},
  [2875] = {.lex_state = 192, .external_lex_state = 2},
  [2876] = {.lex_state = 361, .external_lex_state = 3},
  [2877] = {.lex_state = 192, .external_lex_state = 2},
  [2878] = {.lex_state = 192, .external_lex_state = 2},
  [2879] = {.lex_state = 237},
  [2880] = {.lex_state = 192, .external_lex_state = 2},
  [2881] = {.lex_state = 358, .external_lex_state = 11},
  [2882] = {.lex_state = 361, .external_lex_state = 3},
  [2883] = {.lex_state = 361, .external_lex_state = 3},
  [2884] = {.lex_state = 361, .external_lex_state = 3},
  [2885] = {.lex_state = 371, .external_lex_state = 14},
  [2886] = {.lex_state = 361, .external_lex_state = 3},
  [2887] = {.lex_state = 361, .external_lex_state = 3},
  [2888] = {.lex_state = 192, .external_lex_state = 2},
  [2889] = {.lex_state = 192, .external_lex_state = 2},
  [2890] = {.lex_state = 192, .external_lex_state = 2},
  [2891] = {.lex_state = 192, .external_lex_state = 2},
  [2892] = {.lex_state = 192, .external_lex_state = 2},
  [2893] = {.lex_state = 192, .external_lex_state = 2},
  [2894] = {.lex_state = 192, .external_lex_state = 2},
  [2895] = {.lex_state = 192, .external_lex_state = 2},
  [2896] = {.lex_state = 192, .external_lex_state = 2},
  [2897] = {.lex_state = 192, .external_lex_state = 2},
  [2898] = {.lex_state = 192, .external_lex_state = 2},
  [2899] = {.lex_state = 192, .external_lex_state = 2},
  [2900] = {.lex_state = 192, .external_lex_state = 2},
  [2901] = {.lex_state = 192, .external_lex_state = 2},
  [2902] = {.lex_state = 192, .external_lex_state = 2},
  [2903] = {.lex_state = 237},
  [2904] = {.lex_state = 419, .external_lex_state = 6},
  [2905] = {.lex_state = 192, .external_lex_state = 2},
  [2906] = {.lex_state = 358, .external_lex_state = 11},
  [2907] = {.lex_state = 421, .external_lex_state = 3},
  [2908] = {.lex_state = 421, .external_lex_state = 3},
  [2909] = {.lex_state = 421, .external_lex_state = 3},
  [2910] = {.lex_state = 427, .external_lex_state = 14},
  [2911] = {.lex_state = 262, .external_lex_state = 3},
  [2912] = {.lex_state = 524, .external_lex_state = 13},
  [2913] = {.lex_state = 361, .external_lex_state = 3},
  [2914] = {.lex_state = 192, .external_lex_state = 29},
  [2915] = {.lex_state = 192, .external_lex_state = 2},
  [2916] = {.lex_state = 361, .external_lex_state = 14},
  [2917] = {.lex_state = 247, .external_lex_state = 3},
  [2918] = {.lex_state = 247, .external_lex_state = 3},
  [2919] = {.lex_state = 247, .external_lex_state = 3},
  [2920] = {.lex_state = 247, .external_lex_state = 3},
  [2921] = {.lex_state = 247, .external_lex_state = 3},
  [2922] = {.lex_state = 247, .external_lex_state = 3},
  [2923] = {.lex_state = 554, .external_lex_state = 16},
  [2924] = {.lex_state = 247, .external_lex_state = 3},
  [2925] = {.lex_state = 247, .external_lex_state = 3},
  [2926] = {.lex_state = 247, .external_lex_state = 3},
  [2927] = {.lex_state = 247, .external_lex_state = 3},
  [2928] = {.lex_state = 247, .external_lex_state = 3},
  [2929] = {.lex_state = 156, .external_lex_state = 3},
  [2930] = {.lex_state = 128},
  [2931] = {.lex_state = 192, .external_lex_state = 2},
  [2932] = {.lex_state = 254, .external_lex_state = 11},
  [2933] = {.lex_state = 254, .external_lex_state = 11},
  [2934] = {.lex_state = 254, .external_lex_state = 11},
  [2935] = {.lex_state = 254, .external_lex_state = 11},
  [2936] = {.lex_state = 192, .external_lex_state = 2},
  [2937] = {.lex_state = 192, .external_lex_state = 2},
  [2938] = {.lex_state = 192, .external_lex_state = 2},
  [2939] = {.lex_state = 424, .external_lex_state = 3},
  [2940] = {.lex_state = 254, .external_lex_state = 11},
  [2941] = {.lex_state = 213},
  [2942] = {.lex_state = 424, .external_lex_state = 3},
  [2943] = {.lex_state = 424, .external_lex_state = 14},
  [2944] = {.lex_state = 424, .external_lex_state = 3},
  [2945] = {.lex_state = 421, .external_lex_state = 3},
  [2946] = {.lex_state = 421, .external_lex_state = 14},
  [2947] = {.lex_state = 192, .external_lex_state = 2},
  [2948] = {.lex_state = 421, .external_lex_state = 3},
  [2949] = {.lex_state = 424, .external_lex_state = 3},
  [2950] = {.lex_state = 421, .external_lex_state = 3},
  [2951] = {.lex_state = 421, .external_lex_state = 3},
  [2952] = {.lex_state = 192, .external_lex_state = 2},
  [2953] = {.lex_state = 192, .external_lex_state = 2},
  [2954] = {.lex_state = 192, .external_lex_state = 2},
  [2955] = {.lex_state = 192, .external_lex_state = 2},
  [2956] = {.lex_state = 192, .external_lex_state = 2},
  [2957] = {.lex_state = 192, .external_lex_state = 2},
  [2958] = {.lex_state = 192, .external_lex_state = 2},
  [2959] = {.lex_state = 192, .external_lex_state = 2},
  [2960] = {.lex_state = 192, .external_lex_state = 2},
  [2961] = {.lex_state = 192, .external_lex_state = 2},
  [2962] = {.lex_state = 192, .external_lex_state = 2},
  [2963] = {.lex_state = 192, .external_lex_state = 2},
  [2964] = {.lex_state = 192, .external_lex_state = 2},
  [2965] = {.lex_state = 424, .external_lex_state = 3},
  [2966] = {.lex_state = 524, .external_lex_state = 13},
  [2967] = {.lex_state = 424, .external_lex_state = 3},
  [2968] = {.lex_state = 192, .external_lex_state = 29},
  [2969] = {.lex_state = 192, .external_lex_state = 2},
  [2970] = {.lex_state = 421, .external_lex_state = 14},
  [2971] = {.lex_state = 192, .external_lex_state = 2},
  [2972] = {.lex_state = 192, .external_lex_state = 2},
  [2973] = {.lex_state = 192, .external_lex_state = 2},
  [2974] = {.lex_state = 192, .external_lex_state = 2},
  [2975] = {.lex_state = 192, .external_lex_state = 2},
  [2976] = {.lex_state = 528, .external_lex_state = 3},
  [2977] = {.lex_state = 528, .external_lex_state = 3},
  [2978] = {.lex_state = 213},
  [2979] = {.lex_state = 259, .external_lex_state = 3},
  [2980] = {.lex_state = 247, .external_lex_state = 3},
  [2981] = {.lex_state = 262, .external_lex_state = 14},
  [2982] = {.lex_state = 156, .external_lex_state = 3},
  [2983] = {.lex_state = 128},
  [2984] = {.lex_state = 192, .external_lex_state = 2},
  [2985] = {.lex_state = 615, .external_lex_state = 26},
  [2986] = {.lex_state = 615, .external_lex_state = 26},
  [2987] = {.lex_state = 615, .external_lex_state = 26},
  [2988] = {.lex_state = 615, .external_lex_state = 26},
  [2989] = {.lex_state = 192, .external_lex_state = 2},
  [2990] = {.lex_state = 192, .external_lex_state = 2},
  [2991] = {.lex_state = 192, .external_lex_state = 2},
  [2992] = {.lex_state = 508, .external_lex_state = 25},
  [2993] = {.lex_state = 618, .external_lex_state = 26},
  [2994] = {.lex_state = 213},
  [2995] = {.lex_state = 424, .external_lex_state = 25},
  [2996] = {.lex_state = 631, .external_lex_state = 27},
  [2997] = {.lex_state = 508, .external_lex_state = 25},
  [2998] = {.lex_state = 508, .external_lex_state = 25},
  [2999] = {.lex_state = 634, .external_lex_state = 27},
  [3000] = {.lex_state = 192, .external_lex_state = 2},
  [3001] = {.lex_state = 508, .external_lex_state = 25},
  [3002] = {.lex_state = 192, .external_lex_state = 2},
  [3003] = {.lex_state = 192, .external_lex_state = 2},
  [3004] = {.lex_state = 237},
  [3005] = {.lex_state = 192, .external_lex_state = 2},
  [3006] = {.lex_state = 296, .external_lex_state = 26},
  [3007] = {.lex_state = 508, .external_lex_state = 25},
  [3008] = {.lex_state = 508, .external_lex_state = 25},
  [3009] = {.lex_state = 508, .external_lex_state = 25},
  [3010] = {.lex_state = 508, .external_lex_state = 27},
  [3011] = {.lex_state = 508, .external_lex_state = 25},
  [3012] = {.lex_state = 508, .external_lex_state = 25},
  [3013] = {.lex_state = 192, .external_lex_state = 2},
  [3014] = {.lex_state = 192, .external_lex_state = 2},
  [3015] = {.lex_state = 192, .external_lex_state = 2},
  [3016] = {.lex_state = 192, .external_lex_state = 2},
  [3017] = {.lex_state = 192, .external_lex_state = 2},
  [3018] = {.lex_state = 192, .external_lex_state = 2},
  [3019] = {.lex_state = 192, .external_lex_state = 2},
  [3020] = {.lex_state = 192, .external_lex_state = 2},
  [3021] = {.lex_state = 192, .external_lex_state = 2},
  [3022] = {.lex_state = 192, .external_lex_state = 2},
  [3023] = {.lex_state = 192, .external_lex_state = 2},
  [3024] = {.lex_state = 192, .external_lex_state = 2},
  [3025] = {.lex_state = 192, .external_lex_state = 2},
  [3026] = {.lex_state = 192, .external_lex_state = 2},
  [3027] = {.lex_state = 192, .external_lex_state = 2},
  [3028] = {.lex_state = 192, .external_lex_state = 2},
  [3029] = {.lex_state = 237},
  [3030] = {.lex_state = 192, .external_lex_state = 2},
  [3031] = {.lex_state = 304, .external_lex_state = 26},
  [3032] = {.lex_state = 304, .external_lex_state = 26},
  [3033] = {.lex_state = 304, .external_lex_state = 26},
  [3034] = {.lex_state = 304, .external_lex_state = 26},
  [3035] = {.lex_state = 192, .external_lex_state = 2},
  [3036] = {.lex_state = 192, .external_lex_state = 2},
  [3037] = {.lex_state = 192, .external_lex_state = 2},
  [3038] = {.lex_state = 296, .external_lex_state = 26},
  [3039] = {.lex_state = 421, .external_lex_state = 25},
  [3040] = {.lex_state = 421, .external_lex_state = 25},
  [3041] = {.lex_state = 421, .external_lex_state = 25},
  [3042] = {.lex_state = 213},
  [3043] = {.lex_state = 421, .external_lex_state = 25},
  [3044] = {.lex_state = 427, .external_lex_state = 27},
  [3045] = {.lex_state = 340, .external_lex_state = 19},
  [3046] = {.lex_state = 524, .external_lex_state = 13},
  [3047] = {.lex_state = 340, .external_lex_state = 19},
  [3048] = {.lex_state = 192, .external_lex_state = 29},
  [3049] = {.lex_state = 192, .external_lex_state = 2},
  [3050] = {.lex_state = 634, .external_lex_state = 27},
  [3051] = {.lex_state = 247, .external_lex_state = 3},
  [3052] = {.lex_state = 128, .external_lex_state = 2},
  [3053] = {.lex_state = 192, .external_lex_state = 2},
  [3054] = {.lex_state = 511, .external_lex_state = 11},
  [3055] = {.lex_state = 511, .external_lex_state = 11},
  [3056] = {.lex_state = 511, .external_lex_state = 11},
  [3057] = {.lex_state = 511, .external_lex_state = 11},
  [3058] = {.lex_state = 192, .external_lex_state = 2},
  [3059] = {.lex_state = 192, .external_lex_state = 2},
  [3060] = {.lex_state = 192, .external_lex_state = 2},
  [3061] = {.lex_state = 361, .external_lex_state = 3},
  [3062] = {.lex_state = 213},
  [3063] = {.lex_state = 259, .external_lex_state = 3},
  [3064] = {.lex_state = 365, .external_lex_state = 14},
  [3065] = {.lex_state = 361, .external_lex_state = 3},
  [3066] = {.lex_state = 361, .external_lex_state = 3},
  [3067] = {.lex_state = 361, .external_lex_state = 14},
  [3068] = {.lex_state = 192, .external_lex_state = 2},
  [3069] = {.lex_state = 361, .external_lex_state = 3},
  [3070] = {.lex_state = 192, .external_lex_state = 2},
  [3071] = {.lex_state = 192, .external_lex_state = 2},
  [3072] = {.lex_state = 237},
  [3073] = {.lex_state = 192, .external_lex_state = 2},
  [3074] = {.lex_state = 358, .external_lex_state = 11},
  [3075] = {.lex_state = 361, .external_lex_state = 3},
  [3076] = {.lex_state = 361, .external_lex_state = 3},
  [3077] = {.lex_state = 361, .external_lex_state = 3},
  [3078] = {.lex_state = 371, .external_lex_state = 14},
  [3079] = {.lex_state = 361, .external_lex_state = 3},
  [3080] = {.lex_state = 361, .external_lex_state = 3},
  [3081] = {.lex_state = 192, .external_lex_state = 2},
  [3082] = {.lex_state = 192, .external_lex_state = 2},
  [3083] = {.lex_state = 192, .external_lex_state = 2},
  [3084] = {.lex_state = 192, .external_lex_state = 2},
  [3085] = {.lex_state = 192, .external_lex_state = 2},
  [3086] = {.lex_state = 192, .external_lex_state = 2},
  [3087] = {.lex_state = 192, .external_lex_state = 2},
  [3088] = {.lex_state = 192, .external_lex_state = 2},
  [3089] = {.lex_state = 192, .external_lex_state = 2},
  [3090] = {.lex_state = 192, .external_lex_state = 2},
  [3091] = {.lex_state = 192, .external_lex_state = 2},
  [3092] = {.lex_state = 192, .external_lex_state = 2},
  [3093] = {.lex_state = 192, .external_lex_state = 2},
  [3094] = {.lex_state = 262, .external_lex_state = 3},
  [3095] = {.lex_state = 524, .external_lex_state = 13},
  [3096] = {.lex_state = 361, .external_lex_state = 3},
  [3097] = {.lex_state = 192, .external_lex_state = 29},
  [3098] = {.lex_state = 192, .external_lex_state = 2},
  [3099] = {.lex_state = 361, .external_lex_state = 14},
  [3100] = {.lex_state = 247, .external_lex_state = 3},
  [3101] = {.lex_state = 247, .external_lex_state = 3},
  [3102] = {.lex_state = 247, .external_lex_state = 3},
  [3103] = {.lex_state = 247, .external_lex_state = 3},
  [3104] = {.lex_state = 247, .external_lex_state = 3},
  [3105] = {.lex_state = 247, .external_lex_state = 3},
  [3106] = {.lex_state = 554, .external_lex_state = 16},
  [3107] = {.lex_state = 247, .external_lex_state = 3},
  [3108] = {.lex_state = 247, .external_lex_state = 3},
  [3109] = {.lex_state = 247, .external_lex_state = 3},
  [3110] = {.lex_state = 247, .external_lex_state = 3},
  [3111] = {.lex_state = 247, .external_lex_state = 3},
  [3112] = {.lex_state = 128},
  [3113] = {.lex_state = 128},
  [3114] = {.lex_state = 192, .external_lex_state = 2},
  [3115] = {.lex_state = 192, .external_lex_state = 2},
  [3116] = {.lex_state = 192, .external_lex_state = 2},
  [3117] = {.lex_state = 192, .external_lex_state = 2},
  [3118] = {.lex_state = 192, .external_lex_state = 2},
  [3119] = {.lex_state = 528, .external_lex_state = 3},
  [3120] = {.lex_state = 528, .external_lex_state = 3},
  [3121] = {.lex_state = 213},
  [3122] = {.lex_state = 259, .external_lex_state = 3},
  [3123] = {.lex_state = 247, .external_lex_state = 3},
  [3124] = {.lex_state = 262, .external_lex_state = 14},
  [3125] = {.lex_state = 192, .external_lex_state = 2},
  [3126] = {.lex_state = 192, .external_lex_state = 2},
  [3127] = {.lex_state = 511, .external_lex_state = 11},
  [3128] = {.lex_state = 511, .external_lex_state = 11},
  [3129] = {.lex_state = 511, .external_lex_state = 11},
  [3130] = {.lex_state = 511, .external_lex_state = 11},
  [3131] = {.lex_state = 192, .external_lex_state = 2},
  [3132] = {.lex_state = 192, .external_lex_state = 2},
  [3133] = {.lex_state = 192, .external_lex_state = 2},
  [3134] = {.lex_state = 254, .external_lex_state = 8},
  [3135] = {.lex_state = 528, .external_lex_state = 3},
  [3136] = {.lex_state = 254, .external_lex_state = 11},
  [3137] = {.lex_state = 254, .external_lex_state = 8},
  [3138] = {.lex_state = 213},
  [3139] = {.lex_state = 259, .external_lex_state = 3},
  [3140] = {.lex_state = 365, .external_lex_state = 14},
  [3141] = {.lex_state = 156, .external_lex_state = 3},
  [3142] = {.lex_state = 128},
  [3143] = {.lex_state = 526, .external_lex_state = 2},
  [3144] = {.lex_state = 192, .external_lex_state = 2},
  [3145] = {.lex_state = 511, .external_lex_state = 11},
  [3146] = {.lex_state = 511, .external_lex_state = 11},
  [3147] = {.lex_state = 511, .external_lex_state = 11},
  [3148] = {.lex_state = 511, .external_lex_state = 11},
  [3149] = {.lex_state = 192, .external_lex_state = 2},
  [3150] = {.lex_state = 192, .external_lex_state = 2},
  [3151] = {.lex_state = 192, .external_lex_state = 2},
  [3152] = {.lex_state = 361, .external_lex_state = 3},
  [3153] = {.lex_state = 213},
  [3154] = {.lex_state = 259, .external_lex_state = 3},
  [3155] = {.lex_state = 365, .external_lex_state = 14},
  [3156] = {.lex_state = 361, .external_lex_state = 3},
  [3157] = {.lex_state = 361, .external_lex_state = 3},
  [3158] = {.lex_state = 361, .external_lex_state = 14},
  [3159] = {.lex_state = 192, .external_lex_state = 2},
  [3160] = {.lex_state = 361, .external_lex_state = 3},
  [3161] = {.lex_state = 192, .external_lex_state = 2},
  [3162] = {.lex_state = 192, .external_lex_state = 2},
  [3163] = {.lex_state = 237},
  [3164] = {.lex_state = 192, .external_lex_state = 2},
  [3165] = {.lex_state = 358, .external_lex_state = 11},
  [3166] = {.lex_state = 361, .external_lex_state = 3},
  [3167] = {.lex_state = 361, .external_lex_state = 3},
  [3168] = {.lex_state = 361, .external_lex_state = 3},
  [3169] = {.lex_state = 371, .external_lex_state = 14},
  [3170] = {.lex_state = 361, .external_lex_state = 3},
  [3171] = {.lex_state = 361, .external_lex_state = 3},
  [3172] = {.lex_state = 192, .external_lex_state = 2},
  [3173] = {.lex_state = 192, .external_lex_state = 2},
  [3174] = {.lex_state = 192, .external_lex_state = 2},
  [3175] = {.lex_state = 192, .external_lex_state = 2},
  [3176] = {.lex_state = 192, .external_lex_state = 2},
  [3177] = {.lex_state = 192, .external_lex_state = 2},
  [3178] = {.lex_state = 192, .external_lex_state = 2},
  [3179] = {.lex_state = 192, .external_lex_state = 2},
  [3180] = {.lex_state = 192, .external_lex_state = 2},
  [3181] = {.lex_state = 192, .external_lex_state = 2},
  [3182] = {.lex_state = 192, .external_lex_state = 2},
  [3183] = {.lex_state = 192, .external_lex_state = 2},
  [3184] = {.lex_state = 192, .external_lex_state = 2},
  [3185] = {.lex_state = 192, .external_lex_state = 2},
  [3186] = {.lex_state = 192, .external_lex_state = 2},
  [3187] = {.lex_state = 237},
  [3188] = {.lex_state = 192, .external_lex_state = 2},
  [3189] = {.lex_state = 358, .external_lex_state = 11},
  [3190] = {.lex_state = 421, .external_lex_state = 3},
  [3191] = {.lex_state = 421, .external_lex_state = 3},
  [3192] = {.lex_state = 421, .external_lex_state = 3},
  [3193] = {.lex_state = 427, .external_lex_state = 14},
  [3194] = {.lex_state = 262, .external_lex_state = 3},
  [3195] = {.lex_state = 524, .external_lex_state = 13},
  [3196] = {.lex_state = 361, .external_lex_state = 3},
  [3197] = {.lex_state = 192, .external_lex_state = 29},
  [3198] = {.lex_state = 192, .external_lex_state = 2},
  [3199] = {.lex_state = 361, .external_lex_state = 14},
  [3200] = {.lex_state = 528, .external_lex_state = 3},
  [3201] = {.lex_state = 528, .external_lex_state = 3},
  [3202] = {.lex_state = 192, .external_lex_state = 2},
  [3203] = {.lex_state = 192, .external_lex_state = 2},
  [3204] = {.lex_state = 192, .external_lex_state = 2},
  [3205] = {.lex_state = 237},
  [3206] = {.lex_state = 192, .external_lex_state = 2},
  [3207] = {.lex_state = 192, .external_lex_state = 2},
  [3208] = {.lex_state = 192, .external_lex_state = 2},
  [3209] = {.lex_state = 192, .external_lex_state = 2},
  [3210] = {.lex_state = 358, .external_lex_state = 11},
  [3211] = {.lex_state = 361, .external_lex_state = 3},
  [3212] = {.lex_state = 361, .external_lex_state = 3},
  [3213] = {.lex_state = 361, .external_lex_state = 3},
  [3214] = {.lex_state = 213},
  [3215] = {.lex_state = 368, .external_lex_state = 3},
  [3216] = {.lex_state = 371, .external_lex_state = 14},
  [3217] = {.lex_state = 343, .external_lex_state = 8},
  [3218] = {.lex_state = 343, .external_lex_state = 8},
  [3219] = {.lex_state = 343, .external_lex_state = 8},
  [3220] = {.lex_state = 330},
  [3221] = {.lex_state = 350, .external_lex_state = 23},
  [3222] = {.lex_state = 343, .external_lex_state = 8},
  [3223] = {.lex_state = 528, .external_lex_state = 3},
  [3224] = {.lex_state = 528, .external_lex_state = 3},
  [3225] = {.lex_state = 128},
  [3226] = {.lex_state = 128},
  [3227] = {.lex_state = 128, .external_lex_state = 2},
  [3228] = {.lex_state = 128, .external_lex_state = 8},
  [3229] = {.lex_state = 192, .external_lex_state = 2},
  [3230] = {.lex_state = 192, .external_lex_state = 2},
  [3231] = {.lex_state = 192, .external_lex_state = 2},
  [3232] = {.lex_state = 192, .external_lex_state = 2},
  [3233] = {.lex_state = 192, .external_lex_state = 2},
  [3234] = {.lex_state = 192, .external_lex_state = 2},
  [3235] = {.lex_state = 192, .external_lex_state = 2},
  [3236] = {.lex_state = 192, .external_lex_state = 2},
  [3237] = {.lex_state = 192, .external_lex_state = 2},
  [3238] = {.lex_state = 192, .external_lex_state = 2},
  [3239] = {.lex_state = 192, .external_lex_state = 2},
  [3240] = {.lex_state = 192, .external_lex_state = 2},
  [3241] = {.lex_state = 192, .external_lex_state = 2},
  [3242] = {.lex_state = 192, .external_lex_state = 2},
  [3243] = {.lex_state = 192, .external_lex_state = 2},
  [3244] = {.lex_state = 237},
  [3245] = {.lex_state = 192, .external_lex_state = 2},
  [3246] = {.lex_state = 364, .external_lex_state = 11},
  [3247] = {.lex_state = 364, .external_lex_state = 11},
  [3248] = {.lex_state = 364, .external_lex_state = 11},
  [3249] = {.lex_state = 364, .external_lex_state = 11},
  [3250] = {.lex_state = 192, .external_lex_state = 2},
  [3251] = {.lex_state = 192, .external_lex_state = 2},
  [3252] = {.lex_state = 192, .external_lex_state = 2},
  [3253] = {.lex_state = 358, .external_lex_state = 11},
  [3254] = {.lex_state = 421, .external_lex_state = 3},
  [3255] = {.lex_state = 364, .external_lex_state = 11},
  [3256] = {.lex_state = 421, .external_lex_state = 3},
  [3257] = {.lex_state = 421, .external_lex_state = 3},
  [3258] = {.lex_state = 213},
  [3259] = {.lex_state = 421, .external_lex_state = 3},
  [3260] = {.lex_state = 427, .external_lex_state = 14},
  [3261] = {.lex_state = 192, .external_lex_state = 29},
  [3262] = {.lex_state = 353, .external_lex_state = 8},
  [3263] = {.lex_state = 192, .external_lex_state = 29},
  [3264] = {.lex_state = 192, .external_lex_state = 2},
  [3265] = {.lex_state = 361, .external_lex_state = 14},
  [3266] = {.lex_state = 247, .external_lex_state = 3},
  [3267] = {.lex_state = 192, .external_lex_state = 2},
  [3268] = {.lex_state = 192, .external_lex_state = 2},
  [3269] = {.lex_state = 192, .external_lex_state = 2},
  [3270] = {.lex_state = 237},
  [3271] = {.lex_state = 192, .external_lex_state = 2},
  [3272] = {.lex_state = 353, .external_lex_state = 11},
  [3273] = {.lex_state = 353, .external_lex_state = 11},
  [3274] = {.lex_state = 353, .external_lex_state = 11},
  [3275] = {.lex_state = 353, .external_lex_state = 11},
  [3276] = {.lex_state = 192, .external_lex_state = 2},
  [3277] = {.lex_state = 192, .external_lex_state = 2},
  [3278] = {.lex_state = 192, .external_lex_state = 2},
  [3279] = {.lex_state = 358, .external_lex_state = 11},
  [3280] = {.lex_state = 361, .external_lex_state = 3},
  [3281] = {.lex_state = 364, .external_lex_state = 11},
  [3282] = {.lex_state = 262, .external_lex_state = 3},
  [3283] = {.lex_state = 361, .external_lex_state = 3},
  [3284] = {.lex_state = 213},
  [3285] = {.lex_state = 368, .external_lex_state = 3},
  [3286] = {.lex_state = 371, .external_lex_state = 14},
  [3287] = {.lex_state = 247, .external_lex_state = 3},
  [3288] = {.lex_state = 247, .external_lex_state = 3},
  [3289] = {.lex_state = 254, .external_lex_state = 8},
  [3290] = {.lex_state = 128, .external_lex_state = 2},
  [3291] = {.lex_state = 128, .external_lex_state = 8},
  [3292] = {.lex_state = 192, .external_lex_state = 2},
  [3293] = {.lex_state = 192, .external_lex_state = 2},
  [3294] = {.lex_state = 192, .external_lex_state = 2},
  [3295] = {.lex_state = 192, .external_lex_state = 2},
  [3296] = {.lex_state = 192, .external_lex_state = 2},
  [3297] = {.lex_state = 192, .external_lex_state = 2},
  [3298] = {.lex_state = 192, .external_lex_state = 2},
  [3299] = {.lex_state = 192, .external_lex_state = 2},
  [3300] = {.lex_state = 192, .external_lex_state = 2},
  [3301] = {.lex_state = 192, .external_lex_state = 2},
  [3302] = {.lex_state = 192, .external_lex_state = 2},
  [3303] = {.lex_state = 192, .external_lex_state = 2},
  [3304] = {.lex_state = 192, .external_lex_state = 2},
  [3305] = {.lex_state = 192, .external_lex_state = 2},
  [3306] = {.lex_state = 192, .external_lex_state = 2},
  [3307] = {.lex_state = 192, .external_lex_state = 2},
  [3308] = {.lex_state = 192, .external_lex_state = 2},
  [3309] = {.lex_state = 192, .external_lex_state = 2},
  [3310] = {.lex_state = 192, .external_lex_state = 2},
  [3311] = {.lex_state = 192, .external_lex_state = 2},
  [3312] = {.lex_state = 237},
  [3313] = {.lex_state = 192, .external_lex_state = 2},
  [3314] = {.lex_state = 364, .external_lex_state = 11},
  [3315] = {.lex_state = 364, .external_lex_state = 11},
  [3316] = {.lex_state = 364, .external_lex_state = 11},
  [3317] = {.lex_state = 364, .external_lex_state = 11},
  [3318] = {.lex_state = 192, .external_lex_state = 2},
  [3319] = {.lex_state = 192, .external_lex_state = 2},
  [3320] = {.lex_state = 192, .external_lex_state = 2},
  [3321] = {.lex_state = 358, .external_lex_state = 11},
  [3322] = {.lex_state = 421, .external_lex_state = 3},
  [3323] = {.lex_state = 364, .external_lex_state = 11},
  [3324] = {.lex_state = 424, .external_lex_state = 3},
  [3325] = {.lex_state = 424, .external_lex_state = 3},
  [3326] = {.lex_state = 213},
  [3327] = {.lex_state = 421, .external_lex_state = 3},
  [3328] = {.lex_state = 427, .external_lex_state = 14},
  [3329] = {.lex_state = 192, .external_lex_state = 29},
  [3330] = {.lex_state = 192, .external_lex_state = 2},
  [3331] = {.lex_state = 262, .external_lex_state = 14},
  [3332] = {.lex_state = 128},
  [3333] = {.lex_state = 247, .external_lex_state = 3},
  [3334] = {.lex_state = 192, .external_lex_state = 2},
  [3335] = {.lex_state = 192, .external_lex_state = 2},
  [3336] = {.lex_state = 192, .external_lex_state = 2},
  [3337] = {.lex_state = 237},
  [3338] = {.lex_state = 192, .external_lex_state = 2},
  [3339] = {.lex_state = 353, .external_lex_state = 11},
  [3340] = {.lex_state = 353, .external_lex_state = 11},
  [3341] = {.lex_state = 353, .external_lex_state = 11},
  [3342] = {.lex_state = 353, .external_lex_state = 11},
  [3343] = {.lex_state = 192, .external_lex_state = 2},
  [3344] = {.lex_state = 192, .external_lex_state = 2},
  [3345] = {.lex_state = 192, .external_lex_state = 2},
  [3346] = {.lex_state = 358, .external_lex_state = 11},
  [3347] = {.lex_state = 361, .external_lex_state = 3},
  [3348] = {.lex_state = 364, .external_lex_state = 11},
  [3349] = {.lex_state = 262, .external_lex_state = 3},
  [3350] = {.lex_state = 361, .external_lex_state = 3},
  [3351] = {.lex_state = 213},
  [3352] = {.lex_state = 368, .external_lex_state = 3},
  [3353] = {.lex_state = 371, .external_lex_state = 14},
  [3354] = {.lex_state = 247, .external_lex_state = 3},
  [3355] = {.lex_state = 247, .external_lex_state = 3},
  [3356] = {.lex_state = 254, .external_lex_state = 8},
  [3357] = {.lex_state = 128, .external_lex_state = 2},
  [3358] = {.lex_state = 128, .external_lex_state = 8},
  [3359] = {.lex_state = 192, .external_lex_state = 2},
  [3360] = {.lex_state = 192, .external_lex_state = 2},
  [3361] = {.lex_state = 192, .external_lex_state = 2},
  [3362] = {.lex_state = 192, .external_lex_state = 2},
  [3363] = {.lex_state = 192, .external_lex_state = 2},
  [3364] = {.lex_state = 192, .external_lex_state = 2},
  [3365] = {.lex_state = 192, .external_lex_state = 2},
  [3366] = {.lex_state = 192, .external_lex_state = 2},
  [3367] = {.lex_state = 192, .external_lex_state = 2},
  [3368] = {.lex_state = 192, .external_lex_state = 2},
  [3369] = {.lex_state = 192, .external_lex_state = 2},
  [3370] = {.lex_state = 192, .external_lex_state = 2},
  [3371] = {.lex_state = 192, .external_lex_state = 2},
  [3372] = {.lex_state = 192, .external_lex_state = 2},
  [3373] = {.lex_state = 192, .external_lex_state = 2},
  [3374] = {.lex_state = 192, .external_lex_state = 2},
  [3375] = {.lex_state = 192, .external_lex_state = 2},
  [3376] = {.lex_state = 192, .external_lex_state = 2},
  [3377] = {.lex_state = 192, .external_lex_state = 2},
  [3378] = {.lex_state = 192, .external_lex_state = 2},
  [3379] = {.lex_state = 237},
  [3380] = {.lex_state = 192, .external_lex_state = 2},
  [3381] = {.lex_state = 364, .external_lex_state = 11},
  [3382] = {.lex_state = 364, .external_lex_state = 11},
  [3383] = {.lex_state = 364, .external_lex_state = 11},
  [3384] = {.lex_state = 364, .external_lex_state = 11},
  [3385] = {.lex_state = 192, .external_lex_state = 2},
  [3386] = {.lex_state = 192, .external_lex_state = 2},
  [3387] = {.lex_state = 192, .external_lex_state = 2},
  [3388] = {.lex_state = 358, .external_lex_state = 11},
  [3389] = {.lex_state = 421, .external_lex_state = 3},
  [3390] = {.lex_state = 364, .external_lex_state = 11},
  [3391] = {.lex_state = 424, .external_lex_state = 3},
  [3392] = {.lex_state = 424, .external_lex_state = 3},
  [3393] = {.lex_state = 213},
  [3394] = {.lex_state = 421, .external_lex_state = 3},
  [3395] = {.lex_state = 427, .external_lex_state = 14},
  [3396] = {.lex_state = 192, .external_lex_state = 29},
  [3397] = {.lex_state = 192, .external_lex_state = 2},
  [3398] = {.lex_state = 262, .external_lex_state = 14},
  [3399] = {.lex_state = 254, .external_lex_state = 8},
  [3400] = {.lex_state = 156, .external_lex_state = 3},
  [3401] = {.lex_state = 128},
  [3402] = {.lex_state = 128},
  [3403] = {.lex_state = 128, .external_lex_state = 2},
  [3404] = {.lex_state = 128, .external_lex_state = 8},
  [3405] = {.lex_state = 247, .external_lex_state = 3},
  [3406] = {.lex_state = 247, .external_lex_state = 3},
  [3407] = {.lex_state = 247, .external_lex_state = 3},
  [3408] = {.lex_state = 247, .external_lex_state = 3},
  [3409] = {.lex_state = 247, .external_lex_state = 3},
  [3410] = {.lex_state = 247, .external_lex_state = 3},
  [3411] = {.lex_state = 247, .external_lex_state = 3},
  [3412] = {.lex_state = 247, .external_lex_state = 3},
  [3413] = {.lex_state = 247, .external_lex_state = 3},
  [3414] = {.lex_state = 247, .external_lex_state = 3},
  [3415] = {.lex_state = 247, .external_lex_state = 3},
  [3416] = {.lex_state = 554, .external_lex_state = 16},
  [3417] = {.lex_state = 247, .external_lex_state = 3},
  [3418] = {.lex_state = 247, .external_lex_state = 3},
  [3419] = {.lex_state = 247, .external_lex_state = 3},
  [3420] = {.lex_state = 247, .external_lex_state = 3},
  [3421] = {.lex_state = 247, .external_lex_state = 3},
  [3422] = {.lex_state = 192, .external_lex_state = 2},
  [3423] = {.lex_state = 254, .external_lex_state = 11},
  [3424] = {.lex_state = 254, .external_lex_state = 11},
  [3425] = {.lex_state = 254, .external_lex_state = 11},
  [3426] = {.lex_state = 254, .external_lex_state = 11},
  [3427] = {.lex_state = 192, .external_lex_state = 2},
  [3428] = {.lex_state = 192, .external_lex_state = 2},
  [3429] = {.lex_state = 192, .external_lex_state = 2},
  [3430] = {.lex_state = 424, .external_lex_state = 3},
  [3431] = {.lex_state = 254, .external_lex_state = 11},
  [3432] = {.lex_state = 213},
  [3433] = {.lex_state = 424, .external_lex_state = 3},
  [3434] = {.lex_state = 424, .external_lex_state = 14},
  [3435] = {.lex_state = 424, .external_lex_state = 3},
  [3436] = {.lex_state = 421, .external_lex_state = 3},
  [3437] = {.lex_state = 421, .external_lex_state = 14},
  [3438] = {.lex_state = 192, .external_lex_state = 2},
  [3439] = {.lex_state = 424, .external_lex_state = 3},
  [3440] = {.lex_state = 421, .external_lex_state = 3},
  [3441] = {.lex_state = 421, .external_lex_state = 3},
  [3442] = {.lex_state = 192, .external_lex_state = 2},
  [3443] = {.lex_state = 192, .external_lex_state = 2},
  [3444] = {.lex_state = 192, .external_lex_state = 2},
  [3445] = {.lex_state = 192, .external_lex_state = 2},
  [3446] = {.lex_state = 192, .external_lex_state = 2},
  [3447] = {.lex_state = 192, .external_lex_state = 2},
  [3448] = {.lex_state = 192, .external_lex_state = 2},
  [3449] = {.lex_state = 192, .external_lex_state = 2},
  [3450] = {.lex_state = 192, .external_lex_state = 2},
  [3451] = {.lex_state = 192, .external_lex_state = 2},
  [3452] = {.lex_state = 192, .external_lex_state = 2},
  [3453] = {.lex_state = 192, .external_lex_state = 2},
  [3454] = {.lex_state = 192, .external_lex_state = 2},
  [3455] = {.lex_state = 424, .external_lex_state = 3},
  [3456] = {.lex_state = 524, .external_lex_state = 13},
  [3457] = {.lex_state = 424, .external_lex_state = 3},
  [3458] = {.lex_state = 192, .external_lex_state = 29},
  [3459] = {.lex_state = 192, .external_lex_state = 2},
  [3460] = {.lex_state = 421, .external_lex_state = 14},
  [3461] = {.lex_state = 192, .external_lex_state = 2},
  [3462] = {.lex_state = 192, .external_lex_state = 2},
  [3463] = {.lex_state = 192, .external_lex_state = 2},
  [3464] = {.lex_state = 192, .external_lex_state = 2},
  [3465] = {.lex_state = 192, .external_lex_state = 2},
  [3466] = {.lex_state = 528, .external_lex_state = 3},
  [3467] = {.lex_state = 528, .external_lex_state = 3},
  [3468] = {.lex_state = 213},
  [3469] = {.lex_state = 259, .external_lex_state = 3},
  [3470] = {.lex_state = 247, .external_lex_state = 3},
  [3471] = {.lex_state = 262, .external_lex_state = 14},
  [3472] = {.lex_state = 638, .external_lex_state = 8},
  [3473] = {.lex_state = 384, .external_lex_state = 8},
  [3474] = {.lex_state = 225, .external_lex_state = 7},
  [3475] = {.lex_state = 530, .external_lex_state = 27},
  [3476] = {.lex_state = 388, .external_lex_state = 25},
  [3477] = {.lex_state = 388, .external_lex_state = 25},
  [3478] = {.lex_state = 388, .external_lex_state = 25},
  [3479] = {.lex_state = 388, .external_lex_state = 25},
  [3480] = {.lex_state = 192, .external_lex_state = 15},
  [3481] = {.lex_state = 266, .external_lex_state = 15},
  [3482] = {.lex_state = 388, .external_lex_state = 25},
  [3483] = {.lex_state = 177, .external_lex_state = 4},
  [3484] = {.lex_state = 266, .external_lex_state = 15},
  [3485] = {.lex_state = 388, .external_lex_state = 25},
  [3486] = {.lex_state = 192, .external_lex_state = 15},
  [3487] = {.lex_state = 266, .external_lex_state = 15},
  [3488] = {.lex_state = 388, .external_lex_state = 25},
  [3489] = {.lex_state = 177, .external_lex_state = 4},
  [3490] = {.lex_state = 266, .external_lex_state = 15},
  [3491] = {.lex_state = 400, .external_lex_state = 25},
  [3492] = {.lex_state = 192, .external_lex_state = 2},
  [3493] = {.lex_state = 192, .external_lex_state = 2},
  [3494] = {.lex_state = 237},
  [3495] = {.lex_state = 192, .external_lex_state = 2},
  [3496] = {.lex_state = 394, .external_lex_state = 26},
  [3497] = {.lex_state = 406, .external_lex_state = 25},
  [3498] = {.lex_state = 406, .external_lex_state = 25},
  [3499] = {.lex_state = 406, .external_lex_state = 25},
  [3500] = {.lex_state = 406, .external_lex_state = 27},
  [3501] = {.lex_state = 400, .external_lex_state = 25},
  [3502] = {.lex_state = 400, .external_lex_state = 25},
  [3503] = {.lex_state = 192, .external_lex_state = 2},
  [3504] = {.lex_state = 192, .external_lex_state = 2},
  [3505] = {.lex_state = 192, .external_lex_state = 2},
  [3506] = {.lex_state = 192, .external_lex_state = 2},
  [3507] = {.lex_state = 192, .external_lex_state = 2},
  [3508] = {.lex_state = 192, .external_lex_state = 2},
  [3509] = {.lex_state = 192, .external_lex_state = 2},
  [3510] = {.lex_state = 192, .external_lex_state = 2},
  [3511] = {.lex_state = 192, .external_lex_state = 2},
  [3512] = {.lex_state = 192, .external_lex_state = 2},
  [3513] = {.lex_state = 192, .external_lex_state = 2},
  [3514] = {.lex_state = 192, .external_lex_state = 2},
  [3515] = {.lex_state = 192, .external_lex_state = 2},
  [3516] = {.lex_state = 192, .external_lex_state = 2},
  [3517] = {.lex_state = 237},
  [3518] = {.lex_state = 192, .external_lex_state = 2},
  [3519] = {.lex_state = 394, .external_lex_state = 26},
  [3520] = {.lex_state = 403, .external_lex_state = 25},
  [3521] = {.lex_state = 537, .external_lex_state = 25},
  [3522] = {.lex_state = 537, .external_lex_state = 25},
  [3523] = {.lex_state = 403, .external_lex_state = 27},
  [3524] = {.lex_state = 192, .external_lex_state = 29},
  [3525] = {.lex_state = 192, .external_lex_state = 2},
  [3526] = {.lex_state = 540, .external_lex_state = 27},
  [3527] = {.lex_state = 400, .external_lex_state = 25},
  [3528] = {.lex_state = 388, .external_lex_state = 25},
  [3529] = {.lex_state = 194},
  [3530] = {.lex_state = 302, .external_lex_state = 16},
  [3531] = {.lex_state = 225, .external_lex_state = 7},
  [3532] = {.lex_state = 128, .external_lex_state = 2},
  [3533] = {.lex_state = 388, .external_lex_state = 25},
  [3534] = {.lex_state = 247, .external_lex_state = 3},
  [3535] = {.lex_state = 128, .external_lex_state = 8},
  [3536] = {.lex_state = 128, .external_lex_state = 2},
  [3537] = {.lex_state = 388, .external_lex_state = 25},
  [3538] = {.lex_state = 128, .external_lex_state = 2},
  [3539] = {.lex_state = 406, .external_lex_state = 25},
  [3540] = {.lex_state = 406, .external_lex_state = 25},
  [3541] = {.lex_state = 406, .external_lex_state = 25},
  [3542] = {.lex_state = 192, .external_lex_state = 2},
  [3543] = {.lex_state = 406, .external_lex_state = 25},
  [3544] = {.lex_state = 406, .external_lex_state = 25},
  [3545] = {.lex_state = 406, .external_lex_state = 25},
  [3546] = {.lex_state = 192, .external_lex_state = 2},
  [3547] = {.lex_state = 192, .external_lex_state = 2},
  [3548] = {.lex_state = 192, .external_lex_state = 2},
  [3549] = {.lex_state = 192, .external_lex_state = 2},
  [3550] = {.lex_state = 192, .external_lex_state = 2},
  [3551] = {.lex_state = 192, .external_lex_state = 2},
  [3552] = {.lex_state = 192, .external_lex_state = 2},
  [3553] = {.lex_state = 192, .external_lex_state = 2},
  [3554] = {.lex_state = 192, .external_lex_state = 2},
  [3555] = {.lex_state = 192, .external_lex_state = 2},
  [3556] = {.lex_state = 192, .external_lex_state = 2},
  [3557] = {.lex_state = 192, .external_lex_state = 2},
  [3558] = {.lex_state = 192, .external_lex_state = 2},
  [3559] = {.lex_state = 406, .external_lex_state = 25},
  [3560] = {.lex_state = 524, .external_lex_state = 13},
  [3561] = {.lex_state = 406, .external_lex_state = 25},
  [3562] = {.lex_state = 192, .external_lex_state = 29},
  [3563] = {.lex_state = 192, .external_lex_state = 2},
  [3564] = {.lex_state = 128, .external_lex_state = 12},
  [3565] = {.lex_state = 128, .external_lex_state = 2},
  [3566] = {.lex_state = 128, .external_lex_state = 2},
  [3567] = {.lex_state = 128, .external_lex_state = 2},
  [3568] = {.lex_state = 128, .external_lex_state = 8},
  [3569] = {.lex_state = 128},
  [3570] = {.lex_state = 128},
  [3571] = {.lex_state = 128},
  [3572] = {.lex_state = 388, .external_lex_state = 25},
  [3573] = {.lex_state = 128},
  [3574] = {.lex_state = 128},
  [3575] = {.lex_state = 128},
  [3576] = {.lex_state = 388, .external_lex_state = 25},
  [3577] = {.lex_state = 388, .external_lex_state = 25},
  [3578] = {.lex_state = 235},
  [3579] = {.lex_state = 388, .external_lex_state = 25},
  [3580] = {.lex_state = 194},
  [3581] = {.lex_state = 286, .external_lex_state = 2},
  [3582] = {.lex_state = 388, .external_lex_state = 25},
  [3583] = {.lex_state = 128},
  [3584] = {.lex_state = 128, .external_lex_state = 12},
  [3585] = {.lex_state = 414, .external_lex_state = 2},
  [3586] = {.lex_state = 388, .external_lex_state = 25},
  [3587] = {.lex_state = 400, .external_lex_state = 25},
  [3588] = {.lex_state = 400, .external_lex_state = 25},
  [3589] = {.lex_state = 400, .external_lex_state = 25},
  [3590] = {.lex_state = 400, .external_lex_state = 25},
  [3591] = {.lex_state = 400, .external_lex_state = 25},
  [3592] = {.lex_state = 400, .external_lex_state = 25},
  [3593] = {.lex_state = 400, .external_lex_state = 25},
  [3594] = {.lex_state = 554, .external_lex_state = 16},
  [3595] = {.lex_state = 400, .external_lex_state = 25},
  [3596] = {.lex_state = 400, .external_lex_state = 25},
  [3597] = {.lex_state = 400, .external_lex_state = 25},
  [3598] = {.lex_state = 400, .external_lex_state = 25},
  [3599] = {.lex_state = 400, .external_lex_state = 25},
  [3600] = {.lex_state = 544, .external_lex_state = 26},
  [3601] = {.lex_state = 356, .external_lex_state = 13},
  [3602] = {.lex_state = 544, .external_lex_state = 26},
  [3603] = {.lex_state = 544, .external_lex_state = 26},
  [3604] = {.lex_state = 416, .external_lex_state = 28},
  [3605] = {.lex_state = 397, .external_lex_state = 25},
  [3606] = {.lex_state = 235, .external_lex_state = 19},
  [3607] = {.lex_state = 235},
  [3608] = {.lex_state = 544, .external_lex_state = 26},
  [3609] = {.lex_state = 403, .external_lex_state = 25},
  [3610] = {.lex_state = 640, .external_lex_state = 27},
  [3611] = {.lex_state = 403, .external_lex_state = 25},
  [3612] = {.lex_state = 403, .external_lex_state = 25},
  [3613] = {.lex_state = 192, .external_lex_state = 2},
  [3614] = {.lex_state = 397, .external_lex_state = 25},
  [3615] = {.lex_state = 194},
  [3616] = {.lex_state = 286, .external_lex_state = 2},
  [3617] = {.lex_state = 403, .external_lex_state = 25},
  [3618] = {.lex_state = 397, .external_lex_state = 25},
  [3619] = {.lex_state = 128},
  [3620] = {.lex_state = 128, .external_lex_state = 12},
  [3621] = {.lex_state = 414, .external_lex_state = 2},
  [3622] = {.lex_state = 403, .external_lex_state = 25},
  [3623] = {.lex_state = 403, .external_lex_state = 25},
  [3624] = {.lex_state = 192, .external_lex_state = 2},
  [3625] = {.lex_state = 192, .external_lex_state = 2},
  [3626] = {.lex_state = 192, .external_lex_state = 2},
  [3627] = {.lex_state = 192, .external_lex_state = 2},
  [3628] = {.lex_state = 192, .external_lex_state = 2},
  [3629] = {.lex_state = 192, .external_lex_state = 2},
  [3630] = {.lex_state = 192, .external_lex_state = 2},
  [3631] = {.lex_state = 192, .external_lex_state = 2},
  [3632] = {.lex_state = 192, .external_lex_state = 2},
  [3633] = {.lex_state = 192, .external_lex_state = 2},
  [3634] = {.lex_state = 192, .external_lex_state = 2},
  [3635] = {.lex_state = 192, .external_lex_state = 2},
  [3636] = {.lex_state = 192, .external_lex_state = 2},
  [3637] = {.lex_state = 397, .external_lex_state = 25},
  [3638] = {.lex_state = 403, .external_lex_state = 25},
  [3639] = {.lex_state = 524, .external_lex_state = 13},
  [3640] = {.lex_state = 403, .external_lex_state = 25},
  [3641] = {.lex_state = 192, .external_lex_state = 29},
  [3642] = {.lex_state = 192, .external_lex_state = 2},
  [3643] = {.lex_state = 640, .external_lex_state = 27},
  [3644] = {.lex_state = 156, .external_lex_state = 3},
  [3645] = {.lex_state = 177, .external_lex_state = 17},
  [3646] = {.lex_state = 641, .external_lex_state = 19},
  [3647] = {.lex_state = 235, .external_lex_state = 13},
  [3648] = {.lex_state = 192, .external_lex_state = 2},
  [3649] = {.lex_state = 400, .external_lex_state = 25},
  [3650] = {.lex_state = 547, .external_lex_state = 25},
  [3651] = {.lex_state = 400, .external_lex_state = 25},
  [3652] = {.lex_state = 400, .external_lex_state = 25},
  [3653] = {.lex_state = 543, .external_lex_state = 27},
  [3654] = {.lex_state = 237},
  [3655] = {.lex_state = 286, .external_lex_state = 2},
  [3656] = {.lex_state = 128},
  [3657] = {.lex_state = 237},
  [3658] = {.lex_state = 237},
  [3659] = {.lex_state = 156, .external_lex_state = 3},
  [3660] = {.lex_state = 194},
  [3661] = {.lex_state = 302},
  [3662] = {.lex_state = 643, .external_lex_state = 2},
  [3663] = {.lex_state = 192, .external_lex_state = 2},
  [3664] = {.lex_state = 128},
  [3665] = {.lex_state = 197},
  [3666] = {.lex_state = 302},
  [3667] = {.lex_state = 237},
  [3668] = {.lex_state = 128, .external_lex_state = 12},
  [3669] = {.lex_state = 128},
  [3670] = {.lex_state = 237},
  [3671] = {.lex_state = 156, .external_lex_state = 3},
  [3672] = {.lex_state = 128},
  [3673] = {.lex_state = 128, .external_lex_state = 2},
  [3674] = {.lex_state = 128, .external_lex_state = 12},
  [3675] = {.lex_state = 192, .external_lex_state = 2},
  [3676] = {.lex_state = 615, .external_lex_state = 18},
  [3677] = {.lex_state = 615, .external_lex_state = 18},
  [3678] = {.lex_state = 615, .external_lex_state = 18},
  [3679] = {.lex_state = 615, .external_lex_state = 18},
  [3680] = {.lex_state = 192, .external_lex_state = 2},
  [3681] = {.lex_state = 192, .external_lex_state = 2},
  [3682] = {.lex_state = 192, .external_lex_state = 2},
  [3683] = {.lex_state = 302, .external_lex_state = 16},
  [3684] = {.lex_state = 618, .external_lex_state = 18},
  [3685] = {.lex_state = 213},
  [3686] = {.lex_state = 227, .external_lex_state = 16},
  [3687] = {.lex_state = 251, .external_lex_state = 20},
  [3688] = {.lex_state = 302, .external_lex_state = 16},
  [3689] = {.lex_state = 156},
  [3690] = {.lex_state = 156},
  [3691] = {.lex_state = 241},
  [3692] = {.lex_state = 128, .external_lex_state = 2},
  [3693] = {.lex_state = 645, .external_lex_state = 20},
  [3694] = {.lex_state = 192, .external_lex_state = 15},
  [3695] = {.lex_state = 554, .external_lex_state = 16},
  [3696] = {.lex_state = 192, .external_lex_state = 2},
  [3697] = {.lex_state = 192, .external_lex_state = 2},
  [3698] = {.lex_state = 192, .external_lex_state = 2},
  [3699] = {.lex_state = 237},
  [3700] = {.lex_state = 192, .external_lex_state = 2},
  [3701] = {.lex_state = 648, .external_lex_state = 26},
  [3702] = {.lex_state = 648, .external_lex_state = 26},
  [3703] = {.lex_state = 648, .external_lex_state = 26},
  [3704] = {.lex_state = 648, .external_lex_state = 26},
  [3705] = {.lex_state = 192, .external_lex_state = 2},
  [3706] = {.lex_state = 192, .external_lex_state = 2},
  [3707] = {.lex_state = 192, .external_lex_state = 2},
  [3708] = {.lex_state = 651, .external_lex_state = 26},
  [3709] = {.lex_state = 654, .external_lex_state = 25},
  [3710] = {.lex_state = 657, .external_lex_state = 26},
  [3711] = {.lex_state = 562, .external_lex_state = 25},
  [3712] = {.lex_state = 645, .external_lex_state = 25},
  [3713] = {.lex_state = 213},
  [3714] = {.lex_state = 658, .external_lex_state = 25},
  [3715] = {.lex_state = 661, .external_lex_state = 27},
  [3716] = {.lex_state = 554, .external_lex_state = 16},
  [3717] = {.lex_state = 554, .external_lex_state = 16},
  [3718] = {.lex_state = 192, .external_lex_state = 2},
  [3719] = {.lex_state = 192, .external_lex_state = 2},
  [3720] = {.lex_state = 192, .external_lex_state = 2},
  [3721] = {.lex_state = 192, .external_lex_state = 2},
  [3722] = {.lex_state = 192, .external_lex_state = 2},
  [3723] = {.lex_state = 192, .external_lex_state = 2},
  [3724] = {.lex_state = 192, .external_lex_state = 2},
  [3725] = {.lex_state = 192, .external_lex_state = 2},
  [3726] = {.lex_state = 192, .external_lex_state = 2},
  [3727] = {.lex_state = 192, .external_lex_state = 2},
  [3728] = {.lex_state = 192, .external_lex_state = 2},
  [3729] = {.lex_state = 192, .external_lex_state = 2},
  [3730] = {.lex_state = 192, .external_lex_state = 2},
  [3731] = {.lex_state = 192, .external_lex_state = 2},
  [3732] = {.lex_state = 192, .external_lex_state = 2},
  [3733] = {.lex_state = 192, .external_lex_state = 2},
  [3734] = {.lex_state = 237},
  [3735] = {.lex_state = 192, .external_lex_state = 2},
  [3736] = {.lex_state = 657, .external_lex_state = 26},
  [3737] = {.lex_state = 657, .external_lex_state = 26},
  [3738] = {.lex_state = 657, .external_lex_state = 26},
  [3739] = {.lex_state = 657, .external_lex_state = 26},
  [3740] = {.lex_state = 192, .external_lex_state = 2},
  [3741] = {.lex_state = 192, .external_lex_state = 2},
  [3742] = {.lex_state = 192, .external_lex_state = 2},
  [3743] = {.lex_state = 651, .external_lex_state = 26},
  [3744] = {.lex_state = 658, .external_lex_state = 25},
  [3745] = {.lex_state = 657, .external_lex_state = 26},
  [3746] = {.lex_state = 559, .external_lex_state = 25},
  [3747] = {.lex_state = 559, .external_lex_state = 25},
  [3748] = {.lex_state = 213},
  [3749] = {.lex_state = 658, .external_lex_state = 25},
  [3750] = {.lex_state = 662, .external_lex_state = 27},
  [3751] = {.lex_state = 192, .external_lex_state = 29},
  [3752] = {.lex_state = 192, .external_lex_state = 2},
  [3753] = {.lex_state = 562, .external_lex_state = 20},
  [3754] = {.lex_state = 416, .external_lex_state = 28},
  [3755] = {.lex_state = 177, .external_lex_state = 17},
  [3756] = {.lex_state = 327, .external_lex_state = 11},
  [3757] = {.lex_state = 209, .external_lex_state = 19},
  [3758] = {.lex_state = 209},
  [3759] = {.lex_state = 327, .external_lex_state = 11},
  [3760] = {.lex_state = 416, .external_lex_state = 28},
  [3761] = {.lex_state = 227, .external_lex_state = 3},
  [3762] = {.lex_state = 235},
  [3763] = {.lex_state = 565, .external_lex_state = 14},
  [3764] = {.lex_state = 299, .external_lex_state = 3},
  [3765] = {.lex_state = 299, .external_lex_state = 3},
  [3766] = {.lex_state = 299, .external_lex_state = 3},
  [3767] = {.lex_state = 299, .external_lex_state = 3},
  [3768] = {.lex_state = 192, .external_lex_state = 15},
  [3769] = {.lex_state = 266, .external_lex_state = 15},
  [3770] = {.lex_state = 299, .external_lex_state = 3},
  [3771] = {.lex_state = 177, .external_lex_state = 4},
  [3772] = {.lex_state = 266, .external_lex_state = 15},
  [3773] = {.lex_state = 299, .external_lex_state = 3},
  [3774] = {.lex_state = 192, .external_lex_state = 15},
  [3775] = {.lex_state = 266, .external_lex_state = 15},
  [3776] = {.lex_state = 299, .external_lex_state = 3},
  [3777] = {.lex_state = 177, .external_lex_state = 4},
  [3778] = {.lex_state = 266, .external_lex_state = 15},
  [3779] = {.lex_state = 227, .external_lex_state = 14},
  [3780] = {.lex_state = 192, .external_lex_state = 15},
  [3781] = {.lex_state = 227, .external_lex_state = 3},
  [3782] = {.lex_state = 192, .external_lex_state = 15},
  [3783] = {.lex_state = 227, .external_lex_state = 3},
  [3784] = {.lex_state = 192, .external_lex_state = 15},
  [3785] = {.lex_state = 227, .external_lex_state = 3},
  [3786] = {.lex_state = 192, .external_lex_state = 15},
  [3787] = {.lex_state = 227, .external_lex_state = 3},
  [3788] = {.lex_state = 190, .external_lex_state = 4},
  [3789] = {.lex_state = 266, .external_lex_state = 15},
  [3790] = {.lex_state = 227, .external_lex_state = 3},
  [3791] = {.lex_state = 190, .external_lex_state = 4},
  [3792] = {.lex_state = 266, .external_lex_state = 15},
  [3793] = {.lex_state = 424, .external_lex_state = 3},
  [3794] = {.lex_state = 227, .external_lex_state = 3},
  [3795] = {.lex_state = 194},
  [3796] = {.lex_state = 194, .external_lex_state = 19},
  [3797] = {.lex_state = 192, .external_lex_state = 2},
  [3798] = {.lex_state = 227, .external_lex_state = 3},
  [3799] = {.lex_state = 310},
  [3800] = {.lex_state = 310, .external_lex_state = 8},
  [3801] = {.lex_state = 227, .external_lex_state = 3},
  [3802] = {.lex_state = 209},
  [3803] = {.lex_state = 192, .external_lex_state = 2},
  [3804] = {.lex_state = 346, .external_lex_state = 23},
  [3805] = {.lex_state = 346, .external_lex_state = 23},
  [3806] = {.lex_state = 350, .external_lex_state = 23},
  [3807] = {.lex_state = 350, .external_lex_state = 23},
  [3808] = {.lex_state = 227, .external_lex_state = 3},
  [3809] = {.lex_state = 227, .external_lex_state = 3},
  [3810] = {.lex_state = 227, .external_lex_state = 3},
  [3811] = {.lex_state = 227, .external_lex_state = 3},
  [3812] = {.lex_state = 128, .external_lex_state = 8},
  [3813] = {.lex_state = 128, .external_lex_state = 8},
  [3814] = {.lex_state = 247, .external_lex_state = 3},
  [3815] = {.lex_state = 247, .external_lex_state = 3},
  [3816] = {.lex_state = 128},
  [3817] = {.lex_state = 247, .external_lex_state = 3},
  [3818] = {.lex_state = 128},
  [3819] = {.lex_state = 128},
  [3820] = {.lex_state = 128},
  [3821] = {.lex_state = 128},
  [3822] = {.lex_state = 128},
  [3823] = {.lex_state = 227, .external_lex_state = 3},
  [3824] = {.lex_state = 128, .external_lex_state = 2},
  [3825] = {.lex_state = 424, .external_lex_state = 3},
  [3826] = {.lex_state = 424, .external_lex_state = 3},
  [3827] = {.lex_state = 227, .external_lex_state = 3},
  [3828] = {.lex_state = 227, .external_lex_state = 3},
  [3829] = {.lex_state = 227, .external_lex_state = 3},
  [3830] = {.lex_state = 235, .external_lex_state = 19},
  [3831] = {.lex_state = 235},
  [3832] = {.lex_state = 128},
  [3833] = {.lex_state = 227, .external_lex_state = 3},
  [3834] = {.lex_state = 192, .external_lex_state = 2},
  [3835] = {.lex_state = 192, .external_lex_state = 2},
  [3836] = {.lex_state = 192, .external_lex_state = 2},
  [3837] = {.lex_state = 192, .external_lex_state = 2},
  [3838] = {.lex_state = 192, .external_lex_state = 2},
  [3839] = {.lex_state = 192, .external_lex_state = 2},
  [3840] = {.lex_state = 192, .external_lex_state = 2},
  [3841] = {.lex_state = 192, .external_lex_state = 2},
  [3842] = {.lex_state = 192, .external_lex_state = 2},
  [3843] = {.lex_state = 192, .external_lex_state = 2},
  [3844] = {.lex_state = 192, .external_lex_state = 2},
  [3845] = {.lex_state = 192, .external_lex_state = 2},
  [3846] = {.lex_state = 419, .external_lex_state = 6},
  [3847] = {.lex_state = 192, .external_lex_state = 29},
  [3848] = {.lex_state = 192, .external_lex_state = 2},
  [3849] = {.lex_state = 424, .external_lex_state = 14},
  [3850] = {.lex_state = 299, .external_lex_state = 3},
  [3851] = {.lex_state = 424, .external_lex_state = 3},
  [3852] = {.lex_state = 436, .external_lex_state = 3},
  [3853] = {.lex_state = 455, .external_lex_state = 14},
  [3854] = {.lex_state = 192, .external_lex_state = 2},
  [3855] = {.lex_state = 192, .external_lex_state = 2},
  [3856] = {.lex_state = 237},
  [3857] = {.lex_state = 192, .external_lex_state = 2},
  [3858] = {.lex_state = 569, .external_lex_state = 11},
  [3859] = {.lex_state = 588, .external_lex_state = 3},
  [3860] = {.lex_state = 455, .external_lex_state = 3},
  [3861] = {.lex_state = 588, .external_lex_state = 3},
  [3862] = {.lex_state = 588, .external_lex_state = 14},
  [3863] = {.lex_state = 436, .external_lex_state = 3},
  [3864] = {.lex_state = 436, .external_lex_state = 3},
  [3865] = {.lex_state = 227, .external_lex_state = 3},
  [3866] = {.lex_state = 194},
  [3867] = {.lex_state = 192, .external_lex_state = 2},
  [3868] = {.lex_state = 192, .external_lex_state = 2},
  [3869] = {.lex_state = 192, .external_lex_state = 2},
  [3870] = {.lex_state = 192, .external_lex_state = 2},
  [3871] = {.lex_state = 192, .external_lex_state = 2},
  [3872] = {.lex_state = 192, .external_lex_state = 2},
  [3873] = {.lex_state = 192, .external_lex_state = 2},
  [3874] = {.lex_state = 192, .external_lex_state = 2},
  [3875] = {.lex_state = 192, .external_lex_state = 2},
  [3876] = {.lex_state = 192, .external_lex_state = 2},
  [3877] = {.lex_state = 192, .external_lex_state = 2},
  [3878] = {.lex_state = 192, .external_lex_state = 2},
  [3879] = {.lex_state = 192, .external_lex_state = 2},
  [3880] = {.lex_state = 192, .external_lex_state = 2},
  [3881] = {.lex_state = 237},
  [3882] = {.lex_state = 192, .external_lex_state = 2},
  [3883] = {.lex_state = 569, .external_lex_state = 11},
  [3884] = {.lex_state = 573, .external_lex_state = 3},
  [3885] = {.lex_state = 573, .external_lex_state = 3},
  [3886] = {.lex_state = 573, .external_lex_state = 3},
  [3887] = {.lex_state = 573, .external_lex_state = 14},
  [3888] = {.lex_state = 192, .external_lex_state = 29},
  [3889] = {.lex_state = 192, .external_lex_state = 2},
  [3890] = {.lex_state = 455, .external_lex_state = 14},
  [3891] = {.lex_state = 299, .external_lex_state = 3},
  [3892] = {.lex_state = 194},
  [3893] = {.lex_state = 302, .external_lex_state = 16},
  [3894] = {.lex_state = 225, .external_lex_state = 7},
  [3895] = {.lex_state = 128, .external_lex_state = 2},
  [3896] = {.lex_state = 299, .external_lex_state = 3},
  [3897] = {.lex_state = 247, .external_lex_state = 3},
  [3898] = {.lex_state = 128, .external_lex_state = 8},
  [3899] = {.lex_state = 128, .external_lex_state = 2},
  [3900] = {.lex_state = 299, .external_lex_state = 3},
  [3901] = {.lex_state = 128, .external_lex_state = 2},
  [3902] = {.lex_state = 128, .external_lex_state = 12},
  [3903] = {.lex_state = 128, .external_lex_state = 2},
  [3904] = {.lex_state = 128, .external_lex_state = 2},
  [3905] = {.lex_state = 128, .external_lex_state = 2},
  [3906] = {.lex_state = 128, .external_lex_state = 8},
  [3907] = {.lex_state = 227, .external_lex_state = 3},
  [3908] = {.lex_state = 128},
  [3909] = {.lex_state = 128, .external_lex_state = 2},
  [3910] = {.lex_state = 128, .external_lex_state = 12},
  [3911] = {.lex_state = 128},
  [3912] = {.lex_state = 128},
  [3913] = {.lex_state = 128},
  [3914] = {.lex_state = 299, .external_lex_state = 3},
  [3915] = {.lex_state = 128},
  [3916] = {.lex_state = 128},
  [3917] = {.lex_state = 128},
  [3918] = {.lex_state = 299, .external_lex_state = 3},
  [3919] = {.lex_state = 227, .external_lex_state = 3},
  [3920] = {.lex_state = 209},
  [3921] = {.lex_state = 299, .external_lex_state = 3},
  [3922] = {.lex_state = 235},
  [3923] = {.lex_state = 299, .external_lex_state = 3},
  [3924] = {.lex_state = 299, .external_lex_state = 3},
  [3925] = {.lex_state = 421, .external_lex_state = 3},
  [3926] = {.lex_state = 421, .external_lex_state = 3},
  [3927] = {.lex_state = 421, .external_lex_state = 3},
  [3928] = {.lex_state = 421, .external_lex_state = 3},
  [3929] = {.lex_state = 421, .external_lex_state = 3},
  [3930] = {.lex_state = 421, .external_lex_state = 3},
  [3931] = {.lex_state = 424, .external_lex_state = 3},
  [3932] = {.lex_state = 554, .external_lex_state = 16},
  [3933] = {.lex_state = 421, .external_lex_state = 3},
  [3934] = {.lex_state = 421, .external_lex_state = 3},
  [3935] = {.lex_state = 421, .external_lex_state = 3},
  [3936] = {.lex_state = 421, .external_lex_state = 3},
  [3937] = {.lex_state = 421, .external_lex_state = 3},
  [3938] = {.lex_state = 227, .external_lex_state = 3},
  [3939] = {.lex_state = 227, .external_lex_state = 3},
  [3940] = {.lex_state = 177, .external_lex_state = 17},
  [3941] = {.lex_state = 424, .external_lex_state = 3},
  [3942] = {.lex_state = 227, .external_lex_state = 3},
  [3943] = {.lex_state = 524, .external_lex_state = 21},
  [3944] = {.lex_state = 424, .external_lex_state = 3},
  [3945] = {.lex_state = 424, .external_lex_state = 3},
  [3946] = {.lex_state = 421, .external_lex_state = 3},
  [3947] = {.lex_state = 299, .external_lex_state = 3},
  [3948] = {.lex_state = 421, .external_lex_state = 3},
  [3949] = {.lex_state = 421, .external_lex_state = 3},
  [3950] = {.lex_state = 421, .external_lex_state = 14},
  [3951] = {.lex_state = 577, .external_lex_state = 3},
  [3952] = {.lex_state = 577, .external_lex_state = 3},
  [3953] = {.lex_state = 577, .external_lex_state = 3},
  [3954] = {.lex_state = 577, .external_lex_state = 3},
  [3955] = {.lex_state = 192, .external_lex_state = 2},
  [3956] = {.lex_state = 192, .external_lex_state = 2},
  [3957] = {.lex_state = 192, .external_lex_state = 2},
  [3958] = {.lex_state = 192, .external_lex_state = 2},
  [3959] = {.lex_state = 192, .external_lex_state = 2},
  [3960] = {.lex_state = 192, .external_lex_state = 2},
  [3961] = {.lex_state = 192, .external_lex_state = 2},
  [3962] = {.lex_state = 192, .external_lex_state = 2},
  [3963] = {.lex_state = 192, .external_lex_state = 2},
  [3964] = {.lex_state = 192, .external_lex_state = 2},
  [3965] = {.lex_state = 192, .external_lex_state = 2},
  [3966] = {.lex_state = 192, .external_lex_state = 2},
  [3967] = {.lex_state = 192, .external_lex_state = 29},
  [3968] = {.lex_state = 577, .external_lex_state = 3},
  [3969] = {.lex_state = 192, .external_lex_state = 29},
  [3970] = {.lex_state = 192, .external_lex_state = 2},
  [3971] = {.lex_state = 192, .external_lex_state = 2},
  [3972] = {.lex_state = 458, .external_lex_state = 26},
  [3973] = {.lex_state = 458, .external_lex_state = 26},
  [3974] = {.lex_state = 458, .external_lex_state = 26},
  [3975] = {.lex_state = 458, .external_lex_state = 26},
  [3976] = {.lex_state = 192, .external_lex_state = 2},
  [3977] = {.lex_state = 192, .external_lex_state = 2},
  [3978] = {.lex_state = 192, .external_lex_state = 2},
  [3979] = {.lex_state = 467, .external_lex_state = 25},
  [3980] = {.lex_state = 438, .external_lex_state = 26},
  [3981] = {.lex_state = 213},
  [3982] = {.lex_state = 441, .external_lex_state = 25},
  [3983] = {.lex_state = 467, .external_lex_state = 27},
  [3984] = {.lex_state = 467, .external_lex_state = 25},
  [3985] = {.lex_state = 588, .external_lex_state = 25},
  [3986] = {.lex_state = 663, .external_lex_state = 27},
  [3987] = {.lex_state = 192, .external_lex_state = 2},
  [3988] = {.lex_state = 467, .external_lex_state = 25},
  [3989] = {.lex_state = 192, .external_lex_state = 2},
  [3990] = {.lex_state = 192, .external_lex_state = 2},
  [3991] = {.lex_state = 237},
  [3992] = {.lex_state = 192, .external_lex_state = 2},
  [3993] = {.lex_state = 585, .external_lex_state = 26},
  [3994] = {.lex_state = 588, .external_lex_state = 25},
  [3995] = {.lex_state = 588, .external_lex_state = 25},
  [3996] = {.lex_state = 588, .external_lex_state = 25},
  [3997] = {.lex_state = 588, .external_lex_state = 27},
  [3998] = {.lex_state = 588, .external_lex_state = 25},
  [3999] = {.lex_state = 588, .external_lex_state = 25},
  [4000] = {.lex_state = 192, .external_lex_state = 2},
  [4001] = {.lex_state = 192, .external_lex_state = 2},
  [4002] = {.lex_state = 192, .external_lex_state = 2},
  [4003] = {.lex_state = 192, .external_lex_state = 2},
  [4004] = {.lex_state = 192, .external_lex_state = 2},
  [4005] = {.lex_state = 192, .external_lex_state = 2},
  [4006] = {.lex_state = 192, .external_lex_state = 2},
  [4007] = {.lex_state = 192, .external_lex_state = 2},
  [4008] = {.lex_state = 192, .external_lex_state = 2},
  [4009] = {.lex_state = 192, .external_lex_state = 2},
  [4010] = {.lex_state = 192, .external_lex_state = 2},
  [4011] = {.lex_state = 192, .external_lex_state = 2},
  [4012] = {.lex_state = 192, .external_lex_state = 2},
  [4013] = {.lex_state = 192, .external_lex_state = 2},
  [4014] = {.lex_state = 192, .external_lex_state = 2},
  [4015] = {.lex_state = 237},
  [4016] = {.lex_state = 192, .external_lex_state = 2},
  [4017] = {.lex_state = 585, .external_lex_state = 26},
  [4018] = {.lex_state = 573, .external_lex_state = 25},
  [4019] = {.lex_state = 573, .external_lex_state = 25},
  [4020] = {.lex_state = 573, .external_lex_state = 25},
  [4021] = {.lex_state = 573, .external_lex_state = 27},
  [4022] = {.lex_state = 444, .external_lex_state = 25},
  [4023] = {.lex_state = 524, .external_lex_state = 13},
  [4024] = {.lex_state = 467, .external_lex_state = 25},
  [4025] = {.lex_state = 192, .external_lex_state = 29},
  [4026] = {.lex_state = 192, .external_lex_state = 2},
  [4027] = {.lex_state = 663, .external_lex_state = 27},
  [4028] = {.lex_state = 237},
  [4029] = {.lex_state = 225, .external_lex_state = 7},
  [4030] = {.lex_state = 237},
  [4031] = {.lex_state = 194},
  [4032] = {.lex_state = 436, .external_lex_state = 16},
  [4033] = {.lex_state = 436, .external_lex_state = 16},
  [4034] = {.lex_state = 436, .external_lex_state = 16},
  [4035] = {.lex_state = 436, .external_lex_state = 16},
  [4036] = {.lex_state = 436, .external_lex_state = 16},
  [4037] = {.lex_state = 436, .external_lex_state = 16},
  [4038] = {.lex_state = 436, .external_lex_state = 16},
  [4039] = {.lex_state = 436, .external_lex_state = 16},
  [4040] = {.lex_state = 436, .external_lex_state = 16},
  [4041] = {.lex_state = 436, .external_lex_state = 16},
  [4042] = {.lex_state = 436, .external_lex_state = 16},
  [4043] = {.lex_state = 554, .external_lex_state = 16},
  [4044] = {.lex_state = 436, .external_lex_state = 16},
  [4045] = {.lex_state = 436, .external_lex_state = 16},
  [4046] = {.lex_state = 436, .external_lex_state = 16},
  [4047] = {.lex_state = 436, .external_lex_state = 16},
  [4048] = {.lex_state = 436, .external_lex_state = 16},
  [4049] = {.lex_state = 579, .external_lex_state = 18},
  [4050] = {.lex_state = 356, .external_lex_state = 13},
  [4051] = {.lex_state = 579, .external_lex_state = 18},
  [4052] = {.lex_state = 579, .external_lex_state = 18},
  [4053] = {.lex_state = 416, .external_lex_state = 28},
  [4054] = {.lex_state = 433, .external_lex_state = 16},
  [4055] = {.lex_state = 235, .external_lex_state = 19},
  [4056] = {.lex_state = 235},
  [4057] = {.lex_state = 579, .external_lex_state = 18},
  [4058] = {.lex_state = 461, .external_lex_state = 25},
  [4059] = {.lex_state = 177, .external_lex_state = 4},
  [4060] = {.lex_state = 177, .external_lex_state = 4},
  [4061] = {.lex_state = 177, .external_lex_state = 4},
  [4062] = {.lex_state = 177, .external_lex_state = 4},
  [4063] = {.lex_state = 190, .external_lex_state = 4},
  [4064] = {.lex_state = 190, .external_lex_state = 4},
  [4065] = {.lex_state = 192, .external_lex_state = 2},
  [4066] = {.lex_state = 194, .external_lex_state = 6},
  [4067] = {.lex_state = 197, .external_lex_state = 7},
  [4068] = {.lex_state = 209, .external_lex_state = 2},
  [4069] = {.lex_state = 216, .external_lex_state = 10},
  [4070] = {.lex_state = 216, .external_lex_state = 9},
  [4071] = {.lex_state = 438, .external_lex_state = 26},
  [4072] = {.lex_state = 438, .external_lex_state = 26},
  [4073] = {.lex_state = 438, .external_lex_state = 26},
  [4074] = {.lex_state = 438, .external_lex_state = 26},
  [4075] = {.lex_state = 221, .external_lex_state = 2},
  [4076] = {.lex_state = 221, .external_lex_state = 2},
  [4077] = {.lex_state = 192, .external_lex_state = 2},
  [4078] = {.lex_state = 192, .external_lex_state = 2},
  [4079] = {.lex_state = 223, .external_lex_state = 9},
  [4080] = {.lex_state = 221, .external_lex_state = 12},
  [4081] = {.lex_state = 128, .external_lex_state = 12},
  [4082] = {.lex_state = 192, .external_lex_state = 2},
  [4083] = {.lex_state = 192, .external_lex_state = 2},
  [4084] = {.lex_state = 192, .external_lex_state = 2},
  [4085] = {.lex_state = 461, .external_lex_state = 25},
  [4086] = {.lex_state = 235, .external_lex_state = 13},
  [4087] = {.lex_state = 237},
  [4088] = {.lex_state = 441, .external_lex_state = 25},
  [4089] = {.lex_state = 461, .external_lex_state = 25},
  [4090] = {.lex_state = 438, .external_lex_state = 26},
  [4091] = {.lex_state = 213},
  [4092] = {.lex_state = 441, .external_lex_state = 25},
  [4093] = {.lex_state = 441, .external_lex_state = 27},
  [4094] = {.lex_state = 441, .external_lex_state = 25},
  [4095] = {.lex_state = 573, .external_lex_state = 25},
  [4096] = {.lex_state = 664, .external_lex_state = 27},
  [4097] = {.lex_state = 192, .external_lex_state = 2},
  [4098] = {.lex_state = 665, .external_lex_state = 25},
  [4099] = {.lex_state = 194},
  [4100] = {.lex_state = 286, .external_lex_state = 2},
  [4101] = {.lex_state = 441, .external_lex_state = 25},
  [4102] = {.lex_state = 433, .external_lex_state = 16},
  [4103] = {.lex_state = 128},
  [4104] = {.lex_state = 128, .external_lex_state = 12},
  [4105] = {.lex_state = 414, .external_lex_state = 2},
  [4106] = {.lex_state = 461, .external_lex_state = 25},
  [4107] = {.lex_state = 209, .external_lex_state = 19},
  [4108] = {.lex_state = 209},
  [4109] = {.lex_state = 573, .external_lex_state = 25},
  [4110] = {.lex_state = 573, .external_lex_state = 25},
  [4111] = {.lex_state = 192, .external_lex_state = 2},
  [4112] = {.lex_state = 192, .external_lex_state = 2},
  [4113] = {.lex_state = 192, .external_lex_state = 2},
  [4114] = {.lex_state = 192, .external_lex_state = 2},
  [4115] = {.lex_state = 192, .external_lex_state = 2},
  [4116] = {.lex_state = 192, .external_lex_state = 2},
  [4117] = {.lex_state = 192, .external_lex_state = 2},
  [4118] = {.lex_state = 192, .external_lex_state = 2},
  [4119] = {.lex_state = 192, .external_lex_state = 2},
  [4120] = {.lex_state = 192, .external_lex_state = 2},
  [4121] = {.lex_state = 192, .external_lex_state = 2},
  [4122] = {.lex_state = 192, .external_lex_state = 2},
  [4123] = {.lex_state = 192, .external_lex_state = 2},
  [4124] = {.lex_state = 409, .external_lex_state = 2},
  [4125] = {.lex_state = 433, .external_lex_state = 16},
  [4126] = {.lex_state = 177, .external_lex_state = 17},
  [4127] = {.lex_state = 441, .external_lex_state = 25},
  [4128] = {.lex_state = 524, .external_lex_state = 13},
  [4129] = {.lex_state = 441, .external_lex_state = 25},
  [4130] = {.lex_state = 192, .external_lex_state = 29},
  [4131] = {.lex_state = 192, .external_lex_state = 2},
  [4132] = {.lex_state = 664, .external_lex_state = 27},
  [4133] = {.lex_state = 192, .external_lex_state = 2},
  [4134] = {.lex_state = 192, .external_lex_state = 2},
  [4135] = {.lex_state = 458, .external_lex_state = 18},
  [4136] = {.lex_state = 458, .external_lex_state = 18},
  [4137] = {.lex_state = 458, .external_lex_state = 18},
  [4138] = {.lex_state = 458, .external_lex_state = 18},
  [4139] = {.lex_state = 192, .external_lex_state = 2},
  [4140] = {.lex_state = 192, .external_lex_state = 2},
  [4141] = {.lex_state = 192, .external_lex_state = 2},
  [4142] = {.lex_state = 436, .external_lex_state = 16},
  [4143] = {.lex_state = 436, .external_lex_state = 16},
  [4144] = {.lex_state = 213},
  [4145] = {.lex_state = 441, .external_lex_state = 16},
  [4146] = {.lex_state = 467, .external_lex_state = 20},
  [4147] = {.lex_state = 436, .external_lex_state = 16},
  [4148] = {.lex_state = 444, .external_lex_state = 20},
  [4149] = {.lex_state = 156, .external_lex_state = 3},
  [4150] = {.lex_state = 177, .external_lex_state = 4},
  [4151] = {.lex_state = 156, .external_lex_state = 3},
  [4152] = {.lex_state = 177, .external_lex_state = 30},
  [4153] = {.lex_state = 156, .external_lex_state = 3},
  [4154] = {.lex_state = 177, .external_lex_state = 4},
  [4155] = {.lex_state = 156, .external_lex_state = 3},
  [4156] = {.lex_state = 177, .external_lex_state = 30},
  [4157] = {.lex_state = 192, .external_lex_state = 2},
  [4158] = {.lex_state = 668, .external_lex_state = 11},
  [4159] = {.lex_state = 668, .external_lex_state = 11},
  [4160] = {.lex_state = 668, .external_lex_state = 11},
  [4161] = {.lex_state = 668, .external_lex_state = 11},
  [4162] = {.lex_state = 192, .external_lex_state = 2},
  [4163] = {.lex_state = 192, .external_lex_state = 2},
  [4164] = {.lex_state = 192, .external_lex_state = 2},
  [4165] = {.lex_state = 467, .external_lex_state = 3},
  [4166] = {.lex_state = 213},
  [4167] = {.lex_state = 441, .external_lex_state = 3},
  [4168] = {.lex_state = 467, .external_lex_state = 14},
  [4169] = {.lex_state = 467, .external_lex_state = 3},
  [4170] = {.lex_state = 588, .external_lex_state = 3},
  [4171] = {.lex_state = 663, .external_lex_state = 14},
  [4172] = {.lex_state = 192, .external_lex_state = 2},
  [4173] = {.lex_state = 467, .external_lex_state = 3},
  [4174] = {.lex_state = 588, .external_lex_state = 3},
  [4175] = {.lex_state = 588, .external_lex_state = 3},
  [4176] = {.lex_state = 588, .external_lex_state = 3},
  [4177] = {.lex_state = 588, .external_lex_state = 3},
  [4178] = {.lex_state = 192, .external_lex_state = 2},
  [4179] = {.lex_state = 192, .external_lex_state = 2},
  [4180] = {.lex_state = 192, .external_lex_state = 2},
  [4181] = {.lex_state = 192, .external_lex_state = 2},
  [4182] = {.lex_state = 192, .external_lex_state = 2},
  [4183] = {.lex_state = 192, .external_lex_state = 2},
  [4184] = {.lex_state = 192, .external_lex_state = 2},
  [4185] = {.lex_state = 192, .external_lex_state = 2},
  [4186] = {.lex_state = 192, .external_lex_state = 2},
  [4187] = {.lex_state = 192, .external_lex_state = 2},
  [4188] = {.lex_state = 192, .external_lex_state = 2},
  [4189] = {.lex_state = 192, .external_lex_state = 2},
  [4190] = {.lex_state = 192, .external_lex_state = 2},
  [4191] = {.lex_state = 444, .external_lex_state = 3},
  [4192] = {.lex_state = 524, .external_lex_state = 13},
  [4193] = {.lex_state = 467, .external_lex_state = 3},
  [4194] = {.lex_state = 192, .external_lex_state = 29},
  [4195] = {.lex_state = 192, .external_lex_state = 2},
  [4196] = {.lex_state = 663, .external_lex_state = 14},
  [4197] = {.lex_state = 237, .external_lex_state = 8},
  [4198] = {.lex_state = 286, .external_lex_state = 2},
  [4199] = {.lex_state = 237, .external_lex_state = 8},
  [4200] = {.lex_state = 436, .external_lex_state = 3},
  [4201] = {.lex_state = 436, .external_lex_state = 3},
  [4202] = {.lex_state = 436, .external_lex_state = 3},
  [4203] = {.lex_state = 436, .external_lex_state = 3},
  [4204] = {.lex_state = 436, .external_lex_state = 3},
  [4205] = {.lex_state = 436, .external_lex_state = 3},
  [4206] = {.lex_state = 436, .external_lex_state = 3},
  [4207] = {.lex_state = 436, .external_lex_state = 3},
  [4208] = {.lex_state = 436, .external_lex_state = 3},
  [4209] = {.lex_state = 436, .external_lex_state = 3},
  [4210] = {.lex_state = 436, .external_lex_state = 3},
  [4211] = {.lex_state = 554, .external_lex_state = 16},
  [4212] = {.lex_state = 436, .external_lex_state = 3},
  [4213] = {.lex_state = 436, .external_lex_state = 3},
  [4214] = {.lex_state = 436, .external_lex_state = 3},
  [4215] = {.lex_state = 436, .external_lex_state = 3},
  [4216] = {.lex_state = 436, .external_lex_state = 3},
  [4217] = {.lex_state = 192, .external_lex_state = 2},
  [4218] = {.lex_state = 450, .external_lex_state = 11},
  [4219] = {.lex_state = 450, .external_lex_state = 11},
  [4220] = {.lex_state = 450, .external_lex_state = 11},
  [4221] = {.lex_state = 450, .external_lex_state = 11},
  [4222] = {.lex_state = 192, .external_lex_state = 2},
  [4223] = {.lex_state = 192, .external_lex_state = 2},
  [4224] = {.lex_state = 192, .external_lex_state = 2},
  [4225] = {.lex_state = 441, .external_lex_state = 3},
  [4226] = {.lex_state = 450, .external_lex_state = 11},
  [4227] = {.lex_state = 213},
  [4228] = {.lex_state = 441, .external_lex_state = 3},
  [4229] = {.lex_state = 441, .external_lex_state = 14},
  [4230] = {.lex_state = 441, .external_lex_state = 3},
  [4231] = {.lex_state = 573, .external_lex_state = 3},
  [4232] = {.lex_state = 664, .external_lex_state = 14},
  [4233] = {.lex_state = 192, .external_lex_state = 2},
  [4234] = {.lex_state = 441, .external_lex_state = 3},
  [4235] = {.lex_state = 573, .external_lex_state = 3},
  [4236] = {.lex_state = 573, .external_lex_state = 3},
  [4237] = {.lex_state = 192, .external_lex_state = 2},
  [4238] = {.lex_state = 192, .external_lex_state = 2},
  [4239] = {.lex_state = 192, .external_lex_state = 2},
  [4240] = {.lex_state = 192, .external_lex_state = 2},
  [4241] = {.lex_state = 192, .external_lex_state = 2},
  [4242] = {.lex_state = 192, .external_lex_state = 2},
  [4243] = {.lex_state = 192, .external_lex_state = 2},
  [4244] = {.lex_state = 192, .external_lex_state = 2},
  [4245] = {.lex_state = 192, .external_lex_state = 2},
  [4246] = {.lex_state = 192, .external_lex_state = 2},
  [4247] = {.lex_state = 192, .external_lex_state = 2},
  [4248] = {.lex_state = 192, .external_lex_state = 2},
  [4249] = {.lex_state = 192, .external_lex_state = 2},
  [4250] = {.lex_state = 441, .external_lex_state = 3},
  [4251] = {.lex_state = 524, .external_lex_state = 13},
  [4252] = {.lex_state = 441, .external_lex_state = 3},
  [4253] = {.lex_state = 192, .external_lex_state = 29},
  [4254] = {.lex_state = 192, .external_lex_state = 2},
  [4255] = {.lex_state = 664, .external_lex_state = 14},
  [4256] = {.lex_state = 192, .external_lex_state = 2},
  [4257] = {.lex_state = 192, .external_lex_state = 2},
  [4258] = {.lex_state = 192, .external_lex_state = 2},
  [4259] = {.lex_state = 192, .external_lex_state = 2},
  [4260] = {.lex_state = 192, .external_lex_state = 2},
  [4261] = {.lex_state = 436, .external_lex_state = 3},
  [4262] = {.lex_state = 436, .external_lex_state = 3},
  [4263] = {.lex_state = 213},
  [4264] = {.lex_state = 441, .external_lex_state = 3},
  [4265] = {.lex_state = 436, .external_lex_state = 3},
  [4266] = {.lex_state = 444, .external_lex_state = 14},
  [4267] = {.lex_state = 288, .external_lex_state = 16},
  [4268] = {.lex_state = 288, .external_lex_state = 16},
  [4269] = {.lex_state = 177, .external_lex_state = 4},
  [4270] = {.lex_state = 266, .external_lex_state = 15},
  [4271] = {.lex_state = 288, .external_lex_state = 16},
  [4272] = {.lex_state = 177, .external_lex_state = 4},
  [4273] = {.lex_state = 288, .external_lex_state = 16},
  [4274] = {.lex_state = 288, .external_lex_state = 16},
  [4275] = {.lex_state = 177, .external_lex_state = 4},
  [4276] = {.lex_state = 266, .external_lex_state = 15},
  [4277] = {.lex_state = 288, .external_lex_state = 16},
  [4278] = {.lex_state = 177, .external_lex_state = 4},
  [4279] = {.lex_state = 177, .external_lex_state = 17},
  [4280] = {.lex_state = 288, .external_lex_state = 16},
  [4281] = {.lex_state = 310},
  [4282] = {.lex_state = 288, .external_lex_state = 16},
  [4283] = {.lex_state = 288, .external_lex_state = 16},
  [4284] = {.lex_state = 192, .external_lex_state = 2},
  [4285] = {.lex_state = 192, .external_lex_state = 2},
  [4286] = {.lex_state = 192, .external_lex_state = 2},
  [4287] = {.lex_state = 192, .external_lex_state = 2},
  [4288] = {.lex_state = 467, .external_lex_state = 25},
  [4289] = {.lex_state = 213},
  [4290] = {.lex_state = 441, .external_lex_state = 25},
  [4291] = {.lex_state = 467, .external_lex_state = 25},
  [4292] = {.lex_state = 588, .external_lex_state = 25},
  [4293] = {.lex_state = 663, .external_lex_state = 27},
  [4294] = {.lex_state = 192, .external_lex_state = 2},
  [4295] = {.lex_state = 467, .external_lex_state = 25},
  [4296] = {.lex_state = 192, .external_lex_state = 2},
  [4297] = {.lex_state = 192, .external_lex_state = 2},
  [4298] = {.lex_state = 237},
  [4299] = {.lex_state = 192, .external_lex_state = 2},
  [4300] = {.lex_state = 585, .external_lex_state = 26},
  [4301] = {.lex_state = 588, .external_lex_state = 25},
  [4302] = {.lex_state = 588, .external_lex_state = 25},
  [4303] = {.lex_state = 588, .external_lex_state = 25},
  [4304] = {.lex_state = 588, .external_lex_state = 27},
  [4305] = {.lex_state = 588, .external_lex_state = 25},
  [4306] = {.lex_state = 588, .external_lex_state = 25},
  [4307] = {.lex_state = 192, .external_lex_state = 2},
  [4308] = {.lex_state = 192, .external_lex_state = 2},
  [4309] = {.lex_state = 192, .external_lex_state = 2},
  [4310] = {.lex_state = 192, .external_lex_state = 2},
  [4311] = {.lex_state = 192, .external_lex_state = 2},
  [4312] = {.lex_state = 192, .external_lex_state = 2},
  [4313] = {.lex_state = 192, .external_lex_state = 2},
  [4314] = {.lex_state = 192, .external_lex_state = 2},
  [4315] = {.lex_state = 192, .external_lex_state = 2},
  [4316] = {.lex_state = 192, .external_lex_state = 2},
  [4317] = {.lex_state = 192, .external_lex_state = 2},
  [4318] = {.lex_state = 192, .external_lex_state = 2},
  [4319] = {.lex_state = 192, .external_lex_state = 2},
  [4320] = {.lex_state = 192, .external_lex_state = 2},
  [4321] = {.lex_state = 192, .external_lex_state = 2},
  [4322] = {.lex_state = 237},
  [4323] = {.lex_state = 192, .external_lex_state = 2},
  [4324] = {.lex_state = 585, .external_lex_state = 26},
  [4325] = {.lex_state = 573, .external_lex_state = 25},
  [4326] = {.lex_state = 573, .external_lex_state = 25},
  [4327] = {.lex_state = 573, .external_lex_state = 25},
  [4328] = {.lex_state = 573, .external_lex_state = 27},
  [4329] = {.lex_state = 467, .external_lex_state = 25},
  [4330] = {.lex_state = 524, .external_lex_state = 13},
  [4331] = {.lex_state = 467, .external_lex_state = 25},
  [4332] = {.lex_state = 192, .external_lex_state = 29},
  [4333] = {.lex_state = 192, .external_lex_state = 2},
  [4334] = {.lex_state = 663, .external_lex_state = 27},
  [4335] = {.lex_state = 436, .external_lex_state = 25},
  [4336] = {.lex_state = 436, .external_lex_state = 25},
  [4337] = {.lex_state = 436, .external_lex_state = 25},
  [4338] = {.lex_state = 436, .external_lex_state = 25},
  [4339] = {.lex_state = 436, .external_lex_state = 25},
  [4340] = {.lex_state = 436, .external_lex_state = 25},
  [4341] = {.lex_state = 554, .external_lex_state = 16},
  [4342] = {.lex_state = 436, .external_lex_state = 25},
  [4343] = {.lex_state = 436, .external_lex_state = 25},
  [4344] = {.lex_state = 436, .external_lex_state = 25},
  [4345] = {.lex_state = 436, .external_lex_state = 25},
  [4346] = {.lex_state = 436, .external_lex_state = 25},
  [4347] = {.lex_state = 595, .external_lex_state = 26},
  [4348] = {.lex_state = 356, .external_lex_state = 13},
  [4349] = {.lex_state = 595, .external_lex_state = 26},
  [4350] = {.lex_state = 595, .external_lex_state = 26},
  [4351] = {.lex_state = 416, .external_lex_state = 28},
  [4352] = {.lex_state = 461, .external_lex_state = 25},
  [4353] = {.lex_state = 235, .external_lex_state = 19},
  [4354] = {.lex_state = 235},
  [4355] = {.lex_state = 595, .external_lex_state = 26},
  [4356] = {.lex_state = 192, .external_lex_state = 2},
  [4357] = {.lex_state = 438, .external_lex_state = 26},
  [4358] = {.lex_state = 438, .external_lex_state = 26},
  [4359] = {.lex_state = 438, .external_lex_state = 26},
  [4360] = {.lex_state = 438, .external_lex_state = 26},
  [4361] = {.lex_state = 192, .external_lex_state = 2},
  [4362] = {.lex_state = 192, .external_lex_state = 2},
  [4363] = {.lex_state = 192, .external_lex_state = 2},
  [4364] = {.lex_state = 441, .external_lex_state = 25},
  [4365] = {.lex_state = 438, .external_lex_state = 26},
  [4366] = {.lex_state = 213},
  [4367] = {.lex_state = 441, .external_lex_state = 25},
  [4368] = {.lex_state = 441, .external_lex_state = 27},
  [4369] = {.lex_state = 441, .external_lex_state = 25},
  [4370] = {.lex_state = 573, .external_lex_state = 25},
  [4371] = {.lex_state = 664, .external_lex_state = 27},
  [4372] = {.lex_state = 192, .external_lex_state = 2},
  [4373] = {.lex_state = 397, .external_lex_state = 25},
  [4374] = {.lex_state = 194},
  [4375] = {.lex_state = 286, .external_lex_state = 2},
  [4376] = {.lex_state = 441, .external_lex_state = 25},
  [4377] = {.lex_state = 461, .external_lex_state = 25},
  [4378] = {.lex_state = 128},
  [4379] = {.lex_state = 128, .external_lex_state = 12},
  [4380] = {.lex_state = 414, .external_lex_state = 2},
  [4381] = {.lex_state = 573, .external_lex_state = 25},
  [4382] = {.lex_state = 573, .external_lex_state = 25},
  [4383] = {.lex_state = 192, .external_lex_state = 2},
  [4384] = {.lex_state = 192, .external_lex_state = 2},
  [4385] = {.lex_state = 192, .external_lex_state = 2},
  [4386] = {.lex_state = 192, .external_lex_state = 2},
  [4387] = {.lex_state = 192, .external_lex_state = 2},
  [4388] = {.lex_state = 192, .external_lex_state = 2},
  [4389] = {.lex_state = 192, .external_lex_state = 2},
  [4390] = {.lex_state = 192, .external_lex_state = 2},
  [4391] = {.lex_state = 192, .external_lex_state = 2},
  [4392] = {.lex_state = 192, .external_lex_state = 2},
  [4393] = {.lex_state = 192, .external_lex_state = 2},
  [4394] = {.lex_state = 192, .external_lex_state = 2},
  [4395] = {.lex_state = 192, .external_lex_state = 2},
  [4396] = {.lex_state = 409, .external_lex_state = 2},
  [4397] = {.lex_state = 461, .external_lex_state = 25},
  [4398] = {.lex_state = 441, .external_lex_state = 25},
  [4399] = {.lex_state = 524, .external_lex_state = 13},
  [4400] = {.lex_state = 441, .external_lex_state = 25},
  [4401] = {.lex_state = 192, .external_lex_state = 29},
  [4402] = {.lex_state = 192, .external_lex_state = 2},
  [4403] = {.lex_state = 664, .external_lex_state = 27},
  [4404] = {.lex_state = 192, .external_lex_state = 2},
  [4405] = {.lex_state = 436, .external_lex_state = 25},
  [4406] = {.lex_state = 436, .external_lex_state = 25},
  [4407] = {.lex_state = 436, .external_lex_state = 25},
  [4408] = {.lex_state = 467, .external_lex_state = 27},
  [4409] = {.lex_state = 128, .external_lex_state = 2},
  [4410] = {.lex_state = 128, .external_lex_state = 2},
  [4411] = {.lex_state = 288, .external_lex_state = 16},
  [4412] = {.lex_state = 288, .external_lex_state = 16},
  [4413] = {.lex_state = 361, .external_lex_state = 25},
  [4414] = {.lex_state = 361, .external_lex_state = 25},
  [4415] = {.lex_state = 361, .external_lex_state = 25},
  [4416] = {.lex_state = 388, .external_lex_state = 25},
  [4417] = {.lex_state = 209},
  [4418] = {.lex_state = 361, .external_lex_state = 25},
  [4419] = {.lex_state = 361, .external_lex_state = 25},
  [4420] = {.lex_state = 361, .external_lex_state = 25},
  [4421] = {.lex_state = 361, .external_lex_state = 25},
  [4422] = {.lex_state = 361, .external_lex_state = 25},
  [4423] = {.lex_state = 361, .external_lex_state = 25},
  [4424] = {.lex_state = 361, .external_lex_state = 25},
  [4425] = {.lex_state = 554, .external_lex_state = 16},
  [4426] = {.lex_state = 361, .external_lex_state = 25},
  [4427] = {.lex_state = 361, .external_lex_state = 25},
  [4428] = {.lex_state = 361, .external_lex_state = 25},
  [4429] = {.lex_state = 361, .external_lex_state = 25},
  [4430] = {.lex_state = 361, .external_lex_state = 25},
  [4431] = {.lex_state = 388, .external_lex_state = 25},
  [4432] = {.lex_state = 177, .external_lex_state = 17},
  [4433] = {.lex_state = 305, .external_lex_state = 25},
  [4434] = {.lex_state = 388, .external_lex_state = 25},
  [4435] = {.lex_state = 524, .external_lex_state = 21},
  [4436] = {.lex_state = 305, .external_lex_state = 25},
  [4437] = {.lex_state = 361, .external_lex_state = 25},
  [4438] = {.lex_state = 361, .external_lex_state = 25},
  [4439] = {.lex_state = 388, .external_lex_state = 25},
  [4440] = {.lex_state = 361, .external_lex_state = 25},
  [4441] = {.lex_state = 361, .external_lex_state = 25},
  [4442] = {.lex_state = 361, .external_lex_state = 27},
  [4443] = {.lex_state = 288, .external_lex_state = 16},
  [4444] = {.lex_state = 128},
  [4445] = {.lex_state = 128},
  [4446] = {.lex_state = 128, .external_lex_state = 2},
  [4447] = {.lex_state = 288, .external_lex_state = 16},
  [4448] = {.lex_state = 128},
  [4449] = {.lex_state = 128},
  [4450] = {.lex_state = 288, .external_lex_state = 16},
  [4451] = {.lex_state = 128},
  [4452] = {.lex_state = 288, .external_lex_state = 16},
  [4453] = {.lex_state = 128},
  [4454] = {.lex_state = 128, .external_lex_state = 2},
  [4455] = {.lex_state = 128},
  [4456] = {.lex_state = 128},
  [4457] = {.lex_state = 288, .external_lex_state = 16},
  [4458] = {.lex_state = 288, .external_lex_state = 16},
  [4459] = {.lex_state = 128},
  [4460] = {.lex_state = 128},
  [4461] = {.lex_state = 288, .external_lex_state = 16},
  [4462] = {.lex_state = 288, .external_lex_state = 16},
  [4463] = {.lex_state = 194},
  [4464] = {.lex_state = 288, .external_lex_state = 16},
  [4465] = {.lex_state = 128},
  [4466] = {.lex_state = 128, .external_lex_state = 2},
  [4467] = {.lex_state = 128, .external_lex_state = 12},
  [4468] = {.lex_state = 192, .external_lex_state = 2},
  [4469] = {.lex_state = 304, .external_lex_state = 18},
  [4470] = {.lex_state = 209, .external_lex_state = 19},
  [4471] = {.lex_state = 209},
  [4472] = {.lex_state = 304, .external_lex_state = 18},
  [4473] = {.lex_state = 299, .external_lex_state = 16},
  [4474] = {.lex_state = 235},
  [4475] = {.lex_state = 598, .external_lex_state = 27},
  [4476] = {.lex_state = 397, .external_lex_state = 25},
  [4477] = {.lex_state = 397, .external_lex_state = 25},
  [4478] = {.lex_state = 397, .external_lex_state = 25},
  [4479] = {.lex_state = 397, .external_lex_state = 25},
  [4480] = {.lex_state = 192, .external_lex_state = 15},
  [4481] = {.lex_state = 266, .external_lex_state = 15},
  [4482] = {.lex_state = 397, .external_lex_state = 25},
  [4483] = {.lex_state = 177, .external_lex_state = 4},
  [4484] = {.lex_state = 266, .external_lex_state = 15},
  [4485] = {.lex_state = 397, .external_lex_state = 25},
  [4486] = {.lex_state = 192, .external_lex_state = 15},
  [4487] = {.lex_state = 266, .external_lex_state = 15},
  [4488] = {.lex_state = 397, .external_lex_state = 25},
  [4489] = {.lex_state = 177, .external_lex_state = 4},
  [4490] = {.lex_state = 266, .external_lex_state = 15},
  [4491] = {.lex_state = 397, .external_lex_state = 25},
  [4492] = {.lex_state = 421, .external_lex_state = 25},
  [4493] = {.lex_state = 299, .external_lex_state = 16},
  [4494] = {.lex_state = 194},
  [4495] = {.lex_state = 397, .external_lex_state = 25},
  [4496] = {.lex_state = 194},
  [4497] = {.lex_state = 302, .external_lex_state = 16},
  [4498] = {.lex_state = 225, .external_lex_state = 7},
  [4499] = {.lex_state = 128, .external_lex_state = 2},
  [4500] = {.lex_state = 397, .external_lex_state = 25},
  [4501] = {.lex_state = 247, .external_lex_state = 3},
  [4502] = {.lex_state = 128, .external_lex_state = 8},
  [4503] = {.lex_state = 128, .external_lex_state = 2},
  [4504] = {.lex_state = 397, .external_lex_state = 25},
  [4505] = {.lex_state = 128, .external_lex_state = 2},
  [4506] = {.lex_state = 128, .external_lex_state = 12},
  [4507] = {.lex_state = 128, .external_lex_state = 2},
  [4508] = {.lex_state = 128, .external_lex_state = 2},
  [4509] = {.lex_state = 128, .external_lex_state = 2},
  [4510] = {.lex_state = 128, .external_lex_state = 8},
  [4511] = {.lex_state = 299, .external_lex_state = 16},
  [4512] = {.lex_state = 128},
  [4513] = {.lex_state = 128, .external_lex_state = 2},
  [4514] = {.lex_state = 128, .external_lex_state = 12},
  [4515] = {.lex_state = 128},
  [4516] = {.lex_state = 128},
  [4517] = {.lex_state = 128},
  [4518] = {.lex_state = 397, .external_lex_state = 25},
  [4519] = {.lex_state = 128},
  [4520] = {.lex_state = 128},
  [4521] = {.lex_state = 128},
  [4522] = {.lex_state = 397, .external_lex_state = 25},
  [4523] = {.lex_state = 397, .external_lex_state = 25},
  [4524] = {.lex_state = 209},
  [4525] = {.lex_state = 397, .external_lex_state = 25},
  [4526] = {.lex_state = 235},
  [4527] = {.lex_state = 397, .external_lex_state = 25},
  [4528] = {.lex_state = 397, .external_lex_state = 25},
  [4529] = {.lex_state = 421, .external_lex_state = 25},
  [4530] = {.lex_state = 421, .external_lex_state = 25},
  [4531] = {.lex_state = 421, .external_lex_state = 25},
  [4532] = {.lex_state = 421, .external_lex_state = 25},
  [4533] = {.lex_state = 421, .external_lex_state = 25},
  [4534] = {.lex_state = 421, .external_lex_state = 25},
  [4535] = {.lex_state = 421, .external_lex_state = 25},
  [4536] = {.lex_state = 554, .external_lex_state = 16},
  [4537] = {.lex_state = 421, .external_lex_state = 25},
  [4538] = {.lex_state = 421, .external_lex_state = 25},
  [4539] = {.lex_state = 421, .external_lex_state = 25},
  [4540] = {.lex_state = 421, .external_lex_state = 25},
  [4541] = {.lex_state = 421, .external_lex_state = 25},
  [4542] = {.lex_state = 299, .external_lex_state = 16},
  [4543] = {.lex_state = 397, .external_lex_state = 25},
  [4544] = {.lex_state = 177, .external_lex_state = 17},
  [4545] = {.lex_state = 421, .external_lex_state = 25},
  [4546] = {.lex_state = 397, .external_lex_state = 25},
  [4547] = {.lex_state = 524, .external_lex_state = 21},
  [4548] = {.lex_state = 421, .external_lex_state = 25},
  [4549] = {.lex_state = 421, .external_lex_state = 25},
  [4550] = {.lex_state = 421, .external_lex_state = 25},
  [4551] = {.lex_state = 397, .external_lex_state = 25},
  [4552] = {.lex_state = 421, .external_lex_state = 25},
  [4553] = {.lex_state = 421, .external_lex_state = 25},
  [4554] = {.lex_state = 421, .external_lex_state = 27},
  [4555] = {.lex_state = 302, .external_lex_state = 16},
  [4556] = {.lex_state = 302, .external_lex_state = 16},
  [4557] = {.lex_state = 302, .external_lex_state = 16},
  [4558] = {.lex_state = 302, .external_lex_state = 16},
  [4559] = {.lex_state = 192, .external_lex_state = 2},
  [4560] = {.lex_state = 192, .external_lex_state = 2},
  [4561] = {.lex_state = 192, .external_lex_state = 2},
  [4562] = {.lex_state = 192, .external_lex_state = 2},
  [4563] = {.lex_state = 192, .external_lex_state = 2},
  [4564] = {.lex_state = 192, .external_lex_state = 2},
  [4565] = {.lex_state = 192, .external_lex_state = 2},
  [4566] = {.lex_state = 192, .external_lex_state = 2},
  [4567] = {.lex_state = 192, .external_lex_state = 2},
  [4568] = {.lex_state = 192, .external_lex_state = 2},
  [4569] = {.lex_state = 192, .external_lex_state = 2},
  [4570] = {.lex_state = 192, .external_lex_state = 2},
  [4571] = {.lex_state = 192, .external_lex_state = 29},
  [4572] = {.lex_state = 302, .external_lex_state = 16},
  [4573] = {.lex_state = 192, .external_lex_state = 29},
  [4574] = {.lex_state = 192, .external_lex_state = 2},
  [4575] = {.lex_state = 156, .external_lex_state = 20},
  [4576] = {.lex_state = 194, .external_lex_state = 6},
  [4577] = {.lex_state = 177, .external_lex_state = 17},
  [4578] = {.lex_state = 194, .external_lex_state = 19},
  [4579] = {.lex_state = 192, .external_lex_state = 2},
  [4580] = {.lex_state = 192, .external_lex_state = 2},
  [4581] = {.lex_state = 192, .external_lex_state = 2},
  [4582] = {.lex_state = 192, .external_lex_state = 2},
  [4583] = {.lex_state = 493, .external_lex_state = 25},
  [4584] = {.lex_state = 213},
  [4585] = {.lex_state = 321, .external_lex_state = 25},
  [4586] = {.lex_state = 493, .external_lex_state = 25},
  [4587] = {.lex_state = 493, .external_lex_state = 25},
  [4588] = {.lex_state = 192, .external_lex_state = 2},
  [4589] = {.lex_state = 493, .external_lex_state = 25},
  [4590] = {.lex_state = 493, .external_lex_state = 25},
  [4591] = {.lex_state = 493, .external_lex_state = 25},
  [4592] = {.lex_state = 192, .external_lex_state = 2},
  [4593] = {.lex_state = 192, .external_lex_state = 2},
  [4594] = {.lex_state = 192, .external_lex_state = 2},
  [4595] = {.lex_state = 192, .external_lex_state = 2},
  [4596] = {.lex_state = 192, .external_lex_state = 2},
  [4597] = {.lex_state = 192, .external_lex_state = 2},
  [4598] = {.lex_state = 192, .external_lex_state = 2},
  [4599] = {.lex_state = 192, .external_lex_state = 2},
  [4600] = {.lex_state = 192, .external_lex_state = 2},
  [4601] = {.lex_state = 192, .external_lex_state = 2},
  [4602] = {.lex_state = 192, .external_lex_state = 2},
  [4603] = {.lex_state = 192, .external_lex_state = 2},
  [4604] = {.lex_state = 192, .external_lex_state = 2},
  [4605] = {.lex_state = 324, .external_lex_state = 25},
  [4606] = {.lex_state = 524, .external_lex_state = 13},
  [4607] = {.lex_state = 493, .external_lex_state = 25},
  [4608] = {.lex_state = 192, .external_lex_state = 29},
  [4609] = {.lex_state = 192, .external_lex_state = 2},
  [4610] = {.lex_state = 302, .external_lex_state = 16},
  [4611] = {.lex_state = 302, .external_lex_state = 16},
  [4612] = {.lex_state = 225, .external_lex_state = 7},
  [4613] = {.lex_state = 302, .external_lex_state = 16},
  [4614] = {.lex_state = 302, .external_lex_state = 16},
  [4615] = {.lex_state = 302, .external_lex_state = 16},
  [4616] = {.lex_state = 302, .external_lex_state = 16},
  [4617] = {.lex_state = 554, .external_lex_state = 16},
  [4618] = {.lex_state = 302, .external_lex_state = 16},
  [4619] = {.lex_state = 302, .external_lex_state = 16},
  [4620] = {.lex_state = 302, .external_lex_state = 16},
  [4621] = {.lex_state = 302, .external_lex_state = 16},
  [4622] = {.lex_state = 302, .external_lex_state = 16},
  [4623] = {.lex_state = 192, .external_lex_state = 2},
  [4624] = {.lex_state = 478, .external_lex_state = 26},
  [4625] = {.lex_state = 478, .external_lex_state = 26},
  [4626] = {.lex_state = 478, .external_lex_state = 26},
  [4627] = {.lex_state = 478, .external_lex_state = 26},
  [4628] = {.lex_state = 192, .external_lex_state = 2},
  [4629] = {.lex_state = 192, .external_lex_state = 2},
  [4630] = {.lex_state = 192, .external_lex_state = 2},
  [4631] = {.lex_state = 321, .external_lex_state = 25},
  [4632] = {.lex_state = 478, .external_lex_state = 26},
  [4633] = {.lex_state = 213},
  [4634] = {.lex_state = 321, .external_lex_state = 25},
  [4635] = {.lex_state = 321, .external_lex_state = 27},
  [4636] = {.lex_state = 321, .external_lex_state = 25},
  [4637] = {.lex_state = 497, .external_lex_state = 25},
  [4638] = {.lex_state = 614, .external_lex_state = 27},
  [4639] = {.lex_state = 192, .external_lex_state = 2},
  [4640] = {.lex_state = 321, .external_lex_state = 25},
  [4641] = {.lex_state = 497, .external_lex_state = 25},
  [4642] = {.lex_state = 497, .external_lex_state = 25},
  [4643] = {.lex_state = 192, .external_lex_state = 2},
  [4644] = {.lex_state = 192, .external_lex_state = 2},
  [4645] = {.lex_state = 192, .external_lex_state = 2},
  [4646] = {.lex_state = 192, .external_lex_state = 2},
  [4647] = {.lex_state = 192, .external_lex_state = 2},
  [4648] = {.lex_state = 192, .external_lex_state = 2},
  [4649] = {.lex_state = 192, .external_lex_state = 2},
  [4650] = {.lex_state = 192, .external_lex_state = 2},
  [4651] = {.lex_state = 192, .external_lex_state = 2},
  [4652] = {.lex_state = 192, .external_lex_state = 2},
  [4653] = {.lex_state = 192, .external_lex_state = 2},
  [4654] = {.lex_state = 192, .external_lex_state = 2},
  [4655] = {.lex_state = 192, .external_lex_state = 2},
  [4656] = {.lex_state = 321, .external_lex_state = 25},
  [4657] = {.lex_state = 524, .external_lex_state = 13},
  [4658] = {.lex_state = 321, .external_lex_state = 25},
  [4659] = {.lex_state = 192, .external_lex_state = 29},
  [4660] = {.lex_state = 192, .external_lex_state = 2},
  [4661] = {.lex_state = 614, .external_lex_state = 27},
  [4662] = {.lex_state = 192, .external_lex_state = 2},
  [4663] = {.lex_state = 192, .external_lex_state = 2},
  [4664] = {.lex_state = 635, .external_lex_state = 18},
  [4665] = {.lex_state = 635, .external_lex_state = 18},
  [4666] = {.lex_state = 635, .external_lex_state = 18},
  [4667] = {.lex_state = 635, .external_lex_state = 18},
  [4668] = {.lex_state = 192, .external_lex_state = 2},
  [4669] = {.lex_state = 192, .external_lex_state = 2},
  [4670] = {.lex_state = 192, .external_lex_state = 2},
  [4671] = {.lex_state = 302, .external_lex_state = 16},
  [4672] = {.lex_state = 302, .external_lex_state = 16},
  [4673] = {.lex_state = 213},
  [4674] = {.lex_state = 321, .external_lex_state = 16},
  [4675] = {.lex_state = 610, .external_lex_state = 20},
  [4676] = {.lex_state = 302, .external_lex_state = 16},
  [4677] = {.lex_state = 324, .external_lex_state = 20},
  [4678] = {.lex_state = 128, .external_lex_state = 2},
  [4679] = {.lex_state = 128, .external_lex_state = 12},
  [4680] = {.lex_state = 302},
  [4681] = {.lex_state = 409, .external_lex_state = 2},
  [4682] = {.lex_state = 414, .external_lex_state = 12},
  [4683] = {.lex_state = 128},
  [4684] = {.lex_state = 254, .external_lex_state = 8},
  [4685] = {.lex_state = 528, .external_lex_state = 3},
  [4686] = {.lex_state = 528, .external_lex_state = 3},
  [4687] = {.lex_state = 197},
  [4688] = {.lex_state = 254, .external_lex_state = 8},
  [4689] = {.lex_state = 192, .external_lex_state = 2},
  [4690] = {.lex_state = 671, .external_lex_state = 26},
  [4691] = {.lex_state = 671, .external_lex_state = 26},
  [4692] = {.lex_state = 671, .external_lex_state = 26},
  [4693] = {.lex_state = 671, .external_lex_state = 26},
  [4694] = {.lex_state = 192, .external_lex_state = 2},
  [4695] = {.lex_state = 192, .external_lex_state = 2},
  [4696] = {.lex_state = 192, .external_lex_state = 2},
  [4697] = {.lex_state = 621, .external_lex_state = 25},
  [4698] = {.lex_state = 213},
  [4699] = {.lex_state = 321, .external_lex_state = 25},
  [4700] = {.lex_state = 621, .external_lex_state = 27},
  [4701] = {.lex_state = 621, .external_lex_state = 25},
  [4702] = {.lex_state = 604, .external_lex_state = 25},
  [4703] = {.lex_state = 674, .external_lex_state = 27},
  [4704] = {.lex_state = 192, .external_lex_state = 2},
  [4705] = {.lex_state = 621, .external_lex_state = 25},
  [4706] = {.lex_state = 192, .external_lex_state = 2},
  [4707] = {.lex_state = 192, .external_lex_state = 2},
  [4708] = {.lex_state = 237},
  [4709] = {.lex_state = 192, .external_lex_state = 2},
  [4710] = {.lex_state = 520, .external_lex_state = 26},
  [4711] = {.lex_state = 604, .external_lex_state = 25},
  [4712] = {.lex_state = 604, .external_lex_state = 25},
  [4713] = {.lex_state = 604, .external_lex_state = 25},
  [4714] = {.lex_state = 604, .external_lex_state = 27},
  [4715] = {.lex_state = 604, .external_lex_state = 25},
  [4716] = {.lex_state = 604, .external_lex_state = 25},
  [4717] = {.lex_state = 192, .external_lex_state = 2},
  [4718] = {.lex_state = 192, .external_lex_state = 2},
  [4719] = {.lex_state = 192, .external_lex_state = 2},
  [4720] = {.lex_state = 192, .external_lex_state = 2},
  [4721] = {.lex_state = 192, .external_lex_state = 2},
  [4722] = {.lex_state = 192, .external_lex_state = 2},
  [4723] = {.lex_state = 192, .external_lex_state = 2},
  [4724] = {.lex_state = 192, .external_lex_state = 2},
  [4725] = {.lex_state = 192, .external_lex_state = 2},
  [4726] = {.lex_state = 192, .external_lex_state = 2},
  [4727] = {.lex_state = 192, .external_lex_state = 2},
  [4728] = {.lex_state = 192, .external_lex_state = 2},
  [4729] = {.lex_state = 192, .external_lex_state = 2},
  [4730] = {.lex_state = 337, .external_lex_state = 19},
  [4731] = {.lex_state = 524, .external_lex_state = 13},
  [4732] = {.lex_state = 337, .external_lex_state = 19},
  [4733] = {.lex_state = 192, .external_lex_state = 29},
  [4734] = {.lex_state = 192, .external_lex_state = 2},
  [4735] = {.lex_state = 674, .external_lex_state = 27},
  [4736] = {.lex_state = 493, .external_lex_state = 3},
  [4737] = {.lex_state = 493, .external_lex_state = 3},
  [4738] = {.lex_state = 493, .external_lex_state = 3},
  [4739] = {.lex_state = 493, .external_lex_state = 3},
  [4740] = {.lex_state = 493, .external_lex_state = 3},
  [4741] = {.lex_state = 192, .external_lex_state = 2},
  [4742] = {.lex_state = 192, .external_lex_state = 2},
  [4743] = {.lex_state = 192, .external_lex_state = 2},
  [4744] = {.lex_state = 192, .external_lex_state = 2},
  [4745] = {.lex_state = 192, .external_lex_state = 2},
  [4746] = {.lex_state = 192, .external_lex_state = 2},
  [4747] = {.lex_state = 192, .external_lex_state = 2},
  [4748] = {.lex_state = 192, .external_lex_state = 2},
  [4749] = {.lex_state = 192, .external_lex_state = 2},
  [4750] = {.lex_state = 192, .external_lex_state = 2},
  [4751] = {.lex_state = 192, .external_lex_state = 2},
  [4752] = {.lex_state = 192, .external_lex_state = 2},
  [4753] = {.lex_state = 192, .external_lex_state = 29},
  [4754] = {.lex_state = 192, .external_lex_state = 2},
  [4755] = {.lex_state = 610, .external_lex_state = 14},
  [4756] = {.lex_state = 493, .external_lex_state = 3},
  [4757] = {.lex_state = 493, .external_lex_state = 3},
  [4758] = {.lex_state = 493, .external_lex_state = 3},
  [4759] = {.lex_state = 192, .external_lex_state = 2},
  [4760] = {.lex_state = 493, .external_lex_state = 3},
  [4761] = {.lex_state = 192, .external_lex_state = 2},
  [4762] = {.lex_state = 493, .external_lex_state = 3},
  [4763] = {.lex_state = 524, .external_lex_state = 13},
  [4764] = {.lex_state = 493, .external_lex_state = 3},
  [4765] = {.lex_state = 493, .external_lex_state = 3},
  [4766] = {.lex_state = 493, .external_lex_state = 3},
  [4767] = {.lex_state = 493, .external_lex_state = 3},
  [4768] = {.lex_state = 493, .external_lex_state = 3},
  [4769] = {.lex_state = 493, .external_lex_state = 3},
  [4770] = {.lex_state = 493, .external_lex_state = 3},
  [4771] = {.lex_state = 493, .external_lex_state = 3},
  [4772] = {.lex_state = 554, .external_lex_state = 16},
  [4773] = {.lex_state = 493, .external_lex_state = 3},
  [4774] = {.lex_state = 493, .external_lex_state = 3},
  [4775] = {.lex_state = 493, .external_lex_state = 3},
  [4776] = {.lex_state = 493, .external_lex_state = 3},
  [4777] = {.lex_state = 493, .external_lex_state = 3},
  [4778] = {.lex_state = 497, .external_lex_state = 3},
  [4779] = {.lex_state = 497, .external_lex_state = 3},
  [4780] = {.lex_state = 192, .external_lex_state = 2},
  [4781] = {.lex_state = 497, .external_lex_state = 3},
  [4782] = {.lex_state = 192, .external_lex_state = 2},
  [4783] = {.lex_state = 497, .external_lex_state = 3},
  [4784] = {.lex_state = 524, .external_lex_state = 13},
  [4785] = {.lex_state = 497, .external_lex_state = 3},
  [4786] = {.lex_state = 324, .external_lex_state = 3},
  [4787] = {.lex_state = 524, .external_lex_state = 21},
  [4788] = {.lex_state = 324, .external_lex_state = 3},
  [4789] = {.lex_state = 493, .external_lex_state = 3},
  [4790] = {.lex_state = 493, .external_lex_state = 3},
  [4791] = {.lex_state = 493, .external_lex_state = 3},
  [4792] = {.lex_state = 493, .external_lex_state = 3},
  [4793] = {.lex_state = 613, .external_lex_state = 14},
  [4794] = {.lex_state = 302, .external_lex_state = 8},
  [4795] = {.lex_state = 128, .external_lex_state = 2},
  [4796] = {.lex_state = 192, .external_lex_state = 2},
  [4797] = {.lex_state = 321, .external_lex_state = 3},
  [4798] = {.lex_state = 321, .external_lex_state = 3},
  [4799] = {.lex_state = 321, .external_lex_state = 3},
  [4800] = {.lex_state = 192, .external_lex_state = 2},
  [4801] = {.lex_state = 192, .external_lex_state = 2},
  [4802] = {.lex_state = 192, .external_lex_state = 2},
  [4803] = {.lex_state = 192, .external_lex_state = 2},
  [4804] = {.lex_state = 192, .external_lex_state = 2},
  [4805] = {.lex_state = 192, .external_lex_state = 2},
  [4806] = {.lex_state = 192, .external_lex_state = 2},
  [4807] = {.lex_state = 192, .external_lex_state = 2},
  [4808] = {.lex_state = 192, .external_lex_state = 2},
  [4809] = {.lex_state = 192, .external_lex_state = 2},
  [4810] = {.lex_state = 192, .external_lex_state = 2},
  [4811] = {.lex_state = 192, .external_lex_state = 2},
  [4812] = {.lex_state = 192, .external_lex_state = 29},
  [4813] = {.lex_state = 192, .external_lex_state = 2},
  [4814] = {.lex_state = 321, .external_lex_state = 14},
  [4815] = {.lex_state = 321, .external_lex_state = 3},
  [4816] = {.lex_state = 497, .external_lex_state = 3},
  [4817] = {.lex_state = 497, .external_lex_state = 3},
  [4818] = {.lex_state = 497, .external_lex_state = 3},
  [4819] = {.lex_state = 497, .external_lex_state = 3},
  [4820] = {.lex_state = 497, .external_lex_state = 3},
  [4821] = {.lex_state = 497, .external_lex_state = 3},
  [4822] = {.lex_state = 321, .external_lex_state = 3},
  [4823] = {.lex_state = 554, .external_lex_state = 16},
  [4824] = {.lex_state = 497, .external_lex_state = 3},
  [4825] = {.lex_state = 497, .external_lex_state = 3},
  [4826] = {.lex_state = 497, .external_lex_state = 3},
  [4827] = {.lex_state = 497, .external_lex_state = 3},
  [4828] = {.lex_state = 497, .external_lex_state = 3},
  [4829] = {.lex_state = 321, .external_lex_state = 3},
  [4830] = {.lex_state = 524, .external_lex_state = 21},
  [4831] = {.lex_state = 321, .external_lex_state = 3},
  [4832] = {.lex_state = 321, .external_lex_state = 3},
  [4833] = {.lex_state = 497, .external_lex_state = 3},
  [4834] = {.lex_state = 497, .external_lex_state = 3},
  [4835] = {.lex_state = 497, .external_lex_state = 3},
  [4836] = {.lex_state = 614, .external_lex_state = 14},
  [4837] = {.lex_state = 302, .external_lex_state = 3},
  [4838] = {.lex_state = 302, .external_lex_state = 3},
  [4839] = {.lex_state = 302, .external_lex_state = 3},
  [4840] = {.lex_state = 302, .external_lex_state = 3},
  [4841] = {.lex_state = 192, .external_lex_state = 2},
  [4842] = {.lex_state = 192, .external_lex_state = 2},
  [4843] = {.lex_state = 192, .external_lex_state = 2},
  [4844] = {.lex_state = 192, .external_lex_state = 2},
  [4845] = {.lex_state = 192, .external_lex_state = 2},
  [4846] = {.lex_state = 192, .external_lex_state = 2},
  [4847] = {.lex_state = 192, .external_lex_state = 2},
  [4848] = {.lex_state = 192, .external_lex_state = 2},
  [4849] = {.lex_state = 192, .external_lex_state = 2},
  [4850] = {.lex_state = 192, .external_lex_state = 2},
  [4851] = {.lex_state = 192, .external_lex_state = 2},
  [4852] = {.lex_state = 192, .external_lex_state = 2},
  [4853] = {.lex_state = 192, .external_lex_state = 29},
  [4854] = {.lex_state = 302, .external_lex_state = 3},
  [4855] = {.lex_state = 192, .external_lex_state = 29},
  [4856] = {.lex_state = 192, .external_lex_state = 2},
  [4857] = {.lex_state = 330},
  [4858] = {.lex_state = 330},
  [4859] = {.lex_state = 177, .external_lex_state = 4},
  [4860] = {.lex_state = 266, .external_lex_state = 15},
  [4861] = {.lex_state = 330},
  [4862] = {.lex_state = 177, .external_lex_state = 4},
  [4863] = {.lex_state = 330},
  [4864] = {.lex_state = 330},
  [4865] = {.lex_state = 177, .external_lex_state = 4},
  [4866] = {.lex_state = 266, .external_lex_state = 15},
  [4867] = {.lex_state = 330},
  [4868] = {.lex_state = 177, .external_lex_state = 4},
  [4869] = {.lex_state = 330},
  [4870] = {.lex_state = 310},
  [4871] = {.lex_state = 330},
  [4872] = {.lex_state = 330},
  [4873] = {.lex_state = 128, .external_lex_state = 2},
  [4874] = {.lex_state = 128, .external_lex_state = 2},
  [4875] = {.lex_state = 330},
  [4876] = {.lex_state = 330},
  [4877] = {.lex_state = 361, .external_lex_state = 25},
  [4878] = {.lex_state = 192, .external_lex_state = 2},
  [4879] = {.lex_state = 192, .external_lex_state = 2},
  [4880] = {.lex_state = 237},
  [4881] = {.lex_state = 192, .external_lex_state = 2},
  [4882] = {.lex_state = 296, .external_lex_state = 26},
  [4883] = {.lex_state = 361, .external_lex_state = 25},
  [4884] = {.lex_state = 361, .external_lex_state = 25},
  [4885] = {.lex_state = 361, .external_lex_state = 25},
  [4886] = {.lex_state = 371, .external_lex_state = 27},
  [4887] = {.lex_state = 361, .external_lex_state = 25},
  [4888] = {.lex_state = 361, .external_lex_state = 25},
  [4889] = {.lex_state = 192, .external_lex_state = 2},
  [4890] = {.lex_state = 192, .external_lex_state = 2},
  [4891] = {.lex_state = 192, .external_lex_state = 2},
  [4892] = {.lex_state = 192, .external_lex_state = 2},
  [4893] = {.lex_state = 192, .external_lex_state = 2},
  [4894] = {.lex_state = 192, .external_lex_state = 2},
  [4895] = {.lex_state = 192, .external_lex_state = 2},
  [4896] = {.lex_state = 192, .external_lex_state = 2},
  [4897] = {.lex_state = 192, .external_lex_state = 2},
  [4898] = {.lex_state = 192, .external_lex_state = 2},
  [4899] = {.lex_state = 192, .external_lex_state = 2},
  [4900] = {.lex_state = 192, .external_lex_state = 2},
  [4901] = {.lex_state = 192, .external_lex_state = 2},
  [4902] = {.lex_state = 192, .external_lex_state = 2},
  [4903] = {.lex_state = 237},
  [4904] = {.lex_state = 192, .external_lex_state = 2},
  [4905] = {.lex_state = 296, .external_lex_state = 26},
  [4906] = {.lex_state = 421, .external_lex_state = 25},
  [4907] = {.lex_state = 424, .external_lex_state = 25},
  [4908] = {.lex_state = 424, .external_lex_state = 25},
  [4909] = {.lex_state = 427, .external_lex_state = 27},
  [4910] = {.lex_state = 192, .external_lex_state = 29},
  [4911] = {.lex_state = 192, .external_lex_state = 2},
  [4912] = {.lex_state = 365, .external_lex_state = 27},
  [4913] = {.lex_state = 361, .external_lex_state = 25},
  [4914] = {.lex_state = 337, .external_lex_state = 19},
  [4915] = {.lex_state = 209},
  [4916] = {.lex_state = 361, .external_lex_state = 25},
  [4917] = {.lex_state = 337, .external_lex_state = 19},
  [4918] = {.lex_state = 177, .external_lex_state = 17},
  [4919] = {.lex_state = 334, .external_lex_state = 19},
  [4920] = {.lex_state = 337, .external_lex_state = 19},
  [4921] = {.lex_state = 524, .external_lex_state = 21},
  [4922] = {.lex_state = 334, .external_lex_state = 19},
  [4923] = {.lex_state = 340, .external_lex_state = 19},
  [4924] = {.lex_state = 330},
  [4925] = {.lex_state = 128},
  [4926] = {.lex_state = 128},
  [4927] = {.lex_state = 128, .external_lex_state = 2},
  [4928] = {.lex_state = 330},
  [4929] = {.lex_state = 128},
  [4930] = {.lex_state = 128},
  [4931] = {.lex_state = 330},
  [4932] = {.lex_state = 128},
  [4933] = {.lex_state = 330},
  [4934] = {.lex_state = 128},
  [4935] = {.lex_state = 128, .external_lex_state = 2},
  [4936] = {.lex_state = 128},
  [4937] = {.lex_state = 128},
  [4938] = {.lex_state = 330},
  [4939] = {.lex_state = 330},
  [4940] = {.lex_state = 128},
  [4941] = {.lex_state = 128},
  [4942] = {.lex_state = 330},
  [4943] = {.lex_state = 337},
  [4944] = {.lex_state = 194},
  [4945] = {.lex_state = 337},
  [4946] = {.lex_state = 128},
  [4947] = {.lex_state = 128, .external_lex_state = 2},
  [4948] = {.lex_state = 128, .external_lex_state = 12},
  [4949] = {.lex_state = 484, .external_lex_state = 21},
  [4950] = {.lex_state = 209, .external_lex_state = 19},
  [4951] = {.lex_state = 209},
  [4952] = {.lex_state = 484, .external_lex_state = 21},
  [4953] = {.lex_state = 337},
  [4954] = {.lex_state = 235},
  [4955] = {.lex_state = 675, .external_lex_state = 27},
  [4956] = {.lex_state = 192, .external_lex_state = 15},
  [4957] = {.lex_state = 621, .external_lex_state = 25},
  [4958] = {.lex_state = 192, .external_lex_state = 15},
  [4959] = {.lex_state = 621, .external_lex_state = 25},
  [4960] = {.lex_state = 192, .external_lex_state = 15},
  [4961] = {.lex_state = 621, .external_lex_state = 25},
  [4962] = {.lex_state = 192, .external_lex_state = 15},
  [4963] = {.lex_state = 621, .external_lex_state = 25},
  [4964] = {.lex_state = 190, .external_lex_state = 4},
  [4965] = {.lex_state = 266, .external_lex_state = 15},
  [4966] = {.lex_state = 621, .external_lex_state = 25},
  [4967] = {.lex_state = 190, .external_lex_state = 4},
  [4968] = {.lex_state = 266, .external_lex_state = 15},
  [4969] = {.lex_state = 627, .external_lex_state = 25},
  [4970] = {.lex_state = 621, .external_lex_state = 25},
  [4971] = {.lex_state = 194},
  [4972] = {.lex_state = 194, .external_lex_state = 19},
  [4973] = {.lex_state = 192, .external_lex_state = 2},
  [4974] = {.lex_state = 621, .external_lex_state = 25},
  [4975] = {.lex_state = 310},
  [4976] = {.lex_state = 310, .external_lex_state = 8},
  [4977] = {.lex_state = 621, .external_lex_state = 25},
  [4978] = {.lex_state = 209},
  [4979] = {.lex_state = 192, .external_lex_state = 2},
  [4980] = {.lex_state = 346, .external_lex_state = 23},
  [4981] = {.lex_state = 346, .external_lex_state = 23},
  [4982] = {.lex_state = 350, .external_lex_state = 23},
  [4983] = {.lex_state = 350, .external_lex_state = 23},
  [4984] = {.lex_state = 192, .external_lex_state = 2},
  [4985] = {.lex_state = 192, .external_lex_state = 2},
  [4986] = {.lex_state = 237},
  [4987] = {.lex_state = 192, .external_lex_state = 2},
  [4988] = {.lex_state = 356, .external_lex_state = 13},
  [4989] = {.lex_state = 296, .external_lex_state = 26},
  [4990] = {.lex_state = 505, .external_lex_state = 25},
  [4991] = {.lex_state = 621, .external_lex_state = 25},
  [4992] = {.lex_state = 627, .external_lex_state = 25},
  [4993] = {.lex_state = 627, .external_lex_state = 25},
  [4994] = {.lex_state = 505, .external_lex_state = 27},
  [4995] = {.lex_state = 621, .external_lex_state = 25},
  [4996] = {.lex_state = 621, .external_lex_state = 25},
  [4997] = {.lex_state = 621, .external_lex_state = 25},
  [4998] = {.lex_state = 128, .external_lex_state = 8},
  [4999] = {.lex_state = 128, .external_lex_state = 8},
  [5000] = {.lex_state = 247, .external_lex_state = 3},
  [5001] = {.lex_state = 247, .external_lex_state = 3},
  [5002] = {.lex_state = 128},
  [5003] = {.lex_state = 247, .external_lex_state = 3},
  [5004] = {.lex_state = 128},
  [5005] = {.lex_state = 128},
  [5006] = {.lex_state = 128},
  [5007] = {.lex_state = 128},
  [5008] = {.lex_state = 128},
  [5009] = {.lex_state = 621, .external_lex_state = 25},
  [5010] = {.lex_state = 128, .external_lex_state = 2},
  [5011] = {.lex_state = 627, .external_lex_state = 25},
  [5012] = {.lex_state = 627, .external_lex_state = 25},
  [5013] = {.lex_state = 621, .external_lex_state = 25},
  [5014] = {.lex_state = 621, .external_lex_state = 25},
  [5015] = {.lex_state = 621, .external_lex_state = 25},
  [5016] = {.lex_state = 235, .external_lex_state = 19},
  [5017] = {.lex_state = 235},
  [5018] = {.lex_state = 409, .external_lex_state = 2},
  [5019] = {.lex_state = 414, .external_lex_state = 12},
  [5020] = {.lex_state = 128},
  [5021] = {.lex_state = 621, .external_lex_state = 25},
  [5022] = {.lex_state = 192, .external_lex_state = 2},
  [5023] = {.lex_state = 192, .external_lex_state = 2},
  [5024] = {.lex_state = 192, .external_lex_state = 2},
  [5025] = {.lex_state = 192, .external_lex_state = 2},
  [5026] = {.lex_state = 192, .external_lex_state = 2},
  [5027] = {.lex_state = 192, .external_lex_state = 2},
  [5028] = {.lex_state = 192, .external_lex_state = 2},
  [5029] = {.lex_state = 192, .external_lex_state = 2},
  [5030] = {.lex_state = 192, .external_lex_state = 2},
  [5031] = {.lex_state = 192, .external_lex_state = 2},
  [5032] = {.lex_state = 192, .external_lex_state = 2},
  [5033] = {.lex_state = 192, .external_lex_state = 2},
  [5034] = {.lex_state = 419, .external_lex_state = 6},
  [5035] = {.lex_state = 461, .external_lex_state = 25},
  [5036] = {.lex_state = 192, .external_lex_state = 29},
  [5037] = {.lex_state = 192, .external_lex_state = 2},
  [5038] = {.lex_state = 627, .external_lex_state = 27},
  [5039] = {.lex_state = 627, .external_lex_state = 25},
  [5040] = {.lex_state = 505, .external_lex_state = 25},
  [5041] = {.lex_state = 505, .external_lex_state = 25},
  [5042] = {.lex_state = 192, .external_lex_state = 2},
  [5043] = {.lex_state = 505, .external_lex_state = 25},
  [5044] = {.lex_state = 192, .external_lex_state = 2},
  [5045] = {.lex_state = 505, .external_lex_state = 25},
  [5046] = {.lex_state = 524, .external_lex_state = 13},
  [5047] = {.lex_state = 505, .external_lex_state = 25},
  [5048] = {.lex_state = 505, .external_lex_state = 25},
  [5049] = {.lex_state = 505, .external_lex_state = 25},
  [5050] = {.lex_state = 505, .external_lex_state = 25},
  [5051] = {.lex_state = 505, .external_lex_state = 25},
  [5052] = {.lex_state = 505, .external_lex_state = 25},
  [5053] = {.lex_state = 505, .external_lex_state = 25},
  [5054] = {.lex_state = 627, .external_lex_state = 25},
  [5055] = {.lex_state = 554, .external_lex_state = 16},
  [5056] = {.lex_state = 505, .external_lex_state = 25},
  [5057] = {.lex_state = 505, .external_lex_state = 25},
  [5058] = {.lex_state = 505, .external_lex_state = 25},
  [5059] = {.lex_state = 505, .external_lex_state = 25},
  [5060] = {.lex_state = 505, .external_lex_state = 25},
  [5061] = {.lex_state = 340, .external_lex_state = 19},
  [5062] = {.lex_state = 524, .external_lex_state = 21},
  [5063] = {.lex_state = 340, .external_lex_state = 19},
  [5064] = {.lex_state = 340, .external_lex_state = 19},
  [5065] = {.lex_state = 505, .external_lex_state = 25},
  [5066] = {.lex_state = 505, .external_lex_state = 25},
  [5067] = {.lex_state = 505, .external_lex_state = 25},
  [5068] = {.lex_state = 630, .external_lex_state = 27},
  [5069] = {.lex_state = 156, .external_lex_state = 3},
  [5070] = {.lex_state = 156, .external_lex_state = 3},
  [5071] = {.lex_state = 508, .external_lex_state = 25},
  [5072] = {.lex_state = 192, .external_lex_state = 2},
  [5073] = {.lex_state = 192, .external_lex_state = 2},
  [5074] = {.lex_state = 237},
  [5075] = {.lex_state = 192, .external_lex_state = 2},
  [5076] = {.lex_state = 296, .external_lex_state = 26},
  [5077] = {.lex_state = 508, .external_lex_state = 25},
  [5078] = {.lex_state = 508, .external_lex_state = 25},
  [5079] = {.lex_state = 508, .external_lex_state = 25},
  [5080] = {.lex_state = 508, .external_lex_state = 27},
  [5081] = {.lex_state = 508, .external_lex_state = 25},
  [5082] = {.lex_state = 508, .external_lex_state = 25},
  [5083] = {.lex_state = 192, .external_lex_state = 2},
  [5084] = {.lex_state = 192, .external_lex_state = 2},
  [5085] = {.lex_state = 192, .external_lex_state = 2},
  [5086] = {.lex_state = 192, .external_lex_state = 2},
  [5087] = {.lex_state = 192, .external_lex_state = 2},
  [5088] = {.lex_state = 192, .external_lex_state = 2},
  [5089] = {.lex_state = 192, .external_lex_state = 2},
  [5090] = {.lex_state = 192, .external_lex_state = 2},
  [5091] = {.lex_state = 192, .external_lex_state = 2},
  [5092] = {.lex_state = 192, .external_lex_state = 2},
  [5093] = {.lex_state = 192, .external_lex_state = 2},
  [5094] = {.lex_state = 192, .external_lex_state = 2},
  [5095] = {.lex_state = 192, .external_lex_state = 29},
  [5096] = {.lex_state = 192, .external_lex_state = 2},
  [5097] = {.lex_state = 631, .external_lex_state = 27},
  [5098] = {.lex_state = 508, .external_lex_state = 25},
  [5099] = {.lex_state = 508, .external_lex_state = 25},
  [5100] = {.lex_state = 508, .external_lex_state = 25},
  [5101] = {.lex_state = 192, .external_lex_state = 2},
  [5102] = {.lex_state = 508, .external_lex_state = 25},
  [5103] = {.lex_state = 192, .external_lex_state = 2},
  [5104] = {.lex_state = 508, .external_lex_state = 25},
  [5105] = {.lex_state = 524, .external_lex_state = 13},
  [5106] = {.lex_state = 508, .external_lex_state = 25},
  [5107] = {.lex_state = 508, .external_lex_state = 25},
  [5108] = {.lex_state = 508, .external_lex_state = 25},
  [5109] = {.lex_state = 508, .external_lex_state = 25},
  [5110] = {.lex_state = 508, .external_lex_state = 25},
  [5111] = {.lex_state = 508, .external_lex_state = 25},
  [5112] = {.lex_state = 508, .external_lex_state = 25},
  [5113] = {.lex_state = 508, .external_lex_state = 25},
  [5114] = {.lex_state = 554, .external_lex_state = 16},
  [5115] = {.lex_state = 508, .external_lex_state = 25},
  [5116] = {.lex_state = 508, .external_lex_state = 25},
  [5117] = {.lex_state = 508, .external_lex_state = 25},
  [5118] = {.lex_state = 508, .external_lex_state = 25},
  [5119] = {.lex_state = 508, .external_lex_state = 25},
  [5120] = {.lex_state = 334, .external_lex_state = 19},
  [5121] = {.lex_state = 524, .external_lex_state = 21},
  [5122] = {.lex_state = 334, .external_lex_state = 19},
  [5123] = {.lex_state = 340, .external_lex_state = 19},
  [5124] = {.lex_state = 508, .external_lex_state = 25},
  [5125] = {.lex_state = 508, .external_lex_state = 25},
  [5126] = {.lex_state = 508, .external_lex_state = 25},
  [5127] = {.lex_state = 634, .external_lex_state = 27},
  [5128] = {.lex_state = 365, .external_lex_state = 3},
  [5129] = {.lex_state = 365, .external_lex_state = 3},
  [5130] = {.lex_state = 365, .external_lex_state = 3},
  [5131] = {.lex_state = 365, .external_lex_state = 3},
  [5132] = {.lex_state = 365, .external_lex_state = 3},
  [5133] = {.lex_state = 365, .external_lex_state = 3},
  [5134] = {.lex_state = 365, .external_lex_state = 3},
  [5135] = {.lex_state = 365, .external_lex_state = 3},
  [5136] = {.lex_state = 554, .external_lex_state = 16},
  [5137] = {.lex_state = 365, .external_lex_state = 3},
  [5138] = {.lex_state = 365, .external_lex_state = 3},
  [5139] = {.lex_state = 365, .external_lex_state = 3},
  [5140] = {.lex_state = 365, .external_lex_state = 3},
  [5141] = {.lex_state = 365, .external_lex_state = 3},
  [5142] = {.lex_state = 365, .external_lex_state = 3},
  [5143] = {.lex_state = 365, .external_lex_state = 3},
  [5144] = {.lex_state = 365, .external_lex_state = 3},
  [5145] = {.lex_state = 365, .external_lex_state = 14},
  [5146] = {.lex_state = 361, .external_lex_state = 3},
  [5147] = {.lex_state = 361, .external_lex_state = 3},
  [5148] = {.lex_state = 361, .external_lex_state = 3},
  [5149] = {.lex_state = 524, .external_lex_state = 21},
  [5150] = {.lex_state = 361, .external_lex_state = 3},
  [5151] = {.lex_state = 361, .external_lex_state = 3},
  [5152] = {.lex_state = 302, .external_lex_state = 25},
  [5153] = {.lex_state = 493, .external_lex_state = 25},
  [5154] = {.lex_state = 493, .external_lex_state = 25},
  [5155] = {.lex_state = 302, .external_lex_state = 25},
  [5156] = {.lex_state = 302, .external_lex_state = 25},
  [5157] = {.lex_state = 192, .external_lex_state = 2},
  [5158] = {.lex_state = 192, .external_lex_state = 2},
  [5159] = {.lex_state = 192, .external_lex_state = 2},
  [5160] = {.lex_state = 192, .external_lex_state = 2},
  [5161] = {.lex_state = 192, .external_lex_state = 2},
  [5162] = {.lex_state = 192, .external_lex_state = 2},
  [5163] = {.lex_state = 192, .external_lex_state = 2},
  [5164] = {.lex_state = 192, .external_lex_state = 2},
  [5165] = {.lex_state = 192, .external_lex_state = 2},
  [5166] = {.lex_state = 192, .external_lex_state = 2},
  [5167] = {.lex_state = 192, .external_lex_state = 2},
  [5168] = {.lex_state = 192, .external_lex_state = 2},
  [5169] = {.lex_state = 192, .external_lex_state = 29},
  [5170] = {.lex_state = 192, .external_lex_state = 2},
  [5171] = {.lex_state = 610, .external_lex_state = 27},
  [5172] = {.lex_state = 302, .external_lex_state = 25},
  [5173] = {.lex_state = 493, .external_lex_state = 25},
  [5174] = {.lex_state = 493, .external_lex_state = 25},
  [5175] = {.lex_state = 192, .external_lex_state = 2},
  [5176] = {.lex_state = 493, .external_lex_state = 25},
  [5177] = {.lex_state = 192, .external_lex_state = 2},
  [5178] = {.lex_state = 493, .external_lex_state = 25},
  [5179] = {.lex_state = 524, .external_lex_state = 13},
  [5180] = {.lex_state = 493, .external_lex_state = 25},
  [5181] = {.lex_state = 302, .external_lex_state = 25},
  [5182] = {.lex_state = 302, .external_lex_state = 25},
  [5183] = {.lex_state = 302, .external_lex_state = 25},
  [5184] = {.lex_state = 302, .external_lex_state = 25},
  [5185] = {.lex_state = 302, .external_lex_state = 25},
  [5186] = {.lex_state = 302, .external_lex_state = 25},
  [5187] = {.lex_state = 302, .external_lex_state = 25},
  [5188] = {.lex_state = 554, .external_lex_state = 16},
  [5189] = {.lex_state = 302, .external_lex_state = 25},
  [5190] = {.lex_state = 302, .external_lex_state = 25},
  [5191] = {.lex_state = 302, .external_lex_state = 25},
  [5192] = {.lex_state = 302, .external_lex_state = 25},
  [5193] = {.lex_state = 302, .external_lex_state = 25},
  [5194] = {.lex_state = 497, .external_lex_state = 25},
  [5195] = {.lex_state = 497, .external_lex_state = 25},
  [5196] = {.lex_state = 192, .external_lex_state = 2},
  [5197] = {.lex_state = 497, .external_lex_state = 25},
  [5198] = {.lex_state = 192, .external_lex_state = 2},
  [5199] = {.lex_state = 497, .external_lex_state = 25},
  [5200] = {.lex_state = 524, .external_lex_state = 13},
  [5201] = {.lex_state = 497, .external_lex_state = 25},
  [5202] = {.lex_state = 156, .external_lex_state = 3},
  [5203] = {.lex_state = 356, .external_lex_state = 13},
  [5204] = {.lex_state = 192, .external_lex_state = 2},
  [5205] = {.lex_state = 302, .external_lex_state = 25},
  [5206] = {.lex_state = 302, .external_lex_state = 25},
  [5207] = {.lex_state = 302, .external_lex_state = 25},
  [5208] = {.lex_state = 613, .external_lex_state = 27},
  [5209] = {.lex_state = 192, .external_lex_state = 2},
  [5210] = {.lex_state = 514, .external_lex_state = 11},
  [5211] = {.lex_state = 209, .external_lex_state = 19},
  [5212] = {.lex_state = 209},
  [5213] = {.lex_state = 514, .external_lex_state = 11},
  [5214] = {.lex_state = 299, .external_lex_state = 3},
  [5215] = {.lex_state = 235},
  [5216] = {.lex_state = 421, .external_lex_state = 3},
  [5217] = {.lex_state = 299, .external_lex_state = 3},
  [5218] = {.lex_state = 194},
  [5219] = {.lex_state = 299, .external_lex_state = 3},
  [5220] = {.lex_state = 128},
  [5221] = {.lex_state = 128, .external_lex_state = 2},
  [5222] = {.lex_state = 128, .external_lex_state = 12},
  [5223] = {.lex_state = 299, .external_lex_state = 3},
  [5224] = {.lex_state = 209},
  [5225] = {.lex_state = 421, .external_lex_state = 3},
  [5226] = {.lex_state = 299, .external_lex_state = 3},
  [5227] = {.lex_state = 177, .external_lex_state = 17},
  [5228] = {.lex_state = 421, .external_lex_state = 3},
  [5229] = {.lex_state = 299, .external_lex_state = 3},
  [5230] = {.lex_state = 524, .external_lex_state = 21},
  [5231] = {.lex_state = 421, .external_lex_state = 3},
  [5232] = {.lex_state = 421, .external_lex_state = 3},
  [5233] = {.lex_state = 156, .external_lex_state = 3},
  [5234] = {.lex_state = 524, .external_lex_state = 21},
  [5235] = {.lex_state = 177, .external_lex_state = 17},
  [5236] = {.lex_state = 156, .external_lex_state = 3},
  [5237] = {.lex_state = 192, .external_lex_state = 29},
  [5238] = {.lex_state = 361, .external_lex_state = 3},
  [5239] = {.lex_state = 361, .external_lex_state = 3},
  [5240] = {.lex_state = 361, .external_lex_state = 3},
  [5241] = {.lex_state = 361, .external_lex_state = 3},
  [5242] = {.lex_state = 361, .external_lex_state = 3},
  [5243] = {.lex_state = 361, .external_lex_state = 3},
  [5244] = {.lex_state = 192, .external_lex_state = 2},
  [5245] = {.lex_state = 192, .external_lex_state = 2},
  [5246] = {.lex_state = 192, .external_lex_state = 2},
  [5247] = {.lex_state = 192, .external_lex_state = 2},
  [5248] = {.lex_state = 192, .external_lex_state = 2},
  [5249] = {.lex_state = 192, .external_lex_state = 2},
  [5250] = {.lex_state = 192, .external_lex_state = 2},
  [5251] = {.lex_state = 192, .external_lex_state = 2},
  [5252] = {.lex_state = 192, .external_lex_state = 2},
  [5253] = {.lex_state = 192, .external_lex_state = 2},
  [5254] = {.lex_state = 192, .external_lex_state = 2},
  [5255] = {.lex_state = 192, .external_lex_state = 2},
  [5256] = {.lex_state = 192, .external_lex_state = 29},
  [5257] = {.lex_state = 192, .external_lex_state = 2},
  [5258] = {.lex_state = 365, .external_lex_state = 14},
  [5259] = {.lex_state = 361, .external_lex_state = 3},
  [5260] = {.lex_state = 361, .external_lex_state = 3},
  [5261] = {.lex_state = 361, .external_lex_state = 3},
  [5262] = {.lex_state = 192, .external_lex_state = 2},
  [5263] = {.lex_state = 361, .external_lex_state = 3},
  [5264] = {.lex_state = 192, .external_lex_state = 2},
  [5265] = {.lex_state = 361, .external_lex_state = 3},
  [5266] = {.lex_state = 524, .external_lex_state = 13},
  [5267] = {.lex_state = 361, .external_lex_state = 3},
  [5268] = {.lex_state = 361, .external_lex_state = 3},
  [5269] = {.lex_state = 361, .external_lex_state = 3},
  [5270] = {.lex_state = 361, .external_lex_state = 3},
  [5271] = {.lex_state = 361, .external_lex_state = 3},
  [5272] = {.lex_state = 361, .external_lex_state = 3},
  [5273] = {.lex_state = 361, .external_lex_state = 3},
  [5274] = {.lex_state = 361, .external_lex_state = 3},
  [5275] = {.lex_state = 554, .external_lex_state = 16},
  [5276] = {.lex_state = 361, .external_lex_state = 3},
  [5277] = {.lex_state = 361, .external_lex_state = 3},
  [5278] = {.lex_state = 361, .external_lex_state = 3},
  [5279] = {.lex_state = 361, .external_lex_state = 3},
  [5280] = {.lex_state = 361, .external_lex_state = 3},
  [5281] = {.lex_state = 421, .external_lex_state = 3},
  [5282] = {.lex_state = 421, .external_lex_state = 3},
  [5283] = {.lex_state = 192, .external_lex_state = 2},
  [5284] = {.lex_state = 421, .external_lex_state = 3},
  [5285] = {.lex_state = 192, .external_lex_state = 2},
  [5286] = {.lex_state = 421, .external_lex_state = 3},
  [5287] = {.lex_state = 524, .external_lex_state = 13},
  [5288] = {.lex_state = 421, .external_lex_state = 3},
  [5289] = {.lex_state = 262, .external_lex_state = 3},
  [5290] = {.lex_state = 524, .external_lex_state = 21},
  [5291] = {.lex_state = 262, .external_lex_state = 3},
  [5292] = {.lex_state = 361, .external_lex_state = 3},
  [5293] = {.lex_state = 361, .external_lex_state = 3},
  [5294] = {.lex_state = 361, .external_lex_state = 3},
  [5295] = {.lex_state = 361, .external_lex_state = 3},
  [5296] = {.lex_state = 361, .external_lex_state = 14},
  [5297] = {.lex_state = 254, .external_lex_state = 8},
  [5298] = {.lex_state = 128, .external_lex_state = 12},
  [5299] = {.lex_state = 247, .external_lex_state = 3},
  [5300] = {.lex_state = 192, .external_lex_state = 2},
  [5301] = {.lex_state = 192, .external_lex_state = 2},
  [5302] = {.lex_state = 192, .external_lex_state = 2},
  [5303] = {.lex_state = 237},
  [5304] = {.lex_state = 192, .external_lex_state = 2},
  [5305] = {.lex_state = 353, .external_lex_state = 11},
  [5306] = {.lex_state = 353, .external_lex_state = 11},
  [5307] = {.lex_state = 353, .external_lex_state = 11},
  [5308] = {.lex_state = 353, .external_lex_state = 11},
  [5309] = {.lex_state = 192, .external_lex_state = 2},
  [5310] = {.lex_state = 192, .external_lex_state = 2},
  [5311] = {.lex_state = 192, .external_lex_state = 2},
  [5312] = {.lex_state = 358, .external_lex_state = 11},
  [5313] = {.lex_state = 361, .external_lex_state = 3},
  [5314] = {.lex_state = 364, .external_lex_state = 11},
  [5315] = {.lex_state = 262, .external_lex_state = 3},
  [5316] = {.lex_state = 361, .external_lex_state = 3},
  [5317] = {.lex_state = 213},
  [5318] = {.lex_state = 368, .external_lex_state = 3},
  [5319] = {.lex_state = 371, .external_lex_state = 14},
  [5320] = {.lex_state = 128, .external_lex_state = 8},
  [5321] = {.lex_state = 128, .external_lex_state = 2},
  [5322] = {.lex_state = 247, .external_lex_state = 3},
  [5323] = {.lex_state = 247, .external_lex_state = 3},
  [5324] = {.lex_state = 254, .external_lex_state = 8},
  [5325] = {.lex_state = 156, .external_lex_state = 3},
  [5326] = {.lex_state = 128},
  [5327] = {.lex_state = 128, .external_lex_state = 2},
  [5328] = {.lex_state = 128, .external_lex_state = 8},
  [5329] = {.lex_state = 192, .external_lex_state = 2},
  [5330] = {.lex_state = 192, .external_lex_state = 2},
  [5331] = {.lex_state = 192, .external_lex_state = 2},
  [5332] = {.lex_state = 192, .external_lex_state = 2},
  [5333] = {.lex_state = 192, .external_lex_state = 2},
  [5334] = {.lex_state = 192, .external_lex_state = 2},
  [5335] = {.lex_state = 192, .external_lex_state = 2},
  [5336] = {.lex_state = 192, .external_lex_state = 2},
  [5337] = {.lex_state = 192, .external_lex_state = 2},
  [5338] = {.lex_state = 192, .external_lex_state = 2},
  [5339] = {.lex_state = 192, .external_lex_state = 2},
  [5340] = {.lex_state = 192, .external_lex_state = 2},
  [5341] = {.lex_state = 192, .external_lex_state = 2},
  [5342] = {.lex_state = 192, .external_lex_state = 2},
  [5343] = {.lex_state = 192, .external_lex_state = 2},
  [5344] = {.lex_state = 192, .external_lex_state = 2},
  [5345] = {.lex_state = 192, .external_lex_state = 2},
  [5346] = {.lex_state = 192, .external_lex_state = 2},
  [5347] = {.lex_state = 192, .external_lex_state = 2},
  [5348] = {.lex_state = 192, .external_lex_state = 2},
  [5349] = {.lex_state = 237},
  [5350] = {.lex_state = 192, .external_lex_state = 2},
  [5351] = {.lex_state = 364, .external_lex_state = 11},
  [5352] = {.lex_state = 364, .external_lex_state = 11},
  [5353] = {.lex_state = 364, .external_lex_state = 11},
  [5354] = {.lex_state = 364, .external_lex_state = 11},
  [5355] = {.lex_state = 192, .external_lex_state = 2},
  [5356] = {.lex_state = 192, .external_lex_state = 2},
  [5357] = {.lex_state = 192, .external_lex_state = 2},
  [5358] = {.lex_state = 358, .external_lex_state = 11},
  [5359] = {.lex_state = 421, .external_lex_state = 3},
  [5360] = {.lex_state = 364, .external_lex_state = 11},
  [5361] = {.lex_state = 424, .external_lex_state = 3},
  [5362] = {.lex_state = 424, .external_lex_state = 3},
  [5363] = {.lex_state = 213},
  [5364] = {.lex_state = 421, .external_lex_state = 3},
  [5365] = {.lex_state = 427, .external_lex_state = 14},
  [5366] = {.lex_state = 192, .external_lex_state = 29},
  [5367] = {.lex_state = 192, .external_lex_state = 2},
  [5368] = {.lex_state = 262, .external_lex_state = 14},
  [5369] = {.lex_state = 128},
  [5370] = {.lex_state = 192, .external_lex_state = 2},
  [5371] = {.lex_state = 424, .external_lex_state = 3},
  [5372] = {.lex_state = 424, .external_lex_state = 3},
  [5373] = {.lex_state = 424, .external_lex_state = 3},
  [5374] = {.lex_state = 192, .external_lex_state = 2},
  [5375] = {.lex_state = 192, .external_lex_state = 2},
  [5376] = {.lex_state = 192, .external_lex_state = 2},
  [5377] = {.lex_state = 192, .external_lex_state = 2},
  [5378] = {.lex_state = 192, .external_lex_state = 2},
  [5379] = {.lex_state = 192, .external_lex_state = 2},
  [5380] = {.lex_state = 192, .external_lex_state = 2},
  [5381] = {.lex_state = 192, .external_lex_state = 2},
  [5382] = {.lex_state = 192, .external_lex_state = 2},
  [5383] = {.lex_state = 192, .external_lex_state = 2},
  [5384] = {.lex_state = 192, .external_lex_state = 2},
  [5385] = {.lex_state = 192, .external_lex_state = 2},
  [5386] = {.lex_state = 192, .external_lex_state = 29},
  [5387] = {.lex_state = 192, .external_lex_state = 2},
  [5388] = {.lex_state = 424, .external_lex_state = 14},
  [5389] = {.lex_state = 424, .external_lex_state = 3},
  [5390] = {.lex_state = 421, .external_lex_state = 3},
  [5391] = {.lex_state = 421, .external_lex_state = 3},
  [5392] = {.lex_state = 421, .external_lex_state = 3},
  [5393] = {.lex_state = 421, .external_lex_state = 3},
  [5394] = {.lex_state = 421, .external_lex_state = 3},
  [5395] = {.lex_state = 421, .external_lex_state = 3},
  [5396] = {.lex_state = 424, .external_lex_state = 3},
  [5397] = {.lex_state = 554, .external_lex_state = 16},
  [5398] = {.lex_state = 421, .external_lex_state = 3},
  [5399] = {.lex_state = 421, .external_lex_state = 3},
  [5400] = {.lex_state = 421, .external_lex_state = 3},
  [5401] = {.lex_state = 421, .external_lex_state = 3},
  [5402] = {.lex_state = 421, .external_lex_state = 3},
  [5403] = {.lex_state = 424, .external_lex_state = 3},
  [5404] = {.lex_state = 524, .external_lex_state = 21},
  [5405] = {.lex_state = 424, .external_lex_state = 3},
  [5406] = {.lex_state = 424, .external_lex_state = 3},
  [5407] = {.lex_state = 421, .external_lex_state = 3},
  [5408] = {.lex_state = 421, .external_lex_state = 3},
  [5409] = {.lex_state = 421, .external_lex_state = 3},
  [5410] = {.lex_state = 421, .external_lex_state = 14},
  [5411] = {.lex_state = 528, .external_lex_state = 3},
  [5412] = {.lex_state = 528, .external_lex_state = 3},
  [5413] = {.lex_state = 528, .external_lex_state = 3},
  [5414] = {.lex_state = 528, .external_lex_state = 3},
  [5415] = {.lex_state = 192, .external_lex_state = 2},
  [5416] = {.lex_state = 192, .external_lex_state = 2},
  [5417] = {.lex_state = 192, .external_lex_state = 2},
  [5418] = {.lex_state = 192, .external_lex_state = 2},
  [5419] = {.lex_state = 192, .external_lex_state = 2},
  [5420] = {.lex_state = 192, .external_lex_state = 2},
  [5421] = {.lex_state = 192, .external_lex_state = 2},
  [5422] = {.lex_state = 192, .external_lex_state = 2},
  [5423] = {.lex_state = 192, .external_lex_state = 2},
  [5424] = {.lex_state = 192, .external_lex_state = 2},
  [5425] = {.lex_state = 192, .external_lex_state = 2},
  [5426] = {.lex_state = 192, .external_lex_state = 2},
  [5427] = {.lex_state = 192, .external_lex_state = 29},
  [5428] = {.lex_state = 528, .external_lex_state = 3},
  [5429] = {.lex_state = 192, .external_lex_state = 29},
  [5430] = {.lex_state = 192, .external_lex_state = 2},
  [5431] = {.lex_state = 247, .external_lex_state = 3},
  [5432] = {.lex_state = 192, .external_lex_state = 2},
  [5433] = {.lex_state = 192, .external_lex_state = 2},
  [5434] = {.lex_state = 192, .external_lex_state = 2},
  [5435] = {.lex_state = 237},
  [5436] = {.lex_state = 192, .external_lex_state = 2},
  [5437] = {.lex_state = 353, .external_lex_state = 11},
  [5438] = {.lex_state = 353, .external_lex_state = 11},
  [5439] = {.lex_state = 353, .external_lex_state = 11},
  [5440] = {.lex_state = 353, .external_lex_state = 11},
  [5441] = {.lex_state = 192, .external_lex_state = 2},
  [5442] = {.lex_state = 192, .external_lex_state = 2},
  [5443] = {.lex_state = 192, .external_lex_state = 2},
  [5444] = {.lex_state = 358, .external_lex_state = 11},
  [5445] = {.lex_state = 361, .external_lex_state = 3},
  [5446] = {.lex_state = 364, .external_lex_state = 11},
  [5447] = {.lex_state = 262, .external_lex_state = 3},
  [5448] = {.lex_state = 361, .external_lex_state = 3},
  [5449] = {.lex_state = 213},
  [5450] = {.lex_state = 368, .external_lex_state = 3},
  [5451] = {.lex_state = 371, .external_lex_state = 14},
  [5452] = {.lex_state = 247, .external_lex_state = 3},
  [5453] = {.lex_state = 247, .external_lex_state = 3},
  [5454] = {.lex_state = 254, .external_lex_state = 8},
  [5455] = {.lex_state = 156, .external_lex_state = 3},
  [5456] = {.lex_state = 128},
  [5457] = {.lex_state = 128, .external_lex_state = 2},
  [5458] = {.lex_state = 128, .external_lex_state = 8},
  [5459] = {.lex_state = 192, .external_lex_state = 2},
  [5460] = {.lex_state = 192, .external_lex_state = 2},
  [5461] = {.lex_state = 192, .external_lex_state = 2},
  [5462] = {.lex_state = 192, .external_lex_state = 2},
  [5463] = {.lex_state = 192, .external_lex_state = 2},
  [5464] = {.lex_state = 192, .external_lex_state = 2},
  [5465] = {.lex_state = 192, .external_lex_state = 2},
  [5466] = {.lex_state = 192, .external_lex_state = 2},
  [5467] = {.lex_state = 192, .external_lex_state = 2},
  [5468] = {.lex_state = 192, .external_lex_state = 2},
  [5469] = {.lex_state = 192, .external_lex_state = 2},
  [5470] = {.lex_state = 192, .external_lex_state = 2},
  [5471] = {.lex_state = 192, .external_lex_state = 2},
  [5472] = {.lex_state = 192, .external_lex_state = 2},
  [5473] = {.lex_state = 192, .external_lex_state = 2},
  [5474] = {.lex_state = 192, .external_lex_state = 2},
  [5475] = {.lex_state = 192, .external_lex_state = 2},
  [5476] = {.lex_state = 192, .external_lex_state = 2},
  [5477] = {.lex_state = 192, .external_lex_state = 2},
  [5478] = {.lex_state = 192, .external_lex_state = 2},
  [5479] = {.lex_state = 237},
  [5480] = {.lex_state = 192, .external_lex_state = 2},
  [5481] = {.lex_state = 364, .external_lex_state = 11},
  [5482] = {.lex_state = 364, .external_lex_state = 11},
  [5483] = {.lex_state = 364, .external_lex_state = 11},
  [5484] = {.lex_state = 364, .external_lex_state = 11},
  [5485] = {.lex_state = 192, .external_lex_state = 2},
  [5486] = {.lex_state = 192, .external_lex_state = 2},
  [5487] = {.lex_state = 192, .external_lex_state = 2},
  [5488] = {.lex_state = 358, .external_lex_state = 11},
  [5489] = {.lex_state = 421, .external_lex_state = 3},
  [5490] = {.lex_state = 364, .external_lex_state = 11},
  [5491] = {.lex_state = 424, .external_lex_state = 3},
  [5492] = {.lex_state = 424, .external_lex_state = 3},
  [5493] = {.lex_state = 213},
  [5494] = {.lex_state = 421, .external_lex_state = 3},
  [5495] = {.lex_state = 427, .external_lex_state = 14},
  [5496] = {.lex_state = 192, .external_lex_state = 29},
  [5497] = {.lex_state = 192, .external_lex_state = 2},
  [5498] = {.lex_state = 262, .external_lex_state = 14},
  [5499] = {.lex_state = 361, .external_lex_state = 3},
  [5500] = {.lex_state = 361, .external_lex_state = 3},
  [5501] = {.lex_state = 361, .external_lex_state = 3},
  [5502] = {.lex_state = 361, .external_lex_state = 3},
  [5503] = {.lex_state = 361, .external_lex_state = 3},
  [5504] = {.lex_state = 192, .external_lex_state = 2},
  [5505] = {.lex_state = 192, .external_lex_state = 2},
  [5506] = {.lex_state = 192, .external_lex_state = 2},
  [5507] = {.lex_state = 192, .external_lex_state = 2},
  [5508] = {.lex_state = 192, .external_lex_state = 2},
  [5509] = {.lex_state = 192, .external_lex_state = 2},
  [5510] = {.lex_state = 192, .external_lex_state = 2},
  [5511] = {.lex_state = 192, .external_lex_state = 2},
  [5512] = {.lex_state = 192, .external_lex_state = 2},
  [5513] = {.lex_state = 192, .external_lex_state = 2},
  [5514] = {.lex_state = 192, .external_lex_state = 2},
  [5515] = {.lex_state = 192, .external_lex_state = 2},
  [5516] = {.lex_state = 192, .external_lex_state = 29},
  [5517] = {.lex_state = 192, .external_lex_state = 2},
  [5518] = {.lex_state = 365, .external_lex_state = 14},
  [5519] = {.lex_state = 361, .external_lex_state = 3},
  [5520] = {.lex_state = 361, .external_lex_state = 3},
  [5521] = {.lex_state = 361, .external_lex_state = 3},
  [5522] = {.lex_state = 192, .external_lex_state = 2},
  [5523] = {.lex_state = 361, .external_lex_state = 3},
  [5524] = {.lex_state = 192, .external_lex_state = 2},
  [5525] = {.lex_state = 361, .external_lex_state = 3},
  [5526] = {.lex_state = 524, .external_lex_state = 13},
  [5527] = {.lex_state = 361, .external_lex_state = 3},
  [5528] = {.lex_state = 361, .external_lex_state = 3},
  [5529] = {.lex_state = 361, .external_lex_state = 3},
  [5530] = {.lex_state = 361, .external_lex_state = 3},
  [5531] = {.lex_state = 361, .external_lex_state = 3},
  [5532] = {.lex_state = 361, .external_lex_state = 3},
  [5533] = {.lex_state = 361, .external_lex_state = 3},
  [5534] = {.lex_state = 361, .external_lex_state = 3},
  [5535] = {.lex_state = 554, .external_lex_state = 16},
  [5536] = {.lex_state = 361, .external_lex_state = 3},
  [5537] = {.lex_state = 361, .external_lex_state = 3},
  [5538] = {.lex_state = 361, .external_lex_state = 3},
  [5539] = {.lex_state = 361, .external_lex_state = 3},
  [5540] = {.lex_state = 361, .external_lex_state = 3},
  [5541] = {.lex_state = 421, .external_lex_state = 3},
  [5542] = {.lex_state = 421, .external_lex_state = 3},
  [5543] = {.lex_state = 192, .external_lex_state = 2},
  [5544] = {.lex_state = 421, .external_lex_state = 3},
  [5545] = {.lex_state = 421, .external_lex_state = 3},
  [5546] = {.lex_state = 192, .external_lex_state = 2},
  [5547] = {.lex_state = 421, .external_lex_state = 3},
  [5548] = {.lex_state = 524, .external_lex_state = 13},
  [5549] = {.lex_state = 421, .external_lex_state = 3},
  [5550] = {.lex_state = 262, .external_lex_state = 3},
  [5551] = {.lex_state = 524, .external_lex_state = 21},
  [5552] = {.lex_state = 262, .external_lex_state = 3},
  [5553] = {.lex_state = 361, .external_lex_state = 3},
  [5554] = {.lex_state = 361, .external_lex_state = 3},
  [5555] = {.lex_state = 361, .external_lex_state = 3},
  [5556] = {.lex_state = 361, .external_lex_state = 3},
  [5557] = {.lex_state = 361, .external_lex_state = 14},
  [5558] = {.lex_state = 192, .external_lex_state = 2},
  [5559] = {.lex_state = 156, .external_lex_state = 3},
  [5560] = {.lex_state = 424, .external_lex_state = 3},
  [5561] = {.lex_state = 424, .external_lex_state = 3},
  [5562] = {.lex_state = 424, .external_lex_state = 3},
  [5563] = {.lex_state = 192, .external_lex_state = 2},
  [5564] = {.lex_state = 192, .external_lex_state = 2},
  [5565] = {.lex_state = 192, .external_lex_state = 2},
  [5566] = {.lex_state = 192, .external_lex_state = 2},
  [5567] = {.lex_state = 192, .external_lex_state = 2},
  [5568] = {.lex_state = 192, .external_lex_state = 2},
  [5569] = {.lex_state = 192, .external_lex_state = 2},
  [5570] = {.lex_state = 192, .external_lex_state = 2},
  [5571] = {.lex_state = 192, .external_lex_state = 2},
  [5572] = {.lex_state = 192, .external_lex_state = 2},
  [5573] = {.lex_state = 192, .external_lex_state = 2},
  [5574] = {.lex_state = 192, .external_lex_state = 2},
  [5575] = {.lex_state = 192, .external_lex_state = 29},
  [5576] = {.lex_state = 192, .external_lex_state = 2},
  [5577] = {.lex_state = 424, .external_lex_state = 14},
  [5578] = {.lex_state = 424, .external_lex_state = 3},
  [5579] = {.lex_state = 421, .external_lex_state = 3},
  [5580] = {.lex_state = 421, .external_lex_state = 3},
  [5581] = {.lex_state = 421, .external_lex_state = 3},
  [5582] = {.lex_state = 421, .external_lex_state = 3},
  [5583] = {.lex_state = 421, .external_lex_state = 3},
  [5584] = {.lex_state = 421, .external_lex_state = 3},
  [5585] = {.lex_state = 424, .external_lex_state = 3},
  [5586] = {.lex_state = 554, .external_lex_state = 16},
  [5587] = {.lex_state = 421, .external_lex_state = 3},
  [5588] = {.lex_state = 421, .external_lex_state = 3},
  [5589] = {.lex_state = 421, .external_lex_state = 3},
  [5590] = {.lex_state = 421, .external_lex_state = 3},
  [5591] = {.lex_state = 421, .external_lex_state = 3},
  [5592] = {.lex_state = 424, .external_lex_state = 3},
  [5593] = {.lex_state = 524, .external_lex_state = 21},
  [5594] = {.lex_state = 424, .external_lex_state = 3},
  [5595] = {.lex_state = 424, .external_lex_state = 3},
  [5596] = {.lex_state = 421, .external_lex_state = 3},
  [5597] = {.lex_state = 421, .external_lex_state = 3},
  [5598] = {.lex_state = 421, .external_lex_state = 3},
  [5599] = {.lex_state = 421, .external_lex_state = 14},
  [5600] = {.lex_state = 528, .external_lex_state = 3},
  [5601] = {.lex_state = 528, .external_lex_state = 3},
  [5602] = {.lex_state = 528, .external_lex_state = 3},
  [5603] = {.lex_state = 528, .external_lex_state = 3},
  [5604] = {.lex_state = 192, .external_lex_state = 2},
  [5605] = {.lex_state = 192, .external_lex_state = 2},
  [5606] = {.lex_state = 192, .external_lex_state = 2},
  [5607] = {.lex_state = 192, .external_lex_state = 2},
  [5608] = {.lex_state = 192, .external_lex_state = 2},
  [5609] = {.lex_state = 192, .external_lex_state = 2},
  [5610] = {.lex_state = 192, .external_lex_state = 2},
  [5611] = {.lex_state = 192, .external_lex_state = 2},
  [5612] = {.lex_state = 192, .external_lex_state = 2},
  [5613] = {.lex_state = 192, .external_lex_state = 2},
  [5614] = {.lex_state = 192, .external_lex_state = 2},
  [5615] = {.lex_state = 192, .external_lex_state = 2},
  [5616] = {.lex_state = 192, .external_lex_state = 29},
  [5617] = {.lex_state = 528, .external_lex_state = 3},
  [5618] = {.lex_state = 192, .external_lex_state = 29},
  [5619] = {.lex_state = 192, .external_lex_state = 2},
  [5620] = {.lex_state = 156, .external_lex_state = 3},
  [5621] = {.lex_state = 508, .external_lex_state = 25},
  [5622] = {.lex_state = 192, .external_lex_state = 2},
  [5623] = {.lex_state = 192, .external_lex_state = 2},
  [5624] = {.lex_state = 237},
  [5625] = {.lex_state = 192, .external_lex_state = 2},
  [5626] = {.lex_state = 296, .external_lex_state = 26},
  [5627] = {.lex_state = 508, .external_lex_state = 25},
  [5628] = {.lex_state = 508, .external_lex_state = 25},
  [5629] = {.lex_state = 508, .external_lex_state = 25},
  [5630] = {.lex_state = 508, .external_lex_state = 27},
  [5631] = {.lex_state = 508, .external_lex_state = 25},
  [5632] = {.lex_state = 508, .external_lex_state = 25},
  [5633] = {.lex_state = 192, .external_lex_state = 2},
  [5634] = {.lex_state = 192, .external_lex_state = 2},
  [5635] = {.lex_state = 192, .external_lex_state = 2},
  [5636] = {.lex_state = 192, .external_lex_state = 2},
  [5637] = {.lex_state = 192, .external_lex_state = 2},
  [5638] = {.lex_state = 192, .external_lex_state = 2},
  [5639] = {.lex_state = 192, .external_lex_state = 2},
  [5640] = {.lex_state = 192, .external_lex_state = 2},
  [5641] = {.lex_state = 192, .external_lex_state = 2},
  [5642] = {.lex_state = 192, .external_lex_state = 2},
  [5643] = {.lex_state = 192, .external_lex_state = 2},
  [5644] = {.lex_state = 192, .external_lex_state = 2},
  [5645] = {.lex_state = 192, .external_lex_state = 2},
  [5646] = {.lex_state = 192, .external_lex_state = 2},
  [5647] = {.lex_state = 237},
  [5648] = {.lex_state = 192, .external_lex_state = 2},
  [5649] = {.lex_state = 296, .external_lex_state = 26},
  [5650] = {.lex_state = 421, .external_lex_state = 25},
  [5651] = {.lex_state = 424, .external_lex_state = 25},
  [5652] = {.lex_state = 424, .external_lex_state = 25},
  [5653] = {.lex_state = 427, .external_lex_state = 27},
  [5654] = {.lex_state = 192, .external_lex_state = 29},
  [5655] = {.lex_state = 192, .external_lex_state = 2},
  [5656] = {.lex_state = 631, .external_lex_state = 27},
  [5657] = {.lex_state = 508, .external_lex_state = 25},
  [5658] = {.lex_state = 508, .external_lex_state = 25},
  [5659] = {.lex_state = 508, .external_lex_state = 25},
  [5660] = {.lex_state = 192, .external_lex_state = 2},
  [5661] = {.lex_state = 508, .external_lex_state = 25},
  [5662] = {.lex_state = 192, .external_lex_state = 2},
  [5663] = {.lex_state = 508, .external_lex_state = 25},
  [5664] = {.lex_state = 524, .external_lex_state = 13},
  [5665] = {.lex_state = 508, .external_lex_state = 25},
  [5666] = {.lex_state = 508, .external_lex_state = 25},
  [5667] = {.lex_state = 508, .external_lex_state = 25},
  [5668] = {.lex_state = 508, .external_lex_state = 25},
  [5669] = {.lex_state = 508, .external_lex_state = 25},
  [5670] = {.lex_state = 508, .external_lex_state = 25},
  [5671] = {.lex_state = 508, .external_lex_state = 25},
  [5672] = {.lex_state = 508, .external_lex_state = 25},
  [5673] = {.lex_state = 554, .external_lex_state = 16},
  [5674] = {.lex_state = 508, .external_lex_state = 25},
  [5675] = {.lex_state = 508, .external_lex_state = 25},
  [5676] = {.lex_state = 508, .external_lex_state = 25},
  [5677] = {.lex_state = 508, .external_lex_state = 25},
  [5678] = {.lex_state = 508, .external_lex_state = 25},
  [5679] = {.lex_state = 421, .external_lex_state = 25},
  [5680] = {.lex_state = 421, .external_lex_state = 27},
  [5681] = {.lex_state = 421, .external_lex_state = 25},
  [5682] = {.lex_state = 421, .external_lex_state = 25},
  [5683] = {.lex_state = 192, .external_lex_state = 2},
  [5684] = {.lex_state = 421, .external_lex_state = 25},
  [5685] = {.lex_state = 421, .external_lex_state = 25},
  [5686] = {.lex_state = 421, .external_lex_state = 25},
  [5687] = {.lex_state = 192, .external_lex_state = 2},
  [5688] = {.lex_state = 192, .external_lex_state = 2},
  [5689] = {.lex_state = 192, .external_lex_state = 2},
  [5690] = {.lex_state = 192, .external_lex_state = 2},
  [5691] = {.lex_state = 192, .external_lex_state = 2},
  [5692] = {.lex_state = 192, .external_lex_state = 2},
  [5693] = {.lex_state = 192, .external_lex_state = 2},
  [5694] = {.lex_state = 192, .external_lex_state = 2},
  [5695] = {.lex_state = 192, .external_lex_state = 2},
  [5696] = {.lex_state = 192, .external_lex_state = 2},
  [5697] = {.lex_state = 192, .external_lex_state = 2},
  [5698] = {.lex_state = 192, .external_lex_state = 2},
  [5699] = {.lex_state = 192, .external_lex_state = 2},
  [5700] = {.lex_state = 421, .external_lex_state = 25},
  [5701] = {.lex_state = 524, .external_lex_state = 13},
  [5702] = {.lex_state = 421, .external_lex_state = 25},
  [5703] = {.lex_state = 192, .external_lex_state = 29},
  [5704] = {.lex_state = 192, .external_lex_state = 2},
  [5705] = {.lex_state = 421, .external_lex_state = 27},
  [5706] = {.lex_state = 340, .external_lex_state = 19},
  [5707] = {.lex_state = 524, .external_lex_state = 21},
  [5708] = {.lex_state = 340, .external_lex_state = 19},
  [5709] = {.lex_state = 340, .external_lex_state = 19},
  [5710] = {.lex_state = 508, .external_lex_state = 25},
  [5711] = {.lex_state = 508, .external_lex_state = 25},
  [5712] = {.lex_state = 508, .external_lex_state = 25},
  [5713] = {.lex_state = 634, .external_lex_state = 27},
  [5714] = {.lex_state = 156, .external_lex_state = 3},
  [5715] = {.lex_state = 128},
  [5716] = {.lex_state = 361, .external_lex_state = 3},
  [5717] = {.lex_state = 361, .external_lex_state = 3},
  [5718] = {.lex_state = 361, .external_lex_state = 3},
  [5719] = {.lex_state = 361, .external_lex_state = 3},
  [5720] = {.lex_state = 361, .external_lex_state = 3},
  [5721] = {.lex_state = 192, .external_lex_state = 2},
  [5722] = {.lex_state = 192, .external_lex_state = 2},
  [5723] = {.lex_state = 192, .external_lex_state = 2},
  [5724] = {.lex_state = 192, .external_lex_state = 2},
  [5725] = {.lex_state = 192, .external_lex_state = 2},
  [5726] = {.lex_state = 192, .external_lex_state = 2},
  [5727] = {.lex_state = 192, .external_lex_state = 2},
  [5728] = {.lex_state = 192, .external_lex_state = 2},
  [5729] = {.lex_state = 192, .external_lex_state = 2},
  [5730] = {.lex_state = 192, .external_lex_state = 2},
  [5731] = {.lex_state = 192, .external_lex_state = 2},
  [5732] = {.lex_state = 192, .external_lex_state = 2},
  [5733] = {.lex_state = 192, .external_lex_state = 29},
  [5734] = {.lex_state = 192, .external_lex_state = 2},
  [5735] = {.lex_state = 365, .external_lex_state = 14},
  [5736] = {.lex_state = 361, .external_lex_state = 3},
  [5737] = {.lex_state = 361, .external_lex_state = 3},
  [5738] = {.lex_state = 361, .external_lex_state = 3},
  [5739] = {.lex_state = 192, .external_lex_state = 2},
  [5740] = {.lex_state = 361, .external_lex_state = 3},
  [5741] = {.lex_state = 192, .external_lex_state = 2},
  [5742] = {.lex_state = 361, .external_lex_state = 3},
  [5743] = {.lex_state = 524, .external_lex_state = 13},
  [5744] = {.lex_state = 361, .external_lex_state = 3},
  [5745] = {.lex_state = 361, .external_lex_state = 3},
  [5746] = {.lex_state = 361, .external_lex_state = 3},
  [5747] = {.lex_state = 361, .external_lex_state = 3},
  [5748] = {.lex_state = 361, .external_lex_state = 3},
  [5749] = {.lex_state = 361, .external_lex_state = 3},
  [5750] = {.lex_state = 361, .external_lex_state = 3},
  [5751] = {.lex_state = 361, .external_lex_state = 3},
  [5752] = {.lex_state = 554, .external_lex_state = 16},
  [5753] = {.lex_state = 361, .external_lex_state = 3},
  [5754] = {.lex_state = 361, .external_lex_state = 3},
  [5755] = {.lex_state = 361, .external_lex_state = 3},
  [5756] = {.lex_state = 361, .external_lex_state = 3},
  [5757] = {.lex_state = 361, .external_lex_state = 3},
  [5758] = {.lex_state = 262, .external_lex_state = 3},
  [5759] = {.lex_state = 524, .external_lex_state = 21},
  [5760] = {.lex_state = 262, .external_lex_state = 3},
  [5761] = {.lex_state = 361, .external_lex_state = 3},
  [5762] = {.lex_state = 361, .external_lex_state = 3},
  [5763] = {.lex_state = 361, .external_lex_state = 3},
  [5764] = {.lex_state = 361, .external_lex_state = 3},
  [5765] = {.lex_state = 361, .external_lex_state = 14},
  [5766] = {.lex_state = 192, .external_lex_state = 2},
  [5767] = {.lex_state = 156, .external_lex_state = 3},
  [5768] = {.lex_state = 128},
  [5769] = {.lex_state = 528, .external_lex_state = 3},
  [5770] = {.lex_state = 528, .external_lex_state = 3},
  [5771] = {.lex_state = 528, .external_lex_state = 3},
  [5772] = {.lex_state = 528, .external_lex_state = 3},
  [5773] = {.lex_state = 192, .external_lex_state = 2},
  [5774] = {.lex_state = 192, .external_lex_state = 2},
  [5775] = {.lex_state = 192, .external_lex_state = 2},
  [5776] = {.lex_state = 192, .external_lex_state = 2},
  [5777] = {.lex_state = 192, .external_lex_state = 2},
  [5778] = {.lex_state = 192, .external_lex_state = 2},
  [5779] = {.lex_state = 192, .external_lex_state = 2},
  [5780] = {.lex_state = 192, .external_lex_state = 2},
  [5781] = {.lex_state = 192, .external_lex_state = 2},
  [5782] = {.lex_state = 192, .external_lex_state = 2},
  [5783] = {.lex_state = 192, .external_lex_state = 2},
  [5784] = {.lex_state = 192, .external_lex_state = 2},
  [5785] = {.lex_state = 192, .external_lex_state = 29},
  [5786] = {.lex_state = 528, .external_lex_state = 3},
  [5787] = {.lex_state = 192, .external_lex_state = 29},
  [5788] = {.lex_state = 192, .external_lex_state = 2},
  [5789] = {.lex_state = 528, .external_lex_state = 3},
  [5790] = {.lex_state = 528, .external_lex_state = 3},
  [5791] = {.lex_state = 192, .external_lex_state = 2},
  [5792] = {.lex_state = 192, .external_lex_state = 2},
  [5793] = {.lex_state = 237},
  [5794] = {.lex_state = 192, .external_lex_state = 2},
  [5795] = {.lex_state = 358, .external_lex_state = 11},
  [5796] = {.lex_state = 361, .external_lex_state = 3},
  [5797] = {.lex_state = 361, .external_lex_state = 3},
  [5798] = {.lex_state = 361, .external_lex_state = 3},
  [5799] = {.lex_state = 371, .external_lex_state = 14},
  [5800] = {.lex_state = 528, .external_lex_state = 3},
  [5801] = {.lex_state = 528, .external_lex_state = 3},
  [5802] = {.lex_state = 192, .external_lex_state = 29},
  [5803] = {.lex_state = 128, .external_lex_state = 2},
  [5804] = {.lex_state = 254, .external_lex_state = 8},
  [5805] = {.lex_state = 192, .external_lex_state = 2},
  [5806] = {.lex_state = 192, .external_lex_state = 2},
  [5807] = {.lex_state = 192, .external_lex_state = 2},
  [5808] = {.lex_state = 192, .external_lex_state = 2},
  [5809] = {.lex_state = 192, .external_lex_state = 2},
  [5810] = {.lex_state = 192, .external_lex_state = 2},
  [5811] = {.lex_state = 192, .external_lex_state = 2},
  [5812] = {.lex_state = 192, .external_lex_state = 2},
  [5813] = {.lex_state = 192, .external_lex_state = 2},
  [5814] = {.lex_state = 192, .external_lex_state = 2},
  [5815] = {.lex_state = 192, .external_lex_state = 2},
  [5816] = {.lex_state = 192, .external_lex_state = 2},
  [5817] = {.lex_state = 192, .external_lex_state = 2},
  [5818] = {.lex_state = 192, .external_lex_state = 2},
  [5819] = {.lex_state = 237},
  [5820] = {.lex_state = 192, .external_lex_state = 2},
  [5821] = {.lex_state = 358, .external_lex_state = 11},
  [5822] = {.lex_state = 421, .external_lex_state = 3},
  [5823] = {.lex_state = 424, .external_lex_state = 3},
  [5824] = {.lex_state = 424, .external_lex_state = 3},
  [5825] = {.lex_state = 427, .external_lex_state = 14},
  [5826] = {.lex_state = 192, .external_lex_state = 29},
  [5827] = {.lex_state = 192, .external_lex_state = 2},
  [5828] = {.lex_state = 365, .external_lex_state = 14},
  [5829] = {.lex_state = 361, .external_lex_state = 3},
  [5830] = {.lex_state = 361, .external_lex_state = 3},
  [5831] = {.lex_state = 361, .external_lex_state = 3},
  [5832] = {.lex_state = 361, .external_lex_state = 3},
  [5833] = {.lex_state = 361, .external_lex_state = 3},
  [5834] = {.lex_state = 192, .external_lex_state = 2},
  [5835] = {.lex_state = 192, .external_lex_state = 2},
  [5836] = {.lex_state = 192, .external_lex_state = 2},
  [5837] = {.lex_state = 192, .external_lex_state = 2},
  [5838] = {.lex_state = 192, .external_lex_state = 2},
  [5839] = {.lex_state = 192, .external_lex_state = 2},
  [5840] = {.lex_state = 192, .external_lex_state = 2},
  [5841] = {.lex_state = 192, .external_lex_state = 2},
  [5842] = {.lex_state = 192, .external_lex_state = 2},
  [5843] = {.lex_state = 192, .external_lex_state = 2},
  [5844] = {.lex_state = 192, .external_lex_state = 2},
  [5845] = {.lex_state = 192, .external_lex_state = 2},
  [5846] = {.lex_state = 192, .external_lex_state = 29},
  [5847] = {.lex_state = 192, .external_lex_state = 2},
  [5848] = {.lex_state = 365, .external_lex_state = 14},
  [5849] = {.lex_state = 361, .external_lex_state = 3},
  [5850] = {.lex_state = 361, .external_lex_state = 3},
  [5851] = {.lex_state = 361, .external_lex_state = 3},
  [5852] = {.lex_state = 192, .external_lex_state = 2},
  [5853] = {.lex_state = 361, .external_lex_state = 3},
  [5854] = {.lex_state = 192, .external_lex_state = 2},
  [5855] = {.lex_state = 361, .external_lex_state = 3},
  [5856] = {.lex_state = 524, .external_lex_state = 13},
  [5857] = {.lex_state = 361, .external_lex_state = 3},
  [5858] = {.lex_state = 361, .external_lex_state = 3},
  [5859] = {.lex_state = 361, .external_lex_state = 3},
  [5860] = {.lex_state = 361, .external_lex_state = 3},
  [5861] = {.lex_state = 361, .external_lex_state = 3},
  [5862] = {.lex_state = 361, .external_lex_state = 3},
  [5863] = {.lex_state = 361, .external_lex_state = 3},
  [5864] = {.lex_state = 361, .external_lex_state = 3},
  [5865] = {.lex_state = 554, .external_lex_state = 16},
  [5866] = {.lex_state = 361, .external_lex_state = 3},
  [5867] = {.lex_state = 361, .external_lex_state = 3},
  [5868] = {.lex_state = 361, .external_lex_state = 3},
  [5869] = {.lex_state = 361, .external_lex_state = 3},
  [5870] = {.lex_state = 361, .external_lex_state = 3},
  [5871] = {.lex_state = 421, .external_lex_state = 3},
  [5872] = {.lex_state = 421, .external_lex_state = 3},
  [5873] = {.lex_state = 192, .external_lex_state = 2},
  [5874] = {.lex_state = 421, .external_lex_state = 3},
  [5875] = {.lex_state = 192, .external_lex_state = 2},
  [5876] = {.lex_state = 421, .external_lex_state = 3},
  [5877] = {.lex_state = 524, .external_lex_state = 13},
  [5878] = {.lex_state = 421, .external_lex_state = 3},
  [5879] = {.lex_state = 262, .external_lex_state = 3},
  [5880] = {.lex_state = 524, .external_lex_state = 21},
  [5881] = {.lex_state = 262, .external_lex_state = 3},
  [5882] = {.lex_state = 361, .external_lex_state = 3},
  [5883] = {.lex_state = 361, .external_lex_state = 3},
  [5884] = {.lex_state = 361, .external_lex_state = 3},
  [5885] = {.lex_state = 361, .external_lex_state = 3},
  [5886] = {.lex_state = 361, .external_lex_state = 14},
  [5887] = {.lex_state = 361, .external_lex_state = 3},
  [5888] = {.lex_state = 361, .external_lex_state = 3},
  [5889] = {.lex_state = 361, .external_lex_state = 3},
  [5890] = {.lex_state = 192, .external_lex_state = 2},
  [5891] = {.lex_state = 361, .external_lex_state = 3},
  [5892] = {.lex_state = 361, .external_lex_state = 3},
  [5893] = {.lex_state = 361, .external_lex_state = 3},
  [5894] = {.lex_state = 192, .external_lex_state = 2},
  [5895] = {.lex_state = 192, .external_lex_state = 2},
  [5896] = {.lex_state = 192, .external_lex_state = 2},
  [5897] = {.lex_state = 192, .external_lex_state = 2},
  [5898] = {.lex_state = 192, .external_lex_state = 2},
  [5899] = {.lex_state = 192, .external_lex_state = 2},
  [5900] = {.lex_state = 192, .external_lex_state = 2},
  [5901] = {.lex_state = 192, .external_lex_state = 2},
  [5902] = {.lex_state = 192, .external_lex_state = 2},
  [5903] = {.lex_state = 192, .external_lex_state = 2},
  [5904] = {.lex_state = 192, .external_lex_state = 2},
  [5905] = {.lex_state = 192, .external_lex_state = 2},
  [5906] = {.lex_state = 192, .external_lex_state = 2},
  [5907] = {.lex_state = 361, .external_lex_state = 3},
  [5908] = {.lex_state = 524, .external_lex_state = 13},
  [5909] = {.lex_state = 361, .external_lex_state = 3},
  [5910] = {.lex_state = 192, .external_lex_state = 29},
  [5911] = {.lex_state = 192, .external_lex_state = 2},
  [5912] = {.lex_state = 416, .external_lex_state = 28},
  [5913] = {.lex_state = 235, .external_lex_state = 13},
  [5914] = {.lex_state = 192, .external_lex_state = 2},
  [5915] = {.lex_state = 192, .external_lex_state = 2},
  [5916] = {.lex_state = 192, .external_lex_state = 2},
  [5917] = {.lex_state = 237},
  [5918] = {.lex_state = 419, .external_lex_state = 6},
  [5919] = {.lex_state = 192, .external_lex_state = 2},
  [5920] = {.lex_state = 353, .external_lex_state = 11},
  [5921] = {.lex_state = 353, .external_lex_state = 11},
  [5922] = {.lex_state = 353, .external_lex_state = 11},
  [5923] = {.lex_state = 353, .external_lex_state = 11},
  [5924] = {.lex_state = 356, .external_lex_state = 13},
  [5925] = {.lex_state = 192, .external_lex_state = 2},
  [5926] = {.lex_state = 192, .external_lex_state = 2},
  [5927] = {.lex_state = 192, .external_lex_state = 2},
  [5928] = {.lex_state = 358, .external_lex_state = 11},
  [5929] = {.lex_state = 508, .external_lex_state = 3},
  [5930] = {.lex_state = 343, .external_lex_state = 8},
  [5931] = {.lex_state = 343, .external_lex_state = 8},
  [5932] = {.lex_state = 678, .external_lex_state = 8},
  [5933] = {.lex_state = 343, .external_lex_state = 8},
  [5934] = {.lex_state = 213},
  [5935] = {.lex_state = 421, .external_lex_state = 3},
  [5936] = {.lex_state = 508, .external_lex_state = 14},
  [5937] = {.lex_state = 128},
  [5938] = {.lex_state = 128},
  [5939] = {.lex_state = 128, .external_lex_state = 2},
  [5940] = {.lex_state = 528, .external_lex_state = 3},
  [5941] = {.lex_state = 528, .external_lex_state = 3},
  [5942] = {.lex_state = 528, .external_lex_state = 3},
  [5943] = {.lex_state = 528, .external_lex_state = 3},
  [5944] = {.lex_state = 528, .external_lex_state = 3},
  [5945] = {.lex_state = 528, .external_lex_state = 3},
  [5946] = {.lex_state = 554, .external_lex_state = 16},
  [5947] = {.lex_state = 528, .external_lex_state = 3},
  [5948] = {.lex_state = 528, .external_lex_state = 3},
  [5949] = {.lex_state = 528, .external_lex_state = 3},
  [5950] = {.lex_state = 528, .external_lex_state = 3},
  [5951] = {.lex_state = 528, .external_lex_state = 3},
  [5952] = {.lex_state = 421, .external_lex_state = 3},
  [5953] = {.lex_state = 421, .external_lex_state = 14},
  [5954] = {.lex_state = 421, .external_lex_state = 3},
  [5955] = {.lex_state = 421, .external_lex_state = 3},
  [5956] = {.lex_state = 192, .external_lex_state = 2},
  [5957] = {.lex_state = 421, .external_lex_state = 3},
  [5958] = {.lex_state = 421, .external_lex_state = 3},
  [5959] = {.lex_state = 421, .external_lex_state = 3},
  [5960] = {.lex_state = 192, .external_lex_state = 2},
  [5961] = {.lex_state = 192, .external_lex_state = 2},
  [5962] = {.lex_state = 192, .external_lex_state = 2},
  [5963] = {.lex_state = 192, .external_lex_state = 2},
  [5964] = {.lex_state = 192, .external_lex_state = 2},
  [5965] = {.lex_state = 192, .external_lex_state = 2},
  [5966] = {.lex_state = 192, .external_lex_state = 2},
  [5967] = {.lex_state = 192, .external_lex_state = 2},
  [5968] = {.lex_state = 192, .external_lex_state = 2},
  [5969] = {.lex_state = 192, .external_lex_state = 2},
  [5970] = {.lex_state = 192, .external_lex_state = 2},
  [5971] = {.lex_state = 192, .external_lex_state = 2},
  [5972] = {.lex_state = 192, .external_lex_state = 2},
  [5973] = {.lex_state = 421, .external_lex_state = 3},
  [5974] = {.lex_state = 524, .external_lex_state = 13},
  [5975] = {.lex_state = 421, .external_lex_state = 3},
  [5976] = {.lex_state = 192, .external_lex_state = 29},
  [5977] = {.lex_state = 192, .external_lex_state = 2},
  [5978] = {.lex_state = 421, .external_lex_state = 14},
  [5979] = {.lex_state = 353, .external_lex_state = 8},
  [5980] = {.lex_state = 353, .external_lex_state = 8},
  [5981] = {.lex_state = 192, .external_lex_state = 2},
  [5982] = {.lex_state = 528, .external_lex_state = 3},
  [5983] = {.lex_state = 528, .external_lex_state = 3},
  [5984] = {.lex_state = 528, .external_lex_state = 3},
  [5985] = {.lex_state = 361, .external_lex_state = 14},
  [5986] = {.lex_state = 192, .external_lex_state = 2},
  [5987] = {.lex_state = 511, .external_lex_state = 11},
  [5988] = {.lex_state = 511, .external_lex_state = 11},
  [5989] = {.lex_state = 511, .external_lex_state = 11},
  [5990] = {.lex_state = 511, .external_lex_state = 11},
  [5991] = {.lex_state = 192, .external_lex_state = 2},
  [5992] = {.lex_state = 192, .external_lex_state = 2},
  [5993] = {.lex_state = 192, .external_lex_state = 2},
  [5994] = {.lex_state = 361, .external_lex_state = 3},
  [5995] = {.lex_state = 213},
  [5996] = {.lex_state = 259, .external_lex_state = 3},
  [5997] = {.lex_state = 365, .external_lex_state = 14},
  [5998] = {.lex_state = 361, .external_lex_state = 3},
  [5999] = {.lex_state = 361, .external_lex_state = 3},
  [6000] = {.lex_state = 361, .external_lex_state = 14},
  [6001] = {.lex_state = 192, .external_lex_state = 2},
  [6002] = {.lex_state = 361, .external_lex_state = 3},
  [6003] = {.lex_state = 192, .external_lex_state = 2},
  [6004] = {.lex_state = 192, .external_lex_state = 2},
  [6005] = {.lex_state = 237},
  [6006] = {.lex_state = 192, .external_lex_state = 2},
  [6007] = {.lex_state = 358, .external_lex_state = 11},
  [6008] = {.lex_state = 361, .external_lex_state = 3},
  [6009] = {.lex_state = 361, .external_lex_state = 3},
  [6010] = {.lex_state = 361, .external_lex_state = 3},
  [6011] = {.lex_state = 371, .external_lex_state = 14},
  [6012] = {.lex_state = 361, .external_lex_state = 3},
  [6013] = {.lex_state = 361, .external_lex_state = 3},
  [6014] = {.lex_state = 192, .external_lex_state = 2},
  [6015] = {.lex_state = 192, .external_lex_state = 2},
  [6016] = {.lex_state = 192, .external_lex_state = 2},
  [6017] = {.lex_state = 192, .external_lex_state = 2},
  [6018] = {.lex_state = 192, .external_lex_state = 2},
  [6019] = {.lex_state = 192, .external_lex_state = 2},
  [6020] = {.lex_state = 192, .external_lex_state = 2},
  [6021] = {.lex_state = 192, .external_lex_state = 2},
  [6022] = {.lex_state = 192, .external_lex_state = 2},
  [6023] = {.lex_state = 192, .external_lex_state = 2},
  [6024] = {.lex_state = 192, .external_lex_state = 2},
  [6025] = {.lex_state = 192, .external_lex_state = 2},
  [6026] = {.lex_state = 192, .external_lex_state = 2},
  [6027] = {.lex_state = 192, .external_lex_state = 2},
  [6028] = {.lex_state = 192, .external_lex_state = 2},
  [6029] = {.lex_state = 237},
  [6030] = {.lex_state = 192, .external_lex_state = 2},
  [6031] = {.lex_state = 358, .external_lex_state = 11},
  [6032] = {.lex_state = 421, .external_lex_state = 3},
  [6033] = {.lex_state = 421, .external_lex_state = 3},
  [6034] = {.lex_state = 421, .external_lex_state = 3},
  [6035] = {.lex_state = 427, .external_lex_state = 14},
  [6036] = {.lex_state = 262, .external_lex_state = 3},
  [6037] = {.lex_state = 524, .external_lex_state = 13},
  [6038] = {.lex_state = 361, .external_lex_state = 3},
  [6039] = {.lex_state = 192, .external_lex_state = 29},
  [6040] = {.lex_state = 192, .external_lex_state = 2},
  [6041] = {.lex_state = 361, .external_lex_state = 14},
  [6042] = {.lex_state = 254, .external_lex_state = 8},
  [6043] = {.lex_state = 128, .external_lex_state = 2},
  [6044] = {.lex_state = 128, .external_lex_state = 8},
  [6045] = {.lex_state = 247, .external_lex_state = 3},
  [6046] = {.lex_state = 247, .external_lex_state = 3},
  [6047] = {.lex_state = 247, .external_lex_state = 3},
  [6048] = {.lex_state = 247, .external_lex_state = 3},
  [6049] = {.lex_state = 247, .external_lex_state = 3},
  [6050] = {.lex_state = 247, .external_lex_state = 3},
  [6051] = {.lex_state = 247, .external_lex_state = 3},
  [6052] = {.lex_state = 247, .external_lex_state = 3},
  [6053] = {.lex_state = 247, .external_lex_state = 3},
  [6054] = {.lex_state = 247, .external_lex_state = 3},
  [6055] = {.lex_state = 247, .external_lex_state = 3},
  [6056] = {.lex_state = 554, .external_lex_state = 16},
  [6057] = {.lex_state = 247, .external_lex_state = 3},
  [6058] = {.lex_state = 247, .external_lex_state = 3},
  [6059] = {.lex_state = 247, .external_lex_state = 3},
  [6060] = {.lex_state = 247, .external_lex_state = 3},
  [6061] = {.lex_state = 247, .external_lex_state = 3},
  [6062] = {.lex_state = 192, .external_lex_state = 2},
  [6063] = {.lex_state = 254, .external_lex_state = 11},
  [6064] = {.lex_state = 254, .external_lex_state = 11},
  [6065] = {.lex_state = 254, .external_lex_state = 11},
  [6066] = {.lex_state = 254, .external_lex_state = 11},
  [6067] = {.lex_state = 192, .external_lex_state = 2},
  [6068] = {.lex_state = 192, .external_lex_state = 2},
  [6069] = {.lex_state = 192, .external_lex_state = 2},
  [6070] = {.lex_state = 424, .external_lex_state = 3},
  [6071] = {.lex_state = 254, .external_lex_state = 11},
  [6072] = {.lex_state = 213},
  [6073] = {.lex_state = 424, .external_lex_state = 3},
  [6074] = {.lex_state = 424, .external_lex_state = 14},
  [6075] = {.lex_state = 424, .external_lex_state = 3},
  [6076] = {.lex_state = 421, .external_lex_state = 3},
  [6077] = {.lex_state = 421, .external_lex_state = 14},
  [6078] = {.lex_state = 192, .external_lex_state = 2},
  [6079] = {.lex_state = 424, .external_lex_state = 3},
  [6080] = {.lex_state = 421, .external_lex_state = 3},
  [6081] = {.lex_state = 421, .external_lex_state = 3},
  [6082] = {.lex_state = 192, .external_lex_state = 2},
  [6083] = {.lex_state = 192, .external_lex_state = 2},
  [6084] = {.lex_state = 192, .external_lex_state = 2},
  [6085] = {.lex_state = 192, .external_lex_state = 2},
  [6086] = {.lex_state = 192, .external_lex_state = 2},
  [6087] = {.lex_state = 192, .external_lex_state = 2},
  [6088] = {.lex_state = 192, .external_lex_state = 2},
  [6089] = {.lex_state = 192, .external_lex_state = 2},
  [6090] = {.lex_state = 192, .external_lex_state = 2},
  [6091] = {.lex_state = 192, .external_lex_state = 2},
  [6092] = {.lex_state = 192, .external_lex_state = 2},
  [6093] = {.lex_state = 192, .external_lex_state = 2},
  [6094] = {.lex_state = 192, .external_lex_state = 2},
  [6095] = {.lex_state = 424, .external_lex_state = 3},
  [6096] = {.lex_state = 524, .external_lex_state = 13},
  [6097] = {.lex_state = 424, .external_lex_state = 3},
  [6098] = {.lex_state = 192, .external_lex_state = 29},
  [6099] = {.lex_state = 192, .external_lex_state = 2},
  [6100] = {.lex_state = 421, .external_lex_state = 14},
  [6101] = {.lex_state = 192, .external_lex_state = 2},
  [6102] = {.lex_state = 192, .external_lex_state = 2},
  [6103] = {.lex_state = 192, .external_lex_state = 2},
  [6104] = {.lex_state = 192, .external_lex_state = 2},
  [6105] = {.lex_state = 192, .external_lex_state = 2},
  [6106] = {.lex_state = 528, .external_lex_state = 3},
  [6107] = {.lex_state = 528, .external_lex_state = 3},
  [6108] = {.lex_state = 213},
  [6109] = {.lex_state = 259, .external_lex_state = 3},
  [6110] = {.lex_state = 247, .external_lex_state = 3},
  [6111] = {.lex_state = 262, .external_lex_state = 14},
  [6112] = {.lex_state = 192, .external_lex_state = 2},
  [6113] = {.lex_state = 511, .external_lex_state = 11},
  [6114] = {.lex_state = 511, .external_lex_state = 11},
  [6115] = {.lex_state = 511, .external_lex_state = 11},
  [6116] = {.lex_state = 511, .external_lex_state = 11},
  [6117] = {.lex_state = 192, .external_lex_state = 2},
  [6118] = {.lex_state = 192, .external_lex_state = 2},
  [6119] = {.lex_state = 192, .external_lex_state = 2},
  [6120] = {.lex_state = 361, .external_lex_state = 3},
  [6121] = {.lex_state = 213},
  [6122] = {.lex_state = 259, .external_lex_state = 3},
  [6123] = {.lex_state = 365, .external_lex_state = 14},
  [6124] = {.lex_state = 361, .external_lex_state = 3},
  [6125] = {.lex_state = 361, .external_lex_state = 3},
  [6126] = {.lex_state = 361, .external_lex_state = 14},
  [6127] = {.lex_state = 192, .external_lex_state = 2},
  [6128] = {.lex_state = 361, .external_lex_state = 3},
  [6129] = {.lex_state = 192, .external_lex_state = 2},
  [6130] = {.lex_state = 192, .external_lex_state = 2},
  [6131] = {.lex_state = 237},
  [6132] = {.lex_state = 192, .external_lex_state = 2},
  [6133] = {.lex_state = 358, .external_lex_state = 11},
  [6134] = {.lex_state = 361, .external_lex_state = 3},
  [6135] = {.lex_state = 361, .external_lex_state = 3},
  [6136] = {.lex_state = 361, .external_lex_state = 3},
  [6137] = {.lex_state = 371, .external_lex_state = 14},
  [6138] = {.lex_state = 361, .external_lex_state = 3},
  [6139] = {.lex_state = 361, .external_lex_state = 3},
  [6140] = {.lex_state = 192, .external_lex_state = 2},
  [6141] = {.lex_state = 192, .external_lex_state = 2},
  [6142] = {.lex_state = 192, .external_lex_state = 2},
  [6143] = {.lex_state = 192, .external_lex_state = 2},
  [6144] = {.lex_state = 192, .external_lex_state = 2},
  [6145] = {.lex_state = 192, .external_lex_state = 2},
  [6146] = {.lex_state = 192, .external_lex_state = 2},
  [6147] = {.lex_state = 192, .external_lex_state = 2},
  [6148] = {.lex_state = 192, .external_lex_state = 2},
  [6149] = {.lex_state = 192, .external_lex_state = 2},
  [6150] = {.lex_state = 192, .external_lex_state = 2},
  [6151] = {.lex_state = 192, .external_lex_state = 2},
  [6152] = {.lex_state = 192, .external_lex_state = 2},
  [6153] = {.lex_state = 192, .external_lex_state = 2},
  [6154] = {.lex_state = 192, .external_lex_state = 2},
  [6155] = {.lex_state = 237},
  [6156] = {.lex_state = 192, .external_lex_state = 2},
  [6157] = {.lex_state = 358, .external_lex_state = 11},
  [6158] = {.lex_state = 421, .external_lex_state = 3},
  [6159] = {.lex_state = 421, .external_lex_state = 3},
  [6160] = {.lex_state = 421, .external_lex_state = 3},
  [6161] = {.lex_state = 427, .external_lex_state = 14},
  [6162] = {.lex_state = 262, .external_lex_state = 3},
  [6163] = {.lex_state = 524, .external_lex_state = 13},
  [6164] = {.lex_state = 361, .external_lex_state = 3},
  [6165] = {.lex_state = 192, .external_lex_state = 29},
  [6166] = {.lex_state = 192, .external_lex_state = 2},
  [6167] = {.lex_state = 361, .external_lex_state = 14},
  [6168] = {.lex_state = 254, .external_lex_state = 8},
  [6169] = {.lex_state = 128, .external_lex_state = 2},
  [6170] = {.lex_state = 128, .external_lex_state = 8},
  [6171] = {.lex_state = 247, .external_lex_state = 3},
  [6172] = {.lex_state = 247, .external_lex_state = 3},
  [6173] = {.lex_state = 247, .external_lex_state = 3},
  [6174] = {.lex_state = 247, .external_lex_state = 3},
  [6175] = {.lex_state = 247, .external_lex_state = 3},
  [6176] = {.lex_state = 247, .external_lex_state = 3},
  [6177] = {.lex_state = 247, .external_lex_state = 3},
  [6178] = {.lex_state = 247, .external_lex_state = 3},
  [6179] = {.lex_state = 247, .external_lex_state = 3},
  [6180] = {.lex_state = 247, .external_lex_state = 3},
  [6181] = {.lex_state = 247, .external_lex_state = 3},
  [6182] = {.lex_state = 554, .external_lex_state = 16},
  [6183] = {.lex_state = 247, .external_lex_state = 3},
  [6184] = {.lex_state = 247, .external_lex_state = 3},
  [6185] = {.lex_state = 247, .external_lex_state = 3},
  [6186] = {.lex_state = 247, .external_lex_state = 3},
  [6187] = {.lex_state = 247, .external_lex_state = 3},
  [6188] = {.lex_state = 192, .external_lex_state = 2},
  [6189] = {.lex_state = 254, .external_lex_state = 11},
  [6190] = {.lex_state = 254, .external_lex_state = 11},
  [6191] = {.lex_state = 254, .external_lex_state = 11},
  [6192] = {.lex_state = 254, .external_lex_state = 11},
  [6193] = {.lex_state = 192, .external_lex_state = 2},
  [6194] = {.lex_state = 192, .external_lex_state = 2},
  [6195] = {.lex_state = 192, .external_lex_state = 2},
  [6196] = {.lex_state = 424, .external_lex_state = 3},
  [6197] = {.lex_state = 254, .external_lex_state = 11},
  [6198] = {.lex_state = 213},
  [6199] = {.lex_state = 424, .external_lex_state = 3},
  [6200] = {.lex_state = 424, .external_lex_state = 14},
  [6201] = {.lex_state = 424, .external_lex_state = 3},
  [6202] = {.lex_state = 421, .external_lex_state = 3},
  [6203] = {.lex_state = 421, .external_lex_state = 14},
  [6204] = {.lex_state = 192, .external_lex_state = 2},
  [6205] = {.lex_state = 424, .external_lex_state = 3},
  [6206] = {.lex_state = 421, .external_lex_state = 3},
  [6207] = {.lex_state = 421, .external_lex_state = 3},
  [6208] = {.lex_state = 192, .external_lex_state = 2},
  [6209] = {.lex_state = 192, .external_lex_state = 2},
  [6210] = {.lex_state = 192, .external_lex_state = 2},
  [6211] = {.lex_state = 192, .external_lex_state = 2},
  [6212] = {.lex_state = 192, .external_lex_state = 2},
  [6213] = {.lex_state = 192, .external_lex_state = 2},
  [6214] = {.lex_state = 192, .external_lex_state = 2},
  [6215] = {.lex_state = 192, .external_lex_state = 2},
  [6216] = {.lex_state = 192, .external_lex_state = 2},
  [6217] = {.lex_state = 192, .external_lex_state = 2},
  [6218] = {.lex_state = 192, .external_lex_state = 2},
  [6219] = {.lex_state = 192, .external_lex_state = 2},
  [6220] = {.lex_state = 192, .external_lex_state = 2},
  [6221] = {.lex_state = 424, .external_lex_state = 3},
  [6222] = {.lex_state = 524, .external_lex_state = 13},
  [6223] = {.lex_state = 424, .external_lex_state = 3},
  [6224] = {.lex_state = 192, .external_lex_state = 29},
  [6225] = {.lex_state = 192, .external_lex_state = 2},
  [6226] = {.lex_state = 421, .external_lex_state = 14},
  [6227] = {.lex_state = 192, .external_lex_state = 2},
  [6228] = {.lex_state = 192, .external_lex_state = 2},
  [6229] = {.lex_state = 192, .external_lex_state = 2},
  [6230] = {.lex_state = 192, .external_lex_state = 2},
  [6231] = {.lex_state = 192, .external_lex_state = 2},
  [6232] = {.lex_state = 528, .external_lex_state = 3},
  [6233] = {.lex_state = 528, .external_lex_state = 3},
  [6234] = {.lex_state = 213},
  [6235] = {.lex_state = 259, .external_lex_state = 3},
  [6236] = {.lex_state = 247, .external_lex_state = 3},
  [6237] = {.lex_state = 262, .external_lex_state = 14},
  [6238] = {.lex_state = 254, .external_lex_state = 8},
  [6239] = {.lex_state = 156, .external_lex_state = 3},
  [6240] = {.lex_state = 128},
  [6241] = {.lex_state = 128, .external_lex_state = 2},
  [6242] = {.lex_state = 192, .external_lex_state = 2},
  [6243] = {.lex_state = 424, .external_lex_state = 3},
  [6244] = {.lex_state = 424, .external_lex_state = 3},
  [6245] = {.lex_state = 424, .external_lex_state = 3},
  [6246] = {.lex_state = 192, .external_lex_state = 2},
  [6247] = {.lex_state = 192, .external_lex_state = 2},
  [6248] = {.lex_state = 192, .external_lex_state = 2},
  [6249] = {.lex_state = 192, .external_lex_state = 2},
  [6250] = {.lex_state = 192, .external_lex_state = 2},
  [6251] = {.lex_state = 192, .external_lex_state = 2},
  [6252] = {.lex_state = 192, .external_lex_state = 2},
  [6253] = {.lex_state = 192, .external_lex_state = 2},
  [6254] = {.lex_state = 192, .external_lex_state = 2},
  [6255] = {.lex_state = 192, .external_lex_state = 2},
  [6256] = {.lex_state = 192, .external_lex_state = 2},
  [6257] = {.lex_state = 192, .external_lex_state = 2},
  [6258] = {.lex_state = 192, .external_lex_state = 29},
  [6259] = {.lex_state = 192, .external_lex_state = 2},
  [6260] = {.lex_state = 424, .external_lex_state = 14},
  [6261] = {.lex_state = 424, .external_lex_state = 3},
  [6262] = {.lex_state = 421, .external_lex_state = 3},
  [6263] = {.lex_state = 421, .external_lex_state = 3},
  [6264] = {.lex_state = 421, .external_lex_state = 3},
  [6265] = {.lex_state = 421, .external_lex_state = 3},
  [6266] = {.lex_state = 421, .external_lex_state = 3},
  [6267] = {.lex_state = 421, .external_lex_state = 3},
  [6268] = {.lex_state = 424, .external_lex_state = 3},
  [6269] = {.lex_state = 554, .external_lex_state = 16},
  [6270] = {.lex_state = 421, .external_lex_state = 3},
  [6271] = {.lex_state = 421, .external_lex_state = 3},
  [6272] = {.lex_state = 421, .external_lex_state = 3},
  [6273] = {.lex_state = 421, .external_lex_state = 3},
  [6274] = {.lex_state = 421, .external_lex_state = 3},
  [6275] = {.lex_state = 424, .external_lex_state = 3},
  [6276] = {.lex_state = 524, .external_lex_state = 21},
  [6277] = {.lex_state = 424, .external_lex_state = 3},
  [6278] = {.lex_state = 424, .external_lex_state = 3},
  [6279] = {.lex_state = 421, .external_lex_state = 3},
  [6280] = {.lex_state = 421, .external_lex_state = 3},
  [6281] = {.lex_state = 421, .external_lex_state = 3},
  [6282] = {.lex_state = 421, .external_lex_state = 14},
  [6283] = {.lex_state = 528, .external_lex_state = 3},
  [6284] = {.lex_state = 528, .external_lex_state = 3},
  [6285] = {.lex_state = 528, .external_lex_state = 3},
  [6286] = {.lex_state = 528, .external_lex_state = 3},
  [6287] = {.lex_state = 192, .external_lex_state = 2},
  [6288] = {.lex_state = 192, .external_lex_state = 2},
  [6289] = {.lex_state = 192, .external_lex_state = 2},
  [6290] = {.lex_state = 192, .external_lex_state = 2},
  [6291] = {.lex_state = 192, .external_lex_state = 2},
  [6292] = {.lex_state = 192, .external_lex_state = 2},
  [6293] = {.lex_state = 192, .external_lex_state = 2},
  [6294] = {.lex_state = 192, .external_lex_state = 2},
  [6295] = {.lex_state = 192, .external_lex_state = 2},
  [6296] = {.lex_state = 192, .external_lex_state = 2},
  [6297] = {.lex_state = 192, .external_lex_state = 2},
  [6298] = {.lex_state = 192, .external_lex_state = 2},
  [6299] = {.lex_state = 192, .external_lex_state = 29},
  [6300] = {.lex_state = 528, .external_lex_state = 3},
  [6301] = {.lex_state = 192, .external_lex_state = 29},
  [6302] = {.lex_state = 192, .external_lex_state = 2},
  [6303] = {.lex_state = 388, .external_lex_state = 25},
  [6304] = {.lex_state = 388, .external_lex_state = 25},
  [6305] = {.lex_state = 177, .external_lex_state = 4},
  [6306] = {.lex_state = 266, .external_lex_state = 15},
  [6307] = {.lex_state = 388, .external_lex_state = 25},
  [6308] = {.lex_state = 177, .external_lex_state = 4},
  [6309] = {.lex_state = 388, .external_lex_state = 25},
  [6310] = {.lex_state = 388, .external_lex_state = 25},
  [6311] = {.lex_state = 177, .external_lex_state = 4},
  [6312] = {.lex_state = 266, .external_lex_state = 15},
  [6313] = {.lex_state = 388, .external_lex_state = 25},
  [6314] = {.lex_state = 177, .external_lex_state = 4},
  [6315] = {.lex_state = 192, .external_lex_state = 2},
  [6316] = {.lex_state = 192, .external_lex_state = 2},
  [6317] = {.lex_state = 192, .external_lex_state = 2},
  [6318] = {.lex_state = 192, .external_lex_state = 2},
  [6319] = {.lex_state = 406, .external_lex_state = 25},
  [6320] = {.lex_state = 213},
  [6321] = {.lex_state = 537, .external_lex_state = 25},
  [6322] = {.lex_state = 406, .external_lex_state = 25},
  [6323] = {.lex_state = 192, .external_lex_state = 2},
  [6324] = {.lex_state = 406, .external_lex_state = 25},
  [6325] = {.lex_state = 192, .external_lex_state = 2},
  [6326] = {.lex_state = 406, .external_lex_state = 25},
  [6327] = {.lex_state = 524, .external_lex_state = 13},
  [6328] = {.lex_state = 406, .external_lex_state = 25},
  [6329] = {.lex_state = 400, .external_lex_state = 25},
  [6330] = {.lex_state = 400, .external_lex_state = 25},
  [6331] = {.lex_state = 400, .external_lex_state = 25},
  [6332] = {.lex_state = 400, .external_lex_state = 25},
  [6333] = {.lex_state = 400, .external_lex_state = 25},
  [6334] = {.lex_state = 400, .external_lex_state = 25},
  [6335] = {.lex_state = 554, .external_lex_state = 16},
  [6336] = {.lex_state = 400, .external_lex_state = 25},
  [6337] = {.lex_state = 400, .external_lex_state = 25},
  [6338] = {.lex_state = 400, .external_lex_state = 25},
  [6339] = {.lex_state = 400, .external_lex_state = 25},
  [6340] = {.lex_state = 400, .external_lex_state = 25},
  [6341] = {.lex_state = 192, .external_lex_state = 2},
  [6342] = {.lex_state = 534, .external_lex_state = 26},
  [6343] = {.lex_state = 534, .external_lex_state = 26},
  [6344] = {.lex_state = 534, .external_lex_state = 26},
  [6345] = {.lex_state = 534, .external_lex_state = 26},
  [6346] = {.lex_state = 192, .external_lex_state = 2},
  [6347] = {.lex_state = 192, .external_lex_state = 2},
  [6348] = {.lex_state = 192, .external_lex_state = 2},
  [6349] = {.lex_state = 537, .external_lex_state = 25},
  [6350] = {.lex_state = 534, .external_lex_state = 26},
  [6351] = {.lex_state = 213},
  [6352] = {.lex_state = 537, .external_lex_state = 25},
  [6353] = {.lex_state = 537, .external_lex_state = 27},
  [6354] = {.lex_state = 537, .external_lex_state = 25},
  [6355] = {.lex_state = 192, .external_lex_state = 2},
  [6356] = {.lex_state = 537, .external_lex_state = 25},
  [6357] = {.lex_state = 192, .external_lex_state = 2},
  [6358] = {.lex_state = 537, .external_lex_state = 25},
  [6359] = {.lex_state = 524, .external_lex_state = 13},
  [6360] = {.lex_state = 537, .external_lex_state = 25},
  [6361] = {.lex_state = 192, .external_lex_state = 2},
  [6362] = {.lex_state = 400, .external_lex_state = 25},
  [6363] = {.lex_state = 400, .external_lex_state = 25},
  [6364] = {.lex_state = 400, .external_lex_state = 25},
  [6365] = {.lex_state = 540, .external_lex_state = 27},
  [6366] = {.lex_state = 388, .external_lex_state = 25},
  [6367] = {.lex_state = 310},
  [6368] = {.lex_state = 388, .external_lex_state = 25},
  [6369] = {.lex_state = 388, .external_lex_state = 25},
  [6370] = {.lex_state = 128, .external_lex_state = 2},
  [6371] = {.lex_state = 128, .external_lex_state = 2},
  [6372] = {.lex_state = 388, .external_lex_state = 25},
  [6373] = {.lex_state = 388, .external_lex_state = 25},
  [6374] = {.lex_state = 406, .external_lex_state = 25},
  [6375] = {.lex_state = 406, .external_lex_state = 25},
  [6376] = {.lex_state = 406, .external_lex_state = 25},
  [6377] = {.lex_state = 406, .external_lex_state = 25},
  [6378] = {.lex_state = 406, .external_lex_state = 25},
  [6379] = {.lex_state = 406, .external_lex_state = 25},
  [6380] = {.lex_state = 406, .external_lex_state = 25},
  [6381] = {.lex_state = 406, .external_lex_state = 25},
  [6382] = {.lex_state = 554, .external_lex_state = 16},
  [6383] = {.lex_state = 406, .external_lex_state = 25},
  [6384] = {.lex_state = 406, .external_lex_state = 25},
  [6385] = {.lex_state = 406, .external_lex_state = 25},
  [6386] = {.lex_state = 406, .external_lex_state = 25},
  [6387] = {.lex_state = 406, .external_lex_state = 25},
  [6388] = {.lex_state = 406, .external_lex_state = 25},
  [6389] = {.lex_state = 524, .external_lex_state = 21},
  [6390] = {.lex_state = 406, .external_lex_state = 25},
  [6391] = {.lex_state = 406, .external_lex_state = 25},
  [6392] = {.lex_state = 406, .external_lex_state = 25},
  [6393] = {.lex_state = 406, .external_lex_state = 25},
  [6394] = {.lex_state = 406, .external_lex_state = 25},
  [6395] = {.lex_state = 388, .external_lex_state = 25},
  [6396] = {.lex_state = 128},
  [6397] = {.lex_state = 128},
  [6398] = {.lex_state = 128, .external_lex_state = 2},
  [6399] = {.lex_state = 388, .external_lex_state = 25},
  [6400] = {.lex_state = 128},
  [6401] = {.lex_state = 128},
  [6402] = {.lex_state = 388, .external_lex_state = 25},
  [6403] = {.lex_state = 128},
  [6404] = {.lex_state = 388, .external_lex_state = 25},
  [6405] = {.lex_state = 128},
  [6406] = {.lex_state = 128, .external_lex_state = 2},
  [6407] = {.lex_state = 128},
  [6408] = {.lex_state = 128},
  [6409] = {.lex_state = 388, .external_lex_state = 25},
  [6410] = {.lex_state = 388, .external_lex_state = 25},
  [6411] = {.lex_state = 128},
  [6412] = {.lex_state = 128},
  [6413] = {.lex_state = 388, .external_lex_state = 25},
  [6414] = {.lex_state = 388, .external_lex_state = 25},
  [6415] = {.lex_state = 194},
  [6416] = {.lex_state = 388, .external_lex_state = 25},
  [6417] = {.lex_state = 128},
  [6418] = {.lex_state = 128, .external_lex_state = 2},
  [6419] = {.lex_state = 128, .external_lex_state = 12},
  [6420] = {.lex_state = 192, .external_lex_state = 2},
  [6421] = {.lex_state = 544, .external_lex_state = 26},
  [6422] = {.lex_state = 209, .external_lex_state = 19},
  [6423] = {.lex_state = 209},
  [6424] = {.lex_state = 544, .external_lex_state = 26},
  [6425] = {.lex_state = 397, .external_lex_state = 25},
  [6426] = {.lex_state = 235},
  [6427] = {.lex_state = 403, .external_lex_state = 25},
  [6428] = {.lex_state = 397, .external_lex_state = 25},
  [6429] = {.lex_state = 194},
  [6430] = {.lex_state = 397, .external_lex_state = 25},
  [6431] = {.lex_state = 128},
  [6432] = {.lex_state = 128, .external_lex_state = 2},
  [6433] = {.lex_state = 128, .external_lex_state = 12},
  [6434] = {.lex_state = 403, .external_lex_state = 25},
  [6435] = {.lex_state = 403, .external_lex_state = 25},
  [6436] = {.lex_state = 403, .external_lex_state = 25},
  [6437] = {.lex_state = 403, .external_lex_state = 25},
  [6438] = {.lex_state = 403, .external_lex_state = 25},
  [6439] = {.lex_state = 403, .external_lex_state = 25},
  [6440] = {.lex_state = 403, .external_lex_state = 25},
  [6441] = {.lex_state = 554, .external_lex_state = 16},
  [6442] = {.lex_state = 403, .external_lex_state = 25},
  [6443] = {.lex_state = 403, .external_lex_state = 25},
  [6444] = {.lex_state = 403, .external_lex_state = 25},
  [6445] = {.lex_state = 403, .external_lex_state = 25},
  [6446] = {.lex_state = 403, .external_lex_state = 25},
  [6447] = {.lex_state = 403, .external_lex_state = 25},
  [6448] = {.lex_state = 524, .external_lex_state = 21},
  [6449] = {.lex_state = 403, .external_lex_state = 25},
  [6450] = {.lex_state = 403, .external_lex_state = 25},
  [6451] = {.lex_state = 403, .external_lex_state = 25},
  [6452] = {.lex_state = 403, .external_lex_state = 25},
  [6453] = {.lex_state = 403, .external_lex_state = 25},
  [6454] = {.lex_state = 640, .external_lex_state = 27},
  [6455] = {.lex_state = 641, .external_lex_state = 13},
  [6456] = {.lex_state = 177, .external_lex_state = 17},
  [6457] = {.lex_state = 641, .external_lex_state = 19},
  [6458] = {.lex_state = 400, .external_lex_state = 25},
  [6459] = {.lex_state = 192, .external_lex_state = 29},
  [6460] = {.lex_state = 400, .external_lex_state = 25},
  [6461] = {.lex_state = 286, .external_lex_state = 2},
  [6462] = {.lex_state = 128},
  [6463] = {.lex_state = 237},
  [6464] = {.lex_state = 681, .external_lex_state = 2},
  [6465] = {.lex_state = 192, .external_lex_state = 2},
  [6466] = {.lex_state = 237},
  [6467] = {.lex_state = 237},
  [6468] = {.lex_state = 156, .external_lex_state = 3},
  [6469] = {.lex_state = 337},
  [6470] = {.lex_state = 302},
  [6471] = {.lex_state = 302, .external_lex_state = 16},
  [6472] = {.lex_state = 302, .external_lex_state = 16},
  [6473] = {.lex_state = 337},
  [6474] = {.lex_state = 128},
  [6475] = {.lex_state = 302},
  [6476] = {.lex_state = 128, .external_lex_state = 12},
  [6477] = {.lex_state = 128},
  [6478] = {.lex_state = 237},
  [6479] = {.lex_state = 237},
  [6480] = {.lex_state = 237},
  [6481] = {.lex_state = 156, .external_lex_state = 3},
  [6482] = {.lex_state = 128},
  [6483] = {.lex_state = 128, .external_lex_state = 2},
  [6484] = {.lex_state = 302, .external_lex_state = 16},
  [6485] = {.lex_state = 302, .external_lex_state = 16},
  [6486] = {.lex_state = 302, .external_lex_state = 16},
  [6487] = {.lex_state = 192, .external_lex_state = 2},
  [6488] = {.lex_state = 192, .external_lex_state = 2},
  [6489] = {.lex_state = 192, .external_lex_state = 2},
  [6490] = {.lex_state = 192, .external_lex_state = 2},
  [6491] = {.lex_state = 192, .external_lex_state = 2},
  [6492] = {.lex_state = 192, .external_lex_state = 2},
  [6493] = {.lex_state = 192, .external_lex_state = 2},
  [6494] = {.lex_state = 192, .external_lex_state = 2},
  [6495] = {.lex_state = 192, .external_lex_state = 2},
  [6496] = {.lex_state = 192, .external_lex_state = 2},
  [6497] = {.lex_state = 192, .external_lex_state = 2},
  [6498] = {.lex_state = 192, .external_lex_state = 2},
  [6499] = {.lex_state = 419, .external_lex_state = 6},
  [6500] = {.lex_state = 227, .external_lex_state = 16},
  [6501] = {.lex_state = 192, .external_lex_state = 29},
  [6502] = {.lex_state = 192, .external_lex_state = 2},
  [6503] = {.lex_state = 251, .external_lex_state = 20},
  [6504] = {.lex_state = 645, .external_lex_state = 20},
  [6505] = {.lex_state = 192, .external_lex_state = 2},
  [6506] = {.lex_state = 683, .external_lex_state = 26},
  [6507] = {.lex_state = 683, .external_lex_state = 26},
  [6508] = {.lex_state = 683, .external_lex_state = 26},
  [6509] = {.lex_state = 683, .external_lex_state = 26},
  [6510] = {.lex_state = 192, .external_lex_state = 2},
  [6511] = {.lex_state = 192, .external_lex_state = 2},
  [6512] = {.lex_state = 192, .external_lex_state = 2},
  [6513] = {.lex_state = 645, .external_lex_state = 25},
  [6514] = {.lex_state = 556, .external_lex_state = 26},
  [6515] = {.lex_state = 213},
  [6516] = {.lex_state = 559, .external_lex_state = 25},
  [6517] = {.lex_state = 645, .external_lex_state = 27},
  [6518] = {.lex_state = 645, .external_lex_state = 25},
  [6519] = {.lex_state = 177, .external_lex_state = 4},
  [6520] = {.lex_state = 654, .external_lex_state = 25},
  [6521] = {.lex_state = 654, .external_lex_state = 27},
  [6522] = {.lex_state = 192, .external_lex_state = 2},
  [6523] = {.lex_state = 645, .external_lex_state = 25},
  [6524] = {.lex_state = 192, .external_lex_state = 2},
  [6525] = {.lex_state = 192, .external_lex_state = 2},
  [6526] = {.lex_state = 237},
  [6527] = {.lex_state = 192, .external_lex_state = 2},
  [6528] = {.lex_state = 651, .external_lex_state = 26},
  [6529] = {.lex_state = 654, .external_lex_state = 25},
  [6530] = {.lex_state = 654, .external_lex_state = 25},
  [6531] = {.lex_state = 654, .external_lex_state = 25},
  [6532] = {.lex_state = 661, .external_lex_state = 27},
  [6533] = {.lex_state = 654, .external_lex_state = 25},
  [6534] = {.lex_state = 654, .external_lex_state = 25},
  [6535] = {.lex_state = 192, .external_lex_state = 2},
  [6536] = {.lex_state = 192, .external_lex_state = 2},
  [6537] = {.lex_state = 192, .external_lex_state = 2},
  [6538] = {.lex_state = 192, .external_lex_state = 2},
  [6539] = {.lex_state = 192, .external_lex_state = 2},
  [6540] = {.lex_state = 192, .external_lex_state = 2},
  [6541] = {.lex_state = 192, .external_lex_state = 2},
  [6542] = {.lex_state = 192, .external_lex_state = 2},
  [6543] = {.lex_state = 192, .external_lex_state = 2},
  [6544] = {.lex_state = 192, .external_lex_state = 2},
  [6545] = {.lex_state = 192, .external_lex_state = 2},
  [6546] = {.lex_state = 192, .external_lex_state = 2},
  [6547] = {.lex_state = 192, .external_lex_state = 2},
  [6548] = {.lex_state = 192, .external_lex_state = 2},
  [6549] = {.lex_state = 192, .external_lex_state = 2},
  [6550] = {.lex_state = 237},
  [6551] = {.lex_state = 192, .external_lex_state = 2},
  [6552] = {.lex_state = 651, .external_lex_state = 26},
  [6553] = {.lex_state = 658, .external_lex_state = 25},
  [6554] = {.lex_state = 658, .external_lex_state = 25},
  [6555] = {.lex_state = 658, .external_lex_state = 25},
  [6556] = {.lex_state = 662, .external_lex_state = 27},
  [6557] = {.lex_state = 562, .external_lex_state = 25},
  [6558] = {.lex_state = 524, .external_lex_state = 13},
  [6559] = {.lex_state = 645, .external_lex_state = 25},
  [6560] = {.lex_state = 192, .external_lex_state = 29},
  [6561] = {.lex_state = 192, .external_lex_state = 2},
  [6562] = {.lex_state = 654, .external_lex_state = 27},
  [6563] = {.lex_state = 554, .external_lex_state = 16},
  [6564] = {.lex_state = 554, .external_lex_state = 16},
  [6565] = {.lex_state = 554, .external_lex_state = 16},
  [6566] = {.lex_state = 554, .external_lex_state = 16},
  [6567] = {.lex_state = 554, .external_lex_state = 16},
  [6568] = {.lex_state = 554, .external_lex_state = 16},
  [6569] = {.lex_state = 554, .external_lex_state = 16},
  [6570] = {.lex_state = 247, .external_lex_state = 3},
  [6571] = {.lex_state = 554, .external_lex_state = 16},
  [6572] = {.lex_state = 554, .external_lex_state = 16},
  [6573] = {.lex_state = 554, .external_lex_state = 16},
  [6574] = {.lex_state = 554, .external_lex_state = 16},
  [6575] = {.lex_state = 554, .external_lex_state = 16},
  [6576] = {.lex_state = 192, .external_lex_state = 2},
  [6577] = {.lex_state = 556, .external_lex_state = 26},
  [6578] = {.lex_state = 556, .external_lex_state = 26},
  [6579] = {.lex_state = 556, .external_lex_state = 26},
  [6580] = {.lex_state = 556, .external_lex_state = 26},
  [6581] = {.lex_state = 192, .external_lex_state = 2},
  [6582] = {.lex_state = 192, .external_lex_state = 2},
  [6583] = {.lex_state = 192, .external_lex_state = 2},
  [6584] = {.lex_state = 559, .external_lex_state = 25},
  [6585] = {.lex_state = 556, .external_lex_state = 26},
  [6586] = {.lex_state = 213},
  [6587] = {.lex_state = 559, .external_lex_state = 25},
  [6588] = {.lex_state = 559, .external_lex_state = 27},
  [6589] = {.lex_state = 559, .external_lex_state = 25},
  [6590] = {.lex_state = 177, .external_lex_state = 4},
  [6591] = {.lex_state = 658, .external_lex_state = 25},
  [6592] = {.lex_state = 658, .external_lex_state = 27},
  [6593] = {.lex_state = 192, .external_lex_state = 2},
  [6594] = {.lex_state = 559, .external_lex_state = 25},
  [6595] = {.lex_state = 658, .external_lex_state = 25},
  [6596] = {.lex_state = 658, .external_lex_state = 25},
  [6597] = {.lex_state = 192, .external_lex_state = 2},
  [6598] = {.lex_state = 192, .external_lex_state = 2},
  [6599] = {.lex_state = 192, .external_lex_state = 2},
  [6600] = {.lex_state = 192, .external_lex_state = 2},
  [6601] = {.lex_state = 192, .external_lex_state = 2},
  [6602] = {.lex_state = 192, .external_lex_state = 2},
  [6603] = {.lex_state = 192, .external_lex_state = 2},
  [6604] = {.lex_state = 192, .external_lex_state = 2},
  [6605] = {.lex_state = 192, .external_lex_state = 2},
  [6606] = {.lex_state = 192, .external_lex_state = 2},
  [6607] = {.lex_state = 192, .external_lex_state = 2},
  [6608] = {.lex_state = 192, .external_lex_state = 2},
  [6609] = {.lex_state = 192, .external_lex_state = 2},
  [6610] = {.lex_state = 559, .external_lex_state = 25},
  [6611] = {.lex_state = 524, .external_lex_state = 13},
  [6612] = {.lex_state = 559, .external_lex_state = 25},
  [6613] = {.lex_state = 192, .external_lex_state = 29},
  [6614] = {.lex_state = 192, .external_lex_state = 2},
  [6615] = {.lex_state = 658, .external_lex_state = 27},
  [6616] = {.lex_state = 192, .external_lex_state = 2},
  [6617] = {.lex_state = 192, .external_lex_state = 2},
  [6618] = {.lex_state = 683, .external_lex_state = 18},
  [6619] = {.lex_state = 683, .external_lex_state = 18},
  [6620] = {.lex_state = 683, .external_lex_state = 18},
  [6621] = {.lex_state = 683, .external_lex_state = 18},
  [6622] = {.lex_state = 192, .external_lex_state = 2},
  [6623] = {.lex_state = 192, .external_lex_state = 2},
  [6624] = {.lex_state = 192, .external_lex_state = 2},
  [6625] = {.lex_state = 554, .external_lex_state = 16},
  [6626] = {.lex_state = 554, .external_lex_state = 16},
  [6627] = {.lex_state = 213},
  [6628] = {.lex_state = 559, .external_lex_state = 16},
  [6629] = {.lex_state = 645, .external_lex_state = 20},
  [6630] = {.lex_state = 554, .external_lex_state = 16},
  [6631] = {.lex_state = 562, .external_lex_state = 20},
  [6632] = {.lex_state = 416, .external_lex_state = 28},
  [6633] = {.lex_state = 327, .external_lex_state = 11},
  [6634] = {.lex_state = 209},
  [6635] = {.lex_state = 227, .external_lex_state = 3},
  [6636] = {.lex_state = 299, .external_lex_state = 3},
  [6637] = {.lex_state = 299, .external_lex_state = 3},
  [6638] = {.lex_state = 177, .external_lex_state = 4},
  [6639] = {.lex_state = 266, .external_lex_state = 15},
  [6640] = {.lex_state = 299, .external_lex_state = 3},
  [6641] = {.lex_state = 177, .external_lex_state = 4},
  [6642] = {.lex_state = 299, .external_lex_state = 3},
  [6643] = {.lex_state = 299, .external_lex_state = 3},
  [6644] = {.lex_state = 177, .external_lex_state = 4},
  [6645] = {.lex_state = 266, .external_lex_state = 15},
  [6646] = {.lex_state = 299, .external_lex_state = 3},
  [6647] = {.lex_state = 177, .external_lex_state = 4},
  [6648] = {.lex_state = 227, .external_lex_state = 14},
  [6649] = {.lex_state = 227, .external_lex_state = 3},
  [6650] = {.lex_state = 227, .external_lex_state = 3},
  [6651] = {.lex_state = 227, .external_lex_state = 3},
  [6652] = {.lex_state = 227, .external_lex_state = 3},
  [6653] = {.lex_state = 192, .external_lex_state = 15},
  [6654] = {.lex_state = 266, .external_lex_state = 15},
  [6655] = {.lex_state = 227, .external_lex_state = 3},
  [6656] = {.lex_state = 177, .external_lex_state = 4},
  [6657] = {.lex_state = 266, .external_lex_state = 15},
  [6658] = {.lex_state = 227, .external_lex_state = 3},
  [6659] = {.lex_state = 192, .external_lex_state = 15},
  [6660] = {.lex_state = 266, .external_lex_state = 15},
  [6661] = {.lex_state = 227, .external_lex_state = 3},
  [6662] = {.lex_state = 177, .external_lex_state = 4},
  [6663] = {.lex_state = 266, .external_lex_state = 15},
  [6664] = {.lex_state = 227, .external_lex_state = 3},
  [6665] = {.lex_state = 194},
  [6666] = {.lex_state = 302, .external_lex_state = 16},
  [6667] = {.lex_state = 225, .external_lex_state = 7},
  [6668] = {.lex_state = 128, .external_lex_state = 2},
  [6669] = {.lex_state = 227, .external_lex_state = 3},
  [6670] = {.lex_state = 247, .external_lex_state = 3},
  [6671] = {.lex_state = 128, .external_lex_state = 8},
  [6672] = {.lex_state = 128, .external_lex_state = 2},
  [6673] = {.lex_state = 227, .external_lex_state = 3},
  [6674] = {.lex_state = 128, .external_lex_state = 2},
  [6675] = {.lex_state = 128, .external_lex_state = 12},
  [6676] = {.lex_state = 128, .external_lex_state = 2},
  [6677] = {.lex_state = 128, .external_lex_state = 2},
  [6678] = {.lex_state = 128, .external_lex_state = 2},
  [6679] = {.lex_state = 128, .external_lex_state = 8},
  [6680] = {.lex_state = 128},
  [6681] = {.lex_state = 128},
  [6682] = {.lex_state = 128},
  [6683] = {.lex_state = 227, .external_lex_state = 3},
  [6684] = {.lex_state = 128},
  [6685] = {.lex_state = 128},
  [6686] = {.lex_state = 128},
  [6687] = {.lex_state = 227, .external_lex_state = 3},
  [6688] = {.lex_state = 227, .external_lex_state = 3},
  [6689] = {.lex_state = 235},
  [6690] = {.lex_state = 227, .external_lex_state = 3},
  [6691] = {.lex_state = 424, .external_lex_state = 3},
  [6692] = {.lex_state = 424, .external_lex_state = 3},
  [6693] = {.lex_state = 424, .external_lex_state = 3},
  [6694] = {.lex_state = 424, .external_lex_state = 3},
  [6695] = {.lex_state = 424, .external_lex_state = 3},
  [6696] = {.lex_state = 424, .external_lex_state = 3},
  [6697] = {.lex_state = 554, .external_lex_state = 16},
  [6698] = {.lex_state = 424, .external_lex_state = 3},
  [6699] = {.lex_state = 424, .external_lex_state = 3},
  [6700] = {.lex_state = 424, .external_lex_state = 3},
  [6701] = {.lex_state = 424, .external_lex_state = 3},
  [6702] = {.lex_state = 424, .external_lex_state = 3},
  [6703] = {.lex_state = 299, .external_lex_state = 3},
  [6704] = {.lex_state = 424, .external_lex_state = 3},
  [6705] = {.lex_state = 227, .external_lex_state = 3},
  [6706] = {.lex_state = 424, .external_lex_state = 3},
  [6707] = {.lex_state = 424, .external_lex_state = 3},
  [6708] = {.lex_state = 424, .external_lex_state = 14},
  [6709] = {.lex_state = 588, .external_lex_state = 3},
  [6710] = {.lex_state = 588, .external_lex_state = 3},
  [6711] = {.lex_state = 192, .external_lex_state = 2},
  [6712] = {.lex_state = 588, .external_lex_state = 3},
  [6713] = {.lex_state = 192, .external_lex_state = 2},
  [6714] = {.lex_state = 455, .external_lex_state = 3},
  [6715] = {.lex_state = 524, .external_lex_state = 13},
  [6716] = {.lex_state = 588, .external_lex_state = 3},
  [6717] = {.lex_state = 227, .external_lex_state = 3},
  [6718] = {.lex_state = 436, .external_lex_state = 3},
  [6719] = {.lex_state = 436, .external_lex_state = 3},
  [6720] = {.lex_state = 436, .external_lex_state = 3},
  [6721] = {.lex_state = 436, .external_lex_state = 3},
  [6722] = {.lex_state = 436, .external_lex_state = 3},
  [6723] = {.lex_state = 436, .external_lex_state = 3},
  [6724] = {.lex_state = 554, .external_lex_state = 16},
  [6725] = {.lex_state = 436, .external_lex_state = 3},
  [6726] = {.lex_state = 436, .external_lex_state = 3},
  [6727] = {.lex_state = 436, .external_lex_state = 3},
  [6728] = {.lex_state = 436, .external_lex_state = 3},
  [6729] = {.lex_state = 436, .external_lex_state = 3},
  [6730] = {.lex_state = 573, .external_lex_state = 3},
  [6731] = {.lex_state = 573, .external_lex_state = 3},
  [6732] = {.lex_state = 192, .external_lex_state = 2},
  [6733] = {.lex_state = 573, .external_lex_state = 3},
  [6734] = {.lex_state = 192, .external_lex_state = 2},
  [6735] = {.lex_state = 573, .external_lex_state = 3},
  [6736] = {.lex_state = 524, .external_lex_state = 13},
  [6737] = {.lex_state = 573, .external_lex_state = 3},
  [6738] = {.lex_state = 192, .external_lex_state = 2},
  [6739] = {.lex_state = 192, .external_lex_state = 2},
  [6740] = {.lex_state = 192, .external_lex_state = 2},
  [6741] = {.lex_state = 192, .external_lex_state = 2},
  [6742] = {.lex_state = 192, .external_lex_state = 2},
  [6743] = {.lex_state = 436, .external_lex_state = 3},
  [6744] = {.lex_state = 436, .external_lex_state = 3},
  [6745] = {.lex_state = 213},
  [6746] = {.lex_state = 573, .external_lex_state = 3},
  [6747] = {.lex_state = 436, .external_lex_state = 3},
  [6748] = {.lex_state = 455, .external_lex_state = 14},
  [6749] = {.lex_state = 299, .external_lex_state = 3},
  [6750] = {.lex_state = 310},
  [6751] = {.lex_state = 299, .external_lex_state = 3},
  [6752] = {.lex_state = 299, .external_lex_state = 3},
  [6753] = {.lex_state = 128, .external_lex_state = 2},
  [6754] = {.lex_state = 128, .external_lex_state = 2},
  [6755] = {.lex_state = 299, .external_lex_state = 3},
  [6756] = {.lex_state = 299, .external_lex_state = 3},
  [6757] = {.lex_state = 299, .external_lex_state = 3},
  [6758] = {.lex_state = 128},
  [6759] = {.lex_state = 128},
  [6760] = {.lex_state = 128, .external_lex_state = 2},
  [6761] = {.lex_state = 299, .external_lex_state = 3},
  [6762] = {.lex_state = 128},
  [6763] = {.lex_state = 128},
  [6764] = {.lex_state = 299, .external_lex_state = 3},
  [6765] = {.lex_state = 128},
  [6766] = {.lex_state = 299, .external_lex_state = 3},
  [6767] = {.lex_state = 128},
  [6768] = {.lex_state = 128, .external_lex_state = 2},
  [6769] = {.lex_state = 227, .external_lex_state = 3},
  [6770] = {.lex_state = 128},
  [6771] = {.lex_state = 128, .external_lex_state = 2},
  [6772] = {.lex_state = 128},
  [6773] = {.lex_state = 128},
  [6774] = {.lex_state = 299, .external_lex_state = 3},
  [6775] = {.lex_state = 299, .external_lex_state = 3},
  [6776] = {.lex_state = 128},
  [6777] = {.lex_state = 128},
  [6778] = {.lex_state = 227, .external_lex_state = 3},
  [6779] = {.lex_state = 299, .external_lex_state = 3},
  [6780] = {.lex_state = 192, .external_lex_state = 2},
  [6781] = {.lex_state = 227, .external_lex_state = 3},
  [6782] = {.lex_state = 227, .external_lex_state = 3},
  [6783] = {.lex_state = 192, .external_lex_state = 29},
  [6784] = {.lex_state = 421, .external_lex_state = 3},
  [6785] = {.lex_state = 577, .external_lex_state = 3},
  [6786] = {.lex_state = 577, .external_lex_state = 3},
  [6787] = {.lex_state = 577, .external_lex_state = 3},
  [6788] = {.lex_state = 577, .external_lex_state = 3},
  [6789] = {.lex_state = 577, .external_lex_state = 3},
  [6790] = {.lex_state = 577, .external_lex_state = 3},
  [6791] = {.lex_state = 554, .external_lex_state = 16},
  [6792] = {.lex_state = 577, .external_lex_state = 3},
  [6793] = {.lex_state = 577, .external_lex_state = 3},
  [6794] = {.lex_state = 577, .external_lex_state = 3},
  [6795] = {.lex_state = 577, .external_lex_state = 3},
  [6796] = {.lex_state = 577, .external_lex_state = 3},
  [6797] = {.lex_state = 380, .external_lex_state = 3},
  [6798] = {.lex_state = 577, .external_lex_state = 3},
  [6799] = {.lex_state = 577, .external_lex_state = 3},
  [6800] = {.lex_state = 577, .external_lex_state = 3},
  [6801] = {.lex_state = 467, .external_lex_state = 25},
  [6802] = {.lex_state = 467, .external_lex_state = 25},
  [6803] = {.lex_state = 467, .external_lex_state = 25},
  [6804] = {.lex_state = 467, .external_lex_state = 25},
  [6805] = {.lex_state = 467, .external_lex_state = 25},
  [6806] = {.lex_state = 192, .external_lex_state = 2},
  [6807] = {.lex_state = 192, .external_lex_state = 2},
  [6808] = {.lex_state = 192, .external_lex_state = 2},
  [6809] = {.lex_state = 192, .external_lex_state = 2},
  [6810] = {.lex_state = 192, .external_lex_state = 2},
  [6811] = {.lex_state = 192, .external_lex_state = 2},
  [6812] = {.lex_state = 192, .external_lex_state = 2},
  [6813] = {.lex_state = 192, .external_lex_state = 2},
  [6814] = {.lex_state = 192, .external_lex_state = 2},
  [6815] = {.lex_state = 192, .external_lex_state = 2},
  [6816] = {.lex_state = 192, .external_lex_state = 2},
  [6817] = {.lex_state = 192, .external_lex_state = 2},
  [6818] = {.lex_state = 192, .external_lex_state = 29},
  [6819] = {.lex_state = 192, .external_lex_state = 2},
  [6820] = {.lex_state = 467, .external_lex_state = 27},
  [6821] = {.lex_state = 467, .external_lex_state = 25},
  [6822] = {.lex_state = 588, .external_lex_state = 25},
  [6823] = {.lex_state = 588, .external_lex_state = 25},
  [6824] = {.lex_state = 192, .external_lex_state = 2},
  [6825] = {.lex_state = 588, .external_lex_state = 25},
  [6826] = {.lex_state = 192, .external_lex_state = 2},
  [6827] = {.lex_state = 588, .external_lex_state = 25},
  [6828] = {.lex_state = 524, .external_lex_state = 13},
  [6829] = {.lex_state = 588, .external_lex_state = 25},
  [6830] = {.lex_state = 588, .external_lex_state = 25},
  [6831] = {.lex_state = 588, .external_lex_state = 25},
  [6832] = {.lex_state = 588, .external_lex_state = 25},
  [6833] = {.lex_state = 588, .external_lex_state = 25},
  [6834] = {.lex_state = 588, .external_lex_state = 25},
  [6835] = {.lex_state = 588, .external_lex_state = 25},
  [6836] = {.lex_state = 467, .external_lex_state = 25},
  [6837] = {.lex_state = 554, .external_lex_state = 16},
  [6838] = {.lex_state = 588, .external_lex_state = 25},
  [6839] = {.lex_state = 588, .external_lex_state = 25},
  [6840] = {.lex_state = 588, .external_lex_state = 25},
  [6841] = {.lex_state = 588, .external_lex_state = 25},
  [6842] = {.lex_state = 588, .external_lex_state = 25},
  [6843] = {.lex_state = 573, .external_lex_state = 25},
  [6844] = {.lex_state = 573, .external_lex_state = 25},
  [6845] = {.lex_state = 192, .external_lex_state = 2},
  [6846] = {.lex_state = 573, .external_lex_state = 25},
  [6847] = {.lex_state = 192, .external_lex_state = 2},
  [6848] = {.lex_state = 573, .external_lex_state = 25},
  [6849] = {.lex_state = 524, .external_lex_state = 13},
  [6850] = {.lex_state = 573, .external_lex_state = 25},
  [6851] = {.lex_state = 444, .external_lex_state = 25},
  [6852] = {.lex_state = 524, .external_lex_state = 21},
  [6853] = {.lex_state = 444, .external_lex_state = 25},
  [6854] = {.lex_state = 467, .external_lex_state = 25},
  [6855] = {.lex_state = 588, .external_lex_state = 25},
  [6856] = {.lex_state = 588, .external_lex_state = 25},
  [6857] = {.lex_state = 588, .external_lex_state = 25},
  [6858] = {.lex_state = 663, .external_lex_state = 27},
  [6859] = {.lex_state = 237},
  [6860] = {.lex_state = 237},
  [6861] = {.lex_state = 192, .external_lex_state = 2},
  [6862] = {.lex_state = 579, .external_lex_state = 18},
  [6863] = {.lex_state = 209, .external_lex_state = 19},
  [6864] = {.lex_state = 209},
  [6865] = {.lex_state = 579, .external_lex_state = 18},
  [6866] = {.lex_state = 433, .external_lex_state = 16},
  [6867] = {.lex_state = 235},
  [6868] = {.lex_state = 461, .external_lex_state = 27},
  [6869] = {.lex_state = 192, .external_lex_state = 15},
  [6870] = {.lex_state = 461, .external_lex_state = 25},
  [6871] = {.lex_state = 192, .external_lex_state = 15},
  [6872] = {.lex_state = 461, .external_lex_state = 25},
  [6873] = {.lex_state = 192, .external_lex_state = 15},
  [6874] = {.lex_state = 461, .external_lex_state = 25},
  [6875] = {.lex_state = 192, .external_lex_state = 15},
  [6876] = {.lex_state = 461, .external_lex_state = 25},
  [6877] = {.lex_state = 190, .external_lex_state = 4},
  [6878] = {.lex_state = 266, .external_lex_state = 15},
  [6879] = {.lex_state = 461, .external_lex_state = 25},
  [6880] = {.lex_state = 190, .external_lex_state = 4},
  [6881] = {.lex_state = 266, .external_lex_state = 15},
  [6882] = {.lex_state = 441, .external_lex_state = 25},
  [6883] = {.lex_state = 461, .external_lex_state = 25},
  [6884] = {.lex_state = 194},
  [6885] = {.lex_state = 194, .external_lex_state = 19},
  [6886] = {.lex_state = 192, .external_lex_state = 2},
  [6887] = {.lex_state = 461, .external_lex_state = 25},
  [6888] = {.lex_state = 310},
  [6889] = {.lex_state = 310, .external_lex_state = 8},
  [6890] = {.lex_state = 461, .external_lex_state = 25},
  [6891] = {.lex_state = 209},
  [6892] = {.lex_state = 192, .external_lex_state = 2},
  [6893] = {.lex_state = 346, .external_lex_state = 23},
  [6894] = {.lex_state = 346, .external_lex_state = 23},
  [6895] = {.lex_state = 350, .external_lex_state = 23},
  [6896] = {.lex_state = 350, .external_lex_state = 23},
  [6897] = {.lex_state = 461, .external_lex_state = 25},
  [6898] = {.lex_state = 461, .external_lex_state = 25},
  [6899] = {.lex_state = 461, .external_lex_state = 25},
  [6900] = {.lex_state = 461, .external_lex_state = 25},
  [6901] = {.lex_state = 128, .external_lex_state = 8},
  [6902] = {.lex_state = 128, .external_lex_state = 8},
  [6903] = {.lex_state = 247, .external_lex_state = 3},
  [6904] = {.lex_state = 247, .external_lex_state = 3},
  [6905] = {.lex_state = 128},
  [6906] = {.lex_state = 247, .external_lex_state = 3},
  [6907] = {.lex_state = 128},
  [6908] = {.lex_state = 128},
  [6909] = {.lex_state = 128},
  [6910] = {.lex_state = 128},
  [6911] = {.lex_state = 128},
  [6912] = {.lex_state = 461, .external_lex_state = 25},
  [6913] = {.lex_state = 128, .external_lex_state = 2},
  [6914] = {.lex_state = 441, .external_lex_state = 25},
  [6915] = {.lex_state = 441, .external_lex_state = 25},
  [6916] = {.lex_state = 461, .external_lex_state = 25},
  [6917] = {.lex_state = 461, .external_lex_state = 25},
  [6918] = {.lex_state = 461, .external_lex_state = 25},
  [6919] = {.lex_state = 235, .external_lex_state = 19},
  [6920] = {.lex_state = 235},
  [6921] = {.lex_state = 128},
  [6922] = {.lex_state = 461, .external_lex_state = 25},
  [6923] = {.lex_state = 192, .external_lex_state = 2},
  [6924] = {.lex_state = 192, .external_lex_state = 2},
  [6925] = {.lex_state = 192, .external_lex_state = 2},
  [6926] = {.lex_state = 192, .external_lex_state = 2},
  [6927] = {.lex_state = 192, .external_lex_state = 2},
  [6928] = {.lex_state = 192, .external_lex_state = 2},
  [6929] = {.lex_state = 192, .external_lex_state = 2},
  [6930] = {.lex_state = 192, .external_lex_state = 2},
  [6931] = {.lex_state = 192, .external_lex_state = 2},
  [6932] = {.lex_state = 192, .external_lex_state = 2},
  [6933] = {.lex_state = 192, .external_lex_state = 2},
  [6934] = {.lex_state = 192, .external_lex_state = 2},
  [6935] = {.lex_state = 192, .external_lex_state = 29},
  [6936] = {.lex_state = 192, .external_lex_state = 2},
  [6937] = {.lex_state = 441, .external_lex_state = 27},
  [6938] = {.lex_state = 441, .external_lex_state = 25},
  [6939] = {.lex_state = 433, .external_lex_state = 16},
  [6940] = {.lex_state = 194},
  [6941] = {.lex_state = 433, .external_lex_state = 16},
  [6942] = {.lex_state = 128},
  [6943] = {.lex_state = 128, .external_lex_state = 2},
  [6944] = {.lex_state = 128, .external_lex_state = 12},
  [6945] = {.lex_state = 461, .external_lex_state = 25},
  [6946] = {.lex_state = 209},
  [6947] = {.lex_state = 573, .external_lex_state = 25},
  [6948] = {.lex_state = 573, .external_lex_state = 25},
  [6949] = {.lex_state = 573, .external_lex_state = 25},
  [6950] = {.lex_state = 573, .external_lex_state = 25},
  [6951] = {.lex_state = 573, .external_lex_state = 25},
  [6952] = {.lex_state = 573, .external_lex_state = 25},
  [6953] = {.lex_state = 441, .external_lex_state = 25},
  [6954] = {.lex_state = 554, .external_lex_state = 16},
  [6955] = {.lex_state = 573, .external_lex_state = 25},
  [6956] = {.lex_state = 573, .external_lex_state = 25},
  [6957] = {.lex_state = 573, .external_lex_state = 25},
  [6958] = {.lex_state = 573, .external_lex_state = 25},
  [6959] = {.lex_state = 573, .external_lex_state = 25},
  [6960] = {.lex_state = 433, .external_lex_state = 16},
  [6961] = {.lex_state = 461, .external_lex_state = 25},
  [6962] = {.lex_state = 177, .external_lex_state = 17},
  [6963] = {.lex_state = 441, .external_lex_state = 25},
  [6964] = {.lex_state = 461, .external_lex_state = 25},
  [6965] = {.lex_state = 524, .external_lex_state = 21},
  [6966] = {.lex_state = 441, .external_lex_state = 25},
  [6967] = {.lex_state = 441, .external_lex_state = 25},
  [6968] = {.lex_state = 573, .external_lex_state = 25},
  [6969] = {.lex_state = 573, .external_lex_state = 25},
  [6970] = {.lex_state = 573, .external_lex_state = 25},
  [6971] = {.lex_state = 664, .external_lex_state = 27},
  [6972] = {.lex_state = 436, .external_lex_state = 16},
  [6973] = {.lex_state = 436, .external_lex_state = 16},
  [6974] = {.lex_state = 436, .external_lex_state = 16},
  [6975] = {.lex_state = 436, .external_lex_state = 16},
  [6976] = {.lex_state = 192, .external_lex_state = 2},
  [6977] = {.lex_state = 192, .external_lex_state = 2},
  [6978] = {.lex_state = 192, .external_lex_state = 2},
  [6979] = {.lex_state = 192, .external_lex_state = 2},
  [6980] = {.lex_state = 192, .external_lex_state = 2},
  [6981] = {.lex_state = 192, .external_lex_state = 2},
  [6982] = {.lex_state = 192, .external_lex_state = 2},
  [6983] = {.lex_state = 192, .external_lex_state = 2},
  [6984] = {.lex_state = 192, .external_lex_state = 2},
  [6985] = {.lex_state = 192, .external_lex_state = 2},
  [6986] = {.lex_state = 192, .external_lex_state = 2},
  [6987] = {.lex_state = 192, .external_lex_state = 2},
  [6988] = {.lex_state = 192, .external_lex_state = 29},
  [6989] = {.lex_state = 436, .external_lex_state = 16},
  [6990] = {.lex_state = 192, .external_lex_state = 29},
  [6991] = {.lex_state = 192, .external_lex_state = 2},
  [6992] = {.lex_state = 467, .external_lex_state = 20},
  [6993] = {.lex_state = 156, .external_lex_state = 3},
  [6994] = {.lex_state = 156, .external_lex_state = 3},
  [6995] = {.lex_state = 467, .external_lex_state = 3},
  [6996] = {.lex_state = 467, .external_lex_state = 3},
  [6997] = {.lex_state = 467, .external_lex_state = 3},
  [6998] = {.lex_state = 467, .external_lex_state = 3},
  [6999] = {.lex_state = 467, .external_lex_state = 3},
  [7000] = {.lex_state = 192, .external_lex_state = 2},
  [7001] = {.lex_state = 192, .external_lex_state = 2},
  [7002] = {.lex_state = 192, .external_lex_state = 2},
  [7003] = {.lex_state = 192, .external_lex_state = 2},
  [7004] = {.lex_state = 192, .external_lex_state = 2},
  [7005] = {.lex_state = 192, .external_lex_state = 2},
  [7006] = {.lex_state = 192, .external_lex_state = 2},
  [7007] = {.lex_state = 192, .external_lex_state = 2},
  [7008] = {.lex_state = 192, .external_lex_state = 2},
  [7009] = {.lex_state = 192, .external_lex_state = 2},
  [7010] = {.lex_state = 192, .external_lex_state = 2},
  [7011] = {.lex_state = 192, .external_lex_state = 2},
  [7012] = {.lex_state = 192, .external_lex_state = 29},
  [7013] = {.lex_state = 192, .external_lex_state = 2},
  [7014] = {.lex_state = 467, .external_lex_state = 14},
  [7015] = {.lex_state = 467, .external_lex_state = 3},
  [7016] = {.lex_state = 588, .external_lex_state = 3},
  [7017] = {.lex_state = 588, .external_lex_state = 3},
  [7018] = {.lex_state = 588, .external_lex_state = 3},
  [7019] = {.lex_state = 588, .external_lex_state = 3},
  [7020] = {.lex_state = 588, .external_lex_state = 3},
  [7021] = {.lex_state = 588, .external_lex_state = 3},
  [7022] = {.lex_state = 588, .external_lex_state = 3},
  [7023] = {.lex_state = 588, .external_lex_state = 3},
  [7024] = {.lex_state = 467, .external_lex_state = 3},
  [7025] = {.lex_state = 554, .external_lex_state = 16},
  [7026] = {.lex_state = 588, .external_lex_state = 3},
  [7027] = {.lex_state = 588, .external_lex_state = 3},
  [7028] = {.lex_state = 588, .external_lex_state = 3},
  [7029] = {.lex_state = 588, .external_lex_state = 3},
  [7030] = {.lex_state = 588, .external_lex_state = 3},
  [7031] = {.lex_state = 444, .external_lex_state = 3},
  [7032] = {.lex_state = 524, .external_lex_state = 21},
  [7033] = {.lex_state = 444, .external_lex_state = 3},
  [7034] = {.lex_state = 467, .external_lex_state = 3},
  [7035] = {.lex_state = 588, .external_lex_state = 3},
  [7036] = {.lex_state = 588, .external_lex_state = 3},
  [7037] = {.lex_state = 588, .external_lex_state = 3},
  [7038] = {.lex_state = 663, .external_lex_state = 14},
  [7039] = {.lex_state = 237, .external_lex_state = 8},
  [7040] = {.lex_state = 128, .external_lex_state = 2},
  [7041] = {.lex_state = 192, .external_lex_state = 2},
  [7042] = {.lex_state = 441, .external_lex_state = 3},
  [7043] = {.lex_state = 441, .external_lex_state = 3},
  [7044] = {.lex_state = 441, .external_lex_state = 3},
  [7045] = {.lex_state = 192, .external_lex_state = 2},
  [7046] = {.lex_state = 192, .external_lex_state = 2},
  [7047] = {.lex_state = 192, .external_lex_state = 2},
  [7048] = {.lex_state = 192, .external_lex_state = 2},
  [7049] = {.lex_state = 192, .external_lex_state = 2},
  [7050] = {.lex_state = 192, .external_lex_state = 2},
  [7051] = {.lex_state = 192, .external_lex_state = 2},
  [7052] = {.lex_state = 192, .external_lex_state = 2},
  [7053] = {.lex_state = 192, .external_lex_state = 2},
  [7054] = {.lex_state = 192, .external_lex_state = 2},
  [7055] = {.lex_state = 192, .external_lex_state = 2},
  [7056] = {.lex_state = 192, .external_lex_state = 2},
  [7057] = {.lex_state = 192, .external_lex_state = 29},
  [7058] = {.lex_state = 192, .external_lex_state = 2},
  [7059] = {.lex_state = 441, .external_lex_state = 14},
  [7060] = {.lex_state = 441, .external_lex_state = 3},
  [7061] = {.lex_state = 573, .external_lex_state = 3},
  [7062] = {.lex_state = 573, .external_lex_state = 3},
  [7063] = {.lex_state = 573, .external_lex_state = 3},
  [7064] = {.lex_state = 573, .external_lex_state = 3},
  [7065] = {.lex_state = 573, .external_lex_state = 3},
  [7066] = {.lex_state = 573, .external_lex_state = 3},
  [7067] = {.lex_state = 441, .external_lex_state = 3},
  [7068] = {.lex_state = 554, .external_lex_state = 16},
  [7069] = {.lex_state = 573, .external_lex_state = 3},
  [7070] = {.lex_state = 573, .external_lex_state = 3},
  [7071] = {.lex_state = 573, .external_lex_state = 3},
  [7072] = {.lex_state = 573, .external_lex_state = 3},
  [7073] = {.lex_state = 573, .external_lex_state = 3},
  [7074] = {.lex_state = 441, .external_lex_state = 3},
  [7075] = {.lex_state = 524, .external_lex_state = 21},
  [7076] = {.lex_state = 441, .external_lex_state = 3},
  [7077] = {.lex_state = 441, .external_lex_state = 3},
  [7078] = {.lex_state = 573, .external_lex_state = 3},
  [7079] = {.lex_state = 573, .external_lex_state = 3},
  [7080] = {.lex_state = 573, .external_lex_state = 3},
  [7081] = {.lex_state = 664, .external_lex_state = 14},
  [7082] = {.lex_state = 436, .external_lex_state = 3},
  [7083] = {.lex_state = 436, .external_lex_state = 3},
  [7084] = {.lex_state = 436, .external_lex_state = 3},
  [7085] = {.lex_state = 436, .external_lex_state = 3},
  [7086] = {.lex_state = 192, .external_lex_state = 2},
  [7087] = {.lex_state = 192, .external_lex_state = 2},
  [7088] = {.lex_state = 192, .external_lex_state = 2},
  [7089] = {.lex_state = 192, .external_lex_state = 2},
  [7090] = {.lex_state = 192, .external_lex_state = 2},
  [7091] = {.lex_state = 192, .external_lex_state = 2},
  [7092] = {.lex_state = 192, .external_lex_state = 2},
  [7093] = {.lex_state = 192, .external_lex_state = 2},
  [7094] = {.lex_state = 192, .external_lex_state = 2},
  [7095] = {.lex_state = 192, .external_lex_state = 2},
  [7096] = {.lex_state = 192, .external_lex_state = 2},
  [7097] = {.lex_state = 192, .external_lex_state = 2},
  [7098] = {.lex_state = 192, .external_lex_state = 29},
  [7099] = {.lex_state = 436, .external_lex_state = 3},
  [7100] = {.lex_state = 192, .external_lex_state = 29},
  [7101] = {.lex_state = 192, .external_lex_state = 2},
  [7102] = {.lex_state = 288, .external_lex_state = 16},
  [7103] = {.lex_state = 177, .external_lex_state = 4},
  [7104] = {.lex_state = 288, .external_lex_state = 16},
  [7105] = {.lex_state = 288, .external_lex_state = 16},
  [7106] = {.lex_state = 177, .external_lex_state = 4},
  [7107] = {.lex_state = 288, .external_lex_state = 16},
  [7108] = {.lex_state = 225, .external_lex_state = 7},
  [7109] = {.lex_state = 467, .external_lex_state = 25},
  [7110] = {.lex_state = 467, .external_lex_state = 25},
  [7111] = {.lex_state = 467, .external_lex_state = 25},
  [7112] = {.lex_state = 192, .external_lex_state = 2},
  [7113] = {.lex_state = 192, .external_lex_state = 2},
  [7114] = {.lex_state = 192, .external_lex_state = 2},
  [7115] = {.lex_state = 192, .external_lex_state = 2},
  [7116] = {.lex_state = 192, .external_lex_state = 2},
  [7117] = {.lex_state = 192, .external_lex_state = 2},
  [7118] = {.lex_state = 192, .external_lex_state = 2},
  [7119] = {.lex_state = 192, .external_lex_state = 2},
  [7120] = {.lex_state = 192, .external_lex_state = 2},
  [7121] = {.lex_state = 192, .external_lex_state = 2},
  [7122] = {.lex_state = 192, .external_lex_state = 2},
  [7123] = {.lex_state = 192, .external_lex_state = 2},
  [7124] = {.lex_state = 192, .external_lex_state = 29},
  [7125] = {.lex_state = 192, .external_lex_state = 2},
  [7126] = {.lex_state = 467, .external_lex_state = 25},
  [7127] = {.lex_state = 588, .external_lex_state = 25},
  [7128] = {.lex_state = 588, .external_lex_state = 25},
  [7129] = {.lex_state = 192, .external_lex_state = 2},
  [7130] = {.lex_state = 588, .external_lex_state = 25},
  [7131] = {.lex_state = 192, .external_lex_state = 2},
  [7132] = {.lex_state = 588, .external_lex_state = 25},
  [7133] = {.lex_state = 524, .external_lex_state = 13},
  [7134] = {.lex_state = 588, .external_lex_state = 25},
  [7135] = {.lex_state = 588, .external_lex_state = 25},
  [7136] = {.lex_state = 588, .external_lex_state = 25},
  [7137] = {.lex_state = 588, .external_lex_state = 25},
  [7138] = {.lex_state = 588, .external_lex_state = 25},
  [7139] = {.lex_state = 588, .external_lex_state = 25},
  [7140] = {.lex_state = 588, .external_lex_state = 25},
  [7141] = {.lex_state = 467, .external_lex_state = 25},
  [7142] = {.lex_state = 554, .external_lex_state = 16},
  [7143] = {.lex_state = 588, .external_lex_state = 25},
  [7144] = {.lex_state = 588, .external_lex_state = 25},
  [7145] = {.lex_state = 588, .external_lex_state = 25},
  [7146] = {.lex_state = 588, .external_lex_state = 25},
  [7147] = {.lex_state = 588, .external_lex_state = 25},
  [7148] = {.lex_state = 573, .external_lex_state = 25},
  [7149] = {.lex_state = 573, .external_lex_state = 25},
  [7150] = {.lex_state = 192, .external_lex_state = 2},
  [7151] = {.lex_state = 573, .external_lex_state = 25},
  [7152] = {.lex_state = 192, .external_lex_state = 2},
  [7153] = {.lex_state = 573, .external_lex_state = 25},
  [7154] = {.lex_state = 524, .external_lex_state = 13},
  [7155] = {.lex_state = 573, .external_lex_state = 25},
  [7156] = {.lex_state = 467, .external_lex_state = 25},
  [7157] = {.lex_state = 524, .external_lex_state = 21},
  [7158] = {.lex_state = 467, .external_lex_state = 25},
  [7159] = {.lex_state = 467, .external_lex_state = 25},
  [7160] = {.lex_state = 588, .external_lex_state = 25},
  [7161] = {.lex_state = 588, .external_lex_state = 25},
  [7162] = {.lex_state = 588, .external_lex_state = 25},
  [7163] = {.lex_state = 663, .external_lex_state = 27},
  [7164] = {.lex_state = 192, .external_lex_state = 2},
  [7165] = {.lex_state = 595, .external_lex_state = 26},
  [7166] = {.lex_state = 209, .external_lex_state = 19},
  [7167] = {.lex_state = 209},
  [7168] = {.lex_state = 595, .external_lex_state = 26},
  [7169] = {.lex_state = 461, .external_lex_state = 25},
  [7170] = {.lex_state = 235},
  [7171] = {.lex_state = 441, .external_lex_state = 25},
  [7172] = {.lex_state = 441, .external_lex_state = 25},
  [7173] = {.lex_state = 441, .external_lex_state = 25},
  [7174] = {.lex_state = 192, .external_lex_state = 2},
  [7175] = {.lex_state = 192, .external_lex_state = 2},
  [7176] = {.lex_state = 192, .external_lex_state = 2},
  [7177] = {.lex_state = 192, .external_lex_state = 2},
  [7178] = {.lex_state = 192, .external_lex_state = 2},
  [7179] = {.lex_state = 192, .external_lex_state = 2},
  [7180] = {.lex_state = 192, .external_lex_state = 2},
  [7181] = {.lex_state = 192, .external_lex_state = 2},
  [7182] = {.lex_state = 192, .external_lex_state = 2},
  [7183] = {.lex_state = 192, .external_lex_state = 2},
  [7184] = {.lex_state = 192, .external_lex_state = 2},
  [7185] = {.lex_state = 192, .external_lex_state = 2},
  [7186] = {.lex_state = 192, .external_lex_state = 29},
  [7187] = {.lex_state = 192, .external_lex_state = 2},
  [7188] = {.lex_state = 441, .external_lex_state = 27},
  [7189] = {.lex_state = 441, .external_lex_state = 25},
  [7190] = {.lex_state = 461, .external_lex_state = 25},
  [7191] = {.lex_state = 194},
  [7192] = {.lex_state = 461, .external_lex_state = 25},
  [7193] = {.lex_state = 128},
  [7194] = {.lex_state = 128, .external_lex_state = 2},
  [7195] = {.lex_state = 128, .external_lex_state = 12},
  [7196] = {.lex_state = 573, .external_lex_state = 25},
  [7197] = {.lex_state = 573, .external_lex_state = 25},
  [7198] = {.lex_state = 573, .external_lex_state = 25},
  [7199] = {.lex_state = 573, .external_lex_state = 25},
  [7200] = {.lex_state = 573, .external_lex_state = 25},
  [7201] = {.lex_state = 573, .external_lex_state = 25},
  [7202] = {.lex_state = 441, .external_lex_state = 25},
  [7203] = {.lex_state = 554, .external_lex_state = 16},
  [7204] = {.lex_state = 573, .external_lex_state = 25},
  [7205] = {.lex_state = 573, .external_lex_state = 25},
  [7206] = {.lex_state = 573, .external_lex_state = 25},
  [7207] = {.lex_state = 573, .external_lex_state = 25},
  [7208] = {.lex_state = 573, .external_lex_state = 25},
  [7209] = {.lex_state = 461, .external_lex_state = 25},
  [7210] = {.lex_state = 441, .external_lex_state = 25},
  [7211] = {.lex_state = 524, .external_lex_state = 21},
  [7212] = {.lex_state = 441, .external_lex_state = 25},
  [7213] = {.lex_state = 441, .external_lex_state = 25},
  [7214] = {.lex_state = 573, .external_lex_state = 25},
  [7215] = {.lex_state = 573, .external_lex_state = 25},
  [7216] = {.lex_state = 573, .external_lex_state = 25},
  [7217] = {.lex_state = 664, .external_lex_state = 27},
  [7218] = {.lex_state = 436, .external_lex_state = 25},
  [7219] = {.lex_state = 192, .external_lex_state = 29},
  [7220] = {.lex_state = 436, .external_lex_state = 25},
  [7221] = {.lex_state = 288, .external_lex_state = 16},
  [7222] = {.lex_state = 288, .external_lex_state = 16},
  [7223] = {.lex_state = 361, .external_lex_state = 25},
  [7224] = {.lex_state = 361, .external_lex_state = 25},
  [7225] = {.lex_state = 388, .external_lex_state = 25},
  [7226] = {.lex_state = 192, .external_lex_state = 2},
  [7227] = {.lex_state = 388, .external_lex_state = 25},
  [7228] = {.lex_state = 388, .external_lex_state = 25},
  [7229] = {.lex_state = 192, .external_lex_state = 29},
  [7230] = {.lex_state = 361, .external_lex_state = 25},
  [7231] = {.lex_state = 288, .external_lex_state = 16},
  [7232] = {.lex_state = 128},
  [7233] = {.lex_state = 128},
  [7234] = {.lex_state = 288, .external_lex_state = 16},
  [7235] = {.lex_state = 128},
  [7236] = {.lex_state = 288, .external_lex_state = 16},
  [7237] = {.lex_state = 288, .external_lex_state = 16},
  [7238] = {.lex_state = 288, .external_lex_state = 16},
  [7239] = {.lex_state = 128},
  [7240] = {.lex_state = 288, .external_lex_state = 16},
  [7241] = {.lex_state = 128},
  [7242] = {.lex_state = 288, .external_lex_state = 16},
  [7243] = {.lex_state = 128},
  [7244] = {.lex_state = 288, .external_lex_state = 16},
  [7245] = {.lex_state = 288, .external_lex_state = 16},
  [7246] = {.lex_state = 128},
  [7247] = {.lex_state = 128, .external_lex_state = 2},
  [7248] = {.lex_state = 302, .external_lex_state = 16},
  [7249] = {.lex_state = 304, .external_lex_state = 18},
  [7250] = {.lex_state = 209},
  [7251] = {.lex_state = 299, .external_lex_state = 16},
  [7252] = {.lex_state = 397, .external_lex_state = 25},
  [7253] = {.lex_state = 397, .external_lex_state = 25},
  [7254] = {.lex_state = 177, .external_lex_state = 4},
  [7255] = {.lex_state = 266, .external_lex_state = 15},
  [7256] = {.lex_state = 397, .external_lex_state = 25},
  [7257] = {.lex_state = 177, .external_lex_state = 4},
  [7258] = {.lex_state = 397, .external_lex_state = 25},
  [7259] = {.lex_state = 397, .external_lex_state = 25},
  [7260] = {.lex_state = 177, .external_lex_state = 4},
  [7261] = {.lex_state = 266, .external_lex_state = 15},
  [7262] = {.lex_state = 397, .external_lex_state = 25},
  [7263] = {.lex_state = 177, .external_lex_state = 4},
  [7264] = {.lex_state = 299, .external_lex_state = 16},
  [7265] = {.lex_state = 397, .external_lex_state = 25},
  [7266] = {.lex_state = 310},
  [7267] = {.lex_state = 397, .external_lex_state = 25},
  [7268] = {.lex_state = 397, .external_lex_state = 25},
  [7269] = {.lex_state = 128, .external_lex_state = 2},
  [7270] = {.lex_state = 128, .external_lex_state = 2},
  [7271] = {.lex_state = 397, .external_lex_state = 25},
  [7272] = {.lex_state = 397, .external_lex_state = 25},
  [7273] = {.lex_state = 397, .external_lex_state = 25},
  [7274] = {.lex_state = 128},
  [7275] = {.lex_state = 128},
  [7276] = {.lex_state = 128, .external_lex_state = 2},
  [7277] = {.lex_state = 397, .external_lex_state = 25},
  [7278] = {.lex_state = 128},
  [7279] = {.lex_state = 128},
  [7280] = {.lex_state = 397, .external_lex_state = 25},
  [7281] = {.lex_state = 128},
  [7282] = {.lex_state = 397, .external_lex_state = 25},
  [7283] = {.lex_state = 128},
  [7284] = {.lex_state = 128, .external_lex_state = 2},
  [7285] = {.lex_state = 299, .external_lex_state = 16},
  [7286] = {.lex_state = 128},
  [7287] = {.lex_state = 128, .external_lex_state = 2},
  [7288] = {.lex_state = 128},
  [7289] = {.lex_state = 128},
  [7290] = {.lex_state = 397, .external_lex_state = 25},
  [7291] = {.lex_state = 397, .external_lex_state = 25},
  [7292] = {.lex_state = 128},
  [7293] = {.lex_state = 128},
  [7294] = {.lex_state = 397, .external_lex_state = 25},
  [7295] = {.lex_state = 397, .external_lex_state = 25},
  [7296] = {.lex_state = 192, .external_lex_state = 2},
  [7297] = {.lex_state = 397, .external_lex_state = 25},
  [7298] = {.lex_state = 397, .external_lex_state = 25},
  [7299] = {.lex_state = 192, .external_lex_state = 29},
  [7300] = {.lex_state = 421, .external_lex_state = 25},
  [7301] = {.lex_state = 302, .external_lex_state = 16},
  [7302] = {.lex_state = 302, .external_lex_state = 16},
  [7303] = {.lex_state = 302, .external_lex_state = 16},
  [7304] = {.lex_state = 302, .external_lex_state = 16},
  [7305] = {.lex_state = 302, .external_lex_state = 16},
  [7306] = {.lex_state = 302, .external_lex_state = 16},
  [7307] = {.lex_state = 554, .external_lex_state = 16},
  [7308] = {.lex_state = 302, .external_lex_state = 16},
  [7309] = {.lex_state = 302, .external_lex_state = 16},
  [7310] = {.lex_state = 302, .external_lex_state = 16},
  [7311] = {.lex_state = 302, .external_lex_state = 16},
  [7312] = {.lex_state = 302, .external_lex_state = 16},
  [7313] = {.lex_state = 473, .external_lex_state = 16},
  [7314] = {.lex_state = 302, .external_lex_state = 16},
  [7315] = {.lex_state = 302, .external_lex_state = 16},
  [7316] = {.lex_state = 302, .external_lex_state = 16},
  [7317] = {.lex_state = 156, .external_lex_state = 20},
  [7318] = {.lex_state = 194, .external_lex_state = 6},
  [7319] = {.lex_state = 493, .external_lex_state = 25},
  [7320] = {.lex_state = 493, .external_lex_state = 25},
  [7321] = {.lex_state = 493, .external_lex_state = 25},
  [7322] = {.lex_state = 192, .external_lex_state = 2},
  [7323] = {.lex_state = 192, .external_lex_state = 2},
  [7324] = {.lex_state = 192, .external_lex_state = 2},
  [7325] = {.lex_state = 192, .external_lex_state = 2},
  [7326] = {.lex_state = 192, .external_lex_state = 2},
  [7327] = {.lex_state = 192, .external_lex_state = 2},
  [7328] = {.lex_state = 192, .external_lex_state = 2},
  [7329] = {.lex_state = 192, .external_lex_state = 2},
  [7330] = {.lex_state = 192, .external_lex_state = 2},
  [7331] = {.lex_state = 192, .external_lex_state = 2},
  [7332] = {.lex_state = 192, .external_lex_state = 2},
  [7333] = {.lex_state = 192, .external_lex_state = 2},
  [7334] = {.lex_state = 192, .external_lex_state = 29},
  [7335] = {.lex_state = 192, .external_lex_state = 2},
  [7336] = {.lex_state = 493, .external_lex_state = 25},
  [7337] = {.lex_state = 493, .external_lex_state = 25},
  [7338] = {.lex_state = 493, .external_lex_state = 25},
  [7339] = {.lex_state = 493, .external_lex_state = 25},
  [7340] = {.lex_state = 493, .external_lex_state = 25},
  [7341] = {.lex_state = 493, .external_lex_state = 25},
  [7342] = {.lex_state = 493, .external_lex_state = 25},
  [7343] = {.lex_state = 493, .external_lex_state = 25},
  [7344] = {.lex_state = 554, .external_lex_state = 16},
  [7345] = {.lex_state = 493, .external_lex_state = 25},
  [7346] = {.lex_state = 493, .external_lex_state = 25},
  [7347] = {.lex_state = 493, .external_lex_state = 25},
  [7348] = {.lex_state = 493, .external_lex_state = 25},
  [7349] = {.lex_state = 493, .external_lex_state = 25},
  [7350] = {.lex_state = 324, .external_lex_state = 25},
  [7351] = {.lex_state = 524, .external_lex_state = 21},
  [7352] = {.lex_state = 324, .external_lex_state = 25},
  [7353] = {.lex_state = 493, .external_lex_state = 25},
  [7354] = {.lex_state = 493, .external_lex_state = 25},
  [7355] = {.lex_state = 493, .external_lex_state = 25},
  [7356] = {.lex_state = 493, .external_lex_state = 25},
  [7357] = {.lex_state = 156, .external_lex_state = 3},
  [7358] = {.lex_state = 192, .external_lex_state = 2},
  [7359] = {.lex_state = 321, .external_lex_state = 25},
  [7360] = {.lex_state = 321, .external_lex_state = 25},
  [7361] = {.lex_state = 321, .external_lex_state = 25},
  [7362] = {.lex_state = 192, .external_lex_state = 2},
  [7363] = {.lex_state = 192, .external_lex_state = 2},
  [7364] = {.lex_state = 192, .external_lex_state = 2},
  [7365] = {.lex_state = 192, .external_lex_state = 2},
  [7366] = {.lex_state = 192, .external_lex_state = 2},
  [7367] = {.lex_state = 192, .external_lex_state = 2},
  [7368] = {.lex_state = 192, .external_lex_state = 2},
  [7369] = {.lex_state = 192, .external_lex_state = 2},
  [7370] = {.lex_state = 192, .external_lex_state = 2},
  [7371] = {.lex_state = 192, .external_lex_state = 2},
  [7372] = {.lex_state = 192, .external_lex_state = 2},
  [7373] = {.lex_state = 192, .external_lex_state = 2},
  [7374] = {.lex_state = 192, .external_lex_state = 29},
  [7375] = {.lex_state = 192, .external_lex_state = 2},
  [7376] = {.lex_state = 321, .external_lex_state = 27},
  [7377] = {.lex_state = 321, .external_lex_state = 25},
  [7378] = {.lex_state = 497, .external_lex_state = 25},
  [7379] = {.lex_state = 497, .external_lex_state = 25},
  [7380] = {.lex_state = 497, .external_lex_state = 25},
  [7381] = {.lex_state = 497, .external_lex_state = 25},
  [7382] = {.lex_state = 497, .external_lex_state = 25},
  [7383] = {.lex_state = 497, .external_lex_state = 25},
  [7384] = {.lex_state = 321, .external_lex_state = 25},
  [7385] = {.lex_state = 554, .external_lex_state = 16},
  [7386] = {.lex_state = 497, .external_lex_state = 25},
  [7387] = {.lex_state = 497, .external_lex_state = 25},
  [7388] = {.lex_state = 497, .external_lex_state = 25},
  [7389] = {.lex_state = 497, .external_lex_state = 25},
  [7390] = {.lex_state = 497, .external_lex_state = 25},
  [7391] = {.lex_state = 321, .external_lex_state = 25},
  [7392] = {.lex_state = 524, .external_lex_state = 21},
  [7393] = {.lex_state = 321, .external_lex_state = 25},
  [7394] = {.lex_state = 321, .external_lex_state = 25},
  [7395] = {.lex_state = 497, .external_lex_state = 25},
  [7396] = {.lex_state = 497, .external_lex_state = 25},
  [7397] = {.lex_state = 497, .external_lex_state = 25},
  [7398] = {.lex_state = 614, .external_lex_state = 27},
  [7399] = {.lex_state = 302, .external_lex_state = 16},
  [7400] = {.lex_state = 302, .external_lex_state = 16},
  [7401] = {.lex_state = 302, .external_lex_state = 16},
  [7402] = {.lex_state = 302, .external_lex_state = 16},
  [7403] = {.lex_state = 192, .external_lex_state = 2},
  [7404] = {.lex_state = 192, .external_lex_state = 2},
  [7405] = {.lex_state = 192, .external_lex_state = 2},
  [7406] = {.lex_state = 192, .external_lex_state = 2},
  [7407] = {.lex_state = 192, .external_lex_state = 2},
  [7408] = {.lex_state = 192, .external_lex_state = 2},
  [7409] = {.lex_state = 192, .external_lex_state = 2},
  [7410] = {.lex_state = 192, .external_lex_state = 2},
  [7411] = {.lex_state = 192, .external_lex_state = 2},
  [7412] = {.lex_state = 192, .external_lex_state = 2},
  [7413] = {.lex_state = 192, .external_lex_state = 2},
  [7414] = {.lex_state = 192, .external_lex_state = 2},
  [7415] = {.lex_state = 192, .external_lex_state = 29},
  [7416] = {.lex_state = 302, .external_lex_state = 16},
  [7417] = {.lex_state = 192, .external_lex_state = 29},
  [7418] = {.lex_state = 192, .external_lex_state = 2},
  [7419] = {.lex_state = 610, .external_lex_state = 20},
  [7420] = {.lex_state = 128, .external_lex_state = 2},
  [7421] = {.lex_state = 128, .external_lex_state = 12},
  [7422] = {.lex_state = 678, .external_lex_state = 8},
  [7423] = {.lex_state = 194},
  [7424] = {.lex_state = 286, .external_lex_state = 2},
  [7425] = {.lex_state = 678, .external_lex_state = 8},
  [7426] = {.lex_state = 128},
  [7427] = {.lex_state = 128, .external_lex_state = 12},
  [7428] = {.lex_state = 414, .external_lex_state = 2},
  [7429] = {.lex_state = 254, .external_lex_state = 8},
  [7430] = {.lex_state = 302},
  [7431] = {.lex_state = 197},
  [7432] = {.lex_state = 254, .external_lex_state = 8},
  [7433] = {.lex_state = 621, .external_lex_state = 25},
  [7434] = {.lex_state = 192, .external_lex_state = 2},
  [7435] = {.lex_state = 192, .external_lex_state = 2},
  [7436] = {.lex_state = 237},
  [7437] = {.lex_state = 192, .external_lex_state = 2},
  [7438] = {.lex_state = 520, .external_lex_state = 26},
  [7439] = {.lex_state = 604, .external_lex_state = 25},
  [7440] = {.lex_state = 621, .external_lex_state = 25},
  [7441] = {.lex_state = 621, .external_lex_state = 25},
  [7442] = {.lex_state = 604, .external_lex_state = 27},
  [7443] = {.lex_state = 621, .external_lex_state = 25},
  [7444] = {.lex_state = 621, .external_lex_state = 25},
  [7445] = {.lex_state = 192, .external_lex_state = 2},
  [7446] = {.lex_state = 192, .external_lex_state = 2},
  [7447] = {.lex_state = 192, .external_lex_state = 2},
  [7448] = {.lex_state = 192, .external_lex_state = 2},
  [7449] = {.lex_state = 192, .external_lex_state = 2},
  [7450] = {.lex_state = 192, .external_lex_state = 2},
  [7451] = {.lex_state = 192, .external_lex_state = 2},
  [7452] = {.lex_state = 192, .external_lex_state = 2},
  [7453] = {.lex_state = 192, .external_lex_state = 2},
  [7454] = {.lex_state = 192, .external_lex_state = 2},
  [7455] = {.lex_state = 192, .external_lex_state = 2},
  [7456] = {.lex_state = 192, .external_lex_state = 2},
  [7457] = {.lex_state = 192, .external_lex_state = 29},
  [7458] = {.lex_state = 192, .external_lex_state = 2},
  [7459] = {.lex_state = 621, .external_lex_state = 27},
  [7460] = {.lex_state = 621, .external_lex_state = 25},
  [7461] = {.lex_state = 604, .external_lex_state = 25},
  [7462] = {.lex_state = 604, .external_lex_state = 25},
  [7463] = {.lex_state = 192, .external_lex_state = 2},
  [7464] = {.lex_state = 604, .external_lex_state = 25},
  [7465] = {.lex_state = 192, .external_lex_state = 2},
  [7466] = {.lex_state = 604, .external_lex_state = 25},
  [7467] = {.lex_state = 524, .external_lex_state = 13},
  [7468] = {.lex_state = 604, .external_lex_state = 25},
  [7469] = {.lex_state = 604, .external_lex_state = 25},
  [7470] = {.lex_state = 604, .external_lex_state = 25},
  [7471] = {.lex_state = 604, .external_lex_state = 25},
  [7472] = {.lex_state = 604, .external_lex_state = 25},
  [7473] = {.lex_state = 604, .external_lex_state = 25},
  [7474] = {.lex_state = 604, .external_lex_state = 25},
  [7475] = {.lex_state = 621, .external_lex_state = 25},
  [7476] = {.lex_state = 554, .external_lex_state = 16},
  [7477] = {.lex_state = 604, .external_lex_state = 25},
  [7478] = {.lex_state = 604, .external_lex_state = 25},
  [7479] = {.lex_state = 604, .external_lex_state = 25},
  [7480] = {.lex_state = 604, .external_lex_state = 25},
  [7481] = {.lex_state = 604, .external_lex_state = 25},
  [7482] = {.lex_state = 337, .external_lex_state = 19},
  [7483] = {.lex_state = 524, .external_lex_state = 21},
  [7484] = {.lex_state = 337, .external_lex_state = 19},
  [7485] = {.lex_state = 337, .external_lex_state = 19},
  [7486] = {.lex_state = 604, .external_lex_state = 25},
  [7487] = {.lex_state = 604, .external_lex_state = 25},
  [7488] = {.lex_state = 604, .external_lex_state = 25},
  [7489] = {.lex_state = 674, .external_lex_state = 27},
  [7490] = {.lex_state = 493, .external_lex_state = 3},
  [7491] = {.lex_state = 493, .external_lex_state = 3},
  [7492] = {.lex_state = 493, .external_lex_state = 3},
  [7493] = {.lex_state = 493, .external_lex_state = 3},
  [7494] = {.lex_state = 493, .external_lex_state = 3},
  [7495] = {.lex_state = 493, .external_lex_state = 3},
  [7496] = {.lex_state = 493, .external_lex_state = 3},
  [7497] = {.lex_state = 493, .external_lex_state = 3},
  [7498] = {.lex_state = 554, .external_lex_state = 16},
  [7499] = {.lex_state = 493, .external_lex_state = 3},
  [7500] = {.lex_state = 493, .external_lex_state = 3},
  [7501] = {.lex_state = 493, .external_lex_state = 3},
  [7502] = {.lex_state = 493, .external_lex_state = 3},
  [7503] = {.lex_state = 493, .external_lex_state = 3},
  [7504] = {.lex_state = 493, .external_lex_state = 3},
  [7505] = {.lex_state = 493, .external_lex_state = 3},
  [7506] = {.lex_state = 493, .external_lex_state = 3},
  [7507] = {.lex_state = 610, .external_lex_state = 14},
  [7508] = {.lex_state = 493, .external_lex_state = 3},
  [7509] = {.lex_state = 493, .external_lex_state = 3},
  [7510] = {.lex_state = 493, .external_lex_state = 3},
  [7511] = {.lex_state = 524, .external_lex_state = 21},
  [7512] = {.lex_state = 493, .external_lex_state = 3},
  [7513] = {.lex_state = 493, .external_lex_state = 3},
  [7514] = {.lex_state = 192, .external_lex_state = 2},
  [7515] = {.lex_state = 497, .external_lex_state = 3},
  [7516] = {.lex_state = 497, .external_lex_state = 3},
  [7517] = {.lex_state = 497, .external_lex_state = 3},
  [7518] = {.lex_state = 524, .external_lex_state = 21},
  [7519] = {.lex_state = 497, .external_lex_state = 3},
  [7520] = {.lex_state = 497, .external_lex_state = 3},
  [7521] = {.lex_state = 192, .external_lex_state = 29},
  [7522] = {.lex_state = 493, .external_lex_state = 3},
  [7523] = {.lex_state = 302, .external_lex_state = 3},
  [7524] = {.lex_state = 321, .external_lex_state = 3},
  [7525] = {.lex_state = 321, .external_lex_state = 3},
  [7526] = {.lex_state = 321, .external_lex_state = 3},
  [7527] = {.lex_state = 321, .external_lex_state = 3},
  [7528] = {.lex_state = 321, .external_lex_state = 3},
  [7529] = {.lex_state = 321, .external_lex_state = 3},
  [7530] = {.lex_state = 554, .external_lex_state = 16},
  [7531] = {.lex_state = 321, .external_lex_state = 3},
  [7532] = {.lex_state = 321, .external_lex_state = 3},
  [7533] = {.lex_state = 321, .external_lex_state = 3},
  [7534] = {.lex_state = 321, .external_lex_state = 3},
  [7535] = {.lex_state = 321, .external_lex_state = 3},
  [7536] = {.lex_state = 321, .external_lex_state = 3},
  [7537] = {.lex_state = 321, .external_lex_state = 3},
  [7538] = {.lex_state = 321, .external_lex_state = 3},
  [7539] = {.lex_state = 321, .external_lex_state = 14},
  [7540] = {.lex_state = 192, .external_lex_state = 2},
  [7541] = {.lex_state = 192, .external_lex_state = 29},
  [7542] = {.lex_state = 497, .external_lex_state = 3},
  [7543] = {.lex_state = 302, .external_lex_state = 3},
  [7544] = {.lex_state = 302, .external_lex_state = 3},
  [7545] = {.lex_state = 302, .external_lex_state = 3},
  [7546] = {.lex_state = 302, .external_lex_state = 3},
  [7547] = {.lex_state = 302, .external_lex_state = 3},
  [7548] = {.lex_state = 302, .external_lex_state = 3},
  [7549] = {.lex_state = 554, .external_lex_state = 16},
  [7550] = {.lex_state = 302, .external_lex_state = 3},
  [7551] = {.lex_state = 302, .external_lex_state = 3},
  [7552] = {.lex_state = 302, .external_lex_state = 3},
  [7553] = {.lex_state = 302, .external_lex_state = 3},
  [7554] = {.lex_state = 302, .external_lex_state = 3},
  [7555] = {.lex_state = 302, .external_lex_state = 3},
  [7556] = {.lex_state = 302, .external_lex_state = 3},
  [7557] = {.lex_state = 302, .external_lex_state = 3},
  [7558] = {.lex_state = 330},
  [7559] = {.lex_state = 177, .external_lex_state = 4},
  [7560] = {.lex_state = 330},
  [7561] = {.lex_state = 330},
  [7562] = {.lex_state = 177, .external_lex_state = 4},
  [7563] = {.lex_state = 330},
  [7564] = {.lex_state = 225, .external_lex_state = 7},
  [7565] = {.lex_state = 330},
  [7566] = {.lex_state = 330},
  [7567] = {.lex_state = 361, .external_lex_state = 25},
  [7568] = {.lex_state = 361, .external_lex_state = 25},
  [7569] = {.lex_state = 192, .external_lex_state = 2},
  [7570] = {.lex_state = 361, .external_lex_state = 25},
  [7571] = {.lex_state = 192, .external_lex_state = 2},
  [7572] = {.lex_state = 361, .external_lex_state = 25},
  [7573] = {.lex_state = 524, .external_lex_state = 13},
  [7574] = {.lex_state = 361, .external_lex_state = 25},
  [7575] = {.lex_state = 361, .external_lex_state = 25},
  [7576] = {.lex_state = 361, .external_lex_state = 25},
  [7577] = {.lex_state = 361, .external_lex_state = 25},
  [7578] = {.lex_state = 361, .external_lex_state = 25},
  [7579] = {.lex_state = 361, .external_lex_state = 25},
  [7580] = {.lex_state = 361, .external_lex_state = 25},
  [7581] = {.lex_state = 554, .external_lex_state = 16},
  [7582] = {.lex_state = 361, .external_lex_state = 25},
  [7583] = {.lex_state = 361, .external_lex_state = 25},
  [7584] = {.lex_state = 361, .external_lex_state = 25},
  [7585] = {.lex_state = 361, .external_lex_state = 25},
  [7586] = {.lex_state = 361, .external_lex_state = 25},
  [7587] = {.lex_state = 192, .external_lex_state = 2},
  [7588] = {.lex_state = 618, .external_lex_state = 26},
  [7589] = {.lex_state = 618, .external_lex_state = 26},
  [7590] = {.lex_state = 618, .external_lex_state = 26},
  [7591] = {.lex_state = 618, .external_lex_state = 26},
  [7592] = {.lex_state = 192, .external_lex_state = 2},
  [7593] = {.lex_state = 192, .external_lex_state = 2},
  [7594] = {.lex_state = 192, .external_lex_state = 2},
  [7595] = {.lex_state = 424, .external_lex_state = 25},
  [7596] = {.lex_state = 213},
  [7597] = {.lex_state = 424, .external_lex_state = 25},
  [7598] = {.lex_state = 424, .external_lex_state = 27},
  [7599] = {.lex_state = 424, .external_lex_state = 25},
  [7600] = {.lex_state = 192, .external_lex_state = 2},
  [7601] = {.lex_state = 424, .external_lex_state = 25},
  [7602] = {.lex_state = 192, .external_lex_state = 2},
  [7603] = {.lex_state = 424, .external_lex_state = 25},
  [7604] = {.lex_state = 524, .external_lex_state = 13},
  [7605] = {.lex_state = 424, .external_lex_state = 25},
  [7606] = {.lex_state = 361, .external_lex_state = 25},
  [7607] = {.lex_state = 361, .external_lex_state = 25},
  [7608] = {.lex_state = 361, .external_lex_state = 25},
  [7609] = {.lex_state = 365, .external_lex_state = 27},
  [7610] = {.lex_state = 337, .external_lex_state = 19},
  [7611] = {.lex_state = 337, .external_lex_state = 19},
  [7612] = {.lex_state = 337, .external_lex_state = 19},
  [7613] = {.lex_state = 330},
  [7614] = {.lex_state = 128},
  [7615] = {.lex_state = 128},
  [7616] = {.lex_state = 330},
  [7617] = {.lex_state = 128},
  [7618] = {.lex_state = 330},
  [7619] = {.lex_state = 330},
  [7620] = {.lex_state = 330},
  [7621] = {.lex_state = 128},
  [7622] = {.lex_state = 330},
  [7623] = {.lex_state = 128},
  [7624] = {.lex_state = 330},
  [7625] = {.lex_state = 128},
  [7626] = {.lex_state = 337},
  [7627] = {.lex_state = 337},
  [7628] = {.lex_state = 128},
  [7629] = {.lex_state = 128, .external_lex_state = 2},
  [7630] = {.lex_state = 484, .external_lex_state = 21},
  [7631] = {.lex_state = 209},
  [7632] = {.lex_state = 337},
  [7633] = {.lex_state = 675, .external_lex_state = 27},
  [7634] = {.lex_state = 621, .external_lex_state = 25},
  [7635] = {.lex_state = 621, .external_lex_state = 25},
  [7636] = {.lex_state = 621, .external_lex_state = 25},
  [7637] = {.lex_state = 621, .external_lex_state = 25},
  [7638] = {.lex_state = 192, .external_lex_state = 15},
  [7639] = {.lex_state = 266, .external_lex_state = 15},
  [7640] = {.lex_state = 621, .external_lex_state = 25},
  [7641] = {.lex_state = 177, .external_lex_state = 4},
  [7642] = {.lex_state = 266, .external_lex_state = 15},
  [7643] = {.lex_state = 621, .external_lex_state = 25},
  [7644] = {.lex_state = 192, .external_lex_state = 15},
  [7645] = {.lex_state = 266, .external_lex_state = 15},
  [7646] = {.lex_state = 621, .external_lex_state = 25},
  [7647] = {.lex_state = 177, .external_lex_state = 4},
  [7648] = {.lex_state = 266, .external_lex_state = 15},
  [7649] = {.lex_state = 621, .external_lex_state = 25},
  [7650] = {.lex_state = 194},
  [7651] = {.lex_state = 302, .external_lex_state = 16},
  [7652] = {.lex_state = 225, .external_lex_state = 7},
  [7653] = {.lex_state = 128, .external_lex_state = 2},
  [7654] = {.lex_state = 621, .external_lex_state = 25},
  [7655] = {.lex_state = 247, .external_lex_state = 3},
  [7656] = {.lex_state = 128, .external_lex_state = 8},
  [7657] = {.lex_state = 128, .external_lex_state = 2},
  [7658] = {.lex_state = 621, .external_lex_state = 25},
  [7659] = {.lex_state = 128, .external_lex_state = 2},
  [7660] = {.lex_state = 627, .external_lex_state = 25},
  [7661] = {.lex_state = 627, .external_lex_state = 25},
  [7662] = {.lex_state = 192, .external_lex_state = 2},
  [7663] = {.lex_state = 627, .external_lex_state = 25},
  [7664] = {.lex_state = 621, .external_lex_state = 25},
  [7665] = {.lex_state = 209, .external_lex_state = 19},
  [7666] = {.lex_state = 209},
  [7667] = {.lex_state = 192, .external_lex_state = 2},
  [7668] = {.lex_state = 177, .external_lex_state = 17},
  [7669] = {.lex_state = 627, .external_lex_state = 25},
  [7670] = {.lex_state = 524, .external_lex_state = 13},
  [7671] = {.lex_state = 627, .external_lex_state = 25},
  [7672] = {.lex_state = 128, .external_lex_state = 12},
  [7673] = {.lex_state = 128, .external_lex_state = 2},
  [7674] = {.lex_state = 128, .external_lex_state = 2},
  [7675] = {.lex_state = 128, .external_lex_state = 2},
  [7676] = {.lex_state = 128, .external_lex_state = 8},
  [7677] = {.lex_state = 128},
  [7678] = {.lex_state = 128},
  [7679] = {.lex_state = 128},
  [7680] = {.lex_state = 621, .external_lex_state = 25},
  [7681] = {.lex_state = 128},
  [7682] = {.lex_state = 128},
  [7683] = {.lex_state = 128},
  [7684] = {.lex_state = 621, .external_lex_state = 25},
  [7685] = {.lex_state = 621, .external_lex_state = 25},
  [7686] = {.lex_state = 235},
  [7687] = {.lex_state = 621, .external_lex_state = 25},
  [7688] = {.lex_state = 194},
  [7689] = {.lex_state = 286, .external_lex_state = 2},
  [7690] = {.lex_state = 621, .external_lex_state = 25},
  [7691] = {.lex_state = 128},
  [7692] = {.lex_state = 128, .external_lex_state = 12},
  [7693] = {.lex_state = 414, .external_lex_state = 2},
  [7694] = {.lex_state = 621, .external_lex_state = 25},
  [7695] = {.lex_state = 627, .external_lex_state = 25},
  [7696] = {.lex_state = 627, .external_lex_state = 25},
  [7697] = {.lex_state = 627, .external_lex_state = 25},
  [7698] = {.lex_state = 627, .external_lex_state = 25},
  [7699] = {.lex_state = 627, .external_lex_state = 25},
  [7700] = {.lex_state = 627, .external_lex_state = 25},
  [7701] = {.lex_state = 554, .external_lex_state = 16},
  [7702] = {.lex_state = 627, .external_lex_state = 25},
  [7703] = {.lex_state = 627, .external_lex_state = 25},
  [7704] = {.lex_state = 627, .external_lex_state = 25},
  [7705] = {.lex_state = 627, .external_lex_state = 25},
  [7706] = {.lex_state = 627, .external_lex_state = 25},
  [7707] = {.lex_state = 397, .external_lex_state = 25},
  [7708] = {.lex_state = 627, .external_lex_state = 25},
  [7709] = {.lex_state = 621, .external_lex_state = 25},
  [7710] = {.lex_state = 627, .external_lex_state = 25},
  [7711] = {.lex_state = 627, .external_lex_state = 25},
  [7712] = {.lex_state = 627, .external_lex_state = 27},
  [7713] = {.lex_state = 505, .external_lex_state = 25},
  [7714] = {.lex_state = 505, .external_lex_state = 25},
  [7715] = {.lex_state = 505, .external_lex_state = 25},
  [7716] = {.lex_state = 524, .external_lex_state = 21},
  [7717] = {.lex_state = 505, .external_lex_state = 25},
  [7718] = {.lex_state = 505, .external_lex_state = 25},
  [7719] = {.lex_state = 192, .external_lex_state = 2},
  [7720] = {.lex_state = 192, .external_lex_state = 29},
  [7721] = {.lex_state = 505, .external_lex_state = 25},
  [7722] = {.lex_state = 508, .external_lex_state = 25},
  [7723] = {.lex_state = 508, .external_lex_state = 25},
  [7724] = {.lex_state = 192, .external_lex_state = 2},
  [7725] = {.lex_state = 508, .external_lex_state = 25},
  [7726] = {.lex_state = 192, .external_lex_state = 2},
  [7727] = {.lex_state = 508, .external_lex_state = 25},
  [7728] = {.lex_state = 524, .external_lex_state = 13},
  [7729] = {.lex_state = 508, .external_lex_state = 25},
  [7730] = {.lex_state = 508, .external_lex_state = 25},
  [7731] = {.lex_state = 508, .external_lex_state = 25},
  [7732] = {.lex_state = 508, .external_lex_state = 25},
  [7733] = {.lex_state = 508, .external_lex_state = 25},
  [7734] = {.lex_state = 508, .external_lex_state = 25},
  [7735] = {.lex_state = 508, .external_lex_state = 25},
  [7736] = {.lex_state = 554, .external_lex_state = 16},
  [7737] = {.lex_state = 508, .external_lex_state = 25},
  [7738] = {.lex_state = 508, .external_lex_state = 25},
  [7739] = {.lex_state = 508, .external_lex_state = 25},
  [7740] = {.lex_state = 508, .external_lex_state = 25},
  [7741] = {.lex_state = 508, .external_lex_state = 25},
  [7742] = {.lex_state = 508, .external_lex_state = 25},
  [7743] = {.lex_state = 508, .external_lex_state = 25},
  [7744] = {.lex_state = 508, .external_lex_state = 25},
  [7745] = {.lex_state = 631, .external_lex_state = 27},
  [7746] = {.lex_state = 508, .external_lex_state = 25},
  [7747] = {.lex_state = 508, .external_lex_state = 25},
  [7748] = {.lex_state = 508, .external_lex_state = 25},
  [7749] = {.lex_state = 524, .external_lex_state = 21},
  [7750] = {.lex_state = 508, .external_lex_state = 25},
  [7751] = {.lex_state = 508, .external_lex_state = 25},
  [7752] = {.lex_state = 192, .external_lex_state = 2},
  [7753] = {.lex_state = 192, .external_lex_state = 29},
  [7754] = {.lex_state = 508, .external_lex_state = 25},
  [7755] = {.lex_state = 365, .external_lex_state = 3},
  [7756] = {.lex_state = 365, .external_lex_state = 3},
  [7757] = {.lex_state = 192, .external_lex_state = 2},
  [7758] = {.lex_state = 192, .external_lex_state = 29},
  [7759] = {.lex_state = 365, .external_lex_state = 3},
  [7760] = {.lex_state = 493, .external_lex_state = 25},
  [7761] = {.lex_state = 493, .external_lex_state = 25},
  [7762] = {.lex_state = 302, .external_lex_state = 25},
  [7763] = {.lex_state = 302, .external_lex_state = 25},
  [7764] = {.lex_state = 302, .external_lex_state = 25},
  [7765] = {.lex_state = 302, .external_lex_state = 25},
  [7766] = {.lex_state = 302, .external_lex_state = 25},
  [7767] = {.lex_state = 302, .external_lex_state = 25},
  [7768] = {.lex_state = 554, .external_lex_state = 16},
  [7769] = {.lex_state = 302, .external_lex_state = 25},
  [7770] = {.lex_state = 302, .external_lex_state = 25},
  [7771] = {.lex_state = 302, .external_lex_state = 25},
  [7772] = {.lex_state = 302, .external_lex_state = 25},
  [7773] = {.lex_state = 302, .external_lex_state = 25},
  [7774] = {.lex_state = 192, .external_lex_state = 2},
  [7775] = {.lex_state = 302, .external_lex_state = 25},
  [7776] = {.lex_state = 302, .external_lex_state = 25},
  [7777] = {.lex_state = 302, .external_lex_state = 25},
  [7778] = {.lex_state = 610, .external_lex_state = 27},
  [7779] = {.lex_state = 493, .external_lex_state = 25},
  [7780] = {.lex_state = 493, .external_lex_state = 25},
  [7781] = {.lex_state = 493, .external_lex_state = 25},
  [7782] = {.lex_state = 524, .external_lex_state = 21},
  [7783] = {.lex_state = 493, .external_lex_state = 25},
  [7784] = {.lex_state = 493, .external_lex_state = 25},
  [7785] = {.lex_state = 192, .external_lex_state = 2},
  [7786] = {.lex_state = 497, .external_lex_state = 25},
  [7787] = {.lex_state = 497, .external_lex_state = 25},
  [7788] = {.lex_state = 497, .external_lex_state = 25},
  [7789] = {.lex_state = 524, .external_lex_state = 21},
  [7790] = {.lex_state = 497, .external_lex_state = 25},
  [7791] = {.lex_state = 497, .external_lex_state = 25},
  [7792] = {.lex_state = 302, .external_lex_state = 25},
  [7793] = {.lex_state = 192, .external_lex_state = 29},
  [7794] = {.lex_state = 302, .external_lex_state = 25},
  [7795] = {.lex_state = 361, .external_lex_state = 3},
  [7796] = {.lex_state = 514, .external_lex_state = 11},
  [7797] = {.lex_state = 209},
  [7798] = {.lex_state = 299, .external_lex_state = 3},
  [7799] = {.lex_state = 299, .external_lex_state = 3},
  [7800] = {.lex_state = 299, .external_lex_state = 3},
  [7801] = {.lex_state = 128},
  [7802] = {.lex_state = 128, .external_lex_state = 2},
  [7803] = {.lex_state = 299, .external_lex_state = 3},
  [7804] = {.lex_state = 299, .external_lex_state = 3},
  [7805] = {.lex_state = 299, .external_lex_state = 3},
  [7806] = {.lex_state = 524, .external_lex_state = 21},
  [7807] = {.lex_state = 156, .external_lex_state = 3},
  [7808] = {.lex_state = 361, .external_lex_state = 3},
  [7809] = {.lex_state = 361, .external_lex_state = 3},
  [7810] = {.lex_state = 361, .external_lex_state = 3},
  [7811] = {.lex_state = 361, .external_lex_state = 3},
  [7812] = {.lex_state = 361, .external_lex_state = 3},
  [7813] = {.lex_state = 361, .external_lex_state = 3},
  [7814] = {.lex_state = 361, .external_lex_state = 3},
  [7815] = {.lex_state = 361, .external_lex_state = 3},
  [7816] = {.lex_state = 361, .external_lex_state = 3},
  [7817] = {.lex_state = 554, .external_lex_state = 16},
  [7818] = {.lex_state = 361, .external_lex_state = 3},
  [7819] = {.lex_state = 361, .external_lex_state = 3},
  [7820] = {.lex_state = 361, .external_lex_state = 3},
  [7821] = {.lex_state = 361, .external_lex_state = 3},
  [7822] = {.lex_state = 361, .external_lex_state = 3},
  [7823] = {.lex_state = 361, .external_lex_state = 3},
  [7824] = {.lex_state = 361, .external_lex_state = 3},
  [7825] = {.lex_state = 361, .external_lex_state = 3},
  [7826] = {.lex_state = 365, .external_lex_state = 14},
  [7827] = {.lex_state = 361, .external_lex_state = 3},
  [7828] = {.lex_state = 361, .external_lex_state = 3},
  [7829] = {.lex_state = 361, .external_lex_state = 3},
  [7830] = {.lex_state = 524, .external_lex_state = 21},
  [7831] = {.lex_state = 361, .external_lex_state = 3},
  [7832] = {.lex_state = 361, .external_lex_state = 3},
  [7833] = {.lex_state = 192, .external_lex_state = 2},
  [7834] = {.lex_state = 421, .external_lex_state = 3},
  [7835] = {.lex_state = 421, .external_lex_state = 3},
  [7836] = {.lex_state = 421, .external_lex_state = 3},
  [7837] = {.lex_state = 524, .external_lex_state = 21},
  [7838] = {.lex_state = 421, .external_lex_state = 3},
  [7839] = {.lex_state = 421, .external_lex_state = 3},
  [7840] = {.lex_state = 192, .external_lex_state = 29},
  [7841] = {.lex_state = 361, .external_lex_state = 3},
  [7842] = {.lex_state = 192, .external_lex_state = 2},
  [7843] = {.lex_state = 511, .external_lex_state = 11},
  [7844] = {.lex_state = 511, .external_lex_state = 11},
  [7845] = {.lex_state = 511, .external_lex_state = 11},
  [7846] = {.lex_state = 511, .external_lex_state = 11},
  [7847] = {.lex_state = 192, .external_lex_state = 2},
  [7848] = {.lex_state = 192, .external_lex_state = 2},
  [7849] = {.lex_state = 192, .external_lex_state = 2},
  [7850] = {.lex_state = 361, .external_lex_state = 3},
  [7851] = {.lex_state = 213},
  [7852] = {.lex_state = 259, .external_lex_state = 3},
  [7853] = {.lex_state = 365, .external_lex_state = 14},
  [7854] = {.lex_state = 361, .external_lex_state = 3},
  [7855] = {.lex_state = 361, .external_lex_state = 3},
  [7856] = {.lex_state = 361, .external_lex_state = 14},
  [7857] = {.lex_state = 192, .external_lex_state = 2},
  [7858] = {.lex_state = 361, .external_lex_state = 3},
  [7859] = {.lex_state = 192, .external_lex_state = 2},
  [7860] = {.lex_state = 192, .external_lex_state = 2},
  [7861] = {.lex_state = 237},
  [7862] = {.lex_state = 192, .external_lex_state = 2},
  [7863] = {.lex_state = 358, .external_lex_state = 11},
  [7864] = {.lex_state = 361, .external_lex_state = 3},
  [7865] = {.lex_state = 361, .external_lex_state = 3},
  [7866] = {.lex_state = 361, .external_lex_state = 3},
  [7867] = {.lex_state = 371, .external_lex_state = 14},
  [7868] = {.lex_state = 361, .external_lex_state = 3},
  [7869] = {.lex_state = 361, .external_lex_state = 3},
  [7870] = {.lex_state = 192, .external_lex_state = 2},
  [7871] = {.lex_state = 192, .external_lex_state = 2},
  [7872] = {.lex_state = 192, .external_lex_state = 2},
  [7873] = {.lex_state = 192, .external_lex_state = 2},
  [7874] = {.lex_state = 192, .external_lex_state = 2},
  [7875] = {.lex_state = 192, .external_lex_state = 2},
  [7876] = {.lex_state = 192, .external_lex_state = 2},
  [7877] = {.lex_state = 192, .external_lex_state = 2},
  [7878] = {.lex_state = 192, .external_lex_state = 2},
  [7879] = {.lex_state = 192, .external_lex_state = 2},
  [7880] = {.lex_state = 192, .external_lex_state = 2},
  [7881] = {.lex_state = 192, .external_lex_state = 2},
  [7882] = {.lex_state = 192, .external_lex_state = 2},
  [7883] = {.lex_state = 192, .external_lex_state = 2},
  [7884] = {.lex_state = 192, .external_lex_state = 2},
  [7885] = {.lex_state = 237},
  [7886] = {.lex_state = 192, .external_lex_state = 2},
  [7887] = {.lex_state = 358, .external_lex_state = 11},
  [7888] = {.lex_state = 421, .external_lex_state = 3},
  [7889] = {.lex_state = 421, .external_lex_state = 3},
  [7890] = {.lex_state = 421, .external_lex_state = 3},
  [7891] = {.lex_state = 427, .external_lex_state = 14},
  [7892] = {.lex_state = 262, .external_lex_state = 3},
  [7893] = {.lex_state = 524, .external_lex_state = 13},
  [7894] = {.lex_state = 361, .external_lex_state = 3},
  [7895] = {.lex_state = 192, .external_lex_state = 29},
  [7896] = {.lex_state = 192, .external_lex_state = 2},
  [7897] = {.lex_state = 361, .external_lex_state = 14},
  [7898] = {.lex_state = 128, .external_lex_state = 2},
  [7899] = {.lex_state = 254, .external_lex_state = 8},
  [7900] = {.lex_state = 156, .external_lex_state = 3},
  [7901] = {.lex_state = 128, .external_lex_state = 2},
  [7902] = {.lex_state = 128, .external_lex_state = 8},
  [7903] = {.lex_state = 247, .external_lex_state = 3},
  [7904] = {.lex_state = 247, .external_lex_state = 3},
  [7905] = {.lex_state = 247, .external_lex_state = 3},
  [7906] = {.lex_state = 247, .external_lex_state = 3},
  [7907] = {.lex_state = 247, .external_lex_state = 3},
  [7908] = {.lex_state = 247, .external_lex_state = 3},
  [7909] = {.lex_state = 247, .external_lex_state = 3},
  [7910] = {.lex_state = 247, .external_lex_state = 3},
  [7911] = {.lex_state = 247, .external_lex_state = 3},
  [7912] = {.lex_state = 247, .external_lex_state = 3},
  [7913] = {.lex_state = 247, .external_lex_state = 3},
  [7914] = {.lex_state = 554, .external_lex_state = 16},
  [7915] = {.lex_state = 247, .external_lex_state = 3},
  [7916] = {.lex_state = 247, .external_lex_state = 3},
  [7917] = {.lex_state = 247, .external_lex_state = 3},
  [7918] = {.lex_state = 247, .external_lex_state = 3},
  [7919] = {.lex_state = 247, .external_lex_state = 3},
  [7920] = {.lex_state = 192, .external_lex_state = 2},
  [7921] = {.lex_state = 254, .external_lex_state = 11},
  [7922] = {.lex_state = 254, .external_lex_state = 11},
  [7923] = {.lex_state = 254, .external_lex_state = 11},
  [7924] = {.lex_state = 254, .external_lex_state = 11},
  [7925] = {.lex_state = 192, .external_lex_state = 2},
  [7926] = {.lex_state = 192, .external_lex_state = 2},
  [7927] = {.lex_state = 192, .external_lex_state = 2},
  [7928] = {.lex_state = 424, .external_lex_state = 3},
  [7929] = {.lex_state = 254, .external_lex_state = 11},
  [7930] = {.lex_state = 213},
  [7931] = {.lex_state = 424, .external_lex_state = 3},
  [7932] = {.lex_state = 424, .external_lex_state = 14},
  [7933] = {.lex_state = 424, .external_lex_state = 3},
  [7934] = {.lex_state = 421, .external_lex_state = 3},
  [7935] = {.lex_state = 421, .external_lex_state = 14},
  [7936] = {.lex_state = 192, .external_lex_state = 2},
  [7937] = {.lex_state = 424, .external_lex_state = 3},
  [7938] = {.lex_state = 421, .external_lex_state = 3},
  [7939] = {.lex_state = 421, .external_lex_state = 3},
  [7940] = {.lex_state = 192, .external_lex_state = 2},
  [7941] = {.lex_state = 192, .external_lex_state = 2},
  [7942] = {.lex_state = 192, .external_lex_state = 2},
  [7943] = {.lex_state = 192, .external_lex_state = 2},
  [7944] = {.lex_state = 192, .external_lex_state = 2},
  [7945] = {.lex_state = 192, .external_lex_state = 2},
  [7946] = {.lex_state = 192, .external_lex_state = 2},
  [7947] = {.lex_state = 192, .external_lex_state = 2},
  [7948] = {.lex_state = 192, .external_lex_state = 2},
  [7949] = {.lex_state = 192, .external_lex_state = 2},
  [7950] = {.lex_state = 192, .external_lex_state = 2},
  [7951] = {.lex_state = 192, .external_lex_state = 2},
  [7952] = {.lex_state = 192, .external_lex_state = 2},
  [7953] = {.lex_state = 424, .external_lex_state = 3},
  [7954] = {.lex_state = 524, .external_lex_state = 13},
  [7955] = {.lex_state = 424, .external_lex_state = 3},
  [7956] = {.lex_state = 192, .external_lex_state = 29},
  [7957] = {.lex_state = 192, .external_lex_state = 2},
  [7958] = {.lex_state = 421, .external_lex_state = 14},
  [7959] = {.lex_state = 192, .external_lex_state = 2},
  [7960] = {.lex_state = 192, .external_lex_state = 2},
  [7961] = {.lex_state = 192, .external_lex_state = 2},
  [7962] = {.lex_state = 192, .external_lex_state = 2},
  [7963] = {.lex_state = 192, .external_lex_state = 2},
  [7964] = {.lex_state = 528, .external_lex_state = 3},
  [7965] = {.lex_state = 528, .external_lex_state = 3},
  [7966] = {.lex_state = 213},
  [7967] = {.lex_state = 259, .external_lex_state = 3},
  [7968] = {.lex_state = 247, .external_lex_state = 3},
  [7969] = {.lex_state = 262, .external_lex_state = 14},
  [7970] = {.lex_state = 128},
  [7971] = {.lex_state = 247, .external_lex_state = 3},
  [7972] = {.lex_state = 424, .external_lex_state = 3},
  [7973] = {.lex_state = 424, .external_lex_state = 3},
  [7974] = {.lex_state = 424, .external_lex_state = 3},
  [7975] = {.lex_state = 424, .external_lex_state = 3},
  [7976] = {.lex_state = 424, .external_lex_state = 3},
  [7977] = {.lex_state = 424, .external_lex_state = 3},
  [7978] = {.lex_state = 554, .external_lex_state = 16},
  [7979] = {.lex_state = 424, .external_lex_state = 3},
  [7980] = {.lex_state = 424, .external_lex_state = 3},
  [7981] = {.lex_state = 424, .external_lex_state = 3},
  [7982] = {.lex_state = 424, .external_lex_state = 3},
  [7983] = {.lex_state = 424, .external_lex_state = 3},
  [7984] = {.lex_state = 424, .external_lex_state = 3},
  [7985] = {.lex_state = 424, .external_lex_state = 3},
  [7986] = {.lex_state = 424, .external_lex_state = 3},
  [7987] = {.lex_state = 424, .external_lex_state = 14},
  [7988] = {.lex_state = 192, .external_lex_state = 2},
  [7989] = {.lex_state = 192, .external_lex_state = 29},
  [7990] = {.lex_state = 421, .external_lex_state = 3},
  [7991] = {.lex_state = 528, .external_lex_state = 3},
  [7992] = {.lex_state = 528, .external_lex_state = 3},
  [7993] = {.lex_state = 528, .external_lex_state = 3},
  [7994] = {.lex_state = 528, .external_lex_state = 3},
  [7995] = {.lex_state = 528, .external_lex_state = 3},
  [7996] = {.lex_state = 528, .external_lex_state = 3},
  [7997] = {.lex_state = 554, .external_lex_state = 16},
  [7998] = {.lex_state = 528, .external_lex_state = 3},
  [7999] = {.lex_state = 528, .external_lex_state = 3},
  [8000] = {.lex_state = 528, .external_lex_state = 3},
  [8001] = {.lex_state = 528, .external_lex_state = 3},
  [8002] = {.lex_state = 528, .external_lex_state = 3},
  [8003] = {.lex_state = 528, .external_lex_state = 3},
  [8004] = {.lex_state = 528, .external_lex_state = 3},
  [8005] = {.lex_state = 528, .external_lex_state = 3},
  [8006] = {.lex_state = 192, .external_lex_state = 2},
  [8007] = {.lex_state = 511, .external_lex_state = 11},
  [8008] = {.lex_state = 511, .external_lex_state = 11},
  [8009] = {.lex_state = 511, .external_lex_state = 11},
  [8010] = {.lex_state = 511, .external_lex_state = 11},
  [8011] = {.lex_state = 192, .external_lex_state = 2},
  [8012] = {.lex_state = 192, .external_lex_state = 2},
  [8013] = {.lex_state = 192, .external_lex_state = 2},
  [8014] = {.lex_state = 361, .external_lex_state = 3},
  [8015] = {.lex_state = 213},
  [8016] = {.lex_state = 259, .external_lex_state = 3},
  [8017] = {.lex_state = 365, .external_lex_state = 14},
  [8018] = {.lex_state = 361, .external_lex_state = 3},
  [8019] = {.lex_state = 361, .external_lex_state = 3},
  [8020] = {.lex_state = 361, .external_lex_state = 14},
  [8021] = {.lex_state = 192, .external_lex_state = 2},
  [8022] = {.lex_state = 361, .external_lex_state = 3},
  [8023] = {.lex_state = 192, .external_lex_state = 2},
  [8024] = {.lex_state = 192, .external_lex_state = 2},
  [8025] = {.lex_state = 237},
  [8026] = {.lex_state = 192, .external_lex_state = 2},
  [8027] = {.lex_state = 358, .external_lex_state = 11},
  [8028] = {.lex_state = 361, .external_lex_state = 3},
  [8029] = {.lex_state = 361, .external_lex_state = 3},
  [8030] = {.lex_state = 361, .external_lex_state = 3},
  [8031] = {.lex_state = 371, .external_lex_state = 14},
  [8032] = {.lex_state = 361, .external_lex_state = 3},
  [8033] = {.lex_state = 361, .external_lex_state = 3},
  [8034] = {.lex_state = 192, .external_lex_state = 2},
  [8035] = {.lex_state = 192, .external_lex_state = 2},
  [8036] = {.lex_state = 192, .external_lex_state = 2},
  [8037] = {.lex_state = 192, .external_lex_state = 2},
  [8038] = {.lex_state = 192, .external_lex_state = 2},
  [8039] = {.lex_state = 192, .external_lex_state = 2},
  [8040] = {.lex_state = 192, .external_lex_state = 2},
  [8041] = {.lex_state = 192, .external_lex_state = 2},
  [8042] = {.lex_state = 192, .external_lex_state = 2},
  [8043] = {.lex_state = 192, .external_lex_state = 2},
  [8044] = {.lex_state = 192, .external_lex_state = 2},
  [8045] = {.lex_state = 192, .external_lex_state = 2},
  [8046] = {.lex_state = 192, .external_lex_state = 2},
  [8047] = {.lex_state = 192, .external_lex_state = 2},
  [8048] = {.lex_state = 192, .external_lex_state = 2},
  [8049] = {.lex_state = 237},
  [8050] = {.lex_state = 192, .external_lex_state = 2},
  [8051] = {.lex_state = 358, .external_lex_state = 11},
  [8052] = {.lex_state = 421, .external_lex_state = 3},
  [8053] = {.lex_state = 421, .external_lex_state = 3},
  [8054] = {.lex_state = 421, .external_lex_state = 3},
  [8055] = {.lex_state = 427, .external_lex_state = 14},
  [8056] = {.lex_state = 262, .external_lex_state = 3},
  [8057] = {.lex_state = 524, .external_lex_state = 13},
  [8058] = {.lex_state = 361, .external_lex_state = 3},
  [8059] = {.lex_state = 192, .external_lex_state = 29},
  [8060] = {.lex_state = 192, .external_lex_state = 2},
  [8061] = {.lex_state = 361, .external_lex_state = 14},
  [8062] = {.lex_state = 254, .external_lex_state = 8},
  [8063] = {.lex_state = 156, .external_lex_state = 3},
  [8064] = {.lex_state = 128, .external_lex_state = 2},
  [8065] = {.lex_state = 128, .external_lex_state = 8},
  [8066] = {.lex_state = 247, .external_lex_state = 3},
  [8067] = {.lex_state = 247, .external_lex_state = 3},
  [8068] = {.lex_state = 247, .external_lex_state = 3},
  [8069] = {.lex_state = 247, .external_lex_state = 3},
  [8070] = {.lex_state = 247, .external_lex_state = 3},
  [8071] = {.lex_state = 247, .external_lex_state = 3},
  [8072] = {.lex_state = 247, .external_lex_state = 3},
  [8073] = {.lex_state = 247, .external_lex_state = 3},
  [8074] = {.lex_state = 247, .external_lex_state = 3},
  [8075] = {.lex_state = 247, .external_lex_state = 3},
  [8076] = {.lex_state = 247, .external_lex_state = 3},
  [8077] = {.lex_state = 554, .external_lex_state = 16},
  [8078] = {.lex_state = 247, .external_lex_state = 3},
  [8079] = {.lex_state = 247, .external_lex_state = 3},
  [8080] = {.lex_state = 247, .external_lex_state = 3},
  [8081] = {.lex_state = 247, .external_lex_state = 3},
  [8082] = {.lex_state = 247, .external_lex_state = 3},
  [8083] = {.lex_state = 192, .external_lex_state = 2},
  [8084] = {.lex_state = 254, .external_lex_state = 11},
  [8085] = {.lex_state = 254, .external_lex_state = 11},
  [8086] = {.lex_state = 254, .external_lex_state = 11},
  [8087] = {.lex_state = 254, .external_lex_state = 11},
  [8088] = {.lex_state = 192, .external_lex_state = 2},
  [8089] = {.lex_state = 192, .external_lex_state = 2},
  [8090] = {.lex_state = 192, .external_lex_state = 2},
  [8091] = {.lex_state = 424, .external_lex_state = 3},
  [8092] = {.lex_state = 254, .external_lex_state = 11},
  [8093] = {.lex_state = 213},
  [8094] = {.lex_state = 424, .external_lex_state = 3},
  [8095] = {.lex_state = 424, .external_lex_state = 14},
  [8096] = {.lex_state = 424, .external_lex_state = 3},
  [8097] = {.lex_state = 421, .external_lex_state = 3},
  [8098] = {.lex_state = 421, .external_lex_state = 14},
  [8099] = {.lex_state = 192, .external_lex_state = 2},
  [8100] = {.lex_state = 424, .external_lex_state = 3},
  [8101] = {.lex_state = 421, .external_lex_state = 3},
  [8102] = {.lex_state = 421, .external_lex_state = 3},
  [8103] = {.lex_state = 192, .external_lex_state = 2},
  [8104] = {.lex_state = 192, .external_lex_state = 2},
  [8105] = {.lex_state = 192, .external_lex_state = 2},
  [8106] = {.lex_state = 192, .external_lex_state = 2},
  [8107] = {.lex_state = 192, .external_lex_state = 2},
  [8108] = {.lex_state = 192, .external_lex_state = 2},
  [8109] = {.lex_state = 192, .external_lex_state = 2},
  [8110] = {.lex_state = 192, .external_lex_state = 2},
  [8111] = {.lex_state = 192, .external_lex_state = 2},
  [8112] = {.lex_state = 192, .external_lex_state = 2},
  [8113] = {.lex_state = 192, .external_lex_state = 2},
  [8114] = {.lex_state = 192, .external_lex_state = 2},
  [8115] = {.lex_state = 192, .external_lex_state = 2},
  [8116] = {.lex_state = 424, .external_lex_state = 3},
  [8117] = {.lex_state = 524, .external_lex_state = 13},
  [8118] = {.lex_state = 424, .external_lex_state = 3},
  [8119] = {.lex_state = 192, .external_lex_state = 29},
  [8120] = {.lex_state = 192, .external_lex_state = 2},
  [8121] = {.lex_state = 421, .external_lex_state = 14},
  [8122] = {.lex_state = 192, .external_lex_state = 2},
  [8123] = {.lex_state = 192, .external_lex_state = 2},
  [8124] = {.lex_state = 192, .external_lex_state = 2},
  [8125] = {.lex_state = 192, .external_lex_state = 2},
  [8126] = {.lex_state = 192, .external_lex_state = 2},
  [8127] = {.lex_state = 528, .external_lex_state = 3},
  [8128] = {.lex_state = 528, .external_lex_state = 3},
  [8129] = {.lex_state = 213},
  [8130] = {.lex_state = 259, .external_lex_state = 3},
  [8131] = {.lex_state = 247, .external_lex_state = 3},
  [8132] = {.lex_state = 262, .external_lex_state = 14},
  [8133] = {.lex_state = 361, .external_lex_state = 3},
  [8134] = {.lex_state = 361, .external_lex_state = 3},
  [8135] = {.lex_state = 361, .external_lex_state = 3},
  [8136] = {.lex_state = 361, .external_lex_state = 3},
  [8137] = {.lex_state = 361, .external_lex_state = 3},
  [8138] = {.lex_state = 361, .external_lex_state = 3},
  [8139] = {.lex_state = 361, .external_lex_state = 3},
  [8140] = {.lex_state = 361, .external_lex_state = 3},
  [8141] = {.lex_state = 554, .external_lex_state = 16},
  [8142] = {.lex_state = 361, .external_lex_state = 3},
  [8143] = {.lex_state = 361, .external_lex_state = 3},
  [8144] = {.lex_state = 361, .external_lex_state = 3},
  [8145] = {.lex_state = 361, .external_lex_state = 3},
  [8146] = {.lex_state = 361, .external_lex_state = 3},
  [8147] = {.lex_state = 361, .external_lex_state = 3},
  [8148] = {.lex_state = 361, .external_lex_state = 3},
  [8149] = {.lex_state = 361, .external_lex_state = 3},
  [8150] = {.lex_state = 365, .external_lex_state = 14},
  [8151] = {.lex_state = 361, .external_lex_state = 3},
  [8152] = {.lex_state = 361, .external_lex_state = 3},
  [8153] = {.lex_state = 361, .external_lex_state = 3},
  [8154] = {.lex_state = 524, .external_lex_state = 21},
  [8155] = {.lex_state = 361, .external_lex_state = 3},
  [8156] = {.lex_state = 361, .external_lex_state = 3},
  [8157] = {.lex_state = 192, .external_lex_state = 2},
  [8158] = {.lex_state = 421, .external_lex_state = 3},
  [8159] = {.lex_state = 421, .external_lex_state = 3},
  [8160] = {.lex_state = 421, .external_lex_state = 3},
  [8161] = {.lex_state = 524, .external_lex_state = 21},
  [8162] = {.lex_state = 421, .external_lex_state = 3},
  [8163] = {.lex_state = 421, .external_lex_state = 3},
  [8164] = {.lex_state = 192, .external_lex_state = 29},
  [8165] = {.lex_state = 361, .external_lex_state = 3},
  [8166] = {.lex_state = 247, .external_lex_state = 3},
  [8167] = {.lex_state = 424, .external_lex_state = 3},
  [8168] = {.lex_state = 424, .external_lex_state = 3},
  [8169] = {.lex_state = 424, .external_lex_state = 3},
  [8170] = {.lex_state = 424, .external_lex_state = 3},
  [8171] = {.lex_state = 424, .external_lex_state = 3},
  [8172] = {.lex_state = 424, .external_lex_state = 3},
  [8173] = {.lex_state = 554, .external_lex_state = 16},
  [8174] = {.lex_state = 424, .external_lex_state = 3},
  [8175] = {.lex_state = 424, .external_lex_state = 3},
  [8176] = {.lex_state = 424, .external_lex_state = 3},
  [8177] = {.lex_state = 424, .external_lex_state = 3},
  [8178] = {.lex_state = 424, .external_lex_state = 3},
  [8179] = {.lex_state = 424, .external_lex_state = 3},
  [8180] = {.lex_state = 424, .external_lex_state = 3},
  [8181] = {.lex_state = 424, .external_lex_state = 3},
  [8182] = {.lex_state = 424, .external_lex_state = 14},
  [8183] = {.lex_state = 192, .external_lex_state = 2},
  [8184] = {.lex_state = 192, .external_lex_state = 29},
  [8185] = {.lex_state = 421, .external_lex_state = 3},
  [8186] = {.lex_state = 528, .external_lex_state = 3},
  [8187] = {.lex_state = 528, .external_lex_state = 3},
  [8188] = {.lex_state = 528, .external_lex_state = 3},
  [8189] = {.lex_state = 528, .external_lex_state = 3},
  [8190] = {.lex_state = 528, .external_lex_state = 3},
  [8191] = {.lex_state = 528, .external_lex_state = 3},
  [8192] = {.lex_state = 554, .external_lex_state = 16},
  [8193] = {.lex_state = 528, .external_lex_state = 3},
  [8194] = {.lex_state = 528, .external_lex_state = 3},
  [8195] = {.lex_state = 528, .external_lex_state = 3},
  [8196] = {.lex_state = 528, .external_lex_state = 3},
  [8197] = {.lex_state = 528, .external_lex_state = 3},
  [8198] = {.lex_state = 528, .external_lex_state = 3},
  [8199] = {.lex_state = 528, .external_lex_state = 3},
  [8200] = {.lex_state = 528, .external_lex_state = 3},
  [8201] = {.lex_state = 508, .external_lex_state = 25},
  [8202] = {.lex_state = 508, .external_lex_state = 25},
  [8203] = {.lex_state = 192, .external_lex_state = 2},
  [8204] = {.lex_state = 508, .external_lex_state = 25},
  [8205] = {.lex_state = 192, .external_lex_state = 2},
  [8206] = {.lex_state = 508, .external_lex_state = 25},
  [8207] = {.lex_state = 524, .external_lex_state = 13},
  [8208] = {.lex_state = 508, .external_lex_state = 25},
  [8209] = {.lex_state = 508, .external_lex_state = 25},
  [8210] = {.lex_state = 508, .external_lex_state = 25},
  [8211] = {.lex_state = 508, .external_lex_state = 25},
  [8212] = {.lex_state = 508, .external_lex_state = 25},
  [8213] = {.lex_state = 508, .external_lex_state = 25},
  [8214] = {.lex_state = 508, .external_lex_state = 25},
  [8215] = {.lex_state = 554, .external_lex_state = 16},
  [8216] = {.lex_state = 508, .external_lex_state = 25},
  [8217] = {.lex_state = 508, .external_lex_state = 25},
  [8218] = {.lex_state = 508, .external_lex_state = 25},
  [8219] = {.lex_state = 508, .external_lex_state = 25},
  [8220] = {.lex_state = 508, .external_lex_state = 25},
  [8221] = {.lex_state = 192, .external_lex_state = 2},
  [8222] = {.lex_state = 618, .external_lex_state = 26},
  [8223] = {.lex_state = 618, .external_lex_state = 26},
  [8224] = {.lex_state = 618, .external_lex_state = 26},
  [8225] = {.lex_state = 618, .external_lex_state = 26},
  [8226] = {.lex_state = 192, .external_lex_state = 2},
  [8227] = {.lex_state = 192, .external_lex_state = 2},
  [8228] = {.lex_state = 192, .external_lex_state = 2},
  [8229] = {.lex_state = 424, .external_lex_state = 25},
  [8230] = {.lex_state = 213},
  [8231] = {.lex_state = 424, .external_lex_state = 25},
  [8232] = {.lex_state = 424, .external_lex_state = 27},
  [8233] = {.lex_state = 424, .external_lex_state = 25},
  [8234] = {.lex_state = 192, .external_lex_state = 2},
  [8235] = {.lex_state = 424, .external_lex_state = 25},
  [8236] = {.lex_state = 192, .external_lex_state = 2},
  [8237] = {.lex_state = 424, .external_lex_state = 25},
  [8238] = {.lex_state = 524, .external_lex_state = 13},
  [8239] = {.lex_state = 424, .external_lex_state = 25},
  [8240] = {.lex_state = 508, .external_lex_state = 25},
  [8241] = {.lex_state = 508, .external_lex_state = 25},
  [8242] = {.lex_state = 508, .external_lex_state = 25},
  [8243] = {.lex_state = 631, .external_lex_state = 27},
  [8244] = {.lex_state = 508, .external_lex_state = 25},
  [8245] = {.lex_state = 508, .external_lex_state = 25},
  [8246] = {.lex_state = 508, .external_lex_state = 25},
  [8247] = {.lex_state = 524, .external_lex_state = 21},
  [8248] = {.lex_state = 508, .external_lex_state = 25},
  [8249] = {.lex_state = 508, .external_lex_state = 25},
  [8250] = {.lex_state = 192, .external_lex_state = 2},
  [8251] = {.lex_state = 421, .external_lex_state = 25},
  [8252] = {.lex_state = 421, .external_lex_state = 25},
  [8253] = {.lex_state = 421, .external_lex_state = 25},
  [8254] = {.lex_state = 421, .external_lex_state = 25},
  [8255] = {.lex_state = 421, .external_lex_state = 25},
  [8256] = {.lex_state = 421, .external_lex_state = 25},
  [8257] = {.lex_state = 421, .external_lex_state = 25},
  [8258] = {.lex_state = 421, .external_lex_state = 25},
  [8259] = {.lex_state = 554, .external_lex_state = 16},
  [8260] = {.lex_state = 421, .external_lex_state = 25},
  [8261] = {.lex_state = 421, .external_lex_state = 25},
  [8262] = {.lex_state = 421, .external_lex_state = 25},
  [8263] = {.lex_state = 421, .external_lex_state = 25},
  [8264] = {.lex_state = 421, .external_lex_state = 25},
  [8265] = {.lex_state = 421, .external_lex_state = 25},
  [8266] = {.lex_state = 524, .external_lex_state = 21},
  [8267] = {.lex_state = 421, .external_lex_state = 25},
  [8268] = {.lex_state = 421, .external_lex_state = 25},
  [8269] = {.lex_state = 421, .external_lex_state = 25},
  [8270] = {.lex_state = 421, .external_lex_state = 25},
  [8271] = {.lex_state = 421, .external_lex_state = 25},
  [8272] = {.lex_state = 421, .external_lex_state = 27},
  [8273] = {.lex_state = 192, .external_lex_state = 29},
  [8274] = {.lex_state = 508, .external_lex_state = 25},
  [8275] = {.lex_state = 156, .external_lex_state = 3},
  [8276] = {.lex_state = 361, .external_lex_state = 3},
  [8277] = {.lex_state = 361, .external_lex_state = 3},
  [8278] = {.lex_state = 361, .external_lex_state = 3},
  [8279] = {.lex_state = 361, .external_lex_state = 3},
  [8280] = {.lex_state = 361, .external_lex_state = 3},
  [8281] = {.lex_state = 361, .external_lex_state = 3},
  [8282] = {.lex_state = 361, .external_lex_state = 3},
  [8283] = {.lex_state = 361, .external_lex_state = 3},
  [8284] = {.lex_state = 554, .external_lex_state = 16},
  [8285] = {.lex_state = 361, .external_lex_state = 3},
  [8286] = {.lex_state = 361, .external_lex_state = 3},
  [8287] = {.lex_state = 361, .external_lex_state = 3},
  [8288] = {.lex_state = 361, .external_lex_state = 3},
  [8289] = {.lex_state = 361, .external_lex_state = 3},
  [8290] = {.lex_state = 361, .external_lex_state = 3},
  [8291] = {.lex_state = 361, .external_lex_state = 3},
  [8292] = {.lex_state = 361, .external_lex_state = 3},
  [8293] = {.lex_state = 365, .external_lex_state = 14},
  [8294] = {.lex_state = 361, .external_lex_state = 3},
  [8295] = {.lex_state = 361, .external_lex_state = 3},
  [8296] = {.lex_state = 361, .external_lex_state = 3},
  [8297] = {.lex_state = 524, .external_lex_state = 21},
  [8298] = {.lex_state = 361, .external_lex_state = 3},
  [8299] = {.lex_state = 361, .external_lex_state = 3},
  [8300] = {.lex_state = 192, .external_lex_state = 2},
  [8301] = {.lex_state = 192, .external_lex_state = 29},
  [8302] = {.lex_state = 361, .external_lex_state = 3},
  [8303] = {.lex_state = 247, .external_lex_state = 3},
  [8304] = {.lex_state = 156, .external_lex_state = 3},
  [8305] = {.lex_state = 528, .external_lex_state = 3},
  [8306] = {.lex_state = 528, .external_lex_state = 3},
  [8307] = {.lex_state = 528, .external_lex_state = 3},
  [8308] = {.lex_state = 528, .external_lex_state = 3},
  [8309] = {.lex_state = 528, .external_lex_state = 3},
  [8310] = {.lex_state = 528, .external_lex_state = 3},
  [8311] = {.lex_state = 554, .external_lex_state = 16},
  [8312] = {.lex_state = 528, .external_lex_state = 3},
  [8313] = {.lex_state = 528, .external_lex_state = 3},
  [8314] = {.lex_state = 528, .external_lex_state = 3},
  [8315] = {.lex_state = 528, .external_lex_state = 3},
  [8316] = {.lex_state = 528, .external_lex_state = 3},
  [8317] = {.lex_state = 528, .external_lex_state = 3},
  [8318] = {.lex_state = 528, .external_lex_state = 3},
  [8319] = {.lex_state = 528, .external_lex_state = 3},
  [8320] = {.lex_state = 192, .external_lex_state = 2},
  [8321] = {.lex_state = 192, .external_lex_state = 2},
  [8322] = {.lex_state = 192, .external_lex_state = 2},
  [8323] = {.lex_state = 192, .external_lex_state = 2},
  [8324] = {.lex_state = 361, .external_lex_state = 3},
  [8325] = {.lex_state = 213},
  [8326] = {.lex_state = 259, .external_lex_state = 3},
  [8327] = {.lex_state = 361, .external_lex_state = 3},
  [8328] = {.lex_state = 192, .external_lex_state = 2},
  [8329] = {.lex_state = 361, .external_lex_state = 3},
  [8330] = {.lex_state = 192, .external_lex_state = 2},
  [8331] = {.lex_state = 361, .external_lex_state = 3},
  [8332] = {.lex_state = 524, .external_lex_state = 13},
  [8333] = {.lex_state = 361, .external_lex_state = 3},
  [8334] = {.lex_state = 254, .external_lex_state = 8},
  [8335] = {.lex_state = 192, .external_lex_state = 2},
  [8336] = {.lex_state = 218, .external_lex_state = 11},
  [8337] = {.lex_state = 218, .external_lex_state = 11},
  [8338] = {.lex_state = 218, .external_lex_state = 11},
  [8339] = {.lex_state = 218, .external_lex_state = 11},
  [8340] = {.lex_state = 192, .external_lex_state = 2},
  [8341] = {.lex_state = 192, .external_lex_state = 2},
  [8342] = {.lex_state = 192, .external_lex_state = 2},
  [8343] = {.lex_state = 225, .external_lex_state = 7},
  [8344] = {.lex_state = 128},
  [8345] = {.lex_state = 128, .external_lex_state = 8},
  [8346] = {.lex_state = 128, .external_lex_state = 8},
  [8347] = {.lex_state = 128},
  [8348] = {.lex_state = 247, .external_lex_state = 3},
  [8349] = {.lex_state = 254, .external_lex_state = 11},
  [8350] = {.lex_state = 213},
  [8351] = {.lex_state = 259, .external_lex_state = 3},
  [8352] = {.lex_state = 262, .external_lex_state = 14},
  [8353] = {.lex_state = 128, .external_lex_state = 2},
  [8354] = {.lex_state = 254, .external_lex_state = 8},
  [8355] = {.lex_state = 528, .external_lex_state = 3},
  [8356] = {.lex_state = 528, .external_lex_state = 3},
  [8357] = {.lex_state = 528, .external_lex_state = 3},
  [8358] = {.lex_state = 528, .external_lex_state = 3},
  [8359] = {.lex_state = 528, .external_lex_state = 3},
  [8360] = {.lex_state = 528, .external_lex_state = 3},
  [8361] = {.lex_state = 554, .external_lex_state = 16},
  [8362] = {.lex_state = 528, .external_lex_state = 3},
  [8363] = {.lex_state = 528, .external_lex_state = 3},
  [8364] = {.lex_state = 528, .external_lex_state = 3},
  [8365] = {.lex_state = 528, .external_lex_state = 3},
  [8366] = {.lex_state = 528, .external_lex_state = 3},
  [8367] = {.lex_state = 192, .external_lex_state = 2},
  [8368] = {.lex_state = 254, .external_lex_state = 11},
  [8369] = {.lex_state = 254, .external_lex_state = 11},
  [8370] = {.lex_state = 254, .external_lex_state = 11},
  [8371] = {.lex_state = 254, .external_lex_state = 11},
  [8372] = {.lex_state = 192, .external_lex_state = 2},
  [8373] = {.lex_state = 192, .external_lex_state = 2},
  [8374] = {.lex_state = 192, .external_lex_state = 2},
  [8375] = {.lex_state = 424, .external_lex_state = 3},
  [8376] = {.lex_state = 254, .external_lex_state = 11},
  [8377] = {.lex_state = 213},
  [8378] = {.lex_state = 424, .external_lex_state = 3},
  [8379] = {.lex_state = 424, .external_lex_state = 14},
  [8380] = {.lex_state = 424, .external_lex_state = 3},
  [8381] = {.lex_state = 192, .external_lex_state = 2},
  [8382] = {.lex_state = 424, .external_lex_state = 3},
  [8383] = {.lex_state = 192, .external_lex_state = 2},
  [8384] = {.lex_state = 424, .external_lex_state = 3},
  [8385] = {.lex_state = 524, .external_lex_state = 13},
  [8386] = {.lex_state = 424, .external_lex_state = 3},
  [8387] = {.lex_state = 192, .external_lex_state = 2},
  [8388] = {.lex_state = 528, .external_lex_state = 3},
  [8389] = {.lex_state = 528, .external_lex_state = 3},
  [8390] = {.lex_state = 528, .external_lex_state = 3},
  [8391] = {.lex_state = 365, .external_lex_state = 14},
  [8392] = {.lex_state = 361, .external_lex_state = 3},
  [8393] = {.lex_state = 361, .external_lex_state = 3},
  [8394] = {.lex_state = 361, .external_lex_state = 3},
  [8395] = {.lex_state = 361, .external_lex_state = 3},
  [8396] = {.lex_state = 361, .external_lex_state = 3},
  [8397] = {.lex_state = 361, .external_lex_state = 3},
  [8398] = {.lex_state = 361, .external_lex_state = 3},
  [8399] = {.lex_state = 361, .external_lex_state = 3},
  [8400] = {.lex_state = 554, .external_lex_state = 16},
  [8401] = {.lex_state = 361, .external_lex_state = 3},
  [8402] = {.lex_state = 361, .external_lex_state = 3},
  [8403] = {.lex_state = 361, .external_lex_state = 3},
  [8404] = {.lex_state = 361, .external_lex_state = 3},
  [8405] = {.lex_state = 361, .external_lex_state = 3},
  [8406] = {.lex_state = 361, .external_lex_state = 3},
  [8407] = {.lex_state = 361, .external_lex_state = 3},
  [8408] = {.lex_state = 361, .external_lex_state = 3},
  [8409] = {.lex_state = 365, .external_lex_state = 14},
  [8410] = {.lex_state = 361, .external_lex_state = 3},
  [8411] = {.lex_state = 361, .external_lex_state = 3},
  [8412] = {.lex_state = 361, .external_lex_state = 3},
  [8413] = {.lex_state = 524, .external_lex_state = 21},
  [8414] = {.lex_state = 361, .external_lex_state = 3},
  [8415] = {.lex_state = 361, .external_lex_state = 3},
  [8416] = {.lex_state = 192, .external_lex_state = 2},
  [8417] = {.lex_state = 421, .external_lex_state = 3},
  [8418] = {.lex_state = 421, .external_lex_state = 3},
  [8419] = {.lex_state = 421, .external_lex_state = 3},
  [8420] = {.lex_state = 524, .external_lex_state = 21},
  [8421] = {.lex_state = 421, .external_lex_state = 3},
  [8422] = {.lex_state = 421, .external_lex_state = 3},
  [8423] = {.lex_state = 192, .external_lex_state = 29},
  [8424] = {.lex_state = 361, .external_lex_state = 3},
  [8425] = {.lex_state = 361, .external_lex_state = 3},
  [8426] = {.lex_state = 361, .external_lex_state = 3},
  [8427] = {.lex_state = 361, .external_lex_state = 3},
  [8428] = {.lex_state = 361, .external_lex_state = 3},
  [8429] = {.lex_state = 361, .external_lex_state = 3},
  [8430] = {.lex_state = 361, .external_lex_state = 3},
  [8431] = {.lex_state = 361, .external_lex_state = 3},
  [8432] = {.lex_state = 361, .external_lex_state = 3},
  [8433] = {.lex_state = 554, .external_lex_state = 16},
  [8434] = {.lex_state = 361, .external_lex_state = 3},
  [8435] = {.lex_state = 361, .external_lex_state = 3},
  [8436] = {.lex_state = 361, .external_lex_state = 3},
  [8437] = {.lex_state = 361, .external_lex_state = 3},
  [8438] = {.lex_state = 361, .external_lex_state = 3},
  [8439] = {.lex_state = 361, .external_lex_state = 3},
  [8440] = {.lex_state = 524, .external_lex_state = 21},
  [8441] = {.lex_state = 361, .external_lex_state = 3},
  [8442] = {.lex_state = 361, .external_lex_state = 3},
  [8443] = {.lex_state = 361, .external_lex_state = 3},
  [8444] = {.lex_state = 361, .external_lex_state = 3},
  [8445] = {.lex_state = 361, .external_lex_state = 3},
  [8446] = {.lex_state = 350, .external_lex_state = 23},
  [8447] = {.lex_state = 356, .external_lex_state = 13},
  [8448] = {.lex_state = 350, .external_lex_state = 23},
  [8449] = {.lex_state = 350, .external_lex_state = 23},
  [8450] = {.lex_state = 416, .external_lex_state = 28},
  [8451] = {.lex_state = 343, .external_lex_state = 8},
  [8452] = {.lex_state = 235, .external_lex_state = 19},
  [8453] = {.lex_state = 235},
  [8454] = {.lex_state = 192, .external_lex_state = 2},
  [8455] = {.lex_state = 511, .external_lex_state = 11},
  [8456] = {.lex_state = 511, .external_lex_state = 11},
  [8457] = {.lex_state = 511, .external_lex_state = 11},
  [8458] = {.lex_state = 511, .external_lex_state = 11},
  [8459] = {.lex_state = 192, .external_lex_state = 2},
  [8460] = {.lex_state = 192, .external_lex_state = 2},
  [8461] = {.lex_state = 192, .external_lex_state = 2},
  [8462] = {.lex_state = 508, .external_lex_state = 3},
  [8463] = {.lex_state = 213},
  [8464] = {.lex_state = 424, .external_lex_state = 3},
  [8465] = {.lex_state = 631, .external_lex_state = 14},
  [8466] = {.lex_state = 508, .external_lex_state = 3},
  [8467] = {.lex_state = 508, .external_lex_state = 3},
  [8468] = {.lex_state = 634, .external_lex_state = 14},
  [8469] = {.lex_state = 192, .external_lex_state = 2},
  [8470] = {.lex_state = 508, .external_lex_state = 3},
  [8471] = {.lex_state = 508, .external_lex_state = 3},
  [8472] = {.lex_state = 192, .external_lex_state = 2},
  [8473] = {.lex_state = 192, .external_lex_state = 2},
  [8474] = {.lex_state = 237},
  [8475] = {.lex_state = 192, .external_lex_state = 2},
  [8476] = {.lex_state = 358, .external_lex_state = 11},
  [8477] = {.lex_state = 508, .external_lex_state = 3},
  [8478] = {.lex_state = 508, .external_lex_state = 3},
  [8479] = {.lex_state = 508, .external_lex_state = 3},
  [8480] = {.lex_state = 508, .external_lex_state = 14},
  [8481] = {.lex_state = 343, .external_lex_state = 8},
  [8482] = {.lex_state = 209, .external_lex_state = 19},
  [8483] = {.lex_state = 209},
  [8484] = {.lex_state = 508, .external_lex_state = 3},
  [8485] = {.lex_state = 508, .external_lex_state = 3},
  [8486] = {.lex_state = 192, .external_lex_state = 2},
  [8487] = {.lex_state = 192, .external_lex_state = 2},
  [8488] = {.lex_state = 192, .external_lex_state = 2},
  [8489] = {.lex_state = 192, .external_lex_state = 2},
  [8490] = {.lex_state = 192, .external_lex_state = 2},
  [8491] = {.lex_state = 192, .external_lex_state = 2},
  [8492] = {.lex_state = 192, .external_lex_state = 2},
  [8493] = {.lex_state = 192, .external_lex_state = 2},
  [8494] = {.lex_state = 192, .external_lex_state = 2},
  [8495] = {.lex_state = 192, .external_lex_state = 2},
  [8496] = {.lex_state = 192, .external_lex_state = 2},
  [8497] = {.lex_state = 192, .external_lex_state = 2},
  [8498] = {.lex_state = 192, .external_lex_state = 2},
  [8499] = {.lex_state = 343, .external_lex_state = 8},
  [8500] = {.lex_state = 177, .external_lex_state = 17},
  [8501] = {.lex_state = 343, .external_lex_state = 8},
  [8502] = {.lex_state = 524, .external_lex_state = 13},
  [8503] = {.lex_state = 678, .external_lex_state = 8},
  [8504] = {.lex_state = 192, .external_lex_state = 29},
  [8505] = {.lex_state = 192, .external_lex_state = 2},
  [8506] = {.lex_state = 634, .external_lex_state = 14},
  [8507] = {.lex_state = 128},
  [8508] = {.lex_state = 128},
  [8509] = {.lex_state = 192, .external_lex_state = 2},
  [8510] = {.lex_state = 421, .external_lex_state = 3},
  [8511] = {.lex_state = 421, .external_lex_state = 3},
  [8512] = {.lex_state = 421, .external_lex_state = 3},
  [8513] = {.lex_state = 421, .external_lex_state = 3},
  [8514] = {.lex_state = 421, .external_lex_state = 3},
  [8515] = {.lex_state = 421, .external_lex_state = 3},
  [8516] = {.lex_state = 421, .external_lex_state = 3},
  [8517] = {.lex_state = 421, .external_lex_state = 3},
  [8518] = {.lex_state = 554, .external_lex_state = 16},
  [8519] = {.lex_state = 421, .external_lex_state = 3},
  [8520] = {.lex_state = 421, .external_lex_state = 3},
  [8521] = {.lex_state = 421, .external_lex_state = 3},
  [8522] = {.lex_state = 421, .external_lex_state = 3},
  [8523] = {.lex_state = 421, .external_lex_state = 3},
  [8524] = {.lex_state = 421, .external_lex_state = 3},
  [8525] = {.lex_state = 524, .external_lex_state = 21},
  [8526] = {.lex_state = 421, .external_lex_state = 3},
  [8527] = {.lex_state = 421, .external_lex_state = 3},
  [8528] = {.lex_state = 421, .external_lex_state = 3},
  [8529] = {.lex_state = 421, .external_lex_state = 3},
  [8530] = {.lex_state = 421, .external_lex_state = 3},
  [8531] = {.lex_state = 421, .external_lex_state = 14},
  [8532] = {.lex_state = 528, .external_lex_state = 3},
  [8533] = {.lex_state = 192, .external_lex_state = 29},
  [8534] = {.lex_state = 528, .external_lex_state = 3},
  [8535] = {.lex_state = 361, .external_lex_state = 3},
  [8536] = {.lex_state = 361, .external_lex_state = 3},
  [8537] = {.lex_state = 361, .external_lex_state = 3},
  [8538] = {.lex_state = 361, .external_lex_state = 3},
  [8539] = {.lex_state = 361, .external_lex_state = 3},
  [8540] = {.lex_state = 192, .external_lex_state = 2},
  [8541] = {.lex_state = 192, .external_lex_state = 2},
  [8542] = {.lex_state = 192, .external_lex_state = 2},
  [8543] = {.lex_state = 192, .external_lex_state = 2},
  [8544] = {.lex_state = 192, .external_lex_state = 2},
  [8545] = {.lex_state = 192, .external_lex_state = 2},
  [8546] = {.lex_state = 192, .external_lex_state = 2},
  [8547] = {.lex_state = 192, .external_lex_state = 2},
  [8548] = {.lex_state = 192, .external_lex_state = 2},
  [8549] = {.lex_state = 192, .external_lex_state = 2},
  [8550] = {.lex_state = 192, .external_lex_state = 2},
  [8551] = {.lex_state = 192, .external_lex_state = 2},
  [8552] = {.lex_state = 192, .external_lex_state = 29},
  [8553] = {.lex_state = 192, .external_lex_state = 2},
  [8554] = {.lex_state = 365, .external_lex_state = 14},
  [8555] = {.lex_state = 361, .external_lex_state = 3},
  [8556] = {.lex_state = 361, .external_lex_state = 3},
  [8557] = {.lex_state = 361, .external_lex_state = 3},
  [8558] = {.lex_state = 192, .external_lex_state = 2},
  [8559] = {.lex_state = 361, .external_lex_state = 3},
  [8560] = {.lex_state = 192, .external_lex_state = 2},
  [8561] = {.lex_state = 361, .external_lex_state = 3},
  [8562] = {.lex_state = 524, .external_lex_state = 13},
  [8563] = {.lex_state = 361, .external_lex_state = 3},
  [8564] = {.lex_state = 361, .external_lex_state = 3},
  [8565] = {.lex_state = 361, .external_lex_state = 3},
  [8566] = {.lex_state = 361, .external_lex_state = 3},
  [8567] = {.lex_state = 361, .external_lex_state = 3},
  [8568] = {.lex_state = 361, .external_lex_state = 3},
  [8569] = {.lex_state = 361, .external_lex_state = 3},
  [8570] = {.lex_state = 361, .external_lex_state = 3},
  [8571] = {.lex_state = 554, .external_lex_state = 16},
  [8572] = {.lex_state = 361, .external_lex_state = 3},
  [8573] = {.lex_state = 361, .external_lex_state = 3},
  [8574] = {.lex_state = 361, .external_lex_state = 3},
  [8575] = {.lex_state = 361, .external_lex_state = 3},
  [8576] = {.lex_state = 361, .external_lex_state = 3},
  [8577] = {.lex_state = 421, .external_lex_state = 3},
  [8578] = {.lex_state = 421, .external_lex_state = 3},
  [8579] = {.lex_state = 192, .external_lex_state = 2},
  [8580] = {.lex_state = 421, .external_lex_state = 3},
  [8581] = {.lex_state = 192, .external_lex_state = 2},
  [8582] = {.lex_state = 421, .external_lex_state = 3},
  [8583] = {.lex_state = 524, .external_lex_state = 13},
  [8584] = {.lex_state = 421, .external_lex_state = 3},
  [8585] = {.lex_state = 262, .external_lex_state = 3},
  [8586] = {.lex_state = 524, .external_lex_state = 21},
  [8587] = {.lex_state = 262, .external_lex_state = 3},
  [8588] = {.lex_state = 361, .external_lex_state = 3},
  [8589] = {.lex_state = 361, .external_lex_state = 3},
  [8590] = {.lex_state = 361, .external_lex_state = 3},
  [8591] = {.lex_state = 361, .external_lex_state = 3},
  [8592] = {.lex_state = 361, .external_lex_state = 14},
  [8593] = {.lex_state = 254, .external_lex_state = 8},
  [8594] = {.lex_state = 128, .external_lex_state = 2},
  [8595] = {.lex_state = 192, .external_lex_state = 2},
  [8596] = {.lex_state = 424, .external_lex_state = 3},
  [8597] = {.lex_state = 424, .external_lex_state = 3},
  [8598] = {.lex_state = 424, .external_lex_state = 3},
  [8599] = {.lex_state = 192, .external_lex_state = 2},
  [8600] = {.lex_state = 192, .external_lex_state = 2},
  [8601] = {.lex_state = 192, .external_lex_state = 2},
  [8602] = {.lex_state = 192, .external_lex_state = 2},
  [8603] = {.lex_state = 192, .external_lex_state = 2},
  [8604] = {.lex_state = 192, .external_lex_state = 2},
  [8605] = {.lex_state = 192, .external_lex_state = 2},
  [8606] = {.lex_state = 192, .external_lex_state = 2},
  [8607] = {.lex_state = 192, .external_lex_state = 2},
  [8608] = {.lex_state = 192, .external_lex_state = 2},
  [8609] = {.lex_state = 192, .external_lex_state = 2},
  [8610] = {.lex_state = 192, .external_lex_state = 2},
  [8611] = {.lex_state = 192, .external_lex_state = 29},
  [8612] = {.lex_state = 192, .external_lex_state = 2},
  [8613] = {.lex_state = 424, .external_lex_state = 14},
  [8614] = {.lex_state = 424, .external_lex_state = 3},
  [8615] = {.lex_state = 421, .external_lex_state = 3},
  [8616] = {.lex_state = 421, .external_lex_state = 3},
  [8617] = {.lex_state = 421, .external_lex_state = 3},
  [8618] = {.lex_state = 421, .external_lex_state = 3},
  [8619] = {.lex_state = 421, .external_lex_state = 3},
  [8620] = {.lex_state = 421, .external_lex_state = 3},
  [8621] = {.lex_state = 424, .external_lex_state = 3},
  [8622] = {.lex_state = 554, .external_lex_state = 16},
  [8623] = {.lex_state = 421, .external_lex_state = 3},
  [8624] = {.lex_state = 421, .external_lex_state = 3},
  [8625] = {.lex_state = 421, .external_lex_state = 3},
  [8626] = {.lex_state = 421, .external_lex_state = 3},
  [8627] = {.lex_state = 421, .external_lex_state = 3},
  [8628] = {.lex_state = 424, .external_lex_state = 3},
  [8629] = {.lex_state = 524, .external_lex_state = 21},
  [8630] = {.lex_state = 424, .external_lex_state = 3},
  [8631] = {.lex_state = 424, .external_lex_state = 3},
  [8632] = {.lex_state = 421, .external_lex_state = 3},
  [8633] = {.lex_state = 421, .external_lex_state = 3},
  [8634] = {.lex_state = 421, .external_lex_state = 3},
  [8635] = {.lex_state = 421, .external_lex_state = 14},
  [8636] = {.lex_state = 528, .external_lex_state = 3},
  [8637] = {.lex_state = 528, .external_lex_state = 3},
  [8638] = {.lex_state = 528, .external_lex_state = 3},
  [8639] = {.lex_state = 528, .external_lex_state = 3},
  [8640] = {.lex_state = 192, .external_lex_state = 2},
  [8641] = {.lex_state = 192, .external_lex_state = 2},
  [8642] = {.lex_state = 192, .external_lex_state = 2},
  [8643] = {.lex_state = 192, .external_lex_state = 2},
  [8644] = {.lex_state = 192, .external_lex_state = 2},
  [8645] = {.lex_state = 192, .external_lex_state = 2},
  [8646] = {.lex_state = 192, .external_lex_state = 2},
  [8647] = {.lex_state = 192, .external_lex_state = 2},
  [8648] = {.lex_state = 192, .external_lex_state = 2},
  [8649] = {.lex_state = 192, .external_lex_state = 2},
  [8650] = {.lex_state = 192, .external_lex_state = 2},
  [8651] = {.lex_state = 192, .external_lex_state = 2},
  [8652] = {.lex_state = 192, .external_lex_state = 29},
  [8653] = {.lex_state = 528, .external_lex_state = 3},
  [8654] = {.lex_state = 192, .external_lex_state = 29},
  [8655] = {.lex_state = 192, .external_lex_state = 2},
  [8656] = {.lex_state = 361, .external_lex_state = 3},
  [8657] = {.lex_state = 361, .external_lex_state = 3},
  [8658] = {.lex_state = 361, .external_lex_state = 3},
  [8659] = {.lex_state = 361, .external_lex_state = 3},
  [8660] = {.lex_state = 361, .external_lex_state = 3},
  [8661] = {.lex_state = 192, .external_lex_state = 2},
  [8662] = {.lex_state = 192, .external_lex_state = 2},
  [8663] = {.lex_state = 192, .external_lex_state = 2},
  [8664] = {.lex_state = 192, .external_lex_state = 2},
  [8665] = {.lex_state = 192, .external_lex_state = 2},
  [8666] = {.lex_state = 192, .external_lex_state = 2},
  [8667] = {.lex_state = 192, .external_lex_state = 2},
  [8668] = {.lex_state = 192, .external_lex_state = 2},
  [8669] = {.lex_state = 192, .external_lex_state = 2},
  [8670] = {.lex_state = 192, .external_lex_state = 2},
  [8671] = {.lex_state = 192, .external_lex_state = 2},
  [8672] = {.lex_state = 192, .external_lex_state = 2},
  [8673] = {.lex_state = 192, .external_lex_state = 29},
  [8674] = {.lex_state = 192, .external_lex_state = 2},
  [8675] = {.lex_state = 365, .external_lex_state = 14},
  [8676] = {.lex_state = 361, .external_lex_state = 3},
  [8677] = {.lex_state = 361, .external_lex_state = 3},
  [8678] = {.lex_state = 361, .external_lex_state = 3},
  [8679] = {.lex_state = 192, .external_lex_state = 2},
  [8680] = {.lex_state = 361, .external_lex_state = 3},
  [8681] = {.lex_state = 192, .external_lex_state = 2},
  [8682] = {.lex_state = 361, .external_lex_state = 3},
  [8683] = {.lex_state = 524, .external_lex_state = 13},
  [8684] = {.lex_state = 361, .external_lex_state = 3},
  [8685] = {.lex_state = 361, .external_lex_state = 3},
  [8686] = {.lex_state = 361, .external_lex_state = 3},
  [8687] = {.lex_state = 361, .external_lex_state = 3},
  [8688] = {.lex_state = 361, .external_lex_state = 3},
  [8689] = {.lex_state = 361, .external_lex_state = 3},
  [8690] = {.lex_state = 361, .external_lex_state = 3},
  [8691] = {.lex_state = 361, .external_lex_state = 3},
  [8692] = {.lex_state = 554, .external_lex_state = 16},
  [8693] = {.lex_state = 361, .external_lex_state = 3},
  [8694] = {.lex_state = 361, .external_lex_state = 3},
  [8695] = {.lex_state = 361, .external_lex_state = 3},
  [8696] = {.lex_state = 361, .external_lex_state = 3},
  [8697] = {.lex_state = 361, .external_lex_state = 3},
  [8698] = {.lex_state = 421, .external_lex_state = 3},
  [8699] = {.lex_state = 421, .external_lex_state = 3},
  [8700] = {.lex_state = 192, .external_lex_state = 2},
  [8701] = {.lex_state = 421, .external_lex_state = 3},
  [8702] = {.lex_state = 192, .external_lex_state = 2},
  [8703] = {.lex_state = 421, .external_lex_state = 3},
  [8704] = {.lex_state = 524, .external_lex_state = 13},
  [8705] = {.lex_state = 421, .external_lex_state = 3},
  [8706] = {.lex_state = 262, .external_lex_state = 3},
  [8707] = {.lex_state = 524, .external_lex_state = 21},
  [8708] = {.lex_state = 262, .external_lex_state = 3},
  [8709] = {.lex_state = 361, .external_lex_state = 3},
  [8710] = {.lex_state = 361, .external_lex_state = 3},
  [8711] = {.lex_state = 361, .external_lex_state = 3},
  [8712] = {.lex_state = 361, .external_lex_state = 3},
  [8713] = {.lex_state = 361, .external_lex_state = 14},
  [8714] = {.lex_state = 254, .external_lex_state = 8},
  [8715] = {.lex_state = 128, .external_lex_state = 2},
  [8716] = {.lex_state = 192, .external_lex_state = 2},
  [8717] = {.lex_state = 424, .external_lex_state = 3},
  [8718] = {.lex_state = 424, .external_lex_state = 3},
  [8719] = {.lex_state = 424, .external_lex_state = 3},
  [8720] = {.lex_state = 192, .external_lex_state = 2},
  [8721] = {.lex_state = 192, .external_lex_state = 2},
  [8722] = {.lex_state = 192, .external_lex_state = 2},
  [8723] = {.lex_state = 192, .external_lex_state = 2},
  [8724] = {.lex_state = 192, .external_lex_state = 2},
  [8725] = {.lex_state = 192, .external_lex_state = 2},
  [8726] = {.lex_state = 192, .external_lex_state = 2},
  [8727] = {.lex_state = 192, .external_lex_state = 2},
  [8728] = {.lex_state = 192, .external_lex_state = 2},
  [8729] = {.lex_state = 192, .external_lex_state = 2},
  [8730] = {.lex_state = 192, .external_lex_state = 2},
  [8731] = {.lex_state = 192, .external_lex_state = 2},
  [8732] = {.lex_state = 192, .external_lex_state = 29},
  [8733] = {.lex_state = 192, .external_lex_state = 2},
  [8734] = {.lex_state = 424, .external_lex_state = 14},
  [8735] = {.lex_state = 424, .external_lex_state = 3},
  [8736] = {.lex_state = 421, .external_lex_state = 3},
  [8737] = {.lex_state = 421, .external_lex_state = 3},
  [8738] = {.lex_state = 421, .external_lex_state = 3},
  [8739] = {.lex_state = 421, .external_lex_state = 3},
  [8740] = {.lex_state = 421, .external_lex_state = 3},
  [8741] = {.lex_state = 421, .external_lex_state = 3},
  [8742] = {.lex_state = 424, .external_lex_state = 3},
  [8743] = {.lex_state = 554, .external_lex_state = 16},
  [8744] = {.lex_state = 421, .external_lex_state = 3},
  [8745] = {.lex_state = 421, .external_lex_state = 3},
  [8746] = {.lex_state = 421, .external_lex_state = 3},
  [8747] = {.lex_state = 421, .external_lex_state = 3},
  [8748] = {.lex_state = 421, .external_lex_state = 3},
  [8749] = {.lex_state = 424, .external_lex_state = 3},
  [8750] = {.lex_state = 524, .external_lex_state = 21},
  [8751] = {.lex_state = 424, .external_lex_state = 3},
  [8752] = {.lex_state = 424, .external_lex_state = 3},
  [8753] = {.lex_state = 421, .external_lex_state = 3},
  [8754] = {.lex_state = 421, .external_lex_state = 3},
  [8755] = {.lex_state = 421, .external_lex_state = 3},
  [8756] = {.lex_state = 421, .external_lex_state = 14},
  [8757] = {.lex_state = 528, .external_lex_state = 3},
  [8758] = {.lex_state = 528, .external_lex_state = 3},
  [8759] = {.lex_state = 528, .external_lex_state = 3},
  [8760] = {.lex_state = 528, .external_lex_state = 3},
  [8761] = {.lex_state = 192, .external_lex_state = 2},
  [8762] = {.lex_state = 192, .external_lex_state = 2},
  [8763] = {.lex_state = 192, .external_lex_state = 2},
  [8764] = {.lex_state = 192, .external_lex_state = 2},
  [8765] = {.lex_state = 192, .external_lex_state = 2},
  [8766] = {.lex_state = 192, .external_lex_state = 2},
  [8767] = {.lex_state = 192, .external_lex_state = 2},
  [8768] = {.lex_state = 192, .external_lex_state = 2},
  [8769] = {.lex_state = 192, .external_lex_state = 2},
  [8770] = {.lex_state = 192, .external_lex_state = 2},
  [8771] = {.lex_state = 192, .external_lex_state = 2},
  [8772] = {.lex_state = 192, .external_lex_state = 2},
  [8773] = {.lex_state = 192, .external_lex_state = 29},
  [8774] = {.lex_state = 528, .external_lex_state = 3},
  [8775] = {.lex_state = 192, .external_lex_state = 29},
  [8776] = {.lex_state = 192, .external_lex_state = 2},
  [8777] = {.lex_state = 156, .external_lex_state = 3},
  [8778] = {.lex_state = 247, .external_lex_state = 3},
  [8779] = {.lex_state = 424, .external_lex_state = 3},
  [8780] = {.lex_state = 424, .external_lex_state = 3},
  [8781] = {.lex_state = 424, .external_lex_state = 3},
  [8782] = {.lex_state = 424, .external_lex_state = 3},
  [8783] = {.lex_state = 424, .external_lex_state = 3},
  [8784] = {.lex_state = 424, .external_lex_state = 3},
  [8785] = {.lex_state = 554, .external_lex_state = 16},
  [8786] = {.lex_state = 424, .external_lex_state = 3},
  [8787] = {.lex_state = 424, .external_lex_state = 3},
  [8788] = {.lex_state = 424, .external_lex_state = 3},
  [8789] = {.lex_state = 424, .external_lex_state = 3},
  [8790] = {.lex_state = 424, .external_lex_state = 3},
  [8791] = {.lex_state = 424, .external_lex_state = 3},
  [8792] = {.lex_state = 424, .external_lex_state = 3},
  [8793] = {.lex_state = 424, .external_lex_state = 3},
  [8794] = {.lex_state = 424, .external_lex_state = 14},
  [8795] = {.lex_state = 192, .external_lex_state = 2},
  [8796] = {.lex_state = 192, .external_lex_state = 29},
  [8797] = {.lex_state = 421, .external_lex_state = 3},
  [8798] = {.lex_state = 528, .external_lex_state = 3},
  [8799] = {.lex_state = 528, .external_lex_state = 3},
  [8800] = {.lex_state = 528, .external_lex_state = 3},
  [8801] = {.lex_state = 528, .external_lex_state = 3},
  [8802] = {.lex_state = 528, .external_lex_state = 3},
  [8803] = {.lex_state = 528, .external_lex_state = 3},
  [8804] = {.lex_state = 554, .external_lex_state = 16},
  [8805] = {.lex_state = 528, .external_lex_state = 3},
  [8806] = {.lex_state = 528, .external_lex_state = 3},
  [8807] = {.lex_state = 528, .external_lex_state = 3},
  [8808] = {.lex_state = 528, .external_lex_state = 3},
  [8809] = {.lex_state = 528, .external_lex_state = 3},
  [8810] = {.lex_state = 528, .external_lex_state = 3},
  [8811] = {.lex_state = 528, .external_lex_state = 3},
  [8812] = {.lex_state = 528, .external_lex_state = 3},
  [8813] = {.lex_state = 388, .external_lex_state = 25},
  [8814] = {.lex_state = 177, .external_lex_state = 4},
  [8815] = {.lex_state = 388, .external_lex_state = 25},
  [8816] = {.lex_state = 388, .external_lex_state = 25},
  [8817] = {.lex_state = 177, .external_lex_state = 4},
  [8818] = {.lex_state = 388, .external_lex_state = 25},
  [8819] = {.lex_state = 406, .external_lex_state = 25},
  [8820] = {.lex_state = 406, .external_lex_state = 25},
  [8821] = {.lex_state = 406, .external_lex_state = 25},
  [8822] = {.lex_state = 192, .external_lex_state = 2},
  [8823] = {.lex_state = 192, .external_lex_state = 2},
  [8824] = {.lex_state = 192, .external_lex_state = 2},
  [8825] = {.lex_state = 192, .external_lex_state = 2},
  [8826] = {.lex_state = 192, .external_lex_state = 2},
  [8827] = {.lex_state = 192, .external_lex_state = 2},
  [8828] = {.lex_state = 192, .external_lex_state = 2},
  [8829] = {.lex_state = 192, .external_lex_state = 2},
  [8830] = {.lex_state = 192, .external_lex_state = 2},
  [8831] = {.lex_state = 192, .external_lex_state = 2},
  [8832] = {.lex_state = 192, .external_lex_state = 2},
  [8833] = {.lex_state = 192, .external_lex_state = 2},
  [8834] = {.lex_state = 192, .external_lex_state = 29},
  [8835] = {.lex_state = 192, .external_lex_state = 2},
  [8836] = {.lex_state = 406, .external_lex_state = 25},
  [8837] = {.lex_state = 406, .external_lex_state = 25},
  [8838] = {.lex_state = 406, .external_lex_state = 25},
  [8839] = {.lex_state = 524, .external_lex_state = 21},
  [8840] = {.lex_state = 406, .external_lex_state = 25},
  [8841] = {.lex_state = 406, .external_lex_state = 25},
  [8842] = {.lex_state = 192, .external_lex_state = 2},
  [8843] = {.lex_state = 537, .external_lex_state = 25},
  [8844] = {.lex_state = 537, .external_lex_state = 25},
  [8845] = {.lex_state = 537, .external_lex_state = 25},
  [8846] = {.lex_state = 192, .external_lex_state = 2},
  [8847] = {.lex_state = 192, .external_lex_state = 2},
  [8848] = {.lex_state = 192, .external_lex_state = 2},
  [8849] = {.lex_state = 192, .external_lex_state = 2},
  [8850] = {.lex_state = 192, .external_lex_state = 2},
  [8851] = {.lex_state = 192, .external_lex_state = 2},
  [8852] = {.lex_state = 192, .external_lex_state = 2},
  [8853] = {.lex_state = 192, .external_lex_state = 2},
  [8854] = {.lex_state = 192, .external_lex_state = 2},
  [8855] = {.lex_state = 192, .external_lex_state = 2},
  [8856] = {.lex_state = 192, .external_lex_state = 2},
  [8857] = {.lex_state = 192, .external_lex_state = 2},
  [8858] = {.lex_state = 192, .external_lex_state = 29},
  [8859] = {.lex_state = 192, .external_lex_state = 2},
  [8860] = {.lex_state = 537, .external_lex_state = 27},
  [8861] = {.lex_state = 537, .external_lex_state = 25},
  [8862] = {.lex_state = 537, .external_lex_state = 25},
  [8863] = {.lex_state = 537, .external_lex_state = 25},
  [8864] = {.lex_state = 524, .external_lex_state = 21},
  [8865] = {.lex_state = 537, .external_lex_state = 25},
  [8866] = {.lex_state = 537, .external_lex_state = 25},
  [8867] = {.lex_state = 400, .external_lex_state = 25},
  [8868] = {.lex_state = 192, .external_lex_state = 29},
  [8869] = {.lex_state = 400, .external_lex_state = 25},
  [8870] = {.lex_state = 225, .external_lex_state = 7},
  [8871] = {.lex_state = 388, .external_lex_state = 25},
  [8872] = {.lex_state = 388, .external_lex_state = 25},
  [8873] = {.lex_state = 192, .external_lex_state = 2},
  [8874] = {.lex_state = 192, .external_lex_state = 29},
  [8875] = {.lex_state = 406, .external_lex_state = 25},
  [8876] = {.lex_state = 388, .external_lex_state = 25},
  [8877] = {.lex_state = 128},
  [8878] = {.lex_state = 128},
  [8879] = {.lex_state = 388, .external_lex_state = 25},
  [8880] = {.lex_state = 128},
  [8881] = {.lex_state = 388, .external_lex_state = 25},
  [8882] = {.lex_state = 388, .external_lex_state = 25},
  [8883] = {.lex_state = 388, .external_lex_state = 25},
  [8884] = {.lex_state = 128},
  [8885] = {.lex_state = 388, .external_lex_state = 25},
  [8886] = {.lex_state = 128},
  [8887] = {.lex_state = 388, .external_lex_state = 25},
  [8888] = {.lex_state = 128},
  [8889] = {.lex_state = 388, .external_lex_state = 25},
  [8890] = {.lex_state = 388, .external_lex_state = 25},
  [8891] = {.lex_state = 128},
  [8892] = {.lex_state = 128, .external_lex_state = 2},
  [8893] = {.lex_state = 400, .external_lex_state = 25},
  [8894] = {.lex_state = 544, .external_lex_state = 26},
  [8895] = {.lex_state = 209},
  [8896] = {.lex_state = 397, .external_lex_state = 25},
  [8897] = {.lex_state = 397, .external_lex_state = 25},
  [8898] = {.lex_state = 397, .external_lex_state = 25},
  [8899] = {.lex_state = 128},
  [8900] = {.lex_state = 128, .external_lex_state = 2},
  [8901] = {.lex_state = 192, .external_lex_state = 2},
  [8902] = {.lex_state = 192, .external_lex_state = 29},
  [8903] = {.lex_state = 403, .external_lex_state = 25},
  [8904] = {.lex_state = 641, .external_lex_state = 13},
  [8905] = {.lex_state = 547, .external_lex_state = 25},
  [8906] = {.lex_state = 400, .external_lex_state = 25},
  [8907] = {.lex_state = 237},
  [8908] = {.lex_state = 128},
  [8909] = {.lex_state = 286, .external_lex_state = 2},
  [8910] = {.lex_state = 237},
  [8911] = {.lex_state = 192, .external_lex_state = 2},
  [8912] = {.lex_state = 511, .external_lex_state = 18},
  [8913] = {.lex_state = 511, .external_lex_state = 18},
  [8914] = {.lex_state = 511, .external_lex_state = 18},
  [8915] = {.lex_state = 511, .external_lex_state = 18},
  [8916] = {.lex_state = 192, .external_lex_state = 2},
  [8917] = {.lex_state = 192, .external_lex_state = 2},
  [8918] = {.lex_state = 192, .external_lex_state = 2},
  [8919] = {.lex_state = 302, .external_lex_state = 16},
  [8920] = {.lex_state = 254, .external_lex_state = 18},
  [8921] = {.lex_state = 213},
  [8922] = {.lex_state = 227, .external_lex_state = 16},
  [8923] = {.lex_state = 251, .external_lex_state = 20},
  [8924] = {.lex_state = 302, .external_lex_state = 16},
  [8925] = {.lex_state = 128},
  [8926] = {.lex_state = 237},
  [8927] = {.lex_state = 237},
  [8928] = {.lex_state = 337},
  [8929] = {.lex_state = 237},
  [8930] = {.lex_state = 128, .external_lex_state = 12},
  [8931] = {.lex_state = 237},
  [8932] = {.lex_state = 128},
  [8933] = {.lex_state = 237},
  [8934] = {.lex_state = 156, .external_lex_state = 3},
  [8935] = {.lex_state = 128},
  [8936] = {.lex_state = 302, .external_lex_state = 16},
  [8937] = {.lex_state = 302, .external_lex_state = 16},
  [8938] = {.lex_state = 302, .external_lex_state = 16},
  [8939] = {.lex_state = 302, .external_lex_state = 16},
  [8940] = {.lex_state = 302, .external_lex_state = 16},
  [8941] = {.lex_state = 302, .external_lex_state = 16},
  [8942] = {.lex_state = 554, .external_lex_state = 16},
  [8943] = {.lex_state = 302, .external_lex_state = 16},
  [8944] = {.lex_state = 302, .external_lex_state = 16},
  [8945] = {.lex_state = 302, .external_lex_state = 16},
  [8946] = {.lex_state = 302, .external_lex_state = 16},
  [8947] = {.lex_state = 302, .external_lex_state = 16},
  [8948] = {.lex_state = 421, .external_lex_state = 25},
  [8949] = {.lex_state = 192, .external_lex_state = 2},
  [8950] = {.lex_state = 302, .external_lex_state = 16},
  [8951] = {.lex_state = 302, .external_lex_state = 16},
  [8952] = {.lex_state = 302, .external_lex_state = 16},
  [8953] = {.lex_state = 251, .external_lex_state = 20},
  [8954] = {.lex_state = 645, .external_lex_state = 25},
  [8955] = {.lex_state = 645, .external_lex_state = 25},
  [8956] = {.lex_state = 645, .external_lex_state = 25},
  [8957] = {.lex_state = 645, .external_lex_state = 25},
  [8958] = {.lex_state = 645, .external_lex_state = 25},
  [8959] = {.lex_state = 192, .external_lex_state = 2},
  [8960] = {.lex_state = 192, .external_lex_state = 2},
  [8961] = {.lex_state = 192, .external_lex_state = 2},
  [8962] = {.lex_state = 192, .external_lex_state = 2},
  [8963] = {.lex_state = 192, .external_lex_state = 2},
  [8964] = {.lex_state = 192, .external_lex_state = 2},
  [8965] = {.lex_state = 192, .external_lex_state = 2},
  [8966] = {.lex_state = 192, .external_lex_state = 2},
  [8967] = {.lex_state = 192, .external_lex_state = 2},
  [8968] = {.lex_state = 192, .external_lex_state = 2},
  [8969] = {.lex_state = 192, .external_lex_state = 2},
  [8970] = {.lex_state = 192, .external_lex_state = 2},
  [8971] = {.lex_state = 192, .external_lex_state = 29},
  [8972] = {.lex_state = 192, .external_lex_state = 2},
  [8973] = {.lex_state = 645, .external_lex_state = 27},
  [8974] = {.lex_state = 654, .external_lex_state = 27},
  [8975] = {.lex_state = 192, .external_lex_state = 15},
  [8976] = {.lex_state = 645, .external_lex_state = 25},
  [8977] = {.lex_state = 654, .external_lex_state = 25},
  [8978] = {.lex_state = 654, .external_lex_state = 25},
  [8979] = {.lex_state = 192, .external_lex_state = 2},
  [8980] = {.lex_state = 654, .external_lex_state = 25},
  [8981] = {.lex_state = 192, .external_lex_state = 2},
  [8982] = {.lex_state = 654, .external_lex_state = 25},
  [8983] = {.lex_state = 524, .external_lex_state = 13},
  [8984] = {.lex_state = 654, .external_lex_state = 25},
  [8985] = {.lex_state = 654, .external_lex_state = 25},
  [8986] = {.lex_state = 654, .external_lex_state = 25},
  [8987] = {.lex_state = 654, .external_lex_state = 25},
  [8988] = {.lex_state = 654, .external_lex_state = 25},
  [8989] = {.lex_state = 654, .external_lex_state = 25},
  [8990] = {.lex_state = 654, .external_lex_state = 25},
  [8991] = {.lex_state = 645, .external_lex_state = 25},
  [8992] = {.lex_state = 554, .external_lex_state = 16},
  [8993] = {.lex_state = 654, .external_lex_state = 25},
  [8994] = {.lex_state = 654, .external_lex_state = 25},
  [8995] = {.lex_state = 654, .external_lex_state = 25},
  [8996] = {.lex_state = 654, .external_lex_state = 25},
  [8997] = {.lex_state = 654, .external_lex_state = 25},
  [8998] = {.lex_state = 658, .external_lex_state = 25},
  [8999] = {.lex_state = 658, .external_lex_state = 25},
  [9000] = {.lex_state = 192, .external_lex_state = 2},
  [9001] = {.lex_state = 658, .external_lex_state = 25},
  [9002] = {.lex_state = 192, .external_lex_state = 2},
  [9003] = {.lex_state = 658, .external_lex_state = 25},
  [9004] = {.lex_state = 524, .external_lex_state = 13},
  [9005] = {.lex_state = 658, .external_lex_state = 25},
  [9006] = {.lex_state = 562, .external_lex_state = 25},
  [9007] = {.lex_state = 524, .external_lex_state = 21},
  [9008] = {.lex_state = 562, .external_lex_state = 25},
  [9009] = {.lex_state = 645, .external_lex_state = 25},
  [9010] = {.lex_state = 654, .external_lex_state = 25},
  [9011] = {.lex_state = 654, .external_lex_state = 25},
  [9012] = {.lex_state = 654, .external_lex_state = 25},
  [9013] = {.lex_state = 654, .external_lex_state = 27},
  [9014] = {.lex_state = 192, .external_lex_state = 2},
  [9015] = {.lex_state = 559, .external_lex_state = 25},
  [9016] = {.lex_state = 559, .external_lex_state = 25},
  [9017] = {.lex_state = 559, .external_lex_state = 25},
  [9018] = {.lex_state = 192, .external_lex_state = 2},
  [9019] = {.lex_state = 192, .external_lex_state = 2},
  [9020] = {.lex_state = 192, .external_lex_state = 2},
  [9021] = {.lex_state = 192, .external_lex_state = 2},
  [9022] = {.lex_state = 192, .external_lex_state = 2},
  [9023] = {.lex_state = 192, .external_lex_state = 2},
  [9024] = {.lex_state = 192, .external_lex_state = 2},
  [9025] = {.lex_state = 192, .external_lex_state = 2},
  [9026] = {.lex_state = 192, .external_lex_state = 2},
  [9027] = {.lex_state = 192, .external_lex_state = 2},
  [9028] = {.lex_state = 192, .external_lex_state = 2},
  [9029] = {.lex_state = 192, .external_lex_state = 2},
  [9030] = {.lex_state = 192, .external_lex_state = 29},
  [9031] = {.lex_state = 192, .external_lex_state = 2},
  [9032] = {.lex_state = 559, .external_lex_state = 27},
  [9033] = {.lex_state = 658, .external_lex_state = 27},
  [9034] = {.lex_state = 192, .external_lex_state = 15},
  [9035] = {.lex_state = 559, .external_lex_state = 25},
  [9036] = {.lex_state = 658, .external_lex_state = 25},
  [9037] = {.lex_state = 658, .external_lex_state = 25},
  [9038] = {.lex_state = 658, .external_lex_state = 25},
  [9039] = {.lex_state = 658, .external_lex_state = 25},
  [9040] = {.lex_state = 658, .external_lex_state = 25},
  [9041] = {.lex_state = 658, .external_lex_state = 25},
  [9042] = {.lex_state = 559, .external_lex_state = 25},
  [9043] = {.lex_state = 554, .external_lex_state = 16},
  [9044] = {.lex_state = 658, .external_lex_state = 25},
  [9045] = {.lex_state = 658, .external_lex_state = 25},
  [9046] = {.lex_state = 658, .external_lex_state = 25},
  [9047] = {.lex_state = 658, .external_lex_state = 25},
  [9048] = {.lex_state = 658, .external_lex_state = 25},
  [9049] = {.lex_state = 559, .external_lex_state = 25},
  [9050] = {.lex_state = 524, .external_lex_state = 21},
  [9051] = {.lex_state = 559, .external_lex_state = 25},
  [9052] = {.lex_state = 559, .external_lex_state = 25},
  [9053] = {.lex_state = 658, .external_lex_state = 25},
  [9054] = {.lex_state = 658, .external_lex_state = 25},
  [9055] = {.lex_state = 658, .external_lex_state = 25},
  [9056] = {.lex_state = 658, .external_lex_state = 27},
  [9057] = {.lex_state = 554, .external_lex_state = 16},
  [9058] = {.lex_state = 554, .external_lex_state = 16},
  [9059] = {.lex_state = 554, .external_lex_state = 16},
  [9060] = {.lex_state = 554, .external_lex_state = 16},
  [9061] = {.lex_state = 192, .external_lex_state = 2},
  [9062] = {.lex_state = 192, .external_lex_state = 2},
  [9063] = {.lex_state = 192, .external_lex_state = 2},
  [9064] = {.lex_state = 192, .external_lex_state = 2},
  [9065] = {.lex_state = 192, .external_lex_state = 2},
  [9066] = {.lex_state = 192, .external_lex_state = 2},
  [9067] = {.lex_state = 192, .external_lex_state = 2},
  [9068] = {.lex_state = 192, .external_lex_state = 2},
  [9069] = {.lex_state = 192, .external_lex_state = 2},
  [9070] = {.lex_state = 192, .external_lex_state = 2},
  [9071] = {.lex_state = 192, .external_lex_state = 2},
  [9072] = {.lex_state = 192, .external_lex_state = 2},
  [9073] = {.lex_state = 192, .external_lex_state = 29},
  [9074] = {.lex_state = 554, .external_lex_state = 16},
  [9075] = {.lex_state = 192, .external_lex_state = 29},
  [9076] = {.lex_state = 192, .external_lex_state = 2},
  [9077] = {.lex_state = 645, .external_lex_state = 20},
  [9078] = {.lex_state = 327, .external_lex_state = 11},
  [9079] = {.lex_state = 299, .external_lex_state = 3},
  [9080] = {.lex_state = 177, .external_lex_state = 4},
  [9081] = {.lex_state = 299, .external_lex_state = 3},
  [9082] = {.lex_state = 299, .external_lex_state = 3},
  [9083] = {.lex_state = 177, .external_lex_state = 4},
  [9084] = {.lex_state = 299, .external_lex_state = 3},
  [9085] = {.lex_state = 227, .external_lex_state = 3},
  [9086] = {.lex_state = 227, .external_lex_state = 3},
  [9087] = {.lex_state = 177, .external_lex_state = 4},
  [9088] = {.lex_state = 266, .external_lex_state = 15},
  [9089] = {.lex_state = 227, .external_lex_state = 3},
  [9090] = {.lex_state = 177, .external_lex_state = 4},
  [9091] = {.lex_state = 227, .external_lex_state = 3},
  [9092] = {.lex_state = 227, .external_lex_state = 3},
  [9093] = {.lex_state = 177, .external_lex_state = 4},
  [9094] = {.lex_state = 266, .external_lex_state = 15},
  [9095] = {.lex_state = 227, .external_lex_state = 3},
  [9096] = {.lex_state = 177, .external_lex_state = 4},
  [9097] = {.lex_state = 227, .external_lex_state = 3},
  [9098] = {.lex_state = 310},
  [9099] = {.lex_state = 227, .external_lex_state = 3},
  [9100] = {.lex_state = 227, .external_lex_state = 3},
  [9101] = {.lex_state = 128, .external_lex_state = 2},
  [9102] = {.lex_state = 128, .external_lex_state = 2},
  [9103] = {.lex_state = 227, .external_lex_state = 3},
  [9104] = {.lex_state = 227, .external_lex_state = 3},
  [9105] = {.lex_state = 227, .external_lex_state = 3},
  [9106] = {.lex_state = 128},
  [9107] = {.lex_state = 128},
  [9108] = {.lex_state = 128, .external_lex_state = 2},
  [9109] = {.lex_state = 227, .external_lex_state = 3},
  [9110] = {.lex_state = 128},
  [9111] = {.lex_state = 128},
  [9112] = {.lex_state = 227, .external_lex_state = 3},
  [9113] = {.lex_state = 128},
  [9114] = {.lex_state = 227, .external_lex_state = 3},
  [9115] = {.lex_state = 128},
  [9116] = {.lex_state = 128, .external_lex_state = 2},
  [9117] = {.lex_state = 128},
  [9118] = {.lex_state = 128},
  [9119] = {.lex_state = 227, .external_lex_state = 3},
  [9120] = {.lex_state = 227, .external_lex_state = 3},
  [9121] = {.lex_state = 128},
  [9122] = {.lex_state = 128},
  [9123] = {.lex_state = 227, .external_lex_state = 3},
  [9124] = {.lex_state = 192, .external_lex_state = 2},
  [9125] = {.lex_state = 192, .external_lex_state = 29},
  [9126] = {.lex_state = 424, .external_lex_state = 3},
  [9127] = {.lex_state = 588, .external_lex_state = 3},
  [9128] = {.lex_state = 588, .external_lex_state = 3},
  [9129] = {.lex_state = 455, .external_lex_state = 3},
  [9130] = {.lex_state = 524, .external_lex_state = 21},
  [9131] = {.lex_state = 455, .external_lex_state = 3},
  [9132] = {.lex_state = 588, .external_lex_state = 3},
  [9133] = {.lex_state = 192, .external_lex_state = 2},
  [9134] = {.lex_state = 573, .external_lex_state = 3},
  [9135] = {.lex_state = 573, .external_lex_state = 3},
  [9136] = {.lex_state = 573, .external_lex_state = 3},
  [9137] = {.lex_state = 524, .external_lex_state = 21},
  [9138] = {.lex_state = 573, .external_lex_state = 3},
  [9139] = {.lex_state = 573, .external_lex_state = 3},
  [9140] = {.lex_state = 436, .external_lex_state = 3},
  [9141] = {.lex_state = 436, .external_lex_state = 3},
  [9142] = {.lex_state = 436, .external_lex_state = 3},
  [9143] = {.lex_state = 436, .external_lex_state = 3},
  [9144] = {.lex_state = 192, .external_lex_state = 2},
  [9145] = {.lex_state = 192, .external_lex_state = 2},
  [9146] = {.lex_state = 192, .external_lex_state = 2},
  [9147] = {.lex_state = 192, .external_lex_state = 2},
  [9148] = {.lex_state = 192, .external_lex_state = 2},
  [9149] = {.lex_state = 192, .external_lex_state = 2},
  [9150] = {.lex_state = 192, .external_lex_state = 2},
  [9151] = {.lex_state = 192, .external_lex_state = 2},
  [9152] = {.lex_state = 192, .external_lex_state = 2},
  [9153] = {.lex_state = 192, .external_lex_state = 2},
  [9154] = {.lex_state = 192, .external_lex_state = 2},
  [9155] = {.lex_state = 192, .external_lex_state = 2},
  [9156] = {.lex_state = 192, .external_lex_state = 29},
  [9157] = {.lex_state = 436, .external_lex_state = 3},
  [9158] = {.lex_state = 192, .external_lex_state = 29},
  [9159] = {.lex_state = 192, .external_lex_state = 2},
  [9160] = {.lex_state = 225, .external_lex_state = 7},
  [9161] = {.lex_state = 299, .external_lex_state = 3},
  [9162] = {.lex_state = 299, .external_lex_state = 3},
  [9163] = {.lex_state = 299, .external_lex_state = 3},
  [9164] = {.lex_state = 128},
  [9165] = {.lex_state = 128},
  [9166] = {.lex_state = 299, .external_lex_state = 3},
  [9167] = {.lex_state = 128},
  [9168] = {.lex_state = 299, .external_lex_state = 3},
  [9169] = {.lex_state = 299, .external_lex_state = 3},
  [9170] = {.lex_state = 299, .external_lex_state = 3},
  [9171] = {.lex_state = 128},
  [9172] = {.lex_state = 227, .external_lex_state = 3},
  [9173] = {.lex_state = 128},
  [9174] = {.lex_state = 299, .external_lex_state = 3},
  [9175] = {.lex_state = 128},
  [9176] = {.lex_state = 299, .external_lex_state = 3},
  [9177] = {.lex_state = 128},
  [9178] = {.lex_state = 421, .external_lex_state = 3},
  [9179] = {.lex_state = 299, .external_lex_state = 3},
  [9180] = {.lex_state = 421, .external_lex_state = 3},
  [9181] = {.lex_state = 192, .external_lex_state = 2},
  [9182] = {.lex_state = 467, .external_lex_state = 25},
  [9183] = {.lex_state = 467, .external_lex_state = 25},
  [9184] = {.lex_state = 467, .external_lex_state = 25},
  [9185] = {.lex_state = 467, .external_lex_state = 25},
  [9186] = {.lex_state = 467, .external_lex_state = 25},
  [9187] = {.lex_state = 467, .external_lex_state = 25},
  [9188] = {.lex_state = 467, .external_lex_state = 25},
  [9189] = {.lex_state = 467, .external_lex_state = 25},
  [9190] = {.lex_state = 554, .external_lex_state = 16},
  [9191] = {.lex_state = 467, .external_lex_state = 25},
  [9192] = {.lex_state = 467, .external_lex_state = 25},
  [9193] = {.lex_state = 467, .external_lex_state = 25},
  [9194] = {.lex_state = 467, .external_lex_state = 25},
  [9195] = {.lex_state = 467, .external_lex_state = 25},
  [9196] = {.lex_state = 467, .external_lex_state = 25},
  [9197] = {.lex_state = 467, .external_lex_state = 25},
  [9198] = {.lex_state = 467, .external_lex_state = 25},
  [9199] = {.lex_state = 467, .external_lex_state = 27},
  [9200] = {.lex_state = 588, .external_lex_state = 25},
  [9201] = {.lex_state = 588, .external_lex_state = 25},
  [9202] = {.lex_state = 588, .external_lex_state = 25},
  [9203] = {.lex_state = 524, .external_lex_state = 21},
  [9204] = {.lex_state = 588, .external_lex_state = 25},
  [9205] = {.lex_state = 588, .external_lex_state = 25},
  [9206] = {.lex_state = 192, .external_lex_state = 2},
  [9207] = {.lex_state = 573, .external_lex_state = 25},
  [9208] = {.lex_state = 573, .external_lex_state = 25},
  [9209] = {.lex_state = 573, .external_lex_state = 25},
  [9210] = {.lex_state = 524, .external_lex_state = 21},
  [9211] = {.lex_state = 573, .external_lex_state = 25},
  [9212] = {.lex_state = 573, .external_lex_state = 25},
  [9213] = {.lex_state = 192, .external_lex_state = 29},
  [9214] = {.lex_state = 588, .external_lex_state = 25},
  [9215] = {.lex_state = 436, .external_lex_state = 16},
  [9216] = {.lex_state = 579, .external_lex_state = 18},
  [9217] = {.lex_state = 209},
  [9218] = {.lex_state = 433, .external_lex_state = 16},
  [9219] = {.lex_state = 461, .external_lex_state = 27},
  [9220] = {.lex_state = 461, .external_lex_state = 25},
  [9221] = {.lex_state = 461, .external_lex_state = 25},
  [9222] = {.lex_state = 461, .external_lex_state = 25},
  [9223] = {.lex_state = 461, .external_lex_state = 25},
  [9224] = {.lex_state = 192, .external_lex_state = 15},
  [9225] = {.lex_state = 266, .external_lex_state = 15},
  [9226] = {.lex_state = 461, .external_lex_state = 25},
  [9227] = {.lex_state = 177, .external_lex_state = 4},
  [9228] = {.lex_state = 266, .external_lex_state = 15},
  [9229] = {.lex_state = 461, .external_lex_state = 25},
  [9230] = {.lex_state = 192, .external_lex_state = 15},
  [9231] = {.lex_state = 266, .external_lex_state = 15},
  [9232] = {.lex_state = 461, .external_lex_state = 25},
  [9233] = {.lex_state = 177, .external_lex_state = 4},
  [9234] = {.lex_state = 266, .external_lex_state = 15},
  [9235] = {.lex_state = 461, .external_lex_state = 25},
  [9236] = {.lex_state = 194},
  [9237] = {.lex_state = 302, .external_lex_state = 16},
  [9238] = {.lex_state = 225, .external_lex_state = 7},
  [9239] = {.lex_state = 128, .external_lex_state = 2},
  [9240] = {.lex_state = 461, .external_lex_state = 25},
  [9241] = {.lex_state = 247, .external_lex_state = 3},
  [9242] = {.lex_state = 128, .external_lex_state = 8},
  [9243] = {.lex_state = 128, .external_lex_state = 2},
  [9244] = {.lex_state = 461, .external_lex_state = 25},
  [9245] = {.lex_state = 128, .external_lex_state = 2},
  [9246] = {.lex_state = 128, .external_lex_state = 12},
  [9247] = {.lex_state = 128, .external_lex_state = 2},
  [9248] = {.lex_state = 128, .external_lex_state = 2},
  [9249] = {.lex_state = 128, .external_lex_state = 2},
  [9250] = {.lex_state = 128, .external_lex_state = 8},
  [9251] = {.lex_state = 128},
  [9252] = {.lex_state = 128},
  [9253] = {.lex_state = 128},
  [9254] = {.lex_state = 461, .external_lex_state = 25},
  [9255] = {.lex_state = 128},
  [9256] = {.lex_state = 128},
  [9257] = {.lex_state = 128},
  [9258] = {.lex_state = 461, .external_lex_state = 25},
  [9259] = {.lex_state = 461, .external_lex_state = 25},
  [9260] = {.lex_state = 235},
  [9261] = {.lex_state = 461, .external_lex_state = 25},
  [9262] = {.lex_state = 441, .external_lex_state = 25},
  [9263] = {.lex_state = 441, .external_lex_state = 25},
  [9264] = {.lex_state = 441, .external_lex_state = 25},
  [9265] = {.lex_state = 441, .external_lex_state = 25},
  [9266] = {.lex_state = 441, .external_lex_state = 25},
  [9267] = {.lex_state = 441, .external_lex_state = 25},
  [9268] = {.lex_state = 554, .external_lex_state = 16},
  [9269] = {.lex_state = 441, .external_lex_state = 25},
  [9270] = {.lex_state = 441, .external_lex_state = 25},
  [9271] = {.lex_state = 441, .external_lex_state = 25},
  [9272] = {.lex_state = 441, .external_lex_state = 25},
  [9273] = {.lex_state = 441, .external_lex_state = 25},
  [9274] = {.lex_state = 441, .external_lex_state = 25},
  [9275] = {.lex_state = 461, .external_lex_state = 25},
  [9276] = {.lex_state = 441, .external_lex_state = 25},
  [9277] = {.lex_state = 441, .external_lex_state = 25},
  [9278] = {.lex_state = 441, .external_lex_state = 27},
  [9279] = {.lex_state = 433, .external_lex_state = 16},
  [9280] = {.lex_state = 433, .external_lex_state = 16},
  [9281] = {.lex_state = 128},
  [9282] = {.lex_state = 128, .external_lex_state = 2},
  [9283] = {.lex_state = 461, .external_lex_state = 25},
  [9284] = {.lex_state = 192, .external_lex_state = 2},
  [9285] = {.lex_state = 461, .external_lex_state = 25},
  [9286] = {.lex_state = 461, .external_lex_state = 25},
  [9287] = {.lex_state = 192, .external_lex_state = 29},
  [9288] = {.lex_state = 573, .external_lex_state = 25},
  [9289] = {.lex_state = 436, .external_lex_state = 16},
  [9290] = {.lex_state = 436, .external_lex_state = 16},
  [9291] = {.lex_state = 436, .external_lex_state = 16},
  [9292] = {.lex_state = 436, .external_lex_state = 16},
  [9293] = {.lex_state = 436, .external_lex_state = 16},
  [9294] = {.lex_state = 436, .external_lex_state = 16},
  [9295] = {.lex_state = 554, .external_lex_state = 16},
  [9296] = {.lex_state = 436, .external_lex_state = 16},
  [9297] = {.lex_state = 436, .external_lex_state = 16},
  [9298] = {.lex_state = 436, .external_lex_state = 16},
  [9299] = {.lex_state = 436, .external_lex_state = 16},
  [9300] = {.lex_state = 436, .external_lex_state = 16},
  [9301] = {.lex_state = 436, .external_lex_state = 16},
  [9302] = {.lex_state = 436, .external_lex_state = 16},
  [9303] = {.lex_state = 436, .external_lex_state = 16},
  [9304] = {.lex_state = 467, .external_lex_state = 20},
  [9305] = {.lex_state = 467, .external_lex_state = 3},
  [9306] = {.lex_state = 467, .external_lex_state = 3},
  [9307] = {.lex_state = 467, .external_lex_state = 3},
  [9308] = {.lex_state = 467, .external_lex_state = 3},
  [9309] = {.lex_state = 467, .external_lex_state = 3},
  [9310] = {.lex_state = 467, .external_lex_state = 3},
  [9311] = {.lex_state = 467, .external_lex_state = 3},
  [9312] = {.lex_state = 467, .external_lex_state = 3},
  [9313] = {.lex_state = 554, .external_lex_state = 16},
  [9314] = {.lex_state = 467, .external_lex_state = 3},
  [9315] = {.lex_state = 467, .external_lex_state = 3},
  [9316] = {.lex_state = 467, .external_lex_state = 3},
  [9317] = {.lex_state = 467, .external_lex_state = 3},
  [9318] = {.lex_state = 467, .external_lex_state = 3},
  [9319] = {.lex_state = 467, .external_lex_state = 3},
  [9320] = {.lex_state = 467, .external_lex_state = 3},
  [9321] = {.lex_state = 467, .external_lex_state = 3},
  [9322] = {.lex_state = 467, .external_lex_state = 14},
  [9323] = {.lex_state = 588, .external_lex_state = 3},
  [9324] = {.lex_state = 588, .external_lex_state = 3},
  [9325] = {.lex_state = 192, .external_lex_state = 2},
  [9326] = {.lex_state = 192, .external_lex_state = 29},
  [9327] = {.lex_state = 588, .external_lex_state = 3},
  [9328] = {.lex_state = 436, .external_lex_state = 3},
  [9329] = {.lex_state = 441, .external_lex_state = 3},
  [9330] = {.lex_state = 441, .external_lex_state = 3},
  [9331] = {.lex_state = 441, .external_lex_state = 3},
  [9332] = {.lex_state = 441, .external_lex_state = 3},
  [9333] = {.lex_state = 441, .external_lex_state = 3},
  [9334] = {.lex_state = 441, .external_lex_state = 3},
  [9335] = {.lex_state = 554, .external_lex_state = 16},
  [9336] = {.lex_state = 441, .external_lex_state = 3},
  [9337] = {.lex_state = 441, .external_lex_state = 3},
  [9338] = {.lex_state = 441, .external_lex_state = 3},
  [9339] = {.lex_state = 441, .external_lex_state = 3},
  [9340] = {.lex_state = 441, .external_lex_state = 3},
  [9341] = {.lex_state = 441, .external_lex_state = 3},
  [9342] = {.lex_state = 441, .external_lex_state = 3},
  [9343] = {.lex_state = 441, .external_lex_state = 3},
  [9344] = {.lex_state = 441, .external_lex_state = 14},
  [9345] = {.lex_state = 192, .external_lex_state = 2},
  [9346] = {.lex_state = 192, .external_lex_state = 29},
  [9347] = {.lex_state = 573, .external_lex_state = 3},
  [9348] = {.lex_state = 436, .external_lex_state = 3},
  [9349] = {.lex_state = 436, .external_lex_state = 3},
  [9350] = {.lex_state = 436, .external_lex_state = 3},
  [9351] = {.lex_state = 436, .external_lex_state = 3},
  [9352] = {.lex_state = 436, .external_lex_state = 3},
  [9353] = {.lex_state = 436, .external_lex_state = 3},
  [9354] = {.lex_state = 554, .external_lex_state = 16},
  [9355] = {.lex_state = 436, .external_lex_state = 3},
  [9356] = {.lex_state = 436, .external_lex_state = 3},
  [9357] = {.lex_state = 436, .external_lex_state = 3},
  [9358] = {.lex_state = 436, .external_lex_state = 3},
  [9359] = {.lex_state = 436, .external_lex_state = 3},
  [9360] = {.lex_state = 436, .external_lex_state = 3},
  [9361] = {.lex_state = 436, .external_lex_state = 3},
  [9362] = {.lex_state = 436, .external_lex_state = 3},
  [9363] = {.lex_state = 288, .external_lex_state = 16},
  [9364] = {.lex_state = 288, .external_lex_state = 16},
  [9365] = {.lex_state = 288, .external_lex_state = 16},
  [9366] = {.lex_state = 467, .external_lex_state = 25},
  [9367] = {.lex_state = 467, .external_lex_state = 25},
  [9368] = {.lex_state = 467, .external_lex_state = 25},
  [9369] = {.lex_state = 467, .external_lex_state = 25},
  [9370] = {.lex_state = 467, .external_lex_state = 25},
  [9371] = {.lex_state = 467, .external_lex_state = 25},
  [9372] = {.lex_state = 554, .external_lex_state = 16},
  [9373] = {.lex_state = 467, .external_lex_state = 25},
  [9374] = {.lex_state = 467, .external_lex_state = 25},
  [9375] = {.lex_state = 467, .external_lex_state = 25},
  [9376] = {.lex_state = 467, .external_lex_state = 25},
  [9377] = {.lex_state = 467, .external_lex_state = 25},
  [9378] = {.lex_state = 467, .external_lex_state = 25},
  [9379] = {.lex_state = 467, .external_lex_state = 25},
  [9380] = {.lex_state = 467, .external_lex_state = 25},
  [9381] = {.lex_state = 588, .external_lex_state = 25},
  [9382] = {.lex_state = 588, .external_lex_state = 25},
  [9383] = {.lex_state = 588, .external_lex_state = 25},
  [9384] = {.lex_state = 524, .external_lex_state = 21},
  [9385] = {.lex_state = 588, .external_lex_state = 25},
  [9386] = {.lex_state = 588, .external_lex_state = 25},
  [9387] = {.lex_state = 192, .external_lex_state = 2},
  [9388] = {.lex_state = 573, .external_lex_state = 25},
  [9389] = {.lex_state = 573, .external_lex_state = 25},
  [9390] = {.lex_state = 573, .external_lex_state = 25},
  [9391] = {.lex_state = 524, .external_lex_state = 21},
  [9392] = {.lex_state = 573, .external_lex_state = 25},
  [9393] = {.lex_state = 573, .external_lex_state = 25},
  [9394] = {.lex_state = 192, .external_lex_state = 29},
  [9395] = {.lex_state = 588, .external_lex_state = 25},
  [9396] = {.lex_state = 436, .external_lex_state = 25},
  [9397] = {.lex_state = 595, .external_lex_state = 26},
  [9398] = {.lex_state = 209},
  [9399] = {.lex_state = 461, .external_lex_state = 25},
  [9400] = {.lex_state = 441, .external_lex_state = 25},
  [9401] = {.lex_state = 441, .external_lex_state = 25},
  [9402] = {.lex_state = 441, .external_lex_state = 25},
  [9403] = {.lex_state = 441, .external_lex_state = 25},
  [9404] = {.lex_state = 441, .external_lex_state = 25},
  [9405] = {.lex_state = 441, .external_lex_state = 25},
  [9406] = {.lex_state = 554, .external_lex_state = 16},
  [9407] = {.lex_state = 441, .external_lex_state = 25},
  [9408] = {.lex_state = 441, .external_lex_state = 25},
  [9409] = {.lex_state = 441, .external_lex_state = 25},
  [9410] = {.lex_state = 441, .external_lex_state = 25},
  [9411] = {.lex_state = 441, .external_lex_state = 25},
  [9412] = {.lex_state = 441, .external_lex_state = 25},
  [9413] = {.lex_state = 441, .external_lex_state = 25},
  [9414] = {.lex_state = 441, .external_lex_state = 25},
  [9415] = {.lex_state = 441, .external_lex_state = 27},
  [9416] = {.lex_state = 461, .external_lex_state = 25},
  [9417] = {.lex_state = 461, .external_lex_state = 25},
  [9418] = {.lex_state = 128},
  [9419] = {.lex_state = 128, .external_lex_state = 2},
  [9420] = {.lex_state = 192, .external_lex_state = 2},
  [9421] = {.lex_state = 192, .external_lex_state = 29},
  [9422] = {.lex_state = 573, .external_lex_state = 25},
  [9423] = {.lex_state = 436, .external_lex_state = 25},
  [9424] = {.lex_state = 361, .external_lex_state = 25},
  [9425] = {.lex_state = 388, .external_lex_state = 25},
  [9426] = {.lex_state = 361, .external_lex_state = 25},
  [9427] = {.lex_state = 288, .external_lex_state = 16},
  [9428] = {.lex_state = 128},
  [9429] = {.lex_state = 288, .external_lex_state = 16},
  [9430] = {.lex_state = 288, .external_lex_state = 16},
  [9431] = {.lex_state = 288, .external_lex_state = 16},
  [9432] = {.lex_state = 288, .external_lex_state = 16},
  [9433] = {.lex_state = 288, .external_lex_state = 16},
  [9434] = {.lex_state = 128},
  [9435] = {.lex_state = 304, .external_lex_state = 18},
  [9436] = {.lex_state = 397, .external_lex_state = 25},
  [9437] = {.lex_state = 177, .external_lex_state = 4},
  [9438] = {.lex_state = 397, .external_lex_state = 25},
  [9439] = {.lex_state = 397, .external_lex_state = 25},
  [9440] = {.lex_state = 177, .external_lex_state = 4},
  [9441] = {.lex_state = 397, .external_lex_state = 25},
  [9442] = {.lex_state = 225, .external_lex_state = 7},
  [9443] = {.lex_state = 397, .external_lex_state = 25},
  [9444] = {.lex_state = 397, .external_lex_state = 25},
  [9445] = {.lex_state = 397, .external_lex_state = 25},
  [9446] = {.lex_state = 128},
  [9447] = {.lex_state = 128},
  [9448] = {.lex_state = 397, .external_lex_state = 25},
  [9449] = {.lex_state = 128},
  [9450] = {.lex_state = 397, .external_lex_state = 25},
  [9451] = {.lex_state = 397, .external_lex_state = 25},
  [9452] = {.lex_state = 397, .external_lex_state = 25},
  [9453] = {.lex_state = 128},
  [9454] = {.lex_state = 299, .external_lex_state = 16},
  [9455] = {.lex_state = 128},
  [9456] = {.lex_state = 397, .external_lex_state = 25},
  [9457] = {.lex_state = 128},
  [9458] = {.lex_state = 397, .external_lex_state = 25},
  [9459] = {.lex_state = 128},
  [9460] = {.lex_state = 421, .external_lex_state = 25},
  [9461] = {.lex_state = 397, .external_lex_state = 25},
  [9462] = {.lex_state = 421, .external_lex_state = 25},
  [9463] = {.lex_state = 192, .external_lex_state = 2},
  [9464] = {.lex_state = 493, .external_lex_state = 25},
  [9465] = {.lex_state = 493, .external_lex_state = 25},
  [9466] = {.lex_state = 493, .external_lex_state = 25},
  [9467] = {.lex_state = 493, .external_lex_state = 25},
  [9468] = {.lex_state = 493, .external_lex_state = 25},
  [9469] = {.lex_state = 493, .external_lex_state = 25},
  [9470] = {.lex_state = 554, .external_lex_state = 16},
  [9471] = {.lex_state = 493, .external_lex_state = 25},
  [9472] = {.lex_state = 493, .external_lex_state = 25},
  [9473] = {.lex_state = 493, .external_lex_state = 25},
  [9474] = {.lex_state = 493, .external_lex_state = 25},
  [9475] = {.lex_state = 493, .external_lex_state = 25},
  [9476] = {.lex_state = 493, .external_lex_state = 25},
  [9477] = {.lex_state = 493, .external_lex_state = 25},
  [9478] = {.lex_state = 493, .external_lex_state = 25},
  [9479] = {.lex_state = 192, .external_lex_state = 2},
  [9480] = {.lex_state = 192, .external_lex_state = 29},
  [9481] = {.lex_state = 493, .external_lex_state = 25},
  [9482] = {.lex_state = 302, .external_lex_state = 16},
  [9483] = {.lex_state = 321, .external_lex_state = 25},
  [9484] = {.lex_state = 321, .external_lex_state = 25},
  [9485] = {.lex_state = 321, .external_lex_state = 25},
  [9486] = {.lex_state = 321, .external_lex_state = 25},
  [9487] = {.lex_state = 321, .external_lex_state = 25},
  [9488] = {.lex_state = 321, .external_lex_state = 25},
  [9489] = {.lex_state = 554, .external_lex_state = 16},
  [9490] = {.lex_state = 321, .external_lex_state = 25},
  [9491] = {.lex_state = 321, .external_lex_state = 25},
  [9492] = {.lex_state = 321, .external_lex_state = 25},
  [9493] = {.lex_state = 321, .external_lex_state = 25},
  [9494] = {.lex_state = 321, .external_lex_state = 25},
  [9495] = {.lex_state = 321, .external_lex_state = 25},
  [9496] = {.lex_state = 321, .external_lex_state = 25},
  [9497] = {.lex_state = 321, .external_lex_state = 25},
  [9498] = {.lex_state = 321, .external_lex_state = 27},
  [9499] = {.lex_state = 192, .external_lex_state = 2},
  [9500] = {.lex_state = 192, .external_lex_state = 29},
  [9501] = {.lex_state = 497, .external_lex_state = 25},
  [9502] = {.lex_state = 302, .external_lex_state = 16},
  [9503] = {.lex_state = 302, .external_lex_state = 16},
  [9504] = {.lex_state = 302, .external_lex_state = 16},
  [9505] = {.lex_state = 302, .external_lex_state = 16},
  [9506] = {.lex_state = 302, .external_lex_state = 16},
  [9507] = {.lex_state = 302, .external_lex_state = 16},
  [9508] = {.lex_state = 554, .external_lex_state = 16},
  [9509] = {.lex_state = 302, .external_lex_state = 16},
  [9510] = {.lex_state = 302, .external_lex_state = 16},
  [9511] = {.lex_state = 302, .external_lex_state = 16},
  [9512] = {.lex_state = 302, .external_lex_state = 16},
  [9513] = {.lex_state = 302, .external_lex_state = 16},
  [9514] = {.lex_state = 302, .external_lex_state = 16},
  [9515] = {.lex_state = 302, .external_lex_state = 16},
  [9516] = {.lex_state = 302, .external_lex_state = 16},
  [9517] = {.lex_state = 610, .external_lex_state = 20},
  [9518] = {.lex_state = 128, .external_lex_state = 2},
  [9519] = {.lex_state = 678, .external_lex_state = 8},
  [9520] = {.lex_state = 194},
  [9521] = {.lex_state = 678, .external_lex_state = 8},
  [9522] = {.lex_state = 128},
  [9523] = {.lex_state = 128, .external_lex_state = 2},
  [9524] = {.lex_state = 128, .external_lex_state = 12},
  [9525] = {.lex_state = 254, .external_lex_state = 8},
  [9526] = {.lex_state = 302},
  [9527] = {.lex_state = 254, .external_lex_state = 8},
  [9528] = {.lex_state = 254, .external_lex_state = 8},
  [9529] = {.lex_state = 621, .external_lex_state = 25},
  [9530] = {.lex_state = 621, .external_lex_state = 25},
  [9531] = {.lex_state = 192, .external_lex_state = 2},
  [9532] = {.lex_state = 621, .external_lex_state = 25},
  [9533] = {.lex_state = 192, .external_lex_state = 2},
  [9534] = {.lex_state = 621, .external_lex_state = 25},
  [9535] = {.lex_state = 524, .external_lex_state = 13},
  [9536] = {.lex_state = 621, .external_lex_state = 25},
  [9537] = {.lex_state = 621, .external_lex_state = 25},
  [9538] = {.lex_state = 621, .external_lex_state = 25},
  [9539] = {.lex_state = 621, .external_lex_state = 25},
  [9540] = {.lex_state = 621, .external_lex_state = 25},
  [9541] = {.lex_state = 621, .external_lex_state = 25},
  [9542] = {.lex_state = 621, .external_lex_state = 25},
  [9543] = {.lex_state = 554, .external_lex_state = 16},
  [9544] = {.lex_state = 621, .external_lex_state = 25},
  [9545] = {.lex_state = 621, .external_lex_state = 25},
  [9546] = {.lex_state = 621, .external_lex_state = 25},
  [9547] = {.lex_state = 621, .external_lex_state = 25},
  [9548] = {.lex_state = 621, .external_lex_state = 25},
  [9549] = {.lex_state = 621, .external_lex_state = 25},
  [9550] = {.lex_state = 621, .external_lex_state = 25},
  [9551] = {.lex_state = 621, .external_lex_state = 25},
  [9552] = {.lex_state = 621, .external_lex_state = 27},
  [9553] = {.lex_state = 604, .external_lex_state = 25},
  [9554] = {.lex_state = 604, .external_lex_state = 25},
  [9555] = {.lex_state = 604, .external_lex_state = 25},
  [9556] = {.lex_state = 524, .external_lex_state = 21},
  [9557] = {.lex_state = 604, .external_lex_state = 25},
  [9558] = {.lex_state = 604, .external_lex_state = 25},
  [9559] = {.lex_state = 192, .external_lex_state = 2},
  [9560] = {.lex_state = 192, .external_lex_state = 29},
  [9561] = {.lex_state = 604, .external_lex_state = 25},
  [9562] = {.lex_state = 493, .external_lex_state = 3},
  [9563] = {.lex_state = 493, .external_lex_state = 3},
  [9564] = {.lex_state = 192, .external_lex_state = 2},
  [9565] = {.lex_state = 192, .external_lex_state = 29},
  [9566] = {.lex_state = 493, .external_lex_state = 3},
  [9567] = {.lex_state = 493, .external_lex_state = 3},
  [9568] = {.lex_state = 493, .external_lex_state = 3},
  [9569] = {.lex_state = 192, .external_lex_state = 2},
  [9570] = {.lex_state = 192, .external_lex_state = 29},
  [9571] = {.lex_state = 321, .external_lex_state = 3},
  [9572] = {.lex_state = 497, .external_lex_state = 3},
  [9573] = {.lex_state = 497, .external_lex_state = 3},
  [9574] = {.lex_state = 192, .external_lex_state = 2},
  [9575] = {.lex_state = 330},
  [9576] = {.lex_state = 330},
  [9577] = {.lex_state = 330},
  [9578] = {.lex_state = 361, .external_lex_state = 25},
  [9579] = {.lex_state = 361, .external_lex_state = 25},
  [9580] = {.lex_state = 361, .external_lex_state = 25},
  [9581] = {.lex_state = 524, .external_lex_state = 21},
  [9582] = {.lex_state = 361, .external_lex_state = 25},
  [9583] = {.lex_state = 361, .external_lex_state = 25},
  [9584] = {.lex_state = 192, .external_lex_state = 2},
  [9585] = {.lex_state = 424, .external_lex_state = 25},
  [9586] = {.lex_state = 424, .external_lex_state = 25},
  [9587] = {.lex_state = 424, .external_lex_state = 25},
  [9588] = {.lex_state = 192, .external_lex_state = 2},
  [9589] = {.lex_state = 192, .external_lex_state = 2},
  [9590] = {.lex_state = 192, .external_lex_state = 2},
  [9591] = {.lex_state = 192, .external_lex_state = 2},
  [9592] = {.lex_state = 192, .external_lex_state = 2},
  [9593] = {.lex_state = 192, .external_lex_state = 2},
  [9594] = {.lex_state = 192, .external_lex_state = 2},
  [9595] = {.lex_state = 192, .external_lex_state = 2},
  [9596] = {.lex_state = 192, .external_lex_state = 2},
  [9597] = {.lex_state = 192, .external_lex_state = 2},
  [9598] = {.lex_state = 192, .external_lex_state = 2},
  [9599] = {.lex_state = 192, .external_lex_state = 2},
  [9600] = {.lex_state = 192, .external_lex_state = 29},
  [9601] = {.lex_state = 192, .external_lex_state = 2},
  [9602] = {.lex_state = 424, .external_lex_state = 27},
  [9603] = {.lex_state = 424, .external_lex_state = 25},
  [9604] = {.lex_state = 424, .external_lex_state = 25},
  [9605] = {.lex_state = 424, .external_lex_state = 25},
  [9606] = {.lex_state = 524, .external_lex_state = 21},
  [9607] = {.lex_state = 424, .external_lex_state = 25},
  [9608] = {.lex_state = 424, .external_lex_state = 25},
  [9609] = {.lex_state = 192, .external_lex_state = 29},
  [9610] = {.lex_state = 361, .external_lex_state = 25},
  [9611] = {.lex_state = 330},
  [9612] = {.lex_state = 128},
  [9613] = {.lex_state = 330},
  [9614] = {.lex_state = 330},
  [9615] = {.lex_state = 330},
  [9616] = {.lex_state = 330},
  [9617] = {.lex_state = 337},
  [9618] = {.lex_state = 128},
  [9619] = {.lex_state = 484, .external_lex_state = 21},
  [9620] = {.lex_state = 621, .external_lex_state = 25},
  [9621] = {.lex_state = 621, .external_lex_state = 25},
  [9622] = {.lex_state = 177, .external_lex_state = 4},
  [9623] = {.lex_state = 266, .external_lex_state = 15},
  [9624] = {.lex_state = 621, .external_lex_state = 25},
  [9625] = {.lex_state = 177, .external_lex_state = 4},
  [9626] = {.lex_state = 621, .external_lex_state = 25},
  [9627] = {.lex_state = 621, .external_lex_state = 25},
  [9628] = {.lex_state = 177, .external_lex_state = 4},
  [9629] = {.lex_state = 266, .external_lex_state = 15},
  [9630] = {.lex_state = 621, .external_lex_state = 25},
  [9631] = {.lex_state = 177, .external_lex_state = 4},
  [9632] = {.lex_state = 621, .external_lex_state = 25},
  [9633] = {.lex_state = 310},
  [9634] = {.lex_state = 621, .external_lex_state = 25},
  [9635] = {.lex_state = 621, .external_lex_state = 25},
  [9636] = {.lex_state = 128, .external_lex_state = 2},
  [9637] = {.lex_state = 128, .external_lex_state = 2},
  [9638] = {.lex_state = 621, .external_lex_state = 25},
  [9639] = {.lex_state = 621, .external_lex_state = 25},
  [9640] = {.lex_state = 627, .external_lex_state = 25},
  [9641] = {.lex_state = 621, .external_lex_state = 25},
  [9642] = {.lex_state = 209},
  [9643] = {.lex_state = 627, .external_lex_state = 25},
  [9644] = {.lex_state = 621, .external_lex_state = 25},
  [9645] = {.lex_state = 177, .external_lex_state = 17},
  [9646] = {.lex_state = 627, .external_lex_state = 25},
  [9647] = {.lex_state = 621, .external_lex_state = 25},
  [9648] = {.lex_state = 524, .external_lex_state = 21},
  [9649] = {.lex_state = 627, .external_lex_state = 25},
  [9650] = {.lex_state = 627, .external_lex_state = 25},
  [9651] = {.lex_state = 621, .external_lex_state = 25},
  [9652] = {.lex_state = 128},
  [9653] = {.lex_state = 128},
  [9654] = {.lex_state = 128, .external_lex_state = 2},
  [9655] = {.lex_state = 621, .external_lex_state = 25},
  [9656] = {.lex_state = 128},
  [9657] = {.lex_state = 128},
  [9658] = {.lex_state = 621, .external_lex_state = 25},
  [9659] = {.lex_state = 128},
  [9660] = {.lex_state = 621, .external_lex_state = 25},
  [9661] = {.lex_state = 128},
  [9662] = {.lex_state = 128, .external_lex_state = 2},
  [9663] = {.lex_state = 128},
  [9664] = {.lex_state = 128},
  [9665] = {.lex_state = 621, .external_lex_state = 25},
  [9666] = {.lex_state = 621, .external_lex_state = 25},
  [9667] = {.lex_state = 128},
  [9668] = {.lex_state = 128},
  [9669] = {.lex_state = 621, .external_lex_state = 25},
  [9670] = {.lex_state = 621, .external_lex_state = 25},
  [9671] = {.lex_state = 194},
  [9672] = {.lex_state = 621, .external_lex_state = 25},
  [9673] = {.lex_state = 128},
  [9674] = {.lex_state = 128, .external_lex_state = 2},
  [9675] = {.lex_state = 128, .external_lex_state = 12},
  [9676] = {.lex_state = 192, .external_lex_state = 2},
  [9677] = {.lex_state = 192, .external_lex_state = 29},
  [9678] = {.lex_state = 627, .external_lex_state = 25},
  [9679] = {.lex_state = 505, .external_lex_state = 25},
  [9680] = {.lex_state = 505, .external_lex_state = 25},
  [9681] = {.lex_state = 508, .external_lex_state = 25},
  [9682] = {.lex_state = 508, .external_lex_state = 25},
  [9683] = {.lex_state = 508, .external_lex_state = 25},
  [9684] = {.lex_state = 524, .external_lex_state = 21},
  [9685] = {.lex_state = 508, .external_lex_state = 25},
  [9686] = {.lex_state = 508, .external_lex_state = 25},
  [9687] = {.lex_state = 192, .external_lex_state = 2},
  [9688] = {.lex_state = 192, .external_lex_state = 29},
  [9689] = {.lex_state = 508, .external_lex_state = 25},
  [9690] = {.lex_state = 508, .external_lex_state = 25},
  [9691] = {.lex_state = 508, .external_lex_state = 25},
  [9692] = {.lex_state = 365, .external_lex_state = 3},
  [9693] = {.lex_state = 365, .external_lex_state = 3},
  [9694] = {.lex_state = 493, .external_lex_state = 25},
  [9695] = {.lex_state = 493, .external_lex_state = 25},
  [9696] = {.lex_state = 192, .external_lex_state = 2},
  [9697] = {.lex_state = 302, .external_lex_state = 25},
  [9698] = {.lex_state = 192, .external_lex_state = 29},
  [9699] = {.lex_state = 302, .external_lex_state = 25},
  [9700] = {.lex_state = 302, .external_lex_state = 25},
  [9701] = {.lex_state = 302, .external_lex_state = 25},
  [9702] = {.lex_state = 514, .external_lex_state = 11},
  [9703] = {.lex_state = 299, .external_lex_state = 3},
  [9704] = {.lex_state = 128},
  [9705] = {.lex_state = 361, .external_lex_state = 3},
  [9706] = {.lex_state = 361, .external_lex_state = 3},
  [9707] = {.lex_state = 192, .external_lex_state = 2},
  [9708] = {.lex_state = 192, .external_lex_state = 29},
  [9709] = {.lex_state = 361, .external_lex_state = 3},
  [9710] = {.lex_state = 361, .external_lex_state = 3},
  [9711] = {.lex_state = 361, .external_lex_state = 3},
  [9712] = {.lex_state = 361, .external_lex_state = 3},
  [9713] = {.lex_state = 361, .external_lex_state = 3},
  [9714] = {.lex_state = 361, .external_lex_state = 3},
  [9715] = {.lex_state = 361, .external_lex_state = 3},
  [9716] = {.lex_state = 361, .external_lex_state = 3},
  [9717] = {.lex_state = 192, .external_lex_state = 2},
  [9718] = {.lex_state = 192, .external_lex_state = 2},
  [9719] = {.lex_state = 192, .external_lex_state = 2},
  [9720] = {.lex_state = 192, .external_lex_state = 2},
  [9721] = {.lex_state = 192, .external_lex_state = 2},
  [9722] = {.lex_state = 192, .external_lex_state = 2},
  [9723] = {.lex_state = 192, .external_lex_state = 2},
  [9724] = {.lex_state = 192, .external_lex_state = 2},
  [9725] = {.lex_state = 192, .external_lex_state = 2},
  [9726] = {.lex_state = 192, .external_lex_state = 2},
  [9727] = {.lex_state = 192, .external_lex_state = 2},
  [9728] = {.lex_state = 192, .external_lex_state = 2},
  [9729] = {.lex_state = 192, .external_lex_state = 29},
  [9730] = {.lex_state = 192, .external_lex_state = 2},
  [9731] = {.lex_state = 365, .external_lex_state = 14},
  [9732] = {.lex_state = 361, .external_lex_state = 3},
  [9733] = {.lex_state = 361, .external_lex_state = 3},
  [9734] = {.lex_state = 361, .external_lex_state = 3},
  [9735] = {.lex_state = 192, .external_lex_state = 2},
  [9736] = {.lex_state = 361, .external_lex_state = 3},
  [9737] = {.lex_state = 192, .external_lex_state = 2},
  [9738] = {.lex_state = 361, .external_lex_state = 3},
  [9739] = {.lex_state = 524, .external_lex_state = 13},
  [9740] = {.lex_state = 361, .external_lex_state = 3},
  [9741] = {.lex_state = 361, .external_lex_state = 3},
  [9742] = {.lex_state = 361, .external_lex_state = 3},
  [9743] = {.lex_state = 361, .external_lex_state = 3},
  [9744] = {.lex_state = 361, .external_lex_state = 3},
  [9745] = {.lex_state = 361, .external_lex_state = 3},
  [9746] = {.lex_state = 361, .external_lex_state = 3},
  [9747] = {.lex_state = 361, .external_lex_state = 3},
  [9748] = {.lex_state = 554, .external_lex_state = 16},
  [9749] = {.lex_state = 361, .external_lex_state = 3},
  [9750] = {.lex_state = 361, .external_lex_state = 3},
  [9751] = {.lex_state = 361, .external_lex_state = 3},
  [9752] = {.lex_state = 361, .external_lex_state = 3},
  [9753] = {.lex_state = 361, .external_lex_state = 3},
  [9754] = {.lex_state = 421, .external_lex_state = 3},
  [9755] = {.lex_state = 421, .external_lex_state = 3},
  [9756] = {.lex_state = 192, .external_lex_state = 2},
  [9757] = {.lex_state = 421, .external_lex_state = 3},
  [9758] = {.lex_state = 192, .external_lex_state = 2},
  [9759] = {.lex_state = 421, .external_lex_state = 3},
  [9760] = {.lex_state = 524, .external_lex_state = 13},
  [9761] = {.lex_state = 421, .external_lex_state = 3},
  [9762] = {.lex_state = 262, .external_lex_state = 3},
  [9763] = {.lex_state = 524, .external_lex_state = 21},
  [9764] = {.lex_state = 262, .external_lex_state = 3},
  [9765] = {.lex_state = 361, .external_lex_state = 3},
  [9766] = {.lex_state = 361, .external_lex_state = 3},
  [9767] = {.lex_state = 361, .external_lex_state = 3},
  [9768] = {.lex_state = 361, .external_lex_state = 3},
  [9769] = {.lex_state = 361, .external_lex_state = 14},
  [9770] = {.lex_state = 128},
  [9771] = {.lex_state = 128},
  [9772] = {.lex_state = 254, .external_lex_state = 8},
  [9773] = {.lex_state = 128, .external_lex_state = 2},
  [9774] = {.lex_state = 192, .external_lex_state = 2},
  [9775] = {.lex_state = 424, .external_lex_state = 3},
  [9776] = {.lex_state = 424, .external_lex_state = 3},
  [9777] = {.lex_state = 424, .external_lex_state = 3},
  [9778] = {.lex_state = 192, .external_lex_state = 2},
  [9779] = {.lex_state = 192, .external_lex_state = 2},
  [9780] = {.lex_state = 192, .external_lex_state = 2},
  [9781] = {.lex_state = 192, .external_lex_state = 2},
  [9782] = {.lex_state = 192, .external_lex_state = 2},
  [9783] = {.lex_state = 192, .external_lex_state = 2},
  [9784] = {.lex_state = 192, .external_lex_state = 2},
  [9785] = {.lex_state = 192, .external_lex_state = 2},
  [9786] = {.lex_state = 192, .external_lex_state = 2},
  [9787] = {.lex_state = 192, .external_lex_state = 2},
  [9788] = {.lex_state = 192, .external_lex_state = 2},
  [9789] = {.lex_state = 192, .external_lex_state = 2},
  [9790] = {.lex_state = 192, .external_lex_state = 29},
  [9791] = {.lex_state = 192, .external_lex_state = 2},
  [9792] = {.lex_state = 424, .external_lex_state = 14},
  [9793] = {.lex_state = 424, .external_lex_state = 3},
  [9794] = {.lex_state = 421, .external_lex_state = 3},
  [9795] = {.lex_state = 421, .external_lex_state = 3},
  [9796] = {.lex_state = 421, .external_lex_state = 3},
  [9797] = {.lex_state = 421, .external_lex_state = 3},
  [9798] = {.lex_state = 421, .external_lex_state = 3},
  [9799] = {.lex_state = 421, .external_lex_state = 3},
  [9800] = {.lex_state = 424, .external_lex_state = 3},
  [9801] = {.lex_state = 554, .external_lex_state = 16},
  [9802] = {.lex_state = 421, .external_lex_state = 3},
  [9803] = {.lex_state = 421, .external_lex_state = 3},
  [9804] = {.lex_state = 421, .external_lex_state = 3},
  [9805] = {.lex_state = 421, .external_lex_state = 3},
  [9806] = {.lex_state = 421, .external_lex_state = 3},
  [9807] = {.lex_state = 424, .external_lex_state = 3},
  [9808] = {.lex_state = 524, .external_lex_state = 21},
  [9809] = {.lex_state = 424, .external_lex_state = 3},
  [9810] = {.lex_state = 424, .external_lex_state = 3},
  [9811] = {.lex_state = 421, .external_lex_state = 3},
  [9812] = {.lex_state = 421, .external_lex_state = 3},
  [9813] = {.lex_state = 421, .external_lex_state = 3},
  [9814] = {.lex_state = 421, .external_lex_state = 14},
  [9815] = {.lex_state = 528, .external_lex_state = 3},
  [9816] = {.lex_state = 528, .external_lex_state = 3},
  [9817] = {.lex_state = 528, .external_lex_state = 3},
  [9818] = {.lex_state = 528, .external_lex_state = 3},
  [9819] = {.lex_state = 192, .external_lex_state = 2},
  [9820] = {.lex_state = 192, .external_lex_state = 2},
  [9821] = {.lex_state = 192, .external_lex_state = 2},
  [9822] = {.lex_state = 192, .external_lex_state = 2},
  [9823] = {.lex_state = 192, .external_lex_state = 2},
  [9824] = {.lex_state = 192, .external_lex_state = 2},
  [9825] = {.lex_state = 192, .external_lex_state = 2},
  [9826] = {.lex_state = 192, .external_lex_state = 2},
  [9827] = {.lex_state = 192, .external_lex_state = 2},
  [9828] = {.lex_state = 192, .external_lex_state = 2},
  [9829] = {.lex_state = 192, .external_lex_state = 2},
  [9830] = {.lex_state = 192, .external_lex_state = 2},
  [9831] = {.lex_state = 192, .external_lex_state = 29},
  [9832] = {.lex_state = 528, .external_lex_state = 3},
  [9833] = {.lex_state = 192, .external_lex_state = 29},
  [9834] = {.lex_state = 192, .external_lex_state = 2},
  [9835] = {.lex_state = 156, .external_lex_state = 3},
  [9836] = {.lex_state = 192, .external_lex_state = 2},
  [9837] = {.lex_state = 192, .external_lex_state = 29},
  [9838] = {.lex_state = 424, .external_lex_state = 3},
  [9839] = {.lex_state = 421, .external_lex_state = 3},
  [9840] = {.lex_state = 421, .external_lex_state = 3},
  [9841] = {.lex_state = 192, .external_lex_state = 2},
  [9842] = {.lex_state = 361, .external_lex_state = 3},
  [9843] = {.lex_state = 361, .external_lex_state = 3},
  [9844] = {.lex_state = 361, .external_lex_state = 3},
  [9845] = {.lex_state = 361, .external_lex_state = 3},
  [9846] = {.lex_state = 361, .external_lex_state = 3},
  [9847] = {.lex_state = 192, .external_lex_state = 2},
  [9848] = {.lex_state = 192, .external_lex_state = 2},
  [9849] = {.lex_state = 192, .external_lex_state = 2},
  [9850] = {.lex_state = 192, .external_lex_state = 2},
  [9851] = {.lex_state = 192, .external_lex_state = 2},
  [9852] = {.lex_state = 192, .external_lex_state = 2},
  [9853] = {.lex_state = 192, .external_lex_state = 2},
  [9854] = {.lex_state = 192, .external_lex_state = 2},
  [9855] = {.lex_state = 192, .external_lex_state = 2},
  [9856] = {.lex_state = 192, .external_lex_state = 2},
  [9857] = {.lex_state = 192, .external_lex_state = 2},
  [9858] = {.lex_state = 192, .external_lex_state = 2},
  [9859] = {.lex_state = 192, .external_lex_state = 29},
  [9860] = {.lex_state = 192, .external_lex_state = 2},
  [9861] = {.lex_state = 365, .external_lex_state = 14},
  [9862] = {.lex_state = 361, .external_lex_state = 3},
  [9863] = {.lex_state = 361, .external_lex_state = 3},
  [9864] = {.lex_state = 361, .external_lex_state = 3},
  [9865] = {.lex_state = 192, .external_lex_state = 2},
  [9866] = {.lex_state = 361, .external_lex_state = 3},
  [9867] = {.lex_state = 192, .external_lex_state = 2},
  [9868] = {.lex_state = 361, .external_lex_state = 3},
  [9869] = {.lex_state = 524, .external_lex_state = 13},
  [9870] = {.lex_state = 361, .external_lex_state = 3},
  [9871] = {.lex_state = 361, .external_lex_state = 3},
  [9872] = {.lex_state = 361, .external_lex_state = 3},
  [9873] = {.lex_state = 361, .external_lex_state = 3},
  [9874] = {.lex_state = 361, .external_lex_state = 3},
  [9875] = {.lex_state = 361, .external_lex_state = 3},
  [9876] = {.lex_state = 361, .external_lex_state = 3},
  [9877] = {.lex_state = 361, .external_lex_state = 3},
  [9878] = {.lex_state = 554, .external_lex_state = 16},
  [9879] = {.lex_state = 361, .external_lex_state = 3},
  [9880] = {.lex_state = 361, .external_lex_state = 3},
  [9881] = {.lex_state = 361, .external_lex_state = 3},
  [9882] = {.lex_state = 361, .external_lex_state = 3},
  [9883] = {.lex_state = 361, .external_lex_state = 3},
  [9884] = {.lex_state = 421, .external_lex_state = 3},
  [9885] = {.lex_state = 421, .external_lex_state = 3},
  [9886] = {.lex_state = 192, .external_lex_state = 2},
  [9887] = {.lex_state = 421, .external_lex_state = 3},
  [9888] = {.lex_state = 192, .external_lex_state = 2},
  [9889] = {.lex_state = 421, .external_lex_state = 3},
  [9890] = {.lex_state = 524, .external_lex_state = 13},
  [9891] = {.lex_state = 421, .external_lex_state = 3},
  [9892] = {.lex_state = 262, .external_lex_state = 3},
  [9893] = {.lex_state = 524, .external_lex_state = 21},
  [9894] = {.lex_state = 262, .external_lex_state = 3},
  [9895] = {.lex_state = 361, .external_lex_state = 3},
  [9896] = {.lex_state = 361, .external_lex_state = 3},
  [9897] = {.lex_state = 361, .external_lex_state = 3},
  [9898] = {.lex_state = 361, .external_lex_state = 3},
  [9899] = {.lex_state = 361, .external_lex_state = 14},
  [9900] = {.lex_state = 254, .external_lex_state = 8},
  [9901] = {.lex_state = 128, .external_lex_state = 2},
  [9902] = {.lex_state = 192, .external_lex_state = 2},
  [9903] = {.lex_state = 424, .external_lex_state = 3},
  [9904] = {.lex_state = 424, .external_lex_state = 3},
  [9905] = {.lex_state = 424, .external_lex_state = 3},
  [9906] = {.lex_state = 192, .external_lex_state = 2},
  [9907] = {.lex_state = 192, .external_lex_state = 2},
  [9908] = {.lex_state = 192, .external_lex_state = 2},
  [9909] = {.lex_state = 192, .external_lex_state = 2},
  [9910] = {.lex_state = 192, .external_lex_state = 2},
  [9911] = {.lex_state = 192, .external_lex_state = 2},
  [9912] = {.lex_state = 192, .external_lex_state = 2},
  [9913] = {.lex_state = 192, .external_lex_state = 2},
  [9914] = {.lex_state = 192, .external_lex_state = 2},
  [9915] = {.lex_state = 192, .external_lex_state = 2},
  [9916] = {.lex_state = 192, .external_lex_state = 2},
  [9917] = {.lex_state = 192, .external_lex_state = 2},
  [9918] = {.lex_state = 192, .external_lex_state = 29},
  [9919] = {.lex_state = 192, .external_lex_state = 2},
  [9920] = {.lex_state = 424, .external_lex_state = 14},
  [9921] = {.lex_state = 424, .external_lex_state = 3},
  [9922] = {.lex_state = 421, .external_lex_state = 3},
  [9923] = {.lex_state = 421, .external_lex_state = 3},
  [9924] = {.lex_state = 421, .external_lex_state = 3},
  [9925] = {.lex_state = 421, .external_lex_state = 3},
  [9926] = {.lex_state = 421, .external_lex_state = 3},
  [9927] = {.lex_state = 421, .external_lex_state = 3},
  [9928] = {.lex_state = 424, .external_lex_state = 3},
  [9929] = {.lex_state = 554, .external_lex_state = 16},
  [9930] = {.lex_state = 421, .external_lex_state = 3},
  [9931] = {.lex_state = 421, .external_lex_state = 3},
  [9932] = {.lex_state = 421, .external_lex_state = 3},
  [9933] = {.lex_state = 421, .external_lex_state = 3},
  [9934] = {.lex_state = 421, .external_lex_state = 3},
  [9935] = {.lex_state = 424, .external_lex_state = 3},
  [9936] = {.lex_state = 524, .external_lex_state = 21},
  [9937] = {.lex_state = 424, .external_lex_state = 3},
  [9938] = {.lex_state = 424, .external_lex_state = 3},
  [9939] = {.lex_state = 421, .external_lex_state = 3},
  [9940] = {.lex_state = 421, .external_lex_state = 3},
  [9941] = {.lex_state = 421, .external_lex_state = 3},
  [9942] = {.lex_state = 421, .external_lex_state = 14},
  [9943] = {.lex_state = 528, .external_lex_state = 3},
  [9944] = {.lex_state = 528, .external_lex_state = 3},
  [9945] = {.lex_state = 528, .external_lex_state = 3},
  [9946] = {.lex_state = 528, .external_lex_state = 3},
  [9947] = {.lex_state = 192, .external_lex_state = 2},
  [9948] = {.lex_state = 192, .external_lex_state = 2},
  [9949] = {.lex_state = 192, .external_lex_state = 2},
  [9950] = {.lex_state = 192, .external_lex_state = 2},
  [9951] = {.lex_state = 192, .external_lex_state = 2},
  [9952] = {.lex_state = 192, .external_lex_state = 2},
  [9953] = {.lex_state = 192, .external_lex_state = 2},
  [9954] = {.lex_state = 192, .external_lex_state = 2},
  [9955] = {.lex_state = 192, .external_lex_state = 2},
  [9956] = {.lex_state = 192, .external_lex_state = 2},
  [9957] = {.lex_state = 192, .external_lex_state = 2},
  [9958] = {.lex_state = 192, .external_lex_state = 2},
  [9959] = {.lex_state = 192, .external_lex_state = 29},
  [9960] = {.lex_state = 528, .external_lex_state = 3},
  [9961] = {.lex_state = 192, .external_lex_state = 29},
  [9962] = {.lex_state = 192, .external_lex_state = 2},
  [9963] = {.lex_state = 361, .external_lex_state = 3},
  [9964] = {.lex_state = 361, .external_lex_state = 3},
  [9965] = {.lex_state = 192, .external_lex_state = 2},
  [9966] = {.lex_state = 192, .external_lex_state = 29},
  [9967] = {.lex_state = 361, .external_lex_state = 3},
  [9968] = {.lex_state = 361, .external_lex_state = 3},
  [9969] = {.lex_state = 361, .external_lex_state = 3},
  [9970] = {.lex_state = 192, .external_lex_state = 2},
  [9971] = {.lex_state = 192, .external_lex_state = 29},
  [9972] = {.lex_state = 424, .external_lex_state = 3},
  [9973] = {.lex_state = 421, .external_lex_state = 3},
  [9974] = {.lex_state = 421, .external_lex_state = 3},
  [9975] = {.lex_state = 192, .external_lex_state = 2},
  [9976] = {.lex_state = 508, .external_lex_state = 25},
  [9977] = {.lex_state = 508, .external_lex_state = 25},
  [9978] = {.lex_state = 508, .external_lex_state = 25},
  [9979] = {.lex_state = 524, .external_lex_state = 21},
  [9980] = {.lex_state = 508, .external_lex_state = 25},
  [9981] = {.lex_state = 508, .external_lex_state = 25},
  [9982] = {.lex_state = 192, .external_lex_state = 2},
  [9983] = {.lex_state = 424, .external_lex_state = 25},
  [9984] = {.lex_state = 424, .external_lex_state = 25},
  [9985] = {.lex_state = 424, .external_lex_state = 25},
  [9986] = {.lex_state = 192, .external_lex_state = 2},
  [9987] = {.lex_state = 192, .external_lex_state = 2},
  [9988] = {.lex_state = 192, .external_lex_state = 2},
  [9989] = {.lex_state = 192, .external_lex_state = 2},
  [9990] = {.lex_state = 192, .external_lex_state = 2},
  [9991] = {.lex_state = 192, .external_lex_state = 2},
  [9992] = {.lex_state = 192, .external_lex_state = 2},
  [9993] = {.lex_state = 192, .external_lex_state = 2},
  [9994] = {.lex_state = 192, .external_lex_state = 2},
  [9995] = {.lex_state = 192, .external_lex_state = 2},
  [9996] = {.lex_state = 192, .external_lex_state = 2},
  [9997] = {.lex_state = 192, .external_lex_state = 2},
  [9998] = {.lex_state = 192, .external_lex_state = 29},
  [9999] = {.lex_state = 192, .external_lex_state = 2},
  [10000] = {.lex_state = 424, .external_lex_state = 27},
  [10001] = {.lex_state = 424, .external_lex_state = 25},
  [10002] = {.lex_state = 424, .external_lex_state = 25},
  [10003] = {.lex_state = 424, .external_lex_state = 25},
  [10004] = {.lex_state = 524, .external_lex_state = 21},
  [10005] = {.lex_state = 424, .external_lex_state = 25},
  [10006] = {.lex_state = 424, .external_lex_state = 25},
  [10007] = {.lex_state = 192, .external_lex_state = 29},
  [10008] = {.lex_state = 508, .external_lex_state = 25},
  [10009] = {.lex_state = 508, .external_lex_state = 25},
  [10010] = {.lex_state = 192, .external_lex_state = 2},
  [10011] = {.lex_state = 192, .external_lex_state = 29},
  [10012] = {.lex_state = 421, .external_lex_state = 25},
  [10013] = {.lex_state = 508, .external_lex_state = 25},
  [10014] = {.lex_state = 361, .external_lex_state = 3},
  [10015] = {.lex_state = 361, .external_lex_state = 3},
  [10016] = {.lex_state = 192, .external_lex_state = 2},
  [10017] = {.lex_state = 192, .external_lex_state = 29},
  [10018] = {.lex_state = 361, .external_lex_state = 3},
  [10019] = {.lex_state = 361, .external_lex_state = 3},
  [10020] = {.lex_state = 361, .external_lex_state = 3},
  [10021] = {.lex_state = 192, .external_lex_state = 2},
  [10022] = {.lex_state = 361, .external_lex_state = 3},
  [10023] = {.lex_state = 361, .external_lex_state = 3},
  [10024] = {.lex_state = 361, .external_lex_state = 3},
  [10025] = {.lex_state = 192, .external_lex_state = 2},
  [10026] = {.lex_state = 192, .external_lex_state = 2},
  [10027] = {.lex_state = 192, .external_lex_state = 2},
  [10028] = {.lex_state = 192, .external_lex_state = 2},
  [10029] = {.lex_state = 192, .external_lex_state = 2},
  [10030] = {.lex_state = 192, .external_lex_state = 2},
  [10031] = {.lex_state = 192, .external_lex_state = 2},
  [10032] = {.lex_state = 192, .external_lex_state = 2},
  [10033] = {.lex_state = 192, .external_lex_state = 2},
  [10034] = {.lex_state = 192, .external_lex_state = 2},
  [10035] = {.lex_state = 192, .external_lex_state = 2},
  [10036] = {.lex_state = 192, .external_lex_state = 2},
  [10037] = {.lex_state = 192, .external_lex_state = 29},
  [10038] = {.lex_state = 192, .external_lex_state = 2},
  [10039] = {.lex_state = 361, .external_lex_state = 3},
  [10040] = {.lex_state = 361, .external_lex_state = 3},
  [10041] = {.lex_state = 361, .external_lex_state = 3},
  [10042] = {.lex_state = 524, .external_lex_state = 21},
  [10043] = {.lex_state = 361, .external_lex_state = 3},
  [10044] = {.lex_state = 361, .external_lex_state = 3},
  [10045] = {.lex_state = 247, .external_lex_state = 3},
  [10046] = {.lex_state = 192, .external_lex_state = 2},
  [10047] = {.lex_state = 192, .external_lex_state = 2},
  [10048] = {.lex_state = 192, .external_lex_state = 2},
  [10049] = {.lex_state = 237},
  [10050] = {.lex_state = 192, .external_lex_state = 2},
  [10051] = {.lex_state = 353, .external_lex_state = 11},
  [10052] = {.lex_state = 353, .external_lex_state = 11},
  [10053] = {.lex_state = 353, .external_lex_state = 11},
  [10054] = {.lex_state = 353, .external_lex_state = 11},
  [10055] = {.lex_state = 192, .external_lex_state = 2},
  [10056] = {.lex_state = 192, .external_lex_state = 2},
  [10057] = {.lex_state = 192, .external_lex_state = 2},
  [10058] = {.lex_state = 358, .external_lex_state = 11},
  [10059] = {.lex_state = 361, .external_lex_state = 3},
  [10060] = {.lex_state = 364, .external_lex_state = 11},
  [10061] = {.lex_state = 262, .external_lex_state = 3},
  [10062] = {.lex_state = 361, .external_lex_state = 3},
  [10063] = {.lex_state = 213},
  [10064] = {.lex_state = 368, .external_lex_state = 3},
  [10065] = {.lex_state = 371, .external_lex_state = 14},
  [10066] = {.lex_state = 247, .external_lex_state = 3},
  [10067] = {.lex_state = 247, .external_lex_state = 3},
  [10068] = {.lex_state = 254, .external_lex_state = 8},
  [10069] = {.lex_state = 128},
  [10070] = {.lex_state = 128, .external_lex_state = 2},
  [10071] = {.lex_state = 128, .external_lex_state = 8},
  [10072] = {.lex_state = 192, .external_lex_state = 2},
  [10073] = {.lex_state = 192, .external_lex_state = 2},
  [10074] = {.lex_state = 192, .external_lex_state = 2},
  [10075] = {.lex_state = 192, .external_lex_state = 2},
  [10076] = {.lex_state = 192, .external_lex_state = 2},
  [10077] = {.lex_state = 192, .external_lex_state = 2},
  [10078] = {.lex_state = 192, .external_lex_state = 2},
  [10079] = {.lex_state = 192, .external_lex_state = 2},
  [10080] = {.lex_state = 192, .external_lex_state = 2},
  [10081] = {.lex_state = 192, .external_lex_state = 2},
  [10082] = {.lex_state = 192, .external_lex_state = 2},
  [10083] = {.lex_state = 192, .external_lex_state = 2},
  [10084] = {.lex_state = 192, .external_lex_state = 2},
  [10085] = {.lex_state = 192, .external_lex_state = 2},
  [10086] = {.lex_state = 192, .external_lex_state = 2},
  [10087] = {.lex_state = 192, .external_lex_state = 2},
  [10088] = {.lex_state = 192, .external_lex_state = 2},
  [10089] = {.lex_state = 192, .external_lex_state = 2},
  [10090] = {.lex_state = 192, .external_lex_state = 2},
  [10091] = {.lex_state = 192, .external_lex_state = 2},
  [10092] = {.lex_state = 237},
  [10093] = {.lex_state = 192, .external_lex_state = 2},
  [10094] = {.lex_state = 364, .external_lex_state = 11},
  [10095] = {.lex_state = 364, .external_lex_state = 11},
  [10096] = {.lex_state = 364, .external_lex_state = 11},
  [10097] = {.lex_state = 364, .external_lex_state = 11},
  [10098] = {.lex_state = 192, .external_lex_state = 2},
  [10099] = {.lex_state = 192, .external_lex_state = 2},
  [10100] = {.lex_state = 192, .external_lex_state = 2},
  [10101] = {.lex_state = 358, .external_lex_state = 11},
  [10102] = {.lex_state = 421, .external_lex_state = 3},
  [10103] = {.lex_state = 364, .external_lex_state = 11},
  [10104] = {.lex_state = 424, .external_lex_state = 3},
  [10105] = {.lex_state = 424, .external_lex_state = 3},
  [10106] = {.lex_state = 213},
  [10107] = {.lex_state = 421, .external_lex_state = 3},
  [10108] = {.lex_state = 427, .external_lex_state = 14},
  [10109] = {.lex_state = 192, .external_lex_state = 29},
  [10110] = {.lex_state = 192, .external_lex_state = 2},
  [10111] = {.lex_state = 262, .external_lex_state = 14},
  [10112] = {.lex_state = 128},
  [10113] = {.lex_state = 192, .external_lex_state = 2},
  [10114] = {.lex_state = 424, .external_lex_state = 3},
  [10115] = {.lex_state = 424, .external_lex_state = 3},
  [10116] = {.lex_state = 424, .external_lex_state = 3},
  [10117] = {.lex_state = 192, .external_lex_state = 2},
  [10118] = {.lex_state = 192, .external_lex_state = 2},
  [10119] = {.lex_state = 192, .external_lex_state = 2},
  [10120] = {.lex_state = 192, .external_lex_state = 2},
  [10121] = {.lex_state = 192, .external_lex_state = 2},
  [10122] = {.lex_state = 192, .external_lex_state = 2},
  [10123] = {.lex_state = 192, .external_lex_state = 2},
  [10124] = {.lex_state = 192, .external_lex_state = 2},
  [10125] = {.lex_state = 192, .external_lex_state = 2},
  [10126] = {.lex_state = 192, .external_lex_state = 2},
  [10127] = {.lex_state = 192, .external_lex_state = 2},
  [10128] = {.lex_state = 192, .external_lex_state = 2},
  [10129] = {.lex_state = 192, .external_lex_state = 29},
  [10130] = {.lex_state = 192, .external_lex_state = 2},
  [10131] = {.lex_state = 424, .external_lex_state = 14},
  [10132] = {.lex_state = 424, .external_lex_state = 3},
  [10133] = {.lex_state = 424, .external_lex_state = 3},
  [10134] = {.lex_state = 424, .external_lex_state = 3},
  [10135] = {.lex_state = 524, .external_lex_state = 21},
  [10136] = {.lex_state = 424, .external_lex_state = 3},
  [10137] = {.lex_state = 424, .external_lex_state = 3},
  [10138] = {.lex_state = 528, .external_lex_state = 3},
  [10139] = {.lex_state = 192, .external_lex_state = 29},
  [10140] = {.lex_state = 528, .external_lex_state = 3},
  [10141] = {.lex_state = 361, .external_lex_state = 3},
  [10142] = {.lex_state = 361, .external_lex_state = 3},
  [10143] = {.lex_state = 192, .external_lex_state = 2},
  [10144] = {.lex_state = 192, .external_lex_state = 29},
  [10145] = {.lex_state = 361, .external_lex_state = 3},
  [10146] = {.lex_state = 361, .external_lex_state = 3},
  [10147] = {.lex_state = 361, .external_lex_state = 3},
  [10148] = {.lex_state = 192, .external_lex_state = 2},
  [10149] = {.lex_state = 192, .external_lex_state = 29},
  [10150] = {.lex_state = 361, .external_lex_state = 3},
  [10151] = {.lex_state = 350, .external_lex_state = 23},
  [10152] = {.lex_state = 209, .external_lex_state = 19},
  [10153] = {.lex_state = 209},
  [10154] = {.lex_state = 350, .external_lex_state = 23},
  [10155] = {.lex_state = 343, .external_lex_state = 8},
  [10156] = {.lex_state = 235},
  [10157] = {.lex_state = 508, .external_lex_state = 3},
  [10158] = {.lex_state = 192, .external_lex_state = 2},
  [10159] = {.lex_state = 192, .external_lex_state = 2},
  [10160] = {.lex_state = 237},
  [10161] = {.lex_state = 192, .external_lex_state = 2},
  [10162] = {.lex_state = 358, .external_lex_state = 11},
  [10163] = {.lex_state = 508, .external_lex_state = 3},
  [10164] = {.lex_state = 508, .external_lex_state = 3},
  [10165] = {.lex_state = 508, .external_lex_state = 3},
  [10166] = {.lex_state = 508, .external_lex_state = 14},
  [10167] = {.lex_state = 508, .external_lex_state = 3},
  [10168] = {.lex_state = 508, .external_lex_state = 3},
  [10169] = {.lex_state = 192, .external_lex_state = 2},
  [10170] = {.lex_state = 192, .external_lex_state = 2},
  [10171] = {.lex_state = 192, .external_lex_state = 2},
  [10172] = {.lex_state = 192, .external_lex_state = 2},
  [10173] = {.lex_state = 192, .external_lex_state = 2},
  [10174] = {.lex_state = 192, .external_lex_state = 2},
  [10175] = {.lex_state = 192, .external_lex_state = 2},
  [10176] = {.lex_state = 192, .external_lex_state = 2},
  [10177] = {.lex_state = 192, .external_lex_state = 2},
  [10178] = {.lex_state = 192, .external_lex_state = 2},
  [10179] = {.lex_state = 192, .external_lex_state = 2},
  [10180] = {.lex_state = 192, .external_lex_state = 2},
  [10181] = {.lex_state = 192, .external_lex_state = 29},
  [10182] = {.lex_state = 192, .external_lex_state = 2},
  [10183] = {.lex_state = 631, .external_lex_state = 14},
  [10184] = {.lex_state = 508, .external_lex_state = 3},
  [10185] = {.lex_state = 508, .external_lex_state = 3},
  [10186] = {.lex_state = 508, .external_lex_state = 3},
  [10187] = {.lex_state = 192, .external_lex_state = 2},
  [10188] = {.lex_state = 508, .external_lex_state = 3},
  [10189] = {.lex_state = 192, .external_lex_state = 2},
  [10190] = {.lex_state = 508, .external_lex_state = 3},
  [10191] = {.lex_state = 524, .external_lex_state = 13},
  [10192] = {.lex_state = 508, .external_lex_state = 3},
  [10193] = {.lex_state = 343, .external_lex_state = 8},
  [10194] = {.lex_state = 209},
  [10195] = {.lex_state = 508, .external_lex_state = 3},
  [10196] = {.lex_state = 508, .external_lex_state = 3},
  [10197] = {.lex_state = 508, .external_lex_state = 3},
  [10198] = {.lex_state = 508, .external_lex_state = 3},
  [10199] = {.lex_state = 508, .external_lex_state = 3},
  [10200] = {.lex_state = 508, .external_lex_state = 3},
  [10201] = {.lex_state = 508, .external_lex_state = 3},
  [10202] = {.lex_state = 554, .external_lex_state = 16},
  [10203] = {.lex_state = 508, .external_lex_state = 3},
  [10204] = {.lex_state = 508, .external_lex_state = 3},
  [10205] = {.lex_state = 508, .external_lex_state = 3},
  [10206] = {.lex_state = 508, .external_lex_state = 3},
  [10207] = {.lex_state = 508, .external_lex_state = 3},
  [10208] = {.lex_state = 343, .external_lex_state = 8},
  [10209] = {.lex_state = 177, .external_lex_state = 17},
  [10210] = {.lex_state = 343, .external_lex_state = 8},
  [10211] = {.lex_state = 678, .external_lex_state = 8},
  [10212] = {.lex_state = 524, .external_lex_state = 21},
  [10213] = {.lex_state = 343, .external_lex_state = 8},
  [10214] = {.lex_state = 678, .external_lex_state = 8},
  [10215] = {.lex_state = 508, .external_lex_state = 3},
  [10216] = {.lex_state = 508, .external_lex_state = 3},
  [10217] = {.lex_state = 508, .external_lex_state = 3},
  [10218] = {.lex_state = 634, .external_lex_state = 14},
  [10219] = {.lex_state = 128},
  [10220] = {.lex_state = 528, .external_lex_state = 3},
  [10221] = {.lex_state = 192, .external_lex_state = 2},
  [10222] = {.lex_state = 192, .external_lex_state = 29},
  [10223] = {.lex_state = 421, .external_lex_state = 3},
  [10224] = {.lex_state = 528, .external_lex_state = 3},
  [10225] = {.lex_state = 361, .external_lex_state = 3},
  [10226] = {.lex_state = 361, .external_lex_state = 3},
  [10227] = {.lex_state = 361, .external_lex_state = 3},
  [10228] = {.lex_state = 361, .external_lex_state = 3},
  [10229] = {.lex_state = 361, .external_lex_state = 3},
  [10230] = {.lex_state = 361, .external_lex_state = 3},
  [10231] = {.lex_state = 361, .external_lex_state = 3},
  [10232] = {.lex_state = 361, .external_lex_state = 3},
  [10233] = {.lex_state = 554, .external_lex_state = 16},
  [10234] = {.lex_state = 361, .external_lex_state = 3},
  [10235] = {.lex_state = 361, .external_lex_state = 3},
  [10236] = {.lex_state = 361, .external_lex_state = 3},
  [10237] = {.lex_state = 361, .external_lex_state = 3},
  [10238] = {.lex_state = 361, .external_lex_state = 3},
  [10239] = {.lex_state = 361, .external_lex_state = 3},
  [10240] = {.lex_state = 361, .external_lex_state = 3},
  [10241] = {.lex_state = 361, .external_lex_state = 3},
  [10242] = {.lex_state = 365, .external_lex_state = 14},
  [10243] = {.lex_state = 361, .external_lex_state = 3},
  [10244] = {.lex_state = 361, .external_lex_state = 3},
  [10245] = {.lex_state = 361, .external_lex_state = 3},
  [10246] = {.lex_state = 524, .external_lex_state = 21},
  [10247] = {.lex_state = 361, .external_lex_state = 3},
  [10248] = {.lex_state = 361, .external_lex_state = 3},
  [10249] = {.lex_state = 192, .external_lex_state = 2},
  [10250] = {.lex_state = 421, .external_lex_state = 3},
  [10251] = {.lex_state = 421, .external_lex_state = 3},
  [10252] = {.lex_state = 421, .external_lex_state = 3},
  [10253] = {.lex_state = 524, .external_lex_state = 21},
  [10254] = {.lex_state = 421, .external_lex_state = 3},
  [10255] = {.lex_state = 421, .external_lex_state = 3},
  [10256] = {.lex_state = 192, .external_lex_state = 29},
  [10257] = {.lex_state = 361, .external_lex_state = 3},
  [10258] = {.lex_state = 247, .external_lex_state = 3},
  [10259] = {.lex_state = 424, .external_lex_state = 3},
  [10260] = {.lex_state = 424, .external_lex_state = 3},
  [10261] = {.lex_state = 424, .external_lex_state = 3},
  [10262] = {.lex_state = 424, .external_lex_state = 3},
  [10263] = {.lex_state = 424, .external_lex_state = 3},
  [10264] = {.lex_state = 424, .external_lex_state = 3},
  [10265] = {.lex_state = 554, .external_lex_state = 16},
  [10266] = {.lex_state = 424, .external_lex_state = 3},
  [10267] = {.lex_state = 424, .external_lex_state = 3},
  [10268] = {.lex_state = 424, .external_lex_state = 3},
  [10269] = {.lex_state = 424, .external_lex_state = 3},
  [10270] = {.lex_state = 424, .external_lex_state = 3},
  [10271] = {.lex_state = 424, .external_lex_state = 3},
  [10272] = {.lex_state = 424, .external_lex_state = 3},
  [10273] = {.lex_state = 424, .external_lex_state = 3},
  [10274] = {.lex_state = 424, .external_lex_state = 14},
  [10275] = {.lex_state = 192, .external_lex_state = 2},
  [10276] = {.lex_state = 192, .external_lex_state = 29},
  [10277] = {.lex_state = 421, .external_lex_state = 3},
  [10278] = {.lex_state = 528, .external_lex_state = 3},
  [10279] = {.lex_state = 528, .external_lex_state = 3},
  [10280] = {.lex_state = 528, .external_lex_state = 3},
  [10281] = {.lex_state = 528, .external_lex_state = 3},
  [10282] = {.lex_state = 528, .external_lex_state = 3},
  [10283] = {.lex_state = 528, .external_lex_state = 3},
  [10284] = {.lex_state = 554, .external_lex_state = 16},
  [10285] = {.lex_state = 528, .external_lex_state = 3},
  [10286] = {.lex_state = 528, .external_lex_state = 3},
  [10287] = {.lex_state = 528, .external_lex_state = 3},
  [10288] = {.lex_state = 528, .external_lex_state = 3},
  [10289] = {.lex_state = 528, .external_lex_state = 3},
  [10290] = {.lex_state = 528, .external_lex_state = 3},
  [10291] = {.lex_state = 528, .external_lex_state = 3},
  [10292] = {.lex_state = 528, .external_lex_state = 3},
  [10293] = {.lex_state = 361, .external_lex_state = 3},
  [10294] = {.lex_state = 361, .external_lex_state = 3},
  [10295] = {.lex_state = 361, .external_lex_state = 3},
  [10296] = {.lex_state = 361, .external_lex_state = 3},
  [10297] = {.lex_state = 361, .external_lex_state = 3},
  [10298] = {.lex_state = 361, .external_lex_state = 3},
  [10299] = {.lex_state = 361, .external_lex_state = 3},
  [10300] = {.lex_state = 361, .external_lex_state = 3},
  [10301] = {.lex_state = 554, .external_lex_state = 16},
  [10302] = {.lex_state = 361, .external_lex_state = 3},
  [10303] = {.lex_state = 361, .external_lex_state = 3},
  [10304] = {.lex_state = 361, .external_lex_state = 3},
  [10305] = {.lex_state = 361, .external_lex_state = 3},
  [10306] = {.lex_state = 361, .external_lex_state = 3},
  [10307] = {.lex_state = 361, .external_lex_state = 3},
  [10308] = {.lex_state = 361, .external_lex_state = 3},
  [10309] = {.lex_state = 361, .external_lex_state = 3},
  [10310] = {.lex_state = 365, .external_lex_state = 14},
  [10311] = {.lex_state = 361, .external_lex_state = 3},
  [10312] = {.lex_state = 361, .external_lex_state = 3},
  [10313] = {.lex_state = 361, .external_lex_state = 3},
  [10314] = {.lex_state = 524, .external_lex_state = 21},
  [10315] = {.lex_state = 361, .external_lex_state = 3},
  [10316] = {.lex_state = 361, .external_lex_state = 3},
  [10317] = {.lex_state = 192, .external_lex_state = 2},
  [10318] = {.lex_state = 421, .external_lex_state = 3},
  [10319] = {.lex_state = 421, .external_lex_state = 3},
  [10320] = {.lex_state = 421, .external_lex_state = 3},
  [10321] = {.lex_state = 524, .external_lex_state = 21},
  [10322] = {.lex_state = 421, .external_lex_state = 3},
  [10323] = {.lex_state = 421, .external_lex_state = 3},
  [10324] = {.lex_state = 192, .external_lex_state = 29},
  [10325] = {.lex_state = 361, .external_lex_state = 3},
  [10326] = {.lex_state = 247, .external_lex_state = 3},
  [10327] = {.lex_state = 424, .external_lex_state = 3},
  [10328] = {.lex_state = 424, .external_lex_state = 3},
  [10329] = {.lex_state = 424, .external_lex_state = 3},
  [10330] = {.lex_state = 424, .external_lex_state = 3},
  [10331] = {.lex_state = 424, .external_lex_state = 3},
  [10332] = {.lex_state = 424, .external_lex_state = 3},
  [10333] = {.lex_state = 554, .external_lex_state = 16},
  [10334] = {.lex_state = 424, .external_lex_state = 3},
  [10335] = {.lex_state = 424, .external_lex_state = 3},
  [10336] = {.lex_state = 424, .external_lex_state = 3},
  [10337] = {.lex_state = 424, .external_lex_state = 3},
  [10338] = {.lex_state = 424, .external_lex_state = 3},
  [10339] = {.lex_state = 424, .external_lex_state = 3},
  [10340] = {.lex_state = 424, .external_lex_state = 3},
  [10341] = {.lex_state = 424, .external_lex_state = 3},
  [10342] = {.lex_state = 424, .external_lex_state = 14},
  [10343] = {.lex_state = 192, .external_lex_state = 2},
  [10344] = {.lex_state = 192, .external_lex_state = 29},
  [10345] = {.lex_state = 421, .external_lex_state = 3},
  [10346] = {.lex_state = 528, .external_lex_state = 3},
  [10347] = {.lex_state = 528, .external_lex_state = 3},
  [10348] = {.lex_state = 528, .external_lex_state = 3},
  [10349] = {.lex_state = 528, .external_lex_state = 3},
  [10350] = {.lex_state = 528, .external_lex_state = 3},
  [10351] = {.lex_state = 528, .external_lex_state = 3},
  [10352] = {.lex_state = 554, .external_lex_state = 16},
  [10353] = {.lex_state = 528, .external_lex_state = 3},
  [10354] = {.lex_state = 528, .external_lex_state = 3},
  [10355] = {.lex_state = 528, .external_lex_state = 3},
  [10356] = {.lex_state = 528, .external_lex_state = 3},
  [10357] = {.lex_state = 528, .external_lex_state = 3},
  [10358] = {.lex_state = 528, .external_lex_state = 3},
  [10359] = {.lex_state = 528, .external_lex_state = 3},
  [10360] = {.lex_state = 528, .external_lex_state = 3},
  [10361] = {.lex_state = 192, .external_lex_state = 2},
  [10362] = {.lex_state = 192, .external_lex_state = 29},
  [10363] = {.lex_state = 424, .external_lex_state = 3},
  [10364] = {.lex_state = 421, .external_lex_state = 3},
  [10365] = {.lex_state = 421, .external_lex_state = 3},
  [10366] = {.lex_state = 192, .external_lex_state = 2},
  [10367] = {.lex_state = 388, .external_lex_state = 25},
  [10368] = {.lex_state = 388, .external_lex_state = 25},
  [10369] = {.lex_state = 406, .external_lex_state = 25},
  [10370] = {.lex_state = 406, .external_lex_state = 25},
  [10371] = {.lex_state = 406, .external_lex_state = 25},
  [10372] = {.lex_state = 406, .external_lex_state = 25},
  [10373] = {.lex_state = 406, .external_lex_state = 25},
  [10374] = {.lex_state = 406, .external_lex_state = 25},
  [10375] = {.lex_state = 554, .external_lex_state = 16},
  [10376] = {.lex_state = 406, .external_lex_state = 25},
  [10377] = {.lex_state = 406, .external_lex_state = 25},
  [10378] = {.lex_state = 406, .external_lex_state = 25},
  [10379] = {.lex_state = 406, .external_lex_state = 25},
  [10380] = {.lex_state = 406, .external_lex_state = 25},
  [10381] = {.lex_state = 406, .external_lex_state = 25},
  [10382] = {.lex_state = 406, .external_lex_state = 25},
  [10383] = {.lex_state = 406, .external_lex_state = 25},
  [10384] = {.lex_state = 400, .external_lex_state = 25},
  [10385] = {.lex_state = 537, .external_lex_state = 25},
  [10386] = {.lex_state = 537, .external_lex_state = 25},
  [10387] = {.lex_state = 537, .external_lex_state = 25},
  [10388] = {.lex_state = 537, .external_lex_state = 25},
  [10389] = {.lex_state = 537, .external_lex_state = 25},
  [10390] = {.lex_state = 537, .external_lex_state = 25},
  [10391] = {.lex_state = 554, .external_lex_state = 16},
  [10392] = {.lex_state = 537, .external_lex_state = 25},
  [10393] = {.lex_state = 537, .external_lex_state = 25},
  [10394] = {.lex_state = 537, .external_lex_state = 25},
  [10395] = {.lex_state = 537, .external_lex_state = 25},
  [10396] = {.lex_state = 537, .external_lex_state = 25},
  [10397] = {.lex_state = 537, .external_lex_state = 25},
  [10398] = {.lex_state = 537, .external_lex_state = 25},
  [10399] = {.lex_state = 537, .external_lex_state = 25},
  [10400] = {.lex_state = 537, .external_lex_state = 27},
  [10401] = {.lex_state = 400, .external_lex_state = 25},
  [10402] = {.lex_state = 388, .external_lex_state = 25},
  [10403] = {.lex_state = 406, .external_lex_state = 25},
  [10404] = {.lex_state = 406, .external_lex_state = 25},
  [10405] = {.lex_state = 388, .external_lex_state = 25},
  [10406] = {.lex_state = 128},
  [10407] = {.lex_state = 388, .external_lex_state = 25},
  [10408] = {.lex_state = 388, .external_lex_state = 25},
  [10409] = {.lex_state = 388, .external_lex_state = 25},
  [10410] = {.lex_state = 388, .external_lex_state = 25},
  [10411] = {.lex_state = 388, .external_lex_state = 25},
  [10412] = {.lex_state = 128},
  [10413] = {.lex_state = 544, .external_lex_state = 26},
  [10414] = {.lex_state = 397, .external_lex_state = 25},
  [10415] = {.lex_state = 128},
  [10416] = {.lex_state = 403, .external_lex_state = 25},
  [10417] = {.lex_state = 403, .external_lex_state = 25},
  [10418] = {.lex_state = 286, .external_lex_state = 2},
  [10419] = {.lex_state = 237},
  [10420] = {.lex_state = 237},
  [10421] = {.lex_state = 237},
  [10422] = {.lex_state = 302, .external_lex_state = 16},
  [10423] = {.lex_state = 192, .external_lex_state = 2},
  [10424] = {.lex_state = 192, .external_lex_state = 2},
  [10425] = {.lex_state = 192, .external_lex_state = 2},
  [10426] = {.lex_state = 237},
  [10427] = {.lex_state = 192, .external_lex_state = 2},
  [10428] = {.lex_state = 353, .external_lex_state = 26},
  [10429] = {.lex_state = 353, .external_lex_state = 26},
  [10430] = {.lex_state = 353, .external_lex_state = 26},
  [10431] = {.lex_state = 353, .external_lex_state = 26},
  [10432] = {.lex_state = 192, .external_lex_state = 2},
  [10433] = {.lex_state = 192, .external_lex_state = 2},
  [10434] = {.lex_state = 192, .external_lex_state = 2},
  [10435] = {.lex_state = 358, .external_lex_state = 26},
  [10436] = {.lex_state = 361, .external_lex_state = 25},
  [10437] = {.lex_state = 364, .external_lex_state = 26},
  [10438] = {.lex_state = 361, .external_lex_state = 25},
  [10439] = {.lex_state = 361, .external_lex_state = 25},
  [10440] = {.lex_state = 213},
  [10441] = {.lex_state = 368, .external_lex_state = 25},
  [10442] = {.lex_state = 371, .external_lex_state = 27},
  [10443] = {.lex_state = 302, .external_lex_state = 16},
  [10444] = {.lex_state = 302, .external_lex_state = 16},
  [10445] = {.lex_state = 192, .external_lex_state = 2},
  [10446] = {.lex_state = 192, .external_lex_state = 2},
  [10447] = {.lex_state = 192, .external_lex_state = 2},
  [10448] = {.lex_state = 192, .external_lex_state = 2},
  [10449] = {.lex_state = 192, .external_lex_state = 2},
  [10450] = {.lex_state = 192, .external_lex_state = 2},
  [10451] = {.lex_state = 192, .external_lex_state = 2},
  [10452] = {.lex_state = 192, .external_lex_state = 2},
  [10453] = {.lex_state = 192, .external_lex_state = 2},
  [10454] = {.lex_state = 192, .external_lex_state = 2},
  [10455] = {.lex_state = 192, .external_lex_state = 2},
  [10456] = {.lex_state = 192, .external_lex_state = 2},
  [10457] = {.lex_state = 192, .external_lex_state = 2},
  [10458] = {.lex_state = 192, .external_lex_state = 2},
  [10459] = {.lex_state = 192, .external_lex_state = 2},
  [10460] = {.lex_state = 237},
  [10461] = {.lex_state = 192, .external_lex_state = 2},
  [10462] = {.lex_state = 364, .external_lex_state = 26},
  [10463] = {.lex_state = 364, .external_lex_state = 26},
  [10464] = {.lex_state = 364, .external_lex_state = 26},
  [10465] = {.lex_state = 364, .external_lex_state = 26},
  [10466] = {.lex_state = 192, .external_lex_state = 2},
  [10467] = {.lex_state = 192, .external_lex_state = 2},
  [10468] = {.lex_state = 192, .external_lex_state = 2},
  [10469] = {.lex_state = 358, .external_lex_state = 26},
  [10470] = {.lex_state = 421, .external_lex_state = 25},
  [10471] = {.lex_state = 364, .external_lex_state = 26},
  [10472] = {.lex_state = 424, .external_lex_state = 25},
  [10473] = {.lex_state = 424, .external_lex_state = 25},
  [10474] = {.lex_state = 213},
  [10475] = {.lex_state = 421, .external_lex_state = 25},
  [10476] = {.lex_state = 427, .external_lex_state = 27},
  [10477] = {.lex_state = 192, .external_lex_state = 29},
  [10478] = {.lex_state = 192, .external_lex_state = 2},
  [10479] = {.lex_state = 251, .external_lex_state = 20},
  [10480] = {.lex_state = 237},
  [10481] = {.lex_state = 128},
  [10482] = {.lex_state = 197},
  [10483] = {.lex_state = 128, .external_lex_state = 12},
  [10484] = {.lex_state = 237},
  [10485] = {.lex_state = 237},
  [10486] = {.lex_state = 128},
  [10487] = {.lex_state = 156, .external_lex_state = 3},
  [10488] = {.lex_state = 192, .external_lex_state = 2},
  [10489] = {.lex_state = 302, .external_lex_state = 16},
  [10490] = {.lex_state = 192, .external_lex_state = 29},
  [10491] = {.lex_state = 302, .external_lex_state = 16},
  [10492] = {.lex_state = 645, .external_lex_state = 25},
  [10493] = {.lex_state = 645, .external_lex_state = 25},
  [10494] = {.lex_state = 645, .external_lex_state = 25},
  [10495] = {.lex_state = 645, .external_lex_state = 25},
  [10496] = {.lex_state = 645, .external_lex_state = 25},
  [10497] = {.lex_state = 645, .external_lex_state = 25},
  [10498] = {.lex_state = 645, .external_lex_state = 25},
  [10499] = {.lex_state = 645, .external_lex_state = 25},
  [10500] = {.lex_state = 554, .external_lex_state = 16},
  [10501] = {.lex_state = 645, .external_lex_state = 25},
  [10502] = {.lex_state = 645, .external_lex_state = 25},
  [10503] = {.lex_state = 645, .external_lex_state = 25},
  [10504] = {.lex_state = 645, .external_lex_state = 25},
  [10505] = {.lex_state = 645, .external_lex_state = 25},
  [10506] = {.lex_state = 645, .external_lex_state = 25},
  [10507] = {.lex_state = 645, .external_lex_state = 25},
  [10508] = {.lex_state = 645, .external_lex_state = 25},
  [10509] = {.lex_state = 645, .external_lex_state = 27},
  [10510] = {.lex_state = 654, .external_lex_state = 27},
  [10511] = {.lex_state = 654, .external_lex_state = 25},
  [10512] = {.lex_state = 654, .external_lex_state = 25},
  [10513] = {.lex_state = 654, .external_lex_state = 25},
  [10514] = {.lex_state = 524, .external_lex_state = 21},
  [10515] = {.lex_state = 654, .external_lex_state = 25},
  [10516] = {.lex_state = 654, .external_lex_state = 25},
  [10517] = {.lex_state = 192, .external_lex_state = 2},
  [10518] = {.lex_state = 658, .external_lex_state = 25},
  [10519] = {.lex_state = 658, .external_lex_state = 25},
  [10520] = {.lex_state = 658, .external_lex_state = 25},
  [10521] = {.lex_state = 524, .external_lex_state = 21},
  [10522] = {.lex_state = 658, .external_lex_state = 25},
  [10523] = {.lex_state = 658, .external_lex_state = 25},
  [10524] = {.lex_state = 192, .external_lex_state = 29},
  [10525] = {.lex_state = 654, .external_lex_state = 25},
  [10526] = {.lex_state = 554, .external_lex_state = 16},
  [10527] = {.lex_state = 559, .external_lex_state = 25},
  [10528] = {.lex_state = 559, .external_lex_state = 25},
  [10529] = {.lex_state = 559, .external_lex_state = 25},
  [10530] = {.lex_state = 559, .external_lex_state = 25},
  [10531] = {.lex_state = 559, .external_lex_state = 25},
  [10532] = {.lex_state = 559, .external_lex_state = 25},
  [10533] = {.lex_state = 554, .external_lex_state = 16},
  [10534] = {.lex_state = 559, .external_lex_state = 25},
  [10535] = {.lex_state = 559, .external_lex_state = 25},
  [10536] = {.lex_state = 559, .external_lex_state = 25},
  [10537] = {.lex_state = 559, .external_lex_state = 25},
  [10538] = {.lex_state = 559, .external_lex_state = 25},
  [10539] = {.lex_state = 559, .external_lex_state = 25},
  [10540] = {.lex_state = 559, .external_lex_state = 25},
  [10541] = {.lex_state = 559, .external_lex_state = 25},
  [10542] = {.lex_state = 559, .external_lex_state = 27},
  [10543] = {.lex_state = 658, .external_lex_state = 27},
  [10544] = {.lex_state = 192, .external_lex_state = 2},
  [10545] = {.lex_state = 192, .external_lex_state = 29},
  [10546] = {.lex_state = 658, .external_lex_state = 25},
  [10547] = {.lex_state = 554, .external_lex_state = 16},
  [10548] = {.lex_state = 554, .external_lex_state = 16},
  [10549] = {.lex_state = 554, .external_lex_state = 16},
  [10550] = {.lex_state = 554, .external_lex_state = 16},
  [10551] = {.lex_state = 554, .external_lex_state = 16},
  [10552] = {.lex_state = 554, .external_lex_state = 16},
  [10553] = {.lex_state = 554, .external_lex_state = 16},
  [10554] = {.lex_state = 554, .external_lex_state = 16},
  [10555] = {.lex_state = 554, .external_lex_state = 16},
  [10556] = {.lex_state = 554, .external_lex_state = 16},
  [10557] = {.lex_state = 554, .external_lex_state = 16},
  [10558] = {.lex_state = 554, .external_lex_state = 16},
  [10559] = {.lex_state = 554, .external_lex_state = 16},
  [10560] = {.lex_state = 554, .external_lex_state = 16},
  [10561] = {.lex_state = 554, .external_lex_state = 16},
  [10562] = {.lex_state = 645, .external_lex_state = 20},
  [10563] = {.lex_state = 299, .external_lex_state = 3},
  [10564] = {.lex_state = 299, .external_lex_state = 3},
  [10565] = {.lex_state = 227, .external_lex_state = 3},
  [10566] = {.lex_state = 177, .external_lex_state = 4},
  [10567] = {.lex_state = 227, .external_lex_state = 3},
  [10568] = {.lex_state = 227, .external_lex_state = 3},
  [10569] = {.lex_state = 177, .external_lex_state = 4},
  [10570] = {.lex_state = 227, .external_lex_state = 3},
  [10571] = {.lex_state = 225, .external_lex_state = 7},
  [10572] = {.lex_state = 227, .external_lex_state = 3},
  [10573] = {.lex_state = 227, .external_lex_state = 3},
  [10574] = {.lex_state = 227, .external_lex_state = 3},
  [10575] = {.lex_state = 128},
  [10576] = {.lex_state = 128},
  [10577] = {.lex_state = 227, .external_lex_state = 3},
  [10578] = {.lex_state = 128},
  [10579] = {.lex_state = 227, .external_lex_state = 3},
  [10580] = {.lex_state = 227, .external_lex_state = 3},
  [10581] = {.lex_state = 227, .external_lex_state = 3},
  [10582] = {.lex_state = 128},
  [10583] = {.lex_state = 227, .external_lex_state = 3},
  [10584] = {.lex_state = 128},
  [10585] = {.lex_state = 227, .external_lex_state = 3},
  [10586] = {.lex_state = 128},
  [10587] = {.lex_state = 424, .external_lex_state = 3},
  [10588] = {.lex_state = 227, .external_lex_state = 3},
  [10589] = {.lex_state = 424, .external_lex_state = 3},
  [10590] = {.lex_state = 436, .external_lex_state = 3},
  [10591] = {.lex_state = 436, .external_lex_state = 3},
  [10592] = {.lex_state = 436, .external_lex_state = 3},
  [10593] = {.lex_state = 436, .external_lex_state = 3},
  [10594] = {.lex_state = 436, .external_lex_state = 3},
  [10595] = {.lex_state = 436, .external_lex_state = 3},
  [10596] = {.lex_state = 436, .external_lex_state = 3},
  [10597] = {.lex_state = 554, .external_lex_state = 16},
  [10598] = {.lex_state = 436, .external_lex_state = 3},
  [10599] = {.lex_state = 436, .external_lex_state = 3},
  [10600] = {.lex_state = 436, .external_lex_state = 3},
  [10601] = {.lex_state = 436, .external_lex_state = 3},
  [10602] = {.lex_state = 436, .external_lex_state = 3},
  [10603] = {.lex_state = 436, .external_lex_state = 3},
  [10604] = {.lex_state = 436, .external_lex_state = 3},
  [10605] = {.lex_state = 436, .external_lex_state = 3},
  [10606] = {.lex_state = 299, .external_lex_state = 3},
  [10607] = {.lex_state = 299, .external_lex_state = 3},
  [10608] = {.lex_state = 128},
  [10609] = {.lex_state = 299, .external_lex_state = 3},
  [10610] = {.lex_state = 299, .external_lex_state = 3},
  [10611] = {.lex_state = 227, .external_lex_state = 3},
  [10612] = {.lex_state = 299, .external_lex_state = 3},
  [10613] = {.lex_state = 299, .external_lex_state = 3},
  [10614] = {.lex_state = 577, .external_lex_state = 3},
  [10615] = {.lex_state = 467, .external_lex_state = 25},
  [10616] = {.lex_state = 467, .external_lex_state = 25},
  [10617] = {.lex_state = 192, .external_lex_state = 2},
  [10618] = {.lex_state = 192, .external_lex_state = 29},
  [10619] = {.lex_state = 467, .external_lex_state = 25},
  [10620] = {.lex_state = 588, .external_lex_state = 25},
  [10621] = {.lex_state = 588, .external_lex_state = 25},
  [10622] = {.lex_state = 579, .external_lex_state = 18},
  [10623] = {.lex_state = 461, .external_lex_state = 25},
  [10624] = {.lex_state = 461, .external_lex_state = 25},
  [10625] = {.lex_state = 177, .external_lex_state = 4},
  [10626] = {.lex_state = 266, .external_lex_state = 15},
  [10627] = {.lex_state = 461, .external_lex_state = 25},
  [10628] = {.lex_state = 177, .external_lex_state = 4},
  [10629] = {.lex_state = 461, .external_lex_state = 25},
  [10630] = {.lex_state = 461, .external_lex_state = 25},
  [10631] = {.lex_state = 177, .external_lex_state = 4},
  [10632] = {.lex_state = 266, .external_lex_state = 15},
  [10633] = {.lex_state = 461, .external_lex_state = 25},
  [10634] = {.lex_state = 177, .external_lex_state = 4},
  [10635] = {.lex_state = 461, .external_lex_state = 25},
  [10636] = {.lex_state = 310},
  [10637] = {.lex_state = 461, .external_lex_state = 25},
  [10638] = {.lex_state = 461, .external_lex_state = 25},
  [10639] = {.lex_state = 128, .external_lex_state = 2},
  [10640] = {.lex_state = 128, .external_lex_state = 2},
  [10641] = {.lex_state = 461, .external_lex_state = 25},
  [10642] = {.lex_state = 461, .external_lex_state = 25},
  [10643] = {.lex_state = 461, .external_lex_state = 25},
  [10644] = {.lex_state = 128},
  [10645] = {.lex_state = 128},
  [10646] = {.lex_state = 128, .external_lex_state = 2},
  [10647] = {.lex_state = 461, .external_lex_state = 25},
  [10648] = {.lex_state = 128},
  [10649] = {.lex_state = 128},
  [10650] = {.lex_state = 461, .external_lex_state = 25},
  [10651] = {.lex_state = 128},
  [10652] = {.lex_state = 461, .external_lex_state = 25},
  [10653] = {.lex_state = 128},
  [10654] = {.lex_state = 128, .external_lex_state = 2},
  [10655] = {.lex_state = 128},
  [10656] = {.lex_state = 128},
  [10657] = {.lex_state = 461, .external_lex_state = 25},
  [10658] = {.lex_state = 461, .external_lex_state = 25},
  [10659] = {.lex_state = 128},
  [10660] = {.lex_state = 128},
  [10661] = {.lex_state = 461, .external_lex_state = 25},
  [10662] = {.lex_state = 192, .external_lex_state = 2},
  [10663] = {.lex_state = 192, .external_lex_state = 29},
  [10664] = {.lex_state = 441, .external_lex_state = 25},
  [10665] = {.lex_state = 433, .external_lex_state = 16},
  [10666] = {.lex_state = 128},
  [10667] = {.lex_state = 573, .external_lex_state = 25},
  [10668] = {.lex_state = 573, .external_lex_state = 25},
  [10669] = {.lex_state = 192, .external_lex_state = 2},
  [10670] = {.lex_state = 467, .external_lex_state = 3},
  [10671] = {.lex_state = 467, .external_lex_state = 3},
  [10672] = {.lex_state = 192, .external_lex_state = 2},
  [10673] = {.lex_state = 192, .external_lex_state = 29},
  [10674] = {.lex_state = 467, .external_lex_state = 3},
  [10675] = {.lex_state = 588, .external_lex_state = 3},
  [10676] = {.lex_state = 588, .external_lex_state = 3},
  [10677] = {.lex_state = 192, .external_lex_state = 2},
  [10678] = {.lex_state = 192, .external_lex_state = 29},
  [10679] = {.lex_state = 441, .external_lex_state = 3},
  [10680] = {.lex_state = 573, .external_lex_state = 3},
  [10681] = {.lex_state = 573, .external_lex_state = 3},
  [10682] = {.lex_state = 192, .external_lex_state = 2},
  [10683] = {.lex_state = 192, .external_lex_state = 2},
  [10684] = {.lex_state = 192, .external_lex_state = 29},
  [10685] = {.lex_state = 467, .external_lex_state = 25},
  [10686] = {.lex_state = 588, .external_lex_state = 25},
  [10687] = {.lex_state = 588, .external_lex_state = 25},
  [10688] = {.lex_state = 595, .external_lex_state = 26},
  [10689] = {.lex_state = 192, .external_lex_state = 2},
  [10690] = {.lex_state = 192, .external_lex_state = 29},
  [10691] = {.lex_state = 441, .external_lex_state = 25},
  [10692] = {.lex_state = 461, .external_lex_state = 25},
  [10693] = {.lex_state = 128},
  [10694] = {.lex_state = 573, .external_lex_state = 25},
  [10695] = {.lex_state = 573, .external_lex_state = 25},
  [10696] = {.lex_state = 288, .external_lex_state = 16},
  [10697] = {.lex_state = 288, .external_lex_state = 16},
  [10698] = {.lex_state = 397, .external_lex_state = 25},
  [10699] = {.lex_state = 397, .external_lex_state = 25},
  [10700] = {.lex_state = 397, .external_lex_state = 25},
  [10701] = {.lex_state = 397, .external_lex_state = 25},
  [10702] = {.lex_state = 128},
  [10703] = {.lex_state = 397, .external_lex_state = 25},
  [10704] = {.lex_state = 397, .external_lex_state = 25},
  [10705] = {.lex_state = 299, .external_lex_state = 16},
  [10706] = {.lex_state = 397, .external_lex_state = 25},
  [10707] = {.lex_state = 397, .external_lex_state = 25},
  [10708] = {.lex_state = 302, .external_lex_state = 16},
  [10709] = {.lex_state = 192, .external_lex_state = 2},
  [10710] = {.lex_state = 192, .external_lex_state = 29},
  [10711] = {.lex_state = 493, .external_lex_state = 25},
  [10712] = {.lex_state = 493, .external_lex_state = 25},
  [10713] = {.lex_state = 493, .external_lex_state = 25},
  [10714] = {.lex_state = 192, .external_lex_state = 2},
  [10715] = {.lex_state = 192, .external_lex_state = 29},
  [10716] = {.lex_state = 321, .external_lex_state = 25},
  [10717] = {.lex_state = 497, .external_lex_state = 25},
  [10718] = {.lex_state = 497, .external_lex_state = 25},
  [10719] = {.lex_state = 192, .external_lex_state = 2},
  [10720] = {.lex_state = 678, .external_lex_state = 8},
  [10721] = {.lex_state = 678, .external_lex_state = 8},
  [10722] = {.lex_state = 128},
  [10723] = {.lex_state = 128, .external_lex_state = 2},
  [10724] = {.lex_state = 254, .external_lex_state = 8},
  [10725] = {.lex_state = 621, .external_lex_state = 25},
  [10726] = {.lex_state = 621, .external_lex_state = 25},
  [10727] = {.lex_state = 621, .external_lex_state = 25},
  [10728] = {.lex_state = 524, .external_lex_state = 21},
  [10729] = {.lex_state = 621, .external_lex_state = 25},
  [10730] = {.lex_state = 621, .external_lex_state = 25},
  [10731] = {.lex_state = 192, .external_lex_state = 2},
  [10732] = {.lex_state = 192, .external_lex_state = 29},
  [10733] = {.lex_state = 621, .external_lex_state = 25},
  [10734] = {.lex_state = 604, .external_lex_state = 25},
  [10735] = {.lex_state = 604, .external_lex_state = 25},
  [10736] = {.lex_state = 493, .external_lex_state = 3},
  [10737] = {.lex_state = 493, .external_lex_state = 3},
  [10738] = {.lex_state = 321, .external_lex_state = 3},
  [10739] = {.lex_state = 321, .external_lex_state = 3},
  [10740] = {.lex_state = 302, .external_lex_state = 3},
  [10741] = {.lex_state = 361, .external_lex_state = 25},
  [10742] = {.lex_state = 424, .external_lex_state = 25},
  [10743] = {.lex_state = 424, .external_lex_state = 25},
  [10744] = {.lex_state = 424, .external_lex_state = 25},
  [10745] = {.lex_state = 424, .external_lex_state = 25},
  [10746] = {.lex_state = 424, .external_lex_state = 25},
  [10747] = {.lex_state = 424, .external_lex_state = 25},
  [10748] = {.lex_state = 554, .external_lex_state = 16},
  [10749] = {.lex_state = 424, .external_lex_state = 25},
  [10750] = {.lex_state = 424, .external_lex_state = 25},
  [10751] = {.lex_state = 424, .external_lex_state = 25},
  [10752] = {.lex_state = 424, .external_lex_state = 25},
  [10753] = {.lex_state = 424, .external_lex_state = 25},
  [10754] = {.lex_state = 424, .external_lex_state = 25},
  [10755] = {.lex_state = 424, .external_lex_state = 25},
  [10756] = {.lex_state = 424, .external_lex_state = 25},
  [10757] = {.lex_state = 424, .external_lex_state = 27},
  [10758] = {.lex_state = 361, .external_lex_state = 25},
  [10759] = {.lex_state = 330},
  [10760] = {.lex_state = 337},
  [10761] = {.lex_state = 621, .external_lex_state = 25},
  [10762] = {.lex_state = 177, .external_lex_state = 4},
  [10763] = {.lex_state = 621, .external_lex_state = 25},
  [10764] = {.lex_state = 621, .external_lex_state = 25},
  [10765] = {.lex_state = 177, .external_lex_state = 4},
  [10766] = {.lex_state = 621, .external_lex_state = 25},
  [10767] = {.lex_state = 225, .external_lex_state = 7},
  [10768] = {.lex_state = 621, .external_lex_state = 25},
  [10769] = {.lex_state = 621, .external_lex_state = 25},
  [10770] = {.lex_state = 621, .external_lex_state = 25},
  [10771] = {.lex_state = 621, .external_lex_state = 25},
  [10772] = {.lex_state = 621, .external_lex_state = 25},
  [10773] = {.lex_state = 621, .external_lex_state = 25},
  [10774] = {.lex_state = 128},
  [10775] = {.lex_state = 128},
  [10776] = {.lex_state = 621, .external_lex_state = 25},
  [10777] = {.lex_state = 128},
  [10778] = {.lex_state = 621, .external_lex_state = 25},
  [10779] = {.lex_state = 621, .external_lex_state = 25},
  [10780] = {.lex_state = 621, .external_lex_state = 25},
  [10781] = {.lex_state = 128},
  [10782] = {.lex_state = 621, .external_lex_state = 25},
  [10783] = {.lex_state = 128},
  [10784] = {.lex_state = 621, .external_lex_state = 25},
  [10785] = {.lex_state = 128},
  [10786] = {.lex_state = 621, .external_lex_state = 25},
  [10787] = {.lex_state = 621, .external_lex_state = 25},
  [10788] = {.lex_state = 128},
  [10789] = {.lex_state = 128, .external_lex_state = 2},
  [10790] = {.lex_state = 627, .external_lex_state = 25},
  [10791] = {.lex_state = 621, .external_lex_state = 25},
  [10792] = {.lex_state = 627, .external_lex_state = 25},
  [10793] = {.lex_state = 508, .external_lex_state = 25},
  [10794] = {.lex_state = 508, .external_lex_state = 25},
  [10795] = {.lex_state = 302, .external_lex_state = 25},
  [10796] = {.lex_state = 302, .external_lex_state = 25},
  [10797] = {.lex_state = 299, .external_lex_state = 3},
  [10798] = {.lex_state = 361, .external_lex_state = 3},
  [10799] = {.lex_state = 361, .external_lex_state = 3},
  [10800] = {.lex_state = 361, .external_lex_state = 3},
  [10801] = {.lex_state = 361, .external_lex_state = 3},
  [10802] = {.lex_state = 361, .external_lex_state = 3},
  [10803] = {.lex_state = 361, .external_lex_state = 3},
  [10804] = {.lex_state = 361, .external_lex_state = 3},
  [10805] = {.lex_state = 361, .external_lex_state = 3},
  [10806] = {.lex_state = 361, .external_lex_state = 3},
  [10807] = {.lex_state = 361, .external_lex_state = 3},
  [10808] = {.lex_state = 554, .external_lex_state = 16},
  [10809] = {.lex_state = 361, .external_lex_state = 3},
  [10810] = {.lex_state = 361, .external_lex_state = 3},
  [10811] = {.lex_state = 361, .external_lex_state = 3},
  [10812] = {.lex_state = 361, .external_lex_state = 3},
  [10813] = {.lex_state = 361, .external_lex_state = 3},
  [10814] = {.lex_state = 361, .external_lex_state = 3},
  [10815] = {.lex_state = 361, .external_lex_state = 3},
  [10816] = {.lex_state = 361, .external_lex_state = 3},
  [10817] = {.lex_state = 365, .external_lex_state = 14},
  [10818] = {.lex_state = 361, .external_lex_state = 3},
  [10819] = {.lex_state = 361, .external_lex_state = 3},
  [10820] = {.lex_state = 361, .external_lex_state = 3},
  [10821] = {.lex_state = 524, .external_lex_state = 21},
  [10822] = {.lex_state = 361, .external_lex_state = 3},
  [10823] = {.lex_state = 361, .external_lex_state = 3},
  [10824] = {.lex_state = 192, .external_lex_state = 2},
  [10825] = {.lex_state = 421, .external_lex_state = 3},
  [10826] = {.lex_state = 421, .external_lex_state = 3},
  [10827] = {.lex_state = 421, .external_lex_state = 3},
  [10828] = {.lex_state = 524, .external_lex_state = 21},
  [10829] = {.lex_state = 421, .external_lex_state = 3},
  [10830] = {.lex_state = 421, .external_lex_state = 3},
  [10831] = {.lex_state = 192, .external_lex_state = 29},
  [10832] = {.lex_state = 361, .external_lex_state = 3},
  [10833] = {.lex_state = 128},
  [10834] = {.lex_state = 247, .external_lex_state = 3},
  [10835] = {.lex_state = 424, .external_lex_state = 3},
  [10836] = {.lex_state = 424, .external_lex_state = 3},
  [10837] = {.lex_state = 424, .external_lex_state = 3},
  [10838] = {.lex_state = 424, .external_lex_state = 3},
  [10839] = {.lex_state = 424, .external_lex_state = 3},
  [10840] = {.lex_state = 424, .external_lex_state = 3},
  [10841] = {.lex_state = 554, .external_lex_state = 16},
  [10842] = {.lex_state = 424, .external_lex_state = 3},
  [10843] = {.lex_state = 424, .external_lex_state = 3},
  [10844] = {.lex_state = 424, .external_lex_state = 3},
  [10845] = {.lex_state = 424, .external_lex_state = 3},
  [10846] = {.lex_state = 424, .external_lex_state = 3},
  [10847] = {.lex_state = 424, .external_lex_state = 3},
  [10848] = {.lex_state = 424, .external_lex_state = 3},
  [10849] = {.lex_state = 424, .external_lex_state = 3},
  [10850] = {.lex_state = 424, .external_lex_state = 14},
  [10851] = {.lex_state = 192, .external_lex_state = 2},
  [10852] = {.lex_state = 192, .external_lex_state = 29},
  [10853] = {.lex_state = 421, .external_lex_state = 3},
  [10854] = {.lex_state = 528, .external_lex_state = 3},
  [10855] = {.lex_state = 528, .external_lex_state = 3},
  [10856] = {.lex_state = 528, .external_lex_state = 3},
  [10857] = {.lex_state = 528, .external_lex_state = 3},
  [10858] = {.lex_state = 528, .external_lex_state = 3},
  [10859] = {.lex_state = 528, .external_lex_state = 3},
  [10860] = {.lex_state = 554, .external_lex_state = 16},
  [10861] = {.lex_state = 528, .external_lex_state = 3},
  [10862] = {.lex_state = 528, .external_lex_state = 3},
  [10863] = {.lex_state = 528, .external_lex_state = 3},
  [10864] = {.lex_state = 528, .external_lex_state = 3},
  [10865] = {.lex_state = 528, .external_lex_state = 3},
  [10866] = {.lex_state = 528, .external_lex_state = 3},
  [10867] = {.lex_state = 528, .external_lex_state = 3},
  [10868] = {.lex_state = 528, .external_lex_state = 3},
  [10869] = {.lex_state = 424, .external_lex_state = 3},
  [10870] = {.lex_state = 424, .external_lex_state = 3},
  [10871] = {.lex_state = 528, .external_lex_state = 3},
  [10872] = {.lex_state = 361, .external_lex_state = 3},
  [10873] = {.lex_state = 361, .external_lex_state = 3},
  [10874] = {.lex_state = 361, .external_lex_state = 3},
  [10875] = {.lex_state = 361, .external_lex_state = 3},
  [10876] = {.lex_state = 361, .external_lex_state = 3},
  [10877] = {.lex_state = 361, .external_lex_state = 3},
  [10878] = {.lex_state = 361, .external_lex_state = 3},
  [10879] = {.lex_state = 361, .external_lex_state = 3},
  [10880] = {.lex_state = 554, .external_lex_state = 16},
  [10881] = {.lex_state = 361, .external_lex_state = 3},
  [10882] = {.lex_state = 361, .external_lex_state = 3},
  [10883] = {.lex_state = 361, .external_lex_state = 3},
  [10884] = {.lex_state = 361, .external_lex_state = 3},
  [10885] = {.lex_state = 361, .external_lex_state = 3},
  [10886] = {.lex_state = 361, .external_lex_state = 3},
  [10887] = {.lex_state = 361, .external_lex_state = 3},
  [10888] = {.lex_state = 361, .external_lex_state = 3},
  [10889] = {.lex_state = 365, .external_lex_state = 14},
  [10890] = {.lex_state = 361, .external_lex_state = 3},
  [10891] = {.lex_state = 361, .external_lex_state = 3},
  [10892] = {.lex_state = 361, .external_lex_state = 3},
  [10893] = {.lex_state = 524, .external_lex_state = 21},
  [10894] = {.lex_state = 361, .external_lex_state = 3},
  [10895] = {.lex_state = 361, .external_lex_state = 3},
  [10896] = {.lex_state = 192, .external_lex_state = 2},
  [10897] = {.lex_state = 421, .external_lex_state = 3},
  [10898] = {.lex_state = 421, .external_lex_state = 3},
  [10899] = {.lex_state = 421, .external_lex_state = 3},
  [10900] = {.lex_state = 524, .external_lex_state = 21},
  [10901] = {.lex_state = 421, .external_lex_state = 3},
  [10902] = {.lex_state = 421, .external_lex_state = 3},
  [10903] = {.lex_state = 192, .external_lex_state = 29},
  [10904] = {.lex_state = 361, .external_lex_state = 3},
  [10905] = {.lex_state = 247, .external_lex_state = 3},
  [10906] = {.lex_state = 424, .external_lex_state = 3},
  [10907] = {.lex_state = 424, .external_lex_state = 3},
  [10908] = {.lex_state = 424, .external_lex_state = 3},
  [10909] = {.lex_state = 424, .external_lex_state = 3},
  [10910] = {.lex_state = 424, .external_lex_state = 3},
  [10911] = {.lex_state = 424, .external_lex_state = 3},
  [10912] = {.lex_state = 554, .external_lex_state = 16},
  [10913] = {.lex_state = 424, .external_lex_state = 3},
  [10914] = {.lex_state = 424, .external_lex_state = 3},
  [10915] = {.lex_state = 424, .external_lex_state = 3},
  [10916] = {.lex_state = 424, .external_lex_state = 3},
  [10917] = {.lex_state = 424, .external_lex_state = 3},
  [10918] = {.lex_state = 424, .external_lex_state = 3},
  [10919] = {.lex_state = 424, .external_lex_state = 3},
  [10920] = {.lex_state = 424, .external_lex_state = 3},
  [10921] = {.lex_state = 424, .external_lex_state = 14},
  [10922] = {.lex_state = 192, .external_lex_state = 2},
  [10923] = {.lex_state = 192, .external_lex_state = 29},
  [10924] = {.lex_state = 421, .external_lex_state = 3},
  [10925] = {.lex_state = 528, .external_lex_state = 3},
  [10926] = {.lex_state = 528, .external_lex_state = 3},
  [10927] = {.lex_state = 528, .external_lex_state = 3},
  [10928] = {.lex_state = 528, .external_lex_state = 3},
  [10929] = {.lex_state = 528, .external_lex_state = 3},
  [10930] = {.lex_state = 528, .external_lex_state = 3},
  [10931] = {.lex_state = 554, .external_lex_state = 16},
  [10932] = {.lex_state = 528, .external_lex_state = 3},
  [10933] = {.lex_state = 528, .external_lex_state = 3},
  [10934] = {.lex_state = 528, .external_lex_state = 3},
  [10935] = {.lex_state = 528, .external_lex_state = 3},
  [10936] = {.lex_state = 528, .external_lex_state = 3},
  [10937] = {.lex_state = 528, .external_lex_state = 3},
  [10938] = {.lex_state = 528, .external_lex_state = 3},
  [10939] = {.lex_state = 528, .external_lex_state = 3},
  [10940] = {.lex_state = 361, .external_lex_state = 3},
  [10941] = {.lex_state = 361, .external_lex_state = 3},
  [10942] = {.lex_state = 424, .external_lex_state = 3},
  [10943] = {.lex_state = 424, .external_lex_state = 3},
  [10944] = {.lex_state = 528, .external_lex_state = 3},
  [10945] = {.lex_state = 508, .external_lex_state = 25},
  [10946] = {.lex_state = 424, .external_lex_state = 25},
  [10947] = {.lex_state = 424, .external_lex_state = 25},
  [10948] = {.lex_state = 424, .external_lex_state = 25},
  [10949] = {.lex_state = 424, .external_lex_state = 25},
  [10950] = {.lex_state = 424, .external_lex_state = 25},
  [10951] = {.lex_state = 424, .external_lex_state = 25},
  [10952] = {.lex_state = 554, .external_lex_state = 16},
  [10953] = {.lex_state = 424, .external_lex_state = 25},
  [10954] = {.lex_state = 424, .external_lex_state = 25},
  [10955] = {.lex_state = 424, .external_lex_state = 25},
  [10956] = {.lex_state = 424, .external_lex_state = 25},
  [10957] = {.lex_state = 424, .external_lex_state = 25},
  [10958] = {.lex_state = 424, .external_lex_state = 25},
  [10959] = {.lex_state = 424, .external_lex_state = 25},
  [10960] = {.lex_state = 424, .external_lex_state = 25},
  [10961] = {.lex_state = 424, .external_lex_state = 27},
  [10962] = {.lex_state = 508, .external_lex_state = 25},
  [10963] = {.lex_state = 421, .external_lex_state = 25},
  [10964] = {.lex_state = 421, .external_lex_state = 25},
  [10965] = {.lex_state = 361, .external_lex_state = 3},
  [10966] = {.lex_state = 361, .external_lex_state = 3},
  [10967] = {.lex_state = 528, .external_lex_state = 3},
  [10968] = {.lex_state = 361, .external_lex_state = 3},
  [10969] = {.lex_state = 361, .external_lex_state = 3},
  [10970] = {.lex_state = 361, .external_lex_state = 3},
  [10971] = {.lex_state = 361, .external_lex_state = 3},
  [10972] = {.lex_state = 361, .external_lex_state = 3},
  [10973] = {.lex_state = 361, .external_lex_state = 3},
  [10974] = {.lex_state = 554, .external_lex_state = 16},
  [10975] = {.lex_state = 361, .external_lex_state = 3},
  [10976] = {.lex_state = 361, .external_lex_state = 3},
  [10977] = {.lex_state = 361, .external_lex_state = 3},
  [10978] = {.lex_state = 361, .external_lex_state = 3},
  [10979] = {.lex_state = 361, .external_lex_state = 3},
  [10980] = {.lex_state = 361, .external_lex_state = 3},
  [10981] = {.lex_state = 361, .external_lex_state = 3},
  [10982] = {.lex_state = 361, .external_lex_state = 3},
  [10983] = {.lex_state = 192, .external_lex_state = 2},
  [10984] = {.lex_state = 511, .external_lex_state = 11},
  [10985] = {.lex_state = 511, .external_lex_state = 11},
  [10986] = {.lex_state = 511, .external_lex_state = 11},
  [10987] = {.lex_state = 511, .external_lex_state = 11},
  [10988] = {.lex_state = 192, .external_lex_state = 2},
  [10989] = {.lex_state = 192, .external_lex_state = 2},
  [10990] = {.lex_state = 192, .external_lex_state = 2},
  [10991] = {.lex_state = 361, .external_lex_state = 3},
  [10992] = {.lex_state = 213},
  [10993] = {.lex_state = 259, .external_lex_state = 3},
  [10994] = {.lex_state = 365, .external_lex_state = 14},
  [10995] = {.lex_state = 361, .external_lex_state = 3},
  [10996] = {.lex_state = 361, .external_lex_state = 3},
  [10997] = {.lex_state = 361, .external_lex_state = 14},
  [10998] = {.lex_state = 192, .external_lex_state = 2},
  [10999] = {.lex_state = 361, .external_lex_state = 3},
  [11000] = {.lex_state = 192, .external_lex_state = 2},
  [11001] = {.lex_state = 192, .external_lex_state = 2},
  [11002] = {.lex_state = 237},
  [11003] = {.lex_state = 192, .external_lex_state = 2},
  [11004] = {.lex_state = 358, .external_lex_state = 11},
  [11005] = {.lex_state = 361, .external_lex_state = 3},
  [11006] = {.lex_state = 361, .external_lex_state = 3},
  [11007] = {.lex_state = 361, .external_lex_state = 3},
  [11008] = {.lex_state = 371, .external_lex_state = 14},
  [11009] = {.lex_state = 361, .external_lex_state = 3},
  [11010] = {.lex_state = 361, .external_lex_state = 3},
  [11011] = {.lex_state = 192, .external_lex_state = 2},
  [11012] = {.lex_state = 192, .external_lex_state = 2},
  [11013] = {.lex_state = 192, .external_lex_state = 2},
  [11014] = {.lex_state = 192, .external_lex_state = 2},
  [11015] = {.lex_state = 192, .external_lex_state = 2},
  [11016] = {.lex_state = 192, .external_lex_state = 2},
  [11017] = {.lex_state = 192, .external_lex_state = 2},
  [11018] = {.lex_state = 192, .external_lex_state = 2},
  [11019] = {.lex_state = 192, .external_lex_state = 2},
  [11020] = {.lex_state = 192, .external_lex_state = 2},
  [11021] = {.lex_state = 192, .external_lex_state = 2},
  [11022] = {.lex_state = 192, .external_lex_state = 2},
  [11023] = {.lex_state = 192, .external_lex_state = 2},
  [11024] = {.lex_state = 192, .external_lex_state = 2},
  [11025] = {.lex_state = 192, .external_lex_state = 2},
  [11026] = {.lex_state = 237},
  [11027] = {.lex_state = 192, .external_lex_state = 2},
  [11028] = {.lex_state = 358, .external_lex_state = 11},
  [11029] = {.lex_state = 421, .external_lex_state = 3},
  [11030] = {.lex_state = 421, .external_lex_state = 3},
  [11031] = {.lex_state = 421, .external_lex_state = 3},
  [11032] = {.lex_state = 427, .external_lex_state = 14},
  [11033] = {.lex_state = 262, .external_lex_state = 3},
  [11034] = {.lex_state = 524, .external_lex_state = 13},
  [11035] = {.lex_state = 361, .external_lex_state = 3},
  [11036] = {.lex_state = 192, .external_lex_state = 29},
  [11037] = {.lex_state = 192, .external_lex_state = 2},
  [11038] = {.lex_state = 361, .external_lex_state = 14},
  [11039] = {.lex_state = 254, .external_lex_state = 8},
  [11040] = {.lex_state = 128, .external_lex_state = 2},
  [11041] = {.lex_state = 128, .external_lex_state = 8},
  [11042] = {.lex_state = 247, .external_lex_state = 3},
  [11043] = {.lex_state = 247, .external_lex_state = 3},
  [11044] = {.lex_state = 247, .external_lex_state = 3},
  [11045] = {.lex_state = 247, .external_lex_state = 3},
  [11046] = {.lex_state = 247, .external_lex_state = 3},
  [11047] = {.lex_state = 247, .external_lex_state = 3},
  [11048] = {.lex_state = 247, .external_lex_state = 3},
  [11049] = {.lex_state = 247, .external_lex_state = 3},
  [11050] = {.lex_state = 247, .external_lex_state = 3},
  [11051] = {.lex_state = 247, .external_lex_state = 3},
  [11052] = {.lex_state = 247, .external_lex_state = 3},
  [11053] = {.lex_state = 554, .external_lex_state = 16},
  [11054] = {.lex_state = 247, .external_lex_state = 3},
  [11055] = {.lex_state = 247, .external_lex_state = 3},
  [11056] = {.lex_state = 247, .external_lex_state = 3},
  [11057] = {.lex_state = 247, .external_lex_state = 3},
  [11058] = {.lex_state = 247, .external_lex_state = 3},
  [11059] = {.lex_state = 192, .external_lex_state = 2},
  [11060] = {.lex_state = 254, .external_lex_state = 11},
  [11061] = {.lex_state = 254, .external_lex_state = 11},
  [11062] = {.lex_state = 254, .external_lex_state = 11},
  [11063] = {.lex_state = 254, .external_lex_state = 11},
  [11064] = {.lex_state = 192, .external_lex_state = 2},
  [11065] = {.lex_state = 192, .external_lex_state = 2},
  [11066] = {.lex_state = 192, .external_lex_state = 2},
  [11067] = {.lex_state = 424, .external_lex_state = 3},
  [11068] = {.lex_state = 254, .external_lex_state = 11},
  [11069] = {.lex_state = 213},
  [11070] = {.lex_state = 424, .external_lex_state = 3},
  [11071] = {.lex_state = 424, .external_lex_state = 14},
  [11072] = {.lex_state = 424, .external_lex_state = 3},
  [11073] = {.lex_state = 421, .external_lex_state = 3},
  [11074] = {.lex_state = 421, .external_lex_state = 14},
  [11075] = {.lex_state = 192, .external_lex_state = 2},
  [11076] = {.lex_state = 424, .external_lex_state = 3},
  [11077] = {.lex_state = 421, .external_lex_state = 3},
  [11078] = {.lex_state = 421, .external_lex_state = 3},
  [11079] = {.lex_state = 192, .external_lex_state = 2},
  [11080] = {.lex_state = 192, .external_lex_state = 2},
  [11081] = {.lex_state = 192, .external_lex_state = 2},
  [11082] = {.lex_state = 192, .external_lex_state = 2},
  [11083] = {.lex_state = 192, .external_lex_state = 2},
  [11084] = {.lex_state = 192, .external_lex_state = 2},
  [11085] = {.lex_state = 192, .external_lex_state = 2},
  [11086] = {.lex_state = 192, .external_lex_state = 2},
  [11087] = {.lex_state = 192, .external_lex_state = 2},
  [11088] = {.lex_state = 192, .external_lex_state = 2},
  [11089] = {.lex_state = 192, .external_lex_state = 2},
  [11090] = {.lex_state = 192, .external_lex_state = 2},
  [11091] = {.lex_state = 192, .external_lex_state = 2},
  [11092] = {.lex_state = 424, .external_lex_state = 3},
  [11093] = {.lex_state = 524, .external_lex_state = 13},
  [11094] = {.lex_state = 424, .external_lex_state = 3},
  [11095] = {.lex_state = 192, .external_lex_state = 29},
  [11096] = {.lex_state = 192, .external_lex_state = 2},
  [11097] = {.lex_state = 421, .external_lex_state = 14},
  [11098] = {.lex_state = 192, .external_lex_state = 2},
  [11099] = {.lex_state = 192, .external_lex_state = 2},
  [11100] = {.lex_state = 192, .external_lex_state = 2},
  [11101] = {.lex_state = 192, .external_lex_state = 2},
  [11102] = {.lex_state = 192, .external_lex_state = 2},
  [11103] = {.lex_state = 528, .external_lex_state = 3},
  [11104] = {.lex_state = 528, .external_lex_state = 3},
  [11105] = {.lex_state = 213},
  [11106] = {.lex_state = 259, .external_lex_state = 3},
  [11107] = {.lex_state = 247, .external_lex_state = 3},
  [11108] = {.lex_state = 262, .external_lex_state = 14},
  [11109] = {.lex_state = 128},
  [11110] = {.lex_state = 528, .external_lex_state = 3},
  [11111] = {.lex_state = 424, .external_lex_state = 3},
  [11112] = {.lex_state = 424, .external_lex_state = 3},
  [11113] = {.lex_state = 424, .external_lex_state = 3},
  [11114] = {.lex_state = 424, .external_lex_state = 3},
  [11115] = {.lex_state = 424, .external_lex_state = 3},
  [11116] = {.lex_state = 424, .external_lex_state = 3},
  [11117] = {.lex_state = 554, .external_lex_state = 16},
  [11118] = {.lex_state = 424, .external_lex_state = 3},
  [11119] = {.lex_state = 424, .external_lex_state = 3},
  [11120] = {.lex_state = 424, .external_lex_state = 3},
  [11121] = {.lex_state = 424, .external_lex_state = 3},
  [11122] = {.lex_state = 424, .external_lex_state = 3},
  [11123] = {.lex_state = 424, .external_lex_state = 3},
  [11124] = {.lex_state = 424, .external_lex_state = 3},
  [11125] = {.lex_state = 424, .external_lex_state = 3},
  [11126] = {.lex_state = 424, .external_lex_state = 14},
  [11127] = {.lex_state = 528, .external_lex_state = 3},
  [11128] = {.lex_state = 361, .external_lex_state = 3},
  [11129] = {.lex_state = 361, .external_lex_state = 3},
  [11130] = {.lex_state = 361, .external_lex_state = 3},
  [11131] = {.lex_state = 361, .external_lex_state = 3},
  [11132] = {.lex_state = 350, .external_lex_state = 23},
  [11133] = {.lex_state = 209},
  [11134] = {.lex_state = 343, .external_lex_state = 8},
  [11135] = {.lex_state = 508, .external_lex_state = 3},
  [11136] = {.lex_state = 508, .external_lex_state = 3},
  [11137] = {.lex_state = 192, .external_lex_state = 2},
  [11138] = {.lex_state = 508, .external_lex_state = 3},
  [11139] = {.lex_state = 192, .external_lex_state = 2},
  [11140] = {.lex_state = 508, .external_lex_state = 3},
  [11141] = {.lex_state = 524, .external_lex_state = 13},
  [11142] = {.lex_state = 508, .external_lex_state = 3},
  [11143] = {.lex_state = 508, .external_lex_state = 3},
  [11144] = {.lex_state = 508, .external_lex_state = 3},
  [11145] = {.lex_state = 508, .external_lex_state = 3},
  [11146] = {.lex_state = 508, .external_lex_state = 3},
  [11147] = {.lex_state = 508, .external_lex_state = 3},
  [11148] = {.lex_state = 508, .external_lex_state = 3},
  [11149] = {.lex_state = 554, .external_lex_state = 16},
  [11150] = {.lex_state = 508, .external_lex_state = 3},
  [11151] = {.lex_state = 508, .external_lex_state = 3},
  [11152] = {.lex_state = 508, .external_lex_state = 3},
  [11153] = {.lex_state = 508, .external_lex_state = 3},
  [11154] = {.lex_state = 508, .external_lex_state = 3},
  [11155] = {.lex_state = 508, .external_lex_state = 3},
  [11156] = {.lex_state = 508, .external_lex_state = 3},
  [11157] = {.lex_state = 508, .external_lex_state = 3},
  [11158] = {.lex_state = 631, .external_lex_state = 14},
  [11159] = {.lex_state = 508, .external_lex_state = 3},
  [11160] = {.lex_state = 508, .external_lex_state = 3},
  [11161] = {.lex_state = 508, .external_lex_state = 3},
  [11162] = {.lex_state = 524, .external_lex_state = 21},
  [11163] = {.lex_state = 508, .external_lex_state = 3},
  [11164] = {.lex_state = 508, .external_lex_state = 3},
  [11165] = {.lex_state = 343, .external_lex_state = 8},
  [11166] = {.lex_state = 192, .external_lex_state = 2},
  [11167] = {.lex_state = 343, .external_lex_state = 8},
  [11168] = {.lex_state = 678, .external_lex_state = 8},
  [11169] = {.lex_state = 192, .external_lex_state = 29},
  [11170] = {.lex_state = 508, .external_lex_state = 3},
  [11171] = {.lex_state = 421, .external_lex_state = 3},
  [11172] = {.lex_state = 421, .external_lex_state = 3},
  [11173] = {.lex_state = 361, .external_lex_state = 3},
  [11174] = {.lex_state = 361, .external_lex_state = 3},
  [11175] = {.lex_state = 192, .external_lex_state = 2},
  [11176] = {.lex_state = 192, .external_lex_state = 29},
  [11177] = {.lex_state = 361, .external_lex_state = 3},
  [11178] = {.lex_state = 361, .external_lex_state = 3},
  [11179] = {.lex_state = 361, .external_lex_state = 3},
  [11180] = {.lex_state = 192, .external_lex_state = 2},
  [11181] = {.lex_state = 192, .external_lex_state = 29},
  [11182] = {.lex_state = 424, .external_lex_state = 3},
  [11183] = {.lex_state = 421, .external_lex_state = 3},
  [11184] = {.lex_state = 421, .external_lex_state = 3},
  [11185] = {.lex_state = 192, .external_lex_state = 2},
  [11186] = {.lex_state = 361, .external_lex_state = 3},
  [11187] = {.lex_state = 361, .external_lex_state = 3},
  [11188] = {.lex_state = 192, .external_lex_state = 2},
  [11189] = {.lex_state = 192, .external_lex_state = 29},
  [11190] = {.lex_state = 361, .external_lex_state = 3},
  [11191] = {.lex_state = 361, .external_lex_state = 3},
  [11192] = {.lex_state = 361, .external_lex_state = 3},
  [11193] = {.lex_state = 192, .external_lex_state = 2},
  [11194] = {.lex_state = 192, .external_lex_state = 29},
  [11195] = {.lex_state = 424, .external_lex_state = 3},
  [11196] = {.lex_state = 421, .external_lex_state = 3},
  [11197] = {.lex_state = 421, .external_lex_state = 3},
  [11198] = {.lex_state = 192, .external_lex_state = 2},
  [11199] = {.lex_state = 424, .external_lex_state = 3},
  [11200] = {.lex_state = 424, .external_lex_state = 3},
  [11201] = {.lex_state = 528, .external_lex_state = 3},
  [11202] = {.lex_state = 192, .external_lex_state = 2},
  [11203] = {.lex_state = 192, .external_lex_state = 29},
  [11204] = {.lex_state = 406, .external_lex_state = 25},
  [11205] = {.lex_state = 192, .external_lex_state = 2},
  [11206] = {.lex_state = 192, .external_lex_state = 29},
  [11207] = {.lex_state = 537, .external_lex_state = 25},
  [11208] = {.lex_state = 388, .external_lex_state = 25},
  [11209] = {.lex_state = 388, .external_lex_state = 25},
  [11210] = {.lex_state = 397, .external_lex_state = 25},
  [11211] = {.lex_state = 286, .external_lex_state = 2},
  [11212] = {.lex_state = 192, .external_lex_state = 2},
  [11213] = {.lex_state = 511, .external_lex_state = 26},
  [11214] = {.lex_state = 511, .external_lex_state = 26},
  [11215] = {.lex_state = 511, .external_lex_state = 26},
  [11216] = {.lex_state = 511, .external_lex_state = 26},
  [11217] = {.lex_state = 192, .external_lex_state = 2},
  [11218] = {.lex_state = 192, .external_lex_state = 2},
  [11219] = {.lex_state = 192, .external_lex_state = 2},
  [11220] = {.lex_state = 361, .external_lex_state = 25},
  [11221] = {.lex_state = 254, .external_lex_state = 26},
  [11222] = {.lex_state = 213},
  [11223] = {.lex_state = 259, .external_lex_state = 25},
  [11224] = {.lex_state = 365, .external_lex_state = 27},
  [11225] = {.lex_state = 361, .external_lex_state = 25},
  [11226] = {.lex_state = 361, .external_lex_state = 25},
  [11227] = {.lex_state = 361, .external_lex_state = 27},
  [11228] = {.lex_state = 192, .external_lex_state = 2},
  [11229] = {.lex_state = 361, .external_lex_state = 25},
  [11230] = {.lex_state = 192, .external_lex_state = 2},
  [11231] = {.lex_state = 192, .external_lex_state = 2},
  [11232] = {.lex_state = 237},
  [11233] = {.lex_state = 192, .external_lex_state = 2},
  [11234] = {.lex_state = 358, .external_lex_state = 26},
  [11235] = {.lex_state = 361, .external_lex_state = 25},
  [11236] = {.lex_state = 361, .external_lex_state = 25},
  [11237] = {.lex_state = 361, .external_lex_state = 25},
  [11238] = {.lex_state = 371, .external_lex_state = 27},
  [11239] = {.lex_state = 361, .external_lex_state = 25},
  [11240] = {.lex_state = 361, .external_lex_state = 25},
  [11241] = {.lex_state = 192, .external_lex_state = 2},
  [11242] = {.lex_state = 192, .external_lex_state = 2},
  [11243] = {.lex_state = 192, .external_lex_state = 2},
  [11244] = {.lex_state = 192, .external_lex_state = 2},
  [11245] = {.lex_state = 192, .external_lex_state = 2},
  [11246] = {.lex_state = 192, .external_lex_state = 2},
  [11247] = {.lex_state = 192, .external_lex_state = 2},
  [11248] = {.lex_state = 192, .external_lex_state = 2},
  [11249] = {.lex_state = 192, .external_lex_state = 2},
  [11250] = {.lex_state = 192, .external_lex_state = 2},
  [11251] = {.lex_state = 192, .external_lex_state = 2},
  [11252] = {.lex_state = 192, .external_lex_state = 2},
  [11253] = {.lex_state = 192, .external_lex_state = 2},
  [11254] = {.lex_state = 192, .external_lex_state = 2},
  [11255] = {.lex_state = 192, .external_lex_state = 2},
  [11256] = {.lex_state = 237},
  [11257] = {.lex_state = 192, .external_lex_state = 2},
  [11258] = {.lex_state = 358, .external_lex_state = 26},
  [11259] = {.lex_state = 421, .external_lex_state = 25},
  [11260] = {.lex_state = 421, .external_lex_state = 25},
  [11261] = {.lex_state = 421, .external_lex_state = 25},
  [11262] = {.lex_state = 427, .external_lex_state = 27},
  [11263] = {.lex_state = 361, .external_lex_state = 25},
  [11264] = {.lex_state = 524, .external_lex_state = 13},
  [11265] = {.lex_state = 361, .external_lex_state = 25},
  [11266] = {.lex_state = 192, .external_lex_state = 29},
  [11267] = {.lex_state = 192, .external_lex_state = 2},
  [11268] = {.lex_state = 361, .external_lex_state = 27},
  [11269] = {.lex_state = 302, .external_lex_state = 16},
  [11270] = {.lex_state = 302, .external_lex_state = 16},
  [11271] = {.lex_state = 302, .external_lex_state = 16},
  [11272] = {.lex_state = 302, .external_lex_state = 16},
  [11273] = {.lex_state = 302, .external_lex_state = 16},
  [11274] = {.lex_state = 302, .external_lex_state = 16},
  [11275] = {.lex_state = 554, .external_lex_state = 16},
  [11276] = {.lex_state = 302, .external_lex_state = 16},
  [11277] = {.lex_state = 302, .external_lex_state = 16},
  [11278] = {.lex_state = 302, .external_lex_state = 16},
  [11279] = {.lex_state = 302, .external_lex_state = 16},
  [11280] = {.lex_state = 302, .external_lex_state = 16},
  [11281] = {.lex_state = 192, .external_lex_state = 2},
  [11282] = {.lex_state = 254, .external_lex_state = 26},
  [11283] = {.lex_state = 254, .external_lex_state = 26},
  [11284] = {.lex_state = 254, .external_lex_state = 26},
  [11285] = {.lex_state = 254, .external_lex_state = 26},
  [11286] = {.lex_state = 192, .external_lex_state = 2},
  [11287] = {.lex_state = 192, .external_lex_state = 2},
  [11288] = {.lex_state = 192, .external_lex_state = 2},
  [11289] = {.lex_state = 424, .external_lex_state = 25},
  [11290] = {.lex_state = 254, .external_lex_state = 26},
  [11291] = {.lex_state = 213},
  [11292] = {.lex_state = 424, .external_lex_state = 25},
  [11293] = {.lex_state = 424, .external_lex_state = 27},
  [11294] = {.lex_state = 424, .external_lex_state = 25},
  [11295] = {.lex_state = 421, .external_lex_state = 25},
  [11296] = {.lex_state = 421, .external_lex_state = 27},
  [11297] = {.lex_state = 192, .external_lex_state = 2},
  [11298] = {.lex_state = 424, .external_lex_state = 25},
  [11299] = {.lex_state = 421, .external_lex_state = 25},
  [11300] = {.lex_state = 421, .external_lex_state = 25},
  [11301] = {.lex_state = 192, .external_lex_state = 2},
  [11302] = {.lex_state = 192, .external_lex_state = 2},
  [11303] = {.lex_state = 192, .external_lex_state = 2},
  [11304] = {.lex_state = 192, .external_lex_state = 2},
  [11305] = {.lex_state = 192, .external_lex_state = 2},
  [11306] = {.lex_state = 192, .external_lex_state = 2},
  [11307] = {.lex_state = 192, .external_lex_state = 2},
  [11308] = {.lex_state = 192, .external_lex_state = 2},
  [11309] = {.lex_state = 192, .external_lex_state = 2},
  [11310] = {.lex_state = 192, .external_lex_state = 2},
  [11311] = {.lex_state = 192, .external_lex_state = 2},
  [11312] = {.lex_state = 192, .external_lex_state = 2},
  [11313] = {.lex_state = 192, .external_lex_state = 2},
  [11314] = {.lex_state = 424, .external_lex_state = 25},
  [11315] = {.lex_state = 524, .external_lex_state = 13},
  [11316] = {.lex_state = 424, .external_lex_state = 25},
  [11317] = {.lex_state = 192, .external_lex_state = 29},
  [11318] = {.lex_state = 192, .external_lex_state = 2},
  [11319] = {.lex_state = 421, .external_lex_state = 27},
  [11320] = {.lex_state = 192, .external_lex_state = 2},
  [11321] = {.lex_state = 302, .external_lex_state = 16},
  [11322] = {.lex_state = 302, .external_lex_state = 16},
  [11323] = {.lex_state = 302, .external_lex_state = 16},
  [11324] = {.lex_state = 251, .external_lex_state = 20},
  [11325] = {.lex_state = 237},
  [11326] = {.lex_state = 237},
  [11327] = {.lex_state = 128, .external_lex_state = 12},
  [11328] = {.lex_state = 237},
  [11329] = {.lex_state = 237},
  [11330] = {.lex_state = 302, .external_lex_state = 16},
  [11331] = {.lex_state = 302, .external_lex_state = 16},
  [11332] = {.lex_state = 645, .external_lex_state = 25},
  [11333] = {.lex_state = 645, .external_lex_state = 25},
  [11334] = {.lex_state = 192, .external_lex_state = 2},
  [11335] = {.lex_state = 192, .external_lex_state = 29},
  [11336] = {.lex_state = 645, .external_lex_state = 25},
  [11337] = {.lex_state = 654, .external_lex_state = 25},
  [11338] = {.lex_state = 654, .external_lex_state = 25},
  [11339] = {.lex_state = 192, .external_lex_state = 2},
  [11340] = {.lex_state = 192, .external_lex_state = 29},
  [11341] = {.lex_state = 559, .external_lex_state = 25},
  [11342] = {.lex_state = 658, .external_lex_state = 25},
  [11343] = {.lex_state = 658, .external_lex_state = 25},
  [11344] = {.lex_state = 192, .external_lex_state = 2},
  [11345] = {.lex_state = 227, .external_lex_state = 3},
  [11346] = {.lex_state = 227, .external_lex_state = 3},
  [11347] = {.lex_state = 227, .external_lex_state = 3},
  [11348] = {.lex_state = 227, .external_lex_state = 3},
  [11349] = {.lex_state = 128},
  [11350] = {.lex_state = 227, .external_lex_state = 3},
  [11351] = {.lex_state = 227, .external_lex_state = 3},
  [11352] = {.lex_state = 227, .external_lex_state = 3},
  [11353] = {.lex_state = 227, .external_lex_state = 3},
  [11354] = {.lex_state = 192, .external_lex_state = 2},
  [11355] = {.lex_state = 299, .external_lex_state = 3},
  [11356] = {.lex_state = 467, .external_lex_state = 25},
  [11357] = {.lex_state = 467, .external_lex_state = 25},
  [11358] = {.lex_state = 461, .external_lex_state = 25},
  [11359] = {.lex_state = 177, .external_lex_state = 4},
  [11360] = {.lex_state = 461, .external_lex_state = 25},
  [11361] = {.lex_state = 461, .external_lex_state = 25},
  [11362] = {.lex_state = 177, .external_lex_state = 4},
  [11363] = {.lex_state = 461, .external_lex_state = 25},
  [11364] = {.lex_state = 225, .external_lex_state = 7},
  [11365] = {.lex_state = 461, .external_lex_state = 25},
  [11366] = {.lex_state = 461, .external_lex_state = 25},
  [11367] = {.lex_state = 461, .external_lex_state = 25},
  [11368] = {.lex_state = 128},
  [11369] = {.lex_state = 128},
  [11370] = {.lex_state = 461, .external_lex_state = 25},
  [11371] = {.lex_state = 128},
  [11372] = {.lex_state = 461, .external_lex_state = 25},
  [11373] = {.lex_state = 461, .external_lex_state = 25},
  [11374] = {.lex_state = 461, .external_lex_state = 25},
  [11375] = {.lex_state = 128},
  [11376] = {.lex_state = 461, .external_lex_state = 25},
  [11377] = {.lex_state = 128},
  [11378] = {.lex_state = 461, .external_lex_state = 25},
  [11379] = {.lex_state = 128},
  [11380] = {.lex_state = 441, .external_lex_state = 25},
  [11381] = {.lex_state = 461, .external_lex_state = 25},
  [11382] = {.lex_state = 441, .external_lex_state = 25},
  [11383] = {.lex_state = 433, .external_lex_state = 16},
  [11384] = {.lex_state = 436, .external_lex_state = 16},
  [11385] = {.lex_state = 467, .external_lex_state = 3},
  [11386] = {.lex_state = 467, .external_lex_state = 3},
  [11387] = {.lex_state = 441, .external_lex_state = 3},
  [11388] = {.lex_state = 441, .external_lex_state = 3},
  [11389] = {.lex_state = 436, .external_lex_state = 3},
  [11390] = {.lex_state = 467, .external_lex_state = 25},
  [11391] = {.lex_state = 467, .external_lex_state = 25},
  [11392] = {.lex_state = 441, .external_lex_state = 25},
  [11393] = {.lex_state = 441, .external_lex_state = 25},
  [11394] = {.lex_state = 461, .external_lex_state = 25},
  [11395] = {.lex_state = 397, .external_lex_state = 25},
  [11396] = {.lex_state = 493, .external_lex_state = 25},
  [11397] = {.lex_state = 493, .external_lex_state = 25},
  [11398] = {.lex_state = 321, .external_lex_state = 25},
  [11399] = {.lex_state = 321, .external_lex_state = 25},
  [11400] = {.lex_state = 302, .external_lex_state = 16},
  [11401] = {.lex_state = 678, .external_lex_state = 8},
  [11402] = {.lex_state = 128},
  [11403] = {.lex_state = 621, .external_lex_state = 25},
  [11404] = {.lex_state = 621, .external_lex_state = 25},
  [11405] = {.lex_state = 192, .external_lex_state = 2},
  [11406] = {.lex_state = 192, .external_lex_state = 29},
  [11407] = {.lex_state = 424, .external_lex_state = 25},
  [11408] = {.lex_state = 621, .external_lex_state = 25},
  [11409] = {.lex_state = 621, .external_lex_state = 25},
  [11410] = {.lex_state = 621, .external_lex_state = 25},
  [11411] = {.lex_state = 621, .external_lex_state = 25},
  [11412] = {.lex_state = 128},
  [11413] = {.lex_state = 621, .external_lex_state = 25},
  [11414] = {.lex_state = 621, .external_lex_state = 25},
  [11415] = {.lex_state = 621, .external_lex_state = 25},
  [11416] = {.lex_state = 621, .external_lex_state = 25},
  [11417] = {.lex_state = 621, .external_lex_state = 25},
  [11418] = {.lex_state = 128},
  [11419] = {.lex_state = 361, .external_lex_state = 3},
  [11420] = {.lex_state = 361, .external_lex_state = 3},
  [11421] = {.lex_state = 192, .external_lex_state = 2},
  [11422] = {.lex_state = 192, .external_lex_state = 29},
  [11423] = {.lex_state = 361, .external_lex_state = 3},
  [11424] = {.lex_state = 361, .external_lex_state = 3},
  [11425] = {.lex_state = 361, .external_lex_state = 3},
  [11426] = {.lex_state = 192, .external_lex_state = 2},
  [11427] = {.lex_state = 192, .external_lex_state = 29},
  [11428] = {.lex_state = 424, .external_lex_state = 3},
  [11429] = {.lex_state = 421, .external_lex_state = 3},
  [11430] = {.lex_state = 421, .external_lex_state = 3},
  [11431] = {.lex_state = 192, .external_lex_state = 2},
  [11432] = {.lex_state = 361, .external_lex_state = 3},
  [11433] = {.lex_state = 361, .external_lex_state = 3},
  [11434] = {.lex_state = 192, .external_lex_state = 2},
  [11435] = {.lex_state = 192, .external_lex_state = 29},
  [11436] = {.lex_state = 361, .external_lex_state = 3},
  [11437] = {.lex_state = 361, .external_lex_state = 3},
  [11438] = {.lex_state = 361, .external_lex_state = 3},
  [11439] = {.lex_state = 192, .external_lex_state = 2},
  [11440] = {.lex_state = 192, .external_lex_state = 29},
  [11441] = {.lex_state = 424, .external_lex_state = 3},
  [11442] = {.lex_state = 421, .external_lex_state = 3},
  [11443] = {.lex_state = 421, .external_lex_state = 3},
  [11444] = {.lex_state = 192, .external_lex_state = 2},
  [11445] = {.lex_state = 192, .external_lex_state = 2},
  [11446] = {.lex_state = 192, .external_lex_state = 29},
  [11447] = {.lex_state = 424, .external_lex_state = 25},
  [11448] = {.lex_state = 192, .external_lex_state = 2},
  [11449] = {.lex_state = 192, .external_lex_state = 29},
  [11450] = {.lex_state = 361, .external_lex_state = 3},
  [11451] = {.lex_state = 361, .external_lex_state = 3},
  [11452] = {.lex_state = 361, .external_lex_state = 3},
  [11453] = {.lex_state = 361, .external_lex_state = 3},
  [11454] = {.lex_state = 361, .external_lex_state = 3},
  [11455] = {.lex_state = 361, .external_lex_state = 3},
  [11456] = {.lex_state = 192, .external_lex_state = 2},
  [11457] = {.lex_state = 192, .external_lex_state = 2},
  [11458] = {.lex_state = 192, .external_lex_state = 2},
  [11459] = {.lex_state = 192, .external_lex_state = 2},
  [11460] = {.lex_state = 192, .external_lex_state = 2},
  [11461] = {.lex_state = 192, .external_lex_state = 2},
  [11462] = {.lex_state = 192, .external_lex_state = 2},
  [11463] = {.lex_state = 192, .external_lex_state = 2},
  [11464] = {.lex_state = 192, .external_lex_state = 2},
  [11465] = {.lex_state = 192, .external_lex_state = 2},
  [11466] = {.lex_state = 192, .external_lex_state = 2},
  [11467] = {.lex_state = 192, .external_lex_state = 2},
  [11468] = {.lex_state = 192, .external_lex_state = 29},
  [11469] = {.lex_state = 192, .external_lex_state = 2},
  [11470] = {.lex_state = 365, .external_lex_state = 14},
  [11471] = {.lex_state = 361, .external_lex_state = 3},
  [11472] = {.lex_state = 361, .external_lex_state = 3},
  [11473] = {.lex_state = 361, .external_lex_state = 3},
  [11474] = {.lex_state = 192, .external_lex_state = 2},
  [11475] = {.lex_state = 361, .external_lex_state = 3},
  [11476] = {.lex_state = 192, .external_lex_state = 2},
  [11477] = {.lex_state = 361, .external_lex_state = 3},
  [11478] = {.lex_state = 524, .external_lex_state = 13},
  [11479] = {.lex_state = 361, .external_lex_state = 3},
  [11480] = {.lex_state = 361, .external_lex_state = 3},
  [11481] = {.lex_state = 361, .external_lex_state = 3},
  [11482] = {.lex_state = 361, .external_lex_state = 3},
  [11483] = {.lex_state = 361, .external_lex_state = 3},
  [11484] = {.lex_state = 361, .external_lex_state = 3},
  [11485] = {.lex_state = 361, .external_lex_state = 3},
  [11486] = {.lex_state = 361, .external_lex_state = 3},
  [11487] = {.lex_state = 554, .external_lex_state = 16},
  [11488] = {.lex_state = 361, .external_lex_state = 3},
  [11489] = {.lex_state = 361, .external_lex_state = 3},
  [11490] = {.lex_state = 361, .external_lex_state = 3},
  [11491] = {.lex_state = 361, .external_lex_state = 3},
  [11492] = {.lex_state = 361, .external_lex_state = 3},
  [11493] = {.lex_state = 421, .external_lex_state = 3},
  [11494] = {.lex_state = 421, .external_lex_state = 3},
  [11495] = {.lex_state = 192, .external_lex_state = 2},
  [11496] = {.lex_state = 421, .external_lex_state = 3},
  [11497] = {.lex_state = 192, .external_lex_state = 2},
  [11498] = {.lex_state = 421, .external_lex_state = 3},
  [11499] = {.lex_state = 524, .external_lex_state = 13},
  [11500] = {.lex_state = 421, .external_lex_state = 3},
  [11501] = {.lex_state = 262, .external_lex_state = 3},
  [11502] = {.lex_state = 524, .external_lex_state = 21},
  [11503] = {.lex_state = 262, .external_lex_state = 3},
  [11504] = {.lex_state = 361, .external_lex_state = 3},
  [11505] = {.lex_state = 361, .external_lex_state = 3},
  [11506] = {.lex_state = 361, .external_lex_state = 3},
  [11507] = {.lex_state = 361, .external_lex_state = 3},
  [11508] = {.lex_state = 361, .external_lex_state = 14},
  [11509] = {.lex_state = 254, .external_lex_state = 8},
  [11510] = {.lex_state = 128, .external_lex_state = 2},
  [11511] = {.lex_state = 192, .external_lex_state = 2},
  [11512] = {.lex_state = 424, .external_lex_state = 3},
  [11513] = {.lex_state = 424, .external_lex_state = 3},
  [11514] = {.lex_state = 424, .external_lex_state = 3},
  [11515] = {.lex_state = 192, .external_lex_state = 2},
  [11516] = {.lex_state = 192, .external_lex_state = 2},
  [11517] = {.lex_state = 192, .external_lex_state = 2},
  [11518] = {.lex_state = 192, .external_lex_state = 2},
  [11519] = {.lex_state = 192, .external_lex_state = 2},
  [11520] = {.lex_state = 192, .external_lex_state = 2},
  [11521] = {.lex_state = 192, .external_lex_state = 2},
  [11522] = {.lex_state = 192, .external_lex_state = 2},
  [11523] = {.lex_state = 192, .external_lex_state = 2},
  [11524] = {.lex_state = 192, .external_lex_state = 2},
  [11525] = {.lex_state = 192, .external_lex_state = 2},
  [11526] = {.lex_state = 192, .external_lex_state = 2},
  [11527] = {.lex_state = 192, .external_lex_state = 29},
  [11528] = {.lex_state = 192, .external_lex_state = 2},
  [11529] = {.lex_state = 424, .external_lex_state = 14},
  [11530] = {.lex_state = 424, .external_lex_state = 3},
  [11531] = {.lex_state = 421, .external_lex_state = 3},
  [11532] = {.lex_state = 421, .external_lex_state = 3},
  [11533] = {.lex_state = 421, .external_lex_state = 3},
  [11534] = {.lex_state = 421, .external_lex_state = 3},
  [11535] = {.lex_state = 421, .external_lex_state = 3},
  [11536] = {.lex_state = 421, .external_lex_state = 3},
  [11537] = {.lex_state = 424, .external_lex_state = 3},
  [11538] = {.lex_state = 554, .external_lex_state = 16},
  [11539] = {.lex_state = 421, .external_lex_state = 3},
  [11540] = {.lex_state = 421, .external_lex_state = 3},
  [11541] = {.lex_state = 421, .external_lex_state = 3},
  [11542] = {.lex_state = 421, .external_lex_state = 3},
  [11543] = {.lex_state = 421, .external_lex_state = 3},
  [11544] = {.lex_state = 424, .external_lex_state = 3},
  [11545] = {.lex_state = 524, .external_lex_state = 21},
  [11546] = {.lex_state = 424, .external_lex_state = 3},
  [11547] = {.lex_state = 424, .external_lex_state = 3},
  [11548] = {.lex_state = 421, .external_lex_state = 3},
  [11549] = {.lex_state = 421, .external_lex_state = 3},
  [11550] = {.lex_state = 421, .external_lex_state = 3},
  [11551] = {.lex_state = 421, .external_lex_state = 14},
  [11552] = {.lex_state = 528, .external_lex_state = 3},
  [11553] = {.lex_state = 528, .external_lex_state = 3},
  [11554] = {.lex_state = 528, .external_lex_state = 3},
  [11555] = {.lex_state = 528, .external_lex_state = 3},
  [11556] = {.lex_state = 192, .external_lex_state = 2},
  [11557] = {.lex_state = 192, .external_lex_state = 2},
  [11558] = {.lex_state = 192, .external_lex_state = 2},
  [11559] = {.lex_state = 192, .external_lex_state = 2},
  [11560] = {.lex_state = 192, .external_lex_state = 2},
  [11561] = {.lex_state = 192, .external_lex_state = 2},
  [11562] = {.lex_state = 192, .external_lex_state = 2},
  [11563] = {.lex_state = 192, .external_lex_state = 2},
  [11564] = {.lex_state = 192, .external_lex_state = 2},
  [11565] = {.lex_state = 192, .external_lex_state = 2},
  [11566] = {.lex_state = 192, .external_lex_state = 2},
  [11567] = {.lex_state = 192, .external_lex_state = 2},
  [11568] = {.lex_state = 192, .external_lex_state = 29},
  [11569] = {.lex_state = 528, .external_lex_state = 3},
  [11570] = {.lex_state = 192, .external_lex_state = 29},
  [11571] = {.lex_state = 192, .external_lex_state = 2},
  [11572] = {.lex_state = 192, .external_lex_state = 2},
  [11573] = {.lex_state = 192, .external_lex_state = 29},
  [11574] = {.lex_state = 424, .external_lex_state = 3},
  [11575] = {.lex_state = 350, .external_lex_state = 23},
  [11576] = {.lex_state = 508, .external_lex_state = 3},
  [11577] = {.lex_state = 508, .external_lex_state = 3},
  [11578] = {.lex_state = 508, .external_lex_state = 3},
  [11579] = {.lex_state = 524, .external_lex_state = 21},
  [11580] = {.lex_state = 508, .external_lex_state = 3},
  [11581] = {.lex_state = 508, .external_lex_state = 3},
  [11582] = {.lex_state = 192, .external_lex_state = 2},
  [11583] = {.lex_state = 192, .external_lex_state = 29},
  [11584] = {.lex_state = 508, .external_lex_state = 3},
  [11585] = {.lex_state = 508, .external_lex_state = 3},
  [11586] = {.lex_state = 508, .external_lex_state = 3},
  [11587] = {.lex_state = 361, .external_lex_state = 3},
  [11588] = {.lex_state = 361, .external_lex_state = 3},
  [11589] = {.lex_state = 424, .external_lex_state = 3},
  [11590] = {.lex_state = 424, .external_lex_state = 3},
  [11591] = {.lex_state = 528, .external_lex_state = 3},
  [11592] = {.lex_state = 361, .external_lex_state = 3},
  [11593] = {.lex_state = 361, .external_lex_state = 3},
  [11594] = {.lex_state = 424, .external_lex_state = 3},
  [11595] = {.lex_state = 424, .external_lex_state = 3},
  [11596] = {.lex_state = 528, .external_lex_state = 3},
  [11597] = {.lex_state = 406, .external_lex_state = 25},
  [11598] = {.lex_state = 406, .external_lex_state = 25},
  [11599] = {.lex_state = 537, .external_lex_state = 25},
  [11600] = {.lex_state = 537, .external_lex_state = 25},
  [11601] = {.lex_state = 361, .external_lex_state = 25},
  [11602] = {.lex_state = 361, .external_lex_state = 25},
  [11603] = {.lex_state = 361, .external_lex_state = 25},
  [11604] = {.lex_state = 192, .external_lex_state = 2},
  [11605] = {.lex_state = 192, .external_lex_state = 2},
  [11606] = {.lex_state = 192, .external_lex_state = 2},
  [11607] = {.lex_state = 192, .external_lex_state = 2},
  [11608] = {.lex_state = 192, .external_lex_state = 2},
  [11609] = {.lex_state = 192, .external_lex_state = 2},
  [11610] = {.lex_state = 192, .external_lex_state = 2},
  [11611] = {.lex_state = 192, .external_lex_state = 2},
  [11612] = {.lex_state = 192, .external_lex_state = 2},
  [11613] = {.lex_state = 192, .external_lex_state = 2},
  [11614] = {.lex_state = 192, .external_lex_state = 2},
  [11615] = {.lex_state = 192, .external_lex_state = 2},
  [11616] = {.lex_state = 192, .external_lex_state = 29},
  [11617] = {.lex_state = 192, .external_lex_state = 2},
  [11618] = {.lex_state = 365, .external_lex_state = 27},
  [11619] = {.lex_state = 361, .external_lex_state = 25},
  [11620] = {.lex_state = 361, .external_lex_state = 25},
  [11621] = {.lex_state = 361, .external_lex_state = 25},
  [11622] = {.lex_state = 192, .external_lex_state = 2},
  [11623] = {.lex_state = 361, .external_lex_state = 25},
  [11624] = {.lex_state = 192, .external_lex_state = 2},
  [11625] = {.lex_state = 361, .external_lex_state = 25},
  [11626] = {.lex_state = 524, .external_lex_state = 13},
  [11627] = {.lex_state = 361, .external_lex_state = 25},
  [11628] = {.lex_state = 361, .external_lex_state = 25},
  [11629] = {.lex_state = 361, .external_lex_state = 25},
  [11630] = {.lex_state = 361, .external_lex_state = 25},
  [11631] = {.lex_state = 361, .external_lex_state = 25},
  [11632] = {.lex_state = 361, .external_lex_state = 25},
  [11633] = {.lex_state = 361, .external_lex_state = 25},
  [11634] = {.lex_state = 361, .external_lex_state = 25},
  [11635] = {.lex_state = 554, .external_lex_state = 16},
  [11636] = {.lex_state = 361, .external_lex_state = 25},
  [11637] = {.lex_state = 361, .external_lex_state = 25},
  [11638] = {.lex_state = 361, .external_lex_state = 25},
  [11639] = {.lex_state = 361, .external_lex_state = 25},
  [11640] = {.lex_state = 361, .external_lex_state = 25},
  [11641] = {.lex_state = 421, .external_lex_state = 25},
  [11642] = {.lex_state = 421, .external_lex_state = 25},
  [11643] = {.lex_state = 192, .external_lex_state = 2},
  [11644] = {.lex_state = 421, .external_lex_state = 25},
  [11645] = {.lex_state = 192, .external_lex_state = 2},
  [11646] = {.lex_state = 421, .external_lex_state = 25},
  [11647] = {.lex_state = 524, .external_lex_state = 13},
  [11648] = {.lex_state = 421, .external_lex_state = 25},
  [11649] = {.lex_state = 361, .external_lex_state = 25},
  [11650] = {.lex_state = 524, .external_lex_state = 21},
  [11651] = {.lex_state = 361, .external_lex_state = 25},
  [11652] = {.lex_state = 361, .external_lex_state = 25},
  [11653] = {.lex_state = 361, .external_lex_state = 25},
  [11654] = {.lex_state = 361, .external_lex_state = 25},
  [11655] = {.lex_state = 361, .external_lex_state = 25},
  [11656] = {.lex_state = 361, .external_lex_state = 27},
  [11657] = {.lex_state = 192, .external_lex_state = 2},
  [11658] = {.lex_state = 424, .external_lex_state = 25},
  [11659] = {.lex_state = 424, .external_lex_state = 25},
  [11660] = {.lex_state = 424, .external_lex_state = 25},
  [11661] = {.lex_state = 192, .external_lex_state = 2},
  [11662] = {.lex_state = 192, .external_lex_state = 2},
  [11663] = {.lex_state = 192, .external_lex_state = 2},
  [11664] = {.lex_state = 192, .external_lex_state = 2},
  [11665] = {.lex_state = 192, .external_lex_state = 2},
  [11666] = {.lex_state = 192, .external_lex_state = 2},
  [11667] = {.lex_state = 192, .external_lex_state = 2},
  [11668] = {.lex_state = 192, .external_lex_state = 2},
  [11669] = {.lex_state = 192, .external_lex_state = 2},
  [11670] = {.lex_state = 192, .external_lex_state = 2},
  [11671] = {.lex_state = 192, .external_lex_state = 2},
  [11672] = {.lex_state = 192, .external_lex_state = 2},
  [11673] = {.lex_state = 192, .external_lex_state = 29},
  [11674] = {.lex_state = 192, .external_lex_state = 2},
  [11675] = {.lex_state = 424, .external_lex_state = 27},
  [11676] = {.lex_state = 424, .external_lex_state = 25},
  [11677] = {.lex_state = 421, .external_lex_state = 25},
  [11678] = {.lex_state = 421, .external_lex_state = 25},
  [11679] = {.lex_state = 421, .external_lex_state = 25},
  [11680] = {.lex_state = 421, .external_lex_state = 25},
  [11681] = {.lex_state = 421, .external_lex_state = 25},
  [11682] = {.lex_state = 421, .external_lex_state = 25},
  [11683] = {.lex_state = 424, .external_lex_state = 25},
  [11684] = {.lex_state = 554, .external_lex_state = 16},
  [11685] = {.lex_state = 421, .external_lex_state = 25},
  [11686] = {.lex_state = 421, .external_lex_state = 25},
  [11687] = {.lex_state = 421, .external_lex_state = 25},
  [11688] = {.lex_state = 421, .external_lex_state = 25},
  [11689] = {.lex_state = 421, .external_lex_state = 25},
  [11690] = {.lex_state = 424, .external_lex_state = 25},
  [11691] = {.lex_state = 524, .external_lex_state = 21},
  [11692] = {.lex_state = 424, .external_lex_state = 25},
  [11693] = {.lex_state = 424, .external_lex_state = 25},
  [11694] = {.lex_state = 421, .external_lex_state = 25},
  [11695] = {.lex_state = 421, .external_lex_state = 25},
  [11696] = {.lex_state = 421, .external_lex_state = 25},
  [11697] = {.lex_state = 421, .external_lex_state = 27},
  [11698] = {.lex_state = 302, .external_lex_state = 16},
  [11699] = {.lex_state = 192, .external_lex_state = 29},
  [11700] = {.lex_state = 302, .external_lex_state = 16},
  [11701] = {.lex_state = 286, .external_lex_state = 2},
  [11702] = {.lex_state = 237},
  [11703] = {.lex_state = 128, .external_lex_state = 12},
  [11704] = {.lex_state = 237},
  [11705] = {.lex_state = 645, .external_lex_state = 25},
  [11706] = {.lex_state = 645, .external_lex_state = 25},
  [11707] = {.lex_state = 559, .external_lex_state = 25},
  [11708] = {.lex_state = 559, .external_lex_state = 25},
  [11709] = {.lex_state = 554, .external_lex_state = 16},
  [11710] = {.lex_state = 227, .external_lex_state = 3},
  [11711] = {.lex_state = 436, .external_lex_state = 3},
  [11712] = {.lex_state = 461, .external_lex_state = 25},
  [11713] = {.lex_state = 461, .external_lex_state = 25},
  [11714] = {.lex_state = 461, .external_lex_state = 25},
  [11715] = {.lex_state = 461, .external_lex_state = 25},
  [11716] = {.lex_state = 128},
  [11717] = {.lex_state = 461, .external_lex_state = 25},
  [11718] = {.lex_state = 461, .external_lex_state = 25},
  [11719] = {.lex_state = 461, .external_lex_state = 25},
  [11720] = {.lex_state = 461, .external_lex_state = 25},
  [11721] = {.lex_state = 678, .external_lex_state = 8},
  [11722] = {.lex_state = 424, .external_lex_state = 25},
  [11723] = {.lex_state = 424, .external_lex_state = 25},
  [11724] = {.lex_state = 621, .external_lex_state = 25},
  [11725] = {.lex_state = 621, .external_lex_state = 25},
  [11726] = {.lex_state = 361, .external_lex_state = 3},
  [11727] = {.lex_state = 361, .external_lex_state = 3},
  [11728] = {.lex_state = 424, .external_lex_state = 3},
  [11729] = {.lex_state = 424, .external_lex_state = 3},
  [11730] = {.lex_state = 528, .external_lex_state = 3},
  [11731] = {.lex_state = 361, .external_lex_state = 3},
  [11732] = {.lex_state = 361, .external_lex_state = 3},
  [11733] = {.lex_state = 424, .external_lex_state = 3},
  [11734] = {.lex_state = 424, .external_lex_state = 3},
  [11735] = {.lex_state = 528, .external_lex_state = 3},
  [11736] = {.lex_state = 424, .external_lex_state = 25},
  [11737] = {.lex_state = 424, .external_lex_state = 25},
  [11738] = {.lex_state = 361, .external_lex_state = 3},
  [11739] = {.lex_state = 361, .external_lex_state = 3},
  [11740] = {.lex_state = 361, .external_lex_state = 3},
  [11741] = {.lex_state = 361, .external_lex_state = 3},
  [11742] = {.lex_state = 361, .external_lex_state = 3},
  [11743] = {.lex_state = 361, .external_lex_state = 3},
  [11744] = {.lex_state = 361, .external_lex_state = 3},
  [11745] = {.lex_state = 361, .external_lex_state = 3},
  [11746] = {.lex_state = 361, .external_lex_state = 3},
  [11747] = {.lex_state = 361, .external_lex_state = 3},
  [11748] = {.lex_state = 554, .external_lex_state = 16},
  [11749] = {.lex_state = 361, .external_lex_state = 3},
  [11750] = {.lex_state = 361, .external_lex_state = 3},
  [11751] = {.lex_state = 361, .external_lex_state = 3},
  [11752] = {.lex_state = 361, .external_lex_state = 3},
  [11753] = {.lex_state = 361, .external_lex_state = 3},
  [11754] = {.lex_state = 361, .external_lex_state = 3},
  [11755] = {.lex_state = 361, .external_lex_state = 3},
  [11756] = {.lex_state = 361, .external_lex_state = 3},
  [11757] = {.lex_state = 365, .external_lex_state = 14},
  [11758] = {.lex_state = 361, .external_lex_state = 3},
  [11759] = {.lex_state = 361, .external_lex_state = 3},
  [11760] = {.lex_state = 361, .external_lex_state = 3},
  [11761] = {.lex_state = 524, .external_lex_state = 21},
  [11762] = {.lex_state = 361, .external_lex_state = 3},
  [11763] = {.lex_state = 361, .external_lex_state = 3},
  [11764] = {.lex_state = 192, .external_lex_state = 2},
  [11765] = {.lex_state = 421, .external_lex_state = 3},
  [11766] = {.lex_state = 421, .external_lex_state = 3},
  [11767] = {.lex_state = 421, .external_lex_state = 3},
  [11768] = {.lex_state = 524, .external_lex_state = 21},
  [11769] = {.lex_state = 421, .external_lex_state = 3},
  [11770] = {.lex_state = 421, .external_lex_state = 3},
  [11771] = {.lex_state = 192, .external_lex_state = 29},
  [11772] = {.lex_state = 361, .external_lex_state = 3},
  [11773] = {.lex_state = 247, .external_lex_state = 3},
  [11774] = {.lex_state = 424, .external_lex_state = 3},
  [11775] = {.lex_state = 424, .external_lex_state = 3},
  [11776] = {.lex_state = 424, .external_lex_state = 3},
  [11777] = {.lex_state = 424, .external_lex_state = 3},
  [11778] = {.lex_state = 424, .external_lex_state = 3},
  [11779] = {.lex_state = 424, .external_lex_state = 3},
  [11780] = {.lex_state = 554, .external_lex_state = 16},
  [11781] = {.lex_state = 424, .external_lex_state = 3},
  [11782] = {.lex_state = 424, .external_lex_state = 3},
  [11783] = {.lex_state = 424, .external_lex_state = 3},
  [11784] = {.lex_state = 424, .external_lex_state = 3},
  [11785] = {.lex_state = 424, .external_lex_state = 3},
  [11786] = {.lex_state = 424, .external_lex_state = 3},
  [11787] = {.lex_state = 424, .external_lex_state = 3},
  [11788] = {.lex_state = 424, .external_lex_state = 3},
  [11789] = {.lex_state = 424, .external_lex_state = 14},
  [11790] = {.lex_state = 192, .external_lex_state = 2},
  [11791] = {.lex_state = 192, .external_lex_state = 29},
  [11792] = {.lex_state = 421, .external_lex_state = 3},
  [11793] = {.lex_state = 528, .external_lex_state = 3},
  [11794] = {.lex_state = 528, .external_lex_state = 3},
  [11795] = {.lex_state = 528, .external_lex_state = 3},
  [11796] = {.lex_state = 528, .external_lex_state = 3},
  [11797] = {.lex_state = 528, .external_lex_state = 3},
  [11798] = {.lex_state = 528, .external_lex_state = 3},
  [11799] = {.lex_state = 554, .external_lex_state = 16},
  [11800] = {.lex_state = 528, .external_lex_state = 3},
  [11801] = {.lex_state = 528, .external_lex_state = 3},
  [11802] = {.lex_state = 528, .external_lex_state = 3},
  [11803] = {.lex_state = 528, .external_lex_state = 3},
  [11804] = {.lex_state = 528, .external_lex_state = 3},
  [11805] = {.lex_state = 528, .external_lex_state = 3},
  [11806] = {.lex_state = 528, .external_lex_state = 3},
  [11807] = {.lex_state = 528, .external_lex_state = 3},
  [11808] = {.lex_state = 424, .external_lex_state = 3},
  [11809] = {.lex_state = 424, .external_lex_state = 3},
  [11810] = {.lex_state = 508, .external_lex_state = 3},
  [11811] = {.lex_state = 508, .external_lex_state = 3},
  [11812] = {.lex_state = 361, .external_lex_state = 25},
  [11813] = {.lex_state = 361, .external_lex_state = 25},
  [11814] = {.lex_state = 361, .external_lex_state = 25},
  [11815] = {.lex_state = 361, .external_lex_state = 25},
  [11816] = {.lex_state = 361, .external_lex_state = 25},
  [11817] = {.lex_state = 361, .external_lex_state = 25},
  [11818] = {.lex_state = 554, .external_lex_state = 16},
  [11819] = {.lex_state = 361, .external_lex_state = 25},
  [11820] = {.lex_state = 361, .external_lex_state = 25},
  [11821] = {.lex_state = 361, .external_lex_state = 25},
  [11822] = {.lex_state = 361, .external_lex_state = 25},
  [11823] = {.lex_state = 361, .external_lex_state = 25},
  [11824] = {.lex_state = 361, .external_lex_state = 25},
  [11825] = {.lex_state = 361, .external_lex_state = 25},
  [11826] = {.lex_state = 361, .external_lex_state = 25},
  [11827] = {.lex_state = 365, .external_lex_state = 27},
  [11828] = {.lex_state = 361, .external_lex_state = 25},
  [11829] = {.lex_state = 361, .external_lex_state = 25},
  [11830] = {.lex_state = 361, .external_lex_state = 25},
  [11831] = {.lex_state = 524, .external_lex_state = 21},
  [11832] = {.lex_state = 361, .external_lex_state = 25},
  [11833] = {.lex_state = 361, .external_lex_state = 25},
  [11834] = {.lex_state = 192, .external_lex_state = 2},
  [11835] = {.lex_state = 421, .external_lex_state = 25},
  [11836] = {.lex_state = 421, .external_lex_state = 25},
  [11837] = {.lex_state = 421, .external_lex_state = 25},
  [11838] = {.lex_state = 524, .external_lex_state = 21},
  [11839] = {.lex_state = 421, .external_lex_state = 25},
  [11840] = {.lex_state = 421, .external_lex_state = 25},
  [11841] = {.lex_state = 192, .external_lex_state = 29},
  [11842] = {.lex_state = 361, .external_lex_state = 25},
  [11843] = {.lex_state = 302, .external_lex_state = 16},
  [11844] = {.lex_state = 424, .external_lex_state = 25},
  [11845] = {.lex_state = 424, .external_lex_state = 25},
  [11846] = {.lex_state = 424, .external_lex_state = 25},
  [11847] = {.lex_state = 424, .external_lex_state = 25},
  [11848] = {.lex_state = 424, .external_lex_state = 25},
  [11849] = {.lex_state = 424, .external_lex_state = 25},
  [11850] = {.lex_state = 554, .external_lex_state = 16},
  [11851] = {.lex_state = 424, .external_lex_state = 25},
  [11852] = {.lex_state = 424, .external_lex_state = 25},
  [11853] = {.lex_state = 424, .external_lex_state = 25},
  [11854] = {.lex_state = 424, .external_lex_state = 25},
  [11855] = {.lex_state = 424, .external_lex_state = 25},
  [11856] = {.lex_state = 424, .external_lex_state = 25},
  [11857] = {.lex_state = 424, .external_lex_state = 25},
  [11858] = {.lex_state = 424, .external_lex_state = 25},
  [11859] = {.lex_state = 424, .external_lex_state = 27},
  [11860] = {.lex_state = 192, .external_lex_state = 2},
  [11861] = {.lex_state = 192, .external_lex_state = 29},
  [11862] = {.lex_state = 421, .external_lex_state = 25},
  [11863] = {.lex_state = 302, .external_lex_state = 16},
  [11864] = {.lex_state = 286, .external_lex_state = 2},
  [11865] = {.lex_state = 128, .external_lex_state = 12},
  [11866] = {.lex_state = 461, .external_lex_state = 25},
  [11867] = {.lex_state = 361, .external_lex_state = 3},
  [11868] = {.lex_state = 361, .external_lex_state = 3},
  [11869] = {.lex_state = 192, .external_lex_state = 2},
  [11870] = {.lex_state = 192, .external_lex_state = 29},
  [11871] = {.lex_state = 361, .external_lex_state = 3},
  [11872] = {.lex_state = 361, .external_lex_state = 3},
  [11873] = {.lex_state = 361, .external_lex_state = 3},
  [11874] = {.lex_state = 192, .external_lex_state = 2},
  [11875] = {.lex_state = 192, .external_lex_state = 29},
  [11876] = {.lex_state = 424, .external_lex_state = 3},
  [11877] = {.lex_state = 421, .external_lex_state = 3},
  [11878] = {.lex_state = 421, .external_lex_state = 3},
  [11879] = {.lex_state = 192, .external_lex_state = 2},
  [11880] = {.lex_state = 192, .external_lex_state = 2},
  [11881] = {.lex_state = 192, .external_lex_state = 29},
  [11882] = {.lex_state = 361, .external_lex_state = 25},
  [11883] = {.lex_state = 361, .external_lex_state = 25},
  [11884] = {.lex_state = 361, .external_lex_state = 25},
  [11885] = {.lex_state = 192, .external_lex_state = 2},
  [11886] = {.lex_state = 192, .external_lex_state = 29},
  [11887] = {.lex_state = 424, .external_lex_state = 25},
  [11888] = {.lex_state = 421, .external_lex_state = 25},
  [11889] = {.lex_state = 421, .external_lex_state = 25},
  [11890] = {.lex_state = 361, .external_lex_state = 3},
  [11891] = {.lex_state = 361, .external_lex_state = 3},
  [11892] = {.lex_state = 424, .external_lex_state = 3},
  [11893] = {.lex_state = 424, .external_lex_state = 3},
  [11894] = {.lex_state = 528, .external_lex_state = 3},
  [11895] = {.lex_state = 361, .external_lex_state = 25},
  [11896] = {.lex_state = 361, .external_lex_state = 25},
  [11897] = {.lex_state = 424, .external_lex_state = 25},
  [11898] = {.lex_state = 424, .external_lex_state = 25},
};

enum {
  ts_external_token__line_break,
  ts_external_token__simple_symbol,
  ts_external_token__string_start,
  ts_external_token__symbol_start,
  ts_external_token__subshell_start,
  ts_external_token__regex_start,
  ts_external_token__string_array_start,
  ts_external_token__symbol_array_start,
  ts_external_token__heredoc_body_start,
  ts_external_token__string_content,
  ts_external_token__heredoc_content,
  ts_external_token__string_end,
  ts_external_token_heredoc_end,
  ts_external_token_heredoc_beginning,
  ts_external_token_SLASH,
  ts_external_token__block_ampersand,
  ts_external_token__splat_star,
  ts_external_token__unary_minus,
  ts_external_token__binary_minus,
  ts_external_token__binary_star,
  ts_external_token__singleton_class_left_angle_left_langle,
  ts_external_token__identifier_hash_key,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__line_break] = sym__line_break2,
  [ts_external_token__simple_symbol] = sym__simple_symbol2,
  [ts_external_token__string_start] = sym__string_start2,
  [ts_external_token__symbol_start] = sym__symbol_start2,
  [ts_external_token__subshell_start] = sym__subshell_start2,
  [ts_external_token__regex_start] = sym__regex_start2,
  [ts_external_token__string_array_start] = sym__string_array_start2,
  [ts_external_token__symbol_array_start] = sym__symbol_array_start2,
  [ts_external_token__heredoc_body_start] = sym__heredoc_body_start2,
  [ts_external_token__string_content] = sym__string_content2,
  [ts_external_token__heredoc_content] = sym__heredoc_content2,
  [ts_external_token__string_end] = sym__string_end2,
  [ts_external_token_heredoc_end] = sym_heredoc_end2,
  [ts_external_token_heredoc_beginning] = sym_heredoc_beginning2,
  [ts_external_token_SLASH] = anon_sym_SLASH,
  [ts_external_token__block_ampersand] = sym__block_ampersand2,
  [ts_external_token__splat_star] = sym__splat_star2,
  [ts_external_token__unary_minus] = sym__unary_minus2,
  [ts_external_token__binary_minus] = sym__binary_minus2,
  [ts_external_token__binary_star] = sym__binary_star2,
  [ts_external_token__singleton_class_left_angle_left_langle] = sym__singleton_class_left_angle_left_langle2,
  [ts_external_token__identifier_hash_key] = sym__identifier_hash_key2,
};

static bool ts_external_scanner_states[31][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__heredoc_content] = true,
    [ts_external_token__string_end] = true,
    [ts_external_token_heredoc_end] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [2] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [3] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [4] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [5] = {
    [ts_external_token__line_break] = true,
  },
  [6] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [7] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [8] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__heredoc_body_start] = true,
  },
  [9] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
  },
  [10] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__singleton_class_left_angle_left_langle] = true,
  },
  [11] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [12] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__unary_minus] = true,
  },
  [13] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [14] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [15] = {
    [ts_external_token__string_end] = true,
  },
  [16] = {
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [17] = {
    [ts_external_token__heredoc_content] = true,
    [ts_external_token_heredoc_end] = true,
  },
  [18] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [19] = {
    [ts_external_token__heredoc_body_start] = true,
  },
  [20] = {
    [ts_external_token__string_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [21] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [22] = {
    [ts_external_token__string_start] = true,
  },
  [23] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [24] = {
    [ts_external_token__line_break] = true,
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [25] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [26] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__block_ampersand] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
    [ts_external_token__identifier_hash_key] = true,
  },
  [27] = {
    [ts_external_token__string_start] = true,
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
    [ts_external_token__binary_minus] = true,
    [ts_external_token__binary_star] = true,
  },
  [28] = {
    [ts_external_token__heredoc_body_start] = true,
    [ts_external_token_SLASH] = true,
  },
  [29] = {
    [ts_external_token__simple_symbol] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__symbol_start] = true,
    [ts_external_token__subshell_start] = true,
    [ts_external_token__regex_start] = true,
    [ts_external_token__string_array_start] = true,
    [ts_external_token__symbol_array_start] = true,
    [ts_external_token_heredoc_beginning] = true,
    [ts_external_token__splat_star] = true,
    [ts_external_token__unary_minus] = true,
  },
  [30] = {
    [ts_external_token__string_content] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__line_break2] = ACTIONS(1),
    [sym__simple_symbol2] = ACTIONS(1),
    [sym__string_start2] = ACTIONS(1),
    [sym__symbol_start2] = ACTIONS(1),
    [sym__subshell_start2] = ACTIONS(1),
    [sym__regex_start2] = ACTIONS(1),
    [sym__string_array_start2] = ACTIONS(1),
    [sym__symbol_array_start2] = ACTIONS(1),
    [sym__heredoc_body_start2] = ACTIONS(1),
    [sym__string_content2] = ACTIONS(1),
    [sym__heredoc_content2] = ACTIONS(1),
    [sym__string_end2] = ACTIONS(1),
    [sym_heredoc_end2] = ACTIONS(1),
    [sym_heredoc_beginning2] = ACTIONS(1),
    [sym__block_ampersand2] = ACTIONS(1),
    [sym__splat_star2] = ACTIONS(1),
    [sym__unary_minus2] = ACTIONS(1),
    [sym__binary_minus2] = ACTIONS(1),
    [sym__binary_star2] = ACTIONS(1),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(1),
    [sym__identifier_hash_key2] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym___END__] = ACTIONS(3),
    [anon_sym_BEGIN] = ACTIONS(3),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_END] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_COLON_COLON] = ACTIONS(3),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_module] = ACTIONS(3),
    [anon_sym_end] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_next] = ACTIONS(3),
    [sym_redo] = ACTIONS(3),
    [sym_retry] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_unless] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_until] = ACTIONS(3),
    [anon_sym_rescue] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_do] = ACTIONS(3),
    [anon_sym_case] = ACTIONS(3),
    [anon_sym_when] = ACTIONS(3),
    [anon_sym_elsif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_then] = ACTIONS(3),
    [anon_sym_begin] = ACTIONS(3),
    [anon_sym_ensure] = ACTIONS(3),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_COLON_COLON2] = ACTIONS(1),
    [anon_sym_AMP_DOT] = ACTIONS(1),
    [anon_sym_LPAREN2] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(3),
    [anon_sym_COLON2] = ACTIONS(3),
    [anon_sym_DOT_DOT] = ACTIONS(3),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PIPE_PIPE] = ACTIONS(3),
    [anon_sym_AMP_AMP] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_EQ_EQ] = ACTIONS(3),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ_GT] = ACTIONS(1),
    [anon_sym_EQ_TILDE] = ACTIONS(1),
    [anon_sym_BANG_TILDE] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(3),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_defined_QMARK] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_BANG] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [sym_constant] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_instance_variable] = ACTIONS(1),
    [sym_class_variable] = ACTIONS(1),
    [sym_global_variable] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_PLUS_AT] = ACTIONS(1),
    [anon_sym_DASH_AT] = ACTIONS(1),
    [anon_sym_BQUOTE] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(3),
    [anon_sym_alias] = ACTIONS(3),
    [sym_comment] = ACTIONS(3),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [anon_sym_r] = ACTIONS(3),
    [sym_super] = ACTIONS(3),
    [anon_sym_true] = ACTIONS(3),
    [anon_sym_TRUE] = ACTIONS(3),
    [anon_sym_false] = ACTIONS(3),
    [anon_sym_FALSE] = ACTIONS(3),
    [sym_self] = ACTIONS(3),
    [anon_sym_nil] = ACTIONS(3),
    [anon_sym_NIL] = ACTIONS(3),
    [sym_character] = ACTIONS(1),
    [anon_sym_POUND_LBRACE] = ACTIONS(1),
    [anon_sym_LBRACK2] = ACTIONS(3),
  },
  [1] = {
    [sym_program] = STATE(43),
    [sym__statements] = STATE(44),
    [sym__top_level_statement] = STATE(45),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(47),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(49),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(49),
    [sym_operator_assignment] = STATE(49),
    [sym_conditional] = STATE(49),
    [sym_range] = STATE(49),
    [sym_binary] = STATE(49),
    [sym_unary] = STATE(49),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(23),
    [anon_sym___END__] = ACTIONS(25),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2] = {
    [sym__line_break2] = ACTIONS(101),
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [3] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(59),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(107),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(62),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(113),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [5] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(64),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(115),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(66),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(117),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [7] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(70),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(121),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(125),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [8] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(74),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(129),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(131),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [9] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(75),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(75),
    [sym_operator_assignment] = STATE(75),
    [sym_conditional] = STATE(75),
    [sym_range] = STATE(75),
    [sym_binary] = STATE(75),
    [sym_unary] = STATE(75),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10] = {
    [sym__line_break2] = ACTIONS(133),
    [sym_comment] = ACTIONS(87),
  },
  [11] = {
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_comment] = ACTIONS(87),
  },
  [12] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(125),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(161),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [13] = {
    [anon_sym_LBRACE] = ACTIONS(227),
    [sym_comment] = ACTIONS(87),
  },
  [14] = {
    [sym__method_rest] = STATE(134),
    [sym__variable] = STATE(135),
    [sym_operator] = STATE(136),
    [sym__method_name] = STATE(136),
    [sym_setter] = STATE(136),
    [sym_symbol] = STATE(136),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(233),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(243),
    [sym_self] = ACTIONS(243),
  },
  [15] = {
    [sym__statements] = STATE(148),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(247),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [16] = {
    [sym_constant] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_comment] = ACTIONS(87),
  },
  [17] = {
    [sym__line_break2] = ACTIONS(275),
    [sym__heredoc_body_start2] = ACTIONS(275),
    [ts_builtin_sym_end] = ACTIONS(275),
    [anon_sym___END__] = ACTIONS(275),
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_RPAREN] = ACTIONS(275),
    [anon_sym_SEMI] = ACTIONS(275),
    [anon_sym_end] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [anon_sym_when] = ACTIONS(275),
    [anon_sym_elsif] = ACTIONS(275),
    [anon_sym_else] = ACTIONS(275),
    [anon_sym_then] = ACTIONS(275),
    [anon_sym_ensure] = ACTIONS(275),
    [sym_comment] = ACTIONS(87),
  },
  [18] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(190),
    [sym_call] = STATE(190),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(190),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_EQ] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(331),
    [sym_identifier] = ACTIONS(331),
    [sym_instance_variable] = ACTIONS(333),
    [sym_class_variable] = ACTIONS(333),
    [sym_global_variable] = ACTIONS(333),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(331),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(331),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [19] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(197),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(349),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(355),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [20] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(200),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(361),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [21] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(223),
    [sym__argument] = STATE(224),
    [sym_splat_argument] = STATE(224),
    [sym_hash_splat_argument] = STATE(224),
    [sym_block_argument] = STATE(224),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(224),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [22] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(223),
    [sym__argument] = STATE(224),
    [sym_splat_argument] = STATE(224),
    [sym_hash_splat_argument] = STATE(224),
    [sym_block_argument] = STATE(224),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(224),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [23] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(223),
    [sym__argument] = STATE(224),
    [sym_splat_argument] = STATE(224),
    [sym_hash_splat_argument] = STATE(224),
    [sym_block_argument] = STATE(224),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(224),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [24] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(223),
    [sym__argument] = STATE(224),
    [sym_splat_argument] = STATE(224),
    [sym_hash_splat_argument] = STATE(224),
    [sym_block_argument] = STATE(224),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(224),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [25] = {
    [sym__statement] = STATE(240),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [26] = {
    [sym__statement] = STATE(246),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [27] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(255),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(255),
    [sym_operator_assignment] = STATE(255),
    [sym_conditional] = STATE(255),
    [sym_range] = STATE(255),
    [sym_binary] = STATE(255),
    [sym_unary] = STATE(255),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [28] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(260),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(260),
    [sym_operator_assignment] = STATE(260),
    [sym_conditional] = STATE(260),
    [sym_range] = STATE(260),
    [sym_binary] = STATE(260),
    [sym_unary] = STATE(260),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [29] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(264),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [30] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(275),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(275),
    [sym_operator_assignment] = STATE(275),
    [sym_conditional] = STATE(275),
    [sym_range] = STATE(275),
    [sym_binary] = STATE(275),
    [sym_unary] = STATE(275),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(280),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(280),
    [sym__line_break2] = ACTIONS(481),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(481),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [31] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(301),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(307),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(307),
    [sym__line_break2] = ACTIONS(505),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(513),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [32] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(308),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(308),
    [sym_operator_assignment] = STATE(308),
    [sym_conditional] = STATE(308),
    [sym_range] = STATE(308),
    [sym_binary] = STATE(308),
    [sym_unary] = STATE(308),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [33] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(309),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(309),
    [sym_operator_assignment] = STATE(309),
    [sym_conditional] = STATE(309),
    [sym_range] = STATE(309),
    [sym_binary] = STATE(309),
    [sym_unary] = STATE(309),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [34] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [35] = {
    [sym_operator] = STATE(312),
    [sym__method_name] = STATE(312),
    [sym_setter] = STATE(312),
    [sym_symbol] = STATE(312),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(543),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(543),
    [sym_class_variable] = ACTIONS(543),
    [sym_global_variable] = ACTIONS(543),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [36] = {
    [sym_operator] = STATE(317),
    [sym__method_name] = STATE(317),
    [sym_setter] = STATE(317),
    [sym_symbol] = STATE(317),
    [sym__simple_symbol2] = ACTIONS(547),
    [sym__symbol_start2] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(555),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(555),
    [sym_class_variable] = ACTIONS(555),
    [sym_global_variable] = ACTIONS(555),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [37] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(563),
  },
  [38] = {
    [sym__line_break2] = ACTIONS(565),
    [sym__heredoc_body_start2] = ACTIONS(565),
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [39] = {
    [sym__line_break2] = ACTIONS(569),
    [sym__heredoc_body_start2] = ACTIONS(569),
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [40] = {
    [sym__line_break2] = ACTIONS(573),
    [sym__heredoc_body_start2] = ACTIONS(573),
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [41] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(362),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(367),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(639),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [42] = {
    [sym_lambda_parameters] = STATE(375),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(377),
    [sym_block] = STATE(377),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(677),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [43] = {
    [ts_builtin_sym_end] = ACTIONS(681),
    [sym_comment] = ACTIONS(87),
  },
  [44] = {
    [ts_builtin_sym_end] = ACTIONS(683),
    [anon_sym___END__] = ACTIONS(685),
    [sym_comment] = ACTIONS(87),
  },
  [45] = {
    [sym_heredoc_body] = STATE(379),
    [sym__terminator] = STATE(379),
    [aux_sym__statements_repeat1] = STATE(380),
    [sym__line_break2] = ACTIONS(687),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [ts_builtin_sym_end] = ACTIONS(689),
    [anon_sym___END__] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(687),
    [sym_comment] = ACTIONS(87),
  },
  [46] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [ts_builtin_sym_end] = ACTIONS(691),
    [anon_sym___END__] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_rescue] = ACTIONS(691),
    [anon_sym_when] = ACTIONS(691),
    [anon_sym_elsif] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [anon_sym_ensure] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [47] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [ts_builtin_sym_end] = ACTIONS(691),
    [anon_sym___END__] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(693),
    [anon_sym_unless] = ACTIONS(695),
    [anon_sym_while] = ACTIONS(697),
    [anon_sym_until] = ACTIONS(699),
    [anon_sym_rescue] = ACTIONS(701),
    [sym_comment] = ACTIONS(87),
  },
  [48] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [ts_builtin_sym_end] = ACTIONS(703),
    [anon_sym___END__] = ACTIONS(703),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_when] = ACTIONS(703),
    [anon_sym_elsif] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(703),
    [anon_sym_ensure] = ACTIONS(703),
    [sym_comment] = ACTIONS(87),
  },
  [49] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(703),
    [anon_sym___END__] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [50] = {
    [sym__line_break2] = ACTIONS(737),
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [ts_builtin_sym_end] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(739),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(747),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [51] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym___END__] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [52] = {
    [anon_sym_EQ] = ACTIONS(827),
    [sym_comment] = ACTIONS(87),
  },
  [53] = {
    [anon_sym_EQ] = ACTIONS(829),
    [sym_comment] = ACTIONS(87),
  },
  [54] = {
    [anon_sym_COMMA] = ACTIONS(831),
    [anon_sym_EQ] = ACTIONS(833),
    [sym_comment] = ACTIONS(87),
  },
  [55] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(839),
    [anon_sym_DASH_EQ] = ACTIONS(839),
    [anon_sym_STAR_EQ] = ACTIONS(839),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(839),
    [anon_sym_SLASH_EQ] = ACTIONS(839),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(839),
    [anon_sym_PIPE_EQ] = ACTIONS(839),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(839),
    [anon_sym_AMP_EQ] = ACTIONS(839),
    [anon_sym_PERCENT_EQ] = ACTIONS(839),
    [anon_sym_GT_GT_EQ] = ACTIONS(839),
    [anon_sym_LT_LT_EQ] = ACTIONS(839),
    [anon_sym_CARET_EQ] = ACTIONS(839),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [56] = {
    [sym_string] = STATE(451),
    [aux_sym_chained_string_repeat1] = STATE(451),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [57] = {
    [sym__line_break2] = ACTIONS(841),
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [ts_builtin_sym_end] = ACTIONS(841),
    [anon_sym___END__] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_when] = ACTIONS(841),
    [anon_sym_elsif] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_then] = ACTIONS(841),
    [anon_sym_ensure] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [58] = {
    [sym__statement] = STATE(467),
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_if_modifier] = STATE(468),
    [sym_unless_modifier] = STATE(468),
    [sym_while_modifier] = STATE(468),
    [sym_until_modifier] = STATE(468),
    [sym_rescue_modifier] = STATE(468),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(469),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(469),
    [sym_operator_assignment] = STATE(469),
    [sym_conditional] = STATE(469),
    [sym_range] = STATE(469),
    [sym_binary] = STATE(469),
    [sym_unary] = STATE(469),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_undef] = STATE(468),
    [sym_alias] = STATE(468),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym_empty_statement] = STATE(468),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [anon_sym_undef] = ACTIONS(875),
    [anon_sym_alias] = ACTIONS(877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [59] = {
    [sym__string_end2] = ACTIONS(885),
    [sym_comment] = ACTIONS(87),
  },
  [60] = {
    [sym_interpolation] = STATE(476),
    [aux_sym__literal_contents_repeat1] = STATE(476),
    [sym__string_content2] = ACTIONS(887),
    [sym__string_end2] = ACTIONS(889),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(887),
  },
  [61] = {
    [sym__line_break2] = ACTIONS(891),
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym___END__] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_end] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_when] = ACTIONS(891),
    [anon_sym_elsif] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_then] = ACTIONS(891),
    [anon_sym_ensure] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [62] = {
    [sym__string_end2] = ACTIONS(895),
    [sym_comment] = ACTIONS(87),
  },
  [63] = {
    [sym__line_break2] = ACTIONS(897),
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(897),
    [anon_sym___END__] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(897),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_when] = ACTIONS(897),
    [anon_sym_elsif] = ACTIONS(897),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_then] = ACTIONS(897),
    [anon_sym_ensure] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [64] = {
    [sym__string_end2] = ACTIONS(901),
    [sym_comment] = ACTIONS(87),
  },
  [65] = {
    [sym__line_break2] = ACTIONS(903),
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym___END__] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_when] = ACTIONS(903),
    [anon_sym_elsif] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_then] = ACTIONS(903),
    [anon_sym_ensure] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [66] = {
    [sym__string_end2] = ACTIONS(907),
    [sym_comment] = ACTIONS(87),
  },
  [67] = {
    [sym__line_break2] = ACTIONS(909),
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [sym_comment] = ACTIONS(87),
  },
  [68] = {
    [sym__statement] = STATE(480),
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_if_modifier] = STATE(468),
    [sym_unless_modifier] = STATE(468),
    [sym_while_modifier] = STATE(468),
    [sym_until_modifier] = STATE(468),
    [sym_rescue_modifier] = STATE(468),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(469),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(469),
    [sym_operator_assignment] = STATE(469),
    [sym_conditional] = STATE(469),
    [sym_range] = STATE(469),
    [sym_binary] = STATE(469),
    [sym_unary] = STATE(469),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_undef] = STATE(468),
    [sym_alias] = STATE(468),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym_empty_statement] = STATE(468),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [anon_sym_undef] = ACTIONS(875),
    [anon_sym_alias] = ACTIONS(877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [69] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(483),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(913),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(915),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [70] = {
    [aux_sym_string_array_repeat1] = STATE(486),
    [sym__string_end2] = ACTIONS(917),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(919),
  },
  [71] = {
    [sym_interpolation] = STATE(487),
    [aux_sym__literal_contents_repeat1] = STATE(487),
    [sym__string_content2] = ACTIONS(921),
    [sym__string_end2] = ACTIONS(889),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(923),
    [sym_escape_sequence] = ACTIONS(925),
  },
  [72] = {
    [sym__line_break2] = ACTIONS(927),
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym___END__] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_when] = ACTIONS(927),
    [anon_sym_elsif] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_then] = ACTIONS(927),
    [anon_sym_ensure] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [sym_comment] = ACTIONS(87),
  },
  [73] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(490),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(931),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(933),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [74] = {
    [aux_sym_symbol_array_repeat1] = STATE(493),
    [sym__string_end2] = ACTIONS(935),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(937),
  },
  [75] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [76] = {
    [sym_uninterpreted] = ACTIONS(943),
    [sym_comment] = ACTIONS(109),
  },
  [77] = {
    [sym__statements] = STATE(505),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(947),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [78] = {
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [79] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(514),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(971),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [80] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(516),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(973),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [81] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(518),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(975),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [82] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(520),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(977),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [83] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(523),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(979),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(981),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [84] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(526),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(983),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(985),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [85] = {
    [sym_interpolation] = STATE(529),
    [aux_sym_heredoc_body_repeat1] = STATE(529),
    [sym__heredoc_content2] = ACTIONS(987),
    [sym_heredoc_end2] = ACTIONS(989),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(987),
  },
  [86] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(530),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(530),
    [sym_operator_assignment] = STATE(530),
    [sym_conditional] = STATE(530),
    [sym_range] = STATE(530),
    [sym_binary] = STATE(530),
    [sym_unary] = STATE(530),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [87] = {
    [anon_sym_COLON] = ACTIONS(993),
    [sym_comment] = ACTIONS(87),
  },
  [88] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(534),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(535),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(995),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [89] = {
    [sym__line_break2] = ACTIONS(997),
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [90] = {
    [sym__method_rest] = STATE(537),
    [sym__variable] = STATE(538),
    [sym_operator] = STATE(539),
    [sym__method_name] = STATE(539),
    [sym_setter] = STATE(539),
    [sym_symbol] = STATE(539),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(1001),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(1003),
    [sym_self] = ACTIONS(1003),
  },
  [91] = {
    [sym__statements] = STATE(541),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1005),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [92] = {
    [sym_constant] = ACTIONS(1007),
    [sym_identifier] = ACTIONS(1007),
    [sym_comment] = ACTIONS(87),
  },
  [93] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(555),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(555),
    [sym_operator_assignment] = STATE(555),
    [sym_conditional] = STATE(555),
    [sym_range] = STATE(555),
    [sym_binary] = STATE(555),
    [sym_unary] = STATE(555),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [94] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(563),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(1043),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1045),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [95] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(565),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1047),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [96] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(583),
    [sym__argument] = STATE(584),
    [sym_splat_argument] = STATE(584),
    [sym_hash_splat_argument] = STATE(584),
    [sym_block_argument] = STATE(584),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(584),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [97] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(583),
    [sym__argument] = STATE(584),
    [sym_splat_argument] = STATE(584),
    [sym_hash_splat_argument] = STATE(584),
    [sym_block_argument] = STATE(584),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(584),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [98] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(583),
    [sym__argument] = STATE(584),
    [sym_splat_argument] = STATE(584),
    [sym_hash_splat_argument] = STATE(584),
    [sym_block_argument] = STATE(584),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(584),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [99] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(583),
    [sym__argument] = STATE(584),
    [sym_splat_argument] = STATE(584),
    [sym_hash_splat_argument] = STATE(584),
    [sym_block_argument] = STATE(584),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(584),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [100] = {
    [sym__statement] = STATE(591),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [101] = {
    [sym__statement] = STATE(592),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [102] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(593),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(593),
    [sym_operator_assignment] = STATE(593),
    [sym_conditional] = STATE(593),
    [sym_range] = STATE(593),
    [sym_binary] = STATE(593),
    [sym_unary] = STATE(593),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [103] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(594),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(594),
    [sym_operator_assignment] = STATE(594),
    [sym_conditional] = STATE(594),
    [sym_range] = STATE(594),
    [sym_binary] = STATE(594),
    [sym_unary] = STATE(594),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [104] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(595),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [105] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(596),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(596),
    [sym_operator_assignment] = STATE(596),
    [sym_conditional] = STATE(596),
    [sym_range] = STATE(596),
    [sym_binary] = STATE(596),
    [sym_unary] = STATE(596),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(597),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(597),
    [sym__line_break2] = ACTIONS(1087),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1087),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [106] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(602),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(603),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(603),
    [sym__line_break2] = ACTIONS(1089),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1091),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [107] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(604),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(604),
    [sym_operator_assignment] = STATE(604),
    [sym_conditional] = STATE(604),
    [sym_range] = STATE(604),
    [sym_binary] = STATE(604),
    [sym_unary] = STATE(604),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [108] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(605),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(605),
    [sym_operator_assignment] = STATE(605),
    [sym_conditional] = STATE(605),
    [sym_range] = STATE(605),
    [sym_binary] = STATE(605),
    [sym_unary] = STATE(605),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [109] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [110] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [111] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1099),
  },
  [112] = {
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [113] = {
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [114] = {
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [115] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(609),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(610),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1101),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [116] = {
    [sym_lambda_parameters] = STATE(613),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(614),
    [sym_block] = STATE(614),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1105),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [117] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(1127),
    [anon_sym_or] = ACTIONS(1127),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [118] = {
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(1141),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(1143),
    [anon_sym_COLON_COLON2] = ACTIONS(1145),
    [anon_sym_AMP_DOT] = ACTIONS(1147),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [119] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(671),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_do_block] = STATE(674),
    [sym_block] = STATE(674),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(1173),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(1203),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [120] = {
    [sym__heredoc_body_start2] = ACTIONS(1231),
    [anon_sym_RBRACE] = ACTIONS(1231),
    [anon_sym_COMMA] = ACTIONS(1231),
    [sym_comment] = ACTIONS(87),
  },
  [121] = {
    [anon_sym_EQ] = ACTIONS(1233),
    [sym_comment] = ACTIONS(87),
  },
  [122] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1235),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1237),
    [anon_sym_DASH_EQ] = ACTIONS(1237),
    [anon_sym_STAR_EQ] = ACTIONS(1237),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1237),
    [anon_sym_SLASH_EQ] = ACTIONS(1237),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_PIPE_EQ] = ACTIONS(1237),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1237),
    [anon_sym_AMP_EQ] = ACTIONS(1237),
    [anon_sym_PERCENT_EQ] = ACTIONS(1237),
    [anon_sym_GT_GT_EQ] = ACTIONS(1237),
    [anon_sym_LT_LT_EQ] = ACTIONS(1237),
    [anon_sym_CARET_EQ] = ACTIONS(1237),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [123] = {
    [sym_string] = STATE(680),
    [aux_sym_chained_string_repeat1] = STATE(680),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [124] = {
    [anon_sym_RBRACE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(87),
  },
  [125] = {
    [sym_heredoc_body] = STATE(682),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(1241),
    [sym_comment] = ACTIONS(87),
  },
  [126] = {
    [sym__heredoc_body_start2] = ACTIONS(1243),
    [anon_sym_RBRACE] = ACTIONS(1243),
    [anon_sym_COMMA] = ACTIONS(1245),
    [sym_comment] = ACTIONS(87),
  },
  [127] = {
    [sym__statements] = STATE(685),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(1247),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [128] = {
    [sym__line_break2] = ACTIONS(101),
    [sym__heredoc_body_start2] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(103),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_end] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(103),
    [anon_sym_unless] = ACTIONS(103),
    [anon_sym_while] = ACTIONS(103),
    [anon_sym_until] = ACTIONS(103),
    [anon_sym_rescue] = ACTIONS(103),
    [anon_sym_when] = ACTIONS(103),
    [anon_sym_elsif] = ACTIONS(103),
    [anon_sym_else] = ACTIONS(103),
    [anon_sym_then] = ACTIONS(103),
    [anon_sym_ensure] = ACTIONS(103),
    [sym_identifier] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [129] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(687),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(1249),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [130] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(696),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(696),
    [sym_operator_assignment] = STATE(696),
    [sym_conditional] = STATE(696),
    [sym_range] = STATE(696),
    [sym_binary] = STATE(696),
    [sym_unary] = STATE(696),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [131] = {
    [sym__line_break2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1275),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
    [anon_sym_end] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(1275),
    [anon_sym_elsif] = ACTIONS(1275),
    [anon_sym_else] = ACTIONS(1275),
    [anon_sym_then] = ACTIONS(1275),
    [anon_sym_ensure] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_comment] = ACTIONS(87),
  },
  [132] = {
    [sym__line_break2] = ACTIONS(1277),
    [sym__heredoc_body_start2] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [133] = {
    [sym__line_break2] = ACTIONS(1277),
    [sym__heredoc_body_start2] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1093),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(1281),
    [sym_identifier] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [134] = {
    [sym__line_break2] = ACTIONS(1283),
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [ts_builtin_sym_end] = ACTIONS(1283),
    [anon_sym___END__] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_end] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_when] = ACTIONS(1283),
    [anon_sym_elsif] = ACTIONS(1283),
    [anon_sym_else] = ACTIONS(1283),
    [anon_sym_then] = ACTIONS(1283),
    [anon_sym_ensure] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [sym_comment] = ACTIONS(87),
  },
  [135] = {
    [anon_sym_DOT] = ACTIONS(1287),
    [anon_sym_COLON_COLON] = ACTIONS(1287),
    [sym_comment] = ACTIONS(87),
  },
  [136] = {
    [sym_method_parameters] = STATE(708),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(708),
    [sym__terminator] = STATE(708),
    [sym__line_break2] = ACTIONS(1289),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(1289),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [137] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(710),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(710),
    [sym_operator_assignment] = STATE(710),
    [sym_conditional] = STATE(710),
    [sym_range] = STATE(710),
    [sym_binary] = STATE(710),
    [sym_unary] = STATE(710),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [138] = {
    [sym__line_break2] = ACTIONS(1301),
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym___END__] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_when] = ACTIONS(1301),
    [anon_sym_elsif] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_then] = ACTIONS(1301),
    [anon_sym_ensure] = ACTIONS(1301),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(1301),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [sym_comment] = ACTIONS(87),
  },
  [139] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(711),
    [sym_call] = STATE(711),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(711),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_EQ] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_instance_variable] = ACTIONS(1307),
    [sym_class_variable] = ACTIONS(1307),
    [sym_global_variable] = ACTIONS(1307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(1305),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(1305),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [140] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(727),
    [sym__argument] = STATE(728),
    [sym_splat_argument] = STATE(728),
    [sym_hash_splat_argument] = STATE(728),
    [sym_block_argument] = STATE(728),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(728),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [141] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(727),
    [sym__argument] = STATE(728),
    [sym_splat_argument] = STATE(728),
    [sym_hash_splat_argument] = STATE(728),
    [sym_block_argument] = STATE(728),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(728),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [142] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(727),
    [sym__argument] = STATE(728),
    [sym_splat_argument] = STATE(728),
    [sym_hash_splat_argument] = STATE(728),
    [sym_block_argument] = STATE(728),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(728),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [143] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(727),
    [sym__argument] = STATE(728),
    [sym_splat_argument] = STATE(728),
    [sym_hash_splat_argument] = STATE(728),
    [sym_block_argument] = STATE(728),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(728),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [144] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(732),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(732),
    [sym_operator_assignment] = STATE(732),
    [sym_conditional] = STATE(732),
    [sym_range] = STATE(732),
    [sym_binary] = STATE(732),
    [sym_unary] = STATE(732),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [145] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(733),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(733),
    [sym_operator_assignment] = STATE(733),
    [sym_conditional] = STATE(733),
    [sym_range] = STATE(733),
    [sym_binary] = STATE(733),
    [sym_unary] = STATE(733),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [146] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [147] = {
    [sym_operator] = STATE(734),
    [sym__method_name] = STATE(734),
    [sym_setter] = STATE(734),
    [sym_symbol] = STATE(734),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1339),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1339),
    [sym_class_variable] = ACTIONS(1339),
    [sym_global_variable] = ACTIONS(1339),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [148] = {
    [anon_sym_RPAREN] = ACTIONS(1341),
    [sym_comment] = ACTIONS(87),
  },
  [149] = {
    [sym_heredoc_body] = STATE(736),
    [sym__terminator] = STATE(736),
    [aux_sym__statements_repeat1] = STATE(737),
    [sym__line_break2] = ACTIONS(1343),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(1343),
    [sym_comment] = ACTIONS(87),
  },
  [150] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_RPAREN] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(1345),
    [anon_sym_unless] = ACTIONS(1347),
    [anon_sym_while] = ACTIONS(1349),
    [anon_sym_until] = ACTIONS(1351),
    [anon_sym_rescue] = ACTIONS(1353),
    [sym_comment] = ACTIONS(87),
  },
  [151] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [152] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [153] = {
    [anon_sym_EQ] = ACTIONS(1417),
    [sym_comment] = ACTIONS(87),
  },
  [154] = {
    [anon_sym_RPAREN] = ACTIONS(1419),
    [anon_sym_EQ] = ACTIONS(829),
    [sym_comment] = ACTIONS(87),
  },
  [155] = {
    [anon_sym_RPAREN] = ACTIONS(833),
    [anon_sym_COMMA] = ACTIONS(1421),
    [anon_sym_EQ] = ACTIONS(833),
    [sym_comment] = ACTIONS(87),
  },
  [156] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1423),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1425),
    [anon_sym_DASH_EQ] = ACTIONS(1425),
    [anon_sym_STAR_EQ] = ACTIONS(1425),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1425),
    [anon_sym_SLASH_EQ] = ACTIONS(1425),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_PIPE_EQ] = ACTIONS(1425),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1425),
    [anon_sym_AMP_EQ] = ACTIONS(1425),
    [anon_sym_PERCENT_EQ] = ACTIONS(1425),
    [anon_sym_GT_GT_EQ] = ACTIONS(1425),
    [anon_sym_LT_LT_EQ] = ACTIONS(1425),
    [anon_sym_CARET_EQ] = ACTIONS(1425),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [157] = {
    [sym_string] = STATE(779),
    [aux_sym_chained_string_repeat1] = STATE(779),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [158] = {
    [sym__line_break2] = ACTIONS(1427),
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym__heredoc_body_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [ts_builtin_sym_end] = ACTIONS(1427),
    [anon_sym___END__] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_end] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_rescue] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1429),
    [anon_sym_elsif] = ACTIONS(1429),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_then] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_ensure] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [159] = {
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(101),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [160] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(781),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(1431),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [161] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(783),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(1433),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [162] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(785),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(1435),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [163] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(787),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(1437),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [164] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(790),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(1439),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1441),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [165] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(793),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(1443),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(1445),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [166] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(795),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(796),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(1447),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [167] = {
    [sym__method_rest] = STATE(798),
    [sym__variable] = STATE(799),
    [sym_operator] = STATE(800),
    [sym__method_name] = STATE(800),
    [sym_setter] = STATE(800),
    [sym_symbol] = STATE(800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(1451),
    [sym_self] = ACTIONS(1451),
  },
  [168] = {
    [sym__statements] = STATE(802),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [169] = {
    [sym_constant] = ACTIONS(1455),
    [sym_identifier] = ACTIONS(1455),
    [sym_comment] = ACTIONS(87),
  },
  [170] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(806),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(1457),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1459),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [171] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(808),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1461),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [172] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(816),
    [sym__argument_list_with_parens] = STATE(817),
    [sym__argument] = STATE(818),
    [sym_splat_argument] = STATE(818),
    [sym_hash_splat_argument] = STATE(818),
    [sym_block_argument] = STATE(818),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(818),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(363),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [173] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(820),
    [sym__argument_list_with_parens] = STATE(817),
    [sym__argument] = STATE(818),
    [sym_splat_argument] = STATE(818),
    [sym_hash_splat_argument] = STATE(818),
    [sym_block_argument] = STATE(818),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(818),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(415),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [174] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(821),
    [sym__argument_list_with_parens] = STATE(817),
    [sym__argument] = STATE(818),
    [sym_splat_argument] = STATE(818),
    [sym_hash_splat_argument] = STATE(818),
    [sym_block_argument] = STATE(818),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(818),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(419),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [175] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(822),
    [sym__argument_list_with_parens] = STATE(817),
    [sym__argument] = STATE(818),
    [sym_splat_argument] = STATE(818),
    [sym_hash_splat_argument] = STATE(818),
    [sym_block_argument] = STATE(818),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(818),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(423),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [176] = {
    [sym__statement] = STATE(823),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [177] = {
    [sym__statement] = STATE(824),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [178] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(825),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(825),
    [sym_operator_assignment] = STATE(825),
    [sym_conditional] = STATE(825),
    [sym_range] = STATE(825),
    [sym_binary] = STATE(825),
    [sym_unary] = STATE(825),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [179] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(826),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(826),
    [sym_operator_assignment] = STATE(826),
    [sym_conditional] = STATE(826),
    [sym_range] = STATE(826),
    [sym_binary] = STATE(826),
    [sym_unary] = STATE(826),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [180] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(827),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [181] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(828),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(828),
    [sym_operator_assignment] = STATE(828),
    [sym_conditional] = STATE(828),
    [sym_range] = STATE(828),
    [sym_binary] = STATE(828),
    [sym_unary] = STATE(828),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(829),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(829),
    [sym__line_break2] = ACTIONS(1477),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(1477),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [182] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(834),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(835),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(835),
    [sym__line_break2] = ACTIONS(1479),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(1481),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [183] = {
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(1483),
  },
  [184] = {
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_EQ] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [185] = {
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_EQ] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [186] = {
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_EQ] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [187] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(838),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(839),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(1485),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [188] = {
    [sym_lambda_parameters] = STATE(842),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(843),
    [sym_block] = STATE(843),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1489),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [189] = {
    [anon_sym_DOT] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1493),
    [anon_sym_COLON_COLON2] = ACTIONS(1495),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [sym_comment] = ACTIONS(87),
  },
  [190] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(861),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(863),
    [sym__argument] = STATE(864),
    [sym_splat_argument] = STATE(864),
    [sym_hash_splat_argument] = STATE(864),
    [sym_block_argument] = STATE(864),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(861),
    [sym_operator_assignment] = STATE(861),
    [sym_conditional] = STATE(861),
    [sym_range] = STATE(861),
    [sym_binary] = STATE(861),
    [sym_unary] = STATE(861),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(868),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(864),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1497),
    [sym__splat_star2] = ACTIONS(1499),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1507),
    [anon_sym_EQ] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1525),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [191] = {
    [anon_sym_RPAREN] = ACTIONS(1527),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(1527),
    [anon_sym_in] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [192] = {
    [sym_string] = STATE(869),
    [aux_sym_chained_string_repeat1] = STATE(869),
    [sym__string_start2] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [193] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(870),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(870),
    [sym_operator_assignment] = STATE(870),
    [sym_conditional] = STATE(870),
    [sym_range] = STATE(870),
    [sym_binary] = STATE(870),
    [sym_unary] = STATE(870),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [194] = {
    [sym_constant] = ACTIONS(1529),
    [sym_identifier] = ACTIONS(1529),
    [sym_comment] = ACTIONS(87),
  },
  [195] = {
    [sym_superclass] = STATE(873),
    [sym_heredoc_body] = STATE(874),
    [sym__terminator] = STATE(874),
    [sym__line_break2] = ACTIONS(1531),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [196] = {
    [anon_sym_DOT] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(1493),
    [anon_sym_COLON_COLON2] = ACTIONS(1535),
    [anon_sym_AMP_DOT] = ACTIONS(1491),
    [sym_comment] = ACTIONS(87),
  },
  [197] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(873),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(874),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(874),
    [sym__line_break2] = ACTIONS(1531),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1531),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [198] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [199] = {
    [sym_heredoc_body] = STATE(897),
    [sym__terminator] = STATE(897),
    [sym__line_break2] = ACTIONS(1567),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [200] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(897),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(897),
    [sym__line_break2] = ACTIONS(1567),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(1567),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(1569),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [201] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(906),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(906),
    [sym_operator_assignment] = STATE(906),
    [sym_conditional] = STATE(906),
    [sym_range] = STATE(906),
    [sym_binary] = STATE(906),
    [sym_unary] = STATE(906),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [202] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(910),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(910),
    [sym_operator_assignment] = STATE(910),
    [sym_conditional] = STATE(910),
    [sym_range] = STATE(910),
    [sym_binary] = STATE(910),
    [sym_unary] = STATE(910),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [203] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(911),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(911),
    [sym_operator_assignment] = STATE(911),
    [sym_conditional] = STATE(911),
    [sym_range] = STATE(911),
    [sym_binary] = STATE(911),
    [sym_unary] = STATE(911),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [204] = {
    [anon_sym_COLON] = ACTIONS(1593),
    [sym_comment] = ACTIONS(87),
  },
  [205] = {
    [sym_constant] = ACTIONS(1595),
    [sym_identifier] = ACTIONS(1595),
    [sym_comment] = ACTIONS(87),
  },
  [206] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(915),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(915),
    [sym_operator_assignment] = STATE(915),
    [sym_conditional] = STATE(915),
    [sym_range] = STATE(915),
    [sym_binary] = STATE(915),
    [sym_unary] = STATE(915),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [207] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(922),
    [sym__argument] = STATE(923),
    [sym_splat_argument] = STATE(923),
    [sym_hash_splat_argument] = STATE(923),
    [sym_block_argument] = STATE(923),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(923),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [208] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(922),
    [sym__argument] = STATE(923),
    [sym_splat_argument] = STATE(923),
    [sym_hash_splat_argument] = STATE(923),
    [sym_block_argument] = STATE(923),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(923),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [209] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(922),
    [sym__argument] = STATE(923),
    [sym_splat_argument] = STATE(923),
    [sym_hash_splat_argument] = STATE(923),
    [sym_block_argument] = STATE(923),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(923),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [210] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(922),
    [sym__argument] = STATE(923),
    [sym_splat_argument] = STATE(923),
    [sym_hash_splat_argument] = STATE(923),
    [sym_block_argument] = STATE(923),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(923),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [211] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(941),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(946),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(1613),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [212] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(947),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(947),
    [sym_operator_assignment] = STATE(947),
    [sym_conditional] = STATE(947),
    [sym_range] = STATE(947),
    [sym_binary] = STATE(947),
    [sym_unary] = STATE(947),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [213] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(948),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(948),
    [sym_operator_assignment] = STATE(948),
    [sym_conditional] = STATE(948),
    [sym_range] = STATE(948),
    [sym_binary] = STATE(948),
    [sym_unary] = STATE(948),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [214] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [215] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym___END__] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(1639),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [216] = {
    [sym__line_break2] = ACTIONS(565),
    [sym__heredoc_body_start2] = ACTIONS(565),
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [ts_builtin_sym_end] = ACTIONS(565),
    [anon_sym___END__] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_end] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_when] = ACTIONS(565),
    [anon_sym_elsif] = ACTIONS(565),
    [anon_sym_else] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_ensure] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [217] = {
    [sym__line_break2] = ACTIONS(569),
    [sym__heredoc_body_start2] = ACTIONS(569),
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [ts_builtin_sym_end] = ACTIONS(569),
    [anon_sym___END__] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_end] = ACTIONS(569),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_when] = ACTIONS(569),
    [anon_sym_elsif] = ACTIONS(569),
    [anon_sym_else] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_ensure] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [218] = {
    [sym__line_break2] = ACTIONS(573),
    [sym__heredoc_body_start2] = ACTIONS(573),
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [ts_builtin_sym_end] = ACTIONS(573),
    [anon_sym___END__] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_end] = ACTIONS(573),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_when] = ACTIONS(573),
    [anon_sym_elsif] = ACTIONS(573),
    [anon_sym_else] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_ensure] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [219] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym___END__] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1657),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [220] = {
    [sym__line_break2] = ACTIONS(737),
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [ts_builtin_sym_end] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [221] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym___END__] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [222] = {
    [sym__line_break2] = ACTIONS(1699),
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [223] = {
    [sym_heredoc_body] = STATE(981),
    [aux_sym_call_repeat1] = STATE(981),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [224] = {
    [sym_heredoc_body] = STATE(981),
    [aux_sym_call_repeat1] = STATE(981),
    [aux_sym_argument_list_repeat1] = STATE(983),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [225] = {
    [anon_sym_EQ] = ACTIONS(1711),
    [sym_comment] = ACTIONS(87),
  },
  [226] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1713),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1715),
    [anon_sym_DASH_EQ] = ACTIONS(1715),
    [anon_sym_STAR_EQ] = ACTIONS(1715),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1715),
    [anon_sym_SLASH_EQ] = ACTIONS(1715),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1715),
    [anon_sym_PIPE_EQ] = ACTIONS(1715),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1715),
    [anon_sym_AMP_EQ] = ACTIONS(1715),
    [anon_sym_PERCENT_EQ] = ACTIONS(1715),
    [anon_sym_GT_GT_EQ] = ACTIONS(1715),
    [anon_sym_LT_LT_EQ] = ACTIONS(1715),
    [anon_sym_CARET_EQ] = ACTIONS(1715),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [227] = {
    [sym_string] = STATE(986),
    [aux_sym_chained_string_repeat1] = STATE(986),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1717),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [228] = {
    [sym__line_break2] = ACTIONS(1719),
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [ts_builtin_sym_end] = ACTIONS(1719),
    [anon_sym___END__] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_end] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_when] = ACTIONS(1719),
    [anon_sym_elsif] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_then] = ACTIONS(1719),
    [anon_sym_ensure] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1719),
    [sym_comment] = ACTIONS(87),
  },
  [229] = {
    [sym__line_break2] = ACTIONS(1723),
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [ts_builtin_sym_end] = ACTIONS(1723),
    [anon_sym___END__] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_end] = ACTIONS(1723),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_when] = ACTIONS(1723),
    [anon_sym_elsif] = ACTIONS(1723),
    [anon_sym_else] = ACTIONS(1723),
    [anon_sym_then] = ACTIONS(1723),
    [anon_sym_ensure] = ACTIONS(1723),
    [anon_sym_EQ_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1723),
    [anon_sym_AMP_AMP] = ACTIONS(1723),
    [anon_sym_LT_LT] = ACTIONS(1723),
    [anon_sym_GT_GT] = ACTIONS(1723),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1723),
    [anon_sym_PLUS] = ACTIONS(1723),
    [anon_sym_SLASH] = ACTIONS(1723),
    [anon_sym_PERCENT] = ACTIONS(1723),
    [sym_comment] = ACTIONS(87),
  },
  [230] = {
    [sym__line_break2] = ACTIONS(1727),
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [ts_builtin_sym_end] = ACTIONS(1727),
    [anon_sym___END__] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_end] = ACTIONS(1727),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_when] = ACTIONS(1727),
    [anon_sym_elsif] = ACTIONS(1727),
    [anon_sym_else] = ACTIONS(1727),
    [anon_sym_then] = ACTIONS(1727),
    [anon_sym_ensure] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1727),
    [anon_sym_GT_GT] = ACTIONS(1727),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_PERCENT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(87),
  },
  [231] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(987),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(987),
    [sym_operator_assignment] = STATE(987),
    [sym_conditional] = STATE(987),
    [sym_range] = STATE(987),
    [sym_binary] = STATE(987),
    [sym_unary] = STATE(987),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [232] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1003),
    [sym__argument] = STATE(1004),
    [sym_splat_argument] = STATE(1004),
    [sym_hash_splat_argument] = STATE(1004),
    [sym_block_argument] = STATE(1004),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1004),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [233] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(1003),
    [sym__argument] = STATE(1004),
    [sym_splat_argument] = STATE(1004),
    [sym_hash_splat_argument] = STATE(1004),
    [sym_block_argument] = STATE(1004),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1004),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [234] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(1003),
    [sym__argument] = STATE(1004),
    [sym_splat_argument] = STATE(1004),
    [sym_hash_splat_argument] = STATE(1004),
    [sym_block_argument] = STATE(1004),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1004),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [235] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(1003),
    [sym__argument] = STATE(1004),
    [sym_splat_argument] = STATE(1004),
    [sym_hash_splat_argument] = STATE(1004),
    [sym_block_argument] = STATE(1004),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1004),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [236] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1008),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(1008),
    [sym_operator_assignment] = STATE(1008),
    [sym_conditional] = STATE(1008),
    [sym_range] = STATE(1008),
    [sym_binary] = STATE(1008),
    [sym_unary] = STATE(1008),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [237] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1009),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(1009),
    [sym_operator_assignment] = STATE(1009),
    [sym_conditional] = STATE(1009),
    [sym_range] = STATE(1009),
    [sym_binary] = STATE(1009),
    [sym_unary] = STATE(1009),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [238] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [239] = {
    [sym_operator] = STATE(1010),
    [sym__method_name] = STATE(1010),
    [sym_setter] = STATE(1010),
    [sym_symbol] = STATE(1010),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(1761),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(1761),
    [sym_class_variable] = ACTIONS(1761),
    [sym_global_variable] = ACTIONS(1761),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [240] = {
    [sym__then] = STATE(1017),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(1777),
    [sym_comment] = ACTIONS(87),
  },
  [241] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_then] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [242] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [243] = {
    [anon_sym_EQ] = ACTIONS(1841),
    [sym_comment] = ACTIONS(87),
  },
  [244] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1843),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1845),
    [anon_sym_DASH_EQ] = ACTIONS(1845),
    [anon_sym_STAR_EQ] = ACTIONS(1845),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1845),
    [anon_sym_SLASH_EQ] = ACTIONS(1845),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1845),
    [anon_sym_PIPE_EQ] = ACTIONS(1845),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1845),
    [anon_sym_AMP_EQ] = ACTIONS(1845),
    [anon_sym_PERCENT_EQ] = ACTIONS(1845),
    [anon_sym_GT_GT_EQ] = ACTIONS(1845),
    [anon_sym_LT_LT_EQ] = ACTIONS(1845),
    [anon_sym_CARET_EQ] = ACTIONS(1845),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [245] = {
    [sym_string] = STATE(1053),
    [aux_sym_chained_string_repeat1] = STATE(1053),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [246] = {
    [sym__then] = STATE(1054),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(1849),
    [sym_comment] = ACTIONS(87),
  },
  [247] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1056),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1056),
    [sym_operator_assignment] = STATE(1056),
    [sym_conditional] = STATE(1056),
    [sym_range] = STATE(1056),
    [sym_binary] = STATE(1056),
    [sym_unary] = STATE(1056),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [248] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1072),
    [sym__argument] = STATE(1073),
    [sym_splat_argument] = STATE(1073),
    [sym_hash_splat_argument] = STATE(1073),
    [sym_block_argument] = STATE(1073),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1073),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [249] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(1072),
    [sym__argument] = STATE(1073),
    [sym_splat_argument] = STATE(1073),
    [sym_hash_splat_argument] = STATE(1073),
    [sym_block_argument] = STATE(1073),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1073),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [250] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(1072),
    [sym__argument] = STATE(1073),
    [sym_splat_argument] = STATE(1073),
    [sym_hash_splat_argument] = STATE(1073),
    [sym_block_argument] = STATE(1073),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1073),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [251] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(1072),
    [sym__argument] = STATE(1073),
    [sym_splat_argument] = STATE(1073),
    [sym_hash_splat_argument] = STATE(1073),
    [sym_block_argument] = STATE(1073),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1073),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [252] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1077),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1077),
    [sym_operator_assignment] = STATE(1077),
    [sym_conditional] = STATE(1077),
    [sym_range] = STATE(1077),
    [sym_binary] = STATE(1077),
    [sym_unary] = STATE(1077),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [253] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1078),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1078),
    [sym_operator_assignment] = STATE(1078),
    [sym_conditional] = STATE(1078),
    [sym_range] = STATE(1078),
    [sym_binary] = STATE(1078),
    [sym_unary] = STATE(1078),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [254] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [255] = {
    [sym__do] = STATE(1091),
    [sym_heredoc_body] = STATE(1091),
    [sym__terminator] = STATE(1091),
    [sym__line_break2] = ACTIONS(1881),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1881),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1881),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [256] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(1923),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [257] = {
    [anon_sym_EQ] = ACTIONS(1955),
    [sym_comment] = ACTIONS(87),
  },
  [258] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(1959),
    [anon_sym_DASH_EQ] = ACTIONS(1959),
    [anon_sym_STAR_EQ] = ACTIONS(1959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1959),
    [anon_sym_SLASH_EQ] = ACTIONS(1959),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1959),
    [anon_sym_PIPE_EQ] = ACTIONS(1959),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1959),
    [anon_sym_AMP_EQ] = ACTIONS(1959),
    [anon_sym_PERCENT_EQ] = ACTIONS(1959),
    [anon_sym_GT_GT_EQ] = ACTIONS(1959),
    [anon_sym_LT_LT_EQ] = ACTIONS(1959),
    [anon_sym_CARET_EQ] = ACTIONS(1959),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [259] = {
    [sym_string] = STATE(1116),
    [aux_sym_chained_string_repeat1] = STATE(1116),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [260] = {
    [sym__do] = STATE(1117),
    [sym_heredoc_body] = STATE(1117),
    [sym__terminator] = STATE(1117),
    [sym__line_break2] = ACTIONS(1961),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(1961),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(1961),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [261] = {
    [sym__statements] = STATE(802),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(1453),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [262] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(191),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(191),
    [sym__lhs] = STATE(191),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(191),
    [sym_false] = STATE(191),
    [sym_nil] = STATE(191),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_in] = ACTIONS(1963),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [263] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1131),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(1133),
    [sym__argument] = STATE(1134),
    [sym_splat_argument] = STATE(1134),
    [sym_hash_splat_argument] = STATE(1134),
    [sym_block_argument] = STATE(1134),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(1131),
    [sym_operator_assignment] = STATE(1131),
    [sym_conditional] = STATE(1131),
    [sym_range] = STATE(1131),
    [sym_binary] = STATE(1131),
    [sym_unary] = STATE(1131),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1137),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1134),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1965),
    [sym__splat_star2] = ACTIONS(1967),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1991),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [264] = {
    [sym_in] = STATE(1139),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [265] = {
    [anon_sym_COMMA] = ACTIONS(1999),
    [anon_sym_in] = ACTIONS(833),
    [sym_comment] = ACTIONS(87),
  },
  [266] = {
    [anon_sym_RPAREN] = ACTIONS(835),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_EQ] = ACTIONS(835),
    [anon_sym_in] = ACTIONS(835),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [267] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1141),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1141),
    [sym_operator_assignment] = STATE(1141),
    [sym_conditional] = STATE(1141),
    [sym_range] = STATE(1141),
    [sym_binary] = STATE(1141),
    [sym_unary] = STATE(1141),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [268] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1157),
    [sym__argument] = STATE(1158),
    [sym_splat_argument] = STATE(1158),
    [sym_hash_splat_argument] = STATE(1158),
    [sym_block_argument] = STATE(1158),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1158),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [269] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(1157),
    [sym__argument] = STATE(1158),
    [sym_splat_argument] = STATE(1158),
    [sym_hash_splat_argument] = STATE(1158),
    [sym_block_argument] = STATE(1158),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1158),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [270] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(1157),
    [sym__argument] = STATE(1158),
    [sym_splat_argument] = STATE(1158),
    [sym_hash_splat_argument] = STATE(1158),
    [sym_block_argument] = STATE(1158),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1158),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [271] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(1157),
    [sym__argument] = STATE(1158),
    [sym_splat_argument] = STATE(1158),
    [sym_hash_splat_argument] = STATE(1158),
    [sym_block_argument] = STATE(1158),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1158),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [272] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1162),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1162),
    [sym_operator_assignment] = STATE(1162),
    [sym_conditional] = STATE(1162),
    [sym_range] = STATE(1162),
    [sym_binary] = STATE(1162),
    [sym_unary] = STATE(1162),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [273] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1163),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1163),
    [sym_operator_assignment] = STATE(1163),
    [sym_conditional] = STATE(1163),
    [sym_range] = STATE(1163),
    [sym_binary] = STATE(1163),
    [sym_unary] = STATE(1163),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [274] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [275] = {
    [sym_heredoc_body] = STATE(1176),
    [sym__terminator] = STATE(1176),
    [sym__line_break2] = ACTIONS(2031),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(2031),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [276] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [277] = {
    [anon_sym_EQ] = ACTIONS(2065),
    [sym_comment] = ACTIONS(87),
  },
  [278] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2067),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2069),
    [anon_sym_DASH_EQ] = ACTIONS(2069),
    [anon_sym_STAR_EQ] = ACTIONS(2069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2069),
    [anon_sym_SLASH_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_PIPE_EQ] = ACTIONS(2069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2069),
    [anon_sym_AMP_EQ] = ACTIONS(2069),
    [anon_sym_PERCENT_EQ] = ACTIONS(2069),
    [anon_sym_GT_GT_EQ] = ACTIONS(2069),
    [anon_sym_LT_LT_EQ] = ACTIONS(2069),
    [anon_sym_CARET_EQ] = ACTIONS(2069),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [279] = {
    [sym_string] = STATE(1179),
    [aux_sym_chained_string_repeat1] = STATE(1179),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [280] = {
    [sym_when] = STATE(1181),
    [aux_sym_case_repeat1] = STATE(1182),
    [anon_sym_SEMI] = ACTIONS(2071),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [281] = {
    [sym_interpolation] = STATE(1184),
    [aux_sym_heredoc_body_repeat1] = STATE(1184),
    [sym__heredoc_content2] = ACTIONS(2075),
    [sym_heredoc_end2] = ACTIONS(2077),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(2075),
  },
  [282] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1185),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(1185),
    [sym_operator_assignment] = STATE(1185),
    [sym_conditional] = STATE(1185),
    [sym_range] = STATE(1185),
    [sym_binary] = STATE(1185),
    [sym_unary] = STATE(1185),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [283] = {
    [sym__line_break2] = ACTIONS(275),
    [sym__simple_symbol2] = ACTIONS(2079),
    [sym__string_start2] = ACTIONS(2079),
    [sym__symbol_start2] = ACTIONS(2079),
    [sym__subshell_start2] = ACTIONS(2079),
    [sym__regex_start2] = ACTIONS(2079),
    [sym__string_array_start2] = ACTIONS(2079),
    [sym__symbol_array_start2] = ACTIONS(2079),
    [sym__heredoc_body_start2] = ACTIONS(275),
    [sym_heredoc_beginning2] = ACTIONS(2079),
    [sym__unary_minus2] = ACTIONS(2079),
    [anon_sym_BEGIN] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_END] = ACTIONS(2081),
    [anon_sym_def] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2079),
    [anon_sym_COLON_COLON] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_STAR] = ACTIONS(2079),
    [anon_sym_class] = ACTIONS(2081),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_end] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(2081),
    [anon_sym_break] = ACTIONS(2081),
    [anon_sym_next] = ACTIONS(2081),
    [sym_redo] = ACTIONS(2081),
    [sym_retry] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_unless] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_until] = ACTIONS(2081),
    [anon_sym_rescue] = ACTIONS(2081),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_case] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_begin] = ACTIONS(2081),
    [anon_sym_ensure] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_defined_QMARK] = ACTIONS(2079),
    [anon_sym_not] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [sym_constant] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2079),
    [sym_class_variable] = ACTIONS(2079),
    [sym_global_variable] = ACTIONS(2079),
    [anon_sym_undef] = ACTIONS(2081),
    [anon_sym_alias] = ACTIONS(2081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [sym_complex] = ACTIONS(2079),
    [sym_super] = ACTIONS(2081),
    [anon_sym_true] = ACTIONS(2081),
    [anon_sym_TRUE] = ACTIONS(2081),
    [anon_sym_false] = ACTIONS(2081),
    [anon_sym_FALSE] = ACTIONS(2081),
    [sym_self] = ACTIONS(2081),
    [anon_sym_nil] = ACTIONS(2081),
    [anon_sym_NIL] = ACTIONS(2081),
    [sym_character] = ACTIONS(2079),
    [anon_sym_LBRACK2] = ACTIONS(2079),
    [anon_sym_DASH_GT] = ACTIONS(2079),
  },
  [284] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1201),
    [sym__argument] = STATE(1202),
    [sym_splat_argument] = STATE(1202),
    [sym_hash_splat_argument] = STATE(1202),
    [sym_block_argument] = STATE(1202),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1202),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [285] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(1201),
    [sym__argument] = STATE(1202),
    [sym_splat_argument] = STATE(1202),
    [sym_hash_splat_argument] = STATE(1202),
    [sym_block_argument] = STATE(1202),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1202),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [286] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(1201),
    [sym__argument] = STATE(1202),
    [sym_splat_argument] = STATE(1202),
    [sym_hash_splat_argument] = STATE(1202),
    [sym_block_argument] = STATE(1202),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1202),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [287] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(1201),
    [sym__argument] = STATE(1202),
    [sym_splat_argument] = STATE(1202),
    [sym_hash_splat_argument] = STATE(1202),
    [sym_block_argument] = STATE(1202),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1202),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [288] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym__then] = STATE(1216),
    [sym_begin] = STATE(220),
    [sym_exceptions] = STATE(1217),
    [sym_exception_variable] = STATE(1218),
    [sym__arg] = STATE(1219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(1221),
    [sym_assignment] = STATE(1219),
    [sym_operator_assignment] = STATE(1219),
    [sym_conditional] = STATE(1219),
    [sym_range] = STATE(1219),
    [sym_binary] = STATE(1219),
    [sym_unary] = STATE(1219),
    [sym__arg_or_splat_arg] = STATE(1221),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1055),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(2113),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(2125),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(2127),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [289] = {
    [sym__statements] = STATE(1235),
    [sym__top_level_statement] = STATE(1236),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1237),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(1238),
    [sym_operator_assignment] = STATE(1238),
    [sym_conditional] = STATE(1238),
    [sym_range] = STATE(1238),
    [sym_binary] = STATE(1238),
    [sym_unary] = STATE(1238),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1243),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1243),
    [sym__line_break2] = ACTIONS(2141),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2147),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [anon_sym_undef] = ACTIONS(2169),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [290] = {
    [sym__statements] = STATE(1253),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2173),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [291] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1261),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(1261),
    [sym_operator_assignment] = STATE(1261),
    [sym_conditional] = STATE(1261),
    [sym_range] = STATE(1261),
    [sym_binary] = STATE(1261),
    [sym_unary] = STATE(1261),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [292] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1262),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(1262),
    [sym_operator_assignment] = STATE(1262),
    [sym_conditional] = STATE(1262),
    [sym_range] = STATE(1262),
    [sym_binary] = STATE(1262),
    [sym_unary] = STATE(1262),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [293] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [294] = {
    [sym_operator] = STATE(1263),
    [sym__method_name] = STATE(1263),
    [sym_setter] = STATE(1263),
    [sym_symbol] = STATE(1263),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2197),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2197),
    [sym_class_variable] = ACTIONS(2197),
    [sym_global_variable] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [295] = {
    [sym_else] = STATE(1265),
    [sym_ensure] = STATE(1266),
    [sym_rescue] = STATE(1267),
    [anon_sym_end] = ACTIONS(2199),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [296] = {
    [sym_heredoc_body] = STATE(1268),
    [sym__terminator] = STATE(1268),
    [aux_sym__statements_repeat1] = STATE(1269),
    [sym__line_break2] = ACTIONS(2207),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(2207),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_rescue] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [297] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(2209),
    [anon_sym_unless] = ACTIONS(2211),
    [anon_sym_while] = ACTIONS(2213),
    [anon_sym_until] = ACTIONS(2215),
    [anon_sym_rescue] = ACTIONS(2217),
    [anon_sym_else] = ACTIONS(691),
    [anon_sym_ensure] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [298] = {
    [sym_ensure] = STATE(1266),
    [anon_sym_end] = ACTIONS(2199),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [299] = {
    [anon_sym_end] = ACTIONS(2199),
    [sym_comment] = ACTIONS(87),
  },
  [300] = {
    [sym_else] = STATE(1265),
    [sym_ensure] = STATE(1266),
    [anon_sym_end] = ACTIONS(2199),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [301] = {
    [sym__line_break2] = ACTIONS(2219),
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [ts_builtin_sym_end] = ACTIONS(2219),
    [anon_sym___END__] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_end] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_when] = ACTIONS(2219),
    [anon_sym_elsif] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2219),
    [anon_sym_then] = ACTIONS(2219),
    [anon_sym_ensure] = ACTIONS(2219),
    [anon_sym_EQ_GT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [anon_sym_PERCENT] = ACTIONS(2219),
    [sym_comment] = ACTIONS(87),
  },
  [302] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_ensure] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [303] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [304] = {
    [anon_sym_EQ] = ACTIONS(2285),
    [sym_comment] = ACTIONS(87),
  },
  [305] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2287),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2289),
    [anon_sym_DASH_EQ] = ACTIONS(2289),
    [anon_sym_STAR_EQ] = ACTIONS(2289),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2289),
    [anon_sym_SLASH_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2289),
    [anon_sym_PIPE_EQ] = ACTIONS(2289),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2289),
    [anon_sym_AMP_EQ] = ACTIONS(2289),
    [anon_sym_PERCENT_EQ] = ACTIONS(2289),
    [anon_sym_GT_GT_EQ] = ACTIONS(2289),
    [anon_sym_LT_LT_EQ] = ACTIONS(2289),
    [anon_sym_CARET_EQ] = ACTIONS(2289),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [306] = {
    [sym_string] = STATE(1309),
    [aux_sym_chained_string_repeat1] = STATE(1309),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [307] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(1310),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2291),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [308] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [309] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [310] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [311] = {
    [sym__line_break2] = ACTIONS(1277),
    [sym__heredoc_body_start2] = ACTIONS(1277),
    [ts_builtin_sym_end] = ACTIONS(1277),
    [anon_sym___END__] = ACTIONS(1279),
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_LPAREN] = ACTIONS(1277),
    [anon_sym_RPAREN] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_SEMI] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(1281),
    [anon_sym_end] = ACTIONS(1279),
    [anon_sym_if] = ACTIONS(1279),
    [anon_sym_unless] = ACTIONS(1279),
    [anon_sym_while] = ACTIONS(1279),
    [anon_sym_until] = ACTIONS(1279),
    [anon_sym_rescue] = ACTIONS(1279),
    [anon_sym_when] = ACTIONS(1279),
    [anon_sym_elsif] = ACTIONS(1279),
    [anon_sym_else] = ACTIONS(1279),
    [anon_sym_then] = ACTIONS(1279),
    [anon_sym_ensure] = ACTIONS(1279),
    [sym_identifier] = ACTIONS(1279),
    [sym_comment] = ACTIONS(87),
  },
  [312] = {
    [aux_sym_undef_repeat1] = STATE(1312),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [ts_builtin_sym_end] = ACTIONS(2297),
    [anon_sym___END__] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [313] = {
    [sym__simple_symbol2] = ACTIONS(101),
    [sym__symbol_start2] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_STAR] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(101),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [anon_sym_BANG] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(101),
    [sym_constant] = ACTIONS(101),
    [sym_identifier] = ACTIONS(101),
    [sym_instance_variable] = ACTIONS(101),
    [sym_class_variable] = ACTIONS(101),
    [sym_global_variable] = ACTIONS(101),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_PLUS_AT] = ACTIONS(101),
    [anon_sym_DASH_AT] = ACTIONS(101),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(103),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(101),
    [anon_sym_BQUOTE] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [314] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1314),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2301),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [315] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_AMP] = ACTIONS(1273),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1273),
    [anon_sym_LT_LT] = ACTIONS(1273),
    [anon_sym_GT_GT] = ACTIONS(1273),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1273),
    [anon_sym_PERCENT] = ACTIONS(1273),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1273),
    [sym_identifier] = ACTIONS(1273),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [anon_sym_DASH] = ACTIONS(1275),
    [anon_sym_PLUS_AT] = ACTIONS(1273),
    [anon_sym_DASH_AT] = ACTIONS(1273),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1275),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1273),
    [anon_sym_BQUOTE] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [316] = {
    [sym__simple_symbol2] = ACTIONS(1277),
    [sym__symbol_start2] = ACTIONS(1277),
    [anon_sym_PIPE] = ACTIONS(1277),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_STAR_STAR] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(2303),
    [anon_sym_LT] = ACTIONS(1279),
    [anon_sym_DOT_DOT] = ACTIONS(1277),
    [anon_sym_LT_LT] = ACTIONS(1277),
    [anon_sym_GT_GT] = ACTIONS(1277),
    [anon_sym_EQ_EQ] = ACTIONS(1279),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1277),
    [anon_sym_LT_EQ_GT] = ACTIONS(1277),
    [anon_sym_EQ_TILDE] = ACTIONS(1277),
    [anon_sym_BANG_TILDE] = ACTIONS(1277),
    [anon_sym_LT_EQ] = ACTIONS(1279),
    [anon_sym_GT] = ACTIONS(1279),
    [anon_sym_GT_EQ] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(1277),
    [anon_sym_PERCENT] = ACTIONS(1277),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_TILDE] = ACTIONS(1277),
    [sym_constant] = ACTIONS(1277),
    [sym_identifier] = ACTIONS(1277),
    [sym_instance_variable] = ACTIONS(1277),
    [sym_class_variable] = ACTIONS(1277),
    [sym_global_variable] = ACTIONS(1277),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_PLUS_AT] = ACTIONS(1277),
    [anon_sym_DASH_AT] = ACTIONS(1277),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(1279),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(1277),
    [anon_sym_BQUOTE] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [317] = {
    [sym_operator] = STATE(1316),
    [sym__method_name] = STATE(1316),
    [sym_setter] = STATE(1316),
    [sym_symbol] = STATE(1316),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(2305),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(2305),
    [sym_class_variable] = ACTIONS(2305),
    [sym_global_variable] = ACTIONS(2305),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [318] = {
    [sym__line_break2] = ACTIONS(2307),
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2307),
    [anon_sym___END__] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_end] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_when] = ACTIONS(2307),
    [anon_sym_elsif] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_then] = ACTIONS(2307),
    [anon_sym_ensure] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
  },
  [319] = {
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [320] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1318),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2311),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [321] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1320),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2313),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [322] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1322),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2315),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [323] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1324),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2317),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [324] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1327),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(2319),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2321),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [325] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1330),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(2323),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2325),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [326] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1339),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(1339),
    [sym_operator_assignment] = STATE(1339),
    [sym_conditional] = STATE(1339),
    [sym_range] = STATE(1339),
    [sym_binary] = STATE(1339),
    [sym_unary] = STATE(1339),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [327] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1344),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(1344),
    [sym_operator_assignment] = STATE(1344),
    [sym_conditional] = STATE(1344),
    [sym_range] = STATE(1344),
    [sym_binary] = STATE(1344),
    [sym_unary] = STATE(1344),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [328] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1345),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(1345),
    [sym_operator_assignment] = STATE(1345),
    [sym_conditional] = STATE(1345),
    [sym_range] = STATE(1345),
    [sym_binary] = STATE(1345),
    [sym_unary] = STATE(1345),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [329] = {
    [anon_sym_COLON] = ACTIONS(2349),
    [sym_comment] = ACTIONS(87),
  },
  [330] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(1350),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(2351),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [331] = {
    [sym__method_rest] = STATE(1352),
    [sym__variable] = STATE(1353),
    [sym_operator] = STATE(1354),
    [sym__method_name] = STATE(1354),
    [sym_setter] = STATE(1354),
    [sym_symbol] = STATE(1354),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2353),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2355),
    [sym_self] = ACTIONS(2355),
  },
  [332] = {
    [sym__statements] = STATE(1356),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2357),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [333] = {
    [sym_constant] = ACTIONS(2359),
    [sym_identifier] = ACTIONS(2359),
    [sym_comment] = ACTIONS(87),
  },
  [334] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1358),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(1358),
    [sym_operator_assignment] = STATE(1358),
    [sym_conditional] = STATE(1358),
    [sym_range] = STATE(1358),
    [sym_binary] = STATE(1358),
    [sym_unary] = STATE(1358),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [335] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(1361),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(2361),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2363),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [336] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(1363),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2365),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [337] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [338] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [339] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [340] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(1375),
    [sym__argument] = STATE(1376),
    [sym_splat_argument] = STATE(1376),
    [sym_hash_splat_argument] = STATE(1376),
    [sym_block_argument] = STATE(1376),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1376),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [341] = {
    [sym__statement] = STATE(1383),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [342] = {
    [sym__statement] = STATE(1384),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [343] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1385),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1385),
    [sym_operator_assignment] = STATE(1385),
    [sym_conditional] = STATE(1385),
    [sym_range] = STATE(1385),
    [sym_binary] = STATE(1385),
    [sym_unary] = STATE(1385),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [344] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1386),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1386),
    [sym_operator_assignment] = STATE(1386),
    [sym_conditional] = STATE(1386),
    [sym_range] = STATE(1386),
    [sym_binary] = STATE(1386),
    [sym_unary] = STATE(1386),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [345] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(1387),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [346] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1388),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1388),
    [sym_operator_assignment] = STATE(1388),
    [sym_conditional] = STATE(1388),
    [sym_range] = STATE(1388),
    [sym_binary] = STATE(1388),
    [sym_unary] = STATE(1388),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1389),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(1389),
    [sym__line_break2] = ACTIONS(2385),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2385),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [347] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(1394),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1395),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1395),
    [sym__line_break2] = ACTIONS(2387),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2389),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [348] = {
    [sym__line_break2] = ACTIONS(2391),
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [ts_builtin_sym_end] = ACTIONS(2391),
    [anon_sym___END__] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_end] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_when] = ACTIONS(2391),
    [anon_sym_elsif] = ACTIONS(2391),
    [anon_sym_else] = ACTIONS(2391),
    [anon_sym_then] = ACTIONS(2391),
    [anon_sym_ensure] = ACTIONS(2391),
    [anon_sym_EQ_GT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2391),
    [anon_sym_AMP_AMP] = ACTIONS(2391),
    [anon_sym_LT_LT] = ACTIONS(2391),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_SLASH] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(87),
  },
  [349] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1396),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(1396),
    [sym_operator_assignment] = STATE(1396),
    [sym_conditional] = STATE(1396),
    [sym_range] = STATE(1396),
    [sym_binary] = STATE(1396),
    [sym_unary] = STATE(1396),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [350] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1397),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(1397),
    [sym_operator_assignment] = STATE(1397),
    [sym_conditional] = STATE(1397),
    [sym_range] = STATE(1397),
    [sym_binary] = STATE(1397),
    [sym_unary] = STATE(1397),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [351] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1398),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(1398),
    [sym_operator_assignment] = STATE(1398),
    [sym_conditional] = STATE(1398),
    [sym_range] = STATE(1398),
    [sym_binary] = STATE(1398),
    [sym_unary] = STATE(1398),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [352] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(2395),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [353] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2397),
  },
  [354] = {
    [sym__heredoc_body_start2] = ACTIONS(565),
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_EQ_GT] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [355] = {
    [sym__heredoc_body_start2] = ACTIONS(569),
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_EQ_GT] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [356] = {
    [sym__heredoc_body_start2] = ACTIONS(573),
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_EQ_GT] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [357] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(1401),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1402),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2399),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [358] = {
    [sym_lambda_parameters] = STATE(1405),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(1406),
    [sym_block] = STATE(1406),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2403),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [359] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(2417),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(2425),
    [anon_sym_or] = ACTIONS(2425),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [360] = {
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(2439),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(2443),
    [anon_sym_AMP_DOT] = ACTIONS(2445),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [361] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_RBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [362] = {
    [sym_heredoc_body] = STATE(1448),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(2481),
    [sym_comment] = ACTIONS(87),
  },
  [363] = {
    [sym__heredoc_body_start2] = ACTIONS(2483),
    [anon_sym_COMMA] = ACTIONS(2485),
    [anon_sym_RBRACK] = ACTIONS(2483),
    [sym_comment] = ACTIONS(87),
  },
  [364] = {
    [anon_sym_EQ] = ACTIONS(2487),
    [sym_comment] = ACTIONS(87),
  },
  [365] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2489),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2491),
    [anon_sym_DASH_EQ] = ACTIONS(2491),
    [anon_sym_STAR_EQ] = ACTIONS(2491),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2491),
    [anon_sym_SLASH_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_PIPE_EQ] = ACTIONS(2491),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2491),
    [anon_sym_AMP_EQ] = ACTIONS(2491),
    [anon_sym_PERCENT_EQ] = ACTIONS(2491),
    [anon_sym_GT_GT_EQ] = ACTIONS(2491),
    [anon_sym_LT_LT_EQ] = ACTIONS(2491),
    [anon_sym_CARET_EQ] = ACTIONS(2491),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [366] = {
    [sym_string] = STATE(1452),
    [aux_sym_chained_string_repeat1] = STATE(1452),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2493),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [367] = {
    [anon_sym_RBRACK] = ACTIONS(2481),
    [sym_comment] = ACTIONS(87),
  },
  [368] = {
    [sym__statements] = STATE(1455),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1456),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2495),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [369] = {
    [sym__formal_parameter] = STATE(1460),
    [sym__simple_formal_parameter] = STATE(1460),
    [sym_destructured_parameter] = STATE(1460),
    [sym_splat_parameter] = STATE(1460),
    [sym_hash_splat_parameter] = STATE(1460),
    [sym_block_parameter] = STATE(1460),
    [sym_keyword_parameter] = STATE(1460),
    [sym_optional_parameter] = STATE(1460),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_RPAREN] = ACTIONS(2501),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2503),
    [sym_comment] = ACTIONS(87),
  },
  [370] = {
    [anon_sym_LBRACE] = ACTIONS(2505),
    [anon_sym_RPAREN] = ACTIONS(2505),
    [anon_sym_COMMA] = ACTIONS(2505),
    [anon_sym_PIPE] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2505),
    [anon_sym_do] = ACTIONS(2507),
    [sym_identifier] = ACTIONS(2509),
    [sym_comment] = ACTIONS(87),
  },
  [371] = {
    [anon_sym_LBRACE] = ACTIONS(2511),
    [anon_sym_RPAREN] = ACTIONS(2511),
    [anon_sym_COMMA] = ACTIONS(2511),
    [anon_sym_PIPE] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(2511),
    [anon_sym_do] = ACTIONS(2513),
    [sym_identifier] = ACTIONS(2515),
    [sym_comment] = ACTIONS(87),
  },
  [372] = {
    [sym_lambda] = STATE(1463),
    [sym_identifier] = ACTIONS(2517),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [373] = {
    [sym__statements] = STATE(1466),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1467),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1468),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1468),
    [sym__line_break2] = ACTIONS(2519),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2523),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [374] = {
    [anon_sym_LBRACE] = ACTIONS(2525),
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_COLON] = ACTIONS(2527),
    [anon_sym_EQ] = ACTIONS(2529),
    [anon_sym_do] = ACTIONS(2525),
    [sym_comment] = ACTIONS(87),
  },
  [375] = {
    [sym_do_block] = STATE(1471),
    [sym_block] = STATE(1471),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_do] = ACTIONS(2531),
    [sym_comment] = ACTIONS(87),
  },
  [376] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(1473),
    [anon_sym_LBRACE] = ACTIONS(2533),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(2533),
    [sym_comment] = ACTIONS(87),
  },
  [377] = {
    [sym__line_break2] = ACTIONS(2537),
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [ts_builtin_sym_end] = ACTIONS(2537),
    [anon_sym___END__] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_end] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_when] = ACTIONS(2537),
    [anon_sym_elsif] = ACTIONS(2537),
    [anon_sym_else] = ACTIONS(2537),
    [anon_sym_then] = ACTIONS(2537),
    [anon_sym_ensure] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [378] = {
    [sym__line_break2] = ACTIONS(2541),
    [sym_comment] = ACTIONS(87),
  },
  [379] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(47),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(49),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(49),
    [sym_operator_assignment] = STATE(49),
    [sym_conditional] = STATE(49),
    [sym_range] = STATE(49),
    [sym_binary] = STATE(49),
    [sym_unary] = STATE(49),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(2543),
    [anon_sym___END__] = ACTIONS(2545),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [380] = {
    [sym_heredoc_body] = STATE(1476),
    [sym__terminator] = STATE(1476),
    [aux_sym__statements_repeat1] = STATE(1477),
    [sym__line_break2] = ACTIONS(2547),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [ts_builtin_sym_end] = ACTIONS(2543),
    [anon_sym___END__] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(2547),
    [sym_comment] = ACTIONS(87),
  },
  [381] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1478),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1478),
    [sym_operator_assignment] = STATE(1478),
    [sym_conditional] = STATE(1478),
    [sym_range] = STATE(1478),
    [sym_binary] = STATE(1478),
    [sym_unary] = STATE(1478),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [382] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1479),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1479),
    [sym_operator_assignment] = STATE(1479),
    [sym_conditional] = STATE(1479),
    [sym_range] = STATE(1479),
    [sym_binary] = STATE(1479),
    [sym_unary] = STATE(1479),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [383] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1480),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1480),
    [sym_operator_assignment] = STATE(1480),
    [sym_conditional] = STATE(1480),
    [sym_range] = STATE(1480),
    [sym_binary] = STATE(1480),
    [sym_unary] = STATE(1480),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [384] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1481),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1481),
    [sym_operator_assignment] = STATE(1481),
    [sym_conditional] = STATE(1481),
    [sym_range] = STATE(1481),
    [sym_binary] = STATE(1481),
    [sym_unary] = STATE(1481),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [385] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1482),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1482),
    [sym_operator_assignment] = STATE(1482),
    [sym_conditional] = STATE(1482),
    [sym_range] = STATE(1482),
    [sym_binary] = STATE(1482),
    [sym_unary] = STATE(1482),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [386] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1483),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1483),
    [sym_operator_assignment] = STATE(1483),
    [sym_conditional] = STATE(1483),
    [sym_range] = STATE(1483),
    [sym_binary] = STATE(1483),
    [sym_unary] = STATE(1483),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [387] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1484),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1484),
    [sym_operator_assignment] = STATE(1484),
    [sym_conditional] = STATE(1484),
    [sym_range] = STATE(1484),
    [sym_binary] = STATE(1484),
    [sym_unary] = STATE(1484),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [388] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1485),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1485),
    [sym_operator_assignment] = STATE(1485),
    [sym_conditional] = STATE(1485),
    [sym_range] = STATE(1485),
    [sym_binary] = STATE(1485),
    [sym_unary] = STATE(1485),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [389] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1486),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1486),
    [sym_operator_assignment] = STATE(1486),
    [sym_conditional] = STATE(1486),
    [sym_range] = STATE(1486),
    [sym_binary] = STATE(1486),
    [sym_unary] = STATE(1486),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [390] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1487),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1487),
    [sym_operator_assignment] = STATE(1487),
    [sym_conditional] = STATE(1487),
    [sym_range] = STATE(1487),
    [sym_binary] = STATE(1487),
    [sym_unary] = STATE(1487),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [391] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1488),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1488),
    [sym_operator_assignment] = STATE(1488),
    [sym_conditional] = STATE(1488),
    [sym_range] = STATE(1488),
    [sym_binary] = STATE(1488),
    [sym_unary] = STATE(1488),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [392] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1498),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(1498),
    [sym_operator_assignment] = STATE(1498),
    [sym_conditional] = STATE(1498),
    [sym_range] = STATE(1498),
    [sym_binary] = STATE(1498),
    [sym_unary] = STATE(1498),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [393] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1503),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1503),
    [sym_operator_assignment] = STATE(1503),
    [sym_conditional] = STATE(1503),
    [sym_range] = STATE(1503),
    [sym_binary] = STATE(1503),
    [sym_unary] = STATE(1503),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [394] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1504),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1504),
    [sym_operator_assignment] = STATE(1504),
    [sym_conditional] = STATE(1504),
    [sym_range] = STATE(1504),
    [sym_binary] = STATE(1504),
    [sym_unary] = STATE(1504),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [395] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1505),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1505),
    [sym_operator_assignment] = STATE(1505),
    [sym_conditional] = STATE(1505),
    [sym_range] = STATE(1505),
    [sym_binary] = STATE(1505),
    [sym_unary] = STATE(1505),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [396] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1506),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1506),
    [sym_operator_assignment] = STATE(1506),
    [sym_conditional] = STATE(1506),
    [sym_range] = STATE(1506),
    [sym_binary] = STATE(1506),
    [sym_unary] = STATE(1506),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [397] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1507),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1507),
    [sym_operator_assignment] = STATE(1507),
    [sym_conditional] = STATE(1507),
    [sym_range] = STATE(1507),
    [sym_binary] = STATE(1507),
    [sym_unary] = STATE(1507),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [398] = {
    [sym_argument_list_with_parens] = STATE(1511),
    [sym__argument_list_with_parens] = STATE(1512),
    [sym_operator] = STATE(1511),
    [sym_heredoc_body] = STATE(1513),
    [aux_sym_call_repeat1] = STATE(1513),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(2579),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2575),
    [anon_sym_EQ_TILDE] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_CARET] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2575),
    [sym_constant] = ACTIONS(2581),
    [sym_identifier] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_AT] = ACTIONS(2575),
    [anon_sym_DASH_AT] = ACTIONS(2575),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2577),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2575),
    [anon_sym_BQUOTE] = ACTIONS(2575),
    [sym_comment] = ACTIONS(87),
  },
  [399] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(1515),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1516),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2583),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [400] = {
    [sym_constant] = ACTIONS(2585),
    [sym_identifier] = ACTIONS(2585),
    [sym_comment] = ACTIONS(87),
  },
  [401] = {
    [sym__line_break2] = ACTIONS(101),
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [402] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1519),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2587),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [403] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1521),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2589),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [404] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1523),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2591),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [405] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(1525),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(2593),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [406] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1528),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(2595),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2597),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [407] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1531),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(2599),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2601),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [408] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(1562),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(1562),
    [sym_operator_assignment] = STATE(1562),
    [sym_conditional] = STATE(1562),
    [sym_range] = STATE(1562),
    [sym_binary] = STATE(1562),
    [sym_unary] = STATE(1562),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [409] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(1568),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(1568),
    [sym_operator_assignment] = STATE(1568),
    [sym_conditional] = STATE(1568),
    [sym_range] = STATE(1568),
    [sym_binary] = STATE(1568),
    [sym_unary] = STATE(1568),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [410] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1570),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(1570),
    [sym_operator_assignment] = STATE(1570),
    [sym_conditional] = STATE(1570),
    [sym_range] = STATE(1570),
    [sym_binary] = STATE(1570),
    [sym_unary] = STATE(1570),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [411] = {
    [anon_sym_COLON] = ACTIONS(2681),
    [sym_comment] = ACTIONS(87),
  },
  [412] = {
    [sym__statements] = STATE(1583),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(1584),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2685),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [413] = {
    [sym__method_rest] = STATE(1593),
    [sym__variable] = STATE(1594),
    [sym_operator] = STATE(1595),
    [sym__method_name] = STATE(1595),
    [sym_setter] = STATE(1595),
    [sym_symbol] = STATE(1595),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(2709),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(2711),
    [sym_self] = ACTIONS(2711),
  },
  [414] = {
    [sym__statements] = STATE(1597),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2713),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [415] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(1598),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(1598),
    [sym_operator_assignment] = STATE(1598),
    [sym_conditional] = STATE(1598),
    [sym_range] = STATE(1598),
    [sym_binary] = STATE(1598),
    [sym_unary] = STATE(1598),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [416] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(1601),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(2715),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2717),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [417] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(1603),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(2719),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [418] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [419] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [420] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [421] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [422] = {
    [sym__statement] = STATE(1608),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [423] = {
    [sym__statement] = STATE(1609),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [424] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1610),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1610),
    [sym_operator_assignment] = STATE(1610),
    [sym_conditional] = STATE(1610),
    [sym_range] = STATE(1610),
    [sym_binary] = STATE(1610),
    [sym_unary] = STATE(1610),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [425] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1611),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(1611),
    [sym_operator_assignment] = STATE(1611),
    [sym_conditional] = STATE(1611),
    [sym_range] = STATE(1611),
    [sym_binary] = STATE(1611),
    [sym_unary] = STATE(1611),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [426] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(1612),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [427] = {
    [sym__statements] = STATE(1614),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1615),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1616),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1616),
    [sym__line_break2] = ACTIONS(2721),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2723),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [428] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1617),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1617),
    [sym_operator_assignment] = STATE(1617),
    [sym_conditional] = STATE(1617),
    [sym_range] = STATE(1617),
    [sym_binary] = STATE(1617),
    [sym_unary] = STATE(1617),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1618),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(1618),
    [sym__line_break2] = ACTIONS(2725),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2725),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [429] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(1623),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1624),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1624),
    [sym__line_break2] = ACTIONS(2727),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [430] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(1626),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1627),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(2731),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [431] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1628),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(1628),
    [sym_operator_assignment] = STATE(1628),
    [sym_conditional] = STATE(1628),
    [sym_range] = STATE(1628),
    [sym_binary] = STATE(1628),
    [sym_unary] = STATE(1628),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [432] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1629),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(1629),
    [sym_operator_assignment] = STATE(1629),
    [sym_conditional] = STATE(1629),
    [sym_range] = STATE(1629),
    [sym_binary] = STATE(1629),
    [sym_unary] = STATE(1629),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [433] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [434] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym___END__] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(2733),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [435] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(2735),
  },
  [436] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(1633),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1634),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(2737),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [437] = {
    [sym_lambda_parameters] = STATE(1636),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(1637),
    [sym_block] = STATE(1637),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(1693),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [438] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym___END__] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [439] = {
    [sym__line_break2] = ACTIONS(737),
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [ts_builtin_sym_end] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(1677),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(1679),
    [anon_sym_COLON_COLON2] = ACTIONS(1681),
    [anon_sym_AMP_DOT] = ACTIONS(1683),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [sym_comment] = ACTIONS(87),
  },
  [440] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(976),
    [sym__argument] = STATE(977),
    [sym_splat_argument] = STATE(977),
    [sym_hash_splat_argument] = STATE(977),
    [sym_block_argument] = STATE(977),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(977),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym___END__] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [441] = {
    [sym_do_block] = STATE(1654),
    [sym_block] = STATE(1654),
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2779),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [442] = {
    [sym_heredoc_body] = STATE(1656),
    [aux_sym_call_repeat1] = STATE(1656),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [443] = {
    [sym_heredoc_body] = STATE(1656),
    [aux_sym_call_repeat1] = STATE(1656),
    [aux_sym_argument_list_repeat1] = STATE(1658),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [444] = {
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [445] = {
    [anon_sym_EQ] = ACTIONS(2785),
    [sym_comment] = ACTIONS(87),
  },
  [446] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2787),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2789),
    [anon_sym_DASH_EQ] = ACTIONS(2789),
    [anon_sym_STAR_EQ] = ACTIONS(2789),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2789),
    [anon_sym_SLASH_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_PIPE_EQ] = ACTIONS(2789),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2789),
    [anon_sym_AMP_EQ] = ACTIONS(2789),
    [anon_sym_PERCENT_EQ] = ACTIONS(2789),
    [anon_sym_GT_GT_EQ] = ACTIONS(2789),
    [anon_sym_LT_LT_EQ] = ACTIONS(2789),
    [anon_sym_CARET_EQ] = ACTIONS(2789),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [447] = {
    [sym_string] = STATE(1661),
    [aux_sym_chained_string_repeat1] = STATE(1661),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(2791),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [448] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1667),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_splat_argument] = STATE(1669),
    [sym_assignment] = STATE(1667),
    [sym_operator_assignment] = STATE(1667),
    [sym_conditional] = STATE(1667),
    [sym_range] = STATE(1667),
    [sym_binary] = STATE(1667),
    [sym_unary] = STATE(1667),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(1669),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2793),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [449] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(190),
    [sym_call] = STATE(190),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(1672),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(190),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_EQ] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(331),
    [sym_identifier] = ACTIONS(331),
    [sym_instance_variable] = ACTIONS(333),
    [sym_class_variable] = ACTIONS(333),
    [sym_global_variable] = ACTIONS(333),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(331),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(331),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [450] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1673),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(1673),
    [sym_operator_assignment] = STATE(1673),
    [sym_conditional] = STATE(1673),
    [sym_range] = STATE(1673),
    [sym_binary] = STATE(1673),
    [sym_unary] = STATE(1673),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [451] = {
    [sym_string] = STATE(1674),
    [aux_sym_chained_string_repeat1] = STATE(1674),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [anon_sym___END__] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [452] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1675),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(1675),
    [sym_operator_assignment] = STATE(1675),
    [sym_conditional] = STATE(1675),
    [sym_range] = STATE(1675),
    [sym_binary] = STATE(1675),
    [sym_unary] = STATE(1675),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [453] = {
    [sym_constant] = ACTIONS(2811),
    [sym_identifier] = ACTIONS(2811),
    [sym_comment] = ACTIONS(87),
  },
  [454] = {
    [anon_sym_RBRACE] = ACTIONS(275),
    [anon_sym_if] = ACTIONS(275),
    [anon_sym_unless] = ACTIONS(275),
    [anon_sym_while] = ACTIONS(275),
    [anon_sym_until] = ACTIONS(275),
    [anon_sym_rescue] = ACTIONS(275),
    [sym_comment] = ACTIONS(87),
  },
  [455] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(1692),
    [sym__argument] = STATE(1693),
    [sym_splat_argument] = STATE(1693),
    [sym_hash_splat_argument] = STATE(1693),
    [sym_block_argument] = STATE(1693),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1693),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [456] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(1692),
    [sym__argument] = STATE(1693),
    [sym_splat_argument] = STATE(1693),
    [sym_hash_splat_argument] = STATE(1693),
    [sym_block_argument] = STATE(1693),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1693),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [457] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(1692),
    [sym__argument] = STATE(1693),
    [sym_splat_argument] = STATE(1693),
    [sym_hash_splat_argument] = STATE(1693),
    [sym_block_argument] = STATE(1693),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1693),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [458] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(1692),
    [sym__argument] = STATE(1693),
    [sym_splat_argument] = STATE(1693),
    [sym_hash_splat_argument] = STATE(1693),
    [sym_block_argument] = STATE(1693),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1693),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [459] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1697),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(1697),
    [sym_operator_assignment] = STATE(1697),
    [sym_conditional] = STATE(1697),
    [sym_range] = STATE(1697),
    [sym_binary] = STATE(1697),
    [sym_unary] = STATE(1697),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [460] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1698),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(1698),
    [sym_operator_assignment] = STATE(1698),
    [sym_conditional] = STATE(1698),
    [sym_range] = STATE(1698),
    [sym_binary] = STATE(1698),
    [sym_unary] = STATE(1698),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [461] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [462] = {
    [sym_operator] = STATE(1701),
    [sym__method_name] = STATE(1701),
    [sym_setter] = STATE(1701),
    [sym_symbol] = STATE(1701),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__symbol_start2] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_STAR_STAR] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_LT_LT] = ACTIONS(2843),
    [anon_sym_GT_GT] = ACTIONS(2843),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ_GT] = ACTIONS(2843),
    [anon_sym_EQ_TILDE] = ACTIONS(2843),
    [anon_sym_BANG_TILDE] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2843),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2843),
    [sym_constant] = ACTIONS(2847),
    [sym_identifier] = ACTIONS(2849),
    [sym_instance_variable] = ACTIONS(2847),
    [sym_class_variable] = ACTIONS(2847),
    [sym_global_variable] = ACTIONS(2847),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_AT] = ACTIONS(2843),
    [anon_sym_DASH_AT] = ACTIONS(2843),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2845),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2843),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(87),
  },
  [463] = {
    [sym_operator] = STATE(1702),
    [sym__method_name] = STATE(1702),
    [sym_setter] = STATE(1702),
    [sym_symbol] = STATE(1702),
    [sym__simple_symbol2] = ACTIONS(547),
    [sym__symbol_start2] = ACTIONS(549),
    [anon_sym_PIPE] = ACTIONS(551),
    [anon_sym_STAR] = ACTIONS(553),
    [anon_sym_STAR_STAR] = ACTIONS(551),
    [anon_sym_AMP] = ACTIONS(551),
    [anon_sym_LT] = ACTIONS(553),
    [anon_sym_DOT_DOT] = ACTIONS(551),
    [anon_sym_LT_LT] = ACTIONS(551),
    [anon_sym_GT_GT] = ACTIONS(551),
    [anon_sym_EQ_EQ] = ACTIONS(553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(551),
    [anon_sym_LT_EQ_GT] = ACTIONS(551),
    [anon_sym_EQ_TILDE] = ACTIONS(551),
    [anon_sym_BANG_TILDE] = ACTIONS(551),
    [anon_sym_LT_EQ] = ACTIONS(553),
    [anon_sym_GT] = ACTIONS(553),
    [anon_sym_GT_EQ] = ACTIONS(551),
    [anon_sym_CARET] = ACTIONS(551),
    [anon_sym_PLUS] = ACTIONS(553),
    [anon_sym_SLASH] = ACTIONS(551),
    [anon_sym_PERCENT] = ACTIONS(551),
    [anon_sym_BANG] = ACTIONS(553),
    [anon_sym_TILDE] = ACTIONS(551),
    [sym_constant] = ACTIONS(2851),
    [sym_identifier] = ACTIONS(557),
    [sym_instance_variable] = ACTIONS(2851),
    [sym_class_variable] = ACTIONS(2851),
    [sym_global_variable] = ACTIONS(2851),
    [anon_sym_DASH] = ACTIONS(553),
    [anon_sym_PLUS_AT] = ACTIONS(551),
    [anon_sym_DASH_AT] = ACTIONS(551),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(553),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(551),
    [anon_sym_BQUOTE] = ACTIONS(551),
    [sym_comment] = ACTIONS(87),
  },
  [464] = {
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [465] = {
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [466] = {
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [467] = {
    [anon_sym_RBRACE] = ACTIONS(2853),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_until] = ACTIONS(2861),
    [anon_sym_rescue] = ACTIONS(2863),
    [sym_comment] = ACTIONS(87),
  },
  [468] = {
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [sym_comment] = ACTIONS(87),
  },
  [469] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [470] = {
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(2897),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(2899),
    [anon_sym_COLON_COLON2] = ACTIONS(2901),
    [anon_sym_AMP_DOT] = ACTIONS(2903),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [471] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(1742),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_do_block] = STATE(1745),
    [sym_block] = STATE(1745),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [472] = {
    [anon_sym_EQ] = ACTIONS(2941),
    [sym_comment] = ACTIONS(87),
  },
  [473] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(2943),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(2945),
    [anon_sym_DASH_EQ] = ACTIONS(2945),
    [anon_sym_STAR_EQ] = ACTIONS(2945),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2945),
    [anon_sym_SLASH_EQ] = ACTIONS(2945),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2945),
    [anon_sym_PIPE_EQ] = ACTIONS(2945),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2945),
    [anon_sym_AMP_EQ] = ACTIONS(2945),
    [anon_sym_PERCENT_EQ] = ACTIONS(2945),
    [anon_sym_GT_GT_EQ] = ACTIONS(2945),
    [anon_sym_LT_LT_EQ] = ACTIONS(2945),
    [anon_sym_CARET_EQ] = ACTIONS(2945),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [474] = {
    [sym_string] = STATE(1751),
    [aux_sym_chained_string_repeat1] = STATE(1751),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [475] = {
    [sym__line_break2] = ACTIONS(2947),
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym___END__] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_end] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_when] = ACTIONS(2947),
    [anon_sym_elsif] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_then] = ACTIONS(2947),
    [anon_sym_ensure] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [476] = {
    [sym_interpolation] = STATE(476),
    [aux_sym__literal_contents_repeat1] = STATE(476),
    [sym__string_content2] = ACTIONS(2951),
    [sym__string_end2] = ACTIONS(2954),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(2956),
    [sym_escape_sequence] = ACTIONS(2951),
  },
  [477] = {
    [sym__line_break2] = ACTIONS(2959),
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [anon_sym___END__] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_end] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_when] = ACTIONS(2959),
    [anon_sym_elsif] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_then] = ACTIONS(2959),
    [anon_sym_ensure] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [478] = {
    [sym__line_break2] = ACTIONS(2963),
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [ts_builtin_sym_end] = ACTIONS(2963),
    [anon_sym___END__] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_end] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_elsif] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_then] = ACTIONS(2963),
    [anon_sym_ensure] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [sym_comment] = ACTIONS(87),
  },
  [479] = {
    [sym__line_break2] = ACTIONS(2967),
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [ts_builtin_sym_end] = ACTIONS(2967),
    [anon_sym___END__] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_end] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_elsif] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_then] = ACTIONS(2967),
    [anon_sym_ensure] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [sym_comment] = ACTIONS(87),
  },
  [480] = {
    [anon_sym_RBRACE] = ACTIONS(2971),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_until] = ACTIONS(2861),
    [anon_sym_rescue] = ACTIONS(2863),
    [sym_comment] = ACTIONS(87),
  },
  [481] = {
    [sym__line_break2] = ACTIONS(2973),
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [ts_builtin_sym_end] = ACTIONS(2973),
    [anon_sym___END__] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_end] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_when] = ACTIONS(2973),
    [anon_sym_elsif] = ACTIONS(2973),
    [anon_sym_else] = ACTIONS(2973),
    [anon_sym_then] = ACTIONS(2973),
    [anon_sym_ensure] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [sym_comment] = ACTIONS(87),
  },
  [482] = {
    [sym__string_end2] = ACTIONS(2977),
    [sym_comment] = ACTIONS(87),
  },
  [483] = {
    [aux_sym_string_array_repeat1] = STATE(1756),
    [sym__string_end2] = ACTIONS(2979),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2981),
  },
  [484] = {
    [sym__line_break2] = ACTIONS(2983),
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [anon_sym___END__] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_when] = ACTIONS(2983),
    [anon_sym_elsif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_then] = ACTIONS(2983),
    [anon_sym_ensure] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [sym_comment] = ACTIONS(87),
  },
  [485] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(2987),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [486] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(2987),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2989),
  },
  [487] = {
    [sym_interpolation] = STATE(487),
    [aux_sym__literal_contents_repeat1] = STATE(487),
    [sym__string_content2] = ACTIONS(2991),
    [sym__string_end2] = ACTIONS(2954),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(2994),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(2997),
    [sym_escape_sequence] = ACTIONS(2999),
  },
  [488] = {
    [sym__line_break2] = ACTIONS(3002),
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [ts_builtin_sym_end] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_when] = ACTIONS(3002),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_then] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [489] = {
    [sym__string_end2] = ACTIONS(3006),
    [sym_comment] = ACTIONS(87),
  },
  [490] = {
    [aux_sym_symbol_array_repeat1] = STATE(1764),
    [sym__string_end2] = ACTIONS(3008),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3010),
  },
  [491] = {
    [sym__line_break2] = ACTIONS(3012),
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3012),
    [anon_sym___END__] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_end] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_when] = ACTIONS(3012),
    [anon_sym_elsif] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_then] = ACTIONS(3012),
    [anon_sym_ensure] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [492] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3016),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [493] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(3016),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3018),
  },
  [494] = {
    [ts_builtin_sym_end] = ACTIONS(3020),
    [sym_comment] = ACTIONS(87),
  },
  [495] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1769),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(1769),
    [sym_operator_assignment] = STATE(1769),
    [sym_conditional] = STATE(1769),
    [sym_range] = STATE(1769),
    [sym_binary] = STATE(1769),
    [sym_unary] = STATE(1769),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [496] = {
    [sym__line_break2] = ACTIONS(3022),
    [sym__heredoc_body_start2] = ACTIONS(3022),
    [ts_builtin_sym_end] = ACTIONS(3022),
    [anon_sym___END__] = ACTIONS(3022),
    [anon_sym_RBRACE] = ACTIONS(3022),
    [anon_sym_RPAREN] = ACTIONS(3022),
    [anon_sym_SEMI] = ACTIONS(3022),
    [anon_sym_end] = ACTIONS(3022),
    [anon_sym_rescue] = ACTIONS(3022),
    [anon_sym_when] = ACTIONS(3022),
    [anon_sym_elsif] = ACTIONS(3022),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_ensure] = ACTIONS(3022),
    [sym_comment] = ACTIONS(87),
  },
  [497] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(1784),
    [sym__argument] = STATE(1785),
    [sym_splat_argument] = STATE(1785),
    [sym_hash_splat_argument] = STATE(1785),
    [sym_block_argument] = STATE(1785),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1785),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [498] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(1784),
    [sym__argument] = STATE(1785),
    [sym_splat_argument] = STATE(1785),
    [sym_hash_splat_argument] = STATE(1785),
    [sym_block_argument] = STATE(1785),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1785),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [499] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(1784),
    [sym__argument] = STATE(1785),
    [sym_splat_argument] = STATE(1785),
    [sym_hash_splat_argument] = STATE(1785),
    [sym_block_argument] = STATE(1785),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1785),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [500] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(1784),
    [sym__argument] = STATE(1785),
    [sym_splat_argument] = STATE(1785),
    [sym_hash_splat_argument] = STATE(1785),
    [sym_block_argument] = STATE(1785),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(1785),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [501] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1789),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(1789),
    [sym_operator_assignment] = STATE(1789),
    [sym_conditional] = STATE(1789),
    [sym_range] = STATE(1789),
    [sym_binary] = STATE(1789),
    [sym_unary] = STATE(1789),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [502] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1790),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(1790),
    [sym_operator_assignment] = STATE(1790),
    [sym_conditional] = STATE(1790),
    [sym_range] = STATE(1790),
    [sym_binary] = STATE(1790),
    [sym_unary] = STATE(1790),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [503] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [504] = {
    [sym_operator] = STATE(1791),
    [sym__method_name] = STATE(1791),
    [sym_setter] = STATE(1791),
    [sym_symbol] = STATE(1791),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3050),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3050),
    [sym_class_variable] = ACTIONS(3050),
    [sym_global_variable] = ACTIONS(3050),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [505] = {
    [anon_sym_RBRACE] = ACTIONS(3052),
    [sym_comment] = ACTIONS(87),
  },
  [506] = {
    [sym_heredoc_body] = STATE(1793),
    [sym__terminator] = STATE(1793),
    [aux_sym__statements_repeat1] = STATE(1794),
    [sym__line_break2] = ACTIONS(3054),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(689),
    [anon_sym_SEMI] = ACTIONS(3054),
    [sym_comment] = ACTIONS(87),
  },
  [507] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_RBRACE] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(3056),
    [anon_sym_unless] = ACTIONS(3058),
    [anon_sym_while] = ACTIONS(3060),
    [anon_sym_until] = ACTIONS(3062),
    [anon_sym_rescue] = ACTIONS(3064),
    [sym_comment] = ACTIONS(87),
  },
  [508] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [509] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [510] = {
    [anon_sym_EQ] = ACTIONS(3128),
    [sym_comment] = ACTIONS(87),
  },
  [511] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3130),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3132),
    [anon_sym_DASH_EQ] = ACTIONS(3132),
    [anon_sym_STAR_EQ] = ACTIONS(3132),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3132),
    [anon_sym_SLASH_EQ] = ACTIONS(3132),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3132),
    [anon_sym_PIPE_EQ] = ACTIONS(3132),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3132),
    [anon_sym_AMP_EQ] = ACTIONS(3132),
    [anon_sym_PERCENT_EQ] = ACTIONS(3132),
    [anon_sym_GT_GT_EQ] = ACTIONS(3132),
    [anon_sym_LT_LT_EQ] = ACTIONS(3132),
    [anon_sym_CARET_EQ] = ACTIONS(3132),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [512] = {
    [sym_string] = STATE(1834),
    [aux_sym_chained_string_repeat1] = STATE(1834),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [513] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [514] = {
    [sym__string_end2] = ACTIONS(3134),
    [sym_comment] = ACTIONS(87),
  },
  [515] = {
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_COLON2] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [516] = {
    [sym__string_end2] = ACTIONS(3136),
    [sym_comment] = ACTIONS(87),
  },
  [517] = {
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_COLON2] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [518] = {
    [sym__string_end2] = ACTIONS(3138),
    [sym_comment] = ACTIONS(87),
  },
  [519] = {
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_COLON2] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [520] = {
    [sym__string_end2] = ACTIONS(3140),
    [sym_comment] = ACTIONS(87),
  },
  [521] = {
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [sym_comment] = ACTIONS(87),
  },
  [522] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1841),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3142),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3144),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [523] = {
    [aux_sym_string_array_repeat1] = STATE(1844),
    [sym__string_end2] = ACTIONS(3146),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3148),
  },
  [524] = {
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_COLON2] = ACTIONS(929),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [sym_comment] = ACTIONS(87),
  },
  [525] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1847),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3150),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3152),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [526] = {
    [aux_sym_symbol_array_repeat1] = STATE(1850),
    [sym__string_end2] = ACTIONS(3154),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3156),
  },
  [527] = {
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_when] = ACTIONS(3158),
    [anon_sym_RBRACK] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [528] = {
    [sym__statement] = STATE(1851),
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_if_modifier] = STATE(468),
    [sym_unless_modifier] = STATE(468),
    [sym_while_modifier] = STATE(468),
    [sym_until_modifier] = STATE(468),
    [sym_rescue_modifier] = STATE(468),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(469),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(469),
    [sym_operator_assignment] = STATE(469),
    [sym_conditional] = STATE(469),
    [sym_range] = STATE(469),
    [sym_binary] = STATE(469),
    [sym_unary] = STATE(469),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_undef] = STATE(468),
    [sym_alias] = STATE(468),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym_empty_statement] = STATE(468),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_SEMI] = ACTIONS(851),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [anon_sym_undef] = ACTIONS(875),
    [anon_sym_alias] = ACTIONS(877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [529] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(3162),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [530] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [531] = {
    [sym_string] = STATE(680),
    [aux_sym_chained_string_repeat1] = STATE(680),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [532] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1854),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1854),
    [sym_operator_assignment] = STATE(1854),
    [sym_conditional] = STATE(1854),
    [sym_range] = STATE(1854),
    [sym_binary] = STATE(1854),
    [sym_unary] = STATE(1854),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [533] = {
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_COLON2] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [534] = {
    [anon_sym_RBRACE] = ACTIONS(3164),
    [sym_comment] = ACTIONS(87),
  },
  [535] = {
    [sym_heredoc_body] = STATE(1856),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3164),
    [sym_comment] = ACTIONS(87),
  },
  [536] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1857),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(1857),
    [sym_operator_assignment] = STATE(1857),
    [sym_conditional] = STATE(1857),
    [sym_range] = STATE(1857),
    [sym_binary] = STATE(1857),
    [sym_unary] = STATE(1857),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [537] = {
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_COLON2] = ACTIONS(1285),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [sym_comment] = ACTIONS(87),
  },
  [538] = {
    [anon_sym_DOT] = ACTIONS(3166),
    [anon_sym_COLON_COLON] = ACTIONS(3166),
    [sym_comment] = ACTIONS(87),
  },
  [539] = {
    [sym_method_parameters] = STATE(1859),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(1859),
    [sym__terminator] = STATE(1859),
    [sym__line_break2] = ACTIONS(3168),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(3168),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [540] = {
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_COLON2] = ACTIONS(1303),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(1301),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [sym_comment] = ACTIONS(87),
  },
  [541] = {
    [anon_sym_RPAREN] = ACTIONS(3170),
    [sym_comment] = ACTIONS(87),
  },
  [542] = {
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_EQ_GT] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [543] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1861),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1861),
    [sym_operator_assignment] = STATE(1861),
    [sym_conditional] = STATE(1861),
    [sym_range] = STATE(1861),
    [sym_binary] = STATE(1861),
    [sym_unary] = STATE(1861),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [544] = {
    [sym_constant] = ACTIONS(3172),
    [sym_identifier] = ACTIONS(3172),
    [sym_comment] = ACTIONS(87),
  },
  [545] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1878),
    [sym__argument] = STATE(1879),
    [sym_splat_argument] = STATE(1879),
    [sym_hash_splat_argument] = STATE(1879),
    [sym_block_argument] = STATE(1879),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1879),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [546] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(1878),
    [sym__argument] = STATE(1879),
    [sym_splat_argument] = STATE(1879),
    [sym_hash_splat_argument] = STATE(1879),
    [sym_block_argument] = STATE(1879),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1879),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [547] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(1878),
    [sym__argument] = STATE(1879),
    [sym_splat_argument] = STATE(1879),
    [sym_hash_splat_argument] = STATE(1879),
    [sym_block_argument] = STATE(1879),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1879),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [548] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(1878),
    [sym__argument] = STATE(1879),
    [sym_splat_argument] = STATE(1879),
    [sym_hash_splat_argument] = STATE(1879),
    [sym_block_argument] = STATE(1879),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1879),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [549] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1883),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1883),
    [sym_operator_assignment] = STATE(1883),
    [sym_conditional] = STATE(1883),
    [sym_range] = STATE(1883),
    [sym_binary] = STATE(1883),
    [sym_unary] = STATE(1883),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [550] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1884),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1884),
    [sym_operator_assignment] = STATE(1884),
    [sym_conditional] = STATE(1884),
    [sym_range] = STATE(1884),
    [sym_binary] = STATE(1884),
    [sym_unary] = STATE(1884),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [551] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1398),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1398),
    [sym_operator_assignment] = STATE(1398),
    [sym_conditional] = STATE(1398),
    [sym_range] = STATE(1398),
    [sym_binary] = STATE(1398),
    [sym_unary] = STATE(1398),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [552] = {
    [sym__heredoc_body_start2] = ACTIONS(565),
    [sym__binary_minus2] = ACTIONS(565),
    [sym__binary_star2] = ACTIONS(565),
    [anon_sym_LBRACE] = ACTIONS(565),
    [anon_sym_RBRACE] = ACTIONS(565),
    [anon_sym_RPAREN] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(567),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_PIPE] = ACTIONS(567),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_STAR_STAR] = ACTIONS(567),
    [anon_sym_AMP] = ACTIONS(567),
    [anon_sym_EQ] = ACTIONS(567),
    [anon_sym_LT] = ACTIONS(567),
    [anon_sym_if] = ACTIONS(565),
    [anon_sym_unless] = ACTIONS(565),
    [anon_sym_while] = ACTIONS(565),
    [anon_sym_until] = ACTIONS(565),
    [anon_sym_rescue] = ACTIONS(565),
    [anon_sym_in] = ACTIONS(565),
    [anon_sym_do] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_RBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [anon_sym_PLUS_EQ] = ACTIONS(565),
    [anon_sym_DASH_EQ] = ACTIONS(565),
    [anon_sym_STAR_EQ] = ACTIONS(565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(565),
    [anon_sym_SLASH_EQ] = ACTIONS(565),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(565),
    [anon_sym_PIPE_EQ] = ACTIONS(565),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(565),
    [anon_sym_AMP_EQ] = ACTIONS(565),
    [anon_sym_PERCENT_EQ] = ACTIONS(565),
    [anon_sym_GT_GT_EQ] = ACTIONS(565),
    [anon_sym_LT_LT_EQ] = ACTIONS(565),
    [anon_sym_CARET_EQ] = ACTIONS(565),
    [anon_sym_QMARK] = ACTIONS(565),
    [anon_sym_COLON2] = ACTIONS(567),
    [anon_sym_DOT_DOT] = ACTIONS(567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(565),
    [anon_sym_and] = ACTIONS(565),
    [anon_sym_or] = ACTIONS(565),
    [anon_sym_PIPE_PIPE] = ACTIONS(567),
    [anon_sym_AMP_AMP] = ACTIONS(567),
    [anon_sym_LT_LT] = ACTIONS(567),
    [anon_sym_GT_GT] = ACTIONS(567),
    [anon_sym_EQ_EQ] = ACTIONS(567),
    [anon_sym_BANG_EQ] = ACTIONS(565),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(565),
    [anon_sym_LT_EQ_GT] = ACTIONS(565),
    [anon_sym_EQ_TILDE] = ACTIONS(565),
    [anon_sym_BANG_TILDE] = ACTIONS(565),
    [anon_sym_LT_EQ] = ACTIONS(567),
    [anon_sym_GT] = ACTIONS(567),
    [anon_sym_GT_EQ] = ACTIONS(565),
    [anon_sym_CARET] = ACTIONS(567),
    [anon_sym_PLUS] = ACTIONS(567),
    [anon_sym_SLASH] = ACTIONS(567),
    [anon_sym_PERCENT] = ACTIONS(567),
    [sym_comment] = ACTIONS(87),
  },
  [553] = {
    [sym__heredoc_body_start2] = ACTIONS(569),
    [sym__binary_minus2] = ACTIONS(569),
    [sym__binary_star2] = ACTIONS(569),
    [anon_sym_LBRACE] = ACTIONS(569),
    [anon_sym_RBRACE] = ACTIONS(569),
    [anon_sym_RPAREN] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(571),
    [anon_sym_COMMA] = ACTIONS(569),
    [anon_sym_PIPE] = ACTIONS(571),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_STAR_STAR] = ACTIONS(571),
    [anon_sym_AMP] = ACTIONS(571),
    [anon_sym_EQ] = ACTIONS(571),
    [anon_sym_LT] = ACTIONS(571),
    [anon_sym_if] = ACTIONS(569),
    [anon_sym_unless] = ACTIONS(569),
    [anon_sym_while] = ACTIONS(569),
    [anon_sym_until] = ACTIONS(569),
    [anon_sym_rescue] = ACTIONS(569),
    [anon_sym_in] = ACTIONS(569),
    [anon_sym_do] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_RBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [anon_sym_PLUS_EQ] = ACTIONS(569),
    [anon_sym_DASH_EQ] = ACTIONS(569),
    [anon_sym_STAR_EQ] = ACTIONS(569),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(569),
    [anon_sym_SLASH_EQ] = ACTIONS(569),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(569),
    [anon_sym_PIPE_EQ] = ACTIONS(569),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(569),
    [anon_sym_AMP_EQ] = ACTIONS(569),
    [anon_sym_PERCENT_EQ] = ACTIONS(569),
    [anon_sym_GT_GT_EQ] = ACTIONS(569),
    [anon_sym_LT_LT_EQ] = ACTIONS(569),
    [anon_sym_CARET_EQ] = ACTIONS(569),
    [anon_sym_QMARK] = ACTIONS(569),
    [anon_sym_COLON2] = ACTIONS(571),
    [anon_sym_DOT_DOT] = ACTIONS(571),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(569),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(569),
    [anon_sym_PIPE_PIPE] = ACTIONS(571),
    [anon_sym_AMP_AMP] = ACTIONS(571),
    [anon_sym_LT_LT] = ACTIONS(571),
    [anon_sym_GT_GT] = ACTIONS(571),
    [anon_sym_EQ_EQ] = ACTIONS(571),
    [anon_sym_BANG_EQ] = ACTIONS(569),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(569),
    [anon_sym_LT_EQ_GT] = ACTIONS(569),
    [anon_sym_EQ_TILDE] = ACTIONS(569),
    [anon_sym_BANG_TILDE] = ACTIONS(569),
    [anon_sym_LT_EQ] = ACTIONS(571),
    [anon_sym_GT] = ACTIONS(571),
    [anon_sym_GT_EQ] = ACTIONS(569),
    [anon_sym_CARET] = ACTIONS(571),
    [anon_sym_PLUS] = ACTIONS(571),
    [anon_sym_SLASH] = ACTIONS(571),
    [anon_sym_PERCENT] = ACTIONS(571),
    [sym_comment] = ACTIONS(87),
  },
  [554] = {
    [sym__heredoc_body_start2] = ACTIONS(573),
    [sym__binary_minus2] = ACTIONS(573),
    [sym__binary_star2] = ACTIONS(573),
    [anon_sym_LBRACE] = ACTIONS(573),
    [anon_sym_RBRACE] = ACTIONS(573),
    [anon_sym_RPAREN] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(575),
    [anon_sym_COMMA] = ACTIONS(573),
    [anon_sym_PIPE] = ACTIONS(575),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_STAR_STAR] = ACTIONS(575),
    [anon_sym_AMP] = ACTIONS(575),
    [anon_sym_EQ] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(573),
    [anon_sym_unless] = ACTIONS(573),
    [anon_sym_while] = ACTIONS(573),
    [anon_sym_until] = ACTIONS(573),
    [anon_sym_rescue] = ACTIONS(573),
    [anon_sym_in] = ACTIONS(573),
    [anon_sym_do] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_RBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [anon_sym_PLUS_EQ] = ACTIONS(573),
    [anon_sym_DASH_EQ] = ACTIONS(573),
    [anon_sym_STAR_EQ] = ACTIONS(573),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(573),
    [anon_sym_SLASH_EQ] = ACTIONS(573),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(573),
    [anon_sym_PIPE_EQ] = ACTIONS(573),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(573),
    [anon_sym_AMP_EQ] = ACTIONS(573),
    [anon_sym_PERCENT_EQ] = ACTIONS(573),
    [anon_sym_GT_GT_EQ] = ACTIONS(573),
    [anon_sym_LT_LT_EQ] = ACTIONS(573),
    [anon_sym_CARET_EQ] = ACTIONS(573),
    [anon_sym_QMARK] = ACTIONS(573),
    [anon_sym_COLON2] = ACTIONS(575),
    [anon_sym_DOT_DOT] = ACTIONS(575),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(573),
    [anon_sym_and] = ACTIONS(573),
    [anon_sym_or] = ACTIONS(573),
    [anon_sym_PIPE_PIPE] = ACTIONS(575),
    [anon_sym_AMP_AMP] = ACTIONS(575),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_EQ_EQ] = ACTIONS(575),
    [anon_sym_BANG_EQ] = ACTIONS(573),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(573),
    [anon_sym_LT_EQ_GT] = ACTIONS(573),
    [anon_sym_EQ_TILDE] = ACTIONS(573),
    [anon_sym_BANG_TILDE] = ACTIONS(573),
    [anon_sym_LT_EQ] = ACTIONS(575),
    [anon_sym_GT] = ACTIONS(575),
    [anon_sym_GT_EQ] = ACTIONS(573),
    [anon_sym_CARET] = ACTIONS(575),
    [anon_sym_PLUS] = ACTIONS(575),
    [anon_sym_SLASH] = ACTIONS(575),
    [anon_sym_PERCENT] = ACTIONS(575),
    [sym_comment] = ACTIONS(87),
  },
  [555] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(3224),
    [anon_sym_or] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [556] = {
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(737),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(3242),
    [anon_sym_AMP_DOT] = ACTIONS(3244),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(737),
    [anon_sym_AMP_AMP] = ACTIONS(737),
    [anon_sym_LT_LT] = ACTIONS(737),
    [anon_sym_GT_GT] = ACTIONS(737),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(737),
    [anon_sym_PLUS] = ACTIONS(737),
    [anon_sym_SLASH] = ACTIONS(737),
    [anon_sym_PERCENT] = ACTIONS(737),
    [sym_comment] = ACTIONS(87),
  },
  [557] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [558] = {
    [anon_sym_EQ] = ACTIONS(3280),
    [sym_comment] = ACTIONS(87),
  },
  [559] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3284),
    [anon_sym_DASH_EQ] = ACTIONS(3284),
    [anon_sym_STAR_EQ] = ACTIONS(3284),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3284),
    [anon_sym_SLASH_EQ] = ACTIONS(3284),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3284),
    [anon_sym_PIPE_EQ] = ACTIONS(3284),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3284),
    [anon_sym_AMP_EQ] = ACTIONS(3284),
    [anon_sym_PERCENT_EQ] = ACTIONS(3284),
    [anon_sym_GT_GT_EQ] = ACTIONS(3284),
    [anon_sym_LT_LT_EQ] = ACTIONS(3284),
    [anon_sym_CARET_EQ] = ACTIONS(3284),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [560] = {
    [sym_string] = STATE(1926),
    [aux_sym_chained_string_repeat1] = STATE(1926),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [561] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1927),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(1927),
    [sym_operator_assignment] = STATE(1927),
    [sym_conditional] = STATE(1927),
    [sym_range] = STATE(1927),
    [sym_binary] = STATE(1927),
    [sym_unary] = STATE(1927),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [562] = {
    [sym_superclass] = STATE(1928),
    [sym_heredoc_body] = STATE(1929),
    [sym__terminator] = STATE(1929),
    [sym__line_break2] = ACTIONS(3286),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [563] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(1928),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1929),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(1929),
    [sym__line_break2] = ACTIONS(3286),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(3286),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [564] = {
    [sym_heredoc_body] = STATE(1931),
    [sym__terminator] = STATE(1931),
    [sym__line_break2] = ACTIONS(3288),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [565] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1931),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(1931),
    [sym__line_break2] = ACTIONS(3288),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(3288),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3290),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [566] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1932),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1932),
    [sym_operator_assignment] = STATE(1932),
    [sym_conditional] = STATE(1932),
    [sym_range] = STATE(1932),
    [sym_binary] = STATE(1932),
    [sym_unary] = STATE(1932),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [567] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1934),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1934),
    [sym_operator_assignment] = STATE(1934),
    [sym_conditional] = STATE(1934),
    [sym_range] = STATE(1934),
    [sym_binary] = STATE(1934),
    [sym_unary] = STATE(1934),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [568] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1935),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1935),
    [sym_operator_assignment] = STATE(1935),
    [sym_conditional] = STATE(1935),
    [sym_range] = STATE(1935),
    [sym_binary] = STATE(1935),
    [sym_unary] = STATE(1935),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [569] = {
    [anon_sym_COLON] = ACTIONS(3292),
    [sym_comment] = ACTIONS(87),
  },
  [570] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1937),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1937),
    [sym_operator_assignment] = STATE(1937),
    [sym_conditional] = STATE(1937),
    [sym_range] = STATE(1937),
    [sym_binary] = STATE(1937),
    [sym_unary] = STATE(1937),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [571] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [572] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [573] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [574] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [575] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(1941),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(1942),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3294),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [576] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1943),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1943),
    [sym_operator_assignment] = STATE(1943),
    [sym_conditional] = STATE(1943),
    [sym_range] = STATE(1943),
    [sym_binary] = STATE(1943),
    [sym_unary] = STATE(1943),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [577] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1944),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1944),
    [sym_operator_assignment] = STATE(1944),
    [sym_conditional] = STATE(1944),
    [sym_range] = STATE(1944),
    [sym_binary] = STATE(1944),
    [sym_unary] = STATE(1944),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [578] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [579] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(3296),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [580] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [581] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [582] = {
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [583] = {
    [sym_heredoc_body] = STATE(1960),
    [aux_sym_call_repeat1] = STATE(1960),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [584] = {
    [sym_heredoc_body] = STATE(1960),
    [aux_sym_call_repeat1] = STATE(1960),
    [aux_sym_argument_list_repeat1] = STATE(1962),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [585] = {
    [anon_sym_EQ] = ACTIONS(3332),
    [sym_comment] = ACTIONS(87),
  },
  [586] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [587] = {
    [sym_string] = STATE(1965),
    [aux_sym_chained_string_repeat1] = STATE(1965),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [588] = {
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_COLON2] = ACTIONS(1721),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1719),
    [sym_comment] = ACTIONS(87),
  },
  [589] = {
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_EQ_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_COLON2] = ACTIONS(1725),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1723),
    [anon_sym_AMP_AMP] = ACTIONS(1723),
    [anon_sym_LT_LT] = ACTIONS(1723),
    [anon_sym_GT_GT] = ACTIONS(1723),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1723),
    [anon_sym_PLUS] = ACTIONS(1723),
    [anon_sym_SLASH] = ACTIONS(1723),
    [anon_sym_PERCENT] = ACTIONS(1723),
    [sym_comment] = ACTIONS(87),
  },
  [590] = {
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_COLON2] = ACTIONS(1729),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1727),
    [anon_sym_GT_GT] = ACTIONS(1727),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_PERCENT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(87),
  },
  [591] = {
    [sym__then] = STATE(1966),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(3340),
    [sym_comment] = ACTIONS(87),
  },
  [592] = {
    [sym__then] = STATE(1967),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(3342),
    [sym_comment] = ACTIONS(87),
  },
  [593] = {
    [sym__do] = STATE(1968),
    [sym_heredoc_body] = STATE(1968),
    [sym__terminator] = STATE(1968),
    [sym__line_break2] = ACTIONS(3344),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(3344),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(3344),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [594] = {
    [sym__do] = STATE(1969),
    [sym_heredoc_body] = STATE(1969),
    [sym__terminator] = STATE(1969),
    [sym__line_break2] = ACTIONS(3346),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [595] = {
    [sym_in] = STATE(1970),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [596] = {
    [sym_heredoc_body] = STATE(1971),
    [sym__terminator] = STATE(1971),
    [sym__line_break2] = ACTIONS(3348),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(3348),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [597] = {
    [sym_when] = STATE(1972),
    [aux_sym_case_repeat1] = STATE(1973),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [598] = {
    [sym_else] = STATE(1975),
    [sym_ensure] = STATE(1976),
    [sym_rescue] = STATE(1977),
    [anon_sym_end] = ACTIONS(3352),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [599] = {
    [sym_ensure] = STATE(1976),
    [anon_sym_end] = ACTIONS(3352),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [600] = {
    [anon_sym_end] = ACTIONS(3352),
    [sym_comment] = ACTIONS(87),
  },
  [601] = {
    [sym_else] = STATE(1975),
    [sym_ensure] = STATE(1976),
    [anon_sym_end] = ACTIONS(3352),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [602] = {
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_EQ_GT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_COLON2] = ACTIONS(2221),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [anon_sym_PERCENT] = ACTIONS(2219),
    [sym_comment] = ACTIONS(87),
  },
  [603] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(1978),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3354),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [604] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [605] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [606] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [607] = {
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_COLON2] = ACTIONS(2309),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
  },
  [608] = {
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_EQ_GT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_COLON2] = ACTIONS(2393),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2391),
    [anon_sym_AMP_AMP] = ACTIONS(2391),
    [anon_sym_LT_LT] = ACTIONS(2391),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_SLASH] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(87),
  },
  [609] = {
    [sym_heredoc_body] = STATE(1980),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(3356),
    [sym_comment] = ACTIONS(87),
  },
  [610] = {
    [anon_sym_RBRACK] = ACTIONS(3356),
    [sym_comment] = ACTIONS(87),
  },
  [611] = {
    [sym__statements] = STATE(1982),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1983),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [612] = {
    [sym__statements] = STATE(1985),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1986),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(1987),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(1987),
    [sym__line_break2] = ACTIONS(3360),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3362),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [613] = {
    [sym_do_block] = STATE(1988),
    [sym_block] = STATE(1988),
    [anon_sym_LBRACE] = ACTIONS(1103),
    [anon_sym_do] = ACTIONS(3364),
    [sym_comment] = ACTIONS(87),
  },
  [614] = {
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_COLON2] = ACTIONS(2539),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [615] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1989),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1989),
    [sym_operator_assignment] = STATE(1989),
    [sym_conditional] = STATE(1989),
    [sym_range] = STATE(1989),
    [sym_binary] = STATE(1989),
    [sym_unary] = STATE(1989),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [616] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1990),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1990),
    [sym_operator_assignment] = STATE(1990),
    [sym_conditional] = STATE(1990),
    [sym_range] = STATE(1990),
    [sym_binary] = STATE(1990),
    [sym_unary] = STATE(1990),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [617] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1991),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1991),
    [sym_operator_assignment] = STATE(1991),
    [sym_conditional] = STATE(1991),
    [sym_range] = STATE(1991),
    [sym_binary] = STATE(1991),
    [sym_unary] = STATE(1991),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [618] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1992),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1992),
    [sym_operator_assignment] = STATE(1992),
    [sym_conditional] = STATE(1992),
    [sym_range] = STATE(1992),
    [sym_binary] = STATE(1992),
    [sym_unary] = STATE(1992),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [619] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1993),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1993),
    [sym_operator_assignment] = STATE(1993),
    [sym_conditional] = STATE(1993),
    [sym_range] = STATE(1993),
    [sym_binary] = STATE(1993),
    [sym_unary] = STATE(1993),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [620] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1994),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1994),
    [sym_operator_assignment] = STATE(1994),
    [sym_conditional] = STATE(1994),
    [sym_range] = STATE(1994),
    [sym_binary] = STATE(1994),
    [sym_unary] = STATE(1994),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [621] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1995),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(1995),
    [sym_operator_assignment] = STATE(1995),
    [sym_conditional] = STATE(1995),
    [sym_range] = STATE(1995),
    [sym_binary] = STATE(1995),
    [sym_unary] = STATE(1995),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [622] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(1996),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(1996),
    [sym_operator_assignment] = STATE(1996),
    [sym_conditional] = STATE(1996),
    [sym_range] = STATE(1996),
    [sym_binary] = STATE(1996),
    [sym_unary] = STATE(1996),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [623] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1997),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1997),
    [sym_operator_assignment] = STATE(1997),
    [sym_conditional] = STATE(1997),
    [sym_range] = STATE(1997),
    [sym_binary] = STATE(1997),
    [sym_unary] = STATE(1997),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [624] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1998),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1998),
    [sym_operator_assignment] = STATE(1998),
    [sym_conditional] = STATE(1998),
    [sym_range] = STATE(1998),
    [sym_binary] = STATE(1998),
    [sym_unary] = STATE(1998),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [625] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(1999),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(1999),
    [sym_operator_assignment] = STATE(1999),
    [sym_conditional] = STATE(1999),
    [sym_range] = STATE(1999),
    [sym_binary] = STATE(1999),
    [sym_unary] = STATE(1999),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [626] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2000),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(2000),
    [sym_operator_assignment] = STATE(2000),
    [sym_conditional] = STATE(2000),
    [sym_range] = STATE(2000),
    [sym_binary] = STATE(2000),
    [sym_unary] = STATE(2000),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [627] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2001),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(2001),
    [sym_operator_assignment] = STATE(2001),
    [sym_conditional] = STATE(2001),
    [sym_range] = STATE(2001),
    [sym_binary] = STATE(2001),
    [sym_unary] = STATE(2001),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [628] = {
    [sym_argument_list_with_parens] = STATE(2004),
    [sym__argument_list_with_parens] = STATE(2005),
    [sym_operator] = STATE(2004),
    [sym_heredoc_body] = STATE(2006),
    [aux_sym_call_repeat1] = STATE(2006),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_STAR_STAR] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_DOT_DOT] = ACTIONS(3366),
    [anon_sym_LT_LT] = ACTIONS(3366),
    [anon_sym_GT_GT] = ACTIONS(3366),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3366),
    [anon_sym_LT_EQ_GT] = ACTIONS(3366),
    [anon_sym_EQ_TILDE] = ACTIONS(3366),
    [anon_sym_BANG_TILDE] = ACTIONS(3366),
    [anon_sym_LT_EQ] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_PERCENT] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3366),
    [sym_constant] = ACTIONS(3372),
    [sym_identifier] = ACTIONS(3372),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS_AT] = ACTIONS(3366),
    [anon_sym_DASH_AT] = ACTIONS(3366),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3368),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3366),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_comment] = ACTIONS(87),
  },
  [629] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(2008),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2009),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [630] = {
    [sym_constant] = ACTIONS(3376),
    [sym_identifier] = ACTIONS(3376),
    [sym_comment] = ACTIONS(87),
  },
  [631] = {
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_EQ_GT] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [632] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(2012),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(3378),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [633] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(2014),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(3380),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [634] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(2016),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(3382),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [635] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(2018),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(3384),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [636] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(2021),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3386),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3388),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [637] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(2024),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3390),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3392),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [638] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2026),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2026),
    [sym_operator_assignment] = STATE(2026),
    [sym_conditional] = STATE(2026),
    [sym_range] = STATE(2026),
    [sym_binary] = STATE(2026),
    [sym_unary] = STATE(2026),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [639] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2028),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2028),
    [sym_operator_assignment] = STATE(2028),
    [sym_conditional] = STATE(2028),
    [sym_range] = STATE(2028),
    [sym_binary] = STATE(2028),
    [sym_unary] = STATE(2028),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [640] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2029),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2029),
    [sym_operator_assignment] = STATE(2029),
    [sym_conditional] = STATE(2029),
    [sym_range] = STATE(2029),
    [sym_binary] = STATE(2029),
    [sym_unary] = STATE(2029),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [641] = {
    [anon_sym_COLON] = ACTIONS(3402),
    [sym_comment] = ACTIONS(87),
  },
  [642] = {
    [sym__statements] = STATE(2032),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2033),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3404),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [643] = {
    [sym__method_rest] = STATE(2037),
    [sym__variable] = STATE(2038),
    [sym_operator] = STATE(2039),
    [sym__method_name] = STATE(2039),
    [sym_setter] = STATE(2039),
    [sym_symbol] = STATE(2039),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(3406),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(3408),
    [sym_self] = ACTIONS(3408),
  },
  [644] = {
    [sym__statements] = STATE(2041),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [645] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2042),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2042),
    [sym_operator_assignment] = STATE(2042),
    [sym_conditional] = STATE(2042),
    [sym_range] = STATE(2042),
    [sym_binary] = STATE(2042),
    [sym_unary] = STATE(2042),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [646] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(2045),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(3412),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(3414),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [647] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(2047),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(3416),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [648] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [649] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [650] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [651] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [652] = {
    [sym__statement] = STATE(2052),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [653] = {
    [sym__statement] = STATE(2053),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [654] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2054),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2054),
    [sym_operator_assignment] = STATE(2054),
    [sym_conditional] = STATE(2054),
    [sym_range] = STATE(2054),
    [sym_binary] = STATE(2054),
    [sym_unary] = STATE(2054),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [655] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2055),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2055),
    [sym_operator_assignment] = STATE(2055),
    [sym_conditional] = STATE(2055),
    [sym_range] = STATE(2055),
    [sym_binary] = STATE(2055),
    [sym_unary] = STATE(2055),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [656] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(2056),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [657] = {
    [sym__statements] = STATE(2058),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2059),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2060),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(2060),
    [sym__line_break2] = ACTIONS(3418),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3420),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [658] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2061),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(2061),
    [sym_operator_assignment] = STATE(2061),
    [sym_conditional] = STATE(2061),
    [sym_range] = STATE(2061),
    [sym_binary] = STATE(2061),
    [sym_unary] = STATE(2061),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2062),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(2062),
    [sym__line_break2] = ACTIONS(3422),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(3422),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [659] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(2067),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2068),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(2068),
    [sym__line_break2] = ACTIONS(3424),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3426),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [660] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(2070),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2071),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3428),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [661] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2072),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2072),
    [sym_operator_assignment] = STATE(2072),
    [sym_conditional] = STATE(2072),
    [sym_range] = STATE(2072),
    [sym_binary] = STATE(2072),
    [sym_unary] = STATE(2072),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [662] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2073),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2073),
    [sym_operator_assignment] = STATE(2073),
    [sym_conditional] = STATE(2073),
    [sym_range] = STATE(2073),
    [sym_binary] = STATE(2073),
    [sym_unary] = STATE(2073),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [663] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [664] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(3430),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [665] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(3432),
  },
  [666] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(2077),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2078),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [667] = {
    [sym_lambda_parameters] = STATE(2080),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(2081),
    [sym_block] = STATE(2081),
    [anon_sym_LBRACE] = ACTIONS(3436),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(2465),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [668] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [669] = {
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(2439),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_EQ_GT] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(2441),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(2443),
    [anon_sym_AMP_DOT] = ACTIONS(2445),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [sym_comment] = ACTIONS(87),
  },
  [670] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(672),
    [sym__argument] = STATE(673),
    [sym_splat_argument] = STATE(673),
    [sym_hash_splat_argument] = STATE(673),
    [sym_block_argument] = STATE(673),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(673),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [671] = {
    [sym_do_block] = STATE(2098),
    [sym_block] = STATE(2098),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_do] = ACTIONS(3470),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [672] = {
    [sym_heredoc_body] = STATE(2100),
    [aux_sym_call_repeat1] = STATE(2100),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [673] = {
    [sym_heredoc_body] = STATE(2100),
    [aux_sym_call_repeat1] = STATE(2100),
    [aux_sym_argument_list_repeat1] = STATE(2102),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [674] = {
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [675] = {
    [anon_sym_EQ] = ACTIONS(3476),
    [sym_comment] = ACTIONS(87),
  },
  [676] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3478),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3480),
    [anon_sym_DASH_EQ] = ACTIONS(3480),
    [anon_sym_STAR_EQ] = ACTIONS(3480),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3480),
    [anon_sym_SLASH_EQ] = ACTIONS(3480),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3480),
    [anon_sym_PIPE_EQ] = ACTIONS(3480),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3480),
    [anon_sym_AMP_EQ] = ACTIONS(3480),
    [anon_sym_PERCENT_EQ] = ACTIONS(3480),
    [anon_sym_GT_GT_EQ] = ACTIONS(3480),
    [anon_sym_LT_LT_EQ] = ACTIONS(3480),
    [anon_sym_CARET_EQ] = ACTIONS(3480),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [677] = {
    [sym_string] = STATE(2105),
    [aux_sym_chained_string_repeat1] = STATE(2105),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3482),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [678] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2115),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_splat_argument] = STATE(2117),
    [sym_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(2115),
    [sym_range] = STATE(2115),
    [sym_binary] = STATE(2115),
    [sym_unary] = STATE(2115),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(2117),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__splat_star2] = ACTIONS(3484),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [679] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2121),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(2121),
    [sym_operator_assignment] = STATE(2121),
    [sym_conditional] = STATE(2121),
    [sym_range] = STATE(2121),
    [sym_binary] = STATE(2121),
    [sym_unary] = STATE(2121),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [680] = {
    [sym_string] = STATE(2122),
    [aux_sym_chained_string_repeat1] = STATE(2122),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [681] = {
    [sym__line_break2] = ACTIONS(3504),
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [anon_sym___END__] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_end] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_when] = ACTIONS(3504),
    [anon_sym_elsif] = ACTIONS(3504),
    [anon_sym_else] = ACTIONS(3504),
    [anon_sym_then] = ACTIONS(3504),
    [anon_sym_ensure] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(87),
  },
  [682] = {
    [anon_sym_RBRACE] = ACTIONS(3508),
    [sym_comment] = ACTIONS(87),
  },
  [683] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(2125),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(2126),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(3510),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(3512),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [684] = {
    [sym__line_break2] = ACTIONS(3514),
    [sym__heredoc_body_start2] = ACTIONS(3514),
    [ts_builtin_sym_end] = ACTIONS(3514),
    [anon_sym___END__] = ACTIONS(3514),
    [anon_sym_RBRACE] = ACTIONS(3514),
    [anon_sym_RPAREN] = ACTIONS(3514),
    [anon_sym_SEMI] = ACTIONS(3514),
    [anon_sym_end] = ACTIONS(3514),
    [anon_sym_rescue] = ACTIONS(3514),
    [anon_sym_when] = ACTIONS(3514),
    [anon_sym_elsif] = ACTIONS(3514),
    [anon_sym_else] = ACTIONS(3514),
    [anon_sym_ensure] = ACTIONS(3514),
    [sym_comment] = ACTIONS(87),
  },
  [685] = {
    [anon_sym_RBRACE] = ACTIONS(3516),
    [sym_comment] = ACTIONS(87),
  },
  [686] = {
    [sym__line_break2] = ACTIONS(891),
    [sym__heredoc_body_start2] = ACTIONS(891),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym___END__] = ACTIONS(893),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_LPAREN] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_end] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(893),
    [anon_sym_unless] = ACTIONS(893),
    [anon_sym_while] = ACTIONS(893),
    [anon_sym_until] = ACTIONS(893),
    [anon_sym_rescue] = ACTIONS(893),
    [anon_sym_when] = ACTIONS(893),
    [anon_sym_elsif] = ACTIONS(893),
    [anon_sym_else] = ACTIONS(893),
    [anon_sym_then] = ACTIONS(893),
    [anon_sym_ensure] = ACTIONS(893),
    [sym_identifier] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [687] = {
    [sym__string_end2] = ACTIONS(3518),
    [sym_comment] = ACTIONS(87),
  },
  [688] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2129),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(2129),
    [sym_operator_assignment] = STATE(2129),
    [sym_conditional] = STATE(2129),
    [sym_range] = STATE(2129),
    [sym_binary] = STATE(2129),
    [sym_unary] = STATE(2129),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [689] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(2140),
    [sym__argument] = STATE(2141),
    [sym_splat_argument] = STATE(2141),
    [sym_hash_splat_argument] = STATE(2141),
    [sym_block_argument] = STATE(2141),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2141),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [690] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(2140),
    [sym__argument] = STATE(2141),
    [sym_splat_argument] = STATE(2141),
    [sym_hash_splat_argument] = STATE(2141),
    [sym_block_argument] = STATE(2141),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2141),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [691] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(2140),
    [sym__argument] = STATE(2141),
    [sym_splat_argument] = STATE(2141),
    [sym_hash_splat_argument] = STATE(2141),
    [sym_block_argument] = STATE(2141),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2141),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [692] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(2140),
    [sym__argument] = STATE(2141),
    [sym_splat_argument] = STATE(2141),
    [sym_hash_splat_argument] = STATE(2141),
    [sym_block_argument] = STATE(2141),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2141),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [693] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2145),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(2145),
    [sym_operator_assignment] = STATE(2145),
    [sym_conditional] = STATE(2145),
    [sym_range] = STATE(2145),
    [sym_binary] = STATE(2145),
    [sym_unary] = STATE(2145),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [694] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2146),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(2146),
    [sym_operator_assignment] = STATE(2146),
    [sym_conditional] = STATE(2146),
    [sym_range] = STATE(2146),
    [sym_binary] = STATE(2146),
    [sym_unary] = STATE(2146),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [695] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [696] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [697] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(1742),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_do_block] = STATE(1745),
    [sym_block] = STATE(1745),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [698] = {
    [anon_sym_EQ] = ACTIONS(3602),
    [sym_comment] = ACTIONS(87),
  },
  [699] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3604),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3606),
    [anon_sym_DASH_EQ] = ACTIONS(3606),
    [anon_sym_STAR_EQ] = ACTIONS(3606),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3606),
    [anon_sym_SLASH_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_PIPE_EQ] = ACTIONS(3606),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3606),
    [anon_sym_AMP_EQ] = ACTIONS(3606),
    [anon_sym_PERCENT_EQ] = ACTIONS(3606),
    [anon_sym_GT_GT_EQ] = ACTIONS(3606),
    [anon_sym_LT_LT_EQ] = ACTIONS(3606),
    [anon_sym_CARET_EQ] = ACTIONS(3606),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [700] = {
    [sym_string] = STATE(2182),
    [aux_sym_chained_string_repeat1] = STATE(2182),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [701] = {
    [sym__line_break2] = ACTIONS(3608),
    [sym__heredoc_body_start2] = ACTIONS(3608),
    [ts_builtin_sym_end] = ACTIONS(3608),
    [anon_sym___END__] = ACTIONS(3610),
    [anon_sym_RBRACE] = ACTIONS(3608),
    [anon_sym_LPAREN] = ACTIONS(3608),
    [anon_sym_RPAREN] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_SEMI] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(3610),
    [anon_sym_STAR_STAR] = ACTIONS(3608),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_end] = ACTIONS(3610),
    [anon_sym_if] = ACTIONS(3610),
    [anon_sym_unless] = ACTIONS(3610),
    [anon_sym_while] = ACTIONS(3610),
    [anon_sym_until] = ACTIONS(3610),
    [anon_sym_rescue] = ACTIONS(3610),
    [anon_sym_when] = ACTIONS(3610),
    [anon_sym_elsif] = ACTIONS(3610),
    [anon_sym_else] = ACTIONS(3610),
    [anon_sym_then] = ACTIONS(3610),
    [anon_sym_ensure] = ACTIONS(3610),
    [sym_identifier] = ACTIONS(3610),
    [sym_comment] = ACTIONS(87),
  },
  [702] = {
    [sym__method_rest] = STATE(2183),
    [sym_operator] = STATE(136),
    [sym__method_name] = STATE(136),
    [sym_setter] = STATE(136),
    [sym_symbol] = STATE(136),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3612),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3612),
    [sym_class_variable] = ACTIONS(3612),
    [sym_global_variable] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [703] = {
    [sym__formal_parameter] = STATE(2185),
    [sym__simple_formal_parameter] = STATE(2185),
    [sym_destructured_parameter] = STATE(2185),
    [sym_splat_parameter] = STATE(2185),
    [sym_hash_splat_parameter] = STATE(2185),
    [sym_block_parameter] = STATE(2185),
    [sym_keyword_parameter] = STATE(2185),
    [sym_optional_parameter] = STATE(2185),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_RPAREN] = ACTIONS(3614),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2503),
    [sym_comment] = ACTIONS(87),
  },
  [704] = {
    [sym__line_break2] = ACTIONS(2505),
    [sym__heredoc_body_start2] = ACTIONS(2505),
    [anon_sym_COMMA] = ACTIONS(2505),
    [anon_sym_SEMI] = ACTIONS(2505),
    [sym_identifier] = ACTIONS(3616),
    [sym_comment] = ACTIONS(87),
  },
  [705] = {
    [sym__line_break2] = ACTIONS(2511),
    [sym__heredoc_body_start2] = ACTIONS(2511),
    [anon_sym_COMMA] = ACTIONS(2511),
    [anon_sym_SEMI] = ACTIONS(2511),
    [sym_identifier] = ACTIONS(3618),
    [sym_comment] = ACTIONS(87),
  },
  [706] = {
    [sym_lambda] = STATE(2188),
    [sym_identifier] = ACTIONS(3620),
    [sym_comment] = ACTIONS(87),
    [anon_sym_DASH_GT] = ACTIONS(3622),
  },
  [707] = {
    [sym__line_break2] = ACTIONS(2525),
    [sym__heredoc_body_start2] = ACTIONS(2525),
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_COLON] = ACTIONS(3624),
    [anon_sym_EQ] = ACTIONS(3626),
    [sym_comment] = ACTIONS(87),
  },
  [708] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(2192),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3628),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [709] = {
    [sym_heredoc_body] = STATE(2194),
    [sym__terminator] = STATE(2194),
    [sym__line_break2] = ACTIONS(3630),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(3632),
    [anon_sym_SEMI] = ACTIONS(3630),
    [sym_comment] = ACTIONS(87),
  },
  [710] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [711] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2208),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(2209),
    [sym__argument] = STATE(2210),
    [sym_splat_argument] = STATE(2210),
    [sym_hash_splat_argument] = STATE(2210),
    [sym_block_argument] = STATE(2210),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(2208),
    [sym_operator_assignment] = STATE(2208),
    [sym_conditional] = STATE(2208),
    [sym_range] = STATE(2208),
    [sym_binary] = STATE(2208),
    [sym_unary] = STATE(2208),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2213),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2210),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3634),
    [sym__splat_star2] = ACTIONS(3636),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(1505),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3642),
    [anon_sym_EQ] = ACTIONS(749),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3660),
    [sym_identifier] = ACTIONS(3660),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [712] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2222),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(2222),
    [sym_operator_assignment] = STATE(2222),
    [sym_conditional] = STATE(2222),
    [sym_range] = STATE(2222),
    [sym_binary] = STATE(2222),
    [sym_unary] = STATE(2222),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [713] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2226),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(2226),
    [sym_operator_assignment] = STATE(2226),
    [sym_conditional] = STATE(2226),
    [sym_range] = STATE(2226),
    [sym_binary] = STATE(2226),
    [sym_unary] = STATE(2226),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [714] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2227),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(2227),
    [sym_operator_assignment] = STATE(2227),
    [sym_conditional] = STATE(2227),
    [sym_range] = STATE(2227),
    [sym_binary] = STATE(2227),
    [sym_unary] = STATE(2227),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [715] = {
    [anon_sym_COLON] = ACTIONS(3682),
    [sym_comment] = ACTIONS(87),
  },
  [716] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2230),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(2230),
    [sym_operator_assignment] = STATE(2230),
    [sym_conditional] = STATE(2230),
    [sym_range] = STATE(2230),
    [sym_binary] = STATE(2230),
    [sym_unary] = STATE(2230),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [717] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2237),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [718] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(2237),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [719] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(2237),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [720] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(2237),
    [sym__argument] = STATE(2238),
    [sym_splat_argument] = STATE(2238),
    [sym_hash_splat_argument] = STATE(2238),
    [sym_block_argument] = STATE(2238),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2238),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [721] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2240),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(2240),
    [sym_operator_assignment] = STATE(2240),
    [sym_conditional] = STATE(2240),
    [sym_range] = STATE(2240),
    [sym_binary] = STATE(2240),
    [sym_unary] = STATE(2240),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [722] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2241),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(2241),
    [sym_operator_assignment] = STATE(2241),
    [sym_conditional] = STATE(2241),
    [sym_range] = STATE(2241),
    [sym_binary] = STATE(2241),
    [sym_unary] = STATE(2241),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [723] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [724] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(3692),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [725] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(3706),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [726] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [727] = {
    [sym_heredoc_body] = STATE(2264),
    [aux_sym_call_repeat1] = STATE(2264),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [728] = {
    [sym_heredoc_body] = STATE(2264),
    [aux_sym_call_repeat1] = STATE(2264),
    [aux_sym_argument_list_repeat1] = STATE(2266),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [729] = {
    [anon_sym_EQ] = ACTIONS(3736),
    [sym_comment] = ACTIONS(87),
  },
  [730] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3738),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3740),
    [anon_sym_DASH_EQ] = ACTIONS(3740),
    [anon_sym_STAR_EQ] = ACTIONS(3740),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3740),
    [anon_sym_SLASH_EQ] = ACTIONS(3740),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3740),
    [anon_sym_PIPE_EQ] = ACTIONS(3740),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3740),
    [anon_sym_AMP_EQ] = ACTIONS(3740),
    [anon_sym_PERCENT_EQ] = ACTIONS(3740),
    [anon_sym_GT_GT_EQ] = ACTIONS(3740),
    [anon_sym_LT_LT_EQ] = ACTIONS(3740),
    [anon_sym_CARET_EQ] = ACTIONS(3740),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [731] = {
    [sym_string] = STATE(2269),
    [aux_sym_chained_string_repeat1] = STATE(2269),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3742),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [732] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [733] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [734] = {
    [aux_sym_undef_repeat1] = STATE(2270),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_RPAREN] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [735] = {
    [sym__line_break2] = ACTIONS(3744),
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [anon_sym___END__] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_end] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_elsif] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3744),
    [anon_sym_then] = ACTIONS(3744),
    [anon_sym_ensure] = ACTIONS(3744),
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(87),
  },
  [736] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [737] = {
    [sym_heredoc_body] = STATE(2271),
    [sym__terminator] = STATE(2271),
    [aux_sym__statements_repeat1] = STATE(2272),
    [sym__line_break2] = ACTIONS(3748),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_RPAREN] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(3748),
    [sym_comment] = ACTIONS(87),
  },
  [738] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2273),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2273),
    [sym_operator_assignment] = STATE(2273),
    [sym_conditional] = STATE(2273),
    [sym_range] = STATE(2273),
    [sym_binary] = STATE(2273),
    [sym_unary] = STATE(2273),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [739] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2274),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2274),
    [sym_operator_assignment] = STATE(2274),
    [sym_conditional] = STATE(2274),
    [sym_range] = STATE(2274),
    [sym_binary] = STATE(2274),
    [sym_unary] = STATE(2274),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [740] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2275),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2275),
    [sym_operator_assignment] = STATE(2275),
    [sym_conditional] = STATE(2275),
    [sym_range] = STATE(2275),
    [sym_binary] = STATE(2275),
    [sym_unary] = STATE(2275),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [741] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2276),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2276),
    [sym_operator_assignment] = STATE(2276),
    [sym_conditional] = STATE(2276),
    [sym_range] = STATE(2276),
    [sym_binary] = STATE(2276),
    [sym_unary] = STATE(2276),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [742] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2277),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2277),
    [sym_operator_assignment] = STATE(2277),
    [sym_conditional] = STATE(2277),
    [sym_range] = STATE(2277),
    [sym_binary] = STATE(2277),
    [sym_unary] = STATE(2277),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [743] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2278),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2278),
    [sym_operator_assignment] = STATE(2278),
    [sym_conditional] = STATE(2278),
    [sym_range] = STATE(2278),
    [sym_binary] = STATE(2278),
    [sym_unary] = STATE(2278),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [744] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2279),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2279),
    [sym_operator_assignment] = STATE(2279),
    [sym_conditional] = STATE(2279),
    [sym_range] = STATE(2279),
    [sym_binary] = STATE(2279),
    [sym_unary] = STATE(2279),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [745] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2280),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2280),
    [sym_operator_assignment] = STATE(2280),
    [sym_conditional] = STATE(2280),
    [sym_range] = STATE(2280),
    [sym_binary] = STATE(2280),
    [sym_unary] = STATE(2280),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [746] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2281),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2281),
    [sym_operator_assignment] = STATE(2281),
    [sym_conditional] = STATE(2281),
    [sym_range] = STATE(2281),
    [sym_binary] = STATE(2281),
    [sym_unary] = STATE(2281),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [747] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2282),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2282),
    [sym_operator_assignment] = STATE(2282),
    [sym_conditional] = STATE(2282),
    [sym_range] = STATE(2282),
    [sym_binary] = STATE(2282),
    [sym_unary] = STATE(2282),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [748] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2283),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2283),
    [sym_operator_assignment] = STATE(2283),
    [sym_conditional] = STATE(2283),
    [sym_range] = STATE(2283),
    [sym_binary] = STATE(2283),
    [sym_unary] = STATE(2283),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [749] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2284),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(2284),
    [sym_operator_assignment] = STATE(2284),
    [sym_conditional] = STATE(2284),
    [sym_range] = STATE(2284),
    [sym_binary] = STATE(2284),
    [sym_unary] = STATE(2284),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [750] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2285),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2285),
    [sym_operator_assignment] = STATE(2285),
    [sym_conditional] = STATE(2285),
    [sym_range] = STATE(2285),
    [sym_binary] = STATE(2285),
    [sym_unary] = STATE(2285),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [751] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2286),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2286),
    [sym_operator_assignment] = STATE(2286),
    [sym_conditional] = STATE(2286),
    [sym_range] = STATE(2286),
    [sym_binary] = STATE(2286),
    [sym_unary] = STATE(2286),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [752] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2287),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2287),
    [sym_operator_assignment] = STATE(2287),
    [sym_conditional] = STATE(2287),
    [sym_range] = STATE(2287),
    [sym_binary] = STATE(2287),
    [sym_unary] = STATE(2287),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [753] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2288),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2288),
    [sym_operator_assignment] = STATE(2288),
    [sym_conditional] = STATE(2288),
    [sym_range] = STATE(2288),
    [sym_binary] = STATE(2288),
    [sym_unary] = STATE(2288),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [754] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2289),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2289),
    [sym_operator_assignment] = STATE(2289),
    [sym_conditional] = STATE(2289),
    [sym_range] = STATE(2289),
    [sym_binary] = STATE(2289),
    [sym_unary] = STATE(2289),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [755] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2298),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(2298),
    [sym_operator_assignment] = STATE(2298),
    [sym_conditional] = STATE(2298),
    [sym_range] = STATE(2298),
    [sym_binary] = STATE(2298),
    [sym_unary] = STATE(2298),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [756] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2303),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(2303),
    [sym_operator_assignment] = STATE(2303),
    [sym_conditional] = STATE(2303),
    [sym_range] = STATE(2303),
    [sym_binary] = STATE(2303),
    [sym_unary] = STATE(2303),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [757] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2304),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(2304),
    [sym_operator_assignment] = STATE(2304),
    [sym_conditional] = STATE(2304),
    [sym_range] = STATE(2304),
    [sym_binary] = STATE(2304),
    [sym_unary] = STATE(2304),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [758] = {
    [anon_sym_COLON] = ACTIONS(3774),
    [sym_comment] = ACTIONS(87),
  },
  [759] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2307),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(2307),
    [sym_operator_assignment] = STATE(2307),
    [sym_conditional] = STATE(2307),
    [sym_range] = STATE(2307),
    [sym_binary] = STATE(2307),
    [sym_unary] = STATE(2307),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [760] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [761] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [762] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [763] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [764] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2308),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(2308),
    [sym_operator_assignment] = STATE(2308),
    [sym_conditional] = STATE(2308),
    [sym_range] = STATE(2308),
    [sym_binary] = STATE(2308),
    [sym_unary] = STATE(2308),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [765] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2309),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(2309),
    [sym_operator_assignment] = STATE(2309),
    [sym_conditional] = STATE(2309),
    [sym_range] = STATE(2309),
    [sym_binary] = STATE(2309),
    [sym_unary] = STATE(2309),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [766] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [767] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(3776),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [768] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(3790),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [769] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(2261),
    [sym__argument] = STATE(2262),
    [sym_splat_argument] = STATE(2262),
    [sym_hash_splat_argument] = STATE(2262),
    [sym_block_argument] = STATE(2262),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2262),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [770] = {
    [sym_heredoc_body] = STATE(2323),
    [aux_sym_call_repeat1] = STATE(2323),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [771] = {
    [sym_heredoc_body] = STATE(2323),
    [aux_sym_call_repeat1] = STATE(2323),
    [aux_sym_argument_list_repeat1] = STATE(2325),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [772] = {
    [anon_sym_EQ] = ACTIONS(3810),
    [sym_comment] = ACTIONS(87),
  },
  [773] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(3812),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(3814),
    [anon_sym_DASH_EQ] = ACTIONS(3814),
    [anon_sym_STAR_EQ] = ACTIONS(3814),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3814),
    [anon_sym_SLASH_EQ] = ACTIONS(3814),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3814),
    [anon_sym_PIPE_EQ] = ACTIONS(3814),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3814),
    [anon_sym_AMP_EQ] = ACTIONS(3814),
    [anon_sym_PERCENT_EQ] = ACTIONS(3814),
    [anon_sym_GT_GT_EQ] = ACTIONS(3814),
    [anon_sym_LT_LT_EQ] = ACTIONS(3814),
    [anon_sym_CARET_EQ] = ACTIONS(3814),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [774] = {
    [sym_string] = STATE(2328),
    [aux_sym_chained_string_repeat1] = STATE(2328),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3816),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [775] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2334),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_splat_argument] = STATE(2335),
    [sym_assignment] = STATE(2334),
    [sym_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(2334),
    [sym_range] = STATE(2334),
    [sym_binary] = STATE(2334),
    [sym_unary] = STATE(2334),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(2335),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(3818),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [776] = {
    [anon_sym_RPAREN] = ACTIONS(3830),
    [anon_sym_COMMA] = ACTIONS(3830),
    [anon_sym_EQ] = ACTIONS(3830),
    [anon_sym_in] = ACTIONS(3830),
    [sym_comment] = ACTIONS(87),
  },
  [777] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(711),
    [sym_call] = STATE(711),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(1672),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(711),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_RPAREN] = ACTIONS(2805),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_EQ] = ACTIONS(2805),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(1305),
    [sym_identifier] = ACTIONS(1305),
    [sym_instance_variable] = ACTIONS(1307),
    [sym_class_variable] = ACTIONS(1307),
    [sym_global_variable] = ACTIONS(1307),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(1305),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(1305),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [778] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2338),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(2338),
    [sym_operator_assignment] = STATE(2338),
    [sym_conditional] = STATE(2338),
    [sym_range] = STATE(2338),
    [sym_binary] = STATE(2338),
    [sym_unary] = STATE(2338),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [779] = {
    [sym_string] = STATE(2339),
    [aux_sym_chained_string_repeat1] = STATE(2339),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [780] = {
    [sym__string_start2] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [781] = {
    [sym__string_end2] = ACTIONS(3832),
    [sym_comment] = ACTIONS(87),
  },
  [782] = {
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(891),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [783] = {
    [sym__string_end2] = ACTIONS(3834),
    [sym_comment] = ACTIONS(87),
  },
  [784] = {
    [anon_sym_DOT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [785] = {
    [sym__string_end2] = ACTIONS(3836),
    [sym_comment] = ACTIONS(87),
  },
  [786] = {
    [anon_sym_DOT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [787] = {
    [sym__string_end2] = ACTIONS(3838),
    [sym_comment] = ACTIONS(87),
  },
  [788] = {
    [anon_sym_DOT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [sym_comment] = ACTIONS(87),
  },
  [789] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(2346),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3840),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3842),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [790] = {
    [aux_sym_string_array_repeat1] = STATE(2349),
    [sym__string_end2] = ACTIONS(3844),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3846),
  },
  [791] = {
    [anon_sym_DOT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [sym_comment] = ACTIONS(87),
  },
  [792] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(2352),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(3848),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3850),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [793] = {
    [aux_sym_symbol_array_repeat1] = STATE(2355),
    [sym__string_end2] = ACTIONS(3852),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(3854),
  },
  [794] = {
    [anon_sym_DOT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [795] = {
    [anon_sym_RBRACE] = ACTIONS(3856),
    [sym_comment] = ACTIONS(87),
  },
  [796] = {
    [sym_heredoc_body] = STATE(2357),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(3856),
    [sym_comment] = ACTIONS(87),
  },
  [797] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2358),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(2358),
    [sym_operator_assignment] = STATE(2358),
    [sym_conditional] = STATE(2358),
    [sym_range] = STATE(2358),
    [sym_binary] = STATE(2358),
    [sym_unary] = STATE(2358),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [798] = {
    [anon_sym_DOT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [sym_comment] = ACTIONS(87),
  },
  [799] = {
    [anon_sym_DOT] = ACTIONS(3858),
    [anon_sym_COLON_COLON] = ACTIONS(3858),
    [sym_comment] = ACTIONS(87),
  },
  [800] = {
    [sym_method_parameters] = STATE(2360),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(2360),
    [sym__terminator] = STATE(2360),
    [sym__line_break2] = ACTIONS(3860),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(3860),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [801] = {
    [anon_sym_DOT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [sym_comment] = ACTIONS(87),
  },
  [802] = {
    [anon_sym_RPAREN] = ACTIONS(3862),
    [sym_comment] = ACTIONS(87),
  },
  [803] = {
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1427),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1427),
    [anon_sym_EQ] = ACTIONS(1427),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [804] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2362),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(2362),
    [sym_operator_assignment] = STATE(2362),
    [sym_conditional] = STATE(2362),
    [sym_range] = STATE(2362),
    [sym_binary] = STATE(2362),
    [sym_unary] = STATE(2362),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [805] = {
    [sym_superclass] = STATE(2363),
    [sym_heredoc_body] = STATE(2364),
    [sym__terminator] = STATE(2364),
    [sym__line_break2] = ACTIONS(3864),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [806] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(2363),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2364),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(2364),
    [sym__line_break2] = ACTIONS(3864),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(3864),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [807] = {
    [sym_heredoc_body] = STATE(2366),
    [sym__terminator] = STATE(2366),
    [sym__line_break2] = ACTIONS(3866),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [808] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2366),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(2366),
    [sym__line_break2] = ACTIONS(3866),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(3866),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(3868),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [809] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2375),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(2375),
    [sym_operator_assignment] = STATE(2375),
    [sym_conditional] = STATE(2375),
    [sym_range] = STATE(2375),
    [sym_binary] = STATE(2375),
    [sym_unary] = STATE(2375),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [810] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2380),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(2380),
    [sym_operator_assignment] = STATE(2380),
    [sym_conditional] = STATE(2380),
    [sym_range] = STATE(2380),
    [sym_binary] = STATE(2380),
    [sym_unary] = STATE(2380),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [811] = {
    [anon_sym_COLON] = ACTIONS(3892),
    [sym_comment] = ACTIONS(87),
  },
  [812] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2382),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(2382),
    [sym_operator_assignment] = STATE(2382),
    [sym_conditional] = STATE(2382),
    [sym_range] = STATE(2382),
    [sym_binary] = STATE(2382),
    [sym_unary] = STATE(2382),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [813] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(2384),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2385),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(3894),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [814] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(3896),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [815] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(3898),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(3900),
    [anon_sym_or] = ACTIONS(3900),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [816] = {
    [anon_sym_DOT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [817] = {
    [sym_heredoc_body] = STATE(2388),
    [aux_sym_call_repeat1] = STATE(2388),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [818] = {
    [sym_heredoc_body] = STATE(2388),
    [aux_sym_call_repeat1] = STATE(2388),
    [aux_sym_argument_list_repeat1] = STATE(2390),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(3904),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [819] = {
    [sym_string] = STATE(1965),
    [aux_sym_chained_string_repeat1] = STATE(1965),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(3906),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [820] = {
    [anon_sym_DOT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [sym_comment] = ACTIONS(87),
  },
  [821] = {
    [anon_sym_DOT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [sym_comment] = ACTIONS(87),
  },
  [822] = {
    [anon_sym_DOT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(87),
  },
  [823] = {
    [sym__then] = STATE(2391),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(3908),
    [sym_comment] = ACTIONS(87),
  },
  [824] = {
    [sym__then] = STATE(2392),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(3910),
    [sym_comment] = ACTIONS(87),
  },
  [825] = {
    [sym__do] = STATE(2393),
    [sym_heredoc_body] = STATE(2393),
    [sym__terminator] = STATE(2393),
    [sym__line_break2] = ACTIONS(3912),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(3912),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(3912),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [826] = {
    [sym__do] = STATE(2394),
    [sym_heredoc_body] = STATE(2394),
    [sym__terminator] = STATE(2394),
    [sym__line_break2] = ACTIONS(3914),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(3914),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(3914),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [827] = {
    [sym_in] = STATE(2395),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [828] = {
    [sym_heredoc_body] = STATE(2396),
    [sym__terminator] = STATE(2396),
    [sym__line_break2] = ACTIONS(3916),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(3916),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [829] = {
    [sym_when] = STATE(2397),
    [aux_sym_case_repeat1] = STATE(2398),
    [anon_sym_SEMI] = ACTIONS(3918),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [830] = {
    [sym_else] = STATE(2400),
    [sym_ensure] = STATE(2401),
    [sym_rescue] = STATE(2402),
    [anon_sym_end] = ACTIONS(3920),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [831] = {
    [sym_ensure] = STATE(2401),
    [anon_sym_end] = ACTIONS(3920),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [832] = {
    [anon_sym_end] = ACTIONS(3920),
    [sym_comment] = ACTIONS(87),
  },
  [833] = {
    [sym_else] = STATE(2400),
    [sym_ensure] = STATE(2401),
    [anon_sym_end] = ACTIONS(3920),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [834] = {
    [anon_sym_DOT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [sym_comment] = ACTIONS(87),
  },
  [835] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(2403),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3922),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [836] = {
    [anon_sym_DOT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
  },
  [837] = {
    [anon_sym_DOT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(87),
  },
  [838] = {
    [sym_heredoc_body] = STATE(2405),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(3924),
    [sym_comment] = ACTIONS(87),
  },
  [839] = {
    [anon_sym_RBRACK] = ACTIONS(3924),
    [sym_comment] = ACTIONS(87),
  },
  [840] = {
    [sym__statements] = STATE(2407),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2408),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(3926),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [841] = {
    [sym__statements] = STATE(2410),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2411),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2412),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(2412),
    [sym__line_break2] = ACTIONS(3928),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(3930),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [842] = {
    [sym_do_block] = STATE(2413),
    [sym_block] = STATE(2413),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_do] = ACTIONS(3932),
    [sym_comment] = ACTIONS(87),
  },
  [843] = {
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2537),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2537),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [844] = {
    [sym_argument_list_with_parens] = STATE(2416),
    [sym__argument_list_with_parens] = STATE(2417),
    [sym_operator] = STATE(2416),
    [sym_heredoc_body] = STATE(2418),
    [aux_sym_call_repeat1] = STATE(2418),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(3934),
    [anon_sym_STAR] = ACTIONS(3936),
    [anon_sym_STAR_STAR] = ACTIONS(3934),
    [anon_sym_AMP] = ACTIONS(3934),
    [anon_sym_LT] = ACTIONS(3936),
    [anon_sym_LPAREN2] = ACTIONS(3938),
    [anon_sym_DOT_DOT] = ACTIONS(3934),
    [anon_sym_LT_LT] = ACTIONS(3934),
    [anon_sym_GT_GT] = ACTIONS(3934),
    [anon_sym_EQ_EQ] = ACTIONS(3936),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3934),
    [anon_sym_LT_EQ_GT] = ACTIONS(3934),
    [anon_sym_EQ_TILDE] = ACTIONS(3934),
    [anon_sym_BANG_TILDE] = ACTIONS(3934),
    [anon_sym_LT_EQ] = ACTIONS(3936),
    [anon_sym_GT] = ACTIONS(3936),
    [anon_sym_GT_EQ] = ACTIONS(3934),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_PLUS] = ACTIONS(3936),
    [anon_sym_SLASH] = ACTIONS(3934),
    [anon_sym_PERCENT] = ACTIONS(3934),
    [anon_sym_BANG] = ACTIONS(3936),
    [anon_sym_TILDE] = ACTIONS(3934),
    [sym_constant] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_PLUS_AT] = ACTIONS(3934),
    [anon_sym_DASH_AT] = ACTIONS(3934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3936),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3934),
    [anon_sym_BQUOTE] = ACTIONS(3934),
    [sym_comment] = ACTIONS(87),
  },
  [845] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(2420),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2421),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(3942),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [846] = {
    [sym_constant] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3944),
    [sym_comment] = ACTIONS(87),
  },
  [847] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2453),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(2453),
    [sym_operator_assignment] = STATE(2453),
    [sym_conditional] = STATE(2453),
    [sym_range] = STATE(2453),
    [sym_binary] = STATE(2453),
    [sym_unary] = STATE(2453),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [848] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2458),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(2458),
    [sym_operator_assignment] = STATE(2458),
    [sym_conditional] = STATE(2458),
    [sym_range] = STATE(2458),
    [sym_binary] = STATE(2458),
    [sym_unary] = STATE(2458),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [849] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2459),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(2459),
    [sym_operator_assignment] = STATE(2459),
    [sym_conditional] = STATE(2459),
    [sym_range] = STATE(2459),
    [sym_binary] = STATE(2459),
    [sym_unary] = STATE(2459),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [850] = {
    [anon_sym_COLON] = ACTIONS(4012),
    [sym_comment] = ACTIONS(87),
  },
  [851] = {
    [sym__statements] = STATE(2407),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2408),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1350),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4014),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [852] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2463),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(2463),
    [sym_operator_assignment] = STATE(2463),
    [sym_conditional] = STATE(2463),
    [sym_range] = STATE(2463),
    [sym_binary] = STATE(2463),
    [sym_unary] = STATE(2463),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [853] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(2470),
    [sym__argument] = STATE(2471),
    [sym_splat_argument] = STATE(2471),
    [sym_hash_splat_argument] = STATE(2471),
    [sym_block_argument] = STATE(2471),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2471),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [854] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(2470),
    [sym__argument] = STATE(2471),
    [sym_splat_argument] = STATE(2471),
    [sym_hash_splat_argument] = STATE(2471),
    [sym_block_argument] = STATE(2471),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2471),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [855] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(2470),
    [sym__argument] = STATE(2471),
    [sym_splat_argument] = STATE(2471),
    [sym_hash_splat_argument] = STATE(2471),
    [sym_block_argument] = STATE(2471),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2471),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [856] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(2470),
    [sym__argument] = STATE(2471),
    [sym_splat_argument] = STATE(2471),
    [sym_hash_splat_argument] = STATE(2471),
    [sym_block_argument] = STATE(2471),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2471),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [857] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2473),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(2473),
    [sym_operator_assignment] = STATE(2473),
    [sym_conditional] = STATE(2473),
    [sym_range] = STATE(2473),
    [sym_binary] = STATE(2473),
    [sym_unary] = STATE(2473),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [858] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2474),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(2474),
    [sym_operator_assignment] = STATE(2474),
    [sym_conditional] = STATE(2474),
    [sym_range] = STATE(2474),
    [sym_binary] = STATE(2474),
    [sym_unary] = STATE(2474),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [859] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [860] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4026),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [861] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(4048),
    [anon_sym_or] = ACTIONS(4048),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [862] = {
    [sym_do_block] = STATE(2488),
    [sym_block] = STATE(2488),
    [anon_sym_LBRACE] = ACTIONS(1487),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(3932),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [sym_comment] = ACTIONS(87),
  },
  [863] = {
    [sym_heredoc_body] = STATE(2489),
    [aux_sym_call_repeat1] = STATE(2489),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [864] = {
    [sym_heredoc_body] = STATE(2489),
    [aux_sym_call_repeat1] = STATE(2489),
    [aux_sym_argument_list_repeat1] = STATE(2491),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [865] = {
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [sym_comment] = ACTIONS(87),
  },
  [866] = {
    [anon_sym_EQ] = ACTIONS(4064),
    [sym_comment] = ACTIONS(87),
  },
  [867] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4066),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4068),
    [anon_sym_DASH_EQ] = ACTIONS(4068),
    [anon_sym_STAR_EQ] = ACTIONS(4068),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4068),
    [anon_sym_SLASH_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_PIPE_EQ] = ACTIONS(4068),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4068),
    [anon_sym_AMP_EQ] = ACTIONS(4068),
    [anon_sym_PERCENT_EQ] = ACTIONS(4068),
    [anon_sym_GT_GT_EQ] = ACTIONS(4068),
    [anon_sym_LT_LT_EQ] = ACTIONS(4068),
    [anon_sym_CARET_EQ] = ACTIONS(4068),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [868] = {
    [sym_string] = STATE(2494),
    [aux_sym_chained_string_repeat1] = STATE(2494),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4070),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [869] = {
    [sym_string] = STATE(2495),
    [aux_sym_chained_string_repeat1] = STATE(2495),
    [sym__string_start2] = ACTIONS(279),
    [anon_sym_DOT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [870] = {
    [sym_heredoc_body] = STATE(2496),
    [sym__terminator] = STATE(2496),
    [sym__line_break2] = ACTIONS(4072),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(4072),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [871] = {
    [sym__line_break2] = ACTIONS(1427),
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym__heredoc_body_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_DOT] = ACTIONS(1427),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1427),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1427),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_end] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_then] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1427),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [872] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2497),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(2497),
    [sym_operator_assignment] = STATE(2497),
    [sym_conditional] = STATE(2497),
    [sym_range] = STATE(2497),
    [sym_binary] = STATE(2497),
    [sym_unary] = STATE(2497),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [873] = {
    [sym_heredoc_body] = STATE(2498),
    [sym__terminator] = STATE(2498),
    [sym__line_break2] = ACTIONS(4074),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(4074),
    [sym_comment] = ACTIONS(87),
  },
  [874] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(2499),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4076),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [875] = {
    [sym_constant] = ACTIONS(4078),
    [sym_identifier] = ACTIONS(4078),
    [sym_comment] = ACTIONS(87),
  },
  [876] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2509),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(2509),
    [sym_operator_assignment] = STATE(2509),
    [sym_conditional] = STATE(2509),
    [sym_range] = STATE(2509),
    [sym_binary] = STATE(2509),
    [sym_unary] = STATE(2509),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [877] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2513),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(2513),
    [sym_operator_assignment] = STATE(2513),
    [sym_conditional] = STATE(2513),
    [sym_range] = STATE(2513),
    [sym_binary] = STATE(2513),
    [sym_unary] = STATE(2513),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [878] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2514),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(2514),
    [sym_operator_assignment] = STATE(2514),
    [sym_conditional] = STATE(2514),
    [sym_range] = STATE(2514),
    [sym_binary] = STATE(2514),
    [sym_unary] = STATE(2514),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [879] = {
    [anon_sym_COLON] = ACTIONS(4098),
    [sym_comment] = ACTIONS(87),
  },
  [880] = {
    [sym__statements] = STATE(2407),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2408),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1349),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1350),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4100),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [881] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2518),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(2518),
    [sym_operator_assignment] = STATE(2518),
    [sym_conditional] = STATE(2518),
    [sym_range] = STATE(2518),
    [sym_binary] = STATE(2518),
    [sym_unary] = STATE(2518),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [882] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(2525),
    [sym__argument] = STATE(2526),
    [sym_splat_argument] = STATE(2526),
    [sym_hash_splat_argument] = STATE(2526),
    [sym_block_argument] = STATE(2526),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2526),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [883] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(2525),
    [sym__argument] = STATE(2526),
    [sym_splat_argument] = STATE(2526),
    [sym_hash_splat_argument] = STATE(2526),
    [sym_block_argument] = STATE(2526),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2526),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [884] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(2525),
    [sym__argument] = STATE(2526),
    [sym_splat_argument] = STATE(2526),
    [sym_hash_splat_argument] = STATE(2526),
    [sym_block_argument] = STATE(2526),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2526),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [885] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(2525),
    [sym__argument] = STATE(2526),
    [sym_splat_argument] = STATE(2526),
    [sym_hash_splat_argument] = STATE(2526),
    [sym_block_argument] = STATE(2526),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2526),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [886] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2528),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(2528),
    [sym_operator_assignment] = STATE(2528),
    [sym_conditional] = STATE(2528),
    [sym_range] = STATE(2528),
    [sym_binary] = STATE(2528),
    [sym_unary] = STATE(2528),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [887] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(2529),
    [sym_operator_assignment] = STATE(2529),
    [sym_conditional] = STATE(2529),
    [sym_range] = STATE(2529),
    [sym_binary] = STATE(2529),
    [sym_unary] = STATE(2529),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [888] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [889] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4112),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [890] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4126),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4134),
    [anon_sym_or] = ACTIONS(4134),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [891] = {
    [sym_heredoc_body] = STATE(2543),
    [aux_sym_call_repeat1] = STATE(2543),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [892] = {
    [sym_heredoc_body] = STATE(2543),
    [aux_sym_call_repeat1] = STATE(2543),
    [aux_sym_argument_list_repeat1] = STATE(2545),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [893] = {
    [anon_sym_EQ] = ACTIONS(4150),
    [sym_comment] = ACTIONS(87),
  },
  [894] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4152),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4154),
    [anon_sym_DASH_EQ] = ACTIONS(4154),
    [anon_sym_STAR_EQ] = ACTIONS(4154),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4154),
    [anon_sym_SLASH_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_PIPE_EQ] = ACTIONS(4154),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4154),
    [anon_sym_AMP_EQ] = ACTIONS(4154),
    [anon_sym_PERCENT_EQ] = ACTIONS(4154),
    [anon_sym_GT_GT_EQ] = ACTIONS(4154),
    [anon_sym_LT_LT_EQ] = ACTIONS(4154),
    [anon_sym_CARET_EQ] = ACTIONS(4154),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [895] = {
    [sym_string] = STATE(2548),
    [aux_sym_chained_string_repeat1] = STATE(2548),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4156),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [896] = {
    [sym__line_break2] = ACTIONS(4158),
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [ts_builtin_sym_end] = ACTIONS(4158),
    [anon_sym___END__] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4158),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_end] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_when] = ACTIONS(4158),
    [anon_sym_elsif] = ACTIONS(4158),
    [anon_sym_else] = ACTIONS(4158),
    [anon_sym_then] = ACTIONS(4158),
    [anon_sym_ensure] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_LT_LT] = ACTIONS(4158),
    [anon_sym_GT_GT] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_SLASH] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(87),
  },
  [897] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(2549),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [898] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2550),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(2550),
    [sym_operator_assignment] = STATE(2550),
    [sym_conditional] = STATE(2550),
    [sym_range] = STATE(2550),
    [sym_binary] = STATE(2550),
    [sym_unary] = STATE(2550),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [899] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2551),
    [sym__argument] = STATE(2552),
    [sym_splat_argument] = STATE(2552),
    [sym_hash_splat_argument] = STATE(2552),
    [sym_block_argument] = STATE(2552),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2552),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [900] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(2551),
    [sym__argument] = STATE(2552),
    [sym_splat_argument] = STATE(2552),
    [sym_hash_splat_argument] = STATE(2552),
    [sym_block_argument] = STATE(2552),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2552),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [901] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(2551),
    [sym__argument] = STATE(2552),
    [sym_splat_argument] = STATE(2552),
    [sym_hash_splat_argument] = STATE(2552),
    [sym_block_argument] = STATE(2552),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2552),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [902] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(2551),
    [sym__argument] = STATE(2552),
    [sym_splat_argument] = STATE(2552),
    [sym_hash_splat_argument] = STATE(2552),
    [sym_block_argument] = STATE(2552),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2552),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(397),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [903] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2553),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(2553),
    [sym_operator_assignment] = STATE(2553),
    [sym_conditional] = STATE(2553),
    [sym_range] = STATE(2553),
    [sym_binary] = STATE(2553),
    [sym_unary] = STATE(2553),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [904] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2554),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(2554),
    [sym_operator_assignment] = STATE(2554),
    [sym_conditional] = STATE(2554),
    [sym_range] = STATE(2554),
    [sym_binary] = STATE(2554),
    [sym_unary] = STATE(2554),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [905] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [906] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(4164),
    [anon_sym___END__] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [907] = {
    [anon_sym_EQ] = ACTIONS(4198),
    [sym_comment] = ACTIONS(87),
  },
  [908] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4200),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4202),
    [anon_sym_DASH_EQ] = ACTIONS(4202),
    [anon_sym_STAR_EQ] = ACTIONS(4202),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4202),
    [anon_sym_SLASH_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_PIPE_EQ] = ACTIONS(4202),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4202),
    [anon_sym_AMP_EQ] = ACTIONS(4202),
    [anon_sym_PERCENT_EQ] = ACTIONS(4202),
    [anon_sym_GT_GT_EQ] = ACTIONS(4202),
    [anon_sym_LT_LT_EQ] = ACTIONS(4202),
    [anon_sym_CARET_EQ] = ACTIONS(4202),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [909] = {
    [sym_string] = STATE(2569),
    [aux_sym_chained_string_repeat1] = STATE(2569),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [910] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(4204),
    [anon_sym___END__] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [911] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [912] = {
    [sym_string] = STATE(986),
    [aux_sym_chained_string_repeat1] = STATE(986),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [913] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2570),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(2570),
    [sym_operator_assignment] = STATE(2570),
    [sym_conditional] = STATE(2570),
    [sym_range] = STATE(2570),
    [sym_binary] = STATE(2570),
    [sym_unary] = STATE(2570),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [914] = {
    [sym__line_break2] = ACTIONS(1427),
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym__heredoc_body_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [ts_builtin_sym_end] = ACTIONS(1427),
    [anon_sym___END__] = ACTIONS(1429),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_end] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_rescue] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_when] = ACTIONS(1429),
    [anon_sym_elsif] = ACTIONS(1429),
    [anon_sym_else] = ACTIONS(1429),
    [anon_sym_then] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_ensure] = ACTIONS(1429),
    [anon_sym_EQ_GT] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [915] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [916] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2571),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2571),
    [sym_operator_assignment] = STATE(2571),
    [sym_conditional] = STATE(2571),
    [sym_range] = STATE(2571),
    [sym_binary] = STATE(2571),
    [sym_unary] = STATE(2571),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [917] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2572),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2572),
    [sym_operator_assignment] = STATE(2572),
    [sym_conditional] = STATE(2572),
    [sym_range] = STATE(2572),
    [sym_binary] = STATE(2572),
    [sym_unary] = STATE(2572),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [918] = {
    [anon_sym_COLON] = ACTIONS(4210),
    [sym_comment] = ACTIONS(87),
  },
  [919] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2574),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2574),
    [sym_operator_assignment] = STATE(2574),
    [sym_conditional] = STATE(2574),
    [sym_range] = STATE(2574),
    [sym_binary] = STATE(2574),
    [sym_unary] = STATE(2574),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [920] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym___END__] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4212),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [921] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym___END__] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [922] = {
    [sym_heredoc_body] = STATE(2576),
    [aux_sym_call_repeat1] = STATE(2576),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [923] = {
    [sym_heredoc_body] = STATE(2576),
    [aux_sym_call_repeat1] = STATE(2576),
    [aux_sym_argument_list_repeat1] = STATE(2578),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [924] = {
    [sym_string] = STATE(986),
    [aux_sym_chained_string_repeat1] = STATE(986),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4216),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [925] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2587),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(2587),
    [sym_operator_assignment] = STATE(2587),
    [sym_conditional] = STATE(2587),
    [sym_range] = STATE(2587),
    [sym_binary] = STATE(2587),
    [sym_unary] = STATE(2587),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [926] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2592),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(2592),
    [sym_operator_assignment] = STATE(2592),
    [sym_conditional] = STATE(2592),
    [sym_range] = STATE(2592),
    [sym_binary] = STATE(2592),
    [sym_unary] = STATE(2592),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [927] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2593),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(2593),
    [sym_operator_assignment] = STATE(2593),
    [sym_conditional] = STATE(2593),
    [sym_range] = STATE(2593),
    [sym_binary] = STATE(2593),
    [sym_unary] = STATE(2593),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [928] = {
    [anon_sym_COLON] = ACTIONS(4240),
    [sym_comment] = ACTIONS(87),
  },
  [929] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_end] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_when] = ACTIONS(4242),
    [anon_sym_elsif] = ACTIONS(4242),
    [anon_sym_else] = ACTIONS(4242),
    [anon_sym_then] = ACTIONS(4242),
    [anon_sym_ensure] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4242),
    [anon_sym_AMP_AMP] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
  },
  [930] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2596),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(2596),
    [sym_operator_assignment] = STATE(2596),
    [sym_conditional] = STATE(2596),
    [sym_range] = STATE(2596),
    [sym_binary] = STATE(2596),
    [sym_unary] = STATE(2596),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [931] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(2603),
    [sym__argument] = STATE(2604),
    [sym_splat_argument] = STATE(2604),
    [sym_hash_splat_argument] = STATE(2604),
    [sym_block_argument] = STATE(2604),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2604),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [932] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(2603),
    [sym__argument] = STATE(2604),
    [sym_splat_argument] = STATE(2604),
    [sym_hash_splat_argument] = STATE(2604),
    [sym_block_argument] = STATE(2604),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2604),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [933] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(2603),
    [sym__argument] = STATE(2604),
    [sym_splat_argument] = STATE(2604),
    [sym_hash_splat_argument] = STATE(2604),
    [sym_block_argument] = STATE(2604),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2604),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [934] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(2603),
    [sym__argument] = STATE(2604),
    [sym_splat_argument] = STATE(2604),
    [sym_hash_splat_argument] = STATE(2604),
    [sym_block_argument] = STATE(2604),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(2604),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [935] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2606),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(2606),
    [sym_operator_assignment] = STATE(2606),
    [sym_conditional] = STATE(2606),
    [sym_range] = STATE(2606),
    [sym_binary] = STATE(2606),
    [sym_unary] = STATE(2606),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [936] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2607),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(2607),
    [sym_operator_assignment] = STATE(2607),
    [sym_conditional] = STATE(2607),
    [sym_range] = STATE(2607),
    [sym_binary] = STATE(2607),
    [sym_unary] = STATE(2607),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [937] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1398),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(1398),
    [sym_operator_assignment] = STATE(1398),
    [sym_conditional] = STATE(1398),
    [sym_range] = STATE(1398),
    [sym_binary] = STATE(1398),
    [sym_unary] = STATE(1398),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [938] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4254),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [939] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(4268),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(4276),
    [anon_sym_or] = ACTIONS(4276),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [940] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [941] = {
    [sym_heredoc_body] = STATE(2631),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(4298),
    [sym_comment] = ACTIONS(87),
  },
  [942] = {
    [sym__heredoc_body_start2] = ACTIONS(2483),
    [anon_sym_RPAREN] = ACTIONS(2483),
    [anon_sym_COMMA] = ACTIONS(4300),
    [sym_comment] = ACTIONS(87),
  },
  [943] = {
    [anon_sym_EQ] = ACTIONS(4302),
    [sym_comment] = ACTIONS(87),
  },
  [944] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4304),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4306),
    [anon_sym_DASH_EQ] = ACTIONS(4306),
    [anon_sym_STAR_EQ] = ACTIONS(4306),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4306),
    [anon_sym_SLASH_EQ] = ACTIONS(4306),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4306),
    [anon_sym_PIPE_EQ] = ACTIONS(4306),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4306),
    [anon_sym_AMP_EQ] = ACTIONS(4306),
    [anon_sym_PERCENT_EQ] = ACTIONS(4306),
    [anon_sym_GT_GT_EQ] = ACTIONS(4306),
    [anon_sym_LT_LT_EQ] = ACTIONS(4306),
    [anon_sym_CARET_EQ] = ACTIONS(4306),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [945] = {
    [sym_string] = STATE(2635),
    [aux_sym_chained_string_repeat1] = STATE(2635),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4308),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [946] = {
    [anon_sym_RPAREN] = ACTIONS(4298),
    [sym_comment] = ACTIONS(87),
  },
  [947] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [948] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [949] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [950] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2636),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2636),
    [sym_operator_assignment] = STATE(2636),
    [sym_conditional] = STATE(2636),
    [sym_range] = STATE(2636),
    [sym_binary] = STATE(2636),
    [sym_unary] = STATE(2636),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [951] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2637),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2637),
    [sym_operator_assignment] = STATE(2637),
    [sym_conditional] = STATE(2637),
    [sym_range] = STATE(2637),
    [sym_binary] = STATE(2637),
    [sym_unary] = STATE(2637),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [952] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2638),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2638),
    [sym_operator_assignment] = STATE(2638),
    [sym_conditional] = STATE(2638),
    [sym_range] = STATE(2638),
    [sym_binary] = STATE(2638),
    [sym_unary] = STATE(2638),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [953] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2639),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2639),
    [sym_operator_assignment] = STATE(2639),
    [sym_conditional] = STATE(2639),
    [sym_range] = STATE(2639),
    [sym_binary] = STATE(2639),
    [sym_unary] = STATE(2639),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [954] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2640),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2640),
    [sym_operator_assignment] = STATE(2640),
    [sym_conditional] = STATE(2640),
    [sym_range] = STATE(2640),
    [sym_binary] = STATE(2640),
    [sym_unary] = STATE(2640),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [955] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2641),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2641),
    [sym_operator_assignment] = STATE(2641),
    [sym_conditional] = STATE(2641),
    [sym_range] = STATE(2641),
    [sym_binary] = STATE(2641),
    [sym_unary] = STATE(2641),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [956] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2642),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(2642),
    [sym_operator_assignment] = STATE(2642),
    [sym_conditional] = STATE(2642),
    [sym_range] = STATE(2642),
    [sym_binary] = STATE(2642),
    [sym_unary] = STATE(2642),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [957] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2643),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(2643),
    [sym_operator_assignment] = STATE(2643),
    [sym_conditional] = STATE(2643),
    [sym_range] = STATE(2643),
    [sym_binary] = STATE(2643),
    [sym_unary] = STATE(2643),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [958] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2644),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2644),
    [sym_operator_assignment] = STATE(2644),
    [sym_conditional] = STATE(2644),
    [sym_range] = STATE(2644),
    [sym_binary] = STATE(2644),
    [sym_unary] = STATE(2644),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [959] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2645),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2645),
    [sym_operator_assignment] = STATE(2645),
    [sym_conditional] = STATE(2645),
    [sym_range] = STATE(2645),
    [sym_binary] = STATE(2645),
    [sym_unary] = STATE(2645),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [960] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2646),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2646),
    [sym_operator_assignment] = STATE(2646),
    [sym_conditional] = STATE(2646),
    [sym_range] = STATE(2646),
    [sym_binary] = STATE(2646),
    [sym_unary] = STATE(2646),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [961] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2647),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2647),
    [sym_operator_assignment] = STATE(2647),
    [sym_conditional] = STATE(2647),
    [sym_range] = STATE(2647),
    [sym_binary] = STATE(2647),
    [sym_unary] = STATE(2647),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [962] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2648),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2648),
    [sym_operator_assignment] = STATE(2648),
    [sym_conditional] = STATE(2648),
    [sym_range] = STATE(2648),
    [sym_binary] = STATE(2648),
    [sym_unary] = STATE(2648),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [963] = {
    [sym_argument_list_with_parens] = STATE(2651),
    [sym__argument_list_with_parens] = STATE(2652),
    [sym_operator] = STATE(2651),
    [sym_heredoc_body] = STATE(2653),
    [aux_sym_call_repeat1] = STATE(2653),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(4310),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_STAR_STAR] = ACTIONS(4310),
    [anon_sym_AMP] = ACTIONS(4310),
    [anon_sym_LT] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(4314),
    [anon_sym_DOT_DOT] = ACTIONS(4310),
    [anon_sym_LT_LT] = ACTIONS(4310),
    [anon_sym_GT_GT] = ACTIONS(4310),
    [anon_sym_EQ_EQ] = ACTIONS(4312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4310),
    [anon_sym_LT_EQ_GT] = ACTIONS(4310),
    [anon_sym_EQ_TILDE] = ACTIONS(4310),
    [anon_sym_BANG_TILDE] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(4312),
    [anon_sym_GT] = ACTIONS(4312),
    [anon_sym_GT_EQ] = ACTIONS(4310),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4312),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_PERCENT] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(4312),
    [anon_sym_TILDE] = ACTIONS(4310),
    [sym_constant] = ACTIONS(4316),
    [sym_identifier] = ACTIONS(4316),
    [anon_sym_DASH] = ACTIONS(4312),
    [anon_sym_PLUS_AT] = ACTIONS(4310),
    [anon_sym_DASH_AT] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4312),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4310),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [sym_comment] = ACTIONS(87),
  },
  [964] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(2655),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2656),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(4318),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [965] = {
    [sym_constant] = ACTIONS(4320),
    [sym_identifier] = ACTIONS(4320),
    [sym_comment] = ACTIONS(87),
  },
  [966] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2658),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(2658),
    [sym_operator_assignment] = STATE(2658),
    [sym_conditional] = STATE(2658),
    [sym_range] = STATE(2658),
    [sym_binary] = STATE(2658),
    [sym_unary] = STATE(2658),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [967] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2659),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(2659),
    [sym_operator_assignment] = STATE(2659),
    [sym_conditional] = STATE(2659),
    [sym_range] = STATE(2659),
    [sym_binary] = STATE(2659),
    [sym_unary] = STATE(2659),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [968] = {
    [anon_sym_COLON] = ACTIONS(4322),
    [sym_comment] = ACTIONS(87),
  },
  [969] = {
    [sym__statements] = STATE(2662),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2663),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4324),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [970] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2664),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(2664),
    [sym_operator_assignment] = STATE(2664),
    [sym_conditional] = STATE(2664),
    [sym_range] = STATE(2664),
    [sym_binary] = STATE(2664),
    [sym_unary] = STATE(2664),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [971] = {
    [sym__statements] = STATE(2666),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2667),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2668),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(2668),
    [sym__line_break2] = ACTIONS(4326),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4328),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [972] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(2670),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(2671),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(4330),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [973] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [ts_builtin_sym_end] = ACTIONS(1093),
    [anon_sym___END__] = ACTIONS(1095),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4332),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [974] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(1641),
    [anon_sym___END__] = ACTIONS(1641),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [975] = {
    [sym_do_block] = STATE(2673),
    [sym_block] = STATE(2673),
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(4334),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [976] = {
    [sym_heredoc_body] = STATE(2675),
    [aux_sym_call_repeat1] = STATE(2675),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [977] = {
    [sym_heredoc_body] = STATE(2675),
    [aux_sym_call_repeat1] = STATE(2675),
    [aux_sym_argument_list_repeat1] = STATE(2677),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4338),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [978] = {
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [979] = {
    [sym_string] = STATE(1661),
    [aux_sym_chained_string_repeat1] = STATE(1661),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4340),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [980] = {
    [sym_interpolation] = STATE(2679),
    [aux_sym_heredoc_body_repeat1] = STATE(2679),
    [sym__heredoc_content2] = ACTIONS(4342),
    [sym_heredoc_end2] = ACTIONS(4344),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(4342),
  },
  [981] = {
    [sym_heredoc_body] = STATE(2680),
    [aux_sym_call_repeat1] = STATE(2680),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [982] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2683),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4352),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [983] = {
    [sym_heredoc_body] = STATE(2684),
    [aux_sym_call_repeat1] = STATE(2684),
    [aux_sym_argument_list_repeat1] = STATE(2685),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [984] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2686),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_splat_argument] = STATE(2688),
    [sym_assignment] = STATE(2686),
    [sym_operator_assignment] = STATE(2686),
    [sym_conditional] = STATE(2686),
    [sym_range] = STATE(2686),
    [sym_binary] = STATE(2686),
    [sym_unary] = STATE(2686),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(2688),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [985] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2689),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(2689),
    [sym_operator_assignment] = STATE(2689),
    [sym_conditional] = STATE(2689),
    [sym_range] = STATE(2689),
    [sym_binary] = STATE(2689),
    [sym_unary] = STATE(2689),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [986] = {
    [sym_string] = STATE(2690),
    [aux_sym_chained_string_repeat1] = STATE(2690),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [anon_sym___END__] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [987] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [988] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2699),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(2699),
    [sym_operator_assignment] = STATE(2699),
    [sym_conditional] = STATE(2699),
    [sym_range] = STATE(2699),
    [sym_binary] = STATE(2699),
    [sym_unary] = STATE(2699),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [989] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2703),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(2703),
    [sym_operator_assignment] = STATE(2703),
    [sym_conditional] = STATE(2703),
    [sym_range] = STATE(2703),
    [sym_binary] = STATE(2703),
    [sym_unary] = STATE(2703),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [990] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2704),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(2704),
    [sym_operator_assignment] = STATE(2704),
    [sym_conditional] = STATE(2704),
    [sym_range] = STATE(2704),
    [sym_binary] = STATE(2704),
    [sym_unary] = STATE(2704),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [991] = {
    [anon_sym_COLON] = ACTIONS(4374),
    [sym_comment] = ACTIONS(87),
  },
  [992] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2707),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(2707),
    [sym_operator_assignment] = STATE(2707),
    [sym_conditional] = STATE(2707),
    [sym_range] = STATE(2707),
    [sym_binary] = STATE(2707),
    [sym_unary] = STATE(2707),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [993] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2714),
    [sym__argument] = STATE(2715),
    [sym_splat_argument] = STATE(2715),
    [sym_hash_splat_argument] = STATE(2715),
    [sym_block_argument] = STATE(2715),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2715),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [994] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(2714),
    [sym__argument] = STATE(2715),
    [sym_splat_argument] = STATE(2715),
    [sym_hash_splat_argument] = STATE(2715),
    [sym_block_argument] = STATE(2715),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2715),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [995] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(2714),
    [sym__argument] = STATE(2715),
    [sym_splat_argument] = STATE(2715),
    [sym_hash_splat_argument] = STATE(2715),
    [sym_block_argument] = STATE(2715),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2715),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [996] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(2714),
    [sym__argument] = STATE(2715),
    [sym_splat_argument] = STATE(2715),
    [sym_hash_splat_argument] = STATE(2715),
    [sym_block_argument] = STATE(2715),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2715),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [997] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2717),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(2717),
    [sym_operator_assignment] = STATE(2717),
    [sym_conditional] = STATE(2717),
    [sym_range] = STATE(2717),
    [sym_binary] = STATE(2717),
    [sym_unary] = STATE(2717),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [998] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2718),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(2718),
    [sym_operator_assignment] = STATE(2718),
    [sym_conditional] = STATE(2718),
    [sym_range] = STATE(2718),
    [sym_binary] = STATE(2718),
    [sym_unary] = STATE(2718),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [999] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1000] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4384),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1001] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4398),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [1002] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1003] = {
    [sym_heredoc_body] = STATE(2741),
    [aux_sym_call_repeat1] = STATE(2741),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1004] = {
    [sym_heredoc_body] = STATE(2741),
    [aux_sym_call_repeat1] = STATE(2741),
    [aux_sym_argument_list_repeat1] = STATE(2743),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1005] = {
    [anon_sym_EQ] = ACTIONS(4428),
    [sym_comment] = ACTIONS(87),
  },
  [1006] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4430),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4432),
    [anon_sym_DASH_EQ] = ACTIONS(4432),
    [anon_sym_STAR_EQ] = ACTIONS(4432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4432),
    [anon_sym_SLASH_EQ] = ACTIONS(4432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4432),
    [anon_sym_PIPE_EQ] = ACTIONS(4432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4432),
    [anon_sym_AMP_EQ] = ACTIONS(4432),
    [anon_sym_PERCENT_EQ] = ACTIONS(4432),
    [anon_sym_GT_GT_EQ] = ACTIONS(4432),
    [anon_sym_LT_LT_EQ] = ACTIONS(4432),
    [anon_sym_CARET_EQ] = ACTIONS(4432),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1007] = {
    [sym_string] = STATE(2746),
    [aux_sym_chained_string_repeat1] = STATE(2746),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4434),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1008] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1009] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [1010] = {
    [aux_sym_undef_repeat1] = STATE(2747),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_then] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [1011] = {
    [sym_interpolation] = STATE(2749),
    [aux_sym_heredoc_body_repeat1] = STATE(2749),
    [sym__heredoc_content2] = ACTIONS(4436),
    [sym_heredoc_end2] = ACTIONS(4438),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(4436),
  },
  [1012] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2750),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2750),
    [sym_operator_assignment] = STATE(2750),
    [sym_conditional] = STATE(2750),
    [sym_range] = STATE(2750),
    [sym_binary] = STATE(2750),
    [sym_unary] = STATE(2750),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1013] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2751),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2751),
    [sym_operator_assignment] = STATE(2751),
    [sym_conditional] = STATE(2751),
    [sym_range] = STATE(2751),
    [sym_binary] = STATE(2751),
    [sym_unary] = STATE(2751),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1014] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2752),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2752),
    [sym_operator_assignment] = STATE(2752),
    [sym_conditional] = STATE(2752),
    [sym_range] = STATE(2752),
    [sym_binary] = STATE(2752),
    [sym_unary] = STATE(2752),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1015] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2753),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2753),
    [sym_operator_assignment] = STATE(2753),
    [sym_conditional] = STATE(2753),
    [sym_range] = STATE(2753),
    [sym_binary] = STATE(2753),
    [sym_unary] = STATE(2753),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1016] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2754),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2754),
    [sym_operator_assignment] = STATE(2754),
    [sym_conditional] = STATE(2754),
    [sym_range] = STATE(2754),
    [sym_binary] = STATE(2754),
    [sym_unary] = STATE(2754),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1017] = {
    [sym__statements] = STATE(2767),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(2770),
    [sym_else] = STATE(2770),
    [sym__if_tail] = STATE(2770),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(2776),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(2776),
    [sym__line_break2] = ACTIONS(4440),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4444),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1018] = {
    [sym__line_break2] = ACTIONS(4472),
    [sym__simple_symbol2] = ACTIONS(4472),
    [sym__string_start2] = ACTIONS(4472),
    [sym__symbol_start2] = ACTIONS(4472),
    [sym__subshell_start2] = ACTIONS(4472),
    [sym__regex_start2] = ACTIONS(4472),
    [sym__string_array_start2] = ACTIONS(4472),
    [sym__symbol_array_start2] = ACTIONS(4472),
    [sym__heredoc_body_start2] = ACTIONS(4472),
    [sym_heredoc_beginning2] = ACTIONS(4472),
    [sym__unary_minus2] = ACTIONS(4472),
    [anon_sym_BEGIN] = ACTIONS(4474),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_END] = ACTIONS(4474),
    [anon_sym_def] = ACTIONS(4474),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_COLON_COLON] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_class] = ACTIONS(4474),
    [anon_sym_module] = ACTIONS(4474),
    [anon_sym_end] = ACTIONS(4474),
    [anon_sym_return] = ACTIONS(4474),
    [anon_sym_yield] = ACTIONS(4474),
    [anon_sym_break] = ACTIONS(4474),
    [anon_sym_next] = ACTIONS(4474),
    [sym_redo] = ACTIONS(4474),
    [sym_retry] = ACTIONS(4474),
    [anon_sym_if] = ACTIONS(4474),
    [anon_sym_unless] = ACTIONS(4474),
    [anon_sym_while] = ACTIONS(4474),
    [anon_sym_until] = ACTIONS(4474),
    [anon_sym_for] = ACTIONS(4474),
    [anon_sym_case] = ACTIONS(4474),
    [anon_sym_elsif] = ACTIONS(4474),
    [anon_sym_else] = ACTIONS(4474),
    [anon_sym_then] = ACTIONS(4476),
    [anon_sym_begin] = ACTIONS(4474),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_defined_QMARK] = ACTIONS(4472),
    [anon_sym_not] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [sym_constant] = ACTIONS(4474),
    [sym_identifier] = ACTIONS(4474),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(4474),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_complex] = ACTIONS(4472),
    [sym_super] = ACTIONS(4474),
    [anon_sym_true] = ACTIONS(4474),
    [anon_sym_TRUE] = ACTIONS(4474),
    [anon_sym_false] = ACTIONS(4474),
    [anon_sym_FALSE] = ACTIONS(4474),
    [sym_self] = ACTIONS(4474),
    [anon_sym_nil] = ACTIONS(4474),
    [anon_sym_NIL] = ACTIONS(4474),
    [sym_character] = ACTIONS(4472),
    [anon_sym_LBRACK2] = ACTIONS(4472),
    [anon_sym_DASH_GT] = ACTIONS(4472),
  },
  [1019] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2778),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2778),
    [sym_operator_assignment] = STATE(2778),
    [sym_conditional] = STATE(2778),
    [sym_range] = STATE(2778),
    [sym_binary] = STATE(2778),
    [sym_unary] = STATE(2778),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1020] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2779),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2779),
    [sym_operator_assignment] = STATE(2779),
    [sym_conditional] = STATE(2779),
    [sym_range] = STATE(2779),
    [sym_binary] = STATE(2779),
    [sym_unary] = STATE(2779),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1021] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2780),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2780),
    [sym_operator_assignment] = STATE(2780),
    [sym_conditional] = STATE(2780),
    [sym_range] = STATE(2780),
    [sym_binary] = STATE(2780),
    [sym_unary] = STATE(2780),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1022] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2781),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2781),
    [sym_operator_assignment] = STATE(2781),
    [sym_conditional] = STATE(2781),
    [sym_range] = STATE(2781),
    [sym_binary] = STATE(2781),
    [sym_unary] = STATE(2781),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1023] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2782),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2782),
    [sym_operator_assignment] = STATE(2782),
    [sym_conditional] = STATE(2782),
    [sym_range] = STATE(2782),
    [sym_binary] = STATE(2782),
    [sym_unary] = STATE(2782),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1024] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2783),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2783),
    [sym_operator_assignment] = STATE(2783),
    [sym_conditional] = STATE(2783),
    [sym_range] = STATE(2783),
    [sym_binary] = STATE(2783),
    [sym_unary] = STATE(2783),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1025] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2784),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(2784),
    [sym_operator_assignment] = STATE(2784),
    [sym_conditional] = STATE(2784),
    [sym_range] = STATE(2784),
    [sym_binary] = STATE(2784),
    [sym_unary] = STATE(2784),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1026] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2785),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2785),
    [sym_operator_assignment] = STATE(2785),
    [sym_conditional] = STATE(2785),
    [sym_range] = STATE(2785),
    [sym_binary] = STATE(2785),
    [sym_unary] = STATE(2785),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1027] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2786),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2786),
    [sym_operator_assignment] = STATE(2786),
    [sym_conditional] = STATE(2786),
    [sym_range] = STATE(2786),
    [sym_binary] = STATE(2786),
    [sym_unary] = STATE(2786),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1028] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2787),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2787),
    [sym_operator_assignment] = STATE(2787),
    [sym_conditional] = STATE(2787),
    [sym_range] = STATE(2787),
    [sym_binary] = STATE(2787),
    [sym_unary] = STATE(2787),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1029] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2788),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2788),
    [sym_operator_assignment] = STATE(2788),
    [sym_conditional] = STATE(2788),
    [sym_range] = STATE(2788),
    [sym_binary] = STATE(2788),
    [sym_unary] = STATE(2788),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1030] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2789),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2789),
    [sym_operator_assignment] = STATE(2789),
    [sym_conditional] = STATE(2789),
    [sym_range] = STATE(2789),
    [sym_binary] = STATE(2789),
    [sym_unary] = STATE(2789),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1031] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2798),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(2798),
    [sym_operator_assignment] = STATE(2798),
    [sym_conditional] = STATE(2798),
    [sym_range] = STATE(2798),
    [sym_binary] = STATE(2798),
    [sym_unary] = STATE(2798),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1032] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2803),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(2803),
    [sym_operator_assignment] = STATE(2803),
    [sym_conditional] = STATE(2803),
    [sym_range] = STATE(2803),
    [sym_binary] = STATE(2803),
    [sym_unary] = STATE(2803),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1033] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2804),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(2804),
    [sym_operator_assignment] = STATE(2804),
    [sym_conditional] = STATE(2804),
    [sym_range] = STATE(2804),
    [sym_binary] = STATE(2804),
    [sym_unary] = STATE(2804),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1034] = {
    [anon_sym_COLON] = ACTIONS(4502),
    [sym_comment] = ACTIONS(87),
  },
  [1035] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2807),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(2807),
    [sym_operator_assignment] = STATE(2807),
    [sym_conditional] = STATE(2807),
    [sym_range] = STATE(2807),
    [sym_binary] = STATE(2807),
    [sym_unary] = STATE(2807),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1036] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1037] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1038] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1039] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1040] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2808),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(2808),
    [sym_operator_assignment] = STATE(2808),
    [sym_conditional] = STATE(2808),
    [sym_range] = STATE(2808),
    [sym_binary] = STATE(2808),
    [sym_unary] = STATE(2808),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1041] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2809),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(2809),
    [sym_operator_assignment] = STATE(2809),
    [sym_conditional] = STATE(2809),
    [sym_range] = STATE(2809),
    [sym_binary] = STATE(2809),
    [sym_unary] = STATE(2809),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1042] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1043] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4504),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1044] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4518),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [1045] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(2738),
    [sym__argument] = STATE(2739),
    [sym_splat_argument] = STATE(2739),
    [sym_hash_splat_argument] = STATE(2739),
    [sym_block_argument] = STATE(2739),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2739),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1046] = {
    [sym_heredoc_body] = STATE(2823),
    [aux_sym_call_repeat1] = STATE(2823),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1047] = {
    [sym_heredoc_body] = STATE(2823),
    [aux_sym_call_repeat1] = STATE(2823),
    [aux_sym_argument_list_repeat1] = STATE(2825),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1048] = {
    [anon_sym_EQ] = ACTIONS(4538),
    [sym_comment] = ACTIONS(87),
  },
  [1049] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4540),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4542),
    [anon_sym_DASH_EQ] = ACTIONS(4542),
    [anon_sym_STAR_EQ] = ACTIONS(4542),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4542),
    [anon_sym_SLASH_EQ] = ACTIONS(4542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4542),
    [anon_sym_PIPE_EQ] = ACTIONS(4542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4542),
    [anon_sym_AMP_EQ] = ACTIONS(4542),
    [anon_sym_PERCENT_EQ] = ACTIONS(4542),
    [anon_sym_GT_GT_EQ] = ACTIONS(4542),
    [anon_sym_LT_LT_EQ] = ACTIONS(4542),
    [anon_sym_CARET_EQ] = ACTIONS(4542),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1050] = {
    [sym_string] = STATE(2828),
    [aux_sym_chained_string_repeat1] = STATE(2828),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4544),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1051] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2834),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_splat_argument] = STATE(2835),
    [sym_assignment] = STATE(2834),
    [sym_operator_assignment] = STATE(2834),
    [sym_conditional] = STATE(2834),
    [sym_range] = STATE(2834),
    [sym_binary] = STATE(2834),
    [sym_unary] = STATE(2834),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(2835),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4546),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1052] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2838),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(2838),
    [sym_operator_assignment] = STATE(2838),
    [sym_conditional] = STATE(2838),
    [sym_range] = STATE(2838),
    [sym_binary] = STATE(2838),
    [sym_unary] = STATE(2838),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1053] = {
    [sym_string] = STATE(2839),
    [aux_sym_chained_string_repeat1] = STATE(2839),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1054] = {
    [sym__statements] = STATE(2850),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2853),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4560),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1055] = {
    [sym__simple_symbol2] = ACTIONS(4472),
    [sym__string_start2] = ACTIONS(4472),
    [sym__symbol_start2] = ACTIONS(4472),
    [sym__subshell_start2] = ACTIONS(4472),
    [sym__regex_start2] = ACTIONS(4472),
    [sym__string_array_start2] = ACTIONS(4472),
    [sym__symbol_array_start2] = ACTIONS(4472),
    [sym_heredoc_beginning2] = ACTIONS(4472),
    [sym__unary_minus2] = ACTIONS(4472),
    [anon_sym_BEGIN] = ACTIONS(4474),
    [anon_sym_LBRACE] = ACTIONS(4472),
    [anon_sym_END] = ACTIONS(4474),
    [anon_sym_def] = ACTIONS(4474),
    [anon_sym_LPAREN] = ACTIONS(4472),
    [anon_sym_COLON_COLON] = ACTIONS(4472),
    [anon_sym_SEMI] = ACTIONS(4472),
    [anon_sym_STAR] = ACTIONS(4472),
    [anon_sym_class] = ACTIONS(4474),
    [anon_sym_module] = ACTIONS(4474),
    [anon_sym_end] = ACTIONS(4474),
    [anon_sym_return] = ACTIONS(4474),
    [anon_sym_yield] = ACTIONS(4474),
    [anon_sym_break] = ACTIONS(4474),
    [anon_sym_next] = ACTIONS(4474),
    [sym_redo] = ACTIONS(4474),
    [sym_retry] = ACTIONS(4474),
    [anon_sym_if] = ACTIONS(4474),
    [anon_sym_unless] = ACTIONS(4474),
    [anon_sym_while] = ACTIONS(4474),
    [anon_sym_until] = ACTIONS(4474),
    [anon_sym_rescue] = ACTIONS(4474),
    [anon_sym_for] = ACTIONS(4474),
    [anon_sym_case] = ACTIONS(4474),
    [anon_sym_when] = ACTIONS(4474),
    [anon_sym_elsif] = ACTIONS(4474),
    [anon_sym_else] = ACTIONS(4474),
    [anon_sym_then] = ACTIONS(4584),
    [anon_sym_begin] = ACTIONS(4474),
    [anon_sym_ensure] = ACTIONS(4474),
    [anon_sym_PLUS] = ACTIONS(4474),
    [anon_sym_defined_QMARK] = ACTIONS(4472),
    [anon_sym_not] = ACTIONS(4474),
    [anon_sym_BANG] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4472),
    [sym_constant] = ACTIONS(4474),
    [sym_identifier] = ACTIONS(4474),
    [sym_instance_variable] = ACTIONS(4472),
    [sym_class_variable] = ACTIONS(4472),
    [sym_global_variable] = ACTIONS(4472),
    [anon_sym_undef] = ACTIONS(4474),
    [anon_sym_alias] = ACTIONS(4474),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4474),
    [sym_float] = ACTIONS(4474),
    [sym_complex] = ACTIONS(4472),
    [sym_super] = ACTIONS(4474),
    [anon_sym_true] = ACTIONS(4474),
    [anon_sym_TRUE] = ACTIONS(4474),
    [anon_sym_false] = ACTIONS(4474),
    [anon_sym_FALSE] = ACTIONS(4474),
    [sym_self] = ACTIONS(4474),
    [anon_sym_nil] = ACTIONS(4474),
    [anon_sym_NIL] = ACTIONS(4474),
    [sym_character] = ACTIONS(4472),
    [anon_sym_LBRACK2] = ACTIONS(4472),
    [anon_sym_DASH_GT] = ACTIONS(4472),
  },
  [1056] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1057] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2868),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(2868),
    [sym_operator_assignment] = STATE(2868),
    [sym_conditional] = STATE(2868),
    [sym_range] = STATE(2868),
    [sym_binary] = STATE(2868),
    [sym_unary] = STATE(2868),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1058] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2872),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(2872),
    [sym_operator_assignment] = STATE(2872),
    [sym_conditional] = STATE(2872),
    [sym_range] = STATE(2872),
    [sym_binary] = STATE(2872),
    [sym_unary] = STATE(2872),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1059] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2873),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(2873),
    [sym_operator_assignment] = STATE(2873),
    [sym_conditional] = STATE(2873),
    [sym_range] = STATE(2873),
    [sym_binary] = STATE(2873),
    [sym_unary] = STATE(2873),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1060] = {
    [anon_sym_COLON] = ACTIONS(4606),
    [sym_comment] = ACTIONS(87),
  },
  [1061] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2876),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(2876),
    [sym_operator_assignment] = STATE(2876),
    [sym_conditional] = STATE(2876),
    [sym_range] = STATE(2876),
    [sym_binary] = STATE(2876),
    [sym_unary] = STATE(2876),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1062] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(2883),
    [sym__argument] = STATE(2884),
    [sym_splat_argument] = STATE(2884),
    [sym_hash_splat_argument] = STATE(2884),
    [sym_block_argument] = STATE(2884),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2884),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1063] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(2883),
    [sym__argument] = STATE(2884),
    [sym_splat_argument] = STATE(2884),
    [sym_hash_splat_argument] = STATE(2884),
    [sym_block_argument] = STATE(2884),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2884),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1064] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(2883),
    [sym__argument] = STATE(2884),
    [sym_splat_argument] = STATE(2884),
    [sym_hash_splat_argument] = STATE(2884),
    [sym_block_argument] = STATE(2884),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2884),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1065] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(2883),
    [sym__argument] = STATE(2884),
    [sym_splat_argument] = STATE(2884),
    [sym_hash_splat_argument] = STATE(2884),
    [sym_block_argument] = STATE(2884),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2884),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1066] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2886),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(2886),
    [sym_operator_assignment] = STATE(2886),
    [sym_conditional] = STATE(2886),
    [sym_range] = STATE(2886),
    [sym_binary] = STATE(2886),
    [sym_unary] = STATE(2886),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1067] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2887),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(2887),
    [sym_operator_assignment] = STATE(2887),
    [sym_conditional] = STATE(2887),
    [sym_range] = STATE(2887),
    [sym_binary] = STATE(2887),
    [sym_unary] = STATE(2887),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1068] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1069] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4616),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1070] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4630),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [1071] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(4656),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1072] = {
    [sym_heredoc_body] = STATE(2911),
    [aux_sym_call_repeat1] = STATE(2911),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1073] = {
    [sym_heredoc_body] = STATE(2911),
    [aux_sym_call_repeat1] = STATE(2911),
    [aux_sym_argument_list_repeat1] = STATE(2913),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4660),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1074] = {
    [anon_sym_EQ] = ACTIONS(4662),
    [sym_comment] = ACTIONS(87),
  },
  [1075] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4664),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4666),
    [anon_sym_DASH_EQ] = ACTIONS(4666),
    [anon_sym_STAR_EQ] = ACTIONS(4666),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4666),
    [anon_sym_SLASH_EQ] = ACTIONS(4666),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4666),
    [anon_sym_PIPE_EQ] = ACTIONS(4666),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4666),
    [anon_sym_AMP_EQ] = ACTIONS(4666),
    [anon_sym_PERCENT_EQ] = ACTIONS(4666),
    [anon_sym_GT_GT_EQ] = ACTIONS(4666),
    [anon_sym_LT_LT_EQ] = ACTIONS(4666),
    [anon_sym_CARET_EQ] = ACTIONS(4666),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1076] = {
    [sym_string] = STATE(2916),
    [aux_sym_chained_string_repeat1] = STATE(2916),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4668),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1077] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1078] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [1079] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2917),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2917),
    [sym_operator_assignment] = STATE(2917),
    [sym_conditional] = STATE(2917),
    [sym_range] = STATE(2917),
    [sym_binary] = STATE(2917),
    [sym_unary] = STATE(2917),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1080] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2918),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2918),
    [sym_operator_assignment] = STATE(2918),
    [sym_conditional] = STATE(2918),
    [sym_range] = STATE(2918),
    [sym_binary] = STATE(2918),
    [sym_unary] = STATE(2918),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1081] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2919),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2919),
    [sym_operator_assignment] = STATE(2919),
    [sym_conditional] = STATE(2919),
    [sym_range] = STATE(2919),
    [sym_binary] = STATE(2919),
    [sym_unary] = STATE(2919),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1082] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2920),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2920),
    [sym_operator_assignment] = STATE(2920),
    [sym_conditional] = STATE(2920),
    [sym_range] = STATE(2920),
    [sym_binary] = STATE(2920),
    [sym_unary] = STATE(2920),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1083] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2921),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2921),
    [sym_operator_assignment] = STATE(2921),
    [sym_conditional] = STATE(2921),
    [sym_range] = STATE(2921),
    [sym_binary] = STATE(2921),
    [sym_unary] = STATE(2921),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1084] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2922),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2922),
    [sym_operator_assignment] = STATE(2922),
    [sym_conditional] = STATE(2922),
    [sym_range] = STATE(2922),
    [sym_binary] = STATE(2922),
    [sym_unary] = STATE(2922),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1085] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(2923),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(2923),
    [sym_operator_assignment] = STATE(2923),
    [sym_conditional] = STATE(2923),
    [sym_range] = STATE(2923),
    [sym_binary] = STATE(2923),
    [sym_unary] = STATE(2923),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1086] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2924),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2924),
    [sym_operator_assignment] = STATE(2924),
    [sym_conditional] = STATE(2924),
    [sym_range] = STATE(2924),
    [sym_binary] = STATE(2924),
    [sym_unary] = STATE(2924),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1087] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2925),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2925),
    [sym_operator_assignment] = STATE(2925),
    [sym_conditional] = STATE(2925),
    [sym_range] = STATE(2925),
    [sym_binary] = STATE(2925),
    [sym_unary] = STATE(2925),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1088] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2926),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2926),
    [sym_operator_assignment] = STATE(2926),
    [sym_conditional] = STATE(2926),
    [sym_range] = STATE(2926),
    [sym_binary] = STATE(2926),
    [sym_unary] = STATE(2926),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1089] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2927),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2927),
    [sym_operator_assignment] = STATE(2927),
    [sym_conditional] = STATE(2927),
    [sym_range] = STATE(2927),
    [sym_binary] = STATE(2927),
    [sym_unary] = STATE(2927),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1090] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2928),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2928),
    [sym_operator_assignment] = STATE(2928),
    [sym_conditional] = STATE(2928),
    [sym_range] = STATE(2928),
    [sym_binary] = STATE(2928),
    [sym_unary] = STATE(2928),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1091] = {
    [sym__statements] = STATE(2930),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4670),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1092] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2939),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(2939),
    [sym_operator_assignment] = STATE(2939),
    [sym_conditional] = STATE(2939),
    [sym_range] = STATE(2939),
    [sym_binary] = STATE(2939),
    [sym_unary] = STATE(2939),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1093] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2944),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(2944),
    [sym_operator_assignment] = STATE(2944),
    [sym_conditional] = STATE(2944),
    [sym_range] = STATE(2944),
    [sym_binary] = STATE(2944),
    [sym_unary] = STATE(2944),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1094] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2945),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(2945),
    [sym_operator_assignment] = STATE(2945),
    [sym_conditional] = STATE(2945),
    [sym_range] = STATE(2945),
    [sym_binary] = STATE(2945),
    [sym_unary] = STATE(2945),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1095] = {
    [anon_sym_COLON] = ACTIONS(4696),
    [sym_comment] = ACTIONS(87),
  },
  [1096] = {
    [sym__statements] = STATE(1583),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(1584),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(4698),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1097] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(2949),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(2949),
    [sym_operator_assignment] = STATE(2949),
    [sym_conditional] = STATE(2949),
    [sym_range] = STATE(2949),
    [sym_binary] = STATE(2949),
    [sym_unary] = STATE(2949),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1098] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1099] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1100] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1101] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1102] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2950),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(2950),
    [sym_operator_assignment] = STATE(2950),
    [sym_conditional] = STATE(2950),
    [sym_range] = STATE(2950),
    [sym_binary] = STATE(2950),
    [sym_unary] = STATE(2950),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1103] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2951),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(2951),
    [sym_operator_assignment] = STATE(2951),
    [sym_conditional] = STATE(2951),
    [sym_range] = STATE(2951),
    [sym_binary] = STATE(2951),
    [sym_unary] = STATE(2951),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1104] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1105] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4700),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1106] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4714),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [1107] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1108] = {
    [sym_do_block] = STATE(1654),
    [sym_block] = STATE(1654),
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1109] = {
    [sym_heredoc_body] = STATE(2965),
    [aux_sym_call_repeat1] = STATE(2965),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1110] = {
    [sym_heredoc_body] = STATE(2965),
    [aux_sym_call_repeat1] = STATE(2965),
    [aux_sym_argument_list_repeat1] = STATE(2967),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4732),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1111] = {
    [anon_sym_EQ] = ACTIONS(4734),
    [sym_comment] = ACTIONS(87),
  },
  [1112] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4736),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4738),
    [anon_sym_DASH_EQ] = ACTIONS(4738),
    [anon_sym_STAR_EQ] = ACTIONS(4738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4738),
    [anon_sym_SLASH_EQ] = ACTIONS(4738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4738),
    [anon_sym_PIPE_EQ] = ACTIONS(4738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4738),
    [anon_sym_AMP_EQ] = ACTIONS(4738),
    [anon_sym_PERCENT_EQ] = ACTIONS(4738),
    [anon_sym_GT_GT_EQ] = ACTIONS(4738),
    [anon_sym_LT_LT_EQ] = ACTIONS(4738),
    [anon_sym_CARET_EQ] = ACTIONS(4738),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1113] = {
    [sym_string] = STATE(2970),
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4740),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1114] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2976),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_splat_argument] = STATE(2977),
    [sym_assignment] = STATE(2976),
    [sym_operator_assignment] = STATE(2976),
    [sym_conditional] = STATE(2976),
    [sym_range] = STATE(2976),
    [sym_binary] = STATE(2976),
    [sym_unary] = STATE(2976),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(2977),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4742),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1115] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2980),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(2980),
    [sym_operator_assignment] = STATE(2980),
    [sym_conditional] = STATE(2980),
    [sym_range] = STATE(2980),
    [sym_binary] = STATE(2980),
    [sym_unary] = STATE(2980),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1116] = {
    [sym_string] = STATE(2981),
    [aux_sym_chained_string_repeat1] = STATE(2981),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1117] = {
    [sym__statements] = STATE(2983),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(4754),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1118] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2992),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(2992),
    [sym_operator_assignment] = STATE(2992),
    [sym_conditional] = STATE(2992),
    [sym_range] = STATE(2992),
    [sym_binary] = STATE(2992),
    [sym_unary] = STATE(2992),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1119] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(2997),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(2997),
    [sym_operator_assignment] = STATE(2997),
    [sym_conditional] = STATE(2997),
    [sym_range] = STATE(2997),
    [sym_binary] = STATE(2997),
    [sym_unary] = STATE(2997),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1120] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2998),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(2998),
    [sym_operator_assignment] = STATE(2998),
    [sym_conditional] = STATE(2998),
    [sym_range] = STATE(2998),
    [sym_binary] = STATE(2998),
    [sym_unary] = STATE(2998),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1121] = {
    [anon_sym_COLON] = ACTIONS(4778),
    [sym_comment] = ACTIONS(87),
  },
  [1122] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3001),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(3001),
    [sym_operator_assignment] = STATE(3001),
    [sym_conditional] = STATE(3001),
    [sym_range] = STATE(3001),
    [sym_binary] = STATE(3001),
    [sym_unary] = STATE(3001),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1123] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3008),
    [sym__argument] = STATE(3009),
    [sym_splat_argument] = STATE(3009),
    [sym_hash_splat_argument] = STATE(3009),
    [sym_block_argument] = STATE(3009),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3009),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1124] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(3008),
    [sym__argument] = STATE(3009),
    [sym_splat_argument] = STATE(3009),
    [sym_hash_splat_argument] = STATE(3009),
    [sym_block_argument] = STATE(3009),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3009),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1125] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(3008),
    [sym__argument] = STATE(3009),
    [sym_splat_argument] = STATE(3009),
    [sym_hash_splat_argument] = STATE(3009),
    [sym_block_argument] = STATE(3009),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3009),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1126] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(3008),
    [sym__argument] = STATE(3009),
    [sym_splat_argument] = STATE(3009),
    [sym_hash_splat_argument] = STATE(3009),
    [sym_block_argument] = STATE(3009),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3009),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1127] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3011),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(3011),
    [sym_operator_assignment] = STATE(3011),
    [sym_conditional] = STATE(3011),
    [sym_range] = STATE(3011),
    [sym_binary] = STATE(3011),
    [sym_unary] = STATE(3011),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1128] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3012),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(3012),
    [sym_operator_assignment] = STATE(3012),
    [sym_conditional] = STATE(3012),
    [sym_range] = STATE(3012),
    [sym_binary] = STATE(3012),
    [sym_unary] = STATE(3012),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1129] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1130] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4790),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1131] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(4804),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4812),
    [anon_sym_or] = ACTIONS(4812),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [1132] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(3040),
    [sym__argument] = STATE(3041),
    [sym_splat_argument] = STATE(3041),
    [sym_hash_splat_argument] = STATE(3041),
    [sym_block_argument] = STATE(3041),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3041),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1133] = {
    [sym_heredoc_body] = STATE(3045),
    [aux_sym_call_repeat1] = STATE(3045),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1134] = {
    [sym_heredoc_body] = STATE(3045),
    [aux_sym_call_repeat1] = STATE(3045),
    [aux_sym_argument_list_repeat1] = STATE(3047),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(4852),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1135] = {
    [anon_sym_EQ] = ACTIONS(4854),
    [sym_comment] = ACTIONS(87),
  },
  [1136] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4856),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4858),
    [anon_sym_DASH_EQ] = ACTIONS(4858),
    [anon_sym_STAR_EQ] = ACTIONS(4858),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4858),
    [anon_sym_SLASH_EQ] = ACTIONS(4858),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4858),
    [anon_sym_PIPE_EQ] = ACTIONS(4858),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4858),
    [anon_sym_AMP_EQ] = ACTIONS(4858),
    [anon_sym_PERCENT_EQ] = ACTIONS(4858),
    [anon_sym_GT_GT_EQ] = ACTIONS(4858),
    [anon_sym_LT_LT_EQ] = ACTIONS(4858),
    [anon_sym_CARET_EQ] = ACTIONS(4858),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1137] = {
    [sym_string] = STATE(3050),
    [aux_sym_chained_string_repeat1] = STATE(3050),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4860),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1138] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3051),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(3051),
    [sym_operator_assignment] = STATE(3051),
    [sym_conditional] = STATE(3051),
    [sym_range] = STATE(3051),
    [sym_binary] = STATE(3051),
    [sym_unary] = STATE(3051),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1139] = {
    [sym__do] = STATE(3052),
    [sym_heredoc_body] = STATE(3052),
    [sym__terminator] = STATE(3052),
    [sym__line_break2] = ACTIONS(4862),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(4862),
    [anon_sym_do] = ACTIONS(4862),
    [sym_comment] = ACTIONS(87),
  },
  [1140] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(1672),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_in] = ACTIONS(4864),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1141] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1142] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3061),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(3061),
    [sym_operator_assignment] = STATE(3061),
    [sym_conditional] = STATE(3061),
    [sym_range] = STATE(3061),
    [sym_binary] = STATE(3061),
    [sym_unary] = STATE(3061),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1143] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3065),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(3065),
    [sym_operator_assignment] = STATE(3065),
    [sym_conditional] = STATE(3065),
    [sym_range] = STATE(3065),
    [sym_binary] = STATE(3065),
    [sym_unary] = STATE(3065),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1144] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3066),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(3066),
    [sym_operator_assignment] = STATE(3066),
    [sym_conditional] = STATE(3066),
    [sym_range] = STATE(3066),
    [sym_binary] = STATE(3066),
    [sym_unary] = STATE(3066),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1145] = {
    [anon_sym_COLON] = ACTIONS(4886),
    [sym_comment] = ACTIONS(87),
  },
  [1146] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3069),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(3069),
    [sym_operator_assignment] = STATE(3069),
    [sym_conditional] = STATE(3069),
    [sym_range] = STATE(3069),
    [sym_binary] = STATE(3069),
    [sym_unary] = STATE(3069),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1147] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1148] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1149] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1150] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3076),
    [sym__argument] = STATE(3077),
    [sym_splat_argument] = STATE(3077),
    [sym_hash_splat_argument] = STATE(3077),
    [sym_block_argument] = STATE(3077),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3077),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1151] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3079),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(3079),
    [sym_operator_assignment] = STATE(3079),
    [sym_conditional] = STATE(3079),
    [sym_range] = STATE(3079),
    [sym_binary] = STATE(3079),
    [sym_unary] = STATE(3079),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1152] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3080),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(3080),
    [sym_operator_assignment] = STATE(3080),
    [sym_conditional] = STATE(3080),
    [sym_range] = STATE(3080),
    [sym_binary] = STATE(3080),
    [sym_unary] = STATE(3080),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1153] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1154] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(4896),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1155] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(4910),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [1156] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(2908),
    [sym__argument] = STATE(2909),
    [sym_splat_argument] = STATE(2909),
    [sym_hash_splat_argument] = STATE(2909),
    [sym_block_argument] = STATE(2909),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(2909),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1157] = {
    [sym_heredoc_body] = STATE(3094),
    [aux_sym_call_repeat1] = STATE(3094),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1158] = {
    [sym_heredoc_body] = STATE(3094),
    [aux_sym_call_repeat1] = STATE(3094),
    [aux_sym_argument_list_repeat1] = STATE(3096),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1159] = {
    [anon_sym_EQ] = ACTIONS(4932),
    [sym_comment] = ACTIONS(87),
  },
  [1160] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(4934),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(4936),
    [anon_sym_DASH_EQ] = ACTIONS(4936),
    [anon_sym_STAR_EQ] = ACTIONS(4936),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4936),
    [anon_sym_SLASH_EQ] = ACTIONS(4936),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4936),
    [anon_sym_PIPE_EQ] = ACTIONS(4936),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4936),
    [anon_sym_AMP_EQ] = ACTIONS(4936),
    [anon_sym_PERCENT_EQ] = ACTIONS(4936),
    [anon_sym_GT_GT_EQ] = ACTIONS(4936),
    [anon_sym_LT_LT_EQ] = ACTIONS(4936),
    [anon_sym_CARET_EQ] = ACTIONS(4936),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1161] = {
    [sym_string] = STATE(3099),
    [aux_sym_chained_string_repeat1] = STATE(3099),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(4938),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1162] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1163] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [1164] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3100),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3100),
    [sym_operator_assignment] = STATE(3100),
    [sym_conditional] = STATE(3100),
    [sym_range] = STATE(3100),
    [sym_binary] = STATE(3100),
    [sym_unary] = STATE(3100),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1165] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3101),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3101),
    [sym_operator_assignment] = STATE(3101),
    [sym_conditional] = STATE(3101),
    [sym_range] = STATE(3101),
    [sym_binary] = STATE(3101),
    [sym_unary] = STATE(3101),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1166] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3102),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3102),
    [sym_operator_assignment] = STATE(3102),
    [sym_conditional] = STATE(3102),
    [sym_range] = STATE(3102),
    [sym_binary] = STATE(3102),
    [sym_unary] = STATE(3102),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1167] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3103),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3103),
    [sym_operator_assignment] = STATE(3103),
    [sym_conditional] = STATE(3103),
    [sym_range] = STATE(3103),
    [sym_binary] = STATE(3103),
    [sym_unary] = STATE(3103),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1168] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3104),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3104),
    [sym_operator_assignment] = STATE(3104),
    [sym_conditional] = STATE(3104),
    [sym_range] = STATE(3104),
    [sym_binary] = STATE(3104),
    [sym_unary] = STATE(3104),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1169] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3105),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3105),
    [sym_operator_assignment] = STATE(3105),
    [sym_conditional] = STATE(3105),
    [sym_range] = STATE(3105),
    [sym_binary] = STATE(3105),
    [sym_unary] = STATE(3105),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1170] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3106),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3106),
    [sym_operator_assignment] = STATE(3106),
    [sym_conditional] = STATE(3106),
    [sym_range] = STATE(3106),
    [sym_binary] = STATE(3106),
    [sym_unary] = STATE(3106),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1171] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3107),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3107),
    [sym_operator_assignment] = STATE(3107),
    [sym_conditional] = STATE(3107),
    [sym_range] = STATE(3107),
    [sym_binary] = STATE(3107),
    [sym_unary] = STATE(3107),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1172] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3108),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3108),
    [sym_operator_assignment] = STATE(3108),
    [sym_conditional] = STATE(3108),
    [sym_range] = STATE(3108),
    [sym_binary] = STATE(3108),
    [sym_unary] = STATE(3108),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1173] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3109),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3109),
    [sym_operator_assignment] = STATE(3109),
    [sym_conditional] = STATE(3109),
    [sym_range] = STATE(3109),
    [sym_binary] = STATE(3109),
    [sym_unary] = STATE(3109),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1174] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3110),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3110),
    [sym_operator_assignment] = STATE(3110),
    [sym_conditional] = STATE(3110),
    [sym_range] = STATE(3110),
    [sym_binary] = STATE(3110),
    [sym_unary] = STATE(3110),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1175] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3111),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3111),
    [sym_operator_assignment] = STATE(3111),
    [sym_conditional] = STATE(3111),
    [sym_range] = STATE(3111),
    [sym_binary] = STATE(3111),
    [sym_unary] = STATE(3111),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1176] = {
    [sym_when] = STATE(3112),
    [aux_sym_case_repeat1] = STATE(3113),
    [anon_sym_SEMI] = ACTIONS(4940),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1177] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3119),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_splat_argument] = STATE(3120),
    [sym_assignment] = STATE(3119),
    [sym_operator_assignment] = STATE(3119),
    [sym_conditional] = STATE(3119),
    [sym_range] = STATE(3119),
    [sym_binary] = STATE(3119),
    [sym_unary] = STATE(3119),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(3120),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4942),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1178] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3123),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3123),
    [sym_operator_assignment] = STATE(3123),
    [sym_conditional] = STATE(3123),
    [sym_range] = STATE(3123),
    [sym_binary] = STATE(3123),
    [sym_unary] = STATE(3123),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1179] = {
    [sym_string] = STATE(3124),
    [aux_sym_chained_string_repeat1] = STATE(3124),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1180] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_pattern] = STATE(3134),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3135),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_splat_argument] = STATE(3137),
    [sym_assignment] = STATE(3135),
    [sym_operator_assignment] = STATE(3135),
    [sym_conditional] = STATE(3135),
    [sym_range] = STATE(3135),
    [sym_binary] = STATE(3135),
    [sym_unary] = STATE(3135),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4954),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1181] = {
    [anon_sym_end] = ACTIONS(4978),
    [sym_comment] = ACTIONS(87),
  },
  [1182] = {
    [sym_when] = STATE(3112),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1183] = {
    [sym__simple_symbol2] = ACTIONS(3158),
    [sym__string_start2] = ACTIONS(3158),
    [sym__symbol_start2] = ACTIONS(3158),
    [sym__subshell_start2] = ACTIONS(3158),
    [sym__regex_start2] = ACTIONS(3158),
    [sym__string_array_start2] = ACTIONS(3158),
    [sym__symbol_array_start2] = ACTIONS(3158),
    [sym_heredoc_beginning2] = ACTIONS(3158),
    [sym__unary_minus2] = ACTIONS(3158),
    [ts_builtin_sym_end] = ACTIONS(3158),
    [anon_sym___END__] = ACTIONS(4982),
    [anon_sym_BEGIN] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_END] = ACTIONS(4982),
    [anon_sym_def] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(4982),
    [anon_sym_end] = ACTIONS(4982),
    [anon_sym_return] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_break] = ACTIONS(4982),
    [anon_sym_next] = ACTIONS(4982),
    [sym_redo] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(4982),
    [anon_sym_unless] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(4982),
    [anon_sym_until] = ACTIONS(4982),
    [anon_sym_rescue] = ACTIONS(4982),
    [anon_sym_for] = ACTIONS(4982),
    [anon_sym_case] = ACTIONS(4982),
    [anon_sym_when] = ACTIONS(4982),
    [anon_sym_elsif] = ACTIONS(4982),
    [anon_sym_else] = ACTIONS(4982),
    [anon_sym_then] = ACTIONS(4982),
    [anon_sym_begin] = ACTIONS(4982),
    [anon_sym_ensure] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_defined_QMARK] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(4982),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4982),
    [sym_instance_variable] = ACTIONS(3158),
    [sym_class_variable] = ACTIONS(3158),
    [sym_global_variable] = ACTIONS(3158),
    [anon_sym_undef] = ACTIONS(4982),
    [anon_sym_alias] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4982),
    [sym_float] = ACTIONS(4982),
    [sym_complex] = ACTIONS(3158),
    [sym_super] = ACTIONS(4982),
    [anon_sym_true] = ACTIONS(4982),
    [anon_sym_TRUE] = ACTIONS(4982),
    [anon_sym_false] = ACTIONS(4982),
    [anon_sym_FALSE] = ACTIONS(4982),
    [sym_self] = ACTIONS(4982),
    [anon_sym_nil] = ACTIONS(4982),
    [anon_sym_NIL] = ACTIONS(4982),
    [sym_character] = ACTIONS(3158),
    [anon_sym_LBRACK2] = ACTIONS(3158),
    [anon_sym_DASH_GT] = ACTIONS(3158),
  },
  [1184] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(4984),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [1185] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1186] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3152),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(3152),
    [sym_operator_assignment] = STATE(3152),
    [sym_conditional] = STATE(3152),
    [sym_range] = STATE(3152),
    [sym_binary] = STATE(3152),
    [sym_unary] = STATE(3152),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1187] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3156),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(3156),
    [sym_operator_assignment] = STATE(3156),
    [sym_conditional] = STATE(3156),
    [sym_range] = STATE(3156),
    [sym_binary] = STATE(3156),
    [sym_unary] = STATE(3156),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1188] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3157),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(3157),
    [sym_operator_assignment] = STATE(3157),
    [sym_conditional] = STATE(3157),
    [sym_range] = STATE(3157),
    [sym_binary] = STATE(3157),
    [sym_unary] = STATE(3157),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1189] = {
    [anon_sym_COLON] = ACTIONS(5006),
    [sym_comment] = ACTIONS(87),
  },
  [1190] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3160),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(3160),
    [sym_operator_assignment] = STATE(3160),
    [sym_conditional] = STATE(3160),
    [sym_range] = STATE(3160),
    [sym_binary] = STATE(3160),
    [sym_unary] = STATE(3160),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1191] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3167),
    [sym__argument] = STATE(3168),
    [sym_splat_argument] = STATE(3168),
    [sym_hash_splat_argument] = STATE(3168),
    [sym_block_argument] = STATE(3168),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3168),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1192] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3167),
    [sym__argument] = STATE(3168),
    [sym_splat_argument] = STATE(3168),
    [sym_hash_splat_argument] = STATE(3168),
    [sym_block_argument] = STATE(3168),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3168),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1193] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3167),
    [sym__argument] = STATE(3168),
    [sym_splat_argument] = STATE(3168),
    [sym_hash_splat_argument] = STATE(3168),
    [sym_block_argument] = STATE(3168),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3168),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1194] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3167),
    [sym__argument] = STATE(3168),
    [sym_splat_argument] = STATE(3168),
    [sym_hash_splat_argument] = STATE(3168),
    [sym_block_argument] = STATE(3168),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3168),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1195] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3170),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(3170),
    [sym_operator_assignment] = STATE(3170),
    [sym_conditional] = STATE(3170),
    [sym_range] = STATE(3170),
    [sym_binary] = STATE(3170),
    [sym_unary] = STATE(3170),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1196] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3171),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(3171),
    [sym_operator_assignment] = STATE(3171),
    [sym_conditional] = STATE(3171),
    [sym_range] = STATE(3171),
    [sym_binary] = STATE(3171),
    [sym_unary] = STATE(3171),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1197] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1198] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(5016),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1199] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(5030),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [1200] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1201] = {
    [sym_heredoc_body] = STATE(3194),
    [aux_sym_call_repeat1] = STATE(3194),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1202] = {
    [sym_heredoc_body] = STATE(3194),
    [aux_sym_call_repeat1] = STATE(3194),
    [aux_sym_argument_list_repeat1] = STATE(3196),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1203] = {
    [anon_sym_EQ] = ACTIONS(5060),
    [sym_comment] = ACTIONS(87),
  },
  [1204] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5062),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5064),
    [anon_sym_DASH_EQ] = ACTIONS(5064),
    [anon_sym_STAR_EQ] = ACTIONS(5064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5064),
    [anon_sym_SLASH_EQ] = ACTIONS(5064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5064),
    [anon_sym_PIPE_EQ] = ACTIONS(5064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5064),
    [anon_sym_AMP_EQ] = ACTIONS(5064),
    [anon_sym_PERCENT_EQ] = ACTIONS(5064),
    [anon_sym_GT_GT_EQ] = ACTIONS(5064),
    [anon_sym_LT_LT_EQ] = ACTIONS(5064),
    [anon_sym_CARET_EQ] = ACTIONS(5064),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1205] = {
    [sym_string] = STATE(3199),
    [aux_sym_chained_string_repeat1] = STATE(3199),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5066),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1206] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3200),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(3200),
    [sym_operator_assignment] = STATE(3200),
    [sym_conditional] = STATE(3200),
    [sym_range] = STATE(3200),
    [sym_binary] = STATE(3200),
    [sym_unary] = STATE(3200),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1207] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3201),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(3201),
    [sym_operator_assignment] = STATE(3201),
    [sym_conditional] = STATE(3201),
    [sym_range] = STATE(3201),
    [sym_binary] = STATE(3201),
    [sym_unary] = STATE(3201),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1208] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3212),
    [sym__argument] = STATE(3213),
    [sym_splat_argument] = STATE(3213),
    [sym_hash_splat_argument] = STATE(3213),
    [sym_block_argument] = STATE(3213),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3213),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1209] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3212),
    [sym__argument] = STATE(3213),
    [sym_splat_argument] = STATE(3213),
    [sym_hash_splat_argument] = STATE(3213),
    [sym_block_argument] = STATE(3213),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3213),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1210] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3212),
    [sym__argument] = STATE(3213),
    [sym_splat_argument] = STATE(3213),
    [sym_hash_splat_argument] = STATE(3213),
    [sym_block_argument] = STATE(3213),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3213),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1211] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3212),
    [sym__argument] = STATE(3213),
    [sym_splat_argument] = STATE(3213),
    [sym_hash_splat_argument] = STATE(3213),
    [sym_block_argument] = STATE(3213),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3213),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1212] = {
    [sym_method] = STATE(3220),
    [sym_singleton_method] = STATE(3220),
    [sym_class] = STATE(3220),
    [sym_singleton_class] = STATE(3220),
    [sym_module] = STATE(3220),
    [sym_return] = STATE(3220),
    [sym_yield] = STATE(3220),
    [sym_break] = STATE(3220),
    [sym_next] = STATE(3220),
    [sym_while] = STATE(3220),
    [sym_until] = STATE(3220),
    [sym_for] = STATE(3220),
    [sym_case] = STATE(3220),
    [sym_if] = STATE(3220),
    [sym_unless] = STATE(3220),
    [sym_begin] = STATE(3220),
    [sym__primary] = STATE(3220),
    [sym_parenthesized_statements] = STATE(3220),
    [sym_element_reference] = STATE(3222),
    [sym_scope_resolution] = STATE(3221),
    [sym_call] = STATE(3221),
    [sym_method_call] = STATE(3222),
    [sym__lhs] = STATE(3222),
    [sym__variable] = STATE(3221),
    [sym_rational] = STATE(3220),
    [sym_true] = STATE(3222),
    [sym_false] = STATE(3222),
    [sym_nil] = STATE(3222),
    [sym_chained_string] = STATE(3220),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(3220),
    [sym_string_array] = STATE(3220),
    [sym_symbol_array] = STATE(3220),
    [sym_symbol] = STATE(3220),
    [sym_regex] = STATE(3220),
    [sym_array] = STATE(3220),
    [sym_hash] = STATE(3220),
    [sym_lambda] = STATE(3220),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(5086),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(5088),
    [sym_retry] = ACTIONS(5088),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(5090),
    [sym_identifier] = ACTIONS(5090),
    [sym_instance_variable] = ACTIONS(5092),
    [sym_class_variable] = ACTIONS(5092),
    [sym_global_variable] = ACTIONS(5092),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(5088),
    [sym_complex] = ACTIONS(5086),
    [sym_super] = ACTIONS(5090),
    [anon_sym_true] = ACTIONS(5094),
    [anon_sym_TRUE] = ACTIONS(5094),
    [anon_sym_false] = ACTIONS(5096),
    [anon_sym_FALSE] = ACTIONS(5096),
    [sym_self] = ACTIONS(5090),
    [anon_sym_nil] = ACTIONS(5098),
    [anon_sym_NIL] = ACTIONS(5098),
    [sym_character] = ACTIONS(5086),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1213] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3223),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(3223),
    [sym_operator_assignment] = STATE(3223),
    [sym_conditional] = STATE(3223),
    [sym_range] = STATE(3223),
    [sym_binary] = STATE(3223),
    [sym_unary] = STATE(3223),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1214] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3224),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(3224),
    [sym_operator_assignment] = STATE(3224),
    [sym_conditional] = STATE(3224),
    [sym_range] = STATE(3224),
    [sym_binary] = STATE(3224),
    [sym_unary] = STATE(3224),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1215] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1216] = {
    [sym__statements] = STATE(3225),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym_rescue] = STATE(3226),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5100),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5100),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5100),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1217] = {
    [sym__then] = STATE(3227),
    [sym_exception_variable] = STATE(3228),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_then] = ACTIONS(5102),
    [anon_sym_EQ_GT] = ACTIONS(2127),
    [sym_comment] = ACTIONS(87),
  },
  [1218] = {
    [sym__then] = STATE(3227),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_then] = ACTIONS(5102),
    [sym_comment] = ACTIONS(87),
  },
  [1219] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5124),
    [anon_sym_or] = ACTIONS(5124),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [1220] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1221] = {
    [aux_sym_exceptions_repeat1] = STATE(3262),
    [sym__line_break2] = ACTIONS(5168),
    [sym__heredoc_body_start2] = ACTIONS(5168),
    [anon_sym_COMMA] = ACTIONS(5170),
    [anon_sym_SEMI] = ACTIONS(5168),
    [anon_sym_then] = ACTIONS(5168),
    [anon_sym_EQ_GT] = ACTIONS(5168),
    [sym_comment] = ACTIONS(87),
  },
  [1222] = {
    [anon_sym_EQ] = ACTIONS(5172),
    [sym_comment] = ACTIONS(87),
  },
  [1223] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5174),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5176),
    [anon_sym_DASH_EQ] = ACTIONS(5176),
    [anon_sym_STAR_EQ] = ACTIONS(5176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5176),
    [anon_sym_SLASH_EQ] = ACTIONS(5176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5176),
    [anon_sym_PIPE_EQ] = ACTIONS(5176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5176),
    [anon_sym_AMP_EQ] = ACTIONS(5176),
    [anon_sym_PERCENT_EQ] = ACTIONS(5176),
    [anon_sym_GT_GT_EQ] = ACTIONS(5176),
    [anon_sym_LT_LT_EQ] = ACTIONS(5176),
    [anon_sym_CARET_EQ] = ACTIONS(5176),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1224] = {
    [sym_string] = STATE(3265),
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1225] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3266),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(3266),
    [sym_operator_assignment] = STATE(3266),
    [sym_conditional] = STATE(3266),
    [sym_range] = STATE(3266),
    [sym_binary] = STATE(3266),
    [sym_unary] = STATE(3266),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1226] = {
    [sym__line_break2] = ACTIONS(275),
    [sym__simple_symbol2] = ACTIONS(2079),
    [sym__string_start2] = ACTIONS(2079),
    [sym__symbol_start2] = ACTIONS(2079),
    [sym__subshell_start2] = ACTIONS(2079),
    [sym__regex_start2] = ACTIONS(2079),
    [sym__string_array_start2] = ACTIONS(2079),
    [sym__symbol_array_start2] = ACTIONS(2079),
    [sym__heredoc_body_start2] = ACTIONS(275),
    [sym_heredoc_beginning2] = ACTIONS(2079),
    [sym__unary_minus2] = ACTIONS(2079),
    [anon_sym_BEGIN] = ACTIONS(2081),
    [anon_sym_LBRACE] = ACTIONS(2079),
    [anon_sym_END] = ACTIONS(2081),
    [anon_sym_def] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(2079),
    [anon_sym_COLON_COLON] = ACTIONS(2079),
    [anon_sym_PIPE] = ACTIONS(2079),
    [anon_sym_SEMI] = ACTIONS(2079),
    [anon_sym_STAR] = ACTIONS(2079),
    [anon_sym_class] = ACTIONS(2081),
    [anon_sym_module] = ACTIONS(2081),
    [anon_sym_end] = ACTIONS(2081),
    [anon_sym_return] = ACTIONS(2081),
    [anon_sym_yield] = ACTIONS(2081),
    [anon_sym_break] = ACTIONS(2081),
    [anon_sym_next] = ACTIONS(2081),
    [sym_redo] = ACTIONS(2081),
    [sym_retry] = ACTIONS(2081),
    [anon_sym_if] = ACTIONS(2081),
    [anon_sym_unless] = ACTIONS(2081),
    [anon_sym_while] = ACTIONS(2081),
    [anon_sym_until] = ACTIONS(2081),
    [anon_sym_rescue] = ACTIONS(5178),
    [anon_sym_for] = ACTIONS(2081),
    [anon_sym_case] = ACTIONS(2081),
    [anon_sym_elsif] = ACTIONS(2081),
    [anon_sym_else] = ACTIONS(2081),
    [anon_sym_begin] = ACTIONS(2081),
    [anon_sym_ensure] = ACTIONS(2081),
    [anon_sym_PLUS] = ACTIONS(2081),
    [anon_sym_defined_QMARK] = ACTIONS(2079),
    [anon_sym_not] = ACTIONS(2081),
    [anon_sym_BANG] = ACTIONS(2079),
    [anon_sym_TILDE] = ACTIONS(2079),
    [sym_constant] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2081),
    [sym_instance_variable] = ACTIONS(2079),
    [sym_class_variable] = ACTIONS(2079),
    [sym_global_variable] = ACTIONS(2079),
    [anon_sym_undef] = ACTIONS(2081),
    [anon_sym_alias] = ACTIONS(2081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [sym_complex] = ACTIONS(2079),
    [sym_super] = ACTIONS(2081),
    [anon_sym_true] = ACTIONS(2081),
    [anon_sym_TRUE] = ACTIONS(2081),
    [anon_sym_false] = ACTIONS(2081),
    [anon_sym_FALSE] = ACTIONS(2081),
    [sym_self] = ACTIONS(2081),
    [anon_sym_nil] = ACTIONS(2081),
    [anon_sym_NIL] = ACTIONS(2081),
    [sym_character] = ACTIONS(2079),
    [anon_sym_LBRACK2] = ACTIONS(2079),
    [anon_sym_DASH_GT] = ACTIONS(2079),
  },
  [1227] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3282),
    [sym__argument] = STATE(3283),
    [sym_splat_argument] = STATE(3283),
    [sym_hash_splat_argument] = STATE(3283),
    [sym_block_argument] = STATE(3283),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3283),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1228] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3282),
    [sym__argument] = STATE(3283),
    [sym_splat_argument] = STATE(3283),
    [sym_hash_splat_argument] = STATE(3283),
    [sym_block_argument] = STATE(3283),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3283),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1229] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3282),
    [sym__argument] = STATE(3283),
    [sym_splat_argument] = STATE(3283),
    [sym_hash_splat_argument] = STATE(3283),
    [sym_block_argument] = STATE(3283),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3283),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1230] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3282),
    [sym__argument] = STATE(3283),
    [sym_splat_argument] = STATE(3283),
    [sym_hash_splat_argument] = STATE(3283),
    [sym_block_argument] = STATE(3283),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3283),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1231] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3287),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(3287),
    [sym_operator_assignment] = STATE(3287),
    [sym_conditional] = STATE(3287),
    [sym_range] = STATE(3287),
    [sym_binary] = STATE(3287),
    [sym_unary] = STATE(3287),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1232] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3288),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(3288),
    [sym_operator_assignment] = STATE(3288),
    [sym_conditional] = STATE(3288),
    [sym_range] = STATE(3288),
    [sym_binary] = STATE(3288),
    [sym_unary] = STATE(3288),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1233] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1234] = {
    [sym_operator] = STATE(3289),
    [sym__method_name] = STATE(3289),
    [sym_setter] = STATE(3289),
    [sym_symbol] = STATE(3289),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5210),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5210),
    [sym_class_variable] = ACTIONS(5210),
    [sym_global_variable] = ACTIONS(5210),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1235] = {
    [anon_sym_end] = ACTIONS(5212),
    [anon_sym_ensure] = ACTIONS(5212),
    [sym_comment] = ACTIONS(87),
  },
  [1236] = {
    [sym_heredoc_body] = STATE(3290),
    [sym__terminator] = STATE(3290),
    [aux_sym__statements_repeat1] = STATE(3291),
    [sym__line_break2] = ACTIONS(5214),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5214),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_ensure] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [1237] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(5216),
    [anon_sym_unless] = ACTIONS(5218),
    [anon_sym_while] = ACTIONS(5220),
    [anon_sym_until] = ACTIONS(5222),
    [anon_sym_rescue] = ACTIONS(5224),
    [anon_sym_ensure] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [1238] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_ensure] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [1239] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1240] = {
    [anon_sym_EQ] = ACTIONS(5288),
    [sym_comment] = ACTIONS(87),
  },
  [1241] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5290),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5292),
    [anon_sym_DASH_EQ] = ACTIONS(5292),
    [anon_sym_STAR_EQ] = ACTIONS(5292),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5292),
    [anon_sym_SLASH_EQ] = ACTIONS(5292),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5292),
    [anon_sym_PIPE_EQ] = ACTIONS(5292),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5292),
    [anon_sym_AMP_EQ] = ACTIONS(5292),
    [anon_sym_PERCENT_EQ] = ACTIONS(5292),
    [anon_sym_GT_GT_EQ] = ACTIONS(5292),
    [anon_sym_LT_LT_EQ] = ACTIONS(5292),
    [anon_sym_CARET_EQ] = ACTIONS(5292),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1242] = {
    [sym_string] = STATE(3331),
    [aux_sym_chained_string_repeat1] = STATE(3331),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1243] = {
    [sym__statements] = STATE(3332),
    [sym__top_level_statement] = STATE(1236),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1237),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(1238),
    [sym_operator_assignment] = STATE(1238),
    [sym_conditional] = STATE(1238),
    [sym_range] = STATE(1238),
    [sym_binary] = STATE(1238),
    [sym_unary] = STATE(1238),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5294),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5294),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [anon_sym_undef] = ACTIONS(2169),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1244] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3333),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(3333),
    [sym_operator_assignment] = STATE(3333),
    [sym_conditional] = STATE(3333),
    [sym_range] = STATE(3333),
    [sym_binary] = STATE(3333),
    [sym_unary] = STATE(3333),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1245] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3349),
    [sym__argument] = STATE(3350),
    [sym_splat_argument] = STATE(3350),
    [sym_hash_splat_argument] = STATE(3350),
    [sym_block_argument] = STATE(3350),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3350),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1246] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3349),
    [sym__argument] = STATE(3350),
    [sym_splat_argument] = STATE(3350),
    [sym_hash_splat_argument] = STATE(3350),
    [sym_block_argument] = STATE(3350),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3350),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1247] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3349),
    [sym__argument] = STATE(3350),
    [sym_splat_argument] = STATE(3350),
    [sym_hash_splat_argument] = STATE(3350),
    [sym_block_argument] = STATE(3350),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3350),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1248] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3349),
    [sym__argument] = STATE(3350),
    [sym_splat_argument] = STATE(3350),
    [sym_hash_splat_argument] = STATE(3350),
    [sym_block_argument] = STATE(3350),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3350),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1249] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3354),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(3354),
    [sym_operator_assignment] = STATE(3354),
    [sym_conditional] = STATE(3354),
    [sym_range] = STATE(3354),
    [sym_binary] = STATE(3354),
    [sym_unary] = STATE(3354),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1250] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3355),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(3355),
    [sym_operator_assignment] = STATE(3355),
    [sym_conditional] = STATE(3355),
    [sym_range] = STATE(3355),
    [sym_binary] = STATE(3355),
    [sym_unary] = STATE(3355),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1251] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1252] = {
    [sym_operator] = STATE(3356),
    [sym__method_name] = STATE(3356),
    [sym_setter] = STATE(3356),
    [sym_symbol] = STATE(3356),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5326),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5326),
    [sym_class_variable] = ACTIONS(5326),
    [sym_global_variable] = ACTIONS(5326),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1253] = {
    [anon_sym_end] = ACTIONS(5328),
    [sym_comment] = ACTIONS(87),
  },
  [1254] = {
    [sym_heredoc_body] = STATE(3357),
    [sym__terminator] = STATE(3357),
    [aux_sym__statements_repeat1] = STATE(3358),
    [sym__line_break2] = ACTIONS(5330),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5330),
    [anon_sym_end] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [1255] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(5332),
    [anon_sym_unless] = ACTIONS(5334),
    [anon_sym_while] = ACTIONS(5336),
    [anon_sym_until] = ACTIONS(5338),
    [anon_sym_rescue] = ACTIONS(5340),
    [sym_comment] = ACTIONS(87),
  },
  [1256] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [1257] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1258] = {
    [anon_sym_EQ] = ACTIONS(5404),
    [sym_comment] = ACTIONS(87),
  },
  [1259] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5406),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5408),
    [anon_sym_DASH_EQ] = ACTIONS(5408),
    [anon_sym_STAR_EQ] = ACTIONS(5408),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5408),
    [anon_sym_SLASH_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_PIPE_EQ] = ACTIONS(5408),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5408),
    [anon_sym_AMP_EQ] = ACTIONS(5408),
    [anon_sym_PERCENT_EQ] = ACTIONS(5408),
    [anon_sym_GT_GT_EQ] = ACTIONS(5408),
    [anon_sym_LT_LT_EQ] = ACTIONS(5408),
    [anon_sym_CARET_EQ] = ACTIONS(5408),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1260] = {
    [sym_string] = STATE(3398),
    [aux_sym_chained_string_repeat1] = STATE(3398),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1261] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1262] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [1263] = {
    [aux_sym_undef_repeat1] = STATE(3399),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2297),
    [anon_sym_ensure] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [1264] = {
    [sym__line_break2] = ACTIONS(5410),
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [ts_builtin_sym_end] = ACTIONS(5410),
    [anon_sym___END__] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_end] = ACTIONS(5410),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_when] = ACTIONS(5410),
    [anon_sym_elsif] = ACTIONS(5410),
    [anon_sym_else] = ACTIONS(5410),
    [anon_sym_then] = ACTIONS(5410),
    [anon_sym_ensure] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [sym_comment] = ACTIONS(87),
  },
  [1265] = {
    [sym_ensure] = STATE(3401),
    [anon_sym_end] = ACTIONS(5414),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1266] = {
    [anon_sym_end] = ACTIONS(5414),
    [sym_comment] = ACTIONS(87),
  },
  [1267] = {
    [sym_else] = STATE(3402),
    [sym_ensure] = STATE(3401),
    [anon_sym_end] = ACTIONS(5414),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1268] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(2545),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(2545),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2545),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1269] = {
    [sym_heredoc_body] = STATE(3403),
    [sym__terminator] = STATE(3403),
    [aux_sym__statements_repeat1] = STATE(3404),
    [sym__line_break2] = ACTIONS(5416),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(5416),
    [anon_sym_end] = ACTIONS(2543),
    [anon_sym_rescue] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [anon_sym_ensure] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [1270] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3405),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3405),
    [sym_operator_assignment] = STATE(3405),
    [sym_conditional] = STATE(3405),
    [sym_range] = STATE(3405),
    [sym_binary] = STATE(3405),
    [sym_unary] = STATE(3405),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1271] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3406),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3406),
    [sym_operator_assignment] = STATE(3406),
    [sym_conditional] = STATE(3406),
    [sym_range] = STATE(3406),
    [sym_binary] = STATE(3406),
    [sym_unary] = STATE(3406),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1272] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3407),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3407),
    [sym_operator_assignment] = STATE(3407),
    [sym_conditional] = STATE(3407),
    [sym_range] = STATE(3407),
    [sym_binary] = STATE(3407),
    [sym_unary] = STATE(3407),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1273] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3408),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3408),
    [sym_operator_assignment] = STATE(3408),
    [sym_conditional] = STATE(3408),
    [sym_range] = STATE(3408),
    [sym_binary] = STATE(3408),
    [sym_unary] = STATE(3408),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1274] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3409),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3409),
    [sym_operator_assignment] = STATE(3409),
    [sym_conditional] = STATE(3409),
    [sym_range] = STATE(3409),
    [sym_binary] = STATE(3409),
    [sym_unary] = STATE(3409),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1275] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3410),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3410),
    [sym_operator_assignment] = STATE(3410),
    [sym_conditional] = STATE(3410),
    [sym_range] = STATE(3410),
    [sym_binary] = STATE(3410),
    [sym_unary] = STATE(3410),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1276] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3411),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3411),
    [sym_operator_assignment] = STATE(3411),
    [sym_conditional] = STATE(3411),
    [sym_range] = STATE(3411),
    [sym_binary] = STATE(3411),
    [sym_unary] = STATE(3411),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1277] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3412),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3412),
    [sym_operator_assignment] = STATE(3412),
    [sym_conditional] = STATE(3412),
    [sym_range] = STATE(3412),
    [sym_binary] = STATE(3412),
    [sym_unary] = STATE(3412),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1278] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3413),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3413),
    [sym_operator_assignment] = STATE(3413),
    [sym_conditional] = STATE(3413),
    [sym_range] = STATE(3413),
    [sym_binary] = STATE(3413),
    [sym_unary] = STATE(3413),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1279] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3414),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3414),
    [sym_operator_assignment] = STATE(3414),
    [sym_conditional] = STATE(3414),
    [sym_range] = STATE(3414),
    [sym_binary] = STATE(3414),
    [sym_unary] = STATE(3414),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1280] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3415),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3415),
    [sym_operator_assignment] = STATE(3415),
    [sym_conditional] = STATE(3415),
    [sym_range] = STATE(3415),
    [sym_binary] = STATE(3415),
    [sym_unary] = STATE(3415),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1281] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3416),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3416),
    [sym_operator_assignment] = STATE(3416),
    [sym_conditional] = STATE(3416),
    [sym_range] = STATE(3416),
    [sym_binary] = STATE(3416),
    [sym_unary] = STATE(3416),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1282] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3417),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3417),
    [sym_operator_assignment] = STATE(3417),
    [sym_conditional] = STATE(3417),
    [sym_range] = STATE(3417),
    [sym_binary] = STATE(3417),
    [sym_unary] = STATE(3417),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1283] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3418),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3418),
    [sym_operator_assignment] = STATE(3418),
    [sym_conditional] = STATE(3418),
    [sym_range] = STATE(3418),
    [sym_binary] = STATE(3418),
    [sym_unary] = STATE(3418),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1284] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3419),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3419),
    [sym_operator_assignment] = STATE(3419),
    [sym_conditional] = STATE(3419),
    [sym_range] = STATE(3419),
    [sym_binary] = STATE(3419),
    [sym_unary] = STATE(3419),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1285] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3420),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3420),
    [sym_operator_assignment] = STATE(3420),
    [sym_conditional] = STATE(3420),
    [sym_range] = STATE(3420),
    [sym_binary] = STATE(3420),
    [sym_unary] = STATE(3420),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1286] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3421),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3421),
    [sym_operator_assignment] = STATE(3421),
    [sym_conditional] = STATE(3421),
    [sym_range] = STATE(3421),
    [sym_binary] = STATE(3421),
    [sym_unary] = STATE(3421),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1287] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3430),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(3430),
    [sym_operator_assignment] = STATE(3430),
    [sym_conditional] = STATE(3430),
    [sym_range] = STATE(3430),
    [sym_binary] = STATE(3430),
    [sym_unary] = STATE(3430),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1288] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3435),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(3435),
    [sym_operator_assignment] = STATE(3435),
    [sym_conditional] = STATE(3435),
    [sym_range] = STATE(3435),
    [sym_binary] = STATE(3435),
    [sym_unary] = STATE(3435),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1289] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3436),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(3436),
    [sym_operator_assignment] = STATE(3436),
    [sym_conditional] = STATE(3436),
    [sym_range] = STATE(3436),
    [sym_binary] = STATE(3436),
    [sym_unary] = STATE(3436),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1290] = {
    [anon_sym_COLON] = ACTIONS(5442),
    [sym_comment] = ACTIONS(87),
  },
  [1291] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3439),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(3439),
    [sym_operator_assignment] = STATE(3439),
    [sym_conditional] = STATE(3439),
    [sym_range] = STATE(3439),
    [sym_binary] = STATE(3439),
    [sym_unary] = STATE(3439),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1292] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1293] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1294] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1295] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1296] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3440),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(3440),
    [sym_operator_assignment] = STATE(3440),
    [sym_conditional] = STATE(3440),
    [sym_range] = STATE(3440),
    [sym_binary] = STATE(3440),
    [sym_unary] = STATE(3440),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1297] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3441),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(3441),
    [sym_operator_assignment] = STATE(3441),
    [sym_conditional] = STATE(3441),
    [sym_range] = STATE(3441),
    [sym_binary] = STATE(3441),
    [sym_unary] = STATE(3441),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1298] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1299] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(5444),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1300] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(5458),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [1301] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(3191),
    [sym__argument] = STATE(3192),
    [sym_splat_argument] = STATE(3192),
    [sym_hash_splat_argument] = STATE(3192),
    [sym_block_argument] = STATE(3192),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3192),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1302] = {
    [sym_heredoc_body] = STATE(3455),
    [aux_sym_call_repeat1] = STATE(3455),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1303] = {
    [sym_heredoc_body] = STATE(3455),
    [aux_sym_call_repeat1] = STATE(3455),
    [aux_sym_argument_list_repeat1] = STATE(3457),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1304] = {
    [anon_sym_EQ] = ACTIONS(5478),
    [sym_comment] = ACTIONS(87),
  },
  [1305] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5480),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5482),
    [anon_sym_DASH_EQ] = ACTIONS(5482),
    [anon_sym_STAR_EQ] = ACTIONS(5482),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5482),
    [anon_sym_SLASH_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_PIPE_EQ] = ACTIONS(5482),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5482),
    [anon_sym_AMP_EQ] = ACTIONS(5482),
    [anon_sym_PERCENT_EQ] = ACTIONS(5482),
    [anon_sym_GT_GT_EQ] = ACTIONS(5482),
    [anon_sym_LT_LT_EQ] = ACTIONS(5482),
    [anon_sym_CARET_EQ] = ACTIONS(5482),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1306] = {
    [sym_string] = STATE(3460),
    [aux_sym_chained_string_repeat1] = STATE(3460),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5484),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1307] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3466),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_splat_argument] = STATE(3467),
    [sym_assignment] = STATE(3466),
    [sym_operator_assignment] = STATE(3466),
    [sym_conditional] = STATE(3466),
    [sym_range] = STATE(3466),
    [sym_binary] = STATE(3466),
    [sym_unary] = STATE(3466),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(3467),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5486),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1308] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3470),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(3470),
    [sym_operator_assignment] = STATE(3470),
    [sym_conditional] = STATE(3470),
    [sym_range] = STATE(3470),
    [sym_binary] = STATE(3470),
    [sym_unary] = STATE(3470),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1309] = {
    [sym_string] = STATE(3471),
    [aux_sym_chained_string_repeat1] = STATE(3471),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1310] = {
    [sym__line_break2] = ACTIONS(5498),
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [ts_builtin_sym_end] = ACTIONS(5498),
    [anon_sym___END__] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_end] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_when] = ACTIONS(5498),
    [anon_sym_elsif] = ACTIONS(5498),
    [anon_sym_else] = ACTIONS(5498),
    [anon_sym_then] = ACTIONS(5498),
    [anon_sym_ensure] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [sym_comment] = ACTIONS(87),
  },
  [1311] = {
    [sym_operator] = STATE(3472),
    [sym__method_name] = STATE(3472),
    [sym_setter] = STATE(3472),
    [sym_symbol] = STATE(3472),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(5502),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(5502),
    [sym_class_variable] = ACTIONS(5502),
    [sym_global_variable] = ACTIONS(5502),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1312] = {
    [aux_sym_undef_repeat1] = STATE(3473),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [ts_builtin_sym_end] = ACTIONS(5504),
    [anon_sym___END__] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [1313] = {
    [sym__simple_symbol2] = ACTIONS(891),
    [sym__symbol_start2] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(891),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_TILDE] = ACTIONS(891),
    [sym_constant] = ACTIONS(891),
    [sym_identifier] = ACTIONS(891),
    [sym_instance_variable] = ACTIONS(891),
    [sym_class_variable] = ACTIONS(891),
    [sym_global_variable] = ACTIONS(891),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_PLUS_AT] = ACTIONS(891),
    [anon_sym_DASH_AT] = ACTIONS(891),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(893),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(891),
    [anon_sym_BQUOTE] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [1314] = {
    [sym__string_end2] = ACTIONS(5506),
    [sym_comment] = ACTIONS(87),
  },
  [1315] = {
    [sym__simple_symbol2] = ACTIONS(3608),
    [sym__symbol_start2] = ACTIONS(3608),
    [anon_sym_PIPE] = ACTIONS(3608),
    [anon_sym_STAR] = ACTIONS(3610),
    [anon_sym_STAR_STAR] = ACTIONS(3608),
    [anon_sym_AMP] = ACTIONS(3608),
    [anon_sym_LT] = ACTIONS(3610),
    [anon_sym_DOT_DOT] = ACTIONS(3608),
    [anon_sym_LT_LT] = ACTIONS(3608),
    [anon_sym_GT_GT] = ACTIONS(3608),
    [anon_sym_EQ_EQ] = ACTIONS(3610),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3608),
    [anon_sym_LT_EQ_GT] = ACTIONS(3608),
    [anon_sym_EQ_TILDE] = ACTIONS(3608),
    [anon_sym_BANG_TILDE] = ACTIONS(3608),
    [anon_sym_LT_EQ] = ACTIONS(3610),
    [anon_sym_GT] = ACTIONS(3610),
    [anon_sym_GT_EQ] = ACTIONS(3608),
    [anon_sym_CARET] = ACTIONS(3608),
    [anon_sym_PLUS] = ACTIONS(3610),
    [anon_sym_SLASH] = ACTIONS(3608),
    [anon_sym_PERCENT] = ACTIONS(3608),
    [anon_sym_BANG] = ACTIONS(3610),
    [anon_sym_TILDE] = ACTIONS(3608),
    [sym_constant] = ACTIONS(3608),
    [sym_identifier] = ACTIONS(3608),
    [sym_instance_variable] = ACTIONS(3608),
    [sym_class_variable] = ACTIONS(3608),
    [sym_global_variable] = ACTIONS(3608),
    [anon_sym_DASH] = ACTIONS(3610),
    [anon_sym_PLUS_AT] = ACTIONS(3608),
    [anon_sym_DASH_AT] = ACTIONS(3608),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3610),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3608),
    [anon_sym_BQUOTE] = ACTIONS(3608),
    [sym_comment] = ACTIONS(87),
  },
  [1316] = {
    [sym__line_break2] = ACTIONS(5508),
    [sym__heredoc_body_start2] = ACTIONS(5508),
    [ts_builtin_sym_end] = ACTIONS(5508),
    [anon_sym___END__] = ACTIONS(5508),
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_RPAREN] = ACTIONS(5508),
    [anon_sym_SEMI] = ACTIONS(5508),
    [anon_sym_end] = ACTIONS(5508),
    [anon_sym_if] = ACTIONS(5508),
    [anon_sym_unless] = ACTIONS(5508),
    [anon_sym_while] = ACTIONS(5508),
    [anon_sym_until] = ACTIONS(5508),
    [anon_sym_rescue] = ACTIONS(5508),
    [anon_sym_when] = ACTIONS(5508),
    [anon_sym_elsif] = ACTIONS(5508),
    [anon_sym_else] = ACTIONS(5508),
    [anon_sym_then] = ACTIONS(5508),
    [anon_sym_ensure] = ACTIONS(5508),
    [sym_comment] = ACTIONS(87),
  },
  [1317] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_in] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [1318] = {
    [sym__string_end2] = ACTIONS(5510),
    [sym_comment] = ACTIONS(87),
  },
  [1319] = {
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_COLON2] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [1320] = {
    [sym__string_end2] = ACTIONS(5512),
    [sym_comment] = ACTIONS(87),
  },
  [1321] = {
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_RBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_COLON2] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [1322] = {
    [sym__string_end2] = ACTIONS(5514),
    [sym_comment] = ACTIONS(87),
  },
  [1323] = {
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_COLON2] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [1324] = {
    [sym__string_end2] = ACTIONS(5516),
    [sym_comment] = ACTIONS(87),
  },
  [1325] = {
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [sym_comment] = ACTIONS(87),
  },
  [1326] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3481),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(5518),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5520),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1327] = {
    [aux_sym_string_array_repeat1] = STATE(3484),
    [sym__string_end2] = ACTIONS(5522),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5524),
  },
  [1328] = {
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_in] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_COLON2] = ACTIONS(929),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [sym_comment] = ACTIONS(87),
  },
  [1329] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3487),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(5526),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5528),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1330] = {
    [aux_sym_symbol_array_repeat1] = STATE(3490),
    [sym__string_end2] = ACTIONS(5530),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(5532),
  },
  [1331] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3491),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(3491),
    [sym_operator_assignment] = STATE(3491),
    [sym_conditional] = STATE(3491),
    [sym_range] = STATE(3491),
    [sym_binary] = STATE(3491),
    [sym_unary] = STATE(3491),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1332] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3498),
    [sym__argument] = STATE(3499),
    [sym_splat_argument] = STATE(3499),
    [sym_hash_splat_argument] = STATE(3499),
    [sym_block_argument] = STATE(3499),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3499),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1333] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(3498),
    [sym__argument] = STATE(3499),
    [sym_splat_argument] = STATE(3499),
    [sym_hash_splat_argument] = STATE(3499),
    [sym_block_argument] = STATE(3499),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3499),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1334] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(3498),
    [sym__argument] = STATE(3499),
    [sym_splat_argument] = STATE(3499),
    [sym_hash_splat_argument] = STATE(3499),
    [sym_block_argument] = STATE(3499),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3499),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1335] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(3498),
    [sym__argument] = STATE(3499),
    [sym_splat_argument] = STATE(3499),
    [sym_hash_splat_argument] = STATE(3499),
    [sym_block_argument] = STATE(3499),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3499),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2379),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1336] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3501),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(3501),
    [sym_operator_assignment] = STATE(3501),
    [sym_conditional] = STATE(3501),
    [sym_range] = STATE(3501),
    [sym_binary] = STATE(3501),
    [sym_unary] = STATE(3501),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1337] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3502),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(3502),
    [sym_operator_assignment] = STATE(3502),
    [sym_conditional] = STATE(3502),
    [sym_range] = STATE(3502),
    [sym_binary] = STATE(3502),
    [sym_unary] = STATE(3502),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1338] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1398),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(1398),
    [sym_operator_assignment] = STATE(1398),
    [sym_conditional] = STATE(1398),
    [sym_range] = STATE(1398),
    [sym_binary] = STATE(1398),
    [sym_unary] = STATE(1398),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1339] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [1340] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_RBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1341] = {
    [anon_sym_EQ] = ACTIONS(5582),
    [sym_comment] = ACTIONS(87),
  },
  [1342] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5584),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5586),
    [anon_sym_DASH_EQ] = ACTIONS(5586),
    [anon_sym_STAR_EQ] = ACTIONS(5586),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5586),
    [anon_sym_SLASH_EQ] = ACTIONS(5586),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5586),
    [anon_sym_PIPE_EQ] = ACTIONS(5586),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5586),
    [anon_sym_AMP_EQ] = ACTIONS(5586),
    [anon_sym_PERCENT_EQ] = ACTIONS(5586),
    [anon_sym_GT_GT_EQ] = ACTIONS(5586),
    [anon_sym_LT_LT_EQ] = ACTIONS(5586),
    [anon_sym_CARET_EQ] = ACTIONS(5586),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1343] = {
    [sym_string] = STATE(3526),
    [aux_sym_chained_string_repeat1] = STATE(3526),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1344] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [1345] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1346] = {
    [sym_string] = STATE(1452),
    [aux_sym_chained_string_repeat1] = STATE(1452),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1347] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3527),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(3527),
    [sym_operator_assignment] = STATE(3527),
    [sym_conditional] = STATE(3527),
    [sym_range] = STATE(3527),
    [sym_binary] = STATE(3527),
    [sym_unary] = STATE(3527),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1348] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_in] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_RBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_COLON2] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [1349] = {
    [anon_sym_RBRACE] = ACTIONS(5588),
    [sym_comment] = ACTIONS(87),
  },
  [1350] = {
    [sym_heredoc_body] = STATE(3529),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(5588),
    [sym_comment] = ACTIONS(87),
  },
  [1351] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3530),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(3530),
    [sym_operator_assignment] = STATE(3530),
    [sym_conditional] = STATE(3530),
    [sym_range] = STATE(3530),
    [sym_binary] = STATE(3530),
    [sym_unary] = STATE(3530),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1352] = {
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_COLON2] = ACTIONS(1285),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [sym_comment] = ACTIONS(87),
  },
  [1353] = {
    [anon_sym_DOT] = ACTIONS(5590),
    [anon_sym_COLON_COLON] = ACTIONS(5590),
    [sym_comment] = ACTIONS(87),
  },
  [1354] = {
    [sym_method_parameters] = STATE(3532),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(3532),
    [sym__terminator] = STATE(3532),
    [sym__line_break2] = ACTIONS(5592),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(5592),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [1355] = {
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_RBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_COLON2] = ACTIONS(1303),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(1301),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [sym_comment] = ACTIONS(87),
  },
  [1356] = {
    [anon_sym_RPAREN] = ACTIONS(5594),
    [sym_comment] = ACTIONS(87),
  },
  [1357] = {
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym__heredoc_body_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_rescue] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_EQ_GT] = ACTIONS(1427),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_RBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_COLON2] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [1358] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [1359] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3534),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3534),
    [sym_operator_assignment] = STATE(3534),
    [sym_conditional] = STATE(3534),
    [sym_range] = STATE(3534),
    [sym_binary] = STATE(3534),
    [sym_unary] = STATE(3534),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1360] = {
    [sym_superclass] = STATE(3535),
    [sym_heredoc_body] = STATE(3536),
    [sym__terminator] = STATE(3536),
    [sym__line_break2] = ACTIONS(5596),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1361] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(3535),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3536),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(3536),
    [sym__line_break2] = ACTIONS(5596),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(5596),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1362] = {
    [sym_heredoc_body] = STATE(3538),
    [sym__terminator] = STATE(3538),
    [sym__line_break2] = ACTIONS(5598),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(5600),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1363] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3538),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(3538),
    [sym__line_break2] = ACTIONS(5598),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(5598),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(5600),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1364] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3539),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3539),
    [sym_operator_assignment] = STATE(3539),
    [sym_conditional] = STATE(3539),
    [sym_range] = STATE(3539),
    [sym_binary] = STATE(3539),
    [sym_unary] = STATE(3539),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1365] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3540),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3540),
    [sym_operator_assignment] = STATE(3540),
    [sym_conditional] = STATE(3540),
    [sym_range] = STATE(3540),
    [sym_binary] = STATE(3540),
    [sym_unary] = STATE(3540),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1366] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3541),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3541),
    [sym_operator_assignment] = STATE(3541),
    [sym_conditional] = STATE(3541),
    [sym_range] = STATE(3541),
    [sym_binary] = STATE(3541),
    [sym_unary] = STATE(3541),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1367] = {
    [anon_sym_COLON] = ACTIONS(5604),
    [sym_comment] = ACTIONS(87),
  },
  [1368] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3543),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3543),
    [sym_operator_assignment] = STATE(3543),
    [sym_conditional] = STATE(3543),
    [sym_range] = STATE(3543),
    [sym_binary] = STATE(3543),
    [sym_unary] = STATE(3543),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1369] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3544),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3544),
    [sym_operator_assignment] = STATE(3544),
    [sym_conditional] = STATE(3544),
    [sym_range] = STATE(3544),
    [sym_binary] = STATE(3544),
    [sym_unary] = STATE(3544),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1370] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3545),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(3545),
    [sym_operator_assignment] = STATE(3545),
    [sym_conditional] = STATE(3545),
    [sym_range] = STATE(3545),
    [sym_binary] = STATE(3545),
    [sym_unary] = STATE(3545),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1371] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1372] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(5606),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1373] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [1374] = {
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [1375] = {
    [sym_heredoc_body] = STATE(3559),
    [aux_sym_call_repeat1] = STATE(3559),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1376] = {
    [sym_heredoc_body] = STATE(3559),
    [aux_sym_call_repeat1] = STATE(3559),
    [aux_sym_argument_list_repeat1] = STATE(3561),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1377] = {
    [anon_sym_EQ] = ACTIONS(5640),
    [sym_comment] = ACTIONS(87),
  },
  [1378] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5642),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5644),
    [anon_sym_DASH_EQ] = ACTIONS(5644),
    [anon_sym_STAR_EQ] = ACTIONS(5644),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5644),
    [anon_sym_SLASH_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_PIPE_EQ] = ACTIONS(5644),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5644),
    [anon_sym_AMP_EQ] = ACTIONS(5644),
    [anon_sym_PERCENT_EQ] = ACTIONS(5644),
    [anon_sym_GT_GT_EQ] = ACTIONS(5644),
    [anon_sym_LT_LT_EQ] = ACTIONS(5644),
    [anon_sym_CARET_EQ] = ACTIONS(5644),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1379] = {
    [sym_string] = STATE(1452),
    [aux_sym_chained_string_repeat1] = STATE(1452),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5646),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1380] = {
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_RBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_COLON2] = ACTIONS(1721),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1719),
    [sym_comment] = ACTIONS(87),
  },
  [1381] = {
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_in] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_EQ_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_RBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_COLON2] = ACTIONS(1725),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1723),
    [anon_sym_AMP_AMP] = ACTIONS(1723),
    [anon_sym_LT_LT] = ACTIONS(1723),
    [anon_sym_GT_GT] = ACTIONS(1723),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1723),
    [anon_sym_PLUS] = ACTIONS(1723),
    [anon_sym_SLASH] = ACTIONS(1723),
    [anon_sym_PERCENT] = ACTIONS(1723),
    [sym_comment] = ACTIONS(87),
  },
  [1382] = {
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_COLON2] = ACTIONS(1729),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1727),
    [anon_sym_GT_GT] = ACTIONS(1727),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_PERCENT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(87),
  },
  [1383] = {
    [sym__then] = STATE(3564),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(5648),
    [sym_comment] = ACTIONS(87),
  },
  [1384] = {
    [sym__then] = STATE(3565),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(5650),
    [sym_comment] = ACTIONS(87),
  },
  [1385] = {
    [sym__do] = STATE(3566),
    [sym_heredoc_body] = STATE(3566),
    [sym__terminator] = STATE(3566),
    [sym__line_break2] = ACTIONS(5652),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5652),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(5652),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [1386] = {
    [sym__do] = STATE(3567),
    [sym_heredoc_body] = STATE(3567),
    [sym__terminator] = STATE(3567),
    [sym__line_break2] = ACTIONS(5654),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5654),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(5654),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [1387] = {
    [sym_in] = STATE(3568),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [1388] = {
    [sym_heredoc_body] = STATE(3569),
    [sym__terminator] = STATE(3569),
    [sym__line_break2] = ACTIONS(5656),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(5656),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [1389] = {
    [sym_when] = STATE(3570),
    [aux_sym_case_repeat1] = STATE(3571),
    [anon_sym_SEMI] = ACTIONS(5658),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1390] = {
    [sym_else] = STATE(3573),
    [sym_ensure] = STATE(3574),
    [sym_rescue] = STATE(3575),
    [anon_sym_end] = ACTIONS(5660),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1391] = {
    [sym_ensure] = STATE(3574),
    [anon_sym_end] = ACTIONS(5660),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1392] = {
    [anon_sym_end] = ACTIONS(5660),
    [sym_comment] = ACTIONS(87),
  },
  [1393] = {
    [sym_else] = STATE(3573),
    [sym_ensure] = STATE(3574),
    [anon_sym_end] = ACTIONS(5660),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1394] = {
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_EQ_GT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_RBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_COLON2] = ACTIONS(2221),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [anon_sym_PERCENT] = ACTIONS(2219),
    [sym_comment] = ACTIONS(87),
  },
  [1395] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(3576),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5662),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1396] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1397] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [1398] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1399] = {
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_COLON2] = ACTIONS(2309),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
  },
  [1400] = {
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_in] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_EQ_GT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_RBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_COLON2] = ACTIONS(2393),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2391),
    [anon_sym_AMP_AMP] = ACTIONS(2391),
    [anon_sym_LT_LT] = ACTIONS(2391),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_SLASH] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(87),
  },
  [1401] = {
    [sym_heredoc_body] = STATE(3578),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
  },
  [1402] = {
    [anon_sym_RBRACK] = ACTIONS(5664),
    [sym_comment] = ACTIONS(87),
  },
  [1403] = {
    [sym__statements] = STATE(3580),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3581),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5666),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1404] = {
    [sym__statements] = STATE(3583),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3584),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3585),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(3585),
    [sym__line_break2] = ACTIONS(5668),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5670),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1405] = {
    [sym_do_block] = STATE(3586),
    [sym_block] = STATE(3586),
    [anon_sym_LBRACE] = ACTIONS(2401),
    [anon_sym_do] = ACTIONS(5672),
    [sym_comment] = ACTIONS(87),
  },
  [1406] = {
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_in] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_RBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_COLON2] = ACTIONS(2539),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [1407] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3587),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3587),
    [sym_operator_assignment] = STATE(3587),
    [sym_conditional] = STATE(3587),
    [sym_range] = STATE(3587),
    [sym_binary] = STATE(3587),
    [sym_unary] = STATE(3587),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1408] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3588),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3588),
    [sym_operator_assignment] = STATE(3588),
    [sym_conditional] = STATE(3588),
    [sym_range] = STATE(3588),
    [sym_binary] = STATE(3588),
    [sym_unary] = STATE(3588),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1409] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3589),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3589),
    [sym_operator_assignment] = STATE(3589),
    [sym_conditional] = STATE(3589),
    [sym_range] = STATE(3589),
    [sym_binary] = STATE(3589),
    [sym_unary] = STATE(3589),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1410] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3590),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3590),
    [sym_operator_assignment] = STATE(3590),
    [sym_conditional] = STATE(3590),
    [sym_range] = STATE(3590),
    [sym_binary] = STATE(3590),
    [sym_unary] = STATE(3590),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1411] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3591),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3591),
    [sym_operator_assignment] = STATE(3591),
    [sym_conditional] = STATE(3591),
    [sym_range] = STATE(3591),
    [sym_binary] = STATE(3591),
    [sym_unary] = STATE(3591),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1412] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3592),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3592),
    [sym_operator_assignment] = STATE(3592),
    [sym_conditional] = STATE(3592),
    [sym_range] = STATE(3592),
    [sym_binary] = STATE(3592),
    [sym_unary] = STATE(3592),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1413] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3593),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(3593),
    [sym_operator_assignment] = STATE(3593),
    [sym_conditional] = STATE(3593),
    [sym_range] = STATE(3593),
    [sym_binary] = STATE(3593),
    [sym_unary] = STATE(3593),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1414] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3594),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3594),
    [sym_operator_assignment] = STATE(3594),
    [sym_conditional] = STATE(3594),
    [sym_range] = STATE(3594),
    [sym_binary] = STATE(3594),
    [sym_unary] = STATE(3594),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1415] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3595),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3595),
    [sym_operator_assignment] = STATE(3595),
    [sym_conditional] = STATE(3595),
    [sym_range] = STATE(3595),
    [sym_binary] = STATE(3595),
    [sym_unary] = STATE(3595),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1416] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3596),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3596),
    [sym_operator_assignment] = STATE(3596),
    [sym_conditional] = STATE(3596),
    [sym_range] = STATE(3596),
    [sym_binary] = STATE(3596),
    [sym_unary] = STATE(3596),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1417] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3597),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3597),
    [sym_operator_assignment] = STATE(3597),
    [sym_conditional] = STATE(3597),
    [sym_range] = STATE(3597),
    [sym_binary] = STATE(3597),
    [sym_unary] = STATE(3597),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1418] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3598),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3598),
    [sym_operator_assignment] = STATE(3598),
    [sym_conditional] = STATE(3598),
    [sym_range] = STATE(3598),
    [sym_binary] = STATE(3598),
    [sym_unary] = STATE(3598),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1419] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3599),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3599),
    [sym_operator_assignment] = STATE(3599),
    [sym_conditional] = STATE(3599),
    [sym_range] = STATE(3599),
    [sym_binary] = STATE(3599),
    [sym_unary] = STATE(3599),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1420] = {
    [sym_argument_list_with_parens] = STATE(3602),
    [sym__argument_list_with_parens] = STATE(3603),
    [sym_operator] = STATE(3602),
    [sym_heredoc_body] = STATE(3604),
    [aux_sym_call_repeat1] = STATE(3604),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_STAR_STAR] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LPAREN2] = ACTIONS(5678),
    [anon_sym_DOT_DOT] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_BANG_TILDE] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_CARET] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5674),
    [sym_constant] = ACTIONS(5680),
    [sym_identifier] = ACTIONS(5680),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS_AT] = ACTIONS(5674),
    [anon_sym_DASH_AT] = ACTIONS(5674),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [1421] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(3606),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3607),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5682),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1422] = {
    [sym_constant] = ACTIONS(5684),
    [sym_identifier] = ACTIONS(5684),
    [sym_comment] = ACTIONS(87),
  },
  [1423] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3609),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3609),
    [sym_operator_assignment] = STATE(3609),
    [sym_conditional] = STATE(3609),
    [sym_range] = STATE(3609),
    [sym_binary] = STATE(3609),
    [sym_unary] = STATE(3609),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1424] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3611),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3611),
    [sym_operator_assignment] = STATE(3611),
    [sym_conditional] = STATE(3611),
    [sym_range] = STATE(3611),
    [sym_binary] = STATE(3611),
    [sym_unary] = STATE(3611),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1425] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3612),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3612),
    [sym_operator_assignment] = STATE(3612),
    [sym_conditional] = STATE(3612),
    [sym_range] = STATE(3612),
    [sym_binary] = STATE(3612),
    [sym_unary] = STATE(3612),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1426] = {
    [anon_sym_COLON] = ACTIONS(5688),
    [sym_comment] = ACTIONS(87),
  },
  [1427] = {
    [sym__statements] = STATE(3615),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(3616),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5690),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1428] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3617),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3617),
    [sym_operator_assignment] = STATE(3617),
    [sym_conditional] = STATE(3617),
    [sym_range] = STATE(3617),
    [sym_binary] = STATE(3617),
    [sym_unary] = STATE(3617),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1429] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1430] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1431] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1432] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1433] = {
    [sym__statements] = STATE(3619),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3620),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3621),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(3621),
    [sym__line_break2] = ACTIONS(5692),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5694),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1434] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3622),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3622),
    [sym_operator_assignment] = STATE(3622),
    [sym_conditional] = STATE(3622),
    [sym_range] = STATE(3622),
    [sym_binary] = STATE(3622),
    [sym_unary] = STATE(3622),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1435] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3623),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(3623),
    [sym_operator_assignment] = STATE(3623),
    [sym_conditional] = STATE(3623),
    [sym_range] = STATE(3623),
    [sym_binary] = STATE(3623),
    [sym_unary] = STATE(3623),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1436] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1437] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(5696),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1438] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [1439] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(1441),
    [sym__argument] = STATE(1442),
    [sym_splat_argument] = STATE(1442),
    [sym_hash_splat_argument] = STATE(1442),
    [sym_block_argument] = STATE(1442),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1442),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_RBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1440] = {
    [sym_do_block] = STATE(3637),
    [sym_block] = STATE(3637),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(5726),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1441] = {
    [sym_heredoc_body] = STATE(3638),
    [aux_sym_call_repeat1] = STATE(3638),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1442] = {
    [sym_heredoc_body] = STATE(3638),
    [aux_sym_call_repeat1] = STATE(3638),
    [aux_sym_argument_list_repeat1] = STATE(3640),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1443] = {
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1444] = {
    [anon_sym_EQ] = ACTIONS(5730),
    [sym_comment] = ACTIONS(87),
  },
  [1445] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5732),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5734),
    [anon_sym_DASH_EQ] = ACTIONS(5734),
    [anon_sym_STAR_EQ] = ACTIONS(5734),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5734),
    [anon_sym_SLASH_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_PIPE_EQ] = ACTIONS(5734),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5734),
    [anon_sym_AMP_EQ] = ACTIONS(5734),
    [anon_sym_PERCENT_EQ] = ACTIONS(5734),
    [anon_sym_GT_GT_EQ] = ACTIONS(5734),
    [anon_sym_LT_LT_EQ] = ACTIONS(5734),
    [anon_sym_CARET_EQ] = ACTIONS(5734),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1446] = {
    [sym_string] = STATE(3643),
    [aux_sym_chained_string_repeat1] = STATE(3643),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(5736),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1447] = {
    [sym__line_break2] = ACTIONS(5738),
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [ts_builtin_sym_end] = ACTIONS(5738),
    [anon_sym___END__] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_end] = ACTIONS(5738),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_when] = ACTIONS(5738),
    [anon_sym_elsif] = ACTIONS(5738),
    [anon_sym_else] = ACTIONS(5738),
    [anon_sym_then] = ACTIONS(5738),
    [anon_sym_ensure] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_PLUS] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5738),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(87),
  },
  [1448] = {
    [anon_sym_RBRACK] = ACTIONS(5742),
    [sym_comment] = ACTIONS(87),
  },
  [1449] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(3646),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3647),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(5744),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(5746),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1450] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3649),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_splat_argument] = STATE(3651),
    [sym_assignment] = STATE(3649),
    [sym_operator_assignment] = STATE(3649),
    [sym_conditional] = STATE(3649),
    [sym_range] = STATE(3649),
    [sym_binary] = STATE(3649),
    [sym_unary] = STATE(3649),
    [sym_right_assignment_list] = STATE(3650),
    [sym__arg_or_splat_arg] = STATE(3651),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(5748),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1451] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3652),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(3652),
    [sym_operator_assignment] = STATE(3652),
    [sym_conditional] = STATE(3652),
    [sym_range] = STATE(3652),
    [sym_binary] = STATE(3652),
    [sym_unary] = STATE(3652),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1452] = {
    [sym_string] = STATE(3653),
    [aux_sym_chained_string_repeat1] = STATE(3653),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1453] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [1454] = {
    [sym__formal_parameter] = STATE(3658),
    [sym__simple_formal_parameter] = STATE(3658),
    [sym_destructured_parameter] = STATE(3658),
    [sym_splat_parameter] = STATE(3658),
    [sym_hash_splat_parameter] = STATE(3658),
    [sym_block_parameter] = STATE(3658),
    [sym_keyword_parameter] = STATE(3658),
    [sym_optional_parameter] = STATE(3658),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_COMMA] = ACTIONS(5754),
    [anon_sym_PIPE] = ACTIONS(5756),
    [anon_sym_SEMI] = ACTIONS(5758),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [1455] = {
    [anon_sym_RBRACE] = ACTIONS(5762),
    [sym_comment] = ACTIONS(87),
  },
  [1456] = {
    [sym__statements] = STATE(3660),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5762),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1457] = {
    [sym__formal_parameter] = STATE(3661),
    [sym__simple_formal_parameter] = STATE(3661),
    [sym_destructured_parameter] = STATE(3661),
    [sym_splat_parameter] = STATE(3661),
    [sym_hash_splat_parameter] = STATE(3661),
    [sym_block_parameter] = STATE(3661),
    [sym_keyword_parameter] = STATE(3661),
    [sym_optional_parameter] = STATE(3661),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2503),
    [sym_comment] = ACTIONS(87),
  },
  [1458] = {
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_do] = ACTIONS(5764),
    [sym_comment] = ACTIONS(87),
  },
  [1459] = {
    [anon_sym_RPAREN] = ACTIONS(2525),
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_COLON] = ACTIONS(5766),
    [anon_sym_EQ] = ACTIONS(5768),
    [sym_comment] = ACTIONS(87),
  },
  [1460] = {
    [aux_sym_method_parameters_repeat1] = STATE(3666),
    [anon_sym_RPAREN] = ACTIONS(5770),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [1461] = {
    [anon_sym_LBRACE] = ACTIONS(5774),
    [anon_sym_RPAREN] = ACTIONS(5774),
    [anon_sym_COMMA] = ACTIONS(5774),
    [anon_sym_PIPE] = ACTIONS(5774),
    [anon_sym_SEMI] = ACTIONS(5774),
    [anon_sym_do] = ACTIONS(5774),
    [sym_comment] = ACTIONS(87),
  },
  [1462] = {
    [anon_sym_LBRACE] = ACTIONS(5776),
    [anon_sym_RPAREN] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_PIPE] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [anon_sym_do] = ACTIONS(5776),
    [sym_comment] = ACTIONS(87),
  },
  [1463] = {
    [anon_sym_LBRACE] = ACTIONS(5778),
    [anon_sym_RPAREN] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_PIPE] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5778),
    [anon_sym_do] = ACTIONS(5778),
    [sym_comment] = ACTIONS(87),
  },
  [1464] = {
    [sym__formal_parameter] = STATE(3670),
    [sym__simple_formal_parameter] = STATE(3670),
    [sym_destructured_parameter] = STATE(3670),
    [sym_splat_parameter] = STATE(3670),
    [sym_hash_splat_parameter] = STATE(3670),
    [sym_block_parameter] = STATE(3670),
    [sym_keyword_parameter] = STATE(3670),
    [sym_optional_parameter] = STATE(3670),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_COMMA] = ACTIONS(5780),
    [anon_sym_PIPE] = ACTIONS(5782),
    [anon_sym_SEMI] = ACTIONS(5784),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [1465] = {
    [sym__line_break2] = ACTIONS(5786),
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [ts_builtin_sym_end] = ACTIONS(5786),
    [anon_sym___END__] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_end] = ACTIONS(5786),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_when] = ACTIONS(5786),
    [anon_sym_elsif] = ACTIONS(5786),
    [anon_sym_else] = ACTIONS(5786),
    [anon_sym_then] = ACTIONS(5786),
    [anon_sym_ensure] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [1466] = {
    [anon_sym_end] = ACTIONS(5790),
    [sym_comment] = ACTIONS(87),
  },
  [1467] = {
    [sym__statements] = STATE(3672),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3673),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(3673),
    [sym__line_break2] = ACTIONS(5792),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5794),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1468] = {
    [sym__statements] = STATE(3672),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3674),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5794),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1469] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3683),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(3683),
    [sym_operator_assignment] = STATE(3683),
    [sym_conditional] = STATE(3683),
    [sym_range] = STATE(3683),
    [sym_binary] = STATE(3683),
    [sym_unary] = STATE(3683),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_do] = ACTIONS(5808),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1470] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3688),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(3688),
    [sym_operator_assignment] = STATE(3688),
    [sym_conditional] = STATE(3688),
    [sym_range] = STATE(3688),
    [sym_binary] = STATE(3688),
    [sym_unary] = STATE(3688),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1471] = {
    [sym__line_break2] = ACTIONS(5822),
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [anon_sym___END__] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5822),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_when] = ACTIONS(5822),
    [anon_sym_elsif] = ACTIONS(5822),
    [anon_sym_else] = ACTIONS(5822),
    [anon_sym_then] = ACTIONS(5822),
    [anon_sym_ensure] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_AMP_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [1472] = {
    [sym__simple_formal_parameter] = STATE(3689),
    [sym_splat_parameter] = STATE(3689),
    [sym_hash_splat_parameter] = STATE(3689),
    [sym_block_parameter] = STATE(3689),
    [sym_keyword_parameter] = STATE(3689),
    [sym_optional_parameter] = STATE(3689),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5826),
    [sym_comment] = ACTIONS(87),
  },
  [1473] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3690),
    [anon_sym_LBRACE] = ACTIONS(5764),
    [anon_sym_COMMA] = ACTIONS(2535),
    [anon_sym_do] = ACTIONS(5764),
    [sym_comment] = ACTIONS(87),
  },
  [1474] = {
    [sym_uninterpreted] = ACTIONS(5828),
    [sym_comment] = ACTIONS(109),
  },
  [1475] = {
    [sym__line_break2] = ACTIONS(5830),
    [sym__heredoc_body_start2] = ACTIONS(5830),
    [ts_builtin_sym_end] = ACTIONS(5830),
    [anon_sym___END__] = ACTIONS(5830),
    [anon_sym_RBRACE] = ACTIONS(5830),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(5830),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_rescue] = ACTIONS(5830),
    [anon_sym_when] = ACTIONS(5830),
    [anon_sym_elsif] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [anon_sym_ensure] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [1476] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(47),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(49),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(49),
    [sym_operator_assignment] = STATE(49),
    [sym_conditional] = STATE(49),
    [sym_range] = STATE(49),
    [sym_binary] = STATE(49),
    [sym_unary] = STATE(49),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [ts_builtin_sym_end] = ACTIONS(5832),
    [anon_sym___END__] = ACTIONS(5834),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1477] = {
    [sym_heredoc_body] = STATE(3692),
    [sym__terminator] = STATE(3692),
    [aux_sym__statements_repeat1] = STATE(1477),
    [sym__line_break2] = ACTIONS(5836),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [ts_builtin_sym_end] = ACTIONS(5830),
    [anon_sym___END__] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(5836),
    [sym_comment] = ACTIONS(87),
  },
  [1478] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5842),
    [anon_sym___END__] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1479] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5844),
    [anon_sym___END__] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1480] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5846),
    [anon_sym___END__] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1481] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5848),
    [anon_sym___END__] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1482] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5850),
    [anon_sym___END__] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(723),
    [anon_sym_or] = ACTIONS(723),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1483] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1484] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [1485] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1486] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [1487] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1488] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1489] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(3694),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(5864),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1490] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3695),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3695),
    [sym_operator_assignment] = STATE(3695),
    [sym_conditional] = STATE(3695),
    [sym_range] = STATE(3695),
    [sym_binary] = STATE(3695),
    [sym_unary] = STATE(3695),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1491] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(3711),
    [sym__argument] = STATE(3712),
    [sym_splat_argument] = STATE(3712),
    [sym_hash_splat_argument] = STATE(3712),
    [sym_block_argument] = STATE(3712),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3712),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1492] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(3711),
    [sym__argument] = STATE(3712),
    [sym_splat_argument] = STATE(3712),
    [sym_hash_splat_argument] = STATE(3712),
    [sym_block_argument] = STATE(3712),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3712),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1493] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(3711),
    [sym__argument] = STATE(3712),
    [sym_splat_argument] = STATE(3712),
    [sym_hash_splat_argument] = STATE(3712),
    [sym_block_argument] = STATE(3712),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3712),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1494] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(3711),
    [sym__argument] = STATE(3712),
    [sym_splat_argument] = STATE(3712),
    [sym_hash_splat_argument] = STATE(3712),
    [sym_block_argument] = STATE(3712),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3712),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1495] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3716),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3716),
    [sym_operator_assignment] = STATE(3716),
    [sym_conditional] = STATE(3716),
    [sym_range] = STATE(3716),
    [sym_binary] = STATE(3716),
    [sym_unary] = STATE(3716),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1496] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3717),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3717),
    [sym_operator_assignment] = STATE(3717),
    [sym_conditional] = STATE(3717),
    [sym_range] = STATE(3717),
    [sym_binary] = STATE(3717),
    [sym_unary] = STATE(3717),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1497] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1498] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(5910),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [1499] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(1742),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_do_block] = STATE(1745),
    [sym_block] = STATE(1745),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1500] = {
    [anon_sym_EQ] = ACTIONS(5960),
    [sym_comment] = ACTIONS(87),
  },
  [1501] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(5962),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(5964),
    [anon_sym_DASH_EQ] = ACTIONS(5964),
    [anon_sym_STAR_EQ] = ACTIONS(5964),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5964),
    [anon_sym_SLASH_EQ] = ACTIONS(5964),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5964),
    [anon_sym_PIPE_EQ] = ACTIONS(5964),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5964),
    [anon_sym_AMP_EQ] = ACTIONS(5964),
    [anon_sym_PERCENT_EQ] = ACTIONS(5964),
    [anon_sym_GT_GT_EQ] = ACTIONS(5964),
    [anon_sym_LT_LT_EQ] = ACTIONS(5964),
    [anon_sym_CARET_EQ] = ACTIONS(5964),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1502] = {
    [sym_string] = STATE(3753),
    [aux_sym_chained_string_repeat1] = STATE(3753),
    [sym__string_start2] = ACTIONS(2549),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1503] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1504] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1505] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1506] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1507] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1508] = {
    [sym_interpolation] = STATE(3755),
    [aux_sym_heredoc_body_repeat1] = STATE(3755),
    [sym__heredoc_content2] = ACTIONS(5968),
    [sym_heredoc_end2] = ACTIONS(5970),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(5968),
  },
  [1509] = {
    [sym__line_break2] = ACTIONS(1273),
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(1275),
    [anon_sym_elsif] = ACTIONS(1275),
    [anon_sym_else] = ACTIONS(1275),
    [anon_sym_then] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_ensure] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [1510] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(3757),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3758),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5972),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1511] = {
    [sym__line_break2] = ACTIONS(5974),
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym__heredoc_body_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5976),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_end] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_rescue] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_when] = ACTIONS(5976),
    [anon_sym_elsif] = ACTIONS(5976),
    [anon_sym_else] = ACTIONS(5976),
    [anon_sym_then] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_ensure] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [1512] = {
    [sym__line_break2] = ACTIONS(5978),
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym__heredoc_body_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [ts_builtin_sym_end] = ACTIONS(5978),
    [anon_sym___END__] = ACTIONS(5980),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_end] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_rescue] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_when] = ACTIONS(5980),
    [anon_sym_elsif] = ACTIONS(5980),
    [anon_sym_else] = ACTIONS(5980),
    [anon_sym_then] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_ensure] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [1513] = {
    [sym_argument_list_with_parens] = STATE(3759),
    [sym__argument_list_with_parens] = STATE(1512),
    [sym_operator] = STATE(3759),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(2575),
    [anon_sym_STAR] = ACTIONS(2577),
    [anon_sym_STAR_STAR] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_LT] = ACTIONS(2577),
    [anon_sym_LPAREN2] = ACTIONS(2579),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym_LT_LT] = ACTIONS(2575),
    [anon_sym_GT_GT] = ACTIONS(2575),
    [anon_sym_EQ_EQ] = ACTIONS(2577),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2575),
    [anon_sym_LT_EQ_GT] = ACTIONS(2575),
    [anon_sym_EQ_TILDE] = ACTIONS(2575),
    [anon_sym_BANG_TILDE] = ACTIONS(2575),
    [anon_sym_LT_EQ] = ACTIONS(2577),
    [anon_sym_GT] = ACTIONS(2577),
    [anon_sym_GT_EQ] = ACTIONS(2575),
    [anon_sym_CARET] = ACTIONS(2575),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_SLASH] = ACTIONS(2575),
    [anon_sym_PERCENT] = ACTIONS(2575),
    [anon_sym_BANG] = ACTIONS(2577),
    [anon_sym_TILDE] = ACTIONS(2575),
    [sym_constant] = ACTIONS(5982),
    [sym_identifier] = ACTIONS(5982),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_PLUS_AT] = ACTIONS(2575),
    [anon_sym_DASH_AT] = ACTIONS(2575),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2577),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2575),
    [anon_sym_BQUOTE] = ACTIONS(2575),
    [sym_comment] = ACTIONS(87),
  },
  [1514] = {
    [sym__line_break2] = ACTIONS(5984),
    [sym__heredoc_body_start2] = ACTIONS(5984),
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [ts_builtin_sym_end] = ACTIONS(5984),
    [anon_sym___END__] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_end] = ACTIONS(5984),
    [anon_sym_if] = ACTIONS(5984),
    [anon_sym_unless] = ACTIONS(5984),
    [anon_sym_while] = ACTIONS(5984),
    [anon_sym_until] = ACTIONS(5984),
    [anon_sym_rescue] = ACTIONS(5984),
    [anon_sym_do] = ACTIONS(5984),
    [anon_sym_when] = ACTIONS(5984),
    [anon_sym_elsif] = ACTIONS(5984),
    [anon_sym_else] = ACTIONS(5984),
    [anon_sym_then] = ACTIONS(5984),
    [anon_sym_ensure] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [1515] = {
    [sym_heredoc_body] = STATE(3762),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(5988),
    [sym_comment] = ACTIONS(87),
  },
  [1516] = {
    [anon_sym_RBRACK] = ACTIONS(5988),
    [sym_comment] = ACTIONS(87),
  },
  [1517] = {
    [sym__line_break2] = ACTIONS(5990),
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym__heredoc_body_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [ts_builtin_sym_end] = ACTIONS(5990),
    [anon_sym___END__] = ACTIONS(5992),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_end] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_rescue] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_when] = ACTIONS(5992),
    [anon_sym_elsif] = ACTIONS(5992),
    [anon_sym_else] = ACTIONS(5992),
    [anon_sym_then] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_ensure] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [1518] = {
    [sym__line_break2] = ACTIONS(841),
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [ts_builtin_sym_end] = ACTIONS(841),
    [anon_sym___END__] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_when] = ACTIONS(841),
    [anon_sym_elsif] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_then] = ACTIONS(841),
    [anon_sym_ensure] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
    [anon_sym_STAR_EQ] = ACTIONS(841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(841),
    [anon_sym_SLASH_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(841),
    [anon_sym_PIPE_EQ] = ACTIONS(841),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(841),
    [anon_sym_AMP_EQ] = ACTIONS(841),
    [anon_sym_PERCENT_EQ] = ACTIONS(841),
    [anon_sym_GT_GT_EQ] = ACTIONS(841),
    [anon_sym_LT_LT_EQ] = ACTIONS(841),
    [anon_sym_CARET_EQ] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [sym_comment] = ACTIONS(87),
  },
  [1519] = {
    [sym__string_end2] = ACTIONS(5994),
    [sym_comment] = ACTIONS(87),
  },
  [1520] = {
    [sym__line_break2] = ACTIONS(891),
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym___END__] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_end] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_when] = ACTIONS(891),
    [anon_sym_elsif] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_then] = ACTIONS(891),
    [anon_sym_ensure] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [1521] = {
    [sym__string_end2] = ACTIONS(5996),
    [sym_comment] = ACTIONS(87),
  },
  [1522] = {
    [sym__line_break2] = ACTIONS(897),
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(897),
    [anon_sym___END__] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(897),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_when] = ACTIONS(897),
    [anon_sym_elsif] = ACTIONS(897),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_then] = ACTIONS(897),
    [anon_sym_ensure] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [anon_sym_DASH_EQ] = ACTIONS(897),
    [anon_sym_STAR_EQ] = ACTIONS(897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(897),
    [anon_sym_SLASH_EQ] = ACTIONS(897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(897),
    [anon_sym_PIPE_EQ] = ACTIONS(897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(897),
    [anon_sym_AMP_EQ] = ACTIONS(897),
    [anon_sym_PERCENT_EQ] = ACTIONS(897),
    [anon_sym_GT_GT_EQ] = ACTIONS(897),
    [anon_sym_LT_LT_EQ] = ACTIONS(897),
    [anon_sym_CARET_EQ] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [1523] = {
    [sym__string_end2] = ACTIONS(5998),
    [sym_comment] = ACTIONS(87),
  },
  [1524] = {
    [sym__line_break2] = ACTIONS(903),
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym___END__] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_when] = ACTIONS(903),
    [anon_sym_elsif] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_then] = ACTIONS(903),
    [anon_sym_ensure] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [anon_sym_DASH_EQ] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(903),
    [anon_sym_SLASH_EQ] = ACTIONS(903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(903),
    [anon_sym_PIPE_EQ] = ACTIONS(903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(903),
    [anon_sym_AMP_EQ] = ACTIONS(903),
    [anon_sym_PERCENT_EQ] = ACTIONS(903),
    [anon_sym_GT_GT_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_EQ] = ACTIONS(903),
    [anon_sym_CARET_EQ] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [1525] = {
    [sym__string_end2] = ACTIONS(6000),
    [sym_comment] = ACTIONS(87),
  },
  [1526] = {
    [sym__line_break2] = ACTIONS(909),
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [sym_comment] = ACTIONS(87),
  },
  [1527] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3769),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6002),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6004),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1528] = {
    [aux_sym_string_array_repeat1] = STATE(3772),
    [sym__string_end2] = ACTIONS(6006),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6008),
  },
  [1529] = {
    [sym__line_break2] = ACTIONS(927),
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym___END__] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_when] = ACTIONS(927),
    [anon_sym_elsif] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_then] = ACTIONS(927),
    [anon_sym_ensure] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [sym_comment] = ACTIONS(87),
  },
  [1530] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3775),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6010),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6012),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1531] = {
    [aux_sym_symbol_array_repeat1] = STATE(3778),
    [sym__string_end2] = ACTIONS(6014),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6016),
  },
  [1532] = {
    [sym__line_break2] = ACTIONS(101),
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym___END__] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_end] = ACTIONS(101),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_when] = ACTIONS(101),
    [anon_sym_elsif] = ACTIONS(101),
    [anon_sym_else] = ACTIONS(101),
    [anon_sym_then] = ACTIONS(101),
    [anon_sym_ensure] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [1533] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(3780),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(6018),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1534] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(3782),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(6020),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1535] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(3784),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(6022),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1536] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(3786),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(6024),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [1537] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3789),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6026),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6028),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1538] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(3792),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6030),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6032),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [1539] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3793),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3793),
    [sym_operator_assignment] = STATE(3793),
    [sym_conditional] = STATE(3793),
    [sym_range] = STATE(3793),
    [sym_binary] = STATE(3793),
    [sym_unary] = STATE(3793),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1540] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(3795),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(3796),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(6034),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1541] = {
    [sym__method_rest] = STATE(3798),
    [sym__variable] = STATE(3799),
    [sym_operator] = STATE(3800),
    [sym__method_name] = STATE(3800),
    [sym_setter] = STATE(3800),
    [sym_symbol] = STATE(3800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(6036),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(6038),
    [sym_self] = ACTIONS(6038),
  },
  [1542] = {
    [sym__statements] = STATE(3802),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(6040),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1543] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(3805),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(6042),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(6044),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1544] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(3807),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(6046),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1545] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(363),
    [anon_sym___END__] = ACTIONS(375),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1546] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(415),
    [anon_sym___END__] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1547] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(419),
    [anon_sym___END__] = ACTIONS(421),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1548] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(423),
    [anon_sym___END__] = ACTIONS(425),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1549] = {
    [sym__statement] = STATE(3812),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1550] = {
    [sym__statement] = STATE(3813),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1551] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3814),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(3814),
    [sym_operator_assignment] = STATE(3814),
    [sym_conditional] = STATE(3814),
    [sym_range] = STATE(3814),
    [sym_binary] = STATE(3814),
    [sym_unary] = STATE(3814),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1552] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3815),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(3815),
    [sym_operator_assignment] = STATE(3815),
    [sym_conditional] = STATE(3815),
    [sym_range] = STATE(3815),
    [sym_binary] = STATE(3815),
    [sym_unary] = STATE(3815),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1553] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(3816),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [1554] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3817),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3817),
    [sym_operator_assignment] = STATE(3817),
    [sym_conditional] = STATE(3817),
    [sym_range] = STATE(3817),
    [sym_binary] = STATE(3817),
    [sym_unary] = STATE(3817),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3818),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(3818),
    [sym__line_break2] = ACTIONS(6048),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(6048),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1555] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(3823),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3824),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(3824),
    [sym__line_break2] = ACTIONS(6050),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6052),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1556] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3825),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3825),
    [sym_operator_assignment] = STATE(3825),
    [sym_conditional] = STATE(3825),
    [sym_range] = STATE(3825),
    [sym_binary] = STATE(3825),
    [sym_unary] = STATE(3825),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1557] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3826),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3826),
    [sym_operator_assignment] = STATE(3826),
    [sym_conditional] = STATE(3826),
    [sym_range] = STATE(3826),
    [sym_binary] = STATE(3826),
    [sym_unary] = STATE(3826),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1558] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1559] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(6054),
  },
  [1560] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(3830),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3831),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6056),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1561] = {
    [sym_lambda_parameters] = STATE(3832),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(3833),
    [sym_block] = STATE(3833),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(799),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [1562] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(4164),
    [anon_sym___END__] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [1563] = {
    [sym__line_break2] = ACTIONS(737),
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [ts_builtin_sym_end] = ACTIONS(737),
    [anon_sym___END__] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(739),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_end] = ACTIONS(737),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_when] = ACTIONS(737),
    [anon_sym_elsif] = ACTIONS(737),
    [anon_sym_else] = ACTIONS(737),
    [anon_sym_then] = ACTIONS(737),
    [anon_sym_ensure] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(743),
    [anon_sym_COLON_COLON2] = ACTIONS(745),
    [anon_sym_AMP_DOT] = ACTIONS(747),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [sym_comment] = ACTIONS(87),
  },
  [1564] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(442),
    [sym__argument] = STATE(443),
    [sym_splat_argument] = STATE(443),
    [sym_hash_splat_argument] = STATE(443),
    [sym_block_argument] = STATE(443),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(443),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [ts_builtin_sym_end] = ACTIONS(749),
    [anon_sym___END__] = ACTIONS(775),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(811),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1565] = {
    [anon_sym_EQ] = ACTIONS(6088),
    [sym_comment] = ACTIONS(87),
  },
  [1566] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6090),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6092),
    [anon_sym_DASH_EQ] = ACTIONS(6092),
    [anon_sym_STAR_EQ] = ACTIONS(6092),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6092),
    [anon_sym_SLASH_EQ] = ACTIONS(6092),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6092),
    [anon_sym_PIPE_EQ] = ACTIONS(6092),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6092),
    [anon_sym_AMP_EQ] = ACTIONS(6092),
    [anon_sym_PERCENT_EQ] = ACTIONS(6092),
    [anon_sym_GT_GT_EQ] = ACTIONS(6092),
    [anon_sym_LT_LT_EQ] = ACTIONS(6092),
    [anon_sym_CARET_EQ] = ACTIONS(6092),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1567] = {
    [sym_string] = STATE(3849),
    [aux_sym_chained_string_repeat1] = STATE(3849),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1568] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(4204),
    [anon_sym___END__] = ACTIONS(4204),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [1569] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(6094),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1570] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [1571] = {
    [sym_string] = STATE(1661),
    [aux_sym_chained_string_repeat1] = STATE(1661),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1572] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3851),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3851),
    [sym_operator_assignment] = STATE(3851),
    [sym_conditional] = STATE(3851),
    [sym_range] = STATE(3851),
    [sym_binary] = STATE(3851),
    [sym_unary] = STATE(3851),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1573] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3852),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(3852),
    [sym_operator_assignment] = STATE(3852),
    [sym_conditional] = STATE(3852),
    [sym_range] = STATE(3852),
    [sym_binary] = STATE(3852),
    [sym_unary] = STATE(3852),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1574] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [1575] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(3860),
    [sym__argument] = STATE(3861),
    [sym_splat_argument] = STATE(3861),
    [sym_hash_splat_argument] = STATE(3861),
    [sym_block_argument] = STATE(3861),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3861),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1576] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(3860),
    [sym__argument] = STATE(3861),
    [sym_splat_argument] = STATE(3861),
    [sym_hash_splat_argument] = STATE(3861),
    [sym_block_argument] = STATE(3861),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3861),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1577] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(3860),
    [sym__argument] = STATE(3861),
    [sym_splat_argument] = STATE(3861),
    [sym_hash_splat_argument] = STATE(3861),
    [sym_block_argument] = STATE(3861),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3861),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1578] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(3860),
    [sym__argument] = STATE(3861),
    [sym_splat_argument] = STATE(3861),
    [sym_hash_splat_argument] = STATE(3861),
    [sym_block_argument] = STATE(3861),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(3861),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1579] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3863),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(3863),
    [sym_operator_assignment] = STATE(3863),
    [sym_conditional] = STATE(3863),
    [sym_range] = STATE(3863),
    [sym_binary] = STATE(3863),
    [sym_unary] = STATE(3863),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1580] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(3864),
    [sym_operator_assignment] = STATE(3864),
    [sym_conditional] = STATE(3864),
    [sym_range] = STATE(3864),
    [sym_binary] = STATE(3864),
    [sym_unary] = STATE(3864),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1581] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1582] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(1097),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1583] = {
    [anon_sym_RBRACE] = ACTIONS(6104),
    [sym_comment] = ACTIONS(87),
  },
  [1584] = {
    [sym__statements] = STATE(3866),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6104),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1585] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(703),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_EQ_GT] = ACTIONS(1119),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(6124),
    [anon_sym_or] = ACTIONS(6124),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [1586] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1587] = {
    [anon_sym_EQ] = ACTIONS(6146),
    [sym_comment] = ACTIONS(87),
  },
  [1588] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6148),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6150),
    [anon_sym_DASH_EQ] = ACTIONS(6150),
    [anon_sym_STAR_EQ] = ACTIONS(6150),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6150),
    [anon_sym_SLASH_EQ] = ACTIONS(6150),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6150),
    [anon_sym_PIPE_EQ] = ACTIONS(6150),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6150),
    [anon_sym_AMP_EQ] = ACTIONS(6150),
    [anon_sym_PERCENT_EQ] = ACTIONS(6150),
    [anon_sym_GT_GT_EQ] = ACTIONS(6150),
    [anon_sym_LT_LT_EQ] = ACTIONS(6150),
    [anon_sym_CARET_EQ] = ACTIONS(6150),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1589] = {
    [sym_string] = STATE(3890),
    [aux_sym_chained_string_repeat1] = STATE(3890),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(1239),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1590] = {
    [anon_sym_RBRACE] = ACTIONS(6152),
    [sym_comment] = ACTIONS(87),
  },
  [1591] = {
    [sym_heredoc_body] = STATE(3892),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(6152),
    [sym_comment] = ACTIONS(87),
  },
  [1592] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3893),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(3893),
    [sym_operator_assignment] = STATE(3893),
    [sym_conditional] = STATE(3893),
    [sym_range] = STATE(3893),
    [sym_binary] = STATE(3893),
    [sym_unary] = STATE(3893),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1593] = {
    [sym__line_break2] = ACTIONS(1283),
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [ts_builtin_sym_end] = ACTIONS(1283),
    [anon_sym___END__] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_end] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_when] = ACTIONS(1283),
    [anon_sym_elsif] = ACTIONS(1283),
    [anon_sym_else] = ACTIONS(1283),
    [anon_sym_then] = ACTIONS(1283),
    [anon_sym_ensure] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1283),
    [anon_sym_STAR_EQ] = ACTIONS(1283),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1283),
    [anon_sym_AMP_EQ] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [sym_comment] = ACTIONS(87),
  },
  [1594] = {
    [anon_sym_DOT] = ACTIONS(6154),
    [anon_sym_COLON_COLON] = ACTIONS(6154),
    [sym_comment] = ACTIONS(87),
  },
  [1595] = {
    [sym_method_parameters] = STATE(3895),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(3895),
    [sym__terminator] = STATE(3895),
    [sym__line_break2] = ACTIONS(6156),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(6156),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [1596] = {
    [sym__line_break2] = ACTIONS(1301),
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym___END__] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_when] = ACTIONS(1301),
    [anon_sym_elsif] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_then] = ACTIONS(1301),
    [anon_sym_ensure] = ACTIONS(1301),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_PLUS_EQ] = ACTIONS(1301),
    [anon_sym_DASH_EQ] = ACTIONS(1301),
    [anon_sym_STAR_EQ] = ACTIONS(1301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1301),
    [anon_sym_SLASH_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1301),
    [anon_sym_AMP_EQ] = ACTIONS(1301),
    [anon_sym_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_GT_GT_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_EQ] = ACTIONS(1301),
    [anon_sym_CARET_EQ] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1303),
    [sym_comment] = ACTIONS(87),
  },
  [1597] = {
    [anon_sym_RPAREN] = ACTIONS(6158),
    [sym_comment] = ACTIONS(87),
  },
  [1598] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [1599] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3897),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(3897),
    [sym_operator_assignment] = STATE(3897),
    [sym_conditional] = STATE(3897),
    [sym_range] = STATE(3897),
    [sym_binary] = STATE(3897),
    [sym_unary] = STATE(3897),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1600] = {
    [sym_superclass] = STATE(3898),
    [sym_heredoc_body] = STATE(3899),
    [sym__terminator] = STATE(3899),
    [sym__line_break2] = ACTIONS(6160),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1601] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(3898),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3899),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(3899),
    [sym__line_break2] = ACTIONS(6160),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(6160),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1602] = {
    [sym_heredoc_body] = STATE(3901),
    [sym__terminator] = STATE(3901),
    [sym__line_break2] = ACTIONS(6162),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(6164),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1603] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(3901),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(3901),
    [sym__line_break2] = ACTIONS(6162),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(6162),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(6164),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1604] = {
    [sym__line_break2] = ACTIONS(1699),
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [1605] = {
    [sym__line_break2] = ACTIONS(1719),
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [ts_builtin_sym_end] = ACTIONS(1719),
    [anon_sym___END__] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_end] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_when] = ACTIONS(1719),
    [anon_sym_elsif] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_then] = ACTIONS(1719),
    [anon_sym_ensure] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [sym_comment] = ACTIONS(87),
  },
  [1606] = {
    [sym__line_break2] = ACTIONS(1723),
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [ts_builtin_sym_end] = ACTIONS(1723),
    [anon_sym___END__] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1725),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_end] = ACTIONS(1723),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_when] = ACTIONS(1723),
    [anon_sym_elsif] = ACTIONS(1723),
    [anon_sym_else] = ACTIONS(1723),
    [anon_sym_then] = ACTIONS(1723),
    [anon_sym_ensure] = ACTIONS(1723),
    [anon_sym_EQ_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_PLUS_EQ] = ACTIONS(1723),
    [anon_sym_DASH_EQ] = ACTIONS(1723),
    [anon_sym_STAR_EQ] = ACTIONS(1723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1723),
    [anon_sym_SLASH_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1723),
    [anon_sym_AMP_EQ] = ACTIONS(1723),
    [anon_sym_PERCENT_EQ] = ACTIONS(1723),
    [anon_sym_GT_GT_EQ] = ACTIONS(1723),
    [anon_sym_LT_LT_EQ] = ACTIONS(1723),
    [anon_sym_CARET_EQ] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1725),
    [anon_sym_AMP_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1725),
    [anon_sym_GT_GT] = ACTIONS(1725),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_SLASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1725),
    [sym_comment] = ACTIONS(87),
  },
  [1607] = {
    [sym__line_break2] = ACTIONS(1727),
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [ts_builtin_sym_end] = ACTIONS(1727),
    [anon_sym___END__] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_end] = ACTIONS(1727),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_when] = ACTIONS(1727),
    [anon_sym_elsif] = ACTIONS(1727),
    [anon_sym_else] = ACTIONS(1727),
    [anon_sym_then] = ACTIONS(1727),
    [anon_sym_ensure] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1727),
    [anon_sym_DASH_EQ] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1727),
    [anon_sym_SLASH_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1727),
    [anon_sym_AMP_EQ] = ACTIONS(1727),
    [anon_sym_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_GT_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_EQ] = ACTIONS(1727),
    [anon_sym_CARET_EQ] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [sym_comment] = ACTIONS(87),
  },
  [1608] = {
    [sym__then] = STATE(3902),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(6166),
    [sym_comment] = ACTIONS(87),
  },
  [1609] = {
    [sym__then] = STATE(3903),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(6168),
    [sym_comment] = ACTIONS(87),
  },
  [1610] = {
    [sym__do] = STATE(3904),
    [sym_heredoc_body] = STATE(3904),
    [sym__terminator] = STATE(3904),
    [sym__line_break2] = ACTIONS(6170),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(6170),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(6170),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [1611] = {
    [sym__do] = STATE(3905),
    [sym_heredoc_body] = STATE(3905),
    [sym__terminator] = STATE(3905),
    [sym__line_break2] = ACTIONS(6172),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(6172),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(6172),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [1612] = {
    [sym_in] = STATE(3906),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [1613] = {
    [sym__line_break2] = ACTIONS(5786),
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [ts_builtin_sym_end] = ACTIONS(5786),
    [anon_sym___END__] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_end] = ACTIONS(5786),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_when] = ACTIONS(5786),
    [anon_sym_elsif] = ACTIONS(5786),
    [anon_sym_else] = ACTIONS(5786),
    [anon_sym_then] = ACTIONS(5786),
    [anon_sym_ensure] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [1614] = {
    [anon_sym_end] = ACTIONS(6174),
    [sym_comment] = ACTIONS(87),
  },
  [1615] = {
    [sym__statements] = STATE(3908),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(3909),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(3909),
    [sym__line_break2] = ACTIONS(6176),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6178),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1616] = {
    [sym__statements] = STATE(3908),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3910),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6178),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1617] = {
    [sym_heredoc_body] = STATE(3911),
    [sym__terminator] = STATE(3911),
    [sym__line_break2] = ACTIONS(6180),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(6180),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [1618] = {
    [sym_when] = STATE(3912),
    [aux_sym_case_repeat1] = STATE(3913),
    [anon_sym_SEMI] = ACTIONS(6182),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1619] = {
    [sym_else] = STATE(3915),
    [sym_ensure] = STATE(3916),
    [sym_rescue] = STATE(3917),
    [anon_sym_end] = ACTIONS(6184),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1620] = {
    [sym_ensure] = STATE(3916),
    [anon_sym_end] = ACTIONS(6184),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1621] = {
    [anon_sym_end] = ACTIONS(6184),
    [sym_comment] = ACTIONS(87),
  },
  [1622] = {
    [sym_else] = STATE(3915),
    [sym_ensure] = STATE(3916),
    [anon_sym_end] = ACTIONS(6184),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1623] = {
    [sym__line_break2] = ACTIONS(2219),
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [ts_builtin_sym_end] = ACTIONS(2219),
    [anon_sym___END__] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_end] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_when] = ACTIONS(2219),
    [anon_sym_elsif] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2219),
    [anon_sym_then] = ACTIONS(2219),
    [anon_sym_ensure] = ACTIONS(2219),
    [anon_sym_EQ_GT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_PLUS_EQ] = ACTIONS(2219),
    [anon_sym_DASH_EQ] = ACTIONS(2219),
    [anon_sym_STAR_EQ] = ACTIONS(2219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2219),
    [anon_sym_SLASH_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2219),
    [anon_sym_AMP_EQ] = ACTIONS(2219),
    [anon_sym_PERCENT_EQ] = ACTIONS(2219),
    [anon_sym_GT_GT_EQ] = ACTIONS(2219),
    [anon_sym_LT_LT_EQ] = ACTIONS(2219),
    [anon_sym_CARET_EQ] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [sym_comment] = ACTIONS(87),
  },
  [1624] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(3918),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6186),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1625] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_end] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_when] = ACTIONS(4242),
    [anon_sym_elsif] = ACTIONS(4242),
    [anon_sym_else] = ACTIONS(4242),
    [anon_sym_then] = ACTIONS(4242),
    [anon_sym_ensure] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [sym_comment] = ACTIONS(87),
  },
  [1626] = {
    [sym_heredoc_body] = STATE(3920),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(6188),
    [sym_comment] = ACTIONS(87),
  },
  [1627] = {
    [anon_sym_RPAREN] = ACTIONS(6188),
    [sym_comment] = ACTIONS(87),
  },
  [1628] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [1629] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [1630] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [1631] = {
    [sym__line_break2] = ACTIONS(2307),
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2307),
    [anon_sym___END__] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_end] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_when] = ACTIONS(2307),
    [anon_sym_elsif] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_then] = ACTIONS(2307),
    [anon_sym_ensure] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2309),
    [anon_sym_GT_GT] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [sym_comment] = ACTIONS(87),
  },
  [1632] = {
    [sym__line_break2] = ACTIONS(2391),
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [ts_builtin_sym_end] = ACTIONS(2391),
    [anon_sym___END__] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2393),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_end] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_when] = ACTIONS(2391),
    [anon_sym_elsif] = ACTIONS(2391),
    [anon_sym_else] = ACTIONS(2391),
    [anon_sym_then] = ACTIONS(2391),
    [anon_sym_ensure] = ACTIONS(2391),
    [anon_sym_EQ_GT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_PLUS_EQ] = ACTIONS(2391),
    [anon_sym_DASH_EQ] = ACTIONS(2391),
    [anon_sym_STAR_EQ] = ACTIONS(2391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2391),
    [anon_sym_SLASH_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2391),
    [anon_sym_AMP_EQ] = ACTIONS(2391),
    [anon_sym_PERCENT_EQ] = ACTIONS(2391),
    [anon_sym_GT_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_EQ] = ACTIONS(2391),
    [anon_sym_CARET_EQ] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2393),
    [anon_sym_AMP_AMP] = ACTIONS(2393),
    [anon_sym_LT_LT] = ACTIONS(2393),
    [anon_sym_GT_GT] = ACTIONS(2393),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_PERCENT] = ACTIONS(2393),
    [sym_comment] = ACTIONS(87),
  },
  [1633] = {
    [sym_heredoc_body] = STATE(3922),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(6190),
    [sym_comment] = ACTIONS(87),
  },
  [1634] = {
    [anon_sym_RBRACK] = ACTIONS(6190),
    [sym_comment] = ACTIONS(87),
  },
  [1635] = {
    [sym__statements] = STATE(2662),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2663),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1636] = {
    [sym_do_block] = STATE(3924),
    [sym_block] = STATE(3924),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_do] = ACTIONS(4334),
    [sym_comment] = ACTIONS(87),
  },
  [1637] = {
    [sym__line_break2] = ACTIONS(2537),
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [ts_builtin_sym_end] = ACTIONS(2537),
    [anon_sym___END__] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_end] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_when] = ACTIONS(2537),
    [anon_sym_elsif] = ACTIONS(2537),
    [anon_sym_else] = ACTIONS(2537),
    [anon_sym_then] = ACTIONS(2537),
    [anon_sym_ensure] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_PLUS_EQ] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2537),
    [anon_sym_STAR_EQ] = ACTIONS(2537),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2537),
    [anon_sym_AMP_EQ] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2539),
    [anon_sym_AMP_AMP] = ACTIONS(2539),
    [anon_sym_LT_LT] = ACTIONS(2539),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [anon_sym_PERCENT] = ACTIONS(2539),
    [sym_comment] = ACTIONS(87),
  },
  [1638] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3925),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3925),
    [sym_operator_assignment] = STATE(3925),
    [sym_conditional] = STATE(3925),
    [sym_range] = STATE(3925),
    [sym_binary] = STATE(3925),
    [sym_unary] = STATE(3925),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1639] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3926),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3926),
    [sym_operator_assignment] = STATE(3926),
    [sym_conditional] = STATE(3926),
    [sym_range] = STATE(3926),
    [sym_binary] = STATE(3926),
    [sym_unary] = STATE(3926),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1640] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3927),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3927),
    [sym_operator_assignment] = STATE(3927),
    [sym_conditional] = STATE(3927),
    [sym_range] = STATE(3927),
    [sym_binary] = STATE(3927),
    [sym_unary] = STATE(3927),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1641] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3928),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3928),
    [sym_operator_assignment] = STATE(3928),
    [sym_conditional] = STATE(3928),
    [sym_range] = STATE(3928),
    [sym_binary] = STATE(3928),
    [sym_unary] = STATE(3928),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1642] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3929),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3929),
    [sym_operator_assignment] = STATE(3929),
    [sym_conditional] = STATE(3929),
    [sym_range] = STATE(3929),
    [sym_binary] = STATE(3929),
    [sym_unary] = STATE(3929),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1643] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3930),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3930),
    [sym_operator_assignment] = STATE(3930),
    [sym_conditional] = STATE(3930),
    [sym_range] = STATE(3930),
    [sym_binary] = STATE(3930),
    [sym_unary] = STATE(3930),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1644] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3931),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(3931),
    [sym_operator_assignment] = STATE(3931),
    [sym_conditional] = STATE(3931),
    [sym_range] = STATE(3931),
    [sym_binary] = STATE(3931),
    [sym_unary] = STATE(3931),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1645] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(3932),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(3932),
    [sym_operator_assignment] = STATE(3932),
    [sym_conditional] = STATE(3932),
    [sym_range] = STATE(3932),
    [sym_binary] = STATE(3932),
    [sym_unary] = STATE(3932),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1646] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3933),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3933),
    [sym_operator_assignment] = STATE(3933),
    [sym_conditional] = STATE(3933),
    [sym_range] = STATE(3933),
    [sym_binary] = STATE(3933),
    [sym_unary] = STATE(3933),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1647] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3934),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3934),
    [sym_operator_assignment] = STATE(3934),
    [sym_conditional] = STATE(3934),
    [sym_range] = STATE(3934),
    [sym_binary] = STATE(3934),
    [sym_unary] = STATE(3934),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1648] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3935),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3935),
    [sym_operator_assignment] = STATE(3935),
    [sym_conditional] = STATE(3935),
    [sym_range] = STATE(3935),
    [sym_binary] = STATE(3935),
    [sym_unary] = STATE(3935),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1649] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3936),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3936),
    [sym_operator_assignment] = STATE(3936),
    [sym_conditional] = STATE(3936),
    [sym_range] = STATE(3936),
    [sym_binary] = STATE(3936),
    [sym_unary] = STATE(3936),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1650] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3937),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3937),
    [sym_operator_assignment] = STATE(3937),
    [sym_conditional] = STATE(3937),
    [sym_range] = STATE(3937),
    [sym_binary] = STATE(3937),
    [sym_unary] = STATE(3937),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1651] = {
    [sym__statements] = STATE(2662),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2663),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6192),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1652] = {
    [sym_do_block] = STATE(2673),
    [sym_block] = STATE(2673),
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [ts_builtin_sym_end] = ACTIONS(2773),
    [anon_sym___END__] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2739),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_end] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_when] = ACTIONS(2773),
    [anon_sym_elsif] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_ensure] = ACTIONS(2773),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1653] = {
    [sym__statements] = STATE(1583),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(1584),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6194),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1654] = {
    [sym__line_break2] = ACTIONS(6196),
    [sym__heredoc_body_start2] = ACTIONS(6196),
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [ts_builtin_sym_end] = ACTIONS(6196),
    [anon_sym___END__] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_end] = ACTIONS(6196),
    [anon_sym_if] = ACTIONS(6196),
    [anon_sym_unless] = ACTIONS(6196),
    [anon_sym_while] = ACTIONS(6196),
    [anon_sym_until] = ACTIONS(6196),
    [anon_sym_rescue] = ACTIONS(6196),
    [anon_sym_do] = ACTIONS(6196),
    [anon_sym_when] = ACTIONS(6196),
    [anon_sym_elsif] = ACTIONS(6196),
    [anon_sym_else] = ACTIONS(6196),
    [anon_sym_then] = ACTIONS(6196),
    [anon_sym_ensure] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [1655] = {
    [sym_interpolation] = STATE(3940),
    [aux_sym_heredoc_body_repeat1] = STATE(3940),
    [sym__heredoc_content2] = ACTIONS(6200),
    [sym_heredoc_end2] = ACTIONS(6202),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(6200),
  },
  [1656] = {
    [sym_heredoc_body] = STATE(3941),
    [aux_sym_call_repeat1] = STATE(3941),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [1657] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(3943),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6204),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1658] = {
    [sym_heredoc_body] = STATE(3944),
    [aux_sym_call_repeat1] = STATE(3944),
    [aux_sym_argument_list_repeat1] = STATE(3945),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [1659] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3946),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_splat_argument] = STATE(3948),
    [sym_assignment] = STATE(3946),
    [sym_operator_assignment] = STATE(3946),
    [sym_conditional] = STATE(3946),
    [sym_range] = STATE(3946),
    [sym_binary] = STATE(3946),
    [sym_unary] = STATE(3946),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(3948),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1660] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3949),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(3949),
    [sym_operator_assignment] = STATE(3949),
    [sym_conditional] = STATE(3949),
    [sym_range] = STATE(3949),
    [sym_binary] = STATE(3949),
    [sym_unary] = STATE(3949),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1661] = {
    [sym_string] = STATE(3950),
    [aux_sym_chained_string_repeat1] = STATE(3950),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [anon_sym___END__] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [1662] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3951),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(3951),
    [sym_operator_assignment] = STATE(3951),
    [sym_conditional] = STATE(3951),
    [sym_range] = STATE(3951),
    [sym_binary] = STATE(3951),
    [sym_unary] = STATE(3951),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1663] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3952),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(3952),
    [sym_operator_assignment] = STATE(3952),
    [sym_conditional] = STATE(3952),
    [sym_range] = STATE(3952),
    [sym_binary] = STATE(3952),
    [sym_unary] = STATE(3952),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1664] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3953),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(3953),
    [sym_operator_assignment] = STATE(3953),
    [sym_conditional] = STATE(3953),
    [sym_range] = STATE(3953),
    [sym_binary] = STATE(3953),
    [sym_unary] = STATE(3953),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1665] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3954),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(3954),
    [sym_operator_assignment] = STATE(3954),
    [sym_conditional] = STATE(3954),
    [sym_range] = STATE(3954),
    [sym_binary] = STATE(3954),
    [sym_unary] = STATE(3954),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1666] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1667] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5104),
    [anon_sym___END__] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [1668] = {
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [1669] = {
    [aux_sym_exceptions_repeat1] = STATE(3968),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [1670] = {
    [anon_sym_EQ] = ACTIONS(6242),
    [sym_comment] = ACTIONS(87),
  },
  [1671] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [ts_builtin_sym_end] = ACTIONS(559),
    [anon_sym___END__] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6244),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6246),
    [anon_sym_DASH_EQ] = ACTIONS(6246),
    [anon_sym_STAR_EQ] = ACTIONS(6246),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6246),
    [anon_sym_SLASH_EQ] = ACTIONS(6246),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6246),
    [anon_sym_PIPE_EQ] = ACTIONS(6246),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6246),
    [anon_sym_AMP_EQ] = ACTIONS(6246),
    [anon_sym_PERCENT_EQ] = ACTIONS(6246),
    [anon_sym_GT_GT_EQ] = ACTIONS(6246),
    [anon_sym_LT_LT_EQ] = ACTIONS(6246),
    [anon_sym_CARET_EQ] = ACTIONS(6246),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1672] = {
    [anon_sym_RPAREN] = ACTIONS(6248),
    [anon_sym_EQ] = ACTIONS(6248),
    [anon_sym_in] = ACTIONS(6248),
    [sym_comment] = ACTIONS(87),
  },
  [1673] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [1674] = {
    [sym_string] = STATE(1674),
    [aux_sym_chained_string_repeat1] = STATE(1674),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [ts_builtin_sym_end] = ACTIONS(6252),
    [anon_sym___END__] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [1675] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1676] = {
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_rescue] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_COLON2] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [1677] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3979),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(3979),
    [sym_operator_assignment] = STATE(3979),
    [sym_conditional] = STATE(3979),
    [sym_range] = STATE(3979),
    [sym_binary] = STATE(3979),
    [sym_unary] = STATE(3979),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1678] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3984),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(3984),
    [sym_operator_assignment] = STATE(3984),
    [sym_conditional] = STATE(3984),
    [sym_range] = STATE(3984),
    [sym_binary] = STATE(3984),
    [sym_unary] = STATE(3984),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1679] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3985),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(3985),
    [sym_operator_assignment] = STATE(3985),
    [sym_conditional] = STATE(3985),
    [sym_range] = STATE(3985),
    [sym_binary] = STATE(3985),
    [sym_unary] = STATE(3985),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1680] = {
    [anon_sym_COLON] = ACTIONS(6283),
    [sym_comment] = ACTIONS(87),
  },
  [1681] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(3988),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(3988),
    [sym_operator_assignment] = STATE(3988),
    [sym_conditional] = STATE(3988),
    [sym_range] = STATE(3988),
    [sym_binary] = STATE(3988),
    [sym_unary] = STATE(3988),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1682] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(3995),
    [sym__argument] = STATE(3996),
    [sym_splat_argument] = STATE(3996),
    [sym_hash_splat_argument] = STATE(3996),
    [sym_block_argument] = STATE(3996),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3996),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1683] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(3995),
    [sym__argument] = STATE(3996),
    [sym_splat_argument] = STATE(3996),
    [sym_hash_splat_argument] = STATE(3996),
    [sym_block_argument] = STATE(3996),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3996),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1684] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(3995),
    [sym__argument] = STATE(3996),
    [sym_splat_argument] = STATE(3996),
    [sym_hash_splat_argument] = STATE(3996),
    [sym_block_argument] = STATE(3996),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3996),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1685] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(3995),
    [sym__argument] = STATE(3996),
    [sym_splat_argument] = STATE(3996),
    [sym_hash_splat_argument] = STATE(3996),
    [sym_block_argument] = STATE(3996),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(3996),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1686] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3998),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(3998),
    [sym_operator_assignment] = STATE(3998),
    [sym_conditional] = STATE(3998),
    [sym_range] = STATE(3998),
    [sym_binary] = STATE(3998),
    [sym_unary] = STATE(3998),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1687] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3999),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(3999),
    [sym_operator_assignment] = STATE(3999),
    [sym_conditional] = STATE(3999),
    [sym_range] = STATE(3999),
    [sym_binary] = STATE(3999),
    [sym_unary] = STATE(3999),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1688] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1689] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6293),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1690] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(6307),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [1691] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1692] = {
    [sym_heredoc_body] = STATE(4022),
    [aux_sym_call_repeat1] = STATE(4022),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1693] = {
    [sym_heredoc_body] = STATE(4022),
    [aux_sym_call_repeat1] = STATE(4022),
    [aux_sym_argument_list_repeat1] = STATE(4024),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6335),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1694] = {
    [anon_sym_EQ] = ACTIONS(6337),
    [sym_comment] = ACTIONS(87),
  },
  [1695] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6339),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6341),
    [anon_sym_DASH_EQ] = ACTIONS(6341),
    [anon_sym_STAR_EQ] = ACTIONS(6341),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6341),
    [anon_sym_SLASH_EQ] = ACTIONS(6341),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6341),
    [anon_sym_PIPE_EQ] = ACTIONS(6341),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6341),
    [anon_sym_AMP_EQ] = ACTIONS(6341),
    [anon_sym_PERCENT_EQ] = ACTIONS(6341),
    [anon_sym_GT_GT_EQ] = ACTIONS(6341),
    [anon_sym_LT_LT_EQ] = ACTIONS(6341),
    [anon_sym_CARET_EQ] = ACTIONS(6341),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1696] = {
    [sym_string] = STATE(4027),
    [aux_sym_chained_string_repeat1] = STATE(4027),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6343),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1697] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1698] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [1699] = {
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_if] = ACTIONS(1273),
    [anon_sym_unless] = ACTIONS(1273),
    [anon_sym_while] = ACTIONS(1273),
    [anon_sym_until] = ACTIONS(1273),
    [anon_sym_rescue] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
  },
  [1700] = {
    [anon_sym_RBRACE] = ACTIONS(1277),
    [anon_sym_COMMA] = ACTIONS(1277),
    [anon_sym_EQ] = ACTIONS(6345),
    [anon_sym_if] = ACTIONS(1277),
    [anon_sym_unless] = ACTIONS(1277),
    [anon_sym_while] = ACTIONS(1277),
    [anon_sym_until] = ACTIONS(1277),
    [anon_sym_rescue] = ACTIONS(1277),
    [sym_comment] = ACTIONS(87),
  },
  [1701] = {
    [aux_sym_undef_repeat1] = STATE(4030),
    [anon_sym_RBRACE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [1702] = {
    [sym_operator] = STATE(4031),
    [sym__method_name] = STATE(4031),
    [sym_setter] = STATE(4031),
    [sym_symbol] = STATE(4031),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__symbol_start2] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_STAR_STAR] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_LT_LT] = ACTIONS(2843),
    [anon_sym_GT_GT] = ACTIONS(2843),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ_GT] = ACTIONS(2843),
    [anon_sym_EQ_TILDE] = ACTIONS(2843),
    [anon_sym_BANG_TILDE] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2843),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2843),
    [sym_constant] = ACTIONS(6349),
    [sym_identifier] = ACTIONS(2849),
    [sym_instance_variable] = ACTIONS(6349),
    [sym_class_variable] = ACTIONS(6349),
    [sym_global_variable] = ACTIONS(6349),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_AT] = ACTIONS(2843),
    [anon_sym_DASH_AT] = ACTIONS(2843),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2845),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2843),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(87),
  },
  [1703] = {
    [sym__string_content2] = ACTIONS(6351),
    [sym__string_end2] = ACTIONS(6351),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6353),
    [sym_escape_sequence] = ACTIONS(6351),
  },
  [1704] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4032),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4032),
    [sym_operator_assignment] = STATE(4032),
    [sym_conditional] = STATE(4032),
    [sym_range] = STATE(4032),
    [sym_binary] = STATE(4032),
    [sym_unary] = STATE(4032),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1705] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4033),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4033),
    [sym_operator_assignment] = STATE(4033),
    [sym_conditional] = STATE(4033),
    [sym_range] = STATE(4033),
    [sym_binary] = STATE(4033),
    [sym_unary] = STATE(4033),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1706] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4034),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4034),
    [sym_operator_assignment] = STATE(4034),
    [sym_conditional] = STATE(4034),
    [sym_range] = STATE(4034),
    [sym_binary] = STATE(4034),
    [sym_unary] = STATE(4034),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1707] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4035),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4035),
    [sym_operator_assignment] = STATE(4035),
    [sym_conditional] = STATE(4035),
    [sym_range] = STATE(4035),
    [sym_binary] = STATE(4035),
    [sym_unary] = STATE(4035),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1708] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4036),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4036),
    [sym_operator_assignment] = STATE(4036),
    [sym_conditional] = STATE(4036),
    [sym_range] = STATE(4036),
    [sym_binary] = STATE(4036),
    [sym_unary] = STATE(4036),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1709] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4037),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4037),
    [sym_operator_assignment] = STATE(4037),
    [sym_conditional] = STATE(4037),
    [sym_range] = STATE(4037),
    [sym_binary] = STATE(4037),
    [sym_unary] = STATE(4037),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1710] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4038),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4038),
    [sym_operator_assignment] = STATE(4038),
    [sym_conditional] = STATE(4038),
    [sym_range] = STATE(4038),
    [sym_binary] = STATE(4038),
    [sym_unary] = STATE(4038),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1711] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4039),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4039),
    [sym_operator_assignment] = STATE(4039),
    [sym_conditional] = STATE(4039),
    [sym_range] = STATE(4039),
    [sym_binary] = STATE(4039),
    [sym_unary] = STATE(4039),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1712] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4040),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4040),
    [sym_operator_assignment] = STATE(4040),
    [sym_conditional] = STATE(4040),
    [sym_range] = STATE(4040),
    [sym_binary] = STATE(4040),
    [sym_unary] = STATE(4040),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1713] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4041),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4041),
    [sym_operator_assignment] = STATE(4041),
    [sym_conditional] = STATE(4041),
    [sym_range] = STATE(4041),
    [sym_binary] = STATE(4041),
    [sym_unary] = STATE(4041),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1714] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4042),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4042),
    [sym_operator_assignment] = STATE(4042),
    [sym_conditional] = STATE(4042),
    [sym_range] = STATE(4042),
    [sym_binary] = STATE(4042),
    [sym_unary] = STATE(4042),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1715] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4043),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4043),
    [sym_operator_assignment] = STATE(4043),
    [sym_conditional] = STATE(4043),
    [sym_range] = STATE(4043),
    [sym_binary] = STATE(4043),
    [sym_unary] = STATE(4043),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1716] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4044),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4044),
    [sym_operator_assignment] = STATE(4044),
    [sym_conditional] = STATE(4044),
    [sym_range] = STATE(4044),
    [sym_binary] = STATE(4044),
    [sym_unary] = STATE(4044),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1717] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4045),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4045),
    [sym_operator_assignment] = STATE(4045),
    [sym_conditional] = STATE(4045),
    [sym_range] = STATE(4045),
    [sym_binary] = STATE(4045),
    [sym_unary] = STATE(4045),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1718] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4046),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4046),
    [sym_operator_assignment] = STATE(4046),
    [sym_conditional] = STATE(4046),
    [sym_range] = STATE(4046),
    [sym_binary] = STATE(4046),
    [sym_unary] = STATE(4046),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1719] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4047),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4047),
    [sym_operator_assignment] = STATE(4047),
    [sym_conditional] = STATE(4047),
    [sym_range] = STATE(4047),
    [sym_binary] = STATE(4047),
    [sym_unary] = STATE(4047),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1720] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4048),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4048),
    [sym_operator_assignment] = STATE(4048),
    [sym_conditional] = STATE(4048),
    [sym_range] = STATE(4048),
    [sym_binary] = STATE(4048),
    [sym_unary] = STATE(4048),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1721] = {
    [sym_argument_list_with_parens] = STATE(4051),
    [sym__argument_list_with_parens] = STATE(4052),
    [sym_operator] = STATE(4051),
    [sym_heredoc_body] = STATE(4053),
    [aux_sym_call_repeat1] = STATE(4053),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(6355),
    [anon_sym_STAR] = ACTIONS(6357),
    [anon_sym_STAR_STAR] = ACTIONS(6355),
    [anon_sym_AMP] = ACTIONS(6355),
    [anon_sym_LT] = ACTIONS(6357),
    [anon_sym_LPAREN2] = ACTIONS(6359),
    [anon_sym_DOT_DOT] = ACTIONS(6355),
    [anon_sym_LT_LT] = ACTIONS(6355),
    [anon_sym_GT_GT] = ACTIONS(6355),
    [anon_sym_EQ_EQ] = ACTIONS(6357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6355),
    [anon_sym_LT_EQ_GT] = ACTIONS(6355),
    [anon_sym_EQ_TILDE] = ACTIONS(6355),
    [anon_sym_BANG_TILDE] = ACTIONS(6355),
    [anon_sym_LT_EQ] = ACTIONS(6357),
    [anon_sym_GT] = ACTIONS(6357),
    [anon_sym_GT_EQ] = ACTIONS(6355),
    [anon_sym_CARET] = ACTIONS(6355),
    [anon_sym_PLUS] = ACTIONS(6357),
    [anon_sym_SLASH] = ACTIONS(6355),
    [anon_sym_PERCENT] = ACTIONS(6355),
    [anon_sym_BANG] = ACTIONS(6357),
    [anon_sym_TILDE] = ACTIONS(6355),
    [sym_constant] = ACTIONS(6361),
    [sym_identifier] = ACTIONS(6361),
    [anon_sym_DASH] = ACTIONS(6357),
    [anon_sym_PLUS_AT] = ACTIONS(6355),
    [anon_sym_DASH_AT] = ACTIONS(6355),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6357),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6355),
    [anon_sym_BQUOTE] = ACTIONS(6355),
    [sym_comment] = ACTIONS(87),
  },
  [1722] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(4055),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4056),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6363),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1723] = {
    [sym_constant] = ACTIONS(6365),
    [sym_identifier] = ACTIONS(6365),
    [sym_comment] = ACTIONS(87),
  },
  [1724] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4088),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(4088),
    [sym_operator_assignment] = STATE(4088),
    [sym_conditional] = STATE(4088),
    [sym_range] = STATE(4088),
    [sym_binary] = STATE(4088),
    [sym_unary] = STATE(4088),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1725] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4094),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(4094),
    [sym_operator_assignment] = STATE(4094),
    [sym_conditional] = STATE(4094),
    [sym_range] = STATE(4094),
    [sym_binary] = STATE(4094),
    [sym_unary] = STATE(4094),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1726] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4095),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(4095),
    [sym_operator_assignment] = STATE(4095),
    [sym_conditional] = STATE(4095),
    [sym_range] = STATE(4095),
    [sym_binary] = STATE(4095),
    [sym_unary] = STATE(4095),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1727] = {
    [anon_sym_COLON] = ACTIONS(6439),
    [sym_comment] = ACTIONS(87),
  },
  [1728] = {
    [sym__statements] = STATE(4099),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(4100),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6441),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1729] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4101),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(4101),
    [sym_operator_assignment] = STATE(4101),
    [sym_conditional] = STATE(4101),
    [sym_range] = STATE(4101),
    [sym_binary] = STATE(4101),
    [sym_unary] = STATE(4101),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1730] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1731] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1732] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1733] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1734] = {
    [sym__statements] = STATE(4103),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4104),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4105),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4105),
    [sym__line_break2] = ACTIONS(6443),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6445),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1735] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(4107),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4108),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(6447),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1736] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4109),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(4109),
    [sym_operator_assignment] = STATE(4109),
    [sym_conditional] = STATE(4109),
    [sym_range] = STATE(4109),
    [sym_binary] = STATE(4109),
    [sym_unary] = STATE(4109),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1737] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4110),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(4110),
    [sym_operator_assignment] = STATE(4110),
    [sym_conditional] = STATE(4110),
    [sym_range] = STATE(4110),
    [sym_binary] = STATE(4110),
    [sym_unary] = STATE(4110),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1738] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1739] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6449),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1740] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(6463),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [1741] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(4019),
    [sym__argument] = STATE(4020),
    [sym_splat_argument] = STATE(4020),
    [sym_hash_splat_argument] = STATE(4020),
    [sym_block_argument] = STATE(4020),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4020),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1742] = {
    [sym_do_block] = STATE(4125),
    [sym_block] = STATE(4125),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(6481),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(6483),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1743] = {
    [sym_heredoc_body] = STATE(4127),
    [aux_sym_call_repeat1] = STATE(4127),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1744] = {
    [sym_heredoc_body] = STATE(4127),
    [aux_sym_call_repeat1] = STATE(4127),
    [aux_sym_argument_list_repeat1] = STATE(4129),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6487),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1745] = {
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1746] = {
    [anon_sym_EQ] = ACTIONS(6489),
    [sym_comment] = ACTIONS(87),
  },
  [1747] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6491),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6493),
    [anon_sym_DASH_EQ] = ACTIONS(6493),
    [anon_sym_STAR_EQ] = ACTIONS(6493),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6493),
    [anon_sym_SLASH_EQ] = ACTIONS(6493),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6493),
    [anon_sym_PIPE_EQ] = ACTIONS(6493),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6493),
    [anon_sym_AMP_EQ] = ACTIONS(6493),
    [anon_sym_PERCENT_EQ] = ACTIONS(6493),
    [anon_sym_GT_GT_EQ] = ACTIONS(6493),
    [anon_sym_LT_LT_EQ] = ACTIONS(6493),
    [anon_sym_CARET_EQ] = ACTIONS(6493),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1748] = {
    [sym_string] = STATE(4132),
    [aux_sym_chained_string_repeat1] = STATE(4132),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6495),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1749] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4142),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_splat_argument] = STATE(4143),
    [sym_assignment] = STATE(4142),
    [sym_operator_assignment] = STATE(4142),
    [sym_conditional] = STATE(4142),
    [sym_range] = STATE(4142),
    [sym_binary] = STATE(4142),
    [sym_unary] = STATE(4142),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(4143),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(6497),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1750] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4147),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(4147),
    [sym_operator_assignment] = STATE(4147),
    [sym_conditional] = STATE(4147),
    [sym_range] = STATE(4147),
    [sym_binary] = STATE(4147),
    [sym_unary] = STATE(4147),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1751] = {
    [sym_string] = STATE(4148),
    [aux_sym_chained_string_repeat1] = STATE(4148),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1752] = {
    [sym__string_content2] = ACTIONS(6351),
    [sym__string_end2] = ACTIONS(6351),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6353),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6353),
    [sym_escape_sequence] = ACTIONS(6353),
  },
  [1753] = {
    [sym__line_break2] = ACTIONS(6517),
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [ts_builtin_sym_end] = ACTIONS(6517),
    [anon_sym___END__] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6517),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_end] = ACTIONS(6517),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_when] = ACTIONS(6517),
    [anon_sym_elsif] = ACTIONS(6517),
    [anon_sym_else] = ACTIONS(6517),
    [anon_sym_then] = ACTIONS(6517),
    [anon_sym_ensure] = ACTIONS(6517),
    [anon_sym_EQ_GT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6517),
    [anon_sym_GT_GT] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6517),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_SLASH] = ACTIONS(6517),
    [anon_sym_PERCENT] = ACTIONS(6517),
    [sym_comment] = ACTIONS(87),
  },
  [1754] = {
    [sym__line_break2] = ACTIONS(6521),
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [ts_builtin_sym_end] = ACTIONS(6521),
    [anon_sym___END__] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6521),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_end] = ACTIONS(6521),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_when] = ACTIONS(6521),
    [anon_sym_elsif] = ACTIONS(6521),
    [anon_sym_else] = ACTIONS(6521),
    [anon_sym_then] = ACTIONS(6521),
    [anon_sym_ensure] = ACTIONS(6521),
    [anon_sym_EQ_GT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6521),
    [anon_sym_AMP_AMP] = ACTIONS(6521),
    [anon_sym_LT_LT] = ACTIONS(6521),
    [anon_sym_GT_GT] = ACTIONS(6521),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6521),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_PERCENT] = ACTIONS(6521),
    [sym_comment] = ACTIONS(87),
  },
  [1755] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6525),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1756] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(6525),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6527),
  },
  [1757] = {
    [sym__line_break2] = ACTIONS(6529),
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [ts_builtin_sym_end] = ACTIONS(6529),
    [anon_sym___END__] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6529),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_end] = ACTIONS(6529),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_when] = ACTIONS(6529),
    [anon_sym_elsif] = ACTIONS(6529),
    [anon_sym_else] = ACTIONS(6529),
    [anon_sym_then] = ACTIONS(6529),
    [anon_sym_ensure] = ACTIONS(6529),
    [anon_sym_EQ_GT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6529),
    [anon_sym_AMP_AMP] = ACTIONS(6529),
    [anon_sym_LT_LT] = ACTIONS(6529),
    [anon_sym_GT_GT] = ACTIONS(6529),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6529),
    [anon_sym_PLUS] = ACTIONS(6529),
    [anon_sym_SLASH] = ACTIONS(6529),
    [anon_sym_PERCENT] = ACTIONS(6529),
    [sym_comment] = ACTIONS(87),
  },
  [1758] = {
    [sym__string_end2] = ACTIONS(6533),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6533),
  },
  [1759] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6535),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1760] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(6537),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6539),
  },
  [1761] = {
    [sym__line_break2] = ACTIONS(6542),
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [ts_builtin_sym_end] = ACTIONS(6542),
    [anon_sym___END__] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6542),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_end] = ACTIONS(6542),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_when] = ACTIONS(6542),
    [anon_sym_elsif] = ACTIONS(6542),
    [anon_sym_else] = ACTIONS(6542),
    [anon_sym_then] = ACTIONS(6542),
    [anon_sym_ensure] = ACTIONS(6542),
    [anon_sym_EQ_GT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6542),
    [anon_sym_AMP_AMP] = ACTIONS(6542),
    [anon_sym_LT_LT] = ACTIONS(6542),
    [anon_sym_GT_GT] = ACTIONS(6542),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6542),
    [anon_sym_PLUS] = ACTIONS(6542),
    [anon_sym_SLASH] = ACTIONS(6542),
    [anon_sym_PERCENT] = ACTIONS(6542),
    [sym_comment] = ACTIONS(87),
  },
  [1762] = {
    [sym__line_break2] = ACTIONS(6546),
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [ts_builtin_sym_end] = ACTIONS(6546),
    [anon_sym___END__] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6546),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_end] = ACTIONS(6546),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_when] = ACTIONS(6546),
    [anon_sym_elsif] = ACTIONS(6546),
    [anon_sym_else] = ACTIONS(6546),
    [anon_sym_then] = ACTIONS(6546),
    [anon_sym_ensure] = ACTIONS(6546),
    [anon_sym_EQ_GT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6546),
    [anon_sym_AMP_AMP] = ACTIONS(6546),
    [anon_sym_LT_LT] = ACTIONS(6546),
    [anon_sym_GT_GT] = ACTIONS(6546),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6546),
    [anon_sym_PLUS] = ACTIONS(6546),
    [anon_sym_SLASH] = ACTIONS(6546),
    [anon_sym_PERCENT] = ACTIONS(6546),
    [sym_comment] = ACTIONS(87),
  },
  [1763] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6550),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1764] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(6550),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6552),
  },
  [1765] = {
    [sym__line_break2] = ACTIONS(6554),
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [ts_builtin_sym_end] = ACTIONS(6554),
    [anon_sym___END__] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6554),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_end] = ACTIONS(6554),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_when] = ACTIONS(6554),
    [anon_sym_elsif] = ACTIONS(6554),
    [anon_sym_else] = ACTIONS(6554),
    [anon_sym_then] = ACTIONS(6554),
    [anon_sym_ensure] = ACTIONS(6554),
    [anon_sym_EQ_GT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6554),
    [anon_sym_AMP_AMP] = ACTIONS(6554),
    [anon_sym_LT_LT] = ACTIONS(6554),
    [anon_sym_GT_GT] = ACTIONS(6554),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6554),
    [anon_sym_PLUS] = ACTIONS(6554),
    [anon_sym_SLASH] = ACTIONS(6554),
    [anon_sym_PERCENT] = ACTIONS(6554),
    [sym_comment] = ACTIONS(87),
  },
  [1766] = {
    [sym__string_end2] = ACTIONS(6558),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6558),
  },
  [1767] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6560),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1768] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(6562),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6564),
  },
  [1769] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1770] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4165),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(4165),
    [sym_operator_assignment] = STATE(4165),
    [sym_conditional] = STATE(4165),
    [sym_range] = STATE(4165),
    [sym_binary] = STATE(4165),
    [sym_unary] = STATE(4165),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1771] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4169),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(4169),
    [sym_operator_assignment] = STATE(4169),
    [sym_conditional] = STATE(4169),
    [sym_range] = STATE(4169),
    [sym_binary] = STATE(4169),
    [sym_unary] = STATE(4169),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1772] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4170),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(4170),
    [sym_operator_assignment] = STATE(4170),
    [sym_conditional] = STATE(4170),
    [sym_range] = STATE(4170),
    [sym_binary] = STATE(4170),
    [sym_unary] = STATE(4170),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1773] = {
    [anon_sym_COLON] = ACTIONS(6587),
    [sym_comment] = ACTIONS(87),
  },
  [1774] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4173),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(4173),
    [sym_operator_assignment] = STATE(4173),
    [sym_conditional] = STATE(4173),
    [sym_range] = STATE(4173),
    [sym_binary] = STATE(4173),
    [sym_unary] = STATE(4173),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1775] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1776] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1777] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1778] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(4174),
    [sym__argument] = STATE(4175),
    [sym_splat_argument] = STATE(4175),
    [sym_hash_splat_argument] = STATE(4175),
    [sym_block_argument] = STATE(4175),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4175),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1779] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4176),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(4176),
    [sym_operator_assignment] = STATE(4176),
    [sym_conditional] = STATE(4176),
    [sym_range] = STATE(4176),
    [sym_binary] = STATE(4176),
    [sym_unary] = STATE(4176),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1780] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4177),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(4177),
    [sym_operator_assignment] = STATE(4177),
    [sym_conditional] = STATE(4177),
    [sym_range] = STATE(4177),
    [sym_binary] = STATE(4177),
    [sym_unary] = STATE(4177),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1781] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1782] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6589),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1783] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(6603),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [1784] = {
    [sym_heredoc_body] = STATE(4191),
    [aux_sym_call_repeat1] = STATE(4191),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1785] = {
    [sym_heredoc_body] = STATE(4191),
    [aux_sym_call_repeat1] = STATE(4191),
    [aux_sym_argument_list_repeat1] = STATE(4193),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6623),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1786] = {
    [anon_sym_EQ] = ACTIONS(6625),
    [sym_comment] = ACTIONS(87),
  },
  [1787] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6627),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6629),
    [anon_sym_DASH_EQ] = ACTIONS(6629),
    [anon_sym_STAR_EQ] = ACTIONS(6629),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6629),
    [anon_sym_SLASH_EQ] = ACTIONS(6629),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6629),
    [anon_sym_PIPE_EQ] = ACTIONS(6629),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6629),
    [anon_sym_AMP_EQ] = ACTIONS(6629),
    [anon_sym_PERCENT_EQ] = ACTIONS(6629),
    [anon_sym_GT_GT_EQ] = ACTIONS(6629),
    [anon_sym_LT_LT_EQ] = ACTIONS(6629),
    [anon_sym_CARET_EQ] = ACTIONS(6629),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1788] = {
    [sym_string] = STATE(4196),
    [aux_sym_chained_string_repeat1] = STATE(4196),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6631),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1789] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1790] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [1791] = {
    [aux_sym_undef_repeat1] = STATE(4197),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_RBRACE] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [1792] = {
    [sym__line_break2] = ACTIONS(6633),
    [sym__heredoc_body_start2] = ACTIONS(6633),
    [ts_builtin_sym_end] = ACTIONS(6633),
    [anon_sym___END__] = ACTIONS(6633),
    [anon_sym_RBRACE] = ACTIONS(6633),
    [anon_sym_RPAREN] = ACTIONS(6633),
    [anon_sym_SEMI] = ACTIONS(6633),
    [anon_sym_end] = ACTIONS(6633),
    [anon_sym_rescue] = ACTIONS(6633),
    [anon_sym_when] = ACTIONS(6633),
    [anon_sym_elsif] = ACTIONS(6633),
    [anon_sym_else] = ACTIONS(6633),
    [anon_sym_ensure] = ACTIONS(6633),
    [sym_comment] = ACTIONS(87),
  },
  [1793] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2543),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1794] = {
    [sym_heredoc_body] = STATE(4198),
    [sym__terminator] = STATE(4198),
    [aux_sym__statements_repeat1] = STATE(4199),
    [sym__line_break2] = ACTIONS(6635),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_RBRACE] = ACTIONS(2543),
    [anon_sym_SEMI] = ACTIONS(6635),
    [sym_comment] = ACTIONS(87),
  },
  [1795] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4200),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4200),
    [sym_operator_assignment] = STATE(4200),
    [sym_conditional] = STATE(4200),
    [sym_range] = STATE(4200),
    [sym_binary] = STATE(4200),
    [sym_unary] = STATE(4200),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1796] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4201),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4201),
    [sym_operator_assignment] = STATE(4201),
    [sym_conditional] = STATE(4201),
    [sym_range] = STATE(4201),
    [sym_binary] = STATE(4201),
    [sym_unary] = STATE(4201),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1797] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4202),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4202),
    [sym_operator_assignment] = STATE(4202),
    [sym_conditional] = STATE(4202),
    [sym_range] = STATE(4202),
    [sym_binary] = STATE(4202),
    [sym_unary] = STATE(4202),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1798] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4203),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4203),
    [sym_operator_assignment] = STATE(4203),
    [sym_conditional] = STATE(4203),
    [sym_range] = STATE(4203),
    [sym_binary] = STATE(4203),
    [sym_unary] = STATE(4203),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1799] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4204),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4204),
    [sym_operator_assignment] = STATE(4204),
    [sym_conditional] = STATE(4204),
    [sym_range] = STATE(4204),
    [sym_binary] = STATE(4204),
    [sym_unary] = STATE(4204),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1800] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4205),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4205),
    [sym_operator_assignment] = STATE(4205),
    [sym_conditional] = STATE(4205),
    [sym_range] = STATE(4205),
    [sym_binary] = STATE(4205),
    [sym_unary] = STATE(4205),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1801] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4206),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4206),
    [sym_operator_assignment] = STATE(4206),
    [sym_conditional] = STATE(4206),
    [sym_range] = STATE(4206),
    [sym_binary] = STATE(4206),
    [sym_unary] = STATE(4206),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1802] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4207),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4207),
    [sym_operator_assignment] = STATE(4207),
    [sym_conditional] = STATE(4207),
    [sym_range] = STATE(4207),
    [sym_binary] = STATE(4207),
    [sym_unary] = STATE(4207),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1803] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4208),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4208),
    [sym_operator_assignment] = STATE(4208),
    [sym_conditional] = STATE(4208),
    [sym_range] = STATE(4208),
    [sym_binary] = STATE(4208),
    [sym_unary] = STATE(4208),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1804] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4209),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4209),
    [sym_operator_assignment] = STATE(4209),
    [sym_conditional] = STATE(4209),
    [sym_range] = STATE(4209),
    [sym_binary] = STATE(4209),
    [sym_unary] = STATE(4209),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1805] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4210),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4210),
    [sym_operator_assignment] = STATE(4210),
    [sym_conditional] = STATE(4210),
    [sym_range] = STATE(4210),
    [sym_binary] = STATE(4210),
    [sym_unary] = STATE(4210),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1806] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4211),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4211),
    [sym_operator_assignment] = STATE(4211),
    [sym_conditional] = STATE(4211),
    [sym_range] = STATE(4211),
    [sym_binary] = STATE(4211),
    [sym_unary] = STATE(4211),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1807] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4212),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4212),
    [sym_operator_assignment] = STATE(4212),
    [sym_conditional] = STATE(4212),
    [sym_range] = STATE(4212),
    [sym_binary] = STATE(4212),
    [sym_unary] = STATE(4212),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1808] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4213),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4213),
    [sym_operator_assignment] = STATE(4213),
    [sym_conditional] = STATE(4213),
    [sym_range] = STATE(4213),
    [sym_binary] = STATE(4213),
    [sym_unary] = STATE(4213),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1809] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4214),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4214),
    [sym_operator_assignment] = STATE(4214),
    [sym_conditional] = STATE(4214),
    [sym_range] = STATE(4214),
    [sym_binary] = STATE(4214),
    [sym_unary] = STATE(4214),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1810] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4215),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4215),
    [sym_operator_assignment] = STATE(4215),
    [sym_conditional] = STATE(4215),
    [sym_range] = STATE(4215),
    [sym_binary] = STATE(4215),
    [sym_unary] = STATE(4215),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1811] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4216),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4216),
    [sym_operator_assignment] = STATE(4216),
    [sym_conditional] = STATE(4216),
    [sym_range] = STATE(4216),
    [sym_binary] = STATE(4216),
    [sym_unary] = STATE(4216),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1812] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4225),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(4225),
    [sym_operator_assignment] = STATE(4225),
    [sym_conditional] = STATE(4225),
    [sym_range] = STATE(4225),
    [sym_binary] = STATE(4225),
    [sym_unary] = STATE(4225),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1813] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4230),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(4230),
    [sym_operator_assignment] = STATE(4230),
    [sym_conditional] = STATE(4230),
    [sym_range] = STATE(4230),
    [sym_binary] = STATE(4230),
    [sym_unary] = STATE(4230),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1814] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4231),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(4231),
    [sym_operator_assignment] = STATE(4231),
    [sym_conditional] = STATE(4231),
    [sym_range] = STATE(4231),
    [sym_binary] = STATE(4231),
    [sym_unary] = STATE(4231),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1815] = {
    [anon_sym_COLON] = ACTIONS(6661),
    [sym_comment] = ACTIONS(87),
  },
  [1816] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4234),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(4234),
    [sym_operator_assignment] = STATE(4234),
    [sym_conditional] = STATE(4234),
    [sym_range] = STATE(4234),
    [sym_binary] = STATE(4234),
    [sym_unary] = STATE(4234),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [1817] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1818] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1819] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1820] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1821] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4235),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(4235),
    [sym_operator_assignment] = STATE(4235),
    [sym_conditional] = STATE(4235),
    [sym_range] = STATE(4235),
    [sym_binary] = STATE(4235),
    [sym_unary] = STATE(4235),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1822] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4236),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(4236),
    [sym_operator_assignment] = STATE(4236),
    [sym_conditional] = STATE(4236),
    [sym_range] = STATE(4236),
    [sym_binary] = STATE(4236),
    [sym_unary] = STATE(4236),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1823] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1824] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6663),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1825] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(6677),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [1826] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(3885),
    [sym__argument] = STATE(3886),
    [sym_splat_argument] = STATE(3886),
    [sym_hash_splat_argument] = STATE(3886),
    [sym_block_argument] = STATE(3886),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3886),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [1827] = {
    [sym_heredoc_body] = STATE(4250),
    [aux_sym_call_repeat1] = STATE(4250),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1828] = {
    [sym_heredoc_body] = STATE(4250),
    [aux_sym_call_repeat1] = STATE(4250),
    [aux_sym_argument_list_repeat1] = STATE(4252),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6695),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1829] = {
    [anon_sym_EQ] = ACTIONS(6697),
    [sym_comment] = ACTIONS(87),
  },
  [1830] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6699),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6701),
    [anon_sym_DASH_EQ] = ACTIONS(6701),
    [anon_sym_STAR_EQ] = ACTIONS(6701),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6701),
    [anon_sym_SLASH_EQ] = ACTIONS(6701),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6701),
    [anon_sym_PIPE_EQ] = ACTIONS(6701),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6701),
    [anon_sym_AMP_EQ] = ACTIONS(6701),
    [anon_sym_PERCENT_EQ] = ACTIONS(6701),
    [anon_sym_GT_GT_EQ] = ACTIONS(6701),
    [anon_sym_LT_LT_EQ] = ACTIONS(6701),
    [anon_sym_CARET_EQ] = ACTIONS(6701),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1831] = {
    [sym_string] = STATE(4255),
    [aux_sym_chained_string_repeat1] = STATE(4255),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6703),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1832] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4261),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_splat_argument] = STATE(4262),
    [sym_assignment] = STATE(4261),
    [sym_operator_assignment] = STATE(4261),
    [sym_conditional] = STATE(4261),
    [sym_range] = STATE(4261),
    [sym_binary] = STATE(4261),
    [sym_unary] = STATE(4261),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(4262),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(6705),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1833] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4265),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(4265),
    [sym_operator_assignment] = STATE(4265),
    [sym_conditional] = STATE(4265),
    [sym_range] = STATE(4265),
    [sym_binary] = STATE(4265),
    [sym_unary] = STATE(4265),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1834] = {
    [sym_string] = STATE(4266),
    [aux_sym_chained_string_repeat1] = STATE(4266),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1835] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [1836] = {
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [1837] = {
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [sym_comment] = ACTIONS(87),
  },
  [1838] = {
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [sym_comment] = ACTIONS(87),
  },
  [1839] = {
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [sym_comment] = ACTIONS(87),
  },
  [1840] = {
    [sym__string_end2] = ACTIONS(6717),
    [sym_comment] = ACTIONS(87),
  },
  [1841] = {
    [aux_sym_string_array_repeat1] = STATE(4270),
    [sym__string_end2] = ACTIONS(6719),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6721),
  },
  [1842] = {
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [sym_comment] = ACTIONS(87),
  },
  [1843] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6723),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1844] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(6723),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6725),
  },
  [1845] = {
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_COLON2] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [1846] = {
    [sym__string_end2] = ACTIONS(6727),
    [sym_comment] = ACTIONS(87),
  },
  [1847] = {
    [aux_sym_symbol_array_repeat1] = STATE(4276),
    [sym__string_end2] = ACTIONS(6729),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6731),
  },
  [1848] = {
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON2] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [1849] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6733),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [1850] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(6733),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6735),
  },
  [1851] = {
    [anon_sym_RBRACE] = ACTIONS(6737),
    [anon_sym_if] = ACTIONS(2855),
    [anon_sym_unless] = ACTIONS(2857),
    [anon_sym_while] = ACTIONS(2859),
    [anon_sym_until] = ACTIONS(2861),
    [anon_sym_rescue] = ACTIONS(2863),
    [sym_comment] = ACTIONS(87),
  },
  [1852] = {
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [1853] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(6741),
    [sym_heredoc_end2] = ACTIONS(6744),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6746),
    [sym_escape_sequence] = ACTIONS(6741),
  },
  [1854] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(3224),
    [anon_sym_or] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [1855] = {
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_COLON2] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(87),
  },
  [1856] = {
    [anon_sym_RBRACE] = ACTIONS(6751),
    [sym_comment] = ACTIONS(87),
  },
  [1857] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(6753),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [1858] = {
    [sym__method_rest] = STATE(4282),
    [sym_operator] = STATE(539),
    [sym__method_name] = STATE(539),
    [sym_setter] = STATE(539),
    [sym_symbol] = STATE(539),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6755),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6755),
    [sym_class_variable] = ACTIONS(6755),
    [sym_global_variable] = ACTIONS(6755),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [1859] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(4283),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6757),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1860] = {
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_COLON2] = ACTIONS(3746),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(87),
  },
  [1861] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1862] = {
    [sym__simple_symbol2] = ACTIONS(1427),
    [sym__string_start2] = ACTIONS(1427),
    [sym__symbol_start2] = ACTIONS(1427),
    [sym__subshell_start2] = ACTIONS(1427),
    [sym__regex_start2] = ACTIONS(1427),
    [sym__string_array_start2] = ACTIONS(1427),
    [sym__symbol_array_start2] = ACTIONS(1427),
    [sym__heredoc_body_start2] = ACTIONS(1427),
    [sym_heredoc_beginning2] = ACTIONS(1427),
    [sym__block_ampersand2] = ACTIONS(1427),
    [sym__splat_star2] = ACTIONS(1427),
    [sym__unary_minus2] = ACTIONS(1427),
    [sym__binary_minus2] = ACTIONS(1427),
    [sym__binary_star2] = ACTIONS(1427),
    [sym__identifier_hash_key2] = ACTIONS(1427),
    [anon_sym_LBRACE] = ACTIONS(1427),
    [anon_sym_RBRACE] = ACTIONS(1427),
    [anon_sym_def] = ACTIONS(1429),
    [anon_sym_LPAREN] = ACTIONS(1429),
    [anon_sym_RPAREN] = ACTIONS(1427),
    [anon_sym_DOT] = ACTIONS(1429),
    [anon_sym_COLON_COLON] = ACTIONS(1429),
    [anon_sym_COMMA] = ACTIONS(1427),
    [anon_sym_PIPE] = ACTIONS(1429),
    [anon_sym_SEMI] = ACTIONS(1427),
    [anon_sym_STAR] = ACTIONS(1429),
    [anon_sym_STAR_STAR] = ACTIONS(1429),
    [anon_sym_AMP] = ACTIONS(1429),
    [anon_sym_EQ] = ACTIONS(1429),
    [anon_sym_class] = ACTIONS(1429),
    [anon_sym_LT] = ACTIONS(1429),
    [anon_sym_module] = ACTIONS(1429),
    [anon_sym_return] = ACTIONS(1429),
    [anon_sym_yield] = ACTIONS(1429),
    [anon_sym_break] = ACTIONS(1429),
    [anon_sym_next] = ACTIONS(1429),
    [sym_redo] = ACTIONS(1429),
    [sym_retry] = ACTIONS(1429),
    [anon_sym_if] = ACTIONS(1429),
    [anon_sym_unless] = ACTIONS(1429),
    [anon_sym_while] = ACTIONS(1429),
    [anon_sym_until] = ACTIONS(1429),
    [anon_sym_rescue] = ACTIONS(1429),
    [anon_sym_for] = ACTIONS(1429),
    [anon_sym_in] = ACTIONS(1429),
    [anon_sym_do] = ACTIONS(1429),
    [anon_sym_case] = ACTIONS(1429),
    [anon_sym_begin] = ACTIONS(1429),
    [anon_sym_LBRACK] = ACTIONS(1427),
    [anon_sym_RBRACK] = ACTIONS(1427),
    [anon_sym_COLON_COLON2] = ACTIONS(1427),
    [anon_sym_AMP_DOT] = ACTIONS(1427),
    [anon_sym_LPAREN2] = ACTIONS(1427),
    [anon_sym_PLUS_EQ] = ACTIONS(1427),
    [anon_sym_DASH_EQ] = ACTIONS(1427),
    [anon_sym_STAR_EQ] = ACTIONS(1427),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1427),
    [anon_sym_SLASH_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_PIPE_EQ] = ACTIONS(1427),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1427),
    [anon_sym_AMP_EQ] = ACTIONS(1427),
    [anon_sym_PERCENT_EQ] = ACTIONS(1427),
    [anon_sym_GT_GT_EQ] = ACTIONS(1427),
    [anon_sym_LT_LT_EQ] = ACTIONS(1427),
    [anon_sym_CARET_EQ] = ACTIONS(1427),
    [anon_sym_QMARK] = ACTIONS(1429),
    [anon_sym_COLON2] = ACTIONS(1429),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1427),
    [anon_sym_and] = ACTIONS(1429),
    [anon_sym_or] = ACTIONS(1429),
    [anon_sym_PIPE_PIPE] = ACTIONS(1429),
    [anon_sym_AMP_AMP] = ACTIONS(1429),
    [anon_sym_LT_LT] = ACTIONS(1429),
    [anon_sym_GT_GT] = ACTIONS(1429),
    [anon_sym_EQ_EQ] = ACTIONS(1429),
    [anon_sym_BANG_EQ] = ACTIONS(1427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1427),
    [anon_sym_LT_EQ_GT] = ACTIONS(1427),
    [anon_sym_EQ_TILDE] = ACTIONS(1427),
    [anon_sym_BANG_TILDE] = ACTIONS(1427),
    [anon_sym_LT_EQ] = ACTIONS(1429),
    [anon_sym_GT] = ACTIONS(1429),
    [anon_sym_GT_EQ] = ACTIONS(1427),
    [anon_sym_CARET] = ACTIONS(1429),
    [anon_sym_PLUS] = ACTIONS(1429),
    [anon_sym_SLASH] = ACTIONS(1429),
    [anon_sym_PERCENT] = ACTIONS(1429),
    [anon_sym_defined_QMARK] = ACTIONS(1427),
    [anon_sym_not] = ACTIONS(1429),
    [anon_sym_BANG] = ACTIONS(1429),
    [anon_sym_TILDE] = ACTIONS(1427),
    [sym_constant] = ACTIONS(1429),
    [sym_identifier] = ACTIONS(1429),
    [sym_instance_variable] = ACTIONS(1427),
    [sym_class_variable] = ACTIONS(1427),
    [sym_global_variable] = ACTIONS(1427),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1429),
    [sym_float] = ACTIONS(1429),
    [sym_complex] = ACTIONS(1427),
    [sym_super] = ACTIONS(1429),
    [anon_sym_true] = ACTIONS(1429),
    [anon_sym_TRUE] = ACTIONS(1429),
    [anon_sym_false] = ACTIONS(1429),
    [anon_sym_FALSE] = ACTIONS(1429),
    [sym_self] = ACTIONS(1429),
    [anon_sym_nil] = ACTIONS(1429),
    [anon_sym_NIL] = ACTIONS(1429),
    [sym_character] = ACTIONS(1427),
    [anon_sym_LBRACK2] = ACTIONS(1429),
    [anon_sym_DASH_GT] = ACTIONS(1427),
  },
  [1863] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4288),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(4288),
    [sym_operator_assignment] = STATE(4288),
    [sym_conditional] = STATE(4288),
    [sym_range] = STATE(4288),
    [sym_binary] = STATE(4288),
    [sym_unary] = STATE(4288),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1864] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4291),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(4291),
    [sym_operator_assignment] = STATE(4291),
    [sym_conditional] = STATE(4291),
    [sym_range] = STATE(4291),
    [sym_binary] = STATE(4291),
    [sym_unary] = STATE(4291),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1865] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4292),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(4292),
    [sym_operator_assignment] = STATE(4292),
    [sym_conditional] = STATE(4292),
    [sym_range] = STATE(4292),
    [sym_binary] = STATE(4292),
    [sym_unary] = STATE(4292),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1866] = {
    [anon_sym_COLON] = ACTIONS(6771),
    [sym_comment] = ACTIONS(87),
  },
  [1867] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4295),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(4295),
    [sym_operator_assignment] = STATE(4295),
    [sym_conditional] = STATE(4295),
    [sym_range] = STATE(4295),
    [sym_binary] = STATE(4295),
    [sym_unary] = STATE(4295),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1868] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(4302),
    [sym__argument] = STATE(4303),
    [sym_splat_argument] = STATE(4303),
    [sym_hash_splat_argument] = STATE(4303),
    [sym_block_argument] = STATE(4303),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4303),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1869] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(4302),
    [sym__argument] = STATE(4303),
    [sym_splat_argument] = STATE(4303),
    [sym_hash_splat_argument] = STATE(4303),
    [sym_block_argument] = STATE(4303),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4303),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1870] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(4302),
    [sym__argument] = STATE(4303),
    [sym_splat_argument] = STATE(4303),
    [sym_hash_splat_argument] = STATE(4303),
    [sym_block_argument] = STATE(4303),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4303),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1871] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(4302),
    [sym__argument] = STATE(4303),
    [sym_splat_argument] = STATE(4303),
    [sym_hash_splat_argument] = STATE(4303),
    [sym_block_argument] = STATE(4303),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4303),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3194),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1872] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4305),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(4305),
    [sym_operator_assignment] = STATE(4305),
    [sym_conditional] = STATE(4305),
    [sym_range] = STATE(4305),
    [sym_binary] = STATE(4305),
    [sym_unary] = STATE(4305),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1873] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4306),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(4306),
    [sym_operator_assignment] = STATE(4306),
    [sym_conditional] = STATE(4306),
    [sym_range] = STATE(4306),
    [sym_binary] = STATE(4306),
    [sym_unary] = STATE(4306),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1874] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1875] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6781),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1876] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(6795),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [1877] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1878] = {
    [sym_heredoc_body] = STATE(4329),
    [aux_sym_call_repeat1] = STATE(4329),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1879] = {
    [sym_heredoc_body] = STATE(4329),
    [aux_sym_call_repeat1] = STATE(4329),
    [aux_sym_argument_list_repeat1] = STATE(4331),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1880] = {
    [anon_sym_EQ] = ACTIONS(6825),
    [sym_comment] = ACTIONS(87),
  },
  [1881] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6827),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6829),
    [anon_sym_DASH_EQ] = ACTIONS(6829),
    [anon_sym_STAR_EQ] = ACTIONS(6829),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6829),
    [anon_sym_SLASH_EQ] = ACTIONS(6829),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6829),
    [anon_sym_PIPE_EQ] = ACTIONS(6829),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6829),
    [anon_sym_AMP_EQ] = ACTIONS(6829),
    [anon_sym_PERCENT_EQ] = ACTIONS(6829),
    [anon_sym_GT_GT_EQ] = ACTIONS(6829),
    [anon_sym_LT_LT_EQ] = ACTIONS(6829),
    [anon_sym_CARET_EQ] = ACTIONS(6829),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1882] = {
    [sym_string] = STATE(4334),
    [aux_sym_chained_string_repeat1] = STATE(4334),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6831),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1883] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1884] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [1885] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4335),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4335),
    [sym_operator_assignment] = STATE(4335),
    [sym_conditional] = STATE(4335),
    [sym_range] = STATE(4335),
    [sym_binary] = STATE(4335),
    [sym_unary] = STATE(4335),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1886] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4336),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4336),
    [sym_operator_assignment] = STATE(4336),
    [sym_conditional] = STATE(4336),
    [sym_range] = STATE(4336),
    [sym_binary] = STATE(4336),
    [sym_unary] = STATE(4336),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1887] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4337),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4337),
    [sym_operator_assignment] = STATE(4337),
    [sym_conditional] = STATE(4337),
    [sym_range] = STATE(4337),
    [sym_binary] = STATE(4337),
    [sym_unary] = STATE(4337),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1888] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4338),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4338),
    [sym_operator_assignment] = STATE(4338),
    [sym_conditional] = STATE(4338),
    [sym_range] = STATE(4338),
    [sym_binary] = STATE(4338),
    [sym_unary] = STATE(4338),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1889] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4339),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4339),
    [sym_operator_assignment] = STATE(4339),
    [sym_conditional] = STATE(4339),
    [sym_range] = STATE(4339),
    [sym_binary] = STATE(4339),
    [sym_unary] = STATE(4339),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1890] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4340),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4340),
    [sym_operator_assignment] = STATE(4340),
    [sym_conditional] = STATE(4340),
    [sym_range] = STATE(4340),
    [sym_binary] = STATE(4340),
    [sym_unary] = STATE(4340),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1891] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4341),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4341),
    [sym_operator_assignment] = STATE(4341),
    [sym_conditional] = STATE(4341),
    [sym_range] = STATE(4341),
    [sym_binary] = STATE(4341),
    [sym_unary] = STATE(4341),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1892] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4342),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4342),
    [sym_operator_assignment] = STATE(4342),
    [sym_conditional] = STATE(4342),
    [sym_range] = STATE(4342),
    [sym_binary] = STATE(4342),
    [sym_unary] = STATE(4342),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1893] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4343),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4343),
    [sym_operator_assignment] = STATE(4343),
    [sym_conditional] = STATE(4343),
    [sym_range] = STATE(4343),
    [sym_binary] = STATE(4343),
    [sym_unary] = STATE(4343),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1894] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4344),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4344),
    [sym_operator_assignment] = STATE(4344),
    [sym_conditional] = STATE(4344),
    [sym_range] = STATE(4344),
    [sym_binary] = STATE(4344),
    [sym_unary] = STATE(4344),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1895] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4345),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4345),
    [sym_operator_assignment] = STATE(4345),
    [sym_conditional] = STATE(4345),
    [sym_range] = STATE(4345),
    [sym_binary] = STATE(4345),
    [sym_unary] = STATE(4345),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1896] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4346),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4346),
    [sym_operator_assignment] = STATE(4346),
    [sym_conditional] = STATE(4346),
    [sym_range] = STATE(4346),
    [sym_binary] = STATE(4346),
    [sym_unary] = STATE(4346),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1897] = {
    [sym_argument_list_with_parens] = STATE(4349),
    [sym__argument_list_with_parens] = STATE(4350),
    [sym_operator] = STATE(4349),
    [sym_heredoc_body] = STATE(4351),
    [aux_sym_call_repeat1] = STATE(4351),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(6833),
    [anon_sym_STAR] = ACTIONS(6835),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_AMP] = ACTIONS(6833),
    [anon_sym_LT] = ACTIONS(6835),
    [anon_sym_LPAREN2] = ACTIONS(6837),
    [anon_sym_DOT_DOT] = ACTIONS(6833),
    [anon_sym_LT_LT] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6833),
    [anon_sym_LT_EQ_GT] = ACTIONS(6833),
    [anon_sym_EQ_TILDE] = ACTIONS(6833),
    [anon_sym_BANG_TILDE] = ACTIONS(6833),
    [anon_sym_LT_EQ] = ACTIONS(6835),
    [anon_sym_GT] = ACTIONS(6835),
    [anon_sym_GT_EQ] = ACTIONS(6833),
    [anon_sym_CARET] = ACTIONS(6833),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_SLASH] = ACTIONS(6833),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_BANG] = ACTIONS(6835),
    [anon_sym_TILDE] = ACTIONS(6833),
    [sym_constant] = ACTIONS(6839),
    [sym_identifier] = ACTIONS(6839),
    [anon_sym_DASH] = ACTIONS(6835),
    [anon_sym_PLUS_AT] = ACTIONS(6833),
    [anon_sym_DASH_AT] = ACTIONS(6833),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6835),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6833),
    [anon_sym_BQUOTE] = ACTIONS(6833),
    [sym_comment] = ACTIONS(87),
  },
  [1898] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(4353),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4354),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(6841),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1899] = {
    [sym_constant] = ACTIONS(6843),
    [sym_identifier] = ACTIONS(6843),
    [sym_comment] = ACTIONS(87),
  },
  [1900] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4364),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(4364),
    [sym_operator_assignment] = STATE(4364),
    [sym_conditional] = STATE(4364),
    [sym_range] = STATE(4364),
    [sym_binary] = STATE(4364),
    [sym_unary] = STATE(4364),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1901] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4369),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(4369),
    [sym_operator_assignment] = STATE(4369),
    [sym_conditional] = STATE(4369),
    [sym_range] = STATE(4369),
    [sym_binary] = STATE(4369),
    [sym_unary] = STATE(4369),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1902] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4370),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(4370),
    [sym_operator_assignment] = STATE(4370),
    [sym_conditional] = STATE(4370),
    [sym_range] = STATE(4370),
    [sym_binary] = STATE(4370),
    [sym_unary] = STATE(4370),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1903] = {
    [anon_sym_COLON] = ACTIONS(6869),
    [sym_comment] = ACTIONS(87),
  },
  [1904] = {
    [sym__statements] = STATE(4374),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(4375),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6871),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1905] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4376),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(4376),
    [sym_operator_assignment] = STATE(4376),
    [sym_conditional] = STATE(4376),
    [sym_range] = STATE(4376),
    [sym_binary] = STATE(4376),
    [sym_unary] = STATE(4376),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [1906] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1907] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1908] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1909] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1910] = {
    [sym__statements] = STATE(4378),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4379),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4380),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4380),
    [sym__line_break2] = ACTIONS(6873),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6875),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1911] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4381),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(4381),
    [sym_operator_assignment] = STATE(4381),
    [sym_conditional] = STATE(4381),
    [sym_range] = STATE(4381),
    [sym_binary] = STATE(4381),
    [sym_unary] = STATE(4381),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1912] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4382),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(4382),
    [sym_operator_assignment] = STATE(4382),
    [sym_conditional] = STATE(4382),
    [sym_range] = STATE(4382),
    [sym_binary] = STATE(4382),
    [sym_unary] = STATE(4382),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1913] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1914] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(6877),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [1915] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(6891),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [1916] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(4326),
    [sym__argument] = STATE(4327),
    [sym_splat_argument] = STATE(4327),
    [sym_hash_splat_argument] = STATE(4327),
    [sym_block_argument] = STATE(4327),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4327),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [1917] = {
    [sym_do_block] = STATE(4397),
    [sym_block] = STATE(4397),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(6911),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1918] = {
    [sym_heredoc_body] = STATE(4398),
    [aux_sym_call_repeat1] = STATE(4398),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1919] = {
    [sym_heredoc_body] = STATE(4398),
    [aux_sym_call_repeat1] = STATE(4398),
    [aux_sym_argument_list_repeat1] = STATE(4400),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6913),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [1920] = {
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [1921] = {
    [anon_sym_EQ] = ACTIONS(6915),
    [sym_comment] = ACTIONS(87),
  },
  [1922] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(6917),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(6919),
    [anon_sym_DASH_EQ] = ACTIONS(6919),
    [anon_sym_STAR_EQ] = ACTIONS(6919),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6919),
    [anon_sym_SLASH_EQ] = ACTIONS(6919),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6919),
    [anon_sym_PIPE_EQ] = ACTIONS(6919),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6919),
    [anon_sym_AMP_EQ] = ACTIONS(6919),
    [anon_sym_PERCENT_EQ] = ACTIONS(6919),
    [anon_sym_GT_GT_EQ] = ACTIONS(6919),
    [anon_sym_LT_LT_EQ] = ACTIONS(6919),
    [anon_sym_CARET_EQ] = ACTIONS(6919),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1923] = {
    [sym_string] = STATE(4403),
    [aux_sym_chained_string_repeat1] = STATE(4403),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(6921),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [1924] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4405),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_splat_argument] = STATE(4406),
    [sym_assignment] = STATE(4405),
    [sym_operator_assignment] = STATE(4405),
    [sym_conditional] = STATE(4405),
    [sym_range] = STATE(4405),
    [sym_binary] = STATE(4405),
    [sym_unary] = STATE(4405),
    [sym_right_assignment_list] = STATE(3650),
    [sym__arg_or_splat_arg] = STATE(4406),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(6923),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1925] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4407),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(4407),
    [sym_operator_assignment] = STATE(4407),
    [sym_conditional] = STATE(4407),
    [sym_range] = STATE(4407),
    [sym_binary] = STATE(4407),
    [sym_unary] = STATE(4407),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1926] = {
    [sym_string] = STATE(4408),
    [aux_sym_chained_string_repeat1] = STATE(4408),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1927] = {
    [sym_heredoc_body] = STATE(4409),
    [sym__terminator] = STATE(4409),
    [sym__line_break2] = ACTIONS(6925),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(6925),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [1928] = {
    [sym_heredoc_body] = STATE(4410),
    [sym__terminator] = STATE(4410),
    [sym__line_break2] = ACTIONS(6927),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(6927),
    [sym_comment] = ACTIONS(87),
  },
  [1929] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(4411),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6929),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1930] = {
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4158),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON2] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_LT_LT] = ACTIONS(4158),
    [anon_sym_GT_GT] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_SLASH] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(87),
  },
  [1931] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(4412),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6931),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1932] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [1933] = {
    [sym_string] = STATE(1965),
    [aux_sym_chained_string_repeat1] = STATE(1965),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [1934] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [1935] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [1936] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4413),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4413),
    [sym_operator_assignment] = STATE(4413),
    [sym_conditional] = STATE(4413),
    [sym_range] = STATE(4413),
    [sym_binary] = STATE(4413),
    [sym_unary] = STATE(4413),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1937] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [1938] = {
    [sym_heredoc_body] = STATE(4414),
    [aux_sym_call_repeat1] = STATE(4414),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1939] = {
    [sym_heredoc_body] = STATE(4414),
    [aux_sym_call_repeat1] = STATE(4414),
    [aux_sym_argument_list_repeat1] = STATE(4415),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [1940] = {
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4242),
    [anon_sym_AMP_AMP] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
  },
  [1941] = {
    [sym_heredoc_body] = STATE(4417),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
  },
  [1942] = {
    [anon_sym_RPAREN] = ACTIONS(6933),
    [sym_comment] = ACTIONS(87),
  },
  [1943] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1944] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [1945] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [1946] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4418),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4418),
    [sym_operator_assignment] = STATE(4418),
    [sym_conditional] = STATE(4418),
    [sym_range] = STATE(4418),
    [sym_binary] = STATE(4418),
    [sym_unary] = STATE(4418),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1947] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4419),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4419),
    [sym_operator_assignment] = STATE(4419),
    [sym_conditional] = STATE(4419),
    [sym_range] = STATE(4419),
    [sym_binary] = STATE(4419),
    [sym_unary] = STATE(4419),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1948] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4420),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4420),
    [sym_operator_assignment] = STATE(4420),
    [sym_conditional] = STATE(4420),
    [sym_range] = STATE(4420),
    [sym_binary] = STATE(4420),
    [sym_unary] = STATE(4420),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1949] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4421),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4421),
    [sym_operator_assignment] = STATE(4421),
    [sym_conditional] = STATE(4421),
    [sym_range] = STATE(4421),
    [sym_binary] = STATE(4421),
    [sym_unary] = STATE(4421),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1950] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4422),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4422),
    [sym_operator_assignment] = STATE(4422),
    [sym_conditional] = STATE(4422),
    [sym_range] = STATE(4422),
    [sym_binary] = STATE(4422),
    [sym_unary] = STATE(4422),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1951] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4423),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4423),
    [sym_operator_assignment] = STATE(4423),
    [sym_conditional] = STATE(4423),
    [sym_range] = STATE(4423),
    [sym_binary] = STATE(4423),
    [sym_unary] = STATE(4423),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1952] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4424),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4424),
    [sym_operator_assignment] = STATE(4424),
    [sym_conditional] = STATE(4424),
    [sym_range] = STATE(4424),
    [sym_binary] = STATE(4424),
    [sym_unary] = STATE(4424),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1953] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4425),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4425),
    [sym_operator_assignment] = STATE(4425),
    [sym_conditional] = STATE(4425),
    [sym_range] = STATE(4425),
    [sym_binary] = STATE(4425),
    [sym_unary] = STATE(4425),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [1954] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4426),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4426),
    [sym_operator_assignment] = STATE(4426),
    [sym_conditional] = STATE(4426),
    [sym_range] = STATE(4426),
    [sym_binary] = STATE(4426),
    [sym_unary] = STATE(4426),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1955] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4427),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4427),
    [sym_operator_assignment] = STATE(4427),
    [sym_conditional] = STATE(4427),
    [sym_range] = STATE(4427),
    [sym_binary] = STATE(4427),
    [sym_unary] = STATE(4427),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1956] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4428),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4428),
    [sym_operator_assignment] = STATE(4428),
    [sym_conditional] = STATE(4428),
    [sym_range] = STATE(4428),
    [sym_binary] = STATE(4428),
    [sym_unary] = STATE(4428),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1957] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4429),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4429),
    [sym_operator_assignment] = STATE(4429),
    [sym_conditional] = STATE(4429),
    [sym_range] = STATE(4429),
    [sym_binary] = STATE(4429),
    [sym_unary] = STATE(4429),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1958] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4430),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4430),
    [sym_operator_assignment] = STATE(4430),
    [sym_conditional] = STATE(4430),
    [sym_range] = STATE(4430),
    [sym_binary] = STATE(4430),
    [sym_unary] = STATE(4430),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1959] = {
    [sym_interpolation] = STATE(4432),
    [aux_sym_heredoc_body_repeat1] = STATE(4432),
    [sym__heredoc_content2] = ACTIONS(6935),
    [sym_heredoc_end2] = ACTIONS(6937),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(6935),
  },
  [1960] = {
    [sym_heredoc_body] = STATE(4433),
    [aux_sym_call_repeat1] = STATE(4433),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [1961] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4435),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6939),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1962] = {
    [sym_heredoc_body] = STATE(4436),
    [aux_sym_call_repeat1] = STATE(4436),
    [aux_sym_argument_list_repeat1] = STATE(4437),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [1963] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4438),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_splat_argument] = STATE(4440),
    [sym_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(4438),
    [sym_range] = STATE(4438),
    [sym_binary] = STATE(4438),
    [sym_unary] = STATE(4438),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(4440),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1964] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4441),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(4441),
    [sym_operator_assignment] = STATE(4441),
    [sym_conditional] = STATE(4441),
    [sym_range] = STATE(4441),
    [sym_binary] = STATE(4441),
    [sym_unary] = STATE(4441),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [1965] = {
    [sym_string] = STATE(4442),
    [aux_sym_chained_string_repeat1] = STATE(4442),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [1966] = {
    [sym__statements] = STATE(4444),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(4445),
    [sym_else] = STATE(4445),
    [sym__if_tail] = STATE(4445),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4446),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4446),
    [sym__line_break2] = ACTIONS(6941),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6943),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1967] = {
    [sym__statements] = STATE(4448),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(4449),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6945),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1968] = {
    [sym__statements] = STATE(4451),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6947),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1969] = {
    [sym__statements] = STATE(4453),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6949),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1970] = {
    [sym__do] = STATE(4454),
    [sym_heredoc_body] = STATE(4454),
    [sym__terminator] = STATE(4454),
    [sym__line_break2] = ACTIONS(6951),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(6951),
    [anon_sym_do] = ACTIONS(6951),
    [sym_comment] = ACTIONS(87),
  },
  [1971] = {
    [sym_when] = STATE(4455),
    [aux_sym_case_repeat1] = STATE(4456),
    [anon_sym_SEMI] = ACTIONS(6953),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1972] = {
    [anon_sym_end] = ACTIONS(6955),
    [sym_comment] = ACTIONS(87),
  },
  [1973] = {
    [sym_when] = STATE(4455),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [1974] = {
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_COLON2] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [sym_comment] = ACTIONS(87),
  },
  [1975] = {
    [sym_ensure] = STATE(4459),
    [anon_sym_end] = ACTIONS(6957),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1976] = {
    [anon_sym_end] = ACTIONS(6957),
    [sym_comment] = ACTIONS(87),
  },
  [1977] = {
    [sym_else] = STATE(4460),
    [sym_ensure] = STATE(4459),
    [anon_sym_end] = ACTIONS(6957),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [1978] = {
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON2] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [sym_comment] = ACTIONS(87),
  },
  [1979] = {
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_COLON2] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_PLUS] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5738),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(87),
  },
  [1980] = {
    [anon_sym_RBRACK] = ACTIONS(6959),
    [sym_comment] = ACTIONS(87),
  },
  [1981] = {
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [1982] = {
    [anon_sym_RBRACE] = ACTIONS(6961),
    [sym_comment] = ACTIONS(87),
  },
  [1983] = {
    [sym__statements] = STATE(4463),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(6961),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1984] = {
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_COLON2] = ACTIONS(5788),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [1985] = {
    [anon_sym_end] = ACTIONS(6963),
    [sym_comment] = ACTIONS(87),
  },
  [1986] = {
    [sym__statements] = STATE(4465),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4466),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4466),
    [sym__line_break2] = ACTIONS(6965),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6967),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1987] = {
    [sym__statements] = STATE(4465),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4467),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(6967),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [1988] = {
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_AMP_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [1989] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1990] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [1991] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1992] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [1993] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1994] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1995] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(3224),
    [anon_sym_or] = ACTIONS(3224),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [1996] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(6971),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [1997] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1998] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [1999] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [2000] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [2001] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [2002] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [2003] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(4470),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4471),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(6973),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2004] = {
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [2005] = {
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_EQ_GT] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [2006] = {
    [sym_argument_list_with_parens] = STATE(4472),
    [sym__argument_list_with_parens] = STATE(2005),
    [sym_operator] = STATE(4472),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(3366),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_STAR_STAR] = ACTIONS(3366),
    [anon_sym_AMP] = ACTIONS(3366),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_LPAREN2] = ACTIONS(3370),
    [anon_sym_DOT_DOT] = ACTIONS(3366),
    [anon_sym_LT_LT] = ACTIONS(3366),
    [anon_sym_GT_GT] = ACTIONS(3366),
    [anon_sym_EQ_EQ] = ACTIONS(3368),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3366),
    [anon_sym_LT_EQ_GT] = ACTIONS(3366),
    [anon_sym_EQ_TILDE] = ACTIONS(3366),
    [anon_sym_BANG_TILDE] = ACTIONS(3366),
    [anon_sym_LT_EQ] = ACTIONS(3368),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_CARET] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3366),
    [anon_sym_PERCENT] = ACTIONS(3366),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_TILDE] = ACTIONS(3366),
    [sym_constant] = ACTIONS(6975),
    [sym_identifier] = ACTIONS(6975),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_PLUS_AT] = ACTIONS(3366),
    [anon_sym_DASH_AT] = ACTIONS(3366),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3368),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3366),
    [anon_sym_BQUOTE] = ACTIONS(3366),
    [sym_comment] = ACTIONS(87),
  },
  [2007] = {
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_EQ_GT] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [2008] = {
    [sym_heredoc_body] = STATE(4474),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(6977),
    [sym_comment] = ACTIONS(87),
  },
  [2009] = {
    [anon_sym_RBRACK] = ACTIONS(6977),
    [sym_comment] = ACTIONS(87),
  },
  [2010] = {
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_EQ_GT] = ACTIONS(5990),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [2011] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_COLON] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_in] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
    [anon_sym_STAR_EQ] = ACTIONS(841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(841),
    [anon_sym_SLASH_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(841),
    [anon_sym_PIPE_EQ] = ACTIONS(841),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(841),
    [anon_sym_AMP_EQ] = ACTIONS(841),
    [anon_sym_PERCENT_EQ] = ACTIONS(841),
    [anon_sym_GT_GT_EQ] = ACTIONS(841),
    [anon_sym_LT_LT_EQ] = ACTIONS(841),
    [anon_sym_CARET_EQ] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [sym_comment] = ACTIONS(87),
  },
  [2012] = {
    [sym__string_end2] = ACTIONS(6979),
    [sym_comment] = ACTIONS(87),
  },
  [2013] = {
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_EQ_GT] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_COLON2] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [2014] = {
    [sym__string_end2] = ACTIONS(6981),
    [sym_comment] = ACTIONS(87),
  },
  [2015] = {
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_EQ_GT] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_RBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [anon_sym_DASH_EQ] = ACTIONS(897),
    [anon_sym_STAR_EQ] = ACTIONS(897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(897),
    [anon_sym_SLASH_EQ] = ACTIONS(897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(897),
    [anon_sym_PIPE_EQ] = ACTIONS(897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(897),
    [anon_sym_AMP_EQ] = ACTIONS(897),
    [anon_sym_PERCENT_EQ] = ACTIONS(897),
    [anon_sym_GT_GT_EQ] = ACTIONS(897),
    [anon_sym_LT_LT_EQ] = ACTIONS(897),
    [anon_sym_CARET_EQ] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_COLON2] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [2016] = {
    [sym__string_end2] = ACTIONS(6983),
    [sym_comment] = ACTIONS(87),
  },
  [2017] = {
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_EQ_GT] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [anon_sym_DASH_EQ] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(903),
    [anon_sym_SLASH_EQ] = ACTIONS(903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(903),
    [anon_sym_PIPE_EQ] = ACTIONS(903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(903),
    [anon_sym_AMP_EQ] = ACTIONS(903),
    [anon_sym_PERCENT_EQ] = ACTIONS(903),
    [anon_sym_GT_GT_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_EQ] = ACTIONS(903),
    [anon_sym_CARET_EQ] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_COLON2] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [2018] = {
    [sym__string_end2] = ACTIONS(6985),
    [sym_comment] = ACTIONS(87),
  },
  [2019] = {
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_EQ_GT] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [sym_comment] = ACTIONS(87),
  },
  [2020] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(4481),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6987),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6989),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2021] = {
    [aux_sym_string_array_repeat1] = STATE(4484),
    [sym__string_end2] = ACTIONS(6991),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6993),
  },
  [2022] = {
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_in] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_EQ_GT] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_COLON2] = ACTIONS(929),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [sym_comment] = ACTIONS(87),
  },
  [2023] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(4487),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(6995),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(6997),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2024] = {
    [aux_sym_symbol_array_repeat1] = STATE(4490),
    [sym__string_end2] = ACTIONS(6999),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7001),
  },
  [2025] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7003),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2026] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [2027] = {
    [sym_string] = STATE(2105),
    [aux_sym_chained_string_repeat1] = STATE(2105),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2028] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [2029] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [2030] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4492),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4492),
    [sym_operator_assignment] = STATE(4492),
    [sym_conditional] = STATE(4492),
    [sym_range] = STATE(4492),
    [sym_binary] = STATE(4492),
    [sym_unary] = STATE(4492),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2031] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [2032] = {
    [anon_sym_RBRACE] = ACTIONS(7005),
    [sym_comment] = ACTIONS(87),
  },
  [2033] = {
    [sym__statements] = STATE(4494),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7005),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2034] = {
    [anon_sym_RBRACE] = ACTIONS(7007),
    [sym_comment] = ACTIONS(87),
  },
  [2035] = {
    [sym_heredoc_body] = STATE(4496),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(7007),
    [sym_comment] = ACTIONS(87),
  },
  [2036] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4497),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4497),
    [sym_operator_assignment] = STATE(4497),
    [sym_conditional] = STATE(4497),
    [sym_range] = STATE(4497),
    [sym_binary] = STATE(4497),
    [sym_unary] = STATE(4497),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2037] = {
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_EQ_GT] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1283),
    [anon_sym_STAR_EQ] = ACTIONS(1283),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1283),
    [anon_sym_AMP_EQ] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_COLON2] = ACTIONS(1285),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [sym_comment] = ACTIONS(87),
  },
  [2038] = {
    [anon_sym_DOT] = ACTIONS(7009),
    [anon_sym_COLON_COLON] = ACTIONS(7009),
    [sym_comment] = ACTIONS(87),
  },
  [2039] = {
    [sym_method_parameters] = STATE(4499),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(4499),
    [sym__terminator] = STATE(4499),
    [sym__line_break2] = ACTIONS(7011),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(7011),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [2040] = {
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_EQ_GT] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_RBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_PLUS_EQ] = ACTIONS(1301),
    [anon_sym_DASH_EQ] = ACTIONS(1301),
    [anon_sym_STAR_EQ] = ACTIONS(1301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1301),
    [anon_sym_SLASH_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1301),
    [anon_sym_AMP_EQ] = ACTIONS(1301),
    [anon_sym_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_GT_GT_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_EQ] = ACTIONS(1301),
    [anon_sym_CARET_EQ] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_COLON2] = ACTIONS(1303),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1303),
    [sym_comment] = ACTIONS(87),
  },
  [2041] = {
    [anon_sym_RPAREN] = ACTIONS(7013),
    [sym_comment] = ACTIONS(87),
  },
  [2042] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [2043] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4501),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(4501),
    [sym_operator_assignment] = STATE(4501),
    [sym_conditional] = STATE(4501),
    [sym_range] = STATE(4501),
    [sym_binary] = STATE(4501),
    [sym_unary] = STATE(4501),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2044] = {
    [sym_superclass] = STATE(4502),
    [sym_heredoc_body] = STATE(4503),
    [sym__terminator] = STATE(4503),
    [sym__line_break2] = ACTIONS(7015),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(7015),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2045] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(4502),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4503),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(4503),
    [sym__line_break2] = ACTIONS(7015),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(7015),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2046] = {
    [sym_heredoc_body] = STATE(4505),
    [sym__terminator] = STATE(4505),
    [sym__line_break2] = ACTIONS(7017),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(7017),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(7019),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2047] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4505),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(4505),
    [sym__line_break2] = ACTIONS(7017),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(7017),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(7019),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2048] = {
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_EQ_GT] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [2049] = {
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_EQ_GT] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_RBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_COLON2] = ACTIONS(1721),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [sym_comment] = ACTIONS(87),
  },
  [2050] = {
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1725),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_in] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_EQ_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_RBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_PLUS_EQ] = ACTIONS(1723),
    [anon_sym_DASH_EQ] = ACTIONS(1723),
    [anon_sym_STAR_EQ] = ACTIONS(1723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1723),
    [anon_sym_SLASH_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1723),
    [anon_sym_AMP_EQ] = ACTIONS(1723),
    [anon_sym_PERCENT_EQ] = ACTIONS(1723),
    [anon_sym_GT_GT_EQ] = ACTIONS(1723),
    [anon_sym_LT_LT_EQ] = ACTIONS(1723),
    [anon_sym_CARET_EQ] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_COLON2] = ACTIONS(1725),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1725),
    [anon_sym_AMP_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1725),
    [anon_sym_GT_GT] = ACTIONS(1725),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_SLASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1725),
    [sym_comment] = ACTIONS(87),
  },
  [2051] = {
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_EQ_GT] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1727),
    [anon_sym_DASH_EQ] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1727),
    [anon_sym_SLASH_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1727),
    [anon_sym_AMP_EQ] = ACTIONS(1727),
    [anon_sym_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_GT_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_EQ] = ACTIONS(1727),
    [anon_sym_CARET_EQ] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_COLON2] = ACTIONS(1729),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [sym_comment] = ACTIONS(87),
  },
  [2052] = {
    [sym__then] = STATE(4506),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(7021),
    [sym_comment] = ACTIONS(87),
  },
  [2053] = {
    [sym__then] = STATE(4507),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(7023),
    [sym_comment] = ACTIONS(87),
  },
  [2054] = {
    [sym__do] = STATE(4508),
    [sym_heredoc_body] = STATE(4508),
    [sym__terminator] = STATE(4508),
    [sym__line_break2] = ACTIONS(7025),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(7025),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(7025),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2055] = {
    [sym__do] = STATE(4509),
    [sym_heredoc_body] = STATE(4509),
    [sym__terminator] = STATE(4509),
    [sym__line_break2] = ACTIONS(7027),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(7027),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(7027),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2056] = {
    [sym_in] = STATE(4510),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [2057] = {
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [2058] = {
    [anon_sym_end] = ACTIONS(7029),
    [sym_comment] = ACTIONS(87),
  },
  [2059] = {
    [sym__statements] = STATE(4512),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4513),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4513),
    [sym__line_break2] = ACTIONS(7031),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7033),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2060] = {
    [sym__statements] = STATE(4512),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4514),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7033),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2061] = {
    [sym_heredoc_body] = STATE(4515),
    [sym__terminator] = STATE(4515),
    [sym__line_break2] = ACTIONS(7035),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(7035),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [2062] = {
    [sym_when] = STATE(4516),
    [aux_sym_case_repeat1] = STATE(4517),
    [anon_sym_SEMI] = ACTIONS(7037),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [2063] = {
    [sym_else] = STATE(4519),
    [sym_ensure] = STATE(4520),
    [sym_rescue] = STATE(4521),
    [anon_sym_end] = ACTIONS(7039),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [2064] = {
    [sym_ensure] = STATE(4520),
    [anon_sym_end] = ACTIONS(7039),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [2065] = {
    [anon_sym_end] = ACTIONS(7039),
    [sym_comment] = ACTIONS(87),
  },
  [2066] = {
    [sym_else] = STATE(4519),
    [sym_ensure] = STATE(4520),
    [anon_sym_end] = ACTIONS(7039),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [2067] = {
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_EQ_GT] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_RBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_PLUS_EQ] = ACTIONS(2219),
    [anon_sym_DASH_EQ] = ACTIONS(2219),
    [anon_sym_STAR_EQ] = ACTIONS(2219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2219),
    [anon_sym_SLASH_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2219),
    [anon_sym_AMP_EQ] = ACTIONS(2219),
    [anon_sym_PERCENT_EQ] = ACTIONS(2219),
    [anon_sym_GT_GT_EQ] = ACTIONS(2219),
    [anon_sym_LT_LT_EQ] = ACTIONS(2219),
    [anon_sym_CARET_EQ] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_COLON2] = ACTIONS(2221),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [sym_comment] = ACTIONS(87),
  },
  [2068] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(4522),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7041),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2069] = {
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [sym_comment] = ACTIONS(87),
  },
  [2070] = {
    [sym_heredoc_body] = STATE(4524),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(87),
  },
  [2071] = {
    [anon_sym_RPAREN] = ACTIONS(7043),
    [sym_comment] = ACTIONS(87),
  },
  [2072] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [2073] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [2074] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [2075] = {
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_EQ_GT] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_COLON2] = ACTIONS(2309),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2309),
    [anon_sym_GT_GT] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [sym_comment] = ACTIONS(87),
  },
  [2076] = {
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2393),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_in] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_EQ_GT] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_RBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_PLUS_EQ] = ACTIONS(2391),
    [anon_sym_DASH_EQ] = ACTIONS(2391),
    [anon_sym_STAR_EQ] = ACTIONS(2391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2391),
    [anon_sym_SLASH_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2391),
    [anon_sym_AMP_EQ] = ACTIONS(2391),
    [anon_sym_PERCENT_EQ] = ACTIONS(2391),
    [anon_sym_GT_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_EQ] = ACTIONS(2391),
    [anon_sym_CARET_EQ] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_COLON2] = ACTIONS(2393),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2393),
    [anon_sym_AMP_AMP] = ACTIONS(2393),
    [anon_sym_LT_LT] = ACTIONS(2393),
    [anon_sym_GT_GT] = ACTIONS(2393),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_PERCENT] = ACTIONS(2393),
    [sym_comment] = ACTIONS(87),
  },
  [2077] = {
    [sym_heredoc_body] = STATE(4526),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(7045),
    [sym_comment] = ACTIONS(87),
  },
  [2078] = {
    [anon_sym_RBRACK] = ACTIONS(7045),
    [sym_comment] = ACTIONS(87),
  },
  [2079] = {
    [sym__statements] = STATE(3615),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(3616),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2080] = {
    [sym_do_block] = STATE(4528),
    [sym_block] = STATE(4528),
    [anon_sym_LBRACE] = ACTIONS(3436),
    [anon_sym_do] = ACTIONS(5726),
    [sym_comment] = ACTIONS(87),
  },
  [2081] = {
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_in] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_EQ_GT] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_RBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_PLUS_EQ] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2537),
    [anon_sym_STAR_EQ] = ACTIONS(2537),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2537),
    [anon_sym_AMP_EQ] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_COLON2] = ACTIONS(2539),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2539),
    [anon_sym_AMP_AMP] = ACTIONS(2539),
    [anon_sym_LT_LT] = ACTIONS(2539),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [anon_sym_PERCENT] = ACTIONS(2539),
    [sym_comment] = ACTIONS(87),
  },
  [2082] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4529),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4529),
    [sym_operator_assignment] = STATE(4529),
    [sym_conditional] = STATE(4529),
    [sym_range] = STATE(4529),
    [sym_binary] = STATE(4529),
    [sym_unary] = STATE(4529),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2083] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4530),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4530),
    [sym_operator_assignment] = STATE(4530),
    [sym_conditional] = STATE(4530),
    [sym_range] = STATE(4530),
    [sym_binary] = STATE(4530),
    [sym_unary] = STATE(4530),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2084] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4531),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4531),
    [sym_operator_assignment] = STATE(4531),
    [sym_conditional] = STATE(4531),
    [sym_range] = STATE(4531),
    [sym_binary] = STATE(4531),
    [sym_unary] = STATE(4531),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2085] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4532),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4532),
    [sym_operator_assignment] = STATE(4532),
    [sym_conditional] = STATE(4532),
    [sym_range] = STATE(4532),
    [sym_binary] = STATE(4532),
    [sym_unary] = STATE(4532),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2086] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4533),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4533),
    [sym_operator_assignment] = STATE(4533),
    [sym_conditional] = STATE(4533),
    [sym_range] = STATE(4533),
    [sym_binary] = STATE(4533),
    [sym_unary] = STATE(4533),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2087] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4534),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4534),
    [sym_operator_assignment] = STATE(4534),
    [sym_conditional] = STATE(4534),
    [sym_range] = STATE(4534),
    [sym_binary] = STATE(4534),
    [sym_unary] = STATE(4534),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2088] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4535),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4535),
    [sym_operator_assignment] = STATE(4535),
    [sym_conditional] = STATE(4535),
    [sym_range] = STATE(4535),
    [sym_binary] = STATE(4535),
    [sym_unary] = STATE(4535),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2089] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4536),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4536),
    [sym_operator_assignment] = STATE(4536),
    [sym_conditional] = STATE(4536),
    [sym_range] = STATE(4536),
    [sym_binary] = STATE(4536),
    [sym_unary] = STATE(4536),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2090] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4537),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4537),
    [sym_operator_assignment] = STATE(4537),
    [sym_conditional] = STATE(4537),
    [sym_range] = STATE(4537),
    [sym_binary] = STATE(4537),
    [sym_unary] = STATE(4537),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2091] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4538),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4538),
    [sym_operator_assignment] = STATE(4538),
    [sym_conditional] = STATE(4538),
    [sym_range] = STATE(4538),
    [sym_binary] = STATE(4538),
    [sym_unary] = STATE(4538),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2092] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4539),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4539),
    [sym_operator_assignment] = STATE(4539),
    [sym_conditional] = STATE(4539),
    [sym_range] = STATE(4539),
    [sym_binary] = STATE(4539),
    [sym_unary] = STATE(4539),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2093] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4540),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4540),
    [sym_operator_assignment] = STATE(4540),
    [sym_conditional] = STATE(4540),
    [sym_range] = STATE(4540),
    [sym_binary] = STATE(4540),
    [sym_unary] = STATE(4540),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2094] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4541),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4541),
    [sym_operator_assignment] = STATE(4541),
    [sym_conditional] = STATE(4541),
    [sym_range] = STATE(4541),
    [sym_binary] = STATE(4541),
    [sym_unary] = STATE(4541),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2095] = {
    [sym__statements] = STATE(3615),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(3616),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7047),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2096] = {
    [sym_do_block] = STATE(3637),
    [sym_block] = STATE(3637),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_EQ_GT] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [2097] = {
    [sym__statements] = STATE(2032),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(2033),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7049),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2098] = {
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_EQ_GT] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [2099] = {
    [sym_interpolation] = STATE(4544),
    [aux_sym_heredoc_body_repeat1] = STATE(4544),
    [sym__heredoc_content2] = ACTIONS(7051),
    [sym_heredoc_end2] = ACTIONS(7053),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(7051),
  },
  [2100] = {
    [sym_heredoc_body] = STATE(4545),
    [aux_sym_call_repeat1] = STATE(4545),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2101] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(4547),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7055),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2102] = {
    [sym_heredoc_body] = STATE(4548),
    [aux_sym_call_repeat1] = STATE(4548),
    [aux_sym_argument_list_repeat1] = STATE(4549),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2103] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4550),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_splat_argument] = STATE(4552),
    [sym_assignment] = STATE(4550),
    [sym_operator_assignment] = STATE(4550),
    [sym_conditional] = STATE(4550),
    [sym_range] = STATE(4550),
    [sym_binary] = STATE(4550),
    [sym_unary] = STATE(4550),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(4552),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2104] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(4553),
    [sym_operator_assignment] = STATE(4553),
    [sym_conditional] = STATE(4553),
    [sym_range] = STATE(4553),
    [sym_binary] = STATE(4553),
    [sym_unary] = STATE(4553),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2105] = {
    [sym_string] = STATE(4554),
    [aux_sym_chained_string_repeat1] = STATE(4554),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [2106] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(4555),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(4555),
    [sym_operator_assignment] = STATE(4555),
    [sym_conditional] = STATE(4555),
    [sym_range] = STATE(4555),
    [sym_binary] = STATE(4555),
    [sym_unary] = STATE(4555),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2107] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(4556),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(4556),
    [sym_operator_assignment] = STATE(4556),
    [sym_conditional] = STATE(4556),
    [sym_range] = STATE(4556),
    [sym_binary] = STATE(4556),
    [sym_unary] = STATE(4556),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2108] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2109] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2110] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2111] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(1938),
    [sym__argument] = STATE(1939),
    [sym_splat_argument] = STATE(1939),
    [sym_hash_splat_argument] = STATE(1939),
    [sym_block_argument] = STATE(1939),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(1939),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2112] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(4557),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(4557),
    [sym_operator_assignment] = STATE(4557),
    [sym_conditional] = STATE(4557),
    [sym_range] = STATE(4557),
    [sym_binary] = STATE(4557),
    [sym_unary] = STATE(4557),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2113] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(4558),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(4558),
    [sym_operator_assignment] = STATE(4558),
    [sym_conditional] = STATE(4558),
    [sym_range] = STATE(4558),
    [sym_binary] = STATE(4558),
    [sym_unary] = STATE(4558),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2114] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2115] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [2116] = {
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2117] = {
    [aux_sym_exceptions_repeat1] = STATE(4572),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(7087),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2118] = {
    [anon_sym_EQ] = ACTIONS(7089),
    [sym_comment] = ACTIONS(87),
  },
  [2119] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7091),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7093),
    [anon_sym_DASH_EQ] = ACTIONS(7093),
    [anon_sym_STAR_EQ] = ACTIONS(7093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7093),
    [anon_sym_SLASH_EQ] = ACTIONS(7093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7093),
    [anon_sym_PIPE_EQ] = ACTIONS(7093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7093),
    [anon_sym_AMP_EQ] = ACTIONS(7093),
    [anon_sym_PERCENT_EQ] = ACTIONS(7093),
    [anon_sym_GT_GT_EQ] = ACTIONS(7093),
    [anon_sym_LT_LT_EQ] = ACTIONS(7093),
    [anon_sym_CARET_EQ] = ACTIONS(7093),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2120] = {
    [sym_string] = STATE(4575),
    [aux_sym_chained_string_repeat1] = STATE(4575),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2121] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [2122] = {
    [sym_string] = STATE(2122),
    [aux_sym_chained_string_repeat1] = STATE(2122),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2123] = {
    [sym__line_break2] = ACTIONS(7098),
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [ts_builtin_sym_end] = ACTIONS(7098),
    [anon_sym___END__] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7098),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_end] = ACTIONS(7098),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_when] = ACTIONS(7098),
    [anon_sym_elsif] = ACTIONS(7098),
    [anon_sym_else] = ACTIONS(7098),
    [anon_sym_then] = ACTIONS(7098),
    [anon_sym_ensure] = ACTIONS(7098),
    [anon_sym_EQ_GT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7098),
    [anon_sym_AMP_AMP] = ACTIONS(7098),
    [anon_sym_LT_LT] = ACTIONS(7098),
    [anon_sym_GT_GT] = ACTIONS(7098),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7098),
    [anon_sym_PLUS] = ACTIONS(7098),
    [anon_sym_SLASH] = ACTIONS(7098),
    [anon_sym_PERCENT] = ACTIONS(7098),
    [sym_comment] = ACTIONS(87),
  },
  [2124] = {
    [sym_interpolation] = STATE(4577),
    [aux_sym_heredoc_body_repeat1] = STATE(4577),
    [sym__heredoc_content2] = ACTIONS(7102),
    [sym_heredoc_end2] = ACTIONS(7104),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(7102),
  },
  [2125] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(4578),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(7106),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2126] = {
    [sym__heredoc_body_start2] = ACTIONS(7106),
    [anon_sym_RBRACE] = ACTIONS(7106),
    [sym_comment] = ACTIONS(87),
  },
  [2127] = {
    [sym__line_break2] = ACTIONS(7108),
    [sym__heredoc_body_start2] = ACTIONS(7108),
    [ts_builtin_sym_end] = ACTIONS(7108),
    [anon_sym___END__] = ACTIONS(7108),
    [anon_sym_RBRACE] = ACTIONS(7108),
    [anon_sym_RPAREN] = ACTIONS(7108),
    [anon_sym_SEMI] = ACTIONS(7108),
    [anon_sym_end] = ACTIONS(7108),
    [anon_sym_rescue] = ACTIONS(7108),
    [anon_sym_when] = ACTIONS(7108),
    [anon_sym_elsif] = ACTIONS(7108),
    [anon_sym_else] = ACTIONS(7108),
    [anon_sym_ensure] = ACTIONS(7108),
    [sym_comment] = ACTIONS(87),
  },
  [2128] = {
    [sym__line_break2] = ACTIONS(2959),
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [anon_sym___END__] = ACTIONS(2961),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_end] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2961),
    [anon_sym_unless] = ACTIONS(2961),
    [anon_sym_while] = ACTIONS(2961),
    [anon_sym_until] = ACTIONS(2961),
    [anon_sym_rescue] = ACTIONS(2961),
    [anon_sym_when] = ACTIONS(2961),
    [anon_sym_elsif] = ACTIONS(2961),
    [anon_sym_else] = ACTIONS(2961),
    [anon_sym_then] = ACTIONS(2961),
    [anon_sym_ensure] = ACTIONS(2961),
    [sym_identifier] = ACTIONS(2961),
    [sym_comment] = ACTIONS(87),
  },
  [2129] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2130] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4583),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(4583),
    [sym_operator_assignment] = STATE(4583),
    [sym_conditional] = STATE(4583),
    [sym_range] = STATE(4583),
    [sym_binary] = STATE(4583),
    [sym_unary] = STATE(4583),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2131] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4586),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(4586),
    [sym_operator_assignment] = STATE(4586),
    [sym_conditional] = STATE(4586),
    [sym_range] = STATE(4586),
    [sym_binary] = STATE(4586),
    [sym_unary] = STATE(4586),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2132] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4587),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(4587),
    [sym_operator_assignment] = STATE(4587),
    [sym_conditional] = STATE(4587),
    [sym_range] = STATE(4587),
    [sym_binary] = STATE(4587),
    [sym_unary] = STATE(4587),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2133] = {
    [anon_sym_COLON] = ACTIONS(7122),
    [sym_comment] = ACTIONS(87),
  },
  [2134] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4589),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(4589),
    [sym_operator_assignment] = STATE(4589),
    [sym_conditional] = STATE(4589),
    [sym_range] = STATE(4589),
    [sym_binary] = STATE(4589),
    [sym_unary] = STATE(4589),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2135] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4590),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(4590),
    [sym_operator_assignment] = STATE(4590),
    [sym_conditional] = STATE(4590),
    [sym_range] = STATE(4590),
    [sym_binary] = STATE(4590),
    [sym_unary] = STATE(4590),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2136] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4591),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(4591),
    [sym_operator_assignment] = STATE(4591),
    [sym_conditional] = STATE(4591),
    [sym_range] = STATE(4591),
    [sym_binary] = STATE(4591),
    [sym_unary] = STATE(4591),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2137] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2138] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7124),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2139] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(7138),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [2140] = {
    [sym_heredoc_body] = STATE(4605),
    [aux_sym_call_repeat1] = STATE(4605),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2141] = {
    [sym_heredoc_body] = STATE(4605),
    [aux_sym_call_repeat1] = STATE(4605),
    [aux_sym_argument_list_repeat1] = STATE(4607),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7158),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2142] = {
    [anon_sym_EQ] = ACTIONS(7160),
    [sym_comment] = ACTIONS(87),
  },
  [2143] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7162),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7164),
    [anon_sym_DASH_EQ] = ACTIONS(7164),
    [anon_sym_STAR_EQ] = ACTIONS(7164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7164),
    [anon_sym_SLASH_EQ] = ACTIONS(7164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7164),
    [anon_sym_PIPE_EQ] = ACTIONS(7164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7164),
    [anon_sym_AMP_EQ] = ACTIONS(7164),
    [anon_sym_PERCENT_EQ] = ACTIONS(7164),
    [anon_sym_GT_GT_EQ] = ACTIONS(7164),
    [anon_sym_LT_LT_EQ] = ACTIONS(7164),
    [anon_sym_CARET_EQ] = ACTIONS(7164),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2144] = {
    [sym_string] = STATE(2635),
    [aux_sym_chained_string_repeat1] = STATE(2635),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7166),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2145] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2146] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [2147] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4610),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4610),
    [sym_operator_assignment] = STATE(4610),
    [sym_conditional] = STATE(4610),
    [sym_range] = STATE(4610),
    [sym_binary] = STATE(4610),
    [sym_unary] = STATE(4610),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2148] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4611),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4611),
    [sym_operator_assignment] = STATE(4611),
    [sym_conditional] = STATE(4611),
    [sym_range] = STATE(4611),
    [sym_binary] = STATE(4611),
    [sym_unary] = STATE(4611),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2149] = {
    [anon_sym_DOT] = ACTIONS(7168),
    [anon_sym_COLON_COLON] = ACTIONS(7168),
    [sym_comment] = ACTIONS(87),
  },
  [2150] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4613),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4613),
    [sym_operator_assignment] = STATE(4613),
    [sym_conditional] = STATE(4613),
    [sym_range] = STATE(4613),
    [sym_binary] = STATE(4613),
    [sym_unary] = STATE(4613),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2151] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4614),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4614),
    [sym_operator_assignment] = STATE(4614),
    [sym_conditional] = STATE(4614),
    [sym_range] = STATE(4614),
    [sym_binary] = STATE(4614),
    [sym_unary] = STATE(4614),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2152] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4615),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4615),
    [sym_operator_assignment] = STATE(4615),
    [sym_conditional] = STATE(4615),
    [sym_range] = STATE(4615),
    [sym_binary] = STATE(4615),
    [sym_unary] = STATE(4615),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2153] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4616),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4616),
    [sym_operator_assignment] = STATE(4616),
    [sym_conditional] = STATE(4616),
    [sym_range] = STATE(4616),
    [sym_binary] = STATE(4616),
    [sym_unary] = STATE(4616),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2154] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4617),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4617),
    [sym_operator_assignment] = STATE(4617),
    [sym_conditional] = STATE(4617),
    [sym_range] = STATE(4617),
    [sym_binary] = STATE(4617),
    [sym_unary] = STATE(4617),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2155] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4618),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4618),
    [sym_operator_assignment] = STATE(4618),
    [sym_conditional] = STATE(4618),
    [sym_range] = STATE(4618),
    [sym_binary] = STATE(4618),
    [sym_unary] = STATE(4618),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2156] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4619),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4619),
    [sym_operator_assignment] = STATE(4619),
    [sym_conditional] = STATE(4619),
    [sym_range] = STATE(4619),
    [sym_binary] = STATE(4619),
    [sym_unary] = STATE(4619),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2157] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4620),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4620),
    [sym_operator_assignment] = STATE(4620),
    [sym_conditional] = STATE(4620),
    [sym_range] = STATE(4620),
    [sym_binary] = STATE(4620),
    [sym_unary] = STATE(4620),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2158] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4621),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4621),
    [sym_operator_assignment] = STATE(4621),
    [sym_conditional] = STATE(4621),
    [sym_range] = STATE(4621),
    [sym_binary] = STATE(4621),
    [sym_unary] = STATE(4621),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2159] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4622),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4622),
    [sym_operator_assignment] = STATE(4622),
    [sym_conditional] = STATE(4622),
    [sym_range] = STATE(4622),
    [sym_binary] = STATE(4622),
    [sym_unary] = STATE(4622),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2160] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4631),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(4631),
    [sym_operator_assignment] = STATE(4631),
    [sym_conditional] = STATE(4631),
    [sym_range] = STATE(4631),
    [sym_binary] = STATE(4631),
    [sym_unary] = STATE(4631),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [2161] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4636),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(4636),
    [sym_operator_assignment] = STATE(4636),
    [sym_conditional] = STATE(4636),
    [sym_range] = STATE(4636),
    [sym_binary] = STATE(4636),
    [sym_unary] = STATE(4636),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [2162] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4637),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(4637),
    [sym_operator_assignment] = STATE(4637),
    [sym_conditional] = STATE(4637),
    [sym_range] = STATE(4637),
    [sym_binary] = STATE(4637),
    [sym_unary] = STATE(4637),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2163] = {
    [anon_sym_COLON] = ACTIONS(7194),
    [sym_comment] = ACTIONS(87),
  },
  [2164] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(4640),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(4640),
    [sym_operator_assignment] = STATE(4640),
    [sym_conditional] = STATE(4640),
    [sym_range] = STATE(4640),
    [sym_binary] = STATE(4640),
    [sym_unary] = STATE(4640),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [2165] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2166] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2167] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2168] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2169] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4641),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(4641),
    [sym_operator_assignment] = STATE(4641),
    [sym_conditional] = STATE(4641),
    [sym_range] = STATE(4641),
    [sym_binary] = STATE(4641),
    [sym_unary] = STATE(4641),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2170] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4642),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(4642),
    [sym_operator_assignment] = STATE(4642),
    [sym_conditional] = STATE(4642),
    [sym_range] = STATE(4642),
    [sym_binary] = STATE(4642),
    [sym_unary] = STATE(4642),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2171] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2172] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7196),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2173] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(7210),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [2174] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(2627),
    [sym__argument] = STATE(2628),
    [sym_splat_argument] = STATE(2628),
    [sym_hash_splat_argument] = STATE(2628),
    [sym_block_argument] = STATE(2628),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2628),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2175] = {
    [sym_heredoc_body] = STATE(4656),
    [aux_sym_call_repeat1] = STATE(4656),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2176] = {
    [sym_heredoc_body] = STATE(4656),
    [aux_sym_call_repeat1] = STATE(4656),
    [aux_sym_argument_list_repeat1] = STATE(4658),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7228),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2177] = {
    [anon_sym_EQ] = ACTIONS(7230),
    [sym_comment] = ACTIONS(87),
  },
  [2178] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7232),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7234),
    [anon_sym_DASH_EQ] = ACTIONS(7234),
    [anon_sym_STAR_EQ] = ACTIONS(7234),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7234),
    [anon_sym_SLASH_EQ] = ACTIONS(7234),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7234),
    [anon_sym_PIPE_EQ] = ACTIONS(7234),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7234),
    [anon_sym_AMP_EQ] = ACTIONS(7234),
    [anon_sym_PERCENT_EQ] = ACTIONS(7234),
    [anon_sym_GT_GT_EQ] = ACTIONS(7234),
    [anon_sym_LT_LT_EQ] = ACTIONS(7234),
    [anon_sym_CARET_EQ] = ACTIONS(7234),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2179] = {
    [sym_string] = STATE(4661),
    [aux_sym_chained_string_repeat1] = STATE(4661),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7236),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2180] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4671),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_splat_argument] = STATE(4672),
    [sym_assignment] = STATE(4671),
    [sym_operator_assignment] = STATE(4671),
    [sym_conditional] = STATE(4671),
    [sym_range] = STATE(4671),
    [sym_binary] = STATE(4671),
    [sym_unary] = STATE(4671),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(4672),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(7238),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2181] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4676),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(4676),
    [sym_operator_assignment] = STATE(4676),
    [sym_conditional] = STATE(4676),
    [sym_range] = STATE(4676),
    [sym_binary] = STATE(4676),
    [sym_unary] = STATE(4676),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2182] = {
    [sym_string] = STATE(4677),
    [aux_sym_chained_string_repeat1] = STATE(4677),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2183] = {
    [sym__line_break2] = ACTIONS(7258),
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [ts_builtin_sym_end] = ACTIONS(7258),
    [anon_sym___END__] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7258),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_end] = ACTIONS(7258),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_when] = ACTIONS(7258),
    [anon_sym_elsif] = ACTIONS(7258),
    [anon_sym_else] = ACTIONS(7258),
    [anon_sym_then] = ACTIONS(7258),
    [anon_sym_ensure] = ACTIONS(7258),
    [anon_sym_EQ_GT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7258),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [anon_sym_LT_LT] = ACTIONS(7258),
    [anon_sym_GT_GT] = ACTIONS(7258),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7258),
    [anon_sym_PLUS] = ACTIONS(7258),
    [anon_sym_SLASH] = ACTIONS(7258),
    [anon_sym_PERCENT] = ACTIONS(7258),
    [sym_comment] = ACTIONS(87),
  },
  [2184] = {
    [sym_heredoc_body] = STATE(4678),
    [sym__terminator] = STATE(4678),
    [sym__line_break2] = ACTIONS(7262),
    [sym__simple_symbol2] = ACTIONS(7264),
    [sym__string_start2] = ACTIONS(7264),
    [sym__symbol_start2] = ACTIONS(7264),
    [sym__subshell_start2] = ACTIONS(7264),
    [sym__regex_start2] = ACTIONS(7264),
    [sym__string_array_start2] = ACTIONS(7264),
    [sym__symbol_array_start2] = ACTIONS(7264),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(7264),
    [sym__unary_minus2] = ACTIONS(7264),
    [anon_sym_BEGIN] = ACTIONS(7266),
    [anon_sym_LBRACE] = ACTIONS(7264),
    [anon_sym_END] = ACTIONS(7266),
    [anon_sym_def] = ACTIONS(7266),
    [anon_sym_LPAREN] = ACTIONS(7264),
    [anon_sym_COLON_COLON] = ACTIONS(7264),
    [anon_sym_SEMI] = ACTIONS(7262),
    [anon_sym_STAR] = ACTIONS(7264),
    [anon_sym_class] = ACTIONS(7266),
    [anon_sym_module] = ACTIONS(7266),
    [anon_sym_end] = ACTIONS(7266),
    [anon_sym_return] = ACTIONS(7266),
    [anon_sym_yield] = ACTIONS(7266),
    [anon_sym_break] = ACTIONS(7266),
    [anon_sym_next] = ACTIONS(7266),
    [sym_redo] = ACTIONS(7266),
    [sym_retry] = ACTIONS(7266),
    [anon_sym_if] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(7266),
    [anon_sym_while] = ACTIONS(7266),
    [anon_sym_until] = ACTIONS(7266),
    [anon_sym_rescue] = ACTIONS(7266),
    [anon_sym_for] = ACTIONS(7266),
    [anon_sym_case] = ACTIONS(7266),
    [anon_sym_else] = ACTIONS(7266),
    [anon_sym_begin] = ACTIONS(7266),
    [anon_sym_ensure] = ACTIONS(7266),
    [anon_sym_PLUS] = ACTIONS(7266),
    [anon_sym_defined_QMARK] = ACTIONS(7264),
    [anon_sym_not] = ACTIONS(7266),
    [anon_sym_BANG] = ACTIONS(7264),
    [anon_sym_TILDE] = ACTIONS(7264),
    [sym_constant] = ACTIONS(7266),
    [sym_identifier] = ACTIONS(7266),
    [sym_instance_variable] = ACTIONS(7264),
    [sym_class_variable] = ACTIONS(7264),
    [sym_global_variable] = ACTIONS(7264),
    [anon_sym_undef] = ACTIONS(7266),
    [anon_sym_alias] = ACTIONS(7266),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7266),
    [sym_float] = ACTIONS(7266),
    [sym_complex] = ACTIONS(7264),
    [sym_super] = ACTIONS(7266),
    [anon_sym_true] = ACTIONS(7266),
    [anon_sym_TRUE] = ACTIONS(7266),
    [anon_sym_false] = ACTIONS(7266),
    [anon_sym_FALSE] = ACTIONS(7266),
    [sym_self] = ACTIONS(7266),
    [anon_sym_nil] = ACTIONS(7266),
    [anon_sym_NIL] = ACTIONS(7266),
    [sym_character] = ACTIONS(7264),
    [anon_sym_LBRACK2] = ACTIONS(7264),
    [anon_sym_DASH_GT] = ACTIONS(7264),
  },
  [2185] = {
    [aux_sym_method_parameters_repeat1] = STATE(4680),
    [anon_sym_RPAREN] = ACTIONS(7268),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [2186] = {
    [sym__line_break2] = ACTIONS(5774),
    [sym__heredoc_body_start2] = ACTIONS(5774),
    [anon_sym_COMMA] = ACTIONS(5774),
    [anon_sym_SEMI] = ACTIONS(5774),
    [sym_comment] = ACTIONS(87),
  },
  [2187] = {
    [sym__line_break2] = ACTIONS(5776),
    [sym__heredoc_body_start2] = ACTIONS(5776),
    [anon_sym_COMMA] = ACTIONS(5776),
    [anon_sym_SEMI] = ACTIONS(5776),
    [sym_comment] = ACTIONS(87),
  },
  [2188] = {
    [sym__line_break2] = ACTIONS(5778),
    [sym__heredoc_body_start2] = ACTIONS(5778),
    [anon_sym_COMMA] = ACTIONS(5778),
    [anon_sym_SEMI] = ACTIONS(5778),
    [sym_comment] = ACTIONS(87),
  },
  [2189] = {
    [sym_lambda_parameters] = STATE(4683),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(4684),
    [sym_block] = STATE(4684),
    [anon_sym_LBRACE] = ACTIONS(7270),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7272),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2190] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4685),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(4685),
    [sym_operator_assignment] = STATE(4685),
    [sym_conditional] = STATE(4685),
    [sym_range] = STATE(4685),
    [sym_binary] = STATE(4685),
    [sym_unary] = STATE(4685),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__line_break2] = ACTIONS(5798),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(5798),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2191] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4686),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(4686),
    [sym_operator_assignment] = STATE(4686),
    [sym_conditional] = STATE(4686),
    [sym_range] = STATE(4686),
    [sym_binary] = STATE(4686),
    [sym_unary] = STATE(4686),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2192] = {
    [sym__line_break2] = ACTIONS(7274),
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [ts_builtin_sym_end] = ACTIONS(7274),
    [anon_sym___END__] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7274),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_end] = ACTIONS(7274),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_when] = ACTIONS(7274),
    [anon_sym_elsif] = ACTIONS(7274),
    [anon_sym_else] = ACTIONS(7274),
    [anon_sym_then] = ACTIONS(7274),
    [anon_sym_ensure] = ACTIONS(7274),
    [anon_sym_EQ_GT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7274),
    [anon_sym_GT_GT] = ACTIONS(7274),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7274),
    [anon_sym_PLUS] = ACTIONS(7274),
    [anon_sym_SLASH] = ACTIONS(7274),
    [anon_sym_PERCENT] = ACTIONS(7274),
    [sym_comment] = ACTIONS(87),
  },
  [2193] = {
    [sym__formal_parameter] = STATE(4688),
    [sym__simple_formal_parameter] = STATE(4688),
    [sym_destructured_parameter] = STATE(4688),
    [sym_splat_parameter] = STATE(4688),
    [sym_hash_splat_parameter] = STATE(4688),
    [sym_block_parameter] = STATE(4688),
    [sym_keyword_parameter] = STATE(4688),
    [sym_optional_parameter] = STATE(4688),
    [anon_sym_LPAREN] = ACTIONS(7278),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [2194] = {
    [sym__simple_symbol2] = ACTIONS(7264),
    [sym__string_start2] = ACTIONS(7264),
    [sym__symbol_start2] = ACTIONS(7264),
    [sym__subshell_start2] = ACTIONS(7264),
    [sym__regex_start2] = ACTIONS(7264),
    [sym__string_array_start2] = ACTIONS(7264),
    [sym__symbol_array_start2] = ACTIONS(7264),
    [sym_heredoc_beginning2] = ACTIONS(7264),
    [sym__unary_minus2] = ACTIONS(7264),
    [anon_sym_BEGIN] = ACTIONS(7266),
    [anon_sym_LBRACE] = ACTIONS(7264),
    [anon_sym_END] = ACTIONS(7266),
    [anon_sym_def] = ACTIONS(7266),
    [anon_sym_LPAREN] = ACTIONS(7264),
    [anon_sym_COLON_COLON] = ACTIONS(7264),
    [anon_sym_SEMI] = ACTIONS(7264),
    [anon_sym_STAR] = ACTIONS(7264),
    [anon_sym_class] = ACTIONS(7266),
    [anon_sym_module] = ACTIONS(7266),
    [anon_sym_end] = ACTIONS(7266),
    [anon_sym_return] = ACTIONS(7266),
    [anon_sym_yield] = ACTIONS(7266),
    [anon_sym_break] = ACTIONS(7266),
    [anon_sym_next] = ACTIONS(7266),
    [sym_redo] = ACTIONS(7266),
    [sym_retry] = ACTIONS(7266),
    [anon_sym_if] = ACTIONS(7266),
    [anon_sym_unless] = ACTIONS(7266),
    [anon_sym_while] = ACTIONS(7266),
    [anon_sym_until] = ACTIONS(7266),
    [anon_sym_rescue] = ACTIONS(7266),
    [anon_sym_for] = ACTIONS(7266),
    [anon_sym_case] = ACTIONS(7266),
    [anon_sym_else] = ACTIONS(7266),
    [anon_sym_begin] = ACTIONS(7266),
    [anon_sym_ensure] = ACTIONS(7266),
    [anon_sym_PLUS] = ACTIONS(7266),
    [anon_sym_defined_QMARK] = ACTIONS(7264),
    [anon_sym_not] = ACTIONS(7266),
    [anon_sym_BANG] = ACTIONS(7264),
    [anon_sym_TILDE] = ACTIONS(7264),
    [sym_constant] = ACTIONS(7266),
    [sym_identifier] = ACTIONS(7266),
    [sym_instance_variable] = ACTIONS(7264),
    [sym_class_variable] = ACTIONS(7264),
    [sym_global_variable] = ACTIONS(7264),
    [anon_sym_undef] = ACTIONS(7266),
    [anon_sym_alias] = ACTIONS(7266),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7266),
    [sym_float] = ACTIONS(7266),
    [sym_complex] = ACTIONS(7264),
    [sym_super] = ACTIONS(7266),
    [anon_sym_true] = ACTIONS(7266),
    [anon_sym_TRUE] = ACTIONS(7266),
    [anon_sym_false] = ACTIONS(7266),
    [anon_sym_FALSE] = ACTIONS(7266),
    [sym_self] = ACTIONS(7266),
    [anon_sym_nil] = ACTIONS(7266),
    [anon_sym_NIL] = ACTIONS(7266),
    [sym_character] = ACTIONS(7264),
    [anon_sym_LBRACK2] = ACTIONS(7264),
    [anon_sym_DASH_GT] = ACTIONS(7264),
  },
  [2195] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4697),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(4697),
    [sym_operator_assignment] = STATE(4697),
    [sym_conditional] = STATE(4697),
    [sym_range] = STATE(4697),
    [sym_binary] = STATE(4697),
    [sym_unary] = STATE(4697),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2196] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4701),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(4701),
    [sym_operator_assignment] = STATE(4701),
    [sym_conditional] = STATE(4701),
    [sym_range] = STATE(4701),
    [sym_binary] = STATE(4701),
    [sym_unary] = STATE(4701),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2197] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4702),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(4702),
    [sym_operator_assignment] = STATE(4702),
    [sym_conditional] = STATE(4702),
    [sym_range] = STATE(4702),
    [sym_binary] = STATE(4702),
    [sym_unary] = STATE(4702),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2198] = {
    [anon_sym_COLON] = ACTIONS(7298),
    [sym_comment] = ACTIONS(87),
  },
  [2199] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4705),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(4705),
    [sym_operator_assignment] = STATE(4705),
    [sym_conditional] = STATE(4705),
    [sym_range] = STATE(4705),
    [sym_binary] = STATE(4705),
    [sym_unary] = STATE(4705),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2200] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(4712),
    [sym__argument] = STATE(4713),
    [sym_splat_argument] = STATE(4713),
    [sym_hash_splat_argument] = STATE(4713),
    [sym_block_argument] = STATE(4713),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4713),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2201] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(4712),
    [sym__argument] = STATE(4713),
    [sym_splat_argument] = STATE(4713),
    [sym_hash_splat_argument] = STATE(4713),
    [sym_block_argument] = STATE(4713),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4713),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2202] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(4712),
    [sym__argument] = STATE(4713),
    [sym_splat_argument] = STATE(4713),
    [sym_hash_splat_argument] = STATE(4713),
    [sym_block_argument] = STATE(4713),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4713),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2203] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(4712),
    [sym__argument] = STATE(4713),
    [sym_splat_argument] = STATE(4713),
    [sym_hash_splat_argument] = STATE(4713),
    [sym_block_argument] = STATE(4713),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4713),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2204] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4715),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(4715),
    [sym_operator_assignment] = STATE(4715),
    [sym_conditional] = STATE(4715),
    [sym_range] = STATE(4715),
    [sym_binary] = STATE(4715),
    [sym_unary] = STATE(4715),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2205] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4716),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(4716),
    [sym_operator_assignment] = STATE(4716),
    [sym_conditional] = STATE(4716),
    [sym_range] = STATE(4716),
    [sym_binary] = STATE(4716),
    [sym_unary] = STATE(4716),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2206] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2207] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7310),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2208] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(7324),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(7332),
    [anon_sym_or] = ACTIONS(7332),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [2209] = {
    [sym_heredoc_body] = STATE(4730),
    [aux_sym_call_repeat1] = STATE(4730),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2210] = {
    [sym_heredoc_body] = STATE(4730),
    [aux_sym_call_repeat1] = STATE(4730),
    [aux_sym_argument_list_repeat1] = STATE(4732),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(7346),
    [anon_sym_EQ] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2211] = {
    [anon_sym_EQ] = ACTIONS(7348),
    [sym_comment] = ACTIONS(87),
  },
  [2212] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7350),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7352),
    [anon_sym_DASH_EQ] = ACTIONS(7352),
    [anon_sym_STAR_EQ] = ACTIONS(7352),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7352),
    [anon_sym_SLASH_EQ] = ACTIONS(7352),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7352),
    [anon_sym_PIPE_EQ] = ACTIONS(7352),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7352),
    [anon_sym_AMP_EQ] = ACTIONS(7352),
    [anon_sym_PERCENT_EQ] = ACTIONS(7352),
    [anon_sym_GT_GT_EQ] = ACTIONS(7352),
    [anon_sym_LT_LT_EQ] = ACTIONS(7352),
    [anon_sym_CARET_EQ] = ACTIONS(7352),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2213] = {
    [sym_string] = STATE(4735),
    [aux_sym_chained_string_repeat1] = STATE(4735),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7354),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2214] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4736),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(4736),
    [sym_operator_assignment] = STATE(4736),
    [sym_conditional] = STATE(4736),
    [sym_range] = STATE(4736),
    [sym_binary] = STATE(4736),
    [sym_unary] = STATE(4736),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2215] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(4737),
    [sym__argument] = STATE(4738),
    [sym_splat_argument] = STATE(4738),
    [sym_hash_splat_argument] = STATE(4738),
    [sym_block_argument] = STATE(4738),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4738),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2216] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(4737),
    [sym__argument] = STATE(4738),
    [sym_splat_argument] = STATE(4738),
    [sym_hash_splat_argument] = STATE(4738),
    [sym_block_argument] = STATE(4738),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4738),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2217] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(4737),
    [sym__argument] = STATE(4738),
    [sym_splat_argument] = STATE(4738),
    [sym_hash_splat_argument] = STATE(4738),
    [sym_block_argument] = STATE(4738),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4738),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2218] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(4737),
    [sym__argument] = STATE(4738),
    [sym_splat_argument] = STATE(4738),
    [sym_hash_splat_argument] = STATE(4738),
    [sym_block_argument] = STATE(4738),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(4738),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1329),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2219] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4739),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(4739),
    [sym_operator_assignment] = STATE(4739),
    [sym_conditional] = STATE(4739),
    [sym_range] = STATE(4739),
    [sym_binary] = STATE(4739),
    [sym_unary] = STATE(4739),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2220] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4740),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(4740),
    [sym_operator_assignment] = STATE(4740),
    [sym_conditional] = STATE(4740),
    [sym_range] = STATE(4740),
    [sym_binary] = STATE(4740),
    [sym_unary] = STATE(4740),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2221] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2222] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [2223] = {
    [anon_sym_EQ] = ACTIONS(7386),
    [sym_comment] = ACTIONS(87),
  },
  [2224] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7388),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7390),
    [anon_sym_DASH_EQ] = ACTIONS(7390),
    [anon_sym_STAR_EQ] = ACTIONS(7390),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7390),
    [anon_sym_SLASH_EQ] = ACTIONS(7390),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7390),
    [anon_sym_PIPE_EQ] = ACTIONS(7390),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7390),
    [anon_sym_AMP_EQ] = ACTIONS(7390),
    [anon_sym_PERCENT_EQ] = ACTIONS(7390),
    [anon_sym_GT_GT_EQ] = ACTIONS(7390),
    [anon_sym_LT_LT_EQ] = ACTIONS(7390),
    [anon_sym_CARET_EQ] = ACTIONS(7390),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2225] = {
    [sym_string] = STATE(4755),
    [aux_sym_chained_string_repeat1] = STATE(4755),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2226] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [2227] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2228] = {
    [sym_string] = STATE(2269),
    [aux_sym_chained_string_repeat1] = STATE(2269),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2229] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4756),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(4756),
    [sym_operator_assignment] = STATE(4756),
    [sym_conditional] = STATE(4756),
    [sym_range] = STATE(4756),
    [sym_binary] = STATE(4756),
    [sym_unary] = STATE(4756),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2230] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [2231] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4757),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4757),
    [sym_operator_assignment] = STATE(4757),
    [sym_conditional] = STATE(4757),
    [sym_range] = STATE(4757),
    [sym_binary] = STATE(4757),
    [sym_unary] = STATE(4757),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2232] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4758),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4758),
    [sym_operator_assignment] = STATE(4758),
    [sym_conditional] = STATE(4758),
    [sym_range] = STATE(4758),
    [sym_binary] = STATE(4758),
    [sym_unary] = STATE(4758),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2233] = {
    [anon_sym_COLON] = ACTIONS(7392),
    [sym_comment] = ACTIONS(87),
  },
  [2234] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4760),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4760),
    [sym_operator_assignment] = STATE(4760),
    [sym_conditional] = STATE(4760),
    [sym_range] = STATE(4760),
    [sym_binary] = STATE(4760),
    [sym_unary] = STATE(4760),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2235] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7394),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2236] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [2237] = {
    [sym_heredoc_body] = STATE(4762),
    [aux_sym_call_repeat1] = STATE(4762),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2238] = {
    [sym_heredoc_body] = STATE(4762),
    [aux_sym_call_repeat1] = STATE(4762),
    [aux_sym_argument_list_repeat1] = STATE(4764),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2239] = {
    [sym_string] = STATE(2269),
    [aux_sym_chained_string_repeat1] = STATE(2269),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7398),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2240] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2241] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [2242] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4765),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4765),
    [sym_operator_assignment] = STATE(4765),
    [sym_conditional] = STATE(4765),
    [sym_range] = STATE(4765),
    [sym_binary] = STATE(4765),
    [sym_unary] = STATE(4765),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2243] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4766),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4766),
    [sym_operator_assignment] = STATE(4766),
    [sym_conditional] = STATE(4766),
    [sym_range] = STATE(4766),
    [sym_binary] = STATE(4766),
    [sym_unary] = STATE(4766),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2244] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4767),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4767),
    [sym_operator_assignment] = STATE(4767),
    [sym_conditional] = STATE(4767),
    [sym_range] = STATE(4767),
    [sym_binary] = STATE(4767),
    [sym_unary] = STATE(4767),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2245] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4768),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4768),
    [sym_operator_assignment] = STATE(4768),
    [sym_conditional] = STATE(4768),
    [sym_range] = STATE(4768),
    [sym_binary] = STATE(4768),
    [sym_unary] = STATE(4768),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2246] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4769),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4769),
    [sym_operator_assignment] = STATE(4769),
    [sym_conditional] = STATE(4769),
    [sym_range] = STATE(4769),
    [sym_binary] = STATE(4769),
    [sym_unary] = STATE(4769),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2247] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4770),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4770),
    [sym_operator_assignment] = STATE(4770),
    [sym_conditional] = STATE(4770),
    [sym_range] = STATE(4770),
    [sym_binary] = STATE(4770),
    [sym_unary] = STATE(4770),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2248] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(4771),
    [sym_operator_assignment] = STATE(4771),
    [sym_conditional] = STATE(4771),
    [sym_range] = STATE(4771),
    [sym_binary] = STATE(4771),
    [sym_unary] = STATE(4771),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2249] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4772),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4772),
    [sym_operator_assignment] = STATE(4772),
    [sym_conditional] = STATE(4772),
    [sym_range] = STATE(4772),
    [sym_binary] = STATE(4772),
    [sym_unary] = STATE(4772),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2250] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4773),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4773),
    [sym_operator_assignment] = STATE(4773),
    [sym_conditional] = STATE(4773),
    [sym_range] = STATE(4773),
    [sym_binary] = STATE(4773),
    [sym_unary] = STATE(4773),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2251] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4774),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4774),
    [sym_operator_assignment] = STATE(4774),
    [sym_conditional] = STATE(4774),
    [sym_range] = STATE(4774),
    [sym_binary] = STATE(4774),
    [sym_unary] = STATE(4774),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2252] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4775),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4775),
    [sym_operator_assignment] = STATE(4775),
    [sym_conditional] = STATE(4775),
    [sym_range] = STATE(4775),
    [sym_binary] = STATE(4775),
    [sym_unary] = STATE(4775),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2253] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4776),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4776),
    [sym_operator_assignment] = STATE(4776),
    [sym_conditional] = STATE(4776),
    [sym_range] = STATE(4776),
    [sym_binary] = STATE(4776),
    [sym_unary] = STATE(4776),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2254] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4777),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4777),
    [sym_operator_assignment] = STATE(4777),
    [sym_conditional] = STATE(4777),
    [sym_range] = STATE(4777),
    [sym_binary] = STATE(4777),
    [sym_unary] = STATE(4777),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2255] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4778),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4778),
    [sym_operator_assignment] = STATE(4778),
    [sym_conditional] = STATE(4778),
    [sym_range] = STATE(4778),
    [sym_binary] = STATE(4778),
    [sym_unary] = STATE(4778),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2256] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4779),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4779),
    [sym_operator_assignment] = STATE(4779),
    [sym_conditional] = STATE(4779),
    [sym_range] = STATE(4779),
    [sym_binary] = STATE(4779),
    [sym_unary] = STATE(4779),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2257] = {
    [anon_sym_COLON] = ACTIONS(7400),
    [sym_comment] = ACTIONS(87),
  },
  [2258] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4781),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4781),
    [sym_operator_assignment] = STATE(4781),
    [sym_conditional] = STATE(4781),
    [sym_range] = STATE(4781),
    [sym_binary] = STATE(4781),
    [sym_unary] = STATE(4781),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2259] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7402),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2260] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [2261] = {
    [sym_heredoc_body] = STATE(4783),
    [aux_sym_call_repeat1] = STATE(4783),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2262] = {
    [sym_heredoc_body] = STATE(4783),
    [aux_sym_call_repeat1] = STATE(4783),
    [aux_sym_argument_list_repeat1] = STATE(4785),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7404),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2263] = {
    [sym_string] = STATE(2328),
    [aux_sym_chained_string_repeat1] = STATE(2328),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7406),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2264] = {
    [sym_heredoc_body] = STATE(4786),
    [aux_sym_call_repeat1] = STATE(4786),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2265] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(4787),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2266] = {
    [sym_heredoc_body] = STATE(4788),
    [aux_sym_call_repeat1] = STATE(4788),
    [aux_sym_argument_list_repeat1] = STATE(4789),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2267] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4790),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_splat_argument] = STATE(4791),
    [sym_assignment] = STATE(4790),
    [sym_operator_assignment] = STATE(4790),
    [sym_conditional] = STATE(4790),
    [sym_range] = STATE(4790),
    [sym_binary] = STATE(4790),
    [sym_unary] = STATE(4790),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(4791),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2268] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4792),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(4792),
    [sym_operator_assignment] = STATE(4792),
    [sym_conditional] = STATE(4792),
    [sym_range] = STATE(4792),
    [sym_binary] = STATE(4792),
    [sym_unary] = STATE(4792),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2269] = {
    [sym_string] = STATE(4793),
    [aux_sym_chained_string_repeat1] = STATE(4793),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2270] = {
    [aux_sym_undef_repeat1] = STATE(4794),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_RPAREN] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [2271] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(5832),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2272] = {
    [sym_heredoc_body] = STATE(4795),
    [sym__terminator] = STATE(4795),
    [aux_sym__statements_repeat1] = STATE(2272),
    [sym__line_break2] = ACTIONS(7410),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_RPAREN] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(7410),
    [sym_comment] = ACTIONS(87),
  },
  [2273] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2274] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2275] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2276] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2277] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(1373),
    [anon_sym_or] = ACTIONS(1373),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2278] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2279] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [2280] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2281] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [2282] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2283] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2284] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(7413),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [2285] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2286] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2287] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2288] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2289] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2290] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4797),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(4797),
    [sym_operator_assignment] = STATE(4797),
    [sym_conditional] = STATE(4797),
    [sym_range] = STATE(4797),
    [sym_binary] = STATE(4797),
    [sym_unary] = STATE(4797),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2291] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2292] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2293] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2294] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2295] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4798),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(4798),
    [sym_operator_assignment] = STATE(4798),
    [sym_conditional] = STATE(4798),
    [sym_range] = STATE(4798),
    [sym_binary] = STATE(4798),
    [sym_unary] = STATE(4798),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2296] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4799),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(4799),
    [sym_operator_assignment] = STATE(4799),
    [sym_conditional] = STATE(4799),
    [sym_range] = STATE(4799),
    [sym_binary] = STATE(4799),
    [sym_unary] = STATE(4799),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2297] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2298] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [2299] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(770),
    [sym__argument] = STATE(771),
    [sym_splat_argument] = STATE(771),
    [sym_hash_splat_argument] = STATE(771),
    [sym_block_argument] = STATE(771),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(771),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1407),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2300] = {
    [anon_sym_EQ] = ACTIONS(7443),
    [sym_comment] = ACTIONS(87),
  },
  [2301] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7445),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7447),
    [anon_sym_DASH_EQ] = ACTIONS(7447),
    [anon_sym_STAR_EQ] = ACTIONS(7447),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7447),
    [anon_sym_SLASH_EQ] = ACTIONS(7447),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7447),
    [anon_sym_PIPE_EQ] = ACTIONS(7447),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7447),
    [anon_sym_AMP_EQ] = ACTIONS(7447),
    [anon_sym_PERCENT_EQ] = ACTIONS(7447),
    [anon_sym_GT_GT_EQ] = ACTIONS(7447),
    [anon_sym_LT_LT_EQ] = ACTIONS(7447),
    [anon_sym_CARET_EQ] = ACTIONS(7447),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2302] = {
    [sym_string] = STATE(4814),
    [aux_sym_chained_string_repeat1] = STATE(4814),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2303] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [2304] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [2305] = {
    [sym_string] = STATE(2328),
    [aux_sym_chained_string_repeat1] = STATE(2328),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2306] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4815),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(4815),
    [sym_operator_assignment] = STATE(4815),
    [sym_conditional] = STATE(4815),
    [sym_range] = STATE(4815),
    [sym_binary] = STATE(4815),
    [sym_unary] = STATE(4815),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2307] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [2308] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [2309] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [2310] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4816),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4816),
    [sym_operator_assignment] = STATE(4816),
    [sym_conditional] = STATE(4816),
    [sym_range] = STATE(4816),
    [sym_binary] = STATE(4816),
    [sym_unary] = STATE(4816),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2311] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4817),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4817),
    [sym_operator_assignment] = STATE(4817),
    [sym_conditional] = STATE(4817),
    [sym_range] = STATE(4817),
    [sym_binary] = STATE(4817),
    [sym_unary] = STATE(4817),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2312] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4818),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4818),
    [sym_operator_assignment] = STATE(4818),
    [sym_conditional] = STATE(4818),
    [sym_range] = STATE(4818),
    [sym_binary] = STATE(4818),
    [sym_unary] = STATE(4818),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2313] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4819),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4819),
    [sym_operator_assignment] = STATE(4819),
    [sym_conditional] = STATE(4819),
    [sym_range] = STATE(4819),
    [sym_binary] = STATE(4819),
    [sym_unary] = STATE(4819),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2314] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4820),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4820),
    [sym_operator_assignment] = STATE(4820),
    [sym_conditional] = STATE(4820),
    [sym_range] = STATE(4820),
    [sym_binary] = STATE(4820),
    [sym_unary] = STATE(4820),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2315] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4821),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4821),
    [sym_operator_assignment] = STATE(4821),
    [sym_conditional] = STATE(4821),
    [sym_range] = STATE(4821),
    [sym_binary] = STATE(4821),
    [sym_unary] = STATE(4821),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2316] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(4822),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(4822),
    [sym_operator_assignment] = STATE(4822),
    [sym_conditional] = STATE(4822),
    [sym_range] = STATE(4822),
    [sym_binary] = STATE(4822),
    [sym_unary] = STATE(4822),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2317] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4823),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(4823),
    [sym_operator_assignment] = STATE(4823),
    [sym_conditional] = STATE(4823),
    [sym_range] = STATE(4823),
    [sym_binary] = STATE(4823),
    [sym_unary] = STATE(4823),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2318] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4824),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4824),
    [sym_operator_assignment] = STATE(4824),
    [sym_conditional] = STATE(4824),
    [sym_range] = STATE(4824),
    [sym_binary] = STATE(4824),
    [sym_unary] = STATE(4824),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2319] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4825),
    [sym_operator_assignment] = STATE(4825),
    [sym_conditional] = STATE(4825),
    [sym_range] = STATE(4825),
    [sym_binary] = STATE(4825),
    [sym_unary] = STATE(4825),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2320] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4826),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4826),
    [sym_operator_assignment] = STATE(4826),
    [sym_conditional] = STATE(4826),
    [sym_range] = STATE(4826),
    [sym_binary] = STATE(4826),
    [sym_unary] = STATE(4826),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2321] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4827),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4827),
    [sym_operator_assignment] = STATE(4827),
    [sym_conditional] = STATE(4827),
    [sym_range] = STATE(4827),
    [sym_binary] = STATE(4827),
    [sym_unary] = STATE(4827),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2322] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4828),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4828),
    [sym_operator_assignment] = STATE(4828),
    [sym_conditional] = STATE(4828),
    [sym_range] = STATE(4828),
    [sym_binary] = STATE(4828),
    [sym_unary] = STATE(4828),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2323] = {
    [sym_heredoc_body] = STATE(4829),
    [aux_sym_call_repeat1] = STATE(4829),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2324] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(4830),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7449),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2325] = {
    [sym_heredoc_body] = STATE(4831),
    [aux_sym_call_repeat1] = STATE(4831),
    [aux_sym_argument_list_repeat1] = STATE(4832),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2326] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4833),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_splat_argument] = STATE(4834),
    [sym_assignment] = STATE(4833),
    [sym_operator_assignment] = STATE(4833),
    [sym_conditional] = STATE(4833),
    [sym_range] = STATE(4833),
    [sym_binary] = STATE(4833),
    [sym_unary] = STATE(4833),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(4834),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2327] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4835),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(4835),
    [sym_operator_assignment] = STATE(4835),
    [sym_conditional] = STATE(4835),
    [sym_range] = STATE(4835),
    [sym_binary] = STATE(4835),
    [sym_unary] = STATE(4835),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2328] = {
    [sym_string] = STATE(4836),
    [aux_sym_chained_string_repeat1] = STATE(4836),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [2329] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4837),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(4837),
    [sym_operator_assignment] = STATE(4837),
    [sym_conditional] = STATE(4837),
    [sym_range] = STATE(4837),
    [sym_binary] = STATE(4837),
    [sym_unary] = STATE(4837),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2330] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4838),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(4838),
    [sym_operator_assignment] = STATE(4838),
    [sym_conditional] = STATE(4838),
    [sym_range] = STATE(4838),
    [sym_binary] = STATE(4838),
    [sym_unary] = STATE(4838),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2331] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4839),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(4839),
    [sym_operator_assignment] = STATE(4839),
    [sym_conditional] = STATE(4839),
    [sym_range] = STATE(4839),
    [sym_binary] = STATE(4839),
    [sym_unary] = STATE(4839),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2332] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4840),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(4840),
    [sym_operator_assignment] = STATE(4840),
    [sym_conditional] = STATE(4840),
    [sym_range] = STATE(4840),
    [sym_binary] = STATE(4840),
    [sym_unary] = STATE(4840),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2333] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2334] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [2335] = {
    [aux_sym_exceptions_repeat1] = STATE(4854),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(7481),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2336] = {
    [anon_sym_EQ] = ACTIONS(7483),
    [sym_comment] = ACTIONS(87),
  },
  [2337] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7485),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7487),
    [anon_sym_DASH_EQ] = ACTIONS(7487),
    [anon_sym_STAR_EQ] = ACTIONS(7487),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7487),
    [anon_sym_SLASH_EQ] = ACTIONS(7487),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7487),
    [anon_sym_PIPE_EQ] = ACTIONS(7487),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7487),
    [anon_sym_AMP_EQ] = ACTIONS(7487),
    [anon_sym_PERCENT_EQ] = ACTIONS(7487),
    [anon_sym_GT_GT_EQ] = ACTIONS(7487),
    [anon_sym_LT_LT_EQ] = ACTIONS(7487),
    [anon_sym_CARET_EQ] = ACTIONS(7487),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2338] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [2339] = {
    [sym_string] = STATE(2339),
    [aux_sym_chained_string_repeat1] = STATE(2339),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2340] = {
    [sym__string_start2] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [2341] = {
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2959),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [2342] = {
    [anon_sym_DOT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [sym_comment] = ACTIONS(87),
  },
  [2343] = {
    [anon_sym_DOT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [sym_comment] = ACTIONS(87),
  },
  [2344] = {
    [anon_sym_DOT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [sym_comment] = ACTIONS(87),
  },
  [2345] = {
    [sym__string_end2] = ACTIONS(7489),
    [sym_comment] = ACTIONS(87),
  },
  [2346] = {
    [aux_sym_string_array_repeat1] = STATE(4860),
    [sym__string_end2] = ACTIONS(7491),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7493),
  },
  [2347] = {
    [anon_sym_DOT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [sym_comment] = ACTIONS(87),
  },
  [2348] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(7495),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2349] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(7495),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7497),
  },
  [2350] = {
    [anon_sym_DOT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [2351] = {
    [sym__string_end2] = ACTIONS(7499),
    [sym_comment] = ACTIONS(87),
  },
  [2352] = {
    [aux_sym_symbol_array_repeat1] = STATE(4866),
    [sym__string_end2] = ACTIONS(7501),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7503),
  },
  [2353] = {
    [anon_sym_DOT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [2354] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(7505),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [2355] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(7505),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7507),
  },
  [2356] = {
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(87),
  },
  [2357] = {
    [anon_sym_RBRACE] = ACTIONS(7509),
    [sym_comment] = ACTIONS(87),
  },
  [2358] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(7511),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [2359] = {
    [sym__method_rest] = STATE(4871),
    [sym_operator] = STATE(800),
    [sym__method_name] = STATE(800),
    [sym_setter] = STATE(800),
    [sym_symbol] = STATE(800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7513),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7513),
    [sym_class_variable] = ACTIONS(7513),
    [sym_global_variable] = ACTIONS(7513),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2360] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(4872),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7515),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2361] = {
    [anon_sym_DOT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(87),
  },
  [2362] = {
    [sym_heredoc_body] = STATE(4873),
    [sym__terminator] = STATE(4873),
    [sym__line_break2] = ACTIONS(7517),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(7517),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [2363] = {
    [sym_heredoc_body] = STATE(4874),
    [sym__terminator] = STATE(4874),
    [sym__line_break2] = ACTIONS(7519),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7519),
    [sym_comment] = ACTIONS(87),
  },
  [2364] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(4875),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7521),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2365] = {
    [anon_sym_DOT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(87),
  },
  [2366] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(4876),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7523),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2367] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4877),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(4877),
    [sym_operator_assignment] = STATE(4877),
    [sym_conditional] = STATE(4877),
    [sym_range] = STATE(4877),
    [sym_binary] = STATE(4877),
    [sym_unary] = STATE(4877),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2368] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(4884),
    [sym__argument] = STATE(4885),
    [sym_splat_argument] = STATE(4885),
    [sym_hash_splat_argument] = STATE(4885),
    [sym_block_argument] = STATE(4885),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4885),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2369] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(4884),
    [sym__argument] = STATE(4885),
    [sym_splat_argument] = STATE(4885),
    [sym_hash_splat_argument] = STATE(4885),
    [sym_block_argument] = STATE(4885),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4885),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2370] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(4884),
    [sym__argument] = STATE(4885),
    [sym_splat_argument] = STATE(4885),
    [sym_hash_splat_argument] = STATE(4885),
    [sym_block_argument] = STATE(4885),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4885),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2371] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(4884),
    [sym__argument] = STATE(4885),
    [sym_splat_argument] = STATE(4885),
    [sym_hash_splat_argument] = STATE(4885),
    [sym_block_argument] = STATE(4885),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4885),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1075),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2372] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4887),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(4887),
    [sym_operator_assignment] = STATE(4887),
    [sym_conditional] = STATE(4887),
    [sym_range] = STATE(4887),
    [sym_binary] = STATE(4887),
    [sym_unary] = STATE(4887),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2373] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4888),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(4888),
    [sym_operator_assignment] = STATE(4888),
    [sym_conditional] = STATE(4888),
    [sym_range] = STATE(4888),
    [sym_binary] = STATE(4888),
    [sym_unary] = STATE(4888),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2374] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2375] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(7551),
    [anon_sym_or] = ACTIONS(7551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [2376] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2377] = {
    [anon_sym_EQ] = ACTIONS(7573),
    [sym_comment] = ACTIONS(87),
  },
  [2378] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7575),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7577),
    [anon_sym_DASH_EQ] = ACTIONS(7577),
    [anon_sym_STAR_EQ] = ACTIONS(7577),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7577),
    [anon_sym_SLASH_EQ] = ACTIONS(7577),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7577),
    [anon_sym_PIPE_EQ] = ACTIONS(7577),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7577),
    [anon_sym_AMP_EQ] = ACTIONS(7577),
    [anon_sym_PERCENT_EQ] = ACTIONS(7577),
    [anon_sym_GT_GT_EQ] = ACTIONS(7577),
    [anon_sym_LT_LT_EQ] = ACTIONS(7577),
    [anon_sym_CARET_EQ] = ACTIONS(7577),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2379] = {
    [sym_string] = STATE(4912),
    [aux_sym_chained_string_repeat1] = STATE(4912),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2380] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(7551),
    [anon_sym_or] = ACTIONS(7551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [2381] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4913),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(4913),
    [sym_operator_assignment] = STATE(4913),
    [sym_conditional] = STATE(4913),
    [sym_range] = STATE(4913),
    [sym_binary] = STATE(4913),
    [sym_unary] = STATE(4913),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2382] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(7551),
    [anon_sym_or] = ACTIONS(7551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [2383] = {
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
  },
  [2384] = {
    [sym_heredoc_body] = STATE(4915),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(7579),
    [sym_comment] = ACTIONS(87),
  },
  [2385] = {
    [anon_sym_RPAREN] = ACTIONS(7579),
    [sym_comment] = ACTIONS(87),
  },
  [2386] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4916),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(4916),
    [sym_operator_assignment] = STATE(4916),
    [sym_conditional] = STATE(4916),
    [sym_range] = STATE(4916),
    [sym_binary] = STATE(4916),
    [sym_unary] = STATE(4916),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2387] = {
    [sym_interpolation] = STATE(4918),
    [aux_sym_heredoc_body_repeat1] = STATE(4918),
    [sym__heredoc_content2] = ACTIONS(7581),
    [sym_heredoc_end2] = ACTIONS(7583),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(7581),
  },
  [2388] = {
    [sym_heredoc_body] = STATE(4919),
    [aux_sym_call_repeat1] = STATE(4919),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2389] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(4920),
    [sym_splat_argument] = STATE(4920),
    [sym_hash_splat_argument] = STATE(4920),
    [sym_block_argument] = STATE(4920),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4921),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4920),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2390] = {
    [sym_heredoc_body] = STATE(4922),
    [aux_sym_call_repeat1] = STATE(4922),
    [aux_sym_argument_list_repeat1] = STATE(4923),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(3904),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2391] = {
    [sym__statements] = STATE(4925),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(4926),
    [sym_else] = STATE(4926),
    [sym__if_tail] = STATE(4926),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4927),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4927),
    [sym__line_break2] = ACTIONS(7585),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7587),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2392] = {
    [sym__statements] = STATE(4929),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(4930),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7589),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2393] = {
    [sym__statements] = STATE(4932),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7591),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2394] = {
    [sym__statements] = STATE(4934),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7593),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2395] = {
    [sym__do] = STATE(4935),
    [sym_heredoc_body] = STATE(4935),
    [sym__terminator] = STATE(4935),
    [sym__line_break2] = ACTIONS(7595),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(7595),
    [anon_sym_do] = ACTIONS(7595),
    [sym_comment] = ACTIONS(87),
  },
  [2396] = {
    [sym_when] = STATE(4936),
    [aux_sym_case_repeat1] = STATE(4937),
    [anon_sym_SEMI] = ACTIONS(7597),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [2397] = {
    [anon_sym_end] = ACTIONS(7599),
    [sym_comment] = ACTIONS(87),
  },
  [2398] = {
    [sym_when] = STATE(4936),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [2399] = {
    [anon_sym_DOT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [sym_comment] = ACTIONS(87),
  },
  [2400] = {
    [sym_ensure] = STATE(4940),
    [anon_sym_end] = ACTIONS(7601),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [2401] = {
    [anon_sym_end] = ACTIONS(7601),
    [sym_comment] = ACTIONS(87),
  },
  [2402] = {
    [sym_else] = STATE(4941),
    [sym_ensure] = STATE(4940),
    [anon_sym_end] = ACTIONS(7601),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [2403] = {
    [anon_sym_DOT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [sym_comment] = ACTIONS(87),
  },
  [2404] = {
    [anon_sym_DOT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(87),
  },
  [2405] = {
    [anon_sym_RBRACK] = ACTIONS(7603),
    [sym_comment] = ACTIONS(87),
  },
  [2406] = {
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_EQ] = ACTIONS(5750),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [2407] = {
    [anon_sym_RBRACE] = ACTIONS(7605),
    [sym_comment] = ACTIONS(87),
  },
  [2408] = {
    [sym__statements] = STATE(4944),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7605),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2409] = {
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5786),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_EQ] = ACTIONS(5786),
    [anon_sym_in] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [2410] = {
    [anon_sym_end] = ACTIONS(7607),
    [sym_comment] = ACTIONS(87),
  },
  [2411] = {
    [sym__statements] = STATE(4946),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(4947),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(4947),
    [sym__line_break2] = ACTIONS(7609),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7611),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2412] = {
    [sym__statements] = STATE(4946),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4948),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7611),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2413] = {
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5822),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [2414] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_EQ] = ACTIONS(1273),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [2415] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(4950),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(4951),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7613),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2416] = {
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5974),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_EQ] = ACTIONS(5974),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5974),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [2417] = {
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5978),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5978),
    [anon_sym_EQ] = ACTIONS(5978),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_in] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5978),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [2418] = {
    [sym_argument_list_with_parens] = STATE(4952),
    [sym__argument_list_with_parens] = STATE(2417),
    [sym_operator] = STATE(4952),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(3934),
    [anon_sym_STAR] = ACTIONS(3936),
    [anon_sym_STAR_STAR] = ACTIONS(3934),
    [anon_sym_AMP] = ACTIONS(3934),
    [anon_sym_LT] = ACTIONS(3936),
    [anon_sym_LPAREN2] = ACTIONS(3938),
    [anon_sym_DOT_DOT] = ACTIONS(3934),
    [anon_sym_LT_LT] = ACTIONS(3934),
    [anon_sym_GT_GT] = ACTIONS(3934),
    [anon_sym_EQ_EQ] = ACTIONS(3936),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3934),
    [anon_sym_LT_EQ_GT] = ACTIONS(3934),
    [anon_sym_EQ_TILDE] = ACTIONS(3934),
    [anon_sym_BANG_TILDE] = ACTIONS(3934),
    [anon_sym_LT_EQ] = ACTIONS(3936),
    [anon_sym_GT] = ACTIONS(3936),
    [anon_sym_GT_EQ] = ACTIONS(3934),
    [anon_sym_CARET] = ACTIONS(3934),
    [anon_sym_PLUS] = ACTIONS(3936),
    [anon_sym_SLASH] = ACTIONS(3934),
    [anon_sym_PERCENT] = ACTIONS(3934),
    [anon_sym_BANG] = ACTIONS(3936),
    [anon_sym_TILDE] = ACTIONS(3934),
    [sym_constant] = ACTIONS(7615),
    [sym_identifier] = ACTIONS(7615),
    [anon_sym_DASH] = ACTIONS(3936),
    [anon_sym_PLUS_AT] = ACTIONS(3934),
    [anon_sym_DASH_AT] = ACTIONS(3934),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(3936),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3934),
    [anon_sym_BQUOTE] = ACTIONS(3934),
    [sym_comment] = ACTIONS(87),
  },
  [2419] = {
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5984),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_EQ] = ACTIONS(5984),
    [anon_sym_in] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [sym_comment] = ACTIONS(87),
  },
  [2420] = {
    [sym_heredoc_body] = STATE(4954),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(7617),
    [sym_comment] = ACTIONS(87),
  },
  [2421] = {
    [anon_sym_RBRACK] = ACTIONS(7617),
    [sym_comment] = ACTIONS(87),
  },
  [2422] = {
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5990),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5990),
    [anon_sym_EQ] = ACTIONS(5990),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_in] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5990),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [2423] = {
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_STAR_STAR] = ACTIONS(101),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(101),
    [anon_sym_AMP_AMP] = ACTIONS(101),
    [anon_sym_LT_LT] = ACTIONS(101),
    [anon_sym_GT_GT] = ACTIONS(101),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(101),
    [anon_sym_SLASH] = ACTIONS(101),
    [anon_sym_PERCENT] = ACTIONS(101),
    [sym_comment] = ACTIONS(87),
  },
  [2424] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(4956),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(7619),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2425] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(4958),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(7621),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2426] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(4960),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(7623),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2427] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(4962),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(7625),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [2428] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(4965),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(7627),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7629),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2429] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(4968),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(7631),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(7633),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [2430] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4969),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(4969),
    [sym_operator_assignment] = STATE(4969),
    [sym_conditional] = STATE(4969),
    [sym_range] = STATE(4969),
    [sym_binary] = STATE(4969),
    [sym_unary] = STATE(4969),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2431] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(4971),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(4972),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(7635),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2432] = {
    [sym__method_rest] = STATE(4974),
    [sym__variable] = STATE(4975),
    [sym_operator] = STATE(4976),
    [sym__method_name] = STATE(4976),
    [sym_setter] = STATE(4976),
    [sym_symbol] = STATE(4976),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(7637),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(7639),
    [sym_self] = ACTIONS(7639),
  },
  [2433] = {
    [sym__statements] = STATE(4978),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(7641),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2434] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(4981),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(7643),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(7645),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2435] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(4983),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(7647),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2436] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(4991),
    [sym__argument_list_with_parens] = STATE(4992),
    [sym__argument] = STATE(4993),
    [sym_splat_argument] = STATE(4993),
    [sym_hash_splat_argument] = STATE(4993),
    [sym_block_argument] = STATE(4993),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4993),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2437] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(4995),
    [sym__argument_list_with_parens] = STATE(4992),
    [sym__argument] = STATE(4993),
    [sym_splat_argument] = STATE(4993),
    [sym_hash_splat_argument] = STATE(4993),
    [sym_block_argument] = STATE(4993),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4993),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2438] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(4996),
    [sym__argument_list_with_parens] = STATE(4992),
    [sym__argument] = STATE(4993),
    [sym_splat_argument] = STATE(4993),
    [sym_hash_splat_argument] = STATE(4993),
    [sym_block_argument] = STATE(4993),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4993),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2439] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_argument_list] = STATE(4997),
    [sym__argument_list_with_parens] = STATE(4992),
    [sym__argument] = STATE(4993),
    [sym_splat_argument] = STATE(4993),
    [sym_hash_splat_argument] = STATE(4993),
    [sym_block_argument] = STATE(4993),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4993),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(4022),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2440] = {
    [sym__statement] = STATE(4998),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2441] = {
    [sym__statement] = STATE(4999),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2442] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5000),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(5000),
    [sym_operator_assignment] = STATE(5000),
    [sym_conditional] = STATE(5000),
    [sym_range] = STATE(5000),
    [sym_binary] = STATE(5000),
    [sym_unary] = STATE(5000),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2443] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5001),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(5001),
    [sym_operator_assignment] = STATE(5001),
    [sym_conditional] = STATE(5001),
    [sym_range] = STATE(5001),
    [sym_binary] = STATE(5001),
    [sym_unary] = STATE(5001),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2444] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(5002),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [2445] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5003),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(5003),
    [sym_operator_assignment] = STATE(5003),
    [sym_conditional] = STATE(5003),
    [sym_range] = STATE(5003),
    [sym_binary] = STATE(5003),
    [sym_unary] = STATE(5003),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(5004),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(5004),
    [sym__line_break2] = ACTIONS(7659),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(7659),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2446] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(5009),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(5010),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(5010),
    [sym__line_break2] = ACTIONS(7661),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7663),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2447] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5011),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(5011),
    [sym_operator_assignment] = STATE(5011),
    [sym_conditional] = STATE(5011),
    [sym_range] = STATE(5011),
    [sym_binary] = STATE(5011),
    [sym_unary] = STATE(5011),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2448] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5012),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(5012),
    [sym_operator_assignment] = STATE(5012),
    [sym_conditional] = STATE(5012),
    [sym_range] = STATE(5012),
    [sym_binary] = STATE(5012),
    [sym_unary] = STATE(5012),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2449] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5013),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(5013),
    [sym_operator_assignment] = STATE(5013),
    [sym_conditional] = STATE(5013),
    [sym_range] = STATE(5013),
    [sym_binary] = STATE(5013),
    [sym_unary] = STATE(5013),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2450] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(7665),
  },
  [2451] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(5016),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5017),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(7667),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2452] = {
    [sym_lambda_parameters] = STATE(5020),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(5021),
    [sym_block] = STATE(5021),
    [anon_sym_LBRACE] = ACTIONS(7669),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(7671),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [2453] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [2454] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2455] = {
    [anon_sym_EQ] = ACTIONS(7707),
    [sym_comment] = ACTIONS(87),
  },
  [2456] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7709),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7711),
    [anon_sym_DASH_EQ] = ACTIONS(7711),
    [anon_sym_STAR_EQ] = ACTIONS(7711),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7711),
    [anon_sym_SLASH_EQ] = ACTIONS(7711),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7711),
    [anon_sym_PIPE_EQ] = ACTIONS(7711),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7711),
    [anon_sym_AMP_EQ] = ACTIONS(7711),
    [anon_sym_PERCENT_EQ] = ACTIONS(7711),
    [anon_sym_GT_GT_EQ] = ACTIONS(7711),
    [anon_sym_LT_LT_EQ] = ACTIONS(7711),
    [anon_sym_CARET_EQ] = ACTIONS(7711),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2457] = {
    [sym_string] = STATE(5038),
    [aux_sym_chained_string_repeat1] = STATE(5038),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2458] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [2459] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2460] = {
    [sym_string] = STATE(2494),
    [aux_sym_chained_string_repeat1] = STATE(2494),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2461] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5039),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(5039),
    [sym_operator_assignment] = STATE(5039),
    [sym_conditional] = STATE(5039),
    [sym_range] = STATE(5039),
    [sym_binary] = STATE(5039),
    [sym_unary] = STATE(5039),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2462] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [2463] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [2464] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5040),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5040),
    [sym_operator_assignment] = STATE(5040),
    [sym_conditional] = STATE(5040),
    [sym_range] = STATE(5040),
    [sym_binary] = STATE(5040),
    [sym_unary] = STATE(5040),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2465] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5041),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5041),
    [sym_operator_assignment] = STATE(5041),
    [sym_conditional] = STATE(5041),
    [sym_range] = STATE(5041),
    [sym_binary] = STATE(5041),
    [sym_unary] = STATE(5041),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2466] = {
    [anon_sym_COLON] = ACTIONS(7713),
    [sym_comment] = ACTIONS(87),
  },
  [2467] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5043),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5043),
    [sym_operator_assignment] = STATE(5043),
    [sym_conditional] = STATE(5043),
    [sym_range] = STATE(5043),
    [sym_binary] = STATE(5043),
    [sym_unary] = STATE(5043),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2468] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7715),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2469] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [2470] = {
    [sym_heredoc_body] = STATE(5045),
    [aux_sym_call_repeat1] = STATE(5045),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2471] = {
    [sym_heredoc_body] = STATE(5045),
    [aux_sym_call_repeat1] = STATE(5045),
    [aux_sym_argument_list_repeat1] = STATE(5047),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7717),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2472] = {
    [sym_string] = STATE(2494),
    [aux_sym_chained_string_repeat1] = STATE(2494),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7719),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2473] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2474] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [2475] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5048),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5048),
    [sym_operator_assignment] = STATE(5048),
    [sym_conditional] = STATE(5048),
    [sym_range] = STATE(5048),
    [sym_binary] = STATE(5048),
    [sym_unary] = STATE(5048),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2476] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5049),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5049),
    [sym_operator_assignment] = STATE(5049),
    [sym_conditional] = STATE(5049),
    [sym_range] = STATE(5049),
    [sym_binary] = STATE(5049),
    [sym_unary] = STATE(5049),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2477] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5050),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5050),
    [sym_operator_assignment] = STATE(5050),
    [sym_conditional] = STATE(5050),
    [sym_range] = STATE(5050),
    [sym_binary] = STATE(5050),
    [sym_unary] = STATE(5050),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2478] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5051),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5051),
    [sym_operator_assignment] = STATE(5051),
    [sym_conditional] = STATE(5051),
    [sym_range] = STATE(5051),
    [sym_binary] = STATE(5051),
    [sym_unary] = STATE(5051),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2479] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5052),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5052),
    [sym_operator_assignment] = STATE(5052),
    [sym_conditional] = STATE(5052),
    [sym_range] = STATE(5052),
    [sym_binary] = STATE(5052),
    [sym_unary] = STATE(5052),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2480] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5053),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5053),
    [sym_operator_assignment] = STATE(5053),
    [sym_conditional] = STATE(5053),
    [sym_range] = STATE(5053),
    [sym_binary] = STATE(5053),
    [sym_unary] = STATE(5053),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2481] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5054),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(5054),
    [sym_operator_assignment] = STATE(5054),
    [sym_conditional] = STATE(5054),
    [sym_range] = STATE(5054),
    [sym_binary] = STATE(5054),
    [sym_unary] = STATE(5054),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [2482] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5055),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5055),
    [sym_operator_assignment] = STATE(5055),
    [sym_conditional] = STATE(5055),
    [sym_range] = STATE(5055),
    [sym_binary] = STATE(5055),
    [sym_unary] = STATE(5055),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2483] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5056),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5056),
    [sym_operator_assignment] = STATE(5056),
    [sym_conditional] = STATE(5056),
    [sym_range] = STATE(5056),
    [sym_binary] = STATE(5056),
    [sym_unary] = STATE(5056),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2484] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5057),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5057),
    [sym_operator_assignment] = STATE(5057),
    [sym_conditional] = STATE(5057),
    [sym_range] = STATE(5057),
    [sym_binary] = STATE(5057),
    [sym_unary] = STATE(5057),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2485] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5058),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5058),
    [sym_operator_assignment] = STATE(5058),
    [sym_conditional] = STATE(5058),
    [sym_range] = STATE(5058),
    [sym_binary] = STATE(5058),
    [sym_unary] = STATE(5058),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2486] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5059),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5059),
    [sym_operator_assignment] = STATE(5059),
    [sym_conditional] = STATE(5059),
    [sym_range] = STATE(5059),
    [sym_binary] = STATE(5059),
    [sym_unary] = STATE(5059),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2487] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5060),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5060),
    [sym_operator_assignment] = STATE(5060),
    [sym_conditional] = STATE(5060),
    [sym_range] = STATE(5060),
    [sym_binary] = STATE(5060),
    [sym_unary] = STATE(5060),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2488] = {
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6196),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_EQ] = ACTIONS(6196),
    [anon_sym_in] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [sym_comment] = ACTIONS(87),
  },
  [2489] = {
    [sym_heredoc_body] = STATE(5061),
    [aux_sym_call_repeat1] = STATE(5061),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_EQ] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2490] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(861),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(4920),
    [sym_splat_argument] = STATE(4920),
    [sym_hash_splat_argument] = STATE(4920),
    [sym_block_argument] = STATE(4920),
    [sym_assignment] = STATE(861),
    [sym_operator_assignment] = STATE(861),
    [sym_conditional] = STATE(861),
    [sym_range] = STATE(861),
    [sym_binary] = STATE(861),
    [sym_unary] = STATE(861),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(868),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5062),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4920),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1497),
    [sym__splat_star2] = ACTIONS(1499),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1507),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1525),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2491] = {
    [sym_heredoc_body] = STATE(5063),
    [aux_sym_call_repeat1] = STATE(5063),
    [aux_sym_argument_list_repeat1] = STATE(5064),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4062),
    [anon_sym_EQ] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2492] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5065),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_splat_argument] = STATE(5066),
    [sym_assignment] = STATE(5065),
    [sym_operator_assignment] = STATE(5065),
    [sym_conditional] = STATE(5065),
    [sym_range] = STATE(5065),
    [sym_binary] = STATE(5065),
    [sym_unary] = STATE(5065),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(5066),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2493] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5067),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(5067),
    [sym_operator_assignment] = STATE(5067),
    [sym_conditional] = STATE(5067),
    [sym_range] = STATE(5067),
    [sym_binary] = STATE(5067),
    [sym_unary] = STATE(5067),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2494] = {
    [sym_string] = STATE(5068),
    [aux_sym_chained_string_repeat1] = STATE(5068),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2495] = {
    [sym_string] = STATE(2495),
    [aux_sym_chained_string_repeat1] = STATE(2495),
    [sym__string_start2] = ACTIONS(7721),
    [anon_sym_DOT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2496] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(5069),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7724),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2497] = {
    [sym__line_break2] = ACTIONS(7726),
    [sym__heredoc_body_start2] = ACTIONS(7726),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(7726),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [2498] = {
    [sym__statements] = STATE(295),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(298),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(299),
    [sym_rescue] = STATE(300),
    [sym__body_statement] = STATE(5070),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7728),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2499] = {
    [sym__line_break2] = ACTIONS(7730),
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [ts_builtin_sym_end] = ACTIONS(7730),
    [anon_sym___END__] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7730),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_end] = ACTIONS(7730),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_when] = ACTIONS(7730),
    [anon_sym_elsif] = ACTIONS(7730),
    [anon_sym_else] = ACTIONS(7730),
    [anon_sym_then] = ACTIONS(7730),
    [anon_sym_ensure] = ACTIONS(7730),
    [anon_sym_EQ_GT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7730),
    [anon_sym_AMP_AMP] = ACTIONS(7730),
    [anon_sym_LT_LT] = ACTIONS(7730),
    [anon_sym_GT_GT] = ACTIONS(7730),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7730),
    [anon_sym_PLUS] = ACTIONS(7730),
    [anon_sym_SLASH] = ACTIONS(7730),
    [anon_sym_PERCENT] = ACTIONS(7730),
    [sym_comment] = ACTIONS(87),
  },
  [2500] = {
    [sym__line_break2] = ACTIONS(5990),
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym__heredoc_body_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_DOT] = ACTIONS(5990),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5990),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5990),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_end] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_then] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5990),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [2501] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5071),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(5071),
    [sym_operator_assignment] = STATE(5071),
    [sym_conditional] = STATE(5071),
    [sym_range] = STATE(5071),
    [sym_binary] = STATE(5071),
    [sym_unary] = STATE(5071),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2502] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2503] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2504] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2505] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2506] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5081),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(5081),
    [sym_operator_assignment] = STATE(5081),
    [sym_conditional] = STATE(5081),
    [sym_range] = STATE(5081),
    [sym_binary] = STATE(5081),
    [sym_unary] = STATE(5081),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2507] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5082),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(5082),
    [sym_operator_assignment] = STATE(5082),
    [sym_conditional] = STATE(5082),
    [sym_range] = STATE(5082),
    [sym_binary] = STATE(5082),
    [sym_unary] = STATE(5082),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2508] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2509] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(7760),
    [anon_sym_or] = ACTIONS(7760),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [2510] = {
    [anon_sym_EQ] = ACTIONS(7774),
    [sym_comment] = ACTIONS(87),
  },
  [2511] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7776),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7778),
    [anon_sym_DASH_EQ] = ACTIONS(7778),
    [anon_sym_STAR_EQ] = ACTIONS(7778),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7778),
    [anon_sym_SLASH_EQ] = ACTIONS(7778),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7778),
    [anon_sym_PIPE_EQ] = ACTIONS(7778),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7778),
    [anon_sym_AMP_EQ] = ACTIONS(7778),
    [anon_sym_PERCENT_EQ] = ACTIONS(7778),
    [anon_sym_GT_GT_EQ] = ACTIONS(7778),
    [anon_sym_LT_LT_EQ] = ACTIONS(7778),
    [anon_sym_CARET_EQ] = ACTIONS(7778),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2512] = {
    [sym_string] = STATE(5097),
    [aux_sym_chained_string_repeat1] = STATE(5097),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2513] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(7760),
    [anon_sym_or] = ACTIONS(7760),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [2514] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2515] = {
    [sym_string] = STATE(2548),
    [aux_sym_chained_string_repeat1] = STATE(2548),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2516] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5098),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(5098),
    [sym_operator_assignment] = STATE(5098),
    [sym_conditional] = STATE(5098),
    [sym_range] = STATE(5098),
    [sym_binary] = STATE(5098),
    [sym_unary] = STATE(5098),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2517] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [2518] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(7760),
    [anon_sym_or] = ACTIONS(7760),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [2519] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5099),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5099),
    [sym_operator_assignment] = STATE(5099),
    [sym_conditional] = STATE(5099),
    [sym_range] = STATE(5099),
    [sym_binary] = STATE(5099),
    [sym_unary] = STATE(5099),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2520] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5100),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5100),
    [sym_operator_assignment] = STATE(5100),
    [sym_conditional] = STATE(5100),
    [sym_range] = STATE(5100),
    [sym_binary] = STATE(5100),
    [sym_unary] = STATE(5100),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2521] = {
    [anon_sym_COLON] = ACTIONS(7780),
    [sym_comment] = ACTIONS(87),
  },
  [2522] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5102),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5102),
    [sym_operator_assignment] = STATE(5102),
    [sym_conditional] = STATE(5102),
    [sym_range] = STATE(5102),
    [sym_binary] = STATE(5102),
    [sym_unary] = STATE(5102),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2523] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7782),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2524] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [2525] = {
    [sym_heredoc_body] = STATE(5104),
    [aux_sym_call_repeat1] = STATE(5104),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2526] = {
    [sym_heredoc_body] = STATE(5104),
    [aux_sym_call_repeat1] = STATE(5104),
    [aux_sym_argument_list_repeat1] = STATE(5106),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7784),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2527] = {
    [sym_string] = STATE(2548),
    [aux_sym_chained_string_repeat1] = STATE(2548),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7786),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2528] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2529] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [2530] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5107),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5107),
    [sym_operator_assignment] = STATE(5107),
    [sym_conditional] = STATE(5107),
    [sym_range] = STATE(5107),
    [sym_binary] = STATE(5107),
    [sym_unary] = STATE(5107),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2531] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5108),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5108),
    [sym_operator_assignment] = STATE(5108),
    [sym_conditional] = STATE(5108),
    [sym_range] = STATE(5108),
    [sym_binary] = STATE(5108),
    [sym_unary] = STATE(5108),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2532] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5109),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5109),
    [sym_operator_assignment] = STATE(5109),
    [sym_conditional] = STATE(5109),
    [sym_range] = STATE(5109),
    [sym_binary] = STATE(5109),
    [sym_unary] = STATE(5109),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2533] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5110),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5110),
    [sym_operator_assignment] = STATE(5110),
    [sym_conditional] = STATE(5110),
    [sym_range] = STATE(5110),
    [sym_binary] = STATE(5110),
    [sym_unary] = STATE(5110),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2534] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5111),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5111),
    [sym_operator_assignment] = STATE(5111),
    [sym_conditional] = STATE(5111),
    [sym_range] = STATE(5111),
    [sym_binary] = STATE(5111),
    [sym_unary] = STATE(5111),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2535] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5112),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5112),
    [sym_operator_assignment] = STATE(5112),
    [sym_conditional] = STATE(5112),
    [sym_range] = STATE(5112),
    [sym_binary] = STATE(5112),
    [sym_unary] = STATE(5112),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2536] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5113),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(5113),
    [sym_operator_assignment] = STATE(5113),
    [sym_conditional] = STATE(5113),
    [sym_range] = STATE(5113),
    [sym_binary] = STATE(5113),
    [sym_unary] = STATE(5113),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2537] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5114),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5114),
    [sym_operator_assignment] = STATE(5114),
    [sym_conditional] = STATE(5114),
    [sym_range] = STATE(5114),
    [sym_binary] = STATE(5114),
    [sym_unary] = STATE(5114),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2538] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5115),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5115),
    [sym_operator_assignment] = STATE(5115),
    [sym_conditional] = STATE(5115),
    [sym_range] = STATE(5115),
    [sym_binary] = STATE(5115),
    [sym_unary] = STATE(5115),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2539] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5116),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5116),
    [sym_operator_assignment] = STATE(5116),
    [sym_conditional] = STATE(5116),
    [sym_range] = STATE(5116),
    [sym_binary] = STATE(5116),
    [sym_unary] = STATE(5116),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2540] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5117),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5117),
    [sym_operator_assignment] = STATE(5117),
    [sym_conditional] = STATE(5117),
    [sym_range] = STATE(5117),
    [sym_binary] = STATE(5117),
    [sym_unary] = STATE(5117),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2541] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5118),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5118),
    [sym_operator_assignment] = STATE(5118),
    [sym_conditional] = STATE(5118),
    [sym_range] = STATE(5118),
    [sym_binary] = STATE(5118),
    [sym_unary] = STATE(5118),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2542] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5119),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5119),
    [sym_operator_assignment] = STATE(5119),
    [sym_conditional] = STATE(5119),
    [sym_range] = STATE(5119),
    [sym_binary] = STATE(5119),
    [sym_unary] = STATE(5119),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2543] = {
    [sym_heredoc_body] = STATE(5120),
    [aux_sym_call_repeat1] = STATE(5120),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2544] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(4920),
    [sym_splat_argument] = STATE(4920),
    [sym_hash_splat_argument] = STATE(4920),
    [sym_block_argument] = STATE(4920),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5121),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4920),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2545] = {
    [sym_heredoc_body] = STATE(5122),
    [aux_sym_call_repeat1] = STATE(5122),
    [aux_sym_argument_list_repeat1] = STATE(5123),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4148),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2546] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5124),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_splat_argument] = STATE(5125),
    [sym_assignment] = STATE(5124),
    [sym_operator_assignment] = STATE(5124),
    [sym_conditional] = STATE(5124),
    [sym_range] = STATE(5124),
    [sym_binary] = STATE(5124),
    [sym_unary] = STATE(5124),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(5125),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2547] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5126),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(5126),
    [sym_operator_assignment] = STATE(5126),
    [sym_conditional] = STATE(5126),
    [sym_range] = STATE(5126),
    [sym_binary] = STATE(5126),
    [sym_unary] = STATE(5126),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2548] = {
    [sym_string] = STATE(5127),
    [aux_sym_chained_string_repeat1] = STATE(5127),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2549] = {
    [sym__line_break2] = ACTIONS(7788),
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [ts_builtin_sym_end] = ACTIONS(7788),
    [anon_sym___END__] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_when] = ACTIONS(7788),
    [anon_sym_elsif] = ACTIONS(7788),
    [anon_sym_else] = ACTIONS(7788),
    [anon_sym_then] = ACTIONS(7788),
    [anon_sym_ensure] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7788),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [sym_comment] = ACTIONS(87),
  },
  [2550] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2551] = {
    [sym_heredoc_body] = STATE(5128),
    [aux_sym_call_repeat1] = STATE(5128),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2552] = {
    [sym_heredoc_body] = STATE(5128),
    [aux_sym_call_repeat1] = STATE(5128),
    [aux_sym_argument_list_repeat1] = STATE(5129),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [ts_builtin_sym_end] = ACTIONS(1703),
    [anon_sym___END__] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2553] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2554] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [2555] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5130),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5130),
    [sym_operator_assignment] = STATE(5130),
    [sym_conditional] = STATE(5130),
    [sym_range] = STATE(5130),
    [sym_binary] = STATE(5130),
    [sym_unary] = STATE(5130),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2556] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5131),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5131),
    [sym_operator_assignment] = STATE(5131),
    [sym_conditional] = STATE(5131),
    [sym_range] = STATE(5131),
    [sym_binary] = STATE(5131),
    [sym_unary] = STATE(5131),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2557] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5132),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5132),
    [sym_operator_assignment] = STATE(5132),
    [sym_conditional] = STATE(5132),
    [sym_range] = STATE(5132),
    [sym_binary] = STATE(5132),
    [sym_unary] = STATE(5132),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2558] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5133),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5133),
    [sym_operator_assignment] = STATE(5133),
    [sym_conditional] = STATE(5133),
    [sym_range] = STATE(5133),
    [sym_binary] = STATE(5133),
    [sym_unary] = STATE(5133),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2559] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5134),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5134),
    [sym_operator_assignment] = STATE(5134),
    [sym_conditional] = STATE(5134),
    [sym_range] = STATE(5134),
    [sym_binary] = STATE(5134),
    [sym_unary] = STATE(5134),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2560] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5135),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5135),
    [sym_operator_assignment] = STATE(5135),
    [sym_conditional] = STATE(5135),
    [sym_range] = STATE(5135),
    [sym_binary] = STATE(5135),
    [sym_unary] = STATE(5135),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2561] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5136),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5136),
    [sym_operator_assignment] = STATE(5136),
    [sym_conditional] = STATE(5136),
    [sym_range] = STATE(5136),
    [sym_binary] = STATE(5136),
    [sym_unary] = STATE(5136),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2562] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5137),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5137),
    [sym_operator_assignment] = STATE(5137),
    [sym_conditional] = STATE(5137),
    [sym_range] = STATE(5137),
    [sym_binary] = STATE(5137),
    [sym_unary] = STATE(5137),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2563] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5138),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5138),
    [sym_operator_assignment] = STATE(5138),
    [sym_conditional] = STATE(5138),
    [sym_range] = STATE(5138),
    [sym_binary] = STATE(5138),
    [sym_unary] = STATE(5138),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2564] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5139),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5139),
    [sym_operator_assignment] = STATE(5139),
    [sym_conditional] = STATE(5139),
    [sym_range] = STATE(5139),
    [sym_binary] = STATE(5139),
    [sym_unary] = STATE(5139),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2565] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5140),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5140),
    [sym_operator_assignment] = STATE(5140),
    [sym_conditional] = STATE(5140),
    [sym_range] = STATE(5140),
    [sym_binary] = STATE(5140),
    [sym_unary] = STATE(5140),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2566] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5141),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5141),
    [sym_operator_assignment] = STATE(5141),
    [sym_conditional] = STATE(5141),
    [sym_range] = STATE(5141),
    [sym_binary] = STATE(5141),
    [sym_unary] = STATE(5141),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2567] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5142),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_splat_argument] = STATE(5143),
    [sym_assignment] = STATE(5142),
    [sym_operator_assignment] = STATE(5142),
    [sym_conditional] = STATE(5142),
    [sym_range] = STATE(5142),
    [sym_binary] = STATE(5142),
    [sym_unary] = STATE(5142),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(5143),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2568] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5144),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(5144),
    [sym_operator_assignment] = STATE(5144),
    [sym_conditional] = STATE(5144),
    [sym_range] = STATE(5144),
    [sym_binary] = STATE(5144),
    [sym_unary] = STATE(5144),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2569] = {
    [sym_string] = STATE(5145),
    [aux_sym_chained_string_repeat1] = STATE(5145),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [anon_sym___END__] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2570] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(6749),
    [anon_sym___END__] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [2571] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(4164),
    [anon_sym___END__] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2572] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(4204),
    [anon_sym___END__] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2573] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5146),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(5146),
    [sym_operator_assignment] = STATE(5146),
    [sym_conditional] = STATE(5146),
    [sym_range] = STATE(5146),
    [sym_binary] = STATE(5146),
    [sym_unary] = STATE(5146),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2574] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2575] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5147),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(5147),
    [sym_operator_assignment] = STATE(5147),
    [sym_conditional] = STATE(5147),
    [sym_range] = STATE(5147),
    [sym_binary] = STATE(5147),
    [sym_unary] = STATE(5147),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2576] = {
    [sym_heredoc_body] = STATE(5148),
    [aux_sym_call_repeat1] = STATE(5148),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2577] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(5149),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7794),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2578] = {
    [sym_heredoc_body] = STATE(5150),
    [aux_sym_call_repeat1] = STATE(5150),
    [aux_sym_argument_list_repeat1] = STATE(5151),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4214),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2579] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5152),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(5152),
    [sym_operator_assignment] = STATE(5152),
    [sym_conditional] = STATE(5152),
    [sym_range] = STATE(5152),
    [sym_binary] = STATE(5152),
    [sym_unary] = STATE(5152),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2580] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2581] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2582] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2583] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2584] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5155),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(5155),
    [sym_operator_assignment] = STATE(5155),
    [sym_conditional] = STATE(5155),
    [sym_range] = STATE(5155),
    [sym_binary] = STATE(5155),
    [sym_unary] = STATE(5155),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2585] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5156),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(5156),
    [sym_operator_assignment] = STATE(5156),
    [sym_conditional] = STATE(5156),
    [sym_range] = STATE(5156),
    [sym_binary] = STATE(5156),
    [sym_unary] = STATE(5156),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2586] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1398),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(1398),
    [sym_operator_assignment] = STATE(1398),
    [sym_conditional] = STATE(1398),
    [sym_range] = STATE(1398),
    [sym_binary] = STATE(1398),
    [sym_unary] = STATE(1398),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2587] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [2588] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2589] = {
    [anon_sym_EQ] = ACTIONS(7828),
    [sym_comment] = ACTIONS(87),
  },
  [2590] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7830),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7832),
    [anon_sym_DASH_EQ] = ACTIONS(7832),
    [anon_sym_STAR_EQ] = ACTIONS(7832),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7832),
    [anon_sym_SLASH_EQ] = ACTIONS(7832),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7832),
    [anon_sym_PIPE_EQ] = ACTIONS(7832),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7832),
    [anon_sym_AMP_EQ] = ACTIONS(7832),
    [anon_sym_PERCENT_EQ] = ACTIONS(7832),
    [anon_sym_GT_GT_EQ] = ACTIONS(7832),
    [anon_sym_LT_LT_EQ] = ACTIONS(7832),
    [anon_sym_CARET_EQ] = ACTIONS(7832),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2591] = {
    [sym_string] = STATE(5171),
    [aux_sym_chained_string_repeat1] = STATE(5171),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2592] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [2593] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2594] = {
    [sym_string] = STATE(2635),
    [aux_sym_chained_string_repeat1] = STATE(2635),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2595] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5172),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(5172),
    [sym_operator_assignment] = STATE(5172),
    [sym_conditional] = STATE(5172),
    [sym_range] = STATE(5172),
    [sym_binary] = STATE(5172),
    [sym_unary] = STATE(5172),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2596] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [2597] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5173),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(5173),
    [sym_operator_assignment] = STATE(5173),
    [sym_conditional] = STATE(5173),
    [sym_range] = STATE(5173),
    [sym_binary] = STATE(5173),
    [sym_unary] = STATE(5173),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2598] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5174),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(5174),
    [sym_operator_assignment] = STATE(5174),
    [sym_conditional] = STATE(5174),
    [sym_range] = STATE(5174),
    [sym_binary] = STATE(5174),
    [sym_unary] = STATE(5174),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2599] = {
    [anon_sym_COLON] = ACTIONS(7834),
    [sym_comment] = ACTIONS(87),
  },
  [2600] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5176),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(5176),
    [sym_operator_assignment] = STATE(5176),
    [sym_conditional] = STATE(5176),
    [sym_range] = STATE(5176),
    [sym_binary] = STATE(5176),
    [sym_unary] = STATE(5176),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2601] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7836),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2602] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [2603] = {
    [sym_heredoc_body] = STATE(5178),
    [aux_sym_call_repeat1] = STATE(5178),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2604] = {
    [sym_heredoc_body] = STATE(5178),
    [aux_sym_call_repeat1] = STATE(5178),
    [aux_sym_argument_list_repeat1] = STATE(5180),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7838),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2605] = {
    [sym_string] = STATE(2635),
    [aux_sym_chained_string_repeat1] = STATE(2635),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7840),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2606] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2607] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [2608] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5181),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5181),
    [sym_operator_assignment] = STATE(5181),
    [sym_conditional] = STATE(5181),
    [sym_range] = STATE(5181),
    [sym_binary] = STATE(5181),
    [sym_unary] = STATE(5181),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2609] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5182),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5182),
    [sym_operator_assignment] = STATE(5182),
    [sym_conditional] = STATE(5182),
    [sym_range] = STATE(5182),
    [sym_binary] = STATE(5182),
    [sym_unary] = STATE(5182),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2610] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5183),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5183),
    [sym_operator_assignment] = STATE(5183),
    [sym_conditional] = STATE(5183),
    [sym_range] = STATE(5183),
    [sym_binary] = STATE(5183),
    [sym_unary] = STATE(5183),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2611] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5184),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5184),
    [sym_operator_assignment] = STATE(5184),
    [sym_conditional] = STATE(5184),
    [sym_range] = STATE(5184),
    [sym_binary] = STATE(5184),
    [sym_unary] = STATE(5184),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2612] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5185),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5185),
    [sym_operator_assignment] = STATE(5185),
    [sym_conditional] = STATE(5185),
    [sym_range] = STATE(5185),
    [sym_binary] = STATE(5185),
    [sym_unary] = STATE(5185),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2613] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5186),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5186),
    [sym_operator_assignment] = STATE(5186),
    [sym_conditional] = STATE(5186),
    [sym_range] = STATE(5186),
    [sym_binary] = STATE(5186),
    [sym_unary] = STATE(5186),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2614] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5187),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(5187),
    [sym_operator_assignment] = STATE(5187),
    [sym_conditional] = STATE(5187),
    [sym_range] = STATE(5187),
    [sym_binary] = STATE(5187),
    [sym_unary] = STATE(5187),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2615] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5188),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5188),
    [sym_operator_assignment] = STATE(5188),
    [sym_conditional] = STATE(5188),
    [sym_range] = STATE(5188),
    [sym_binary] = STATE(5188),
    [sym_unary] = STATE(5188),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2616] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5189),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5189),
    [sym_operator_assignment] = STATE(5189),
    [sym_conditional] = STATE(5189),
    [sym_range] = STATE(5189),
    [sym_binary] = STATE(5189),
    [sym_unary] = STATE(5189),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2617] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5190),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5190),
    [sym_operator_assignment] = STATE(5190),
    [sym_conditional] = STATE(5190),
    [sym_range] = STATE(5190),
    [sym_binary] = STATE(5190),
    [sym_unary] = STATE(5190),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2618] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5191),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5191),
    [sym_operator_assignment] = STATE(5191),
    [sym_conditional] = STATE(5191),
    [sym_range] = STATE(5191),
    [sym_binary] = STATE(5191),
    [sym_unary] = STATE(5191),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2619] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5192),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5192),
    [sym_operator_assignment] = STATE(5192),
    [sym_conditional] = STATE(5192),
    [sym_range] = STATE(5192),
    [sym_binary] = STATE(5192),
    [sym_unary] = STATE(5192),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2620] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5193),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5193),
    [sym_operator_assignment] = STATE(5193),
    [sym_conditional] = STATE(5193),
    [sym_range] = STATE(5193),
    [sym_binary] = STATE(5193),
    [sym_unary] = STATE(5193),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2621] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5194),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(5194),
    [sym_operator_assignment] = STATE(5194),
    [sym_conditional] = STATE(5194),
    [sym_range] = STATE(5194),
    [sym_binary] = STATE(5194),
    [sym_unary] = STATE(5194),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2622] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5195),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(5195),
    [sym_operator_assignment] = STATE(5195),
    [sym_conditional] = STATE(5195),
    [sym_range] = STATE(5195),
    [sym_binary] = STATE(5195),
    [sym_unary] = STATE(5195),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2623] = {
    [anon_sym_COLON] = ACTIONS(7842),
    [sym_comment] = ACTIONS(87),
  },
  [2624] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5197),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(5197),
    [sym_operator_assignment] = STATE(5197),
    [sym_conditional] = STATE(5197),
    [sym_range] = STATE(5197),
    [sym_binary] = STATE(5197),
    [sym_unary] = STATE(5197),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2625] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7844),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2626] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [2627] = {
    [sym_heredoc_body] = STATE(5199),
    [aux_sym_call_repeat1] = STATE(5199),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2628] = {
    [sym_heredoc_body] = STATE(5199),
    [aux_sym_call_repeat1] = STATE(5199),
    [aux_sym_argument_list_repeat1] = STATE(5201),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7846),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2629] = {
    [sym_string] = STATE(4661),
    [aux_sym_chained_string_repeat1] = STATE(4661),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7848),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2630] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [ts_builtin_sym_end] = ACTIONS(7850),
    [anon_sym___END__] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7850),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_end] = ACTIONS(7850),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_when] = ACTIONS(7850),
    [anon_sym_elsif] = ACTIONS(7850),
    [anon_sym_else] = ACTIONS(7850),
    [anon_sym_then] = ACTIONS(7850),
    [anon_sym_ensure] = ACTIONS(7850),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7850),
    [anon_sym_AMP_AMP] = ACTIONS(7850),
    [anon_sym_LT_LT] = ACTIONS(7850),
    [anon_sym_GT_GT] = ACTIONS(7850),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7850),
    [anon_sym_PLUS] = ACTIONS(7850),
    [anon_sym_SLASH] = ACTIONS(7850),
    [anon_sym_PERCENT] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
  },
  [2631] = {
    [anon_sym_RPAREN] = ACTIONS(7854),
    [sym_comment] = ACTIONS(87),
  },
  [2632] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(3646),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5203),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(5744),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(5746),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2633] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5205),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_splat_argument] = STATE(5206),
    [sym_assignment] = STATE(5205),
    [sym_operator_assignment] = STATE(5205),
    [sym_conditional] = STATE(5205),
    [sym_range] = STATE(5205),
    [sym_binary] = STATE(5205),
    [sym_unary] = STATE(5205),
    [sym_right_assignment_list] = STATE(3650),
    [sym__arg_or_splat_arg] = STATE(5206),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(7856),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2634] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5207),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(5207),
    [sym_operator_assignment] = STATE(5207),
    [sym_conditional] = STATE(5207),
    [sym_range] = STATE(5207),
    [sym_binary] = STATE(5207),
    [sym_unary] = STATE(5207),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2635] = {
    [sym_string] = STATE(5208),
    [aux_sym_chained_string_repeat1] = STATE(5208),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2636] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2637] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [2638] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2639] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [2640] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2641] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2642] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(6969),
    [anon_sym___END__] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [2643] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(7860),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [2644] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2645] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2646] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2647] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2648] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2649] = {
    [sym__line_break2] = ACTIONS(1273),
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [ts_builtin_sym_end] = ACTIONS(1273),
    [anon_sym___END__] = ACTIONS(1275),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_end] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_when] = ACTIONS(1275),
    [anon_sym_elsif] = ACTIONS(1275),
    [anon_sym_else] = ACTIONS(1275),
    [anon_sym_then] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_ensure] = ACTIONS(1275),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [2650] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(5211),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5212),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(7864),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2651] = {
    [sym__line_break2] = ACTIONS(5974),
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym__heredoc_body_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [ts_builtin_sym_end] = ACTIONS(5974),
    [anon_sym___END__] = ACTIONS(5976),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_end] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_rescue] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_when] = ACTIONS(5976),
    [anon_sym_elsif] = ACTIONS(5976),
    [anon_sym_else] = ACTIONS(5976),
    [anon_sym_then] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_ensure] = ACTIONS(5976),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [2652] = {
    [sym__line_break2] = ACTIONS(5978),
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym__heredoc_body_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [ts_builtin_sym_end] = ACTIONS(5978),
    [anon_sym___END__] = ACTIONS(5980),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_end] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_rescue] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_when] = ACTIONS(5980),
    [anon_sym_elsif] = ACTIONS(5980),
    [anon_sym_else] = ACTIONS(5980),
    [anon_sym_then] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_ensure] = ACTIONS(5980),
    [anon_sym_EQ_GT] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [2653] = {
    [sym_argument_list_with_parens] = STATE(5213),
    [sym__argument_list_with_parens] = STATE(2652),
    [sym_operator] = STATE(5213),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(4310),
    [anon_sym_STAR] = ACTIONS(4312),
    [anon_sym_STAR_STAR] = ACTIONS(4310),
    [anon_sym_AMP] = ACTIONS(4310),
    [anon_sym_LT] = ACTIONS(4312),
    [anon_sym_LPAREN2] = ACTIONS(4314),
    [anon_sym_DOT_DOT] = ACTIONS(4310),
    [anon_sym_LT_LT] = ACTIONS(4310),
    [anon_sym_GT_GT] = ACTIONS(4310),
    [anon_sym_EQ_EQ] = ACTIONS(4312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4310),
    [anon_sym_LT_EQ_GT] = ACTIONS(4310),
    [anon_sym_EQ_TILDE] = ACTIONS(4310),
    [anon_sym_BANG_TILDE] = ACTIONS(4310),
    [anon_sym_LT_EQ] = ACTIONS(4312),
    [anon_sym_GT] = ACTIONS(4312),
    [anon_sym_GT_EQ] = ACTIONS(4310),
    [anon_sym_CARET] = ACTIONS(4310),
    [anon_sym_PLUS] = ACTIONS(4312),
    [anon_sym_SLASH] = ACTIONS(4310),
    [anon_sym_PERCENT] = ACTIONS(4310),
    [anon_sym_BANG] = ACTIONS(4312),
    [anon_sym_TILDE] = ACTIONS(4310),
    [sym_constant] = ACTIONS(7866),
    [sym_identifier] = ACTIONS(7866),
    [anon_sym_DASH] = ACTIONS(4312),
    [anon_sym_PLUS_AT] = ACTIONS(4310),
    [anon_sym_DASH_AT] = ACTIONS(4310),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4312),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(4310),
    [anon_sym_BQUOTE] = ACTIONS(4310),
    [sym_comment] = ACTIONS(87),
  },
  [2654] = {
    [sym__line_break2] = ACTIONS(5984),
    [sym__heredoc_body_start2] = ACTIONS(5984),
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [ts_builtin_sym_end] = ACTIONS(5984),
    [anon_sym___END__] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_end] = ACTIONS(5984),
    [anon_sym_if] = ACTIONS(5984),
    [anon_sym_unless] = ACTIONS(5984),
    [anon_sym_while] = ACTIONS(5984),
    [anon_sym_until] = ACTIONS(5984),
    [anon_sym_rescue] = ACTIONS(5984),
    [anon_sym_do] = ACTIONS(5984),
    [anon_sym_when] = ACTIONS(5984),
    [anon_sym_elsif] = ACTIONS(5984),
    [anon_sym_else] = ACTIONS(5984),
    [anon_sym_then] = ACTIONS(5984),
    [anon_sym_ensure] = ACTIONS(5984),
    [anon_sym_EQ_GT] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [2655] = {
    [sym_heredoc_body] = STATE(5215),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(7868),
    [sym_comment] = ACTIONS(87),
  },
  [2656] = {
    [anon_sym_RBRACK] = ACTIONS(7868),
    [sym_comment] = ACTIONS(87),
  },
  [2657] = {
    [sym__line_break2] = ACTIONS(5990),
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym__heredoc_body_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [ts_builtin_sym_end] = ACTIONS(5990),
    [anon_sym___END__] = ACTIONS(5992),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_end] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_rescue] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_when] = ACTIONS(5992),
    [anon_sym_elsif] = ACTIONS(5992),
    [anon_sym_else] = ACTIONS(5992),
    [anon_sym_then] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_ensure] = ACTIONS(5992),
    [anon_sym_EQ_GT] = ACTIONS(5990),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [2658] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(4164),
    [anon_sym___END__] = ACTIONS(4164),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [2659] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(4204),
    [anon_sym___END__] = ACTIONS(4204),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [2660] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5216),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(5216),
    [sym_operator_assignment] = STATE(5216),
    [sym_conditional] = STATE(5216),
    [sym_range] = STATE(5216),
    [sym_binary] = STATE(5216),
    [sym_unary] = STATE(5216),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2661] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [2662] = {
    [anon_sym_RBRACE] = ACTIONS(7870),
    [sym_comment] = ACTIONS(87),
  },
  [2663] = {
    [sym__statements] = STATE(5218),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(7870),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2664] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(3204),
    [anon_sym___END__] = ACTIONS(3204),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [2665] = {
    [sym__line_break2] = ACTIONS(5786),
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [ts_builtin_sym_end] = ACTIONS(5786),
    [anon_sym___END__] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_end] = ACTIONS(5786),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_when] = ACTIONS(5786),
    [anon_sym_elsif] = ACTIONS(5786),
    [anon_sym_else] = ACTIONS(5786),
    [anon_sym_then] = ACTIONS(5786),
    [anon_sym_ensure] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [2666] = {
    [anon_sym_end] = ACTIONS(7872),
    [sym_comment] = ACTIONS(87),
  },
  [2667] = {
    [sym__statements] = STATE(5220),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(5221),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(5221),
    [sym__line_break2] = ACTIONS(7874),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7876),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2668] = {
    [sym__statements] = STATE(5220),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(5222),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(7876),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2669] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_end] = ACTIONS(4242),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_when] = ACTIONS(4242),
    [anon_sym_elsif] = ACTIONS(4242),
    [anon_sym_else] = ACTIONS(4242),
    [anon_sym_then] = ACTIONS(4242),
    [anon_sym_ensure] = ACTIONS(4242),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [sym_comment] = ACTIONS(87),
  },
  [2670] = {
    [sym_heredoc_body] = STATE(5224),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [2671] = {
    [anon_sym_RPAREN] = ACTIONS(7878),
    [sym_comment] = ACTIONS(87),
  },
  [2672] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5225),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(5225),
    [sym_operator_assignment] = STATE(5225),
    [sym_conditional] = STATE(5225),
    [sym_range] = STATE(5225),
    [sym_binary] = STATE(5225),
    [sym_unary] = STATE(5225),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2673] = {
    [sym__line_break2] = ACTIONS(6196),
    [sym__heredoc_body_start2] = ACTIONS(6196),
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [ts_builtin_sym_end] = ACTIONS(6196),
    [anon_sym___END__] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_end] = ACTIONS(6196),
    [anon_sym_if] = ACTIONS(6196),
    [anon_sym_unless] = ACTIONS(6196),
    [anon_sym_while] = ACTIONS(6196),
    [anon_sym_until] = ACTIONS(6196),
    [anon_sym_rescue] = ACTIONS(6196),
    [anon_sym_do] = ACTIONS(6196),
    [anon_sym_when] = ACTIONS(6196),
    [anon_sym_elsif] = ACTIONS(6196),
    [anon_sym_else] = ACTIONS(6196),
    [anon_sym_then] = ACTIONS(6196),
    [anon_sym_ensure] = ACTIONS(6196),
    [anon_sym_EQ_GT] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [2674] = {
    [sym_interpolation] = STATE(5227),
    [aux_sym_heredoc_body_repeat1] = STATE(5227),
    [sym__heredoc_content2] = ACTIONS(7880),
    [sym_heredoc_end2] = ACTIONS(7882),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(7880),
  },
  [2675] = {
    [sym_heredoc_body] = STATE(5228),
    [aux_sym_call_repeat1] = STATE(5228),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2676] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(5230),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7884),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2677] = {
    [sym_heredoc_body] = STATE(5231),
    [aux_sym_call_repeat1] = STATE(5231),
    [aux_sym_argument_list_repeat1] = STATE(5232),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4338),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2678] = {
    [sym__line_break2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [ts_builtin_sym_end] = ACTIONS(3158),
    [anon_sym___END__] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_end] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_when] = ACTIONS(3158),
    [anon_sym_elsif] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_then] = ACTIONS(3158),
    [anon_sym_ensure] = ACTIONS(3158),
    [anon_sym_EQ_GT] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [2679] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(7886),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [2680] = {
    [sym_heredoc_body] = STATE(2680),
    [aux_sym_call_repeat1] = STATE(2680),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [ts_builtin_sym_end] = ACTIONS(7888),
    [anon_sym___END__] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [2681] = {
    [sym_interpolation] = STATE(5235),
    [aux_sym_heredoc_body_repeat1] = STATE(5235),
    [sym__heredoc_content2] = ACTIONS(7895),
    [sym_heredoc_end2] = ACTIONS(7897),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(7895),
  },
  [2682] = {
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [2683] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(219),
    [sym_operator_assignment] = STATE(219),
    [sym_conditional] = STATE(219),
    [sym_range] = STATE(219),
    [sym_binary] = STATE(219),
    [sym_unary] = STATE(219),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(227),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(367),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__identifier_hash_key2] = ACTIONS(373),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(4352),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(401),
    [sym_identifier] = ACTIONS(401),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2684] = {
    [sym_heredoc_body] = STATE(2680),
    [aux_sym_call_repeat1] = STATE(2680),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [ts_builtin_sym_end] = ACTIONS(7903),
    [anon_sym___END__] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [2685] = {
    [aux_sym_argument_list_repeat1] = STATE(2685),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7907),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [2686] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(5104),
    [anon_sym___END__] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2687] = {
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2688] = {
    [aux_sym_exceptions_repeat1] = STATE(5238),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2689] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [2690] = {
    [sym_string] = STATE(2690),
    [aux_sym_chained_string_repeat1] = STATE(2690),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [ts_builtin_sym_end] = ACTIONS(6252),
    [anon_sym___END__] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2691] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5239),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(5239),
    [sym_operator_assignment] = STATE(5239),
    [sym_conditional] = STATE(5239),
    [sym_range] = STATE(5239),
    [sym_binary] = STATE(5239),
    [sym_unary] = STATE(5239),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2692] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5240),
    [sym__argument] = STATE(5241),
    [sym_splat_argument] = STATE(5241),
    [sym_hash_splat_argument] = STATE(5241),
    [sym_block_argument] = STATE(5241),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5241),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2693] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5240),
    [sym__argument] = STATE(5241),
    [sym_splat_argument] = STATE(5241),
    [sym_hash_splat_argument] = STATE(5241),
    [sym_block_argument] = STATE(5241),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5241),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2694] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5240),
    [sym__argument] = STATE(5241),
    [sym_splat_argument] = STATE(5241),
    [sym_hash_splat_argument] = STATE(5241),
    [sym_block_argument] = STATE(5241),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5241),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2695] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5240),
    [sym__argument] = STATE(5241),
    [sym_splat_argument] = STATE(5241),
    [sym_hash_splat_argument] = STATE(5241),
    [sym_block_argument] = STATE(5241),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5241),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1751),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2696] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5242),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(5242),
    [sym_operator_assignment] = STATE(5242),
    [sym_conditional] = STATE(5242),
    [sym_range] = STATE(5242),
    [sym_binary] = STATE(5242),
    [sym_unary] = STATE(5242),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2697] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5243),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(5243),
    [sym_operator_assignment] = STATE(5243),
    [sym_conditional] = STATE(5243),
    [sym_range] = STATE(5243),
    [sym_binary] = STATE(5243),
    [sym_unary] = STATE(5243),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2698] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2699] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [2700] = {
    [anon_sym_EQ] = ACTIONS(7944),
    [sym_comment] = ACTIONS(87),
  },
  [2701] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(7946),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(7948),
    [anon_sym_DASH_EQ] = ACTIONS(7948),
    [anon_sym_STAR_EQ] = ACTIONS(7948),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7948),
    [anon_sym_SLASH_EQ] = ACTIONS(7948),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7948),
    [anon_sym_PIPE_EQ] = ACTIONS(7948),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7948),
    [anon_sym_AMP_EQ] = ACTIONS(7948),
    [anon_sym_PERCENT_EQ] = ACTIONS(7948),
    [anon_sym_GT_GT_EQ] = ACTIONS(7948),
    [anon_sym_LT_LT_EQ] = ACTIONS(7948),
    [anon_sym_CARET_EQ] = ACTIONS(7948),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2702] = {
    [sym_string] = STATE(5258),
    [aux_sym_chained_string_repeat1] = STATE(5258),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2703] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [2704] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2705] = {
    [sym_string] = STATE(2746),
    [aux_sym_chained_string_repeat1] = STATE(2746),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2706] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5259),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(5259),
    [sym_operator_assignment] = STATE(5259),
    [sym_conditional] = STATE(5259),
    [sym_range] = STATE(5259),
    [sym_binary] = STATE(5259),
    [sym_unary] = STATE(5259),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2707] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [2708] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5260),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5260),
    [sym_operator_assignment] = STATE(5260),
    [sym_conditional] = STATE(5260),
    [sym_range] = STATE(5260),
    [sym_binary] = STATE(5260),
    [sym_unary] = STATE(5260),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2709] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5261),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5261),
    [sym_operator_assignment] = STATE(5261),
    [sym_conditional] = STATE(5261),
    [sym_range] = STATE(5261),
    [sym_binary] = STATE(5261),
    [sym_unary] = STATE(5261),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2710] = {
    [anon_sym_COLON] = ACTIONS(7950),
    [sym_comment] = ACTIONS(87),
  },
  [2711] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5263),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5263),
    [sym_operator_assignment] = STATE(5263),
    [sym_conditional] = STATE(5263),
    [sym_range] = STATE(5263),
    [sym_binary] = STATE(5263),
    [sym_unary] = STATE(5263),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2712] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7952),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2713] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [2714] = {
    [sym_heredoc_body] = STATE(5265),
    [aux_sym_call_repeat1] = STATE(5265),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2715] = {
    [sym_heredoc_body] = STATE(5265),
    [aux_sym_call_repeat1] = STATE(5265),
    [aux_sym_argument_list_repeat1] = STATE(5267),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7954),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2716] = {
    [sym_string] = STATE(2746),
    [aux_sym_chained_string_repeat1] = STATE(2746),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7956),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2717] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2718] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [2719] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5268),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5268),
    [sym_operator_assignment] = STATE(5268),
    [sym_conditional] = STATE(5268),
    [sym_range] = STATE(5268),
    [sym_binary] = STATE(5268),
    [sym_unary] = STATE(5268),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2720] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5269),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5269),
    [sym_operator_assignment] = STATE(5269),
    [sym_conditional] = STATE(5269),
    [sym_range] = STATE(5269),
    [sym_binary] = STATE(5269),
    [sym_unary] = STATE(5269),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2721] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5270),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5270),
    [sym_operator_assignment] = STATE(5270),
    [sym_conditional] = STATE(5270),
    [sym_range] = STATE(5270),
    [sym_binary] = STATE(5270),
    [sym_unary] = STATE(5270),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2722] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5271),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5271),
    [sym_operator_assignment] = STATE(5271),
    [sym_conditional] = STATE(5271),
    [sym_range] = STATE(5271),
    [sym_binary] = STATE(5271),
    [sym_unary] = STATE(5271),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2723] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5272),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5272),
    [sym_operator_assignment] = STATE(5272),
    [sym_conditional] = STATE(5272),
    [sym_range] = STATE(5272),
    [sym_binary] = STATE(5272),
    [sym_unary] = STATE(5272),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2724] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5273),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5273),
    [sym_operator_assignment] = STATE(5273),
    [sym_conditional] = STATE(5273),
    [sym_range] = STATE(5273),
    [sym_binary] = STATE(5273),
    [sym_unary] = STATE(5273),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2725] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5274),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(5274),
    [sym_operator_assignment] = STATE(5274),
    [sym_conditional] = STATE(5274),
    [sym_range] = STATE(5274),
    [sym_binary] = STATE(5274),
    [sym_unary] = STATE(5274),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2726] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5275),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5275),
    [sym_operator_assignment] = STATE(5275),
    [sym_conditional] = STATE(5275),
    [sym_range] = STATE(5275),
    [sym_binary] = STATE(5275),
    [sym_unary] = STATE(5275),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2727] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5276),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5276),
    [sym_operator_assignment] = STATE(5276),
    [sym_conditional] = STATE(5276),
    [sym_range] = STATE(5276),
    [sym_binary] = STATE(5276),
    [sym_unary] = STATE(5276),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2728] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5277),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5277),
    [sym_operator_assignment] = STATE(5277),
    [sym_conditional] = STATE(5277),
    [sym_range] = STATE(5277),
    [sym_binary] = STATE(5277),
    [sym_unary] = STATE(5277),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2729] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5278),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5278),
    [sym_operator_assignment] = STATE(5278),
    [sym_conditional] = STATE(5278),
    [sym_range] = STATE(5278),
    [sym_binary] = STATE(5278),
    [sym_unary] = STATE(5278),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2730] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5279),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5279),
    [sym_operator_assignment] = STATE(5279),
    [sym_conditional] = STATE(5279),
    [sym_range] = STATE(5279),
    [sym_binary] = STATE(5279),
    [sym_unary] = STATE(5279),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2731] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5280),
    [sym_operator_assignment] = STATE(5280),
    [sym_conditional] = STATE(5280),
    [sym_range] = STATE(5280),
    [sym_binary] = STATE(5280),
    [sym_unary] = STATE(5280),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2732] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5281),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5281),
    [sym_operator_assignment] = STATE(5281),
    [sym_conditional] = STATE(5281),
    [sym_range] = STATE(5281),
    [sym_binary] = STATE(5281),
    [sym_unary] = STATE(5281),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2733] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5282),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5282),
    [sym_operator_assignment] = STATE(5282),
    [sym_conditional] = STATE(5282),
    [sym_range] = STATE(5282),
    [sym_binary] = STATE(5282),
    [sym_unary] = STATE(5282),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2734] = {
    [anon_sym_COLON] = ACTIONS(7958),
    [sym_comment] = ACTIONS(87),
  },
  [2735] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5284),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5284),
    [sym_operator_assignment] = STATE(5284),
    [sym_conditional] = STATE(5284),
    [sym_range] = STATE(5284),
    [sym_binary] = STATE(5284),
    [sym_unary] = STATE(5284),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2736] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(7960),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2737] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [2738] = {
    [sym_heredoc_body] = STATE(5286),
    [aux_sym_call_repeat1] = STATE(5286),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2739] = {
    [sym_heredoc_body] = STATE(5286),
    [aux_sym_call_repeat1] = STATE(5286),
    [aux_sym_argument_list_repeat1] = STATE(5288),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7962),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2740] = {
    [sym_string] = STATE(2828),
    [aux_sym_chained_string_repeat1] = STATE(2828),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(7964),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2741] = {
    [sym_heredoc_body] = STATE(5289),
    [aux_sym_call_repeat1] = STATE(5289),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2742] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(5290),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7966),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2743] = {
    [sym_heredoc_body] = STATE(5291),
    [aux_sym_call_repeat1] = STATE(5291),
    [aux_sym_argument_list_repeat1] = STATE(5292),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2744] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5293),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_splat_argument] = STATE(5294),
    [sym_assignment] = STATE(5293),
    [sym_operator_assignment] = STATE(5293),
    [sym_conditional] = STATE(5293),
    [sym_range] = STATE(5293),
    [sym_binary] = STATE(5293),
    [sym_unary] = STATE(5293),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(5294),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2745] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5295),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(5295),
    [sym_operator_assignment] = STATE(5295),
    [sym_conditional] = STATE(5295),
    [sym_range] = STATE(5295),
    [sym_binary] = STATE(5295),
    [sym_unary] = STATE(5295),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2746] = {
    [sym_string] = STATE(5296),
    [aux_sym_chained_string_repeat1] = STATE(5296),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2747] = {
    [aux_sym_undef_repeat1] = STATE(5297),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_then] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [2748] = {
    [sym__line_break2] = ACTIONS(3158),
    [sym__simple_symbol2] = ACTIONS(3158),
    [sym__string_start2] = ACTIONS(3158),
    [sym__symbol_start2] = ACTIONS(3158),
    [sym__subshell_start2] = ACTIONS(3158),
    [sym__regex_start2] = ACTIONS(3158),
    [sym__string_array_start2] = ACTIONS(3158),
    [sym__symbol_array_start2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym_heredoc_beginning2] = ACTIONS(3158),
    [sym__unary_minus2] = ACTIONS(3158),
    [anon_sym_BEGIN] = ACTIONS(4982),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_END] = ACTIONS(4982),
    [anon_sym_def] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(4982),
    [anon_sym_end] = ACTIONS(4982),
    [anon_sym_return] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_break] = ACTIONS(4982),
    [anon_sym_next] = ACTIONS(4982),
    [sym_redo] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(4982),
    [anon_sym_unless] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(4982),
    [anon_sym_until] = ACTIONS(4982),
    [anon_sym_for] = ACTIONS(4982),
    [anon_sym_case] = ACTIONS(4982),
    [anon_sym_elsif] = ACTIONS(4982),
    [anon_sym_else] = ACTIONS(4982),
    [anon_sym_then] = ACTIONS(4982),
    [anon_sym_begin] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_defined_QMARK] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(4982),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4982),
    [sym_instance_variable] = ACTIONS(3158),
    [sym_class_variable] = ACTIONS(3158),
    [sym_global_variable] = ACTIONS(3158),
    [anon_sym_undef] = ACTIONS(4982),
    [anon_sym_alias] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4982),
    [sym_float] = ACTIONS(4982),
    [sym_complex] = ACTIONS(3158),
    [sym_super] = ACTIONS(4982),
    [anon_sym_true] = ACTIONS(4982),
    [anon_sym_TRUE] = ACTIONS(4982),
    [anon_sym_false] = ACTIONS(4982),
    [anon_sym_FALSE] = ACTIONS(4982),
    [sym_self] = ACTIONS(4982),
    [anon_sym_nil] = ACTIONS(4982),
    [anon_sym_NIL] = ACTIONS(4982),
    [sym_character] = ACTIONS(3158),
    [anon_sym_LBRACK2] = ACTIONS(3158),
    [anon_sym_DASH_GT] = ACTIONS(3158),
  },
  [2749] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(7968),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [2750] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_then] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2751] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_then] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2752] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_then] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2753] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_then] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2754] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_then] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(1797),
    [anon_sym_or] = ACTIONS(1797),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2755] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5299),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(5299),
    [sym_operator_assignment] = STATE(5299),
    [sym_conditional] = STATE(5299),
    [sym_range] = STATE(5299),
    [sym_binary] = STATE(5299),
    [sym_unary] = STATE(5299),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2756] = {
    [sym__line_break2] = ACTIONS(7970),
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [ts_builtin_sym_end] = ACTIONS(7970),
    [anon_sym___END__] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7970),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_end] = ACTIONS(7970),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_when] = ACTIONS(7970),
    [anon_sym_elsif] = ACTIONS(7970),
    [anon_sym_else] = ACTIONS(7970),
    [anon_sym_then] = ACTIONS(7970),
    [anon_sym_ensure] = ACTIONS(7970),
    [anon_sym_EQ_GT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7970),
    [anon_sym_AMP_AMP] = ACTIONS(7970),
    [anon_sym_LT_LT] = ACTIONS(7970),
    [anon_sym_GT_GT] = ACTIONS(7970),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7970),
    [anon_sym_PLUS] = ACTIONS(7970),
    [anon_sym_SLASH] = ACTIONS(7970),
    [anon_sym_PERCENT] = ACTIONS(7970),
    [sym_comment] = ACTIONS(87),
  },
  [2757] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5315),
    [sym__argument] = STATE(5316),
    [sym_splat_argument] = STATE(5316),
    [sym_hash_splat_argument] = STATE(5316),
    [sym_block_argument] = STATE(5316),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5316),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2758] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5315),
    [sym__argument] = STATE(5316),
    [sym_splat_argument] = STATE(5316),
    [sym_hash_splat_argument] = STATE(5316),
    [sym_block_argument] = STATE(5316),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5316),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2759] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5315),
    [sym__argument] = STATE(5316),
    [sym_splat_argument] = STATE(5316),
    [sym_hash_splat_argument] = STATE(5316),
    [sym_block_argument] = STATE(5316),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5316),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2760] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5315),
    [sym__argument] = STATE(5316),
    [sym_splat_argument] = STATE(5316),
    [sym_hash_splat_argument] = STATE(5316),
    [sym_block_argument] = STATE(5316),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5316),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2761] = {
    [sym__statement] = STATE(5320),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2762] = {
    [sym__statements] = STATE(1235),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(5321),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(5321),
    [sym__line_break2] = ACTIONS(8004),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2147),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2763] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5322),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(5322),
    [sym_operator_assignment] = STATE(5322),
    [sym_conditional] = STATE(5322),
    [sym_range] = STATE(5322),
    [sym_binary] = STATE(5322),
    [sym_unary] = STATE(5322),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2764] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5323),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(5323),
    [sym_operator_assignment] = STATE(5323),
    [sym_conditional] = STATE(5323),
    [sym_range] = STATE(5323),
    [sym_binary] = STATE(5323),
    [sym_unary] = STATE(5323),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2765] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2766] = {
    [sym_operator] = STATE(5324),
    [sym__method_name] = STATE(5324),
    [sym_setter] = STATE(5324),
    [sym_symbol] = STATE(5324),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(8006),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(8006),
    [sym_class_variable] = ACTIONS(8006),
    [sym_global_variable] = ACTIONS(8006),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2767] = {
    [sym_elsif] = STATE(5326),
    [sym_else] = STATE(5326),
    [sym__if_tail] = STATE(5326),
    [anon_sym_end] = ACTIONS(8008),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [2768] = {
    [sym_heredoc_body] = STATE(5327),
    [sym__terminator] = STATE(5327),
    [aux_sym__statements_repeat1] = STATE(5328),
    [sym__line_break2] = ACTIONS(8014),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(8014),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_elsif] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2769] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(8016),
    [anon_sym_unless] = ACTIONS(8018),
    [anon_sym_while] = ACTIONS(8020),
    [anon_sym_until] = ACTIONS(8022),
    [anon_sym_rescue] = ACTIONS(8024),
    [anon_sym_elsif] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [2770] = {
    [anon_sym_end] = ACTIONS(8008),
    [sym_comment] = ACTIONS(87),
  },
  [2771] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_elsif] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [2772] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2773] = {
    [anon_sym_EQ] = ACTIONS(8088),
    [sym_comment] = ACTIONS(87),
  },
  [2774] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8090),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8092),
    [anon_sym_DASH_EQ] = ACTIONS(8092),
    [anon_sym_STAR_EQ] = ACTIONS(8092),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8092),
    [anon_sym_SLASH_EQ] = ACTIONS(8092),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8092),
    [anon_sym_PIPE_EQ] = ACTIONS(8092),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8092),
    [anon_sym_AMP_EQ] = ACTIONS(8092),
    [anon_sym_PERCENT_EQ] = ACTIONS(8092),
    [anon_sym_GT_GT_EQ] = ACTIONS(8092),
    [anon_sym_LT_LT_EQ] = ACTIONS(8092),
    [anon_sym_CARET_EQ] = ACTIONS(8092),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2775] = {
    [sym_string] = STATE(5368),
    [aux_sym_chained_string_repeat1] = STATE(5368),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2776] = {
    [sym__statements] = STATE(5369),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(5326),
    [sym_else] = STATE(5326),
    [sym__if_tail] = STATE(5326),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8094),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2777] = {
    [sym__line_break2] = ACTIONS(8096),
    [sym__simple_symbol2] = ACTIONS(8096),
    [sym__string_start2] = ACTIONS(8096),
    [sym__symbol_start2] = ACTIONS(8096),
    [sym__subshell_start2] = ACTIONS(8096),
    [sym__regex_start2] = ACTIONS(8096),
    [sym__string_array_start2] = ACTIONS(8096),
    [sym__symbol_array_start2] = ACTIONS(8096),
    [sym__heredoc_body_start2] = ACTIONS(8096),
    [sym_heredoc_beginning2] = ACTIONS(8096),
    [sym__unary_minus2] = ACTIONS(8096),
    [anon_sym_BEGIN] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8096),
    [anon_sym_END] = ACTIONS(8098),
    [anon_sym_def] = ACTIONS(8098),
    [anon_sym_LPAREN] = ACTIONS(8096),
    [anon_sym_COLON_COLON] = ACTIONS(8096),
    [anon_sym_SEMI] = ACTIONS(8096),
    [anon_sym_STAR] = ACTIONS(8096),
    [anon_sym_class] = ACTIONS(8098),
    [anon_sym_module] = ACTIONS(8098),
    [anon_sym_end] = ACTIONS(8098),
    [anon_sym_return] = ACTIONS(8098),
    [anon_sym_yield] = ACTIONS(8098),
    [anon_sym_break] = ACTIONS(8098),
    [anon_sym_next] = ACTIONS(8098),
    [sym_redo] = ACTIONS(8098),
    [sym_retry] = ACTIONS(8098),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_for] = ACTIONS(8098),
    [anon_sym_case] = ACTIONS(8098),
    [anon_sym_elsif] = ACTIONS(8098),
    [anon_sym_else] = ACTIONS(8098),
    [anon_sym_begin] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_defined_QMARK] = ACTIONS(8096),
    [anon_sym_not] = ACTIONS(8098),
    [anon_sym_BANG] = ACTIONS(8096),
    [anon_sym_TILDE] = ACTIONS(8096),
    [sym_constant] = ACTIONS(8098),
    [sym_identifier] = ACTIONS(8098),
    [sym_instance_variable] = ACTIONS(8096),
    [sym_class_variable] = ACTIONS(8096),
    [sym_global_variable] = ACTIONS(8096),
    [anon_sym_undef] = ACTIONS(8098),
    [anon_sym_alias] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8098),
    [sym_float] = ACTIONS(8098),
    [sym_complex] = ACTIONS(8096),
    [sym_super] = ACTIONS(8098),
    [anon_sym_true] = ACTIONS(8098),
    [anon_sym_TRUE] = ACTIONS(8098),
    [anon_sym_false] = ACTIONS(8098),
    [anon_sym_FALSE] = ACTIONS(8098),
    [sym_self] = ACTIONS(8098),
    [anon_sym_nil] = ACTIONS(8098),
    [anon_sym_NIL] = ACTIONS(8098),
    [sym_character] = ACTIONS(8096),
    [anon_sym_LBRACK2] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(8096),
  },
  [2778] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2779] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [2780] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2781] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [2782] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2783] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2784] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(8100),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [2785] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2786] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2787] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2788] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2789] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2790] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5371),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(5371),
    [sym_operator_assignment] = STATE(5371),
    [sym_conditional] = STATE(5371),
    [sym_range] = STATE(5371),
    [sym_binary] = STATE(5371),
    [sym_unary] = STATE(5371),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2791] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2792] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2793] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2794] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2795] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5372),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(5372),
    [sym_operator_assignment] = STATE(5372),
    [sym_conditional] = STATE(5372),
    [sym_range] = STATE(5372),
    [sym_binary] = STATE(5372),
    [sym_unary] = STATE(5372),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2796] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5373),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(5373),
    [sym_operator_assignment] = STATE(5373),
    [sym_conditional] = STATE(5373),
    [sym_range] = STATE(5373),
    [sym_binary] = STATE(5373),
    [sym_unary] = STATE(5373),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2797] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2798] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [2799] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(1046),
    [sym__argument] = STATE(1047),
    [sym_splat_argument] = STATE(1047),
    [sym_hash_splat_argument] = STATE(1047),
    [sym_block_argument] = STATE(1047),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1047),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1831),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2800] = {
    [anon_sym_EQ] = ACTIONS(8130),
    [sym_comment] = ACTIONS(87),
  },
  [2801] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8132),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8134),
    [anon_sym_DASH_EQ] = ACTIONS(8134),
    [anon_sym_STAR_EQ] = ACTIONS(8134),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8134),
    [anon_sym_SLASH_EQ] = ACTIONS(8134),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8134),
    [anon_sym_PIPE_EQ] = ACTIONS(8134),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8134),
    [anon_sym_AMP_EQ] = ACTIONS(8134),
    [anon_sym_PERCENT_EQ] = ACTIONS(8134),
    [anon_sym_GT_GT_EQ] = ACTIONS(8134),
    [anon_sym_LT_LT_EQ] = ACTIONS(8134),
    [anon_sym_CARET_EQ] = ACTIONS(8134),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2802] = {
    [sym_string] = STATE(5388),
    [aux_sym_chained_string_repeat1] = STATE(5388),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2803] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [2804] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [2805] = {
    [sym_string] = STATE(2828),
    [aux_sym_chained_string_repeat1] = STATE(2828),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2806] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5389),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(5389),
    [sym_operator_assignment] = STATE(5389),
    [sym_conditional] = STATE(5389),
    [sym_range] = STATE(5389),
    [sym_binary] = STATE(5389),
    [sym_unary] = STATE(5389),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2807] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [2808] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [2809] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [2810] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5390),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5390),
    [sym_operator_assignment] = STATE(5390),
    [sym_conditional] = STATE(5390),
    [sym_range] = STATE(5390),
    [sym_binary] = STATE(5390),
    [sym_unary] = STATE(5390),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2811] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5391),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5391),
    [sym_operator_assignment] = STATE(5391),
    [sym_conditional] = STATE(5391),
    [sym_range] = STATE(5391),
    [sym_binary] = STATE(5391),
    [sym_unary] = STATE(5391),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2812] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5392),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5392),
    [sym_operator_assignment] = STATE(5392),
    [sym_conditional] = STATE(5392),
    [sym_range] = STATE(5392),
    [sym_binary] = STATE(5392),
    [sym_unary] = STATE(5392),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2813] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5393),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5393),
    [sym_operator_assignment] = STATE(5393),
    [sym_conditional] = STATE(5393),
    [sym_range] = STATE(5393),
    [sym_binary] = STATE(5393),
    [sym_unary] = STATE(5393),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2814] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5394),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5394),
    [sym_operator_assignment] = STATE(5394),
    [sym_conditional] = STATE(5394),
    [sym_range] = STATE(5394),
    [sym_binary] = STATE(5394),
    [sym_unary] = STATE(5394),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2815] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5395),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5395),
    [sym_operator_assignment] = STATE(5395),
    [sym_conditional] = STATE(5395),
    [sym_range] = STATE(5395),
    [sym_binary] = STATE(5395),
    [sym_unary] = STATE(5395),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2816] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5396),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(5396),
    [sym_operator_assignment] = STATE(5396),
    [sym_conditional] = STATE(5396),
    [sym_range] = STATE(5396),
    [sym_binary] = STATE(5396),
    [sym_unary] = STATE(5396),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2817] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5397),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5397),
    [sym_operator_assignment] = STATE(5397),
    [sym_conditional] = STATE(5397),
    [sym_range] = STATE(5397),
    [sym_binary] = STATE(5397),
    [sym_unary] = STATE(5397),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2818] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5398),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5398),
    [sym_operator_assignment] = STATE(5398),
    [sym_conditional] = STATE(5398),
    [sym_range] = STATE(5398),
    [sym_binary] = STATE(5398),
    [sym_unary] = STATE(5398),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2819] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5399),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5399),
    [sym_operator_assignment] = STATE(5399),
    [sym_conditional] = STATE(5399),
    [sym_range] = STATE(5399),
    [sym_binary] = STATE(5399),
    [sym_unary] = STATE(5399),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2820] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5400),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5400),
    [sym_operator_assignment] = STATE(5400),
    [sym_conditional] = STATE(5400),
    [sym_range] = STATE(5400),
    [sym_binary] = STATE(5400),
    [sym_unary] = STATE(5400),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2821] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5401),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5401),
    [sym_operator_assignment] = STATE(5401),
    [sym_conditional] = STATE(5401),
    [sym_range] = STATE(5401),
    [sym_binary] = STATE(5401),
    [sym_unary] = STATE(5401),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2822] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5402),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5402),
    [sym_operator_assignment] = STATE(5402),
    [sym_conditional] = STATE(5402),
    [sym_range] = STATE(5402),
    [sym_binary] = STATE(5402),
    [sym_unary] = STATE(5402),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2823] = {
    [sym_heredoc_body] = STATE(5403),
    [aux_sym_call_repeat1] = STATE(5403),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2824] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(5404),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8136),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2825] = {
    [sym_heredoc_body] = STATE(5405),
    [aux_sym_call_repeat1] = STATE(5405),
    [aux_sym_argument_list_repeat1] = STATE(5406),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4536),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2826] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5407),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_splat_argument] = STATE(5408),
    [sym_assignment] = STATE(5407),
    [sym_operator_assignment] = STATE(5407),
    [sym_conditional] = STATE(5407),
    [sym_range] = STATE(5407),
    [sym_binary] = STATE(5407),
    [sym_unary] = STATE(5407),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(5408),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2827] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5409),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(5409),
    [sym_operator_assignment] = STATE(5409),
    [sym_conditional] = STATE(5409),
    [sym_range] = STATE(5409),
    [sym_binary] = STATE(5409),
    [sym_unary] = STATE(5409),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2828] = {
    [sym_string] = STATE(5410),
    [aux_sym_chained_string_repeat1] = STATE(5410),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [2829] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5411),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(5411),
    [sym_operator_assignment] = STATE(5411),
    [sym_conditional] = STATE(5411),
    [sym_range] = STATE(5411),
    [sym_binary] = STATE(5411),
    [sym_unary] = STATE(5411),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2830] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5412),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(5412),
    [sym_operator_assignment] = STATE(5412),
    [sym_conditional] = STATE(5412),
    [sym_range] = STATE(5412),
    [sym_binary] = STATE(5412),
    [sym_unary] = STATE(5412),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2831] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5413),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(5413),
    [sym_operator_assignment] = STATE(5413),
    [sym_conditional] = STATE(5413),
    [sym_range] = STATE(5413),
    [sym_binary] = STATE(5413),
    [sym_unary] = STATE(5413),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2832] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5414),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(5414),
    [sym_operator_assignment] = STATE(5414),
    [sym_conditional] = STATE(5414),
    [sym_range] = STATE(5414),
    [sym_binary] = STATE(5414),
    [sym_unary] = STATE(5414),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2833] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2834] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [2835] = {
    [aux_sym_exceptions_repeat1] = STATE(5428),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2836] = {
    [anon_sym_EQ] = ACTIONS(8170),
    [sym_comment] = ACTIONS(87),
  },
  [2837] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8172),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8174),
    [anon_sym_DASH_EQ] = ACTIONS(8174),
    [anon_sym_STAR_EQ] = ACTIONS(8174),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8174),
    [anon_sym_SLASH_EQ] = ACTIONS(8174),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8174),
    [anon_sym_PIPE_EQ] = ACTIONS(8174),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8174),
    [anon_sym_AMP_EQ] = ACTIONS(8174),
    [anon_sym_PERCENT_EQ] = ACTIONS(8174),
    [anon_sym_GT_GT_EQ] = ACTIONS(8174),
    [anon_sym_LT_LT_EQ] = ACTIONS(8174),
    [anon_sym_CARET_EQ] = ACTIONS(8174),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2838] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [2839] = {
    [sym_string] = STATE(2839),
    [aux_sym_chained_string_repeat1] = STATE(2839),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2840] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5431),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(5431),
    [sym_operator_assignment] = STATE(5431),
    [sym_conditional] = STATE(5431),
    [sym_range] = STATE(5431),
    [sym_binary] = STATE(5431),
    [sym_unary] = STATE(5431),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2841] = {
    [sym__line_break2] = ACTIONS(8176),
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [ts_builtin_sym_end] = ACTIONS(8176),
    [anon_sym___END__] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8176),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_end] = ACTIONS(8176),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_when] = ACTIONS(8176),
    [anon_sym_elsif] = ACTIONS(8176),
    [anon_sym_else] = ACTIONS(8176),
    [anon_sym_then] = ACTIONS(8176),
    [anon_sym_ensure] = ACTIONS(8176),
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8176),
    [anon_sym_AMP_AMP] = ACTIONS(8176),
    [anon_sym_LT_LT] = ACTIONS(8176),
    [anon_sym_GT_GT] = ACTIONS(8176),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8176),
    [anon_sym_PLUS] = ACTIONS(8176),
    [anon_sym_SLASH] = ACTIONS(8176),
    [anon_sym_PERCENT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(87),
  },
  [2842] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5447),
    [sym__argument] = STATE(5448),
    [sym_splat_argument] = STATE(5448),
    [sym_hash_splat_argument] = STATE(5448),
    [sym_block_argument] = STATE(5448),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5448),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2843] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5447),
    [sym__argument] = STATE(5448),
    [sym_splat_argument] = STATE(5448),
    [sym_hash_splat_argument] = STATE(5448),
    [sym_block_argument] = STATE(5448),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5448),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2844] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5447),
    [sym__argument] = STATE(5448),
    [sym_splat_argument] = STATE(5448),
    [sym_hash_splat_argument] = STATE(5448),
    [sym_block_argument] = STATE(5448),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5448),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2845] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5447),
    [sym__argument] = STATE(5448),
    [sym_splat_argument] = STATE(5448),
    [sym_hash_splat_argument] = STATE(5448),
    [sym_block_argument] = STATE(5448),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5448),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2846] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5452),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(5452),
    [sym_operator_assignment] = STATE(5452),
    [sym_conditional] = STATE(5452),
    [sym_range] = STATE(5452),
    [sym_binary] = STATE(5452),
    [sym_unary] = STATE(5452),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2847] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5453),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(5453),
    [sym_operator_assignment] = STATE(5453),
    [sym_conditional] = STATE(5453),
    [sym_range] = STATE(5453),
    [sym_binary] = STATE(5453),
    [sym_unary] = STATE(5453),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2848] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2849] = {
    [sym_operator] = STATE(5454),
    [sym__method_name] = STATE(5454),
    [sym_setter] = STATE(5454),
    [sym_symbol] = STATE(5454),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(8210),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(8210),
    [sym_class_variable] = ACTIONS(8210),
    [sym_global_variable] = ACTIONS(8210),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [2850] = {
    [sym_else] = STATE(5456),
    [anon_sym_end] = ACTIONS(8212),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [2851] = {
    [sym_heredoc_body] = STATE(5457),
    [sym__terminator] = STATE(5457),
    [aux_sym__statements_repeat1] = STATE(5458),
    [sym__line_break2] = ACTIONS(8214),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(8214),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [2852] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(8216),
    [anon_sym_unless] = ACTIONS(8218),
    [anon_sym_while] = ACTIONS(8220),
    [anon_sym_until] = ACTIONS(8222),
    [anon_sym_rescue] = ACTIONS(8224),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [2853] = {
    [anon_sym_end] = ACTIONS(8212),
    [sym_comment] = ACTIONS(87),
  },
  [2854] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [2855] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2856] = {
    [anon_sym_EQ] = ACTIONS(8288),
    [sym_comment] = ACTIONS(87),
  },
  [2857] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8290),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8292),
    [anon_sym_DASH_EQ] = ACTIONS(8292),
    [anon_sym_STAR_EQ] = ACTIONS(8292),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8292),
    [anon_sym_SLASH_EQ] = ACTIONS(8292),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8292),
    [anon_sym_PIPE_EQ] = ACTIONS(8292),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8292),
    [anon_sym_AMP_EQ] = ACTIONS(8292),
    [anon_sym_PERCENT_EQ] = ACTIONS(8292),
    [anon_sym_GT_GT_EQ] = ACTIONS(8292),
    [anon_sym_LT_LT_EQ] = ACTIONS(8292),
    [anon_sym_CARET_EQ] = ACTIONS(8292),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2858] = {
    [sym_string] = STATE(5498),
    [aux_sym_chained_string_repeat1] = STATE(5498),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2859] = {
    [sym__simple_symbol2] = ACTIONS(8096),
    [sym__string_start2] = ACTIONS(8096),
    [sym__symbol_start2] = ACTIONS(8096),
    [sym__subshell_start2] = ACTIONS(8096),
    [sym__regex_start2] = ACTIONS(8096),
    [sym__string_array_start2] = ACTIONS(8096),
    [sym__symbol_array_start2] = ACTIONS(8096),
    [sym_heredoc_beginning2] = ACTIONS(8096),
    [sym__unary_minus2] = ACTIONS(8096),
    [anon_sym_BEGIN] = ACTIONS(8098),
    [anon_sym_LBRACE] = ACTIONS(8096),
    [anon_sym_END] = ACTIONS(8098),
    [anon_sym_def] = ACTIONS(8098),
    [anon_sym_LPAREN] = ACTIONS(8096),
    [anon_sym_COLON_COLON] = ACTIONS(8096),
    [anon_sym_SEMI] = ACTIONS(8096),
    [anon_sym_STAR] = ACTIONS(8096),
    [anon_sym_class] = ACTIONS(8098),
    [anon_sym_module] = ACTIONS(8098),
    [anon_sym_end] = ACTIONS(8098),
    [anon_sym_return] = ACTIONS(8098),
    [anon_sym_yield] = ACTIONS(8098),
    [anon_sym_break] = ACTIONS(8098),
    [anon_sym_next] = ACTIONS(8098),
    [sym_redo] = ACTIONS(8098),
    [sym_retry] = ACTIONS(8098),
    [anon_sym_if] = ACTIONS(8098),
    [anon_sym_unless] = ACTIONS(8098),
    [anon_sym_while] = ACTIONS(8098),
    [anon_sym_until] = ACTIONS(8098),
    [anon_sym_rescue] = ACTIONS(8098),
    [anon_sym_for] = ACTIONS(8098),
    [anon_sym_case] = ACTIONS(8098),
    [anon_sym_when] = ACTIONS(8098),
    [anon_sym_elsif] = ACTIONS(8098),
    [anon_sym_else] = ACTIONS(8098),
    [anon_sym_begin] = ACTIONS(8098),
    [anon_sym_ensure] = ACTIONS(8098),
    [anon_sym_PLUS] = ACTIONS(8098),
    [anon_sym_defined_QMARK] = ACTIONS(8096),
    [anon_sym_not] = ACTIONS(8098),
    [anon_sym_BANG] = ACTIONS(8096),
    [anon_sym_TILDE] = ACTIONS(8096),
    [sym_constant] = ACTIONS(8098),
    [sym_identifier] = ACTIONS(8098),
    [sym_instance_variable] = ACTIONS(8096),
    [sym_class_variable] = ACTIONS(8096),
    [sym_global_variable] = ACTIONS(8096),
    [anon_sym_undef] = ACTIONS(8098),
    [anon_sym_alias] = ACTIONS(8098),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8098),
    [sym_float] = ACTIONS(8098),
    [sym_complex] = ACTIONS(8096),
    [sym_super] = ACTIONS(8098),
    [anon_sym_true] = ACTIONS(8098),
    [anon_sym_TRUE] = ACTIONS(8098),
    [anon_sym_false] = ACTIONS(8098),
    [anon_sym_FALSE] = ACTIONS(8098),
    [sym_self] = ACTIONS(8098),
    [anon_sym_nil] = ACTIONS(8098),
    [anon_sym_NIL] = ACTIONS(8098),
    [sym_character] = ACTIONS(8096),
    [anon_sym_LBRACK2] = ACTIONS(8096),
    [anon_sym_DASH_GT] = ACTIONS(8096),
  },
  [2860] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5499),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(5499),
    [sym_operator_assignment] = STATE(5499),
    [sym_conditional] = STATE(5499),
    [sym_range] = STATE(5499),
    [sym_binary] = STATE(5499),
    [sym_unary] = STATE(5499),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2861] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5500),
    [sym__argument] = STATE(5501),
    [sym_splat_argument] = STATE(5501),
    [sym_hash_splat_argument] = STATE(5501),
    [sym_block_argument] = STATE(5501),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5501),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2862] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5500),
    [sym__argument] = STATE(5501),
    [sym_splat_argument] = STATE(5501),
    [sym_hash_splat_argument] = STATE(5501),
    [sym_block_argument] = STATE(5501),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5501),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2863] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5500),
    [sym__argument] = STATE(5501),
    [sym_splat_argument] = STATE(5501),
    [sym_hash_splat_argument] = STATE(5501),
    [sym_block_argument] = STATE(5501),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5501),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2864] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5500),
    [sym__argument] = STATE(5501),
    [sym_splat_argument] = STATE(5501),
    [sym_hash_splat_argument] = STATE(5501),
    [sym_block_argument] = STATE(5501),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5501),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1871),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2865] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5502),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(5502),
    [sym_operator_assignment] = STATE(5502),
    [sym_conditional] = STATE(5502),
    [sym_range] = STATE(5502),
    [sym_binary] = STATE(5502),
    [sym_unary] = STATE(5502),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2866] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5503),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(5503),
    [sym_operator_assignment] = STATE(5503),
    [sym_conditional] = STATE(5503),
    [sym_range] = STATE(5503),
    [sym_binary] = STATE(5503),
    [sym_unary] = STATE(5503),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2867] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2868] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [2869] = {
    [anon_sym_EQ] = ACTIONS(8324),
    [sym_comment] = ACTIONS(87),
  },
  [2870] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8326),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8328),
    [anon_sym_DASH_EQ] = ACTIONS(8328),
    [anon_sym_STAR_EQ] = ACTIONS(8328),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8328),
    [anon_sym_SLASH_EQ] = ACTIONS(8328),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8328),
    [anon_sym_PIPE_EQ] = ACTIONS(8328),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8328),
    [anon_sym_AMP_EQ] = ACTIONS(8328),
    [anon_sym_PERCENT_EQ] = ACTIONS(8328),
    [anon_sym_GT_GT_EQ] = ACTIONS(8328),
    [anon_sym_LT_LT_EQ] = ACTIONS(8328),
    [anon_sym_CARET_EQ] = ACTIONS(8328),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2871] = {
    [sym_string] = STATE(5518),
    [aux_sym_chained_string_repeat1] = STATE(5518),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2872] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [2873] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2874] = {
    [sym_string] = STATE(2916),
    [aux_sym_chained_string_repeat1] = STATE(2916),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2875] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5519),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(5519),
    [sym_operator_assignment] = STATE(5519),
    [sym_conditional] = STATE(5519),
    [sym_range] = STATE(5519),
    [sym_binary] = STATE(5519),
    [sym_unary] = STATE(5519),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2876] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [2877] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5520),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5520),
    [sym_operator_assignment] = STATE(5520),
    [sym_conditional] = STATE(5520),
    [sym_range] = STATE(5520),
    [sym_binary] = STATE(5520),
    [sym_unary] = STATE(5520),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2878] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5521),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5521),
    [sym_operator_assignment] = STATE(5521),
    [sym_conditional] = STATE(5521),
    [sym_range] = STATE(5521),
    [sym_binary] = STATE(5521),
    [sym_unary] = STATE(5521),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2879] = {
    [anon_sym_COLON] = ACTIONS(8330),
    [sym_comment] = ACTIONS(87),
  },
  [2880] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5523),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5523),
    [sym_operator_assignment] = STATE(5523),
    [sym_conditional] = STATE(5523),
    [sym_range] = STATE(5523),
    [sym_binary] = STATE(5523),
    [sym_unary] = STATE(5523),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2881] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8332),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2882] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [2883] = {
    [sym_heredoc_body] = STATE(5525),
    [aux_sym_call_repeat1] = STATE(5525),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2884] = {
    [sym_heredoc_body] = STATE(5525),
    [aux_sym_call_repeat1] = STATE(5525),
    [aux_sym_argument_list_repeat1] = STATE(5527),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8334),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [2885] = {
    [sym_string] = STATE(2916),
    [aux_sym_chained_string_repeat1] = STATE(2916),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8336),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2886] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [2887] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [2888] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5528),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5528),
    [sym_operator_assignment] = STATE(5528),
    [sym_conditional] = STATE(5528),
    [sym_range] = STATE(5528),
    [sym_binary] = STATE(5528),
    [sym_unary] = STATE(5528),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2889] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5529),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5529),
    [sym_operator_assignment] = STATE(5529),
    [sym_conditional] = STATE(5529),
    [sym_range] = STATE(5529),
    [sym_binary] = STATE(5529),
    [sym_unary] = STATE(5529),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2890] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5530),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5530),
    [sym_operator_assignment] = STATE(5530),
    [sym_conditional] = STATE(5530),
    [sym_range] = STATE(5530),
    [sym_binary] = STATE(5530),
    [sym_unary] = STATE(5530),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2891] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5531),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5531),
    [sym_operator_assignment] = STATE(5531),
    [sym_conditional] = STATE(5531),
    [sym_range] = STATE(5531),
    [sym_binary] = STATE(5531),
    [sym_unary] = STATE(5531),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2892] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5532),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5532),
    [sym_operator_assignment] = STATE(5532),
    [sym_conditional] = STATE(5532),
    [sym_range] = STATE(5532),
    [sym_binary] = STATE(5532),
    [sym_unary] = STATE(5532),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2893] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5533),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5533),
    [sym_operator_assignment] = STATE(5533),
    [sym_conditional] = STATE(5533),
    [sym_range] = STATE(5533),
    [sym_binary] = STATE(5533),
    [sym_unary] = STATE(5533),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2894] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5534),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(5534),
    [sym_operator_assignment] = STATE(5534),
    [sym_conditional] = STATE(5534),
    [sym_range] = STATE(5534),
    [sym_binary] = STATE(5534),
    [sym_unary] = STATE(5534),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2895] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5535),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5535),
    [sym_operator_assignment] = STATE(5535),
    [sym_conditional] = STATE(5535),
    [sym_range] = STATE(5535),
    [sym_binary] = STATE(5535),
    [sym_unary] = STATE(5535),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2896] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5536),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5536),
    [sym_operator_assignment] = STATE(5536),
    [sym_conditional] = STATE(5536),
    [sym_range] = STATE(5536),
    [sym_binary] = STATE(5536),
    [sym_unary] = STATE(5536),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2897] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5537),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5537),
    [sym_operator_assignment] = STATE(5537),
    [sym_conditional] = STATE(5537),
    [sym_range] = STATE(5537),
    [sym_binary] = STATE(5537),
    [sym_unary] = STATE(5537),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2898] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5538),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5538),
    [sym_operator_assignment] = STATE(5538),
    [sym_conditional] = STATE(5538),
    [sym_range] = STATE(5538),
    [sym_binary] = STATE(5538),
    [sym_unary] = STATE(5538),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2899] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5539),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5539),
    [sym_operator_assignment] = STATE(5539),
    [sym_conditional] = STATE(5539),
    [sym_range] = STATE(5539),
    [sym_binary] = STATE(5539),
    [sym_unary] = STATE(5539),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2900] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5540),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5540),
    [sym_operator_assignment] = STATE(5540),
    [sym_conditional] = STATE(5540),
    [sym_range] = STATE(5540),
    [sym_binary] = STATE(5540),
    [sym_unary] = STATE(5540),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2901] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5541),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5541),
    [sym_operator_assignment] = STATE(5541),
    [sym_conditional] = STATE(5541),
    [sym_range] = STATE(5541),
    [sym_binary] = STATE(5541),
    [sym_unary] = STATE(5541),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2902] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5542),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5542),
    [sym_operator_assignment] = STATE(5542),
    [sym_conditional] = STATE(5542),
    [sym_range] = STATE(5542),
    [sym_binary] = STATE(5542),
    [sym_unary] = STATE(5542),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2903] = {
    [anon_sym_COLON] = ACTIONS(8338),
    [sym_comment] = ACTIONS(87),
  },
  [2904] = {
    [sym__statements] = STATE(2662),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(2663),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(8340),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2905] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5545),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5545),
    [sym_operator_assignment] = STATE(5545),
    [sym_conditional] = STATE(5545),
    [sym_range] = STATE(5545),
    [sym_binary] = STATE(5545),
    [sym_unary] = STATE(5545),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2906] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8342),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [2907] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [2908] = {
    [sym_heredoc_body] = STATE(5547),
    [aux_sym_call_repeat1] = STATE(5547),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2909] = {
    [sym_heredoc_body] = STATE(5547),
    [aux_sym_call_repeat1] = STATE(5547),
    [aux_sym_argument_list_repeat1] = STATE(5549),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [2910] = {
    [sym_string] = STATE(2970),
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8346),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2911] = {
    [sym_heredoc_body] = STATE(5550),
    [aux_sym_call_repeat1] = STATE(5550),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2912] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(5551),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8348),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2913] = {
    [sym_heredoc_body] = STATE(5552),
    [aux_sym_call_repeat1] = STATE(5552),
    [aux_sym_argument_list_repeat1] = STATE(5553),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4660),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [2914] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5554),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_splat_argument] = STATE(5555),
    [sym_assignment] = STATE(5554),
    [sym_operator_assignment] = STATE(5554),
    [sym_conditional] = STATE(5554),
    [sym_range] = STATE(5554),
    [sym_binary] = STATE(5554),
    [sym_unary] = STATE(5554),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(5555),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2915] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5556),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(5556),
    [sym_operator_assignment] = STATE(5556),
    [sym_conditional] = STATE(5556),
    [sym_range] = STATE(5556),
    [sym_binary] = STATE(5556),
    [sym_unary] = STATE(5556),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2916] = {
    [sym_string] = STATE(5557),
    [aux_sym_chained_string_repeat1] = STATE(5557),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [2917] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2918] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [2919] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2920] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [2921] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2922] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2923] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(8350),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [2924] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2925] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2926] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2927] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2928] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2929] = {
    [sym__line_break2] = ACTIONS(8352),
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [ts_builtin_sym_end] = ACTIONS(8352),
    [anon_sym___END__] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8352),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_end] = ACTIONS(8352),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_when] = ACTIONS(8352),
    [anon_sym_elsif] = ACTIONS(8352),
    [anon_sym_else] = ACTIONS(8352),
    [anon_sym_then] = ACTIONS(8352),
    [anon_sym_ensure] = ACTIONS(8352),
    [anon_sym_EQ_GT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8352),
    [anon_sym_AMP_AMP] = ACTIONS(8352),
    [anon_sym_LT_LT] = ACTIONS(8352),
    [anon_sym_GT_GT] = ACTIONS(8352),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8352),
    [anon_sym_PLUS] = ACTIONS(8352),
    [anon_sym_SLASH] = ACTIONS(8352),
    [anon_sym_PERCENT] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [2930] = {
    [anon_sym_end] = ACTIONS(8356),
    [sym_comment] = ACTIONS(87),
  },
  [2931] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5560),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(5560),
    [sym_operator_assignment] = STATE(5560),
    [sym_conditional] = STATE(5560),
    [sym_range] = STATE(5560),
    [sym_binary] = STATE(5560),
    [sym_unary] = STATE(5560),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2932] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2933] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2934] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2935] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2936] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5561),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(5561),
    [sym_operator_assignment] = STATE(5561),
    [sym_conditional] = STATE(5561),
    [sym_range] = STATE(5561),
    [sym_binary] = STATE(5561),
    [sym_unary] = STATE(5561),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2937] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5562),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(5562),
    [sym_operator_assignment] = STATE(5562),
    [sym_conditional] = STATE(5562),
    [sym_range] = STATE(5562),
    [sym_binary] = STATE(5562),
    [sym_unary] = STATE(5562),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2938] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2939] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [2940] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(1109),
    [sym__argument] = STATE(1110),
    [sym_splat_argument] = STATE(1110),
    [sym_hash_splat_argument] = STATE(1110),
    [sym_block_argument] = STATE(1110),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1110),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1945),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2941] = {
    [anon_sym_EQ] = ACTIONS(8386),
    [sym_comment] = ACTIONS(87),
  },
  [2942] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8388),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8390),
    [anon_sym_DASH_EQ] = ACTIONS(8390),
    [anon_sym_STAR_EQ] = ACTIONS(8390),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8390),
    [anon_sym_SLASH_EQ] = ACTIONS(8390),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8390),
    [anon_sym_PIPE_EQ] = ACTIONS(8390),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8390),
    [anon_sym_AMP_EQ] = ACTIONS(8390),
    [anon_sym_PERCENT_EQ] = ACTIONS(8390),
    [anon_sym_GT_GT_EQ] = ACTIONS(8390),
    [anon_sym_LT_LT_EQ] = ACTIONS(8390),
    [anon_sym_CARET_EQ] = ACTIONS(8390),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2943] = {
    [sym_string] = STATE(5577),
    [aux_sym_chained_string_repeat1] = STATE(5577),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2944] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [2945] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [2946] = {
    [sym_string] = STATE(2970),
    [aux_sym_chained_string_repeat1] = STATE(2970),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2947] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5578),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(5578),
    [sym_operator_assignment] = STATE(5578),
    [sym_conditional] = STATE(5578),
    [sym_range] = STATE(5578),
    [sym_binary] = STATE(5578),
    [sym_unary] = STATE(5578),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2948] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [2949] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [2950] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [2951] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [2952] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5579),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5579),
    [sym_operator_assignment] = STATE(5579),
    [sym_conditional] = STATE(5579),
    [sym_range] = STATE(5579),
    [sym_binary] = STATE(5579),
    [sym_unary] = STATE(5579),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2953] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5580),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5580),
    [sym_operator_assignment] = STATE(5580),
    [sym_conditional] = STATE(5580),
    [sym_range] = STATE(5580),
    [sym_binary] = STATE(5580),
    [sym_unary] = STATE(5580),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2954] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5581),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5581),
    [sym_operator_assignment] = STATE(5581),
    [sym_conditional] = STATE(5581),
    [sym_range] = STATE(5581),
    [sym_binary] = STATE(5581),
    [sym_unary] = STATE(5581),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2955] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5582),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5582),
    [sym_operator_assignment] = STATE(5582),
    [sym_conditional] = STATE(5582),
    [sym_range] = STATE(5582),
    [sym_binary] = STATE(5582),
    [sym_unary] = STATE(5582),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2956] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5583),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5583),
    [sym_operator_assignment] = STATE(5583),
    [sym_conditional] = STATE(5583),
    [sym_range] = STATE(5583),
    [sym_binary] = STATE(5583),
    [sym_unary] = STATE(5583),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2957] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5584),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5584),
    [sym_operator_assignment] = STATE(5584),
    [sym_conditional] = STATE(5584),
    [sym_range] = STATE(5584),
    [sym_binary] = STATE(5584),
    [sym_unary] = STATE(5584),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2958] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(5585),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(5585),
    [sym_operator_assignment] = STATE(5585),
    [sym_conditional] = STATE(5585),
    [sym_range] = STATE(5585),
    [sym_binary] = STATE(5585),
    [sym_unary] = STATE(5585),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [2959] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5586),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5586),
    [sym_operator_assignment] = STATE(5586),
    [sym_conditional] = STATE(5586),
    [sym_range] = STATE(5586),
    [sym_binary] = STATE(5586),
    [sym_unary] = STATE(5586),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [2960] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5587),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5587),
    [sym_operator_assignment] = STATE(5587),
    [sym_conditional] = STATE(5587),
    [sym_range] = STATE(5587),
    [sym_binary] = STATE(5587),
    [sym_unary] = STATE(5587),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2961] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5588),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5588),
    [sym_operator_assignment] = STATE(5588),
    [sym_conditional] = STATE(5588),
    [sym_range] = STATE(5588),
    [sym_binary] = STATE(5588),
    [sym_unary] = STATE(5588),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2962] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5589),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5589),
    [sym_operator_assignment] = STATE(5589),
    [sym_conditional] = STATE(5589),
    [sym_range] = STATE(5589),
    [sym_binary] = STATE(5589),
    [sym_unary] = STATE(5589),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2963] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5590),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5590),
    [sym_operator_assignment] = STATE(5590),
    [sym_conditional] = STATE(5590),
    [sym_range] = STATE(5590),
    [sym_binary] = STATE(5590),
    [sym_unary] = STATE(5590),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2964] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5591),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5591),
    [sym_operator_assignment] = STATE(5591),
    [sym_conditional] = STATE(5591),
    [sym_range] = STATE(5591),
    [sym_binary] = STATE(5591),
    [sym_unary] = STATE(5591),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2965] = {
    [sym_heredoc_body] = STATE(5592),
    [aux_sym_call_repeat1] = STATE(5592),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2966] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(5593),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8392),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2967] = {
    [sym_heredoc_body] = STATE(5594),
    [aux_sym_call_repeat1] = STATE(5594),
    [aux_sym_argument_list_repeat1] = STATE(5595),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4732),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [2968] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5596),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_splat_argument] = STATE(5597),
    [sym_assignment] = STATE(5596),
    [sym_operator_assignment] = STATE(5596),
    [sym_conditional] = STATE(5596),
    [sym_range] = STATE(5596),
    [sym_binary] = STATE(5596),
    [sym_unary] = STATE(5596),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(5597),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2969] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5598),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(5598),
    [sym_operator_assignment] = STATE(5598),
    [sym_conditional] = STATE(5598),
    [sym_range] = STATE(5598),
    [sym_binary] = STATE(5598),
    [sym_unary] = STATE(5598),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [2970] = {
    [sym_string] = STATE(5599),
    [aux_sym_chained_string_repeat1] = STATE(5599),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [2971] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5600),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(5600),
    [sym_operator_assignment] = STATE(5600),
    [sym_conditional] = STATE(5600),
    [sym_range] = STATE(5600),
    [sym_binary] = STATE(5600),
    [sym_unary] = STATE(5600),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2972] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5601),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(5601),
    [sym_operator_assignment] = STATE(5601),
    [sym_conditional] = STATE(5601),
    [sym_range] = STATE(5601),
    [sym_binary] = STATE(5601),
    [sym_unary] = STATE(5601),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2973] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5602),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(5602),
    [sym_operator_assignment] = STATE(5602),
    [sym_conditional] = STATE(5602),
    [sym_range] = STATE(5602),
    [sym_binary] = STATE(5602),
    [sym_unary] = STATE(5602),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2974] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5603),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(5603),
    [sym_operator_assignment] = STATE(5603),
    [sym_conditional] = STATE(5603),
    [sym_range] = STATE(5603),
    [sym_binary] = STATE(5603),
    [sym_unary] = STATE(5603),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2975] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [2976] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [2977] = {
    [aux_sym_exceptions_repeat1] = STATE(5617),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(8424),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [2978] = {
    [anon_sym_EQ] = ACTIONS(8426),
    [sym_comment] = ACTIONS(87),
  },
  [2979] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8428),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8430),
    [anon_sym_DASH_EQ] = ACTIONS(8430),
    [anon_sym_STAR_EQ] = ACTIONS(8430),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8430),
    [anon_sym_SLASH_EQ] = ACTIONS(8430),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8430),
    [anon_sym_PIPE_EQ] = ACTIONS(8430),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8430),
    [anon_sym_AMP_EQ] = ACTIONS(8430),
    [anon_sym_PERCENT_EQ] = ACTIONS(8430),
    [anon_sym_GT_GT_EQ] = ACTIONS(8430),
    [anon_sym_LT_LT_EQ] = ACTIONS(8430),
    [anon_sym_CARET_EQ] = ACTIONS(8430),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2980] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [2981] = {
    [sym_string] = STATE(2981),
    [aux_sym_chained_string_repeat1] = STATE(2981),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [2982] = {
    [sym__line_break2] = ACTIONS(8432),
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [ts_builtin_sym_end] = ACTIONS(8432),
    [anon_sym___END__] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8432),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_end] = ACTIONS(8432),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_when] = ACTIONS(8432),
    [anon_sym_elsif] = ACTIONS(8432),
    [anon_sym_else] = ACTIONS(8432),
    [anon_sym_then] = ACTIONS(8432),
    [anon_sym_ensure] = ACTIONS(8432),
    [anon_sym_EQ_GT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8432),
    [anon_sym_AMP_AMP] = ACTIONS(8432),
    [anon_sym_LT_LT] = ACTIONS(8432),
    [anon_sym_GT_GT] = ACTIONS(8432),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8432),
    [anon_sym_PLUS] = ACTIONS(8432),
    [anon_sym_SLASH] = ACTIONS(8432),
    [anon_sym_PERCENT] = ACTIONS(8432),
    [sym_comment] = ACTIONS(87),
  },
  [2983] = {
    [anon_sym_end] = ACTIONS(8436),
    [sym_comment] = ACTIONS(87),
  },
  [2984] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5621),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(5621),
    [sym_operator_assignment] = STATE(5621),
    [sym_conditional] = STATE(5621),
    [sym_range] = STATE(5621),
    [sym_binary] = STATE(5621),
    [sym_unary] = STATE(5621),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2985] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(5628),
    [sym__argument] = STATE(5629),
    [sym_splat_argument] = STATE(5629),
    [sym_hash_splat_argument] = STATE(5629),
    [sym_block_argument] = STATE(5629),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5629),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2986] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(5628),
    [sym__argument] = STATE(5629),
    [sym_splat_argument] = STATE(5629),
    [sym_hash_splat_argument] = STATE(5629),
    [sym_block_argument] = STATE(5629),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5629),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2987] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(5628),
    [sym__argument] = STATE(5629),
    [sym_splat_argument] = STATE(5629),
    [sym_hash_splat_argument] = STATE(5629),
    [sym_block_argument] = STATE(5629),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5629),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2988] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(5628),
    [sym__argument] = STATE(5629),
    [sym_splat_argument] = STATE(5629),
    [sym_hash_splat_argument] = STATE(5629),
    [sym_block_argument] = STATE(5629),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5629),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2989] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5631),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(5631),
    [sym_operator_assignment] = STATE(5631),
    [sym_conditional] = STATE(5631),
    [sym_range] = STATE(5631),
    [sym_binary] = STATE(5631),
    [sym_unary] = STATE(5631),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2990] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5632),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(5632),
    [sym_operator_assignment] = STATE(5632),
    [sym_conditional] = STATE(5632),
    [sym_range] = STATE(5632),
    [sym_binary] = STATE(5632),
    [sym_unary] = STATE(5632),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2991] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [2992] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(8464),
    [anon_sym_or] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [2993] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(5651),
    [sym__argument] = STATE(5652),
    [sym_splat_argument] = STATE(5652),
    [sym_hash_splat_argument] = STATE(5652),
    [sym_block_argument] = STATE(5652),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(5652),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(775),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [2994] = {
    [anon_sym_EQ] = ACTIONS(8486),
    [sym_comment] = ACTIONS(87),
  },
  [2995] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8488),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8490),
    [anon_sym_DASH_EQ] = ACTIONS(8490),
    [anon_sym_STAR_EQ] = ACTIONS(8490),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8490),
    [anon_sym_SLASH_EQ] = ACTIONS(8490),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8490),
    [anon_sym_PIPE_EQ] = ACTIONS(8490),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8490),
    [anon_sym_AMP_EQ] = ACTIONS(8490),
    [anon_sym_PERCENT_EQ] = ACTIONS(8490),
    [anon_sym_GT_GT_EQ] = ACTIONS(8490),
    [anon_sym_LT_LT_EQ] = ACTIONS(8490),
    [anon_sym_CARET_EQ] = ACTIONS(8490),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [2996] = {
    [sym_string] = STATE(5656),
    [aux_sym_chained_string_repeat1] = STATE(5656),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [2997] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(8464),
    [anon_sym_or] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [2998] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [2999] = {
    [sym_string] = STATE(3050),
    [aux_sym_chained_string_repeat1] = STATE(3050),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3000] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5657),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(5657),
    [sym_operator_assignment] = STATE(5657),
    [sym_conditional] = STATE(5657),
    [sym_range] = STATE(5657),
    [sym_binary] = STATE(5657),
    [sym_unary] = STATE(5657),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3001] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(8464),
    [anon_sym_or] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [3002] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5658),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5658),
    [sym_operator_assignment] = STATE(5658),
    [sym_conditional] = STATE(5658),
    [sym_range] = STATE(5658),
    [sym_binary] = STATE(5658),
    [sym_unary] = STATE(5658),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3003] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5659),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5659),
    [sym_operator_assignment] = STATE(5659),
    [sym_conditional] = STATE(5659),
    [sym_range] = STATE(5659),
    [sym_binary] = STATE(5659),
    [sym_unary] = STATE(5659),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3004] = {
    [anon_sym_COLON] = ACTIONS(8492),
    [sym_comment] = ACTIONS(87),
  },
  [3005] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5661),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5661),
    [sym_operator_assignment] = STATE(5661),
    [sym_conditional] = STATE(5661),
    [sym_range] = STATE(5661),
    [sym_binary] = STATE(5661),
    [sym_unary] = STATE(5661),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3006] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8494),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3007] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [3008] = {
    [sym_heredoc_body] = STATE(5663),
    [aux_sym_call_repeat1] = STATE(5663),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3009] = {
    [sym_heredoc_body] = STATE(5663),
    [aux_sym_call_repeat1] = STATE(5663),
    [aux_sym_argument_list_repeat1] = STATE(5665),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8496),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3010] = {
    [sym_string] = STATE(3050),
    [aux_sym_chained_string_repeat1] = STATE(3050),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8498),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3011] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3012] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [3013] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5666),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5666),
    [sym_operator_assignment] = STATE(5666),
    [sym_conditional] = STATE(5666),
    [sym_range] = STATE(5666),
    [sym_binary] = STATE(5666),
    [sym_unary] = STATE(5666),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3014] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5667),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5667),
    [sym_operator_assignment] = STATE(5667),
    [sym_conditional] = STATE(5667),
    [sym_range] = STATE(5667),
    [sym_binary] = STATE(5667),
    [sym_unary] = STATE(5667),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3015] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5668),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5668),
    [sym_operator_assignment] = STATE(5668),
    [sym_conditional] = STATE(5668),
    [sym_range] = STATE(5668),
    [sym_binary] = STATE(5668),
    [sym_unary] = STATE(5668),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3016] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5669),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5669),
    [sym_operator_assignment] = STATE(5669),
    [sym_conditional] = STATE(5669),
    [sym_range] = STATE(5669),
    [sym_binary] = STATE(5669),
    [sym_unary] = STATE(5669),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3017] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5670),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5670),
    [sym_operator_assignment] = STATE(5670),
    [sym_conditional] = STATE(5670),
    [sym_range] = STATE(5670),
    [sym_binary] = STATE(5670),
    [sym_unary] = STATE(5670),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3018] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5671),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5671),
    [sym_operator_assignment] = STATE(5671),
    [sym_conditional] = STATE(5671),
    [sym_range] = STATE(5671),
    [sym_binary] = STATE(5671),
    [sym_unary] = STATE(5671),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3019] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5672),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(5672),
    [sym_operator_assignment] = STATE(5672),
    [sym_conditional] = STATE(5672),
    [sym_range] = STATE(5672),
    [sym_binary] = STATE(5672),
    [sym_unary] = STATE(5672),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3020] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5673),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5673),
    [sym_operator_assignment] = STATE(5673),
    [sym_conditional] = STATE(5673),
    [sym_range] = STATE(5673),
    [sym_binary] = STATE(5673),
    [sym_unary] = STATE(5673),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3021] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5674),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5674),
    [sym_operator_assignment] = STATE(5674),
    [sym_conditional] = STATE(5674),
    [sym_range] = STATE(5674),
    [sym_binary] = STATE(5674),
    [sym_unary] = STATE(5674),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3022] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5675),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5675),
    [sym_operator_assignment] = STATE(5675),
    [sym_conditional] = STATE(5675),
    [sym_range] = STATE(5675),
    [sym_binary] = STATE(5675),
    [sym_unary] = STATE(5675),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3023] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5676),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5676),
    [sym_operator_assignment] = STATE(5676),
    [sym_conditional] = STATE(5676),
    [sym_range] = STATE(5676),
    [sym_binary] = STATE(5676),
    [sym_unary] = STATE(5676),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3024] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5677),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5677),
    [sym_operator_assignment] = STATE(5677),
    [sym_conditional] = STATE(5677),
    [sym_range] = STATE(5677),
    [sym_binary] = STATE(5677),
    [sym_unary] = STATE(5677),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3025] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5678),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5678),
    [sym_operator_assignment] = STATE(5678),
    [sym_conditional] = STATE(5678),
    [sym_range] = STATE(5678),
    [sym_binary] = STATE(5678),
    [sym_unary] = STATE(5678),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3026] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5679),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5679),
    [sym_operator_assignment] = STATE(5679),
    [sym_conditional] = STATE(5679),
    [sym_range] = STATE(5679),
    [sym_binary] = STATE(5679),
    [sym_unary] = STATE(5679),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3027] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5681),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5681),
    [sym_operator_assignment] = STATE(5681),
    [sym_conditional] = STATE(5681),
    [sym_range] = STATE(5681),
    [sym_binary] = STATE(5681),
    [sym_unary] = STATE(5681),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3028] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5682),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5682),
    [sym_operator_assignment] = STATE(5682),
    [sym_conditional] = STATE(5682),
    [sym_range] = STATE(5682),
    [sym_binary] = STATE(5682),
    [sym_unary] = STATE(5682),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3029] = {
    [anon_sym_COLON] = ACTIONS(8502),
    [sym_comment] = ACTIONS(87),
  },
  [3030] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5684),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5684),
    [sym_operator_assignment] = STATE(5684),
    [sym_conditional] = STATE(5684),
    [sym_range] = STATE(5684),
    [sym_binary] = STATE(5684),
    [sym_unary] = STATE(5684),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3031] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(3040),
    [sym__argument] = STATE(3041),
    [sym_splat_argument] = STATE(3041),
    [sym_hash_splat_argument] = STATE(3041),
    [sym_block_argument] = STATE(3041),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3041),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3032] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(3040),
    [sym__argument] = STATE(3041),
    [sym_splat_argument] = STATE(3041),
    [sym_hash_splat_argument] = STATE(3041),
    [sym_block_argument] = STATE(3041),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3041),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3033] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(3040),
    [sym__argument] = STATE(3041),
    [sym_splat_argument] = STATE(3041),
    [sym_hash_splat_argument] = STATE(3041),
    [sym_block_argument] = STATE(3041),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3041),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3034] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(3040),
    [sym__argument] = STATE(3041),
    [sym_splat_argument] = STATE(3041),
    [sym_hash_splat_argument] = STATE(3041),
    [sym_block_argument] = STATE(3041),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3041),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3035] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5685),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5685),
    [sym_operator_assignment] = STATE(5685),
    [sym_conditional] = STATE(5685),
    [sym_range] = STATE(5685),
    [sym_binary] = STATE(5685),
    [sym_unary] = STATE(5685),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3036] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5686),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(5686),
    [sym_operator_assignment] = STATE(5686),
    [sym_conditional] = STATE(5686),
    [sym_range] = STATE(5686),
    [sym_binary] = STATE(5686),
    [sym_unary] = STATE(5686),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3037] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3038] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8504),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3039] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [3040] = {
    [sym_heredoc_body] = STATE(5700),
    [aux_sym_call_repeat1] = STATE(5700),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3041] = {
    [sym_heredoc_body] = STATE(5700),
    [aux_sym_call_repeat1] = STATE(5700),
    [aux_sym_argument_list_repeat1] = STATE(5702),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8534),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3042] = {
    [anon_sym_EQ] = ACTIONS(8536),
    [sym_comment] = ACTIONS(87),
  },
  [3043] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8538),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8540),
    [anon_sym_DASH_EQ] = ACTIONS(8540),
    [anon_sym_STAR_EQ] = ACTIONS(8540),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8540),
    [anon_sym_SLASH_EQ] = ACTIONS(8540),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8540),
    [anon_sym_PIPE_EQ] = ACTIONS(8540),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8540),
    [anon_sym_AMP_EQ] = ACTIONS(8540),
    [anon_sym_PERCENT_EQ] = ACTIONS(8540),
    [anon_sym_GT_GT_EQ] = ACTIONS(8540),
    [anon_sym_LT_LT_EQ] = ACTIONS(8540),
    [anon_sym_CARET_EQ] = ACTIONS(8540),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3044] = {
    [sym_string] = STATE(5705),
    [aux_sym_chained_string_repeat1] = STATE(5705),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8542),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3045] = {
    [sym_heredoc_body] = STATE(5706),
    [aux_sym_call_repeat1] = STATE(5706),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3046] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1131),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(4920),
    [sym_splat_argument] = STATE(4920),
    [sym_hash_splat_argument] = STATE(4920),
    [sym_block_argument] = STATE(4920),
    [sym_assignment] = STATE(1131),
    [sym_operator_assignment] = STATE(1131),
    [sym_conditional] = STATE(1131),
    [sym_range] = STATE(1131),
    [sym_binary] = STATE(1131),
    [sym_unary] = STATE(1131),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1137),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(5707),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4920),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1965),
    [sym__splat_star2] = ACTIONS(1967),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1991),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3047] = {
    [sym_heredoc_body] = STATE(5708),
    [aux_sym_call_repeat1] = STATE(5708),
    [aux_sym_argument_list_repeat1] = STATE(5709),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4852),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3048] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5710),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_splat_argument] = STATE(5711),
    [sym_assignment] = STATE(5710),
    [sym_operator_assignment] = STATE(5710),
    [sym_conditional] = STATE(5710),
    [sym_range] = STATE(5710),
    [sym_binary] = STATE(5710),
    [sym_unary] = STATE(5710),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(5711),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3049] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5712),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(5712),
    [sym_operator_assignment] = STATE(5712),
    [sym_conditional] = STATE(5712),
    [sym_range] = STATE(5712),
    [sym_binary] = STATE(5712),
    [sym_unary] = STATE(5712),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3050] = {
    [sym_string] = STATE(5713),
    [aux_sym_chained_string_repeat1] = STATE(5713),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3051] = {
    [sym__line_break2] = ACTIONS(8544),
    [sym__heredoc_body_start2] = ACTIONS(8544),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(8544),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(8544),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [3052] = {
    [sym__statements] = STATE(5715),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8546),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3053] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5716),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(5716),
    [sym_operator_assignment] = STATE(5716),
    [sym_conditional] = STATE(5716),
    [sym_range] = STATE(5716),
    [sym_binary] = STATE(5716),
    [sym_unary] = STATE(5716),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3054] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5717),
    [sym__argument] = STATE(5718),
    [sym_splat_argument] = STATE(5718),
    [sym_hash_splat_argument] = STATE(5718),
    [sym_block_argument] = STATE(5718),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5718),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3055] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5717),
    [sym__argument] = STATE(5718),
    [sym_splat_argument] = STATE(5718),
    [sym_hash_splat_argument] = STATE(5718),
    [sym_block_argument] = STATE(5718),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5718),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3056] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5717),
    [sym__argument] = STATE(5718),
    [sym_splat_argument] = STATE(5718),
    [sym_hash_splat_argument] = STATE(5718),
    [sym_block_argument] = STATE(5718),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5718),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3057] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5717),
    [sym__argument] = STATE(5718),
    [sym_splat_argument] = STATE(5718),
    [sym_hash_splat_argument] = STATE(5718),
    [sym_block_argument] = STATE(5718),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5718),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2021),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3058] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5719),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(5719),
    [sym_operator_assignment] = STATE(5719),
    [sym_conditional] = STATE(5719),
    [sym_range] = STATE(5719),
    [sym_binary] = STATE(5719),
    [sym_unary] = STATE(5719),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3059] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5720),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(5720),
    [sym_operator_assignment] = STATE(5720),
    [sym_conditional] = STATE(5720),
    [sym_range] = STATE(5720),
    [sym_binary] = STATE(5720),
    [sym_unary] = STATE(5720),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3060] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3061] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [3062] = {
    [anon_sym_EQ] = ACTIONS(8578),
    [sym_comment] = ACTIONS(87),
  },
  [3063] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8580),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8582),
    [anon_sym_DASH_EQ] = ACTIONS(8582),
    [anon_sym_STAR_EQ] = ACTIONS(8582),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8582),
    [anon_sym_SLASH_EQ] = ACTIONS(8582),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8582),
    [anon_sym_PIPE_EQ] = ACTIONS(8582),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8582),
    [anon_sym_AMP_EQ] = ACTIONS(8582),
    [anon_sym_PERCENT_EQ] = ACTIONS(8582),
    [anon_sym_GT_GT_EQ] = ACTIONS(8582),
    [anon_sym_LT_LT_EQ] = ACTIONS(8582),
    [anon_sym_CARET_EQ] = ACTIONS(8582),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3064] = {
    [sym_string] = STATE(5735),
    [aux_sym_chained_string_repeat1] = STATE(5735),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3065] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [3066] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3067] = {
    [sym_string] = STATE(3099),
    [aux_sym_chained_string_repeat1] = STATE(3099),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3068] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5736),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(5736),
    [sym_operator_assignment] = STATE(5736),
    [sym_conditional] = STATE(5736),
    [sym_range] = STATE(5736),
    [sym_binary] = STATE(5736),
    [sym_unary] = STATE(5736),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3069] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [3070] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5737),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5737),
    [sym_operator_assignment] = STATE(5737),
    [sym_conditional] = STATE(5737),
    [sym_range] = STATE(5737),
    [sym_binary] = STATE(5737),
    [sym_unary] = STATE(5737),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3071] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5738),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5738),
    [sym_operator_assignment] = STATE(5738),
    [sym_conditional] = STATE(5738),
    [sym_range] = STATE(5738),
    [sym_binary] = STATE(5738),
    [sym_unary] = STATE(5738),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3072] = {
    [anon_sym_COLON] = ACTIONS(8584),
    [sym_comment] = ACTIONS(87),
  },
  [3073] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5740),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5740),
    [sym_operator_assignment] = STATE(5740),
    [sym_conditional] = STATE(5740),
    [sym_range] = STATE(5740),
    [sym_binary] = STATE(5740),
    [sym_unary] = STATE(5740),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3074] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8586),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3075] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [3076] = {
    [sym_heredoc_body] = STATE(5742),
    [aux_sym_call_repeat1] = STATE(5742),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3077] = {
    [sym_heredoc_body] = STATE(5742),
    [aux_sym_call_repeat1] = STATE(5742),
    [aux_sym_argument_list_repeat1] = STATE(5744),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8588),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3078] = {
    [sym_string] = STATE(3099),
    [aux_sym_chained_string_repeat1] = STATE(3099),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8590),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3079] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3080] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [3081] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5745),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5745),
    [sym_operator_assignment] = STATE(5745),
    [sym_conditional] = STATE(5745),
    [sym_range] = STATE(5745),
    [sym_binary] = STATE(5745),
    [sym_unary] = STATE(5745),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3082] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5746),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5746),
    [sym_operator_assignment] = STATE(5746),
    [sym_conditional] = STATE(5746),
    [sym_range] = STATE(5746),
    [sym_binary] = STATE(5746),
    [sym_unary] = STATE(5746),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3083] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5747),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5747),
    [sym_operator_assignment] = STATE(5747),
    [sym_conditional] = STATE(5747),
    [sym_range] = STATE(5747),
    [sym_binary] = STATE(5747),
    [sym_unary] = STATE(5747),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3084] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5748),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5748),
    [sym_operator_assignment] = STATE(5748),
    [sym_conditional] = STATE(5748),
    [sym_range] = STATE(5748),
    [sym_binary] = STATE(5748),
    [sym_unary] = STATE(5748),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3085] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5749),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5749),
    [sym_operator_assignment] = STATE(5749),
    [sym_conditional] = STATE(5749),
    [sym_range] = STATE(5749),
    [sym_binary] = STATE(5749),
    [sym_unary] = STATE(5749),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3086] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5750),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5750),
    [sym_operator_assignment] = STATE(5750),
    [sym_conditional] = STATE(5750),
    [sym_range] = STATE(5750),
    [sym_binary] = STATE(5750),
    [sym_unary] = STATE(5750),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3087] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5751),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(5751),
    [sym_operator_assignment] = STATE(5751),
    [sym_conditional] = STATE(5751),
    [sym_range] = STATE(5751),
    [sym_binary] = STATE(5751),
    [sym_unary] = STATE(5751),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3088] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5752),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5752),
    [sym_operator_assignment] = STATE(5752),
    [sym_conditional] = STATE(5752),
    [sym_range] = STATE(5752),
    [sym_binary] = STATE(5752),
    [sym_unary] = STATE(5752),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3089] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5753),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5753),
    [sym_operator_assignment] = STATE(5753),
    [sym_conditional] = STATE(5753),
    [sym_range] = STATE(5753),
    [sym_binary] = STATE(5753),
    [sym_unary] = STATE(5753),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3090] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5754),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5754),
    [sym_operator_assignment] = STATE(5754),
    [sym_conditional] = STATE(5754),
    [sym_range] = STATE(5754),
    [sym_binary] = STATE(5754),
    [sym_unary] = STATE(5754),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3091] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5755),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5755),
    [sym_operator_assignment] = STATE(5755),
    [sym_conditional] = STATE(5755),
    [sym_range] = STATE(5755),
    [sym_binary] = STATE(5755),
    [sym_unary] = STATE(5755),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3092] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5756),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5756),
    [sym_operator_assignment] = STATE(5756),
    [sym_conditional] = STATE(5756),
    [sym_range] = STATE(5756),
    [sym_binary] = STATE(5756),
    [sym_unary] = STATE(5756),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3093] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5757),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5757),
    [sym_operator_assignment] = STATE(5757),
    [sym_conditional] = STATE(5757),
    [sym_range] = STATE(5757),
    [sym_binary] = STATE(5757),
    [sym_unary] = STATE(5757),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3094] = {
    [sym_heredoc_body] = STATE(5758),
    [aux_sym_call_repeat1] = STATE(5758),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3095] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(5759),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8592),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3096] = {
    [sym_heredoc_body] = STATE(5760),
    [aux_sym_call_repeat1] = STATE(5760),
    [aux_sym_argument_list_repeat1] = STATE(5761),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3097] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_splat_argument] = STATE(5763),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(5763),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3098] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5764),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(5764),
    [sym_operator_assignment] = STATE(5764),
    [sym_conditional] = STATE(5764),
    [sym_range] = STATE(5764),
    [sym_binary] = STATE(5764),
    [sym_unary] = STATE(5764),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3099] = {
    [sym_string] = STATE(5765),
    [aux_sym_chained_string_repeat1] = STATE(5765),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3100] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3101] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [3102] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3103] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [3104] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3105] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3106] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(8594),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [3107] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3108] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3109] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3110] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3111] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3112] = {
    [anon_sym_end] = ACTIONS(8596),
    [sym_comment] = ACTIONS(87),
  },
  [3113] = {
    [sym_when] = STATE(5768),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3114] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5769),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5769),
    [sym_operator_assignment] = STATE(5769),
    [sym_conditional] = STATE(5769),
    [sym_range] = STATE(5769),
    [sym_binary] = STATE(5769),
    [sym_unary] = STATE(5769),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3115] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5770),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5770),
    [sym_operator_assignment] = STATE(5770),
    [sym_conditional] = STATE(5770),
    [sym_range] = STATE(5770),
    [sym_binary] = STATE(5770),
    [sym_unary] = STATE(5770),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3116] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5771),
    [sym_operator_assignment] = STATE(5771),
    [sym_conditional] = STATE(5771),
    [sym_range] = STATE(5771),
    [sym_binary] = STATE(5771),
    [sym_unary] = STATE(5771),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3117] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5772),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(5772),
    [sym_operator_assignment] = STATE(5772),
    [sym_conditional] = STATE(5772),
    [sym_range] = STATE(5772),
    [sym_binary] = STATE(5772),
    [sym_unary] = STATE(5772),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3118] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3119] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [3120] = {
    [aux_sym_exceptions_repeat1] = STATE(5786),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(8628),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [3121] = {
    [anon_sym_EQ] = ACTIONS(8630),
    [sym_comment] = ACTIONS(87),
  },
  [3122] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8632),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8634),
    [anon_sym_DASH_EQ] = ACTIONS(8634),
    [anon_sym_STAR_EQ] = ACTIONS(8634),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8634),
    [anon_sym_SLASH_EQ] = ACTIONS(8634),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8634),
    [anon_sym_PIPE_EQ] = ACTIONS(8634),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8634),
    [anon_sym_AMP_EQ] = ACTIONS(8634),
    [anon_sym_PERCENT_EQ] = ACTIONS(8634),
    [anon_sym_GT_GT_EQ] = ACTIONS(8634),
    [anon_sym_LT_LT_EQ] = ACTIONS(8634),
    [anon_sym_CARET_EQ] = ACTIONS(8634),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3123] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3124] = {
    [sym_string] = STATE(3124),
    [aux_sym_chained_string_repeat1] = STATE(3124),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [3125] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5789),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(5789),
    [sym_operator_assignment] = STATE(5789),
    [sym_conditional] = STATE(5789),
    [sym_range] = STATE(5789),
    [sym_binary] = STATE(5789),
    [sym_unary] = STATE(5789),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3126] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5790),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(5790),
    [sym_operator_assignment] = STATE(5790),
    [sym_conditional] = STATE(5790),
    [sym_range] = STATE(5790),
    [sym_binary] = STATE(5790),
    [sym_unary] = STATE(5790),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3127] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5797),
    [sym__argument] = STATE(5798),
    [sym_splat_argument] = STATE(5798),
    [sym_hash_splat_argument] = STATE(5798),
    [sym_block_argument] = STATE(5798),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5798),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3128] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5797),
    [sym__argument] = STATE(5798),
    [sym_splat_argument] = STATE(5798),
    [sym_hash_splat_argument] = STATE(5798),
    [sym_block_argument] = STATE(5798),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5798),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3129] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5797),
    [sym__argument] = STATE(5798),
    [sym_splat_argument] = STATE(5798),
    [sym_hash_splat_argument] = STATE(5798),
    [sym_block_argument] = STATE(5798),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5798),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3130] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5797),
    [sym__argument] = STATE(5798),
    [sym_splat_argument] = STATE(5798),
    [sym_hash_splat_argument] = STATE(5798),
    [sym_block_argument] = STATE(5798),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5798),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5080),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3131] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5800),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(5800),
    [sym_operator_assignment] = STATE(5800),
    [sym_conditional] = STATE(5800),
    [sym_range] = STATE(5800),
    [sym_binary] = STATE(5800),
    [sym_unary] = STATE(5800),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3132] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5801),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(5801),
    [sym_operator_assignment] = STATE(5801),
    [sym_conditional] = STATE(5801),
    [sym_range] = STATE(5801),
    [sym_binary] = STATE(5801),
    [sym_unary] = STATE(5801),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3133] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3134] = {
    [sym__then] = STATE(5803),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [aux_sym_when_repeat1] = STATE(5804),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(8644),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_then] = ACTIONS(8646),
    [sym_comment] = ACTIONS(87),
  },
  [3135] = {
    [sym__line_break2] = ACTIONS(8648),
    [sym__heredoc_body_start2] = ACTIONS(8648),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(8648),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(8648),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(8648),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(8668),
    [anon_sym_or] = ACTIONS(8668),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [3136] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3137] = {
    [sym__line_break2] = ACTIONS(8648),
    [sym__heredoc_body_start2] = ACTIONS(8648),
    [anon_sym_COMMA] = ACTIONS(8648),
    [anon_sym_SEMI] = ACTIONS(8648),
    [anon_sym_then] = ACTIONS(8648),
    [sym_comment] = ACTIONS(87),
  },
  [3138] = {
    [anon_sym_EQ] = ACTIONS(8690),
    [sym_comment] = ACTIONS(87),
  },
  [3139] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8692),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8694),
    [anon_sym_DASH_EQ] = ACTIONS(8694),
    [anon_sym_STAR_EQ] = ACTIONS(8694),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8694),
    [anon_sym_SLASH_EQ] = ACTIONS(8694),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8694),
    [anon_sym_PIPE_EQ] = ACTIONS(8694),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8694),
    [anon_sym_AMP_EQ] = ACTIONS(8694),
    [anon_sym_PERCENT_EQ] = ACTIONS(8694),
    [anon_sym_GT_GT_EQ] = ACTIONS(8694),
    [anon_sym_LT_LT_EQ] = ACTIONS(8694),
    [anon_sym_CARET_EQ] = ACTIONS(8694),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3140] = {
    [sym_string] = STATE(5828),
    [aux_sym_chained_string_repeat1] = STATE(5828),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3141] = {
    [sym__line_break2] = ACTIONS(8696),
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [ts_builtin_sym_end] = ACTIONS(8696),
    [anon_sym___END__] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8696),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_end] = ACTIONS(8696),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_when] = ACTIONS(8696),
    [anon_sym_elsif] = ACTIONS(8696),
    [anon_sym_else] = ACTIONS(8696),
    [anon_sym_then] = ACTIONS(8696),
    [anon_sym_ensure] = ACTIONS(8696),
    [anon_sym_EQ_GT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8696),
    [anon_sym_AMP_AMP] = ACTIONS(8696),
    [anon_sym_LT_LT] = ACTIONS(8696),
    [anon_sym_GT_GT] = ACTIONS(8696),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8696),
    [anon_sym_PLUS] = ACTIONS(8696),
    [anon_sym_SLASH] = ACTIONS(8696),
    [anon_sym_PERCENT] = ACTIONS(8696),
    [sym_comment] = ACTIONS(87),
  },
  [3142] = {
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(8700),
    [anon_sym_when] = ACTIONS(8703),
    [sym_comment] = ACTIONS(87),
  },
  [3143] = {
    [sym__simple_symbol2] = ACTIONS(6739),
    [sym__string_start2] = ACTIONS(6739),
    [sym__symbol_start2] = ACTIONS(6739),
    [sym__subshell_start2] = ACTIONS(6739),
    [sym__regex_start2] = ACTIONS(6739),
    [sym__string_array_start2] = ACTIONS(6739),
    [sym__symbol_array_start2] = ACTIONS(6739),
    [sym_heredoc_beginning2] = ACTIONS(6739),
    [sym__unary_minus2] = ACTIONS(6739),
    [ts_builtin_sym_end] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(8705),
    [anon_sym_BEGIN] = ACTIONS(8705),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_END] = ACTIONS(8705),
    [anon_sym_def] = ACTIONS(8705),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(8705),
    [anon_sym_module] = ACTIONS(8705),
    [anon_sym_end] = ACTIONS(8705),
    [anon_sym_return] = ACTIONS(8705),
    [anon_sym_yield] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(8705),
    [anon_sym_next] = ACTIONS(8705),
    [sym_redo] = ACTIONS(8705),
    [sym_retry] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(8705),
    [anon_sym_unless] = ACTIONS(8705),
    [anon_sym_while] = ACTIONS(8705),
    [anon_sym_until] = ACTIONS(8705),
    [anon_sym_rescue] = ACTIONS(8705),
    [anon_sym_for] = ACTIONS(8705),
    [anon_sym_case] = ACTIONS(8705),
    [anon_sym_when] = ACTIONS(8705),
    [anon_sym_elsif] = ACTIONS(8705),
    [anon_sym_else] = ACTIONS(8705),
    [anon_sym_then] = ACTIONS(8705),
    [anon_sym_begin] = ACTIONS(8705),
    [anon_sym_ensure] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_defined_QMARK] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(8705),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6739),
    [anon_sym_undef] = ACTIONS(8705),
    [anon_sym_alias] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8705),
    [sym_float] = ACTIONS(8705),
    [sym_complex] = ACTIONS(6739),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(8705),
    [anon_sym_TRUE] = ACTIONS(8705),
    [anon_sym_false] = ACTIONS(8705),
    [anon_sym_FALSE] = ACTIONS(8705),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(8705),
    [anon_sym_NIL] = ACTIONS(8705),
    [sym_character] = ACTIONS(6739),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6739),
  },
  [3144] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5829),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(5829),
    [sym_operator_assignment] = STATE(5829),
    [sym_conditional] = STATE(5829),
    [sym_range] = STATE(5829),
    [sym_binary] = STATE(5829),
    [sym_unary] = STATE(5829),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3145] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(5830),
    [sym__argument] = STATE(5831),
    [sym_splat_argument] = STATE(5831),
    [sym_hash_splat_argument] = STATE(5831),
    [sym_block_argument] = STATE(5831),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5831),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3146] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(5830),
    [sym__argument] = STATE(5831),
    [sym_splat_argument] = STATE(5831),
    [sym_hash_splat_argument] = STATE(5831),
    [sym_block_argument] = STATE(5831),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5831),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3147] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(5830),
    [sym__argument] = STATE(5831),
    [sym_splat_argument] = STATE(5831),
    [sym_hash_splat_argument] = STATE(5831),
    [sym_block_argument] = STATE(5831),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5831),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3148] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(5830),
    [sym__argument] = STATE(5831),
    [sym_splat_argument] = STATE(5831),
    [sym_hash_splat_argument] = STATE(5831),
    [sym_block_argument] = STATE(5831),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5831),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2103),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3149] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5832),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(5832),
    [sym_operator_assignment] = STATE(5832),
    [sym_conditional] = STATE(5832),
    [sym_range] = STATE(5832),
    [sym_binary] = STATE(5832),
    [sym_unary] = STATE(5832),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3150] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5833),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(5833),
    [sym_operator_assignment] = STATE(5833),
    [sym_conditional] = STATE(5833),
    [sym_range] = STATE(5833),
    [sym_binary] = STATE(5833),
    [sym_unary] = STATE(5833),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3151] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3152] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [3153] = {
    [anon_sym_EQ] = ACTIONS(8737),
    [sym_comment] = ACTIONS(87),
  },
  [3154] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8739),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8741),
    [anon_sym_DASH_EQ] = ACTIONS(8741),
    [anon_sym_STAR_EQ] = ACTIONS(8741),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8741),
    [anon_sym_SLASH_EQ] = ACTIONS(8741),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8741),
    [anon_sym_PIPE_EQ] = ACTIONS(8741),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8741),
    [anon_sym_AMP_EQ] = ACTIONS(8741),
    [anon_sym_PERCENT_EQ] = ACTIONS(8741),
    [anon_sym_GT_GT_EQ] = ACTIONS(8741),
    [anon_sym_LT_LT_EQ] = ACTIONS(8741),
    [anon_sym_CARET_EQ] = ACTIONS(8741),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3155] = {
    [sym_string] = STATE(5848),
    [aux_sym_chained_string_repeat1] = STATE(5848),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3156] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [3157] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3158] = {
    [sym_string] = STATE(3199),
    [aux_sym_chained_string_repeat1] = STATE(3199),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3159] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5849),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(5849),
    [sym_operator_assignment] = STATE(5849),
    [sym_conditional] = STATE(5849),
    [sym_range] = STATE(5849),
    [sym_binary] = STATE(5849),
    [sym_unary] = STATE(5849),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3160] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [3161] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5850),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5850),
    [sym_operator_assignment] = STATE(5850),
    [sym_conditional] = STATE(5850),
    [sym_range] = STATE(5850),
    [sym_binary] = STATE(5850),
    [sym_unary] = STATE(5850),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3162] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5851),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5851),
    [sym_operator_assignment] = STATE(5851),
    [sym_conditional] = STATE(5851),
    [sym_range] = STATE(5851),
    [sym_binary] = STATE(5851),
    [sym_unary] = STATE(5851),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3163] = {
    [anon_sym_COLON] = ACTIONS(8743),
    [sym_comment] = ACTIONS(87),
  },
  [3164] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5853),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5853),
    [sym_operator_assignment] = STATE(5853),
    [sym_conditional] = STATE(5853),
    [sym_range] = STATE(5853),
    [sym_binary] = STATE(5853),
    [sym_unary] = STATE(5853),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3165] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8745),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3166] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [3167] = {
    [sym_heredoc_body] = STATE(5855),
    [aux_sym_call_repeat1] = STATE(5855),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3168] = {
    [sym_heredoc_body] = STATE(5855),
    [aux_sym_call_repeat1] = STATE(5855),
    [aux_sym_argument_list_repeat1] = STATE(5857),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8747),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3169] = {
    [sym_string] = STATE(3199),
    [aux_sym_chained_string_repeat1] = STATE(3199),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8749),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3170] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3171] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [3172] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5858),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5858),
    [sym_operator_assignment] = STATE(5858),
    [sym_conditional] = STATE(5858),
    [sym_range] = STATE(5858),
    [sym_binary] = STATE(5858),
    [sym_unary] = STATE(5858),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3173] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5859),
    [sym_operator_assignment] = STATE(5859),
    [sym_conditional] = STATE(5859),
    [sym_range] = STATE(5859),
    [sym_binary] = STATE(5859),
    [sym_unary] = STATE(5859),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3174] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5860),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5860),
    [sym_operator_assignment] = STATE(5860),
    [sym_conditional] = STATE(5860),
    [sym_range] = STATE(5860),
    [sym_binary] = STATE(5860),
    [sym_unary] = STATE(5860),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3175] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5861),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5861),
    [sym_operator_assignment] = STATE(5861),
    [sym_conditional] = STATE(5861),
    [sym_range] = STATE(5861),
    [sym_binary] = STATE(5861),
    [sym_unary] = STATE(5861),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3176] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5862),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5862),
    [sym_operator_assignment] = STATE(5862),
    [sym_conditional] = STATE(5862),
    [sym_range] = STATE(5862),
    [sym_binary] = STATE(5862),
    [sym_unary] = STATE(5862),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3177] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5863),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5863),
    [sym_operator_assignment] = STATE(5863),
    [sym_conditional] = STATE(5863),
    [sym_range] = STATE(5863),
    [sym_binary] = STATE(5863),
    [sym_unary] = STATE(5863),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3178] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5864),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(5864),
    [sym_operator_assignment] = STATE(5864),
    [sym_conditional] = STATE(5864),
    [sym_range] = STATE(5864),
    [sym_binary] = STATE(5864),
    [sym_unary] = STATE(5864),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3179] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5865),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5865),
    [sym_operator_assignment] = STATE(5865),
    [sym_conditional] = STATE(5865),
    [sym_range] = STATE(5865),
    [sym_binary] = STATE(5865),
    [sym_unary] = STATE(5865),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3180] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5866),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5866),
    [sym_operator_assignment] = STATE(5866),
    [sym_conditional] = STATE(5866),
    [sym_range] = STATE(5866),
    [sym_binary] = STATE(5866),
    [sym_unary] = STATE(5866),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3181] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5867),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5867),
    [sym_operator_assignment] = STATE(5867),
    [sym_conditional] = STATE(5867),
    [sym_range] = STATE(5867),
    [sym_binary] = STATE(5867),
    [sym_unary] = STATE(5867),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3182] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5868),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5868),
    [sym_operator_assignment] = STATE(5868),
    [sym_conditional] = STATE(5868),
    [sym_range] = STATE(5868),
    [sym_binary] = STATE(5868),
    [sym_unary] = STATE(5868),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3183] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5869),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5869),
    [sym_operator_assignment] = STATE(5869),
    [sym_conditional] = STATE(5869),
    [sym_range] = STATE(5869),
    [sym_binary] = STATE(5869),
    [sym_unary] = STATE(5869),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3184] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5870),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5870),
    [sym_operator_assignment] = STATE(5870),
    [sym_conditional] = STATE(5870),
    [sym_range] = STATE(5870),
    [sym_binary] = STATE(5870),
    [sym_unary] = STATE(5870),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3185] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5871),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(5871),
    [sym_operator_assignment] = STATE(5871),
    [sym_conditional] = STATE(5871),
    [sym_range] = STATE(5871),
    [sym_binary] = STATE(5871),
    [sym_unary] = STATE(5871),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3186] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5872),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(5872),
    [sym_operator_assignment] = STATE(5872),
    [sym_conditional] = STATE(5872),
    [sym_range] = STATE(5872),
    [sym_binary] = STATE(5872),
    [sym_unary] = STATE(5872),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3187] = {
    [anon_sym_COLON] = ACTIONS(8751),
    [sym_comment] = ACTIONS(87),
  },
  [3188] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5874),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(5874),
    [sym_operator_assignment] = STATE(5874),
    [sym_conditional] = STATE(5874),
    [sym_range] = STATE(5874),
    [sym_binary] = STATE(5874),
    [sym_unary] = STATE(5874),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3189] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8753),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3190] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [3191] = {
    [sym_heredoc_body] = STATE(5876),
    [aux_sym_call_repeat1] = STATE(5876),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3192] = {
    [sym_heredoc_body] = STATE(5876),
    [aux_sym_call_repeat1] = STATE(5876),
    [aux_sym_argument_list_repeat1] = STATE(5878),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8755),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3193] = {
    [sym_string] = STATE(3460),
    [aux_sym_chained_string_repeat1] = STATE(3460),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8757),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3194] = {
    [sym_heredoc_body] = STATE(5879),
    [aux_sym_call_repeat1] = STATE(5879),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3195] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(5880),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3196] = {
    [sym_heredoc_body] = STATE(5881),
    [aux_sym_call_repeat1] = STATE(5881),
    [aux_sym_argument_list_repeat1] = STATE(5882),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3197] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5883),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_splat_argument] = STATE(5884),
    [sym_assignment] = STATE(5883),
    [sym_operator_assignment] = STATE(5883),
    [sym_conditional] = STATE(5883),
    [sym_range] = STATE(5883),
    [sym_binary] = STATE(5883),
    [sym_unary] = STATE(5883),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(5884),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3198] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5885),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(5885),
    [sym_operator_assignment] = STATE(5885),
    [sym_conditional] = STATE(5885),
    [sym_range] = STATE(5885),
    [sym_binary] = STATE(5885),
    [sym_unary] = STATE(5885),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3199] = {
    [sym_string] = STATE(5886),
    [aux_sym_chained_string_repeat1] = STATE(5886),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3200] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5124),
    [anon_sym_or] = ACTIONS(5124),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [3201] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3202] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5887),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5887),
    [sym_operator_assignment] = STATE(5887),
    [sym_conditional] = STATE(5887),
    [sym_range] = STATE(5887),
    [sym_binary] = STATE(5887),
    [sym_unary] = STATE(5887),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3203] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5888),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5888),
    [sym_operator_assignment] = STATE(5888),
    [sym_conditional] = STATE(5888),
    [sym_range] = STATE(5888),
    [sym_binary] = STATE(5888),
    [sym_unary] = STATE(5888),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3204] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5889),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5889),
    [sym_operator_assignment] = STATE(5889),
    [sym_conditional] = STATE(5889),
    [sym_range] = STATE(5889),
    [sym_binary] = STATE(5889),
    [sym_unary] = STATE(5889),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3205] = {
    [anon_sym_COLON] = ACTIONS(8763),
    [sym_comment] = ACTIONS(87),
  },
  [3206] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5891),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5891),
    [sym_operator_assignment] = STATE(5891),
    [sym_conditional] = STATE(5891),
    [sym_range] = STATE(5891),
    [sym_binary] = STATE(5891),
    [sym_unary] = STATE(5891),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3207] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5892),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5892),
    [sym_operator_assignment] = STATE(5892),
    [sym_conditional] = STATE(5892),
    [sym_range] = STATE(5892),
    [sym_binary] = STATE(5892),
    [sym_unary] = STATE(5892),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3208] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5893),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(5893),
    [sym_operator_assignment] = STATE(5893),
    [sym_conditional] = STATE(5893),
    [sym_range] = STATE(5893),
    [sym_binary] = STATE(5893),
    [sym_unary] = STATE(5893),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3209] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3210] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8765),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3211] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [3212] = {
    [sym_heredoc_body] = STATE(5907),
    [aux_sym_call_repeat1] = STATE(5907),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3213] = {
    [sym_heredoc_body] = STATE(5907),
    [aux_sym_call_repeat1] = STATE(5907),
    [aux_sym_argument_list_repeat1] = STATE(5909),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8797),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3214] = {
    [anon_sym_EQ] = ACTIONS(8799),
    [sym_comment] = ACTIONS(87),
  },
  [3215] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8801),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8803),
    [anon_sym_DASH_EQ] = ACTIONS(8803),
    [anon_sym_STAR_EQ] = ACTIONS(8803),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8803),
    [anon_sym_SLASH_EQ] = ACTIONS(8803),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8803),
    [anon_sym_PIPE_EQ] = ACTIONS(8803),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8803),
    [anon_sym_AMP_EQ] = ACTIONS(8803),
    [anon_sym_PERCENT_EQ] = ACTIONS(8803),
    [anon_sym_GT_GT_EQ] = ACTIONS(8803),
    [anon_sym_LT_LT_EQ] = ACTIONS(8803),
    [anon_sym_CARET_EQ] = ACTIONS(8803),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3216] = {
    [sym_string] = STATE(3265),
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8805),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3217] = {
    [sym__line_break2] = ACTIONS(565),
    [sym__heredoc_body_start2] = ACTIONS(565),
    [anon_sym_DOT] = ACTIONS(565),
    [anon_sym_SEMI] = ACTIONS(565),
    [anon_sym_then] = ACTIONS(565),
    [anon_sym_LBRACK] = ACTIONS(565),
    [anon_sym_COLON_COLON2] = ACTIONS(565),
    [anon_sym_AMP_DOT] = ACTIONS(565),
    [sym_comment] = ACTIONS(87),
  },
  [3218] = {
    [sym__line_break2] = ACTIONS(569),
    [sym__heredoc_body_start2] = ACTIONS(569),
    [anon_sym_DOT] = ACTIONS(569),
    [anon_sym_SEMI] = ACTIONS(569),
    [anon_sym_then] = ACTIONS(569),
    [anon_sym_LBRACK] = ACTIONS(569),
    [anon_sym_COLON_COLON2] = ACTIONS(569),
    [anon_sym_AMP_DOT] = ACTIONS(569),
    [sym_comment] = ACTIONS(87),
  },
  [3219] = {
    [sym__line_break2] = ACTIONS(573),
    [sym__heredoc_body_start2] = ACTIONS(573),
    [anon_sym_DOT] = ACTIONS(573),
    [anon_sym_SEMI] = ACTIONS(573),
    [anon_sym_then] = ACTIONS(573),
    [anon_sym_LBRACK] = ACTIONS(573),
    [anon_sym_COLON_COLON2] = ACTIONS(573),
    [anon_sym_AMP_DOT] = ACTIONS(573),
    [sym_comment] = ACTIONS(87),
  },
  [3220] = {
    [anon_sym_DOT] = ACTIONS(8807),
    [anon_sym_LBRACK] = ACTIONS(8809),
    [anon_sym_COLON_COLON2] = ACTIONS(1535),
    [anon_sym_AMP_DOT] = ACTIONS(8807),
    [sym_comment] = ACTIONS(87),
  },
  [3221] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5929),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(5930),
    [sym__argument_list_with_parens] = STATE(5931),
    [sym__argument] = STATE(5932),
    [sym_splat_argument] = STATE(5932),
    [sym_hash_splat_argument] = STATE(5932),
    [sym_block_argument] = STATE(5932),
    [sym_do_block] = STATE(5933),
    [sym_block] = STATE(5933),
    [sym_assignment] = STATE(5929),
    [sym_operator_assignment] = STATE(5929),
    [sym_conditional] = STATE(5929),
    [sym_range] = STATE(5929),
    [sym_binary] = STATE(5929),
    [sym_unary] = STATE(5929),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5936),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5932),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8811),
    [sym__splat_star2] = ACTIONS(8813),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(8817),
    [anon_sym_LBRACE] = ACTIONS(8819),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8821),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(7272),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(8831),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(8841),
    [sym_identifier] = ACTIONS(8841),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3222] = {
    [sym__line_break2] = ACTIONS(8843),
    [sym__heredoc_body_start2] = ACTIONS(8843),
    [anon_sym_DOT] = ACTIONS(559),
    [anon_sym_SEMI] = ACTIONS(8843),
    [anon_sym_then] = ACTIONS(8843),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3223] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3224] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [3225] = {
    [sym_rescue] = STATE(5937),
    [anon_sym_end] = ACTIONS(8845),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(8845),
    [anon_sym_ensure] = ACTIONS(8845),
    [sym_comment] = ACTIONS(87),
  },
  [3226] = {
    [anon_sym_end] = ACTIONS(8845),
    [anon_sym_else] = ACTIONS(8845),
    [anon_sym_ensure] = ACTIONS(8845),
    [sym_comment] = ACTIONS(87),
  },
  [3227] = {
    [sym__statements] = STATE(5938),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym_rescue] = STATE(5937),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(8847),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(8847),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(8847),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3228] = {
    [sym__then] = STATE(5939),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_then] = ACTIONS(8849),
    [sym_comment] = ACTIONS(87),
  },
  [3229] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5940),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5940),
    [sym_operator_assignment] = STATE(5940),
    [sym_conditional] = STATE(5940),
    [sym_range] = STATE(5940),
    [sym_binary] = STATE(5940),
    [sym_unary] = STATE(5940),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3230] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5941),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5941),
    [sym_operator_assignment] = STATE(5941),
    [sym_conditional] = STATE(5941),
    [sym_range] = STATE(5941),
    [sym_binary] = STATE(5941),
    [sym_unary] = STATE(5941),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3231] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5942),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5942),
    [sym_operator_assignment] = STATE(5942),
    [sym_conditional] = STATE(5942),
    [sym_range] = STATE(5942),
    [sym_binary] = STATE(5942),
    [sym_unary] = STATE(5942),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3232] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5943),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5943),
    [sym_operator_assignment] = STATE(5943),
    [sym_conditional] = STATE(5943),
    [sym_range] = STATE(5943),
    [sym_binary] = STATE(5943),
    [sym_unary] = STATE(5943),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3233] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5944),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5944),
    [sym_operator_assignment] = STATE(5944),
    [sym_conditional] = STATE(5944),
    [sym_range] = STATE(5944),
    [sym_binary] = STATE(5944),
    [sym_unary] = STATE(5944),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3234] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5945),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5945),
    [sym_operator_assignment] = STATE(5945),
    [sym_conditional] = STATE(5945),
    [sym_range] = STATE(5945),
    [sym_binary] = STATE(5945),
    [sym_unary] = STATE(5945),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3235] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(5946),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(5946),
    [sym_operator_assignment] = STATE(5946),
    [sym_conditional] = STATE(5946),
    [sym_range] = STATE(5946),
    [sym_binary] = STATE(5946),
    [sym_unary] = STATE(5946),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3236] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5947),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5947),
    [sym_operator_assignment] = STATE(5947),
    [sym_conditional] = STATE(5947),
    [sym_range] = STATE(5947),
    [sym_binary] = STATE(5947),
    [sym_unary] = STATE(5947),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3237] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5948),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5948),
    [sym_operator_assignment] = STATE(5948),
    [sym_conditional] = STATE(5948),
    [sym_range] = STATE(5948),
    [sym_binary] = STATE(5948),
    [sym_unary] = STATE(5948),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3238] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5949),
    [sym_operator_assignment] = STATE(5949),
    [sym_conditional] = STATE(5949),
    [sym_range] = STATE(5949),
    [sym_binary] = STATE(5949),
    [sym_unary] = STATE(5949),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3239] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5950),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5950),
    [sym_operator_assignment] = STATE(5950),
    [sym_conditional] = STATE(5950),
    [sym_range] = STATE(5950),
    [sym_binary] = STATE(5950),
    [sym_unary] = STATE(5950),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3240] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5951),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5951),
    [sym_operator_assignment] = STATE(5951),
    [sym_conditional] = STATE(5951),
    [sym_range] = STATE(5951),
    [sym_binary] = STATE(5951),
    [sym_unary] = STATE(5951),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3241] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5952),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5952),
    [sym_operator_assignment] = STATE(5952),
    [sym_conditional] = STATE(5952),
    [sym_range] = STATE(5952),
    [sym_binary] = STATE(5952),
    [sym_unary] = STATE(5952),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3242] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5954),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5954),
    [sym_operator_assignment] = STATE(5954),
    [sym_conditional] = STATE(5954),
    [sym_range] = STATE(5954),
    [sym_binary] = STATE(5954),
    [sym_unary] = STATE(5954),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3243] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5955),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5955),
    [sym_operator_assignment] = STATE(5955),
    [sym_conditional] = STATE(5955),
    [sym_range] = STATE(5955),
    [sym_binary] = STATE(5955),
    [sym_unary] = STATE(5955),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3244] = {
    [anon_sym_COLON] = ACTIONS(8853),
    [sym_comment] = ACTIONS(87),
  },
  [3245] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5957),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5957),
    [sym_operator_assignment] = STATE(5957),
    [sym_conditional] = STATE(5957),
    [sym_range] = STATE(5957),
    [sym_binary] = STATE(5957),
    [sym_unary] = STATE(5957),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3246] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3247] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3248] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3249] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3250] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5958),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5958),
    [sym_operator_assignment] = STATE(5958),
    [sym_conditional] = STATE(5958),
    [sym_range] = STATE(5958),
    [sym_binary] = STATE(5958),
    [sym_unary] = STATE(5958),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3251] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5959),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(5959),
    [sym_operator_assignment] = STATE(5959),
    [sym_conditional] = STATE(5959),
    [sym_range] = STATE(5959),
    [sym_binary] = STATE(5959),
    [sym_unary] = STATE(5959),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3252] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3253] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8855),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3254] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [3255] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(3256),
    [sym__argument] = STATE(3257),
    [sym_splat_argument] = STATE(3257),
    [sym_hash_splat_argument] = STATE(3257),
    [sym_block_argument] = STATE(3257),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3257),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3256] = {
    [sym_heredoc_body] = STATE(5973),
    [aux_sym_call_repeat1] = STATE(5973),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3257] = {
    [sym_heredoc_body] = STATE(5973),
    [aux_sym_call_repeat1] = STATE(5973),
    [aux_sym_argument_list_repeat1] = STATE(5975),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8885),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3258] = {
    [anon_sym_EQ] = ACTIONS(8887),
    [sym_comment] = ACTIONS(87),
  },
  [3259] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8889),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8891),
    [anon_sym_DASH_EQ] = ACTIONS(8891),
    [anon_sym_STAR_EQ] = ACTIONS(8891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8891),
    [anon_sym_SLASH_EQ] = ACTIONS(8891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8891),
    [anon_sym_PIPE_EQ] = ACTIONS(8891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8891),
    [anon_sym_AMP_EQ] = ACTIONS(8891),
    [anon_sym_PERCENT_EQ] = ACTIONS(8891),
    [anon_sym_GT_GT_EQ] = ACTIONS(8891),
    [anon_sym_LT_LT_EQ] = ACTIONS(8891),
    [anon_sym_CARET_EQ] = ACTIONS(8891),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3260] = {
    [sym_string] = STATE(5978),
    [aux_sym_chained_string_repeat1] = STATE(5978),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8893),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3261] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1219),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(5979),
    [sym_assignment] = STATE(1219),
    [sym_operator_assignment] = STATE(1219),
    [sym_conditional] = STATE(1219),
    [sym_range] = STATE(1219),
    [sym_binary] = STATE(1219),
    [sym_unary] = STATE(1219),
    [sym__arg_or_splat_arg] = STATE(5979),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(2113),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3262] = {
    [aux_sym_exceptions_repeat1] = STATE(5980),
    [sym__line_break2] = ACTIONS(8895),
    [sym__heredoc_body_start2] = ACTIONS(8895),
    [anon_sym_COMMA] = ACTIONS(5170),
    [anon_sym_SEMI] = ACTIONS(8895),
    [anon_sym_then] = ACTIONS(8895),
    [anon_sym_EQ_GT] = ACTIONS(8895),
    [sym_comment] = ACTIONS(87),
  },
  [3263] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5982),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(5983),
    [sym_assignment] = STATE(5982),
    [sym_operator_assignment] = STATE(5982),
    [sym_conditional] = STATE(5982),
    [sym_range] = STATE(5982),
    [sym_binary] = STATE(5982),
    [sym_unary] = STATE(5982),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(5983),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(8897),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3264] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5984),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(5984),
    [sym_operator_assignment] = STATE(5984),
    [sym_conditional] = STATE(5984),
    [sym_range] = STATE(5984),
    [sym_binary] = STATE(5984),
    [sym_unary] = STATE(5984),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3265] = {
    [sym_string] = STATE(5985),
    [aux_sym_chained_string_repeat1] = STATE(5985),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3266] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3267] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5994),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(5994),
    [sym_operator_assignment] = STATE(5994),
    [sym_conditional] = STATE(5994),
    [sym_range] = STATE(5994),
    [sym_binary] = STATE(5994),
    [sym_unary] = STATE(5994),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3268] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5998),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(5998),
    [sym_operator_assignment] = STATE(5998),
    [sym_conditional] = STATE(5998),
    [sym_range] = STATE(5998),
    [sym_binary] = STATE(5998),
    [sym_unary] = STATE(5998),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3269] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5999),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(5999),
    [sym_operator_assignment] = STATE(5999),
    [sym_conditional] = STATE(5999),
    [sym_range] = STATE(5999),
    [sym_binary] = STATE(5999),
    [sym_unary] = STATE(5999),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3270] = {
    [anon_sym_COLON] = ACTIONS(8919),
    [sym_comment] = ACTIONS(87),
  },
  [3271] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6002),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(6002),
    [sym_operator_assignment] = STATE(6002),
    [sym_conditional] = STATE(6002),
    [sym_range] = STATE(6002),
    [sym_binary] = STATE(6002),
    [sym_unary] = STATE(6002),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3272] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6009),
    [sym__argument] = STATE(6010),
    [sym_splat_argument] = STATE(6010),
    [sym_hash_splat_argument] = STATE(6010),
    [sym_block_argument] = STATE(6010),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6010),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3273] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(6009),
    [sym__argument] = STATE(6010),
    [sym_splat_argument] = STATE(6010),
    [sym_hash_splat_argument] = STATE(6010),
    [sym_block_argument] = STATE(6010),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6010),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3274] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(6009),
    [sym__argument] = STATE(6010),
    [sym_splat_argument] = STATE(6010),
    [sym_hash_splat_argument] = STATE(6010),
    [sym_block_argument] = STATE(6010),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6010),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3275] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(6009),
    [sym__argument] = STATE(6010),
    [sym_splat_argument] = STATE(6010),
    [sym_hash_splat_argument] = STATE(6010),
    [sym_block_argument] = STATE(6010),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6010),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3276] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6012),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(6012),
    [sym_operator_assignment] = STATE(6012),
    [sym_conditional] = STATE(6012),
    [sym_range] = STATE(6012),
    [sym_binary] = STATE(6012),
    [sym_unary] = STATE(6012),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3277] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6013),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(6013),
    [sym_operator_assignment] = STATE(6013),
    [sym_conditional] = STATE(6013),
    [sym_range] = STATE(6013),
    [sym_binary] = STATE(6013),
    [sym_unary] = STATE(6013),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3278] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3279] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(8929),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3280] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(8943),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [3281] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3282] = {
    [sym_heredoc_body] = STATE(6036),
    [aux_sym_call_repeat1] = STATE(6036),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3283] = {
    [sym_heredoc_body] = STATE(6036),
    [aux_sym_call_repeat1] = STATE(6036),
    [aux_sym_argument_list_repeat1] = STATE(6038),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8971),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3284] = {
    [anon_sym_EQ] = ACTIONS(8973),
    [sym_comment] = ACTIONS(87),
  },
  [3285] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(8975),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(8977),
    [anon_sym_DASH_EQ] = ACTIONS(8977),
    [anon_sym_STAR_EQ] = ACTIONS(8977),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8977),
    [anon_sym_SLASH_EQ] = ACTIONS(8977),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8977),
    [anon_sym_PIPE_EQ] = ACTIONS(8977),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8977),
    [anon_sym_AMP_EQ] = ACTIONS(8977),
    [anon_sym_PERCENT_EQ] = ACTIONS(8977),
    [anon_sym_GT_GT_EQ] = ACTIONS(8977),
    [anon_sym_LT_LT_EQ] = ACTIONS(8977),
    [anon_sym_CARET_EQ] = ACTIONS(8977),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3286] = {
    [sym_string] = STATE(6041),
    [aux_sym_chained_string_repeat1] = STATE(6041),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(8979),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3287] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3288] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [3289] = {
    [aux_sym_undef_repeat1] = STATE(6042),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_ensure] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [3290] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1237),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(1238),
    [sym_operator_assignment] = STATE(1238),
    [sym_conditional] = STATE(1238),
    [sym_range] = STATE(1238),
    [sym_binary] = STATE(1238),
    [sym_unary] = STATE(1238),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(2545),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [anon_sym_undef] = ACTIONS(2169),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3291] = {
    [sym_heredoc_body] = STATE(6043),
    [sym__terminator] = STATE(6043),
    [aux_sym__statements_repeat1] = STATE(6044),
    [sym__line_break2] = ACTIONS(8981),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(8981),
    [anon_sym_end] = ACTIONS(2543),
    [anon_sym_ensure] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [3292] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6045),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6045),
    [sym_operator_assignment] = STATE(6045),
    [sym_conditional] = STATE(6045),
    [sym_range] = STATE(6045),
    [sym_binary] = STATE(6045),
    [sym_unary] = STATE(6045),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3293] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6046),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6046),
    [sym_operator_assignment] = STATE(6046),
    [sym_conditional] = STATE(6046),
    [sym_range] = STATE(6046),
    [sym_binary] = STATE(6046),
    [sym_unary] = STATE(6046),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3294] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6047),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6047),
    [sym_operator_assignment] = STATE(6047),
    [sym_conditional] = STATE(6047),
    [sym_range] = STATE(6047),
    [sym_binary] = STATE(6047),
    [sym_unary] = STATE(6047),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3295] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6048),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6048),
    [sym_operator_assignment] = STATE(6048),
    [sym_conditional] = STATE(6048),
    [sym_range] = STATE(6048),
    [sym_binary] = STATE(6048),
    [sym_unary] = STATE(6048),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3296] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6049),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6049),
    [sym_operator_assignment] = STATE(6049),
    [sym_conditional] = STATE(6049),
    [sym_range] = STATE(6049),
    [sym_binary] = STATE(6049),
    [sym_unary] = STATE(6049),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3297] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6050),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6050),
    [sym_operator_assignment] = STATE(6050),
    [sym_conditional] = STATE(6050),
    [sym_range] = STATE(6050),
    [sym_binary] = STATE(6050),
    [sym_unary] = STATE(6050),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3298] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6051),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6051),
    [sym_operator_assignment] = STATE(6051),
    [sym_conditional] = STATE(6051),
    [sym_range] = STATE(6051),
    [sym_binary] = STATE(6051),
    [sym_unary] = STATE(6051),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3299] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6052),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6052),
    [sym_operator_assignment] = STATE(6052),
    [sym_conditional] = STATE(6052),
    [sym_range] = STATE(6052),
    [sym_binary] = STATE(6052),
    [sym_unary] = STATE(6052),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3300] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6053),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6053),
    [sym_operator_assignment] = STATE(6053),
    [sym_conditional] = STATE(6053),
    [sym_range] = STATE(6053),
    [sym_binary] = STATE(6053),
    [sym_unary] = STATE(6053),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3301] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6054),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6054),
    [sym_operator_assignment] = STATE(6054),
    [sym_conditional] = STATE(6054),
    [sym_range] = STATE(6054),
    [sym_binary] = STATE(6054),
    [sym_unary] = STATE(6054),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3302] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6055),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6055),
    [sym_operator_assignment] = STATE(6055),
    [sym_conditional] = STATE(6055),
    [sym_range] = STATE(6055),
    [sym_binary] = STATE(6055),
    [sym_unary] = STATE(6055),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3303] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6056),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6056),
    [sym_operator_assignment] = STATE(6056),
    [sym_conditional] = STATE(6056),
    [sym_range] = STATE(6056),
    [sym_binary] = STATE(6056),
    [sym_unary] = STATE(6056),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3304] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6057),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6057),
    [sym_operator_assignment] = STATE(6057),
    [sym_conditional] = STATE(6057),
    [sym_range] = STATE(6057),
    [sym_binary] = STATE(6057),
    [sym_unary] = STATE(6057),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3305] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6058),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6058),
    [sym_operator_assignment] = STATE(6058),
    [sym_conditional] = STATE(6058),
    [sym_range] = STATE(6058),
    [sym_binary] = STATE(6058),
    [sym_unary] = STATE(6058),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3306] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6059),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6059),
    [sym_operator_assignment] = STATE(6059),
    [sym_conditional] = STATE(6059),
    [sym_range] = STATE(6059),
    [sym_binary] = STATE(6059),
    [sym_unary] = STATE(6059),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3307] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6060),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6060),
    [sym_operator_assignment] = STATE(6060),
    [sym_conditional] = STATE(6060),
    [sym_range] = STATE(6060),
    [sym_binary] = STATE(6060),
    [sym_unary] = STATE(6060),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3308] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6061),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6061),
    [sym_operator_assignment] = STATE(6061),
    [sym_conditional] = STATE(6061),
    [sym_range] = STATE(6061),
    [sym_binary] = STATE(6061),
    [sym_unary] = STATE(6061),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3309] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6070),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(6070),
    [sym_operator_assignment] = STATE(6070),
    [sym_conditional] = STATE(6070),
    [sym_range] = STATE(6070),
    [sym_binary] = STATE(6070),
    [sym_unary] = STATE(6070),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3310] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6075),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(6075),
    [sym_operator_assignment] = STATE(6075),
    [sym_conditional] = STATE(6075),
    [sym_range] = STATE(6075),
    [sym_binary] = STATE(6075),
    [sym_unary] = STATE(6075),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3311] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6076),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(6076),
    [sym_operator_assignment] = STATE(6076),
    [sym_conditional] = STATE(6076),
    [sym_range] = STATE(6076),
    [sym_binary] = STATE(6076),
    [sym_unary] = STATE(6076),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3312] = {
    [anon_sym_COLON] = ACTIONS(9007),
    [sym_comment] = ACTIONS(87),
  },
  [3313] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6079),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(6079),
    [sym_operator_assignment] = STATE(6079),
    [sym_conditional] = STATE(6079),
    [sym_range] = STATE(6079),
    [sym_binary] = STATE(6079),
    [sym_unary] = STATE(6079),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3314] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3315] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3316] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3317] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3318] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6080),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(6080),
    [sym_operator_assignment] = STATE(6080),
    [sym_conditional] = STATE(6080),
    [sym_range] = STATE(6080),
    [sym_binary] = STATE(6080),
    [sym_unary] = STATE(6080),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3319] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6081),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(6081),
    [sym_operator_assignment] = STATE(6081),
    [sym_conditional] = STATE(6081),
    [sym_range] = STATE(6081),
    [sym_binary] = STATE(6081),
    [sym_unary] = STATE(6081),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3320] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3321] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9009),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3322] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(9023),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [3323] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(6033),
    [sym__argument] = STATE(6034),
    [sym_splat_argument] = STATE(6034),
    [sym_hash_splat_argument] = STATE(6034),
    [sym_block_argument] = STATE(6034),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6034),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3324] = {
    [sym_heredoc_body] = STATE(6095),
    [aux_sym_call_repeat1] = STATE(6095),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3325] = {
    [sym_heredoc_body] = STATE(6095),
    [aux_sym_call_repeat1] = STATE(6095),
    [aux_sym_argument_list_repeat1] = STATE(6097),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9041),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3326] = {
    [anon_sym_EQ] = ACTIONS(9043),
    [sym_comment] = ACTIONS(87),
  },
  [3327] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9045),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9047),
    [anon_sym_DASH_EQ] = ACTIONS(9047),
    [anon_sym_STAR_EQ] = ACTIONS(9047),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9047),
    [anon_sym_SLASH_EQ] = ACTIONS(9047),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9047),
    [anon_sym_PIPE_EQ] = ACTIONS(9047),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9047),
    [anon_sym_AMP_EQ] = ACTIONS(9047),
    [anon_sym_PERCENT_EQ] = ACTIONS(9047),
    [anon_sym_GT_GT_EQ] = ACTIONS(9047),
    [anon_sym_LT_LT_EQ] = ACTIONS(9047),
    [anon_sym_CARET_EQ] = ACTIONS(9047),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3328] = {
    [sym_string] = STATE(6100),
    [aux_sym_chained_string_repeat1] = STATE(6100),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9049),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3329] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_splat_argument] = STATE(6107),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(6107),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9051),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3330] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6110),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(6110),
    [sym_operator_assignment] = STATE(6110),
    [sym_conditional] = STATE(6110),
    [sym_range] = STATE(6110),
    [sym_binary] = STATE(6110),
    [sym_unary] = STATE(6110),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3331] = {
    [sym_string] = STATE(6111),
    [aux_sym_chained_string_repeat1] = STATE(6111),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3332] = {
    [anon_sym_end] = ACTIONS(9063),
    [anon_sym_ensure] = ACTIONS(9063),
    [sym_comment] = ACTIONS(87),
  },
  [3333] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3334] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6120),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(6120),
    [sym_operator_assignment] = STATE(6120),
    [sym_conditional] = STATE(6120),
    [sym_range] = STATE(6120),
    [sym_binary] = STATE(6120),
    [sym_unary] = STATE(6120),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3335] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6124),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(6124),
    [sym_operator_assignment] = STATE(6124),
    [sym_conditional] = STATE(6124),
    [sym_range] = STATE(6124),
    [sym_binary] = STATE(6124),
    [sym_unary] = STATE(6124),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3336] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6125),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(6125),
    [sym_operator_assignment] = STATE(6125),
    [sym_conditional] = STATE(6125),
    [sym_range] = STATE(6125),
    [sym_binary] = STATE(6125),
    [sym_unary] = STATE(6125),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3337] = {
    [anon_sym_COLON] = ACTIONS(9085),
    [sym_comment] = ACTIONS(87),
  },
  [3338] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6128),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(6128),
    [sym_operator_assignment] = STATE(6128),
    [sym_conditional] = STATE(6128),
    [sym_range] = STATE(6128),
    [sym_binary] = STATE(6128),
    [sym_unary] = STATE(6128),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3339] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6135),
    [sym__argument] = STATE(6136),
    [sym_splat_argument] = STATE(6136),
    [sym_hash_splat_argument] = STATE(6136),
    [sym_block_argument] = STATE(6136),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6136),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3340] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(6135),
    [sym__argument] = STATE(6136),
    [sym_splat_argument] = STATE(6136),
    [sym_hash_splat_argument] = STATE(6136),
    [sym_block_argument] = STATE(6136),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6136),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3341] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(6135),
    [sym__argument] = STATE(6136),
    [sym_splat_argument] = STATE(6136),
    [sym_hash_splat_argument] = STATE(6136),
    [sym_block_argument] = STATE(6136),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6136),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3342] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(6135),
    [sym__argument] = STATE(6136),
    [sym_splat_argument] = STATE(6136),
    [sym_hash_splat_argument] = STATE(6136),
    [sym_block_argument] = STATE(6136),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6136),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3343] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6138),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(6138),
    [sym_operator_assignment] = STATE(6138),
    [sym_conditional] = STATE(6138),
    [sym_range] = STATE(6138),
    [sym_binary] = STATE(6138),
    [sym_unary] = STATE(6138),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3344] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6139),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(6139),
    [sym_operator_assignment] = STATE(6139),
    [sym_conditional] = STATE(6139),
    [sym_range] = STATE(6139),
    [sym_binary] = STATE(6139),
    [sym_unary] = STATE(6139),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3345] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3346] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9095),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3347] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(9109),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [3348] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3349] = {
    [sym_heredoc_body] = STATE(6162),
    [aux_sym_call_repeat1] = STATE(6162),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3350] = {
    [sym_heredoc_body] = STATE(6162),
    [aux_sym_call_repeat1] = STATE(6162),
    [aux_sym_argument_list_repeat1] = STATE(6164),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9137),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3351] = {
    [anon_sym_EQ] = ACTIONS(9139),
    [sym_comment] = ACTIONS(87),
  },
  [3352] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9141),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9143),
    [anon_sym_DASH_EQ] = ACTIONS(9143),
    [anon_sym_STAR_EQ] = ACTIONS(9143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9143),
    [anon_sym_SLASH_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_PIPE_EQ] = ACTIONS(9143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9143),
    [anon_sym_AMP_EQ] = ACTIONS(9143),
    [anon_sym_PERCENT_EQ] = ACTIONS(9143),
    [anon_sym_GT_GT_EQ] = ACTIONS(9143),
    [anon_sym_LT_LT_EQ] = ACTIONS(9143),
    [anon_sym_CARET_EQ] = ACTIONS(9143),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3353] = {
    [sym_string] = STATE(6167),
    [aux_sym_chained_string_repeat1] = STATE(6167),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9145),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3354] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3355] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [3356] = {
    [aux_sym_undef_repeat1] = STATE(6168),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [3357] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3358] = {
    [sym_heredoc_body] = STATE(6169),
    [sym__terminator] = STATE(6169),
    [aux_sym__statements_repeat1] = STATE(6170),
    [sym__line_break2] = ACTIONS(9147),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9147),
    [anon_sym_end] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [3359] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6171),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6171),
    [sym_operator_assignment] = STATE(6171),
    [sym_conditional] = STATE(6171),
    [sym_range] = STATE(6171),
    [sym_binary] = STATE(6171),
    [sym_unary] = STATE(6171),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3360] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6172),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6172),
    [sym_operator_assignment] = STATE(6172),
    [sym_conditional] = STATE(6172),
    [sym_range] = STATE(6172),
    [sym_binary] = STATE(6172),
    [sym_unary] = STATE(6172),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3361] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6173),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6173),
    [sym_operator_assignment] = STATE(6173),
    [sym_conditional] = STATE(6173),
    [sym_range] = STATE(6173),
    [sym_binary] = STATE(6173),
    [sym_unary] = STATE(6173),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3362] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6174),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6174),
    [sym_operator_assignment] = STATE(6174),
    [sym_conditional] = STATE(6174),
    [sym_range] = STATE(6174),
    [sym_binary] = STATE(6174),
    [sym_unary] = STATE(6174),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3363] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6175),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6175),
    [sym_operator_assignment] = STATE(6175),
    [sym_conditional] = STATE(6175),
    [sym_range] = STATE(6175),
    [sym_binary] = STATE(6175),
    [sym_unary] = STATE(6175),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3364] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6176),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6176),
    [sym_operator_assignment] = STATE(6176),
    [sym_conditional] = STATE(6176),
    [sym_range] = STATE(6176),
    [sym_binary] = STATE(6176),
    [sym_unary] = STATE(6176),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3365] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6177),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6177),
    [sym_operator_assignment] = STATE(6177),
    [sym_conditional] = STATE(6177),
    [sym_range] = STATE(6177),
    [sym_binary] = STATE(6177),
    [sym_unary] = STATE(6177),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3366] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6178),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6178),
    [sym_operator_assignment] = STATE(6178),
    [sym_conditional] = STATE(6178),
    [sym_range] = STATE(6178),
    [sym_binary] = STATE(6178),
    [sym_unary] = STATE(6178),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3367] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6179),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6179),
    [sym_operator_assignment] = STATE(6179),
    [sym_conditional] = STATE(6179),
    [sym_range] = STATE(6179),
    [sym_binary] = STATE(6179),
    [sym_unary] = STATE(6179),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3368] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6180),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6180),
    [sym_operator_assignment] = STATE(6180),
    [sym_conditional] = STATE(6180),
    [sym_range] = STATE(6180),
    [sym_binary] = STATE(6180),
    [sym_unary] = STATE(6180),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3369] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6181),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6181),
    [sym_operator_assignment] = STATE(6181),
    [sym_conditional] = STATE(6181),
    [sym_range] = STATE(6181),
    [sym_binary] = STATE(6181),
    [sym_unary] = STATE(6181),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3370] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6182),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6182),
    [sym_operator_assignment] = STATE(6182),
    [sym_conditional] = STATE(6182),
    [sym_range] = STATE(6182),
    [sym_binary] = STATE(6182),
    [sym_unary] = STATE(6182),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3371] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6183),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6183),
    [sym_operator_assignment] = STATE(6183),
    [sym_conditional] = STATE(6183),
    [sym_range] = STATE(6183),
    [sym_binary] = STATE(6183),
    [sym_unary] = STATE(6183),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3372] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6184),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6184),
    [sym_operator_assignment] = STATE(6184),
    [sym_conditional] = STATE(6184),
    [sym_range] = STATE(6184),
    [sym_binary] = STATE(6184),
    [sym_unary] = STATE(6184),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3373] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6185),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6185),
    [sym_operator_assignment] = STATE(6185),
    [sym_conditional] = STATE(6185),
    [sym_range] = STATE(6185),
    [sym_binary] = STATE(6185),
    [sym_unary] = STATE(6185),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3374] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6186),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6186),
    [sym_operator_assignment] = STATE(6186),
    [sym_conditional] = STATE(6186),
    [sym_range] = STATE(6186),
    [sym_binary] = STATE(6186),
    [sym_unary] = STATE(6186),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3375] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6187),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6187),
    [sym_operator_assignment] = STATE(6187),
    [sym_conditional] = STATE(6187),
    [sym_range] = STATE(6187),
    [sym_binary] = STATE(6187),
    [sym_unary] = STATE(6187),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3376] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6196),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(6196),
    [sym_operator_assignment] = STATE(6196),
    [sym_conditional] = STATE(6196),
    [sym_range] = STATE(6196),
    [sym_binary] = STATE(6196),
    [sym_unary] = STATE(6196),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3377] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6201),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(6201),
    [sym_operator_assignment] = STATE(6201),
    [sym_conditional] = STATE(6201),
    [sym_range] = STATE(6201),
    [sym_binary] = STATE(6201),
    [sym_unary] = STATE(6201),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3378] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6202),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(6202),
    [sym_operator_assignment] = STATE(6202),
    [sym_conditional] = STATE(6202),
    [sym_range] = STATE(6202),
    [sym_binary] = STATE(6202),
    [sym_unary] = STATE(6202),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3379] = {
    [anon_sym_COLON] = ACTIONS(9173),
    [sym_comment] = ACTIONS(87),
  },
  [3380] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6205),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(6205),
    [sym_operator_assignment] = STATE(6205),
    [sym_conditional] = STATE(6205),
    [sym_range] = STATE(6205),
    [sym_binary] = STATE(6205),
    [sym_unary] = STATE(6205),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3381] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3382] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3383] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3384] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3385] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6206),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(6206),
    [sym_operator_assignment] = STATE(6206),
    [sym_conditional] = STATE(6206),
    [sym_range] = STATE(6206),
    [sym_binary] = STATE(6206),
    [sym_unary] = STATE(6206),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3386] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6207),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(6207),
    [sym_operator_assignment] = STATE(6207),
    [sym_conditional] = STATE(6207),
    [sym_range] = STATE(6207),
    [sym_binary] = STATE(6207),
    [sym_unary] = STATE(6207),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3387] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3388] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9175),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3389] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(9189),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [3390] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(6159),
    [sym__argument] = STATE(6160),
    [sym_splat_argument] = STATE(6160),
    [sym_hash_splat_argument] = STATE(6160),
    [sym_block_argument] = STATE(6160),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6160),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3391] = {
    [sym_heredoc_body] = STATE(6221),
    [aux_sym_call_repeat1] = STATE(6221),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3392] = {
    [sym_heredoc_body] = STATE(6221),
    [aux_sym_call_repeat1] = STATE(6221),
    [aux_sym_argument_list_repeat1] = STATE(6223),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9207),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3393] = {
    [anon_sym_EQ] = ACTIONS(9209),
    [sym_comment] = ACTIONS(87),
  },
  [3394] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9211),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9213),
    [anon_sym_DASH_EQ] = ACTIONS(9213),
    [anon_sym_STAR_EQ] = ACTIONS(9213),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9213),
    [anon_sym_SLASH_EQ] = ACTIONS(9213),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9213),
    [anon_sym_PIPE_EQ] = ACTIONS(9213),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9213),
    [anon_sym_AMP_EQ] = ACTIONS(9213),
    [anon_sym_PERCENT_EQ] = ACTIONS(9213),
    [anon_sym_GT_GT_EQ] = ACTIONS(9213),
    [anon_sym_LT_LT_EQ] = ACTIONS(9213),
    [anon_sym_CARET_EQ] = ACTIONS(9213),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3395] = {
    [sym_string] = STATE(6226),
    [aux_sym_chained_string_repeat1] = STATE(6226),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9215),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3396] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6232),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_splat_argument] = STATE(6233),
    [sym_assignment] = STATE(6232),
    [sym_operator_assignment] = STATE(6232),
    [sym_conditional] = STATE(6232),
    [sym_range] = STATE(6232),
    [sym_binary] = STATE(6232),
    [sym_unary] = STATE(6232),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(6233),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9217),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3397] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6236),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(6236),
    [sym_operator_assignment] = STATE(6236),
    [sym_conditional] = STATE(6236),
    [sym_range] = STATE(6236),
    [sym_binary] = STATE(6236),
    [sym_unary] = STATE(6236),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3398] = {
    [sym_string] = STATE(6237),
    [aux_sym_chained_string_repeat1] = STATE(6237),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3399] = {
    [aux_sym_undef_repeat1] = STATE(6238),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_else] = ACTIONS(5504),
    [anon_sym_ensure] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [3400] = {
    [sym__line_break2] = ACTIONS(9229),
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [ts_builtin_sym_end] = ACTIONS(9229),
    [anon_sym___END__] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9229),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_end] = ACTIONS(9229),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_when] = ACTIONS(9229),
    [anon_sym_elsif] = ACTIONS(9229),
    [anon_sym_else] = ACTIONS(9229),
    [anon_sym_then] = ACTIONS(9229),
    [anon_sym_ensure] = ACTIONS(9229),
    [anon_sym_EQ_GT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9229),
    [anon_sym_AMP_AMP] = ACTIONS(9229),
    [anon_sym_LT_LT] = ACTIONS(9229),
    [anon_sym_GT_GT] = ACTIONS(9229),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9229),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9229),
    [anon_sym_PERCENT] = ACTIONS(9229),
    [sym_comment] = ACTIONS(87),
  },
  [3401] = {
    [anon_sym_end] = ACTIONS(9233),
    [sym_comment] = ACTIONS(87),
  },
  [3402] = {
    [sym_ensure] = STATE(6240),
    [anon_sym_end] = ACTIONS(9233),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3403] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(5834),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5834),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3404] = {
    [sym_heredoc_body] = STATE(6241),
    [sym__terminator] = STATE(6241),
    [aux_sym__statements_repeat1] = STATE(3404),
    [sym__line_break2] = ACTIONS(9235),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(9235),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_rescue] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [anon_sym_ensure] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [3405] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_ensure] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3406] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_else] = ACTIONS(5844),
    [anon_sym_ensure] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3407] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_ensure] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3408] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_else] = ACTIONS(5848),
    [anon_sym_ensure] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3409] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_ensure] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(2241),
    [anon_sym_or] = ACTIONS(2241),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3410] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3411] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [3412] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3413] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [3414] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3415] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3416] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(9238),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [3417] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3418] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3419] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3420] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3421] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3422] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6243),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(6243),
    [sym_operator_assignment] = STATE(6243),
    [sym_conditional] = STATE(6243),
    [sym_range] = STATE(6243),
    [sym_binary] = STATE(6243),
    [sym_unary] = STATE(6243),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3423] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3424] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3425] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3426] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3427] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6244),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(6244),
    [sym_operator_assignment] = STATE(6244),
    [sym_conditional] = STATE(6244),
    [sym_range] = STATE(6244),
    [sym_binary] = STATE(6244),
    [sym_unary] = STATE(6244),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3428] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6245),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(6245),
    [sym_operator_assignment] = STATE(6245),
    [sym_conditional] = STATE(6245),
    [sym_range] = STATE(6245),
    [sym_binary] = STATE(6245),
    [sym_unary] = STATE(6245),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3429] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3430] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [3431] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(1302),
    [sym__argument] = STATE(1303),
    [sym_splat_argument] = STATE(1303),
    [sym_hash_splat_argument] = STATE(1303),
    [sym_block_argument] = STATE(1303),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1303),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2275),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3432] = {
    [anon_sym_EQ] = ACTIONS(9268),
    [sym_comment] = ACTIONS(87),
  },
  [3433] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9270),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9272),
    [anon_sym_DASH_EQ] = ACTIONS(9272),
    [anon_sym_STAR_EQ] = ACTIONS(9272),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9272),
    [anon_sym_SLASH_EQ] = ACTIONS(9272),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9272),
    [anon_sym_PIPE_EQ] = ACTIONS(9272),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9272),
    [anon_sym_AMP_EQ] = ACTIONS(9272),
    [anon_sym_PERCENT_EQ] = ACTIONS(9272),
    [anon_sym_GT_GT_EQ] = ACTIONS(9272),
    [anon_sym_LT_LT_EQ] = ACTIONS(9272),
    [anon_sym_CARET_EQ] = ACTIONS(9272),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3434] = {
    [sym_string] = STATE(6260),
    [aux_sym_chained_string_repeat1] = STATE(6260),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3435] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [3436] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [3437] = {
    [sym_string] = STATE(3460),
    [aux_sym_chained_string_repeat1] = STATE(3460),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3438] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6261),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(6261),
    [sym_operator_assignment] = STATE(6261),
    [sym_conditional] = STATE(6261),
    [sym_range] = STATE(6261),
    [sym_binary] = STATE(6261),
    [sym_unary] = STATE(6261),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3439] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [3440] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [3441] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [3442] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6262),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6262),
    [sym_operator_assignment] = STATE(6262),
    [sym_conditional] = STATE(6262),
    [sym_range] = STATE(6262),
    [sym_binary] = STATE(6262),
    [sym_unary] = STATE(6262),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3443] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6263),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6263),
    [sym_operator_assignment] = STATE(6263),
    [sym_conditional] = STATE(6263),
    [sym_range] = STATE(6263),
    [sym_binary] = STATE(6263),
    [sym_unary] = STATE(6263),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3444] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6264),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6264),
    [sym_operator_assignment] = STATE(6264),
    [sym_conditional] = STATE(6264),
    [sym_range] = STATE(6264),
    [sym_binary] = STATE(6264),
    [sym_unary] = STATE(6264),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3445] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6265),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6265),
    [sym_operator_assignment] = STATE(6265),
    [sym_conditional] = STATE(6265),
    [sym_range] = STATE(6265),
    [sym_binary] = STATE(6265),
    [sym_unary] = STATE(6265),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3446] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6266),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6266),
    [sym_operator_assignment] = STATE(6266),
    [sym_conditional] = STATE(6266),
    [sym_range] = STATE(6266),
    [sym_binary] = STATE(6266),
    [sym_unary] = STATE(6266),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3447] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6267),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6267),
    [sym_operator_assignment] = STATE(6267),
    [sym_conditional] = STATE(6267),
    [sym_range] = STATE(6267),
    [sym_binary] = STATE(6267),
    [sym_unary] = STATE(6267),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3448] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6268),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(6268),
    [sym_operator_assignment] = STATE(6268),
    [sym_conditional] = STATE(6268),
    [sym_range] = STATE(6268),
    [sym_binary] = STATE(6268),
    [sym_unary] = STATE(6268),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3449] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6269),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6269),
    [sym_operator_assignment] = STATE(6269),
    [sym_conditional] = STATE(6269),
    [sym_range] = STATE(6269),
    [sym_binary] = STATE(6269),
    [sym_unary] = STATE(6269),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3450] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6270),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6270),
    [sym_operator_assignment] = STATE(6270),
    [sym_conditional] = STATE(6270),
    [sym_range] = STATE(6270),
    [sym_binary] = STATE(6270),
    [sym_unary] = STATE(6270),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3451] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6271),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6271),
    [sym_operator_assignment] = STATE(6271),
    [sym_conditional] = STATE(6271),
    [sym_range] = STATE(6271),
    [sym_binary] = STATE(6271),
    [sym_unary] = STATE(6271),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3452] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6272),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6272),
    [sym_operator_assignment] = STATE(6272),
    [sym_conditional] = STATE(6272),
    [sym_range] = STATE(6272),
    [sym_binary] = STATE(6272),
    [sym_unary] = STATE(6272),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3453] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6273),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6273),
    [sym_operator_assignment] = STATE(6273),
    [sym_conditional] = STATE(6273),
    [sym_range] = STATE(6273),
    [sym_binary] = STATE(6273),
    [sym_unary] = STATE(6273),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3454] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6274),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6274),
    [sym_operator_assignment] = STATE(6274),
    [sym_conditional] = STATE(6274),
    [sym_range] = STATE(6274),
    [sym_binary] = STATE(6274),
    [sym_unary] = STATE(6274),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3455] = {
    [sym_heredoc_body] = STATE(6275),
    [aux_sym_call_repeat1] = STATE(6275),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [3456] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(6276),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9274),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3457] = {
    [sym_heredoc_body] = STATE(6277),
    [aux_sym_call_repeat1] = STATE(6277),
    [aux_sym_argument_list_repeat1] = STATE(6278),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(5476),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [3458] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6279),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_splat_argument] = STATE(6280),
    [sym_assignment] = STATE(6279),
    [sym_operator_assignment] = STATE(6279),
    [sym_conditional] = STATE(6279),
    [sym_range] = STATE(6279),
    [sym_binary] = STATE(6279),
    [sym_unary] = STATE(6279),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(6280),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3459] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6281),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(6281),
    [sym_operator_assignment] = STATE(6281),
    [sym_conditional] = STATE(6281),
    [sym_range] = STATE(6281),
    [sym_binary] = STATE(6281),
    [sym_unary] = STATE(6281),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3460] = {
    [sym_string] = STATE(6282),
    [aux_sym_chained_string_repeat1] = STATE(6282),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [3461] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6283),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(6283),
    [sym_operator_assignment] = STATE(6283),
    [sym_conditional] = STATE(6283),
    [sym_range] = STATE(6283),
    [sym_binary] = STATE(6283),
    [sym_unary] = STATE(6283),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3462] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6284),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(6284),
    [sym_operator_assignment] = STATE(6284),
    [sym_conditional] = STATE(6284),
    [sym_range] = STATE(6284),
    [sym_binary] = STATE(6284),
    [sym_unary] = STATE(6284),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3463] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6285),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(6285),
    [sym_operator_assignment] = STATE(6285),
    [sym_conditional] = STATE(6285),
    [sym_range] = STATE(6285),
    [sym_binary] = STATE(6285),
    [sym_unary] = STATE(6285),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3464] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6286),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(6286),
    [sym_operator_assignment] = STATE(6286),
    [sym_conditional] = STATE(6286),
    [sym_range] = STATE(6286),
    [sym_binary] = STATE(6286),
    [sym_unary] = STATE(6286),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3465] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3466] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [3467] = {
    [aux_sym_exceptions_repeat1] = STATE(6300),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(9306),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [3468] = {
    [anon_sym_EQ] = ACTIONS(9308),
    [sym_comment] = ACTIONS(87),
  },
  [3469] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9310),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9312),
    [anon_sym_DASH_EQ] = ACTIONS(9312),
    [anon_sym_STAR_EQ] = ACTIONS(9312),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9312),
    [anon_sym_SLASH_EQ] = ACTIONS(9312),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9312),
    [anon_sym_PIPE_EQ] = ACTIONS(9312),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9312),
    [anon_sym_AMP_EQ] = ACTIONS(9312),
    [anon_sym_PERCENT_EQ] = ACTIONS(9312),
    [anon_sym_GT_GT_EQ] = ACTIONS(9312),
    [anon_sym_LT_LT_EQ] = ACTIONS(9312),
    [anon_sym_CARET_EQ] = ACTIONS(9312),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3470] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [3471] = {
    [sym_string] = STATE(3471),
    [aux_sym_chained_string_repeat1] = STATE(3471),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [3472] = {
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [ts_builtin_sym_end] = ACTIONS(9314),
    [anon_sym___END__] = ACTIONS(9314),
    [anon_sym_RBRACE] = ACTIONS(9314),
    [anon_sym_RPAREN] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9314),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_when] = ACTIONS(9314),
    [anon_sym_elsif] = ACTIONS(9314),
    [anon_sym_else] = ACTIONS(9314),
    [anon_sym_then] = ACTIONS(9314),
    [anon_sym_ensure] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [3473] = {
    [aux_sym_undef_repeat1] = STATE(3473),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [ts_builtin_sym_end] = ACTIONS(9314),
    [anon_sym___END__] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [3474] = {
    [sym__simple_symbol2] = ACTIONS(2959),
    [sym__symbol_start2] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2959),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2959),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_TILDE] = ACTIONS(2959),
    [sym_constant] = ACTIONS(2959),
    [sym_identifier] = ACTIONS(2959),
    [sym_instance_variable] = ACTIONS(2959),
    [sym_class_variable] = ACTIONS(2959),
    [sym_global_variable] = ACTIONS(2959),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_PLUS_AT] = ACTIONS(2959),
    [anon_sym_DASH_AT] = ACTIONS(2959),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2961),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2959),
    [anon_sym_BQUOTE] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [3475] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [3476] = {
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [3477] = {
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [sym_comment] = ACTIONS(87),
  },
  [3478] = {
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [sym_comment] = ACTIONS(87),
  },
  [3479] = {
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_RBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [sym_comment] = ACTIONS(87),
  },
  [3480] = {
    [sym__string_end2] = ACTIONS(9319),
    [sym_comment] = ACTIONS(87),
  },
  [3481] = {
    [aux_sym_string_array_repeat1] = STATE(6306),
    [sym__string_end2] = ACTIONS(9321),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9323),
  },
  [3482] = {
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [sym_comment] = ACTIONS(87),
  },
  [3483] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9325),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3484] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(9325),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9327),
  },
  [3485] = {
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_RBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_COLON2] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [3486] = {
    [sym__string_end2] = ACTIONS(9329),
    [sym_comment] = ACTIONS(87),
  },
  [3487] = {
    [aux_sym_symbol_array_repeat1] = STATE(6312),
    [sym__string_end2] = ACTIONS(9331),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9333),
  },
  [3488] = {
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON2] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [3489] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9335),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3490] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(9335),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9337),
  },
  [3491] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3492] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6319),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(6319),
    [sym_operator_assignment] = STATE(6319),
    [sym_conditional] = STATE(6319),
    [sym_range] = STATE(6319),
    [sym_binary] = STATE(6319),
    [sym_unary] = STATE(6319),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3493] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6322),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(6322),
    [sym_operator_assignment] = STATE(6322),
    [sym_conditional] = STATE(6322),
    [sym_range] = STATE(6322),
    [sym_binary] = STATE(6322),
    [sym_unary] = STATE(6322),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3494] = {
    [anon_sym_COLON] = ACTIONS(9349),
    [sym_comment] = ACTIONS(87),
  },
  [3495] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6324),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(6324),
    [sym_operator_assignment] = STATE(6324),
    [sym_conditional] = STATE(6324),
    [sym_range] = STATE(6324),
    [sym_binary] = STATE(6324),
    [sym_unary] = STATE(6324),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3496] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9351),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3497] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(9353),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [3498] = {
    [sym_heredoc_body] = STATE(6326),
    [aux_sym_call_repeat1] = STATE(6326),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3499] = {
    [sym_heredoc_body] = STATE(6326),
    [aux_sym_call_repeat1] = STATE(6326),
    [aux_sym_argument_list_repeat1] = STATE(6328),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9355),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3500] = {
    [sym_string] = STATE(1452),
    [aux_sym_chained_string_repeat1] = STATE(1452),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9357),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3501] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3502] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3503] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6329),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6329),
    [sym_operator_assignment] = STATE(6329),
    [sym_conditional] = STATE(6329),
    [sym_range] = STATE(6329),
    [sym_binary] = STATE(6329),
    [sym_unary] = STATE(6329),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3504] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6330),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6330),
    [sym_operator_assignment] = STATE(6330),
    [sym_conditional] = STATE(6330),
    [sym_range] = STATE(6330),
    [sym_binary] = STATE(6330),
    [sym_unary] = STATE(6330),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3505] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6331),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6331),
    [sym_operator_assignment] = STATE(6331),
    [sym_conditional] = STATE(6331),
    [sym_range] = STATE(6331),
    [sym_binary] = STATE(6331),
    [sym_unary] = STATE(6331),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3506] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6332),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6332),
    [sym_operator_assignment] = STATE(6332),
    [sym_conditional] = STATE(6332),
    [sym_range] = STATE(6332),
    [sym_binary] = STATE(6332),
    [sym_unary] = STATE(6332),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3507] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6333),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6333),
    [sym_operator_assignment] = STATE(6333),
    [sym_conditional] = STATE(6333),
    [sym_range] = STATE(6333),
    [sym_binary] = STATE(6333),
    [sym_unary] = STATE(6333),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3508] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6334),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6334),
    [sym_operator_assignment] = STATE(6334),
    [sym_conditional] = STATE(6334),
    [sym_range] = STATE(6334),
    [sym_binary] = STATE(6334),
    [sym_unary] = STATE(6334),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3509] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6335),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6335),
    [sym_operator_assignment] = STATE(6335),
    [sym_conditional] = STATE(6335),
    [sym_range] = STATE(6335),
    [sym_binary] = STATE(6335),
    [sym_unary] = STATE(6335),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3510] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6336),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6336),
    [sym_operator_assignment] = STATE(6336),
    [sym_conditional] = STATE(6336),
    [sym_range] = STATE(6336),
    [sym_binary] = STATE(6336),
    [sym_unary] = STATE(6336),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3511] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6337),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6337),
    [sym_operator_assignment] = STATE(6337),
    [sym_conditional] = STATE(6337),
    [sym_range] = STATE(6337),
    [sym_binary] = STATE(6337),
    [sym_unary] = STATE(6337),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3512] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6338),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6338),
    [sym_operator_assignment] = STATE(6338),
    [sym_conditional] = STATE(6338),
    [sym_range] = STATE(6338),
    [sym_binary] = STATE(6338),
    [sym_unary] = STATE(6338),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3513] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6339),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6339),
    [sym_operator_assignment] = STATE(6339),
    [sym_conditional] = STATE(6339),
    [sym_range] = STATE(6339),
    [sym_binary] = STATE(6339),
    [sym_unary] = STATE(6339),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3514] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6340),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6340),
    [sym_operator_assignment] = STATE(6340),
    [sym_conditional] = STATE(6340),
    [sym_range] = STATE(6340),
    [sym_binary] = STATE(6340),
    [sym_unary] = STATE(6340),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3515] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6349),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(6349),
    [sym_operator_assignment] = STATE(6349),
    [sym_conditional] = STATE(6349),
    [sym_range] = STATE(6349),
    [sym_binary] = STATE(6349),
    [sym_unary] = STATE(6349),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3516] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6354),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(6354),
    [sym_operator_assignment] = STATE(6354),
    [sym_conditional] = STATE(6354),
    [sym_range] = STATE(6354),
    [sym_binary] = STATE(6354),
    [sym_unary] = STATE(6354),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3517] = {
    [anon_sym_COLON] = ACTIONS(9381),
    [sym_comment] = ACTIONS(87),
  },
  [3518] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6356),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(6356),
    [sym_operator_assignment] = STATE(6356),
    [sym_conditional] = STATE(6356),
    [sym_range] = STATE(6356),
    [sym_binary] = STATE(6356),
    [sym_unary] = STATE(6356),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3519] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9383),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_RBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3520] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(9385),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_RBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [3521] = {
    [sym_heredoc_body] = STATE(6358),
    [aux_sym_call_repeat1] = STATE(6358),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3522] = {
    [sym_heredoc_body] = STATE(6358),
    [aux_sym_call_repeat1] = STATE(6358),
    [aux_sym_argument_list_repeat1] = STATE(6360),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9387),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_RBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3523] = {
    [sym_string] = STATE(3643),
    [aux_sym_chained_string_repeat1] = STATE(3643),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9389),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3524] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6362),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_splat_argument] = STATE(6363),
    [sym_assignment] = STATE(6362),
    [sym_operator_assignment] = STATE(6362),
    [sym_conditional] = STATE(6362),
    [sym_range] = STATE(6362),
    [sym_binary] = STATE(6362),
    [sym_unary] = STATE(6362),
    [sym_right_assignment_list] = STATE(3650),
    [sym__arg_or_splat_arg] = STATE(6363),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(9391),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3525] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6364),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(6364),
    [sym_operator_assignment] = STATE(6364),
    [sym_conditional] = STATE(6364),
    [sym_range] = STATE(6364),
    [sym_binary] = STATE(6364),
    [sym_unary] = STATE(6364),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3526] = {
    [sym_string] = STATE(6365),
    [aux_sym_chained_string_repeat1] = STATE(6365),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3527] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3528] = {
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_in] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_COLON2] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(87),
  },
  [3529] = {
    [anon_sym_RBRACE] = ACTIONS(9393),
    [sym_comment] = ACTIONS(87),
  },
  [3530] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(9395),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [3531] = {
    [sym__method_rest] = STATE(6368),
    [sym_operator] = STATE(1354),
    [sym__method_name] = STATE(1354),
    [sym_setter] = STATE(1354),
    [sym_symbol] = STATE(1354),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9397),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9397),
    [sym_class_variable] = ACTIONS(9397),
    [sym_global_variable] = ACTIONS(9397),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3532] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(6369),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9399),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3533] = {
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_COLON2] = ACTIONS(3746),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(87),
  },
  [3534] = {
    [sym_heredoc_body] = STATE(6370),
    [sym__terminator] = STATE(6370),
    [sym__line_break2] = ACTIONS(9401),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(9401),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3535] = {
    [sym_heredoc_body] = STATE(6371),
    [sym__terminator] = STATE(6371),
    [sym__line_break2] = ACTIONS(9403),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9403),
    [sym_comment] = ACTIONS(87),
  },
  [3536] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(6372),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9405),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3537] = {
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4158),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_in] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON2] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_LT_LT] = ACTIONS(4158),
    [anon_sym_GT_GT] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_SLASH] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(87),
  },
  [3538] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(6373),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9407),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3539] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [3540] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [3541] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3542] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6374),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6374),
    [sym_operator_assignment] = STATE(6374),
    [sym_conditional] = STATE(6374),
    [sym_range] = STATE(6374),
    [sym_binary] = STATE(6374),
    [sym_unary] = STATE(6374),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3543] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [3544] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3545] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [3546] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6375),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6375),
    [sym_operator_assignment] = STATE(6375),
    [sym_conditional] = STATE(6375),
    [sym_range] = STATE(6375),
    [sym_binary] = STATE(6375),
    [sym_unary] = STATE(6375),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3547] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6376),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6376),
    [sym_operator_assignment] = STATE(6376),
    [sym_conditional] = STATE(6376),
    [sym_range] = STATE(6376),
    [sym_binary] = STATE(6376),
    [sym_unary] = STATE(6376),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3548] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6377),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6377),
    [sym_operator_assignment] = STATE(6377),
    [sym_conditional] = STATE(6377),
    [sym_range] = STATE(6377),
    [sym_binary] = STATE(6377),
    [sym_unary] = STATE(6377),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3549] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6378),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6378),
    [sym_operator_assignment] = STATE(6378),
    [sym_conditional] = STATE(6378),
    [sym_range] = STATE(6378),
    [sym_binary] = STATE(6378),
    [sym_unary] = STATE(6378),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3550] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6379),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6379),
    [sym_operator_assignment] = STATE(6379),
    [sym_conditional] = STATE(6379),
    [sym_range] = STATE(6379),
    [sym_binary] = STATE(6379),
    [sym_unary] = STATE(6379),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3551] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6380),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6380),
    [sym_operator_assignment] = STATE(6380),
    [sym_conditional] = STATE(6380),
    [sym_range] = STATE(6380),
    [sym_binary] = STATE(6380),
    [sym_unary] = STATE(6380),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3552] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6381),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6381),
    [sym_operator_assignment] = STATE(6381),
    [sym_conditional] = STATE(6381),
    [sym_range] = STATE(6381),
    [sym_binary] = STATE(6381),
    [sym_unary] = STATE(6381),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3553] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6382),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6382),
    [sym_operator_assignment] = STATE(6382),
    [sym_conditional] = STATE(6382),
    [sym_range] = STATE(6382),
    [sym_binary] = STATE(6382),
    [sym_unary] = STATE(6382),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3554] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6383),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6383),
    [sym_operator_assignment] = STATE(6383),
    [sym_conditional] = STATE(6383),
    [sym_range] = STATE(6383),
    [sym_binary] = STATE(6383),
    [sym_unary] = STATE(6383),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3555] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6384),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6384),
    [sym_operator_assignment] = STATE(6384),
    [sym_conditional] = STATE(6384),
    [sym_range] = STATE(6384),
    [sym_binary] = STATE(6384),
    [sym_unary] = STATE(6384),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3556] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6385),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6385),
    [sym_operator_assignment] = STATE(6385),
    [sym_conditional] = STATE(6385),
    [sym_range] = STATE(6385),
    [sym_binary] = STATE(6385),
    [sym_unary] = STATE(6385),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3557] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6386),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6386),
    [sym_operator_assignment] = STATE(6386),
    [sym_conditional] = STATE(6386),
    [sym_range] = STATE(6386),
    [sym_binary] = STATE(6386),
    [sym_unary] = STATE(6386),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3558] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6387),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6387),
    [sym_operator_assignment] = STATE(6387),
    [sym_conditional] = STATE(6387),
    [sym_range] = STATE(6387),
    [sym_binary] = STATE(6387),
    [sym_unary] = STATE(6387),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3559] = {
    [sym_heredoc_body] = STATE(6388),
    [aux_sym_call_repeat1] = STATE(6388),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3560] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6389),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9409),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3561] = {
    [sym_heredoc_body] = STATE(6390),
    [aux_sym_call_repeat1] = STATE(6390),
    [aux_sym_argument_list_repeat1] = STATE(6391),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(5638),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [3562] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6392),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_splat_argument] = STATE(6393),
    [sym_assignment] = STATE(6392),
    [sym_operator_assignment] = STATE(6392),
    [sym_conditional] = STATE(6392),
    [sym_range] = STATE(6392),
    [sym_binary] = STATE(6392),
    [sym_unary] = STATE(6392),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(6393),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3563] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6394),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(6394),
    [sym_operator_assignment] = STATE(6394),
    [sym_conditional] = STATE(6394),
    [sym_range] = STATE(6394),
    [sym_binary] = STATE(6394),
    [sym_unary] = STATE(6394),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3564] = {
    [sym__statements] = STATE(6396),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(6397),
    [sym_else] = STATE(6397),
    [sym__if_tail] = STATE(6397),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6398),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6398),
    [sym__line_break2] = ACTIONS(9411),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9413),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3565] = {
    [sym__statements] = STATE(6400),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6401),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9415),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3566] = {
    [sym__statements] = STATE(6403),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9417),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3567] = {
    [sym__statements] = STATE(6405),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9419),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3568] = {
    [sym__do] = STATE(6406),
    [sym_heredoc_body] = STATE(6406),
    [sym__terminator] = STATE(6406),
    [sym__line_break2] = ACTIONS(9421),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9421),
    [anon_sym_do] = ACTIONS(9421),
    [sym_comment] = ACTIONS(87),
  },
  [3569] = {
    [sym_when] = STATE(6407),
    [aux_sym_case_repeat1] = STATE(6408),
    [anon_sym_SEMI] = ACTIONS(9423),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3570] = {
    [anon_sym_end] = ACTIONS(9425),
    [sym_comment] = ACTIONS(87),
  },
  [3571] = {
    [sym_when] = STATE(6407),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3572] = {
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_RBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_COLON2] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [sym_comment] = ACTIONS(87),
  },
  [3573] = {
    [sym_ensure] = STATE(6411),
    [anon_sym_end] = ACTIONS(9427),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3574] = {
    [anon_sym_end] = ACTIONS(9427),
    [sym_comment] = ACTIONS(87),
  },
  [3575] = {
    [sym_else] = STATE(6412),
    [sym_ensure] = STATE(6411),
    [anon_sym_end] = ACTIONS(9427),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3576] = {
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON2] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [sym_comment] = ACTIONS(87),
  },
  [3577] = {
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_in] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_COLON2] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_PLUS] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5738),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(87),
  },
  [3578] = {
    [anon_sym_RBRACK] = ACTIONS(9429),
    [sym_comment] = ACTIONS(87),
  },
  [3579] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [3580] = {
    [anon_sym_RBRACE] = ACTIONS(9431),
    [sym_comment] = ACTIONS(87),
  },
  [3581] = {
    [sym__statements] = STATE(6415),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9431),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3582] = {
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_in] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_COLON2] = ACTIONS(5788),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [3583] = {
    [anon_sym_end] = ACTIONS(9433),
    [sym_comment] = ACTIONS(87),
  },
  [3584] = {
    [sym__statements] = STATE(6417),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6418),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6418),
    [sym__line_break2] = ACTIONS(9435),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9437),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3585] = {
    [sym__statements] = STATE(6417),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(6419),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9437),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3586] = {
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_in] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_AMP_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [3587] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3588] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [3589] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3590] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [3591] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3592] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3593] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5560),
    [anon_sym_or] = ACTIONS(5560),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [3594] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(9439),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [3595] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3596] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3597] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3598] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3599] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3600] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_EQ_GT] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [3601] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(6422),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6423),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9441),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3602] = {
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym__heredoc_body_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_rescue] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_EQ_GT] = ACTIONS(5974),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_COLON2] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [3603] = {
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym__heredoc_body_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_rescue] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_in] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_EQ_GT] = ACTIONS(5978),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_COLON2] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [3604] = {
    [sym_argument_list_with_parens] = STATE(6424),
    [sym__argument_list_with_parens] = STATE(3603),
    [sym_operator] = STATE(6424),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(5674),
    [anon_sym_STAR] = ACTIONS(5676),
    [anon_sym_STAR_STAR] = ACTIONS(5674),
    [anon_sym_AMP] = ACTIONS(5674),
    [anon_sym_LT] = ACTIONS(5676),
    [anon_sym_LPAREN2] = ACTIONS(5678),
    [anon_sym_DOT_DOT] = ACTIONS(5674),
    [anon_sym_LT_LT] = ACTIONS(5674),
    [anon_sym_GT_GT] = ACTIONS(5674),
    [anon_sym_EQ_EQ] = ACTIONS(5676),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5674),
    [anon_sym_LT_EQ_GT] = ACTIONS(5674),
    [anon_sym_EQ_TILDE] = ACTIONS(5674),
    [anon_sym_BANG_TILDE] = ACTIONS(5674),
    [anon_sym_LT_EQ] = ACTIONS(5676),
    [anon_sym_GT] = ACTIONS(5676),
    [anon_sym_GT_EQ] = ACTIONS(5674),
    [anon_sym_CARET] = ACTIONS(5674),
    [anon_sym_PLUS] = ACTIONS(5676),
    [anon_sym_SLASH] = ACTIONS(5674),
    [anon_sym_PERCENT] = ACTIONS(5674),
    [anon_sym_BANG] = ACTIONS(5676),
    [anon_sym_TILDE] = ACTIONS(5674),
    [sym_constant] = ACTIONS(9443),
    [sym_identifier] = ACTIONS(9443),
    [anon_sym_DASH] = ACTIONS(5676),
    [anon_sym_PLUS_AT] = ACTIONS(5674),
    [anon_sym_DASH_AT] = ACTIONS(5674),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(5676),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(5674),
    [anon_sym_BQUOTE] = ACTIONS(5674),
    [sym_comment] = ACTIONS(87),
  },
  [3605] = {
    [sym__heredoc_body_start2] = ACTIONS(5984),
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_if] = ACTIONS(5984),
    [anon_sym_unless] = ACTIONS(5984),
    [anon_sym_while] = ACTIONS(5984),
    [anon_sym_until] = ACTIONS(5984),
    [anon_sym_rescue] = ACTIONS(5984),
    [anon_sym_in] = ACTIONS(5984),
    [anon_sym_do] = ACTIONS(5984),
    [anon_sym_EQ_GT] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_COLON2] = ACTIONS(5986),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [3606] = {
    [sym_heredoc_body] = STATE(6426),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9445),
    [sym_comment] = ACTIONS(87),
  },
  [3607] = {
    [anon_sym_RBRACK] = ACTIONS(9445),
    [sym_comment] = ACTIONS(87),
  },
  [3608] = {
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym__heredoc_body_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_rescue] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_in] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_EQ_GT] = ACTIONS(5990),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_RBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_COLON2] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [3609] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [3610] = {
    [sym_string] = STATE(3643),
    [aux_sym_chained_string_repeat1] = STATE(3643),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3611] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [3612] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [3613] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6427),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6427),
    [sym_operator_assignment] = STATE(6427),
    [sym_conditional] = STATE(6427),
    [sym_range] = STATE(6427),
    [sym_binary] = STATE(6427),
    [sym_unary] = STATE(6427),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3614] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [3615] = {
    [anon_sym_RBRACE] = ACTIONS(9447),
    [sym_comment] = ACTIONS(87),
  },
  [3616] = {
    [sym__statements] = STATE(6429),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9447),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3617] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [3618] = {
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_in] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_EQ_GT] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_COLON2] = ACTIONS(5788),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [3619] = {
    [anon_sym_end] = ACTIONS(9449),
    [sym_comment] = ACTIONS(87),
  },
  [3620] = {
    [sym__statements] = STATE(6431),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6432),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6432),
    [sym__line_break2] = ACTIONS(9451),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9453),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3621] = {
    [sym__statements] = STATE(6431),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(6433),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9453),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3622] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [3623] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [3624] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6434),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6434),
    [sym_operator_assignment] = STATE(6434),
    [sym_conditional] = STATE(6434),
    [sym_range] = STATE(6434),
    [sym_binary] = STATE(6434),
    [sym_unary] = STATE(6434),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3625] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6435),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6435),
    [sym_operator_assignment] = STATE(6435),
    [sym_conditional] = STATE(6435),
    [sym_range] = STATE(6435),
    [sym_binary] = STATE(6435),
    [sym_unary] = STATE(6435),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3626] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6436),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6436),
    [sym_operator_assignment] = STATE(6436),
    [sym_conditional] = STATE(6436),
    [sym_range] = STATE(6436),
    [sym_binary] = STATE(6436),
    [sym_unary] = STATE(6436),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3627] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6437),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6437),
    [sym_operator_assignment] = STATE(6437),
    [sym_conditional] = STATE(6437),
    [sym_range] = STATE(6437),
    [sym_binary] = STATE(6437),
    [sym_unary] = STATE(6437),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3628] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6438),
    [sym_operator_assignment] = STATE(6438),
    [sym_conditional] = STATE(6438),
    [sym_range] = STATE(6438),
    [sym_binary] = STATE(6438),
    [sym_unary] = STATE(6438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3629] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6439),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6439),
    [sym_operator_assignment] = STATE(6439),
    [sym_conditional] = STATE(6439),
    [sym_range] = STATE(6439),
    [sym_binary] = STATE(6439),
    [sym_unary] = STATE(6439),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3630] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6440),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6440),
    [sym_operator_assignment] = STATE(6440),
    [sym_conditional] = STATE(6440),
    [sym_range] = STATE(6440),
    [sym_binary] = STATE(6440),
    [sym_unary] = STATE(6440),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3631] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6441),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6441),
    [sym_operator_assignment] = STATE(6441),
    [sym_conditional] = STATE(6441),
    [sym_range] = STATE(6441),
    [sym_binary] = STATE(6441),
    [sym_unary] = STATE(6441),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3632] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6442),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6442),
    [sym_operator_assignment] = STATE(6442),
    [sym_conditional] = STATE(6442),
    [sym_range] = STATE(6442),
    [sym_binary] = STATE(6442),
    [sym_unary] = STATE(6442),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3633] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6443),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6443),
    [sym_operator_assignment] = STATE(6443),
    [sym_conditional] = STATE(6443),
    [sym_range] = STATE(6443),
    [sym_binary] = STATE(6443),
    [sym_unary] = STATE(6443),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3634] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6444),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6444),
    [sym_operator_assignment] = STATE(6444),
    [sym_conditional] = STATE(6444),
    [sym_range] = STATE(6444),
    [sym_binary] = STATE(6444),
    [sym_unary] = STATE(6444),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3635] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6445),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6445),
    [sym_operator_assignment] = STATE(6445),
    [sym_conditional] = STATE(6445),
    [sym_range] = STATE(6445),
    [sym_binary] = STATE(6445),
    [sym_unary] = STATE(6445),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3636] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6446),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6446),
    [sym_operator_assignment] = STATE(6446),
    [sym_conditional] = STATE(6446),
    [sym_range] = STATE(6446),
    [sym_binary] = STATE(6446),
    [sym_unary] = STATE(6446),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3637] = {
    [sym__heredoc_body_start2] = ACTIONS(6196),
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_if] = ACTIONS(6196),
    [anon_sym_unless] = ACTIONS(6196),
    [anon_sym_while] = ACTIONS(6196),
    [anon_sym_until] = ACTIONS(6196),
    [anon_sym_rescue] = ACTIONS(6196),
    [anon_sym_in] = ACTIONS(6196),
    [anon_sym_do] = ACTIONS(6196),
    [anon_sym_EQ_GT] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_COLON2] = ACTIONS(6198),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [3638] = {
    [sym_heredoc_body] = STATE(6447),
    [aux_sym_call_repeat1] = STATE(6447),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [3639] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(6448),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9455),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3640] = {
    [sym_heredoc_body] = STATE(6449),
    [aux_sym_call_repeat1] = STATE(6449),
    [aux_sym_argument_list_repeat1] = STATE(6450),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(5728),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [3641] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6451),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_splat_argument] = STATE(6452),
    [sym_assignment] = STATE(6451),
    [sym_operator_assignment] = STATE(6451),
    [sym_conditional] = STATE(6451),
    [sym_range] = STATE(6451),
    [sym_binary] = STATE(6451),
    [sym_unary] = STATE(6451),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(6452),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3642] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6453),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(6453),
    [sym_operator_assignment] = STATE(6453),
    [sym_conditional] = STATE(6453),
    [sym_range] = STATE(6453),
    [sym_binary] = STATE(6453),
    [sym_unary] = STATE(6453),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3643] = {
    [sym_string] = STATE(6454),
    [aux_sym_chained_string_repeat1] = STATE(6454),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [3644] = {
    [sym__line_break2] = ACTIONS(9457),
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [ts_builtin_sym_end] = ACTIONS(9457),
    [anon_sym___END__] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9457),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_end] = ACTIONS(9457),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_when] = ACTIONS(9457),
    [anon_sym_elsif] = ACTIONS(9457),
    [anon_sym_else] = ACTIONS(9457),
    [anon_sym_then] = ACTIONS(9457),
    [anon_sym_ensure] = ACTIONS(9457),
    [anon_sym_EQ_GT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9457),
    [anon_sym_AMP_AMP] = ACTIONS(9457),
    [anon_sym_LT_LT] = ACTIONS(9457),
    [anon_sym_GT_GT] = ACTIONS(9457),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9457),
    [anon_sym_PLUS] = ACTIONS(9457),
    [anon_sym_SLASH] = ACTIONS(9457),
    [anon_sym_PERCENT] = ACTIONS(9457),
    [sym_comment] = ACTIONS(87),
  },
  [3645] = {
    [sym_interpolation] = STATE(6456),
    [aux_sym_heredoc_body_repeat1] = STATE(6456),
    [sym__heredoc_content2] = ACTIONS(9461),
    [sym_heredoc_end2] = ACTIONS(9463),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(9461),
  },
  [3646] = {
    [sym__heredoc_body_start2] = ACTIONS(9465),
    [anon_sym_RPAREN] = ACTIONS(9465),
    [anon_sym_RBRACK] = ACTIONS(9465),
    [sym_comment] = ACTIONS(87),
  },
  [3647] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(6457),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(9465),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(9465),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3648] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6458),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(6458),
    [sym_operator_assignment] = STATE(6458),
    [sym_conditional] = STATE(6458),
    [sym_range] = STATE(6458),
    [sym_binary] = STATE(6458),
    [sym_unary] = STATE(6458),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3649] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3650] = {
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [3651] = {
    [aux_sym_exceptions_repeat1] = STATE(6460),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [3652] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [3653] = {
    [sym_string] = STATE(3653),
    [aux_sym_chained_string_repeat1] = STATE(3653),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [3654] = {
    [anon_sym_PIPE] = ACTIONS(9470),
    [anon_sym_SEMI] = ACTIONS(9472),
    [sym_comment] = ACTIONS(87),
  },
  [3655] = {
    [sym__simple_symbol2] = ACTIONS(9474),
    [sym__string_start2] = ACTIONS(9474),
    [sym__symbol_start2] = ACTIONS(9474),
    [sym__subshell_start2] = ACTIONS(9474),
    [sym__regex_start2] = ACTIONS(9474),
    [sym__string_array_start2] = ACTIONS(9474),
    [sym__symbol_array_start2] = ACTIONS(9474),
    [sym_heredoc_beginning2] = ACTIONS(9474),
    [sym__unary_minus2] = ACTIONS(9474),
    [anon_sym_BEGIN] = ACTIONS(9476),
    [anon_sym_LBRACE] = ACTIONS(9474),
    [anon_sym_RBRACE] = ACTIONS(9474),
    [anon_sym_END] = ACTIONS(9476),
    [anon_sym_def] = ACTIONS(9476),
    [anon_sym_LPAREN] = ACTIONS(9474),
    [anon_sym_COLON_COLON] = ACTIONS(9474),
    [anon_sym_SEMI] = ACTIONS(9474),
    [anon_sym_STAR] = ACTIONS(9474),
    [anon_sym_class] = ACTIONS(9476),
    [anon_sym_module] = ACTIONS(9476),
    [anon_sym_return] = ACTIONS(9476),
    [anon_sym_yield] = ACTIONS(9476),
    [anon_sym_break] = ACTIONS(9476),
    [anon_sym_next] = ACTIONS(9476),
    [sym_redo] = ACTIONS(9476),
    [sym_retry] = ACTIONS(9476),
    [anon_sym_if] = ACTIONS(9476),
    [anon_sym_unless] = ACTIONS(9476),
    [anon_sym_while] = ACTIONS(9476),
    [anon_sym_until] = ACTIONS(9476),
    [anon_sym_for] = ACTIONS(9476),
    [anon_sym_case] = ACTIONS(9476),
    [anon_sym_begin] = ACTIONS(9476),
    [anon_sym_PLUS] = ACTIONS(9476),
    [anon_sym_defined_QMARK] = ACTIONS(9474),
    [anon_sym_not] = ACTIONS(9476),
    [anon_sym_BANG] = ACTIONS(9474),
    [anon_sym_TILDE] = ACTIONS(9474),
    [sym_constant] = ACTIONS(9476),
    [sym_identifier] = ACTIONS(9476),
    [sym_instance_variable] = ACTIONS(9474),
    [sym_class_variable] = ACTIONS(9474),
    [sym_global_variable] = ACTIONS(9474),
    [anon_sym_undef] = ACTIONS(9476),
    [anon_sym_alias] = ACTIONS(9476),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9476),
    [sym_float] = ACTIONS(9476),
    [sym_complex] = ACTIONS(9474),
    [sym_super] = ACTIONS(9476),
    [anon_sym_true] = ACTIONS(9476),
    [anon_sym_TRUE] = ACTIONS(9476),
    [anon_sym_false] = ACTIONS(9476),
    [anon_sym_FALSE] = ACTIONS(9476),
    [sym_self] = ACTIONS(9476),
    [anon_sym_nil] = ACTIONS(9476),
    [anon_sym_NIL] = ACTIONS(9476),
    [sym_character] = ACTIONS(9474),
    [anon_sym_LBRACK2] = ACTIONS(9474),
    [anon_sym_DASH_GT] = ACTIONS(9474),
  },
  [3656] = {
    [sym_identifier] = ACTIONS(9478),
    [sym_comment] = ACTIONS(87),
  },
  [3657] = {
    [anon_sym_COMMA] = ACTIONS(2525),
    [anon_sym_PIPE] = ACTIONS(2525),
    [anon_sym_SEMI] = ACTIONS(2525),
    [anon_sym_COLON] = ACTIONS(9480),
    [anon_sym_EQ] = ACTIONS(9482),
    [sym_comment] = ACTIONS(87),
  },
  [3658] = {
    [aux_sym_method_parameters_repeat1] = STATE(6467),
    [anon_sym_COMMA] = ACTIONS(9484),
    [anon_sym_PIPE] = ACTIONS(9470),
    [anon_sym_SEMI] = ACTIONS(9472),
    [sym_comment] = ACTIONS(87),
  },
  [3659] = {
    [sym__line_break2] = ACTIONS(9486),
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [ts_builtin_sym_end] = ACTIONS(9486),
    [anon_sym___END__] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_end] = ACTIONS(9486),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_when] = ACTIONS(9486),
    [anon_sym_elsif] = ACTIONS(9486),
    [anon_sym_else] = ACTIONS(9486),
    [anon_sym_then] = ACTIONS(9486),
    [anon_sym_ensure] = ACTIONS(9486),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9486),
    [anon_sym_AMP_AMP] = ACTIONS(9486),
    [anon_sym_LT_LT] = ACTIONS(9486),
    [anon_sym_GT_GT] = ACTIONS(9486),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9486),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_SLASH] = ACTIONS(9486),
    [anon_sym_PERCENT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [3660] = {
    [anon_sym_RBRACE] = ACTIONS(9490),
    [sym_comment] = ACTIONS(87),
  },
  [3661] = {
    [aux_sym_method_parameters_repeat1] = STATE(6470),
    [anon_sym_RPAREN] = ACTIONS(9492),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [3662] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6471),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(6471),
    [sym_operator_assignment] = STATE(6471),
    [sym_conditional] = STATE(6471),
    [sym_range] = STATE(6471),
    [sym_binary] = STATE(6471),
    [sym_unary] = STATE(6471),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_RPAREN] = ACTIONS(5798),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3663] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6472),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(6472),
    [sym_operator_assignment] = STATE(6472),
    [sym_conditional] = STATE(6472),
    [sym_range] = STATE(6472),
    [sym_binary] = STATE(6472),
    [sym_unary] = STATE(6472),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3664] = {
    [anon_sym_LBRACE] = ACTIONS(9494),
    [anon_sym_do] = ACTIONS(9494),
    [sym_comment] = ACTIONS(87),
  },
  [3665] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2503),
    [sym_comment] = ACTIONS(87),
  },
  [3666] = {
    [aux_sym_method_parameters_repeat1] = STATE(6475),
    [anon_sym_RPAREN] = ACTIONS(9496),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [3667] = {
    [anon_sym_PIPE] = ACTIONS(9498),
    [anon_sym_SEMI] = ACTIONS(9500),
    [sym_comment] = ACTIONS(87),
  },
  [3668] = {
    [sym__line_break2] = ACTIONS(9474),
    [sym__simple_symbol2] = ACTIONS(9474),
    [sym__string_start2] = ACTIONS(9474),
    [sym__symbol_start2] = ACTIONS(9474),
    [sym__subshell_start2] = ACTIONS(9474),
    [sym__regex_start2] = ACTIONS(9474),
    [sym__string_array_start2] = ACTIONS(9474),
    [sym__symbol_array_start2] = ACTIONS(9474),
    [sym__heredoc_body_start2] = ACTIONS(9474),
    [sym_heredoc_beginning2] = ACTIONS(9474),
    [sym__unary_minus2] = ACTIONS(9474),
    [anon_sym_BEGIN] = ACTIONS(9476),
    [anon_sym_LBRACE] = ACTIONS(9474),
    [anon_sym_END] = ACTIONS(9476),
    [anon_sym_def] = ACTIONS(9476),
    [anon_sym_LPAREN] = ACTIONS(9474),
    [anon_sym_COLON_COLON] = ACTIONS(9474),
    [anon_sym_SEMI] = ACTIONS(9474),
    [anon_sym_STAR] = ACTIONS(9474),
    [anon_sym_class] = ACTIONS(9476),
    [anon_sym_module] = ACTIONS(9476),
    [anon_sym_end] = ACTIONS(9476),
    [anon_sym_return] = ACTIONS(9476),
    [anon_sym_yield] = ACTIONS(9476),
    [anon_sym_break] = ACTIONS(9476),
    [anon_sym_next] = ACTIONS(9476),
    [sym_redo] = ACTIONS(9476),
    [sym_retry] = ACTIONS(9476),
    [anon_sym_if] = ACTIONS(9476),
    [anon_sym_unless] = ACTIONS(9476),
    [anon_sym_while] = ACTIONS(9476),
    [anon_sym_until] = ACTIONS(9476),
    [anon_sym_for] = ACTIONS(9476),
    [anon_sym_case] = ACTIONS(9476),
    [anon_sym_begin] = ACTIONS(9476),
    [anon_sym_PLUS] = ACTIONS(9476),
    [anon_sym_defined_QMARK] = ACTIONS(9474),
    [anon_sym_not] = ACTIONS(9476),
    [anon_sym_BANG] = ACTIONS(9474),
    [anon_sym_TILDE] = ACTIONS(9474),
    [sym_constant] = ACTIONS(9476),
    [sym_identifier] = ACTIONS(9476),
    [sym_instance_variable] = ACTIONS(9474),
    [sym_class_variable] = ACTIONS(9474),
    [sym_global_variable] = ACTIONS(9474),
    [anon_sym_undef] = ACTIONS(9476),
    [anon_sym_alias] = ACTIONS(9476),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9476),
    [sym_float] = ACTIONS(9476),
    [sym_complex] = ACTIONS(9474),
    [sym_super] = ACTIONS(9476),
    [anon_sym_true] = ACTIONS(9476),
    [anon_sym_TRUE] = ACTIONS(9476),
    [anon_sym_false] = ACTIONS(9476),
    [anon_sym_FALSE] = ACTIONS(9476),
    [sym_self] = ACTIONS(9476),
    [anon_sym_nil] = ACTIONS(9476),
    [anon_sym_NIL] = ACTIONS(9476),
    [sym_character] = ACTIONS(9474),
    [anon_sym_LBRACK2] = ACTIONS(9474),
    [anon_sym_DASH_GT] = ACTIONS(9474),
  },
  [3669] = {
    [sym_identifier] = ACTIONS(9502),
    [sym_comment] = ACTIONS(87),
  },
  [3670] = {
    [aux_sym_method_parameters_repeat1] = STATE(6480),
    [anon_sym_COMMA] = ACTIONS(9504),
    [anon_sym_PIPE] = ACTIONS(9498),
    [anon_sym_SEMI] = ACTIONS(9500),
    [sym_comment] = ACTIONS(87),
  },
  [3671] = {
    [sym__line_break2] = ACTIONS(9506),
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [ts_builtin_sym_end] = ACTIONS(9506),
    [anon_sym___END__] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9506),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_end] = ACTIONS(9506),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_when] = ACTIONS(9506),
    [anon_sym_elsif] = ACTIONS(9506),
    [anon_sym_else] = ACTIONS(9506),
    [anon_sym_then] = ACTIONS(9506),
    [anon_sym_ensure] = ACTIONS(9506),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9506),
    [anon_sym_AMP_AMP] = ACTIONS(9506),
    [anon_sym_LT_LT] = ACTIONS(9506),
    [anon_sym_GT_GT] = ACTIONS(9506),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9506),
    [anon_sym_PLUS] = ACTIONS(9506),
    [anon_sym_SLASH] = ACTIONS(9506),
    [anon_sym_PERCENT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [3672] = {
    [anon_sym_end] = ACTIONS(9510),
    [sym_comment] = ACTIONS(87),
  },
  [3673] = {
    [sym__statements] = STATE(6482),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9512),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3674] = {
    [sym__statements] = STATE(6482),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6483),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6483),
    [sym__line_break2] = ACTIONS(9514),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9512),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3675] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6484),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(6484),
    [sym_operator_assignment] = STATE(6484),
    [sym_conditional] = STATE(6484),
    [sym_range] = STATE(6484),
    [sym_binary] = STATE(6484),
    [sym_unary] = STATE(6484),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3676] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3677] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3678] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3679] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(5078),
    [sym__argument] = STATE(5079),
    [sym_splat_argument] = STATE(5079),
    [sym_hash_splat_argument] = STATE(5079),
    [sym_block_argument] = STATE(5079),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5079),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3680] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6485),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(6485),
    [sym_operator_assignment] = STATE(6485),
    [sym_conditional] = STATE(6485),
    [sym_range] = STATE(6485),
    [sym_binary] = STATE(6485),
    [sym_unary] = STATE(6485),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3681] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6486),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(6486),
    [sym_operator_assignment] = STATE(6486),
    [sym_conditional] = STATE(6486),
    [sym_range] = STATE(6486),
    [sym_binary] = STATE(6486),
    [sym_unary] = STATE(6486),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3682] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3683] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(9520),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(9520),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(9536),
    [anon_sym_or] = ACTIONS(9536),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [3684] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(6500),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_do_block] = STATE(1745),
    [sym_block] = STATE(1745),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(9550),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3685] = {
    [anon_sym_EQ] = ACTIONS(9552),
    [sym_comment] = ACTIONS(87),
  },
  [3686] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9554),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9556),
    [anon_sym_DASH_EQ] = ACTIONS(9556),
    [anon_sym_STAR_EQ] = ACTIONS(9556),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9556),
    [anon_sym_SLASH_EQ] = ACTIONS(9556),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9556),
    [anon_sym_PIPE_EQ] = ACTIONS(9556),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9556),
    [anon_sym_AMP_EQ] = ACTIONS(9556),
    [anon_sym_PERCENT_EQ] = ACTIONS(9556),
    [anon_sym_GT_GT_EQ] = ACTIONS(9556),
    [anon_sym_LT_LT_EQ] = ACTIONS(9556),
    [anon_sym_CARET_EQ] = ACTIONS(9556),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3687] = {
    [sym_string] = STATE(6503),
    [aux_sym_chained_string_repeat1] = STATE(6503),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3688] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(9558),
    [anon_sym_COMMA] = ACTIONS(9558),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(9558),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(9536),
    [anon_sym_or] = ACTIONS(9536),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [3689] = {
    [anon_sym_LBRACE] = ACTIONS(9560),
    [anon_sym_COMMA] = ACTIONS(9560),
    [anon_sym_do] = ACTIONS(9560),
    [sym_comment] = ACTIONS(87),
  },
  [3690] = {
    [aux_sym_lambda_parameters_repeat1] = STATE(3690),
    [anon_sym_LBRACE] = ACTIONS(9560),
    [anon_sym_COMMA] = ACTIONS(9562),
    [anon_sym_do] = ACTIONS(9560),
    [sym_comment] = ACTIONS(87),
  },
  [3691] = {
    [ts_builtin_sym_end] = ACTIONS(9565),
    [sym_comment] = ACTIONS(87),
  },
  [3692] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(47),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(49),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(49),
    [sym_operator_assignment] = STATE(49),
    [sym_conditional] = STATE(49),
    [sym_range] = STATE(49),
    [sym_binary] = STATE(49),
    [sym_unary] = STATE(49),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [anon_sym_undef] = ACTIONS(83),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3693] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [3694] = {
    [sym__string_end2] = ACTIONS(9567),
    [sym_comment] = ACTIONS(87),
  },
  [3695] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3696] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6513),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(6513),
    [sym_operator_assignment] = STATE(6513),
    [sym_conditional] = STATE(6513),
    [sym_range] = STATE(6513),
    [sym_binary] = STATE(6513),
    [sym_unary] = STATE(6513),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3697] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6518),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(6518),
    [sym_operator_assignment] = STATE(6518),
    [sym_conditional] = STATE(6518),
    [sym_range] = STATE(6518),
    [sym_binary] = STATE(6518),
    [sym_unary] = STATE(6518),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3698] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6520),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(6520),
    [sym_operator_assignment] = STATE(6520),
    [sym_conditional] = STATE(6520),
    [sym_range] = STATE(6520),
    [sym_binary] = STATE(6520),
    [sym_unary] = STATE(6520),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3699] = {
    [anon_sym_COLON] = ACTIONS(9595),
    [sym_comment] = ACTIONS(87),
  },
  [3700] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6523),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(6523),
    [sym_operator_assignment] = STATE(6523),
    [sym_conditional] = STATE(6523),
    [sym_range] = STATE(6523),
    [sym_binary] = STATE(6523),
    [sym_unary] = STATE(6523),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3701] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6530),
    [sym__argument] = STATE(6531),
    [sym_splat_argument] = STATE(6531),
    [sym_hash_splat_argument] = STATE(6531),
    [sym_block_argument] = STATE(6531),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6531),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3702] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(6530),
    [sym__argument] = STATE(6531),
    [sym_splat_argument] = STATE(6531),
    [sym_hash_splat_argument] = STATE(6531),
    [sym_block_argument] = STATE(6531),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6531),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3703] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(6530),
    [sym__argument] = STATE(6531),
    [sym_splat_argument] = STATE(6531),
    [sym_hash_splat_argument] = STATE(6531),
    [sym_block_argument] = STATE(6531),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6531),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3704] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(6530),
    [sym__argument] = STATE(6531),
    [sym_splat_argument] = STATE(6531),
    [sym_hash_splat_argument] = STATE(6531),
    [sym_block_argument] = STATE(6531),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6531),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3705] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6533),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(6533),
    [sym_operator_assignment] = STATE(6533),
    [sym_conditional] = STATE(6533),
    [sym_range] = STATE(6533),
    [sym_binary] = STATE(6533),
    [sym_unary] = STATE(6533),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3706] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6534),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(6534),
    [sym_operator_assignment] = STATE(6534),
    [sym_conditional] = STATE(6534),
    [sym_range] = STATE(6534),
    [sym_binary] = STATE(6534),
    [sym_unary] = STATE(6534),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3707] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3708] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9605),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3709] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(9619),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(1647),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [3710] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3711] = {
    [sym_heredoc_body] = STATE(6557),
    [aux_sym_call_repeat1] = STATE(6557),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3712] = {
    [sym_heredoc_body] = STATE(6557),
    [aux_sym_call_repeat1] = STATE(6557),
    [aux_sym_argument_list_repeat1] = STATE(6559),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9647),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3713] = {
    [anon_sym_EQ] = ACTIONS(9649),
    [sym_comment] = ACTIONS(87),
  },
  [3714] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9651),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9653),
    [anon_sym_DASH_EQ] = ACTIONS(9653),
    [anon_sym_STAR_EQ] = ACTIONS(9653),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9653),
    [anon_sym_SLASH_EQ] = ACTIONS(9653),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9653),
    [anon_sym_PIPE_EQ] = ACTIONS(9653),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9653),
    [anon_sym_AMP_EQ] = ACTIONS(9653),
    [anon_sym_PERCENT_EQ] = ACTIONS(9653),
    [anon_sym_GT_GT_EQ] = ACTIONS(9653),
    [anon_sym_LT_LT_EQ] = ACTIONS(9653),
    [anon_sym_CARET_EQ] = ACTIONS(9653),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3715] = {
    [sym_string] = STATE(6562),
    [aux_sym_chained_string_repeat1] = STATE(6562),
    [sym__string_start2] = ACTIONS(9591),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9655),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3716] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3717] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [3718] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6563),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6563),
    [sym_operator_assignment] = STATE(6563),
    [sym_conditional] = STATE(6563),
    [sym_range] = STATE(6563),
    [sym_binary] = STATE(6563),
    [sym_unary] = STATE(6563),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3719] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6564),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6564),
    [sym_operator_assignment] = STATE(6564),
    [sym_conditional] = STATE(6564),
    [sym_range] = STATE(6564),
    [sym_binary] = STATE(6564),
    [sym_unary] = STATE(6564),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3720] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6565),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6565),
    [sym_operator_assignment] = STATE(6565),
    [sym_conditional] = STATE(6565),
    [sym_range] = STATE(6565),
    [sym_binary] = STATE(6565),
    [sym_unary] = STATE(6565),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3721] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6566),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6566),
    [sym_operator_assignment] = STATE(6566),
    [sym_conditional] = STATE(6566),
    [sym_range] = STATE(6566),
    [sym_binary] = STATE(6566),
    [sym_unary] = STATE(6566),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3722] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6567),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6567),
    [sym_operator_assignment] = STATE(6567),
    [sym_conditional] = STATE(6567),
    [sym_range] = STATE(6567),
    [sym_binary] = STATE(6567),
    [sym_unary] = STATE(6567),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3723] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6568),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6568),
    [sym_operator_assignment] = STATE(6568),
    [sym_conditional] = STATE(6568),
    [sym_range] = STATE(6568),
    [sym_binary] = STATE(6568),
    [sym_unary] = STATE(6568),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3724] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6569),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6569),
    [sym_operator_assignment] = STATE(6569),
    [sym_conditional] = STATE(6569),
    [sym_range] = STATE(6569),
    [sym_binary] = STATE(6569),
    [sym_unary] = STATE(6569),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3725] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6570),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(55),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(55),
    [sym_assignment] = STATE(6570),
    [sym_operator_assignment] = STATE(6570),
    [sym_conditional] = STATE(6570),
    [sym_range] = STATE(6570),
    [sym_binary] = STATE(6570),
    [sym_unary] = STATE(6570),
    [sym_left_assignment_list] = STATE(52),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(55),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(55),
    [sym_false] = STATE(55),
    [sym_nil] = STATE(55),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(56),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(21),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(47),
    [anon_sym_yield] = ACTIONS(49),
    [anon_sym_break] = ACTIONS(51),
    [anon_sym_next] = ACTIONS(53),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(71),
    [anon_sym_defined_QMARK] = ACTIONS(73),
    [anon_sym_not] = ACTIONS(75),
    [anon_sym_BANG] = ACTIONS(77),
    [anon_sym_TILDE] = ACTIONS(77),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3726] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6571),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6571),
    [sym_operator_assignment] = STATE(6571),
    [sym_conditional] = STATE(6571),
    [sym_range] = STATE(6571),
    [sym_binary] = STATE(6571),
    [sym_unary] = STATE(6571),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3727] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6572),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6572),
    [sym_operator_assignment] = STATE(6572),
    [sym_conditional] = STATE(6572),
    [sym_range] = STATE(6572),
    [sym_binary] = STATE(6572),
    [sym_unary] = STATE(6572),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3728] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6573),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6573),
    [sym_operator_assignment] = STATE(6573),
    [sym_conditional] = STATE(6573),
    [sym_range] = STATE(6573),
    [sym_binary] = STATE(6573),
    [sym_unary] = STATE(6573),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3729] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6574),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6574),
    [sym_operator_assignment] = STATE(6574),
    [sym_conditional] = STATE(6574),
    [sym_range] = STATE(6574),
    [sym_binary] = STATE(6574),
    [sym_unary] = STATE(6574),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3730] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6575),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6575),
    [sym_operator_assignment] = STATE(6575),
    [sym_conditional] = STATE(6575),
    [sym_range] = STATE(6575),
    [sym_binary] = STATE(6575),
    [sym_unary] = STATE(6575),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3731] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6584),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(6584),
    [sym_operator_assignment] = STATE(6584),
    [sym_conditional] = STATE(6584),
    [sym_range] = STATE(6584),
    [sym_binary] = STATE(6584),
    [sym_unary] = STATE(6584),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3732] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6589),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(6589),
    [sym_operator_assignment] = STATE(6589),
    [sym_conditional] = STATE(6589),
    [sym_range] = STATE(6589),
    [sym_binary] = STATE(6589),
    [sym_unary] = STATE(6589),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3733] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6591),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(6591),
    [sym_operator_assignment] = STATE(6591),
    [sym_conditional] = STATE(6591),
    [sym_range] = STATE(6591),
    [sym_binary] = STATE(6591),
    [sym_unary] = STATE(6591),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3734] = {
    [anon_sym_COLON] = ACTIONS(9683),
    [sym_comment] = ACTIONS(87),
  },
  [3735] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6594),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(6594),
    [sym_operator_assignment] = STATE(6594),
    [sym_conditional] = STATE(6594),
    [sym_range] = STATE(6594),
    [sym_binary] = STATE(6594),
    [sym_unary] = STATE(6594),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [3736] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3737] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3738] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3739] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3740] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6595),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(6595),
    [sym_operator_assignment] = STATE(6595),
    [sym_conditional] = STATE(6595),
    [sym_range] = STATE(6595),
    [sym_binary] = STATE(6595),
    [sym_unary] = STATE(6595),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3741] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6596),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(6596),
    [sym_operator_assignment] = STATE(6596),
    [sym_conditional] = STATE(6596),
    [sym_range] = STATE(6596),
    [sym_binary] = STATE(6596),
    [sym_unary] = STATE(6596),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3742] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3743] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9685),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3744] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(9699),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(1647),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [3745] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(6554),
    [sym__argument] = STATE(6555),
    [sym_splat_argument] = STATE(6555),
    [sym_hash_splat_argument] = STATE(6555),
    [sym_block_argument] = STATE(6555),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6555),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3746] = {
    [sym_heredoc_body] = STATE(6610),
    [aux_sym_call_repeat1] = STATE(6610),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3747] = {
    [sym_heredoc_body] = STATE(6610),
    [aux_sym_call_repeat1] = STATE(6610),
    [aux_sym_argument_list_repeat1] = STATE(6612),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9717),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3748] = {
    [anon_sym_EQ] = ACTIONS(9719),
    [sym_comment] = ACTIONS(87),
  },
  [3749] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9721),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9723),
    [anon_sym_DASH_EQ] = ACTIONS(9723),
    [anon_sym_STAR_EQ] = ACTIONS(9723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9723),
    [anon_sym_SLASH_EQ] = ACTIONS(9723),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9723),
    [anon_sym_PIPE_EQ] = ACTIONS(9723),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9723),
    [anon_sym_AMP_EQ] = ACTIONS(9723),
    [anon_sym_PERCENT_EQ] = ACTIONS(9723),
    [anon_sym_GT_GT_EQ] = ACTIONS(9723),
    [anon_sym_LT_LT_EQ] = ACTIONS(9723),
    [anon_sym_CARET_EQ] = ACTIONS(9723),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3750] = {
    [sym_string] = STATE(6615),
    [aux_sym_chained_string_repeat1] = STATE(6615),
    [sym__string_start2] = ACTIONS(9679),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9725),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3751] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6625),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_splat_argument] = STATE(6626),
    [sym_assignment] = STATE(6625),
    [sym_operator_assignment] = STATE(6625),
    [sym_conditional] = STATE(6625),
    [sym_range] = STATE(6625),
    [sym_binary] = STATE(6625),
    [sym_unary] = STATE(6625),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(6626),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(9727),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3752] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6630),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6630),
    [sym_operator_assignment] = STATE(6630),
    [sym_conditional] = STATE(6630),
    [sym_range] = STATE(6630),
    [sym_binary] = STATE(6630),
    [sym_unary] = STATE(6630),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3753] = {
    [sym_string] = STATE(6631),
    [aux_sym_chained_string_repeat1] = STATE(6631),
    [sym__string_start2] = ACTIONS(2549),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3754] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(3158),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_LPAREN2] = ACTIONS(3158),
    [anon_sym_DOT_DOT] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [anon_sym_BANG] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(3158),
    [sym_identifier] = ACTIONS(3158),
    [anon_sym_DASH] = ACTIONS(4982),
    [anon_sym_PLUS_AT] = ACTIONS(3158),
    [anon_sym_DASH_AT] = ACTIONS(3158),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(4982),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(3158),
    [anon_sym_BQUOTE] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [3755] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(9747),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [3756] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4244),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_end] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_rescue] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_when] = ACTIONS(4244),
    [anon_sym_elsif] = ACTIONS(4244),
    [anon_sym_else] = ACTIONS(4244),
    [anon_sym_then] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_ensure] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [3757] = {
    [sym_heredoc_body] = STATE(6634),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(9749),
    [sym_comment] = ACTIONS(87),
  },
  [3758] = {
    [anon_sym_RPAREN] = ACTIONS(9749),
    [sym_comment] = ACTIONS(87),
  },
  [3759] = {
    [sym__line_break2] = ACTIONS(9751),
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym__heredoc_body_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [ts_builtin_sym_end] = ACTIONS(9751),
    [anon_sym___END__] = ACTIONS(9753),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_end] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_rescue] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_when] = ACTIONS(9753),
    [anon_sym_elsif] = ACTIONS(9753),
    [anon_sym_else] = ACTIONS(9753),
    [anon_sym_then] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_ensure] = ACTIONS(9753),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [3760] = {
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(9755),
    [anon_sym_PIPE] = ACTIONS(7888),
    [anon_sym_STAR] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7888),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LPAREN2] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [anon_sym_BANG] = ACTIONS(7893),
    [anon_sym_TILDE] = ACTIONS(7888),
    [sym_constant] = ACTIONS(7888),
    [sym_identifier] = ACTIONS(7888),
    [anon_sym_DASH] = ACTIONS(7893),
    [anon_sym_PLUS_AT] = ACTIONS(7888),
    [anon_sym_DASH_AT] = ACTIONS(7888),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(7893),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(7888),
    [anon_sym_BQUOTE] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [3761] = {
    [sym__line_break2] = ACTIONS(9758),
    [sym__heredoc_body_start2] = ACTIONS(9758),
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [ts_builtin_sym_end] = ACTIONS(9758),
    [anon_sym___END__] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9758),
    [anon_sym_if] = ACTIONS(9758),
    [anon_sym_unless] = ACTIONS(9758),
    [anon_sym_while] = ACTIONS(9758),
    [anon_sym_until] = ACTIONS(9758),
    [anon_sym_rescue] = ACTIONS(9758),
    [anon_sym_do] = ACTIONS(9758),
    [anon_sym_when] = ACTIONS(9758),
    [anon_sym_elsif] = ACTIONS(9758),
    [anon_sym_else] = ACTIONS(9758),
    [anon_sym_then] = ACTIONS(9758),
    [anon_sym_ensure] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [3762] = {
    [anon_sym_RBRACK] = ACTIONS(9762),
    [sym_comment] = ACTIONS(87),
  },
  [3763] = {
    [sym__line_break2] = ACTIONS(2947),
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym___END__] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_end] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_when] = ACTIONS(2947),
    [anon_sym_elsif] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_then] = ACTIONS(2947),
    [anon_sym_ensure] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(87),
  },
  [3764] = {
    [sym__line_break2] = ACTIONS(2959),
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [anon_sym___END__] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_end] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_when] = ACTIONS(2959),
    [anon_sym_elsif] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_then] = ACTIONS(2959),
    [anon_sym_ensure] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [sym_comment] = ACTIONS(87),
  },
  [3765] = {
    [sym__line_break2] = ACTIONS(2963),
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [ts_builtin_sym_end] = ACTIONS(2963),
    [anon_sym___END__] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_end] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_elsif] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_then] = ACTIONS(2963),
    [anon_sym_ensure] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [sym_comment] = ACTIONS(87),
  },
  [3766] = {
    [sym__line_break2] = ACTIONS(2967),
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [ts_builtin_sym_end] = ACTIONS(2967),
    [anon_sym___END__] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_end] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_elsif] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_then] = ACTIONS(2967),
    [anon_sym_ensure] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [sym_comment] = ACTIONS(87),
  },
  [3767] = {
    [sym__line_break2] = ACTIONS(2973),
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [ts_builtin_sym_end] = ACTIONS(2973),
    [anon_sym___END__] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_end] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_when] = ACTIONS(2973),
    [anon_sym_elsif] = ACTIONS(2973),
    [anon_sym_else] = ACTIONS(2973),
    [anon_sym_then] = ACTIONS(2973),
    [anon_sym_ensure] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [sym_comment] = ACTIONS(87),
  },
  [3768] = {
    [sym__string_end2] = ACTIONS(9764),
    [sym_comment] = ACTIONS(87),
  },
  [3769] = {
    [aux_sym_string_array_repeat1] = STATE(6639),
    [sym__string_end2] = ACTIONS(9766),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9768),
  },
  [3770] = {
    [sym__line_break2] = ACTIONS(2983),
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [anon_sym___END__] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_when] = ACTIONS(2983),
    [anon_sym_elsif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_then] = ACTIONS(2983),
    [anon_sym_ensure] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [sym_comment] = ACTIONS(87),
  },
  [3771] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9770),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3772] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(9770),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9772),
  },
  [3773] = {
    [sym__line_break2] = ACTIONS(3002),
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [ts_builtin_sym_end] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_when] = ACTIONS(3002),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_then] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(87),
  },
  [3774] = {
    [sym__string_end2] = ACTIONS(9774),
    [sym_comment] = ACTIONS(87),
  },
  [3775] = {
    [aux_sym_symbol_array_repeat1] = STATE(6645),
    [sym__string_end2] = ACTIONS(9776),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9778),
  },
  [3776] = {
    [sym__line_break2] = ACTIONS(3012),
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3012),
    [anon_sym___END__] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_end] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_when] = ACTIONS(3012),
    [anon_sym_elsif] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_then] = ACTIONS(3012),
    [anon_sym_ensure] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [sym_comment] = ACTIONS(87),
  },
  [3777] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9780),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [3778] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(9780),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9782),
  },
  [3779] = {
    [sym__line_break2] = ACTIONS(841),
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [ts_builtin_sym_end] = ACTIONS(841),
    [anon_sym___END__] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_end] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_when] = ACTIONS(841),
    [anon_sym_elsif] = ACTIONS(841),
    [anon_sym_else] = ACTIONS(841),
    [anon_sym_then] = ACTIONS(841),
    [anon_sym_ensure] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
    [anon_sym_STAR_EQ] = ACTIONS(841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(841),
    [anon_sym_SLASH_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(841),
    [anon_sym_PIPE_EQ] = ACTIONS(841),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(841),
    [anon_sym_AMP_EQ] = ACTIONS(841),
    [anon_sym_PERCENT_EQ] = ACTIONS(841),
    [anon_sym_GT_GT_EQ] = ACTIONS(841),
    [anon_sym_LT_LT_EQ] = ACTIONS(841),
    [anon_sym_CARET_EQ] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [sym_comment] = ACTIONS(87),
  },
  [3780] = {
    [sym__string_end2] = ACTIONS(9784),
    [sym_comment] = ACTIONS(87),
  },
  [3781] = {
    [sym__line_break2] = ACTIONS(891),
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [ts_builtin_sym_end] = ACTIONS(891),
    [anon_sym___END__] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_end] = ACTIONS(891),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_when] = ACTIONS(891),
    [anon_sym_elsif] = ACTIONS(891),
    [anon_sym_else] = ACTIONS(891),
    [anon_sym_then] = ACTIONS(891),
    [anon_sym_ensure] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [3782] = {
    [sym__string_end2] = ACTIONS(9786),
    [sym_comment] = ACTIONS(87),
  },
  [3783] = {
    [sym__line_break2] = ACTIONS(897),
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [ts_builtin_sym_end] = ACTIONS(897),
    [anon_sym___END__] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_end] = ACTIONS(897),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_when] = ACTIONS(897),
    [anon_sym_elsif] = ACTIONS(897),
    [anon_sym_else] = ACTIONS(897),
    [anon_sym_then] = ACTIONS(897),
    [anon_sym_ensure] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [anon_sym_DASH_EQ] = ACTIONS(897),
    [anon_sym_STAR_EQ] = ACTIONS(897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(897),
    [anon_sym_SLASH_EQ] = ACTIONS(897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(897),
    [anon_sym_PIPE_EQ] = ACTIONS(897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(897),
    [anon_sym_AMP_EQ] = ACTIONS(897),
    [anon_sym_PERCENT_EQ] = ACTIONS(897),
    [anon_sym_GT_GT_EQ] = ACTIONS(897),
    [anon_sym_LT_LT_EQ] = ACTIONS(897),
    [anon_sym_CARET_EQ] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [3784] = {
    [sym__string_end2] = ACTIONS(9788),
    [sym_comment] = ACTIONS(87),
  },
  [3785] = {
    [sym__line_break2] = ACTIONS(903),
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [ts_builtin_sym_end] = ACTIONS(903),
    [anon_sym___END__] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_end] = ACTIONS(903),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_when] = ACTIONS(903),
    [anon_sym_elsif] = ACTIONS(903),
    [anon_sym_else] = ACTIONS(903),
    [anon_sym_then] = ACTIONS(903),
    [anon_sym_ensure] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [anon_sym_DASH_EQ] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(903),
    [anon_sym_SLASH_EQ] = ACTIONS(903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(903),
    [anon_sym_PIPE_EQ] = ACTIONS(903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(903),
    [anon_sym_AMP_EQ] = ACTIONS(903),
    [anon_sym_PERCENT_EQ] = ACTIONS(903),
    [anon_sym_GT_GT_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_EQ] = ACTIONS(903),
    [anon_sym_CARET_EQ] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [3786] = {
    [sym__string_end2] = ACTIONS(9790),
    [sym_comment] = ACTIONS(87),
  },
  [3787] = {
    [sym__line_break2] = ACTIONS(909),
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [ts_builtin_sym_end] = ACTIONS(909),
    [anon_sym___END__] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_end] = ACTIONS(909),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_when] = ACTIONS(909),
    [anon_sym_elsif] = ACTIONS(909),
    [anon_sym_else] = ACTIONS(909),
    [anon_sym_then] = ACTIONS(909),
    [anon_sym_ensure] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [sym_comment] = ACTIONS(87),
  },
  [3788] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(6654),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9792),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9794),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3789] = {
    [aux_sym_string_array_repeat1] = STATE(6657),
    [sym__string_end2] = ACTIONS(9796),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9798),
  },
  [3790] = {
    [sym__line_break2] = ACTIONS(927),
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [ts_builtin_sym_end] = ACTIONS(927),
    [anon_sym___END__] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_end] = ACTIONS(927),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_when] = ACTIONS(927),
    [anon_sym_elsif] = ACTIONS(927),
    [anon_sym_else] = ACTIONS(927),
    [anon_sym_then] = ACTIONS(927),
    [anon_sym_ensure] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [sym_comment] = ACTIONS(87),
  },
  [3791] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(6660),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(9800),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9802),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [3792] = {
    [aux_sym_symbol_array_repeat1] = STATE(6663),
    [sym__string_end2] = ACTIONS(9804),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(9806),
  },
  [3793] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [3794] = {
    [sym__line_break2] = ACTIONS(997),
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [sym_comment] = ACTIONS(87),
  },
  [3795] = {
    [anon_sym_RBRACE] = ACTIONS(9808),
    [sym_comment] = ACTIONS(87),
  },
  [3796] = {
    [sym_heredoc_body] = STATE(6665),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(9808),
    [sym_comment] = ACTIONS(87),
  },
  [3797] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6666),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(6666),
    [sym_operator_assignment] = STATE(6666),
    [sym_conditional] = STATE(6666),
    [sym_range] = STATE(6666),
    [sym_binary] = STATE(6666),
    [sym_unary] = STATE(6666),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3798] = {
    [sym__line_break2] = ACTIONS(1283),
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [ts_builtin_sym_end] = ACTIONS(1283),
    [anon_sym___END__] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_end] = ACTIONS(1283),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_when] = ACTIONS(1283),
    [anon_sym_elsif] = ACTIONS(1283),
    [anon_sym_else] = ACTIONS(1283),
    [anon_sym_then] = ACTIONS(1283),
    [anon_sym_ensure] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1283),
    [anon_sym_STAR_EQ] = ACTIONS(1283),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1283),
    [anon_sym_AMP_EQ] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [sym_comment] = ACTIONS(87),
  },
  [3799] = {
    [anon_sym_DOT] = ACTIONS(9810),
    [anon_sym_COLON_COLON] = ACTIONS(9810),
    [sym_comment] = ACTIONS(87),
  },
  [3800] = {
    [sym_method_parameters] = STATE(6668),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(6668),
    [sym__terminator] = STATE(6668),
    [sym__line_break2] = ACTIONS(9812),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(9812),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [3801] = {
    [sym__line_break2] = ACTIONS(1301),
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [ts_builtin_sym_end] = ACTIONS(1301),
    [anon_sym___END__] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_end] = ACTIONS(1301),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_when] = ACTIONS(1301),
    [anon_sym_elsif] = ACTIONS(1301),
    [anon_sym_else] = ACTIONS(1301),
    [anon_sym_then] = ACTIONS(1301),
    [anon_sym_ensure] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_PLUS_EQ] = ACTIONS(1301),
    [anon_sym_DASH_EQ] = ACTIONS(1301),
    [anon_sym_STAR_EQ] = ACTIONS(1301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1301),
    [anon_sym_SLASH_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1301),
    [anon_sym_AMP_EQ] = ACTIONS(1301),
    [anon_sym_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_GT_GT_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_EQ] = ACTIONS(1301),
    [anon_sym_CARET_EQ] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1303),
    [sym_comment] = ACTIONS(87),
  },
  [3802] = {
    [anon_sym_RPAREN] = ACTIONS(9814),
    [sym_comment] = ACTIONS(87),
  },
  [3803] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6670),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(6670),
    [sym_operator_assignment] = STATE(6670),
    [sym_conditional] = STATE(6670),
    [sym_range] = STATE(6670),
    [sym_binary] = STATE(6670),
    [sym_unary] = STATE(6670),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3804] = {
    [sym_superclass] = STATE(6671),
    [sym_heredoc_body] = STATE(6672),
    [sym__terminator] = STATE(6672),
    [sym__line_break2] = ACTIONS(9816),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(9816),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3805] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(6671),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6672),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(6672),
    [sym__line_break2] = ACTIONS(9816),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(9816),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3806] = {
    [sym_heredoc_body] = STATE(6674),
    [sym__terminator] = STATE(6674),
    [sym__line_break2] = ACTIONS(9818),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(9818),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(9820),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3807] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6674),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(6674),
    [sym__line_break2] = ACTIONS(9818),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(9818),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(9820),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3808] = {
    [sym__line_break2] = ACTIONS(1699),
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [ts_builtin_sym_end] = ACTIONS(1699),
    [anon_sym___END__] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_end] = ACTIONS(1699),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_when] = ACTIONS(1699),
    [anon_sym_elsif] = ACTIONS(1699),
    [anon_sym_else] = ACTIONS(1699),
    [anon_sym_then] = ACTIONS(1699),
    [anon_sym_ensure] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [3809] = {
    [sym__line_break2] = ACTIONS(1719),
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [ts_builtin_sym_end] = ACTIONS(1719),
    [anon_sym___END__] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_end] = ACTIONS(1719),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_when] = ACTIONS(1719),
    [anon_sym_elsif] = ACTIONS(1719),
    [anon_sym_else] = ACTIONS(1719),
    [anon_sym_then] = ACTIONS(1719),
    [anon_sym_ensure] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [sym_comment] = ACTIONS(87),
  },
  [3810] = {
    [sym__line_break2] = ACTIONS(1723),
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [ts_builtin_sym_end] = ACTIONS(1723),
    [anon_sym___END__] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1725),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_end] = ACTIONS(1723),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_when] = ACTIONS(1723),
    [anon_sym_elsif] = ACTIONS(1723),
    [anon_sym_else] = ACTIONS(1723),
    [anon_sym_then] = ACTIONS(1723),
    [anon_sym_ensure] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_PLUS_EQ] = ACTIONS(1723),
    [anon_sym_DASH_EQ] = ACTIONS(1723),
    [anon_sym_STAR_EQ] = ACTIONS(1723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1723),
    [anon_sym_SLASH_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1723),
    [anon_sym_AMP_EQ] = ACTIONS(1723),
    [anon_sym_PERCENT_EQ] = ACTIONS(1723),
    [anon_sym_GT_GT_EQ] = ACTIONS(1723),
    [anon_sym_LT_LT_EQ] = ACTIONS(1723),
    [anon_sym_CARET_EQ] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1725),
    [anon_sym_AMP_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1725),
    [anon_sym_GT_GT] = ACTIONS(1725),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_SLASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1725),
    [sym_comment] = ACTIONS(87),
  },
  [3811] = {
    [sym__line_break2] = ACTIONS(1727),
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [ts_builtin_sym_end] = ACTIONS(1727),
    [anon_sym___END__] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_end] = ACTIONS(1727),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_when] = ACTIONS(1727),
    [anon_sym_elsif] = ACTIONS(1727),
    [anon_sym_else] = ACTIONS(1727),
    [anon_sym_then] = ACTIONS(1727),
    [anon_sym_ensure] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1727),
    [anon_sym_DASH_EQ] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1727),
    [anon_sym_SLASH_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1727),
    [anon_sym_AMP_EQ] = ACTIONS(1727),
    [anon_sym_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_GT_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_EQ] = ACTIONS(1727),
    [anon_sym_CARET_EQ] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [sym_comment] = ACTIONS(87),
  },
  [3812] = {
    [sym__then] = STATE(6675),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(9822),
    [sym_comment] = ACTIONS(87),
  },
  [3813] = {
    [sym__then] = STATE(6676),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(9824),
    [sym_comment] = ACTIONS(87),
  },
  [3814] = {
    [sym__do] = STATE(6677),
    [sym_heredoc_body] = STATE(6677),
    [sym__terminator] = STATE(6677),
    [sym__line_break2] = ACTIONS(9826),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(9826),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(9826),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [3815] = {
    [sym__do] = STATE(6678),
    [sym_heredoc_body] = STATE(6678),
    [sym__terminator] = STATE(6678),
    [sym__line_break2] = ACTIONS(9828),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(9828),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(9828),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [3816] = {
    [sym_in] = STATE(6679),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [3817] = {
    [sym_heredoc_body] = STATE(6680),
    [sym__terminator] = STATE(6680),
    [sym__line_break2] = ACTIONS(9830),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(9830),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3818] = {
    [sym_when] = STATE(6681),
    [aux_sym_case_repeat1] = STATE(6682),
    [anon_sym_SEMI] = ACTIONS(9832),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3819] = {
    [sym_else] = STATE(6684),
    [sym_ensure] = STATE(6685),
    [sym_rescue] = STATE(6686),
    [anon_sym_end] = ACTIONS(9834),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3820] = {
    [sym_ensure] = STATE(6685),
    [anon_sym_end] = ACTIONS(9834),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3821] = {
    [anon_sym_end] = ACTIONS(9834),
    [sym_comment] = ACTIONS(87),
  },
  [3822] = {
    [sym_else] = STATE(6684),
    [sym_ensure] = STATE(6685),
    [anon_sym_end] = ACTIONS(9834),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3823] = {
    [sym__line_break2] = ACTIONS(2219),
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [ts_builtin_sym_end] = ACTIONS(2219),
    [anon_sym___END__] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_end] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_when] = ACTIONS(2219),
    [anon_sym_elsif] = ACTIONS(2219),
    [anon_sym_else] = ACTIONS(2219),
    [anon_sym_then] = ACTIONS(2219),
    [anon_sym_ensure] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_PLUS_EQ] = ACTIONS(2219),
    [anon_sym_DASH_EQ] = ACTIONS(2219),
    [anon_sym_STAR_EQ] = ACTIONS(2219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2219),
    [anon_sym_SLASH_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2219),
    [anon_sym_AMP_EQ] = ACTIONS(2219),
    [anon_sym_PERCENT_EQ] = ACTIONS(2219),
    [anon_sym_GT_GT_EQ] = ACTIONS(2219),
    [anon_sym_LT_LT_EQ] = ACTIONS(2219),
    [anon_sym_CARET_EQ] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [sym_comment] = ACTIONS(87),
  },
  [3824] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(6687),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9836),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3825] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [3826] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [3827] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [3828] = {
    [sym__line_break2] = ACTIONS(2307),
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [ts_builtin_sym_end] = ACTIONS(2307),
    [anon_sym___END__] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_end] = ACTIONS(2307),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_when] = ACTIONS(2307),
    [anon_sym_elsif] = ACTIONS(2307),
    [anon_sym_else] = ACTIONS(2307),
    [anon_sym_then] = ACTIONS(2307),
    [anon_sym_ensure] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2309),
    [anon_sym_GT_GT] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [sym_comment] = ACTIONS(87),
  },
  [3829] = {
    [sym__line_break2] = ACTIONS(2391),
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [ts_builtin_sym_end] = ACTIONS(2391),
    [anon_sym___END__] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2393),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_end] = ACTIONS(2391),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_when] = ACTIONS(2391),
    [anon_sym_elsif] = ACTIONS(2391),
    [anon_sym_else] = ACTIONS(2391),
    [anon_sym_then] = ACTIONS(2391),
    [anon_sym_ensure] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_PLUS_EQ] = ACTIONS(2391),
    [anon_sym_DASH_EQ] = ACTIONS(2391),
    [anon_sym_STAR_EQ] = ACTIONS(2391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2391),
    [anon_sym_SLASH_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2391),
    [anon_sym_AMP_EQ] = ACTIONS(2391),
    [anon_sym_PERCENT_EQ] = ACTIONS(2391),
    [anon_sym_GT_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_EQ] = ACTIONS(2391),
    [anon_sym_CARET_EQ] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2393),
    [anon_sym_AMP_AMP] = ACTIONS(2393),
    [anon_sym_LT_LT] = ACTIONS(2393),
    [anon_sym_GT_GT] = ACTIONS(2393),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_PERCENT] = ACTIONS(2393),
    [sym_comment] = ACTIONS(87),
  },
  [3830] = {
    [sym_heredoc_body] = STATE(6689),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9838),
    [sym_comment] = ACTIONS(87),
  },
  [3831] = {
    [anon_sym_RBRACK] = ACTIONS(9838),
    [sym_comment] = ACTIONS(87),
  },
  [3832] = {
    [sym_do_block] = STATE(6690),
    [sym_block] = STATE(6690),
    [anon_sym_LBRACE] = ACTIONS(2775),
    [anon_sym_do] = ACTIONS(2779),
    [sym_comment] = ACTIONS(87),
  },
  [3833] = {
    [sym__line_break2] = ACTIONS(2537),
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [ts_builtin_sym_end] = ACTIONS(2537),
    [anon_sym___END__] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_end] = ACTIONS(2537),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_when] = ACTIONS(2537),
    [anon_sym_elsif] = ACTIONS(2537),
    [anon_sym_else] = ACTIONS(2537),
    [anon_sym_then] = ACTIONS(2537),
    [anon_sym_ensure] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_PLUS_EQ] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2537),
    [anon_sym_STAR_EQ] = ACTIONS(2537),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2537),
    [anon_sym_AMP_EQ] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2539),
    [anon_sym_AMP_AMP] = ACTIONS(2539),
    [anon_sym_LT_LT] = ACTIONS(2539),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [anon_sym_PERCENT] = ACTIONS(2539),
    [sym_comment] = ACTIONS(87),
  },
  [3834] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6691),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6691),
    [sym_operator_assignment] = STATE(6691),
    [sym_conditional] = STATE(6691),
    [sym_range] = STATE(6691),
    [sym_binary] = STATE(6691),
    [sym_unary] = STATE(6691),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3835] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6692),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6692),
    [sym_operator_assignment] = STATE(6692),
    [sym_conditional] = STATE(6692),
    [sym_range] = STATE(6692),
    [sym_binary] = STATE(6692),
    [sym_unary] = STATE(6692),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3836] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6693),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6693),
    [sym_operator_assignment] = STATE(6693),
    [sym_conditional] = STATE(6693),
    [sym_range] = STATE(6693),
    [sym_binary] = STATE(6693),
    [sym_unary] = STATE(6693),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3837] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6694),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6694),
    [sym_operator_assignment] = STATE(6694),
    [sym_conditional] = STATE(6694),
    [sym_range] = STATE(6694),
    [sym_binary] = STATE(6694),
    [sym_unary] = STATE(6694),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3838] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6695),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6695),
    [sym_operator_assignment] = STATE(6695),
    [sym_conditional] = STATE(6695),
    [sym_range] = STATE(6695),
    [sym_binary] = STATE(6695),
    [sym_unary] = STATE(6695),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3839] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6696),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6696),
    [sym_operator_assignment] = STATE(6696),
    [sym_conditional] = STATE(6696),
    [sym_range] = STATE(6696),
    [sym_binary] = STATE(6696),
    [sym_unary] = STATE(6696),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3840] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6697),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6697),
    [sym_operator_assignment] = STATE(6697),
    [sym_conditional] = STATE(6697),
    [sym_range] = STATE(6697),
    [sym_binary] = STATE(6697),
    [sym_unary] = STATE(6697),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3841] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6698),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6698),
    [sym_operator_assignment] = STATE(6698),
    [sym_conditional] = STATE(6698),
    [sym_range] = STATE(6698),
    [sym_binary] = STATE(6698),
    [sym_unary] = STATE(6698),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3842] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6699),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6699),
    [sym_operator_assignment] = STATE(6699),
    [sym_conditional] = STATE(6699),
    [sym_range] = STATE(6699),
    [sym_binary] = STATE(6699),
    [sym_unary] = STATE(6699),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3843] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6700),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6700),
    [sym_operator_assignment] = STATE(6700),
    [sym_conditional] = STATE(6700),
    [sym_range] = STATE(6700),
    [sym_binary] = STATE(6700),
    [sym_unary] = STATE(6700),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3844] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6701),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6701),
    [sym_operator_assignment] = STATE(6701),
    [sym_conditional] = STATE(6701),
    [sym_range] = STATE(6701),
    [sym_binary] = STATE(6701),
    [sym_unary] = STATE(6701),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3845] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6702),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6702),
    [sym_operator_assignment] = STATE(6702),
    [sym_conditional] = STATE(6702),
    [sym_range] = STATE(6702),
    [sym_binary] = STATE(6702),
    [sym_unary] = STATE(6702),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3846] = {
    [sym__statements] = STATE(1583),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(1584),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(1590),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(1591),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(9840),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3847] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6704),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_splat_argument] = STATE(6706),
    [sym_assignment] = STATE(6704),
    [sym_operator_assignment] = STATE(6704),
    [sym_conditional] = STATE(6704),
    [sym_range] = STATE(6704),
    [sym_binary] = STATE(6704),
    [sym_unary] = STATE(6704),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(6706),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3848] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6707),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(6707),
    [sym_operator_assignment] = STATE(6707),
    [sym_conditional] = STATE(6707),
    [sym_range] = STATE(6707),
    [sym_binary] = STATE(6707),
    [sym_unary] = STATE(6707),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [3849] = {
    [sym_string] = STATE(6708),
    [aux_sym_chained_string_repeat1] = STATE(6708),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [ts_builtin_sym_end] = ACTIONS(2807),
    [anon_sym___END__] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [3850] = {
    [sym__line_break2] = ACTIONS(997),
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [ts_builtin_sym_end] = ACTIONS(997),
    [anon_sym___END__] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_end] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_when] = ACTIONS(997),
    [anon_sym_elsif] = ACTIONS(997),
    [anon_sym_else] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(997),
    [anon_sym_ensure] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [sym_comment] = ACTIONS(87),
  },
  [3851] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6749),
    [anon_sym___END__] = ACTIONS(6749),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [3852] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3853] = {
    [sym_string] = STATE(3890),
    [aux_sym_chained_string_repeat1] = STATE(3890),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3854] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6709),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(6709),
    [sym_operator_assignment] = STATE(6709),
    [sym_conditional] = STATE(6709),
    [sym_range] = STATE(6709),
    [sym_binary] = STATE(6709),
    [sym_unary] = STATE(6709),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3855] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6710),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(6710),
    [sym_operator_assignment] = STATE(6710),
    [sym_conditional] = STATE(6710),
    [sym_range] = STATE(6710),
    [sym_binary] = STATE(6710),
    [sym_unary] = STATE(6710),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3856] = {
    [anon_sym_COLON] = ACTIONS(9842),
    [sym_comment] = ACTIONS(87),
  },
  [3857] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6712),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(6712),
    [sym_operator_assignment] = STATE(6712),
    [sym_conditional] = STATE(6712),
    [sym_range] = STATE(6712),
    [sym_binary] = STATE(6712),
    [sym_unary] = STATE(6712),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3858] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9844),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3859] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [3860] = {
    [sym_heredoc_body] = STATE(6714),
    [aux_sym_call_repeat1] = STATE(6714),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3861] = {
    [sym_heredoc_body] = STATE(6714),
    [aux_sym_call_repeat1] = STATE(6714),
    [aux_sym_argument_list_repeat1] = STATE(6716),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9846),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3862] = {
    [sym_string] = STATE(4196),
    [aux_sym_chained_string_repeat1] = STATE(4196),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9848),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3863] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3864] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [3865] = {
    [sym__line_break2] = ACTIONS(9486),
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [ts_builtin_sym_end] = ACTIONS(9486),
    [anon_sym___END__] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_end] = ACTIONS(9486),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_when] = ACTIONS(9486),
    [anon_sym_elsif] = ACTIONS(9486),
    [anon_sym_else] = ACTIONS(9486),
    [anon_sym_then] = ACTIONS(9486),
    [anon_sym_ensure] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [3866] = {
    [anon_sym_RBRACE] = ACTIONS(9850),
    [sym_comment] = ACTIONS(87),
  },
  [3867] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6718),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6718),
    [sym_operator_assignment] = STATE(6718),
    [sym_conditional] = STATE(6718),
    [sym_range] = STATE(6718),
    [sym_binary] = STATE(6718),
    [sym_unary] = STATE(6718),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3868] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6719),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6719),
    [sym_operator_assignment] = STATE(6719),
    [sym_conditional] = STATE(6719),
    [sym_range] = STATE(6719),
    [sym_binary] = STATE(6719),
    [sym_unary] = STATE(6719),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3869] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6720),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6720),
    [sym_operator_assignment] = STATE(6720),
    [sym_conditional] = STATE(6720),
    [sym_range] = STATE(6720),
    [sym_binary] = STATE(6720),
    [sym_unary] = STATE(6720),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3870] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6721),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6721),
    [sym_operator_assignment] = STATE(6721),
    [sym_conditional] = STATE(6721),
    [sym_range] = STATE(6721),
    [sym_binary] = STATE(6721),
    [sym_unary] = STATE(6721),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3871] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6722),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6722),
    [sym_operator_assignment] = STATE(6722),
    [sym_conditional] = STATE(6722),
    [sym_range] = STATE(6722),
    [sym_binary] = STATE(6722),
    [sym_unary] = STATE(6722),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3872] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6723),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6723),
    [sym_operator_assignment] = STATE(6723),
    [sym_conditional] = STATE(6723),
    [sym_range] = STATE(6723),
    [sym_binary] = STATE(6723),
    [sym_unary] = STATE(6723),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3873] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6724),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6724),
    [sym_operator_assignment] = STATE(6724),
    [sym_conditional] = STATE(6724),
    [sym_range] = STATE(6724),
    [sym_binary] = STATE(6724),
    [sym_unary] = STATE(6724),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3874] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6725),
    [sym_operator_assignment] = STATE(6725),
    [sym_conditional] = STATE(6725),
    [sym_range] = STATE(6725),
    [sym_binary] = STATE(6725),
    [sym_unary] = STATE(6725),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3875] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6726),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6726),
    [sym_operator_assignment] = STATE(6726),
    [sym_conditional] = STATE(6726),
    [sym_range] = STATE(6726),
    [sym_binary] = STATE(6726),
    [sym_unary] = STATE(6726),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3876] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6727),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6727),
    [sym_operator_assignment] = STATE(6727),
    [sym_conditional] = STATE(6727),
    [sym_range] = STATE(6727),
    [sym_binary] = STATE(6727),
    [sym_unary] = STATE(6727),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3877] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6728),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6728),
    [sym_operator_assignment] = STATE(6728),
    [sym_conditional] = STATE(6728),
    [sym_range] = STATE(6728),
    [sym_binary] = STATE(6728),
    [sym_unary] = STATE(6728),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3878] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6729),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6729),
    [sym_operator_assignment] = STATE(6729),
    [sym_conditional] = STATE(6729),
    [sym_range] = STATE(6729),
    [sym_binary] = STATE(6729),
    [sym_unary] = STATE(6729),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3879] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6730),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(6730),
    [sym_operator_assignment] = STATE(6730),
    [sym_conditional] = STATE(6730),
    [sym_range] = STATE(6730),
    [sym_binary] = STATE(6730),
    [sym_unary] = STATE(6730),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3880] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6731),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(6731),
    [sym_operator_assignment] = STATE(6731),
    [sym_conditional] = STATE(6731),
    [sym_range] = STATE(6731),
    [sym_binary] = STATE(6731),
    [sym_unary] = STATE(6731),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3881] = {
    [anon_sym_COLON] = ACTIONS(9852),
    [sym_comment] = ACTIONS(87),
  },
  [3882] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6733),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(6733),
    [sym_operator_assignment] = STATE(6733),
    [sym_conditional] = STATE(6733),
    [sym_range] = STATE(6733),
    [sym_binary] = STATE(6733),
    [sym_unary] = STATE(6733),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3883] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9854),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3884] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [3885] = {
    [sym_heredoc_body] = STATE(6735),
    [aux_sym_call_repeat1] = STATE(6735),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3886] = {
    [sym_heredoc_body] = STATE(6735),
    [aux_sym_call_repeat1] = STATE(6735),
    [aux_sym_argument_list_repeat1] = STATE(6737),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9856),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [3887] = {
    [sym_string] = STATE(4255),
    [aux_sym_chained_string_repeat1] = STATE(4255),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9858),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3888] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6743),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_splat_argument] = STATE(6744),
    [sym_assignment] = STATE(6743),
    [sym_operator_assignment] = STATE(6743),
    [sym_conditional] = STATE(6743),
    [sym_range] = STATE(6743),
    [sym_binary] = STATE(6743),
    [sym_unary] = STATE(6743),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(6744),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(9860),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3889] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6747),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(6747),
    [sym_operator_assignment] = STATE(6747),
    [sym_conditional] = STATE(6747),
    [sym_range] = STATE(6747),
    [sym_binary] = STATE(6747),
    [sym_unary] = STATE(6747),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3890] = {
    [sym_string] = STATE(6748),
    [aux_sym_chained_string_repeat1] = STATE(6748),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [3891] = {
    [sym__line_break2] = ACTIONS(3504),
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [anon_sym___END__] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_end] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_when] = ACTIONS(3504),
    [anon_sym_elsif] = ACTIONS(3504),
    [anon_sym_else] = ACTIONS(3504),
    [anon_sym_then] = ACTIONS(3504),
    [anon_sym_ensure] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_GT_GT] = ACTIONS(3506),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [sym_comment] = ACTIONS(87),
  },
  [3892] = {
    [anon_sym_RBRACE] = ACTIONS(9872),
    [sym_comment] = ACTIONS(87),
  },
  [3893] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(9874),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [3894] = {
    [sym__method_rest] = STATE(6751),
    [sym_operator] = STATE(1595),
    [sym__method_name] = STATE(1595),
    [sym_setter] = STATE(1595),
    [sym_symbol] = STATE(1595),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9876),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9876),
    [sym_class_variable] = ACTIONS(9876),
    [sym_global_variable] = ACTIONS(9876),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [3895] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(6752),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9878),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3896] = {
    [sym__line_break2] = ACTIONS(3744),
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [anon_sym___END__] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_end] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_elsif] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3744),
    [anon_sym_then] = ACTIONS(3744),
    [anon_sym_ensure] = ACTIONS(3744),
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_PLUS_EQ] = ACTIONS(3744),
    [anon_sym_DASH_EQ] = ACTIONS(3744),
    [anon_sym_STAR_EQ] = ACTIONS(3744),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3744),
    [anon_sym_SLASH_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3744),
    [anon_sym_AMP_EQ] = ACTIONS(3744),
    [anon_sym_PERCENT_EQ] = ACTIONS(3744),
    [anon_sym_GT_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_LT_EQ] = ACTIONS(3744),
    [anon_sym_CARET_EQ] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(87),
  },
  [3897] = {
    [sym_heredoc_body] = STATE(6753),
    [sym__terminator] = STATE(6753),
    [sym__line_break2] = ACTIONS(9880),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(9880),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [3898] = {
    [sym_heredoc_body] = STATE(6754),
    [sym__terminator] = STATE(6754),
    [sym__line_break2] = ACTIONS(9882),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9882),
    [sym_comment] = ACTIONS(87),
  },
  [3899] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(6755),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9884),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3900] = {
    [sym__line_break2] = ACTIONS(4158),
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [ts_builtin_sym_end] = ACTIONS(4158),
    [anon_sym___END__] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_end] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_when] = ACTIONS(4158),
    [anon_sym_elsif] = ACTIONS(4158),
    [anon_sym_else] = ACTIONS(4158),
    [anon_sym_then] = ACTIONS(4158),
    [anon_sym_ensure] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [sym_comment] = ACTIONS(87),
  },
  [3901] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(6756),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9886),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3902] = {
    [sym__statements] = STATE(6758),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(6759),
    [sym_else] = STATE(6759),
    [sym__if_tail] = STATE(6759),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6760),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6760),
    [sym__line_break2] = ACTIONS(9888),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9890),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3903] = {
    [sym__statements] = STATE(6762),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6763),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9892),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3904] = {
    [sym__statements] = STATE(6765),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9894),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3905] = {
    [sym__statements] = STATE(6767),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9896),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3906] = {
    [sym__do] = STATE(6768),
    [sym_heredoc_body] = STATE(6768),
    [sym__terminator] = STATE(6768),
    [sym__line_break2] = ACTIONS(9898),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(9898),
    [anon_sym_do] = ACTIONS(9898),
    [sym_comment] = ACTIONS(87),
  },
  [3907] = {
    [sym__line_break2] = ACTIONS(9506),
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [ts_builtin_sym_end] = ACTIONS(9506),
    [anon_sym___END__] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_end] = ACTIONS(9506),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_when] = ACTIONS(9506),
    [anon_sym_elsif] = ACTIONS(9506),
    [anon_sym_else] = ACTIONS(9506),
    [anon_sym_then] = ACTIONS(9506),
    [anon_sym_ensure] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [3908] = {
    [anon_sym_end] = ACTIONS(9900),
    [sym_comment] = ACTIONS(87),
  },
  [3909] = {
    [sym__statements] = STATE(6770),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9902),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3910] = {
    [sym__statements] = STATE(6770),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6771),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6771),
    [sym__line_break2] = ACTIONS(9904),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(9902),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3911] = {
    [sym_when] = STATE(6772),
    [aux_sym_case_repeat1] = STATE(6773),
    [anon_sym_SEMI] = ACTIONS(9906),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3912] = {
    [anon_sym_end] = ACTIONS(9908),
    [sym_comment] = ACTIONS(87),
  },
  [3913] = {
    [sym_when] = STATE(6772),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [3914] = {
    [sym__line_break2] = ACTIONS(5410),
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [ts_builtin_sym_end] = ACTIONS(5410),
    [anon_sym___END__] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5412),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_end] = ACTIONS(5410),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_when] = ACTIONS(5410),
    [anon_sym_elsif] = ACTIONS(5410),
    [anon_sym_else] = ACTIONS(5410),
    [anon_sym_then] = ACTIONS(5410),
    [anon_sym_ensure] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_PLUS_EQ] = ACTIONS(5410),
    [anon_sym_DASH_EQ] = ACTIONS(5410),
    [anon_sym_STAR_EQ] = ACTIONS(5410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5410),
    [anon_sym_SLASH_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5410),
    [anon_sym_AMP_EQ] = ACTIONS(5410),
    [anon_sym_PERCENT_EQ] = ACTIONS(5410),
    [anon_sym_GT_GT_EQ] = ACTIONS(5410),
    [anon_sym_LT_LT_EQ] = ACTIONS(5410),
    [anon_sym_CARET_EQ] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5412),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [sym_comment] = ACTIONS(87),
  },
  [3915] = {
    [sym_ensure] = STATE(6776),
    [anon_sym_end] = ACTIONS(9910),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3916] = {
    [anon_sym_end] = ACTIONS(9910),
    [sym_comment] = ACTIONS(87),
  },
  [3917] = {
    [sym_else] = STATE(6777),
    [sym_ensure] = STATE(6776),
    [anon_sym_end] = ACTIONS(9910),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [3918] = {
    [sym__line_break2] = ACTIONS(5498),
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [ts_builtin_sym_end] = ACTIONS(5498),
    [anon_sym___END__] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_end] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_when] = ACTIONS(5498),
    [anon_sym_elsif] = ACTIONS(5498),
    [anon_sym_else] = ACTIONS(5498),
    [anon_sym_then] = ACTIONS(5498),
    [anon_sym_ensure] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_PLUS_EQ] = ACTIONS(5498),
    [anon_sym_DASH_EQ] = ACTIONS(5498),
    [anon_sym_STAR_EQ] = ACTIONS(5498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5498),
    [anon_sym_SLASH_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5498),
    [anon_sym_AMP_EQ] = ACTIONS(5498),
    [anon_sym_PERCENT_EQ] = ACTIONS(5498),
    [anon_sym_GT_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_LT_EQ] = ACTIONS(5498),
    [anon_sym_CARET_EQ] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(87),
  },
  [3919] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [ts_builtin_sym_end] = ACTIONS(7850),
    [anon_sym___END__] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_end] = ACTIONS(7850),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_when] = ACTIONS(7850),
    [anon_sym_elsif] = ACTIONS(7850),
    [anon_sym_else] = ACTIONS(7850),
    [anon_sym_then] = ACTIONS(7850),
    [anon_sym_ensure] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [sym_comment] = ACTIONS(87),
  },
  [3920] = {
    [anon_sym_RPAREN] = ACTIONS(9912),
    [sym_comment] = ACTIONS(87),
  },
  [3921] = {
    [sym__line_break2] = ACTIONS(5738),
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [ts_builtin_sym_end] = ACTIONS(5738),
    [anon_sym___END__] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_end] = ACTIONS(5738),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_when] = ACTIONS(5738),
    [anon_sym_elsif] = ACTIONS(5738),
    [anon_sym_else] = ACTIONS(5738),
    [anon_sym_then] = ACTIONS(5738),
    [anon_sym_ensure] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_AMP_AMP] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [sym_comment] = ACTIONS(87),
  },
  [3922] = {
    [anon_sym_RBRACK] = ACTIONS(9914),
    [sym_comment] = ACTIONS(87),
  },
  [3923] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [3924] = {
    [sym__line_break2] = ACTIONS(5822),
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [anon_sym___END__] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5822),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_when] = ACTIONS(5822),
    [anon_sym_elsif] = ACTIONS(5822),
    [anon_sym_else] = ACTIONS(5822),
    [anon_sym_then] = ACTIONS(5822),
    [anon_sym_ensure] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [sym_comment] = ACTIONS(87),
  },
  [3925] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3926] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [3927] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3928] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [3929] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3930] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3931] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6969),
    [anon_sym___END__] = ACTIONS(6969),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [3932] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(9916),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [3933] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3934] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3935] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3936] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3937] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3938] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [3939] = {
    [sym__line_break2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [ts_builtin_sym_end] = ACTIONS(3158),
    [anon_sym___END__] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_end] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_when] = ACTIONS(3158),
    [anon_sym_elsif] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_then] = ACTIONS(3158),
    [anon_sym_ensure] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_PLUS_EQ] = ACTIONS(3158),
    [anon_sym_DASH_EQ] = ACTIONS(3158),
    [anon_sym_STAR_EQ] = ACTIONS(3158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3158),
    [anon_sym_SLASH_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3158),
    [anon_sym_AMP_EQ] = ACTIONS(3158),
    [anon_sym_PERCENT_EQ] = ACTIONS(3158),
    [anon_sym_GT_GT_EQ] = ACTIONS(3158),
    [anon_sym_LT_LT_EQ] = ACTIONS(3158),
    [anon_sym_CARET_EQ] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4982),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
  },
  [3940] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(9918),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [3941] = {
    [sym_heredoc_body] = STATE(3941),
    [aux_sym_call_repeat1] = STATE(3941),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [ts_builtin_sym_end] = ACTIONS(7888),
    [anon_sym___END__] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [3942] = {
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [3943] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(438),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(438),
    [sym_operator_assignment] = STATE(438),
    [sym_conditional] = STATE(438),
    [sym_range] = STATE(438),
    [sym_binary] = STATE(438),
    [sym_unary] = STATE(438),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(447),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(767),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__identifier_hash_key2] = ACTIONS(773),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6204),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(815),
    [sym_identifier] = ACTIONS(815),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [3944] = {
    [sym_heredoc_body] = STATE(3941),
    [aux_sym_call_repeat1] = STATE(3941),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [ts_builtin_sym_end] = ACTIONS(7903),
    [anon_sym___END__] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [3945] = {
    [aux_sym_argument_list_repeat1] = STATE(3945),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(9923),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [3946] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(5104),
    [anon_sym___END__] = ACTIONS(5104),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3947] = {
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [3948] = {
    [aux_sym_exceptions_repeat1] = STATE(6784),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [3949] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [3950] = {
    [sym_string] = STATE(3950),
    [aux_sym_chained_string_repeat1] = STATE(3950),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [ts_builtin_sym_end] = ACTIONS(6252),
    [anon_sym___END__] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [3951] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(4204),
    [anon_sym___END__] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [3952] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [ts_builtin_sym_end] = ACTIONS(939),
    [anon_sym___END__] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3953] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3954] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(2293),
    [anon_sym___END__] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [3955] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6785),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6785),
    [sym_operator_assignment] = STATE(6785),
    [sym_conditional] = STATE(6785),
    [sym_range] = STATE(6785),
    [sym_binary] = STATE(6785),
    [sym_unary] = STATE(6785),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3956] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6786),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6786),
    [sym_operator_assignment] = STATE(6786),
    [sym_conditional] = STATE(6786),
    [sym_range] = STATE(6786),
    [sym_binary] = STATE(6786),
    [sym_unary] = STATE(6786),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3957] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6787),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6787),
    [sym_operator_assignment] = STATE(6787),
    [sym_conditional] = STATE(6787),
    [sym_range] = STATE(6787),
    [sym_binary] = STATE(6787),
    [sym_unary] = STATE(6787),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3958] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6788),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6788),
    [sym_operator_assignment] = STATE(6788),
    [sym_conditional] = STATE(6788),
    [sym_range] = STATE(6788),
    [sym_binary] = STATE(6788),
    [sym_unary] = STATE(6788),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3959] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6789),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6789),
    [sym_operator_assignment] = STATE(6789),
    [sym_conditional] = STATE(6789),
    [sym_range] = STATE(6789),
    [sym_binary] = STATE(6789),
    [sym_unary] = STATE(6789),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3960] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6790),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6790),
    [sym_operator_assignment] = STATE(6790),
    [sym_conditional] = STATE(6790),
    [sym_range] = STATE(6790),
    [sym_binary] = STATE(6790),
    [sym_unary] = STATE(6790),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3961] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6791),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6791),
    [sym_operator_assignment] = STATE(6791),
    [sym_conditional] = STATE(6791),
    [sym_range] = STATE(6791),
    [sym_binary] = STATE(6791),
    [sym_unary] = STATE(6791),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [3962] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6792),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6792),
    [sym_operator_assignment] = STATE(6792),
    [sym_conditional] = STATE(6792),
    [sym_range] = STATE(6792),
    [sym_binary] = STATE(6792),
    [sym_unary] = STATE(6792),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3963] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6793),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6793),
    [sym_operator_assignment] = STATE(6793),
    [sym_conditional] = STATE(6793),
    [sym_range] = STATE(6793),
    [sym_binary] = STATE(6793),
    [sym_unary] = STATE(6793),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3964] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6794),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6794),
    [sym_operator_assignment] = STATE(6794),
    [sym_conditional] = STATE(6794),
    [sym_range] = STATE(6794),
    [sym_binary] = STATE(6794),
    [sym_unary] = STATE(6794),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3965] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6795),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6795),
    [sym_operator_assignment] = STATE(6795),
    [sym_conditional] = STATE(6795),
    [sym_range] = STATE(6795),
    [sym_binary] = STATE(6795),
    [sym_unary] = STATE(6795),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3966] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6796),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6796),
    [sym_operator_assignment] = STATE(6796),
    [sym_conditional] = STATE(6796),
    [sym_range] = STATE(6796),
    [sym_binary] = STATE(6796),
    [sym_unary] = STATE(6796),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3967] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1667),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(1667),
    [sym_operator_assignment] = STATE(1667),
    [sym_conditional] = STATE(1667),
    [sym_range] = STATE(1667),
    [sym_binary] = STATE(1667),
    [sym_unary] = STATE(1667),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2793),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3968] = {
    [aux_sym_exceptions_repeat1] = STATE(6798),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [ts_builtin_sym_end] = ACTIONS(9929),
    [anon_sym___END__] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(6240),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [3969] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1667),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_splat_argument] = STATE(6799),
    [sym_assignment] = STATE(1667),
    [sym_operator_assignment] = STATE(1667),
    [sym_conditional] = STATE(1667),
    [sym_range] = STATE(1667),
    [sym_binary] = STATE(1667),
    [sym_unary] = STATE(1667),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(6799),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2793),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3970] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6800),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(6800),
    [sym_operator_assignment] = STATE(6800),
    [sym_conditional] = STATE(6800),
    [sym_range] = STATE(6800),
    [sym_binary] = STATE(6800),
    [sym_unary] = STATE(6800),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [3971] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6801),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(6801),
    [sym_operator_assignment] = STATE(6801),
    [sym_conditional] = STATE(6801),
    [sym_range] = STATE(6801),
    [sym_binary] = STATE(6801),
    [sym_unary] = STATE(6801),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3972] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3973] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3974] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3975] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3976] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6804),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(6804),
    [sym_operator_assignment] = STATE(6804),
    [sym_conditional] = STATE(6804),
    [sym_range] = STATE(6804),
    [sym_binary] = STATE(6804),
    [sym_unary] = STATE(6804),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3977] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6805),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(6805),
    [sym_operator_assignment] = STATE(6805),
    [sym_conditional] = STATE(6805),
    [sym_range] = STATE(6805),
    [sym_binary] = STATE(6805),
    [sym_unary] = STATE(6805),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3978] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3979] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [3980] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [3981] = {
    [anon_sym_EQ] = ACTIONS(9963),
    [sym_comment] = ACTIONS(87),
  },
  [3982] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(9965),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(9967),
    [anon_sym_DASH_EQ] = ACTIONS(9967),
    [anon_sym_STAR_EQ] = ACTIONS(9967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9967),
    [anon_sym_SLASH_EQ] = ACTIONS(9967),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9967),
    [anon_sym_PIPE_EQ] = ACTIONS(9967),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9967),
    [anon_sym_AMP_EQ] = ACTIONS(9967),
    [anon_sym_PERCENT_EQ] = ACTIONS(9967),
    [anon_sym_GT_GT_EQ] = ACTIONS(9967),
    [anon_sym_LT_LT_EQ] = ACTIONS(9967),
    [anon_sym_CARET_EQ] = ACTIONS(9967),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [3983] = {
    [sym_string] = STATE(6820),
    [aux_sym_chained_string_repeat1] = STATE(6820),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3984] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [3985] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [3986] = {
    [sym_string] = STATE(4027),
    [aux_sym_chained_string_repeat1] = STATE(4027),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3987] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6821),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(6821),
    [sym_operator_assignment] = STATE(6821),
    [sym_conditional] = STATE(6821),
    [sym_range] = STATE(6821),
    [sym_binary] = STATE(6821),
    [sym_unary] = STATE(6821),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3988] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [3989] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6822),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6822),
    [sym_operator_assignment] = STATE(6822),
    [sym_conditional] = STATE(6822),
    [sym_range] = STATE(6822),
    [sym_binary] = STATE(6822),
    [sym_unary] = STATE(6822),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3990] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6823),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6823),
    [sym_operator_assignment] = STATE(6823),
    [sym_conditional] = STATE(6823),
    [sym_range] = STATE(6823),
    [sym_binary] = STATE(6823),
    [sym_unary] = STATE(6823),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3991] = {
    [anon_sym_COLON] = ACTIONS(9969),
    [sym_comment] = ACTIONS(87),
  },
  [3992] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6825),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6825),
    [sym_operator_assignment] = STATE(6825),
    [sym_conditional] = STATE(6825),
    [sym_range] = STATE(6825),
    [sym_binary] = STATE(6825),
    [sym_unary] = STATE(6825),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [3993] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9971),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [3994] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [3995] = {
    [sym_heredoc_body] = STATE(6827),
    [aux_sym_call_repeat1] = STATE(6827),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3996] = {
    [sym_heredoc_body] = STATE(6827),
    [aux_sym_call_repeat1] = STATE(6827),
    [aux_sym_argument_list_repeat1] = STATE(6829),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9973),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [3997] = {
    [sym_string] = STATE(4027),
    [aux_sym_chained_string_repeat1] = STATE(4027),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9975),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [3998] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [3999] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [4000] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6830),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6830),
    [sym_operator_assignment] = STATE(6830),
    [sym_conditional] = STATE(6830),
    [sym_range] = STATE(6830),
    [sym_binary] = STATE(6830),
    [sym_unary] = STATE(6830),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4001] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6831),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6831),
    [sym_operator_assignment] = STATE(6831),
    [sym_conditional] = STATE(6831),
    [sym_range] = STATE(6831),
    [sym_binary] = STATE(6831),
    [sym_unary] = STATE(6831),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4002] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6832),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6832),
    [sym_operator_assignment] = STATE(6832),
    [sym_conditional] = STATE(6832),
    [sym_range] = STATE(6832),
    [sym_binary] = STATE(6832),
    [sym_unary] = STATE(6832),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4003] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6833),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6833),
    [sym_operator_assignment] = STATE(6833),
    [sym_conditional] = STATE(6833),
    [sym_range] = STATE(6833),
    [sym_binary] = STATE(6833),
    [sym_unary] = STATE(6833),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4004] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6834),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6834),
    [sym_operator_assignment] = STATE(6834),
    [sym_conditional] = STATE(6834),
    [sym_range] = STATE(6834),
    [sym_binary] = STATE(6834),
    [sym_unary] = STATE(6834),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4005] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6835),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6835),
    [sym_operator_assignment] = STATE(6835),
    [sym_conditional] = STATE(6835),
    [sym_range] = STATE(6835),
    [sym_binary] = STATE(6835),
    [sym_unary] = STATE(6835),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4006] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6836),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(6836),
    [sym_operator_assignment] = STATE(6836),
    [sym_conditional] = STATE(6836),
    [sym_range] = STATE(6836),
    [sym_binary] = STATE(6836),
    [sym_unary] = STATE(6836),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4007] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6837),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6837),
    [sym_operator_assignment] = STATE(6837),
    [sym_conditional] = STATE(6837),
    [sym_range] = STATE(6837),
    [sym_binary] = STATE(6837),
    [sym_unary] = STATE(6837),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4008] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6838),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6838),
    [sym_operator_assignment] = STATE(6838),
    [sym_conditional] = STATE(6838),
    [sym_range] = STATE(6838),
    [sym_binary] = STATE(6838),
    [sym_unary] = STATE(6838),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4009] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6839),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6839),
    [sym_operator_assignment] = STATE(6839),
    [sym_conditional] = STATE(6839),
    [sym_range] = STATE(6839),
    [sym_binary] = STATE(6839),
    [sym_unary] = STATE(6839),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4010] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6840),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6840),
    [sym_operator_assignment] = STATE(6840),
    [sym_conditional] = STATE(6840),
    [sym_range] = STATE(6840),
    [sym_binary] = STATE(6840),
    [sym_unary] = STATE(6840),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4011] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6841),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6841),
    [sym_operator_assignment] = STATE(6841),
    [sym_conditional] = STATE(6841),
    [sym_range] = STATE(6841),
    [sym_binary] = STATE(6841),
    [sym_unary] = STATE(6841),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4012] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6842),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6842),
    [sym_operator_assignment] = STATE(6842),
    [sym_conditional] = STATE(6842),
    [sym_range] = STATE(6842),
    [sym_binary] = STATE(6842),
    [sym_unary] = STATE(6842),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4013] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6843),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6843),
    [sym_operator_assignment] = STATE(6843),
    [sym_conditional] = STATE(6843),
    [sym_range] = STATE(6843),
    [sym_binary] = STATE(6843),
    [sym_unary] = STATE(6843),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4014] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6844),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6844),
    [sym_operator_assignment] = STATE(6844),
    [sym_conditional] = STATE(6844),
    [sym_range] = STATE(6844),
    [sym_binary] = STATE(6844),
    [sym_unary] = STATE(6844),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4015] = {
    [anon_sym_COLON] = ACTIONS(9977),
    [sym_comment] = ACTIONS(87),
  },
  [4016] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6846),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6846),
    [sym_operator_assignment] = STATE(6846),
    [sym_conditional] = STATE(6846),
    [sym_range] = STATE(6846),
    [sym_binary] = STATE(6846),
    [sym_unary] = STATE(6846),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4017] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(9979),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4018] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [4019] = {
    [sym_heredoc_body] = STATE(6848),
    [aux_sym_call_repeat1] = STATE(6848),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4020] = {
    [sym_heredoc_body] = STATE(6848),
    [aux_sym_call_repeat1] = STATE(6848),
    [aux_sym_argument_list_repeat1] = STATE(6850),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9981),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4021] = {
    [sym_string] = STATE(4132),
    [aux_sym_chained_string_repeat1] = STATE(4132),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(9983),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4022] = {
    [sym_heredoc_body] = STATE(6851),
    [aux_sym_call_repeat1] = STATE(6851),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4023] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6852),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9985),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4024] = {
    [sym_heredoc_body] = STATE(6853),
    [aux_sym_call_repeat1] = STATE(6853),
    [aux_sym_argument_list_repeat1] = STATE(6854),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6335),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4025] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6855),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_splat_argument] = STATE(6856),
    [sym_assignment] = STATE(6855),
    [sym_operator_assignment] = STATE(6855),
    [sym_conditional] = STATE(6855),
    [sym_range] = STATE(6855),
    [sym_binary] = STATE(6855),
    [sym_unary] = STATE(6855),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(6856),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4026] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6857),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(6857),
    [sym_operator_assignment] = STATE(6857),
    [sym_conditional] = STATE(6857),
    [sym_range] = STATE(6857),
    [sym_binary] = STATE(6857),
    [sym_unary] = STATE(6857),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4027] = {
    [sym_string] = STATE(6858),
    [aux_sym_chained_string_repeat1] = STATE(6858),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4028] = {
    [anon_sym_RBRACE] = ACTIONS(3608),
    [anon_sym_COMMA] = ACTIONS(3608),
    [anon_sym_if] = ACTIONS(3608),
    [anon_sym_unless] = ACTIONS(3608),
    [anon_sym_while] = ACTIONS(3608),
    [anon_sym_until] = ACTIONS(3608),
    [anon_sym_rescue] = ACTIONS(3608),
    [sym_comment] = ACTIONS(87),
  },
  [4029] = {
    [sym_operator] = STATE(6859),
    [sym__method_name] = STATE(6859),
    [sym_setter] = STATE(6859),
    [sym_symbol] = STATE(6859),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__symbol_start2] = ACTIONS(281),
    [anon_sym_PIPE] = ACTIONS(2843),
    [anon_sym_STAR] = ACTIONS(2845),
    [anon_sym_STAR_STAR] = ACTIONS(2843),
    [anon_sym_AMP] = ACTIONS(2843),
    [anon_sym_LT] = ACTIONS(2845),
    [anon_sym_DOT_DOT] = ACTIONS(2843),
    [anon_sym_LT_LT] = ACTIONS(2843),
    [anon_sym_GT_GT] = ACTIONS(2843),
    [anon_sym_EQ_EQ] = ACTIONS(2845),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2843),
    [anon_sym_LT_EQ_GT] = ACTIONS(2843),
    [anon_sym_EQ_TILDE] = ACTIONS(2843),
    [anon_sym_BANG_TILDE] = ACTIONS(2843),
    [anon_sym_LT_EQ] = ACTIONS(2845),
    [anon_sym_GT] = ACTIONS(2845),
    [anon_sym_GT_EQ] = ACTIONS(2843),
    [anon_sym_CARET] = ACTIONS(2843),
    [anon_sym_PLUS] = ACTIONS(2845),
    [anon_sym_SLASH] = ACTIONS(2843),
    [anon_sym_PERCENT] = ACTIONS(2843),
    [anon_sym_BANG] = ACTIONS(2845),
    [anon_sym_TILDE] = ACTIONS(2843),
    [sym_constant] = ACTIONS(9987),
    [sym_identifier] = ACTIONS(2849),
    [sym_instance_variable] = ACTIONS(9987),
    [sym_class_variable] = ACTIONS(9987),
    [sym_global_variable] = ACTIONS(9987),
    [anon_sym_DASH] = ACTIONS(2845),
    [anon_sym_PLUS_AT] = ACTIONS(2843),
    [anon_sym_DASH_AT] = ACTIONS(2843),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(2845),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(2843),
    [anon_sym_BQUOTE] = ACTIONS(2843),
    [sym_comment] = ACTIONS(87),
  },
  [4030] = {
    [aux_sym_undef_repeat1] = STATE(6860),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(6347),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [4031] = {
    [anon_sym_RBRACE] = ACTIONS(5508),
    [anon_sym_if] = ACTIONS(5508),
    [anon_sym_unless] = ACTIONS(5508),
    [anon_sym_while] = ACTIONS(5508),
    [anon_sym_until] = ACTIONS(5508),
    [anon_sym_rescue] = ACTIONS(5508),
    [sym_comment] = ACTIONS(87),
  },
  [4032] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4033] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4034] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4035] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4036] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(2883),
    [anon_sym_or] = ACTIONS(2883),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4037] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4038] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4039] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4040] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4041] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4042] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4043] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(9989),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4044] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4045] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4046] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4047] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4048] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4049] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [4050] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(6863),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6864),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9991),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4051] = {
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_rescue] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_COLON2] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [4052] = {
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_rescue] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_COLON2] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [4053] = {
    [sym_argument_list_with_parens] = STATE(6865),
    [sym__argument_list_with_parens] = STATE(4052),
    [sym_operator] = STATE(6865),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(6355),
    [anon_sym_STAR] = ACTIONS(6357),
    [anon_sym_STAR_STAR] = ACTIONS(6355),
    [anon_sym_AMP] = ACTIONS(6355),
    [anon_sym_LT] = ACTIONS(6357),
    [anon_sym_LPAREN2] = ACTIONS(6359),
    [anon_sym_DOT_DOT] = ACTIONS(6355),
    [anon_sym_LT_LT] = ACTIONS(6355),
    [anon_sym_GT_GT] = ACTIONS(6355),
    [anon_sym_EQ_EQ] = ACTIONS(6357),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6355),
    [anon_sym_LT_EQ_GT] = ACTIONS(6355),
    [anon_sym_EQ_TILDE] = ACTIONS(6355),
    [anon_sym_BANG_TILDE] = ACTIONS(6355),
    [anon_sym_LT_EQ] = ACTIONS(6357),
    [anon_sym_GT] = ACTIONS(6357),
    [anon_sym_GT_EQ] = ACTIONS(6355),
    [anon_sym_CARET] = ACTIONS(6355),
    [anon_sym_PLUS] = ACTIONS(6357),
    [anon_sym_SLASH] = ACTIONS(6355),
    [anon_sym_PERCENT] = ACTIONS(6355),
    [anon_sym_BANG] = ACTIONS(6357),
    [anon_sym_TILDE] = ACTIONS(6355),
    [sym_constant] = ACTIONS(9993),
    [sym_identifier] = ACTIONS(9993),
    [anon_sym_DASH] = ACTIONS(6357),
    [anon_sym_PLUS_AT] = ACTIONS(6355),
    [anon_sym_DASH_AT] = ACTIONS(6355),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6357),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6355),
    [anon_sym_BQUOTE] = ACTIONS(6355),
    [sym_comment] = ACTIONS(87),
  },
  [4054] = {
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_if] = ACTIONS(5984),
    [anon_sym_unless] = ACTIONS(5984),
    [anon_sym_while] = ACTIONS(5984),
    [anon_sym_until] = ACTIONS(5984),
    [anon_sym_rescue] = ACTIONS(5984),
    [anon_sym_do] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_COLON2] = ACTIONS(5986),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [4055] = {
    [sym_heredoc_body] = STATE(6867),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(9995),
    [sym_comment] = ACTIONS(87),
  },
  [4056] = {
    [anon_sym_RBRACK] = ACTIONS(9995),
    [sym_comment] = ACTIONS(87),
  },
  [4057] = {
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_rescue] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_COLON2] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [4058] = {
    [sym__heredoc_body_start2] = ACTIONS(101),
    [sym__binary_minus2] = ACTIONS(101),
    [sym__binary_star2] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [anon_sym_RBRACE] = ACTIONS(101),
    [anon_sym_RPAREN] = ACTIONS(101),
    [anon_sym_DOT] = ACTIONS(103),
    [anon_sym_COMMA] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(103),
    [anon_sym_SEMI] = ACTIONS(101),
    [anon_sym_STAR_STAR] = ACTIONS(103),
    [anon_sym_AMP] = ACTIONS(103),
    [anon_sym_EQ] = ACTIONS(103),
    [anon_sym_LT] = ACTIONS(103),
    [anon_sym_if] = ACTIONS(101),
    [anon_sym_unless] = ACTIONS(101),
    [anon_sym_while] = ACTIONS(101),
    [anon_sym_until] = ACTIONS(101),
    [anon_sym_rescue] = ACTIONS(101),
    [anon_sym_in] = ACTIONS(101),
    [anon_sym_do] = ACTIONS(101),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_RBRACK] = ACTIONS(101),
    [anon_sym_COLON_COLON2] = ACTIONS(101),
    [anon_sym_AMP_DOT] = ACTIONS(101),
    [anon_sym_PLUS_EQ] = ACTIONS(101),
    [anon_sym_DASH_EQ] = ACTIONS(101),
    [anon_sym_STAR_EQ] = ACTIONS(101),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(101),
    [anon_sym_SLASH_EQ] = ACTIONS(101),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(101),
    [anon_sym_PIPE_EQ] = ACTIONS(101),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(101),
    [anon_sym_AMP_EQ] = ACTIONS(101),
    [anon_sym_PERCENT_EQ] = ACTIONS(101),
    [anon_sym_GT_GT_EQ] = ACTIONS(101),
    [anon_sym_LT_LT_EQ] = ACTIONS(101),
    [anon_sym_CARET_EQ] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(101),
    [anon_sym_COLON2] = ACTIONS(103),
    [anon_sym_DOT_DOT] = ACTIONS(103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(101),
    [anon_sym_and] = ACTIONS(101),
    [anon_sym_or] = ACTIONS(101),
    [anon_sym_PIPE_PIPE] = ACTIONS(103),
    [anon_sym_AMP_AMP] = ACTIONS(103),
    [anon_sym_LT_LT] = ACTIONS(103),
    [anon_sym_GT_GT] = ACTIONS(103),
    [anon_sym_EQ_EQ] = ACTIONS(103),
    [anon_sym_BANG_EQ] = ACTIONS(101),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(101),
    [anon_sym_LT_EQ_GT] = ACTIONS(101),
    [anon_sym_EQ_TILDE] = ACTIONS(101),
    [anon_sym_BANG_TILDE] = ACTIONS(101),
    [anon_sym_LT_EQ] = ACTIONS(103),
    [anon_sym_GT] = ACTIONS(103),
    [anon_sym_GT_EQ] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(103),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_SLASH] = ACTIONS(103),
    [anon_sym_PERCENT] = ACTIONS(103),
    [sym_comment] = ACTIONS(87),
  },
  [4059] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(6869),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(9997),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4060] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(6871),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(9999),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4061] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(6873),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(10001),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4062] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(6875),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(10003),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [4063] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(6878),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10005),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10007),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4064] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(6881),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10009),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10011),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4065] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6882),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6882),
    [sym_operator_assignment] = STATE(6882),
    [sym_conditional] = STATE(6882),
    [sym_range] = STATE(6882),
    [sym_binary] = STATE(6882),
    [sym_unary] = STATE(6882),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4066] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(117),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(117),
    [sym_operator_assignment] = STATE(117),
    [sym_conditional] = STATE(117),
    [sym_range] = STATE(117),
    [sym_binary] = STATE(117),
    [sym_unary] = STATE(117),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(123),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_heredoc_body] = STATE(6884),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym__hash_items] = STATE(6885),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_RBRACE] = ACTIONS(10013),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(209),
    [sym_identifier] = ACTIONS(209),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4067] = {
    [sym__method_rest] = STATE(6887),
    [sym__variable] = STATE(6888),
    [sym_operator] = STATE(6889),
    [sym__method_name] = STATE(6889),
    [sym_setter] = STATE(6889),
    [sym_symbol] = STATE(6889),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_LPAREN] = ACTIONS(10015),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(239),
    [sym_identifier] = ACTIONS(241),
    [sym_instance_variable] = ACTIONS(239),
    [sym_class_variable] = ACTIONS(239),
    [sym_global_variable] = ACTIONS(239),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
    [sym_super] = ACTIONS(10017),
    [sym_self] = ACTIONS(10017),
  },
  [4068] = {
    [sym__statements] = STATE(6891),
    [sym__top_level_statement] = STATE(149),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(154),
    [sym__simple_mlhs] = STATE(155),
    [sym_destructured_left_assignment] = STATE(155),
    [sym_rest_assignment] = STATE(155),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_RPAREN] = ACTIONS(10019),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4069] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(6894),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [sym__singleton_class_left_angle_left_langle2] = ACTIONS(10021),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(10023),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [4070] = {
    [sym_method] = STATE(196),
    [sym_singleton_method] = STATE(196),
    [sym_class] = STATE(196),
    [sym_singleton_class] = STATE(196),
    [sym_module] = STATE(196),
    [sym_return] = STATE(196),
    [sym_yield] = STATE(196),
    [sym_break] = STATE(196),
    [sym_next] = STATE(196),
    [sym_while] = STATE(196),
    [sym_until] = STATE(196),
    [sym_for] = STATE(196),
    [sym_case] = STATE(196),
    [sym_if] = STATE(196),
    [sym_unless] = STATE(196),
    [sym_begin] = STATE(196),
    [sym__primary] = STATE(196),
    [sym_parenthesized_statements] = STATE(196),
    [sym_element_reference] = STATE(196),
    [sym_scope_resolution] = STATE(6896),
    [sym_call] = STATE(198),
    [sym_method_call] = STATE(196),
    [sym__lhs] = STATE(196),
    [sym__variable] = STATE(198),
    [sym_rational] = STATE(196),
    [sym_true] = STATE(196),
    [sym_false] = STATE(196),
    [sym_nil] = STATE(196),
    [sym_chained_string] = STATE(196),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(196),
    [sym_string_array] = STATE(196),
    [sym_symbol_array] = STATE(196),
    [sym_symbol] = STATE(196),
    [sym_regex] = STATE(196),
    [sym_array] = STATE(196),
    [sym_hash] = STATE(196),
    [sym_lambda] = STATE(196),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(347),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(297),
    [anon_sym_COLON_COLON] = ACTIONS(351),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(353),
    [sym_retry] = ACTIONS(353),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(10025),
    [sym_identifier] = ACTIONS(357),
    [sym_instance_variable] = ACTIONS(359),
    [sym_class_variable] = ACTIONS(359),
    [sym_global_variable] = ACTIONS(359),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(353),
    [sym_complex] = ACTIONS(347),
    [sym_super] = ACTIONS(357),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(357),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(347),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [4071] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4072] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4073] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4074] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4075] = {
    [sym__statement] = STATE(6901),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4076] = {
    [sym__statement] = STATE(6902),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(241),
    [sym_operator_assignment] = STATE(241),
    [sym_conditional] = STATE(241),
    [sym_range] = STATE(241),
    [sym_binary] = STATE(241),
    [sym_unary] = STATE(241),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [anon_sym_undef] = ACTIONS(449),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4077] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6903),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(6903),
    [sym_operator_assignment] = STATE(6903),
    [sym_conditional] = STATE(6903),
    [sym_range] = STATE(6903),
    [sym_binary] = STATE(6903),
    [sym_unary] = STATE(6903),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4078] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6904),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(6904),
    [sym_operator_assignment] = STATE(6904),
    [sym_conditional] = STATE(6904),
    [sym_range] = STATE(6904),
    [sym_binary] = STATE(6904),
    [sym_unary] = STATE(6904),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4079] = {
    [sym_method] = STATE(189),
    [sym_singleton_method] = STATE(189),
    [sym_class] = STATE(189),
    [sym_singleton_class] = STATE(189),
    [sym_module] = STATE(189),
    [sym_return] = STATE(189),
    [sym_yield] = STATE(189),
    [sym_break] = STATE(189),
    [sym_next] = STATE(189),
    [sym_while] = STATE(189),
    [sym_until] = STATE(189),
    [sym_for] = STATE(189),
    [sym_case] = STATE(189),
    [sym_if] = STATE(189),
    [sym_unless] = STATE(189),
    [sym_begin] = STATE(189),
    [sym__primary] = STATE(189),
    [sym_parenthesized_statements] = STATE(189),
    [sym_element_reference] = STATE(266),
    [sym_scope_resolution] = STATE(263),
    [sym_call] = STATE(263),
    [sym_method_call] = STATE(266),
    [sym__mlhs] = STATE(6905),
    [sym__simple_mlhs] = STATE(265),
    [sym_destructured_left_assignment] = STATE(265),
    [sym_rest_assignment] = STATE(265),
    [sym__lhs] = STATE(266),
    [sym__variable] = STATE(263),
    [sym_rational] = STATE(189),
    [sym_true] = STATE(266),
    [sym_false] = STATE(266),
    [sym_nil] = STATE(266),
    [sym_chained_string] = STATE(189),
    [sym_string] = STATE(192),
    [sym_subshell] = STATE(189),
    [sym_string_array] = STATE(189),
    [sym_symbol_array] = STATE(189),
    [sym_symbol] = STATE(189),
    [sym_regex] = STATE(189),
    [sym_array] = STATE(189),
    [sym_hash] = STATE(189),
    [sym_lambda] = STATE(189),
    [sym__simple_symbol2] = ACTIONS(277),
    [sym__string_start2] = ACTIONS(279),
    [sym__symbol_start2] = ACTIONS(281),
    [sym__subshell_start2] = ACTIONS(283),
    [sym__regex_start2] = ACTIONS(285),
    [sym__string_array_start2] = ACTIONS(287),
    [sym__symbol_array_start2] = ACTIONS(289),
    [sym_heredoc_beginning2] = ACTIONS(291),
    [anon_sym_LBRACE] = ACTIONS(293),
    [anon_sym_def] = ACTIONS(295),
    [anon_sym_LPAREN] = ACTIONS(473),
    [anon_sym_COLON_COLON] = ACTIONS(299),
    [anon_sym_STAR] = ACTIONS(475),
    [anon_sym_class] = ACTIONS(303),
    [anon_sym_module] = ACTIONS(305),
    [anon_sym_return] = ACTIONS(307),
    [anon_sym_yield] = ACTIONS(309),
    [anon_sym_break] = ACTIONS(311),
    [anon_sym_next] = ACTIONS(313),
    [sym_redo] = ACTIONS(315),
    [sym_retry] = ACTIONS(315),
    [anon_sym_if] = ACTIONS(317),
    [anon_sym_unless] = ACTIONS(319),
    [anon_sym_while] = ACTIONS(321),
    [anon_sym_until] = ACTIONS(323),
    [anon_sym_for] = ACTIONS(325),
    [anon_sym_case] = ACTIONS(327),
    [anon_sym_begin] = ACTIONS(329),
    [sym_constant] = ACTIONS(477),
    [sym_identifier] = ACTIONS(477),
    [sym_instance_variable] = ACTIONS(479),
    [sym_class_variable] = ACTIONS(479),
    [sym_global_variable] = ACTIONS(479),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(335),
    [sym_float] = ACTIONS(315),
    [sym_complex] = ACTIONS(291),
    [sym_super] = ACTIONS(477),
    [anon_sym_true] = ACTIONS(337),
    [anon_sym_TRUE] = ACTIONS(337),
    [anon_sym_false] = ACTIONS(339),
    [anon_sym_FALSE] = ACTIONS(339),
    [sym_self] = ACTIONS(477),
    [anon_sym_nil] = ACTIONS(341),
    [anon_sym_NIL] = ACTIONS(341),
    [sym_character] = ACTIONS(291),
    [anon_sym_LBRACK2] = ACTIONS(343),
    [anon_sym_DASH_GT] = ACTIONS(345),
  },
  [4080] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6906),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(6906),
    [sym_operator_assignment] = STATE(6906),
    [sym_conditional] = STATE(6906),
    [sym_range] = STATE(6906),
    [sym_binary] = STATE(6906),
    [sym_unary] = STATE(6906),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6907),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__terminator] = STATE(6907),
    [sym__line_break2] = ACTIONS(10027),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(10027),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4081] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(6912),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6913),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6913),
    [sym__line_break2] = ACTIONS(10029),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(511),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10031),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4082] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6914),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6914),
    [sym_operator_assignment] = STATE(6914),
    [sym_conditional] = STATE(6914),
    [sym_range] = STATE(6914),
    [sym_binary] = STATE(6914),
    [sym_unary] = STATE(6914),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4083] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6915),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6915),
    [sym_operator_assignment] = STATE(6915),
    [sym_conditional] = STATE(6915),
    [sym_range] = STATE(6915),
    [sym_binary] = STATE(6915),
    [sym_unary] = STATE(6915),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4084] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4085] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
    [anon_sym_r] = ACTIONS(10033),
  },
  [4086] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(6919),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(6920),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(10035),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4087] = {
    [sym_lambda_parameters] = STATE(6921),
    [sym__simple_formal_parameter] = STATE(376),
    [sym_splat_parameter] = STATE(376),
    [sym_hash_splat_parameter] = STATE(376),
    [sym_block_parameter] = STATE(376),
    [sym_keyword_parameter] = STATE(376),
    [sym_optional_parameter] = STATE(376),
    [sym_do_block] = STATE(6922),
    [sym_block] = STATE(6922),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_LPAREN] = ACTIONS(669),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [anon_sym_do] = ACTIONS(3264),
    [sym_identifier] = ACTIONS(679),
    [sym_comment] = ACTIONS(87),
  },
  [4088] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [4089] = {
    [sym__heredoc_body_start2] = ACTIONS(737),
    [sym__binary_minus2] = ACTIONS(737),
    [sym__binary_star2] = ACTIONS(737),
    [anon_sym_LBRACE] = ACTIONS(737),
    [anon_sym_RBRACE] = ACTIONS(737),
    [anon_sym_RPAREN] = ACTIONS(737),
    [anon_sym_DOT] = ACTIONS(3238),
    [anon_sym_COMMA] = ACTIONS(737),
    [anon_sym_PIPE] = ACTIONS(741),
    [anon_sym_SEMI] = ACTIONS(737),
    [anon_sym_STAR_STAR] = ACTIONS(741),
    [anon_sym_AMP] = ACTIONS(741),
    [anon_sym_EQ] = ACTIONS(741),
    [anon_sym_LT] = ACTIONS(741),
    [anon_sym_if] = ACTIONS(737),
    [anon_sym_unless] = ACTIONS(737),
    [anon_sym_while] = ACTIONS(737),
    [anon_sym_until] = ACTIONS(737),
    [anon_sym_rescue] = ACTIONS(737),
    [anon_sym_in] = ACTIONS(737),
    [anon_sym_do] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(3240),
    [anon_sym_RBRACK] = ACTIONS(737),
    [anon_sym_COLON_COLON2] = ACTIONS(3242),
    [anon_sym_AMP_DOT] = ACTIONS(3244),
    [anon_sym_PLUS_EQ] = ACTIONS(737),
    [anon_sym_DASH_EQ] = ACTIONS(737),
    [anon_sym_STAR_EQ] = ACTIONS(737),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(737),
    [anon_sym_SLASH_EQ] = ACTIONS(737),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(737),
    [anon_sym_PIPE_EQ] = ACTIONS(737),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(737),
    [anon_sym_AMP_EQ] = ACTIONS(737),
    [anon_sym_PERCENT_EQ] = ACTIONS(737),
    [anon_sym_GT_GT_EQ] = ACTIONS(737),
    [anon_sym_LT_LT_EQ] = ACTIONS(737),
    [anon_sym_CARET_EQ] = ACTIONS(737),
    [anon_sym_QMARK] = ACTIONS(737),
    [anon_sym_COLON2] = ACTIONS(741),
    [anon_sym_DOT_DOT] = ACTIONS(741),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(737),
    [anon_sym_and] = ACTIONS(737),
    [anon_sym_or] = ACTIONS(737),
    [anon_sym_PIPE_PIPE] = ACTIONS(741),
    [anon_sym_AMP_AMP] = ACTIONS(741),
    [anon_sym_LT_LT] = ACTIONS(741),
    [anon_sym_GT_GT] = ACTIONS(741),
    [anon_sym_EQ_EQ] = ACTIONS(741),
    [anon_sym_BANG_EQ] = ACTIONS(737),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(737),
    [anon_sym_LT_EQ_GT] = ACTIONS(737),
    [anon_sym_EQ_TILDE] = ACTIONS(737),
    [anon_sym_BANG_TILDE] = ACTIONS(737),
    [anon_sym_LT_EQ] = ACTIONS(741),
    [anon_sym_GT] = ACTIONS(741),
    [anon_sym_GT_EQ] = ACTIONS(737),
    [anon_sym_CARET] = ACTIONS(741),
    [anon_sym_PLUS] = ACTIONS(741),
    [anon_sym_SLASH] = ACTIONS(741),
    [anon_sym_PERCENT] = ACTIONS(741),
    [sym_comment] = ACTIONS(87),
  },
  [4090] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(1743),
    [sym__argument] = STATE(1744),
    [sym_splat_argument] = STATE(1744),
    [sym_hash_splat_argument] = STATE(1744),
    [sym_block_argument] = STATE(1744),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1744),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2931),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4091] = {
    [anon_sym_EQ] = ACTIONS(10065),
    [sym_comment] = ACTIONS(87),
  },
  [4092] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10067),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10069),
    [anon_sym_DASH_EQ] = ACTIONS(10069),
    [anon_sym_STAR_EQ] = ACTIONS(10069),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10069),
    [anon_sym_SLASH_EQ] = ACTIONS(10069),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10069),
    [anon_sym_PIPE_EQ] = ACTIONS(10069),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10069),
    [anon_sym_AMP_EQ] = ACTIONS(10069),
    [anon_sym_PERCENT_EQ] = ACTIONS(10069),
    [anon_sym_GT_GT_EQ] = ACTIONS(10069),
    [anon_sym_LT_LT_EQ] = ACTIONS(10069),
    [anon_sym_CARET_EQ] = ACTIONS(10069),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4093] = {
    [sym_string] = STATE(6937),
    [aux_sym_chained_string_repeat1] = STATE(6937),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4094] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [4095] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [4096] = {
    [sym_string] = STATE(4132),
    [aux_sym_chained_string_repeat1] = STATE(4132),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4097] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6938),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6938),
    [sym_operator_assignment] = STATE(6938),
    [sym_conditional] = STATE(6938),
    [sym_range] = STATE(6938),
    [sym_binary] = STATE(6938),
    [sym_unary] = STATE(6938),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4098] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [4099] = {
    [anon_sym_RBRACE] = ACTIONS(10071),
    [sym_comment] = ACTIONS(87),
  },
  [4100] = {
    [sym__statements] = STATE(6940),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10071),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4101] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [4102] = {
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_COLON2] = ACTIONS(5788),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [4103] = {
    [anon_sym_end] = ACTIONS(10073),
    [sym_comment] = ACTIONS(87),
  },
  [4104] = {
    [sym__statements] = STATE(6942),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(6943),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(6943),
    [sym__line_break2] = ACTIONS(10075),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10077),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4105] = {
    [sym__statements] = STATE(6942),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(6944),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10077),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4106] = {
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4242),
    [anon_sym_unless] = ACTIONS(4242),
    [anon_sym_while] = ACTIONS(4242),
    [anon_sym_until] = ACTIONS(4242),
    [anon_sym_rescue] = ACTIONS(4242),
    [anon_sym_in] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [sym_comment] = ACTIONS(87),
  },
  [4107] = {
    [sym_heredoc_body] = STATE(6946),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10079),
    [sym_comment] = ACTIONS(87),
  },
  [4108] = {
    [anon_sym_RPAREN] = ACTIONS(10079),
    [sym_comment] = ACTIONS(87),
  },
  [4109] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [4110] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [4111] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6947),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6947),
    [sym_operator_assignment] = STATE(6947),
    [sym_conditional] = STATE(6947),
    [sym_range] = STATE(6947),
    [sym_binary] = STATE(6947),
    [sym_unary] = STATE(6947),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4112] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6948),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6948),
    [sym_operator_assignment] = STATE(6948),
    [sym_conditional] = STATE(6948),
    [sym_range] = STATE(6948),
    [sym_binary] = STATE(6948),
    [sym_unary] = STATE(6948),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4113] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6949),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6949),
    [sym_operator_assignment] = STATE(6949),
    [sym_conditional] = STATE(6949),
    [sym_range] = STATE(6949),
    [sym_binary] = STATE(6949),
    [sym_unary] = STATE(6949),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4114] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6950),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6950),
    [sym_operator_assignment] = STATE(6950),
    [sym_conditional] = STATE(6950),
    [sym_range] = STATE(6950),
    [sym_binary] = STATE(6950),
    [sym_unary] = STATE(6950),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4115] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6951),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6951),
    [sym_operator_assignment] = STATE(6951),
    [sym_conditional] = STATE(6951),
    [sym_range] = STATE(6951),
    [sym_binary] = STATE(6951),
    [sym_unary] = STATE(6951),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4116] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6952),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6952),
    [sym_operator_assignment] = STATE(6952),
    [sym_conditional] = STATE(6952),
    [sym_range] = STATE(6952),
    [sym_binary] = STATE(6952),
    [sym_unary] = STATE(6952),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4117] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6953),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(6953),
    [sym_operator_assignment] = STATE(6953),
    [sym_conditional] = STATE(6953),
    [sym_range] = STATE(6953),
    [sym_binary] = STATE(6953),
    [sym_unary] = STATE(6953),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4118] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6954),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(6954),
    [sym_operator_assignment] = STATE(6954),
    [sym_conditional] = STATE(6954),
    [sym_range] = STATE(6954),
    [sym_binary] = STATE(6954),
    [sym_unary] = STATE(6954),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4119] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6955),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6955),
    [sym_operator_assignment] = STATE(6955),
    [sym_conditional] = STATE(6955),
    [sym_range] = STATE(6955),
    [sym_binary] = STATE(6955),
    [sym_unary] = STATE(6955),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4120] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6956),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6956),
    [sym_operator_assignment] = STATE(6956),
    [sym_conditional] = STATE(6956),
    [sym_range] = STATE(6956),
    [sym_binary] = STATE(6956),
    [sym_unary] = STATE(6956),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4121] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6957),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6957),
    [sym_operator_assignment] = STATE(6957),
    [sym_conditional] = STATE(6957),
    [sym_range] = STATE(6957),
    [sym_binary] = STATE(6957),
    [sym_unary] = STATE(6957),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4122] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6958),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6958),
    [sym_operator_assignment] = STATE(6958),
    [sym_conditional] = STATE(6958),
    [sym_range] = STATE(6958),
    [sym_binary] = STATE(6958),
    [sym_unary] = STATE(6958),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4123] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6959),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6959),
    [sym_operator_assignment] = STATE(6959),
    [sym_conditional] = STATE(6959),
    [sym_range] = STATE(6959),
    [sym_binary] = STATE(6959),
    [sym_unary] = STATE(6959),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4124] = {
    [sym__statements] = STATE(4099),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4100),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10081),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4125] = {
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_if] = ACTIONS(6196),
    [anon_sym_unless] = ACTIONS(6196),
    [anon_sym_while] = ACTIONS(6196),
    [anon_sym_until] = ACTIONS(6196),
    [anon_sym_rescue] = ACTIONS(6196),
    [anon_sym_do] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_COLON2] = ACTIONS(6198),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [4126] = {
    [sym_interpolation] = STATE(6962),
    [aux_sym_heredoc_body_repeat1] = STATE(6962),
    [sym__heredoc_content2] = ACTIONS(10083),
    [sym_heredoc_end2] = ACTIONS(10085),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(10083),
  },
  [4127] = {
    [sym_heredoc_body] = STATE(6963),
    [aux_sym_call_repeat1] = STATE(6963),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4128] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(6965),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10087),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4129] = {
    [sym_heredoc_body] = STATE(6966),
    [aux_sym_call_repeat1] = STATE(6966),
    [aux_sym_argument_list_repeat1] = STATE(6967),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6487),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4130] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6968),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_splat_argument] = STATE(6969),
    [sym_assignment] = STATE(6968),
    [sym_operator_assignment] = STATE(6968),
    [sym_conditional] = STATE(6968),
    [sym_range] = STATE(6968),
    [sym_binary] = STATE(6968),
    [sym_unary] = STATE(6968),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(6969),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4131] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6970),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(6970),
    [sym_operator_assignment] = STATE(6970),
    [sym_conditional] = STATE(6970),
    [sym_range] = STATE(6970),
    [sym_binary] = STATE(6970),
    [sym_unary] = STATE(6970),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4132] = {
    [sym_string] = STATE(6971),
    [aux_sym_chained_string_repeat1] = STATE(6971),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [4133] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6972),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(6972),
    [sym_operator_assignment] = STATE(6972),
    [sym_conditional] = STATE(6972),
    [sym_range] = STATE(6972),
    [sym_binary] = STATE(6972),
    [sym_unary] = STATE(6972),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4134] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6973),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(6973),
    [sym_operator_assignment] = STATE(6973),
    [sym_conditional] = STATE(6973),
    [sym_range] = STATE(6973),
    [sym_binary] = STATE(6973),
    [sym_unary] = STATE(6973),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4135] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4136] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4137] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4138] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(6802),
    [sym__argument] = STATE(6803),
    [sym_splat_argument] = STATE(6803),
    [sym_hash_splat_argument] = STATE(6803),
    [sym_block_argument] = STATE(6803),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(6803),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4139] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6974),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(6974),
    [sym_operator_assignment] = STATE(6974),
    [sym_conditional] = STATE(6974),
    [sym_range] = STATE(6974),
    [sym_binary] = STATE(6974),
    [sym_unary] = STATE(6974),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4140] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6975),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(6975),
    [sym_operator_assignment] = STATE(6975),
    [sym_conditional] = STATE(6975),
    [sym_range] = STATE(6975),
    [sym_binary] = STATE(6975),
    [sym_unary] = STATE(6975),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4141] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4142] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [4143] = {
    [aux_sym_exceptions_repeat1] = STATE(6989),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(10119),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4144] = {
    [anon_sym_EQ] = ACTIONS(10121),
    [sym_comment] = ACTIONS(87),
  },
  [4145] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10123),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10125),
    [anon_sym_DASH_EQ] = ACTIONS(10125),
    [anon_sym_STAR_EQ] = ACTIONS(10125),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10125),
    [anon_sym_SLASH_EQ] = ACTIONS(10125),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10125),
    [anon_sym_PIPE_EQ] = ACTIONS(10125),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10125),
    [anon_sym_AMP_EQ] = ACTIONS(10125),
    [anon_sym_PERCENT_EQ] = ACTIONS(10125),
    [anon_sym_GT_GT_EQ] = ACTIONS(10125),
    [anon_sym_LT_LT_EQ] = ACTIONS(10125),
    [anon_sym_CARET_EQ] = ACTIONS(10125),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4146] = {
    [sym_string] = STATE(6992),
    [aux_sym_chained_string_repeat1] = STATE(6992),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4147] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [4148] = {
    [sym_string] = STATE(4148),
    [aux_sym_chained_string_repeat1] = STATE(4148),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4149] = {
    [sym__line_break2] = ACTIONS(10127),
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [ts_builtin_sym_end] = ACTIONS(10127),
    [anon_sym___END__] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10127),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_end] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_when] = ACTIONS(10127),
    [anon_sym_elsif] = ACTIONS(10127),
    [anon_sym_else] = ACTIONS(10127),
    [anon_sym_then] = ACTIONS(10127),
    [anon_sym_ensure] = ACTIONS(10127),
    [anon_sym_EQ_GT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10127),
    [anon_sym_AMP_AMP] = ACTIONS(10127),
    [anon_sym_LT_LT] = ACTIONS(10127),
    [anon_sym_GT_GT] = ACTIONS(10127),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10127),
    [anon_sym_PLUS] = ACTIONS(10127),
    [anon_sym_SLASH] = ACTIONS(10127),
    [anon_sym_PERCENT] = ACTIONS(10127),
    [sym_comment] = ACTIONS(87),
  },
  [4150] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10131),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4151] = {
    [sym__line_break2] = ACTIONS(10133),
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [ts_builtin_sym_end] = ACTIONS(10133),
    [anon_sym___END__] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10133),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_end] = ACTIONS(10133),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_when] = ACTIONS(10133),
    [anon_sym_elsif] = ACTIONS(10133),
    [anon_sym_else] = ACTIONS(10133),
    [anon_sym_then] = ACTIONS(10133),
    [anon_sym_ensure] = ACTIONS(10133),
    [anon_sym_EQ_GT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10133),
    [anon_sym_AMP_AMP] = ACTIONS(10133),
    [anon_sym_LT_LT] = ACTIONS(10133),
    [anon_sym_GT_GT] = ACTIONS(10133),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10133),
    [anon_sym_PLUS] = ACTIONS(10133),
    [anon_sym_SLASH] = ACTIONS(10133),
    [anon_sym_PERCENT] = ACTIONS(10133),
    [sym_comment] = ACTIONS(87),
  },
  [4152] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4153] = {
    [sym__line_break2] = ACTIONS(10137),
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [ts_builtin_sym_end] = ACTIONS(10137),
    [anon_sym___END__] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10137),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_end] = ACTIONS(10137),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_when] = ACTIONS(10137),
    [anon_sym_elsif] = ACTIONS(10137),
    [anon_sym_else] = ACTIONS(10137),
    [anon_sym_then] = ACTIONS(10137),
    [anon_sym_ensure] = ACTIONS(10137),
    [anon_sym_EQ_GT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10137),
    [anon_sym_AMP_AMP] = ACTIONS(10137),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10137),
    [anon_sym_PLUS] = ACTIONS(10137),
    [anon_sym_SLASH] = ACTIONS(10137),
    [anon_sym_PERCENT] = ACTIONS(10137),
    [sym_comment] = ACTIONS(87),
  },
  [4154] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10141),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4155] = {
    [sym__line_break2] = ACTIONS(10143),
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [ts_builtin_sym_end] = ACTIONS(10143),
    [anon_sym___END__] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10143),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_end] = ACTIONS(10143),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_when] = ACTIONS(10143),
    [anon_sym_elsif] = ACTIONS(10143),
    [anon_sym_else] = ACTIONS(10143),
    [anon_sym_then] = ACTIONS(10143),
    [anon_sym_ensure] = ACTIONS(10143),
    [anon_sym_EQ_GT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10143),
    [anon_sym_AMP_AMP] = ACTIONS(10143),
    [anon_sym_LT_LT] = ACTIONS(10143),
    [anon_sym_GT_GT] = ACTIONS(10143),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10143),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10143),
    [anon_sym_PERCENT] = ACTIONS(10143),
    [sym_comment] = ACTIONS(87),
  },
  [4156] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4157] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6995),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(6995),
    [sym_operator_assignment] = STATE(6995),
    [sym_conditional] = STATE(6995),
    [sym_range] = STATE(6995),
    [sym_binary] = STATE(6995),
    [sym_unary] = STATE(6995),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4158] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(6996),
    [sym__argument] = STATE(6997),
    [sym_splat_argument] = STATE(6997),
    [sym_hash_splat_argument] = STATE(6997),
    [sym_block_argument] = STATE(6997),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6997),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4159] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(6996),
    [sym__argument] = STATE(6997),
    [sym_splat_argument] = STATE(6997),
    [sym_hash_splat_argument] = STATE(6997),
    [sym_block_argument] = STATE(6997),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6997),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4160] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(6996),
    [sym__argument] = STATE(6997),
    [sym_splat_argument] = STATE(6997),
    [sym_hash_splat_argument] = STATE(6997),
    [sym_block_argument] = STATE(6997),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6997),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4161] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(6996),
    [sym__argument] = STATE(6997),
    [sym_splat_argument] = STATE(6997),
    [sym_hash_splat_argument] = STATE(6997),
    [sym_block_argument] = STATE(6997),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(6997),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3044),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4162] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6998),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(6998),
    [sym_operator_assignment] = STATE(6998),
    [sym_conditional] = STATE(6998),
    [sym_range] = STATE(6998),
    [sym_binary] = STATE(6998),
    [sym_unary] = STATE(6998),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4163] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6999),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(6999),
    [sym_operator_assignment] = STATE(6999),
    [sym_conditional] = STATE(6999),
    [sym_range] = STATE(6999),
    [sym_binary] = STATE(6999),
    [sym_unary] = STATE(6999),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4164] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4165] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [4166] = {
    [anon_sym_EQ] = ACTIONS(10177),
    [sym_comment] = ACTIONS(87),
  },
  [4167] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10179),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10181),
    [anon_sym_DASH_EQ] = ACTIONS(10181),
    [anon_sym_STAR_EQ] = ACTIONS(10181),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10181),
    [anon_sym_SLASH_EQ] = ACTIONS(10181),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10181),
    [anon_sym_PIPE_EQ] = ACTIONS(10181),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10181),
    [anon_sym_AMP_EQ] = ACTIONS(10181),
    [anon_sym_PERCENT_EQ] = ACTIONS(10181),
    [anon_sym_GT_GT_EQ] = ACTIONS(10181),
    [anon_sym_LT_LT_EQ] = ACTIONS(10181),
    [anon_sym_CARET_EQ] = ACTIONS(10181),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4168] = {
    [sym_string] = STATE(7014),
    [aux_sym_chained_string_repeat1] = STATE(7014),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4169] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [4170] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4171] = {
    [sym_string] = STATE(4196),
    [aux_sym_chained_string_repeat1] = STATE(4196),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4172] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7015),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(7015),
    [sym_operator_assignment] = STATE(7015),
    [sym_conditional] = STATE(7015),
    [sym_range] = STATE(7015),
    [sym_binary] = STATE(7015),
    [sym_unary] = STATE(7015),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4173] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [4174] = {
    [sym_heredoc_body] = STATE(7016),
    [aux_sym_call_repeat1] = STATE(7016),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4175] = {
    [sym_heredoc_body] = STATE(7016),
    [aux_sym_call_repeat1] = STATE(7016),
    [aux_sym_argument_list_repeat1] = STATE(7017),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9846),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4176] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4177] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [4178] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7018),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7018),
    [sym_operator_assignment] = STATE(7018),
    [sym_conditional] = STATE(7018),
    [sym_range] = STATE(7018),
    [sym_binary] = STATE(7018),
    [sym_unary] = STATE(7018),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4179] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7019),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7019),
    [sym_operator_assignment] = STATE(7019),
    [sym_conditional] = STATE(7019),
    [sym_range] = STATE(7019),
    [sym_binary] = STATE(7019),
    [sym_unary] = STATE(7019),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4180] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7020),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7020),
    [sym_operator_assignment] = STATE(7020),
    [sym_conditional] = STATE(7020),
    [sym_range] = STATE(7020),
    [sym_binary] = STATE(7020),
    [sym_unary] = STATE(7020),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4181] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7021),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7021),
    [sym_operator_assignment] = STATE(7021),
    [sym_conditional] = STATE(7021),
    [sym_range] = STATE(7021),
    [sym_binary] = STATE(7021),
    [sym_unary] = STATE(7021),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4182] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7022),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7022),
    [sym_operator_assignment] = STATE(7022),
    [sym_conditional] = STATE(7022),
    [sym_range] = STATE(7022),
    [sym_binary] = STATE(7022),
    [sym_unary] = STATE(7022),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4183] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7023),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7023),
    [sym_operator_assignment] = STATE(7023),
    [sym_conditional] = STATE(7023),
    [sym_range] = STATE(7023),
    [sym_binary] = STATE(7023),
    [sym_unary] = STATE(7023),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4184] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7024),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(7024),
    [sym_operator_assignment] = STATE(7024),
    [sym_conditional] = STATE(7024),
    [sym_range] = STATE(7024),
    [sym_binary] = STATE(7024),
    [sym_unary] = STATE(7024),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4185] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7025),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7025),
    [sym_operator_assignment] = STATE(7025),
    [sym_conditional] = STATE(7025),
    [sym_range] = STATE(7025),
    [sym_binary] = STATE(7025),
    [sym_unary] = STATE(7025),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4186] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7026),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7026),
    [sym_operator_assignment] = STATE(7026),
    [sym_conditional] = STATE(7026),
    [sym_range] = STATE(7026),
    [sym_binary] = STATE(7026),
    [sym_unary] = STATE(7026),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4187] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7027),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7027),
    [sym_operator_assignment] = STATE(7027),
    [sym_conditional] = STATE(7027),
    [sym_range] = STATE(7027),
    [sym_binary] = STATE(7027),
    [sym_unary] = STATE(7027),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4188] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7028),
    [sym_operator_assignment] = STATE(7028),
    [sym_conditional] = STATE(7028),
    [sym_range] = STATE(7028),
    [sym_binary] = STATE(7028),
    [sym_unary] = STATE(7028),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4189] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7029),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7029),
    [sym_operator_assignment] = STATE(7029),
    [sym_conditional] = STATE(7029),
    [sym_range] = STATE(7029),
    [sym_binary] = STATE(7029),
    [sym_unary] = STATE(7029),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4190] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7030),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7030),
    [sym_operator_assignment] = STATE(7030),
    [sym_conditional] = STATE(7030),
    [sym_range] = STATE(7030),
    [sym_binary] = STATE(7030),
    [sym_unary] = STATE(7030),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4191] = {
    [sym_heredoc_body] = STATE(7031),
    [aux_sym_call_repeat1] = STATE(7031),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4192] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(7032),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10183),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4193] = {
    [sym_heredoc_body] = STATE(7033),
    [aux_sym_call_repeat1] = STATE(7033),
    [aux_sym_argument_list_repeat1] = STATE(7034),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6623),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4194] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7035),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_splat_argument] = STATE(7036),
    [sym_assignment] = STATE(7035),
    [sym_operator_assignment] = STATE(7035),
    [sym_conditional] = STATE(7035),
    [sym_range] = STATE(7035),
    [sym_binary] = STATE(7035),
    [sym_unary] = STATE(7035),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(7036),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4195] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7037),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(7037),
    [sym_operator_assignment] = STATE(7037),
    [sym_conditional] = STATE(7037),
    [sym_range] = STATE(7037),
    [sym_binary] = STATE(7037),
    [sym_unary] = STATE(7037),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4196] = {
    [sym_string] = STATE(7038),
    [aux_sym_chained_string_repeat1] = STATE(7038),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4197] = {
    [aux_sym_undef_repeat1] = STATE(7039),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_RBRACE] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [4198] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(5832),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4199] = {
    [sym_heredoc_body] = STATE(7040),
    [sym__terminator] = STATE(7040),
    [aux_sym__statements_repeat1] = STATE(4199),
    [sym__line_break2] = ACTIONS(10185),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_RBRACE] = ACTIONS(5830),
    [anon_sym_SEMI] = ACTIONS(10185),
    [sym_comment] = ACTIONS(87),
  },
  [4200] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5842),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4201] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5844),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4202] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5846),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4203] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5848),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4204] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5850),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(3084),
    [anon_sym_or] = ACTIONS(3084),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4205] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4206] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4207] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4208] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4209] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4210] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4211] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10188),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4212] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4213] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4214] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4215] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4216] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4217] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7042),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(7042),
    [sym_operator_assignment] = STATE(7042),
    [sym_conditional] = STATE(7042),
    [sym_range] = STATE(7042),
    [sym_binary] = STATE(7042),
    [sym_unary] = STATE(7042),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4218] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4219] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4220] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4221] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4222] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7043),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(7043),
    [sym_operator_assignment] = STATE(7043),
    [sym_conditional] = STATE(7043),
    [sym_range] = STATE(7043),
    [sym_binary] = STATE(7043),
    [sym_unary] = STATE(7043),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4223] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7044),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(7044),
    [sym_operator_assignment] = STATE(7044),
    [sym_conditional] = STATE(7044),
    [sym_range] = STATE(7044),
    [sym_binary] = STATE(7044),
    [sym_unary] = STATE(7044),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4224] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4225] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [4226] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(1827),
    [sym__argument] = STATE(1828),
    [sym_splat_argument] = STATE(1828),
    [sym_hash_splat_argument] = STATE(1828),
    [sym_block_argument] = STATE(1828),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(1828),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3118),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4227] = {
    [anon_sym_EQ] = ACTIONS(10218),
    [sym_comment] = ACTIONS(87),
  },
  [4228] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10220),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10222),
    [anon_sym_DASH_EQ] = ACTIONS(10222),
    [anon_sym_STAR_EQ] = ACTIONS(10222),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10222),
    [anon_sym_SLASH_EQ] = ACTIONS(10222),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10222),
    [anon_sym_PIPE_EQ] = ACTIONS(10222),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10222),
    [anon_sym_AMP_EQ] = ACTIONS(10222),
    [anon_sym_PERCENT_EQ] = ACTIONS(10222),
    [anon_sym_GT_GT_EQ] = ACTIONS(10222),
    [anon_sym_LT_LT_EQ] = ACTIONS(10222),
    [anon_sym_CARET_EQ] = ACTIONS(10222),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4229] = {
    [sym_string] = STATE(7059),
    [aux_sym_chained_string_repeat1] = STATE(7059),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4230] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [4231] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [4232] = {
    [sym_string] = STATE(4255),
    [aux_sym_chained_string_repeat1] = STATE(4255),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4233] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7060),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(7060),
    [sym_operator_assignment] = STATE(7060),
    [sym_conditional] = STATE(7060),
    [sym_range] = STATE(7060),
    [sym_binary] = STATE(7060),
    [sym_unary] = STATE(7060),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4234] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [4235] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [4236] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [4237] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7061),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7061),
    [sym_operator_assignment] = STATE(7061),
    [sym_conditional] = STATE(7061),
    [sym_range] = STATE(7061),
    [sym_binary] = STATE(7061),
    [sym_unary] = STATE(7061),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4238] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7062),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7062),
    [sym_operator_assignment] = STATE(7062),
    [sym_conditional] = STATE(7062),
    [sym_range] = STATE(7062),
    [sym_binary] = STATE(7062),
    [sym_unary] = STATE(7062),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4239] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7063),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7063),
    [sym_operator_assignment] = STATE(7063),
    [sym_conditional] = STATE(7063),
    [sym_range] = STATE(7063),
    [sym_binary] = STATE(7063),
    [sym_unary] = STATE(7063),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4240] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7064),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7064),
    [sym_operator_assignment] = STATE(7064),
    [sym_conditional] = STATE(7064),
    [sym_range] = STATE(7064),
    [sym_binary] = STATE(7064),
    [sym_unary] = STATE(7064),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4241] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7065),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7065),
    [sym_operator_assignment] = STATE(7065),
    [sym_conditional] = STATE(7065),
    [sym_range] = STATE(7065),
    [sym_binary] = STATE(7065),
    [sym_unary] = STATE(7065),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4242] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7066),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7066),
    [sym_operator_assignment] = STATE(7066),
    [sym_conditional] = STATE(7066),
    [sym_range] = STATE(7066),
    [sym_binary] = STATE(7066),
    [sym_unary] = STATE(7066),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4243] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7067),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(7067),
    [sym_operator_assignment] = STATE(7067),
    [sym_conditional] = STATE(7067),
    [sym_range] = STATE(7067),
    [sym_binary] = STATE(7067),
    [sym_unary] = STATE(7067),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4244] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7068),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7068),
    [sym_operator_assignment] = STATE(7068),
    [sym_conditional] = STATE(7068),
    [sym_range] = STATE(7068),
    [sym_binary] = STATE(7068),
    [sym_unary] = STATE(7068),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4245] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7069),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7069),
    [sym_operator_assignment] = STATE(7069),
    [sym_conditional] = STATE(7069),
    [sym_range] = STATE(7069),
    [sym_binary] = STATE(7069),
    [sym_unary] = STATE(7069),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4246] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7070),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7070),
    [sym_operator_assignment] = STATE(7070),
    [sym_conditional] = STATE(7070),
    [sym_range] = STATE(7070),
    [sym_binary] = STATE(7070),
    [sym_unary] = STATE(7070),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4247] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7071),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7071),
    [sym_operator_assignment] = STATE(7071),
    [sym_conditional] = STATE(7071),
    [sym_range] = STATE(7071),
    [sym_binary] = STATE(7071),
    [sym_unary] = STATE(7071),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4248] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7072),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7072),
    [sym_operator_assignment] = STATE(7072),
    [sym_conditional] = STATE(7072),
    [sym_range] = STATE(7072),
    [sym_binary] = STATE(7072),
    [sym_unary] = STATE(7072),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4249] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7073),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7073),
    [sym_operator_assignment] = STATE(7073),
    [sym_conditional] = STATE(7073),
    [sym_range] = STATE(7073),
    [sym_binary] = STATE(7073),
    [sym_unary] = STATE(7073),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4250] = {
    [sym_heredoc_body] = STATE(7074),
    [aux_sym_call_repeat1] = STATE(7074),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4251] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(7075),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10224),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4252] = {
    [sym_heredoc_body] = STATE(7076),
    [aux_sym_call_repeat1] = STATE(7076),
    [aux_sym_argument_list_repeat1] = STATE(7077),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6695),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4253] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7078),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_splat_argument] = STATE(7079),
    [sym_assignment] = STATE(7078),
    [sym_operator_assignment] = STATE(7078),
    [sym_conditional] = STATE(7078),
    [sym_range] = STATE(7078),
    [sym_binary] = STATE(7078),
    [sym_unary] = STATE(7078),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(7079),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4254] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7080),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(7080),
    [sym_operator_assignment] = STATE(7080),
    [sym_conditional] = STATE(7080),
    [sym_range] = STATE(7080),
    [sym_binary] = STATE(7080),
    [sym_unary] = STATE(7080),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4255] = {
    [sym_string] = STATE(7081),
    [aux_sym_chained_string_repeat1] = STATE(7081),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [4256] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7082),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(7082),
    [sym_operator_assignment] = STATE(7082),
    [sym_conditional] = STATE(7082),
    [sym_range] = STATE(7082),
    [sym_binary] = STATE(7082),
    [sym_unary] = STATE(7082),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4257] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7083),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(7083),
    [sym_operator_assignment] = STATE(7083),
    [sym_conditional] = STATE(7083),
    [sym_range] = STATE(7083),
    [sym_binary] = STATE(7083),
    [sym_unary] = STATE(7083),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4258] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7084),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(7084),
    [sym_operator_assignment] = STATE(7084),
    [sym_conditional] = STATE(7084),
    [sym_range] = STATE(7084),
    [sym_binary] = STATE(7084),
    [sym_unary] = STATE(7084),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4259] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7085),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(7085),
    [sym_operator_assignment] = STATE(7085),
    [sym_conditional] = STATE(7085),
    [sym_range] = STATE(7085),
    [sym_binary] = STATE(7085),
    [sym_unary] = STATE(7085),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4260] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4261] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [4262] = {
    [aux_sym_exceptions_repeat1] = STATE(7099),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(10256),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4263] = {
    [anon_sym_EQ] = ACTIONS(10258),
    [sym_comment] = ACTIONS(87),
  },
  [4264] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10260),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10262),
    [anon_sym_DASH_EQ] = ACTIONS(10262),
    [anon_sym_STAR_EQ] = ACTIONS(10262),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10262),
    [anon_sym_SLASH_EQ] = ACTIONS(10262),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10262),
    [anon_sym_PIPE_EQ] = ACTIONS(10262),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10262),
    [anon_sym_AMP_EQ] = ACTIONS(10262),
    [anon_sym_PERCENT_EQ] = ACTIONS(10262),
    [anon_sym_GT_GT_EQ] = ACTIONS(10262),
    [anon_sym_LT_LT_EQ] = ACTIONS(10262),
    [anon_sym_CARET_EQ] = ACTIONS(10262),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4265] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [4266] = {
    [sym_string] = STATE(4266),
    [aux_sym_chained_string_repeat1] = STATE(4266),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4267] = {
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6517),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_EQ_GT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_COLON2] = ACTIONS(6519),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6517),
    [anon_sym_GT_GT] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6517),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_SLASH] = ACTIONS(6517),
    [anon_sym_PERCENT] = ACTIONS(6517),
    [sym_comment] = ACTIONS(87),
  },
  [4268] = {
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6521),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_EQ_GT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_COLON2] = ACTIONS(6523),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6521),
    [anon_sym_AMP_AMP] = ACTIONS(6521),
    [anon_sym_LT_LT] = ACTIONS(6521),
    [anon_sym_GT_GT] = ACTIONS(6521),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6521),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_PERCENT] = ACTIONS(6521),
    [sym_comment] = ACTIONS(87),
  },
  [4269] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10264),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4270] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(10264),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10266),
  },
  [4271] = {
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6529),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_EQ_GT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_COLON2] = ACTIONS(6531),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6529),
    [anon_sym_AMP_AMP] = ACTIONS(6529),
    [anon_sym_LT_LT] = ACTIONS(6529),
    [anon_sym_GT_GT] = ACTIONS(6529),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6529),
    [anon_sym_PLUS] = ACTIONS(6529),
    [anon_sym_SLASH] = ACTIONS(6529),
    [anon_sym_PERCENT] = ACTIONS(6529),
    [sym_comment] = ACTIONS(87),
  },
  [4272] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10268),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4273] = {
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6542),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_EQ_GT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_COLON2] = ACTIONS(6544),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6542),
    [anon_sym_AMP_AMP] = ACTIONS(6542),
    [anon_sym_LT_LT] = ACTIONS(6542),
    [anon_sym_GT_GT] = ACTIONS(6542),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6542),
    [anon_sym_PLUS] = ACTIONS(6542),
    [anon_sym_SLASH] = ACTIONS(6542),
    [anon_sym_PERCENT] = ACTIONS(6542),
    [sym_comment] = ACTIONS(87),
  },
  [4274] = {
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6546),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_EQ_GT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_COLON2] = ACTIONS(6548),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6546),
    [anon_sym_AMP_AMP] = ACTIONS(6546),
    [anon_sym_LT_LT] = ACTIONS(6546),
    [anon_sym_GT_GT] = ACTIONS(6546),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6546),
    [anon_sym_PLUS] = ACTIONS(6546),
    [anon_sym_SLASH] = ACTIONS(6546),
    [anon_sym_PERCENT] = ACTIONS(6546),
    [sym_comment] = ACTIONS(87),
  },
  [4275] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10270),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4276] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(10270),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10272),
  },
  [4277] = {
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6554),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_EQ_GT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_COLON2] = ACTIONS(6556),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6554),
    [anon_sym_AMP_AMP] = ACTIONS(6554),
    [anon_sym_LT_LT] = ACTIONS(6554),
    [anon_sym_GT_GT] = ACTIONS(6554),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6554),
    [anon_sym_PLUS] = ACTIONS(6554),
    [anon_sym_SLASH] = ACTIONS(6554),
    [anon_sym_PERCENT] = ACTIONS(6554),
    [sym_comment] = ACTIONS(87),
  },
  [4278] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10274),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4279] = {
    [sym__heredoc_content2] = ACTIONS(6351),
    [sym_heredoc_end2] = ACTIONS(6351),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(6353),
    [sym_escape_sequence] = ACTIONS(6351),
  },
  [4280] = {
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7098),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_EQ_GT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_COLON2] = ACTIONS(7100),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7098),
    [anon_sym_AMP_AMP] = ACTIONS(7098),
    [anon_sym_LT_LT] = ACTIONS(7098),
    [anon_sym_GT_GT] = ACTIONS(7098),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7098),
    [anon_sym_PLUS] = ACTIONS(7098),
    [anon_sym_SLASH] = ACTIONS(7098),
    [anon_sym_PERCENT] = ACTIONS(7098),
    [sym_comment] = ACTIONS(87),
  },
  [4281] = {
    [anon_sym_DOT] = ACTIONS(10276),
    [anon_sym_COLON_COLON] = ACTIONS(10276),
    [sym_comment] = ACTIONS(87),
  },
  [4282] = {
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7258),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_EQ_GT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_COLON2] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7258),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [anon_sym_LT_LT] = ACTIONS(7258),
    [anon_sym_GT_GT] = ACTIONS(7258),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7258),
    [anon_sym_PLUS] = ACTIONS(7258),
    [anon_sym_SLASH] = ACTIONS(7258),
    [anon_sym_PERCENT] = ACTIONS(7258),
    [sym_comment] = ACTIONS(87),
  },
  [4283] = {
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7274),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_EQ_GT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_COLON2] = ACTIONS(7276),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7274),
    [anon_sym_GT_GT] = ACTIONS(7274),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7274),
    [anon_sym_PLUS] = ACTIONS(7274),
    [anon_sym_SLASH] = ACTIONS(7274),
    [anon_sym_PERCENT] = ACTIONS(7274),
    [sym_comment] = ACTIONS(87),
  },
  [4284] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7109),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(7109),
    [sym_operator_assignment] = STATE(7109),
    [sym_conditional] = STATE(7109),
    [sym_range] = STATE(7109),
    [sym_binary] = STATE(7109),
    [sym_unary] = STATE(7109),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4285] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7110),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(7110),
    [sym_operator_assignment] = STATE(7110),
    [sym_conditional] = STATE(7110),
    [sym_range] = STATE(7110),
    [sym_binary] = STATE(7110),
    [sym_unary] = STATE(7110),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4286] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7111),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(7111),
    [sym_operator_assignment] = STATE(7111),
    [sym_conditional] = STATE(7111),
    [sym_range] = STATE(7111),
    [sym_binary] = STATE(7111),
    [sym_unary] = STATE(7111),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4287] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4288] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [4289] = {
    [anon_sym_EQ] = ACTIONS(10308),
    [sym_comment] = ACTIONS(87),
  },
  [4290] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10310),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10312),
    [anon_sym_DASH_EQ] = ACTIONS(10312),
    [anon_sym_STAR_EQ] = ACTIONS(10312),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10312),
    [anon_sym_SLASH_EQ] = ACTIONS(10312),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10312),
    [anon_sym_PIPE_EQ] = ACTIONS(10312),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10312),
    [anon_sym_AMP_EQ] = ACTIONS(10312),
    [anon_sym_PERCENT_EQ] = ACTIONS(10312),
    [anon_sym_GT_GT_EQ] = ACTIONS(10312),
    [anon_sym_LT_LT_EQ] = ACTIONS(10312),
    [anon_sym_CARET_EQ] = ACTIONS(10312),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4291] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [4292] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4293] = {
    [sym_string] = STATE(4334),
    [aux_sym_chained_string_repeat1] = STATE(4334),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4294] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7126),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(7126),
    [sym_operator_assignment] = STATE(7126),
    [sym_conditional] = STATE(7126),
    [sym_range] = STATE(7126),
    [sym_binary] = STATE(7126),
    [sym_unary] = STATE(7126),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4295] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [4296] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7127),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7127),
    [sym_operator_assignment] = STATE(7127),
    [sym_conditional] = STATE(7127),
    [sym_range] = STATE(7127),
    [sym_binary] = STATE(7127),
    [sym_unary] = STATE(7127),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4297] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7128),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7128),
    [sym_operator_assignment] = STATE(7128),
    [sym_conditional] = STATE(7128),
    [sym_range] = STATE(7128),
    [sym_binary] = STATE(7128),
    [sym_unary] = STATE(7128),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4298] = {
    [anon_sym_COLON] = ACTIONS(10314),
    [sym_comment] = ACTIONS(87),
  },
  [4299] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7130),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7130),
    [sym_operator_assignment] = STATE(7130),
    [sym_conditional] = STATE(7130),
    [sym_range] = STATE(7130),
    [sym_binary] = STATE(7130),
    [sym_unary] = STATE(7130),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4300] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10316),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4301] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [4302] = {
    [sym_heredoc_body] = STATE(7132),
    [aux_sym_call_repeat1] = STATE(7132),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4303] = {
    [sym_heredoc_body] = STATE(7132),
    [aux_sym_call_repeat1] = STATE(7132),
    [aux_sym_argument_list_repeat1] = STATE(7134),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10318),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4304] = {
    [sym_string] = STATE(4334),
    [aux_sym_chained_string_repeat1] = STATE(4334),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10320),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4305] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4306] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [4307] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7135),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7135),
    [sym_operator_assignment] = STATE(7135),
    [sym_conditional] = STATE(7135),
    [sym_range] = STATE(7135),
    [sym_binary] = STATE(7135),
    [sym_unary] = STATE(7135),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4308] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7136),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7136),
    [sym_operator_assignment] = STATE(7136),
    [sym_conditional] = STATE(7136),
    [sym_range] = STATE(7136),
    [sym_binary] = STATE(7136),
    [sym_unary] = STATE(7136),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4309] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7137),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7137),
    [sym_operator_assignment] = STATE(7137),
    [sym_conditional] = STATE(7137),
    [sym_range] = STATE(7137),
    [sym_binary] = STATE(7137),
    [sym_unary] = STATE(7137),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4310] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7138),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7138),
    [sym_operator_assignment] = STATE(7138),
    [sym_conditional] = STATE(7138),
    [sym_range] = STATE(7138),
    [sym_binary] = STATE(7138),
    [sym_unary] = STATE(7138),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4311] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7139),
    [sym_operator_assignment] = STATE(7139),
    [sym_conditional] = STATE(7139),
    [sym_range] = STATE(7139),
    [sym_binary] = STATE(7139),
    [sym_unary] = STATE(7139),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4312] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7140),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7140),
    [sym_operator_assignment] = STATE(7140),
    [sym_conditional] = STATE(7140),
    [sym_range] = STATE(7140),
    [sym_binary] = STATE(7140),
    [sym_unary] = STATE(7140),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4313] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7141),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(7141),
    [sym_operator_assignment] = STATE(7141),
    [sym_conditional] = STATE(7141),
    [sym_range] = STATE(7141),
    [sym_binary] = STATE(7141),
    [sym_unary] = STATE(7141),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4314] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7142),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7142),
    [sym_operator_assignment] = STATE(7142),
    [sym_conditional] = STATE(7142),
    [sym_range] = STATE(7142),
    [sym_binary] = STATE(7142),
    [sym_unary] = STATE(7142),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4315] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7143),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7143),
    [sym_operator_assignment] = STATE(7143),
    [sym_conditional] = STATE(7143),
    [sym_range] = STATE(7143),
    [sym_binary] = STATE(7143),
    [sym_unary] = STATE(7143),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4316] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7144),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7144),
    [sym_operator_assignment] = STATE(7144),
    [sym_conditional] = STATE(7144),
    [sym_range] = STATE(7144),
    [sym_binary] = STATE(7144),
    [sym_unary] = STATE(7144),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4317] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7145),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7145),
    [sym_operator_assignment] = STATE(7145),
    [sym_conditional] = STATE(7145),
    [sym_range] = STATE(7145),
    [sym_binary] = STATE(7145),
    [sym_unary] = STATE(7145),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4318] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7146),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7146),
    [sym_operator_assignment] = STATE(7146),
    [sym_conditional] = STATE(7146),
    [sym_range] = STATE(7146),
    [sym_binary] = STATE(7146),
    [sym_unary] = STATE(7146),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4319] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7147),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7147),
    [sym_operator_assignment] = STATE(7147),
    [sym_conditional] = STATE(7147),
    [sym_range] = STATE(7147),
    [sym_binary] = STATE(7147),
    [sym_unary] = STATE(7147),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4320] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7148),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7148),
    [sym_operator_assignment] = STATE(7148),
    [sym_conditional] = STATE(7148),
    [sym_range] = STATE(7148),
    [sym_binary] = STATE(7148),
    [sym_unary] = STATE(7148),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4321] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7149),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7149),
    [sym_operator_assignment] = STATE(7149),
    [sym_conditional] = STATE(7149),
    [sym_range] = STATE(7149),
    [sym_binary] = STATE(7149),
    [sym_unary] = STATE(7149),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4322] = {
    [anon_sym_COLON] = ACTIONS(10322),
    [sym_comment] = ACTIONS(87),
  },
  [4323] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7151),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7151),
    [sym_operator_assignment] = STATE(7151),
    [sym_conditional] = STATE(7151),
    [sym_range] = STATE(7151),
    [sym_binary] = STATE(7151),
    [sym_unary] = STATE(7151),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4324] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_RBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10324),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4325] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [4326] = {
    [sym_heredoc_body] = STATE(7153),
    [aux_sym_call_repeat1] = STATE(7153),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4327] = {
    [sym_heredoc_body] = STATE(7153),
    [aux_sym_call_repeat1] = STATE(7153),
    [aux_sym_argument_list_repeat1] = STATE(7155),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10326),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4328] = {
    [sym_string] = STATE(4403),
    [aux_sym_chained_string_repeat1] = STATE(4403),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10328),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4329] = {
    [sym_heredoc_body] = STATE(7156),
    [aux_sym_call_repeat1] = STATE(7156),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4330] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7157),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10330),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4331] = {
    [sym_heredoc_body] = STATE(7158),
    [aux_sym_call_repeat1] = STATE(7158),
    [aux_sym_argument_list_repeat1] = STATE(7159),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6823),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4332] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7160),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_splat_argument] = STATE(7161),
    [sym_assignment] = STATE(7160),
    [sym_operator_assignment] = STATE(7160),
    [sym_conditional] = STATE(7160),
    [sym_range] = STATE(7160),
    [sym_binary] = STATE(7160),
    [sym_unary] = STATE(7160),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(7161),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4333] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7162),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(7162),
    [sym_operator_assignment] = STATE(7162),
    [sym_conditional] = STATE(7162),
    [sym_range] = STATE(7162),
    [sym_binary] = STATE(7162),
    [sym_unary] = STATE(7162),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4334] = {
    [sym_string] = STATE(7163),
    [aux_sym_chained_string_repeat1] = STATE(7163),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4335] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4336] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4337] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4338] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4339] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4340] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4341] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10332),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4342] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4343] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4344] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4345] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4346] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4347] = {
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__binary_minus2] = ACTIONS(1273),
    [sym__binary_star2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_RBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_RPAREN] = ACTIONS(1273),
    [anon_sym_DOT] = ACTIONS(1275),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_COMMA] = ACTIONS(1273),
    [anon_sym_PIPE] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1275),
    [anon_sym_AMP] = ACTIONS(1275),
    [anon_sym_EQ] = ACTIONS(1275),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_LT] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_rescue] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_in] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_RBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS_EQ] = ACTIONS(1273),
    [anon_sym_DASH_EQ] = ACTIONS(1273),
    [anon_sym_STAR_EQ] = ACTIONS(1273),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1273),
    [anon_sym_SLASH_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_PIPE_EQ] = ACTIONS(1273),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1273),
    [anon_sym_AMP_EQ] = ACTIONS(1273),
    [anon_sym_PERCENT_EQ] = ACTIONS(1273),
    [anon_sym_GT_GT_EQ] = ACTIONS(1273),
    [anon_sym_LT_LT_EQ] = ACTIONS(1273),
    [anon_sym_CARET_EQ] = ACTIONS(1273),
    [anon_sym_QMARK] = ACTIONS(1275),
    [anon_sym_COLON2] = ACTIONS(1275),
    [anon_sym_DOT_DOT] = ACTIONS(1275),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1273),
    [anon_sym_and] = ACTIONS(1275),
    [anon_sym_or] = ACTIONS(1275),
    [anon_sym_PIPE_PIPE] = ACTIONS(1275),
    [anon_sym_AMP_AMP] = ACTIONS(1275),
    [anon_sym_LT_LT] = ACTIONS(1275),
    [anon_sym_GT_GT] = ACTIONS(1275),
    [anon_sym_EQ_EQ] = ACTIONS(1275),
    [anon_sym_BANG_EQ] = ACTIONS(1273),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1273),
    [anon_sym_LT_EQ_GT] = ACTIONS(1273),
    [anon_sym_EQ_TILDE] = ACTIONS(1273),
    [anon_sym_BANG_TILDE] = ACTIONS(1273),
    [anon_sym_LT_EQ] = ACTIONS(1275),
    [anon_sym_GT] = ACTIONS(1275),
    [anon_sym_GT_EQ] = ACTIONS(1273),
    [anon_sym_CARET] = ACTIONS(1275),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_SLASH] = ACTIONS(1275),
    [anon_sym_PERCENT] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1275),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [4348] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(7166),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7167),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10334),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4349] = {
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym__heredoc_body_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__binary_minus2] = ACTIONS(5974),
    [sym__binary_star2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_RBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_RPAREN] = ACTIONS(5974),
    [anon_sym_DOT] = ACTIONS(5976),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_COMMA] = ACTIONS(5974),
    [anon_sym_PIPE] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5976),
    [anon_sym_AMP] = ACTIONS(5976),
    [anon_sym_EQ] = ACTIONS(5976),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_LT] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_rescue] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_in] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_RBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS_EQ] = ACTIONS(5974),
    [anon_sym_DASH_EQ] = ACTIONS(5974),
    [anon_sym_STAR_EQ] = ACTIONS(5974),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5974),
    [anon_sym_SLASH_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_PIPE_EQ] = ACTIONS(5974),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5974),
    [anon_sym_AMP_EQ] = ACTIONS(5974),
    [anon_sym_PERCENT_EQ] = ACTIONS(5974),
    [anon_sym_GT_GT_EQ] = ACTIONS(5974),
    [anon_sym_LT_LT_EQ] = ACTIONS(5974),
    [anon_sym_CARET_EQ] = ACTIONS(5974),
    [anon_sym_QMARK] = ACTIONS(5976),
    [anon_sym_COLON2] = ACTIONS(5976),
    [anon_sym_DOT_DOT] = ACTIONS(5976),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5974),
    [anon_sym_and] = ACTIONS(5976),
    [anon_sym_or] = ACTIONS(5976),
    [anon_sym_PIPE_PIPE] = ACTIONS(5976),
    [anon_sym_AMP_AMP] = ACTIONS(5976),
    [anon_sym_LT_LT] = ACTIONS(5976),
    [anon_sym_GT_GT] = ACTIONS(5976),
    [anon_sym_EQ_EQ] = ACTIONS(5976),
    [anon_sym_BANG_EQ] = ACTIONS(5974),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5974),
    [anon_sym_LT_EQ_GT] = ACTIONS(5974),
    [anon_sym_EQ_TILDE] = ACTIONS(5974),
    [anon_sym_BANG_TILDE] = ACTIONS(5974),
    [anon_sym_LT_EQ] = ACTIONS(5976),
    [anon_sym_GT] = ACTIONS(5976),
    [anon_sym_GT_EQ] = ACTIONS(5974),
    [anon_sym_CARET] = ACTIONS(5976),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_SLASH] = ACTIONS(5976),
    [anon_sym_PERCENT] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5976),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [4350] = {
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym__heredoc_body_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__binary_minus2] = ACTIONS(5978),
    [sym__binary_star2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_RBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_RPAREN] = ACTIONS(5978),
    [anon_sym_DOT] = ACTIONS(5980),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_COMMA] = ACTIONS(5978),
    [anon_sym_PIPE] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5980),
    [anon_sym_AMP] = ACTIONS(5980),
    [anon_sym_EQ] = ACTIONS(5980),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_LT] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_rescue] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_in] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_RBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS_EQ] = ACTIONS(5978),
    [anon_sym_DASH_EQ] = ACTIONS(5978),
    [anon_sym_STAR_EQ] = ACTIONS(5978),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5978),
    [anon_sym_SLASH_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_PIPE_EQ] = ACTIONS(5978),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5978),
    [anon_sym_AMP_EQ] = ACTIONS(5978),
    [anon_sym_PERCENT_EQ] = ACTIONS(5978),
    [anon_sym_GT_GT_EQ] = ACTIONS(5978),
    [anon_sym_LT_LT_EQ] = ACTIONS(5978),
    [anon_sym_CARET_EQ] = ACTIONS(5978),
    [anon_sym_QMARK] = ACTIONS(5980),
    [anon_sym_COLON2] = ACTIONS(5980),
    [anon_sym_DOT_DOT] = ACTIONS(5980),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5978),
    [anon_sym_and] = ACTIONS(5980),
    [anon_sym_or] = ACTIONS(5980),
    [anon_sym_PIPE_PIPE] = ACTIONS(5980),
    [anon_sym_AMP_AMP] = ACTIONS(5980),
    [anon_sym_LT_LT] = ACTIONS(5980),
    [anon_sym_GT_GT] = ACTIONS(5980),
    [anon_sym_EQ_EQ] = ACTIONS(5980),
    [anon_sym_BANG_EQ] = ACTIONS(5978),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5978),
    [anon_sym_LT_EQ_GT] = ACTIONS(5978),
    [anon_sym_EQ_TILDE] = ACTIONS(5978),
    [anon_sym_BANG_TILDE] = ACTIONS(5978),
    [anon_sym_LT_EQ] = ACTIONS(5980),
    [anon_sym_GT] = ACTIONS(5980),
    [anon_sym_GT_EQ] = ACTIONS(5978),
    [anon_sym_CARET] = ACTIONS(5980),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_SLASH] = ACTIONS(5980),
    [anon_sym_PERCENT] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5980),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [4351] = {
    [sym_argument_list_with_parens] = STATE(7168),
    [sym__argument_list_with_parens] = STATE(4350),
    [sym_operator] = STATE(7168),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(6833),
    [anon_sym_STAR] = ACTIONS(6835),
    [anon_sym_STAR_STAR] = ACTIONS(6833),
    [anon_sym_AMP] = ACTIONS(6833),
    [anon_sym_LT] = ACTIONS(6835),
    [anon_sym_LPAREN2] = ACTIONS(6837),
    [anon_sym_DOT_DOT] = ACTIONS(6833),
    [anon_sym_LT_LT] = ACTIONS(6833),
    [anon_sym_GT_GT] = ACTIONS(6833),
    [anon_sym_EQ_EQ] = ACTIONS(6835),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6833),
    [anon_sym_LT_EQ_GT] = ACTIONS(6833),
    [anon_sym_EQ_TILDE] = ACTIONS(6833),
    [anon_sym_BANG_TILDE] = ACTIONS(6833),
    [anon_sym_LT_EQ] = ACTIONS(6835),
    [anon_sym_GT] = ACTIONS(6835),
    [anon_sym_GT_EQ] = ACTIONS(6833),
    [anon_sym_CARET] = ACTIONS(6833),
    [anon_sym_PLUS] = ACTIONS(6835),
    [anon_sym_SLASH] = ACTIONS(6833),
    [anon_sym_PERCENT] = ACTIONS(6833),
    [anon_sym_BANG] = ACTIONS(6835),
    [anon_sym_TILDE] = ACTIONS(6833),
    [sym_constant] = ACTIONS(10336),
    [sym_identifier] = ACTIONS(10336),
    [anon_sym_DASH] = ACTIONS(6835),
    [anon_sym_PLUS_AT] = ACTIONS(6833),
    [anon_sym_DASH_AT] = ACTIONS(6833),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(6835),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6833),
    [anon_sym_BQUOTE] = ACTIONS(6833),
    [sym_comment] = ACTIONS(87),
  },
  [4352] = {
    [sym__heredoc_body_start2] = ACTIONS(5984),
    [sym__binary_minus2] = ACTIONS(5984),
    [sym__binary_star2] = ACTIONS(5984),
    [anon_sym_LBRACE] = ACTIONS(5984),
    [anon_sym_RBRACE] = ACTIONS(5984),
    [anon_sym_RPAREN] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5986),
    [anon_sym_COMMA] = ACTIONS(5984),
    [anon_sym_PIPE] = ACTIONS(5986),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_STAR_STAR] = ACTIONS(5986),
    [anon_sym_AMP] = ACTIONS(5986),
    [anon_sym_EQ] = ACTIONS(5986),
    [anon_sym_LT] = ACTIONS(5986),
    [anon_sym_if] = ACTIONS(5984),
    [anon_sym_unless] = ACTIONS(5984),
    [anon_sym_while] = ACTIONS(5984),
    [anon_sym_until] = ACTIONS(5984),
    [anon_sym_rescue] = ACTIONS(5984),
    [anon_sym_in] = ACTIONS(5984),
    [anon_sym_do] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_RBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [anon_sym_PLUS_EQ] = ACTIONS(5984),
    [anon_sym_DASH_EQ] = ACTIONS(5984),
    [anon_sym_STAR_EQ] = ACTIONS(5984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5984),
    [anon_sym_SLASH_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_PIPE_EQ] = ACTIONS(5984),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5984),
    [anon_sym_AMP_EQ] = ACTIONS(5984),
    [anon_sym_PERCENT_EQ] = ACTIONS(5984),
    [anon_sym_GT_GT_EQ] = ACTIONS(5984),
    [anon_sym_LT_LT_EQ] = ACTIONS(5984),
    [anon_sym_CARET_EQ] = ACTIONS(5984),
    [anon_sym_QMARK] = ACTIONS(5984),
    [anon_sym_COLON2] = ACTIONS(5986),
    [anon_sym_DOT_DOT] = ACTIONS(5986),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5984),
    [anon_sym_and] = ACTIONS(5984),
    [anon_sym_or] = ACTIONS(5984),
    [anon_sym_PIPE_PIPE] = ACTIONS(5986),
    [anon_sym_AMP_AMP] = ACTIONS(5986),
    [anon_sym_LT_LT] = ACTIONS(5986),
    [anon_sym_GT_GT] = ACTIONS(5986),
    [anon_sym_EQ_EQ] = ACTIONS(5986),
    [anon_sym_BANG_EQ] = ACTIONS(5984),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5984),
    [anon_sym_LT_EQ_GT] = ACTIONS(5984),
    [anon_sym_EQ_TILDE] = ACTIONS(5984),
    [anon_sym_BANG_TILDE] = ACTIONS(5984),
    [anon_sym_LT_EQ] = ACTIONS(5986),
    [anon_sym_GT] = ACTIONS(5986),
    [anon_sym_GT_EQ] = ACTIONS(5984),
    [anon_sym_CARET] = ACTIONS(5986),
    [anon_sym_PLUS] = ACTIONS(5986),
    [anon_sym_SLASH] = ACTIONS(5986),
    [anon_sym_PERCENT] = ACTIONS(5986),
    [sym_comment] = ACTIONS(87),
  },
  [4353] = {
    [sym_heredoc_body] = STATE(7170),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(10338),
    [sym_comment] = ACTIONS(87),
  },
  [4354] = {
    [anon_sym_RBRACK] = ACTIONS(10338),
    [sym_comment] = ACTIONS(87),
  },
  [4355] = {
    [sym__simple_symbol2] = ACTIONS(5990),
    [sym__string_start2] = ACTIONS(5990),
    [sym__symbol_start2] = ACTIONS(5990),
    [sym__subshell_start2] = ACTIONS(5990),
    [sym__regex_start2] = ACTIONS(5990),
    [sym__string_array_start2] = ACTIONS(5990),
    [sym__symbol_array_start2] = ACTIONS(5990),
    [sym__heredoc_body_start2] = ACTIONS(5990),
    [sym_heredoc_beginning2] = ACTIONS(5990),
    [sym__block_ampersand2] = ACTIONS(5990),
    [sym__splat_star2] = ACTIONS(5990),
    [sym__unary_minus2] = ACTIONS(5990),
    [sym__binary_minus2] = ACTIONS(5990),
    [sym__binary_star2] = ACTIONS(5990),
    [sym__identifier_hash_key2] = ACTIONS(5990),
    [anon_sym_LBRACE] = ACTIONS(5990),
    [anon_sym_RBRACE] = ACTIONS(5990),
    [anon_sym_def] = ACTIONS(5992),
    [anon_sym_LPAREN] = ACTIONS(5992),
    [anon_sym_RPAREN] = ACTIONS(5990),
    [anon_sym_DOT] = ACTIONS(5992),
    [anon_sym_COLON_COLON] = ACTIONS(5992),
    [anon_sym_COMMA] = ACTIONS(5990),
    [anon_sym_PIPE] = ACTIONS(5992),
    [anon_sym_SEMI] = ACTIONS(5990),
    [anon_sym_STAR] = ACTIONS(5992),
    [anon_sym_STAR_STAR] = ACTIONS(5992),
    [anon_sym_AMP] = ACTIONS(5992),
    [anon_sym_EQ] = ACTIONS(5992),
    [anon_sym_class] = ACTIONS(5992),
    [anon_sym_LT] = ACTIONS(5992),
    [anon_sym_module] = ACTIONS(5992),
    [anon_sym_return] = ACTIONS(5992),
    [anon_sym_yield] = ACTIONS(5992),
    [anon_sym_break] = ACTIONS(5992),
    [anon_sym_next] = ACTIONS(5992),
    [sym_redo] = ACTIONS(5992),
    [sym_retry] = ACTIONS(5992),
    [anon_sym_if] = ACTIONS(5992),
    [anon_sym_unless] = ACTIONS(5992),
    [anon_sym_while] = ACTIONS(5992),
    [anon_sym_until] = ACTIONS(5992),
    [anon_sym_rescue] = ACTIONS(5992),
    [anon_sym_for] = ACTIONS(5992),
    [anon_sym_in] = ACTIONS(5992),
    [anon_sym_do] = ACTIONS(5992),
    [anon_sym_case] = ACTIONS(5992),
    [anon_sym_begin] = ACTIONS(5992),
    [anon_sym_LBRACK] = ACTIONS(5990),
    [anon_sym_RBRACK] = ACTIONS(5990),
    [anon_sym_COLON_COLON2] = ACTIONS(5990),
    [anon_sym_AMP_DOT] = ACTIONS(5990),
    [anon_sym_LPAREN2] = ACTIONS(5990),
    [anon_sym_PLUS_EQ] = ACTIONS(5990),
    [anon_sym_DASH_EQ] = ACTIONS(5990),
    [anon_sym_STAR_EQ] = ACTIONS(5990),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5990),
    [anon_sym_SLASH_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_PIPE_EQ] = ACTIONS(5990),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5990),
    [anon_sym_AMP_EQ] = ACTIONS(5990),
    [anon_sym_PERCENT_EQ] = ACTIONS(5990),
    [anon_sym_GT_GT_EQ] = ACTIONS(5990),
    [anon_sym_LT_LT_EQ] = ACTIONS(5990),
    [anon_sym_CARET_EQ] = ACTIONS(5990),
    [anon_sym_QMARK] = ACTIONS(5992),
    [anon_sym_COLON2] = ACTIONS(5992),
    [anon_sym_DOT_DOT] = ACTIONS(5992),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5990),
    [anon_sym_and] = ACTIONS(5992),
    [anon_sym_or] = ACTIONS(5992),
    [anon_sym_PIPE_PIPE] = ACTIONS(5992),
    [anon_sym_AMP_AMP] = ACTIONS(5992),
    [anon_sym_LT_LT] = ACTIONS(5992),
    [anon_sym_GT_GT] = ACTIONS(5992),
    [anon_sym_EQ_EQ] = ACTIONS(5992),
    [anon_sym_BANG_EQ] = ACTIONS(5990),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5990),
    [anon_sym_LT_EQ_GT] = ACTIONS(5990),
    [anon_sym_EQ_TILDE] = ACTIONS(5990),
    [anon_sym_BANG_TILDE] = ACTIONS(5990),
    [anon_sym_LT_EQ] = ACTIONS(5992),
    [anon_sym_GT] = ACTIONS(5992),
    [anon_sym_GT_EQ] = ACTIONS(5990),
    [anon_sym_CARET] = ACTIONS(5992),
    [anon_sym_PLUS] = ACTIONS(5992),
    [anon_sym_SLASH] = ACTIONS(5992),
    [anon_sym_PERCENT] = ACTIONS(5992),
    [anon_sym_defined_QMARK] = ACTIONS(5990),
    [anon_sym_not] = ACTIONS(5992),
    [anon_sym_BANG] = ACTIONS(5992),
    [anon_sym_TILDE] = ACTIONS(5990),
    [sym_constant] = ACTIONS(5992),
    [sym_identifier] = ACTIONS(5992),
    [sym_instance_variable] = ACTIONS(5990),
    [sym_class_variable] = ACTIONS(5990),
    [sym_global_variable] = ACTIONS(5990),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5992),
    [sym_float] = ACTIONS(5992),
    [sym_complex] = ACTIONS(5990),
    [sym_super] = ACTIONS(5992),
    [anon_sym_true] = ACTIONS(5992),
    [anon_sym_TRUE] = ACTIONS(5992),
    [anon_sym_false] = ACTIONS(5992),
    [anon_sym_FALSE] = ACTIONS(5992),
    [sym_self] = ACTIONS(5992),
    [anon_sym_nil] = ACTIONS(5992),
    [anon_sym_NIL] = ACTIONS(5992),
    [sym_character] = ACTIONS(5990),
    [anon_sym_LBRACK2] = ACTIONS(5992),
    [anon_sym_DASH_GT] = ACTIONS(5990),
  },
  [4356] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7171),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(7171),
    [sym_operator_assignment] = STATE(7171),
    [sym_conditional] = STATE(7171),
    [sym_range] = STATE(7171),
    [sym_binary] = STATE(7171),
    [sym_unary] = STATE(7171),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4357] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_RBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4358] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_RBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4359] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_RBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4360] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_RBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4361] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7172),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(7172),
    [sym_operator_assignment] = STATE(7172),
    [sym_conditional] = STATE(7172),
    [sym_range] = STATE(7172),
    [sym_binary] = STATE(7172),
    [sym_unary] = STATE(7172),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4362] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7173),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(7173),
    [sym_operator_assignment] = STATE(7173),
    [sym_conditional] = STATE(7173),
    [sym_range] = STATE(7173),
    [sym_binary] = STATE(7173),
    [sym_unary] = STATE(7173),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4363] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4364] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [4365] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(1918),
    [sym__argument] = STATE(1919),
    [sym_splat_argument] = STATE(1919),
    [sym_hash_splat_argument] = STATE(1919),
    [sym_block_argument] = STATE(1919),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(1919),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_RBRACE] = ACTIONS(749),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3270),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4366] = {
    [anon_sym_EQ] = ACTIONS(10368),
    [sym_comment] = ACTIONS(87),
  },
  [4367] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10370),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10372),
    [anon_sym_DASH_EQ] = ACTIONS(10372),
    [anon_sym_STAR_EQ] = ACTIONS(10372),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10372),
    [anon_sym_SLASH_EQ] = ACTIONS(10372),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10372),
    [anon_sym_PIPE_EQ] = ACTIONS(10372),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10372),
    [anon_sym_AMP_EQ] = ACTIONS(10372),
    [anon_sym_PERCENT_EQ] = ACTIONS(10372),
    [anon_sym_GT_GT_EQ] = ACTIONS(10372),
    [anon_sym_LT_LT_EQ] = ACTIONS(10372),
    [anon_sym_CARET_EQ] = ACTIONS(10372),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4368] = {
    [sym_string] = STATE(7188),
    [aux_sym_chained_string_repeat1] = STATE(7188),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4369] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [4370] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [4371] = {
    [sym_string] = STATE(4403),
    [aux_sym_chained_string_repeat1] = STATE(4403),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4372] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7189),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(7189),
    [sym_operator_assignment] = STATE(7189),
    [sym_conditional] = STATE(7189),
    [sym_range] = STATE(7189),
    [sym_binary] = STATE(7189),
    [sym_unary] = STATE(7189),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4373] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [4374] = {
    [anon_sym_RBRACE] = ACTIONS(10374),
    [sym_comment] = ACTIONS(87),
  },
  [4375] = {
    [sym__statements] = STATE(7191),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10374),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4376] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [4377] = {
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_STAR_STAR] = ACTIONS(5788),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_if] = ACTIONS(5786),
    [anon_sym_unless] = ACTIONS(5786),
    [anon_sym_while] = ACTIONS(5786),
    [anon_sym_until] = ACTIONS(5786),
    [anon_sym_rescue] = ACTIONS(5786),
    [anon_sym_in] = ACTIONS(5786),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_RBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_PLUS_EQ] = ACTIONS(5786),
    [anon_sym_DASH_EQ] = ACTIONS(5786),
    [anon_sym_STAR_EQ] = ACTIONS(5786),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5786),
    [anon_sym_SLASH_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_PIPE_EQ] = ACTIONS(5786),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5786),
    [anon_sym_AMP_EQ] = ACTIONS(5786),
    [anon_sym_PERCENT_EQ] = ACTIONS(5786),
    [anon_sym_GT_GT_EQ] = ACTIONS(5786),
    [anon_sym_LT_LT_EQ] = ACTIONS(5786),
    [anon_sym_CARET_EQ] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_COLON2] = ACTIONS(5788),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5788),
    [anon_sym_AMP_AMP] = ACTIONS(5788),
    [anon_sym_LT_LT] = ACTIONS(5788),
    [anon_sym_GT_GT] = ACTIONS(5788),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5788),
    [anon_sym_PLUS] = ACTIONS(5788),
    [anon_sym_SLASH] = ACTIONS(5788),
    [anon_sym_PERCENT] = ACTIONS(5788),
    [sym_comment] = ACTIONS(87),
  },
  [4378] = {
    [anon_sym_end] = ACTIONS(10376),
    [sym_comment] = ACTIONS(87),
  },
  [4379] = {
    [sym__statements] = STATE(7193),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7194),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7194),
    [sym__line_break2] = ACTIONS(10378),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10380),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4380] = {
    [sym__statements] = STATE(7193),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(7195),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10380),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4381] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [4382] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [4383] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7196),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7196),
    [sym_operator_assignment] = STATE(7196),
    [sym_conditional] = STATE(7196),
    [sym_range] = STATE(7196),
    [sym_binary] = STATE(7196),
    [sym_unary] = STATE(7196),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4384] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7197),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7197),
    [sym_operator_assignment] = STATE(7197),
    [sym_conditional] = STATE(7197),
    [sym_range] = STATE(7197),
    [sym_binary] = STATE(7197),
    [sym_unary] = STATE(7197),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4385] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7198),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7198),
    [sym_operator_assignment] = STATE(7198),
    [sym_conditional] = STATE(7198),
    [sym_range] = STATE(7198),
    [sym_binary] = STATE(7198),
    [sym_unary] = STATE(7198),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4386] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7199),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7199),
    [sym_operator_assignment] = STATE(7199),
    [sym_conditional] = STATE(7199),
    [sym_range] = STATE(7199),
    [sym_binary] = STATE(7199),
    [sym_unary] = STATE(7199),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4387] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7200),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7200),
    [sym_operator_assignment] = STATE(7200),
    [sym_conditional] = STATE(7200),
    [sym_range] = STATE(7200),
    [sym_binary] = STATE(7200),
    [sym_unary] = STATE(7200),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4388] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7201),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7201),
    [sym_operator_assignment] = STATE(7201),
    [sym_conditional] = STATE(7201),
    [sym_range] = STATE(7201),
    [sym_binary] = STATE(7201),
    [sym_unary] = STATE(7201),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4389] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7202),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(7202),
    [sym_operator_assignment] = STATE(7202),
    [sym_conditional] = STATE(7202),
    [sym_range] = STATE(7202),
    [sym_binary] = STATE(7202),
    [sym_unary] = STATE(7202),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4390] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7203),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7203),
    [sym_operator_assignment] = STATE(7203),
    [sym_conditional] = STATE(7203),
    [sym_range] = STATE(7203),
    [sym_binary] = STATE(7203),
    [sym_unary] = STATE(7203),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4391] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7204),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7204),
    [sym_operator_assignment] = STATE(7204),
    [sym_conditional] = STATE(7204),
    [sym_range] = STATE(7204),
    [sym_binary] = STATE(7204),
    [sym_unary] = STATE(7204),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4392] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7205),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7205),
    [sym_operator_assignment] = STATE(7205),
    [sym_conditional] = STATE(7205),
    [sym_range] = STATE(7205),
    [sym_binary] = STATE(7205),
    [sym_unary] = STATE(7205),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4393] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7206),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7206),
    [sym_operator_assignment] = STATE(7206),
    [sym_conditional] = STATE(7206),
    [sym_range] = STATE(7206),
    [sym_binary] = STATE(7206),
    [sym_unary] = STATE(7206),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4394] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7207),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7207),
    [sym_operator_assignment] = STATE(7207),
    [sym_conditional] = STATE(7207),
    [sym_range] = STATE(7207),
    [sym_binary] = STATE(7207),
    [sym_unary] = STATE(7207),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4395] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7208),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7208),
    [sym_operator_assignment] = STATE(7208),
    [sym_conditional] = STATE(7208),
    [sym_range] = STATE(7208),
    [sym_binary] = STATE(7208),
    [sym_unary] = STATE(7208),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4396] = {
    [sym__statements] = STATE(4374),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(4375),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10382),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4397] = {
    [sym__heredoc_body_start2] = ACTIONS(6196),
    [sym__binary_minus2] = ACTIONS(6196),
    [sym__binary_star2] = ACTIONS(6196),
    [anon_sym_LBRACE] = ACTIONS(6196),
    [anon_sym_RBRACE] = ACTIONS(6196),
    [anon_sym_RPAREN] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6198),
    [anon_sym_COMMA] = ACTIONS(6196),
    [anon_sym_PIPE] = ACTIONS(6198),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_STAR_STAR] = ACTIONS(6198),
    [anon_sym_AMP] = ACTIONS(6198),
    [anon_sym_EQ] = ACTIONS(6198),
    [anon_sym_LT] = ACTIONS(6198),
    [anon_sym_if] = ACTIONS(6196),
    [anon_sym_unless] = ACTIONS(6196),
    [anon_sym_while] = ACTIONS(6196),
    [anon_sym_until] = ACTIONS(6196),
    [anon_sym_rescue] = ACTIONS(6196),
    [anon_sym_in] = ACTIONS(6196),
    [anon_sym_do] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_RBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [anon_sym_PLUS_EQ] = ACTIONS(6196),
    [anon_sym_DASH_EQ] = ACTIONS(6196),
    [anon_sym_STAR_EQ] = ACTIONS(6196),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6196),
    [anon_sym_SLASH_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_PIPE_EQ] = ACTIONS(6196),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6196),
    [anon_sym_AMP_EQ] = ACTIONS(6196),
    [anon_sym_PERCENT_EQ] = ACTIONS(6196),
    [anon_sym_GT_GT_EQ] = ACTIONS(6196),
    [anon_sym_LT_LT_EQ] = ACTIONS(6196),
    [anon_sym_CARET_EQ] = ACTIONS(6196),
    [anon_sym_QMARK] = ACTIONS(6196),
    [anon_sym_COLON2] = ACTIONS(6198),
    [anon_sym_DOT_DOT] = ACTIONS(6198),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6196),
    [anon_sym_and] = ACTIONS(6196),
    [anon_sym_or] = ACTIONS(6196),
    [anon_sym_PIPE_PIPE] = ACTIONS(6198),
    [anon_sym_AMP_AMP] = ACTIONS(6198),
    [anon_sym_LT_LT] = ACTIONS(6198),
    [anon_sym_GT_GT] = ACTIONS(6198),
    [anon_sym_EQ_EQ] = ACTIONS(6198),
    [anon_sym_BANG_EQ] = ACTIONS(6196),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6196),
    [anon_sym_LT_EQ_GT] = ACTIONS(6196),
    [anon_sym_EQ_TILDE] = ACTIONS(6196),
    [anon_sym_BANG_TILDE] = ACTIONS(6196),
    [anon_sym_LT_EQ] = ACTIONS(6198),
    [anon_sym_GT] = ACTIONS(6198),
    [anon_sym_GT_EQ] = ACTIONS(6196),
    [anon_sym_CARET] = ACTIONS(6198),
    [anon_sym_PLUS] = ACTIONS(6198),
    [anon_sym_SLASH] = ACTIONS(6198),
    [anon_sym_PERCENT] = ACTIONS(6198),
    [sym_comment] = ACTIONS(87),
  },
  [4398] = {
    [sym_heredoc_body] = STATE(7210),
    [aux_sym_call_repeat1] = STATE(7210),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4399] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(7211),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10384),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4400] = {
    [sym_heredoc_body] = STATE(7212),
    [aux_sym_call_repeat1] = STATE(7212),
    [aux_sym_argument_list_repeat1] = STATE(7213),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6913),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4401] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7214),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_splat_argument] = STATE(7215),
    [sym_assignment] = STATE(7214),
    [sym_operator_assignment] = STATE(7214),
    [sym_conditional] = STATE(7214),
    [sym_range] = STATE(7214),
    [sym_binary] = STATE(7214),
    [sym_unary] = STATE(7214),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(7215),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4402] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7216),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(7216),
    [sym_operator_assignment] = STATE(7216),
    [sym_conditional] = STATE(7216),
    [sym_range] = STATE(7216),
    [sym_binary] = STATE(7216),
    [sym_unary] = STATE(7216),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4403] = {
    [sym_string] = STATE(7217),
    [aux_sym_chained_string_repeat1] = STATE(7217),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [4404] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7218),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(7218),
    [sym_operator_assignment] = STATE(7218),
    [sym_conditional] = STATE(7218),
    [sym_range] = STATE(7218),
    [sym_binary] = STATE(7218),
    [sym_unary] = STATE(7218),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4405] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4406] = {
    [aux_sym_exceptions_repeat1] = STATE(7220),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4407] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [4408] = {
    [sym_string] = STATE(4408),
    [aux_sym_chained_string_repeat1] = STATE(4408),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4409] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(7221),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10386),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4410] = {
    [sym__statements] = STATE(598),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(599),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(600),
    [sym_rescue] = STATE(601),
    [sym__body_statement] = STATE(7222),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10388),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4411] = {
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7730),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_EQ_GT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_COLON2] = ACTIONS(7732),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7730),
    [anon_sym_AMP_AMP] = ACTIONS(7730),
    [anon_sym_LT_LT] = ACTIONS(7730),
    [anon_sym_GT_GT] = ACTIONS(7730),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7730),
    [anon_sym_PLUS] = ACTIONS(7730),
    [anon_sym_SLASH] = ACTIONS(7730),
    [anon_sym_PERCENT] = ACTIONS(7730),
    [sym_comment] = ACTIONS(87),
  },
  [4412] = {
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_COLON2] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7788),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [sym_comment] = ACTIONS(87),
  },
  [4413] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4414] = {
    [sym_heredoc_body] = STATE(7223),
    [aux_sym_call_repeat1] = STATE(7223),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4415] = {
    [sym_heredoc_body] = STATE(7224),
    [aux_sym_call_repeat1] = STATE(7224),
    [aux_sym_argument_list_repeat1] = STATE(4437),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4416] = {
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7850),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_in] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7850),
    [anon_sym_AMP_AMP] = ACTIONS(7850),
    [anon_sym_LT_LT] = ACTIONS(7850),
    [anon_sym_GT_GT] = ACTIONS(7850),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7850),
    [anon_sym_PLUS] = ACTIONS(7850),
    [anon_sym_SLASH] = ACTIONS(7850),
    [anon_sym_PERCENT] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
  },
  [4417] = {
    [anon_sym_RPAREN] = ACTIONS(10390),
    [sym_comment] = ACTIONS(87),
  },
  [4418] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4419] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4420] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4421] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4422] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4423] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4424] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4425] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10392),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4426] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4427] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4428] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4429] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4430] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4431] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_EQ_GT] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_RBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_COLON2] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [4432] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10394),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [4433] = {
    [sym_heredoc_body] = STATE(4433),
    [aux_sym_call_repeat1] = STATE(4433),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [4434] = {
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [4435] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(580),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(580),
    [sym_operator_assignment] = STATE(580),
    [sym_conditional] = STATE(580),
    [sym_range] = STATE(580),
    [sym_binary] = STATE(580),
    [sym_unary] = STATE(580),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(587),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1049),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1055),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(6939),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1079),
    [sym_identifier] = ACTIONS(1079),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4436] = {
    [sym_heredoc_body] = STATE(4433),
    [aux_sym_call_repeat1] = STATE(4433),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [4437] = {
    [aux_sym_argument_list_repeat1] = STATE(4437),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10399),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [4438] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4439] = {
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4440] = {
    [aux_sym_exceptions_repeat1] = STATE(7230),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4441] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4442] = {
    [sym_string] = STATE(4442),
    [aux_sym_chained_string_repeat1] = STATE(4442),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4443] = {
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7970),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_EQ_GT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_COLON2] = ACTIONS(7972),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7970),
    [anon_sym_AMP_AMP] = ACTIONS(7970),
    [anon_sym_LT_LT] = ACTIONS(7970),
    [anon_sym_GT_GT] = ACTIONS(7970),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7970),
    [anon_sym_PLUS] = ACTIONS(7970),
    [anon_sym_SLASH] = ACTIONS(7970),
    [anon_sym_PERCENT] = ACTIONS(7970),
    [sym_comment] = ACTIONS(87),
  },
  [4444] = {
    [sym_elsif] = STATE(7232),
    [sym_else] = STATE(7232),
    [sym__if_tail] = STATE(7232),
    [anon_sym_end] = ACTIONS(10402),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [4445] = {
    [anon_sym_end] = ACTIONS(10402),
    [sym_comment] = ACTIONS(87),
  },
  [4446] = {
    [sym__statements] = STATE(7233),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(7232),
    [sym_else] = STATE(7232),
    [sym__if_tail] = STATE(7232),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10404),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4447] = {
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8176),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_COLON2] = ACTIONS(8178),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8176),
    [anon_sym_AMP_AMP] = ACTIONS(8176),
    [anon_sym_LT_LT] = ACTIONS(8176),
    [anon_sym_GT_GT] = ACTIONS(8176),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8176),
    [anon_sym_PLUS] = ACTIONS(8176),
    [anon_sym_SLASH] = ACTIONS(8176),
    [anon_sym_PERCENT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(87),
  },
  [4448] = {
    [sym_else] = STATE(7235),
    [anon_sym_end] = ACTIONS(10406),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [4449] = {
    [anon_sym_end] = ACTIONS(10406),
    [sym_comment] = ACTIONS(87),
  },
  [4450] = {
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8352),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_EQ_GT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_COLON2] = ACTIONS(8354),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8352),
    [anon_sym_AMP_AMP] = ACTIONS(8352),
    [anon_sym_LT_LT] = ACTIONS(8352),
    [anon_sym_GT_GT] = ACTIONS(8352),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8352),
    [anon_sym_PLUS] = ACTIONS(8352),
    [anon_sym_SLASH] = ACTIONS(8352),
    [anon_sym_PERCENT] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [4451] = {
    [anon_sym_end] = ACTIONS(10408),
    [sym_comment] = ACTIONS(87),
  },
  [4452] = {
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8432),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_EQ_GT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_COLON2] = ACTIONS(8434),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8432),
    [anon_sym_AMP_AMP] = ACTIONS(8432),
    [anon_sym_LT_LT] = ACTIONS(8432),
    [anon_sym_GT_GT] = ACTIONS(8432),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8432),
    [anon_sym_PLUS] = ACTIONS(8432),
    [anon_sym_SLASH] = ACTIONS(8432),
    [anon_sym_PERCENT] = ACTIONS(8432),
    [sym_comment] = ACTIONS(87),
  },
  [4453] = {
    [anon_sym_end] = ACTIONS(10410),
    [sym_comment] = ACTIONS(87),
  },
  [4454] = {
    [sym__statements] = STATE(7239),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10412),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4455] = {
    [anon_sym_end] = ACTIONS(10414),
    [sym_comment] = ACTIONS(87),
  },
  [4456] = {
    [sym_when] = STATE(7241),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [4457] = {
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8696),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_EQ_GT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_COLON2] = ACTIONS(8698),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8696),
    [anon_sym_AMP_AMP] = ACTIONS(8696),
    [anon_sym_LT_LT] = ACTIONS(8696),
    [anon_sym_GT_GT] = ACTIONS(8696),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8696),
    [anon_sym_PLUS] = ACTIONS(8696),
    [anon_sym_SLASH] = ACTIONS(8696),
    [anon_sym_PERCENT] = ACTIONS(8696),
    [sym_comment] = ACTIONS(87),
  },
  [4458] = {
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9229),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_EQ_GT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_COLON2] = ACTIONS(9231),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9229),
    [anon_sym_AMP_AMP] = ACTIONS(9229),
    [anon_sym_LT_LT] = ACTIONS(9229),
    [anon_sym_GT_GT] = ACTIONS(9229),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9229),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9229),
    [anon_sym_PERCENT] = ACTIONS(9229),
    [sym_comment] = ACTIONS(87),
  },
  [4459] = {
    [anon_sym_end] = ACTIONS(10416),
    [sym_comment] = ACTIONS(87),
  },
  [4460] = {
    [sym_ensure] = STATE(7243),
    [anon_sym_end] = ACTIONS(10416),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [4461] = {
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9457),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_EQ_GT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_COLON2] = ACTIONS(9459),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9457),
    [anon_sym_AMP_AMP] = ACTIONS(9457),
    [anon_sym_LT_LT] = ACTIONS(9457),
    [anon_sym_GT_GT] = ACTIONS(9457),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9457),
    [anon_sym_PLUS] = ACTIONS(9457),
    [anon_sym_SLASH] = ACTIONS(9457),
    [anon_sym_PERCENT] = ACTIONS(9457),
    [sym_comment] = ACTIONS(87),
  },
  [4462] = {
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_COLON2] = ACTIONS(9488),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9486),
    [anon_sym_AMP_AMP] = ACTIONS(9486),
    [anon_sym_LT_LT] = ACTIONS(9486),
    [anon_sym_GT_GT] = ACTIONS(9486),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9486),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_SLASH] = ACTIONS(9486),
    [anon_sym_PERCENT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [4463] = {
    [anon_sym_RBRACE] = ACTIONS(10418),
    [sym_comment] = ACTIONS(87),
  },
  [4464] = {
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9506),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_COLON2] = ACTIONS(9508),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9506),
    [anon_sym_AMP_AMP] = ACTIONS(9506),
    [anon_sym_LT_LT] = ACTIONS(9506),
    [anon_sym_GT_GT] = ACTIONS(9506),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9506),
    [anon_sym_PLUS] = ACTIONS(9506),
    [anon_sym_SLASH] = ACTIONS(9506),
    [anon_sym_PERCENT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [4465] = {
    [anon_sym_end] = ACTIONS(10420),
    [sym_comment] = ACTIONS(87),
  },
  [4466] = {
    [sym__statements] = STATE(7246),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10422),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4467] = {
    [sym__statements] = STATE(7246),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7247),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7247),
    [sym__line_break2] = ACTIONS(10424),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10422),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4468] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7248),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(122),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(122),
    [sym_assignment] = STATE(7248),
    [sym_operator_assignment] = STATE(7248),
    [sym_conditional] = STATE(7248),
    [sym_range] = STATE(7248),
    [sym_binary] = STATE(7248),
    [sym_unary] = STATE(7248),
    [sym_left_assignment_list] = STATE(121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(122),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(122),
    [sym_false] = STATE(122),
    [sym_nil] = STATE(122),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(531),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(155),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(177),
    [anon_sym_yield] = ACTIONS(179),
    [anon_sym_break] = ACTIONS(181),
    [anon_sym_next] = ACTIONS(183),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(201),
    [anon_sym_defined_QMARK] = ACTIONS(203),
    [anon_sym_not] = ACTIONS(205),
    [anon_sym_BANG] = ACTIONS(207),
    [anon_sym_TILDE] = ACTIONS(207),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4469] = {
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [4470] = {
    [sym_heredoc_body] = STATE(7250),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10426),
    [sym_comment] = ACTIONS(87),
  },
  [4471] = {
    [anon_sym_RPAREN] = ACTIONS(10426),
    [sym_comment] = ACTIONS(87),
  },
  [4472] = {
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_EQ_GT] = ACTIONS(9751),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [4473] = {
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_EQ_GT] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [4474] = {
    [anon_sym_RBRACK] = ACTIONS(10428),
    [sym_comment] = ACTIONS(87),
  },
  [4475] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_COLON] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(87),
  },
  [4476] = {
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [sym_comment] = ACTIONS(87),
  },
  [4477] = {
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [sym_comment] = ACTIONS(87),
  },
  [4478] = {
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [sym_comment] = ACTIONS(87),
  },
  [4479] = {
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_RBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [sym_comment] = ACTIONS(87),
  },
  [4480] = {
    [sym__string_end2] = ACTIONS(10430),
    [sym_comment] = ACTIONS(87),
  },
  [4481] = {
    [aux_sym_string_array_repeat1] = STATE(7255),
    [sym__string_end2] = ACTIONS(10432),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10434),
  },
  [4482] = {
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_EQ_GT] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [sym_comment] = ACTIONS(87),
  },
  [4483] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10436),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4484] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(10436),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10438),
  },
  [4485] = {
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_EQ_GT] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_RBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_COLON2] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(87),
  },
  [4486] = {
    [sym__string_end2] = ACTIONS(10440),
    [sym_comment] = ACTIONS(87),
  },
  [4487] = {
    [aux_sym_symbol_array_repeat1] = STATE(7261),
    [sym__string_end2] = ACTIONS(10442),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10444),
  },
  [4488] = {
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_EQ_GT] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON2] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [sym_comment] = ACTIONS(87),
  },
  [4489] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10446),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4490] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(10446),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10448),
  },
  [4491] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_in] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_RBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_COLON2] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [sym_comment] = ACTIONS(87),
  },
  [4492] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4493] = {
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [4494] = {
    [anon_sym_RBRACE] = ACTIONS(10450),
    [sym_comment] = ACTIONS(87),
  },
  [4495] = {
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_in] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_EQ_GT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_COLON2] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_GT_GT] = ACTIONS(3506),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [sym_comment] = ACTIONS(87),
  },
  [4496] = {
    [anon_sym_RBRACE] = ACTIONS(10452),
    [sym_comment] = ACTIONS(87),
  },
  [4497] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(10454),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4498] = {
    [sym__method_rest] = STATE(7267),
    [sym_operator] = STATE(2039),
    [sym__method_name] = STATE(2039),
    [sym_setter] = STATE(2039),
    [sym_symbol] = STATE(2039),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10456),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10456),
    [sym_class_variable] = ACTIONS(10456),
    [sym_global_variable] = ACTIONS(10456),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4499] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(7268),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10458),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4500] = {
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_EQ_GT] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_PLUS_EQ] = ACTIONS(3744),
    [anon_sym_DASH_EQ] = ACTIONS(3744),
    [anon_sym_STAR_EQ] = ACTIONS(3744),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3744),
    [anon_sym_SLASH_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3744),
    [anon_sym_AMP_EQ] = ACTIONS(3744),
    [anon_sym_PERCENT_EQ] = ACTIONS(3744),
    [anon_sym_GT_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_LT_EQ] = ACTIONS(3744),
    [anon_sym_CARET_EQ] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_COLON2] = ACTIONS(3746),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(87),
  },
  [4501] = {
    [sym_heredoc_body] = STATE(7269),
    [sym__terminator] = STATE(7269),
    [sym__line_break2] = ACTIONS(10460),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(10460),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [4502] = {
    [sym_heredoc_body] = STATE(7270),
    [sym__terminator] = STATE(7270),
    [sym__line_break2] = ACTIONS(10462),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10462),
    [sym_comment] = ACTIONS(87),
  },
  [4503] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(7271),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10464),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4504] = {
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_in] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_EQ_GT] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON2] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [sym_comment] = ACTIONS(87),
  },
  [4505] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(7272),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10466),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4506] = {
    [sym__statements] = STATE(7274),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(7275),
    [sym_else] = STATE(7275),
    [sym__if_tail] = STATE(7275),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7276),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7276),
    [sym__line_break2] = ACTIONS(10468),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10470),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4507] = {
    [sym__statements] = STATE(7278),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(7279),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10472),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4508] = {
    [sym__statements] = STATE(7281),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10474),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4509] = {
    [sym__statements] = STATE(7283),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10476),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4510] = {
    [sym__do] = STATE(7284),
    [sym_heredoc_body] = STATE(7284),
    [sym__terminator] = STATE(7284),
    [sym__line_break2] = ACTIONS(10478),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(10478),
    [anon_sym_do] = ACTIONS(10478),
    [sym_comment] = ACTIONS(87),
  },
  [4511] = {
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [4512] = {
    [anon_sym_end] = ACTIONS(10480),
    [sym_comment] = ACTIONS(87),
  },
  [4513] = {
    [sym__statements] = STATE(7286),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10482),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4514] = {
    [sym__statements] = STATE(7286),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7287),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7287),
    [sym__line_break2] = ACTIONS(10484),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10482),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4515] = {
    [sym_when] = STATE(7288),
    [aux_sym_case_repeat1] = STATE(7289),
    [anon_sym_SEMI] = ACTIONS(10486),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [4516] = {
    [anon_sym_end] = ACTIONS(10488),
    [sym_comment] = ACTIONS(87),
  },
  [4517] = {
    [sym_when] = STATE(7288),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [4518] = {
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5412),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_EQ_GT] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_RBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_PLUS_EQ] = ACTIONS(5410),
    [anon_sym_DASH_EQ] = ACTIONS(5410),
    [anon_sym_STAR_EQ] = ACTIONS(5410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5410),
    [anon_sym_SLASH_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5410),
    [anon_sym_AMP_EQ] = ACTIONS(5410),
    [anon_sym_PERCENT_EQ] = ACTIONS(5410),
    [anon_sym_GT_GT_EQ] = ACTIONS(5410),
    [anon_sym_LT_LT_EQ] = ACTIONS(5410),
    [anon_sym_CARET_EQ] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_COLON2] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5412),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [sym_comment] = ACTIONS(87),
  },
  [4519] = {
    [sym_ensure] = STATE(7292),
    [anon_sym_end] = ACTIONS(10490),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [4520] = {
    [anon_sym_end] = ACTIONS(10490),
    [sym_comment] = ACTIONS(87),
  },
  [4521] = {
    [sym_else] = STATE(7293),
    [sym_ensure] = STATE(7292),
    [anon_sym_end] = ACTIONS(10490),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [4522] = {
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_EQ_GT] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_PLUS_EQ] = ACTIONS(5498),
    [anon_sym_DASH_EQ] = ACTIONS(5498),
    [anon_sym_STAR_EQ] = ACTIONS(5498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5498),
    [anon_sym_SLASH_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5498),
    [anon_sym_AMP_EQ] = ACTIONS(5498),
    [anon_sym_PERCENT_EQ] = ACTIONS(5498),
    [anon_sym_GT_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_LT_EQ] = ACTIONS(5498),
    [anon_sym_CARET_EQ] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON2] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(87),
  },
  [4523] = {
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_in] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [sym_comment] = ACTIONS(87),
  },
  [4524] = {
    [anon_sym_RPAREN] = ACTIONS(10492),
    [sym_comment] = ACTIONS(87),
  },
  [4525] = {
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_in] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_EQ_GT] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_COLON2] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_AMP_AMP] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [sym_comment] = ACTIONS(87),
  },
  [4526] = {
    [anon_sym_RBRACK] = ACTIONS(10494),
    [sym_comment] = ACTIONS(87),
  },
  [4527] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [4528] = {
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_in] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_EQ_GT] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [sym_comment] = ACTIONS(87),
  },
  [4529] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4530] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [4531] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4532] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [4533] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4534] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4535] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4536] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10496),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4537] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4538] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4539] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4540] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4541] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4542] = {
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [4543] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_EQ_GT] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_RBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_PLUS_EQ] = ACTIONS(3158),
    [anon_sym_DASH_EQ] = ACTIONS(3158),
    [anon_sym_STAR_EQ] = ACTIONS(3158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3158),
    [anon_sym_SLASH_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3158),
    [anon_sym_AMP_EQ] = ACTIONS(3158),
    [anon_sym_PERCENT_EQ] = ACTIONS(3158),
    [anon_sym_GT_GT_EQ] = ACTIONS(3158),
    [anon_sym_LT_LT_EQ] = ACTIONS(3158),
    [anon_sym_CARET_EQ] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_COLON2] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4982),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
  },
  [4544] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10498),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [4545] = {
    [sym_heredoc_body] = STATE(4545),
    [aux_sym_call_repeat1] = STATE(4545),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [4546] = {
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [4547] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(668),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(668),
    [sym_operator_assignment] = STATE(668),
    [sym_conditional] = STATE(668),
    [sym_range] = STATE(668),
    [sym_binary] = STATE(668),
    [sym_unary] = STATE(668),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(677),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(1165),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__identifier_hash_key2] = ACTIONS(1171),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7055),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1219),
    [sym_identifier] = ACTIONS(1219),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4548] = {
    [sym_heredoc_body] = STATE(4545),
    [aux_sym_call_repeat1] = STATE(4545),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [4549] = {
    [aux_sym_argument_list_repeat1] = STATE(4549),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10503),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [4550] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4551] = {
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [4552] = {
    [aux_sym_exceptions_repeat1] = STATE(7300),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [4553] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4554] = {
    [sym_string] = STATE(4554),
    [aux_sym_chained_string_repeat1] = STATE(4554),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [4555] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [4556] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4557] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4558] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [4559] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7301),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7301),
    [sym_operator_assignment] = STATE(7301),
    [sym_conditional] = STATE(7301),
    [sym_range] = STATE(7301),
    [sym_binary] = STATE(7301),
    [sym_unary] = STATE(7301),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4560] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7302),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7302),
    [sym_operator_assignment] = STATE(7302),
    [sym_conditional] = STATE(7302),
    [sym_range] = STATE(7302),
    [sym_binary] = STATE(7302),
    [sym_unary] = STATE(7302),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4561] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7303),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7303),
    [sym_operator_assignment] = STATE(7303),
    [sym_conditional] = STATE(7303),
    [sym_range] = STATE(7303),
    [sym_binary] = STATE(7303),
    [sym_unary] = STATE(7303),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4562] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7304),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7304),
    [sym_operator_assignment] = STATE(7304),
    [sym_conditional] = STATE(7304),
    [sym_range] = STATE(7304),
    [sym_binary] = STATE(7304),
    [sym_unary] = STATE(7304),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4563] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7305),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7305),
    [sym_operator_assignment] = STATE(7305),
    [sym_conditional] = STATE(7305),
    [sym_range] = STATE(7305),
    [sym_binary] = STATE(7305),
    [sym_unary] = STATE(7305),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4564] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7306),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7306),
    [sym_operator_assignment] = STATE(7306),
    [sym_conditional] = STATE(7306),
    [sym_range] = STATE(7306),
    [sym_binary] = STATE(7306),
    [sym_unary] = STATE(7306),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4565] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7307),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7307),
    [sym_operator_assignment] = STATE(7307),
    [sym_conditional] = STATE(7307),
    [sym_range] = STATE(7307),
    [sym_binary] = STATE(7307),
    [sym_unary] = STATE(7307),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4566] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7308),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7308),
    [sym_operator_assignment] = STATE(7308),
    [sym_conditional] = STATE(7308),
    [sym_range] = STATE(7308),
    [sym_binary] = STATE(7308),
    [sym_unary] = STATE(7308),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4567] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7309),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7309),
    [sym_operator_assignment] = STATE(7309),
    [sym_conditional] = STATE(7309),
    [sym_range] = STATE(7309),
    [sym_binary] = STATE(7309),
    [sym_unary] = STATE(7309),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4568] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7310),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7310),
    [sym_operator_assignment] = STATE(7310),
    [sym_conditional] = STATE(7310),
    [sym_range] = STATE(7310),
    [sym_binary] = STATE(7310),
    [sym_unary] = STATE(7310),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4569] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7311),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7311),
    [sym_operator_assignment] = STATE(7311),
    [sym_conditional] = STATE(7311),
    [sym_range] = STATE(7311),
    [sym_binary] = STATE(7311),
    [sym_unary] = STATE(7311),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4570] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7312),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7312),
    [sym_operator_assignment] = STATE(7312),
    [sym_conditional] = STATE(7312),
    [sym_range] = STATE(7312),
    [sym_binary] = STATE(7312),
    [sym_unary] = STATE(7312),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4571] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2115),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(2115),
    [sym_range] = STATE(2115),
    [sym_binary] = STATE(2115),
    [sym_unary] = STATE(2115),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__splat_star2] = ACTIONS(3484),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4572] = {
    [aux_sym_exceptions_repeat1] = STATE(7314),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(7087),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [4573] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(2115),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_splat_argument] = STATE(7315),
    [sym_assignment] = STATE(2115),
    [sym_operator_assignment] = STATE(2115),
    [sym_conditional] = STATE(2115),
    [sym_range] = STATE(2115),
    [sym_binary] = STATE(2115),
    [sym_unary] = STATE(2115),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(7315),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__splat_star2] = ACTIONS(3484),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4574] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(7316),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(7316),
    [sym_operator_assignment] = STATE(7316),
    [sym_conditional] = STATE(7316),
    [sym_range] = STATE(7316),
    [sym_binary] = STATE(7316),
    [sym_unary] = STATE(7316),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4575] = {
    [sym_string] = STATE(7317),
    [aux_sym_chained_string_repeat1] = STATE(7317),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4576] = {
    [sym__simple_symbol2] = ACTIONS(3158),
    [sym__string_start2] = ACTIONS(3158),
    [sym__symbol_start2] = ACTIONS(3158),
    [sym__subshell_start2] = ACTIONS(3158),
    [sym__regex_start2] = ACTIONS(3158),
    [sym__string_array_start2] = ACTIONS(3158),
    [sym__symbol_array_start2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym_heredoc_beginning2] = ACTIONS(3158),
    [sym__unary_minus2] = ACTIONS(3158),
    [sym__identifier_hash_key2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_def] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(4982),
    [anon_sym_return] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_break] = ACTIONS(4982),
    [anon_sym_next] = ACTIONS(4982),
    [sym_redo] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(4982),
    [anon_sym_unless] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(4982),
    [anon_sym_until] = ACTIONS(4982),
    [anon_sym_for] = ACTIONS(4982),
    [anon_sym_case] = ACTIONS(4982),
    [anon_sym_begin] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_defined_QMARK] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(4982),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4982),
    [sym_instance_variable] = ACTIONS(3158),
    [sym_class_variable] = ACTIONS(3158),
    [sym_global_variable] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4982),
    [sym_float] = ACTIONS(4982),
    [sym_complex] = ACTIONS(3158),
    [sym_super] = ACTIONS(4982),
    [anon_sym_true] = ACTIONS(4982),
    [anon_sym_TRUE] = ACTIONS(4982),
    [anon_sym_false] = ACTIONS(4982),
    [anon_sym_FALSE] = ACTIONS(4982),
    [sym_self] = ACTIONS(4982),
    [anon_sym_nil] = ACTIONS(4982),
    [anon_sym_NIL] = ACTIONS(4982),
    [sym_character] = ACTIONS(3158),
    [anon_sym_LBRACK2] = ACTIONS(3158),
    [anon_sym_DASH_GT] = ACTIONS(3158),
  },
  [4577] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10509),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [4578] = {
    [sym__heredoc_body_start2] = ACTIONS(10511),
    [anon_sym_RBRACE] = ACTIONS(10511),
    [sym_comment] = ACTIONS(87),
  },
  [4579] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7319),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(7319),
    [sym_operator_assignment] = STATE(7319),
    [sym_conditional] = STATE(7319),
    [sym_range] = STATE(7319),
    [sym_binary] = STATE(7319),
    [sym_unary] = STATE(7319),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4580] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7320),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(7320),
    [sym_operator_assignment] = STATE(7320),
    [sym_conditional] = STATE(7320),
    [sym_range] = STATE(7320),
    [sym_binary] = STATE(7320),
    [sym_unary] = STATE(7320),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4581] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7321),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(7321),
    [sym_operator_assignment] = STATE(7321),
    [sym_conditional] = STATE(7321),
    [sym_range] = STATE(7321),
    [sym_binary] = STATE(7321),
    [sym_unary] = STATE(7321),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4582] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4583] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [4584] = {
    [anon_sym_EQ] = ACTIONS(10543),
    [sym_comment] = ACTIONS(87),
  },
  [4585] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10545),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10547),
    [anon_sym_DASH_EQ] = ACTIONS(10547),
    [anon_sym_STAR_EQ] = ACTIONS(10547),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10547),
    [anon_sym_SLASH_EQ] = ACTIONS(10547),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10547),
    [anon_sym_PIPE_EQ] = ACTIONS(10547),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10547),
    [anon_sym_AMP_EQ] = ACTIONS(10547),
    [anon_sym_PERCENT_EQ] = ACTIONS(10547),
    [anon_sym_GT_GT_EQ] = ACTIONS(10547),
    [anon_sym_LT_LT_EQ] = ACTIONS(10547),
    [anon_sym_CARET_EQ] = ACTIONS(10547),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4586] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [4587] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4588] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7336),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(7336),
    [sym_operator_assignment] = STATE(7336),
    [sym_conditional] = STATE(7336),
    [sym_range] = STATE(7336),
    [sym_binary] = STATE(7336),
    [sym_unary] = STATE(7336),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4589] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [4590] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4591] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [4592] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7337),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7337),
    [sym_operator_assignment] = STATE(7337),
    [sym_conditional] = STATE(7337),
    [sym_range] = STATE(7337),
    [sym_binary] = STATE(7337),
    [sym_unary] = STATE(7337),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4593] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7338),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7338),
    [sym_operator_assignment] = STATE(7338),
    [sym_conditional] = STATE(7338),
    [sym_range] = STATE(7338),
    [sym_binary] = STATE(7338),
    [sym_unary] = STATE(7338),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4594] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7339),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7339),
    [sym_operator_assignment] = STATE(7339),
    [sym_conditional] = STATE(7339),
    [sym_range] = STATE(7339),
    [sym_binary] = STATE(7339),
    [sym_unary] = STATE(7339),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4595] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7340),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7340),
    [sym_operator_assignment] = STATE(7340),
    [sym_conditional] = STATE(7340),
    [sym_range] = STATE(7340),
    [sym_binary] = STATE(7340),
    [sym_unary] = STATE(7340),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4596] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7341),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7341),
    [sym_operator_assignment] = STATE(7341),
    [sym_conditional] = STATE(7341),
    [sym_range] = STATE(7341),
    [sym_binary] = STATE(7341),
    [sym_unary] = STATE(7341),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4597] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7342),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7342),
    [sym_operator_assignment] = STATE(7342),
    [sym_conditional] = STATE(7342),
    [sym_range] = STATE(7342),
    [sym_binary] = STATE(7342),
    [sym_unary] = STATE(7342),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4598] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7343),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(7343),
    [sym_operator_assignment] = STATE(7343),
    [sym_conditional] = STATE(7343),
    [sym_range] = STATE(7343),
    [sym_binary] = STATE(7343),
    [sym_unary] = STATE(7343),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4599] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7344),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7344),
    [sym_operator_assignment] = STATE(7344),
    [sym_conditional] = STATE(7344),
    [sym_range] = STATE(7344),
    [sym_binary] = STATE(7344),
    [sym_unary] = STATE(7344),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4600] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7345),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7345),
    [sym_operator_assignment] = STATE(7345),
    [sym_conditional] = STATE(7345),
    [sym_range] = STATE(7345),
    [sym_binary] = STATE(7345),
    [sym_unary] = STATE(7345),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4601] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7346),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7346),
    [sym_operator_assignment] = STATE(7346),
    [sym_conditional] = STATE(7346),
    [sym_range] = STATE(7346),
    [sym_binary] = STATE(7346),
    [sym_unary] = STATE(7346),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4602] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7347),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7347),
    [sym_operator_assignment] = STATE(7347),
    [sym_conditional] = STATE(7347),
    [sym_range] = STATE(7347),
    [sym_binary] = STATE(7347),
    [sym_unary] = STATE(7347),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4603] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7348),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7348),
    [sym_operator_assignment] = STATE(7348),
    [sym_conditional] = STATE(7348),
    [sym_range] = STATE(7348),
    [sym_binary] = STATE(7348),
    [sym_unary] = STATE(7348),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4604] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7349),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7349),
    [sym_operator_assignment] = STATE(7349),
    [sym_conditional] = STATE(7349),
    [sym_range] = STATE(7349),
    [sym_binary] = STATE(7349),
    [sym_unary] = STATE(7349),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4605] = {
    [sym_heredoc_body] = STATE(7350),
    [aux_sym_call_repeat1] = STATE(7350),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4606] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7351),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10549),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4607] = {
    [sym_heredoc_body] = STATE(7352),
    [aux_sym_call_repeat1] = STATE(7352),
    [aux_sym_argument_list_repeat1] = STATE(7353),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7158),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4608] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7354),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_splat_argument] = STATE(7355),
    [sym_assignment] = STATE(7354),
    [sym_operator_assignment] = STATE(7354),
    [sym_conditional] = STATE(7354),
    [sym_range] = STATE(7354),
    [sym_binary] = STATE(7354),
    [sym_unary] = STATE(7354),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(7355),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4609] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7356),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7356),
    [sym_operator_assignment] = STATE(7356),
    [sym_conditional] = STATE(7356),
    [sym_range] = STATE(7356),
    [sym_binary] = STATE(7356),
    [sym_unary] = STATE(7356),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4610] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4611] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4612] = {
    [sym__method_rest] = STATE(7357),
    [sym_operator] = STATE(136),
    [sym__method_name] = STATE(136),
    [sym_setter] = STATE(136),
    [sym_symbol] = STATE(136),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(3612),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(3612),
    [sym_class_variable] = ACTIONS(3612),
    [sym_global_variable] = ACTIONS(3612),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [4613] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4614] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4615] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4616] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4617] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10551),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4618] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4619] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4620] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4621] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4622] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4623] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7359),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(7359),
    [sym_operator_assignment] = STATE(7359),
    [sym_conditional] = STATE(7359),
    [sym_range] = STATE(7359),
    [sym_binary] = STATE(7359),
    [sym_unary] = STATE(7359),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4624] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4625] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4626] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4627] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4628] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7360),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(7360),
    [sym_operator_assignment] = STATE(7360),
    [sym_conditional] = STATE(7360),
    [sym_range] = STATE(7360),
    [sym_binary] = STATE(7360),
    [sym_unary] = STATE(7360),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4629] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7361),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(7361),
    [sym_operator_assignment] = STATE(7361),
    [sym_conditional] = STATE(7361),
    [sym_range] = STATE(7361),
    [sym_binary] = STATE(7361),
    [sym_unary] = STATE(7361),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4630] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4631] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [4632] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(2175),
    [sym__argument] = STATE(2176),
    [sym_splat_argument] = STATE(2176),
    [sym_hash_splat_argument] = STATE(2176),
    [sym_block_argument] = STATE(2176),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(2176),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_RPAREN] = ACTIONS(749),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4633] = {
    [anon_sym_EQ] = ACTIONS(10581),
    [sym_comment] = ACTIONS(87),
  },
  [4634] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10583),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10585),
    [anon_sym_DASH_EQ] = ACTIONS(10585),
    [anon_sym_STAR_EQ] = ACTIONS(10585),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10585),
    [anon_sym_SLASH_EQ] = ACTIONS(10585),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10585),
    [anon_sym_PIPE_EQ] = ACTIONS(10585),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10585),
    [anon_sym_AMP_EQ] = ACTIONS(10585),
    [anon_sym_PERCENT_EQ] = ACTIONS(10585),
    [anon_sym_GT_GT_EQ] = ACTIONS(10585),
    [anon_sym_LT_LT_EQ] = ACTIONS(10585),
    [anon_sym_CARET_EQ] = ACTIONS(10585),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4635] = {
    [sym_string] = STATE(7376),
    [aux_sym_chained_string_repeat1] = STATE(7376),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4636] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [4637] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [4638] = {
    [sym_string] = STATE(4661),
    [aux_sym_chained_string_repeat1] = STATE(4661),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4639] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7377),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(7377),
    [sym_operator_assignment] = STATE(7377),
    [sym_conditional] = STATE(7377),
    [sym_range] = STATE(7377),
    [sym_binary] = STATE(7377),
    [sym_unary] = STATE(7377),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4640] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [4641] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [4642] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [4643] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7378),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7378),
    [sym_operator_assignment] = STATE(7378),
    [sym_conditional] = STATE(7378),
    [sym_range] = STATE(7378),
    [sym_binary] = STATE(7378),
    [sym_unary] = STATE(7378),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4644] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7379),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7379),
    [sym_operator_assignment] = STATE(7379),
    [sym_conditional] = STATE(7379),
    [sym_range] = STATE(7379),
    [sym_binary] = STATE(7379),
    [sym_unary] = STATE(7379),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4645] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7380),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7380),
    [sym_operator_assignment] = STATE(7380),
    [sym_conditional] = STATE(7380),
    [sym_range] = STATE(7380),
    [sym_binary] = STATE(7380),
    [sym_unary] = STATE(7380),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4646] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7381),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7381),
    [sym_operator_assignment] = STATE(7381),
    [sym_conditional] = STATE(7381),
    [sym_range] = STATE(7381),
    [sym_binary] = STATE(7381),
    [sym_unary] = STATE(7381),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4647] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7382),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7382),
    [sym_operator_assignment] = STATE(7382),
    [sym_conditional] = STATE(7382),
    [sym_range] = STATE(7382),
    [sym_binary] = STATE(7382),
    [sym_unary] = STATE(7382),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4648] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7383),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7383),
    [sym_operator_assignment] = STATE(7383),
    [sym_conditional] = STATE(7383),
    [sym_range] = STATE(7383),
    [sym_binary] = STATE(7383),
    [sym_unary] = STATE(7383),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4649] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7384),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(7384),
    [sym_operator_assignment] = STATE(7384),
    [sym_conditional] = STATE(7384),
    [sym_range] = STATE(7384),
    [sym_binary] = STATE(7384),
    [sym_unary] = STATE(7384),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4650] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7385),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7385),
    [sym_operator_assignment] = STATE(7385),
    [sym_conditional] = STATE(7385),
    [sym_range] = STATE(7385),
    [sym_binary] = STATE(7385),
    [sym_unary] = STATE(7385),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4651] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7386),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7386),
    [sym_operator_assignment] = STATE(7386),
    [sym_conditional] = STATE(7386),
    [sym_range] = STATE(7386),
    [sym_binary] = STATE(7386),
    [sym_unary] = STATE(7386),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4652] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7387),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7387),
    [sym_operator_assignment] = STATE(7387),
    [sym_conditional] = STATE(7387),
    [sym_range] = STATE(7387),
    [sym_binary] = STATE(7387),
    [sym_unary] = STATE(7387),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4653] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7388),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7388),
    [sym_operator_assignment] = STATE(7388),
    [sym_conditional] = STATE(7388),
    [sym_range] = STATE(7388),
    [sym_binary] = STATE(7388),
    [sym_unary] = STATE(7388),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4654] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7389),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7389),
    [sym_operator_assignment] = STATE(7389),
    [sym_conditional] = STATE(7389),
    [sym_range] = STATE(7389),
    [sym_binary] = STATE(7389),
    [sym_unary] = STATE(7389),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4655] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7390),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7390),
    [sym_operator_assignment] = STATE(7390),
    [sym_conditional] = STATE(7390),
    [sym_range] = STATE(7390),
    [sym_binary] = STATE(7390),
    [sym_unary] = STATE(7390),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4656] = {
    [sym_heredoc_body] = STATE(7391),
    [aux_sym_call_repeat1] = STATE(7391),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4657] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(7392),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10587),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4658] = {
    [sym_heredoc_body] = STATE(7393),
    [aux_sym_call_repeat1] = STATE(7393),
    [aux_sym_argument_list_repeat1] = STATE(7394),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7228),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4659] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7395),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_splat_argument] = STATE(7396),
    [sym_assignment] = STATE(7395),
    [sym_operator_assignment] = STATE(7395),
    [sym_conditional] = STATE(7395),
    [sym_range] = STATE(7395),
    [sym_binary] = STATE(7395),
    [sym_unary] = STATE(7395),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(7396),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4660] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7397),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7397),
    [sym_operator_assignment] = STATE(7397),
    [sym_conditional] = STATE(7397),
    [sym_range] = STATE(7397),
    [sym_binary] = STATE(7397),
    [sym_unary] = STATE(7397),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [4661] = {
    [sym_string] = STATE(7398),
    [aux_sym_chained_string_repeat1] = STATE(7398),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [4662] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7399),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(7399),
    [sym_operator_assignment] = STATE(7399),
    [sym_conditional] = STATE(7399),
    [sym_range] = STATE(7399),
    [sym_binary] = STATE(7399),
    [sym_unary] = STATE(7399),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4663] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7400),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(7400),
    [sym_operator_assignment] = STATE(7400),
    [sym_conditional] = STATE(7400),
    [sym_range] = STATE(7400),
    [sym_binary] = STATE(7400),
    [sym_unary] = STATE(7400),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4664] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4665] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4666] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4667] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(5153),
    [sym__argument] = STATE(5154),
    [sym_splat_argument] = STATE(5154),
    [sym_hash_splat_argument] = STATE(5154),
    [sym_block_argument] = STATE(5154),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(5154),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4668] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7401),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(7401),
    [sym_operator_assignment] = STATE(7401),
    [sym_conditional] = STATE(7401),
    [sym_range] = STATE(7401),
    [sym_binary] = STATE(7401),
    [sym_unary] = STATE(7401),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4669] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7402),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(7402),
    [sym_operator_assignment] = STATE(7402),
    [sym_conditional] = STATE(7402),
    [sym_range] = STATE(7402),
    [sym_binary] = STATE(7402),
    [sym_unary] = STATE(7402),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4670] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4671] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [4672] = {
    [aux_sym_exceptions_repeat1] = STATE(7416),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(10619),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4673] = {
    [anon_sym_EQ] = ACTIONS(10621),
    [sym_comment] = ACTIONS(87),
  },
  [4674] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10623),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10625),
    [anon_sym_DASH_EQ] = ACTIONS(10625),
    [anon_sym_STAR_EQ] = ACTIONS(10625),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10625),
    [anon_sym_SLASH_EQ] = ACTIONS(10625),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10625),
    [anon_sym_PIPE_EQ] = ACTIONS(10625),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10625),
    [anon_sym_AMP_EQ] = ACTIONS(10625),
    [anon_sym_PERCENT_EQ] = ACTIONS(10625),
    [anon_sym_GT_GT_EQ] = ACTIONS(10625),
    [anon_sym_LT_LT_EQ] = ACTIONS(10625),
    [anon_sym_CARET_EQ] = ACTIONS(10625),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4675] = {
    [sym_string] = STATE(7419),
    [aux_sym_chained_string_repeat1] = STATE(7419),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4676] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [4677] = {
    [sym_string] = STATE(4677),
    [aux_sym_chained_string_repeat1] = STATE(4677),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4678] = {
    [sym__simple_symbol2] = ACTIONS(10627),
    [sym__string_start2] = ACTIONS(10627),
    [sym__symbol_start2] = ACTIONS(10627),
    [sym__subshell_start2] = ACTIONS(10627),
    [sym__regex_start2] = ACTIONS(10627),
    [sym__string_array_start2] = ACTIONS(10627),
    [sym__symbol_array_start2] = ACTIONS(10627),
    [sym_heredoc_beginning2] = ACTIONS(10627),
    [sym__unary_minus2] = ACTIONS(10627),
    [anon_sym_BEGIN] = ACTIONS(10629),
    [anon_sym_LBRACE] = ACTIONS(10627),
    [anon_sym_END] = ACTIONS(10629),
    [anon_sym_def] = ACTIONS(10629),
    [anon_sym_LPAREN] = ACTIONS(10627),
    [anon_sym_COLON_COLON] = ACTIONS(10627),
    [anon_sym_SEMI] = ACTIONS(10627),
    [anon_sym_STAR] = ACTIONS(10627),
    [anon_sym_class] = ACTIONS(10629),
    [anon_sym_module] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(10629),
    [anon_sym_return] = ACTIONS(10629),
    [anon_sym_yield] = ACTIONS(10629),
    [anon_sym_break] = ACTIONS(10629),
    [anon_sym_next] = ACTIONS(10629),
    [sym_redo] = ACTIONS(10629),
    [sym_retry] = ACTIONS(10629),
    [anon_sym_if] = ACTIONS(10629),
    [anon_sym_unless] = ACTIONS(10629),
    [anon_sym_while] = ACTIONS(10629),
    [anon_sym_until] = ACTIONS(10629),
    [anon_sym_rescue] = ACTIONS(10629),
    [anon_sym_for] = ACTIONS(10629),
    [anon_sym_case] = ACTIONS(10629),
    [anon_sym_else] = ACTIONS(10629),
    [anon_sym_begin] = ACTIONS(10629),
    [anon_sym_ensure] = ACTIONS(10629),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(10627),
    [anon_sym_not] = ACTIONS(10629),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(10629),
    [sym_identifier] = ACTIONS(10629),
    [sym_instance_variable] = ACTIONS(10627),
    [sym_class_variable] = ACTIONS(10627),
    [sym_global_variable] = ACTIONS(10627),
    [anon_sym_undef] = ACTIONS(10629),
    [anon_sym_alias] = ACTIONS(10629),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10629),
    [sym_float] = ACTIONS(10629),
    [sym_complex] = ACTIONS(10627),
    [sym_super] = ACTIONS(10629),
    [anon_sym_true] = ACTIONS(10629),
    [anon_sym_TRUE] = ACTIONS(10629),
    [anon_sym_false] = ACTIONS(10629),
    [anon_sym_FALSE] = ACTIONS(10629),
    [sym_self] = ACTIONS(10629),
    [anon_sym_nil] = ACTIONS(10629),
    [anon_sym_NIL] = ACTIONS(10629),
    [sym_character] = ACTIONS(10627),
    [anon_sym_LBRACK2] = ACTIONS(10627),
    [anon_sym_DASH_GT] = ACTIONS(10627),
  },
  [4679] = {
    [sym_heredoc_body] = STATE(7420),
    [sym__terminator] = STATE(7420),
    [sym__line_break2] = ACTIONS(10631),
    [sym__simple_symbol2] = ACTIONS(10627),
    [sym__string_start2] = ACTIONS(10627),
    [sym__symbol_start2] = ACTIONS(10627),
    [sym__subshell_start2] = ACTIONS(10627),
    [sym__regex_start2] = ACTIONS(10627),
    [sym__string_array_start2] = ACTIONS(10627),
    [sym__symbol_array_start2] = ACTIONS(10627),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(10627),
    [sym__unary_minus2] = ACTIONS(10627),
    [anon_sym_BEGIN] = ACTIONS(10629),
    [anon_sym_LBRACE] = ACTIONS(10627),
    [anon_sym_END] = ACTIONS(10629),
    [anon_sym_def] = ACTIONS(10629),
    [anon_sym_LPAREN] = ACTIONS(10627),
    [anon_sym_COLON_COLON] = ACTIONS(10627),
    [anon_sym_SEMI] = ACTIONS(10631),
    [anon_sym_STAR] = ACTIONS(10627),
    [anon_sym_class] = ACTIONS(10629),
    [anon_sym_module] = ACTIONS(10629),
    [anon_sym_end] = ACTIONS(10629),
    [anon_sym_return] = ACTIONS(10629),
    [anon_sym_yield] = ACTIONS(10629),
    [anon_sym_break] = ACTIONS(10629),
    [anon_sym_next] = ACTIONS(10629),
    [sym_redo] = ACTIONS(10629),
    [sym_retry] = ACTIONS(10629),
    [anon_sym_if] = ACTIONS(10629),
    [anon_sym_unless] = ACTIONS(10629),
    [anon_sym_while] = ACTIONS(10629),
    [anon_sym_until] = ACTIONS(10629),
    [anon_sym_rescue] = ACTIONS(10629),
    [anon_sym_for] = ACTIONS(10629),
    [anon_sym_case] = ACTIONS(10629),
    [anon_sym_else] = ACTIONS(10629),
    [anon_sym_begin] = ACTIONS(10629),
    [anon_sym_ensure] = ACTIONS(10629),
    [anon_sym_PLUS] = ACTIONS(10629),
    [anon_sym_defined_QMARK] = ACTIONS(10627),
    [anon_sym_not] = ACTIONS(10629),
    [anon_sym_BANG] = ACTIONS(10627),
    [anon_sym_TILDE] = ACTIONS(10627),
    [sym_constant] = ACTIONS(10629),
    [sym_identifier] = ACTIONS(10629),
    [sym_instance_variable] = ACTIONS(10627),
    [sym_class_variable] = ACTIONS(10627),
    [sym_global_variable] = ACTIONS(10627),
    [anon_sym_undef] = ACTIONS(10629),
    [anon_sym_alias] = ACTIONS(10629),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10629),
    [sym_float] = ACTIONS(10629),
    [sym_complex] = ACTIONS(10627),
    [sym_super] = ACTIONS(10629),
    [anon_sym_true] = ACTIONS(10629),
    [anon_sym_TRUE] = ACTIONS(10629),
    [anon_sym_false] = ACTIONS(10629),
    [anon_sym_FALSE] = ACTIONS(10629),
    [sym_self] = ACTIONS(10629),
    [anon_sym_nil] = ACTIONS(10629),
    [anon_sym_NIL] = ACTIONS(10629),
    [sym_character] = ACTIONS(10627),
    [anon_sym_LBRACK2] = ACTIONS(10627),
    [anon_sym_DASH_GT] = ACTIONS(10627),
  },
  [4680] = {
    [aux_sym_method_parameters_repeat1] = STATE(6475),
    [anon_sym_RPAREN] = ACTIONS(10633),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [4681] = {
    [sym__statements] = STATE(7423),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(7424),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10635),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4682] = {
    [sym__statements] = STATE(7426),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(7427),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7428),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7428),
    [sym__line_break2] = ACTIONS(10637),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10639),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4683] = {
    [sym_do_block] = STATE(7429),
    [sym_block] = STATE(7429),
    [anon_sym_LBRACE] = ACTIONS(7270),
    [anon_sym_do] = ACTIONS(10641),
    [sym_comment] = ACTIONS(87),
  },
  [4684] = {
    [sym__line_break2] = ACTIONS(2537),
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_SEMI] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [4685] = {
    [sym__line_break2] = ACTIONS(9520),
    [sym__heredoc_body_start2] = ACTIONS(9520),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(9520),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(10643),
    [anon_sym_or] = ACTIONS(10643),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [4686] = {
    [sym__line_break2] = ACTIONS(9558),
    [sym__heredoc_body_start2] = ACTIONS(9558),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(9558),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(9558),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(10643),
    [anon_sym_or] = ACTIONS(10643),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [4687] = {
    [sym__formal_parameter] = STATE(7430),
    [sym__simple_formal_parameter] = STATE(7430),
    [sym_destructured_parameter] = STATE(7430),
    [sym_splat_parameter] = STATE(7430),
    [sym_hash_splat_parameter] = STATE(7430),
    [sym_block_parameter] = STATE(7430),
    [sym_keyword_parameter] = STATE(7430),
    [sym_optional_parameter] = STATE(7430),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(2503),
    [sym_comment] = ACTIONS(87),
  },
  [4688] = {
    [sym_heredoc_body] = STATE(7420),
    [sym__terminator] = STATE(7420),
    [aux_sym_method_parameters_repeat1] = STATE(7432),
    [sym__line_break2] = ACTIONS(10631),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(10645),
    [anon_sym_SEMI] = ACTIONS(10631),
    [sym_comment] = ACTIONS(87),
  },
  [4689] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7433),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(7433),
    [sym_operator_assignment] = STATE(7433),
    [sym_conditional] = STATE(7433),
    [sym_range] = STATE(7433),
    [sym_binary] = STATE(7433),
    [sym_unary] = STATE(7433),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4690] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(4991),
    [sym__argument_list_with_parens] = STATE(7440),
    [sym__argument] = STATE(7441),
    [sym_splat_argument] = STATE(7441),
    [sym_hash_splat_argument] = STATE(7441),
    [sym_block_argument] = STATE(7441),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7441),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(363),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4691] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(4995),
    [sym__argument_list_with_parens] = STATE(7440),
    [sym__argument] = STATE(7441),
    [sym_splat_argument] = STATE(7441),
    [sym_hash_splat_argument] = STATE(7441),
    [sym_block_argument] = STATE(7441),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7441),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(415),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4692] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(4996),
    [sym__argument_list_with_parens] = STATE(7440),
    [sym__argument] = STATE(7441),
    [sym_splat_argument] = STATE(7441),
    [sym_hash_splat_argument] = STATE(7441),
    [sym_block_argument] = STATE(7441),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7441),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(419),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4693] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_argument_list] = STATE(4997),
    [sym__argument_list_with_parens] = STATE(7440),
    [sym__argument] = STATE(7441),
    [sym_splat_argument] = STATE(7441),
    [sym_hash_splat_argument] = STATE(7441),
    [sym_block_argument] = STATE(7441),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7441),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_RPAREN] = ACTIONS(423),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(7655),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(7306),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4694] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7443),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(7443),
    [sym_operator_assignment] = STATE(7443),
    [sym_conditional] = STATE(7443),
    [sym_range] = STATE(7443),
    [sym_binary] = STATE(7443),
    [sym_unary] = STATE(7443),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4695] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7444),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(7444),
    [sym_operator_assignment] = STATE(7444),
    [sym_conditional] = STATE(7444),
    [sym_range] = STATE(7444),
    [sym_binary] = STATE(7444),
    [sym_unary] = STATE(7444),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4696] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(5013),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(5013),
    [sym_operator_assignment] = STATE(5013),
    [sym_conditional] = STATE(5013),
    [sym_range] = STATE(5013),
    [sym_binary] = STATE(5013),
    [sym_unary] = STATE(5013),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4697] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(10673),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [4698] = {
    [anon_sym_EQ] = ACTIONS(10687),
    [sym_comment] = ACTIONS(87),
  },
  [4699] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(10689),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(10691),
    [anon_sym_DASH_EQ] = ACTIONS(10691),
    [anon_sym_STAR_EQ] = ACTIONS(10691),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10691),
    [anon_sym_SLASH_EQ] = ACTIONS(10691),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10691),
    [anon_sym_PIPE_EQ] = ACTIONS(10691),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10691),
    [anon_sym_AMP_EQ] = ACTIONS(10691),
    [anon_sym_PERCENT_EQ] = ACTIONS(10691),
    [anon_sym_GT_GT_EQ] = ACTIONS(10691),
    [anon_sym_LT_LT_EQ] = ACTIONS(10691),
    [anon_sym_CARET_EQ] = ACTIONS(10691),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4700] = {
    [sym_string] = STATE(7459),
    [aux_sym_chained_string_repeat1] = STATE(7459),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4701] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(10673),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [4702] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4703] = {
    [sym_string] = STATE(4735),
    [aux_sym_chained_string_repeat1] = STATE(4735),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4704] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7460),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(7460),
    [sym_operator_assignment] = STATE(7460),
    [sym_conditional] = STATE(7460),
    [sym_range] = STATE(7460),
    [sym_binary] = STATE(7460),
    [sym_unary] = STATE(7460),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4705] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(10673),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [4706] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7461),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7461),
    [sym_operator_assignment] = STATE(7461),
    [sym_conditional] = STATE(7461),
    [sym_range] = STATE(7461),
    [sym_binary] = STATE(7461),
    [sym_unary] = STATE(7461),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4707] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7462),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7462),
    [sym_operator_assignment] = STATE(7462),
    [sym_conditional] = STATE(7462),
    [sym_range] = STATE(7462),
    [sym_binary] = STATE(7462),
    [sym_unary] = STATE(7462),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4708] = {
    [anon_sym_COLON] = ACTIONS(10693),
    [sym_comment] = ACTIONS(87),
  },
  [4709] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7464),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7464),
    [sym_operator_assignment] = STATE(7464),
    [sym_conditional] = STATE(7464),
    [sym_range] = STATE(7464),
    [sym_binary] = STATE(7464),
    [sym_unary] = STATE(7464),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4710] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10695),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4711] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [4712] = {
    [sym_heredoc_body] = STATE(7466),
    [aux_sym_call_repeat1] = STATE(7466),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4713] = {
    [sym_heredoc_body] = STATE(7466),
    [aux_sym_call_repeat1] = STATE(7466),
    [aux_sym_argument_list_repeat1] = STATE(7468),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4714] = {
    [sym_string] = STATE(4735),
    [aux_sym_chained_string_repeat1] = STATE(4735),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10699),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4715] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4716] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [4717] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7469),
    [sym_operator_assignment] = STATE(7469),
    [sym_conditional] = STATE(7469),
    [sym_range] = STATE(7469),
    [sym_binary] = STATE(7469),
    [sym_unary] = STATE(7469),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4718] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7470),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7470),
    [sym_operator_assignment] = STATE(7470),
    [sym_conditional] = STATE(7470),
    [sym_range] = STATE(7470),
    [sym_binary] = STATE(7470),
    [sym_unary] = STATE(7470),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4719] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7471),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7471),
    [sym_operator_assignment] = STATE(7471),
    [sym_conditional] = STATE(7471),
    [sym_range] = STATE(7471),
    [sym_binary] = STATE(7471),
    [sym_unary] = STATE(7471),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4720] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7472),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7472),
    [sym_operator_assignment] = STATE(7472),
    [sym_conditional] = STATE(7472),
    [sym_range] = STATE(7472),
    [sym_binary] = STATE(7472),
    [sym_unary] = STATE(7472),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4721] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7473),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7473),
    [sym_operator_assignment] = STATE(7473),
    [sym_conditional] = STATE(7473),
    [sym_range] = STATE(7473),
    [sym_binary] = STATE(7473),
    [sym_unary] = STATE(7473),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4722] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7474),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7474),
    [sym_operator_assignment] = STATE(7474),
    [sym_conditional] = STATE(7474),
    [sym_range] = STATE(7474),
    [sym_binary] = STATE(7474),
    [sym_unary] = STATE(7474),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4723] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7475),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(7475),
    [sym_operator_assignment] = STATE(7475),
    [sym_conditional] = STATE(7475),
    [sym_range] = STATE(7475),
    [sym_binary] = STATE(7475),
    [sym_unary] = STATE(7475),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4724] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7476),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7476),
    [sym_operator_assignment] = STATE(7476),
    [sym_conditional] = STATE(7476),
    [sym_range] = STATE(7476),
    [sym_binary] = STATE(7476),
    [sym_unary] = STATE(7476),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4725] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7477),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7477),
    [sym_operator_assignment] = STATE(7477),
    [sym_conditional] = STATE(7477),
    [sym_range] = STATE(7477),
    [sym_binary] = STATE(7477),
    [sym_unary] = STATE(7477),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4726] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7478),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7478),
    [sym_operator_assignment] = STATE(7478),
    [sym_conditional] = STATE(7478),
    [sym_range] = STATE(7478),
    [sym_binary] = STATE(7478),
    [sym_unary] = STATE(7478),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4727] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7479),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7479),
    [sym_operator_assignment] = STATE(7479),
    [sym_conditional] = STATE(7479),
    [sym_range] = STATE(7479),
    [sym_binary] = STATE(7479),
    [sym_unary] = STATE(7479),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4728] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7480),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7480),
    [sym_operator_assignment] = STATE(7480),
    [sym_conditional] = STATE(7480),
    [sym_range] = STATE(7480),
    [sym_binary] = STATE(7480),
    [sym_unary] = STATE(7480),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4729] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7481),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7481),
    [sym_operator_assignment] = STATE(7481),
    [sym_conditional] = STATE(7481),
    [sym_range] = STATE(7481),
    [sym_binary] = STATE(7481),
    [sym_unary] = STATE(7481),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4730] = {
    [sym_heredoc_body] = STATE(7482),
    [aux_sym_call_repeat1] = STATE(7482),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_EQ] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4731] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2208),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(4920),
    [sym_splat_argument] = STATE(4920),
    [sym_hash_splat_argument] = STATE(4920),
    [sym_block_argument] = STATE(4920),
    [sym_assignment] = STATE(2208),
    [sym_operator_assignment] = STATE(2208),
    [sym_conditional] = STATE(2208),
    [sym_range] = STATE(2208),
    [sym_binary] = STATE(2208),
    [sym_unary] = STATE(2208),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2213),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7483),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4920),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3634),
    [sym__splat_star2] = ACTIONS(3636),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3642),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3660),
    [sym_identifier] = ACTIONS(3660),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4732] = {
    [sym_heredoc_body] = STATE(7484),
    [aux_sym_call_repeat1] = STATE(7484),
    [aux_sym_argument_list_repeat1] = STATE(7485),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(7346),
    [anon_sym_EQ] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4733] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7486),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_splat_argument] = STATE(7487),
    [sym_assignment] = STATE(7486),
    [sym_operator_assignment] = STATE(7486),
    [sym_conditional] = STATE(7486),
    [sym_range] = STATE(7486),
    [sym_binary] = STATE(7486),
    [sym_unary] = STATE(7486),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(7487),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4734] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7488),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(7488),
    [sym_operator_assignment] = STATE(7488),
    [sym_conditional] = STATE(7488),
    [sym_range] = STATE(7488),
    [sym_binary] = STATE(7488),
    [sym_unary] = STATE(7488),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4735] = {
    [sym_string] = STATE(7489),
    [aux_sym_chained_string_repeat1] = STATE(7489),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4736] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4737] = {
    [sym_heredoc_body] = STATE(7490),
    [aux_sym_call_repeat1] = STATE(7490),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4738] = {
    [sym_heredoc_body] = STATE(7490),
    [aux_sym_call_repeat1] = STATE(7490),
    [aux_sym_argument_list_repeat1] = STATE(7491),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4739] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4740] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [4741] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7492),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7492),
    [sym_operator_assignment] = STATE(7492),
    [sym_conditional] = STATE(7492),
    [sym_range] = STATE(7492),
    [sym_binary] = STATE(7492),
    [sym_unary] = STATE(7492),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4742] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7493),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7493),
    [sym_operator_assignment] = STATE(7493),
    [sym_conditional] = STATE(7493),
    [sym_range] = STATE(7493),
    [sym_binary] = STATE(7493),
    [sym_unary] = STATE(7493),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4743] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7494),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7494),
    [sym_operator_assignment] = STATE(7494),
    [sym_conditional] = STATE(7494),
    [sym_range] = STATE(7494),
    [sym_binary] = STATE(7494),
    [sym_unary] = STATE(7494),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4744] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7495),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7495),
    [sym_operator_assignment] = STATE(7495),
    [sym_conditional] = STATE(7495),
    [sym_range] = STATE(7495),
    [sym_binary] = STATE(7495),
    [sym_unary] = STATE(7495),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4745] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7496),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7496),
    [sym_operator_assignment] = STATE(7496),
    [sym_conditional] = STATE(7496),
    [sym_range] = STATE(7496),
    [sym_binary] = STATE(7496),
    [sym_unary] = STATE(7496),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4746] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7497),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7497),
    [sym_operator_assignment] = STATE(7497),
    [sym_conditional] = STATE(7497),
    [sym_range] = STATE(7497),
    [sym_binary] = STATE(7497),
    [sym_unary] = STATE(7497),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4747] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7498),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7498),
    [sym_operator_assignment] = STATE(7498),
    [sym_conditional] = STATE(7498),
    [sym_range] = STATE(7498),
    [sym_binary] = STATE(7498),
    [sym_unary] = STATE(7498),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4748] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7499),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7499),
    [sym_operator_assignment] = STATE(7499),
    [sym_conditional] = STATE(7499),
    [sym_range] = STATE(7499),
    [sym_binary] = STATE(7499),
    [sym_unary] = STATE(7499),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4749] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7500),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7500),
    [sym_operator_assignment] = STATE(7500),
    [sym_conditional] = STATE(7500),
    [sym_range] = STATE(7500),
    [sym_binary] = STATE(7500),
    [sym_unary] = STATE(7500),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4750] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7501),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7501),
    [sym_operator_assignment] = STATE(7501),
    [sym_conditional] = STATE(7501),
    [sym_range] = STATE(7501),
    [sym_binary] = STATE(7501),
    [sym_unary] = STATE(7501),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4751] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7502),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7502),
    [sym_operator_assignment] = STATE(7502),
    [sym_conditional] = STATE(7502),
    [sym_range] = STATE(7502),
    [sym_binary] = STATE(7502),
    [sym_unary] = STATE(7502),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4752] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7503),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7503),
    [sym_operator_assignment] = STATE(7503),
    [sym_conditional] = STATE(7503),
    [sym_range] = STATE(7503),
    [sym_binary] = STATE(7503),
    [sym_unary] = STATE(7503),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4753] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7504),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_splat_argument] = STATE(7505),
    [sym_assignment] = STATE(7504),
    [sym_operator_assignment] = STATE(7504),
    [sym_conditional] = STATE(7504),
    [sym_range] = STATE(7504),
    [sym_binary] = STATE(7504),
    [sym_unary] = STATE(7504),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(7505),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4754] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7506),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(7506),
    [sym_operator_assignment] = STATE(7506),
    [sym_conditional] = STATE(7506),
    [sym_range] = STATE(7506),
    [sym_binary] = STATE(7506),
    [sym_unary] = STATE(7506),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4755] = {
    [sym_string] = STATE(7507),
    [aux_sym_chained_string_repeat1] = STATE(7507),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4756] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [4757] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4758] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4759] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7508),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(7508),
    [sym_operator_assignment] = STATE(7508),
    [sym_conditional] = STATE(7508),
    [sym_range] = STATE(7508),
    [sym_binary] = STATE(7508),
    [sym_unary] = STATE(7508),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4760] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4761] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7509),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(7509),
    [sym_operator_assignment] = STATE(7509),
    [sym_conditional] = STATE(7509),
    [sym_range] = STATE(7509),
    [sym_binary] = STATE(7509),
    [sym_unary] = STATE(7509),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4762] = {
    [sym_heredoc_body] = STATE(7510),
    [aux_sym_call_repeat1] = STATE(7510),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4763] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(7511),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10701),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4764] = {
    [sym_heredoc_body] = STATE(7512),
    [aux_sym_call_repeat1] = STATE(7512),
    [aux_sym_argument_list_repeat1] = STATE(7513),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7396),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [4765] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4766] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [4767] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4768] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [4769] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4770] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4771] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [4772] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10703),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4773] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4774] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4775] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4776] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4777] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4778] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4779] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4780] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7515),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(7515),
    [sym_operator_assignment] = STATE(7515),
    [sym_conditional] = STATE(7515),
    [sym_range] = STATE(7515),
    [sym_binary] = STATE(7515),
    [sym_unary] = STATE(7515),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4781] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4782] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7516),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(7516),
    [sym_operator_assignment] = STATE(7516),
    [sym_conditional] = STATE(7516),
    [sym_range] = STATE(7516),
    [sym_binary] = STATE(7516),
    [sym_unary] = STATE(7516),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4783] = {
    [sym_heredoc_body] = STATE(7517),
    [aux_sym_call_repeat1] = STATE(7517),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4784] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(7518),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10705),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4785] = {
    [sym_heredoc_body] = STATE(7519),
    [aux_sym_call_repeat1] = STATE(7519),
    [aux_sym_argument_list_repeat1] = STATE(7520),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7404),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [4786] = {
    [sym_heredoc_body] = STATE(4786),
    [aux_sym_call_repeat1] = STATE(4786),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [4787] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(725),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(725),
    [sym_operator_assignment] = STATE(725),
    [sym_conditional] = STATE(725),
    [sym_range] = STATE(725),
    [sym_binary] = STATE(725),
    [sym_unary] = STATE(725),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(731),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1309),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__identifier_hash_key2] = ACTIONS(1315),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7408),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1333),
    [sym_identifier] = ACTIONS(1333),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4788] = {
    [sym_heredoc_body] = STATE(4786),
    [aux_sym_call_repeat1] = STATE(4786),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [4789] = {
    [aux_sym_argument_list_repeat1] = STATE(4789),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10707),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [4790] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4791] = {
    [aux_sym_exceptions_repeat1] = STATE(7522),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [4792] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [4793] = {
    [sym_string] = STATE(4793),
    [aux_sym_chained_string_repeat1] = STATE(4793),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [4794] = {
    [aux_sym_undef_repeat1] = STATE(4794),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_RPAREN] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [4795] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(150),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(151),
    [sym_operator_assignment] = STATE(151),
    [sym_conditional] = STATE(151),
    [sym_range] = STATE(151),
    [sym_binary] = STATE(151),
    [sym_unary] = STATE(151),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [anon_sym_undef] = ACTIONS(271),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4796] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7523),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(156),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(156),
    [sym_assignment] = STATE(7523),
    [sym_operator_assignment] = STATE(7523),
    [sym_conditional] = STATE(7523),
    [sym_range] = STATE(7523),
    [sym_binary] = STATE(7523),
    [sym_unary] = STATE(7523),
    [sym_left_assignment_list] = STATE(153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(156),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(156),
    [sym_false] = STATE(156),
    [sym_nil] = STATE(156),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(157),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(245),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(251),
    [anon_sym_yield] = ACTIONS(253),
    [anon_sym_break] = ACTIONS(255),
    [anon_sym_next] = ACTIONS(257),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(259),
    [anon_sym_defined_QMARK] = ACTIONS(261),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_BANG] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4797] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [4798] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [4799] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [4800] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7524),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7524),
    [sym_operator_assignment] = STATE(7524),
    [sym_conditional] = STATE(7524),
    [sym_range] = STATE(7524),
    [sym_binary] = STATE(7524),
    [sym_unary] = STATE(7524),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4801] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7525),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7525),
    [sym_operator_assignment] = STATE(7525),
    [sym_conditional] = STATE(7525),
    [sym_range] = STATE(7525),
    [sym_binary] = STATE(7525),
    [sym_unary] = STATE(7525),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4802] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7526),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7526),
    [sym_operator_assignment] = STATE(7526),
    [sym_conditional] = STATE(7526),
    [sym_range] = STATE(7526),
    [sym_binary] = STATE(7526),
    [sym_unary] = STATE(7526),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4803] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7527),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7527),
    [sym_operator_assignment] = STATE(7527),
    [sym_conditional] = STATE(7527),
    [sym_range] = STATE(7527),
    [sym_binary] = STATE(7527),
    [sym_unary] = STATE(7527),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4804] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7528),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7528),
    [sym_operator_assignment] = STATE(7528),
    [sym_conditional] = STATE(7528),
    [sym_range] = STATE(7528),
    [sym_binary] = STATE(7528),
    [sym_unary] = STATE(7528),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4805] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7529),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7529),
    [sym_operator_assignment] = STATE(7529),
    [sym_conditional] = STATE(7529),
    [sym_range] = STATE(7529),
    [sym_binary] = STATE(7529),
    [sym_unary] = STATE(7529),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4806] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7530),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7530),
    [sym_operator_assignment] = STATE(7530),
    [sym_conditional] = STATE(7530),
    [sym_range] = STATE(7530),
    [sym_binary] = STATE(7530),
    [sym_unary] = STATE(7530),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4807] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7531),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7531),
    [sym_operator_assignment] = STATE(7531),
    [sym_conditional] = STATE(7531),
    [sym_range] = STATE(7531),
    [sym_binary] = STATE(7531),
    [sym_unary] = STATE(7531),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4808] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7532),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7532),
    [sym_operator_assignment] = STATE(7532),
    [sym_conditional] = STATE(7532),
    [sym_range] = STATE(7532),
    [sym_binary] = STATE(7532),
    [sym_unary] = STATE(7532),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4809] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7533),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7533),
    [sym_operator_assignment] = STATE(7533),
    [sym_conditional] = STATE(7533),
    [sym_range] = STATE(7533),
    [sym_binary] = STATE(7533),
    [sym_unary] = STATE(7533),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4810] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7534),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7534),
    [sym_operator_assignment] = STATE(7534),
    [sym_conditional] = STATE(7534),
    [sym_range] = STATE(7534),
    [sym_binary] = STATE(7534),
    [sym_unary] = STATE(7534),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4811] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7535),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7535),
    [sym_operator_assignment] = STATE(7535),
    [sym_conditional] = STATE(7535),
    [sym_range] = STATE(7535),
    [sym_binary] = STATE(7535),
    [sym_unary] = STATE(7535),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4812] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7536),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_splat_argument] = STATE(7537),
    [sym_assignment] = STATE(7536),
    [sym_operator_assignment] = STATE(7536),
    [sym_conditional] = STATE(7536),
    [sym_range] = STATE(7536),
    [sym_binary] = STATE(7536),
    [sym_unary] = STATE(7536),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(7537),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4813] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7538),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(7538),
    [sym_operator_assignment] = STATE(7538),
    [sym_conditional] = STATE(7538),
    [sym_range] = STATE(7538),
    [sym_binary] = STATE(7538),
    [sym_unary] = STATE(7538),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [4814] = {
    [sym_string] = STATE(7539),
    [aux_sym_chained_string_repeat1] = STATE(7539),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [4815] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [4816] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4817] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [4818] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4819] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [4820] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4821] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4822] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [4823] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10710),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [4824] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4825] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4826] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4827] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4828] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4829] = {
    [sym_heredoc_body] = STATE(4829),
    [aux_sym_call_repeat1] = STATE(4829),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [4830] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(768),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(768),
    [sym_operator_assignment] = STATE(768),
    [sym_conditional] = STATE(768),
    [sym_range] = STATE(768),
    [sym_binary] = STATE(768),
    [sym_unary] = STATE(768),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(774),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1387),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__identifier_hash_key2] = ACTIONS(1393),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7449),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1411),
    [sym_identifier] = ACTIONS(1411),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [4831] = {
    [sym_heredoc_body] = STATE(4829),
    [aux_sym_call_repeat1] = STATE(4829),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [4832] = {
    [aux_sym_argument_list_repeat1] = STATE(4832),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10712),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [4833] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4834] = {
    [aux_sym_exceptions_repeat1] = STATE(7542),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [4835] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [4836] = {
    [sym_string] = STATE(4836),
    [aux_sym_chained_string_repeat1] = STATE(4836),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [4837] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [4838] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4839] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4840] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [4841] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7543),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7543),
    [sym_operator_assignment] = STATE(7543),
    [sym_conditional] = STATE(7543),
    [sym_range] = STATE(7543),
    [sym_binary] = STATE(7543),
    [sym_unary] = STATE(7543),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4842] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7544),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7544),
    [sym_operator_assignment] = STATE(7544),
    [sym_conditional] = STATE(7544),
    [sym_range] = STATE(7544),
    [sym_binary] = STATE(7544),
    [sym_unary] = STATE(7544),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4843] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7545),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7545),
    [sym_operator_assignment] = STATE(7545),
    [sym_conditional] = STATE(7545),
    [sym_range] = STATE(7545),
    [sym_binary] = STATE(7545),
    [sym_unary] = STATE(7545),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4844] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7546),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7546),
    [sym_operator_assignment] = STATE(7546),
    [sym_conditional] = STATE(7546),
    [sym_range] = STATE(7546),
    [sym_binary] = STATE(7546),
    [sym_unary] = STATE(7546),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4845] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7547),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7547),
    [sym_operator_assignment] = STATE(7547),
    [sym_conditional] = STATE(7547),
    [sym_range] = STATE(7547),
    [sym_binary] = STATE(7547),
    [sym_unary] = STATE(7547),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4846] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7548),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7548),
    [sym_operator_assignment] = STATE(7548),
    [sym_conditional] = STATE(7548),
    [sym_range] = STATE(7548),
    [sym_binary] = STATE(7548),
    [sym_unary] = STATE(7548),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4847] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7549),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7549),
    [sym_operator_assignment] = STATE(7549),
    [sym_conditional] = STATE(7549),
    [sym_range] = STATE(7549),
    [sym_binary] = STATE(7549),
    [sym_unary] = STATE(7549),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4848] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7550),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7550),
    [sym_operator_assignment] = STATE(7550),
    [sym_conditional] = STATE(7550),
    [sym_range] = STATE(7550),
    [sym_binary] = STATE(7550),
    [sym_unary] = STATE(7550),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4849] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7551),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7551),
    [sym_operator_assignment] = STATE(7551),
    [sym_conditional] = STATE(7551),
    [sym_range] = STATE(7551),
    [sym_binary] = STATE(7551),
    [sym_unary] = STATE(7551),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4850] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7552),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7552),
    [sym_operator_assignment] = STATE(7552),
    [sym_conditional] = STATE(7552),
    [sym_range] = STATE(7552),
    [sym_binary] = STATE(7552),
    [sym_unary] = STATE(7552),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4851] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7553),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7553),
    [sym_operator_assignment] = STATE(7553),
    [sym_conditional] = STATE(7553),
    [sym_range] = STATE(7553),
    [sym_binary] = STATE(7553),
    [sym_unary] = STATE(7553),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4852] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7554),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7554),
    [sym_operator_assignment] = STATE(7554),
    [sym_conditional] = STATE(7554),
    [sym_range] = STATE(7554),
    [sym_binary] = STATE(7554),
    [sym_unary] = STATE(7554),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4853] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2334),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(2334),
    [sym_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(2334),
    [sym_range] = STATE(2334),
    [sym_binary] = STATE(2334),
    [sym_unary] = STATE(2334),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(3818),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4854] = {
    [aux_sym_exceptions_repeat1] = STATE(7555),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(7481),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [4855] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2334),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_splat_argument] = STATE(7556),
    [sym_assignment] = STATE(2334),
    [sym_operator_assignment] = STATE(2334),
    [sym_conditional] = STATE(2334),
    [sym_range] = STATE(2334),
    [sym_binary] = STATE(2334),
    [sym_unary] = STATE(2334),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(7556),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(3818),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4856] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7557),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(7557),
    [sym_operator_assignment] = STATE(7557),
    [sym_conditional] = STATE(7557),
    [sym_range] = STATE(7557),
    [sym_binary] = STATE(7557),
    [sym_unary] = STATE(7557),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4857] = {
    [anon_sym_DOT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [sym_comment] = ACTIONS(87),
  },
  [4858] = {
    [anon_sym_DOT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [sym_comment] = ACTIONS(87),
  },
  [4859] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10715),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4860] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(10715),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10717),
  },
  [4861] = {
    [anon_sym_DOT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [sym_comment] = ACTIONS(87),
  },
  [4862] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10719),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4863] = {
    [anon_sym_DOT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [sym_comment] = ACTIONS(87),
  },
  [4864] = {
    [anon_sym_DOT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [sym_comment] = ACTIONS(87),
  },
  [4865] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10721),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4866] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(10721),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10723),
  },
  [4867] = {
    [anon_sym_DOT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [sym_comment] = ACTIONS(87),
  },
  [4868] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10725),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [4869] = {
    [anon_sym_DOT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [sym_comment] = ACTIONS(87),
  },
  [4870] = {
    [anon_sym_DOT] = ACTIONS(10727),
    [anon_sym_COLON_COLON] = ACTIONS(10727),
    [sym_comment] = ACTIONS(87),
  },
  [4871] = {
    [anon_sym_DOT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [sym_comment] = ACTIONS(87),
  },
  [4872] = {
    [anon_sym_DOT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [sym_comment] = ACTIONS(87),
  },
  [4873] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(7565),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10729),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4874] = {
    [sym__statements] = STATE(830),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(831),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(832),
    [sym_rescue] = STATE(833),
    [sym__body_statement] = STATE(7566),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10731),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4875] = {
    [anon_sym_DOT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [sym_comment] = ACTIONS(87),
  },
  [4876] = {
    [anon_sym_DOT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [sym_comment] = ACTIONS(87),
  },
  [4877] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4878] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7567),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7567),
    [sym_operator_assignment] = STATE(7567),
    [sym_conditional] = STATE(7567),
    [sym_range] = STATE(7567),
    [sym_binary] = STATE(7567),
    [sym_unary] = STATE(7567),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4879] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7568),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7568),
    [sym_operator_assignment] = STATE(7568),
    [sym_conditional] = STATE(7568),
    [sym_range] = STATE(7568),
    [sym_binary] = STATE(7568),
    [sym_unary] = STATE(7568),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4880] = {
    [anon_sym_COLON] = ACTIONS(10733),
    [sym_comment] = ACTIONS(87),
  },
  [4881] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7570),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7570),
    [sym_operator_assignment] = STATE(7570),
    [sym_conditional] = STATE(7570),
    [sym_range] = STATE(7570),
    [sym_binary] = STATE(7570),
    [sym_unary] = STATE(7570),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4882] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10735),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4883] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(10737),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [4884] = {
    [sym_heredoc_body] = STATE(7572),
    [aux_sym_call_repeat1] = STATE(7572),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4885] = {
    [sym_heredoc_body] = STATE(7572),
    [aux_sym_call_repeat1] = STATE(7572),
    [aux_sym_argument_list_repeat1] = STATE(7574),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10739),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4886] = {
    [sym_string] = STATE(1965),
    [aux_sym_chained_string_repeat1] = STATE(1965),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10741),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4887] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [4888] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [4889] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7575),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7575),
    [sym_operator_assignment] = STATE(7575),
    [sym_conditional] = STATE(7575),
    [sym_range] = STATE(7575),
    [sym_binary] = STATE(7575),
    [sym_unary] = STATE(7575),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4890] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7576),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7576),
    [sym_operator_assignment] = STATE(7576),
    [sym_conditional] = STATE(7576),
    [sym_range] = STATE(7576),
    [sym_binary] = STATE(7576),
    [sym_unary] = STATE(7576),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4891] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7577),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7577),
    [sym_operator_assignment] = STATE(7577),
    [sym_conditional] = STATE(7577),
    [sym_range] = STATE(7577),
    [sym_binary] = STATE(7577),
    [sym_unary] = STATE(7577),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4892] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7578),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7578),
    [sym_operator_assignment] = STATE(7578),
    [sym_conditional] = STATE(7578),
    [sym_range] = STATE(7578),
    [sym_binary] = STATE(7578),
    [sym_unary] = STATE(7578),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4893] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7579),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7579),
    [sym_operator_assignment] = STATE(7579),
    [sym_conditional] = STATE(7579),
    [sym_range] = STATE(7579),
    [sym_binary] = STATE(7579),
    [sym_unary] = STATE(7579),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4894] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7580),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7580),
    [sym_operator_assignment] = STATE(7580),
    [sym_conditional] = STATE(7580),
    [sym_range] = STATE(7580),
    [sym_binary] = STATE(7580),
    [sym_unary] = STATE(7580),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4895] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7581),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7581),
    [sym_operator_assignment] = STATE(7581),
    [sym_conditional] = STATE(7581),
    [sym_range] = STATE(7581),
    [sym_binary] = STATE(7581),
    [sym_unary] = STATE(7581),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4896] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7582),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7582),
    [sym_operator_assignment] = STATE(7582),
    [sym_conditional] = STATE(7582),
    [sym_range] = STATE(7582),
    [sym_binary] = STATE(7582),
    [sym_unary] = STATE(7582),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4897] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7583),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7583),
    [sym_operator_assignment] = STATE(7583),
    [sym_conditional] = STATE(7583),
    [sym_range] = STATE(7583),
    [sym_binary] = STATE(7583),
    [sym_unary] = STATE(7583),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4898] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7584),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7584),
    [sym_operator_assignment] = STATE(7584),
    [sym_conditional] = STATE(7584),
    [sym_range] = STATE(7584),
    [sym_binary] = STATE(7584),
    [sym_unary] = STATE(7584),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4899] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7585),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7585),
    [sym_operator_assignment] = STATE(7585),
    [sym_conditional] = STATE(7585),
    [sym_range] = STATE(7585),
    [sym_binary] = STATE(7585),
    [sym_unary] = STATE(7585),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4900] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7586),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7586),
    [sym_operator_assignment] = STATE(7586),
    [sym_conditional] = STATE(7586),
    [sym_range] = STATE(7586),
    [sym_binary] = STATE(7586),
    [sym_unary] = STATE(7586),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4901] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7595),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(7595),
    [sym_operator_assignment] = STATE(7595),
    [sym_conditional] = STATE(7595),
    [sym_range] = STATE(7595),
    [sym_binary] = STATE(7595),
    [sym_unary] = STATE(7595),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4902] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7599),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(7599),
    [sym_operator_assignment] = STATE(7599),
    [sym_conditional] = STATE(7599),
    [sym_range] = STATE(7599),
    [sym_binary] = STATE(7599),
    [sym_unary] = STATE(7599),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4903] = {
    [anon_sym_COLON] = ACTIONS(10761),
    [sym_comment] = ACTIONS(87),
  },
  [4904] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(7601),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(7601),
    [sym_operator_assignment] = STATE(7601),
    [sym_conditional] = STATE(7601),
    [sym_range] = STATE(7601),
    [sym_binary] = STATE(7601),
    [sym_unary] = STATE(7601),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [4905] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10763),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4906] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(10765),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [4907] = {
    [sym_heredoc_body] = STATE(7603),
    [aux_sym_call_repeat1] = STATE(7603),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4908] = {
    [sym_heredoc_body] = STATE(7603),
    [aux_sym_call_repeat1] = STATE(7603),
    [aux_sym_argument_list_repeat1] = STATE(7605),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [4909] = {
    [sym_string] = STATE(2105),
    [aux_sym_chained_string_repeat1] = STATE(2105),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10769),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [4910] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_splat_argument] = STATE(7607),
    [sym_assignment] = STATE(7606),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(7607),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4911] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7608),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(7608),
    [sym_operator_assignment] = STATE(7608),
    [sym_conditional] = STATE(7608),
    [sym_range] = STATE(7608),
    [sym_binary] = STATE(7608),
    [sym_unary] = STATE(7608),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4912] = {
    [sym_string] = STATE(7609),
    [aux_sym_chained_string_repeat1] = STATE(7609),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [4913] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(7551),
    [anon_sym_or] = ACTIONS(7551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [4914] = {
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7850),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_EQ] = ACTIONS(7850),
    [anon_sym_in] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
  },
  [4915] = {
    [anon_sym_RPAREN] = ACTIONS(10771),
    [sym_comment] = ACTIONS(87),
  },
  [4916] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(7551),
    [anon_sym_or] = ACTIONS(7551),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [4917] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(3158),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_EQ] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [4918] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10773),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [4919] = {
    [sym_heredoc_body] = STATE(4919),
    [aux_sym_call_repeat1] = STATE(4919),
    [sym__heredoc_body_start2] = ACTIONS(10775),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [4920] = {
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_EQ] = ACTIONS(7899),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [4921] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(815),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(7612),
    [sym_splat_argument] = STATE(7612),
    [sym_hash_splat_argument] = STATE(7612),
    [sym_block_argument] = STATE(7612),
    [sym_assignment] = STATE(815),
    [sym_operator_assignment] = STATE(815),
    [sym_conditional] = STATE(815),
    [sym_range] = STATE(815),
    [sym_binary] = STATE(815),
    [sym_unary] = STATE(815),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(819),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7612),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1463),
    [sym__splat_star2] = ACTIONS(1465),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(1467),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1469),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1475),
    [sym_identifier] = ACTIONS(1475),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4922] = {
    [sym_heredoc_body] = STATE(4919),
    [aux_sym_call_repeat1] = STATE(4919),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [4923] = {
    [aux_sym_argument_list_repeat1] = STATE(4923),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(10778),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [4924] = {
    [anon_sym_DOT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [sym_comment] = ACTIONS(87),
  },
  [4925] = {
    [sym_elsif] = STATE(7614),
    [sym_else] = STATE(7614),
    [sym__if_tail] = STATE(7614),
    [anon_sym_end] = ACTIONS(10781),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [4926] = {
    [anon_sym_end] = ACTIONS(10781),
    [sym_comment] = ACTIONS(87),
  },
  [4927] = {
    [sym__statements] = STATE(7615),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(7614),
    [sym_else] = STATE(7614),
    [sym__if_tail] = STATE(7614),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10783),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4928] = {
    [anon_sym_DOT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(87),
  },
  [4929] = {
    [sym_else] = STATE(7617),
    [anon_sym_end] = ACTIONS(10785),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [4930] = {
    [anon_sym_end] = ACTIONS(10785),
    [sym_comment] = ACTIONS(87),
  },
  [4931] = {
    [anon_sym_DOT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [4932] = {
    [anon_sym_end] = ACTIONS(10787),
    [sym_comment] = ACTIONS(87),
  },
  [4933] = {
    [anon_sym_DOT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [sym_comment] = ACTIONS(87),
  },
  [4934] = {
    [anon_sym_end] = ACTIONS(10789),
    [sym_comment] = ACTIONS(87),
  },
  [4935] = {
    [sym__statements] = STATE(7621),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10791),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4936] = {
    [anon_sym_end] = ACTIONS(10793),
    [sym_comment] = ACTIONS(87),
  },
  [4937] = {
    [sym_when] = STATE(7623),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [4938] = {
    [anon_sym_DOT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [sym_comment] = ACTIONS(87),
  },
  [4939] = {
    [anon_sym_DOT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [sym_comment] = ACTIONS(87),
  },
  [4940] = {
    [anon_sym_end] = ACTIONS(10795),
    [sym_comment] = ACTIONS(87),
  },
  [4941] = {
    [sym_ensure] = STATE(7625),
    [anon_sym_end] = ACTIONS(10795),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [4942] = {
    [anon_sym_DOT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [sym_comment] = ACTIONS(87),
  },
  [4943] = {
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9486),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9486),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_EQ] = ACTIONS(9486),
    [anon_sym_in] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [4944] = {
    [anon_sym_RBRACE] = ACTIONS(10797),
    [sym_comment] = ACTIONS(87),
  },
  [4945] = {
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9506),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9506),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_EQ] = ACTIONS(9506),
    [anon_sym_in] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [4946] = {
    [anon_sym_end] = ACTIONS(10799),
    [sym_comment] = ACTIONS(87),
  },
  [4947] = {
    [sym__statements] = STATE(7628),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10801),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4948] = {
    [sym__statements] = STATE(7628),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7629),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7629),
    [sym__line_break2] = ACTIONS(10803),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10801),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4949] = {
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4242),
    [anon_sym_EQ] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4242),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [4950] = {
    [sym_heredoc_body] = STATE(7631),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10805),
    [sym_comment] = ACTIONS(87),
  },
  [4951] = {
    [anon_sym_RPAREN] = ACTIONS(10805),
    [sym_comment] = ACTIONS(87),
  },
  [4952] = {
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9751),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9751),
    [anon_sym_EQ] = ACTIONS(9751),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_in] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9751),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [4953] = {
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9758),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_EQ] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [sym_comment] = ACTIONS(87),
  },
  [4954] = {
    [anon_sym_RBRACK] = ACTIONS(10807),
    [sym_comment] = ACTIONS(87),
  },
  [4955] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [4956] = {
    [sym__string_end2] = ACTIONS(10809),
    [sym_comment] = ACTIONS(87),
  },
  [4957] = {
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_STAR_STAR] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(891),
    [anon_sym_AMP_AMP] = ACTIONS(891),
    [anon_sym_LT_LT] = ACTIONS(891),
    [anon_sym_GT_GT] = ACTIONS(891),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_PLUS] = ACTIONS(891),
    [anon_sym_SLASH] = ACTIONS(891),
    [anon_sym_PERCENT] = ACTIONS(891),
    [sym_comment] = ACTIONS(87),
  },
  [4958] = {
    [sym__string_end2] = ACTIONS(10811),
    [sym_comment] = ACTIONS(87),
  },
  [4959] = {
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_STAR_STAR] = ACTIONS(897),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(897),
    [anon_sym_AMP_AMP] = ACTIONS(897),
    [anon_sym_LT_LT] = ACTIONS(897),
    [anon_sym_GT_GT] = ACTIONS(897),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(897),
    [anon_sym_PLUS] = ACTIONS(897),
    [anon_sym_SLASH] = ACTIONS(897),
    [anon_sym_PERCENT] = ACTIONS(897),
    [sym_comment] = ACTIONS(87),
  },
  [4960] = {
    [sym__string_end2] = ACTIONS(10813),
    [sym_comment] = ACTIONS(87),
  },
  [4961] = {
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_STAR_STAR] = ACTIONS(903),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(903),
    [anon_sym_AMP_AMP] = ACTIONS(903),
    [anon_sym_LT_LT] = ACTIONS(903),
    [anon_sym_GT_GT] = ACTIONS(903),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(903),
    [anon_sym_PLUS] = ACTIONS(903),
    [anon_sym_SLASH] = ACTIONS(903),
    [anon_sym_PERCENT] = ACTIONS(903),
    [sym_comment] = ACTIONS(87),
  },
  [4962] = {
    [sym__string_end2] = ACTIONS(10815),
    [sym_comment] = ACTIONS(87),
  },
  [4963] = {
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_STAR_STAR] = ACTIONS(909),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(909),
    [anon_sym_AMP_AMP] = ACTIONS(909),
    [anon_sym_LT_LT] = ACTIONS(909),
    [anon_sym_GT_GT] = ACTIONS(909),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(909),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_SLASH] = ACTIONS(909),
    [anon_sym_PERCENT] = ACTIONS(909),
    [sym_comment] = ACTIONS(87),
  },
  [4964] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(7639),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10817),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10819),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4965] = {
    [aux_sym_string_array_repeat1] = STATE(7642),
    [sym__string_end2] = ACTIONS(10821),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10823),
  },
  [4966] = {
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_STAR_STAR] = ACTIONS(927),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(927),
    [anon_sym_AMP_AMP] = ACTIONS(927),
    [anon_sym_LT_LT] = ACTIONS(927),
    [anon_sym_GT_GT] = ACTIONS(927),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(927),
    [anon_sym_PLUS] = ACTIONS(927),
    [anon_sym_SLASH] = ACTIONS(927),
    [anon_sym_PERCENT] = ACTIONS(927),
    [sym_comment] = ACTIONS(87),
  },
  [4967] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(7645),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(10825),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10827),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [4968] = {
    [aux_sym_symbol_array_repeat1] = STATE(7648),
    [sym__string_end2] = ACTIONS(10829),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(10831),
  },
  [4969] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [4970] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [4971] = {
    [anon_sym_RBRACE] = ACTIONS(10833),
    [sym_comment] = ACTIONS(87),
  },
  [4972] = {
    [sym_heredoc_body] = STATE(7650),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(10833),
    [sym_comment] = ACTIONS(87),
  },
  [4973] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7651),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(7651),
    [sym_operator_assignment] = STATE(7651),
    [sym_conditional] = STATE(7651),
    [sym_range] = STATE(7651),
    [sym_binary] = STATE(7651),
    [sym_unary] = STATE(7651),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [4974] = {
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_STAR_STAR] = ACTIONS(1283),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1283),
    [anon_sym_AMP_AMP] = ACTIONS(1283),
    [anon_sym_LT_LT] = ACTIONS(1283),
    [anon_sym_GT_GT] = ACTIONS(1283),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1283),
    [anon_sym_PLUS] = ACTIONS(1283),
    [anon_sym_SLASH] = ACTIONS(1283),
    [anon_sym_PERCENT] = ACTIONS(1283),
    [sym_comment] = ACTIONS(87),
  },
  [4975] = {
    [anon_sym_DOT] = ACTIONS(10835),
    [anon_sym_COLON_COLON] = ACTIONS(10835),
    [sym_comment] = ACTIONS(87),
  },
  [4976] = {
    [sym_method_parameters] = STATE(7653),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(7653),
    [sym__terminator] = STATE(7653),
    [sym__line_break2] = ACTIONS(10837),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(10837),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [4977] = {
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_STAR_STAR] = ACTIONS(1301),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1301),
    [anon_sym_AMP_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(1301),
    [anon_sym_GT_GT] = ACTIONS(1301),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(1301),
    [anon_sym_PERCENT] = ACTIONS(1301),
    [sym_comment] = ACTIONS(87),
  },
  [4978] = {
    [anon_sym_RPAREN] = ACTIONS(10839),
    [sym_comment] = ACTIONS(87),
  },
  [4979] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7655),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(7655),
    [sym_operator_assignment] = STATE(7655),
    [sym_conditional] = STATE(7655),
    [sym_range] = STATE(7655),
    [sym_binary] = STATE(7655),
    [sym_unary] = STATE(7655),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [4980] = {
    [sym_superclass] = STATE(7656),
    [sym_heredoc_body] = STATE(7657),
    [sym__terminator] = STATE(7657),
    [sym__line_break2] = ACTIONS(10841),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(10841),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4981] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(7656),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7657),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(7657),
    [sym__line_break2] = ACTIONS(10841),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(10841),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4982] = {
    [sym_heredoc_body] = STATE(7659),
    [sym__terminator] = STATE(7659),
    [sym__line_break2] = ACTIONS(10843),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(10843),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(10845),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4983] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7659),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(7659),
    [sym__line_break2] = ACTIONS(10843),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(10843),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(10845),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4984] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7660),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7660),
    [sym_operator_assignment] = STATE(7660),
    [sym_conditional] = STATE(7660),
    [sym_range] = STATE(7660),
    [sym_binary] = STATE(7660),
    [sym_unary] = STATE(7660),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4985] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7661),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7661),
    [sym_operator_assignment] = STATE(7661),
    [sym_conditional] = STATE(7661),
    [sym_range] = STATE(7661),
    [sym_binary] = STATE(7661),
    [sym_unary] = STATE(7661),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4986] = {
    [anon_sym_COLON] = ACTIONS(10847),
    [sym_comment] = ACTIONS(87),
  },
  [4987] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7663),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7663),
    [sym_operator_assignment] = STATE(7663),
    [sym_conditional] = STATE(7663),
    [sym_range] = STATE(7663),
    [sym_binary] = STATE(7663),
    [sym_unary] = STATE(7663),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [4988] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(7665),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7666),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(10849),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [4989] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10851),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [4990] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(10853),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [4991] = {
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_STAR_STAR] = ACTIONS(1699),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1699),
    [anon_sym_AMP_AMP] = ACTIONS(1699),
    [anon_sym_LT_LT] = ACTIONS(1699),
    [anon_sym_GT_GT] = ACTIONS(1699),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1699),
    [anon_sym_PLUS] = ACTIONS(1699),
    [anon_sym_SLASH] = ACTIONS(1699),
    [anon_sym_PERCENT] = ACTIONS(1699),
    [sym_comment] = ACTIONS(87),
  },
  [4992] = {
    [sym_heredoc_body] = STATE(7669),
    [aux_sym_call_repeat1] = STATE(7669),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4993] = {
    [sym_heredoc_body] = STATE(7669),
    [aux_sym_call_repeat1] = STATE(7669),
    [aux_sym_argument_list_repeat1] = STATE(7671),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10857),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [4994] = {
    [sym_string] = STATE(2494),
    [aux_sym_chained_string_repeat1] = STATE(2494),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10859),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [4995] = {
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_STAR_STAR] = ACTIONS(1719),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1719),
    [anon_sym_AMP_AMP] = ACTIONS(1719),
    [anon_sym_LT_LT] = ACTIONS(1719),
    [anon_sym_GT_GT] = ACTIONS(1719),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1719),
    [anon_sym_PLUS] = ACTIONS(1719),
    [anon_sym_SLASH] = ACTIONS(1719),
    [anon_sym_PERCENT] = ACTIONS(1719),
    [sym_comment] = ACTIONS(87),
  },
  [4996] = {
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_STAR_STAR] = ACTIONS(1723),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1723),
    [anon_sym_AMP_AMP] = ACTIONS(1723),
    [anon_sym_LT_LT] = ACTIONS(1723),
    [anon_sym_GT_GT] = ACTIONS(1723),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1723),
    [anon_sym_PLUS] = ACTIONS(1723),
    [anon_sym_SLASH] = ACTIONS(1723),
    [anon_sym_PERCENT] = ACTIONS(1723),
    [sym_comment] = ACTIONS(87),
  },
  [4997] = {
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_STAR_STAR] = ACTIONS(1727),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1727),
    [anon_sym_AMP_AMP] = ACTIONS(1727),
    [anon_sym_LT_LT] = ACTIONS(1727),
    [anon_sym_GT_GT] = ACTIONS(1727),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1727),
    [anon_sym_PLUS] = ACTIONS(1727),
    [anon_sym_SLASH] = ACTIONS(1727),
    [anon_sym_PERCENT] = ACTIONS(1727),
    [sym_comment] = ACTIONS(87),
  },
  [4998] = {
    [sym__then] = STATE(7672),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(10861),
    [sym_comment] = ACTIONS(87),
  },
  [4999] = {
    [sym__then] = STATE(7673),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(10863),
    [sym_comment] = ACTIONS(87),
  },
  [5000] = {
    [sym__do] = STATE(7674),
    [sym_heredoc_body] = STATE(7674),
    [sym__terminator] = STATE(7674),
    [sym__line_break2] = ACTIONS(10865),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(10865),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(10865),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [5001] = {
    [sym__do] = STATE(7675),
    [sym_heredoc_body] = STATE(7675),
    [sym__terminator] = STATE(7675),
    [sym__line_break2] = ACTIONS(10867),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(10867),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(10867),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [5002] = {
    [sym_in] = STATE(7676),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [5003] = {
    [sym_heredoc_body] = STATE(7677),
    [sym__terminator] = STATE(7677),
    [sym__line_break2] = ACTIONS(10869),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(10869),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [5004] = {
    [sym_when] = STATE(7678),
    [aux_sym_case_repeat1] = STATE(7679),
    [anon_sym_SEMI] = ACTIONS(10871),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [5005] = {
    [sym_else] = STATE(7681),
    [sym_ensure] = STATE(7682),
    [sym_rescue] = STATE(7683),
    [anon_sym_end] = ACTIONS(10873),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [5006] = {
    [sym_ensure] = STATE(7682),
    [anon_sym_end] = ACTIONS(10873),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [5007] = {
    [anon_sym_end] = ACTIONS(10873),
    [sym_comment] = ACTIONS(87),
  },
  [5008] = {
    [sym_else] = STATE(7681),
    [sym_ensure] = STATE(7682),
    [anon_sym_end] = ACTIONS(10873),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [5009] = {
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_STAR_STAR] = ACTIONS(2219),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2219),
    [anon_sym_AMP_AMP] = ACTIONS(2219),
    [anon_sym_LT_LT] = ACTIONS(2219),
    [anon_sym_GT_GT] = ACTIONS(2219),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2219),
    [anon_sym_PLUS] = ACTIONS(2219),
    [anon_sym_SLASH] = ACTIONS(2219),
    [anon_sym_PERCENT] = ACTIONS(2219),
    [sym_comment] = ACTIONS(87),
  },
  [5010] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(7684),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10875),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5011] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5012] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [5013] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(2293),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5014] = {
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_STAR_STAR] = ACTIONS(2307),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2307),
    [anon_sym_AMP_AMP] = ACTIONS(2307),
    [anon_sym_LT_LT] = ACTIONS(2307),
    [anon_sym_GT_GT] = ACTIONS(2307),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2307),
    [anon_sym_PLUS] = ACTIONS(2307),
    [anon_sym_SLASH] = ACTIONS(2307),
    [anon_sym_PERCENT] = ACTIONS(2307),
    [sym_comment] = ACTIONS(87),
  },
  [5015] = {
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_STAR_STAR] = ACTIONS(2391),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2391),
    [anon_sym_AMP_AMP] = ACTIONS(2391),
    [anon_sym_LT_LT] = ACTIONS(2391),
    [anon_sym_GT_GT] = ACTIONS(2391),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2391),
    [anon_sym_PLUS] = ACTIONS(2391),
    [anon_sym_SLASH] = ACTIONS(2391),
    [anon_sym_PERCENT] = ACTIONS(2391),
    [sym_comment] = ACTIONS(87),
  },
  [5016] = {
    [sym_heredoc_body] = STATE(7686),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(10877),
    [sym_comment] = ACTIONS(87),
  },
  [5017] = {
    [anon_sym_RBRACK] = ACTIONS(10877),
    [sym_comment] = ACTIONS(87),
  },
  [5018] = {
    [sym__statements] = STATE(7688),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(7689),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10879),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5019] = {
    [sym__statements] = STATE(7691),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(7692),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7693),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7693),
    [sym__line_break2] = ACTIONS(10881),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10883),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5020] = {
    [sym_do_block] = STATE(7694),
    [sym_block] = STATE(7694),
    [anon_sym_LBRACE] = ACTIONS(7669),
    [anon_sym_do] = ACTIONS(10885),
    [sym_comment] = ACTIONS(87),
  },
  [5021] = {
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_STAR_STAR] = ACTIONS(2537),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2537),
    [anon_sym_AMP_AMP] = ACTIONS(2537),
    [anon_sym_LT_LT] = ACTIONS(2537),
    [anon_sym_GT_GT] = ACTIONS(2537),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2537),
    [anon_sym_PLUS] = ACTIONS(2537),
    [anon_sym_SLASH] = ACTIONS(2537),
    [anon_sym_PERCENT] = ACTIONS(2537),
    [sym_comment] = ACTIONS(87),
  },
  [5022] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7695),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7695),
    [sym_operator_assignment] = STATE(7695),
    [sym_conditional] = STATE(7695),
    [sym_range] = STATE(7695),
    [sym_binary] = STATE(7695),
    [sym_unary] = STATE(7695),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5023] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7696),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7696),
    [sym_operator_assignment] = STATE(7696),
    [sym_conditional] = STATE(7696),
    [sym_range] = STATE(7696),
    [sym_binary] = STATE(7696),
    [sym_unary] = STATE(7696),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5024] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7697),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7697),
    [sym_operator_assignment] = STATE(7697),
    [sym_conditional] = STATE(7697),
    [sym_range] = STATE(7697),
    [sym_binary] = STATE(7697),
    [sym_unary] = STATE(7697),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5025] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7698),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7698),
    [sym_operator_assignment] = STATE(7698),
    [sym_conditional] = STATE(7698),
    [sym_range] = STATE(7698),
    [sym_binary] = STATE(7698),
    [sym_unary] = STATE(7698),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5026] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7699),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7699),
    [sym_operator_assignment] = STATE(7699),
    [sym_conditional] = STATE(7699),
    [sym_range] = STATE(7699),
    [sym_binary] = STATE(7699),
    [sym_unary] = STATE(7699),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5027] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7700),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7700),
    [sym_operator_assignment] = STATE(7700),
    [sym_conditional] = STATE(7700),
    [sym_range] = STATE(7700),
    [sym_binary] = STATE(7700),
    [sym_unary] = STATE(7700),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5028] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7701),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7701),
    [sym_operator_assignment] = STATE(7701),
    [sym_conditional] = STATE(7701),
    [sym_range] = STATE(7701),
    [sym_binary] = STATE(7701),
    [sym_unary] = STATE(7701),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5029] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7702),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7702),
    [sym_operator_assignment] = STATE(7702),
    [sym_conditional] = STATE(7702),
    [sym_range] = STATE(7702),
    [sym_binary] = STATE(7702),
    [sym_unary] = STATE(7702),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5030] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7703),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7703),
    [sym_operator_assignment] = STATE(7703),
    [sym_conditional] = STATE(7703),
    [sym_range] = STATE(7703),
    [sym_binary] = STATE(7703),
    [sym_unary] = STATE(7703),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5031] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7704),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7704),
    [sym_operator_assignment] = STATE(7704),
    [sym_conditional] = STATE(7704),
    [sym_range] = STATE(7704),
    [sym_binary] = STATE(7704),
    [sym_unary] = STATE(7704),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5032] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7705),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7705),
    [sym_operator_assignment] = STATE(7705),
    [sym_conditional] = STATE(7705),
    [sym_range] = STATE(7705),
    [sym_binary] = STATE(7705),
    [sym_unary] = STATE(7705),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5033] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7706),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7706),
    [sym_operator_assignment] = STATE(7706),
    [sym_conditional] = STATE(7706),
    [sym_range] = STATE(7706),
    [sym_binary] = STATE(7706),
    [sym_unary] = STATE(7706),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5034] = {
    [sym__statements] = STATE(4374),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(4375),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(10887),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5035] = {
    [sym_do_block] = STATE(4397),
    [sym_block] = STATE(4397),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_unless] = ACTIONS(2773),
    [anon_sym_while] = ACTIONS(2773),
    [anon_sym_until] = ACTIONS(2773),
    [anon_sym_rescue] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_COLON2] = ACTIONS(2777),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [5036] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7708),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_splat_argument] = STATE(7710),
    [sym_assignment] = STATE(7708),
    [sym_operator_assignment] = STATE(7708),
    [sym_conditional] = STATE(7708),
    [sym_range] = STATE(7708),
    [sym_binary] = STATE(7708),
    [sym_unary] = STATE(7708),
    [sym_right_assignment_list] = STATE(7709),
    [sym__arg_or_splat_arg] = STATE(7710),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5037] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7711),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(7711),
    [sym_operator_assignment] = STATE(7711),
    [sym_conditional] = STATE(7711),
    [sym_range] = STATE(7711),
    [sym_binary] = STATE(7711),
    [sym_unary] = STATE(7711),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [5038] = {
    [sym_string] = STATE(7712),
    [aux_sym_chained_string_repeat1] = STATE(7712),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5039] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [5040] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5041] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5042] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7713),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(7713),
    [sym_operator_assignment] = STATE(7713),
    [sym_conditional] = STATE(7713),
    [sym_range] = STATE(7713),
    [sym_binary] = STATE(7713),
    [sym_unary] = STATE(7713),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5043] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5044] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7714),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(7714),
    [sym_operator_assignment] = STATE(7714),
    [sym_conditional] = STATE(7714),
    [sym_range] = STATE(7714),
    [sym_binary] = STATE(7714),
    [sym_unary] = STATE(7714),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5045] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5046] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7716),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10889),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5047] = {
    [sym_heredoc_body] = STATE(7717),
    [aux_sym_call_repeat1] = STATE(7717),
    [aux_sym_argument_list_repeat1] = STATE(7718),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7717),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5048] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5049] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5050] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5051] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5052] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5053] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5054] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(7691),
    [anon_sym_or] = ACTIONS(7691),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [5055] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10891),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5056] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5057] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5058] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5059] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5060] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5061] = {
    [sym_heredoc_body] = STATE(5061),
    [aux_sym_call_repeat1] = STATE(5061),
    [sym__heredoc_body_start2] = ACTIONS(10775),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5062] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(861),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(7612),
    [sym_splat_argument] = STATE(7612),
    [sym_hash_splat_argument] = STATE(7612),
    [sym_block_argument] = STATE(7612),
    [sym_assignment] = STATE(861),
    [sym_operator_assignment] = STATE(861),
    [sym_conditional] = STATE(861),
    [sym_range] = STATE(861),
    [sym_binary] = STATE(861),
    [sym_unary] = STATE(861),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(868),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7612),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1497),
    [sym__splat_star2] = ACTIONS(1499),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(1503),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1507),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1525),
    [sym_identifier] = ACTIONS(1525),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5063] = {
    [sym_heredoc_body] = STATE(5061),
    [aux_sym_call_repeat1] = STATE(5061),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_EQ] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5064] = {
    [aux_sym_argument_list_repeat1] = STATE(5064),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(10893),
    [anon_sym_EQ] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5065] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5066] = {
    [aux_sym_exceptions_repeat1] = STATE(7721),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5067] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [5068] = {
    [sym_string] = STATE(5068),
    [aux_sym_chained_string_repeat1] = STATE(5068),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5069] = {
    [sym__line_break2] = ACTIONS(10896),
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [ts_builtin_sym_end] = ACTIONS(10896),
    [anon_sym___END__] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10896),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_end] = ACTIONS(10896),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_when] = ACTIONS(10896),
    [anon_sym_elsif] = ACTIONS(10896),
    [anon_sym_else] = ACTIONS(10896),
    [anon_sym_then] = ACTIONS(10896),
    [anon_sym_ensure] = ACTIONS(10896),
    [anon_sym_EQ_GT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10896),
    [anon_sym_AMP_AMP] = ACTIONS(10896),
    [anon_sym_LT_LT] = ACTIONS(10896),
    [anon_sym_GT_GT] = ACTIONS(10896),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10896),
    [anon_sym_SLASH] = ACTIONS(10896),
    [anon_sym_PERCENT] = ACTIONS(10896),
    [sym_comment] = ACTIONS(87),
  },
  [5070] = {
    [sym__line_break2] = ACTIONS(10900),
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [ts_builtin_sym_end] = ACTIONS(10900),
    [anon_sym___END__] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10900),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(10900),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_when] = ACTIONS(10900),
    [anon_sym_elsif] = ACTIONS(10900),
    [anon_sym_else] = ACTIONS(10900),
    [anon_sym_then] = ACTIONS(10900),
    [anon_sym_ensure] = ACTIONS(10900),
    [anon_sym_EQ_GT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10900),
    [anon_sym_AMP_AMP] = ACTIONS(10900),
    [anon_sym_LT_LT] = ACTIONS(10900),
    [anon_sym_GT_GT] = ACTIONS(10900),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10900),
    [anon_sym_PLUS] = ACTIONS(10900),
    [anon_sym_SLASH] = ACTIONS(10900),
    [anon_sym_PERCENT] = ACTIONS(10900),
    [sym_comment] = ACTIONS(87),
  },
  [5071] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5072] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7722),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7722),
    [sym_operator_assignment] = STATE(7722),
    [sym_conditional] = STATE(7722),
    [sym_range] = STATE(7722),
    [sym_binary] = STATE(7722),
    [sym_unary] = STATE(7722),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5073] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7723),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7723),
    [sym_operator_assignment] = STATE(7723),
    [sym_conditional] = STATE(7723),
    [sym_range] = STATE(7723),
    [sym_binary] = STATE(7723),
    [sym_unary] = STATE(7723),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5074] = {
    [anon_sym_COLON] = ACTIONS(10904),
    [sym_comment] = ACTIONS(87),
  },
  [5075] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7725),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7725),
    [sym_operator_assignment] = STATE(7725),
    [sym_conditional] = STATE(7725),
    [sym_range] = STATE(7725),
    [sym_binary] = STATE(7725),
    [sym_unary] = STATE(7725),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5076] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(10906),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5077] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(10908),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5078] = {
    [sym_heredoc_body] = STATE(7727),
    [aux_sym_call_repeat1] = STATE(7727),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5079] = {
    [sym_heredoc_body] = STATE(7727),
    [aux_sym_call_repeat1] = STATE(7727),
    [aux_sym_argument_list_repeat1] = STATE(7729),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5080] = {
    [sym_string] = STATE(2548),
    [aux_sym_chained_string_repeat1] = STATE(2548),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(10912),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5081] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5082] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [5083] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7730),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7730),
    [sym_operator_assignment] = STATE(7730),
    [sym_conditional] = STATE(7730),
    [sym_range] = STATE(7730),
    [sym_binary] = STATE(7730),
    [sym_unary] = STATE(7730),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5084] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7731),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7731),
    [sym_operator_assignment] = STATE(7731),
    [sym_conditional] = STATE(7731),
    [sym_range] = STATE(7731),
    [sym_binary] = STATE(7731),
    [sym_unary] = STATE(7731),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5085] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7732),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7732),
    [sym_operator_assignment] = STATE(7732),
    [sym_conditional] = STATE(7732),
    [sym_range] = STATE(7732),
    [sym_binary] = STATE(7732),
    [sym_unary] = STATE(7732),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5086] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7733),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7733),
    [sym_operator_assignment] = STATE(7733),
    [sym_conditional] = STATE(7733),
    [sym_range] = STATE(7733),
    [sym_binary] = STATE(7733),
    [sym_unary] = STATE(7733),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5087] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7734),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7734),
    [sym_operator_assignment] = STATE(7734),
    [sym_conditional] = STATE(7734),
    [sym_range] = STATE(7734),
    [sym_binary] = STATE(7734),
    [sym_unary] = STATE(7734),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5088] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7735),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7735),
    [sym_operator_assignment] = STATE(7735),
    [sym_conditional] = STATE(7735),
    [sym_range] = STATE(7735),
    [sym_binary] = STATE(7735),
    [sym_unary] = STATE(7735),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5089] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7736),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7736),
    [sym_operator_assignment] = STATE(7736),
    [sym_conditional] = STATE(7736),
    [sym_range] = STATE(7736),
    [sym_binary] = STATE(7736),
    [sym_unary] = STATE(7736),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5090] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7737),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7737),
    [sym_operator_assignment] = STATE(7737),
    [sym_conditional] = STATE(7737),
    [sym_range] = STATE(7737),
    [sym_binary] = STATE(7737),
    [sym_unary] = STATE(7737),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5091] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7738),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7738),
    [sym_operator_assignment] = STATE(7738),
    [sym_conditional] = STATE(7738),
    [sym_range] = STATE(7738),
    [sym_binary] = STATE(7738),
    [sym_unary] = STATE(7738),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5092] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7739),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7739),
    [sym_operator_assignment] = STATE(7739),
    [sym_conditional] = STATE(7739),
    [sym_range] = STATE(7739),
    [sym_binary] = STATE(7739),
    [sym_unary] = STATE(7739),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5093] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7740),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7740),
    [sym_operator_assignment] = STATE(7740),
    [sym_conditional] = STATE(7740),
    [sym_range] = STATE(7740),
    [sym_binary] = STATE(7740),
    [sym_unary] = STATE(7740),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5094] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7741),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7741),
    [sym_operator_assignment] = STATE(7741),
    [sym_conditional] = STATE(7741),
    [sym_range] = STATE(7741),
    [sym_binary] = STATE(7741),
    [sym_unary] = STATE(7741),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5095] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7742),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_splat_argument] = STATE(7743),
    [sym_assignment] = STATE(7742),
    [sym_operator_assignment] = STATE(7742),
    [sym_conditional] = STATE(7742),
    [sym_range] = STATE(7742),
    [sym_binary] = STATE(7742),
    [sym_unary] = STATE(7742),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(7743),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5096] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7744),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(7744),
    [sym_operator_assignment] = STATE(7744),
    [sym_conditional] = STATE(7744),
    [sym_range] = STATE(7744),
    [sym_binary] = STATE(7744),
    [sym_unary] = STATE(7744),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5097] = {
    [sym_string] = STATE(7745),
    [aux_sym_chained_string_repeat1] = STATE(7745),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5098] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(7760),
    [anon_sym_or] = ACTIONS(7760),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [5099] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5100] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5101] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7746),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(7746),
    [sym_operator_assignment] = STATE(7746),
    [sym_conditional] = STATE(7746),
    [sym_range] = STATE(7746),
    [sym_binary] = STATE(7746),
    [sym_unary] = STATE(7746),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5102] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5103] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7747),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(7747),
    [sym_operator_assignment] = STATE(7747),
    [sym_conditional] = STATE(7747),
    [sym_range] = STATE(7747),
    [sym_binary] = STATE(7747),
    [sym_unary] = STATE(7747),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5104] = {
    [sym_heredoc_body] = STATE(7748),
    [aux_sym_call_repeat1] = STATE(7748),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5105] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7749),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10914),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5106] = {
    [sym_heredoc_body] = STATE(7750),
    [aux_sym_call_repeat1] = STATE(7750),
    [aux_sym_argument_list_repeat1] = STATE(7751),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7784),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5107] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5108] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5109] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5110] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5111] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5112] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5113] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(7760),
    [anon_sym_or] = ACTIONS(7760),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [5114] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10916),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5115] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5116] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5117] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5118] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5119] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5120] = {
    [sym_heredoc_body] = STATE(5120),
    [aux_sym_call_repeat1] = STATE(5120),
    [sym__heredoc_body_start2] = ACTIONS(10775),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5121] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(7612),
    [sym_splat_argument] = STATE(7612),
    [sym_hash_splat_argument] = STATE(7612),
    [sym_block_argument] = STATE(7612),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7612),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5122] = {
    [sym_heredoc_body] = STATE(5120),
    [aux_sym_call_repeat1] = STATE(5120),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5123] = {
    [aux_sym_argument_list_repeat1] = STATE(5123),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(10918),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5124] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5125] = {
    [aux_sym_exceptions_repeat1] = STATE(7754),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5126] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [5127] = {
    [sym_string] = STATE(5127),
    [aux_sym_chained_string_repeat1] = STATE(5127),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5128] = {
    [sym_heredoc_body] = STATE(7755),
    [aux_sym_call_repeat1] = STATE(7755),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5129] = {
    [sym_heredoc_body] = STATE(7756),
    [aux_sym_call_repeat1] = STATE(7756),
    [aux_sym_argument_list_repeat1] = STATE(2685),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [ts_builtin_sym_end] = ACTIONS(4346),
    [anon_sym___END__] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(1709),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5130] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5131] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5132] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5133] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5134] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5135] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5136] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10921),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5137] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5138] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5139] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5140] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5141] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5142] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(5104),
    [anon_sym___END__] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5143] = {
    [aux_sym_exceptions_repeat1] = STATE(7759),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5144] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [5145] = {
    [sym_string] = STATE(5145),
    [aux_sym_chained_string_repeat1] = STATE(5145),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [ts_builtin_sym_end] = ACTIONS(6252),
    [anon_sym___END__] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5146] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(6749),
    [anon_sym___END__] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [5147] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(6969),
    [anon_sym___END__] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [5148] = {
    [sym_heredoc_body] = STATE(5148),
    [aux_sym_call_repeat1] = STATE(5148),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [ts_builtin_sym_end] = ACTIONS(7888),
    [anon_sym___END__] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5149] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(921),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(921),
    [sym_operator_assignment] = STATE(921),
    [sym_conditional] = STATE(921),
    [sym_range] = STATE(921),
    [sym_binary] = STATE(921),
    [sym_unary] = STATE(921),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(924),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1597),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [sym__identifier_hash_key2] = ACTIONS(1601),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7794),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(1603),
    [sym_identifier] = ACTIONS(1603),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5150] = {
    [sym_heredoc_body] = STATE(5148),
    [aux_sym_call_repeat1] = STATE(5148),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [ts_builtin_sym_end] = ACTIONS(7903),
    [anon_sym___END__] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5151] = {
    [aux_sym_argument_list_repeat1] = STATE(5151),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10923),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5152] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5153] = {
    [sym_heredoc_body] = STATE(7760),
    [aux_sym_call_repeat1] = STATE(7760),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5154] = {
    [sym_heredoc_body] = STATE(7760),
    [aux_sym_call_repeat1] = STATE(7760),
    [aux_sym_argument_list_repeat1] = STATE(7761),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(7158),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5155] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5156] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [5157] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7762),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7762),
    [sym_operator_assignment] = STATE(7762),
    [sym_conditional] = STATE(7762),
    [sym_range] = STATE(7762),
    [sym_binary] = STATE(7762),
    [sym_unary] = STATE(7762),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5158] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7763),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7763),
    [sym_operator_assignment] = STATE(7763),
    [sym_conditional] = STATE(7763),
    [sym_range] = STATE(7763),
    [sym_binary] = STATE(7763),
    [sym_unary] = STATE(7763),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5159] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7764),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7764),
    [sym_operator_assignment] = STATE(7764),
    [sym_conditional] = STATE(7764),
    [sym_range] = STATE(7764),
    [sym_binary] = STATE(7764),
    [sym_unary] = STATE(7764),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5160] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7765),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7765),
    [sym_operator_assignment] = STATE(7765),
    [sym_conditional] = STATE(7765),
    [sym_range] = STATE(7765),
    [sym_binary] = STATE(7765),
    [sym_unary] = STATE(7765),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5161] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7766),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7766),
    [sym_operator_assignment] = STATE(7766),
    [sym_conditional] = STATE(7766),
    [sym_range] = STATE(7766),
    [sym_binary] = STATE(7766),
    [sym_unary] = STATE(7766),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5162] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7767),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7767),
    [sym_operator_assignment] = STATE(7767),
    [sym_conditional] = STATE(7767),
    [sym_range] = STATE(7767),
    [sym_binary] = STATE(7767),
    [sym_unary] = STATE(7767),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5163] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7768),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7768),
    [sym_operator_assignment] = STATE(7768),
    [sym_conditional] = STATE(7768),
    [sym_range] = STATE(7768),
    [sym_binary] = STATE(7768),
    [sym_unary] = STATE(7768),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5164] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7769),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7769),
    [sym_operator_assignment] = STATE(7769),
    [sym_conditional] = STATE(7769),
    [sym_range] = STATE(7769),
    [sym_binary] = STATE(7769),
    [sym_unary] = STATE(7769),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5165] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7770),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7770),
    [sym_operator_assignment] = STATE(7770),
    [sym_conditional] = STATE(7770),
    [sym_range] = STATE(7770),
    [sym_binary] = STATE(7770),
    [sym_unary] = STATE(7770),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5166] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7771),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7771),
    [sym_operator_assignment] = STATE(7771),
    [sym_conditional] = STATE(7771),
    [sym_range] = STATE(7771),
    [sym_binary] = STATE(7771),
    [sym_unary] = STATE(7771),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5167] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7772),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7772),
    [sym_operator_assignment] = STATE(7772),
    [sym_conditional] = STATE(7772),
    [sym_range] = STATE(7772),
    [sym_binary] = STATE(7772),
    [sym_unary] = STATE(7772),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5168] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7773),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7773),
    [sym_operator_assignment] = STATE(7773),
    [sym_conditional] = STATE(7773),
    [sym_range] = STATE(7773),
    [sym_binary] = STATE(7773),
    [sym_unary] = STATE(7773),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5169] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7775),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_splat_argument] = STATE(7776),
    [sym_assignment] = STATE(7775),
    [sym_operator_assignment] = STATE(7775),
    [sym_conditional] = STATE(7775),
    [sym_range] = STATE(7775),
    [sym_binary] = STATE(7775),
    [sym_unary] = STATE(7775),
    [sym_right_assignment_list] = STATE(3650),
    [sym__arg_or_splat_arg] = STATE(7776),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(10926),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5170] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7777),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(7777),
    [sym_operator_assignment] = STATE(7777),
    [sym_conditional] = STATE(7777),
    [sym_range] = STATE(7777),
    [sym_binary] = STATE(7777),
    [sym_unary] = STATE(7777),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5171] = {
    [sym_string] = STATE(7778),
    [aux_sym_chained_string_repeat1] = STATE(7778),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5172] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [5173] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [5174] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [5175] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7779),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7779),
    [sym_operator_assignment] = STATE(7779),
    [sym_conditional] = STATE(7779),
    [sym_range] = STATE(7779),
    [sym_binary] = STATE(7779),
    [sym_unary] = STATE(7779),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5176] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [5177] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7780),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(7780),
    [sym_operator_assignment] = STATE(7780),
    [sym_conditional] = STATE(7780),
    [sym_range] = STATE(7780),
    [sym_binary] = STATE(7780),
    [sym_unary] = STATE(7780),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5178] = {
    [sym_heredoc_body] = STATE(7781),
    [aux_sym_call_repeat1] = STATE(7781),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5179] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(7782),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10928),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5180] = {
    [sym_heredoc_body] = STATE(7783),
    [aux_sym_call_repeat1] = STATE(7783),
    [aux_sym_argument_list_repeat1] = STATE(7784),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7838),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5181] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5182] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5183] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5184] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5185] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5186] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5187] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(7814),
    [anon_sym_or] = ACTIONS(7814),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [5188] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10930),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5189] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5190] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5191] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5192] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5193] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5194] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [5195] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [5196] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7786),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7786),
    [sym_operator_assignment] = STATE(7786),
    [sym_conditional] = STATE(7786),
    [sym_range] = STATE(7786),
    [sym_binary] = STATE(7786),
    [sym_unary] = STATE(7786),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5197] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [5198] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7787),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(7787),
    [sym_operator_assignment] = STATE(7787),
    [sym_conditional] = STATE(7787),
    [sym_range] = STATE(7787),
    [sym_binary] = STATE(7787),
    [sym_unary] = STATE(7787),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5199] = {
    [sym_heredoc_body] = STATE(7788),
    [aux_sym_call_repeat1] = STATE(7788),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5200] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(7789),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10932),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5201] = {
    [sym_heredoc_body] = STATE(7790),
    [aux_sym_call_repeat1] = STATE(7790),
    [aux_sym_argument_list_repeat1] = STATE(7791),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7846),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5202] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [ts_builtin_sym_end] = ACTIONS(10934),
    [anon_sym___END__] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10934),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_end] = ACTIONS(10934),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_when] = ACTIONS(10934),
    [anon_sym_elsif] = ACTIONS(10934),
    [anon_sym_else] = ACTIONS(10934),
    [anon_sym_then] = ACTIONS(10934),
    [anon_sym_ensure] = ACTIONS(10934),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10934),
    [anon_sym_AMP_AMP] = ACTIONS(10934),
    [anon_sym_LT_LT] = ACTIONS(10934),
    [anon_sym_GT_GT] = ACTIONS(10934),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10934),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_SLASH] = ACTIONS(10934),
    [anon_sym_PERCENT] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
  },
  [5203] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(6457),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(9465),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(9465),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5204] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7792),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(7792),
    [sym_operator_assignment] = STATE(7792),
    [sym_conditional] = STATE(7792),
    [sym_range] = STATE(7792),
    [sym_binary] = STATE(7792),
    [sym_unary] = STATE(7792),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5205] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5206] = {
    [aux_sym_exceptions_repeat1] = STATE(7794),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5207] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [5208] = {
    [sym_string] = STATE(5208),
    [aux_sym_chained_string_repeat1] = STATE(5208),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5209] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7795),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_assignment] = STATE(7795),
    [sym_operator_assignment] = STATE(7795),
    [sym_conditional] = STATE(7795),
    [sym_range] = STATE(7795),
    [sym_binary] = STATE(7795),
    [sym_unary] = STATE(7795),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5210] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [ts_builtin_sym_end] = ACTIONS(4242),
    [anon_sym___END__] = ACTIONS(4244),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_end] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_rescue] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_when] = ACTIONS(4244),
    [anon_sym_elsif] = ACTIONS(4244),
    [anon_sym_else] = ACTIONS(4244),
    [anon_sym_then] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_ensure] = ACTIONS(4244),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [5211] = {
    [sym_heredoc_body] = STATE(7797),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(10938),
    [sym_comment] = ACTIONS(87),
  },
  [5212] = {
    [anon_sym_RPAREN] = ACTIONS(10938),
    [sym_comment] = ACTIONS(87),
  },
  [5213] = {
    [sym__line_break2] = ACTIONS(9751),
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym__heredoc_body_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [ts_builtin_sym_end] = ACTIONS(9751),
    [anon_sym___END__] = ACTIONS(9753),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_end] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_rescue] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_when] = ACTIONS(9753),
    [anon_sym_elsif] = ACTIONS(9753),
    [anon_sym_else] = ACTIONS(9753),
    [anon_sym_then] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_ensure] = ACTIONS(9753),
    [anon_sym_EQ_GT] = ACTIONS(9751),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [5214] = {
    [sym__line_break2] = ACTIONS(9758),
    [sym__heredoc_body_start2] = ACTIONS(9758),
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [ts_builtin_sym_end] = ACTIONS(9758),
    [anon_sym___END__] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_end] = ACTIONS(9758),
    [anon_sym_if] = ACTIONS(9758),
    [anon_sym_unless] = ACTIONS(9758),
    [anon_sym_while] = ACTIONS(9758),
    [anon_sym_until] = ACTIONS(9758),
    [anon_sym_rescue] = ACTIONS(9758),
    [anon_sym_do] = ACTIONS(9758),
    [anon_sym_when] = ACTIONS(9758),
    [anon_sym_elsif] = ACTIONS(9758),
    [anon_sym_else] = ACTIONS(9758),
    [anon_sym_then] = ACTIONS(9758),
    [anon_sym_ensure] = ACTIONS(9758),
    [anon_sym_EQ_GT] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [5215] = {
    [anon_sym_RBRACK] = ACTIONS(10940),
    [sym_comment] = ACTIONS(87),
  },
  [5216] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(6749),
    [anon_sym___END__] = ACTIONS(6749),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [5217] = {
    [sym__line_break2] = ACTIONS(9486),
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [ts_builtin_sym_end] = ACTIONS(9486),
    [anon_sym___END__] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_end] = ACTIONS(9486),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_when] = ACTIONS(9486),
    [anon_sym_elsif] = ACTIONS(9486),
    [anon_sym_else] = ACTIONS(9486),
    [anon_sym_then] = ACTIONS(9486),
    [anon_sym_ensure] = ACTIONS(9486),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [5218] = {
    [anon_sym_RBRACE] = ACTIONS(10942),
    [sym_comment] = ACTIONS(87),
  },
  [5219] = {
    [sym__line_break2] = ACTIONS(9506),
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [ts_builtin_sym_end] = ACTIONS(9506),
    [anon_sym___END__] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_end] = ACTIONS(9506),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_when] = ACTIONS(9506),
    [anon_sym_elsif] = ACTIONS(9506),
    [anon_sym_else] = ACTIONS(9506),
    [anon_sym_then] = ACTIONS(9506),
    [anon_sym_ensure] = ACTIONS(9506),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [5220] = {
    [anon_sym_end] = ACTIONS(10944),
    [sym_comment] = ACTIONS(87),
  },
  [5221] = {
    [sym__statements] = STATE(7801),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10946),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5222] = {
    [sym__statements] = STATE(7801),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(7802),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(7802),
    [sym__line_break2] = ACTIONS(10948),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(10946),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5223] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [ts_builtin_sym_end] = ACTIONS(7850),
    [anon_sym___END__] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_end] = ACTIONS(7850),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_when] = ACTIONS(7850),
    [anon_sym_elsif] = ACTIONS(7850),
    [anon_sym_else] = ACTIONS(7850),
    [anon_sym_then] = ACTIONS(7850),
    [anon_sym_ensure] = ACTIONS(7850),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [sym_comment] = ACTIONS(87),
  },
  [5224] = {
    [anon_sym_RPAREN] = ACTIONS(10950),
    [sym_comment] = ACTIONS(87),
  },
  [5225] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(6969),
    [anon_sym___END__] = ACTIONS(6969),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [5226] = {
    [sym__line_break2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [ts_builtin_sym_end] = ACTIONS(3158),
    [anon_sym___END__] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_end] = ACTIONS(3158),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_when] = ACTIONS(3158),
    [anon_sym_elsif] = ACTIONS(3158),
    [anon_sym_else] = ACTIONS(3158),
    [anon_sym_then] = ACTIONS(3158),
    [anon_sym_ensure] = ACTIONS(3158),
    [anon_sym_EQ_GT] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_PLUS_EQ] = ACTIONS(3158),
    [anon_sym_DASH_EQ] = ACTIONS(3158),
    [anon_sym_STAR_EQ] = ACTIONS(3158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3158),
    [anon_sym_SLASH_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3158),
    [anon_sym_AMP_EQ] = ACTIONS(3158),
    [anon_sym_PERCENT_EQ] = ACTIONS(3158),
    [anon_sym_GT_GT_EQ] = ACTIONS(3158),
    [anon_sym_LT_LT_EQ] = ACTIONS(3158),
    [anon_sym_CARET_EQ] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4982),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
  },
  [5227] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10952),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [5228] = {
    [sym_heredoc_body] = STATE(5228),
    [aux_sym_call_repeat1] = STATE(5228),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [ts_builtin_sym_end] = ACTIONS(7888),
    [anon_sym___END__] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [5229] = {
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [5230] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(974),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(974),
    [sym_operator_assignment] = STATE(974),
    [sym_conditional] = STATE(974),
    [sym_range] = STATE(974),
    [sym_binary] = STATE(974),
    [sym_unary] = STATE(974),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(979),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1685),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [sym__identifier_hash_key2] = ACTIONS(1689),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7884),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(1697),
    [sym_identifier] = ACTIONS(1697),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5231] = {
    [sym_heredoc_body] = STATE(5228),
    [aux_sym_call_repeat1] = STATE(5228),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [ts_builtin_sym_end] = ACTIONS(7903),
    [anon_sym___END__] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [5232] = {
    [aux_sym_argument_list_repeat1] = STATE(5232),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [ts_builtin_sym_end] = ACTIONS(7899),
    [anon_sym___END__] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10957),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [5233] = {
    [sym__line_break2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [ts_builtin_sym_end] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_elsif] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_SLASH] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [5234] = {
    [sym__simple_symbol2] = ACTIONS(3158),
    [sym__string_start2] = ACTIONS(3158),
    [sym__symbol_start2] = ACTIONS(3158),
    [sym__subshell_start2] = ACTIONS(3158),
    [sym__regex_start2] = ACTIONS(3158),
    [sym__string_array_start2] = ACTIONS(3158),
    [sym__symbol_array_start2] = ACTIONS(3158),
    [sym_heredoc_beginning2] = ACTIONS(3158),
    [sym__block_ampersand2] = ACTIONS(3158),
    [sym__splat_star2] = ACTIONS(3158),
    [sym__unary_minus2] = ACTIONS(3158),
    [sym__identifier_hash_key2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_def] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(4982),
    [anon_sym_return] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_break] = ACTIONS(4982),
    [anon_sym_next] = ACTIONS(4982),
    [sym_redo] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(4982),
    [anon_sym_unless] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(4982),
    [anon_sym_until] = ACTIONS(4982),
    [anon_sym_for] = ACTIONS(4982),
    [anon_sym_case] = ACTIONS(4982),
    [anon_sym_begin] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_defined_QMARK] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(4982),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4982),
    [sym_instance_variable] = ACTIONS(3158),
    [sym_class_variable] = ACTIONS(3158),
    [sym_global_variable] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4982),
    [sym_float] = ACTIONS(4982),
    [sym_complex] = ACTIONS(3158),
    [sym_super] = ACTIONS(4982),
    [anon_sym_true] = ACTIONS(4982),
    [anon_sym_TRUE] = ACTIONS(4982),
    [anon_sym_false] = ACTIONS(4982),
    [anon_sym_FALSE] = ACTIONS(4982),
    [sym_self] = ACTIONS(4982),
    [anon_sym_nil] = ACTIONS(4982),
    [anon_sym_NIL] = ACTIONS(4982),
    [sym_character] = ACTIONS(3158),
    [anon_sym_LBRACK2] = ACTIONS(3158),
    [anon_sym_DASH_GT] = ACTIONS(3158),
  },
  [5235] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(10960),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [5236] = {
    [sym__line_break2] = ACTIONS(10962),
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [ts_builtin_sym_end] = ACTIONS(10962),
    [anon_sym___END__] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_end] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_when] = ACTIONS(10962),
    [anon_sym_elsif] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10962),
    [anon_sym_then] = ACTIONS(10962),
    [anon_sym_ensure] = ACTIONS(10962),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [5237] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2686),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(226),
    [sym_scope_resolution] = STATE(221),
    [sym_call] = STATE(221),
    [sym_method_call] = STATE(226),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(2686),
    [sym_operator_assignment] = STATE(2686),
    [sym_conditional] = STATE(2686),
    [sym_range] = STATE(2686),
    [sym_binary] = STATE(2686),
    [sym_unary] = STATE(2686),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(225),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(226),
    [sym__variable] = STATE(221),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(226),
    [sym_false] = STATE(226),
    [sym_nil] = STATE(226),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(912),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(1599),
    [sym__unary_minus2] = ACTIONS(371),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(381),
    [anon_sym_yield] = ACTIONS(383),
    [anon_sym_break] = ACTIONS(385),
    [anon_sym_next] = ACTIONS(387),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_defined_QMARK] = ACTIONS(393),
    [anon_sym_not] = ACTIONS(395),
    [anon_sym_BANG] = ACTIONS(399),
    [anon_sym_TILDE] = ACTIONS(399),
    [sym_constant] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_instance_variable] = ACTIONS(403),
    [sym_class_variable] = ACTIONS(403),
    [sym_global_variable] = ACTIONS(403),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(405),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(405),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5238] = {
    [aux_sym_exceptions_repeat1] = STATE(7808),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [ts_builtin_sym_end] = ACTIONS(9929),
    [anon_sym___END__] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(10966),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [5239] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5240] = {
    [sym_heredoc_body] = STATE(7809),
    [aux_sym_call_repeat1] = STATE(7809),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5241] = {
    [sym_heredoc_body] = STATE(7809),
    [aux_sym_call_repeat1] = STATE(7809),
    [aux_sym_argument_list_repeat1] = STATE(7810),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5242] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5243] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [5244] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7811),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7811),
    [sym_operator_assignment] = STATE(7811),
    [sym_conditional] = STATE(7811),
    [sym_range] = STATE(7811),
    [sym_binary] = STATE(7811),
    [sym_unary] = STATE(7811),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5245] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7812),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7812),
    [sym_operator_assignment] = STATE(7812),
    [sym_conditional] = STATE(7812),
    [sym_range] = STATE(7812),
    [sym_binary] = STATE(7812),
    [sym_unary] = STATE(7812),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5246] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7813),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7813),
    [sym_operator_assignment] = STATE(7813),
    [sym_conditional] = STATE(7813),
    [sym_range] = STATE(7813),
    [sym_binary] = STATE(7813),
    [sym_unary] = STATE(7813),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5247] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7814),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7814),
    [sym_operator_assignment] = STATE(7814),
    [sym_conditional] = STATE(7814),
    [sym_range] = STATE(7814),
    [sym_binary] = STATE(7814),
    [sym_unary] = STATE(7814),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5248] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7815),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7815),
    [sym_operator_assignment] = STATE(7815),
    [sym_conditional] = STATE(7815),
    [sym_range] = STATE(7815),
    [sym_binary] = STATE(7815),
    [sym_unary] = STATE(7815),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5249] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7816),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7816),
    [sym_operator_assignment] = STATE(7816),
    [sym_conditional] = STATE(7816),
    [sym_range] = STATE(7816),
    [sym_binary] = STATE(7816),
    [sym_unary] = STATE(7816),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5250] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7817),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7817),
    [sym_operator_assignment] = STATE(7817),
    [sym_conditional] = STATE(7817),
    [sym_range] = STATE(7817),
    [sym_binary] = STATE(7817),
    [sym_unary] = STATE(7817),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5251] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7818),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7818),
    [sym_operator_assignment] = STATE(7818),
    [sym_conditional] = STATE(7818),
    [sym_range] = STATE(7818),
    [sym_binary] = STATE(7818),
    [sym_unary] = STATE(7818),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5252] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7819),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7819),
    [sym_operator_assignment] = STATE(7819),
    [sym_conditional] = STATE(7819),
    [sym_range] = STATE(7819),
    [sym_binary] = STATE(7819),
    [sym_unary] = STATE(7819),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5253] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7820),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7820),
    [sym_operator_assignment] = STATE(7820),
    [sym_conditional] = STATE(7820),
    [sym_range] = STATE(7820),
    [sym_binary] = STATE(7820),
    [sym_unary] = STATE(7820),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5254] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7821),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7821),
    [sym_operator_assignment] = STATE(7821),
    [sym_conditional] = STATE(7821),
    [sym_range] = STATE(7821),
    [sym_binary] = STATE(7821),
    [sym_unary] = STATE(7821),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5255] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7822),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7822),
    [sym_operator_assignment] = STATE(7822),
    [sym_conditional] = STATE(7822),
    [sym_range] = STATE(7822),
    [sym_binary] = STATE(7822),
    [sym_unary] = STATE(7822),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5256] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7823),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_splat_argument] = STATE(7824),
    [sym_assignment] = STATE(7823),
    [sym_operator_assignment] = STATE(7823),
    [sym_conditional] = STATE(7823),
    [sym_range] = STATE(7823),
    [sym_binary] = STATE(7823),
    [sym_unary] = STATE(7823),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(7824),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5257] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7825),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(7825),
    [sym_operator_assignment] = STATE(7825),
    [sym_conditional] = STATE(7825),
    [sym_range] = STATE(7825),
    [sym_binary] = STATE(7825),
    [sym_unary] = STATE(7825),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5258] = {
    [sym_string] = STATE(7826),
    [aux_sym_chained_string_repeat1] = STATE(7826),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5259] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [5260] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5261] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5262] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7827),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(7827),
    [sym_operator_assignment] = STATE(7827),
    [sym_conditional] = STATE(7827),
    [sym_range] = STATE(7827),
    [sym_binary] = STATE(7827),
    [sym_unary] = STATE(7827),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5263] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5264] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7828),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(7828),
    [sym_operator_assignment] = STATE(7828),
    [sym_conditional] = STATE(7828),
    [sym_range] = STATE(7828),
    [sym_binary] = STATE(7828),
    [sym_unary] = STATE(7828),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5265] = {
    [sym_heredoc_body] = STATE(7829),
    [aux_sym_call_repeat1] = STATE(7829),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5266] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(7830),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10968),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5267] = {
    [sym_heredoc_body] = STATE(7831),
    [aux_sym_call_repeat1] = STATE(7831),
    [aux_sym_argument_list_repeat1] = STATE(7832),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7954),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5268] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5269] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5270] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5271] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5272] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5273] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5274] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [5275] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(10970),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5276] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5277] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5278] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5279] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5280] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5281] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5282] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5283] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7834),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(7834),
    [sym_operator_assignment] = STATE(7834),
    [sym_conditional] = STATE(7834),
    [sym_range] = STATE(7834),
    [sym_binary] = STATE(7834),
    [sym_unary] = STATE(7834),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5284] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5285] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7835),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(7835),
    [sym_operator_assignment] = STATE(7835),
    [sym_conditional] = STATE(7835),
    [sym_range] = STATE(7835),
    [sym_binary] = STATE(7835),
    [sym_unary] = STATE(7835),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5286] = {
    [sym_heredoc_body] = STATE(7836),
    [aux_sym_call_repeat1] = STATE(7836),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5287] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(7837),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10972),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5288] = {
    [sym_heredoc_body] = STATE(7838),
    [aux_sym_call_repeat1] = STATE(7838),
    [aux_sym_argument_list_repeat1] = STATE(7839),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7962),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5289] = {
    [sym_heredoc_body] = STATE(5289),
    [aux_sym_call_repeat1] = STATE(5289),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5290] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1001),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(1001),
    [sym_operator_assignment] = STATE(1001),
    [sym_conditional] = STATE(1001),
    [sym_range] = STATE(1001),
    [sym_binary] = STATE(1001),
    [sym_unary] = STATE(1001),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1007),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1731),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__identifier_hash_key2] = ACTIONS(1737),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(7966),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1755),
    [sym_identifier] = ACTIONS(1755),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5291] = {
    [sym_heredoc_body] = STATE(5289),
    [aux_sym_call_repeat1] = STATE(5289),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5292] = {
    [aux_sym_argument_list_repeat1] = STATE(5292),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(10974),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5293] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5294] = {
    [aux_sym_exceptions_repeat1] = STATE(7841),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5295] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [5296] = {
    [sym_string] = STATE(5296),
    [aux_sym_chained_string_repeat1] = STATE(5296),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5297] = {
    [aux_sym_undef_repeat1] = STATE(5297),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_then] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [5298] = {
    [sym__line_break2] = ACTIONS(6739),
    [sym__simple_symbol2] = ACTIONS(6739),
    [sym__string_start2] = ACTIONS(6739),
    [sym__symbol_start2] = ACTIONS(6739),
    [sym__subshell_start2] = ACTIONS(6739),
    [sym__regex_start2] = ACTIONS(6739),
    [sym__string_array_start2] = ACTIONS(6739),
    [sym__symbol_array_start2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym_heredoc_beginning2] = ACTIONS(6739),
    [sym__unary_minus2] = ACTIONS(6739),
    [anon_sym_BEGIN] = ACTIONS(8705),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_END] = ACTIONS(8705),
    [anon_sym_def] = ACTIONS(8705),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(8705),
    [anon_sym_module] = ACTIONS(8705),
    [anon_sym_end] = ACTIONS(8705),
    [anon_sym_return] = ACTIONS(8705),
    [anon_sym_yield] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(8705),
    [anon_sym_next] = ACTIONS(8705),
    [sym_redo] = ACTIONS(8705),
    [sym_retry] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(8705),
    [anon_sym_unless] = ACTIONS(8705),
    [anon_sym_while] = ACTIONS(8705),
    [anon_sym_until] = ACTIONS(8705),
    [anon_sym_for] = ACTIONS(8705),
    [anon_sym_case] = ACTIONS(8705),
    [anon_sym_elsif] = ACTIONS(8705),
    [anon_sym_else] = ACTIONS(8705),
    [anon_sym_then] = ACTIONS(8705),
    [anon_sym_begin] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_defined_QMARK] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(8705),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6739),
    [anon_sym_undef] = ACTIONS(8705),
    [anon_sym_alias] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8705),
    [sym_float] = ACTIONS(8705),
    [sym_complex] = ACTIONS(6739),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(8705),
    [anon_sym_TRUE] = ACTIONS(8705),
    [anon_sym_false] = ACTIONS(8705),
    [anon_sym_FALSE] = ACTIONS(8705),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(8705),
    [anon_sym_NIL] = ACTIONS(8705),
    [sym_character] = ACTIONS(6739),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6739),
  },
  [5299] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5300] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7850),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(7850),
    [sym_operator_assignment] = STATE(7850),
    [sym_conditional] = STATE(7850),
    [sym_range] = STATE(7850),
    [sym_binary] = STATE(7850),
    [sym_unary] = STATE(7850),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5301] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(7854),
    [sym_operator_assignment] = STATE(7854),
    [sym_conditional] = STATE(7854),
    [sym_range] = STATE(7854),
    [sym_binary] = STATE(7854),
    [sym_unary] = STATE(7854),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5302] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7855),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(7855),
    [sym_operator_assignment] = STATE(7855),
    [sym_conditional] = STATE(7855),
    [sym_range] = STATE(7855),
    [sym_binary] = STATE(7855),
    [sym_unary] = STATE(7855),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5303] = {
    [anon_sym_COLON] = ACTIONS(10997),
    [sym_comment] = ACTIONS(87),
  },
  [5304] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7858),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(7858),
    [sym_operator_assignment] = STATE(7858),
    [sym_conditional] = STATE(7858),
    [sym_range] = STATE(7858),
    [sym_binary] = STATE(7858),
    [sym_unary] = STATE(7858),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5305] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(7865),
    [sym__argument] = STATE(7866),
    [sym_splat_argument] = STATE(7866),
    [sym_hash_splat_argument] = STATE(7866),
    [sym_block_argument] = STATE(7866),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(7866),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5306] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(7865),
    [sym__argument] = STATE(7866),
    [sym_splat_argument] = STATE(7866),
    [sym_hash_splat_argument] = STATE(7866),
    [sym_block_argument] = STATE(7866),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(7866),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5307] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(7865),
    [sym__argument] = STATE(7866),
    [sym_splat_argument] = STATE(7866),
    [sym_hash_splat_argument] = STATE(7866),
    [sym_block_argument] = STATE(7866),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(7866),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5308] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(7865),
    [sym__argument] = STATE(7866),
    [sym_splat_argument] = STATE(7866),
    [sym_hash_splat_argument] = STATE(7866),
    [sym_block_argument] = STATE(7866),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(7866),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5309] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7868),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(7868),
    [sym_operator_assignment] = STATE(7868),
    [sym_conditional] = STATE(7868),
    [sym_range] = STATE(7868),
    [sym_binary] = STATE(7868),
    [sym_unary] = STATE(7868),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5310] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7869),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(7869),
    [sym_operator_assignment] = STATE(7869),
    [sym_conditional] = STATE(7869),
    [sym_range] = STATE(7869),
    [sym_binary] = STATE(7869),
    [sym_unary] = STATE(7869),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5311] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5312] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11007),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_elsif] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5313] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_elsif] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11021),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [5314] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5315] = {
    [sym_heredoc_body] = STATE(7892),
    [aux_sym_call_repeat1] = STATE(7892),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5316] = {
    [sym_heredoc_body] = STATE(7892),
    [aux_sym_call_repeat1] = STATE(7892),
    [aux_sym_argument_list_repeat1] = STATE(7894),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5317] = {
    [anon_sym_EQ] = ACTIONS(11051),
    [sym_comment] = ACTIONS(87),
  },
  [5318] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11053),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11055),
    [anon_sym_DASH_EQ] = ACTIONS(11055),
    [anon_sym_STAR_EQ] = ACTIONS(11055),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11055),
    [anon_sym_SLASH_EQ] = ACTIONS(11055),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11055),
    [anon_sym_PIPE_EQ] = ACTIONS(11055),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11055),
    [anon_sym_AMP_EQ] = ACTIONS(11055),
    [anon_sym_PERCENT_EQ] = ACTIONS(11055),
    [anon_sym_GT_GT_EQ] = ACTIONS(11055),
    [anon_sym_LT_LT_EQ] = ACTIONS(11055),
    [anon_sym_CARET_EQ] = ACTIONS(11055),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5319] = {
    [sym_string] = STATE(7897),
    [aux_sym_chained_string_repeat1] = STATE(7897),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11057),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5320] = {
    [sym__then] = STATE(7898),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(11059),
    [sym_comment] = ACTIONS(87),
  },
  [5321] = {
    [sym__statements] = STATE(3332),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5294),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5322] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5323] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [5324] = {
    [aux_sym_undef_repeat1] = STATE(7899),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_elsif] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [5325] = {
    [sym__line_break2] = ACTIONS(11061),
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [ts_builtin_sym_end] = ACTIONS(11061),
    [anon_sym___END__] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11061),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_end] = ACTIONS(11061),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_when] = ACTIONS(11061),
    [anon_sym_elsif] = ACTIONS(11061),
    [anon_sym_else] = ACTIONS(11061),
    [anon_sym_then] = ACTIONS(11061),
    [anon_sym_ensure] = ACTIONS(11061),
    [anon_sym_EQ_GT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11061),
    [anon_sym_AMP_AMP] = ACTIONS(11061),
    [anon_sym_LT_LT] = ACTIONS(11061),
    [anon_sym_GT_GT] = ACTIONS(11061),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11061),
    [anon_sym_PLUS] = ACTIONS(11061),
    [anon_sym_SLASH] = ACTIONS(11061),
    [anon_sym_PERCENT] = ACTIONS(11061),
    [sym_comment] = ACTIONS(87),
  },
  [5326] = {
    [anon_sym_end] = ACTIONS(11065),
    [sym_comment] = ACTIONS(87),
  },
  [5327] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(2545),
    [anon_sym_else] = ACTIONS(2545),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5328] = {
    [sym_heredoc_body] = STATE(7901),
    [sym__terminator] = STATE(7901),
    [aux_sym__statements_repeat1] = STATE(7902),
    [sym__line_break2] = ACTIONS(11067),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(11067),
    [anon_sym_end] = ACTIONS(2543),
    [anon_sym_elsif] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [5329] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7903),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7903),
    [sym_operator_assignment] = STATE(7903),
    [sym_conditional] = STATE(7903),
    [sym_range] = STATE(7903),
    [sym_binary] = STATE(7903),
    [sym_unary] = STATE(7903),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5330] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7904),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7904),
    [sym_operator_assignment] = STATE(7904),
    [sym_conditional] = STATE(7904),
    [sym_range] = STATE(7904),
    [sym_binary] = STATE(7904),
    [sym_unary] = STATE(7904),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5331] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7905),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7905),
    [sym_operator_assignment] = STATE(7905),
    [sym_conditional] = STATE(7905),
    [sym_range] = STATE(7905),
    [sym_binary] = STATE(7905),
    [sym_unary] = STATE(7905),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5332] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7906),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7906),
    [sym_operator_assignment] = STATE(7906),
    [sym_conditional] = STATE(7906),
    [sym_range] = STATE(7906),
    [sym_binary] = STATE(7906),
    [sym_unary] = STATE(7906),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5333] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7907),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7907),
    [sym_operator_assignment] = STATE(7907),
    [sym_conditional] = STATE(7907),
    [sym_range] = STATE(7907),
    [sym_binary] = STATE(7907),
    [sym_unary] = STATE(7907),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5334] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7908),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7908),
    [sym_operator_assignment] = STATE(7908),
    [sym_conditional] = STATE(7908),
    [sym_range] = STATE(7908),
    [sym_binary] = STATE(7908),
    [sym_unary] = STATE(7908),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5335] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7909),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7909),
    [sym_operator_assignment] = STATE(7909),
    [sym_conditional] = STATE(7909),
    [sym_range] = STATE(7909),
    [sym_binary] = STATE(7909),
    [sym_unary] = STATE(7909),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5336] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7910),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7910),
    [sym_operator_assignment] = STATE(7910),
    [sym_conditional] = STATE(7910),
    [sym_range] = STATE(7910),
    [sym_binary] = STATE(7910),
    [sym_unary] = STATE(7910),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5337] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7911),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7911),
    [sym_operator_assignment] = STATE(7911),
    [sym_conditional] = STATE(7911),
    [sym_range] = STATE(7911),
    [sym_binary] = STATE(7911),
    [sym_unary] = STATE(7911),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5338] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7912),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7912),
    [sym_operator_assignment] = STATE(7912),
    [sym_conditional] = STATE(7912),
    [sym_range] = STATE(7912),
    [sym_binary] = STATE(7912),
    [sym_unary] = STATE(7912),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5339] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7913),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7913),
    [sym_operator_assignment] = STATE(7913),
    [sym_conditional] = STATE(7913),
    [sym_range] = STATE(7913),
    [sym_binary] = STATE(7913),
    [sym_unary] = STATE(7913),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5340] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7914),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7914),
    [sym_operator_assignment] = STATE(7914),
    [sym_conditional] = STATE(7914),
    [sym_range] = STATE(7914),
    [sym_binary] = STATE(7914),
    [sym_unary] = STATE(7914),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5341] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7915),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7915),
    [sym_operator_assignment] = STATE(7915),
    [sym_conditional] = STATE(7915),
    [sym_range] = STATE(7915),
    [sym_binary] = STATE(7915),
    [sym_unary] = STATE(7915),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5342] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7916),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7916),
    [sym_operator_assignment] = STATE(7916),
    [sym_conditional] = STATE(7916),
    [sym_range] = STATE(7916),
    [sym_binary] = STATE(7916),
    [sym_unary] = STATE(7916),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5343] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7917),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7917),
    [sym_operator_assignment] = STATE(7917),
    [sym_conditional] = STATE(7917),
    [sym_range] = STATE(7917),
    [sym_binary] = STATE(7917),
    [sym_unary] = STATE(7917),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5344] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7918),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7918),
    [sym_operator_assignment] = STATE(7918),
    [sym_conditional] = STATE(7918),
    [sym_range] = STATE(7918),
    [sym_binary] = STATE(7918),
    [sym_unary] = STATE(7918),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5345] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7919),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7919),
    [sym_operator_assignment] = STATE(7919),
    [sym_conditional] = STATE(7919),
    [sym_range] = STATE(7919),
    [sym_binary] = STATE(7919),
    [sym_unary] = STATE(7919),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5346] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7928),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(7928),
    [sym_operator_assignment] = STATE(7928),
    [sym_conditional] = STATE(7928),
    [sym_range] = STATE(7928),
    [sym_binary] = STATE(7928),
    [sym_unary] = STATE(7928),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5347] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7933),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(7933),
    [sym_operator_assignment] = STATE(7933),
    [sym_conditional] = STATE(7933),
    [sym_range] = STATE(7933),
    [sym_binary] = STATE(7933),
    [sym_unary] = STATE(7933),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5348] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7934),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(7934),
    [sym_operator_assignment] = STATE(7934),
    [sym_conditional] = STATE(7934),
    [sym_range] = STATE(7934),
    [sym_binary] = STATE(7934),
    [sym_unary] = STATE(7934),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5349] = {
    [anon_sym_COLON] = ACTIONS(11093),
    [sym_comment] = ACTIONS(87),
  },
  [5350] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7937),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(7937),
    [sym_operator_assignment] = STATE(7937),
    [sym_conditional] = STATE(7937),
    [sym_range] = STATE(7937),
    [sym_binary] = STATE(7937),
    [sym_unary] = STATE(7937),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5351] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5352] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5353] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5354] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5355] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7938),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(7938),
    [sym_operator_assignment] = STATE(7938),
    [sym_conditional] = STATE(7938),
    [sym_range] = STATE(7938),
    [sym_binary] = STATE(7938),
    [sym_unary] = STATE(7938),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5356] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7939),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(7939),
    [sym_operator_assignment] = STATE(7939),
    [sym_conditional] = STATE(7939),
    [sym_range] = STATE(7939),
    [sym_binary] = STATE(7939),
    [sym_unary] = STATE(7939),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5357] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5358] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11095),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_elsif] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5359] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_elsif] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11109),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [5360] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(7889),
    [sym__argument] = STATE(7890),
    [sym_splat_argument] = STATE(7890),
    [sym_hash_splat_argument] = STATE(7890),
    [sym_block_argument] = STATE(7890),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7890),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5361] = {
    [sym_heredoc_body] = STATE(7953),
    [aux_sym_call_repeat1] = STATE(7953),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5362] = {
    [sym_heredoc_body] = STATE(7953),
    [aux_sym_call_repeat1] = STATE(7953),
    [aux_sym_argument_list_repeat1] = STATE(7955),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11127),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5363] = {
    [anon_sym_EQ] = ACTIONS(11129),
    [sym_comment] = ACTIONS(87),
  },
  [5364] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11131),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11133),
    [anon_sym_DASH_EQ] = ACTIONS(11133),
    [anon_sym_STAR_EQ] = ACTIONS(11133),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11133),
    [anon_sym_SLASH_EQ] = ACTIONS(11133),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11133),
    [anon_sym_PIPE_EQ] = ACTIONS(11133),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11133),
    [anon_sym_AMP_EQ] = ACTIONS(11133),
    [anon_sym_PERCENT_EQ] = ACTIONS(11133),
    [anon_sym_GT_GT_EQ] = ACTIONS(11133),
    [anon_sym_LT_LT_EQ] = ACTIONS(11133),
    [anon_sym_CARET_EQ] = ACTIONS(11133),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5365] = {
    [sym_string] = STATE(7958),
    [aux_sym_chained_string_repeat1] = STATE(7958),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11135),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5366] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7964),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_splat_argument] = STATE(7965),
    [sym_assignment] = STATE(7964),
    [sym_operator_assignment] = STATE(7964),
    [sym_conditional] = STATE(7964),
    [sym_range] = STATE(7964),
    [sym_binary] = STATE(7964),
    [sym_unary] = STATE(7964),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(7965),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11137),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5367] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7968),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(7968),
    [sym_operator_assignment] = STATE(7968),
    [sym_conditional] = STATE(7968),
    [sym_range] = STATE(7968),
    [sym_binary] = STATE(7968),
    [sym_unary] = STATE(7968),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5368] = {
    [sym_string] = STATE(7969),
    [aux_sym_chained_string_repeat1] = STATE(7969),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_elsif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5369] = {
    [sym_elsif] = STATE(7970),
    [sym_else] = STATE(7970),
    [sym__if_tail] = STATE(7970),
    [anon_sym_end] = ACTIONS(11065),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [5370] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7971),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(244),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(244),
    [sym_assignment] = STATE(7971),
    [sym_operator_assignment] = STATE(7971),
    [sym_conditional] = STATE(7971),
    [sym_range] = STATE(7971),
    [sym_binary] = STATE(7971),
    [sym_unary] = STATE(7971),
    [sym_left_assignment_list] = STATE(243),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(244),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(244),
    [sym_false] = STATE(244),
    [sym_nil] = STATE(244),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(245),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(427),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(429),
    [anon_sym_yield] = ACTIONS(431),
    [anon_sym_break] = ACTIONS(433),
    [anon_sym_next] = ACTIONS(435),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(437),
    [anon_sym_defined_QMARK] = ACTIONS(439),
    [anon_sym_not] = ACTIONS(441),
    [anon_sym_BANG] = ACTIONS(443),
    [anon_sym_TILDE] = ACTIONS(443),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5371] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [5372] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [5373] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [5374] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7972),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7972),
    [sym_operator_assignment] = STATE(7972),
    [sym_conditional] = STATE(7972),
    [sym_range] = STATE(7972),
    [sym_binary] = STATE(7972),
    [sym_unary] = STATE(7972),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5375] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7973),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7973),
    [sym_operator_assignment] = STATE(7973),
    [sym_conditional] = STATE(7973),
    [sym_range] = STATE(7973),
    [sym_binary] = STATE(7973),
    [sym_unary] = STATE(7973),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5376] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7974),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7974),
    [sym_operator_assignment] = STATE(7974),
    [sym_conditional] = STATE(7974),
    [sym_range] = STATE(7974),
    [sym_binary] = STATE(7974),
    [sym_unary] = STATE(7974),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5377] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7975),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7975),
    [sym_operator_assignment] = STATE(7975),
    [sym_conditional] = STATE(7975),
    [sym_range] = STATE(7975),
    [sym_binary] = STATE(7975),
    [sym_unary] = STATE(7975),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5378] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7976),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7976),
    [sym_operator_assignment] = STATE(7976),
    [sym_conditional] = STATE(7976),
    [sym_range] = STATE(7976),
    [sym_binary] = STATE(7976),
    [sym_unary] = STATE(7976),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5379] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7977),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7977),
    [sym_operator_assignment] = STATE(7977),
    [sym_conditional] = STATE(7977),
    [sym_range] = STATE(7977),
    [sym_binary] = STATE(7977),
    [sym_unary] = STATE(7977),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5380] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7978),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7978),
    [sym_operator_assignment] = STATE(7978),
    [sym_conditional] = STATE(7978),
    [sym_range] = STATE(7978),
    [sym_binary] = STATE(7978),
    [sym_unary] = STATE(7978),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5381] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7979),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7979),
    [sym_operator_assignment] = STATE(7979),
    [sym_conditional] = STATE(7979),
    [sym_range] = STATE(7979),
    [sym_binary] = STATE(7979),
    [sym_unary] = STATE(7979),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5382] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7980),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7980),
    [sym_operator_assignment] = STATE(7980),
    [sym_conditional] = STATE(7980),
    [sym_range] = STATE(7980),
    [sym_binary] = STATE(7980),
    [sym_unary] = STATE(7980),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5383] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7981),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7981),
    [sym_operator_assignment] = STATE(7981),
    [sym_conditional] = STATE(7981),
    [sym_range] = STATE(7981),
    [sym_binary] = STATE(7981),
    [sym_unary] = STATE(7981),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5384] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7982),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7982),
    [sym_operator_assignment] = STATE(7982),
    [sym_conditional] = STATE(7982),
    [sym_range] = STATE(7982),
    [sym_binary] = STATE(7982),
    [sym_unary] = STATE(7982),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5385] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7983),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7983),
    [sym_operator_assignment] = STATE(7983),
    [sym_conditional] = STATE(7983),
    [sym_range] = STATE(7983),
    [sym_binary] = STATE(7983),
    [sym_unary] = STATE(7983),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5386] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7984),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_splat_argument] = STATE(7985),
    [sym_assignment] = STATE(7984),
    [sym_operator_assignment] = STATE(7984),
    [sym_conditional] = STATE(7984),
    [sym_range] = STATE(7984),
    [sym_binary] = STATE(7984),
    [sym_unary] = STATE(7984),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(7985),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5387] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7986),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(7986),
    [sym_operator_assignment] = STATE(7986),
    [sym_conditional] = STATE(7986),
    [sym_range] = STATE(7986),
    [sym_binary] = STATE(7986),
    [sym_unary] = STATE(7986),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5388] = {
    [sym_string] = STATE(7987),
    [aux_sym_chained_string_repeat1] = STATE(7987),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [5389] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [5390] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5391] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [5392] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5393] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [5394] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5395] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5396] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [5397] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11149),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5398] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5399] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5400] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5401] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5402] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5403] = {
    [sym_heredoc_body] = STATE(5403),
    [aux_sym_call_repeat1] = STATE(5403),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [5404] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1044),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(1044),
    [sym_operator_assignment] = STATE(1044),
    [sym_conditional] = STATE(1044),
    [sym_range] = STATE(1044),
    [sym_binary] = STATE(1044),
    [sym_unary] = STATE(1044),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1050),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1811),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__identifier_hash_key2] = ACTIONS(1817),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8136),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1835),
    [sym_identifier] = ACTIONS(1835),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5405] = {
    [sym_heredoc_body] = STATE(5403),
    [aux_sym_call_repeat1] = STATE(5403),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [5406] = {
    [aux_sym_argument_list_repeat1] = STATE(5406),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11151),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [5407] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5408] = {
    [aux_sym_exceptions_repeat1] = STATE(7990),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [5409] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [5410] = {
    [sym_string] = STATE(5410),
    [aux_sym_chained_string_repeat1] = STATE(5410),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [5411] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [5412] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5413] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5414] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [5415] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7991),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7991),
    [sym_operator_assignment] = STATE(7991),
    [sym_conditional] = STATE(7991),
    [sym_range] = STATE(7991),
    [sym_binary] = STATE(7991),
    [sym_unary] = STATE(7991),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5416] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7992),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7992),
    [sym_operator_assignment] = STATE(7992),
    [sym_conditional] = STATE(7992),
    [sym_range] = STATE(7992),
    [sym_binary] = STATE(7992),
    [sym_unary] = STATE(7992),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5417] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7993),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7993),
    [sym_operator_assignment] = STATE(7993),
    [sym_conditional] = STATE(7993),
    [sym_range] = STATE(7993),
    [sym_binary] = STATE(7993),
    [sym_unary] = STATE(7993),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5418] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7994),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7994),
    [sym_operator_assignment] = STATE(7994),
    [sym_conditional] = STATE(7994),
    [sym_range] = STATE(7994),
    [sym_binary] = STATE(7994),
    [sym_unary] = STATE(7994),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5419] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7995),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7995),
    [sym_operator_assignment] = STATE(7995),
    [sym_conditional] = STATE(7995),
    [sym_range] = STATE(7995),
    [sym_binary] = STATE(7995),
    [sym_unary] = STATE(7995),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5420] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7996),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7996),
    [sym_operator_assignment] = STATE(7996),
    [sym_conditional] = STATE(7996),
    [sym_range] = STATE(7996),
    [sym_binary] = STATE(7996),
    [sym_unary] = STATE(7996),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5421] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(7997),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(7997),
    [sym_operator_assignment] = STATE(7997),
    [sym_conditional] = STATE(7997),
    [sym_range] = STATE(7997),
    [sym_binary] = STATE(7997),
    [sym_unary] = STATE(7997),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5422] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7998),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7998),
    [sym_operator_assignment] = STATE(7998),
    [sym_conditional] = STATE(7998),
    [sym_range] = STATE(7998),
    [sym_binary] = STATE(7998),
    [sym_unary] = STATE(7998),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5423] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7999),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(7999),
    [sym_operator_assignment] = STATE(7999),
    [sym_conditional] = STATE(7999),
    [sym_range] = STATE(7999),
    [sym_binary] = STATE(7999),
    [sym_unary] = STATE(7999),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5424] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8000),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(8000),
    [sym_operator_assignment] = STATE(8000),
    [sym_conditional] = STATE(8000),
    [sym_range] = STATE(8000),
    [sym_binary] = STATE(8000),
    [sym_unary] = STATE(8000),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5425] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8001),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(8001),
    [sym_operator_assignment] = STATE(8001),
    [sym_conditional] = STATE(8001),
    [sym_range] = STATE(8001),
    [sym_binary] = STATE(8001),
    [sym_unary] = STATE(8001),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5426] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8002),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(8002),
    [sym_operator_assignment] = STATE(8002),
    [sym_conditional] = STATE(8002),
    [sym_range] = STATE(8002),
    [sym_binary] = STATE(8002),
    [sym_unary] = STATE(8002),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5427] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2834),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(2834),
    [sym_operator_assignment] = STATE(2834),
    [sym_conditional] = STATE(2834),
    [sym_range] = STATE(2834),
    [sym_binary] = STATE(2834),
    [sym_unary] = STATE(2834),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4546),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5428] = {
    [aux_sym_exceptions_repeat1] = STATE(8003),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(8168),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [5429] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2834),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_splat_argument] = STATE(8004),
    [sym_assignment] = STATE(2834),
    [sym_operator_assignment] = STATE(2834),
    [sym_conditional] = STATE(2834),
    [sym_range] = STATE(2834),
    [sym_binary] = STATE(2834),
    [sym_unary] = STATE(2834),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8004),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4546),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5430] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8005),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(8005),
    [sym_operator_assignment] = STATE(8005),
    [sym_conditional] = STATE(8005),
    [sym_range] = STATE(8005),
    [sym_binary] = STATE(8005),
    [sym_unary] = STATE(8005),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5431] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5432] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8014),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(8014),
    [sym_operator_assignment] = STATE(8014),
    [sym_conditional] = STATE(8014),
    [sym_range] = STATE(8014),
    [sym_binary] = STATE(8014),
    [sym_unary] = STATE(8014),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5433] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8018),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(8018),
    [sym_operator_assignment] = STATE(8018),
    [sym_conditional] = STATE(8018),
    [sym_range] = STATE(8018),
    [sym_binary] = STATE(8018),
    [sym_unary] = STATE(8018),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5434] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8019),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(8019),
    [sym_operator_assignment] = STATE(8019),
    [sym_conditional] = STATE(8019),
    [sym_range] = STATE(8019),
    [sym_binary] = STATE(8019),
    [sym_unary] = STATE(8019),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5435] = {
    [anon_sym_COLON] = ACTIONS(11174),
    [sym_comment] = ACTIONS(87),
  },
  [5436] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8022),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(8022),
    [sym_operator_assignment] = STATE(8022),
    [sym_conditional] = STATE(8022),
    [sym_range] = STATE(8022),
    [sym_binary] = STATE(8022),
    [sym_unary] = STATE(8022),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5437] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8029),
    [sym__argument] = STATE(8030),
    [sym_splat_argument] = STATE(8030),
    [sym_hash_splat_argument] = STATE(8030),
    [sym_block_argument] = STATE(8030),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8030),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5438] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(8029),
    [sym__argument] = STATE(8030),
    [sym_splat_argument] = STATE(8030),
    [sym_hash_splat_argument] = STATE(8030),
    [sym_block_argument] = STATE(8030),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8030),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5439] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(8029),
    [sym__argument] = STATE(8030),
    [sym_splat_argument] = STATE(8030),
    [sym_hash_splat_argument] = STATE(8030),
    [sym_block_argument] = STATE(8030),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8030),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5440] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(8029),
    [sym__argument] = STATE(8030),
    [sym_splat_argument] = STATE(8030),
    [sym_hash_splat_argument] = STATE(8030),
    [sym_block_argument] = STATE(8030),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8030),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5441] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8032),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(8032),
    [sym_operator_assignment] = STATE(8032),
    [sym_conditional] = STATE(8032),
    [sym_range] = STATE(8032),
    [sym_binary] = STATE(8032),
    [sym_unary] = STATE(8032),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5442] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8033),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(8033),
    [sym_operator_assignment] = STATE(8033),
    [sym_conditional] = STATE(8033),
    [sym_range] = STATE(8033),
    [sym_binary] = STATE(8033),
    [sym_unary] = STATE(8033),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5443] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5444] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11184),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5445] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11198),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [5446] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5447] = {
    [sym_heredoc_body] = STATE(8056),
    [aux_sym_call_repeat1] = STATE(8056),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5448] = {
    [sym_heredoc_body] = STATE(8056),
    [aux_sym_call_repeat1] = STATE(8056),
    [aux_sym_argument_list_repeat1] = STATE(8058),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11226),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5449] = {
    [anon_sym_EQ] = ACTIONS(11228),
    [sym_comment] = ACTIONS(87),
  },
  [5450] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11230),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11232),
    [anon_sym_DASH_EQ] = ACTIONS(11232),
    [anon_sym_STAR_EQ] = ACTIONS(11232),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11232),
    [anon_sym_SLASH_EQ] = ACTIONS(11232),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11232),
    [anon_sym_PIPE_EQ] = ACTIONS(11232),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11232),
    [anon_sym_AMP_EQ] = ACTIONS(11232),
    [anon_sym_PERCENT_EQ] = ACTIONS(11232),
    [anon_sym_GT_GT_EQ] = ACTIONS(11232),
    [anon_sym_LT_LT_EQ] = ACTIONS(11232),
    [anon_sym_CARET_EQ] = ACTIONS(11232),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5451] = {
    [sym_string] = STATE(8061),
    [aux_sym_chained_string_repeat1] = STATE(8061),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11234),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5452] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5453] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [5454] = {
    [aux_sym_undef_repeat1] = STATE(8062),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [5455] = {
    [sym__line_break2] = ACTIONS(11236),
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [ts_builtin_sym_end] = ACTIONS(11236),
    [anon_sym___END__] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11236),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_end] = ACTIONS(11236),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_when] = ACTIONS(11236),
    [anon_sym_elsif] = ACTIONS(11236),
    [anon_sym_else] = ACTIONS(11236),
    [anon_sym_then] = ACTIONS(11236),
    [anon_sym_ensure] = ACTIONS(11236),
    [anon_sym_EQ_GT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11236),
    [anon_sym_AMP_AMP] = ACTIONS(11236),
    [anon_sym_LT_LT] = ACTIONS(11236),
    [anon_sym_GT_GT] = ACTIONS(11236),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11236),
    [anon_sym_PLUS] = ACTIONS(11236),
    [anon_sym_SLASH] = ACTIONS(11236),
    [anon_sym_PERCENT] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [5456] = {
    [anon_sym_end] = ACTIONS(11240),
    [sym_comment] = ACTIONS(87),
  },
  [5457] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(2545),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5458] = {
    [sym_heredoc_body] = STATE(8064),
    [sym__terminator] = STATE(8064),
    [aux_sym__statements_repeat1] = STATE(8065),
    [sym__line_break2] = ACTIONS(11242),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(11242),
    [anon_sym_end] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [5459] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8066),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8066),
    [sym_operator_assignment] = STATE(8066),
    [sym_conditional] = STATE(8066),
    [sym_range] = STATE(8066),
    [sym_binary] = STATE(8066),
    [sym_unary] = STATE(8066),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5460] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8067),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8067),
    [sym_operator_assignment] = STATE(8067),
    [sym_conditional] = STATE(8067),
    [sym_range] = STATE(8067),
    [sym_binary] = STATE(8067),
    [sym_unary] = STATE(8067),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5461] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8068),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8068),
    [sym_operator_assignment] = STATE(8068),
    [sym_conditional] = STATE(8068),
    [sym_range] = STATE(8068),
    [sym_binary] = STATE(8068),
    [sym_unary] = STATE(8068),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5462] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8069),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8069),
    [sym_operator_assignment] = STATE(8069),
    [sym_conditional] = STATE(8069),
    [sym_range] = STATE(8069),
    [sym_binary] = STATE(8069),
    [sym_unary] = STATE(8069),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5463] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8070),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8070),
    [sym_operator_assignment] = STATE(8070),
    [sym_conditional] = STATE(8070),
    [sym_range] = STATE(8070),
    [sym_binary] = STATE(8070),
    [sym_unary] = STATE(8070),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5464] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8071),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8071),
    [sym_operator_assignment] = STATE(8071),
    [sym_conditional] = STATE(8071),
    [sym_range] = STATE(8071),
    [sym_binary] = STATE(8071),
    [sym_unary] = STATE(8071),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5465] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8072),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8072),
    [sym_operator_assignment] = STATE(8072),
    [sym_conditional] = STATE(8072),
    [sym_range] = STATE(8072),
    [sym_binary] = STATE(8072),
    [sym_unary] = STATE(8072),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5466] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8073),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8073),
    [sym_operator_assignment] = STATE(8073),
    [sym_conditional] = STATE(8073),
    [sym_range] = STATE(8073),
    [sym_binary] = STATE(8073),
    [sym_unary] = STATE(8073),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5467] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8074),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8074),
    [sym_operator_assignment] = STATE(8074),
    [sym_conditional] = STATE(8074),
    [sym_range] = STATE(8074),
    [sym_binary] = STATE(8074),
    [sym_unary] = STATE(8074),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5468] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8075),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8075),
    [sym_operator_assignment] = STATE(8075),
    [sym_conditional] = STATE(8075),
    [sym_range] = STATE(8075),
    [sym_binary] = STATE(8075),
    [sym_unary] = STATE(8075),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5469] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8076),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8076),
    [sym_operator_assignment] = STATE(8076),
    [sym_conditional] = STATE(8076),
    [sym_range] = STATE(8076),
    [sym_binary] = STATE(8076),
    [sym_unary] = STATE(8076),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5470] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8077),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8077),
    [sym_operator_assignment] = STATE(8077),
    [sym_conditional] = STATE(8077),
    [sym_range] = STATE(8077),
    [sym_binary] = STATE(8077),
    [sym_unary] = STATE(8077),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5471] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8078),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8078),
    [sym_operator_assignment] = STATE(8078),
    [sym_conditional] = STATE(8078),
    [sym_range] = STATE(8078),
    [sym_binary] = STATE(8078),
    [sym_unary] = STATE(8078),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5472] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8079),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8079),
    [sym_operator_assignment] = STATE(8079),
    [sym_conditional] = STATE(8079),
    [sym_range] = STATE(8079),
    [sym_binary] = STATE(8079),
    [sym_unary] = STATE(8079),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5473] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8080),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8080),
    [sym_operator_assignment] = STATE(8080),
    [sym_conditional] = STATE(8080),
    [sym_range] = STATE(8080),
    [sym_binary] = STATE(8080),
    [sym_unary] = STATE(8080),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5474] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8081),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8081),
    [sym_operator_assignment] = STATE(8081),
    [sym_conditional] = STATE(8081),
    [sym_range] = STATE(8081),
    [sym_binary] = STATE(8081),
    [sym_unary] = STATE(8081),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5475] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8082),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8082),
    [sym_operator_assignment] = STATE(8082),
    [sym_conditional] = STATE(8082),
    [sym_range] = STATE(8082),
    [sym_binary] = STATE(8082),
    [sym_unary] = STATE(8082),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5476] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8091),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(8091),
    [sym_operator_assignment] = STATE(8091),
    [sym_conditional] = STATE(8091),
    [sym_range] = STATE(8091),
    [sym_binary] = STATE(8091),
    [sym_unary] = STATE(8091),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5477] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8096),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(8096),
    [sym_operator_assignment] = STATE(8096),
    [sym_conditional] = STATE(8096),
    [sym_range] = STATE(8096),
    [sym_binary] = STATE(8096),
    [sym_unary] = STATE(8096),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5478] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8097),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(8097),
    [sym_operator_assignment] = STATE(8097),
    [sym_conditional] = STATE(8097),
    [sym_range] = STATE(8097),
    [sym_binary] = STATE(8097),
    [sym_unary] = STATE(8097),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5479] = {
    [anon_sym_COLON] = ACTIONS(11268),
    [sym_comment] = ACTIONS(87),
  },
  [5480] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8100),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(8100),
    [sym_operator_assignment] = STATE(8100),
    [sym_conditional] = STATE(8100),
    [sym_range] = STATE(8100),
    [sym_binary] = STATE(8100),
    [sym_unary] = STATE(8100),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5481] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5482] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5483] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5484] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5485] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8101),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(8101),
    [sym_operator_assignment] = STATE(8101),
    [sym_conditional] = STATE(8101),
    [sym_range] = STATE(8101),
    [sym_binary] = STATE(8101),
    [sym_unary] = STATE(8101),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5486] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(8102),
    [sym_operator_assignment] = STATE(8102),
    [sym_conditional] = STATE(8102),
    [sym_range] = STATE(8102),
    [sym_binary] = STATE(8102),
    [sym_unary] = STATE(8102),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5487] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5488] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11270),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5489] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11284),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [5490] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(8053),
    [sym__argument] = STATE(8054),
    [sym_splat_argument] = STATE(8054),
    [sym_hash_splat_argument] = STATE(8054),
    [sym_block_argument] = STATE(8054),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(8054),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5491] = {
    [sym_heredoc_body] = STATE(8116),
    [aux_sym_call_repeat1] = STATE(8116),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5492] = {
    [sym_heredoc_body] = STATE(8116),
    [aux_sym_call_repeat1] = STATE(8116),
    [aux_sym_argument_list_repeat1] = STATE(8118),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11302),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5493] = {
    [anon_sym_EQ] = ACTIONS(11304),
    [sym_comment] = ACTIONS(87),
  },
  [5494] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11306),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11308),
    [anon_sym_DASH_EQ] = ACTIONS(11308),
    [anon_sym_STAR_EQ] = ACTIONS(11308),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11308),
    [anon_sym_SLASH_EQ] = ACTIONS(11308),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11308),
    [anon_sym_PIPE_EQ] = ACTIONS(11308),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11308),
    [anon_sym_AMP_EQ] = ACTIONS(11308),
    [anon_sym_PERCENT_EQ] = ACTIONS(11308),
    [anon_sym_GT_GT_EQ] = ACTIONS(11308),
    [anon_sym_LT_LT_EQ] = ACTIONS(11308),
    [anon_sym_CARET_EQ] = ACTIONS(11308),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5495] = {
    [sym_string] = STATE(8121),
    [aux_sym_chained_string_repeat1] = STATE(8121),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11310),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5496] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8127),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_splat_argument] = STATE(8128),
    [sym_assignment] = STATE(8127),
    [sym_operator_assignment] = STATE(8127),
    [sym_conditional] = STATE(8127),
    [sym_range] = STATE(8127),
    [sym_binary] = STATE(8127),
    [sym_unary] = STATE(8127),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8128),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11312),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5497] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8131),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(8131),
    [sym_operator_assignment] = STATE(8131),
    [sym_conditional] = STATE(8131),
    [sym_range] = STATE(8131),
    [sym_binary] = STATE(8131),
    [sym_unary] = STATE(8131),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5498] = {
    [sym_string] = STATE(8132),
    [aux_sym_chained_string_repeat1] = STATE(8132),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5499] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5500] = {
    [sym_heredoc_body] = STATE(8133),
    [aux_sym_call_repeat1] = STATE(8133),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5501] = {
    [sym_heredoc_body] = STATE(8133),
    [aux_sym_call_repeat1] = STATE(8133),
    [aux_sym_argument_list_repeat1] = STATE(8134),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4660),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5502] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5503] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [5504] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8135),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8135),
    [sym_operator_assignment] = STATE(8135),
    [sym_conditional] = STATE(8135),
    [sym_range] = STATE(8135),
    [sym_binary] = STATE(8135),
    [sym_unary] = STATE(8135),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5505] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8136),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8136),
    [sym_operator_assignment] = STATE(8136),
    [sym_conditional] = STATE(8136),
    [sym_range] = STATE(8136),
    [sym_binary] = STATE(8136),
    [sym_unary] = STATE(8136),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5506] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8137),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8137),
    [sym_operator_assignment] = STATE(8137),
    [sym_conditional] = STATE(8137),
    [sym_range] = STATE(8137),
    [sym_binary] = STATE(8137),
    [sym_unary] = STATE(8137),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5507] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8138),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8138),
    [sym_operator_assignment] = STATE(8138),
    [sym_conditional] = STATE(8138),
    [sym_range] = STATE(8138),
    [sym_binary] = STATE(8138),
    [sym_unary] = STATE(8138),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5508] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8139),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8139),
    [sym_operator_assignment] = STATE(8139),
    [sym_conditional] = STATE(8139),
    [sym_range] = STATE(8139),
    [sym_binary] = STATE(8139),
    [sym_unary] = STATE(8139),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5509] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8140),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8140),
    [sym_operator_assignment] = STATE(8140),
    [sym_conditional] = STATE(8140),
    [sym_range] = STATE(8140),
    [sym_binary] = STATE(8140),
    [sym_unary] = STATE(8140),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5510] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8141),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8141),
    [sym_operator_assignment] = STATE(8141),
    [sym_conditional] = STATE(8141),
    [sym_range] = STATE(8141),
    [sym_binary] = STATE(8141),
    [sym_unary] = STATE(8141),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5511] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8142),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8142),
    [sym_operator_assignment] = STATE(8142),
    [sym_conditional] = STATE(8142),
    [sym_range] = STATE(8142),
    [sym_binary] = STATE(8142),
    [sym_unary] = STATE(8142),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5512] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8143),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8143),
    [sym_operator_assignment] = STATE(8143),
    [sym_conditional] = STATE(8143),
    [sym_range] = STATE(8143),
    [sym_binary] = STATE(8143),
    [sym_unary] = STATE(8143),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5513] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8144),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8144),
    [sym_operator_assignment] = STATE(8144),
    [sym_conditional] = STATE(8144),
    [sym_range] = STATE(8144),
    [sym_binary] = STATE(8144),
    [sym_unary] = STATE(8144),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5514] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8145),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8145),
    [sym_operator_assignment] = STATE(8145),
    [sym_conditional] = STATE(8145),
    [sym_range] = STATE(8145),
    [sym_binary] = STATE(8145),
    [sym_unary] = STATE(8145),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5515] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8146),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8146),
    [sym_operator_assignment] = STATE(8146),
    [sym_conditional] = STATE(8146),
    [sym_range] = STATE(8146),
    [sym_binary] = STATE(8146),
    [sym_unary] = STATE(8146),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5516] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8147),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_splat_argument] = STATE(8148),
    [sym_assignment] = STATE(8147),
    [sym_operator_assignment] = STATE(8147),
    [sym_conditional] = STATE(8147),
    [sym_range] = STATE(8147),
    [sym_binary] = STATE(8147),
    [sym_unary] = STATE(8147),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8148),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5517] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8149),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(8149),
    [sym_operator_assignment] = STATE(8149),
    [sym_conditional] = STATE(8149),
    [sym_range] = STATE(8149),
    [sym_binary] = STATE(8149),
    [sym_unary] = STATE(8149),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5518] = {
    [sym_string] = STATE(8150),
    [aux_sym_chained_string_repeat1] = STATE(8150),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5519] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [5520] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5521] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5522] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8151),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(8151),
    [sym_operator_assignment] = STATE(8151),
    [sym_conditional] = STATE(8151),
    [sym_range] = STATE(8151),
    [sym_binary] = STATE(8151),
    [sym_unary] = STATE(8151),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5523] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5524] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8152),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(8152),
    [sym_operator_assignment] = STATE(8152),
    [sym_conditional] = STATE(8152),
    [sym_range] = STATE(8152),
    [sym_binary] = STATE(8152),
    [sym_unary] = STATE(8152),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5525] = {
    [sym_heredoc_body] = STATE(8153),
    [aux_sym_call_repeat1] = STATE(8153),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5526] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8154),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5527] = {
    [sym_heredoc_body] = STATE(8155),
    [aux_sym_call_repeat1] = STATE(8155),
    [aux_sym_argument_list_repeat1] = STATE(8156),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8334),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5528] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5529] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5530] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5531] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5532] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5533] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5534] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [5535] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11326),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5536] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5537] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5538] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5539] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5540] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5541] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5542] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5543] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(8158),
    [sym_operator_assignment] = STATE(8158),
    [sym_conditional] = STATE(8158),
    [sym_range] = STATE(8158),
    [sym_binary] = STATE(8158),
    [sym_unary] = STATE(8158),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5544] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [5545] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5546] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8159),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(8159),
    [sym_operator_assignment] = STATE(8159),
    [sym_conditional] = STATE(8159),
    [sym_range] = STATE(8159),
    [sym_binary] = STATE(8159),
    [sym_unary] = STATE(8159),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5547] = {
    [sym_heredoc_body] = STATE(8160),
    [aux_sym_call_repeat1] = STATE(8160),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5548] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(8161),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11328),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5549] = {
    [sym_heredoc_body] = STATE(8162),
    [aux_sym_call_repeat1] = STATE(8162),
    [aux_sym_argument_list_repeat1] = STATE(8163),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8344),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5550] = {
    [sym_heredoc_body] = STATE(5550),
    [aux_sym_call_repeat1] = STATE(5550),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5551] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1070),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(1070),
    [sym_operator_assignment] = STATE(1070),
    [sym_conditional] = STATE(1070),
    [sym_range] = STATE(1070),
    [sym_binary] = STATE(1070),
    [sym_unary] = STATE(1070),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1076),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(1851),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__identifier_hash_key2] = ACTIONS(1857),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8348),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1875),
    [sym_identifier] = ACTIONS(1875),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5552] = {
    [sym_heredoc_body] = STATE(5550),
    [aux_sym_call_repeat1] = STATE(5550),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5553] = {
    [aux_sym_argument_list_repeat1] = STATE(5553),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11330),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5554] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5555] = {
    [aux_sym_exceptions_repeat1] = STATE(8165),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5556] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [5557] = {
    [sym_string] = STATE(5557),
    [aux_sym_chained_string_repeat1] = STATE(5557),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5558] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8166),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(258),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(258),
    [sym_assignment] = STATE(8166),
    [sym_operator_assignment] = STATE(8166),
    [sym_conditional] = STATE(8166),
    [sym_range] = STATE(8166),
    [sym_binary] = STATE(8166),
    [sym_unary] = STATE(8166),
    [sym_left_assignment_list] = STATE(257),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(258),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(258),
    [sym_false] = STATE(258),
    [sym_nil] = STATE(258),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(259),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(451),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(453),
    [anon_sym_yield] = ACTIONS(455),
    [anon_sym_break] = ACTIONS(457),
    [anon_sym_next] = ACTIONS(459),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(461),
    [anon_sym_defined_QMARK] = ACTIONS(463),
    [anon_sym_not] = ACTIONS(465),
    [anon_sym_BANG] = ACTIONS(467),
    [anon_sym_TILDE] = ACTIONS(467),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5559] = {
    [sym__line_break2] = ACTIONS(11333),
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [ts_builtin_sym_end] = ACTIONS(11333),
    [anon_sym___END__] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11333),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11333),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_when] = ACTIONS(11333),
    [anon_sym_elsif] = ACTIONS(11333),
    [anon_sym_else] = ACTIONS(11333),
    [anon_sym_then] = ACTIONS(11333),
    [anon_sym_ensure] = ACTIONS(11333),
    [anon_sym_EQ_GT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11333),
    [anon_sym_AMP_AMP] = ACTIONS(11333),
    [anon_sym_LT_LT] = ACTIONS(11333),
    [anon_sym_GT_GT] = ACTIONS(11333),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11333),
    [anon_sym_PLUS] = ACTIONS(11333),
    [anon_sym_SLASH] = ACTIONS(11333),
    [anon_sym_PERCENT] = ACTIONS(11333),
    [sym_comment] = ACTIONS(87),
  },
  [5560] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [5561] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [5562] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [5563] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8167),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8167),
    [sym_operator_assignment] = STATE(8167),
    [sym_conditional] = STATE(8167),
    [sym_range] = STATE(8167),
    [sym_binary] = STATE(8167),
    [sym_unary] = STATE(8167),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5564] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8168),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8168),
    [sym_operator_assignment] = STATE(8168),
    [sym_conditional] = STATE(8168),
    [sym_range] = STATE(8168),
    [sym_binary] = STATE(8168),
    [sym_unary] = STATE(8168),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5565] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8169),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8169),
    [sym_operator_assignment] = STATE(8169),
    [sym_conditional] = STATE(8169),
    [sym_range] = STATE(8169),
    [sym_binary] = STATE(8169),
    [sym_unary] = STATE(8169),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5566] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8170),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8170),
    [sym_operator_assignment] = STATE(8170),
    [sym_conditional] = STATE(8170),
    [sym_range] = STATE(8170),
    [sym_binary] = STATE(8170),
    [sym_unary] = STATE(8170),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5567] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8171),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8171),
    [sym_operator_assignment] = STATE(8171),
    [sym_conditional] = STATE(8171),
    [sym_range] = STATE(8171),
    [sym_binary] = STATE(8171),
    [sym_unary] = STATE(8171),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5568] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8172),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8172),
    [sym_operator_assignment] = STATE(8172),
    [sym_conditional] = STATE(8172),
    [sym_range] = STATE(8172),
    [sym_binary] = STATE(8172),
    [sym_unary] = STATE(8172),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5569] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8173),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8173),
    [sym_operator_assignment] = STATE(8173),
    [sym_conditional] = STATE(8173),
    [sym_range] = STATE(8173),
    [sym_binary] = STATE(8173),
    [sym_unary] = STATE(8173),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5570] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8174),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8174),
    [sym_operator_assignment] = STATE(8174),
    [sym_conditional] = STATE(8174),
    [sym_range] = STATE(8174),
    [sym_binary] = STATE(8174),
    [sym_unary] = STATE(8174),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5571] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8175),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8175),
    [sym_operator_assignment] = STATE(8175),
    [sym_conditional] = STATE(8175),
    [sym_range] = STATE(8175),
    [sym_binary] = STATE(8175),
    [sym_unary] = STATE(8175),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5572] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8176),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8176),
    [sym_operator_assignment] = STATE(8176),
    [sym_conditional] = STATE(8176),
    [sym_range] = STATE(8176),
    [sym_binary] = STATE(8176),
    [sym_unary] = STATE(8176),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5573] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8177),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8177),
    [sym_operator_assignment] = STATE(8177),
    [sym_conditional] = STATE(8177),
    [sym_range] = STATE(8177),
    [sym_binary] = STATE(8177),
    [sym_unary] = STATE(8177),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5574] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8178),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8178),
    [sym_operator_assignment] = STATE(8178),
    [sym_conditional] = STATE(8178),
    [sym_range] = STATE(8178),
    [sym_binary] = STATE(8178),
    [sym_unary] = STATE(8178),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5575] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8179),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_splat_argument] = STATE(8180),
    [sym_assignment] = STATE(8179),
    [sym_operator_assignment] = STATE(8179),
    [sym_conditional] = STATE(8179),
    [sym_range] = STATE(8179),
    [sym_binary] = STATE(8179),
    [sym_unary] = STATE(8179),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(8180),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5576] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8181),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(8181),
    [sym_operator_assignment] = STATE(8181),
    [sym_conditional] = STATE(8181),
    [sym_range] = STATE(8181),
    [sym_binary] = STATE(8181),
    [sym_unary] = STATE(8181),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5577] = {
    [sym_string] = STATE(8182),
    [aux_sym_chained_string_repeat1] = STATE(8182),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [5578] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [5579] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5580] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [5581] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5582] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [5583] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5584] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5585] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [5586] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11337),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5587] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5588] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5589] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5590] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5591] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5592] = {
    [sym_heredoc_body] = STATE(5592),
    [aux_sym_call_repeat1] = STATE(5592),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [5593] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1106),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(1106),
    [sym_operator_assignment] = STATE(1106),
    [sym_conditional] = STATE(1106),
    [sym_range] = STATE(1106),
    [sym_binary] = STATE(1106),
    [sym_unary] = STATE(1106),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1113),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(1915),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__identifier_hash_key2] = ACTIONS(1921),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8392),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1949),
    [sym_identifier] = ACTIONS(1949),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5594] = {
    [sym_heredoc_body] = STATE(5592),
    [aux_sym_call_repeat1] = STATE(5592),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [5595] = {
    [aux_sym_argument_list_repeat1] = STATE(5595),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11339),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [5596] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5597] = {
    [aux_sym_exceptions_repeat1] = STATE(8185),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [5598] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [5599] = {
    [sym_string] = STATE(5599),
    [aux_sym_chained_string_repeat1] = STATE(5599),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [5600] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [5601] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5602] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5603] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [5604] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8186),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8186),
    [sym_operator_assignment] = STATE(8186),
    [sym_conditional] = STATE(8186),
    [sym_range] = STATE(8186),
    [sym_binary] = STATE(8186),
    [sym_unary] = STATE(8186),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5605] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8187),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8187),
    [sym_operator_assignment] = STATE(8187),
    [sym_conditional] = STATE(8187),
    [sym_range] = STATE(8187),
    [sym_binary] = STATE(8187),
    [sym_unary] = STATE(8187),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5606] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8188),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8188),
    [sym_operator_assignment] = STATE(8188),
    [sym_conditional] = STATE(8188),
    [sym_range] = STATE(8188),
    [sym_binary] = STATE(8188),
    [sym_unary] = STATE(8188),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5607] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8189),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8189),
    [sym_operator_assignment] = STATE(8189),
    [sym_conditional] = STATE(8189),
    [sym_range] = STATE(8189),
    [sym_binary] = STATE(8189),
    [sym_unary] = STATE(8189),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5608] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8190),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8190),
    [sym_operator_assignment] = STATE(8190),
    [sym_conditional] = STATE(8190),
    [sym_range] = STATE(8190),
    [sym_binary] = STATE(8190),
    [sym_unary] = STATE(8190),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5609] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8191),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8191),
    [sym_operator_assignment] = STATE(8191),
    [sym_conditional] = STATE(8191),
    [sym_range] = STATE(8191),
    [sym_binary] = STATE(8191),
    [sym_unary] = STATE(8191),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5610] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8192),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8192),
    [sym_operator_assignment] = STATE(8192),
    [sym_conditional] = STATE(8192),
    [sym_range] = STATE(8192),
    [sym_binary] = STATE(8192),
    [sym_unary] = STATE(8192),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5611] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8193),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8193),
    [sym_operator_assignment] = STATE(8193),
    [sym_conditional] = STATE(8193),
    [sym_range] = STATE(8193),
    [sym_binary] = STATE(8193),
    [sym_unary] = STATE(8193),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5612] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8194),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8194),
    [sym_operator_assignment] = STATE(8194),
    [sym_conditional] = STATE(8194),
    [sym_range] = STATE(8194),
    [sym_binary] = STATE(8194),
    [sym_unary] = STATE(8194),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5613] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8195),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8195),
    [sym_operator_assignment] = STATE(8195),
    [sym_conditional] = STATE(8195),
    [sym_range] = STATE(8195),
    [sym_binary] = STATE(8195),
    [sym_unary] = STATE(8195),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5614] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8196),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8196),
    [sym_operator_assignment] = STATE(8196),
    [sym_conditional] = STATE(8196),
    [sym_range] = STATE(8196),
    [sym_binary] = STATE(8196),
    [sym_unary] = STATE(8196),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5615] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8197),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8197),
    [sym_operator_assignment] = STATE(8197),
    [sym_conditional] = STATE(8197),
    [sym_range] = STATE(8197),
    [sym_binary] = STATE(8197),
    [sym_unary] = STATE(8197),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5616] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2976),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(2976),
    [sym_operator_assignment] = STATE(2976),
    [sym_conditional] = STATE(2976),
    [sym_range] = STATE(2976),
    [sym_binary] = STATE(2976),
    [sym_unary] = STATE(2976),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4742),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5617] = {
    [aux_sym_exceptions_repeat1] = STATE(8198),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(8424),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [5618] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2976),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_splat_argument] = STATE(8199),
    [sym_assignment] = STATE(2976),
    [sym_operator_assignment] = STATE(2976),
    [sym_conditional] = STATE(2976),
    [sym_range] = STATE(2976),
    [sym_binary] = STATE(2976),
    [sym_unary] = STATE(2976),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8199),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4742),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5619] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8200),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(8200),
    [sym_operator_assignment] = STATE(8200),
    [sym_conditional] = STATE(8200),
    [sym_range] = STATE(8200),
    [sym_binary] = STATE(8200),
    [sym_unary] = STATE(8200),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5620] = {
    [sym__line_break2] = ACTIONS(11342),
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [ts_builtin_sym_end] = ACTIONS(11342),
    [anon_sym___END__] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11342),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_end] = ACTIONS(11342),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_when] = ACTIONS(11342),
    [anon_sym_elsif] = ACTIONS(11342),
    [anon_sym_else] = ACTIONS(11342),
    [anon_sym_then] = ACTIONS(11342),
    [anon_sym_ensure] = ACTIONS(11342),
    [anon_sym_EQ_GT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11342),
    [anon_sym_AMP_AMP] = ACTIONS(11342),
    [anon_sym_LT_LT] = ACTIONS(11342),
    [anon_sym_GT_GT] = ACTIONS(11342),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11342),
    [anon_sym_PLUS] = ACTIONS(11342),
    [anon_sym_SLASH] = ACTIONS(11342),
    [anon_sym_PERCENT] = ACTIONS(11342),
    [sym_comment] = ACTIONS(87),
  },
  [5621] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5622] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8201),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8201),
    [sym_operator_assignment] = STATE(8201),
    [sym_conditional] = STATE(8201),
    [sym_range] = STATE(8201),
    [sym_binary] = STATE(8201),
    [sym_unary] = STATE(8201),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5623] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8202),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8202),
    [sym_operator_assignment] = STATE(8202),
    [sym_conditional] = STATE(8202),
    [sym_range] = STATE(8202),
    [sym_binary] = STATE(8202),
    [sym_unary] = STATE(8202),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5624] = {
    [anon_sym_COLON] = ACTIONS(11346),
    [sym_comment] = ACTIONS(87),
  },
  [5625] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8204),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8204),
    [sym_operator_assignment] = STATE(8204),
    [sym_conditional] = STATE(8204),
    [sym_range] = STATE(8204),
    [sym_binary] = STATE(8204),
    [sym_unary] = STATE(8204),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5626] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11348),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5627] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11350),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5628] = {
    [sym_heredoc_body] = STATE(8206),
    [aux_sym_call_repeat1] = STATE(8206),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5629] = {
    [sym_heredoc_body] = STATE(8206),
    [aux_sym_call_repeat1] = STATE(8206),
    [aux_sym_argument_list_repeat1] = STATE(8208),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11352),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5630] = {
    [sym_string] = STATE(3050),
    [aux_sym_chained_string_repeat1] = STATE(3050),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11354),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5631] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5632] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [5633] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8209),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8209),
    [sym_operator_assignment] = STATE(8209),
    [sym_conditional] = STATE(8209),
    [sym_range] = STATE(8209),
    [sym_binary] = STATE(8209),
    [sym_unary] = STATE(8209),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5634] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8210),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8210),
    [sym_operator_assignment] = STATE(8210),
    [sym_conditional] = STATE(8210),
    [sym_range] = STATE(8210),
    [sym_binary] = STATE(8210),
    [sym_unary] = STATE(8210),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5635] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8211),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8211),
    [sym_operator_assignment] = STATE(8211),
    [sym_conditional] = STATE(8211),
    [sym_range] = STATE(8211),
    [sym_binary] = STATE(8211),
    [sym_unary] = STATE(8211),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5636] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8212),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8212),
    [sym_operator_assignment] = STATE(8212),
    [sym_conditional] = STATE(8212),
    [sym_range] = STATE(8212),
    [sym_binary] = STATE(8212),
    [sym_unary] = STATE(8212),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5637] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8213),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8213),
    [sym_operator_assignment] = STATE(8213),
    [sym_conditional] = STATE(8213),
    [sym_range] = STATE(8213),
    [sym_binary] = STATE(8213),
    [sym_unary] = STATE(8213),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5638] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8214),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8214),
    [sym_operator_assignment] = STATE(8214),
    [sym_conditional] = STATE(8214),
    [sym_range] = STATE(8214),
    [sym_binary] = STATE(8214),
    [sym_unary] = STATE(8214),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5639] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8215),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8215),
    [sym_operator_assignment] = STATE(8215),
    [sym_conditional] = STATE(8215),
    [sym_range] = STATE(8215),
    [sym_binary] = STATE(8215),
    [sym_unary] = STATE(8215),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5640] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8216),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8216),
    [sym_operator_assignment] = STATE(8216),
    [sym_conditional] = STATE(8216),
    [sym_range] = STATE(8216),
    [sym_binary] = STATE(8216),
    [sym_unary] = STATE(8216),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5641] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8217),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8217),
    [sym_operator_assignment] = STATE(8217),
    [sym_conditional] = STATE(8217),
    [sym_range] = STATE(8217),
    [sym_binary] = STATE(8217),
    [sym_unary] = STATE(8217),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5642] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8218),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8218),
    [sym_operator_assignment] = STATE(8218),
    [sym_conditional] = STATE(8218),
    [sym_range] = STATE(8218),
    [sym_binary] = STATE(8218),
    [sym_unary] = STATE(8218),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5643] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8219),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8219),
    [sym_operator_assignment] = STATE(8219),
    [sym_conditional] = STATE(8219),
    [sym_range] = STATE(8219),
    [sym_binary] = STATE(8219),
    [sym_unary] = STATE(8219),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5644] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8220),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8220),
    [sym_operator_assignment] = STATE(8220),
    [sym_conditional] = STATE(8220),
    [sym_range] = STATE(8220),
    [sym_binary] = STATE(8220),
    [sym_unary] = STATE(8220),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5645] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8229),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(8229),
    [sym_operator_assignment] = STATE(8229),
    [sym_conditional] = STATE(8229),
    [sym_range] = STATE(8229),
    [sym_binary] = STATE(8229),
    [sym_unary] = STATE(8229),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [5646] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8233),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(8233),
    [sym_operator_assignment] = STATE(8233),
    [sym_conditional] = STATE(8233),
    [sym_range] = STATE(8233),
    [sym_binary] = STATE(8233),
    [sym_unary] = STATE(8233),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [5647] = {
    [anon_sym_COLON] = ACTIONS(11374),
    [sym_comment] = ACTIONS(87),
  },
  [5648] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8235),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(8235),
    [sym_operator_assignment] = STATE(8235),
    [sym_conditional] = STATE(8235),
    [sym_range] = STATE(8235),
    [sym_binary] = STATE(8235),
    [sym_unary] = STATE(8235),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [5649] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11376),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_in] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5650] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11378),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [5651] = {
    [sym_heredoc_body] = STATE(8237),
    [aux_sym_call_repeat1] = STATE(8237),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5652] = {
    [sym_heredoc_body] = STATE(8237),
    [aux_sym_call_repeat1] = STATE(8237),
    [aux_sym_argument_list_repeat1] = STATE(8239),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11380),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_in] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5653] = {
    [sym_string] = STATE(5705),
    [aux_sym_chained_string_repeat1] = STATE(5705),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11382),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5654] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8240),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_splat_argument] = STATE(8241),
    [sym_assignment] = STATE(8240),
    [sym_operator_assignment] = STATE(8240),
    [sym_conditional] = STATE(8240),
    [sym_range] = STATE(8240),
    [sym_binary] = STATE(8240),
    [sym_unary] = STATE(8240),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(8241),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5655] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8242),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(8242),
    [sym_operator_assignment] = STATE(8242),
    [sym_conditional] = STATE(8242),
    [sym_range] = STATE(8242),
    [sym_binary] = STATE(8242),
    [sym_unary] = STATE(8242),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5656] = {
    [sym_string] = STATE(8243),
    [aux_sym_chained_string_repeat1] = STATE(8243),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5657] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(8464),
    [anon_sym_or] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [5658] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5659] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5660] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8244),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(8244),
    [sym_operator_assignment] = STATE(8244),
    [sym_conditional] = STATE(8244),
    [sym_range] = STATE(8244),
    [sym_binary] = STATE(8244),
    [sym_unary] = STATE(8244),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5661] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5662] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8245),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(8245),
    [sym_operator_assignment] = STATE(8245),
    [sym_conditional] = STATE(8245),
    [sym_range] = STATE(8245),
    [sym_binary] = STATE(8245),
    [sym_unary] = STATE(8245),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5663] = {
    [sym_heredoc_body] = STATE(8246),
    [aux_sym_call_repeat1] = STATE(8246),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5664] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(8247),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11384),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5665] = {
    [sym_heredoc_body] = STATE(8248),
    [aux_sym_call_repeat1] = STATE(8248),
    [aux_sym_argument_list_repeat1] = STATE(8249),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8496),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5666] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_in] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5667] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5668] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5669] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5670] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5671] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5672] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(8464),
    [anon_sym_or] = ACTIONS(8464),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [5673] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11386),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5674] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5675] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5676] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5677] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5678] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5679] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [5680] = {
    [sym_string] = STATE(5705),
    [aux_sym_chained_string_repeat1] = STATE(5705),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5681] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [5682] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [5683] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8251),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8251),
    [sym_operator_assignment] = STATE(8251),
    [sym_conditional] = STATE(8251),
    [sym_range] = STATE(8251),
    [sym_binary] = STATE(8251),
    [sym_unary] = STATE(8251),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5684] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [5685] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [5686] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [5687] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8252),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8252),
    [sym_operator_assignment] = STATE(8252),
    [sym_conditional] = STATE(8252),
    [sym_range] = STATE(8252),
    [sym_binary] = STATE(8252),
    [sym_unary] = STATE(8252),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5688] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8253),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8253),
    [sym_operator_assignment] = STATE(8253),
    [sym_conditional] = STATE(8253),
    [sym_range] = STATE(8253),
    [sym_binary] = STATE(8253),
    [sym_unary] = STATE(8253),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5689] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8254),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8254),
    [sym_operator_assignment] = STATE(8254),
    [sym_conditional] = STATE(8254),
    [sym_range] = STATE(8254),
    [sym_binary] = STATE(8254),
    [sym_unary] = STATE(8254),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5690] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8255),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8255),
    [sym_operator_assignment] = STATE(8255),
    [sym_conditional] = STATE(8255),
    [sym_range] = STATE(8255),
    [sym_binary] = STATE(8255),
    [sym_unary] = STATE(8255),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5691] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8256),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8256),
    [sym_operator_assignment] = STATE(8256),
    [sym_conditional] = STATE(8256),
    [sym_range] = STATE(8256),
    [sym_binary] = STATE(8256),
    [sym_unary] = STATE(8256),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5692] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8257),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8257),
    [sym_operator_assignment] = STATE(8257),
    [sym_conditional] = STATE(8257),
    [sym_range] = STATE(8257),
    [sym_binary] = STATE(8257),
    [sym_unary] = STATE(8257),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5693] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8258),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8258),
    [sym_operator_assignment] = STATE(8258),
    [sym_conditional] = STATE(8258),
    [sym_range] = STATE(8258),
    [sym_binary] = STATE(8258),
    [sym_unary] = STATE(8258),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5694] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8259),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8259),
    [sym_operator_assignment] = STATE(8259),
    [sym_conditional] = STATE(8259),
    [sym_range] = STATE(8259),
    [sym_binary] = STATE(8259),
    [sym_unary] = STATE(8259),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5695] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8260),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8260),
    [sym_operator_assignment] = STATE(8260),
    [sym_conditional] = STATE(8260),
    [sym_range] = STATE(8260),
    [sym_binary] = STATE(8260),
    [sym_unary] = STATE(8260),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5696] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8261),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8261),
    [sym_operator_assignment] = STATE(8261),
    [sym_conditional] = STATE(8261),
    [sym_range] = STATE(8261),
    [sym_binary] = STATE(8261),
    [sym_unary] = STATE(8261),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5697] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8262),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8262),
    [sym_operator_assignment] = STATE(8262),
    [sym_conditional] = STATE(8262),
    [sym_range] = STATE(8262),
    [sym_binary] = STATE(8262),
    [sym_unary] = STATE(8262),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5698] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8263),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8263),
    [sym_operator_assignment] = STATE(8263),
    [sym_conditional] = STATE(8263),
    [sym_range] = STATE(8263),
    [sym_binary] = STATE(8263),
    [sym_unary] = STATE(8263),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5699] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8264),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8264),
    [sym_operator_assignment] = STATE(8264),
    [sym_conditional] = STATE(8264),
    [sym_range] = STATE(8264),
    [sym_binary] = STATE(8264),
    [sym_unary] = STATE(8264),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5700] = {
    [sym_heredoc_body] = STATE(8265),
    [aux_sym_call_repeat1] = STATE(8265),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5701] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(8266),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11388),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5702] = {
    [sym_heredoc_body] = STATE(8267),
    [aux_sym_call_repeat1] = STATE(8267),
    [aux_sym_argument_list_repeat1] = STATE(8268),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8534),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5703] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8269),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_splat_argument] = STATE(8270),
    [sym_assignment] = STATE(8269),
    [sym_operator_assignment] = STATE(8269),
    [sym_conditional] = STATE(8269),
    [sym_range] = STATE(8269),
    [sym_binary] = STATE(8269),
    [sym_unary] = STATE(8269),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(8270),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5704] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8271),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(8271),
    [sym_operator_assignment] = STATE(8271),
    [sym_conditional] = STATE(8271),
    [sym_range] = STATE(8271),
    [sym_binary] = STATE(8271),
    [sym_unary] = STATE(8271),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [5705] = {
    [sym_string] = STATE(8272),
    [aux_sym_chained_string_repeat1] = STATE(8272),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [5706] = {
    [sym_heredoc_body] = STATE(5706),
    [aux_sym_call_repeat1] = STATE(5706),
    [sym__heredoc_body_start2] = ACTIONS(10775),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_in] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5707] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1131),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(7612),
    [sym_splat_argument] = STATE(7612),
    [sym_hash_splat_argument] = STATE(7612),
    [sym_block_argument] = STATE(7612),
    [sym_assignment] = STATE(1131),
    [sym_operator_assignment] = STATE(1131),
    [sym_conditional] = STATE(1131),
    [sym_range] = STATE(1131),
    [sym_binary] = STATE(1131),
    [sym_unary] = STATE(1131),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1137),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7612),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1965),
    [sym__splat_star2] = ACTIONS(1967),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(1971),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1973),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1991),
    [sym_identifier] = ACTIONS(1991),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5708] = {
    [sym_heredoc_body] = STATE(5706),
    [aux_sym_call_repeat1] = STATE(5706),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_in] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5709] = {
    [aux_sym_argument_list_repeat1] = STATE(5709),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(11390),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5710] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5711] = {
    [aux_sym_exceptions_repeat1] = STATE(8274),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5712] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [5713] = {
    [sym_string] = STATE(5713),
    [aux_sym_chained_string_repeat1] = STATE(5713),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5714] = {
    [sym__line_break2] = ACTIONS(11393),
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [ts_builtin_sym_end] = ACTIONS(11393),
    [anon_sym___END__] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_end] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_when] = ACTIONS(11393),
    [anon_sym_elsif] = ACTIONS(11393),
    [anon_sym_else] = ACTIONS(11393),
    [anon_sym_then] = ACTIONS(11393),
    [anon_sym_ensure] = ACTIONS(11393),
    [anon_sym_EQ_GT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [5715] = {
    [anon_sym_end] = ACTIONS(11397),
    [sym_comment] = ACTIONS(87),
  },
  [5716] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5717] = {
    [sym_heredoc_body] = STATE(8276),
    [aux_sym_call_repeat1] = STATE(8276),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5718] = {
    [sym_heredoc_body] = STATE(8276),
    [aux_sym_call_repeat1] = STATE(8276),
    [aux_sym_argument_list_repeat1] = STATE(8277),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5719] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5720] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [5721] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8278),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8278),
    [sym_operator_assignment] = STATE(8278),
    [sym_conditional] = STATE(8278),
    [sym_range] = STATE(8278),
    [sym_binary] = STATE(8278),
    [sym_unary] = STATE(8278),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5722] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8279),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8279),
    [sym_operator_assignment] = STATE(8279),
    [sym_conditional] = STATE(8279),
    [sym_range] = STATE(8279),
    [sym_binary] = STATE(8279),
    [sym_unary] = STATE(8279),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5723] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8280),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8280),
    [sym_operator_assignment] = STATE(8280),
    [sym_conditional] = STATE(8280),
    [sym_range] = STATE(8280),
    [sym_binary] = STATE(8280),
    [sym_unary] = STATE(8280),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5724] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8281),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8281),
    [sym_operator_assignment] = STATE(8281),
    [sym_conditional] = STATE(8281),
    [sym_range] = STATE(8281),
    [sym_binary] = STATE(8281),
    [sym_unary] = STATE(8281),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5725] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8282),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8282),
    [sym_operator_assignment] = STATE(8282),
    [sym_conditional] = STATE(8282),
    [sym_range] = STATE(8282),
    [sym_binary] = STATE(8282),
    [sym_unary] = STATE(8282),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5726] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8283),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8283),
    [sym_operator_assignment] = STATE(8283),
    [sym_conditional] = STATE(8283),
    [sym_range] = STATE(8283),
    [sym_binary] = STATE(8283),
    [sym_unary] = STATE(8283),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5727] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8284),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8284),
    [sym_operator_assignment] = STATE(8284),
    [sym_conditional] = STATE(8284),
    [sym_range] = STATE(8284),
    [sym_binary] = STATE(8284),
    [sym_unary] = STATE(8284),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5728] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8285),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8285),
    [sym_operator_assignment] = STATE(8285),
    [sym_conditional] = STATE(8285),
    [sym_range] = STATE(8285),
    [sym_binary] = STATE(8285),
    [sym_unary] = STATE(8285),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5729] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8286),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8286),
    [sym_operator_assignment] = STATE(8286),
    [sym_conditional] = STATE(8286),
    [sym_range] = STATE(8286),
    [sym_binary] = STATE(8286),
    [sym_unary] = STATE(8286),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5730] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8287),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8287),
    [sym_operator_assignment] = STATE(8287),
    [sym_conditional] = STATE(8287),
    [sym_range] = STATE(8287),
    [sym_binary] = STATE(8287),
    [sym_unary] = STATE(8287),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5731] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8288),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8288),
    [sym_operator_assignment] = STATE(8288),
    [sym_conditional] = STATE(8288),
    [sym_range] = STATE(8288),
    [sym_binary] = STATE(8288),
    [sym_unary] = STATE(8288),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5732] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8289),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8289),
    [sym_operator_assignment] = STATE(8289),
    [sym_conditional] = STATE(8289),
    [sym_range] = STATE(8289),
    [sym_binary] = STATE(8289),
    [sym_unary] = STATE(8289),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5733] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8290),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_splat_argument] = STATE(8291),
    [sym_assignment] = STATE(8290),
    [sym_operator_assignment] = STATE(8290),
    [sym_conditional] = STATE(8290),
    [sym_range] = STATE(8290),
    [sym_binary] = STATE(8290),
    [sym_unary] = STATE(8290),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8291),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5734] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8292),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(8292),
    [sym_operator_assignment] = STATE(8292),
    [sym_conditional] = STATE(8292),
    [sym_range] = STATE(8292),
    [sym_binary] = STATE(8292),
    [sym_unary] = STATE(8292),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5735] = {
    [sym_string] = STATE(8293),
    [aux_sym_chained_string_repeat1] = STATE(8293),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5736] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [5737] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5738] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5739] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8294),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(8294),
    [sym_operator_assignment] = STATE(8294),
    [sym_conditional] = STATE(8294),
    [sym_range] = STATE(8294),
    [sym_binary] = STATE(8294),
    [sym_unary] = STATE(8294),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5740] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5741] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8295),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(8295),
    [sym_operator_assignment] = STATE(8295),
    [sym_conditional] = STATE(8295),
    [sym_range] = STATE(8295),
    [sym_binary] = STATE(8295),
    [sym_unary] = STATE(8295),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5742] = {
    [sym_heredoc_body] = STATE(8296),
    [aux_sym_call_repeat1] = STATE(8296),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5743] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8297),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11399),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5744] = {
    [sym_heredoc_body] = STATE(8298),
    [aux_sym_call_repeat1] = STATE(8298),
    [aux_sym_argument_list_repeat1] = STATE(8299),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8588),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5745] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5746] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5747] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5748] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5749] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5750] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5751] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [5752] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11401),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5753] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5754] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5755] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5756] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5757] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5758] = {
    [sym_heredoc_body] = STATE(5758),
    [aux_sym_call_repeat1] = STATE(5758),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5759] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1155),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(1155),
    [sym_operator_assignment] = STATE(1155),
    [sym_conditional] = STATE(1155),
    [sym_range] = STATE(1155),
    [sym_binary] = STATE(1155),
    [sym_unary] = STATE(1155),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1161),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2001),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__identifier_hash_key2] = ACTIONS(2007),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8592),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2025),
    [sym_identifier] = ACTIONS(2025),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5760] = {
    [sym_heredoc_body] = STATE(5758),
    [aux_sym_call_repeat1] = STATE(5758),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5761] = {
    [aux_sym_argument_list_repeat1] = STATE(5761),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11403),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5762] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5763] = {
    [aux_sym_exceptions_repeat1] = STATE(8302),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5764] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [5765] = {
    [sym_string] = STATE(5765),
    [aux_sym_chained_string_repeat1] = STATE(5765),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5766] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8303),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(8303),
    [sym_operator_assignment] = STATE(8303),
    [sym_conditional] = STATE(8303),
    [sym_range] = STATE(8303),
    [sym_binary] = STATE(8303),
    [sym_unary] = STATE(8303),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5767] = {
    [sym__line_break2] = ACTIONS(11406),
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [ts_builtin_sym_end] = ACTIONS(11406),
    [anon_sym___END__] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_end] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_when] = ACTIONS(11406),
    [anon_sym_elsif] = ACTIONS(11406),
    [anon_sym_else] = ACTIONS(11406),
    [anon_sym_then] = ACTIONS(11406),
    [anon_sym_ensure] = ACTIONS(11406),
    [anon_sym_EQ_GT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [5768] = {
    [anon_sym_end] = ACTIONS(11410),
    [sym_comment] = ACTIONS(87),
  },
  [5769] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [5770] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5771] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5772] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [5773] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8305),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8305),
    [sym_operator_assignment] = STATE(8305),
    [sym_conditional] = STATE(8305),
    [sym_range] = STATE(8305),
    [sym_binary] = STATE(8305),
    [sym_unary] = STATE(8305),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5774] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8306),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8306),
    [sym_operator_assignment] = STATE(8306),
    [sym_conditional] = STATE(8306),
    [sym_range] = STATE(8306),
    [sym_binary] = STATE(8306),
    [sym_unary] = STATE(8306),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5775] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8307),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8307),
    [sym_operator_assignment] = STATE(8307),
    [sym_conditional] = STATE(8307),
    [sym_range] = STATE(8307),
    [sym_binary] = STATE(8307),
    [sym_unary] = STATE(8307),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5776] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8308),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8308),
    [sym_operator_assignment] = STATE(8308),
    [sym_conditional] = STATE(8308),
    [sym_range] = STATE(8308),
    [sym_binary] = STATE(8308),
    [sym_unary] = STATE(8308),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5777] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8309),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8309),
    [sym_operator_assignment] = STATE(8309),
    [sym_conditional] = STATE(8309),
    [sym_range] = STATE(8309),
    [sym_binary] = STATE(8309),
    [sym_unary] = STATE(8309),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5778] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8310),
    [sym_operator_assignment] = STATE(8310),
    [sym_conditional] = STATE(8310),
    [sym_range] = STATE(8310),
    [sym_binary] = STATE(8310),
    [sym_unary] = STATE(8310),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5779] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8311),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8311),
    [sym_operator_assignment] = STATE(8311),
    [sym_conditional] = STATE(8311),
    [sym_range] = STATE(8311),
    [sym_binary] = STATE(8311),
    [sym_unary] = STATE(8311),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5780] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8312),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8312),
    [sym_operator_assignment] = STATE(8312),
    [sym_conditional] = STATE(8312),
    [sym_range] = STATE(8312),
    [sym_binary] = STATE(8312),
    [sym_unary] = STATE(8312),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5781] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8313),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8313),
    [sym_operator_assignment] = STATE(8313),
    [sym_conditional] = STATE(8313),
    [sym_range] = STATE(8313),
    [sym_binary] = STATE(8313),
    [sym_unary] = STATE(8313),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5782] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8314),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8314),
    [sym_operator_assignment] = STATE(8314),
    [sym_conditional] = STATE(8314),
    [sym_range] = STATE(8314),
    [sym_binary] = STATE(8314),
    [sym_unary] = STATE(8314),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5783] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8315),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8315),
    [sym_operator_assignment] = STATE(8315),
    [sym_conditional] = STATE(8315),
    [sym_range] = STATE(8315),
    [sym_binary] = STATE(8315),
    [sym_unary] = STATE(8315),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5784] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8316),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8316),
    [sym_operator_assignment] = STATE(8316),
    [sym_conditional] = STATE(8316),
    [sym_range] = STATE(8316),
    [sym_binary] = STATE(8316),
    [sym_unary] = STATE(8316),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5785] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3119),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(3119),
    [sym_operator_assignment] = STATE(3119),
    [sym_conditional] = STATE(3119),
    [sym_range] = STATE(3119),
    [sym_binary] = STATE(3119),
    [sym_unary] = STATE(3119),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4942),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5786] = {
    [aux_sym_exceptions_repeat1] = STATE(8317),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(8628),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [5787] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3119),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_splat_argument] = STATE(8318),
    [sym_assignment] = STATE(3119),
    [sym_operator_assignment] = STATE(3119),
    [sym_conditional] = STATE(3119),
    [sym_range] = STATE(3119),
    [sym_binary] = STATE(3119),
    [sym_unary] = STATE(3119),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8318),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4942),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5788] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8319),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(8319),
    [sym_operator_assignment] = STATE(8319),
    [sym_conditional] = STATE(8319),
    [sym_range] = STATE(8319),
    [sym_binary] = STATE(8319),
    [sym_unary] = STATE(8319),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5789] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(8668),
    [anon_sym_or] = ACTIONS(8668),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [5790] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5791] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8324),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(8324),
    [sym_operator_assignment] = STATE(8324),
    [sym_conditional] = STATE(8324),
    [sym_range] = STATE(8324),
    [sym_binary] = STATE(8324),
    [sym_unary] = STATE(8324),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5792] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8327),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(8327),
    [sym_operator_assignment] = STATE(8327),
    [sym_conditional] = STATE(8327),
    [sym_range] = STATE(8327),
    [sym_binary] = STATE(8327),
    [sym_unary] = STATE(8327),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5793] = {
    [anon_sym_COLON] = ACTIONS(11422),
    [sym_comment] = ACTIONS(87),
  },
  [5794] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8329),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(8329),
    [sym_operator_assignment] = STATE(8329),
    [sym_conditional] = STATE(8329),
    [sym_range] = STATE(8329),
    [sym_binary] = STATE(8329),
    [sym_unary] = STATE(8329),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5795] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11424),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5796] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11426),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [5797] = {
    [sym_heredoc_body] = STATE(8331),
    [aux_sym_call_repeat1] = STATE(8331),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5798] = {
    [sym_heredoc_body] = STATE(8331),
    [aux_sym_call_repeat1] = STATE(8331),
    [aux_sym_argument_list_repeat1] = STATE(8333),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11428),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5799] = {
    [sym_string] = STATE(3265),
    [aux_sym_chained_string_repeat1] = STATE(3265),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11430),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5800] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5801] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [5802] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_pattern] = STATE(8334),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3135),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_splat_argument] = STATE(3137),
    [sym_assignment] = STATE(3135),
    [sym_operator_assignment] = STATE(3135),
    [sym_conditional] = STATE(3135),
    [sym_range] = STATE(3135),
    [sym_binary] = STATE(3135),
    [sym_unary] = STATE(3135),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(4954),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5803] = {
    [sym__statements] = STATE(8344),
    [sym__top_level_statement] = STATE(8345),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(8346),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_when] = STATE(8347),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(8347),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(8348),
    [sym_operator_assignment] = STATE(8348),
    [sym_conditional] = STATE(8348),
    [sym_range] = STATE(8348),
    [sym_binary] = STATE(8348),
    [sym_unary] = STATE(8348),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11434),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(11444),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [anon_sym_undef] = ACTIONS(11458),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5804] = {
    [sym__then] = STATE(8353),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [aux_sym_when_repeat1] = STATE(8354),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(8644),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_then] = ACTIONS(11460),
    [sym_comment] = ACTIONS(87),
  },
  [5805] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8355),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8355),
    [sym_operator_assignment] = STATE(8355),
    [sym_conditional] = STATE(8355),
    [sym_range] = STATE(8355),
    [sym_binary] = STATE(8355),
    [sym_unary] = STATE(8355),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5806] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8356),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8356),
    [sym_operator_assignment] = STATE(8356),
    [sym_conditional] = STATE(8356),
    [sym_range] = STATE(8356),
    [sym_binary] = STATE(8356),
    [sym_unary] = STATE(8356),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5807] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8357),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8357),
    [sym_operator_assignment] = STATE(8357),
    [sym_conditional] = STATE(8357),
    [sym_range] = STATE(8357),
    [sym_binary] = STATE(8357),
    [sym_unary] = STATE(8357),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5808] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8358),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8358),
    [sym_operator_assignment] = STATE(8358),
    [sym_conditional] = STATE(8358),
    [sym_range] = STATE(8358),
    [sym_binary] = STATE(8358),
    [sym_unary] = STATE(8358),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5809] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8359),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8359),
    [sym_operator_assignment] = STATE(8359),
    [sym_conditional] = STATE(8359),
    [sym_range] = STATE(8359),
    [sym_binary] = STATE(8359),
    [sym_unary] = STATE(8359),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5810] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8360),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8360),
    [sym_operator_assignment] = STATE(8360),
    [sym_conditional] = STATE(8360),
    [sym_range] = STATE(8360),
    [sym_binary] = STATE(8360),
    [sym_unary] = STATE(8360),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5811] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8361),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8361),
    [sym_operator_assignment] = STATE(8361),
    [sym_conditional] = STATE(8361),
    [sym_range] = STATE(8361),
    [sym_binary] = STATE(8361),
    [sym_unary] = STATE(8361),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5812] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8362),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8362),
    [sym_operator_assignment] = STATE(8362),
    [sym_conditional] = STATE(8362),
    [sym_range] = STATE(8362),
    [sym_binary] = STATE(8362),
    [sym_unary] = STATE(8362),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5813] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8363),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8363),
    [sym_operator_assignment] = STATE(8363),
    [sym_conditional] = STATE(8363),
    [sym_range] = STATE(8363),
    [sym_binary] = STATE(8363),
    [sym_unary] = STATE(8363),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5814] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8364),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8364),
    [sym_operator_assignment] = STATE(8364),
    [sym_conditional] = STATE(8364),
    [sym_range] = STATE(8364),
    [sym_binary] = STATE(8364),
    [sym_unary] = STATE(8364),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5815] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8365),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8365),
    [sym_operator_assignment] = STATE(8365),
    [sym_conditional] = STATE(8365),
    [sym_range] = STATE(8365),
    [sym_binary] = STATE(8365),
    [sym_unary] = STATE(8365),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5816] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8366),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8366),
    [sym_operator_assignment] = STATE(8366),
    [sym_conditional] = STATE(8366),
    [sym_range] = STATE(8366),
    [sym_binary] = STATE(8366),
    [sym_unary] = STATE(8366),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5817] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8375),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(8375),
    [sym_operator_assignment] = STATE(8375),
    [sym_conditional] = STATE(8375),
    [sym_range] = STATE(8375),
    [sym_binary] = STATE(8375),
    [sym_unary] = STATE(8375),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5818] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8380),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(8380),
    [sym_operator_assignment] = STATE(8380),
    [sym_conditional] = STATE(8380),
    [sym_range] = STATE(8380),
    [sym_binary] = STATE(8380),
    [sym_unary] = STATE(8380),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5819] = {
    [anon_sym_COLON] = ACTIONS(11484),
    [sym_comment] = ACTIONS(87),
  },
  [5820] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8382),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(8382),
    [sym_operator_assignment] = STATE(8382),
    [sym_conditional] = STATE(8382),
    [sym_range] = STATE(8382),
    [sym_binary] = STATE(8382),
    [sym_unary] = STATE(8382),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [5821] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11486),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5822] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11488),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [5823] = {
    [sym_heredoc_body] = STATE(8384),
    [aux_sym_call_repeat1] = STATE(8384),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5824] = {
    [sym_heredoc_body] = STATE(8384),
    [aux_sym_call_repeat1] = STATE(8384),
    [aux_sym_argument_list_repeat1] = STATE(8386),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11490),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [5825] = {
    [sym_string] = STATE(5978),
    [aux_sym_chained_string_repeat1] = STATE(5978),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11492),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5826] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8388),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_splat_argument] = STATE(8389),
    [sym_assignment] = STATE(8388),
    [sym_operator_assignment] = STATE(8388),
    [sym_conditional] = STATE(8388),
    [sym_range] = STATE(8388),
    [sym_binary] = STATE(8388),
    [sym_unary] = STATE(8388),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8389),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11494),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5827] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8390),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(8390),
    [sym_operator_assignment] = STATE(8390),
    [sym_conditional] = STATE(8390),
    [sym_range] = STATE(8390),
    [sym_binary] = STATE(8390),
    [sym_unary] = STATE(8390),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5828] = {
    [sym_string] = STATE(8391),
    [aux_sym_chained_string_repeat1] = STATE(8391),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5829] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5830] = {
    [sym_heredoc_body] = STATE(8392),
    [aux_sym_call_repeat1] = STATE(8392),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5831] = {
    [sym_heredoc_body] = STATE(8392),
    [aux_sym_call_repeat1] = STATE(8392),
    [aux_sym_argument_list_repeat1] = STATE(8393),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5832] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5833] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [5834] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8394),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8394),
    [sym_operator_assignment] = STATE(8394),
    [sym_conditional] = STATE(8394),
    [sym_range] = STATE(8394),
    [sym_binary] = STATE(8394),
    [sym_unary] = STATE(8394),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5835] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8395),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8395),
    [sym_operator_assignment] = STATE(8395),
    [sym_conditional] = STATE(8395),
    [sym_range] = STATE(8395),
    [sym_binary] = STATE(8395),
    [sym_unary] = STATE(8395),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5836] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8396),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8396),
    [sym_operator_assignment] = STATE(8396),
    [sym_conditional] = STATE(8396),
    [sym_range] = STATE(8396),
    [sym_binary] = STATE(8396),
    [sym_unary] = STATE(8396),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5837] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8397),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8397),
    [sym_operator_assignment] = STATE(8397),
    [sym_conditional] = STATE(8397),
    [sym_range] = STATE(8397),
    [sym_binary] = STATE(8397),
    [sym_unary] = STATE(8397),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5838] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8398),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8398),
    [sym_operator_assignment] = STATE(8398),
    [sym_conditional] = STATE(8398),
    [sym_range] = STATE(8398),
    [sym_binary] = STATE(8398),
    [sym_unary] = STATE(8398),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5839] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8399),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8399),
    [sym_operator_assignment] = STATE(8399),
    [sym_conditional] = STATE(8399),
    [sym_range] = STATE(8399),
    [sym_binary] = STATE(8399),
    [sym_unary] = STATE(8399),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5840] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8400),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8400),
    [sym_operator_assignment] = STATE(8400),
    [sym_conditional] = STATE(8400),
    [sym_range] = STATE(8400),
    [sym_binary] = STATE(8400),
    [sym_unary] = STATE(8400),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5841] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8401),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8401),
    [sym_operator_assignment] = STATE(8401),
    [sym_conditional] = STATE(8401),
    [sym_range] = STATE(8401),
    [sym_binary] = STATE(8401),
    [sym_unary] = STATE(8401),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5842] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8402),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8402),
    [sym_operator_assignment] = STATE(8402),
    [sym_conditional] = STATE(8402),
    [sym_range] = STATE(8402),
    [sym_binary] = STATE(8402),
    [sym_unary] = STATE(8402),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5843] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8403),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8403),
    [sym_operator_assignment] = STATE(8403),
    [sym_conditional] = STATE(8403),
    [sym_range] = STATE(8403),
    [sym_binary] = STATE(8403),
    [sym_unary] = STATE(8403),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5844] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8404),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8404),
    [sym_operator_assignment] = STATE(8404),
    [sym_conditional] = STATE(8404),
    [sym_range] = STATE(8404),
    [sym_binary] = STATE(8404),
    [sym_unary] = STATE(8404),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5845] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8405),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8405),
    [sym_operator_assignment] = STATE(8405),
    [sym_conditional] = STATE(8405),
    [sym_range] = STATE(8405),
    [sym_binary] = STATE(8405),
    [sym_unary] = STATE(8405),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5846] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8406),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_splat_argument] = STATE(8407),
    [sym_assignment] = STATE(8406),
    [sym_operator_assignment] = STATE(8406),
    [sym_conditional] = STATE(8406),
    [sym_range] = STATE(8406),
    [sym_binary] = STATE(8406),
    [sym_unary] = STATE(8406),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8407),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5847] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8408),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(8408),
    [sym_operator_assignment] = STATE(8408),
    [sym_conditional] = STATE(8408),
    [sym_range] = STATE(8408),
    [sym_binary] = STATE(8408),
    [sym_unary] = STATE(8408),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5848] = {
    [sym_string] = STATE(8409),
    [aux_sym_chained_string_repeat1] = STATE(8409),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [5849] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [5850] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5851] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5852] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8410),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(8410),
    [sym_operator_assignment] = STATE(8410),
    [sym_conditional] = STATE(8410),
    [sym_range] = STATE(8410),
    [sym_binary] = STATE(8410),
    [sym_unary] = STATE(8410),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5853] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5854] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8411),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(8411),
    [sym_operator_assignment] = STATE(8411),
    [sym_conditional] = STATE(8411),
    [sym_range] = STATE(8411),
    [sym_binary] = STATE(8411),
    [sym_unary] = STATE(8411),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5855] = {
    [sym_heredoc_body] = STATE(8412),
    [aux_sym_call_repeat1] = STATE(8412),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5856] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8413),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11496),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5857] = {
    [sym_heredoc_body] = STATE(8414),
    [aux_sym_call_repeat1] = STATE(8414),
    [aux_sym_argument_list_repeat1] = STATE(8415),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8747),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5858] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5859] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5860] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5861] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5862] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5863] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5864] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [5865] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11498),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5866] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5867] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5868] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5869] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5870] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5871] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [5872] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [5873] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8417),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(8417),
    [sym_operator_assignment] = STATE(8417),
    [sym_conditional] = STATE(8417),
    [sym_range] = STATE(8417),
    [sym_binary] = STATE(8417),
    [sym_unary] = STATE(8417),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5874] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [5875] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8418),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(8418),
    [sym_operator_assignment] = STATE(8418),
    [sym_conditional] = STATE(8418),
    [sym_range] = STATE(8418),
    [sym_binary] = STATE(8418),
    [sym_unary] = STATE(8418),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5876] = {
    [sym_heredoc_body] = STATE(8419),
    [aux_sym_call_repeat1] = STATE(8419),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5877] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(8420),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5878] = {
    [sym_heredoc_body] = STATE(8421),
    [aux_sym_call_repeat1] = STATE(8421),
    [aux_sym_argument_list_repeat1] = STATE(8422),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8755),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5879] = {
    [sym_heredoc_body] = STATE(5879),
    [aux_sym_call_repeat1] = STATE(5879),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [5880] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(1199),
    [sym_operator_assignment] = STATE(1199),
    [sym_conditional] = STATE(1199),
    [sym_range] = STATE(1199),
    [sym_binary] = STATE(1199),
    [sym_unary] = STATE(1199),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1205),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(2083),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__identifier_hash_key2] = ACTIONS(2089),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8759),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2107),
    [sym_identifier] = ACTIONS(2107),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5881] = {
    [sym_heredoc_body] = STATE(5879),
    [aux_sym_call_repeat1] = STATE(5879),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [5882] = {
    [aux_sym_argument_list_repeat1] = STATE(5882),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11502),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [5883] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5884] = {
    [aux_sym_exceptions_repeat1] = STATE(8424),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5885] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [5886] = {
    [sym_string] = STATE(5886),
    [aux_sym_chained_string_repeat1] = STATE(5886),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5887] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [5888] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [5889] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [5890] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8425),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8425),
    [sym_operator_assignment] = STATE(8425),
    [sym_conditional] = STATE(8425),
    [sym_range] = STATE(8425),
    [sym_binary] = STATE(8425),
    [sym_unary] = STATE(8425),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5891] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [5892] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [5893] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [5894] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8426),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8426),
    [sym_operator_assignment] = STATE(8426),
    [sym_conditional] = STATE(8426),
    [sym_range] = STATE(8426),
    [sym_binary] = STATE(8426),
    [sym_unary] = STATE(8426),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5895] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8427),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8427),
    [sym_operator_assignment] = STATE(8427),
    [sym_conditional] = STATE(8427),
    [sym_range] = STATE(8427),
    [sym_binary] = STATE(8427),
    [sym_unary] = STATE(8427),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5896] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8428),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8428),
    [sym_operator_assignment] = STATE(8428),
    [sym_conditional] = STATE(8428),
    [sym_range] = STATE(8428),
    [sym_binary] = STATE(8428),
    [sym_unary] = STATE(8428),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5897] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8429),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8429),
    [sym_operator_assignment] = STATE(8429),
    [sym_conditional] = STATE(8429),
    [sym_range] = STATE(8429),
    [sym_binary] = STATE(8429),
    [sym_unary] = STATE(8429),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5898] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8430),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8430),
    [sym_operator_assignment] = STATE(8430),
    [sym_conditional] = STATE(8430),
    [sym_range] = STATE(8430),
    [sym_binary] = STATE(8430),
    [sym_unary] = STATE(8430),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5899] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8431),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8431),
    [sym_operator_assignment] = STATE(8431),
    [sym_conditional] = STATE(8431),
    [sym_range] = STATE(8431),
    [sym_binary] = STATE(8431),
    [sym_unary] = STATE(8431),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5900] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8432),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8432),
    [sym_operator_assignment] = STATE(8432),
    [sym_conditional] = STATE(8432),
    [sym_range] = STATE(8432),
    [sym_binary] = STATE(8432),
    [sym_unary] = STATE(8432),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5901] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8433),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8433),
    [sym_operator_assignment] = STATE(8433),
    [sym_conditional] = STATE(8433),
    [sym_range] = STATE(8433),
    [sym_binary] = STATE(8433),
    [sym_unary] = STATE(8433),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5902] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8434),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8434),
    [sym_operator_assignment] = STATE(8434),
    [sym_conditional] = STATE(8434),
    [sym_range] = STATE(8434),
    [sym_binary] = STATE(8434),
    [sym_unary] = STATE(8434),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5903] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8435),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8435),
    [sym_operator_assignment] = STATE(8435),
    [sym_conditional] = STATE(8435),
    [sym_range] = STATE(8435),
    [sym_binary] = STATE(8435),
    [sym_unary] = STATE(8435),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5904] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8436),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8436),
    [sym_operator_assignment] = STATE(8436),
    [sym_conditional] = STATE(8436),
    [sym_range] = STATE(8436),
    [sym_binary] = STATE(8436),
    [sym_unary] = STATE(8436),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5905] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8437),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8437),
    [sym_operator_assignment] = STATE(8437),
    [sym_conditional] = STATE(8437),
    [sym_range] = STATE(8437),
    [sym_binary] = STATE(8437),
    [sym_unary] = STATE(8437),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5906] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8438),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8438),
    [sym_operator_assignment] = STATE(8438),
    [sym_conditional] = STATE(8438),
    [sym_range] = STATE(8438),
    [sym_binary] = STATE(8438),
    [sym_unary] = STATE(8438),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5907] = {
    [sym_heredoc_body] = STATE(8439),
    [aux_sym_call_repeat1] = STATE(8439),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5908] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8440),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11505),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5909] = {
    [sym_heredoc_body] = STATE(8441),
    [aux_sym_call_repeat1] = STATE(8441),
    [aux_sym_argument_list_repeat1] = STATE(8442),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8797),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [5910] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8443),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_splat_argument] = STATE(8444),
    [sym_assignment] = STATE(8443),
    [sym_operator_assignment] = STATE(8443),
    [sym_conditional] = STATE(8443),
    [sym_range] = STATE(8443),
    [sym_binary] = STATE(8443),
    [sym_unary] = STATE(8443),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8444),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5911] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(8445),
    [sym_operator_assignment] = STATE(8445),
    [sym_conditional] = STATE(8445),
    [sym_range] = STATE(8445),
    [sym_binary] = STATE(8445),
    [sym_unary] = STATE(8445),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5912] = {
    [sym_argument_list_with_parens] = STATE(8448),
    [sym__argument_list_with_parens] = STATE(8449),
    [sym_operator] = STATE(8448),
    [sym_heredoc_body] = STATE(8450),
    [aux_sym_call_repeat1] = STATE(8450),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(11507),
    [anon_sym_STAR] = ACTIONS(11509),
    [anon_sym_STAR_STAR] = ACTIONS(11507),
    [anon_sym_AMP] = ACTIONS(11507),
    [anon_sym_LT] = ACTIONS(11509),
    [anon_sym_LPAREN2] = ACTIONS(11511),
    [anon_sym_DOT_DOT] = ACTIONS(11507),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11507),
    [anon_sym_LT_EQ_GT] = ACTIONS(11507),
    [anon_sym_EQ_TILDE] = ACTIONS(11507),
    [anon_sym_BANG_TILDE] = ACTIONS(11507),
    [anon_sym_LT_EQ] = ACTIONS(11509),
    [anon_sym_GT] = ACTIONS(11509),
    [anon_sym_GT_EQ] = ACTIONS(11507),
    [anon_sym_CARET] = ACTIONS(11507),
    [anon_sym_PLUS] = ACTIONS(11509),
    [anon_sym_SLASH] = ACTIONS(11507),
    [anon_sym_PERCENT] = ACTIONS(11507),
    [anon_sym_BANG] = ACTIONS(11509),
    [anon_sym_TILDE] = ACTIONS(11507),
    [sym_constant] = ACTIONS(11513),
    [sym_identifier] = ACTIONS(11513),
    [anon_sym_DASH] = ACTIONS(11509),
    [anon_sym_PLUS_AT] = ACTIONS(11507),
    [anon_sym_DASH_AT] = ACTIONS(11507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11509),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11507),
    [anon_sym_BQUOTE] = ACTIONS(11507),
    [sym_comment] = ACTIONS(87),
  },
  [5913] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(359),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym__argument_list_with_trailing_comma] = STATE(8452),
    [sym__argument] = STATE(363),
    [sym_splat_argument] = STATE(363),
    [sym_hash_splat_argument] = STATE(363),
    [sym_block_argument] = STATE(363),
    [sym_assignment] = STATE(359),
    [sym_operator_assignment] = STATE(359),
    [sym_conditional] = STATE(359),
    [sym_range] = STATE(359),
    [sym_binary] = STATE(359),
    [sym_unary] = STATE(359),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(366),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(8453),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(363),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(593),
    [sym__splat_star2] = ACTIONS(595),
    [sym__unary_minus2] = ACTIONS(597),
    [sym__identifier_hash_key2] = ACTIONS(599),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(609),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_RBRACK] = ACTIONS(11515),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(649),
    [sym_identifier] = ACTIONS(649),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5914] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8462),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(8462),
    [sym_operator_assignment] = STATE(8462),
    [sym_conditional] = STATE(8462),
    [sym_range] = STATE(8462),
    [sym_binary] = STATE(8462),
    [sym_unary] = STATE(8462),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5915] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8466),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(8466),
    [sym_operator_assignment] = STATE(8466),
    [sym_conditional] = STATE(8466),
    [sym_range] = STATE(8466),
    [sym_binary] = STATE(8466),
    [sym_unary] = STATE(8466),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5916] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8467),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(8467),
    [sym_operator_assignment] = STATE(8467),
    [sym_conditional] = STATE(8467),
    [sym_range] = STATE(8467),
    [sym_binary] = STATE(8467),
    [sym_unary] = STATE(8467),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5917] = {
    [anon_sym_COLON] = ACTIONS(11535),
    [sym_comment] = ACTIONS(87),
  },
  [5918] = {
    [sym__statements] = STATE(7423),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(7424),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(124),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(125),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(11537),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5919] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8471),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(8471),
    [sym_operator_assignment] = STATE(8471),
    [sym_conditional] = STATE(8471),
    [sym_range] = STATE(8471),
    [sym_binary] = STATE(8471),
    [sym_unary] = STATE(8471),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5920] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8478),
    [sym__argument] = STATE(8479),
    [sym_splat_argument] = STATE(8479),
    [sym_hash_splat_argument] = STATE(8479),
    [sym_block_argument] = STATE(8479),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8479),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5921] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(8478),
    [sym__argument] = STATE(8479),
    [sym_splat_argument] = STATE(8479),
    [sym_hash_splat_argument] = STATE(8479),
    [sym_block_argument] = STATE(8479),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8479),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5922] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(8478),
    [sym__argument] = STATE(8479),
    [sym_splat_argument] = STATE(8479),
    [sym_hash_splat_argument] = STATE(8479),
    [sym_block_argument] = STATE(8479),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8479),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5923] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(8478),
    [sym__argument] = STATE(8479),
    [sym_splat_argument] = STATE(8479),
    [sym_hash_splat_argument] = STATE(8479),
    [sym_block_argument] = STATE(8479),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8479),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5924] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(8482),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(8483),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(11549),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [5925] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8484),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(8484),
    [sym_operator_assignment] = STATE(8484),
    [sym_conditional] = STATE(8484),
    [sym_range] = STATE(8484),
    [sym_binary] = STATE(8484),
    [sym_unary] = STATE(8484),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5926] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8485),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(8485),
    [sym_operator_assignment] = STATE(8485),
    [sym_conditional] = STATE(8485),
    [sym_range] = STATE(8485),
    [sym_binary] = STATE(8485),
    [sym_unary] = STATE(8485),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5927] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5928] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11551),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [5929] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(11565),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(11573),
    [anon_sym_or] = ACTIONS(11573),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [5930] = {
    [sym_do_block] = STATE(8499),
    [sym_block] = STATE(8499),
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(7270),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_do] = ACTIONS(10641),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [sym_comment] = ACTIONS(87),
  },
  [5931] = {
    [sym_heredoc_body] = STATE(8501),
    [aux_sym_call_repeat1] = STATE(8501),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5932] = {
    [sym_heredoc_body] = STATE(8501),
    [aux_sym_call_repeat1] = STATE(8501),
    [aux_sym_argument_list_repeat1] = STATE(8503),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1703),
    [anon_sym_COMMA] = ACTIONS(11589),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [5933] = {
    [sym__line_break2] = ACTIONS(2773),
    [sym__heredoc_body_start2] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_SEMI] = ACTIONS(2773),
    [anon_sym_then] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [sym_comment] = ACTIONS(87),
  },
  [5934] = {
    [anon_sym_EQ] = ACTIONS(11591),
    [sym_comment] = ACTIONS(87),
  },
  [5935] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11593),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11595),
    [anon_sym_DASH_EQ] = ACTIONS(11595),
    [anon_sym_STAR_EQ] = ACTIONS(11595),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11595),
    [anon_sym_SLASH_EQ] = ACTIONS(11595),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11595),
    [anon_sym_PIPE_EQ] = ACTIONS(11595),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11595),
    [anon_sym_AMP_EQ] = ACTIONS(11595),
    [anon_sym_PERCENT_EQ] = ACTIONS(11595),
    [anon_sym_GT_GT_EQ] = ACTIONS(11595),
    [anon_sym_LT_LT_EQ] = ACTIONS(11595),
    [anon_sym_CARET_EQ] = ACTIONS(11595),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5936] = {
    [sym_string] = STATE(8506),
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11597),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5937] = {
    [anon_sym_end] = ACTIONS(11599),
    [anon_sym_else] = ACTIONS(11599),
    [anon_sym_ensure] = ACTIONS(11599),
    [sym_comment] = ACTIONS(87),
  },
  [5938] = {
    [sym_rescue] = STATE(8507),
    [anon_sym_end] = ACTIONS(11599),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(11599),
    [anon_sym_ensure] = ACTIONS(11599),
    [sym_comment] = ACTIONS(87),
  },
  [5939] = {
    [sym__statements] = STATE(8508),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym_rescue] = STATE(8507),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11601),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(11601),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(11601),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5940] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5941] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [5942] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5943] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [5944] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5945] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5946] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11603),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [5947] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5948] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5949] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5950] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5951] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5952] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [5953] = {
    [sym_string] = STATE(5978),
    [aux_sym_chained_string_repeat1] = STATE(5978),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5954] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [5955] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [5956] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8510),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8510),
    [sym_operator_assignment] = STATE(8510),
    [sym_conditional] = STATE(8510),
    [sym_range] = STATE(8510),
    [sym_binary] = STATE(8510),
    [sym_unary] = STATE(8510),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5957] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [5958] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [5959] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [5960] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8511),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8511),
    [sym_operator_assignment] = STATE(8511),
    [sym_conditional] = STATE(8511),
    [sym_range] = STATE(8511),
    [sym_binary] = STATE(8511),
    [sym_unary] = STATE(8511),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5961] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8512),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8512),
    [sym_operator_assignment] = STATE(8512),
    [sym_conditional] = STATE(8512),
    [sym_range] = STATE(8512),
    [sym_binary] = STATE(8512),
    [sym_unary] = STATE(8512),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5962] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8513),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8513),
    [sym_operator_assignment] = STATE(8513),
    [sym_conditional] = STATE(8513),
    [sym_range] = STATE(8513),
    [sym_binary] = STATE(8513),
    [sym_unary] = STATE(8513),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5963] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8514),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8514),
    [sym_operator_assignment] = STATE(8514),
    [sym_conditional] = STATE(8514),
    [sym_range] = STATE(8514),
    [sym_binary] = STATE(8514),
    [sym_unary] = STATE(8514),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5964] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8515),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8515),
    [sym_operator_assignment] = STATE(8515),
    [sym_conditional] = STATE(8515),
    [sym_range] = STATE(8515),
    [sym_binary] = STATE(8515),
    [sym_unary] = STATE(8515),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5965] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8516),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8516),
    [sym_operator_assignment] = STATE(8516),
    [sym_conditional] = STATE(8516),
    [sym_range] = STATE(8516),
    [sym_binary] = STATE(8516),
    [sym_unary] = STATE(8516),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5966] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8517),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8517),
    [sym_operator_assignment] = STATE(8517),
    [sym_conditional] = STATE(8517),
    [sym_range] = STATE(8517),
    [sym_binary] = STATE(8517),
    [sym_unary] = STATE(8517),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5967] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8518),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8518),
    [sym_operator_assignment] = STATE(8518),
    [sym_conditional] = STATE(8518),
    [sym_range] = STATE(8518),
    [sym_binary] = STATE(8518),
    [sym_unary] = STATE(8518),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [5968] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8519),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8519),
    [sym_operator_assignment] = STATE(8519),
    [sym_conditional] = STATE(8519),
    [sym_range] = STATE(8519),
    [sym_binary] = STATE(8519),
    [sym_unary] = STATE(8519),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5969] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8520),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8520),
    [sym_operator_assignment] = STATE(8520),
    [sym_conditional] = STATE(8520),
    [sym_range] = STATE(8520),
    [sym_binary] = STATE(8520),
    [sym_unary] = STATE(8520),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5970] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8521),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8521),
    [sym_operator_assignment] = STATE(8521),
    [sym_conditional] = STATE(8521),
    [sym_range] = STATE(8521),
    [sym_binary] = STATE(8521),
    [sym_unary] = STATE(8521),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5971] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8522),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8522),
    [sym_operator_assignment] = STATE(8522),
    [sym_conditional] = STATE(8522),
    [sym_range] = STATE(8522),
    [sym_binary] = STATE(8522),
    [sym_unary] = STATE(8522),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5972] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8523),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8523),
    [sym_operator_assignment] = STATE(8523),
    [sym_conditional] = STATE(8523),
    [sym_range] = STATE(8523),
    [sym_binary] = STATE(8523),
    [sym_unary] = STATE(8523),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5973] = {
    [sym_heredoc_body] = STATE(8524),
    [aux_sym_call_repeat1] = STATE(8524),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5974] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(8525),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11605),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5975] = {
    [sym_heredoc_body] = STATE(8526),
    [aux_sym_call_repeat1] = STATE(8526),
    [aux_sym_argument_list_repeat1] = STATE(8527),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8885),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [5976] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8528),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_splat_argument] = STATE(8529),
    [sym_assignment] = STATE(8528),
    [sym_operator_assignment] = STATE(8528),
    [sym_conditional] = STATE(8528),
    [sym_range] = STATE(8528),
    [sym_binary] = STATE(8528),
    [sym_unary] = STATE(8528),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(8529),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5977] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8530),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(8530),
    [sym_operator_assignment] = STATE(8530),
    [sym_conditional] = STATE(8530),
    [sym_range] = STATE(8530),
    [sym_binary] = STATE(8530),
    [sym_unary] = STATE(8530),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [5978] = {
    [sym_string] = STATE(8531),
    [aux_sym_chained_string_repeat1] = STATE(8531),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [5979] = {
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [5980] = {
    [aux_sym_exceptions_repeat1] = STATE(5980),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(11609),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [5981] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8532),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(8532),
    [sym_operator_assignment] = STATE(8532),
    [sym_conditional] = STATE(8532),
    [sym_range] = STATE(8532),
    [sym_binary] = STATE(8532),
    [sym_unary] = STATE(8532),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5982] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5983] = {
    [aux_sym_exceptions_repeat1] = STATE(8534),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [5984] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [5985] = {
    [sym_string] = STATE(5985),
    [aux_sym_chained_string_repeat1] = STATE(5985),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [5986] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8535),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(8535),
    [sym_operator_assignment] = STATE(8535),
    [sym_conditional] = STATE(8535),
    [sym_range] = STATE(8535),
    [sym_binary] = STATE(8535),
    [sym_unary] = STATE(8535),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5987] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8536),
    [sym__argument] = STATE(8537),
    [sym_splat_argument] = STATE(8537),
    [sym_hash_splat_argument] = STATE(8537),
    [sym_block_argument] = STATE(8537),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8537),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5988] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(8536),
    [sym__argument] = STATE(8537),
    [sym_splat_argument] = STATE(8537),
    [sym_hash_splat_argument] = STATE(8537),
    [sym_block_argument] = STATE(8537),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8537),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5989] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(8536),
    [sym__argument] = STATE(8537),
    [sym_splat_argument] = STATE(8537),
    [sym_hash_splat_argument] = STATE(8537),
    [sym_block_argument] = STATE(8537),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8537),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5990] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(8536),
    [sym__argument] = STATE(8537),
    [sym_splat_argument] = STATE(8537),
    [sym_hash_splat_argument] = STATE(8537),
    [sym_block_argument] = STATE(8537),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8537),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5200),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5991] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8538),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(8538),
    [sym_operator_assignment] = STATE(8538),
    [sym_conditional] = STATE(8538),
    [sym_range] = STATE(8538),
    [sym_binary] = STATE(8538),
    [sym_unary] = STATE(8538),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5992] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8539),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(8539),
    [sym_operator_assignment] = STATE(8539),
    [sym_conditional] = STATE(8539),
    [sym_range] = STATE(8539),
    [sym_binary] = STATE(8539),
    [sym_unary] = STATE(8539),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5993] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [5994] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [5995] = {
    [anon_sym_EQ] = ACTIONS(11642),
    [sym_comment] = ACTIONS(87),
  },
  [5996] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11644),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11646),
    [anon_sym_DASH_EQ] = ACTIONS(11646),
    [anon_sym_STAR_EQ] = ACTIONS(11646),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11646),
    [anon_sym_SLASH_EQ] = ACTIONS(11646),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11646),
    [anon_sym_PIPE_EQ] = ACTIONS(11646),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11646),
    [anon_sym_AMP_EQ] = ACTIONS(11646),
    [anon_sym_PERCENT_EQ] = ACTIONS(11646),
    [anon_sym_GT_GT_EQ] = ACTIONS(11646),
    [anon_sym_LT_LT_EQ] = ACTIONS(11646),
    [anon_sym_CARET_EQ] = ACTIONS(11646),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [5997] = {
    [sym_string] = STATE(8554),
    [aux_sym_chained_string_repeat1] = STATE(8554),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [5998] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [5999] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6000] = {
    [sym_string] = STATE(6041),
    [aux_sym_chained_string_repeat1] = STATE(6041),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6001] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8555),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(8555),
    [sym_operator_assignment] = STATE(8555),
    [sym_conditional] = STATE(8555),
    [sym_range] = STATE(8555),
    [sym_binary] = STATE(8555),
    [sym_unary] = STATE(8555),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6002] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [6003] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8556),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8556),
    [sym_operator_assignment] = STATE(8556),
    [sym_conditional] = STATE(8556),
    [sym_range] = STATE(8556),
    [sym_binary] = STATE(8556),
    [sym_unary] = STATE(8556),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6004] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8557),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8557),
    [sym_operator_assignment] = STATE(8557),
    [sym_conditional] = STATE(8557),
    [sym_range] = STATE(8557),
    [sym_binary] = STATE(8557),
    [sym_unary] = STATE(8557),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6005] = {
    [anon_sym_COLON] = ACTIONS(11648),
    [sym_comment] = ACTIONS(87),
  },
  [6006] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8559),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8559),
    [sym_operator_assignment] = STATE(8559),
    [sym_conditional] = STATE(8559),
    [sym_range] = STATE(8559),
    [sym_binary] = STATE(8559),
    [sym_unary] = STATE(8559),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6007] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11650),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6008] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [6009] = {
    [sym_heredoc_body] = STATE(8561),
    [aux_sym_call_repeat1] = STATE(8561),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6010] = {
    [sym_heredoc_body] = STATE(8561),
    [aux_sym_call_repeat1] = STATE(8561),
    [aux_sym_argument_list_repeat1] = STATE(8563),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11652),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6011] = {
    [sym_string] = STATE(6041),
    [aux_sym_chained_string_repeat1] = STATE(6041),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11654),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6012] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6013] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [6014] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8564),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8564),
    [sym_operator_assignment] = STATE(8564),
    [sym_conditional] = STATE(8564),
    [sym_range] = STATE(8564),
    [sym_binary] = STATE(8564),
    [sym_unary] = STATE(8564),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6015] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8565),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8565),
    [sym_operator_assignment] = STATE(8565),
    [sym_conditional] = STATE(8565),
    [sym_range] = STATE(8565),
    [sym_binary] = STATE(8565),
    [sym_unary] = STATE(8565),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6016] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8566),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8566),
    [sym_operator_assignment] = STATE(8566),
    [sym_conditional] = STATE(8566),
    [sym_range] = STATE(8566),
    [sym_binary] = STATE(8566),
    [sym_unary] = STATE(8566),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6017] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8567),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8567),
    [sym_operator_assignment] = STATE(8567),
    [sym_conditional] = STATE(8567),
    [sym_range] = STATE(8567),
    [sym_binary] = STATE(8567),
    [sym_unary] = STATE(8567),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6018] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8568),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8568),
    [sym_operator_assignment] = STATE(8568),
    [sym_conditional] = STATE(8568),
    [sym_range] = STATE(8568),
    [sym_binary] = STATE(8568),
    [sym_unary] = STATE(8568),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6019] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8569),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8569),
    [sym_operator_assignment] = STATE(8569),
    [sym_conditional] = STATE(8569),
    [sym_range] = STATE(8569),
    [sym_binary] = STATE(8569),
    [sym_unary] = STATE(8569),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6020] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8570),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(8570),
    [sym_operator_assignment] = STATE(8570),
    [sym_conditional] = STATE(8570),
    [sym_range] = STATE(8570),
    [sym_binary] = STATE(8570),
    [sym_unary] = STATE(8570),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6021] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8571),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8571),
    [sym_operator_assignment] = STATE(8571),
    [sym_conditional] = STATE(8571),
    [sym_range] = STATE(8571),
    [sym_binary] = STATE(8571),
    [sym_unary] = STATE(8571),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6022] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8572),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8572),
    [sym_operator_assignment] = STATE(8572),
    [sym_conditional] = STATE(8572),
    [sym_range] = STATE(8572),
    [sym_binary] = STATE(8572),
    [sym_unary] = STATE(8572),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6023] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8573),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8573),
    [sym_operator_assignment] = STATE(8573),
    [sym_conditional] = STATE(8573),
    [sym_range] = STATE(8573),
    [sym_binary] = STATE(8573),
    [sym_unary] = STATE(8573),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6024] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8574),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8574),
    [sym_operator_assignment] = STATE(8574),
    [sym_conditional] = STATE(8574),
    [sym_range] = STATE(8574),
    [sym_binary] = STATE(8574),
    [sym_unary] = STATE(8574),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6025] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8575),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8575),
    [sym_operator_assignment] = STATE(8575),
    [sym_conditional] = STATE(8575),
    [sym_range] = STATE(8575),
    [sym_binary] = STATE(8575),
    [sym_unary] = STATE(8575),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6026] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8576),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8576),
    [sym_operator_assignment] = STATE(8576),
    [sym_conditional] = STATE(8576),
    [sym_range] = STATE(8576),
    [sym_binary] = STATE(8576),
    [sym_unary] = STATE(8576),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6027] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8577),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8577),
    [sym_operator_assignment] = STATE(8577),
    [sym_conditional] = STATE(8577),
    [sym_range] = STATE(8577),
    [sym_binary] = STATE(8577),
    [sym_unary] = STATE(8577),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6028] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8578),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8578),
    [sym_operator_assignment] = STATE(8578),
    [sym_conditional] = STATE(8578),
    [sym_range] = STATE(8578),
    [sym_binary] = STATE(8578),
    [sym_unary] = STATE(8578),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6029] = {
    [anon_sym_COLON] = ACTIONS(11656),
    [sym_comment] = ACTIONS(87),
  },
  [6030] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8580),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8580),
    [sym_operator_assignment] = STATE(8580),
    [sym_conditional] = STATE(8580),
    [sym_range] = STATE(8580),
    [sym_binary] = STATE(8580),
    [sym_unary] = STATE(8580),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6031] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11658),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_ensure] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6032] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_ensure] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [6033] = {
    [sym_heredoc_body] = STATE(8582),
    [aux_sym_call_repeat1] = STATE(8582),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6034] = {
    [sym_heredoc_body] = STATE(8582),
    [aux_sym_call_repeat1] = STATE(8582),
    [aux_sym_argument_list_repeat1] = STATE(8584),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11660),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6035] = {
    [sym_string] = STATE(6100),
    [aux_sym_chained_string_repeat1] = STATE(6100),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11662),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6036] = {
    [sym_heredoc_body] = STATE(8585),
    [aux_sym_call_repeat1] = STATE(8585),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6037] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8586),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11664),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6038] = {
    [sym_heredoc_body] = STATE(8587),
    [aux_sym_call_repeat1] = STATE(8587),
    [aux_sym_argument_list_repeat1] = STATE(8588),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8971),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6039] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8589),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_splat_argument] = STATE(8590),
    [sym_assignment] = STATE(8589),
    [sym_operator_assignment] = STATE(8589),
    [sym_conditional] = STATE(8589),
    [sym_range] = STATE(8589),
    [sym_binary] = STATE(8589),
    [sym_unary] = STATE(8589),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8590),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6040] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8591),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(8591),
    [sym_operator_assignment] = STATE(8591),
    [sym_conditional] = STATE(8591),
    [sym_range] = STATE(8591),
    [sym_binary] = STATE(8591),
    [sym_unary] = STATE(8591),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6041] = {
    [sym_string] = STATE(8592),
    [aux_sym_chained_string_repeat1] = STATE(8592),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6042] = {
    [aux_sym_undef_repeat1] = STATE(8593),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_ensure] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [6043] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1237),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(1238),
    [sym_operator_assignment] = STATE(1238),
    [sym_conditional] = STATE(1238),
    [sym_range] = STATE(1238),
    [sym_binary] = STATE(1238),
    [sym_unary] = STATE(1238),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(5834),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [anon_sym_undef] = ACTIONS(2169),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6044] = {
    [sym_heredoc_body] = STATE(8594),
    [sym__terminator] = STATE(8594),
    [aux_sym__statements_repeat1] = STATE(6044),
    [sym__line_break2] = ACTIONS(11666),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(11666),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_ensure] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [6045] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_ensure] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6046] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_ensure] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6047] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_ensure] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6048] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_ensure] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6049] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_ensure] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5244),
    [anon_sym_or] = ACTIONS(5244),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6050] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6051] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6052] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6053] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6054] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6055] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6056] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11669),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6057] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6058] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6059] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6060] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6061] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6062] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8596),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(8596),
    [sym_operator_assignment] = STATE(8596),
    [sym_conditional] = STATE(8596),
    [sym_range] = STATE(8596),
    [sym_binary] = STATE(8596),
    [sym_unary] = STATE(8596),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6063] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(375),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6064] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(417),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6065] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(421),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6066] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(425),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6067] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8597),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(8597),
    [sym_operator_assignment] = STATE(8597),
    [sym_conditional] = STATE(8597),
    [sym_range] = STATE(8597),
    [sym_binary] = STATE(8597),
    [sym_unary] = STATE(8597),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6068] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8598),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(8598),
    [sym_operator_assignment] = STATE(8598),
    [sym_conditional] = STATE(8598),
    [sym_range] = STATE(8598),
    [sym_binary] = STATE(8598),
    [sym_unary] = STATE(8598),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6069] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6070] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [6071] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(3324),
    [sym__argument] = STATE(3325),
    [sym_splat_argument] = STATE(3325),
    [sym_hash_splat_argument] = STATE(3325),
    [sym_block_argument] = STATE(3325),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3325),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_ensure] = ACTIONS(775),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5278),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6072] = {
    [anon_sym_EQ] = ACTIONS(11699),
    [sym_comment] = ACTIONS(87),
  },
  [6073] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11701),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11703),
    [anon_sym_DASH_EQ] = ACTIONS(11703),
    [anon_sym_STAR_EQ] = ACTIONS(11703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11703),
    [anon_sym_SLASH_EQ] = ACTIONS(11703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11703),
    [anon_sym_PIPE_EQ] = ACTIONS(11703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11703),
    [anon_sym_AMP_EQ] = ACTIONS(11703),
    [anon_sym_PERCENT_EQ] = ACTIONS(11703),
    [anon_sym_GT_GT_EQ] = ACTIONS(11703),
    [anon_sym_LT_LT_EQ] = ACTIONS(11703),
    [anon_sym_CARET_EQ] = ACTIONS(11703),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6074] = {
    [sym_string] = STATE(8613),
    [aux_sym_chained_string_repeat1] = STATE(8613),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6075] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [6076] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [6077] = {
    [sym_string] = STATE(6100),
    [aux_sym_chained_string_repeat1] = STATE(6100),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6078] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8614),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(8614),
    [sym_operator_assignment] = STATE(8614),
    [sym_conditional] = STATE(8614),
    [sym_range] = STATE(8614),
    [sym_binary] = STATE(8614),
    [sym_unary] = STATE(8614),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6079] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [6080] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6081] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [6082] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8615),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8615),
    [sym_operator_assignment] = STATE(8615),
    [sym_conditional] = STATE(8615),
    [sym_range] = STATE(8615),
    [sym_binary] = STATE(8615),
    [sym_unary] = STATE(8615),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6083] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8616),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8616),
    [sym_operator_assignment] = STATE(8616),
    [sym_conditional] = STATE(8616),
    [sym_range] = STATE(8616),
    [sym_binary] = STATE(8616),
    [sym_unary] = STATE(8616),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6084] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8617),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8617),
    [sym_operator_assignment] = STATE(8617),
    [sym_conditional] = STATE(8617),
    [sym_range] = STATE(8617),
    [sym_binary] = STATE(8617),
    [sym_unary] = STATE(8617),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6085] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8618),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8618),
    [sym_operator_assignment] = STATE(8618),
    [sym_conditional] = STATE(8618),
    [sym_range] = STATE(8618),
    [sym_binary] = STATE(8618),
    [sym_unary] = STATE(8618),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6086] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8619),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8619),
    [sym_operator_assignment] = STATE(8619),
    [sym_conditional] = STATE(8619),
    [sym_range] = STATE(8619),
    [sym_binary] = STATE(8619),
    [sym_unary] = STATE(8619),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6087] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8620),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8620),
    [sym_operator_assignment] = STATE(8620),
    [sym_conditional] = STATE(8620),
    [sym_range] = STATE(8620),
    [sym_binary] = STATE(8620),
    [sym_unary] = STATE(8620),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6088] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8621),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(8621),
    [sym_operator_assignment] = STATE(8621),
    [sym_conditional] = STATE(8621),
    [sym_range] = STATE(8621),
    [sym_binary] = STATE(8621),
    [sym_unary] = STATE(8621),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6089] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8622),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8622),
    [sym_operator_assignment] = STATE(8622),
    [sym_conditional] = STATE(8622),
    [sym_range] = STATE(8622),
    [sym_binary] = STATE(8622),
    [sym_unary] = STATE(8622),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6090] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8623),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8623),
    [sym_operator_assignment] = STATE(8623),
    [sym_conditional] = STATE(8623),
    [sym_range] = STATE(8623),
    [sym_binary] = STATE(8623),
    [sym_unary] = STATE(8623),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6091] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8624),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8624),
    [sym_operator_assignment] = STATE(8624),
    [sym_conditional] = STATE(8624),
    [sym_range] = STATE(8624),
    [sym_binary] = STATE(8624),
    [sym_unary] = STATE(8624),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6092] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8625),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8625),
    [sym_operator_assignment] = STATE(8625),
    [sym_conditional] = STATE(8625),
    [sym_range] = STATE(8625),
    [sym_binary] = STATE(8625),
    [sym_unary] = STATE(8625),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6093] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8626),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8626),
    [sym_operator_assignment] = STATE(8626),
    [sym_conditional] = STATE(8626),
    [sym_range] = STATE(8626),
    [sym_binary] = STATE(8626),
    [sym_unary] = STATE(8626),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6094] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8627),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8627),
    [sym_operator_assignment] = STATE(8627),
    [sym_conditional] = STATE(8627),
    [sym_range] = STATE(8627),
    [sym_binary] = STATE(8627),
    [sym_unary] = STATE(8627),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6095] = {
    [sym_heredoc_body] = STATE(8628),
    [aux_sym_call_repeat1] = STATE(8628),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6096] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(8629),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11705),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6097] = {
    [sym_heredoc_body] = STATE(8630),
    [aux_sym_call_repeat1] = STATE(8630),
    [aux_sym_argument_list_repeat1] = STATE(8631),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9041),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6098] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8632),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_splat_argument] = STATE(8633),
    [sym_assignment] = STATE(8632),
    [sym_operator_assignment] = STATE(8632),
    [sym_conditional] = STATE(8632),
    [sym_range] = STATE(8632),
    [sym_binary] = STATE(8632),
    [sym_unary] = STATE(8632),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(8633),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6099] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8634),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(8634),
    [sym_operator_assignment] = STATE(8634),
    [sym_conditional] = STATE(8634),
    [sym_range] = STATE(8634),
    [sym_binary] = STATE(8634),
    [sym_unary] = STATE(8634),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6100] = {
    [sym_string] = STATE(8635),
    [aux_sym_chained_string_repeat1] = STATE(8635),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [6101] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8636),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(8636),
    [sym_operator_assignment] = STATE(8636),
    [sym_conditional] = STATE(8636),
    [sym_range] = STATE(8636),
    [sym_binary] = STATE(8636),
    [sym_unary] = STATE(8636),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6102] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8637),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(8637),
    [sym_operator_assignment] = STATE(8637),
    [sym_conditional] = STATE(8637),
    [sym_range] = STATE(8637),
    [sym_binary] = STATE(8637),
    [sym_unary] = STATE(8637),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6103] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8638),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(8638),
    [sym_operator_assignment] = STATE(8638),
    [sym_conditional] = STATE(8638),
    [sym_range] = STATE(8638),
    [sym_binary] = STATE(8638),
    [sym_unary] = STATE(8638),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6104] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8639),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(8639),
    [sym_operator_assignment] = STATE(8639),
    [sym_conditional] = STATE(8639),
    [sym_range] = STATE(8639),
    [sym_binary] = STATE(8639),
    [sym_unary] = STATE(8639),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6105] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6106] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [6107] = {
    [aux_sym_exceptions_repeat1] = STATE(8653),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(11737),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6108] = {
    [anon_sym_EQ] = ACTIONS(11739),
    [sym_comment] = ACTIONS(87),
  },
  [6109] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11741),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_ensure] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11743),
    [anon_sym_DASH_EQ] = ACTIONS(11743),
    [anon_sym_STAR_EQ] = ACTIONS(11743),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11743),
    [anon_sym_SLASH_EQ] = ACTIONS(11743),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11743),
    [anon_sym_PIPE_EQ] = ACTIONS(11743),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11743),
    [anon_sym_AMP_EQ] = ACTIONS(11743),
    [anon_sym_PERCENT_EQ] = ACTIONS(11743),
    [anon_sym_GT_GT_EQ] = ACTIONS(11743),
    [anon_sym_LT_LT_EQ] = ACTIONS(11743),
    [anon_sym_CARET_EQ] = ACTIONS(11743),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6110] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [6111] = {
    [sym_string] = STATE(6111),
    [aux_sym_chained_string_repeat1] = STATE(6111),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6112] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8656),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(8656),
    [sym_operator_assignment] = STATE(8656),
    [sym_conditional] = STATE(8656),
    [sym_range] = STATE(8656),
    [sym_binary] = STATE(8656),
    [sym_unary] = STATE(8656),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6113] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(8657),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6114] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(8657),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6115] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(8657),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6116] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(8657),
    [sym__argument] = STATE(8658),
    [sym_splat_argument] = STATE(8658),
    [sym_hash_splat_argument] = STATE(8658),
    [sym_block_argument] = STATE(8658),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(8658),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5316),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6117] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8659),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(8659),
    [sym_operator_assignment] = STATE(8659),
    [sym_conditional] = STATE(8659),
    [sym_range] = STATE(8659),
    [sym_binary] = STATE(8659),
    [sym_unary] = STATE(8659),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6118] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8660),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(8660),
    [sym_operator_assignment] = STATE(8660),
    [sym_conditional] = STATE(8660),
    [sym_range] = STATE(8660),
    [sym_binary] = STATE(8660),
    [sym_unary] = STATE(8660),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6119] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6120] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [6121] = {
    [anon_sym_EQ] = ACTIONS(11775),
    [sym_comment] = ACTIONS(87),
  },
  [6122] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11777),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11779),
    [anon_sym_DASH_EQ] = ACTIONS(11779),
    [anon_sym_STAR_EQ] = ACTIONS(11779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11779),
    [anon_sym_SLASH_EQ] = ACTIONS(11779),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11779),
    [anon_sym_PIPE_EQ] = ACTIONS(11779),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11779),
    [anon_sym_AMP_EQ] = ACTIONS(11779),
    [anon_sym_PERCENT_EQ] = ACTIONS(11779),
    [anon_sym_GT_GT_EQ] = ACTIONS(11779),
    [anon_sym_LT_LT_EQ] = ACTIONS(11779),
    [anon_sym_CARET_EQ] = ACTIONS(11779),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6123] = {
    [sym_string] = STATE(8675),
    [aux_sym_chained_string_repeat1] = STATE(8675),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6124] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [6125] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6126] = {
    [sym_string] = STATE(6167),
    [aux_sym_chained_string_repeat1] = STATE(6167),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6127] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8676),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(8676),
    [sym_operator_assignment] = STATE(8676),
    [sym_conditional] = STATE(8676),
    [sym_range] = STATE(8676),
    [sym_binary] = STATE(8676),
    [sym_unary] = STATE(8676),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6128] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [6129] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8677),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8677),
    [sym_operator_assignment] = STATE(8677),
    [sym_conditional] = STATE(8677),
    [sym_range] = STATE(8677),
    [sym_binary] = STATE(8677),
    [sym_unary] = STATE(8677),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6130] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8678),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8678),
    [sym_operator_assignment] = STATE(8678),
    [sym_conditional] = STATE(8678),
    [sym_range] = STATE(8678),
    [sym_binary] = STATE(8678),
    [sym_unary] = STATE(8678),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6131] = {
    [anon_sym_COLON] = ACTIONS(11781),
    [sym_comment] = ACTIONS(87),
  },
  [6132] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8680),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8680),
    [sym_operator_assignment] = STATE(8680),
    [sym_conditional] = STATE(8680),
    [sym_range] = STATE(8680),
    [sym_binary] = STATE(8680),
    [sym_unary] = STATE(8680),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6133] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11783),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6134] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [6135] = {
    [sym_heredoc_body] = STATE(8682),
    [aux_sym_call_repeat1] = STATE(8682),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6136] = {
    [sym_heredoc_body] = STATE(8682),
    [aux_sym_call_repeat1] = STATE(8682),
    [aux_sym_argument_list_repeat1] = STATE(8684),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11785),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6137] = {
    [sym_string] = STATE(6167),
    [aux_sym_chained_string_repeat1] = STATE(6167),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11787),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6138] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6139] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [6140] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8685),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8685),
    [sym_operator_assignment] = STATE(8685),
    [sym_conditional] = STATE(8685),
    [sym_range] = STATE(8685),
    [sym_binary] = STATE(8685),
    [sym_unary] = STATE(8685),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6141] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8686),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8686),
    [sym_operator_assignment] = STATE(8686),
    [sym_conditional] = STATE(8686),
    [sym_range] = STATE(8686),
    [sym_binary] = STATE(8686),
    [sym_unary] = STATE(8686),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6142] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8687),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8687),
    [sym_operator_assignment] = STATE(8687),
    [sym_conditional] = STATE(8687),
    [sym_range] = STATE(8687),
    [sym_binary] = STATE(8687),
    [sym_unary] = STATE(8687),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6143] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8688),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8688),
    [sym_operator_assignment] = STATE(8688),
    [sym_conditional] = STATE(8688),
    [sym_range] = STATE(8688),
    [sym_binary] = STATE(8688),
    [sym_unary] = STATE(8688),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6144] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8689),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8689),
    [sym_operator_assignment] = STATE(8689),
    [sym_conditional] = STATE(8689),
    [sym_range] = STATE(8689),
    [sym_binary] = STATE(8689),
    [sym_unary] = STATE(8689),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6145] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8690),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8690),
    [sym_operator_assignment] = STATE(8690),
    [sym_conditional] = STATE(8690),
    [sym_range] = STATE(8690),
    [sym_binary] = STATE(8690),
    [sym_unary] = STATE(8690),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6146] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8691),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(8691),
    [sym_operator_assignment] = STATE(8691),
    [sym_conditional] = STATE(8691),
    [sym_range] = STATE(8691),
    [sym_binary] = STATE(8691),
    [sym_unary] = STATE(8691),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6147] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8692),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8692),
    [sym_operator_assignment] = STATE(8692),
    [sym_conditional] = STATE(8692),
    [sym_range] = STATE(8692),
    [sym_binary] = STATE(8692),
    [sym_unary] = STATE(8692),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6148] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8693),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8693),
    [sym_operator_assignment] = STATE(8693),
    [sym_conditional] = STATE(8693),
    [sym_range] = STATE(8693),
    [sym_binary] = STATE(8693),
    [sym_unary] = STATE(8693),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6149] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8694),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8694),
    [sym_operator_assignment] = STATE(8694),
    [sym_conditional] = STATE(8694),
    [sym_range] = STATE(8694),
    [sym_binary] = STATE(8694),
    [sym_unary] = STATE(8694),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6150] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8695),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8695),
    [sym_operator_assignment] = STATE(8695),
    [sym_conditional] = STATE(8695),
    [sym_range] = STATE(8695),
    [sym_binary] = STATE(8695),
    [sym_unary] = STATE(8695),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6151] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8696),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8696),
    [sym_operator_assignment] = STATE(8696),
    [sym_conditional] = STATE(8696),
    [sym_range] = STATE(8696),
    [sym_binary] = STATE(8696),
    [sym_unary] = STATE(8696),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6152] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8697),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8697),
    [sym_operator_assignment] = STATE(8697),
    [sym_conditional] = STATE(8697),
    [sym_range] = STATE(8697),
    [sym_binary] = STATE(8697),
    [sym_unary] = STATE(8697),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6153] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8698),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8698),
    [sym_operator_assignment] = STATE(8698),
    [sym_conditional] = STATE(8698),
    [sym_range] = STATE(8698),
    [sym_binary] = STATE(8698),
    [sym_unary] = STATE(8698),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6154] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8699),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8699),
    [sym_operator_assignment] = STATE(8699),
    [sym_conditional] = STATE(8699),
    [sym_range] = STATE(8699),
    [sym_binary] = STATE(8699),
    [sym_unary] = STATE(8699),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6155] = {
    [anon_sym_COLON] = ACTIONS(11789),
    [sym_comment] = ACTIONS(87),
  },
  [6156] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8701),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8701),
    [sym_operator_assignment] = STATE(8701),
    [sym_conditional] = STATE(8701),
    [sym_range] = STATE(8701),
    [sym_binary] = STATE(8701),
    [sym_unary] = STATE(8701),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6157] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(11791),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6158] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [6159] = {
    [sym_heredoc_body] = STATE(8703),
    [aux_sym_call_repeat1] = STATE(8703),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6160] = {
    [sym_heredoc_body] = STATE(8703),
    [aux_sym_call_repeat1] = STATE(8703),
    [aux_sym_argument_list_repeat1] = STATE(8705),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11793),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6161] = {
    [sym_string] = STATE(6226),
    [aux_sym_chained_string_repeat1] = STATE(6226),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(11795),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6162] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6163] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(8707),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11797),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6164] = {
    [sym_heredoc_body] = STATE(8708),
    [aux_sym_call_repeat1] = STATE(8708),
    [aux_sym_argument_list_repeat1] = STATE(8709),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9137),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6165] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8710),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_splat_argument] = STATE(8711),
    [sym_assignment] = STATE(8710),
    [sym_operator_assignment] = STATE(8710),
    [sym_conditional] = STATE(8710),
    [sym_range] = STATE(8710),
    [sym_binary] = STATE(8710),
    [sym_unary] = STATE(8710),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(8711),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6166] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8712),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(8712),
    [sym_operator_assignment] = STATE(8712),
    [sym_conditional] = STATE(8712),
    [sym_range] = STATE(8712),
    [sym_binary] = STATE(8712),
    [sym_unary] = STATE(8712),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6167] = {
    [sym_string] = STATE(8713),
    [aux_sym_chained_string_repeat1] = STATE(8713),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6168] = {
    [aux_sym_undef_repeat1] = STATE(8714),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [6169] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6170] = {
    [sym_heredoc_body] = STATE(8715),
    [sym__terminator] = STATE(8715),
    [aux_sym__statements_repeat1] = STATE(6170),
    [sym__line_break2] = ACTIONS(11799),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(11799),
    [anon_sym_end] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [6171] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6172] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6173] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6174] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6175] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5360),
    [anon_sym_or] = ACTIONS(5360),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6176] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6177] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6178] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6179] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6180] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6181] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6182] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11802),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6183] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6184] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6185] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6186] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6187] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6188] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8717),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(8717),
    [sym_operator_assignment] = STATE(8717),
    [sym_conditional] = STATE(8717),
    [sym_range] = STATE(8717),
    [sym_binary] = STATE(8717),
    [sym_unary] = STATE(8717),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6189] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6190] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6191] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6192] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6193] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8718),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(8718),
    [sym_operator_assignment] = STATE(8718),
    [sym_conditional] = STATE(8718),
    [sym_range] = STATE(8718),
    [sym_binary] = STATE(8718),
    [sym_unary] = STATE(8718),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6194] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8719),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(8719),
    [sym_operator_assignment] = STATE(8719),
    [sym_conditional] = STATE(8719),
    [sym_range] = STATE(8719),
    [sym_binary] = STATE(8719),
    [sym_unary] = STATE(8719),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6195] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6196] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [6197] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(3391),
    [sym__argument] = STATE(3392),
    [sym_splat_argument] = STATE(3392),
    [sym_hash_splat_argument] = STATE(3392),
    [sym_block_argument] = STATE(3392),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3392),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5394),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6198] = {
    [anon_sym_EQ] = ACTIONS(11832),
    [sym_comment] = ACTIONS(87),
  },
  [6199] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11834),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11836),
    [anon_sym_DASH_EQ] = ACTIONS(11836),
    [anon_sym_STAR_EQ] = ACTIONS(11836),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11836),
    [anon_sym_SLASH_EQ] = ACTIONS(11836),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11836),
    [anon_sym_PIPE_EQ] = ACTIONS(11836),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11836),
    [anon_sym_AMP_EQ] = ACTIONS(11836),
    [anon_sym_PERCENT_EQ] = ACTIONS(11836),
    [anon_sym_GT_GT_EQ] = ACTIONS(11836),
    [anon_sym_LT_LT_EQ] = ACTIONS(11836),
    [anon_sym_CARET_EQ] = ACTIONS(11836),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6200] = {
    [sym_string] = STATE(8734),
    [aux_sym_chained_string_repeat1] = STATE(8734),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6201] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [6202] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [6203] = {
    [sym_string] = STATE(6226),
    [aux_sym_chained_string_repeat1] = STATE(6226),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6204] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8735),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(8735),
    [sym_operator_assignment] = STATE(8735),
    [sym_conditional] = STATE(8735),
    [sym_range] = STATE(8735),
    [sym_binary] = STATE(8735),
    [sym_unary] = STATE(8735),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6205] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [6206] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6207] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [6208] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8736),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8736),
    [sym_operator_assignment] = STATE(8736),
    [sym_conditional] = STATE(8736),
    [sym_range] = STATE(8736),
    [sym_binary] = STATE(8736),
    [sym_unary] = STATE(8736),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6209] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8737),
    [sym_operator_assignment] = STATE(8737),
    [sym_conditional] = STATE(8737),
    [sym_range] = STATE(8737),
    [sym_binary] = STATE(8737),
    [sym_unary] = STATE(8737),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6210] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8738),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8738),
    [sym_operator_assignment] = STATE(8738),
    [sym_conditional] = STATE(8738),
    [sym_range] = STATE(8738),
    [sym_binary] = STATE(8738),
    [sym_unary] = STATE(8738),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6211] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8739),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8739),
    [sym_operator_assignment] = STATE(8739),
    [sym_conditional] = STATE(8739),
    [sym_range] = STATE(8739),
    [sym_binary] = STATE(8739),
    [sym_unary] = STATE(8739),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6212] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8740),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8740),
    [sym_operator_assignment] = STATE(8740),
    [sym_conditional] = STATE(8740),
    [sym_range] = STATE(8740),
    [sym_binary] = STATE(8740),
    [sym_unary] = STATE(8740),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6213] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8741),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8741),
    [sym_operator_assignment] = STATE(8741),
    [sym_conditional] = STATE(8741),
    [sym_range] = STATE(8741),
    [sym_binary] = STATE(8741),
    [sym_unary] = STATE(8741),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6214] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8742),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(8742),
    [sym_operator_assignment] = STATE(8742),
    [sym_conditional] = STATE(8742),
    [sym_range] = STATE(8742),
    [sym_binary] = STATE(8742),
    [sym_unary] = STATE(8742),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6215] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8743),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8743),
    [sym_operator_assignment] = STATE(8743),
    [sym_conditional] = STATE(8743),
    [sym_range] = STATE(8743),
    [sym_binary] = STATE(8743),
    [sym_unary] = STATE(8743),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6216] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8744),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8744),
    [sym_operator_assignment] = STATE(8744),
    [sym_conditional] = STATE(8744),
    [sym_range] = STATE(8744),
    [sym_binary] = STATE(8744),
    [sym_unary] = STATE(8744),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6217] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8745),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8745),
    [sym_operator_assignment] = STATE(8745),
    [sym_conditional] = STATE(8745),
    [sym_range] = STATE(8745),
    [sym_binary] = STATE(8745),
    [sym_unary] = STATE(8745),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6218] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8746),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8746),
    [sym_operator_assignment] = STATE(8746),
    [sym_conditional] = STATE(8746),
    [sym_range] = STATE(8746),
    [sym_binary] = STATE(8746),
    [sym_unary] = STATE(8746),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6219] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8747),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8747),
    [sym_operator_assignment] = STATE(8747),
    [sym_conditional] = STATE(8747),
    [sym_range] = STATE(8747),
    [sym_binary] = STATE(8747),
    [sym_unary] = STATE(8747),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6220] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8748),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8748),
    [sym_operator_assignment] = STATE(8748),
    [sym_conditional] = STATE(8748),
    [sym_range] = STATE(8748),
    [sym_binary] = STATE(8748),
    [sym_unary] = STATE(8748),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6221] = {
    [sym_heredoc_body] = STATE(8749),
    [aux_sym_call_repeat1] = STATE(8749),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6222] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(8750),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11838),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6223] = {
    [sym_heredoc_body] = STATE(8751),
    [aux_sym_call_repeat1] = STATE(8751),
    [aux_sym_argument_list_repeat1] = STATE(8752),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9207),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6224] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8753),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_splat_argument] = STATE(8754),
    [sym_assignment] = STATE(8753),
    [sym_operator_assignment] = STATE(8753),
    [sym_conditional] = STATE(8753),
    [sym_range] = STATE(8753),
    [sym_binary] = STATE(8753),
    [sym_unary] = STATE(8753),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(8754),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6225] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8755),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(8755),
    [sym_operator_assignment] = STATE(8755),
    [sym_conditional] = STATE(8755),
    [sym_range] = STATE(8755),
    [sym_binary] = STATE(8755),
    [sym_unary] = STATE(8755),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6226] = {
    [sym_string] = STATE(8756),
    [aux_sym_chained_string_repeat1] = STATE(8756),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [6227] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8757),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(8757),
    [sym_operator_assignment] = STATE(8757),
    [sym_conditional] = STATE(8757),
    [sym_range] = STATE(8757),
    [sym_binary] = STATE(8757),
    [sym_unary] = STATE(8757),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6228] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8758),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(8758),
    [sym_operator_assignment] = STATE(8758),
    [sym_conditional] = STATE(8758),
    [sym_range] = STATE(8758),
    [sym_binary] = STATE(8758),
    [sym_unary] = STATE(8758),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6229] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8759),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(8759),
    [sym_operator_assignment] = STATE(8759),
    [sym_conditional] = STATE(8759),
    [sym_range] = STATE(8759),
    [sym_binary] = STATE(8759),
    [sym_unary] = STATE(8759),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6230] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8760),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(8760),
    [sym_operator_assignment] = STATE(8760),
    [sym_conditional] = STATE(8760),
    [sym_range] = STATE(8760),
    [sym_binary] = STATE(8760),
    [sym_unary] = STATE(8760),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6231] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6232] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [6233] = {
    [aux_sym_exceptions_repeat1] = STATE(8774),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(11870),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6234] = {
    [anon_sym_EQ] = ACTIONS(11872),
    [sym_comment] = ACTIONS(87),
  },
  [6235] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11874),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11876),
    [anon_sym_DASH_EQ] = ACTIONS(11876),
    [anon_sym_STAR_EQ] = ACTIONS(11876),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11876),
    [anon_sym_SLASH_EQ] = ACTIONS(11876),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11876),
    [anon_sym_PIPE_EQ] = ACTIONS(11876),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11876),
    [anon_sym_AMP_EQ] = ACTIONS(11876),
    [anon_sym_PERCENT_EQ] = ACTIONS(11876),
    [anon_sym_GT_GT_EQ] = ACTIONS(11876),
    [anon_sym_LT_LT_EQ] = ACTIONS(11876),
    [anon_sym_CARET_EQ] = ACTIONS(11876),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6236] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [6237] = {
    [sym_string] = STATE(6237),
    [aux_sym_chained_string_repeat1] = STATE(6237),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6238] = {
    [aux_sym_undef_repeat1] = STATE(6238),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_else] = ACTIONS(9314),
    [anon_sym_ensure] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [6239] = {
    [sym__line_break2] = ACTIONS(11878),
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [ts_builtin_sym_end] = ACTIONS(11878),
    [anon_sym___END__] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11878),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_end] = ACTIONS(11878),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_when] = ACTIONS(11878),
    [anon_sym_elsif] = ACTIONS(11878),
    [anon_sym_else] = ACTIONS(11878),
    [anon_sym_then] = ACTIONS(11878),
    [anon_sym_ensure] = ACTIONS(11878),
    [anon_sym_EQ_GT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11878),
    [anon_sym_AMP_AMP] = ACTIONS(11878),
    [anon_sym_LT_LT] = ACTIONS(11878),
    [anon_sym_GT_GT] = ACTIONS(11878),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11878),
    [anon_sym_PLUS] = ACTIONS(11878),
    [anon_sym_SLASH] = ACTIONS(11878),
    [anon_sym_PERCENT] = ACTIONS(11878),
    [sym_comment] = ACTIONS(87),
  },
  [6240] = {
    [anon_sym_end] = ACTIONS(11882),
    [sym_comment] = ACTIONS(87),
  },
  [6241] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6242] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8778),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(8778),
    [sym_operator_assignment] = STATE(8778),
    [sym_conditional] = STATE(8778),
    [sym_range] = STATE(8778),
    [sym_binary] = STATE(8778),
    [sym_unary] = STATE(8778),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6243] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [6244] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6245] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [6246] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8779),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8779),
    [sym_operator_assignment] = STATE(8779),
    [sym_conditional] = STATE(8779),
    [sym_range] = STATE(8779),
    [sym_binary] = STATE(8779),
    [sym_unary] = STATE(8779),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6247] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8780),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8780),
    [sym_operator_assignment] = STATE(8780),
    [sym_conditional] = STATE(8780),
    [sym_range] = STATE(8780),
    [sym_binary] = STATE(8780),
    [sym_unary] = STATE(8780),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6248] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8781),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8781),
    [sym_operator_assignment] = STATE(8781),
    [sym_conditional] = STATE(8781),
    [sym_range] = STATE(8781),
    [sym_binary] = STATE(8781),
    [sym_unary] = STATE(8781),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6249] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8782),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8782),
    [sym_operator_assignment] = STATE(8782),
    [sym_conditional] = STATE(8782),
    [sym_range] = STATE(8782),
    [sym_binary] = STATE(8782),
    [sym_unary] = STATE(8782),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6250] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8783),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8783),
    [sym_operator_assignment] = STATE(8783),
    [sym_conditional] = STATE(8783),
    [sym_range] = STATE(8783),
    [sym_binary] = STATE(8783),
    [sym_unary] = STATE(8783),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6251] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8784),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8784),
    [sym_operator_assignment] = STATE(8784),
    [sym_conditional] = STATE(8784),
    [sym_range] = STATE(8784),
    [sym_binary] = STATE(8784),
    [sym_unary] = STATE(8784),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6252] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8785),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8785),
    [sym_operator_assignment] = STATE(8785),
    [sym_conditional] = STATE(8785),
    [sym_range] = STATE(8785),
    [sym_binary] = STATE(8785),
    [sym_unary] = STATE(8785),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6253] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8786),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8786),
    [sym_operator_assignment] = STATE(8786),
    [sym_conditional] = STATE(8786),
    [sym_range] = STATE(8786),
    [sym_binary] = STATE(8786),
    [sym_unary] = STATE(8786),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6254] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8787),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8787),
    [sym_operator_assignment] = STATE(8787),
    [sym_conditional] = STATE(8787),
    [sym_range] = STATE(8787),
    [sym_binary] = STATE(8787),
    [sym_unary] = STATE(8787),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6255] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8788),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8788),
    [sym_operator_assignment] = STATE(8788),
    [sym_conditional] = STATE(8788),
    [sym_range] = STATE(8788),
    [sym_binary] = STATE(8788),
    [sym_unary] = STATE(8788),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6256] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8789),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8789),
    [sym_operator_assignment] = STATE(8789),
    [sym_conditional] = STATE(8789),
    [sym_range] = STATE(8789),
    [sym_binary] = STATE(8789),
    [sym_unary] = STATE(8789),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6257] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8790),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8790),
    [sym_operator_assignment] = STATE(8790),
    [sym_conditional] = STATE(8790),
    [sym_range] = STATE(8790),
    [sym_binary] = STATE(8790),
    [sym_unary] = STATE(8790),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6258] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8791),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_splat_argument] = STATE(8792),
    [sym_assignment] = STATE(8791),
    [sym_operator_assignment] = STATE(8791),
    [sym_conditional] = STATE(8791),
    [sym_range] = STATE(8791),
    [sym_binary] = STATE(8791),
    [sym_unary] = STATE(8791),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(8792),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6259] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8793),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(8793),
    [sym_operator_assignment] = STATE(8793),
    [sym_conditional] = STATE(8793),
    [sym_range] = STATE(8793),
    [sym_binary] = STATE(8793),
    [sym_unary] = STATE(8793),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [6260] = {
    [sym_string] = STATE(8794),
    [aux_sym_chained_string_repeat1] = STATE(8794),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [6261] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [6262] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6263] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [6264] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6265] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [6266] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6267] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6268] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [6269] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11884),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6270] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6271] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6272] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6273] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6274] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6275] = {
    [sym_heredoc_body] = STATE(6275),
    [aux_sym_call_repeat1] = STATE(6275),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [6276] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1300),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(1300),
    [sym_operator_assignment] = STATE(1300),
    [sym_conditional] = STATE(1300),
    [sym_range] = STATE(1300),
    [sym_binary] = STATE(1300),
    [sym_unary] = STATE(1300),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1306),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(2255),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__identifier_hash_key2] = ACTIONS(2261),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9274),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2279),
    [sym_identifier] = ACTIONS(2279),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6277] = {
    [sym_heredoc_body] = STATE(6275),
    [aux_sym_call_repeat1] = STATE(6275),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [6278] = {
    [aux_sym_argument_list_repeat1] = STATE(6278),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11886),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [6279] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6280] = {
    [aux_sym_exceptions_repeat1] = STATE(8797),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [6281] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [6282] = {
    [sym_string] = STATE(6282),
    [aux_sym_chained_string_repeat1] = STATE(6282),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [6283] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [6284] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6285] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6286] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [6287] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8798),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8798),
    [sym_operator_assignment] = STATE(8798),
    [sym_conditional] = STATE(8798),
    [sym_range] = STATE(8798),
    [sym_binary] = STATE(8798),
    [sym_unary] = STATE(8798),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6288] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8799),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8799),
    [sym_operator_assignment] = STATE(8799),
    [sym_conditional] = STATE(8799),
    [sym_range] = STATE(8799),
    [sym_binary] = STATE(8799),
    [sym_unary] = STATE(8799),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6289] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8800),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8800),
    [sym_operator_assignment] = STATE(8800),
    [sym_conditional] = STATE(8800),
    [sym_range] = STATE(8800),
    [sym_binary] = STATE(8800),
    [sym_unary] = STATE(8800),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6290] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8801),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8801),
    [sym_operator_assignment] = STATE(8801),
    [sym_conditional] = STATE(8801),
    [sym_range] = STATE(8801),
    [sym_binary] = STATE(8801),
    [sym_unary] = STATE(8801),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6291] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8802),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8802),
    [sym_operator_assignment] = STATE(8802),
    [sym_conditional] = STATE(8802),
    [sym_range] = STATE(8802),
    [sym_binary] = STATE(8802),
    [sym_unary] = STATE(8802),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6292] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8803),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8803),
    [sym_operator_assignment] = STATE(8803),
    [sym_conditional] = STATE(8803),
    [sym_range] = STATE(8803),
    [sym_binary] = STATE(8803),
    [sym_unary] = STATE(8803),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6293] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8804),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8804),
    [sym_operator_assignment] = STATE(8804),
    [sym_conditional] = STATE(8804),
    [sym_range] = STATE(8804),
    [sym_binary] = STATE(8804),
    [sym_unary] = STATE(8804),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6294] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8805),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8805),
    [sym_operator_assignment] = STATE(8805),
    [sym_conditional] = STATE(8805),
    [sym_range] = STATE(8805),
    [sym_binary] = STATE(8805),
    [sym_unary] = STATE(8805),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6295] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8806),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8806),
    [sym_operator_assignment] = STATE(8806),
    [sym_conditional] = STATE(8806),
    [sym_range] = STATE(8806),
    [sym_binary] = STATE(8806),
    [sym_unary] = STATE(8806),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6296] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8807),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8807),
    [sym_operator_assignment] = STATE(8807),
    [sym_conditional] = STATE(8807),
    [sym_range] = STATE(8807),
    [sym_binary] = STATE(8807),
    [sym_unary] = STATE(8807),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6297] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8808),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8808),
    [sym_operator_assignment] = STATE(8808),
    [sym_conditional] = STATE(8808),
    [sym_range] = STATE(8808),
    [sym_binary] = STATE(8808),
    [sym_unary] = STATE(8808),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6298] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8809),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8809),
    [sym_operator_assignment] = STATE(8809),
    [sym_conditional] = STATE(8809),
    [sym_range] = STATE(8809),
    [sym_binary] = STATE(8809),
    [sym_unary] = STATE(8809),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6299] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3466),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(3466),
    [sym_operator_assignment] = STATE(3466),
    [sym_conditional] = STATE(3466),
    [sym_range] = STATE(3466),
    [sym_binary] = STATE(3466),
    [sym_unary] = STATE(3466),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5486),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6300] = {
    [aux_sym_exceptions_repeat1] = STATE(8810),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(9306),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [6301] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(3466),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_splat_argument] = STATE(8811),
    [sym_assignment] = STATE(3466),
    [sym_operator_assignment] = STATE(3466),
    [sym_conditional] = STATE(3466),
    [sym_range] = STATE(3466),
    [sym_binary] = STATE(3466),
    [sym_unary] = STATE(3466),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(8811),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5486),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6302] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8812),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(8812),
    [sym_operator_assignment] = STATE(8812),
    [sym_conditional] = STATE(8812),
    [sym_range] = STATE(8812),
    [sym_binary] = STATE(8812),
    [sym_unary] = STATE(8812),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6303] = {
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6517),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_in] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_EQ_GT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_RBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_COLON2] = ACTIONS(6519),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6517),
    [anon_sym_GT_GT] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6517),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_SLASH] = ACTIONS(6517),
    [anon_sym_PERCENT] = ACTIONS(6517),
    [sym_comment] = ACTIONS(87),
  },
  [6304] = {
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6521),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_in] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_EQ_GT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_RBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_COLON2] = ACTIONS(6523),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6521),
    [anon_sym_AMP_AMP] = ACTIONS(6521),
    [anon_sym_LT_LT] = ACTIONS(6521),
    [anon_sym_GT_GT] = ACTIONS(6521),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6521),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_PERCENT] = ACTIONS(6521),
    [sym_comment] = ACTIONS(87),
  },
  [6305] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(11889),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6306] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(11889),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11891),
  },
  [6307] = {
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6529),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_in] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_EQ_GT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_RBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_COLON2] = ACTIONS(6531),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6529),
    [anon_sym_AMP_AMP] = ACTIONS(6529),
    [anon_sym_LT_LT] = ACTIONS(6529),
    [anon_sym_GT_GT] = ACTIONS(6529),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6529),
    [anon_sym_PLUS] = ACTIONS(6529),
    [anon_sym_SLASH] = ACTIONS(6529),
    [anon_sym_PERCENT] = ACTIONS(6529),
    [sym_comment] = ACTIONS(87),
  },
  [6308] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(11893),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6309] = {
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6542),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_in] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_EQ_GT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_RBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_COLON2] = ACTIONS(6544),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6542),
    [anon_sym_AMP_AMP] = ACTIONS(6542),
    [anon_sym_LT_LT] = ACTIONS(6542),
    [anon_sym_GT_GT] = ACTIONS(6542),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6542),
    [anon_sym_PLUS] = ACTIONS(6542),
    [anon_sym_SLASH] = ACTIONS(6542),
    [anon_sym_PERCENT] = ACTIONS(6542),
    [sym_comment] = ACTIONS(87),
  },
  [6310] = {
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6546),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_in] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_EQ_GT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_RBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_COLON2] = ACTIONS(6548),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6546),
    [anon_sym_AMP_AMP] = ACTIONS(6546),
    [anon_sym_LT_LT] = ACTIONS(6546),
    [anon_sym_GT_GT] = ACTIONS(6546),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6546),
    [anon_sym_PLUS] = ACTIONS(6546),
    [anon_sym_SLASH] = ACTIONS(6546),
    [anon_sym_PERCENT] = ACTIONS(6546),
    [sym_comment] = ACTIONS(87),
  },
  [6311] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(11895),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6312] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(11895),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(11897),
  },
  [6313] = {
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6554),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_in] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_EQ_GT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_RBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_COLON2] = ACTIONS(6556),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6554),
    [anon_sym_AMP_AMP] = ACTIONS(6554),
    [anon_sym_LT_LT] = ACTIONS(6554),
    [anon_sym_GT_GT] = ACTIONS(6554),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6554),
    [anon_sym_PLUS] = ACTIONS(6554),
    [anon_sym_SLASH] = ACTIONS(6554),
    [anon_sym_PERCENT] = ACTIONS(6554),
    [sym_comment] = ACTIONS(87),
  },
  [6314] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(11899),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6315] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8819),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(8819),
    [sym_operator_assignment] = STATE(8819),
    [sym_conditional] = STATE(8819),
    [sym_range] = STATE(8819),
    [sym_binary] = STATE(8819),
    [sym_unary] = STATE(8819),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6316] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8820),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(8820),
    [sym_operator_assignment] = STATE(8820),
    [sym_conditional] = STATE(8820),
    [sym_range] = STATE(8820),
    [sym_binary] = STATE(8820),
    [sym_unary] = STATE(8820),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6317] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8821),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(8821),
    [sym_operator_assignment] = STATE(8821),
    [sym_conditional] = STATE(8821),
    [sym_range] = STATE(8821),
    [sym_binary] = STATE(8821),
    [sym_unary] = STATE(8821),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6318] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6319] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [6320] = {
    [anon_sym_EQ] = ACTIONS(11931),
    [sym_comment] = ACTIONS(87),
  },
  [6321] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11933),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11935),
    [anon_sym_DASH_EQ] = ACTIONS(11935),
    [anon_sym_STAR_EQ] = ACTIONS(11935),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11935),
    [anon_sym_SLASH_EQ] = ACTIONS(11935),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11935),
    [anon_sym_PIPE_EQ] = ACTIONS(11935),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11935),
    [anon_sym_AMP_EQ] = ACTIONS(11935),
    [anon_sym_PERCENT_EQ] = ACTIONS(11935),
    [anon_sym_GT_GT_EQ] = ACTIONS(11935),
    [anon_sym_LT_LT_EQ] = ACTIONS(11935),
    [anon_sym_CARET_EQ] = ACTIONS(11935),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6322] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [6323] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8836),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(8836),
    [sym_operator_assignment] = STATE(8836),
    [sym_conditional] = STATE(8836),
    [sym_range] = STATE(8836),
    [sym_binary] = STATE(8836),
    [sym_unary] = STATE(8836),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6324] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [6325] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8837),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(8837),
    [sym_operator_assignment] = STATE(8837),
    [sym_conditional] = STATE(8837),
    [sym_range] = STATE(8837),
    [sym_binary] = STATE(8837),
    [sym_unary] = STATE(8837),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6326] = {
    [sym_heredoc_body] = STATE(8838),
    [aux_sym_call_repeat1] = STATE(8838),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6327] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(8839),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11937),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6328] = {
    [sym_heredoc_body] = STATE(8840),
    [aux_sym_call_repeat1] = STATE(8840),
    [aux_sym_argument_list_repeat1] = STATE(8841),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9355),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6329] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6330] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6331] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6332] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6333] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6334] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6335] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11939),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6336] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6337] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6338] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6339] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6340] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6341] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8843),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(8843),
    [sym_operator_assignment] = STATE(8843),
    [sym_conditional] = STATE(8843),
    [sym_range] = STATE(8843),
    [sym_binary] = STATE(8843),
    [sym_unary] = STATE(8843),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6342] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_RBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6343] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_RBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6344] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_RBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6345] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_RBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6346] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8844),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(8844),
    [sym_operator_assignment] = STATE(8844),
    [sym_conditional] = STATE(8844),
    [sym_range] = STATE(8844),
    [sym_binary] = STATE(8844),
    [sym_unary] = STATE(8844),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6347] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8845),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(8845),
    [sym_operator_assignment] = STATE(8845),
    [sym_conditional] = STATE(8845),
    [sym_range] = STATE(8845),
    [sym_binary] = STATE(8845),
    [sym_unary] = STATE(8845),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6348] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6349] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_RBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [6350] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(3521),
    [sym__argument] = STATE(3522),
    [sym_splat_argument] = STATE(3522),
    [sym_hash_splat_argument] = STATE(3522),
    [sym_block_argument] = STATE(3522),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3522),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_RBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2471),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6351] = {
    [anon_sym_EQ] = ACTIONS(11969),
    [sym_comment] = ACTIONS(87),
  },
  [6352] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(11971),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(11973),
    [anon_sym_DASH_EQ] = ACTIONS(11973),
    [anon_sym_STAR_EQ] = ACTIONS(11973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11973),
    [anon_sym_SLASH_EQ] = ACTIONS(11973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11973),
    [anon_sym_PIPE_EQ] = ACTIONS(11973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11973),
    [anon_sym_AMP_EQ] = ACTIONS(11973),
    [anon_sym_PERCENT_EQ] = ACTIONS(11973),
    [anon_sym_GT_GT_EQ] = ACTIONS(11973),
    [anon_sym_LT_LT_EQ] = ACTIONS(11973),
    [anon_sym_CARET_EQ] = ACTIONS(11973),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6353] = {
    [sym_string] = STATE(8860),
    [aux_sym_chained_string_repeat1] = STATE(8860),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_RBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6354] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [6355] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8861),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(8861),
    [sym_operator_assignment] = STATE(8861),
    [sym_conditional] = STATE(8861),
    [sym_range] = STATE(8861),
    [sym_binary] = STATE(8861),
    [sym_unary] = STATE(8861),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6356] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_RBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [6357] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(8862),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(8862),
    [sym_operator_assignment] = STATE(8862),
    [sym_conditional] = STATE(8862),
    [sym_range] = STATE(8862),
    [sym_binary] = STATE(8862),
    [sym_unary] = STATE(8862),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6358] = {
    [sym_heredoc_body] = STATE(8863),
    [aux_sym_call_repeat1] = STATE(8863),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6359] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(8864),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11975),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6360] = {
    [sym_heredoc_body] = STATE(8865),
    [aux_sym_call_repeat1] = STATE(8865),
    [aux_sym_argument_list_repeat1] = STATE(8866),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9387),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_RBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6361] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8867),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(8867),
    [sym_operator_assignment] = STATE(8867),
    [sym_conditional] = STATE(8867),
    [sym_range] = STATE(8867),
    [sym_binary] = STATE(8867),
    [sym_unary] = STATE(8867),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6362] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6363] = {
    [aux_sym_exceptions_repeat1] = STATE(8869),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6364] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [6365] = {
    [sym_string] = STATE(6365),
    [aux_sym_chained_string_repeat1] = STATE(6365),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6366] = {
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7098),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_in] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_EQ_GT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_RBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_COLON2] = ACTIONS(7100),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7098),
    [anon_sym_AMP_AMP] = ACTIONS(7098),
    [anon_sym_LT_LT] = ACTIONS(7098),
    [anon_sym_GT_GT] = ACTIONS(7098),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7098),
    [anon_sym_PLUS] = ACTIONS(7098),
    [anon_sym_SLASH] = ACTIONS(7098),
    [anon_sym_PERCENT] = ACTIONS(7098),
    [sym_comment] = ACTIONS(87),
  },
  [6367] = {
    [anon_sym_DOT] = ACTIONS(11977),
    [anon_sym_COLON_COLON] = ACTIONS(11977),
    [sym_comment] = ACTIONS(87),
  },
  [6368] = {
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7258),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_in] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_EQ_GT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_RBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_COLON2] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7258),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [anon_sym_LT_LT] = ACTIONS(7258),
    [anon_sym_GT_GT] = ACTIONS(7258),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7258),
    [anon_sym_PLUS] = ACTIONS(7258),
    [anon_sym_SLASH] = ACTIONS(7258),
    [anon_sym_PERCENT] = ACTIONS(7258),
    [sym_comment] = ACTIONS(87),
  },
  [6369] = {
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7274),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_in] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_EQ_GT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_RBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_COLON2] = ACTIONS(7276),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7274),
    [anon_sym_GT_GT] = ACTIONS(7274),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7274),
    [anon_sym_PLUS] = ACTIONS(7274),
    [anon_sym_SLASH] = ACTIONS(7274),
    [anon_sym_PERCENT] = ACTIONS(7274),
    [sym_comment] = ACTIONS(87),
  },
  [6370] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(8871),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11979),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6371] = {
    [sym__statements] = STATE(1390),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1391),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1392),
    [sym_rescue] = STATE(1393),
    [sym__body_statement] = STATE(8872),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11981),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6372] = {
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7730),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_in] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_EQ_GT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_RBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_COLON2] = ACTIONS(7732),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7730),
    [anon_sym_AMP_AMP] = ACTIONS(7730),
    [anon_sym_LT_LT] = ACTIONS(7730),
    [anon_sym_GT_GT] = ACTIONS(7730),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7730),
    [anon_sym_PLUS] = ACTIONS(7730),
    [anon_sym_SLASH] = ACTIONS(7730),
    [anon_sym_PERCENT] = ACTIONS(7730),
    [sym_comment] = ACTIONS(87),
  },
  [6373] = {
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_in] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_RBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_COLON2] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7788),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [sym_comment] = ACTIONS(87),
  },
  [6374] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_RBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6375] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6376] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6377] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6378] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6379] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6380] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6381] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_RBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6382] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(11983),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6383] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6384] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6385] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6386] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6387] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6388] = {
    [sym_heredoc_body] = STATE(6388),
    [aux_sym_call_repeat1] = STATE(6388),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_RBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [6389] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1373),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(1373),
    [sym_operator_assignment] = STATE(1373),
    [sym_conditional] = STATE(1373),
    [sym_range] = STATE(1373),
    [sym_binary] = STATE(1373),
    [sym_unary] = STATE(1373),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1379),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2367),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__identifier_hash_key2] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9409),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(2383),
    [sym_identifier] = ACTIONS(2383),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6390] = {
    [sym_heredoc_body] = STATE(6388),
    [aux_sym_call_repeat1] = STATE(6388),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_RBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [6391] = {
    [aux_sym_argument_list_repeat1] = STATE(6391),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(11985),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [6392] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6393] = {
    [aux_sym_exceptions_repeat1] = STATE(8875),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6394] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [6395] = {
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7970),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_in] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_EQ_GT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_RBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_COLON2] = ACTIONS(7972),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7970),
    [anon_sym_AMP_AMP] = ACTIONS(7970),
    [anon_sym_LT_LT] = ACTIONS(7970),
    [anon_sym_GT_GT] = ACTIONS(7970),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7970),
    [anon_sym_PLUS] = ACTIONS(7970),
    [anon_sym_SLASH] = ACTIONS(7970),
    [anon_sym_PERCENT] = ACTIONS(7970),
    [sym_comment] = ACTIONS(87),
  },
  [6396] = {
    [sym_elsif] = STATE(8877),
    [sym_else] = STATE(8877),
    [sym__if_tail] = STATE(8877),
    [anon_sym_end] = ACTIONS(11988),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [6397] = {
    [anon_sym_end] = ACTIONS(11988),
    [sym_comment] = ACTIONS(87),
  },
  [6398] = {
    [sym__statements] = STATE(8878),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(8877),
    [sym_else] = STATE(8877),
    [sym__if_tail] = STATE(8877),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11990),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6399] = {
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8176),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_in] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_COLON2] = ACTIONS(8178),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8176),
    [anon_sym_AMP_AMP] = ACTIONS(8176),
    [anon_sym_LT_LT] = ACTIONS(8176),
    [anon_sym_GT_GT] = ACTIONS(8176),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8176),
    [anon_sym_PLUS] = ACTIONS(8176),
    [anon_sym_SLASH] = ACTIONS(8176),
    [anon_sym_PERCENT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(87),
  },
  [6400] = {
    [sym_else] = STATE(8880),
    [anon_sym_end] = ACTIONS(11992),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [6401] = {
    [anon_sym_end] = ACTIONS(11992),
    [sym_comment] = ACTIONS(87),
  },
  [6402] = {
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8352),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_in] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_EQ_GT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_COLON2] = ACTIONS(8354),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8352),
    [anon_sym_AMP_AMP] = ACTIONS(8352),
    [anon_sym_LT_LT] = ACTIONS(8352),
    [anon_sym_GT_GT] = ACTIONS(8352),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8352),
    [anon_sym_PLUS] = ACTIONS(8352),
    [anon_sym_SLASH] = ACTIONS(8352),
    [anon_sym_PERCENT] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [6403] = {
    [anon_sym_end] = ACTIONS(11994),
    [sym_comment] = ACTIONS(87),
  },
  [6404] = {
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8432),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_in] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_EQ_GT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_RBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_COLON2] = ACTIONS(8434),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8432),
    [anon_sym_AMP_AMP] = ACTIONS(8432),
    [anon_sym_LT_LT] = ACTIONS(8432),
    [anon_sym_GT_GT] = ACTIONS(8432),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8432),
    [anon_sym_PLUS] = ACTIONS(8432),
    [anon_sym_SLASH] = ACTIONS(8432),
    [anon_sym_PERCENT] = ACTIONS(8432),
    [sym_comment] = ACTIONS(87),
  },
  [6405] = {
    [anon_sym_end] = ACTIONS(11996),
    [sym_comment] = ACTIONS(87),
  },
  [6406] = {
    [sym__statements] = STATE(8884),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(11998),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6407] = {
    [anon_sym_end] = ACTIONS(12000),
    [sym_comment] = ACTIONS(87),
  },
  [6408] = {
    [sym_when] = STATE(8886),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [6409] = {
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8696),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_in] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_EQ_GT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_RBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_COLON2] = ACTIONS(8698),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8696),
    [anon_sym_AMP_AMP] = ACTIONS(8696),
    [anon_sym_LT_LT] = ACTIONS(8696),
    [anon_sym_GT_GT] = ACTIONS(8696),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8696),
    [anon_sym_PLUS] = ACTIONS(8696),
    [anon_sym_SLASH] = ACTIONS(8696),
    [anon_sym_PERCENT] = ACTIONS(8696),
    [sym_comment] = ACTIONS(87),
  },
  [6410] = {
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9229),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_in] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_EQ_GT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_RBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_COLON2] = ACTIONS(9231),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9229),
    [anon_sym_AMP_AMP] = ACTIONS(9229),
    [anon_sym_LT_LT] = ACTIONS(9229),
    [anon_sym_GT_GT] = ACTIONS(9229),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9229),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9229),
    [anon_sym_PERCENT] = ACTIONS(9229),
    [sym_comment] = ACTIONS(87),
  },
  [6411] = {
    [anon_sym_end] = ACTIONS(12002),
    [sym_comment] = ACTIONS(87),
  },
  [6412] = {
    [sym_ensure] = STATE(8888),
    [anon_sym_end] = ACTIONS(12002),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6413] = {
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9457),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_in] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_EQ_GT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_RBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_COLON2] = ACTIONS(9459),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9457),
    [anon_sym_AMP_AMP] = ACTIONS(9457),
    [anon_sym_LT_LT] = ACTIONS(9457),
    [anon_sym_GT_GT] = ACTIONS(9457),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9457),
    [anon_sym_PLUS] = ACTIONS(9457),
    [anon_sym_SLASH] = ACTIONS(9457),
    [anon_sym_PERCENT] = ACTIONS(9457),
    [sym_comment] = ACTIONS(87),
  },
  [6414] = {
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_in] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_RBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_COLON2] = ACTIONS(9488),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9486),
    [anon_sym_AMP_AMP] = ACTIONS(9486),
    [anon_sym_LT_LT] = ACTIONS(9486),
    [anon_sym_GT_GT] = ACTIONS(9486),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9486),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_SLASH] = ACTIONS(9486),
    [anon_sym_PERCENT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [6415] = {
    [anon_sym_RBRACE] = ACTIONS(12004),
    [sym_comment] = ACTIONS(87),
  },
  [6416] = {
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9506),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_in] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_RBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_COLON2] = ACTIONS(9508),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9506),
    [anon_sym_AMP_AMP] = ACTIONS(9506),
    [anon_sym_LT_LT] = ACTIONS(9506),
    [anon_sym_GT_GT] = ACTIONS(9506),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9506),
    [anon_sym_PLUS] = ACTIONS(9506),
    [anon_sym_SLASH] = ACTIONS(9506),
    [anon_sym_PERCENT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [6417] = {
    [anon_sym_end] = ACTIONS(12006),
    [sym_comment] = ACTIONS(87),
  },
  [6418] = {
    [sym__statements] = STATE(8891),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12008),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6419] = {
    [sym__statements] = STATE(8891),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(8892),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(8892),
    [sym__line_break2] = ACTIONS(12010),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12008),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6420] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8893),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_assignment] = STATE(8893),
    [sym_operator_assignment] = STATE(8893),
    [sym_conditional] = STATE(8893),
    [sym_range] = STATE(8893),
    [sym_binary] = STATE(8893),
    [sym_unary] = STATE(8893),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6421] = {
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_rescue] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_EQ_GT] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [6422] = {
    [sym_heredoc_body] = STATE(8895),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12012),
    [sym_comment] = ACTIONS(87),
  },
  [6423] = {
    [anon_sym_RPAREN] = ACTIONS(12012),
    [sym_comment] = ACTIONS(87),
  },
  [6424] = {
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym__heredoc_body_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_rescue] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_in] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_EQ_GT] = ACTIONS(9751),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_RBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_COLON2] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [6425] = {
    [sym__heredoc_body_start2] = ACTIONS(9758),
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9758),
    [anon_sym_unless] = ACTIONS(9758),
    [anon_sym_while] = ACTIONS(9758),
    [anon_sym_until] = ACTIONS(9758),
    [anon_sym_rescue] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9758),
    [anon_sym_do] = ACTIONS(9758),
    [anon_sym_EQ_GT] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_RBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [6426] = {
    [anon_sym_RBRACK] = ACTIONS(12014),
    [sym_comment] = ACTIONS(87),
  },
  [6427] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_RBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6428] = {
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_in] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_EQ_GT] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_RBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_COLON2] = ACTIONS(9488),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [6429] = {
    [anon_sym_RBRACE] = ACTIONS(12016),
    [sym_comment] = ACTIONS(87),
  },
  [6430] = {
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_in] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_EQ_GT] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_RBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_COLON2] = ACTIONS(9508),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [6431] = {
    [anon_sym_end] = ACTIONS(12018),
    [sym_comment] = ACTIONS(87),
  },
  [6432] = {
    [sym__statements] = STATE(8899),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6433] = {
    [sym__statements] = STATE(8899),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(8900),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(8900),
    [sym__line_break2] = ACTIONS(12022),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12020),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6434] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6435] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [6436] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6437] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [6438] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6439] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6440] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_RBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6441] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12024),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6442] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6443] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6444] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6445] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6446] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6447] = {
    [sym_heredoc_body] = STATE(6447),
    [aux_sym_call_repeat1] = STATE(6447),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_RBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [6448] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1438),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(1438),
    [sym_operator_assignment] = STATE(1438),
    [sym_conditional] = STATE(1438),
    [sym_range] = STATE(1438),
    [sym_binary] = STATE(1438),
    [sym_unary] = STATE(1438),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1446),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2447),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__identifier_hash_key2] = ACTIONS(2453),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9455),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2475),
    [sym_identifier] = ACTIONS(2475),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6449] = {
    [sym_heredoc_body] = STATE(6447),
    [aux_sym_call_repeat1] = STATE(6447),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_RBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [6450] = {
    [aux_sym_argument_list_repeat1] = STATE(6450),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12026),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [6451] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6452] = {
    [aux_sym_exceptions_repeat1] = STATE(8903),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [6453] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [6454] = {
    [sym_string] = STATE(6454),
    [aux_sym_chained_string_repeat1] = STATE(6454),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [6455] = {
    [sym__simple_symbol2] = ACTIONS(3158),
    [sym__string_start2] = ACTIONS(3158),
    [sym__symbol_start2] = ACTIONS(3158),
    [sym__subshell_start2] = ACTIONS(3158),
    [sym__regex_start2] = ACTIONS(3158),
    [sym__string_array_start2] = ACTIONS(3158),
    [sym__symbol_array_start2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym_heredoc_beginning2] = ACTIONS(3158),
    [sym__block_ampersand2] = ACTIONS(3158),
    [sym__splat_star2] = ACTIONS(3158),
    [sym__unary_minus2] = ACTIONS(3158),
    [sym__identifier_hash_key2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_def] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_COLON_COLON] = ACTIONS(3158),
    [anon_sym_STAR] = ACTIONS(4982),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_module] = ACTIONS(4982),
    [anon_sym_return] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_break] = ACTIONS(4982),
    [anon_sym_next] = ACTIONS(4982),
    [sym_redo] = ACTIONS(4982),
    [sym_retry] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(4982),
    [anon_sym_unless] = ACTIONS(4982),
    [anon_sym_while] = ACTIONS(4982),
    [anon_sym_until] = ACTIONS(4982),
    [anon_sym_for] = ACTIONS(4982),
    [anon_sym_case] = ACTIONS(4982),
    [anon_sym_begin] = ACTIONS(4982),
    [anon_sym_RBRACK] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_defined_QMARK] = ACTIONS(3158),
    [anon_sym_not] = ACTIONS(4982),
    [anon_sym_BANG] = ACTIONS(3158),
    [anon_sym_TILDE] = ACTIONS(3158),
    [sym_constant] = ACTIONS(4982),
    [sym_identifier] = ACTIONS(4982),
    [sym_instance_variable] = ACTIONS(3158),
    [sym_class_variable] = ACTIONS(3158),
    [sym_global_variable] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4982),
    [sym_float] = ACTIONS(4982),
    [sym_complex] = ACTIONS(3158),
    [sym_super] = ACTIONS(4982),
    [anon_sym_true] = ACTIONS(4982),
    [anon_sym_TRUE] = ACTIONS(4982),
    [anon_sym_false] = ACTIONS(4982),
    [anon_sym_FALSE] = ACTIONS(4982),
    [sym_self] = ACTIONS(4982),
    [anon_sym_nil] = ACTIONS(4982),
    [anon_sym_NIL] = ACTIONS(4982),
    [sym_character] = ACTIONS(3158),
    [anon_sym_LBRACK2] = ACTIONS(3158),
    [anon_sym_DASH_GT] = ACTIONS(3158),
  },
  [6456] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(12029),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [6457] = {
    [sym__heredoc_body_start2] = ACTIONS(12031),
    [anon_sym_RPAREN] = ACTIONS(12031),
    [anon_sym_RBRACK] = ACTIONS(12031),
    [sym_comment] = ACTIONS(87),
  },
  [6458] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [6459] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3649),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(365),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(365),
    [sym_splat_argument] = STATE(8905),
    [sym_assignment] = STATE(3649),
    [sym_operator_assignment] = STATE(3649),
    [sym_conditional] = STATE(3649),
    [sym_range] = STATE(3649),
    [sym_binary] = STATE(3649),
    [sym_unary] = STATE(3649),
    [sym__arg_or_splat_arg] = STATE(8905),
    [sym_left_assignment_list] = STATE(364),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(365),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(365),
    [sym_false] = STATE(365),
    [sym_nil] = STATE(365),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(5748),
    [sym__unary_minus2] = ACTIONS(597),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(641),
    [anon_sym_defined_QMARK] = ACTIONS(643),
    [anon_sym_not] = ACTIONS(645),
    [anon_sym_BANG] = ACTIONS(647),
    [anon_sym_TILDE] = ACTIONS(647),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6460] = {
    [aux_sym_exceptions_repeat1] = STATE(8906),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12033),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [6461] = {
    [sym__simple_symbol2] = ACTIONS(12035),
    [sym__string_start2] = ACTIONS(12035),
    [sym__symbol_start2] = ACTIONS(12035),
    [sym__subshell_start2] = ACTIONS(12035),
    [sym__regex_start2] = ACTIONS(12035),
    [sym__string_array_start2] = ACTIONS(12035),
    [sym__symbol_array_start2] = ACTIONS(12035),
    [sym_heredoc_beginning2] = ACTIONS(12035),
    [sym__unary_minus2] = ACTIONS(12035),
    [anon_sym_BEGIN] = ACTIONS(12037),
    [anon_sym_LBRACE] = ACTIONS(12035),
    [anon_sym_RBRACE] = ACTIONS(12035),
    [anon_sym_END] = ACTIONS(12037),
    [anon_sym_def] = ACTIONS(12037),
    [anon_sym_LPAREN] = ACTIONS(12035),
    [anon_sym_COLON_COLON] = ACTIONS(12035),
    [anon_sym_SEMI] = ACTIONS(12035),
    [anon_sym_STAR] = ACTIONS(12035),
    [anon_sym_class] = ACTIONS(12037),
    [anon_sym_module] = ACTIONS(12037),
    [anon_sym_return] = ACTIONS(12037),
    [anon_sym_yield] = ACTIONS(12037),
    [anon_sym_break] = ACTIONS(12037),
    [anon_sym_next] = ACTIONS(12037),
    [sym_redo] = ACTIONS(12037),
    [sym_retry] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(12037),
    [anon_sym_unless] = ACTIONS(12037),
    [anon_sym_while] = ACTIONS(12037),
    [anon_sym_until] = ACTIONS(12037),
    [anon_sym_for] = ACTIONS(12037),
    [anon_sym_case] = ACTIONS(12037),
    [anon_sym_begin] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12037),
    [anon_sym_defined_QMARK] = ACTIONS(12035),
    [anon_sym_not] = ACTIONS(12037),
    [anon_sym_BANG] = ACTIONS(12035),
    [anon_sym_TILDE] = ACTIONS(12035),
    [sym_constant] = ACTIONS(12037),
    [sym_identifier] = ACTIONS(12037),
    [sym_instance_variable] = ACTIONS(12035),
    [sym_class_variable] = ACTIONS(12035),
    [sym_global_variable] = ACTIONS(12035),
    [anon_sym_undef] = ACTIONS(12037),
    [anon_sym_alias] = ACTIONS(12037),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12037),
    [sym_float] = ACTIONS(12037),
    [sym_complex] = ACTIONS(12035),
    [sym_super] = ACTIONS(12037),
    [anon_sym_true] = ACTIONS(12037),
    [anon_sym_TRUE] = ACTIONS(12037),
    [anon_sym_false] = ACTIONS(12037),
    [anon_sym_FALSE] = ACTIONS(12037),
    [sym_self] = ACTIONS(12037),
    [anon_sym_nil] = ACTIONS(12037),
    [anon_sym_NIL] = ACTIONS(12037),
    [sym_character] = ACTIONS(12035),
    [anon_sym_LBRACK2] = ACTIONS(12035),
    [anon_sym_DASH_GT] = ACTIONS(12035),
  },
  [6462] = {
    [sym_identifier] = ACTIONS(12039),
    [sym_comment] = ACTIONS(87),
  },
  [6463] = {
    [aux_sym_block_parameters_repeat1] = STATE(8910),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(12043),
    [sym_comment] = ACTIONS(87),
  },
  [6464] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8919),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(8919),
    [sym_operator_assignment] = STATE(8919),
    [sym_conditional] = STATE(8919),
    [sym_range] = STATE(8919),
    [sym_binary] = STATE(8919),
    [sym_unary] = STATE(8919),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_COMMA] = ACTIONS(5798),
    [anon_sym_PIPE] = ACTIONS(5798),
    [anon_sym_SEMI] = ACTIONS(5798),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6465] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8924),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(8924),
    [sym_operator_assignment] = STATE(8924),
    [sym_conditional] = STATE(8924),
    [sym_range] = STATE(8924),
    [sym_binary] = STATE(8924),
    [sym_unary] = STATE(8924),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6466] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(12043),
    [anon_sym_SEMI] = ACTIONS(12067),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [6467] = {
    [aux_sym_method_parameters_repeat1] = STATE(8927),
    [anon_sym_COMMA] = ACTIONS(12069),
    [anon_sym_PIPE] = ACTIONS(12043),
    [anon_sym_SEMI] = ACTIONS(12067),
    [sym_comment] = ACTIONS(87),
  },
  [6468] = {
    [sym__line_break2] = ACTIONS(12071),
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [ts_builtin_sym_end] = ACTIONS(12071),
    [anon_sym___END__] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_end] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_when] = ACTIONS(12071),
    [anon_sym_elsif] = ACTIONS(12071),
    [anon_sym_else] = ACTIONS(12071),
    [anon_sym_then] = ACTIONS(12071),
    [anon_sym_ensure] = ACTIONS(12071),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [6469] = {
    [anon_sym_RPAREN] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12075),
    [anon_sym_PIPE] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [6470] = {
    [aux_sym_method_parameters_repeat1] = STATE(6475),
    [anon_sym_RPAREN] = ACTIONS(12077),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [6471] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(9520),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(12079),
    [anon_sym_or] = ACTIONS(12079),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [6472] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(9558),
    [anon_sym_COMMA] = ACTIONS(9558),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(12079),
    [anon_sym_or] = ACTIONS(12079),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [6473] = {
    [anon_sym_RPAREN] = ACTIONS(12081),
    [anon_sym_COMMA] = ACTIONS(12081),
    [anon_sym_PIPE] = ACTIONS(12081),
    [anon_sym_SEMI] = ACTIONS(12081),
    [sym_comment] = ACTIONS(87),
  },
  [6474] = {
    [anon_sym_LBRACE] = ACTIONS(12083),
    [anon_sym_do] = ACTIONS(12083),
    [sym_comment] = ACTIONS(87),
  },
  [6475] = {
    [aux_sym_method_parameters_repeat1] = STATE(6475),
    [anon_sym_RPAREN] = ACTIONS(12081),
    [anon_sym_COMMA] = ACTIONS(12085),
    [sym_comment] = ACTIONS(87),
  },
  [6476] = {
    [sym__line_break2] = ACTIONS(12035),
    [sym__simple_symbol2] = ACTIONS(12035),
    [sym__string_start2] = ACTIONS(12035),
    [sym__symbol_start2] = ACTIONS(12035),
    [sym__subshell_start2] = ACTIONS(12035),
    [sym__regex_start2] = ACTIONS(12035),
    [sym__string_array_start2] = ACTIONS(12035),
    [sym__symbol_array_start2] = ACTIONS(12035),
    [sym__heredoc_body_start2] = ACTIONS(12035),
    [sym_heredoc_beginning2] = ACTIONS(12035),
    [sym__unary_minus2] = ACTIONS(12035),
    [anon_sym_BEGIN] = ACTIONS(12037),
    [anon_sym_LBRACE] = ACTIONS(12035),
    [anon_sym_END] = ACTIONS(12037),
    [anon_sym_def] = ACTIONS(12037),
    [anon_sym_LPAREN] = ACTIONS(12035),
    [anon_sym_COLON_COLON] = ACTIONS(12035),
    [anon_sym_SEMI] = ACTIONS(12035),
    [anon_sym_STAR] = ACTIONS(12035),
    [anon_sym_class] = ACTIONS(12037),
    [anon_sym_module] = ACTIONS(12037),
    [anon_sym_end] = ACTIONS(12037),
    [anon_sym_return] = ACTIONS(12037),
    [anon_sym_yield] = ACTIONS(12037),
    [anon_sym_break] = ACTIONS(12037),
    [anon_sym_next] = ACTIONS(12037),
    [sym_redo] = ACTIONS(12037),
    [sym_retry] = ACTIONS(12037),
    [anon_sym_if] = ACTIONS(12037),
    [anon_sym_unless] = ACTIONS(12037),
    [anon_sym_while] = ACTIONS(12037),
    [anon_sym_until] = ACTIONS(12037),
    [anon_sym_for] = ACTIONS(12037),
    [anon_sym_case] = ACTIONS(12037),
    [anon_sym_begin] = ACTIONS(12037),
    [anon_sym_PLUS] = ACTIONS(12037),
    [anon_sym_defined_QMARK] = ACTIONS(12035),
    [anon_sym_not] = ACTIONS(12037),
    [anon_sym_BANG] = ACTIONS(12035),
    [anon_sym_TILDE] = ACTIONS(12035),
    [sym_constant] = ACTIONS(12037),
    [sym_identifier] = ACTIONS(12037),
    [sym_instance_variable] = ACTIONS(12035),
    [sym_class_variable] = ACTIONS(12035),
    [sym_global_variable] = ACTIONS(12035),
    [anon_sym_undef] = ACTIONS(12037),
    [anon_sym_alias] = ACTIONS(12037),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12037),
    [sym_float] = ACTIONS(12037),
    [sym_complex] = ACTIONS(12035),
    [sym_super] = ACTIONS(12037),
    [anon_sym_true] = ACTIONS(12037),
    [anon_sym_TRUE] = ACTIONS(12037),
    [anon_sym_false] = ACTIONS(12037),
    [anon_sym_FALSE] = ACTIONS(12037),
    [sym_self] = ACTIONS(12037),
    [anon_sym_nil] = ACTIONS(12037),
    [anon_sym_NIL] = ACTIONS(12037),
    [sym_character] = ACTIONS(12035),
    [anon_sym_LBRACK2] = ACTIONS(12035),
    [anon_sym_DASH_GT] = ACTIONS(12035),
  },
  [6477] = {
    [sym_identifier] = ACTIONS(12088),
    [sym_comment] = ACTIONS(87),
  },
  [6478] = {
    [aux_sym_block_parameters_repeat1] = STATE(8931),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(12090),
    [sym_comment] = ACTIONS(87),
  },
  [6479] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(12090),
    [anon_sym_SEMI] = ACTIONS(12092),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [6480] = {
    [aux_sym_method_parameters_repeat1] = STATE(8927),
    [anon_sym_COMMA] = ACTIONS(12094),
    [anon_sym_PIPE] = ACTIONS(12090),
    [anon_sym_SEMI] = ACTIONS(12092),
    [sym_comment] = ACTIONS(87),
  },
  [6481] = {
    [sym__line_break2] = ACTIONS(12096),
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [ts_builtin_sym_end] = ACTIONS(12096),
    [anon_sym___END__] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12096),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_end] = ACTIONS(12096),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_when] = ACTIONS(12096),
    [anon_sym_elsif] = ACTIONS(12096),
    [anon_sym_else] = ACTIONS(12096),
    [anon_sym_then] = ACTIONS(12096),
    [anon_sym_ensure] = ACTIONS(12096),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12096),
    [anon_sym_AMP_AMP] = ACTIONS(12096),
    [anon_sym_LT_LT] = ACTIONS(12096),
    [anon_sym_GT_GT] = ACTIONS(12096),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12096),
    [anon_sym_PLUS] = ACTIONS(12096),
    [anon_sym_SLASH] = ACTIONS(12096),
    [anon_sym_PERCENT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [6482] = {
    [anon_sym_end] = ACTIONS(12100),
    [sym_comment] = ACTIONS(87),
  },
  [6483] = {
    [sym__statements] = STATE(8935),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12102),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6484] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6485] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6486] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [6487] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8936),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8936),
    [sym_operator_assignment] = STATE(8936),
    [sym_conditional] = STATE(8936),
    [sym_range] = STATE(8936),
    [sym_binary] = STATE(8936),
    [sym_unary] = STATE(8936),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6488] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8937),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8937),
    [sym_operator_assignment] = STATE(8937),
    [sym_conditional] = STATE(8937),
    [sym_range] = STATE(8937),
    [sym_binary] = STATE(8937),
    [sym_unary] = STATE(8937),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6489] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8938),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8938),
    [sym_operator_assignment] = STATE(8938),
    [sym_conditional] = STATE(8938),
    [sym_range] = STATE(8938),
    [sym_binary] = STATE(8938),
    [sym_unary] = STATE(8938),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6490] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8939),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8939),
    [sym_operator_assignment] = STATE(8939),
    [sym_conditional] = STATE(8939),
    [sym_range] = STATE(8939),
    [sym_binary] = STATE(8939),
    [sym_unary] = STATE(8939),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6491] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8940),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8940),
    [sym_operator_assignment] = STATE(8940),
    [sym_conditional] = STATE(8940),
    [sym_range] = STATE(8940),
    [sym_binary] = STATE(8940),
    [sym_unary] = STATE(8940),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6492] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8941),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8941),
    [sym_operator_assignment] = STATE(8941),
    [sym_conditional] = STATE(8941),
    [sym_range] = STATE(8941),
    [sym_binary] = STATE(8941),
    [sym_unary] = STATE(8941),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6493] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8942),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8942),
    [sym_operator_assignment] = STATE(8942),
    [sym_conditional] = STATE(8942),
    [sym_range] = STATE(8942),
    [sym_binary] = STATE(8942),
    [sym_unary] = STATE(8942),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6494] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8943),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8943),
    [sym_operator_assignment] = STATE(8943),
    [sym_conditional] = STATE(8943),
    [sym_range] = STATE(8943),
    [sym_binary] = STATE(8943),
    [sym_unary] = STATE(8943),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6495] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8944),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8944),
    [sym_operator_assignment] = STATE(8944),
    [sym_conditional] = STATE(8944),
    [sym_range] = STATE(8944),
    [sym_binary] = STATE(8944),
    [sym_unary] = STATE(8944),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6496] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8945),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8945),
    [sym_operator_assignment] = STATE(8945),
    [sym_conditional] = STATE(8945),
    [sym_range] = STATE(8945),
    [sym_binary] = STATE(8945),
    [sym_unary] = STATE(8945),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6497] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8946),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8946),
    [sym_operator_assignment] = STATE(8946),
    [sym_conditional] = STATE(8946),
    [sym_range] = STATE(8946),
    [sym_binary] = STATE(8946),
    [sym_unary] = STATE(8946),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6498] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8947),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8947),
    [sym_operator_assignment] = STATE(8947),
    [sym_conditional] = STATE(8947),
    [sym_range] = STATE(8947),
    [sym_binary] = STATE(8947),
    [sym_unary] = STATE(8947),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6499] = {
    [sym__statements] = STATE(4099),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_block_parameters] = STATE(4100),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_hash_splat_argument] = STATE(120),
    [sym_assignment] = STATE(1585),
    [sym_operator_assignment] = STATE(1585),
    [sym_conditional] = STATE(1585),
    [sym_range] = STATE(1585),
    [sym_binary] = STATE(1585),
    [sym_unary] = STATE(1585),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1589),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(2034),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym__hash_items] = STATE(2035),
    [sym_pair] = STATE(126),
    [sym_lambda] = STATE(220),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [sym__identifier_hash_key2] = ACTIONS(157),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12104),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_PIPE] = ACTIONS(2497),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(171),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2703),
    [sym_identifier] = ACTIONS(2703),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6500] = {
    [sym_do_block] = STATE(4125),
    [sym_block] = STATE(4125),
    [sym__binary_minus2] = ACTIONS(2773),
    [sym__binary_star2] = ACTIONS(2773),
    [anon_sym_LBRACE] = ACTIONS(6481),
    [anon_sym_DOT] = ACTIONS(2777),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2777),
    [anon_sym_STAR_STAR] = ACTIONS(2777),
    [anon_sym_AMP] = ACTIONS(2777),
    [anon_sym_EQ] = ACTIONS(2777),
    [anon_sym_LT] = ACTIONS(2777),
    [anon_sym_do] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_COLON_COLON2] = ACTIONS(2773),
    [anon_sym_AMP_DOT] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_QMARK] = ACTIONS(2773),
    [anon_sym_DOT_DOT] = ACTIONS(2777),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PIPE_PIPE] = ACTIONS(2777),
    [anon_sym_AMP_AMP] = ACTIONS(2777),
    [anon_sym_LT_LT] = ACTIONS(2777),
    [anon_sym_GT_GT] = ACTIONS(2777),
    [anon_sym_EQ_EQ] = ACTIONS(2777),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2773),
    [anon_sym_LT_EQ_GT] = ACTIONS(2773),
    [anon_sym_EQ_TILDE] = ACTIONS(2773),
    [anon_sym_BANG_TILDE] = ACTIONS(2773),
    [anon_sym_LT_EQ] = ACTIONS(2777),
    [anon_sym_GT] = ACTIONS(2777),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2777),
    [anon_sym_PLUS] = ACTIONS(2777),
    [anon_sym_SLASH] = ACTIONS(2777),
    [anon_sym_PERCENT] = ACTIONS(2777),
    [sym_comment] = ACTIONS(87),
  },
  [6501] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8950),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_splat_argument] = STATE(8951),
    [sym_assignment] = STATE(8950),
    [sym_operator_assignment] = STATE(8950),
    [sym_conditional] = STATE(8950),
    [sym_range] = STATE(8950),
    [sym_binary] = STATE(8950),
    [sym_unary] = STATE(8950),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(8951),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(12106),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6502] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8952),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(8952),
    [sym_operator_assignment] = STATE(8952),
    [sym_conditional] = STATE(8952),
    [sym_range] = STATE(8952),
    [sym_binary] = STATE(8952),
    [sym_unary] = STATE(8952),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6503] = {
    [sym_string] = STATE(8953),
    [aux_sym_chained_string_repeat1] = STATE(8953),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6504] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [6505] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8954),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(8954),
    [sym_operator_assignment] = STATE(8954),
    [sym_conditional] = STATE(8954),
    [sym_range] = STATE(8954),
    [sym_binary] = STATE(8954),
    [sym_unary] = STATE(8954),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6506] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6507] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6508] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6509] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6510] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8957),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(8957),
    [sym_operator_assignment] = STATE(8957),
    [sym_conditional] = STATE(8957),
    [sym_range] = STATE(8957),
    [sym_binary] = STATE(8957),
    [sym_unary] = STATE(8957),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6511] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8958),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(8958),
    [sym_operator_assignment] = STATE(8958),
    [sym_conditional] = STATE(8958),
    [sym_range] = STATE(8958),
    [sym_binary] = STATE(8958),
    [sym_unary] = STATE(8958),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6512] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6513] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [6514] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6515] = {
    [anon_sym_EQ] = ACTIONS(12138),
    [sym_comment] = ACTIONS(87),
  },
  [6516] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12140),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12142),
    [anon_sym_DASH_EQ] = ACTIONS(12142),
    [anon_sym_STAR_EQ] = ACTIONS(12142),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12142),
    [anon_sym_SLASH_EQ] = ACTIONS(12142),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12142),
    [anon_sym_PIPE_EQ] = ACTIONS(12142),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12142),
    [anon_sym_AMP_EQ] = ACTIONS(12142),
    [anon_sym_PERCENT_EQ] = ACTIONS(12142),
    [anon_sym_GT_GT_EQ] = ACTIONS(12142),
    [anon_sym_LT_LT_EQ] = ACTIONS(12142),
    [anon_sym_CARET_EQ] = ACTIONS(12142),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6517] = {
    [sym_string] = STATE(8973),
    [aux_sym_chained_string_repeat1] = STATE(8973),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6518] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [6519] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(8975),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(12144),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6520] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6521] = {
    [sym_string] = STATE(6562),
    [aux_sym_chained_string_repeat1] = STATE(6562),
    [sym__string_start2] = ACTIONS(9591),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6522] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8976),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(8976),
    [sym_operator_assignment] = STATE(8976),
    [sym_conditional] = STATE(8976),
    [sym_range] = STATE(8976),
    [sym_binary] = STATE(8976),
    [sym_unary] = STATE(8976),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6523] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(4208),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [6524] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8977),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8977),
    [sym_operator_assignment] = STATE(8977),
    [sym_conditional] = STATE(8977),
    [sym_range] = STATE(8977),
    [sym_binary] = STATE(8977),
    [sym_unary] = STATE(8977),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6525] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8978),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8978),
    [sym_operator_assignment] = STATE(8978),
    [sym_conditional] = STATE(8978),
    [sym_range] = STATE(8978),
    [sym_binary] = STATE(8978),
    [sym_unary] = STATE(8978),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6526] = {
    [anon_sym_COLON] = ACTIONS(12146),
    [sym_comment] = ACTIONS(87),
  },
  [6527] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8980),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8980),
    [sym_operator_assignment] = STATE(8980),
    [sym_conditional] = STATE(8980),
    [sym_range] = STATE(8980),
    [sym_binary] = STATE(8980),
    [sym_unary] = STATE(8980),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6528] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(12148),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6529] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(1647),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [6530] = {
    [sym_heredoc_body] = STATE(8982),
    [aux_sym_call_repeat1] = STATE(8982),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6531] = {
    [sym_heredoc_body] = STATE(8982),
    [aux_sym_call_repeat1] = STATE(8982),
    [aux_sym_argument_list_repeat1] = STATE(8984),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6532] = {
    [sym_string] = STATE(6562),
    [aux_sym_chained_string_repeat1] = STATE(6562),
    [sym__string_start2] = ACTIONS(9591),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12152),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6533] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6534] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [6535] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8985),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8985),
    [sym_operator_assignment] = STATE(8985),
    [sym_conditional] = STATE(8985),
    [sym_range] = STATE(8985),
    [sym_binary] = STATE(8985),
    [sym_unary] = STATE(8985),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6536] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8986),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8986),
    [sym_operator_assignment] = STATE(8986),
    [sym_conditional] = STATE(8986),
    [sym_range] = STATE(8986),
    [sym_binary] = STATE(8986),
    [sym_unary] = STATE(8986),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6537] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8987),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8987),
    [sym_operator_assignment] = STATE(8987),
    [sym_conditional] = STATE(8987),
    [sym_range] = STATE(8987),
    [sym_binary] = STATE(8987),
    [sym_unary] = STATE(8987),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6538] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8988),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8988),
    [sym_operator_assignment] = STATE(8988),
    [sym_conditional] = STATE(8988),
    [sym_range] = STATE(8988),
    [sym_binary] = STATE(8988),
    [sym_unary] = STATE(8988),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6539] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8989),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8989),
    [sym_operator_assignment] = STATE(8989),
    [sym_conditional] = STATE(8989),
    [sym_range] = STATE(8989),
    [sym_binary] = STATE(8989),
    [sym_unary] = STATE(8989),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6540] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8990),
    [sym_operator_assignment] = STATE(8990),
    [sym_conditional] = STATE(8990),
    [sym_range] = STATE(8990),
    [sym_binary] = STATE(8990),
    [sym_unary] = STATE(8990),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6541] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8991),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(8991),
    [sym_operator_assignment] = STATE(8991),
    [sym_conditional] = STATE(8991),
    [sym_range] = STATE(8991),
    [sym_binary] = STATE(8991),
    [sym_unary] = STATE(8991),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6542] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8992),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(8992),
    [sym_operator_assignment] = STATE(8992),
    [sym_conditional] = STATE(8992),
    [sym_range] = STATE(8992),
    [sym_binary] = STATE(8992),
    [sym_unary] = STATE(8992),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6543] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8993),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8993),
    [sym_operator_assignment] = STATE(8993),
    [sym_conditional] = STATE(8993),
    [sym_range] = STATE(8993),
    [sym_binary] = STATE(8993),
    [sym_unary] = STATE(8993),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6544] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8994),
    [sym_operator_assignment] = STATE(8994),
    [sym_conditional] = STATE(8994),
    [sym_range] = STATE(8994),
    [sym_binary] = STATE(8994),
    [sym_unary] = STATE(8994),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6545] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8995),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8995),
    [sym_operator_assignment] = STATE(8995),
    [sym_conditional] = STATE(8995),
    [sym_range] = STATE(8995),
    [sym_binary] = STATE(8995),
    [sym_unary] = STATE(8995),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6546] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8996),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8996),
    [sym_operator_assignment] = STATE(8996),
    [sym_conditional] = STATE(8996),
    [sym_range] = STATE(8996),
    [sym_binary] = STATE(8996),
    [sym_unary] = STATE(8996),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6547] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(8997),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(8997),
    [sym_operator_assignment] = STATE(8997),
    [sym_conditional] = STATE(8997),
    [sym_range] = STATE(8997),
    [sym_binary] = STATE(8997),
    [sym_unary] = STATE(8997),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6548] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8998),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(8998),
    [sym_operator_assignment] = STATE(8998),
    [sym_conditional] = STATE(8998),
    [sym_range] = STATE(8998),
    [sym_binary] = STATE(8998),
    [sym_unary] = STATE(8998),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6549] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8999),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(8999),
    [sym_operator_assignment] = STATE(8999),
    [sym_conditional] = STATE(8999),
    [sym_range] = STATE(8999),
    [sym_binary] = STATE(8999),
    [sym_unary] = STATE(8999),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6550] = {
    [anon_sym_COLON] = ACTIONS(12154),
    [sym_comment] = ACTIONS(87),
  },
  [6551] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9001),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9001),
    [sym_operator_assignment] = STATE(9001),
    [sym_conditional] = STATE(9001),
    [sym_range] = STATE(9001),
    [sym_binary] = STATE(9001),
    [sym_unary] = STATE(9001),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6552] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(12156),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_COLON2] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6553] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(1647),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [6554] = {
    [sym_heredoc_body] = STATE(9003),
    [aux_sym_call_repeat1] = STATE(9003),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6555] = {
    [sym_heredoc_body] = STATE(9003),
    [aux_sym_call_repeat1] = STATE(9003),
    [aux_sym_argument_list_repeat1] = STATE(9005),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [6556] = {
    [sym_string] = STATE(6615),
    [aux_sym_chained_string_repeat1] = STATE(6615),
    [sym__string_start2] = ACTIONS(9679),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12160),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6557] = {
    [sym_heredoc_body] = STATE(9006),
    [aux_sym_call_repeat1] = STATE(9006),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6558] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9007),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6559] = {
    [sym_heredoc_body] = STATE(9008),
    [aux_sym_call_repeat1] = STATE(9008),
    [aux_sym_argument_list_repeat1] = STATE(9009),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9647),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6560] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9010),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_splat_argument] = STATE(9011),
    [sym_assignment] = STATE(9010),
    [sym_operator_assignment] = STATE(9010),
    [sym_conditional] = STATE(9010),
    [sym_range] = STATE(9010),
    [sym_binary] = STATE(9010),
    [sym_unary] = STATE(9010),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(9011),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6561] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9012),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(9012),
    [sym_operator_assignment] = STATE(9012),
    [sym_conditional] = STATE(9012),
    [sym_range] = STATE(9012),
    [sym_binary] = STATE(9012),
    [sym_unary] = STATE(9012),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6562] = {
    [sym_string] = STATE(9013),
    [aux_sym_chained_string_repeat1] = STATE(9013),
    [sym__string_start2] = ACTIONS(9591),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6563] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6564] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6565] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6566] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6567] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6568] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6569] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12164),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6570] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(705),
    [sym__binary_star2] = ACTIONS(707),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(709),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(711),
    [anon_sym_AMP] = ACTIONS(713),
    [anon_sym_LT] = ACTIONS(715),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(717),
    [anon_sym_DOT_DOT] = ACTIONS(719),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(721),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_EQ_EQ] = ACTIONS(729),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ_GT] = ACTIONS(725),
    [anon_sym_EQ_TILDE] = ACTIONS(725),
    [anon_sym_BANG_TILDE] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(715),
    [anon_sym_GT] = ACTIONS(715),
    [anon_sym_GT_EQ] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_SLASH] = ACTIONS(711),
    [anon_sym_PERCENT] = ACTIONS(711),
    [sym_comment] = ACTIONS(87),
  },
  [6571] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6572] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6573] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6574] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6575] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6576] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9015),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(9015),
    [sym_operator_assignment] = STATE(9015),
    [sym_conditional] = STATE(9015),
    [sym_range] = STATE(9015),
    [sym_binary] = STATE(9015),
    [sym_unary] = STATE(9015),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6577] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6578] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6579] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6580] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6581] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9016),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(9016),
    [sym_operator_assignment] = STATE(9016),
    [sym_conditional] = STATE(9016),
    [sym_range] = STATE(9016),
    [sym_binary] = STATE(9016),
    [sym_unary] = STATE(9016),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6582] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9017),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(9017),
    [sym_operator_assignment] = STATE(9017),
    [sym_conditional] = STATE(9017),
    [sym_range] = STATE(9017),
    [sym_binary] = STATE(9017),
    [sym_unary] = STATE(9017),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6583] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6584] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [6585] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(3746),
    [sym__argument] = STATE(3747),
    [sym_splat_argument] = STATE(3747),
    [sym_hash_splat_argument] = STATE(3747),
    [sym_block_argument] = STATE(3747),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(3747),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_COLON2] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5950),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6586] = {
    [anon_sym_EQ] = ACTIONS(12196),
    [sym_comment] = ACTIONS(87),
  },
  [6587] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12198),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12200),
    [anon_sym_DASH_EQ] = ACTIONS(12200),
    [anon_sym_STAR_EQ] = ACTIONS(12200),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12200),
    [anon_sym_SLASH_EQ] = ACTIONS(12200),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12200),
    [anon_sym_PIPE_EQ] = ACTIONS(12200),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12200),
    [anon_sym_AMP_EQ] = ACTIONS(12200),
    [anon_sym_PERCENT_EQ] = ACTIONS(12200),
    [anon_sym_GT_GT_EQ] = ACTIONS(12200),
    [anon_sym_LT_LT_EQ] = ACTIONS(12200),
    [anon_sym_CARET_EQ] = ACTIONS(12200),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6588] = {
    [sym_string] = STATE(9032),
    [aux_sym_chained_string_repeat1] = STATE(9032),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6589] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [6590] = {
    [sym_interpolation] = STATE(60),
    [sym__literal_contents] = STATE(9034),
    [aux_sym__literal_contents_repeat1] = STATE(60),
    [sym__string_content2] = ACTIONS(105),
    [sym__string_end2] = ACTIONS(12202),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(111),
    [sym_escape_sequence] = ACTIONS(105),
  },
  [6591] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [6592] = {
    [sym_string] = STATE(6615),
    [aux_sym_chained_string_repeat1] = STATE(6615),
    [sym__string_start2] = ACTIONS(9679),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6593] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9035),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(9035),
    [sym_operator_assignment] = STATE(9035),
    [sym_conditional] = STATE(9035),
    [sym_range] = STATE(9035),
    [sym_binary] = STATE(9035),
    [sym_unary] = STATE(9035),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6594] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(4208),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [6595] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6596] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [6597] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9036),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9036),
    [sym_operator_assignment] = STATE(9036),
    [sym_conditional] = STATE(9036),
    [sym_range] = STATE(9036),
    [sym_binary] = STATE(9036),
    [sym_unary] = STATE(9036),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6598] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9037),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9037),
    [sym_operator_assignment] = STATE(9037),
    [sym_conditional] = STATE(9037),
    [sym_range] = STATE(9037),
    [sym_binary] = STATE(9037),
    [sym_unary] = STATE(9037),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6599] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9038),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9038),
    [sym_operator_assignment] = STATE(9038),
    [sym_conditional] = STATE(9038),
    [sym_range] = STATE(9038),
    [sym_binary] = STATE(9038),
    [sym_unary] = STATE(9038),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6600] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9039),
    [sym_operator_assignment] = STATE(9039),
    [sym_conditional] = STATE(9039),
    [sym_range] = STATE(9039),
    [sym_binary] = STATE(9039),
    [sym_unary] = STATE(9039),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6601] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9040),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9040),
    [sym_operator_assignment] = STATE(9040),
    [sym_conditional] = STATE(9040),
    [sym_range] = STATE(9040),
    [sym_binary] = STATE(9040),
    [sym_unary] = STATE(9040),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6602] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9041),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9041),
    [sym_operator_assignment] = STATE(9041),
    [sym_conditional] = STATE(9041),
    [sym_range] = STATE(9041),
    [sym_binary] = STATE(9041),
    [sym_unary] = STATE(9041),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6603] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9042),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(9042),
    [sym_operator_assignment] = STATE(9042),
    [sym_conditional] = STATE(9042),
    [sym_range] = STATE(9042),
    [sym_binary] = STATE(9042),
    [sym_unary] = STATE(9042),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6604] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9043),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9043),
    [sym_operator_assignment] = STATE(9043),
    [sym_conditional] = STATE(9043),
    [sym_range] = STATE(9043),
    [sym_binary] = STATE(9043),
    [sym_unary] = STATE(9043),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6605] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9044),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9044),
    [sym_operator_assignment] = STATE(9044),
    [sym_conditional] = STATE(9044),
    [sym_range] = STATE(9044),
    [sym_binary] = STATE(9044),
    [sym_unary] = STATE(9044),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6606] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9045),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9045),
    [sym_operator_assignment] = STATE(9045),
    [sym_conditional] = STATE(9045),
    [sym_range] = STATE(9045),
    [sym_binary] = STATE(9045),
    [sym_unary] = STATE(9045),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6607] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9046),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9046),
    [sym_operator_assignment] = STATE(9046),
    [sym_conditional] = STATE(9046),
    [sym_range] = STATE(9046),
    [sym_binary] = STATE(9046),
    [sym_unary] = STATE(9046),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6608] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9047),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9047),
    [sym_operator_assignment] = STATE(9047),
    [sym_conditional] = STATE(9047),
    [sym_range] = STATE(9047),
    [sym_binary] = STATE(9047),
    [sym_unary] = STATE(9047),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6609] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9048),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9048),
    [sym_operator_assignment] = STATE(9048),
    [sym_conditional] = STATE(9048),
    [sym_range] = STATE(9048),
    [sym_binary] = STATE(9048),
    [sym_unary] = STATE(9048),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6610] = {
    [sym_heredoc_body] = STATE(9049),
    [aux_sym_call_repeat1] = STATE(9049),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6611] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(9050),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12204),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6612] = {
    [sym_heredoc_body] = STATE(9051),
    [aux_sym_call_repeat1] = STATE(9051),
    [aux_sym_argument_list_repeat1] = STATE(9052),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9717),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6613] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9053),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_splat_argument] = STATE(9054),
    [sym_assignment] = STATE(9053),
    [sym_operator_assignment] = STATE(9053),
    [sym_conditional] = STATE(9053),
    [sym_range] = STATE(9053),
    [sym_binary] = STATE(9053),
    [sym_unary] = STATE(9053),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(9054),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6614] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9055),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(9055),
    [sym_operator_assignment] = STATE(9055),
    [sym_conditional] = STATE(9055),
    [sym_range] = STATE(9055),
    [sym_binary] = STATE(9055),
    [sym_unary] = STATE(9055),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6615] = {
    [sym_string] = STATE(9056),
    [aux_sym_chained_string_repeat1] = STATE(9056),
    [sym__string_start2] = ACTIONS(9679),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [6616] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9057),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(9057),
    [sym_operator_assignment] = STATE(9057),
    [sym_conditional] = STATE(9057),
    [sym_range] = STATE(9057),
    [sym_binary] = STATE(9057),
    [sym_unary] = STATE(9057),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6617] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9058),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(9058),
    [sym_operator_assignment] = STATE(9058),
    [sym_conditional] = STATE(9058),
    [sym_range] = STATE(9058),
    [sym_binary] = STATE(9058),
    [sym_unary] = STATE(9058),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6618] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_COLON2] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6619] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_COLON2] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6620] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_COLON2] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6621] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(8955),
    [sym__argument] = STATE(8956),
    [sym_splat_argument] = STATE(8956),
    [sym_hash_splat_argument] = STATE(8956),
    [sym_block_argument] = STATE(8956),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(8956),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_COLON2] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5886),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6622] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9059),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(9059),
    [sym_operator_assignment] = STATE(9059),
    [sym_conditional] = STATE(9059),
    [sym_range] = STATE(9059),
    [sym_binary] = STATE(9059),
    [sym_unary] = STATE(9059),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6623] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9060),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(9060),
    [sym_operator_assignment] = STATE(9060),
    [sym_conditional] = STATE(9060),
    [sym_range] = STATE(9060),
    [sym_binary] = STATE(9060),
    [sym_unary] = STATE(9060),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6624] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6625] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(5104),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [6626] = {
    [aux_sym_exceptions_repeat1] = STATE(9074),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6627] = {
    [anon_sym_EQ] = ACTIONS(12238),
    [sym_comment] = ACTIONS(87),
  },
  [6628] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12240),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12242),
    [anon_sym_DASH_EQ] = ACTIONS(12242),
    [anon_sym_STAR_EQ] = ACTIONS(12242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12242),
    [anon_sym_SLASH_EQ] = ACTIONS(12242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12242),
    [anon_sym_PIPE_EQ] = ACTIONS(12242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12242),
    [anon_sym_AMP_EQ] = ACTIONS(12242),
    [anon_sym_PERCENT_EQ] = ACTIONS(12242),
    [anon_sym_GT_GT_EQ] = ACTIONS(12242),
    [anon_sym_LT_LT_EQ] = ACTIONS(12242),
    [anon_sym_CARET_EQ] = ACTIONS(12242),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6629] = {
    [sym_string] = STATE(9077),
    [aux_sym_chained_string_repeat1] = STATE(9077),
    [sym__string_start2] = ACTIONS(2549),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_COLON2] = ACTIONS(561),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [6630] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(6250),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6631] = {
    [sym_string] = STATE(6631),
    [aux_sym_chained_string_repeat1] = STATE(6631),
    [sym__string_start2] = ACTIONS(12244),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6632] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(8705),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(6739),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_LPAREN2] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(6739),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_SLASH] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [anon_sym_BANG] = ACTIONS(8705),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(6739),
    [sym_identifier] = ACTIONS(6739),
    [anon_sym_DASH] = ACTIONS(8705),
    [anon_sym_PLUS_AT] = ACTIONS(6739),
    [anon_sym_DASH_AT] = ACTIONS(6739),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(8705),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(6739),
    [anon_sym_BQUOTE] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [6633] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [ts_builtin_sym_end] = ACTIONS(7850),
    [anon_sym___END__] = ACTIONS(7852),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_end] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_rescue] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_when] = ACTIONS(7852),
    [anon_sym_elsif] = ACTIONS(7852),
    [anon_sym_else] = ACTIONS(7852),
    [anon_sym_then] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_ensure] = ACTIONS(7852),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [6634] = {
    [anon_sym_RPAREN] = ACTIONS(12247),
    [sym_comment] = ACTIONS(87),
  },
  [6635] = {
    [sym__line_break2] = ACTIONS(12249),
    [sym__heredoc_body_start2] = ACTIONS(12249),
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [ts_builtin_sym_end] = ACTIONS(12249),
    [anon_sym___END__] = ACTIONS(12249),
    [anon_sym_LBRACE] = ACTIONS(12249),
    [anon_sym_RBRACE] = ACTIONS(12249),
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_end] = ACTIONS(12249),
    [anon_sym_if] = ACTIONS(12249),
    [anon_sym_unless] = ACTIONS(12249),
    [anon_sym_while] = ACTIONS(12249),
    [anon_sym_until] = ACTIONS(12249),
    [anon_sym_rescue] = ACTIONS(12249),
    [anon_sym_do] = ACTIONS(12249),
    [anon_sym_when] = ACTIONS(12249),
    [anon_sym_elsif] = ACTIONS(12249),
    [anon_sym_else] = ACTIONS(12249),
    [anon_sym_then] = ACTIONS(12249),
    [anon_sym_ensure] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [6636] = {
    [sym__line_break2] = ACTIONS(6517),
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [ts_builtin_sym_end] = ACTIONS(6517),
    [anon_sym___END__] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6519),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_end] = ACTIONS(6517),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_when] = ACTIONS(6517),
    [anon_sym_elsif] = ACTIONS(6517),
    [anon_sym_else] = ACTIONS(6517),
    [anon_sym_then] = ACTIONS(6517),
    [anon_sym_ensure] = ACTIONS(6517),
    [anon_sym_EQ_GT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_PLUS_EQ] = ACTIONS(6517),
    [anon_sym_DASH_EQ] = ACTIONS(6517),
    [anon_sym_STAR_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6517),
    [anon_sym_SLASH_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6517),
    [anon_sym_AMP_EQ] = ACTIONS(6517),
    [anon_sym_PERCENT_EQ] = ACTIONS(6517),
    [anon_sym_GT_GT_EQ] = ACTIONS(6517),
    [anon_sym_LT_LT_EQ] = ACTIONS(6517),
    [anon_sym_CARET_EQ] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6519),
    [anon_sym_AMP_AMP] = ACTIONS(6519),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6519),
    [anon_sym_PLUS] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6519),
    [anon_sym_PERCENT] = ACTIONS(6519),
    [sym_comment] = ACTIONS(87),
  },
  [6637] = {
    [sym__line_break2] = ACTIONS(6521),
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [ts_builtin_sym_end] = ACTIONS(6521),
    [anon_sym___END__] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_end] = ACTIONS(6521),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_when] = ACTIONS(6521),
    [anon_sym_elsif] = ACTIONS(6521),
    [anon_sym_else] = ACTIONS(6521),
    [anon_sym_then] = ACTIONS(6521),
    [anon_sym_ensure] = ACTIONS(6521),
    [anon_sym_EQ_GT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_PLUS_EQ] = ACTIONS(6521),
    [anon_sym_DASH_EQ] = ACTIONS(6521),
    [anon_sym_STAR_EQ] = ACTIONS(6521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6521),
    [anon_sym_SLASH_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6521),
    [anon_sym_AMP_EQ] = ACTIONS(6521),
    [anon_sym_PERCENT_EQ] = ACTIONS(6521),
    [anon_sym_GT_GT_EQ] = ACTIONS(6521),
    [anon_sym_LT_LT_EQ] = ACTIONS(6521),
    [anon_sym_CARET_EQ] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6523),
    [anon_sym_AMP_AMP] = ACTIONS(6523),
    [anon_sym_LT_LT] = ACTIONS(6523),
    [anon_sym_GT_GT] = ACTIONS(6523),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6523),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(6523),
    [sym_comment] = ACTIONS(87),
  },
  [6638] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12253),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6639] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(12253),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12255),
  },
  [6640] = {
    [sym__line_break2] = ACTIONS(6529),
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [ts_builtin_sym_end] = ACTIONS(6529),
    [anon_sym___END__] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6531),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_end] = ACTIONS(6529),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_when] = ACTIONS(6529),
    [anon_sym_elsif] = ACTIONS(6529),
    [anon_sym_else] = ACTIONS(6529),
    [anon_sym_then] = ACTIONS(6529),
    [anon_sym_ensure] = ACTIONS(6529),
    [anon_sym_EQ_GT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_PLUS_EQ] = ACTIONS(6529),
    [anon_sym_DASH_EQ] = ACTIONS(6529),
    [anon_sym_STAR_EQ] = ACTIONS(6529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6529),
    [anon_sym_SLASH_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6529),
    [anon_sym_AMP_EQ] = ACTIONS(6529),
    [anon_sym_PERCENT_EQ] = ACTIONS(6529),
    [anon_sym_GT_GT_EQ] = ACTIONS(6529),
    [anon_sym_LT_LT_EQ] = ACTIONS(6529),
    [anon_sym_CARET_EQ] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6531),
    [anon_sym_AMP_AMP] = ACTIONS(6531),
    [anon_sym_LT_LT] = ACTIONS(6531),
    [anon_sym_GT_GT] = ACTIONS(6531),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6531),
    [anon_sym_PLUS] = ACTIONS(6531),
    [anon_sym_SLASH] = ACTIONS(6531),
    [anon_sym_PERCENT] = ACTIONS(6531),
    [sym_comment] = ACTIONS(87),
  },
  [6641] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12257),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6642] = {
    [sym__line_break2] = ACTIONS(6542),
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [ts_builtin_sym_end] = ACTIONS(6542),
    [anon_sym___END__] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6544),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_end] = ACTIONS(6542),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_when] = ACTIONS(6542),
    [anon_sym_elsif] = ACTIONS(6542),
    [anon_sym_else] = ACTIONS(6542),
    [anon_sym_then] = ACTIONS(6542),
    [anon_sym_ensure] = ACTIONS(6542),
    [anon_sym_EQ_GT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_PLUS_EQ] = ACTIONS(6542),
    [anon_sym_DASH_EQ] = ACTIONS(6542),
    [anon_sym_STAR_EQ] = ACTIONS(6542),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6542),
    [anon_sym_SLASH_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6542),
    [anon_sym_AMP_EQ] = ACTIONS(6542),
    [anon_sym_PERCENT_EQ] = ACTIONS(6542),
    [anon_sym_GT_GT_EQ] = ACTIONS(6542),
    [anon_sym_LT_LT_EQ] = ACTIONS(6542),
    [anon_sym_CARET_EQ] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6544),
    [anon_sym_AMP_AMP] = ACTIONS(6544),
    [anon_sym_LT_LT] = ACTIONS(6544),
    [anon_sym_GT_GT] = ACTIONS(6544),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_PERCENT] = ACTIONS(6544),
    [sym_comment] = ACTIONS(87),
  },
  [6643] = {
    [sym__line_break2] = ACTIONS(6546),
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [ts_builtin_sym_end] = ACTIONS(6546),
    [anon_sym___END__] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_end] = ACTIONS(6546),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_when] = ACTIONS(6546),
    [anon_sym_elsif] = ACTIONS(6546),
    [anon_sym_else] = ACTIONS(6546),
    [anon_sym_then] = ACTIONS(6546),
    [anon_sym_ensure] = ACTIONS(6546),
    [anon_sym_EQ_GT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_PLUS_EQ] = ACTIONS(6546),
    [anon_sym_DASH_EQ] = ACTIONS(6546),
    [anon_sym_STAR_EQ] = ACTIONS(6546),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6546),
    [anon_sym_SLASH_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6546),
    [anon_sym_AMP_EQ] = ACTIONS(6546),
    [anon_sym_PERCENT_EQ] = ACTIONS(6546),
    [anon_sym_GT_GT_EQ] = ACTIONS(6546),
    [anon_sym_LT_LT_EQ] = ACTIONS(6546),
    [anon_sym_CARET_EQ] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6548),
    [anon_sym_AMP_AMP] = ACTIONS(6548),
    [anon_sym_LT_LT] = ACTIONS(6548),
    [anon_sym_GT_GT] = ACTIONS(6548),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6548),
    [sym_comment] = ACTIONS(87),
  },
  [6644] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12259),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6645] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(12259),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12261),
  },
  [6646] = {
    [sym__line_break2] = ACTIONS(6554),
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [ts_builtin_sym_end] = ACTIONS(6554),
    [anon_sym___END__] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6556),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_end] = ACTIONS(6554),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_when] = ACTIONS(6554),
    [anon_sym_elsif] = ACTIONS(6554),
    [anon_sym_else] = ACTIONS(6554),
    [anon_sym_then] = ACTIONS(6554),
    [anon_sym_ensure] = ACTIONS(6554),
    [anon_sym_EQ_GT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_PLUS_EQ] = ACTIONS(6554),
    [anon_sym_DASH_EQ] = ACTIONS(6554),
    [anon_sym_STAR_EQ] = ACTIONS(6554),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6554),
    [anon_sym_SLASH_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6554),
    [anon_sym_AMP_EQ] = ACTIONS(6554),
    [anon_sym_PERCENT_EQ] = ACTIONS(6554),
    [anon_sym_GT_GT_EQ] = ACTIONS(6554),
    [anon_sym_LT_LT_EQ] = ACTIONS(6554),
    [anon_sym_CARET_EQ] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6556),
    [anon_sym_AMP_AMP] = ACTIONS(6556),
    [anon_sym_LT_LT] = ACTIONS(6556),
    [anon_sym_GT_GT] = ACTIONS(6556),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_PERCENT] = ACTIONS(6556),
    [sym_comment] = ACTIONS(87),
  },
  [6647] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12263),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6648] = {
    [sym__line_break2] = ACTIONS(2947),
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [ts_builtin_sym_end] = ACTIONS(2947),
    [anon_sym___END__] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_end] = ACTIONS(2947),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_when] = ACTIONS(2947),
    [anon_sym_elsif] = ACTIONS(2947),
    [anon_sym_else] = ACTIONS(2947),
    [anon_sym_then] = ACTIONS(2947),
    [anon_sym_ensure] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(87),
  },
  [6649] = {
    [sym__line_break2] = ACTIONS(2959),
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [ts_builtin_sym_end] = ACTIONS(2959),
    [anon_sym___END__] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_end] = ACTIONS(2959),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_when] = ACTIONS(2959),
    [anon_sym_elsif] = ACTIONS(2959),
    [anon_sym_else] = ACTIONS(2959),
    [anon_sym_then] = ACTIONS(2959),
    [anon_sym_ensure] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [sym_comment] = ACTIONS(87),
  },
  [6650] = {
    [sym__line_break2] = ACTIONS(2963),
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [ts_builtin_sym_end] = ACTIONS(2963),
    [anon_sym___END__] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_end] = ACTIONS(2963),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_when] = ACTIONS(2963),
    [anon_sym_elsif] = ACTIONS(2963),
    [anon_sym_else] = ACTIONS(2963),
    [anon_sym_then] = ACTIONS(2963),
    [anon_sym_ensure] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [sym_comment] = ACTIONS(87),
  },
  [6651] = {
    [sym__line_break2] = ACTIONS(2967),
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [ts_builtin_sym_end] = ACTIONS(2967),
    [anon_sym___END__] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_end] = ACTIONS(2967),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_when] = ACTIONS(2967),
    [anon_sym_elsif] = ACTIONS(2967),
    [anon_sym_else] = ACTIONS(2967),
    [anon_sym_then] = ACTIONS(2967),
    [anon_sym_ensure] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [sym_comment] = ACTIONS(87),
  },
  [6652] = {
    [sym__line_break2] = ACTIONS(2973),
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [ts_builtin_sym_end] = ACTIONS(2973),
    [anon_sym___END__] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_end] = ACTIONS(2973),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_when] = ACTIONS(2973),
    [anon_sym_elsif] = ACTIONS(2973),
    [anon_sym_else] = ACTIONS(2973),
    [anon_sym_then] = ACTIONS(2973),
    [anon_sym_ensure] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [sym_comment] = ACTIONS(87),
  },
  [6653] = {
    [sym__string_end2] = ACTIONS(12265),
    [sym_comment] = ACTIONS(87),
  },
  [6654] = {
    [aux_sym_string_array_repeat1] = STATE(9088),
    [sym__string_end2] = ACTIONS(12267),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12269),
  },
  [6655] = {
    [sym__line_break2] = ACTIONS(2983),
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [ts_builtin_sym_end] = ACTIONS(2983),
    [anon_sym___END__] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_end] = ACTIONS(2983),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_when] = ACTIONS(2983),
    [anon_sym_elsif] = ACTIONS(2983),
    [anon_sym_else] = ACTIONS(2983),
    [anon_sym_then] = ACTIONS(2983),
    [anon_sym_ensure] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [sym_comment] = ACTIONS(87),
  },
  [6656] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12271),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6657] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(12271),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12273),
  },
  [6658] = {
    [sym__line_break2] = ACTIONS(3002),
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [ts_builtin_sym_end] = ACTIONS(3002),
    [anon_sym___END__] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_end] = ACTIONS(3002),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_when] = ACTIONS(3002),
    [anon_sym_elsif] = ACTIONS(3002),
    [anon_sym_else] = ACTIONS(3002),
    [anon_sym_then] = ACTIONS(3002),
    [anon_sym_ensure] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(87),
  },
  [6659] = {
    [sym__string_end2] = ACTIONS(12275),
    [sym_comment] = ACTIONS(87),
  },
  [6660] = {
    [aux_sym_symbol_array_repeat1] = STATE(9094),
    [sym__string_end2] = ACTIONS(12277),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12279),
  },
  [6661] = {
    [sym__line_break2] = ACTIONS(3012),
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [ts_builtin_sym_end] = ACTIONS(3012),
    [anon_sym___END__] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_end] = ACTIONS(3012),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_when] = ACTIONS(3012),
    [anon_sym_elsif] = ACTIONS(3012),
    [anon_sym_else] = ACTIONS(3012),
    [anon_sym_then] = ACTIONS(3012),
    [anon_sym_ensure] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [sym_comment] = ACTIONS(87),
  },
  [6662] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12281),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [6663] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(12281),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12283),
  },
  [6664] = {
    [sym__line_break2] = ACTIONS(3504),
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [ts_builtin_sym_end] = ACTIONS(3504),
    [anon_sym___END__] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_end] = ACTIONS(3504),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_when] = ACTIONS(3504),
    [anon_sym_elsif] = ACTIONS(3504),
    [anon_sym_else] = ACTIONS(3504),
    [anon_sym_then] = ACTIONS(3504),
    [anon_sym_ensure] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_GT_GT] = ACTIONS(3506),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [sym_comment] = ACTIONS(87),
  },
  [6665] = {
    [anon_sym_RBRACE] = ACTIONS(12285),
    [sym_comment] = ACTIONS(87),
  },
  [6666] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(12287),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [6667] = {
    [sym__method_rest] = STATE(9099),
    [sym_operator] = STATE(3800),
    [sym__method_name] = STATE(3800),
    [sym_setter] = STATE(3800),
    [sym_symbol] = STATE(3800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12289),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12289),
    [sym_class_variable] = ACTIONS(12289),
    [sym_global_variable] = ACTIONS(12289),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [6668] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(9100),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12291),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6669] = {
    [sym__line_break2] = ACTIONS(3744),
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [ts_builtin_sym_end] = ACTIONS(3744),
    [anon_sym___END__] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_end] = ACTIONS(3744),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_when] = ACTIONS(3744),
    [anon_sym_elsif] = ACTIONS(3744),
    [anon_sym_else] = ACTIONS(3744),
    [anon_sym_then] = ACTIONS(3744),
    [anon_sym_ensure] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_PLUS_EQ] = ACTIONS(3744),
    [anon_sym_DASH_EQ] = ACTIONS(3744),
    [anon_sym_STAR_EQ] = ACTIONS(3744),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3744),
    [anon_sym_SLASH_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3744),
    [anon_sym_AMP_EQ] = ACTIONS(3744),
    [anon_sym_PERCENT_EQ] = ACTIONS(3744),
    [anon_sym_GT_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_LT_EQ] = ACTIONS(3744),
    [anon_sym_CARET_EQ] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(87),
  },
  [6670] = {
    [sym_heredoc_body] = STATE(9101),
    [sym__terminator] = STATE(9101),
    [sym__line_break2] = ACTIONS(12293),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(12293),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [6671] = {
    [sym_heredoc_body] = STATE(9102),
    [sym__terminator] = STATE(9102),
    [sym__line_break2] = ACTIONS(12295),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12295),
    [sym_comment] = ACTIONS(87),
  },
  [6672] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(9103),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12297),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6673] = {
    [sym__line_break2] = ACTIONS(4158),
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [ts_builtin_sym_end] = ACTIONS(4158),
    [anon_sym___END__] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_end] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_when] = ACTIONS(4158),
    [anon_sym_elsif] = ACTIONS(4158),
    [anon_sym_else] = ACTIONS(4158),
    [anon_sym_then] = ACTIONS(4158),
    [anon_sym_ensure] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [sym_comment] = ACTIONS(87),
  },
  [6674] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(9104),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12299),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6675] = {
    [sym__statements] = STATE(9106),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(9107),
    [sym_else] = STATE(9107),
    [sym__if_tail] = STATE(9107),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9108),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9108),
    [sym__line_break2] = ACTIONS(12301),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12303),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6676] = {
    [sym__statements] = STATE(9110),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(9111),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12305),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6677] = {
    [sym__statements] = STATE(9113),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12307),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6678] = {
    [sym__statements] = STATE(9115),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12309),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6679] = {
    [sym__do] = STATE(9116),
    [sym_heredoc_body] = STATE(9116),
    [sym__terminator] = STATE(9116),
    [sym__line_break2] = ACTIONS(12311),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12311),
    [anon_sym_do] = ACTIONS(12311),
    [sym_comment] = ACTIONS(87),
  },
  [6680] = {
    [sym_when] = STATE(9117),
    [aux_sym_case_repeat1] = STATE(9118),
    [anon_sym_SEMI] = ACTIONS(12313),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [6681] = {
    [anon_sym_end] = ACTIONS(12315),
    [sym_comment] = ACTIONS(87),
  },
  [6682] = {
    [sym_when] = STATE(9117),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [6683] = {
    [sym__line_break2] = ACTIONS(5410),
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [ts_builtin_sym_end] = ACTIONS(5410),
    [anon_sym___END__] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5412),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_end] = ACTIONS(5410),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_when] = ACTIONS(5410),
    [anon_sym_elsif] = ACTIONS(5410),
    [anon_sym_else] = ACTIONS(5410),
    [anon_sym_then] = ACTIONS(5410),
    [anon_sym_ensure] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_PLUS_EQ] = ACTIONS(5410),
    [anon_sym_DASH_EQ] = ACTIONS(5410),
    [anon_sym_STAR_EQ] = ACTIONS(5410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5410),
    [anon_sym_SLASH_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5410),
    [anon_sym_AMP_EQ] = ACTIONS(5410),
    [anon_sym_PERCENT_EQ] = ACTIONS(5410),
    [anon_sym_GT_GT_EQ] = ACTIONS(5410),
    [anon_sym_LT_LT_EQ] = ACTIONS(5410),
    [anon_sym_CARET_EQ] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5412),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [sym_comment] = ACTIONS(87),
  },
  [6684] = {
    [sym_ensure] = STATE(9121),
    [anon_sym_end] = ACTIONS(12317),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6685] = {
    [anon_sym_end] = ACTIONS(12317),
    [sym_comment] = ACTIONS(87),
  },
  [6686] = {
    [sym_else] = STATE(9122),
    [sym_ensure] = STATE(9121),
    [anon_sym_end] = ACTIONS(12317),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6687] = {
    [sym__line_break2] = ACTIONS(5498),
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [ts_builtin_sym_end] = ACTIONS(5498),
    [anon_sym___END__] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_end] = ACTIONS(5498),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_when] = ACTIONS(5498),
    [anon_sym_elsif] = ACTIONS(5498),
    [anon_sym_else] = ACTIONS(5498),
    [anon_sym_then] = ACTIONS(5498),
    [anon_sym_ensure] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_PLUS_EQ] = ACTIONS(5498),
    [anon_sym_DASH_EQ] = ACTIONS(5498),
    [anon_sym_STAR_EQ] = ACTIONS(5498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5498),
    [anon_sym_SLASH_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5498),
    [anon_sym_AMP_EQ] = ACTIONS(5498),
    [anon_sym_PERCENT_EQ] = ACTIONS(5498),
    [anon_sym_GT_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_LT_EQ] = ACTIONS(5498),
    [anon_sym_CARET_EQ] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(87),
  },
  [6688] = {
    [sym__line_break2] = ACTIONS(5738),
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [ts_builtin_sym_end] = ACTIONS(5738),
    [anon_sym___END__] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_end] = ACTIONS(5738),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_when] = ACTIONS(5738),
    [anon_sym_elsif] = ACTIONS(5738),
    [anon_sym_else] = ACTIONS(5738),
    [anon_sym_then] = ACTIONS(5738),
    [anon_sym_ensure] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_AMP_AMP] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [sym_comment] = ACTIONS(87),
  },
  [6689] = {
    [anon_sym_RBRACK] = ACTIONS(12319),
    [sym_comment] = ACTIONS(87),
  },
  [6690] = {
    [sym__line_break2] = ACTIONS(5822),
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [ts_builtin_sym_end] = ACTIONS(5822),
    [anon_sym___END__] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_end] = ACTIONS(5822),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_when] = ACTIONS(5822),
    [anon_sym_elsif] = ACTIONS(5822),
    [anon_sym_else] = ACTIONS(5822),
    [anon_sym_then] = ACTIONS(5822),
    [anon_sym_ensure] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [sym_comment] = ACTIONS(87),
  },
  [6691] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6692] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [6693] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6694] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [6695] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6696] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6697] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12321),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6698] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6699] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6700] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6701] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6702] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6703] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [ts_builtin_sym_end] = ACTIONS(5750),
    [anon_sym___END__] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_end] = ACTIONS(5750),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_when] = ACTIONS(5750),
    [anon_sym_elsif] = ACTIONS(5750),
    [anon_sym_else] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_ensure] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [6704] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(5104),
    [anon_sym___END__] = ACTIONS(5104),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6705] = {
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [6706] = {
    [aux_sym_exceptions_repeat1] = STATE(9126),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [6707] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [6708] = {
    [sym_string] = STATE(6708),
    [aux_sym_chained_string_repeat1] = STATE(6708),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [ts_builtin_sym_end] = ACTIONS(6252),
    [anon_sym___END__] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [6709] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [6710] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [6711] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9127),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(9127),
    [sym_operator_assignment] = STATE(9127),
    [sym_conditional] = STATE(9127),
    [sym_range] = STATE(9127),
    [sym_binary] = STATE(9127),
    [sym_unary] = STATE(9127),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6712] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [6713] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9128),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(9128),
    [sym_operator_assignment] = STATE(9128),
    [sym_conditional] = STATE(9128),
    [sym_range] = STATE(9128),
    [sym_binary] = STATE(9128),
    [sym_unary] = STATE(9128),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6714] = {
    [sym_heredoc_body] = STATE(9129),
    [aux_sym_call_repeat1] = STATE(9129),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6715] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(9130),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12326),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6716] = {
    [sym_heredoc_body] = STATE(9131),
    [aux_sym_call_repeat1] = STATE(9131),
    [aux_sym_argument_list_repeat1] = STATE(9132),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9846),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6717] = {
    [sym__line_break2] = ACTIONS(12071),
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [ts_builtin_sym_end] = ACTIONS(12071),
    [anon_sym___END__] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_end] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_when] = ACTIONS(12071),
    [anon_sym_elsif] = ACTIONS(12071),
    [anon_sym_else] = ACTIONS(12071),
    [anon_sym_then] = ACTIONS(12071),
    [anon_sym_ensure] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [6718] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6719] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6720] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6721] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6722] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6723] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6724] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12328),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6725] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6726] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6727] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6728] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6729] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6730] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [6731] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [6732] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9134),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(9134),
    [sym_operator_assignment] = STATE(9134),
    [sym_conditional] = STATE(9134),
    [sym_range] = STATE(9134),
    [sym_binary] = STATE(9134),
    [sym_unary] = STATE(9134),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6733] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [6734] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9135),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(9135),
    [sym_operator_assignment] = STATE(9135),
    [sym_conditional] = STATE(9135),
    [sym_range] = STATE(9135),
    [sym_binary] = STATE(9135),
    [sym_unary] = STATE(9135),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6735] = {
    [sym_heredoc_body] = STATE(9136),
    [aux_sym_call_repeat1] = STATE(9136),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6736] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(9137),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12330),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6737] = {
    [sym_heredoc_body] = STATE(9138),
    [aux_sym_call_repeat1] = STATE(9138),
    [aux_sym_argument_list_repeat1] = STATE(9139),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9856),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6738] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9140),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(9140),
    [sym_operator_assignment] = STATE(9140),
    [sym_conditional] = STATE(9140),
    [sym_range] = STATE(9140),
    [sym_binary] = STATE(9140),
    [sym_unary] = STATE(9140),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6739] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9141),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(9141),
    [sym_operator_assignment] = STATE(9141),
    [sym_conditional] = STATE(9141),
    [sym_range] = STATE(9141),
    [sym_binary] = STATE(9141),
    [sym_unary] = STATE(9141),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6740] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9142),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(9142),
    [sym_operator_assignment] = STATE(9142),
    [sym_conditional] = STATE(9142),
    [sym_range] = STATE(9142),
    [sym_binary] = STATE(9142),
    [sym_unary] = STATE(9142),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6741] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9143),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(9143),
    [sym_operator_assignment] = STATE(9143),
    [sym_conditional] = STATE(9143),
    [sym_range] = STATE(9143),
    [sym_binary] = STATE(9143),
    [sym_unary] = STATE(9143),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6742] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6743] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [6744] = {
    [aux_sym_exceptions_repeat1] = STATE(9157),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(12362),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6745] = {
    [anon_sym_EQ] = ACTIONS(12364),
    [sym_comment] = ACTIONS(87),
  },
  [6746] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_RBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12366),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12368),
    [anon_sym_DASH_EQ] = ACTIONS(12368),
    [anon_sym_STAR_EQ] = ACTIONS(12368),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12368),
    [anon_sym_SLASH_EQ] = ACTIONS(12368),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12368),
    [anon_sym_PIPE_EQ] = ACTIONS(12368),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12368),
    [anon_sym_AMP_EQ] = ACTIONS(12368),
    [anon_sym_PERCENT_EQ] = ACTIONS(12368),
    [anon_sym_GT_GT_EQ] = ACTIONS(12368),
    [anon_sym_LT_LT_EQ] = ACTIONS(12368),
    [anon_sym_CARET_EQ] = ACTIONS(12368),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [6747] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [6748] = {
    [sym_string] = STATE(6748),
    [aux_sym_chained_string_repeat1] = STATE(6748),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6749] = {
    [sym__line_break2] = ACTIONS(7098),
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [ts_builtin_sym_end] = ACTIONS(7098),
    [anon_sym___END__] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7100),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_end] = ACTIONS(7098),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_when] = ACTIONS(7098),
    [anon_sym_elsif] = ACTIONS(7098),
    [anon_sym_else] = ACTIONS(7098),
    [anon_sym_then] = ACTIONS(7098),
    [anon_sym_ensure] = ACTIONS(7098),
    [anon_sym_EQ_GT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [anon_sym_DASH_EQ] = ACTIONS(7098),
    [anon_sym_STAR_EQ] = ACTIONS(7098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7098),
    [anon_sym_SLASH_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7098),
    [anon_sym_AMP_EQ] = ACTIONS(7098),
    [anon_sym_PERCENT_EQ] = ACTIONS(7098),
    [anon_sym_GT_GT_EQ] = ACTIONS(7098),
    [anon_sym_LT_LT_EQ] = ACTIONS(7098),
    [anon_sym_CARET_EQ] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7100),
    [anon_sym_AMP_AMP] = ACTIONS(7100),
    [anon_sym_LT_LT] = ACTIONS(7100),
    [anon_sym_GT_GT] = ACTIONS(7100),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7100),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7100),
    [anon_sym_PERCENT] = ACTIONS(7100),
    [sym_comment] = ACTIONS(87),
  },
  [6750] = {
    [anon_sym_DOT] = ACTIONS(12370),
    [anon_sym_COLON_COLON] = ACTIONS(12370),
    [sym_comment] = ACTIONS(87),
  },
  [6751] = {
    [sym__line_break2] = ACTIONS(7258),
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [ts_builtin_sym_end] = ACTIONS(7258),
    [anon_sym___END__] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7260),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_end] = ACTIONS(7258),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_when] = ACTIONS(7258),
    [anon_sym_elsif] = ACTIONS(7258),
    [anon_sym_else] = ACTIONS(7258),
    [anon_sym_then] = ACTIONS(7258),
    [anon_sym_ensure] = ACTIONS(7258),
    [anon_sym_EQ_GT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_PLUS_EQ] = ACTIONS(7258),
    [anon_sym_DASH_EQ] = ACTIONS(7258),
    [anon_sym_STAR_EQ] = ACTIONS(7258),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7258),
    [anon_sym_SLASH_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7258),
    [anon_sym_AMP_EQ] = ACTIONS(7258),
    [anon_sym_PERCENT_EQ] = ACTIONS(7258),
    [anon_sym_GT_GT_EQ] = ACTIONS(7258),
    [anon_sym_LT_LT_EQ] = ACTIONS(7258),
    [anon_sym_CARET_EQ] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_LT] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7260),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7260),
    [anon_sym_SLASH] = ACTIONS(7260),
    [anon_sym_PERCENT] = ACTIONS(7260),
    [sym_comment] = ACTIONS(87),
  },
  [6752] = {
    [sym__line_break2] = ACTIONS(7274),
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [ts_builtin_sym_end] = ACTIONS(7274),
    [anon_sym___END__] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7276),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_end] = ACTIONS(7274),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_when] = ACTIONS(7274),
    [anon_sym_elsif] = ACTIONS(7274),
    [anon_sym_else] = ACTIONS(7274),
    [anon_sym_then] = ACTIONS(7274),
    [anon_sym_ensure] = ACTIONS(7274),
    [anon_sym_EQ_GT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_PLUS_EQ] = ACTIONS(7274),
    [anon_sym_DASH_EQ] = ACTIONS(7274),
    [anon_sym_STAR_EQ] = ACTIONS(7274),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7274),
    [anon_sym_SLASH_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7274),
    [anon_sym_AMP_EQ] = ACTIONS(7274),
    [anon_sym_PERCENT_EQ] = ACTIONS(7274),
    [anon_sym_GT_GT_EQ] = ACTIONS(7274),
    [anon_sym_LT_LT_EQ] = ACTIONS(7274),
    [anon_sym_CARET_EQ] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7276),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7276),
    [anon_sym_PLUS] = ACTIONS(7276),
    [anon_sym_SLASH] = ACTIONS(7276),
    [anon_sym_PERCENT] = ACTIONS(7276),
    [sym_comment] = ACTIONS(87),
  },
  [6753] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(9161),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12372),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6754] = {
    [sym__statements] = STATE(1619),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(1620),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(1621),
    [sym_rescue] = STATE(1622),
    [sym__body_statement] = STATE(9162),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12374),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6755] = {
    [sym__line_break2] = ACTIONS(7730),
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [ts_builtin_sym_end] = ACTIONS(7730),
    [anon_sym___END__] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7732),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_end] = ACTIONS(7730),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_when] = ACTIONS(7730),
    [anon_sym_elsif] = ACTIONS(7730),
    [anon_sym_else] = ACTIONS(7730),
    [anon_sym_then] = ACTIONS(7730),
    [anon_sym_ensure] = ACTIONS(7730),
    [anon_sym_EQ_GT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_PLUS_EQ] = ACTIONS(7730),
    [anon_sym_DASH_EQ] = ACTIONS(7730),
    [anon_sym_STAR_EQ] = ACTIONS(7730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7730),
    [anon_sym_SLASH_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7730),
    [anon_sym_AMP_EQ] = ACTIONS(7730),
    [anon_sym_PERCENT_EQ] = ACTIONS(7730),
    [anon_sym_GT_GT_EQ] = ACTIONS(7730),
    [anon_sym_LT_LT_EQ] = ACTIONS(7730),
    [anon_sym_CARET_EQ] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7732),
    [anon_sym_AMP_AMP] = ACTIONS(7732),
    [anon_sym_LT_LT] = ACTIONS(7732),
    [anon_sym_GT_GT] = ACTIONS(7732),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7732),
    [anon_sym_PLUS] = ACTIONS(7732),
    [anon_sym_SLASH] = ACTIONS(7732),
    [anon_sym_PERCENT] = ACTIONS(7732),
    [sym_comment] = ACTIONS(87),
  },
  [6756] = {
    [sym__line_break2] = ACTIONS(7788),
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [ts_builtin_sym_end] = ACTIONS(7788),
    [anon_sym___END__] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_when] = ACTIONS(7788),
    [anon_sym_elsif] = ACTIONS(7788),
    [anon_sym_else] = ACTIONS(7788),
    [anon_sym_then] = ACTIONS(7788),
    [anon_sym_ensure] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_PLUS_EQ] = ACTIONS(7788),
    [anon_sym_DASH_EQ] = ACTIONS(7788),
    [anon_sym_STAR_EQ] = ACTIONS(7788),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7788),
    [anon_sym_SLASH_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7788),
    [anon_sym_AMP_EQ] = ACTIONS(7788),
    [anon_sym_PERCENT_EQ] = ACTIONS(7788),
    [anon_sym_GT_GT_EQ] = ACTIONS(7788),
    [anon_sym_LT_LT_EQ] = ACTIONS(7788),
    [anon_sym_CARET_EQ] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [sym_comment] = ACTIONS(87),
  },
  [6757] = {
    [sym__line_break2] = ACTIONS(7970),
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [ts_builtin_sym_end] = ACTIONS(7970),
    [anon_sym___END__] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7972),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_end] = ACTIONS(7970),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_when] = ACTIONS(7970),
    [anon_sym_elsif] = ACTIONS(7970),
    [anon_sym_else] = ACTIONS(7970),
    [anon_sym_then] = ACTIONS(7970),
    [anon_sym_ensure] = ACTIONS(7970),
    [anon_sym_EQ_GT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_PLUS_EQ] = ACTIONS(7970),
    [anon_sym_DASH_EQ] = ACTIONS(7970),
    [anon_sym_STAR_EQ] = ACTIONS(7970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7970),
    [anon_sym_SLASH_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7970),
    [anon_sym_AMP_EQ] = ACTIONS(7970),
    [anon_sym_PERCENT_EQ] = ACTIONS(7970),
    [anon_sym_GT_GT_EQ] = ACTIONS(7970),
    [anon_sym_LT_LT_EQ] = ACTIONS(7970),
    [anon_sym_CARET_EQ] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7972),
    [anon_sym_AMP_AMP] = ACTIONS(7972),
    [anon_sym_LT_LT] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(7972),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7972),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7972),
    [anon_sym_PERCENT] = ACTIONS(7972),
    [sym_comment] = ACTIONS(87),
  },
  [6758] = {
    [sym_elsif] = STATE(9164),
    [sym_else] = STATE(9164),
    [sym__if_tail] = STATE(9164),
    [anon_sym_end] = ACTIONS(12376),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [6759] = {
    [anon_sym_end] = ACTIONS(12376),
    [sym_comment] = ACTIONS(87),
  },
  [6760] = {
    [sym__statements] = STATE(9165),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(9164),
    [sym_else] = STATE(9164),
    [sym__if_tail] = STATE(9164),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12378),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6761] = {
    [sym__line_break2] = ACTIONS(8176),
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [ts_builtin_sym_end] = ACTIONS(8176),
    [anon_sym___END__] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8178),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_end] = ACTIONS(8176),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_when] = ACTIONS(8176),
    [anon_sym_elsif] = ACTIONS(8176),
    [anon_sym_else] = ACTIONS(8176),
    [anon_sym_then] = ACTIONS(8176),
    [anon_sym_ensure] = ACTIONS(8176),
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_PLUS_EQ] = ACTIONS(8176),
    [anon_sym_DASH_EQ] = ACTIONS(8176),
    [anon_sym_STAR_EQ] = ACTIONS(8176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8176),
    [anon_sym_SLASH_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8176),
    [anon_sym_AMP_EQ] = ACTIONS(8176),
    [anon_sym_PERCENT_EQ] = ACTIONS(8176),
    [anon_sym_GT_GT_EQ] = ACTIONS(8176),
    [anon_sym_LT_LT_EQ] = ACTIONS(8176),
    [anon_sym_CARET_EQ] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8178),
    [anon_sym_AMP_AMP] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(8178),
    [anon_sym_GT_GT] = ACTIONS(8178),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8178),
    [anon_sym_PLUS] = ACTIONS(8178),
    [anon_sym_SLASH] = ACTIONS(8178),
    [anon_sym_PERCENT] = ACTIONS(8178),
    [sym_comment] = ACTIONS(87),
  },
  [6762] = {
    [sym_else] = STATE(9167),
    [anon_sym_end] = ACTIONS(12380),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [6763] = {
    [anon_sym_end] = ACTIONS(12380),
    [sym_comment] = ACTIONS(87),
  },
  [6764] = {
    [sym__line_break2] = ACTIONS(8352),
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [ts_builtin_sym_end] = ACTIONS(8352),
    [anon_sym___END__] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8354),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_end] = ACTIONS(8352),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_when] = ACTIONS(8352),
    [anon_sym_elsif] = ACTIONS(8352),
    [anon_sym_else] = ACTIONS(8352),
    [anon_sym_then] = ACTIONS(8352),
    [anon_sym_ensure] = ACTIONS(8352),
    [anon_sym_EQ_GT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_PLUS_EQ] = ACTIONS(8352),
    [anon_sym_DASH_EQ] = ACTIONS(8352),
    [anon_sym_STAR_EQ] = ACTIONS(8352),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8352),
    [anon_sym_SLASH_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8352),
    [anon_sym_AMP_EQ] = ACTIONS(8352),
    [anon_sym_PERCENT_EQ] = ACTIONS(8352),
    [anon_sym_GT_GT_EQ] = ACTIONS(8352),
    [anon_sym_LT_LT_EQ] = ACTIONS(8352),
    [anon_sym_CARET_EQ] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8354),
    [anon_sym_AMP_AMP] = ACTIONS(8354),
    [anon_sym_LT_LT] = ACTIONS(8354),
    [anon_sym_GT_GT] = ACTIONS(8354),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8354),
    [anon_sym_SLASH] = ACTIONS(8354),
    [anon_sym_PERCENT] = ACTIONS(8354),
    [sym_comment] = ACTIONS(87),
  },
  [6765] = {
    [anon_sym_end] = ACTIONS(12382),
    [sym_comment] = ACTIONS(87),
  },
  [6766] = {
    [sym__line_break2] = ACTIONS(8432),
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [ts_builtin_sym_end] = ACTIONS(8432),
    [anon_sym___END__] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8434),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_end] = ACTIONS(8432),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_when] = ACTIONS(8432),
    [anon_sym_elsif] = ACTIONS(8432),
    [anon_sym_else] = ACTIONS(8432),
    [anon_sym_then] = ACTIONS(8432),
    [anon_sym_ensure] = ACTIONS(8432),
    [anon_sym_EQ_GT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_PLUS_EQ] = ACTIONS(8432),
    [anon_sym_DASH_EQ] = ACTIONS(8432),
    [anon_sym_STAR_EQ] = ACTIONS(8432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8432),
    [anon_sym_SLASH_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8432),
    [anon_sym_AMP_EQ] = ACTIONS(8432),
    [anon_sym_PERCENT_EQ] = ACTIONS(8432),
    [anon_sym_GT_GT_EQ] = ACTIONS(8432),
    [anon_sym_LT_LT_EQ] = ACTIONS(8432),
    [anon_sym_CARET_EQ] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8434),
    [anon_sym_AMP_AMP] = ACTIONS(8434),
    [anon_sym_LT_LT] = ACTIONS(8434),
    [anon_sym_GT_GT] = ACTIONS(8434),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8434),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8434),
    [anon_sym_PERCENT] = ACTIONS(8434),
    [sym_comment] = ACTIONS(87),
  },
  [6767] = {
    [anon_sym_end] = ACTIONS(12384),
    [sym_comment] = ACTIONS(87),
  },
  [6768] = {
    [sym__statements] = STATE(9171),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12386),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6769] = {
    [sym__line_break2] = ACTIONS(12096),
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [ts_builtin_sym_end] = ACTIONS(12096),
    [anon_sym___END__] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_end] = ACTIONS(12096),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_when] = ACTIONS(12096),
    [anon_sym_elsif] = ACTIONS(12096),
    [anon_sym_else] = ACTIONS(12096),
    [anon_sym_then] = ACTIONS(12096),
    [anon_sym_ensure] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [6770] = {
    [anon_sym_end] = ACTIONS(12388),
    [sym_comment] = ACTIONS(87),
  },
  [6771] = {
    [sym__statements] = STATE(9173),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12390),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6772] = {
    [anon_sym_end] = ACTIONS(12392),
    [sym_comment] = ACTIONS(87),
  },
  [6773] = {
    [sym_when] = STATE(9175),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [6774] = {
    [sym__line_break2] = ACTIONS(8696),
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [ts_builtin_sym_end] = ACTIONS(8696),
    [anon_sym___END__] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8698),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_end] = ACTIONS(8696),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_when] = ACTIONS(8696),
    [anon_sym_elsif] = ACTIONS(8696),
    [anon_sym_else] = ACTIONS(8696),
    [anon_sym_then] = ACTIONS(8696),
    [anon_sym_ensure] = ACTIONS(8696),
    [anon_sym_EQ_GT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_PLUS_EQ] = ACTIONS(8696),
    [anon_sym_DASH_EQ] = ACTIONS(8696),
    [anon_sym_STAR_EQ] = ACTIONS(8696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8696),
    [anon_sym_SLASH_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8696),
    [anon_sym_AMP_EQ] = ACTIONS(8696),
    [anon_sym_PERCENT_EQ] = ACTIONS(8696),
    [anon_sym_GT_GT_EQ] = ACTIONS(8696),
    [anon_sym_LT_LT_EQ] = ACTIONS(8696),
    [anon_sym_CARET_EQ] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8698),
    [anon_sym_AMP_AMP] = ACTIONS(8698),
    [anon_sym_LT_LT] = ACTIONS(8698),
    [anon_sym_GT_GT] = ACTIONS(8698),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8698),
    [anon_sym_PLUS] = ACTIONS(8698),
    [anon_sym_SLASH] = ACTIONS(8698),
    [anon_sym_PERCENT] = ACTIONS(8698),
    [sym_comment] = ACTIONS(87),
  },
  [6775] = {
    [sym__line_break2] = ACTIONS(9229),
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [ts_builtin_sym_end] = ACTIONS(9229),
    [anon_sym___END__] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_end] = ACTIONS(9229),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_when] = ACTIONS(9229),
    [anon_sym_elsif] = ACTIONS(9229),
    [anon_sym_else] = ACTIONS(9229),
    [anon_sym_then] = ACTIONS(9229),
    [anon_sym_ensure] = ACTIONS(9229),
    [anon_sym_EQ_GT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_PLUS_EQ] = ACTIONS(9229),
    [anon_sym_DASH_EQ] = ACTIONS(9229),
    [anon_sym_STAR_EQ] = ACTIONS(9229),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9229),
    [anon_sym_SLASH_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9229),
    [anon_sym_AMP_EQ] = ACTIONS(9229),
    [anon_sym_PERCENT_EQ] = ACTIONS(9229),
    [anon_sym_GT_GT_EQ] = ACTIONS(9229),
    [anon_sym_LT_LT_EQ] = ACTIONS(9229),
    [anon_sym_CARET_EQ] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9231),
    [anon_sym_AMP_AMP] = ACTIONS(9231),
    [anon_sym_LT_LT] = ACTIONS(9231),
    [anon_sym_GT_GT] = ACTIONS(9231),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9231),
    [anon_sym_PLUS] = ACTIONS(9231),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [6776] = {
    [anon_sym_end] = ACTIONS(12394),
    [sym_comment] = ACTIONS(87),
  },
  [6777] = {
    [sym_ensure] = STATE(9177),
    [anon_sym_end] = ACTIONS(12394),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6778] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [ts_builtin_sym_end] = ACTIONS(10934),
    [anon_sym___END__] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_end] = ACTIONS(10934),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_when] = ACTIONS(10934),
    [anon_sym_elsif] = ACTIONS(10934),
    [anon_sym_else] = ACTIONS(10934),
    [anon_sym_then] = ACTIONS(10934),
    [anon_sym_ensure] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [sym_comment] = ACTIONS(87),
  },
  [6779] = {
    [sym__line_break2] = ACTIONS(9457),
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [ts_builtin_sym_end] = ACTIONS(9457),
    [anon_sym___END__] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9459),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_end] = ACTIONS(9457),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_when] = ACTIONS(9457),
    [anon_sym_elsif] = ACTIONS(9457),
    [anon_sym_else] = ACTIONS(9457),
    [anon_sym_then] = ACTIONS(9457),
    [anon_sym_ensure] = ACTIONS(9457),
    [anon_sym_EQ_GT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_PLUS_EQ] = ACTIONS(9457),
    [anon_sym_DASH_EQ] = ACTIONS(9457),
    [anon_sym_STAR_EQ] = ACTIONS(9457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9457),
    [anon_sym_SLASH_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9457),
    [anon_sym_AMP_EQ] = ACTIONS(9457),
    [anon_sym_PERCENT_EQ] = ACTIONS(9457),
    [anon_sym_GT_GT_EQ] = ACTIONS(9457),
    [anon_sym_LT_LT_EQ] = ACTIONS(9457),
    [anon_sym_CARET_EQ] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9459),
    [anon_sym_AMP_AMP] = ACTIONS(9459),
    [anon_sym_LT_LT] = ACTIONS(9459),
    [anon_sym_GT_GT] = ACTIONS(9459),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9459),
    [anon_sym_PLUS] = ACTIONS(9459),
    [anon_sym_SLASH] = ACTIONS(9459),
    [anon_sym_PERCENT] = ACTIONS(9459),
    [sym_comment] = ACTIONS(87),
  },
  [6780] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9178),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_assignment] = STATE(9178),
    [sym_operator_assignment] = STATE(9178),
    [sym_conditional] = STATE(9178),
    [sym_range] = STATE(9178),
    [sym_binary] = STATE(9178),
    [sym_unary] = STATE(9178),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6781] = {
    [sym__line_break2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [ts_builtin_sym_end] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(8705),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_elsif] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6739),
    [anon_sym_STAR_EQ] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6739),
    [anon_sym_CARET_EQ] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(8705),
    [anon_sym_AMP_AMP] = ACTIONS(8705),
    [anon_sym_LT_LT] = ACTIONS(8705),
    [anon_sym_GT_GT] = ACTIONS(8705),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_SLASH] = ACTIONS(8705),
    [anon_sym_PERCENT] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
  },
  [6782] = {
    [sym__line_break2] = ACTIONS(10962),
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [ts_builtin_sym_end] = ACTIONS(10962),
    [anon_sym___END__] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10964),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_end] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_when] = ACTIONS(10962),
    [anon_sym_elsif] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10962),
    [anon_sym_then] = ACTIONS(10962),
    [anon_sym_ensure] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10964),
    [anon_sym_AMP_AMP] = ACTIONS(10964),
    [anon_sym_LT_LT] = ACTIONS(10964),
    [anon_sym_GT_GT] = ACTIONS(10964),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10964),
    [anon_sym_PLUS] = ACTIONS(10964),
    [anon_sym_SLASH] = ACTIONS(10964),
    [anon_sym_PERCENT] = ACTIONS(10964),
    [sym_comment] = ACTIONS(87),
  },
  [6783] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3946),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(446),
    [sym_scope_resolution] = STATE(440),
    [sym_call] = STATE(440),
    [sym_method_call] = STATE(446),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(3946),
    [sym_operator_assignment] = STATE(3946),
    [sym_conditional] = STATE(3946),
    [sym_range] = STATE(3946),
    [sym_binary] = STATE(3946),
    [sym_unary] = STATE(3946),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(445),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(446),
    [sym__variable] = STATE(440),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(446),
    [sym_false] = STATE(446),
    [sym_nil] = STATE(446),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1571),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(1687),
    [sym__unary_minus2] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(787),
    [anon_sym_yield] = ACTIONS(789),
    [anon_sym_break] = ACTIONS(791),
    [anon_sym_next] = ACTIONS(793),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(2677),
    [anon_sym_defined_QMARK] = ACTIONS(807),
    [anon_sym_not] = ACTIONS(809),
    [anon_sym_BANG] = ACTIONS(813),
    [anon_sym_TILDE] = ACTIONS(813),
    [sym_constant] = ACTIONS(821),
    [sym_identifier] = ACTIONS(821),
    [sym_instance_variable] = ACTIONS(817),
    [sym_class_variable] = ACTIONS(817),
    [sym_global_variable] = ACTIONS(817),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(821),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(821),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [6784] = {
    [aux_sym_exceptions_repeat1] = STATE(9180),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [ts_builtin_sym_end] = ACTIONS(9929),
    [anon_sym___END__] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12396),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [6785] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5852),
    [anon_sym___END__] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6786] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [ts_builtin_sym_end] = ACTIONS(5856),
    [anon_sym___END__] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6787] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6788] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6789] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6790] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6791] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12398),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6792] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5966),
    [anon_sym___END__] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6793] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6794] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6795] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6796] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(5860),
    [anon_sym___END__] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6797] = {
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [6798] = {
    [aux_sym_exceptions_repeat1] = STATE(6798),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(12402),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [6799] = {
    [aux_sym_exceptions_repeat1] = STATE(3968),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [ts_builtin_sym_end] = ACTIONS(6236),
    [anon_sym___END__] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6800] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(6250),
    [anon_sym___END__] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [6801] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6802] = {
    [sym_heredoc_body] = STATE(9182),
    [aux_sym_call_repeat1] = STATE(9182),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6803] = {
    [sym_heredoc_body] = STATE(9182),
    [aux_sym_call_repeat1] = STATE(9182),
    [aux_sym_argument_list_repeat1] = STATE(9183),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6335),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6804] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6805] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [6806] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9184),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9184),
    [sym_operator_assignment] = STATE(9184),
    [sym_conditional] = STATE(9184),
    [sym_range] = STATE(9184),
    [sym_binary] = STATE(9184),
    [sym_unary] = STATE(9184),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6807] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9185),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9185),
    [sym_operator_assignment] = STATE(9185),
    [sym_conditional] = STATE(9185),
    [sym_range] = STATE(9185),
    [sym_binary] = STATE(9185),
    [sym_unary] = STATE(9185),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6808] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9186),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9186),
    [sym_operator_assignment] = STATE(9186),
    [sym_conditional] = STATE(9186),
    [sym_range] = STATE(9186),
    [sym_binary] = STATE(9186),
    [sym_unary] = STATE(9186),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6809] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9187),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9187),
    [sym_operator_assignment] = STATE(9187),
    [sym_conditional] = STATE(9187),
    [sym_range] = STATE(9187),
    [sym_binary] = STATE(9187),
    [sym_unary] = STATE(9187),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6810] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9188),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9188),
    [sym_operator_assignment] = STATE(9188),
    [sym_conditional] = STATE(9188),
    [sym_range] = STATE(9188),
    [sym_binary] = STATE(9188),
    [sym_unary] = STATE(9188),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6811] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9189),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9189),
    [sym_operator_assignment] = STATE(9189),
    [sym_conditional] = STATE(9189),
    [sym_range] = STATE(9189),
    [sym_binary] = STATE(9189),
    [sym_unary] = STATE(9189),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6812] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9190),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9190),
    [sym_operator_assignment] = STATE(9190),
    [sym_conditional] = STATE(9190),
    [sym_range] = STATE(9190),
    [sym_binary] = STATE(9190),
    [sym_unary] = STATE(9190),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6813] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9191),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9191),
    [sym_operator_assignment] = STATE(9191),
    [sym_conditional] = STATE(9191),
    [sym_range] = STATE(9191),
    [sym_binary] = STATE(9191),
    [sym_unary] = STATE(9191),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6814] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9192),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9192),
    [sym_operator_assignment] = STATE(9192),
    [sym_conditional] = STATE(9192),
    [sym_range] = STATE(9192),
    [sym_binary] = STATE(9192),
    [sym_unary] = STATE(9192),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6815] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9193),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9193),
    [sym_operator_assignment] = STATE(9193),
    [sym_conditional] = STATE(9193),
    [sym_range] = STATE(9193),
    [sym_binary] = STATE(9193),
    [sym_unary] = STATE(9193),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6816] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9194),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9194),
    [sym_operator_assignment] = STATE(9194),
    [sym_conditional] = STATE(9194),
    [sym_range] = STATE(9194),
    [sym_binary] = STATE(9194),
    [sym_unary] = STATE(9194),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6817] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9195),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9195),
    [sym_operator_assignment] = STATE(9195),
    [sym_conditional] = STATE(9195),
    [sym_range] = STATE(9195),
    [sym_binary] = STATE(9195),
    [sym_unary] = STATE(9195),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6818] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9196),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_splat_argument] = STATE(9197),
    [sym_assignment] = STATE(9196),
    [sym_operator_assignment] = STATE(9196),
    [sym_conditional] = STATE(9196),
    [sym_range] = STATE(9196),
    [sym_binary] = STATE(9196),
    [sym_unary] = STATE(9196),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(9197),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6819] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9198),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(9198),
    [sym_operator_assignment] = STATE(9198),
    [sym_conditional] = STATE(9198),
    [sym_range] = STATE(9198),
    [sym_binary] = STATE(9198),
    [sym_unary] = STATE(9198),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6820] = {
    [sym_string] = STATE(9199),
    [aux_sym_chained_string_repeat1] = STATE(9199),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6821] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [6822] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6823] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6824] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9200),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(9200),
    [sym_operator_assignment] = STATE(9200),
    [sym_conditional] = STATE(9200),
    [sym_range] = STATE(9200),
    [sym_binary] = STATE(9200),
    [sym_unary] = STATE(9200),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6825] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6826] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9201),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(9201),
    [sym_operator_assignment] = STATE(9201),
    [sym_conditional] = STATE(9201),
    [sym_range] = STATE(9201),
    [sym_binary] = STATE(9201),
    [sym_unary] = STATE(9201),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6827] = {
    [sym_heredoc_body] = STATE(9202),
    [aux_sym_call_repeat1] = STATE(9202),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6828] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9203),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12405),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6829] = {
    [sym_heredoc_body] = STATE(9204),
    [aux_sym_call_repeat1] = STATE(9204),
    [aux_sym_argument_list_repeat1] = STATE(9205),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9973),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [6830] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6831] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [6832] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6833] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [6834] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6835] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6836] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [6837] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12407),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6838] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6839] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6840] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6841] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6842] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6843] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6844] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6845] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9207),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(9207),
    [sym_operator_assignment] = STATE(9207),
    [sym_conditional] = STATE(9207),
    [sym_range] = STATE(9207),
    [sym_binary] = STATE(9207),
    [sym_unary] = STATE(9207),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6846] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6847] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9208),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(9208),
    [sym_operator_assignment] = STATE(9208),
    [sym_conditional] = STATE(9208),
    [sym_range] = STATE(9208),
    [sym_binary] = STATE(9208),
    [sym_unary] = STATE(9208),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6848] = {
    [sym_heredoc_body] = STATE(9209),
    [aux_sym_call_repeat1] = STATE(9209),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6849] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(9210),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12409),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6850] = {
    [sym_heredoc_body] = STATE(9211),
    [aux_sym_call_repeat1] = STATE(9211),
    [aux_sym_argument_list_repeat1] = STATE(9212),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9981),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [6851] = {
    [sym_heredoc_body] = STATE(6851),
    [aux_sym_call_repeat1] = STATE(6851),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [6852] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(1690),
    [sym_operator_assignment] = STATE(1690),
    [sym_conditional] = STATE(1690),
    [sym_range] = STATE(1690),
    [sym_binary] = STATE(1690),
    [sym_unary] = STATE(1690),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1696),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(2813),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__identifier_hash_key2] = ACTIONS(2819),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(9985),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2837),
    [sym_identifier] = ACTIONS(2837),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6853] = {
    [sym_heredoc_body] = STATE(6851),
    [aux_sym_call_repeat1] = STATE(6851),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [6854] = {
    [aux_sym_argument_list_repeat1] = STATE(6854),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12411),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [6855] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6856] = {
    [aux_sym_exceptions_repeat1] = STATE(9214),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [6857] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [6858] = {
    [sym_string] = STATE(6858),
    [aux_sym_chained_string_repeat1] = STATE(6858),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [6859] = {
    [anon_sym_RBRACE] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [6860] = {
    [aux_sym_undef_repeat1] = STATE(6860),
    [anon_sym_RBRACE] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(12414),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [6861] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9215),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(473),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(473),
    [sym_assignment] = STATE(9215),
    [sym_operator_assignment] = STATE(9215),
    [sym_conditional] = STATE(9215),
    [sym_range] = STATE(9215),
    [sym_binary] = STATE(9215),
    [sym_unary] = STATE(9215),
    [sym_left_assignment_list] = STATE(472),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(473),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(473),
    [sym_false] = STATE(473),
    [sym_nil] = STATE(473),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(474),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(847),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(853),
    [anon_sym_yield] = ACTIONS(855),
    [anon_sym_break] = ACTIONS(857),
    [anon_sym_next] = ACTIONS(859),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(863),
    [anon_sym_defined_QMARK] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_BANG] = ACTIONS(869),
    [anon_sym_TILDE] = ACTIONS(869),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6862] = {
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_rescue] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [6863] = {
    [sym_heredoc_body] = STATE(9217),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12417),
    [sym_comment] = ACTIONS(87),
  },
  [6864] = {
    [anon_sym_RPAREN] = ACTIONS(12417),
    [sym_comment] = ACTIONS(87),
  },
  [6865] = {
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_rescue] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_COLON2] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [6866] = {
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9758),
    [anon_sym_unless] = ACTIONS(9758),
    [anon_sym_while] = ACTIONS(9758),
    [anon_sym_until] = ACTIONS(9758),
    [anon_sym_rescue] = ACTIONS(9758),
    [anon_sym_do] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [6867] = {
    [anon_sym_RBRACK] = ACTIONS(12419),
    [sym_comment] = ACTIONS(87),
  },
  [6868] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(841),
    [anon_sym_RPAREN] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_SEMI] = ACTIONS(841),
    [anon_sym_STAR_STAR] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_if] = ACTIONS(841),
    [anon_sym_unless] = ACTIONS(841),
    [anon_sym_while] = ACTIONS(841),
    [anon_sym_until] = ACTIONS(841),
    [anon_sym_rescue] = ACTIONS(841),
    [anon_sym_in] = ACTIONS(841),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_RBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
    [anon_sym_STAR_EQ] = ACTIONS(841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(841),
    [anon_sym_SLASH_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(841),
    [anon_sym_PIPE_EQ] = ACTIONS(841),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(841),
    [anon_sym_AMP_EQ] = ACTIONS(841),
    [anon_sym_PERCENT_EQ] = ACTIONS(841),
    [anon_sym_GT_GT_EQ] = ACTIONS(841),
    [anon_sym_LT_LT_EQ] = ACTIONS(841),
    [anon_sym_CARET_EQ] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [sym_comment] = ACTIONS(87),
  },
  [6869] = {
    [sym__string_end2] = ACTIONS(12421),
    [sym_comment] = ACTIONS(87),
  },
  [6870] = {
    [sym__heredoc_body_start2] = ACTIONS(891),
    [sym__binary_minus2] = ACTIONS(891),
    [sym__binary_star2] = ACTIONS(891),
    [anon_sym_LBRACE] = ACTIONS(891),
    [anon_sym_RBRACE] = ACTIONS(891),
    [anon_sym_RPAREN] = ACTIONS(891),
    [anon_sym_DOT] = ACTIONS(893),
    [anon_sym_COMMA] = ACTIONS(891),
    [anon_sym_PIPE] = ACTIONS(893),
    [anon_sym_SEMI] = ACTIONS(891),
    [anon_sym_STAR_STAR] = ACTIONS(893),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_EQ] = ACTIONS(893),
    [anon_sym_LT] = ACTIONS(893),
    [anon_sym_if] = ACTIONS(891),
    [anon_sym_unless] = ACTIONS(891),
    [anon_sym_while] = ACTIONS(891),
    [anon_sym_until] = ACTIONS(891),
    [anon_sym_rescue] = ACTIONS(891),
    [anon_sym_in] = ACTIONS(891),
    [anon_sym_do] = ACTIONS(891),
    [anon_sym_LBRACK] = ACTIONS(891),
    [anon_sym_RBRACK] = ACTIONS(891),
    [anon_sym_COLON_COLON2] = ACTIONS(891),
    [anon_sym_AMP_DOT] = ACTIONS(891),
    [anon_sym_PLUS_EQ] = ACTIONS(891),
    [anon_sym_DASH_EQ] = ACTIONS(891),
    [anon_sym_STAR_EQ] = ACTIONS(891),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(891),
    [anon_sym_SLASH_EQ] = ACTIONS(891),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(891),
    [anon_sym_PIPE_EQ] = ACTIONS(891),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(891),
    [anon_sym_AMP_EQ] = ACTIONS(891),
    [anon_sym_PERCENT_EQ] = ACTIONS(891),
    [anon_sym_GT_GT_EQ] = ACTIONS(891),
    [anon_sym_LT_LT_EQ] = ACTIONS(891),
    [anon_sym_CARET_EQ] = ACTIONS(891),
    [anon_sym_QMARK] = ACTIONS(891),
    [anon_sym_COLON2] = ACTIONS(893),
    [anon_sym_DOT_DOT] = ACTIONS(893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(891),
    [anon_sym_and] = ACTIONS(891),
    [anon_sym_or] = ACTIONS(891),
    [anon_sym_PIPE_PIPE] = ACTIONS(893),
    [anon_sym_AMP_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(893),
    [anon_sym_GT_GT] = ACTIONS(893),
    [anon_sym_EQ_EQ] = ACTIONS(893),
    [anon_sym_BANG_EQ] = ACTIONS(891),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(891),
    [anon_sym_LT_EQ_GT] = ACTIONS(891),
    [anon_sym_EQ_TILDE] = ACTIONS(891),
    [anon_sym_BANG_TILDE] = ACTIONS(891),
    [anon_sym_LT_EQ] = ACTIONS(893),
    [anon_sym_GT] = ACTIONS(893),
    [anon_sym_GT_EQ] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(893),
    [anon_sym_PERCENT] = ACTIONS(893),
    [sym_comment] = ACTIONS(87),
  },
  [6871] = {
    [sym__string_end2] = ACTIONS(12423),
    [sym_comment] = ACTIONS(87),
  },
  [6872] = {
    [sym__heredoc_body_start2] = ACTIONS(897),
    [sym__binary_minus2] = ACTIONS(897),
    [sym__binary_star2] = ACTIONS(897),
    [anon_sym_LBRACE] = ACTIONS(897),
    [anon_sym_RBRACE] = ACTIONS(897),
    [anon_sym_RPAREN] = ACTIONS(897),
    [anon_sym_DOT] = ACTIONS(899),
    [anon_sym_COMMA] = ACTIONS(897),
    [anon_sym_PIPE] = ACTIONS(899),
    [anon_sym_SEMI] = ACTIONS(897),
    [anon_sym_STAR_STAR] = ACTIONS(899),
    [anon_sym_AMP] = ACTIONS(899),
    [anon_sym_EQ] = ACTIONS(899),
    [anon_sym_LT] = ACTIONS(899),
    [anon_sym_if] = ACTIONS(897),
    [anon_sym_unless] = ACTIONS(897),
    [anon_sym_while] = ACTIONS(897),
    [anon_sym_until] = ACTIONS(897),
    [anon_sym_rescue] = ACTIONS(897),
    [anon_sym_in] = ACTIONS(897),
    [anon_sym_do] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(897),
    [anon_sym_RBRACK] = ACTIONS(897),
    [anon_sym_COLON_COLON2] = ACTIONS(897),
    [anon_sym_AMP_DOT] = ACTIONS(897),
    [anon_sym_PLUS_EQ] = ACTIONS(897),
    [anon_sym_DASH_EQ] = ACTIONS(897),
    [anon_sym_STAR_EQ] = ACTIONS(897),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(897),
    [anon_sym_SLASH_EQ] = ACTIONS(897),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(897),
    [anon_sym_PIPE_EQ] = ACTIONS(897),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(897),
    [anon_sym_AMP_EQ] = ACTIONS(897),
    [anon_sym_PERCENT_EQ] = ACTIONS(897),
    [anon_sym_GT_GT_EQ] = ACTIONS(897),
    [anon_sym_LT_LT_EQ] = ACTIONS(897),
    [anon_sym_CARET_EQ] = ACTIONS(897),
    [anon_sym_QMARK] = ACTIONS(897),
    [anon_sym_COLON2] = ACTIONS(899),
    [anon_sym_DOT_DOT] = ACTIONS(899),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(897),
    [anon_sym_and] = ACTIONS(897),
    [anon_sym_or] = ACTIONS(897),
    [anon_sym_PIPE_PIPE] = ACTIONS(899),
    [anon_sym_AMP_AMP] = ACTIONS(899),
    [anon_sym_LT_LT] = ACTIONS(899),
    [anon_sym_GT_GT] = ACTIONS(899),
    [anon_sym_EQ_EQ] = ACTIONS(899),
    [anon_sym_BANG_EQ] = ACTIONS(897),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(897),
    [anon_sym_LT_EQ_GT] = ACTIONS(897),
    [anon_sym_EQ_TILDE] = ACTIONS(897),
    [anon_sym_BANG_TILDE] = ACTIONS(897),
    [anon_sym_LT_EQ] = ACTIONS(899),
    [anon_sym_GT] = ACTIONS(899),
    [anon_sym_GT_EQ] = ACTIONS(897),
    [anon_sym_CARET] = ACTIONS(899),
    [anon_sym_PLUS] = ACTIONS(899),
    [anon_sym_SLASH] = ACTIONS(899),
    [anon_sym_PERCENT] = ACTIONS(899),
    [sym_comment] = ACTIONS(87),
  },
  [6873] = {
    [sym__string_end2] = ACTIONS(12425),
    [sym_comment] = ACTIONS(87),
  },
  [6874] = {
    [sym__heredoc_body_start2] = ACTIONS(903),
    [sym__binary_minus2] = ACTIONS(903),
    [sym__binary_star2] = ACTIONS(903),
    [anon_sym_LBRACE] = ACTIONS(903),
    [anon_sym_RBRACE] = ACTIONS(903),
    [anon_sym_RPAREN] = ACTIONS(903),
    [anon_sym_DOT] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(903),
    [anon_sym_PIPE] = ACTIONS(905),
    [anon_sym_SEMI] = ACTIONS(903),
    [anon_sym_STAR_STAR] = ACTIONS(905),
    [anon_sym_AMP] = ACTIONS(905),
    [anon_sym_EQ] = ACTIONS(905),
    [anon_sym_LT] = ACTIONS(905),
    [anon_sym_if] = ACTIONS(903),
    [anon_sym_unless] = ACTIONS(903),
    [anon_sym_while] = ACTIONS(903),
    [anon_sym_until] = ACTIONS(903),
    [anon_sym_rescue] = ACTIONS(903),
    [anon_sym_in] = ACTIONS(903),
    [anon_sym_do] = ACTIONS(903),
    [anon_sym_LBRACK] = ACTIONS(903),
    [anon_sym_RBRACK] = ACTIONS(903),
    [anon_sym_COLON_COLON2] = ACTIONS(903),
    [anon_sym_AMP_DOT] = ACTIONS(903),
    [anon_sym_PLUS_EQ] = ACTIONS(903),
    [anon_sym_DASH_EQ] = ACTIONS(903),
    [anon_sym_STAR_EQ] = ACTIONS(903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(903),
    [anon_sym_SLASH_EQ] = ACTIONS(903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(903),
    [anon_sym_PIPE_EQ] = ACTIONS(903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(903),
    [anon_sym_AMP_EQ] = ACTIONS(903),
    [anon_sym_PERCENT_EQ] = ACTIONS(903),
    [anon_sym_GT_GT_EQ] = ACTIONS(903),
    [anon_sym_LT_LT_EQ] = ACTIONS(903),
    [anon_sym_CARET_EQ] = ACTIONS(903),
    [anon_sym_QMARK] = ACTIONS(903),
    [anon_sym_COLON2] = ACTIONS(905),
    [anon_sym_DOT_DOT] = ACTIONS(905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(903),
    [anon_sym_and] = ACTIONS(903),
    [anon_sym_or] = ACTIONS(903),
    [anon_sym_PIPE_PIPE] = ACTIONS(905),
    [anon_sym_AMP_AMP] = ACTIONS(905),
    [anon_sym_LT_LT] = ACTIONS(905),
    [anon_sym_GT_GT] = ACTIONS(905),
    [anon_sym_EQ_EQ] = ACTIONS(905),
    [anon_sym_BANG_EQ] = ACTIONS(903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(903),
    [anon_sym_LT_EQ_GT] = ACTIONS(903),
    [anon_sym_EQ_TILDE] = ACTIONS(903),
    [anon_sym_BANG_TILDE] = ACTIONS(903),
    [anon_sym_LT_EQ] = ACTIONS(905),
    [anon_sym_GT] = ACTIONS(905),
    [anon_sym_GT_EQ] = ACTIONS(903),
    [anon_sym_CARET] = ACTIONS(905),
    [anon_sym_PLUS] = ACTIONS(905),
    [anon_sym_SLASH] = ACTIONS(905),
    [anon_sym_PERCENT] = ACTIONS(905),
    [sym_comment] = ACTIONS(87),
  },
  [6875] = {
    [sym__string_end2] = ACTIONS(12427),
    [sym_comment] = ACTIONS(87),
  },
  [6876] = {
    [sym__heredoc_body_start2] = ACTIONS(909),
    [sym__binary_minus2] = ACTIONS(909),
    [sym__binary_star2] = ACTIONS(909),
    [anon_sym_LBRACE] = ACTIONS(909),
    [anon_sym_RBRACE] = ACTIONS(909),
    [anon_sym_RPAREN] = ACTIONS(909),
    [anon_sym_DOT] = ACTIONS(911),
    [anon_sym_COMMA] = ACTIONS(909),
    [anon_sym_PIPE] = ACTIONS(911),
    [anon_sym_SEMI] = ACTIONS(909),
    [anon_sym_STAR_STAR] = ACTIONS(911),
    [anon_sym_AMP] = ACTIONS(911),
    [anon_sym_EQ] = ACTIONS(911),
    [anon_sym_LT] = ACTIONS(911),
    [anon_sym_if] = ACTIONS(909),
    [anon_sym_unless] = ACTIONS(909),
    [anon_sym_while] = ACTIONS(909),
    [anon_sym_until] = ACTIONS(909),
    [anon_sym_rescue] = ACTIONS(909),
    [anon_sym_in] = ACTIONS(909),
    [anon_sym_do] = ACTIONS(909),
    [anon_sym_LBRACK] = ACTIONS(909),
    [anon_sym_RBRACK] = ACTIONS(909),
    [anon_sym_COLON_COLON2] = ACTIONS(909),
    [anon_sym_AMP_DOT] = ACTIONS(909),
    [anon_sym_PLUS_EQ] = ACTIONS(909),
    [anon_sym_DASH_EQ] = ACTIONS(909),
    [anon_sym_STAR_EQ] = ACTIONS(909),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(909),
    [anon_sym_SLASH_EQ] = ACTIONS(909),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(909),
    [anon_sym_PIPE_EQ] = ACTIONS(909),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(909),
    [anon_sym_AMP_EQ] = ACTIONS(909),
    [anon_sym_PERCENT_EQ] = ACTIONS(909),
    [anon_sym_GT_GT_EQ] = ACTIONS(909),
    [anon_sym_LT_LT_EQ] = ACTIONS(909),
    [anon_sym_CARET_EQ] = ACTIONS(909),
    [anon_sym_QMARK] = ACTIONS(909),
    [anon_sym_COLON2] = ACTIONS(911),
    [anon_sym_DOT_DOT] = ACTIONS(911),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(909),
    [anon_sym_and] = ACTIONS(909),
    [anon_sym_or] = ACTIONS(909),
    [anon_sym_PIPE_PIPE] = ACTIONS(911),
    [anon_sym_AMP_AMP] = ACTIONS(911),
    [anon_sym_LT_LT] = ACTIONS(911),
    [anon_sym_GT_GT] = ACTIONS(911),
    [anon_sym_EQ_EQ] = ACTIONS(911),
    [anon_sym_BANG_EQ] = ACTIONS(909),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(909),
    [anon_sym_LT_EQ_GT] = ACTIONS(909),
    [anon_sym_EQ_TILDE] = ACTIONS(909),
    [anon_sym_BANG_TILDE] = ACTIONS(909),
    [anon_sym_LT_EQ] = ACTIONS(911),
    [anon_sym_GT] = ACTIONS(911),
    [anon_sym_GT_EQ] = ACTIONS(909),
    [anon_sym_CARET] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(911),
    [anon_sym_SLASH] = ACTIONS(911),
    [anon_sym_PERCENT] = ACTIONS(911),
    [sym_comment] = ACTIONS(87),
  },
  [6877] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(9225),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12429),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12431),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6878] = {
    [aux_sym_string_array_repeat1] = STATE(9228),
    [sym__string_end2] = ACTIONS(12433),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12435),
  },
  [6879] = {
    [sym__heredoc_body_start2] = ACTIONS(927),
    [sym__binary_minus2] = ACTIONS(927),
    [sym__binary_star2] = ACTIONS(927),
    [anon_sym_LBRACE] = ACTIONS(927),
    [anon_sym_RBRACE] = ACTIONS(927),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_DOT] = ACTIONS(929),
    [anon_sym_COMMA] = ACTIONS(927),
    [anon_sym_PIPE] = ACTIONS(929),
    [anon_sym_SEMI] = ACTIONS(927),
    [anon_sym_STAR_STAR] = ACTIONS(929),
    [anon_sym_AMP] = ACTIONS(929),
    [anon_sym_EQ] = ACTIONS(929),
    [anon_sym_LT] = ACTIONS(929),
    [anon_sym_if] = ACTIONS(927),
    [anon_sym_unless] = ACTIONS(927),
    [anon_sym_while] = ACTIONS(927),
    [anon_sym_until] = ACTIONS(927),
    [anon_sym_rescue] = ACTIONS(927),
    [anon_sym_in] = ACTIONS(927),
    [anon_sym_do] = ACTIONS(927),
    [anon_sym_LBRACK] = ACTIONS(927),
    [anon_sym_RBRACK] = ACTIONS(927),
    [anon_sym_COLON_COLON2] = ACTIONS(927),
    [anon_sym_AMP_DOT] = ACTIONS(927),
    [anon_sym_PLUS_EQ] = ACTIONS(927),
    [anon_sym_DASH_EQ] = ACTIONS(927),
    [anon_sym_STAR_EQ] = ACTIONS(927),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(927),
    [anon_sym_SLASH_EQ] = ACTIONS(927),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(927),
    [anon_sym_PIPE_EQ] = ACTIONS(927),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(927),
    [anon_sym_AMP_EQ] = ACTIONS(927),
    [anon_sym_PERCENT_EQ] = ACTIONS(927),
    [anon_sym_GT_GT_EQ] = ACTIONS(927),
    [anon_sym_LT_LT_EQ] = ACTIONS(927),
    [anon_sym_CARET_EQ] = ACTIONS(927),
    [anon_sym_QMARK] = ACTIONS(927),
    [anon_sym_COLON2] = ACTIONS(929),
    [anon_sym_DOT_DOT] = ACTIONS(929),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(927),
    [anon_sym_and] = ACTIONS(927),
    [anon_sym_or] = ACTIONS(927),
    [anon_sym_PIPE_PIPE] = ACTIONS(929),
    [anon_sym_AMP_AMP] = ACTIONS(929),
    [anon_sym_LT_LT] = ACTIONS(929),
    [anon_sym_GT_GT] = ACTIONS(929),
    [anon_sym_EQ_EQ] = ACTIONS(929),
    [anon_sym_BANG_EQ] = ACTIONS(927),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(927),
    [anon_sym_LT_EQ_GT] = ACTIONS(927),
    [anon_sym_EQ_TILDE] = ACTIONS(927),
    [anon_sym_BANG_TILDE] = ACTIONS(927),
    [anon_sym_LT_EQ] = ACTIONS(929),
    [anon_sym_GT] = ACTIONS(929),
    [anon_sym_GT_EQ] = ACTIONS(927),
    [anon_sym_CARET] = ACTIONS(929),
    [anon_sym_PLUS] = ACTIONS(929),
    [anon_sym_SLASH] = ACTIONS(929),
    [anon_sym_PERCENT] = ACTIONS(929),
    [sym_comment] = ACTIONS(87),
  },
  [6880] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(9231),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12437),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12439),
    [sym_escape_sequence] = ACTIONS(127),
  },
  [6881] = {
    [aux_sym_symbol_array_repeat1] = STATE(9234),
    [sym__string_end2] = ACTIONS(12441),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12443),
  },
  [6882] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [6883] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_RBRACE] = ACTIONS(997),
    [anon_sym_RPAREN] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(999),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(999),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_EQ] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_if] = ACTIONS(997),
    [anon_sym_unless] = ACTIONS(997),
    [anon_sym_while] = ACTIONS(997),
    [anon_sym_until] = ACTIONS(997),
    [anon_sym_rescue] = ACTIONS(997),
    [anon_sym_in] = ACTIONS(997),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(997),
    [anon_sym_RBRACK] = ACTIONS(997),
    [anon_sym_COLON_COLON2] = ACTIONS(997),
    [anon_sym_AMP_DOT] = ACTIONS(997),
    [anon_sym_PLUS_EQ] = ACTIONS(997),
    [anon_sym_DASH_EQ] = ACTIONS(997),
    [anon_sym_STAR_EQ] = ACTIONS(997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(997),
    [anon_sym_SLASH_EQ] = ACTIONS(997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(997),
    [anon_sym_PIPE_EQ] = ACTIONS(997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(997),
    [anon_sym_AMP_EQ] = ACTIONS(997),
    [anon_sym_PERCENT_EQ] = ACTIONS(997),
    [anon_sym_GT_GT_EQ] = ACTIONS(997),
    [anon_sym_LT_LT_EQ] = ACTIONS(997),
    [anon_sym_CARET_EQ] = ACTIONS(997),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_COLON2] = ACTIONS(999),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(999),
    [anon_sym_AMP_AMP] = ACTIONS(999),
    [anon_sym_LT_LT] = ACTIONS(999),
    [anon_sym_GT_GT] = ACTIONS(999),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(999),
    [anon_sym_PLUS] = ACTIONS(999),
    [anon_sym_SLASH] = ACTIONS(999),
    [anon_sym_PERCENT] = ACTIONS(999),
    [sym_comment] = ACTIONS(87),
  },
  [6884] = {
    [anon_sym_RBRACE] = ACTIONS(12445),
    [sym_comment] = ACTIONS(87),
  },
  [6885] = {
    [sym_heredoc_body] = STATE(9236),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACE] = ACTIONS(12445),
    [sym_comment] = ACTIONS(87),
  },
  [6886] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9237),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(9237),
    [sym_operator_assignment] = STATE(9237),
    [sym_conditional] = STATE(9237),
    [sym_range] = STATE(9237),
    [sym_binary] = STATE(9237),
    [sym_unary] = STATE(9237),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6887] = {
    [sym__heredoc_body_start2] = ACTIONS(1283),
    [sym__binary_minus2] = ACTIONS(1283),
    [sym__binary_star2] = ACTIONS(1283),
    [anon_sym_LBRACE] = ACTIONS(1283),
    [anon_sym_RBRACE] = ACTIONS(1283),
    [anon_sym_RPAREN] = ACTIONS(1283),
    [anon_sym_DOT] = ACTIONS(1285),
    [anon_sym_COMMA] = ACTIONS(1283),
    [anon_sym_PIPE] = ACTIONS(1285),
    [anon_sym_SEMI] = ACTIONS(1283),
    [anon_sym_STAR_STAR] = ACTIONS(1285),
    [anon_sym_AMP] = ACTIONS(1285),
    [anon_sym_EQ] = ACTIONS(1285),
    [anon_sym_LT] = ACTIONS(1285),
    [anon_sym_if] = ACTIONS(1283),
    [anon_sym_unless] = ACTIONS(1283),
    [anon_sym_while] = ACTIONS(1283),
    [anon_sym_until] = ACTIONS(1283),
    [anon_sym_rescue] = ACTIONS(1283),
    [anon_sym_in] = ACTIONS(1283),
    [anon_sym_do] = ACTIONS(1283),
    [anon_sym_LBRACK] = ACTIONS(1283),
    [anon_sym_RBRACK] = ACTIONS(1283),
    [anon_sym_COLON_COLON2] = ACTIONS(1283),
    [anon_sym_AMP_DOT] = ACTIONS(1283),
    [anon_sym_PLUS_EQ] = ACTIONS(1283),
    [anon_sym_DASH_EQ] = ACTIONS(1283),
    [anon_sym_STAR_EQ] = ACTIONS(1283),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1283),
    [anon_sym_SLASH_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_PIPE_EQ] = ACTIONS(1283),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1283),
    [anon_sym_AMP_EQ] = ACTIONS(1283),
    [anon_sym_PERCENT_EQ] = ACTIONS(1283),
    [anon_sym_GT_GT_EQ] = ACTIONS(1283),
    [anon_sym_LT_LT_EQ] = ACTIONS(1283),
    [anon_sym_CARET_EQ] = ACTIONS(1283),
    [anon_sym_QMARK] = ACTIONS(1283),
    [anon_sym_COLON2] = ACTIONS(1285),
    [anon_sym_DOT_DOT] = ACTIONS(1285),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1283),
    [anon_sym_and] = ACTIONS(1283),
    [anon_sym_or] = ACTIONS(1283),
    [anon_sym_PIPE_PIPE] = ACTIONS(1285),
    [anon_sym_AMP_AMP] = ACTIONS(1285),
    [anon_sym_LT_LT] = ACTIONS(1285),
    [anon_sym_GT_GT] = ACTIONS(1285),
    [anon_sym_EQ_EQ] = ACTIONS(1285),
    [anon_sym_BANG_EQ] = ACTIONS(1283),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1283),
    [anon_sym_LT_EQ_GT] = ACTIONS(1283),
    [anon_sym_EQ_TILDE] = ACTIONS(1283),
    [anon_sym_BANG_TILDE] = ACTIONS(1283),
    [anon_sym_LT_EQ] = ACTIONS(1285),
    [anon_sym_GT] = ACTIONS(1285),
    [anon_sym_GT_EQ] = ACTIONS(1283),
    [anon_sym_CARET] = ACTIONS(1285),
    [anon_sym_PLUS] = ACTIONS(1285),
    [anon_sym_SLASH] = ACTIONS(1285),
    [anon_sym_PERCENT] = ACTIONS(1285),
    [sym_comment] = ACTIONS(87),
  },
  [6888] = {
    [anon_sym_DOT] = ACTIONS(12447),
    [anon_sym_COLON_COLON] = ACTIONS(12447),
    [sym_comment] = ACTIONS(87),
  },
  [6889] = {
    [sym_method_parameters] = STATE(9239),
    [sym__simple_formal_parameter] = STATE(709),
    [sym_splat_parameter] = STATE(709),
    [sym_hash_splat_parameter] = STATE(709),
    [sym_block_parameter] = STATE(709),
    [sym_keyword_parameter] = STATE(709),
    [sym_optional_parameter] = STATE(709),
    [sym_heredoc_body] = STATE(9239),
    [sym__terminator] = STATE(9239),
    [sym__line_break2] = ACTIONS(12449),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(1291),
    [anon_sym_SEMI] = ACTIONS(12449),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [6890] = {
    [sym__heredoc_body_start2] = ACTIONS(1301),
    [sym__binary_minus2] = ACTIONS(1301),
    [sym__binary_star2] = ACTIONS(1301),
    [anon_sym_LBRACE] = ACTIONS(1301),
    [anon_sym_RBRACE] = ACTIONS(1301),
    [anon_sym_RPAREN] = ACTIONS(1301),
    [anon_sym_DOT] = ACTIONS(1303),
    [anon_sym_COMMA] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(1303),
    [anon_sym_SEMI] = ACTIONS(1301),
    [anon_sym_STAR_STAR] = ACTIONS(1303),
    [anon_sym_AMP] = ACTIONS(1303),
    [anon_sym_EQ] = ACTIONS(1303),
    [anon_sym_LT] = ACTIONS(1303),
    [anon_sym_if] = ACTIONS(1301),
    [anon_sym_unless] = ACTIONS(1301),
    [anon_sym_while] = ACTIONS(1301),
    [anon_sym_until] = ACTIONS(1301),
    [anon_sym_rescue] = ACTIONS(1301),
    [anon_sym_in] = ACTIONS(1301),
    [anon_sym_do] = ACTIONS(1301),
    [anon_sym_LBRACK] = ACTIONS(1301),
    [anon_sym_RBRACK] = ACTIONS(1301),
    [anon_sym_COLON_COLON2] = ACTIONS(1301),
    [anon_sym_AMP_DOT] = ACTIONS(1301),
    [anon_sym_PLUS_EQ] = ACTIONS(1301),
    [anon_sym_DASH_EQ] = ACTIONS(1301),
    [anon_sym_STAR_EQ] = ACTIONS(1301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1301),
    [anon_sym_SLASH_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_PIPE_EQ] = ACTIONS(1301),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1301),
    [anon_sym_AMP_EQ] = ACTIONS(1301),
    [anon_sym_PERCENT_EQ] = ACTIONS(1301),
    [anon_sym_GT_GT_EQ] = ACTIONS(1301),
    [anon_sym_LT_LT_EQ] = ACTIONS(1301),
    [anon_sym_CARET_EQ] = ACTIONS(1301),
    [anon_sym_QMARK] = ACTIONS(1301),
    [anon_sym_COLON2] = ACTIONS(1303),
    [anon_sym_DOT_DOT] = ACTIONS(1303),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1301),
    [anon_sym_and] = ACTIONS(1301),
    [anon_sym_or] = ACTIONS(1301),
    [anon_sym_PIPE_PIPE] = ACTIONS(1303),
    [anon_sym_AMP_AMP] = ACTIONS(1303),
    [anon_sym_LT_LT] = ACTIONS(1303),
    [anon_sym_GT_GT] = ACTIONS(1303),
    [anon_sym_EQ_EQ] = ACTIONS(1303),
    [anon_sym_BANG_EQ] = ACTIONS(1301),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1301),
    [anon_sym_LT_EQ_GT] = ACTIONS(1301),
    [anon_sym_EQ_TILDE] = ACTIONS(1301),
    [anon_sym_BANG_TILDE] = ACTIONS(1301),
    [anon_sym_LT_EQ] = ACTIONS(1303),
    [anon_sym_GT] = ACTIONS(1303),
    [anon_sym_GT_EQ] = ACTIONS(1301),
    [anon_sym_CARET] = ACTIONS(1303),
    [anon_sym_PLUS] = ACTIONS(1303),
    [anon_sym_SLASH] = ACTIONS(1303),
    [anon_sym_PERCENT] = ACTIONS(1303),
    [sym_comment] = ACTIONS(87),
  },
  [6891] = {
    [anon_sym_RPAREN] = ACTIONS(12451),
    [sym_comment] = ACTIONS(87),
  },
  [6892] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(278),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(278),
    [sym_assignment] = STATE(9241),
    [sym_operator_assignment] = STATE(9241),
    [sym_conditional] = STATE(9241),
    [sym_range] = STATE(9241),
    [sym_binary] = STATE(9241),
    [sym_unary] = STATE(9241),
    [sym_left_assignment_list] = STATE(277),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(278),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(278),
    [sym_false] = STATE(278),
    [sym_nil] = STATE(278),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(279),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(485),
    [anon_sym_yield] = ACTIONS(487),
    [anon_sym_break] = ACTIONS(489),
    [anon_sym_next] = ACTIONS(491),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(493),
    [anon_sym_defined_QMARK] = ACTIONS(495),
    [anon_sym_not] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_TILDE] = ACTIONS(499),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6893] = {
    [sym_superclass] = STATE(9242),
    [sym_heredoc_body] = STATE(9243),
    [sym__terminator] = STATE(9243),
    [sym__line_break2] = ACTIONS(12453),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(12453),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6894] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_superclass] = STATE(9242),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9243),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(9243),
    [sym__line_break2] = ACTIONS(12453),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(12453),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(1533),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6895] = {
    [sym_heredoc_body] = STATE(9245),
    [sym__terminator] = STATE(9245),
    [sym__line_break2] = ACTIONS(12455),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1093),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(12455),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1093),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(12457),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1093),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [6896] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(890),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_argument_list] = STATE(862),
    [sym__argument_list_with_parens] = STATE(891),
    [sym__argument] = STATE(892),
    [sym_splat_argument] = STATE(892),
    [sym_hash_splat_argument] = STATE(892),
    [sym_block_argument] = STATE(892),
    [sym_do_block] = STATE(865),
    [sym_block] = STATE(865),
    [sym_assignment] = STATE(890),
    [sym_operator_assignment] = STATE(890),
    [sym_conditional] = STATE(890),
    [sym_range] = STATE(890),
    [sym_binary] = STATE(890),
    [sym_unary] = STATE(890),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(895),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9245),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(892),
    [sym_lambda] = STATE(360),
    [sym__terminator] = STATE(9245),
    [sym__line_break2] = ACTIONS(12455),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1537),
    [sym__splat_star2] = ACTIONS(1539),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(1543),
    [anon_sym_LBRACE] = ACTIONS(1545),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(749),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_SEMI] = ACTIONS(12455),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1547),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_end] = ACTIONS(12457),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_do] = ACTIONS(1489),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1471),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1565),
    [sym_identifier] = ACTIONS(1565),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [6897] = {
    [sym__heredoc_body_start2] = ACTIONS(1699),
    [sym__binary_minus2] = ACTIONS(1699),
    [sym__binary_star2] = ACTIONS(1699),
    [anon_sym_LBRACE] = ACTIONS(1699),
    [anon_sym_RBRACE] = ACTIONS(1699),
    [anon_sym_RPAREN] = ACTIONS(1699),
    [anon_sym_DOT] = ACTIONS(1701),
    [anon_sym_COMMA] = ACTIONS(1699),
    [anon_sym_PIPE] = ACTIONS(1701),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_STAR_STAR] = ACTIONS(1701),
    [anon_sym_AMP] = ACTIONS(1701),
    [anon_sym_EQ] = ACTIONS(1701),
    [anon_sym_LT] = ACTIONS(1701),
    [anon_sym_if] = ACTIONS(1699),
    [anon_sym_unless] = ACTIONS(1699),
    [anon_sym_while] = ACTIONS(1699),
    [anon_sym_until] = ACTIONS(1699),
    [anon_sym_rescue] = ACTIONS(1699),
    [anon_sym_in] = ACTIONS(1699),
    [anon_sym_do] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1699),
    [anon_sym_RBRACK] = ACTIONS(1699),
    [anon_sym_COLON_COLON2] = ACTIONS(1699),
    [anon_sym_AMP_DOT] = ACTIONS(1699),
    [anon_sym_PLUS_EQ] = ACTIONS(1699),
    [anon_sym_DASH_EQ] = ACTIONS(1699),
    [anon_sym_STAR_EQ] = ACTIONS(1699),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1699),
    [anon_sym_SLASH_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_PIPE_EQ] = ACTIONS(1699),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1699),
    [anon_sym_AMP_EQ] = ACTIONS(1699),
    [anon_sym_PERCENT_EQ] = ACTIONS(1699),
    [anon_sym_GT_GT_EQ] = ACTIONS(1699),
    [anon_sym_LT_LT_EQ] = ACTIONS(1699),
    [anon_sym_CARET_EQ] = ACTIONS(1699),
    [anon_sym_QMARK] = ACTIONS(1699),
    [anon_sym_COLON2] = ACTIONS(1701),
    [anon_sym_DOT_DOT] = ACTIONS(1701),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1699),
    [anon_sym_and] = ACTIONS(1699),
    [anon_sym_or] = ACTIONS(1699),
    [anon_sym_PIPE_PIPE] = ACTIONS(1701),
    [anon_sym_AMP_AMP] = ACTIONS(1701),
    [anon_sym_LT_LT] = ACTIONS(1701),
    [anon_sym_GT_GT] = ACTIONS(1701),
    [anon_sym_EQ_EQ] = ACTIONS(1701),
    [anon_sym_BANG_EQ] = ACTIONS(1699),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1699),
    [anon_sym_LT_EQ_GT] = ACTIONS(1699),
    [anon_sym_EQ_TILDE] = ACTIONS(1699),
    [anon_sym_BANG_TILDE] = ACTIONS(1699),
    [anon_sym_LT_EQ] = ACTIONS(1701),
    [anon_sym_GT] = ACTIONS(1701),
    [anon_sym_GT_EQ] = ACTIONS(1699),
    [anon_sym_CARET] = ACTIONS(1701),
    [anon_sym_PLUS] = ACTIONS(1701),
    [anon_sym_SLASH] = ACTIONS(1701),
    [anon_sym_PERCENT] = ACTIONS(1701),
    [sym_comment] = ACTIONS(87),
  },
  [6898] = {
    [sym__heredoc_body_start2] = ACTIONS(1719),
    [sym__binary_minus2] = ACTIONS(1719),
    [sym__binary_star2] = ACTIONS(1719),
    [anon_sym_LBRACE] = ACTIONS(1719),
    [anon_sym_RBRACE] = ACTIONS(1719),
    [anon_sym_RPAREN] = ACTIONS(1719),
    [anon_sym_DOT] = ACTIONS(1721),
    [anon_sym_COMMA] = ACTIONS(1719),
    [anon_sym_PIPE] = ACTIONS(1721),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_STAR_STAR] = ACTIONS(1721),
    [anon_sym_AMP] = ACTIONS(1721),
    [anon_sym_EQ] = ACTIONS(1721),
    [anon_sym_LT] = ACTIONS(1721),
    [anon_sym_if] = ACTIONS(1719),
    [anon_sym_unless] = ACTIONS(1719),
    [anon_sym_while] = ACTIONS(1719),
    [anon_sym_until] = ACTIONS(1719),
    [anon_sym_rescue] = ACTIONS(1719),
    [anon_sym_in] = ACTIONS(1719),
    [anon_sym_do] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1719),
    [anon_sym_RBRACK] = ACTIONS(1719),
    [anon_sym_COLON_COLON2] = ACTIONS(1719),
    [anon_sym_AMP_DOT] = ACTIONS(1719),
    [anon_sym_PLUS_EQ] = ACTIONS(1719),
    [anon_sym_DASH_EQ] = ACTIONS(1719),
    [anon_sym_STAR_EQ] = ACTIONS(1719),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1719),
    [anon_sym_SLASH_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_PIPE_EQ] = ACTIONS(1719),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1719),
    [anon_sym_AMP_EQ] = ACTIONS(1719),
    [anon_sym_PERCENT_EQ] = ACTIONS(1719),
    [anon_sym_GT_GT_EQ] = ACTIONS(1719),
    [anon_sym_LT_LT_EQ] = ACTIONS(1719),
    [anon_sym_CARET_EQ] = ACTIONS(1719),
    [anon_sym_QMARK] = ACTIONS(1719),
    [anon_sym_COLON2] = ACTIONS(1721),
    [anon_sym_DOT_DOT] = ACTIONS(1721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1719),
    [anon_sym_and] = ACTIONS(1719),
    [anon_sym_or] = ACTIONS(1719),
    [anon_sym_PIPE_PIPE] = ACTIONS(1721),
    [anon_sym_AMP_AMP] = ACTIONS(1721),
    [anon_sym_LT_LT] = ACTIONS(1721),
    [anon_sym_GT_GT] = ACTIONS(1721),
    [anon_sym_EQ_EQ] = ACTIONS(1721),
    [anon_sym_BANG_EQ] = ACTIONS(1719),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1719),
    [anon_sym_LT_EQ_GT] = ACTIONS(1719),
    [anon_sym_EQ_TILDE] = ACTIONS(1719),
    [anon_sym_BANG_TILDE] = ACTIONS(1719),
    [anon_sym_LT_EQ] = ACTIONS(1721),
    [anon_sym_GT] = ACTIONS(1721),
    [anon_sym_GT_EQ] = ACTIONS(1719),
    [anon_sym_CARET] = ACTIONS(1721),
    [anon_sym_PLUS] = ACTIONS(1721),
    [anon_sym_SLASH] = ACTIONS(1721),
    [anon_sym_PERCENT] = ACTIONS(1721),
    [sym_comment] = ACTIONS(87),
  },
  [6899] = {
    [sym__heredoc_body_start2] = ACTIONS(1723),
    [sym__binary_minus2] = ACTIONS(1723),
    [sym__binary_star2] = ACTIONS(1723),
    [anon_sym_LBRACE] = ACTIONS(1723),
    [anon_sym_RBRACE] = ACTIONS(1723),
    [anon_sym_RPAREN] = ACTIONS(1723),
    [anon_sym_DOT] = ACTIONS(1725),
    [anon_sym_COMMA] = ACTIONS(1723),
    [anon_sym_PIPE] = ACTIONS(1725),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_STAR_STAR] = ACTIONS(1725),
    [anon_sym_AMP] = ACTIONS(1725),
    [anon_sym_EQ] = ACTIONS(1725),
    [anon_sym_LT] = ACTIONS(1725),
    [anon_sym_if] = ACTIONS(1723),
    [anon_sym_unless] = ACTIONS(1723),
    [anon_sym_while] = ACTIONS(1723),
    [anon_sym_until] = ACTIONS(1723),
    [anon_sym_rescue] = ACTIONS(1723),
    [anon_sym_in] = ACTIONS(1723),
    [anon_sym_do] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1723),
    [anon_sym_RBRACK] = ACTIONS(1723),
    [anon_sym_COLON_COLON2] = ACTIONS(1723),
    [anon_sym_AMP_DOT] = ACTIONS(1723),
    [anon_sym_PLUS_EQ] = ACTIONS(1723),
    [anon_sym_DASH_EQ] = ACTIONS(1723),
    [anon_sym_STAR_EQ] = ACTIONS(1723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1723),
    [anon_sym_SLASH_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_PIPE_EQ] = ACTIONS(1723),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1723),
    [anon_sym_AMP_EQ] = ACTIONS(1723),
    [anon_sym_PERCENT_EQ] = ACTIONS(1723),
    [anon_sym_GT_GT_EQ] = ACTIONS(1723),
    [anon_sym_LT_LT_EQ] = ACTIONS(1723),
    [anon_sym_CARET_EQ] = ACTIONS(1723),
    [anon_sym_QMARK] = ACTIONS(1723),
    [anon_sym_COLON2] = ACTIONS(1725),
    [anon_sym_DOT_DOT] = ACTIONS(1725),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1723),
    [anon_sym_and] = ACTIONS(1723),
    [anon_sym_or] = ACTIONS(1723),
    [anon_sym_PIPE_PIPE] = ACTIONS(1725),
    [anon_sym_AMP_AMP] = ACTIONS(1725),
    [anon_sym_LT_LT] = ACTIONS(1725),
    [anon_sym_GT_GT] = ACTIONS(1725),
    [anon_sym_EQ_EQ] = ACTIONS(1725),
    [anon_sym_BANG_EQ] = ACTIONS(1723),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1723),
    [anon_sym_LT_EQ_GT] = ACTIONS(1723),
    [anon_sym_EQ_TILDE] = ACTIONS(1723),
    [anon_sym_BANG_TILDE] = ACTIONS(1723),
    [anon_sym_LT_EQ] = ACTIONS(1725),
    [anon_sym_GT] = ACTIONS(1725),
    [anon_sym_GT_EQ] = ACTIONS(1723),
    [anon_sym_CARET] = ACTIONS(1725),
    [anon_sym_PLUS] = ACTIONS(1725),
    [anon_sym_SLASH] = ACTIONS(1725),
    [anon_sym_PERCENT] = ACTIONS(1725),
    [sym_comment] = ACTIONS(87),
  },
  [6900] = {
    [sym__heredoc_body_start2] = ACTIONS(1727),
    [sym__binary_minus2] = ACTIONS(1727),
    [sym__binary_star2] = ACTIONS(1727),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_RBRACE] = ACTIONS(1727),
    [anon_sym_RPAREN] = ACTIONS(1727),
    [anon_sym_DOT] = ACTIONS(1729),
    [anon_sym_COMMA] = ACTIONS(1727),
    [anon_sym_PIPE] = ACTIONS(1729),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_STAR_STAR] = ACTIONS(1729),
    [anon_sym_AMP] = ACTIONS(1729),
    [anon_sym_EQ] = ACTIONS(1729),
    [anon_sym_LT] = ACTIONS(1729),
    [anon_sym_if] = ACTIONS(1727),
    [anon_sym_unless] = ACTIONS(1727),
    [anon_sym_while] = ACTIONS(1727),
    [anon_sym_until] = ACTIONS(1727),
    [anon_sym_rescue] = ACTIONS(1727),
    [anon_sym_in] = ACTIONS(1727),
    [anon_sym_do] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1727),
    [anon_sym_RBRACK] = ACTIONS(1727),
    [anon_sym_COLON_COLON2] = ACTIONS(1727),
    [anon_sym_AMP_DOT] = ACTIONS(1727),
    [anon_sym_PLUS_EQ] = ACTIONS(1727),
    [anon_sym_DASH_EQ] = ACTIONS(1727),
    [anon_sym_STAR_EQ] = ACTIONS(1727),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1727),
    [anon_sym_SLASH_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_PIPE_EQ] = ACTIONS(1727),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1727),
    [anon_sym_AMP_EQ] = ACTIONS(1727),
    [anon_sym_PERCENT_EQ] = ACTIONS(1727),
    [anon_sym_GT_GT_EQ] = ACTIONS(1727),
    [anon_sym_LT_LT_EQ] = ACTIONS(1727),
    [anon_sym_CARET_EQ] = ACTIONS(1727),
    [anon_sym_QMARK] = ACTIONS(1727),
    [anon_sym_COLON2] = ACTIONS(1729),
    [anon_sym_DOT_DOT] = ACTIONS(1729),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1727),
    [anon_sym_and] = ACTIONS(1727),
    [anon_sym_or] = ACTIONS(1727),
    [anon_sym_PIPE_PIPE] = ACTIONS(1729),
    [anon_sym_AMP_AMP] = ACTIONS(1729),
    [anon_sym_LT_LT] = ACTIONS(1729),
    [anon_sym_GT_GT] = ACTIONS(1729),
    [anon_sym_EQ_EQ] = ACTIONS(1729),
    [anon_sym_BANG_EQ] = ACTIONS(1727),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1727),
    [anon_sym_LT_EQ_GT] = ACTIONS(1727),
    [anon_sym_EQ_TILDE] = ACTIONS(1727),
    [anon_sym_BANG_TILDE] = ACTIONS(1727),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_GT] = ACTIONS(1729),
    [anon_sym_GT_EQ] = ACTIONS(1727),
    [anon_sym_CARET] = ACTIONS(1729),
    [anon_sym_PLUS] = ACTIONS(1729),
    [anon_sym_SLASH] = ACTIONS(1729),
    [anon_sym_PERCENT] = ACTIONS(1729),
    [sym_comment] = ACTIONS(87),
  },
  [6901] = {
    [sym__then] = STATE(9246),
    [sym_heredoc_body] = STATE(1018),
    [sym__terminator] = STATE(1018),
    [sym__line_break2] = ACTIONS(1763),
    [sym__heredoc_body_start2] = ACTIONS(1765),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(12459),
    [sym_comment] = ACTIONS(87),
  },
  [6902] = {
    [sym__then] = STATE(9247),
    [sym_heredoc_body] = STATE(1055),
    [sym__terminator] = STATE(1055),
    [sym__line_break2] = ACTIONS(1847),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(1847),
    [anon_sym_if] = ACTIONS(1767),
    [anon_sym_unless] = ACTIONS(1769),
    [anon_sym_while] = ACTIONS(1771),
    [anon_sym_until] = ACTIONS(1773),
    [anon_sym_rescue] = ACTIONS(1775),
    [anon_sym_then] = ACTIONS(12461),
    [sym_comment] = ACTIONS(87),
  },
  [6903] = {
    [sym__do] = STATE(9248),
    [sym_heredoc_body] = STATE(9248),
    [sym__terminator] = STATE(9248),
    [sym__line_break2] = ACTIONS(12463),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(12463),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(12463),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [6904] = {
    [sym__do] = STATE(9249),
    [sym_heredoc_body] = STATE(9249),
    [sym__terminator] = STATE(9249),
    [sym__line_break2] = ACTIONS(12465),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(12465),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(12465),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(1901),
    [anon_sym_or] = ACTIONS(1901),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [6905] = {
    [sym_in] = STATE(9250),
    [anon_sym_in] = ACTIONS(1997),
    [sym_comment] = ACTIONS(87),
  },
  [6906] = {
    [sym_heredoc_body] = STATE(9251),
    [sym__terminator] = STATE(9251),
    [sym__line_break2] = ACTIONS(12467),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(12467),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [6907] = {
    [sym_when] = STATE(9252),
    [aux_sym_case_repeat1] = STATE(9253),
    [anon_sym_SEMI] = ACTIONS(12469),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [6908] = {
    [sym_else] = STATE(9255),
    [sym_ensure] = STATE(9256),
    [sym_rescue] = STATE(9257),
    [anon_sym_end] = ACTIONS(12471),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6909] = {
    [sym_ensure] = STATE(9256),
    [anon_sym_end] = ACTIONS(12471),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6910] = {
    [anon_sym_end] = ACTIONS(12471),
    [sym_comment] = ACTIONS(87),
  },
  [6911] = {
    [sym_else] = STATE(9255),
    [sym_ensure] = STATE(9256),
    [anon_sym_end] = ACTIONS(12471),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [6912] = {
    [sym__heredoc_body_start2] = ACTIONS(2219),
    [sym__binary_minus2] = ACTIONS(2219),
    [sym__binary_star2] = ACTIONS(2219),
    [anon_sym_LBRACE] = ACTIONS(2219),
    [anon_sym_RBRACE] = ACTIONS(2219),
    [anon_sym_RPAREN] = ACTIONS(2219),
    [anon_sym_DOT] = ACTIONS(2221),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_PIPE] = ACTIONS(2221),
    [anon_sym_SEMI] = ACTIONS(2219),
    [anon_sym_STAR_STAR] = ACTIONS(2221),
    [anon_sym_AMP] = ACTIONS(2221),
    [anon_sym_EQ] = ACTIONS(2221),
    [anon_sym_LT] = ACTIONS(2221),
    [anon_sym_if] = ACTIONS(2219),
    [anon_sym_unless] = ACTIONS(2219),
    [anon_sym_while] = ACTIONS(2219),
    [anon_sym_until] = ACTIONS(2219),
    [anon_sym_rescue] = ACTIONS(2219),
    [anon_sym_in] = ACTIONS(2219),
    [anon_sym_do] = ACTIONS(2219),
    [anon_sym_LBRACK] = ACTIONS(2219),
    [anon_sym_RBRACK] = ACTIONS(2219),
    [anon_sym_COLON_COLON2] = ACTIONS(2219),
    [anon_sym_AMP_DOT] = ACTIONS(2219),
    [anon_sym_PLUS_EQ] = ACTIONS(2219),
    [anon_sym_DASH_EQ] = ACTIONS(2219),
    [anon_sym_STAR_EQ] = ACTIONS(2219),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2219),
    [anon_sym_SLASH_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_PIPE_EQ] = ACTIONS(2219),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2219),
    [anon_sym_AMP_EQ] = ACTIONS(2219),
    [anon_sym_PERCENT_EQ] = ACTIONS(2219),
    [anon_sym_GT_GT_EQ] = ACTIONS(2219),
    [anon_sym_LT_LT_EQ] = ACTIONS(2219),
    [anon_sym_CARET_EQ] = ACTIONS(2219),
    [anon_sym_QMARK] = ACTIONS(2219),
    [anon_sym_COLON2] = ACTIONS(2221),
    [anon_sym_DOT_DOT] = ACTIONS(2221),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2219),
    [anon_sym_and] = ACTIONS(2219),
    [anon_sym_or] = ACTIONS(2219),
    [anon_sym_PIPE_PIPE] = ACTIONS(2221),
    [anon_sym_AMP_AMP] = ACTIONS(2221),
    [anon_sym_LT_LT] = ACTIONS(2221),
    [anon_sym_GT_GT] = ACTIONS(2221),
    [anon_sym_EQ_EQ] = ACTIONS(2221),
    [anon_sym_BANG_EQ] = ACTIONS(2219),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2219),
    [anon_sym_LT_EQ_GT] = ACTIONS(2219),
    [anon_sym_EQ_TILDE] = ACTIONS(2219),
    [anon_sym_BANG_TILDE] = ACTIONS(2219),
    [anon_sym_LT_EQ] = ACTIONS(2221),
    [anon_sym_GT] = ACTIONS(2221),
    [anon_sym_GT_EQ] = ACTIONS(2219),
    [anon_sym_CARET] = ACTIONS(2221),
    [anon_sym_PLUS] = ACTIONS(2221),
    [anon_sym_SLASH] = ACTIONS(2221),
    [anon_sym_PERCENT] = ACTIONS(2221),
    [sym_comment] = ACTIONS(87),
  },
  [6913] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(9258),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12473),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6914] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6915] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [6916] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(2295),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [6917] = {
    [sym__heredoc_body_start2] = ACTIONS(2307),
    [sym__binary_minus2] = ACTIONS(2307),
    [sym__binary_star2] = ACTIONS(2307),
    [anon_sym_LBRACE] = ACTIONS(2307),
    [anon_sym_RBRACE] = ACTIONS(2307),
    [anon_sym_RPAREN] = ACTIONS(2307),
    [anon_sym_DOT] = ACTIONS(2309),
    [anon_sym_COMMA] = ACTIONS(2307),
    [anon_sym_PIPE] = ACTIONS(2309),
    [anon_sym_SEMI] = ACTIONS(2307),
    [anon_sym_STAR_STAR] = ACTIONS(2309),
    [anon_sym_AMP] = ACTIONS(2309),
    [anon_sym_EQ] = ACTIONS(2309),
    [anon_sym_LT] = ACTIONS(2309),
    [anon_sym_if] = ACTIONS(2307),
    [anon_sym_unless] = ACTIONS(2307),
    [anon_sym_while] = ACTIONS(2307),
    [anon_sym_until] = ACTIONS(2307),
    [anon_sym_rescue] = ACTIONS(2307),
    [anon_sym_in] = ACTIONS(2307),
    [anon_sym_do] = ACTIONS(2307),
    [anon_sym_LBRACK] = ACTIONS(2307),
    [anon_sym_RBRACK] = ACTIONS(2307),
    [anon_sym_COLON_COLON2] = ACTIONS(2307),
    [anon_sym_AMP_DOT] = ACTIONS(2307),
    [anon_sym_PLUS_EQ] = ACTIONS(2307),
    [anon_sym_DASH_EQ] = ACTIONS(2307),
    [anon_sym_STAR_EQ] = ACTIONS(2307),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2307),
    [anon_sym_SLASH_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_PIPE_EQ] = ACTIONS(2307),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2307),
    [anon_sym_AMP_EQ] = ACTIONS(2307),
    [anon_sym_PERCENT_EQ] = ACTIONS(2307),
    [anon_sym_GT_GT_EQ] = ACTIONS(2307),
    [anon_sym_LT_LT_EQ] = ACTIONS(2307),
    [anon_sym_CARET_EQ] = ACTIONS(2307),
    [anon_sym_QMARK] = ACTIONS(2307),
    [anon_sym_COLON2] = ACTIONS(2309),
    [anon_sym_DOT_DOT] = ACTIONS(2309),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2307),
    [anon_sym_and] = ACTIONS(2307),
    [anon_sym_or] = ACTIONS(2307),
    [anon_sym_PIPE_PIPE] = ACTIONS(2309),
    [anon_sym_AMP_AMP] = ACTIONS(2309),
    [anon_sym_LT_LT] = ACTIONS(2309),
    [anon_sym_GT_GT] = ACTIONS(2309),
    [anon_sym_EQ_EQ] = ACTIONS(2309),
    [anon_sym_BANG_EQ] = ACTIONS(2307),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2307),
    [anon_sym_LT_EQ_GT] = ACTIONS(2307),
    [anon_sym_EQ_TILDE] = ACTIONS(2307),
    [anon_sym_BANG_TILDE] = ACTIONS(2307),
    [anon_sym_LT_EQ] = ACTIONS(2309),
    [anon_sym_GT] = ACTIONS(2309),
    [anon_sym_GT_EQ] = ACTIONS(2307),
    [anon_sym_CARET] = ACTIONS(2309),
    [anon_sym_PLUS] = ACTIONS(2309),
    [anon_sym_SLASH] = ACTIONS(2309),
    [anon_sym_PERCENT] = ACTIONS(2309),
    [sym_comment] = ACTIONS(87),
  },
  [6918] = {
    [sym__heredoc_body_start2] = ACTIONS(2391),
    [sym__binary_minus2] = ACTIONS(2391),
    [sym__binary_star2] = ACTIONS(2391),
    [anon_sym_LBRACE] = ACTIONS(2391),
    [anon_sym_RBRACE] = ACTIONS(2391),
    [anon_sym_RPAREN] = ACTIONS(2391),
    [anon_sym_DOT] = ACTIONS(2393),
    [anon_sym_COMMA] = ACTIONS(2391),
    [anon_sym_PIPE] = ACTIONS(2393),
    [anon_sym_SEMI] = ACTIONS(2391),
    [anon_sym_STAR_STAR] = ACTIONS(2393),
    [anon_sym_AMP] = ACTIONS(2393),
    [anon_sym_EQ] = ACTIONS(2393),
    [anon_sym_LT] = ACTIONS(2393),
    [anon_sym_if] = ACTIONS(2391),
    [anon_sym_unless] = ACTIONS(2391),
    [anon_sym_while] = ACTIONS(2391),
    [anon_sym_until] = ACTIONS(2391),
    [anon_sym_rescue] = ACTIONS(2391),
    [anon_sym_in] = ACTIONS(2391),
    [anon_sym_do] = ACTIONS(2391),
    [anon_sym_LBRACK] = ACTIONS(2391),
    [anon_sym_RBRACK] = ACTIONS(2391),
    [anon_sym_COLON_COLON2] = ACTIONS(2391),
    [anon_sym_AMP_DOT] = ACTIONS(2391),
    [anon_sym_PLUS_EQ] = ACTIONS(2391),
    [anon_sym_DASH_EQ] = ACTIONS(2391),
    [anon_sym_STAR_EQ] = ACTIONS(2391),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2391),
    [anon_sym_SLASH_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_PIPE_EQ] = ACTIONS(2391),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2391),
    [anon_sym_AMP_EQ] = ACTIONS(2391),
    [anon_sym_PERCENT_EQ] = ACTIONS(2391),
    [anon_sym_GT_GT_EQ] = ACTIONS(2391),
    [anon_sym_LT_LT_EQ] = ACTIONS(2391),
    [anon_sym_CARET_EQ] = ACTIONS(2391),
    [anon_sym_QMARK] = ACTIONS(2391),
    [anon_sym_COLON2] = ACTIONS(2393),
    [anon_sym_DOT_DOT] = ACTIONS(2393),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2391),
    [anon_sym_and] = ACTIONS(2391),
    [anon_sym_or] = ACTIONS(2391),
    [anon_sym_PIPE_PIPE] = ACTIONS(2393),
    [anon_sym_AMP_AMP] = ACTIONS(2393),
    [anon_sym_LT_LT] = ACTIONS(2393),
    [anon_sym_GT_GT] = ACTIONS(2393),
    [anon_sym_EQ_EQ] = ACTIONS(2393),
    [anon_sym_BANG_EQ] = ACTIONS(2391),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2391),
    [anon_sym_LT_EQ_GT] = ACTIONS(2391),
    [anon_sym_EQ_TILDE] = ACTIONS(2391),
    [anon_sym_BANG_TILDE] = ACTIONS(2391),
    [anon_sym_LT_EQ] = ACTIONS(2393),
    [anon_sym_GT] = ACTIONS(2393),
    [anon_sym_GT_EQ] = ACTIONS(2391),
    [anon_sym_CARET] = ACTIONS(2393),
    [anon_sym_PLUS] = ACTIONS(2393),
    [anon_sym_SLASH] = ACTIONS(2393),
    [anon_sym_PERCENT] = ACTIONS(2393),
    [sym_comment] = ACTIONS(87),
  },
  [6919] = {
    [sym_heredoc_body] = STATE(9260),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(12475),
    [sym_comment] = ACTIONS(87),
  },
  [6920] = {
    [anon_sym_RBRACK] = ACTIONS(12475),
    [sym_comment] = ACTIONS(87),
  },
  [6921] = {
    [sym_do_block] = STATE(9261),
    [sym_block] = STATE(9261),
    [anon_sym_LBRACE] = ACTIONS(6909),
    [anon_sym_do] = ACTIONS(6911),
    [sym_comment] = ACTIONS(87),
  },
  [6922] = {
    [sym__heredoc_body_start2] = ACTIONS(2537),
    [sym__binary_minus2] = ACTIONS(2537),
    [sym__binary_star2] = ACTIONS(2537),
    [anon_sym_LBRACE] = ACTIONS(2537),
    [anon_sym_RBRACE] = ACTIONS(2537),
    [anon_sym_RPAREN] = ACTIONS(2537),
    [anon_sym_DOT] = ACTIONS(2539),
    [anon_sym_COMMA] = ACTIONS(2537),
    [anon_sym_PIPE] = ACTIONS(2539),
    [anon_sym_SEMI] = ACTIONS(2537),
    [anon_sym_STAR_STAR] = ACTIONS(2539),
    [anon_sym_AMP] = ACTIONS(2539),
    [anon_sym_EQ] = ACTIONS(2539),
    [anon_sym_LT] = ACTIONS(2539),
    [anon_sym_if] = ACTIONS(2537),
    [anon_sym_unless] = ACTIONS(2537),
    [anon_sym_while] = ACTIONS(2537),
    [anon_sym_until] = ACTIONS(2537),
    [anon_sym_rescue] = ACTIONS(2537),
    [anon_sym_in] = ACTIONS(2537),
    [anon_sym_do] = ACTIONS(2537),
    [anon_sym_LBRACK] = ACTIONS(2537),
    [anon_sym_RBRACK] = ACTIONS(2537),
    [anon_sym_COLON_COLON2] = ACTIONS(2537),
    [anon_sym_AMP_DOT] = ACTIONS(2537),
    [anon_sym_PLUS_EQ] = ACTIONS(2537),
    [anon_sym_DASH_EQ] = ACTIONS(2537),
    [anon_sym_STAR_EQ] = ACTIONS(2537),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2537),
    [anon_sym_SLASH_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_PIPE_EQ] = ACTIONS(2537),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2537),
    [anon_sym_AMP_EQ] = ACTIONS(2537),
    [anon_sym_PERCENT_EQ] = ACTIONS(2537),
    [anon_sym_GT_GT_EQ] = ACTIONS(2537),
    [anon_sym_LT_LT_EQ] = ACTIONS(2537),
    [anon_sym_CARET_EQ] = ACTIONS(2537),
    [anon_sym_QMARK] = ACTIONS(2537),
    [anon_sym_COLON2] = ACTIONS(2539),
    [anon_sym_DOT_DOT] = ACTIONS(2539),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2537),
    [anon_sym_and] = ACTIONS(2537),
    [anon_sym_or] = ACTIONS(2537),
    [anon_sym_PIPE_PIPE] = ACTIONS(2539),
    [anon_sym_AMP_AMP] = ACTIONS(2539),
    [anon_sym_LT_LT] = ACTIONS(2539),
    [anon_sym_GT_GT] = ACTIONS(2539),
    [anon_sym_EQ_EQ] = ACTIONS(2539),
    [anon_sym_BANG_EQ] = ACTIONS(2537),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2537),
    [anon_sym_LT_EQ_GT] = ACTIONS(2537),
    [anon_sym_EQ_TILDE] = ACTIONS(2537),
    [anon_sym_BANG_TILDE] = ACTIONS(2537),
    [anon_sym_LT_EQ] = ACTIONS(2539),
    [anon_sym_GT] = ACTIONS(2539),
    [anon_sym_GT_EQ] = ACTIONS(2537),
    [anon_sym_CARET] = ACTIONS(2539),
    [anon_sym_PLUS] = ACTIONS(2539),
    [anon_sym_SLASH] = ACTIONS(2539),
    [anon_sym_PERCENT] = ACTIONS(2539),
    [sym_comment] = ACTIONS(87),
  },
  [6923] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9262),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9262),
    [sym_operator_assignment] = STATE(9262),
    [sym_conditional] = STATE(9262),
    [sym_range] = STATE(9262),
    [sym_binary] = STATE(9262),
    [sym_unary] = STATE(9262),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6924] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9263),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9263),
    [sym_operator_assignment] = STATE(9263),
    [sym_conditional] = STATE(9263),
    [sym_range] = STATE(9263),
    [sym_binary] = STATE(9263),
    [sym_unary] = STATE(9263),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6925] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9264),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9264),
    [sym_operator_assignment] = STATE(9264),
    [sym_conditional] = STATE(9264),
    [sym_range] = STATE(9264),
    [sym_binary] = STATE(9264),
    [sym_unary] = STATE(9264),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6926] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9265),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9265),
    [sym_operator_assignment] = STATE(9265),
    [sym_conditional] = STATE(9265),
    [sym_range] = STATE(9265),
    [sym_binary] = STATE(9265),
    [sym_unary] = STATE(9265),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6927] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9266),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9266),
    [sym_operator_assignment] = STATE(9266),
    [sym_conditional] = STATE(9266),
    [sym_range] = STATE(9266),
    [sym_binary] = STATE(9266),
    [sym_unary] = STATE(9266),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6928] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9267),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9267),
    [sym_operator_assignment] = STATE(9267),
    [sym_conditional] = STATE(9267),
    [sym_range] = STATE(9267),
    [sym_binary] = STATE(9267),
    [sym_unary] = STATE(9267),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6929] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9268),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9268),
    [sym_operator_assignment] = STATE(9268),
    [sym_conditional] = STATE(9268),
    [sym_range] = STATE(9268),
    [sym_binary] = STATE(9268),
    [sym_unary] = STATE(9268),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6930] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9269),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9269),
    [sym_operator_assignment] = STATE(9269),
    [sym_conditional] = STATE(9269),
    [sym_range] = STATE(9269),
    [sym_binary] = STATE(9269),
    [sym_unary] = STATE(9269),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6931] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9270),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9270),
    [sym_operator_assignment] = STATE(9270),
    [sym_conditional] = STATE(9270),
    [sym_range] = STATE(9270),
    [sym_binary] = STATE(9270),
    [sym_unary] = STATE(9270),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6932] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9271),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9271),
    [sym_operator_assignment] = STATE(9271),
    [sym_conditional] = STATE(9271),
    [sym_range] = STATE(9271),
    [sym_binary] = STATE(9271),
    [sym_unary] = STATE(9271),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6933] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9272),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9272),
    [sym_operator_assignment] = STATE(9272),
    [sym_conditional] = STATE(9272),
    [sym_range] = STATE(9272),
    [sym_binary] = STATE(9272),
    [sym_unary] = STATE(9272),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6934] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9273),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9273),
    [sym_operator_assignment] = STATE(9273),
    [sym_conditional] = STATE(9273),
    [sym_range] = STATE(9273),
    [sym_binary] = STATE(9273),
    [sym_unary] = STATE(9273),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6935] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9274),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_splat_argument] = STATE(9276),
    [sym_assignment] = STATE(9274),
    [sym_operator_assignment] = STATE(9274),
    [sym_conditional] = STATE(9274),
    [sym_range] = STATE(9274),
    [sym_binary] = STATE(9274),
    [sym_unary] = STATE(9274),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(9276),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6936] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9277),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(9277),
    [sym_operator_assignment] = STATE(9277),
    [sym_conditional] = STATE(9277),
    [sym_range] = STATE(9277),
    [sym_binary] = STATE(9277),
    [sym_unary] = STATE(9277),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [6937] = {
    [sym_string] = STATE(9278),
    [aux_sym_chained_string_repeat1] = STATE(9278),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [6938] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [6939] = {
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_COLON2] = ACTIONS(9488),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [6940] = {
    [anon_sym_RBRACE] = ACTIONS(12477),
    [sym_comment] = ACTIONS(87),
  },
  [6941] = {
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_COLON2] = ACTIONS(9508),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [6942] = {
    [anon_sym_end] = ACTIONS(12479),
    [sym_comment] = ACTIONS(87),
  },
  [6943] = {
    [sym__statements] = STATE(9281),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12481),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6944] = {
    [sym__statements] = STATE(9281),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9282),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9282),
    [sym__line_break2] = ACTIONS(12483),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12481),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [6945] = {
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7850),
    [anon_sym_unless] = ACTIONS(7850),
    [anon_sym_while] = ACTIONS(7850),
    [anon_sym_until] = ACTIONS(7850),
    [anon_sym_rescue] = ACTIONS(7850),
    [anon_sym_in] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [sym_comment] = ACTIONS(87),
  },
  [6946] = {
    [anon_sym_RPAREN] = ACTIONS(12485),
    [sym_comment] = ACTIONS(87),
  },
  [6947] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6948] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [6949] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6950] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [6951] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6952] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6953] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [6954] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12487),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [6955] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6956] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6957] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6958] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6959] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6960] = {
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [6961] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_STAR_STAR] = ACTIONS(4982),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_if] = ACTIONS(3158),
    [anon_sym_unless] = ACTIONS(3158),
    [anon_sym_while] = ACTIONS(3158),
    [anon_sym_until] = ACTIONS(3158),
    [anon_sym_rescue] = ACTIONS(3158),
    [anon_sym_in] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_RBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_PLUS_EQ] = ACTIONS(3158),
    [anon_sym_DASH_EQ] = ACTIONS(3158),
    [anon_sym_STAR_EQ] = ACTIONS(3158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3158),
    [anon_sym_SLASH_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_PIPE_EQ] = ACTIONS(3158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3158),
    [anon_sym_AMP_EQ] = ACTIONS(3158),
    [anon_sym_PERCENT_EQ] = ACTIONS(3158),
    [anon_sym_GT_GT_EQ] = ACTIONS(3158),
    [anon_sym_LT_LT_EQ] = ACTIONS(3158),
    [anon_sym_CARET_EQ] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_COLON2] = ACTIONS(4982),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4982),
    [anon_sym_AMP_AMP] = ACTIONS(4982),
    [anon_sym_LT_LT] = ACTIONS(4982),
    [anon_sym_GT_GT] = ACTIONS(4982),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(4982),
    [anon_sym_PLUS] = ACTIONS(4982),
    [anon_sym_SLASH] = ACTIONS(4982),
    [anon_sym_PERCENT] = ACTIONS(4982),
    [sym_comment] = ACTIONS(87),
  },
  [6962] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(12489),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [6963] = {
    [sym_heredoc_body] = STATE(6963),
    [aux_sym_call_repeat1] = STATE(6963),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [6964] = {
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [6965] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1740),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(1740),
    [sym_operator_assignment] = STATE(1740),
    [sym_conditional] = STATE(1740),
    [sym_range] = STATE(1740),
    [sym_binary] = STATE(1740),
    [sym_unary] = STATE(1740),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1748),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(2905),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__identifier_hash_key2] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10087),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2935),
    [sym_identifier] = ACTIONS(2935),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [6966] = {
    [sym_heredoc_body] = STATE(6963),
    [aux_sym_call_repeat1] = STATE(6963),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [6967] = {
    [aux_sym_argument_list_repeat1] = STATE(6967),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12494),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [6968] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6969] = {
    [aux_sym_exceptions_repeat1] = STATE(9288),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [6970] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [6971] = {
    [sym_string] = STATE(6971),
    [aux_sym_chained_string_repeat1] = STATE(6971),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [6972] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [6973] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6974] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6975] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [6976] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9289),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9289),
    [sym_operator_assignment] = STATE(9289),
    [sym_conditional] = STATE(9289),
    [sym_range] = STATE(9289),
    [sym_binary] = STATE(9289),
    [sym_unary] = STATE(9289),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6977] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9290),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9290),
    [sym_operator_assignment] = STATE(9290),
    [sym_conditional] = STATE(9290),
    [sym_range] = STATE(9290),
    [sym_binary] = STATE(9290),
    [sym_unary] = STATE(9290),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6978] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9291),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9291),
    [sym_operator_assignment] = STATE(9291),
    [sym_conditional] = STATE(9291),
    [sym_range] = STATE(9291),
    [sym_binary] = STATE(9291),
    [sym_unary] = STATE(9291),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6979] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9292),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9292),
    [sym_operator_assignment] = STATE(9292),
    [sym_conditional] = STATE(9292),
    [sym_range] = STATE(9292),
    [sym_binary] = STATE(9292),
    [sym_unary] = STATE(9292),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6980] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9293),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9293),
    [sym_operator_assignment] = STATE(9293),
    [sym_conditional] = STATE(9293),
    [sym_range] = STATE(9293),
    [sym_binary] = STATE(9293),
    [sym_unary] = STATE(9293),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6981] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9294),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9294),
    [sym_operator_assignment] = STATE(9294),
    [sym_conditional] = STATE(9294),
    [sym_range] = STATE(9294),
    [sym_binary] = STATE(9294),
    [sym_unary] = STATE(9294),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6982] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9295),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9295),
    [sym_operator_assignment] = STATE(9295),
    [sym_conditional] = STATE(9295),
    [sym_range] = STATE(9295),
    [sym_binary] = STATE(9295),
    [sym_unary] = STATE(9295),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6983] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9296),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9296),
    [sym_operator_assignment] = STATE(9296),
    [sym_conditional] = STATE(9296),
    [sym_range] = STATE(9296),
    [sym_binary] = STATE(9296),
    [sym_unary] = STATE(9296),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6984] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9297),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9297),
    [sym_operator_assignment] = STATE(9297),
    [sym_conditional] = STATE(9297),
    [sym_range] = STATE(9297),
    [sym_binary] = STATE(9297),
    [sym_unary] = STATE(9297),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6985] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9298),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9298),
    [sym_operator_assignment] = STATE(9298),
    [sym_conditional] = STATE(9298),
    [sym_range] = STATE(9298),
    [sym_binary] = STATE(9298),
    [sym_unary] = STATE(9298),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6986] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9299),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9299),
    [sym_operator_assignment] = STATE(9299),
    [sym_conditional] = STATE(9299),
    [sym_range] = STATE(9299),
    [sym_binary] = STATE(9299),
    [sym_unary] = STATE(9299),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6987] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9300),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9300),
    [sym_operator_assignment] = STATE(9300),
    [sym_conditional] = STATE(9300),
    [sym_range] = STATE(9300),
    [sym_binary] = STATE(9300),
    [sym_unary] = STATE(9300),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6988] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4142),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(4142),
    [sym_operator_assignment] = STATE(4142),
    [sym_conditional] = STATE(4142),
    [sym_range] = STATE(4142),
    [sym_binary] = STATE(4142),
    [sym_unary] = STATE(4142),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(6497),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6989] = {
    [aux_sym_exceptions_repeat1] = STATE(9301),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(10119),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [6990] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4142),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_splat_argument] = STATE(9302),
    [sym_assignment] = STATE(4142),
    [sym_operator_assignment] = STATE(4142),
    [sym_conditional] = STATE(4142),
    [sym_range] = STATE(4142),
    [sym_binary] = STATE(4142),
    [sym_unary] = STATE(4142),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(9302),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(6497),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6991] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9303),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(9303),
    [sym_operator_assignment] = STATE(9303),
    [sym_conditional] = STATE(9303),
    [sym_range] = STATE(9303),
    [sym_binary] = STATE(9303),
    [sym_unary] = STATE(9303),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [6992] = {
    [sym_string] = STATE(9304),
    [aux_sym_chained_string_repeat1] = STATE(9304),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [6993] = {
    [sym__line_break2] = ACTIONS(12497),
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [ts_builtin_sym_end] = ACTIONS(12497),
    [anon_sym___END__] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_end] = ACTIONS(12497),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_when] = ACTIONS(12497),
    [anon_sym_elsif] = ACTIONS(12497),
    [anon_sym_else] = ACTIONS(12497),
    [anon_sym_then] = ACTIONS(12497),
    [anon_sym_ensure] = ACTIONS(12497),
    [anon_sym_EQ_GT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12497),
    [anon_sym_AMP_AMP] = ACTIONS(12497),
    [anon_sym_LT_LT] = ACTIONS(12497),
    [anon_sym_GT_GT] = ACTIONS(12497),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12497),
    [anon_sym_PLUS] = ACTIONS(12497),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [6994] = {
    [sym__line_break2] = ACTIONS(12501),
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [ts_builtin_sym_end] = ACTIONS(12501),
    [anon_sym___END__] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12501),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_end] = ACTIONS(12501),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_when] = ACTIONS(12501),
    [anon_sym_elsif] = ACTIONS(12501),
    [anon_sym_else] = ACTIONS(12501),
    [anon_sym_then] = ACTIONS(12501),
    [anon_sym_ensure] = ACTIONS(12501),
    [anon_sym_EQ_GT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12501),
    [anon_sym_AMP_AMP] = ACTIONS(12501),
    [anon_sym_LT_LT] = ACTIONS(12501),
    [anon_sym_GT_GT] = ACTIONS(12501),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12501),
    [anon_sym_PLUS] = ACTIONS(12501),
    [anon_sym_SLASH] = ACTIONS(12501),
    [anon_sym_PERCENT] = ACTIONS(12501),
    [sym_comment] = ACTIONS(87),
  },
  [6995] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [6996] = {
    [sym_heredoc_body] = STATE(9305),
    [aux_sym_call_repeat1] = STATE(9305),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6997] = {
    [sym_heredoc_body] = STATE(9305),
    [aux_sym_call_repeat1] = STATE(9305),
    [aux_sym_argument_list_repeat1] = STATE(9306),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(6623),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [6998] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [6999] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [7000] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9307),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9307),
    [sym_operator_assignment] = STATE(9307),
    [sym_conditional] = STATE(9307),
    [sym_range] = STATE(9307),
    [sym_binary] = STATE(9307),
    [sym_unary] = STATE(9307),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7001] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9308),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9308),
    [sym_operator_assignment] = STATE(9308),
    [sym_conditional] = STATE(9308),
    [sym_range] = STATE(9308),
    [sym_binary] = STATE(9308),
    [sym_unary] = STATE(9308),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7002] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9309),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9309),
    [sym_operator_assignment] = STATE(9309),
    [sym_conditional] = STATE(9309),
    [sym_range] = STATE(9309),
    [sym_binary] = STATE(9309),
    [sym_unary] = STATE(9309),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7003] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9310),
    [sym_operator_assignment] = STATE(9310),
    [sym_conditional] = STATE(9310),
    [sym_range] = STATE(9310),
    [sym_binary] = STATE(9310),
    [sym_unary] = STATE(9310),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7004] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9311),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9311),
    [sym_operator_assignment] = STATE(9311),
    [sym_conditional] = STATE(9311),
    [sym_range] = STATE(9311),
    [sym_binary] = STATE(9311),
    [sym_unary] = STATE(9311),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7005] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9312),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9312),
    [sym_operator_assignment] = STATE(9312),
    [sym_conditional] = STATE(9312),
    [sym_range] = STATE(9312),
    [sym_binary] = STATE(9312),
    [sym_unary] = STATE(9312),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7006] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9313),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9313),
    [sym_operator_assignment] = STATE(9313),
    [sym_conditional] = STATE(9313),
    [sym_range] = STATE(9313),
    [sym_binary] = STATE(9313),
    [sym_unary] = STATE(9313),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7007] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9314),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9314),
    [sym_operator_assignment] = STATE(9314),
    [sym_conditional] = STATE(9314),
    [sym_range] = STATE(9314),
    [sym_binary] = STATE(9314),
    [sym_unary] = STATE(9314),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7008] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9315),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9315),
    [sym_operator_assignment] = STATE(9315),
    [sym_conditional] = STATE(9315),
    [sym_range] = STATE(9315),
    [sym_binary] = STATE(9315),
    [sym_unary] = STATE(9315),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7009] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9316),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9316),
    [sym_operator_assignment] = STATE(9316),
    [sym_conditional] = STATE(9316),
    [sym_range] = STATE(9316),
    [sym_binary] = STATE(9316),
    [sym_unary] = STATE(9316),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7010] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9317),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9317),
    [sym_operator_assignment] = STATE(9317),
    [sym_conditional] = STATE(9317),
    [sym_range] = STATE(9317),
    [sym_binary] = STATE(9317),
    [sym_unary] = STATE(9317),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7011] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9318),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9318),
    [sym_operator_assignment] = STATE(9318),
    [sym_conditional] = STATE(9318),
    [sym_range] = STATE(9318),
    [sym_binary] = STATE(9318),
    [sym_unary] = STATE(9318),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7012] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9319),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_splat_argument] = STATE(9320),
    [sym_assignment] = STATE(9319),
    [sym_operator_assignment] = STATE(9319),
    [sym_conditional] = STATE(9319),
    [sym_range] = STATE(9319),
    [sym_binary] = STATE(9319),
    [sym_unary] = STATE(9319),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(9320),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7013] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9321),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(9321),
    [sym_operator_assignment] = STATE(9321),
    [sym_conditional] = STATE(9321),
    [sym_range] = STATE(9321),
    [sym_binary] = STATE(9321),
    [sym_unary] = STATE(9321),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7014] = {
    [sym_string] = STATE(9322),
    [aux_sym_chained_string_repeat1] = STATE(9322),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [7015] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [7016] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7017] = {
    [sym_heredoc_body] = STATE(9324),
    [aux_sym_call_repeat1] = STATE(9324),
    [aux_sym_argument_list_repeat1] = STATE(9132),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9846),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7018] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7019] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7020] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7021] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7022] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7023] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7024] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [7025] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12505),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7026] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7027] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7028] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7029] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7030] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7031] = {
    [sym_heredoc_body] = STATE(7031),
    [aux_sym_call_repeat1] = STATE(7031),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7032] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(1783),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(1783),
    [sym_operator_assignment] = STATE(1783),
    [sym_conditional] = STATE(1783),
    [sym_range] = STATE(1783),
    [sym_binary] = STATE(1783),
    [sym_unary] = STATE(1783),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1788),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3024),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__identifier_hash_key2] = ACTIONS(3030),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10183),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(3048),
    [sym_identifier] = ACTIONS(3048),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7033] = {
    [sym_heredoc_body] = STATE(7031),
    [aux_sym_call_repeat1] = STATE(7031),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7034] = {
    [aux_sym_argument_list_repeat1] = STATE(7034),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12507),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7035] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7036] = {
    [aux_sym_exceptions_repeat1] = STATE(9327),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7037] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [7038] = {
    [sym_string] = STATE(7038),
    [aux_sym_chained_string_repeat1] = STATE(7038),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7039] = {
    [aux_sym_undef_repeat1] = STATE(7039),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_RBRACE] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [7040] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7041] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9328),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(9328),
    [sym_operator_assignment] = STATE(9328),
    [sym_conditional] = STATE(9328),
    [sym_range] = STATE(9328),
    [sym_binary] = STATE(9328),
    [sym_unary] = STATE(9328),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7042] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [7043] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [7044] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [7045] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9329),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9329),
    [sym_operator_assignment] = STATE(9329),
    [sym_conditional] = STATE(9329),
    [sym_range] = STATE(9329),
    [sym_binary] = STATE(9329),
    [sym_unary] = STATE(9329),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7046] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9330),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9330),
    [sym_operator_assignment] = STATE(9330),
    [sym_conditional] = STATE(9330),
    [sym_range] = STATE(9330),
    [sym_binary] = STATE(9330),
    [sym_unary] = STATE(9330),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7047] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9331),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9331),
    [sym_operator_assignment] = STATE(9331),
    [sym_conditional] = STATE(9331),
    [sym_range] = STATE(9331),
    [sym_binary] = STATE(9331),
    [sym_unary] = STATE(9331),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7048] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9332),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9332),
    [sym_operator_assignment] = STATE(9332),
    [sym_conditional] = STATE(9332),
    [sym_range] = STATE(9332),
    [sym_binary] = STATE(9332),
    [sym_unary] = STATE(9332),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7049] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9333),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9333),
    [sym_operator_assignment] = STATE(9333),
    [sym_conditional] = STATE(9333),
    [sym_range] = STATE(9333),
    [sym_binary] = STATE(9333),
    [sym_unary] = STATE(9333),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7050] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9334),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9334),
    [sym_operator_assignment] = STATE(9334),
    [sym_conditional] = STATE(9334),
    [sym_range] = STATE(9334),
    [sym_binary] = STATE(9334),
    [sym_unary] = STATE(9334),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7051] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9335),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9335),
    [sym_operator_assignment] = STATE(9335),
    [sym_conditional] = STATE(9335),
    [sym_range] = STATE(9335),
    [sym_binary] = STATE(9335),
    [sym_unary] = STATE(9335),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7052] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9336),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9336),
    [sym_operator_assignment] = STATE(9336),
    [sym_conditional] = STATE(9336),
    [sym_range] = STATE(9336),
    [sym_binary] = STATE(9336),
    [sym_unary] = STATE(9336),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7053] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9337),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9337),
    [sym_operator_assignment] = STATE(9337),
    [sym_conditional] = STATE(9337),
    [sym_range] = STATE(9337),
    [sym_binary] = STATE(9337),
    [sym_unary] = STATE(9337),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7054] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9338),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9338),
    [sym_operator_assignment] = STATE(9338),
    [sym_conditional] = STATE(9338),
    [sym_range] = STATE(9338),
    [sym_binary] = STATE(9338),
    [sym_unary] = STATE(9338),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7055] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9339),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9339),
    [sym_operator_assignment] = STATE(9339),
    [sym_conditional] = STATE(9339),
    [sym_range] = STATE(9339),
    [sym_binary] = STATE(9339),
    [sym_unary] = STATE(9339),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7056] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9340),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9340),
    [sym_operator_assignment] = STATE(9340),
    [sym_conditional] = STATE(9340),
    [sym_range] = STATE(9340),
    [sym_binary] = STATE(9340),
    [sym_unary] = STATE(9340),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7057] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9341),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_splat_argument] = STATE(9342),
    [sym_assignment] = STATE(9341),
    [sym_operator_assignment] = STATE(9341),
    [sym_conditional] = STATE(9341),
    [sym_range] = STATE(9341),
    [sym_binary] = STATE(9341),
    [sym_unary] = STATE(9341),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(9342),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7058] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9343),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(9343),
    [sym_operator_assignment] = STATE(9343),
    [sym_conditional] = STATE(9343),
    [sym_range] = STATE(9343),
    [sym_binary] = STATE(9343),
    [sym_unary] = STATE(9343),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7059] = {
    [sym_string] = STATE(9344),
    [aux_sym_chained_string_repeat1] = STATE(9344),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [7060] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [7061] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7062] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [7063] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7064] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [7065] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7066] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7067] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [7068] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12510),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7069] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7070] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7071] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7072] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7073] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7074] = {
    [sym_heredoc_body] = STATE(7074),
    [aux_sym_call_repeat1] = STATE(7074),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7075] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(1825),
    [sym_operator_assignment] = STATE(1825),
    [sym_conditional] = STATE(1825),
    [sym_range] = STATE(1825),
    [sym_binary] = STATE(1825),
    [sym_unary] = STATE(1825),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(1831),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3098),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__identifier_hash_key2] = ACTIONS(3104),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10224),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3122),
    [sym_identifier] = ACTIONS(3122),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7076] = {
    [sym_heredoc_body] = STATE(7074),
    [aux_sym_call_repeat1] = STATE(7074),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7077] = {
    [aux_sym_argument_list_repeat1] = STATE(7077),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12512),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7078] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7079] = {
    [aux_sym_exceptions_repeat1] = STATE(9347),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [7080] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [7081] = {
    [sym_string] = STATE(7081),
    [aux_sym_chained_string_repeat1] = STATE(7081),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [7082] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [7083] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7084] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7085] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [7086] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9348),
    [sym_operator_assignment] = STATE(9348),
    [sym_conditional] = STATE(9348),
    [sym_range] = STATE(9348),
    [sym_binary] = STATE(9348),
    [sym_unary] = STATE(9348),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7087] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9349),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9349),
    [sym_operator_assignment] = STATE(9349),
    [sym_conditional] = STATE(9349),
    [sym_range] = STATE(9349),
    [sym_binary] = STATE(9349),
    [sym_unary] = STATE(9349),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7088] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9350),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9350),
    [sym_operator_assignment] = STATE(9350),
    [sym_conditional] = STATE(9350),
    [sym_range] = STATE(9350),
    [sym_binary] = STATE(9350),
    [sym_unary] = STATE(9350),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7089] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9351),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9351),
    [sym_operator_assignment] = STATE(9351),
    [sym_conditional] = STATE(9351),
    [sym_range] = STATE(9351),
    [sym_binary] = STATE(9351),
    [sym_unary] = STATE(9351),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7090] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9352),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9352),
    [sym_operator_assignment] = STATE(9352),
    [sym_conditional] = STATE(9352),
    [sym_range] = STATE(9352),
    [sym_binary] = STATE(9352),
    [sym_unary] = STATE(9352),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7091] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9353),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9353),
    [sym_operator_assignment] = STATE(9353),
    [sym_conditional] = STATE(9353),
    [sym_range] = STATE(9353),
    [sym_binary] = STATE(9353),
    [sym_unary] = STATE(9353),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7092] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9354),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9354),
    [sym_operator_assignment] = STATE(9354),
    [sym_conditional] = STATE(9354),
    [sym_range] = STATE(9354),
    [sym_binary] = STATE(9354),
    [sym_unary] = STATE(9354),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7093] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9355),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9355),
    [sym_operator_assignment] = STATE(9355),
    [sym_conditional] = STATE(9355),
    [sym_range] = STATE(9355),
    [sym_binary] = STATE(9355),
    [sym_unary] = STATE(9355),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7094] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9356),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9356),
    [sym_operator_assignment] = STATE(9356),
    [sym_conditional] = STATE(9356),
    [sym_range] = STATE(9356),
    [sym_binary] = STATE(9356),
    [sym_unary] = STATE(9356),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7095] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9357),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9357),
    [sym_operator_assignment] = STATE(9357),
    [sym_conditional] = STATE(9357),
    [sym_range] = STATE(9357),
    [sym_binary] = STATE(9357),
    [sym_unary] = STATE(9357),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7096] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9358),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9358),
    [sym_operator_assignment] = STATE(9358),
    [sym_conditional] = STATE(9358),
    [sym_range] = STATE(9358),
    [sym_binary] = STATE(9358),
    [sym_unary] = STATE(9358),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7097] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9359),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9359),
    [sym_operator_assignment] = STATE(9359),
    [sym_conditional] = STATE(9359),
    [sym_range] = STATE(9359),
    [sym_binary] = STATE(9359),
    [sym_unary] = STATE(9359),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7098] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4261),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(4261),
    [sym_operator_assignment] = STATE(4261),
    [sym_conditional] = STATE(4261),
    [sym_range] = STATE(4261),
    [sym_binary] = STATE(4261),
    [sym_unary] = STATE(4261),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(6705),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7099] = {
    [aux_sym_exceptions_repeat1] = STATE(9360),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(10256),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7100] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(4261),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_splat_argument] = STATE(9361),
    [sym_assignment] = STATE(4261),
    [sym_operator_assignment] = STATE(4261),
    [sym_conditional] = STATE(4261),
    [sym_range] = STATE(4261),
    [sym_binary] = STATE(4261),
    [sym_unary] = STATE(4261),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(9361),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(6705),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7101] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9362),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(9362),
    [sym_operator_assignment] = STATE(9362),
    [sym_conditional] = STATE(9362),
    [sym_range] = STATE(9362),
    [sym_binary] = STATE(9362),
    [sym_unary] = STATE(9362),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7102] = {
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10127),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_EQ_GT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_COLON2] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10127),
    [anon_sym_AMP_AMP] = ACTIONS(10127),
    [anon_sym_LT_LT] = ACTIONS(10127),
    [anon_sym_GT_GT] = ACTIONS(10127),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10127),
    [anon_sym_PLUS] = ACTIONS(10127),
    [anon_sym_SLASH] = ACTIONS(10127),
    [anon_sym_PERCENT] = ACTIONS(10127),
    [sym_comment] = ACTIONS(87),
  },
  [7103] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12515),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7104] = {
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10133),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_EQ_GT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_COLON2] = ACTIONS(10135),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10133),
    [anon_sym_AMP_AMP] = ACTIONS(10133),
    [anon_sym_LT_LT] = ACTIONS(10133),
    [anon_sym_GT_GT] = ACTIONS(10133),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10133),
    [anon_sym_PLUS] = ACTIONS(10133),
    [anon_sym_SLASH] = ACTIONS(10133),
    [anon_sym_PERCENT] = ACTIONS(10133),
    [sym_comment] = ACTIONS(87),
  },
  [7105] = {
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10137),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_EQ_GT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_COLON2] = ACTIONS(10139),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10137),
    [anon_sym_AMP_AMP] = ACTIONS(10137),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10137),
    [anon_sym_PLUS] = ACTIONS(10137),
    [anon_sym_SLASH] = ACTIONS(10137),
    [anon_sym_PERCENT] = ACTIONS(10137),
    [sym_comment] = ACTIONS(87),
  },
  [7106] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12517),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7107] = {
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10143),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_EQ_GT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_COLON2] = ACTIONS(10145),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10143),
    [anon_sym_AMP_AMP] = ACTIONS(10143),
    [anon_sym_LT_LT] = ACTIONS(10143),
    [anon_sym_GT_GT] = ACTIONS(10143),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10143),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10143),
    [anon_sym_PERCENT] = ACTIONS(10143),
    [sym_comment] = ACTIONS(87),
  },
  [7108] = {
    [sym__method_rest] = STATE(9365),
    [sym_operator] = STATE(539),
    [sym__method_name] = STATE(539),
    [sym_setter] = STATE(539),
    [sym_symbol] = STATE(539),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(6755),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(6755),
    [sym_class_variable] = ACTIONS(6755),
    [sym_global_variable] = ACTIONS(6755),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7109] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7110] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7111] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [7112] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9366),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9366),
    [sym_operator_assignment] = STATE(9366),
    [sym_conditional] = STATE(9366),
    [sym_range] = STATE(9366),
    [sym_binary] = STATE(9366),
    [sym_unary] = STATE(9366),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7113] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9367),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9367),
    [sym_operator_assignment] = STATE(9367),
    [sym_conditional] = STATE(9367),
    [sym_range] = STATE(9367),
    [sym_binary] = STATE(9367),
    [sym_unary] = STATE(9367),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7114] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9368),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9368),
    [sym_operator_assignment] = STATE(9368),
    [sym_conditional] = STATE(9368),
    [sym_range] = STATE(9368),
    [sym_binary] = STATE(9368),
    [sym_unary] = STATE(9368),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7115] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9369),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9369),
    [sym_operator_assignment] = STATE(9369),
    [sym_conditional] = STATE(9369),
    [sym_range] = STATE(9369),
    [sym_binary] = STATE(9369),
    [sym_unary] = STATE(9369),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7116] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9370),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9370),
    [sym_operator_assignment] = STATE(9370),
    [sym_conditional] = STATE(9370),
    [sym_range] = STATE(9370),
    [sym_binary] = STATE(9370),
    [sym_unary] = STATE(9370),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7117] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9371),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9371),
    [sym_operator_assignment] = STATE(9371),
    [sym_conditional] = STATE(9371),
    [sym_range] = STATE(9371),
    [sym_binary] = STATE(9371),
    [sym_unary] = STATE(9371),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7118] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9372),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9372),
    [sym_operator_assignment] = STATE(9372),
    [sym_conditional] = STATE(9372),
    [sym_range] = STATE(9372),
    [sym_binary] = STATE(9372),
    [sym_unary] = STATE(9372),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7119] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9373),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9373),
    [sym_operator_assignment] = STATE(9373),
    [sym_conditional] = STATE(9373),
    [sym_range] = STATE(9373),
    [sym_binary] = STATE(9373),
    [sym_unary] = STATE(9373),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7120] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9374),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9374),
    [sym_operator_assignment] = STATE(9374),
    [sym_conditional] = STATE(9374),
    [sym_range] = STATE(9374),
    [sym_binary] = STATE(9374),
    [sym_unary] = STATE(9374),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7121] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9375),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9375),
    [sym_operator_assignment] = STATE(9375),
    [sym_conditional] = STATE(9375),
    [sym_range] = STATE(9375),
    [sym_binary] = STATE(9375),
    [sym_unary] = STATE(9375),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7122] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9376),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9376),
    [sym_operator_assignment] = STATE(9376),
    [sym_conditional] = STATE(9376),
    [sym_range] = STATE(9376),
    [sym_binary] = STATE(9376),
    [sym_unary] = STATE(9376),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7123] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9377),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9377),
    [sym_operator_assignment] = STATE(9377),
    [sym_conditional] = STATE(9377),
    [sym_range] = STATE(9377),
    [sym_binary] = STATE(9377),
    [sym_unary] = STATE(9377),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7124] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9378),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_splat_argument] = STATE(9379),
    [sym_assignment] = STATE(9378),
    [sym_operator_assignment] = STATE(9378),
    [sym_conditional] = STATE(9378),
    [sym_range] = STATE(9378),
    [sym_binary] = STATE(9378),
    [sym_unary] = STATE(9378),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(9379),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7125] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9380),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(9380),
    [sym_operator_assignment] = STATE(9380),
    [sym_conditional] = STATE(9380),
    [sym_range] = STATE(9380),
    [sym_binary] = STATE(9380),
    [sym_unary] = STATE(9380),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7126] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [7127] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7128] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7129] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9381),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(9381),
    [sym_operator_assignment] = STATE(9381),
    [sym_conditional] = STATE(9381),
    [sym_range] = STATE(9381),
    [sym_binary] = STATE(9381),
    [sym_unary] = STATE(9381),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7130] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7131] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9382),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(9382),
    [sym_operator_assignment] = STATE(9382),
    [sym_conditional] = STATE(9382),
    [sym_range] = STATE(9382),
    [sym_binary] = STATE(9382),
    [sym_unary] = STATE(9382),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7132] = {
    [sym_heredoc_body] = STATE(9383),
    [aux_sym_call_repeat1] = STATE(9383),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7133] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9384),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12519),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7134] = {
    [sym_heredoc_body] = STATE(9385),
    [aux_sym_call_repeat1] = STATE(9385),
    [aux_sym_argument_list_repeat1] = STATE(9386),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10318),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7135] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7136] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7137] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7138] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7139] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7140] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7141] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [7142] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12521),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7143] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7144] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7145] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7146] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7147] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7148] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7149] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7150] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9388),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(9388),
    [sym_operator_assignment] = STATE(9388),
    [sym_conditional] = STATE(9388),
    [sym_range] = STATE(9388),
    [sym_binary] = STATE(9388),
    [sym_unary] = STATE(9388),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7151] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7152] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9389),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(9389),
    [sym_operator_assignment] = STATE(9389),
    [sym_conditional] = STATE(9389),
    [sym_range] = STATE(9389),
    [sym_binary] = STATE(9389),
    [sym_unary] = STATE(9389),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7153] = {
    [sym_heredoc_body] = STATE(9390),
    [aux_sym_call_repeat1] = STATE(9390),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7154] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(9391),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12523),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7155] = {
    [sym_heredoc_body] = STATE(9392),
    [aux_sym_call_repeat1] = STATE(9392),
    [aux_sym_argument_list_repeat1] = STATE(9393),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10326),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7156] = {
    [sym_heredoc_body] = STATE(7156),
    [aux_sym_call_repeat1] = STATE(7156),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7157] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1876),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(1876),
    [sym_operator_assignment] = STATE(1876),
    [sym_conditional] = STATE(1876),
    [sym_range] = STATE(1876),
    [sym_binary] = STATE(1876),
    [sym_unary] = STATE(1876),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1882),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3174),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__identifier_hash_key2] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10330),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3198),
    [sym_identifier] = ACTIONS(3198),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7158] = {
    [sym_heredoc_body] = STATE(7156),
    [aux_sym_call_repeat1] = STATE(7156),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7159] = {
    [aux_sym_argument_list_repeat1] = STATE(7159),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12525),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7160] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7161] = {
    [aux_sym_exceptions_repeat1] = STATE(9395),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7162] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [7163] = {
    [sym_string] = STATE(7163),
    [aux_sym_chained_string_repeat1] = STATE(7163),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7164] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9396),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_assignment] = STATE(9396),
    [sym_operator_assignment] = STATE(9396),
    [sym_conditional] = STATE(9396),
    [sym_range] = STATE(9396),
    [sym_binary] = STATE(9396),
    [sym_unary] = STATE(9396),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7165] = {
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4244),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_rescue] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_in] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_RBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS_EQ] = ACTIONS(4242),
    [anon_sym_DASH_EQ] = ACTIONS(4242),
    [anon_sym_STAR_EQ] = ACTIONS(4242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4242),
    [anon_sym_SLASH_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_PIPE_EQ] = ACTIONS(4242),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4242),
    [anon_sym_AMP_EQ] = ACTIONS(4242),
    [anon_sym_PERCENT_EQ] = ACTIONS(4242),
    [anon_sym_GT_GT_EQ] = ACTIONS(4242),
    [anon_sym_LT_LT_EQ] = ACTIONS(4242),
    [anon_sym_CARET_EQ] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4244),
    [anon_sym_COLON2] = ACTIONS(4244),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4244),
    [anon_sym_or] = ACTIONS(4244),
    [anon_sym_PIPE_PIPE] = ACTIONS(4244),
    [anon_sym_AMP_AMP] = ACTIONS(4244),
    [anon_sym_LT_LT] = ACTIONS(4244),
    [anon_sym_GT_GT] = ACTIONS(4244),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4244),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_SLASH] = ACTIONS(4244),
    [anon_sym_PERCENT] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [7166] = {
    [sym_heredoc_body] = STATE(9398),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12528),
    [sym_comment] = ACTIONS(87),
  },
  [7167] = {
    [anon_sym_RPAREN] = ACTIONS(12528),
    [sym_comment] = ACTIONS(87),
  },
  [7168] = {
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym__heredoc_body_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__binary_minus2] = ACTIONS(9751),
    [sym__binary_star2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_RBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_RPAREN] = ACTIONS(9751),
    [anon_sym_DOT] = ACTIONS(9753),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_COMMA] = ACTIONS(9751),
    [anon_sym_PIPE] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9753),
    [anon_sym_AMP] = ACTIONS(9753),
    [anon_sym_EQ] = ACTIONS(9753),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_LT] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_rescue] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_in] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_RBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS_EQ] = ACTIONS(9751),
    [anon_sym_DASH_EQ] = ACTIONS(9751),
    [anon_sym_STAR_EQ] = ACTIONS(9751),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9751),
    [anon_sym_SLASH_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_PIPE_EQ] = ACTIONS(9751),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9751),
    [anon_sym_AMP_EQ] = ACTIONS(9751),
    [anon_sym_PERCENT_EQ] = ACTIONS(9751),
    [anon_sym_GT_GT_EQ] = ACTIONS(9751),
    [anon_sym_LT_LT_EQ] = ACTIONS(9751),
    [anon_sym_CARET_EQ] = ACTIONS(9751),
    [anon_sym_QMARK] = ACTIONS(9753),
    [anon_sym_COLON2] = ACTIONS(9753),
    [anon_sym_DOT_DOT] = ACTIONS(9753),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9751),
    [anon_sym_and] = ACTIONS(9753),
    [anon_sym_or] = ACTIONS(9753),
    [anon_sym_PIPE_PIPE] = ACTIONS(9753),
    [anon_sym_AMP_AMP] = ACTIONS(9753),
    [anon_sym_LT_LT] = ACTIONS(9753),
    [anon_sym_GT_GT] = ACTIONS(9753),
    [anon_sym_EQ_EQ] = ACTIONS(9753),
    [anon_sym_BANG_EQ] = ACTIONS(9751),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9751),
    [anon_sym_LT_EQ_GT] = ACTIONS(9751),
    [anon_sym_EQ_TILDE] = ACTIONS(9751),
    [anon_sym_BANG_TILDE] = ACTIONS(9751),
    [anon_sym_LT_EQ] = ACTIONS(9753),
    [anon_sym_GT] = ACTIONS(9753),
    [anon_sym_GT_EQ] = ACTIONS(9751),
    [anon_sym_CARET] = ACTIONS(9753),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_SLASH] = ACTIONS(9753),
    [anon_sym_PERCENT] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9753),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [7169] = {
    [sym__heredoc_body_start2] = ACTIONS(9758),
    [sym__binary_minus2] = ACTIONS(9758),
    [sym__binary_star2] = ACTIONS(9758),
    [anon_sym_LBRACE] = ACTIONS(9758),
    [anon_sym_RBRACE] = ACTIONS(9758),
    [anon_sym_RPAREN] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9760),
    [anon_sym_COMMA] = ACTIONS(9758),
    [anon_sym_PIPE] = ACTIONS(9760),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_STAR_STAR] = ACTIONS(9760),
    [anon_sym_AMP] = ACTIONS(9760),
    [anon_sym_EQ] = ACTIONS(9760),
    [anon_sym_LT] = ACTIONS(9760),
    [anon_sym_if] = ACTIONS(9758),
    [anon_sym_unless] = ACTIONS(9758),
    [anon_sym_while] = ACTIONS(9758),
    [anon_sym_until] = ACTIONS(9758),
    [anon_sym_rescue] = ACTIONS(9758),
    [anon_sym_in] = ACTIONS(9758),
    [anon_sym_do] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_RBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [anon_sym_PLUS_EQ] = ACTIONS(9758),
    [anon_sym_DASH_EQ] = ACTIONS(9758),
    [anon_sym_STAR_EQ] = ACTIONS(9758),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9758),
    [anon_sym_SLASH_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_PIPE_EQ] = ACTIONS(9758),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9758),
    [anon_sym_AMP_EQ] = ACTIONS(9758),
    [anon_sym_PERCENT_EQ] = ACTIONS(9758),
    [anon_sym_GT_GT_EQ] = ACTIONS(9758),
    [anon_sym_LT_LT_EQ] = ACTIONS(9758),
    [anon_sym_CARET_EQ] = ACTIONS(9758),
    [anon_sym_QMARK] = ACTIONS(9758),
    [anon_sym_COLON2] = ACTIONS(9760),
    [anon_sym_DOT_DOT] = ACTIONS(9760),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9758),
    [anon_sym_and] = ACTIONS(9758),
    [anon_sym_or] = ACTIONS(9758),
    [anon_sym_PIPE_PIPE] = ACTIONS(9760),
    [anon_sym_AMP_AMP] = ACTIONS(9760),
    [anon_sym_LT_LT] = ACTIONS(9760),
    [anon_sym_GT_GT] = ACTIONS(9760),
    [anon_sym_EQ_EQ] = ACTIONS(9760),
    [anon_sym_BANG_EQ] = ACTIONS(9758),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9758),
    [anon_sym_LT_EQ_GT] = ACTIONS(9758),
    [anon_sym_EQ_TILDE] = ACTIONS(9758),
    [anon_sym_BANG_TILDE] = ACTIONS(9758),
    [anon_sym_LT_EQ] = ACTIONS(9760),
    [anon_sym_GT] = ACTIONS(9760),
    [anon_sym_GT_EQ] = ACTIONS(9758),
    [anon_sym_CARET] = ACTIONS(9760),
    [anon_sym_PLUS] = ACTIONS(9760),
    [anon_sym_SLASH] = ACTIONS(9760),
    [anon_sym_PERCENT] = ACTIONS(9760),
    [sym_comment] = ACTIONS(87),
  },
  [7170] = {
    [anon_sym_RBRACK] = ACTIONS(12530),
    [sym_comment] = ACTIONS(87),
  },
  [7171] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [7172] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [7173] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [7174] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9400),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9400),
    [sym_operator_assignment] = STATE(9400),
    [sym_conditional] = STATE(9400),
    [sym_range] = STATE(9400),
    [sym_binary] = STATE(9400),
    [sym_unary] = STATE(9400),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7175] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9401),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9401),
    [sym_operator_assignment] = STATE(9401),
    [sym_conditional] = STATE(9401),
    [sym_range] = STATE(9401),
    [sym_binary] = STATE(9401),
    [sym_unary] = STATE(9401),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7176] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9402),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9402),
    [sym_operator_assignment] = STATE(9402),
    [sym_conditional] = STATE(9402),
    [sym_range] = STATE(9402),
    [sym_binary] = STATE(9402),
    [sym_unary] = STATE(9402),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7177] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9403),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9403),
    [sym_operator_assignment] = STATE(9403),
    [sym_conditional] = STATE(9403),
    [sym_range] = STATE(9403),
    [sym_binary] = STATE(9403),
    [sym_unary] = STATE(9403),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7178] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9404),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9404),
    [sym_operator_assignment] = STATE(9404),
    [sym_conditional] = STATE(9404),
    [sym_range] = STATE(9404),
    [sym_binary] = STATE(9404),
    [sym_unary] = STATE(9404),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7179] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9405),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9405),
    [sym_operator_assignment] = STATE(9405),
    [sym_conditional] = STATE(9405),
    [sym_range] = STATE(9405),
    [sym_binary] = STATE(9405),
    [sym_unary] = STATE(9405),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7180] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9406),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9406),
    [sym_operator_assignment] = STATE(9406),
    [sym_conditional] = STATE(9406),
    [sym_range] = STATE(9406),
    [sym_binary] = STATE(9406),
    [sym_unary] = STATE(9406),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7181] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9407),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9407),
    [sym_operator_assignment] = STATE(9407),
    [sym_conditional] = STATE(9407),
    [sym_range] = STATE(9407),
    [sym_binary] = STATE(9407),
    [sym_unary] = STATE(9407),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7182] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9408),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9408),
    [sym_operator_assignment] = STATE(9408),
    [sym_conditional] = STATE(9408),
    [sym_range] = STATE(9408),
    [sym_binary] = STATE(9408),
    [sym_unary] = STATE(9408),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7183] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9409),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9409),
    [sym_operator_assignment] = STATE(9409),
    [sym_conditional] = STATE(9409),
    [sym_range] = STATE(9409),
    [sym_binary] = STATE(9409),
    [sym_unary] = STATE(9409),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7184] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9410),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9410),
    [sym_operator_assignment] = STATE(9410),
    [sym_conditional] = STATE(9410),
    [sym_range] = STATE(9410),
    [sym_binary] = STATE(9410),
    [sym_unary] = STATE(9410),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7185] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9411),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9411),
    [sym_operator_assignment] = STATE(9411),
    [sym_conditional] = STATE(9411),
    [sym_range] = STATE(9411),
    [sym_binary] = STATE(9411),
    [sym_unary] = STATE(9411),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7186] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9412),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_splat_argument] = STATE(9413),
    [sym_assignment] = STATE(9412),
    [sym_operator_assignment] = STATE(9412),
    [sym_conditional] = STATE(9412),
    [sym_range] = STATE(9412),
    [sym_binary] = STATE(9412),
    [sym_unary] = STATE(9412),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(9413),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7187] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9414),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(9414),
    [sym_operator_assignment] = STATE(9414),
    [sym_conditional] = STATE(9414),
    [sym_range] = STATE(9414),
    [sym_binary] = STATE(9414),
    [sym_unary] = STATE(9414),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7188] = {
    [sym_string] = STATE(9415),
    [aux_sym_chained_string_repeat1] = STATE(9415),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [7189] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [7190] = {
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_STAR_STAR] = ACTIONS(9488),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_if] = ACTIONS(9486),
    [anon_sym_unless] = ACTIONS(9486),
    [anon_sym_while] = ACTIONS(9486),
    [anon_sym_until] = ACTIONS(9486),
    [anon_sym_rescue] = ACTIONS(9486),
    [anon_sym_in] = ACTIONS(9486),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_RBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_PLUS_EQ] = ACTIONS(9486),
    [anon_sym_DASH_EQ] = ACTIONS(9486),
    [anon_sym_STAR_EQ] = ACTIONS(9486),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9486),
    [anon_sym_SLASH_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_PIPE_EQ] = ACTIONS(9486),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9486),
    [anon_sym_AMP_EQ] = ACTIONS(9486),
    [anon_sym_PERCENT_EQ] = ACTIONS(9486),
    [anon_sym_GT_GT_EQ] = ACTIONS(9486),
    [anon_sym_LT_LT_EQ] = ACTIONS(9486),
    [anon_sym_CARET_EQ] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_COLON2] = ACTIONS(9488),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9488),
    [anon_sym_AMP_AMP] = ACTIONS(9488),
    [anon_sym_LT_LT] = ACTIONS(9488),
    [anon_sym_GT_GT] = ACTIONS(9488),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9488),
    [anon_sym_PLUS] = ACTIONS(9488),
    [anon_sym_SLASH] = ACTIONS(9488),
    [anon_sym_PERCENT] = ACTIONS(9488),
    [sym_comment] = ACTIONS(87),
  },
  [7191] = {
    [anon_sym_RBRACE] = ACTIONS(12532),
    [sym_comment] = ACTIONS(87),
  },
  [7192] = {
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_STAR_STAR] = ACTIONS(9508),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_if] = ACTIONS(9506),
    [anon_sym_unless] = ACTIONS(9506),
    [anon_sym_while] = ACTIONS(9506),
    [anon_sym_until] = ACTIONS(9506),
    [anon_sym_rescue] = ACTIONS(9506),
    [anon_sym_in] = ACTIONS(9506),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_RBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_PLUS_EQ] = ACTIONS(9506),
    [anon_sym_DASH_EQ] = ACTIONS(9506),
    [anon_sym_STAR_EQ] = ACTIONS(9506),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9506),
    [anon_sym_SLASH_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_PIPE_EQ] = ACTIONS(9506),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9506),
    [anon_sym_AMP_EQ] = ACTIONS(9506),
    [anon_sym_PERCENT_EQ] = ACTIONS(9506),
    [anon_sym_GT_GT_EQ] = ACTIONS(9506),
    [anon_sym_LT_LT_EQ] = ACTIONS(9506),
    [anon_sym_CARET_EQ] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_COLON2] = ACTIONS(9508),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9508),
    [anon_sym_AMP_AMP] = ACTIONS(9508),
    [anon_sym_LT_LT] = ACTIONS(9508),
    [anon_sym_GT_GT] = ACTIONS(9508),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9508),
    [anon_sym_PLUS] = ACTIONS(9508),
    [anon_sym_SLASH] = ACTIONS(9508),
    [anon_sym_PERCENT] = ACTIONS(9508),
    [sym_comment] = ACTIONS(87),
  },
  [7193] = {
    [anon_sym_end] = ACTIONS(12534),
    [sym_comment] = ACTIONS(87),
  },
  [7194] = {
    [sym__statements] = STATE(9418),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12536),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7195] = {
    [sym__statements] = STATE(9418),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9419),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9419),
    [sym__line_break2] = ACTIONS(12538),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12536),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7196] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7197] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [7198] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7199] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [7200] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7201] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7202] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [7203] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12540),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7204] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7205] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7206] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7207] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7208] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7209] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [7210] = {
    [sym_heredoc_body] = STATE(7210),
    [aux_sym_call_repeat1] = STATE(7210),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7211] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(1915),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(1915),
    [sym_operator_assignment] = STATE(1915),
    [sym_conditional] = STATE(1915),
    [sym_range] = STATE(1915),
    [sym_binary] = STATE(1915),
    [sym_unary] = STATE(1915),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(1923),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3246),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__identifier_hash_key2] = ACTIONS(3252),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10384),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3274),
    [sym_identifier] = ACTIONS(3274),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7212] = {
    [sym_heredoc_body] = STATE(7210),
    [aux_sym_call_repeat1] = STATE(7210),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7213] = {
    [aux_sym_argument_list_repeat1] = STATE(7213),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12542),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7214] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7215] = {
    [aux_sym_exceptions_repeat1] = STATE(9422),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [7216] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [7217] = {
    [sym_string] = STATE(7217),
    [aux_sym_chained_string_repeat1] = STATE(7217),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [7218] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [7219] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(4405),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(559),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(559),
    [sym_splat_argument] = STATE(8905),
    [sym_assignment] = STATE(4405),
    [sym_operator_assignment] = STATE(4405),
    [sym_conditional] = STATE(4405),
    [sym_range] = STATE(4405),
    [sym_binary] = STATE(4405),
    [sym_unary] = STATE(4405),
    [sym__arg_or_splat_arg] = STATE(8905),
    [sym_left_assignment_list] = STATE(558),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(559),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(559),
    [sym_false] = STATE(559),
    [sym_nil] = STATE(559),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(6923),
    [sym__unary_minus2] = ACTIONS(1011),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1025),
    [anon_sym_defined_QMARK] = ACTIONS(1027),
    [anon_sym_not] = ACTIONS(1029),
    [anon_sym_BANG] = ACTIONS(1031),
    [anon_sym_TILDE] = ACTIONS(1031),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7220] = {
    [aux_sym_exceptions_repeat1] = STATE(9423),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12545),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7221] = {
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10896),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_EQ_GT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_COLON2] = ACTIONS(10898),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10896),
    [anon_sym_AMP_AMP] = ACTIONS(10896),
    [anon_sym_LT_LT] = ACTIONS(10896),
    [anon_sym_GT_GT] = ACTIONS(10896),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10896),
    [anon_sym_SLASH] = ACTIONS(10896),
    [anon_sym_PERCENT] = ACTIONS(10896),
    [sym_comment] = ACTIONS(87),
  },
  [7222] = {
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10900),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_EQ_GT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_COLON2] = ACTIONS(10902),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10900),
    [anon_sym_AMP_AMP] = ACTIONS(10900),
    [anon_sym_LT_LT] = ACTIONS(10900),
    [anon_sym_GT_GT] = ACTIONS(10900),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10900),
    [anon_sym_PLUS] = ACTIONS(10900),
    [anon_sym_SLASH] = ACTIONS(10900),
    [anon_sym_PERCENT] = ACTIONS(10900),
    [sym_comment] = ACTIONS(87),
  },
  [7223] = {
    [sym_heredoc_body] = STATE(7223),
    [aux_sym_call_repeat1] = STATE(7223),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7224] = {
    [sym_heredoc_body] = STATE(7223),
    [aux_sym_call_repeat1] = STATE(7223),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7225] = {
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10934),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_in] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_RBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10934),
    [anon_sym_AMP_AMP] = ACTIONS(10934),
    [anon_sym_LT_LT] = ACTIONS(10934),
    [anon_sym_GT_GT] = ACTIONS(10934),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10934),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_SLASH] = ACTIONS(10934),
    [anon_sym_PERCENT] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
  },
  [7226] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9424),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_assignment] = STATE(9424),
    [sym_operator_assignment] = STATE(9424),
    [sym_conditional] = STATE(9424),
    [sym_range] = STATE(9424),
    [sym_binary] = STATE(9424),
    [sym_unary] = STATE(9424),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7227] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COLON2] = ACTIONS(8705),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_SLASH] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [7228] = {
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_in] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_RBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10964),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [7229] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4438),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(4438),
    [sym_operator_assignment] = STATE(4438),
    [sym_conditional] = STATE(4438),
    [sym_range] = STATE(4438),
    [sym_binary] = STATE(4438),
    [sym_unary] = STATE(4438),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1933),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(1051),
    [sym__unary_minus2] = ACTIONS(1053),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(1083),
    [sym_identifier] = ACTIONS(1083),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7230] = {
    [aux_sym_exceptions_repeat1] = STATE(9426),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12547),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7231] = {
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11061),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_EQ_GT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_COLON2] = ACTIONS(11063),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11061),
    [anon_sym_AMP_AMP] = ACTIONS(11061),
    [anon_sym_LT_LT] = ACTIONS(11061),
    [anon_sym_GT_GT] = ACTIONS(11061),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11061),
    [anon_sym_PLUS] = ACTIONS(11061),
    [anon_sym_SLASH] = ACTIONS(11061),
    [anon_sym_PERCENT] = ACTIONS(11061),
    [sym_comment] = ACTIONS(87),
  },
  [7232] = {
    [anon_sym_end] = ACTIONS(12549),
    [sym_comment] = ACTIONS(87),
  },
  [7233] = {
    [sym_elsif] = STATE(9428),
    [sym_else] = STATE(9428),
    [sym__if_tail] = STATE(9428),
    [anon_sym_end] = ACTIONS(12549),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [7234] = {
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11236),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_EQ_GT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_COLON2] = ACTIONS(11238),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11236),
    [anon_sym_AMP_AMP] = ACTIONS(11236),
    [anon_sym_LT_LT] = ACTIONS(11236),
    [anon_sym_GT_GT] = ACTIONS(11236),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11236),
    [anon_sym_PLUS] = ACTIONS(11236),
    [anon_sym_SLASH] = ACTIONS(11236),
    [anon_sym_PERCENT] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [7235] = {
    [anon_sym_end] = ACTIONS(12551),
    [sym_comment] = ACTIONS(87),
  },
  [7236] = {
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11333),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_EQ_GT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11333),
    [anon_sym_AMP_AMP] = ACTIONS(11333),
    [anon_sym_LT_LT] = ACTIONS(11333),
    [anon_sym_GT_GT] = ACTIONS(11333),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11333),
    [anon_sym_PLUS] = ACTIONS(11333),
    [anon_sym_SLASH] = ACTIONS(11333),
    [anon_sym_PERCENT] = ACTIONS(11333),
    [sym_comment] = ACTIONS(87),
  },
  [7237] = {
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11342),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_EQ_GT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_COLON2] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11342),
    [anon_sym_AMP_AMP] = ACTIONS(11342),
    [anon_sym_LT_LT] = ACTIONS(11342),
    [anon_sym_GT_GT] = ACTIONS(11342),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11342),
    [anon_sym_PLUS] = ACTIONS(11342),
    [anon_sym_SLASH] = ACTIONS(11342),
    [anon_sym_PERCENT] = ACTIONS(11342),
    [sym_comment] = ACTIONS(87),
  },
  [7238] = {
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_EQ_GT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_COLON2] = ACTIONS(11395),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [7239] = {
    [anon_sym_end] = ACTIONS(12553),
    [sym_comment] = ACTIONS(87),
  },
  [7240] = {
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_EQ_GT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_COLON2] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [7241] = {
    [anon_sym_end] = ACTIONS(12555),
    [sym_comment] = ACTIONS(87),
  },
  [7242] = {
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11878),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_EQ_GT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_COLON2] = ACTIONS(11880),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11878),
    [anon_sym_AMP_AMP] = ACTIONS(11878),
    [anon_sym_LT_LT] = ACTIONS(11878),
    [anon_sym_GT_GT] = ACTIONS(11878),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11878),
    [anon_sym_PLUS] = ACTIONS(11878),
    [anon_sym_SLASH] = ACTIONS(11878),
    [anon_sym_PERCENT] = ACTIONS(11878),
    [sym_comment] = ACTIONS(87),
  },
  [7243] = {
    [anon_sym_end] = ACTIONS(12557),
    [sym_comment] = ACTIONS(87),
  },
  [7244] = {
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_COLON2] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [7245] = {
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12096),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12098),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12096),
    [anon_sym_AMP_AMP] = ACTIONS(12096),
    [anon_sym_LT_LT] = ACTIONS(12096),
    [anon_sym_GT_GT] = ACTIONS(12096),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12096),
    [anon_sym_PLUS] = ACTIONS(12096),
    [anon_sym_SLASH] = ACTIONS(12096),
    [anon_sym_PERCENT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [7246] = {
    [anon_sym_end] = ACTIONS(12559),
    [sym_comment] = ACTIONS(87),
  },
  [7247] = {
    [sym__statements] = STATE(9434),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12561),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7248] = {
    [sym__binary_minus2] = ACTIONS(1107),
    [sym__binary_star2] = ACTIONS(1109),
    [anon_sym_PIPE] = ACTIONS(1111),
    [anon_sym_STAR_STAR] = ACTIONS(1113),
    [anon_sym_AMP] = ACTIONS(1115),
    [anon_sym_LT] = ACTIONS(1117),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(1121),
    [anon_sym_DOT_DOT] = ACTIONS(1123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1125),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1129),
    [anon_sym_AMP_AMP] = ACTIONS(1129),
    [anon_sym_LT_LT] = ACTIONS(1131),
    [anon_sym_GT_GT] = ACTIONS(1131),
    [anon_sym_EQ_EQ] = ACTIONS(1133),
    [anon_sym_BANG_EQ] = ACTIONS(1129),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1129),
    [anon_sym_LT_EQ_GT] = ACTIONS(1129),
    [anon_sym_EQ_TILDE] = ACTIONS(1129),
    [anon_sym_BANG_TILDE] = ACTIONS(1129),
    [anon_sym_LT_EQ] = ACTIONS(1117),
    [anon_sym_GT] = ACTIONS(1117),
    [anon_sym_GT_EQ] = ACTIONS(1135),
    [anon_sym_CARET] = ACTIONS(1137),
    [anon_sym_PLUS] = ACTIONS(1139),
    [anon_sym_SLASH] = ACTIONS(1113),
    [anon_sym_PERCENT] = ACTIONS(1113),
    [sym_comment] = ACTIONS(87),
  },
  [7249] = {
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [7250] = {
    [anon_sym_RPAREN] = ACTIONS(12563),
    [sym_comment] = ACTIONS(87),
  },
  [7251] = {
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_EQ_GT] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [7252] = {
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6519),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_in] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_EQ_GT] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_RBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_PLUS_EQ] = ACTIONS(6517),
    [anon_sym_DASH_EQ] = ACTIONS(6517),
    [anon_sym_STAR_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6517),
    [anon_sym_SLASH_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6517),
    [anon_sym_AMP_EQ] = ACTIONS(6517),
    [anon_sym_PERCENT_EQ] = ACTIONS(6517),
    [anon_sym_GT_GT_EQ] = ACTIONS(6517),
    [anon_sym_LT_LT_EQ] = ACTIONS(6517),
    [anon_sym_CARET_EQ] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_COLON2] = ACTIONS(6519),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6519),
    [anon_sym_AMP_AMP] = ACTIONS(6519),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6519),
    [anon_sym_PLUS] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6519),
    [anon_sym_PERCENT] = ACTIONS(6519),
    [sym_comment] = ACTIONS(87),
  },
  [7253] = {
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_in] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_EQ_GT] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_RBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_PLUS_EQ] = ACTIONS(6521),
    [anon_sym_DASH_EQ] = ACTIONS(6521),
    [anon_sym_STAR_EQ] = ACTIONS(6521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6521),
    [anon_sym_SLASH_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6521),
    [anon_sym_AMP_EQ] = ACTIONS(6521),
    [anon_sym_PERCENT_EQ] = ACTIONS(6521),
    [anon_sym_GT_GT_EQ] = ACTIONS(6521),
    [anon_sym_LT_LT_EQ] = ACTIONS(6521),
    [anon_sym_CARET_EQ] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_COLON2] = ACTIONS(6523),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6523),
    [anon_sym_AMP_AMP] = ACTIONS(6523),
    [anon_sym_LT_LT] = ACTIONS(6523),
    [anon_sym_GT_GT] = ACTIONS(6523),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6523),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(6523),
    [sym_comment] = ACTIONS(87),
  },
  [7254] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12565),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7255] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(12565),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12567),
  },
  [7256] = {
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6531),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_in] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_EQ_GT] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_RBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_PLUS_EQ] = ACTIONS(6529),
    [anon_sym_DASH_EQ] = ACTIONS(6529),
    [anon_sym_STAR_EQ] = ACTIONS(6529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6529),
    [anon_sym_SLASH_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6529),
    [anon_sym_AMP_EQ] = ACTIONS(6529),
    [anon_sym_PERCENT_EQ] = ACTIONS(6529),
    [anon_sym_GT_GT_EQ] = ACTIONS(6529),
    [anon_sym_LT_LT_EQ] = ACTIONS(6529),
    [anon_sym_CARET_EQ] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_COLON2] = ACTIONS(6531),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6531),
    [anon_sym_AMP_AMP] = ACTIONS(6531),
    [anon_sym_LT_LT] = ACTIONS(6531),
    [anon_sym_GT_GT] = ACTIONS(6531),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6531),
    [anon_sym_PLUS] = ACTIONS(6531),
    [anon_sym_SLASH] = ACTIONS(6531),
    [anon_sym_PERCENT] = ACTIONS(6531),
    [sym_comment] = ACTIONS(87),
  },
  [7257] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12569),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7258] = {
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6544),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_in] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_EQ_GT] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_RBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_PLUS_EQ] = ACTIONS(6542),
    [anon_sym_DASH_EQ] = ACTIONS(6542),
    [anon_sym_STAR_EQ] = ACTIONS(6542),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6542),
    [anon_sym_SLASH_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6542),
    [anon_sym_AMP_EQ] = ACTIONS(6542),
    [anon_sym_PERCENT_EQ] = ACTIONS(6542),
    [anon_sym_GT_GT_EQ] = ACTIONS(6542),
    [anon_sym_LT_LT_EQ] = ACTIONS(6542),
    [anon_sym_CARET_EQ] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_COLON2] = ACTIONS(6544),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6544),
    [anon_sym_AMP_AMP] = ACTIONS(6544),
    [anon_sym_LT_LT] = ACTIONS(6544),
    [anon_sym_GT_GT] = ACTIONS(6544),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_PERCENT] = ACTIONS(6544),
    [sym_comment] = ACTIONS(87),
  },
  [7259] = {
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_in] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_EQ_GT] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_RBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_PLUS_EQ] = ACTIONS(6546),
    [anon_sym_DASH_EQ] = ACTIONS(6546),
    [anon_sym_STAR_EQ] = ACTIONS(6546),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6546),
    [anon_sym_SLASH_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6546),
    [anon_sym_AMP_EQ] = ACTIONS(6546),
    [anon_sym_PERCENT_EQ] = ACTIONS(6546),
    [anon_sym_GT_GT_EQ] = ACTIONS(6546),
    [anon_sym_LT_LT_EQ] = ACTIONS(6546),
    [anon_sym_CARET_EQ] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_COLON2] = ACTIONS(6548),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6548),
    [anon_sym_AMP_AMP] = ACTIONS(6548),
    [anon_sym_LT_LT] = ACTIONS(6548),
    [anon_sym_GT_GT] = ACTIONS(6548),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6548),
    [sym_comment] = ACTIONS(87),
  },
  [7260] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12571),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7261] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(12571),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12573),
  },
  [7262] = {
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6556),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_in] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_EQ_GT] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_RBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_PLUS_EQ] = ACTIONS(6554),
    [anon_sym_DASH_EQ] = ACTIONS(6554),
    [anon_sym_STAR_EQ] = ACTIONS(6554),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6554),
    [anon_sym_SLASH_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6554),
    [anon_sym_AMP_EQ] = ACTIONS(6554),
    [anon_sym_PERCENT_EQ] = ACTIONS(6554),
    [anon_sym_GT_GT_EQ] = ACTIONS(6554),
    [anon_sym_LT_LT_EQ] = ACTIONS(6554),
    [anon_sym_CARET_EQ] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_COLON2] = ACTIONS(6556),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6556),
    [anon_sym_AMP_AMP] = ACTIONS(6556),
    [anon_sym_LT_LT] = ACTIONS(6556),
    [anon_sym_GT_GT] = ACTIONS(6556),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_PERCENT] = ACTIONS(6556),
    [sym_comment] = ACTIONS(87),
  },
  [7263] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12575),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7264] = {
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [7265] = {
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7100),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_in] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_EQ_GT] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_RBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [anon_sym_DASH_EQ] = ACTIONS(7098),
    [anon_sym_STAR_EQ] = ACTIONS(7098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7098),
    [anon_sym_SLASH_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7098),
    [anon_sym_AMP_EQ] = ACTIONS(7098),
    [anon_sym_PERCENT_EQ] = ACTIONS(7098),
    [anon_sym_GT_GT_EQ] = ACTIONS(7098),
    [anon_sym_LT_LT_EQ] = ACTIONS(7098),
    [anon_sym_CARET_EQ] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_COLON2] = ACTIONS(7100),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7100),
    [anon_sym_AMP_AMP] = ACTIONS(7100),
    [anon_sym_LT_LT] = ACTIONS(7100),
    [anon_sym_GT_GT] = ACTIONS(7100),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7100),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7100),
    [anon_sym_PERCENT] = ACTIONS(7100),
    [sym_comment] = ACTIONS(87),
  },
  [7266] = {
    [anon_sym_DOT] = ACTIONS(12577),
    [anon_sym_COLON_COLON] = ACTIONS(12577),
    [sym_comment] = ACTIONS(87),
  },
  [7267] = {
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7260),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_in] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_EQ_GT] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_RBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_PLUS_EQ] = ACTIONS(7258),
    [anon_sym_DASH_EQ] = ACTIONS(7258),
    [anon_sym_STAR_EQ] = ACTIONS(7258),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7258),
    [anon_sym_SLASH_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7258),
    [anon_sym_AMP_EQ] = ACTIONS(7258),
    [anon_sym_PERCENT_EQ] = ACTIONS(7258),
    [anon_sym_GT_GT_EQ] = ACTIONS(7258),
    [anon_sym_LT_LT_EQ] = ACTIONS(7258),
    [anon_sym_CARET_EQ] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_COLON2] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_LT] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7260),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7260),
    [anon_sym_SLASH] = ACTIONS(7260),
    [anon_sym_PERCENT] = ACTIONS(7260),
    [sym_comment] = ACTIONS(87),
  },
  [7268] = {
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7276),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_in] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_EQ_GT] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_RBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_PLUS_EQ] = ACTIONS(7274),
    [anon_sym_DASH_EQ] = ACTIONS(7274),
    [anon_sym_STAR_EQ] = ACTIONS(7274),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7274),
    [anon_sym_SLASH_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7274),
    [anon_sym_AMP_EQ] = ACTIONS(7274),
    [anon_sym_PERCENT_EQ] = ACTIONS(7274),
    [anon_sym_GT_GT_EQ] = ACTIONS(7274),
    [anon_sym_LT_LT_EQ] = ACTIONS(7274),
    [anon_sym_CARET_EQ] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_COLON2] = ACTIONS(7276),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7276),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7276),
    [anon_sym_PLUS] = ACTIONS(7276),
    [anon_sym_SLASH] = ACTIONS(7276),
    [anon_sym_PERCENT] = ACTIONS(7276),
    [sym_comment] = ACTIONS(87),
  },
  [7269] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(9443),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12579),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7270] = {
    [sym__statements] = STATE(2063),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(2064),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(2065),
    [sym_rescue] = STATE(2066),
    [sym__body_statement] = STATE(9444),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12581),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7271] = {
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7732),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_in] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_EQ_GT] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_RBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_PLUS_EQ] = ACTIONS(7730),
    [anon_sym_DASH_EQ] = ACTIONS(7730),
    [anon_sym_STAR_EQ] = ACTIONS(7730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7730),
    [anon_sym_SLASH_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7730),
    [anon_sym_AMP_EQ] = ACTIONS(7730),
    [anon_sym_PERCENT_EQ] = ACTIONS(7730),
    [anon_sym_GT_GT_EQ] = ACTIONS(7730),
    [anon_sym_LT_LT_EQ] = ACTIONS(7730),
    [anon_sym_CARET_EQ] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_COLON2] = ACTIONS(7732),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7732),
    [anon_sym_AMP_AMP] = ACTIONS(7732),
    [anon_sym_LT_LT] = ACTIONS(7732),
    [anon_sym_GT_GT] = ACTIONS(7732),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7732),
    [anon_sym_PLUS] = ACTIONS(7732),
    [anon_sym_SLASH] = ACTIONS(7732),
    [anon_sym_PERCENT] = ACTIONS(7732),
    [sym_comment] = ACTIONS(87),
  },
  [7272] = {
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_in] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_EQ_GT] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_RBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_PLUS_EQ] = ACTIONS(7788),
    [anon_sym_DASH_EQ] = ACTIONS(7788),
    [anon_sym_STAR_EQ] = ACTIONS(7788),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7788),
    [anon_sym_SLASH_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7788),
    [anon_sym_AMP_EQ] = ACTIONS(7788),
    [anon_sym_PERCENT_EQ] = ACTIONS(7788),
    [anon_sym_GT_GT_EQ] = ACTIONS(7788),
    [anon_sym_LT_LT_EQ] = ACTIONS(7788),
    [anon_sym_CARET_EQ] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_COLON2] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [sym_comment] = ACTIONS(87),
  },
  [7273] = {
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7972),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_in] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_EQ_GT] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_RBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_PLUS_EQ] = ACTIONS(7970),
    [anon_sym_DASH_EQ] = ACTIONS(7970),
    [anon_sym_STAR_EQ] = ACTIONS(7970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7970),
    [anon_sym_SLASH_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7970),
    [anon_sym_AMP_EQ] = ACTIONS(7970),
    [anon_sym_PERCENT_EQ] = ACTIONS(7970),
    [anon_sym_GT_GT_EQ] = ACTIONS(7970),
    [anon_sym_LT_LT_EQ] = ACTIONS(7970),
    [anon_sym_CARET_EQ] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_COLON2] = ACTIONS(7972),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7972),
    [anon_sym_AMP_AMP] = ACTIONS(7972),
    [anon_sym_LT_LT] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(7972),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7972),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7972),
    [anon_sym_PERCENT] = ACTIONS(7972),
    [sym_comment] = ACTIONS(87),
  },
  [7274] = {
    [sym_elsif] = STATE(9446),
    [sym_else] = STATE(9446),
    [sym__if_tail] = STATE(9446),
    [anon_sym_end] = ACTIONS(12583),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [7275] = {
    [anon_sym_end] = ACTIONS(12583),
    [sym_comment] = ACTIONS(87),
  },
  [7276] = {
    [sym__statements] = STATE(9447),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(9446),
    [sym_else] = STATE(9446),
    [sym__if_tail] = STATE(9446),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12585),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7277] = {
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8178),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_in] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_EQ_GT] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_PLUS_EQ] = ACTIONS(8176),
    [anon_sym_DASH_EQ] = ACTIONS(8176),
    [anon_sym_STAR_EQ] = ACTIONS(8176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8176),
    [anon_sym_SLASH_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8176),
    [anon_sym_AMP_EQ] = ACTIONS(8176),
    [anon_sym_PERCENT_EQ] = ACTIONS(8176),
    [anon_sym_GT_GT_EQ] = ACTIONS(8176),
    [anon_sym_LT_LT_EQ] = ACTIONS(8176),
    [anon_sym_CARET_EQ] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_COLON2] = ACTIONS(8178),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8178),
    [anon_sym_AMP_AMP] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(8178),
    [anon_sym_GT_GT] = ACTIONS(8178),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8178),
    [anon_sym_PLUS] = ACTIONS(8178),
    [anon_sym_SLASH] = ACTIONS(8178),
    [anon_sym_PERCENT] = ACTIONS(8178),
    [sym_comment] = ACTIONS(87),
  },
  [7278] = {
    [sym_else] = STATE(9449),
    [anon_sym_end] = ACTIONS(12587),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [7279] = {
    [anon_sym_end] = ACTIONS(12587),
    [sym_comment] = ACTIONS(87),
  },
  [7280] = {
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8354),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_in] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_EQ_GT] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_PLUS_EQ] = ACTIONS(8352),
    [anon_sym_DASH_EQ] = ACTIONS(8352),
    [anon_sym_STAR_EQ] = ACTIONS(8352),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8352),
    [anon_sym_SLASH_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8352),
    [anon_sym_AMP_EQ] = ACTIONS(8352),
    [anon_sym_PERCENT_EQ] = ACTIONS(8352),
    [anon_sym_GT_GT_EQ] = ACTIONS(8352),
    [anon_sym_LT_LT_EQ] = ACTIONS(8352),
    [anon_sym_CARET_EQ] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_COLON2] = ACTIONS(8354),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8354),
    [anon_sym_AMP_AMP] = ACTIONS(8354),
    [anon_sym_LT_LT] = ACTIONS(8354),
    [anon_sym_GT_GT] = ACTIONS(8354),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8354),
    [anon_sym_SLASH] = ACTIONS(8354),
    [anon_sym_PERCENT] = ACTIONS(8354),
    [sym_comment] = ACTIONS(87),
  },
  [7281] = {
    [anon_sym_end] = ACTIONS(12589),
    [sym_comment] = ACTIONS(87),
  },
  [7282] = {
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8434),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_in] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_EQ_GT] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_RBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_PLUS_EQ] = ACTIONS(8432),
    [anon_sym_DASH_EQ] = ACTIONS(8432),
    [anon_sym_STAR_EQ] = ACTIONS(8432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8432),
    [anon_sym_SLASH_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8432),
    [anon_sym_AMP_EQ] = ACTIONS(8432),
    [anon_sym_PERCENT_EQ] = ACTIONS(8432),
    [anon_sym_GT_GT_EQ] = ACTIONS(8432),
    [anon_sym_LT_LT_EQ] = ACTIONS(8432),
    [anon_sym_CARET_EQ] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_COLON2] = ACTIONS(8434),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8434),
    [anon_sym_AMP_AMP] = ACTIONS(8434),
    [anon_sym_LT_LT] = ACTIONS(8434),
    [anon_sym_GT_GT] = ACTIONS(8434),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8434),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8434),
    [anon_sym_PERCENT] = ACTIONS(8434),
    [sym_comment] = ACTIONS(87),
  },
  [7283] = {
    [anon_sym_end] = ACTIONS(12591),
    [sym_comment] = ACTIONS(87),
  },
  [7284] = {
    [sym__statements] = STATE(9453),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12593),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7285] = {
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [7286] = {
    [anon_sym_end] = ACTIONS(12595),
    [sym_comment] = ACTIONS(87),
  },
  [7287] = {
    [sym__statements] = STATE(9455),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12597),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7288] = {
    [anon_sym_end] = ACTIONS(12599),
    [sym_comment] = ACTIONS(87),
  },
  [7289] = {
    [sym_when] = STATE(9457),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [7290] = {
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8698),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_in] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_EQ_GT] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_RBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_PLUS_EQ] = ACTIONS(8696),
    [anon_sym_DASH_EQ] = ACTIONS(8696),
    [anon_sym_STAR_EQ] = ACTIONS(8696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8696),
    [anon_sym_SLASH_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8696),
    [anon_sym_AMP_EQ] = ACTIONS(8696),
    [anon_sym_PERCENT_EQ] = ACTIONS(8696),
    [anon_sym_GT_GT_EQ] = ACTIONS(8696),
    [anon_sym_LT_LT_EQ] = ACTIONS(8696),
    [anon_sym_CARET_EQ] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_COLON2] = ACTIONS(8698),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8698),
    [anon_sym_AMP_AMP] = ACTIONS(8698),
    [anon_sym_LT_LT] = ACTIONS(8698),
    [anon_sym_GT_GT] = ACTIONS(8698),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8698),
    [anon_sym_PLUS] = ACTIONS(8698),
    [anon_sym_SLASH] = ACTIONS(8698),
    [anon_sym_PERCENT] = ACTIONS(8698),
    [sym_comment] = ACTIONS(87),
  },
  [7291] = {
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_in] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_EQ_GT] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_RBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_PLUS_EQ] = ACTIONS(9229),
    [anon_sym_DASH_EQ] = ACTIONS(9229),
    [anon_sym_STAR_EQ] = ACTIONS(9229),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9229),
    [anon_sym_SLASH_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9229),
    [anon_sym_AMP_EQ] = ACTIONS(9229),
    [anon_sym_PERCENT_EQ] = ACTIONS(9229),
    [anon_sym_GT_GT_EQ] = ACTIONS(9229),
    [anon_sym_LT_LT_EQ] = ACTIONS(9229),
    [anon_sym_CARET_EQ] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_COLON2] = ACTIONS(9231),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9231),
    [anon_sym_AMP_AMP] = ACTIONS(9231),
    [anon_sym_LT_LT] = ACTIONS(9231),
    [anon_sym_GT_GT] = ACTIONS(9231),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9231),
    [anon_sym_PLUS] = ACTIONS(9231),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [7292] = {
    [anon_sym_end] = ACTIONS(12601),
    [sym_comment] = ACTIONS(87),
  },
  [7293] = {
    [sym_ensure] = STATE(9459),
    [anon_sym_end] = ACTIONS(12601),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [7294] = {
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_in] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_RBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [sym_comment] = ACTIONS(87),
  },
  [7295] = {
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9459),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_in] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_EQ_GT] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_RBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_PLUS_EQ] = ACTIONS(9457),
    [anon_sym_DASH_EQ] = ACTIONS(9457),
    [anon_sym_STAR_EQ] = ACTIONS(9457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9457),
    [anon_sym_SLASH_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9457),
    [anon_sym_AMP_EQ] = ACTIONS(9457),
    [anon_sym_PERCENT_EQ] = ACTIONS(9457),
    [anon_sym_GT_GT_EQ] = ACTIONS(9457),
    [anon_sym_LT_LT_EQ] = ACTIONS(9457),
    [anon_sym_CARET_EQ] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_COLON2] = ACTIONS(9459),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9459),
    [anon_sym_AMP_AMP] = ACTIONS(9459),
    [anon_sym_LT_LT] = ACTIONS(9459),
    [anon_sym_GT_GT] = ACTIONS(9459),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9459),
    [anon_sym_PLUS] = ACTIONS(9459),
    [anon_sym_SLASH] = ACTIONS(9459),
    [anon_sym_PERCENT] = ACTIONS(9459),
    [sym_comment] = ACTIONS(87),
  },
  [7296] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9460),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_assignment] = STATE(9460),
    [sym_operator_assignment] = STATE(9460),
    [sym_conditional] = STATE(9460),
    [sym_range] = STATE(9460),
    [sym_binary] = STATE(9460),
    [sym_unary] = STATE(9460),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7297] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(8705),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6739),
    [anon_sym_STAR_EQ] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6739),
    [anon_sym_CARET_EQ] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COLON2] = ACTIONS(8705),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(8705),
    [anon_sym_AMP_AMP] = ACTIONS(8705),
    [anon_sym_LT_LT] = ACTIONS(8705),
    [anon_sym_GT_GT] = ACTIONS(8705),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_SLASH] = ACTIONS(8705),
    [anon_sym_PERCENT] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
  },
  [7298] = {
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10964),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_in] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_RBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10964),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10964),
    [anon_sym_AMP_AMP] = ACTIONS(10964),
    [anon_sym_LT_LT] = ACTIONS(10964),
    [anon_sym_GT_GT] = ACTIONS(10964),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10964),
    [anon_sym_PLUS] = ACTIONS(10964),
    [anon_sym_SLASH] = ACTIONS(10964),
    [anon_sym_PERCENT] = ACTIONS(10964),
    [sym_comment] = ACTIONS(87),
  },
  [7299] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4550),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(4550),
    [sym_operator_assignment] = STATE(4550),
    [sym_conditional] = STATE(4550),
    [sym_range] = STATE(4550),
    [sym_binary] = STATE(4550),
    [sym_unary] = STATE(4550),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2027),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(1167),
    [sym__unary_minus2] = ACTIONS(1169),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7300] = {
    [aux_sym_exceptions_repeat1] = STATE(9462),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12603),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [7301] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7302] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7303] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7304] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7305] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7306] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7307] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12605),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7308] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7309] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7310] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7311] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7312] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7313] = {
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [7314] = {
    [aux_sym_exceptions_repeat1] = STATE(7314),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(12607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [7315] = {
    [aux_sym_exceptions_repeat1] = STATE(4572),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7316] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [7317] = {
    [sym_string] = STATE(7317),
    [aux_sym_chained_string_repeat1] = STATE(7317),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7318] = {
    [sym__simple_symbol2] = ACTIONS(6739),
    [sym__string_start2] = ACTIONS(6739),
    [sym__symbol_start2] = ACTIONS(6739),
    [sym__subshell_start2] = ACTIONS(6739),
    [sym__regex_start2] = ACTIONS(6739),
    [sym__string_array_start2] = ACTIONS(6739),
    [sym__symbol_array_start2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym_heredoc_beginning2] = ACTIONS(6739),
    [sym__unary_minus2] = ACTIONS(6739),
    [sym__identifier_hash_key2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(8705),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(8705),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(8705),
    [anon_sym_module] = ACTIONS(8705),
    [anon_sym_return] = ACTIONS(8705),
    [anon_sym_yield] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(8705),
    [anon_sym_next] = ACTIONS(8705),
    [sym_redo] = ACTIONS(8705),
    [sym_retry] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(8705),
    [anon_sym_unless] = ACTIONS(8705),
    [anon_sym_while] = ACTIONS(8705),
    [anon_sym_until] = ACTIONS(8705),
    [anon_sym_for] = ACTIONS(8705),
    [anon_sym_case] = ACTIONS(8705),
    [anon_sym_begin] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_defined_QMARK] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(8705),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8705),
    [sym_float] = ACTIONS(8705),
    [sym_complex] = ACTIONS(6739),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(8705),
    [anon_sym_TRUE] = ACTIONS(8705),
    [anon_sym_false] = ACTIONS(8705),
    [anon_sym_FALSE] = ACTIONS(8705),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(8705),
    [anon_sym_NIL] = ACTIONS(8705),
    [sym_character] = ACTIONS(6739),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6739),
  },
  [7319] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7320] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7321] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [7322] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9464),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9464),
    [sym_operator_assignment] = STATE(9464),
    [sym_conditional] = STATE(9464),
    [sym_range] = STATE(9464),
    [sym_binary] = STATE(9464),
    [sym_unary] = STATE(9464),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7323] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9465),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9465),
    [sym_operator_assignment] = STATE(9465),
    [sym_conditional] = STATE(9465),
    [sym_range] = STATE(9465),
    [sym_binary] = STATE(9465),
    [sym_unary] = STATE(9465),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7324] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9466),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9466),
    [sym_operator_assignment] = STATE(9466),
    [sym_conditional] = STATE(9466),
    [sym_range] = STATE(9466),
    [sym_binary] = STATE(9466),
    [sym_unary] = STATE(9466),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7325] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9467),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9467),
    [sym_operator_assignment] = STATE(9467),
    [sym_conditional] = STATE(9467),
    [sym_range] = STATE(9467),
    [sym_binary] = STATE(9467),
    [sym_unary] = STATE(9467),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7326] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9468),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9468),
    [sym_operator_assignment] = STATE(9468),
    [sym_conditional] = STATE(9468),
    [sym_range] = STATE(9468),
    [sym_binary] = STATE(9468),
    [sym_unary] = STATE(9468),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7327] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9469),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9469),
    [sym_operator_assignment] = STATE(9469),
    [sym_conditional] = STATE(9469),
    [sym_range] = STATE(9469),
    [sym_binary] = STATE(9469),
    [sym_unary] = STATE(9469),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7328] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9470),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9470),
    [sym_operator_assignment] = STATE(9470),
    [sym_conditional] = STATE(9470),
    [sym_range] = STATE(9470),
    [sym_binary] = STATE(9470),
    [sym_unary] = STATE(9470),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7329] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9471),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9471),
    [sym_operator_assignment] = STATE(9471),
    [sym_conditional] = STATE(9471),
    [sym_range] = STATE(9471),
    [sym_binary] = STATE(9471),
    [sym_unary] = STATE(9471),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7330] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9472),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9472),
    [sym_operator_assignment] = STATE(9472),
    [sym_conditional] = STATE(9472),
    [sym_range] = STATE(9472),
    [sym_binary] = STATE(9472),
    [sym_unary] = STATE(9472),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7331] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9473),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9473),
    [sym_operator_assignment] = STATE(9473),
    [sym_conditional] = STATE(9473),
    [sym_range] = STATE(9473),
    [sym_binary] = STATE(9473),
    [sym_unary] = STATE(9473),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7332] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9474),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9474),
    [sym_operator_assignment] = STATE(9474),
    [sym_conditional] = STATE(9474),
    [sym_range] = STATE(9474),
    [sym_binary] = STATE(9474),
    [sym_unary] = STATE(9474),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7333] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9475),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9475),
    [sym_operator_assignment] = STATE(9475),
    [sym_conditional] = STATE(9475),
    [sym_range] = STATE(9475),
    [sym_binary] = STATE(9475),
    [sym_unary] = STATE(9475),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7334] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9476),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_splat_argument] = STATE(9477),
    [sym_assignment] = STATE(9476),
    [sym_operator_assignment] = STATE(9476),
    [sym_conditional] = STATE(9476),
    [sym_range] = STATE(9476),
    [sym_binary] = STATE(9476),
    [sym_unary] = STATE(9476),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(9477),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7335] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9478),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(9478),
    [sym_operator_assignment] = STATE(9478),
    [sym_conditional] = STATE(9478),
    [sym_range] = STATE(9478),
    [sym_binary] = STATE(9478),
    [sym_unary] = STATE(9478),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7336] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [7337] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7338] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7339] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7340] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7341] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7342] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7343] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [7344] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12610),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7345] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7346] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7347] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7348] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7349] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7350] = {
    [sym_heredoc_body] = STATE(7350),
    [aux_sym_call_repeat1] = STATE(7350),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7351] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2139),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(2139),
    [sym_operator_assignment] = STATE(2139),
    [sym_conditional] = STATE(2139),
    [sym_range] = STATE(2139),
    [sym_binary] = STATE(2139),
    [sym_unary] = STATE(2139),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2144),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3520),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__identifier_hash_key2] = ACTIONS(3526),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10549),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(3536),
    [sym_identifier] = ACTIONS(3536),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7352] = {
    [sym_heredoc_body] = STATE(7350),
    [aux_sym_call_repeat1] = STATE(7350),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7353] = {
    [aux_sym_argument_list_repeat1] = STATE(7353),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12612),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7354] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7355] = {
    [aux_sym_exceptions_repeat1] = STATE(9481),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7356] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7357] = {
    [sym__line_break2] = ACTIONS(12615),
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [ts_builtin_sym_end] = ACTIONS(12615),
    [anon_sym___END__] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12615),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_end] = ACTIONS(12615),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_when] = ACTIONS(12615),
    [anon_sym_elsif] = ACTIONS(12615),
    [anon_sym_else] = ACTIONS(12615),
    [anon_sym_then] = ACTIONS(12615),
    [anon_sym_ensure] = ACTIONS(12615),
    [anon_sym_EQ_GT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12615),
    [anon_sym_AMP_AMP] = ACTIONS(12615),
    [anon_sym_LT_LT] = ACTIONS(12615),
    [anon_sym_GT_GT] = ACTIONS(12615),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12615),
    [anon_sym_PLUS] = ACTIONS(12615),
    [anon_sym_SLASH] = ACTIONS(12615),
    [anon_sym_PERCENT] = ACTIONS(12615),
    [sym_comment] = ACTIONS(87),
  },
  [7358] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9482),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(699),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(699),
    [sym_assignment] = STATE(9482),
    [sym_operator_assignment] = STATE(9482),
    [sym_conditional] = STATE(9482),
    [sym_range] = STATE(9482),
    [sym_binary] = STATE(9482),
    [sym_unary] = STATE(9482),
    [sym_left_assignment_list] = STATE(698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(699),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(699),
    [sym_false] = STATE(699),
    [sym_nil] = STATE(699),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(700),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(1251),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(1253),
    [anon_sym_yield] = ACTIONS(1255),
    [anon_sym_break] = ACTIONS(1257),
    [anon_sym_next] = ACTIONS(1259),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(1261),
    [anon_sym_defined_QMARK] = ACTIONS(1263),
    [anon_sym_not] = ACTIONS(1265),
    [anon_sym_BANG] = ACTIONS(1267),
    [anon_sym_TILDE] = ACTIONS(1267),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7359] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [7360] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [7361] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [7362] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9483),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9483),
    [sym_operator_assignment] = STATE(9483),
    [sym_conditional] = STATE(9483),
    [sym_range] = STATE(9483),
    [sym_binary] = STATE(9483),
    [sym_unary] = STATE(9483),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7363] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9484),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9484),
    [sym_operator_assignment] = STATE(9484),
    [sym_conditional] = STATE(9484),
    [sym_range] = STATE(9484),
    [sym_binary] = STATE(9484),
    [sym_unary] = STATE(9484),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7364] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9485),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9485),
    [sym_operator_assignment] = STATE(9485),
    [sym_conditional] = STATE(9485),
    [sym_range] = STATE(9485),
    [sym_binary] = STATE(9485),
    [sym_unary] = STATE(9485),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7365] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9486),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9486),
    [sym_operator_assignment] = STATE(9486),
    [sym_conditional] = STATE(9486),
    [sym_range] = STATE(9486),
    [sym_binary] = STATE(9486),
    [sym_unary] = STATE(9486),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7366] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9487),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9487),
    [sym_operator_assignment] = STATE(9487),
    [sym_conditional] = STATE(9487),
    [sym_range] = STATE(9487),
    [sym_binary] = STATE(9487),
    [sym_unary] = STATE(9487),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7367] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9488),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9488),
    [sym_operator_assignment] = STATE(9488),
    [sym_conditional] = STATE(9488),
    [sym_range] = STATE(9488),
    [sym_binary] = STATE(9488),
    [sym_unary] = STATE(9488),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7368] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9489),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9489),
    [sym_operator_assignment] = STATE(9489),
    [sym_conditional] = STATE(9489),
    [sym_range] = STATE(9489),
    [sym_binary] = STATE(9489),
    [sym_unary] = STATE(9489),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7369] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9490),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9490),
    [sym_operator_assignment] = STATE(9490),
    [sym_conditional] = STATE(9490),
    [sym_range] = STATE(9490),
    [sym_binary] = STATE(9490),
    [sym_unary] = STATE(9490),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7370] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9491),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9491),
    [sym_operator_assignment] = STATE(9491),
    [sym_conditional] = STATE(9491),
    [sym_range] = STATE(9491),
    [sym_binary] = STATE(9491),
    [sym_unary] = STATE(9491),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7371] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9492),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9492),
    [sym_operator_assignment] = STATE(9492),
    [sym_conditional] = STATE(9492),
    [sym_range] = STATE(9492),
    [sym_binary] = STATE(9492),
    [sym_unary] = STATE(9492),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7372] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9493),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9493),
    [sym_operator_assignment] = STATE(9493),
    [sym_conditional] = STATE(9493),
    [sym_range] = STATE(9493),
    [sym_binary] = STATE(9493),
    [sym_unary] = STATE(9493),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7373] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9494),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9494),
    [sym_operator_assignment] = STATE(9494),
    [sym_conditional] = STATE(9494),
    [sym_range] = STATE(9494),
    [sym_binary] = STATE(9494),
    [sym_unary] = STATE(9494),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7374] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9495),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_splat_argument] = STATE(9496),
    [sym_assignment] = STATE(9495),
    [sym_operator_assignment] = STATE(9495),
    [sym_conditional] = STATE(9495),
    [sym_range] = STATE(9495),
    [sym_binary] = STATE(9495),
    [sym_unary] = STATE(9495),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(9496),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7375] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9497),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(9497),
    [sym_operator_assignment] = STATE(9497),
    [sym_conditional] = STATE(9497),
    [sym_range] = STATE(9497),
    [sym_binary] = STATE(9497),
    [sym_unary] = STATE(9497),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7376] = {
    [sym_string] = STATE(9498),
    [aux_sym_chained_string_repeat1] = STATE(9498),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [7377] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [7378] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7379] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [7380] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7381] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [7382] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7383] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7384] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [7385] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12619),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7386] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7387] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7388] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7389] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7390] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7391] = {
    [sym_heredoc_body] = STATE(7391),
    [aux_sym_call_repeat1] = STATE(7391),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7392] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2173),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(2173),
    [sym_operator_assignment] = STATE(2173),
    [sym_conditional] = STATE(2173),
    [sym_range] = STATE(2173),
    [sym_binary] = STATE(2173),
    [sym_unary] = STATE(2173),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2179),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(3572),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__identifier_hash_key2] = ACTIONS(3578),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10587),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3596),
    [sym_identifier] = ACTIONS(3596),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7393] = {
    [sym_heredoc_body] = STATE(7391),
    [aux_sym_call_repeat1] = STATE(7391),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7394] = {
    [aux_sym_argument_list_repeat1] = STATE(7394),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12621),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7395] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7396] = {
    [aux_sym_exceptions_repeat1] = STATE(9501),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [7397] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7398] = {
    [sym_string] = STATE(7398),
    [aux_sym_chained_string_repeat1] = STATE(7398),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [7399] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [7400] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7401] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7402] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [7403] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9502),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9502),
    [sym_operator_assignment] = STATE(9502),
    [sym_conditional] = STATE(9502),
    [sym_range] = STATE(9502),
    [sym_binary] = STATE(9502),
    [sym_unary] = STATE(9502),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7404] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9503),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9503),
    [sym_operator_assignment] = STATE(9503),
    [sym_conditional] = STATE(9503),
    [sym_range] = STATE(9503),
    [sym_binary] = STATE(9503),
    [sym_unary] = STATE(9503),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7405] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9504),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9504),
    [sym_operator_assignment] = STATE(9504),
    [sym_conditional] = STATE(9504),
    [sym_range] = STATE(9504),
    [sym_binary] = STATE(9504),
    [sym_unary] = STATE(9504),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7406] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9505),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9505),
    [sym_operator_assignment] = STATE(9505),
    [sym_conditional] = STATE(9505),
    [sym_range] = STATE(9505),
    [sym_binary] = STATE(9505),
    [sym_unary] = STATE(9505),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7407] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9506),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9506),
    [sym_operator_assignment] = STATE(9506),
    [sym_conditional] = STATE(9506),
    [sym_range] = STATE(9506),
    [sym_binary] = STATE(9506),
    [sym_unary] = STATE(9506),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7408] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9507),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9507),
    [sym_operator_assignment] = STATE(9507),
    [sym_conditional] = STATE(9507),
    [sym_range] = STATE(9507),
    [sym_binary] = STATE(9507),
    [sym_unary] = STATE(9507),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7409] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9508),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9508),
    [sym_operator_assignment] = STATE(9508),
    [sym_conditional] = STATE(9508),
    [sym_range] = STATE(9508),
    [sym_binary] = STATE(9508),
    [sym_unary] = STATE(9508),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7410] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9509),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9509),
    [sym_operator_assignment] = STATE(9509),
    [sym_conditional] = STATE(9509),
    [sym_range] = STATE(9509),
    [sym_binary] = STATE(9509),
    [sym_unary] = STATE(9509),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7411] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9510),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9510),
    [sym_operator_assignment] = STATE(9510),
    [sym_conditional] = STATE(9510),
    [sym_range] = STATE(9510),
    [sym_binary] = STATE(9510),
    [sym_unary] = STATE(9510),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7412] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9511),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9511),
    [sym_operator_assignment] = STATE(9511),
    [sym_conditional] = STATE(9511),
    [sym_range] = STATE(9511),
    [sym_binary] = STATE(9511),
    [sym_unary] = STATE(9511),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7413] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9512),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9512),
    [sym_operator_assignment] = STATE(9512),
    [sym_conditional] = STATE(9512),
    [sym_range] = STATE(9512),
    [sym_binary] = STATE(9512),
    [sym_unary] = STATE(9512),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7414] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9513),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9513),
    [sym_operator_assignment] = STATE(9513),
    [sym_conditional] = STATE(9513),
    [sym_range] = STATE(9513),
    [sym_binary] = STATE(9513),
    [sym_unary] = STATE(9513),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7415] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4671),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(4671),
    [sym_operator_assignment] = STATE(4671),
    [sym_conditional] = STATE(4671),
    [sym_range] = STATE(4671),
    [sym_binary] = STATE(4671),
    [sym_unary] = STATE(4671),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(7238),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7416] = {
    [aux_sym_exceptions_repeat1] = STATE(9514),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(10619),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7417] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(4671),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_splat_argument] = STATE(9515),
    [sym_assignment] = STATE(4671),
    [sym_operator_assignment] = STATE(4671),
    [sym_conditional] = STATE(4671),
    [sym_range] = STATE(4671),
    [sym_binary] = STATE(4671),
    [sym_unary] = STATE(4671),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(9515),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(7238),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7418] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9516),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(9516),
    [sym_operator_assignment] = STATE(9516),
    [sym_conditional] = STATE(9516),
    [sym_range] = STATE(9516),
    [sym_binary] = STATE(9516),
    [sym_unary] = STATE(9516),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7419] = {
    [sym_string] = STATE(9517),
    [aux_sym_chained_string_repeat1] = STATE(9517),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [7420] = {
    [sym__simple_symbol2] = ACTIONS(12624),
    [sym__string_start2] = ACTIONS(12624),
    [sym__symbol_start2] = ACTIONS(12624),
    [sym__subshell_start2] = ACTIONS(12624),
    [sym__regex_start2] = ACTIONS(12624),
    [sym__string_array_start2] = ACTIONS(12624),
    [sym__symbol_array_start2] = ACTIONS(12624),
    [sym_heredoc_beginning2] = ACTIONS(12624),
    [sym__unary_minus2] = ACTIONS(12624),
    [anon_sym_BEGIN] = ACTIONS(12626),
    [anon_sym_LBRACE] = ACTIONS(12624),
    [anon_sym_END] = ACTIONS(12626),
    [anon_sym_def] = ACTIONS(12626),
    [anon_sym_LPAREN] = ACTIONS(12624),
    [anon_sym_COLON_COLON] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12624),
    [anon_sym_STAR] = ACTIONS(12624),
    [anon_sym_class] = ACTIONS(12626),
    [anon_sym_module] = ACTIONS(12626),
    [anon_sym_end] = ACTIONS(12626),
    [anon_sym_return] = ACTIONS(12626),
    [anon_sym_yield] = ACTIONS(12626),
    [anon_sym_break] = ACTIONS(12626),
    [anon_sym_next] = ACTIONS(12626),
    [sym_redo] = ACTIONS(12626),
    [sym_retry] = ACTIONS(12626),
    [anon_sym_if] = ACTIONS(12626),
    [anon_sym_unless] = ACTIONS(12626),
    [anon_sym_while] = ACTIONS(12626),
    [anon_sym_until] = ACTIONS(12626),
    [anon_sym_rescue] = ACTIONS(12626),
    [anon_sym_for] = ACTIONS(12626),
    [anon_sym_case] = ACTIONS(12626),
    [anon_sym_else] = ACTIONS(12626),
    [anon_sym_begin] = ACTIONS(12626),
    [anon_sym_ensure] = ACTIONS(12626),
    [anon_sym_PLUS] = ACTIONS(12626),
    [anon_sym_defined_QMARK] = ACTIONS(12624),
    [anon_sym_not] = ACTIONS(12626),
    [anon_sym_BANG] = ACTIONS(12624),
    [anon_sym_TILDE] = ACTIONS(12624),
    [sym_constant] = ACTIONS(12626),
    [sym_identifier] = ACTIONS(12626),
    [sym_instance_variable] = ACTIONS(12624),
    [sym_class_variable] = ACTIONS(12624),
    [sym_global_variable] = ACTIONS(12624),
    [anon_sym_undef] = ACTIONS(12626),
    [anon_sym_alias] = ACTIONS(12626),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12626),
    [sym_float] = ACTIONS(12626),
    [sym_complex] = ACTIONS(12624),
    [sym_super] = ACTIONS(12626),
    [anon_sym_true] = ACTIONS(12626),
    [anon_sym_TRUE] = ACTIONS(12626),
    [anon_sym_false] = ACTIONS(12626),
    [anon_sym_FALSE] = ACTIONS(12626),
    [sym_self] = ACTIONS(12626),
    [anon_sym_nil] = ACTIONS(12626),
    [anon_sym_NIL] = ACTIONS(12626),
    [sym_character] = ACTIONS(12624),
    [anon_sym_LBRACK2] = ACTIONS(12624),
    [anon_sym_DASH_GT] = ACTIONS(12624),
  },
  [7421] = {
    [sym_heredoc_body] = STATE(9518),
    [sym__terminator] = STATE(9518),
    [sym__line_break2] = ACTIONS(12628),
    [sym__simple_symbol2] = ACTIONS(12624),
    [sym__string_start2] = ACTIONS(12624),
    [sym__symbol_start2] = ACTIONS(12624),
    [sym__subshell_start2] = ACTIONS(12624),
    [sym__regex_start2] = ACTIONS(12624),
    [sym__string_array_start2] = ACTIONS(12624),
    [sym__symbol_array_start2] = ACTIONS(12624),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(12624),
    [sym__unary_minus2] = ACTIONS(12624),
    [anon_sym_BEGIN] = ACTIONS(12626),
    [anon_sym_LBRACE] = ACTIONS(12624),
    [anon_sym_END] = ACTIONS(12626),
    [anon_sym_def] = ACTIONS(12626),
    [anon_sym_LPAREN] = ACTIONS(12624),
    [anon_sym_COLON_COLON] = ACTIONS(12624),
    [anon_sym_SEMI] = ACTIONS(12628),
    [anon_sym_STAR] = ACTIONS(12624),
    [anon_sym_class] = ACTIONS(12626),
    [anon_sym_module] = ACTIONS(12626),
    [anon_sym_end] = ACTIONS(12626),
    [anon_sym_return] = ACTIONS(12626),
    [anon_sym_yield] = ACTIONS(12626),
    [anon_sym_break] = ACTIONS(12626),
    [anon_sym_next] = ACTIONS(12626),
    [sym_redo] = ACTIONS(12626),
    [sym_retry] = ACTIONS(12626),
    [anon_sym_if] = ACTIONS(12626),
    [anon_sym_unless] = ACTIONS(12626),
    [anon_sym_while] = ACTIONS(12626),
    [anon_sym_until] = ACTIONS(12626),
    [anon_sym_rescue] = ACTIONS(12626),
    [anon_sym_for] = ACTIONS(12626),
    [anon_sym_case] = ACTIONS(12626),
    [anon_sym_else] = ACTIONS(12626),
    [anon_sym_begin] = ACTIONS(12626),
    [anon_sym_ensure] = ACTIONS(12626),
    [anon_sym_PLUS] = ACTIONS(12626),
    [anon_sym_defined_QMARK] = ACTIONS(12624),
    [anon_sym_not] = ACTIONS(12626),
    [anon_sym_BANG] = ACTIONS(12624),
    [anon_sym_TILDE] = ACTIONS(12624),
    [sym_constant] = ACTIONS(12626),
    [sym_identifier] = ACTIONS(12626),
    [sym_instance_variable] = ACTIONS(12624),
    [sym_class_variable] = ACTIONS(12624),
    [sym_global_variable] = ACTIONS(12624),
    [anon_sym_undef] = ACTIONS(12626),
    [anon_sym_alias] = ACTIONS(12626),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(12626),
    [sym_float] = ACTIONS(12626),
    [sym_complex] = ACTIONS(12624),
    [sym_super] = ACTIONS(12626),
    [anon_sym_true] = ACTIONS(12626),
    [anon_sym_TRUE] = ACTIONS(12626),
    [anon_sym_false] = ACTIONS(12626),
    [anon_sym_FALSE] = ACTIONS(12626),
    [sym_self] = ACTIONS(12626),
    [anon_sym_nil] = ACTIONS(12626),
    [anon_sym_NIL] = ACTIONS(12626),
    [sym_character] = ACTIONS(12624),
    [anon_sym_LBRACK2] = ACTIONS(12624),
    [anon_sym_DASH_GT] = ACTIONS(12624),
  },
  [7422] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5750),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [7423] = {
    [anon_sym_RBRACE] = ACTIONS(12630),
    [sym_comment] = ACTIONS(87),
  },
  [7424] = {
    [sym__statements] = STATE(9520),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12630),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7425] = {
    [sym__line_break2] = ACTIONS(5786),
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5786),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_SEMI] = ACTIONS(5786),
    [anon_sym_then] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [7426] = {
    [anon_sym_end] = ACTIONS(12632),
    [sym_comment] = ACTIONS(87),
  },
  [7427] = {
    [sym__statements] = STATE(9522),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9523),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9523),
    [sym__line_break2] = ACTIONS(12634),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12636),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7428] = {
    [sym__statements] = STATE(9522),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(9524),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12636),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7429] = {
    [sym__line_break2] = ACTIONS(5822),
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_SEMI] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [7430] = {
    [aux_sym_method_parameters_repeat1] = STATE(9526),
    [anon_sym_RPAREN] = ACTIONS(12638),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [7431] = {
    [sym__formal_parameter] = STATE(9527),
    [sym__simple_formal_parameter] = STATE(9527),
    [sym_destructured_parameter] = STATE(9527),
    [sym_splat_parameter] = STATE(9527),
    [sym_hash_splat_parameter] = STATE(9527),
    [sym_block_parameter] = STATE(9527),
    [sym_keyword_parameter] = STATE(9527),
    [sym_optional_parameter] = STATE(9527),
    [anon_sym_LPAREN] = ACTIONS(7278),
    [anon_sym_STAR] = ACTIONS(1293),
    [anon_sym_STAR_STAR] = ACTIONS(1295),
    [anon_sym_AMP] = ACTIONS(1297),
    [sym_identifier] = ACTIONS(1299),
    [sym_comment] = ACTIONS(87),
  },
  [7432] = {
    [sym_heredoc_body] = STATE(9518),
    [sym__terminator] = STATE(9518),
    [aux_sym_method_parameters_repeat1] = STATE(9528),
    [sym__line_break2] = ACTIONS(12628),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_COMMA] = ACTIONS(10645),
    [anon_sym_SEMI] = ACTIONS(12628),
    [sym_comment] = ACTIONS(87),
  },
  [7433] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_RPAREN] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7434] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9529),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9529),
    [sym_operator_assignment] = STATE(9529),
    [sym_conditional] = STATE(9529),
    [sym_range] = STATE(9529),
    [sym_binary] = STATE(9529),
    [sym_unary] = STATE(9529),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7435] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9530),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9530),
    [sym_operator_assignment] = STATE(9530),
    [sym_conditional] = STATE(9530),
    [sym_range] = STATE(9530),
    [sym_binary] = STATE(9530),
    [sym_unary] = STATE(9530),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7436] = {
    [anon_sym_COLON] = ACTIONS(12640),
    [sym_comment] = ACTIONS(87),
  },
  [7437] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9532),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9532),
    [sym_operator_assignment] = STATE(9532),
    [sym_conditional] = STATE(9532),
    [sym_range] = STATE(9532),
    [sym_binary] = STATE(9532),
    [sym_unary] = STATE(9532),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7438] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_RPAREN] = ACTIONS(1093),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(12642),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [7439] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_RPAREN] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(12644),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7440] = {
    [sym_heredoc_body] = STATE(9534),
    [aux_sym_call_repeat1] = STATE(9534),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [7441] = {
    [sym_heredoc_body] = STATE(9534),
    [aux_sym_call_repeat1] = STATE(9534),
    [aux_sym_argument_list_repeat1] = STATE(9536),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_RPAREN] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(12646),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [7442] = {
    [sym_string] = STATE(4735),
    [aux_sym_chained_string_repeat1] = STATE(4735),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_RPAREN] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12648),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7443] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7444] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_RPAREN] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [7445] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9537),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9537),
    [sym_operator_assignment] = STATE(9537),
    [sym_conditional] = STATE(9537),
    [sym_range] = STATE(9537),
    [sym_binary] = STATE(9537),
    [sym_unary] = STATE(9537),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7446] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9538),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9538),
    [sym_operator_assignment] = STATE(9538),
    [sym_conditional] = STATE(9538),
    [sym_range] = STATE(9538),
    [sym_binary] = STATE(9538),
    [sym_unary] = STATE(9538),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7447] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9539),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9539),
    [sym_operator_assignment] = STATE(9539),
    [sym_conditional] = STATE(9539),
    [sym_range] = STATE(9539),
    [sym_binary] = STATE(9539),
    [sym_unary] = STATE(9539),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7448] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9540),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9540),
    [sym_operator_assignment] = STATE(9540),
    [sym_conditional] = STATE(9540),
    [sym_range] = STATE(9540),
    [sym_binary] = STATE(9540),
    [sym_unary] = STATE(9540),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7449] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9541),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9541),
    [sym_operator_assignment] = STATE(9541),
    [sym_conditional] = STATE(9541),
    [sym_range] = STATE(9541),
    [sym_binary] = STATE(9541),
    [sym_unary] = STATE(9541),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7450] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9542),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9542),
    [sym_operator_assignment] = STATE(9542),
    [sym_conditional] = STATE(9542),
    [sym_range] = STATE(9542),
    [sym_binary] = STATE(9542),
    [sym_unary] = STATE(9542),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7451] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9543),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9543),
    [sym_operator_assignment] = STATE(9543),
    [sym_conditional] = STATE(9543),
    [sym_range] = STATE(9543),
    [sym_binary] = STATE(9543),
    [sym_unary] = STATE(9543),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7452] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9544),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9544),
    [sym_operator_assignment] = STATE(9544),
    [sym_conditional] = STATE(9544),
    [sym_range] = STATE(9544),
    [sym_binary] = STATE(9544),
    [sym_unary] = STATE(9544),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7453] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9545),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9545),
    [sym_operator_assignment] = STATE(9545),
    [sym_conditional] = STATE(9545),
    [sym_range] = STATE(9545),
    [sym_binary] = STATE(9545),
    [sym_unary] = STATE(9545),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7454] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9546),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9546),
    [sym_operator_assignment] = STATE(9546),
    [sym_conditional] = STATE(9546),
    [sym_range] = STATE(9546),
    [sym_binary] = STATE(9546),
    [sym_unary] = STATE(9546),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7455] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9547),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9547),
    [sym_operator_assignment] = STATE(9547),
    [sym_conditional] = STATE(9547),
    [sym_range] = STATE(9547),
    [sym_binary] = STATE(9547),
    [sym_unary] = STATE(9547),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7456] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9548),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9548),
    [sym_operator_assignment] = STATE(9548),
    [sym_conditional] = STATE(9548),
    [sym_range] = STATE(9548),
    [sym_binary] = STATE(9548),
    [sym_unary] = STATE(9548),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7457] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9549),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_splat_argument] = STATE(9550),
    [sym_assignment] = STATE(9549),
    [sym_operator_assignment] = STATE(9549),
    [sym_conditional] = STATE(9549),
    [sym_range] = STATE(9549),
    [sym_binary] = STATE(9549),
    [sym_unary] = STATE(9549),
    [sym_right_assignment_list] = STATE(7709),
    [sym__arg_or_splat_arg] = STATE(9550),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7458] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9551),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(9551),
    [sym_operator_assignment] = STATE(9551),
    [sym_conditional] = STATE(9551),
    [sym_range] = STATE(9551),
    [sym_binary] = STATE(9551),
    [sym_unary] = STATE(9551),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7459] = {
    [sym_string] = STATE(9552),
    [aux_sym_chained_string_repeat1] = STATE(9552),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [7460] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(10673),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [7461] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7462] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7463] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9553),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(9553),
    [sym_operator_assignment] = STATE(9553),
    [sym_conditional] = STATE(9553),
    [sym_range] = STATE(9553),
    [sym_binary] = STATE(9553),
    [sym_unary] = STATE(9553),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7464] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7465] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9554),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(9554),
    [sym_operator_assignment] = STATE(9554),
    [sym_conditional] = STATE(9554),
    [sym_range] = STATE(9554),
    [sym_binary] = STATE(9554),
    [sym_unary] = STATE(9554),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7466] = {
    [sym_heredoc_body] = STATE(9555),
    [aux_sym_call_repeat1] = STATE(9555),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7467] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9556),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12650),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7468] = {
    [sym_heredoc_body] = STATE(9557),
    [aux_sym_call_repeat1] = STATE(9557),
    [aux_sym_argument_list_repeat1] = STATE(9558),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10697),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7469] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7470] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7471] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7472] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7473] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7474] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7475] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(10673),
    [anon_sym_or] = ACTIONS(10673),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [7476] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12652),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7477] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7478] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7479] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7480] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7481] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7482] = {
    [sym_heredoc_body] = STATE(7482),
    [aux_sym_call_repeat1] = STATE(7482),
    [sym__heredoc_body_start2] = ACTIONS(10775),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_EQ] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7483] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2208),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(7612),
    [sym_splat_argument] = STATE(7612),
    [sym_hash_splat_argument] = STATE(7612),
    [sym_block_argument] = STATE(7612),
    [sym_assignment] = STATE(2208),
    [sym_operator_assignment] = STATE(2208),
    [sym_conditional] = STATE(2208),
    [sym_range] = STATE(2208),
    [sym_binary] = STATE(2208),
    [sym_unary] = STATE(2208),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2213),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7612),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(3634),
    [sym__splat_star2] = ACTIONS(3636),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(3640),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(3642),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3660),
    [sym_identifier] = ACTIONS(3660),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7484] = {
    [sym_heredoc_body] = STATE(7482),
    [aux_sym_call_repeat1] = STATE(7482),
    [sym__heredoc_body_start2] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_EQ] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7485] = {
    [aux_sym_argument_list_repeat1] = STATE(7485),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(12654),
    [anon_sym_EQ] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7486] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7487] = {
    [aux_sym_exceptions_repeat1] = STATE(9561),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7488] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [7489] = {
    [sym_string] = STATE(7489),
    [aux_sym_chained_string_repeat1] = STATE(7489),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7490] = {
    [sym_heredoc_body] = STATE(9562),
    [aux_sym_call_repeat1] = STATE(9562),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7491] = {
    [sym_heredoc_body] = STATE(9563),
    [aux_sym_call_repeat1] = STATE(9563),
    [aux_sym_argument_list_repeat1] = STATE(4789),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(3734),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7492] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7493] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7494] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7495] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7496] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7497] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7498] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12657),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7499] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7500] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7501] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7502] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7503] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7504] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7505] = {
    [aux_sym_exceptions_repeat1] = STATE(9566),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7506] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [7507] = {
    [sym_string] = STATE(7507),
    [aux_sym_chained_string_repeat1] = STATE(7507),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7508] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [7509] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [7510] = {
    [sym_heredoc_body] = STATE(7510),
    [aux_sym_call_repeat1] = STATE(7510),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7511] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2236),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(2236),
    [sym_operator_assignment] = STATE(2236),
    [sym_conditional] = STATE(2236),
    [sym_range] = STATE(2236),
    [sym_binary] = STATE(2236),
    [sym_unary] = STATE(2236),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2239),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(3684),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [sym__identifier_hash_key2] = ACTIONS(3688),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10701),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(3690),
    [sym_identifier] = ACTIONS(3690),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7512] = {
    [sym_heredoc_body] = STATE(7510),
    [aux_sym_call_repeat1] = STATE(7510),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7513] = {
    [aux_sym_argument_list_repeat1] = STATE(7513),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12659),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7514] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9567),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_assignment] = STATE(9567),
    [sym_operator_assignment] = STATE(9567),
    [sym_conditional] = STATE(9567),
    [sym_range] = STATE(9567),
    [sym_binary] = STATE(9567),
    [sym_unary] = STATE(9567),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7515] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [7516] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [7517] = {
    [sym_heredoc_body] = STATE(7517),
    [aux_sym_call_repeat1] = STATE(7517),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7518] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2260),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(2260),
    [sym_operator_assignment] = STATE(2260),
    [sym_conditional] = STATE(2260),
    [sym_range] = STATE(2260),
    [sym_binary] = STATE(2260),
    [sym_unary] = STATE(2260),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2263),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(3726),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [sym__identifier_hash_key2] = ACTIONS(3730),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10705),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(3732),
    [sym_identifier] = ACTIONS(3732),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7519] = {
    [sym_heredoc_body] = STATE(7517),
    [aux_sym_call_repeat1] = STATE(7517),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7520] = {
    [aux_sym_argument_list_repeat1] = STATE(7520),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12662),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7521] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(4790),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(730),
    [sym_scope_resolution] = STATE(726),
    [sym_call] = STATE(726),
    [sym_method_call] = STATE(730),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(4790),
    [sym_operator_assignment] = STATE(4790),
    [sym_conditional] = STATE(4790),
    [sym_range] = STATE(4790),
    [sym_binary] = STATE(4790),
    [sym_unary] = STATE(4790),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(729),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(730),
    [sym__variable] = STATE(726),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(730),
    [sym_false] = STATE(730),
    [sym_nil] = STATE(730),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2228),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(3686),
    [sym__unary_minus2] = ACTIONS(1313),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1317),
    [anon_sym_yield] = ACTIONS(1319),
    [anon_sym_break] = ACTIONS(1321),
    [anon_sym_next] = ACTIONS(1323),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3680),
    [anon_sym_defined_QMARK] = ACTIONS(1325),
    [anon_sym_not] = ACTIONS(1327),
    [anon_sym_BANG] = ACTIONS(1331),
    [anon_sym_TILDE] = ACTIONS(1331),
    [sym_constant] = ACTIONS(1337),
    [sym_identifier] = ACTIONS(1337),
    [sym_instance_variable] = ACTIONS(1335),
    [sym_class_variable] = ACTIONS(1335),
    [sym_global_variable] = ACTIONS(1335),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1337),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1337),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7522] = {
    [aux_sym_exceptions_repeat1] = STATE(9568),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12665),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7523] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(1355),
    [sym__binary_star2] = ACTIONS(1357),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(1359),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(1361),
    [anon_sym_AMP] = ACTIONS(1363),
    [anon_sym_LT] = ACTIONS(1365),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(1367),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1371),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1375),
    [anon_sym_AMP_AMP] = ACTIONS(1375),
    [anon_sym_LT_LT] = ACTIONS(1377),
    [anon_sym_GT_GT] = ACTIONS(1377),
    [anon_sym_EQ_EQ] = ACTIONS(1379),
    [anon_sym_BANG_EQ] = ACTIONS(1375),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1375),
    [anon_sym_LT_EQ_GT] = ACTIONS(1375),
    [anon_sym_EQ_TILDE] = ACTIONS(1375),
    [anon_sym_BANG_TILDE] = ACTIONS(1375),
    [anon_sym_LT_EQ] = ACTIONS(1365),
    [anon_sym_GT] = ACTIONS(1365),
    [anon_sym_GT_EQ] = ACTIONS(1381),
    [anon_sym_CARET] = ACTIONS(1383),
    [anon_sym_PLUS] = ACTIONS(1385),
    [anon_sym_SLASH] = ACTIONS(1361),
    [anon_sym_PERCENT] = ACTIONS(1361),
    [sym_comment] = ACTIONS(87),
  },
  [7524] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7525] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [7526] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7527] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [7528] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7529] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7530] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12667),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7531] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7532] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7533] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7534] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7535] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7536] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7537] = {
    [aux_sym_exceptions_repeat1] = STATE(9571),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [7538] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [7539] = {
    [sym_string] = STATE(7539),
    [aux_sym_chained_string_repeat1] = STATE(7539),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [7540] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9572),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_assignment] = STATE(9572),
    [sym_operator_assignment] = STATE(9572),
    [sym_conditional] = STATE(9572),
    [sym_range] = STATE(9572),
    [sym_binary] = STATE(9572),
    [sym_unary] = STATE(9572),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7541] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(4833),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(773),
    [sym_scope_resolution] = STATE(769),
    [sym_call] = STATE(769),
    [sym_method_call] = STATE(773),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(4833),
    [sym_operator_assignment] = STATE(4833),
    [sym_conditional] = STATE(4833),
    [sym_range] = STATE(4833),
    [sym_binary] = STATE(4833),
    [sym_unary] = STATE(4833),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(772),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(773),
    [sym__variable] = STATE(769),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(773),
    [sym_false] = STATE(773),
    [sym_nil] = STATE(773),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2305),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(3728),
    [sym__unary_minus2] = ACTIONS(1391),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1395),
    [anon_sym_yield] = ACTIONS(1397),
    [anon_sym_break] = ACTIONS(1399),
    [anon_sym_next] = ACTIONS(1401),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(3772),
    [anon_sym_defined_QMARK] = ACTIONS(1403),
    [anon_sym_not] = ACTIONS(1405),
    [anon_sym_BANG] = ACTIONS(1409),
    [anon_sym_TILDE] = ACTIONS(1409),
    [sym_constant] = ACTIONS(1415),
    [sym_identifier] = ACTIONS(1415),
    [sym_instance_variable] = ACTIONS(1413),
    [sym_class_variable] = ACTIONS(1413),
    [sym_global_variable] = ACTIONS(1413),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1415),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1415),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7542] = {
    [aux_sym_exceptions_repeat1] = STATE(9573),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12669),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [7543] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7544] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7545] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7546] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7547] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7548] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7549] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12671),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7550] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7551] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7552] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7553] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7554] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7555] = {
    [aux_sym_exceptions_repeat1] = STATE(7555),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(12673),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [7556] = {
    [aux_sym_exceptions_repeat1] = STATE(4854),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7557] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [7558] = {
    [anon_sym_DOT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [sym_comment] = ACTIONS(87),
  },
  [7559] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12676),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7560] = {
    [anon_sym_DOT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [sym_comment] = ACTIONS(87),
  },
  [7561] = {
    [anon_sym_DOT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [sym_comment] = ACTIONS(87),
  },
  [7562] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12678),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7563] = {
    [anon_sym_DOT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [sym_comment] = ACTIONS(87),
  },
  [7564] = {
    [sym__method_rest] = STATE(9577),
    [sym_operator] = STATE(800),
    [sym__method_name] = STATE(800),
    [sym_setter] = STATE(800),
    [sym_symbol] = STATE(800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(7513),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(7513),
    [sym_class_variable] = ACTIONS(7513),
    [sym_global_variable] = ACTIONS(7513),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7565] = {
    [anon_sym_DOT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [sym_comment] = ACTIONS(87),
  },
  [7566] = {
    [anon_sym_DOT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [sym_comment] = ACTIONS(87),
  },
  [7567] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7568] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7569] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9578),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(9578),
    [sym_operator_assignment] = STATE(9578),
    [sym_conditional] = STATE(9578),
    [sym_range] = STATE(9578),
    [sym_binary] = STATE(9578),
    [sym_unary] = STATE(9578),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7570] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7571] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9579),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(9579),
    [sym_operator_assignment] = STATE(9579),
    [sym_conditional] = STATE(9579),
    [sym_range] = STATE(9579),
    [sym_binary] = STATE(9579),
    [sym_unary] = STATE(9579),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7572] = {
    [sym_heredoc_body] = STATE(9580),
    [aux_sym_call_repeat1] = STATE(9580),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7573] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9581),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12680),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7574] = {
    [sym_heredoc_body] = STATE(9582),
    [aux_sym_call_repeat1] = STATE(9582),
    [aux_sym_argument_list_repeat1] = STATE(9583),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10739),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7575] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7576] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7577] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7578] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7579] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7580] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7581] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12682),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7582] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7583] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7584] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7585] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7586] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7587] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9585),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(9585),
    [sym_operator_assignment] = STATE(9585),
    [sym_conditional] = STATE(9585),
    [sym_range] = STATE(9585),
    [sym_binary] = STATE(9585),
    [sym_unary] = STATE(9585),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7588] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7589] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7590] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7591] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(4907),
    [sym__argument] = STATE(4908),
    [sym_splat_argument] = STATE(4908),
    [sym_hash_splat_argument] = STATE(4908),
    [sym_block_argument] = STATE(4908),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4908),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7592] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9586),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(9586),
    [sym_operator_assignment] = STATE(9586),
    [sym_conditional] = STATE(9586),
    [sym_range] = STATE(9586),
    [sym_binary] = STATE(9586),
    [sym_unary] = STATE(9586),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7593] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9587),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(9587),
    [sym_operator_assignment] = STATE(9587),
    [sym_conditional] = STATE(9587),
    [sym_range] = STATE(9587),
    [sym_binary] = STATE(9587),
    [sym_unary] = STATE(9587),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7594] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7595] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [7596] = {
    [anon_sym_EQ] = ACTIONS(12712),
    [sym_comment] = ACTIONS(87),
  },
  [7597] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12714),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12716),
    [anon_sym_DASH_EQ] = ACTIONS(12716),
    [anon_sym_STAR_EQ] = ACTIONS(12716),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12716),
    [anon_sym_SLASH_EQ] = ACTIONS(12716),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12716),
    [anon_sym_PIPE_EQ] = ACTIONS(12716),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12716),
    [anon_sym_AMP_EQ] = ACTIONS(12716),
    [anon_sym_PERCENT_EQ] = ACTIONS(12716),
    [anon_sym_GT_GT_EQ] = ACTIONS(12716),
    [anon_sym_LT_LT_EQ] = ACTIONS(12716),
    [anon_sym_CARET_EQ] = ACTIONS(12716),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7598] = {
    [sym_string] = STATE(9602),
    [aux_sym_chained_string_repeat1] = STATE(9602),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7599] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [7600] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9603),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(9603),
    [sym_operator_assignment] = STATE(9603),
    [sym_conditional] = STATE(9603),
    [sym_range] = STATE(9603),
    [sym_binary] = STATE(9603),
    [sym_unary] = STATE(9603),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7601] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [7602] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9604),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(9604),
    [sym_operator_assignment] = STATE(9604),
    [sym_conditional] = STATE(9604),
    [sym_range] = STATE(9604),
    [sym_binary] = STATE(9604),
    [sym_unary] = STATE(9604),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [7603] = {
    [sym_heredoc_body] = STATE(9605),
    [aux_sym_call_repeat1] = STATE(9605),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7604] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(9606),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12718),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7605] = {
    [sym_heredoc_body] = STATE(9607),
    [aux_sym_call_repeat1] = STATE(9607),
    [aux_sym_argument_list_repeat1] = STATE(9608),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10767),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7606] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7607] = {
    [aux_sym_exceptions_repeat1] = STATE(9610),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7608] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [7609] = {
    [sym_string] = STATE(7609),
    [aux_sym_chained_string_repeat1] = STATE(7609),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7610] = {
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10934),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_EQ] = ACTIONS(10934),
    [anon_sym_in] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
  },
  [7611] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_EQ] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [7612] = {
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_EQ] = ACTIONS(10962),
    [anon_sym_in] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [7613] = {
    [anon_sym_DOT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [sym_comment] = ACTIONS(87),
  },
  [7614] = {
    [anon_sym_end] = ACTIONS(12720),
    [sym_comment] = ACTIONS(87),
  },
  [7615] = {
    [sym_elsif] = STATE(9612),
    [sym_else] = STATE(9612),
    [sym__if_tail] = STATE(9612),
    [anon_sym_end] = ACTIONS(12720),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [7616] = {
    [anon_sym_DOT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [7617] = {
    [anon_sym_end] = ACTIONS(12722),
    [sym_comment] = ACTIONS(87),
  },
  [7618] = {
    [anon_sym_DOT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [sym_comment] = ACTIONS(87),
  },
  [7619] = {
    [anon_sym_DOT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [sym_comment] = ACTIONS(87),
  },
  [7620] = {
    [anon_sym_DOT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [7621] = {
    [anon_sym_end] = ACTIONS(12724),
    [sym_comment] = ACTIONS(87),
  },
  [7622] = {
    [anon_sym_DOT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [7623] = {
    [anon_sym_end] = ACTIONS(12726),
    [sym_comment] = ACTIONS(87),
  },
  [7624] = {
    [anon_sym_DOT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [sym_comment] = ACTIONS(87),
  },
  [7625] = {
    [anon_sym_end] = ACTIONS(12728),
    [sym_comment] = ACTIONS(87),
  },
  [7626] = {
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_EQ] = ACTIONS(12071),
    [anon_sym_in] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [7627] = {
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12096),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12096),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_EQ] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [7628] = {
    [anon_sym_end] = ACTIONS(12730),
    [sym_comment] = ACTIONS(87),
  },
  [7629] = {
    [sym__statements] = STATE(9618),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12732),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7630] = {
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7850),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7850),
    [anon_sym_EQ] = ACTIONS(7850),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_in] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7850),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [7631] = {
    [anon_sym_RPAREN] = ACTIONS(12734),
    [sym_comment] = ACTIONS(87),
  },
  [7632] = {
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12249),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_EQ] = ACTIONS(12249),
    [anon_sym_in] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [sym_comment] = ACTIONS(87),
  },
  [7633] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [7634] = {
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_STAR_STAR] = ACTIONS(2959),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_LT_LT] = ACTIONS(2959),
    [anon_sym_GT_GT] = ACTIONS(2959),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2959),
    [anon_sym_SLASH] = ACTIONS(2959),
    [anon_sym_PERCENT] = ACTIONS(2959),
    [sym_comment] = ACTIONS(87),
  },
  [7635] = {
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_STAR_STAR] = ACTIONS(2963),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_LT_LT] = ACTIONS(2963),
    [anon_sym_GT_GT] = ACTIONS(2963),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2963),
    [anon_sym_SLASH] = ACTIONS(2963),
    [anon_sym_PERCENT] = ACTIONS(2963),
    [sym_comment] = ACTIONS(87),
  },
  [7636] = {
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_STAR_STAR] = ACTIONS(2967),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_LT_LT] = ACTIONS(2967),
    [anon_sym_GT_GT] = ACTIONS(2967),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2967),
    [anon_sym_SLASH] = ACTIONS(2967),
    [anon_sym_PERCENT] = ACTIONS(2967),
    [sym_comment] = ACTIONS(87),
  },
  [7637] = {
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_STAR_STAR] = ACTIONS(2973),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_LT_LT] = ACTIONS(2973),
    [anon_sym_GT_GT] = ACTIONS(2973),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2973),
    [anon_sym_SLASH] = ACTIONS(2973),
    [anon_sym_PERCENT] = ACTIONS(2973),
    [sym_comment] = ACTIONS(87),
  },
  [7638] = {
    [sym__string_end2] = ACTIONS(12736),
    [sym_comment] = ACTIONS(87),
  },
  [7639] = {
    [aux_sym_string_array_repeat1] = STATE(9623),
    [sym__string_end2] = ACTIONS(12738),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12740),
  },
  [7640] = {
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_STAR_STAR] = ACTIONS(2983),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2983),
    [anon_sym_AMP_AMP] = ACTIONS(2983),
    [anon_sym_LT_LT] = ACTIONS(2983),
    [anon_sym_GT_GT] = ACTIONS(2983),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2983),
    [anon_sym_PLUS] = ACTIONS(2983),
    [anon_sym_SLASH] = ACTIONS(2983),
    [anon_sym_PERCENT] = ACTIONS(2983),
    [sym_comment] = ACTIONS(87),
  },
  [7641] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12742),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7642] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(12742),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12744),
  },
  [7643] = {
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_STAR_STAR] = ACTIONS(3002),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3002),
    [anon_sym_AMP_AMP] = ACTIONS(3002),
    [anon_sym_LT_LT] = ACTIONS(3002),
    [anon_sym_GT_GT] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3002),
    [anon_sym_PLUS] = ACTIONS(3002),
    [anon_sym_SLASH] = ACTIONS(3002),
    [anon_sym_PERCENT] = ACTIONS(3002),
    [sym_comment] = ACTIONS(87),
  },
  [7644] = {
    [sym__string_end2] = ACTIONS(12746),
    [sym_comment] = ACTIONS(87),
  },
  [7645] = {
    [aux_sym_symbol_array_repeat1] = STATE(9629),
    [sym__string_end2] = ACTIONS(12748),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12750),
  },
  [7646] = {
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_STAR_STAR] = ACTIONS(3012),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3012),
    [anon_sym_AMP_AMP] = ACTIONS(3012),
    [anon_sym_LT_LT] = ACTIONS(3012),
    [anon_sym_GT_GT] = ACTIONS(3012),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3012),
    [anon_sym_PLUS] = ACTIONS(3012),
    [anon_sym_SLASH] = ACTIONS(3012),
    [anon_sym_PERCENT] = ACTIONS(3012),
    [sym_comment] = ACTIONS(87),
  },
  [7647] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(12752),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [7648] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(12752),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(12754),
  },
  [7649] = {
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_STAR_STAR] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3504),
    [anon_sym_AMP_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [sym_comment] = ACTIONS(87),
  },
  [7650] = {
    [anon_sym_RBRACE] = ACTIONS(12756),
    [sym_comment] = ACTIONS(87),
  },
  [7651] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(12758),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [7652] = {
    [sym__method_rest] = STATE(9634),
    [sym_operator] = STATE(4976),
    [sym__method_name] = STATE(4976),
    [sym_setter] = STATE(4976),
    [sym_symbol] = STATE(4976),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12760),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12760),
    [sym_class_variable] = ACTIONS(12760),
    [sym_global_variable] = ACTIONS(12760),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [7653] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(9635),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12762),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7654] = {
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_STAR_STAR] = ACTIONS(3744),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3744),
    [anon_sym_AMP_AMP] = ACTIONS(3744),
    [anon_sym_LT_LT] = ACTIONS(3744),
    [anon_sym_GT_GT] = ACTIONS(3744),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3744),
    [anon_sym_PLUS] = ACTIONS(3744),
    [anon_sym_SLASH] = ACTIONS(3744),
    [anon_sym_PERCENT] = ACTIONS(3744),
    [sym_comment] = ACTIONS(87),
  },
  [7655] = {
    [sym_heredoc_body] = STATE(9636),
    [sym__terminator] = STATE(9636),
    [sym__line_break2] = ACTIONS(12764),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(12764),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [7656] = {
    [sym_heredoc_body] = STATE(9637),
    [sym__terminator] = STATE(9637),
    [sym__line_break2] = ACTIONS(12766),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12766),
    [sym_comment] = ACTIONS(87),
  },
  [7657] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(9638),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12768),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7658] = {
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_STAR_STAR] = ACTIONS(4158),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4158),
    [anon_sym_AMP_AMP] = ACTIONS(4158),
    [anon_sym_LT_LT] = ACTIONS(4158),
    [anon_sym_GT_GT] = ACTIONS(4158),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4158),
    [anon_sym_SLASH] = ACTIONS(4158),
    [anon_sym_PERCENT] = ACTIONS(4158),
    [sym_comment] = ACTIONS(87),
  },
  [7659] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(9639),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12770),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7660] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7661] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7662] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9640),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(9640),
    [sym_operator_assignment] = STATE(9640),
    [sym_conditional] = STATE(9640),
    [sym_range] = STATE(9640),
    [sym_binary] = STATE(9640),
    [sym_unary] = STATE(9640),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7663] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7664] = {
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym__binary_minus2] = ACTIONS(4242),
    [sym__binary_star2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_RPAREN] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4244),
    [anon_sym_COMMA] = ACTIONS(4242),
    [anon_sym_PIPE] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4242),
    [anon_sym_AMP] = ACTIONS(4244),
    [anon_sym_EQ] = ACTIONS(4244),
    [anon_sym_LT] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_QMARK] = ACTIONS(4242),
    [anon_sym_DOT_DOT] = ACTIONS(4244),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4242),
    [anon_sym_and] = ACTIONS(4242),
    [anon_sym_or] = ACTIONS(4242),
    [anon_sym_PIPE_PIPE] = ACTIONS(4242),
    [anon_sym_AMP_AMP] = ACTIONS(4242),
    [anon_sym_LT_LT] = ACTIONS(4242),
    [anon_sym_GT_GT] = ACTIONS(4242),
    [anon_sym_EQ_EQ] = ACTIONS(4244),
    [anon_sym_BANG_EQ] = ACTIONS(4242),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4242),
    [anon_sym_LT_EQ_GT] = ACTIONS(4242),
    [anon_sym_EQ_TILDE] = ACTIONS(4242),
    [anon_sym_BANG_TILDE] = ACTIONS(4242),
    [anon_sym_LT_EQ] = ACTIONS(4244),
    [anon_sym_GT] = ACTIONS(4244),
    [anon_sym_GT_EQ] = ACTIONS(4242),
    [anon_sym_CARET] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4242),
    [anon_sym_SLASH] = ACTIONS(4242),
    [anon_sym_PERCENT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
  },
  [7665] = {
    [sym_heredoc_body] = STATE(9642),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [7666] = {
    [anon_sym_RPAREN] = ACTIONS(12772),
    [sym_comment] = ACTIONS(87),
  },
  [7667] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9643),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(9643),
    [sym_operator_assignment] = STATE(9643),
    [sym_conditional] = STATE(9643),
    [sym_range] = STATE(9643),
    [sym_binary] = STATE(9643),
    [sym_unary] = STATE(9643),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [7668] = {
    [sym_interpolation] = STATE(9645),
    [aux_sym_heredoc_body_repeat1] = STATE(9645),
    [sym__heredoc_content2] = ACTIONS(12774),
    [sym_heredoc_end2] = ACTIONS(12776),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(12774),
  },
  [7669] = {
    [sym_heredoc_body] = STATE(9646),
    [aux_sym_call_repeat1] = STATE(9646),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7670] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(9647),
    [sym_splat_argument] = STATE(9647),
    [sym_hash_splat_argument] = STATE(9647),
    [sym_block_argument] = STATE(9647),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9648),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(9647),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12778),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7671] = {
    [sym_heredoc_body] = STATE(9649),
    [aux_sym_call_repeat1] = STATE(9649),
    [aux_sym_argument_list_repeat1] = STATE(9650),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10857),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7672] = {
    [sym__statements] = STATE(9652),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(9653),
    [sym_else] = STATE(9653),
    [sym__if_tail] = STATE(9653),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9654),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9654),
    [sym__line_break2] = ACTIONS(12780),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12782),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7673] = {
    [sym__statements] = STATE(9656),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(9657),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12784),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7674] = {
    [sym__statements] = STATE(9659),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12786),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7675] = {
    [sym__statements] = STATE(9661),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12788),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7676] = {
    [sym__do] = STATE(9662),
    [sym_heredoc_body] = STATE(9662),
    [sym__terminator] = STATE(9662),
    [sym__line_break2] = ACTIONS(12790),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(12790),
    [anon_sym_do] = ACTIONS(12790),
    [sym_comment] = ACTIONS(87),
  },
  [7677] = {
    [sym_when] = STATE(9663),
    [aux_sym_case_repeat1] = STATE(9664),
    [anon_sym_SEMI] = ACTIONS(12792),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [7678] = {
    [anon_sym_end] = ACTIONS(12794),
    [sym_comment] = ACTIONS(87),
  },
  [7679] = {
    [sym_when] = STATE(9663),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [7680] = {
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_STAR_STAR] = ACTIONS(5410),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5410),
    [anon_sym_AMP_AMP] = ACTIONS(5410),
    [anon_sym_LT_LT] = ACTIONS(5410),
    [anon_sym_GT_GT] = ACTIONS(5410),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5410),
    [anon_sym_PLUS] = ACTIONS(5410),
    [anon_sym_SLASH] = ACTIONS(5410),
    [anon_sym_PERCENT] = ACTIONS(5410),
    [sym_comment] = ACTIONS(87),
  },
  [7681] = {
    [sym_ensure] = STATE(9667),
    [anon_sym_end] = ACTIONS(12796),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [7682] = {
    [anon_sym_end] = ACTIONS(12796),
    [sym_comment] = ACTIONS(87),
  },
  [7683] = {
    [sym_else] = STATE(9668),
    [sym_ensure] = STATE(9667),
    [anon_sym_end] = ACTIONS(12796),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [7684] = {
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_STAR_STAR] = ACTIONS(5498),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5498),
    [anon_sym_AMP_AMP] = ACTIONS(5498),
    [anon_sym_LT_LT] = ACTIONS(5498),
    [anon_sym_GT_GT] = ACTIONS(5498),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5498),
    [anon_sym_PLUS] = ACTIONS(5498),
    [anon_sym_SLASH] = ACTIONS(5498),
    [anon_sym_PERCENT] = ACTIONS(5498),
    [sym_comment] = ACTIONS(87),
  },
  [7685] = {
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_STAR_STAR] = ACTIONS(5738),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5738),
    [anon_sym_AMP_AMP] = ACTIONS(5738),
    [anon_sym_LT_LT] = ACTIONS(5738),
    [anon_sym_GT_GT] = ACTIONS(5738),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5738),
    [anon_sym_PLUS] = ACTIONS(5738),
    [anon_sym_SLASH] = ACTIONS(5738),
    [anon_sym_PERCENT] = ACTIONS(5738),
    [sym_comment] = ACTIONS(87),
  },
  [7686] = {
    [anon_sym_RBRACK] = ACTIONS(12798),
    [sym_comment] = ACTIONS(87),
  },
  [7687] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_STAR_STAR] = ACTIONS(5750),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5750),
    [anon_sym_AMP_AMP] = ACTIONS(5750),
    [anon_sym_LT_LT] = ACTIONS(5750),
    [anon_sym_GT_GT] = ACTIONS(5750),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5750),
    [anon_sym_PLUS] = ACTIONS(5750),
    [anon_sym_SLASH] = ACTIONS(5750),
    [anon_sym_PERCENT] = ACTIONS(5750),
    [sym_comment] = ACTIONS(87),
  },
  [7688] = {
    [anon_sym_RBRACE] = ACTIONS(12800),
    [sym_comment] = ACTIONS(87),
  },
  [7689] = {
    [sym__statements] = STATE(9671),
    [sym__top_level_statement] = STATE(506),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(507),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(508),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(511),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(511),
    [sym_assignment] = STATE(508),
    [sym_operator_assignment] = STATE(508),
    [sym_conditional] = STATE(508),
    [sym_range] = STATE(508),
    [sym_binary] = STATE(508),
    [sym_unary] = STATE(508),
    [sym_left_assignment_list] = STATE(510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(511),
    [sym__variable] = STATE(509),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(511),
    [sym_false] = STATE(511),
    [sym_nil] = STATE(511),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(512),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(945),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(12800),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(949),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_break] = ACTIONS(953),
    [anon_sym_next] = ACTIONS(955),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(957),
    [anon_sym_defined_QMARK] = ACTIONS(959),
    [anon_sym_not] = ACTIONS(961),
    [anon_sym_BANG] = ACTIONS(963),
    [anon_sym_TILDE] = ACTIONS(963),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [anon_sym_undef] = ACTIONS(969),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7690] = {
    [sym__heredoc_body_start2] = ACTIONS(5786),
    [sym__binary_minus2] = ACTIONS(5786),
    [sym__binary_star2] = ACTIONS(5786),
    [anon_sym_LBRACE] = ACTIONS(5786),
    [anon_sym_RPAREN] = ACTIONS(5786),
    [anon_sym_DOT] = ACTIONS(5788),
    [anon_sym_COMMA] = ACTIONS(5786),
    [anon_sym_PIPE] = ACTIONS(5788),
    [anon_sym_STAR_STAR] = ACTIONS(5786),
    [anon_sym_AMP] = ACTIONS(5788),
    [anon_sym_EQ] = ACTIONS(5788),
    [anon_sym_LT] = ACTIONS(5788),
    [anon_sym_do] = ACTIONS(5786),
    [anon_sym_LBRACK] = ACTIONS(5786),
    [anon_sym_COLON_COLON2] = ACTIONS(5786),
    [anon_sym_AMP_DOT] = ACTIONS(5786),
    [anon_sym_QMARK] = ACTIONS(5786),
    [anon_sym_DOT_DOT] = ACTIONS(5788),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5786),
    [anon_sym_and] = ACTIONS(5786),
    [anon_sym_or] = ACTIONS(5786),
    [anon_sym_PIPE_PIPE] = ACTIONS(5786),
    [anon_sym_AMP_AMP] = ACTIONS(5786),
    [anon_sym_LT_LT] = ACTIONS(5786),
    [anon_sym_GT_GT] = ACTIONS(5786),
    [anon_sym_EQ_EQ] = ACTIONS(5788),
    [anon_sym_BANG_EQ] = ACTIONS(5786),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5786),
    [anon_sym_LT_EQ_GT] = ACTIONS(5786),
    [anon_sym_EQ_TILDE] = ACTIONS(5786),
    [anon_sym_BANG_TILDE] = ACTIONS(5786),
    [anon_sym_LT_EQ] = ACTIONS(5788),
    [anon_sym_GT] = ACTIONS(5788),
    [anon_sym_GT_EQ] = ACTIONS(5786),
    [anon_sym_CARET] = ACTIONS(5786),
    [anon_sym_PLUS] = ACTIONS(5786),
    [anon_sym_SLASH] = ACTIONS(5786),
    [anon_sym_PERCENT] = ACTIONS(5786),
    [sym_comment] = ACTIONS(87),
  },
  [7691] = {
    [anon_sym_end] = ACTIONS(12802),
    [sym_comment] = ACTIONS(87),
  },
  [7692] = {
    [sym__statements] = STATE(9673),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(9674),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(9674),
    [sym__line_break2] = ACTIONS(12804),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12806),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7693] = {
    [sym__statements] = STATE(9673),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_block_parameters] = STATE(9675),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_PIPE] = ACTIONS(2521),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12806),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7694] = {
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_STAR_STAR] = ACTIONS(5822),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5822),
    [anon_sym_AMP_AMP] = ACTIONS(5822),
    [anon_sym_LT_LT] = ACTIONS(5822),
    [anon_sym_GT_GT] = ACTIONS(5822),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5822),
    [anon_sym_PLUS] = ACTIONS(5822),
    [anon_sym_SLASH] = ACTIONS(5822),
    [anon_sym_PERCENT] = ACTIONS(5822),
    [sym_comment] = ACTIONS(87),
  },
  [7695] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7696] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7697] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7698] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7699] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7700] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7701] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12808),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7702] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7703] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7704] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7705] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7706] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7707] = {
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_RBRACE] = ACTIONS(5750),
    [anon_sym_RPAREN] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_if] = ACTIONS(5750),
    [anon_sym_unless] = ACTIONS(5750),
    [anon_sym_while] = ACTIONS(5750),
    [anon_sym_until] = ACTIONS(5750),
    [anon_sym_rescue] = ACTIONS(5750),
    [anon_sym_in] = ACTIONS(5750),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_RBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_COLON2] = ACTIONS(5752),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [7708] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7709] = {
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7710] = {
    [aux_sym_exceptions_repeat1] = STATE(9678),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7711] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [7712] = {
    [sym_string] = STATE(7712),
    [aux_sym_chained_string_repeat1] = STATE(7712),
    [sym__string_start2] = ACTIONS(12810),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7713] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [7714] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [7715] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7716] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2469),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(2469),
    [sym_operator_assignment] = STATE(2469),
    [sym_conditional] = STATE(2469),
    [sym_range] = STATE(2469),
    [sym_binary] = STATE(2469),
    [sym_unary] = STATE(2469),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2472),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4016),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(4020),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10889),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(4024),
    [sym_identifier] = ACTIONS(4024),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7717] = {
    [sym_heredoc_body] = STATE(7715),
    [aux_sym_call_repeat1] = STATE(7715),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7718] = {
    [aux_sym_argument_list_repeat1] = STATE(7718),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12813),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7719] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9679),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_assignment] = STATE(9679),
    [sym_operator_assignment] = STATE(9679),
    [sym_conditional] = STATE(9679),
    [sym_range] = STATE(9679),
    [sym_binary] = STATE(9679),
    [sym_unary] = STATE(9679),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7720] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5065),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(5065),
    [sym_operator_assignment] = STATE(5065),
    [sym_conditional] = STATE(5065),
    [sym_range] = STATE(5065),
    [sym_binary] = STATE(5065),
    [sym_unary] = STATE(5065),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2460),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4018),
    [sym__unary_minus2] = ACTIONS(1501),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7721] = {
    [aux_sym_exceptions_repeat1] = STATE(9680),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12816),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7722] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7723] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7724] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9681),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(9681),
    [sym_operator_assignment] = STATE(9681),
    [sym_conditional] = STATE(9681),
    [sym_range] = STATE(9681),
    [sym_binary] = STATE(9681),
    [sym_unary] = STATE(9681),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7725] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7726] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9682),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(9682),
    [sym_operator_assignment] = STATE(9682),
    [sym_conditional] = STATE(9682),
    [sym_range] = STATE(9682),
    [sym_binary] = STATE(9682),
    [sym_unary] = STATE(9682),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7727] = {
    [sym_heredoc_body] = STATE(9683),
    [aux_sym_call_repeat1] = STATE(9683),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7728] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9684),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12818),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7729] = {
    [sym_heredoc_body] = STATE(9685),
    [aux_sym_call_repeat1] = STATE(9685),
    [aux_sym_argument_list_repeat1] = STATE(9686),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(10910),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7730] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7731] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7732] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7733] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7734] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7735] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7736] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12820),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7737] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7738] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7739] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7740] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7741] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7742] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7743] = {
    [aux_sym_exceptions_repeat1] = STATE(9689),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7744] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [7745] = {
    [sym_string] = STATE(7745),
    [aux_sym_chained_string_repeat1] = STATE(7745),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7746] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [7747] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [7748] = {
    [sym_heredoc_body] = STATE(7748),
    [aux_sym_call_repeat1] = STATE(7748),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7749] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2524),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(2524),
    [sym_operator_assignment] = STATE(2524),
    [sym_conditional] = STATE(2524),
    [sym_range] = STATE(2524),
    [sym_binary] = STATE(2524),
    [sym_unary] = STATE(2524),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2527),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4102),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(4106),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10914),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(4110),
    [sym_identifier] = ACTIONS(4110),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7750] = {
    [sym_heredoc_body] = STATE(7748),
    [aux_sym_call_repeat1] = STATE(7748),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7751] = {
    [aux_sym_argument_list_repeat1] = STATE(7751),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12822),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7752] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9690),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_assignment] = STATE(9690),
    [sym_operator_assignment] = STATE(9690),
    [sym_conditional] = STATE(9690),
    [sym_range] = STATE(9690),
    [sym_binary] = STATE(9690),
    [sym_unary] = STATE(9690),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7753] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5124),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(5124),
    [sym_operator_assignment] = STATE(5124),
    [sym_conditional] = STATE(5124),
    [sym_range] = STATE(5124),
    [sym_binary] = STATE(5124),
    [sym_unary] = STATE(5124),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2515),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4104),
    [sym__unary_minus2] = ACTIONS(1541),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(1225),
    [sym_identifier] = ACTIONS(1225),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7754] = {
    [aux_sym_exceptions_repeat1] = STATE(9691),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12825),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7755] = {
    [sym_heredoc_body] = STATE(7755),
    [aux_sym_call_repeat1] = STATE(7755),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [ts_builtin_sym_end] = ACTIONS(7888),
    [anon_sym___END__] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7756] = {
    [sym_heredoc_body] = STATE(7755),
    [aux_sym_call_repeat1] = STATE(7755),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [ts_builtin_sym_end] = ACTIONS(7903),
    [anon_sym___END__] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7757] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9692),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_assignment] = STATE(9692),
    [sym_operator_assignment] = STATE(9692),
    [sym_conditional] = STATE(9692),
    [sym_range] = STATE(9692),
    [sym_binary] = STATE(9692),
    [sym_unary] = STATE(9692),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7758] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(5142),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(908),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(908),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(5142),
    [sym_operator_assignment] = STATE(5142),
    [sym_conditional] = STATE(5142),
    [sym_range] = STATE(5142),
    [sym_binary] = STATE(5142),
    [sym_unary] = STATE(5142),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(907),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(908),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(908),
    [sym_false] = STATE(908),
    [sym_nil] = STATE(908),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(369),
    [sym__unary_minus2] = ACTIONS(1571),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(1581),
    [anon_sym_defined_QMARK] = ACTIONS(1583),
    [anon_sym_not] = ACTIONS(1585),
    [anon_sym_BANG] = ACTIONS(1587),
    [anon_sym_TILDE] = ACTIONS(1587),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7759] = {
    [aux_sym_exceptions_repeat1] = STATE(9693),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [ts_builtin_sym_end] = ACTIONS(9929),
    [anon_sym___END__] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12827),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7760] = {
    [sym_heredoc_body] = STATE(9694),
    [aux_sym_call_repeat1] = STATE(9694),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7761] = {
    [sym_heredoc_body] = STATE(9695),
    [aux_sym_call_repeat1] = STATE(9695),
    [aux_sym_argument_list_repeat1] = STATE(7353),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(7158),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7762] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7763] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7764] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7765] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7766] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7767] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7768] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12829),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7769] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7770] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7771] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7772] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7773] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7774] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9697),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(9697),
    [sym_operator_assignment] = STATE(9697),
    [sym_conditional] = STATE(9697),
    [sym_range] = STATE(9697),
    [sym_binary] = STATE(9697),
    [sym_unary] = STATE(9697),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7775] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7776] = {
    [aux_sym_exceptions_repeat1] = STATE(9699),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7777] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [7778] = {
    [sym_string] = STATE(7778),
    [aux_sym_chained_string_repeat1] = STATE(7778),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7779] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7780] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [7781] = {
    [sym_heredoc_body] = STATE(7781),
    [aux_sym_call_repeat1] = STATE(7781),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7782] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(2602),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(2602),
    [sym_operator_assignment] = STATE(2602),
    [sym_conditional] = STATE(2602),
    [sym_range] = STATE(2602),
    [sym_binary] = STATE(2602),
    [sym_unary] = STATE(2602),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2605),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4246),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [sym__identifier_hash_key2] = ACTIONS(4250),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10928),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(4252),
    [sym_identifier] = ACTIONS(4252),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7783] = {
    [sym_heredoc_body] = STATE(7781),
    [aux_sym_call_repeat1] = STATE(7781),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7784] = {
    [aux_sym_argument_list_repeat1] = STATE(7784),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12831),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7785] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9700),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_assignment] = STATE(9700),
    [sym_operator_assignment] = STATE(9700),
    [sym_conditional] = STATE(9700),
    [sym_range] = STATE(9700),
    [sym_binary] = STATE(9700),
    [sym_unary] = STATE(9700),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7786] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7787] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [7788] = {
    [sym_heredoc_body] = STATE(7788),
    [aux_sym_call_repeat1] = STATE(7788),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7789] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2626),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(2626),
    [sym_operator_assignment] = STATE(2626),
    [sym_conditional] = STATE(2626),
    [sym_range] = STATE(2626),
    [sym_binary] = STATE(2626),
    [sym_unary] = STATE(2626),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(2629),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4290),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [sym__identifier_hash_key2] = ACTIONS(4294),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10932),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(4296),
    [sym_identifier] = ACTIONS(4296),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [7790] = {
    [sym_heredoc_body] = STATE(7788),
    [aux_sym_call_repeat1] = STATE(7788),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7791] = {
    [aux_sym_argument_list_repeat1] = STATE(7791),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12834),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7792] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [7793] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5205),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym_splat_argument] = STATE(8905),
    [sym_assignment] = STATE(5205),
    [sym_operator_assignment] = STATE(5205),
    [sym_conditional] = STATE(5205),
    [sym_range] = STATE(5205),
    [sym_binary] = STATE(5205),
    [sym_unary] = STATE(5205),
    [sym__arg_or_splat_arg] = STATE(8905),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(7856),
    [sym__unary_minus2] = ACTIONS(1609),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [7794] = {
    [aux_sym_exceptions_repeat1] = STATE(9701),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12837),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7795] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(1643),
    [sym__binary_star2] = ACTIONS(1645),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(1649),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(1651),
    [anon_sym_AMP] = ACTIONS(1653),
    [anon_sym_LT] = ACTIONS(1655),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(1659),
    [anon_sym_DOT_DOT] = ACTIONS(1661),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1663),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1665),
    [anon_sym_AMP_AMP] = ACTIONS(1665),
    [anon_sym_LT_LT] = ACTIONS(1667),
    [anon_sym_GT_GT] = ACTIONS(1667),
    [anon_sym_EQ_EQ] = ACTIONS(1669),
    [anon_sym_BANG_EQ] = ACTIONS(1665),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1665),
    [anon_sym_LT_EQ_GT] = ACTIONS(1665),
    [anon_sym_EQ_TILDE] = ACTIONS(1665),
    [anon_sym_BANG_TILDE] = ACTIONS(1665),
    [anon_sym_LT_EQ] = ACTIONS(1655),
    [anon_sym_GT] = ACTIONS(1655),
    [anon_sym_GT_EQ] = ACTIONS(1671),
    [anon_sym_CARET] = ACTIONS(1673),
    [anon_sym_PLUS] = ACTIONS(1675),
    [anon_sym_SLASH] = ACTIONS(1651),
    [anon_sym_PERCENT] = ACTIONS(1651),
    [sym_comment] = ACTIONS(87),
  },
  [7796] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [ts_builtin_sym_end] = ACTIONS(7850),
    [anon_sym___END__] = ACTIONS(7852),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_end] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_rescue] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_when] = ACTIONS(7852),
    [anon_sym_elsif] = ACTIONS(7852),
    [anon_sym_else] = ACTIONS(7852),
    [anon_sym_then] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_ensure] = ACTIONS(7852),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [7797] = {
    [anon_sym_RPAREN] = ACTIONS(12841),
    [sym_comment] = ACTIONS(87),
  },
  [7798] = {
    [sym__line_break2] = ACTIONS(12249),
    [sym__heredoc_body_start2] = ACTIONS(12249),
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [ts_builtin_sym_end] = ACTIONS(12249),
    [anon_sym___END__] = ACTIONS(12249),
    [anon_sym_LBRACE] = ACTIONS(12249),
    [anon_sym_RBRACE] = ACTIONS(12249),
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_end] = ACTIONS(12249),
    [anon_sym_if] = ACTIONS(12249),
    [anon_sym_unless] = ACTIONS(12249),
    [anon_sym_while] = ACTIONS(12249),
    [anon_sym_until] = ACTIONS(12249),
    [anon_sym_rescue] = ACTIONS(12249),
    [anon_sym_do] = ACTIONS(12249),
    [anon_sym_when] = ACTIONS(12249),
    [anon_sym_elsif] = ACTIONS(12249),
    [anon_sym_else] = ACTIONS(12249),
    [anon_sym_then] = ACTIONS(12249),
    [anon_sym_ensure] = ACTIONS(12249),
    [anon_sym_EQ_GT] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [7799] = {
    [sym__line_break2] = ACTIONS(12071),
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [ts_builtin_sym_end] = ACTIONS(12071),
    [anon_sym___END__] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_end] = ACTIONS(12071),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_when] = ACTIONS(12071),
    [anon_sym_elsif] = ACTIONS(12071),
    [anon_sym_else] = ACTIONS(12071),
    [anon_sym_then] = ACTIONS(12071),
    [anon_sym_ensure] = ACTIONS(12071),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [7800] = {
    [sym__line_break2] = ACTIONS(12096),
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [ts_builtin_sym_end] = ACTIONS(12096),
    [anon_sym___END__] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_end] = ACTIONS(12096),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_when] = ACTIONS(12096),
    [anon_sym_elsif] = ACTIONS(12096),
    [anon_sym_else] = ACTIONS(12096),
    [anon_sym_then] = ACTIONS(12096),
    [anon_sym_ensure] = ACTIONS(12096),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [7801] = {
    [anon_sym_end] = ACTIONS(12843),
    [sym_comment] = ACTIONS(87),
  },
  [7802] = {
    [sym__statements] = STATE(9704),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12845),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7803] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [ts_builtin_sym_end] = ACTIONS(10934),
    [anon_sym___END__] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_end] = ACTIONS(10934),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_when] = ACTIONS(10934),
    [anon_sym_elsif] = ACTIONS(10934),
    [anon_sym_else] = ACTIONS(10934),
    [anon_sym_then] = ACTIONS(10934),
    [anon_sym_ensure] = ACTIONS(10934),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [sym_comment] = ACTIONS(87),
  },
  [7804] = {
    [sym__line_break2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [ts_builtin_sym_end] = ACTIONS(6739),
    [anon_sym___END__] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(8705),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_end] = ACTIONS(6739),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_when] = ACTIONS(6739),
    [anon_sym_elsif] = ACTIONS(6739),
    [anon_sym_else] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_ensure] = ACTIONS(6739),
    [anon_sym_EQ_GT] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6739),
    [anon_sym_STAR_EQ] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6739),
    [anon_sym_CARET_EQ] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(8705),
    [anon_sym_AMP_AMP] = ACTIONS(8705),
    [anon_sym_LT_LT] = ACTIONS(8705),
    [anon_sym_GT_GT] = ACTIONS(8705),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_SLASH] = ACTIONS(8705),
    [anon_sym_PERCENT] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
  },
  [7805] = {
    [sym__line_break2] = ACTIONS(10962),
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [ts_builtin_sym_end] = ACTIONS(10962),
    [anon_sym___END__] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10964),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_end] = ACTIONS(10962),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_when] = ACTIONS(10962),
    [anon_sym_elsif] = ACTIONS(10962),
    [anon_sym_else] = ACTIONS(10962),
    [anon_sym_then] = ACTIONS(10962),
    [anon_sym_ensure] = ACTIONS(10962),
    [anon_sym_EQ_GT] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10964),
    [anon_sym_AMP_AMP] = ACTIONS(10964),
    [anon_sym_LT_LT] = ACTIONS(10964),
    [anon_sym_GT_GT] = ACTIONS(10964),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10964),
    [anon_sym_PLUS] = ACTIONS(10964),
    [anon_sym_SLASH] = ACTIONS(10964),
    [anon_sym_PERCENT] = ACTIONS(10964),
    [sym_comment] = ACTIONS(87),
  },
  [7806] = {
    [sym__simple_symbol2] = ACTIONS(6739),
    [sym__string_start2] = ACTIONS(6739),
    [sym__symbol_start2] = ACTIONS(6739),
    [sym__subshell_start2] = ACTIONS(6739),
    [sym__regex_start2] = ACTIONS(6739),
    [sym__string_array_start2] = ACTIONS(6739),
    [sym__symbol_array_start2] = ACTIONS(6739),
    [sym_heredoc_beginning2] = ACTIONS(6739),
    [sym__block_ampersand2] = ACTIONS(6739),
    [sym__splat_star2] = ACTIONS(6739),
    [sym__unary_minus2] = ACTIONS(6739),
    [sym__identifier_hash_key2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(8705),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(8705),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(8705),
    [anon_sym_module] = ACTIONS(8705),
    [anon_sym_return] = ACTIONS(8705),
    [anon_sym_yield] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(8705),
    [anon_sym_next] = ACTIONS(8705),
    [sym_redo] = ACTIONS(8705),
    [sym_retry] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(8705),
    [anon_sym_unless] = ACTIONS(8705),
    [anon_sym_while] = ACTIONS(8705),
    [anon_sym_until] = ACTIONS(8705),
    [anon_sym_for] = ACTIONS(8705),
    [anon_sym_case] = ACTIONS(8705),
    [anon_sym_begin] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_defined_QMARK] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(8705),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8705),
    [sym_float] = ACTIONS(8705),
    [sym_complex] = ACTIONS(6739),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(8705),
    [anon_sym_TRUE] = ACTIONS(8705),
    [anon_sym_false] = ACTIONS(8705),
    [anon_sym_FALSE] = ACTIONS(8705),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(8705),
    [anon_sym_NIL] = ACTIONS(8705),
    [sym_character] = ACTIONS(6739),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6739),
  },
  [7807] = {
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [7808] = {
    [aux_sym_exceptions_repeat1] = STATE(7808),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(12847),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [7809] = {
    [sym_heredoc_body] = STATE(9705),
    [aux_sym_call_repeat1] = STATE(9705),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7810] = {
    [sym_heredoc_body] = STATE(9706),
    [aux_sym_call_repeat1] = STATE(9706),
    [aux_sym_argument_list_repeat1] = STATE(5292),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4426),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7811] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7812] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7813] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7814] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7815] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7816] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7817] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12850),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7818] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7819] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7820] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7821] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7822] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7823] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7824] = {
    [aux_sym_exceptions_repeat1] = STATE(9709),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7825] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [7826] = {
    [sym_string] = STATE(7826),
    [aux_sym_chained_string_repeat1] = STATE(7826),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7827] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [7828] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [7829] = {
    [sym_heredoc_body] = STATE(7829),
    [aux_sym_call_repeat1] = STATE(7829),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [7830] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2713),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(2713),
    [sym_operator_assignment] = STATE(2713),
    [sym_conditional] = STATE(2713),
    [sym_range] = STATE(2713),
    [sym_binary] = STATE(2713),
    [sym_unary] = STATE(2713),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2716),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4376),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [sym__identifier_hash_key2] = ACTIONS(4380),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10968),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(4382),
    [sym_identifier] = ACTIONS(4382),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7831] = {
    [sym_heredoc_body] = STATE(7829),
    [aux_sym_call_repeat1] = STATE(7829),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [7832] = {
    [aux_sym_argument_list_repeat1] = STATE(7832),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12852),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [7833] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9710),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_assignment] = STATE(9710),
    [sym_operator_assignment] = STATE(9710),
    [sym_conditional] = STATE(9710),
    [sym_range] = STATE(9710),
    [sym_binary] = STATE(9710),
    [sym_unary] = STATE(9710),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7834] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [7835] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [7836] = {
    [sym_heredoc_body] = STATE(7836),
    [aux_sym_call_repeat1] = STATE(7836),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [7837] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2737),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(2737),
    [sym_operator_assignment] = STATE(2737),
    [sym_conditional] = STATE(2737),
    [sym_range] = STATE(2737),
    [sym_binary] = STATE(2737),
    [sym_unary] = STATE(2737),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2740),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4418),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [sym__identifier_hash_key2] = ACTIONS(4422),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(10972),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(4424),
    [sym_identifier] = ACTIONS(4424),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7838] = {
    [sym_heredoc_body] = STATE(7836),
    [aux_sym_call_repeat1] = STATE(7836),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [7839] = {
    [aux_sym_argument_list_repeat1] = STATE(7839),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(12855),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [7840] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5293),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1006),
    [sym_scope_resolution] = STATE(1002),
    [sym_call] = STATE(1002),
    [sym_method_call] = STATE(1006),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(5293),
    [sym_operator_assignment] = STATE(5293),
    [sym_conditional] = STATE(5293),
    [sym_range] = STATE(5293),
    [sym_binary] = STATE(5293),
    [sym_unary] = STATE(5293),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(1005),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1006),
    [sym__variable] = STATE(1002),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1006),
    [sym_false] = STATE(1006),
    [sym_nil] = STATE(1006),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2705),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4378),
    [sym__unary_minus2] = ACTIONS(1735),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1739),
    [anon_sym_yield] = ACTIONS(1741),
    [anon_sym_break] = ACTIONS(1743),
    [anon_sym_next] = ACTIONS(1745),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4372),
    [anon_sym_defined_QMARK] = ACTIONS(1747),
    [anon_sym_not] = ACTIONS(1749),
    [anon_sym_BANG] = ACTIONS(1753),
    [anon_sym_TILDE] = ACTIONS(1753),
    [sym_constant] = ACTIONS(1759),
    [sym_identifier] = ACTIONS(1759),
    [sym_instance_variable] = ACTIONS(1757),
    [sym_class_variable] = ACTIONS(1757),
    [sym_global_variable] = ACTIONS(1757),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1759),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1759),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7841] = {
    [aux_sym_exceptions_repeat1] = STATE(9711),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(12858),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [7842] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9712),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(9712),
    [sym_operator_assignment] = STATE(9712),
    [sym_conditional] = STATE(9712),
    [sym_range] = STATE(9712),
    [sym_binary] = STATE(9712),
    [sym_unary] = STATE(9712),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7843] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9713),
    [sym__argument] = STATE(9714),
    [sym_splat_argument] = STATE(9714),
    [sym_hash_splat_argument] = STATE(9714),
    [sym_block_argument] = STATE(9714),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9714),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7844] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(9713),
    [sym__argument] = STATE(9714),
    [sym_splat_argument] = STATE(9714),
    [sym_hash_splat_argument] = STATE(9714),
    [sym_block_argument] = STATE(9714),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9714),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7845] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(9713),
    [sym__argument] = STATE(9714),
    [sym_splat_argument] = STATE(9714),
    [sym_hash_splat_argument] = STATE(9714),
    [sym_block_argument] = STATE(9714),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9714),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7846] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(9713),
    [sym__argument] = STATE(9714),
    [sym_splat_argument] = STATE(9714),
    [sym_hash_splat_argument] = STATE(9714),
    [sym_block_argument] = STATE(9714),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9714),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7994),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7847] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9715),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(9715),
    [sym_operator_assignment] = STATE(9715),
    [sym_conditional] = STATE(9715),
    [sym_range] = STATE(9715),
    [sym_binary] = STATE(9715),
    [sym_unary] = STATE(9715),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7848] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9716),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(9716),
    [sym_operator_assignment] = STATE(9716),
    [sym_conditional] = STATE(9716),
    [sym_range] = STATE(9716),
    [sym_binary] = STATE(9716),
    [sym_unary] = STATE(9716),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7849] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7850] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_elsif] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [7851] = {
    [anon_sym_EQ] = ACTIONS(12890),
    [sym_comment] = ACTIONS(87),
  },
  [7852] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12892),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12894),
    [anon_sym_DASH_EQ] = ACTIONS(12894),
    [anon_sym_STAR_EQ] = ACTIONS(12894),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12894),
    [anon_sym_SLASH_EQ] = ACTIONS(12894),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12894),
    [anon_sym_PIPE_EQ] = ACTIONS(12894),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12894),
    [anon_sym_AMP_EQ] = ACTIONS(12894),
    [anon_sym_PERCENT_EQ] = ACTIONS(12894),
    [anon_sym_GT_GT_EQ] = ACTIONS(12894),
    [anon_sym_LT_LT_EQ] = ACTIONS(12894),
    [anon_sym_CARET_EQ] = ACTIONS(12894),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7853] = {
    [sym_string] = STATE(9731),
    [aux_sym_chained_string_repeat1] = STATE(9731),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7854] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_elsif] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [7855] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [7856] = {
    [sym_string] = STATE(7897),
    [aux_sym_chained_string_repeat1] = STATE(7897),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7857] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9732),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(9732),
    [sym_operator_assignment] = STATE(9732),
    [sym_conditional] = STATE(9732),
    [sym_range] = STATE(9732),
    [sym_binary] = STATE(9732),
    [sym_unary] = STATE(9732),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7858] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [7859] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9733),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9733),
    [sym_operator_assignment] = STATE(9733),
    [sym_conditional] = STATE(9733),
    [sym_range] = STATE(9733),
    [sym_binary] = STATE(9733),
    [sym_unary] = STATE(9733),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7860] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9734),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9734),
    [sym_operator_assignment] = STATE(9734),
    [sym_conditional] = STATE(9734),
    [sym_range] = STATE(9734),
    [sym_binary] = STATE(9734),
    [sym_unary] = STATE(9734),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7861] = {
    [anon_sym_COLON] = ACTIONS(12896),
    [sym_comment] = ACTIONS(87),
  },
  [7862] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9736),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9736),
    [sym_operator_assignment] = STATE(9736),
    [sym_conditional] = STATE(9736),
    [sym_range] = STATE(9736),
    [sym_binary] = STATE(9736),
    [sym_unary] = STATE(9736),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7863] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(12898),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_elsif] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [7864] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_elsif] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [7865] = {
    [sym_heredoc_body] = STATE(9738),
    [aux_sym_call_repeat1] = STATE(9738),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [7866] = {
    [sym_heredoc_body] = STATE(9738),
    [aux_sym_call_repeat1] = STATE(9738),
    [aux_sym_argument_list_repeat1] = STATE(9740),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(12900),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [7867] = {
    [sym_string] = STATE(7897),
    [aux_sym_chained_string_repeat1] = STATE(7897),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12902),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [7868] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [7869] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [7870] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9741),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9741),
    [sym_operator_assignment] = STATE(9741),
    [sym_conditional] = STATE(9741),
    [sym_range] = STATE(9741),
    [sym_binary] = STATE(9741),
    [sym_unary] = STATE(9741),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7871] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9742),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9742),
    [sym_operator_assignment] = STATE(9742),
    [sym_conditional] = STATE(9742),
    [sym_range] = STATE(9742),
    [sym_binary] = STATE(9742),
    [sym_unary] = STATE(9742),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7872] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9743),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9743),
    [sym_operator_assignment] = STATE(9743),
    [sym_conditional] = STATE(9743),
    [sym_range] = STATE(9743),
    [sym_binary] = STATE(9743),
    [sym_unary] = STATE(9743),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7873] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9744),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9744),
    [sym_operator_assignment] = STATE(9744),
    [sym_conditional] = STATE(9744),
    [sym_range] = STATE(9744),
    [sym_binary] = STATE(9744),
    [sym_unary] = STATE(9744),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7874] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9745),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9745),
    [sym_operator_assignment] = STATE(9745),
    [sym_conditional] = STATE(9745),
    [sym_range] = STATE(9745),
    [sym_binary] = STATE(9745),
    [sym_unary] = STATE(9745),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7875] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9746),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9746),
    [sym_operator_assignment] = STATE(9746),
    [sym_conditional] = STATE(9746),
    [sym_range] = STATE(9746),
    [sym_binary] = STATE(9746),
    [sym_unary] = STATE(9746),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7876] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9747),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(9747),
    [sym_operator_assignment] = STATE(9747),
    [sym_conditional] = STATE(9747),
    [sym_range] = STATE(9747),
    [sym_binary] = STATE(9747),
    [sym_unary] = STATE(9747),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7877] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9748),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9748),
    [sym_operator_assignment] = STATE(9748),
    [sym_conditional] = STATE(9748),
    [sym_range] = STATE(9748),
    [sym_binary] = STATE(9748),
    [sym_unary] = STATE(9748),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7878] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9749),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9749),
    [sym_operator_assignment] = STATE(9749),
    [sym_conditional] = STATE(9749),
    [sym_range] = STATE(9749),
    [sym_binary] = STATE(9749),
    [sym_unary] = STATE(9749),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7879] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9750),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9750),
    [sym_operator_assignment] = STATE(9750),
    [sym_conditional] = STATE(9750),
    [sym_range] = STATE(9750),
    [sym_binary] = STATE(9750),
    [sym_unary] = STATE(9750),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7880] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9751),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9751),
    [sym_operator_assignment] = STATE(9751),
    [sym_conditional] = STATE(9751),
    [sym_range] = STATE(9751),
    [sym_binary] = STATE(9751),
    [sym_unary] = STATE(9751),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7881] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9752),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9752),
    [sym_operator_assignment] = STATE(9752),
    [sym_conditional] = STATE(9752),
    [sym_range] = STATE(9752),
    [sym_binary] = STATE(9752),
    [sym_unary] = STATE(9752),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7882] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9753),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9753),
    [sym_operator_assignment] = STATE(9753),
    [sym_conditional] = STATE(9753),
    [sym_range] = STATE(9753),
    [sym_binary] = STATE(9753),
    [sym_unary] = STATE(9753),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7883] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9754),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9754),
    [sym_operator_assignment] = STATE(9754),
    [sym_conditional] = STATE(9754),
    [sym_range] = STATE(9754),
    [sym_binary] = STATE(9754),
    [sym_unary] = STATE(9754),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7884] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9755),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9755),
    [sym_operator_assignment] = STATE(9755),
    [sym_conditional] = STATE(9755),
    [sym_range] = STATE(9755),
    [sym_binary] = STATE(9755),
    [sym_unary] = STATE(9755),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7885] = {
    [anon_sym_COLON] = ACTIONS(12904),
    [sym_comment] = ACTIONS(87),
  },
  [7886] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9757),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9757),
    [sym_operator_assignment] = STATE(9757),
    [sym_conditional] = STATE(9757),
    [sym_range] = STATE(9757),
    [sym_binary] = STATE(9757),
    [sym_unary] = STATE(9757),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7887] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(12906),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_elsif] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [7888] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_elsif] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [7889] = {
    [sym_heredoc_body] = STATE(9759),
    [aux_sym_call_repeat1] = STATE(9759),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [7890] = {
    [sym_heredoc_body] = STATE(9759),
    [aux_sym_call_repeat1] = STATE(9759),
    [aux_sym_argument_list_repeat1] = STATE(9761),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(12908),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [7891] = {
    [sym_string] = STATE(7958),
    [aux_sym_chained_string_repeat1] = STATE(7958),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(12910),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7892] = {
    [sym_heredoc_body] = STATE(9762),
    [aux_sym_call_repeat1] = STATE(9762),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7893] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(9763),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12912),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7894] = {
    [sym_heredoc_body] = STATE(9764),
    [aux_sym_call_repeat1] = STATE(9764),
    [aux_sym_argument_list_repeat1] = STATE(9765),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [7895] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9766),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_splat_argument] = STATE(9767),
    [sym_assignment] = STATE(9766),
    [sym_operator_assignment] = STATE(9766),
    [sym_conditional] = STATE(9766),
    [sym_range] = STATE(9766),
    [sym_binary] = STATE(9766),
    [sym_unary] = STATE(9766),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(9767),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7896] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9768),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(9768),
    [sym_operator_assignment] = STATE(9768),
    [sym_conditional] = STATE(9768),
    [sym_range] = STATE(9768),
    [sym_binary] = STATE(9768),
    [sym_unary] = STATE(9768),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7897] = {
    [sym_string] = STATE(9769),
    [aux_sym_chained_string_repeat1] = STATE(9769),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_elsif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [7898] = {
    [sym__statements] = STATE(9770),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(9771),
    [sym_else] = STATE(9771),
    [sym__if_tail] = STATE(9771),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(12914),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7899] = {
    [aux_sym_undef_repeat1] = STATE(9772),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_elsif] = ACTIONS(5504),
    [anon_sym_else] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [7900] = {
    [sym__line_break2] = ACTIONS(12916),
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [ts_builtin_sym_end] = ACTIONS(12916),
    [anon_sym___END__] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12916),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_end] = ACTIONS(12916),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_when] = ACTIONS(12916),
    [anon_sym_elsif] = ACTIONS(12916),
    [anon_sym_else] = ACTIONS(12916),
    [anon_sym_then] = ACTIONS(12916),
    [anon_sym_ensure] = ACTIONS(12916),
    [anon_sym_EQ_GT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12916),
    [anon_sym_AMP_AMP] = ACTIONS(12916),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12916),
    [anon_sym_PLUS] = ACTIONS(12916),
    [anon_sym_SLASH] = ACTIONS(12916),
    [anon_sym_PERCENT] = ACTIONS(12916),
    [sym_comment] = ACTIONS(87),
  },
  [7901] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(5834),
    [anon_sym_else] = ACTIONS(5834),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7902] = {
    [sym_heredoc_body] = STATE(9773),
    [sym__terminator] = STATE(9773),
    [aux_sym__statements_repeat1] = STATE(7902),
    [sym__line_break2] = ACTIONS(12920),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(12920),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_elsif] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [7903] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_elsif] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7904] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_elsif] = ACTIONS(5844),
    [anon_sym_else] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7905] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_elsif] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7906] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_elsif] = ACTIONS(5848),
    [anon_sym_else] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7907] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_elsif] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(8044),
    [anon_sym_or] = ACTIONS(8044),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7908] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7909] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7910] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7911] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7912] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7913] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7914] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12923),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7915] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7916] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7917] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7918] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7919] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7920] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9775),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(9775),
    [sym_operator_assignment] = STATE(9775),
    [sym_conditional] = STATE(9775),
    [sym_range] = STATE(9775),
    [sym_binary] = STATE(9775),
    [sym_unary] = STATE(9775),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7921] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7922] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7923] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7924] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7925] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9776),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(9776),
    [sym_operator_assignment] = STATE(9776),
    [sym_conditional] = STATE(9776),
    [sym_range] = STATE(9776),
    [sym_binary] = STATE(9776),
    [sym_unary] = STATE(9776),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7926] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9777),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(9777),
    [sym_operator_assignment] = STATE(9777),
    [sym_conditional] = STATE(9777),
    [sym_range] = STATE(9777),
    [sym_binary] = STATE(9777),
    [sym_unary] = STATE(9777),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7927] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7928] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_elsif] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [7929] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(5361),
    [sym__argument] = STATE(5362),
    [sym_splat_argument] = STATE(5362),
    [sym_hash_splat_argument] = STATE(5362),
    [sym_block_argument] = STATE(5362),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5362),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_elsif] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8078),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7930] = {
    [anon_sym_EQ] = ACTIONS(12953),
    [sym_comment] = ACTIONS(87),
  },
  [7931] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12955),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12957),
    [anon_sym_DASH_EQ] = ACTIONS(12957),
    [anon_sym_STAR_EQ] = ACTIONS(12957),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12957),
    [anon_sym_SLASH_EQ] = ACTIONS(12957),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12957),
    [anon_sym_PIPE_EQ] = ACTIONS(12957),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12957),
    [anon_sym_AMP_EQ] = ACTIONS(12957),
    [anon_sym_PERCENT_EQ] = ACTIONS(12957),
    [anon_sym_GT_GT_EQ] = ACTIONS(12957),
    [anon_sym_LT_LT_EQ] = ACTIONS(12957),
    [anon_sym_CARET_EQ] = ACTIONS(12957),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7932] = {
    [sym_string] = STATE(9792),
    [aux_sym_chained_string_repeat1] = STATE(9792),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7933] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_elsif] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [7934] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [7935] = {
    [sym_string] = STATE(7958),
    [aux_sym_chained_string_repeat1] = STATE(7958),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7936] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9793),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(9793),
    [sym_operator_assignment] = STATE(9793),
    [sym_conditional] = STATE(9793),
    [sym_range] = STATE(9793),
    [sym_binary] = STATE(9793),
    [sym_unary] = STATE(9793),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7937] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [7938] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [7939] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [7940] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9794),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9794),
    [sym_operator_assignment] = STATE(9794),
    [sym_conditional] = STATE(9794),
    [sym_range] = STATE(9794),
    [sym_binary] = STATE(9794),
    [sym_unary] = STATE(9794),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7941] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9795),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9795),
    [sym_operator_assignment] = STATE(9795),
    [sym_conditional] = STATE(9795),
    [sym_range] = STATE(9795),
    [sym_binary] = STATE(9795),
    [sym_unary] = STATE(9795),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7942] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9796),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9796),
    [sym_operator_assignment] = STATE(9796),
    [sym_conditional] = STATE(9796),
    [sym_range] = STATE(9796),
    [sym_binary] = STATE(9796),
    [sym_unary] = STATE(9796),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7943] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9797),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9797),
    [sym_operator_assignment] = STATE(9797),
    [sym_conditional] = STATE(9797),
    [sym_range] = STATE(9797),
    [sym_binary] = STATE(9797),
    [sym_unary] = STATE(9797),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7944] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9798),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9798),
    [sym_operator_assignment] = STATE(9798),
    [sym_conditional] = STATE(9798),
    [sym_range] = STATE(9798),
    [sym_binary] = STATE(9798),
    [sym_unary] = STATE(9798),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7945] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9799),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9799),
    [sym_operator_assignment] = STATE(9799),
    [sym_conditional] = STATE(9799),
    [sym_range] = STATE(9799),
    [sym_binary] = STATE(9799),
    [sym_unary] = STATE(9799),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7946] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9800),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(9800),
    [sym_operator_assignment] = STATE(9800),
    [sym_conditional] = STATE(9800),
    [sym_range] = STATE(9800),
    [sym_binary] = STATE(9800),
    [sym_unary] = STATE(9800),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [7947] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9801),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9801),
    [sym_operator_assignment] = STATE(9801),
    [sym_conditional] = STATE(9801),
    [sym_range] = STATE(9801),
    [sym_binary] = STATE(9801),
    [sym_unary] = STATE(9801),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [7948] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9802),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9802),
    [sym_operator_assignment] = STATE(9802),
    [sym_conditional] = STATE(9802),
    [sym_range] = STATE(9802),
    [sym_binary] = STATE(9802),
    [sym_unary] = STATE(9802),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7949] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9803),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9803),
    [sym_operator_assignment] = STATE(9803),
    [sym_conditional] = STATE(9803),
    [sym_range] = STATE(9803),
    [sym_binary] = STATE(9803),
    [sym_unary] = STATE(9803),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7950] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9804),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9804),
    [sym_operator_assignment] = STATE(9804),
    [sym_conditional] = STATE(9804),
    [sym_range] = STATE(9804),
    [sym_binary] = STATE(9804),
    [sym_unary] = STATE(9804),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7951] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9805),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9805),
    [sym_operator_assignment] = STATE(9805),
    [sym_conditional] = STATE(9805),
    [sym_range] = STATE(9805),
    [sym_binary] = STATE(9805),
    [sym_unary] = STATE(9805),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7952] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9806),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9806),
    [sym_operator_assignment] = STATE(9806),
    [sym_conditional] = STATE(9806),
    [sym_range] = STATE(9806),
    [sym_binary] = STATE(9806),
    [sym_unary] = STATE(9806),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7953] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7954] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(9808),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12959),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7955] = {
    [sym_heredoc_body] = STATE(9809),
    [aux_sym_call_repeat1] = STATE(9809),
    [aux_sym_argument_list_repeat1] = STATE(9810),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11127),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [7956] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9811),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_splat_argument] = STATE(9812),
    [sym_assignment] = STATE(9811),
    [sym_operator_assignment] = STATE(9811),
    [sym_conditional] = STATE(9811),
    [sym_range] = STATE(9811),
    [sym_binary] = STATE(9811),
    [sym_unary] = STATE(9811),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(9812),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7957] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9813),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(9813),
    [sym_operator_assignment] = STATE(9813),
    [sym_conditional] = STATE(9813),
    [sym_range] = STATE(9813),
    [sym_binary] = STATE(9813),
    [sym_unary] = STATE(9813),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7958] = {
    [sym_string] = STATE(9814),
    [aux_sym_chained_string_repeat1] = STATE(9814),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_elsif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [7959] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9815),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(9815),
    [sym_operator_assignment] = STATE(9815),
    [sym_conditional] = STATE(9815),
    [sym_range] = STATE(9815),
    [sym_binary] = STATE(9815),
    [sym_unary] = STATE(9815),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7960] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9816),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(9816),
    [sym_operator_assignment] = STATE(9816),
    [sym_conditional] = STATE(9816),
    [sym_range] = STATE(9816),
    [sym_binary] = STATE(9816),
    [sym_unary] = STATE(9816),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7961] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9817),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(9817),
    [sym_operator_assignment] = STATE(9817),
    [sym_conditional] = STATE(9817),
    [sym_range] = STATE(9817),
    [sym_binary] = STATE(9817),
    [sym_unary] = STATE(9817),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7962] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9818),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(9818),
    [sym_operator_assignment] = STATE(9818),
    [sym_conditional] = STATE(9818),
    [sym_range] = STATE(9818),
    [sym_binary] = STATE(9818),
    [sym_unary] = STATE(9818),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7963] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [7964] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_elsif] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [7965] = {
    [aux_sym_exceptions_repeat1] = STATE(9832),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(12991),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [7966] = {
    [anon_sym_EQ] = ACTIONS(12993),
    [sym_comment] = ACTIONS(87),
  },
  [7967] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(12995),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_elsif] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(12997),
    [anon_sym_DASH_EQ] = ACTIONS(12997),
    [anon_sym_STAR_EQ] = ACTIONS(12997),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12997),
    [anon_sym_SLASH_EQ] = ACTIONS(12997),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12997),
    [anon_sym_PIPE_EQ] = ACTIONS(12997),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12997),
    [anon_sym_AMP_EQ] = ACTIONS(12997),
    [anon_sym_PERCENT_EQ] = ACTIONS(12997),
    [anon_sym_GT_GT_EQ] = ACTIONS(12997),
    [anon_sym_LT_LT_EQ] = ACTIONS(12997),
    [anon_sym_CARET_EQ] = ACTIONS(12997),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [7968] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [7969] = {
    [sym_string] = STATE(7969),
    [aux_sym_chained_string_repeat1] = STATE(7969),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_elsif] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [7970] = {
    [anon_sym_end] = ACTIONS(12999),
    [sym_comment] = ACTIONS(87),
  },
  [7971] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(1779),
    [sym__binary_star2] = ACTIONS(1781),
    [anon_sym_PIPE] = ACTIONS(1783),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(1785),
    [anon_sym_AMP] = ACTIONS(1787),
    [anon_sym_LT] = ACTIONS(1789),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(1791),
    [anon_sym_DOT_DOT] = ACTIONS(1793),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1795),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1799),
    [anon_sym_AMP_AMP] = ACTIONS(1799),
    [anon_sym_LT_LT] = ACTIONS(1801),
    [anon_sym_GT_GT] = ACTIONS(1801),
    [anon_sym_EQ_EQ] = ACTIONS(1803),
    [anon_sym_BANG_EQ] = ACTIONS(1799),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1799),
    [anon_sym_LT_EQ_GT] = ACTIONS(1799),
    [anon_sym_EQ_TILDE] = ACTIONS(1799),
    [anon_sym_BANG_TILDE] = ACTIONS(1799),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_GT] = ACTIONS(1789),
    [anon_sym_GT_EQ] = ACTIONS(1805),
    [anon_sym_CARET] = ACTIONS(1807),
    [anon_sym_PLUS] = ACTIONS(1809),
    [anon_sym_SLASH] = ACTIONS(1785),
    [anon_sym_PERCENT] = ACTIONS(1785),
    [sym_comment] = ACTIONS(87),
  },
  [7972] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7973] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [7974] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7975] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [7976] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7977] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7978] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13001),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7979] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7980] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7981] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7982] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7983] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7984] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7985] = {
    [aux_sym_exceptions_repeat1] = STATE(9838),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [7986] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [7987] = {
    [sym_string] = STATE(7987),
    [aux_sym_chained_string_repeat1] = STATE(7987),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [7988] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9839),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_assignment] = STATE(9839),
    [sym_operator_assignment] = STATE(9839),
    [sym_conditional] = STATE(9839),
    [sym_range] = STATE(9839),
    [sym_binary] = STATE(9839),
    [sym_unary] = STATE(9839),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7989] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5407),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1049),
    [sym_scope_resolution] = STATE(1045),
    [sym_call] = STATE(1045),
    [sym_method_call] = STATE(1049),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(5407),
    [sym_operator_assignment] = STATE(5407),
    [sym_conditional] = STATE(5407),
    [sym_range] = STATE(5407),
    [sym_binary] = STATE(5407),
    [sym_unary] = STATE(5407),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(1048),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1049),
    [sym__variable] = STATE(1045),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1049),
    [sym_false] = STATE(1049),
    [sym_nil] = STATE(1049),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2805),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(4420),
    [sym__unary_minus2] = ACTIONS(1815),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1819),
    [anon_sym_yield] = ACTIONS(1821),
    [anon_sym_break] = ACTIONS(1823),
    [anon_sym_next] = ACTIONS(1825),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4500),
    [anon_sym_defined_QMARK] = ACTIONS(1827),
    [anon_sym_not] = ACTIONS(1829),
    [anon_sym_BANG] = ACTIONS(1833),
    [anon_sym_TILDE] = ACTIONS(1833),
    [sym_constant] = ACTIONS(1839),
    [sym_identifier] = ACTIONS(1839),
    [sym_instance_variable] = ACTIONS(1837),
    [sym_class_variable] = ACTIONS(1837),
    [sym_global_variable] = ACTIONS(1837),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1839),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1839),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [7990] = {
    [aux_sym_exceptions_repeat1] = STATE(9840),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13003),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [7991] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [7992] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [7993] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [7994] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [7995] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [7996] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [7997] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13005),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [7998] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [7999] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [8000] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [8001] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [8002] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [8003] = {
    [aux_sym_exceptions_repeat1] = STATE(8003),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13007),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8004] = {
    [aux_sym_exceptions_repeat1] = STATE(5428),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8005] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [8006] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9842),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(9842),
    [sym_operator_assignment] = STATE(9842),
    [sym_conditional] = STATE(9842),
    [sym_range] = STATE(9842),
    [sym_binary] = STATE(9842),
    [sym_unary] = STATE(9842),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8007] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(9843),
    [sym__argument] = STATE(9844),
    [sym_splat_argument] = STATE(9844),
    [sym_hash_splat_argument] = STATE(9844),
    [sym_block_argument] = STATE(9844),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9844),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8008] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(9843),
    [sym__argument] = STATE(9844),
    [sym_splat_argument] = STATE(9844),
    [sym_hash_splat_argument] = STATE(9844),
    [sym_block_argument] = STATE(9844),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9844),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8009] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(9843),
    [sym__argument] = STATE(9844),
    [sym_splat_argument] = STATE(9844),
    [sym_hash_splat_argument] = STATE(9844),
    [sym_block_argument] = STATE(9844),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9844),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8010] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(9843),
    [sym__argument] = STATE(9844),
    [sym_splat_argument] = STATE(9844),
    [sym_hash_splat_argument] = STATE(9844),
    [sym_block_argument] = STATE(9844),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(9844),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8200),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8011] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9845),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(9845),
    [sym_operator_assignment] = STATE(9845),
    [sym_conditional] = STATE(9845),
    [sym_range] = STATE(9845),
    [sym_binary] = STATE(9845),
    [sym_unary] = STATE(9845),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8012] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9846),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(9846),
    [sym_operator_assignment] = STATE(9846),
    [sym_conditional] = STATE(9846),
    [sym_range] = STATE(9846),
    [sym_binary] = STATE(9846),
    [sym_unary] = STATE(9846),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8013] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8014] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [8015] = {
    [anon_sym_EQ] = ACTIONS(13040),
    [sym_comment] = ACTIONS(87),
  },
  [8016] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13042),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13044),
    [anon_sym_DASH_EQ] = ACTIONS(13044),
    [anon_sym_STAR_EQ] = ACTIONS(13044),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13044),
    [anon_sym_SLASH_EQ] = ACTIONS(13044),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13044),
    [anon_sym_PIPE_EQ] = ACTIONS(13044),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13044),
    [anon_sym_AMP_EQ] = ACTIONS(13044),
    [anon_sym_PERCENT_EQ] = ACTIONS(13044),
    [anon_sym_GT_GT_EQ] = ACTIONS(13044),
    [anon_sym_LT_LT_EQ] = ACTIONS(13044),
    [anon_sym_CARET_EQ] = ACTIONS(13044),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8017] = {
    [sym_string] = STATE(9861),
    [aux_sym_chained_string_repeat1] = STATE(9861),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8018] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [8019] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8020] = {
    [sym_string] = STATE(8061),
    [aux_sym_chained_string_repeat1] = STATE(8061),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8021] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9862),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(9862),
    [sym_operator_assignment] = STATE(9862),
    [sym_conditional] = STATE(9862),
    [sym_range] = STATE(9862),
    [sym_binary] = STATE(9862),
    [sym_unary] = STATE(9862),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8022] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [8023] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9863),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9863),
    [sym_operator_assignment] = STATE(9863),
    [sym_conditional] = STATE(9863),
    [sym_range] = STATE(9863),
    [sym_binary] = STATE(9863),
    [sym_unary] = STATE(9863),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8024] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9864),
    [sym_operator_assignment] = STATE(9864),
    [sym_conditional] = STATE(9864),
    [sym_range] = STATE(9864),
    [sym_binary] = STATE(9864),
    [sym_unary] = STATE(9864),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8025] = {
    [anon_sym_COLON] = ACTIONS(13046),
    [sym_comment] = ACTIONS(87),
  },
  [8026] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9866),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9866),
    [sym_operator_assignment] = STATE(9866),
    [sym_conditional] = STATE(9866),
    [sym_range] = STATE(9866),
    [sym_binary] = STATE(9866),
    [sym_unary] = STATE(9866),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8027] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(13048),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [8028] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [8029] = {
    [sym_heredoc_body] = STATE(9868),
    [aux_sym_call_repeat1] = STATE(9868),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8030] = {
    [sym_heredoc_body] = STATE(9868),
    [aux_sym_call_repeat1] = STATE(9868),
    [aux_sym_argument_list_repeat1] = STATE(9870),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(13050),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8031] = {
    [sym_string] = STATE(8061),
    [aux_sym_chained_string_repeat1] = STATE(8061),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13052),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8032] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8033] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [8034] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9871),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9871),
    [sym_operator_assignment] = STATE(9871),
    [sym_conditional] = STATE(9871),
    [sym_range] = STATE(9871),
    [sym_binary] = STATE(9871),
    [sym_unary] = STATE(9871),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8035] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9872),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9872),
    [sym_operator_assignment] = STATE(9872),
    [sym_conditional] = STATE(9872),
    [sym_range] = STATE(9872),
    [sym_binary] = STATE(9872),
    [sym_unary] = STATE(9872),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8036] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9873),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9873),
    [sym_operator_assignment] = STATE(9873),
    [sym_conditional] = STATE(9873),
    [sym_range] = STATE(9873),
    [sym_binary] = STATE(9873),
    [sym_unary] = STATE(9873),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8037] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9874),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9874),
    [sym_operator_assignment] = STATE(9874),
    [sym_conditional] = STATE(9874),
    [sym_range] = STATE(9874),
    [sym_binary] = STATE(9874),
    [sym_unary] = STATE(9874),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8038] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9875),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9875),
    [sym_operator_assignment] = STATE(9875),
    [sym_conditional] = STATE(9875),
    [sym_range] = STATE(9875),
    [sym_binary] = STATE(9875),
    [sym_unary] = STATE(9875),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8039] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9876),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9876),
    [sym_operator_assignment] = STATE(9876),
    [sym_conditional] = STATE(9876),
    [sym_range] = STATE(9876),
    [sym_binary] = STATE(9876),
    [sym_unary] = STATE(9876),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8040] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9877),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(9877),
    [sym_operator_assignment] = STATE(9877),
    [sym_conditional] = STATE(9877),
    [sym_range] = STATE(9877),
    [sym_binary] = STATE(9877),
    [sym_unary] = STATE(9877),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8041] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9878),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9878),
    [sym_operator_assignment] = STATE(9878),
    [sym_conditional] = STATE(9878),
    [sym_range] = STATE(9878),
    [sym_binary] = STATE(9878),
    [sym_unary] = STATE(9878),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8042] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9879),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9879),
    [sym_operator_assignment] = STATE(9879),
    [sym_conditional] = STATE(9879),
    [sym_range] = STATE(9879),
    [sym_binary] = STATE(9879),
    [sym_unary] = STATE(9879),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8043] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9880),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9880),
    [sym_operator_assignment] = STATE(9880),
    [sym_conditional] = STATE(9880),
    [sym_range] = STATE(9880),
    [sym_binary] = STATE(9880),
    [sym_unary] = STATE(9880),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8044] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9881),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9881),
    [sym_operator_assignment] = STATE(9881),
    [sym_conditional] = STATE(9881),
    [sym_range] = STATE(9881),
    [sym_binary] = STATE(9881),
    [sym_unary] = STATE(9881),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8045] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9882),
    [sym_operator_assignment] = STATE(9882),
    [sym_conditional] = STATE(9882),
    [sym_range] = STATE(9882),
    [sym_binary] = STATE(9882),
    [sym_unary] = STATE(9882),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8046] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9883),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9883),
    [sym_operator_assignment] = STATE(9883),
    [sym_conditional] = STATE(9883),
    [sym_range] = STATE(9883),
    [sym_binary] = STATE(9883),
    [sym_unary] = STATE(9883),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8047] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9884),
    [sym_operator_assignment] = STATE(9884),
    [sym_conditional] = STATE(9884),
    [sym_range] = STATE(9884),
    [sym_binary] = STATE(9884),
    [sym_unary] = STATE(9884),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8048] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9885),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9885),
    [sym_operator_assignment] = STATE(9885),
    [sym_conditional] = STATE(9885),
    [sym_range] = STATE(9885),
    [sym_binary] = STATE(9885),
    [sym_unary] = STATE(9885),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8049] = {
    [anon_sym_COLON] = ACTIONS(13054),
    [sym_comment] = ACTIONS(87),
  },
  [8050] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9887),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9887),
    [sym_operator_assignment] = STATE(9887),
    [sym_conditional] = STATE(9887),
    [sym_range] = STATE(9887),
    [sym_binary] = STATE(9887),
    [sym_unary] = STATE(9887),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8051] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(13056),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [8052] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [8053] = {
    [sym_heredoc_body] = STATE(9889),
    [aux_sym_call_repeat1] = STATE(9889),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [8054] = {
    [sym_heredoc_body] = STATE(9889),
    [aux_sym_call_repeat1] = STATE(9889),
    [aux_sym_argument_list_repeat1] = STATE(9891),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(13058),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [8055] = {
    [sym_string] = STATE(8121),
    [aux_sym_chained_string_repeat1] = STATE(8121),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13060),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8056] = {
    [sym_heredoc_body] = STATE(9892),
    [aux_sym_call_repeat1] = STATE(9892),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8057] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(9893),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13062),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8058] = {
    [sym_heredoc_body] = STATE(9894),
    [aux_sym_call_repeat1] = STATE(9894),
    [aux_sym_argument_list_repeat1] = STATE(9895),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11226),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8059] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9896),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_splat_argument] = STATE(9897),
    [sym_assignment] = STATE(9896),
    [sym_operator_assignment] = STATE(9896),
    [sym_conditional] = STATE(9896),
    [sym_range] = STATE(9896),
    [sym_binary] = STATE(9896),
    [sym_unary] = STATE(9896),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(9897),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8060] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9898),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(9898),
    [sym_operator_assignment] = STATE(9898),
    [sym_conditional] = STATE(9898),
    [sym_range] = STATE(9898),
    [sym_binary] = STATE(9898),
    [sym_unary] = STATE(9898),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8061] = {
    [sym_string] = STATE(9899),
    [aux_sym_chained_string_repeat1] = STATE(9899),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [8062] = {
    [aux_sym_undef_repeat1] = STATE(9900),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_else] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [8063] = {
    [sym__line_break2] = ACTIONS(13064),
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [ts_builtin_sym_end] = ACTIONS(13064),
    [anon_sym___END__] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13064),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13064),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_when] = ACTIONS(13064),
    [anon_sym_elsif] = ACTIONS(13064),
    [anon_sym_else] = ACTIONS(13064),
    [anon_sym_then] = ACTIONS(13064),
    [anon_sym_ensure] = ACTIONS(13064),
    [anon_sym_EQ_GT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13064),
    [anon_sym_AMP_AMP] = ACTIONS(13064),
    [anon_sym_LT_LT] = ACTIONS(13064),
    [anon_sym_GT_GT] = ACTIONS(13064),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13064),
    [anon_sym_PLUS] = ACTIONS(13064),
    [anon_sym_SLASH] = ACTIONS(13064),
    [anon_sym_PERCENT] = ACTIONS(13064),
    [sym_comment] = ACTIONS(87),
  },
  [8064] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(5834),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8065] = {
    [sym_heredoc_body] = STATE(9901),
    [sym__terminator] = STATE(9901),
    [aux_sym__statements_repeat1] = STATE(8065),
    [sym__line_break2] = ACTIONS(13068),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(13068),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [8066] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8067] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_else] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8068] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8069] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_else] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8070] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(8244),
    [anon_sym_or] = ACTIONS(8244),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8071] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8072] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8073] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8074] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8075] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8076] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8077] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13071),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8078] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8079] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8080] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8081] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8082] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8083] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9903),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(9903),
    [sym_operator_assignment] = STATE(9903),
    [sym_conditional] = STATE(9903),
    [sym_range] = STATE(9903),
    [sym_binary] = STATE(9903),
    [sym_unary] = STATE(9903),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8084] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8085] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8086] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8087] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8088] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9904),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(9904),
    [sym_operator_assignment] = STATE(9904),
    [sym_conditional] = STATE(9904),
    [sym_range] = STATE(9904),
    [sym_binary] = STATE(9904),
    [sym_unary] = STATE(9904),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8089] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9905),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(9905),
    [sym_operator_assignment] = STATE(9905),
    [sym_conditional] = STATE(9905),
    [sym_range] = STATE(9905),
    [sym_binary] = STATE(9905),
    [sym_unary] = STATE(9905),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8090] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8091] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [8092] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(5491),
    [sym__argument] = STATE(5492),
    [sym_splat_argument] = STATE(5492),
    [sym_hash_splat_argument] = STATE(5492),
    [sym_block_argument] = STATE(5492),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5492),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8278),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8093] = {
    [anon_sym_EQ] = ACTIONS(13101),
    [sym_comment] = ACTIONS(87),
  },
  [8094] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13103),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13105),
    [anon_sym_DASH_EQ] = ACTIONS(13105),
    [anon_sym_STAR_EQ] = ACTIONS(13105),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13105),
    [anon_sym_SLASH_EQ] = ACTIONS(13105),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13105),
    [anon_sym_PIPE_EQ] = ACTIONS(13105),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13105),
    [anon_sym_AMP_EQ] = ACTIONS(13105),
    [anon_sym_PERCENT_EQ] = ACTIONS(13105),
    [anon_sym_GT_GT_EQ] = ACTIONS(13105),
    [anon_sym_LT_LT_EQ] = ACTIONS(13105),
    [anon_sym_CARET_EQ] = ACTIONS(13105),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8095] = {
    [sym_string] = STATE(9920),
    [aux_sym_chained_string_repeat1] = STATE(9920),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8096] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [8097] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [8098] = {
    [sym_string] = STATE(8121),
    [aux_sym_chained_string_repeat1] = STATE(8121),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8099] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9921),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(9921),
    [sym_operator_assignment] = STATE(9921),
    [sym_conditional] = STATE(9921),
    [sym_range] = STATE(9921),
    [sym_binary] = STATE(9921),
    [sym_unary] = STATE(9921),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8100] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [8101] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [8102] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [8103] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9922),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9922),
    [sym_operator_assignment] = STATE(9922),
    [sym_conditional] = STATE(9922),
    [sym_range] = STATE(9922),
    [sym_binary] = STATE(9922),
    [sym_unary] = STATE(9922),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8104] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9923),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9923),
    [sym_operator_assignment] = STATE(9923),
    [sym_conditional] = STATE(9923),
    [sym_range] = STATE(9923),
    [sym_binary] = STATE(9923),
    [sym_unary] = STATE(9923),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8105] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9924),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9924),
    [sym_operator_assignment] = STATE(9924),
    [sym_conditional] = STATE(9924),
    [sym_range] = STATE(9924),
    [sym_binary] = STATE(9924),
    [sym_unary] = STATE(9924),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8106] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9925),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9925),
    [sym_operator_assignment] = STATE(9925),
    [sym_conditional] = STATE(9925),
    [sym_range] = STATE(9925),
    [sym_binary] = STATE(9925),
    [sym_unary] = STATE(9925),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8107] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9926),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9926),
    [sym_operator_assignment] = STATE(9926),
    [sym_conditional] = STATE(9926),
    [sym_range] = STATE(9926),
    [sym_binary] = STATE(9926),
    [sym_unary] = STATE(9926),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8108] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9927),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9927),
    [sym_operator_assignment] = STATE(9927),
    [sym_conditional] = STATE(9927),
    [sym_range] = STATE(9927),
    [sym_binary] = STATE(9927),
    [sym_unary] = STATE(9927),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8109] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9928),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(9928),
    [sym_operator_assignment] = STATE(9928),
    [sym_conditional] = STATE(9928),
    [sym_range] = STATE(9928),
    [sym_binary] = STATE(9928),
    [sym_unary] = STATE(9928),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8110] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(9929),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(9929),
    [sym_operator_assignment] = STATE(9929),
    [sym_conditional] = STATE(9929),
    [sym_range] = STATE(9929),
    [sym_binary] = STATE(9929),
    [sym_unary] = STATE(9929),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8111] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9930),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9930),
    [sym_operator_assignment] = STATE(9930),
    [sym_conditional] = STATE(9930),
    [sym_range] = STATE(9930),
    [sym_binary] = STATE(9930),
    [sym_unary] = STATE(9930),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8112] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9931),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9931),
    [sym_operator_assignment] = STATE(9931),
    [sym_conditional] = STATE(9931),
    [sym_range] = STATE(9931),
    [sym_binary] = STATE(9931),
    [sym_unary] = STATE(9931),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8113] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9932),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9932),
    [sym_operator_assignment] = STATE(9932),
    [sym_conditional] = STATE(9932),
    [sym_range] = STATE(9932),
    [sym_binary] = STATE(9932),
    [sym_unary] = STATE(9932),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8114] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9933),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9933),
    [sym_operator_assignment] = STATE(9933),
    [sym_conditional] = STATE(9933),
    [sym_range] = STATE(9933),
    [sym_binary] = STATE(9933),
    [sym_unary] = STATE(9933),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8115] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9934),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9934),
    [sym_operator_assignment] = STATE(9934),
    [sym_conditional] = STATE(9934),
    [sym_range] = STATE(9934),
    [sym_binary] = STATE(9934),
    [sym_unary] = STATE(9934),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8116] = {
    [sym_heredoc_body] = STATE(9935),
    [aux_sym_call_repeat1] = STATE(9935),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8117] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(9936),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13107),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8118] = {
    [sym_heredoc_body] = STATE(9937),
    [aux_sym_call_repeat1] = STATE(9937),
    [aux_sym_argument_list_repeat1] = STATE(9938),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11302),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8119] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9939),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_splat_argument] = STATE(9940),
    [sym_assignment] = STATE(9939),
    [sym_operator_assignment] = STATE(9939),
    [sym_conditional] = STATE(9939),
    [sym_range] = STATE(9939),
    [sym_binary] = STATE(9939),
    [sym_unary] = STATE(9939),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(9940),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8120] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9941),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(9941),
    [sym_operator_assignment] = STATE(9941),
    [sym_conditional] = STATE(9941),
    [sym_range] = STATE(9941),
    [sym_binary] = STATE(9941),
    [sym_unary] = STATE(9941),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8121] = {
    [sym_string] = STATE(9942),
    [aux_sym_chained_string_repeat1] = STATE(9942),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [8122] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9943),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(9943),
    [sym_operator_assignment] = STATE(9943),
    [sym_conditional] = STATE(9943),
    [sym_range] = STATE(9943),
    [sym_binary] = STATE(9943),
    [sym_unary] = STATE(9943),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8123] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9944),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(9944),
    [sym_operator_assignment] = STATE(9944),
    [sym_conditional] = STATE(9944),
    [sym_range] = STATE(9944),
    [sym_binary] = STATE(9944),
    [sym_unary] = STATE(9944),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8124] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9945),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(9945),
    [sym_operator_assignment] = STATE(9945),
    [sym_conditional] = STATE(9945),
    [sym_range] = STATE(9945),
    [sym_binary] = STATE(9945),
    [sym_unary] = STATE(9945),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8125] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9946),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(9946),
    [sym_operator_assignment] = STATE(9946),
    [sym_conditional] = STATE(9946),
    [sym_range] = STATE(9946),
    [sym_binary] = STATE(9946),
    [sym_unary] = STATE(9946),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8126] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8127] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [8128] = {
    [aux_sym_exceptions_repeat1] = STATE(9960),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(13139),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8129] = {
    [anon_sym_EQ] = ACTIONS(13141),
    [sym_comment] = ACTIONS(87),
  },
  [8130] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13143),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13145),
    [anon_sym_DASH_EQ] = ACTIONS(13145),
    [anon_sym_STAR_EQ] = ACTIONS(13145),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13145),
    [anon_sym_SLASH_EQ] = ACTIONS(13145),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13145),
    [anon_sym_PIPE_EQ] = ACTIONS(13145),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13145),
    [anon_sym_AMP_EQ] = ACTIONS(13145),
    [anon_sym_PERCENT_EQ] = ACTIONS(13145),
    [anon_sym_GT_GT_EQ] = ACTIONS(13145),
    [anon_sym_LT_LT_EQ] = ACTIONS(13145),
    [anon_sym_CARET_EQ] = ACTIONS(13145),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8131] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [8132] = {
    [sym_string] = STATE(8132),
    [aux_sym_chained_string_repeat1] = STATE(8132),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8133] = {
    [sym_heredoc_body] = STATE(9963),
    [aux_sym_call_repeat1] = STATE(9963),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8134] = {
    [sym_heredoc_body] = STATE(9964),
    [aux_sym_call_repeat1] = STATE(9964),
    [aux_sym_argument_list_repeat1] = STATE(5553),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4660),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8135] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8136] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8137] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8138] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8139] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8140] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8141] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13147),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8142] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8143] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8144] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8145] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8146] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8147] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8148] = {
    [aux_sym_exceptions_repeat1] = STATE(9967),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8149] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [8150] = {
    [sym_string] = STATE(8150),
    [aux_sym_chained_string_repeat1] = STATE(8150),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8151] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [8152] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [8153] = {
    [sym_heredoc_body] = STATE(8153),
    [aux_sym_call_repeat1] = STATE(8153),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8154] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(2882),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(2882),
    [sym_operator_assignment] = STATE(2882),
    [sym_conditional] = STATE(2882),
    [sym_range] = STATE(2882),
    [sym_binary] = STATE(2882),
    [sym_unary] = STATE(2882),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2885),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4608),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [sym__identifier_hash_key2] = ACTIONS(4612),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11324),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(4614),
    [sym_identifier] = ACTIONS(4614),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8155] = {
    [sym_heredoc_body] = STATE(8153),
    [aux_sym_call_repeat1] = STATE(8153),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8156] = {
    [aux_sym_argument_list_repeat1] = STATE(8156),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13149),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8157] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9968),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_assignment] = STATE(9968),
    [sym_operator_assignment] = STATE(9968),
    [sym_conditional] = STATE(9968),
    [sym_range] = STATE(9968),
    [sym_binary] = STATE(9968),
    [sym_unary] = STATE(9968),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8158] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [8159] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [8160] = {
    [sym_heredoc_body] = STATE(8160),
    [aux_sym_call_repeat1] = STATE(8160),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8161] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(2907),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(2907),
    [sym_operator_assignment] = STATE(2907),
    [sym_conditional] = STATE(2907),
    [sym_range] = STATE(2907),
    [sym_binary] = STATE(2907),
    [sym_unary] = STATE(2907),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2910),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(4650),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [sym__identifier_hash_key2] = ACTIONS(4654),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11328),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(4658),
    [sym_identifier] = ACTIONS(4658),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8162] = {
    [sym_heredoc_body] = STATE(8160),
    [aux_sym_call_repeat1] = STATE(8160),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8163] = {
    [aux_sym_argument_list_repeat1] = STATE(8163),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13152),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8164] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5554),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1075),
    [sym_scope_resolution] = STATE(1071),
    [sym_call] = STATE(1071),
    [sym_method_call] = STATE(1075),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(5554),
    [sym_operator_assignment] = STATE(5554),
    [sym_conditional] = STATE(5554),
    [sym_range] = STATE(5554),
    [sym_binary] = STATE(5554),
    [sym_unary] = STATE(5554),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(1074),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1075),
    [sym__variable] = STATE(1071),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1075),
    [sym_false] = STATE(1075),
    [sym_nil] = STATE(1075),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(2874),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4610),
    [sym__unary_minus2] = ACTIONS(1855),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1859),
    [anon_sym_yield] = ACTIONS(1861),
    [anon_sym_break] = ACTIONS(1863),
    [anon_sym_next] = ACTIONS(1865),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4604),
    [anon_sym_defined_QMARK] = ACTIONS(1867),
    [anon_sym_not] = ACTIONS(1869),
    [anon_sym_BANG] = ACTIONS(1873),
    [anon_sym_TILDE] = ACTIONS(1873),
    [sym_constant] = ACTIONS(1879),
    [sym_identifier] = ACTIONS(1879),
    [sym_instance_variable] = ACTIONS(1877),
    [sym_class_variable] = ACTIONS(1877),
    [sym_global_variable] = ACTIONS(1877),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(1879),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1879),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8165] = {
    [aux_sym_exceptions_repeat1] = STATE(9969),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13155),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8166] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(1883),
    [sym__binary_star2] = ACTIONS(1885),
    [anon_sym_PIPE] = ACTIONS(1887),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(1889),
    [anon_sym_AMP] = ACTIONS(1891),
    [anon_sym_LT] = ACTIONS(1893),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(1895),
    [anon_sym_DOT_DOT] = ACTIONS(1897),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1899),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(1903),
    [anon_sym_AMP_AMP] = ACTIONS(1903),
    [anon_sym_LT_LT] = ACTIONS(1905),
    [anon_sym_GT_GT] = ACTIONS(1905),
    [anon_sym_EQ_EQ] = ACTIONS(1907),
    [anon_sym_BANG_EQ] = ACTIONS(1903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ_GT] = ACTIONS(1903),
    [anon_sym_EQ_TILDE] = ACTIONS(1903),
    [anon_sym_BANG_TILDE] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1893),
    [anon_sym_GT] = ACTIONS(1893),
    [anon_sym_GT_EQ] = ACTIONS(1909),
    [anon_sym_CARET] = ACTIONS(1911),
    [anon_sym_PLUS] = ACTIONS(1913),
    [anon_sym_SLASH] = ACTIONS(1889),
    [anon_sym_PERCENT] = ACTIONS(1889),
    [sym_comment] = ACTIONS(87),
  },
  [8167] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8168] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8169] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8170] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8171] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8172] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8173] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13157),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8174] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8175] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8176] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8177] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8178] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8179] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8180] = {
    [aux_sym_exceptions_repeat1] = STATE(9972),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8181] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [8182] = {
    [sym_string] = STATE(8182),
    [aux_sym_chained_string_repeat1] = STATE(8182),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8183] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9973),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_assignment] = STATE(9973),
    [sym_operator_assignment] = STATE(9973),
    [sym_conditional] = STATE(9973),
    [sym_range] = STATE(9973),
    [sym_binary] = STATE(9973),
    [sym_unary] = STATE(9973),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8184] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5596),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1112),
    [sym_scope_resolution] = STATE(1107),
    [sym_call] = STATE(1107),
    [sym_method_call] = STATE(1112),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(5596),
    [sym_operator_assignment] = STATE(5596),
    [sym_conditional] = STATE(5596),
    [sym_range] = STATE(5596),
    [sym_binary] = STATE(5596),
    [sym_unary] = STATE(5596),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(1111),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1112),
    [sym__variable] = STATE(1107),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1112),
    [sym_false] = STATE(1112),
    [sym_nil] = STATE(1112),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(2946),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(4652),
    [sym__unary_minus2] = ACTIONS(1919),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(1925),
    [anon_sym_yield] = ACTIONS(1927),
    [anon_sym_break] = ACTIONS(1929),
    [anon_sym_next] = ACTIONS(1931),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(4694),
    [anon_sym_defined_QMARK] = ACTIONS(1941),
    [anon_sym_not] = ACTIONS(1943),
    [anon_sym_BANG] = ACTIONS(1947),
    [anon_sym_TILDE] = ACTIONS(1947),
    [sym_constant] = ACTIONS(1953),
    [sym_identifier] = ACTIONS(1953),
    [sym_instance_variable] = ACTIONS(1951),
    [sym_class_variable] = ACTIONS(1951),
    [sym_global_variable] = ACTIONS(1951),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(1953),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(1953),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8185] = {
    [aux_sym_exceptions_repeat1] = STATE(9974),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13159),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [8186] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8187] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8188] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8189] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8190] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8191] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8192] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13161),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8193] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8194] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8195] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8196] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8197] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8198] = {
    [aux_sym_exceptions_repeat1] = STATE(8198),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13163),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8199] = {
    [aux_sym_exceptions_repeat1] = STATE(5617),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8200] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [8201] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8202] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8203] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9976),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(9976),
    [sym_operator_assignment] = STATE(9976),
    [sym_conditional] = STATE(9976),
    [sym_range] = STATE(9976),
    [sym_binary] = STATE(9976),
    [sym_unary] = STATE(9976),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8204] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8205] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9977),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(9977),
    [sym_operator_assignment] = STATE(9977),
    [sym_conditional] = STATE(9977),
    [sym_range] = STATE(9977),
    [sym_binary] = STATE(9977),
    [sym_unary] = STATE(9977),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8206] = {
    [sym_heredoc_body] = STATE(9978),
    [aux_sym_call_repeat1] = STATE(9978),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8207] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(9979),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13166),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8208] = {
    [sym_heredoc_body] = STATE(9980),
    [aux_sym_call_repeat1] = STATE(9980),
    [aux_sym_argument_list_repeat1] = STATE(9981),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11352),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8209] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_in] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8210] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8211] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8212] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8213] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8214] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8215] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13168),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8216] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8217] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8218] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8219] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8220] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8221] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9983),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(9983),
    [sym_operator_assignment] = STATE(9983),
    [sym_conditional] = STATE(9983),
    [sym_range] = STATE(9983),
    [sym_binary] = STATE(9983),
    [sym_unary] = STATE(9983),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8222] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(5651),
    [sym__argument] = STATE(5652),
    [sym_splat_argument] = STATE(5652),
    [sym_hash_splat_argument] = STATE(5652),
    [sym_block_argument] = STATE(5652),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(5652),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(375),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8223] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(5651),
    [sym__argument] = STATE(5652),
    [sym_splat_argument] = STATE(5652),
    [sym_hash_splat_argument] = STATE(5652),
    [sym_block_argument] = STATE(5652),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(5652),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(417),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8224] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(5651),
    [sym__argument] = STATE(5652),
    [sym_splat_argument] = STATE(5652),
    [sym_hash_splat_argument] = STATE(5652),
    [sym_block_argument] = STATE(5652),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(5652),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(421),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8225] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(5651),
    [sym__argument] = STATE(5652),
    [sym_splat_argument] = STATE(5652),
    [sym_hash_splat_argument] = STATE(5652),
    [sym_block_argument] = STATE(5652),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(5652),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_in] = ACTIONS(425),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8226] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9984),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(9984),
    [sym_operator_assignment] = STATE(9984),
    [sym_conditional] = STATE(9984),
    [sym_range] = STATE(9984),
    [sym_binary] = STATE(9984),
    [sym_unary] = STATE(9984),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8227] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9985),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(9985),
    [sym_operator_assignment] = STATE(9985),
    [sym_conditional] = STATE(9985),
    [sym_range] = STATE(9985),
    [sym_binary] = STATE(9985),
    [sym_unary] = STATE(9985),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8228] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8229] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [8230] = {
    [anon_sym_EQ] = ACTIONS(13198),
    [sym_comment] = ACTIONS(87),
  },
  [8231] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13200),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13202),
    [anon_sym_DASH_EQ] = ACTIONS(13202),
    [anon_sym_STAR_EQ] = ACTIONS(13202),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13202),
    [anon_sym_SLASH_EQ] = ACTIONS(13202),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13202),
    [anon_sym_PIPE_EQ] = ACTIONS(13202),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13202),
    [anon_sym_AMP_EQ] = ACTIONS(13202),
    [anon_sym_PERCENT_EQ] = ACTIONS(13202),
    [anon_sym_GT_GT_EQ] = ACTIONS(13202),
    [anon_sym_LT_LT_EQ] = ACTIONS(13202),
    [anon_sym_CARET_EQ] = ACTIONS(13202),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8232] = {
    [sym_string] = STATE(10000),
    [aux_sym_chained_string_repeat1] = STATE(10000),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_in] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8233] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [8234] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10001),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10001),
    [sym_operator_assignment] = STATE(10001),
    [sym_conditional] = STATE(10001),
    [sym_range] = STATE(10001),
    [sym_binary] = STATE(10001),
    [sym_unary] = STATE(10001),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8235] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [8236] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10002),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10002),
    [sym_operator_assignment] = STATE(10002),
    [sym_conditional] = STATE(10002),
    [sym_range] = STATE(10002),
    [sym_binary] = STATE(10002),
    [sym_unary] = STATE(10002),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8237] = {
    [sym_heredoc_body] = STATE(10003),
    [aux_sym_call_repeat1] = STATE(10003),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8238] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(10004),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13204),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8239] = {
    [sym_heredoc_body] = STATE(10005),
    [aux_sym_call_repeat1] = STATE(10005),
    [aux_sym_argument_list_repeat1] = STATE(10006),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11380),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_in] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8240] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8241] = {
    [aux_sym_exceptions_repeat1] = STATE(10008),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8242] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [8243] = {
    [sym_string] = STATE(8243),
    [aux_sym_chained_string_repeat1] = STATE(8243),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8244] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [8245] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [8246] = {
    [sym_heredoc_body] = STATE(8246),
    [aux_sym_call_repeat1] = STATE(8246),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_in] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8247] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3007),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(3007),
    [sym_operator_assignment] = STATE(3007),
    [sym_conditional] = STATE(3007),
    [sym_range] = STATE(3007),
    [sym_binary] = STATE(3007),
    [sym_unary] = STATE(3007),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3010),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(4780),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(4784),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11384),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(4788),
    [sym_identifier] = ACTIONS(4788),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8248] = {
    [sym_heredoc_body] = STATE(8246),
    [aux_sym_call_repeat1] = STATE(8246),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_in] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8249] = {
    [aux_sym_argument_list_repeat1] = STATE(8249),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13206),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8250] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10009),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_assignment] = STATE(10009),
    [sym_operator_assignment] = STATE(10009),
    [sym_conditional] = STATE(10009),
    [sym_range] = STATE(10009),
    [sym_binary] = STATE(10009),
    [sym_unary] = STATE(10009),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8251] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8252] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_in] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8253] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8254] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8255] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8256] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8257] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8258] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8259] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13209),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8260] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8261] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8262] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8263] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8264] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8265] = {
    [sym_heredoc_body] = STATE(8265),
    [aux_sym_call_repeat1] = STATE(8265),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_in] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8266] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3039),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(3039),
    [sym_operator_assignment] = STATE(3039),
    [sym_conditional] = STATE(3039),
    [sym_range] = STATE(3039),
    [sym_binary] = STATE(3039),
    [sym_unary] = STATE(3039),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3044),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(4826),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__identifier_hash_key2] = ACTIONS(4832),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11388),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(4850),
    [sym_identifier] = ACTIONS(4850),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8267] = {
    [sym_heredoc_body] = STATE(8265),
    [aux_sym_call_repeat1] = STATE(8265),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_in] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8268] = {
    [aux_sym_argument_list_repeat1] = STATE(8268),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13211),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8269] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8270] = {
    [aux_sym_exceptions_repeat1] = STATE(10012),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8271] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [8272] = {
    [sym_string] = STATE(8272),
    [aux_sym_chained_string_repeat1] = STATE(8272),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8273] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5710),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(5710),
    [sym_operator_assignment] = STATE(5710),
    [sym_conditional] = STATE(5710),
    [sym_range] = STATE(5710),
    [sym_binary] = STATE(5710),
    [sym_unary] = STATE(5710),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2999),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4782),
    [sym__unary_minus2] = ACTIONS(1969),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8274] = {
    [aux_sym_exceptions_repeat1] = STATE(10013),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13214),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_in] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8275] = {
    [sym__line_break2] = ACTIONS(13216),
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [ts_builtin_sym_end] = ACTIONS(13216),
    [anon_sym___END__] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13216),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_end] = ACTIONS(13216),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_when] = ACTIONS(13216),
    [anon_sym_elsif] = ACTIONS(13216),
    [anon_sym_else] = ACTIONS(13216),
    [anon_sym_then] = ACTIONS(13216),
    [anon_sym_ensure] = ACTIONS(13216),
    [anon_sym_EQ_GT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13216),
    [anon_sym_AMP_AMP] = ACTIONS(13216),
    [anon_sym_LT_LT] = ACTIONS(13216),
    [anon_sym_GT_GT] = ACTIONS(13216),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13216),
    [anon_sym_PLUS] = ACTIONS(13216),
    [anon_sym_SLASH] = ACTIONS(13216),
    [anon_sym_PERCENT] = ACTIONS(13216),
    [sym_comment] = ACTIONS(87),
  },
  [8276] = {
    [sym_heredoc_body] = STATE(10014),
    [aux_sym_call_repeat1] = STATE(10014),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8277] = {
    [sym_heredoc_body] = STATE(10015),
    [aux_sym_call_repeat1] = STATE(10015),
    [aux_sym_argument_list_repeat1] = STATE(5761),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4930),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8278] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8279] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8280] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8281] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8282] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8283] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8284] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13220),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8285] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8286] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8287] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8288] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8289] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8290] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8291] = {
    [aux_sym_exceptions_repeat1] = STATE(10018),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8292] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [8293] = {
    [sym_string] = STATE(8293),
    [aux_sym_chained_string_repeat1] = STATE(8293),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8294] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [8295] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [8296] = {
    [sym_heredoc_body] = STATE(8296),
    [aux_sym_call_repeat1] = STATE(8296),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8297] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3075),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3075),
    [sym_operator_assignment] = STATE(3075),
    [sym_conditional] = STATE(3075),
    [sym_range] = STATE(3075),
    [sym_binary] = STATE(3075),
    [sym_unary] = STATE(3075),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3078),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(4888),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [sym__identifier_hash_key2] = ACTIONS(4892),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11399),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(4894),
    [sym_identifier] = ACTIONS(4894),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8298] = {
    [sym_heredoc_body] = STATE(8296),
    [aux_sym_call_repeat1] = STATE(8296),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8299] = {
    [aux_sym_argument_list_repeat1] = STATE(8299),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13222),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8300] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10019),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_assignment] = STATE(10019),
    [sym_operator_assignment] = STATE(10019),
    [sym_conditional] = STATE(10019),
    [sym_range] = STATE(10019),
    [sym_binary] = STATE(10019),
    [sym_unary] = STATE(10019),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8301] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5762),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1160),
    [sym_scope_resolution] = STATE(1156),
    [sym_call] = STATE(1156),
    [sym_method_call] = STATE(1160),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(5762),
    [sym_operator_assignment] = STATE(5762),
    [sym_conditional] = STATE(5762),
    [sym_range] = STATE(5762),
    [sym_binary] = STATE(5762),
    [sym_unary] = STATE(5762),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(1159),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1160),
    [sym__variable] = STATE(1156),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1160),
    [sym_false] = STATE(1160),
    [sym_nil] = STATE(1160),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3067),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(4890),
    [sym__unary_minus2] = ACTIONS(2005),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2009),
    [anon_sym_yield] = ACTIONS(2011),
    [anon_sym_break] = ACTIONS(2013),
    [anon_sym_next] = ACTIONS(2015),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4884),
    [anon_sym_defined_QMARK] = ACTIONS(2017),
    [anon_sym_not] = ACTIONS(2019),
    [anon_sym_BANG] = ACTIONS(2023),
    [anon_sym_TILDE] = ACTIONS(2023),
    [sym_constant] = ACTIONS(2029),
    [sym_identifier] = ACTIONS(2029),
    [sym_instance_variable] = ACTIONS(2027),
    [sym_class_variable] = ACTIONS(2027),
    [sym_global_variable] = ACTIONS(2027),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2029),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2029),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8302] = {
    [aux_sym_exceptions_repeat1] = STATE(10020),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13225),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8303] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [8304] = {
    [sym__line_break2] = ACTIONS(13227),
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [ts_builtin_sym_end] = ACTIONS(13227),
    [anon_sym___END__] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_end] = ACTIONS(13227),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_when] = ACTIONS(13227),
    [anon_sym_elsif] = ACTIONS(13227),
    [anon_sym_else] = ACTIONS(13227),
    [anon_sym_then] = ACTIONS(13227),
    [anon_sym_ensure] = ACTIONS(13227),
    [anon_sym_EQ_GT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13227),
    [anon_sym_AMP_AMP] = ACTIONS(13227),
    [anon_sym_LT_LT] = ACTIONS(13227),
    [anon_sym_GT_GT] = ACTIONS(13227),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13227),
    [anon_sym_PLUS] = ACTIONS(13227),
    [anon_sym_SLASH] = ACTIONS(13227),
    [anon_sym_PERCENT] = ACTIONS(13227),
    [sym_comment] = ACTIONS(87),
  },
  [8305] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8306] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8307] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8308] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8309] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8310] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8311] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13231),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8312] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8313] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8314] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8315] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8316] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8317] = {
    [aux_sym_exceptions_repeat1] = STATE(8317),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13233),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8318] = {
    [aux_sym_exceptions_repeat1] = STATE(5786),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8319] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [8320] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10022),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10022),
    [sym_operator_assignment] = STATE(10022),
    [sym_conditional] = STATE(10022),
    [sym_range] = STATE(10022),
    [sym_binary] = STATE(10022),
    [sym_unary] = STATE(10022),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8321] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10023),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10023),
    [sym_operator_assignment] = STATE(10023),
    [sym_conditional] = STATE(10023),
    [sym_range] = STATE(10023),
    [sym_binary] = STATE(10023),
    [sym_unary] = STATE(10023),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8322] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10024),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10024),
    [sym_operator_assignment] = STATE(10024),
    [sym_conditional] = STATE(10024),
    [sym_range] = STATE(10024),
    [sym_binary] = STATE(10024),
    [sym_unary] = STATE(10024),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8323] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8324] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [8325] = {
    [anon_sym_EQ] = ACTIONS(13266),
    [sym_comment] = ACTIONS(87),
  },
  [8326] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13268),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13270),
    [anon_sym_DASH_EQ] = ACTIONS(13270),
    [anon_sym_STAR_EQ] = ACTIONS(13270),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13270),
    [anon_sym_SLASH_EQ] = ACTIONS(13270),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13270),
    [anon_sym_PIPE_EQ] = ACTIONS(13270),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13270),
    [anon_sym_AMP_EQ] = ACTIONS(13270),
    [anon_sym_PERCENT_EQ] = ACTIONS(13270),
    [anon_sym_GT_GT_EQ] = ACTIONS(13270),
    [anon_sym_LT_LT_EQ] = ACTIONS(13270),
    [anon_sym_CARET_EQ] = ACTIONS(13270),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8327] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [8328] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10039),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10039),
    [sym_operator_assignment] = STATE(10039),
    [sym_conditional] = STATE(10039),
    [sym_range] = STATE(10039),
    [sym_binary] = STATE(10039),
    [sym_unary] = STATE(10039),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8329] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [8330] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10040),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10040),
    [sym_operator_assignment] = STATE(10040),
    [sym_conditional] = STATE(10040),
    [sym_range] = STATE(10040),
    [sym_binary] = STATE(10040),
    [sym_unary] = STATE(10040),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8331] = {
    [sym_heredoc_body] = STATE(10041),
    [aux_sym_call_repeat1] = STATE(10041),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8332] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10042),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13272),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8333] = {
    [sym_heredoc_body] = STATE(10043),
    [aux_sym_call_repeat1] = STATE(10043),
    [aux_sym_argument_list_repeat1] = STATE(10044),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11428),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8334] = {
    [sym__line_break2] = ACTIONS(13274),
    [sym__heredoc_body_start2] = ACTIONS(13274),
    [anon_sym_COMMA] = ACTIONS(13274),
    [anon_sym_SEMI] = ACTIONS(13274),
    [anon_sym_then] = ACTIONS(13274),
    [sym_comment] = ACTIONS(87),
  },
  [8335] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10045),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(10045),
    [sym_operator_assignment] = STATE(10045),
    [sym_conditional] = STATE(10045),
    [sym_range] = STATE(10045),
    [sym_binary] = STATE(10045),
    [sym_unary] = STATE(10045),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8336] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10061),
    [sym__argument] = STATE(10062),
    [sym_splat_argument] = STATE(10062),
    [sym_hash_splat_argument] = STATE(10062),
    [sym_block_argument] = STATE(10062),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10062),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8337] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(10061),
    [sym__argument] = STATE(10062),
    [sym_splat_argument] = STATE(10062),
    [sym_hash_splat_argument] = STATE(10062),
    [sym_block_argument] = STATE(10062),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10062),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8338] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(10061),
    [sym__argument] = STATE(10062),
    [sym_splat_argument] = STATE(10062),
    [sym_hash_splat_argument] = STATE(10062),
    [sym_block_argument] = STATE(10062),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10062),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8339] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(10061),
    [sym__argument] = STATE(10062),
    [sym_splat_argument] = STATE(10062),
    [sym_hash_splat_argument] = STATE(10062),
    [sym_block_argument] = STATE(10062),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10062),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8340] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10066),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(10066),
    [sym_operator_assignment] = STATE(10066),
    [sym_conditional] = STATE(10066),
    [sym_range] = STATE(10066),
    [sym_binary] = STATE(10066),
    [sym_unary] = STATE(10066),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8341] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10067),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(10067),
    [sym_operator_assignment] = STATE(10067),
    [sym_conditional] = STATE(10067),
    [sym_range] = STATE(10067),
    [sym_binary] = STATE(10067),
    [sym_unary] = STATE(10067),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8342] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8343] = {
    [sym_operator] = STATE(10068),
    [sym__method_name] = STATE(10068),
    [sym_setter] = STATE(10068),
    [sym_symbol] = STATE(10068),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13306),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13306),
    [sym_class_variable] = ACTIONS(13306),
    [sym_global_variable] = ACTIONS(13306),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8344] = {
    [sym_when] = STATE(10069),
    [sym_else] = STATE(10069),
    [anon_sym_end] = ACTIONS(13308),
    [anon_sym_when] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [8345] = {
    [sym_heredoc_body] = STATE(10070),
    [sym__terminator] = STATE(10070),
    [aux_sym__statements_repeat1] = STATE(10071),
    [sym__line_break2] = ACTIONS(13310),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13310),
    [anon_sym_end] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(689),
    [anon_sym_else] = ACTIONS(689),
    [sym_comment] = ACTIONS(87),
  },
  [8346] = {
    [sym__line_break2] = ACTIONS(691),
    [sym__heredoc_body_start2] = ACTIONS(691),
    [anon_sym_SEMI] = ACTIONS(691),
    [anon_sym_end] = ACTIONS(691),
    [anon_sym_if] = ACTIONS(13312),
    [anon_sym_unless] = ACTIONS(13314),
    [anon_sym_while] = ACTIONS(13316),
    [anon_sym_until] = ACTIONS(13318),
    [anon_sym_rescue] = ACTIONS(13320),
    [anon_sym_when] = ACTIONS(691),
    [anon_sym_else] = ACTIONS(691),
    [sym_comment] = ACTIONS(87),
  },
  [8347] = {
    [anon_sym_end] = ACTIONS(13308),
    [sym_comment] = ACTIONS(87),
  },
  [8348] = {
    [sym__line_break2] = ACTIONS(703),
    [sym__heredoc_body_start2] = ACTIONS(703),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(703),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(703),
    [anon_sym_if] = ACTIONS(703),
    [anon_sym_unless] = ACTIONS(703),
    [anon_sym_while] = ACTIONS(703),
    [anon_sym_until] = ACTIONS(703),
    [anon_sym_rescue] = ACTIONS(703),
    [anon_sym_when] = ACTIONS(703),
    [anon_sym_else] = ACTIONS(703),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [8349] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(441),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(777),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(799),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8350] = {
    [anon_sym_EQ] = ACTIONS(13384),
    [sym_comment] = ACTIONS(87),
  },
  [8351] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(835),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13386),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13388),
    [anon_sym_DASH_EQ] = ACTIONS(13388),
    [anon_sym_STAR_EQ] = ACTIONS(13388),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13388),
    [anon_sym_SLASH_EQ] = ACTIONS(13388),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13388),
    [anon_sym_PIPE_EQ] = ACTIONS(13388),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13388),
    [anon_sym_AMP_EQ] = ACTIONS(13388),
    [anon_sym_PERCENT_EQ] = ACTIONS(13388),
    [anon_sym_GT_GT_EQ] = ACTIONS(13388),
    [anon_sym_LT_LT_EQ] = ACTIONS(13388),
    [anon_sym_CARET_EQ] = ACTIONS(13388),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8352] = {
    [sym_string] = STATE(10111),
    [aux_sym_chained_string_repeat1] = STATE(10111),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8353] = {
    [sym__statements] = STATE(10112),
    [sym__top_level_statement] = STATE(8345),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(8346),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_when] = STATE(10069),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(10069),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(8348),
    [sym_operator_assignment] = STATE(8348),
    [sym_conditional] = STATE(8348),
    [sym_range] = STATE(8348),
    [sym_binary] = STATE(8348),
    [sym_unary] = STATE(8348),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13390),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(11444),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [anon_sym_undef] = ACTIONS(11458),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8354] = {
    [aux_sym_when_repeat1] = STATE(8354),
    [sym__line_break2] = ACTIONS(13274),
    [sym__heredoc_body_start2] = ACTIONS(13274),
    [anon_sym_COMMA] = ACTIONS(13392),
    [anon_sym_SEMI] = ACTIONS(13274),
    [anon_sym_then] = ACTIONS(13274),
    [sym_comment] = ACTIONS(87),
  },
  [8355] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8356] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8357] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8358] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8359] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8360] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8361] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13395),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8362] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8363] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8364] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8365] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8366] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8367] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10114),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(10114),
    [sym_operator_assignment] = STATE(10114),
    [sym_conditional] = STATE(10114),
    [sym_range] = STATE(10114),
    [sym_binary] = STATE(10114),
    [sym_unary] = STATE(10114),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8368] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8369] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8370] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8371] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8372] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10115),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(10115),
    [sym_operator_assignment] = STATE(10115),
    [sym_conditional] = STATE(10115),
    [sym_range] = STATE(10115),
    [sym_binary] = STATE(10115),
    [sym_unary] = STATE(10115),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8373] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10116),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(10116),
    [sym_operator_assignment] = STATE(10116),
    [sym_conditional] = STATE(10116),
    [sym_range] = STATE(10116),
    [sym_binary] = STATE(10116),
    [sym_unary] = STATE(10116),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8374] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8375] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [8376] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(5823),
    [sym__argument] = STATE(5824),
    [sym_splat_argument] = STATE(5824),
    [sym_hash_splat_argument] = STATE(5824),
    [sym_block_argument] = STATE(5824),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5824),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_then] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8377] = {
    [anon_sym_EQ] = ACTIONS(13425),
    [sym_comment] = ACTIONS(87),
  },
  [8378] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13427),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13429),
    [anon_sym_DASH_EQ] = ACTIONS(13429),
    [anon_sym_STAR_EQ] = ACTIONS(13429),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13429),
    [anon_sym_SLASH_EQ] = ACTIONS(13429),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13429),
    [anon_sym_PIPE_EQ] = ACTIONS(13429),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13429),
    [anon_sym_AMP_EQ] = ACTIONS(13429),
    [anon_sym_PERCENT_EQ] = ACTIONS(13429),
    [anon_sym_GT_GT_EQ] = ACTIONS(13429),
    [anon_sym_LT_LT_EQ] = ACTIONS(13429),
    [anon_sym_CARET_EQ] = ACTIONS(13429),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8379] = {
    [sym_string] = STATE(10131),
    [aux_sym_chained_string_repeat1] = STATE(10131),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8380] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [8381] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10132),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(10132),
    [sym_operator_assignment] = STATE(10132),
    [sym_conditional] = STATE(10132),
    [sym_range] = STATE(10132),
    [sym_binary] = STATE(10132),
    [sym_unary] = STATE(10132),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8382] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [8383] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10133),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(10133),
    [sym_operator_assignment] = STATE(10133),
    [sym_conditional] = STATE(10133),
    [sym_range] = STATE(10133),
    [sym_binary] = STATE(10133),
    [sym_unary] = STATE(10133),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8384] = {
    [sym_heredoc_body] = STATE(10134),
    [aux_sym_call_repeat1] = STATE(10134),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8385] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(10135),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13431),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8386] = {
    [sym_heredoc_body] = STATE(10136),
    [aux_sym_call_repeat1] = STATE(10136),
    [aux_sym_argument_list_repeat1] = STATE(10137),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11490),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8387] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10138),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(10138),
    [sym_operator_assignment] = STATE(10138),
    [sym_conditional] = STATE(10138),
    [sym_range] = STATE(10138),
    [sym_binary] = STATE(10138),
    [sym_unary] = STATE(10138),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8388] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8389] = {
    [aux_sym_exceptions_repeat1] = STATE(10140),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8390] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [8391] = {
    [sym_string] = STATE(8391),
    [aux_sym_chained_string_repeat1] = STATE(8391),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8392] = {
    [sym_heredoc_body] = STATE(10141),
    [aux_sym_call_repeat1] = STATE(10141),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8393] = {
    [sym_heredoc_body] = STATE(10142),
    [aux_sym_call_repeat1] = STATE(10142),
    [aux_sym_argument_list_repeat1] = STATE(5882),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(5058),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8394] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8395] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8396] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8397] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8398] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8399] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8400] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13433),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8401] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8402] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8403] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8404] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8405] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8406] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8407] = {
    [aux_sym_exceptions_repeat1] = STATE(10145),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8408] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [8409] = {
    [sym_string] = STATE(8409),
    [aux_sym_chained_string_repeat1] = STATE(8409),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8410] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [8411] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [8412] = {
    [sym_heredoc_body] = STATE(8412),
    [aux_sym_call_repeat1] = STATE(8412),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8413] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3166),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3166),
    [sym_operator_assignment] = STATE(3166),
    [sym_conditional] = STATE(3166),
    [sym_range] = STATE(3166),
    [sym_binary] = STATE(3166),
    [sym_unary] = STATE(3166),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3169),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5008),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [sym__identifier_hash_key2] = ACTIONS(5012),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11496),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(5014),
    [sym_identifier] = ACTIONS(5014),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8414] = {
    [sym_heredoc_body] = STATE(8412),
    [aux_sym_call_repeat1] = STATE(8412),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8415] = {
    [aux_sym_argument_list_repeat1] = STATE(8415),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13435),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8416] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10146),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_assignment] = STATE(10146),
    [sym_operator_assignment] = STATE(10146),
    [sym_conditional] = STATE(10146),
    [sym_range] = STATE(10146),
    [sym_binary] = STATE(10146),
    [sym_unary] = STATE(10146),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8417] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [8418] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [8419] = {
    [sym_heredoc_body] = STATE(8419),
    [aux_sym_call_repeat1] = STATE(8419),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8420] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3190),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(3190),
    [sym_operator_assignment] = STATE(3190),
    [sym_conditional] = STATE(3190),
    [sym_range] = STATE(3190),
    [sym_binary] = STATE(3190),
    [sym_unary] = STATE(3190),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3193),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5050),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [sym__identifier_hash_key2] = ACTIONS(5054),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11500),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(5056),
    [sym_identifier] = ACTIONS(5056),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8421] = {
    [sym_heredoc_body] = STATE(8419),
    [aux_sym_call_repeat1] = STATE(8419),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8422] = {
    [aux_sym_argument_list_repeat1] = STATE(8422),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13438),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8423] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5883),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1204),
    [sym_scope_resolution] = STATE(1200),
    [sym_call] = STATE(1200),
    [sym_method_call] = STATE(1204),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(5883),
    [sym_operator_assignment] = STATE(5883),
    [sym_conditional] = STATE(5883),
    [sym_range] = STATE(5883),
    [sym_binary] = STATE(5883),
    [sym_unary] = STATE(5883),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(1203),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1204),
    [sym__variable] = STATE(1200),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1204),
    [sym_false] = STATE(1204),
    [sym_nil] = STATE(1204),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3158),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(5010),
    [sym__unary_minus2] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2091),
    [anon_sym_yield] = ACTIONS(2093),
    [anon_sym_break] = ACTIONS(2095),
    [anon_sym_next] = ACTIONS(2097),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5004),
    [anon_sym_defined_QMARK] = ACTIONS(2099),
    [anon_sym_not] = ACTIONS(2101),
    [anon_sym_BANG] = ACTIONS(2105),
    [anon_sym_TILDE] = ACTIONS(2105),
    [sym_constant] = ACTIONS(2111),
    [sym_identifier] = ACTIONS(2111),
    [sym_instance_variable] = ACTIONS(2109),
    [sym_class_variable] = ACTIONS(2109),
    [sym_global_variable] = ACTIONS(2109),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2111),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2111),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8424] = {
    [aux_sym_exceptions_repeat1] = STATE(10147),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13441),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8425] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8426] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8427] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8428] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8429] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8430] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8431] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8432] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8433] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13443),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8434] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8435] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8436] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8437] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8438] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8439] = {
    [sym_heredoc_body] = STATE(8439),
    [aux_sym_call_repeat1] = STATE(8439),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8440] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3211),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3211),
    [sym_operator_assignment] = STATE(3211),
    [sym_conditional] = STATE(3211),
    [sym_range] = STATE(3211),
    [sym_binary] = STATE(3211),
    [sym_unary] = STATE(3211),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3216),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5068),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__identifier_hash_key2] = ACTIONS(5074),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11505),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(5084),
    [sym_identifier] = ACTIONS(5084),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8441] = {
    [sym_heredoc_body] = STATE(8439),
    [aux_sym_call_repeat1] = STATE(8439),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8442] = {
    [aux_sym_argument_list_repeat1] = STATE(8442),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13445),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8443] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8444] = {
    [aux_sym_exceptions_repeat1] = STATE(10150),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8445] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [8446] = {
    [sym__line_break2] = ACTIONS(1273),
    [sym__simple_symbol2] = ACTIONS(1273),
    [sym__string_start2] = ACTIONS(1273),
    [sym__symbol_start2] = ACTIONS(1273),
    [sym__subshell_start2] = ACTIONS(1273),
    [sym__regex_start2] = ACTIONS(1273),
    [sym__string_array_start2] = ACTIONS(1273),
    [sym__symbol_array_start2] = ACTIONS(1273),
    [sym__heredoc_body_start2] = ACTIONS(1273),
    [sym_heredoc_beginning2] = ACTIONS(1273),
    [sym__block_ampersand2] = ACTIONS(1273),
    [sym__splat_star2] = ACTIONS(1273),
    [sym__unary_minus2] = ACTIONS(1273),
    [sym__identifier_hash_key2] = ACTIONS(1273),
    [anon_sym_LBRACE] = ACTIONS(1273),
    [anon_sym_def] = ACTIONS(1275),
    [anon_sym_LPAREN] = ACTIONS(1275),
    [anon_sym_DOT] = ACTIONS(1273),
    [anon_sym_COLON_COLON] = ACTIONS(1275),
    [anon_sym_SEMI] = ACTIONS(1273),
    [anon_sym_STAR] = ACTIONS(1275),
    [anon_sym_STAR_STAR] = ACTIONS(1273),
    [anon_sym_class] = ACTIONS(1275),
    [anon_sym_module] = ACTIONS(1275),
    [anon_sym_return] = ACTIONS(1275),
    [anon_sym_yield] = ACTIONS(1275),
    [anon_sym_break] = ACTIONS(1275),
    [anon_sym_next] = ACTIONS(1275),
    [sym_redo] = ACTIONS(1275),
    [sym_retry] = ACTIONS(1275),
    [anon_sym_if] = ACTIONS(1275),
    [anon_sym_unless] = ACTIONS(1275),
    [anon_sym_while] = ACTIONS(1275),
    [anon_sym_until] = ACTIONS(1275),
    [anon_sym_for] = ACTIONS(1275),
    [anon_sym_do] = ACTIONS(1275),
    [anon_sym_case] = ACTIONS(1275),
    [anon_sym_then] = ACTIONS(1275),
    [anon_sym_begin] = ACTIONS(1275),
    [anon_sym_LBRACK] = ACTIONS(1273),
    [anon_sym_COLON_COLON2] = ACTIONS(1273),
    [anon_sym_AMP_DOT] = ACTIONS(1273),
    [anon_sym_LPAREN2] = ACTIONS(1273),
    [anon_sym_PLUS] = ACTIONS(1275),
    [anon_sym_defined_QMARK] = ACTIONS(1273),
    [anon_sym_not] = ACTIONS(1275),
    [anon_sym_BANG] = ACTIONS(1273),
    [anon_sym_TILDE] = ACTIONS(1273),
    [sym_constant] = ACTIONS(1275),
    [sym_identifier] = ACTIONS(1275),
    [sym_instance_variable] = ACTIONS(1273),
    [sym_class_variable] = ACTIONS(1273),
    [sym_global_variable] = ACTIONS(1273),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1275),
    [sym_float] = ACTIONS(1275),
    [sym_complex] = ACTIONS(1273),
    [sym_super] = ACTIONS(1275),
    [anon_sym_true] = ACTIONS(1275),
    [anon_sym_TRUE] = ACTIONS(1275),
    [anon_sym_false] = ACTIONS(1275),
    [anon_sym_FALSE] = ACTIONS(1275),
    [sym_self] = ACTIONS(1275),
    [anon_sym_nil] = ACTIONS(1275),
    [anon_sym_NIL] = ACTIONS(1275),
    [sym_character] = ACTIONS(1273),
    [anon_sym_LBRACK2] = ACTIONS(1275),
    [anon_sym_DASH_GT] = ACTIONS(1273),
  },
  [8447] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(939),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(944),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(944),
    [sym__argument_list_with_trailing_comma] = STATE(10152),
    [sym__argument] = STATE(942),
    [sym_splat_argument] = STATE(942),
    [sym_hash_splat_argument] = STATE(942),
    [sym_block_argument] = STATE(942),
    [sym_assignment] = STATE(939),
    [sym_operator_assignment] = STATE(939),
    [sym_conditional] = STATE(939),
    [sym_range] = STATE(939),
    [sym_binary] = STATE(939),
    [sym_unary] = STATE(939),
    [sym_left_assignment_list] = STATE(943),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(944),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(944),
    [sym_false] = STATE(944),
    [sym_nil] = STATE(944),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(945),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(10153),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(942),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(1605),
    [sym__splat_star2] = ACTIONS(1607),
    [sym__unary_minus2] = ACTIONS(1609),
    [sym__identifier_hash_key2] = ACTIONS(1611),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_RPAREN] = ACTIONS(13448),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(1615),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1625),
    [anon_sym_defined_QMARK] = ACTIONS(1627),
    [anon_sym_not] = ACTIONS(1629),
    [anon_sym_BANG] = ACTIONS(1631),
    [anon_sym_TILDE] = ACTIONS(1631),
    [sym_constant] = ACTIONS(1633),
    [sym_identifier] = ACTIONS(1633),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8448] = {
    [sym__line_break2] = ACTIONS(5974),
    [sym__simple_symbol2] = ACTIONS(5974),
    [sym__string_start2] = ACTIONS(5974),
    [sym__symbol_start2] = ACTIONS(5974),
    [sym__subshell_start2] = ACTIONS(5974),
    [sym__regex_start2] = ACTIONS(5974),
    [sym__string_array_start2] = ACTIONS(5974),
    [sym__symbol_array_start2] = ACTIONS(5974),
    [sym__heredoc_body_start2] = ACTIONS(5974),
    [sym_heredoc_beginning2] = ACTIONS(5974),
    [sym__block_ampersand2] = ACTIONS(5974),
    [sym__splat_star2] = ACTIONS(5974),
    [sym__unary_minus2] = ACTIONS(5974),
    [sym__identifier_hash_key2] = ACTIONS(5974),
    [anon_sym_LBRACE] = ACTIONS(5974),
    [anon_sym_def] = ACTIONS(5976),
    [anon_sym_LPAREN] = ACTIONS(5976),
    [anon_sym_DOT] = ACTIONS(5974),
    [anon_sym_COLON_COLON] = ACTIONS(5976),
    [anon_sym_SEMI] = ACTIONS(5974),
    [anon_sym_STAR] = ACTIONS(5976),
    [anon_sym_STAR_STAR] = ACTIONS(5974),
    [anon_sym_class] = ACTIONS(5976),
    [anon_sym_module] = ACTIONS(5976),
    [anon_sym_return] = ACTIONS(5976),
    [anon_sym_yield] = ACTIONS(5976),
    [anon_sym_break] = ACTIONS(5976),
    [anon_sym_next] = ACTIONS(5976),
    [sym_redo] = ACTIONS(5976),
    [sym_retry] = ACTIONS(5976),
    [anon_sym_if] = ACTIONS(5976),
    [anon_sym_unless] = ACTIONS(5976),
    [anon_sym_while] = ACTIONS(5976),
    [anon_sym_until] = ACTIONS(5976),
    [anon_sym_for] = ACTIONS(5976),
    [anon_sym_do] = ACTIONS(5976),
    [anon_sym_case] = ACTIONS(5976),
    [anon_sym_then] = ACTIONS(5976),
    [anon_sym_begin] = ACTIONS(5976),
    [anon_sym_LBRACK] = ACTIONS(5974),
    [anon_sym_COLON_COLON2] = ACTIONS(5974),
    [anon_sym_AMP_DOT] = ACTIONS(5974),
    [anon_sym_LPAREN2] = ACTIONS(5974),
    [anon_sym_PLUS] = ACTIONS(5976),
    [anon_sym_defined_QMARK] = ACTIONS(5974),
    [anon_sym_not] = ACTIONS(5976),
    [anon_sym_BANG] = ACTIONS(5974),
    [anon_sym_TILDE] = ACTIONS(5974),
    [sym_constant] = ACTIONS(5976),
    [sym_identifier] = ACTIONS(5976),
    [sym_instance_variable] = ACTIONS(5974),
    [sym_class_variable] = ACTIONS(5974),
    [sym_global_variable] = ACTIONS(5974),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5976),
    [sym_float] = ACTIONS(5976),
    [sym_complex] = ACTIONS(5974),
    [sym_super] = ACTIONS(5976),
    [anon_sym_true] = ACTIONS(5976),
    [anon_sym_TRUE] = ACTIONS(5976),
    [anon_sym_false] = ACTIONS(5976),
    [anon_sym_FALSE] = ACTIONS(5976),
    [sym_self] = ACTIONS(5976),
    [anon_sym_nil] = ACTIONS(5976),
    [anon_sym_NIL] = ACTIONS(5976),
    [sym_character] = ACTIONS(5974),
    [anon_sym_LBRACK2] = ACTIONS(5976),
    [anon_sym_DASH_GT] = ACTIONS(5974),
  },
  [8449] = {
    [sym__line_break2] = ACTIONS(5978),
    [sym__simple_symbol2] = ACTIONS(5978),
    [sym__string_start2] = ACTIONS(5978),
    [sym__symbol_start2] = ACTIONS(5978),
    [sym__subshell_start2] = ACTIONS(5978),
    [sym__regex_start2] = ACTIONS(5978),
    [sym__string_array_start2] = ACTIONS(5978),
    [sym__symbol_array_start2] = ACTIONS(5978),
    [sym__heredoc_body_start2] = ACTIONS(5978),
    [sym_heredoc_beginning2] = ACTIONS(5978),
    [sym__block_ampersand2] = ACTIONS(5978),
    [sym__splat_star2] = ACTIONS(5978),
    [sym__unary_minus2] = ACTIONS(5978),
    [sym__identifier_hash_key2] = ACTIONS(5978),
    [anon_sym_LBRACE] = ACTIONS(5978),
    [anon_sym_def] = ACTIONS(5980),
    [anon_sym_LPAREN] = ACTIONS(5980),
    [anon_sym_DOT] = ACTIONS(5978),
    [anon_sym_COLON_COLON] = ACTIONS(5980),
    [anon_sym_SEMI] = ACTIONS(5978),
    [anon_sym_STAR] = ACTIONS(5980),
    [anon_sym_STAR_STAR] = ACTIONS(5978),
    [anon_sym_class] = ACTIONS(5980),
    [anon_sym_module] = ACTIONS(5980),
    [anon_sym_return] = ACTIONS(5980),
    [anon_sym_yield] = ACTIONS(5980),
    [anon_sym_break] = ACTIONS(5980),
    [anon_sym_next] = ACTIONS(5980),
    [sym_redo] = ACTIONS(5980),
    [sym_retry] = ACTIONS(5980),
    [anon_sym_if] = ACTIONS(5980),
    [anon_sym_unless] = ACTIONS(5980),
    [anon_sym_while] = ACTIONS(5980),
    [anon_sym_until] = ACTIONS(5980),
    [anon_sym_for] = ACTIONS(5980),
    [anon_sym_do] = ACTIONS(5980),
    [anon_sym_case] = ACTIONS(5980),
    [anon_sym_then] = ACTIONS(5980),
    [anon_sym_begin] = ACTIONS(5980),
    [anon_sym_LBRACK] = ACTIONS(5978),
    [anon_sym_COLON_COLON2] = ACTIONS(5978),
    [anon_sym_AMP_DOT] = ACTIONS(5978),
    [anon_sym_LPAREN2] = ACTIONS(5978),
    [anon_sym_PLUS] = ACTIONS(5980),
    [anon_sym_defined_QMARK] = ACTIONS(5978),
    [anon_sym_not] = ACTIONS(5980),
    [anon_sym_BANG] = ACTIONS(5978),
    [anon_sym_TILDE] = ACTIONS(5978),
    [sym_constant] = ACTIONS(5980),
    [sym_identifier] = ACTIONS(5980),
    [sym_instance_variable] = ACTIONS(5978),
    [sym_class_variable] = ACTIONS(5978),
    [sym_global_variable] = ACTIONS(5978),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(5980),
    [sym_float] = ACTIONS(5980),
    [sym_complex] = ACTIONS(5978),
    [sym_super] = ACTIONS(5980),
    [anon_sym_true] = ACTIONS(5980),
    [anon_sym_TRUE] = ACTIONS(5980),
    [anon_sym_false] = ACTIONS(5980),
    [anon_sym_FALSE] = ACTIONS(5980),
    [sym_self] = ACTIONS(5980),
    [anon_sym_nil] = ACTIONS(5980),
    [anon_sym_NIL] = ACTIONS(5980),
    [sym_character] = ACTIONS(5978),
    [anon_sym_LBRACK2] = ACTIONS(5980),
    [anon_sym_DASH_GT] = ACTIONS(5978),
  },
  [8450] = {
    [sym_argument_list_with_parens] = STATE(10154),
    [sym__argument_list_with_parens] = STATE(8449),
    [sym_operator] = STATE(10154),
    [sym_heredoc_body] = STATE(3760),
    [aux_sym_call_repeat1] = STATE(3760),
    [sym__heredoc_body_start2] = ACTIONS(2573),
    [anon_sym_PIPE] = ACTIONS(11507),
    [anon_sym_STAR] = ACTIONS(11509),
    [anon_sym_STAR_STAR] = ACTIONS(11507),
    [anon_sym_AMP] = ACTIONS(11507),
    [anon_sym_LT] = ACTIONS(11509),
    [anon_sym_LPAREN2] = ACTIONS(11511),
    [anon_sym_DOT_DOT] = ACTIONS(11507),
    [anon_sym_LT_LT] = ACTIONS(11507),
    [anon_sym_GT_GT] = ACTIONS(11507),
    [anon_sym_EQ_EQ] = ACTIONS(11509),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11507),
    [anon_sym_LT_EQ_GT] = ACTIONS(11507),
    [anon_sym_EQ_TILDE] = ACTIONS(11507),
    [anon_sym_BANG_TILDE] = ACTIONS(11507),
    [anon_sym_LT_EQ] = ACTIONS(11509),
    [anon_sym_GT] = ACTIONS(11509),
    [anon_sym_GT_EQ] = ACTIONS(11507),
    [anon_sym_CARET] = ACTIONS(11507),
    [anon_sym_PLUS] = ACTIONS(11509),
    [anon_sym_SLASH] = ACTIONS(11507),
    [anon_sym_PERCENT] = ACTIONS(11507),
    [anon_sym_BANG] = ACTIONS(11509),
    [anon_sym_TILDE] = ACTIONS(11507),
    [sym_constant] = ACTIONS(13450),
    [sym_identifier] = ACTIONS(13450),
    [anon_sym_DASH] = ACTIONS(11509),
    [anon_sym_PLUS_AT] = ACTIONS(11507),
    [anon_sym_DASH_AT] = ACTIONS(11507),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(11509),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(11507),
    [anon_sym_BQUOTE] = ACTIONS(11507),
    [sym_comment] = ACTIONS(87),
  },
  [8451] = {
    [sym__line_break2] = ACTIONS(5984),
    [sym__heredoc_body_start2] = ACTIONS(5984),
    [anon_sym_DOT] = ACTIONS(5984),
    [anon_sym_SEMI] = ACTIONS(5984),
    [anon_sym_then] = ACTIONS(5984),
    [anon_sym_LBRACK] = ACTIONS(5984),
    [anon_sym_COLON_COLON2] = ACTIONS(5984),
    [anon_sym_AMP_DOT] = ACTIONS(5984),
    [sym_comment] = ACTIONS(87),
  },
  [8452] = {
    [sym_heredoc_body] = STATE(10156),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RBRACK] = ACTIONS(13452),
    [sym_comment] = ACTIONS(87),
  },
  [8453] = {
    [anon_sym_RBRACK] = ACTIONS(13452),
    [sym_comment] = ACTIONS(87),
  },
  [8454] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10157),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(10157),
    [sym_operator_assignment] = STATE(10157),
    [sym_conditional] = STATE(10157),
    [sym_range] = STATE(10157),
    [sym_binary] = STATE(10157),
    [sym_unary] = STATE(10157),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8455] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(10164),
    [sym__argument] = STATE(10165),
    [sym_splat_argument] = STATE(10165),
    [sym_hash_splat_argument] = STATE(10165),
    [sym_block_argument] = STATE(10165),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10165),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8456] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(10164),
    [sym__argument] = STATE(10165),
    [sym_splat_argument] = STATE(10165),
    [sym_hash_splat_argument] = STATE(10165),
    [sym_block_argument] = STATE(10165),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10165),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8457] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(10164),
    [sym__argument] = STATE(10165),
    [sym_splat_argument] = STATE(10165),
    [sym_hash_splat_argument] = STATE(10165),
    [sym_block_argument] = STATE(10165),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10165),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8458] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(10164),
    [sym__argument] = STATE(10165),
    [sym_splat_argument] = STATE(10165),
    [sym_hash_splat_argument] = STATE(10165),
    [sym_block_argument] = STATE(10165),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10165),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_then] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(11545),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8459] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10167),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(10167),
    [sym_operator_assignment] = STATE(10167),
    [sym_conditional] = STATE(10167),
    [sym_range] = STATE(10167),
    [sym_binary] = STATE(10167),
    [sym_unary] = STATE(10167),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8460] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10168),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(10168),
    [sym_operator_assignment] = STATE(10168),
    [sym_conditional] = STATE(10168),
    [sym_range] = STATE(10168),
    [sym_binary] = STATE(10168),
    [sym_unary] = STATE(10168),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8461] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8462] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(13480),
    [anon_sym_or] = ACTIONS(13480),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [8463] = {
    [anon_sym_EQ] = ACTIONS(13494),
    [sym_comment] = ACTIONS(87),
  },
  [8464] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13496),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13498),
    [anon_sym_DASH_EQ] = ACTIONS(13498),
    [anon_sym_STAR_EQ] = ACTIONS(13498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13498),
    [anon_sym_SLASH_EQ] = ACTIONS(13498),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13498),
    [anon_sym_PIPE_EQ] = ACTIONS(13498),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13498),
    [anon_sym_AMP_EQ] = ACTIONS(13498),
    [anon_sym_PERCENT_EQ] = ACTIONS(13498),
    [anon_sym_GT_GT_EQ] = ACTIONS(13498),
    [anon_sym_LT_LT_EQ] = ACTIONS(13498),
    [anon_sym_CARET_EQ] = ACTIONS(13498),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8465] = {
    [sym_string] = STATE(10183),
    [aux_sym_chained_string_repeat1] = STATE(10183),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8466] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(13480),
    [anon_sym_or] = ACTIONS(13480),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [8467] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8468] = {
    [sym_string] = STATE(8506),
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8469] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10184),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(10184),
    [sym_operator_assignment] = STATE(10184),
    [sym_conditional] = STATE(10184),
    [sym_range] = STATE(10184),
    [sym_binary] = STATE(10184),
    [sym_unary] = STATE(10184),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8470] = {
    [sym__line_break2] = ACTIONS(5750),
    [sym__heredoc_body_start2] = ACTIONS(5750),
    [sym__binary_minus2] = ACTIONS(997),
    [sym__binary_star2] = ACTIONS(997),
    [anon_sym_LBRACE] = ACTIONS(997),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(999),
    [anon_sym_SEMI] = ACTIONS(5750),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(999),
    [anon_sym_LT] = ACTIONS(999),
    [anon_sym_do] = ACTIONS(997),
    [anon_sym_then] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(997),
    [anon_sym_DOT_DOT] = ACTIONS(999),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(997),
    [anon_sym_and] = ACTIONS(997),
    [anon_sym_or] = ACTIONS(997),
    [anon_sym_PIPE_PIPE] = ACTIONS(997),
    [anon_sym_AMP_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_EQ_EQ] = ACTIONS(999),
    [anon_sym_BANG_EQ] = ACTIONS(997),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(997),
    [anon_sym_LT_EQ_GT] = ACTIONS(997),
    [anon_sym_EQ_TILDE] = ACTIONS(997),
    [anon_sym_BANG_TILDE] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(999),
    [anon_sym_GT] = ACTIONS(999),
    [anon_sym_GT_EQ] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [sym_comment] = ACTIONS(87),
  },
  [8471] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(13480),
    [anon_sym_or] = ACTIONS(13480),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [8472] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10185),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10185),
    [sym_operator_assignment] = STATE(10185),
    [sym_conditional] = STATE(10185),
    [sym_range] = STATE(10185),
    [sym_binary] = STATE(10185),
    [sym_unary] = STATE(10185),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8473] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10186),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10186),
    [sym_operator_assignment] = STATE(10186),
    [sym_conditional] = STATE(10186),
    [sym_range] = STATE(10186),
    [sym_binary] = STATE(10186),
    [sym_unary] = STATE(10186),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8474] = {
    [anon_sym_COLON] = ACTIONS(13500),
    [sym_comment] = ACTIONS(87),
  },
  [8475] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10188),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10188),
    [sym_operator_assignment] = STATE(10188),
    [sym_conditional] = STATE(10188),
    [sym_range] = STATE(10188),
    [sym_binary] = STATE(10188),
    [sym_unary] = STATE(10188),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8476] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(13502),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [8477] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [8478] = {
    [sym_heredoc_body] = STATE(10190),
    [aux_sym_call_repeat1] = STATE(10190),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8479] = {
    [sym_heredoc_body] = STATE(10190),
    [aux_sym_call_repeat1] = STATE(10190),
    [aux_sym_argument_list_repeat1] = STATE(10192),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(13504),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8480] = {
    [sym_string] = STATE(8506),
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(13506),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8481] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_do] = ACTIONS(4242),
    [anon_sym_then] = ACTIONS(4242),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
  },
  [8482] = {
    [sym_heredoc_body] = STATE(10194),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(13508),
    [sym_comment] = ACTIONS(87),
  },
  [8483] = {
    [anon_sym_RPAREN] = ACTIONS(13508),
    [sym_comment] = ACTIONS(87),
  },
  [8484] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8485] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [8486] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10195),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10195),
    [sym_operator_assignment] = STATE(10195),
    [sym_conditional] = STATE(10195),
    [sym_range] = STATE(10195),
    [sym_binary] = STATE(10195),
    [sym_unary] = STATE(10195),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8487] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10196),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10196),
    [sym_operator_assignment] = STATE(10196),
    [sym_conditional] = STATE(10196),
    [sym_range] = STATE(10196),
    [sym_binary] = STATE(10196),
    [sym_unary] = STATE(10196),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8488] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10197),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10197),
    [sym_operator_assignment] = STATE(10197),
    [sym_conditional] = STATE(10197),
    [sym_range] = STATE(10197),
    [sym_binary] = STATE(10197),
    [sym_unary] = STATE(10197),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8489] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10198),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10198),
    [sym_operator_assignment] = STATE(10198),
    [sym_conditional] = STATE(10198),
    [sym_range] = STATE(10198),
    [sym_binary] = STATE(10198),
    [sym_unary] = STATE(10198),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8490] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10199),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10199),
    [sym_operator_assignment] = STATE(10199),
    [sym_conditional] = STATE(10199),
    [sym_range] = STATE(10199),
    [sym_binary] = STATE(10199),
    [sym_unary] = STATE(10199),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8491] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10200),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10200),
    [sym_operator_assignment] = STATE(10200),
    [sym_conditional] = STATE(10200),
    [sym_range] = STATE(10200),
    [sym_binary] = STATE(10200),
    [sym_unary] = STATE(10200),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8492] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10201),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(10201),
    [sym_operator_assignment] = STATE(10201),
    [sym_conditional] = STATE(10201),
    [sym_range] = STATE(10201),
    [sym_binary] = STATE(10201),
    [sym_unary] = STATE(10201),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8493] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10202),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10202),
    [sym_operator_assignment] = STATE(10202),
    [sym_conditional] = STATE(10202),
    [sym_range] = STATE(10202),
    [sym_binary] = STATE(10202),
    [sym_unary] = STATE(10202),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8494] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10203),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10203),
    [sym_operator_assignment] = STATE(10203),
    [sym_conditional] = STATE(10203),
    [sym_range] = STATE(10203),
    [sym_binary] = STATE(10203),
    [sym_unary] = STATE(10203),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8495] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10204),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10204),
    [sym_operator_assignment] = STATE(10204),
    [sym_conditional] = STATE(10204),
    [sym_range] = STATE(10204),
    [sym_binary] = STATE(10204),
    [sym_unary] = STATE(10204),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8496] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10205),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10205),
    [sym_operator_assignment] = STATE(10205),
    [sym_conditional] = STATE(10205),
    [sym_range] = STATE(10205),
    [sym_binary] = STATE(10205),
    [sym_unary] = STATE(10205),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8497] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10206),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10206),
    [sym_operator_assignment] = STATE(10206),
    [sym_conditional] = STATE(10206),
    [sym_range] = STATE(10206),
    [sym_binary] = STATE(10206),
    [sym_unary] = STATE(10206),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8498] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10207),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10207),
    [sym_operator_assignment] = STATE(10207),
    [sym_conditional] = STATE(10207),
    [sym_range] = STATE(10207),
    [sym_binary] = STATE(10207),
    [sym_unary] = STATE(10207),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8499] = {
    [sym__line_break2] = ACTIONS(6196),
    [sym__heredoc_body_start2] = ACTIONS(6196),
    [anon_sym_DOT] = ACTIONS(6196),
    [anon_sym_SEMI] = ACTIONS(6196),
    [anon_sym_then] = ACTIONS(6196),
    [anon_sym_LBRACK] = ACTIONS(6196),
    [anon_sym_COLON_COLON2] = ACTIONS(6196),
    [anon_sym_AMP_DOT] = ACTIONS(6196),
    [sym_comment] = ACTIONS(87),
  },
  [8500] = {
    [sym_interpolation] = STATE(10209),
    [aux_sym_heredoc_body_repeat1] = STATE(10209),
    [sym__heredoc_content2] = ACTIONS(13510),
    [sym_heredoc_end2] = ACTIONS(13512),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(13510),
  },
  [8501] = {
    [sym_heredoc_body] = STATE(10210),
    [aux_sym_call_repeat1] = STATE(10210),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8502] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5929),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(10211),
    [sym_splat_argument] = STATE(10211),
    [sym_hash_splat_argument] = STATE(10211),
    [sym_block_argument] = STATE(10211),
    [sym_assignment] = STATE(5929),
    [sym_operator_assignment] = STATE(5929),
    [sym_conditional] = STATE(5929),
    [sym_range] = STATE(5929),
    [sym_binary] = STATE(5929),
    [sym_unary] = STATE(5929),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5936),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10212),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(10211),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8811),
    [sym__splat_star2] = ACTIONS(8813),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(8817),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8821),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(8841),
    [sym_identifier] = ACTIONS(8841),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8503] = {
    [sym_heredoc_body] = STATE(10213),
    [aux_sym_call_repeat1] = STATE(10213),
    [aux_sym_argument_list_repeat1] = STATE(10214),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4346),
    [anon_sym_COMMA] = ACTIONS(11589),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8504] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10215),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_splat_argument] = STATE(10216),
    [sym_assignment] = STATE(10215),
    [sym_operator_assignment] = STATE(10215),
    [sym_conditional] = STATE(10215),
    [sym_range] = STATE(10215),
    [sym_binary] = STATE(10215),
    [sym_unary] = STATE(10215),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10216),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8505] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10217),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(10217),
    [sym_operator_assignment] = STATE(10217),
    [sym_conditional] = STATE(10217),
    [sym_range] = STATE(10217),
    [sym_binary] = STATE(10217),
    [sym_unary] = STATE(10217),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8506] = {
    [sym_string] = STATE(10218),
    [aux_sym_chained_string_repeat1] = STATE(10218),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [8507] = {
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_else] = ACTIONS(13514),
    [anon_sym_ensure] = ACTIONS(13514),
    [sym_comment] = ACTIONS(87),
  },
  [8508] = {
    [sym_rescue] = STATE(10219),
    [anon_sym_end] = ACTIONS(13514),
    [anon_sym_rescue] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(13514),
    [anon_sym_ensure] = ACTIONS(13514),
    [sym_comment] = ACTIONS(87),
  },
  [8509] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10220),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_assignment] = STATE(10220),
    [sym_operator_assignment] = STATE(10220),
    [sym_conditional] = STATE(10220),
    [sym_range] = STATE(10220),
    [sym_binary] = STATE(10220),
    [sym_unary] = STATE(10220),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8510] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8511] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8512] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8513] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8514] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8515] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8516] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8517] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8518] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13516),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8519] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8520] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8521] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8522] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8523] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8524] = {
    [sym_heredoc_body] = STATE(8524),
    [aux_sym_call_repeat1] = STATE(8524),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8525] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3254),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(3254),
    [sym_operator_assignment] = STATE(3254),
    [sym_conditional] = STATE(3254),
    [sym_range] = STATE(3254),
    [sym_binary] = STATE(3254),
    [sym_unary] = STATE(3254),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3260),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5138),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__identifier_hash_key2] = ACTIONS(5144),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11605),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5162),
    [sym_identifier] = ACTIONS(5162),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8526] = {
    [sym_heredoc_body] = STATE(8524),
    [aux_sym_call_repeat1] = STATE(8524),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8527] = {
    [aux_sym_argument_list_repeat1] = STATE(8527),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13518),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8528] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8529] = {
    [aux_sym_exceptions_repeat1] = STATE(10223),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8530] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [8531] = {
    [sym_string] = STATE(8531),
    [aux_sym_chained_string_repeat1] = STATE(8531),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8532] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [8533] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5982),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1223),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(1223),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(5982),
    [sym_operator_assignment] = STATE(5982),
    [sym_conditional] = STATE(5982),
    [sym_range] = STATE(5982),
    [sym_binary] = STATE(5982),
    [sym_unary] = STATE(5982),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(1222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1223),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1223),
    [sym_false] = STATE(1223),
    [sym_nil] = STATE(1223),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(8897),
    [sym__unary_minus2] = ACTIONS(2115),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2129),
    [anon_sym_defined_QMARK] = ACTIONS(2131),
    [anon_sym_not] = ACTIONS(2133),
    [anon_sym_BANG] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(2135),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8534] = {
    [aux_sym_exceptions_repeat1] = STATE(10224),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(13521),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8535] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8536] = {
    [sym_heredoc_body] = STATE(10225),
    [aux_sym_call_repeat1] = STATE(10225),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8537] = {
    [sym_heredoc_body] = STATE(10225),
    [aux_sym_call_repeat1] = STATE(10225),
    [aux_sym_argument_list_repeat1] = STATE(10226),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(8971),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_ensure] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8538] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8539] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [8540] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10227),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10227),
    [sym_operator_assignment] = STATE(10227),
    [sym_conditional] = STATE(10227),
    [sym_range] = STATE(10227),
    [sym_binary] = STATE(10227),
    [sym_unary] = STATE(10227),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8541] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10228),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10228),
    [sym_operator_assignment] = STATE(10228),
    [sym_conditional] = STATE(10228),
    [sym_range] = STATE(10228),
    [sym_binary] = STATE(10228),
    [sym_unary] = STATE(10228),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8542] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10229),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10229),
    [sym_operator_assignment] = STATE(10229),
    [sym_conditional] = STATE(10229),
    [sym_range] = STATE(10229),
    [sym_binary] = STATE(10229),
    [sym_unary] = STATE(10229),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8543] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10230),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10230),
    [sym_operator_assignment] = STATE(10230),
    [sym_conditional] = STATE(10230),
    [sym_range] = STATE(10230),
    [sym_binary] = STATE(10230),
    [sym_unary] = STATE(10230),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8544] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10231),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10231),
    [sym_operator_assignment] = STATE(10231),
    [sym_conditional] = STATE(10231),
    [sym_range] = STATE(10231),
    [sym_binary] = STATE(10231),
    [sym_unary] = STATE(10231),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8545] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10232),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10232),
    [sym_operator_assignment] = STATE(10232),
    [sym_conditional] = STATE(10232),
    [sym_range] = STATE(10232),
    [sym_binary] = STATE(10232),
    [sym_unary] = STATE(10232),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8546] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10233),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10233),
    [sym_operator_assignment] = STATE(10233),
    [sym_conditional] = STATE(10233),
    [sym_range] = STATE(10233),
    [sym_binary] = STATE(10233),
    [sym_unary] = STATE(10233),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8547] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10234),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10234),
    [sym_operator_assignment] = STATE(10234),
    [sym_conditional] = STATE(10234),
    [sym_range] = STATE(10234),
    [sym_binary] = STATE(10234),
    [sym_unary] = STATE(10234),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8548] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10235),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10235),
    [sym_operator_assignment] = STATE(10235),
    [sym_conditional] = STATE(10235),
    [sym_range] = STATE(10235),
    [sym_binary] = STATE(10235),
    [sym_unary] = STATE(10235),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8549] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10236),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10236),
    [sym_operator_assignment] = STATE(10236),
    [sym_conditional] = STATE(10236),
    [sym_range] = STATE(10236),
    [sym_binary] = STATE(10236),
    [sym_unary] = STATE(10236),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8550] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10237),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10237),
    [sym_operator_assignment] = STATE(10237),
    [sym_conditional] = STATE(10237),
    [sym_range] = STATE(10237),
    [sym_binary] = STATE(10237),
    [sym_unary] = STATE(10237),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8551] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10238),
    [sym_operator_assignment] = STATE(10238),
    [sym_conditional] = STATE(10238),
    [sym_range] = STATE(10238),
    [sym_binary] = STATE(10238),
    [sym_unary] = STATE(10238),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8552] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10239),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_splat_argument] = STATE(10240),
    [sym_assignment] = STATE(10239),
    [sym_operator_assignment] = STATE(10239),
    [sym_conditional] = STATE(10239),
    [sym_range] = STATE(10239),
    [sym_binary] = STATE(10239),
    [sym_unary] = STATE(10239),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10240),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8553] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10241),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(10241),
    [sym_operator_assignment] = STATE(10241),
    [sym_conditional] = STATE(10241),
    [sym_range] = STATE(10241),
    [sym_binary] = STATE(10241),
    [sym_unary] = STATE(10241),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8554] = {
    [sym_string] = STATE(10242),
    [aux_sym_chained_string_repeat1] = STATE(10242),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [8555] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [8556] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8557] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8558] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10243),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(10243),
    [sym_operator_assignment] = STATE(10243),
    [sym_conditional] = STATE(10243),
    [sym_range] = STATE(10243),
    [sym_binary] = STATE(10243),
    [sym_unary] = STATE(10243),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8559] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8560] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10244),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(10244),
    [sym_operator_assignment] = STATE(10244),
    [sym_conditional] = STATE(10244),
    [sym_range] = STATE(10244),
    [sym_binary] = STATE(10244),
    [sym_unary] = STATE(10244),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8561] = {
    [sym_heredoc_body] = STATE(10245),
    [aux_sym_call_repeat1] = STATE(10245),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8562] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10246),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13523),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8563] = {
    [sym_heredoc_body] = STATE(10247),
    [aux_sym_call_repeat1] = STATE(10247),
    [aux_sym_argument_list_repeat1] = STATE(10248),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11652),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8564] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8565] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8566] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8567] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8568] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8569] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8570] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [8571] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13525),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8572] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8573] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8574] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8575] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8576] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8577] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_ensure] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8578] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8579] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10250),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(10250),
    [sym_operator_assignment] = STATE(10250),
    [sym_conditional] = STATE(10250),
    [sym_range] = STATE(10250),
    [sym_binary] = STATE(10250),
    [sym_unary] = STATE(10250),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8580] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_ensure] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8581] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10251),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(10251),
    [sym_operator_assignment] = STATE(10251),
    [sym_conditional] = STATE(10251),
    [sym_range] = STATE(10251),
    [sym_binary] = STATE(10251),
    [sym_unary] = STATE(10251),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8582] = {
    [sym_heredoc_body] = STATE(10252),
    [aux_sym_call_repeat1] = STATE(10252),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8583] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(10253),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13527),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8584] = {
    [sym_heredoc_body] = STATE(10254),
    [aux_sym_call_repeat1] = STATE(10254),
    [aux_sym_argument_list_repeat1] = STATE(10255),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11660),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8585] = {
    [sym_heredoc_body] = STATE(8585),
    [aux_sym_call_repeat1] = STATE(8585),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8586] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3280),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3280),
    [sym_operator_assignment] = STATE(3280),
    [sym_conditional] = STATE(3280),
    [sym_range] = STATE(3280),
    [sym_binary] = STATE(3280),
    [sym_unary] = STATE(3280),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3286),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5180),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__identifier_hash_key2] = ACTIONS(5186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11664),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5204),
    [sym_identifier] = ACTIONS(5204),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8587] = {
    [sym_heredoc_body] = STATE(8585),
    [aux_sym_call_repeat1] = STATE(8585),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8588] = {
    [aux_sym_argument_list_repeat1] = STATE(8588),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13529),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8589] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8590] = {
    [aux_sym_exceptions_repeat1] = STATE(10257),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8591] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [8592] = {
    [sym_string] = STATE(8592),
    [aux_sym_chained_string_repeat1] = STATE(8592),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8593] = {
    [aux_sym_undef_repeat1] = STATE(8593),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_ensure] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [8594] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1237),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1238),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(1238),
    [sym_operator_assignment] = STATE(1238),
    [sym_conditional] = STATE(1238),
    [sym_range] = STATE(1238),
    [sym_binary] = STATE(1238),
    [sym_unary] = STATE(1238),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [anon_sym_undef] = ACTIONS(2169),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8595] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10258),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1241),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(1241),
    [sym_assignment] = STATE(10258),
    [sym_operator_assignment] = STATE(10258),
    [sym_conditional] = STATE(10258),
    [sym_range] = STATE(10258),
    [sym_binary] = STATE(10258),
    [sym_unary] = STATE(10258),
    [sym_left_assignment_list] = STATE(1240),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1241),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1241),
    [sym_false] = STATE(1241),
    [sym_nil] = STATE(1241),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1242),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2143),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2149),
    [anon_sym_yield] = ACTIONS(2151),
    [anon_sym_break] = ACTIONS(2153),
    [anon_sym_next] = ACTIONS(2155),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2157),
    [anon_sym_defined_QMARK] = ACTIONS(2159),
    [anon_sym_not] = ACTIONS(2161),
    [anon_sym_BANG] = ACTIONS(2163),
    [anon_sym_TILDE] = ACTIONS(2163),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8596] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [8597] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [8598] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [8599] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10259),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10259),
    [sym_operator_assignment] = STATE(10259),
    [sym_conditional] = STATE(10259),
    [sym_range] = STATE(10259),
    [sym_binary] = STATE(10259),
    [sym_unary] = STATE(10259),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8600] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10260),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10260),
    [sym_operator_assignment] = STATE(10260),
    [sym_conditional] = STATE(10260),
    [sym_range] = STATE(10260),
    [sym_binary] = STATE(10260),
    [sym_unary] = STATE(10260),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8601] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10261),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10261),
    [sym_operator_assignment] = STATE(10261),
    [sym_conditional] = STATE(10261),
    [sym_range] = STATE(10261),
    [sym_binary] = STATE(10261),
    [sym_unary] = STATE(10261),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8602] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10262),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10262),
    [sym_operator_assignment] = STATE(10262),
    [sym_conditional] = STATE(10262),
    [sym_range] = STATE(10262),
    [sym_binary] = STATE(10262),
    [sym_unary] = STATE(10262),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8603] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10263),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10263),
    [sym_operator_assignment] = STATE(10263),
    [sym_conditional] = STATE(10263),
    [sym_range] = STATE(10263),
    [sym_binary] = STATE(10263),
    [sym_unary] = STATE(10263),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8604] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10264),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10264),
    [sym_operator_assignment] = STATE(10264),
    [sym_conditional] = STATE(10264),
    [sym_range] = STATE(10264),
    [sym_binary] = STATE(10264),
    [sym_unary] = STATE(10264),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8605] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10265),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10265),
    [sym_operator_assignment] = STATE(10265),
    [sym_conditional] = STATE(10265),
    [sym_range] = STATE(10265),
    [sym_binary] = STATE(10265),
    [sym_unary] = STATE(10265),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8606] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10266),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10266),
    [sym_operator_assignment] = STATE(10266),
    [sym_conditional] = STATE(10266),
    [sym_range] = STATE(10266),
    [sym_binary] = STATE(10266),
    [sym_unary] = STATE(10266),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8607] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10267),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10267),
    [sym_operator_assignment] = STATE(10267),
    [sym_conditional] = STATE(10267),
    [sym_range] = STATE(10267),
    [sym_binary] = STATE(10267),
    [sym_unary] = STATE(10267),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8608] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10268),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10268),
    [sym_operator_assignment] = STATE(10268),
    [sym_conditional] = STATE(10268),
    [sym_range] = STATE(10268),
    [sym_binary] = STATE(10268),
    [sym_unary] = STATE(10268),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8609] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10269),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10269),
    [sym_operator_assignment] = STATE(10269),
    [sym_conditional] = STATE(10269),
    [sym_range] = STATE(10269),
    [sym_binary] = STATE(10269),
    [sym_unary] = STATE(10269),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8610] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10270),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10270),
    [sym_operator_assignment] = STATE(10270),
    [sym_conditional] = STATE(10270),
    [sym_range] = STATE(10270),
    [sym_binary] = STATE(10270),
    [sym_unary] = STATE(10270),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8611] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10271),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_splat_argument] = STATE(10272),
    [sym_assignment] = STATE(10271),
    [sym_operator_assignment] = STATE(10271),
    [sym_conditional] = STATE(10271),
    [sym_range] = STATE(10271),
    [sym_binary] = STATE(10271),
    [sym_unary] = STATE(10271),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(10272),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8612] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10273),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(10273),
    [sym_operator_assignment] = STATE(10273),
    [sym_conditional] = STATE(10273),
    [sym_range] = STATE(10273),
    [sym_binary] = STATE(10273),
    [sym_unary] = STATE(10273),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8613] = {
    [sym_string] = STATE(10274),
    [aux_sym_chained_string_repeat1] = STATE(10274),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_ensure] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [8614] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [8615] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8616] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8617] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8618] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8619] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8620] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8621] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [8622] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13532),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8623] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8624] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8625] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8626] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8627] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8628] = {
    [sym_heredoc_body] = STATE(8628),
    [aux_sym_call_repeat1] = STATE(8628),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8629] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3322),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(3322),
    [sym_operator_assignment] = STATE(3322),
    [sym_conditional] = STATE(3322),
    [sym_range] = STATE(3322),
    [sym_binary] = STATE(3322),
    [sym_unary] = STATE(3322),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3328),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5258),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__identifier_hash_key2] = ACTIONS(5264),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11705),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5282),
    [sym_identifier] = ACTIONS(5282),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8630] = {
    [sym_heredoc_body] = STATE(8628),
    [aux_sym_call_repeat1] = STATE(8628),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8631] = {
    [aux_sym_argument_list_repeat1] = STATE(8631),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13534),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8632] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8633] = {
    [aux_sym_exceptions_repeat1] = STATE(10277),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8634] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [8635] = {
    [sym_string] = STATE(8635),
    [aux_sym_chained_string_repeat1] = STATE(8635),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8636] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_ensure] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [8637] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_ensure] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8638] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8639] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_ensure] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [8640] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10278),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10278),
    [sym_operator_assignment] = STATE(10278),
    [sym_conditional] = STATE(10278),
    [sym_range] = STATE(10278),
    [sym_binary] = STATE(10278),
    [sym_unary] = STATE(10278),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8641] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10279),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10279),
    [sym_operator_assignment] = STATE(10279),
    [sym_conditional] = STATE(10279),
    [sym_range] = STATE(10279),
    [sym_binary] = STATE(10279),
    [sym_unary] = STATE(10279),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8642] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10280),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10280),
    [sym_operator_assignment] = STATE(10280),
    [sym_conditional] = STATE(10280),
    [sym_range] = STATE(10280),
    [sym_binary] = STATE(10280),
    [sym_unary] = STATE(10280),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8643] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10281),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10281),
    [sym_operator_assignment] = STATE(10281),
    [sym_conditional] = STATE(10281),
    [sym_range] = STATE(10281),
    [sym_binary] = STATE(10281),
    [sym_unary] = STATE(10281),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8644] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10282),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10282),
    [sym_operator_assignment] = STATE(10282),
    [sym_conditional] = STATE(10282),
    [sym_range] = STATE(10282),
    [sym_binary] = STATE(10282),
    [sym_unary] = STATE(10282),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8645] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10283),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10283),
    [sym_operator_assignment] = STATE(10283),
    [sym_conditional] = STATE(10283),
    [sym_range] = STATE(10283),
    [sym_binary] = STATE(10283),
    [sym_unary] = STATE(10283),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8646] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10284),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10284),
    [sym_operator_assignment] = STATE(10284),
    [sym_conditional] = STATE(10284),
    [sym_range] = STATE(10284),
    [sym_binary] = STATE(10284),
    [sym_unary] = STATE(10284),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8647] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10285),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10285),
    [sym_operator_assignment] = STATE(10285),
    [sym_conditional] = STATE(10285),
    [sym_range] = STATE(10285),
    [sym_binary] = STATE(10285),
    [sym_unary] = STATE(10285),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8648] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10286),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10286),
    [sym_operator_assignment] = STATE(10286),
    [sym_conditional] = STATE(10286),
    [sym_range] = STATE(10286),
    [sym_binary] = STATE(10286),
    [sym_unary] = STATE(10286),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8649] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10287),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10287),
    [sym_operator_assignment] = STATE(10287),
    [sym_conditional] = STATE(10287),
    [sym_range] = STATE(10287),
    [sym_binary] = STATE(10287),
    [sym_unary] = STATE(10287),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8650] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10288),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10288),
    [sym_operator_assignment] = STATE(10288),
    [sym_conditional] = STATE(10288),
    [sym_range] = STATE(10288),
    [sym_binary] = STATE(10288),
    [sym_unary] = STATE(10288),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8651] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10289),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10289),
    [sym_operator_assignment] = STATE(10289),
    [sym_conditional] = STATE(10289),
    [sym_range] = STATE(10289),
    [sym_binary] = STATE(10289),
    [sym_unary] = STATE(10289),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8652] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9051),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8653] = {
    [aux_sym_exceptions_repeat1] = STATE(10290),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(11737),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8654] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6106),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_splat_argument] = STATE(10291),
    [sym_assignment] = STATE(6106),
    [sym_operator_assignment] = STATE(6106),
    [sym_conditional] = STATE(6106),
    [sym_range] = STATE(6106),
    [sym_binary] = STATE(6106),
    [sym_unary] = STATE(6106),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(10291),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9051),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8655] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10292),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(10292),
    [sym_operator_assignment] = STATE(10292),
    [sym_conditional] = STATE(10292),
    [sym_range] = STATE(10292),
    [sym_binary] = STATE(10292),
    [sym_unary] = STATE(10292),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8656] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8657] = {
    [sym_heredoc_body] = STATE(10293),
    [aux_sym_call_repeat1] = STATE(10293),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8658] = {
    [sym_heredoc_body] = STATE(10293),
    [aux_sym_call_repeat1] = STATE(10293),
    [aux_sym_argument_list_repeat1] = STATE(10294),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9137),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8659] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8660] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [8661] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10295),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10295),
    [sym_operator_assignment] = STATE(10295),
    [sym_conditional] = STATE(10295),
    [sym_range] = STATE(10295),
    [sym_binary] = STATE(10295),
    [sym_unary] = STATE(10295),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8662] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10296),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10296),
    [sym_operator_assignment] = STATE(10296),
    [sym_conditional] = STATE(10296),
    [sym_range] = STATE(10296),
    [sym_binary] = STATE(10296),
    [sym_unary] = STATE(10296),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8663] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10297),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10297),
    [sym_operator_assignment] = STATE(10297),
    [sym_conditional] = STATE(10297),
    [sym_range] = STATE(10297),
    [sym_binary] = STATE(10297),
    [sym_unary] = STATE(10297),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8664] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10298),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10298),
    [sym_operator_assignment] = STATE(10298),
    [sym_conditional] = STATE(10298),
    [sym_range] = STATE(10298),
    [sym_binary] = STATE(10298),
    [sym_unary] = STATE(10298),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8665] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10299),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10299),
    [sym_operator_assignment] = STATE(10299),
    [sym_conditional] = STATE(10299),
    [sym_range] = STATE(10299),
    [sym_binary] = STATE(10299),
    [sym_unary] = STATE(10299),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8666] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10300),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10300),
    [sym_operator_assignment] = STATE(10300),
    [sym_conditional] = STATE(10300),
    [sym_range] = STATE(10300),
    [sym_binary] = STATE(10300),
    [sym_unary] = STATE(10300),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8667] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10301),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10301),
    [sym_operator_assignment] = STATE(10301),
    [sym_conditional] = STATE(10301),
    [sym_range] = STATE(10301),
    [sym_binary] = STATE(10301),
    [sym_unary] = STATE(10301),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8668] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10302),
    [sym_operator_assignment] = STATE(10302),
    [sym_conditional] = STATE(10302),
    [sym_range] = STATE(10302),
    [sym_binary] = STATE(10302),
    [sym_unary] = STATE(10302),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8669] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10303),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10303),
    [sym_operator_assignment] = STATE(10303),
    [sym_conditional] = STATE(10303),
    [sym_range] = STATE(10303),
    [sym_binary] = STATE(10303),
    [sym_unary] = STATE(10303),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8670] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10304),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10304),
    [sym_operator_assignment] = STATE(10304),
    [sym_conditional] = STATE(10304),
    [sym_range] = STATE(10304),
    [sym_binary] = STATE(10304),
    [sym_unary] = STATE(10304),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8671] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10305),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10305),
    [sym_operator_assignment] = STATE(10305),
    [sym_conditional] = STATE(10305),
    [sym_range] = STATE(10305),
    [sym_binary] = STATE(10305),
    [sym_unary] = STATE(10305),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8672] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10306),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10306),
    [sym_operator_assignment] = STATE(10306),
    [sym_conditional] = STATE(10306),
    [sym_range] = STATE(10306),
    [sym_binary] = STATE(10306),
    [sym_unary] = STATE(10306),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8673] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10307),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_splat_argument] = STATE(10308),
    [sym_assignment] = STATE(10307),
    [sym_operator_assignment] = STATE(10307),
    [sym_conditional] = STATE(10307),
    [sym_range] = STATE(10307),
    [sym_binary] = STATE(10307),
    [sym_unary] = STATE(10307),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10308),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8674] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10309),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(10309),
    [sym_operator_assignment] = STATE(10309),
    [sym_conditional] = STATE(10309),
    [sym_range] = STATE(10309),
    [sym_binary] = STATE(10309),
    [sym_unary] = STATE(10309),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8675] = {
    [sym_string] = STATE(10310),
    [aux_sym_chained_string_repeat1] = STATE(10310),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [8676] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [8677] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8678] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8679] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10311),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(10311),
    [sym_operator_assignment] = STATE(10311),
    [sym_conditional] = STATE(10311),
    [sym_range] = STATE(10311),
    [sym_binary] = STATE(10311),
    [sym_unary] = STATE(10311),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8680] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8681] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10312),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(10312),
    [sym_operator_assignment] = STATE(10312),
    [sym_conditional] = STATE(10312),
    [sym_range] = STATE(10312),
    [sym_binary] = STATE(10312),
    [sym_unary] = STATE(10312),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8682] = {
    [sym_heredoc_body] = STATE(10313),
    [aux_sym_call_repeat1] = STATE(10313),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8683] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10314),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13537),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8684] = {
    [sym_heredoc_body] = STATE(10315),
    [aux_sym_call_repeat1] = STATE(10315),
    [aux_sym_argument_list_repeat1] = STATE(10316),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11785),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8685] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8686] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8687] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8688] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8689] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8690] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8691] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [8692] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13539),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8693] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8694] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8695] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8696] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8697] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8698] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8699] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8700] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10318),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(10318),
    [sym_operator_assignment] = STATE(10318),
    [sym_conditional] = STATE(10318),
    [sym_range] = STATE(10318),
    [sym_binary] = STATE(10318),
    [sym_unary] = STATE(10318),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8701] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8702] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10319),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(10319),
    [sym_operator_assignment] = STATE(10319),
    [sym_conditional] = STATE(10319),
    [sym_range] = STATE(10319),
    [sym_binary] = STATE(10319),
    [sym_unary] = STATE(10319),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8703] = {
    [sym_heredoc_body] = STATE(10320),
    [aux_sym_call_repeat1] = STATE(10320),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8704] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(10321),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8705] = {
    [sym_heredoc_body] = STATE(10322),
    [aux_sym_call_repeat1] = STATE(10322),
    [aux_sym_argument_list_repeat1] = STATE(10323),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11793),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [8706] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8707] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3347),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3347),
    [sym_operator_assignment] = STATE(3347),
    [sym_conditional] = STATE(3347),
    [sym_range] = STATE(3347),
    [sym_binary] = STATE(3347),
    [sym_unary] = STATE(3347),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3353),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(5296),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__identifier_hash_key2] = ACTIONS(5302),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11797),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5320),
    [sym_identifier] = ACTIONS(5320),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8708] = {
    [sym_heredoc_body] = STATE(8706),
    [aux_sym_call_repeat1] = STATE(8706),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8709] = {
    [aux_sym_argument_list_repeat1] = STATE(8709),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13543),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8710] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8711] = {
    [aux_sym_exceptions_repeat1] = STATE(10325),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8712] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [8713] = {
    [sym_string] = STATE(8713),
    [aux_sym_chained_string_repeat1] = STATE(8713),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8714] = {
    [aux_sym_undef_repeat1] = STATE(8714),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [8715] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8716] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10326),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(10326),
    [sym_operator_assignment] = STATE(10326),
    [sym_conditional] = STATE(10326),
    [sym_range] = STATE(10326),
    [sym_binary] = STATE(10326),
    [sym_unary] = STATE(10326),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8717] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [8718] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [8719] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [8720] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10327),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10327),
    [sym_operator_assignment] = STATE(10327),
    [sym_conditional] = STATE(10327),
    [sym_range] = STATE(10327),
    [sym_binary] = STATE(10327),
    [sym_unary] = STATE(10327),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8721] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10328),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10328),
    [sym_operator_assignment] = STATE(10328),
    [sym_conditional] = STATE(10328),
    [sym_range] = STATE(10328),
    [sym_binary] = STATE(10328),
    [sym_unary] = STATE(10328),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8722] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10329),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10329),
    [sym_operator_assignment] = STATE(10329),
    [sym_conditional] = STATE(10329),
    [sym_range] = STATE(10329),
    [sym_binary] = STATE(10329),
    [sym_unary] = STATE(10329),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8723] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10330),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10330),
    [sym_operator_assignment] = STATE(10330),
    [sym_conditional] = STATE(10330),
    [sym_range] = STATE(10330),
    [sym_binary] = STATE(10330),
    [sym_unary] = STATE(10330),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8724] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10331),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10331),
    [sym_operator_assignment] = STATE(10331),
    [sym_conditional] = STATE(10331),
    [sym_range] = STATE(10331),
    [sym_binary] = STATE(10331),
    [sym_unary] = STATE(10331),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8725] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10332),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10332),
    [sym_operator_assignment] = STATE(10332),
    [sym_conditional] = STATE(10332),
    [sym_range] = STATE(10332),
    [sym_binary] = STATE(10332),
    [sym_unary] = STATE(10332),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8726] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10333),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10333),
    [sym_operator_assignment] = STATE(10333),
    [sym_conditional] = STATE(10333),
    [sym_range] = STATE(10333),
    [sym_binary] = STATE(10333),
    [sym_unary] = STATE(10333),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8727] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10334),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10334),
    [sym_operator_assignment] = STATE(10334),
    [sym_conditional] = STATE(10334),
    [sym_range] = STATE(10334),
    [sym_binary] = STATE(10334),
    [sym_unary] = STATE(10334),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8728] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10335),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10335),
    [sym_operator_assignment] = STATE(10335),
    [sym_conditional] = STATE(10335),
    [sym_range] = STATE(10335),
    [sym_binary] = STATE(10335),
    [sym_unary] = STATE(10335),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8729] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10336),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10336),
    [sym_operator_assignment] = STATE(10336),
    [sym_conditional] = STATE(10336),
    [sym_range] = STATE(10336),
    [sym_binary] = STATE(10336),
    [sym_unary] = STATE(10336),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8730] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10337),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10337),
    [sym_operator_assignment] = STATE(10337),
    [sym_conditional] = STATE(10337),
    [sym_range] = STATE(10337),
    [sym_binary] = STATE(10337),
    [sym_unary] = STATE(10337),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8731] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10338),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10338),
    [sym_operator_assignment] = STATE(10338),
    [sym_conditional] = STATE(10338),
    [sym_range] = STATE(10338),
    [sym_binary] = STATE(10338),
    [sym_unary] = STATE(10338),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8732] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10339),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_splat_argument] = STATE(10340),
    [sym_assignment] = STATE(10339),
    [sym_operator_assignment] = STATE(10339),
    [sym_conditional] = STATE(10339),
    [sym_range] = STATE(10339),
    [sym_binary] = STATE(10339),
    [sym_unary] = STATE(10339),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(10340),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8733] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10341),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(10341),
    [sym_operator_assignment] = STATE(10341),
    [sym_conditional] = STATE(10341),
    [sym_range] = STATE(10341),
    [sym_binary] = STATE(10341),
    [sym_unary] = STATE(10341),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [8734] = {
    [sym_string] = STATE(10342),
    [aux_sym_chained_string_repeat1] = STATE(10342),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [8735] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [8736] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8737] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8738] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8739] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8740] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8741] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8742] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [8743] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13546),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8744] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8745] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8746] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8747] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8748] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8749] = {
    [sym_heredoc_body] = STATE(8749),
    [aux_sym_call_repeat1] = STATE(8749),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8750] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3389),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(3389),
    [sym_operator_assignment] = STATE(3389),
    [sym_conditional] = STATE(3389),
    [sym_range] = STATE(3389),
    [sym_binary] = STATE(3389),
    [sym_unary] = STATE(3389),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3395),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(5374),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__identifier_hash_key2] = ACTIONS(5380),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11838),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5398),
    [sym_identifier] = ACTIONS(5398),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8751] = {
    [sym_heredoc_body] = STATE(8749),
    [aux_sym_call_repeat1] = STATE(8749),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8752] = {
    [aux_sym_argument_list_repeat1] = STATE(8752),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13548),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8753] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8754] = {
    [aux_sym_exceptions_repeat1] = STATE(10345),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8755] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [8756] = {
    [sym_string] = STATE(8756),
    [aux_sym_chained_string_repeat1] = STATE(8756),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8757] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [8758] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8759] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8760] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [8761] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10346),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10346),
    [sym_operator_assignment] = STATE(10346),
    [sym_conditional] = STATE(10346),
    [sym_range] = STATE(10346),
    [sym_binary] = STATE(10346),
    [sym_unary] = STATE(10346),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8762] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10347),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10347),
    [sym_operator_assignment] = STATE(10347),
    [sym_conditional] = STATE(10347),
    [sym_range] = STATE(10347),
    [sym_binary] = STATE(10347),
    [sym_unary] = STATE(10347),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8763] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10348),
    [sym_operator_assignment] = STATE(10348),
    [sym_conditional] = STATE(10348),
    [sym_range] = STATE(10348),
    [sym_binary] = STATE(10348),
    [sym_unary] = STATE(10348),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8764] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10349),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10349),
    [sym_operator_assignment] = STATE(10349),
    [sym_conditional] = STATE(10349),
    [sym_range] = STATE(10349),
    [sym_binary] = STATE(10349),
    [sym_unary] = STATE(10349),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8765] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10350),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10350),
    [sym_operator_assignment] = STATE(10350),
    [sym_conditional] = STATE(10350),
    [sym_range] = STATE(10350),
    [sym_binary] = STATE(10350),
    [sym_unary] = STATE(10350),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8766] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10351),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10351),
    [sym_operator_assignment] = STATE(10351),
    [sym_conditional] = STATE(10351),
    [sym_range] = STATE(10351),
    [sym_binary] = STATE(10351),
    [sym_unary] = STATE(10351),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8767] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10352),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10352),
    [sym_operator_assignment] = STATE(10352),
    [sym_conditional] = STATE(10352),
    [sym_range] = STATE(10352),
    [sym_binary] = STATE(10352),
    [sym_unary] = STATE(10352),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8768] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10353),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10353),
    [sym_operator_assignment] = STATE(10353),
    [sym_conditional] = STATE(10353),
    [sym_range] = STATE(10353),
    [sym_binary] = STATE(10353),
    [sym_unary] = STATE(10353),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8769] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10354),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10354),
    [sym_operator_assignment] = STATE(10354),
    [sym_conditional] = STATE(10354),
    [sym_range] = STATE(10354),
    [sym_binary] = STATE(10354),
    [sym_unary] = STATE(10354),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8770] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10355),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10355),
    [sym_operator_assignment] = STATE(10355),
    [sym_conditional] = STATE(10355),
    [sym_range] = STATE(10355),
    [sym_binary] = STATE(10355),
    [sym_unary] = STATE(10355),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8771] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10356),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10356),
    [sym_operator_assignment] = STATE(10356),
    [sym_conditional] = STATE(10356),
    [sym_range] = STATE(10356),
    [sym_binary] = STATE(10356),
    [sym_unary] = STATE(10356),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8772] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10357),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10357),
    [sym_operator_assignment] = STATE(10357),
    [sym_conditional] = STATE(10357),
    [sym_range] = STATE(10357),
    [sym_binary] = STATE(10357),
    [sym_unary] = STATE(10357),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8773] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6232),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(6232),
    [sym_operator_assignment] = STATE(6232),
    [sym_conditional] = STATE(6232),
    [sym_range] = STATE(6232),
    [sym_binary] = STATE(6232),
    [sym_unary] = STATE(6232),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9217),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8774] = {
    [aux_sym_exceptions_repeat1] = STATE(10358),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(11870),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8775] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(6232),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_splat_argument] = STATE(10359),
    [sym_assignment] = STATE(6232),
    [sym_operator_assignment] = STATE(6232),
    [sym_conditional] = STATE(6232),
    [sym_range] = STATE(6232),
    [sym_binary] = STATE(6232),
    [sym_unary] = STATE(6232),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(10359),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(9217),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8776] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10360),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(10360),
    [sym_operator_assignment] = STATE(10360),
    [sym_conditional] = STATE(10360),
    [sym_range] = STATE(10360),
    [sym_binary] = STATE(10360),
    [sym_unary] = STATE(10360),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8777] = {
    [sym__line_break2] = ACTIONS(13551),
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [ts_builtin_sym_end] = ACTIONS(13551),
    [anon_sym___END__] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13551),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_end] = ACTIONS(13551),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_when] = ACTIONS(13551),
    [anon_sym_elsif] = ACTIONS(13551),
    [anon_sym_else] = ACTIONS(13551),
    [anon_sym_then] = ACTIONS(13551),
    [anon_sym_ensure] = ACTIONS(13551),
    [anon_sym_EQ_GT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13551),
    [anon_sym_AMP_AMP] = ACTIONS(13551),
    [anon_sym_LT_LT] = ACTIONS(13551),
    [anon_sym_GT_GT] = ACTIONS(13551),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13551),
    [anon_sym_PLUS] = ACTIONS(13551),
    [anon_sym_SLASH] = ACTIONS(13551),
    [anon_sym_PERCENT] = ACTIONS(13551),
    [sym_comment] = ACTIONS(87),
  },
  [8778] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(2223),
    [sym__binary_star2] = ACTIONS(2225),
    [anon_sym_PIPE] = ACTIONS(2227),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(2229),
    [anon_sym_AMP] = ACTIONS(2231),
    [anon_sym_LT] = ACTIONS(2233),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2237),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2239),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2243),
    [anon_sym_AMP_AMP] = ACTIONS(2243),
    [anon_sym_LT_LT] = ACTIONS(2245),
    [anon_sym_GT_GT] = ACTIONS(2245),
    [anon_sym_EQ_EQ] = ACTIONS(2247),
    [anon_sym_BANG_EQ] = ACTIONS(2243),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2243),
    [anon_sym_LT_EQ_GT] = ACTIONS(2243),
    [anon_sym_EQ_TILDE] = ACTIONS(2243),
    [anon_sym_BANG_TILDE] = ACTIONS(2243),
    [anon_sym_LT_EQ] = ACTIONS(2233),
    [anon_sym_GT] = ACTIONS(2233),
    [anon_sym_GT_EQ] = ACTIONS(2249),
    [anon_sym_CARET] = ACTIONS(2251),
    [anon_sym_PLUS] = ACTIONS(2253),
    [anon_sym_SLASH] = ACTIONS(2229),
    [anon_sym_PERCENT] = ACTIONS(2229),
    [sym_comment] = ACTIONS(87),
  },
  [8779] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8780] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [8781] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8782] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [8783] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8784] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8785] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13555),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8786] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8787] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8788] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8789] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8790] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8791] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8792] = {
    [aux_sym_exceptions_repeat1] = STATE(10363),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [8793] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [8794] = {
    [sym_string] = STATE(8794),
    [aux_sym_chained_string_repeat1] = STATE(8794),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [8795] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10364),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_assignment] = STATE(10364),
    [sym_operator_assignment] = STATE(10364),
    [sym_conditional] = STATE(10364),
    [sym_range] = STATE(10364),
    [sym_binary] = STATE(10364),
    [sym_unary] = STATE(10364),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8796] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6279),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1305),
    [sym_scope_resolution] = STATE(1301),
    [sym_call] = STATE(1301),
    [sym_method_call] = STATE(1305),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(6279),
    [sym_operator_assignment] = STATE(6279),
    [sym_conditional] = STATE(6279),
    [sym_range] = STATE(6279),
    [sym_binary] = STATE(6279),
    [sym_unary] = STATE(6279),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(1304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1305),
    [sym__variable] = STATE(1301),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1305),
    [sym_false] = STATE(1305),
    [sym_nil] = STATE(1305),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3437),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(5052),
    [sym__unary_minus2] = ACTIONS(2259),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(2263),
    [anon_sym_yield] = ACTIONS(2265),
    [anon_sym_break] = ACTIONS(2267),
    [anon_sym_next] = ACTIONS(2269),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(5440),
    [anon_sym_defined_QMARK] = ACTIONS(2271),
    [anon_sym_not] = ACTIONS(2273),
    [anon_sym_BANG] = ACTIONS(2277),
    [anon_sym_TILDE] = ACTIONS(2277),
    [sym_constant] = ACTIONS(2283),
    [sym_identifier] = ACTIONS(2283),
    [sym_instance_variable] = ACTIONS(2281),
    [sym_class_variable] = ACTIONS(2281),
    [sym_global_variable] = ACTIONS(2281),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(2283),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2283),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [8797] = {
    [aux_sym_exceptions_repeat1] = STATE(10365),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13557),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [8798] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8799] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8800] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8801] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8802] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8803] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8804] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13559),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8805] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8806] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8807] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8808] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8809] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8810] = {
    [aux_sym_exceptions_repeat1] = STATE(8810),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13561),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8811] = {
    [aux_sym_exceptions_repeat1] = STATE(6300),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8812] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [8813] = {
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10127),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_in] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_EQ_GT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_RBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_COLON2] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10127),
    [anon_sym_AMP_AMP] = ACTIONS(10127),
    [anon_sym_LT_LT] = ACTIONS(10127),
    [anon_sym_GT_GT] = ACTIONS(10127),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10127),
    [anon_sym_PLUS] = ACTIONS(10127),
    [anon_sym_SLASH] = ACTIONS(10127),
    [anon_sym_PERCENT] = ACTIONS(10127),
    [sym_comment] = ACTIONS(87),
  },
  [8814] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13564),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8815] = {
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10133),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_in] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_EQ_GT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_RBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_COLON2] = ACTIONS(10135),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10133),
    [anon_sym_AMP_AMP] = ACTIONS(10133),
    [anon_sym_LT_LT] = ACTIONS(10133),
    [anon_sym_GT_GT] = ACTIONS(10133),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10133),
    [anon_sym_PLUS] = ACTIONS(10133),
    [anon_sym_SLASH] = ACTIONS(10133),
    [anon_sym_PERCENT] = ACTIONS(10133),
    [sym_comment] = ACTIONS(87),
  },
  [8816] = {
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10137),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_in] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_EQ_GT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_RBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_COLON2] = ACTIONS(10139),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10137),
    [anon_sym_AMP_AMP] = ACTIONS(10137),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10137),
    [anon_sym_PLUS] = ACTIONS(10137),
    [anon_sym_SLASH] = ACTIONS(10137),
    [anon_sym_PERCENT] = ACTIONS(10137),
    [sym_comment] = ACTIONS(87),
  },
  [8817] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13566),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [8818] = {
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10143),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_in] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_EQ_GT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_RBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_COLON2] = ACTIONS(10145),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10143),
    [anon_sym_AMP_AMP] = ACTIONS(10143),
    [anon_sym_LT_LT] = ACTIONS(10143),
    [anon_sym_GT_GT] = ACTIONS(10143),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10143),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10143),
    [anon_sym_PERCENT] = ACTIONS(10143),
    [sym_comment] = ACTIONS(87),
  },
  [8819] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8820] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8821] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [8822] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10369),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10369),
    [sym_operator_assignment] = STATE(10369),
    [sym_conditional] = STATE(10369),
    [sym_range] = STATE(10369),
    [sym_binary] = STATE(10369),
    [sym_unary] = STATE(10369),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8823] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10370),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10370),
    [sym_operator_assignment] = STATE(10370),
    [sym_conditional] = STATE(10370),
    [sym_range] = STATE(10370),
    [sym_binary] = STATE(10370),
    [sym_unary] = STATE(10370),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8824] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10371),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10371),
    [sym_operator_assignment] = STATE(10371),
    [sym_conditional] = STATE(10371),
    [sym_range] = STATE(10371),
    [sym_binary] = STATE(10371),
    [sym_unary] = STATE(10371),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8825] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10372),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10372),
    [sym_operator_assignment] = STATE(10372),
    [sym_conditional] = STATE(10372),
    [sym_range] = STATE(10372),
    [sym_binary] = STATE(10372),
    [sym_unary] = STATE(10372),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8826] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10373),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10373),
    [sym_operator_assignment] = STATE(10373),
    [sym_conditional] = STATE(10373),
    [sym_range] = STATE(10373),
    [sym_binary] = STATE(10373),
    [sym_unary] = STATE(10373),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8827] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10374),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10374),
    [sym_operator_assignment] = STATE(10374),
    [sym_conditional] = STATE(10374),
    [sym_range] = STATE(10374),
    [sym_binary] = STATE(10374),
    [sym_unary] = STATE(10374),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8828] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10375),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10375),
    [sym_operator_assignment] = STATE(10375),
    [sym_conditional] = STATE(10375),
    [sym_range] = STATE(10375),
    [sym_binary] = STATE(10375),
    [sym_unary] = STATE(10375),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8829] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10376),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10376),
    [sym_operator_assignment] = STATE(10376),
    [sym_conditional] = STATE(10376),
    [sym_range] = STATE(10376),
    [sym_binary] = STATE(10376),
    [sym_unary] = STATE(10376),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8830] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10377),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10377),
    [sym_operator_assignment] = STATE(10377),
    [sym_conditional] = STATE(10377),
    [sym_range] = STATE(10377),
    [sym_binary] = STATE(10377),
    [sym_unary] = STATE(10377),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8831] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10378),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10378),
    [sym_operator_assignment] = STATE(10378),
    [sym_conditional] = STATE(10378),
    [sym_range] = STATE(10378),
    [sym_binary] = STATE(10378),
    [sym_unary] = STATE(10378),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8832] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10379),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10379),
    [sym_operator_assignment] = STATE(10379),
    [sym_conditional] = STATE(10379),
    [sym_range] = STATE(10379),
    [sym_binary] = STATE(10379),
    [sym_unary] = STATE(10379),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8833] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10380),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10380),
    [sym_operator_assignment] = STATE(10380),
    [sym_conditional] = STATE(10380),
    [sym_range] = STATE(10380),
    [sym_binary] = STATE(10380),
    [sym_unary] = STATE(10380),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8834] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10381),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_splat_argument] = STATE(10382),
    [sym_assignment] = STATE(10381),
    [sym_operator_assignment] = STATE(10381),
    [sym_conditional] = STATE(10381),
    [sym_range] = STATE(10381),
    [sym_binary] = STATE(10381),
    [sym_unary] = STATE(10381),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(10382),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8835] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10383),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(10383),
    [sym_operator_assignment] = STATE(10383),
    [sym_conditional] = STATE(10383),
    [sym_range] = STATE(10383),
    [sym_binary] = STATE(10383),
    [sym_unary] = STATE(10383),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8836] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_RBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [8837] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_RBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [8838] = {
    [sym_heredoc_body] = STATE(8838),
    [aux_sym_call_repeat1] = STATE(8838),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_RBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [8839] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3497),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(3497),
    [sym_operator_assignment] = STATE(3497),
    [sym_conditional] = STATE(3497),
    [sym_range] = STATE(3497),
    [sym_binary] = STATE(3497),
    [sym_unary] = STATE(3497),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3500),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5534),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(2371),
    [sym__identifier_hash_key2] = ACTIONS(5538),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11937),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(5540),
    [sym_identifier] = ACTIONS(5540),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8840] = {
    [sym_heredoc_body] = STATE(8838),
    [aux_sym_call_repeat1] = STATE(8838),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_RBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [8841] = {
    [aux_sym_argument_list_repeat1] = STATE(8841),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13568),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [8842] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10384),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_assignment] = STATE(10384),
    [sym_operator_assignment] = STATE(10384),
    [sym_conditional] = STATE(10384),
    [sym_range] = STATE(10384),
    [sym_binary] = STATE(10384),
    [sym_unary] = STATE(10384),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8843] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_RBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [8844] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [8845] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_RBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [8846] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10385),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10385),
    [sym_operator_assignment] = STATE(10385),
    [sym_conditional] = STATE(10385),
    [sym_range] = STATE(10385),
    [sym_binary] = STATE(10385),
    [sym_unary] = STATE(10385),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8847] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10386),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10386),
    [sym_operator_assignment] = STATE(10386),
    [sym_conditional] = STATE(10386),
    [sym_range] = STATE(10386),
    [sym_binary] = STATE(10386),
    [sym_unary] = STATE(10386),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8848] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10387),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10387),
    [sym_operator_assignment] = STATE(10387),
    [sym_conditional] = STATE(10387),
    [sym_range] = STATE(10387),
    [sym_binary] = STATE(10387),
    [sym_unary] = STATE(10387),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8849] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10388),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10388),
    [sym_operator_assignment] = STATE(10388),
    [sym_conditional] = STATE(10388),
    [sym_range] = STATE(10388),
    [sym_binary] = STATE(10388),
    [sym_unary] = STATE(10388),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8850] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10389),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10389),
    [sym_operator_assignment] = STATE(10389),
    [sym_conditional] = STATE(10389),
    [sym_range] = STATE(10389),
    [sym_binary] = STATE(10389),
    [sym_unary] = STATE(10389),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8851] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10390),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10390),
    [sym_operator_assignment] = STATE(10390),
    [sym_conditional] = STATE(10390),
    [sym_range] = STATE(10390),
    [sym_binary] = STATE(10390),
    [sym_unary] = STATE(10390),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8852] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10391),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10391),
    [sym_operator_assignment] = STATE(10391),
    [sym_conditional] = STATE(10391),
    [sym_range] = STATE(10391),
    [sym_binary] = STATE(10391),
    [sym_unary] = STATE(10391),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8853] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10392),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10392),
    [sym_operator_assignment] = STATE(10392),
    [sym_conditional] = STATE(10392),
    [sym_range] = STATE(10392),
    [sym_binary] = STATE(10392),
    [sym_unary] = STATE(10392),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8854] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10393),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10393),
    [sym_operator_assignment] = STATE(10393),
    [sym_conditional] = STATE(10393),
    [sym_range] = STATE(10393),
    [sym_binary] = STATE(10393),
    [sym_unary] = STATE(10393),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8855] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10394),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10394),
    [sym_operator_assignment] = STATE(10394),
    [sym_conditional] = STATE(10394),
    [sym_range] = STATE(10394),
    [sym_binary] = STATE(10394),
    [sym_unary] = STATE(10394),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8856] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10395),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10395),
    [sym_operator_assignment] = STATE(10395),
    [sym_conditional] = STATE(10395),
    [sym_range] = STATE(10395),
    [sym_binary] = STATE(10395),
    [sym_unary] = STATE(10395),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8857] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10396),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10396),
    [sym_operator_assignment] = STATE(10396),
    [sym_conditional] = STATE(10396),
    [sym_range] = STATE(10396),
    [sym_binary] = STATE(10396),
    [sym_unary] = STATE(10396),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8858] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_splat_argument] = STATE(10398),
    [sym_assignment] = STATE(10397),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(10398),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8859] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10399),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(10399),
    [sym_operator_assignment] = STATE(10399),
    [sym_conditional] = STATE(10399),
    [sym_range] = STATE(10399),
    [sym_binary] = STATE(10399),
    [sym_unary] = STATE(10399),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [8860] = {
    [sym_string] = STATE(10400),
    [aux_sym_chained_string_repeat1] = STATE(10400),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [8861] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_RBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [8862] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_RBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [8863] = {
    [sym_heredoc_body] = STATE(8863),
    [aux_sym_call_repeat1] = STATE(8863),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_RBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [8864] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3520),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(3520),
    [sym_operator_assignment] = STATE(3520),
    [sym_conditional] = STATE(3520),
    [sym_range] = STATE(3520),
    [sym_binary] = STATE(3520),
    [sym_unary] = STATE(3520),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3523),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5574),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(2451),
    [sym__identifier_hash_key2] = ACTIONS(5578),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(11975),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(5580),
    [sym_identifier] = ACTIONS(5580),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8865] = {
    [sym_heredoc_body] = STATE(8863),
    [aux_sym_call_repeat1] = STATE(8863),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_RBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [8866] = {
    [aux_sym_argument_list_repeat1] = STATE(8866),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13571),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_RBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [8867] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [8868] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(6362),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(1342),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(1342),
    [sym_splat_argument] = STATE(8905),
    [sym_assignment] = STATE(6362),
    [sym_operator_assignment] = STATE(6362),
    [sym_conditional] = STATE(6362),
    [sym_range] = STATE(6362),
    [sym_binary] = STATE(6362),
    [sym_unary] = STATE(6362),
    [sym__arg_or_splat_arg] = STATE(8905),
    [sym_left_assignment_list] = STATE(1341),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1342),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(1342),
    [sym_false] = STATE(1342),
    [sym_nil] = STATE(1342),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(9391),
    [sym__unary_minus2] = ACTIONS(2327),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(2337),
    [anon_sym_defined_QMARK] = ACTIONS(2339),
    [anon_sym_not] = ACTIONS(2341),
    [anon_sym_BANG] = ACTIONS(2343),
    [anon_sym_TILDE] = ACTIONS(2343),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8869] = {
    [aux_sym_exceptions_repeat1] = STATE(10401),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(13574),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8870] = {
    [sym__method_rest] = STATE(10402),
    [sym_operator] = STATE(1354),
    [sym__method_name] = STATE(1354),
    [sym_setter] = STATE(1354),
    [sym_symbol] = STATE(1354),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9397),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9397),
    [sym_class_variable] = ACTIONS(9397),
    [sym_global_variable] = ACTIONS(9397),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [8871] = {
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10896),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_in] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_EQ_GT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_RBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_COLON2] = ACTIONS(10898),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10896),
    [anon_sym_AMP_AMP] = ACTIONS(10896),
    [anon_sym_LT_LT] = ACTIONS(10896),
    [anon_sym_GT_GT] = ACTIONS(10896),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10896),
    [anon_sym_SLASH] = ACTIONS(10896),
    [anon_sym_PERCENT] = ACTIONS(10896),
    [sym_comment] = ACTIONS(87),
  },
  [8872] = {
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10900),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_in] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_EQ_GT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_RBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_COLON2] = ACTIONS(10902),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10900),
    [anon_sym_AMP_AMP] = ACTIONS(10900),
    [anon_sym_LT_LT] = ACTIONS(10900),
    [anon_sym_GT_GT] = ACTIONS(10900),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10900),
    [anon_sym_PLUS] = ACTIONS(10900),
    [anon_sym_SLASH] = ACTIONS(10900),
    [anon_sym_PERCENT] = ACTIONS(10900),
    [sym_comment] = ACTIONS(87),
  },
  [8873] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10403),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_assignment] = STATE(10403),
    [sym_operator_assignment] = STATE(10403),
    [sym_conditional] = STATE(10403),
    [sym_range] = STATE(10403),
    [sym_binary] = STATE(10403),
    [sym_unary] = STATE(10403),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8874] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6392),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1378),
    [sym_scope_resolution] = STATE(361),
    [sym_call] = STATE(361),
    [sym_method_call] = STATE(1378),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(6392),
    [sym_operator_assignment] = STATE(6392),
    [sym_conditional] = STATE(6392),
    [sym_range] = STATE(6392),
    [sym_binary] = STATE(6392),
    [sym_unary] = STATE(6392),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(1377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1378),
    [sym__variable] = STATE(361),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1378),
    [sym_false] = STATE(1378),
    [sym_nil] = STATE(1378),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(1346),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(2369),
    [sym__unary_minus2] = ACTIONS(2371),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(615),
    [anon_sym_yield] = ACTIONS(617),
    [anon_sym_break] = ACTIONS(619),
    [anon_sym_next] = ACTIONS(621),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(5602),
    [anon_sym_defined_QMARK] = ACTIONS(2375),
    [anon_sym_not] = ACTIONS(2377),
    [anon_sym_BANG] = ACTIONS(2381),
    [anon_sym_TILDE] = ACTIONS(2381),
    [sym_constant] = ACTIONS(655),
    [sym_identifier] = ACTIONS(655),
    [sym_instance_variable] = ACTIONS(651),
    [sym_class_variable] = ACTIONS(651),
    [sym_global_variable] = ACTIONS(651),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(655),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(655),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8875] = {
    [aux_sym_exceptions_repeat1] = STATE(10404),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13576),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [8876] = {
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11061),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_in] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_EQ_GT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_RBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_COLON2] = ACTIONS(11063),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11061),
    [anon_sym_AMP_AMP] = ACTIONS(11061),
    [anon_sym_LT_LT] = ACTIONS(11061),
    [anon_sym_GT_GT] = ACTIONS(11061),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11061),
    [anon_sym_PLUS] = ACTIONS(11061),
    [anon_sym_SLASH] = ACTIONS(11061),
    [anon_sym_PERCENT] = ACTIONS(11061),
    [sym_comment] = ACTIONS(87),
  },
  [8877] = {
    [anon_sym_end] = ACTIONS(13578),
    [sym_comment] = ACTIONS(87),
  },
  [8878] = {
    [sym_elsif] = STATE(10406),
    [sym_else] = STATE(10406),
    [sym__if_tail] = STATE(10406),
    [anon_sym_end] = ACTIONS(13578),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [8879] = {
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11236),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_in] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_EQ_GT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_RBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_COLON2] = ACTIONS(11238),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11236),
    [anon_sym_AMP_AMP] = ACTIONS(11236),
    [anon_sym_LT_LT] = ACTIONS(11236),
    [anon_sym_GT_GT] = ACTIONS(11236),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11236),
    [anon_sym_PLUS] = ACTIONS(11236),
    [anon_sym_SLASH] = ACTIONS(11236),
    [anon_sym_PERCENT] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [8880] = {
    [anon_sym_end] = ACTIONS(13580),
    [sym_comment] = ACTIONS(87),
  },
  [8881] = {
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11333),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_in] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_EQ_GT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_RBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11333),
    [anon_sym_AMP_AMP] = ACTIONS(11333),
    [anon_sym_LT_LT] = ACTIONS(11333),
    [anon_sym_GT_GT] = ACTIONS(11333),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11333),
    [anon_sym_PLUS] = ACTIONS(11333),
    [anon_sym_SLASH] = ACTIONS(11333),
    [anon_sym_PERCENT] = ACTIONS(11333),
    [sym_comment] = ACTIONS(87),
  },
  [8882] = {
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11342),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_in] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_EQ_GT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_RBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_COLON2] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11342),
    [anon_sym_AMP_AMP] = ACTIONS(11342),
    [anon_sym_LT_LT] = ACTIONS(11342),
    [anon_sym_GT_GT] = ACTIONS(11342),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11342),
    [anon_sym_PLUS] = ACTIONS(11342),
    [anon_sym_SLASH] = ACTIONS(11342),
    [anon_sym_PERCENT] = ACTIONS(11342),
    [sym_comment] = ACTIONS(87),
  },
  [8883] = {
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_in] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_EQ_GT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_RBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_COLON2] = ACTIONS(11395),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [8884] = {
    [anon_sym_end] = ACTIONS(13582),
    [sym_comment] = ACTIONS(87),
  },
  [8885] = {
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_in] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_EQ_GT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_RBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_COLON2] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [8886] = {
    [anon_sym_end] = ACTIONS(13584),
    [sym_comment] = ACTIONS(87),
  },
  [8887] = {
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11878),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_in] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_EQ_GT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_RBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_COLON2] = ACTIONS(11880),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11878),
    [anon_sym_AMP_AMP] = ACTIONS(11878),
    [anon_sym_LT_LT] = ACTIONS(11878),
    [anon_sym_GT_GT] = ACTIONS(11878),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11878),
    [anon_sym_PLUS] = ACTIONS(11878),
    [anon_sym_SLASH] = ACTIONS(11878),
    [anon_sym_PERCENT] = ACTIONS(11878),
    [sym_comment] = ACTIONS(87),
  },
  [8888] = {
    [anon_sym_end] = ACTIONS(13586),
    [sym_comment] = ACTIONS(87),
  },
  [8889] = {
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_in] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_RBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_COLON2] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [8890] = {
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12096),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12098),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12096),
    [anon_sym_AMP_AMP] = ACTIONS(12096),
    [anon_sym_LT_LT] = ACTIONS(12096),
    [anon_sym_GT_GT] = ACTIONS(12096),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12096),
    [anon_sym_PLUS] = ACTIONS(12096),
    [anon_sym_SLASH] = ACTIONS(12096),
    [anon_sym_PERCENT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [8891] = {
    [anon_sym_end] = ACTIONS(13588),
    [sym_comment] = ACTIONS(87),
  },
  [8892] = {
    [sym__statements] = STATE(10412),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13590),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8893] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(2405),
    [sym__binary_star2] = ACTIONS(2407),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(2409),
    [anon_sym_STAR_STAR] = ACTIONS(2411),
    [anon_sym_AMP] = ACTIONS(2413),
    [anon_sym_LT] = ACTIONS(2415),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(2419),
    [anon_sym_DOT_DOT] = ACTIONS(2421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2423),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2427),
    [anon_sym_AMP_AMP] = ACTIONS(2427),
    [anon_sym_LT_LT] = ACTIONS(2429),
    [anon_sym_GT_GT] = ACTIONS(2429),
    [anon_sym_EQ_EQ] = ACTIONS(2431),
    [anon_sym_BANG_EQ] = ACTIONS(2427),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2427),
    [anon_sym_LT_EQ_GT] = ACTIONS(2427),
    [anon_sym_EQ_TILDE] = ACTIONS(2427),
    [anon_sym_BANG_TILDE] = ACTIONS(2427),
    [anon_sym_LT_EQ] = ACTIONS(2415),
    [anon_sym_GT] = ACTIONS(2415),
    [anon_sym_GT_EQ] = ACTIONS(2433),
    [anon_sym_CARET] = ACTIONS(2435),
    [anon_sym_PLUS] = ACTIONS(2437),
    [anon_sym_SLASH] = ACTIONS(2411),
    [anon_sym_PERCENT] = ACTIONS(2411),
    [sym_comment] = ACTIONS(87),
  },
  [8894] = {
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_rescue] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_in] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_EQ_GT] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [8895] = {
    [anon_sym_RPAREN] = ACTIONS(13592),
    [sym_comment] = ACTIONS(87),
  },
  [8896] = {
    [sym__heredoc_body_start2] = ACTIONS(12249),
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [anon_sym_LBRACE] = ACTIONS(12249),
    [anon_sym_RBRACE] = ACTIONS(12249),
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_if] = ACTIONS(12249),
    [anon_sym_unless] = ACTIONS(12249),
    [anon_sym_while] = ACTIONS(12249),
    [anon_sym_until] = ACTIONS(12249),
    [anon_sym_rescue] = ACTIONS(12249),
    [anon_sym_in] = ACTIONS(12249),
    [anon_sym_do] = ACTIONS(12249),
    [anon_sym_EQ_GT] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_RBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_COLON2] = ACTIONS(12251),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [8897] = {
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_in] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_EQ_GT] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_RBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_COLON2] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [8898] = {
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_EQ_GT] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12098),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [8899] = {
    [anon_sym_end] = ACTIONS(13594),
    [sym_comment] = ACTIONS(87),
  },
  [8900] = {
    [sym__statements] = STATE(10415),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13596),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [8901] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10416),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_assignment] = STATE(10416),
    [sym_operator_assignment] = STATE(10416),
    [sym_conditional] = STATE(10416),
    [sym_range] = STATE(10416),
    [sym_binary] = STATE(10416),
    [sym_unary] = STATE(10416),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8902] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6451),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1445),
    [sym_scope_resolution] = STATE(1439),
    [sym_call] = STATE(1439),
    [sym_method_call] = STATE(1445),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(6451),
    [sym_operator_assignment] = STATE(6451),
    [sym_conditional] = STATE(6451),
    [sym_range] = STATE(6451),
    [sym_binary] = STATE(6451),
    [sym_unary] = STATE(6451),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(1444),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1445),
    [sym__variable] = STATE(1439),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1445),
    [sym_false] = STATE(1445),
    [sym_nil] = STATE(1445),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3610),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(2449),
    [sym__unary_minus2] = ACTIONS(2451),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2457),
    [anon_sym_yield] = ACTIONS(2459),
    [anon_sym_break] = ACTIONS(2461),
    [anon_sym_next] = ACTIONS(2463),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(5686),
    [anon_sym_defined_QMARK] = ACTIONS(2467),
    [anon_sym_not] = ACTIONS(2469),
    [anon_sym_BANG] = ACTIONS(2473),
    [anon_sym_TILDE] = ACTIONS(2473),
    [sym_constant] = ACTIONS(2479),
    [sym_identifier] = ACTIONS(2479),
    [sym_instance_variable] = ACTIONS(2477),
    [sym_class_variable] = ACTIONS(2477),
    [sym_global_variable] = ACTIONS(2477),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2479),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2479),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8903] = {
    [aux_sym_exceptions_repeat1] = STATE(10417),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13598),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [8904] = {
    [sym__simple_symbol2] = ACTIONS(6739),
    [sym__string_start2] = ACTIONS(6739),
    [sym__symbol_start2] = ACTIONS(6739),
    [sym__subshell_start2] = ACTIONS(6739),
    [sym__regex_start2] = ACTIONS(6739),
    [sym__string_array_start2] = ACTIONS(6739),
    [sym__symbol_array_start2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym_heredoc_beginning2] = ACTIONS(6739),
    [sym__block_ampersand2] = ACTIONS(6739),
    [sym__splat_star2] = ACTIONS(6739),
    [sym__unary_minus2] = ACTIONS(6739),
    [sym__identifier_hash_key2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_def] = ACTIONS(8705),
    [anon_sym_LPAREN] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_COLON_COLON] = ACTIONS(6739),
    [anon_sym_STAR] = ACTIONS(8705),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_class] = ACTIONS(8705),
    [anon_sym_module] = ACTIONS(8705),
    [anon_sym_return] = ACTIONS(8705),
    [anon_sym_yield] = ACTIONS(8705),
    [anon_sym_break] = ACTIONS(8705),
    [anon_sym_next] = ACTIONS(8705),
    [sym_redo] = ACTIONS(8705),
    [sym_retry] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(8705),
    [anon_sym_unless] = ACTIONS(8705),
    [anon_sym_while] = ACTIONS(8705),
    [anon_sym_until] = ACTIONS(8705),
    [anon_sym_for] = ACTIONS(8705),
    [anon_sym_case] = ACTIONS(8705),
    [anon_sym_begin] = ACTIONS(8705),
    [anon_sym_RBRACK] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_defined_QMARK] = ACTIONS(6739),
    [anon_sym_not] = ACTIONS(8705),
    [anon_sym_BANG] = ACTIONS(6739),
    [anon_sym_TILDE] = ACTIONS(6739),
    [sym_constant] = ACTIONS(8705),
    [sym_identifier] = ACTIONS(8705),
    [sym_instance_variable] = ACTIONS(6739),
    [sym_class_variable] = ACTIONS(6739),
    [sym_global_variable] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(8705),
    [sym_float] = ACTIONS(8705),
    [sym_complex] = ACTIONS(6739),
    [sym_super] = ACTIONS(8705),
    [anon_sym_true] = ACTIONS(8705),
    [anon_sym_TRUE] = ACTIONS(8705),
    [anon_sym_false] = ACTIONS(8705),
    [anon_sym_FALSE] = ACTIONS(8705),
    [sym_self] = ACTIONS(8705),
    [anon_sym_nil] = ACTIONS(8705),
    [anon_sym_NIL] = ACTIONS(8705),
    [sym_character] = ACTIONS(6739),
    [anon_sym_LBRACK2] = ACTIONS(6739),
    [anon_sym_DASH_GT] = ACTIONS(6739),
  },
  [8905] = {
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8906] = {
    [aux_sym_exceptions_repeat1] = STATE(8906),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13600),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [8907] = {
    [aux_sym_block_parameters_repeat1] = STATE(10419),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(13603),
    [sym_comment] = ACTIONS(87),
  },
  [8908] = {
    [sym_identifier] = ACTIONS(13605),
    [sym_comment] = ACTIONS(87),
  },
  [8909] = {
    [sym__simple_symbol2] = ACTIONS(13607),
    [sym__string_start2] = ACTIONS(13607),
    [sym__symbol_start2] = ACTIONS(13607),
    [sym__subshell_start2] = ACTIONS(13607),
    [sym__regex_start2] = ACTIONS(13607),
    [sym__string_array_start2] = ACTIONS(13607),
    [sym__symbol_array_start2] = ACTIONS(13607),
    [sym_heredoc_beginning2] = ACTIONS(13607),
    [sym__unary_minus2] = ACTIONS(13607),
    [anon_sym_BEGIN] = ACTIONS(13609),
    [anon_sym_LBRACE] = ACTIONS(13607),
    [anon_sym_RBRACE] = ACTIONS(13607),
    [anon_sym_END] = ACTIONS(13609),
    [anon_sym_def] = ACTIONS(13609),
    [anon_sym_LPAREN] = ACTIONS(13607),
    [anon_sym_COLON_COLON] = ACTIONS(13607),
    [anon_sym_SEMI] = ACTIONS(13607),
    [anon_sym_STAR] = ACTIONS(13607),
    [anon_sym_class] = ACTIONS(13609),
    [anon_sym_module] = ACTIONS(13609),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13609),
    [anon_sym_break] = ACTIONS(13609),
    [anon_sym_next] = ACTIONS(13609),
    [sym_redo] = ACTIONS(13609),
    [sym_retry] = ACTIONS(13609),
    [anon_sym_if] = ACTIONS(13609),
    [anon_sym_unless] = ACTIONS(13609),
    [anon_sym_while] = ACTIONS(13609),
    [anon_sym_until] = ACTIONS(13609),
    [anon_sym_for] = ACTIONS(13609),
    [anon_sym_case] = ACTIONS(13609),
    [anon_sym_begin] = ACTIONS(13609),
    [anon_sym_PLUS] = ACTIONS(13609),
    [anon_sym_defined_QMARK] = ACTIONS(13607),
    [anon_sym_not] = ACTIONS(13609),
    [anon_sym_BANG] = ACTIONS(13607),
    [anon_sym_TILDE] = ACTIONS(13607),
    [sym_constant] = ACTIONS(13609),
    [sym_identifier] = ACTIONS(13609),
    [sym_instance_variable] = ACTIONS(13607),
    [sym_class_variable] = ACTIONS(13607),
    [sym_global_variable] = ACTIONS(13607),
    [anon_sym_undef] = ACTIONS(13609),
    [anon_sym_alias] = ACTIONS(13609),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13609),
    [sym_float] = ACTIONS(13609),
    [sym_complex] = ACTIONS(13607),
    [sym_super] = ACTIONS(13609),
    [anon_sym_true] = ACTIONS(13609),
    [anon_sym_TRUE] = ACTIONS(13609),
    [anon_sym_false] = ACTIONS(13609),
    [anon_sym_FALSE] = ACTIONS(13609),
    [sym_self] = ACTIONS(13609),
    [anon_sym_nil] = ACTIONS(13609),
    [anon_sym_NIL] = ACTIONS(13609),
    [sym_character] = ACTIONS(13607),
    [anon_sym_LBRACK2] = ACTIONS(13607),
    [anon_sym_DASH_GT] = ACTIONS(13607),
  },
  [8910] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(13603),
    [sym_comment] = ACTIONS(87),
  },
  [8911] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10422),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(10422),
    [sym_operator_assignment] = STATE(10422),
    [sym_conditional] = STATE(10422),
    [sym_range] = STATE(10422),
    [sym_binary] = STATE(10422),
    [sym_unary] = STATE(10422),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8912] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(582),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8913] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(588),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8914] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(589),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8915] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(590),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8916] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10443),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(10443),
    [sym_operator_assignment] = STATE(10443),
    [sym_conditional] = STATE(10443),
    [sym_range] = STATE(10443),
    [sym_binary] = STATE(10443),
    [sym_unary] = STATE(10443),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8917] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10444),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(10444),
    [sym_operator_assignment] = STATE(10444),
    [sym_conditional] = STATE(10444),
    [sym_range] = STATE(10444),
    [sym_binary] = STATE(10444),
    [sym_unary] = STATE(10444),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8918] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(606),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(606),
    [sym_operator_assignment] = STATE(606),
    [sym_conditional] = STATE(606),
    [sym_range] = STATE(606),
    [sym_binary] = STATE(606),
    [sym_unary] = STATE(606),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8919] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(9520),
    [anon_sym_PIPE] = ACTIONS(13645),
    [anon_sym_SEMI] = ACTIONS(9520),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(13659),
    [anon_sym_or] = ACTIONS(13659),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [8920] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(1742),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_do_block] = STATE(1745),
    [sym_block] = STATE(1745),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2923),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [8921] = {
    [anon_sym_EQ] = ACTIONS(13703),
    [sym_comment] = ACTIONS(87),
  },
  [8922] = {
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(13705),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(13707),
    [anon_sym_DASH_EQ] = ACTIONS(13707),
    [anon_sym_STAR_EQ] = ACTIONS(13707),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13707),
    [anon_sym_SLASH_EQ] = ACTIONS(13707),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13707),
    [anon_sym_PIPE_EQ] = ACTIONS(13707),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13707),
    [anon_sym_AMP_EQ] = ACTIONS(13707),
    [anon_sym_PERCENT_EQ] = ACTIONS(13707),
    [anon_sym_GT_GT_EQ] = ACTIONS(13707),
    [anon_sym_LT_LT_EQ] = ACTIONS(13707),
    [anon_sym_CARET_EQ] = ACTIONS(13707),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [8923] = {
    [sym_string] = STATE(10479),
    [aux_sym_chained_string_repeat1] = STATE(10479),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [8924] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(9558),
    [anon_sym_PIPE] = ACTIONS(13709),
    [anon_sym_SEMI] = ACTIONS(9558),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(13659),
    [anon_sym_or] = ACTIONS(13659),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [8925] = {
    [sym_identifier] = ACTIONS(13711),
    [sym_comment] = ACTIONS(87),
  },
  [8926] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(13603),
    [anon_sym_SEMI] = ACTIONS(13713),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [8927] = {
    [aux_sym_method_parameters_repeat1] = STATE(8927),
    [anon_sym_COMMA] = ACTIONS(13715),
    [anon_sym_PIPE] = ACTIONS(12081),
    [anon_sym_SEMI] = ACTIONS(12081),
    [sym_comment] = ACTIONS(87),
  },
  [8928] = {
    [anon_sym_RPAREN] = ACTIONS(13718),
    [anon_sym_COMMA] = ACTIONS(13718),
    [anon_sym_PIPE] = ACTIONS(13718),
    [anon_sym_SEMI] = ACTIONS(13718),
    [sym_comment] = ACTIONS(87),
  },
  [8929] = {
    [aux_sym_block_parameters_repeat1] = STATE(10484),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(13720),
    [sym_comment] = ACTIONS(87),
  },
  [8930] = {
    [sym__line_break2] = ACTIONS(13607),
    [sym__simple_symbol2] = ACTIONS(13607),
    [sym__string_start2] = ACTIONS(13607),
    [sym__symbol_start2] = ACTIONS(13607),
    [sym__subshell_start2] = ACTIONS(13607),
    [sym__regex_start2] = ACTIONS(13607),
    [sym__string_array_start2] = ACTIONS(13607),
    [sym__symbol_array_start2] = ACTIONS(13607),
    [sym__heredoc_body_start2] = ACTIONS(13607),
    [sym_heredoc_beginning2] = ACTIONS(13607),
    [sym__unary_minus2] = ACTIONS(13607),
    [anon_sym_BEGIN] = ACTIONS(13609),
    [anon_sym_LBRACE] = ACTIONS(13607),
    [anon_sym_END] = ACTIONS(13609),
    [anon_sym_def] = ACTIONS(13609),
    [anon_sym_LPAREN] = ACTIONS(13607),
    [anon_sym_COLON_COLON] = ACTIONS(13607),
    [anon_sym_SEMI] = ACTIONS(13607),
    [anon_sym_STAR] = ACTIONS(13607),
    [anon_sym_class] = ACTIONS(13609),
    [anon_sym_module] = ACTIONS(13609),
    [anon_sym_end] = ACTIONS(13609),
    [anon_sym_return] = ACTIONS(13609),
    [anon_sym_yield] = ACTIONS(13609),
    [anon_sym_break] = ACTIONS(13609),
    [anon_sym_next] = ACTIONS(13609),
    [sym_redo] = ACTIONS(13609),
    [sym_retry] = ACTIONS(13609),
    [anon_sym_if] = ACTIONS(13609),
    [anon_sym_unless] = ACTIONS(13609),
    [anon_sym_while] = ACTIONS(13609),
    [anon_sym_until] = ACTIONS(13609),
    [anon_sym_for] = ACTIONS(13609),
    [anon_sym_case] = ACTIONS(13609),
    [anon_sym_begin] = ACTIONS(13609),
    [anon_sym_PLUS] = ACTIONS(13609),
    [anon_sym_defined_QMARK] = ACTIONS(13607),
    [anon_sym_not] = ACTIONS(13609),
    [anon_sym_BANG] = ACTIONS(13607),
    [anon_sym_TILDE] = ACTIONS(13607),
    [sym_constant] = ACTIONS(13609),
    [sym_identifier] = ACTIONS(13609),
    [sym_instance_variable] = ACTIONS(13607),
    [sym_class_variable] = ACTIONS(13607),
    [sym_global_variable] = ACTIONS(13607),
    [anon_sym_undef] = ACTIONS(13609),
    [anon_sym_alias] = ACTIONS(13609),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13609),
    [sym_float] = ACTIONS(13609),
    [sym_complex] = ACTIONS(13607),
    [sym_super] = ACTIONS(13609),
    [anon_sym_true] = ACTIONS(13609),
    [anon_sym_TRUE] = ACTIONS(13609),
    [anon_sym_false] = ACTIONS(13609),
    [anon_sym_FALSE] = ACTIONS(13609),
    [sym_self] = ACTIONS(13609),
    [anon_sym_nil] = ACTIONS(13609),
    [anon_sym_NIL] = ACTIONS(13609),
    [sym_character] = ACTIONS(13607),
    [anon_sym_LBRACK2] = ACTIONS(13607),
    [anon_sym_DASH_GT] = ACTIONS(13607),
  },
  [8931] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(13720),
    [sym_comment] = ACTIONS(87),
  },
  [8932] = {
    [sym_identifier] = ACTIONS(13722),
    [sym_comment] = ACTIONS(87),
  },
  [8933] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_PIPE] = ACTIONS(13720),
    [anon_sym_SEMI] = ACTIONS(13724),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [8934] = {
    [sym__line_break2] = ACTIONS(13726),
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [ts_builtin_sym_end] = ACTIONS(13726),
    [anon_sym___END__] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_end] = ACTIONS(13726),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_when] = ACTIONS(13726),
    [anon_sym_elsif] = ACTIONS(13726),
    [anon_sym_else] = ACTIONS(13726),
    [anon_sym_then] = ACTIONS(13726),
    [anon_sym_ensure] = ACTIONS(13726),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13726),
    [anon_sym_AMP_AMP] = ACTIONS(13726),
    [anon_sym_LT_LT] = ACTIONS(13726),
    [anon_sym_GT_GT] = ACTIONS(13726),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13726),
    [anon_sym_PLUS] = ACTIONS(13726),
    [anon_sym_SLASH] = ACTIONS(13726),
    [anon_sym_PERCENT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [8935] = {
    [anon_sym_end] = ACTIONS(13730),
    [sym_comment] = ACTIONS(87),
  },
  [8936] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8937] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8938] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8939] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8940] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8941] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8942] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13732),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8943] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8944] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8945] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8946] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8947] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8948] = {
    [sym__heredoc_body_start2] = ACTIONS(997),
    [sym__binary_minus2] = ACTIONS(5750),
    [sym__binary_star2] = ACTIONS(5750),
    [anon_sym_LBRACE] = ACTIONS(5750),
    [anon_sym_DOT] = ACTIONS(5752),
    [anon_sym_COMMA] = ACTIONS(5750),
    [anon_sym_PIPE] = ACTIONS(5752),
    [anon_sym_STAR_STAR] = ACTIONS(5752),
    [anon_sym_AMP] = ACTIONS(5752),
    [anon_sym_EQ] = ACTIONS(5752),
    [anon_sym_LT] = ACTIONS(5752),
    [anon_sym_do] = ACTIONS(5750),
    [anon_sym_EQ_GT] = ACTIONS(997),
    [anon_sym_LBRACK] = ACTIONS(5750),
    [anon_sym_COLON_COLON2] = ACTIONS(5750),
    [anon_sym_AMP_DOT] = ACTIONS(5750),
    [anon_sym_PLUS_EQ] = ACTIONS(5750),
    [anon_sym_DASH_EQ] = ACTIONS(5750),
    [anon_sym_STAR_EQ] = ACTIONS(5750),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5750),
    [anon_sym_SLASH_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_PIPE_EQ] = ACTIONS(5750),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5750),
    [anon_sym_AMP_EQ] = ACTIONS(5750),
    [anon_sym_PERCENT_EQ] = ACTIONS(5750),
    [anon_sym_GT_GT_EQ] = ACTIONS(5750),
    [anon_sym_LT_LT_EQ] = ACTIONS(5750),
    [anon_sym_CARET_EQ] = ACTIONS(5750),
    [anon_sym_QMARK] = ACTIONS(5750),
    [anon_sym_DOT_DOT] = ACTIONS(5752),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5750),
    [anon_sym_and] = ACTIONS(5750),
    [anon_sym_or] = ACTIONS(5750),
    [anon_sym_PIPE_PIPE] = ACTIONS(5752),
    [anon_sym_AMP_AMP] = ACTIONS(5752),
    [anon_sym_LT_LT] = ACTIONS(5752),
    [anon_sym_GT_GT] = ACTIONS(5752),
    [anon_sym_EQ_EQ] = ACTIONS(5752),
    [anon_sym_BANG_EQ] = ACTIONS(5750),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5750),
    [anon_sym_LT_EQ_GT] = ACTIONS(5750),
    [anon_sym_EQ_TILDE] = ACTIONS(5750),
    [anon_sym_BANG_TILDE] = ACTIONS(5750),
    [anon_sym_LT_EQ] = ACTIONS(5752),
    [anon_sym_GT] = ACTIONS(5752),
    [anon_sym_GT_EQ] = ACTIONS(5750),
    [anon_sym_CARET] = ACTIONS(5752),
    [anon_sym_PLUS] = ACTIONS(5752),
    [anon_sym_SLASH] = ACTIONS(5752),
    [anon_sym_PERCENT] = ACTIONS(5752),
    [sym_comment] = ACTIONS(87),
  },
  [8949] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10489),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(10489),
    [sym_operator_assignment] = STATE(10489),
    [sym_conditional] = STATE(10489),
    [sym_range] = STATE(10489),
    [sym_binary] = STATE(10489),
    [sym_unary] = STATE(10489),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8950] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8951] = {
    [aux_sym_exceptions_repeat1] = STATE(10491),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [8952] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [8953] = {
    [sym_string] = STATE(8953),
    [aux_sym_chained_string_repeat1] = STATE(8953),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [8954] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [8955] = {
    [sym_heredoc_body] = STATE(10492),
    [aux_sym_call_repeat1] = STATE(10492),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8956] = {
    [sym_heredoc_body] = STATE(10492),
    [aux_sym_call_repeat1] = STATE(10492),
    [aux_sym_argument_list_repeat1] = STATE(10493),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(9647),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_COLON2] = ACTIONS(1707),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [8957] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [8958] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [8959] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10494),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10494),
    [sym_operator_assignment] = STATE(10494),
    [sym_conditional] = STATE(10494),
    [sym_range] = STATE(10494),
    [sym_binary] = STATE(10494),
    [sym_unary] = STATE(10494),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8960] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10495),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10495),
    [sym_operator_assignment] = STATE(10495),
    [sym_conditional] = STATE(10495),
    [sym_range] = STATE(10495),
    [sym_binary] = STATE(10495),
    [sym_unary] = STATE(10495),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8961] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10496),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10496),
    [sym_operator_assignment] = STATE(10496),
    [sym_conditional] = STATE(10496),
    [sym_range] = STATE(10496),
    [sym_binary] = STATE(10496),
    [sym_unary] = STATE(10496),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8962] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10497),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10497),
    [sym_operator_assignment] = STATE(10497),
    [sym_conditional] = STATE(10497),
    [sym_range] = STATE(10497),
    [sym_binary] = STATE(10497),
    [sym_unary] = STATE(10497),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8963] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10498),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10498),
    [sym_operator_assignment] = STATE(10498),
    [sym_conditional] = STATE(10498),
    [sym_range] = STATE(10498),
    [sym_binary] = STATE(10498),
    [sym_unary] = STATE(10498),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8964] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10499),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10499),
    [sym_operator_assignment] = STATE(10499),
    [sym_conditional] = STATE(10499),
    [sym_range] = STATE(10499),
    [sym_binary] = STATE(10499),
    [sym_unary] = STATE(10499),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8965] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10500),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10500),
    [sym_operator_assignment] = STATE(10500),
    [sym_conditional] = STATE(10500),
    [sym_range] = STATE(10500),
    [sym_binary] = STATE(10500),
    [sym_unary] = STATE(10500),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [8966] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10501),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10501),
    [sym_operator_assignment] = STATE(10501),
    [sym_conditional] = STATE(10501),
    [sym_range] = STATE(10501),
    [sym_binary] = STATE(10501),
    [sym_unary] = STATE(10501),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8967] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10502),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10502),
    [sym_operator_assignment] = STATE(10502),
    [sym_conditional] = STATE(10502),
    [sym_range] = STATE(10502),
    [sym_binary] = STATE(10502),
    [sym_unary] = STATE(10502),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8968] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10503),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10503),
    [sym_operator_assignment] = STATE(10503),
    [sym_conditional] = STATE(10503),
    [sym_range] = STATE(10503),
    [sym_binary] = STATE(10503),
    [sym_unary] = STATE(10503),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8969] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10504),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10504),
    [sym_operator_assignment] = STATE(10504),
    [sym_conditional] = STATE(10504),
    [sym_range] = STATE(10504),
    [sym_binary] = STATE(10504),
    [sym_unary] = STATE(10504),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8970] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10505),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10505),
    [sym_operator_assignment] = STATE(10505),
    [sym_conditional] = STATE(10505),
    [sym_range] = STATE(10505),
    [sym_binary] = STATE(10505),
    [sym_unary] = STATE(10505),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8971] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10506),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_splat_argument] = STATE(10507),
    [sym_assignment] = STATE(10506),
    [sym_operator_assignment] = STATE(10506),
    [sym_conditional] = STATE(10506),
    [sym_range] = STATE(10506),
    [sym_binary] = STATE(10506),
    [sym_unary] = STATE(10506),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(10507),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8972] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10508),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(10508),
    [sym_operator_assignment] = STATE(10508),
    [sym_conditional] = STATE(10508),
    [sym_range] = STATE(10508),
    [sym_binary] = STATE(10508),
    [sym_unary] = STATE(10508),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8973] = {
    [sym_string] = STATE(10509),
    [aux_sym_chained_string_repeat1] = STATE(10509),
    [sym__string_start2] = ACTIONS(3948),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [8974] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_STAR_STAR] = ACTIONS(841),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(841),
    [anon_sym_AMP_AMP] = ACTIONS(841),
    [anon_sym_LT_LT] = ACTIONS(841),
    [anon_sym_GT_GT] = ACTIONS(841),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(841),
    [anon_sym_PLUS] = ACTIONS(841),
    [anon_sym_SLASH] = ACTIONS(841),
    [anon_sym_PERCENT] = ACTIONS(841),
    [sym_comment] = ACTIONS(87),
  },
  [8975] = {
    [sym__string_end2] = ACTIONS(13734),
    [sym_comment] = ACTIONS(87),
  },
  [8976] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(7792),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [8977] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8978] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8979] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10511),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(10511),
    [sym_operator_assignment] = STATE(10511),
    [sym_conditional] = STATE(10511),
    [sym_range] = STATE(10511),
    [sym_binary] = STATE(10511),
    [sym_unary] = STATE(10511),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8980] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(4208),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8981] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10512),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(10512),
    [sym_operator_assignment] = STATE(10512),
    [sym_conditional] = STATE(10512),
    [sym_range] = STATE(10512),
    [sym_binary] = STATE(10512),
    [sym_unary] = STATE(10512),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8982] = {
    [sym_heredoc_body] = STATE(10513),
    [aux_sym_call_repeat1] = STATE(10513),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8983] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(10514),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13736),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [8984] = {
    [sym_heredoc_body] = STATE(10515),
    [aux_sym_call_repeat1] = STATE(10515),
    [aux_sym_argument_list_repeat1] = STATE(10516),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(12150),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [8985] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8986] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [8987] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8988] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [8989] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8990] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8991] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(7858),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [8992] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13738),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [8993] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(7862),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8994] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8995] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8996] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8997] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [8998] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(4170),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [8999] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(4206),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9000] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10518),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(10518),
    [sym_operator_assignment] = STATE(10518),
    [sym_conditional] = STATE(10518),
    [sym_range] = STATE(10518),
    [sym_binary] = STATE(10518),
    [sym_unary] = STATE(10518),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9001] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(4208),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9002] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10519),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(10519),
    [sym_operator_assignment] = STATE(10519),
    [sym_conditional] = STATE(10519),
    [sym_range] = STATE(10519),
    [sym_binary] = STATE(10519),
    [sym_unary] = STATE(10519),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9003] = {
    [sym_heredoc_body] = STATE(10520),
    [aux_sym_call_repeat1] = STATE(10520),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9004] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(10521),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13740),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9005] = {
    [sym_heredoc_body] = STATE(10522),
    [aux_sym_call_repeat1] = STATE(10522),
    [aux_sym_argument_list_repeat1] = STATE(10523),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(12158),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9006] = {
    [sym_heredoc_body] = STATE(9006),
    [aux_sym_call_repeat1] = STATE(9006),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_COLON2] = ACTIONS(7893),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9007] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3709),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(3709),
    [sym_operator_assignment] = STATE(3709),
    [sym_conditional] = STATE(3709),
    [sym_range] = STATE(3709),
    [sym_binary] = STATE(3709),
    [sym_unary] = STATE(3709),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3715),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(5866),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__identifier_hash_key2] = ACTIONS(5872),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12162),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5890),
    [sym_identifier] = ACTIONS(5890),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9008] = {
    [sym_heredoc_body] = STATE(9006),
    [aux_sym_call_repeat1] = STATE(9006),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_COLON2] = ACTIONS(7905),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9009] = {
    [aux_sym_argument_list_repeat1] = STATE(9009),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13742),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9010] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(7910),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [9011] = {
    [aux_sym_exceptions_repeat1] = STATE(10525),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9012] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(7912),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [9013] = {
    [sym_string] = STATE(9013),
    [aux_sym_chained_string_repeat1] = STATE(9013),
    [sym__string_start2] = ACTIONS(13745),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9014] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10526),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10526),
    [sym_operator_assignment] = STATE(10526),
    [sym_conditional] = STATE(10526),
    [sym_range] = STATE(10526),
    [sym_binary] = STATE(10526),
    [sym_unary] = STATE(10526),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9015] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(941),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [9016] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [9017] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(2295),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [9018] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10527),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10527),
    [sym_operator_assignment] = STATE(10527),
    [sym_conditional] = STATE(10527),
    [sym_range] = STATE(10527),
    [sym_binary] = STATE(10527),
    [sym_unary] = STATE(10527),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9019] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10528),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10528),
    [sym_operator_assignment] = STATE(10528),
    [sym_conditional] = STATE(10528),
    [sym_range] = STATE(10528),
    [sym_binary] = STATE(10528),
    [sym_unary] = STATE(10528),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9020] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10529),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10529),
    [sym_operator_assignment] = STATE(10529),
    [sym_conditional] = STATE(10529),
    [sym_range] = STATE(10529),
    [sym_binary] = STATE(10529),
    [sym_unary] = STATE(10529),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9021] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10530),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10530),
    [sym_operator_assignment] = STATE(10530),
    [sym_conditional] = STATE(10530),
    [sym_range] = STATE(10530),
    [sym_binary] = STATE(10530),
    [sym_unary] = STATE(10530),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9022] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10531),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10531),
    [sym_operator_assignment] = STATE(10531),
    [sym_conditional] = STATE(10531),
    [sym_range] = STATE(10531),
    [sym_binary] = STATE(10531),
    [sym_unary] = STATE(10531),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9023] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10532),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10532),
    [sym_operator_assignment] = STATE(10532),
    [sym_conditional] = STATE(10532),
    [sym_range] = STATE(10532),
    [sym_binary] = STATE(10532),
    [sym_unary] = STATE(10532),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9024] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10533),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10533),
    [sym_operator_assignment] = STATE(10533),
    [sym_conditional] = STATE(10533),
    [sym_range] = STATE(10533),
    [sym_binary] = STATE(10533),
    [sym_unary] = STATE(10533),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9025] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10534),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10534),
    [sym_operator_assignment] = STATE(10534),
    [sym_conditional] = STATE(10534),
    [sym_range] = STATE(10534),
    [sym_binary] = STATE(10534),
    [sym_unary] = STATE(10534),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9026] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10535),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10535),
    [sym_operator_assignment] = STATE(10535),
    [sym_conditional] = STATE(10535),
    [sym_range] = STATE(10535),
    [sym_binary] = STATE(10535),
    [sym_unary] = STATE(10535),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9027] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10536),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10536),
    [sym_operator_assignment] = STATE(10536),
    [sym_conditional] = STATE(10536),
    [sym_range] = STATE(10536),
    [sym_binary] = STATE(10536),
    [sym_unary] = STATE(10536),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9028] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10537),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10537),
    [sym_operator_assignment] = STATE(10537),
    [sym_conditional] = STATE(10537),
    [sym_range] = STATE(10537),
    [sym_binary] = STATE(10537),
    [sym_unary] = STATE(10537),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9029] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10538),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10538),
    [sym_operator_assignment] = STATE(10538),
    [sym_conditional] = STATE(10538),
    [sym_range] = STATE(10538),
    [sym_binary] = STATE(10538),
    [sym_unary] = STATE(10538),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9030] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10539),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_splat_argument] = STATE(10540),
    [sym_assignment] = STATE(10539),
    [sym_operator_assignment] = STATE(10539),
    [sym_conditional] = STATE(10539),
    [sym_range] = STATE(10539),
    [sym_binary] = STATE(10539),
    [sym_unary] = STATE(10539),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(10540),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9031] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10541),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(10541),
    [sym_operator_assignment] = STATE(10541),
    [sym_conditional] = STATE(10541),
    [sym_range] = STATE(10541),
    [sym_binary] = STATE(10541),
    [sym_unary] = STATE(10541),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9032] = {
    [sym_string] = STATE(10542),
    [aux_sym_chained_string_repeat1] = STATE(10542),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [9033] = {
    [sym__string_start2] = ACTIONS(841),
    [sym__heredoc_body_start2] = ACTIONS(841),
    [sym__binary_minus2] = ACTIONS(841),
    [sym__binary_star2] = ACTIONS(841),
    [anon_sym_LBRACE] = ACTIONS(841),
    [anon_sym_DOT] = ACTIONS(843),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_PIPE] = ACTIONS(843),
    [anon_sym_STAR_STAR] = ACTIONS(843),
    [anon_sym_AMP] = ACTIONS(843),
    [anon_sym_EQ] = ACTIONS(843),
    [anon_sym_LT] = ACTIONS(843),
    [anon_sym_do] = ACTIONS(841),
    [anon_sym_EQ_GT] = ACTIONS(841),
    [anon_sym_LBRACK] = ACTIONS(841),
    [anon_sym_COLON_COLON2] = ACTIONS(841),
    [anon_sym_AMP_DOT] = ACTIONS(841),
    [anon_sym_PLUS_EQ] = ACTIONS(841),
    [anon_sym_DASH_EQ] = ACTIONS(841),
    [anon_sym_STAR_EQ] = ACTIONS(841),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(841),
    [anon_sym_SLASH_EQ] = ACTIONS(841),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(841),
    [anon_sym_PIPE_EQ] = ACTIONS(841),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(841),
    [anon_sym_AMP_EQ] = ACTIONS(841),
    [anon_sym_PERCENT_EQ] = ACTIONS(841),
    [anon_sym_GT_GT_EQ] = ACTIONS(841),
    [anon_sym_LT_LT_EQ] = ACTIONS(841),
    [anon_sym_CARET_EQ] = ACTIONS(841),
    [anon_sym_QMARK] = ACTIONS(841),
    [anon_sym_COLON2] = ACTIONS(843),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(841),
    [anon_sym_and] = ACTIONS(841),
    [anon_sym_or] = ACTIONS(841),
    [anon_sym_PIPE_PIPE] = ACTIONS(843),
    [anon_sym_AMP_AMP] = ACTIONS(843),
    [anon_sym_LT_LT] = ACTIONS(843),
    [anon_sym_GT_GT] = ACTIONS(843),
    [anon_sym_EQ_EQ] = ACTIONS(843),
    [anon_sym_BANG_EQ] = ACTIONS(841),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(841),
    [anon_sym_LT_EQ_GT] = ACTIONS(841),
    [anon_sym_EQ_TILDE] = ACTIONS(841),
    [anon_sym_BANG_TILDE] = ACTIONS(841),
    [anon_sym_LT_EQ] = ACTIONS(843),
    [anon_sym_GT] = ACTIONS(843),
    [anon_sym_GT_EQ] = ACTIONS(841),
    [anon_sym_CARET] = ACTIONS(843),
    [anon_sym_PLUS] = ACTIONS(843),
    [anon_sym_SLASH] = ACTIONS(843),
    [anon_sym_PERCENT] = ACTIONS(843),
    [sym_comment] = ACTIONS(87),
  },
  [9034] = {
    [sym__string_end2] = ACTIONS(13748),
    [sym_comment] = ACTIONS(87),
  },
  [9035] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(7792),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [9036] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9037] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9038] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9039] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9040] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9041] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9042] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(7858),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [9043] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13750),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9044] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(7862),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9045] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9046] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9047] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9048] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9049] = {
    [sym_heredoc_body] = STATE(9049),
    [aux_sym_call_repeat1] = STATE(9049),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_COLON2] = ACTIONS(7893),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9050] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(3744),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(3744),
    [sym_operator_assignment] = STATE(3744),
    [sym_conditional] = STATE(3744),
    [sym_range] = STATE(3744),
    [sym_binary] = STATE(3744),
    [sym_unary] = STATE(3744),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(3750),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(5930),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__identifier_hash_key2] = ACTIONS(5936),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12204),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5954),
    [sym_identifier] = ACTIONS(5954),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9051] = {
    [sym_heredoc_body] = STATE(9049),
    [aux_sym_call_repeat1] = STATE(9049),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_COLON2] = ACTIONS(7905),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9052] = {
    [aux_sym_argument_list_repeat1] = STATE(9052),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13752),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9053] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(7910),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9054] = {
    [aux_sym_exceptions_repeat1] = STATE(10546),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9055] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(7912),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [9056] = {
    [sym_string] = STATE(9056),
    [aux_sym_chained_string_repeat1] = STATE(9056),
    [sym__string_start2] = ACTIONS(13755),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9057] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(4204),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [9058] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_COLON2] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9059] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_COLON2] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9060] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [9061] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10547),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10547),
    [sym_operator_assignment] = STATE(10547),
    [sym_conditional] = STATE(10547),
    [sym_range] = STATE(10547),
    [sym_binary] = STATE(10547),
    [sym_unary] = STATE(10547),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9062] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10548),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10548),
    [sym_operator_assignment] = STATE(10548),
    [sym_conditional] = STATE(10548),
    [sym_range] = STATE(10548),
    [sym_binary] = STATE(10548),
    [sym_unary] = STATE(10548),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9063] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10549),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10549),
    [sym_operator_assignment] = STATE(10549),
    [sym_conditional] = STATE(10549),
    [sym_range] = STATE(10549),
    [sym_binary] = STATE(10549),
    [sym_unary] = STATE(10549),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9064] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10550),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10550),
    [sym_operator_assignment] = STATE(10550),
    [sym_conditional] = STATE(10550),
    [sym_range] = STATE(10550),
    [sym_binary] = STATE(10550),
    [sym_unary] = STATE(10550),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9065] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10551),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10551),
    [sym_operator_assignment] = STATE(10551),
    [sym_conditional] = STATE(10551),
    [sym_range] = STATE(10551),
    [sym_binary] = STATE(10551),
    [sym_unary] = STATE(10551),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9066] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10552),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10552),
    [sym_operator_assignment] = STATE(10552),
    [sym_conditional] = STATE(10552),
    [sym_range] = STATE(10552),
    [sym_binary] = STATE(10552),
    [sym_unary] = STATE(10552),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9067] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10553),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10553),
    [sym_operator_assignment] = STATE(10553),
    [sym_conditional] = STATE(10553),
    [sym_range] = STATE(10553),
    [sym_binary] = STATE(10553),
    [sym_unary] = STATE(10553),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9068] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10554),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10554),
    [sym_operator_assignment] = STATE(10554),
    [sym_conditional] = STATE(10554),
    [sym_range] = STATE(10554),
    [sym_binary] = STATE(10554),
    [sym_unary] = STATE(10554),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9069] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10555),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10555),
    [sym_operator_assignment] = STATE(10555),
    [sym_conditional] = STATE(10555),
    [sym_range] = STATE(10555),
    [sym_binary] = STATE(10555),
    [sym_unary] = STATE(10555),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9070] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10556),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10556),
    [sym_operator_assignment] = STATE(10556),
    [sym_conditional] = STATE(10556),
    [sym_range] = STATE(10556),
    [sym_binary] = STATE(10556),
    [sym_unary] = STATE(10556),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9071] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10557),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10557),
    [sym_operator_assignment] = STATE(10557),
    [sym_conditional] = STATE(10557),
    [sym_range] = STATE(10557),
    [sym_binary] = STATE(10557),
    [sym_unary] = STATE(10557),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9072] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10558),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10558),
    [sym_operator_assignment] = STATE(10558),
    [sym_conditional] = STATE(10558),
    [sym_range] = STATE(10558),
    [sym_binary] = STATE(10558),
    [sym_unary] = STATE(10558),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9073] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6625),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(6625),
    [sym_operator_assignment] = STATE(6625),
    [sym_conditional] = STATE(6625),
    [sym_range] = STATE(6625),
    [sym_binary] = STATE(6625),
    [sym_unary] = STATE(6625),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(9727),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9074] = {
    [aux_sym_exceptions_repeat1] = STATE(10559),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12236),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_COLON2] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9075] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(6625),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_splat_argument] = STATE(10560),
    [sym_assignment] = STATE(6625),
    [sym_operator_assignment] = STATE(6625),
    [sym_conditional] = STATE(6625),
    [sym_range] = STATE(6625),
    [sym_binary] = STATE(6625),
    [sym_unary] = STATE(6625),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(10560),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(9727),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9076] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10561),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(10561),
    [sym_operator_assignment] = STATE(10561),
    [sym_conditional] = STATE(10561),
    [sym_range] = STATE(10561),
    [sym_binary] = STATE(10561),
    [sym_unary] = STATE(10561),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9077] = {
    [sym_string] = STATE(10562),
    [aux_sym_chained_string_repeat1] = STATE(10562),
    [sym__string_start2] = ACTIONS(2549),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_COLON2] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [9078] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [ts_builtin_sym_end] = ACTIONS(10934),
    [anon_sym___END__] = ACTIONS(10936),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_end] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_rescue] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_when] = ACTIONS(10936),
    [anon_sym_elsif] = ACTIONS(10936),
    [anon_sym_else] = ACTIONS(10936),
    [anon_sym_then] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_ensure] = ACTIONS(10936),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [9079] = {
    [sym__line_break2] = ACTIONS(10127),
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [ts_builtin_sym_end] = ACTIONS(10127),
    [anon_sym___END__] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10129),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_end] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_when] = ACTIONS(10127),
    [anon_sym_elsif] = ACTIONS(10127),
    [anon_sym_else] = ACTIONS(10127),
    [anon_sym_then] = ACTIONS(10127),
    [anon_sym_ensure] = ACTIONS(10127),
    [anon_sym_EQ_GT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_PLUS_EQ] = ACTIONS(10127),
    [anon_sym_DASH_EQ] = ACTIONS(10127),
    [anon_sym_STAR_EQ] = ACTIONS(10127),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10127),
    [anon_sym_SLASH_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10127),
    [anon_sym_AMP_EQ] = ACTIONS(10127),
    [anon_sym_PERCENT_EQ] = ACTIONS(10127),
    [anon_sym_GT_GT_EQ] = ACTIONS(10127),
    [anon_sym_LT_LT_EQ] = ACTIONS(10127),
    [anon_sym_CARET_EQ] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10129),
    [anon_sym_AMP_AMP] = ACTIONS(10129),
    [anon_sym_LT_LT] = ACTIONS(10129),
    [anon_sym_GT_GT] = ACTIONS(10129),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10129),
    [anon_sym_PLUS] = ACTIONS(10129),
    [anon_sym_SLASH] = ACTIONS(10129),
    [anon_sym_PERCENT] = ACTIONS(10129),
    [sym_comment] = ACTIONS(87),
  },
  [9080] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13758),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9081] = {
    [sym__line_break2] = ACTIONS(10133),
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [ts_builtin_sym_end] = ACTIONS(10133),
    [anon_sym___END__] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10135),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_end] = ACTIONS(10133),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_when] = ACTIONS(10133),
    [anon_sym_elsif] = ACTIONS(10133),
    [anon_sym_else] = ACTIONS(10133),
    [anon_sym_then] = ACTIONS(10133),
    [anon_sym_ensure] = ACTIONS(10133),
    [anon_sym_EQ_GT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_PLUS_EQ] = ACTIONS(10133),
    [anon_sym_DASH_EQ] = ACTIONS(10133),
    [anon_sym_STAR_EQ] = ACTIONS(10133),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10133),
    [anon_sym_SLASH_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10133),
    [anon_sym_AMP_EQ] = ACTIONS(10133),
    [anon_sym_PERCENT_EQ] = ACTIONS(10133),
    [anon_sym_GT_GT_EQ] = ACTIONS(10133),
    [anon_sym_LT_LT_EQ] = ACTIONS(10133),
    [anon_sym_CARET_EQ] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10135),
    [anon_sym_GT_GT] = ACTIONS(10135),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10135),
    [anon_sym_PLUS] = ACTIONS(10135),
    [anon_sym_SLASH] = ACTIONS(10135),
    [anon_sym_PERCENT] = ACTIONS(10135),
    [sym_comment] = ACTIONS(87),
  },
  [9082] = {
    [sym__line_break2] = ACTIONS(10137),
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [ts_builtin_sym_end] = ACTIONS(10137),
    [anon_sym___END__] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10139),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_end] = ACTIONS(10137),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_when] = ACTIONS(10137),
    [anon_sym_elsif] = ACTIONS(10137),
    [anon_sym_else] = ACTIONS(10137),
    [anon_sym_then] = ACTIONS(10137),
    [anon_sym_ensure] = ACTIONS(10137),
    [anon_sym_EQ_GT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_PLUS_EQ] = ACTIONS(10137),
    [anon_sym_DASH_EQ] = ACTIONS(10137),
    [anon_sym_STAR_EQ] = ACTIONS(10137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10137),
    [anon_sym_SLASH_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10137),
    [anon_sym_AMP_EQ] = ACTIONS(10137),
    [anon_sym_PERCENT_EQ] = ACTIONS(10137),
    [anon_sym_GT_GT_EQ] = ACTIONS(10137),
    [anon_sym_LT_LT_EQ] = ACTIONS(10137),
    [anon_sym_CARET_EQ] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10139),
    [anon_sym_AMP_AMP] = ACTIONS(10139),
    [anon_sym_LT_LT] = ACTIONS(10139),
    [anon_sym_GT_GT] = ACTIONS(10139),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10139),
    [anon_sym_PLUS] = ACTIONS(10139),
    [anon_sym_SLASH] = ACTIONS(10139),
    [anon_sym_PERCENT] = ACTIONS(10139),
    [sym_comment] = ACTIONS(87),
  },
  [9083] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13760),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9084] = {
    [sym__line_break2] = ACTIONS(10143),
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [ts_builtin_sym_end] = ACTIONS(10143),
    [anon_sym___END__] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10145),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_end] = ACTIONS(10143),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_when] = ACTIONS(10143),
    [anon_sym_elsif] = ACTIONS(10143),
    [anon_sym_else] = ACTIONS(10143),
    [anon_sym_then] = ACTIONS(10143),
    [anon_sym_ensure] = ACTIONS(10143),
    [anon_sym_EQ_GT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_PLUS_EQ] = ACTIONS(10143),
    [anon_sym_DASH_EQ] = ACTIONS(10143),
    [anon_sym_STAR_EQ] = ACTIONS(10143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10143),
    [anon_sym_SLASH_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10143),
    [anon_sym_AMP_EQ] = ACTIONS(10143),
    [anon_sym_PERCENT_EQ] = ACTIONS(10143),
    [anon_sym_GT_GT_EQ] = ACTIONS(10143),
    [anon_sym_LT_LT_EQ] = ACTIONS(10143),
    [anon_sym_CARET_EQ] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10145),
    [anon_sym_AMP_AMP] = ACTIONS(10145),
    [anon_sym_LT_LT] = ACTIONS(10145),
    [anon_sym_GT_GT] = ACTIONS(10145),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10145),
    [anon_sym_PLUS] = ACTIONS(10145),
    [anon_sym_SLASH] = ACTIONS(10145),
    [anon_sym_PERCENT] = ACTIONS(10145),
    [sym_comment] = ACTIONS(87),
  },
  [9085] = {
    [sym__line_break2] = ACTIONS(6517),
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [ts_builtin_sym_end] = ACTIONS(6517),
    [anon_sym___END__] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6519),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_end] = ACTIONS(6517),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_when] = ACTIONS(6517),
    [anon_sym_elsif] = ACTIONS(6517),
    [anon_sym_else] = ACTIONS(6517),
    [anon_sym_then] = ACTIONS(6517),
    [anon_sym_ensure] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_PLUS_EQ] = ACTIONS(6517),
    [anon_sym_DASH_EQ] = ACTIONS(6517),
    [anon_sym_STAR_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6517),
    [anon_sym_SLASH_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6517),
    [anon_sym_AMP_EQ] = ACTIONS(6517),
    [anon_sym_PERCENT_EQ] = ACTIONS(6517),
    [anon_sym_GT_GT_EQ] = ACTIONS(6517),
    [anon_sym_LT_LT_EQ] = ACTIONS(6517),
    [anon_sym_CARET_EQ] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6519),
    [anon_sym_AMP_AMP] = ACTIONS(6519),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6519),
    [anon_sym_PLUS] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6519),
    [anon_sym_PERCENT] = ACTIONS(6519),
    [sym_comment] = ACTIONS(87),
  },
  [9086] = {
    [sym__line_break2] = ACTIONS(6521),
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [ts_builtin_sym_end] = ACTIONS(6521),
    [anon_sym___END__] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_end] = ACTIONS(6521),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_when] = ACTIONS(6521),
    [anon_sym_elsif] = ACTIONS(6521),
    [anon_sym_else] = ACTIONS(6521),
    [anon_sym_then] = ACTIONS(6521),
    [anon_sym_ensure] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_PLUS_EQ] = ACTIONS(6521),
    [anon_sym_DASH_EQ] = ACTIONS(6521),
    [anon_sym_STAR_EQ] = ACTIONS(6521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6521),
    [anon_sym_SLASH_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6521),
    [anon_sym_AMP_EQ] = ACTIONS(6521),
    [anon_sym_PERCENT_EQ] = ACTIONS(6521),
    [anon_sym_GT_GT_EQ] = ACTIONS(6521),
    [anon_sym_LT_LT_EQ] = ACTIONS(6521),
    [anon_sym_CARET_EQ] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6523),
    [anon_sym_AMP_AMP] = ACTIONS(6523),
    [anon_sym_LT_LT] = ACTIONS(6523),
    [anon_sym_GT_GT] = ACTIONS(6523),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6523),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(6523),
    [sym_comment] = ACTIONS(87),
  },
  [9087] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13762),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9088] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(13762),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13764),
  },
  [9089] = {
    [sym__line_break2] = ACTIONS(6529),
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [ts_builtin_sym_end] = ACTIONS(6529),
    [anon_sym___END__] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6531),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_end] = ACTIONS(6529),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_when] = ACTIONS(6529),
    [anon_sym_elsif] = ACTIONS(6529),
    [anon_sym_else] = ACTIONS(6529),
    [anon_sym_then] = ACTIONS(6529),
    [anon_sym_ensure] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_PLUS_EQ] = ACTIONS(6529),
    [anon_sym_DASH_EQ] = ACTIONS(6529),
    [anon_sym_STAR_EQ] = ACTIONS(6529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6529),
    [anon_sym_SLASH_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6529),
    [anon_sym_AMP_EQ] = ACTIONS(6529),
    [anon_sym_PERCENT_EQ] = ACTIONS(6529),
    [anon_sym_GT_GT_EQ] = ACTIONS(6529),
    [anon_sym_LT_LT_EQ] = ACTIONS(6529),
    [anon_sym_CARET_EQ] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6531),
    [anon_sym_AMP_AMP] = ACTIONS(6531),
    [anon_sym_LT_LT] = ACTIONS(6531),
    [anon_sym_GT_GT] = ACTIONS(6531),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6531),
    [anon_sym_PLUS] = ACTIONS(6531),
    [anon_sym_SLASH] = ACTIONS(6531),
    [anon_sym_PERCENT] = ACTIONS(6531),
    [sym_comment] = ACTIONS(87),
  },
  [9090] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13766),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9091] = {
    [sym__line_break2] = ACTIONS(6542),
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [ts_builtin_sym_end] = ACTIONS(6542),
    [anon_sym___END__] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6544),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_end] = ACTIONS(6542),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_when] = ACTIONS(6542),
    [anon_sym_elsif] = ACTIONS(6542),
    [anon_sym_else] = ACTIONS(6542),
    [anon_sym_then] = ACTIONS(6542),
    [anon_sym_ensure] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_PLUS_EQ] = ACTIONS(6542),
    [anon_sym_DASH_EQ] = ACTIONS(6542),
    [anon_sym_STAR_EQ] = ACTIONS(6542),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6542),
    [anon_sym_SLASH_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6542),
    [anon_sym_AMP_EQ] = ACTIONS(6542),
    [anon_sym_PERCENT_EQ] = ACTIONS(6542),
    [anon_sym_GT_GT_EQ] = ACTIONS(6542),
    [anon_sym_LT_LT_EQ] = ACTIONS(6542),
    [anon_sym_CARET_EQ] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6544),
    [anon_sym_AMP_AMP] = ACTIONS(6544),
    [anon_sym_LT_LT] = ACTIONS(6544),
    [anon_sym_GT_GT] = ACTIONS(6544),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_PERCENT] = ACTIONS(6544),
    [sym_comment] = ACTIONS(87),
  },
  [9092] = {
    [sym__line_break2] = ACTIONS(6546),
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [ts_builtin_sym_end] = ACTIONS(6546),
    [anon_sym___END__] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_end] = ACTIONS(6546),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_when] = ACTIONS(6546),
    [anon_sym_elsif] = ACTIONS(6546),
    [anon_sym_else] = ACTIONS(6546),
    [anon_sym_then] = ACTIONS(6546),
    [anon_sym_ensure] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_PLUS_EQ] = ACTIONS(6546),
    [anon_sym_DASH_EQ] = ACTIONS(6546),
    [anon_sym_STAR_EQ] = ACTIONS(6546),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6546),
    [anon_sym_SLASH_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6546),
    [anon_sym_AMP_EQ] = ACTIONS(6546),
    [anon_sym_PERCENT_EQ] = ACTIONS(6546),
    [anon_sym_GT_GT_EQ] = ACTIONS(6546),
    [anon_sym_LT_LT_EQ] = ACTIONS(6546),
    [anon_sym_CARET_EQ] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6548),
    [anon_sym_AMP_AMP] = ACTIONS(6548),
    [anon_sym_LT_LT] = ACTIONS(6548),
    [anon_sym_GT_GT] = ACTIONS(6548),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6548),
    [sym_comment] = ACTIONS(87),
  },
  [9093] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13768),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9094] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(13768),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13770),
  },
  [9095] = {
    [sym__line_break2] = ACTIONS(6554),
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [ts_builtin_sym_end] = ACTIONS(6554),
    [anon_sym___END__] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6556),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_end] = ACTIONS(6554),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_when] = ACTIONS(6554),
    [anon_sym_elsif] = ACTIONS(6554),
    [anon_sym_else] = ACTIONS(6554),
    [anon_sym_then] = ACTIONS(6554),
    [anon_sym_ensure] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_PLUS_EQ] = ACTIONS(6554),
    [anon_sym_DASH_EQ] = ACTIONS(6554),
    [anon_sym_STAR_EQ] = ACTIONS(6554),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6554),
    [anon_sym_SLASH_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6554),
    [anon_sym_AMP_EQ] = ACTIONS(6554),
    [anon_sym_PERCENT_EQ] = ACTIONS(6554),
    [anon_sym_GT_GT_EQ] = ACTIONS(6554),
    [anon_sym_LT_LT_EQ] = ACTIONS(6554),
    [anon_sym_CARET_EQ] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6556),
    [anon_sym_AMP_AMP] = ACTIONS(6556),
    [anon_sym_LT_LT] = ACTIONS(6556),
    [anon_sym_GT_GT] = ACTIONS(6556),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_PERCENT] = ACTIONS(6556),
    [sym_comment] = ACTIONS(87),
  },
  [9096] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13772),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9097] = {
    [sym__line_break2] = ACTIONS(7098),
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [ts_builtin_sym_end] = ACTIONS(7098),
    [anon_sym___END__] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7100),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_end] = ACTIONS(7098),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_when] = ACTIONS(7098),
    [anon_sym_elsif] = ACTIONS(7098),
    [anon_sym_else] = ACTIONS(7098),
    [anon_sym_then] = ACTIONS(7098),
    [anon_sym_ensure] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [anon_sym_DASH_EQ] = ACTIONS(7098),
    [anon_sym_STAR_EQ] = ACTIONS(7098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7098),
    [anon_sym_SLASH_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7098),
    [anon_sym_AMP_EQ] = ACTIONS(7098),
    [anon_sym_PERCENT_EQ] = ACTIONS(7098),
    [anon_sym_GT_GT_EQ] = ACTIONS(7098),
    [anon_sym_LT_LT_EQ] = ACTIONS(7098),
    [anon_sym_CARET_EQ] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7100),
    [anon_sym_AMP_AMP] = ACTIONS(7100),
    [anon_sym_LT_LT] = ACTIONS(7100),
    [anon_sym_GT_GT] = ACTIONS(7100),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7100),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7100),
    [anon_sym_PERCENT] = ACTIONS(7100),
    [sym_comment] = ACTIONS(87),
  },
  [9098] = {
    [anon_sym_DOT] = ACTIONS(13774),
    [anon_sym_COLON_COLON] = ACTIONS(13774),
    [sym_comment] = ACTIONS(87),
  },
  [9099] = {
    [sym__line_break2] = ACTIONS(7258),
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [ts_builtin_sym_end] = ACTIONS(7258),
    [anon_sym___END__] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7260),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_end] = ACTIONS(7258),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_when] = ACTIONS(7258),
    [anon_sym_elsif] = ACTIONS(7258),
    [anon_sym_else] = ACTIONS(7258),
    [anon_sym_then] = ACTIONS(7258),
    [anon_sym_ensure] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_PLUS_EQ] = ACTIONS(7258),
    [anon_sym_DASH_EQ] = ACTIONS(7258),
    [anon_sym_STAR_EQ] = ACTIONS(7258),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7258),
    [anon_sym_SLASH_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7258),
    [anon_sym_AMP_EQ] = ACTIONS(7258),
    [anon_sym_PERCENT_EQ] = ACTIONS(7258),
    [anon_sym_GT_GT_EQ] = ACTIONS(7258),
    [anon_sym_LT_LT_EQ] = ACTIONS(7258),
    [anon_sym_CARET_EQ] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_LT] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7260),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7260),
    [anon_sym_SLASH] = ACTIONS(7260),
    [anon_sym_PERCENT] = ACTIONS(7260),
    [sym_comment] = ACTIONS(87),
  },
  [9100] = {
    [sym__line_break2] = ACTIONS(7274),
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [ts_builtin_sym_end] = ACTIONS(7274),
    [anon_sym___END__] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7276),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_end] = ACTIONS(7274),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_when] = ACTIONS(7274),
    [anon_sym_elsif] = ACTIONS(7274),
    [anon_sym_else] = ACTIONS(7274),
    [anon_sym_then] = ACTIONS(7274),
    [anon_sym_ensure] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_PLUS_EQ] = ACTIONS(7274),
    [anon_sym_DASH_EQ] = ACTIONS(7274),
    [anon_sym_STAR_EQ] = ACTIONS(7274),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7274),
    [anon_sym_SLASH_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7274),
    [anon_sym_AMP_EQ] = ACTIONS(7274),
    [anon_sym_PERCENT_EQ] = ACTIONS(7274),
    [anon_sym_GT_GT_EQ] = ACTIONS(7274),
    [anon_sym_LT_LT_EQ] = ACTIONS(7274),
    [anon_sym_CARET_EQ] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7276),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7276),
    [anon_sym_PLUS] = ACTIONS(7276),
    [anon_sym_SLASH] = ACTIONS(7276),
    [anon_sym_PERCENT] = ACTIONS(7276),
    [sym_comment] = ACTIONS(87),
  },
  [9101] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(10572),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13776),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9102] = {
    [sym__statements] = STATE(3819),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(3820),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(3821),
    [sym_rescue] = STATE(3822),
    [sym__body_statement] = STATE(10573),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13778),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9103] = {
    [sym__line_break2] = ACTIONS(7730),
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [ts_builtin_sym_end] = ACTIONS(7730),
    [anon_sym___END__] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7732),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_end] = ACTIONS(7730),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_when] = ACTIONS(7730),
    [anon_sym_elsif] = ACTIONS(7730),
    [anon_sym_else] = ACTIONS(7730),
    [anon_sym_then] = ACTIONS(7730),
    [anon_sym_ensure] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_PLUS_EQ] = ACTIONS(7730),
    [anon_sym_DASH_EQ] = ACTIONS(7730),
    [anon_sym_STAR_EQ] = ACTIONS(7730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7730),
    [anon_sym_SLASH_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7730),
    [anon_sym_AMP_EQ] = ACTIONS(7730),
    [anon_sym_PERCENT_EQ] = ACTIONS(7730),
    [anon_sym_GT_GT_EQ] = ACTIONS(7730),
    [anon_sym_LT_LT_EQ] = ACTIONS(7730),
    [anon_sym_CARET_EQ] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7732),
    [anon_sym_AMP_AMP] = ACTIONS(7732),
    [anon_sym_LT_LT] = ACTIONS(7732),
    [anon_sym_GT_GT] = ACTIONS(7732),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7732),
    [anon_sym_PLUS] = ACTIONS(7732),
    [anon_sym_SLASH] = ACTIONS(7732),
    [anon_sym_PERCENT] = ACTIONS(7732),
    [sym_comment] = ACTIONS(87),
  },
  [9104] = {
    [sym__line_break2] = ACTIONS(7788),
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [ts_builtin_sym_end] = ACTIONS(7788),
    [anon_sym___END__] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_end] = ACTIONS(7788),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_when] = ACTIONS(7788),
    [anon_sym_elsif] = ACTIONS(7788),
    [anon_sym_else] = ACTIONS(7788),
    [anon_sym_then] = ACTIONS(7788),
    [anon_sym_ensure] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_PLUS_EQ] = ACTIONS(7788),
    [anon_sym_DASH_EQ] = ACTIONS(7788),
    [anon_sym_STAR_EQ] = ACTIONS(7788),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7788),
    [anon_sym_SLASH_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7788),
    [anon_sym_AMP_EQ] = ACTIONS(7788),
    [anon_sym_PERCENT_EQ] = ACTIONS(7788),
    [anon_sym_GT_GT_EQ] = ACTIONS(7788),
    [anon_sym_LT_LT_EQ] = ACTIONS(7788),
    [anon_sym_CARET_EQ] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [sym_comment] = ACTIONS(87),
  },
  [9105] = {
    [sym__line_break2] = ACTIONS(7970),
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [ts_builtin_sym_end] = ACTIONS(7970),
    [anon_sym___END__] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7972),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_end] = ACTIONS(7970),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_when] = ACTIONS(7970),
    [anon_sym_elsif] = ACTIONS(7970),
    [anon_sym_else] = ACTIONS(7970),
    [anon_sym_then] = ACTIONS(7970),
    [anon_sym_ensure] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_PLUS_EQ] = ACTIONS(7970),
    [anon_sym_DASH_EQ] = ACTIONS(7970),
    [anon_sym_STAR_EQ] = ACTIONS(7970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7970),
    [anon_sym_SLASH_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7970),
    [anon_sym_AMP_EQ] = ACTIONS(7970),
    [anon_sym_PERCENT_EQ] = ACTIONS(7970),
    [anon_sym_GT_GT_EQ] = ACTIONS(7970),
    [anon_sym_LT_LT_EQ] = ACTIONS(7970),
    [anon_sym_CARET_EQ] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7972),
    [anon_sym_AMP_AMP] = ACTIONS(7972),
    [anon_sym_LT_LT] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(7972),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7972),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7972),
    [anon_sym_PERCENT] = ACTIONS(7972),
    [sym_comment] = ACTIONS(87),
  },
  [9106] = {
    [sym_elsif] = STATE(10575),
    [sym_else] = STATE(10575),
    [sym__if_tail] = STATE(10575),
    [anon_sym_end] = ACTIONS(13780),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9107] = {
    [anon_sym_end] = ACTIONS(13780),
    [sym_comment] = ACTIONS(87),
  },
  [9108] = {
    [sym__statements] = STATE(10576),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(10575),
    [sym_else] = STATE(10575),
    [sym__if_tail] = STATE(10575),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13782),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9109] = {
    [sym__line_break2] = ACTIONS(8176),
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [ts_builtin_sym_end] = ACTIONS(8176),
    [anon_sym___END__] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8178),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_end] = ACTIONS(8176),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_when] = ACTIONS(8176),
    [anon_sym_elsif] = ACTIONS(8176),
    [anon_sym_else] = ACTIONS(8176),
    [anon_sym_then] = ACTIONS(8176),
    [anon_sym_ensure] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_PLUS_EQ] = ACTIONS(8176),
    [anon_sym_DASH_EQ] = ACTIONS(8176),
    [anon_sym_STAR_EQ] = ACTIONS(8176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8176),
    [anon_sym_SLASH_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8176),
    [anon_sym_AMP_EQ] = ACTIONS(8176),
    [anon_sym_PERCENT_EQ] = ACTIONS(8176),
    [anon_sym_GT_GT_EQ] = ACTIONS(8176),
    [anon_sym_LT_LT_EQ] = ACTIONS(8176),
    [anon_sym_CARET_EQ] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8178),
    [anon_sym_AMP_AMP] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(8178),
    [anon_sym_GT_GT] = ACTIONS(8178),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8178),
    [anon_sym_PLUS] = ACTIONS(8178),
    [anon_sym_SLASH] = ACTIONS(8178),
    [anon_sym_PERCENT] = ACTIONS(8178),
    [sym_comment] = ACTIONS(87),
  },
  [9110] = {
    [sym_else] = STATE(10578),
    [anon_sym_end] = ACTIONS(13784),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9111] = {
    [anon_sym_end] = ACTIONS(13784),
    [sym_comment] = ACTIONS(87),
  },
  [9112] = {
    [sym__line_break2] = ACTIONS(8352),
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [ts_builtin_sym_end] = ACTIONS(8352),
    [anon_sym___END__] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8354),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_end] = ACTIONS(8352),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_when] = ACTIONS(8352),
    [anon_sym_elsif] = ACTIONS(8352),
    [anon_sym_else] = ACTIONS(8352),
    [anon_sym_then] = ACTIONS(8352),
    [anon_sym_ensure] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_PLUS_EQ] = ACTIONS(8352),
    [anon_sym_DASH_EQ] = ACTIONS(8352),
    [anon_sym_STAR_EQ] = ACTIONS(8352),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8352),
    [anon_sym_SLASH_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8352),
    [anon_sym_AMP_EQ] = ACTIONS(8352),
    [anon_sym_PERCENT_EQ] = ACTIONS(8352),
    [anon_sym_GT_GT_EQ] = ACTIONS(8352),
    [anon_sym_LT_LT_EQ] = ACTIONS(8352),
    [anon_sym_CARET_EQ] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8354),
    [anon_sym_AMP_AMP] = ACTIONS(8354),
    [anon_sym_LT_LT] = ACTIONS(8354),
    [anon_sym_GT_GT] = ACTIONS(8354),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8354),
    [anon_sym_SLASH] = ACTIONS(8354),
    [anon_sym_PERCENT] = ACTIONS(8354),
    [sym_comment] = ACTIONS(87),
  },
  [9113] = {
    [anon_sym_end] = ACTIONS(13786),
    [sym_comment] = ACTIONS(87),
  },
  [9114] = {
    [sym__line_break2] = ACTIONS(8432),
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [ts_builtin_sym_end] = ACTIONS(8432),
    [anon_sym___END__] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8434),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_end] = ACTIONS(8432),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_when] = ACTIONS(8432),
    [anon_sym_elsif] = ACTIONS(8432),
    [anon_sym_else] = ACTIONS(8432),
    [anon_sym_then] = ACTIONS(8432),
    [anon_sym_ensure] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_PLUS_EQ] = ACTIONS(8432),
    [anon_sym_DASH_EQ] = ACTIONS(8432),
    [anon_sym_STAR_EQ] = ACTIONS(8432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8432),
    [anon_sym_SLASH_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8432),
    [anon_sym_AMP_EQ] = ACTIONS(8432),
    [anon_sym_PERCENT_EQ] = ACTIONS(8432),
    [anon_sym_GT_GT_EQ] = ACTIONS(8432),
    [anon_sym_LT_LT_EQ] = ACTIONS(8432),
    [anon_sym_CARET_EQ] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8434),
    [anon_sym_AMP_AMP] = ACTIONS(8434),
    [anon_sym_LT_LT] = ACTIONS(8434),
    [anon_sym_GT_GT] = ACTIONS(8434),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8434),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8434),
    [anon_sym_PERCENT] = ACTIONS(8434),
    [sym_comment] = ACTIONS(87),
  },
  [9115] = {
    [anon_sym_end] = ACTIONS(13788),
    [sym_comment] = ACTIONS(87),
  },
  [9116] = {
    [sym__statements] = STATE(10582),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13790),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9117] = {
    [anon_sym_end] = ACTIONS(13792),
    [sym_comment] = ACTIONS(87),
  },
  [9118] = {
    [sym_when] = STATE(10584),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [9119] = {
    [sym__line_break2] = ACTIONS(8696),
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [ts_builtin_sym_end] = ACTIONS(8696),
    [anon_sym___END__] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8698),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_end] = ACTIONS(8696),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_when] = ACTIONS(8696),
    [anon_sym_elsif] = ACTIONS(8696),
    [anon_sym_else] = ACTIONS(8696),
    [anon_sym_then] = ACTIONS(8696),
    [anon_sym_ensure] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_PLUS_EQ] = ACTIONS(8696),
    [anon_sym_DASH_EQ] = ACTIONS(8696),
    [anon_sym_STAR_EQ] = ACTIONS(8696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8696),
    [anon_sym_SLASH_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8696),
    [anon_sym_AMP_EQ] = ACTIONS(8696),
    [anon_sym_PERCENT_EQ] = ACTIONS(8696),
    [anon_sym_GT_GT_EQ] = ACTIONS(8696),
    [anon_sym_LT_LT_EQ] = ACTIONS(8696),
    [anon_sym_CARET_EQ] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8698),
    [anon_sym_AMP_AMP] = ACTIONS(8698),
    [anon_sym_LT_LT] = ACTIONS(8698),
    [anon_sym_GT_GT] = ACTIONS(8698),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8698),
    [anon_sym_PLUS] = ACTIONS(8698),
    [anon_sym_SLASH] = ACTIONS(8698),
    [anon_sym_PERCENT] = ACTIONS(8698),
    [sym_comment] = ACTIONS(87),
  },
  [9120] = {
    [sym__line_break2] = ACTIONS(9229),
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [ts_builtin_sym_end] = ACTIONS(9229),
    [anon_sym___END__] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_end] = ACTIONS(9229),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_when] = ACTIONS(9229),
    [anon_sym_elsif] = ACTIONS(9229),
    [anon_sym_else] = ACTIONS(9229),
    [anon_sym_then] = ACTIONS(9229),
    [anon_sym_ensure] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_PLUS_EQ] = ACTIONS(9229),
    [anon_sym_DASH_EQ] = ACTIONS(9229),
    [anon_sym_STAR_EQ] = ACTIONS(9229),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9229),
    [anon_sym_SLASH_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9229),
    [anon_sym_AMP_EQ] = ACTIONS(9229),
    [anon_sym_PERCENT_EQ] = ACTIONS(9229),
    [anon_sym_GT_GT_EQ] = ACTIONS(9229),
    [anon_sym_LT_LT_EQ] = ACTIONS(9229),
    [anon_sym_CARET_EQ] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9231),
    [anon_sym_AMP_AMP] = ACTIONS(9231),
    [anon_sym_LT_LT] = ACTIONS(9231),
    [anon_sym_GT_GT] = ACTIONS(9231),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9231),
    [anon_sym_PLUS] = ACTIONS(9231),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [9121] = {
    [anon_sym_end] = ACTIONS(13794),
    [sym_comment] = ACTIONS(87),
  },
  [9122] = {
    [sym_ensure] = STATE(10586),
    [anon_sym_end] = ACTIONS(13794),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [9123] = {
    [sym__line_break2] = ACTIONS(9457),
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [ts_builtin_sym_end] = ACTIONS(9457),
    [anon_sym___END__] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9459),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_end] = ACTIONS(9457),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_when] = ACTIONS(9457),
    [anon_sym_elsif] = ACTIONS(9457),
    [anon_sym_else] = ACTIONS(9457),
    [anon_sym_then] = ACTIONS(9457),
    [anon_sym_ensure] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_PLUS_EQ] = ACTIONS(9457),
    [anon_sym_DASH_EQ] = ACTIONS(9457),
    [anon_sym_STAR_EQ] = ACTIONS(9457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9457),
    [anon_sym_SLASH_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9457),
    [anon_sym_AMP_EQ] = ACTIONS(9457),
    [anon_sym_PERCENT_EQ] = ACTIONS(9457),
    [anon_sym_GT_GT_EQ] = ACTIONS(9457),
    [anon_sym_LT_LT_EQ] = ACTIONS(9457),
    [anon_sym_CARET_EQ] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9459),
    [anon_sym_AMP_AMP] = ACTIONS(9459),
    [anon_sym_LT_LT] = ACTIONS(9459),
    [anon_sym_GT_GT] = ACTIONS(9459),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9459),
    [anon_sym_PLUS] = ACTIONS(9459),
    [anon_sym_SLASH] = ACTIONS(9459),
    [anon_sym_PERCENT] = ACTIONS(9459),
    [sym_comment] = ACTIONS(87),
  },
  [9124] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10587),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_assignment] = STATE(10587),
    [sym_operator_assignment] = STATE(10587),
    [sym_conditional] = STATE(10587),
    [sym_range] = STATE(10587),
    [sym_binary] = STATE(10587),
    [sym_unary] = STATE(10587),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9125] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(6704),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(1566),
    [sym_scope_resolution] = STATE(1564),
    [sym_call] = STATE(1564),
    [sym_method_call] = STATE(1566),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(6704),
    [sym_operator_assignment] = STATE(6704),
    [sym_conditional] = STATE(6704),
    [sym_range] = STATE(6704),
    [sym_binary] = STATE(6704),
    [sym_unary] = STATE(6704),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(1565),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1566),
    [sym__variable] = STATE(1564),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(1566),
    [sym_false] = STATE(1566),
    [sym_nil] = STATE(1566),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(1567),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(769),
    [sym__unary_minus2] = ACTIONS(2619),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(2631),
    [anon_sym_yield] = ACTIONS(2633),
    [anon_sym_break] = ACTIONS(2635),
    [anon_sym_next] = ACTIONS(2637),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(2655),
    [anon_sym_defined_QMARK] = ACTIONS(2657),
    [anon_sym_not] = ACTIONS(2659),
    [anon_sym_BANG] = ACTIONS(2661),
    [anon_sym_TILDE] = ACTIONS(2661),
    [sym_constant] = ACTIONS(2663),
    [sym_identifier] = ACTIONS(2663),
    [sym_instance_variable] = ACTIONS(2665),
    [sym_class_variable] = ACTIONS(2665),
    [sym_global_variable] = ACTIONS(2665),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(2663),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2663),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9126] = {
    [aux_sym_exceptions_repeat1] = STATE(10589),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [ts_builtin_sym_end] = ACTIONS(9929),
    [anon_sym___END__] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13796),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9127] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [9128] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [9129] = {
    [sym_heredoc_body] = STATE(9129),
    [aux_sym_call_repeat1] = STATE(9129),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9130] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(3859),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(3859),
    [sym_operator_assignment] = STATE(3859),
    [sym_conditional] = STATE(3859),
    [sym_range] = STATE(3859),
    [sym_binary] = STATE(3859),
    [sym_unary] = STATE(3859),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3862),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(6096),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [sym__identifier_hash_key2] = ACTIONS(6100),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12326),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(6102),
    [sym_identifier] = ACTIONS(6102),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9131] = {
    [sym_heredoc_body] = STATE(9129),
    [aux_sym_call_repeat1] = STATE(9129),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9132] = {
    [aux_sym_argument_list_repeat1] = STATE(9132),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13798),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9133] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10590),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1588),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1588),
    [sym_assignment] = STATE(10590),
    [sym_operator_assignment] = STATE(10590),
    [sym_conditional] = STATE(10590),
    [sym_range] = STATE(10590),
    [sym_binary] = STATE(10590),
    [sym_unary] = STATE(10590),
    [sym_left_assignment_list] = STATE(1587),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1588),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1588),
    [sym_false] = STATE(1588),
    [sym_nil] = STATE(1588),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(3853),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(2683),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2687),
    [anon_sym_yield] = ACTIONS(2689),
    [anon_sym_break] = ACTIONS(2691),
    [anon_sym_next] = ACTIONS(2693),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2695),
    [anon_sym_defined_QMARK] = ACTIONS(2697),
    [anon_sym_not] = ACTIONS(2699),
    [anon_sym_BANG] = ACTIONS(2701),
    [anon_sym_TILDE] = ACTIONS(2701),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9134] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [9135] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [9136] = {
    [sym_heredoc_body] = STATE(9136),
    [aux_sym_call_repeat1] = STATE(9136),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9137] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(3884),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(3884),
    [sym_operator_assignment] = STATE(3884),
    [sym_conditional] = STATE(3884),
    [sym_range] = STATE(3884),
    [sym_binary] = STATE(3884),
    [sym_unary] = STATE(3884),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(3887),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(6138),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [sym__identifier_hash_key2] = ACTIONS(6142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12330),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(6144),
    [sym_identifier] = ACTIONS(6144),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9138] = {
    [sym_heredoc_body] = STATE(9136),
    [aux_sym_call_repeat1] = STATE(9136),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9139] = {
    [aux_sym_argument_list_repeat1] = STATE(9139),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13801),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9140] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9141] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_RBRACE] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9142] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9143] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [9144] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10591),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10591),
    [sym_operator_assignment] = STATE(10591),
    [sym_conditional] = STATE(10591),
    [sym_range] = STATE(10591),
    [sym_binary] = STATE(10591),
    [sym_unary] = STATE(10591),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9145] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10592),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10592),
    [sym_operator_assignment] = STATE(10592),
    [sym_conditional] = STATE(10592),
    [sym_range] = STATE(10592),
    [sym_binary] = STATE(10592),
    [sym_unary] = STATE(10592),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9146] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10593),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10593),
    [sym_operator_assignment] = STATE(10593),
    [sym_conditional] = STATE(10593),
    [sym_range] = STATE(10593),
    [sym_binary] = STATE(10593),
    [sym_unary] = STATE(10593),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9147] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10594),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10594),
    [sym_operator_assignment] = STATE(10594),
    [sym_conditional] = STATE(10594),
    [sym_range] = STATE(10594),
    [sym_binary] = STATE(10594),
    [sym_unary] = STATE(10594),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9148] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10595),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10595),
    [sym_operator_assignment] = STATE(10595),
    [sym_conditional] = STATE(10595),
    [sym_range] = STATE(10595),
    [sym_binary] = STATE(10595),
    [sym_unary] = STATE(10595),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9149] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10596),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10596),
    [sym_operator_assignment] = STATE(10596),
    [sym_conditional] = STATE(10596),
    [sym_range] = STATE(10596),
    [sym_binary] = STATE(10596),
    [sym_unary] = STATE(10596),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9150] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10597),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10597),
    [sym_operator_assignment] = STATE(10597),
    [sym_conditional] = STATE(10597),
    [sym_range] = STATE(10597),
    [sym_binary] = STATE(10597),
    [sym_unary] = STATE(10597),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9151] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10598),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10598),
    [sym_operator_assignment] = STATE(10598),
    [sym_conditional] = STATE(10598),
    [sym_range] = STATE(10598),
    [sym_binary] = STATE(10598),
    [sym_unary] = STATE(10598),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9152] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10599),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10599),
    [sym_operator_assignment] = STATE(10599),
    [sym_conditional] = STATE(10599),
    [sym_range] = STATE(10599),
    [sym_binary] = STATE(10599),
    [sym_unary] = STATE(10599),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9153] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10600),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10600),
    [sym_operator_assignment] = STATE(10600),
    [sym_conditional] = STATE(10600),
    [sym_range] = STATE(10600),
    [sym_binary] = STATE(10600),
    [sym_unary] = STATE(10600),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9154] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10601),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10601),
    [sym_operator_assignment] = STATE(10601),
    [sym_conditional] = STATE(10601),
    [sym_range] = STATE(10601),
    [sym_binary] = STATE(10601),
    [sym_unary] = STATE(10601),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9155] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10602),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10602),
    [sym_operator_assignment] = STATE(10602),
    [sym_conditional] = STATE(10602),
    [sym_range] = STATE(10602),
    [sym_binary] = STATE(10602),
    [sym_unary] = STATE(10602),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9156] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6743),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(6743),
    [sym_operator_assignment] = STATE(6743),
    [sym_conditional] = STATE(6743),
    [sym_range] = STATE(6743),
    [sym_binary] = STATE(6743),
    [sym_unary] = STATE(6743),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(9860),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9157] = {
    [aux_sym_exceptions_repeat1] = STATE(10603),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12362),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9158] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6743),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_splat_argument] = STATE(10604),
    [sym_assignment] = STATE(6743),
    [sym_operator_assignment] = STATE(6743),
    [sym_conditional] = STATE(6743),
    [sym_range] = STATE(6743),
    [sym_binary] = STATE(6743),
    [sym_unary] = STATE(6743),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(10604),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(9860),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9159] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10605),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(10605),
    [sym_operator_assignment] = STATE(10605),
    [sym_conditional] = STATE(10605),
    [sym_range] = STATE(10605),
    [sym_binary] = STATE(10605),
    [sym_unary] = STATE(10605),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9160] = {
    [sym__method_rest] = STATE(10606),
    [sym_operator] = STATE(1595),
    [sym__method_name] = STATE(1595),
    [sym_setter] = STATE(1595),
    [sym_symbol] = STATE(1595),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(9876),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(9876),
    [sym_class_variable] = ACTIONS(9876),
    [sym_global_variable] = ACTIONS(9876),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [9161] = {
    [sym__line_break2] = ACTIONS(10896),
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [ts_builtin_sym_end] = ACTIONS(10896),
    [anon_sym___END__] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_end] = ACTIONS(10896),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_when] = ACTIONS(10896),
    [anon_sym_elsif] = ACTIONS(10896),
    [anon_sym_else] = ACTIONS(10896),
    [anon_sym_then] = ACTIONS(10896),
    [anon_sym_ensure] = ACTIONS(10896),
    [anon_sym_EQ_GT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_PLUS_EQ] = ACTIONS(10896),
    [anon_sym_DASH_EQ] = ACTIONS(10896),
    [anon_sym_STAR_EQ] = ACTIONS(10896),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10896),
    [anon_sym_SLASH_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10896),
    [anon_sym_AMP_EQ] = ACTIONS(10896),
    [anon_sym_PERCENT_EQ] = ACTIONS(10896),
    [anon_sym_GT_GT_EQ] = ACTIONS(10896),
    [anon_sym_LT_LT_EQ] = ACTIONS(10896),
    [anon_sym_CARET_EQ] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10898),
    [anon_sym_AMP_AMP] = ACTIONS(10898),
    [anon_sym_LT_LT] = ACTIONS(10898),
    [anon_sym_GT_GT] = ACTIONS(10898),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10898),
    [anon_sym_PLUS] = ACTIONS(10898),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9162] = {
    [sym__line_break2] = ACTIONS(10900),
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [ts_builtin_sym_end] = ACTIONS(10900),
    [anon_sym___END__] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10902),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(10900),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_when] = ACTIONS(10900),
    [anon_sym_elsif] = ACTIONS(10900),
    [anon_sym_else] = ACTIONS(10900),
    [anon_sym_then] = ACTIONS(10900),
    [anon_sym_ensure] = ACTIONS(10900),
    [anon_sym_EQ_GT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_PLUS_EQ] = ACTIONS(10900),
    [anon_sym_DASH_EQ] = ACTIONS(10900),
    [anon_sym_STAR_EQ] = ACTIONS(10900),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10900),
    [anon_sym_SLASH_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10900),
    [anon_sym_AMP_EQ] = ACTIONS(10900),
    [anon_sym_PERCENT_EQ] = ACTIONS(10900),
    [anon_sym_GT_GT_EQ] = ACTIONS(10900),
    [anon_sym_LT_LT_EQ] = ACTIONS(10900),
    [anon_sym_CARET_EQ] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10902),
    [anon_sym_AMP_AMP] = ACTIONS(10902),
    [anon_sym_LT_LT] = ACTIONS(10902),
    [anon_sym_GT_GT] = ACTIONS(10902),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10902),
    [anon_sym_PLUS] = ACTIONS(10902),
    [anon_sym_SLASH] = ACTIONS(10902),
    [anon_sym_PERCENT] = ACTIONS(10902),
    [sym_comment] = ACTIONS(87),
  },
  [9163] = {
    [sym__line_break2] = ACTIONS(11061),
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [ts_builtin_sym_end] = ACTIONS(11061),
    [anon_sym___END__] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11063),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_end] = ACTIONS(11061),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_when] = ACTIONS(11061),
    [anon_sym_elsif] = ACTIONS(11061),
    [anon_sym_else] = ACTIONS(11061),
    [anon_sym_then] = ACTIONS(11061),
    [anon_sym_ensure] = ACTIONS(11061),
    [anon_sym_EQ_GT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_PLUS_EQ] = ACTIONS(11061),
    [anon_sym_DASH_EQ] = ACTIONS(11061),
    [anon_sym_STAR_EQ] = ACTIONS(11061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11061),
    [anon_sym_SLASH_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11061),
    [anon_sym_AMP_EQ] = ACTIONS(11061),
    [anon_sym_PERCENT_EQ] = ACTIONS(11061),
    [anon_sym_GT_GT_EQ] = ACTIONS(11061),
    [anon_sym_LT_LT_EQ] = ACTIONS(11061),
    [anon_sym_CARET_EQ] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11063),
    [anon_sym_AMP_AMP] = ACTIONS(11063),
    [anon_sym_LT_LT] = ACTIONS(11063),
    [anon_sym_GT_GT] = ACTIONS(11063),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11063),
    [anon_sym_PLUS] = ACTIONS(11063),
    [anon_sym_SLASH] = ACTIONS(11063),
    [anon_sym_PERCENT] = ACTIONS(11063),
    [sym_comment] = ACTIONS(87),
  },
  [9164] = {
    [anon_sym_end] = ACTIONS(13804),
    [sym_comment] = ACTIONS(87),
  },
  [9165] = {
    [sym_elsif] = STATE(10608),
    [sym_else] = STATE(10608),
    [sym__if_tail] = STATE(10608),
    [anon_sym_end] = ACTIONS(13804),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9166] = {
    [sym__line_break2] = ACTIONS(11236),
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [ts_builtin_sym_end] = ACTIONS(11236),
    [anon_sym___END__] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11238),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_end] = ACTIONS(11236),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_when] = ACTIONS(11236),
    [anon_sym_elsif] = ACTIONS(11236),
    [anon_sym_else] = ACTIONS(11236),
    [anon_sym_then] = ACTIONS(11236),
    [anon_sym_ensure] = ACTIONS(11236),
    [anon_sym_EQ_GT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_PLUS_EQ] = ACTIONS(11236),
    [anon_sym_DASH_EQ] = ACTIONS(11236),
    [anon_sym_STAR_EQ] = ACTIONS(11236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11236),
    [anon_sym_SLASH_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11236),
    [anon_sym_AMP_EQ] = ACTIONS(11236),
    [anon_sym_PERCENT_EQ] = ACTIONS(11236),
    [anon_sym_GT_GT_EQ] = ACTIONS(11236),
    [anon_sym_LT_LT_EQ] = ACTIONS(11236),
    [anon_sym_CARET_EQ] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11238),
    [anon_sym_AMP_AMP] = ACTIONS(11238),
    [anon_sym_LT_LT] = ACTIONS(11238),
    [anon_sym_GT_GT] = ACTIONS(11238),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11238),
    [anon_sym_PLUS] = ACTIONS(11238),
    [anon_sym_SLASH] = ACTIONS(11238),
    [anon_sym_PERCENT] = ACTIONS(11238),
    [sym_comment] = ACTIONS(87),
  },
  [9167] = {
    [anon_sym_end] = ACTIONS(13806),
    [sym_comment] = ACTIONS(87),
  },
  [9168] = {
    [sym__line_break2] = ACTIONS(11333),
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [ts_builtin_sym_end] = ACTIONS(11333),
    [anon_sym___END__] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11333),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_when] = ACTIONS(11333),
    [anon_sym_elsif] = ACTIONS(11333),
    [anon_sym_else] = ACTIONS(11333),
    [anon_sym_then] = ACTIONS(11333),
    [anon_sym_ensure] = ACTIONS(11333),
    [anon_sym_EQ_GT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_PLUS_EQ] = ACTIONS(11333),
    [anon_sym_DASH_EQ] = ACTIONS(11333),
    [anon_sym_STAR_EQ] = ACTIONS(11333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11333),
    [anon_sym_SLASH_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11333),
    [anon_sym_AMP_EQ] = ACTIONS(11333),
    [anon_sym_PERCENT_EQ] = ACTIONS(11333),
    [anon_sym_GT_GT_EQ] = ACTIONS(11333),
    [anon_sym_LT_LT_EQ] = ACTIONS(11333),
    [anon_sym_CARET_EQ] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [9169] = {
    [sym__line_break2] = ACTIONS(11342),
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [ts_builtin_sym_end] = ACTIONS(11342),
    [anon_sym___END__] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_end] = ACTIONS(11342),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_when] = ACTIONS(11342),
    [anon_sym_elsif] = ACTIONS(11342),
    [anon_sym_else] = ACTIONS(11342),
    [anon_sym_then] = ACTIONS(11342),
    [anon_sym_ensure] = ACTIONS(11342),
    [anon_sym_EQ_GT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_PLUS_EQ] = ACTIONS(11342),
    [anon_sym_DASH_EQ] = ACTIONS(11342),
    [anon_sym_STAR_EQ] = ACTIONS(11342),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11342),
    [anon_sym_SLASH_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11342),
    [anon_sym_AMP_EQ] = ACTIONS(11342),
    [anon_sym_PERCENT_EQ] = ACTIONS(11342),
    [anon_sym_GT_GT_EQ] = ACTIONS(11342),
    [anon_sym_LT_LT_EQ] = ACTIONS(11342),
    [anon_sym_CARET_EQ] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [9170] = {
    [sym__line_break2] = ACTIONS(11393),
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [ts_builtin_sym_end] = ACTIONS(11393),
    [anon_sym___END__] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11395),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_end] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_when] = ACTIONS(11393),
    [anon_sym_elsif] = ACTIONS(11393),
    [anon_sym_else] = ACTIONS(11393),
    [anon_sym_then] = ACTIONS(11393),
    [anon_sym_ensure] = ACTIONS(11393),
    [anon_sym_EQ_GT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_PLUS_EQ] = ACTIONS(11393),
    [anon_sym_DASH_EQ] = ACTIONS(11393),
    [anon_sym_STAR_EQ] = ACTIONS(11393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11393),
    [anon_sym_SLASH_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11393),
    [anon_sym_AMP_EQ] = ACTIONS(11393),
    [anon_sym_PERCENT_EQ] = ACTIONS(11393),
    [anon_sym_GT_GT_EQ] = ACTIONS(11393),
    [anon_sym_LT_LT_EQ] = ACTIONS(11393),
    [anon_sym_CARET_EQ] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11395),
    [anon_sym_AMP_AMP] = ACTIONS(11395),
    [anon_sym_LT_LT] = ACTIONS(11395),
    [anon_sym_GT_GT] = ACTIONS(11395),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11395),
    [anon_sym_PLUS] = ACTIONS(11395),
    [anon_sym_SLASH] = ACTIONS(11395),
    [anon_sym_PERCENT] = ACTIONS(11395),
    [sym_comment] = ACTIONS(87),
  },
  [9171] = {
    [anon_sym_end] = ACTIONS(13808),
    [sym_comment] = ACTIONS(87),
  },
  [9172] = {
    [sym__line_break2] = ACTIONS(13726),
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [ts_builtin_sym_end] = ACTIONS(13726),
    [anon_sym___END__] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_end] = ACTIONS(13726),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_when] = ACTIONS(13726),
    [anon_sym_elsif] = ACTIONS(13726),
    [anon_sym_else] = ACTIONS(13726),
    [anon_sym_then] = ACTIONS(13726),
    [anon_sym_ensure] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [9173] = {
    [anon_sym_end] = ACTIONS(13810),
    [sym_comment] = ACTIONS(87),
  },
  [9174] = {
    [sym__line_break2] = ACTIONS(11406),
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [ts_builtin_sym_end] = ACTIONS(11406),
    [anon_sym___END__] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11408),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_end] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_when] = ACTIONS(11406),
    [anon_sym_elsif] = ACTIONS(11406),
    [anon_sym_else] = ACTIONS(11406),
    [anon_sym_then] = ACTIONS(11406),
    [anon_sym_ensure] = ACTIONS(11406),
    [anon_sym_EQ_GT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_PLUS_EQ] = ACTIONS(11406),
    [anon_sym_DASH_EQ] = ACTIONS(11406),
    [anon_sym_STAR_EQ] = ACTIONS(11406),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11406),
    [anon_sym_SLASH_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11406),
    [anon_sym_AMP_EQ] = ACTIONS(11406),
    [anon_sym_PERCENT_EQ] = ACTIONS(11406),
    [anon_sym_GT_GT_EQ] = ACTIONS(11406),
    [anon_sym_LT_LT_EQ] = ACTIONS(11406),
    [anon_sym_CARET_EQ] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11408),
    [anon_sym_AMP_AMP] = ACTIONS(11408),
    [anon_sym_LT_LT] = ACTIONS(11408),
    [anon_sym_GT_GT] = ACTIONS(11408),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11408),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_SLASH] = ACTIONS(11408),
    [anon_sym_PERCENT] = ACTIONS(11408),
    [sym_comment] = ACTIONS(87),
  },
  [9175] = {
    [anon_sym_end] = ACTIONS(13812),
    [sym_comment] = ACTIONS(87),
  },
  [9176] = {
    [sym__line_break2] = ACTIONS(11878),
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [ts_builtin_sym_end] = ACTIONS(11878),
    [anon_sym___END__] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11880),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_end] = ACTIONS(11878),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_when] = ACTIONS(11878),
    [anon_sym_elsif] = ACTIONS(11878),
    [anon_sym_else] = ACTIONS(11878),
    [anon_sym_then] = ACTIONS(11878),
    [anon_sym_ensure] = ACTIONS(11878),
    [anon_sym_EQ_GT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_PLUS_EQ] = ACTIONS(11878),
    [anon_sym_DASH_EQ] = ACTIONS(11878),
    [anon_sym_STAR_EQ] = ACTIONS(11878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11878),
    [anon_sym_SLASH_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11878),
    [anon_sym_AMP_EQ] = ACTIONS(11878),
    [anon_sym_PERCENT_EQ] = ACTIONS(11878),
    [anon_sym_GT_GT_EQ] = ACTIONS(11878),
    [anon_sym_LT_LT_EQ] = ACTIONS(11878),
    [anon_sym_CARET_EQ] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11880),
    [anon_sym_AMP_AMP] = ACTIONS(11880),
    [anon_sym_LT_LT] = ACTIONS(11880),
    [anon_sym_GT_GT] = ACTIONS(11880),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11880),
    [anon_sym_PLUS] = ACTIONS(11880),
    [anon_sym_SLASH] = ACTIONS(11880),
    [anon_sym_PERCENT] = ACTIONS(11880),
    [sym_comment] = ACTIONS(87),
  },
  [9177] = {
    [anon_sym_end] = ACTIONS(13814),
    [sym_comment] = ACTIONS(87),
  },
  [9178] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(2741),
    [sym__binary_star2] = ACTIONS(2743),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2749),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(2751),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(2755),
    [anon_sym_DOT_DOT] = ACTIONS(2757),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2759),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2761),
    [anon_sym_AMP_AMP] = ACTIONS(2761),
    [anon_sym_LT_LT] = ACTIONS(2763),
    [anon_sym_GT_GT] = ACTIONS(2763),
    [anon_sym_EQ_EQ] = ACTIONS(2761),
    [anon_sym_BANG_EQ] = ACTIONS(2765),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2765),
    [anon_sym_LT_EQ_GT] = ACTIONS(2765),
    [anon_sym_EQ_TILDE] = ACTIONS(2765),
    [anon_sym_BANG_TILDE] = ACTIONS(2765),
    [anon_sym_LT_EQ] = ACTIONS(2751),
    [anon_sym_GT] = ACTIONS(2751),
    [anon_sym_GT_EQ] = ACTIONS(2767),
    [anon_sym_CARET] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2747),
    [anon_sym_PERCENT] = ACTIONS(2747),
    [sym_comment] = ACTIONS(87),
  },
  [9179] = {
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9180] = {
    [aux_sym_exceptions_repeat1] = STATE(9180),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(13816),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9181] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10614),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1671),
    [sym_scope_resolution] = STATE(51),
    [sym_call] = STATE(51),
    [sym_method_call] = STATE(1671),
    [sym_assignment] = STATE(10614),
    [sym_operator_assignment] = STATE(10614),
    [sym_conditional] = STATE(10614),
    [sym_range] = STATE(10614),
    [sym_binary] = STATE(10614),
    [sym_unary] = STATE(10614),
    [sym_left_assignment_list] = STATE(1670),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1671),
    [sym__variable] = STATE(51),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1671),
    [sym_false] = STATE(1671),
    [sym_nil] = STATE(1671),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(909),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2795),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(1573),
    [anon_sym_yield] = ACTIONS(1575),
    [anon_sym_break] = ACTIONS(1577),
    [anon_sym_next] = ACTIONS(1579),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2797),
    [anon_sym_defined_QMARK] = ACTIONS(2799),
    [anon_sym_not] = ACTIONS(2801),
    [anon_sym_BANG] = ACTIONS(2803),
    [anon_sym_TILDE] = ACTIONS(2803),
    [sym_constant] = ACTIONS(79),
    [sym_identifier] = ACTIONS(79),
    [sym_instance_variable] = ACTIONS(81),
    [sym_class_variable] = ACTIONS(81),
    [sym_global_variable] = ACTIONS(81),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(79),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(79),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9182] = {
    [sym_heredoc_body] = STATE(10615),
    [aux_sym_call_repeat1] = STATE(10615),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9183] = {
    [sym_heredoc_body] = STATE(10616),
    [aux_sym_call_repeat1] = STATE(10616),
    [aux_sym_argument_list_repeat1] = STATE(6854),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6335),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9184] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9185] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9186] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9187] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9188] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9189] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9190] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13819),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9191] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9192] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9193] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9194] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9195] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9196] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9197] = {
    [aux_sym_exceptions_repeat1] = STATE(10619),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9198] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [9199] = {
    [sym_string] = STATE(9199),
    [aux_sym_chained_string_repeat1] = STATE(9199),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9200] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [9201] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [9202] = {
    [sym_heredoc_body] = STATE(9202),
    [aux_sym_call_repeat1] = STATE(9202),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9203] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(3994),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(3994),
    [sym_operator_assignment] = STATE(3994),
    [sym_conditional] = STATE(3994),
    [sym_range] = STATE(3994),
    [sym_binary] = STATE(3994),
    [sym_unary] = STATE(3994),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3997),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6285),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [sym__identifier_hash_key2] = ACTIONS(6289),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12405),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(6291),
    [sym_identifier] = ACTIONS(6291),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9204] = {
    [sym_heredoc_body] = STATE(9202),
    [aux_sym_call_repeat1] = STATE(9202),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9205] = {
    [aux_sym_argument_list_repeat1] = STATE(9205),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13821),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9206] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10620),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_assignment] = STATE(10620),
    [sym_operator_assignment] = STATE(10620),
    [sym_conditional] = STATE(10620),
    [sym_range] = STATE(10620),
    [sym_binary] = STATE(10620),
    [sym_unary] = STATE(10620),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9207] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [9208] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [9209] = {
    [sym_heredoc_body] = STATE(9209),
    [aux_sym_call_repeat1] = STATE(9209),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9210] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4018),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(4018),
    [sym_operator_assignment] = STATE(4018),
    [sym_conditional] = STATE(4018),
    [sym_range] = STATE(4018),
    [sym_binary] = STATE(4018),
    [sym_unary] = STATE(4018),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4021),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6327),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [sym__identifier_hash_key2] = ACTIONS(6331),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12409),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(6333),
    [sym_identifier] = ACTIONS(6333),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9211] = {
    [sym_heredoc_body] = STATE(9209),
    [aux_sym_call_repeat1] = STATE(9209),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9212] = {
    [aux_sym_argument_list_repeat1] = STATE(9212),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13824),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9213] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6855),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1695),
    [sym_scope_resolution] = STATE(1691),
    [sym_call] = STATE(1691),
    [sym_method_call] = STATE(1695),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(6855),
    [sym_operator_assignment] = STATE(6855),
    [sym_conditional] = STATE(6855),
    [sym_range] = STATE(6855),
    [sym_binary] = STATE(6855),
    [sym_unary] = STATE(6855),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(1694),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1695),
    [sym__variable] = STATE(1691),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1695),
    [sym_false] = STATE(1695),
    [sym_nil] = STATE(1695),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(3986),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(6287),
    [sym__unary_minus2] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2821),
    [anon_sym_yield] = ACTIONS(2823),
    [anon_sym_break] = ACTIONS(2825),
    [anon_sym_next] = ACTIONS(2827),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6281),
    [anon_sym_defined_QMARK] = ACTIONS(2829),
    [anon_sym_not] = ACTIONS(2831),
    [anon_sym_BANG] = ACTIONS(2835),
    [anon_sym_TILDE] = ACTIONS(2835),
    [sym_constant] = ACTIONS(2841),
    [sym_identifier] = ACTIONS(2841),
    [sym_instance_variable] = ACTIONS(2839),
    [sym_class_variable] = ACTIONS(2839),
    [sym_global_variable] = ACTIONS(2839),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(2841),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2841),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9214] = {
    [aux_sym_exceptions_repeat1] = STATE(10621),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13827),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9215] = {
    [sym__binary_minus2] = ACTIONS(2865),
    [sym__binary_star2] = ACTIONS(2867),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(2869),
    [anon_sym_STAR_STAR] = ACTIONS(2871),
    [anon_sym_AMP] = ACTIONS(2873),
    [anon_sym_LT] = ACTIONS(2875),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(2877),
    [anon_sym_DOT_DOT] = ACTIONS(2879),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2881),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(2885),
    [anon_sym_AMP_AMP] = ACTIONS(2885),
    [anon_sym_LT_LT] = ACTIONS(2887),
    [anon_sym_GT_GT] = ACTIONS(2887),
    [anon_sym_EQ_EQ] = ACTIONS(2889),
    [anon_sym_BANG_EQ] = ACTIONS(2885),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2885),
    [anon_sym_LT_EQ_GT] = ACTIONS(2885),
    [anon_sym_EQ_TILDE] = ACTIONS(2885),
    [anon_sym_BANG_TILDE] = ACTIONS(2885),
    [anon_sym_LT_EQ] = ACTIONS(2875),
    [anon_sym_GT] = ACTIONS(2875),
    [anon_sym_GT_EQ] = ACTIONS(2891),
    [anon_sym_CARET] = ACTIONS(2893),
    [anon_sym_PLUS] = ACTIONS(2895),
    [anon_sym_SLASH] = ACTIONS(2871),
    [anon_sym_PERCENT] = ACTIONS(2871),
    [sym_comment] = ACTIONS(87),
  },
  [9216] = {
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_rescue] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [9217] = {
    [anon_sym_RPAREN] = ACTIONS(13829),
    [sym_comment] = ACTIONS(87),
  },
  [9218] = {
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [anon_sym_LBRACE] = ACTIONS(12249),
    [anon_sym_RBRACE] = ACTIONS(12249),
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_if] = ACTIONS(12249),
    [anon_sym_unless] = ACTIONS(12249),
    [anon_sym_while] = ACTIONS(12249),
    [anon_sym_until] = ACTIONS(12249),
    [anon_sym_rescue] = ACTIONS(12249),
    [anon_sym_do] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_COLON2] = ACTIONS(12251),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [9219] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_STAR_STAR] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_if] = ACTIONS(2947),
    [anon_sym_unless] = ACTIONS(2947),
    [anon_sym_while] = ACTIONS(2947),
    [anon_sym_until] = ACTIONS(2947),
    [anon_sym_rescue] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(87),
  },
  [9220] = {
    [sym__heredoc_body_start2] = ACTIONS(2959),
    [sym__binary_minus2] = ACTIONS(2959),
    [sym__binary_star2] = ACTIONS(2959),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_STAR_STAR] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_if] = ACTIONS(2959),
    [anon_sym_unless] = ACTIONS(2959),
    [anon_sym_while] = ACTIONS(2959),
    [anon_sym_until] = ACTIONS(2959),
    [anon_sym_rescue] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2959),
    [anon_sym_do] = ACTIONS(2959),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_COLON_COLON2] = ACTIONS(2959),
    [anon_sym_AMP_DOT] = ACTIONS(2959),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2959),
    [anon_sym_COLON2] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2961),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2961),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ_GT] = ACTIONS(2959),
    [anon_sym_EQ_TILDE] = ACTIONS(2959),
    [anon_sym_BANG_TILDE] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2961),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [sym_comment] = ACTIONS(87),
  },
  [9221] = {
    [sym__heredoc_body_start2] = ACTIONS(2963),
    [sym__binary_minus2] = ACTIONS(2963),
    [sym__binary_star2] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_STAR_STAR] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_if] = ACTIONS(2963),
    [anon_sym_unless] = ACTIONS(2963),
    [anon_sym_while] = ACTIONS(2963),
    [anon_sym_until] = ACTIONS(2963),
    [anon_sym_rescue] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_do] = ACTIONS(2963),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON_COLON2] = ACTIONS(2963),
    [anon_sym_AMP_DOT] = ACTIONS(2963),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2963),
    [anon_sym_COLON2] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2965),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2965),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ_GT] = ACTIONS(2963),
    [anon_sym_EQ_TILDE] = ACTIONS(2963),
    [anon_sym_BANG_TILDE] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [sym_comment] = ACTIONS(87),
  },
  [9222] = {
    [sym__heredoc_body_start2] = ACTIONS(2967),
    [sym__binary_minus2] = ACTIONS(2967),
    [sym__binary_star2] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_DOT] = ACTIONS(2969),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_PIPE] = ACTIONS(2969),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_STAR_STAR] = ACTIONS(2969),
    [anon_sym_AMP] = ACTIONS(2969),
    [anon_sym_EQ] = ACTIONS(2969),
    [anon_sym_LT] = ACTIONS(2969),
    [anon_sym_if] = ACTIONS(2967),
    [anon_sym_unless] = ACTIONS(2967),
    [anon_sym_while] = ACTIONS(2967),
    [anon_sym_until] = ACTIONS(2967),
    [anon_sym_rescue] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2967),
    [anon_sym_do] = ACTIONS(2967),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_COLON_COLON2] = ACTIONS(2967),
    [anon_sym_AMP_DOT] = ACTIONS(2967),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_QMARK] = ACTIONS(2967),
    [anon_sym_COLON2] = ACTIONS(2969),
    [anon_sym_DOT_DOT] = ACTIONS(2969),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2967),
    [anon_sym_and] = ACTIONS(2967),
    [anon_sym_or] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2969),
    [anon_sym_AMP_AMP] = ACTIONS(2969),
    [anon_sym_LT_LT] = ACTIONS(2969),
    [anon_sym_GT_GT] = ACTIONS(2969),
    [anon_sym_EQ_EQ] = ACTIONS(2969),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ_GT] = ACTIONS(2967),
    [anon_sym_EQ_TILDE] = ACTIONS(2967),
    [anon_sym_BANG_TILDE] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2969),
    [anon_sym_GT] = ACTIONS(2969),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_CARET] = ACTIONS(2969),
    [anon_sym_PLUS] = ACTIONS(2969),
    [anon_sym_SLASH] = ACTIONS(2969),
    [anon_sym_PERCENT] = ACTIONS(2969),
    [sym_comment] = ACTIONS(87),
  },
  [9223] = {
    [sym__heredoc_body_start2] = ACTIONS(2973),
    [sym__binary_minus2] = ACTIONS(2973),
    [sym__binary_star2] = ACTIONS(2973),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_DOT] = ACTIONS(2975),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_PIPE] = ACTIONS(2975),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_STAR_STAR] = ACTIONS(2975),
    [anon_sym_AMP] = ACTIONS(2975),
    [anon_sym_EQ] = ACTIONS(2975),
    [anon_sym_LT] = ACTIONS(2975),
    [anon_sym_if] = ACTIONS(2973),
    [anon_sym_unless] = ACTIONS(2973),
    [anon_sym_while] = ACTIONS(2973),
    [anon_sym_until] = ACTIONS(2973),
    [anon_sym_rescue] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2973),
    [anon_sym_do] = ACTIONS(2973),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_RBRACK] = ACTIONS(2973),
    [anon_sym_COLON_COLON2] = ACTIONS(2973),
    [anon_sym_AMP_DOT] = ACTIONS(2973),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_QMARK] = ACTIONS(2973),
    [anon_sym_COLON2] = ACTIONS(2975),
    [anon_sym_DOT_DOT] = ACTIONS(2975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2973),
    [anon_sym_and] = ACTIONS(2973),
    [anon_sym_or] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2975),
    [anon_sym_AMP_AMP] = ACTIONS(2975),
    [anon_sym_LT_LT] = ACTIONS(2975),
    [anon_sym_GT_GT] = ACTIONS(2975),
    [anon_sym_EQ_EQ] = ACTIONS(2975),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ_GT] = ACTIONS(2973),
    [anon_sym_EQ_TILDE] = ACTIONS(2973),
    [anon_sym_BANG_TILDE] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2975),
    [anon_sym_GT] = ACTIONS(2975),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_CARET] = ACTIONS(2975),
    [anon_sym_PLUS] = ACTIONS(2975),
    [anon_sym_SLASH] = ACTIONS(2975),
    [anon_sym_PERCENT] = ACTIONS(2975),
    [sym_comment] = ACTIONS(87),
  },
  [9224] = {
    [sym__string_end2] = ACTIONS(13831),
    [sym_comment] = ACTIONS(87),
  },
  [9225] = {
    [aux_sym_string_array_repeat1] = STATE(10626),
    [sym__string_end2] = ACTIONS(13833),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13835),
  },
  [9226] = {
    [sym__heredoc_body_start2] = ACTIONS(2983),
    [sym__binary_minus2] = ACTIONS(2983),
    [sym__binary_star2] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2983),
    [anon_sym_RBRACE] = ACTIONS(2983),
    [anon_sym_RPAREN] = ACTIONS(2983),
    [anon_sym_DOT] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(2983),
    [anon_sym_PIPE] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(2983),
    [anon_sym_STAR_STAR] = ACTIONS(2985),
    [anon_sym_AMP] = ACTIONS(2985),
    [anon_sym_EQ] = ACTIONS(2985),
    [anon_sym_LT] = ACTIONS(2985),
    [anon_sym_if] = ACTIONS(2983),
    [anon_sym_unless] = ACTIONS(2983),
    [anon_sym_while] = ACTIONS(2983),
    [anon_sym_until] = ACTIONS(2983),
    [anon_sym_rescue] = ACTIONS(2983),
    [anon_sym_in] = ACTIONS(2983),
    [anon_sym_do] = ACTIONS(2983),
    [anon_sym_LBRACK] = ACTIONS(2983),
    [anon_sym_RBRACK] = ACTIONS(2983),
    [anon_sym_COLON_COLON2] = ACTIONS(2983),
    [anon_sym_AMP_DOT] = ACTIONS(2983),
    [anon_sym_PLUS_EQ] = ACTIONS(2983),
    [anon_sym_DASH_EQ] = ACTIONS(2983),
    [anon_sym_STAR_EQ] = ACTIONS(2983),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2983),
    [anon_sym_SLASH_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_PIPE_EQ] = ACTIONS(2983),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2983),
    [anon_sym_AMP_EQ] = ACTIONS(2983),
    [anon_sym_PERCENT_EQ] = ACTIONS(2983),
    [anon_sym_GT_GT_EQ] = ACTIONS(2983),
    [anon_sym_LT_LT_EQ] = ACTIONS(2983),
    [anon_sym_CARET_EQ] = ACTIONS(2983),
    [anon_sym_QMARK] = ACTIONS(2983),
    [anon_sym_COLON2] = ACTIONS(2985),
    [anon_sym_DOT_DOT] = ACTIONS(2985),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2983),
    [anon_sym_and] = ACTIONS(2983),
    [anon_sym_or] = ACTIONS(2983),
    [anon_sym_PIPE_PIPE] = ACTIONS(2985),
    [anon_sym_AMP_AMP] = ACTIONS(2985),
    [anon_sym_LT_LT] = ACTIONS(2985),
    [anon_sym_GT_GT] = ACTIONS(2985),
    [anon_sym_EQ_EQ] = ACTIONS(2985),
    [anon_sym_BANG_EQ] = ACTIONS(2983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2983),
    [anon_sym_LT_EQ_GT] = ACTIONS(2983),
    [anon_sym_EQ_TILDE] = ACTIONS(2983),
    [anon_sym_BANG_TILDE] = ACTIONS(2983),
    [anon_sym_LT_EQ] = ACTIONS(2985),
    [anon_sym_GT] = ACTIONS(2985),
    [anon_sym_GT_EQ] = ACTIONS(2983),
    [anon_sym_CARET] = ACTIONS(2985),
    [anon_sym_PLUS] = ACTIONS(2985),
    [anon_sym_SLASH] = ACTIONS(2985),
    [anon_sym_PERCENT] = ACTIONS(2985),
    [sym_comment] = ACTIONS(87),
  },
  [9227] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13837),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9228] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(13837),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13839),
  },
  [9229] = {
    [sym__heredoc_body_start2] = ACTIONS(3002),
    [sym__binary_minus2] = ACTIONS(3002),
    [sym__binary_star2] = ACTIONS(3002),
    [anon_sym_LBRACE] = ACTIONS(3002),
    [anon_sym_RBRACE] = ACTIONS(3002),
    [anon_sym_RPAREN] = ACTIONS(3002),
    [anon_sym_DOT] = ACTIONS(3004),
    [anon_sym_COMMA] = ACTIONS(3002),
    [anon_sym_PIPE] = ACTIONS(3004),
    [anon_sym_SEMI] = ACTIONS(3002),
    [anon_sym_STAR_STAR] = ACTIONS(3004),
    [anon_sym_AMP] = ACTIONS(3004),
    [anon_sym_EQ] = ACTIONS(3004),
    [anon_sym_LT] = ACTIONS(3004),
    [anon_sym_if] = ACTIONS(3002),
    [anon_sym_unless] = ACTIONS(3002),
    [anon_sym_while] = ACTIONS(3002),
    [anon_sym_until] = ACTIONS(3002),
    [anon_sym_rescue] = ACTIONS(3002),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_do] = ACTIONS(3002),
    [anon_sym_LBRACK] = ACTIONS(3002),
    [anon_sym_RBRACK] = ACTIONS(3002),
    [anon_sym_COLON_COLON2] = ACTIONS(3002),
    [anon_sym_AMP_DOT] = ACTIONS(3002),
    [anon_sym_PLUS_EQ] = ACTIONS(3002),
    [anon_sym_DASH_EQ] = ACTIONS(3002),
    [anon_sym_STAR_EQ] = ACTIONS(3002),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3002),
    [anon_sym_SLASH_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_PIPE_EQ] = ACTIONS(3002),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3002),
    [anon_sym_AMP_EQ] = ACTIONS(3002),
    [anon_sym_PERCENT_EQ] = ACTIONS(3002),
    [anon_sym_GT_GT_EQ] = ACTIONS(3002),
    [anon_sym_LT_LT_EQ] = ACTIONS(3002),
    [anon_sym_CARET_EQ] = ACTIONS(3002),
    [anon_sym_QMARK] = ACTIONS(3002),
    [anon_sym_COLON2] = ACTIONS(3004),
    [anon_sym_DOT_DOT] = ACTIONS(3004),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3002),
    [anon_sym_and] = ACTIONS(3002),
    [anon_sym_or] = ACTIONS(3002),
    [anon_sym_PIPE_PIPE] = ACTIONS(3004),
    [anon_sym_AMP_AMP] = ACTIONS(3004),
    [anon_sym_LT_LT] = ACTIONS(3004),
    [anon_sym_GT_GT] = ACTIONS(3004),
    [anon_sym_EQ_EQ] = ACTIONS(3004),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3002),
    [anon_sym_LT_EQ_GT] = ACTIONS(3002),
    [anon_sym_EQ_TILDE] = ACTIONS(3002),
    [anon_sym_BANG_TILDE] = ACTIONS(3002),
    [anon_sym_LT_EQ] = ACTIONS(3004),
    [anon_sym_GT] = ACTIONS(3004),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_CARET] = ACTIONS(3004),
    [anon_sym_PLUS] = ACTIONS(3004),
    [anon_sym_SLASH] = ACTIONS(3004),
    [anon_sym_PERCENT] = ACTIONS(3004),
    [sym_comment] = ACTIONS(87),
  },
  [9230] = {
    [sym__string_end2] = ACTIONS(13841),
    [sym_comment] = ACTIONS(87),
  },
  [9231] = {
    [aux_sym_symbol_array_repeat1] = STATE(10632),
    [sym__string_end2] = ACTIONS(13843),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13845),
  },
  [9232] = {
    [sym__heredoc_body_start2] = ACTIONS(3012),
    [sym__binary_minus2] = ACTIONS(3012),
    [sym__binary_star2] = ACTIONS(3012),
    [anon_sym_LBRACE] = ACTIONS(3012),
    [anon_sym_RBRACE] = ACTIONS(3012),
    [anon_sym_RPAREN] = ACTIONS(3012),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3012),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3012),
    [anon_sym_STAR_STAR] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_if] = ACTIONS(3012),
    [anon_sym_unless] = ACTIONS(3012),
    [anon_sym_while] = ACTIONS(3012),
    [anon_sym_until] = ACTIONS(3012),
    [anon_sym_rescue] = ACTIONS(3012),
    [anon_sym_in] = ACTIONS(3012),
    [anon_sym_do] = ACTIONS(3012),
    [anon_sym_LBRACK] = ACTIONS(3012),
    [anon_sym_RBRACK] = ACTIONS(3012),
    [anon_sym_COLON_COLON2] = ACTIONS(3012),
    [anon_sym_AMP_DOT] = ACTIONS(3012),
    [anon_sym_PLUS_EQ] = ACTIONS(3012),
    [anon_sym_DASH_EQ] = ACTIONS(3012),
    [anon_sym_STAR_EQ] = ACTIONS(3012),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3012),
    [anon_sym_SLASH_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_PIPE_EQ] = ACTIONS(3012),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3012),
    [anon_sym_AMP_EQ] = ACTIONS(3012),
    [anon_sym_PERCENT_EQ] = ACTIONS(3012),
    [anon_sym_GT_GT_EQ] = ACTIONS(3012),
    [anon_sym_LT_LT_EQ] = ACTIONS(3012),
    [anon_sym_CARET_EQ] = ACTIONS(3012),
    [anon_sym_QMARK] = ACTIONS(3012),
    [anon_sym_COLON2] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3014),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3012),
    [anon_sym_and] = ACTIONS(3012),
    [anon_sym_or] = ACTIONS(3012),
    [anon_sym_PIPE_PIPE] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3014),
    [anon_sym_BANG_EQ] = ACTIONS(3012),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3012),
    [anon_sym_LT_EQ_GT] = ACTIONS(3012),
    [anon_sym_EQ_TILDE] = ACTIONS(3012),
    [anon_sym_BANG_TILDE] = ACTIONS(3012),
    [anon_sym_LT_EQ] = ACTIONS(3014),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_GT_EQ] = ACTIONS(3012),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [sym_comment] = ACTIONS(87),
  },
  [9233] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13847),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9234] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(13847),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(13849),
  },
  [9235] = {
    [sym__heredoc_body_start2] = ACTIONS(3504),
    [sym__binary_minus2] = ACTIONS(3504),
    [sym__binary_star2] = ACTIONS(3504),
    [anon_sym_LBRACE] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3504),
    [anon_sym_RPAREN] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3506),
    [anon_sym_COMMA] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3506),
    [anon_sym_SEMI] = ACTIONS(3504),
    [anon_sym_STAR_STAR] = ACTIONS(3506),
    [anon_sym_AMP] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3506),
    [anon_sym_LT] = ACTIONS(3506),
    [anon_sym_if] = ACTIONS(3504),
    [anon_sym_unless] = ACTIONS(3504),
    [anon_sym_while] = ACTIONS(3504),
    [anon_sym_until] = ACTIONS(3504),
    [anon_sym_rescue] = ACTIONS(3504),
    [anon_sym_in] = ACTIONS(3504),
    [anon_sym_do] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3504),
    [anon_sym_RBRACK] = ACTIONS(3504),
    [anon_sym_COLON_COLON2] = ACTIONS(3504),
    [anon_sym_AMP_DOT] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3504),
    [anon_sym_DASH_EQ] = ACTIONS(3504),
    [anon_sym_STAR_EQ] = ACTIONS(3504),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3504),
    [anon_sym_SLASH_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_PIPE_EQ] = ACTIONS(3504),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3504),
    [anon_sym_AMP_EQ] = ACTIONS(3504),
    [anon_sym_PERCENT_EQ] = ACTIONS(3504),
    [anon_sym_GT_GT_EQ] = ACTIONS(3504),
    [anon_sym_LT_LT_EQ] = ACTIONS(3504),
    [anon_sym_CARET_EQ] = ACTIONS(3504),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_COLON2] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3504),
    [anon_sym_and] = ACTIONS(3504),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_LT_LT] = ACTIONS(3506),
    [anon_sym_GT_GT] = ACTIONS(3506),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3504),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3504),
    [anon_sym_LT_EQ_GT] = ACTIONS(3504),
    [anon_sym_EQ_TILDE] = ACTIONS(3504),
    [anon_sym_BANG_TILDE] = ACTIONS(3504),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3506),
    [anon_sym_SLASH] = ACTIONS(3506),
    [anon_sym_PERCENT] = ACTIONS(3506),
    [sym_comment] = ACTIONS(87),
  },
  [9236] = {
    [anon_sym_RBRACE] = ACTIONS(13851),
    [sym_comment] = ACTIONS(87),
  },
  [9237] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(13853),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(3558),
    [anon_sym_or] = ACTIONS(3558),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [9238] = {
    [sym__method_rest] = STATE(10637),
    [sym_operator] = STATE(6889),
    [sym__method_name] = STATE(6889),
    [sym_setter] = STATE(6889),
    [sym_symbol] = STATE(6889),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13855),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13855),
    [sym_class_variable] = ACTIONS(13855),
    [sym_global_variable] = ACTIONS(13855),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [9239] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(10638),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13857),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9240] = {
    [sym__heredoc_body_start2] = ACTIONS(3744),
    [sym__binary_minus2] = ACTIONS(3744),
    [sym__binary_star2] = ACTIONS(3744),
    [anon_sym_LBRACE] = ACTIONS(3744),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_RPAREN] = ACTIONS(3744),
    [anon_sym_DOT] = ACTIONS(3746),
    [anon_sym_COMMA] = ACTIONS(3744),
    [anon_sym_PIPE] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3744),
    [anon_sym_STAR_STAR] = ACTIONS(3746),
    [anon_sym_AMP] = ACTIONS(3746),
    [anon_sym_EQ] = ACTIONS(3746),
    [anon_sym_LT] = ACTIONS(3746),
    [anon_sym_if] = ACTIONS(3744),
    [anon_sym_unless] = ACTIONS(3744),
    [anon_sym_while] = ACTIONS(3744),
    [anon_sym_until] = ACTIONS(3744),
    [anon_sym_rescue] = ACTIONS(3744),
    [anon_sym_in] = ACTIONS(3744),
    [anon_sym_do] = ACTIONS(3744),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_RBRACK] = ACTIONS(3744),
    [anon_sym_COLON_COLON2] = ACTIONS(3744),
    [anon_sym_AMP_DOT] = ACTIONS(3744),
    [anon_sym_PLUS_EQ] = ACTIONS(3744),
    [anon_sym_DASH_EQ] = ACTIONS(3744),
    [anon_sym_STAR_EQ] = ACTIONS(3744),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3744),
    [anon_sym_SLASH_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_PIPE_EQ] = ACTIONS(3744),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3744),
    [anon_sym_AMP_EQ] = ACTIONS(3744),
    [anon_sym_PERCENT_EQ] = ACTIONS(3744),
    [anon_sym_GT_GT_EQ] = ACTIONS(3744),
    [anon_sym_LT_LT_EQ] = ACTIONS(3744),
    [anon_sym_CARET_EQ] = ACTIONS(3744),
    [anon_sym_QMARK] = ACTIONS(3744),
    [anon_sym_COLON2] = ACTIONS(3746),
    [anon_sym_DOT_DOT] = ACTIONS(3746),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3744),
    [anon_sym_and] = ACTIONS(3744),
    [anon_sym_or] = ACTIONS(3744),
    [anon_sym_PIPE_PIPE] = ACTIONS(3746),
    [anon_sym_AMP_AMP] = ACTIONS(3746),
    [anon_sym_LT_LT] = ACTIONS(3746),
    [anon_sym_GT_GT] = ACTIONS(3746),
    [anon_sym_EQ_EQ] = ACTIONS(3746),
    [anon_sym_BANG_EQ] = ACTIONS(3744),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3744),
    [anon_sym_LT_EQ_GT] = ACTIONS(3744),
    [anon_sym_EQ_TILDE] = ACTIONS(3744),
    [anon_sym_BANG_TILDE] = ACTIONS(3744),
    [anon_sym_LT_EQ] = ACTIONS(3746),
    [anon_sym_GT] = ACTIONS(3746),
    [anon_sym_GT_EQ] = ACTIONS(3744),
    [anon_sym_CARET] = ACTIONS(3746),
    [anon_sym_PLUS] = ACTIONS(3746),
    [anon_sym_SLASH] = ACTIONS(3746),
    [anon_sym_PERCENT] = ACTIONS(3746),
    [sym_comment] = ACTIONS(87),
  },
  [9241] = {
    [sym_heredoc_body] = STATE(10639),
    [sym__terminator] = STATE(10639),
    [sym__line_break2] = ACTIONS(13859),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym__binary_minus2] = ACTIONS(2033),
    [sym__binary_star2] = ACTIONS(2035),
    [anon_sym_PIPE] = ACTIONS(2037),
    [anon_sym_SEMI] = ACTIONS(13859),
    [anon_sym_STAR_STAR] = ACTIONS(2039),
    [anon_sym_AMP] = ACTIONS(2041),
    [anon_sym_LT] = ACTIONS(2043),
    [anon_sym_QMARK] = ACTIONS(2045),
    [anon_sym_DOT_DOT] = ACTIONS(2047),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2049),
    [anon_sym_and] = ACTIONS(2051),
    [anon_sym_or] = ACTIONS(2051),
    [anon_sym_PIPE_PIPE] = ACTIONS(2053),
    [anon_sym_AMP_AMP] = ACTIONS(2053),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_EQ_EQ] = ACTIONS(2057),
    [anon_sym_BANG_EQ] = ACTIONS(2053),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2053),
    [anon_sym_LT_EQ_GT] = ACTIONS(2053),
    [anon_sym_EQ_TILDE] = ACTIONS(2053),
    [anon_sym_BANG_TILDE] = ACTIONS(2053),
    [anon_sym_LT_EQ] = ACTIONS(2043),
    [anon_sym_GT] = ACTIONS(2043),
    [anon_sym_GT_EQ] = ACTIONS(2059),
    [anon_sym_CARET] = ACTIONS(2061),
    [anon_sym_PLUS] = ACTIONS(2063),
    [anon_sym_SLASH] = ACTIONS(2039),
    [anon_sym_PERCENT] = ACTIONS(2039),
    [sym_comment] = ACTIONS(87),
  },
  [9242] = {
    [sym_heredoc_body] = STATE(10640),
    [sym__terminator] = STATE(10640),
    [sym__line_break2] = ACTIONS(13861),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13861),
    [sym_comment] = ACTIONS(87),
  },
  [9243] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(10641),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13863),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9244] = {
    [sym__heredoc_body_start2] = ACTIONS(4158),
    [sym__binary_minus2] = ACTIONS(4158),
    [sym__binary_star2] = ACTIONS(4158),
    [anon_sym_LBRACE] = ACTIONS(4158),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_RPAREN] = ACTIONS(4158),
    [anon_sym_DOT] = ACTIONS(4160),
    [anon_sym_COMMA] = ACTIONS(4158),
    [anon_sym_PIPE] = ACTIONS(4160),
    [anon_sym_SEMI] = ACTIONS(4158),
    [anon_sym_STAR_STAR] = ACTIONS(4160),
    [anon_sym_AMP] = ACTIONS(4160),
    [anon_sym_EQ] = ACTIONS(4160),
    [anon_sym_LT] = ACTIONS(4160),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_unless] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_until] = ACTIONS(4158),
    [anon_sym_rescue] = ACTIONS(4158),
    [anon_sym_in] = ACTIONS(4158),
    [anon_sym_do] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_RBRACK] = ACTIONS(4158),
    [anon_sym_COLON_COLON2] = ACTIONS(4158),
    [anon_sym_AMP_DOT] = ACTIONS(4158),
    [anon_sym_PLUS_EQ] = ACTIONS(4158),
    [anon_sym_DASH_EQ] = ACTIONS(4158),
    [anon_sym_STAR_EQ] = ACTIONS(4158),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4158),
    [anon_sym_SLASH_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_PIPE_EQ] = ACTIONS(4158),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4158),
    [anon_sym_AMP_EQ] = ACTIONS(4158),
    [anon_sym_PERCENT_EQ] = ACTIONS(4158),
    [anon_sym_GT_GT_EQ] = ACTIONS(4158),
    [anon_sym_LT_LT_EQ] = ACTIONS(4158),
    [anon_sym_CARET_EQ] = ACTIONS(4158),
    [anon_sym_QMARK] = ACTIONS(4158),
    [anon_sym_COLON2] = ACTIONS(4160),
    [anon_sym_DOT_DOT] = ACTIONS(4160),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4158),
    [anon_sym_and] = ACTIONS(4158),
    [anon_sym_or] = ACTIONS(4158),
    [anon_sym_PIPE_PIPE] = ACTIONS(4160),
    [anon_sym_AMP_AMP] = ACTIONS(4160),
    [anon_sym_LT_LT] = ACTIONS(4160),
    [anon_sym_GT_GT] = ACTIONS(4160),
    [anon_sym_EQ_EQ] = ACTIONS(4160),
    [anon_sym_BANG_EQ] = ACTIONS(4158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4158),
    [anon_sym_LT_EQ_GT] = ACTIONS(4158),
    [anon_sym_EQ_TILDE] = ACTIONS(4158),
    [anon_sym_BANG_TILDE] = ACTIONS(4158),
    [anon_sym_LT_EQ] = ACTIONS(4160),
    [anon_sym_GT] = ACTIONS(4160),
    [anon_sym_GT_EQ] = ACTIONS(4158),
    [anon_sym_CARET] = ACTIONS(4160),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_SLASH] = ACTIONS(4160),
    [anon_sym_PERCENT] = ACTIONS(4160),
    [sym_comment] = ACTIONS(87),
  },
  [9245] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(10642),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13865),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9246] = {
    [sym__statements] = STATE(10644),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(10645),
    [sym_else] = STATE(10645),
    [sym__if_tail] = STATE(10645),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(10646),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(10646),
    [sym__line_break2] = ACTIONS(13867),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13869),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9247] = {
    [sym__statements] = STATE(10648),
    [sym__top_level_statement] = STATE(2851),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(10649),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13871),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9248] = {
    [sym__statements] = STATE(10651),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13873),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9249] = {
    [sym__statements] = STATE(10653),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13875),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9250] = {
    [sym__do] = STATE(10654),
    [sym_heredoc_body] = STATE(10654),
    [sym__terminator] = STATE(10654),
    [sym__line_break2] = ACTIONS(13877),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(13877),
    [anon_sym_do] = ACTIONS(13877),
    [sym_comment] = ACTIONS(87),
  },
  [9251] = {
    [sym_when] = STATE(10655),
    [aux_sym_case_repeat1] = STATE(10656),
    [anon_sym_SEMI] = ACTIONS(13879),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [9252] = {
    [anon_sym_end] = ACTIONS(13881),
    [sym_comment] = ACTIONS(87),
  },
  [9253] = {
    [sym_when] = STATE(10655),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [9254] = {
    [sym__heredoc_body_start2] = ACTIONS(5410),
    [sym__binary_minus2] = ACTIONS(5410),
    [sym__binary_star2] = ACTIONS(5410),
    [anon_sym_LBRACE] = ACTIONS(5410),
    [anon_sym_RBRACE] = ACTIONS(5410),
    [anon_sym_RPAREN] = ACTIONS(5410),
    [anon_sym_DOT] = ACTIONS(5412),
    [anon_sym_COMMA] = ACTIONS(5410),
    [anon_sym_PIPE] = ACTIONS(5412),
    [anon_sym_SEMI] = ACTIONS(5410),
    [anon_sym_STAR_STAR] = ACTIONS(5412),
    [anon_sym_AMP] = ACTIONS(5412),
    [anon_sym_EQ] = ACTIONS(5412),
    [anon_sym_LT] = ACTIONS(5412),
    [anon_sym_if] = ACTIONS(5410),
    [anon_sym_unless] = ACTIONS(5410),
    [anon_sym_while] = ACTIONS(5410),
    [anon_sym_until] = ACTIONS(5410),
    [anon_sym_rescue] = ACTIONS(5410),
    [anon_sym_in] = ACTIONS(5410),
    [anon_sym_do] = ACTIONS(5410),
    [anon_sym_LBRACK] = ACTIONS(5410),
    [anon_sym_RBRACK] = ACTIONS(5410),
    [anon_sym_COLON_COLON2] = ACTIONS(5410),
    [anon_sym_AMP_DOT] = ACTIONS(5410),
    [anon_sym_PLUS_EQ] = ACTIONS(5410),
    [anon_sym_DASH_EQ] = ACTIONS(5410),
    [anon_sym_STAR_EQ] = ACTIONS(5410),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5410),
    [anon_sym_SLASH_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_PIPE_EQ] = ACTIONS(5410),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5410),
    [anon_sym_AMP_EQ] = ACTIONS(5410),
    [anon_sym_PERCENT_EQ] = ACTIONS(5410),
    [anon_sym_GT_GT_EQ] = ACTIONS(5410),
    [anon_sym_LT_LT_EQ] = ACTIONS(5410),
    [anon_sym_CARET_EQ] = ACTIONS(5410),
    [anon_sym_QMARK] = ACTIONS(5410),
    [anon_sym_COLON2] = ACTIONS(5412),
    [anon_sym_DOT_DOT] = ACTIONS(5412),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5410),
    [anon_sym_and] = ACTIONS(5410),
    [anon_sym_or] = ACTIONS(5410),
    [anon_sym_PIPE_PIPE] = ACTIONS(5412),
    [anon_sym_AMP_AMP] = ACTIONS(5412),
    [anon_sym_LT_LT] = ACTIONS(5412),
    [anon_sym_GT_GT] = ACTIONS(5412),
    [anon_sym_EQ_EQ] = ACTIONS(5412),
    [anon_sym_BANG_EQ] = ACTIONS(5410),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5410),
    [anon_sym_LT_EQ_GT] = ACTIONS(5410),
    [anon_sym_EQ_TILDE] = ACTIONS(5410),
    [anon_sym_BANG_TILDE] = ACTIONS(5410),
    [anon_sym_LT_EQ] = ACTIONS(5412),
    [anon_sym_GT] = ACTIONS(5412),
    [anon_sym_GT_EQ] = ACTIONS(5410),
    [anon_sym_CARET] = ACTIONS(5412),
    [anon_sym_PLUS] = ACTIONS(5412),
    [anon_sym_SLASH] = ACTIONS(5412),
    [anon_sym_PERCENT] = ACTIONS(5412),
    [sym_comment] = ACTIONS(87),
  },
  [9255] = {
    [sym_ensure] = STATE(10659),
    [anon_sym_end] = ACTIONS(13883),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [9256] = {
    [anon_sym_end] = ACTIONS(13883),
    [sym_comment] = ACTIONS(87),
  },
  [9257] = {
    [sym_else] = STATE(10660),
    [sym_ensure] = STATE(10659),
    [anon_sym_end] = ACTIONS(13883),
    [anon_sym_else] = ACTIONS(2203),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [9258] = {
    [sym__heredoc_body_start2] = ACTIONS(5498),
    [sym__binary_minus2] = ACTIONS(5498),
    [sym__binary_star2] = ACTIONS(5498),
    [anon_sym_LBRACE] = ACTIONS(5498),
    [anon_sym_RBRACE] = ACTIONS(5498),
    [anon_sym_RPAREN] = ACTIONS(5498),
    [anon_sym_DOT] = ACTIONS(5500),
    [anon_sym_COMMA] = ACTIONS(5498),
    [anon_sym_PIPE] = ACTIONS(5500),
    [anon_sym_SEMI] = ACTIONS(5498),
    [anon_sym_STAR_STAR] = ACTIONS(5500),
    [anon_sym_AMP] = ACTIONS(5500),
    [anon_sym_EQ] = ACTIONS(5500),
    [anon_sym_LT] = ACTIONS(5500),
    [anon_sym_if] = ACTIONS(5498),
    [anon_sym_unless] = ACTIONS(5498),
    [anon_sym_while] = ACTIONS(5498),
    [anon_sym_until] = ACTIONS(5498),
    [anon_sym_rescue] = ACTIONS(5498),
    [anon_sym_in] = ACTIONS(5498),
    [anon_sym_do] = ACTIONS(5498),
    [anon_sym_LBRACK] = ACTIONS(5498),
    [anon_sym_RBRACK] = ACTIONS(5498),
    [anon_sym_COLON_COLON2] = ACTIONS(5498),
    [anon_sym_AMP_DOT] = ACTIONS(5498),
    [anon_sym_PLUS_EQ] = ACTIONS(5498),
    [anon_sym_DASH_EQ] = ACTIONS(5498),
    [anon_sym_STAR_EQ] = ACTIONS(5498),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5498),
    [anon_sym_SLASH_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_PIPE_EQ] = ACTIONS(5498),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5498),
    [anon_sym_AMP_EQ] = ACTIONS(5498),
    [anon_sym_PERCENT_EQ] = ACTIONS(5498),
    [anon_sym_GT_GT_EQ] = ACTIONS(5498),
    [anon_sym_LT_LT_EQ] = ACTIONS(5498),
    [anon_sym_CARET_EQ] = ACTIONS(5498),
    [anon_sym_QMARK] = ACTIONS(5498),
    [anon_sym_COLON2] = ACTIONS(5500),
    [anon_sym_DOT_DOT] = ACTIONS(5500),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5498),
    [anon_sym_and] = ACTIONS(5498),
    [anon_sym_or] = ACTIONS(5498),
    [anon_sym_PIPE_PIPE] = ACTIONS(5500),
    [anon_sym_AMP_AMP] = ACTIONS(5500),
    [anon_sym_LT_LT] = ACTIONS(5500),
    [anon_sym_GT_GT] = ACTIONS(5500),
    [anon_sym_EQ_EQ] = ACTIONS(5500),
    [anon_sym_BANG_EQ] = ACTIONS(5498),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5498),
    [anon_sym_LT_EQ_GT] = ACTIONS(5498),
    [anon_sym_EQ_TILDE] = ACTIONS(5498),
    [anon_sym_BANG_TILDE] = ACTIONS(5498),
    [anon_sym_LT_EQ] = ACTIONS(5500),
    [anon_sym_GT] = ACTIONS(5500),
    [anon_sym_GT_EQ] = ACTIONS(5498),
    [anon_sym_CARET] = ACTIONS(5500),
    [anon_sym_PLUS] = ACTIONS(5500),
    [anon_sym_SLASH] = ACTIONS(5500),
    [anon_sym_PERCENT] = ACTIONS(5500),
    [sym_comment] = ACTIONS(87),
  },
  [9259] = {
    [sym__heredoc_body_start2] = ACTIONS(5738),
    [sym__binary_minus2] = ACTIONS(5738),
    [sym__binary_star2] = ACTIONS(5738),
    [anon_sym_LBRACE] = ACTIONS(5738),
    [anon_sym_RBRACE] = ACTIONS(5738),
    [anon_sym_RPAREN] = ACTIONS(5738),
    [anon_sym_DOT] = ACTIONS(5740),
    [anon_sym_COMMA] = ACTIONS(5738),
    [anon_sym_PIPE] = ACTIONS(5740),
    [anon_sym_SEMI] = ACTIONS(5738),
    [anon_sym_STAR_STAR] = ACTIONS(5740),
    [anon_sym_AMP] = ACTIONS(5740),
    [anon_sym_EQ] = ACTIONS(5740),
    [anon_sym_LT] = ACTIONS(5740),
    [anon_sym_if] = ACTIONS(5738),
    [anon_sym_unless] = ACTIONS(5738),
    [anon_sym_while] = ACTIONS(5738),
    [anon_sym_until] = ACTIONS(5738),
    [anon_sym_rescue] = ACTIONS(5738),
    [anon_sym_in] = ACTIONS(5738),
    [anon_sym_do] = ACTIONS(5738),
    [anon_sym_LBRACK] = ACTIONS(5738),
    [anon_sym_RBRACK] = ACTIONS(5738),
    [anon_sym_COLON_COLON2] = ACTIONS(5738),
    [anon_sym_AMP_DOT] = ACTIONS(5738),
    [anon_sym_PLUS_EQ] = ACTIONS(5738),
    [anon_sym_DASH_EQ] = ACTIONS(5738),
    [anon_sym_STAR_EQ] = ACTIONS(5738),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5738),
    [anon_sym_SLASH_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_PIPE_EQ] = ACTIONS(5738),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5738),
    [anon_sym_AMP_EQ] = ACTIONS(5738),
    [anon_sym_PERCENT_EQ] = ACTIONS(5738),
    [anon_sym_GT_GT_EQ] = ACTIONS(5738),
    [anon_sym_LT_LT_EQ] = ACTIONS(5738),
    [anon_sym_CARET_EQ] = ACTIONS(5738),
    [anon_sym_QMARK] = ACTIONS(5738),
    [anon_sym_COLON2] = ACTIONS(5740),
    [anon_sym_DOT_DOT] = ACTIONS(5740),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5738),
    [anon_sym_and] = ACTIONS(5738),
    [anon_sym_or] = ACTIONS(5738),
    [anon_sym_PIPE_PIPE] = ACTIONS(5740),
    [anon_sym_AMP_AMP] = ACTIONS(5740),
    [anon_sym_LT_LT] = ACTIONS(5740),
    [anon_sym_GT_GT] = ACTIONS(5740),
    [anon_sym_EQ_EQ] = ACTIONS(5740),
    [anon_sym_BANG_EQ] = ACTIONS(5738),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5738),
    [anon_sym_LT_EQ_GT] = ACTIONS(5738),
    [anon_sym_EQ_TILDE] = ACTIONS(5738),
    [anon_sym_BANG_TILDE] = ACTIONS(5738),
    [anon_sym_LT_EQ] = ACTIONS(5740),
    [anon_sym_GT] = ACTIONS(5740),
    [anon_sym_GT_EQ] = ACTIONS(5738),
    [anon_sym_CARET] = ACTIONS(5740),
    [anon_sym_PLUS] = ACTIONS(5740),
    [anon_sym_SLASH] = ACTIONS(5740),
    [anon_sym_PERCENT] = ACTIONS(5740),
    [sym_comment] = ACTIONS(87),
  },
  [9260] = {
    [anon_sym_RBRACK] = ACTIONS(13885),
    [sym_comment] = ACTIONS(87),
  },
  [9261] = {
    [sym__heredoc_body_start2] = ACTIONS(5822),
    [sym__binary_minus2] = ACTIONS(5822),
    [sym__binary_star2] = ACTIONS(5822),
    [anon_sym_LBRACE] = ACTIONS(5822),
    [anon_sym_RBRACE] = ACTIONS(5822),
    [anon_sym_RPAREN] = ACTIONS(5822),
    [anon_sym_DOT] = ACTIONS(5824),
    [anon_sym_COMMA] = ACTIONS(5822),
    [anon_sym_PIPE] = ACTIONS(5824),
    [anon_sym_SEMI] = ACTIONS(5822),
    [anon_sym_STAR_STAR] = ACTIONS(5824),
    [anon_sym_AMP] = ACTIONS(5824),
    [anon_sym_EQ] = ACTIONS(5824),
    [anon_sym_LT] = ACTIONS(5824),
    [anon_sym_if] = ACTIONS(5822),
    [anon_sym_unless] = ACTIONS(5822),
    [anon_sym_while] = ACTIONS(5822),
    [anon_sym_until] = ACTIONS(5822),
    [anon_sym_rescue] = ACTIONS(5822),
    [anon_sym_in] = ACTIONS(5822),
    [anon_sym_do] = ACTIONS(5822),
    [anon_sym_LBRACK] = ACTIONS(5822),
    [anon_sym_RBRACK] = ACTIONS(5822),
    [anon_sym_COLON_COLON2] = ACTIONS(5822),
    [anon_sym_AMP_DOT] = ACTIONS(5822),
    [anon_sym_PLUS_EQ] = ACTIONS(5822),
    [anon_sym_DASH_EQ] = ACTIONS(5822),
    [anon_sym_STAR_EQ] = ACTIONS(5822),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5822),
    [anon_sym_SLASH_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_PIPE_EQ] = ACTIONS(5822),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5822),
    [anon_sym_AMP_EQ] = ACTIONS(5822),
    [anon_sym_PERCENT_EQ] = ACTIONS(5822),
    [anon_sym_GT_GT_EQ] = ACTIONS(5822),
    [anon_sym_LT_LT_EQ] = ACTIONS(5822),
    [anon_sym_CARET_EQ] = ACTIONS(5822),
    [anon_sym_QMARK] = ACTIONS(5822),
    [anon_sym_COLON2] = ACTIONS(5824),
    [anon_sym_DOT_DOT] = ACTIONS(5824),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5822),
    [anon_sym_and] = ACTIONS(5822),
    [anon_sym_or] = ACTIONS(5822),
    [anon_sym_PIPE_PIPE] = ACTIONS(5824),
    [anon_sym_AMP_AMP] = ACTIONS(5824),
    [anon_sym_LT_LT] = ACTIONS(5824),
    [anon_sym_GT_GT] = ACTIONS(5824),
    [anon_sym_EQ_EQ] = ACTIONS(5824),
    [anon_sym_BANG_EQ] = ACTIONS(5822),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5822),
    [anon_sym_LT_EQ_GT] = ACTIONS(5822),
    [anon_sym_EQ_TILDE] = ACTIONS(5822),
    [anon_sym_BANG_TILDE] = ACTIONS(5822),
    [anon_sym_LT_EQ] = ACTIONS(5824),
    [anon_sym_GT] = ACTIONS(5824),
    [anon_sym_GT_EQ] = ACTIONS(5822),
    [anon_sym_CARET] = ACTIONS(5824),
    [anon_sym_PLUS] = ACTIONS(5824),
    [anon_sym_SLASH] = ACTIONS(5824),
    [anon_sym_PERCENT] = ACTIONS(5824),
    [sym_comment] = ACTIONS(87),
  },
  [9262] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9263] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9264] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9265] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9266] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9267] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9268] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13887),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9269] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9270] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9271] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9272] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9273] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9274] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9275] = {
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9276] = {
    [aux_sym_exceptions_repeat1] = STATE(10664),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9277] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [9278] = {
    [sym_string] = STATE(9278),
    [aux_sym_chained_string_repeat1] = STATE(9278),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9279] = {
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_COLON2] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [9280] = {
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12098),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [9281] = {
    [anon_sym_end] = ACTIONS(13892),
    [sym_comment] = ACTIONS(87),
  },
  [9282] = {
    [sym__statements] = STATE(10666),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13894),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9283] = {
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10934),
    [anon_sym_unless] = ACTIONS(10934),
    [anon_sym_while] = ACTIONS(10934),
    [anon_sym_until] = ACTIONS(10934),
    [anon_sym_rescue] = ACTIONS(10934),
    [anon_sym_in] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_RBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [sym_comment] = ACTIONS(87),
  },
  [9284] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10667),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_assignment] = STATE(10667),
    [sym_operator_assignment] = STATE(10667),
    [sym_conditional] = STATE(10667),
    [sym_range] = STATE(10667),
    [sym_binary] = STATE(10667),
    [sym_unary] = STATE(10667),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9285] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_STAR_STAR] = ACTIONS(8705),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_if] = ACTIONS(6739),
    [anon_sym_unless] = ACTIONS(6739),
    [anon_sym_while] = ACTIONS(6739),
    [anon_sym_until] = ACTIONS(6739),
    [anon_sym_rescue] = ACTIONS(6739),
    [anon_sym_in] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_RBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_PLUS_EQ] = ACTIONS(6739),
    [anon_sym_DASH_EQ] = ACTIONS(6739),
    [anon_sym_STAR_EQ] = ACTIONS(6739),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6739),
    [anon_sym_SLASH_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_PIPE_EQ] = ACTIONS(6739),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6739),
    [anon_sym_AMP_EQ] = ACTIONS(6739),
    [anon_sym_PERCENT_EQ] = ACTIONS(6739),
    [anon_sym_GT_GT_EQ] = ACTIONS(6739),
    [anon_sym_LT_LT_EQ] = ACTIONS(6739),
    [anon_sym_CARET_EQ] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_COLON2] = ACTIONS(8705),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(8705),
    [anon_sym_AMP_AMP] = ACTIONS(8705),
    [anon_sym_LT_LT] = ACTIONS(8705),
    [anon_sym_GT_GT] = ACTIONS(8705),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(8705),
    [anon_sym_PLUS] = ACTIONS(8705),
    [anon_sym_SLASH] = ACTIONS(8705),
    [anon_sym_PERCENT] = ACTIONS(8705),
    [sym_comment] = ACTIONS(87),
  },
  [9286] = {
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_STAR_STAR] = ACTIONS(10964),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_if] = ACTIONS(10962),
    [anon_sym_unless] = ACTIONS(10962),
    [anon_sym_while] = ACTIONS(10962),
    [anon_sym_until] = ACTIONS(10962),
    [anon_sym_rescue] = ACTIONS(10962),
    [anon_sym_in] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_RBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_PLUS_EQ] = ACTIONS(10962),
    [anon_sym_DASH_EQ] = ACTIONS(10962),
    [anon_sym_STAR_EQ] = ACTIONS(10962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10962),
    [anon_sym_SLASH_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_PIPE_EQ] = ACTIONS(10962),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10962),
    [anon_sym_AMP_EQ] = ACTIONS(10962),
    [anon_sym_PERCENT_EQ] = ACTIONS(10962),
    [anon_sym_GT_GT_EQ] = ACTIONS(10962),
    [anon_sym_LT_LT_EQ] = ACTIONS(10962),
    [anon_sym_CARET_EQ] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_COLON2] = ACTIONS(10964),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10964),
    [anon_sym_AMP_AMP] = ACTIONS(10964),
    [anon_sym_LT_LT] = ACTIONS(10964),
    [anon_sym_GT_GT] = ACTIONS(10964),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10964),
    [anon_sym_PLUS] = ACTIONS(10964),
    [anon_sym_SLASH] = ACTIONS(10964),
    [anon_sym_PERCENT] = ACTIONS(10964),
    [sym_comment] = ACTIONS(87),
  },
  [9287] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6968),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1747),
    [sym_scope_resolution] = STATE(1741),
    [sym_call] = STATE(1741),
    [sym_method_call] = STATE(1747),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(6968),
    [sym_operator_assignment] = STATE(6968),
    [sym_conditional] = STATE(6968),
    [sym_range] = STATE(6968),
    [sym_binary] = STATE(6968),
    [sym_unary] = STATE(6968),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(1746),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1747),
    [sym__variable] = STATE(1741),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1747),
    [sym_false] = STATE(1747),
    [sym_nil] = STATE(1747),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4096),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(6329),
    [sym__unary_minus2] = ACTIONS(2909),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2917),
    [anon_sym_break] = ACTIONS(2919),
    [anon_sym_next] = ACTIONS(2921),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6437),
    [anon_sym_defined_QMARK] = ACTIONS(2927),
    [anon_sym_not] = ACTIONS(2929),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_TILDE] = ACTIONS(2933),
    [sym_constant] = ACTIONS(2939),
    [sym_identifier] = ACTIONS(2939),
    [sym_instance_variable] = ACTIONS(2937),
    [sym_class_variable] = ACTIONS(2937),
    [sym_global_variable] = ACTIONS(2937),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(2939),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(2939),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9288] = {
    [aux_sym_exceptions_repeat1] = STATE(10668),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13896),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9289] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9290] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9291] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9292] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9293] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9294] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9295] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13898),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9296] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9297] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9298] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9299] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9300] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9301] = {
    [aux_sym_exceptions_repeat1] = STATE(9301),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13900),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9302] = {
    [aux_sym_exceptions_repeat1] = STATE(6989),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9303] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [9304] = {
    [sym_string] = STATE(9304),
    [aux_sym_chained_string_repeat1] = STATE(9304),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9305] = {
    [sym_heredoc_body] = STATE(10670),
    [aux_sym_call_repeat1] = STATE(10670),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9306] = {
    [sym_heredoc_body] = STATE(10671),
    [aux_sym_call_repeat1] = STATE(10671),
    [aux_sym_argument_list_repeat1] = STATE(7034),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(6623),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9307] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9308] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9309] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9310] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9311] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9312] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9313] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13903),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9314] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9315] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9316] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9317] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9318] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9319] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9320] = {
    [aux_sym_exceptions_repeat1] = STATE(10674),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9321] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [9322] = {
    [sym_string] = STATE(9322),
    [aux_sym_chained_string_repeat1] = STATE(9322),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9323] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9324] = {
    [sym_heredoc_body] = STATE(9323),
    [aux_sym_call_repeat1] = STATE(9323),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9325] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10675),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_assignment] = STATE(10675),
    [sym_operator_assignment] = STATE(10675),
    [sym_conditional] = STATE(10675),
    [sym_range] = STATE(10675),
    [sym_binary] = STATE(10675),
    [sym_unary] = STATE(10675),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9326] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7035),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(1787),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(1787),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(7035),
    [sym_operator_assignment] = STATE(7035),
    [sym_conditional] = STATE(7035),
    [sym_range] = STATE(7035),
    [sym_binary] = STATE(7035),
    [sym_unary] = STATE(7035),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(1786),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1787),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(1787),
    [sym_false] = STATE(1787),
    [sym_nil] = STATE(1787),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(6098),
    [sym__unary_minus2] = ACTIONS(3028),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6585),
    [anon_sym_defined_QMARK] = ACTIONS(3040),
    [anon_sym_not] = ACTIONS(3042),
    [anon_sym_BANG] = ACTIONS(3046),
    [anon_sym_TILDE] = ACTIONS(3046),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9327] = {
    [aux_sym_exceptions_repeat1] = STATE(10676),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13905),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9328] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3066),
    [sym__binary_star2] = ACTIONS(3068),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3070),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(3072),
    [anon_sym_AMP] = ACTIONS(3074),
    [anon_sym_LT] = ACTIONS(3076),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(3078),
    [anon_sym_DOT_DOT] = ACTIONS(3080),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3082),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3086),
    [anon_sym_AMP_AMP] = ACTIONS(3086),
    [anon_sym_LT_LT] = ACTIONS(3088),
    [anon_sym_GT_GT] = ACTIONS(3088),
    [anon_sym_EQ_EQ] = ACTIONS(3090),
    [anon_sym_BANG_EQ] = ACTIONS(3086),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3086),
    [anon_sym_LT_EQ_GT] = ACTIONS(3086),
    [anon_sym_EQ_TILDE] = ACTIONS(3086),
    [anon_sym_BANG_TILDE] = ACTIONS(3086),
    [anon_sym_LT_EQ] = ACTIONS(3076),
    [anon_sym_GT] = ACTIONS(3076),
    [anon_sym_GT_EQ] = ACTIONS(3092),
    [anon_sym_CARET] = ACTIONS(3094),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3072),
    [anon_sym_PERCENT] = ACTIONS(3072),
    [sym_comment] = ACTIONS(87),
  },
  [9329] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9330] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9331] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9332] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9333] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9334] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9335] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13907),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9336] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9337] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9338] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9339] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9340] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9341] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9342] = {
    [aux_sym_exceptions_repeat1] = STATE(10679),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9343] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [9344] = {
    [sym_string] = STATE(9344),
    [aux_sym_chained_string_repeat1] = STATE(9344),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9345] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10680),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_assignment] = STATE(10680),
    [sym_operator_assignment] = STATE(10680),
    [sym_conditional] = STATE(10680),
    [sym_range] = STATE(10680),
    [sym_binary] = STATE(10680),
    [sym_unary] = STATE(10680),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9346] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7078),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(1830),
    [sym_scope_resolution] = STATE(1826),
    [sym_call] = STATE(1826),
    [sym_method_call] = STATE(1830),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(7078),
    [sym_operator_assignment] = STATE(7078),
    [sym_conditional] = STATE(7078),
    [sym_range] = STATE(7078),
    [sym_binary] = STATE(7078),
    [sym_unary] = STATE(7078),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(1829),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1830),
    [sym__variable] = STATE(1826),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(1830),
    [sym_false] = STATE(1830),
    [sym_nil] = STATE(1830),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(4232),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(6140),
    [sym__unary_minus2] = ACTIONS(3102),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3108),
    [anon_sym_break] = ACTIONS(3110),
    [anon_sym_next] = ACTIONS(3112),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(6659),
    [anon_sym_defined_QMARK] = ACTIONS(3114),
    [anon_sym_not] = ACTIONS(3116),
    [anon_sym_BANG] = ACTIONS(3120),
    [anon_sym_TILDE] = ACTIONS(3120),
    [sym_constant] = ACTIONS(3126),
    [sym_identifier] = ACTIONS(3126),
    [sym_instance_variable] = ACTIONS(3124),
    [sym_class_variable] = ACTIONS(3124),
    [sym_global_variable] = ACTIONS(3124),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(3126),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(3126),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9347] = {
    [aux_sym_exceptions_repeat1] = STATE(10681),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13909),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9348] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9349] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9350] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9351] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9352] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9353] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9354] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13911),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9355] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9356] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9357] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9358] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9359] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9360] = {
    [aux_sym_exceptions_repeat1] = STATE(9360),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13913),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9361] = {
    [aux_sym_exceptions_repeat1] = STATE(7099),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9362] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [9363] = {
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_EQ_GT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_COLON2] = ACTIONS(12499),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12497),
    [anon_sym_AMP_AMP] = ACTIONS(12497),
    [anon_sym_LT_LT] = ACTIONS(12497),
    [anon_sym_GT_GT] = ACTIONS(12497),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12497),
    [anon_sym_PLUS] = ACTIONS(12497),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [9364] = {
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12501),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_EQ_GT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_COLON2] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12501),
    [anon_sym_AMP_AMP] = ACTIONS(12501),
    [anon_sym_LT_LT] = ACTIONS(12501),
    [anon_sym_GT_GT] = ACTIONS(12501),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12501),
    [anon_sym_PLUS] = ACTIONS(12501),
    [anon_sym_SLASH] = ACTIONS(12501),
    [anon_sym_PERCENT] = ACTIONS(12501),
    [sym_comment] = ACTIONS(87),
  },
  [9365] = {
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12615),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_EQ_GT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_COLON2] = ACTIONS(12617),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12615),
    [anon_sym_AMP_AMP] = ACTIONS(12615),
    [anon_sym_LT_LT] = ACTIONS(12615),
    [anon_sym_GT_GT] = ACTIONS(12615),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12615),
    [anon_sym_PLUS] = ACTIONS(12615),
    [anon_sym_SLASH] = ACTIONS(12615),
    [anon_sym_PERCENT] = ACTIONS(12615),
    [sym_comment] = ACTIONS(87),
  },
  [9366] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9367] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9368] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9369] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9370] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9371] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9372] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13916),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9373] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9374] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9375] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9376] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9377] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9378] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9379] = {
    [aux_sym_exceptions_repeat1] = STATE(10685),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9380] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [9381] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [9382] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [9383] = {
    [sym_heredoc_body] = STATE(9383),
    [aux_sym_call_repeat1] = STATE(9383),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9384] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4301),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(4301),
    [sym_operator_assignment] = STATE(4301),
    [sym_conditional] = STATE(4301),
    [sym_range] = STATE(4301),
    [sym_binary] = STATE(4301),
    [sym_unary] = STATE(4301),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4304),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(6773),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [sym__identifier_hash_key2] = ACTIONS(6777),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12519),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(6779),
    [sym_identifier] = ACTIONS(6779),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9385] = {
    [sym_heredoc_body] = STATE(9383),
    [aux_sym_call_repeat1] = STATE(9383),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9386] = {
    [aux_sym_argument_list_repeat1] = STATE(9386),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13918),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9387] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10686),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_assignment] = STATE(10686),
    [sym_operator_assignment] = STATE(10686),
    [sym_conditional] = STATE(10686),
    [sym_range] = STATE(10686),
    [sym_binary] = STATE(10686),
    [sym_unary] = STATE(10686),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9388] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [9389] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [9390] = {
    [sym_heredoc_body] = STATE(9390),
    [aux_sym_call_repeat1] = STATE(9390),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9391] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4325),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(4325),
    [sym_operator_assignment] = STATE(4325),
    [sym_conditional] = STATE(4325),
    [sym_range] = STATE(4325),
    [sym_binary] = STATE(4325),
    [sym_unary] = STATE(4325),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4328),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(6815),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [sym__identifier_hash_key2] = ACTIONS(6819),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12523),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(6821),
    [sym_identifier] = ACTIONS(6821),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9392] = {
    [sym_heredoc_body] = STATE(9390),
    [aux_sym_call_repeat1] = STATE(9390),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9393] = {
    [aux_sym_argument_list_repeat1] = STATE(9393),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13921),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9394] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7160),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1881),
    [sym_scope_resolution] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_method_call] = STATE(1881),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(7160),
    [sym_operator_assignment] = STATE(7160),
    [sym_conditional] = STATE(7160),
    [sym_range] = STATE(7160),
    [sym_binary] = STATE(7160),
    [sym_unary] = STATE(7160),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(1880),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1881),
    [sym__variable] = STATE(1877),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1881),
    [sym_false] = STATE(1881),
    [sym_nil] = STATE(1881),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4293),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(6775),
    [sym__unary_minus2] = ACTIONS(3178),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3182),
    [anon_sym_yield] = ACTIONS(3184),
    [anon_sym_break] = ACTIONS(3186),
    [anon_sym_next] = ACTIONS(3188),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6769),
    [anon_sym_defined_QMARK] = ACTIONS(3190),
    [anon_sym_not] = ACTIONS(3192),
    [anon_sym_BANG] = ACTIONS(3196),
    [anon_sym_TILDE] = ACTIONS(3196),
    [sym_constant] = ACTIONS(3202),
    [sym_identifier] = ACTIONS(3202),
    [sym_instance_variable] = ACTIONS(3200),
    [sym_class_variable] = ACTIONS(3200),
    [sym_global_variable] = ACTIONS(3200),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3202),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3202),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9395] = {
    [aux_sym_exceptions_repeat1] = STATE(10687),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13924),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9396] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3206),
    [sym__binary_star2] = ACTIONS(3208),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3210),
    [anon_sym_STAR_STAR] = ACTIONS(3212),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_LT] = ACTIONS(3216),
    [anon_sym_QMARK] = ACTIONS(3218),
    [anon_sym_DOT_DOT] = ACTIONS(3220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3222),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3226),
    [anon_sym_AMP_AMP] = ACTIONS(3226),
    [anon_sym_LT_LT] = ACTIONS(3228),
    [anon_sym_GT_GT] = ACTIONS(3228),
    [anon_sym_EQ_EQ] = ACTIONS(3230),
    [anon_sym_BANG_EQ] = ACTIONS(3226),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3226),
    [anon_sym_LT_EQ_GT] = ACTIONS(3226),
    [anon_sym_EQ_TILDE] = ACTIONS(3226),
    [anon_sym_BANG_TILDE] = ACTIONS(3226),
    [anon_sym_LT_EQ] = ACTIONS(3216),
    [anon_sym_GT] = ACTIONS(3216),
    [anon_sym_GT_EQ] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_SLASH] = ACTIONS(3212),
    [anon_sym_PERCENT] = ACTIONS(3212),
    [sym_comment] = ACTIONS(87),
  },
  [9397] = {
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7852),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_rescue] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_in] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_RBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS_EQ] = ACTIONS(7850),
    [anon_sym_DASH_EQ] = ACTIONS(7850),
    [anon_sym_STAR_EQ] = ACTIONS(7850),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7850),
    [anon_sym_SLASH_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_PIPE_EQ] = ACTIONS(7850),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7850),
    [anon_sym_AMP_EQ] = ACTIONS(7850),
    [anon_sym_PERCENT_EQ] = ACTIONS(7850),
    [anon_sym_GT_GT_EQ] = ACTIONS(7850),
    [anon_sym_LT_LT_EQ] = ACTIONS(7850),
    [anon_sym_CARET_EQ] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7852),
    [anon_sym_COLON2] = ACTIONS(7852),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7852),
    [anon_sym_or] = ACTIONS(7852),
    [anon_sym_PIPE_PIPE] = ACTIONS(7852),
    [anon_sym_AMP_AMP] = ACTIONS(7852),
    [anon_sym_LT_LT] = ACTIONS(7852),
    [anon_sym_GT_GT] = ACTIONS(7852),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7852),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_SLASH] = ACTIONS(7852),
    [anon_sym_PERCENT] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7852),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [9398] = {
    [anon_sym_RPAREN] = ACTIONS(13926),
    [sym_comment] = ACTIONS(87),
  },
  [9399] = {
    [sym__heredoc_body_start2] = ACTIONS(12249),
    [sym__binary_minus2] = ACTIONS(12249),
    [sym__binary_star2] = ACTIONS(12249),
    [anon_sym_LBRACE] = ACTIONS(12249),
    [anon_sym_RBRACE] = ACTIONS(12249),
    [anon_sym_RPAREN] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12251),
    [anon_sym_COMMA] = ACTIONS(12249),
    [anon_sym_PIPE] = ACTIONS(12251),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_STAR_STAR] = ACTIONS(12251),
    [anon_sym_AMP] = ACTIONS(12251),
    [anon_sym_EQ] = ACTIONS(12251),
    [anon_sym_LT] = ACTIONS(12251),
    [anon_sym_if] = ACTIONS(12249),
    [anon_sym_unless] = ACTIONS(12249),
    [anon_sym_while] = ACTIONS(12249),
    [anon_sym_until] = ACTIONS(12249),
    [anon_sym_rescue] = ACTIONS(12249),
    [anon_sym_in] = ACTIONS(12249),
    [anon_sym_do] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_RBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [anon_sym_PLUS_EQ] = ACTIONS(12249),
    [anon_sym_DASH_EQ] = ACTIONS(12249),
    [anon_sym_STAR_EQ] = ACTIONS(12249),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12249),
    [anon_sym_SLASH_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_PIPE_EQ] = ACTIONS(12249),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12249),
    [anon_sym_AMP_EQ] = ACTIONS(12249),
    [anon_sym_PERCENT_EQ] = ACTIONS(12249),
    [anon_sym_GT_GT_EQ] = ACTIONS(12249),
    [anon_sym_LT_LT_EQ] = ACTIONS(12249),
    [anon_sym_CARET_EQ] = ACTIONS(12249),
    [anon_sym_QMARK] = ACTIONS(12249),
    [anon_sym_COLON2] = ACTIONS(12251),
    [anon_sym_DOT_DOT] = ACTIONS(12251),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12249),
    [anon_sym_and] = ACTIONS(12249),
    [anon_sym_or] = ACTIONS(12249),
    [anon_sym_PIPE_PIPE] = ACTIONS(12251),
    [anon_sym_AMP_AMP] = ACTIONS(12251),
    [anon_sym_LT_LT] = ACTIONS(12251),
    [anon_sym_GT_GT] = ACTIONS(12251),
    [anon_sym_EQ_EQ] = ACTIONS(12251),
    [anon_sym_BANG_EQ] = ACTIONS(12249),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12249),
    [anon_sym_LT_EQ_GT] = ACTIONS(12249),
    [anon_sym_EQ_TILDE] = ACTIONS(12249),
    [anon_sym_BANG_TILDE] = ACTIONS(12249),
    [anon_sym_LT_EQ] = ACTIONS(12251),
    [anon_sym_GT] = ACTIONS(12251),
    [anon_sym_GT_EQ] = ACTIONS(12249),
    [anon_sym_CARET] = ACTIONS(12251),
    [anon_sym_PLUS] = ACTIONS(12251),
    [anon_sym_SLASH] = ACTIONS(12251),
    [anon_sym_PERCENT] = ACTIONS(12251),
    [sym_comment] = ACTIONS(87),
  },
  [9400] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9401] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9402] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9403] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9404] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9405] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9406] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13928),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9407] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9408] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9409] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9410] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9411] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9412] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9413] = {
    [aux_sym_exceptions_repeat1] = STATE(10691),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9414] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [9415] = {
    [sym_string] = STATE(9415),
    [aux_sym_chained_string_repeat1] = STATE(9415),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9416] = {
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_STAR_STAR] = ACTIONS(12073),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_if] = ACTIONS(12071),
    [anon_sym_unless] = ACTIONS(12071),
    [anon_sym_while] = ACTIONS(12071),
    [anon_sym_until] = ACTIONS(12071),
    [anon_sym_rescue] = ACTIONS(12071),
    [anon_sym_in] = ACTIONS(12071),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_RBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_PLUS_EQ] = ACTIONS(12071),
    [anon_sym_DASH_EQ] = ACTIONS(12071),
    [anon_sym_STAR_EQ] = ACTIONS(12071),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12071),
    [anon_sym_SLASH_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_PIPE_EQ] = ACTIONS(12071),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12071),
    [anon_sym_AMP_EQ] = ACTIONS(12071),
    [anon_sym_PERCENT_EQ] = ACTIONS(12071),
    [anon_sym_GT_GT_EQ] = ACTIONS(12071),
    [anon_sym_LT_LT_EQ] = ACTIONS(12071),
    [anon_sym_CARET_EQ] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_COLON2] = ACTIONS(12073),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12073),
    [anon_sym_AMP_AMP] = ACTIONS(12073),
    [anon_sym_LT_LT] = ACTIONS(12073),
    [anon_sym_GT_GT] = ACTIONS(12073),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12073),
    [anon_sym_PLUS] = ACTIONS(12073),
    [anon_sym_SLASH] = ACTIONS(12073),
    [anon_sym_PERCENT] = ACTIONS(12073),
    [sym_comment] = ACTIONS(87),
  },
  [9417] = {
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_STAR_STAR] = ACTIONS(12098),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_if] = ACTIONS(12096),
    [anon_sym_unless] = ACTIONS(12096),
    [anon_sym_while] = ACTIONS(12096),
    [anon_sym_until] = ACTIONS(12096),
    [anon_sym_rescue] = ACTIONS(12096),
    [anon_sym_in] = ACTIONS(12096),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_RBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_PLUS_EQ] = ACTIONS(12096),
    [anon_sym_DASH_EQ] = ACTIONS(12096),
    [anon_sym_STAR_EQ] = ACTIONS(12096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12096),
    [anon_sym_SLASH_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_PIPE_EQ] = ACTIONS(12096),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12096),
    [anon_sym_AMP_EQ] = ACTIONS(12096),
    [anon_sym_PERCENT_EQ] = ACTIONS(12096),
    [anon_sym_GT_GT_EQ] = ACTIONS(12096),
    [anon_sym_LT_LT_EQ] = ACTIONS(12096),
    [anon_sym_CARET_EQ] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_COLON2] = ACTIONS(12098),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12098),
    [anon_sym_AMP_AMP] = ACTIONS(12098),
    [anon_sym_LT_LT] = ACTIONS(12098),
    [anon_sym_GT_GT] = ACTIONS(12098),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12098),
    [anon_sym_PLUS] = ACTIONS(12098),
    [anon_sym_SLASH] = ACTIONS(12098),
    [anon_sym_PERCENT] = ACTIONS(12098),
    [sym_comment] = ACTIONS(87),
  },
  [9418] = {
    [anon_sym_end] = ACTIONS(13930),
    [sym_comment] = ACTIONS(87),
  },
  [9419] = {
    [sym__statements] = STATE(10693),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13932),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9420] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10694),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_assignment] = STATE(10694),
    [sym_operator_assignment] = STATE(10694),
    [sym_conditional] = STATE(10694),
    [sym_range] = STATE(10694),
    [sym_binary] = STATE(10694),
    [sym_unary] = STATE(10694),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9421] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7214),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(1922),
    [sym_scope_resolution] = STATE(1916),
    [sym_call] = STATE(1916),
    [sym_method_call] = STATE(1922),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(7214),
    [sym_operator_assignment] = STATE(7214),
    [sym_conditional] = STATE(7214),
    [sym_range] = STATE(7214),
    [sym_binary] = STATE(7214),
    [sym_unary] = STATE(7214),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(1921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1922),
    [sym__variable] = STATE(1916),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(1922),
    [sym_false] = STATE(1922),
    [sym_nil] = STATE(1922),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4371),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(6817),
    [sym__unary_minus2] = ACTIONS(3250),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3256),
    [anon_sym_yield] = ACTIONS(3258),
    [anon_sym_break] = ACTIONS(3260),
    [anon_sym_next] = ACTIONS(3262),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(6867),
    [anon_sym_defined_QMARK] = ACTIONS(3266),
    [anon_sym_not] = ACTIONS(3268),
    [anon_sym_BANG] = ACTIONS(3272),
    [anon_sym_TILDE] = ACTIONS(3272),
    [sym_constant] = ACTIONS(3278),
    [sym_identifier] = ACTIONS(3278),
    [sym_instance_variable] = ACTIONS(3276),
    [sym_class_variable] = ACTIONS(3276),
    [sym_global_variable] = ACTIONS(3276),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3278),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3278),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9422] = {
    [aux_sym_exceptions_repeat1] = STATE(10695),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13934),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9423] = {
    [aux_sym_exceptions_repeat1] = STATE(9423),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13936),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9424] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3298),
    [sym__binary_star2] = ACTIONS(3300),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3302),
    [anon_sym_STAR_STAR] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3306),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3312),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3314),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ_GT] = ACTIONS(3316),
    [anon_sym_EQ_TILDE] = ACTIONS(3316),
    [anon_sym_BANG_TILDE] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3308),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_GT_EQ] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [sym_comment] = ACTIONS(87),
  },
  [9425] = {
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9426] = {
    [aux_sym_exceptions_repeat1] = STATE(9426),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(13939),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9427] = {
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12916),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_EQ_GT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_COLON2] = ACTIONS(12918),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12916),
    [anon_sym_AMP_AMP] = ACTIONS(12916),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12916),
    [anon_sym_PLUS] = ACTIONS(12916),
    [anon_sym_SLASH] = ACTIONS(12916),
    [anon_sym_PERCENT] = ACTIONS(12916),
    [sym_comment] = ACTIONS(87),
  },
  [9428] = {
    [anon_sym_end] = ACTIONS(13942),
    [sym_comment] = ACTIONS(87),
  },
  [9429] = {
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13064),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_EQ_GT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13064),
    [anon_sym_AMP_AMP] = ACTIONS(13064),
    [anon_sym_LT_LT] = ACTIONS(13064),
    [anon_sym_GT_GT] = ACTIONS(13064),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13064),
    [anon_sym_PLUS] = ACTIONS(13064),
    [anon_sym_SLASH] = ACTIONS(13064),
    [anon_sym_PERCENT] = ACTIONS(13064),
    [sym_comment] = ACTIONS(87),
  },
  [9430] = {
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13216),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_EQ_GT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_COLON2] = ACTIONS(13218),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13216),
    [anon_sym_AMP_AMP] = ACTIONS(13216),
    [anon_sym_LT_LT] = ACTIONS(13216),
    [anon_sym_GT_GT] = ACTIONS(13216),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13216),
    [anon_sym_PLUS] = ACTIONS(13216),
    [anon_sym_SLASH] = ACTIONS(13216),
    [anon_sym_PERCENT] = ACTIONS(13216),
    [sym_comment] = ACTIONS(87),
  },
  [9431] = {
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_EQ_GT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_COLON2] = ACTIONS(13229),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13227),
    [anon_sym_AMP_AMP] = ACTIONS(13227),
    [anon_sym_LT_LT] = ACTIONS(13227),
    [anon_sym_GT_GT] = ACTIONS(13227),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13227),
    [anon_sym_PLUS] = ACTIONS(13227),
    [anon_sym_SLASH] = ACTIONS(13227),
    [anon_sym_PERCENT] = ACTIONS(13227),
    [sym_comment] = ACTIONS(87),
  },
  [9432] = {
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13551),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_EQ_GT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_COLON2] = ACTIONS(13553),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13551),
    [anon_sym_AMP_AMP] = ACTIONS(13551),
    [anon_sym_LT_LT] = ACTIONS(13551),
    [anon_sym_GT_GT] = ACTIONS(13551),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13551),
    [anon_sym_PLUS] = ACTIONS(13551),
    [anon_sym_SLASH] = ACTIONS(13551),
    [anon_sym_PERCENT] = ACTIONS(13551),
    [sym_comment] = ACTIONS(87),
  },
  [9433] = {
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_COLON2] = ACTIONS(13728),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13726),
    [anon_sym_AMP_AMP] = ACTIONS(13726),
    [anon_sym_LT_LT] = ACTIONS(13726),
    [anon_sym_GT_GT] = ACTIONS(13726),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13726),
    [anon_sym_PLUS] = ACTIONS(13726),
    [anon_sym_SLASH] = ACTIONS(13726),
    [anon_sym_PERCENT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [9434] = {
    [anon_sym_end] = ACTIONS(13944),
    [sym_comment] = ACTIONS(87),
  },
  [9435] = {
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [9436] = {
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10129),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_in] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_EQ_GT] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_RBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_PLUS_EQ] = ACTIONS(10127),
    [anon_sym_DASH_EQ] = ACTIONS(10127),
    [anon_sym_STAR_EQ] = ACTIONS(10127),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10127),
    [anon_sym_SLASH_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10127),
    [anon_sym_AMP_EQ] = ACTIONS(10127),
    [anon_sym_PERCENT_EQ] = ACTIONS(10127),
    [anon_sym_GT_GT_EQ] = ACTIONS(10127),
    [anon_sym_LT_LT_EQ] = ACTIONS(10127),
    [anon_sym_CARET_EQ] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_COLON2] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10129),
    [anon_sym_AMP_AMP] = ACTIONS(10129),
    [anon_sym_LT_LT] = ACTIONS(10129),
    [anon_sym_GT_GT] = ACTIONS(10129),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10129),
    [anon_sym_PLUS] = ACTIONS(10129),
    [anon_sym_SLASH] = ACTIONS(10129),
    [anon_sym_PERCENT] = ACTIONS(10129),
    [sym_comment] = ACTIONS(87),
  },
  [9437] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13946),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9438] = {
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10135),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_in] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_EQ_GT] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_RBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_PLUS_EQ] = ACTIONS(10133),
    [anon_sym_DASH_EQ] = ACTIONS(10133),
    [anon_sym_STAR_EQ] = ACTIONS(10133),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10133),
    [anon_sym_SLASH_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10133),
    [anon_sym_AMP_EQ] = ACTIONS(10133),
    [anon_sym_PERCENT_EQ] = ACTIONS(10133),
    [anon_sym_GT_GT_EQ] = ACTIONS(10133),
    [anon_sym_LT_LT_EQ] = ACTIONS(10133),
    [anon_sym_CARET_EQ] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_COLON2] = ACTIONS(10135),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10135),
    [anon_sym_GT_GT] = ACTIONS(10135),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10135),
    [anon_sym_PLUS] = ACTIONS(10135),
    [anon_sym_SLASH] = ACTIONS(10135),
    [anon_sym_PERCENT] = ACTIONS(10135),
    [sym_comment] = ACTIONS(87),
  },
  [9439] = {
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10139),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_in] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_EQ_GT] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_RBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_PLUS_EQ] = ACTIONS(10137),
    [anon_sym_DASH_EQ] = ACTIONS(10137),
    [anon_sym_STAR_EQ] = ACTIONS(10137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10137),
    [anon_sym_SLASH_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10137),
    [anon_sym_AMP_EQ] = ACTIONS(10137),
    [anon_sym_PERCENT_EQ] = ACTIONS(10137),
    [anon_sym_GT_GT_EQ] = ACTIONS(10137),
    [anon_sym_LT_LT_EQ] = ACTIONS(10137),
    [anon_sym_CARET_EQ] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_COLON2] = ACTIONS(10139),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10139),
    [anon_sym_AMP_AMP] = ACTIONS(10139),
    [anon_sym_LT_LT] = ACTIONS(10139),
    [anon_sym_GT_GT] = ACTIONS(10139),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10139),
    [anon_sym_PLUS] = ACTIONS(10139),
    [anon_sym_SLASH] = ACTIONS(10139),
    [anon_sym_PERCENT] = ACTIONS(10139),
    [sym_comment] = ACTIONS(87),
  },
  [9440] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(13948),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9441] = {
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10145),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_in] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_EQ_GT] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_RBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_PLUS_EQ] = ACTIONS(10143),
    [anon_sym_DASH_EQ] = ACTIONS(10143),
    [anon_sym_STAR_EQ] = ACTIONS(10143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10143),
    [anon_sym_SLASH_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10143),
    [anon_sym_AMP_EQ] = ACTIONS(10143),
    [anon_sym_PERCENT_EQ] = ACTIONS(10143),
    [anon_sym_GT_GT_EQ] = ACTIONS(10143),
    [anon_sym_LT_LT_EQ] = ACTIONS(10143),
    [anon_sym_CARET_EQ] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_COLON2] = ACTIONS(10145),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10145),
    [anon_sym_AMP_AMP] = ACTIONS(10145),
    [anon_sym_LT_LT] = ACTIONS(10145),
    [anon_sym_GT_GT] = ACTIONS(10145),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10145),
    [anon_sym_PLUS] = ACTIONS(10145),
    [anon_sym_SLASH] = ACTIONS(10145),
    [anon_sym_PERCENT] = ACTIONS(10145),
    [sym_comment] = ACTIONS(87),
  },
  [9442] = {
    [sym__method_rest] = STATE(10700),
    [sym_operator] = STATE(2039),
    [sym__method_name] = STATE(2039),
    [sym_setter] = STATE(2039),
    [sym_symbol] = STATE(2039),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(10456),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(10456),
    [sym_class_variable] = ACTIONS(10456),
    [sym_global_variable] = ACTIONS(10456),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [9443] = {
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_in] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_EQ_GT] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_RBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_PLUS_EQ] = ACTIONS(10896),
    [anon_sym_DASH_EQ] = ACTIONS(10896),
    [anon_sym_STAR_EQ] = ACTIONS(10896),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10896),
    [anon_sym_SLASH_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10896),
    [anon_sym_AMP_EQ] = ACTIONS(10896),
    [anon_sym_PERCENT_EQ] = ACTIONS(10896),
    [anon_sym_GT_GT_EQ] = ACTIONS(10896),
    [anon_sym_LT_LT_EQ] = ACTIONS(10896),
    [anon_sym_CARET_EQ] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_COLON2] = ACTIONS(10898),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10898),
    [anon_sym_AMP_AMP] = ACTIONS(10898),
    [anon_sym_LT_LT] = ACTIONS(10898),
    [anon_sym_GT_GT] = ACTIONS(10898),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10898),
    [anon_sym_PLUS] = ACTIONS(10898),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [9444] = {
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10902),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_in] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_EQ_GT] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_RBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_PLUS_EQ] = ACTIONS(10900),
    [anon_sym_DASH_EQ] = ACTIONS(10900),
    [anon_sym_STAR_EQ] = ACTIONS(10900),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10900),
    [anon_sym_SLASH_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10900),
    [anon_sym_AMP_EQ] = ACTIONS(10900),
    [anon_sym_PERCENT_EQ] = ACTIONS(10900),
    [anon_sym_GT_GT_EQ] = ACTIONS(10900),
    [anon_sym_LT_LT_EQ] = ACTIONS(10900),
    [anon_sym_CARET_EQ] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_COLON2] = ACTIONS(10902),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10902),
    [anon_sym_AMP_AMP] = ACTIONS(10902),
    [anon_sym_LT_LT] = ACTIONS(10902),
    [anon_sym_GT_GT] = ACTIONS(10902),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10902),
    [anon_sym_PLUS] = ACTIONS(10902),
    [anon_sym_SLASH] = ACTIONS(10902),
    [anon_sym_PERCENT] = ACTIONS(10902),
    [sym_comment] = ACTIONS(87),
  },
  [9445] = {
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11063),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_in] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_EQ_GT] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_RBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_PLUS_EQ] = ACTIONS(11061),
    [anon_sym_DASH_EQ] = ACTIONS(11061),
    [anon_sym_STAR_EQ] = ACTIONS(11061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11061),
    [anon_sym_SLASH_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11061),
    [anon_sym_AMP_EQ] = ACTIONS(11061),
    [anon_sym_PERCENT_EQ] = ACTIONS(11061),
    [anon_sym_GT_GT_EQ] = ACTIONS(11061),
    [anon_sym_LT_LT_EQ] = ACTIONS(11061),
    [anon_sym_CARET_EQ] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_COLON2] = ACTIONS(11063),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11063),
    [anon_sym_AMP_AMP] = ACTIONS(11063),
    [anon_sym_LT_LT] = ACTIONS(11063),
    [anon_sym_GT_GT] = ACTIONS(11063),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11063),
    [anon_sym_PLUS] = ACTIONS(11063),
    [anon_sym_SLASH] = ACTIONS(11063),
    [anon_sym_PERCENT] = ACTIONS(11063),
    [sym_comment] = ACTIONS(87),
  },
  [9446] = {
    [anon_sym_end] = ACTIONS(13950),
    [sym_comment] = ACTIONS(87),
  },
  [9447] = {
    [sym_elsif] = STATE(10702),
    [sym_else] = STATE(10702),
    [sym__if_tail] = STATE(10702),
    [anon_sym_end] = ACTIONS(13950),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9448] = {
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11238),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_in] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_EQ_GT] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_RBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_PLUS_EQ] = ACTIONS(11236),
    [anon_sym_DASH_EQ] = ACTIONS(11236),
    [anon_sym_STAR_EQ] = ACTIONS(11236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11236),
    [anon_sym_SLASH_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11236),
    [anon_sym_AMP_EQ] = ACTIONS(11236),
    [anon_sym_PERCENT_EQ] = ACTIONS(11236),
    [anon_sym_GT_GT_EQ] = ACTIONS(11236),
    [anon_sym_LT_LT_EQ] = ACTIONS(11236),
    [anon_sym_CARET_EQ] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_COLON2] = ACTIONS(11238),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11238),
    [anon_sym_AMP_AMP] = ACTIONS(11238),
    [anon_sym_LT_LT] = ACTIONS(11238),
    [anon_sym_GT_GT] = ACTIONS(11238),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11238),
    [anon_sym_PLUS] = ACTIONS(11238),
    [anon_sym_SLASH] = ACTIONS(11238),
    [anon_sym_PERCENT] = ACTIONS(11238),
    [sym_comment] = ACTIONS(87),
  },
  [9449] = {
    [anon_sym_end] = ACTIONS(13952),
    [sym_comment] = ACTIONS(87),
  },
  [9450] = {
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_in] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_EQ_GT] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_RBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_PLUS_EQ] = ACTIONS(11333),
    [anon_sym_DASH_EQ] = ACTIONS(11333),
    [anon_sym_STAR_EQ] = ACTIONS(11333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11333),
    [anon_sym_SLASH_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11333),
    [anon_sym_AMP_EQ] = ACTIONS(11333),
    [anon_sym_PERCENT_EQ] = ACTIONS(11333),
    [anon_sym_GT_GT_EQ] = ACTIONS(11333),
    [anon_sym_LT_LT_EQ] = ACTIONS(11333),
    [anon_sym_CARET_EQ] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [9451] = {
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_in] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_EQ_GT] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_RBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_PLUS_EQ] = ACTIONS(11342),
    [anon_sym_DASH_EQ] = ACTIONS(11342),
    [anon_sym_STAR_EQ] = ACTIONS(11342),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11342),
    [anon_sym_SLASH_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11342),
    [anon_sym_AMP_EQ] = ACTIONS(11342),
    [anon_sym_PERCENT_EQ] = ACTIONS(11342),
    [anon_sym_GT_GT_EQ] = ACTIONS(11342),
    [anon_sym_LT_LT_EQ] = ACTIONS(11342),
    [anon_sym_CARET_EQ] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_COLON2] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [9452] = {
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11395),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_in] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_EQ_GT] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_RBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_PLUS_EQ] = ACTIONS(11393),
    [anon_sym_DASH_EQ] = ACTIONS(11393),
    [anon_sym_STAR_EQ] = ACTIONS(11393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11393),
    [anon_sym_SLASH_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11393),
    [anon_sym_AMP_EQ] = ACTIONS(11393),
    [anon_sym_PERCENT_EQ] = ACTIONS(11393),
    [anon_sym_GT_GT_EQ] = ACTIONS(11393),
    [anon_sym_LT_LT_EQ] = ACTIONS(11393),
    [anon_sym_CARET_EQ] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_COLON2] = ACTIONS(11395),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11395),
    [anon_sym_AMP_AMP] = ACTIONS(11395),
    [anon_sym_LT_LT] = ACTIONS(11395),
    [anon_sym_GT_GT] = ACTIONS(11395),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11395),
    [anon_sym_PLUS] = ACTIONS(11395),
    [anon_sym_SLASH] = ACTIONS(11395),
    [anon_sym_PERCENT] = ACTIONS(11395),
    [sym_comment] = ACTIONS(87),
  },
  [9453] = {
    [anon_sym_end] = ACTIONS(13954),
    [sym_comment] = ACTIONS(87),
  },
  [9454] = {
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [9455] = {
    [anon_sym_end] = ACTIONS(13956),
    [sym_comment] = ACTIONS(87),
  },
  [9456] = {
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11408),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_in] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_EQ_GT] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_RBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_PLUS_EQ] = ACTIONS(11406),
    [anon_sym_DASH_EQ] = ACTIONS(11406),
    [anon_sym_STAR_EQ] = ACTIONS(11406),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11406),
    [anon_sym_SLASH_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11406),
    [anon_sym_AMP_EQ] = ACTIONS(11406),
    [anon_sym_PERCENT_EQ] = ACTIONS(11406),
    [anon_sym_GT_GT_EQ] = ACTIONS(11406),
    [anon_sym_LT_LT_EQ] = ACTIONS(11406),
    [anon_sym_CARET_EQ] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_COLON2] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11408),
    [anon_sym_AMP_AMP] = ACTIONS(11408),
    [anon_sym_LT_LT] = ACTIONS(11408),
    [anon_sym_GT_GT] = ACTIONS(11408),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11408),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_SLASH] = ACTIONS(11408),
    [anon_sym_PERCENT] = ACTIONS(11408),
    [sym_comment] = ACTIONS(87),
  },
  [9457] = {
    [anon_sym_end] = ACTIONS(13958),
    [sym_comment] = ACTIONS(87),
  },
  [9458] = {
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11880),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_in] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_EQ_GT] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_RBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_PLUS_EQ] = ACTIONS(11878),
    [anon_sym_DASH_EQ] = ACTIONS(11878),
    [anon_sym_STAR_EQ] = ACTIONS(11878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11878),
    [anon_sym_SLASH_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11878),
    [anon_sym_AMP_EQ] = ACTIONS(11878),
    [anon_sym_PERCENT_EQ] = ACTIONS(11878),
    [anon_sym_GT_GT_EQ] = ACTIONS(11878),
    [anon_sym_LT_LT_EQ] = ACTIONS(11878),
    [anon_sym_CARET_EQ] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_COLON2] = ACTIONS(11880),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11880),
    [anon_sym_AMP_AMP] = ACTIONS(11880),
    [anon_sym_LT_LT] = ACTIONS(11880),
    [anon_sym_GT_GT] = ACTIONS(11880),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11880),
    [anon_sym_PLUS] = ACTIONS(11880),
    [anon_sym_SLASH] = ACTIONS(11880),
    [anon_sym_PERCENT] = ACTIONS(11880),
    [sym_comment] = ACTIONS(87),
  },
  [9459] = {
    [anon_sym_end] = ACTIONS(13960),
    [sym_comment] = ACTIONS(87),
  },
  [9460] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3438),
    [sym__binary_star2] = ACTIONS(3440),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3442),
    [anon_sym_STAR_STAR] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3452),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3456),
    [anon_sym_AMP_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3456),
    [anon_sym_BANG_EQ] = ACTIONS(3460),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3460),
    [anon_sym_LT_EQ_GT] = ACTIONS(3460),
    [anon_sym_EQ_TILDE] = ACTIONS(3460),
    [anon_sym_BANG_TILDE] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3448),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [sym_comment] = ACTIONS(87),
  },
  [9461] = {
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9462] = {
    [aux_sym_exceptions_repeat1] = STATE(9462),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(13962),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9463] = {
    [sym_method] = STATE(118),
    [sym_singleton_method] = STATE(118),
    [sym_class] = STATE(118),
    [sym_singleton_class] = STATE(118),
    [sym_module] = STATE(118),
    [sym_return] = STATE(118),
    [sym_yield] = STATE(118),
    [sym_break] = STATE(118),
    [sym_next] = STATE(118),
    [sym_while] = STATE(118),
    [sym_until] = STATE(118),
    [sym_for] = STATE(118),
    [sym_case] = STATE(118),
    [sym_if] = STATE(118),
    [sym_unless] = STATE(118),
    [sym_begin] = STATE(118),
    [sym__arg] = STATE(10708),
    [sym__primary] = STATE(118),
    [sym_parenthesized_statements] = STATE(118),
    [sym_element_reference] = STATE(2119),
    [sym_scope_resolution] = STATE(119),
    [sym_call] = STATE(119),
    [sym_method_call] = STATE(2119),
    [sym_assignment] = STATE(10708),
    [sym_operator_assignment] = STATE(10708),
    [sym_conditional] = STATE(10708),
    [sym_range] = STATE(10708),
    [sym_binary] = STATE(10708),
    [sym_unary] = STATE(10708),
    [sym_left_assignment_list] = STATE(2118),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2119),
    [sym__variable] = STATE(119),
    [sym_rational] = STATE(118),
    [sym_true] = STATE(2119),
    [sym_false] = STATE(2119),
    [sym_nil] = STATE(2119),
    [sym_chained_string] = STATE(118),
    [sym_string] = STATE(2120),
    [sym_subshell] = STATE(118),
    [sym_string_array] = STATE(118),
    [sym_symbol_array] = STATE(118),
    [sym_symbol] = STATE(118),
    [sym_regex] = STATE(118),
    [sym_array] = STATE(118),
    [sym_hash] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(153),
    [sym__unary_minus2] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(167),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(3488),
    [anon_sym_yield] = ACTIONS(3490),
    [anon_sym_break] = ACTIONS(3492),
    [anon_sym_next] = ACTIONS(3494),
    [sym_redo] = ACTIONS(185),
    [sym_retry] = ACTIONS(185),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_defined_QMARK] = ACTIONS(3498),
    [anon_sym_not] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3502),
    [anon_sym_TILDE] = ACTIONS(3502),
    [sym_constant] = ACTIONS(215),
    [sym_identifier] = ACTIONS(215),
    [sym_instance_variable] = ACTIONS(211),
    [sym_class_variable] = ACTIONS(211),
    [sym_global_variable] = ACTIONS(211),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(185),
    [sym_complex] = ACTIONS(153),
    [sym_super] = ACTIONS(215),
    [anon_sym_true] = ACTIONS(217),
    [anon_sym_TRUE] = ACTIONS(217),
    [anon_sym_false] = ACTIONS(219),
    [anon_sym_FALSE] = ACTIONS(219),
    [sym_self] = ACTIONS(215),
    [anon_sym_nil] = ACTIONS(221),
    [anon_sym_NIL] = ACTIONS(221),
    [sym_character] = ACTIONS(153),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9464] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9465] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9466] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9467] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9468] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9469] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9470] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13965),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9471] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9472] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9473] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9474] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9475] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9476] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9477] = {
    [aux_sym_exceptions_repeat1] = STATE(10711),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9478] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [9479] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10712),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_assignment] = STATE(10712),
    [sym_operator_assignment] = STATE(10712),
    [sym_conditional] = STATE(10712),
    [sym_range] = STATE(10712),
    [sym_binary] = STATE(10712),
    [sym_unary] = STATE(10712),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9480] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7354),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2143),
    [sym_scope_resolution] = STATE(940),
    [sym_call] = STATE(940),
    [sym_method_call] = STATE(2143),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(7354),
    [sym_operator_assignment] = STATE(7354),
    [sym_conditional] = STATE(7354),
    [sym_range] = STATE(7354),
    [sym_binary] = STATE(7354),
    [sym_unary] = STATE(7354),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(2142),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2143),
    [sym__variable] = STATE(940),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2143),
    [sym_false] = STATE(2143),
    [sym_nil] = STATE(2143),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(2594),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(4248),
    [sym__unary_minus2] = ACTIONS(3524),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1617),
    [anon_sym_yield] = ACTIONS(1619),
    [anon_sym_break] = ACTIONS(1621),
    [anon_sym_next] = ACTIONS(1623),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7120),
    [anon_sym_defined_QMARK] = ACTIONS(3528),
    [anon_sym_not] = ACTIONS(3530),
    [anon_sym_BANG] = ACTIONS(3534),
    [anon_sym_TILDE] = ACTIONS(3534),
    [sym_constant] = ACTIONS(1637),
    [sym_identifier] = ACTIONS(1637),
    [sym_instance_variable] = ACTIONS(1635),
    [sym_class_variable] = ACTIONS(1635),
    [sym_global_variable] = ACTIONS(1635),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1637),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1637),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9481] = {
    [aux_sym_exceptions_repeat1] = STATE(10713),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13967),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9482] = {
    [sym__binary_minus2] = ACTIONS(3538),
    [sym__binary_star2] = ACTIONS(3540),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_STAR_STAR] = ACTIONS(3546),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3550),
    [anon_sym_QMARK] = ACTIONS(3552),
    [anon_sym_DOT_DOT] = ACTIONS(3554),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3556),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3560),
    [anon_sym_AMP_AMP] = ACTIONS(3560),
    [anon_sym_LT_LT] = ACTIONS(3562),
    [anon_sym_GT_GT] = ACTIONS(3562),
    [anon_sym_EQ_EQ] = ACTIONS(3564),
    [anon_sym_BANG_EQ] = ACTIONS(3560),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3560),
    [anon_sym_LT_EQ_GT] = ACTIONS(3560),
    [anon_sym_EQ_TILDE] = ACTIONS(3560),
    [anon_sym_BANG_TILDE] = ACTIONS(3560),
    [anon_sym_LT_EQ] = ACTIONS(3550),
    [anon_sym_GT] = ACTIONS(3550),
    [anon_sym_GT_EQ] = ACTIONS(3566),
    [anon_sym_CARET] = ACTIONS(3568),
    [anon_sym_PLUS] = ACTIONS(3570),
    [anon_sym_SLASH] = ACTIONS(3546),
    [anon_sym_PERCENT] = ACTIONS(3546),
    [sym_comment] = ACTIONS(87),
  },
  [9483] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9484] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9485] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9486] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9487] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9488] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9489] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13969),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9490] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9491] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9492] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9493] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9494] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9495] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9496] = {
    [aux_sym_exceptions_repeat1] = STATE(10716),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9497] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [9498] = {
    [sym_string] = STATE(9498),
    [aux_sym_chained_string_repeat1] = STATE(9498),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9499] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10717),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_assignment] = STATE(10717),
    [sym_operator_assignment] = STATE(10717),
    [sym_conditional] = STATE(10717),
    [sym_range] = STATE(10717),
    [sym_binary] = STATE(10717),
    [sym_unary] = STATE(10717),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9500] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(7395),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(2178),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2178),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(7395),
    [sym_operator_assignment] = STATE(7395),
    [sym_conditional] = STATE(7395),
    [sym_range] = STATE(7395),
    [sym_binary] = STATE(7395),
    [sym_unary] = STATE(7395),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(2177),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2178),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(2178),
    [sym_false] = STATE(2178),
    [sym_nil] = STATE(2178),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4638),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(4292),
    [sym__unary_minus2] = ACTIONS(3576),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3582),
    [anon_sym_break] = ACTIONS(3584),
    [anon_sym_next] = ACTIONS(3586),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(7192),
    [anon_sym_defined_QMARK] = ACTIONS(3588),
    [anon_sym_not] = ACTIONS(3590),
    [anon_sym_BANG] = ACTIONS(3594),
    [anon_sym_TILDE] = ACTIONS(3594),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9501] = {
    [aux_sym_exceptions_repeat1] = STATE(10718),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(13971),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9502] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9503] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9504] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9505] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9506] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9507] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9508] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13973),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9509] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9510] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9511] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9512] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9513] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9514] = {
    [aux_sym_exceptions_repeat1] = STATE(9514),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(13975),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9515] = {
    [aux_sym_exceptions_repeat1] = STATE(7416),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9516] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [9517] = {
    [sym_string] = STATE(9517),
    [aux_sym_chained_string_repeat1] = STATE(9517),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9518] = {
    [sym__simple_symbol2] = ACTIONS(13978),
    [sym__string_start2] = ACTIONS(13978),
    [sym__symbol_start2] = ACTIONS(13978),
    [sym__subshell_start2] = ACTIONS(13978),
    [sym__regex_start2] = ACTIONS(13978),
    [sym__string_array_start2] = ACTIONS(13978),
    [sym__symbol_array_start2] = ACTIONS(13978),
    [sym_heredoc_beginning2] = ACTIONS(13978),
    [sym__unary_minus2] = ACTIONS(13978),
    [anon_sym_BEGIN] = ACTIONS(13980),
    [anon_sym_LBRACE] = ACTIONS(13978),
    [anon_sym_END] = ACTIONS(13980),
    [anon_sym_def] = ACTIONS(13980),
    [anon_sym_LPAREN] = ACTIONS(13978),
    [anon_sym_COLON_COLON] = ACTIONS(13978),
    [anon_sym_SEMI] = ACTIONS(13978),
    [anon_sym_STAR] = ACTIONS(13978),
    [anon_sym_class] = ACTIONS(13980),
    [anon_sym_module] = ACTIONS(13980),
    [anon_sym_end] = ACTIONS(13980),
    [anon_sym_return] = ACTIONS(13980),
    [anon_sym_yield] = ACTIONS(13980),
    [anon_sym_break] = ACTIONS(13980),
    [anon_sym_next] = ACTIONS(13980),
    [sym_redo] = ACTIONS(13980),
    [sym_retry] = ACTIONS(13980),
    [anon_sym_if] = ACTIONS(13980),
    [anon_sym_unless] = ACTIONS(13980),
    [anon_sym_while] = ACTIONS(13980),
    [anon_sym_until] = ACTIONS(13980),
    [anon_sym_rescue] = ACTIONS(13980),
    [anon_sym_for] = ACTIONS(13980),
    [anon_sym_case] = ACTIONS(13980),
    [anon_sym_else] = ACTIONS(13980),
    [anon_sym_begin] = ACTIONS(13980),
    [anon_sym_ensure] = ACTIONS(13980),
    [anon_sym_PLUS] = ACTIONS(13980),
    [anon_sym_defined_QMARK] = ACTIONS(13978),
    [anon_sym_not] = ACTIONS(13980),
    [anon_sym_BANG] = ACTIONS(13978),
    [anon_sym_TILDE] = ACTIONS(13978),
    [sym_constant] = ACTIONS(13980),
    [sym_identifier] = ACTIONS(13980),
    [sym_instance_variable] = ACTIONS(13978),
    [sym_class_variable] = ACTIONS(13978),
    [sym_global_variable] = ACTIONS(13978),
    [anon_sym_undef] = ACTIONS(13980),
    [anon_sym_alias] = ACTIONS(13980),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(13980),
    [sym_float] = ACTIONS(13980),
    [sym_complex] = ACTIONS(13978),
    [sym_super] = ACTIONS(13980),
    [anon_sym_true] = ACTIONS(13980),
    [anon_sym_TRUE] = ACTIONS(13980),
    [anon_sym_false] = ACTIONS(13980),
    [anon_sym_FALSE] = ACTIONS(13980),
    [sym_self] = ACTIONS(13980),
    [anon_sym_nil] = ACTIONS(13980),
    [anon_sym_NIL] = ACTIONS(13980),
    [sym_character] = ACTIONS(13978),
    [anon_sym_LBRACK2] = ACTIONS(13978),
    [anon_sym_DASH_GT] = ACTIONS(13978),
  },
  [9519] = {
    [sym__line_break2] = ACTIONS(9486),
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9486),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_SEMI] = ACTIONS(9486),
    [anon_sym_then] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [9520] = {
    [anon_sym_RBRACE] = ACTIONS(13982),
    [sym_comment] = ACTIONS(87),
  },
  [9521] = {
    [sym__line_break2] = ACTIONS(9506),
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9506),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_SEMI] = ACTIONS(9506),
    [anon_sym_then] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [9522] = {
    [anon_sym_end] = ACTIONS(13984),
    [sym_comment] = ACTIONS(87),
  },
  [9523] = {
    [sym__statements] = STATE(10722),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13986),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9524] = {
    [sym__statements] = STATE(10722),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(10723),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(10723),
    [sym__line_break2] = ACTIONS(13988),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(13986),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9525] = {
    [sym__line_break2] = ACTIONS(12075),
    [sym__heredoc_body_start2] = ACTIONS(12075),
    [anon_sym_COMMA] = ACTIONS(12075),
    [anon_sym_SEMI] = ACTIONS(12075),
    [sym_comment] = ACTIONS(87),
  },
  [9526] = {
    [aux_sym_method_parameters_repeat1] = STATE(6475),
    [anon_sym_RPAREN] = ACTIONS(13990),
    [anon_sym_COMMA] = ACTIONS(5772),
    [sym_comment] = ACTIONS(87),
  },
  [9527] = {
    [sym__line_break2] = ACTIONS(12081),
    [sym__heredoc_body_start2] = ACTIONS(12081),
    [anon_sym_COMMA] = ACTIONS(12081),
    [anon_sym_SEMI] = ACTIONS(12081),
    [sym_comment] = ACTIONS(87),
  },
  [9528] = {
    [aux_sym_method_parameters_repeat1] = STATE(9528),
    [sym__line_break2] = ACTIONS(12081),
    [sym__heredoc_body_start2] = ACTIONS(12081),
    [anon_sym_COMMA] = ACTIONS(13992),
    [anon_sym_SEMI] = ACTIONS(12081),
    [sym_comment] = ACTIONS(87),
  },
  [9529] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_RPAREN] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9530] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9531] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10725),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(10725),
    [sym_operator_assignment] = STATE(10725),
    [sym_conditional] = STATE(10725),
    [sym_range] = STATE(10725),
    [sym_binary] = STATE(10725),
    [sym_unary] = STATE(10725),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [9532] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_RPAREN] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9533] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10726),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(10726),
    [sym_operator_assignment] = STATE(10726),
    [sym_conditional] = STATE(10726),
    [sym_range] = STATE(10726),
    [sym_binary] = STATE(10726),
    [sym_unary] = STATE(10726),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [9534] = {
    [sym_heredoc_body] = STATE(10727),
    [aux_sym_call_repeat1] = STATE(10727),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9535] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(9647),
    [sym_splat_argument] = STATE(9647),
    [sym_hash_splat_argument] = STATE(9647),
    [sym_block_argument] = STATE(9647),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(10728),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(9647),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9536] = {
    [sym_heredoc_body] = STATE(10729),
    [aux_sym_call_repeat1] = STATE(10729),
    [aux_sym_argument_list_repeat1] = STATE(10730),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_RPAREN] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(12646),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9537] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_RPAREN] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9538] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_RPAREN] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9539] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9540] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9541] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9542] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9543] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(13997),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9544] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_RPAREN] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9545] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9546] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9547] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9548] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_RPAREN] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9549] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_RPAREN] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9550] = {
    [aux_sym_exceptions_repeat1] = STATE(10733),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_RPAREN] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9551] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_RPAREN] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [9552] = {
    [sym_string] = STATE(9552),
    [aux_sym_chained_string_repeat1] = STATE(9552),
    [sym__string_start2] = ACTIONS(12810),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_RPAREN] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9553] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [9554] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [9555] = {
    [sym_heredoc_body] = STATE(9555),
    [aux_sym_call_repeat1] = STATE(9555),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9556] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4711),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(4711),
    [sym_operator_assignment] = STATE(4711),
    [sym_conditional] = STATE(4711),
    [sym_range] = STATE(4711),
    [sym_binary] = STATE(4711),
    [sym_unary] = STATE(4711),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4714),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7300),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(7304),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12650),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(7308),
    [sym_identifier] = ACTIONS(7308),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9557] = {
    [sym_heredoc_body] = STATE(9555),
    [aux_sym_call_repeat1] = STATE(9555),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9558] = {
    [aux_sym_argument_list_repeat1] = STATE(9558),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(13999),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9559] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10734),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_assignment] = STATE(10734),
    [sym_operator_assignment] = STATE(10734),
    [sym_conditional] = STATE(10734),
    [sym_range] = STATE(10734),
    [sym_binary] = STATE(10734),
    [sym_unary] = STATE(10734),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9560] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7486),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(7486),
    [sym_operator_assignment] = STATE(7486),
    [sym_conditional] = STATE(7486),
    [sym_range] = STATE(7486),
    [sym_binary] = STATE(7486),
    [sym_unary] = STATE(7486),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4703),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(7302),
    [sym__unary_minus2] = ACTIONS(3638),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(3600),
    [sym_identifier] = ACTIONS(3600),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9561] = {
    [aux_sym_exceptions_repeat1] = STATE(10735),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14002),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9562] = {
    [sym_heredoc_body] = STATE(9562),
    [aux_sym_call_repeat1] = STATE(9562),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9563] = {
    [sym_heredoc_body] = STATE(9562),
    [aux_sym_call_repeat1] = STATE(9562),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9564] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10736),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_assignment] = STATE(10736),
    [sym_operator_assignment] = STATE(10736),
    [sym_conditional] = STATE(10736),
    [sym_range] = STATE(10736),
    [sym_binary] = STATE(10736),
    [sym_unary] = STATE(10736),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9565] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7504),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2224),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2224),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(7504),
    [sym_operator_assignment] = STATE(7504),
    [sym_conditional] = STATE(7504),
    [sym_range] = STATE(7504),
    [sym_binary] = STATE(7504),
    [sym_unary] = STATE(7504),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(2223),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2224),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2224),
    [sym_false] = STATE(2224),
    [sym_nil] = STATE(2224),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1311),
    [sym__unary_minus2] = ACTIONS(3662),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3672),
    [anon_sym_defined_QMARK] = ACTIONS(3674),
    [anon_sym_not] = ACTIONS(3676),
    [anon_sym_BANG] = ACTIONS(3678),
    [anon_sym_TILDE] = ACTIONS(3678),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9566] = {
    [aux_sym_exceptions_repeat1] = STATE(10737),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14004),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9567] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3694),
    [sym__binary_star2] = ACTIONS(3696),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3698),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(3700),
    [anon_sym_AMP] = ACTIONS(3702),
    [anon_sym_LT] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(3708),
    [anon_sym_DOT_DOT] = ACTIONS(3710),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3712),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3714),
    [anon_sym_AMP_AMP] = ACTIONS(3714),
    [anon_sym_LT_LT] = ACTIONS(3716),
    [anon_sym_GT_GT] = ACTIONS(3716),
    [anon_sym_EQ_EQ] = ACTIONS(3718),
    [anon_sym_BANG_EQ] = ACTIONS(3714),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3714),
    [anon_sym_LT_EQ_GT] = ACTIONS(3714),
    [anon_sym_EQ_TILDE] = ACTIONS(3714),
    [anon_sym_BANG_TILDE] = ACTIONS(3714),
    [anon_sym_LT_EQ] = ACTIONS(3704),
    [anon_sym_GT] = ACTIONS(3704),
    [anon_sym_GT_EQ] = ACTIONS(3720),
    [anon_sym_CARET] = ACTIONS(3722),
    [anon_sym_PLUS] = ACTIONS(3724),
    [anon_sym_SLASH] = ACTIONS(3700),
    [anon_sym_PERCENT] = ACTIONS(3700),
    [sym_comment] = ACTIONS(87),
  },
  [9568] = {
    [aux_sym_exceptions_repeat1] = STATE(9568),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14006),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9569] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10738),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_assignment] = STATE(10738),
    [sym_operator_assignment] = STATE(10738),
    [sym_conditional] = STATE(10738),
    [sym_range] = STATE(10738),
    [sym_binary] = STATE(10738),
    [sym_unary] = STATE(10738),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9570] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7536),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2301),
    [sym_scope_resolution] = STATE(2299),
    [sym_call] = STATE(2299),
    [sym_method_call] = STATE(2301),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(7536),
    [sym_operator_assignment] = STATE(7536),
    [sym_conditional] = STATE(7536),
    [sym_range] = STATE(7536),
    [sym_binary] = STATE(7536),
    [sym_unary] = STATE(7536),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(2300),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2301),
    [sym__variable] = STATE(2299),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2301),
    [sym_false] = STATE(2301),
    [sym_nil] = STATE(2301),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2302),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1389),
    [sym__unary_minus2] = ACTIONS(3750),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3754),
    [anon_sym_break] = ACTIONS(3756),
    [anon_sym_next] = ACTIONS(3758),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(3760),
    [anon_sym_defined_QMARK] = ACTIONS(3762),
    [anon_sym_not] = ACTIONS(3764),
    [anon_sym_BANG] = ACTIONS(3766),
    [anon_sym_TILDE] = ACTIONS(3766),
    [sym_constant] = ACTIONS(3768),
    [sym_identifier] = ACTIONS(3768),
    [sym_instance_variable] = ACTIONS(3770),
    [sym_class_variable] = ACTIONS(3770),
    [sym_global_variable] = ACTIONS(3770),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(3768),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(3768),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9571] = {
    [aux_sym_exceptions_repeat1] = STATE(10739),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14009),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9572] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(3778),
    [sym__binary_star2] = ACTIONS(3780),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(3784),
    [anon_sym_AMP] = ACTIONS(3786),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(3788),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(3792),
    [anon_sym_DOT_DOT] = ACTIONS(3794),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3796),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(3798),
    [anon_sym_AMP_AMP] = ACTIONS(3798),
    [anon_sym_LT_LT] = ACTIONS(3800),
    [anon_sym_GT_GT] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3798),
    [anon_sym_BANG_EQ] = ACTIONS(3802),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3802),
    [anon_sym_LT_EQ_GT] = ACTIONS(3802),
    [anon_sym_EQ_TILDE] = ACTIONS(3802),
    [anon_sym_BANG_TILDE] = ACTIONS(3802),
    [anon_sym_LT_EQ] = ACTIONS(3788),
    [anon_sym_GT] = ACTIONS(3788),
    [anon_sym_GT_EQ] = ACTIONS(3804),
    [anon_sym_CARET] = ACTIONS(3782),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3784),
    [anon_sym_PERCENT] = ACTIONS(3784),
    [sym_comment] = ACTIONS(87),
  },
  [9573] = {
    [aux_sym_exceptions_repeat1] = STATE(9573),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14011),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9574] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10740),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2337),
    [sym_scope_resolution] = STATE(152),
    [sym_call] = STATE(152),
    [sym_method_call] = STATE(2337),
    [sym_assignment] = STATE(10740),
    [sym_operator_assignment] = STATE(10740),
    [sym_conditional] = STATE(10740),
    [sym_range] = STATE(10740),
    [sym_binary] = STATE(10740),
    [sym_unary] = STATE(10740),
    [sym_left_assignment_list] = STATE(2336),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2337),
    [sym__variable] = STATE(152),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2337),
    [sym_false] = STATE(2337),
    [sym_nil] = STATE(2337),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2225),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(3820),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3666),
    [anon_sym_break] = ACTIONS(3668),
    [anon_sym_next] = ACTIONS(3670),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(3822),
    [anon_sym_defined_QMARK] = ACTIONS(3824),
    [anon_sym_not] = ACTIONS(3826),
    [anon_sym_BANG] = ACTIONS(3828),
    [anon_sym_TILDE] = ACTIONS(3828),
    [sym_constant] = ACTIONS(267),
    [sym_identifier] = ACTIONS(267),
    [sym_instance_variable] = ACTIONS(269),
    [sym_class_variable] = ACTIONS(269),
    [sym_global_variable] = ACTIONS(269),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(267),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(267),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9575] = {
    [anon_sym_DOT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [9576] = {
    [anon_sym_DOT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [sym_comment] = ACTIONS(87),
  },
  [9577] = {
    [anon_sym_DOT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [sym_comment] = ACTIONS(87),
  },
  [9578] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [9579] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [9580] = {
    [sym_heredoc_body] = STATE(9580),
    [aux_sym_call_repeat1] = STATE(9580),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9581] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(586),
    [sym_scope_resolution] = STATE(581),
    [sym_call] = STATE(581),
    [sym_method_call] = STATE(586),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(4883),
    [sym_operator_assignment] = STATE(4883),
    [sym_conditional] = STATE(4883),
    [sym_range] = STATE(4883),
    [sym_binary] = STATE(4883),
    [sym_unary] = STATE(4883),
    [sym_left_assignment_list] = STATE(585),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(586),
    [sym__variable] = STATE(581),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(586),
    [sym_false] = STATE(586),
    [sym_nil] = STATE(586),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4886),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7525),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(1053),
    [sym__identifier_hash_key2] = ACTIONS(7529),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12680),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1061),
    [anon_sym_yield] = ACTIONS(1063),
    [anon_sym_break] = ACTIONS(1065),
    [anon_sym_next] = ACTIONS(1067),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1473),
    [anon_sym_defined_QMARK] = ACTIONS(1071),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_BANG] = ACTIONS(1077),
    [anon_sym_TILDE] = ACTIONS(1077),
    [sym_constant] = ACTIONS(7531),
    [sym_identifier] = ACTIONS(7531),
    [sym_instance_variable] = ACTIONS(1081),
    [sym_class_variable] = ACTIONS(1081),
    [sym_global_variable] = ACTIONS(1081),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1083),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1083),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9582] = {
    [sym_heredoc_body] = STATE(9580),
    [aux_sym_call_repeat1] = STATE(9580),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9583] = {
    [aux_sym_argument_list_repeat1] = STATE(9583),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14014),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9584] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10741),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_assignment] = STATE(10741),
    [sym_operator_assignment] = STATE(10741),
    [sym_conditional] = STATE(10741),
    [sym_range] = STATE(10741),
    [sym_binary] = STATE(10741),
    [sym_unary] = STATE(10741),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9585] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [9586] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [9587] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [9588] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10742),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10742),
    [sym_operator_assignment] = STATE(10742),
    [sym_conditional] = STATE(10742),
    [sym_range] = STATE(10742),
    [sym_binary] = STATE(10742),
    [sym_unary] = STATE(10742),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9589] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10743),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10743),
    [sym_operator_assignment] = STATE(10743),
    [sym_conditional] = STATE(10743),
    [sym_range] = STATE(10743),
    [sym_binary] = STATE(10743),
    [sym_unary] = STATE(10743),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9590] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10744),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10744),
    [sym_operator_assignment] = STATE(10744),
    [sym_conditional] = STATE(10744),
    [sym_range] = STATE(10744),
    [sym_binary] = STATE(10744),
    [sym_unary] = STATE(10744),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9591] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10745),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10745),
    [sym_operator_assignment] = STATE(10745),
    [sym_conditional] = STATE(10745),
    [sym_range] = STATE(10745),
    [sym_binary] = STATE(10745),
    [sym_unary] = STATE(10745),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9592] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10746),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10746),
    [sym_operator_assignment] = STATE(10746),
    [sym_conditional] = STATE(10746),
    [sym_range] = STATE(10746),
    [sym_binary] = STATE(10746),
    [sym_unary] = STATE(10746),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9593] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10747),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10747),
    [sym_operator_assignment] = STATE(10747),
    [sym_conditional] = STATE(10747),
    [sym_range] = STATE(10747),
    [sym_binary] = STATE(10747),
    [sym_unary] = STATE(10747),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9594] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10748),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10748),
    [sym_operator_assignment] = STATE(10748),
    [sym_conditional] = STATE(10748),
    [sym_range] = STATE(10748),
    [sym_binary] = STATE(10748),
    [sym_unary] = STATE(10748),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9595] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10749),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10749),
    [sym_operator_assignment] = STATE(10749),
    [sym_conditional] = STATE(10749),
    [sym_range] = STATE(10749),
    [sym_binary] = STATE(10749),
    [sym_unary] = STATE(10749),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9596] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10750),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10750),
    [sym_operator_assignment] = STATE(10750),
    [sym_conditional] = STATE(10750),
    [sym_range] = STATE(10750),
    [sym_binary] = STATE(10750),
    [sym_unary] = STATE(10750),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9597] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10751),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10751),
    [sym_operator_assignment] = STATE(10751),
    [sym_conditional] = STATE(10751),
    [sym_range] = STATE(10751),
    [sym_binary] = STATE(10751),
    [sym_unary] = STATE(10751),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9598] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10752),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10752),
    [sym_operator_assignment] = STATE(10752),
    [sym_conditional] = STATE(10752),
    [sym_range] = STATE(10752),
    [sym_binary] = STATE(10752),
    [sym_unary] = STATE(10752),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9599] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10753),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10753),
    [sym_operator_assignment] = STATE(10753),
    [sym_conditional] = STATE(10753),
    [sym_range] = STATE(10753),
    [sym_binary] = STATE(10753),
    [sym_unary] = STATE(10753),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9600] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10754),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_splat_argument] = STATE(10755),
    [sym_assignment] = STATE(10754),
    [sym_operator_assignment] = STATE(10754),
    [sym_conditional] = STATE(10754),
    [sym_range] = STATE(10754),
    [sym_binary] = STATE(10754),
    [sym_unary] = STATE(10754),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(10755),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9601] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10756),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(10756),
    [sym_operator_assignment] = STATE(10756),
    [sym_conditional] = STATE(10756),
    [sym_range] = STATE(10756),
    [sym_binary] = STATE(10756),
    [sym_unary] = STATE(10756),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9602] = {
    [sym_string] = STATE(10757),
    [aux_sym_chained_string_repeat1] = STATE(10757),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [9603] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [9604] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [9605] = {
    [sym_heredoc_body] = STATE(9605),
    [aux_sym_call_repeat1] = STATE(9605),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9606] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(4906),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(676),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(676),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(4906),
    [sym_operator_assignment] = STATE(4906),
    [sym_conditional] = STATE(4906),
    [sym_range] = STATE(4906),
    [sym_binary] = STATE(4906),
    [sym_unary] = STATE(4906),
    [sym_left_assignment_list] = STATE(675),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(676),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(676),
    [sym_false] = STATE(676),
    [sym_nil] = STATE(676),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(4909),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(7565),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(1169),
    [sym__identifier_hash_key2] = ACTIONS(7569),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12718),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(1183),
    [anon_sym_yield] = ACTIONS(1185),
    [anon_sym_break] = ACTIONS(1187),
    [anon_sym_next] = ACTIONS(1189),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(3398),
    [anon_sym_defined_QMARK] = ACTIONS(1211),
    [anon_sym_not] = ACTIONS(1213),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_TILDE] = ACTIONS(1217),
    [sym_constant] = ACTIONS(7571),
    [sym_identifier] = ACTIONS(7571),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [9607] = {
    [sym_heredoc_body] = STATE(9605),
    [aux_sym_call_repeat1] = STATE(9605),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9608] = {
    [aux_sym_argument_list_repeat1] = STATE(9608),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14017),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9609] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7606),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2378),
    [sym_scope_resolution] = STATE(2376),
    [sym_call] = STATE(2376),
    [sym_method_call] = STATE(2378),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(7606),
    [sym_operator_assignment] = STATE(7606),
    [sym_conditional] = STATE(7606),
    [sym_range] = STATE(7606),
    [sym_binary] = STATE(7606),
    [sym_unary] = STATE(7606),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(2377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2378),
    [sym__variable] = STATE(2376),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2378),
    [sym_false] = STATE(2378),
    [sym_nil] = STATE(2378),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2379),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7527),
    [sym__unary_minus2] = ACTIONS(3870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3872),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_break] = ACTIONS(3876),
    [anon_sym_next] = ACTIONS(3878),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3880),
    [anon_sym_defined_QMARK] = ACTIONS(3882),
    [anon_sym_not] = ACTIONS(3884),
    [anon_sym_BANG] = ACTIONS(3886),
    [anon_sym_TILDE] = ACTIONS(3886),
    [sym_constant] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_instance_variable] = ACTIONS(3890),
    [sym_class_variable] = ACTIONS(3890),
    [sym_global_variable] = ACTIONS(3890),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(3888),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(3888),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9610] = {
    [aux_sym_exceptions_repeat1] = STATE(10758),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14020),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9611] = {
    [anon_sym_DOT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [sym_comment] = ACTIONS(87),
  },
  [9612] = {
    [anon_sym_end] = ACTIONS(14022),
    [sym_comment] = ACTIONS(87),
  },
  [9613] = {
    [anon_sym_DOT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [sym_comment] = ACTIONS(87),
  },
  [9614] = {
    [anon_sym_DOT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [sym_comment] = ACTIONS(87),
  },
  [9615] = {
    [anon_sym_DOT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [sym_comment] = ACTIONS(87),
  },
  [9616] = {
    [anon_sym_DOT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [sym_comment] = ACTIONS(87),
  },
  [9617] = {
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13726),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13726),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_EQ] = ACTIONS(13726),
    [anon_sym_in] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [9618] = {
    [anon_sym_end] = ACTIONS(14024),
    [sym_comment] = ACTIONS(87),
  },
  [9619] = {
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10934),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10934),
    [anon_sym_EQ] = ACTIONS(10934),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_in] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10934),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [9620] = {
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_STAR_STAR] = ACTIONS(6517),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6517),
    [anon_sym_AMP_AMP] = ACTIONS(6517),
    [anon_sym_LT_LT] = ACTIONS(6517),
    [anon_sym_GT_GT] = ACTIONS(6517),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6517),
    [anon_sym_PLUS] = ACTIONS(6517),
    [anon_sym_SLASH] = ACTIONS(6517),
    [anon_sym_PERCENT] = ACTIONS(6517),
    [sym_comment] = ACTIONS(87),
  },
  [9621] = {
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_STAR_STAR] = ACTIONS(6521),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6521),
    [anon_sym_AMP_AMP] = ACTIONS(6521),
    [anon_sym_LT_LT] = ACTIONS(6521),
    [anon_sym_GT_GT] = ACTIONS(6521),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6521),
    [anon_sym_PLUS] = ACTIONS(6521),
    [anon_sym_SLASH] = ACTIONS(6521),
    [anon_sym_PERCENT] = ACTIONS(6521),
    [sym_comment] = ACTIONS(87),
  },
  [9622] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14026),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9623] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(14026),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14028),
  },
  [9624] = {
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_STAR_STAR] = ACTIONS(6529),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6529),
    [anon_sym_AMP_AMP] = ACTIONS(6529),
    [anon_sym_LT_LT] = ACTIONS(6529),
    [anon_sym_GT_GT] = ACTIONS(6529),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6529),
    [anon_sym_PLUS] = ACTIONS(6529),
    [anon_sym_SLASH] = ACTIONS(6529),
    [anon_sym_PERCENT] = ACTIONS(6529),
    [sym_comment] = ACTIONS(87),
  },
  [9625] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14030),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9626] = {
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_STAR_STAR] = ACTIONS(6542),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6542),
    [anon_sym_AMP_AMP] = ACTIONS(6542),
    [anon_sym_LT_LT] = ACTIONS(6542),
    [anon_sym_GT_GT] = ACTIONS(6542),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6542),
    [anon_sym_PLUS] = ACTIONS(6542),
    [anon_sym_SLASH] = ACTIONS(6542),
    [anon_sym_PERCENT] = ACTIONS(6542),
    [sym_comment] = ACTIONS(87),
  },
  [9627] = {
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_STAR_STAR] = ACTIONS(6546),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6546),
    [anon_sym_AMP_AMP] = ACTIONS(6546),
    [anon_sym_LT_LT] = ACTIONS(6546),
    [anon_sym_GT_GT] = ACTIONS(6546),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6546),
    [anon_sym_PLUS] = ACTIONS(6546),
    [anon_sym_SLASH] = ACTIONS(6546),
    [anon_sym_PERCENT] = ACTIONS(6546),
    [sym_comment] = ACTIONS(87),
  },
  [9628] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14032),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9629] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(14032),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14034),
  },
  [9630] = {
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_STAR_STAR] = ACTIONS(6554),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6554),
    [anon_sym_AMP_AMP] = ACTIONS(6554),
    [anon_sym_LT_LT] = ACTIONS(6554),
    [anon_sym_GT_GT] = ACTIONS(6554),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6554),
    [anon_sym_PLUS] = ACTIONS(6554),
    [anon_sym_SLASH] = ACTIONS(6554),
    [anon_sym_PERCENT] = ACTIONS(6554),
    [sym_comment] = ACTIONS(87),
  },
  [9631] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14036),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [9632] = {
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_STAR_STAR] = ACTIONS(7098),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7098),
    [anon_sym_AMP_AMP] = ACTIONS(7098),
    [anon_sym_LT_LT] = ACTIONS(7098),
    [anon_sym_GT_GT] = ACTIONS(7098),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7098),
    [anon_sym_PLUS] = ACTIONS(7098),
    [anon_sym_SLASH] = ACTIONS(7098),
    [anon_sym_PERCENT] = ACTIONS(7098),
    [sym_comment] = ACTIONS(87),
  },
  [9633] = {
    [anon_sym_DOT] = ACTIONS(14038),
    [anon_sym_COLON_COLON] = ACTIONS(14038),
    [sym_comment] = ACTIONS(87),
  },
  [9634] = {
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_STAR_STAR] = ACTIONS(7258),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7258),
    [anon_sym_AMP_AMP] = ACTIONS(7258),
    [anon_sym_LT_LT] = ACTIONS(7258),
    [anon_sym_GT_GT] = ACTIONS(7258),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7258),
    [anon_sym_PLUS] = ACTIONS(7258),
    [anon_sym_SLASH] = ACTIONS(7258),
    [anon_sym_PERCENT] = ACTIONS(7258),
    [sym_comment] = ACTIONS(87),
  },
  [9635] = {
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_STAR_STAR] = ACTIONS(7274),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7274),
    [anon_sym_AMP_AMP] = ACTIONS(7274),
    [anon_sym_LT_LT] = ACTIONS(7274),
    [anon_sym_GT_GT] = ACTIONS(7274),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7274),
    [anon_sym_PLUS] = ACTIONS(7274),
    [anon_sym_SLASH] = ACTIONS(7274),
    [anon_sym_PERCENT] = ACTIONS(7274),
    [sym_comment] = ACTIONS(87),
  },
  [9636] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(10768),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14040),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9637] = {
    [sym__statements] = STATE(5005),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(5006),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(5007),
    [sym_rescue] = STATE(5008),
    [sym__body_statement] = STATE(10769),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14042),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9638] = {
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_STAR_STAR] = ACTIONS(7730),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7730),
    [anon_sym_AMP_AMP] = ACTIONS(7730),
    [anon_sym_LT_LT] = ACTIONS(7730),
    [anon_sym_GT_GT] = ACTIONS(7730),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7730),
    [anon_sym_PLUS] = ACTIONS(7730),
    [anon_sym_SLASH] = ACTIONS(7730),
    [anon_sym_PERCENT] = ACTIONS(7730),
    [sym_comment] = ACTIONS(87),
  },
  [9639] = {
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_STAR_STAR] = ACTIONS(7788),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7788),
    [anon_sym_AMP_AMP] = ACTIONS(7788),
    [anon_sym_LT_LT] = ACTIONS(7788),
    [anon_sym_GT_GT] = ACTIONS(7788),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7788),
    [anon_sym_PLUS] = ACTIONS(7788),
    [anon_sym_SLASH] = ACTIONS(7788),
    [anon_sym_PERCENT] = ACTIONS(7788),
    [sym_comment] = ACTIONS(87),
  },
  [9640] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [9641] = {
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym__binary_minus2] = ACTIONS(7850),
    [sym__binary_star2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_RPAREN] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7852),
    [anon_sym_COMMA] = ACTIONS(7850),
    [anon_sym_PIPE] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7850),
    [anon_sym_AMP] = ACTIONS(7852),
    [anon_sym_EQ] = ACTIONS(7852),
    [anon_sym_LT] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_QMARK] = ACTIONS(7850),
    [anon_sym_DOT_DOT] = ACTIONS(7852),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7850),
    [anon_sym_and] = ACTIONS(7850),
    [anon_sym_or] = ACTIONS(7850),
    [anon_sym_PIPE_PIPE] = ACTIONS(7850),
    [anon_sym_AMP_AMP] = ACTIONS(7850),
    [anon_sym_LT_LT] = ACTIONS(7850),
    [anon_sym_GT_GT] = ACTIONS(7850),
    [anon_sym_EQ_EQ] = ACTIONS(7852),
    [anon_sym_BANG_EQ] = ACTIONS(7850),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7850),
    [anon_sym_LT_EQ_GT] = ACTIONS(7850),
    [anon_sym_EQ_TILDE] = ACTIONS(7850),
    [anon_sym_BANG_TILDE] = ACTIONS(7850),
    [anon_sym_LT_EQ] = ACTIONS(7852),
    [anon_sym_GT] = ACTIONS(7852),
    [anon_sym_GT_EQ] = ACTIONS(7850),
    [anon_sym_CARET] = ACTIONS(7850),
    [anon_sym_PLUS] = ACTIONS(7850),
    [anon_sym_SLASH] = ACTIONS(7850),
    [anon_sym_PERCENT] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
  },
  [9642] = {
    [anon_sym_RPAREN] = ACTIONS(14044),
    [sym_comment] = ACTIONS(87),
  },
  [9643] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [9644] = {
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [sym__binary_minus2] = ACTIONS(3158),
    [sym__binary_star2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_RPAREN] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(4982),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_PIPE] = ACTIONS(4982),
    [anon_sym_STAR_STAR] = ACTIONS(3158),
    [anon_sym_AMP] = ACTIONS(4982),
    [anon_sym_EQ] = ACTIONS(4982),
    [anon_sym_LT] = ACTIONS(4982),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [anon_sym_QMARK] = ACTIONS(3158),
    [anon_sym_DOT_DOT] = ACTIONS(4982),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(3158),
    [anon_sym_and] = ACTIONS(3158),
    [anon_sym_or] = ACTIONS(3158),
    [anon_sym_PIPE_PIPE] = ACTIONS(3158),
    [anon_sym_AMP_AMP] = ACTIONS(3158),
    [anon_sym_LT_LT] = ACTIONS(3158),
    [anon_sym_GT_GT] = ACTIONS(3158),
    [anon_sym_EQ_EQ] = ACTIONS(4982),
    [anon_sym_BANG_EQ] = ACTIONS(3158),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(3158),
    [anon_sym_LT_EQ_GT] = ACTIONS(3158),
    [anon_sym_EQ_TILDE] = ACTIONS(3158),
    [anon_sym_BANG_TILDE] = ACTIONS(3158),
    [anon_sym_LT_EQ] = ACTIONS(4982),
    [anon_sym_GT] = ACTIONS(4982),
    [anon_sym_GT_EQ] = ACTIONS(3158),
    [anon_sym_CARET] = ACTIONS(3158),
    [anon_sym_PLUS] = ACTIONS(3158),
    [anon_sym_SLASH] = ACTIONS(3158),
    [anon_sym_PERCENT] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [9645] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(14046),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [9646] = {
    [sym_heredoc_body] = STATE(9646),
    [aux_sym_call_repeat1] = STATE(9646),
    [sym__heredoc_body_start2] = ACTIONS(14048),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9647] = {
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9648] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(4990),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(867),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(867),
    [sym__argument] = STATE(10772),
    [sym_splat_argument] = STATE(10772),
    [sym_hash_splat_argument] = STATE(10772),
    [sym_block_argument] = STATE(10772),
    [sym_assignment] = STATE(4990),
    [sym_operator_assignment] = STATE(4990),
    [sym_conditional] = STATE(4990),
    [sym_range] = STATE(4990),
    [sym_binary] = STATE(4990),
    [sym_unary] = STATE(4990),
    [sym_left_assignment_list] = STATE(866),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(867),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(867),
    [sym_false] = STATE(867),
    [sym_nil] = STATE(867),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(4994),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10772),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7649),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(1501),
    [sym__identifier_hash_key2] = ACTIONS(7653),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12778),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1509),
    [anon_sym_yield] = ACTIONS(1511),
    [anon_sym_break] = ACTIONS(1513),
    [anon_sym_next] = ACTIONS(1515),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1517),
    [anon_sym_defined_QMARK] = ACTIONS(1519),
    [anon_sym_not] = ACTIONS(1521),
    [anon_sym_BANG] = ACTIONS(1523),
    [anon_sym_TILDE] = ACTIONS(1523),
    [sym_constant] = ACTIONS(7657),
    [sym_identifier] = ACTIONS(7657),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9649] = {
    [sym_heredoc_body] = STATE(9646),
    [aux_sym_call_repeat1] = STATE(9646),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9650] = {
    [aux_sym_argument_list_repeat1] = STATE(9650),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14051),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9651] = {
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_STAR_STAR] = ACTIONS(7970),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7970),
    [anon_sym_AMP_AMP] = ACTIONS(7970),
    [anon_sym_LT_LT] = ACTIONS(7970),
    [anon_sym_GT_GT] = ACTIONS(7970),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7970),
    [anon_sym_PLUS] = ACTIONS(7970),
    [anon_sym_SLASH] = ACTIONS(7970),
    [anon_sym_PERCENT] = ACTIONS(7970),
    [sym_comment] = ACTIONS(87),
  },
  [9652] = {
    [sym_elsif] = STATE(10774),
    [sym_else] = STATE(10774),
    [sym__if_tail] = STATE(10774),
    [anon_sym_end] = ACTIONS(14054),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9653] = {
    [anon_sym_end] = ACTIONS(14054),
    [sym_comment] = ACTIONS(87),
  },
  [9654] = {
    [sym__statements] = STATE(10775),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(10774),
    [sym_else] = STATE(10774),
    [sym__if_tail] = STATE(10774),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14056),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9655] = {
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_STAR_STAR] = ACTIONS(8176),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8176),
    [anon_sym_AMP_AMP] = ACTIONS(8176),
    [anon_sym_LT_LT] = ACTIONS(8176),
    [anon_sym_GT_GT] = ACTIONS(8176),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8176),
    [anon_sym_PLUS] = ACTIONS(8176),
    [anon_sym_SLASH] = ACTIONS(8176),
    [anon_sym_PERCENT] = ACTIONS(8176),
    [sym_comment] = ACTIONS(87),
  },
  [9656] = {
    [sym_else] = STATE(10777),
    [anon_sym_end] = ACTIONS(14058),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9657] = {
    [anon_sym_end] = ACTIONS(14058),
    [sym_comment] = ACTIONS(87),
  },
  [9658] = {
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_STAR_STAR] = ACTIONS(8352),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8352),
    [anon_sym_AMP_AMP] = ACTIONS(8352),
    [anon_sym_LT_LT] = ACTIONS(8352),
    [anon_sym_GT_GT] = ACTIONS(8352),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8352),
    [anon_sym_PLUS] = ACTIONS(8352),
    [anon_sym_SLASH] = ACTIONS(8352),
    [anon_sym_PERCENT] = ACTIONS(8352),
    [sym_comment] = ACTIONS(87),
  },
  [9659] = {
    [anon_sym_end] = ACTIONS(14060),
    [sym_comment] = ACTIONS(87),
  },
  [9660] = {
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_STAR_STAR] = ACTIONS(8432),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8432),
    [anon_sym_AMP_AMP] = ACTIONS(8432),
    [anon_sym_LT_LT] = ACTIONS(8432),
    [anon_sym_GT_GT] = ACTIONS(8432),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8432),
    [anon_sym_PLUS] = ACTIONS(8432),
    [anon_sym_SLASH] = ACTIONS(8432),
    [anon_sym_PERCENT] = ACTIONS(8432),
    [sym_comment] = ACTIONS(87),
  },
  [9661] = {
    [anon_sym_end] = ACTIONS(14062),
    [sym_comment] = ACTIONS(87),
  },
  [9662] = {
    [sym__statements] = STATE(10781),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14064),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9663] = {
    [anon_sym_end] = ACTIONS(14066),
    [sym_comment] = ACTIONS(87),
  },
  [9664] = {
    [sym_when] = STATE(10783),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [9665] = {
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_STAR_STAR] = ACTIONS(8696),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8696),
    [anon_sym_AMP_AMP] = ACTIONS(8696),
    [anon_sym_LT_LT] = ACTIONS(8696),
    [anon_sym_GT_GT] = ACTIONS(8696),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8696),
    [anon_sym_PLUS] = ACTIONS(8696),
    [anon_sym_SLASH] = ACTIONS(8696),
    [anon_sym_PERCENT] = ACTIONS(8696),
    [sym_comment] = ACTIONS(87),
  },
  [9666] = {
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_STAR_STAR] = ACTIONS(9229),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9229),
    [anon_sym_AMP_AMP] = ACTIONS(9229),
    [anon_sym_LT_LT] = ACTIONS(9229),
    [anon_sym_GT_GT] = ACTIONS(9229),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9229),
    [anon_sym_PLUS] = ACTIONS(9229),
    [anon_sym_SLASH] = ACTIONS(9229),
    [anon_sym_PERCENT] = ACTIONS(9229),
    [sym_comment] = ACTIONS(87),
  },
  [9667] = {
    [anon_sym_end] = ACTIONS(14068),
    [sym_comment] = ACTIONS(87),
  },
  [9668] = {
    [sym_ensure] = STATE(10785),
    [anon_sym_end] = ACTIONS(14068),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [9669] = {
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_STAR_STAR] = ACTIONS(9457),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9457),
    [anon_sym_AMP_AMP] = ACTIONS(9457),
    [anon_sym_LT_LT] = ACTIONS(9457),
    [anon_sym_GT_GT] = ACTIONS(9457),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9457),
    [anon_sym_PLUS] = ACTIONS(9457),
    [anon_sym_SLASH] = ACTIONS(9457),
    [anon_sym_PERCENT] = ACTIONS(9457),
    [sym_comment] = ACTIONS(87),
  },
  [9670] = {
    [sym__heredoc_body_start2] = ACTIONS(9486),
    [sym__binary_minus2] = ACTIONS(9486),
    [sym__binary_star2] = ACTIONS(9486),
    [anon_sym_LBRACE] = ACTIONS(9486),
    [anon_sym_RPAREN] = ACTIONS(9486),
    [anon_sym_DOT] = ACTIONS(9488),
    [anon_sym_COMMA] = ACTIONS(9486),
    [anon_sym_PIPE] = ACTIONS(9488),
    [anon_sym_STAR_STAR] = ACTIONS(9486),
    [anon_sym_AMP] = ACTIONS(9488),
    [anon_sym_EQ] = ACTIONS(9488),
    [anon_sym_LT] = ACTIONS(9488),
    [anon_sym_do] = ACTIONS(9486),
    [anon_sym_LBRACK] = ACTIONS(9486),
    [anon_sym_COLON_COLON2] = ACTIONS(9486),
    [anon_sym_AMP_DOT] = ACTIONS(9486),
    [anon_sym_QMARK] = ACTIONS(9486),
    [anon_sym_DOT_DOT] = ACTIONS(9488),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9486),
    [anon_sym_and] = ACTIONS(9486),
    [anon_sym_or] = ACTIONS(9486),
    [anon_sym_PIPE_PIPE] = ACTIONS(9486),
    [anon_sym_AMP_AMP] = ACTIONS(9486),
    [anon_sym_LT_LT] = ACTIONS(9486),
    [anon_sym_GT_GT] = ACTIONS(9486),
    [anon_sym_EQ_EQ] = ACTIONS(9488),
    [anon_sym_BANG_EQ] = ACTIONS(9486),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9486),
    [anon_sym_LT_EQ_GT] = ACTIONS(9486),
    [anon_sym_EQ_TILDE] = ACTIONS(9486),
    [anon_sym_BANG_TILDE] = ACTIONS(9486),
    [anon_sym_LT_EQ] = ACTIONS(9488),
    [anon_sym_GT] = ACTIONS(9488),
    [anon_sym_GT_EQ] = ACTIONS(9486),
    [anon_sym_CARET] = ACTIONS(9486),
    [anon_sym_PLUS] = ACTIONS(9486),
    [anon_sym_SLASH] = ACTIONS(9486),
    [anon_sym_PERCENT] = ACTIONS(9486),
    [sym_comment] = ACTIONS(87),
  },
  [9671] = {
    [anon_sym_RBRACE] = ACTIONS(14070),
    [sym_comment] = ACTIONS(87),
  },
  [9672] = {
    [sym__heredoc_body_start2] = ACTIONS(9506),
    [sym__binary_minus2] = ACTIONS(9506),
    [sym__binary_star2] = ACTIONS(9506),
    [anon_sym_LBRACE] = ACTIONS(9506),
    [anon_sym_RPAREN] = ACTIONS(9506),
    [anon_sym_DOT] = ACTIONS(9508),
    [anon_sym_COMMA] = ACTIONS(9506),
    [anon_sym_PIPE] = ACTIONS(9508),
    [anon_sym_STAR_STAR] = ACTIONS(9506),
    [anon_sym_AMP] = ACTIONS(9508),
    [anon_sym_EQ] = ACTIONS(9508),
    [anon_sym_LT] = ACTIONS(9508),
    [anon_sym_do] = ACTIONS(9506),
    [anon_sym_LBRACK] = ACTIONS(9506),
    [anon_sym_COLON_COLON2] = ACTIONS(9506),
    [anon_sym_AMP_DOT] = ACTIONS(9506),
    [anon_sym_QMARK] = ACTIONS(9506),
    [anon_sym_DOT_DOT] = ACTIONS(9508),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9506),
    [anon_sym_and] = ACTIONS(9506),
    [anon_sym_or] = ACTIONS(9506),
    [anon_sym_PIPE_PIPE] = ACTIONS(9506),
    [anon_sym_AMP_AMP] = ACTIONS(9506),
    [anon_sym_LT_LT] = ACTIONS(9506),
    [anon_sym_GT_GT] = ACTIONS(9506),
    [anon_sym_EQ_EQ] = ACTIONS(9508),
    [anon_sym_BANG_EQ] = ACTIONS(9506),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9506),
    [anon_sym_LT_EQ_GT] = ACTIONS(9506),
    [anon_sym_EQ_TILDE] = ACTIONS(9506),
    [anon_sym_BANG_TILDE] = ACTIONS(9506),
    [anon_sym_LT_EQ] = ACTIONS(9508),
    [anon_sym_GT] = ACTIONS(9508),
    [anon_sym_GT_EQ] = ACTIONS(9506),
    [anon_sym_CARET] = ACTIONS(9506),
    [anon_sym_PLUS] = ACTIONS(9506),
    [anon_sym_SLASH] = ACTIONS(9506),
    [anon_sym_PERCENT] = ACTIONS(9506),
    [sym_comment] = ACTIONS(87),
  },
  [9673] = {
    [anon_sym_end] = ACTIONS(14072),
    [sym_comment] = ACTIONS(87),
  },
  [9674] = {
    [sym__statements] = STATE(10788),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14074),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9675] = {
    [sym__statements] = STATE(10788),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_heredoc_body] = STATE(10789),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__terminator] = STATE(10789),
    [sym__line_break2] = ACTIONS(14076),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(2145),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14074),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9676] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10790),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_assignment] = STATE(10790),
    [sym_operator_assignment] = STATE(10790),
    [sym_conditional] = STATE(10790),
    [sym_range] = STATE(10790),
    [sym_binary] = STATE(10790),
    [sym_unary] = STATE(10790),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [9677] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7708),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2456),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2456),
    [sym_splat_argument] = STATE(10791),
    [sym_assignment] = STATE(7708),
    [sym_operator_assignment] = STATE(7708),
    [sym_conditional] = STATE(7708),
    [sym_range] = STATE(7708),
    [sym_binary] = STATE(7708),
    [sym_unary] = STATE(7708),
    [sym__arg_or_splat_arg] = STATE(10791),
    [sym_left_assignment_list] = STATE(2455),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2456),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2456),
    [sym_false] = STATE(2456),
    [sym_nil] = STATE(2456),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2457),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7651),
    [sym__unary_minus2] = ACTIONS(3960),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3974),
    [anon_sym_break] = ACTIONS(3976),
    [anon_sym_next] = ACTIONS(3978),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(3994),
    [anon_sym_defined_QMARK] = ACTIONS(3996),
    [anon_sym_not] = ACTIONS(3998),
    [anon_sym_BANG] = ACTIONS(4000),
    [anon_sym_TILDE] = ACTIONS(4000),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [9678] = {
    [aux_sym_exceptions_repeat1] = STATE(10792),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14078),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9679] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4028),
    [sym__binary_star2] = ACTIONS(4030),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4032),
    [anon_sym_STAR_STAR] = ACTIONS(4034),
    [anon_sym_AMP] = ACTIONS(4036),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(4038),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4042),
    [anon_sym_DOT_DOT] = ACTIONS(4044),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4046),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4050),
    [anon_sym_AMP_AMP] = ACTIONS(4050),
    [anon_sym_LT_LT] = ACTIONS(4052),
    [anon_sym_GT_GT] = ACTIONS(4052),
    [anon_sym_EQ_EQ] = ACTIONS(4054),
    [anon_sym_BANG_EQ] = ACTIONS(4050),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4050),
    [anon_sym_LT_EQ_GT] = ACTIONS(4050),
    [anon_sym_EQ_TILDE] = ACTIONS(4050),
    [anon_sym_BANG_TILDE] = ACTIONS(4050),
    [anon_sym_LT_EQ] = ACTIONS(4038),
    [anon_sym_GT] = ACTIONS(4038),
    [anon_sym_GT_EQ] = ACTIONS(4056),
    [anon_sym_CARET] = ACTIONS(4058),
    [anon_sym_PLUS] = ACTIONS(4060),
    [anon_sym_SLASH] = ACTIONS(4034),
    [anon_sym_PERCENT] = ACTIONS(4034),
    [sym_comment] = ACTIONS(87),
  },
  [9680] = {
    [aux_sym_exceptions_repeat1] = STATE(9680),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14080),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9681] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [9682] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [9683] = {
    [sym_heredoc_body] = STATE(9683),
    [aux_sym_call_repeat1] = STATE(9683),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9684] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5077),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(894),
    [sym_scope_resolution] = STATE(670),
    [sym_call] = STATE(670),
    [sym_method_call] = STATE(894),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(5077),
    [sym_operator_assignment] = STATE(5077),
    [sym_conditional] = STATE(5077),
    [sym_range] = STATE(5077),
    [sym_binary] = STATE(5077),
    [sym_unary] = STATE(5077),
    [sym_left_assignment_list] = STATE(893),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(894),
    [sym__variable] = STATE(670),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(894),
    [sym_false] = STATE(894),
    [sym_nil] = STATE(894),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5080),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(7734),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(1541),
    [sym__identifier_hash_key2] = ACTIONS(7738),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12818),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1549),
    [anon_sym_yield] = ACTIONS(1551),
    [anon_sym_break] = ACTIONS(1553),
    [anon_sym_next] = ACTIONS(1555),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1557),
    [anon_sym_defined_QMARK] = ACTIONS(1559),
    [anon_sym_not] = ACTIONS(1561),
    [anon_sym_BANG] = ACTIONS(1563),
    [anon_sym_TILDE] = ACTIONS(1563),
    [sym_constant] = ACTIONS(7740),
    [sym_identifier] = ACTIONS(7740),
    [sym_instance_variable] = ACTIONS(1221),
    [sym_class_variable] = ACTIONS(1221),
    [sym_global_variable] = ACTIONS(1221),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1225),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1225),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9685] = {
    [sym_heredoc_body] = STATE(9683),
    [aux_sym_call_repeat1] = STATE(9683),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9686] = {
    [aux_sym_argument_list_repeat1] = STATE(9686),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14083),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9687] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10793),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_assignment] = STATE(10793),
    [sym_operator_assignment] = STATE(10793),
    [sym_conditional] = STATE(10793),
    [sym_range] = STATE(10793),
    [sym_binary] = STATE(10793),
    [sym_unary] = STATE(10793),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9688] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7742),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2511),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(2511),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(7742),
    [sym_operator_assignment] = STATE(7742),
    [sym_conditional] = STATE(7742),
    [sym_range] = STATE(7742),
    [sym_binary] = STATE(7742),
    [sym_unary] = STATE(7742),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(2510),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2511),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2511),
    [sym_false] = STATE(2511),
    [sym_nil] = STATE(2511),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2512),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(7736),
    [sym__unary_minus2] = ACTIONS(4080),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4082),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_break] = ACTIONS(4086),
    [anon_sym_next] = ACTIONS(4088),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4090),
    [anon_sym_defined_QMARK] = ACTIONS(4092),
    [anon_sym_not] = ACTIONS(4094),
    [anon_sym_BANG] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4096),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9689] = {
    [aux_sym_exceptions_repeat1] = STATE(10794),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14086),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9690] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4114),
    [sym__binary_star2] = ACTIONS(4116),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4118),
    [anon_sym_STAR_STAR] = ACTIONS(4120),
    [anon_sym_AMP] = ACTIONS(4122),
    [anon_sym_LT] = ACTIONS(4124),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4128),
    [anon_sym_DOT_DOT] = ACTIONS(4130),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4132),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4136),
    [anon_sym_AMP_AMP] = ACTIONS(4136),
    [anon_sym_LT_LT] = ACTIONS(4138),
    [anon_sym_GT_GT] = ACTIONS(4138),
    [anon_sym_EQ_EQ] = ACTIONS(4140),
    [anon_sym_BANG_EQ] = ACTIONS(4136),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4136),
    [anon_sym_LT_EQ_GT] = ACTIONS(4136),
    [anon_sym_EQ_TILDE] = ACTIONS(4136),
    [anon_sym_BANG_TILDE] = ACTIONS(4136),
    [anon_sym_LT_EQ] = ACTIONS(4124),
    [anon_sym_GT] = ACTIONS(4124),
    [anon_sym_GT_EQ] = ACTIONS(4142),
    [anon_sym_CARET] = ACTIONS(4144),
    [anon_sym_PLUS] = ACTIONS(4146),
    [anon_sym_SLASH] = ACTIONS(4120),
    [anon_sym_PERCENT] = ACTIONS(4120),
    [sym_comment] = ACTIONS(87),
  },
  [9691] = {
    [aux_sym_exceptions_repeat1] = STATE(9691),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14088),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9692] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4166),
    [sym__binary_star2] = ACTIONS(4168),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4172),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4174),
    [anon_sym_AMP] = ACTIONS(4176),
    [anon_sym_LT] = ACTIONS(4178),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4180),
    [anon_sym_DOT_DOT] = ACTIONS(4182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4184),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4186),
    [anon_sym_AMP_AMP] = ACTIONS(4186),
    [anon_sym_LT_LT] = ACTIONS(4188),
    [anon_sym_GT_GT] = ACTIONS(4188),
    [anon_sym_EQ_EQ] = ACTIONS(4190),
    [anon_sym_BANG_EQ] = ACTIONS(4186),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4186),
    [anon_sym_LT_EQ_GT] = ACTIONS(4186),
    [anon_sym_EQ_TILDE] = ACTIONS(4186),
    [anon_sym_BANG_TILDE] = ACTIONS(4186),
    [anon_sym_LT_EQ] = ACTIONS(4178),
    [anon_sym_GT] = ACTIONS(4178),
    [anon_sym_GT_EQ] = ACTIONS(4192),
    [anon_sym_CARET] = ACTIONS(4194),
    [anon_sym_PLUS] = ACTIONS(4196),
    [anon_sym_SLASH] = ACTIONS(4174),
    [anon_sym_PERCENT] = ACTIONS(4174),
    [sym_comment] = ACTIONS(87),
  },
  [9693] = {
    [aux_sym_exceptions_repeat1] = STATE(9693),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14091),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9694] = {
    [sym_heredoc_body] = STATE(9694),
    [aux_sym_call_repeat1] = STATE(9694),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9695] = {
    [sym_heredoc_body] = STATE(9694),
    [aux_sym_call_repeat1] = STATE(9694),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9696] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10795),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_assignment] = STATE(10795),
    [sym_operator_assignment] = STATE(10795),
    [sym_conditional] = STATE(10795),
    [sym_range] = STATE(10795),
    [sym_binary] = STATE(10795),
    [sym_unary] = STATE(10795),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9697] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [9698] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(7775),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2590),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(2590),
    [sym_splat_argument] = STATE(8905),
    [sym_assignment] = STATE(7775),
    [sym_operator_assignment] = STATE(7775),
    [sym_conditional] = STATE(7775),
    [sym_range] = STATE(7775),
    [sym_binary] = STATE(7775),
    [sym_unary] = STATE(7775),
    [sym__arg_or_splat_arg] = STATE(8905),
    [sym_left_assignment_list] = STATE(2589),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2590),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2590),
    [sym_false] = STATE(2590),
    [sym_nil] = STATE(2590),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(10926),
    [sym__unary_minus2] = ACTIONS(4218),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4228),
    [anon_sym_defined_QMARK] = ACTIONS(4230),
    [anon_sym_not] = ACTIONS(4232),
    [anon_sym_BANG] = ACTIONS(4234),
    [anon_sym_TILDE] = ACTIONS(4234),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9699] = {
    [aux_sym_exceptions_repeat1] = STATE(10796),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(14094),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9700] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4256),
    [sym__binary_star2] = ACTIONS(4258),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4260),
    [anon_sym_STAR_STAR] = ACTIONS(4262),
    [anon_sym_AMP] = ACTIONS(4264),
    [anon_sym_LT] = ACTIONS(4266),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4270),
    [anon_sym_DOT_DOT] = ACTIONS(4272),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4274),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4278),
    [anon_sym_AMP_AMP] = ACTIONS(4278),
    [anon_sym_LT_LT] = ACTIONS(4280),
    [anon_sym_GT_GT] = ACTIONS(4280),
    [anon_sym_EQ_EQ] = ACTIONS(4282),
    [anon_sym_BANG_EQ] = ACTIONS(4278),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4278),
    [anon_sym_LT_EQ_GT] = ACTIONS(4278),
    [anon_sym_EQ_TILDE] = ACTIONS(4278),
    [anon_sym_BANG_TILDE] = ACTIONS(4278),
    [anon_sym_LT_EQ] = ACTIONS(4266),
    [anon_sym_GT] = ACTIONS(4266),
    [anon_sym_GT_EQ] = ACTIONS(4284),
    [anon_sym_CARET] = ACTIONS(4286),
    [anon_sym_PLUS] = ACTIONS(4288),
    [anon_sym_SLASH] = ACTIONS(4262),
    [anon_sym_PERCENT] = ACTIONS(4262),
    [sym_comment] = ACTIONS(87),
  },
  [9701] = {
    [aux_sym_exceptions_repeat1] = STATE(9701),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14096),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9702] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [ts_builtin_sym_end] = ACTIONS(10934),
    [anon_sym___END__] = ACTIONS(10936),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_end] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_rescue] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_when] = ACTIONS(10936),
    [anon_sym_elsif] = ACTIONS(10936),
    [anon_sym_else] = ACTIONS(10936),
    [anon_sym_then] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_ensure] = ACTIONS(10936),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [9703] = {
    [sym__line_break2] = ACTIONS(13726),
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [ts_builtin_sym_end] = ACTIONS(13726),
    [anon_sym___END__] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_end] = ACTIONS(13726),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_when] = ACTIONS(13726),
    [anon_sym_elsif] = ACTIONS(13726),
    [anon_sym_else] = ACTIONS(13726),
    [anon_sym_then] = ACTIONS(13726),
    [anon_sym_ensure] = ACTIONS(13726),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [9704] = {
    [anon_sym_end] = ACTIONS(14099),
    [sym_comment] = ACTIONS(87),
  },
  [9705] = {
    [sym_heredoc_body] = STATE(9705),
    [aux_sym_call_repeat1] = STATE(9705),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9706] = {
    [sym_heredoc_body] = STATE(9705),
    [aux_sym_call_repeat1] = STATE(9705),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9707] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10798),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_assignment] = STATE(10798),
    [sym_operator_assignment] = STATE(10798),
    [sym_conditional] = STATE(10798),
    [sym_range] = STATE(10798),
    [sym_binary] = STATE(10798),
    [sym_unary] = STATE(10798),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9708] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7823),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2701),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2701),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(7823),
    [sym_operator_assignment] = STATE(7823),
    [sym_conditional] = STATE(7823),
    [sym_range] = STATE(7823),
    [sym_binary] = STATE(7823),
    [sym_unary] = STATE(7823),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(2700),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2701),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2701),
    [sym_false] = STATE(2701),
    [sym_nil] = STATE(2701),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1733),
    [sym__unary_minus2] = ACTIONS(4354),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4364),
    [anon_sym_defined_QMARK] = ACTIONS(4366),
    [anon_sym_not] = ACTIONS(4368),
    [anon_sym_BANG] = ACTIONS(4370),
    [anon_sym_TILDE] = ACTIONS(4370),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9709] = {
    [aux_sym_exceptions_repeat1] = STATE(10799),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14101),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9710] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4386),
    [sym__binary_star2] = ACTIONS(4388),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4390),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4392),
    [anon_sym_AMP] = ACTIONS(4394),
    [anon_sym_LT] = ACTIONS(4396),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4400),
    [anon_sym_DOT_DOT] = ACTIONS(4402),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4404),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4406),
    [anon_sym_AMP_AMP] = ACTIONS(4406),
    [anon_sym_LT_LT] = ACTIONS(4408),
    [anon_sym_GT_GT] = ACTIONS(4408),
    [anon_sym_EQ_EQ] = ACTIONS(4410),
    [anon_sym_BANG_EQ] = ACTIONS(4406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4406),
    [anon_sym_LT_EQ_GT] = ACTIONS(4406),
    [anon_sym_EQ_TILDE] = ACTIONS(4406),
    [anon_sym_BANG_TILDE] = ACTIONS(4406),
    [anon_sym_LT_EQ] = ACTIONS(4396),
    [anon_sym_GT] = ACTIONS(4396),
    [anon_sym_GT_EQ] = ACTIONS(4412),
    [anon_sym_CARET] = ACTIONS(4414),
    [anon_sym_PLUS] = ACTIONS(4416),
    [anon_sym_SLASH] = ACTIONS(4392),
    [anon_sym_PERCENT] = ACTIONS(4392),
    [sym_comment] = ACTIONS(87),
  },
  [9711] = {
    [aux_sym_exceptions_repeat1] = STATE(9711),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14103),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9712] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9713] = {
    [sym_heredoc_body] = STATE(10800),
    [aux_sym_call_repeat1] = STATE(10800),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [9714] = {
    [sym_heredoc_body] = STATE(10800),
    [aux_sym_call_repeat1] = STATE(10800),
    [aux_sym_argument_list_repeat1] = STATE(10801),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_elsif] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [9715] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9716] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [9717] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10802),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10802),
    [sym_operator_assignment] = STATE(10802),
    [sym_conditional] = STATE(10802),
    [sym_range] = STATE(10802),
    [sym_binary] = STATE(10802),
    [sym_unary] = STATE(10802),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9718] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10803),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10803),
    [sym_operator_assignment] = STATE(10803),
    [sym_conditional] = STATE(10803),
    [sym_range] = STATE(10803),
    [sym_binary] = STATE(10803),
    [sym_unary] = STATE(10803),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9719] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10804),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10804),
    [sym_operator_assignment] = STATE(10804),
    [sym_conditional] = STATE(10804),
    [sym_range] = STATE(10804),
    [sym_binary] = STATE(10804),
    [sym_unary] = STATE(10804),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9720] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10805),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10805),
    [sym_operator_assignment] = STATE(10805),
    [sym_conditional] = STATE(10805),
    [sym_range] = STATE(10805),
    [sym_binary] = STATE(10805),
    [sym_unary] = STATE(10805),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9721] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10806),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10806),
    [sym_operator_assignment] = STATE(10806),
    [sym_conditional] = STATE(10806),
    [sym_range] = STATE(10806),
    [sym_binary] = STATE(10806),
    [sym_unary] = STATE(10806),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9722] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10807),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10807),
    [sym_operator_assignment] = STATE(10807),
    [sym_conditional] = STATE(10807),
    [sym_range] = STATE(10807),
    [sym_binary] = STATE(10807),
    [sym_unary] = STATE(10807),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9723] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10808),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10808),
    [sym_operator_assignment] = STATE(10808),
    [sym_conditional] = STATE(10808),
    [sym_range] = STATE(10808),
    [sym_binary] = STATE(10808),
    [sym_unary] = STATE(10808),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9724] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10809),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10809),
    [sym_operator_assignment] = STATE(10809),
    [sym_conditional] = STATE(10809),
    [sym_range] = STATE(10809),
    [sym_binary] = STATE(10809),
    [sym_unary] = STATE(10809),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9725] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10810),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10810),
    [sym_operator_assignment] = STATE(10810),
    [sym_conditional] = STATE(10810),
    [sym_range] = STATE(10810),
    [sym_binary] = STATE(10810),
    [sym_unary] = STATE(10810),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9726] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10811),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10811),
    [sym_operator_assignment] = STATE(10811),
    [sym_conditional] = STATE(10811),
    [sym_range] = STATE(10811),
    [sym_binary] = STATE(10811),
    [sym_unary] = STATE(10811),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9727] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10812),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10812),
    [sym_operator_assignment] = STATE(10812),
    [sym_conditional] = STATE(10812),
    [sym_range] = STATE(10812),
    [sym_binary] = STATE(10812),
    [sym_unary] = STATE(10812),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9728] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10813),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10813),
    [sym_operator_assignment] = STATE(10813),
    [sym_conditional] = STATE(10813),
    [sym_range] = STATE(10813),
    [sym_binary] = STATE(10813),
    [sym_unary] = STATE(10813),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9729] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10814),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_splat_argument] = STATE(10815),
    [sym_assignment] = STATE(10814),
    [sym_operator_assignment] = STATE(10814),
    [sym_conditional] = STATE(10814),
    [sym_range] = STATE(10814),
    [sym_binary] = STATE(10814),
    [sym_unary] = STATE(10814),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10815),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9730] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10816),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(10816),
    [sym_operator_assignment] = STATE(10816),
    [sym_conditional] = STATE(10816),
    [sym_range] = STATE(10816),
    [sym_binary] = STATE(10816),
    [sym_unary] = STATE(10816),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9731] = {
    [sym_string] = STATE(10817),
    [aux_sym_chained_string_repeat1] = STATE(10817),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_elsif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [9732] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_elsif] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [9733] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_elsif] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9734] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_elsif] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9735] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10818),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(10818),
    [sym_operator_assignment] = STATE(10818),
    [sym_conditional] = STATE(10818),
    [sym_range] = STATE(10818),
    [sym_binary] = STATE(10818),
    [sym_unary] = STATE(10818),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9736] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9737] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10819),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(10819),
    [sym_operator_assignment] = STATE(10819),
    [sym_conditional] = STATE(10819),
    [sym_range] = STATE(10819),
    [sym_binary] = STATE(10819),
    [sym_unary] = STATE(10819),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9738] = {
    [sym_heredoc_body] = STATE(10820),
    [aux_sym_call_repeat1] = STATE(10820),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9739] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10821),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9740] = {
    [sym_heredoc_body] = STATE(10822),
    [aux_sym_call_repeat1] = STATE(10822),
    [aux_sym_argument_list_repeat1] = STATE(10823),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(12900),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9741] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9742] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9743] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9744] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9745] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9746] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9747] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_elsif] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [9748] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14108),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9749] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9750] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9751] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9752] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9753] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9754] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_elsif] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9755] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_elsif] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9756] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10825),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(10825),
    [sym_operator_assignment] = STATE(10825),
    [sym_conditional] = STATE(10825),
    [sym_range] = STATE(10825),
    [sym_binary] = STATE(10825),
    [sym_unary] = STATE(10825),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9757] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_elsif] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9758] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10826),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(10826),
    [sym_operator_assignment] = STATE(10826),
    [sym_conditional] = STATE(10826),
    [sym_range] = STATE(10826),
    [sym_binary] = STATE(10826),
    [sym_unary] = STATE(10826),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9759] = {
    [sym_heredoc_body] = STATE(10827),
    [aux_sym_call_repeat1] = STATE(10827),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9760] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(10828),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14110),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9761] = {
    [sym_heredoc_body] = STATE(10829),
    [aux_sym_call_repeat1] = STATE(10829),
    [aux_sym_argument_list_repeat1] = STATE(10830),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(12908),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9762] = {
    [sym_heredoc_body] = STATE(9762),
    [aux_sym_call_repeat1] = STATE(9762),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_elsif] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9763] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5313),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(5313),
    [sym_operator_assignment] = STATE(5313),
    [sym_conditional] = STATE(5313),
    [sym_range] = STATE(5313),
    [sym_binary] = STATE(5313),
    [sym_unary] = STATE(5313),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5319),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(7974),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__identifier_hash_key2] = ACTIONS(7980),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12912),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(7998),
    [sym_identifier] = ACTIONS(7998),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9764] = {
    [sym_heredoc_body] = STATE(9762),
    [aux_sym_call_repeat1] = STATE(9762),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_elsif] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9765] = {
    [aux_sym_argument_list_repeat1] = STATE(9765),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14112),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9766] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_elsif] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9767] = {
    [aux_sym_exceptions_repeat1] = STATE(10832),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9768] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [9769] = {
    [sym_string] = STATE(9769),
    [aux_sym_chained_string_repeat1] = STATE(9769),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_elsif] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9770] = {
    [sym_elsif] = STATE(10833),
    [sym_else] = STATE(10833),
    [sym__if_tail] = STATE(10833),
    [anon_sym_end] = ACTIONS(14115),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [9771] = {
    [anon_sym_end] = ACTIONS(14115),
    [sym_comment] = ACTIONS(87),
  },
  [9772] = {
    [aux_sym_undef_repeat1] = STATE(9772),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_elsif] = ACTIONS(9314),
    [anon_sym_else] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [9773] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9774] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10834),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(10834),
    [sym_operator_assignment] = STATE(10834),
    [sym_conditional] = STATE(10834),
    [sym_range] = STATE(10834),
    [sym_binary] = STATE(10834),
    [sym_unary] = STATE(10834),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9775] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [9776] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [9777] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [9778] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10835),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10835),
    [sym_operator_assignment] = STATE(10835),
    [sym_conditional] = STATE(10835),
    [sym_range] = STATE(10835),
    [sym_binary] = STATE(10835),
    [sym_unary] = STATE(10835),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9779] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10836),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10836),
    [sym_operator_assignment] = STATE(10836),
    [sym_conditional] = STATE(10836),
    [sym_range] = STATE(10836),
    [sym_binary] = STATE(10836),
    [sym_unary] = STATE(10836),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9780] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10837),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10837),
    [sym_operator_assignment] = STATE(10837),
    [sym_conditional] = STATE(10837),
    [sym_range] = STATE(10837),
    [sym_binary] = STATE(10837),
    [sym_unary] = STATE(10837),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9781] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10838),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10838),
    [sym_operator_assignment] = STATE(10838),
    [sym_conditional] = STATE(10838),
    [sym_range] = STATE(10838),
    [sym_binary] = STATE(10838),
    [sym_unary] = STATE(10838),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9782] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10839),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10839),
    [sym_operator_assignment] = STATE(10839),
    [sym_conditional] = STATE(10839),
    [sym_range] = STATE(10839),
    [sym_binary] = STATE(10839),
    [sym_unary] = STATE(10839),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9783] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10840),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10840),
    [sym_operator_assignment] = STATE(10840),
    [sym_conditional] = STATE(10840),
    [sym_range] = STATE(10840),
    [sym_binary] = STATE(10840),
    [sym_unary] = STATE(10840),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9784] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10841),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10841),
    [sym_operator_assignment] = STATE(10841),
    [sym_conditional] = STATE(10841),
    [sym_range] = STATE(10841),
    [sym_binary] = STATE(10841),
    [sym_unary] = STATE(10841),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9785] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10842),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10842),
    [sym_operator_assignment] = STATE(10842),
    [sym_conditional] = STATE(10842),
    [sym_range] = STATE(10842),
    [sym_binary] = STATE(10842),
    [sym_unary] = STATE(10842),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9786] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10843),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10843),
    [sym_operator_assignment] = STATE(10843),
    [sym_conditional] = STATE(10843),
    [sym_range] = STATE(10843),
    [sym_binary] = STATE(10843),
    [sym_unary] = STATE(10843),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9787] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10844),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10844),
    [sym_operator_assignment] = STATE(10844),
    [sym_conditional] = STATE(10844),
    [sym_range] = STATE(10844),
    [sym_binary] = STATE(10844),
    [sym_unary] = STATE(10844),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9788] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10845),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10845),
    [sym_operator_assignment] = STATE(10845),
    [sym_conditional] = STATE(10845),
    [sym_range] = STATE(10845),
    [sym_binary] = STATE(10845),
    [sym_unary] = STATE(10845),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9789] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10846),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10846),
    [sym_operator_assignment] = STATE(10846),
    [sym_conditional] = STATE(10846),
    [sym_range] = STATE(10846),
    [sym_binary] = STATE(10846),
    [sym_unary] = STATE(10846),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9790] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10847),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_splat_argument] = STATE(10848),
    [sym_assignment] = STATE(10847),
    [sym_operator_assignment] = STATE(10847),
    [sym_conditional] = STATE(10847),
    [sym_range] = STATE(10847),
    [sym_binary] = STATE(10847),
    [sym_unary] = STATE(10847),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(10848),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9791] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10849),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(10849),
    [sym_operator_assignment] = STATE(10849),
    [sym_conditional] = STATE(10849),
    [sym_range] = STATE(10849),
    [sym_binary] = STATE(10849),
    [sym_unary] = STATE(10849),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9792] = {
    [sym_string] = STATE(10850),
    [aux_sym_chained_string_repeat1] = STATE(10850),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_elsif] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [9793] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_elsif] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [9794] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9795] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9796] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9797] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9798] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9799] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9800] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_elsif] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [9801] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14117),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9802] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9803] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9804] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9805] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9806] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9807] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_elsif] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9808] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5359),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(5359),
    [sym_operator_assignment] = STATE(5359),
    [sym_conditional] = STATE(5359),
    [sym_range] = STATE(5359),
    [sym_binary] = STATE(5359),
    [sym_unary] = STATE(5359),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5365),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8058),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__identifier_hash_key2] = ACTIONS(8064),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(12959),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8082),
    [sym_identifier] = ACTIONS(8082),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9809] = {
    [sym_heredoc_body] = STATE(9807),
    [aux_sym_call_repeat1] = STATE(9807),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_elsif] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9810] = {
    [aux_sym_argument_list_repeat1] = STATE(9810),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14119),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9811] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_elsif] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9812] = {
    [aux_sym_exceptions_repeat1] = STATE(10853),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9813] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [9814] = {
    [sym_string] = STATE(9814),
    [aux_sym_chained_string_repeat1] = STATE(9814),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_elsif] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9815] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_elsif] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [9816] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_elsif] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9817] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9818] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_elsif] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [9819] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10854),
    [sym_operator_assignment] = STATE(10854),
    [sym_conditional] = STATE(10854),
    [sym_range] = STATE(10854),
    [sym_binary] = STATE(10854),
    [sym_unary] = STATE(10854),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9820] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10855),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10855),
    [sym_operator_assignment] = STATE(10855),
    [sym_conditional] = STATE(10855),
    [sym_range] = STATE(10855),
    [sym_binary] = STATE(10855),
    [sym_unary] = STATE(10855),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9821] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10856),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10856),
    [sym_operator_assignment] = STATE(10856),
    [sym_conditional] = STATE(10856),
    [sym_range] = STATE(10856),
    [sym_binary] = STATE(10856),
    [sym_unary] = STATE(10856),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9822] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10857),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10857),
    [sym_operator_assignment] = STATE(10857),
    [sym_conditional] = STATE(10857),
    [sym_range] = STATE(10857),
    [sym_binary] = STATE(10857),
    [sym_unary] = STATE(10857),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9823] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10858),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10858),
    [sym_operator_assignment] = STATE(10858),
    [sym_conditional] = STATE(10858),
    [sym_range] = STATE(10858),
    [sym_binary] = STATE(10858),
    [sym_unary] = STATE(10858),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9824] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10859),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10859),
    [sym_operator_assignment] = STATE(10859),
    [sym_conditional] = STATE(10859),
    [sym_range] = STATE(10859),
    [sym_binary] = STATE(10859),
    [sym_unary] = STATE(10859),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9825] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10860),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10860),
    [sym_operator_assignment] = STATE(10860),
    [sym_conditional] = STATE(10860),
    [sym_range] = STATE(10860),
    [sym_binary] = STATE(10860),
    [sym_unary] = STATE(10860),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9826] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10861),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10861),
    [sym_operator_assignment] = STATE(10861),
    [sym_conditional] = STATE(10861),
    [sym_range] = STATE(10861),
    [sym_binary] = STATE(10861),
    [sym_unary] = STATE(10861),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9827] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10862),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10862),
    [sym_operator_assignment] = STATE(10862),
    [sym_conditional] = STATE(10862),
    [sym_range] = STATE(10862),
    [sym_binary] = STATE(10862),
    [sym_unary] = STATE(10862),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9828] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10863),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10863),
    [sym_operator_assignment] = STATE(10863),
    [sym_conditional] = STATE(10863),
    [sym_range] = STATE(10863),
    [sym_binary] = STATE(10863),
    [sym_unary] = STATE(10863),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9829] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10864),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10864),
    [sym_operator_assignment] = STATE(10864),
    [sym_conditional] = STATE(10864),
    [sym_range] = STATE(10864),
    [sym_binary] = STATE(10864),
    [sym_unary] = STATE(10864),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9830] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10865),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10865),
    [sym_operator_assignment] = STATE(10865),
    [sym_conditional] = STATE(10865),
    [sym_range] = STATE(10865),
    [sym_binary] = STATE(10865),
    [sym_unary] = STATE(10865),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9831] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7964),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(7964),
    [sym_operator_assignment] = STATE(7964),
    [sym_conditional] = STATE(7964),
    [sym_range] = STATE(7964),
    [sym_binary] = STATE(7964),
    [sym_unary] = STATE(7964),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11137),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9832] = {
    [aux_sym_exceptions_repeat1] = STATE(10866),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(12991),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_elsif] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9833] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(7964),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_splat_argument] = STATE(10867),
    [sym_assignment] = STATE(7964),
    [sym_operator_assignment] = STATE(7964),
    [sym_conditional] = STATE(7964),
    [sym_range] = STATE(7964),
    [sym_binary] = STATE(7964),
    [sym_unary] = STATE(7964),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(10867),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11137),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9834] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10868),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(10868),
    [sym_operator_assignment] = STATE(10868),
    [sym_conditional] = STATE(10868),
    [sym_range] = STATE(10868),
    [sym_binary] = STATE(10868),
    [sym_unary] = STATE(10868),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9835] = {
    [sym__line_break2] = ACTIONS(14122),
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [ts_builtin_sym_end] = ACTIONS(14122),
    [anon_sym___END__] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14122),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_end] = ACTIONS(14122),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_when] = ACTIONS(14122),
    [anon_sym_elsif] = ACTIONS(14122),
    [anon_sym_else] = ACTIONS(14122),
    [anon_sym_then] = ACTIONS(14122),
    [anon_sym_ensure] = ACTIONS(14122),
    [anon_sym_EQ_GT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14122),
    [anon_sym_AMP_AMP] = ACTIONS(14122),
    [anon_sym_LT_LT] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(14122),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14122),
    [anon_sym_PLUS] = ACTIONS(14122),
    [anon_sym_SLASH] = ACTIONS(14122),
    [anon_sym_PERCENT] = ACTIONS(14122),
    [sym_comment] = ACTIONS(87),
  },
  [9836] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10869),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_assignment] = STATE(10869),
    [sym_operator_assignment] = STATE(10869),
    [sym_conditional] = STATE(10869),
    [sym_range] = STATE(10869),
    [sym_binary] = STATE(10869),
    [sym_unary] = STATE(10869),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9837] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(7984),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2801),
    [sym_scope_resolution] = STATE(2799),
    [sym_call] = STATE(2799),
    [sym_method_call] = STATE(2801),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(7984),
    [sym_operator_assignment] = STATE(7984),
    [sym_conditional] = STATE(7984),
    [sym_range] = STATE(7984),
    [sym_binary] = STATE(7984),
    [sym_unary] = STATE(7984),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(2800),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2801),
    [sym__variable] = STATE(2799),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2801),
    [sym_false] = STATE(2801),
    [sym_nil] = STATE(2801),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2802),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1813),
    [sym__unary_minus2] = ACTIONS(4478),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4482),
    [anon_sym_break] = ACTIONS(4484),
    [anon_sym_next] = ACTIONS(4486),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4488),
    [anon_sym_defined_QMARK] = ACTIONS(4490),
    [anon_sym_not] = ACTIONS(4492),
    [anon_sym_BANG] = ACTIONS(4494),
    [anon_sym_TILDE] = ACTIONS(4494),
    [sym_constant] = ACTIONS(4496),
    [sym_identifier] = ACTIONS(4496),
    [sym_instance_variable] = ACTIONS(4498),
    [sym_class_variable] = ACTIONS(4498),
    [sym_global_variable] = ACTIONS(4498),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4496),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4496),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9838] = {
    [aux_sym_exceptions_repeat1] = STATE(10870),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14126),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9839] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4506),
    [sym__binary_star2] = ACTIONS(4508),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4510),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4512),
    [anon_sym_AMP] = ACTIONS(4514),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(4516),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4520),
    [anon_sym_DOT_DOT] = ACTIONS(4522),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4524),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4526),
    [anon_sym_AMP_AMP] = ACTIONS(4526),
    [anon_sym_LT_LT] = ACTIONS(4528),
    [anon_sym_GT_GT] = ACTIONS(4528),
    [anon_sym_EQ_EQ] = ACTIONS(4526),
    [anon_sym_BANG_EQ] = ACTIONS(4530),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4530),
    [anon_sym_LT_EQ_GT] = ACTIONS(4530),
    [anon_sym_EQ_TILDE] = ACTIONS(4530),
    [anon_sym_BANG_TILDE] = ACTIONS(4530),
    [anon_sym_LT_EQ] = ACTIONS(4516),
    [anon_sym_GT] = ACTIONS(4516),
    [anon_sym_GT_EQ] = ACTIONS(4532),
    [anon_sym_CARET] = ACTIONS(4510),
    [anon_sym_PLUS] = ACTIONS(4534),
    [anon_sym_SLASH] = ACTIONS(4512),
    [anon_sym_PERCENT] = ACTIONS(4512),
    [sym_comment] = ACTIONS(87),
  },
  [9840] = {
    [aux_sym_exceptions_repeat1] = STATE(9840),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14128),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9841] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10871),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2837),
    [sym_scope_resolution] = STATE(242),
    [sym_call] = STATE(242),
    [sym_method_call] = STATE(2837),
    [sym_assignment] = STATE(10871),
    [sym_operator_assignment] = STATE(10871),
    [sym_conditional] = STATE(10871),
    [sym_range] = STATE(10871),
    [sym_binary] = STATE(10871),
    [sym_unary] = STATE(10871),
    [sym_left_assignment_list] = STATE(2836),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2837),
    [sym__variable] = STATE(242),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2837),
    [sym_false] = STATE(2837),
    [sym_nil] = STATE(2837),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2702),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4548),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4358),
    [anon_sym_break] = ACTIONS(4360),
    [anon_sym_next] = ACTIONS(4362),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4550),
    [anon_sym_defined_QMARK] = ACTIONS(4552),
    [anon_sym_not] = ACTIONS(4554),
    [anon_sym_BANG] = ACTIONS(4556),
    [anon_sym_TILDE] = ACTIONS(4556),
    [sym_constant] = ACTIONS(445),
    [sym_identifier] = ACTIONS(445),
    [sym_instance_variable] = ACTIONS(447),
    [sym_class_variable] = ACTIONS(447),
    [sym_global_variable] = ACTIONS(447),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(445),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(445),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9842] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9843] = {
    [sym_heredoc_body] = STATE(10872),
    [aux_sym_call_repeat1] = STATE(10872),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [9844] = {
    [sym_heredoc_body] = STATE(10872),
    [aux_sym_call_repeat1] = STATE(10872),
    [aux_sym_argument_list_repeat1] = STATE(10873),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(11226),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [9845] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9846] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [9847] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10874),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10874),
    [sym_operator_assignment] = STATE(10874),
    [sym_conditional] = STATE(10874),
    [sym_range] = STATE(10874),
    [sym_binary] = STATE(10874),
    [sym_unary] = STATE(10874),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9848] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10875),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10875),
    [sym_operator_assignment] = STATE(10875),
    [sym_conditional] = STATE(10875),
    [sym_range] = STATE(10875),
    [sym_binary] = STATE(10875),
    [sym_unary] = STATE(10875),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9849] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10876),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10876),
    [sym_operator_assignment] = STATE(10876),
    [sym_conditional] = STATE(10876),
    [sym_range] = STATE(10876),
    [sym_binary] = STATE(10876),
    [sym_unary] = STATE(10876),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9850] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10877),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10877),
    [sym_operator_assignment] = STATE(10877),
    [sym_conditional] = STATE(10877),
    [sym_range] = STATE(10877),
    [sym_binary] = STATE(10877),
    [sym_unary] = STATE(10877),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9851] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10878),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10878),
    [sym_operator_assignment] = STATE(10878),
    [sym_conditional] = STATE(10878),
    [sym_range] = STATE(10878),
    [sym_binary] = STATE(10878),
    [sym_unary] = STATE(10878),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9852] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10879),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10879),
    [sym_operator_assignment] = STATE(10879),
    [sym_conditional] = STATE(10879),
    [sym_range] = STATE(10879),
    [sym_binary] = STATE(10879),
    [sym_unary] = STATE(10879),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9853] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10880),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10880),
    [sym_operator_assignment] = STATE(10880),
    [sym_conditional] = STATE(10880),
    [sym_range] = STATE(10880),
    [sym_binary] = STATE(10880),
    [sym_unary] = STATE(10880),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9854] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10881),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10881),
    [sym_operator_assignment] = STATE(10881),
    [sym_conditional] = STATE(10881),
    [sym_range] = STATE(10881),
    [sym_binary] = STATE(10881),
    [sym_unary] = STATE(10881),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9855] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10882),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10882),
    [sym_operator_assignment] = STATE(10882),
    [sym_conditional] = STATE(10882),
    [sym_range] = STATE(10882),
    [sym_binary] = STATE(10882),
    [sym_unary] = STATE(10882),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9856] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10883),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10883),
    [sym_operator_assignment] = STATE(10883),
    [sym_conditional] = STATE(10883),
    [sym_range] = STATE(10883),
    [sym_binary] = STATE(10883),
    [sym_unary] = STATE(10883),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9857] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10884),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10884),
    [sym_operator_assignment] = STATE(10884),
    [sym_conditional] = STATE(10884),
    [sym_range] = STATE(10884),
    [sym_binary] = STATE(10884),
    [sym_unary] = STATE(10884),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9858] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10885),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10885),
    [sym_operator_assignment] = STATE(10885),
    [sym_conditional] = STATE(10885),
    [sym_range] = STATE(10885),
    [sym_binary] = STATE(10885),
    [sym_unary] = STATE(10885),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9859] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10886),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_splat_argument] = STATE(10887),
    [sym_assignment] = STATE(10886),
    [sym_operator_assignment] = STATE(10886),
    [sym_conditional] = STATE(10886),
    [sym_range] = STATE(10886),
    [sym_binary] = STATE(10886),
    [sym_unary] = STATE(10886),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10887),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9860] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10888),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(10888),
    [sym_operator_assignment] = STATE(10888),
    [sym_conditional] = STATE(10888),
    [sym_range] = STATE(10888),
    [sym_binary] = STATE(10888),
    [sym_unary] = STATE(10888),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9861] = {
    [sym_string] = STATE(10889),
    [aux_sym_chained_string_repeat1] = STATE(10889),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [9862] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [9863] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9864] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9865] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10890),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(10890),
    [sym_operator_assignment] = STATE(10890),
    [sym_conditional] = STATE(10890),
    [sym_range] = STATE(10890),
    [sym_binary] = STATE(10890),
    [sym_unary] = STATE(10890),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9866] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9867] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10891),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(10891),
    [sym_operator_assignment] = STATE(10891),
    [sym_conditional] = STATE(10891),
    [sym_range] = STATE(10891),
    [sym_binary] = STATE(10891),
    [sym_unary] = STATE(10891),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9868] = {
    [sym_heredoc_body] = STATE(10892),
    [aux_sym_call_repeat1] = STATE(10892),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9869] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(10893),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14131),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9870] = {
    [sym_heredoc_body] = STATE(10894),
    [aux_sym_call_repeat1] = STATE(10894),
    [aux_sym_argument_list_repeat1] = STATE(10895),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(13050),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [9871] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9872] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [9873] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9874] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [9875] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9876] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9877] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [9878] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14133),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9879] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9880] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9881] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9882] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9883] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9884] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9885] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9886] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10897),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(10897),
    [sym_operator_assignment] = STATE(10897),
    [sym_conditional] = STATE(10897),
    [sym_range] = STATE(10897),
    [sym_binary] = STATE(10897),
    [sym_unary] = STATE(10897),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9887] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9888] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10898),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(10898),
    [sym_operator_assignment] = STATE(10898),
    [sym_conditional] = STATE(10898),
    [sym_range] = STATE(10898),
    [sym_binary] = STATE(10898),
    [sym_unary] = STATE(10898),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9889] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9890] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(10900),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14135),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9891] = {
    [sym_heredoc_body] = STATE(10901),
    [aux_sym_call_repeat1] = STATE(10901),
    [aux_sym_argument_list_repeat1] = STATE(10902),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(13058),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [9892] = {
    [sym_heredoc_body] = STATE(9892),
    [aux_sym_call_repeat1] = STATE(9892),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9893] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5445),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(5445),
    [sym_operator_assignment] = STATE(5445),
    [sym_conditional] = STATE(5445),
    [sym_range] = STATE(5445),
    [sym_binary] = STATE(5445),
    [sym_unary] = STATE(5445),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5451),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8180),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__identifier_hash_key2] = ACTIONS(8186),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13062),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8204),
    [sym_identifier] = ACTIONS(8204),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9894] = {
    [sym_heredoc_body] = STATE(9892),
    [aux_sym_call_repeat1] = STATE(9892),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9895] = {
    [aux_sym_argument_list_repeat1] = STATE(9895),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14137),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9896] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9897] = {
    [aux_sym_exceptions_repeat1] = STATE(10904),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [9898] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [9899] = {
    [sym_string] = STATE(9899),
    [aux_sym_chained_string_repeat1] = STATE(9899),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [9900] = {
    [aux_sym_undef_repeat1] = STATE(9900),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_else] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [9901] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2852),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2854),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(2854),
    [sym_operator_assignment] = STATE(2854),
    [sym_conditional] = STATE(2854),
    [sym_range] = STATE(2854),
    [sym_binary] = STATE(2854),
    [sym_unary] = STATE(2854),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [anon_sym_undef] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9902] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10905),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2857),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(2857),
    [sym_assignment] = STATE(10905),
    [sym_operator_assignment] = STATE(10905),
    [sym_conditional] = STATE(10905),
    [sym_range] = STATE(10905),
    [sym_binary] = STATE(10905),
    [sym_unary] = STATE(10905),
    [sym_left_assignment_list] = STATE(2856),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2857),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2857),
    [sym_false] = STATE(2857),
    [sym_nil] = STATE(2857),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2858),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4558),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4564),
    [anon_sym_break] = ACTIONS(4566),
    [anon_sym_next] = ACTIONS(4568),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4570),
    [anon_sym_defined_QMARK] = ACTIONS(4572),
    [anon_sym_not] = ACTIONS(4574),
    [anon_sym_BANG] = ACTIONS(4576),
    [anon_sym_TILDE] = ACTIONS(4576),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9903] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [9904] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [9905] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [9906] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10906),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10906),
    [sym_operator_assignment] = STATE(10906),
    [sym_conditional] = STATE(10906),
    [sym_range] = STATE(10906),
    [sym_binary] = STATE(10906),
    [sym_unary] = STATE(10906),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9907] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10907),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10907),
    [sym_operator_assignment] = STATE(10907),
    [sym_conditional] = STATE(10907),
    [sym_range] = STATE(10907),
    [sym_binary] = STATE(10907),
    [sym_unary] = STATE(10907),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9908] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10908),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10908),
    [sym_operator_assignment] = STATE(10908),
    [sym_conditional] = STATE(10908),
    [sym_range] = STATE(10908),
    [sym_binary] = STATE(10908),
    [sym_unary] = STATE(10908),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9909] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10909),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10909),
    [sym_operator_assignment] = STATE(10909),
    [sym_conditional] = STATE(10909),
    [sym_range] = STATE(10909),
    [sym_binary] = STATE(10909),
    [sym_unary] = STATE(10909),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9910] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10910),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10910),
    [sym_operator_assignment] = STATE(10910),
    [sym_conditional] = STATE(10910),
    [sym_range] = STATE(10910),
    [sym_binary] = STATE(10910),
    [sym_unary] = STATE(10910),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9911] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10911),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10911),
    [sym_operator_assignment] = STATE(10911),
    [sym_conditional] = STATE(10911),
    [sym_range] = STATE(10911),
    [sym_binary] = STATE(10911),
    [sym_unary] = STATE(10911),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9912] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10912),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10912),
    [sym_operator_assignment] = STATE(10912),
    [sym_conditional] = STATE(10912),
    [sym_range] = STATE(10912),
    [sym_binary] = STATE(10912),
    [sym_unary] = STATE(10912),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9913] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10913),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10913),
    [sym_operator_assignment] = STATE(10913),
    [sym_conditional] = STATE(10913),
    [sym_range] = STATE(10913),
    [sym_binary] = STATE(10913),
    [sym_unary] = STATE(10913),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9914] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10914),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10914),
    [sym_operator_assignment] = STATE(10914),
    [sym_conditional] = STATE(10914),
    [sym_range] = STATE(10914),
    [sym_binary] = STATE(10914),
    [sym_unary] = STATE(10914),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9915] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10915),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10915),
    [sym_operator_assignment] = STATE(10915),
    [sym_conditional] = STATE(10915),
    [sym_range] = STATE(10915),
    [sym_binary] = STATE(10915),
    [sym_unary] = STATE(10915),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9916] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10916),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10916),
    [sym_operator_assignment] = STATE(10916),
    [sym_conditional] = STATE(10916),
    [sym_range] = STATE(10916),
    [sym_binary] = STATE(10916),
    [sym_unary] = STATE(10916),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9917] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10917),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10917),
    [sym_operator_assignment] = STATE(10917),
    [sym_conditional] = STATE(10917),
    [sym_range] = STATE(10917),
    [sym_binary] = STATE(10917),
    [sym_unary] = STATE(10917),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9918] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10918),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_splat_argument] = STATE(10919),
    [sym_assignment] = STATE(10918),
    [sym_operator_assignment] = STATE(10918),
    [sym_conditional] = STATE(10918),
    [sym_range] = STATE(10918),
    [sym_binary] = STATE(10918),
    [sym_unary] = STATE(10918),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(10919),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9919] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10920),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(10920),
    [sym_operator_assignment] = STATE(10920),
    [sym_conditional] = STATE(10920),
    [sym_range] = STATE(10920),
    [sym_binary] = STATE(10920),
    [sym_unary] = STATE(10920),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9920] = {
    [sym_string] = STATE(10921),
    [aux_sym_chained_string_repeat1] = STATE(10921),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [9921] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [9922] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9923] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [9924] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9925] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [9926] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9927] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9928] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [9929] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14140),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [9930] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9931] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9932] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9933] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9934] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9935] = {
    [sym_heredoc_body] = STATE(9935),
    [aux_sym_call_repeat1] = STATE(9935),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [9936] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5489),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(5489),
    [sym_operator_assignment] = STATE(5489),
    [sym_conditional] = STATE(5489),
    [sym_range] = STATE(5489),
    [sym_binary] = STATE(5489),
    [sym_unary] = STATE(5489),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5495),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8258),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__identifier_hash_key2] = ACTIONS(8264),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13107),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8282),
    [sym_identifier] = ACTIONS(8282),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [9937] = {
    [sym_heredoc_body] = STATE(9935),
    [aux_sym_call_repeat1] = STATE(9935),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [9938] = {
    [aux_sym_argument_list_repeat1] = STATE(9938),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14142),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [9939] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9940] = {
    [aux_sym_exceptions_repeat1] = STATE(10924),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [9941] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [9942] = {
    [sym_string] = STATE(9942),
    [aux_sym_chained_string_repeat1] = STATE(9942),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [9943] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [9944] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [9945] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [9946] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [9947] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10925),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10925),
    [sym_operator_assignment] = STATE(10925),
    [sym_conditional] = STATE(10925),
    [sym_range] = STATE(10925),
    [sym_binary] = STATE(10925),
    [sym_unary] = STATE(10925),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9948] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10926),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10926),
    [sym_operator_assignment] = STATE(10926),
    [sym_conditional] = STATE(10926),
    [sym_range] = STATE(10926),
    [sym_binary] = STATE(10926),
    [sym_unary] = STATE(10926),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9949] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10927),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10927),
    [sym_operator_assignment] = STATE(10927),
    [sym_conditional] = STATE(10927),
    [sym_range] = STATE(10927),
    [sym_binary] = STATE(10927),
    [sym_unary] = STATE(10927),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9950] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10928),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10928),
    [sym_operator_assignment] = STATE(10928),
    [sym_conditional] = STATE(10928),
    [sym_range] = STATE(10928),
    [sym_binary] = STATE(10928),
    [sym_unary] = STATE(10928),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9951] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10929),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10929),
    [sym_operator_assignment] = STATE(10929),
    [sym_conditional] = STATE(10929),
    [sym_range] = STATE(10929),
    [sym_binary] = STATE(10929),
    [sym_unary] = STATE(10929),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9952] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10930),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10930),
    [sym_operator_assignment] = STATE(10930),
    [sym_conditional] = STATE(10930),
    [sym_range] = STATE(10930),
    [sym_binary] = STATE(10930),
    [sym_unary] = STATE(10930),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9953] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10931),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10931),
    [sym_operator_assignment] = STATE(10931),
    [sym_conditional] = STATE(10931),
    [sym_range] = STATE(10931),
    [sym_binary] = STATE(10931),
    [sym_unary] = STATE(10931),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9954] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10932),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10932),
    [sym_operator_assignment] = STATE(10932),
    [sym_conditional] = STATE(10932),
    [sym_range] = STATE(10932),
    [sym_binary] = STATE(10932),
    [sym_unary] = STATE(10932),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9955] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10933),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10933),
    [sym_operator_assignment] = STATE(10933),
    [sym_conditional] = STATE(10933),
    [sym_range] = STATE(10933),
    [sym_binary] = STATE(10933),
    [sym_unary] = STATE(10933),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9956] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10934),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10934),
    [sym_operator_assignment] = STATE(10934),
    [sym_conditional] = STATE(10934),
    [sym_range] = STATE(10934),
    [sym_binary] = STATE(10934),
    [sym_unary] = STATE(10934),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9957] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10935),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10935),
    [sym_operator_assignment] = STATE(10935),
    [sym_conditional] = STATE(10935),
    [sym_range] = STATE(10935),
    [sym_binary] = STATE(10935),
    [sym_unary] = STATE(10935),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9958] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10936),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10936),
    [sym_operator_assignment] = STATE(10936),
    [sym_conditional] = STATE(10936),
    [sym_range] = STATE(10936),
    [sym_binary] = STATE(10936),
    [sym_unary] = STATE(10936),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9959] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8127),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(8127),
    [sym_operator_assignment] = STATE(8127),
    [sym_conditional] = STATE(8127),
    [sym_range] = STATE(8127),
    [sym_binary] = STATE(8127),
    [sym_unary] = STATE(8127),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11312),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9960] = {
    [aux_sym_exceptions_repeat1] = STATE(10937),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(13139),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9961] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8127),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_splat_argument] = STATE(10938),
    [sym_assignment] = STATE(8127),
    [sym_operator_assignment] = STATE(8127),
    [sym_conditional] = STATE(8127),
    [sym_range] = STATE(8127),
    [sym_binary] = STATE(8127),
    [sym_unary] = STATE(8127),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(10938),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11312),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9962] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10939),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(10939),
    [sym_operator_assignment] = STATE(10939),
    [sym_conditional] = STATE(10939),
    [sym_range] = STATE(10939),
    [sym_binary] = STATE(10939),
    [sym_unary] = STATE(10939),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9963] = {
    [sym_heredoc_body] = STATE(9963),
    [aux_sym_call_repeat1] = STATE(9963),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9964] = {
    [sym_heredoc_body] = STATE(9963),
    [aux_sym_call_repeat1] = STATE(9963),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9965] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10940),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_assignment] = STATE(10940),
    [sym_operator_assignment] = STATE(10940),
    [sym_conditional] = STATE(10940),
    [sym_range] = STATE(10940),
    [sym_binary] = STATE(10940),
    [sym_unary] = STATE(10940),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9966] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8147),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2870),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2870),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8147),
    [sym_operator_assignment] = STATE(8147),
    [sym_conditional] = STATE(8147),
    [sym_range] = STATE(8147),
    [sym_binary] = STATE(8147),
    [sym_unary] = STATE(8147),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(2869),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2870),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2870),
    [sym_false] = STATE(2870),
    [sym_nil] = STATE(2870),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(1853),
    [sym__unary_minus2] = ACTIONS(4586),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4596),
    [anon_sym_defined_QMARK] = ACTIONS(4598),
    [anon_sym_not] = ACTIONS(4600),
    [anon_sym_BANG] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4602),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9967] = {
    [aux_sym_exceptions_repeat1] = STATE(10941),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14145),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [9968] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4618),
    [sym__binary_star2] = ACTIONS(4620),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4622),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4624),
    [anon_sym_AMP] = ACTIONS(4626),
    [anon_sym_LT] = ACTIONS(4628),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4632),
    [anon_sym_DOT_DOT] = ACTIONS(4634),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4636),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4638),
    [anon_sym_AMP_AMP] = ACTIONS(4638),
    [anon_sym_LT_LT] = ACTIONS(4640),
    [anon_sym_GT_GT] = ACTIONS(4640),
    [anon_sym_EQ_EQ] = ACTIONS(4642),
    [anon_sym_BANG_EQ] = ACTIONS(4638),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4638),
    [anon_sym_LT_EQ_GT] = ACTIONS(4638),
    [anon_sym_EQ_TILDE] = ACTIONS(4638),
    [anon_sym_BANG_TILDE] = ACTIONS(4638),
    [anon_sym_LT_EQ] = ACTIONS(4628),
    [anon_sym_GT] = ACTIONS(4628),
    [anon_sym_GT_EQ] = ACTIONS(4644),
    [anon_sym_CARET] = ACTIONS(4646),
    [anon_sym_PLUS] = ACTIONS(4648),
    [anon_sym_SLASH] = ACTIONS(4624),
    [anon_sym_PERCENT] = ACTIONS(4624),
    [sym_comment] = ACTIONS(87),
  },
  [9969] = {
    [aux_sym_exceptions_repeat1] = STATE(9969),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14147),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [9970] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10942),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_assignment] = STATE(10942),
    [sym_operator_assignment] = STATE(10942),
    [sym_conditional] = STATE(10942),
    [sym_range] = STATE(10942),
    [sym_binary] = STATE(10942),
    [sym_unary] = STATE(10942),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9971] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8179),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(2942),
    [sym_scope_resolution] = STATE(2940),
    [sym_call] = STATE(2940),
    [sym_method_call] = STATE(2942),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(8179),
    [sym_operator_assignment] = STATE(8179),
    [sym_conditional] = STATE(8179),
    [sym_range] = STATE(8179),
    [sym_binary] = STATE(8179),
    [sym_unary] = STATE(8179),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(2941),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2942),
    [sym__variable] = STATE(2940),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(2942),
    [sym_false] = STATE(2942),
    [sym_nil] = STATE(2942),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(2943),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(1917),
    [sym__unary_minus2] = ACTIONS(4672),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4676),
    [anon_sym_break] = ACTIONS(4678),
    [anon_sym_next] = ACTIONS(4680),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(4682),
    [anon_sym_defined_QMARK] = ACTIONS(4684),
    [anon_sym_not] = ACTIONS(4686),
    [anon_sym_BANG] = ACTIONS(4688),
    [anon_sym_TILDE] = ACTIONS(4688),
    [sym_constant] = ACTIONS(4690),
    [sym_identifier] = ACTIONS(4690),
    [sym_instance_variable] = ACTIONS(4692),
    [sym_class_variable] = ACTIONS(4692),
    [sym_global_variable] = ACTIONS(4692),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(4690),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4690),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [9972] = {
    [aux_sym_exceptions_repeat1] = STATE(10943),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14150),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [9973] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4702),
    [sym__binary_star2] = ACTIONS(4704),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4706),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4708),
    [anon_sym_AMP] = ACTIONS(4710),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(4712),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4716),
    [anon_sym_DOT_DOT] = ACTIONS(4718),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4720),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4722),
    [anon_sym_AMP_AMP] = ACTIONS(4722),
    [anon_sym_LT_LT] = ACTIONS(4724),
    [anon_sym_GT_GT] = ACTIONS(4724),
    [anon_sym_EQ_EQ] = ACTIONS(4722),
    [anon_sym_BANG_EQ] = ACTIONS(4726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4726),
    [anon_sym_LT_EQ_GT] = ACTIONS(4726),
    [anon_sym_EQ_TILDE] = ACTIONS(4726),
    [anon_sym_BANG_TILDE] = ACTIONS(4726),
    [anon_sym_LT_EQ] = ACTIONS(4712),
    [anon_sym_GT] = ACTIONS(4712),
    [anon_sym_GT_EQ] = ACTIONS(4728),
    [anon_sym_CARET] = ACTIONS(4706),
    [anon_sym_PLUS] = ACTIONS(4730),
    [anon_sym_SLASH] = ACTIONS(4708),
    [anon_sym_PERCENT] = ACTIONS(4708),
    [sym_comment] = ACTIONS(87),
  },
  [9974] = {
    [aux_sym_exceptions_repeat1] = STATE(9974),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14152),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [9975] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10944),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2979),
    [sym_scope_resolution] = STATE(256),
    [sym_call] = STATE(256),
    [sym_method_call] = STATE(2979),
    [sym_assignment] = STATE(10944),
    [sym_operator_assignment] = STATE(10944),
    [sym_conditional] = STATE(10944),
    [sym_range] = STATE(10944),
    [sym_binary] = STATE(10944),
    [sym_unary] = STATE(10944),
    [sym_left_assignment_list] = STATE(2978),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2979),
    [sym__variable] = STATE(256),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2979),
    [sym_false] = STATE(2979),
    [sym_nil] = STATE(2979),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2871),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4744),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4588),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_break] = ACTIONS(4592),
    [anon_sym_next] = ACTIONS(4594),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4746),
    [anon_sym_defined_QMARK] = ACTIONS(4748),
    [anon_sym_not] = ACTIONS(4750),
    [anon_sym_BANG] = ACTIONS(4752),
    [anon_sym_TILDE] = ACTIONS(4752),
    [sym_constant] = ACTIONS(469),
    [sym_identifier] = ACTIONS(469),
    [sym_instance_variable] = ACTIONS(471),
    [sym_class_variable] = ACTIONS(471),
    [sym_global_variable] = ACTIONS(471),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(469),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(469),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [9976] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [9977] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [9978] = {
    [sym_heredoc_body] = STATE(9978),
    [aux_sym_call_repeat1] = STATE(9978),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_in] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [9979] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(5627),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(1136),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(1136),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(5627),
    [sym_operator_assignment] = STATE(5627),
    [sym_conditional] = STATE(5627),
    [sym_range] = STATE(5627),
    [sym_binary] = STATE(5627),
    [sym_unary] = STATE(5627),
    [sym_left_assignment_list] = STATE(1135),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1136),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(1136),
    [sym_false] = STATE(1136),
    [sym_nil] = STATE(1136),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(5630),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(8438),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(1969),
    [sym__identifier_hash_key2] = ACTIONS(8442),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13166),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1975),
    [anon_sym_yield] = ACTIONS(1977),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_next] = ACTIONS(1981),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(1983),
    [anon_sym_defined_QMARK] = ACTIONS(1985),
    [anon_sym_not] = ACTIONS(1987),
    [anon_sym_BANG] = ACTIONS(1989),
    [anon_sym_TILDE] = ACTIONS(1989),
    [sym_constant] = ACTIONS(8444),
    [sym_identifier] = ACTIONS(8444),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9980] = {
    [sym_heredoc_body] = STATE(9978),
    [aux_sym_call_repeat1] = STATE(9978),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_in] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [9981] = {
    [aux_sym_argument_list_repeat1] = STATE(9981),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14155),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [9982] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_assignment] = STATE(10945),
    [sym_operator_assignment] = STATE(10945),
    [sym_conditional] = STATE(10945),
    [sym_range] = STATE(10945),
    [sym_binary] = STATE(10945),
    [sym_unary] = STATE(10945),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [9983] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_in] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [9984] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [9985] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [9986] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10946),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10946),
    [sym_operator_assignment] = STATE(10946),
    [sym_conditional] = STATE(10946),
    [sym_range] = STATE(10946),
    [sym_binary] = STATE(10946),
    [sym_unary] = STATE(10946),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9987] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10947),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10947),
    [sym_operator_assignment] = STATE(10947),
    [sym_conditional] = STATE(10947),
    [sym_range] = STATE(10947),
    [sym_binary] = STATE(10947),
    [sym_unary] = STATE(10947),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9988] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10948),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10948),
    [sym_operator_assignment] = STATE(10948),
    [sym_conditional] = STATE(10948),
    [sym_range] = STATE(10948),
    [sym_binary] = STATE(10948),
    [sym_unary] = STATE(10948),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9989] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10949),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10949),
    [sym_operator_assignment] = STATE(10949),
    [sym_conditional] = STATE(10949),
    [sym_range] = STATE(10949),
    [sym_binary] = STATE(10949),
    [sym_unary] = STATE(10949),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9990] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10950),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10950),
    [sym_operator_assignment] = STATE(10950),
    [sym_conditional] = STATE(10950),
    [sym_range] = STATE(10950),
    [sym_binary] = STATE(10950),
    [sym_unary] = STATE(10950),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9991] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10951),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10951),
    [sym_operator_assignment] = STATE(10951),
    [sym_conditional] = STATE(10951),
    [sym_range] = STATE(10951),
    [sym_binary] = STATE(10951),
    [sym_unary] = STATE(10951),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9992] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10952),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10952),
    [sym_operator_assignment] = STATE(10952),
    [sym_conditional] = STATE(10952),
    [sym_range] = STATE(10952),
    [sym_binary] = STATE(10952),
    [sym_unary] = STATE(10952),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [9993] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10953),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10953),
    [sym_operator_assignment] = STATE(10953),
    [sym_conditional] = STATE(10953),
    [sym_range] = STATE(10953),
    [sym_binary] = STATE(10953),
    [sym_unary] = STATE(10953),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9994] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10954),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10954),
    [sym_operator_assignment] = STATE(10954),
    [sym_conditional] = STATE(10954),
    [sym_range] = STATE(10954),
    [sym_binary] = STATE(10954),
    [sym_unary] = STATE(10954),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9995] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10955),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10955),
    [sym_operator_assignment] = STATE(10955),
    [sym_conditional] = STATE(10955),
    [sym_range] = STATE(10955),
    [sym_binary] = STATE(10955),
    [sym_unary] = STATE(10955),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9996] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10956),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10956),
    [sym_operator_assignment] = STATE(10956),
    [sym_conditional] = STATE(10956),
    [sym_range] = STATE(10956),
    [sym_binary] = STATE(10956),
    [sym_unary] = STATE(10956),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9997] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10957),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10957),
    [sym_operator_assignment] = STATE(10957),
    [sym_conditional] = STATE(10957),
    [sym_range] = STATE(10957),
    [sym_binary] = STATE(10957),
    [sym_unary] = STATE(10957),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9998] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10958),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_splat_argument] = STATE(10959),
    [sym_assignment] = STATE(10958),
    [sym_operator_assignment] = STATE(10958),
    [sym_conditional] = STATE(10958),
    [sym_range] = STATE(10958),
    [sym_binary] = STATE(10958),
    [sym_unary] = STATE(10958),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(10959),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [9999] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10960),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(10960),
    [sym_operator_assignment] = STATE(10960),
    [sym_conditional] = STATE(10960),
    [sym_range] = STATE(10960),
    [sym_binary] = STATE(10960),
    [sym_unary] = STATE(10960),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10000] = {
    [sym_string] = STATE(10961),
    [aux_sym_chained_string_repeat1] = STATE(10961),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_in] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [10001] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10002] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10003] = {
    [sym_heredoc_body] = STATE(10003),
    [aux_sym_call_repeat1] = STATE(10003),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_in] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10004] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(5650),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(5650),
    [sym_operator_assignment] = STATE(5650),
    [sym_conditional] = STATE(5650),
    [sym_range] = STATE(5650),
    [sym_binary] = STATE(5650),
    [sym_unary] = STATE(5650),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5653),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(8478),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(4830),
    [sym__identifier_hash_key2] = ACTIONS(8482),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13204),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(8484),
    [sym_identifier] = ACTIONS(8484),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10005] = {
    [sym_heredoc_body] = STATE(10003),
    [aux_sym_call_repeat1] = STATE(10003),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_in] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10006] = {
    [aux_sym_argument_list_repeat1] = STATE(10006),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14158),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_in] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10007] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(8240),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(2995),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(2995),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(8240),
    [sym_operator_assignment] = STATE(8240),
    [sym_conditional] = STATE(8240),
    [sym_range] = STATE(8240),
    [sym_binary] = STATE(8240),
    [sym_unary] = STATE(8240),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(2994),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2995),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(2995),
    [sym_false] = STATE(2995),
    [sym_nil] = STATE(2995),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2996),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(8440),
    [sym__unary_minus2] = ACTIONS(4756),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4760),
    [anon_sym_break] = ACTIONS(4762),
    [anon_sym_next] = ACTIONS(4764),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(4766),
    [anon_sym_defined_QMARK] = ACTIONS(4768),
    [anon_sym_not] = ACTIONS(4770),
    [anon_sym_BANG] = ACTIONS(4772),
    [anon_sym_TILDE] = ACTIONS(4772),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10008] = {
    [aux_sym_exceptions_repeat1] = STATE(10962),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14161),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_in] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10009] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4792),
    [sym__binary_star2] = ACTIONS(4794),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4796),
    [anon_sym_STAR_STAR] = ACTIONS(4798),
    [anon_sym_AMP] = ACTIONS(4800),
    [anon_sym_LT] = ACTIONS(4802),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4806),
    [anon_sym_DOT_DOT] = ACTIONS(4808),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4810),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4814),
    [anon_sym_AMP_AMP] = ACTIONS(4814),
    [anon_sym_LT_LT] = ACTIONS(4816),
    [anon_sym_GT_GT] = ACTIONS(4816),
    [anon_sym_EQ_EQ] = ACTIONS(4818),
    [anon_sym_BANG_EQ] = ACTIONS(4814),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4814),
    [anon_sym_LT_EQ_GT] = ACTIONS(4814),
    [anon_sym_EQ_TILDE] = ACTIONS(4814),
    [anon_sym_BANG_TILDE] = ACTIONS(4814),
    [anon_sym_LT_EQ] = ACTIONS(4802),
    [anon_sym_GT] = ACTIONS(4802),
    [anon_sym_GT_EQ] = ACTIONS(4820),
    [anon_sym_CARET] = ACTIONS(4822),
    [anon_sym_PLUS] = ACTIONS(4824),
    [anon_sym_SLASH] = ACTIONS(4798),
    [anon_sym_PERCENT] = ACTIONS(4798),
    [sym_comment] = ACTIONS(87),
  },
  [10010] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10963),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_assignment] = STATE(10963),
    [sym_operator_assignment] = STATE(10963),
    [sym_conditional] = STATE(10963),
    [sym_range] = STATE(10963),
    [sym_binary] = STATE(10963),
    [sym_unary] = STATE(10963),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10011] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(8269),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3043),
    [sym_scope_resolution] = STATE(1132),
    [sym_call] = STATE(1132),
    [sym_method_call] = STATE(3043),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(8269),
    [sym_operator_assignment] = STATE(8269),
    [sym_conditional] = STATE(8269),
    [sym_range] = STATE(8269),
    [sym_binary] = STATE(8269),
    [sym_unary] = STATE(8269),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(3042),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3043),
    [sym__variable] = STATE(1132),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3043),
    [sym_false] = STATE(3043),
    [sym_nil] = STATE(3043),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(5680),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(4828),
    [sym__unary_minus2] = ACTIONS(4830),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4836),
    [anon_sym_break] = ACTIONS(4838),
    [anon_sym_next] = ACTIONS(4840),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(8500),
    [anon_sym_defined_QMARK] = ACTIONS(4842),
    [anon_sym_not] = ACTIONS(4844),
    [anon_sym_BANG] = ACTIONS(4848),
    [anon_sym_TILDE] = ACTIONS(4848),
    [sym_constant] = ACTIONS(1995),
    [sym_identifier] = ACTIONS(1995),
    [sym_instance_variable] = ACTIONS(1993),
    [sym_class_variable] = ACTIONS(1993),
    [sym_global_variable] = ACTIONS(1993),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(1995),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(1995),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10012] = {
    [aux_sym_exceptions_repeat1] = STATE(10964),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14163),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_in] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10013] = {
    [aux_sym_exceptions_repeat1] = STATE(10013),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14165),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10014] = {
    [sym_heredoc_body] = STATE(10014),
    [aux_sym_call_repeat1] = STATE(10014),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10015] = {
    [sym_heredoc_body] = STATE(10014),
    [aux_sym_call_repeat1] = STATE(10014),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10016] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10965),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_assignment] = STATE(10965),
    [sym_operator_assignment] = STATE(10965),
    [sym_conditional] = STATE(10965),
    [sym_range] = STATE(10965),
    [sym_binary] = STATE(10965),
    [sym_unary] = STATE(10965),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10017] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8290),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3063),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3063),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8290),
    [sym_operator_assignment] = STATE(8290),
    [sym_conditional] = STATE(8290),
    [sym_range] = STATE(8290),
    [sym_binary] = STATE(8290),
    [sym_unary] = STATE(8290),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(3062),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3063),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3063),
    [sym_false] = STATE(3063),
    [sym_nil] = STATE(3063),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2003),
    [sym__unary_minus2] = ACTIONS(4866),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4876),
    [anon_sym_defined_QMARK] = ACTIONS(4878),
    [anon_sym_not] = ACTIONS(4880),
    [anon_sym_BANG] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4882),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10018] = {
    [aux_sym_exceptions_repeat1] = STATE(10966),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14168),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10019] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(4898),
    [sym__binary_star2] = ACTIONS(4900),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(4902),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(4904),
    [anon_sym_AMP] = ACTIONS(4906),
    [anon_sym_LT] = ACTIONS(4908),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(4912),
    [anon_sym_DOT_DOT] = ACTIONS(4914),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4916),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(4918),
    [anon_sym_AMP_AMP] = ACTIONS(4918),
    [anon_sym_LT_LT] = ACTIONS(4920),
    [anon_sym_GT_GT] = ACTIONS(4920),
    [anon_sym_EQ_EQ] = ACTIONS(4922),
    [anon_sym_BANG_EQ] = ACTIONS(4918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4918),
    [anon_sym_LT_EQ_GT] = ACTIONS(4918),
    [anon_sym_EQ_TILDE] = ACTIONS(4918),
    [anon_sym_BANG_TILDE] = ACTIONS(4918),
    [anon_sym_LT_EQ] = ACTIONS(4908),
    [anon_sym_GT] = ACTIONS(4908),
    [anon_sym_GT_EQ] = ACTIONS(4924),
    [anon_sym_CARET] = ACTIONS(4926),
    [anon_sym_PLUS] = ACTIONS(4928),
    [anon_sym_SLASH] = ACTIONS(4904),
    [anon_sym_PERCENT] = ACTIONS(4904),
    [sym_comment] = ACTIONS(87),
  },
  [10020] = {
    [aux_sym_exceptions_repeat1] = STATE(10020),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14170),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10021] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10967),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3122),
    [sym_scope_resolution] = STATE(276),
    [sym_call] = STATE(276),
    [sym_method_call] = STATE(3122),
    [sym_assignment] = STATE(10967),
    [sym_operator_assignment] = STATE(10967),
    [sym_conditional] = STATE(10967),
    [sym_range] = STATE(10967),
    [sym_binary] = STATE(10967),
    [sym_unary] = STATE(10967),
    [sym_left_assignment_list] = STATE(3121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3122),
    [sym__variable] = STATE(276),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3122),
    [sym_false] = STATE(3122),
    [sym_nil] = STATE(3122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3064),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4944),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4868),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_break] = ACTIONS(4872),
    [anon_sym_next] = ACTIONS(4874),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4946),
    [anon_sym_defined_QMARK] = ACTIONS(4948),
    [anon_sym_not] = ACTIONS(4950),
    [anon_sym_BANG] = ACTIONS(4952),
    [anon_sym_TILDE] = ACTIONS(4952),
    [sym_constant] = ACTIONS(501),
    [sym_identifier] = ACTIONS(501),
    [sym_instance_variable] = ACTIONS(503),
    [sym_class_variable] = ACTIONS(503),
    [sym_global_variable] = ACTIONS(503),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(501),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(501),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10022] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [10023] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [10024] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10025] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10968),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10968),
    [sym_operator_assignment] = STATE(10968),
    [sym_conditional] = STATE(10968),
    [sym_range] = STATE(10968),
    [sym_binary] = STATE(10968),
    [sym_unary] = STATE(10968),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10026] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10969),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10969),
    [sym_operator_assignment] = STATE(10969),
    [sym_conditional] = STATE(10969),
    [sym_range] = STATE(10969),
    [sym_binary] = STATE(10969),
    [sym_unary] = STATE(10969),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10027] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10970),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10970),
    [sym_operator_assignment] = STATE(10970),
    [sym_conditional] = STATE(10970),
    [sym_range] = STATE(10970),
    [sym_binary] = STATE(10970),
    [sym_unary] = STATE(10970),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10028] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10971),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10971),
    [sym_operator_assignment] = STATE(10971),
    [sym_conditional] = STATE(10971),
    [sym_range] = STATE(10971),
    [sym_binary] = STATE(10971),
    [sym_unary] = STATE(10971),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10029] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10972),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10972),
    [sym_operator_assignment] = STATE(10972),
    [sym_conditional] = STATE(10972),
    [sym_range] = STATE(10972),
    [sym_binary] = STATE(10972),
    [sym_unary] = STATE(10972),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10030] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10973),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10973),
    [sym_operator_assignment] = STATE(10973),
    [sym_conditional] = STATE(10973),
    [sym_range] = STATE(10973),
    [sym_binary] = STATE(10973),
    [sym_unary] = STATE(10973),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10031] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(10974),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(10974),
    [sym_operator_assignment] = STATE(10974),
    [sym_conditional] = STATE(10974),
    [sym_range] = STATE(10974),
    [sym_binary] = STATE(10974),
    [sym_unary] = STATE(10974),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10032] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10975),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10975),
    [sym_operator_assignment] = STATE(10975),
    [sym_conditional] = STATE(10975),
    [sym_range] = STATE(10975),
    [sym_binary] = STATE(10975),
    [sym_unary] = STATE(10975),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10033] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10976),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10976),
    [sym_operator_assignment] = STATE(10976),
    [sym_conditional] = STATE(10976),
    [sym_range] = STATE(10976),
    [sym_binary] = STATE(10976),
    [sym_unary] = STATE(10976),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10034] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10977),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10977),
    [sym_operator_assignment] = STATE(10977),
    [sym_conditional] = STATE(10977),
    [sym_range] = STATE(10977),
    [sym_binary] = STATE(10977),
    [sym_unary] = STATE(10977),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10035] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10978),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10978),
    [sym_operator_assignment] = STATE(10978),
    [sym_conditional] = STATE(10978),
    [sym_range] = STATE(10978),
    [sym_binary] = STATE(10978),
    [sym_unary] = STATE(10978),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10036] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10979),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10979),
    [sym_operator_assignment] = STATE(10979),
    [sym_conditional] = STATE(10979),
    [sym_range] = STATE(10979),
    [sym_binary] = STATE(10979),
    [sym_unary] = STATE(10979),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10037] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10980),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_splat_argument] = STATE(10981),
    [sym_assignment] = STATE(10980),
    [sym_operator_assignment] = STATE(10980),
    [sym_conditional] = STATE(10980),
    [sym_range] = STATE(10980),
    [sym_binary] = STATE(10980),
    [sym_unary] = STATE(10980),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(10981),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10038] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10982),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(10982),
    [sym_operator_assignment] = STATE(10982),
    [sym_conditional] = STATE(10982),
    [sym_range] = STATE(10982),
    [sym_binary] = STATE(10982),
    [sym_unary] = STATE(10982),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10039] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10040] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10041] = {
    [sym_heredoc_body] = STATE(10041),
    [aux_sym_call_repeat1] = STATE(10041),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10042] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5796),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(5796),
    [sym_operator_assignment] = STATE(5796),
    [sym_conditional] = STATE(5796),
    [sym_range] = STATE(5796),
    [sym_binary] = STATE(5796),
    [sym_unary] = STATE(5796),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5799),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8636),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(5072),
    [sym__identifier_hash_key2] = ACTIONS(8640),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13272),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(8642),
    [sym_identifier] = ACTIONS(8642),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10043] = {
    [sym_heredoc_body] = STATE(10041),
    [aux_sym_call_repeat1] = STATE(10041),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10044] = {
    [aux_sym_argument_list_repeat1] = STATE(10044),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14173),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10045] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [10046] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10991),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(10991),
    [sym_operator_assignment] = STATE(10991),
    [sym_conditional] = STATE(10991),
    [sym_range] = STATE(10991),
    [sym_binary] = STATE(10991),
    [sym_unary] = STATE(10991),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10047] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10995),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(10995),
    [sym_operator_assignment] = STATE(10995),
    [sym_conditional] = STATE(10995),
    [sym_range] = STATE(10995),
    [sym_binary] = STATE(10995),
    [sym_unary] = STATE(10995),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10048] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10996),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(10996),
    [sym_operator_assignment] = STATE(10996),
    [sym_conditional] = STATE(10996),
    [sym_range] = STATE(10996),
    [sym_binary] = STATE(10996),
    [sym_unary] = STATE(10996),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10049] = {
    [anon_sym_COLON] = ACTIONS(14196),
    [sym_comment] = ACTIONS(87),
  },
  [10050] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10999),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(10999),
    [sym_operator_assignment] = STATE(10999),
    [sym_conditional] = STATE(10999),
    [sym_range] = STATE(10999),
    [sym_binary] = STATE(10999),
    [sym_unary] = STATE(10999),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10051] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(11006),
    [sym__argument] = STATE(11007),
    [sym_splat_argument] = STATE(11007),
    [sym_hash_splat_argument] = STATE(11007),
    [sym_block_argument] = STATE(11007),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11007),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10052] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(11006),
    [sym__argument] = STATE(11007),
    [sym_splat_argument] = STATE(11007),
    [sym_hash_splat_argument] = STATE(11007),
    [sym_block_argument] = STATE(11007),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11007),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10053] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(11006),
    [sym__argument] = STATE(11007),
    [sym_splat_argument] = STATE(11007),
    [sym_hash_splat_argument] = STATE(11007),
    [sym_block_argument] = STATE(11007),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11007),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10054] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(11006),
    [sym__argument] = STATE(11007),
    [sym_splat_argument] = STATE(11007),
    [sym_hash_splat_argument] = STATE(11007),
    [sym_block_argument] = STATE(11007),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11007),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10055] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11009),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11009),
    [sym_operator_assignment] = STATE(11009),
    [sym_conditional] = STATE(11009),
    [sym_range] = STATE(11009),
    [sym_binary] = STATE(11009),
    [sym_unary] = STATE(11009),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10056] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11010),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11010),
    [sym_operator_assignment] = STATE(11010),
    [sym_conditional] = STATE(11010),
    [sym_range] = STATE(11010),
    [sym_binary] = STATE(11010),
    [sym_unary] = STATE(11010),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10057] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10058] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14206),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_when] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [10059] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_when] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(14220),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [10060] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(975),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(1691),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(1693),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10061] = {
    [sym_heredoc_body] = STATE(11033),
    [aux_sym_call_repeat1] = STATE(11033),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10062] = {
    [sym_heredoc_body] = STATE(11033),
    [aux_sym_call_repeat1] = STATE(11033),
    [aux_sym_argument_list_repeat1] = STATE(11035),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10063] = {
    [anon_sym_EQ] = ACTIONS(14250),
    [sym_comment] = ACTIONS(87),
  },
  [10064] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14252),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14254),
    [anon_sym_DASH_EQ] = ACTIONS(14254),
    [anon_sym_STAR_EQ] = ACTIONS(14254),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14254),
    [anon_sym_SLASH_EQ] = ACTIONS(14254),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14254),
    [anon_sym_PIPE_EQ] = ACTIONS(14254),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14254),
    [anon_sym_AMP_EQ] = ACTIONS(14254),
    [anon_sym_PERCENT_EQ] = ACTIONS(14254),
    [anon_sym_GT_GT_EQ] = ACTIONS(14254),
    [anon_sym_LT_LT_EQ] = ACTIONS(14254),
    [anon_sym_CARET_EQ] = ACTIONS(14254),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10065] = {
    [sym_string] = STATE(11038),
    [aux_sym_chained_string_repeat1] = STATE(11038),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14256),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10066] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [10067] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [10068] = {
    [aux_sym_undef_repeat1] = STATE(11039),
    [sym__line_break2] = ACTIONS(2297),
    [sym__heredoc_body_start2] = ACTIONS(2297),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(2297),
    [anon_sym_end] = ACTIONS(2297),
    [anon_sym_if] = ACTIONS(2297),
    [anon_sym_unless] = ACTIONS(2297),
    [anon_sym_while] = ACTIONS(2297),
    [anon_sym_until] = ACTIONS(2297),
    [anon_sym_rescue] = ACTIONS(2297),
    [anon_sym_when] = ACTIONS(2297),
    [anon_sym_else] = ACTIONS(2297),
    [sym_comment] = ACTIONS(87),
  },
  [10069] = {
    [anon_sym_end] = ACTIONS(14258),
    [sym_comment] = ACTIONS(87),
  },
  [10070] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(8346),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(8348),
    [sym_operator_assignment] = STATE(8348),
    [sym_conditional] = STATE(8348),
    [sym_range] = STATE(8348),
    [sym_binary] = STATE(8348),
    [sym_unary] = STATE(8348),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(2545),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(2545),
    [anon_sym_else] = ACTIONS(2545),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [anon_sym_undef] = ACTIONS(11458),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10071] = {
    [sym_heredoc_body] = STATE(11040),
    [sym__terminator] = STATE(11040),
    [aux_sym__statements_repeat1] = STATE(11041),
    [sym__line_break2] = ACTIONS(14260),
    [sym__heredoc_body_start2] = ACTIONS(507),
    [anon_sym_SEMI] = ACTIONS(14260),
    [anon_sym_end] = ACTIONS(2543),
    [anon_sym_when] = ACTIONS(2543),
    [anon_sym_else] = ACTIONS(2543),
    [sym_comment] = ACTIONS(87),
  },
  [10072] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11042),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11042),
    [sym_operator_assignment] = STATE(11042),
    [sym_conditional] = STATE(11042),
    [sym_range] = STATE(11042),
    [sym_binary] = STATE(11042),
    [sym_unary] = STATE(11042),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10073] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11043),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11043),
    [sym_operator_assignment] = STATE(11043),
    [sym_conditional] = STATE(11043),
    [sym_range] = STATE(11043),
    [sym_binary] = STATE(11043),
    [sym_unary] = STATE(11043),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10074] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11044),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11044),
    [sym_operator_assignment] = STATE(11044),
    [sym_conditional] = STATE(11044),
    [sym_range] = STATE(11044),
    [sym_binary] = STATE(11044),
    [sym_unary] = STATE(11044),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10075] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11045),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11045),
    [sym_operator_assignment] = STATE(11045),
    [sym_conditional] = STATE(11045),
    [sym_range] = STATE(11045),
    [sym_binary] = STATE(11045),
    [sym_unary] = STATE(11045),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10076] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11046),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11046),
    [sym_operator_assignment] = STATE(11046),
    [sym_conditional] = STATE(11046),
    [sym_range] = STATE(11046),
    [sym_binary] = STATE(11046),
    [sym_unary] = STATE(11046),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10077] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11047),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11047),
    [sym_operator_assignment] = STATE(11047),
    [sym_conditional] = STATE(11047),
    [sym_range] = STATE(11047),
    [sym_binary] = STATE(11047),
    [sym_unary] = STATE(11047),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10078] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11048),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11048),
    [sym_operator_assignment] = STATE(11048),
    [sym_conditional] = STATE(11048),
    [sym_range] = STATE(11048),
    [sym_binary] = STATE(11048),
    [sym_unary] = STATE(11048),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10079] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11049),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11049),
    [sym_operator_assignment] = STATE(11049),
    [sym_conditional] = STATE(11049),
    [sym_range] = STATE(11049),
    [sym_binary] = STATE(11049),
    [sym_unary] = STATE(11049),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10080] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11050),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11050),
    [sym_operator_assignment] = STATE(11050),
    [sym_conditional] = STATE(11050),
    [sym_range] = STATE(11050),
    [sym_binary] = STATE(11050),
    [sym_unary] = STATE(11050),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10081] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11051),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11051),
    [sym_operator_assignment] = STATE(11051),
    [sym_conditional] = STATE(11051),
    [sym_range] = STATE(11051),
    [sym_binary] = STATE(11051),
    [sym_unary] = STATE(11051),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10082] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11052),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11052),
    [sym_operator_assignment] = STATE(11052),
    [sym_conditional] = STATE(11052),
    [sym_range] = STATE(11052),
    [sym_binary] = STATE(11052),
    [sym_unary] = STATE(11052),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10083] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11053),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11053),
    [sym_operator_assignment] = STATE(11053),
    [sym_conditional] = STATE(11053),
    [sym_range] = STATE(11053),
    [sym_binary] = STATE(11053),
    [sym_unary] = STATE(11053),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10084] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11054),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11054),
    [sym_operator_assignment] = STATE(11054),
    [sym_conditional] = STATE(11054),
    [sym_range] = STATE(11054),
    [sym_binary] = STATE(11054),
    [sym_unary] = STATE(11054),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10085] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11055),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11055),
    [sym_operator_assignment] = STATE(11055),
    [sym_conditional] = STATE(11055),
    [sym_range] = STATE(11055),
    [sym_binary] = STATE(11055),
    [sym_unary] = STATE(11055),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10086] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11056),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11056),
    [sym_operator_assignment] = STATE(11056),
    [sym_conditional] = STATE(11056),
    [sym_range] = STATE(11056),
    [sym_binary] = STATE(11056),
    [sym_unary] = STATE(11056),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10087] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11057),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11057),
    [sym_operator_assignment] = STATE(11057),
    [sym_conditional] = STATE(11057),
    [sym_range] = STATE(11057),
    [sym_binary] = STATE(11057),
    [sym_unary] = STATE(11057),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10088] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11058),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11058),
    [sym_operator_assignment] = STATE(11058),
    [sym_conditional] = STATE(11058),
    [sym_range] = STATE(11058),
    [sym_binary] = STATE(11058),
    [sym_unary] = STATE(11058),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10089] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11067),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11067),
    [sym_operator_assignment] = STATE(11067),
    [sym_conditional] = STATE(11067),
    [sym_range] = STATE(11067),
    [sym_binary] = STATE(11067),
    [sym_unary] = STATE(11067),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10090] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11072),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11072),
    [sym_operator_assignment] = STATE(11072),
    [sym_conditional] = STATE(11072),
    [sym_range] = STATE(11072),
    [sym_binary] = STATE(11072),
    [sym_unary] = STATE(11072),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10091] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11073),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11073),
    [sym_operator_assignment] = STATE(11073),
    [sym_conditional] = STATE(11073),
    [sym_range] = STATE(11073),
    [sym_binary] = STATE(11073),
    [sym_unary] = STATE(11073),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10092] = {
    [anon_sym_COLON] = ACTIONS(14286),
    [sym_comment] = ACTIONS(87),
  },
  [10093] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11076),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11076),
    [sym_operator_assignment] = STATE(11076),
    [sym_conditional] = STATE(11076),
    [sym_range] = STATE(11076),
    [sym_binary] = STATE(11076),
    [sym_unary] = STATE(11076),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10094] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1604),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10095] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1605),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10096] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1606),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10097] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1607),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10098] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11077),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11077),
    [sym_operator_assignment] = STATE(11077),
    [sym_conditional] = STATE(11077),
    [sym_range] = STATE(11077),
    [sym_binary] = STATE(11077),
    [sym_unary] = STATE(11077),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10099] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11078),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11078),
    [sym_operator_assignment] = STATE(11078),
    [sym_conditional] = STATE(11078),
    [sym_range] = STATE(11078),
    [sym_binary] = STATE(11078),
    [sym_unary] = STATE(11078),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10100] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(1630),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(1630),
    [sym_operator_assignment] = STATE(1630),
    [sym_conditional] = STATE(1630),
    [sym_range] = STATE(1630),
    [sym_binary] = STATE(1630),
    [sym_unary] = STATE(1630),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10101] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14288),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_when] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [10102] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_when] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(14302),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [10103] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1652),
    [sym__argument_list_with_parens] = STATE(11030),
    [sym__argument] = STATE(11031),
    [sym_splat_argument] = STATE(11031),
    [sym_hash_splat_argument] = STATE(11031),
    [sym_block_argument] = STATE(11031),
    [sym_do_block] = STATE(978),
    [sym_block] = STATE(978),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(11031),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(2771),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1695),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10104] = {
    [sym_heredoc_body] = STATE(11092),
    [aux_sym_call_repeat1] = STATE(11092),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [10105] = {
    [sym_heredoc_body] = STATE(11092),
    [aux_sym_call_repeat1] = STATE(11092),
    [aux_sym_argument_list_repeat1] = STATE(11094),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [10106] = {
    [anon_sym_EQ] = ACTIONS(14322),
    [sym_comment] = ACTIONS(87),
  },
  [10107] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14324),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14326),
    [anon_sym_DASH_EQ] = ACTIONS(14326),
    [anon_sym_STAR_EQ] = ACTIONS(14326),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14326),
    [anon_sym_SLASH_EQ] = ACTIONS(14326),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14326),
    [anon_sym_PIPE_EQ] = ACTIONS(14326),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14326),
    [anon_sym_AMP_EQ] = ACTIONS(14326),
    [anon_sym_PERCENT_EQ] = ACTIONS(14326),
    [anon_sym_GT_GT_EQ] = ACTIONS(14326),
    [anon_sym_LT_LT_EQ] = ACTIONS(14326),
    [anon_sym_CARET_EQ] = ACTIONS(14326),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10108] = {
    [sym_string] = STATE(11097),
    [aux_sym_chained_string_repeat1] = STATE(11097),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14328),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10109] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11103),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_splat_argument] = STATE(11104),
    [sym_assignment] = STATE(11103),
    [sym_operator_assignment] = STATE(11103),
    [sym_conditional] = STATE(11103),
    [sym_range] = STATE(11103),
    [sym_binary] = STATE(11103),
    [sym_unary] = STATE(11103),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(11104),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(14330),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10110] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11107),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11107),
    [sym_operator_assignment] = STATE(11107),
    [sym_conditional] = STATE(11107),
    [sym_range] = STATE(11107),
    [sym_binary] = STATE(11107),
    [sym_unary] = STATE(11107),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10111] = {
    [sym_string] = STATE(11108),
    [aux_sym_chained_string_repeat1] = STATE(11108),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_when] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [10112] = {
    [sym_when] = STATE(11109),
    [sym_else] = STATE(11109),
    [anon_sym_end] = ACTIONS(14258),
    [anon_sym_when] = ACTIONS(2073),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [10113] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11110),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_assignment] = STATE(11110),
    [sym_operator_assignment] = STATE(11110),
    [sym_conditional] = STATE(11110),
    [sym_range] = STATE(11110),
    [sym_binary] = STATE(11110),
    [sym_unary] = STATE(11110),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10114] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [10115] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [10116] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10117] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11111),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11111),
    [sym_operator_assignment] = STATE(11111),
    [sym_conditional] = STATE(11111),
    [sym_range] = STATE(11111),
    [sym_binary] = STATE(11111),
    [sym_unary] = STATE(11111),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10118] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11112),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11112),
    [sym_operator_assignment] = STATE(11112),
    [sym_conditional] = STATE(11112),
    [sym_range] = STATE(11112),
    [sym_binary] = STATE(11112),
    [sym_unary] = STATE(11112),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10119] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11113),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11113),
    [sym_operator_assignment] = STATE(11113),
    [sym_conditional] = STATE(11113),
    [sym_range] = STATE(11113),
    [sym_binary] = STATE(11113),
    [sym_unary] = STATE(11113),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10120] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11114),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11114),
    [sym_operator_assignment] = STATE(11114),
    [sym_conditional] = STATE(11114),
    [sym_range] = STATE(11114),
    [sym_binary] = STATE(11114),
    [sym_unary] = STATE(11114),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10121] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11115),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11115),
    [sym_operator_assignment] = STATE(11115),
    [sym_conditional] = STATE(11115),
    [sym_range] = STATE(11115),
    [sym_binary] = STATE(11115),
    [sym_unary] = STATE(11115),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10122] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11116),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11116),
    [sym_operator_assignment] = STATE(11116),
    [sym_conditional] = STATE(11116),
    [sym_range] = STATE(11116),
    [sym_binary] = STATE(11116),
    [sym_unary] = STATE(11116),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10123] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11117),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11117),
    [sym_operator_assignment] = STATE(11117),
    [sym_conditional] = STATE(11117),
    [sym_range] = STATE(11117),
    [sym_binary] = STATE(11117),
    [sym_unary] = STATE(11117),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10124] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11118),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11118),
    [sym_operator_assignment] = STATE(11118),
    [sym_conditional] = STATE(11118),
    [sym_range] = STATE(11118),
    [sym_binary] = STATE(11118),
    [sym_unary] = STATE(11118),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10125] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11119),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11119),
    [sym_operator_assignment] = STATE(11119),
    [sym_conditional] = STATE(11119),
    [sym_range] = STATE(11119),
    [sym_binary] = STATE(11119),
    [sym_unary] = STATE(11119),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10126] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11120),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11120),
    [sym_operator_assignment] = STATE(11120),
    [sym_conditional] = STATE(11120),
    [sym_range] = STATE(11120),
    [sym_binary] = STATE(11120),
    [sym_unary] = STATE(11120),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10127] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11121),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11121),
    [sym_operator_assignment] = STATE(11121),
    [sym_conditional] = STATE(11121),
    [sym_range] = STATE(11121),
    [sym_binary] = STATE(11121),
    [sym_unary] = STATE(11121),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10128] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11122),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11122),
    [sym_operator_assignment] = STATE(11122),
    [sym_conditional] = STATE(11122),
    [sym_range] = STATE(11122),
    [sym_binary] = STATE(11122),
    [sym_unary] = STATE(11122),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10129] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11123),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_splat_argument] = STATE(11124),
    [sym_assignment] = STATE(11123),
    [sym_operator_assignment] = STATE(11123),
    [sym_conditional] = STATE(11123),
    [sym_range] = STATE(11123),
    [sym_binary] = STATE(11123),
    [sym_unary] = STATE(11123),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(11124),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10130] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11125),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11125),
    [sym_operator_assignment] = STATE(11125),
    [sym_conditional] = STATE(11125),
    [sym_range] = STATE(11125),
    [sym_binary] = STATE(11125),
    [sym_unary] = STATE(11125),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10131] = {
    [sym_string] = STATE(11126),
    [aux_sym_chained_string_repeat1] = STATE(11126),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [10132] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10133] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [10134] = {
    [sym_heredoc_body] = STATE(10134),
    [aux_sym_call_repeat1] = STATE(10134),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10135] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(5822),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(5822),
    [sym_operator_assignment] = STATE(5822),
    [sym_conditional] = STATE(5822),
    [sym_range] = STATE(5822),
    [sym_binary] = STATE(5822),
    [sym_unary] = STATE(5822),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5825),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8682),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(5142),
    [sym__identifier_hash_key2] = ACTIONS(8686),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13431),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(8688),
    [sym_identifier] = ACTIONS(8688),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10136] = {
    [sym_heredoc_body] = STATE(10134),
    [aux_sym_call_repeat1] = STATE(10134),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10137] = {
    [aux_sym_argument_list_repeat1] = STATE(10137),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14342),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10138] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [10139] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8388),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3139),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(3139),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(8388),
    [sym_operator_assignment] = STATE(8388),
    [sym_conditional] = STATE(8388),
    [sym_range] = STATE(8388),
    [sym_binary] = STATE(8388),
    [sym_unary] = STATE(8388),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(3138),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3139),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3139),
    [sym_false] = STATE(3139),
    [sym_nil] = STATE(3139),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(11494),
    [sym__unary_minus2] = ACTIONS(4956),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4966),
    [anon_sym_defined_QMARK] = ACTIONS(4968),
    [anon_sym_not] = ACTIONS(4970),
    [anon_sym_BANG] = ACTIONS(4972),
    [anon_sym_TILDE] = ACTIONS(4972),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10140] = {
    [aux_sym_exceptions_repeat1] = STATE(11127),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(14345),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10141] = {
    [sym_heredoc_body] = STATE(10141),
    [aux_sym_call_repeat1] = STATE(10141),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10142] = {
    [sym_heredoc_body] = STATE(10141),
    [aux_sym_call_repeat1] = STATE(10141),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10143] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11128),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_assignment] = STATE(11128),
    [sym_operator_assignment] = STATE(11128),
    [sym_conditional] = STATE(11128),
    [sym_range] = STATE(11128),
    [sym_binary] = STATE(11128),
    [sym_unary] = STATE(11128),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10144] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8406),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3154),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3154),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8406),
    [sym_operator_assignment] = STATE(8406),
    [sym_conditional] = STATE(8406),
    [sym_range] = STATE(8406),
    [sym_binary] = STATE(8406),
    [sym_unary] = STATE(8406),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(3153),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3154),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3154),
    [sym_false] = STATE(3154),
    [sym_nil] = STATE(3154),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(2085),
    [sym__unary_minus2] = ACTIONS(4986),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4996),
    [anon_sym_defined_QMARK] = ACTIONS(4998),
    [anon_sym_not] = ACTIONS(5000),
    [anon_sym_BANG] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5002),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10145] = {
    [aux_sym_exceptions_repeat1] = STATE(11129),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14347),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10146] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5018),
    [sym__binary_star2] = ACTIONS(5020),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5022),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(5024),
    [anon_sym_AMP] = ACTIONS(5026),
    [anon_sym_LT] = ACTIONS(5028),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5032),
    [anon_sym_DOT_DOT] = ACTIONS(5034),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5036),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5038),
    [anon_sym_AMP_AMP] = ACTIONS(5038),
    [anon_sym_LT_LT] = ACTIONS(5040),
    [anon_sym_GT_GT] = ACTIONS(5040),
    [anon_sym_EQ_EQ] = ACTIONS(5042),
    [anon_sym_BANG_EQ] = ACTIONS(5038),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5038),
    [anon_sym_LT_EQ_GT] = ACTIONS(5038),
    [anon_sym_EQ_TILDE] = ACTIONS(5038),
    [anon_sym_BANG_TILDE] = ACTIONS(5038),
    [anon_sym_LT_EQ] = ACTIONS(5028),
    [anon_sym_GT] = ACTIONS(5028),
    [anon_sym_GT_EQ] = ACTIONS(5044),
    [anon_sym_CARET] = ACTIONS(5046),
    [anon_sym_PLUS] = ACTIONS(5048),
    [anon_sym_SLASH] = ACTIONS(5024),
    [anon_sym_PERCENT] = ACTIONS(5024),
    [sym_comment] = ACTIONS(87),
  },
  [10147] = {
    [aux_sym_exceptions_repeat1] = STATE(10147),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14349),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10148] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11130),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_assignment] = STATE(11130),
    [sym_operator_assignment] = STATE(11130),
    [sym_conditional] = STATE(11130),
    [sym_range] = STATE(11130),
    [sym_binary] = STATE(11130),
    [sym_unary] = STATE(11130),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10149] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8443),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3215),
    [sym_scope_resolution] = STATE(1220),
    [sym_call] = STATE(1220),
    [sym_method_call] = STATE(3215),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8443),
    [sym_operator_assignment] = STATE(8443),
    [sym_conditional] = STATE(8443),
    [sym_range] = STATE(8443),
    [sym_binary] = STATE(8443),
    [sym_unary] = STATE(8443),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(3214),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3215),
    [sym__variable] = STATE(1220),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3215),
    [sym_false] = STATE(3215),
    [sym_nil] = STATE(3215),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(1224),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(5070),
    [sym__unary_minus2] = ACTIONS(5072),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(2117),
    [anon_sym_yield] = ACTIONS(2119),
    [anon_sym_break] = ACTIONS(2121),
    [anon_sym_next] = ACTIONS(2123),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8761),
    [anon_sym_defined_QMARK] = ACTIONS(5076),
    [anon_sym_not] = ACTIONS(5078),
    [anon_sym_BANG] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5082),
    [sym_constant] = ACTIONS(2137),
    [sym_identifier] = ACTIONS(2137),
    [sym_instance_variable] = ACTIONS(2139),
    [sym_class_variable] = ACTIONS(2139),
    [sym_global_variable] = ACTIONS(2139),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2137),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2137),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10150] = {
    [aux_sym_exceptions_repeat1] = STATE(11131),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14352),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10151] = {
    [sym__line_break2] = ACTIONS(4242),
    [sym__simple_symbol2] = ACTIONS(4242),
    [sym__string_start2] = ACTIONS(4242),
    [sym__symbol_start2] = ACTIONS(4242),
    [sym__subshell_start2] = ACTIONS(4242),
    [sym__regex_start2] = ACTIONS(4242),
    [sym__string_array_start2] = ACTIONS(4242),
    [sym__symbol_array_start2] = ACTIONS(4242),
    [sym__heredoc_body_start2] = ACTIONS(4242),
    [sym_heredoc_beginning2] = ACTIONS(4242),
    [sym__block_ampersand2] = ACTIONS(4242),
    [sym__splat_star2] = ACTIONS(4242),
    [sym__unary_minus2] = ACTIONS(4242),
    [sym__identifier_hash_key2] = ACTIONS(4242),
    [anon_sym_LBRACE] = ACTIONS(4242),
    [anon_sym_def] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4244),
    [anon_sym_DOT] = ACTIONS(4242),
    [anon_sym_COLON_COLON] = ACTIONS(4244),
    [anon_sym_SEMI] = ACTIONS(4242),
    [anon_sym_STAR] = ACTIONS(4244),
    [anon_sym_STAR_STAR] = ACTIONS(4242),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_module] = ACTIONS(4244),
    [anon_sym_return] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_break] = ACTIONS(4244),
    [anon_sym_next] = ACTIONS(4244),
    [sym_redo] = ACTIONS(4244),
    [sym_retry] = ACTIONS(4244),
    [anon_sym_if] = ACTIONS(4244),
    [anon_sym_unless] = ACTIONS(4244),
    [anon_sym_while] = ACTIONS(4244),
    [anon_sym_until] = ACTIONS(4244),
    [anon_sym_for] = ACTIONS(4244),
    [anon_sym_do] = ACTIONS(4244),
    [anon_sym_case] = ACTIONS(4244),
    [anon_sym_then] = ACTIONS(4244),
    [anon_sym_begin] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_COLON_COLON2] = ACTIONS(4242),
    [anon_sym_AMP_DOT] = ACTIONS(4242),
    [anon_sym_LPAREN2] = ACTIONS(4242),
    [anon_sym_PLUS] = ACTIONS(4244),
    [anon_sym_defined_QMARK] = ACTIONS(4242),
    [anon_sym_not] = ACTIONS(4244),
    [anon_sym_BANG] = ACTIONS(4242),
    [anon_sym_TILDE] = ACTIONS(4242),
    [sym_constant] = ACTIONS(4244),
    [sym_identifier] = ACTIONS(4244),
    [sym_instance_variable] = ACTIONS(4242),
    [sym_class_variable] = ACTIONS(4242),
    [sym_global_variable] = ACTIONS(4242),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4244),
    [sym_float] = ACTIONS(4244),
    [sym_complex] = ACTIONS(4242),
    [sym_super] = ACTIONS(4244),
    [anon_sym_true] = ACTIONS(4244),
    [anon_sym_TRUE] = ACTIONS(4244),
    [anon_sym_false] = ACTIONS(4244),
    [anon_sym_FALSE] = ACTIONS(4244),
    [sym_self] = ACTIONS(4244),
    [anon_sym_nil] = ACTIONS(4244),
    [anon_sym_NIL] = ACTIONS(4244),
    [sym_character] = ACTIONS(4242),
    [anon_sym_LBRACK2] = ACTIONS(4244),
    [anon_sym_DASH_GT] = ACTIONS(4242),
  },
  [10152] = {
    [sym_heredoc_body] = STATE(11133),
    [sym__heredoc_body_start2] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(14354),
    [sym_comment] = ACTIONS(87),
  },
  [10153] = {
    [anon_sym_RPAREN] = ACTIONS(14354),
    [sym_comment] = ACTIONS(87),
  },
  [10154] = {
    [sym__line_break2] = ACTIONS(9751),
    [sym__simple_symbol2] = ACTIONS(9751),
    [sym__string_start2] = ACTIONS(9751),
    [sym__symbol_start2] = ACTIONS(9751),
    [sym__subshell_start2] = ACTIONS(9751),
    [sym__regex_start2] = ACTIONS(9751),
    [sym__string_array_start2] = ACTIONS(9751),
    [sym__symbol_array_start2] = ACTIONS(9751),
    [sym__heredoc_body_start2] = ACTIONS(9751),
    [sym_heredoc_beginning2] = ACTIONS(9751),
    [sym__block_ampersand2] = ACTIONS(9751),
    [sym__splat_star2] = ACTIONS(9751),
    [sym__unary_minus2] = ACTIONS(9751),
    [sym__identifier_hash_key2] = ACTIONS(9751),
    [anon_sym_LBRACE] = ACTIONS(9751),
    [anon_sym_def] = ACTIONS(9753),
    [anon_sym_LPAREN] = ACTIONS(9753),
    [anon_sym_DOT] = ACTIONS(9751),
    [anon_sym_COLON_COLON] = ACTIONS(9753),
    [anon_sym_SEMI] = ACTIONS(9751),
    [anon_sym_STAR] = ACTIONS(9753),
    [anon_sym_STAR_STAR] = ACTIONS(9751),
    [anon_sym_class] = ACTIONS(9753),
    [anon_sym_module] = ACTIONS(9753),
    [anon_sym_return] = ACTIONS(9753),
    [anon_sym_yield] = ACTIONS(9753),
    [anon_sym_break] = ACTIONS(9753),
    [anon_sym_next] = ACTIONS(9753),
    [sym_redo] = ACTIONS(9753),
    [sym_retry] = ACTIONS(9753),
    [anon_sym_if] = ACTIONS(9753),
    [anon_sym_unless] = ACTIONS(9753),
    [anon_sym_while] = ACTIONS(9753),
    [anon_sym_until] = ACTIONS(9753),
    [anon_sym_for] = ACTIONS(9753),
    [anon_sym_do] = ACTIONS(9753),
    [anon_sym_case] = ACTIONS(9753),
    [anon_sym_then] = ACTIONS(9753),
    [anon_sym_begin] = ACTIONS(9753),
    [anon_sym_LBRACK] = ACTIONS(9751),
    [anon_sym_COLON_COLON2] = ACTIONS(9751),
    [anon_sym_AMP_DOT] = ACTIONS(9751),
    [anon_sym_LPAREN2] = ACTIONS(9751),
    [anon_sym_PLUS] = ACTIONS(9753),
    [anon_sym_defined_QMARK] = ACTIONS(9751),
    [anon_sym_not] = ACTIONS(9753),
    [anon_sym_BANG] = ACTIONS(9751),
    [anon_sym_TILDE] = ACTIONS(9751),
    [sym_constant] = ACTIONS(9753),
    [sym_identifier] = ACTIONS(9753),
    [sym_instance_variable] = ACTIONS(9751),
    [sym_class_variable] = ACTIONS(9751),
    [sym_global_variable] = ACTIONS(9751),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(9753),
    [sym_float] = ACTIONS(9753),
    [sym_complex] = ACTIONS(9751),
    [sym_super] = ACTIONS(9753),
    [anon_sym_true] = ACTIONS(9753),
    [anon_sym_TRUE] = ACTIONS(9753),
    [anon_sym_false] = ACTIONS(9753),
    [anon_sym_FALSE] = ACTIONS(9753),
    [sym_self] = ACTIONS(9753),
    [anon_sym_nil] = ACTIONS(9753),
    [anon_sym_NIL] = ACTIONS(9753),
    [sym_character] = ACTIONS(9751),
    [anon_sym_LBRACK2] = ACTIONS(9753),
    [anon_sym_DASH_GT] = ACTIONS(9751),
  },
  [10155] = {
    [sym__line_break2] = ACTIONS(9758),
    [sym__heredoc_body_start2] = ACTIONS(9758),
    [anon_sym_DOT] = ACTIONS(9758),
    [anon_sym_SEMI] = ACTIONS(9758),
    [anon_sym_then] = ACTIONS(9758),
    [anon_sym_LBRACK] = ACTIONS(9758),
    [anon_sym_COLON_COLON2] = ACTIONS(9758),
    [anon_sym_AMP_DOT] = ACTIONS(9758),
    [sym_comment] = ACTIONS(87),
  },
  [10156] = {
    [anon_sym_RBRACK] = ACTIONS(14356),
    [sym_comment] = ACTIONS(87),
  },
  [10157] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_then] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [10158] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11135),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11135),
    [sym_operator_assignment] = STATE(11135),
    [sym_conditional] = STATE(11135),
    [sym_range] = STATE(11135),
    [sym_binary] = STATE(11135),
    [sym_unary] = STATE(11135),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10159] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11136),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11136),
    [sym_operator_assignment] = STATE(11136),
    [sym_conditional] = STATE(11136),
    [sym_range] = STATE(11136),
    [sym_binary] = STATE(11136),
    [sym_unary] = STATE(11136),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10160] = {
    [anon_sym_COLON] = ACTIONS(14358),
    [sym_comment] = ACTIONS(87),
  },
  [10161] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11138),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11138),
    [sym_operator_assignment] = STATE(11138),
    [sym_conditional] = STATE(11138),
    [sym_range] = STATE(11138),
    [sym_binary] = STATE(11138),
    [sym_unary] = STATE(11138),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10162] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14360),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_then] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [10163] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_then] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(14362),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10164] = {
    [sym_heredoc_body] = STATE(11140),
    [aux_sym_call_repeat1] = STATE(11140),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10165] = {
    [sym_heredoc_body] = STATE(11140),
    [aux_sym_call_repeat1] = STATE(11140),
    [aux_sym_argument_list_repeat1] = STATE(11142),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14364),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_then] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10166] = {
    [sym_string] = STATE(8506),
    [aux_sym_chained_string_repeat1] = STATE(8506),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14366),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_then] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10167] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [10168] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_then] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [10169] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11143),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11143),
    [sym_operator_assignment] = STATE(11143),
    [sym_conditional] = STATE(11143),
    [sym_range] = STATE(11143),
    [sym_binary] = STATE(11143),
    [sym_unary] = STATE(11143),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10170] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11144),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11144),
    [sym_operator_assignment] = STATE(11144),
    [sym_conditional] = STATE(11144),
    [sym_range] = STATE(11144),
    [sym_binary] = STATE(11144),
    [sym_unary] = STATE(11144),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10171] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11145),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11145),
    [sym_operator_assignment] = STATE(11145),
    [sym_conditional] = STATE(11145),
    [sym_range] = STATE(11145),
    [sym_binary] = STATE(11145),
    [sym_unary] = STATE(11145),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10172] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11146),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11146),
    [sym_operator_assignment] = STATE(11146),
    [sym_conditional] = STATE(11146),
    [sym_range] = STATE(11146),
    [sym_binary] = STATE(11146),
    [sym_unary] = STATE(11146),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10173] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11147),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11147),
    [sym_operator_assignment] = STATE(11147),
    [sym_conditional] = STATE(11147),
    [sym_range] = STATE(11147),
    [sym_binary] = STATE(11147),
    [sym_unary] = STATE(11147),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10174] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11148),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11148),
    [sym_operator_assignment] = STATE(11148),
    [sym_conditional] = STATE(11148),
    [sym_range] = STATE(11148),
    [sym_binary] = STATE(11148),
    [sym_unary] = STATE(11148),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10175] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11149),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11149),
    [sym_operator_assignment] = STATE(11149),
    [sym_conditional] = STATE(11149),
    [sym_range] = STATE(11149),
    [sym_binary] = STATE(11149),
    [sym_unary] = STATE(11149),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10176] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11150),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11150),
    [sym_operator_assignment] = STATE(11150),
    [sym_conditional] = STATE(11150),
    [sym_range] = STATE(11150),
    [sym_binary] = STATE(11150),
    [sym_unary] = STATE(11150),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10177] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11151),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11151),
    [sym_operator_assignment] = STATE(11151),
    [sym_conditional] = STATE(11151),
    [sym_range] = STATE(11151),
    [sym_binary] = STATE(11151),
    [sym_unary] = STATE(11151),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10178] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11152),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11152),
    [sym_operator_assignment] = STATE(11152),
    [sym_conditional] = STATE(11152),
    [sym_range] = STATE(11152),
    [sym_binary] = STATE(11152),
    [sym_unary] = STATE(11152),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10179] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11153),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11153),
    [sym_operator_assignment] = STATE(11153),
    [sym_conditional] = STATE(11153),
    [sym_range] = STATE(11153),
    [sym_binary] = STATE(11153),
    [sym_unary] = STATE(11153),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10180] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11154),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11154),
    [sym_operator_assignment] = STATE(11154),
    [sym_conditional] = STATE(11154),
    [sym_range] = STATE(11154),
    [sym_binary] = STATE(11154),
    [sym_unary] = STATE(11154),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10181] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11155),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_splat_argument] = STATE(11156),
    [sym_assignment] = STATE(11155),
    [sym_operator_assignment] = STATE(11155),
    [sym_conditional] = STATE(11155),
    [sym_range] = STATE(11155),
    [sym_binary] = STATE(11155),
    [sym_unary] = STATE(11155),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(11156),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10182] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11157),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11157),
    [sym_operator_assignment] = STATE(11157),
    [sym_conditional] = STATE(11157),
    [sym_range] = STATE(11157),
    [sym_binary] = STATE(11157),
    [sym_unary] = STATE(11157),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10183] = {
    [sym_string] = STATE(11158),
    [aux_sym_chained_string_repeat1] = STATE(11158),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_then] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [10184] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(13480),
    [anon_sym_or] = ACTIONS(13480),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [10185] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10186] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10187] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11159),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(11159),
    [sym_operator_assignment] = STATE(11159),
    [sym_conditional] = STATE(11159),
    [sym_range] = STATE(11159),
    [sym_binary] = STATE(11159),
    [sym_unary] = STATE(11159),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10188] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10189] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11160),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(11160),
    [sym_operator_assignment] = STATE(11160),
    [sym_conditional] = STATE(11160),
    [sym_range] = STATE(11160),
    [sym_binary] = STATE(11160),
    [sym_unary] = STATE(11160),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10190] = {
    [sym_heredoc_body] = STATE(11161),
    [aux_sym_call_repeat1] = STATE(11161),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10191] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(11162),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10192] = {
    [sym_heredoc_body] = STATE(11163),
    [aux_sym_call_repeat1] = STATE(11163),
    [aux_sym_argument_list_repeat1] = STATE(11164),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(13504),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10193] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_DOT] = ACTIONS(7850),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_do] = ACTIONS(7850),
    [anon_sym_then] = ACTIONS(7850),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
  },
  [10194] = {
    [anon_sym_RPAREN] = ACTIONS(14370),
    [sym_comment] = ACTIONS(87),
  },
  [10195] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10196] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10197] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10198] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10199] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10200] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10201] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(13480),
    [anon_sym_or] = ACTIONS(13480),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [10202] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14372),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10203] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10204] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10205] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10206] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10207] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10208] = {
    [sym__line_break2] = ACTIONS(3158),
    [sym__heredoc_body_start2] = ACTIONS(3158),
    [anon_sym_LBRACE] = ACTIONS(3158),
    [anon_sym_DOT] = ACTIONS(3158),
    [anon_sym_SEMI] = ACTIONS(3158),
    [anon_sym_do] = ACTIONS(3158),
    [anon_sym_then] = ACTIONS(3158),
    [anon_sym_LBRACK] = ACTIONS(3158),
    [anon_sym_COLON_COLON2] = ACTIONS(3158),
    [anon_sym_AMP_DOT] = ACTIONS(3158),
    [sym_comment] = ACTIONS(87),
  },
  [10209] = {
    [sym_interpolation] = STATE(1853),
    [aux_sym_heredoc_body_repeat1] = STATE(1853),
    [sym__heredoc_content2] = ACTIONS(3160),
    [sym_heredoc_end2] = ACTIONS(14374),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(991),
    [sym_escape_sequence] = ACTIONS(3160),
  },
  [10210] = {
    [sym_heredoc_body] = STATE(10210),
    [aux_sym_call_repeat1] = STATE(10210),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(14376),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7888),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10211] = {
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(7899),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10212] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(5929),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(11168),
    [sym_splat_argument] = STATE(11168),
    [sym_hash_splat_argument] = STATE(11168),
    [sym_block_argument] = STATE(11168),
    [sym_assignment] = STATE(5929),
    [sym_operator_assignment] = STATE(5929),
    [sym_conditional] = STATE(5929),
    [sym_range] = STATE(5929),
    [sym_binary] = STATE(5929),
    [sym_unary] = STATE(5929),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(5936),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11168),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8811),
    [sym__splat_star2] = ACTIONS(8813),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(8817),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(8821),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(8841),
    [sym_identifier] = ACTIONS(8841),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10213] = {
    [sym_heredoc_body] = STATE(10210),
    [aux_sym_call_repeat1] = STATE(10210),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(11587),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7903),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10214] = {
    [aux_sym_argument_list_repeat1] = STATE(10214),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7899),
    [anon_sym_COMMA] = ACTIONS(14379),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10215] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10216] = {
    [aux_sym_exceptions_repeat1] = STATE(11170),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10217] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [10218] = {
    [sym_string] = STATE(10218),
    [aux_sym_chained_string_repeat1] = STATE(10218),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10219] = {
    [anon_sym_end] = ACTIONS(14382),
    [anon_sym_else] = ACTIONS(14382),
    [anon_sym_ensure] = ACTIONS(14382),
    [sym_comment] = ACTIONS(87),
  },
  [10220] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5106),
    [sym__binary_star2] = ACTIONS(5108),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5110),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(5112),
    [anon_sym_AMP] = ACTIONS(5114),
    [anon_sym_LT] = ACTIONS(5116),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5118),
    [anon_sym_DOT_DOT] = ACTIONS(5120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5122),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5126),
    [anon_sym_AMP_AMP] = ACTIONS(5126),
    [anon_sym_LT_LT] = ACTIONS(5128),
    [anon_sym_GT_GT] = ACTIONS(5128),
    [anon_sym_EQ_EQ] = ACTIONS(5130),
    [anon_sym_BANG_EQ] = ACTIONS(5126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5126),
    [anon_sym_LT_EQ_GT] = ACTIONS(5126),
    [anon_sym_EQ_TILDE] = ACTIONS(5126),
    [anon_sym_BANG_TILDE] = ACTIONS(5126),
    [anon_sym_LT_EQ] = ACTIONS(5116),
    [anon_sym_GT] = ACTIONS(5116),
    [anon_sym_GT_EQ] = ACTIONS(5132),
    [anon_sym_CARET] = ACTIONS(5134),
    [anon_sym_PLUS] = ACTIONS(5136),
    [anon_sym_SLASH] = ACTIONS(5112),
    [anon_sym_PERCENT] = ACTIONS(5112),
    [sym_comment] = ACTIONS(87),
  },
  [10221] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11171),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_assignment] = STATE(11171),
    [sym_operator_assignment] = STATE(11171),
    [sym_conditional] = STATE(11171),
    [sym_range] = STATE(11171),
    [sym_binary] = STATE(11171),
    [sym_unary] = STATE(11171),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10222] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8528),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3259),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(3259),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(8528),
    [sym_operator_assignment] = STATE(8528),
    [sym_conditional] = STATE(8528),
    [sym_range] = STATE(8528),
    [sym_binary] = STATE(8528),
    [sym_unary] = STATE(8528),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(3258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3259),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3259),
    [sym_false] = STATE(3259),
    [sym_nil] = STATE(3259),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(5953),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(5140),
    [sym__unary_minus2] = ACTIONS(5142),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5148),
    [anon_sym_break] = ACTIONS(5150),
    [anon_sym_next] = ACTIONS(5152),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(8851),
    [anon_sym_defined_QMARK] = ACTIONS(5154),
    [anon_sym_not] = ACTIONS(5156),
    [anon_sym_BANG] = ACTIONS(5160),
    [anon_sym_TILDE] = ACTIONS(5160),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10223] = {
    [aux_sym_exceptions_repeat1] = STATE(11172),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14384),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10224] = {
    [aux_sym_exceptions_repeat1] = STATE(10224),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14386),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10225] = {
    [sym_heredoc_body] = STATE(11173),
    [aux_sym_call_repeat1] = STATE(11173),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10226] = {
    [sym_heredoc_body] = STATE(11174),
    [aux_sym_call_repeat1] = STATE(11174),
    [aux_sym_argument_list_repeat1] = STATE(8588),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(8971),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_ensure] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10227] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10228] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10229] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10230] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10231] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10232] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10233] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14389),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10234] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10235] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10236] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10237] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10238] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10239] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10240] = {
    [aux_sym_exceptions_repeat1] = STATE(11177),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10241] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [10242] = {
    [sym_string] = STATE(10242),
    [aux_sym_chained_string_repeat1] = STATE(10242),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10243] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [10244] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [10245] = {
    [sym_heredoc_body] = STATE(10245),
    [aux_sym_call_repeat1] = STATE(10245),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10246] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6008),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(6008),
    [sym_operator_assignment] = STATE(6008),
    [sym_conditional] = STATE(6008),
    [sym_range] = STATE(6008),
    [sym_binary] = STATE(6008),
    [sym_unary] = STATE(6008),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6011),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(8921),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [sym__identifier_hash_key2] = ACTIONS(8925),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13523),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(8927),
    [sym_identifier] = ACTIONS(8927),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10247] = {
    [sym_heredoc_body] = STATE(10245),
    [aux_sym_call_repeat1] = STATE(10245),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10248] = {
    [aux_sym_argument_list_repeat1] = STATE(10248),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14391),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10249] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11178),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_assignment] = STATE(11178),
    [sym_operator_assignment] = STATE(11178),
    [sym_conditional] = STATE(11178),
    [sym_range] = STATE(11178),
    [sym_binary] = STATE(11178),
    [sym_unary] = STATE(11178),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10250] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_ensure] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [10251] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_ensure] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [10252] = {
    [sym_heredoc_body] = STATE(10252),
    [aux_sym_call_repeat1] = STATE(10252),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10253] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6032),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(6032),
    [sym_operator_assignment] = STATE(6032),
    [sym_conditional] = STATE(6032),
    [sym_range] = STATE(6032),
    [sym_binary] = STATE(6032),
    [sym_unary] = STATE(6032),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6035),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(8963),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [sym__identifier_hash_key2] = ACTIONS(8967),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13527),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(8969),
    [sym_identifier] = ACTIONS(8969),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10254] = {
    [sym_heredoc_body] = STATE(10252),
    [aux_sym_call_repeat1] = STATE(10252),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10255] = {
    [aux_sym_argument_list_repeat1] = STATE(10255),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14394),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_ensure] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10256] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8589),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3285),
    [sym_scope_resolution] = STATE(3281),
    [sym_call] = STATE(3281),
    [sym_method_call] = STATE(3285),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8589),
    [sym_operator_assignment] = STATE(8589),
    [sym_conditional] = STATE(8589),
    [sym_range] = STATE(8589),
    [sym_binary] = STATE(8589),
    [sym_unary] = STATE(8589),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(3284),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3285),
    [sym__variable] = STATE(3281),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3285),
    [sym_false] = STATE(3285),
    [sym_nil] = STATE(3285),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6000),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(8923),
    [sym__unary_minus2] = ACTIONS(5184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5188),
    [anon_sym_yield] = ACTIONS(5190),
    [anon_sym_break] = ACTIONS(5192),
    [anon_sym_next] = ACTIONS(5194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8917),
    [anon_sym_defined_QMARK] = ACTIONS(5196),
    [anon_sym_not] = ACTIONS(5198),
    [anon_sym_BANG] = ACTIONS(5202),
    [anon_sym_TILDE] = ACTIONS(5202),
    [sym_constant] = ACTIONS(5208),
    [sym_identifier] = ACTIONS(5208),
    [sym_instance_variable] = ACTIONS(5206),
    [sym_class_variable] = ACTIONS(5206),
    [sym_global_variable] = ACTIONS(5206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10257] = {
    [aux_sym_exceptions_repeat1] = STATE(11179),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14397),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10258] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5226),
    [sym__binary_star2] = ACTIONS(5228),
    [anon_sym_PIPE] = ACTIONS(5230),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(5232),
    [anon_sym_AMP] = ACTIONS(5234),
    [anon_sym_LT] = ACTIONS(5236),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5238),
    [anon_sym_DOT_DOT] = ACTIONS(5240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5242),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5246),
    [anon_sym_AMP_AMP] = ACTIONS(5246),
    [anon_sym_LT_LT] = ACTIONS(5248),
    [anon_sym_GT_GT] = ACTIONS(5248),
    [anon_sym_EQ_EQ] = ACTIONS(5250),
    [anon_sym_BANG_EQ] = ACTIONS(5246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5246),
    [anon_sym_LT_EQ_GT] = ACTIONS(5246),
    [anon_sym_EQ_TILDE] = ACTIONS(5246),
    [anon_sym_BANG_TILDE] = ACTIONS(5246),
    [anon_sym_LT_EQ] = ACTIONS(5236),
    [anon_sym_GT] = ACTIONS(5236),
    [anon_sym_GT_EQ] = ACTIONS(5252),
    [anon_sym_CARET] = ACTIONS(5254),
    [anon_sym_PLUS] = ACTIONS(5256),
    [anon_sym_SLASH] = ACTIONS(5232),
    [anon_sym_PERCENT] = ACTIONS(5232),
    [sym_comment] = ACTIONS(87),
  },
  [10259] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10260] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10261] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10262] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10263] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10264] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10265] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14399),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10266] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10267] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10268] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10269] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10270] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10271] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_ensure] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10272] = {
    [aux_sym_exceptions_repeat1] = STATE(11182),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10273] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [10274] = {
    [sym_string] = STATE(10274),
    [aux_sym_chained_string_repeat1] = STATE(10274),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_ensure] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10275] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11183),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_assignment] = STATE(11183),
    [sym_operator_assignment] = STATE(11183),
    [sym_conditional] = STATE(11183),
    [sym_range] = STATE(11183),
    [sym_binary] = STATE(11183),
    [sym_unary] = STATE(11183),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10276] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8632),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3327),
    [sym_scope_resolution] = STATE(3323),
    [sym_call] = STATE(3323),
    [sym_method_call] = STATE(3327),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(8632),
    [sym_operator_assignment] = STATE(8632),
    [sym_conditional] = STATE(8632),
    [sym_range] = STATE(8632),
    [sym_binary] = STATE(8632),
    [sym_unary] = STATE(8632),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(3326),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3327),
    [sym__variable] = STATE(3323),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3327),
    [sym_false] = STATE(3327),
    [sym_nil] = STATE(3327),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6077),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(8965),
    [sym__unary_minus2] = ACTIONS(5262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5266),
    [anon_sym_yield] = ACTIONS(5268),
    [anon_sym_break] = ACTIONS(5270),
    [anon_sym_next] = ACTIONS(5272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9005),
    [anon_sym_defined_QMARK] = ACTIONS(5274),
    [anon_sym_not] = ACTIONS(5276),
    [anon_sym_BANG] = ACTIONS(5280),
    [anon_sym_TILDE] = ACTIONS(5280),
    [sym_constant] = ACTIONS(5286),
    [sym_identifier] = ACTIONS(5286),
    [sym_instance_variable] = ACTIONS(5284),
    [sym_class_variable] = ACTIONS(5284),
    [sym_global_variable] = ACTIONS(5284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10277] = {
    [aux_sym_exceptions_repeat1] = STATE(11184),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14401),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10278] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_ensure] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10279] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_ensure] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10280] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10281] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10282] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10283] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10284] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14403),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10285] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_ensure] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10286] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10287] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10288] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10289] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_ensure] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10290] = {
    [aux_sym_exceptions_repeat1] = STATE(10290),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14405),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10291] = {
    [aux_sym_exceptions_repeat1] = STATE(8653),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_ensure] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10292] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_ensure] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [10293] = {
    [sym_heredoc_body] = STATE(11186),
    [aux_sym_call_repeat1] = STATE(11186),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10294] = {
    [sym_heredoc_body] = STATE(11187),
    [aux_sym_call_repeat1] = STATE(11187),
    [aux_sym_argument_list_repeat1] = STATE(8709),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9137),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10295] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10296] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10297] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10298] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10299] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10300] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10301] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14408),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10302] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10303] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10304] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10305] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10306] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10307] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10308] = {
    [aux_sym_exceptions_repeat1] = STATE(11190),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10309] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [10310] = {
    [sym_string] = STATE(10310),
    [aux_sym_chained_string_repeat1] = STATE(10310),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10311] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [10312] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [10313] = {
    [sym_heredoc_body] = STATE(10313),
    [aux_sym_call_repeat1] = STATE(10313),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10314] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(6134),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(6134),
    [sym_operator_assignment] = STATE(6134),
    [sym_conditional] = STATE(6134),
    [sym_range] = STATE(6134),
    [sym_binary] = STATE(6134),
    [sym_unary] = STATE(6134),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6137),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(9087),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [sym__identifier_hash_key2] = ACTIONS(9091),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13537),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(9093),
    [sym_identifier] = ACTIONS(9093),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10315] = {
    [sym_heredoc_body] = STATE(10313),
    [aux_sym_call_repeat1] = STATE(10313),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10316] = {
    [aux_sym_argument_list_repeat1] = STATE(10316),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14410),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10317] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11191),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_assignment] = STATE(11191),
    [sym_operator_assignment] = STATE(11191),
    [sym_conditional] = STATE(11191),
    [sym_range] = STATE(11191),
    [sym_binary] = STATE(11191),
    [sym_unary] = STATE(11191),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10318] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [10319] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [10320] = {
    [sym_heredoc_body] = STATE(10320),
    [aux_sym_call_repeat1] = STATE(10320),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10321] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(6158),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(6158),
    [sym_operator_assignment] = STATE(6158),
    [sym_conditional] = STATE(6158),
    [sym_range] = STATE(6158),
    [sym_binary] = STATE(6158),
    [sym_unary] = STATE(6158),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6161),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(9129),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [sym__identifier_hash_key2] = ACTIONS(9133),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13541),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(9135),
    [sym_identifier] = ACTIONS(9135),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10322] = {
    [sym_heredoc_body] = STATE(10320),
    [aux_sym_call_repeat1] = STATE(10320),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10323] = {
    [aux_sym_argument_list_repeat1] = STATE(10323),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14413),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10324] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8710),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(3352),
    [sym_scope_resolution] = STATE(3348),
    [sym_call] = STATE(3348),
    [sym_method_call] = STATE(3352),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(8710),
    [sym_operator_assignment] = STATE(8710),
    [sym_conditional] = STATE(8710),
    [sym_range] = STATE(8710),
    [sym_binary] = STATE(8710),
    [sym_unary] = STATE(8710),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(3351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3352),
    [sym__variable] = STATE(3348),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(3352),
    [sym_false] = STATE(3352),
    [sym_nil] = STATE(3352),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(6126),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(9089),
    [sym__unary_minus2] = ACTIONS(5300),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(5304),
    [anon_sym_yield] = ACTIONS(5306),
    [anon_sym_break] = ACTIONS(5308),
    [anon_sym_next] = ACTIONS(5310),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9083),
    [anon_sym_defined_QMARK] = ACTIONS(5312),
    [anon_sym_not] = ACTIONS(5314),
    [anon_sym_BANG] = ACTIONS(5318),
    [anon_sym_TILDE] = ACTIONS(5318),
    [sym_constant] = ACTIONS(5324),
    [sym_identifier] = ACTIONS(5324),
    [sym_instance_variable] = ACTIONS(5322),
    [sym_class_variable] = ACTIONS(5322),
    [sym_global_variable] = ACTIONS(5322),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5324),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5324),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10325] = {
    [aux_sym_exceptions_repeat1] = STATE(11192),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14416),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10326] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5342),
    [sym__binary_star2] = ACTIONS(5344),
    [anon_sym_PIPE] = ACTIONS(5346),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(5348),
    [anon_sym_AMP] = ACTIONS(5350),
    [anon_sym_LT] = ACTIONS(5352),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5354),
    [anon_sym_DOT_DOT] = ACTIONS(5356),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5358),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5362),
    [anon_sym_AMP_AMP] = ACTIONS(5362),
    [anon_sym_LT_LT] = ACTIONS(5364),
    [anon_sym_GT_GT] = ACTIONS(5364),
    [anon_sym_EQ_EQ] = ACTIONS(5366),
    [anon_sym_BANG_EQ] = ACTIONS(5362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5362),
    [anon_sym_LT_EQ_GT] = ACTIONS(5362),
    [anon_sym_EQ_TILDE] = ACTIONS(5362),
    [anon_sym_BANG_TILDE] = ACTIONS(5362),
    [anon_sym_LT_EQ] = ACTIONS(5352),
    [anon_sym_GT] = ACTIONS(5352),
    [anon_sym_GT_EQ] = ACTIONS(5368),
    [anon_sym_CARET] = ACTIONS(5370),
    [anon_sym_PLUS] = ACTIONS(5372),
    [anon_sym_SLASH] = ACTIONS(5348),
    [anon_sym_PERCENT] = ACTIONS(5348),
    [sym_comment] = ACTIONS(87),
  },
  [10327] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10328] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10329] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10330] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10331] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10332] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10333] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14418),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10334] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10335] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10336] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10337] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10338] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10339] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10340] = {
    [aux_sym_exceptions_repeat1] = STATE(11195),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10341] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [10342] = {
    [sym_string] = STATE(10342),
    [aux_sym_chained_string_repeat1] = STATE(10342),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10343] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11196),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_assignment] = STATE(11196),
    [sym_operator_assignment] = STATE(11196),
    [sym_conditional] = STATE(11196),
    [sym_range] = STATE(11196),
    [sym_binary] = STATE(11196),
    [sym_unary] = STATE(11196),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10344] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8753),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(3394),
    [sym_scope_resolution] = STATE(3390),
    [sym_call] = STATE(3390),
    [sym_method_call] = STATE(3394),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(8753),
    [sym_operator_assignment] = STATE(8753),
    [sym_conditional] = STATE(8753),
    [sym_range] = STATE(8753),
    [sym_binary] = STATE(8753),
    [sym_unary] = STATE(8753),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(3393),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3394),
    [sym__variable] = STATE(3390),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(3394),
    [sym_false] = STATE(3394),
    [sym_nil] = STATE(3394),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(6203),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(9131),
    [sym__unary_minus2] = ACTIONS(5378),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(5382),
    [anon_sym_yield] = ACTIONS(5384),
    [anon_sym_break] = ACTIONS(5386),
    [anon_sym_next] = ACTIONS(5388),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(9171),
    [anon_sym_defined_QMARK] = ACTIONS(5390),
    [anon_sym_not] = ACTIONS(5392),
    [anon_sym_BANG] = ACTIONS(5396),
    [anon_sym_TILDE] = ACTIONS(5396),
    [sym_constant] = ACTIONS(5402),
    [sym_identifier] = ACTIONS(5402),
    [sym_instance_variable] = ACTIONS(5400),
    [sym_class_variable] = ACTIONS(5400),
    [sym_global_variable] = ACTIONS(5400),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(5402),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5402),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10345] = {
    [aux_sym_exceptions_repeat1] = STATE(11197),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14420),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10346] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10347] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10348] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10349] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10350] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10351] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10352] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14422),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10353] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10354] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10355] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10356] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10357] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10358] = {
    [aux_sym_exceptions_repeat1] = STATE(10358),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14424),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10359] = {
    [aux_sym_exceptions_repeat1] = STATE(8774),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10360] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [10361] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11199),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_assignment] = STATE(11199),
    [sym_operator_assignment] = STATE(11199),
    [sym_conditional] = STATE(11199),
    [sym_range] = STATE(11199),
    [sym_binary] = STATE(11199),
    [sym_unary] = STATE(11199),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10362] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(8791),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(3433),
    [sym_scope_resolution] = STATE(3431),
    [sym_call] = STATE(3431),
    [sym_method_call] = STATE(3433),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(8791),
    [sym_operator_assignment] = STATE(8791),
    [sym_conditional] = STATE(8791),
    [sym_range] = STATE(8791),
    [sym_binary] = STATE(8791),
    [sym_unary] = STATE(8791),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(3432),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3433),
    [sym__variable] = STATE(3431),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(3433),
    [sym_false] = STATE(3433),
    [sym_nil] = STATE(3433),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(3434),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(2257),
    [sym__unary_minus2] = ACTIONS(5418),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(5420),
    [anon_sym_yield] = ACTIONS(5422),
    [anon_sym_break] = ACTIONS(5424),
    [anon_sym_next] = ACTIONS(5426),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(5428),
    [anon_sym_defined_QMARK] = ACTIONS(5430),
    [anon_sym_not] = ACTIONS(5432),
    [anon_sym_BANG] = ACTIONS(5434),
    [anon_sym_TILDE] = ACTIONS(5434),
    [sym_constant] = ACTIONS(5436),
    [sym_identifier] = ACTIONS(5436),
    [sym_instance_variable] = ACTIONS(5438),
    [sym_class_variable] = ACTIONS(5438),
    [sym_global_variable] = ACTIONS(5438),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(5436),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(5436),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10363] = {
    [aux_sym_exceptions_repeat1] = STATE(11200),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14427),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10364] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5446),
    [sym__binary_star2] = ACTIONS(5448),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5450),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(5452),
    [anon_sym_AMP] = ACTIONS(5454),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(5456),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5460),
    [anon_sym_DOT_DOT] = ACTIONS(5462),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5464),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5466),
    [anon_sym_AMP_AMP] = ACTIONS(5466),
    [anon_sym_LT_LT] = ACTIONS(5468),
    [anon_sym_GT_GT] = ACTIONS(5468),
    [anon_sym_EQ_EQ] = ACTIONS(5466),
    [anon_sym_BANG_EQ] = ACTIONS(5470),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5470),
    [anon_sym_LT_EQ_GT] = ACTIONS(5470),
    [anon_sym_EQ_TILDE] = ACTIONS(5470),
    [anon_sym_BANG_TILDE] = ACTIONS(5470),
    [anon_sym_LT_EQ] = ACTIONS(5456),
    [anon_sym_GT] = ACTIONS(5456),
    [anon_sym_GT_EQ] = ACTIONS(5472),
    [anon_sym_CARET] = ACTIONS(5450),
    [anon_sym_PLUS] = ACTIONS(5474),
    [anon_sym_SLASH] = ACTIONS(5452),
    [anon_sym_PERCENT] = ACTIONS(5452),
    [sym_comment] = ACTIONS(87),
  },
  [10365] = {
    [aux_sym_exceptions_repeat1] = STATE(10365),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14429),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10366] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11201),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(3469),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(3469),
    [sym_assignment] = STATE(11201),
    [sym_operator_assignment] = STATE(11201),
    [sym_conditional] = STATE(11201),
    [sym_range] = STATE(11201),
    [sym_binary] = STATE(11201),
    [sym_unary] = STATE(11201),
    [sym_left_assignment_list] = STATE(3468),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3469),
    [sym__variable] = STATE(303),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(3469),
    [sym_false] = STATE(3469),
    [sym_nil] = STATE(3469),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3155),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(5488),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4988),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_break] = ACTIONS(4992),
    [anon_sym_next] = ACTIONS(4994),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(5490),
    [anon_sym_defined_QMARK] = ACTIONS(5492),
    [anon_sym_not] = ACTIONS(5494),
    [anon_sym_BANG] = ACTIONS(5496),
    [anon_sym_TILDE] = ACTIONS(5496),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10367] = {
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_in] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_EQ_GT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_RBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_COLON2] = ACTIONS(12499),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12497),
    [anon_sym_AMP_AMP] = ACTIONS(12497),
    [anon_sym_LT_LT] = ACTIONS(12497),
    [anon_sym_GT_GT] = ACTIONS(12497),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12497),
    [anon_sym_PLUS] = ACTIONS(12497),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [10368] = {
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12501),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_in] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_EQ_GT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_RBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_COLON2] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12501),
    [anon_sym_AMP_AMP] = ACTIONS(12501),
    [anon_sym_LT_LT] = ACTIONS(12501),
    [anon_sym_GT_GT] = ACTIONS(12501),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12501),
    [anon_sym_PLUS] = ACTIONS(12501),
    [anon_sym_SLASH] = ACTIONS(12501),
    [anon_sym_PERCENT] = ACTIONS(12501),
    [sym_comment] = ACTIONS(87),
  },
  [10369] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10370] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10371] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10372] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10373] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10374] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10375] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14432),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10376] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10377] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10378] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10379] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10380] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10381] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10382] = {
    [aux_sym_exceptions_repeat1] = STATE(11204),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10383] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [10384] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5542),
    [sym__binary_star2] = ACTIONS(5544),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5546),
    [anon_sym_STAR_STAR] = ACTIONS(5548),
    [anon_sym_AMP] = ACTIONS(5550),
    [anon_sym_LT] = ACTIONS(5552),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5554),
    [anon_sym_DOT_DOT] = ACTIONS(5556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5558),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5562),
    [anon_sym_AMP_AMP] = ACTIONS(5562),
    [anon_sym_LT_LT] = ACTIONS(5564),
    [anon_sym_GT_GT] = ACTIONS(5564),
    [anon_sym_EQ_EQ] = ACTIONS(5566),
    [anon_sym_BANG_EQ] = ACTIONS(5562),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5562),
    [anon_sym_LT_EQ_GT] = ACTIONS(5562),
    [anon_sym_EQ_TILDE] = ACTIONS(5562),
    [anon_sym_BANG_TILDE] = ACTIONS(5562),
    [anon_sym_LT_EQ] = ACTIONS(5552),
    [anon_sym_GT] = ACTIONS(5552),
    [anon_sym_GT_EQ] = ACTIONS(5568),
    [anon_sym_CARET] = ACTIONS(5570),
    [anon_sym_PLUS] = ACTIONS(5572),
    [anon_sym_SLASH] = ACTIONS(5548),
    [anon_sym_PERCENT] = ACTIONS(5548),
    [sym_comment] = ACTIONS(87),
  },
  [10385] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_RBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10386] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_RBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10387] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10388] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10389] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10390] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10391] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14434),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10392] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_RBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10393] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10394] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10395] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10396] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_RBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10397] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_RBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10398] = {
    [aux_sym_exceptions_repeat1] = STATE(11207),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_RBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10399] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_RBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [10400] = {
    [sym_string] = STATE(10400),
    [aux_sym_chained_string_repeat1] = STATE(10400),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_RBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10401] = {
    [aux_sym_exceptions_repeat1] = STATE(10401),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14436),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10402] = {
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12615),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_in] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_EQ_GT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_RBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_COLON2] = ACTIONS(12617),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12615),
    [anon_sym_AMP_AMP] = ACTIONS(12615),
    [anon_sym_LT_LT] = ACTIONS(12615),
    [anon_sym_GT_GT] = ACTIONS(12615),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12615),
    [anon_sym_PLUS] = ACTIONS(12615),
    [anon_sym_SLASH] = ACTIONS(12615),
    [anon_sym_PERCENT] = ACTIONS(12615),
    [sym_comment] = ACTIONS(87),
  },
  [10403] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5608),
    [sym__binary_star2] = ACTIONS(5610),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5612),
    [anon_sym_STAR_STAR] = ACTIONS(5614),
    [anon_sym_AMP] = ACTIONS(5616),
    [anon_sym_LT] = ACTIONS(5618),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5620),
    [anon_sym_DOT_DOT] = ACTIONS(5622),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5624),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5626),
    [anon_sym_AMP_AMP] = ACTIONS(5626),
    [anon_sym_LT_LT] = ACTIONS(5628),
    [anon_sym_GT_GT] = ACTIONS(5628),
    [anon_sym_EQ_EQ] = ACTIONS(5630),
    [anon_sym_BANG_EQ] = ACTIONS(5626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5626),
    [anon_sym_LT_EQ_GT] = ACTIONS(5626),
    [anon_sym_EQ_TILDE] = ACTIONS(5626),
    [anon_sym_BANG_TILDE] = ACTIONS(5626),
    [anon_sym_LT_EQ] = ACTIONS(5618),
    [anon_sym_GT] = ACTIONS(5618),
    [anon_sym_GT_EQ] = ACTIONS(5632),
    [anon_sym_CARET] = ACTIONS(5634),
    [anon_sym_PLUS] = ACTIONS(5636),
    [anon_sym_SLASH] = ACTIONS(5614),
    [anon_sym_PERCENT] = ACTIONS(5614),
    [sym_comment] = ACTIONS(87),
  },
  [10404] = {
    [aux_sym_exceptions_repeat1] = STATE(10404),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14439),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10405] = {
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12916),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_in] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_EQ_GT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_RBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_COLON2] = ACTIONS(12918),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12916),
    [anon_sym_AMP_AMP] = ACTIONS(12916),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12916),
    [anon_sym_PLUS] = ACTIONS(12916),
    [anon_sym_SLASH] = ACTIONS(12916),
    [anon_sym_PERCENT] = ACTIONS(12916),
    [sym_comment] = ACTIONS(87),
  },
  [10406] = {
    [anon_sym_end] = ACTIONS(14442),
    [sym_comment] = ACTIONS(87),
  },
  [10407] = {
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13064),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_EQ_GT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_RBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13064),
    [anon_sym_AMP_AMP] = ACTIONS(13064),
    [anon_sym_LT_LT] = ACTIONS(13064),
    [anon_sym_GT_GT] = ACTIONS(13064),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13064),
    [anon_sym_PLUS] = ACTIONS(13064),
    [anon_sym_SLASH] = ACTIONS(13064),
    [anon_sym_PERCENT] = ACTIONS(13064),
    [sym_comment] = ACTIONS(87),
  },
  [10408] = {
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13216),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_in] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_EQ_GT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_RBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_COLON2] = ACTIONS(13218),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13216),
    [anon_sym_AMP_AMP] = ACTIONS(13216),
    [anon_sym_LT_LT] = ACTIONS(13216),
    [anon_sym_GT_GT] = ACTIONS(13216),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13216),
    [anon_sym_PLUS] = ACTIONS(13216),
    [anon_sym_SLASH] = ACTIONS(13216),
    [anon_sym_PERCENT] = ACTIONS(13216),
    [sym_comment] = ACTIONS(87),
  },
  [10409] = {
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_in] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_EQ_GT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_RBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_COLON2] = ACTIONS(13229),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13227),
    [anon_sym_AMP_AMP] = ACTIONS(13227),
    [anon_sym_LT_LT] = ACTIONS(13227),
    [anon_sym_GT_GT] = ACTIONS(13227),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13227),
    [anon_sym_PLUS] = ACTIONS(13227),
    [anon_sym_SLASH] = ACTIONS(13227),
    [anon_sym_PERCENT] = ACTIONS(13227),
    [sym_comment] = ACTIONS(87),
  },
  [10410] = {
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13551),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_in] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_EQ_GT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_RBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_COLON2] = ACTIONS(13553),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13551),
    [anon_sym_AMP_AMP] = ACTIONS(13551),
    [anon_sym_LT_LT] = ACTIONS(13551),
    [anon_sym_GT_GT] = ACTIONS(13551),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13551),
    [anon_sym_PLUS] = ACTIONS(13551),
    [anon_sym_SLASH] = ACTIONS(13551),
    [anon_sym_PERCENT] = ACTIONS(13551),
    [sym_comment] = ACTIONS(87),
  },
  [10411] = {
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_in] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_RBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_COLON2] = ACTIONS(13728),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13726),
    [anon_sym_AMP_AMP] = ACTIONS(13726),
    [anon_sym_LT_LT] = ACTIONS(13726),
    [anon_sym_GT_GT] = ACTIONS(13726),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13726),
    [anon_sym_PLUS] = ACTIONS(13726),
    [anon_sym_SLASH] = ACTIONS(13726),
    [anon_sym_PERCENT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [10412] = {
    [anon_sym_end] = ACTIONS(14444),
    [sym_comment] = ACTIONS(87),
  },
  [10413] = {
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_rescue] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_in] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_EQ_GT] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_RBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [10414] = {
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_in] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_EQ_GT] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_RBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_COLON2] = ACTIONS(13728),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [10415] = {
    [anon_sym_end] = ACTIONS(14446),
    [sym_comment] = ACTIONS(87),
  },
  [10416] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(5698),
    [sym__binary_star2] = ACTIONS(5700),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(5702),
    [anon_sym_STAR_STAR] = ACTIONS(5704),
    [anon_sym_AMP] = ACTIONS(5706),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(5708),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(5710),
    [anon_sym_DOT_DOT] = ACTIONS(5712),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5714),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5716),
    [anon_sym_AMP_AMP] = ACTIONS(5716),
    [anon_sym_LT_LT] = ACTIONS(5718),
    [anon_sym_GT_GT] = ACTIONS(5718),
    [anon_sym_EQ_EQ] = ACTIONS(5716),
    [anon_sym_BANG_EQ] = ACTIONS(5720),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5720),
    [anon_sym_LT_EQ_GT] = ACTIONS(5720),
    [anon_sym_EQ_TILDE] = ACTIONS(5720),
    [anon_sym_BANG_TILDE] = ACTIONS(5720),
    [anon_sym_LT_EQ] = ACTIONS(5708),
    [anon_sym_GT] = ACTIONS(5708),
    [anon_sym_GT_EQ] = ACTIONS(5722),
    [anon_sym_CARET] = ACTIONS(5702),
    [anon_sym_PLUS] = ACTIONS(5724),
    [anon_sym_SLASH] = ACTIONS(5704),
    [anon_sym_PERCENT] = ACTIONS(5704),
    [sym_comment] = ACTIONS(87),
  },
  [10417] = {
    [aux_sym_exceptions_repeat1] = STATE(10417),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14448),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10418] = {
    [sym__simple_symbol2] = ACTIONS(14451),
    [sym__string_start2] = ACTIONS(14451),
    [sym__symbol_start2] = ACTIONS(14451),
    [sym__subshell_start2] = ACTIONS(14451),
    [sym__regex_start2] = ACTIONS(14451),
    [sym__string_array_start2] = ACTIONS(14451),
    [sym__symbol_array_start2] = ACTIONS(14451),
    [sym_heredoc_beginning2] = ACTIONS(14451),
    [sym__unary_minus2] = ACTIONS(14451),
    [anon_sym_BEGIN] = ACTIONS(14453),
    [anon_sym_LBRACE] = ACTIONS(14451),
    [anon_sym_RBRACE] = ACTIONS(14451),
    [anon_sym_END] = ACTIONS(14453),
    [anon_sym_def] = ACTIONS(14453),
    [anon_sym_LPAREN] = ACTIONS(14451),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_SEMI] = ACTIONS(14451),
    [anon_sym_STAR] = ACTIONS(14451),
    [anon_sym_class] = ACTIONS(14453),
    [anon_sym_module] = ACTIONS(14453),
    [anon_sym_return] = ACTIONS(14453),
    [anon_sym_yield] = ACTIONS(14453),
    [anon_sym_break] = ACTIONS(14453),
    [anon_sym_next] = ACTIONS(14453),
    [sym_redo] = ACTIONS(14453),
    [sym_retry] = ACTIONS(14453),
    [anon_sym_if] = ACTIONS(14453),
    [anon_sym_unless] = ACTIONS(14453),
    [anon_sym_while] = ACTIONS(14453),
    [anon_sym_until] = ACTIONS(14453),
    [anon_sym_for] = ACTIONS(14453),
    [anon_sym_case] = ACTIONS(14453),
    [anon_sym_begin] = ACTIONS(14453),
    [anon_sym_PLUS] = ACTIONS(14453),
    [anon_sym_defined_QMARK] = ACTIONS(14451),
    [anon_sym_not] = ACTIONS(14453),
    [anon_sym_BANG] = ACTIONS(14451),
    [anon_sym_TILDE] = ACTIONS(14451),
    [sym_constant] = ACTIONS(14453),
    [sym_identifier] = ACTIONS(14453),
    [sym_instance_variable] = ACTIONS(14451),
    [sym_class_variable] = ACTIONS(14451),
    [sym_global_variable] = ACTIONS(14451),
    [anon_sym_undef] = ACTIONS(14453),
    [anon_sym_alias] = ACTIONS(14453),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14453),
    [sym_float] = ACTIONS(14453),
    [sym_complex] = ACTIONS(14451),
    [sym_super] = ACTIONS(14453),
    [anon_sym_true] = ACTIONS(14453),
    [anon_sym_TRUE] = ACTIONS(14453),
    [anon_sym_false] = ACTIONS(14453),
    [anon_sym_FALSE] = ACTIONS(14453),
    [sym_self] = ACTIONS(14453),
    [anon_sym_nil] = ACTIONS(14453),
    [anon_sym_NIL] = ACTIONS(14453),
    [sym_character] = ACTIONS(14451),
    [anon_sym_LBRACK2] = ACTIONS(14451),
    [anon_sym_DASH_GT] = ACTIONS(14451),
  },
  [10419] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(14455),
    [sym_comment] = ACTIONS(87),
  },
  [10420] = {
    [anon_sym_COMMA] = ACTIONS(14457),
    [anon_sym_PIPE] = ACTIONS(14457),
    [sym_comment] = ACTIONS(87),
  },
  [10421] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(14459),
    [anon_sym_PIPE] = ACTIONS(14457),
    [sym_comment] = ACTIONS(87),
  },
  [10422] = {
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [10423] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11220),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11220),
    [sym_operator_assignment] = STATE(11220),
    [sym_conditional] = STATE(11220),
    [sym_range] = STATE(11220),
    [sym_binary] = STATE(11220),
    [sym_unary] = STATE(11220),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10424] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11225),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11225),
    [sym_operator_assignment] = STATE(11225),
    [sym_conditional] = STATE(11225),
    [sym_range] = STATE(11225),
    [sym_binary] = STATE(11225),
    [sym_unary] = STATE(11225),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10425] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11226),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11226),
    [sym_operator_assignment] = STATE(11226),
    [sym_conditional] = STATE(11226),
    [sym_range] = STATE(11226),
    [sym_binary] = STATE(11226),
    [sym_unary] = STATE(11226),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10426] = {
    [anon_sym_COLON] = ACTIONS(14486),
    [sym_comment] = ACTIONS(87),
  },
  [10427] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11229),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11229),
    [sym_operator_assignment] = STATE(11229),
    [sym_conditional] = STATE(11229),
    [sym_range] = STATE(11229),
    [sym_binary] = STATE(11229),
    [sym_unary] = STATE(11229),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10428] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(11236),
    [sym__argument] = STATE(11237),
    [sym_splat_argument] = STATE(11237),
    [sym_hash_splat_argument] = STATE(11237),
    [sym_block_argument] = STATE(11237),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(11237),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10429] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(11236),
    [sym__argument] = STATE(11237),
    [sym_splat_argument] = STATE(11237),
    [sym_hash_splat_argument] = STATE(11237),
    [sym_block_argument] = STATE(11237),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(11237),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10430] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(11236),
    [sym__argument] = STATE(11237),
    [sym_splat_argument] = STATE(11237),
    [sym_hash_splat_argument] = STATE(11237),
    [sym_block_argument] = STATE(11237),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(11237),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10431] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(11236),
    [sym__argument] = STATE(11237),
    [sym_splat_argument] = STATE(11237),
    [sym_hash_splat_argument] = STATE(11237),
    [sym_block_argument] = STATE(11237),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(11237),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10432] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11239),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11239),
    [sym_operator_assignment] = STATE(11239),
    [sym_conditional] = STATE(11239),
    [sym_range] = STATE(11239),
    [sym_binary] = STATE(11239),
    [sym_unary] = STATE(11239),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10433] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11240),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11240),
    [sym_operator_assignment] = STATE(11240),
    [sym_conditional] = STATE(11240),
    [sym_range] = STATE(11240),
    [sym_binary] = STATE(11240),
    [sym_unary] = STATE(11240),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10434] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10435] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14496),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [10436] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(14510),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [10437] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(1440),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(2455),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(2465),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10438] = {
    [sym_heredoc_body] = STATE(11263),
    [aux_sym_call_repeat1] = STATE(11263),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10439] = {
    [sym_heredoc_body] = STATE(11263),
    [aux_sym_call_repeat1] = STATE(11263),
    [aux_sym_argument_list_repeat1] = STATE(11265),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14538),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [10440] = {
    [anon_sym_EQ] = ACTIONS(14540),
    [sym_comment] = ACTIONS(87),
  },
  [10441] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14542),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14544),
    [anon_sym_DASH_EQ] = ACTIONS(14544),
    [anon_sym_STAR_EQ] = ACTIONS(14544),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14544),
    [anon_sym_SLASH_EQ] = ACTIONS(14544),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14544),
    [anon_sym_PIPE_EQ] = ACTIONS(14544),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14544),
    [anon_sym_AMP_EQ] = ACTIONS(14544),
    [anon_sym_PERCENT_EQ] = ACTIONS(14544),
    [anon_sym_GT_GT_EQ] = ACTIONS(14544),
    [anon_sym_LT_LT_EQ] = ACTIONS(14544),
    [anon_sym_CARET_EQ] = ACTIONS(14544),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10442] = {
    [sym_string] = STATE(11268),
    [aux_sym_chained_string_repeat1] = STATE(11268),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14546),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10443] = {
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [10444] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [10445] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11269),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11269),
    [sym_operator_assignment] = STATE(11269),
    [sym_conditional] = STATE(11269),
    [sym_range] = STATE(11269),
    [sym_binary] = STATE(11269),
    [sym_unary] = STATE(11269),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10446] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11270),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11270),
    [sym_operator_assignment] = STATE(11270),
    [sym_conditional] = STATE(11270),
    [sym_range] = STATE(11270),
    [sym_binary] = STATE(11270),
    [sym_unary] = STATE(11270),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10447] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11271),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11271),
    [sym_operator_assignment] = STATE(11271),
    [sym_conditional] = STATE(11271),
    [sym_range] = STATE(11271),
    [sym_binary] = STATE(11271),
    [sym_unary] = STATE(11271),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10448] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11272),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11272),
    [sym_operator_assignment] = STATE(11272),
    [sym_conditional] = STATE(11272),
    [sym_range] = STATE(11272),
    [sym_binary] = STATE(11272),
    [sym_unary] = STATE(11272),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10449] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11273),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11273),
    [sym_operator_assignment] = STATE(11273),
    [sym_conditional] = STATE(11273),
    [sym_range] = STATE(11273),
    [sym_binary] = STATE(11273),
    [sym_unary] = STATE(11273),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10450] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11274),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11274),
    [sym_operator_assignment] = STATE(11274),
    [sym_conditional] = STATE(11274),
    [sym_range] = STATE(11274),
    [sym_binary] = STATE(11274),
    [sym_unary] = STATE(11274),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10451] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11275),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11275),
    [sym_operator_assignment] = STATE(11275),
    [sym_conditional] = STATE(11275),
    [sym_range] = STATE(11275),
    [sym_binary] = STATE(11275),
    [sym_unary] = STATE(11275),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10452] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11276),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11276),
    [sym_operator_assignment] = STATE(11276),
    [sym_conditional] = STATE(11276),
    [sym_range] = STATE(11276),
    [sym_binary] = STATE(11276),
    [sym_unary] = STATE(11276),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10453] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11277),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11277),
    [sym_operator_assignment] = STATE(11277),
    [sym_conditional] = STATE(11277),
    [sym_range] = STATE(11277),
    [sym_binary] = STATE(11277),
    [sym_unary] = STATE(11277),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10454] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11278),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11278),
    [sym_operator_assignment] = STATE(11278),
    [sym_conditional] = STATE(11278),
    [sym_range] = STATE(11278),
    [sym_binary] = STATE(11278),
    [sym_unary] = STATE(11278),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10455] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11279),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11279),
    [sym_operator_assignment] = STATE(11279),
    [sym_conditional] = STATE(11279),
    [sym_range] = STATE(11279),
    [sym_binary] = STATE(11279),
    [sym_unary] = STATE(11279),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10456] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11280),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11280),
    [sym_operator_assignment] = STATE(11280),
    [sym_conditional] = STATE(11280),
    [sym_range] = STATE(11280),
    [sym_binary] = STATE(11280),
    [sym_unary] = STATE(11280),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10457] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11289),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11289),
    [sym_operator_assignment] = STATE(11289),
    [sym_conditional] = STATE(11289),
    [sym_range] = STATE(11289),
    [sym_binary] = STATE(11289),
    [sym_unary] = STATE(11289),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10458] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11294),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11294),
    [sym_operator_assignment] = STATE(11294),
    [sym_conditional] = STATE(11294),
    [sym_range] = STATE(11294),
    [sym_binary] = STATE(11294),
    [sym_unary] = STATE(11294),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10459] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11295),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11295),
    [sym_operator_assignment] = STATE(11295),
    [sym_conditional] = STATE(11295),
    [sym_range] = STATE(11295),
    [sym_binary] = STATE(11295),
    [sym_unary] = STATE(11295),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10460] = {
    [anon_sym_COLON] = ACTIONS(14574),
    [sym_comment] = ACTIONS(87),
  },
  [10461] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11298),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11298),
    [sym_operator_assignment] = STATE(11298),
    [sym_conditional] = STATE(11298),
    [sym_range] = STATE(11298),
    [sym_binary] = STATE(11298),
    [sym_unary] = STATE(11298),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10462] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(2048),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(363),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10463] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(2049),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10464] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(2050),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(419),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10465] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(2051),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(423),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10466] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11299),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11299),
    [sym_operator_assignment] = STATE(11299),
    [sym_conditional] = STATE(11299),
    [sym_range] = STATE(11299),
    [sym_binary] = STATE(11299),
    [sym_unary] = STATE(11299),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10467] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11300),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11300),
    [sym_operator_assignment] = STATE(11300),
    [sym_conditional] = STATE(11300),
    [sym_range] = STATE(11300),
    [sym_binary] = STATE(11300),
    [sym_unary] = STATE(11300),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10468] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(2074),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(2074),
    [sym_operator_assignment] = STATE(2074),
    [sym_conditional] = STATE(2074),
    [sym_range] = STATE(2074),
    [sym_binary] = STATE(2074),
    [sym_unary] = STATE(2074),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10469] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14576),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [10470] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(14590),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [10471] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(2096),
    [sym__argument_list_with_parens] = STATE(11260),
    [sym__argument] = STATE(11261),
    [sym_splat_argument] = STATE(11261),
    [sym_hash_splat_argument] = STATE(11261),
    [sym_block_argument] = STATE(11261),
    [sym_do_block] = STATE(1443),
    [sym_block] = STATE(1443),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(11261),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(3466),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_EQ_GT] = ACTIONS(749),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(1209),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10472] = {
    [sym_heredoc_body] = STATE(11314),
    [aux_sym_call_repeat1] = STATE(11314),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [10473] = {
    [sym_heredoc_body] = STATE(11314),
    [aux_sym_call_repeat1] = STATE(11314),
    [aux_sym_argument_list_repeat1] = STATE(11316),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14608),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [10474] = {
    [anon_sym_EQ] = ACTIONS(14610),
    [sym_comment] = ACTIONS(87),
  },
  [10475] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14612),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14614),
    [anon_sym_DASH_EQ] = ACTIONS(14614),
    [anon_sym_STAR_EQ] = ACTIONS(14614),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14614),
    [anon_sym_SLASH_EQ] = ACTIONS(14614),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14614),
    [anon_sym_PIPE_EQ] = ACTIONS(14614),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14614),
    [anon_sym_AMP_EQ] = ACTIONS(14614),
    [anon_sym_PERCENT_EQ] = ACTIONS(14614),
    [anon_sym_GT_GT_EQ] = ACTIONS(14614),
    [anon_sym_LT_LT_EQ] = ACTIONS(14614),
    [anon_sym_CARET_EQ] = ACTIONS(14614),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10476] = {
    [sym_string] = STATE(11319),
    [aux_sym_chained_string_repeat1] = STATE(11319),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14616),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10477] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11321),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_splat_argument] = STATE(11322),
    [sym_assignment] = STATE(11321),
    [sym_operator_assignment] = STATE(11321),
    [sym_conditional] = STATE(11321),
    [sym_range] = STATE(11321),
    [sym_binary] = STATE(11321),
    [sym_unary] = STATE(11321),
    [sym_right_assignment_list] = STATE(2116),
    [sym__arg_or_splat_arg] = STATE(11322),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(14618),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10478] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11323),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11323),
    [sym_operator_assignment] = STATE(11323),
    [sym_conditional] = STATE(11323),
    [sym_range] = STATE(11323),
    [sym_binary] = STATE(11323),
    [sym_unary] = STATE(11323),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10479] = {
    [sym_string] = STATE(11324),
    [aux_sym_chained_string_repeat1] = STATE(11324),
    [sym__string_start2] = ACTIONS(139),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [10480] = {
    [aux_sym_block_parameters_repeat1] = STATE(11325),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(14455),
    [sym_comment] = ACTIONS(87),
  },
  [10481] = {
    [sym_identifier] = ACTIONS(14620),
    [sym_comment] = ACTIONS(87),
  },
  [10482] = {
    [sym__formal_parameter] = STATE(6473),
    [sym__simple_formal_parameter] = STATE(6473),
    [sym_destructured_parameter] = STATE(6473),
    [sym_splat_parameter] = STATE(6473),
    [sym_hash_splat_parameter] = STATE(6473),
    [sym_block_parameter] = STATE(6473),
    [sym_keyword_parameter] = STATE(6473),
    [sym_optional_parameter] = STATE(6473),
    [anon_sym_LPAREN] = ACTIONS(2499),
    [anon_sym_STAR] = ACTIONS(671),
    [anon_sym_STAR_STAR] = ACTIONS(673),
    [anon_sym_AMP] = ACTIONS(675),
    [sym_identifier] = ACTIONS(5760),
    [sym_comment] = ACTIONS(87),
  },
  [10483] = {
    [sym__line_break2] = ACTIONS(14451),
    [sym__simple_symbol2] = ACTIONS(14451),
    [sym__string_start2] = ACTIONS(14451),
    [sym__symbol_start2] = ACTIONS(14451),
    [sym__subshell_start2] = ACTIONS(14451),
    [sym__regex_start2] = ACTIONS(14451),
    [sym__string_array_start2] = ACTIONS(14451),
    [sym__symbol_array_start2] = ACTIONS(14451),
    [sym__heredoc_body_start2] = ACTIONS(14451),
    [sym_heredoc_beginning2] = ACTIONS(14451),
    [sym__unary_minus2] = ACTIONS(14451),
    [anon_sym_BEGIN] = ACTIONS(14453),
    [anon_sym_LBRACE] = ACTIONS(14451),
    [anon_sym_END] = ACTIONS(14453),
    [anon_sym_def] = ACTIONS(14453),
    [anon_sym_LPAREN] = ACTIONS(14451),
    [anon_sym_COLON_COLON] = ACTIONS(14451),
    [anon_sym_SEMI] = ACTIONS(14451),
    [anon_sym_STAR] = ACTIONS(14451),
    [anon_sym_class] = ACTIONS(14453),
    [anon_sym_module] = ACTIONS(14453),
    [anon_sym_end] = ACTIONS(14453),
    [anon_sym_return] = ACTIONS(14453),
    [anon_sym_yield] = ACTIONS(14453),
    [anon_sym_break] = ACTIONS(14453),
    [anon_sym_next] = ACTIONS(14453),
    [sym_redo] = ACTIONS(14453),
    [sym_retry] = ACTIONS(14453),
    [anon_sym_if] = ACTIONS(14453),
    [anon_sym_unless] = ACTIONS(14453),
    [anon_sym_while] = ACTIONS(14453),
    [anon_sym_until] = ACTIONS(14453),
    [anon_sym_for] = ACTIONS(14453),
    [anon_sym_case] = ACTIONS(14453),
    [anon_sym_begin] = ACTIONS(14453),
    [anon_sym_PLUS] = ACTIONS(14453),
    [anon_sym_defined_QMARK] = ACTIONS(14451),
    [anon_sym_not] = ACTIONS(14453),
    [anon_sym_BANG] = ACTIONS(14451),
    [anon_sym_TILDE] = ACTIONS(14451),
    [sym_constant] = ACTIONS(14453),
    [sym_identifier] = ACTIONS(14453),
    [sym_instance_variable] = ACTIONS(14451),
    [sym_class_variable] = ACTIONS(14451),
    [sym_global_variable] = ACTIONS(14451),
    [anon_sym_undef] = ACTIONS(14453),
    [anon_sym_alias] = ACTIONS(14453),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(14453),
    [sym_float] = ACTIONS(14453),
    [sym_complex] = ACTIONS(14451),
    [sym_super] = ACTIONS(14453),
    [anon_sym_true] = ACTIONS(14453),
    [anon_sym_TRUE] = ACTIONS(14453),
    [anon_sym_false] = ACTIONS(14453),
    [anon_sym_FALSE] = ACTIONS(14453),
    [sym_self] = ACTIONS(14453),
    [anon_sym_nil] = ACTIONS(14453),
    [anon_sym_NIL] = ACTIONS(14453),
    [sym_character] = ACTIONS(14451),
    [anon_sym_LBRACK2] = ACTIONS(14451),
    [anon_sym_DASH_GT] = ACTIONS(14451),
  },
  [10484] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(14622),
    [sym_comment] = ACTIONS(87),
  },
  [10485] = {
    [aux_sym_block_parameters_repeat1] = STATE(11328),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(14622),
    [sym_comment] = ACTIONS(87),
  },
  [10486] = {
    [sym_identifier] = ACTIONS(14624),
    [sym_comment] = ACTIONS(87),
  },
  [10487] = {
    [sym__line_break2] = ACTIONS(14626),
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [ts_builtin_sym_end] = ACTIONS(14626),
    [anon_sym___END__] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14626),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_end] = ACTIONS(14626),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_when] = ACTIONS(14626),
    [anon_sym_elsif] = ACTIONS(14626),
    [anon_sym_else] = ACTIONS(14626),
    [anon_sym_then] = ACTIONS(14626),
    [anon_sym_ensure] = ACTIONS(14626),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14626),
    [anon_sym_AMP_AMP] = ACTIONS(14626),
    [anon_sym_LT_LT] = ACTIONS(14626),
    [anon_sym_GT_GT] = ACTIONS(14626),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14626),
    [anon_sym_PLUS] = ACTIONS(14626),
    [anon_sym_SLASH] = ACTIONS(14626),
    [anon_sym_PERCENT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [10488] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11330),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_assignment] = STATE(11330),
    [sym_operator_assignment] = STATE(11330),
    [sym_conditional] = STATE(11330),
    [sym_range] = STATE(11330),
    [sym_binary] = STATE(11330),
    [sym_unary] = STATE(11330),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10489] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [10490] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(8950),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(3686),
    [sym_scope_resolution] = STATE(3684),
    [sym_call] = STATE(3684),
    [sym_method_call] = STATE(3686),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(8950),
    [sym_operator_assignment] = STATE(8950),
    [sym_conditional] = STATE(8950),
    [sym_range] = STATE(8950),
    [sym_binary] = STATE(8950),
    [sym_unary] = STATE(8950),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(3685),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3686),
    [sym__variable] = STATE(3684),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(3686),
    [sym_false] = STATE(3686),
    [sym_nil] = STATE(3686),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(3687),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(12106),
    [sym__unary_minus2] = ACTIONS(5796),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(5800),
    [anon_sym_yield] = ACTIONS(5802),
    [anon_sym_break] = ACTIONS(5804),
    [anon_sym_next] = ACTIONS(5806),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(5810),
    [anon_sym_defined_QMARK] = ACTIONS(5812),
    [anon_sym_not] = ACTIONS(5814),
    [anon_sym_BANG] = ACTIONS(5816),
    [anon_sym_TILDE] = ACTIONS(5816),
    [sym_constant] = ACTIONS(5818),
    [sym_identifier] = ACTIONS(5818),
    [sym_instance_variable] = ACTIONS(5820),
    [sym_class_variable] = ACTIONS(5820),
    [sym_global_variable] = ACTIONS(5820),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(5818),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(5818),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10491] = {
    [aux_sym_exceptions_repeat1] = STATE(11331),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(14630),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10492] = {
    [sym_heredoc_body] = STATE(11332),
    [aux_sym_call_repeat1] = STATE(11332),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10493] = {
    [sym_heredoc_body] = STATE(11333),
    [aux_sym_call_repeat1] = STATE(11333),
    [aux_sym_argument_list_repeat1] = STATE(9009),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(9647),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_COLON2] = ACTIONS(4348),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10494] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10495] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10496] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10497] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10498] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10499] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10500] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14632),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10501] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(7862),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10502] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10503] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10504] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10505] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10506] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(7910),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10507] = {
    [aux_sym_exceptions_repeat1] = STATE(11336),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10508] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(7912),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [10509] = {
    [sym_string] = STATE(10509),
    [aux_sym_chained_string_repeat1] = STATE(10509),
    [sym__string_start2] = ACTIONS(12810),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10510] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_STAR_STAR] = ACTIONS(2947),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_LT_LT] = ACTIONS(2947),
    [anon_sym_GT_GT] = ACTIONS(2947),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2947),
    [anon_sym_SLASH] = ACTIONS(2947),
    [anon_sym_PERCENT] = ACTIONS(2947),
    [sym_comment] = ACTIONS(87),
  },
  [10511] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(7792),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [10512] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(7858),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [10513] = {
    [sym_heredoc_body] = STATE(10513),
    [aux_sym_call_repeat1] = STATE(10513),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_COLON2] = ACTIONS(7893),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10514] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(6529),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(6529),
    [sym_operator_assignment] = STATE(6529),
    [sym_conditional] = STATE(6529),
    [sym_range] = STATE(6529),
    [sym_binary] = STATE(6529),
    [sym_unary] = STATE(6529),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6532),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(9597),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [sym__identifier_hash_key2] = ACTIONS(9601),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13736),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(9603),
    [sym_identifier] = ACTIONS(9603),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10515] = {
    [sym_heredoc_body] = STATE(10513),
    [aux_sym_call_repeat1] = STATE(10513),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_COLON2] = ACTIONS(7905),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10516] = {
    [aux_sym_argument_list_repeat1] = STATE(10516),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14634),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10517] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11337),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_assignment] = STATE(11337),
    [sym_operator_assignment] = STATE(11337),
    [sym_conditional] = STATE(11337),
    [sym_range] = STATE(11337),
    [sym_binary] = STATE(11337),
    [sym_unary] = STATE(11337),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10518] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(7792),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [10519] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(7858),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [10520] = {
    [sym_heredoc_body] = STATE(10520),
    [aux_sym_call_repeat1] = STATE(10520),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_COLON2] = ACTIONS(7893),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10521] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(6553),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(6553),
    [sym_operator_assignment] = STATE(6553),
    [sym_conditional] = STATE(6553),
    [sym_range] = STATE(6553),
    [sym_binary] = STATE(6553),
    [sym_unary] = STATE(6553),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6556),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(9639),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [sym__identifier_hash_key2] = ACTIONS(9643),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13740),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(9645),
    [sym_identifier] = ACTIONS(9645),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10522] = {
    [sym_heredoc_body] = STATE(10520),
    [aux_sym_call_repeat1] = STATE(10520),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_COLON2] = ACTIONS(7905),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10523] = {
    [aux_sym_argument_list_repeat1] = STATE(10523),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14637),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_COLON2] = ACTIONS(7901),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10524] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(9010),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(3714),
    [sym_scope_resolution] = STATE(3710),
    [sym_call] = STATE(3710),
    [sym_method_call] = STATE(3714),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(9010),
    [sym_operator_assignment] = STATE(9010),
    [sym_conditional] = STATE(9010),
    [sym_range] = STATE(9010),
    [sym_binary] = STATE(9010),
    [sym_unary] = STATE(9010),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(3713),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3714),
    [sym__variable] = STATE(3710),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(3714),
    [sym_false] = STATE(3714),
    [sym_nil] = STATE(3714),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(6521),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(9591),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(9599),
    [sym__unary_minus2] = ACTIONS(5870),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(5874),
    [anon_sym_yield] = ACTIONS(5876),
    [anon_sym_break] = ACTIONS(5878),
    [anon_sym_next] = ACTIONS(5880),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9593),
    [anon_sym_defined_QMARK] = ACTIONS(5882),
    [anon_sym_not] = ACTIONS(5884),
    [anon_sym_BANG] = ACTIONS(5888),
    [anon_sym_TILDE] = ACTIONS(5888),
    [sym_constant] = ACTIONS(5894),
    [sym_identifier] = ACTIONS(5894),
    [sym_instance_variable] = ACTIONS(5892),
    [sym_class_variable] = ACTIONS(5892),
    [sym_global_variable] = ACTIONS(5892),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(5894),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5894),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10525] = {
    [aux_sym_exceptions_repeat1] = STATE(11338),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14640),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_COLON2] = ACTIONS(9931),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10526] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10527] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5854),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10528] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5858),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10529] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10530] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10531] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10532] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10533] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14642),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10534] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(7862),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10535] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10536] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10537] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10538] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5862),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10539] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(7910),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10540] = {
    [aux_sym_exceptions_repeat1] = STATE(11341),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6238),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10541] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(7912),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [10542] = {
    [sym_string] = STATE(10542),
    [aux_sym_chained_string_repeat1] = STATE(10542),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10543] = {
    [sym__string_start2] = ACTIONS(2947),
    [sym__heredoc_body_start2] = ACTIONS(2947),
    [sym__binary_minus2] = ACTIONS(2947),
    [sym__binary_star2] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_STAR_STAR] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_do] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_COLON_COLON2] = ACTIONS(2947),
    [anon_sym_AMP_DOT] = ACTIONS(2947),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2947),
    [anon_sym_COLON2] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2949),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2949),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ_GT] = ACTIONS(2947),
    [anon_sym_EQ_TILDE] = ACTIONS(2947),
    [anon_sym_BANG_TILDE] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2949),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [sym_comment] = ACTIONS(87),
  },
  [10544] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11342),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_assignment] = STATE(11342),
    [sym_operator_assignment] = STATE(11342),
    [sym_conditional] = STATE(11342),
    [sym_range] = STATE(11342),
    [sym_binary] = STATE(11342),
    [sym_unary] = STATE(11342),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10545] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(9053),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(3749),
    [sym_scope_resolution] = STATE(3745),
    [sym_call] = STATE(3745),
    [sym_method_call] = STATE(3749),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(9053),
    [sym_operator_assignment] = STATE(9053),
    [sym_conditional] = STATE(9053),
    [sym_range] = STATE(9053),
    [sym_binary] = STATE(9053),
    [sym_unary] = STATE(9053),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(3748),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3749),
    [sym__variable] = STATE(3745),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(3749),
    [sym_false] = STATE(3749),
    [sym_nil] = STATE(3749),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(6592),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(9679),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(9641),
    [sym__unary_minus2] = ACTIONS(5934),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(5938),
    [anon_sym_yield] = ACTIONS(5940),
    [anon_sym_break] = ACTIONS(5942),
    [anon_sym_next] = ACTIONS(5944),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(9681),
    [anon_sym_defined_QMARK] = ACTIONS(5946),
    [anon_sym_not] = ACTIONS(5948),
    [anon_sym_BANG] = ACTIONS(5952),
    [anon_sym_TILDE] = ACTIONS(5952),
    [sym_constant] = ACTIONS(5958),
    [sym_identifier] = ACTIONS(5958),
    [sym_instance_variable] = ACTIONS(5956),
    [sym_class_variable] = ACTIONS(5956),
    [sym_global_variable] = ACTIONS(5956),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(5958),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(5958),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [10546] = {
    [aux_sym_exceptions_repeat1] = STATE(11343),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14644),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_COLON2] = ACTIONS(9931),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10547] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_COLON2] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10548] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_COLON2] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10549] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10550] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10551] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10552] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10553] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14646),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10554] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_COLON2] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10555] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10556] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10557] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10558] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_COLON2] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10559] = {
    [aux_sym_exceptions_repeat1] = STATE(10559),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14648),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10560] = {
    [aux_sym_exceptions_repeat1] = STATE(9074),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_COLON2] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10561] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(6250),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [10562] = {
    [sym_string] = STATE(10562),
    [aux_sym_chained_string_repeat1] = STATE(10562),
    [sym__string_start2] = ACTIONS(12244),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_COLON2] = ACTIONS(6257),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10563] = {
    [sym__line_break2] = ACTIONS(12497),
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [ts_builtin_sym_end] = ACTIONS(12497),
    [anon_sym___END__] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12499),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_end] = ACTIONS(12497),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_when] = ACTIONS(12497),
    [anon_sym_elsif] = ACTIONS(12497),
    [anon_sym_else] = ACTIONS(12497),
    [anon_sym_then] = ACTIONS(12497),
    [anon_sym_ensure] = ACTIONS(12497),
    [anon_sym_EQ_GT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_PLUS_EQ] = ACTIONS(12497),
    [anon_sym_DASH_EQ] = ACTIONS(12497),
    [anon_sym_STAR_EQ] = ACTIONS(12497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12497),
    [anon_sym_SLASH_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12497),
    [anon_sym_AMP_EQ] = ACTIONS(12497),
    [anon_sym_PERCENT_EQ] = ACTIONS(12497),
    [anon_sym_GT_GT_EQ] = ACTIONS(12497),
    [anon_sym_LT_LT_EQ] = ACTIONS(12497),
    [anon_sym_CARET_EQ] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12499),
    [anon_sym_AMP_AMP] = ACTIONS(12499),
    [anon_sym_LT_LT] = ACTIONS(12499),
    [anon_sym_GT_GT] = ACTIONS(12499),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12499),
    [anon_sym_PLUS] = ACTIONS(12499),
    [anon_sym_SLASH] = ACTIONS(12499),
    [anon_sym_PERCENT] = ACTIONS(12499),
    [sym_comment] = ACTIONS(87),
  },
  [10564] = {
    [sym__line_break2] = ACTIONS(12501),
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [ts_builtin_sym_end] = ACTIONS(12501),
    [anon_sym___END__] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12503),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_end] = ACTIONS(12501),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_when] = ACTIONS(12501),
    [anon_sym_elsif] = ACTIONS(12501),
    [anon_sym_else] = ACTIONS(12501),
    [anon_sym_then] = ACTIONS(12501),
    [anon_sym_ensure] = ACTIONS(12501),
    [anon_sym_EQ_GT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_PLUS_EQ] = ACTIONS(12501),
    [anon_sym_DASH_EQ] = ACTIONS(12501),
    [anon_sym_STAR_EQ] = ACTIONS(12501),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12501),
    [anon_sym_SLASH_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12501),
    [anon_sym_AMP_EQ] = ACTIONS(12501),
    [anon_sym_PERCENT_EQ] = ACTIONS(12501),
    [anon_sym_GT_GT_EQ] = ACTIONS(12501),
    [anon_sym_LT_LT_EQ] = ACTIONS(12501),
    [anon_sym_CARET_EQ] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12503),
    [anon_sym_AMP_AMP] = ACTIONS(12503),
    [anon_sym_LT_LT] = ACTIONS(12503),
    [anon_sym_GT_GT] = ACTIONS(12503),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12503),
    [anon_sym_PLUS] = ACTIONS(12503),
    [anon_sym_SLASH] = ACTIONS(12503),
    [anon_sym_PERCENT] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [10565] = {
    [sym__line_break2] = ACTIONS(10127),
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [ts_builtin_sym_end] = ACTIONS(10127),
    [anon_sym___END__] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10129),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_end] = ACTIONS(10127),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_when] = ACTIONS(10127),
    [anon_sym_elsif] = ACTIONS(10127),
    [anon_sym_else] = ACTIONS(10127),
    [anon_sym_then] = ACTIONS(10127),
    [anon_sym_ensure] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_PLUS_EQ] = ACTIONS(10127),
    [anon_sym_DASH_EQ] = ACTIONS(10127),
    [anon_sym_STAR_EQ] = ACTIONS(10127),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10127),
    [anon_sym_SLASH_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10127),
    [anon_sym_AMP_EQ] = ACTIONS(10127),
    [anon_sym_PERCENT_EQ] = ACTIONS(10127),
    [anon_sym_GT_GT_EQ] = ACTIONS(10127),
    [anon_sym_LT_LT_EQ] = ACTIONS(10127),
    [anon_sym_CARET_EQ] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10129),
    [anon_sym_AMP_AMP] = ACTIONS(10129),
    [anon_sym_LT_LT] = ACTIONS(10129),
    [anon_sym_GT_GT] = ACTIONS(10129),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10129),
    [anon_sym_PLUS] = ACTIONS(10129),
    [anon_sym_SLASH] = ACTIONS(10129),
    [anon_sym_PERCENT] = ACTIONS(10129),
    [sym_comment] = ACTIONS(87),
  },
  [10566] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14651),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10567] = {
    [sym__line_break2] = ACTIONS(10133),
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [ts_builtin_sym_end] = ACTIONS(10133),
    [anon_sym___END__] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10135),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_end] = ACTIONS(10133),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_when] = ACTIONS(10133),
    [anon_sym_elsif] = ACTIONS(10133),
    [anon_sym_else] = ACTIONS(10133),
    [anon_sym_then] = ACTIONS(10133),
    [anon_sym_ensure] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_PLUS_EQ] = ACTIONS(10133),
    [anon_sym_DASH_EQ] = ACTIONS(10133),
    [anon_sym_STAR_EQ] = ACTIONS(10133),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10133),
    [anon_sym_SLASH_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10133),
    [anon_sym_AMP_EQ] = ACTIONS(10133),
    [anon_sym_PERCENT_EQ] = ACTIONS(10133),
    [anon_sym_GT_GT_EQ] = ACTIONS(10133),
    [anon_sym_LT_LT_EQ] = ACTIONS(10133),
    [anon_sym_CARET_EQ] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10135),
    [anon_sym_GT_GT] = ACTIONS(10135),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10135),
    [anon_sym_PLUS] = ACTIONS(10135),
    [anon_sym_SLASH] = ACTIONS(10135),
    [anon_sym_PERCENT] = ACTIONS(10135),
    [sym_comment] = ACTIONS(87),
  },
  [10568] = {
    [sym__line_break2] = ACTIONS(10137),
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [ts_builtin_sym_end] = ACTIONS(10137),
    [anon_sym___END__] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10139),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_end] = ACTIONS(10137),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_when] = ACTIONS(10137),
    [anon_sym_elsif] = ACTIONS(10137),
    [anon_sym_else] = ACTIONS(10137),
    [anon_sym_then] = ACTIONS(10137),
    [anon_sym_ensure] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_PLUS_EQ] = ACTIONS(10137),
    [anon_sym_DASH_EQ] = ACTIONS(10137),
    [anon_sym_STAR_EQ] = ACTIONS(10137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10137),
    [anon_sym_SLASH_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10137),
    [anon_sym_AMP_EQ] = ACTIONS(10137),
    [anon_sym_PERCENT_EQ] = ACTIONS(10137),
    [anon_sym_GT_GT_EQ] = ACTIONS(10137),
    [anon_sym_LT_LT_EQ] = ACTIONS(10137),
    [anon_sym_CARET_EQ] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10139),
    [anon_sym_AMP_AMP] = ACTIONS(10139),
    [anon_sym_LT_LT] = ACTIONS(10139),
    [anon_sym_GT_GT] = ACTIONS(10139),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10139),
    [anon_sym_PLUS] = ACTIONS(10139),
    [anon_sym_SLASH] = ACTIONS(10139),
    [anon_sym_PERCENT] = ACTIONS(10139),
    [sym_comment] = ACTIONS(87),
  },
  [10569] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14653),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10570] = {
    [sym__line_break2] = ACTIONS(10143),
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [ts_builtin_sym_end] = ACTIONS(10143),
    [anon_sym___END__] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10145),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_end] = ACTIONS(10143),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_when] = ACTIONS(10143),
    [anon_sym_elsif] = ACTIONS(10143),
    [anon_sym_else] = ACTIONS(10143),
    [anon_sym_then] = ACTIONS(10143),
    [anon_sym_ensure] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_PLUS_EQ] = ACTIONS(10143),
    [anon_sym_DASH_EQ] = ACTIONS(10143),
    [anon_sym_STAR_EQ] = ACTIONS(10143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10143),
    [anon_sym_SLASH_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10143),
    [anon_sym_AMP_EQ] = ACTIONS(10143),
    [anon_sym_PERCENT_EQ] = ACTIONS(10143),
    [anon_sym_GT_GT_EQ] = ACTIONS(10143),
    [anon_sym_LT_LT_EQ] = ACTIONS(10143),
    [anon_sym_CARET_EQ] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10145),
    [anon_sym_AMP_AMP] = ACTIONS(10145),
    [anon_sym_LT_LT] = ACTIONS(10145),
    [anon_sym_GT_GT] = ACTIONS(10145),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10145),
    [anon_sym_PLUS] = ACTIONS(10145),
    [anon_sym_SLASH] = ACTIONS(10145),
    [anon_sym_PERCENT] = ACTIONS(10145),
    [sym_comment] = ACTIONS(87),
  },
  [10571] = {
    [sym__method_rest] = STATE(11347),
    [sym_operator] = STATE(3800),
    [sym__method_name] = STATE(3800),
    [sym_setter] = STATE(3800),
    [sym_symbol] = STATE(3800),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12289),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12289),
    [sym_class_variable] = ACTIONS(12289),
    [sym_global_variable] = ACTIONS(12289),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10572] = {
    [sym__line_break2] = ACTIONS(10896),
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [ts_builtin_sym_end] = ACTIONS(10896),
    [anon_sym___END__] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_end] = ACTIONS(10896),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_when] = ACTIONS(10896),
    [anon_sym_elsif] = ACTIONS(10896),
    [anon_sym_else] = ACTIONS(10896),
    [anon_sym_then] = ACTIONS(10896),
    [anon_sym_ensure] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_PLUS_EQ] = ACTIONS(10896),
    [anon_sym_DASH_EQ] = ACTIONS(10896),
    [anon_sym_STAR_EQ] = ACTIONS(10896),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10896),
    [anon_sym_SLASH_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10896),
    [anon_sym_AMP_EQ] = ACTIONS(10896),
    [anon_sym_PERCENT_EQ] = ACTIONS(10896),
    [anon_sym_GT_GT_EQ] = ACTIONS(10896),
    [anon_sym_LT_LT_EQ] = ACTIONS(10896),
    [anon_sym_CARET_EQ] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10898),
    [anon_sym_AMP_AMP] = ACTIONS(10898),
    [anon_sym_LT_LT] = ACTIONS(10898),
    [anon_sym_GT_GT] = ACTIONS(10898),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10898),
    [anon_sym_PLUS] = ACTIONS(10898),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [10573] = {
    [sym__line_break2] = ACTIONS(10900),
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [ts_builtin_sym_end] = ACTIONS(10900),
    [anon_sym___END__] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10902),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_end] = ACTIONS(10900),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_when] = ACTIONS(10900),
    [anon_sym_elsif] = ACTIONS(10900),
    [anon_sym_else] = ACTIONS(10900),
    [anon_sym_then] = ACTIONS(10900),
    [anon_sym_ensure] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_PLUS_EQ] = ACTIONS(10900),
    [anon_sym_DASH_EQ] = ACTIONS(10900),
    [anon_sym_STAR_EQ] = ACTIONS(10900),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10900),
    [anon_sym_SLASH_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10900),
    [anon_sym_AMP_EQ] = ACTIONS(10900),
    [anon_sym_PERCENT_EQ] = ACTIONS(10900),
    [anon_sym_GT_GT_EQ] = ACTIONS(10900),
    [anon_sym_LT_LT_EQ] = ACTIONS(10900),
    [anon_sym_CARET_EQ] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10902),
    [anon_sym_AMP_AMP] = ACTIONS(10902),
    [anon_sym_LT_LT] = ACTIONS(10902),
    [anon_sym_GT_GT] = ACTIONS(10902),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10902),
    [anon_sym_PLUS] = ACTIONS(10902),
    [anon_sym_SLASH] = ACTIONS(10902),
    [anon_sym_PERCENT] = ACTIONS(10902),
    [sym_comment] = ACTIONS(87),
  },
  [10574] = {
    [sym__line_break2] = ACTIONS(11061),
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [ts_builtin_sym_end] = ACTIONS(11061),
    [anon_sym___END__] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11063),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_end] = ACTIONS(11061),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_when] = ACTIONS(11061),
    [anon_sym_elsif] = ACTIONS(11061),
    [anon_sym_else] = ACTIONS(11061),
    [anon_sym_then] = ACTIONS(11061),
    [anon_sym_ensure] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_PLUS_EQ] = ACTIONS(11061),
    [anon_sym_DASH_EQ] = ACTIONS(11061),
    [anon_sym_STAR_EQ] = ACTIONS(11061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11061),
    [anon_sym_SLASH_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11061),
    [anon_sym_AMP_EQ] = ACTIONS(11061),
    [anon_sym_PERCENT_EQ] = ACTIONS(11061),
    [anon_sym_GT_GT_EQ] = ACTIONS(11061),
    [anon_sym_LT_LT_EQ] = ACTIONS(11061),
    [anon_sym_CARET_EQ] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11063),
    [anon_sym_AMP_AMP] = ACTIONS(11063),
    [anon_sym_LT_LT] = ACTIONS(11063),
    [anon_sym_GT_GT] = ACTIONS(11063),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11063),
    [anon_sym_PLUS] = ACTIONS(11063),
    [anon_sym_SLASH] = ACTIONS(11063),
    [anon_sym_PERCENT] = ACTIONS(11063),
    [sym_comment] = ACTIONS(87),
  },
  [10575] = {
    [anon_sym_end] = ACTIONS(14655),
    [sym_comment] = ACTIONS(87),
  },
  [10576] = {
    [sym_elsif] = STATE(11349),
    [sym_else] = STATE(11349),
    [sym__if_tail] = STATE(11349),
    [anon_sym_end] = ACTIONS(14655),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [10577] = {
    [sym__line_break2] = ACTIONS(11236),
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [ts_builtin_sym_end] = ACTIONS(11236),
    [anon_sym___END__] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11238),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_end] = ACTIONS(11236),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_when] = ACTIONS(11236),
    [anon_sym_elsif] = ACTIONS(11236),
    [anon_sym_else] = ACTIONS(11236),
    [anon_sym_then] = ACTIONS(11236),
    [anon_sym_ensure] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_PLUS_EQ] = ACTIONS(11236),
    [anon_sym_DASH_EQ] = ACTIONS(11236),
    [anon_sym_STAR_EQ] = ACTIONS(11236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11236),
    [anon_sym_SLASH_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11236),
    [anon_sym_AMP_EQ] = ACTIONS(11236),
    [anon_sym_PERCENT_EQ] = ACTIONS(11236),
    [anon_sym_GT_GT_EQ] = ACTIONS(11236),
    [anon_sym_LT_LT_EQ] = ACTIONS(11236),
    [anon_sym_CARET_EQ] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11238),
    [anon_sym_AMP_AMP] = ACTIONS(11238),
    [anon_sym_LT_LT] = ACTIONS(11238),
    [anon_sym_GT_GT] = ACTIONS(11238),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11238),
    [anon_sym_PLUS] = ACTIONS(11238),
    [anon_sym_SLASH] = ACTIONS(11238),
    [anon_sym_PERCENT] = ACTIONS(11238),
    [sym_comment] = ACTIONS(87),
  },
  [10578] = {
    [anon_sym_end] = ACTIONS(14657),
    [sym_comment] = ACTIONS(87),
  },
  [10579] = {
    [sym__line_break2] = ACTIONS(11333),
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [ts_builtin_sym_end] = ACTIONS(11333),
    [anon_sym___END__] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_end] = ACTIONS(11333),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_when] = ACTIONS(11333),
    [anon_sym_elsif] = ACTIONS(11333),
    [anon_sym_else] = ACTIONS(11333),
    [anon_sym_then] = ACTIONS(11333),
    [anon_sym_ensure] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_PLUS_EQ] = ACTIONS(11333),
    [anon_sym_DASH_EQ] = ACTIONS(11333),
    [anon_sym_STAR_EQ] = ACTIONS(11333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11333),
    [anon_sym_SLASH_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11333),
    [anon_sym_AMP_EQ] = ACTIONS(11333),
    [anon_sym_PERCENT_EQ] = ACTIONS(11333),
    [anon_sym_GT_GT_EQ] = ACTIONS(11333),
    [anon_sym_LT_LT_EQ] = ACTIONS(11333),
    [anon_sym_CARET_EQ] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [10580] = {
    [sym__line_break2] = ACTIONS(11342),
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [ts_builtin_sym_end] = ACTIONS(11342),
    [anon_sym___END__] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_end] = ACTIONS(11342),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_when] = ACTIONS(11342),
    [anon_sym_elsif] = ACTIONS(11342),
    [anon_sym_else] = ACTIONS(11342),
    [anon_sym_then] = ACTIONS(11342),
    [anon_sym_ensure] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_PLUS_EQ] = ACTIONS(11342),
    [anon_sym_DASH_EQ] = ACTIONS(11342),
    [anon_sym_STAR_EQ] = ACTIONS(11342),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11342),
    [anon_sym_SLASH_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11342),
    [anon_sym_AMP_EQ] = ACTIONS(11342),
    [anon_sym_PERCENT_EQ] = ACTIONS(11342),
    [anon_sym_GT_GT_EQ] = ACTIONS(11342),
    [anon_sym_LT_LT_EQ] = ACTIONS(11342),
    [anon_sym_CARET_EQ] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [10581] = {
    [sym__line_break2] = ACTIONS(11393),
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [ts_builtin_sym_end] = ACTIONS(11393),
    [anon_sym___END__] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11395),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_end] = ACTIONS(11393),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_when] = ACTIONS(11393),
    [anon_sym_elsif] = ACTIONS(11393),
    [anon_sym_else] = ACTIONS(11393),
    [anon_sym_then] = ACTIONS(11393),
    [anon_sym_ensure] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_PLUS_EQ] = ACTIONS(11393),
    [anon_sym_DASH_EQ] = ACTIONS(11393),
    [anon_sym_STAR_EQ] = ACTIONS(11393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11393),
    [anon_sym_SLASH_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11393),
    [anon_sym_AMP_EQ] = ACTIONS(11393),
    [anon_sym_PERCENT_EQ] = ACTIONS(11393),
    [anon_sym_GT_GT_EQ] = ACTIONS(11393),
    [anon_sym_LT_LT_EQ] = ACTIONS(11393),
    [anon_sym_CARET_EQ] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11395),
    [anon_sym_AMP_AMP] = ACTIONS(11395),
    [anon_sym_LT_LT] = ACTIONS(11395),
    [anon_sym_GT_GT] = ACTIONS(11395),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11395),
    [anon_sym_PLUS] = ACTIONS(11395),
    [anon_sym_SLASH] = ACTIONS(11395),
    [anon_sym_PERCENT] = ACTIONS(11395),
    [sym_comment] = ACTIONS(87),
  },
  [10582] = {
    [anon_sym_end] = ACTIONS(14659),
    [sym_comment] = ACTIONS(87),
  },
  [10583] = {
    [sym__line_break2] = ACTIONS(11406),
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [ts_builtin_sym_end] = ACTIONS(11406),
    [anon_sym___END__] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11408),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_end] = ACTIONS(11406),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_when] = ACTIONS(11406),
    [anon_sym_elsif] = ACTIONS(11406),
    [anon_sym_else] = ACTIONS(11406),
    [anon_sym_then] = ACTIONS(11406),
    [anon_sym_ensure] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_PLUS_EQ] = ACTIONS(11406),
    [anon_sym_DASH_EQ] = ACTIONS(11406),
    [anon_sym_STAR_EQ] = ACTIONS(11406),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11406),
    [anon_sym_SLASH_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11406),
    [anon_sym_AMP_EQ] = ACTIONS(11406),
    [anon_sym_PERCENT_EQ] = ACTIONS(11406),
    [anon_sym_GT_GT_EQ] = ACTIONS(11406),
    [anon_sym_LT_LT_EQ] = ACTIONS(11406),
    [anon_sym_CARET_EQ] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11408),
    [anon_sym_AMP_AMP] = ACTIONS(11408),
    [anon_sym_LT_LT] = ACTIONS(11408),
    [anon_sym_GT_GT] = ACTIONS(11408),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11408),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_SLASH] = ACTIONS(11408),
    [anon_sym_PERCENT] = ACTIONS(11408),
    [sym_comment] = ACTIONS(87),
  },
  [10584] = {
    [anon_sym_end] = ACTIONS(14661),
    [sym_comment] = ACTIONS(87),
  },
  [10585] = {
    [sym__line_break2] = ACTIONS(11878),
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [ts_builtin_sym_end] = ACTIONS(11878),
    [anon_sym___END__] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11880),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_end] = ACTIONS(11878),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_when] = ACTIONS(11878),
    [anon_sym_elsif] = ACTIONS(11878),
    [anon_sym_else] = ACTIONS(11878),
    [anon_sym_then] = ACTIONS(11878),
    [anon_sym_ensure] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_PLUS_EQ] = ACTIONS(11878),
    [anon_sym_DASH_EQ] = ACTIONS(11878),
    [anon_sym_STAR_EQ] = ACTIONS(11878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11878),
    [anon_sym_SLASH_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11878),
    [anon_sym_AMP_EQ] = ACTIONS(11878),
    [anon_sym_PERCENT_EQ] = ACTIONS(11878),
    [anon_sym_GT_GT_EQ] = ACTIONS(11878),
    [anon_sym_LT_LT_EQ] = ACTIONS(11878),
    [anon_sym_CARET_EQ] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11880),
    [anon_sym_AMP_AMP] = ACTIONS(11880),
    [anon_sym_LT_LT] = ACTIONS(11880),
    [anon_sym_GT_GT] = ACTIONS(11880),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11880),
    [anon_sym_PLUS] = ACTIONS(11880),
    [anon_sym_SLASH] = ACTIONS(11880),
    [anon_sym_PERCENT] = ACTIONS(11880),
    [sym_comment] = ACTIONS(87),
  },
  [10586] = {
    [anon_sym_end] = ACTIONS(14663),
    [sym_comment] = ACTIONS(87),
  },
  [10587] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6058),
    [sym__binary_star2] = ACTIONS(6060),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6062),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(6064),
    [anon_sym_AMP] = ACTIONS(6066),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(6068),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6070),
    [anon_sym_DOT_DOT] = ACTIONS(6072),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6074),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6076),
    [anon_sym_AMP_AMP] = ACTIONS(6076),
    [anon_sym_LT_LT] = ACTIONS(6078),
    [anon_sym_GT_GT] = ACTIONS(6078),
    [anon_sym_EQ_EQ] = ACTIONS(6076),
    [anon_sym_BANG_EQ] = ACTIONS(6080),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6080),
    [anon_sym_LT_EQ_GT] = ACTIONS(6080),
    [anon_sym_EQ_TILDE] = ACTIONS(6080),
    [anon_sym_BANG_TILDE] = ACTIONS(6080),
    [anon_sym_LT_EQ] = ACTIONS(6068),
    [anon_sym_GT] = ACTIONS(6068),
    [anon_sym_GT_EQ] = ACTIONS(6082),
    [anon_sym_CARET] = ACTIONS(6062),
    [anon_sym_PLUS] = ACTIONS(6084),
    [anon_sym_SLASH] = ACTIONS(6064),
    [anon_sym_PERCENT] = ACTIONS(6064),
    [sym_comment] = ACTIONS(87),
  },
  [10588] = {
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10589] = {
    [aux_sym_exceptions_repeat1] = STATE(10589),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [ts_builtin_sym_end] = ACTIONS(11607),
    [anon_sym___END__] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14665),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10590] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6106),
    [sym__binary_star2] = ACTIONS(6108),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6110),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(6112),
    [anon_sym_AMP] = ACTIONS(6114),
    [anon_sym_LT] = ACTIONS(6116),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6118),
    [anon_sym_DOT_DOT] = ACTIONS(6120),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6122),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6126),
    [anon_sym_AMP_AMP] = ACTIONS(6126),
    [anon_sym_LT_LT] = ACTIONS(6128),
    [anon_sym_GT_GT] = ACTIONS(6128),
    [anon_sym_EQ_EQ] = ACTIONS(6130),
    [anon_sym_BANG_EQ] = ACTIONS(6126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6126),
    [anon_sym_LT_EQ_GT] = ACTIONS(6126),
    [anon_sym_EQ_TILDE] = ACTIONS(6126),
    [anon_sym_BANG_TILDE] = ACTIONS(6126),
    [anon_sym_LT_EQ] = ACTIONS(6116),
    [anon_sym_GT] = ACTIONS(6116),
    [anon_sym_GT_EQ] = ACTIONS(6132),
    [anon_sym_CARET] = ACTIONS(6134),
    [anon_sym_PLUS] = ACTIONS(6136),
    [anon_sym_SLASH] = ACTIONS(6112),
    [anon_sym_PERCENT] = ACTIONS(6112),
    [sym_comment] = ACTIONS(87),
  },
  [10591] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5852),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10592] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_RBRACE] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10593] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10594] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10595] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10596] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10597] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14668),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10598] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5966),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10599] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10600] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10601] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10602] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10603] = {
    [aux_sym_exceptions_repeat1] = STATE(10603),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14670),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10604] = {
    [aux_sym_exceptions_repeat1] = STATE(9157),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_RBRACE] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10605] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(6250),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [10606] = {
    [sym__line_break2] = ACTIONS(12615),
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [ts_builtin_sym_end] = ACTIONS(12615),
    [anon_sym___END__] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12617),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_end] = ACTIONS(12615),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_when] = ACTIONS(12615),
    [anon_sym_elsif] = ACTIONS(12615),
    [anon_sym_else] = ACTIONS(12615),
    [anon_sym_then] = ACTIONS(12615),
    [anon_sym_ensure] = ACTIONS(12615),
    [anon_sym_EQ_GT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_PLUS_EQ] = ACTIONS(12615),
    [anon_sym_DASH_EQ] = ACTIONS(12615),
    [anon_sym_STAR_EQ] = ACTIONS(12615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12615),
    [anon_sym_SLASH_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12615),
    [anon_sym_AMP_EQ] = ACTIONS(12615),
    [anon_sym_PERCENT_EQ] = ACTIONS(12615),
    [anon_sym_GT_GT_EQ] = ACTIONS(12615),
    [anon_sym_LT_LT_EQ] = ACTIONS(12615),
    [anon_sym_CARET_EQ] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12617),
    [anon_sym_AMP_AMP] = ACTIONS(12617),
    [anon_sym_LT_LT] = ACTIONS(12617),
    [anon_sym_GT_GT] = ACTIONS(12617),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12617),
    [anon_sym_PLUS] = ACTIONS(12617),
    [anon_sym_SLASH] = ACTIONS(12617),
    [anon_sym_PERCENT] = ACTIONS(12617),
    [sym_comment] = ACTIONS(87),
  },
  [10607] = {
    [sym__line_break2] = ACTIONS(12916),
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [ts_builtin_sym_end] = ACTIONS(12916),
    [anon_sym___END__] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12918),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_end] = ACTIONS(12916),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_when] = ACTIONS(12916),
    [anon_sym_elsif] = ACTIONS(12916),
    [anon_sym_else] = ACTIONS(12916),
    [anon_sym_then] = ACTIONS(12916),
    [anon_sym_ensure] = ACTIONS(12916),
    [anon_sym_EQ_GT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_PLUS_EQ] = ACTIONS(12916),
    [anon_sym_DASH_EQ] = ACTIONS(12916),
    [anon_sym_STAR_EQ] = ACTIONS(12916),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12916),
    [anon_sym_SLASH_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12916),
    [anon_sym_AMP_EQ] = ACTIONS(12916),
    [anon_sym_PERCENT_EQ] = ACTIONS(12916),
    [anon_sym_GT_GT_EQ] = ACTIONS(12916),
    [anon_sym_LT_LT_EQ] = ACTIONS(12916),
    [anon_sym_CARET_EQ] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12918),
    [anon_sym_AMP_AMP] = ACTIONS(12918),
    [anon_sym_LT_LT] = ACTIONS(12918),
    [anon_sym_GT_GT] = ACTIONS(12918),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12918),
    [anon_sym_PLUS] = ACTIONS(12918),
    [anon_sym_SLASH] = ACTIONS(12918),
    [anon_sym_PERCENT] = ACTIONS(12918),
    [sym_comment] = ACTIONS(87),
  },
  [10608] = {
    [anon_sym_end] = ACTIONS(14673),
    [sym_comment] = ACTIONS(87),
  },
  [10609] = {
    [sym__line_break2] = ACTIONS(13064),
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [ts_builtin_sym_end] = ACTIONS(13064),
    [anon_sym___END__] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13066),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13064),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_when] = ACTIONS(13064),
    [anon_sym_elsif] = ACTIONS(13064),
    [anon_sym_else] = ACTIONS(13064),
    [anon_sym_then] = ACTIONS(13064),
    [anon_sym_ensure] = ACTIONS(13064),
    [anon_sym_EQ_GT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_PLUS_EQ] = ACTIONS(13064),
    [anon_sym_DASH_EQ] = ACTIONS(13064),
    [anon_sym_STAR_EQ] = ACTIONS(13064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13064),
    [anon_sym_SLASH_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13064),
    [anon_sym_AMP_EQ] = ACTIONS(13064),
    [anon_sym_PERCENT_EQ] = ACTIONS(13064),
    [anon_sym_GT_GT_EQ] = ACTIONS(13064),
    [anon_sym_LT_LT_EQ] = ACTIONS(13064),
    [anon_sym_CARET_EQ] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13066),
    [anon_sym_AMP_AMP] = ACTIONS(13066),
    [anon_sym_LT_LT] = ACTIONS(13066),
    [anon_sym_GT_GT] = ACTIONS(13066),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13066),
    [anon_sym_PLUS] = ACTIONS(13066),
    [anon_sym_SLASH] = ACTIONS(13066),
    [anon_sym_PERCENT] = ACTIONS(13066),
    [sym_comment] = ACTIONS(87),
  },
  [10610] = {
    [sym__line_break2] = ACTIONS(13216),
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [ts_builtin_sym_end] = ACTIONS(13216),
    [anon_sym___END__] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13218),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_end] = ACTIONS(13216),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_when] = ACTIONS(13216),
    [anon_sym_elsif] = ACTIONS(13216),
    [anon_sym_else] = ACTIONS(13216),
    [anon_sym_then] = ACTIONS(13216),
    [anon_sym_ensure] = ACTIONS(13216),
    [anon_sym_EQ_GT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_PLUS_EQ] = ACTIONS(13216),
    [anon_sym_DASH_EQ] = ACTIONS(13216),
    [anon_sym_STAR_EQ] = ACTIONS(13216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13216),
    [anon_sym_SLASH_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13216),
    [anon_sym_AMP_EQ] = ACTIONS(13216),
    [anon_sym_PERCENT_EQ] = ACTIONS(13216),
    [anon_sym_GT_GT_EQ] = ACTIONS(13216),
    [anon_sym_LT_LT_EQ] = ACTIONS(13216),
    [anon_sym_CARET_EQ] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13218),
    [anon_sym_AMP_AMP] = ACTIONS(13218),
    [anon_sym_LT_LT] = ACTIONS(13218),
    [anon_sym_GT_GT] = ACTIONS(13218),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13218),
    [anon_sym_PLUS] = ACTIONS(13218),
    [anon_sym_SLASH] = ACTIONS(13218),
    [anon_sym_PERCENT] = ACTIONS(13218),
    [sym_comment] = ACTIONS(87),
  },
  [10611] = {
    [sym__line_break2] = ACTIONS(14626),
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [ts_builtin_sym_end] = ACTIONS(14626),
    [anon_sym___END__] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_end] = ACTIONS(14626),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_when] = ACTIONS(14626),
    [anon_sym_elsif] = ACTIONS(14626),
    [anon_sym_else] = ACTIONS(14626),
    [anon_sym_then] = ACTIONS(14626),
    [anon_sym_ensure] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [10612] = {
    [sym__line_break2] = ACTIONS(13227),
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [ts_builtin_sym_end] = ACTIONS(13227),
    [anon_sym___END__] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13229),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_end] = ACTIONS(13227),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_when] = ACTIONS(13227),
    [anon_sym_elsif] = ACTIONS(13227),
    [anon_sym_else] = ACTIONS(13227),
    [anon_sym_then] = ACTIONS(13227),
    [anon_sym_ensure] = ACTIONS(13227),
    [anon_sym_EQ_GT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_PLUS_EQ] = ACTIONS(13227),
    [anon_sym_DASH_EQ] = ACTIONS(13227),
    [anon_sym_STAR_EQ] = ACTIONS(13227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13227),
    [anon_sym_SLASH_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13227),
    [anon_sym_AMP_EQ] = ACTIONS(13227),
    [anon_sym_PERCENT_EQ] = ACTIONS(13227),
    [anon_sym_GT_GT_EQ] = ACTIONS(13227),
    [anon_sym_LT_LT_EQ] = ACTIONS(13227),
    [anon_sym_CARET_EQ] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13229),
    [anon_sym_AMP_AMP] = ACTIONS(13229),
    [anon_sym_LT_LT] = ACTIONS(13229),
    [anon_sym_GT_GT] = ACTIONS(13229),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13229),
    [anon_sym_PLUS] = ACTIONS(13229),
    [anon_sym_SLASH] = ACTIONS(13229),
    [anon_sym_PERCENT] = ACTIONS(13229),
    [sym_comment] = ACTIONS(87),
  },
  [10613] = {
    [sym__line_break2] = ACTIONS(13551),
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [ts_builtin_sym_end] = ACTIONS(13551),
    [anon_sym___END__] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_end] = ACTIONS(13551),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_when] = ACTIONS(13551),
    [anon_sym_elsif] = ACTIONS(13551),
    [anon_sym_else] = ACTIONS(13551),
    [anon_sym_then] = ACTIONS(13551),
    [anon_sym_ensure] = ACTIONS(13551),
    [anon_sym_EQ_GT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_PLUS_EQ] = ACTIONS(13551),
    [anon_sym_DASH_EQ] = ACTIONS(13551),
    [anon_sym_STAR_EQ] = ACTIONS(13551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13551),
    [anon_sym_SLASH_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13551),
    [anon_sym_AMP_EQ] = ACTIONS(13551),
    [anon_sym_PERCENT_EQ] = ACTIONS(13551),
    [anon_sym_GT_GT_EQ] = ACTIONS(13551),
    [anon_sym_LT_LT_EQ] = ACTIONS(13551),
    [anon_sym_CARET_EQ] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13553),
    [anon_sym_AMP_AMP] = ACTIONS(13553),
    [anon_sym_LT_LT] = ACTIONS(13553),
    [anon_sym_GT_GT] = ACTIONS(13553),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13553),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_SLASH] = ACTIONS(13553),
    [anon_sym_PERCENT] = ACTIONS(13553),
    [sym_comment] = ACTIONS(87),
  },
  [10614] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6206),
    [sym__binary_star2] = ACTIONS(6208),
    [ts_builtin_sym_end] = ACTIONS(12166),
    [anon_sym___END__] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6210),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(6212),
    [anon_sym_AMP] = ACTIONS(6214),
    [anon_sym_LT] = ACTIONS(6216),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6218),
    [anon_sym_DOT_DOT] = ACTIONS(6220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6222),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6224),
    [anon_sym_AMP_AMP] = ACTIONS(6224),
    [anon_sym_LT_LT] = ACTIONS(6226),
    [anon_sym_GT_GT] = ACTIONS(6226),
    [anon_sym_EQ_EQ] = ACTIONS(6228),
    [anon_sym_BANG_EQ] = ACTIONS(6224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6224),
    [anon_sym_LT_EQ_GT] = ACTIONS(6224),
    [anon_sym_EQ_TILDE] = ACTIONS(6224),
    [anon_sym_BANG_TILDE] = ACTIONS(6224),
    [anon_sym_LT_EQ] = ACTIONS(6216),
    [anon_sym_GT] = ACTIONS(6216),
    [anon_sym_GT_EQ] = ACTIONS(6230),
    [anon_sym_CARET] = ACTIONS(6232),
    [anon_sym_PLUS] = ACTIONS(6234),
    [anon_sym_SLASH] = ACTIONS(6212),
    [anon_sym_PERCENT] = ACTIONS(6212),
    [sym_comment] = ACTIONS(87),
  },
  [10615] = {
    [sym_heredoc_body] = STATE(10615),
    [aux_sym_call_repeat1] = STATE(10615),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10616] = {
    [sym_heredoc_body] = STATE(10615),
    [aux_sym_call_repeat1] = STATE(10615),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10617] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11356),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_assignment] = STATE(11356),
    [sym_operator_assignment] = STATE(11356),
    [sym_conditional] = STATE(11356),
    [sym_range] = STATE(11356),
    [sym_binary] = STATE(11356),
    [sym_unary] = STATE(11356),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10618] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9196),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(3982),
    [sym_scope_resolution] = STATE(3980),
    [sym_call] = STATE(3980),
    [sym_method_call] = STATE(3982),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(9196),
    [sym_operator_assignment] = STATE(9196),
    [sym_conditional] = STATE(9196),
    [sym_range] = STATE(9196),
    [sym_binary] = STATE(9196),
    [sym_unary] = STATE(9196),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(3981),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(3982),
    [sym__variable] = STATE(3980),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(3982),
    [sym_false] = STATE(3982),
    [sym_nil] = STATE(3982),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(3983),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(2815),
    [sym__unary_minus2] = ACTIONS(6259),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(6261),
    [anon_sym_yield] = ACTIONS(6263),
    [anon_sym_break] = ACTIONS(6265),
    [anon_sym_next] = ACTIONS(6267),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6269),
    [anon_sym_defined_QMARK] = ACTIONS(6271),
    [anon_sym_not] = ACTIONS(6273),
    [anon_sym_BANG] = ACTIONS(6275),
    [anon_sym_TILDE] = ACTIONS(6275),
    [sym_constant] = ACTIONS(6277),
    [sym_identifier] = ACTIONS(6277),
    [sym_instance_variable] = ACTIONS(6279),
    [sym_class_variable] = ACTIONS(6279),
    [sym_global_variable] = ACTIONS(6279),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(6277),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6277),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10619] = {
    [aux_sym_exceptions_repeat1] = STATE(11357),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14675),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10620] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6295),
    [sym__binary_star2] = ACTIONS(6297),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6299),
    [anon_sym_STAR_STAR] = ACTIONS(6301),
    [anon_sym_AMP] = ACTIONS(6303),
    [anon_sym_LT] = ACTIONS(6305),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6309),
    [anon_sym_DOT_DOT] = ACTIONS(6311),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6313),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6315),
    [anon_sym_AMP_AMP] = ACTIONS(6315),
    [anon_sym_LT_LT] = ACTIONS(6317),
    [anon_sym_GT_GT] = ACTIONS(6317),
    [anon_sym_EQ_EQ] = ACTIONS(6319),
    [anon_sym_BANG_EQ] = ACTIONS(6315),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6315),
    [anon_sym_LT_EQ_GT] = ACTIONS(6315),
    [anon_sym_EQ_TILDE] = ACTIONS(6315),
    [anon_sym_BANG_TILDE] = ACTIONS(6315),
    [anon_sym_LT_EQ] = ACTIONS(6305),
    [anon_sym_GT] = ACTIONS(6305),
    [anon_sym_GT_EQ] = ACTIONS(6321),
    [anon_sym_CARET] = ACTIONS(6323),
    [anon_sym_PLUS] = ACTIONS(6325),
    [anon_sym_SLASH] = ACTIONS(6301),
    [anon_sym_PERCENT] = ACTIONS(6301),
    [sym_comment] = ACTIONS(87),
  },
  [10621] = {
    [aux_sym_exceptions_repeat1] = STATE(10621),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14677),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10622] = {
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_rescue] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [10623] = {
    [sym__heredoc_body_start2] = ACTIONS(6517),
    [sym__binary_minus2] = ACTIONS(6517),
    [sym__binary_star2] = ACTIONS(6517),
    [anon_sym_LBRACE] = ACTIONS(6517),
    [anon_sym_RBRACE] = ACTIONS(6517),
    [anon_sym_RPAREN] = ACTIONS(6517),
    [anon_sym_DOT] = ACTIONS(6519),
    [anon_sym_COMMA] = ACTIONS(6517),
    [anon_sym_PIPE] = ACTIONS(6519),
    [anon_sym_SEMI] = ACTIONS(6517),
    [anon_sym_STAR_STAR] = ACTIONS(6519),
    [anon_sym_AMP] = ACTIONS(6519),
    [anon_sym_EQ] = ACTIONS(6519),
    [anon_sym_LT] = ACTIONS(6519),
    [anon_sym_if] = ACTIONS(6517),
    [anon_sym_unless] = ACTIONS(6517),
    [anon_sym_while] = ACTIONS(6517),
    [anon_sym_until] = ACTIONS(6517),
    [anon_sym_rescue] = ACTIONS(6517),
    [anon_sym_in] = ACTIONS(6517),
    [anon_sym_do] = ACTIONS(6517),
    [anon_sym_LBRACK] = ACTIONS(6517),
    [anon_sym_RBRACK] = ACTIONS(6517),
    [anon_sym_COLON_COLON2] = ACTIONS(6517),
    [anon_sym_AMP_DOT] = ACTIONS(6517),
    [anon_sym_PLUS_EQ] = ACTIONS(6517),
    [anon_sym_DASH_EQ] = ACTIONS(6517),
    [anon_sym_STAR_EQ] = ACTIONS(6517),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6517),
    [anon_sym_SLASH_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_PIPE_EQ] = ACTIONS(6517),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6517),
    [anon_sym_AMP_EQ] = ACTIONS(6517),
    [anon_sym_PERCENT_EQ] = ACTIONS(6517),
    [anon_sym_GT_GT_EQ] = ACTIONS(6517),
    [anon_sym_LT_LT_EQ] = ACTIONS(6517),
    [anon_sym_CARET_EQ] = ACTIONS(6517),
    [anon_sym_QMARK] = ACTIONS(6517),
    [anon_sym_COLON2] = ACTIONS(6519),
    [anon_sym_DOT_DOT] = ACTIONS(6519),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6517),
    [anon_sym_and] = ACTIONS(6517),
    [anon_sym_or] = ACTIONS(6517),
    [anon_sym_PIPE_PIPE] = ACTIONS(6519),
    [anon_sym_AMP_AMP] = ACTIONS(6519),
    [anon_sym_LT_LT] = ACTIONS(6519),
    [anon_sym_GT_GT] = ACTIONS(6519),
    [anon_sym_EQ_EQ] = ACTIONS(6519),
    [anon_sym_BANG_EQ] = ACTIONS(6517),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6517),
    [anon_sym_LT_EQ_GT] = ACTIONS(6517),
    [anon_sym_EQ_TILDE] = ACTIONS(6517),
    [anon_sym_BANG_TILDE] = ACTIONS(6517),
    [anon_sym_LT_EQ] = ACTIONS(6519),
    [anon_sym_GT] = ACTIONS(6519),
    [anon_sym_GT_EQ] = ACTIONS(6517),
    [anon_sym_CARET] = ACTIONS(6519),
    [anon_sym_PLUS] = ACTIONS(6519),
    [anon_sym_SLASH] = ACTIONS(6519),
    [anon_sym_PERCENT] = ACTIONS(6519),
    [sym_comment] = ACTIONS(87),
  },
  [10624] = {
    [sym__heredoc_body_start2] = ACTIONS(6521),
    [sym__binary_minus2] = ACTIONS(6521),
    [sym__binary_star2] = ACTIONS(6521),
    [anon_sym_LBRACE] = ACTIONS(6521),
    [anon_sym_RBRACE] = ACTIONS(6521),
    [anon_sym_RPAREN] = ACTIONS(6521),
    [anon_sym_DOT] = ACTIONS(6523),
    [anon_sym_COMMA] = ACTIONS(6521),
    [anon_sym_PIPE] = ACTIONS(6523),
    [anon_sym_SEMI] = ACTIONS(6521),
    [anon_sym_STAR_STAR] = ACTIONS(6523),
    [anon_sym_AMP] = ACTIONS(6523),
    [anon_sym_EQ] = ACTIONS(6523),
    [anon_sym_LT] = ACTIONS(6523),
    [anon_sym_if] = ACTIONS(6521),
    [anon_sym_unless] = ACTIONS(6521),
    [anon_sym_while] = ACTIONS(6521),
    [anon_sym_until] = ACTIONS(6521),
    [anon_sym_rescue] = ACTIONS(6521),
    [anon_sym_in] = ACTIONS(6521),
    [anon_sym_do] = ACTIONS(6521),
    [anon_sym_LBRACK] = ACTIONS(6521),
    [anon_sym_RBRACK] = ACTIONS(6521),
    [anon_sym_COLON_COLON2] = ACTIONS(6521),
    [anon_sym_AMP_DOT] = ACTIONS(6521),
    [anon_sym_PLUS_EQ] = ACTIONS(6521),
    [anon_sym_DASH_EQ] = ACTIONS(6521),
    [anon_sym_STAR_EQ] = ACTIONS(6521),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6521),
    [anon_sym_SLASH_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_PIPE_EQ] = ACTIONS(6521),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6521),
    [anon_sym_AMP_EQ] = ACTIONS(6521),
    [anon_sym_PERCENT_EQ] = ACTIONS(6521),
    [anon_sym_GT_GT_EQ] = ACTIONS(6521),
    [anon_sym_LT_LT_EQ] = ACTIONS(6521),
    [anon_sym_CARET_EQ] = ACTIONS(6521),
    [anon_sym_QMARK] = ACTIONS(6521),
    [anon_sym_COLON2] = ACTIONS(6523),
    [anon_sym_DOT_DOT] = ACTIONS(6523),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6521),
    [anon_sym_and] = ACTIONS(6521),
    [anon_sym_or] = ACTIONS(6521),
    [anon_sym_PIPE_PIPE] = ACTIONS(6523),
    [anon_sym_AMP_AMP] = ACTIONS(6523),
    [anon_sym_LT_LT] = ACTIONS(6523),
    [anon_sym_GT_GT] = ACTIONS(6523),
    [anon_sym_EQ_EQ] = ACTIONS(6523),
    [anon_sym_BANG_EQ] = ACTIONS(6521),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6521),
    [anon_sym_LT_EQ_GT] = ACTIONS(6521),
    [anon_sym_EQ_TILDE] = ACTIONS(6521),
    [anon_sym_BANG_TILDE] = ACTIONS(6521),
    [anon_sym_LT_EQ] = ACTIONS(6523),
    [anon_sym_GT] = ACTIONS(6523),
    [anon_sym_GT_EQ] = ACTIONS(6521),
    [anon_sym_CARET] = ACTIONS(6523),
    [anon_sym_PLUS] = ACTIONS(6523),
    [anon_sym_SLASH] = ACTIONS(6523),
    [anon_sym_PERCENT] = ACTIONS(6523),
    [sym_comment] = ACTIONS(87),
  },
  [10625] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14680),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10626] = {
    [aux_sym_string_array_repeat1] = STATE(1760),
    [sym__string_end2] = ACTIONS(14680),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14682),
  },
  [10627] = {
    [sym__heredoc_body_start2] = ACTIONS(6529),
    [sym__binary_minus2] = ACTIONS(6529),
    [sym__binary_star2] = ACTIONS(6529),
    [anon_sym_LBRACE] = ACTIONS(6529),
    [anon_sym_RBRACE] = ACTIONS(6529),
    [anon_sym_RPAREN] = ACTIONS(6529),
    [anon_sym_DOT] = ACTIONS(6531),
    [anon_sym_COMMA] = ACTIONS(6529),
    [anon_sym_PIPE] = ACTIONS(6531),
    [anon_sym_SEMI] = ACTIONS(6529),
    [anon_sym_STAR_STAR] = ACTIONS(6531),
    [anon_sym_AMP] = ACTIONS(6531),
    [anon_sym_EQ] = ACTIONS(6531),
    [anon_sym_LT] = ACTIONS(6531),
    [anon_sym_if] = ACTIONS(6529),
    [anon_sym_unless] = ACTIONS(6529),
    [anon_sym_while] = ACTIONS(6529),
    [anon_sym_until] = ACTIONS(6529),
    [anon_sym_rescue] = ACTIONS(6529),
    [anon_sym_in] = ACTIONS(6529),
    [anon_sym_do] = ACTIONS(6529),
    [anon_sym_LBRACK] = ACTIONS(6529),
    [anon_sym_RBRACK] = ACTIONS(6529),
    [anon_sym_COLON_COLON2] = ACTIONS(6529),
    [anon_sym_AMP_DOT] = ACTIONS(6529),
    [anon_sym_PLUS_EQ] = ACTIONS(6529),
    [anon_sym_DASH_EQ] = ACTIONS(6529),
    [anon_sym_STAR_EQ] = ACTIONS(6529),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6529),
    [anon_sym_SLASH_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_PIPE_EQ] = ACTIONS(6529),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6529),
    [anon_sym_AMP_EQ] = ACTIONS(6529),
    [anon_sym_PERCENT_EQ] = ACTIONS(6529),
    [anon_sym_GT_GT_EQ] = ACTIONS(6529),
    [anon_sym_LT_LT_EQ] = ACTIONS(6529),
    [anon_sym_CARET_EQ] = ACTIONS(6529),
    [anon_sym_QMARK] = ACTIONS(6529),
    [anon_sym_COLON2] = ACTIONS(6531),
    [anon_sym_DOT_DOT] = ACTIONS(6531),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6529),
    [anon_sym_and] = ACTIONS(6529),
    [anon_sym_or] = ACTIONS(6529),
    [anon_sym_PIPE_PIPE] = ACTIONS(6531),
    [anon_sym_AMP_AMP] = ACTIONS(6531),
    [anon_sym_LT_LT] = ACTIONS(6531),
    [anon_sym_GT_GT] = ACTIONS(6531),
    [anon_sym_EQ_EQ] = ACTIONS(6531),
    [anon_sym_BANG_EQ] = ACTIONS(6529),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6529),
    [anon_sym_LT_EQ_GT] = ACTIONS(6529),
    [anon_sym_EQ_TILDE] = ACTIONS(6529),
    [anon_sym_BANG_TILDE] = ACTIONS(6529),
    [anon_sym_LT_EQ] = ACTIONS(6531),
    [anon_sym_GT] = ACTIONS(6531),
    [anon_sym_GT_EQ] = ACTIONS(6529),
    [anon_sym_CARET] = ACTIONS(6531),
    [anon_sym_PLUS] = ACTIONS(6531),
    [anon_sym_SLASH] = ACTIONS(6531),
    [anon_sym_PERCENT] = ACTIONS(6531),
    [sym_comment] = ACTIONS(87),
  },
  [10628] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14684),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10629] = {
    [sym__heredoc_body_start2] = ACTIONS(6542),
    [sym__binary_minus2] = ACTIONS(6542),
    [sym__binary_star2] = ACTIONS(6542),
    [anon_sym_LBRACE] = ACTIONS(6542),
    [anon_sym_RBRACE] = ACTIONS(6542),
    [anon_sym_RPAREN] = ACTIONS(6542),
    [anon_sym_DOT] = ACTIONS(6544),
    [anon_sym_COMMA] = ACTIONS(6542),
    [anon_sym_PIPE] = ACTIONS(6544),
    [anon_sym_SEMI] = ACTIONS(6542),
    [anon_sym_STAR_STAR] = ACTIONS(6544),
    [anon_sym_AMP] = ACTIONS(6544),
    [anon_sym_EQ] = ACTIONS(6544),
    [anon_sym_LT] = ACTIONS(6544),
    [anon_sym_if] = ACTIONS(6542),
    [anon_sym_unless] = ACTIONS(6542),
    [anon_sym_while] = ACTIONS(6542),
    [anon_sym_until] = ACTIONS(6542),
    [anon_sym_rescue] = ACTIONS(6542),
    [anon_sym_in] = ACTIONS(6542),
    [anon_sym_do] = ACTIONS(6542),
    [anon_sym_LBRACK] = ACTIONS(6542),
    [anon_sym_RBRACK] = ACTIONS(6542),
    [anon_sym_COLON_COLON2] = ACTIONS(6542),
    [anon_sym_AMP_DOT] = ACTIONS(6542),
    [anon_sym_PLUS_EQ] = ACTIONS(6542),
    [anon_sym_DASH_EQ] = ACTIONS(6542),
    [anon_sym_STAR_EQ] = ACTIONS(6542),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6542),
    [anon_sym_SLASH_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_PIPE_EQ] = ACTIONS(6542),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6542),
    [anon_sym_AMP_EQ] = ACTIONS(6542),
    [anon_sym_PERCENT_EQ] = ACTIONS(6542),
    [anon_sym_GT_GT_EQ] = ACTIONS(6542),
    [anon_sym_LT_LT_EQ] = ACTIONS(6542),
    [anon_sym_CARET_EQ] = ACTIONS(6542),
    [anon_sym_QMARK] = ACTIONS(6542),
    [anon_sym_COLON2] = ACTIONS(6544),
    [anon_sym_DOT_DOT] = ACTIONS(6544),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6542),
    [anon_sym_and] = ACTIONS(6542),
    [anon_sym_or] = ACTIONS(6542),
    [anon_sym_PIPE_PIPE] = ACTIONS(6544),
    [anon_sym_AMP_AMP] = ACTIONS(6544),
    [anon_sym_LT_LT] = ACTIONS(6544),
    [anon_sym_GT_GT] = ACTIONS(6544),
    [anon_sym_EQ_EQ] = ACTIONS(6544),
    [anon_sym_BANG_EQ] = ACTIONS(6542),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6542),
    [anon_sym_LT_EQ_GT] = ACTIONS(6542),
    [anon_sym_EQ_TILDE] = ACTIONS(6542),
    [anon_sym_BANG_TILDE] = ACTIONS(6542),
    [anon_sym_LT_EQ] = ACTIONS(6544),
    [anon_sym_GT] = ACTIONS(6544),
    [anon_sym_GT_EQ] = ACTIONS(6542),
    [anon_sym_CARET] = ACTIONS(6544),
    [anon_sym_PLUS] = ACTIONS(6544),
    [anon_sym_SLASH] = ACTIONS(6544),
    [anon_sym_PERCENT] = ACTIONS(6544),
    [sym_comment] = ACTIONS(87),
  },
  [10630] = {
    [sym__heredoc_body_start2] = ACTIONS(6546),
    [sym__binary_minus2] = ACTIONS(6546),
    [sym__binary_star2] = ACTIONS(6546),
    [anon_sym_LBRACE] = ACTIONS(6546),
    [anon_sym_RBRACE] = ACTIONS(6546),
    [anon_sym_RPAREN] = ACTIONS(6546),
    [anon_sym_DOT] = ACTIONS(6548),
    [anon_sym_COMMA] = ACTIONS(6546),
    [anon_sym_PIPE] = ACTIONS(6548),
    [anon_sym_SEMI] = ACTIONS(6546),
    [anon_sym_STAR_STAR] = ACTIONS(6548),
    [anon_sym_AMP] = ACTIONS(6548),
    [anon_sym_EQ] = ACTIONS(6548),
    [anon_sym_LT] = ACTIONS(6548),
    [anon_sym_if] = ACTIONS(6546),
    [anon_sym_unless] = ACTIONS(6546),
    [anon_sym_while] = ACTIONS(6546),
    [anon_sym_until] = ACTIONS(6546),
    [anon_sym_rescue] = ACTIONS(6546),
    [anon_sym_in] = ACTIONS(6546),
    [anon_sym_do] = ACTIONS(6546),
    [anon_sym_LBRACK] = ACTIONS(6546),
    [anon_sym_RBRACK] = ACTIONS(6546),
    [anon_sym_COLON_COLON2] = ACTIONS(6546),
    [anon_sym_AMP_DOT] = ACTIONS(6546),
    [anon_sym_PLUS_EQ] = ACTIONS(6546),
    [anon_sym_DASH_EQ] = ACTIONS(6546),
    [anon_sym_STAR_EQ] = ACTIONS(6546),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6546),
    [anon_sym_SLASH_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_PIPE_EQ] = ACTIONS(6546),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6546),
    [anon_sym_AMP_EQ] = ACTIONS(6546),
    [anon_sym_PERCENT_EQ] = ACTIONS(6546),
    [anon_sym_GT_GT_EQ] = ACTIONS(6546),
    [anon_sym_LT_LT_EQ] = ACTIONS(6546),
    [anon_sym_CARET_EQ] = ACTIONS(6546),
    [anon_sym_QMARK] = ACTIONS(6546),
    [anon_sym_COLON2] = ACTIONS(6548),
    [anon_sym_DOT_DOT] = ACTIONS(6548),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6546),
    [anon_sym_and] = ACTIONS(6546),
    [anon_sym_or] = ACTIONS(6546),
    [anon_sym_PIPE_PIPE] = ACTIONS(6548),
    [anon_sym_AMP_AMP] = ACTIONS(6548),
    [anon_sym_LT_LT] = ACTIONS(6548),
    [anon_sym_GT_GT] = ACTIONS(6548),
    [anon_sym_EQ_EQ] = ACTIONS(6548),
    [anon_sym_BANG_EQ] = ACTIONS(6546),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6546),
    [anon_sym_LT_EQ_GT] = ACTIONS(6546),
    [anon_sym_EQ_TILDE] = ACTIONS(6546),
    [anon_sym_BANG_TILDE] = ACTIONS(6546),
    [anon_sym_LT_EQ] = ACTIONS(6548),
    [anon_sym_GT] = ACTIONS(6548),
    [anon_sym_GT_EQ] = ACTIONS(6546),
    [anon_sym_CARET] = ACTIONS(6548),
    [anon_sym_PLUS] = ACTIONS(6548),
    [anon_sym_SLASH] = ACTIONS(6548),
    [anon_sym_PERCENT] = ACTIONS(6548),
    [sym_comment] = ACTIONS(87),
  },
  [10631] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14686),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10632] = {
    [aux_sym_symbol_array_repeat1] = STATE(1768),
    [sym__string_end2] = ACTIONS(14686),
    [sym_comment] = ACTIONS(109),
    [aux_sym_SLASH_BSLASHs_PLUS_SLASH] = ACTIONS(14688),
  },
  [10633] = {
    [sym__heredoc_body_start2] = ACTIONS(6554),
    [sym__binary_minus2] = ACTIONS(6554),
    [sym__binary_star2] = ACTIONS(6554),
    [anon_sym_LBRACE] = ACTIONS(6554),
    [anon_sym_RBRACE] = ACTIONS(6554),
    [anon_sym_RPAREN] = ACTIONS(6554),
    [anon_sym_DOT] = ACTIONS(6556),
    [anon_sym_COMMA] = ACTIONS(6554),
    [anon_sym_PIPE] = ACTIONS(6556),
    [anon_sym_SEMI] = ACTIONS(6554),
    [anon_sym_STAR_STAR] = ACTIONS(6556),
    [anon_sym_AMP] = ACTIONS(6556),
    [anon_sym_EQ] = ACTIONS(6556),
    [anon_sym_LT] = ACTIONS(6556),
    [anon_sym_if] = ACTIONS(6554),
    [anon_sym_unless] = ACTIONS(6554),
    [anon_sym_while] = ACTIONS(6554),
    [anon_sym_until] = ACTIONS(6554),
    [anon_sym_rescue] = ACTIONS(6554),
    [anon_sym_in] = ACTIONS(6554),
    [anon_sym_do] = ACTIONS(6554),
    [anon_sym_LBRACK] = ACTIONS(6554),
    [anon_sym_RBRACK] = ACTIONS(6554),
    [anon_sym_COLON_COLON2] = ACTIONS(6554),
    [anon_sym_AMP_DOT] = ACTIONS(6554),
    [anon_sym_PLUS_EQ] = ACTIONS(6554),
    [anon_sym_DASH_EQ] = ACTIONS(6554),
    [anon_sym_STAR_EQ] = ACTIONS(6554),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6554),
    [anon_sym_SLASH_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_PIPE_EQ] = ACTIONS(6554),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6554),
    [anon_sym_AMP_EQ] = ACTIONS(6554),
    [anon_sym_PERCENT_EQ] = ACTIONS(6554),
    [anon_sym_GT_GT_EQ] = ACTIONS(6554),
    [anon_sym_LT_LT_EQ] = ACTIONS(6554),
    [anon_sym_CARET_EQ] = ACTIONS(6554),
    [anon_sym_QMARK] = ACTIONS(6554),
    [anon_sym_COLON2] = ACTIONS(6556),
    [anon_sym_DOT_DOT] = ACTIONS(6556),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6554),
    [anon_sym_and] = ACTIONS(6554),
    [anon_sym_or] = ACTIONS(6554),
    [anon_sym_PIPE_PIPE] = ACTIONS(6556),
    [anon_sym_AMP_AMP] = ACTIONS(6556),
    [anon_sym_LT_LT] = ACTIONS(6556),
    [anon_sym_GT_GT] = ACTIONS(6556),
    [anon_sym_EQ_EQ] = ACTIONS(6556),
    [anon_sym_BANG_EQ] = ACTIONS(6554),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6554),
    [anon_sym_LT_EQ_GT] = ACTIONS(6554),
    [anon_sym_EQ_TILDE] = ACTIONS(6554),
    [anon_sym_BANG_TILDE] = ACTIONS(6554),
    [anon_sym_LT_EQ] = ACTIONS(6556),
    [anon_sym_GT] = ACTIONS(6556),
    [anon_sym_GT_EQ] = ACTIONS(6554),
    [anon_sym_CARET] = ACTIONS(6556),
    [anon_sym_PLUS] = ACTIONS(6556),
    [anon_sym_SLASH] = ACTIONS(6556),
    [anon_sym_PERCENT] = ACTIONS(6556),
    [sym_comment] = ACTIONS(87),
  },
  [10634] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14690),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10635] = {
    [sym__heredoc_body_start2] = ACTIONS(7098),
    [sym__binary_minus2] = ACTIONS(7098),
    [sym__binary_star2] = ACTIONS(7098),
    [anon_sym_LBRACE] = ACTIONS(7098),
    [anon_sym_RBRACE] = ACTIONS(7098),
    [anon_sym_RPAREN] = ACTIONS(7098),
    [anon_sym_DOT] = ACTIONS(7100),
    [anon_sym_COMMA] = ACTIONS(7098),
    [anon_sym_PIPE] = ACTIONS(7100),
    [anon_sym_SEMI] = ACTIONS(7098),
    [anon_sym_STAR_STAR] = ACTIONS(7100),
    [anon_sym_AMP] = ACTIONS(7100),
    [anon_sym_EQ] = ACTIONS(7100),
    [anon_sym_LT] = ACTIONS(7100),
    [anon_sym_if] = ACTIONS(7098),
    [anon_sym_unless] = ACTIONS(7098),
    [anon_sym_while] = ACTIONS(7098),
    [anon_sym_until] = ACTIONS(7098),
    [anon_sym_rescue] = ACTIONS(7098),
    [anon_sym_in] = ACTIONS(7098),
    [anon_sym_do] = ACTIONS(7098),
    [anon_sym_LBRACK] = ACTIONS(7098),
    [anon_sym_RBRACK] = ACTIONS(7098),
    [anon_sym_COLON_COLON2] = ACTIONS(7098),
    [anon_sym_AMP_DOT] = ACTIONS(7098),
    [anon_sym_PLUS_EQ] = ACTIONS(7098),
    [anon_sym_DASH_EQ] = ACTIONS(7098),
    [anon_sym_STAR_EQ] = ACTIONS(7098),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7098),
    [anon_sym_SLASH_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_PIPE_EQ] = ACTIONS(7098),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7098),
    [anon_sym_AMP_EQ] = ACTIONS(7098),
    [anon_sym_PERCENT_EQ] = ACTIONS(7098),
    [anon_sym_GT_GT_EQ] = ACTIONS(7098),
    [anon_sym_LT_LT_EQ] = ACTIONS(7098),
    [anon_sym_CARET_EQ] = ACTIONS(7098),
    [anon_sym_QMARK] = ACTIONS(7098),
    [anon_sym_COLON2] = ACTIONS(7100),
    [anon_sym_DOT_DOT] = ACTIONS(7100),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7098),
    [anon_sym_and] = ACTIONS(7098),
    [anon_sym_or] = ACTIONS(7098),
    [anon_sym_PIPE_PIPE] = ACTIONS(7100),
    [anon_sym_AMP_AMP] = ACTIONS(7100),
    [anon_sym_LT_LT] = ACTIONS(7100),
    [anon_sym_GT_GT] = ACTIONS(7100),
    [anon_sym_EQ_EQ] = ACTIONS(7100),
    [anon_sym_BANG_EQ] = ACTIONS(7098),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7098),
    [anon_sym_LT_EQ_GT] = ACTIONS(7098),
    [anon_sym_EQ_TILDE] = ACTIONS(7098),
    [anon_sym_BANG_TILDE] = ACTIONS(7098),
    [anon_sym_LT_EQ] = ACTIONS(7100),
    [anon_sym_GT] = ACTIONS(7100),
    [anon_sym_GT_EQ] = ACTIONS(7098),
    [anon_sym_CARET] = ACTIONS(7100),
    [anon_sym_PLUS] = ACTIONS(7100),
    [anon_sym_SLASH] = ACTIONS(7100),
    [anon_sym_PERCENT] = ACTIONS(7100),
    [sym_comment] = ACTIONS(87),
  },
  [10636] = {
    [anon_sym_DOT] = ACTIONS(14692),
    [anon_sym_COLON_COLON] = ACTIONS(14692),
    [sym_comment] = ACTIONS(87),
  },
  [10637] = {
    [sym__heredoc_body_start2] = ACTIONS(7258),
    [sym__binary_minus2] = ACTIONS(7258),
    [sym__binary_star2] = ACTIONS(7258),
    [anon_sym_LBRACE] = ACTIONS(7258),
    [anon_sym_RBRACE] = ACTIONS(7258),
    [anon_sym_RPAREN] = ACTIONS(7258),
    [anon_sym_DOT] = ACTIONS(7260),
    [anon_sym_COMMA] = ACTIONS(7258),
    [anon_sym_PIPE] = ACTIONS(7260),
    [anon_sym_SEMI] = ACTIONS(7258),
    [anon_sym_STAR_STAR] = ACTIONS(7260),
    [anon_sym_AMP] = ACTIONS(7260),
    [anon_sym_EQ] = ACTIONS(7260),
    [anon_sym_LT] = ACTIONS(7260),
    [anon_sym_if] = ACTIONS(7258),
    [anon_sym_unless] = ACTIONS(7258),
    [anon_sym_while] = ACTIONS(7258),
    [anon_sym_until] = ACTIONS(7258),
    [anon_sym_rescue] = ACTIONS(7258),
    [anon_sym_in] = ACTIONS(7258),
    [anon_sym_do] = ACTIONS(7258),
    [anon_sym_LBRACK] = ACTIONS(7258),
    [anon_sym_RBRACK] = ACTIONS(7258),
    [anon_sym_COLON_COLON2] = ACTIONS(7258),
    [anon_sym_AMP_DOT] = ACTIONS(7258),
    [anon_sym_PLUS_EQ] = ACTIONS(7258),
    [anon_sym_DASH_EQ] = ACTIONS(7258),
    [anon_sym_STAR_EQ] = ACTIONS(7258),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7258),
    [anon_sym_SLASH_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_PIPE_EQ] = ACTIONS(7258),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7258),
    [anon_sym_AMP_EQ] = ACTIONS(7258),
    [anon_sym_PERCENT_EQ] = ACTIONS(7258),
    [anon_sym_GT_GT_EQ] = ACTIONS(7258),
    [anon_sym_LT_LT_EQ] = ACTIONS(7258),
    [anon_sym_CARET_EQ] = ACTIONS(7258),
    [anon_sym_QMARK] = ACTIONS(7258),
    [anon_sym_COLON2] = ACTIONS(7260),
    [anon_sym_DOT_DOT] = ACTIONS(7260),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7258),
    [anon_sym_and] = ACTIONS(7258),
    [anon_sym_or] = ACTIONS(7258),
    [anon_sym_PIPE_PIPE] = ACTIONS(7260),
    [anon_sym_AMP_AMP] = ACTIONS(7260),
    [anon_sym_LT_LT] = ACTIONS(7260),
    [anon_sym_GT_GT] = ACTIONS(7260),
    [anon_sym_EQ_EQ] = ACTIONS(7260),
    [anon_sym_BANG_EQ] = ACTIONS(7258),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7258),
    [anon_sym_LT_EQ_GT] = ACTIONS(7258),
    [anon_sym_EQ_TILDE] = ACTIONS(7258),
    [anon_sym_BANG_TILDE] = ACTIONS(7258),
    [anon_sym_LT_EQ] = ACTIONS(7260),
    [anon_sym_GT] = ACTIONS(7260),
    [anon_sym_GT_EQ] = ACTIONS(7258),
    [anon_sym_CARET] = ACTIONS(7260),
    [anon_sym_PLUS] = ACTIONS(7260),
    [anon_sym_SLASH] = ACTIONS(7260),
    [anon_sym_PERCENT] = ACTIONS(7260),
    [sym_comment] = ACTIONS(87),
  },
  [10638] = {
    [sym__heredoc_body_start2] = ACTIONS(7274),
    [sym__binary_minus2] = ACTIONS(7274),
    [sym__binary_star2] = ACTIONS(7274),
    [anon_sym_LBRACE] = ACTIONS(7274),
    [anon_sym_RBRACE] = ACTIONS(7274),
    [anon_sym_RPAREN] = ACTIONS(7274),
    [anon_sym_DOT] = ACTIONS(7276),
    [anon_sym_COMMA] = ACTIONS(7274),
    [anon_sym_PIPE] = ACTIONS(7276),
    [anon_sym_SEMI] = ACTIONS(7274),
    [anon_sym_STAR_STAR] = ACTIONS(7276),
    [anon_sym_AMP] = ACTIONS(7276),
    [anon_sym_EQ] = ACTIONS(7276),
    [anon_sym_LT] = ACTIONS(7276),
    [anon_sym_if] = ACTIONS(7274),
    [anon_sym_unless] = ACTIONS(7274),
    [anon_sym_while] = ACTIONS(7274),
    [anon_sym_until] = ACTIONS(7274),
    [anon_sym_rescue] = ACTIONS(7274),
    [anon_sym_in] = ACTIONS(7274),
    [anon_sym_do] = ACTIONS(7274),
    [anon_sym_LBRACK] = ACTIONS(7274),
    [anon_sym_RBRACK] = ACTIONS(7274),
    [anon_sym_COLON_COLON2] = ACTIONS(7274),
    [anon_sym_AMP_DOT] = ACTIONS(7274),
    [anon_sym_PLUS_EQ] = ACTIONS(7274),
    [anon_sym_DASH_EQ] = ACTIONS(7274),
    [anon_sym_STAR_EQ] = ACTIONS(7274),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7274),
    [anon_sym_SLASH_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_PIPE_EQ] = ACTIONS(7274),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7274),
    [anon_sym_AMP_EQ] = ACTIONS(7274),
    [anon_sym_PERCENT_EQ] = ACTIONS(7274),
    [anon_sym_GT_GT_EQ] = ACTIONS(7274),
    [anon_sym_LT_LT_EQ] = ACTIONS(7274),
    [anon_sym_CARET_EQ] = ACTIONS(7274),
    [anon_sym_QMARK] = ACTIONS(7274),
    [anon_sym_COLON2] = ACTIONS(7276),
    [anon_sym_DOT_DOT] = ACTIONS(7276),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7274),
    [anon_sym_and] = ACTIONS(7274),
    [anon_sym_or] = ACTIONS(7274),
    [anon_sym_PIPE_PIPE] = ACTIONS(7276),
    [anon_sym_AMP_AMP] = ACTIONS(7276),
    [anon_sym_LT_LT] = ACTIONS(7276),
    [anon_sym_GT_GT] = ACTIONS(7276),
    [anon_sym_EQ_EQ] = ACTIONS(7276),
    [anon_sym_BANG_EQ] = ACTIONS(7274),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7274),
    [anon_sym_LT_EQ_GT] = ACTIONS(7274),
    [anon_sym_EQ_TILDE] = ACTIONS(7274),
    [anon_sym_BANG_TILDE] = ACTIONS(7274),
    [anon_sym_LT_EQ] = ACTIONS(7276),
    [anon_sym_GT] = ACTIONS(7276),
    [anon_sym_GT_EQ] = ACTIONS(7274),
    [anon_sym_CARET] = ACTIONS(7276),
    [anon_sym_PLUS] = ACTIONS(7276),
    [anon_sym_SLASH] = ACTIONS(7276),
    [anon_sym_PERCENT] = ACTIONS(7276),
    [sym_comment] = ACTIONS(87),
  },
  [10639] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(11365),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14694),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10640] = {
    [sym__statements] = STATE(6908),
    [sym__top_level_statement] = STATE(296),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(297),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_else] = STATE(6909),
    [sym_begin] = STATE(50),
    [sym_ensure] = STATE(6910),
    [sym_rescue] = STATE(6911),
    [sym__body_statement] = STATE(11366),
    [sym__arg] = STATE(302),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(305),
    [sym_scope_resolution] = STATE(303),
    [sym_call] = STATE(303),
    [sym_method_call] = STATE(305),
    [sym_assignment] = STATE(302),
    [sym_operator_assignment] = STATE(302),
    [sym_conditional] = STATE(302),
    [sym_range] = STATE(302),
    [sym_binary] = STATE(302),
    [sym_unary] = STATE(302),
    [sym_left_assignment_list] = STATE(304),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(305),
    [sym__variable] = STATE(303),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(305),
    [sym_false] = STATE(305),
    [sym_nil] = STATE(305),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(306),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(509),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14696),
    [anon_sym_return] = ACTIONS(515),
    [anon_sym_yield] = ACTIONS(517),
    [anon_sym_break] = ACTIONS(519),
    [anon_sym_next] = ACTIONS(521),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_rescue] = ACTIONS(523),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_else] = ACTIONS(525),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_ensure] = ACTIONS(527),
    [anon_sym_PLUS] = ACTIONS(529),
    [anon_sym_defined_QMARK] = ACTIONS(531),
    [anon_sym_not] = ACTIONS(533),
    [anon_sym_BANG] = ACTIONS(535),
    [anon_sym_TILDE] = ACTIONS(535),
    [sym_constant] = ACTIONS(537),
    [sym_identifier] = ACTIONS(537),
    [sym_instance_variable] = ACTIONS(539),
    [sym_class_variable] = ACTIONS(539),
    [sym_global_variable] = ACTIONS(539),
    [anon_sym_undef] = ACTIONS(541),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(537),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(537),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10641] = {
    [sym__heredoc_body_start2] = ACTIONS(7730),
    [sym__binary_minus2] = ACTIONS(7730),
    [sym__binary_star2] = ACTIONS(7730),
    [anon_sym_LBRACE] = ACTIONS(7730),
    [anon_sym_RBRACE] = ACTIONS(7730),
    [anon_sym_RPAREN] = ACTIONS(7730),
    [anon_sym_DOT] = ACTIONS(7732),
    [anon_sym_COMMA] = ACTIONS(7730),
    [anon_sym_PIPE] = ACTIONS(7732),
    [anon_sym_SEMI] = ACTIONS(7730),
    [anon_sym_STAR_STAR] = ACTIONS(7732),
    [anon_sym_AMP] = ACTIONS(7732),
    [anon_sym_EQ] = ACTIONS(7732),
    [anon_sym_LT] = ACTIONS(7732),
    [anon_sym_if] = ACTIONS(7730),
    [anon_sym_unless] = ACTIONS(7730),
    [anon_sym_while] = ACTIONS(7730),
    [anon_sym_until] = ACTIONS(7730),
    [anon_sym_rescue] = ACTIONS(7730),
    [anon_sym_in] = ACTIONS(7730),
    [anon_sym_do] = ACTIONS(7730),
    [anon_sym_LBRACK] = ACTIONS(7730),
    [anon_sym_RBRACK] = ACTIONS(7730),
    [anon_sym_COLON_COLON2] = ACTIONS(7730),
    [anon_sym_AMP_DOT] = ACTIONS(7730),
    [anon_sym_PLUS_EQ] = ACTIONS(7730),
    [anon_sym_DASH_EQ] = ACTIONS(7730),
    [anon_sym_STAR_EQ] = ACTIONS(7730),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7730),
    [anon_sym_SLASH_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_PIPE_EQ] = ACTIONS(7730),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7730),
    [anon_sym_AMP_EQ] = ACTIONS(7730),
    [anon_sym_PERCENT_EQ] = ACTIONS(7730),
    [anon_sym_GT_GT_EQ] = ACTIONS(7730),
    [anon_sym_LT_LT_EQ] = ACTIONS(7730),
    [anon_sym_CARET_EQ] = ACTIONS(7730),
    [anon_sym_QMARK] = ACTIONS(7730),
    [anon_sym_COLON2] = ACTIONS(7732),
    [anon_sym_DOT_DOT] = ACTIONS(7732),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7730),
    [anon_sym_and] = ACTIONS(7730),
    [anon_sym_or] = ACTIONS(7730),
    [anon_sym_PIPE_PIPE] = ACTIONS(7732),
    [anon_sym_AMP_AMP] = ACTIONS(7732),
    [anon_sym_LT_LT] = ACTIONS(7732),
    [anon_sym_GT_GT] = ACTIONS(7732),
    [anon_sym_EQ_EQ] = ACTIONS(7732),
    [anon_sym_BANG_EQ] = ACTIONS(7730),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7730),
    [anon_sym_LT_EQ_GT] = ACTIONS(7730),
    [anon_sym_EQ_TILDE] = ACTIONS(7730),
    [anon_sym_BANG_TILDE] = ACTIONS(7730),
    [anon_sym_LT_EQ] = ACTIONS(7732),
    [anon_sym_GT] = ACTIONS(7732),
    [anon_sym_GT_EQ] = ACTIONS(7730),
    [anon_sym_CARET] = ACTIONS(7732),
    [anon_sym_PLUS] = ACTIONS(7732),
    [anon_sym_SLASH] = ACTIONS(7732),
    [anon_sym_PERCENT] = ACTIONS(7732),
    [sym_comment] = ACTIONS(87),
  },
  [10642] = {
    [sym__heredoc_body_start2] = ACTIONS(7788),
    [sym__binary_minus2] = ACTIONS(7788),
    [sym__binary_star2] = ACTIONS(7788),
    [anon_sym_LBRACE] = ACTIONS(7788),
    [anon_sym_RBRACE] = ACTIONS(7788),
    [anon_sym_RPAREN] = ACTIONS(7788),
    [anon_sym_DOT] = ACTIONS(7790),
    [anon_sym_COMMA] = ACTIONS(7788),
    [anon_sym_PIPE] = ACTIONS(7790),
    [anon_sym_SEMI] = ACTIONS(7788),
    [anon_sym_STAR_STAR] = ACTIONS(7790),
    [anon_sym_AMP] = ACTIONS(7790),
    [anon_sym_EQ] = ACTIONS(7790),
    [anon_sym_LT] = ACTIONS(7790),
    [anon_sym_if] = ACTIONS(7788),
    [anon_sym_unless] = ACTIONS(7788),
    [anon_sym_while] = ACTIONS(7788),
    [anon_sym_until] = ACTIONS(7788),
    [anon_sym_rescue] = ACTIONS(7788),
    [anon_sym_in] = ACTIONS(7788),
    [anon_sym_do] = ACTIONS(7788),
    [anon_sym_LBRACK] = ACTIONS(7788),
    [anon_sym_RBRACK] = ACTIONS(7788),
    [anon_sym_COLON_COLON2] = ACTIONS(7788),
    [anon_sym_AMP_DOT] = ACTIONS(7788),
    [anon_sym_PLUS_EQ] = ACTIONS(7788),
    [anon_sym_DASH_EQ] = ACTIONS(7788),
    [anon_sym_STAR_EQ] = ACTIONS(7788),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7788),
    [anon_sym_SLASH_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_PIPE_EQ] = ACTIONS(7788),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7788),
    [anon_sym_AMP_EQ] = ACTIONS(7788),
    [anon_sym_PERCENT_EQ] = ACTIONS(7788),
    [anon_sym_GT_GT_EQ] = ACTIONS(7788),
    [anon_sym_LT_LT_EQ] = ACTIONS(7788),
    [anon_sym_CARET_EQ] = ACTIONS(7788),
    [anon_sym_QMARK] = ACTIONS(7788),
    [anon_sym_COLON2] = ACTIONS(7790),
    [anon_sym_DOT_DOT] = ACTIONS(7790),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7788),
    [anon_sym_and] = ACTIONS(7788),
    [anon_sym_or] = ACTIONS(7788),
    [anon_sym_PIPE_PIPE] = ACTIONS(7790),
    [anon_sym_AMP_AMP] = ACTIONS(7790),
    [anon_sym_LT_LT] = ACTIONS(7790),
    [anon_sym_GT_GT] = ACTIONS(7790),
    [anon_sym_EQ_EQ] = ACTIONS(7790),
    [anon_sym_BANG_EQ] = ACTIONS(7788),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7788),
    [anon_sym_LT_EQ_GT] = ACTIONS(7788),
    [anon_sym_EQ_TILDE] = ACTIONS(7788),
    [anon_sym_BANG_TILDE] = ACTIONS(7788),
    [anon_sym_LT_EQ] = ACTIONS(7790),
    [anon_sym_GT] = ACTIONS(7790),
    [anon_sym_GT_EQ] = ACTIONS(7788),
    [anon_sym_CARET] = ACTIONS(7790),
    [anon_sym_PLUS] = ACTIONS(7790),
    [anon_sym_SLASH] = ACTIONS(7790),
    [anon_sym_PERCENT] = ACTIONS(7790),
    [sym_comment] = ACTIONS(87),
  },
  [10643] = {
    [sym__heredoc_body_start2] = ACTIONS(7970),
    [sym__binary_minus2] = ACTIONS(7970),
    [sym__binary_star2] = ACTIONS(7970),
    [anon_sym_LBRACE] = ACTIONS(7970),
    [anon_sym_RBRACE] = ACTIONS(7970),
    [anon_sym_RPAREN] = ACTIONS(7970),
    [anon_sym_DOT] = ACTIONS(7972),
    [anon_sym_COMMA] = ACTIONS(7970),
    [anon_sym_PIPE] = ACTIONS(7972),
    [anon_sym_SEMI] = ACTIONS(7970),
    [anon_sym_STAR_STAR] = ACTIONS(7972),
    [anon_sym_AMP] = ACTIONS(7972),
    [anon_sym_EQ] = ACTIONS(7972),
    [anon_sym_LT] = ACTIONS(7972),
    [anon_sym_if] = ACTIONS(7970),
    [anon_sym_unless] = ACTIONS(7970),
    [anon_sym_while] = ACTIONS(7970),
    [anon_sym_until] = ACTIONS(7970),
    [anon_sym_rescue] = ACTIONS(7970),
    [anon_sym_in] = ACTIONS(7970),
    [anon_sym_do] = ACTIONS(7970),
    [anon_sym_LBRACK] = ACTIONS(7970),
    [anon_sym_RBRACK] = ACTIONS(7970),
    [anon_sym_COLON_COLON2] = ACTIONS(7970),
    [anon_sym_AMP_DOT] = ACTIONS(7970),
    [anon_sym_PLUS_EQ] = ACTIONS(7970),
    [anon_sym_DASH_EQ] = ACTIONS(7970),
    [anon_sym_STAR_EQ] = ACTIONS(7970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7970),
    [anon_sym_SLASH_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_PIPE_EQ] = ACTIONS(7970),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7970),
    [anon_sym_AMP_EQ] = ACTIONS(7970),
    [anon_sym_PERCENT_EQ] = ACTIONS(7970),
    [anon_sym_GT_GT_EQ] = ACTIONS(7970),
    [anon_sym_LT_LT_EQ] = ACTIONS(7970),
    [anon_sym_CARET_EQ] = ACTIONS(7970),
    [anon_sym_QMARK] = ACTIONS(7970),
    [anon_sym_COLON2] = ACTIONS(7972),
    [anon_sym_DOT_DOT] = ACTIONS(7972),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7970),
    [anon_sym_and] = ACTIONS(7970),
    [anon_sym_or] = ACTIONS(7970),
    [anon_sym_PIPE_PIPE] = ACTIONS(7972),
    [anon_sym_AMP_AMP] = ACTIONS(7972),
    [anon_sym_LT_LT] = ACTIONS(7972),
    [anon_sym_GT_GT] = ACTIONS(7972),
    [anon_sym_EQ_EQ] = ACTIONS(7972),
    [anon_sym_BANG_EQ] = ACTIONS(7970),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7970),
    [anon_sym_LT_EQ_GT] = ACTIONS(7970),
    [anon_sym_EQ_TILDE] = ACTIONS(7970),
    [anon_sym_BANG_TILDE] = ACTIONS(7970),
    [anon_sym_LT_EQ] = ACTIONS(7972),
    [anon_sym_GT] = ACTIONS(7972),
    [anon_sym_GT_EQ] = ACTIONS(7970),
    [anon_sym_CARET] = ACTIONS(7972),
    [anon_sym_PLUS] = ACTIONS(7972),
    [anon_sym_SLASH] = ACTIONS(7972),
    [anon_sym_PERCENT] = ACTIONS(7972),
    [sym_comment] = ACTIONS(87),
  },
  [10644] = {
    [sym_elsif] = STATE(11368),
    [sym_else] = STATE(11368),
    [sym__if_tail] = STATE(11368),
    [anon_sym_end] = ACTIONS(14698),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [10645] = {
    [anon_sym_end] = ACTIONS(14698),
    [sym_comment] = ACTIONS(87),
  },
  [10646] = {
    [sym__statements] = STATE(11369),
    [sym__top_level_statement] = STATE(2768),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(2769),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_elsif] = STATE(11368),
    [sym_else] = STATE(11368),
    [sym__if_tail] = STATE(11368),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(2771),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(2774),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(2774),
    [sym_assignment] = STATE(2771),
    [sym_operator_assignment] = STATE(2771),
    [sym_conditional] = STATE(2771),
    [sym_range] = STATE(2771),
    [sym_binary] = STATE(2771),
    [sym_unary] = STATE(2771),
    [sym_left_assignment_list] = STATE(2773),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2774),
    [sym__variable] = STATE(2772),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(2774),
    [sym_false] = STATE(2774),
    [sym_nil] = STATE(2774),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(2775),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(4442),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14700),
    [anon_sym_return] = ACTIONS(4446),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_break] = ACTIONS(4450),
    [anon_sym_next] = ACTIONS(4452),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_elsif] = ACTIONS(4454),
    [anon_sym_else] = ACTIONS(4456),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(4458),
    [anon_sym_defined_QMARK] = ACTIONS(4460),
    [anon_sym_not] = ACTIONS(4462),
    [anon_sym_BANG] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4464),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [anon_sym_undef] = ACTIONS(4470),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10647] = {
    [sym__heredoc_body_start2] = ACTIONS(8176),
    [sym__binary_minus2] = ACTIONS(8176),
    [sym__binary_star2] = ACTIONS(8176),
    [anon_sym_LBRACE] = ACTIONS(8176),
    [anon_sym_RBRACE] = ACTIONS(8176),
    [anon_sym_RPAREN] = ACTIONS(8176),
    [anon_sym_DOT] = ACTIONS(8178),
    [anon_sym_COMMA] = ACTIONS(8176),
    [anon_sym_PIPE] = ACTIONS(8178),
    [anon_sym_SEMI] = ACTIONS(8176),
    [anon_sym_STAR_STAR] = ACTIONS(8178),
    [anon_sym_AMP] = ACTIONS(8178),
    [anon_sym_EQ] = ACTIONS(8178),
    [anon_sym_LT] = ACTIONS(8178),
    [anon_sym_if] = ACTIONS(8176),
    [anon_sym_unless] = ACTIONS(8176),
    [anon_sym_while] = ACTIONS(8176),
    [anon_sym_until] = ACTIONS(8176),
    [anon_sym_rescue] = ACTIONS(8176),
    [anon_sym_in] = ACTIONS(8176),
    [anon_sym_do] = ACTIONS(8176),
    [anon_sym_LBRACK] = ACTIONS(8176),
    [anon_sym_RBRACK] = ACTIONS(8176),
    [anon_sym_COLON_COLON2] = ACTIONS(8176),
    [anon_sym_AMP_DOT] = ACTIONS(8176),
    [anon_sym_PLUS_EQ] = ACTIONS(8176),
    [anon_sym_DASH_EQ] = ACTIONS(8176),
    [anon_sym_STAR_EQ] = ACTIONS(8176),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8176),
    [anon_sym_SLASH_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_PIPE_EQ] = ACTIONS(8176),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8176),
    [anon_sym_AMP_EQ] = ACTIONS(8176),
    [anon_sym_PERCENT_EQ] = ACTIONS(8176),
    [anon_sym_GT_GT_EQ] = ACTIONS(8176),
    [anon_sym_LT_LT_EQ] = ACTIONS(8176),
    [anon_sym_CARET_EQ] = ACTIONS(8176),
    [anon_sym_QMARK] = ACTIONS(8176),
    [anon_sym_COLON2] = ACTIONS(8178),
    [anon_sym_DOT_DOT] = ACTIONS(8178),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8176),
    [anon_sym_and] = ACTIONS(8176),
    [anon_sym_or] = ACTIONS(8176),
    [anon_sym_PIPE_PIPE] = ACTIONS(8178),
    [anon_sym_AMP_AMP] = ACTIONS(8178),
    [anon_sym_LT_LT] = ACTIONS(8178),
    [anon_sym_GT_GT] = ACTIONS(8178),
    [anon_sym_EQ_EQ] = ACTIONS(8178),
    [anon_sym_BANG_EQ] = ACTIONS(8176),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8176),
    [anon_sym_LT_EQ_GT] = ACTIONS(8176),
    [anon_sym_EQ_TILDE] = ACTIONS(8176),
    [anon_sym_BANG_TILDE] = ACTIONS(8176),
    [anon_sym_LT_EQ] = ACTIONS(8178),
    [anon_sym_GT] = ACTIONS(8178),
    [anon_sym_GT_EQ] = ACTIONS(8176),
    [anon_sym_CARET] = ACTIONS(8178),
    [anon_sym_PLUS] = ACTIONS(8178),
    [anon_sym_SLASH] = ACTIONS(8178),
    [anon_sym_PERCENT] = ACTIONS(8178),
    [sym_comment] = ACTIONS(87),
  },
  [10648] = {
    [sym_else] = STATE(11371),
    [anon_sym_end] = ACTIONS(14702),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [10649] = {
    [anon_sym_end] = ACTIONS(14702),
    [sym_comment] = ACTIONS(87),
  },
  [10650] = {
    [sym__heredoc_body_start2] = ACTIONS(8352),
    [sym__binary_minus2] = ACTIONS(8352),
    [sym__binary_star2] = ACTIONS(8352),
    [anon_sym_LBRACE] = ACTIONS(8352),
    [anon_sym_RBRACE] = ACTIONS(8352),
    [anon_sym_RPAREN] = ACTIONS(8352),
    [anon_sym_DOT] = ACTIONS(8354),
    [anon_sym_COMMA] = ACTIONS(8352),
    [anon_sym_PIPE] = ACTIONS(8354),
    [anon_sym_SEMI] = ACTIONS(8352),
    [anon_sym_STAR_STAR] = ACTIONS(8354),
    [anon_sym_AMP] = ACTIONS(8354),
    [anon_sym_EQ] = ACTIONS(8354),
    [anon_sym_LT] = ACTIONS(8354),
    [anon_sym_if] = ACTIONS(8352),
    [anon_sym_unless] = ACTIONS(8352),
    [anon_sym_while] = ACTIONS(8352),
    [anon_sym_until] = ACTIONS(8352),
    [anon_sym_rescue] = ACTIONS(8352),
    [anon_sym_in] = ACTIONS(8352),
    [anon_sym_do] = ACTIONS(8352),
    [anon_sym_LBRACK] = ACTIONS(8352),
    [anon_sym_RBRACK] = ACTIONS(8352),
    [anon_sym_COLON_COLON2] = ACTIONS(8352),
    [anon_sym_AMP_DOT] = ACTIONS(8352),
    [anon_sym_PLUS_EQ] = ACTIONS(8352),
    [anon_sym_DASH_EQ] = ACTIONS(8352),
    [anon_sym_STAR_EQ] = ACTIONS(8352),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8352),
    [anon_sym_SLASH_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_PIPE_EQ] = ACTIONS(8352),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8352),
    [anon_sym_AMP_EQ] = ACTIONS(8352),
    [anon_sym_PERCENT_EQ] = ACTIONS(8352),
    [anon_sym_GT_GT_EQ] = ACTIONS(8352),
    [anon_sym_LT_LT_EQ] = ACTIONS(8352),
    [anon_sym_CARET_EQ] = ACTIONS(8352),
    [anon_sym_QMARK] = ACTIONS(8352),
    [anon_sym_COLON2] = ACTIONS(8354),
    [anon_sym_DOT_DOT] = ACTIONS(8354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8352),
    [anon_sym_and] = ACTIONS(8352),
    [anon_sym_or] = ACTIONS(8352),
    [anon_sym_PIPE_PIPE] = ACTIONS(8354),
    [anon_sym_AMP_AMP] = ACTIONS(8354),
    [anon_sym_LT_LT] = ACTIONS(8354),
    [anon_sym_GT_GT] = ACTIONS(8354),
    [anon_sym_EQ_EQ] = ACTIONS(8354),
    [anon_sym_BANG_EQ] = ACTIONS(8352),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8352),
    [anon_sym_LT_EQ_GT] = ACTIONS(8352),
    [anon_sym_EQ_TILDE] = ACTIONS(8352),
    [anon_sym_BANG_TILDE] = ACTIONS(8352),
    [anon_sym_LT_EQ] = ACTIONS(8354),
    [anon_sym_GT] = ACTIONS(8354),
    [anon_sym_GT_EQ] = ACTIONS(8352),
    [anon_sym_CARET] = ACTIONS(8354),
    [anon_sym_PLUS] = ACTIONS(8354),
    [anon_sym_SLASH] = ACTIONS(8354),
    [anon_sym_PERCENT] = ACTIONS(8354),
    [sym_comment] = ACTIONS(87),
  },
  [10651] = {
    [anon_sym_end] = ACTIONS(14704),
    [sym_comment] = ACTIONS(87),
  },
  [10652] = {
    [sym__heredoc_body_start2] = ACTIONS(8432),
    [sym__binary_minus2] = ACTIONS(8432),
    [sym__binary_star2] = ACTIONS(8432),
    [anon_sym_LBRACE] = ACTIONS(8432),
    [anon_sym_RBRACE] = ACTIONS(8432),
    [anon_sym_RPAREN] = ACTIONS(8432),
    [anon_sym_DOT] = ACTIONS(8434),
    [anon_sym_COMMA] = ACTIONS(8432),
    [anon_sym_PIPE] = ACTIONS(8434),
    [anon_sym_SEMI] = ACTIONS(8432),
    [anon_sym_STAR_STAR] = ACTIONS(8434),
    [anon_sym_AMP] = ACTIONS(8434),
    [anon_sym_EQ] = ACTIONS(8434),
    [anon_sym_LT] = ACTIONS(8434),
    [anon_sym_if] = ACTIONS(8432),
    [anon_sym_unless] = ACTIONS(8432),
    [anon_sym_while] = ACTIONS(8432),
    [anon_sym_until] = ACTIONS(8432),
    [anon_sym_rescue] = ACTIONS(8432),
    [anon_sym_in] = ACTIONS(8432),
    [anon_sym_do] = ACTIONS(8432),
    [anon_sym_LBRACK] = ACTIONS(8432),
    [anon_sym_RBRACK] = ACTIONS(8432),
    [anon_sym_COLON_COLON2] = ACTIONS(8432),
    [anon_sym_AMP_DOT] = ACTIONS(8432),
    [anon_sym_PLUS_EQ] = ACTIONS(8432),
    [anon_sym_DASH_EQ] = ACTIONS(8432),
    [anon_sym_STAR_EQ] = ACTIONS(8432),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8432),
    [anon_sym_SLASH_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_PIPE_EQ] = ACTIONS(8432),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8432),
    [anon_sym_AMP_EQ] = ACTIONS(8432),
    [anon_sym_PERCENT_EQ] = ACTIONS(8432),
    [anon_sym_GT_GT_EQ] = ACTIONS(8432),
    [anon_sym_LT_LT_EQ] = ACTIONS(8432),
    [anon_sym_CARET_EQ] = ACTIONS(8432),
    [anon_sym_QMARK] = ACTIONS(8432),
    [anon_sym_COLON2] = ACTIONS(8434),
    [anon_sym_DOT_DOT] = ACTIONS(8434),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8432),
    [anon_sym_and] = ACTIONS(8432),
    [anon_sym_or] = ACTIONS(8432),
    [anon_sym_PIPE_PIPE] = ACTIONS(8434),
    [anon_sym_AMP_AMP] = ACTIONS(8434),
    [anon_sym_LT_LT] = ACTIONS(8434),
    [anon_sym_GT_GT] = ACTIONS(8434),
    [anon_sym_EQ_EQ] = ACTIONS(8434),
    [anon_sym_BANG_EQ] = ACTIONS(8432),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8432),
    [anon_sym_LT_EQ_GT] = ACTIONS(8432),
    [anon_sym_EQ_TILDE] = ACTIONS(8432),
    [anon_sym_BANG_TILDE] = ACTIONS(8432),
    [anon_sym_LT_EQ] = ACTIONS(8434),
    [anon_sym_GT] = ACTIONS(8434),
    [anon_sym_GT_EQ] = ACTIONS(8432),
    [anon_sym_CARET] = ACTIONS(8434),
    [anon_sym_PLUS] = ACTIONS(8434),
    [anon_sym_SLASH] = ACTIONS(8434),
    [anon_sym_PERCENT] = ACTIONS(8434),
    [sym_comment] = ACTIONS(87),
  },
  [10653] = {
    [anon_sym_end] = ACTIONS(14706),
    [sym_comment] = ACTIONS(87),
  },
  [10654] = {
    [sym__statements] = STATE(11375),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14708),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10655] = {
    [anon_sym_end] = ACTIONS(14710),
    [sym_comment] = ACTIONS(87),
  },
  [10656] = {
    [sym_when] = STATE(11377),
    [aux_sym_case_repeat1] = STATE(3142),
    [anon_sym_SEMI] = ACTIONS(4980),
    [anon_sym_when] = ACTIONS(2073),
    [sym_comment] = ACTIONS(87),
  },
  [10657] = {
    [sym__heredoc_body_start2] = ACTIONS(8696),
    [sym__binary_minus2] = ACTIONS(8696),
    [sym__binary_star2] = ACTIONS(8696),
    [anon_sym_LBRACE] = ACTIONS(8696),
    [anon_sym_RBRACE] = ACTIONS(8696),
    [anon_sym_RPAREN] = ACTIONS(8696),
    [anon_sym_DOT] = ACTIONS(8698),
    [anon_sym_COMMA] = ACTIONS(8696),
    [anon_sym_PIPE] = ACTIONS(8698),
    [anon_sym_SEMI] = ACTIONS(8696),
    [anon_sym_STAR_STAR] = ACTIONS(8698),
    [anon_sym_AMP] = ACTIONS(8698),
    [anon_sym_EQ] = ACTIONS(8698),
    [anon_sym_LT] = ACTIONS(8698),
    [anon_sym_if] = ACTIONS(8696),
    [anon_sym_unless] = ACTIONS(8696),
    [anon_sym_while] = ACTIONS(8696),
    [anon_sym_until] = ACTIONS(8696),
    [anon_sym_rescue] = ACTIONS(8696),
    [anon_sym_in] = ACTIONS(8696),
    [anon_sym_do] = ACTIONS(8696),
    [anon_sym_LBRACK] = ACTIONS(8696),
    [anon_sym_RBRACK] = ACTIONS(8696),
    [anon_sym_COLON_COLON2] = ACTIONS(8696),
    [anon_sym_AMP_DOT] = ACTIONS(8696),
    [anon_sym_PLUS_EQ] = ACTIONS(8696),
    [anon_sym_DASH_EQ] = ACTIONS(8696),
    [anon_sym_STAR_EQ] = ACTIONS(8696),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(8696),
    [anon_sym_SLASH_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_PIPE_EQ] = ACTIONS(8696),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(8696),
    [anon_sym_AMP_EQ] = ACTIONS(8696),
    [anon_sym_PERCENT_EQ] = ACTIONS(8696),
    [anon_sym_GT_GT_EQ] = ACTIONS(8696),
    [anon_sym_LT_LT_EQ] = ACTIONS(8696),
    [anon_sym_CARET_EQ] = ACTIONS(8696),
    [anon_sym_QMARK] = ACTIONS(8696),
    [anon_sym_COLON2] = ACTIONS(8698),
    [anon_sym_DOT_DOT] = ACTIONS(8698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8696),
    [anon_sym_and] = ACTIONS(8696),
    [anon_sym_or] = ACTIONS(8696),
    [anon_sym_PIPE_PIPE] = ACTIONS(8698),
    [anon_sym_AMP_AMP] = ACTIONS(8698),
    [anon_sym_LT_LT] = ACTIONS(8698),
    [anon_sym_GT_GT] = ACTIONS(8698),
    [anon_sym_EQ_EQ] = ACTIONS(8698),
    [anon_sym_BANG_EQ] = ACTIONS(8696),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8696),
    [anon_sym_LT_EQ_GT] = ACTIONS(8696),
    [anon_sym_EQ_TILDE] = ACTIONS(8696),
    [anon_sym_BANG_TILDE] = ACTIONS(8696),
    [anon_sym_LT_EQ] = ACTIONS(8698),
    [anon_sym_GT] = ACTIONS(8698),
    [anon_sym_GT_EQ] = ACTIONS(8696),
    [anon_sym_CARET] = ACTIONS(8698),
    [anon_sym_PLUS] = ACTIONS(8698),
    [anon_sym_SLASH] = ACTIONS(8698),
    [anon_sym_PERCENT] = ACTIONS(8698),
    [sym_comment] = ACTIONS(87),
  },
  [10658] = {
    [sym__heredoc_body_start2] = ACTIONS(9229),
    [sym__binary_minus2] = ACTIONS(9229),
    [sym__binary_star2] = ACTIONS(9229),
    [anon_sym_LBRACE] = ACTIONS(9229),
    [anon_sym_RBRACE] = ACTIONS(9229),
    [anon_sym_RPAREN] = ACTIONS(9229),
    [anon_sym_DOT] = ACTIONS(9231),
    [anon_sym_COMMA] = ACTIONS(9229),
    [anon_sym_PIPE] = ACTIONS(9231),
    [anon_sym_SEMI] = ACTIONS(9229),
    [anon_sym_STAR_STAR] = ACTIONS(9231),
    [anon_sym_AMP] = ACTIONS(9231),
    [anon_sym_EQ] = ACTIONS(9231),
    [anon_sym_LT] = ACTIONS(9231),
    [anon_sym_if] = ACTIONS(9229),
    [anon_sym_unless] = ACTIONS(9229),
    [anon_sym_while] = ACTIONS(9229),
    [anon_sym_until] = ACTIONS(9229),
    [anon_sym_rescue] = ACTIONS(9229),
    [anon_sym_in] = ACTIONS(9229),
    [anon_sym_do] = ACTIONS(9229),
    [anon_sym_LBRACK] = ACTIONS(9229),
    [anon_sym_RBRACK] = ACTIONS(9229),
    [anon_sym_COLON_COLON2] = ACTIONS(9229),
    [anon_sym_AMP_DOT] = ACTIONS(9229),
    [anon_sym_PLUS_EQ] = ACTIONS(9229),
    [anon_sym_DASH_EQ] = ACTIONS(9229),
    [anon_sym_STAR_EQ] = ACTIONS(9229),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9229),
    [anon_sym_SLASH_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_PIPE_EQ] = ACTIONS(9229),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9229),
    [anon_sym_AMP_EQ] = ACTIONS(9229),
    [anon_sym_PERCENT_EQ] = ACTIONS(9229),
    [anon_sym_GT_GT_EQ] = ACTIONS(9229),
    [anon_sym_LT_LT_EQ] = ACTIONS(9229),
    [anon_sym_CARET_EQ] = ACTIONS(9229),
    [anon_sym_QMARK] = ACTIONS(9229),
    [anon_sym_COLON2] = ACTIONS(9231),
    [anon_sym_DOT_DOT] = ACTIONS(9231),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9229),
    [anon_sym_and] = ACTIONS(9229),
    [anon_sym_or] = ACTIONS(9229),
    [anon_sym_PIPE_PIPE] = ACTIONS(9231),
    [anon_sym_AMP_AMP] = ACTIONS(9231),
    [anon_sym_LT_LT] = ACTIONS(9231),
    [anon_sym_GT_GT] = ACTIONS(9231),
    [anon_sym_EQ_EQ] = ACTIONS(9231),
    [anon_sym_BANG_EQ] = ACTIONS(9229),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9229),
    [anon_sym_LT_EQ_GT] = ACTIONS(9229),
    [anon_sym_EQ_TILDE] = ACTIONS(9229),
    [anon_sym_BANG_TILDE] = ACTIONS(9229),
    [anon_sym_LT_EQ] = ACTIONS(9231),
    [anon_sym_GT] = ACTIONS(9231),
    [anon_sym_GT_EQ] = ACTIONS(9229),
    [anon_sym_CARET] = ACTIONS(9231),
    [anon_sym_PLUS] = ACTIONS(9231),
    [anon_sym_SLASH] = ACTIONS(9231),
    [anon_sym_PERCENT] = ACTIONS(9231),
    [sym_comment] = ACTIONS(87),
  },
  [10659] = {
    [anon_sym_end] = ACTIONS(14712),
    [sym_comment] = ACTIONS(87),
  },
  [10660] = {
    [sym_ensure] = STATE(11379),
    [anon_sym_end] = ACTIONS(14712),
    [anon_sym_ensure] = ACTIONS(2205),
    [sym_comment] = ACTIONS(87),
  },
  [10661] = {
    [sym__heredoc_body_start2] = ACTIONS(9457),
    [sym__binary_minus2] = ACTIONS(9457),
    [sym__binary_star2] = ACTIONS(9457),
    [anon_sym_LBRACE] = ACTIONS(9457),
    [anon_sym_RBRACE] = ACTIONS(9457),
    [anon_sym_RPAREN] = ACTIONS(9457),
    [anon_sym_DOT] = ACTIONS(9459),
    [anon_sym_COMMA] = ACTIONS(9457),
    [anon_sym_PIPE] = ACTIONS(9459),
    [anon_sym_SEMI] = ACTIONS(9457),
    [anon_sym_STAR_STAR] = ACTIONS(9459),
    [anon_sym_AMP] = ACTIONS(9459),
    [anon_sym_EQ] = ACTIONS(9459),
    [anon_sym_LT] = ACTIONS(9459),
    [anon_sym_if] = ACTIONS(9457),
    [anon_sym_unless] = ACTIONS(9457),
    [anon_sym_while] = ACTIONS(9457),
    [anon_sym_until] = ACTIONS(9457),
    [anon_sym_rescue] = ACTIONS(9457),
    [anon_sym_in] = ACTIONS(9457),
    [anon_sym_do] = ACTIONS(9457),
    [anon_sym_LBRACK] = ACTIONS(9457),
    [anon_sym_RBRACK] = ACTIONS(9457),
    [anon_sym_COLON_COLON2] = ACTIONS(9457),
    [anon_sym_AMP_DOT] = ACTIONS(9457),
    [anon_sym_PLUS_EQ] = ACTIONS(9457),
    [anon_sym_DASH_EQ] = ACTIONS(9457),
    [anon_sym_STAR_EQ] = ACTIONS(9457),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9457),
    [anon_sym_SLASH_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_PIPE_EQ] = ACTIONS(9457),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9457),
    [anon_sym_AMP_EQ] = ACTIONS(9457),
    [anon_sym_PERCENT_EQ] = ACTIONS(9457),
    [anon_sym_GT_GT_EQ] = ACTIONS(9457),
    [anon_sym_LT_LT_EQ] = ACTIONS(9457),
    [anon_sym_CARET_EQ] = ACTIONS(9457),
    [anon_sym_QMARK] = ACTIONS(9457),
    [anon_sym_COLON2] = ACTIONS(9459),
    [anon_sym_DOT_DOT] = ACTIONS(9459),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9457),
    [anon_sym_and] = ACTIONS(9457),
    [anon_sym_or] = ACTIONS(9457),
    [anon_sym_PIPE_PIPE] = ACTIONS(9459),
    [anon_sym_AMP_AMP] = ACTIONS(9459),
    [anon_sym_LT_LT] = ACTIONS(9459),
    [anon_sym_GT_GT] = ACTIONS(9459),
    [anon_sym_EQ_EQ] = ACTIONS(9459),
    [anon_sym_BANG_EQ] = ACTIONS(9457),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9457),
    [anon_sym_LT_EQ_GT] = ACTIONS(9457),
    [anon_sym_EQ_TILDE] = ACTIONS(9457),
    [anon_sym_BANG_TILDE] = ACTIONS(9457),
    [anon_sym_LT_EQ] = ACTIONS(9459),
    [anon_sym_GT] = ACTIONS(9459),
    [anon_sym_GT_EQ] = ACTIONS(9457),
    [anon_sym_CARET] = ACTIONS(9459),
    [anon_sym_PLUS] = ACTIONS(9459),
    [anon_sym_SLASH] = ACTIONS(9459),
    [anon_sym_PERCENT] = ACTIONS(9459),
    [sym_comment] = ACTIONS(87),
  },
  [10662] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11380),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_assignment] = STATE(11380),
    [sym_operator_assignment] = STATE(11380),
    [sym_conditional] = STATE(11380),
    [sym_range] = STATE(11380),
    [sym_binary] = STATE(11380),
    [sym_unary] = STATE(11380),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10663] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9274),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4092),
    [sym_scope_resolution] = STATE(4090),
    [sym_call] = STATE(4090),
    [sym_method_call] = STATE(4092),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(9274),
    [sym_operator_assignment] = STATE(9274),
    [sym_conditional] = STATE(9274),
    [sym_range] = STATE(9274),
    [sym_binary] = STATE(9274),
    [sym_unary] = STATE(9274),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(4091),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4092),
    [sym__variable] = STATE(4090),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4092),
    [sym_false] = STATE(4092),
    [sym_nil] = STATE(4092),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4093),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(2907),
    [sym__unary_minus2] = ACTIONS(6383),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6395),
    [anon_sym_yield] = ACTIONS(6397),
    [anon_sym_break] = ACTIONS(6399),
    [anon_sym_next] = ACTIONS(6401),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6419),
    [anon_sym_defined_QMARK] = ACTIONS(6421),
    [anon_sym_not] = ACTIONS(6423),
    [anon_sym_BANG] = ACTIONS(6425),
    [anon_sym_TILDE] = ACTIONS(6425),
    [sym_constant] = ACTIONS(6427),
    [sym_identifier] = ACTIONS(6427),
    [sym_instance_variable] = ACTIONS(6429),
    [sym_class_variable] = ACTIONS(6429),
    [sym_global_variable] = ACTIONS(6429),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6427),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6427),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10664] = {
    [aux_sym_exceptions_repeat1] = STATE(11382),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14714),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10665] = {
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_COLON2] = ACTIONS(13728),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [10666] = {
    [anon_sym_end] = ACTIONS(14716),
    [sym_comment] = ACTIONS(87),
  },
  [10667] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6451),
    [sym__binary_star2] = ACTIONS(6453),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6455),
    [anon_sym_STAR_STAR] = ACTIONS(6457),
    [anon_sym_AMP] = ACTIONS(6459),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(6461),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6465),
    [anon_sym_DOT_DOT] = ACTIONS(6467),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6469),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6471),
    [anon_sym_AMP_AMP] = ACTIONS(6471),
    [anon_sym_LT_LT] = ACTIONS(6473),
    [anon_sym_GT_GT] = ACTIONS(6473),
    [anon_sym_EQ_EQ] = ACTIONS(6471),
    [anon_sym_BANG_EQ] = ACTIONS(6475),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6475),
    [anon_sym_LT_EQ_GT] = ACTIONS(6475),
    [anon_sym_EQ_TILDE] = ACTIONS(6475),
    [anon_sym_BANG_TILDE] = ACTIONS(6475),
    [anon_sym_LT_EQ] = ACTIONS(6461),
    [anon_sym_GT] = ACTIONS(6461),
    [anon_sym_GT_EQ] = ACTIONS(6477),
    [anon_sym_CARET] = ACTIONS(6455),
    [anon_sym_PLUS] = ACTIONS(6479),
    [anon_sym_SLASH] = ACTIONS(6457),
    [anon_sym_PERCENT] = ACTIONS(6457),
    [sym_comment] = ACTIONS(87),
  },
  [10668] = {
    [aux_sym_exceptions_repeat1] = STATE(10668),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14718),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10669] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11384),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4145),
    [sym_scope_resolution] = STATE(471),
    [sym_call] = STATE(471),
    [sym_method_call] = STATE(4145),
    [sym_assignment] = STATE(11384),
    [sym_operator_assignment] = STATE(11384),
    [sym_conditional] = STATE(11384),
    [sym_range] = STATE(11384),
    [sym_binary] = STATE(11384),
    [sym_unary] = STATE(11384),
    [sym_left_assignment_list] = STATE(4144),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4145),
    [sym__variable] = STATE(471),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4145),
    [sym_false] = STATE(4145),
    [sym_nil] = STATE(4145),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4146),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(6499),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(6501),
    [anon_sym_yield] = ACTIONS(6503),
    [anon_sym_break] = ACTIONS(6505),
    [anon_sym_next] = ACTIONS(6507),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(6509),
    [anon_sym_defined_QMARK] = ACTIONS(6511),
    [anon_sym_not] = ACTIONS(6513),
    [anon_sym_BANG] = ACTIONS(6515),
    [anon_sym_TILDE] = ACTIONS(6515),
    [sym_constant] = ACTIONS(871),
    [sym_identifier] = ACTIONS(871),
    [sym_instance_variable] = ACTIONS(873),
    [sym_class_variable] = ACTIONS(873),
    [sym_global_variable] = ACTIONS(873),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(871),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(871),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10670] = {
    [sym_heredoc_body] = STATE(10670),
    [aux_sym_call_repeat1] = STATE(10670),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_RBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10671] = {
    [sym_heredoc_body] = STATE(10670),
    [aux_sym_call_repeat1] = STATE(10670),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_RBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10672] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11385),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_assignment] = STATE(11385),
    [sym_operator_assignment] = STATE(11385),
    [sym_conditional] = STATE(11385),
    [sym_range] = STATE(11385),
    [sym_binary] = STATE(11385),
    [sym_unary] = STATE(11385),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10673] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(9319),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4167),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4167),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(9319),
    [sym_operator_assignment] = STATE(9319),
    [sym_conditional] = STATE(9319),
    [sym_range] = STATE(9319),
    [sym_binary] = STATE(9319),
    [sym_unary] = STATE(9319),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(4166),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4167),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4167),
    [sym_false] = STATE(4167),
    [sym_nil] = STATE(4167),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(3026),
    [sym__unary_minus2] = ACTIONS(6567),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6577),
    [anon_sym_defined_QMARK] = ACTIONS(6579),
    [anon_sym_not] = ACTIONS(6581),
    [anon_sym_BANG] = ACTIONS(6583),
    [anon_sym_TILDE] = ACTIONS(6583),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10674] = {
    [aux_sym_exceptions_repeat1] = STATE(11386),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14721),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10675] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6591),
    [sym__binary_star2] = ACTIONS(6593),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6595),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(6597),
    [anon_sym_AMP] = ACTIONS(6599),
    [anon_sym_LT] = ACTIONS(6601),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6605),
    [anon_sym_DOT_DOT] = ACTIONS(6607),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6609),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6611),
    [anon_sym_AMP_AMP] = ACTIONS(6611),
    [anon_sym_LT_LT] = ACTIONS(6613),
    [anon_sym_GT_GT] = ACTIONS(6613),
    [anon_sym_EQ_EQ] = ACTIONS(6615),
    [anon_sym_BANG_EQ] = ACTIONS(6611),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6611),
    [anon_sym_LT_EQ_GT] = ACTIONS(6611),
    [anon_sym_EQ_TILDE] = ACTIONS(6611),
    [anon_sym_BANG_TILDE] = ACTIONS(6611),
    [anon_sym_LT_EQ] = ACTIONS(6601),
    [anon_sym_GT] = ACTIONS(6601),
    [anon_sym_GT_EQ] = ACTIONS(6617),
    [anon_sym_CARET] = ACTIONS(6619),
    [anon_sym_PLUS] = ACTIONS(6621),
    [anon_sym_SLASH] = ACTIONS(6597),
    [anon_sym_PERCENT] = ACTIONS(6597),
    [sym_comment] = ACTIONS(87),
  },
  [10676] = {
    [aux_sym_exceptions_repeat1] = STATE(10676),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14723),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10677] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11387),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_assignment] = STATE(11387),
    [sym_operator_assignment] = STATE(11387),
    [sym_conditional] = STATE(11387),
    [sym_range] = STATE(11387),
    [sym_binary] = STATE(11387),
    [sym_unary] = STATE(11387),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10678] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(9341),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(4228),
    [sym_scope_resolution] = STATE(4226),
    [sym_call] = STATE(4226),
    [sym_method_call] = STATE(4228),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(9341),
    [sym_operator_assignment] = STATE(9341),
    [sym_conditional] = STATE(9341),
    [sym_range] = STATE(9341),
    [sym_binary] = STATE(9341),
    [sym_unary] = STATE(9341),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(4227),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4228),
    [sym__variable] = STATE(4226),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(4228),
    [sym_false] = STATE(4228),
    [sym_nil] = STATE(4228),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(4229),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(3100),
    [sym__unary_minus2] = ACTIONS(6637),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(6639),
    [anon_sym_yield] = ACTIONS(6641),
    [anon_sym_break] = ACTIONS(6643),
    [anon_sym_next] = ACTIONS(6645),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(6647),
    [anon_sym_defined_QMARK] = ACTIONS(6649),
    [anon_sym_not] = ACTIONS(6651),
    [anon_sym_BANG] = ACTIONS(6653),
    [anon_sym_TILDE] = ACTIONS(6653),
    [sym_constant] = ACTIONS(6655),
    [sym_identifier] = ACTIONS(6655),
    [sym_instance_variable] = ACTIONS(6657),
    [sym_class_variable] = ACTIONS(6657),
    [sym_global_variable] = ACTIONS(6657),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(6655),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(6655),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [10679] = {
    [aux_sym_exceptions_repeat1] = STATE(11388),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14726),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10680] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6665),
    [sym__binary_star2] = ACTIONS(6667),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6669),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(6671),
    [anon_sym_AMP] = ACTIONS(6673),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(6675),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6679),
    [anon_sym_DOT_DOT] = ACTIONS(6681),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6683),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6685),
    [anon_sym_AMP_AMP] = ACTIONS(6685),
    [anon_sym_LT_LT] = ACTIONS(6687),
    [anon_sym_GT_GT] = ACTIONS(6687),
    [anon_sym_EQ_EQ] = ACTIONS(6685),
    [anon_sym_BANG_EQ] = ACTIONS(6689),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6689),
    [anon_sym_LT_EQ_GT] = ACTIONS(6689),
    [anon_sym_EQ_TILDE] = ACTIONS(6689),
    [anon_sym_BANG_TILDE] = ACTIONS(6689),
    [anon_sym_LT_EQ] = ACTIONS(6675),
    [anon_sym_GT] = ACTIONS(6675),
    [anon_sym_GT_EQ] = ACTIONS(6691),
    [anon_sym_CARET] = ACTIONS(6669),
    [anon_sym_PLUS] = ACTIONS(6693),
    [anon_sym_SLASH] = ACTIONS(6671),
    [anon_sym_PERCENT] = ACTIONS(6671),
    [sym_comment] = ACTIONS(87),
  },
  [10681] = {
    [aux_sym_exceptions_repeat1] = STATE(10681),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14728),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10682] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11389),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(4264),
    [sym_scope_resolution] = STATE(509),
    [sym_call] = STATE(509),
    [sym_method_call] = STATE(4264),
    [sym_assignment] = STATE(11389),
    [sym_operator_assignment] = STATE(11389),
    [sym_conditional] = STATE(11389),
    [sym_range] = STATE(11389),
    [sym_binary] = STATE(11389),
    [sym_unary] = STATE(11389),
    [sym_left_assignment_list] = STATE(4263),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4264),
    [sym__variable] = STATE(509),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(4264),
    [sym_false] = STATE(4264),
    [sym_nil] = STATE(4264),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(4168),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(6707),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(6569),
    [anon_sym_yield] = ACTIONS(6571),
    [anon_sym_break] = ACTIONS(6573),
    [anon_sym_next] = ACTIONS(6575),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(6709),
    [anon_sym_defined_QMARK] = ACTIONS(6711),
    [anon_sym_not] = ACTIONS(6713),
    [anon_sym_BANG] = ACTIONS(6715),
    [anon_sym_TILDE] = ACTIONS(6715),
    [sym_constant] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_instance_variable] = ACTIONS(967),
    [sym_class_variable] = ACTIONS(967),
    [sym_global_variable] = ACTIONS(967),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(965),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(965),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10683] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11390),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_assignment] = STATE(11390),
    [sym_operator_assignment] = STATE(11390),
    [sym_conditional] = STATE(11390),
    [sym_range] = STATE(11390),
    [sym_binary] = STATE(11390),
    [sym_unary] = STATE(11390),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10684] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9378),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4290),
    [sym_scope_resolution] = STATE(557),
    [sym_call] = STATE(557),
    [sym_method_call] = STATE(4290),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(9378),
    [sym_operator_assignment] = STATE(9378),
    [sym_conditional] = STATE(9378),
    [sym_range] = STATE(9378),
    [sym_binary] = STATE(9378),
    [sym_unary] = STATE(9378),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(4289),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4290),
    [sym__variable] = STATE(557),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4290),
    [sym_false] = STATE(4290),
    [sym_nil] = STATE(4290),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(560),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(3176),
    [sym__unary_minus2] = ACTIONS(6759),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(1015),
    [anon_sym_yield] = ACTIONS(1017),
    [anon_sym_break] = ACTIONS(1019),
    [anon_sym_next] = ACTIONS(1021),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(6761),
    [anon_sym_defined_QMARK] = ACTIONS(6763),
    [anon_sym_not] = ACTIONS(6765),
    [anon_sym_BANG] = ACTIONS(6767),
    [anon_sym_TILDE] = ACTIONS(6767),
    [sym_constant] = ACTIONS(1033),
    [sym_identifier] = ACTIONS(1033),
    [sym_instance_variable] = ACTIONS(1035),
    [sym_class_variable] = ACTIONS(1035),
    [sym_global_variable] = ACTIONS(1035),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(1033),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(1033),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10685] = {
    [aux_sym_exceptions_repeat1] = STATE(11391),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14731),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10686] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6783),
    [sym__binary_star2] = ACTIONS(6785),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6787),
    [anon_sym_STAR_STAR] = ACTIONS(6789),
    [anon_sym_AMP] = ACTIONS(6791),
    [anon_sym_LT] = ACTIONS(6793),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6797),
    [anon_sym_DOT_DOT] = ACTIONS(6799),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6801),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6803),
    [anon_sym_AMP_AMP] = ACTIONS(6803),
    [anon_sym_LT_LT] = ACTIONS(6805),
    [anon_sym_GT_GT] = ACTIONS(6805),
    [anon_sym_EQ_EQ] = ACTIONS(6807),
    [anon_sym_BANG_EQ] = ACTIONS(6803),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6803),
    [anon_sym_LT_EQ_GT] = ACTIONS(6803),
    [anon_sym_EQ_TILDE] = ACTIONS(6803),
    [anon_sym_BANG_TILDE] = ACTIONS(6803),
    [anon_sym_LT_EQ] = ACTIONS(6793),
    [anon_sym_GT] = ACTIONS(6793),
    [anon_sym_GT_EQ] = ACTIONS(6809),
    [anon_sym_CARET] = ACTIONS(6811),
    [anon_sym_PLUS] = ACTIONS(6813),
    [anon_sym_SLASH] = ACTIONS(6789),
    [anon_sym_PERCENT] = ACTIONS(6789),
    [sym_comment] = ACTIONS(87),
  },
  [10687] = {
    [aux_sym_exceptions_repeat1] = STATE(10687),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14733),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10688] = {
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10936),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_rescue] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_in] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_RBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS_EQ] = ACTIONS(10934),
    [anon_sym_DASH_EQ] = ACTIONS(10934),
    [anon_sym_STAR_EQ] = ACTIONS(10934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10934),
    [anon_sym_SLASH_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_PIPE_EQ] = ACTIONS(10934),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10934),
    [anon_sym_AMP_EQ] = ACTIONS(10934),
    [anon_sym_PERCENT_EQ] = ACTIONS(10934),
    [anon_sym_GT_GT_EQ] = ACTIONS(10934),
    [anon_sym_LT_LT_EQ] = ACTIONS(10934),
    [anon_sym_CARET_EQ] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10936),
    [anon_sym_COLON2] = ACTIONS(10936),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10936),
    [anon_sym_or] = ACTIONS(10936),
    [anon_sym_PIPE_PIPE] = ACTIONS(10936),
    [anon_sym_AMP_AMP] = ACTIONS(10936),
    [anon_sym_LT_LT] = ACTIONS(10936),
    [anon_sym_GT_GT] = ACTIONS(10936),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10936),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_SLASH] = ACTIONS(10936),
    [anon_sym_PERCENT] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10936),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [10689] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11392),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_assignment] = STATE(11392),
    [sym_operator_assignment] = STATE(11392),
    [sym_conditional] = STATE(11392),
    [sym_range] = STATE(11392),
    [sym_binary] = STATE(11392),
    [sym_unary] = STATE(11392),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10690] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9412),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4367),
    [sym_scope_resolution] = STATE(4365),
    [sym_call] = STATE(4365),
    [sym_method_call] = STATE(4367),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(9412),
    [sym_operator_assignment] = STATE(9412),
    [sym_conditional] = STATE(9412),
    [sym_range] = STATE(9412),
    [sym_binary] = STATE(9412),
    [sym_unary] = STATE(9412),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(4366),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4367),
    [sym__variable] = STATE(4365),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4367),
    [sym_false] = STATE(4367),
    [sym_nil] = STATE(4367),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4368),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(3248),
    [sym__unary_minus2] = ACTIONS(6845),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(6847),
    [anon_sym_yield] = ACTIONS(6849),
    [anon_sym_break] = ACTIONS(6851),
    [anon_sym_next] = ACTIONS(6853),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(6855),
    [anon_sym_defined_QMARK] = ACTIONS(6857),
    [anon_sym_not] = ACTIONS(6859),
    [anon_sym_BANG] = ACTIONS(6861),
    [anon_sym_TILDE] = ACTIONS(6861),
    [sym_constant] = ACTIONS(6863),
    [sym_identifier] = ACTIONS(6863),
    [sym_instance_variable] = ACTIONS(6865),
    [sym_class_variable] = ACTIONS(6865),
    [sym_global_variable] = ACTIONS(6865),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(6863),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(6863),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10691] = {
    [aux_sym_exceptions_repeat1] = STATE(11393),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14736),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10692] = {
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_STAR_STAR] = ACTIONS(13728),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_if] = ACTIONS(13726),
    [anon_sym_unless] = ACTIONS(13726),
    [anon_sym_while] = ACTIONS(13726),
    [anon_sym_until] = ACTIONS(13726),
    [anon_sym_rescue] = ACTIONS(13726),
    [anon_sym_in] = ACTIONS(13726),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_RBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_PLUS_EQ] = ACTIONS(13726),
    [anon_sym_DASH_EQ] = ACTIONS(13726),
    [anon_sym_STAR_EQ] = ACTIONS(13726),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13726),
    [anon_sym_SLASH_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_PIPE_EQ] = ACTIONS(13726),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13726),
    [anon_sym_AMP_EQ] = ACTIONS(13726),
    [anon_sym_PERCENT_EQ] = ACTIONS(13726),
    [anon_sym_GT_GT_EQ] = ACTIONS(13726),
    [anon_sym_LT_LT_EQ] = ACTIONS(13726),
    [anon_sym_CARET_EQ] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_COLON2] = ACTIONS(13728),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13728),
    [anon_sym_AMP_AMP] = ACTIONS(13728),
    [anon_sym_LT_LT] = ACTIONS(13728),
    [anon_sym_GT_GT] = ACTIONS(13728),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13728),
    [anon_sym_PLUS] = ACTIONS(13728),
    [anon_sym_SLASH] = ACTIONS(13728),
    [anon_sym_PERCENT] = ACTIONS(13728),
    [sym_comment] = ACTIONS(87),
  },
  [10693] = {
    [anon_sym_end] = ACTIONS(14738),
    [sym_comment] = ACTIONS(87),
  },
  [10694] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(6879),
    [sym__binary_star2] = ACTIONS(6881),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(6883),
    [anon_sym_STAR_STAR] = ACTIONS(6885),
    [anon_sym_AMP] = ACTIONS(6887),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(6889),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(6893),
    [anon_sym_DOT_DOT] = ACTIONS(6895),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6897),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(6899),
    [anon_sym_AMP_AMP] = ACTIONS(6899),
    [anon_sym_LT_LT] = ACTIONS(6901),
    [anon_sym_GT_GT] = ACTIONS(6901),
    [anon_sym_EQ_EQ] = ACTIONS(6899),
    [anon_sym_BANG_EQ] = ACTIONS(6903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6903),
    [anon_sym_LT_EQ_GT] = ACTIONS(6903),
    [anon_sym_EQ_TILDE] = ACTIONS(6903),
    [anon_sym_BANG_TILDE] = ACTIONS(6903),
    [anon_sym_LT_EQ] = ACTIONS(6889),
    [anon_sym_GT] = ACTIONS(6889),
    [anon_sym_GT_EQ] = ACTIONS(6905),
    [anon_sym_CARET] = ACTIONS(6883),
    [anon_sym_PLUS] = ACTIONS(6907),
    [anon_sym_SLASH] = ACTIONS(6885),
    [anon_sym_PERCENT] = ACTIONS(6885),
    [sym_comment] = ACTIONS(87),
  },
  [10695] = {
    [aux_sym_exceptions_repeat1] = STATE(10695),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14740),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10696] = {
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14122),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_EQ_GT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_COLON2] = ACTIONS(14124),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14122),
    [anon_sym_AMP_AMP] = ACTIONS(14122),
    [anon_sym_LT_LT] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(14122),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14122),
    [anon_sym_PLUS] = ACTIONS(14122),
    [anon_sym_SLASH] = ACTIONS(14122),
    [anon_sym_PERCENT] = ACTIONS(14122),
    [sym_comment] = ACTIONS(87),
  },
  [10697] = {
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14626),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_COLON2] = ACTIONS(14628),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14626),
    [anon_sym_AMP_AMP] = ACTIONS(14626),
    [anon_sym_LT_LT] = ACTIONS(14626),
    [anon_sym_GT_GT] = ACTIONS(14626),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14626),
    [anon_sym_PLUS] = ACTIONS(14626),
    [anon_sym_SLASH] = ACTIONS(14626),
    [anon_sym_PERCENT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [10698] = {
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12499),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_in] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_EQ_GT] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_RBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_PLUS_EQ] = ACTIONS(12497),
    [anon_sym_DASH_EQ] = ACTIONS(12497),
    [anon_sym_STAR_EQ] = ACTIONS(12497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12497),
    [anon_sym_SLASH_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12497),
    [anon_sym_AMP_EQ] = ACTIONS(12497),
    [anon_sym_PERCENT_EQ] = ACTIONS(12497),
    [anon_sym_GT_GT_EQ] = ACTIONS(12497),
    [anon_sym_LT_LT_EQ] = ACTIONS(12497),
    [anon_sym_CARET_EQ] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_COLON2] = ACTIONS(12499),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12499),
    [anon_sym_AMP_AMP] = ACTIONS(12499),
    [anon_sym_LT_LT] = ACTIONS(12499),
    [anon_sym_GT_GT] = ACTIONS(12499),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12499),
    [anon_sym_PLUS] = ACTIONS(12499),
    [anon_sym_SLASH] = ACTIONS(12499),
    [anon_sym_PERCENT] = ACTIONS(12499),
    [sym_comment] = ACTIONS(87),
  },
  [10699] = {
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12503),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_in] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_EQ_GT] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_RBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_PLUS_EQ] = ACTIONS(12501),
    [anon_sym_DASH_EQ] = ACTIONS(12501),
    [anon_sym_STAR_EQ] = ACTIONS(12501),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12501),
    [anon_sym_SLASH_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12501),
    [anon_sym_AMP_EQ] = ACTIONS(12501),
    [anon_sym_PERCENT_EQ] = ACTIONS(12501),
    [anon_sym_GT_GT_EQ] = ACTIONS(12501),
    [anon_sym_LT_LT_EQ] = ACTIONS(12501),
    [anon_sym_CARET_EQ] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_COLON2] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12503),
    [anon_sym_AMP_AMP] = ACTIONS(12503),
    [anon_sym_LT_LT] = ACTIONS(12503),
    [anon_sym_GT_GT] = ACTIONS(12503),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12503),
    [anon_sym_PLUS] = ACTIONS(12503),
    [anon_sym_SLASH] = ACTIONS(12503),
    [anon_sym_PERCENT] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [10700] = {
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12617),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_in] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_EQ_GT] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_RBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_PLUS_EQ] = ACTIONS(12615),
    [anon_sym_DASH_EQ] = ACTIONS(12615),
    [anon_sym_STAR_EQ] = ACTIONS(12615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12615),
    [anon_sym_SLASH_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12615),
    [anon_sym_AMP_EQ] = ACTIONS(12615),
    [anon_sym_PERCENT_EQ] = ACTIONS(12615),
    [anon_sym_GT_GT_EQ] = ACTIONS(12615),
    [anon_sym_LT_LT_EQ] = ACTIONS(12615),
    [anon_sym_CARET_EQ] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_COLON2] = ACTIONS(12617),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12617),
    [anon_sym_AMP_AMP] = ACTIONS(12617),
    [anon_sym_LT_LT] = ACTIONS(12617),
    [anon_sym_GT_GT] = ACTIONS(12617),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12617),
    [anon_sym_PLUS] = ACTIONS(12617),
    [anon_sym_SLASH] = ACTIONS(12617),
    [anon_sym_PERCENT] = ACTIONS(12617),
    [sym_comment] = ACTIONS(87),
  },
  [10701] = {
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12918),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_in] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_EQ_GT] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_RBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_PLUS_EQ] = ACTIONS(12916),
    [anon_sym_DASH_EQ] = ACTIONS(12916),
    [anon_sym_STAR_EQ] = ACTIONS(12916),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12916),
    [anon_sym_SLASH_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12916),
    [anon_sym_AMP_EQ] = ACTIONS(12916),
    [anon_sym_PERCENT_EQ] = ACTIONS(12916),
    [anon_sym_GT_GT_EQ] = ACTIONS(12916),
    [anon_sym_LT_LT_EQ] = ACTIONS(12916),
    [anon_sym_CARET_EQ] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_COLON2] = ACTIONS(12918),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12918),
    [anon_sym_AMP_AMP] = ACTIONS(12918),
    [anon_sym_LT_LT] = ACTIONS(12918),
    [anon_sym_GT_GT] = ACTIONS(12918),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12918),
    [anon_sym_PLUS] = ACTIONS(12918),
    [anon_sym_SLASH] = ACTIONS(12918),
    [anon_sym_PERCENT] = ACTIONS(12918),
    [sym_comment] = ACTIONS(87),
  },
  [10702] = {
    [anon_sym_end] = ACTIONS(14743),
    [sym_comment] = ACTIONS(87),
  },
  [10703] = {
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13066),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_EQ_GT] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_RBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_PLUS_EQ] = ACTIONS(13064),
    [anon_sym_DASH_EQ] = ACTIONS(13064),
    [anon_sym_STAR_EQ] = ACTIONS(13064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13064),
    [anon_sym_SLASH_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13064),
    [anon_sym_AMP_EQ] = ACTIONS(13064),
    [anon_sym_PERCENT_EQ] = ACTIONS(13064),
    [anon_sym_GT_GT_EQ] = ACTIONS(13064),
    [anon_sym_LT_LT_EQ] = ACTIONS(13064),
    [anon_sym_CARET_EQ] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13066),
    [anon_sym_AMP_AMP] = ACTIONS(13066),
    [anon_sym_LT_LT] = ACTIONS(13066),
    [anon_sym_GT_GT] = ACTIONS(13066),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13066),
    [anon_sym_PLUS] = ACTIONS(13066),
    [anon_sym_SLASH] = ACTIONS(13066),
    [anon_sym_PERCENT] = ACTIONS(13066),
    [sym_comment] = ACTIONS(87),
  },
  [10704] = {
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13218),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_in] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_EQ_GT] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_RBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_PLUS_EQ] = ACTIONS(13216),
    [anon_sym_DASH_EQ] = ACTIONS(13216),
    [anon_sym_STAR_EQ] = ACTIONS(13216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13216),
    [anon_sym_SLASH_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13216),
    [anon_sym_AMP_EQ] = ACTIONS(13216),
    [anon_sym_PERCENT_EQ] = ACTIONS(13216),
    [anon_sym_GT_GT_EQ] = ACTIONS(13216),
    [anon_sym_LT_LT_EQ] = ACTIONS(13216),
    [anon_sym_CARET_EQ] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_COLON2] = ACTIONS(13218),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13218),
    [anon_sym_AMP_AMP] = ACTIONS(13218),
    [anon_sym_LT_LT] = ACTIONS(13218),
    [anon_sym_GT_GT] = ACTIONS(13218),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13218),
    [anon_sym_PLUS] = ACTIONS(13218),
    [anon_sym_SLASH] = ACTIONS(13218),
    [anon_sym_PERCENT] = ACTIONS(13218),
    [sym_comment] = ACTIONS(87),
  },
  [10705] = {
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [10706] = {
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13229),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_in] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_EQ_GT] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_RBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_PLUS_EQ] = ACTIONS(13227),
    [anon_sym_DASH_EQ] = ACTIONS(13227),
    [anon_sym_STAR_EQ] = ACTIONS(13227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13227),
    [anon_sym_SLASH_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13227),
    [anon_sym_AMP_EQ] = ACTIONS(13227),
    [anon_sym_PERCENT_EQ] = ACTIONS(13227),
    [anon_sym_GT_GT_EQ] = ACTIONS(13227),
    [anon_sym_LT_LT_EQ] = ACTIONS(13227),
    [anon_sym_CARET_EQ] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_COLON2] = ACTIONS(13229),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13229),
    [anon_sym_AMP_AMP] = ACTIONS(13229),
    [anon_sym_LT_LT] = ACTIONS(13229),
    [anon_sym_GT_GT] = ACTIONS(13229),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13229),
    [anon_sym_PLUS] = ACTIONS(13229),
    [anon_sym_SLASH] = ACTIONS(13229),
    [anon_sym_PERCENT] = ACTIONS(13229),
    [sym_comment] = ACTIONS(87),
  },
  [10707] = {
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_in] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_EQ_GT] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_RBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_PLUS_EQ] = ACTIONS(13551),
    [anon_sym_DASH_EQ] = ACTIONS(13551),
    [anon_sym_STAR_EQ] = ACTIONS(13551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13551),
    [anon_sym_SLASH_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13551),
    [anon_sym_AMP_EQ] = ACTIONS(13551),
    [anon_sym_PERCENT_EQ] = ACTIONS(13551),
    [anon_sym_GT_GT_EQ] = ACTIONS(13551),
    [anon_sym_LT_LT_EQ] = ACTIONS(13551),
    [anon_sym_CARET_EQ] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_COLON2] = ACTIONS(13553),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13553),
    [anon_sym_AMP_AMP] = ACTIONS(13553),
    [anon_sym_LT_LT] = ACTIONS(13553),
    [anon_sym_GT_GT] = ACTIONS(13553),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13553),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_SLASH] = ACTIONS(13553),
    [anon_sym_PERCENT] = ACTIONS(13553),
    [sym_comment] = ACTIONS(87),
  },
  [10708] = {
    [sym__binary_minus2] = ACTIONS(7057),
    [sym__binary_star2] = ACTIONS(7059),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7061),
    [anon_sym_STAR_STAR] = ACTIONS(7063),
    [anon_sym_AMP] = ACTIONS(7065),
    [anon_sym_LT] = ACTIONS(7067),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7069),
    [anon_sym_DOT_DOT] = ACTIONS(7071),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7073),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7075),
    [anon_sym_AMP_AMP] = ACTIONS(7075),
    [anon_sym_LT_LT] = ACTIONS(7077),
    [anon_sym_GT_GT] = ACTIONS(7077),
    [anon_sym_EQ_EQ] = ACTIONS(7079),
    [anon_sym_BANG_EQ] = ACTIONS(7075),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7075),
    [anon_sym_LT_EQ_GT] = ACTIONS(7075),
    [anon_sym_EQ_TILDE] = ACTIONS(7075),
    [anon_sym_BANG_TILDE] = ACTIONS(7075),
    [anon_sym_LT_EQ] = ACTIONS(7067),
    [anon_sym_GT] = ACTIONS(7067),
    [anon_sym_GT_EQ] = ACTIONS(7081),
    [anon_sym_CARET] = ACTIONS(7083),
    [anon_sym_PLUS] = ACTIONS(7085),
    [anon_sym_SLASH] = ACTIONS(7063),
    [anon_sym_PERCENT] = ACTIONS(7063),
    [sym_comment] = ACTIONS(87),
  },
  [10709] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11396),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_assignment] = STATE(11396),
    [sym_operator_assignment] = STATE(11396),
    [sym_conditional] = STATE(11396),
    [sym_range] = STATE(11396),
    [sym_binary] = STATE(11396),
    [sym_unary] = STATE(11396),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10710] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9476),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4585),
    [sym_scope_resolution] = STATE(2588),
    [sym_call] = STATE(2588),
    [sym_method_call] = STATE(4585),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(9476),
    [sym_operator_assignment] = STATE(9476),
    [sym_conditional] = STATE(9476),
    [sym_range] = STATE(9476),
    [sym_binary] = STATE(9476),
    [sym_unary] = STATE(9476),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(4584),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4585),
    [sym__variable] = STATE(2588),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4585),
    [sym_false] = STATE(4585),
    [sym_nil] = STATE(4585),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(2591),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(3522),
    [sym__unary_minus2] = ACTIONS(7110),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4224),
    [anon_sym_next] = ACTIONS(4226),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(7112),
    [anon_sym_defined_QMARK] = ACTIONS(7114),
    [anon_sym_not] = ACTIONS(7116),
    [anon_sym_BANG] = ACTIONS(7118),
    [anon_sym_TILDE] = ACTIONS(7118),
    [sym_constant] = ACTIONS(4236),
    [sym_identifier] = ACTIONS(4236),
    [sym_instance_variable] = ACTIONS(4238),
    [sym_class_variable] = ACTIONS(4238),
    [sym_global_variable] = ACTIONS(4238),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(4236),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4236),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10711] = {
    [aux_sym_exceptions_repeat1] = STATE(11397),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14745),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10712] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7126),
    [sym__binary_star2] = ACTIONS(7128),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7130),
    [anon_sym_STAR_STAR] = ACTIONS(7132),
    [anon_sym_AMP] = ACTIONS(7134),
    [anon_sym_LT] = ACTIONS(7136),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7140),
    [anon_sym_DOT_DOT] = ACTIONS(7142),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7144),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7146),
    [anon_sym_AMP_AMP] = ACTIONS(7146),
    [anon_sym_LT_LT] = ACTIONS(7148),
    [anon_sym_GT_GT] = ACTIONS(7148),
    [anon_sym_EQ_EQ] = ACTIONS(7150),
    [anon_sym_BANG_EQ] = ACTIONS(7146),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7146),
    [anon_sym_LT_EQ_GT] = ACTIONS(7146),
    [anon_sym_EQ_TILDE] = ACTIONS(7146),
    [anon_sym_BANG_TILDE] = ACTIONS(7146),
    [anon_sym_LT_EQ] = ACTIONS(7136),
    [anon_sym_GT] = ACTIONS(7136),
    [anon_sym_GT_EQ] = ACTIONS(7152),
    [anon_sym_CARET] = ACTIONS(7154),
    [anon_sym_PLUS] = ACTIONS(7156),
    [anon_sym_SLASH] = ACTIONS(7132),
    [anon_sym_PERCENT] = ACTIONS(7132),
    [sym_comment] = ACTIONS(87),
  },
  [10713] = {
    [aux_sym_exceptions_repeat1] = STATE(10713),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14747),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10714] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11398),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_assignment] = STATE(11398),
    [sym_operator_assignment] = STATE(11398),
    [sym_conditional] = STATE(11398),
    [sym_range] = STATE(11398),
    [sym_binary] = STATE(11398),
    [sym_unary] = STATE(11398),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10715] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(9495),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(4634),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4634),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(9495),
    [sym_operator_assignment] = STATE(9495),
    [sym_conditional] = STATE(9495),
    [sym_range] = STATE(9495),
    [sym_binary] = STATE(9495),
    [sym_unary] = STATE(9495),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(4633),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4634),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(4634),
    [sym_false] = STATE(4634),
    [sym_nil] = STATE(4634),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(4635),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(3574),
    [sym__unary_minus2] = ACTIONS(7170),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(7172),
    [anon_sym_yield] = ACTIONS(7174),
    [anon_sym_break] = ACTIONS(7176),
    [anon_sym_next] = ACTIONS(7178),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(7180),
    [anon_sym_defined_QMARK] = ACTIONS(7182),
    [anon_sym_not] = ACTIONS(7184),
    [anon_sym_BANG] = ACTIONS(7186),
    [anon_sym_TILDE] = ACTIONS(7186),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [10716] = {
    [aux_sym_exceptions_repeat1] = STATE(11399),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14750),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10717] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7198),
    [sym__binary_star2] = ACTIONS(7200),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7202),
    [anon_sym_STAR_STAR] = ACTIONS(7204),
    [anon_sym_AMP] = ACTIONS(7206),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(7208),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7212),
    [anon_sym_DOT_DOT] = ACTIONS(7214),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7216),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7218),
    [anon_sym_AMP_AMP] = ACTIONS(7218),
    [anon_sym_LT_LT] = ACTIONS(7220),
    [anon_sym_GT_GT] = ACTIONS(7220),
    [anon_sym_EQ_EQ] = ACTIONS(7218),
    [anon_sym_BANG_EQ] = ACTIONS(7222),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7222),
    [anon_sym_LT_EQ_GT] = ACTIONS(7222),
    [anon_sym_EQ_TILDE] = ACTIONS(7222),
    [anon_sym_BANG_TILDE] = ACTIONS(7222),
    [anon_sym_LT_EQ] = ACTIONS(7208),
    [anon_sym_GT] = ACTIONS(7208),
    [anon_sym_GT_EQ] = ACTIONS(7224),
    [anon_sym_CARET] = ACTIONS(7202),
    [anon_sym_PLUS] = ACTIONS(7226),
    [anon_sym_SLASH] = ACTIONS(7204),
    [anon_sym_PERCENT] = ACTIONS(7204),
    [sym_comment] = ACTIONS(87),
  },
  [10718] = {
    [aux_sym_exceptions_repeat1] = STATE(10718),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14752),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10719] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11400),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(4674),
    [sym_scope_resolution] = STATE(697),
    [sym_call] = STATE(697),
    [sym_method_call] = STATE(4674),
    [sym_assignment] = STATE(11400),
    [sym_operator_assignment] = STATE(11400),
    [sym_conditional] = STATE(11400),
    [sym_range] = STATE(11400),
    [sym_binary] = STATE(11400),
    [sym_unary] = STATE(11400),
    [sym_left_assignment_list] = STATE(4673),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4674),
    [sym__variable] = STATE(697),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(4674),
    [sym_false] = STATE(4674),
    [sym_nil] = STATE(4674),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(4675),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(7240),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(7242),
    [anon_sym_yield] = ACTIONS(7244),
    [anon_sym_break] = ACTIONS(7246),
    [anon_sym_next] = ACTIONS(7248),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(7250),
    [anon_sym_defined_QMARK] = ACTIONS(7252),
    [anon_sym_not] = ACTIONS(7254),
    [anon_sym_BANG] = ACTIONS(7256),
    [anon_sym_TILDE] = ACTIONS(7256),
    [sym_constant] = ACTIONS(1269),
    [sym_identifier] = ACTIONS(1269),
    [sym_instance_variable] = ACTIONS(1271),
    [sym_class_variable] = ACTIONS(1271),
    [sym_global_variable] = ACTIONS(1271),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(1269),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(1269),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [10720] = {
    [sym__line_break2] = ACTIONS(12071),
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12071),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_SEMI] = ACTIONS(12071),
    [anon_sym_then] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [10721] = {
    [sym__line_break2] = ACTIONS(12096),
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12096),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_SEMI] = ACTIONS(12096),
    [anon_sym_then] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [10722] = {
    [anon_sym_end] = ACTIONS(14755),
    [sym_comment] = ACTIONS(87),
  },
  [10723] = {
    [sym__statements] = STATE(11402),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14757),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10724] = {
    [sym__line_break2] = ACTIONS(13718),
    [sym__heredoc_body_start2] = ACTIONS(13718),
    [anon_sym_COMMA] = ACTIONS(13718),
    [anon_sym_SEMI] = ACTIONS(13718),
    [sym_comment] = ACTIONS(87),
  },
  [10725] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_RPAREN] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [10726] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_RPAREN] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [10727] = {
    [sym_heredoc_body] = STATE(10727),
    [aux_sym_call_repeat1] = STATE(10727),
    [sym__heredoc_body_start2] = ACTIONS(14048),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_RPAREN] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10728] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(7439),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(2212),
    [sym_scope_resolution] = STATE(2174),
    [sym_call] = STATE(2174),
    [sym_method_call] = STATE(2212),
    [sym__argument] = STATE(10772),
    [sym_splat_argument] = STATE(10772),
    [sym_hash_splat_argument] = STATE(10772),
    [sym_block_argument] = STATE(10772),
    [sym_assignment] = STATE(7439),
    [sym_operator_assignment] = STATE(7439),
    [sym_conditional] = STATE(7439),
    [sym_range] = STATE(7439),
    [sym_binary] = STATE(7439),
    [sym_unary] = STATE(7439),
    [sym_left_assignment_list] = STATE(2211),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(2212),
    [sym__variable] = STATE(2174),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(2212),
    [sym_false] = STATE(2212),
    [sym_nil] = STATE(2212),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(7442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10772),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(10647),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(3638),
    [sym__identifier_hash_key2] = ACTIONS(10651),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(13995),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(3644),
    [anon_sym_yield] = ACTIONS(3646),
    [anon_sym_break] = ACTIONS(3648),
    [anon_sym_next] = ACTIONS(3650),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(3652),
    [anon_sym_defined_QMARK] = ACTIONS(3654),
    [anon_sym_not] = ACTIONS(3656),
    [anon_sym_BANG] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3658),
    [sym_constant] = ACTIONS(10653),
    [sym_identifier] = ACTIONS(10653),
    [sym_instance_variable] = ACTIONS(3598),
    [sym_class_variable] = ACTIONS(3598),
    [sym_global_variable] = ACTIONS(3598),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(3600),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(3600),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [10729] = {
    [sym_heredoc_body] = STATE(10727),
    [aux_sym_call_repeat1] = STATE(10727),
    [sym__heredoc_body_start2] = ACTIONS(10855),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_RPAREN] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10730] = {
    [aux_sym_argument_list_repeat1] = STATE(10730),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_RPAREN] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14759),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10731] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11403),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_assignment] = STATE(11403),
    [sym_operator_assignment] = STATE(11403),
    [sym_conditional] = STATE(11403),
    [sym_range] = STATE(11403),
    [sym_binary] = STATE(11403),
    [sym_unary] = STATE(11403),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [10732] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(9549),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(4699),
    [sym_scope_resolution] = STATE(4632),
    [sym_call] = STATE(4632),
    [sym_method_call] = STATE(4699),
    [sym_splat_argument] = STATE(10791),
    [sym_assignment] = STATE(9549),
    [sym_operator_assignment] = STATE(9549),
    [sym_conditional] = STATE(9549),
    [sym_range] = STATE(9549),
    [sym_binary] = STATE(9549),
    [sym_unary] = STATE(9549),
    [sym__arg_or_splat_arg] = STATE(10791),
    [sym_left_assignment_list] = STATE(4698),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(4699),
    [sym__variable] = STATE(4632),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(4699),
    [sym_false] = STATE(4699),
    [sym_nil] = STATE(4699),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(4700),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(3946),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(3950),
    [sym__subshell_start2] = ACTIONS(3952),
    [sym__regex_start2] = ACTIONS(3954),
    [sym__string_array_start2] = ACTIONS(3956),
    [sym__symbol_array_start2] = ACTIONS(3958),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(10649),
    [sym__unary_minus2] = ACTIONS(7280),
    [anon_sym_LBRACE] = ACTIONS(3962),
    [anon_sym_def] = ACTIONS(3964),
    [anon_sym_LPAREN] = ACTIONS(3966),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(3968),
    [anon_sym_module] = ACTIONS(3970),
    [anon_sym_return] = ACTIONS(7282),
    [anon_sym_yield] = ACTIONS(7284),
    [anon_sym_break] = ACTIONS(7286),
    [anon_sym_next] = ACTIONS(7288),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(3980),
    [anon_sym_unless] = ACTIONS(3982),
    [anon_sym_while] = ACTIONS(3984),
    [anon_sym_until] = ACTIONS(3986),
    [anon_sym_for] = ACTIONS(3988),
    [anon_sym_case] = ACTIONS(3990),
    [anon_sym_begin] = ACTIONS(3992),
    [anon_sym_PLUS] = ACTIONS(7290),
    [anon_sym_defined_QMARK] = ACTIONS(7292),
    [anon_sym_not] = ACTIONS(7294),
    [anon_sym_BANG] = ACTIONS(7296),
    [anon_sym_TILDE] = ACTIONS(7296),
    [sym_constant] = ACTIONS(7188),
    [sym_identifier] = ACTIONS(7188),
    [sym_instance_variable] = ACTIONS(7190),
    [sym_class_variable] = ACTIONS(7190),
    [sym_global_variable] = ACTIONS(7190),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(4006),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(7188),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(7188),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(4008),
    [anon_sym_DASH_GT] = ACTIONS(4010),
  },
  [10733] = {
    [aux_sym_exceptions_repeat1] = STATE(11404),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_RPAREN] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14762),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10734] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7312),
    [sym__binary_star2] = ACTIONS(7314),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7316),
    [anon_sym_STAR_STAR] = ACTIONS(7318),
    [anon_sym_AMP] = ACTIONS(7320),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(7322),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7326),
    [anon_sym_DOT_DOT] = ACTIONS(7328),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7330),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7334),
    [anon_sym_AMP_AMP] = ACTIONS(7334),
    [anon_sym_LT_LT] = ACTIONS(7336),
    [anon_sym_GT_GT] = ACTIONS(7336),
    [anon_sym_EQ_EQ] = ACTIONS(7338),
    [anon_sym_BANG_EQ] = ACTIONS(7334),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7334),
    [anon_sym_LT_EQ_GT] = ACTIONS(7334),
    [anon_sym_EQ_TILDE] = ACTIONS(7334),
    [anon_sym_BANG_TILDE] = ACTIONS(7334),
    [anon_sym_LT_EQ] = ACTIONS(7322),
    [anon_sym_GT] = ACTIONS(7322),
    [anon_sym_GT_EQ] = ACTIONS(7340),
    [anon_sym_CARET] = ACTIONS(7342),
    [anon_sym_PLUS] = ACTIONS(7344),
    [anon_sym_SLASH] = ACTIONS(7318),
    [anon_sym_PERCENT] = ACTIONS(7318),
    [sym_comment] = ACTIONS(87),
  },
  [10735] = {
    [aux_sym_exceptions_repeat1] = STATE(10735),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14764),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10736] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7356),
    [sym__binary_star2] = ACTIONS(7358),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7360),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(7362),
    [anon_sym_AMP] = ACTIONS(7364),
    [anon_sym_LT] = ACTIONS(7366),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7368),
    [anon_sym_DOT_DOT] = ACTIONS(7370),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7372),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7374),
    [anon_sym_AMP_AMP] = ACTIONS(7374),
    [anon_sym_LT_LT] = ACTIONS(7376),
    [anon_sym_GT_GT] = ACTIONS(7376),
    [anon_sym_EQ_EQ] = ACTIONS(7378),
    [anon_sym_BANG_EQ] = ACTIONS(7374),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7374),
    [anon_sym_LT_EQ_GT] = ACTIONS(7374),
    [anon_sym_EQ_TILDE] = ACTIONS(7374),
    [anon_sym_BANG_TILDE] = ACTIONS(7374),
    [anon_sym_LT_EQ] = ACTIONS(7366),
    [anon_sym_GT] = ACTIONS(7366),
    [anon_sym_GT_EQ] = ACTIONS(7380),
    [anon_sym_CARET] = ACTIONS(7382),
    [anon_sym_PLUS] = ACTIONS(7384),
    [anon_sym_SLASH] = ACTIONS(7362),
    [anon_sym_PERCENT] = ACTIONS(7362),
    [sym_comment] = ACTIONS(87),
  },
  [10737] = {
    [aux_sym_exceptions_repeat1] = STATE(10737),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14767),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10738] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7415),
    [sym__binary_star2] = ACTIONS(7417),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7419),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(7421),
    [anon_sym_AMP] = ACTIONS(7423),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(7425),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7427),
    [anon_sym_DOT_DOT] = ACTIONS(7429),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7431),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7433),
    [anon_sym_AMP_AMP] = ACTIONS(7433),
    [anon_sym_LT_LT] = ACTIONS(7435),
    [anon_sym_GT_GT] = ACTIONS(7435),
    [anon_sym_EQ_EQ] = ACTIONS(7433),
    [anon_sym_BANG_EQ] = ACTIONS(7437),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7437),
    [anon_sym_LT_EQ_GT] = ACTIONS(7437),
    [anon_sym_EQ_TILDE] = ACTIONS(7437),
    [anon_sym_BANG_TILDE] = ACTIONS(7437),
    [anon_sym_LT_EQ] = ACTIONS(7425),
    [anon_sym_GT] = ACTIONS(7425),
    [anon_sym_GT_EQ] = ACTIONS(7439),
    [anon_sym_CARET] = ACTIONS(7419),
    [anon_sym_PLUS] = ACTIONS(7441),
    [anon_sym_SLASH] = ACTIONS(7421),
    [anon_sym_PERCENT] = ACTIONS(7421),
    [sym_comment] = ACTIONS(87),
  },
  [10739] = {
    [aux_sym_exceptions_repeat1] = STATE(10739),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14770),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10740] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7451),
    [sym__binary_star2] = ACTIONS(7453),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7455),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(7457),
    [anon_sym_AMP] = ACTIONS(7459),
    [anon_sym_LT] = ACTIONS(7461),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7463),
    [anon_sym_DOT_DOT] = ACTIONS(7465),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7467),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7469),
    [anon_sym_AMP_AMP] = ACTIONS(7469),
    [anon_sym_LT_LT] = ACTIONS(7471),
    [anon_sym_GT_GT] = ACTIONS(7471),
    [anon_sym_EQ_EQ] = ACTIONS(7473),
    [anon_sym_BANG_EQ] = ACTIONS(7469),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7469),
    [anon_sym_LT_EQ_GT] = ACTIONS(7469),
    [anon_sym_EQ_TILDE] = ACTIONS(7469),
    [anon_sym_BANG_TILDE] = ACTIONS(7469),
    [anon_sym_LT_EQ] = ACTIONS(7461),
    [anon_sym_GT] = ACTIONS(7461),
    [anon_sym_GT_EQ] = ACTIONS(7475),
    [anon_sym_CARET] = ACTIONS(7477),
    [anon_sym_PLUS] = ACTIONS(7479),
    [anon_sym_SLASH] = ACTIONS(7457),
    [anon_sym_PERCENT] = ACTIONS(7457),
    [sym_comment] = ACTIONS(87),
  },
  [10741] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7533),
    [sym__binary_star2] = ACTIONS(7535),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7537),
    [anon_sym_STAR_STAR] = ACTIONS(7539),
    [anon_sym_AMP] = ACTIONS(7541),
    [anon_sym_LT] = ACTIONS(7543),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7545),
    [anon_sym_DOT_DOT] = ACTIONS(7547),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7549),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7553),
    [anon_sym_AMP_AMP] = ACTIONS(7553),
    [anon_sym_LT_LT] = ACTIONS(7555),
    [anon_sym_GT_GT] = ACTIONS(7555),
    [anon_sym_EQ_EQ] = ACTIONS(7557),
    [anon_sym_BANG_EQ] = ACTIONS(7553),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7553),
    [anon_sym_LT_EQ_GT] = ACTIONS(7553),
    [anon_sym_EQ_TILDE] = ACTIONS(7553),
    [anon_sym_BANG_TILDE] = ACTIONS(7553),
    [anon_sym_LT_EQ] = ACTIONS(7543),
    [anon_sym_GT] = ACTIONS(7543),
    [anon_sym_GT_EQ] = ACTIONS(7559),
    [anon_sym_CARET] = ACTIONS(7561),
    [anon_sym_PLUS] = ACTIONS(7563),
    [anon_sym_SLASH] = ACTIONS(7539),
    [anon_sym_PERCENT] = ACTIONS(7539),
    [sym_comment] = ACTIONS(87),
  },
  [10742] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10743] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10744] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10745] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10746] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10747] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10748] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14773),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10749] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10750] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10751] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10752] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10753] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10754] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10755] = {
    [aux_sym_exceptions_repeat1] = STATE(11407),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10756] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [10757] = {
    [sym_string] = STATE(10757),
    [aux_sym_chained_string_repeat1] = STATE(10757),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10758] = {
    [aux_sym_exceptions_repeat1] = STATE(10758),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14775),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10759] = {
    [anon_sym_DOT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [sym_comment] = ACTIONS(87),
  },
  [10760] = {
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14626),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14626),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_EQ] = ACTIONS(14626),
    [anon_sym_in] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [10761] = {
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_STAR_STAR] = ACTIONS(10127),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10127),
    [anon_sym_AMP_AMP] = ACTIONS(10127),
    [anon_sym_LT_LT] = ACTIONS(10127),
    [anon_sym_GT_GT] = ACTIONS(10127),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10127),
    [anon_sym_PLUS] = ACTIONS(10127),
    [anon_sym_SLASH] = ACTIONS(10127),
    [anon_sym_PERCENT] = ACTIONS(10127),
    [sym_comment] = ACTIONS(87),
  },
  [10762] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14778),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10763] = {
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_STAR_STAR] = ACTIONS(10133),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10133),
    [anon_sym_AMP_AMP] = ACTIONS(10133),
    [anon_sym_LT_LT] = ACTIONS(10133),
    [anon_sym_GT_GT] = ACTIONS(10133),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10133),
    [anon_sym_PLUS] = ACTIONS(10133),
    [anon_sym_SLASH] = ACTIONS(10133),
    [anon_sym_PERCENT] = ACTIONS(10133),
    [sym_comment] = ACTIONS(87),
  },
  [10764] = {
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_STAR_STAR] = ACTIONS(10137),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10137),
    [anon_sym_AMP_AMP] = ACTIONS(10137),
    [anon_sym_LT_LT] = ACTIONS(10137),
    [anon_sym_GT_GT] = ACTIONS(10137),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10137),
    [anon_sym_PLUS] = ACTIONS(10137),
    [anon_sym_SLASH] = ACTIONS(10137),
    [anon_sym_PERCENT] = ACTIONS(10137),
    [sym_comment] = ACTIONS(87),
  },
  [10765] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(14780),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [10766] = {
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_STAR_STAR] = ACTIONS(10143),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10143),
    [anon_sym_AMP_AMP] = ACTIONS(10143),
    [anon_sym_LT_LT] = ACTIONS(10143),
    [anon_sym_GT_GT] = ACTIONS(10143),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10143),
    [anon_sym_PLUS] = ACTIONS(10143),
    [anon_sym_SLASH] = ACTIONS(10143),
    [anon_sym_PERCENT] = ACTIONS(10143),
    [sym_comment] = ACTIONS(87),
  },
  [10767] = {
    [sym__method_rest] = STATE(11410),
    [sym_operator] = STATE(4976),
    [sym__method_name] = STATE(4976),
    [sym_setter] = STATE(4976),
    [sym_symbol] = STATE(4976),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(12760),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(12760),
    [sym_class_variable] = ACTIONS(12760),
    [sym_global_variable] = ACTIONS(12760),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [10768] = {
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_STAR_STAR] = ACTIONS(10896),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10896),
    [anon_sym_AMP_AMP] = ACTIONS(10896),
    [anon_sym_LT_LT] = ACTIONS(10896),
    [anon_sym_GT_GT] = ACTIONS(10896),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10896),
    [anon_sym_PLUS] = ACTIONS(10896),
    [anon_sym_SLASH] = ACTIONS(10896),
    [anon_sym_PERCENT] = ACTIONS(10896),
    [sym_comment] = ACTIONS(87),
  },
  [10769] = {
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_STAR_STAR] = ACTIONS(10900),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10900),
    [anon_sym_AMP_AMP] = ACTIONS(10900),
    [anon_sym_LT_LT] = ACTIONS(10900),
    [anon_sym_GT_GT] = ACTIONS(10900),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10900),
    [anon_sym_PLUS] = ACTIONS(10900),
    [anon_sym_SLASH] = ACTIONS(10900),
    [anon_sym_PERCENT] = ACTIONS(10900),
    [sym_comment] = ACTIONS(87),
  },
  [10770] = {
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym__binary_minus2] = ACTIONS(10934),
    [sym__binary_star2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_RPAREN] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10936),
    [anon_sym_COMMA] = ACTIONS(10934),
    [anon_sym_PIPE] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10934),
    [anon_sym_AMP] = ACTIONS(10936),
    [anon_sym_EQ] = ACTIONS(10936),
    [anon_sym_LT] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_QMARK] = ACTIONS(10934),
    [anon_sym_DOT_DOT] = ACTIONS(10936),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10934),
    [anon_sym_and] = ACTIONS(10934),
    [anon_sym_or] = ACTIONS(10934),
    [anon_sym_PIPE_PIPE] = ACTIONS(10934),
    [anon_sym_AMP_AMP] = ACTIONS(10934),
    [anon_sym_LT_LT] = ACTIONS(10934),
    [anon_sym_GT_GT] = ACTIONS(10934),
    [anon_sym_EQ_EQ] = ACTIONS(10936),
    [anon_sym_BANG_EQ] = ACTIONS(10934),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10934),
    [anon_sym_LT_EQ_GT] = ACTIONS(10934),
    [anon_sym_EQ_TILDE] = ACTIONS(10934),
    [anon_sym_BANG_TILDE] = ACTIONS(10934),
    [anon_sym_LT_EQ] = ACTIONS(10936),
    [anon_sym_GT] = ACTIONS(10936),
    [anon_sym_GT_EQ] = ACTIONS(10934),
    [anon_sym_CARET] = ACTIONS(10934),
    [anon_sym_PLUS] = ACTIONS(10934),
    [anon_sym_SLASH] = ACTIONS(10934),
    [anon_sym_PERCENT] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
  },
  [10771] = {
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [sym__binary_minus2] = ACTIONS(6739),
    [sym__binary_star2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_RPAREN] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(8705),
    [anon_sym_COMMA] = ACTIONS(6739),
    [anon_sym_PIPE] = ACTIONS(8705),
    [anon_sym_STAR_STAR] = ACTIONS(6739),
    [anon_sym_AMP] = ACTIONS(8705),
    [anon_sym_EQ] = ACTIONS(8705),
    [anon_sym_LT] = ACTIONS(8705),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [anon_sym_QMARK] = ACTIONS(6739),
    [anon_sym_DOT_DOT] = ACTIONS(8705),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6739),
    [anon_sym_and] = ACTIONS(6739),
    [anon_sym_or] = ACTIONS(6739),
    [anon_sym_PIPE_PIPE] = ACTIONS(6739),
    [anon_sym_AMP_AMP] = ACTIONS(6739),
    [anon_sym_LT_LT] = ACTIONS(6739),
    [anon_sym_GT_GT] = ACTIONS(6739),
    [anon_sym_EQ_EQ] = ACTIONS(8705),
    [anon_sym_BANG_EQ] = ACTIONS(6739),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6739),
    [anon_sym_LT_EQ_GT] = ACTIONS(6739),
    [anon_sym_EQ_TILDE] = ACTIONS(6739),
    [anon_sym_BANG_TILDE] = ACTIONS(6739),
    [anon_sym_LT_EQ] = ACTIONS(8705),
    [anon_sym_GT] = ACTIONS(8705),
    [anon_sym_GT_EQ] = ACTIONS(6739),
    [anon_sym_CARET] = ACTIONS(6739),
    [anon_sym_PLUS] = ACTIONS(6739),
    [anon_sym_SLASH] = ACTIONS(6739),
    [anon_sym_PERCENT] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [10772] = {
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [sym__binary_minus2] = ACTIONS(10962),
    [sym__binary_star2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_RPAREN] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10964),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_PIPE] = ACTIONS(10964),
    [anon_sym_STAR_STAR] = ACTIONS(10962),
    [anon_sym_AMP] = ACTIONS(10964),
    [anon_sym_EQ] = ACTIONS(10964),
    [anon_sym_LT] = ACTIONS(10964),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [anon_sym_QMARK] = ACTIONS(10962),
    [anon_sym_DOT_DOT] = ACTIONS(10964),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10962),
    [anon_sym_and] = ACTIONS(10962),
    [anon_sym_or] = ACTIONS(10962),
    [anon_sym_PIPE_PIPE] = ACTIONS(10962),
    [anon_sym_AMP_AMP] = ACTIONS(10962),
    [anon_sym_LT_LT] = ACTIONS(10962),
    [anon_sym_GT_GT] = ACTIONS(10962),
    [anon_sym_EQ_EQ] = ACTIONS(10964),
    [anon_sym_BANG_EQ] = ACTIONS(10962),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10962),
    [anon_sym_LT_EQ_GT] = ACTIONS(10962),
    [anon_sym_EQ_TILDE] = ACTIONS(10962),
    [anon_sym_BANG_TILDE] = ACTIONS(10962),
    [anon_sym_LT_EQ] = ACTIONS(10964),
    [anon_sym_GT] = ACTIONS(10964),
    [anon_sym_GT_EQ] = ACTIONS(10962),
    [anon_sym_CARET] = ACTIONS(10962),
    [anon_sym_PLUS] = ACTIONS(10962),
    [anon_sym_SLASH] = ACTIONS(10962),
    [anon_sym_PERCENT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [10773] = {
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_STAR_STAR] = ACTIONS(11061),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11061),
    [anon_sym_AMP_AMP] = ACTIONS(11061),
    [anon_sym_LT_LT] = ACTIONS(11061),
    [anon_sym_GT_GT] = ACTIONS(11061),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11061),
    [anon_sym_PLUS] = ACTIONS(11061),
    [anon_sym_SLASH] = ACTIONS(11061),
    [anon_sym_PERCENT] = ACTIONS(11061),
    [sym_comment] = ACTIONS(87),
  },
  [10774] = {
    [anon_sym_end] = ACTIONS(14782),
    [sym_comment] = ACTIONS(87),
  },
  [10775] = {
    [sym_elsif] = STATE(11412),
    [sym_else] = STATE(11412),
    [sym__if_tail] = STATE(11412),
    [anon_sym_end] = ACTIONS(14782),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [10776] = {
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_STAR_STAR] = ACTIONS(11236),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11236),
    [anon_sym_AMP_AMP] = ACTIONS(11236),
    [anon_sym_LT_LT] = ACTIONS(11236),
    [anon_sym_GT_GT] = ACTIONS(11236),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11236),
    [anon_sym_PLUS] = ACTIONS(11236),
    [anon_sym_SLASH] = ACTIONS(11236),
    [anon_sym_PERCENT] = ACTIONS(11236),
    [sym_comment] = ACTIONS(87),
  },
  [10777] = {
    [anon_sym_end] = ACTIONS(14784),
    [sym_comment] = ACTIONS(87),
  },
  [10778] = {
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_STAR_STAR] = ACTIONS(11333),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11333),
    [anon_sym_AMP_AMP] = ACTIONS(11333),
    [anon_sym_LT_LT] = ACTIONS(11333),
    [anon_sym_GT_GT] = ACTIONS(11333),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11333),
    [anon_sym_PLUS] = ACTIONS(11333),
    [anon_sym_SLASH] = ACTIONS(11333),
    [anon_sym_PERCENT] = ACTIONS(11333),
    [sym_comment] = ACTIONS(87),
  },
  [10779] = {
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_STAR_STAR] = ACTIONS(11342),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11342),
    [anon_sym_AMP_AMP] = ACTIONS(11342),
    [anon_sym_LT_LT] = ACTIONS(11342),
    [anon_sym_GT_GT] = ACTIONS(11342),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11342),
    [anon_sym_PLUS] = ACTIONS(11342),
    [anon_sym_SLASH] = ACTIONS(11342),
    [anon_sym_PERCENT] = ACTIONS(11342),
    [sym_comment] = ACTIONS(87),
  },
  [10780] = {
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_STAR_STAR] = ACTIONS(11393),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11393),
    [anon_sym_AMP_AMP] = ACTIONS(11393),
    [anon_sym_LT_LT] = ACTIONS(11393),
    [anon_sym_GT_GT] = ACTIONS(11393),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11393),
    [anon_sym_PLUS] = ACTIONS(11393),
    [anon_sym_SLASH] = ACTIONS(11393),
    [anon_sym_PERCENT] = ACTIONS(11393),
    [sym_comment] = ACTIONS(87),
  },
  [10781] = {
    [anon_sym_end] = ACTIONS(14786),
    [sym_comment] = ACTIONS(87),
  },
  [10782] = {
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_STAR_STAR] = ACTIONS(11406),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11406),
    [anon_sym_AMP_AMP] = ACTIONS(11406),
    [anon_sym_LT_LT] = ACTIONS(11406),
    [anon_sym_GT_GT] = ACTIONS(11406),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11406),
    [anon_sym_PLUS] = ACTIONS(11406),
    [anon_sym_SLASH] = ACTIONS(11406),
    [anon_sym_PERCENT] = ACTIONS(11406),
    [sym_comment] = ACTIONS(87),
  },
  [10783] = {
    [anon_sym_end] = ACTIONS(14788),
    [sym_comment] = ACTIONS(87),
  },
  [10784] = {
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_STAR_STAR] = ACTIONS(11878),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11878),
    [anon_sym_AMP_AMP] = ACTIONS(11878),
    [anon_sym_LT_LT] = ACTIONS(11878),
    [anon_sym_GT_GT] = ACTIONS(11878),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11878),
    [anon_sym_PLUS] = ACTIONS(11878),
    [anon_sym_SLASH] = ACTIONS(11878),
    [anon_sym_PERCENT] = ACTIONS(11878),
    [sym_comment] = ACTIONS(87),
  },
  [10785] = {
    [anon_sym_end] = ACTIONS(14790),
    [sym_comment] = ACTIONS(87),
  },
  [10786] = {
    [sym__heredoc_body_start2] = ACTIONS(12071),
    [sym__binary_minus2] = ACTIONS(12071),
    [sym__binary_star2] = ACTIONS(12071),
    [anon_sym_LBRACE] = ACTIONS(12071),
    [anon_sym_RPAREN] = ACTIONS(12071),
    [anon_sym_DOT] = ACTIONS(12073),
    [anon_sym_COMMA] = ACTIONS(12071),
    [anon_sym_PIPE] = ACTIONS(12073),
    [anon_sym_STAR_STAR] = ACTIONS(12071),
    [anon_sym_AMP] = ACTIONS(12073),
    [anon_sym_EQ] = ACTIONS(12073),
    [anon_sym_LT] = ACTIONS(12073),
    [anon_sym_do] = ACTIONS(12071),
    [anon_sym_LBRACK] = ACTIONS(12071),
    [anon_sym_COLON_COLON2] = ACTIONS(12071),
    [anon_sym_AMP_DOT] = ACTIONS(12071),
    [anon_sym_QMARK] = ACTIONS(12071),
    [anon_sym_DOT_DOT] = ACTIONS(12073),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12071),
    [anon_sym_and] = ACTIONS(12071),
    [anon_sym_or] = ACTIONS(12071),
    [anon_sym_PIPE_PIPE] = ACTIONS(12071),
    [anon_sym_AMP_AMP] = ACTIONS(12071),
    [anon_sym_LT_LT] = ACTIONS(12071),
    [anon_sym_GT_GT] = ACTIONS(12071),
    [anon_sym_EQ_EQ] = ACTIONS(12073),
    [anon_sym_BANG_EQ] = ACTIONS(12071),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12071),
    [anon_sym_LT_EQ_GT] = ACTIONS(12071),
    [anon_sym_EQ_TILDE] = ACTIONS(12071),
    [anon_sym_BANG_TILDE] = ACTIONS(12071),
    [anon_sym_LT_EQ] = ACTIONS(12073),
    [anon_sym_GT] = ACTIONS(12073),
    [anon_sym_GT_EQ] = ACTIONS(12071),
    [anon_sym_CARET] = ACTIONS(12071),
    [anon_sym_PLUS] = ACTIONS(12071),
    [anon_sym_SLASH] = ACTIONS(12071),
    [anon_sym_PERCENT] = ACTIONS(12071),
    [sym_comment] = ACTIONS(87),
  },
  [10787] = {
    [sym__heredoc_body_start2] = ACTIONS(12096),
    [sym__binary_minus2] = ACTIONS(12096),
    [sym__binary_star2] = ACTIONS(12096),
    [anon_sym_LBRACE] = ACTIONS(12096),
    [anon_sym_RPAREN] = ACTIONS(12096),
    [anon_sym_DOT] = ACTIONS(12098),
    [anon_sym_COMMA] = ACTIONS(12096),
    [anon_sym_PIPE] = ACTIONS(12098),
    [anon_sym_STAR_STAR] = ACTIONS(12096),
    [anon_sym_AMP] = ACTIONS(12098),
    [anon_sym_EQ] = ACTIONS(12098),
    [anon_sym_LT] = ACTIONS(12098),
    [anon_sym_do] = ACTIONS(12096),
    [anon_sym_LBRACK] = ACTIONS(12096),
    [anon_sym_COLON_COLON2] = ACTIONS(12096),
    [anon_sym_AMP_DOT] = ACTIONS(12096),
    [anon_sym_QMARK] = ACTIONS(12096),
    [anon_sym_DOT_DOT] = ACTIONS(12098),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12096),
    [anon_sym_and] = ACTIONS(12096),
    [anon_sym_or] = ACTIONS(12096),
    [anon_sym_PIPE_PIPE] = ACTIONS(12096),
    [anon_sym_AMP_AMP] = ACTIONS(12096),
    [anon_sym_LT_LT] = ACTIONS(12096),
    [anon_sym_GT_GT] = ACTIONS(12096),
    [anon_sym_EQ_EQ] = ACTIONS(12098),
    [anon_sym_BANG_EQ] = ACTIONS(12096),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12096),
    [anon_sym_LT_EQ_GT] = ACTIONS(12096),
    [anon_sym_EQ_TILDE] = ACTIONS(12096),
    [anon_sym_BANG_TILDE] = ACTIONS(12096),
    [anon_sym_LT_EQ] = ACTIONS(12098),
    [anon_sym_GT] = ACTIONS(12098),
    [anon_sym_GT_EQ] = ACTIONS(12096),
    [anon_sym_CARET] = ACTIONS(12096),
    [anon_sym_PLUS] = ACTIONS(12096),
    [anon_sym_SLASH] = ACTIONS(12096),
    [anon_sym_PERCENT] = ACTIONS(12096),
    [sym_comment] = ACTIONS(87),
  },
  [10788] = {
    [anon_sym_end] = ACTIONS(14792),
    [sym_comment] = ACTIONS(87),
  },
  [10789] = {
    [sym__statements] = STATE(11418),
    [sym__top_level_statement] = STATE(1254),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(1255),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(1256),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(1259),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(1259),
    [sym_assignment] = STATE(1256),
    [sym_operator_assignment] = STATE(1256),
    [sym_conditional] = STATE(1256),
    [sym_range] = STATE(1256),
    [sym_binary] = STATE(1256),
    [sym_unary] = STATE(1256),
    [sym_left_assignment_list] = STATE(1258),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1259),
    [sym__variable] = STATE(1257),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(1259),
    [sym_false] = STATE(1259),
    [sym_nil] = STATE(1259),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(1260),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(2171),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(14794),
    [anon_sym_return] = ACTIONS(2175),
    [anon_sym_yield] = ACTIONS(2177),
    [anon_sym_break] = ACTIONS(2179),
    [anon_sym_next] = ACTIONS(2181),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(2183),
    [anon_sym_defined_QMARK] = ACTIONS(2185),
    [anon_sym_not] = ACTIONS(2187),
    [anon_sym_BANG] = ACTIONS(2189),
    [anon_sym_TILDE] = ACTIONS(2189),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [anon_sym_undef] = ACTIONS(2195),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10790] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7673),
    [sym__binary_star2] = ACTIONS(7675),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7677),
    [anon_sym_STAR_STAR] = ACTIONS(7679),
    [anon_sym_AMP] = ACTIONS(7681),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(7683),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7685),
    [anon_sym_DOT_DOT] = ACTIONS(7687),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7689),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7693),
    [anon_sym_AMP_AMP] = ACTIONS(7693),
    [anon_sym_LT_LT] = ACTIONS(7695),
    [anon_sym_GT_GT] = ACTIONS(7695),
    [anon_sym_EQ_EQ] = ACTIONS(7697),
    [anon_sym_BANG_EQ] = ACTIONS(7693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7693),
    [anon_sym_LT_EQ_GT] = ACTIONS(7693),
    [anon_sym_EQ_TILDE] = ACTIONS(7693),
    [anon_sym_BANG_TILDE] = ACTIONS(7693),
    [anon_sym_LT_EQ] = ACTIONS(7683),
    [anon_sym_GT] = ACTIONS(7683),
    [anon_sym_GT_EQ] = ACTIONS(7699),
    [anon_sym_CARET] = ACTIONS(7701),
    [anon_sym_PLUS] = ACTIONS(7703),
    [anon_sym_SLASH] = ACTIONS(7679),
    [anon_sym_PERCENT] = ACTIONS(7679),
    [sym_comment] = ACTIONS(87),
  },
  [10791] = {
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10792] = {
    [aux_sym_exceptions_repeat1] = STATE(10792),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14796),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10793] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7742),
    [sym__binary_star2] = ACTIONS(7744),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7746),
    [anon_sym_STAR_STAR] = ACTIONS(7748),
    [anon_sym_AMP] = ACTIONS(7750),
    [anon_sym_LT] = ACTIONS(7752),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7754),
    [anon_sym_DOT_DOT] = ACTIONS(7756),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7758),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7762),
    [anon_sym_AMP_AMP] = ACTIONS(7762),
    [anon_sym_LT_LT] = ACTIONS(7764),
    [anon_sym_GT_GT] = ACTIONS(7764),
    [anon_sym_EQ_EQ] = ACTIONS(7766),
    [anon_sym_BANG_EQ] = ACTIONS(7762),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7762),
    [anon_sym_LT_EQ_GT] = ACTIONS(7762),
    [anon_sym_EQ_TILDE] = ACTIONS(7762),
    [anon_sym_BANG_TILDE] = ACTIONS(7762),
    [anon_sym_LT_EQ] = ACTIONS(7752),
    [anon_sym_GT] = ACTIONS(7752),
    [anon_sym_GT_EQ] = ACTIONS(7768),
    [anon_sym_CARET] = ACTIONS(7770),
    [anon_sym_PLUS] = ACTIONS(7772),
    [anon_sym_SLASH] = ACTIONS(7748),
    [anon_sym_PERCENT] = ACTIONS(7748),
    [sym_comment] = ACTIONS(87),
  },
  [10794] = {
    [aux_sym_exceptions_repeat1] = STATE(10794),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14799),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10795] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7796),
    [sym__binary_star2] = ACTIONS(7798),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7800),
    [anon_sym_STAR_STAR] = ACTIONS(7802),
    [anon_sym_AMP] = ACTIONS(7804),
    [anon_sym_LT] = ACTIONS(7806),
    [anon_sym_QMARK] = ACTIONS(7808),
    [anon_sym_DOT_DOT] = ACTIONS(7810),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7812),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7816),
    [anon_sym_AMP_AMP] = ACTIONS(7816),
    [anon_sym_LT_LT] = ACTIONS(7818),
    [anon_sym_GT_GT] = ACTIONS(7818),
    [anon_sym_EQ_EQ] = ACTIONS(7820),
    [anon_sym_BANG_EQ] = ACTIONS(7816),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7816),
    [anon_sym_LT_EQ_GT] = ACTIONS(7816),
    [anon_sym_EQ_TILDE] = ACTIONS(7816),
    [anon_sym_BANG_TILDE] = ACTIONS(7816),
    [anon_sym_LT_EQ] = ACTIONS(7806),
    [anon_sym_GT] = ACTIONS(7806),
    [anon_sym_GT_EQ] = ACTIONS(7822),
    [anon_sym_CARET] = ACTIONS(7824),
    [anon_sym_PLUS] = ACTIONS(7826),
    [anon_sym_SLASH] = ACTIONS(7802),
    [anon_sym_PERCENT] = ACTIONS(7802),
    [sym_comment] = ACTIONS(87),
  },
  [10796] = {
    [aux_sym_exceptions_repeat1] = STATE(10796),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14802),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10797] = {
    [sym__line_break2] = ACTIONS(14626),
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [ts_builtin_sym_end] = ACTIONS(14626),
    [anon_sym___END__] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_end] = ACTIONS(14626),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_when] = ACTIONS(14626),
    [anon_sym_elsif] = ACTIONS(14626),
    [anon_sym_else] = ACTIONS(14626),
    [anon_sym_then] = ACTIONS(14626),
    [anon_sym_ensure] = ACTIONS(14626),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [10798] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(7914),
    [sym__binary_star2] = ACTIONS(7916),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(7918),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(7920),
    [anon_sym_AMP] = ACTIONS(7922),
    [anon_sym_LT] = ACTIONS(7924),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(7926),
    [anon_sym_DOT_DOT] = ACTIONS(7928),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7930),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(7932),
    [anon_sym_AMP_AMP] = ACTIONS(7932),
    [anon_sym_LT_LT] = ACTIONS(7934),
    [anon_sym_GT_GT] = ACTIONS(7934),
    [anon_sym_EQ_EQ] = ACTIONS(7936),
    [anon_sym_BANG_EQ] = ACTIONS(7932),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7932),
    [anon_sym_LT_EQ_GT] = ACTIONS(7932),
    [anon_sym_EQ_TILDE] = ACTIONS(7932),
    [anon_sym_BANG_TILDE] = ACTIONS(7932),
    [anon_sym_LT_EQ] = ACTIONS(7924),
    [anon_sym_GT] = ACTIONS(7924),
    [anon_sym_GT_EQ] = ACTIONS(7938),
    [anon_sym_CARET] = ACTIONS(7940),
    [anon_sym_PLUS] = ACTIONS(7942),
    [anon_sym_SLASH] = ACTIONS(7920),
    [anon_sym_PERCENT] = ACTIONS(7920),
    [sym_comment] = ACTIONS(87),
  },
  [10799] = {
    [aux_sym_exceptions_repeat1] = STATE(10799),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14805),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10800] = {
    [sym_heredoc_body] = STATE(11419),
    [aux_sym_call_repeat1] = STATE(11419),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10801] = {
    [sym_heredoc_body] = STATE(11420),
    [aux_sym_call_repeat1] = STATE(11420),
    [aux_sym_argument_list_repeat1] = STATE(9765),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11049),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_elsif] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10802] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10803] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10804] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10805] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10806] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10807] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10808] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14808),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10809] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10810] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10811] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10812] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10813] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10814] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_elsif] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10815] = {
    [aux_sym_exceptions_repeat1] = STATE(11423),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10816] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [10817] = {
    [sym_string] = STATE(10817),
    [aux_sym_chained_string_repeat1] = STATE(10817),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_elsif] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10818] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_elsif] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [10819] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_elsif] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [10820] = {
    [sym_heredoc_body] = STATE(10820),
    [aux_sym_call_repeat1] = STATE(10820),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_elsif] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10821] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(7864),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(7864),
    [sym_operator_assignment] = STATE(7864),
    [sym_conditional] = STATE(7864),
    [sym_range] = STATE(7864),
    [sym_binary] = STATE(7864),
    [sym_unary] = STATE(7864),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7867),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(10999),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [sym__identifier_hash_key2] = ACTIONS(11003),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14106),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(11005),
    [sym_identifier] = ACTIONS(11005),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10822] = {
    [sym_heredoc_body] = STATE(10820),
    [aux_sym_call_repeat1] = STATE(10820),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_elsif] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10823] = {
    [aux_sym_argument_list_repeat1] = STATE(10823),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14810),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10824] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11424),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_assignment] = STATE(11424),
    [sym_operator_assignment] = STATE(11424),
    [sym_conditional] = STATE(11424),
    [sym_range] = STATE(11424),
    [sym_binary] = STATE(11424),
    [sym_unary] = STATE(11424),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10825] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_elsif] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [10826] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_elsif] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [10827] = {
    [sym_heredoc_body] = STATE(10827),
    [aux_sym_call_repeat1] = STATE(10827),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_elsif] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10828] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(7888),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(7888),
    [sym_operator_assignment] = STATE(7888),
    [sym_conditional] = STATE(7888),
    [sym_range] = STATE(7888),
    [sym_binary] = STATE(7888),
    [sym_unary] = STATE(7888),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7891),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11041),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [sym__identifier_hash_key2] = ACTIONS(11045),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14110),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(11047),
    [sym_identifier] = ACTIONS(11047),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10829] = {
    [sym_heredoc_body] = STATE(10827),
    [aux_sym_call_repeat1] = STATE(10827),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_elsif] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10830] = {
    [aux_sym_argument_list_repeat1] = STATE(10830),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14813),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_elsif] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10831] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9766),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5318),
    [sym_scope_resolution] = STATE(5314),
    [sym_call] = STATE(5314),
    [sym_method_call] = STATE(5318),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(9766),
    [sym_operator_assignment] = STATE(9766),
    [sym_conditional] = STATE(9766),
    [sym_range] = STATE(9766),
    [sym_binary] = STATE(9766),
    [sym_unary] = STATE(9766),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(5317),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5318),
    [sym__variable] = STATE(5314),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5318),
    [sym_false] = STATE(5318),
    [sym_nil] = STATE(5318),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(7856),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11001),
    [sym__unary_minus2] = ACTIONS(7978),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(7982),
    [anon_sym_yield] = ACTIONS(7984),
    [anon_sym_break] = ACTIONS(7986),
    [anon_sym_next] = ACTIONS(7988),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10995),
    [anon_sym_defined_QMARK] = ACTIONS(7990),
    [anon_sym_not] = ACTIONS(7992),
    [anon_sym_BANG] = ACTIONS(7996),
    [anon_sym_TILDE] = ACTIONS(7996),
    [sym_constant] = ACTIONS(8002),
    [sym_identifier] = ACTIONS(8002),
    [sym_instance_variable] = ACTIONS(8000),
    [sym_class_variable] = ACTIONS(8000),
    [sym_global_variable] = ACTIONS(8000),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8002),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8002),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10832] = {
    [aux_sym_exceptions_repeat1] = STATE(11425),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14816),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_elsif] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10833] = {
    [anon_sym_end] = ACTIONS(14818),
    [sym_comment] = ACTIONS(87),
  },
  [10834] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8026),
    [sym__binary_star2] = ACTIONS(8028),
    [anon_sym_PIPE] = ACTIONS(8030),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8032),
    [anon_sym_AMP] = ACTIONS(8034),
    [anon_sym_LT] = ACTIONS(8036),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8038),
    [anon_sym_DOT_DOT] = ACTIONS(8040),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8042),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8046),
    [anon_sym_AMP_AMP] = ACTIONS(8046),
    [anon_sym_LT_LT] = ACTIONS(8048),
    [anon_sym_GT_GT] = ACTIONS(8048),
    [anon_sym_EQ_EQ] = ACTIONS(8050),
    [anon_sym_BANG_EQ] = ACTIONS(8046),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8046),
    [anon_sym_LT_EQ_GT] = ACTIONS(8046),
    [anon_sym_EQ_TILDE] = ACTIONS(8046),
    [anon_sym_BANG_TILDE] = ACTIONS(8046),
    [anon_sym_LT_EQ] = ACTIONS(8036),
    [anon_sym_GT] = ACTIONS(8036),
    [anon_sym_GT_EQ] = ACTIONS(8052),
    [anon_sym_CARET] = ACTIONS(8054),
    [anon_sym_PLUS] = ACTIONS(8056),
    [anon_sym_SLASH] = ACTIONS(8032),
    [anon_sym_PERCENT] = ACTIONS(8032),
    [sym_comment] = ACTIONS(87),
  },
  [10835] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10836] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10837] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10838] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10839] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10840] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10841] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14820),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10842] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10843] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10844] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10845] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10846] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10847] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_elsif] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10848] = {
    [aux_sym_exceptions_repeat1] = STATE(11428),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10849] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [10850] = {
    [sym_string] = STATE(10850),
    [aux_sym_chained_string_repeat1] = STATE(10850),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_elsif] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10851] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11429),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_assignment] = STATE(11429),
    [sym_operator_assignment] = STATE(11429),
    [sym_conditional] = STATE(11429),
    [sym_range] = STATE(11429),
    [sym_binary] = STATE(11429),
    [sym_unary] = STATE(11429),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10852] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9811),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5364),
    [sym_scope_resolution] = STATE(5360),
    [sym_call] = STATE(5360),
    [sym_method_call] = STATE(5364),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(9811),
    [sym_operator_assignment] = STATE(9811),
    [sym_conditional] = STATE(9811),
    [sym_range] = STATE(9811),
    [sym_binary] = STATE(9811),
    [sym_unary] = STATE(9811),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(5363),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5364),
    [sym__variable] = STATE(5360),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5364),
    [sym_false] = STATE(5364),
    [sym_nil] = STATE(5364),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(7935),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(11043),
    [sym__unary_minus2] = ACTIONS(8062),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8066),
    [anon_sym_yield] = ACTIONS(8068),
    [anon_sym_break] = ACTIONS(8070),
    [anon_sym_next] = ACTIONS(8072),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11091),
    [anon_sym_defined_QMARK] = ACTIONS(8074),
    [anon_sym_not] = ACTIONS(8076),
    [anon_sym_BANG] = ACTIONS(8080),
    [anon_sym_TILDE] = ACTIONS(8080),
    [sym_constant] = ACTIONS(8086),
    [sym_identifier] = ACTIONS(8086),
    [sym_instance_variable] = ACTIONS(8084),
    [sym_class_variable] = ACTIONS(8084),
    [sym_global_variable] = ACTIONS(8084),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8086),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8086),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10853] = {
    [aux_sym_exceptions_repeat1] = STATE(11430),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14822),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_elsif] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10854] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_elsif] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10855] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_elsif] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10856] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10857] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10858] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10859] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10860] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14824),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10861] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_elsif] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10862] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10863] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10864] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10865] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_elsif] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10866] = {
    [aux_sym_exceptions_repeat1] = STATE(10866),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14826),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10867] = {
    [aux_sym_exceptions_repeat1] = STATE(9832),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_elsif] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10868] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_elsif] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [10869] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8102),
    [sym__binary_star2] = ACTIONS(8104),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8106),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8108),
    [anon_sym_AMP] = ACTIONS(8110),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(8112),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8114),
    [anon_sym_DOT_DOT] = ACTIONS(8116),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8118),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8120),
    [anon_sym_AMP_AMP] = ACTIONS(8120),
    [anon_sym_LT_LT] = ACTIONS(8122),
    [anon_sym_GT_GT] = ACTIONS(8122),
    [anon_sym_EQ_EQ] = ACTIONS(8120),
    [anon_sym_BANG_EQ] = ACTIONS(8124),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8124),
    [anon_sym_LT_EQ_GT] = ACTIONS(8124),
    [anon_sym_EQ_TILDE] = ACTIONS(8124),
    [anon_sym_BANG_TILDE] = ACTIONS(8124),
    [anon_sym_LT_EQ] = ACTIONS(8112),
    [anon_sym_GT] = ACTIONS(8112),
    [anon_sym_GT_EQ] = ACTIONS(8126),
    [anon_sym_CARET] = ACTIONS(8106),
    [anon_sym_PLUS] = ACTIONS(8128),
    [anon_sym_SLASH] = ACTIONS(8108),
    [anon_sym_PERCENT] = ACTIONS(8108),
    [sym_comment] = ACTIONS(87),
  },
  [10870] = {
    [aux_sym_exceptions_repeat1] = STATE(10870),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14829),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10871] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8138),
    [sym__binary_star2] = ACTIONS(8140),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8142),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8144),
    [anon_sym_AMP] = ACTIONS(8146),
    [anon_sym_LT] = ACTIONS(8148),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8150),
    [anon_sym_DOT_DOT] = ACTIONS(8152),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8154),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8156),
    [anon_sym_AMP_AMP] = ACTIONS(8156),
    [anon_sym_LT_LT] = ACTIONS(8158),
    [anon_sym_GT_GT] = ACTIONS(8158),
    [anon_sym_EQ_EQ] = ACTIONS(8160),
    [anon_sym_BANG_EQ] = ACTIONS(8156),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8156),
    [anon_sym_LT_EQ_GT] = ACTIONS(8156),
    [anon_sym_EQ_TILDE] = ACTIONS(8156),
    [anon_sym_BANG_TILDE] = ACTIONS(8156),
    [anon_sym_LT_EQ] = ACTIONS(8148),
    [anon_sym_GT] = ACTIONS(8148),
    [anon_sym_GT_EQ] = ACTIONS(8162),
    [anon_sym_CARET] = ACTIONS(8164),
    [anon_sym_PLUS] = ACTIONS(8166),
    [anon_sym_SLASH] = ACTIONS(8144),
    [anon_sym_PERCENT] = ACTIONS(8144),
    [sym_comment] = ACTIONS(87),
  },
  [10872] = {
    [sym_heredoc_body] = STATE(11432),
    [aux_sym_call_repeat1] = STATE(11432),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10873] = {
    [sym_heredoc_body] = STATE(11433),
    [aux_sym_call_repeat1] = STATE(11433),
    [aux_sym_argument_list_repeat1] = STATE(9895),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(11226),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [10874] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10875] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10876] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10877] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10878] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10879] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10880] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14832),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10881] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10882] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10883] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10884] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10885] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10886] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10887] = {
    [aux_sym_exceptions_repeat1] = STATE(11436),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10888] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [10889] = {
    [sym_string] = STATE(10889),
    [aux_sym_chained_string_repeat1] = STATE(10889),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [10890] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [10891] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [10892] = {
    [sym_heredoc_body] = STATE(10892),
    [aux_sym_call_repeat1] = STATE(10892),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [10893] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8028),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(8028),
    [sym_operator_assignment] = STATE(8028),
    [sym_conditional] = STATE(8028),
    [sym_range] = STATE(8028),
    [sym_binary] = STATE(8028),
    [sym_unary] = STATE(8028),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8031),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11176),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [sym__identifier_hash_key2] = ACTIONS(11180),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14131),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(11182),
    [sym_identifier] = ACTIONS(11182),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10894] = {
    [sym_heredoc_body] = STATE(10892),
    [aux_sym_call_repeat1] = STATE(10892),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [10895] = {
    [aux_sym_argument_list_repeat1] = STATE(10895),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14834),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [10896] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11437),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_assignment] = STATE(11437),
    [sym_operator_assignment] = STATE(11437),
    [sym_conditional] = STATE(11437),
    [sym_range] = STATE(11437),
    [sym_binary] = STATE(11437),
    [sym_unary] = STATE(11437),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10897] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [10898] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [10899] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [10900] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(8052),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(8052),
    [sym_operator_assignment] = STATE(8052),
    [sym_conditional] = STATE(8052),
    [sym_range] = STATE(8052),
    [sym_binary] = STATE(8052),
    [sym_unary] = STATE(8052),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8055),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(11218),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [sym__identifier_hash_key2] = ACTIONS(11222),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14135),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(11224),
    [sym_identifier] = ACTIONS(11224),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10901] = {
    [sym_heredoc_body] = STATE(10899),
    [aux_sym_call_repeat1] = STATE(10899),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [10902] = {
    [aux_sym_argument_list_repeat1] = STATE(10902),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(14837),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [10903] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(9896),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5450),
    [sym_scope_resolution] = STATE(5446),
    [sym_call] = STATE(5446),
    [sym_method_call] = STATE(5450),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(9896),
    [sym_operator_assignment] = STATE(9896),
    [sym_conditional] = STATE(9896),
    [sym_range] = STATE(9896),
    [sym_binary] = STATE(9896),
    [sym_unary] = STATE(9896),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(5449),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5450),
    [sym__variable] = STATE(5446),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5450),
    [sym_false] = STATE(5450),
    [sym_nil] = STATE(5450),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8020),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11178),
    [sym__unary_minus2] = ACTIONS(8184),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8188),
    [anon_sym_yield] = ACTIONS(8190),
    [anon_sym_break] = ACTIONS(8192),
    [anon_sym_next] = ACTIONS(8194),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11172),
    [anon_sym_defined_QMARK] = ACTIONS(8196),
    [anon_sym_not] = ACTIONS(8198),
    [anon_sym_BANG] = ACTIONS(8202),
    [anon_sym_TILDE] = ACTIONS(8202),
    [sym_constant] = ACTIONS(8208),
    [sym_identifier] = ACTIONS(8208),
    [sym_instance_variable] = ACTIONS(8206),
    [sym_class_variable] = ACTIONS(8206),
    [sym_global_variable] = ACTIONS(8206),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(8208),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8208),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10904] = {
    [aux_sym_exceptions_repeat1] = STATE(11438),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14840),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [10905] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8226),
    [sym__binary_star2] = ACTIONS(8228),
    [anon_sym_PIPE] = ACTIONS(8230),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8232),
    [anon_sym_AMP] = ACTIONS(8234),
    [anon_sym_LT] = ACTIONS(8236),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8238),
    [anon_sym_DOT_DOT] = ACTIONS(8240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8242),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8246),
    [anon_sym_AMP_AMP] = ACTIONS(8246),
    [anon_sym_LT_LT] = ACTIONS(8248),
    [anon_sym_GT_GT] = ACTIONS(8248),
    [anon_sym_EQ_EQ] = ACTIONS(8250),
    [anon_sym_BANG_EQ] = ACTIONS(8246),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8246),
    [anon_sym_LT_EQ_GT] = ACTIONS(8246),
    [anon_sym_EQ_TILDE] = ACTIONS(8246),
    [anon_sym_BANG_TILDE] = ACTIONS(8246),
    [anon_sym_LT_EQ] = ACTIONS(8236),
    [anon_sym_GT] = ACTIONS(8236),
    [anon_sym_GT_EQ] = ACTIONS(8252),
    [anon_sym_CARET] = ACTIONS(8254),
    [anon_sym_PLUS] = ACTIONS(8256),
    [anon_sym_SLASH] = ACTIONS(8232),
    [anon_sym_PERCENT] = ACTIONS(8232),
    [sym_comment] = ACTIONS(87),
  },
  [10906] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10907] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10908] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10909] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10910] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10911] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10912] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14842),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10913] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10914] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10915] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10916] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10917] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10918] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10919] = {
    [aux_sym_exceptions_repeat1] = STATE(11441),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10920] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [10921] = {
    [sym_string] = STATE(10921),
    [aux_sym_chained_string_repeat1] = STATE(10921),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10922] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11442),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_assignment] = STATE(11442),
    [sym_operator_assignment] = STATE(11442),
    [sym_conditional] = STATE(11442),
    [sym_range] = STATE(11442),
    [sym_binary] = STATE(11442),
    [sym_unary] = STATE(11442),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10923] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(9939),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(5494),
    [sym_scope_resolution] = STATE(5490),
    [sym_call] = STATE(5490),
    [sym_method_call] = STATE(5494),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(9939),
    [sym_operator_assignment] = STATE(9939),
    [sym_conditional] = STATE(9939),
    [sym_range] = STATE(9939),
    [sym_binary] = STATE(9939),
    [sym_unary] = STATE(9939),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(5493),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5494),
    [sym__variable] = STATE(5490),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(5494),
    [sym_false] = STATE(5494),
    [sym_nil] = STATE(5494),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(8098),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(11220),
    [sym__unary_minus2] = ACTIONS(8262),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(8266),
    [anon_sym_yield] = ACTIONS(8268),
    [anon_sym_break] = ACTIONS(8270),
    [anon_sym_next] = ACTIONS(8272),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(11266),
    [anon_sym_defined_QMARK] = ACTIONS(8274),
    [anon_sym_not] = ACTIONS(8276),
    [anon_sym_BANG] = ACTIONS(8280),
    [anon_sym_TILDE] = ACTIONS(8280),
    [sym_constant] = ACTIONS(8286),
    [sym_identifier] = ACTIONS(8286),
    [sym_instance_variable] = ACTIONS(8284),
    [sym_class_variable] = ACTIONS(8284),
    [sym_global_variable] = ACTIONS(8284),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(8286),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(8286),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [10924] = {
    [aux_sym_exceptions_repeat1] = STATE(11443),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(14844),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [10925] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10926] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10927] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10928] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10929] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10930] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10931] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14846),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10932] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10933] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10934] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10935] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10936] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10937] = {
    [aux_sym_exceptions_repeat1] = STATE(10937),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(14848),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10938] = {
    [aux_sym_exceptions_repeat1] = STATE(9960),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10939] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [10940] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8294),
    [sym__binary_star2] = ACTIONS(8296),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8298),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8300),
    [anon_sym_AMP] = ACTIONS(8302),
    [anon_sym_LT] = ACTIONS(8304),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8306),
    [anon_sym_DOT_DOT] = ACTIONS(8308),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8310),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8312),
    [anon_sym_AMP_AMP] = ACTIONS(8312),
    [anon_sym_LT_LT] = ACTIONS(8314),
    [anon_sym_GT_GT] = ACTIONS(8314),
    [anon_sym_EQ_EQ] = ACTIONS(8316),
    [anon_sym_BANG_EQ] = ACTIONS(8312),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8312),
    [anon_sym_LT_EQ_GT] = ACTIONS(8312),
    [anon_sym_EQ_TILDE] = ACTIONS(8312),
    [anon_sym_BANG_TILDE] = ACTIONS(8312),
    [anon_sym_LT_EQ] = ACTIONS(8304),
    [anon_sym_GT] = ACTIONS(8304),
    [anon_sym_GT_EQ] = ACTIONS(8318),
    [anon_sym_CARET] = ACTIONS(8320),
    [anon_sym_PLUS] = ACTIONS(8322),
    [anon_sym_SLASH] = ACTIONS(8300),
    [anon_sym_PERCENT] = ACTIONS(8300),
    [sym_comment] = ACTIONS(87),
  },
  [10941] = {
    [aux_sym_exceptions_repeat1] = STATE(10941),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14851),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10942] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8358),
    [sym__binary_star2] = ACTIONS(8360),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8362),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8364),
    [anon_sym_AMP] = ACTIONS(8366),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(8368),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8370),
    [anon_sym_DOT_DOT] = ACTIONS(8372),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8374),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8376),
    [anon_sym_AMP_AMP] = ACTIONS(8376),
    [anon_sym_LT_LT] = ACTIONS(8378),
    [anon_sym_GT_GT] = ACTIONS(8378),
    [anon_sym_EQ_EQ] = ACTIONS(8376),
    [anon_sym_BANG_EQ] = ACTIONS(8380),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8380),
    [anon_sym_LT_EQ_GT] = ACTIONS(8380),
    [anon_sym_EQ_TILDE] = ACTIONS(8380),
    [anon_sym_BANG_TILDE] = ACTIONS(8380),
    [anon_sym_LT_EQ] = ACTIONS(8368),
    [anon_sym_GT] = ACTIONS(8368),
    [anon_sym_GT_EQ] = ACTIONS(8382),
    [anon_sym_CARET] = ACTIONS(8362),
    [anon_sym_PLUS] = ACTIONS(8384),
    [anon_sym_SLASH] = ACTIONS(8364),
    [anon_sym_PERCENT] = ACTIONS(8364),
    [sym_comment] = ACTIONS(87),
  },
  [10943] = {
    [aux_sym_exceptions_repeat1] = STATE(10943),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14854),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10944] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8394),
    [sym__binary_star2] = ACTIONS(8396),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8398),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8400),
    [anon_sym_AMP] = ACTIONS(8402),
    [anon_sym_LT] = ACTIONS(8404),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8406),
    [anon_sym_DOT_DOT] = ACTIONS(8408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8410),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8412),
    [anon_sym_AMP_AMP] = ACTIONS(8412),
    [anon_sym_LT_LT] = ACTIONS(8414),
    [anon_sym_GT_GT] = ACTIONS(8414),
    [anon_sym_EQ_EQ] = ACTIONS(8416),
    [anon_sym_BANG_EQ] = ACTIONS(8412),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8412),
    [anon_sym_LT_EQ_GT] = ACTIONS(8412),
    [anon_sym_EQ_TILDE] = ACTIONS(8412),
    [anon_sym_BANG_TILDE] = ACTIONS(8412),
    [anon_sym_LT_EQ] = ACTIONS(8404),
    [anon_sym_GT] = ACTIONS(8404),
    [anon_sym_GT_EQ] = ACTIONS(8418),
    [anon_sym_CARET] = ACTIONS(8420),
    [anon_sym_PLUS] = ACTIONS(8422),
    [anon_sym_SLASH] = ACTIONS(8400),
    [anon_sym_PERCENT] = ACTIONS(8400),
    [sym_comment] = ACTIONS(87),
  },
  [10945] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8446),
    [sym__binary_star2] = ACTIONS(8448),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8450),
    [anon_sym_STAR_STAR] = ACTIONS(8452),
    [anon_sym_AMP] = ACTIONS(8454),
    [anon_sym_LT] = ACTIONS(8456),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8458),
    [anon_sym_DOT_DOT] = ACTIONS(8460),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8462),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8466),
    [anon_sym_AMP_AMP] = ACTIONS(8466),
    [anon_sym_LT_LT] = ACTIONS(8468),
    [anon_sym_GT_GT] = ACTIONS(8468),
    [anon_sym_EQ_EQ] = ACTIONS(8470),
    [anon_sym_BANG_EQ] = ACTIONS(8466),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8466),
    [anon_sym_LT_EQ_GT] = ACTIONS(8466),
    [anon_sym_EQ_TILDE] = ACTIONS(8466),
    [anon_sym_BANG_TILDE] = ACTIONS(8466),
    [anon_sym_LT_EQ] = ACTIONS(8456),
    [anon_sym_GT] = ACTIONS(8456),
    [anon_sym_GT_EQ] = ACTIONS(8472),
    [anon_sym_CARET] = ACTIONS(8474),
    [anon_sym_PLUS] = ACTIONS(8476),
    [anon_sym_SLASH] = ACTIONS(8452),
    [anon_sym_PERCENT] = ACTIONS(8452),
    [sym_comment] = ACTIONS(87),
  },
  [10946] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_in] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10947] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_in] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [10948] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10949] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [10950] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10951] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10952] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14857),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10953] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10954] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10955] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10956] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10957] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_in] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10958] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10959] = {
    [aux_sym_exceptions_repeat1] = STATE(11447),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_in] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [10960] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [10961] = {
    [sym_string] = STATE(10961),
    [aux_sym_chained_string_repeat1] = STATE(10961),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_in] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [10962] = {
    [aux_sym_exceptions_repeat1] = STATE(10962),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14859),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10963] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8506),
    [sym__binary_star2] = ACTIONS(8508),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8510),
    [anon_sym_STAR_STAR] = ACTIONS(8512),
    [anon_sym_AMP] = ACTIONS(8514),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(8516),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8518),
    [anon_sym_DOT_DOT] = ACTIONS(8520),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8522),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8524),
    [anon_sym_AMP_AMP] = ACTIONS(8524),
    [anon_sym_LT_LT] = ACTIONS(8526),
    [anon_sym_GT_GT] = ACTIONS(8526),
    [anon_sym_EQ_EQ] = ACTIONS(8524),
    [anon_sym_BANG_EQ] = ACTIONS(8528),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8528),
    [anon_sym_LT_EQ_GT] = ACTIONS(8528),
    [anon_sym_EQ_TILDE] = ACTIONS(8528),
    [anon_sym_BANG_TILDE] = ACTIONS(8528),
    [anon_sym_LT_EQ] = ACTIONS(8516),
    [anon_sym_GT] = ACTIONS(8516),
    [anon_sym_GT_EQ] = ACTIONS(8530),
    [anon_sym_CARET] = ACTIONS(8510),
    [anon_sym_PLUS] = ACTIONS(8532),
    [anon_sym_SLASH] = ACTIONS(8512),
    [anon_sym_PERCENT] = ACTIONS(8512),
    [sym_comment] = ACTIONS(87),
  },
  [10964] = {
    [aux_sym_exceptions_repeat1] = STATE(10964),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14862),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [10965] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8548),
    [sym__binary_star2] = ACTIONS(8550),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8552),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8554),
    [anon_sym_AMP] = ACTIONS(8556),
    [anon_sym_LT] = ACTIONS(8558),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8560),
    [anon_sym_DOT_DOT] = ACTIONS(8562),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8564),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8566),
    [anon_sym_AMP_AMP] = ACTIONS(8566),
    [anon_sym_LT_LT] = ACTIONS(8568),
    [anon_sym_GT_GT] = ACTIONS(8568),
    [anon_sym_EQ_EQ] = ACTIONS(8570),
    [anon_sym_BANG_EQ] = ACTIONS(8566),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8566),
    [anon_sym_LT_EQ_GT] = ACTIONS(8566),
    [anon_sym_EQ_TILDE] = ACTIONS(8566),
    [anon_sym_BANG_TILDE] = ACTIONS(8566),
    [anon_sym_LT_EQ] = ACTIONS(8558),
    [anon_sym_GT] = ACTIONS(8558),
    [anon_sym_GT_EQ] = ACTIONS(8572),
    [anon_sym_CARET] = ACTIONS(8574),
    [anon_sym_PLUS] = ACTIONS(8576),
    [anon_sym_SLASH] = ACTIONS(8554),
    [anon_sym_PERCENT] = ACTIONS(8554),
    [sym_comment] = ACTIONS(87),
  },
  [10966] = {
    [aux_sym_exceptions_repeat1] = STATE(10966),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(14865),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [10967] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8598),
    [sym__binary_star2] = ACTIONS(8600),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8602),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8604),
    [anon_sym_AMP] = ACTIONS(8606),
    [anon_sym_LT] = ACTIONS(8608),
    [anon_sym_QMARK] = ACTIONS(8610),
    [anon_sym_DOT_DOT] = ACTIONS(8612),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8614),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8616),
    [anon_sym_AMP_AMP] = ACTIONS(8616),
    [anon_sym_LT_LT] = ACTIONS(8618),
    [anon_sym_GT_GT] = ACTIONS(8618),
    [anon_sym_EQ_EQ] = ACTIONS(8620),
    [anon_sym_BANG_EQ] = ACTIONS(8616),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8616),
    [anon_sym_LT_EQ_GT] = ACTIONS(8616),
    [anon_sym_EQ_TILDE] = ACTIONS(8616),
    [anon_sym_BANG_TILDE] = ACTIONS(8616),
    [anon_sym_LT_EQ] = ACTIONS(8608),
    [anon_sym_GT] = ACTIONS(8608),
    [anon_sym_GT_EQ] = ACTIONS(8622),
    [anon_sym_CARET] = ACTIONS(8624),
    [anon_sym_PLUS] = ACTIONS(8626),
    [anon_sym_SLASH] = ACTIONS(8604),
    [anon_sym_PERCENT] = ACTIONS(8604),
    [sym_comment] = ACTIONS(87),
  },
  [10968] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10969] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [10970] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10971] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [10972] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10973] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10974] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14868),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [10975] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10976] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10977] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10978] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10979] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10980] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10981] = {
    [aux_sym_exceptions_repeat1] = STATE(11450),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [10982] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [10983] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11451),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11451),
    [sym_operator_assignment] = STATE(11451),
    [sym_conditional] = STATE(11451),
    [sym_range] = STATE(11451),
    [sym_binary] = STATE(11451),
    [sym_unary] = STATE(11451),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10984] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(222),
    [sym__argument_list_with_parens] = STATE(11452),
    [sym__argument] = STATE(11453),
    [sym_splat_argument] = STATE(11453),
    [sym_hash_splat_argument] = STATE(11453),
    [sym_block_argument] = STATE(11453),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11453),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10985] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(228),
    [sym__argument_list_with_parens] = STATE(11452),
    [sym__argument] = STATE(11453),
    [sym_splat_argument] = STATE(11453),
    [sym_hash_splat_argument] = STATE(11453),
    [sym_block_argument] = STATE(11453),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11453),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10986] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(229),
    [sym__argument_list_with_parens] = STATE(11452),
    [sym__argument] = STATE(11453),
    [sym_splat_argument] = STATE(11453),
    [sym_hash_splat_argument] = STATE(11453),
    [sym_block_argument] = STATE(11453),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11453),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10987] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_argument_list] = STATE(230),
    [sym__argument_list_with_parens] = STATE(11452),
    [sym__argument] = STATE(11453),
    [sym_splat_argument] = STATE(11453),
    [sym_hash_splat_argument] = STATE(11453),
    [sym_block_argument] = STATE(11453),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(11453),
    [sym_lambda] = STATE(220),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(377),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(391),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13296),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(413),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10988] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11454),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11454),
    [sym_operator_assignment] = STATE(11454),
    [sym_conditional] = STATE(11454),
    [sym_range] = STATE(11454),
    [sym_binary] = STATE(11454),
    [sym_unary] = STATE(11454),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10989] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11455),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11455),
    [sym_operator_assignment] = STATE(11455),
    [sym_conditional] = STATE(11455),
    [sym_range] = STATE(11455),
    [sym_binary] = STATE(11455),
    [sym_unary] = STATE(11455),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10990] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(949),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(949),
    [sym_operator_assignment] = STATE(949),
    [sym_conditional] = STATE(949),
    [sym_range] = STATE(949),
    [sym_binary] = STATE(949),
    [sym_unary] = STATE(949),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10991] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [10992] = {
    [anon_sym_EQ] = ACTIONS(14900),
    [sym_comment] = ACTIONS(87),
  },
  [10993] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14902),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14904),
    [anon_sym_DASH_EQ] = ACTIONS(14904),
    [anon_sym_STAR_EQ] = ACTIONS(14904),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14904),
    [anon_sym_SLASH_EQ] = ACTIONS(14904),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14904),
    [anon_sym_PIPE_EQ] = ACTIONS(14904),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14904),
    [anon_sym_AMP_EQ] = ACTIONS(14904),
    [anon_sym_PERCENT_EQ] = ACTIONS(14904),
    [anon_sym_GT_GT_EQ] = ACTIONS(14904),
    [anon_sym_LT_LT_EQ] = ACTIONS(14904),
    [anon_sym_CARET_EQ] = ACTIONS(14904),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [10994] = {
    [sym_string] = STATE(11470),
    [aux_sym_chained_string_repeat1] = STATE(11470),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10995] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [10996] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [10997] = {
    [sym_string] = STATE(11038),
    [aux_sym_chained_string_repeat1] = STATE(11038),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [10998] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11471),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11471),
    [sym_operator_assignment] = STATE(11471),
    [sym_conditional] = STATE(11471),
    [sym_range] = STATE(11471),
    [sym_binary] = STATE(11471),
    [sym_unary] = STATE(11471),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [10999] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_when] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11000] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11472),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11472),
    [sym_operator_assignment] = STATE(11472),
    [sym_conditional] = STATE(11472),
    [sym_range] = STATE(11472),
    [sym_binary] = STATE(11472),
    [sym_unary] = STATE(11472),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11001] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11473),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11473),
    [sym_operator_assignment] = STATE(11473),
    [sym_conditional] = STATE(11473),
    [sym_range] = STATE(11473),
    [sym_binary] = STATE(11473),
    [sym_unary] = STATE(11473),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11002] = {
    [anon_sym_COLON] = ACTIONS(14906),
    [sym_comment] = ACTIONS(87),
  },
  [11003] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11475),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11475),
    [sym_operator_assignment] = STATE(11475),
    [sym_conditional] = STATE(11475),
    [sym_range] = STATE(11475),
    [sym_binary] = STATE(11475),
    [sym_unary] = STATE(11475),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11004] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14908),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_when] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [11005] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_when] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11006] = {
    [sym_heredoc_body] = STATE(11477),
    [aux_sym_call_repeat1] = STATE(11477),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11007] = {
    [sym_heredoc_body] = STATE(11477),
    [aux_sym_call_repeat1] = STATE(11477),
    [aux_sym_argument_list_repeat1] = STATE(11479),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14910),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11008] = {
    [sym_string] = STATE(11038),
    [aux_sym_chained_string_repeat1] = STATE(11038),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14912),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [11009] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [11010] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11011] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11480),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11480),
    [sym_operator_assignment] = STATE(11480),
    [sym_conditional] = STATE(11480),
    [sym_range] = STATE(11480),
    [sym_binary] = STATE(11480),
    [sym_unary] = STATE(11480),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11012] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11481),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11481),
    [sym_operator_assignment] = STATE(11481),
    [sym_conditional] = STATE(11481),
    [sym_range] = STATE(11481),
    [sym_binary] = STATE(11481),
    [sym_unary] = STATE(11481),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11013] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11482),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11482),
    [sym_operator_assignment] = STATE(11482),
    [sym_conditional] = STATE(11482),
    [sym_range] = STATE(11482),
    [sym_binary] = STATE(11482),
    [sym_unary] = STATE(11482),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11014] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11483),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11483),
    [sym_operator_assignment] = STATE(11483),
    [sym_conditional] = STATE(11483),
    [sym_range] = STATE(11483),
    [sym_binary] = STATE(11483),
    [sym_unary] = STATE(11483),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11015] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11484),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11484),
    [sym_operator_assignment] = STATE(11484),
    [sym_conditional] = STATE(11484),
    [sym_range] = STATE(11484),
    [sym_binary] = STATE(11484),
    [sym_unary] = STATE(11484),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11016] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11485),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11485),
    [sym_operator_assignment] = STATE(11485),
    [sym_conditional] = STATE(11485),
    [sym_range] = STATE(11485),
    [sym_binary] = STATE(11485),
    [sym_unary] = STATE(11485),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11017] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11486),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11486),
    [sym_operator_assignment] = STATE(11486),
    [sym_conditional] = STATE(11486),
    [sym_range] = STATE(11486),
    [sym_binary] = STATE(11486),
    [sym_unary] = STATE(11486),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11018] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11487),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11487),
    [sym_operator_assignment] = STATE(11487),
    [sym_conditional] = STATE(11487),
    [sym_range] = STATE(11487),
    [sym_binary] = STATE(11487),
    [sym_unary] = STATE(11487),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11019] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11488),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11488),
    [sym_operator_assignment] = STATE(11488),
    [sym_conditional] = STATE(11488),
    [sym_range] = STATE(11488),
    [sym_binary] = STATE(11488),
    [sym_unary] = STATE(11488),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11020] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11489),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11489),
    [sym_operator_assignment] = STATE(11489),
    [sym_conditional] = STATE(11489),
    [sym_range] = STATE(11489),
    [sym_binary] = STATE(11489),
    [sym_unary] = STATE(11489),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11021] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11490),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11490),
    [sym_operator_assignment] = STATE(11490),
    [sym_conditional] = STATE(11490),
    [sym_range] = STATE(11490),
    [sym_binary] = STATE(11490),
    [sym_unary] = STATE(11490),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11022] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11491),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11491),
    [sym_operator_assignment] = STATE(11491),
    [sym_conditional] = STATE(11491),
    [sym_range] = STATE(11491),
    [sym_binary] = STATE(11491),
    [sym_unary] = STATE(11491),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11023] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11492),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11492),
    [sym_operator_assignment] = STATE(11492),
    [sym_conditional] = STATE(11492),
    [sym_range] = STATE(11492),
    [sym_binary] = STATE(11492),
    [sym_unary] = STATE(11492),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11024] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11493),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11493),
    [sym_operator_assignment] = STATE(11493),
    [sym_conditional] = STATE(11493),
    [sym_range] = STATE(11493),
    [sym_binary] = STATE(11493),
    [sym_unary] = STATE(11493),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11025] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11494),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11494),
    [sym_operator_assignment] = STATE(11494),
    [sym_conditional] = STATE(11494),
    [sym_range] = STATE(11494),
    [sym_binary] = STATE(11494),
    [sym_unary] = STATE(11494),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11026] = {
    [anon_sym_COLON] = ACTIONS(14914),
    [sym_comment] = ACTIONS(87),
  },
  [11027] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11496),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11496),
    [sym_operator_assignment] = STATE(11496),
    [sym_conditional] = STATE(11496),
    [sym_range] = STATE(11496),
    [sym_binary] = STATE(11496),
    [sym_unary] = STATE(11496),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11028] = {
    [sym__line_break2] = ACTIONS(1093),
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(14916),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_end] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_rescue] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_when] = ACTIONS(1095),
    [anon_sym_else] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [11029] = {
    [sym__line_break2] = ACTIONS(1641),
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(1641),
    [anon_sym_if] = ACTIONS(1641),
    [anon_sym_unless] = ACTIONS(1641),
    [anon_sym_while] = ACTIONS(1641),
    [anon_sym_until] = ACTIONS(1641),
    [anon_sym_rescue] = ACTIONS(1641),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_when] = ACTIONS(1641),
    [anon_sym_else] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11030] = {
    [sym_heredoc_body] = STATE(11498),
    [aux_sym_call_repeat1] = STATE(11498),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [11031] = {
    [sym_heredoc_body] = STATE(11498),
    [aux_sym_call_repeat1] = STATE(11498),
    [aux_sym_argument_list_repeat1] = STATE(11500),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14918),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [11032] = {
    [sym_string] = STATE(11097),
    [aux_sym_chained_string_repeat1] = STATE(11097),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(14920),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11033] = {
    [sym_heredoc_body] = STATE(11501),
    [aux_sym_call_repeat1] = STATE(11501),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11034] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(11502),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14922),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11035] = {
    [sym_heredoc_body] = STATE(11503),
    [aux_sym_call_repeat1] = STATE(11503),
    [aux_sym_argument_list_repeat1] = STATE(11504),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11036] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11505),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_splat_argument] = STATE(11506),
    [sym_assignment] = STATE(11505),
    [sym_operator_assignment] = STATE(11505),
    [sym_conditional] = STATE(11505),
    [sym_range] = STATE(11505),
    [sym_binary] = STATE(11505),
    [sym_unary] = STATE(11505),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(11506),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11037] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11507),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11507),
    [sym_operator_assignment] = STATE(11507),
    [sym_conditional] = STATE(11507),
    [sym_range] = STATE(11507),
    [sym_binary] = STATE(11507),
    [sym_unary] = STATE(11507),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11038] = {
    [sym_string] = STATE(11508),
    [aux_sym_chained_string_repeat1] = STATE(11508),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_when] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [11039] = {
    [aux_sym_undef_repeat1] = STATE(11509),
    [sym__line_break2] = ACTIONS(5504),
    [sym__heredoc_body_start2] = ACTIONS(5504),
    [anon_sym_COMMA] = ACTIONS(2299),
    [anon_sym_SEMI] = ACTIONS(5504),
    [anon_sym_end] = ACTIONS(5504),
    [anon_sym_if] = ACTIONS(5504),
    [anon_sym_unless] = ACTIONS(5504),
    [anon_sym_while] = ACTIONS(5504),
    [anon_sym_until] = ACTIONS(5504),
    [anon_sym_rescue] = ACTIONS(5504),
    [anon_sym_when] = ACTIONS(5504),
    [anon_sym_else] = ACTIONS(5504),
    [sym_comment] = ACTIONS(87),
  },
  [11040] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(8346),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(8348),
    [sym_operator_assignment] = STATE(8348),
    [sym_conditional] = STATE(8348),
    [sym_range] = STATE(8348),
    [sym_binary] = STATE(8348),
    [sym_unary] = STATE(8348),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_end] = ACTIONS(5834),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_when] = ACTIONS(5834),
    [anon_sym_else] = ACTIONS(5834),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [anon_sym_undef] = ACTIONS(11458),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11041] = {
    [sym_heredoc_body] = STATE(11510),
    [sym__terminator] = STATE(11510),
    [aux_sym__statements_repeat1] = STATE(11041),
    [sym__line_break2] = ACTIONS(14924),
    [sym__heredoc_body_start2] = ACTIONS(5839),
    [anon_sym_SEMI] = ACTIONS(14924),
    [anon_sym_end] = ACTIONS(5830),
    [anon_sym_when] = ACTIONS(5830),
    [anon_sym_else] = ACTIONS(5830),
    [sym_comment] = ACTIONS(87),
  },
  [11042] = {
    [sym__line_break2] = ACTIONS(5842),
    [sym__heredoc_body_start2] = ACTIONS(5842),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5842),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5842),
    [anon_sym_if] = ACTIONS(5842),
    [anon_sym_unless] = ACTIONS(5842),
    [anon_sym_while] = ACTIONS(5842),
    [anon_sym_until] = ACTIONS(5842),
    [anon_sym_rescue] = ACTIONS(5842),
    [anon_sym_when] = ACTIONS(5842),
    [anon_sym_else] = ACTIONS(5842),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11043] = {
    [sym__line_break2] = ACTIONS(5844),
    [sym__heredoc_body_start2] = ACTIONS(5844),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5844),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5844),
    [anon_sym_if] = ACTIONS(5844),
    [anon_sym_unless] = ACTIONS(5844),
    [anon_sym_while] = ACTIONS(5844),
    [anon_sym_until] = ACTIONS(5844),
    [anon_sym_rescue] = ACTIONS(5844),
    [anon_sym_when] = ACTIONS(5844),
    [anon_sym_else] = ACTIONS(5844),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11044] = {
    [sym__line_break2] = ACTIONS(5846),
    [sym__heredoc_body_start2] = ACTIONS(5846),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5846),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5846),
    [anon_sym_if] = ACTIONS(5846),
    [anon_sym_unless] = ACTIONS(5846),
    [anon_sym_while] = ACTIONS(5846),
    [anon_sym_until] = ACTIONS(5846),
    [anon_sym_rescue] = ACTIONS(5846),
    [anon_sym_when] = ACTIONS(5846),
    [anon_sym_else] = ACTIONS(5846),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11045] = {
    [sym__line_break2] = ACTIONS(5848),
    [sym__heredoc_body_start2] = ACTIONS(5848),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5848),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5848),
    [anon_sym_if] = ACTIONS(5848),
    [anon_sym_unless] = ACTIONS(5848),
    [anon_sym_while] = ACTIONS(5848),
    [anon_sym_until] = ACTIONS(5848),
    [anon_sym_rescue] = ACTIONS(5848),
    [anon_sym_when] = ACTIONS(5848),
    [anon_sym_else] = ACTIONS(5848),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11046] = {
    [sym__line_break2] = ACTIONS(5850),
    [sym__heredoc_body_start2] = ACTIONS(5850),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5850),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5850),
    [anon_sym_if] = ACTIONS(5850),
    [anon_sym_unless] = ACTIONS(5850),
    [anon_sym_while] = ACTIONS(5850),
    [anon_sym_until] = ACTIONS(5850),
    [anon_sym_rescue] = ACTIONS(5850),
    [anon_sym_when] = ACTIONS(5850),
    [anon_sym_else] = ACTIONS(5850),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(13340),
    [anon_sym_or] = ACTIONS(13340),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11047] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11048] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11049] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11050] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11051] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11052] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11053] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(14927),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11054] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11055] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11056] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11057] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11058] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11059] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11512),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11512),
    [sym_operator_assignment] = STATE(11512),
    [sym_conditional] = STATE(11512),
    [sym_range] = STATE(11512),
    [sym_binary] = STATE(11512),
    [sym_unary] = STATE(11512),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11060] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(3808),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(363),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(375),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(375),
    [anon_sym_unless] = ACTIONS(375),
    [anon_sym_while] = ACTIONS(375),
    [anon_sym_until] = ACTIONS(375),
    [anon_sym_rescue] = ACTIONS(375),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(375),
    [anon_sym_else] = ACTIONS(375),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11061] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(3809),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(415),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(417),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(417),
    [anon_sym_unless] = ACTIONS(417),
    [anon_sym_while] = ACTIONS(417),
    [anon_sym_until] = ACTIONS(417),
    [anon_sym_rescue] = ACTIONS(417),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(417),
    [anon_sym_else] = ACTIONS(417),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11062] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(3810),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(419),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(421),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(421),
    [anon_sym_unless] = ACTIONS(421),
    [anon_sym_while] = ACTIONS(421),
    [anon_sym_until] = ACTIONS(421),
    [anon_sym_rescue] = ACTIONS(421),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(421),
    [anon_sym_else] = ACTIONS(421),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11063] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(3811),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(423),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(425),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(425),
    [anon_sym_unless] = ACTIONS(425),
    [anon_sym_while] = ACTIONS(425),
    [anon_sym_until] = ACTIONS(425),
    [anon_sym_rescue] = ACTIONS(425),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(425),
    [anon_sym_else] = ACTIONS(425),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11064] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11513),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11513),
    [sym_operator_assignment] = STATE(11513),
    [sym_conditional] = STATE(11513),
    [sym_range] = STATE(11513),
    [sym_binary] = STATE(11513),
    [sym_unary] = STATE(11513),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11065] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11514),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11514),
    [sym_operator_assignment] = STATE(11514),
    [sym_conditional] = STATE(11514),
    [sym_range] = STATE(11514),
    [sym_binary] = STATE(11514),
    [sym_unary] = STATE(11514),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11066] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(3827),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(3827),
    [sym_operator_assignment] = STATE(3827),
    [sym_conditional] = STATE(3827),
    [sym_range] = STATE(3827),
    [sym_binary] = STATE(3827),
    [sym_unary] = STATE(3827),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11067] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11068] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_argument_list] = STATE(1108),
    [sym__argument_list_with_parens] = STATE(10104),
    [sym__argument] = STATE(10105),
    [sym_splat_argument] = STATE(10105),
    [sym_hash_splat_argument] = STATE(10105),
    [sym_block_argument] = STATE(10105),
    [sym_do_block] = STATE(444),
    [sym_block] = STATE(444),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(10105),
    [sym_lambda] = STATE(439),
    [sym__line_break2] = ACTIONS(749),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(6086),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(781),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(379),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_end] = ACTIONS(775),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(775),
    [anon_sym_unless] = ACTIONS(775),
    [anon_sym_while] = ACTIONS(775),
    [anon_sym_until] = ACTIONS(775),
    [anon_sym_rescue] = ACTIONS(775),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_when] = ACTIONS(775),
    [anon_sym_else] = ACTIONS(775),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(805),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13374),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(823),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11069] = {
    [anon_sym_EQ] = ACTIONS(14957),
    [sym_comment] = ACTIONS(87),
  },
  [11070] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14959),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(14961),
    [anon_sym_DASH_EQ] = ACTIONS(14961),
    [anon_sym_STAR_EQ] = ACTIONS(14961),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14961),
    [anon_sym_SLASH_EQ] = ACTIONS(14961),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14961),
    [anon_sym_PIPE_EQ] = ACTIONS(14961),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14961),
    [anon_sym_AMP_EQ] = ACTIONS(14961),
    [anon_sym_PERCENT_EQ] = ACTIONS(14961),
    [anon_sym_GT_GT_EQ] = ACTIONS(14961),
    [anon_sym_LT_LT_EQ] = ACTIONS(14961),
    [anon_sym_CARET_EQ] = ACTIONS(14961),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11071] = {
    [sym_string] = STATE(11529),
    [aux_sym_chained_string_repeat1] = STATE(11529),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11072] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11073] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [11074] = {
    [sym_string] = STATE(11097),
    [aux_sym_chained_string_repeat1] = STATE(11097),
    [sym__line_break2] = ACTIONS(559),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11075] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11530),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11530),
    [sym_operator_assignment] = STATE(11530),
    [sym_conditional] = STATE(11530),
    [sym_range] = STATE(11530),
    [sym_binary] = STATE(11530),
    [sym_unary] = STATE(11530),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11076] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_when] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11077] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [11078] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11079] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11531),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11531),
    [sym_operator_assignment] = STATE(11531),
    [sym_conditional] = STATE(11531),
    [sym_range] = STATE(11531),
    [sym_binary] = STATE(11531),
    [sym_unary] = STATE(11531),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11080] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11532),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11532),
    [sym_operator_assignment] = STATE(11532),
    [sym_conditional] = STATE(11532),
    [sym_range] = STATE(11532),
    [sym_binary] = STATE(11532),
    [sym_unary] = STATE(11532),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11081] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11533),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11533),
    [sym_operator_assignment] = STATE(11533),
    [sym_conditional] = STATE(11533),
    [sym_range] = STATE(11533),
    [sym_binary] = STATE(11533),
    [sym_unary] = STATE(11533),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11082] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11534),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11534),
    [sym_operator_assignment] = STATE(11534),
    [sym_conditional] = STATE(11534),
    [sym_range] = STATE(11534),
    [sym_binary] = STATE(11534),
    [sym_unary] = STATE(11534),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11083] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11535),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11535),
    [sym_operator_assignment] = STATE(11535),
    [sym_conditional] = STATE(11535),
    [sym_range] = STATE(11535),
    [sym_binary] = STATE(11535),
    [sym_unary] = STATE(11535),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11084] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11536),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11536),
    [sym_operator_assignment] = STATE(11536),
    [sym_conditional] = STATE(11536),
    [sym_range] = STATE(11536),
    [sym_binary] = STATE(11536),
    [sym_unary] = STATE(11536),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11085] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11537),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11537),
    [sym_operator_assignment] = STATE(11537),
    [sym_conditional] = STATE(11537),
    [sym_range] = STATE(11537),
    [sym_binary] = STATE(11537),
    [sym_unary] = STATE(11537),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11086] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11538),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11538),
    [sym_operator_assignment] = STATE(11538),
    [sym_conditional] = STATE(11538),
    [sym_range] = STATE(11538),
    [sym_binary] = STATE(11538),
    [sym_unary] = STATE(11538),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11087] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11539),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11539),
    [sym_operator_assignment] = STATE(11539),
    [sym_conditional] = STATE(11539),
    [sym_range] = STATE(11539),
    [sym_binary] = STATE(11539),
    [sym_unary] = STATE(11539),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11088] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11540),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11540),
    [sym_operator_assignment] = STATE(11540),
    [sym_conditional] = STATE(11540),
    [sym_range] = STATE(11540),
    [sym_binary] = STATE(11540),
    [sym_unary] = STATE(11540),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11089] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11541),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11541),
    [sym_operator_assignment] = STATE(11541),
    [sym_conditional] = STATE(11541),
    [sym_range] = STATE(11541),
    [sym_binary] = STATE(11541),
    [sym_unary] = STATE(11541),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11090] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11542),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11542),
    [sym_operator_assignment] = STATE(11542),
    [sym_conditional] = STATE(11542),
    [sym_range] = STATE(11542),
    [sym_binary] = STATE(11542),
    [sym_unary] = STATE(11542),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11091] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11543),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11543),
    [sym_operator_assignment] = STATE(11543),
    [sym_conditional] = STATE(11543),
    [sym_range] = STATE(11543),
    [sym_binary] = STATE(11543),
    [sym_unary] = STATE(11543),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11092] = {
    [sym_heredoc_body] = STATE(11544),
    [aux_sym_call_repeat1] = STATE(11544),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11093] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym__argument] = STATE(3942),
    [sym_splat_argument] = STATE(3942),
    [sym_hash_splat_argument] = STATE(3942),
    [sym_block_argument] = STATE(3942),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(11545),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(3942),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14963),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11094] = {
    [sym_heredoc_body] = STATE(11546),
    [aux_sym_call_repeat1] = STATE(11546),
    [aux_sym_argument_list_repeat1] = STATE(11547),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14320),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11095] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11548),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_splat_argument] = STATE(11549),
    [sym_assignment] = STATE(11548),
    [sym_operator_assignment] = STATE(11548),
    [sym_conditional] = STATE(11548),
    [sym_range] = STATE(11548),
    [sym_binary] = STATE(11548),
    [sym_unary] = STATE(11548),
    [sym_right_assignment_list] = STATE(3947),
    [sym__arg_or_splat_arg] = STATE(11549),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11096] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11550),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11550),
    [sym_operator_assignment] = STATE(11550),
    [sym_conditional] = STATE(11550),
    [sym_range] = STATE(11550),
    [sym_binary] = STATE(11550),
    [sym_unary] = STATE(11550),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11097] = {
    [sym_string] = STATE(11551),
    [aux_sym_chained_string_repeat1] = STATE(11551),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(753),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_when] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [11098] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11552),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11552),
    [sym_operator_assignment] = STATE(11552),
    [sym_conditional] = STATE(11552),
    [sym_range] = STATE(11552),
    [sym_binary] = STATE(11552),
    [sym_unary] = STATE(11552),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11099] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11553),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11553),
    [sym_operator_assignment] = STATE(11553),
    [sym_conditional] = STATE(11553),
    [sym_range] = STATE(11553),
    [sym_binary] = STATE(11553),
    [sym_unary] = STATE(11553),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11100] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11554),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11554),
    [sym_operator_assignment] = STATE(11554),
    [sym_conditional] = STATE(11554),
    [sym_range] = STATE(11554),
    [sym_binary] = STATE(11554),
    [sym_unary] = STATE(11554),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11101] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11555),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11555),
    [sym_operator_assignment] = STATE(11555),
    [sym_conditional] = STATE(11555),
    [sym_range] = STATE(11555),
    [sym_binary] = STATE(11555),
    [sym_unary] = STATE(11555),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11102] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(310),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(310),
    [sym_operator_assignment] = STATE(310),
    [sym_conditional] = STATE(310),
    [sym_range] = STATE(310),
    [sym_binary] = STATE(310),
    [sym_unary] = STATE(310),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11103] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_when] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11104] = {
    [aux_sym_exceptions_repeat1] = STATE(11569),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(14995),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11105] = {
    [anon_sym_EQ] = ACTIONS(14997),
    [sym_comment] = ACTIONS(87),
  },
  [11106] = {
    [sym__line_break2] = ACTIONS(559),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(14999),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_end] = ACTIONS(559),
    [anon_sym_if] = ACTIONS(559),
    [anon_sym_unless] = ACTIONS(559),
    [anon_sym_while] = ACTIONS(559),
    [anon_sym_until] = ACTIONS(559),
    [anon_sym_rescue] = ACTIONS(559),
    [anon_sym_when] = ACTIONS(559),
    [anon_sym_else] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(15001),
    [anon_sym_DASH_EQ] = ACTIONS(15001),
    [anon_sym_STAR_EQ] = ACTIONS(15001),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15001),
    [anon_sym_SLASH_EQ] = ACTIONS(15001),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15001),
    [anon_sym_PIPE_EQ] = ACTIONS(15001),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15001),
    [anon_sym_AMP_EQ] = ACTIONS(15001),
    [anon_sym_PERCENT_EQ] = ACTIONS(15001),
    [anon_sym_GT_GT_EQ] = ACTIONS(15001),
    [anon_sym_LT_LT_EQ] = ACTIONS(15001),
    [anon_sym_CARET_EQ] = ACTIONS(15001),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11107] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11108] = {
    [sym_string] = STATE(11108),
    [aux_sym_chained_string_repeat1] = STATE(11108),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_when] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11109] = {
    [anon_sym_end] = ACTIONS(15003),
    [sym_comment] = ACTIONS(87),
  },
  [11110] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8650),
    [sym__binary_star2] = ACTIONS(8652),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8654),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8656),
    [anon_sym_AMP] = ACTIONS(8658),
    [anon_sym_LT] = ACTIONS(8660),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8662),
    [anon_sym_DOT_DOT] = ACTIONS(8664),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8666),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8670),
    [anon_sym_AMP_AMP] = ACTIONS(8670),
    [anon_sym_LT_LT] = ACTIONS(8672),
    [anon_sym_GT_GT] = ACTIONS(8672),
    [anon_sym_EQ_EQ] = ACTIONS(8674),
    [anon_sym_BANG_EQ] = ACTIONS(8670),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8670),
    [anon_sym_LT_EQ_GT] = ACTIONS(8670),
    [anon_sym_EQ_TILDE] = ACTIONS(8670),
    [anon_sym_BANG_TILDE] = ACTIONS(8670),
    [anon_sym_LT_EQ] = ACTIONS(8660),
    [anon_sym_GT] = ACTIONS(8660),
    [anon_sym_GT_EQ] = ACTIONS(8676),
    [anon_sym_CARET] = ACTIONS(8678),
    [anon_sym_PLUS] = ACTIONS(8680),
    [anon_sym_SLASH] = ACTIONS(8656),
    [anon_sym_PERCENT] = ACTIONS(8656),
    [sym_comment] = ACTIONS(87),
  },
  [11111] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11112] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [11113] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11114] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [11115] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11116] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11117] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15005),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11118] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11119] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11120] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11121] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11122] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11123] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11124] = {
    [aux_sym_exceptions_repeat1] = STATE(11574),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [11125] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11126] = {
    [sym_string] = STATE(11126),
    [aux_sym_chained_string_repeat1] = STATE(11126),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [11127] = {
    [aux_sym_exceptions_repeat1] = STATE(11127),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(15007),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11128] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8707),
    [sym__binary_star2] = ACTIONS(8709),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8711),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8713),
    [anon_sym_AMP] = ACTIONS(8715),
    [anon_sym_LT] = ACTIONS(8717),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8719),
    [anon_sym_DOT_DOT] = ACTIONS(8721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8723),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8725),
    [anon_sym_AMP_AMP] = ACTIONS(8725),
    [anon_sym_LT_LT] = ACTIONS(8727),
    [anon_sym_GT_GT] = ACTIONS(8727),
    [anon_sym_EQ_EQ] = ACTIONS(8729),
    [anon_sym_BANG_EQ] = ACTIONS(8725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8725),
    [anon_sym_LT_EQ_GT] = ACTIONS(8725),
    [anon_sym_EQ_TILDE] = ACTIONS(8725),
    [anon_sym_BANG_TILDE] = ACTIONS(8725),
    [anon_sym_LT_EQ] = ACTIONS(8717),
    [anon_sym_GT] = ACTIONS(8717),
    [anon_sym_GT_EQ] = ACTIONS(8731),
    [anon_sym_CARET] = ACTIONS(8733),
    [anon_sym_PLUS] = ACTIONS(8735),
    [anon_sym_SLASH] = ACTIONS(8713),
    [anon_sym_PERCENT] = ACTIONS(8713),
    [sym_comment] = ACTIONS(87),
  },
  [11129] = {
    [aux_sym_exceptions_repeat1] = STATE(11129),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15010),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11130] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8767),
    [sym__binary_star2] = ACTIONS(8769),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8771),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8773),
    [anon_sym_AMP] = ACTIONS(8775),
    [anon_sym_LT] = ACTIONS(8777),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8779),
    [anon_sym_DOT_DOT] = ACTIONS(8781),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8783),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8785),
    [anon_sym_AMP_AMP] = ACTIONS(8785),
    [anon_sym_LT_LT] = ACTIONS(8787),
    [anon_sym_GT_GT] = ACTIONS(8787),
    [anon_sym_EQ_EQ] = ACTIONS(8789),
    [anon_sym_BANG_EQ] = ACTIONS(8785),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8785),
    [anon_sym_LT_EQ_GT] = ACTIONS(8785),
    [anon_sym_EQ_TILDE] = ACTIONS(8785),
    [anon_sym_BANG_TILDE] = ACTIONS(8785),
    [anon_sym_LT_EQ] = ACTIONS(8777),
    [anon_sym_GT] = ACTIONS(8777),
    [anon_sym_GT_EQ] = ACTIONS(8791),
    [anon_sym_CARET] = ACTIONS(8793),
    [anon_sym_PLUS] = ACTIONS(8795),
    [anon_sym_SLASH] = ACTIONS(8773),
    [anon_sym_PERCENT] = ACTIONS(8773),
    [sym_comment] = ACTIONS(87),
  },
  [11131] = {
    [aux_sym_exceptions_repeat1] = STATE(11131),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15013),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11132] = {
    [sym__line_break2] = ACTIONS(7850),
    [sym__simple_symbol2] = ACTIONS(7850),
    [sym__string_start2] = ACTIONS(7850),
    [sym__symbol_start2] = ACTIONS(7850),
    [sym__subshell_start2] = ACTIONS(7850),
    [sym__regex_start2] = ACTIONS(7850),
    [sym__string_array_start2] = ACTIONS(7850),
    [sym__symbol_array_start2] = ACTIONS(7850),
    [sym__heredoc_body_start2] = ACTIONS(7850),
    [sym_heredoc_beginning2] = ACTIONS(7850),
    [sym__block_ampersand2] = ACTIONS(7850),
    [sym__splat_star2] = ACTIONS(7850),
    [sym__unary_minus2] = ACTIONS(7850),
    [sym__identifier_hash_key2] = ACTIONS(7850),
    [anon_sym_LBRACE] = ACTIONS(7850),
    [anon_sym_def] = ACTIONS(7852),
    [anon_sym_LPAREN] = ACTIONS(7852),
    [anon_sym_DOT] = ACTIONS(7850),
    [anon_sym_COLON_COLON] = ACTIONS(7852),
    [anon_sym_SEMI] = ACTIONS(7850),
    [anon_sym_STAR] = ACTIONS(7852),
    [anon_sym_STAR_STAR] = ACTIONS(7850),
    [anon_sym_class] = ACTIONS(7852),
    [anon_sym_module] = ACTIONS(7852),
    [anon_sym_return] = ACTIONS(7852),
    [anon_sym_yield] = ACTIONS(7852),
    [anon_sym_break] = ACTIONS(7852),
    [anon_sym_next] = ACTIONS(7852),
    [sym_redo] = ACTIONS(7852),
    [sym_retry] = ACTIONS(7852),
    [anon_sym_if] = ACTIONS(7852),
    [anon_sym_unless] = ACTIONS(7852),
    [anon_sym_while] = ACTIONS(7852),
    [anon_sym_until] = ACTIONS(7852),
    [anon_sym_for] = ACTIONS(7852),
    [anon_sym_do] = ACTIONS(7852),
    [anon_sym_case] = ACTIONS(7852),
    [anon_sym_then] = ACTIONS(7852),
    [anon_sym_begin] = ACTIONS(7852),
    [anon_sym_LBRACK] = ACTIONS(7850),
    [anon_sym_COLON_COLON2] = ACTIONS(7850),
    [anon_sym_AMP_DOT] = ACTIONS(7850),
    [anon_sym_LPAREN2] = ACTIONS(7850),
    [anon_sym_PLUS] = ACTIONS(7852),
    [anon_sym_defined_QMARK] = ACTIONS(7850),
    [anon_sym_not] = ACTIONS(7852),
    [anon_sym_BANG] = ACTIONS(7850),
    [anon_sym_TILDE] = ACTIONS(7850),
    [sym_constant] = ACTIONS(7852),
    [sym_identifier] = ACTIONS(7852),
    [sym_instance_variable] = ACTIONS(7850),
    [sym_class_variable] = ACTIONS(7850),
    [sym_global_variable] = ACTIONS(7850),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(7852),
    [sym_float] = ACTIONS(7852),
    [sym_complex] = ACTIONS(7850),
    [sym_super] = ACTIONS(7852),
    [anon_sym_true] = ACTIONS(7852),
    [anon_sym_TRUE] = ACTIONS(7852),
    [anon_sym_false] = ACTIONS(7852),
    [anon_sym_FALSE] = ACTIONS(7852),
    [sym_self] = ACTIONS(7852),
    [anon_sym_nil] = ACTIONS(7852),
    [anon_sym_NIL] = ACTIONS(7852),
    [sym_character] = ACTIONS(7850),
    [anon_sym_LBRACK2] = ACTIONS(7852),
    [anon_sym_DASH_GT] = ACTIONS(7850),
  },
  [11133] = {
    [anon_sym_RPAREN] = ACTIONS(15016),
    [sym_comment] = ACTIONS(87),
  },
  [11134] = {
    [sym__line_break2] = ACTIONS(12249),
    [sym__heredoc_body_start2] = ACTIONS(12249),
    [anon_sym_DOT] = ACTIONS(12249),
    [anon_sym_SEMI] = ACTIONS(12249),
    [anon_sym_then] = ACTIONS(12249),
    [anon_sym_LBRACK] = ACTIONS(12249),
    [anon_sym_COLON_COLON2] = ACTIONS(12249),
    [anon_sym_AMP_DOT] = ACTIONS(12249),
    [sym_comment] = ACTIONS(87),
  },
  [11135] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_then] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11136] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_then] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11137] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11576),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11576),
    [sym_operator_assignment] = STATE(11576),
    [sym_conditional] = STATE(11576),
    [sym_range] = STATE(11576),
    [sym_binary] = STATE(11576),
    [sym_unary] = STATE(11576),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11138] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_then] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11139] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11577),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11577),
    [sym_operator_assignment] = STATE(11577),
    [sym_conditional] = STATE(11577),
    [sym_range] = STATE(11577),
    [sym_binary] = STATE(11577),
    [sym_unary] = STATE(11577),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11140] = {
    [sym_heredoc_body] = STATE(11578),
    [aux_sym_call_repeat1] = STATE(11578),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11141] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(11579),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15018),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11142] = {
    [sym_heredoc_body] = STATE(11580),
    [aux_sym_call_repeat1] = STATE(11580),
    [aux_sym_argument_list_repeat1] = STATE(11581),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14364),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_then] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11143] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_then] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11144] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_then] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11145] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11146] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11147] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11148] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11149] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15020),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11150] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_then] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11151] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11152] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11153] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11154] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_then] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11155] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_then] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11156] = {
    [aux_sym_exceptions_repeat1] = STATE(11584),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_then] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11157] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_then] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11158] = {
    [sym_string] = STATE(11158),
    [aux_sym_chained_string_repeat1] = STATE(11158),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_then] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11159] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [11160] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [11161] = {
    [sym_heredoc_body] = STATE(11161),
    [aux_sym_call_repeat1] = STATE(11161),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11162] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(8477),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(8477),
    [sym_operator_assignment] = STATE(8477),
    [sym_conditional] = STATE(8477),
    [sym_range] = STATE(8477),
    [sym_binary] = STATE(8477),
    [sym_unary] = STATE(8477),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8480),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(11539),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(11543),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14368),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(11547),
    [sym_identifier] = ACTIONS(11547),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11163] = {
    [sym_heredoc_body] = STATE(11161),
    [aux_sym_call_repeat1] = STATE(11161),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11164] = {
    [aux_sym_argument_list_repeat1] = STATE(11164),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15022),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11165] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_DOT] = ACTIONS(10934),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_do] = ACTIONS(10934),
    [anon_sym_then] = ACTIONS(10934),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
  },
  [11166] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11585),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_assignment] = STATE(11585),
    [sym_operator_assignment] = STATE(11585),
    [sym_conditional] = STATE(11585),
    [sym_range] = STATE(11585),
    [sym_binary] = STATE(11585),
    [sym_unary] = STATE(11585),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11167] = {
    [sym__line_break2] = ACTIONS(6739),
    [sym__heredoc_body_start2] = ACTIONS(6739),
    [anon_sym_LBRACE] = ACTIONS(6739),
    [anon_sym_DOT] = ACTIONS(6739),
    [anon_sym_SEMI] = ACTIONS(6739),
    [anon_sym_do] = ACTIONS(6739),
    [anon_sym_then] = ACTIONS(6739),
    [anon_sym_LBRACK] = ACTIONS(6739),
    [anon_sym_COLON_COLON2] = ACTIONS(6739),
    [anon_sym_AMP_DOT] = ACTIONS(6739),
    [sym_comment] = ACTIONS(87),
  },
  [11168] = {
    [sym__line_break2] = ACTIONS(10962),
    [sym__heredoc_body_start2] = ACTIONS(10962),
    [anon_sym_LBRACE] = ACTIONS(10962),
    [anon_sym_DOT] = ACTIONS(10962),
    [anon_sym_COMMA] = ACTIONS(10962),
    [anon_sym_SEMI] = ACTIONS(10962),
    [anon_sym_do] = ACTIONS(10962),
    [anon_sym_then] = ACTIONS(10962),
    [anon_sym_LBRACK] = ACTIONS(10962),
    [anon_sym_COLON_COLON2] = ACTIONS(10962),
    [anon_sym_AMP_DOT] = ACTIONS(10962),
    [sym_comment] = ACTIONS(87),
  },
  [11169] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10215),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10215),
    [sym_operator_assignment] = STATE(10215),
    [sym_conditional] = STATE(10215),
    [sym_range] = STATE(10215),
    [sym_binary] = STATE(10215),
    [sym_unary] = STATE(10215),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(8468),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(11541),
    [sym__unary_minus2] = ACTIONS(8815),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(5166),
    [sym_identifier] = ACTIONS(5166),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11170] = {
    [aux_sym_exceptions_repeat1] = STATE(11586),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15025),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11171] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8857),
    [sym__binary_star2] = ACTIONS(8859),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8861),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8863),
    [anon_sym_AMP] = ACTIONS(8865),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(8867),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8869),
    [anon_sym_DOT_DOT] = ACTIONS(8871),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8873),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8875),
    [anon_sym_AMP_AMP] = ACTIONS(8875),
    [anon_sym_LT_LT] = ACTIONS(8877),
    [anon_sym_GT_GT] = ACTIONS(8877),
    [anon_sym_EQ_EQ] = ACTIONS(8875),
    [anon_sym_BANG_EQ] = ACTIONS(8879),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8879),
    [anon_sym_LT_EQ_GT] = ACTIONS(8879),
    [anon_sym_EQ_TILDE] = ACTIONS(8879),
    [anon_sym_BANG_TILDE] = ACTIONS(8879),
    [anon_sym_LT_EQ] = ACTIONS(8867),
    [anon_sym_GT] = ACTIONS(8867),
    [anon_sym_GT_EQ] = ACTIONS(8881),
    [anon_sym_CARET] = ACTIONS(8861),
    [anon_sym_PLUS] = ACTIONS(8883),
    [anon_sym_SLASH] = ACTIONS(8863),
    [anon_sym_PERCENT] = ACTIONS(8863),
    [sym_comment] = ACTIONS(87),
  },
  [11172] = {
    [aux_sym_exceptions_repeat1] = STATE(11172),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15027),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11173] = {
    [sym_heredoc_body] = STATE(11173),
    [aux_sym_call_repeat1] = STATE(11173),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_ensure] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11174] = {
    [sym_heredoc_body] = STATE(11173),
    [aux_sym_call_repeat1] = STATE(11173),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_ensure] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11175] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11587),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_assignment] = STATE(11587),
    [sym_operator_assignment] = STATE(11587),
    [sym_conditional] = STATE(11587),
    [sym_range] = STATE(11587),
    [sym_binary] = STATE(11587),
    [sym_unary] = STATE(11587),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11176] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10239),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(5996),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(5996),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10239),
    [sym_operator_assignment] = STATE(10239),
    [sym_conditional] = STATE(10239),
    [sym_range] = STATE(10239),
    [sym_binary] = STATE(10239),
    [sym_unary] = STATE(10239),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(5995),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5996),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(5996),
    [sym_false] = STATE(5996),
    [sym_nil] = STATE(5996),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5182),
    [sym__unary_minus2] = ACTIONS(8899),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8909),
    [anon_sym_defined_QMARK] = ACTIONS(8911),
    [anon_sym_not] = ACTIONS(8913),
    [anon_sym_BANG] = ACTIONS(8915),
    [anon_sym_TILDE] = ACTIONS(8915),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11177] = {
    [aux_sym_exceptions_repeat1] = STATE(11588),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15030),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11178] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(8931),
    [sym__binary_star2] = ACTIONS(8933),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(8935),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(8937),
    [anon_sym_AMP] = ACTIONS(8939),
    [anon_sym_LT] = ACTIONS(8941),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(8945),
    [anon_sym_DOT_DOT] = ACTIONS(8947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(8949),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(8951),
    [anon_sym_AMP_AMP] = ACTIONS(8951),
    [anon_sym_LT_LT] = ACTIONS(8953),
    [anon_sym_GT_GT] = ACTIONS(8953),
    [anon_sym_EQ_EQ] = ACTIONS(8955),
    [anon_sym_BANG_EQ] = ACTIONS(8951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(8951),
    [anon_sym_LT_EQ_GT] = ACTIONS(8951),
    [anon_sym_EQ_TILDE] = ACTIONS(8951),
    [anon_sym_BANG_TILDE] = ACTIONS(8951),
    [anon_sym_LT_EQ] = ACTIONS(8941),
    [anon_sym_GT] = ACTIONS(8941),
    [anon_sym_GT_EQ] = ACTIONS(8957),
    [anon_sym_CARET] = ACTIONS(8959),
    [anon_sym_PLUS] = ACTIONS(8961),
    [anon_sym_SLASH] = ACTIONS(8937),
    [anon_sym_PERCENT] = ACTIONS(8937),
    [sym_comment] = ACTIONS(87),
  },
  [11179] = {
    [aux_sym_exceptions_repeat1] = STATE(11179),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15032),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11180] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11589),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_assignment] = STATE(11589),
    [sym_operator_assignment] = STATE(11589),
    [sym_conditional] = STATE(11589),
    [sym_range] = STATE(11589),
    [sym_binary] = STATE(11589),
    [sym_unary] = STATE(11589),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11181] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10271),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6073),
    [sym_scope_resolution] = STATE(6071),
    [sym_call] = STATE(6071),
    [sym_method_call] = STATE(6073),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(10271),
    [sym_operator_assignment] = STATE(10271),
    [sym_conditional] = STATE(10271),
    [sym_range] = STATE(10271),
    [sym_binary] = STATE(10271),
    [sym_unary] = STATE(10271),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(6072),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6073),
    [sym__variable] = STATE(6071),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6073),
    [sym_false] = STATE(6073),
    [sym_nil] = STATE(6073),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6074),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(5260),
    [sym__unary_minus2] = ACTIONS(8983),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(8985),
    [anon_sym_yield] = ACTIONS(8987),
    [anon_sym_break] = ACTIONS(8989),
    [anon_sym_next] = ACTIONS(8991),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(8993),
    [anon_sym_defined_QMARK] = ACTIONS(8995),
    [anon_sym_not] = ACTIONS(8997),
    [anon_sym_BANG] = ACTIONS(8999),
    [anon_sym_TILDE] = ACTIONS(8999),
    [sym_constant] = ACTIONS(9001),
    [sym_identifier] = ACTIONS(9001),
    [sym_instance_variable] = ACTIONS(9003),
    [sym_class_variable] = ACTIONS(9003),
    [sym_global_variable] = ACTIONS(9003),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9001),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9001),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11182] = {
    [aux_sym_exceptions_repeat1] = STATE(11590),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15035),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_ensure] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11183] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9011),
    [sym__binary_star2] = ACTIONS(9013),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9015),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(9017),
    [anon_sym_AMP] = ACTIONS(9019),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(9021),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9025),
    [anon_sym_DOT_DOT] = ACTIONS(9027),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9029),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9031),
    [anon_sym_AMP_AMP] = ACTIONS(9031),
    [anon_sym_LT_LT] = ACTIONS(9033),
    [anon_sym_GT_GT] = ACTIONS(9033),
    [anon_sym_EQ_EQ] = ACTIONS(9031),
    [anon_sym_BANG_EQ] = ACTIONS(9035),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9035),
    [anon_sym_LT_EQ_GT] = ACTIONS(9035),
    [anon_sym_EQ_TILDE] = ACTIONS(9035),
    [anon_sym_BANG_TILDE] = ACTIONS(9035),
    [anon_sym_LT_EQ] = ACTIONS(9021),
    [anon_sym_GT] = ACTIONS(9021),
    [anon_sym_GT_EQ] = ACTIONS(9037),
    [anon_sym_CARET] = ACTIONS(9015),
    [anon_sym_PLUS] = ACTIONS(9039),
    [anon_sym_SLASH] = ACTIONS(9017),
    [anon_sym_PERCENT] = ACTIONS(9017),
    [sym_comment] = ACTIONS(87),
  },
  [11184] = {
    [aux_sym_exceptions_repeat1] = STATE(11184),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15037),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11185] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11591),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6109),
    [sym_scope_resolution] = STATE(1239),
    [sym_call] = STATE(1239),
    [sym_method_call] = STATE(6109),
    [sym_assignment] = STATE(11591),
    [sym_operator_assignment] = STATE(11591),
    [sym_conditional] = STATE(11591),
    [sym_range] = STATE(11591),
    [sym_binary] = STATE(11591),
    [sym_unary] = STATE(11591),
    [sym_left_assignment_list] = STATE(6108),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6109),
    [sym__variable] = STATE(1239),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6109),
    [sym_false] = STATE(6109),
    [sym_nil] = STATE(6109),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(5997),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9053),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8901),
    [anon_sym_yield] = ACTIONS(8903),
    [anon_sym_break] = ACTIONS(8905),
    [anon_sym_next] = ACTIONS(8907),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9055),
    [anon_sym_defined_QMARK] = ACTIONS(9057),
    [anon_sym_not] = ACTIONS(9059),
    [anon_sym_BANG] = ACTIONS(9061),
    [anon_sym_TILDE] = ACTIONS(9061),
    [sym_constant] = ACTIONS(2165),
    [sym_identifier] = ACTIONS(2165),
    [sym_instance_variable] = ACTIONS(2167),
    [sym_class_variable] = ACTIONS(2167),
    [sym_global_variable] = ACTIONS(2167),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2165),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2165),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11186] = {
    [sym_heredoc_body] = STATE(11186),
    [aux_sym_call_repeat1] = STATE(11186),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11187] = {
    [sym_heredoc_body] = STATE(11186),
    [aux_sym_call_repeat1] = STATE(11186),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11188] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11592),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_assignment] = STATE(11592),
    [sym_operator_assignment] = STATE(11592),
    [sym_conditional] = STATE(11592),
    [sym_range] = STATE(11592),
    [sym_binary] = STATE(11592),
    [sym_unary] = STATE(11592),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11189] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10307),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6122),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6122),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10307),
    [sym_operator_assignment] = STATE(10307),
    [sym_conditional] = STATE(10307),
    [sym_range] = STATE(10307),
    [sym_binary] = STATE(10307),
    [sym_unary] = STATE(10307),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(6121),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6122),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6122),
    [sym_false] = STATE(6122),
    [sym_nil] = STATE(6122),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(5298),
    [sym__unary_minus2] = ACTIONS(9065),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9075),
    [anon_sym_defined_QMARK] = ACTIONS(9077),
    [anon_sym_not] = ACTIONS(9079),
    [anon_sym_BANG] = ACTIONS(9081),
    [anon_sym_TILDE] = ACTIONS(9081),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11190] = {
    [aux_sym_exceptions_repeat1] = STATE(11593),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15040),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11191] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9097),
    [sym__binary_star2] = ACTIONS(9099),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9101),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(9103),
    [anon_sym_AMP] = ACTIONS(9105),
    [anon_sym_LT] = ACTIONS(9107),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9111),
    [anon_sym_DOT_DOT] = ACTIONS(9113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9115),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9117),
    [anon_sym_AMP_AMP] = ACTIONS(9117),
    [anon_sym_LT_LT] = ACTIONS(9119),
    [anon_sym_GT_GT] = ACTIONS(9119),
    [anon_sym_EQ_EQ] = ACTIONS(9121),
    [anon_sym_BANG_EQ] = ACTIONS(9117),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9117),
    [anon_sym_LT_EQ_GT] = ACTIONS(9117),
    [anon_sym_EQ_TILDE] = ACTIONS(9117),
    [anon_sym_BANG_TILDE] = ACTIONS(9117),
    [anon_sym_LT_EQ] = ACTIONS(9107),
    [anon_sym_GT] = ACTIONS(9107),
    [anon_sym_GT_EQ] = ACTIONS(9123),
    [anon_sym_CARET] = ACTIONS(9125),
    [anon_sym_PLUS] = ACTIONS(9127),
    [anon_sym_SLASH] = ACTIONS(9103),
    [anon_sym_PERCENT] = ACTIONS(9103),
    [sym_comment] = ACTIONS(87),
  },
  [11192] = {
    [aux_sym_exceptions_repeat1] = STATE(11192),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15042),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11193] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11594),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_assignment] = STATE(11594),
    [sym_operator_assignment] = STATE(11594),
    [sym_conditional] = STATE(11594),
    [sym_range] = STATE(11594),
    [sym_binary] = STATE(11594),
    [sym_unary] = STATE(11594),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11194] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10339),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(6199),
    [sym_scope_resolution] = STATE(6197),
    [sym_call] = STATE(6197),
    [sym_method_call] = STATE(6199),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(10339),
    [sym_operator_assignment] = STATE(10339),
    [sym_conditional] = STATE(10339),
    [sym_range] = STATE(10339),
    [sym_binary] = STATE(10339),
    [sym_unary] = STATE(10339),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(6198),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6199),
    [sym__variable] = STATE(6197),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(6199),
    [sym_false] = STATE(6199),
    [sym_nil] = STATE(6199),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(6200),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(5376),
    [sym__unary_minus2] = ACTIONS(9149),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(9151),
    [anon_sym_yield] = ACTIONS(9153),
    [anon_sym_break] = ACTIONS(9155),
    [anon_sym_next] = ACTIONS(9157),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(9159),
    [anon_sym_defined_QMARK] = ACTIONS(9161),
    [anon_sym_not] = ACTIONS(9163),
    [anon_sym_BANG] = ACTIONS(9165),
    [anon_sym_TILDE] = ACTIONS(9165),
    [sym_constant] = ACTIONS(9167),
    [sym_identifier] = ACTIONS(9167),
    [sym_instance_variable] = ACTIONS(9169),
    [sym_class_variable] = ACTIONS(9169),
    [sym_global_variable] = ACTIONS(9169),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(9167),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(9167),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11195] = {
    [aux_sym_exceptions_repeat1] = STATE(11595),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15045),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11196] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9177),
    [sym__binary_star2] = ACTIONS(9179),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9181),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(9183),
    [anon_sym_AMP] = ACTIONS(9185),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(9187),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9191),
    [anon_sym_DOT_DOT] = ACTIONS(9193),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9195),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9197),
    [anon_sym_AMP_AMP] = ACTIONS(9197),
    [anon_sym_LT_LT] = ACTIONS(9199),
    [anon_sym_GT_GT] = ACTIONS(9199),
    [anon_sym_EQ_EQ] = ACTIONS(9197),
    [anon_sym_BANG_EQ] = ACTIONS(9201),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9201),
    [anon_sym_LT_EQ_GT] = ACTIONS(9201),
    [anon_sym_EQ_TILDE] = ACTIONS(9201),
    [anon_sym_BANG_TILDE] = ACTIONS(9201),
    [anon_sym_LT_EQ] = ACTIONS(9187),
    [anon_sym_GT] = ACTIONS(9187),
    [anon_sym_GT_EQ] = ACTIONS(9203),
    [anon_sym_CARET] = ACTIONS(9181),
    [anon_sym_PLUS] = ACTIONS(9205),
    [anon_sym_SLASH] = ACTIONS(9183),
    [anon_sym_PERCENT] = ACTIONS(9183),
    [sym_comment] = ACTIONS(87),
  },
  [11197] = {
    [aux_sym_exceptions_repeat1] = STATE(11197),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15047),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11198] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11596),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(6235),
    [sym_scope_resolution] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_method_call] = STATE(6235),
    [sym_assignment] = STATE(11596),
    [sym_operator_assignment] = STATE(11596),
    [sym_conditional] = STATE(11596),
    [sym_range] = STATE(11596),
    [sym_binary] = STATE(11596),
    [sym_unary] = STATE(11596),
    [sym_left_assignment_list] = STATE(6234),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6235),
    [sym__variable] = STATE(1257),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(6235),
    [sym_false] = STATE(6235),
    [sym_nil] = STATE(6235),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(6123),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(9219),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(9067),
    [anon_sym_yield] = ACTIONS(9069),
    [anon_sym_break] = ACTIONS(9071),
    [anon_sym_next] = ACTIONS(9073),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9221),
    [anon_sym_defined_QMARK] = ACTIONS(9223),
    [anon_sym_not] = ACTIONS(9225),
    [anon_sym_BANG] = ACTIONS(9227),
    [anon_sym_TILDE] = ACTIONS(9227),
    [sym_constant] = ACTIONS(2191),
    [sym_identifier] = ACTIONS(2191),
    [sym_instance_variable] = ACTIONS(2193),
    [sym_class_variable] = ACTIONS(2193),
    [sym_global_variable] = ACTIONS(2193),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(2191),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(2191),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11199] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9240),
    [sym__binary_star2] = ACTIONS(9242),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9244),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(9246),
    [anon_sym_AMP] = ACTIONS(9248),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(9250),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9252),
    [anon_sym_DOT_DOT] = ACTIONS(9254),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9256),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9258),
    [anon_sym_AMP_AMP] = ACTIONS(9258),
    [anon_sym_LT_LT] = ACTIONS(9260),
    [anon_sym_GT_GT] = ACTIONS(9260),
    [anon_sym_EQ_EQ] = ACTIONS(9258),
    [anon_sym_BANG_EQ] = ACTIONS(9262),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9262),
    [anon_sym_LT_EQ_GT] = ACTIONS(9262),
    [anon_sym_EQ_TILDE] = ACTIONS(9262),
    [anon_sym_BANG_TILDE] = ACTIONS(9262),
    [anon_sym_LT_EQ] = ACTIONS(9250),
    [anon_sym_GT] = ACTIONS(9250),
    [anon_sym_GT_EQ] = ACTIONS(9264),
    [anon_sym_CARET] = ACTIONS(9244),
    [anon_sym_PLUS] = ACTIONS(9266),
    [anon_sym_SLASH] = ACTIONS(9246),
    [anon_sym_PERCENT] = ACTIONS(9246),
    [sym_comment] = ACTIONS(87),
  },
  [11200] = {
    [aux_sym_exceptions_repeat1] = STATE(11200),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15050),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11201] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9276),
    [sym__binary_star2] = ACTIONS(9278),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9280),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(9282),
    [anon_sym_AMP] = ACTIONS(9284),
    [anon_sym_LT] = ACTIONS(9286),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9288),
    [anon_sym_DOT_DOT] = ACTIONS(9290),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9292),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9294),
    [anon_sym_AMP_AMP] = ACTIONS(9294),
    [anon_sym_LT_LT] = ACTIONS(9296),
    [anon_sym_GT_GT] = ACTIONS(9296),
    [anon_sym_EQ_EQ] = ACTIONS(9298),
    [anon_sym_BANG_EQ] = ACTIONS(9294),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9294),
    [anon_sym_LT_EQ_GT] = ACTIONS(9294),
    [anon_sym_EQ_TILDE] = ACTIONS(9294),
    [anon_sym_BANG_TILDE] = ACTIONS(9294),
    [anon_sym_LT_EQ] = ACTIONS(9286),
    [anon_sym_GT] = ACTIONS(9286),
    [anon_sym_GT_EQ] = ACTIONS(9300),
    [anon_sym_CARET] = ACTIONS(9302),
    [anon_sym_PLUS] = ACTIONS(9304),
    [anon_sym_SLASH] = ACTIONS(9282),
    [anon_sym_PERCENT] = ACTIONS(9282),
    [sym_comment] = ACTIONS(87),
  },
  [11202] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11597),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_assignment] = STATE(11597),
    [sym_operator_assignment] = STATE(11597),
    [sym_conditional] = STATE(11597),
    [sym_range] = STATE(11597),
    [sym_binary] = STATE(11597),
    [sym_unary] = STATE(11597),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11203] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10381),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6321),
    [sym_scope_resolution] = STATE(1340),
    [sym_call] = STATE(1340),
    [sym_method_call] = STATE(6321),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(10381),
    [sym_operator_assignment] = STATE(10381),
    [sym_conditional] = STATE(10381),
    [sym_range] = STATE(10381),
    [sym_binary] = STATE(10381),
    [sym_unary] = STATE(10381),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(6320),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6321),
    [sym__variable] = STATE(1340),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6321),
    [sym_false] = STATE(6321),
    [sym_nil] = STATE(6321),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(1343),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(5536),
    [sym__unary_minus2] = ACTIONS(9339),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(2329),
    [anon_sym_yield] = ACTIONS(2331),
    [anon_sym_break] = ACTIONS(2333),
    [anon_sym_next] = ACTIONS(2335),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9341),
    [anon_sym_defined_QMARK] = ACTIONS(9343),
    [anon_sym_not] = ACTIONS(9345),
    [anon_sym_BANG] = ACTIONS(9347),
    [anon_sym_TILDE] = ACTIONS(9347),
    [sym_constant] = ACTIONS(2345),
    [sym_identifier] = ACTIONS(2345),
    [sym_instance_variable] = ACTIONS(2347),
    [sym_class_variable] = ACTIONS(2347),
    [sym_global_variable] = ACTIONS(2347),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(2345),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(2345),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11204] = {
    [aux_sym_exceptions_repeat1] = STATE(11598),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15053),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11205] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11599),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_assignment] = STATE(11599),
    [sym_operator_assignment] = STATE(11599),
    [sym_conditional] = STATE(11599),
    [sym_range] = STATE(11599),
    [sym_binary] = STATE(11599),
    [sym_unary] = STATE(11599),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11206] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10397),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6352),
    [sym_scope_resolution] = STATE(6350),
    [sym_call] = STATE(6350),
    [sym_method_call] = STATE(6352),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(10397),
    [sym_operator_assignment] = STATE(10397),
    [sym_conditional] = STATE(10397),
    [sym_range] = STATE(10397),
    [sym_binary] = STATE(10397),
    [sym_unary] = STATE(10397),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(6351),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6352),
    [sym__variable] = STATE(6350),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6352),
    [sym_false] = STATE(6352),
    [sym_nil] = STATE(6352),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6353),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(5576),
    [sym__unary_minus2] = ACTIONS(9359),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9361),
    [anon_sym_yield] = ACTIONS(9363),
    [anon_sym_break] = ACTIONS(9365),
    [anon_sym_next] = ACTIONS(9367),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9369),
    [anon_sym_defined_QMARK] = ACTIONS(9371),
    [anon_sym_not] = ACTIONS(9373),
    [anon_sym_BANG] = ACTIONS(9375),
    [anon_sym_TILDE] = ACTIONS(9375),
    [sym_constant] = ACTIONS(9377),
    [sym_identifier] = ACTIONS(9377),
    [sym_instance_variable] = ACTIONS(9379),
    [sym_class_variable] = ACTIONS(9379),
    [sym_global_variable] = ACTIONS(9379),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9377),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9377),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11207] = {
    [aux_sym_exceptions_repeat1] = STATE(11600),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15055),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_RBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11208] = {
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14122),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_in] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_EQ_GT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_RBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_COLON2] = ACTIONS(14124),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14122),
    [anon_sym_AMP_AMP] = ACTIONS(14122),
    [anon_sym_LT_LT] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(14122),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14122),
    [anon_sym_PLUS] = ACTIONS(14122),
    [anon_sym_SLASH] = ACTIONS(14122),
    [anon_sym_PERCENT] = ACTIONS(14122),
    [sym_comment] = ACTIONS(87),
  },
  [11209] = {
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14626),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_in] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_RBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_COLON2] = ACTIONS(14628),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14626),
    [anon_sym_AMP_AMP] = ACTIONS(14626),
    [anon_sym_LT_LT] = ACTIONS(14626),
    [anon_sym_GT_GT] = ACTIONS(14626),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14626),
    [anon_sym_PLUS] = ACTIONS(14626),
    [anon_sym_SLASH] = ACTIONS(14626),
    [anon_sym_PERCENT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [11210] = {
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_in] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_EQ_GT] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_RBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_COLON2] = ACTIONS(14628),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [11211] = {
    [sym__simple_symbol2] = ACTIONS(15057),
    [sym__string_start2] = ACTIONS(15057),
    [sym__symbol_start2] = ACTIONS(15057),
    [sym__subshell_start2] = ACTIONS(15057),
    [sym__regex_start2] = ACTIONS(15057),
    [sym__string_array_start2] = ACTIONS(15057),
    [sym__symbol_array_start2] = ACTIONS(15057),
    [sym_heredoc_beginning2] = ACTIONS(15057),
    [sym__unary_minus2] = ACTIONS(15057),
    [anon_sym_BEGIN] = ACTIONS(15059),
    [anon_sym_LBRACE] = ACTIONS(15057),
    [anon_sym_RBRACE] = ACTIONS(15057),
    [anon_sym_END] = ACTIONS(15059),
    [anon_sym_def] = ACTIONS(15059),
    [anon_sym_LPAREN] = ACTIONS(15057),
    [anon_sym_COLON_COLON] = ACTIONS(15057),
    [anon_sym_SEMI] = ACTIONS(15057),
    [anon_sym_STAR] = ACTIONS(15057),
    [anon_sym_class] = ACTIONS(15059),
    [anon_sym_module] = ACTIONS(15059),
    [anon_sym_return] = ACTIONS(15059),
    [anon_sym_yield] = ACTIONS(15059),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_next] = ACTIONS(15059),
    [sym_redo] = ACTIONS(15059),
    [sym_retry] = ACTIONS(15059),
    [anon_sym_if] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(15059),
    [anon_sym_while] = ACTIONS(15059),
    [anon_sym_until] = ACTIONS(15059),
    [anon_sym_for] = ACTIONS(15059),
    [anon_sym_case] = ACTIONS(15059),
    [anon_sym_begin] = ACTIONS(15059),
    [anon_sym_PLUS] = ACTIONS(15059),
    [anon_sym_defined_QMARK] = ACTIONS(15057),
    [anon_sym_not] = ACTIONS(15059),
    [anon_sym_BANG] = ACTIONS(15057),
    [anon_sym_TILDE] = ACTIONS(15057),
    [sym_constant] = ACTIONS(15059),
    [sym_identifier] = ACTIONS(15059),
    [sym_instance_variable] = ACTIONS(15057),
    [sym_class_variable] = ACTIONS(15057),
    [sym_global_variable] = ACTIONS(15057),
    [anon_sym_undef] = ACTIONS(15059),
    [anon_sym_alias] = ACTIONS(15059),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15059),
    [sym_float] = ACTIONS(15059),
    [sym_complex] = ACTIONS(15057),
    [sym_super] = ACTIONS(15059),
    [anon_sym_true] = ACTIONS(15059),
    [anon_sym_TRUE] = ACTIONS(15059),
    [anon_sym_false] = ACTIONS(15059),
    [anon_sym_FALSE] = ACTIONS(15059),
    [sym_self] = ACTIONS(15059),
    [anon_sym_nil] = ACTIONS(15059),
    [anon_sym_NIL] = ACTIONS(15059),
    [sym_character] = ACTIONS(15057),
    [anon_sym_LBRACK2] = ACTIONS(15057),
    [anon_sym_DASH_GT] = ACTIONS(15057),
  },
  [11212] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11601),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11601),
    [sym_operator_assignment] = STATE(11601),
    [sym_conditional] = STATE(11601),
    [sym_range] = STATE(11601),
    [sym_binary] = STATE(11601),
    [sym_unary] = STATE(11601),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11213] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1374),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(363),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(363),
    [anon_sym_AMP_AMP] = ACTIONS(363),
    [anon_sym_LT_LT] = ACTIONS(363),
    [anon_sym_GT_GT] = ACTIONS(363),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(363),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(363),
    [anon_sym_PERCENT] = ACTIONS(363),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11214] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1380),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(415),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(415),
    [anon_sym_AMP_AMP] = ACTIONS(415),
    [anon_sym_LT_LT] = ACTIONS(415),
    [anon_sym_GT_GT] = ACTIONS(415),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(415),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(415),
    [anon_sym_PERCENT] = ACTIONS(415),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11215] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1381),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(419),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(419),
    [anon_sym_AMP_AMP] = ACTIONS(419),
    [anon_sym_LT_LT] = ACTIONS(419),
    [anon_sym_GT_GT] = ACTIONS(419),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(419),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(419),
    [anon_sym_PERCENT] = ACTIONS(419),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11216] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_argument_list] = STATE(1382),
    [sym__argument_list_with_parens] = STATE(10438),
    [sym__argument] = STATE(10439),
    [sym_splat_argument] = STATE(10439),
    [sym_hash_splat_argument] = STATE(10439),
    [sym_block_argument] = STATE(10439),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(10439),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(1057),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(423),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(1069),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(423),
    [anon_sym_AMP_AMP] = ACTIONS(423),
    [anon_sym_LT_LT] = ACTIONS(423),
    [anon_sym_GT_GT] = ACTIONS(423),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(423),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(423),
    [anon_sym_PERCENT] = ACTIONS(423),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13631),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(1085),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11217] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11602),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11602),
    [sym_operator_assignment] = STATE(11602),
    [sym_conditional] = STATE(11602),
    [sym_range] = STATE(11602),
    [sym_binary] = STATE(11602),
    [sym_unary] = STATE(11602),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11218] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11603),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11603),
    [sym_operator_assignment] = STATE(11603),
    [sym_conditional] = STATE(11603),
    [sym_range] = STATE(11603),
    [sym_binary] = STATE(11603),
    [sym_unary] = STATE(11603),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11219] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(1945),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(1945),
    [sym_operator_assignment] = STATE(1945),
    [sym_conditional] = STATE(1945),
    [sym_range] = STATE(1945),
    [sym_binary] = STATE(1945),
    [sym_unary] = STATE(1945),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11220] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11221] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(1917),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(3254),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(3264),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11222] = {
    [anon_sym_EQ] = ACTIONS(15091),
    [sym_comment] = ACTIONS(87),
  },
  [11223] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(15093),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(15095),
    [anon_sym_DASH_EQ] = ACTIONS(15095),
    [anon_sym_STAR_EQ] = ACTIONS(15095),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15095),
    [anon_sym_SLASH_EQ] = ACTIONS(15095),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15095),
    [anon_sym_PIPE_EQ] = ACTIONS(15095),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15095),
    [anon_sym_AMP_EQ] = ACTIONS(15095),
    [anon_sym_PERCENT_EQ] = ACTIONS(15095),
    [anon_sym_GT_GT_EQ] = ACTIONS(15095),
    [anon_sym_LT_LT_EQ] = ACTIONS(15095),
    [anon_sym_CARET_EQ] = ACTIONS(15095),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11224] = {
    [sym_string] = STATE(11618),
    [aux_sym_chained_string_repeat1] = STATE(11618),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [11225] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11226] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [11227] = {
    [sym_string] = STATE(11268),
    [aux_sym_chained_string_repeat1] = STATE(11268),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [11228] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11619),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11619),
    [sym_operator_assignment] = STATE(11619),
    [sym_conditional] = STATE(11619),
    [sym_range] = STATE(11619),
    [sym_binary] = STATE(11619),
    [sym_unary] = STATE(11619),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11229] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11230] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11620),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11620),
    [sym_operator_assignment] = STATE(11620),
    [sym_conditional] = STATE(11620),
    [sym_range] = STATE(11620),
    [sym_binary] = STATE(11620),
    [sym_unary] = STATE(11620),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11231] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11621),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11621),
    [sym_operator_assignment] = STATE(11621),
    [sym_conditional] = STATE(11621),
    [sym_range] = STATE(11621),
    [sym_binary] = STATE(11621),
    [sym_unary] = STATE(11621),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11232] = {
    [anon_sym_COLON] = ACTIONS(15097),
    [sym_comment] = ACTIONS(87),
  },
  [11233] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11623),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11623),
    [sym_operator_assignment] = STATE(11623),
    [sym_conditional] = STATE(11623),
    [sym_range] = STATE(11623),
    [sym_binary] = STATE(11623),
    [sym_unary] = STATE(11623),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11234] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(15099),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [11235] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11236] = {
    [sym_heredoc_body] = STATE(11625),
    [aux_sym_call_repeat1] = STATE(11625),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11237] = {
    [sym_heredoc_body] = STATE(11625),
    [aux_sym_call_repeat1] = STATE(11625),
    [aux_sym_argument_list_repeat1] = STATE(11627),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(15101),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11238] = {
    [sym_string] = STATE(11268),
    [aux_sym_chained_string_repeat1] = STATE(11268),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(559),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(15103),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(559),
    [anon_sym_AMP_AMP] = ACTIONS(559),
    [anon_sym_LT_LT] = ACTIONS(559),
    [anon_sym_GT_GT] = ACTIONS(559),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(559),
    [anon_sym_PLUS] = ACTIONS(559),
    [anon_sym_SLASH] = ACTIONS(559),
    [anon_sym_PERCENT] = ACTIONS(559),
    [sym_comment] = ACTIONS(87),
  },
  [11239] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [11240] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11241] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11628),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11628),
    [sym_operator_assignment] = STATE(11628),
    [sym_conditional] = STATE(11628),
    [sym_range] = STATE(11628),
    [sym_binary] = STATE(11628),
    [sym_unary] = STATE(11628),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11242] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11629),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11629),
    [sym_operator_assignment] = STATE(11629),
    [sym_conditional] = STATE(11629),
    [sym_range] = STATE(11629),
    [sym_binary] = STATE(11629),
    [sym_unary] = STATE(11629),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11243] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11630),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11630),
    [sym_operator_assignment] = STATE(11630),
    [sym_conditional] = STATE(11630),
    [sym_range] = STATE(11630),
    [sym_binary] = STATE(11630),
    [sym_unary] = STATE(11630),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11244] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11631),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11631),
    [sym_operator_assignment] = STATE(11631),
    [sym_conditional] = STATE(11631),
    [sym_range] = STATE(11631),
    [sym_binary] = STATE(11631),
    [sym_unary] = STATE(11631),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11245] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11632),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11632),
    [sym_operator_assignment] = STATE(11632),
    [sym_conditional] = STATE(11632),
    [sym_range] = STATE(11632),
    [sym_binary] = STATE(11632),
    [sym_unary] = STATE(11632),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11246] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11633),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11633),
    [sym_operator_assignment] = STATE(11633),
    [sym_conditional] = STATE(11633),
    [sym_range] = STATE(11633),
    [sym_binary] = STATE(11633),
    [sym_unary] = STATE(11633),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11247] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11634),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11634),
    [sym_operator_assignment] = STATE(11634),
    [sym_conditional] = STATE(11634),
    [sym_range] = STATE(11634),
    [sym_binary] = STATE(11634),
    [sym_unary] = STATE(11634),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11248] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11635),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11635),
    [sym_operator_assignment] = STATE(11635),
    [sym_conditional] = STATE(11635),
    [sym_range] = STATE(11635),
    [sym_binary] = STATE(11635),
    [sym_unary] = STATE(11635),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11249] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11636),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11636),
    [sym_operator_assignment] = STATE(11636),
    [sym_conditional] = STATE(11636),
    [sym_range] = STATE(11636),
    [sym_binary] = STATE(11636),
    [sym_unary] = STATE(11636),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11250] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11637),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11637),
    [sym_operator_assignment] = STATE(11637),
    [sym_conditional] = STATE(11637),
    [sym_range] = STATE(11637),
    [sym_binary] = STATE(11637),
    [sym_unary] = STATE(11637),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11251] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11638),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11638),
    [sym_operator_assignment] = STATE(11638),
    [sym_conditional] = STATE(11638),
    [sym_range] = STATE(11638),
    [sym_binary] = STATE(11638),
    [sym_unary] = STATE(11638),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11252] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11639),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11639),
    [sym_operator_assignment] = STATE(11639),
    [sym_conditional] = STATE(11639),
    [sym_range] = STATE(11639),
    [sym_binary] = STATE(11639),
    [sym_unary] = STATE(11639),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11253] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11640),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11640),
    [sym_operator_assignment] = STATE(11640),
    [sym_conditional] = STATE(11640),
    [sym_range] = STATE(11640),
    [sym_binary] = STATE(11640),
    [sym_unary] = STATE(11640),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11254] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11641),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11641),
    [sym_operator_assignment] = STATE(11641),
    [sym_conditional] = STATE(11641),
    [sym_range] = STATE(11641),
    [sym_binary] = STATE(11641),
    [sym_unary] = STATE(11641),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11255] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11642),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11642),
    [sym_operator_assignment] = STATE(11642),
    [sym_conditional] = STATE(11642),
    [sym_range] = STATE(11642),
    [sym_binary] = STATE(11642),
    [sym_unary] = STATE(11642),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11256] = {
    [anon_sym_COLON] = ACTIONS(15105),
    [sym_comment] = ACTIONS(87),
  },
  [11257] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11644),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11644),
    [sym_operator_assignment] = STATE(11644),
    [sym_conditional] = STATE(11644),
    [sym_range] = STATE(11644),
    [sym_binary] = STATE(11644),
    [sym_unary] = STATE(11644),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11258] = {
    [sym__simple_symbol2] = ACTIONS(1093),
    [sym__string_start2] = ACTIONS(1093),
    [sym__symbol_start2] = ACTIONS(1093),
    [sym__subshell_start2] = ACTIONS(1093),
    [sym__regex_start2] = ACTIONS(1093),
    [sym__string_array_start2] = ACTIONS(1093),
    [sym__symbol_array_start2] = ACTIONS(1093),
    [sym__heredoc_body_start2] = ACTIONS(1093),
    [sym_heredoc_beginning2] = ACTIONS(1093),
    [sym__block_ampersand2] = ACTIONS(1093),
    [sym__splat_star2] = ACTIONS(1093),
    [sym__unary_minus2] = ACTIONS(1093),
    [sym__binary_minus2] = ACTIONS(1093),
    [sym__binary_star2] = ACTIONS(1093),
    [sym__identifier_hash_key2] = ACTIONS(1093),
    [anon_sym_LBRACE] = ACTIONS(1093),
    [anon_sym_def] = ACTIONS(1095),
    [anon_sym_LPAREN] = ACTIONS(1095),
    [anon_sym_DOT] = ACTIONS(1095),
    [anon_sym_COLON_COLON] = ACTIONS(1095),
    [anon_sym_COMMA] = ACTIONS(1093),
    [anon_sym_PIPE] = ACTIONS(1095),
    [anon_sym_SEMI] = ACTIONS(1093),
    [anon_sym_STAR] = ACTIONS(1095),
    [anon_sym_STAR_STAR] = ACTIONS(1095),
    [anon_sym_AMP] = ACTIONS(1095),
    [anon_sym_COLON] = ACTIONS(15107),
    [anon_sym_EQ] = ACTIONS(1095),
    [anon_sym_class] = ACTIONS(1095),
    [anon_sym_LT] = ACTIONS(1095),
    [anon_sym_module] = ACTIONS(1095),
    [anon_sym_return] = ACTIONS(1095),
    [anon_sym_yield] = ACTIONS(1095),
    [anon_sym_break] = ACTIONS(1095),
    [anon_sym_next] = ACTIONS(1095),
    [sym_redo] = ACTIONS(1095),
    [sym_retry] = ACTIONS(1095),
    [anon_sym_if] = ACTIONS(1095),
    [anon_sym_unless] = ACTIONS(1095),
    [anon_sym_while] = ACTIONS(1095),
    [anon_sym_until] = ACTIONS(1095),
    [anon_sym_for] = ACTIONS(1095),
    [anon_sym_do] = ACTIONS(1095),
    [anon_sym_case] = ACTIONS(1095),
    [anon_sym_begin] = ACTIONS(1095),
    [anon_sym_EQ_GT] = ACTIONS(1093),
    [anon_sym_LBRACK] = ACTIONS(1093),
    [anon_sym_COLON_COLON2] = ACTIONS(1093),
    [anon_sym_AMP_DOT] = ACTIONS(1093),
    [anon_sym_LPAREN2] = ACTIONS(1093),
    [anon_sym_PLUS_EQ] = ACTIONS(1093),
    [anon_sym_DASH_EQ] = ACTIONS(1093),
    [anon_sym_STAR_EQ] = ACTIONS(1093),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1093),
    [anon_sym_SLASH_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_PIPE_EQ] = ACTIONS(1093),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1093),
    [anon_sym_AMP_EQ] = ACTIONS(1093),
    [anon_sym_PERCENT_EQ] = ACTIONS(1093),
    [anon_sym_GT_GT_EQ] = ACTIONS(1093),
    [anon_sym_LT_LT_EQ] = ACTIONS(1093),
    [anon_sym_CARET_EQ] = ACTIONS(1093),
    [anon_sym_QMARK] = ACTIONS(1095),
    [anon_sym_DOT_DOT] = ACTIONS(1095),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1093),
    [anon_sym_and] = ACTIONS(1095),
    [anon_sym_or] = ACTIONS(1095),
    [anon_sym_PIPE_PIPE] = ACTIONS(1095),
    [anon_sym_AMP_AMP] = ACTIONS(1095),
    [anon_sym_LT_LT] = ACTIONS(1095),
    [anon_sym_GT_GT] = ACTIONS(1095),
    [anon_sym_EQ_EQ] = ACTIONS(1095),
    [anon_sym_BANG_EQ] = ACTIONS(1093),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1093),
    [anon_sym_LT_EQ_GT] = ACTIONS(1093),
    [anon_sym_EQ_TILDE] = ACTIONS(1093),
    [anon_sym_BANG_TILDE] = ACTIONS(1093),
    [anon_sym_LT_EQ] = ACTIONS(1095),
    [anon_sym_GT] = ACTIONS(1095),
    [anon_sym_GT_EQ] = ACTIONS(1093),
    [anon_sym_CARET] = ACTIONS(1095),
    [anon_sym_PLUS] = ACTIONS(1095),
    [anon_sym_SLASH] = ACTIONS(1095),
    [anon_sym_PERCENT] = ACTIONS(1095),
    [anon_sym_defined_QMARK] = ACTIONS(1093),
    [anon_sym_not] = ACTIONS(1095),
    [anon_sym_BANG] = ACTIONS(1095),
    [anon_sym_TILDE] = ACTIONS(1093),
    [sym_constant] = ACTIONS(1095),
    [sym_identifier] = ACTIONS(1095),
    [sym_instance_variable] = ACTIONS(1093),
    [sym_class_variable] = ACTIONS(1093),
    [sym_global_variable] = ACTIONS(1093),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1095),
    [sym_float] = ACTIONS(1095),
    [sym_complex] = ACTIONS(1093),
    [sym_super] = ACTIONS(1095),
    [anon_sym_true] = ACTIONS(1095),
    [anon_sym_TRUE] = ACTIONS(1095),
    [anon_sym_false] = ACTIONS(1095),
    [anon_sym_FALSE] = ACTIONS(1095),
    [sym_self] = ACTIONS(1095),
    [anon_sym_nil] = ACTIONS(1095),
    [anon_sym_NIL] = ACTIONS(1095),
    [sym_character] = ACTIONS(1093),
    [anon_sym_LBRACK2] = ACTIONS(1095),
    [anon_sym_DASH_GT] = ACTIONS(1093),
  },
  [11259] = {
    [sym__heredoc_body_start2] = ACTIONS(1641),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(1641),
    [anon_sym_DOT] = ACTIONS(1647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(1647),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(1641),
    [anon_sym_EQ_GT] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1641),
    [anon_sym_COLON_COLON2] = ACTIONS(1641),
    [anon_sym_AMP_DOT] = ACTIONS(1641),
    [anon_sym_PLUS_EQ] = ACTIONS(1641),
    [anon_sym_DASH_EQ] = ACTIONS(1641),
    [anon_sym_STAR_EQ] = ACTIONS(1641),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1641),
    [anon_sym_SLASH_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_PIPE_EQ] = ACTIONS(1641),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1641),
    [anon_sym_AMP_EQ] = ACTIONS(1641),
    [anon_sym_PERCENT_EQ] = ACTIONS(1641),
    [anon_sym_GT_GT_EQ] = ACTIONS(1641),
    [anon_sym_LT_LT_EQ] = ACTIONS(1641),
    [anon_sym_CARET_EQ] = ACTIONS(1641),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(1641),
    [anon_sym_or] = ACTIONS(1641),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11260] = {
    [sym_heredoc_body] = STATE(11646),
    [aux_sym_call_repeat1] = STATE(11646),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [11261] = {
    [sym_heredoc_body] = STATE(11646),
    [aux_sym_call_repeat1] = STATE(11646),
    [aux_sym_argument_list_repeat1] = STATE(11648),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_LBRACE] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(15109),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1707),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_EQ] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_do] = ACTIONS(1703),
    [anon_sym_EQ_GT] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_PLUS_EQ] = ACTIONS(1703),
    [anon_sym_DASH_EQ] = ACTIONS(1703),
    [anon_sym_STAR_EQ] = ACTIONS(1703),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1703),
    [anon_sym_SLASH_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_PIPE_EQ] = ACTIONS(1703),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(1703),
    [anon_sym_AMP_EQ] = ACTIONS(1703),
    [anon_sym_PERCENT_EQ] = ACTIONS(1703),
    [anon_sym_GT_GT_EQ] = ACTIONS(1703),
    [anon_sym_LT_LT_EQ] = ACTIONS(1703),
    [anon_sym_CARET_EQ] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1707),
    [anon_sym_AMP_AMP] = ACTIONS(1707),
    [anon_sym_LT_LT] = ACTIONS(1707),
    [anon_sym_GT_GT] = ACTIONS(1707),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1707),
    [anon_sym_PLUS] = ACTIONS(1707),
    [anon_sym_SLASH] = ACTIONS(1707),
    [anon_sym_PERCENT] = ACTIONS(1707),
    [sym_comment] = ACTIONS(87),
  },
  [11262] = {
    [sym_string] = STATE(11319),
    [aux_sym_chained_string_repeat1] = STATE(11319),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_COLON] = ACTIONS(15111),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11263] = {
    [sym_heredoc_body] = STATE(11649),
    [aux_sym_call_repeat1] = STATE(11649),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11264] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(11650),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15113),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11265] = {
    [sym_heredoc_body] = STATE(11651),
    [aux_sym_call_repeat1] = STATE(11651),
    [aux_sym_argument_list_repeat1] = STATE(11652),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14538),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11266] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11653),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_splat_argument] = STATE(11654),
    [sym_assignment] = STATE(11653),
    [sym_operator_assignment] = STATE(11653),
    [sym_conditional] = STATE(11653),
    [sym_range] = STATE(11653),
    [sym_binary] = STATE(11653),
    [sym_unary] = STATE(11653),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(11654),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11267] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11655),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11655),
    [sym_operator_assignment] = STATE(11655),
    [sym_conditional] = STATE(11655),
    [sym_range] = STATE(11655),
    [sym_binary] = STATE(11655),
    [sym_unary] = STATE(11655),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11268] = {
    [sym_string] = STATE(11656),
    [aux_sym_chained_string_repeat1] = STATE(11656),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [11269] = {
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11270] = {
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11271] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11272] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11273] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11274] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11275] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15115),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11276] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11277] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11278] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11279] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11280] = {
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11281] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11658),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11658),
    [sym_operator_assignment] = STATE(11658),
    [sym_conditional] = STATE(11658),
    [sym_range] = STATE(11658),
    [sym_binary] = STATE(11658),
    [sym_unary] = STATE(11658),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11282] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(6897),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(363),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(363),
    [sym__binary_star2] = ACTIONS(363),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(363),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(375),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(363),
    [anon_sym_PIPE] = ACTIONS(375),
    [anon_sym_SEMI] = ACTIONS(363),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(375),
    [anon_sym_AMP] = ACTIONS(375),
    [anon_sym_EQ] = ACTIONS(375),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(375),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(375),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(363),
    [anon_sym_COLON_COLON2] = ACTIONS(363),
    [anon_sym_AMP_DOT] = ACTIONS(363),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(363),
    [anon_sym_DASH_EQ] = ACTIONS(363),
    [anon_sym_STAR_EQ] = ACTIONS(363),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(363),
    [anon_sym_SLASH_EQ] = ACTIONS(363),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(363),
    [anon_sym_PIPE_EQ] = ACTIONS(363),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(363),
    [anon_sym_AMP_EQ] = ACTIONS(363),
    [anon_sym_PERCENT_EQ] = ACTIONS(363),
    [anon_sym_GT_GT_EQ] = ACTIONS(363),
    [anon_sym_LT_LT_EQ] = ACTIONS(363),
    [anon_sym_CARET_EQ] = ACTIONS(363),
    [anon_sym_QMARK] = ACTIONS(375),
    [anon_sym_DOT_DOT] = ACTIONS(375),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(363),
    [anon_sym_and] = ACTIONS(375),
    [anon_sym_or] = ACTIONS(375),
    [anon_sym_PIPE_PIPE] = ACTIONS(375),
    [anon_sym_AMP_AMP] = ACTIONS(375),
    [anon_sym_LT_LT] = ACTIONS(375),
    [anon_sym_GT_GT] = ACTIONS(375),
    [anon_sym_EQ_EQ] = ACTIONS(375),
    [anon_sym_BANG_EQ] = ACTIONS(363),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(363),
    [anon_sym_LT_EQ_GT] = ACTIONS(363),
    [anon_sym_EQ_TILDE] = ACTIONS(363),
    [anon_sym_BANG_TILDE] = ACTIONS(363),
    [anon_sym_LT_EQ] = ACTIONS(375),
    [anon_sym_GT] = ACTIONS(375),
    [anon_sym_GT_EQ] = ACTIONS(363),
    [anon_sym_CARET] = ACTIONS(375),
    [anon_sym_PLUS] = ACTIONS(375),
    [anon_sym_SLASH] = ACTIONS(375),
    [anon_sym_PERCENT] = ACTIONS(375),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11283] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(6898),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(415),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(415),
    [sym__binary_star2] = ACTIONS(415),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(415),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(417),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(415),
    [anon_sym_PIPE] = ACTIONS(417),
    [anon_sym_SEMI] = ACTIONS(415),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(417),
    [anon_sym_AMP] = ACTIONS(417),
    [anon_sym_EQ] = ACTIONS(417),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(417),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(417),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(415),
    [anon_sym_COLON_COLON2] = ACTIONS(415),
    [anon_sym_AMP_DOT] = ACTIONS(415),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(415),
    [anon_sym_DASH_EQ] = ACTIONS(415),
    [anon_sym_STAR_EQ] = ACTIONS(415),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(415),
    [anon_sym_SLASH_EQ] = ACTIONS(415),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(415),
    [anon_sym_PIPE_EQ] = ACTIONS(415),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(415),
    [anon_sym_AMP_EQ] = ACTIONS(415),
    [anon_sym_PERCENT_EQ] = ACTIONS(415),
    [anon_sym_GT_GT_EQ] = ACTIONS(415),
    [anon_sym_LT_LT_EQ] = ACTIONS(415),
    [anon_sym_CARET_EQ] = ACTIONS(415),
    [anon_sym_QMARK] = ACTIONS(417),
    [anon_sym_DOT_DOT] = ACTIONS(417),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(415),
    [anon_sym_and] = ACTIONS(417),
    [anon_sym_or] = ACTIONS(417),
    [anon_sym_PIPE_PIPE] = ACTIONS(417),
    [anon_sym_AMP_AMP] = ACTIONS(417),
    [anon_sym_LT_LT] = ACTIONS(417),
    [anon_sym_GT_GT] = ACTIONS(417),
    [anon_sym_EQ_EQ] = ACTIONS(417),
    [anon_sym_BANG_EQ] = ACTIONS(415),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(415),
    [anon_sym_LT_EQ_GT] = ACTIONS(415),
    [anon_sym_EQ_TILDE] = ACTIONS(415),
    [anon_sym_BANG_TILDE] = ACTIONS(415),
    [anon_sym_LT_EQ] = ACTIONS(417),
    [anon_sym_GT] = ACTIONS(417),
    [anon_sym_GT_EQ] = ACTIONS(415),
    [anon_sym_CARET] = ACTIONS(417),
    [anon_sym_PLUS] = ACTIONS(417),
    [anon_sym_SLASH] = ACTIONS(417),
    [anon_sym_PERCENT] = ACTIONS(417),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11284] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(6899),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(419),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(419),
    [sym__binary_star2] = ACTIONS(419),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(419),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(421),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(419),
    [anon_sym_PIPE] = ACTIONS(421),
    [anon_sym_SEMI] = ACTIONS(419),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(421),
    [anon_sym_AMP] = ACTIONS(421),
    [anon_sym_EQ] = ACTIONS(421),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(421),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(421),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(419),
    [anon_sym_COLON_COLON2] = ACTIONS(419),
    [anon_sym_AMP_DOT] = ACTIONS(419),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(419),
    [anon_sym_DASH_EQ] = ACTIONS(419),
    [anon_sym_STAR_EQ] = ACTIONS(419),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(419),
    [anon_sym_SLASH_EQ] = ACTIONS(419),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(419),
    [anon_sym_PIPE_EQ] = ACTIONS(419),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(419),
    [anon_sym_AMP_EQ] = ACTIONS(419),
    [anon_sym_PERCENT_EQ] = ACTIONS(419),
    [anon_sym_GT_GT_EQ] = ACTIONS(419),
    [anon_sym_LT_LT_EQ] = ACTIONS(419),
    [anon_sym_CARET_EQ] = ACTIONS(419),
    [anon_sym_QMARK] = ACTIONS(421),
    [anon_sym_DOT_DOT] = ACTIONS(421),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(419),
    [anon_sym_and] = ACTIONS(421),
    [anon_sym_or] = ACTIONS(421),
    [anon_sym_PIPE_PIPE] = ACTIONS(421),
    [anon_sym_AMP_AMP] = ACTIONS(421),
    [anon_sym_LT_LT] = ACTIONS(421),
    [anon_sym_GT_GT] = ACTIONS(421),
    [anon_sym_EQ_EQ] = ACTIONS(421),
    [anon_sym_BANG_EQ] = ACTIONS(419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(419),
    [anon_sym_LT_EQ_GT] = ACTIONS(419),
    [anon_sym_EQ_TILDE] = ACTIONS(419),
    [anon_sym_BANG_TILDE] = ACTIONS(419),
    [anon_sym_LT_EQ] = ACTIONS(421),
    [anon_sym_GT] = ACTIONS(421),
    [anon_sym_GT_EQ] = ACTIONS(419),
    [anon_sym_CARET] = ACTIONS(421),
    [anon_sym_PLUS] = ACTIONS(421),
    [anon_sym_SLASH] = ACTIONS(421),
    [anon_sym_PERCENT] = ACTIONS(421),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11285] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(6900),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(423),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(423),
    [sym__binary_star2] = ACTIONS(423),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(423),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(425),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_PIPE] = ACTIONS(425),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(425),
    [anon_sym_AMP] = ACTIONS(425),
    [anon_sym_EQ] = ACTIONS(425),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(425),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(425),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(423),
    [anon_sym_COLON_COLON2] = ACTIONS(423),
    [anon_sym_AMP_DOT] = ACTIONS(423),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(423),
    [anon_sym_DASH_EQ] = ACTIONS(423),
    [anon_sym_STAR_EQ] = ACTIONS(423),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(423),
    [anon_sym_SLASH_EQ] = ACTIONS(423),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(423),
    [anon_sym_PIPE_EQ] = ACTIONS(423),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(423),
    [anon_sym_AMP_EQ] = ACTIONS(423),
    [anon_sym_PERCENT_EQ] = ACTIONS(423),
    [anon_sym_GT_GT_EQ] = ACTIONS(423),
    [anon_sym_LT_LT_EQ] = ACTIONS(423),
    [anon_sym_CARET_EQ] = ACTIONS(423),
    [anon_sym_QMARK] = ACTIONS(425),
    [anon_sym_DOT_DOT] = ACTIONS(425),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(423),
    [anon_sym_and] = ACTIONS(425),
    [anon_sym_or] = ACTIONS(425),
    [anon_sym_PIPE_PIPE] = ACTIONS(425),
    [anon_sym_AMP_AMP] = ACTIONS(425),
    [anon_sym_LT_LT] = ACTIONS(425),
    [anon_sym_GT_GT] = ACTIONS(425),
    [anon_sym_EQ_EQ] = ACTIONS(425),
    [anon_sym_BANG_EQ] = ACTIONS(423),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(423),
    [anon_sym_LT_EQ_GT] = ACTIONS(423),
    [anon_sym_EQ_TILDE] = ACTIONS(423),
    [anon_sym_BANG_TILDE] = ACTIONS(423),
    [anon_sym_LT_EQ] = ACTIONS(425),
    [anon_sym_GT] = ACTIONS(425),
    [anon_sym_GT_EQ] = ACTIONS(423),
    [anon_sym_CARET] = ACTIONS(425),
    [anon_sym_PLUS] = ACTIONS(425),
    [anon_sym_SLASH] = ACTIONS(425),
    [anon_sym_PERCENT] = ACTIONS(425),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11286] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11659),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11659),
    [sym_operator_assignment] = STATE(11659),
    [sym_conditional] = STATE(11659),
    [sym_range] = STATE(11659),
    [sym_binary] = STATE(11659),
    [sym_unary] = STATE(11659),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11287] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11660),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11660),
    [sym_operator_assignment] = STATE(11660),
    [sym_conditional] = STATE(11660),
    [sym_range] = STATE(11660),
    [sym_binary] = STATE(11660),
    [sym_unary] = STATE(11660),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11288] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(6916),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(6916),
    [sym_operator_assignment] = STATE(6916),
    [sym_conditional] = STATE(6916),
    [sym_range] = STATE(6916),
    [sym_binary] = STATE(6916),
    [sym_unary] = STATE(6916),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11289] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11290] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_argument_list] = STATE(5035),
    [sym__argument_list_with_parens] = STATE(10472),
    [sym__argument] = STATE(10473),
    [sym_splat_argument] = STATE(10473),
    [sym_hash_splat_argument] = STATE(10473),
    [sym_block_argument] = STATE(10473),
    [sym_do_block] = STATE(1920),
    [sym_block] = STATE(1920),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(10473),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(749),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__binary_minus2] = ACTIONS(749),
    [sym__binary_star2] = ACTIONS(749),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(7705),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(1177),
    [anon_sym_DOT] = ACTIONS(775),
    [anon_sym_COLON_COLON] = ACTIONS(1059),
    [anon_sym_COMMA] = ACTIONS(749),
    [anon_sym_PIPE] = ACTIONS(775),
    [anon_sym_SEMI] = ACTIONS(749),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(775),
    [anon_sym_AMP] = ACTIONS(775),
    [anon_sym_EQ] = ACTIONS(775),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_LT] = ACTIONS(775),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_do] = ACTIONS(775),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_COLON_COLON2] = ACTIONS(749),
    [anon_sym_AMP_DOT] = ACTIONS(749),
    [anon_sym_LPAREN2] = ACTIONS(2925),
    [anon_sym_PLUS_EQ] = ACTIONS(749),
    [anon_sym_DASH_EQ] = ACTIONS(749),
    [anon_sym_STAR_EQ] = ACTIONS(749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(749),
    [anon_sym_SLASH_EQ] = ACTIONS(749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(749),
    [anon_sym_PIPE_EQ] = ACTIONS(749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(749),
    [anon_sym_AMP_EQ] = ACTIONS(749),
    [anon_sym_PERCENT_EQ] = ACTIONS(749),
    [anon_sym_GT_GT_EQ] = ACTIONS(749),
    [anon_sym_LT_LT_EQ] = ACTIONS(749),
    [anon_sym_CARET_EQ] = ACTIONS(749),
    [anon_sym_QMARK] = ACTIONS(775),
    [anon_sym_DOT_DOT] = ACTIONS(775),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(749),
    [anon_sym_and] = ACTIONS(775),
    [anon_sym_or] = ACTIONS(775),
    [anon_sym_PIPE_PIPE] = ACTIONS(775),
    [anon_sym_AMP_AMP] = ACTIONS(775),
    [anon_sym_LT_LT] = ACTIONS(775),
    [anon_sym_GT_GT] = ACTIONS(775),
    [anon_sym_EQ_EQ] = ACTIONS(775),
    [anon_sym_BANG_EQ] = ACTIONS(749),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(749),
    [anon_sym_LT_EQ_GT] = ACTIONS(749),
    [anon_sym_EQ_TILDE] = ACTIONS(749),
    [anon_sym_BANG_TILDE] = ACTIONS(749),
    [anon_sym_LT_EQ] = ACTIONS(775),
    [anon_sym_GT] = ACTIONS(775),
    [anon_sym_GT_EQ] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(775),
    [anon_sym_PLUS] = ACTIONS(775),
    [anon_sym_SLASH] = ACTIONS(775),
    [anon_sym_PERCENT] = ACTIONS(775),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13693),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(1227),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11291] = {
    [anon_sym_EQ] = ACTIONS(15145),
    [sym_comment] = ACTIONS(87),
  },
  [11292] = {
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(15147),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(15149),
    [anon_sym_DASH_EQ] = ACTIONS(15149),
    [anon_sym_STAR_EQ] = ACTIONS(15149),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(15149),
    [anon_sym_SLASH_EQ] = ACTIONS(15149),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(15149),
    [anon_sym_PIPE_EQ] = ACTIONS(15149),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(15149),
    [anon_sym_AMP_EQ] = ACTIONS(15149),
    [anon_sym_PERCENT_EQ] = ACTIONS(15149),
    [anon_sym_GT_GT_EQ] = ACTIONS(15149),
    [anon_sym_LT_LT_EQ] = ACTIONS(15149),
    [anon_sym_CARET_EQ] = ACTIONS(15149),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11293] = {
    [sym_string] = STATE(11675),
    [aux_sym_chained_string_repeat1] = STATE(11675),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11294] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11295] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_EQ_GT] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [11296] = {
    [sym_string] = STATE(11319),
    [aux_sym_chained_string_repeat1] = STATE(11319),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(559),
    [sym__binary_minus2] = ACTIONS(559),
    [sym__binary_star2] = ACTIONS(559),
    [anon_sym_LBRACE] = ACTIONS(559),
    [anon_sym_DOT] = ACTIONS(561),
    [anon_sym_COMMA] = ACTIONS(559),
    [anon_sym_PIPE] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(559),
    [anon_sym_STAR_STAR] = ACTIONS(561),
    [anon_sym_AMP] = ACTIONS(561),
    [anon_sym_EQ] = ACTIONS(561),
    [anon_sym_LT] = ACTIONS(561),
    [anon_sym_do] = ACTIONS(559),
    [anon_sym_EQ_GT] = ACTIONS(559),
    [anon_sym_LBRACK] = ACTIONS(559),
    [anon_sym_COLON_COLON2] = ACTIONS(559),
    [anon_sym_AMP_DOT] = ACTIONS(559),
    [anon_sym_PLUS_EQ] = ACTIONS(559),
    [anon_sym_DASH_EQ] = ACTIONS(559),
    [anon_sym_STAR_EQ] = ACTIONS(559),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(559),
    [anon_sym_SLASH_EQ] = ACTIONS(559),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(559),
    [anon_sym_PIPE_EQ] = ACTIONS(559),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(559),
    [anon_sym_AMP_EQ] = ACTIONS(559),
    [anon_sym_PERCENT_EQ] = ACTIONS(559),
    [anon_sym_GT_GT_EQ] = ACTIONS(559),
    [anon_sym_LT_LT_EQ] = ACTIONS(559),
    [anon_sym_CARET_EQ] = ACTIONS(559),
    [anon_sym_QMARK] = ACTIONS(559),
    [anon_sym_DOT_DOT] = ACTIONS(561),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(559),
    [anon_sym_and] = ACTIONS(559),
    [anon_sym_or] = ACTIONS(559),
    [anon_sym_PIPE_PIPE] = ACTIONS(561),
    [anon_sym_AMP_AMP] = ACTIONS(561),
    [anon_sym_LT_LT] = ACTIONS(561),
    [anon_sym_GT_GT] = ACTIONS(561),
    [anon_sym_EQ_EQ] = ACTIONS(561),
    [anon_sym_BANG_EQ] = ACTIONS(559),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(559),
    [anon_sym_LT_EQ_GT] = ACTIONS(559),
    [anon_sym_EQ_TILDE] = ACTIONS(559),
    [anon_sym_BANG_TILDE] = ACTIONS(559),
    [anon_sym_LT_EQ] = ACTIONS(561),
    [anon_sym_GT] = ACTIONS(561),
    [anon_sym_GT_EQ] = ACTIONS(559),
    [anon_sym_CARET] = ACTIONS(561),
    [anon_sym_PLUS] = ACTIONS(561),
    [anon_sym_SLASH] = ACTIONS(561),
    [anon_sym_PERCENT] = ACTIONS(561),
    [sym_comment] = ACTIONS(87),
  },
  [11297] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11676),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11676),
    [sym_operator_assignment] = STATE(11676),
    [sym_conditional] = STATE(11676),
    [sym_range] = STATE(11676),
    [sym_binary] = STATE(11676),
    [sym_unary] = STATE(11676),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11298] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11299] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [11300] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_EQ_GT] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11301] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11677),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11677),
    [sym_operator_assignment] = STATE(11677),
    [sym_conditional] = STATE(11677),
    [sym_range] = STATE(11677),
    [sym_binary] = STATE(11677),
    [sym_unary] = STATE(11677),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11302] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11678),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11678),
    [sym_operator_assignment] = STATE(11678),
    [sym_conditional] = STATE(11678),
    [sym_range] = STATE(11678),
    [sym_binary] = STATE(11678),
    [sym_unary] = STATE(11678),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11303] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11679),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11679),
    [sym_operator_assignment] = STATE(11679),
    [sym_conditional] = STATE(11679),
    [sym_range] = STATE(11679),
    [sym_binary] = STATE(11679),
    [sym_unary] = STATE(11679),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11304] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11680),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11680),
    [sym_operator_assignment] = STATE(11680),
    [sym_conditional] = STATE(11680),
    [sym_range] = STATE(11680),
    [sym_binary] = STATE(11680),
    [sym_unary] = STATE(11680),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11305] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11681),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11681),
    [sym_operator_assignment] = STATE(11681),
    [sym_conditional] = STATE(11681),
    [sym_range] = STATE(11681),
    [sym_binary] = STATE(11681),
    [sym_unary] = STATE(11681),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11306] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11682),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11682),
    [sym_operator_assignment] = STATE(11682),
    [sym_conditional] = STATE(11682),
    [sym_range] = STATE(11682),
    [sym_binary] = STATE(11682),
    [sym_unary] = STATE(11682),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11307] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11683),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11683),
    [sym_operator_assignment] = STATE(11683),
    [sym_conditional] = STATE(11683),
    [sym_range] = STATE(11683),
    [sym_binary] = STATE(11683),
    [sym_unary] = STATE(11683),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11308] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11684),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11684),
    [sym_operator_assignment] = STATE(11684),
    [sym_conditional] = STATE(11684),
    [sym_range] = STATE(11684),
    [sym_binary] = STATE(11684),
    [sym_unary] = STATE(11684),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11309] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11685),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11685),
    [sym_operator_assignment] = STATE(11685),
    [sym_conditional] = STATE(11685),
    [sym_range] = STATE(11685),
    [sym_binary] = STATE(11685),
    [sym_unary] = STATE(11685),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11310] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11686),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11686),
    [sym_operator_assignment] = STATE(11686),
    [sym_conditional] = STATE(11686),
    [sym_range] = STATE(11686),
    [sym_binary] = STATE(11686),
    [sym_unary] = STATE(11686),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11311] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11687),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11687),
    [sym_operator_assignment] = STATE(11687),
    [sym_conditional] = STATE(11687),
    [sym_range] = STATE(11687),
    [sym_binary] = STATE(11687),
    [sym_unary] = STATE(11687),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11312] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11688),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11688),
    [sym_operator_assignment] = STATE(11688),
    [sym_conditional] = STATE(11688),
    [sym_range] = STATE(11688),
    [sym_binary] = STATE(11688),
    [sym_unary] = STATE(11688),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11313] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11689),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11689),
    [sym_operator_assignment] = STATE(11689),
    [sym_conditional] = STATE(11689),
    [sym_range] = STATE(11689),
    [sym_binary] = STATE(11689),
    [sym_unary] = STATE(11689),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11314] = {
    [sym_heredoc_body] = STATE(11690),
    [aux_sym_call_repeat1] = STATE(11690),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11315] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym__argument] = STATE(6964),
    [sym_splat_argument] = STATE(6964),
    [sym_hash_splat_argument] = STATE(6964),
    [sym_block_argument] = STATE(6964),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(11691),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(6964),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15151),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11316] = {
    [sym_heredoc_body] = STATE(11692),
    [aux_sym_call_repeat1] = STATE(11692),
    [aux_sym_argument_list_repeat1] = STATE(11693),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14608),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11317] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11694),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_splat_argument] = STATE(11695),
    [sym_assignment] = STATE(11694),
    [sym_operator_assignment] = STATE(11694),
    [sym_conditional] = STATE(11694),
    [sym_range] = STATE(11694),
    [sym_binary] = STATE(11694),
    [sym_unary] = STATE(11694),
    [sym_right_assignment_list] = STATE(4551),
    [sym__arg_or_splat_arg] = STATE(11695),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11318] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11696),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11696),
    [sym_operator_assignment] = STATE(11696),
    [sym_conditional] = STATE(11696),
    [sym_range] = STATE(11696),
    [sym_binary] = STATE(11696),
    [sym_unary] = STATE(11696),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11319] = {
    [sym_string] = STATE(11697),
    [aux_sym_chained_string_repeat1] = STATE(11697),
    [sym__string_start2] = ACTIONS(1151),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [11320] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11698),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11698),
    [sym_operator_assignment] = STATE(11698),
    [sym_conditional] = STATE(11698),
    [sym_range] = STATE(11698),
    [sym_binary] = STATE(11698),
    [sym_unary] = STATE(11698),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11321] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11322] = {
    [aux_sym_exceptions_repeat1] = STATE(11700),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11323] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11324] = {
    [sym_string] = STATE(11324),
    [aux_sym_chained_string_repeat1] = STATE(11324),
    [sym__string_start2] = ACTIONS(7095),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11325] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15153),
    [sym_comment] = ACTIONS(87),
  },
  [11326] = {
    [aux_sym_block_parameters_repeat1] = STATE(11702),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15153),
    [sym_comment] = ACTIONS(87),
  },
  [11327] = {
    [sym__line_break2] = ACTIONS(15057),
    [sym__simple_symbol2] = ACTIONS(15057),
    [sym__string_start2] = ACTIONS(15057),
    [sym__symbol_start2] = ACTIONS(15057),
    [sym__subshell_start2] = ACTIONS(15057),
    [sym__regex_start2] = ACTIONS(15057),
    [sym__string_array_start2] = ACTIONS(15057),
    [sym__symbol_array_start2] = ACTIONS(15057),
    [sym__heredoc_body_start2] = ACTIONS(15057),
    [sym_heredoc_beginning2] = ACTIONS(15057),
    [sym__unary_minus2] = ACTIONS(15057),
    [anon_sym_BEGIN] = ACTIONS(15059),
    [anon_sym_LBRACE] = ACTIONS(15057),
    [anon_sym_END] = ACTIONS(15059),
    [anon_sym_def] = ACTIONS(15059),
    [anon_sym_LPAREN] = ACTIONS(15057),
    [anon_sym_COLON_COLON] = ACTIONS(15057),
    [anon_sym_SEMI] = ACTIONS(15057),
    [anon_sym_STAR] = ACTIONS(15057),
    [anon_sym_class] = ACTIONS(15059),
    [anon_sym_module] = ACTIONS(15059),
    [anon_sym_end] = ACTIONS(15059),
    [anon_sym_return] = ACTIONS(15059),
    [anon_sym_yield] = ACTIONS(15059),
    [anon_sym_break] = ACTIONS(15059),
    [anon_sym_next] = ACTIONS(15059),
    [sym_redo] = ACTIONS(15059),
    [sym_retry] = ACTIONS(15059),
    [anon_sym_if] = ACTIONS(15059),
    [anon_sym_unless] = ACTIONS(15059),
    [anon_sym_while] = ACTIONS(15059),
    [anon_sym_until] = ACTIONS(15059),
    [anon_sym_for] = ACTIONS(15059),
    [anon_sym_case] = ACTIONS(15059),
    [anon_sym_begin] = ACTIONS(15059),
    [anon_sym_PLUS] = ACTIONS(15059),
    [anon_sym_defined_QMARK] = ACTIONS(15057),
    [anon_sym_not] = ACTIONS(15059),
    [anon_sym_BANG] = ACTIONS(15057),
    [anon_sym_TILDE] = ACTIONS(15057),
    [sym_constant] = ACTIONS(15059),
    [sym_identifier] = ACTIONS(15059),
    [sym_instance_variable] = ACTIONS(15057),
    [sym_class_variable] = ACTIONS(15057),
    [sym_global_variable] = ACTIONS(15057),
    [anon_sym_undef] = ACTIONS(15059),
    [anon_sym_alias] = ACTIONS(15059),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15059),
    [sym_float] = ACTIONS(15059),
    [sym_complex] = ACTIONS(15057),
    [sym_super] = ACTIONS(15059),
    [anon_sym_true] = ACTIONS(15059),
    [anon_sym_TRUE] = ACTIONS(15059),
    [anon_sym_false] = ACTIONS(15059),
    [anon_sym_FALSE] = ACTIONS(15059),
    [sym_self] = ACTIONS(15059),
    [anon_sym_nil] = ACTIONS(15059),
    [anon_sym_NIL] = ACTIONS(15059),
    [sym_character] = ACTIONS(15057),
    [anon_sym_LBRACK2] = ACTIONS(15057),
    [anon_sym_DASH_GT] = ACTIONS(15057),
  },
  [11328] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15155),
    [sym_comment] = ACTIONS(87),
  },
  [11329] = {
    [aux_sym_block_parameters_repeat1] = STATE(11704),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15155),
    [sym_comment] = ACTIONS(87),
  },
  [11330] = {
    [sym__binary_minus2] = ACTIONS(9516),
    [sym__binary_star2] = ACTIONS(9518),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9522),
    [anon_sym_STAR_STAR] = ACTIONS(9524),
    [anon_sym_AMP] = ACTIONS(9526),
    [anon_sym_LT] = ACTIONS(9528),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9530),
    [anon_sym_DOT_DOT] = ACTIONS(9532),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9534),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9538),
    [anon_sym_AMP_AMP] = ACTIONS(9538),
    [anon_sym_LT_LT] = ACTIONS(9540),
    [anon_sym_GT_GT] = ACTIONS(9540),
    [anon_sym_EQ_EQ] = ACTIONS(9542),
    [anon_sym_BANG_EQ] = ACTIONS(9538),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9538),
    [anon_sym_LT_EQ_GT] = ACTIONS(9538),
    [anon_sym_EQ_TILDE] = ACTIONS(9538),
    [anon_sym_BANG_TILDE] = ACTIONS(9538),
    [anon_sym_LT_EQ] = ACTIONS(9528),
    [anon_sym_GT] = ACTIONS(9528),
    [anon_sym_GT_EQ] = ACTIONS(9544),
    [anon_sym_CARET] = ACTIONS(9546),
    [anon_sym_PLUS] = ACTIONS(9548),
    [anon_sym_SLASH] = ACTIONS(9524),
    [anon_sym_PERCENT] = ACTIONS(9524),
    [sym_comment] = ACTIONS(87),
  },
  [11331] = {
    [aux_sym_exceptions_repeat1] = STATE(11331),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(15157),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11332] = {
    [sym_heredoc_body] = STATE(11332),
    [aux_sym_call_repeat1] = STATE(11332),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_COLON2] = ACTIONS(7893),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11333] = {
    [sym_heredoc_body] = STATE(11332),
    [aux_sym_call_repeat1] = STATE(11332),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_COLON2] = ACTIONS(7905),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11334] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11705),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_assignment] = STATE(11705),
    [sym_operator_assignment] = STATE(11705),
    [sym_conditional] = STATE(11705),
    [sym_range] = STATE(11705),
    [sym_binary] = STATE(11705),
    [sym_unary] = STATE(11705),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11335] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(10506),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(6516),
    [sym_scope_resolution] = STATE(6514),
    [sym_call] = STATE(6514),
    [sym_method_call] = STATE(6516),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(10506),
    [sym_operator_assignment] = STATE(10506),
    [sym_conditional] = STATE(10506),
    [sym_range] = STATE(10506),
    [sym_binary] = STATE(10506),
    [sym_unary] = STATE(10506),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(6515),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6516),
    [sym__variable] = STATE(6514),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(6516),
    [sym_false] = STATE(6516),
    [sym_nil] = STATE(6516),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(6517),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(3948),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(5868),
    [sym__unary_minus2] = ACTIONS(9569),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(9571),
    [anon_sym_yield] = ACTIONS(9573),
    [anon_sym_break] = ACTIONS(9575),
    [anon_sym_next] = ACTIONS(9577),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(9579),
    [anon_sym_defined_QMARK] = ACTIONS(9581),
    [anon_sym_not] = ACTIONS(9583),
    [anon_sym_BANG] = ACTIONS(9585),
    [anon_sym_TILDE] = ACTIONS(9585),
    [sym_constant] = ACTIONS(9587),
    [sym_identifier] = ACTIONS(9587),
    [sym_instance_variable] = ACTIONS(9589),
    [sym_class_variable] = ACTIONS(9589),
    [sym_global_variable] = ACTIONS(9589),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(9587),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9587),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11336] = {
    [aux_sym_exceptions_repeat1] = STATE(11706),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15160),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_COLON2] = ACTIONS(9931),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11337] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9607),
    [sym__binary_star2] = ACTIONS(9609),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9611),
    [anon_sym_STAR_STAR] = ACTIONS(9613),
    [anon_sym_AMP] = ACTIONS(9615),
    [anon_sym_LT] = ACTIONS(9617),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9621),
    [anon_sym_COLON2] = ACTIONS(12839),
    [anon_sym_DOT_DOT] = ACTIONS(9623),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9625),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9627),
    [anon_sym_AMP_AMP] = ACTIONS(9627),
    [anon_sym_LT_LT] = ACTIONS(9629),
    [anon_sym_GT_GT] = ACTIONS(9629),
    [anon_sym_EQ_EQ] = ACTIONS(9631),
    [anon_sym_BANG_EQ] = ACTIONS(9627),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9627),
    [anon_sym_LT_EQ_GT] = ACTIONS(9627),
    [anon_sym_EQ_TILDE] = ACTIONS(9627),
    [anon_sym_BANG_TILDE] = ACTIONS(9627),
    [anon_sym_LT_EQ] = ACTIONS(9617),
    [anon_sym_GT] = ACTIONS(9617),
    [anon_sym_GT_EQ] = ACTIONS(9633),
    [anon_sym_CARET] = ACTIONS(9635),
    [anon_sym_PLUS] = ACTIONS(9637),
    [anon_sym_SLASH] = ACTIONS(9613),
    [anon_sym_PERCENT] = ACTIONS(9613),
    [sym_comment] = ACTIONS(87),
  },
  [11338] = {
    [aux_sym_exceptions_repeat1] = STATE(11338),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15162),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11339] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11707),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_assignment] = STATE(11707),
    [sym_operator_assignment] = STATE(11707),
    [sym_conditional] = STATE(11707),
    [sym_range] = STATE(11707),
    [sym_binary] = STATE(11707),
    [sym_unary] = STATE(11707),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11340] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10539),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(6587),
    [sym_scope_resolution] = STATE(6585),
    [sym_call] = STATE(6585),
    [sym_method_call] = STATE(6587),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(10539),
    [sym_operator_assignment] = STATE(10539),
    [sym_conditional] = STATE(10539),
    [sym_range] = STATE(10539),
    [sym_binary] = STATE(10539),
    [sym_unary] = STATE(10539),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(6586),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6587),
    [sym__variable] = STATE(6585),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(6587),
    [sym_false] = STATE(6587),
    [sym_nil] = STATE(6587),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(6588),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(5932),
    [sym__unary_minus2] = ACTIONS(9657),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(9659),
    [anon_sym_yield] = ACTIONS(9661),
    [anon_sym_break] = ACTIONS(9663),
    [anon_sym_next] = ACTIONS(9665),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(9667),
    [anon_sym_defined_QMARK] = ACTIONS(9669),
    [anon_sym_not] = ACTIONS(9671),
    [anon_sym_BANG] = ACTIONS(9673),
    [anon_sym_TILDE] = ACTIONS(9673),
    [sym_constant] = ACTIONS(9675),
    [sym_identifier] = ACTIONS(9675),
    [sym_instance_variable] = ACTIONS(9677),
    [sym_class_variable] = ACTIONS(9677),
    [sym_global_variable] = ACTIONS(9677),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(9675),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(9675),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11341] = {
    [aux_sym_exceptions_repeat1] = STATE(11708),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15165),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_COLON2] = ACTIONS(9931),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11342] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9687),
    [sym__binary_star2] = ACTIONS(9689),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9691),
    [anon_sym_STAR_STAR] = ACTIONS(9693),
    [anon_sym_AMP] = ACTIONS(9695),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(9697),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9701),
    [anon_sym_COLON2] = ACTIONS(12839),
    [anon_sym_DOT_DOT] = ACTIONS(9703),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9705),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9707),
    [anon_sym_AMP_AMP] = ACTIONS(9707),
    [anon_sym_LT_LT] = ACTIONS(9709),
    [anon_sym_GT_GT] = ACTIONS(9709),
    [anon_sym_EQ_EQ] = ACTIONS(9707),
    [anon_sym_BANG_EQ] = ACTIONS(9711),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9711),
    [anon_sym_LT_EQ_GT] = ACTIONS(9711),
    [anon_sym_EQ_TILDE] = ACTIONS(9711),
    [anon_sym_BANG_TILDE] = ACTIONS(9711),
    [anon_sym_LT_EQ] = ACTIONS(9697),
    [anon_sym_GT] = ACTIONS(9697),
    [anon_sym_GT_EQ] = ACTIONS(9713),
    [anon_sym_CARET] = ACTIONS(9691),
    [anon_sym_PLUS] = ACTIONS(9715),
    [anon_sym_SLASH] = ACTIONS(9693),
    [anon_sym_PERCENT] = ACTIONS(9693),
    [sym_comment] = ACTIONS(87),
  },
  [11343] = {
    [aux_sym_exceptions_repeat1] = STATE(11343),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15167),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11344] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11709),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(6628),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(6628),
    [sym_assignment] = STATE(11709),
    [sym_operator_assignment] = STATE(11709),
    [sym_conditional] = STATE(11709),
    [sym_range] = STATE(11709),
    [sym_binary] = STATE(11709),
    [sym_unary] = STATE(11709),
    [sym_left_assignment_list] = STATE(6627),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6628),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(6628),
    [sym_false] = STATE(6628),
    [sym_nil] = STATE(6628),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(6629),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(9729),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(9731),
    [anon_sym_yield] = ACTIONS(9733),
    [anon_sym_break] = ACTIONS(9735),
    [anon_sym_next] = ACTIONS(9737),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(9739),
    [anon_sym_defined_QMARK] = ACTIONS(9741),
    [anon_sym_not] = ACTIONS(9743),
    [anon_sym_BANG] = ACTIONS(9745),
    [anon_sym_TILDE] = ACTIONS(9745),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11345] = {
    [sym__line_break2] = ACTIONS(12497),
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [ts_builtin_sym_end] = ACTIONS(12497),
    [anon_sym___END__] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12499),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_end] = ACTIONS(12497),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_when] = ACTIONS(12497),
    [anon_sym_elsif] = ACTIONS(12497),
    [anon_sym_else] = ACTIONS(12497),
    [anon_sym_then] = ACTIONS(12497),
    [anon_sym_ensure] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_PLUS_EQ] = ACTIONS(12497),
    [anon_sym_DASH_EQ] = ACTIONS(12497),
    [anon_sym_STAR_EQ] = ACTIONS(12497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12497),
    [anon_sym_SLASH_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12497),
    [anon_sym_AMP_EQ] = ACTIONS(12497),
    [anon_sym_PERCENT_EQ] = ACTIONS(12497),
    [anon_sym_GT_GT_EQ] = ACTIONS(12497),
    [anon_sym_LT_LT_EQ] = ACTIONS(12497),
    [anon_sym_CARET_EQ] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12499),
    [anon_sym_AMP_AMP] = ACTIONS(12499),
    [anon_sym_LT_LT] = ACTIONS(12499),
    [anon_sym_GT_GT] = ACTIONS(12499),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12499),
    [anon_sym_PLUS] = ACTIONS(12499),
    [anon_sym_SLASH] = ACTIONS(12499),
    [anon_sym_PERCENT] = ACTIONS(12499),
    [sym_comment] = ACTIONS(87),
  },
  [11346] = {
    [sym__line_break2] = ACTIONS(12501),
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [ts_builtin_sym_end] = ACTIONS(12501),
    [anon_sym___END__] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12503),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_end] = ACTIONS(12501),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_when] = ACTIONS(12501),
    [anon_sym_elsif] = ACTIONS(12501),
    [anon_sym_else] = ACTIONS(12501),
    [anon_sym_then] = ACTIONS(12501),
    [anon_sym_ensure] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_PLUS_EQ] = ACTIONS(12501),
    [anon_sym_DASH_EQ] = ACTIONS(12501),
    [anon_sym_STAR_EQ] = ACTIONS(12501),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12501),
    [anon_sym_SLASH_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12501),
    [anon_sym_AMP_EQ] = ACTIONS(12501),
    [anon_sym_PERCENT_EQ] = ACTIONS(12501),
    [anon_sym_GT_GT_EQ] = ACTIONS(12501),
    [anon_sym_LT_LT_EQ] = ACTIONS(12501),
    [anon_sym_CARET_EQ] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12503),
    [anon_sym_AMP_AMP] = ACTIONS(12503),
    [anon_sym_LT_LT] = ACTIONS(12503),
    [anon_sym_GT_GT] = ACTIONS(12503),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12503),
    [anon_sym_PLUS] = ACTIONS(12503),
    [anon_sym_SLASH] = ACTIONS(12503),
    [anon_sym_PERCENT] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [11347] = {
    [sym__line_break2] = ACTIONS(12615),
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [ts_builtin_sym_end] = ACTIONS(12615),
    [anon_sym___END__] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12617),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_end] = ACTIONS(12615),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_when] = ACTIONS(12615),
    [anon_sym_elsif] = ACTIONS(12615),
    [anon_sym_else] = ACTIONS(12615),
    [anon_sym_then] = ACTIONS(12615),
    [anon_sym_ensure] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_PLUS_EQ] = ACTIONS(12615),
    [anon_sym_DASH_EQ] = ACTIONS(12615),
    [anon_sym_STAR_EQ] = ACTIONS(12615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12615),
    [anon_sym_SLASH_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12615),
    [anon_sym_AMP_EQ] = ACTIONS(12615),
    [anon_sym_PERCENT_EQ] = ACTIONS(12615),
    [anon_sym_GT_GT_EQ] = ACTIONS(12615),
    [anon_sym_LT_LT_EQ] = ACTIONS(12615),
    [anon_sym_CARET_EQ] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12617),
    [anon_sym_AMP_AMP] = ACTIONS(12617),
    [anon_sym_LT_LT] = ACTIONS(12617),
    [anon_sym_GT_GT] = ACTIONS(12617),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12617),
    [anon_sym_PLUS] = ACTIONS(12617),
    [anon_sym_SLASH] = ACTIONS(12617),
    [anon_sym_PERCENT] = ACTIONS(12617),
    [sym_comment] = ACTIONS(87),
  },
  [11348] = {
    [sym__line_break2] = ACTIONS(12916),
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [ts_builtin_sym_end] = ACTIONS(12916),
    [anon_sym___END__] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12918),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_end] = ACTIONS(12916),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_when] = ACTIONS(12916),
    [anon_sym_elsif] = ACTIONS(12916),
    [anon_sym_else] = ACTIONS(12916),
    [anon_sym_then] = ACTIONS(12916),
    [anon_sym_ensure] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_PLUS_EQ] = ACTIONS(12916),
    [anon_sym_DASH_EQ] = ACTIONS(12916),
    [anon_sym_STAR_EQ] = ACTIONS(12916),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12916),
    [anon_sym_SLASH_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12916),
    [anon_sym_AMP_EQ] = ACTIONS(12916),
    [anon_sym_PERCENT_EQ] = ACTIONS(12916),
    [anon_sym_GT_GT_EQ] = ACTIONS(12916),
    [anon_sym_LT_LT_EQ] = ACTIONS(12916),
    [anon_sym_CARET_EQ] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12918),
    [anon_sym_AMP_AMP] = ACTIONS(12918),
    [anon_sym_LT_LT] = ACTIONS(12918),
    [anon_sym_GT_GT] = ACTIONS(12918),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12918),
    [anon_sym_PLUS] = ACTIONS(12918),
    [anon_sym_SLASH] = ACTIONS(12918),
    [anon_sym_PERCENT] = ACTIONS(12918),
    [sym_comment] = ACTIONS(87),
  },
  [11349] = {
    [anon_sym_end] = ACTIONS(15170),
    [sym_comment] = ACTIONS(87),
  },
  [11350] = {
    [sym__line_break2] = ACTIONS(13064),
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [ts_builtin_sym_end] = ACTIONS(13064),
    [anon_sym___END__] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13066),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_end] = ACTIONS(13064),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_when] = ACTIONS(13064),
    [anon_sym_elsif] = ACTIONS(13064),
    [anon_sym_else] = ACTIONS(13064),
    [anon_sym_then] = ACTIONS(13064),
    [anon_sym_ensure] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_PLUS_EQ] = ACTIONS(13064),
    [anon_sym_DASH_EQ] = ACTIONS(13064),
    [anon_sym_STAR_EQ] = ACTIONS(13064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13064),
    [anon_sym_SLASH_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13064),
    [anon_sym_AMP_EQ] = ACTIONS(13064),
    [anon_sym_PERCENT_EQ] = ACTIONS(13064),
    [anon_sym_GT_GT_EQ] = ACTIONS(13064),
    [anon_sym_LT_LT_EQ] = ACTIONS(13064),
    [anon_sym_CARET_EQ] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13066),
    [anon_sym_AMP_AMP] = ACTIONS(13066),
    [anon_sym_LT_LT] = ACTIONS(13066),
    [anon_sym_GT_GT] = ACTIONS(13066),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13066),
    [anon_sym_PLUS] = ACTIONS(13066),
    [anon_sym_SLASH] = ACTIONS(13066),
    [anon_sym_PERCENT] = ACTIONS(13066),
    [sym_comment] = ACTIONS(87),
  },
  [11351] = {
    [sym__line_break2] = ACTIONS(13216),
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [ts_builtin_sym_end] = ACTIONS(13216),
    [anon_sym___END__] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13218),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_end] = ACTIONS(13216),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_when] = ACTIONS(13216),
    [anon_sym_elsif] = ACTIONS(13216),
    [anon_sym_else] = ACTIONS(13216),
    [anon_sym_then] = ACTIONS(13216),
    [anon_sym_ensure] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_PLUS_EQ] = ACTIONS(13216),
    [anon_sym_DASH_EQ] = ACTIONS(13216),
    [anon_sym_STAR_EQ] = ACTIONS(13216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13216),
    [anon_sym_SLASH_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13216),
    [anon_sym_AMP_EQ] = ACTIONS(13216),
    [anon_sym_PERCENT_EQ] = ACTIONS(13216),
    [anon_sym_GT_GT_EQ] = ACTIONS(13216),
    [anon_sym_LT_LT_EQ] = ACTIONS(13216),
    [anon_sym_CARET_EQ] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13218),
    [anon_sym_AMP_AMP] = ACTIONS(13218),
    [anon_sym_LT_LT] = ACTIONS(13218),
    [anon_sym_GT_GT] = ACTIONS(13218),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13218),
    [anon_sym_PLUS] = ACTIONS(13218),
    [anon_sym_SLASH] = ACTIONS(13218),
    [anon_sym_PERCENT] = ACTIONS(13218),
    [sym_comment] = ACTIONS(87),
  },
  [11352] = {
    [sym__line_break2] = ACTIONS(13227),
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [ts_builtin_sym_end] = ACTIONS(13227),
    [anon_sym___END__] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13229),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_end] = ACTIONS(13227),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_when] = ACTIONS(13227),
    [anon_sym_elsif] = ACTIONS(13227),
    [anon_sym_else] = ACTIONS(13227),
    [anon_sym_then] = ACTIONS(13227),
    [anon_sym_ensure] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_PLUS_EQ] = ACTIONS(13227),
    [anon_sym_DASH_EQ] = ACTIONS(13227),
    [anon_sym_STAR_EQ] = ACTIONS(13227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13227),
    [anon_sym_SLASH_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13227),
    [anon_sym_AMP_EQ] = ACTIONS(13227),
    [anon_sym_PERCENT_EQ] = ACTIONS(13227),
    [anon_sym_GT_GT_EQ] = ACTIONS(13227),
    [anon_sym_LT_LT_EQ] = ACTIONS(13227),
    [anon_sym_CARET_EQ] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13229),
    [anon_sym_AMP_AMP] = ACTIONS(13229),
    [anon_sym_LT_LT] = ACTIONS(13229),
    [anon_sym_GT_GT] = ACTIONS(13229),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13229),
    [anon_sym_PLUS] = ACTIONS(13229),
    [anon_sym_SLASH] = ACTIONS(13229),
    [anon_sym_PERCENT] = ACTIONS(13229),
    [sym_comment] = ACTIONS(87),
  },
  [11353] = {
    [sym__line_break2] = ACTIONS(13551),
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [ts_builtin_sym_end] = ACTIONS(13551),
    [anon_sym___END__] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_end] = ACTIONS(13551),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_when] = ACTIONS(13551),
    [anon_sym_elsif] = ACTIONS(13551),
    [anon_sym_else] = ACTIONS(13551),
    [anon_sym_then] = ACTIONS(13551),
    [anon_sym_ensure] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_PLUS_EQ] = ACTIONS(13551),
    [anon_sym_DASH_EQ] = ACTIONS(13551),
    [anon_sym_STAR_EQ] = ACTIONS(13551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13551),
    [anon_sym_SLASH_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13551),
    [anon_sym_AMP_EQ] = ACTIONS(13551),
    [anon_sym_PERCENT_EQ] = ACTIONS(13551),
    [anon_sym_GT_GT_EQ] = ACTIONS(13551),
    [anon_sym_LT_LT_EQ] = ACTIONS(13551),
    [anon_sym_CARET_EQ] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13553),
    [anon_sym_AMP_AMP] = ACTIONS(13553),
    [anon_sym_LT_LT] = ACTIONS(13553),
    [anon_sym_GT_GT] = ACTIONS(13553),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13553),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_SLASH] = ACTIONS(13553),
    [anon_sym_PERCENT] = ACTIONS(13553),
    [sym_comment] = ACTIONS(87),
  },
  [11354] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11711),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(6746),
    [sym_scope_resolution] = STATE(1586),
    [sym_call] = STATE(1586),
    [sym_method_call] = STATE(6746),
    [sym_assignment] = STATE(11711),
    [sym_operator_assignment] = STATE(11711),
    [sym_conditional] = STATE(11711),
    [sym_range] = STATE(11711),
    [sym_binary] = STATE(11711),
    [sym_unary] = STATE(11711),
    [sym_left_assignment_list] = STATE(6745),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(6746),
    [sym__variable] = STATE(1586),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(6746),
    [sym_false] = STATE(6746),
    [sym_nil] = STATE(6746),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(4171),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(9862),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(3032),
    [anon_sym_yield] = ACTIONS(3034),
    [anon_sym_break] = ACTIONS(3036),
    [anon_sym_next] = ACTIONS(3038),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(9864),
    [anon_sym_defined_QMARK] = ACTIONS(9866),
    [anon_sym_not] = ACTIONS(9868),
    [anon_sym_BANG] = ACTIONS(9870),
    [anon_sym_TILDE] = ACTIONS(9870),
    [sym_constant] = ACTIONS(2707),
    [sym_identifier] = ACTIONS(2707),
    [sym_instance_variable] = ACTIONS(2705),
    [sym_class_variable] = ACTIONS(2705),
    [sym_global_variable] = ACTIONS(2705),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(2707),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11355] = {
    [sym__line_break2] = ACTIONS(14122),
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [ts_builtin_sym_end] = ACTIONS(14122),
    [anon_sym___END__] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14124),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_end] = ACTIONS(14122),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_when] = ACTIONS(14122),
    [anon_sym_elsif] = ACTIONS(14122),
    [anon_sym_else] = ACTIONS(14122),
    [anon_sym_then] = ACTIONS(14122),
    [anon_sym_ensure] = ACTIONS(14122),
    [anon_sym_EQ_GT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_PLUS_EQ] = ACTIONS(14122),
    [anon_sym_DASH_EQ] = ACTIONS(14122),
    [anon_sym_STAR_EQ] = ACTIONS(14122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14122),
    [anon_sym_SLASH_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14122),
    [anon_sym_AMP_EQ] = ACTIONS(14122),
    [anon_sym_PERCENT_EQ] = ACTIONS(14122),
    [anon_sym_GT_GT_EQ] = ACTIONS(14122),
    [anon_sym_LT_LT_EQ] = ACTIONS(14122),
    [anon_sym_CARET_EQ] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14124),
    [anon_sym_AMP_AMP] = ACTIONS(14124),
    [anon_sym_LT_LT] = ACTIONS(14124),
    [anon_sym_GT_GT] = ACTIONS(14124),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14124),
    [anon_sym_PLUS] = ACTIONS(14124),
    [anon_sym_SLASH] = ACTIONS(14124),
    [anon_sym_PERCENT] = ACTIONS(14124),
    [sym_comment] = ACTIONS(87),
  },
  [11356] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(9933),
    [sym__binary_star2] = ACTIONS(9935),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(9937),
    [anon_sym_STAR_STAR] = ACTIONS(9939),
    [anon_sym_AMP] = ACTIONS(9941),
    [anon_sym_LT] = ACTIONS(9943),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(9945),
    [anon_sym_DOT_DOT] = ACTIONS(9947),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9949),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(9951),
    [anon_sym_AMP_AMP] = ACTIONS(9951),
    [anon_sym_LT_LT] = ACTIONS(9953),
    [anon_sym_GT_GT] = ACTIONS(9953),
    [anon_sym_EQ_EQ] = ACTIONS(9955),
    [anon_sym_BANG_EQ] = ACTIONS(9951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9951),
    [anon_sym_LT_EQ_GT] = ACTIONS(9951),
    [anon_sym_EQ_TILDE] = ACTIONS(9951),
    [anon_sym_BANG_TILDE] = ACTIONS(9951),
    [anon_sym_LT_EQ] = ACTIONS(9943),
    [anon_sym_GT] = ACTIONS(9943),
    [anon_sym_GT_EQ] = ACTIONS(9957),
    [anon_sym_CARET] = ACTIONS(9959),
    [anon_sym_PLUS] = ACTIONS(9961),
    [anon_sym_SLASH] = ACTIONS(9939),
    [anon_sym_PERCENT] = ACTIONS(9939),
    [sym_comment] = ACTIONS(87),
  },
  [11357] = {
    [aux_sym_exceptions_repeat1] = STATE(11357),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15172),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11358] = {
    [sym__heredoc_body_start2] = ACTIONS(10127),
    [sym__binary_minus2] = ACTIONS(10127),
    [sym__binary_star2] = ACTIONS(10127),
    [anon_sym_LBRACE] = ACTIONS(10127),
    [anon_sym_RBRACE] = ACTIONS(10127),
    [anon_sym_RPAREN] = ACTIONS(10127),
    [anon_sym_DOT] = ACTIONS(10129),
    [anon_sym_COMMA] = ACTIONS(10127),
    [anon_sym_PIPE] = ACTIONS(10129),
    [anon_sym_SEMI] = ACTIONS(10127),
    [anon_sym_STAR_STAR] = ACTIONS(10129),
    [anon_sym_AMP] = ACTIONS(10129),
    [anon_sym_EQ] = ACTIONS(10129),
    [anon_sym_LT] = ACTIONS(10129),
    [anon_sym_if] = ACTIONS(10127),
    [anon_sym_unless] = ACTIONS(10127),
    [anon_sym_while] = ACTIONS(10127),
    [anon_sym_until] = ACTIONS(10127),
    [anon_sym_rescue] = ACTIONS(10127),
    [anon_sym_in] = ACTIONS(10127),
    [anon_sym_do] = ACTIONS(10127),
    [anon_sym_LBRACK] = ACTIONS(10127),
    [anon_sym_RBRACK] = ACTIONS(10127),
    [anon_sym_COLON_COLON2] = ACTIONS(10127),
    [anon_sym_AMP_DOT] = ACTIONS(10127),
    [anon_sym_PLUS_EQ] = ACTIONS(10127),
    [anon_sym_DASH_EQ] = ACTIONS(10127),
    [anon_sym_STAR_EQ] = ACTIONS(10127),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10127),
    [anon_sym_SLASH_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_PIPE_EQ] = ACTIONS(10127),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10127),
    [anon_sym_AMP_EQ] = ACTIONS(10127),
    [anon_sym_PERCENT_EQ] = ACTIONS(10127),
    [anon_sym_GT_GT_EQ] = ACTIONS(10127),
    [anon_sym_LT_LT_EQ] = ACTIONS(10127),
    [anon_sym_CARET_EQ] = ACTIONS(10127),
    [anon_sym_QMARK] = ACTIONS(10127),
    [anon_sym_COLON2] = ACTIONS(10129),
    [anon_sym_DOT_DOT] = ACTIONS(10129),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10127),
    [anon_sym_and] = ACTIONS(10127),
    [anon_sym_or] = ACTIONS(10127),
    [anon_sym_PIPE_PIPE] = ACTIONS(10129),
    [anon_sym_AMP_AMP] = ACTIONS(10129),
    [anon_sym_LT_LT] = ACTIONS(10129),
    [anon_sym_GT_GT] = ACTIONS(10129),
    [anon_sym_EQ_EQ] = ACTIONS(10129),
    [anon_sym_BANG_EQ] = ACTIONS(10127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10127),
    [anon_sym_LT_EQ_GT] = ACTIONS(10127),
    [anon_sym_EQ_TILDE] = ACTIONS(10127),
    [anon_sym_BANG_TILDE] = ACTIONS(10127),
    [anon_sym_LT_EQ] = ACTIONS(10129),
    [anon_sym_GT] = ACTIONS(10129),
    [anon_sym_GT_EQ] = ACTIONS(10127),
    [anon_sym_CARET] = ACTIONS(10129),
    [anon_sym_PLUS] = ACTIONS(10129),
    [anon_sym_SLASH] = ACTIONS(10129),
    [anon_sym_PERCENT] = ACTIONS(10129),
    [sym_comment] = ACTIONS(87),
  },
  [11359] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1758),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(15175),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [11360] = {
    [sym__heredoc_body_start2] = ACTIONS(10133),
    [sym__binary_minus2] = ACTIONS(10133),
    [sym__binary_star2] = ACTIONS(10133),
    [anon_sym_LBRACE] = ACTIONS(10133),
    [anon_sym_RBRACE] = ACTIONS(10133),
    [anon_sym_RPAREN] = ACTIONS(10133),
    [anon_sym_DOT] = ACTIONS(10135),
    [anon_sym_COMMA] = ACTIONS(10133),
    [anon_sym_PIPE] = ACTIONS(10135),
    [anon_sym_SEMI] = ACTIONS(10133),
    [anon_sym_STAR_STAR] = ACTIONS(10135),
    [anon_sym_AMP] = ACTIONS(10135),
    [anon_sym_EQ] = ACTIONS(10135),
    [anon_sym_LT] = ACTIONS(10135),
    [anon_sym_if] = ACTIONS(10133),
    [anon_sym_unless] = ACTIONS(10133),
    [anon_sym_while] = ACTIONS(10133),
    [anon_sym_until] = ACTIONS(10133),
    [anon_sym_rescue] = ACTIONS(10133),
    [anon_sym_in] = ACTIONS(10133),
    [anon_sym_do] = ACTIONS(10133),
    [anon_sym_LBRACK] = ACTIONS(10133),
    [anon_sym_RBRACK] = ACTIONS(10133),
    [anon_sym_COLON_COLON2] = ACTIONS(10133),
    [anon_sym_AMP_DOT] = ACTIONS(10133),
    [anon_sym_PLUS_EQ] = ACTIONS(10133),
    [anon_sym_DASH_EQ] = ACTIONS(10133),
    [anon_sym_STAR_EQ] = ACTIONS(10133),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10133),
    [anon_sym_SLASH_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_PIPE_EQ] = ACTIONS(10133),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10133),
    [anon_sym_AMP_EQ] = ACTIONS(10133),
    [anon_sym_PERCENT_EQ] = ACTIONS(10133),
    [anon_sym_GT_GT_EQ] = ACTIONS(10133),
    [anon_sym_LT_LT_EQ] = ACTIONS(10133),
    [anon_sym_CARET_EQ] = ACTIONS(10133),
    [anon_sym_QMARK] = ACTIONS(10133),
    [anon_sym_COLON2] = ACTIONS(10135),
    [anon_sym_DOT_DOT] = ACTIONS(10135),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10133),
    [anon_sym_and] = ACTIONS(10133),
    [anon_sym_or] = ACTIONS(10133),
    [anon_sym_PIPE_PIPE] = ACTIONS(10135),
    [anon_sym_AMP_AMP] = ACTIONS(10135),
    [anon_sym_LT_LT] = ACTIONS(10135),
    [anon_sym_GT_GT] = ACTIONS(10135),
    [anon_sym_EQ_EQ] = ACTIONS(10135),
    [anon_sym_BANG_EQ] = ACTIONS(10133),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10133),
    [anon_sym_LT_EQ_GT] = ACTIONS(10133),
    [anon_sym_EQ_TILDE] = ACTIONS(10133),
    [anon_sym_BANG_TILDE] = ACTIONS(10133),
    [anon_sym_LT_EQ] = ACTIONS(10135),
    [anon_sym_GT] = ACTIONS(10135),
    [anon_sym_GT_EQ] = ACTIONS(10133),
    [anon_sym_CARET] = ACTIONS(10135),
    [anon_sym_PLUS] = ACTIONS(10135),
    [anon_sym_SLASH] = ACTIONS(10135),
    [anon_sym_PERCENT] = ACTIONS(10135),
    [sym_comment] = ACTIONS(87),
  },
  [11361] = {
    [sym__heredoc_body_start2] = ACTIONS(10137),
    [sym__binary_minus2] = ACTIONS(10137),
    [sym__binary_star2] = ACTIONS(10137),
    [anon_sym_LBRACE] = ACTIONS(10137),
    [anon_sym_RBRACE] = ACTIONS(10137),
    [anon_sym_RPAREN] = ACTIONS(10137),
    [anon_sym_DOT] = ACTIONS(10139),
    [anon_sym_COMMA] = ACTIONS(10137),
    [anon_sym_PIPE] = ACTIONS(10139),
    [anon_sym_SEMI] = ACTIONS(10137),
    [anon_sym_STAR_STAR] = ACTIONS(10139),
    [anon_sym_AMP] = ACTIONS(10139),
    [anon_sym_EQ] = ACTIONS(10139),
    [anon_sym_LT] = ACTIONS(10139),
    [anon_sym_if] = ACTIONS(10137),
    [anon_sym_unless] = ACTIONS(10137),
    [anon_sym_while] = ACTIONS(10137),
    [anon_sym_until] = ACTIONS(10137),
    [anon_sym_rescue] = ACTIONS(10137),
    [anon_sym_in] = ACTIONS(10137),
    [anon_sym_do] = ACTIONS(10137),
    [anon_sym_LBRACK] = ACTIONS(10137),
    [anon_sym_RBRACK] = ACTIONS(10137),
    [anon_sym_COLON_COLON2] = ACTIONS(10137),
    [anon_sym_AMP_DOT] = ACTIONS(10137),
    [anon_sym_PLUS_EQ] = ACTIONS(10137),
    [anon_sym_DASH_EQ] = ACTIONS(10137),
    [anon_sym_STAR_EQ] = ACTIONS(10137),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10137),
    [anon_sym_SLASH_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_PIPE_EQ] = ACTIONS(10137),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10137),
    [anon_sym_AMP_EQ] = ACTIONS(10137),
    [anon_sym_PERCENT_EQ] = ACTIONS(10137),
    [anon_sym_GT_GT_EQ] = ACTIONS(10137),
    [anon_sym_LT_LT_EQ] = ACTIONS(10137),
    [anon_sym_CARET_EQ] = ACTIONS(10137),
    [anon_sym_QMARK] = ACTIONS(10137),
    [anon_sym_COLON2] = ACTIONS(10139),
    [anon_sym_DOT_DOT] = ACTIONS(10139),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10137),
    [anon_sym_and] = ACTIONS(10137),
    [anon_sym_or] = ACTIONS(10137),
    [anon_sym_PIPE_PIPE] = ACTIONS(10139),
    [anon_sym_AMP_AMP] = ACTIONS(10139),
    [anon_sym_LT_LT] = ACTIONS(10139),
    [anon_sym_GT_GT] = ACTIONS(10139),
    [anon_sym_EQ_EQ] = ACTIONS(10139),
    [anon_sym_BANG_EQ] = ACTIONS(10137),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10137),
    [anon_sym_LT_EQ_GT] = ACTIONS(10137),
    [anon_sym_EQ_TILDE] = ACTIONS(10137),
    [anon_sym_BANG_TILDE] = ACTIONS(10137),
    [anon_sym_LT_EQ] = ACTIONS(10139),
    [anon_sym_GT] = ACTIONS(10139),
    [anon_sym_GT_EQ] = ACTIONS(10137),
    [anon_sym_CARET] = ACTIONS(10139),
    [anon_sym_PLUS] = ACTIONS(10139),
    [anon_sym_SLASH] = ACTIONS(10139),
    [anon_sym_PERCENT] = ACTIONS(10139),
    [sym_comment] = ACTIONS(87),
  },
  [11362] = {
    [sym_interpolation] = STATE(71),
    [sym__literal_contents] = STATE(1766),
    [aux_sym__literal_contents_repeat1] = STATE(71),
    [sym__string_content2] = ACTIONS(119),
    [sym__string_end2] = ACTIONS(15177),
    [sym_comment] = ACTIONS(109),
    [anon_sym_POUND_LBRACE] = ACTIONS(123),
    [sym_escape_sequence] = ACTIONS(119),
  },
  [11363] = {
    [sym__heredoc_body_start2] = ACTIONS(10143),
    [sym__binary_minus2] = ACTIONS(10143),
    [sym__binary_star2] = ACTIONS(10143),
    [anon_sym_LBRACE] = ACTIONS(10143),
    [anon_sym_RBRACE] = ACTIONS(10143),
    [anon_sym_RPAREN] = ACTIONS(10143),
    [anon_sym_DOT] = ACTIONS(10145),
    [anon_sym_COMMA] = ACTIONS(10143),
    [anon_sym_PIPE] = ACTIONS(10145),
    [anon_sym_SEMI] = ACTIONS(10143),
    [anon_sym_STAR_STAR] = ACTIONS(10145),
    [anon_sym_AMP] = ACTIONS(10145),
    [anon_sym_EQ] = ACTIONS(10145),
    [anon_sym_LT] = ACTIONS(10145),
    [anon_sym_if] = ACTIONS(10143),
    [anon_sym_unless] = ACTIONS(10143),
    [anon_sym_while] = ACTIONS(10143),
    [anon_sym_until] = ACTIONS(10143),
    [anon_sym_rescue] = ACTIONS(10143),
    [anon_sym_in] = ACTIONS(10143),
    [anon_sym_do] = ACTIONS(10143),
    [anon_sym_LBRACK] = ACTIONS(10143),
    [anon_sym_RBRACK] = ACTIONS(10143),
    [anon_sym_COLON_COLON2] = ACTIONS(10143),
    [anon_sym_AMP_DOT] = ACTIONS(10143),
    [anon_sym_PLUS_EQ] = ACTIONS(10143),
    [anon_sym_DASH_EQ] = ACTIONS(10143),
    [anon_sym_STAR_EQ] = ACTIONS(10143),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10143),
    [anon_sym_SLASH_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_PIPE_EQ] = ACTIONS(10143),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10143),
    [anon_sym_AMP_EQ] = ACTIONS(10143),
    [anon_sym_PERCENT_EQ] = ACTIONS(10143),
    [anon_sym_GT_GT_EQ] = ACTIONS(10143),
    [anon_sym_LT_LT_EQ] = ACTIONS(10143),
    [anon_sym_CARET_EQ] = ACTIONS(10143),
    [anon_sym_QMARK] = ACTIONS(10143),
    [anon_sym_COLON2] = ACTIONS(10145),
    [anon_sym_DOT_DOT] = ACTIONS(10145),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10143),
    [anon_sym_and] = ACTIONS(10143),
    [anon_sym_or] = ACTIONS(10143),
    [anon_sym_PIPE_PIPE] = ACTIONS(10145),
    [anon_sym_AMP_AMP] = ACTIONS(10145),
    [anon_sym_LT_LT] = ACTIONS(10145),
    [anon_sym_GT_GT] = ACTIONS(10145),
    [anon_sym_EQ_EQ] = ACTIONS(10145),
    [anon_sym_BANG_EQ] = ACTIONS(10143),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10143),
    [anon_sym_LT_EQ_GT] = ACTIONS(10143),
    [anon_sym_EQ_TILDE] = ACTIONS(10143),
    [anon_sym_BANG_TILDE] = ACTIONS(10143),
    [anon_sym_LT_EQ] = ACTIONS(10145),
    [anon_sym_GT] = ACTIONS(10145),
    [anon_sym_GT_EQ] = ACTIONS(10143),
    [anon_sym_CARET] = ACTIONS(10145),
    [anon_sym_PLUS] = ACTIONS(10145),
    [anon_sym_SLASH] = ACTIONS(10145),
    [anon_sym_PERCENT] = ACTIONS(10145),
    [sym_comment] = ACTIONS(87),
  },
  [11364] = {
    [sym__method_rest] = STATE(11714),
    [sym_operator] = STATE(6889),
    [sym__method_name] = STATE(6889),
    [sym_setter] = STATE(6889),
    [sym_symbol] = STATE(6889),
    [sym__simple_symbol2] = ACTIONS(229),
    [sym__symbol_start2] = ACTIONS(231),
    [anon_sym_PIPE] = ACTIONS(235),
    [anon_sym_STAR] = ACTIONS(237),
    [anon_sym_STAR_STAR] = ACTIONS(235),
    [anon_sym_AMP] = ACTIONS(235),
    [anon_sym_LT] = ACTIONS(237),
    [anon_sym_DOT_DOT] = ACTIONS(235),
    [anon_sym_LT_LT] = ACTIONS(235),
    [anon_sym_GT_GT] = ACTIONS(235),
    [anon_sym_EQ_EQ] = ACTIONS(237),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(235),
    [anon_sym_LT_EQ_GT] = ACTIONS(235),
    [anon_sym_EQ_TILDE] = ACTIONS(235),
    [anon_sym_BANG_TILDE] = ACTIONS(235),
    [anon_sym_LT_EQ] = ACTIONS(237),
    [anon_sym_GT] = ACTIONS(237),
    [anon_sym_GT_EQ] = ACTIONS(235),
    [anon_sym_CARET] = ACTIONS(235),
    [anon_sym_PLUS] = ACTIONS(237),
    [anon_sym_SLASH] = ACTIONS(235),
    [anon_sym_PERCENT] = ACTIONS(235),
    [anon_sym_BANG] = ACTIONS(237),
    [anon_sym_TILDE] = ACTIONS(235),
    [sym_constant] = ACTIONS(13855),
    [sym_identifier] = ACTIONS(545),
    [sym_instance_variable] = ACTIONS(13855),
    [sym_class_variable] = ACTIONS(13855),
    [sym_global_variable] = ACTIONS(13855),
    [anon_sym_DASH] = ACTIONS(237),
    [anon_sym_PLUS_AT] = ACTIONS(235),
    [anon_sym_DASH_AT] = ACTIONS(235),
    [anon_sym_LBRACK_RBRACK] = ACTIONS(237),
    [anon_sym_LBRACK_RBRACK_EQ] = ACTIONS(235),
    [anon_sym_BQUOTE] = ACTIONS(235),
    [sym_comment] = ACTIONS(87),
  },
  [11365] = {
    [sym__heredoc_body_start2] = ACTIONS(10896),
    [sym__binary_minus2] = ACTIONS(10896),
    [sym__binary_star2] = ACTIONS(10896),
    [anon_sym_LBRACE] = ACTIONS(10896),
    [anon_sym_RBRACE] = ACTIONS(10896),
    [anon_sym_RPAREN] = ACTIONS(10896),
    [anon_sym_DOT] = ACTIONS(10898),
    [anon_sym_COMMA] = ACTIONS(10896),
    [anon_sym_PIPE] = ACTIONS(10898),
    [anon_sym_SEMI] = ACTIONS(10896),
    [anon_sym_STAR_STAR] = ACTIONS(10898),
    [anon_sym_AMP] = ACTIONS(10898),
    [anon_sym_EQ] = ACTIONS(10898),
    [anon_sym_LT] = ACTIONS(10898),
    [anon_sym_if] = ACTIONS(10896),
    [anon_sym_unless] = ACTIONS(10896),
    [anon_sym_while] = ACTIONS(10896),
    [anon_sym_until] = ACTIONS(10896),
    [anon_sym_rescue] = ACTIONS(10896),
    [anon_sym_in] = ACTIONS(10896),
    [anon_sym_do] = ACTIONS(10896),
    [anon_sym_LBRACK] = ACTIONS(10896),
    [anon_sym_RBRACK] = ACTIONS(10896),
    [anon_sym_COLON_COLON2] = ACTIONS(10896),
    [anon_sym_AMP_DOT] = ACTIONS(10896),
    [anon_sym_PLUS_EQ] = ACTIONS(10896),
    [anon_sym_DASH_EQ] = ACTIONS(10896),
    [anon_sym_STAR_EQ] = ACTIONS(10896),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10896),
    [anon_sym_SLASH_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_PIPE_EQ] = ACTIONS(10896),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10896),
    [anon_sym_AMP_EQ] = ACTIONS(10896),
    [anon_sym_PERCENT_EQ] = ACTIONS(10896),
    [anon_sym_GT_GT_EQ] = ACTIONS(10896),
    [anon_sym_LT_LT_EQ] = ACTIONS(10896),
    [anon_sym_CARET_EQ] = ACTIONS(10896),
    [anon_sym_QMARK] = ACTIONS(10896),
    [anon_sym_COLON2] = ACTIONS(10898),
    [anon_sym_DOT_DOT] = ACTIONS(10898),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10896),
    [anon_sym_and] = ACTIONS(10896),
    [anon_sym_or] = ACTIONS(10896),
    [anon_sym_PIPE_PIPE] = ACTIONS(10898),
    [anon_sym_AMP_AMP] = ACTIONS(10898),
    [anon_sym_LT_LT] = ACTIONS(10898),
    [anon_sym_GT_GT] = ACTIONS(10898),
    [anon_sym_EQ_EQ] = ACTIONS(10898),
    [anon_sym_BANG_EQ] = ACTIONS(10896),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10896),
    [anon_sym_LT_EQ_GT] = ACTIONS(10896),
    [anon_sym_EQ_TILDE] = ACTIONS(10896),
    [anon_sym_BANG_TILDE] = ACTIONS(10896),
    [anon_sym_LT_EQ] = ACTIONS(10898),
    [anon_sym_GT] = ACTIONS(10898),
    [anon_sym_GT_EQ] = ACTIONS(10896),
    [anon_sym_CARET] = ACTIONS(10898),
    [anon_sym_PLUS] = ACTIONS(10898),
    [anon_sym_SLASH] = ACTIONS(10898),
    [anon_sym_PERCENT] = ACTIONS(10898),
    [sym_comment] = ACTIONS(87),
  },
  [11366] = {
    [sym__heredoc_body_start2] = ACTIONS(10900),
    [sym__binary_minus2] = ACTIONS(10900),
    [sym__binary_star2] = ACTIONS(10900),
    [anon_sym_LBRACE] = ACTIONS(10900),
    [anon_sym_RBRACE] = ACTIONS(10900),
    [anon_sym_RPAREN] = ACTIONS(10900),
    [anon_sym_DOT] = ACTIONS(10902),
    [anon_sym_COMMA] = ACTIONS(10900),
    [anon_sym_PIPE] = ACTIONS(10902),
    [anon_sym_SEMI] = ACTIONS(10900),
    [anon_sym_STAR_STAR] = ACTIONS(10902),
    [anon_sym_AMP] = ACTIONS(10902),
    [anon_sym_EQ] = ACTIONS(10902),
    [anon_sym_LT] = ACTIONS(10902),
    [anon_sym_if] = ACTIONS(10900),
    [anon_sym_unless] = ACTIONS(10900),
    [anon_sym_while] = ACTIONS(10900),
    [anon_sym_until] = ACTIONS(10900),
    [anon_sym_rescue] = ACTIONS(10900),
    [anon_sym_in] = ACTIONS(10900),
    [anon_sym_do] = ACTIONS(10900),
    [anon_sym_LBRACK] = ACTIONS(10900),
    [anon_sym_RBRACK] = ACTIONS(10900),
    [anon_sym_COLON_COLON2] = ACTIONS(10900),
    [anon_sym_AMP_DOT] = ACTIONS(10900),
    [anon_sym_PLUS_EQ] = ACTIONS(10900),
    [anon_sym_DASH_EQ] = ACTIONS(10900),
    [anon_sym_STAR_EQ] = ACTIONS(10900),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(10900),
    [anon_sym_SLASH_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_PIPE_EQ] = ACTIONS(10900),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(10900),
    [anon_sym_AMP_EQ] = ACTIONS(10900),
    [anon_sym_PERCENT_EQ] = ACTIONS(10900),
    [anon_sym_GT_GT_EQ] = ACTIONS(10900),
    [anon_sym_LT_LT_EQ] = ACTIONS(10900),
    [anon_sym_CARET_EQ] = ACTIONS(10900),
    [anon_sym_QMARK] = ACTIONS(10900),
    [anon_sym_COLON2] = ACTIONS(10902),
    [anon_sym_DOT_DOT] = ACTIONS(10902),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10900),
    [anon_sym_and] = ACTIONS(10900),
    [anon_sym_or] = ACTIONS(10900),
    [anon_sym_PIPE_PIPE] = ACTIONS(10902),
    [anon_sym_AMP_AMP] = ACTIONS(10902),
    [anon_sym_LT_LT] = ACTIONS(10902),
    [anon_sym_GT_GT] = ACTIONS(10902),
    [anon_sym_EQ_EQ] = ACTIONS(10902),
    [anon_sym_BANG_EQ] = ACTIONS(10900),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10900),
    [anon_sym_LT_EQ_GT] = ACTIONS(10900),
    [anon_sym_EQ_TILDE] = ACTIONS(10900),
    [anon_sym_BANG_TILDE] = ACTIONS(10900),
    [anon_sym_LT_EQ] = ACTIONS(10902),
    [anon_sym_GT] = ACTIONS(10902),
    [anon_sym_GT_EQ] = ACTIONS(10900),
    [anon_sym_CARET] = ACTIONS(10902),
    [anon_sym_PLUS] = ACTIONS(10902),
    [anon_sym_SLASH] = ACTIONS(10902),
    [anon_sym_PERCENT] = ACTIONS(10902),
    [sym_comment] = ACTIONS(87),
  },
  [11367] = {
    [sym__heredoc_body_start2] = ACTIONS(11061),
    [sym__binary_minus2] = ACTIONS(11061),
    [sym__binary_star2] = ACTIONS(11061),
    [anon_sym_LBRACE] = ACTIONS(11061),
    [anon_sym_RBRACE] = ACTIONS(11061),
    [anon_sym_RPAREN] = ACTIONS(11061),
    [anon_sym_DOT] = ACTIONS(11063),
    [anon_sym_COMMA] = ACTIONS(11061),
    [anon_sym_PIPE] = ACTIONS(11063),
    [anon_sym_SEMI] = ACTIONS(11061),
    [anon_sym_STAR_STAR] = ACTIONS(11063),
    [anon_sym_AMP] = ACTIONS(11063),
    [anon_sym_EQ] = ACTIONS(11063),
    [anon_sym_LT] = ACTIONS(11063),
    [anon_sym_if] = ACTIONS(11061),
    [anon_sym_unless] = ACTIONS(11061),
    [anon_sym_while] = ACTIONS(11061),
    [anon_sym_until] = ACTIONS(11061),
    [anon_sym_rescue] = ACTIONS(11061),
    [anon_sym_in] = ACTIONS(11061),
    [anon_sym_do] = ACTIONS(11061),
    [anon_sym_LBRACK] = ACTIONS(11061),
    [anon_sym_RBRACK] = ACTIONS(11061),
    [anon_sym_COLON_COLON2] = ACTIONS(11061),
    [anon_sym_AMP_DOT] = ACTIONS(11061),
    [anon_sym_PLUS_EQ] = ACTIONS(11061),
    [anon_sym_DASH_EQ] = ACTIONS(11061),
    [anon_sym_STAR_EQ] = ACTIONS(11061),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11061),
    [anon_sym_SLASH_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_PIPE_EQ] = ACTIONS(11061),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11061),
    [anon_sym_AMP_EQ] = ACTIONS(11061),
    [anon_sym_PERCENT_EQ] = ACTIONS(11061),
    [anon_sym_GT_GT_EQ] = ACTIONS(11061),
    [anon_sym_LT_LT_EQ] = ACTIONS(11061),
    [anon_sym_CARET_EQ] = ACTIONS(11061),
    [anon_sym_QMARK] = ACTIONS(11061),
    [anon_sym_COLON2] = ACTIONS(11063),
    [anon_sym_DOT_DOT] = ACTIONS(11063),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11061),
    [anon_sym_and] = ACTIONS(11061),
    [anon_sym_or] = ACTIONS(11061),
    [anon_sym_PIPE_PIPE] = ACTIONS(11063),
    [anon_sym_AMP_AMP] = ACTIONS(11063),
    [anon_sym_LT_LT] = ACTIONS(11063),
    [anon_sym_GT_GT] = ACTIONS(11063),
    [anon_sym_EQ_EQ] = ACTIONS(11063),
    [anon_sym_BANG_EQ] = ACTIONS(11061),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11061),
    [anon_sym_LT_EQ_GT] = ACTIONS(11061),
    [anon_sym_EQ_TILDE] = ACTIONS(11061),
    [anon_sym_BANG_TILDE] = ACTIONS(11061),
    [anon_sym_LT_EQ] = ACTIONS(11063),
    [anon_sym_GT] = ACTIONS(11063),
    [anon_sym_GT_EQ] = ACTIONS(11061),
    [anon_sym_CARET] = ACTIONS(11063),
    [anon_sym_PLUS] = ACTIONS(11063),
    [anon_sym_SLASH] = ACTIONS(11063),
    [anon_sym_PERCENT] = ACTIONS(11063),
    [sym_comment] = ACTIONS(87),
  },
  [11368] = {
    [anon_sym_end] = ACTIONS(15179),
    [sym_comment] = ACTIONS(87),
  },
  [11369] = {
    [sym_elsif] = STATE(11716),
    [sym_else] = STATE(11716),
    [sym__if_tail] = STATE(11716),
    [anon_sym_end] = ACTIONS(15179),
    [anon_sym_elsif] = ACTIONS(8010),
    [anon_sym_else] = ACTIONS(8012),
    [sym_comment] = ACTIONS(87),
  },
  [11370] = {
    [sym__heredoc_body_start2] = ACTIONS(11236),
    [sym__binary_minus2] = ACTIONS(11236),
    [sym__binary_star2] = ACTIONS(11236),
    [anon_sym_LBRACE] = ACTIONS(11236),
    [anon_sym_RBRACE] = ACTIONS(11236),
    [anon_sym_RPAREN] = ACTIONS(11236),
    [anon_sym_DOT] = ACTIONS(11238),
    [anon_sym_COMMA] = ACTIONS(11236),
    [anon_sym_PIPE] = ACTIONS(11238),
    [anon_sym_SEMI] = ACTIONS(11236),
    [anon_sym_STAR_STAR] = ACTIONS(11238),
    [anon_sym_AMP] = ACTIONS(11238),
    [anon_sym_EQ] = ACTIONS(11238),
    [anon_sym_LT] = ACTIONS(11238),
    [anon_sym_if] = ACTIONS(11236),
    [anon_sym_unless] = ACTIONS(11236),
    [anon_sym_while] = ACTIONS(11236),
    [anon_sym_until] = ACTIONS(11236),
    [anon_sym_rescue] = ACTIONS(11236),
    [anon_sym_in] = ACTIONS(11236),
    [anon_sym_do] = ACTIONS(11236),
    [anon_sym_LBRACK] = ACTIONS(11236),
    [anon_sym_RBRACK] = ACTIONS(11236),
    [anon_sym_COLON_COLON2] = ACTIONS(11236),
    [anon_sym_AMP_DOT] = ACTIONS(11236),
    [anon_sym_PLUS_EQ] = ACTIONS(11236),
    [anon_sym_DASH_EQ] = ACTIONS(11236),
    [anon_sym_STAR_EQ] = ACTIONS(11236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11236),
    [anon_sym_SLASH_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_PIPE_EQ] = ACTIONS(11236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11236),
    [anon_sym_AMP_EQ] = ACTIONS(11236),
    [anon_sym_PERCENT_EQ] = ACTIONS(11236),
    [anon_sym_GT_GT_EQ] = ACTIONS(11236),
    [anon_sym_LT_LT_EQ] = ACTIONS(11236),
    [anon_sym_CARET_EQ] = ACTIONS(11236),
    [anon_sym_QMARK] = ACTIONS(11236),
    [anon_sym_COLON2] = ACTIONS(11238),
    [anon_sym_DOT_DOT] = ACTIONS(11238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11236),
    [anon_sym_and] = ACTIONS(11236),
    [anon_sym_or] = ACTIONS(11236),
    [anon_sym_PIPE_PIPE] = ACTIONS(11238),
    [anon_sym_AMP_AMP] = ACTIONS(11238),
    [anon_sym_LT_LT] = ACTIONS(11238),
    [anon_sym_GT_GT] = ACTIONS(11238),
    [anon_sym_EQ_EQ] = ACTIONS(11238),
    [anon_sym_BANG_EQ] = ACTIONS(11236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11236),
    [anon_sym_LT_EQ_GT] = ACTIONS(11236),
    [anon_sym_EQ_TILDE] = ACTIONS(11236),
    [anon_sym_BANG_TILDE] = ACTIONS(11236),
    [anon_sym_LT_EQ] = ACTIONS(11238),
    [anon_sym_GT] = ACTIONS(11238),
    [anon_sym_GT_EQ] = ACTIONS(11236),
    [anon_sym_CARET] = ACTIONS(11238),
    [anon_sym_PLUS] = ACTIONS(11238),
    [anon_sym_SLASH] = ACTIONS(11238),
    [anon_sym_PERCENT] = ACTIONS(11238),
    [sym_comment] = ACTIONS(87),
  },
  [11371] = {
    [anon_sym_end] = ACTIONS(15181),
    [sym_comment] = ACTIONS(87),
  },
  [11372] = {
    [sym__heredoc_body_start2] = ACTIONS(11333),
    [sym__binary_minus2] = ACTIONS(11333),
    [sym__binary_star2] = ACTIONS(11333),
    [anon_sym_LBRACE] = ACTIONS(11333),
    [anon_sym_RBRACE] = ACTIONS(11333),
    [anon_sym_RPAREN] = ACTIONS(11333),
    [anon_sym_DOT] = ACTIONS(11335),
    [anon_sym_COMMA] = ACTIONS(11333),
    [anon_sym_PIPE] = ACTIONS(11335),
    [anon_sym_SEMI] = ACTIONS(11333),
    [anon_sym_STAR_STAR] = ACTIONS(11335),
    [anon_sym_AMP] = ACTIONS(11335),
    [anon_sym_EQ] = ACTIONS(11335),
    [anon_sym_LT] = ACTIONS(11335),
    [anon_sym_if] = ACTIONS(11333),
    [anon_sym_unless] = ACTIONS(11333),
    [anon_sym_while] = ACTIONS(11333),
    [anon_sym_until] = ACTIONS(11333),
    [anon_sym_rescue] = ACTIONS(11333),
    [anon_sym_in] = ACTIONS(11333),
    [anon_sym_do] = ACTIONS(11333),
    [anon_sym_LBRACK] = ACTIONS(11333),
    [anon_sym_RBRACK] = ACTIONS(11333),
    [anon_sym_COLON_COLON2] = ACTIONS(11333),
    [anon_sym_AMP_DOT] = ACTIONS(11333),
    [anon_sym_PLUS_EQ] = ACTIONS(11333),
    [anon_sym_DASH_EQ] = ACTIONS(11333),
    [anon_sym_STAR_EQ] = ACTIONS(11333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11333),
    [anon_sym_SLASH_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_PIPE_EQ] = ACTIONS(11333),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11333),
    [anon_sym_AMP_EQ] = ACTIONS(11333),
    [anon_sym_PERCENT_EQ] = ACTIONS(11333),
    [anon_sym_GT_GT_EQ] = ACTIONS(11333),
    [anon_sym_LT_LT_EQ] = ACTIONS(11333),
    [anon_sym_CARET_EQ] = ACTIONS(11333),
    [anon_sym_QMARK] = ACTIONS(11333),
    [anon_sym_COLON2] = ACTIONS(11335),
    [anon_sym_DOT_DOT] = ACTIONS(11335),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11333),
    [anon_sym_and] = ACTIONS(11333),
    [anon_sym_or] = ACTIONS(11333),
    [anon_sym_PIPE_PIPE] = ACTIONS(11335),
    [anon_sym_AMP_AMP] = ACTIONS(11335),
    [anon_sym_LT_LT] = ACTIONS(11335),
    [anon_sym_GT_GT] = ACTIONS(11335),
    [anon_sym_EQ_EQ] = ACTIONS(11335),
    [anon_sym_BANG_EQ] = ACTIONS(11333),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11333),
    [anon_sym_LT_EQ_GT] = ACTIONS(11333),
    [anon_sym_EQ_TILDE] = ACTIONS(11333),
    [anon_sym_BANG_TILDE] = ACTIONS(11333),
    [anon_sym_LT_EQ] = ACTIONS(11335),
    [anon_sym_GT] = ACTIONS(11335),
    [anon_sym_GT_EQ] = ACTIONS(11333),
    [anon_sym_CARET] = ACTIONS(11335),
    [anon_sym_PLUS] = ACTIONS(11335),
    [anon_sym_SLASH] = ACTIONS(11335),
    [anon_sym_PERCENT] = ACTIONS(11335),
    [sym_comment] = ACTIONS(87),
  },
  [11373] = {
    [sym__heredoc_body_start2] = ACTIONS(11342),
    [sym__binary_minus2] = ACTIONS(11342),
    [sym__binary_star2] = ACTIONS(11342),
    [anon_sym_LBRACE] = ACTIONS(11342),
    [anon_sym_RBRACE] = ACTIONS(11342),
    [anon_sym_RPAREN] = ACTIONS(11342),
    [anon_sym_DOT] = ACTIONS(11344),
    [anon_sym_COMMA] = ACTIONS(11342),
    [anon_sym_PIPE] = ACTIONS(11344),
    [anon_sym_SEMI] = ACTIONS(11342),
    [anon_sym_STAR_STAR] = ACTIONS(11344),
    [anon_sym_AMP] = ACTIONS(11344),
    [anon_sym_EQ] = ACTIONS(11344),
    [anon_sym_LT] = ACTIONS(11344),
    [anon_sym_if] = ACTIONS(11342),
    [anon_sym_unless] = ACTIONS(11342),
    [anon_sym_while] = ACTIONS(11342),
    [anon_sym_until] = ACTIONS(11342),
    [anon_sym_rescue] = ACTIONS(11342),
    [anon_sym_in] = ACTIONS(11342),
    [anon_sym_do] = ACTIONS(11342),
    [anon_sym_LBRACK] = ACTIONS(11342),
    [anon_sym_RBRACK] = ACTIONS(11342),
    [anon_sym_COLON_COLON2] = ACTIONS(11342),
    [anon_sym_AMP_DOT] = ACTIONS(11342),
    [anon_sym_PLUS_EQ] = ACTIONS(11342),
    [anon_sym_DASH_EQ] = ACTIONS(11342),
    [anon_sym_STAR_EQ] = ACTIONS(11342),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11342),
    [anon_sym_SLASH_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_PIPE_EQ] = ACTIONS(11342),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11342),
    [anon_sym_AMP_EQ] = ACTIONS(11342),
    [anon_sym_PERCENT_EQ] = ACTIONS(11342),
    [anon_sym_GT_GT_EQ] = ACTIONS(11342),
    [anon_sym_LT_LT_EQ] = ACTIONS(11342),
    [anon_sym_CARET_EQ] = ACTIONS(11342),
    [anon_sym_QMARK] = ACTIONS(11342),
    [anon_sym_COLON2] = ACTIONS(11344),
    [anon_sym_DOT_DOT] = ACTIONS(11344),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11342),
    [anon_sym_and] = ACTIONS(11342),
    [anon_sym_or] = ACTIONS(11342),
    [anon_sym_PIPE_PIPE] = ACTIONS(11344),
    [anon_sym_AMP_AMP] = ACTIONS(11344),
    [anon_sym_LT_LT] = ACTIONS(11344),
    [anon_sym_GT_GT] = ACTIONS(11344),
    [anon_sym_EQ_EQ] = ACTIONS(11344),
    [anon_sym_BANG_EQ] = ACTIONS(11342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11342),
    [anon_sym_LT_EQ_GT] = ACTIONS(11342),
    [anon_sym_EQ_TILDE] = ACTIONS(11342),
    [anon_sym_BANG_TILDE] = ACTIONS(11342),
    [anon_sym_LT_EQ] = ACTIONS(11344),
    [anon_sym_GT] = ACTIONS(11344),
    [anon_sym_GT_EQ] = ACTIONS(11342),
    [anon_sym_CARET] = ACTIONS(11344),
    [anon_sym_PLUS] = ACTIONS(11344),
    [anon_sym_SLASH] = ACTIONS(11344),
    [anon_sym_PERCENT] = ACTIONS(11344),
    [sym_comment] = ACTIONS(87),
  },
  [11374] = {
    [sym__heredoc_body_start2] = ACTIONS(11393),
    [sym__binary_minus2] = ACTIONS(11393),
    [sym__binary_star2] = ACTIONS(11393),
    [anon_sym_LBRACE] = ACTIONS(11393),
    [anon_sym_RBRACE] = ACTIONS(11393),
    [anon_sym_RPAREN] = ACTIONS(11393),
    [anon_sym_DOT] = ACTIONS(11395),
    [anon_sym_COMMA] = ACTIONS(11393),
    [anon_sym_PIPE] = ACTIONS(11395),
    [anon_sym_SEMI] = ACTIONS(11393),
    [anon_sym_STAR_STAR] = ACTIONS(11395),
    [anon_sym_AMP] = ACTIONS(11395),
    [anon_sym_EQ] = ACTIONS(11395),
    [anon_sym_LT] = ACTIONS(11395),
    [anon_sym_if] = ACTIONS(11393),
    [anon_sym_unless] = ACTIONS(11393),
    [anon_sym_while] = ACTIONS(11393),
    [anon_sym_until] = ACTIONS(11393),
    [anon_sym_rescue] = ACTIONS(11393),
    [anon_sym_in] = ACTIONS(11393),
    [anon_sym_do] = ACTIONS(11393),
    [anon_sym_LBRACK] = ACTIONS(11393),
    [anon_sym_RBRACK] = ACTIONS(11393),
    [anon_sym_COLON_COLON2] = ACTIONS(11393),
    [anon_sym_AMP_DOT] = ACTIONS(11393),
    [anon_sym_PLUS_EQ] = ACTIONS(11393),
    [anon_sym_DASH_EQ] = ACTIONS(11393),
    [anon_sym_STAR_EQ] = ACTIONS(11393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11393),
    [anon_sym_SLASH_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_PIPE_EQ] = ACTIONS(11393),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11393),
    [anon_sym_AMP_EQ] = ACTIONS(11393),
    [anon_sym_PERCENT_EQ] = ACTIONS(11393),
    [anon_sym_GT_GT_EQ] = ACTIONS(11393),
    [anon_sym_LT_LT_EQ] = ACTIONS(11393),
    [anon_sym_CARET_EQ] = ACTIONS(11393),
    [anon_sym_QMARK] = ACTIONS(11393),
    [anon_sym_COLON2] = ACTIONS(11395),
    [anon_sym_DOT_DOT] = ACTIONS(11395),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11393),
    [anon_sym_and] = ACTIONS(11393),
    [anon_sym_or] = ACTIONS(11393),
    [anon_sym_PIPE_PIPE] = ACTIONS(11395),
    [anon_sym_AMP_AMP] = ACTIONS(11395),
    [anon_sym_LT_LT] = ACTIONS(11395),
    [anon_sym_GT_GT] = ACTIONS(11395),
    [anon_sym_EQ_EQ] = ACTIONS(11395),
    [anon_sym_BANG_EQ] = ACTIONS(11393),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11393),
    [anon_sym_LT_EQ_GT] = ACTIONS(11393),
    [anon_sym_EQ_TILDE] = ACTIONS(11393),
    [anon_sym_BANG_TILDE] = ACTIONS(11393),
    [anon_sym_LT_EQ] = ACTIONS(11395),
    [anon_sym_GT] = ACTIONS(11395),
    [anon_sym_GT_EQ] = ACTIONS(11393),
    [anon_sym_CARET] = ACTIONS(11395),
    [anon_sym_PLUS] = ACTIONS(11395),
    [anon_sym_SLASH] = ACTIONS(11395),
    [anon_sym_PERCENT] = ACTIONS(11395),
    [sym_comment] = ACTIONS(87),
  },
  [11375] = {
    [anon_sym_end] = ACTIONS(15183),
    [sym_comment] = ACTIONS(87),
  },
  [11376] = {
    [sym__heredoc_body_start2] = ACTIONS(11406),
    [sym__binary_minus2] = ACTIONS(11406),
    [sym__binary_star2] = ACTIONS(11406),
    [anon_sym_LBRACE] = ACTIONS(11406),
    [anon_sym_RBRACE] = ACTIONS(11406),
    [anon_sym_RPAREN] = ACTIONS(11406),
    [anon_sym_DOT] = ACTIONS(11408),
    [anon_sym_COMMA] = ACTIONS(11406),
    [anon_sym_PIPE] = ACTIONS(11408),
    [anon_sym_SEMI] = ACTIONS(11406),
    [anon_sym_STAR_STAR] = ACTIONS(11408),
    [anon_sym_AMP] = ACTIONS(11408),
    [anon_sym_EQ] = ACTIONS(11408),
    [anon_sym_LT] = ACTIONS(11408),
    [anon_sym_if] = ACTIONS(11406),
    [anon_sym_unless] = ACTIONS(11406),
    [anon_sym_while] = ACTIONS(11406),
    [anon_sym_until] = ACTIONS(11406),
    [anon_sym_rescue] = ACTIONS(11406),
    [anon_sym_in] = ACTIONS(11406),
    [anon_sym_do] = ACTIONS(11406),
    [anon_sym_LBRACK] = ACTIONS(11406),
    [anon_sym_RBRACK] = ACTIONS(11406),
    [anon_sym_COLON_COLON2] = ACTIONS(11406),
    [anon_sym_AMP_DOT] = ACTIONS(11406),
    [anon_sym_PLUS_EQ] = ACTIONS(11406),
    [anon_sym_DASH_EQ] = ACTIONS(11406),
    [anon_sym_STAR_EQ] = ACTIONS(11406),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11406),
    [anon_sym_SLASH_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_PIPE_EQ] = ACTIONS(11406),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11406),
    [anon_sym_AMP_EQ] = ACTIONS(11406),
    [anon_sym_PERCENT_EQ] = ACTIONS(11406),
    [anon_sym_GT_GT_EQ] = ACTIONS(11406),
    [anon_sym_LT_LT_EQ] = ACTIONS(11406),
    [anon_sym_CARET_EQ] = ACTIONS(11406),
    [anon_sym_QMARK] = ACTIONS(11406),
    [anon_sym_COLON2] = ACTIONS(11408),
    [anon_sym_DOT_DOT] = ACTIONS(11408),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11406),
    [anon_sym_and] = ACTIONS(11406),
    [anon_sym_or] = ACTIONS(11406),
    [anon_sym_PIPE_PIPE] = ACTIONS(11408),
    [anon_sym_AMP_AMP] = ACTIONS(11408),
    [anon_sym_LT_LT] = ACTIONS(11408),
    [anon_sym_GT_GT] = ACTIONS(11408),
    [anon_sym_EQ_EQ] = ACTIONS(11408),
    [anon_sym_BANG_EQ] = ACTIONS(11406),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11406),
    [anon_sym_LT_EQ_GT] = ACTIONS(11406),
    [anon_sym_EQ_TILDE] = ACTIONS(11406),
    [anon_sym_BANG_TILDE] = ACTIONS(11406),
    [anon_sym_LT_EQ] = ACTIONS(11408),
    [anon_sym_GT] = ACTIONS(11408),
    [anon_sym_GT_EQ] = ACTIONS(11406),
    [anon_sym_CARET] = ACTIONS(11408),
    [anon_sym_PLUS] = ACTIONS(11408),
    [anon_sym_SLASH] = ACTIONS(11408),
    [anon_sym_PERCENT] = ACTIONS(11408),
    [sym_comment] = ACTIONS(87),
  },
  [11377] = {
    [anon_sym_end] = ACTIONS(15185),
    [sym_comment] = ACTIONS(87),
  },
  [11378] = {
    [sym__heredoc_body_start2] = ACTIONS(11878),
    [sym__binary_minus2] = ACTIONS(11878),
    [sym__binary_star2] = ACTIONS(11878),
    [anon_sym_LBRACE] = ACTIONS(11878),
    [anon_sym_RBRACE] = ACTIONS(11878),
    [anon_sym_RPAREN] = ACTIONS(11878),
    [anon_sym_DOT] = ACTIONS(11880),
    [anon_sym_COMMA] = ACTIONS(11878),
    [anon_sym_PIPE] = ACTIONS(11880),
    [anon_sym_SEMI] = ACTIONS(11878),
    [anon_sym_STAR_STAR] = ACTIONS(11880),
    [anon_sym_AMP] = ACTIONS(11880),
    [anon_sym_EQ] = ACTIONS(11880),
    [anon_sym_LT] = ACTIONS(11880),
    [anon_sym_if] = ACTIONS(11878),
    [anon_sym_unless] = ACTIONS(11878),
    [anon_sym_while] = ACTIONS(11878),
    [anon_sym_until] = ACTIONS(11878),
    [anon_sym_rescue] = ACTIONS(11878),
    [anon_sym_in] = ACTIONS(11878),
    [anon_sym_do] = ACTIONS(11878),
    [anon_sym_LBRACK] = ACTIONS(11878),
    [anon_sym_RBRACK] = ACTIONS(11878),
    [anon_sym_COLON_COLON2] = ACTIONS(11878),
    [anon_sym_AMP_DOT] = ACTIONS(11878),
    [anon_sym_PLUS_EQ] = ACTIONS(11878),
    [anon_sym_DASH_EQ] = ACTIONS(11878),
    [anon_sym_STAR_EQ] = ACTIONS(11878),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11878),
    [anon_sym_SLASH_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_PIPE_EQ] = ACTIONS(11878),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11878),
    [anon_sym_AMP_EQ] = ACTIONS(11878),
    [anon_sym_PERCENT_EQ] = ACTIONS(11878),
    [anon_sym_GT_GT_EQ] = ACTIONS(11878),
    [anon_sym_LT_LT_EQ] = ACTIONS(11878),
    [anon_sym_CARET_EQ] = ACTIONS(11878),
    [anon_sym_QMARK] = ACTIONS(11878),
    [anon_sym_COLON2] = ACTIONS(11880),
    [anon_sym_DOT_DOT] = ACTIONS(11880),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11878),
    [anon_sym_and] = ACTIONS(11878),
    [anon_sym_or] = ACTIONS(11878),
    [anon_sym_PIPE_PIPE] = ACTIONS(11880),
    [anon_sym_AMP_AMP] = ACTIONS(11880),
    [anon_sym_LT_LT] = ACTIONS(11880),
    [anon_sym_GT_GT] = ACTIONS(11880),
    [anon_sym_EQ_EQ] = ACTIONS(11880),
    [anon_sym_BANG_EQ] = ACTIONS(11878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11878),
    [anon_sym_LT_EQ_GT] = ACTIONS(11878),
    [anon_sym_EQ_TILDE] = ACTIONS(11878),
    [anon_sym_BANG_TILDE] = ACTIONS(11878),
    [anon_sym_LT_EQ] = ACTIONS(11880),
    [anon_sym_GT] = ACTIONS(11880),
    [anon_sym_GT_EQ] = ACTIONS(11878),
    [anon_sym_CARET] = ACTIONS(11880),
    [anon_sym_PLUS] = ACTIONS(11880),
    [anon_sym_SLASH] = ACTIONS(11880),
    [anon_sym_PERCENT] = ACTIONS(11880),
    [sym_comment] = ACTIONS(87),
  },
  [11379] = {
    [anon_sym_end] = ACTIONS(15187),
    [sym_comment] = ACTIONS(87),
  },
  [11380] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10037),
    [sym__binary_star2] = ACTIONS(10039),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10041),
    [anon_sym_STAR_STAR] = ACTIONS(10043),
    [anon_sym_AMP] = ACTIONS(10045),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(10047),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10049),
    [anon_sym_DOT_DOT] = ACTIONS(10051),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10053),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10055),
    [anon_sym_AMP_AMP] = ACTIONS(10055),
    [anon_sym_LT_LT] = ACTIONS(10057),
    [anon_sym_GT_GT] = ACTIONS(10057),
    [anon_sym_EQ_EQ] = ACTIONS(10055),
    [anon_sym_BANG_EQ] = ACTIONS(10059),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10059),
    [anon_sym_LT_EQ_GT] = ACTIONS(10059),
    [anon_sym_EQ_TILDE] = ACTIONS(10059),
    [anon_sym_BANG_TILDE] = ACTIONS(10059),
    [anon_sym_LT_EQ] = ACTIONS(10047),
    [anon_sym_GT] = ACTIONS(10047),
    [anon_sym_GT_EQ] = ACTIONS(10061),
    [anon_sym_CARET] = ACTIONS(10041),
    [anon_sym_PLUS] = ACTIONS(10063),
    [anon_sym_SLASH] = ACTIONS(10043),
    [anon_sym_PERCENT] = ACTIONS(10043),
    [sym_comment] = ACTIONS(87),
  },
  [11381] = {
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(11607),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11382] = {
    [aux_sym_exceptions_repeat1] = STATE(11382),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15189),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11383] = {
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_COLON2] = ACTIONS(14628),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [11384] = {
    [sym__binary_minus2] = ACTIONS(10089),
    [sym__binary_star2] = ACTIONS(10091),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10093),
    [anon_sym_STAR_STAR] = ACTIONS(10095),
    [anon_sym_AMP] = ACTIONS(10097),
    [anon_sym_LT] = ACTIONS(10099),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10101),
    [anon_sym_DOT_DOT] = ACTIONS(10103),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10105),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10107),
    [anon_sym_AMP_AMP] = ACTIONS(10107),
    [anon_sym_LT_LT] = ACTIONS(10109),
    [anon_sym_GT_GT] = ACTIONS(10109),
    [anon_sym_EQ_EQ] = ACTIONS(10111),
    [anon_sym_BANG_EQ] = ACTIONS(10107),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10107),
    [anon_sym_LT_EQ_GT] = ACTIONS(10107),
    [anon_sym_EQ_TILDE] = ACTIONS(10107),
    [anon_sym_BANG_TILDE] = ACTIONS(10107),
    [anon_sym_LT_EQ] = ACTIONS(10099),
    [anon_sym_GT] = ACTIONS(10099),
    [anon_sym_GT_EQ] = ACTIONS(10113),
    [anon_sym_CARET] = ACTIONS(10115),
    [anon_sym_PLUS] = ACTIONS(10117),
    [anon_sym_SLASH] = ACTIONS(10095),
    [anon_sym_PERCENT] = ACTIONS(10095),
    [sym_comment] = ACTIONS(87),
  },
  [11385] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10147),
    [sym__binary_star2] = ACTIONS(10149),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10151),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(10153),
    [anon_sym_AMP] = ACTIONS(10155),
    [anon_sym_LT] = ACTIONS(10157),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10159),
    [anon_sym_DOT_DOT] = ACTIONS(10161),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10163),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10165),
    [anon_sym_AMP_AMP] = ACTIONS(10165),
    [anon_sym_LT_LT] = ACTIONS(10167),
    [anon_sym_GT_GT] = ACTIONS(10167),
    [anon_sym_EQ_EQ] = ACTIONS(10169),
    [anon_sym_BANG_EQ] = ACTIONS(10165),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10165),
    [anon_sym_LT_EQ_GT] = ACTIONS(10165),
    [anon_sym_EQ_TILDE] = ACTIONS(10165),
    [anon_sym_BANG_TILDE] = ACTIONS(10165),
    [anon_sym_LT_EQ] = ACTIONS(10157),
    [anon_sym_GT] = ACTIONS(10157),
    [anon_sym_GT_EQ] = ACTIONS(10171),
    [anon_sym_CARET] = ACTIONS(10173),
    [anon_sym_PLUS] = ACTIONS(10175),
    [anon_sym_SLASH] = ACTIONS(10153),
    [anon_sym_PERCENT] = ACTIONS(10153),
    [sym_comment] = ACTIONS(87),
  },
  [11386] = {
    [aux_sym_exceptions_repeat1] = STATE(11386),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15192),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11387] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10190),
    [sym__binary_star2] = ACTIONS(10192),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10194),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(10196),
    [anon_sym_AMP] = ACTIONS(10198),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(10200),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10202),
    [anon_sym_DOT_DOT] = ACTIONS(10204),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10206),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10208),
    [anon_sym_AMP_AMP] = ACTIONS(10208),
    [anon_sym_LT_LT] = ACTIONS(10210),
    [anon_sym_GT_GT] = ACTIONS(10210),
    [anon_sym_EQ_EQ] = ACTIONS(10208),
    [anon_sym_BANG_EQ] = ACTIONS(10212),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10212),
    [anon_sym_LT_EQ_GT] = ACTIONS(10212),
    [anon_sym_EQ_TILDE] = ACTIONS(10212),
    [anon_sym_BANG_TILDE] = ACTIONS(10212),
    [anon_sym_LT_EQ] = ACTIONS(10200),
    [anon_sym_GT] = ACTIONS(10200),
    [anon_sym_GT_EQ] = ACTIONS(10214),
    [anon_sym_CARET] = ACTIONS(10194),
    [anon_sym_PLUS] = ACTIONS(10216),
    [anon_sym_SLASH] = ACTIONS(10196),
    [anon_sym_PERCENT] = ACTIONS(10196),
    [sym_comment] = ACTIONS(87),
  },
  [11388] = {
    [aux_sym_exceptions_repeat1] = STATE(11388),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15195),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11389] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10226),
    [sym__binary_star2] = ACTIONS(10228),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10230),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(10232),
    [anon_sym_AMP] = ACTIONS(10234),
    [anon_sym_LT] = ACTIONS(10236),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10238),
    [anon_sym_DOT_DOT] = ACTIONS(10240),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10242),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10244),
    [anon_sym_AMP_AMP] = ACTIONS(10244),
    [anon_sym_LT_LT] = ACTIONS(10246),
    [anon_sym_GT_GT] = ACTIONS(10246),
    [anon_sym_EQ_EQ] = ACTIONS(10248),
    [anon_sym_BANG_EQ] = ACTIONS(10244),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10244),
    [anon_sym_LT_EQ_GT] = ACTIONS(10244),
    [anon_sym_EQ_TILDE] = ACTIONS(10244),
    [anon_sym_BANG_TILDE] = ACTIONS(10244),
    [anon_sym_LT_EQ] = ACTIONS(10236),
    [anon_sym_GT] = ACTIONS(10236),
    [anon_sym_GT_EQ] = ACTIONS(10250),
    [anon_sym_CARET] = ACTIONS(10252),
    [anon_sym_PLUS] = ACTIONS(10254),
    [anon_sym_SLASH] = ACTIONS(10232),
    [anon_sym_PERCENT] = ACTIONS(10232),
    [sym_comment] = ACTIONS(87),
  },
  [11390] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10278),
    [sym__binary_star2] = ACTIONS(10280),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10282),
    [anon_sym_STAR_STAR] = ACTIONS(10284),
    [anon_sym_AMP] = ACTIONS(10286),
    [anon_sym_LT] = ACTIONS(10288),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10290),
    [anon_sym_DOT_DOT] = ACTIONS(10292),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10294),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10296),
    [anon_sym_AMP_AMP] = ACTIONS(10296),
    [anon_sym_LT_LT] = ACTIONS(10298),
    [anon_sym_GT_GT] = ACTIONS(10298),
    [anon_sym_EQ_EQ] = ACTIONS(10300),
    [anon_sym_BANG_EQ] = ACTIONS(10296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10296),
    [anon_sym_LT_EQ_GT] = ACTIONS(10296),
    [anon_sym_EQ_TILDE] = ACTIONS(10296),
    [anon_sym_BANG_TILDE] = ACTIONS(10296),
    [anon_sym_LT_EQ] = ACTIONS(10288),
    [anon_sym_GT] = ACTIONS(10288),
    [anon_sym_GT_EQ] = ACTIONS(10302),
    [anon_sym_CARET] = ACTIONS(10304),
    [anon_sym_PLUS] = ACTIONS(10306),
    [anon_sym_SLASH] = ACTIONS(10284),
    [anon_sym_PERCENT] = ACTIONS(10284),
    [sym_comment] = ACTIONS(87),
  },
  [11391] = {
    [aux_sym_exceptions_repeat1] = STATE(11391),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15198),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11392] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10340),
    [sym__binary_star2] = ACTIONS(10342),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10344),
    [anon_sym_STAR_STAR] = ACTIONS(10346),
    [anon_sym_AMP] = ACTIONS(10348),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(10350),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10352),
    [anon_sym_DOT_DOT] = ACTIONS(10354),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10356),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10358),
    [anon_sym_AMP_AMP] = ACTIONS(10358),
    [anon_sym_LT_LT] = ACTIONS(10360),
    [anon_sym_GT_GT] = ACTIONS(10360),
    [anon_sym_EQ_EQ] = ACTIONS(10358),
    [anon_sym_BANG_EQ] = ACTIONS(10362),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10362),
    [anon_sym_LT_EQ_GT] = ACTIONS(10362),
    [anon_sym_EQ_TILDE] = ACTIONS(10362),
    [anon_sym_BANG_TILDE] = ACTIONS(10362),
    [anon_sym_LT_EQ] = ACTIONS(10350),
    [anon_sym_GT] = ACTIONS(10350),
    [anon_sym_GT_EQ] = ACTIONS(10364),
    [anon_sym_CARET] = ACTIONS(10344),
    [anon_sym_PLUS] = ACTIONS(10366),
    [anon_sym_SLASH] = ACTIONS(10346),
    [anon_sym_PERCENT] = ACTIONS(10346),
    [sym_comment] = ACTIONS(87),
  },
  [11393] = {
    [aux_sym_exceptions_repeat1] = STATE(11393),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15201),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11394] = {
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_STAR_STAR] = ACTIONS(14628),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_if] = ACTIONS(14626),
    [anon_sym_unless] = ACTIONS(14626),
    [anon_sym_while] = ACTIONS(14626),
    [anon_sym_until] = ACTIONS(14626),
    [anon_sym_rescue] = ACTIONS(14626),
    [anon_sym_in] = ACTIONS(14626),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_RBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_PLUS_EQ] = ACTIONS(14626),
    [anon_sym_DASH_EQ] = ACTIONS(14626),
    [anon_sym_STAR_EQ] = ACTIONS(14626),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14626),
    [anon_sym_SLASH_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_PIPE_EQ] = ACTIONS(14626),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14626),
    [anon_sym_AMP_EQ] = ACTIONS(14626),
    [anon_sym_PERCENT_EQ] = ACTIONS(14626),
    [anon_sym_GT_GT_EQ] = ACTIONS(14626),
    [anon_sym_LT_LT_EQ] = ACTIONS(14626),
    [anon_sym_CARET_EQ] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_COLON2] = ACTIONS(14628),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14628),
    [anon_sym_AMP_AMP] = ACTIONS(14628),
    [anon_sym_LT_LT] = ACTIONS(14628),
    [anon_sym_GT_GT] = ACTIONS(14628),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14628),
    [anon_sym_PLUS] = ACTIONS(14628),
    [anon_sym_SLASH] = ACTIONS(14628),
    [anon_sym_PERCENT] = ACTIONS(14628),
    [sym_comment] = ACTIONS(87),
  },
  [11395] = {
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14124),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_in] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_EQ_GT] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_RBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_PLUS_EQ] = ACTIONS(14122),
    [anon_sym_DASH_EQ] = ACTIONS(14122),
    [anon_sym_STAR_EQ] = ACTIONS(14122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14122),
    [anon_sym_SLASH_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14122),
    [anon_sym_AMP_EQ] = ACTIONS(14122),
    [anon_sym_PERCENT_EQ] = ACTIONS(14122),
    [anon_sym_GT_GT_EQ] = ACTIONS(14122),
    [anon_sym_LT_LT_EQ] = ACTIONS(14122),
    [anon_sym_CARET_EQ] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_COLON2] = ACTIONS(14124),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14124),
    [anon_sym_AMP_AMP] = ACTIONS(14124),
    [anon_sym_LT_LT] = ACTIONS(14124),
    [anon_sym_GT_GT] = ACTIONS(14124),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14124),
    [anon_sym_PLUS] = ACTIONS(14124),
    [anon_sym_SLASH] = ACTIONS(14124),
    [anon_sym_PERCENT] = ACTIONS(14124),
    [sym_comment] = ACTIONS(87),
  },
  [11396] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10513),
    [sym__binary_star2] = ACTIONS(10515),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10517),
    [anon_sym_STAR_STAR] = ACTIONS(10519),
    [anon_sym_AMP] = ACTIONS(10521),
    [anon_sym_LT] = ACTIONS(10523),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10525),
    [anon_sym_DOT_DOT] = ACTIONS(10527),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10529),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10531),
    [anon_sym_AMP_AMP] = ACTIONS(10531),
    [anon_sym_LT_LT] = ACTIONS(10533),
    [anon_sym_GT_GT] = ACTIONS(10533),
    [anon_sym_EQ_EQ] = ACTIONS(10535),
    [anon_sym_BANG_EQ] = ACTIONS(10531),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10531),
    [anon_sym_LT_EQ_GT] = ACTIONS(10531),
    [anon_sym_EQ_TILDE] = ACTIONS(10531),
    [anon_sym_BANG_TILDE] = ACTIONS(10531),
    [anon_sym_LT_EQ] = ACTIONS(10523),
    [anon_sym_GT] = ACTIONS(10523),
    [anon_sym_GT_EQ] = ACTIONS(10537),
    [anon_sym_CARET] = ACTIONS(10539),
    [anon_sym_PLUS] = ACTIONS(10541),
    [anon_sym_SLASH] = ACTIONS(10519),
    [anon_sym_PERCENT] = ACTIONS(10519),
    [sym_comment] = ACTIONS(87),
  },
  [11397] = {
    [aux_sym_exceptions_repeat1] = STATE(11397),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15204),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11398] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10553),
    [sym__binary_star2] = ACTIONS(10555),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10557),
    [anon_sym_STAR_STAR] = ACTIONS(10559),
    [anon_sym_AMP] = ACTIONS(10561),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(10563),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10565),
    [anon_sym_DOT_DOT] = ACTIONS(10567),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10569),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10571),
    [anon_sym_AMP_AMP] = ACTIONS(10571),
    [anon_sym_LT_LT] = ACTIONS(10573),
    [anon_sym_GT_GT] = ACTIONS(10573),
    [anon_sym_EQ_EQ] = ACTIONS(10571),
    [anon_sym_BANG_EQ] = ACTIONS(10575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10575),
    [anon_sym_LT_EQ_GT] = ACTIONS(10575),
    [anon_sym_EQ_TILDE] = ACTIONS(10575),
    [anon_sym_BANG_TILDE] = ACTIONS(10575),
    [anon_sym_LT_EQ] = ACTIONS(10563),
    [anon_sym_GT] = ACTIONS(10563),
    [anon_sym_GT_EQ] = ACTIONS(10577),
    [anon_sym_CARET] = ACTIONS(10557),
    [anon_sym_PLUS] = ACTIONS(10579),
    [anon_sym_SLASH] = ACTIONS(10559),
    [anon_sym_PERCENT] = ACTIONS(10559),
    [sym_comment] = ACTIONS(87),
  },
  [11399] = {
    [aux_sym_exceptions_repeat1] = STATE(11399),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15207),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11400] = {
    [sym__binary_minus2] = ACTIONS(10589),
    [sym__binary_star2] = ACTIONS(10591),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10593),
    [anon_sym_STAR_STAR] = ACTIONS(10595),
    [anon_sym_AMP] = ACTIONS(10597),
    [anon_sym_LT] = ACTIONS(10599),
    [anon_sym_QMARK] = ACTIONS(10601),
    [anon_sym_DOT_DOT] = ACTIONS(10603),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10605),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10607),
    [anon_sym_AMP_AMP] = ACTIONS(10607),
    [anon_sym_LT_LT] = ACTIONS(10609),
    [anon_sym_GT_GT] = ACTIONS(10609),
    [anon_sym_EQ_EQ] = ACTIONS(10611),
    [anon_sym_BANG_EQ] = ACTIONS(10607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10607),
    [anon_sym_LT_EQ_GT] = ACTIONS(10607),
    [anon_sym_EQ_TILDE] = ACTIONS(10607),
    [anon_sym_BANG_TILDE] = ACTIONS(10607),
    [anon_sym_LT_EQ] = ACTIONS(10599),
    [anon_sym_GT] = ACTIONS(10599),
    [anon_sym_GT_EQ] = ACTIONS(10613),
    [anon_sym_CARET] = ACTIONS(10615),
    [anon_sym_PLUS] = ACTIONS(10617),
    [anon_sym_SLASH] = ACTIONS(10595),
    [anon_sym_PERCENT] = ACTIONS(10595),
    [sym_comment] = ACTIONS(87),
  },
  [11401] = {
    [sym__line_break2] = ACTIONS(13726),
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13726),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_SEMI] = ACTIONS(13726),
    [anon_sym_then] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [11402] = {
    [anon_sym_end] = ACTIONS(15210),
    [sym_comment] = ACTIONS(87),
  },
  [11403] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(10655),
    [sym__binary_star2] = ACTIONS(10657),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_RPAREN] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(10659),
    [anon_sym_STAR_STAR] = ACTIONS(10661),
    [anon_sym_AMP] = ACTIONS(10663),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(10665),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(10667),
    [anon_sym_DOT_DOT] = ACTIONS(10669),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(10671),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(10675),
    [anon_sym_AMP_AMP] = ACTIONS(10675),
    [anon_sym_LT_LT] = ACTIONS(10677),
    [anon_sym_GT_GT] = ACTIONS(10677),
    [anon_sym_EQ_EQ] = ACTIONS(10679),
    [anon_sym_BANG_EQ] = ACTIONS(10675),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(10675),
    [anon_sym_LT_EQ_GT] = ACTIONS(10675),
    [anon_sym_EQ_TILDE] = ACTIONS(10675),
    [anon_sym_BANG_TILDE] = ACTIONS(10675),
    [anon_sym_LT_EQ] = ACTIONS(10665),
    [anon_sym_GT] = ACTIONS(10665),
    [anon_sym_GT_EQ] = ACTIONS(10681),
    [anon_sym_CARET] = ACTIONS(10683),
    [anon_sym_PLUS] = ACTIONS(10685),
    [anon_sym_SLASH] = ACTIONS(10661),
    [anon_sym_PERCENT] = ACTIONS(10661),
    [sym_comment] = ACTIONS(87),
  },
  [11404] = {
    [aux_sym_exceptions_repeat1] = STATE(11404),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_RPAREN] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15212),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11405] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11722),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_assignment] = STATE(11722),
    [sym_operator_assignment] = STATE(11722),
    [sym_conditional] = STATE(11722),
    [sym_range] = STATE(11722),
    [sym_binary] = STATE(11722),
    [sym_unary] = STATE(11722),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11406] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10754),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(7597),
    [sym_scope_resolution] = STATE(2454),
    [sym_call] = STATE(2454),
    [sym_method_call] = STATE(7597),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(10754),
    [sym_operator_assignment] = STATE(10754),
    [sym_conditional] = STATE(10754),
    [sym_range] = STATE(10754),
    [sym_binary] = STATE(10754),
    [sym_unary] = STATE(10754),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(7596),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7597),
    [sym__variable] = STATE(2454),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(7597),
    [sym_false] = STATE(7597),
    [sym_nil] = STATE(7597),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(7598),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(7567),
    [sym__unary_minus2] = ACTIONS(10743),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(10745),
    [anon_sym_yield] = ACTIONS(10747),
    [anon_sym_break] = ACTIONS(10749),
    [anon_sym_next] = ACTIONS(10751),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(10753),
    [anon_sym_defined_QMARK] = ACTIONS(10755),
    [anon_sym_not] = ACTIONS(10757),
    [anon_sym_BANG] = ACTIONS(10759),
    [anon_sym_TILDE] = ACTIONS(10759),
    [sym_constant] = ACTIONS(4002),
    [sym_identifier] = ACTIONS(4002),
    [sym_instance_variable] = ACTIONS(4004),
    [sym_class_variable] = ACTIONS(4004),
    [sym_global_variable] = ACTIONS(4004),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4002),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4002),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11407] = {
    [aux_sym_exceptions_repeat1] = STATE(11723),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15215),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11408] = {
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_STAR_STAR] = ACTIONS(12497),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12497),
    [anon_sym_AMP_AMP] = ACTIONS(12497),
    [anon_sym_LT_LT] = ACTIONS(12497),
    [anon_sym_GT_GT] = ACTIONS(12497),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12497),
    [anon_sym_PLUS] = ACTIONS(12497),
    [anon_sym_SLASH] = ACTIONS(12497),
    [anon_sym_PERCENT] = ACTIONS(12497),
    [sym_comment] = ACTIONS(87),
  },
  [11409] = {
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_STAR_STAR] = ACTIONS(12501),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12501),
    [anon_sym_AMP_AMP] = ACTIONS(12501),
    [anon_sym_LT_LT] = ACTIONS(12501),
    [anon_sym_GT_GT] = ACTIONS(12501),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12501),
    [anon_sym_PLUS] = ACTIONS(12501),
    [anon_sym_SLASH] = ACTIONS(12501),
    [anon_sym_PERCENT] = ACTIONS(12501),
    [sym_comment] = ACTIONS(87),
  },
  [11410] = {
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_STAR_STAR] = ACTIONS(12615),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12615),
    [anon_sym_AMP_AMP] = ACTIONS(12615),
    [anon_sym_LT_LT] = ACTIONS(12615),
    [anon_sym_GT_GT] = ACTIONS(12615),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12615),
    [anon_sym_PLUS] = ACTIONS(12615),
    [anon_sym_SLASH] = ACTIONS(12615),
    [anon_sym_PERCENT] = ACTIONS(12615),
    [sym_comment] = ACTIONS(87),
  },
  [11411] = {
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_STAR_STAR] = ACTIONS(12916),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12916),
    [anon_sym_AMP_AMP] = ACTIONS(12916),
    [anon_sym_LT_LT] = ACTIONS(12916),
    [anon_sym_GT_GT] = ACTIONS(12916),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12916),
    [anon_sym_PLUS] = ACTIONS(12916),
    [anon_sym_SLASH] = ACTIONS(12916),
    [anon_sym_PERCENT] = ACTIONS(12916),
    [sym_comment] = ACTIONS(87),
  },
  [11412] = {
    [anon_sym_end] = ACTIONS(15217),
    [sym_comment] = ACTIONS(87),
  },
  [11413] = {
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_STAR_STAR] = ACTIONS(13064),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13064),
    [anon_sym_AMP_AMP] = ACTIONS(13064),
    [anon_sym_LT_LT] = ACTIONS(13064),
    [anon_sym_GT_GT] = ACTIONS(13064),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13064),
    [anon_sym_PLUS] = ACTIONS(13064),
    [anon_sym_SLASH] = ACTIONS(13064),
    [anon_sym_PERCENT] = ACTIONS(13064),
    [sym_comment] = ACTIONS(87),
  },
  [11414] = {
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_STAR_STAR] = ACTIONS(13216),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13216),
    [anon_sym_AMP_AMP] = ACTIONS(13216),
    [anon_sym_LT_LT] = ACTIONS(13216),
    [anon_sym_GT_GT] = ACTIONS(13216),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13216),
    [anon_sym_PLUS] = ACTIONS(13216),
    [anon_sym_SLASH] = ACTIONS(13216),
    [anon_sym_PERCENT] = ACTIONS(13216),
    [sym_comment] = ACTIONS(87),
  },
  [11415] = {
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_STAR_STAR] = ACTIONS(13227),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13227),
    [anon_sym_AMP_AMP] = ACTIONS(13227),
    [anon_sym_LT_LT] = ACTIONS(13227),
    [anon_sym_GT_GT] = ACTIONS(13227),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13227),
    [anon_sym_PLUS] = ACTIONS(13227),
    [anon_sym_SLASH] = ACTIONS(13227),
    [anon_sym_PERCENT] = ACTIONS(13227),
    [sym_comment] = ACTIONS(87),
  },
  [11416] = {
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_STAR_STAR] = ACTIONS(13551),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13551),
    [anon_sym_AMP_AMP] = ACTIONS(13551),
    [anon_sym_LT_LT] = ACTIONS(13551),
    [anon_sym_GT_GT] = ACTIONS(13551),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13551),
    [anon_sym_PLUS] = ACTIONS(13551),
    [anon_sym_SLASH] = ACTIONS(13551),
    [anon_sym_PERCENT] = ACTIONS(13551),
    [sym_comment] = ACTIONS(87),
  },
  [11417] = {
    [sym__heredoc_body_start2] = ACTIONS(13726),
    [sym__binary_minus2] = ACTIONS(13726),
    [sym__binary_star2] = ACTIONS(13726),
    [anon_sym_LBRACE] = ACTIONS(13726),
    [anon_sym_RPAREN] = ACTIONS(13726),
    [anon_sym_DOT] = ACTIONS(13728),
    [anon_sym_COMMA] = ACTIONS(13726),
    [anon_sym_PIPE] = ACTIONS(13728),
    [anon_sym_STAR_STAR] = ACTIONS(13726),
    [anon_sym_AMP] = ACTIONS(13728),
    [anon_sym_EQ] = ACTIONS(13728),
    [anon_sym_LT] = ACTIONS(13728),
    [anon_sym_do] = ACTIONS(13726),
    [anon_sym_LBRACK] = ACTIONS(13726),
    [anon_sym_COLON_COLON2] = ACTIONS(13726),
    [anon_sym_AMP_DOT] = ACTIONS(13726),
    [anon_sym_QMARK] = ACTIONS(13726),
    [anon_sym_DOT_DOT] = ACTIONS(13728),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13726),
    [anon_sym_and] = ACTIONS(13726),
    [anon_sym_or] = ACTIONS(13726),
    [anon_sym_PIPE_PIPE] = ACTIONS(13726),
    [anon_sym_AMP_AMP] = ACTIONS(13726),
    [anon_sym_LT_LT] = ACTIONS(13726),
    [anon_sym_GT_GT] = ACTIONS(13726),
    [anon_sym_EQ_EQ] = ACTIONS(13728),
    [anon_sym_BANG_EQ] = ACTIONS(13726),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13726),
    [anon_sym_LT_EQ_GT] = ACTIONS(13726),
    [anon_sym_EQ_TILDE] = ACTIONS(13726),
    [anon_sym_BANG_TILDE] = ACTIONS(13726),
    [anon_sym_LT_EQ] = ACTIONS(13728),
    [anon_sym_GT] = ACTIONS(13728),
    [anon_sym_GT_EQ] = ACTIONS(13726),
    [anon_sym_CARET] = ACTIONS(13726),
    [anon_sym_PLUS] = ACTIONS(13726),
    [anon_sym_SLASH] = ACTIONS(13726),
    [anon_sym_PERCENT] = ACTIONS(13726),
    [sym_comment] = ACTIONS(87),
  },
  [11418] = {
    [anon_sym_end] = ACTIONS(15219),
    [sym_comment] = ACTIONS(87),
  },
  [11419] = {
    [sym_heredoc_body] = STATE(11419),
    [aux_sym_call_repeat1] = STATE(11419),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_elsif] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11420] = {
    [sym_heredoc_body] = STATE(11419),
    [aux_sym_call_repeat1] = STATE(11419),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_elsif] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11421] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11726),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_assignment] = STATE(11726),
    [sym_operator_assignment] = STATE(11726),
    [sym_conditional] = STATE(11726),
    [sym_range] = STATE(11726),
    [sym_binary] = STATE(11726),
    [sym_unary] = STATE(11726),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11422] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10814),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7852),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7852),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10814),
    [sym_operator_assignment] = STATE(10814),
    [sym_conditional] = STATE(10814),
    [sym_range] = STATE(10814),
    [sym_binary] = STATE(10814),
    [sym_unary] = STATE(10814),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(7851),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7852),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7852),
    [sym_false] = STATE(7852),
    [sym_nil] = STATE(7852),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(7976),
    [sym__unary_minus2] = ACTIONS(10977),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(10987),
    [anon_sym_defined_QMARK] = ACTIONS(10989),
    [anon_sym_not] = ACTIONS(10991),
    [anon_sym_BANG] = ACTIONS(10993),
    [anon_sym_TILDE] = ACTIONS(10993),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11423] = {
    [aux_sym_exceptions_repeat1] = STATE(11727),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15221),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_elsif] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11424] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11009),
    [sym__binary_star2] = ACTIONS(11011),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11013),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11015),
    [anon_sym_AMP] = ACTIONS(11017),
    [anon_sym_LT] = ACTIONS(11019),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11023),
    [anon_sym_DOT_DOT] = ACTIONS(11025),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11027),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11029),
    [anon_sym_AMP_AMP] = ACTIONS(11029),
    [anon_sym_LT_LT] = ACTIONS(11031),
    [anon_sym_GT_GT] = ACTIONS(11031),
    [anon_sym_EQ_EQ] = ACTIONS(11033),
    [anon_sym_BANG_EQ] = ACTIONS(11029),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11029),
    [anon_sym_LT_EQ_GT] = ACTIONS(11029),
    [anon_sym_EQ_TILDE] = ACTIONS(11029),
    [anon_sym_BANG_TILDE] = ACTIONS(11029),
    [anon_sym_LT_EQ] = ACTIONS(11019),
    [anon_sym_GT] = ACTIONS(11019),
    [anon_sym_GT_EQ] = ACTIONS(11035),
    [anon_sym_CARET] = ACTIONS(11037),
    [anon_sym_PLUS] = ACTIONS(11039),
    [anon_sym_SLASH] = ACTIONS(11015),
    [anon_sym_PERCENT] = ACTIONS(11015),
    [sym_comment] = ACTIONS(87),
  },
  [11425] = {
    [aux_sym_exceptions_repeat1] = STATE(11425),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15223),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11426] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11728),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_assignment] = STATE(11728),
    [sym_operator_assignment] = STATE(11728),
    [sym_conditional] = STATE(11728),
    [sym_range] = STATE(11728),
    [sym_binary] = STATE(11728),
    [sym_unary] = STATE(11728),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11427] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10847),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(7931),
    [sym_scope_resolution] = STATE(7929),
    [sym_call] = STATE(7929),
    [sym_method_call] = STATE(7931),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(10847),
    [sym_operator_assignment] = STATE(10847),
    [sym_conditional] = STATE(10847),
    [sym_range] = STATE(10847),
    [sym_binary] = STATE(10847),
    [sym_unary] = STATE(10847),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(7930),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7931),
    [sym__variable] = STATE(7929),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(7931),
    [sym_false] = STATE(7931),
    [sym_nil] = STATE(7931),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(7932),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8060),
    [sym__unary_minus2] = ACTIONS(11069),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11071),
    [anon_sym_yield] = ACTIONS(11073),
    [anon_sym_break] = ACTIONS(11075),
    [anon_sym_next] = ACTIONS(11077),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11079),
    [anon_sym_defined_QMARK] = ACTIONS(11081),
    [anon_sym_not] = ACTIONS(11083),
    [anon_sym_BANG] = ACTIONS(11085),
    [anon_sym_TILDE] = ACTIONS(11085),
    [sym_constant] = ACTIONS(11087),
    [sym_identifier] = ACTIONS(11087),
    [sym_instance_variable] = ACTIONS(11089),
    [sym_class_variable] = ACTIONS(11089),
    [sym_global_variable] = ACTIONS(11089),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11087),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11087),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11428] = {
    [aux_sym_exceptions_repeat1] = STATE(11729),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15226),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_elsif] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11429] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11097),
    [sym__binary_star2] = ACTIONS(11099),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11101),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11103),
    [anon_sym_AMP] = ACTIONS(11105),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(11107),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11111),
    [anon_sym_DOT_DOT] = ACTIONS(11113),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11115),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11117),
    [anon_sym_AMP_AMP] = ACTIONS(11117),
    [anon_sym_LT_LT] = ACTIONS(11119),
    [anon_sym_GT_GT] = ACTIONS(11119),
    [anon_sym_EQ_EQ] = ACTIONS(11117),
    [anon_sym_BANG_EQ] = ACTIONS(11121),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11121),
    [anon_sym_LT_EQ_GT] = ACTIONS(11121),
    [anon_sym_EQ_TILDE] = ACTIONS(11121),
    [anon_sym_BANG_TILDE] = ACTIONS(11121),
    [anon_sym_LT_EQ] = ACTIONS(11107),
    [anon_sym_GT] = ACTIONS(11107),
    [anon_sym_GT_EQ] = ACTIONS(11123),
    [anon_sym_CARET] = ACTIONS(11101),
    [anon_sym_PLUS] = ACTIONS(11125),
    [anon_sym_SLASH] = ACTIONS(11103),
    [anon_sym_PERCENT] = ACTIONS(11103),
    [sym_comment] = ACTIONS(87),
  },
  [11430] = {
    [aux_sym_exceptions_repeat1] = STATE(11430),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15228),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11431] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11730),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(7967),
    [sym_scope_resolution] = STATE(2772),
    [sym_call] = STATE(2772),
    [sym_method_call] = STATE(7967),
    [sym_assignment] = STATE(11730),
    [sym_operator_assignment] = STATE(11730),
    [sym_conditional] = STATE(11730),
    [sym_range] = STATE(11730),
    [sym_binary] = STATE(11730),
    [sym_unary] = STATE(11730),
    [sym_left_assignment_list] = STATE(7966),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(7967),
    [sym__variable] = STATE(2772),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(7967),
    [sym_false] = STATE(7967),
    [sym_nil] = STATE(7967),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(7853),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11139),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(10979),
    [anon_sym_yield] = ACTIONS(10981),
    [anon_sym_break] = ACTIONS(10983),
    [anon_sym_next] = ACTIONS(10985),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11141),
    [anon_sym_defined_QMARK] = ACTIONS(11143),
    [anon_sym_not] = ACTIONS(11145),
    [anon_sym_BANG] = ACTIONS(11147),
    [anon_sym_TILDE] = ACTIONS(11147),
    [sym_constant] = ACTIONS(4466),
    [sym_identifier] = ACTIONS(4466),
    [sym_instance_variable] = ACTIONS(4468),
    [sym_class_variable] = ACTIONS(4468),
    [sym_global_variable] = ACTIONS(4468),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4466),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4466),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11432] = {
    [sym_heredoc_body] = STATE(11432),
    [aux_sym_call_repeat1] = STATE(11432),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11433] = {
    [sym_heredoc_body] = STATE(11432),
    [aux_sym_call_repeat1] = STATE(11432),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11434] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11731),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_assignment] = STATE(11731),
    [sym_operator_assignment] = STATE(11731),
    [sym_conditional] = STATE(11731),
    [sym_range] = STATE(11731),
    [sym_binary] = STATE(11731),
    [sym_unary] = STATE(11731),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11435] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10886),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8016),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8016),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10886),
    [sym_operator_assignment] = STATE(10886),
    [sym_conditional] = STATE(10886),
    [sym_range] = STATE(10886),
    [sym_binary] = STATE(10886),
    [sym_unary] = STATE(10886),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(8015),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8016),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8016),
    [sym_false] = STATE(8016),
    [sym_nil] = STATE(8016),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(8182),
    [sym__unary_minus2] = ACTIONS(11154),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11164),
    [anon_sym_defined_QMARK] = ACTIONS(11166),
    [anon_sym_not] = ACTIONS(11168),
    [anon_sym_BANG] = ACTIONS(11170),
    [anon_sym_TILDE] = ACTIONS(11170),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11436] = {
    [aux_sym_exceptions_repeat1] = STATE(11732),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15231),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11437] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11186),
    [sym__binary_star2] = ACTIONS(11188),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11190),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11192),
    [anon_sym_AMP] = ACTIONS(11194),
    [anon_sym_LT] = ACTIONS(11196),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11200),
    [anon_sym_DOT_DOT] = ACTIONS(11202),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11204),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11206),
    [anon_sym_AMP_AMP] = ACTIONS(11206),
    [anon_sym_LT_LT] = ACTIONS(11208),
    [anon_sym_GT_GT] = ACTIONS(11208),
    [anon_sym_EQ_EQ] = ACTIONS(11210),
    [anon_sym_BANG_EQ] = ACTIONS(11206),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11206),
    [anon_sym_LT_EQ_GT] = ACTIONS(11206),
    [anon_sym_EQ_TILDE] = ACTIONS(11206),
    [anon_sym_BANG_TILDE] = ACTIONS(11206),
    [anon_sym_LT_EQ] = ACTIONS(11196),
    [anon_sym_GT] = ACTIONS(11196),
    [anon_sym_GT_EQ] = ACTIONS(11212),
    [anon_sym_CARET] = ACTIONS(11214),
    [anon_sym_PLUS] = ACTIONS(11216),
    [anon_sym_SLASH] = ACTIONS(11192),
    [anon_sym_PERCENT] = ACTIONS(11192),
    [sym_comment] = ACTIONS(87),
  },
  [11438] = {
    [aux_sym_exceptions_repeat1] = STATE(11438),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15233),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11439] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11733),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_assignment] = STATE(11733),
    [sym_operator_assignment] = STATE(11733),
    [sym_conditional] = STATE(11733),
    [sym_range] = STATE(11733),
    [sym_binary] = STATE(11733),
    [sym_unary] = STATE(11733),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11440] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(10918),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8094),
    [sym_scope_resolution] = STATE(8092),
    [sym_call] = STATE(8092),
    [sym_method_call] = STATE(8094),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(10918),
    [sym_operator_assignment] = STATE(10918),
    [sym_conditional] = STATE(10918),
    [sym_range] = STATE(10918),
    [sym_binary] = STATE(10918),
    [sym_unary] = STATE(10918),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(8093),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8094),
    [sym__variable] = STATE(8092),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8094),
    [sym_false] = STATE(8094),
    [sym_nil] = STATE(8094),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8095),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8260),
    [sym__unary_minus2] = ACTIONS(11244),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11246),
    [anon_sym_yield] = ACTIONS(11248),
    [anon_sym_break] = ACTIONS(11250),
    [anon_sym_next] = ACTIONS(11252),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11254),
    [anon_sym_defined_QMARK] = ACTIONS(11256),
    [anon_sym_not] = ACTIONS(11258),
    [anon_sym_BANG] = ACTIONS(11260),
    [anon_sym_TILDE] = ACTIONS(11260),
    [sym_constant] = ACTIONS(11262),
    [sym_identifier] = ACTIONS(11262),
    [sym_instance_variable] = ACTIONS(11264),
    [sym_class_variable] = ACTIONS(11264),
    [sym_global_variable] = ACTIONS(11264),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11262),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11262),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11441] = {
    [aux_sym_exceptions_repeat1] = STATE(11734),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15236),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11442] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11272),
    [sym__binary_star2] = ACTIONS(11274),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11276),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11278),
    [anon_sym_AMP] = ACTIONS(11280),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(11282),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11286),
    [anon_sym_DOT_DOT] = ACTIONS(11288),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11290),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11292),
    [anon_sym_AMP_AMP] = ACTIONS(11292),
    [anon_sym_LT_LT] = ACTIONS(11294),
    [anon_sym_GT_GT] = ACTIONS(11294),
    [anon_sym_EQ_EQ] = ACTIONS(11292),
    [anon_sym_BANG_EQ] = ACTIONS(11296),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11296),
    [anon_sym_LT_EQ_GT] = ACTIONS(11296),
    [anon_sym_EQ_TILDE] = ACTIONS(11296),
    [anon_sym_BANG_TILDE] = ACTIONS(11296),
    [anon_sym_LT_EQ] = ACTIONS(11282),
    [anon_sym_GT] = ACTIONS(11282),
    [anon_sym_GT_EQ] = ACTIONS(11298),
    [anon_sym_CARET] = ACTIONS(11276),
    [anon_sym_PLUS] = ACTIONS(11300),
    [anon_sym_SLASH] = ACTIONS(11278),
    [anon_sym_PERCENT] = ACTIONS(11278),
    [sym_comment] = ACTIONS(87),
  },
  [11443] = {
    [aux_sym_exceptions_repeat1] = STATE(11443),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15238),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11444] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11735),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8130),
    [sym_scope_resolution] = STATE(2855),
    [sym_call] = STATE(2855),
    [sym_method_call] = STATE(8130),
    [sym_assignment] = STATE(11735),
    [sym_operator_assignment] = STATE(11735),
    [sym_conditional] = STATE(11735),
    [sym_range] = STATE(11735),
    [sym_binary] = STATE(11735),
    [sym_unary] = STATE(11735),
    [sym_left_assignment_list] = STATE(8129),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8130),
    [sym__variable] = STATE(2855),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8130),
    [sym_false] = STATE(8130),
    [sym_nil] = STATE(8130),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8017),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11314),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11156),
    [anon_sym_yield] = ACTIONS(11158),
    [anon_sym_break] = ACTIONS(11160),
    [anon_sym_next] = ACTIONS(11162),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11316),
    [anon_sym_defined_QMARK] = ACTIONS(11318),
    [anon_sym_not] = ACTIONS(11320),
    [anon_sym_BANG] = ACTIONS(11322),
    [anon_sym_TILDE] = ACTIONS(11322),
    [sym_constant] = ACTIONS(4578),
    [sym_identifier] = ACTIONS(4578),
    [sym_instance_variable] = ACTIONS(4580),
    [sym_class_variable] = ACTIONS(4580),
    [sym_global_variable] = ACTIONS(4580),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4578),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4578),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11445] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11736),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_assignment] = STATE(11736),
    [sym_operator_assignment] = STATE(11736),
    [sym_conditional] = STATE(11736),
    [sym_range] = STATE(11736),
    [sym_binary] = STATE(11736),
    [sym_unary] = STATE(11736),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11446] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(10958),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(8231),
    [sym_scope_resolution] = STATE(2993),
    [sym_call] = STATE(2993),
    [sym_method_call] = STATE(8231),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(10958),
    [sym_operator_assignment] = STATE(10958),
    [sym_conditional] = STATE(10958),
    [sym_range] = STATE(10958),
    [sym_binary] = STATE(10958),
    [sym_unary] = STATE(10958),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(8230),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8231),
    [sym__variable] = STATE(2993),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(8231),
    [sym_false] = STATE(8231),
    [sym_nil] = STATE(8231),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(8232),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(8480),
    [sym__unary_minus2] = ACTIONS(11356),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(11358),
    [anon_sym_yield] = ACTIONS(11360),
    [anon_sym_break] = ACTIONS(11362),
    [anon_sym_next] = ACTIONS(11364),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(11366),
    [anon_sym_defined_QMARK] = ACTIONS(11368),
    [anon_sym_not] = ACTIONS(11370),
    [anon_sym_BANG] = ACTIONS(11372),
    [anon_sym_TILDE] = ACTIONS(11372),
    [sym_constant] = ACTIONS(4774),
    [sym_identifier] = ACTIONS(4774),
    [sym_instance_variable] = ACTIONS(4776),
    [sym_class_variable] = ACTIONS(4776),
    [sym_global_variable] = ACTIONS(4776),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(4774),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(4774),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11447] = {
    [aux_sym_exceptions_repeat1] = STATE(11737),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15241),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_in] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11448] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11738),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_assignment] = STATE(11738),
    [sym_operator_assignment] = STATE(11738),
    [sym_conditional] = STATE(11738),
    [sym_range] = STATE(11738),
    [sym_binary] = STATE(11738),
    [sym_unary] = STATE(11738),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11449] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(10980),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8326),
    [sym_scope_resolution] = STATE(3136),
    [sym_call] = STATE(3136),
    [sym_method_call] = STATE(8326),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(10980),
    [sym_operator_assignment] = STATE(10980),
    [sym_conditional] = STATE(10980),
    [sym_range] = STATE(10980),
    [sym_binary] = STATE(10980),
    [sym_unary] = STATE(10980),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(8325),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8326),
    [sym__variable] = STATE(3136),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8326),
    [sym_false] = STATE(8326),
    [sym_nil] = STATE(8326),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(3140),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(8638),
    [sym__unary_minus2] = ACTIONS(11412),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4960),
    [anon_sym_break] = ACTIONS(4962),
    [anon_sym_next] = ACTIONS(4964),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11414),
    [anon_sym_defined_QMARK] = ACTIONS(11416),
    [anon_sym_not] = ACTIONS(11418),
    [anon_sym_BANG] = ACTIONS(11420),
    [anon_sym_TILDE] = ACTIONS(11420),
    [sym_constant] = ACTIONS(4974),
    [sym_identifier] = ACTIONS(4974),
    [sym_instance_variable] = ACTIONS(4976),
    [sym_class_variable] = ACTIONS(4976),
    [sym_global_variable] = ACTIONS(4976),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(4974),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(4974),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11450] = {
    [aux_sym_exceptions_repeat1] = STATE(11739),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15243),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11451] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [11452] = {
    [sym_heredoc_body] = STATE(11740),
    [aux_sym_call_repeat1] = STATE(11740),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(1703),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11453] = {
    [sym_heredoc_body] = STATE(11740),
    [aux_sym_call_repeat1] = STATE(11740),
    [aux_sym_argument_list_repeat1] = STATE(11741),
    [sym__line_break2] = ACTIONS(1703),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(1703),
    [sym__binary_star2] = ACTIONS(1703),
    [anon_sym_DOT] = ACTIONS(1707),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_PIPE] = ACTIONS(1707),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_STAR_STAR] = ACTIONS(1703),
    [anon_sym_AMP] = ACTIONS(1707),
    [anon_sym_LT] = ACTIONS(1707),
    [anon_sym_end] = ACTIONS(1703),
    [anon_sym_if] = ACTIONS(1703),
    [anon_sym_unless] = ACTIONS(1703),
    [anon_sym_while] = ACTIONS(1703),
    [anon_sym_until] = ACTIONS(1703),
    [anon_sym_rescue] = ACTIONS(1703),
    [anon_sym_when] = ACTIONS(1703),
    [anon_sym_else] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1703),
    [anon_sym_COLON_COLON2] = ACTIONS(1703),
    [anon_sym_AMP_DOT] = ACTIONS(1703),
    [anon_sym_QMARK] = ACTIONS(1703),
    [anon_sym_DOT_DOT] = ACTIONS(1707),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(1703),
    [anon_sym_and] = ACTIONS(1703),
    [anon_sym_or] = ACTIONS(1703),
    [anon_sym_PIPE_PIPE] = ACTIONS(1703),
    [anon_sym_AMP_AMP] = ACTIONS(1703),
    [anon_sym_LT_LT] = ACTIONS(1703),
    [anon_sym_GT_GT] = ACTIONS(1703),
    [anon_sym_EQ_EQ] = ACTIONS(1707),
    [anon_sym_BANG_EQ] = ACTIONS(1703),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(1703),
    [anon_sym_LT_EQ_GT] = ACTIONS(1703),
    [anon_sym_EQ_TILDE] = ACTIONS(1703),
    [anon_sym_BANG_TILDE] = ACTIONS(1703),
    [anon_sym_LT_EQ] = ACTIONS(1707),
    [anon_sym_GT] = ACTIONS(1707),
    [anon_sym_GT_EQ] = ACTIONS(1703),
    [anon_sym_CARET] = ACTIONS(1703),
    [anon_sym_PLUS] = ACTIONS(1703),
    [anon_sym_SLASH] = ACTIONS(1703),
    [anon_sym_PERCENT] = ACTIONS(1703),
    [sym_comment] = ACTIONS(87),
  },
  [11454] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [11455] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11456] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11742),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11742),
    [sym_operator_assignment] = STATE(11742),
    [sym_conditional] = STATE(11742),
    [sym_range] = STATE(11742),
    [sym_binary] = STATE(11742),
    [sym_unary] = STATE(11742),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11457] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11743),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11743),
    [sym_operator_assignment] = STATE(11743),
    [sym_conditional] = STATE(11743),
    [sym_range] = STATE(11743),
    [sym_binary] = STATE(11743),
    [sym_unary] = STATE(11743),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11458] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11744),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11744),
    [sym_operator_assignment] = STATE(11744),
    [sym_conditional] = STATE(11744),
    [sym_range] = STATE(11744),
    [sym_binary] = STATE(11744),
    [sym_unary] = STATE(11744),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11459] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11745),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11745),
    [sym_operator_assignment] = STATE(11745),
    [sym_conditional] = STATE(11745),
    [sym_range] = STATE(11745),
    [sym_binary] = STATE(11745),
    [sym_unary] = STATE(11745),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11460] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11746),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11746),
    [sym_operator_assignment] = STATE(11746),
    [sym_conditional] = STATE(11746),
    [sym_range] = STATE(11746),
    [sym_binary] = STATE(11746),
    [sym_unary] = STATE(11746),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11461] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11747),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11747),
    [sym_operator_assignment] = STATE(11747),
    [sym_conditional] = STATE(11747),
    [sym_range] = STATE(11747),
    [sym_binary] = STATE(11747),
    [sym_unary] = STATE(11747),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11462] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11748),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11748),
    [sym_operator_assignment] = STATE(11748),
    [sym_conditional] = STATE(11748),
    [sym_range] = STATE(11748),
    [sym_binary] = STATE(11748),
    [sym_unary] = STATE(11748),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11463] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11749),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11749),
    [sym_operator_assignment] = STATE(11749),
    [sym_conditional] = STATE(11749),
    [sym_range] = STATE(11749),
    [sym_binary] = STATE(11749),
    [sym_unary] = STATE(11749),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11464] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11750),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11750),
    [sym_operator_assignment] = STATE(11750),
    [sym_conditional] = STATE(11750),
    [sym_range] = STATE(11750),
    [sym_binary] = STATE(11750),
    [sym_unary] = STATE(11750),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11465] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11751),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11751),
    [sym_operator_assignment] = STATE(11751),
    [sym_conditional] = STATE(11751),
    [sym_range] = STATE(11751),
    [sym_binary] = STATE(11751),
    [sym_unary] = STATE(11751),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11466] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11752),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11752),
    [sym_operator_assignment] = STATE(11752),
    [sym_conditional] = STATE(11752),
    [sym_range] = STATE(11752),
    [sym_binary] = STATE(11752),
    [sym_unary] = STATE(11752),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11467] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11753),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11753),
    [sym_operator_assignment] = STATE(11753),
    [sym_conditional] = STATE(11753),
    [sym_range] = STATE(11753),
    [sym_binary] = STATE(11753),
    [sym_unary] = STATE(11753),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11468] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11754),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_splat_argument] = STATE(11755),
    [sym_assignment] = STATE(11754),
    [sym_operator_assignment] = STATE(11754),
    [sym_conditional] = STATE(11754),
    [sym_range] = STATE(11754),
    [sym_binary] = STATE(11754),
    [sym_unary] = STATE(11754),
    [sym_right_assignment_list] = STATE(2687),
    [sym__arg_or_splat_arg] = STATE(11755),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11469] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11756),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11756),
    [sym_operator_assignment] = STATE(11756),
    [sym_conditional] = STATE(11756),
    [sym_range] = STATE(11756),
    [sym_binary] = STATE(11756),
    [sym_unary] = STATE(11756),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11470] = {
    [sym_string] = STATE(11757),
    [aux_sym_chained_string_repeat1] = STATE(11757),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(7),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_when] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [11471] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_when] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11472] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11473] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11474] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11758),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11758),
    [sym_operator_assignment] = STATE(11758),
    [sym_conditional] = STATE(11758),
    [sym_range] = STATE(11758),
    [sym_binary] = STATE(11758),
    [sym_unary] = STATE(11758),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11475] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_when] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11476] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11759),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11759),
    [sym_operator_assignment] = STATE(11759),
    [sym_conditional] = STATE(11759),
    [sym_range] = STATE(11759),
    [sym_binary] = STATE(11759),
    [sym_unary] = STATE(11759),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11477] = {
    [sym_heredoc_body] = STATE(11760),
    [aux_sym_call_repeat1] = STATE(11760),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11478] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym__argument] = STATE(2682),
    [sym_splat_argument] = STATE(2682),
    [sym_hash_splat_argument] = STATE(2682),
    [sym_block_argument] = STATE(2682),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_heredoc_body] = STATE(11761),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(2682),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15245),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11479] = {
    [sym_heredoc_body] = STATE(11762),
    [aux_sym_call_repeat1] = STATE(11762),
    [aux_sym_argument_list_repeat1] = STATE(11763),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14910),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11480] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11481] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11482] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11483] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11484] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11485] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11486] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_when] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11487] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15247),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11488] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11489] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11490] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11491] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11492] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11493] = {
    [sym__line_break2] = ACTIONS(4164),
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(4164),
    [anon_sym_if] = ACTIONS(4164),
    [anon_sym_unless] = ACTIONS(4164),
    [anon_sym_while] = ACTIONS(4164),
    [anon_sym_until] = ACTIONS(4164),
    [anon_sym_rescue] = ACTIONS(4164),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_else] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11494] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11495] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11765),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11765),
    [sym_operator_assignment] = STATE(11765),
    [sym_conditional] = STATE(11765),
    [sym_range] = STATE(11765),
    [sym_binary] = STATE(11765),
    [sym_unary] = STATE(11765),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11496] = {
    [sym__line_break2] = ACTIONS(3204),
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(3204),
    [anon_sym_if] = ACTIONS(3204),
    [anon_sym_unless] = ACTIONS(3204),
    [anon_sym_while] = ACTIONS(3204),
    [anon_sym_until] = ACTIONS(3204),
    [anon_sym_rescue] = ACTIONS(3204),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_when] = ACTIONS(3204),
    [anon_sym_else] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11497] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11766),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11766),
    [sym_operator_assignment] = STATE(11766),
    [sym_conditional] = STATE(11766),
    [sym_range] = STATE(11766),
    [sym_binary] = STATE(11766),
    [sym_unary] = STATE(11766),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11498] = {
    [sym_heredoc_body] = STATE(11767),
    [aux_sym_call_repeat1] = STATE(11767),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11499] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym__argument] = STATE(5229),
    [sym_splat_argument] = STATE(5229),
    [sym_hash_splat_argument] = STATE(5229),
    [sym_block_argument] = STATE(5229),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_heredoc_body] = STATE(11768),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(5229),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15249),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11500] = {
    [sym_heredoc_body] = STATE(11769),
    [aux_sym_call_repeat1] = STATE(11769),
    [aux_sym_argument_list_repeat1] = STATE(11770),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14918),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11501] = {
    [sym_heredoc_body] = STATE(11501),
    [aux_sym_call_repeat1] = STATE(11501),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_when] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11502] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10059),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(10059),
    [sym_operator_assignment] = STATE(10059),
    [sym_conditional] = STATE(10059),
    [sym_range] = STATE(10059),
    [sym_binary] = STATE(10059),
    [sym_unary] = STATE(10059),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10065),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13276),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__identifier_hash_key2] = ACTIONS(13282),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14922),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13300),
    [sym_identifier] = ACTIONS(13300),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11503] = {
    [sym_heredoc_body] = STATE(11501),
    [aux_sym_call_repeat1] = STATE(11501),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_when] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11504] = {
    [aux_sym_argument_list_repeat1] = STATE(11504),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15251),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11505] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_when] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11506] = {
    [aux_sym_exceptions_repeat1] = STATE(11772),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11507] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11508] = {
    [sym_string] = STATE(11508),
    [aux_sym_chained_string_repeat1] = STATE(11508),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_when] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11509] = {
    [aux_sym_undef_repeat1] = STATE(11509),
    [sym__line_break2] = ACTIONS(9314),
    [sym__heredoc_body_start2] = ACTIONS(9314),
    [anon_sym_COMMA] = ACTIONS(9316),
    [anon_sym_SEMI] = ACTIONS(9314),
    [anon_sym_end] = ACTIONS(9314),
    [anon_sym_if] = ACTIONS(9314),
    [anon_sym_unless] = ACTIONS(9314),
    [anon_sym_while] = ACTIONS(9314),
    [anon_sym_until] = ACTIONS(9314),
    [anon_sym_rescue] = ACTIONS(9314),
    [anon_sym_when] = ACTIONS(9314),
    [anon_sym_else] = ACTIONS(9314),
    [sym_comment] = ACTIONS(87),
  },
  [11510] = {
    [sym__top_level_statement] = STATE(1475),
    [sym_begin_block] = STATE(46),
    [sym_end_block] = STATE(46),
    [sym__statement] = STATE(8346),
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_if_modifier] = STATE(48),
    [sym_unless_modifier] = STATE(48),
    [sym_while_modifier] = STATE(48),
    [sym_until_modifier] = STATE(48),
    [sym_rescue_modifier] = STATE(48),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(8348),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(8348),
    [sym_operator_assignment] = STATE(8348),
    [sym_conditional] = STATE(8348),
    [sym_range] = STATE(8348),
    [sym_binary] = STATE(8348),
    [sym_unary] = STATE(8348),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_undef] = STATE(48),
    [sym_alias] = STATE(48),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym_empty_statement] = STATE(48),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_BEGIN] = ACTIONS(27),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_END] = ACTIONS(31),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_SEMI] = ACTIONS(39),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [anon_sym_undef] = ACTIONS(11458),
    [anon_sym_alias] = ACTIONS(85),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11511] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11773),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8351),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(8351),
    [sym_assignment] = STATE(11773),
    [sym_operator_assignment] = STATE(11773),
    [sym_conditional] = STATE(11773),
    [sym_range] = STATE(11773),
    [sym_binary] = STATE(11773),
    [sym_unary] = STATE(11773),
    [sym_left_assignment_list] = STATE(8350),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8351),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8351),
    [sym_false] = STATE(8351),
    [sym_nil] = STATE(8351),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8352),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11432),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11436),
    [anon_sym_yield] = ACTIONS(11438),
    [anon_sym_break] = ACTIONS(11440),
    [anon_sym_next] = ACTIONS(11442),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11446),
    [anon_sym_defined_QMARK] = ACTIONS(11448),
    [anon_sym_not] = ACTIONS(11450),
    [anon_sym_BANG] = ACTIONS(11452),
    [anon_sym_TILDE] = ACTIONS(11452),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11512] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [11513] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [11514] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11515] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11774),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11774),
    [sym_operator_assignment] = STATE(11774),
    [sym_conditional] = STATE(11774),
    [sym_range] = STATE(11774),
    [sym_binary] = STATE(11774),
    [sym_unary] = STATE(11774),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11516] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11775),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11775),
    [sym_operator_assignment] = STATE(11775),
    [sym_conditional] = STATE(11775),
    [sym_range] = STATE(11775),
    [sym_binary] = STATE(11775),
    [sym_unary] = STATE(11775),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11517] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11776),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11776),
    [sym_operator_assignment] = STATE(11776),
    [sym_conditional] = STATE(11776),
    [sym_range] = STATE(11776),
    [sym_binary] = STATE(11776),
    [sym_unary] = STATE(11776),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11518] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11777),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11777),
    [sym_operator_assignment] = STATE(11777),
    [sym_conditional] = STATE(11777),
    [sym_range] = STATE(11777),
    [sym_binary] = STATE(11777),
    [sym_unary] = STATE(11777),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11519] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11778),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11778),
    [sym_operator_assignment] = STATE(11778),
    [sym_conditional] = STATE(11778),
    [sym_range] = STATE(11778),
    [sym_binary] = STATE(11778),
    [sym_unary] = STATE(11778),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11520] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11779),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11779),
    [sym_operator_assignment] = STATE(11779),
    [sym_conditional] = STATE(11779),
    [sym_range] = STATE(11779),
    [sym_binary] = STATE(11779),
    [sym_unary] = STATE(11779),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11521] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11780),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11780),
    [sym_operator_assignment] = STATE(11780),
    [sym_conditional] = STATE(11780),
    [sym_range] = STATE(11780),
    [sym_binary] = STATE(11780),
    [sym_unary] = STATE(11780),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11522] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11781),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11781),
    [sym_operator_assignment] = STATE(11781),
    [sym_conditional] = STATE(11781),
    [sym_range] = STATE(11781),
    [sym_binary] = STATE(11781),
    [sym_unary] = STATE(11781),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11523] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11782),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11782),
    [sym_operator_assignment] = STATE(11782),
    [sym_conditional] = STATE(11782),
    [sym_range] = STATE(11782),
    [sym_binary] = STATE(11782),
    [sym_unary] = STATE(11782),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11524] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11783),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11783),
    [sym_operator_assignment] = STATE(11783),
    [sym_conditional] = STATE(11783),
    [sym_range] = STATE(11783),
    [sym_binary] = STATE(11783),
    [sym_unary] = STATE(11783),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11525] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11784),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11784),
    [sym_operator_assignment] = STATE(11784),
    [sym_conditional] = STATE(11784),
    [sym_range] = STATE(11784),
    [sym_binary] = STATE(11784),
    [sym_unary] = STATE(11784),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11526] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11785),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11785),
    [sym_operator_assignment] = STATE(11785),
    [sym_conditional] = STATE(11785),
    [sym_range] = STATE(11785),
    [sym_binary] = STATE(11785),
    [sym_unary] = STATE(11785),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11527] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11786),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_splat_argument] = STATE(11787),
    [sym_assignment] = STATE(11786),
    [sym_operator_assignment] = STATE(11786),
    [sym_conditional] = STATE(11786),
    [sym_range] = STATE(11786),
    [sym_binary] = STATE(11786),
    [sym_unary] = STATE(11786),
    [sym_right_assignment_list] = STATE(6705),
    [sym__arg_or_splat_arg] = STATE(11787),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11528] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11788),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11788),
    [sym_operator_assignment] = STATE(11788),
    [sym_conditional] = STATE(11788),
    [sym_range] = STATE(11788),
    [sym_binary] = STATE(11788),
    [sym_unary] = STATE(11788),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11529] = {
    [sym_string] = STATE(11789),
    [aux_sym_chained_string_repeat1] = STATE(11789),
    [sym__line_break2] = ACTIONS(2807),
    [sym__string_start2] = ACTIONS(2605),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_end] = ACTIONS(2807),
    [anon_sym_if] = ACTIONS(2807),
    [anon_sym_unless] = ACTIONS(2807),
    [anon_sym_while] = ACTIONS(2807),
    [anon_sym_until] = ACTIONS(2807),
    [anon_sym_rescue] = ACTIONS(2807),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_when] = ACTIONS(2807),
    [anon_sym_else] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [11530] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_when] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11531] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11532] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [11533] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11534] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [11535] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11536] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11537] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_when] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11538] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15254),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11539] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11540] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11541] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11542] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11543] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11544] = {
    [sym_heredoc_body] = STATE(11544),
    [aux_sym_call_repeat1] = STATE(11544),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(9920),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_when] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [11545] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(10102),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym__argument] = STATE(6782),
    [sym_splat_argument] = STATE(6782),
    [sym_hash_splat_argument] = STATE(6782),
    [sym_block_argument] = STATE(6782),
    [sym_assignment] = STATE(10102),
    [sym_operator_assignment] = STATE(10102),
    [sym_conditional] = STATE(10102),
    [sym_range] = STATE(10102),
    [sym_binary] = STATE(10102),
    [sym_unary] = STATE(10102),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(10108),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(6782),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(13354),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__identifier_hash_key2] = ACTIONS(13360),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(14963),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13378),
    [sym_identifier] = ACTIONS(13378),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11546] = {
    [sym_heredoc_body] = STATE(11544),
    [aux_sym_call_repeat1] = STATE(11544),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(2781),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_when] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [11547] = {
    [aux_sym_argument_list_repeat1] = STATE(11547),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15256),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [11548] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_when] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11549] = {
    [aux_sym_exceptions_repeat1] = STATE(11792),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [11550] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11551] = {
    [sym_string] = STATE(11551),
    [aux_sym_chained_string_repeat1] = STATE(11551),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(9926),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_when] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [11552] = {
    [sym__line_break2] = ACTIONS(4204),
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4204),
    [anon_sym_unless] = ACTIONS(4204),
    [anon_sym_while] = ACTIONS(4204),
    [anon_sym_until] = ACTIONS(4204),
    [anon_sym_rescue] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_else] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11553] = {
    [sym__line_break2] = ACTIONS(939),
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_end] = ACTIONS(939),
    [anon_sym_if] = ACTIONS(939),
    [anon_sym_unless] = ACTIONS(939),
    [anon_sym_while] = ACTIONS(939),
    [anon_sym_until] = ACTIONS(939),
    [anon_sym_rescue] = ACTIONS(939),
    [anon_sym_when] = ACTIONS(939),
    [anon_sym_else] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [11554] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [11555] = {
    [sym__line_break2] = ACTIONS(2293),
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(2293),
    [anon_sym_if] = ACTIONS(2293),
    [anon_sym_unless] = ACTIONS(2293),
    [anon_sym_while] = ACTIONS(2293),
    [anon_sym_until] = ACTIONS(2293),
    [anon_sym_rescue] = ACTIONS(2293),
    [anon_sym_when] = ACTIONS(2293),
    [anon_sym_else] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11556] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11793),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11793),
    [sym_operator_assignment] = STATE(11793),
    [sym_conditional] = STATE(11793),
    [sym_range] = STATE(11793),
    [sym_binary] = STATE(11793),
    [sym_unary] = STATE(11793),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11557] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11794),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11794),
    [sym_operator_assignment] = STATE(11794),
    [sym_conditional] = STATE(11794),
    [sym_range] = STATE(11794),
    [sym_binary] = STATE(11794),
    [sym_unary] = STATE(11794),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11558] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11795),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11795),
    [sym_operator_assignment] = STATE(11795),
    [sym_conditional] = STATE(11795),
    [sym_range] = STATE(11795),
    [sym_binary] = STATE(11795),
    [sym_unary] = STATE(11795),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11559] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11796),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11796),
    [sym_operator_assignment] = STATE(11796),
    [sym_conditional] = STATE(11796),
    [sym_range] = STATE(11796),
    [sym_binary] = STATE(11796),
    [sym_unary] = STATE(11796),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11560] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11797),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11797),
    [sym_operator_assignment] = STATE(11797),
    [sym_conditional] = STATE(11797),
    [sym_range] = STATE(11797),
    [sym_binary] = STATE(11797),
    [sym_unary] = STATE(11797),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11561] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11798),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11798),
    [sym_operator_assignment] = STATE(11798),
    [sym_conditional] = STATE(11798),
    [sym_range] = STATE(11798),
    [sym_binary] = STATE(11798),
    [sym_unary] = STATE(11798),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11562] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11799),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11799),
    [sym_operator_assignment] = STATE(11799),
    [sym_conditional] = STATE(11799),
    [sym_range] = STATE(11799),
    [sym_binary] = STATE(11799),
    [sym_unary] = STATE(11799),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11563] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11800),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11800),
    [sym_operator_assignment] = STATE(11800),
    [sym_conditional] = STATE(11800),
    [sym_range] = STATE(11800),
    [sym_binary] = STATE(11800),
    [sym_unary] = STATE(11800),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11564] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11801),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11801),
    [sym_operator_assignment] = STATE(11801),
    [sym_conditional] = STATE(11801),
    [sym_range] = STATE(11801),
    [sym_binary] = STATE(11801),
    [sym_unary] = STATE(11801),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11565] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11802),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11802),
    [sym_operator_assignment] = STATE(11802),
    [sym_conditional] = STATE(11802),
    [sym_range] = STATE(11802),
    [sym_binary] = STATE(11802),
    [sym_unary] = STATE(11802),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11566] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11803),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11803),
    [sym_operator_assignment] = STATE(11803),
    [sym_conditional] = STATE(11803),
    [sym_range] = STATE(11803),
    [sym_binary] = STATE(11803),
    [sym_unary] = STATE(11803),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11567] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11804),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11804),
    [sym_operator_assignment] = STATE(11804),
    [sym_conditional] = STATE(11804),
    [sym_range] = STATE(11804),
    [sym_binary] = STATE(11804),
    [sym_unary] = STATE(11804),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11568] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11103),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_splat_argument] = STATE(6797),
    [sym_assignment] = STATE(11103),
    [sym_operator_assignment] = STATE(11103),
    [sym_conditional] = STATE(11103),
    [sym_range] = STATE(11103),
    [sym_binary] = STATE(11103),
    [sym_unary] = STATE(11103),
    [sym__arg_or_splat_arg] = STATE(6797),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(14330),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11569] = {
    [aux_sym_exceptions_repeat1] = STATE(11805),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(14995),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_when] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11570] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11103),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_splat_argument] = STATE(11806),
    [sym_assignment] = STATE(11103),
    [sym_operator_assignment] = STATE(11103),
    [sym_conditional] = STATE(11103),
    [sym_range] = STATE(11103),
    [sym_binary] = STATE(11103),
    [sym_unary] = STATE(11103),
    [sym_right_assignment_list] = STATE(1668),
    [sym__arg_or_splat_arg] = STATE(11806),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(14330),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11571] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11807),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11807),
    [sym_operator_assignment] = STATE(11807),
    [sym_conditional] = STATE(11807),
    [sym_range] = STATE(11807),
    [sym_binary] = STATE(11807),
    [sym_unary] = STATE(11807),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11572] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11808),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_assignment] = STATE(11808),
    [sym_operator_assignment] = STATE(11808),
    [sym_conditional] = STATE(11808),
    [sym_range] = STATE(11808),
    [sym_binary] = STATE(11808),
    [sym_unary] = STATE(11808),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11573] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11123),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(8378),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8378),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(11123),
    [sym_operator_assignment] = STATE(11123),
    [sym_conditional] = STATE(11123),
    [sym_range] = STATE(11123),
    [sym_binary] = STATE(11123),
    [sym_unary] = STATE(11123),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(8377),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8378),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(8378),
    [sym_false] = STATE(8378),
    [sym_nil] = STATE(8378),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(8379),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(8684),
    [sym__unary_minus2] = ACTIONS(11462),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(11464),
    [anon_sym_yield] = ACTIONS(11466),
    [anon_sym_break] = ACTIONS(11468),
    [anon_sym_next] = ACTIONS(11470),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(11472),
    [anon_sym_defined_QMARK] = ACTIONS(11474),
    [anon_sym_not] = ACTIONS(11476),
    [anon_sym_BANG] = ACTIONS(11478),
    [anon_sym_TILDE] = ACTIONS(11478),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11574] = {
    [aux_sym_exceptions_repeat1] = STATE(11809),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15259),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11575] = {
    [sym__line_break2] = ACTIONS(10934),
    [sym__simple_symbol2] = ACTIONS(10934),
    [sym__string_start2] = ACTIONS(10934),
    [sym__symbol_start2] = ACTIONS(10934),
    [sym__subshell_start2] = ACTIONS(10934),
    [sym__regex_start2] = ACTIONS(10934),
    [sym__string_array_start2] = ACTIONS(10934),
    [sym__symbol_array_start2] = ACTIONS(10934),
    [sym__heredoc_body_start2] = ACTIONS(10934),
    [sym_heredoc_beginning2] = ACTIONS(10934),
    [sym__block_ampersand2] = ACTIONS(10934),
    [sym__splat_star2] = ACTIONS(10934),
    [sym__unary_minus2] = ACTIONS(10934),
    [sym__identifier_hash_key2] = ACTIONS(10934),
    [anon_sym_LBRACE] = ACTIONS(10934),
    [anon_sym_def] = ACTIONS(10936),
    [anon_sym_LPAREN] = ACTIONS(10936),
    [anon_sym_DOT] = ACTIONS(10934),
    [anon_sym_COLON_COLON] = ACTIONS(10936),
    [anon_sym_SEMI] = ACTIONS(10934),
    [anon_sym_STAR] = ACTIONS(10936),
    [anon_sym_STAR_STAR] = ACTIONS(10934),
    [anon_sym_class] = ACTIONS(10936),
    [anon_sym_module] = ACTIONS(10936),
    [anon_sym_return] = ACTIONS(10936),
    [anon_sym_yield] = ACTIONS(10936),
    [anon_sym_break] = ACTIONS(10936),
    [anon_sym_next] = ACTIONS(10936),
    [sym_redo] = ACTIONS(10936),
    [sym_retry] = ACTIONS(10936),
    [anon_sym_if] = ACTIONS(10936),
    [anon_sym_unless] = ACTIONS(10936),
    [anon_sym_while] = ACTIONS(10936),
    [anon_sym_until] = ACTIONS(10936),
    [anon_sym_for] = ACTIONS(10936),
    [anon_sym_do] = ACTIONS(10936),
    [anon_sym_case] = ACTIONS(10936),
    [anon_sym_then] = ACTIONS(10936),
    [anon_sym_begin] = ACTIONS(10936),
    [anon_sym_LBRACK] = ACTIONS(10934),
    [anon_sym_COLON_COLON2] = ACTIONS(10934),
    [anon_sym_AMP_DOT] = ACTIONS(10934),
    [anon_sym_LPAREN2] = ACTIONS(10934),
    [anon_sym_PLUS] = ACTIONS(10936),
    [anon_sym_defined_QMARK] = ACTIONS(10934),
    [anon_sym_not] = ACTIONS(10936),
    [anon_sym_BANG] = ACTIONS(10934),
    [anon_sym_TILDE] = ACTIONS(10934),
    [sym_constant] = ACTIONS(10936),
    [sym_identifier] = ACTIONS(10936),
    [sym_instance_variable] = ACTIONS(10934),
    [sym_class_variable] = ACTIONS(10934),
    [sym_global_variable] = ACTIONS(10934),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(10936),
    [sym_float] = ACTIONS(10936),
    [sym_complex] = ACTIONS(10934),
    [sym_super] = ACTIONS(10936),
    [anon_sym_true] = ACTIONS(10936),
    [anon_sym_TRUE] = ACTIONS(10936),
    [anon_sym_false] = ACTIONS(10936),
    [anon_sym_FALSE] = ACTIONS(10936),
    [sym_self] = ACTIONS(10936),
    [anon_sym_nil] = ACTIONS(10936),
    [anon_sym_NIL] = ACTIONS(10936),
    [sym_character] = ACTIONS(10934),
    [anon_sym_LBRACK2] = ACTIONS(10936),
    [anon_sym_DASH_GT] = ACTIONS(10934),
  },
  [11576] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_then] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11577] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_then] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11578] = {
    [sym_heredoc_body] = STATE(11578),
    [aux_sym_call_repeat1] = STATE(11578),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_then] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11579] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(10163),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(5935),
    [sym_scope_resolution] = STATE(3255),
    [sym_call] = STATE(3255),
    [sym_method_call] = STATE(5935),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(10163),
    [sym_operator_assignment] = STATE(10163),
    [sym_conditional] = STATE(10163),
    [sym_range] = STATE(10163),
    [sym_binary] = STATE(10163),
    [sym_unary] = STATE(10163),
    [sym_left_assignment_list] = STATE(5934),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(5935),
    [sym__variable] = STATE(3255),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(5935),
    [sym_false] = STATE(5935),
    [sym_nil] = STATE(5935),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10166),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(13454),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(8815),
    [sym__identifier_hash_key2] = ACTIONS(13458),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15018),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(8823),
    [anon_sym_yield] = ACTIONS(8825),
    [anon_sym_break] = ACTIONS(8827),
    [anon_sym_next] = ACTIONS(8829),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(8833),
    [anon_sym_defined_QMARK] = ACTIONS(8835),
    [anon_sym_not] = ACTIONS(8837),
    [anon_sym_BANG] = ACTIONS(8839),
    [anon_sym_TILDE] = ACTIONS(8839),
    [sym_constant] = ACTIONS(13460),
    [sym_identifier] = ACTIONS(13460),
    [sym_instance_variable] = ACTIONS(5164),
    [sym_class_variable] = ACTIONS(5164),
    [sym_global_variable] = ACTIONS(5164),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(5166),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(5166),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11580] = {
    [sym_heredoc_body] = STATE(11578),
    [aux_sym_call_repeat1] = STATE(11578),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_then] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11581] = {
    [aux_sym_argument_list_repeat1] = STATE(11581),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15261),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_then] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11582] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11810),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_assignment] = STATE(11810),
    [sym_operator_assignment] = STATE(11810),
    [sym_conditional] = STATE(11810),
    [sym_range] = STATE(11810),
    [sym_binary] = STATE(11810),
    [sym_unary] = STATE(11810),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11583] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11155),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(8464),
    [sym_scope_resolution] = STATE(8376),
    [sym_call] = STATE(8376),
    [sym_method_call] = STATE(8464),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(11155),
    [sym_operator_assignment] = STATE(11155),
    [sym_conditional] = STATE(11155),
    [sym_range] = STATE(11155),
    [sym_binary] = STATE(11155),
    [sym_unary] = STATE(11155),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(8463),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8464),
    [sym__variable] = STATE(8376),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(8464),
    [sym_false] = STATE(8464),
    [sym_nil] = STATE(8464),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(8465),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(13456),
    [sym__unary_minus2] = ACTIONS(11517),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(11519),
    [anon_sym_yield] = ACTIONS(11521),
    [anon_sym_break] = ACTIONS(11523),
    [anon_sym_next] = ACTIONS(11525),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(11527),
    [anon_sym_defined_QMARK] = ACTIONS(11529),
    [anon_sym_not] = ACTIONS(11531),
    [anon_sym_BANG] = ACTIONS(11533),
    [anon_sym_TILDE] = ACTIONS(11533),
    [sym_constant] = ACTIONS(11480),
    [sym_identifier] = ACTIONS(11480),
    [sym_instance_variable] = ACTIONS(11482),
    [sym_class_variable] = ACTIONS(11482),
    [sym_global_variable] = ACTIONS(11482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11480),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11480),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11584] = {
    [aux_sym_exceptions_repeat1] = STATE(11811),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15264),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_then] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11585] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11553),
    [sym__binary_star2] = ACTIONS(11555),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11557),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11559),
    [anon_sym_AMP] = ACTIONS(11561),
    [anon_sym_LT] = ACTIONS(11563),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11567),
    [anon_sym_DOT_DOT] = ACTIONS(11569),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11571),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11575),
    [anon_sym_AMP_AMP] = ACTIONS(11575),
    [anon_sym_LT_LT] = ACTIONS(11577),
    [anon_sym_GT_GT] = ACTIONS(11577),
    [anon_sym_EQ_EQ] = ACTIONS(11579),
    [anon_sym_BANG_EQ] = ACTIONS(11575),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11575),
    [anon_sym_LT_EQ_GT] = ACTIONS(11575),
    [anon_sym_EQ_TILDE] = ACTIONS(11575),
    [anon_sym_BANG_TILDE] = ACTIONS(11575),
    [anon_sym_LT_EQ] = ACTIONS(11563),
    [anon_sym_GT] = ACTIONS(11563),
    [anon_sym_GT_EQ] = ACTIONS(11581),
    [anon_sym_CARET] = ACTIONS(11583),
    [anon_sym_PLUS] = ACTIONS(11585),
    [anon_sym_SLASH] = ACTIONS(11559),
    [anon_sym_PERCENT] = ACTIONS(11559),
    [sym_comment] = ACTIONS(87),
  },
  [11586] = {
    [aux_sym_exceptions_repeat1] = STATE(11586),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15266),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11587] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11612),
    [sym__binary_star2] = ACTIONS(11614),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11616),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11618),
    [anon_sym_AMP] = ACTIONS(11620),
    [anon_sym_LT] = ACTIONS(11622),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11624),
    [anon_sym_DOT_DOT] = ACTIONS(11626),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11628),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11630),
    [anon_sym_AMP_AMP] = ACTIONS(11630),
    [anon_sym_LT_LT] = ACTIONS(11632),
    [anon_sym_GT_GT] = ACTIONS(11632),
    [anon_sym_EQ_EQ] = ACTIONS(11634),
    [anon_sym_BANG_EQ] = ACTIONS(11630),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11630),
    [anon_sym_LT_EQ_GT] = ACTIONS(11630),
    [anon_sym_EQ_TILDE] = ACTIONS(11630),
    [anon_sym_BANG_TILDE] = ACTIONS(11630),
    [anon_sym_LT_EQ] = ACTIONS(11622),
    [anon_sym_GT] = ACTIONS(11622),
    [anon_sym_GT_EQ] = ACTIONS(11636),
    [anon_sym_CARET] = ACTIONS(11638),
    [anon_sym_PLUS] = ACTIONS(11640),
    [anon_sym_SLASH] = ACTIONS(11618),
    [anon_sym_PERCENT] = ACTIONS(11618),
    [sym_comment] = ACTIONS(87),
  },
  [11588] = {
    [aux_sym_exceptions_repeat1] = STATE(11588),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15269),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11589] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11671),
    [sym__binary_star2] = ACTIONS(11673),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11675),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11677),
    [anon_sym_AMP] = ACTIONS(11679),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(11681),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11683),
    [anon_sym_DOT_DOT] = ACTIONS(11685),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11687),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11689),
    [anon_sym_AMP_AMP] = ACTIONS(11689),
    [anon_sym_LT_LT] = ACTIONS(11691),
    [anon_sym_GT_GT] = ACTIONS(11691),
    [anon_sym_EQ_EQ] = ACTIONS(11689),
    [anon_sym_BANG_EQ] = ACTIONS(11693),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11693),
    [anon_sym_LT_EQ_GT] = ACTIONS(11693),
    [anon_sym_EQ_TILDE] = ACTIONS(11693),
    [anon_sym_BANG_TILDE] = ACTIONS(11693),
    [anon_sym_LT_EQ] = ACTIONS(11681),
    [anon_sym_GT] = ACTIONS(11681),
    [anon_sym_GT_EQ] = ACTIONS(11695),
    [anon_sym_CARET] = ACTIONS(11675),
    [anon_sym_PLUS] = ACTIONS(11697),
    [anon_sym_SLASH] = ACTIONS(11677),
    [anon_sym_PERCENT] = ACTIONS(11677),
    [sym_comment] = ACTIONS(87),
  },
  [11590] = {
    [aux_sym_exceptions_repeat1] = STATE(11590),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15272),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_ensure] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11591] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11707),
    [sym__binary_star2] = ACTIONS(11709),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11711),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11713),
    [anon_sym_AMP] = ACTIONS(11715),
    [anon_sym_LT] = ACTIONS(11717),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_ensure] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11719),
    [anon_sym_DOT_DOT] = ACTIONS(11721),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11723),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11725),
    [anon_sym_AMP_AMP] = ACTIONS(11725),
    [anon_sym_LT_LT] = ACTIONS(11727),
    [anon_sym_GT_GT] = ACTIONS(11727),
    [anon_sym_EQ_EQ] = ACTIONS(11729),
    [anon_sym_BANG_EQ] = ACTIONS(11725),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11725),
    [anon_sym_LT_EQ_GT] = ACTIONS(11725),
    [anon_sym_EQ_TILDE] = ACTIONS(11725),
    [anon_sym_BANG_TILDE] = ACTIONS(11725),
    [anon_sym_LT_EQ] = ACTIONS(11717),
    [anon_sym_GT] = ACTIONS(11717),
    [anon_sym_GT_EQ] = ACTIONS(11731),
    [anon_sym_CARET] = ACTIONS(11733),
    [anon_sym_PLUS] = ACTIONS(11735),
    [anon_sym_SLASH] = ACTIONS(11713),
    [anon_sym_PERCENT] = ACTIONS(11713),
    [sym_comment] = ACTIONS(87),
  },
  [11592] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11745),
    [sym__binary_star2] = ACTIONS(11747),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11749),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11751),
    [anon_sym_AMP] = ACTIONS(11753),
    [anon_sym_LT] = ACTIONS(11755),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11757),
    [anon_sym_DOT_DOT] = ACTIONS(11759),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11761),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11763),
    [anon_sym_AMP_AMP] = ACTIONS(11763),
    [anon_sym_LT_LT] = ACTIONS(11765),
    [anon_sym_GT_GT] = ACTIONS(11765),
    [anon_sym_EQ_EQ] = ACTIONS(11767),
    [anon_sym_BANG_EQ] = ACTIONS(11763),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11763),
    [anon_sym_LT_EQ_GT] = ACTIONS(11763),
    [anon_sym_EQ_TILDE] = ACTIONS(11763),
    [anon_sym_BANG_TILDE] = ACTIONS(11763),
    [anon_sym_LT_EQ] = ACTIONS(11755),
    [anon_sym_GT] = ACTIONS(11755),
    [anon_sym_GT_EQ] = ACTIONS(11769),
    [anon_sym_CARET] = ACTIONS(11771),
    [anon_sym_PLUS] = ACTIONS(11773),
    [anon_sym_SLASH] = ACTIONS(11751),
    [anon_sym_PERCENT] = ACTIONS(11751),
    [sym_comment] = ACTIONS(87),
  },
  [11593] = {
    [aux_sym_exceptions_repeat1] = STATE(11593),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15275),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11594] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11804),
    [sym__binary_star2] = ACTIONS(11806),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11808),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11810),
    [anon_sym_AMP] = ACTIONS(11812),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(11814),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11816),
    [anon_sym_DOT_DOT] = ACTIONS(11818),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11820),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11822),
    [anon_sym_AMP_AMP] = ACTIONS(11822),
    [anon_sym_LT_LT] = ACTIONS(11824),
    [anon_sym_GT_GT] = ACTIONS(11824),
    [anon_sym_EQ_EQ] = ACTIONS(11822),
    [anon_sym_BANG_EQ] = ACTIONS(11826),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11826),
    [anon_sym_LT_EQ_GT] = ACTIONS(11826),
    [anon_sym_EQ_TILDE] = ACTIONS(11826),
    [anon_sym_BANG_TILDE] = ACTIONS(11826),
    [anon_sym_LT_EQ] = ACTIONS(11814),
    [anon_sym_GT] = ACTIONS(11814),
    [anon_sym_GT_EQ] = ACTIONS(11828),
    [anon_sym_CARET] = ACTIONS(11808),
    [anon_sym_PLUS] = ACTIONS(11830),
    [anon_sym_SLASH] = ACTIONS(11810),
    [anon_sym_PERCENT] = ACTIONS(11810),
    [sym_comment] = ACTIONS(87),
  },
  [11595] = {
    [aux_sym_exceptions_repeat1] = STATE(11595),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15278),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11596] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11840),
    [sym__binary_star2] = ACTIONS(11842),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11844),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(11846),
    [anon_sym_AMP] = ACTIONS(11848),
    [anon_sym_LT] = ACTIONS(11850),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11852),
    [anon_sym_DOT_DOT] = ACTIONS(11854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11856),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11858),
    [anon_sym_AMP_AMP] = ACTIONS(11858),
    [anon_sym_LT_LT] = ACTIONS(11860),
    [anon_sym_GT_GT] = ACTIONS(11860),
    [anon_sym_EQ_EQ] = ACTIONS(11862),
    [anon_sym_BANG_EQ] = ACTIONS(11858),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11858),
    [anon_sym_LT_EQ_GT] = ACTIONS(11858),
    [anon_sym_EQ_TILDE] = ACTIONS(11858),
    [anon_sym_BANG_TILDE] = ACTIONS(11858),
    [anon_sym_LT_EQ] = ACTIONS(11850),
    [anon_sym_GT] = ACTIONS(11850),
    [anon_sym_GT_EQ] = ACTIONS(11864),
    [anon_sym_CARET] = ACTIONS(11866),
    [anon_sym_PLUS] = ACTIONS(11868),
    [anon_sym_SLASH] = ACTIONS(11846),
    [anon_sym_PERCENT] = ACTIONS(11846),
    [sym_comment] = ACTIONS(87),
  },
  [11597] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11901),
    [sym__binary_star2] = ACTIONS(11903),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11905),
    [anon_sym_STAR_STAR] = ACTIONS(11907),
    [anon_sym_AMP] = ACTIONS(11909),
    [anon_sym_LT] = ACTIONS(11911),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11913),
    [anon_sym_DOT_DOT] = ACTIONS(11915),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11917),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11919),
    [anon_sym_AMP_AMP] = ACTIONS(11919),
    [anon_sym_LT_LT] = ACTIONS(11921),
    [anon_sym_GT_GT] = ACTIONS(11921),
    [anon_sym_EQ_EQ] = ACTIONS(11923),
    [anon_sym_BANG_EQ] = ACTIONS(11919),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11919),
    [anon_sym_LT_EQ_GT] = ACTIONS(11919),
    [anon_sym_EQ_TILDE] = ACTIONS(11919),
    [anon_sym_BANG_TILDE] = ACTIONS(11919),
    [anon_sym_LT_EQ] = ACTIONS(11911),
    [anon_sym_GT] = ACTIONS(11911),
    [anon_sym_GT_EQ] = ACTIONS(11925),
    [anon_sym_CARET] = ACTIONS(11927),
    [anon_sym_PLUS] = ACTIONS(11929),
    [anon_sym_SLASH] = ACTIONS(11907),
    [anon_sym_PERCENT] = ACTIONS(11907),
    [sym_comment] = ACTIONS(87),
  },
  [11598] = {
    [aux_sym_exceptions_repeat1] = STATE(11598),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15281),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11599] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(11941),
    [sym__binary_star2] = ACTIONS(11943),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(11945),
    [anon_sym_STAR_STAR] = ACTIONS(11947),
    [anon_sym_AMP] = ACTIONS(11949),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(11951),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_RBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(11953),
    [anon_sym_DOT_DOT] = ACTIONS(11955),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11957),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(11959),
    [anon_sym_AMP_AMP] = ACTIONS(11959),
    [anon_sym_LT_LT] = ACTIONS(11961),
    [anon_sym_GT_GT] = ACTIONS(11961),
    [anon_sym_EQ_EQ] = ACTIONS(11959),
    [anon_sym_BANG_EQ] = ACTIONS(11963),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11963),
    [anon_sym_LT_EQ_GT] = ACTIONS(11963),
    [anon_sym_EQ_TILDE] = ACTIONS(11963),
    [anon_sym_BANG_TILDE] = ACTIONS(11963),
    [anon_sym_LT_EQ] = ACTIONS(11951),
    [anon_sym_GT] = ACTIONS(11951),
    [anon_sym_GT_EQ] = ACTIONS(11965),
    [anon_sym_CARET] = ACTIONS(11945),
    [anon_sym_PLUS] = ACTIONS(11967),
    [anon_sym_SLASH] = ACTIONS(11947),
    [anon_sym_PERCENT] = ACTIONS(11947),
    [sym_comment] = ACTIONS(87),
  },
  [11600] = {
    [aux_sym_exceptions_repeat1] = STATE(11600),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15284),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_RBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11601] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(939),
    [anon_sym_AMP_AMP] = ACTIONS(939),
    [anon_sym_LT_LT] = ACTIONS(939),
    [anon_sym_GT_GT] = ACTIONS(939),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(939),
    [anon_sym_PLUS] = ACTIONS(939),
    [anon_sym_SLASH] = ACTIONS(939),
    [anon_sym_PERCENT] = ACTIONS(939),
    [sym_comment] = ACTIONS(87),
  },
  [11602] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2293),
    [anon_sym_AMP_AMP] = ACTIONS(2293),
    [anon_sym_LT_LT] = ACTIONS(2293),
    [anon_sym_GT_GT] = ACTIONS(2293),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2293),
    [anon_sym_PLUS] = ACTIONS(2293),
    [anon_sym_SLASH] = ACTIONS(2293),
    [anon_sym_PERCENT] = ACTIONS(2293),
    [sym_comment] = ACTIONS(87),
  },
  [11603] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11604] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11812),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11812),
    [sym_operator_assignment] = STATE(11812),
    [sym_conditional] = STATE(11812),
    [sym_range] = STATE(11812),
    [sym_binary] = STATE(11812),
    [sym_unary] = STATE(11812),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11605] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11813),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11813),
    [sym_operator_assignment] = STATE(11813),
    [sym_conditional] = STATE(11813),
    [sym_range] = STATE(11813),
    [sym_binary] = STATE(11813),
    [sym_unary] = STATE(11813),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11606] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11814),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11814),
    [sym_operator_assignment] = STATE(11814),
    [sym_conditional] = STATE(11814),
    [sym_range] = STATE(11814),
    [sym_binary] = STATE(11814),
    [sym_unary] = STATE(11814),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11607] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11815),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11815),
    [sym_operator_assignment] = STATE(11815),
    [sym_conditional] = STATE(11815),
    [sym_range] = STATE(11815),
    [sym_binary] = STATE(11815),
    [sym_unary] = STATE(11815),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11608] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11816),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11816),
    [sym_operator_assignment] = STATE(11816),
    [sym_conditional] = STATE(11816),
    [sym_range] = STATE(11816),
    [sym_binary] = STATE(11816),
    [sym_unary] = STATE(11816),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11609] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11817),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11817),
    [sym_operator_assignment] = STATE(11817),
    [sym_conditional] = STATE(11817),
    [sym_range] = STATE(11817),
    [sym_binary] = STATE(11817),
    [sym_unary] = STATE(11817),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11610] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11818),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11818),
    [sym_operator_assignment] = STATE(11818),
    [sym_conditional] = STATE(11818),
    [sym_range] = STATE(11818),
    [sym_binary] = STATE(11818),
    [sym_unary] = STATE(11818),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11611] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11819),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11819),
    [sym_operator_assignment] = STATE(11819),
    [sym_conditional] = STATE(11819),
    [sym_range] = STATE(11819),
    [sym_binary] = STATE(11819),
    [sym_unary] = STATE(11819),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11612] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11820),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11820),
    [sym_operator_assignment] = STATE(11820),
    [sym_conditional] = STATE(11820),
    [sym_range] = STATE(11820),
    [sym_binary] = STATE(11820),
    [sym_unary] = STATE(11820),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11613] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11821),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11821),
    [sym_operator_assignment] = STATE(11821),
    [sym_conditional] = STATE(11821),
    [sym_range] = STATE(11821),
    [sym_binary] = STATE(11821),
    [sym_unary] = STATE(11821),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11614] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11822),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11822),
    [sym_operator_assignment] = STATE(11822),
    [sym_conditional] = STATE(11822),
    [sym_range] = STATE(11822),
    [sym_binary] = STATE(11822),
    [sym_unary] = STATE(11822),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11615] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11823),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11823),
    [sym_operator_assignment] = STATE(11823),
    [sym_conditional] = STATE(11823),
    [sym_range] = STATE(11823),
    [sym_binary] = STATE(11823),
    [sym_unary] = STATE(11823),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11616] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11824),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_splat_argument] = STATE(11825),
    [sym_assignment] = STATE(11824),
    [sym_operator_assignment] = STATE(11824),
    [sym_conditional] = STATE(11824),
    [sym_range] = STATE(11824),
    [sym_binary] = STATE(11824),
    [sym_unary] = STATE(11824),
    [sym_right_assignment_list] = STATE(4439),
    [sym__arg_or_splat_arg] = STATE(11825),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11617] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11826),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11826),
    [sym_operator_assignment] = STATE(11826),
    [sym_conditional] = STATE(11826),
    [sym_range] = STATE(11826),
    [sym_binary] = STATE(11826),
    [sym_unary] = STATE(11826),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11618] = {
    [sym_string] = STATE(11827),
    [aux_sym_chained_string_repeat1] = STATE(11827),
    [sym__string_start2] = ACTIONS(579),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2807),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_LT_LT] = ACTIONS(2807),
    [anon_sym_GT_GT] = ACTIONS(2807),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2807),
    [anon_sym_SLASH] = ACTIONS(2807),
    [anon_sym_PERCENT] = ACTIONS(2807),
    [sym_comment] = ACTIONS(87),
  },
  [11619] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11620] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11621] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11622] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11828),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11828),
    [sym_operator_assignment] = STATE(11828),
    [sym_conditional] = STATE(11828),
    [sym_range] = STATE(11828),
    [sym_binary] = STATE(11828),
    [sym_unary] = STATE(11828),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11623] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11624] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11829),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11829),
    [sym_operator_assignment] = STATE(11829),
    [sym_conditional] = STATE(11829),
    [sym_range] = STATE(11829),
    [sym_binary] = STATE(11829),
    [sym_unary] = STATE(11829),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11625] = {
    [sym_heredoc_body] = STATE(11830),
    [aux_sym_call_repeat1] = STATE(11830),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11626] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym__argument] = STATE(4434),
    [sym_splat_argument] = STATE(4434),
    [sym_hash_splat_argument] = STATE(4434),
    [sym_block_argument] = STATE(4434),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_heredoc_body] = STATE(11831),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(4434),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15287),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11627] = {
    [sym_heredoc_body] = STATE(11832),
    [aux_sym_call_repeat1] = STATE(11832),
    [aux_sym_argument_list_repeat1] = STATE(11833),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(15101),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11628] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11629] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11630] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11631] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11632] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11633] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11634] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11635] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15289),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11636] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11637] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11638] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11639] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11640] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11641] = {
    [sym__heredoc_body_start2] = ACTIONS(4164),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(4164),
    [anon_sym_DOT] = ACTIONS(4170),
    [anon_sym_COMMA] = ACTIONS(4164),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(4164),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(4170),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(4164),
    [anon_sym_EQ_GT] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4164),
    [anon_sym_COLON_COLON2] = ACTIONS(4164),
    [anon_sym_AMP_DOT] = ACTIONS(4164),
    [anon_sym_PLUS_EQ] = ACTIONS(4164),
    [anon_sym_DASH_EQ] = ACTIONS(4164),
    [anon_sym_STAR_EQ] = ACTIONS(4164),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4164),
    [anon_sym_SLASH_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_PIPE_EQ] = ACTIONS(4164),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4164),
    [anon_sym_AMP_EQ] = ACTIONS(4164),
    [anon_sym_PERCENT_EQ] = ACTIONS(4164),
    [anon_sym_GT_GT_EQ] = ACTIONS(4164),
    [anon_sym_LT_LT_EQ] = ACTIONS(4164),
    [anon_sym_CARET_EQ] = ACTIONS(4164),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(4164),
    [anon_sym_or] = ACTIONS(4164),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11642] = {
    [sym__heredoc_body_start2] = ACTIONS(4204),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(4204),
    [anon_sym_DOT] = ACTIONS(4206),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(4206),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(4204),
    [anon_sym_EQ_GT] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4204),
    [anon_sym_COLON_COLON2] = ACTIONS(4204),
    [anon_sym_AMP_DOT] = ACTIONS(4204),
    [anon_sym_PLUS_EQ] = ACTIONS(4204),
    [anon_sym_DASH_EQ] = ACTIONS(4204),
    [anon_sym_STAR_EQ] = ACTIONS(4204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4204),
    [anon_sym_SLASH_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_PIPE_EQ] = ACTIONS(4204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4204),
    [anon_sym_AMP_EQ] = ACTIONS(4204),
    [anon_sym_PERCENT_EQ] = ACTIONS(4204),
    [anon_sym_GT_GT_EQ] = ACTIONS(4204),
    [anon_sym_LT_LT_EQ] = ACTIONS(4204),
    [anon_sym_CARET_EQ] = ACTIONS(4204),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11643] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11835),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11835),
    [sym_operator_assignment] = STATE(11835),
    [sym_conditional] = STATE(11835),
    [sym_range] = STATE(11835),
    [sym_binary] = STATE(11835),
    [sym_unary] = STATE(11835),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11644] = {
    [sym__heredoc_body_start2] = ACTIONS(3204),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(3204),
    [anon_sym_DOT] = ACTIONS(4208),
    [anon_sym_COMMA] = ACTIONS(3204),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(3204),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(4208),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(3204),
    [anon_sym_EQ_GT] = ACTIONS(3204),
    [anon_sym_LBRACK] = ACTIONS(3204),
    [anon_sym_COLON_COLON2] = ACTIONS(3204),
    [anon_sym_AMP_DOT] = ACTIONS(3204),
    [anon_sym_PLUS_EQ] = ACTIONS(3204),
    [anon_sym_DASH_EQ] = ACTIONS(3204),
    [anon_sym_STAR_EQ] = ACTIONS(3204),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3204),
    [anon_sym_SLASH_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_PIPE_EQ] = ACTIONS(3204),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(3204),
    [anon_sym_AMP_EQ] = ACTIONS(3204),
    [anon_sym_PERCENT_EQ] = ACTIONS(3204),
    [anon_sym_GT_GT_EQ] = ACTIONS(3204),
    [anon_sym_LT_LT_EQ] = ACTIONS(3204),
    [anon_sym_CARET_EQ] = ACTIONS(3204),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(3204),
    [anon_sym_or] = ACTIONS(3204),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11645] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11836),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11836),
    [sym_operator_assignment] = STATE(11836),
    [sym_conditional] = STATE(11836),
    [sym_range] = STATE(11836),
    [sym_binary] = STATE(11836),
    [sym_unary] = STATE(11836),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11646] = {
    [sym_heredoc_body] = STATE(11837),
    [aux_sym_call_repeat1] = STATE(11837),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11647] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym__argument] = STATE(4546),
    [sym_splat_argument] = STATE(4546),
    [sym_hash_splat_argument] = STATE(4546),
    [sym_block_argument] = STATE(4546),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_heredoc_body] = STATE(11838),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(4546),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym__heredoc_body_start2] = ACTIONS(4350),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11648] = {
    [sym_heredoc_body] = STATE(11839),
    [aux_sym_call_repeat1] = STATE(11839),
    [aux_sym_argument_list_repeat1] = STATE(11840),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_LBRACE] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(15109),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4348),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_EQ] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_do] = ACTIONS(4346),
    [anon_sym_EQ_GT] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_PLUS_EQ] = ACTIONS(4346),
    [anon_sym_DASH_EQ] = ACTIONS(4346),
    [anon_sym_STAR_EQ] = ACTIONS(4346),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(4346),
    [anon_sym_SLASH_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_PIPE_EQ] = ACTIONS(4346),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(4346),
    [anon_sym_AMP_EQ] = ACTIONS(4346),
    [anon_sym_PERCENT_EQ] = ACTIONS(4346),
    [anon_sym_GT_GT_EQ] = ACTIONS(4346),
    [anon_sym_LT_LT_EQ] = ACTIONS(4346),
    [anon_sym_CARET_EQ] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4348),
    [anon_sym_AMP_AMP] = ACTIONS(4348),
    [anon_sym_LT_LT] = ACTIONS(4348),
    [anon_sym_GT_GT] = ACTIONS(4348),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4348),
    [anon_sym_PLUS] = ACTIONS(4348),
    [anon_sym_SLASH] = ACTIONS(4348),
    [anon_sym_PERCENT] = ACTIONS(4348),
    [sym_comment] = ACTIONS(87),
  },
  [11649] = {
    [sym_heredoc_body] = STATE(11649),
    [aux_sym_call_repeat1] = STATE(11649),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11650] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(10436),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(10436),
    [sym_operator_assignment] = STATE(10436),
    [sym_conditional] = STATE(10436),
    [sym_range] = STATE(10436),
    [sym_binary] = STATE(10436),
    [sym_unary] = STATE(10436),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(10442),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(13611),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__identifier_hash_key2] = ACTIONS(13617),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15113),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13635),
    [sym_identifier] = ACTIONS(13635),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11651] = {
    [sym_heredoc_body] = STATE(11649),
    [aux_sym_call_repeat1] = STATE(11649),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11652] = {
    [aux_sym_argument_list_repeat1] = STATE(11652),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15293),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11653] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11654] = {
    [aux_sym_exceptions_repeat1] = STATE(11842),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11655] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11656] = {
    [sym_string] = STATE(11656),
    [aux_sym_chained_string_repeat1] = STATE(11656),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11657] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11843),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_assignment] = STATE(11843),
    [sym_operator_assignment] = STATE(11843),
    [sym_conditional] = STATE(11843),
    [sym_range] = STATE(11843),
    [sym_binary] = STATE(11843),
    [sym_unary] = STATE(11843),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11658] = {
    [sym__heredoc_body_start2] = ACTIONS(939),
    [sym__binary_minus2] = ACTIONS(939),
    [sym__binary_star2] = ACTIONS(939),
    [anon_sym_LBRACE] = ACTIONS(939),
    [anon_sym_DOT] = ACTIONS(941),
    [anon_sym_COMMA] = ACTIONS(939),
    [anon_sym_PIPE] = ACTIONS(941),
    [anon_sym_SEMI] = ACTIONS(939),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(941),
    [anon_sym_EQ] = ACTIONS(941),
    [anon_sym_LT] = ACTIONS(941),
    [anon_sym_do] = ACTIONS(939),
    [anon_sym_LBRACK] = ACTIONS(939),
    [anon_sym_COLON_COLON2] = ACTIONS(939),
    [anon_sym_AMP_DOT] = ACTIONS(939),
    [anon_sym_PLUS_EQ] = ACTIONS(939),
    [anon_sym_DASH_EQ] = ACTIONS(939),
    [anon_sym_STAR_EQ] = ACTIONS(939),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(939),
    [anon_sym_SLASH_EQ] = ACTIONS(939),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(939),
    [anon_sym_PIPE_EQ] = ACTIONS(939),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(939),
    [anon_sym_AMP_EQ] = ACTIONS(939),
    [anon_sym_PERCENT_EQ] = ACTIONS(939),
    [anon_sym_GT_GT_EQ] = ACTIONS(939),
    [anon_sym_LT_LT_EQ] = ACTIONS(939),
    [anon_sym_CARET_EQ] = ACTIONS(939),
    [anon_sym_QMARK] = ACTIONS(939),
    [anon_sym_DOT_DOT] = ACTIONS(941),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(939),
    [anon_sym_and] = ACTIONS(939),
    [anon_sym_or] = ACTIONS(939),
    [anon_sym_PIPE_PIPE] = ACTIONS(941),
    [anon_sym_AMP_AMP] = ACTIONS(941),
    [anon_sym_LT_LT] = ACTIONS(941),
    [anon_sym_GT_GT] = ACTIONS(941),
    [anon_sym_EQ_EQ] = ACTIONS(941),
    [anon_sym_BANG_EQ] = ACTIONS(939),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(939),
    [anon_sym_LT_EQ_GT] = ACTIONS(939),
    [anon_sym_EQ_TILDE] = ACTIONS(939),
    [anon_sym_BANG_TILDE] = ACTIONS(939),
    [anon_sym_LT_EQ] = ACTIONS(941),
    [anon_sym_GT] = ACTIONS(941),
    [anon_sym_GT_EQ] = ACTIONS(939),
    [anon_sym_CARET] = ACTIONS(941),
    [anon_sym_PLUS] = ACTIONS(941),
    [anon_sym_SLASH] = ACTIONS(941),
    [anon_sym_PERCENT] = ACTIONS(941),
    [sym_comment] = ACTIONS(87),
  },
  [11659] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(2293),
    [sym__binary_star2] = ACTIONS(2293),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(2295),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(2295),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(2295),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(2293),
    [anon_sym_DOT_DOT] = ACTIONS(2295),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2293),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(2295),
    [anon_sym_AMP_AMP] = ACTIONS(2295),
    [anon_sym_LT_LT] = ACTIONS(2295),
    [anon_sym_GT_GT] = ACTIONS(2295),
    [anon_sym_EQ_EQ] = ACTIONS(2295),
    [anon_sym_BANG_EQ] = ACTIONS(2293),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2293),
    [anon_sym_LT_EQ_GT] = ACTIONS(2293),
    [anon_sym_EQ_TILDE] = ACTIONS(2293),
    [anon_sym_BANG_TILDE] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2295),
    [anon_sym_GT] = ACTIONS(2295),
    [anon_sym_GT_EQ] = ACTIONS(2293),
    [anon_sym_CARET] = ACTIONS(2295),
    [anon_sym_PLUS] = ACTIONS(2295),
    [anon_sym_SLASH] = ACTIONS(2295),
    [anon_sym_PERCENT] = ACTIONS(2295),
    [sym_comment] = ACTIONS(87),
  },
  [11660] = {
    [sym__heredoc_body_start2] = ACTIONS(2293),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(2293),
    [anon_sym_DOT] = ACTIONS(2295),
    [anon_sym_COMMA] = ACTIONS(2293),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(2293),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(2295),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(2293),
    [anon_sym_LBRACK] = ACTIONS(2293),
    [anon_sym_COLON_COLON2] = ACTIONS(2293),
    [anon_sym_AMP_DOT] = ACTIONS(2293),
    [anon_sym_PLUS_EQ] = ACTIONS(2293),
    [anon_sym_DASH_EQ] = ACTIONS(2293),
    [anon_sym_STAR_EQ] = ACTIONS(2293),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2293),
    [anon_sym_SLASH_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_PIPE_EQ] = ACTIONS(2293),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2293),
    [anon_sym_AMP_EQ] = ACTIONS(2293),
    [anon_sym_PERCENT_EQ] = ACTIONS(2293),
    [anon_sym_GT_GT_EQ] = ACTIONS(2293),
    [anon_sym_LT_LT_EQ] = ACTIONS(2293),
    [anon_sym_CARET_EQ] = ACTIONS(2293),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(2293),
    [anon_sym_or] = ACTIONS(2293),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11661] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11844),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11844),
    [sym_operator_assignment] = STATE(11844),
    [sym_conditional] = STATE(11844),
    [sym_range] = STATE(11844),
    [sym_binary] = STATE(11844),
    [sym_unary] = STATE(11844),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11662] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11845),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11845),
    [sym_operator_assignment] = STATE(11845),
    [sym_conditional] = STATE(11845),
    [sym_range] = STATE(11845),
    [sym_binary] = STATE(11845),
    [sym_unary] = STATE(11845),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11663] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11846),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11846),
    [sym_operator_assignment] = STATE(11846),
    [sym_conditional] = STATE(11846),
    [sym_range] = STATE(11846),
    [sym_binary] = STATE(11846),
    [sym_unary] = STATE(11846),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11664] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11847),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11847),
    [sym_operator_assignment] = STATE(11847),
    [sym_conditional] = STATE(11847),
    [sym_range] = STATE(11847),
    [sym_binary] = STATE(11847),
    [sym_unary] = STATE(11847),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11665] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11848),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11848),
    [sym_operator_assignment] = STATE(11848),
    [sym_conditional] = STATE(11848),
    [sym_range] = STATE(11848),
    [sym_binary] = STATE(11848),
    [sym_unary] = STATE(11848),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11666] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11849),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11849),
    [sym_operator_assignment] = STATE(11849),
    [sym_conditional] = STATE(11849),
    [sym_range] = STATE(11849),
    [sym_binary] = STATE(11849),
    [sym_unary] = STATE(11849),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11667] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11850),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(1501),
    [sym_scope_resolution] = STATE(1499),
    [sym_call] = STATE(1499),
    [sym_method_call] = STATE(1501),
    [sym_assignment] = STATE(11850),
    [sym_operator_assignment] = STATE(11850),
    [sym_conditional] = STATE(11850),
    [sym_range] = STATE(11850),
    [sym_binary] = STATE(11850),
    [sym_unary] = STATE(11850),
    [sym_left_assignment_list] = STATE(1500),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(1501),
    [sym__variable] = STATE(1499),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(1501),
    [sym_false] = STATE(1501),
    [sym_nil] = STATE(1501),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(1502),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(2549),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__unary_minus2] = ACTIONS(2551),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(2553),
    [anon_sym_yield] = ACTIONS(2555),
    [anon_sym_break] = ACTIONS(2557),
    [anon_sym_next] = ACTIONS(2559),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(2561),
    [anon_sym_defined_QMARK] = ACTIONS(2563),
    [anon_sym_not] = ACTIONS(2565),
    [anon_sym_BANG] = ACTIONS(2567),
    [anon_sym_TILDE] = ACTIONS(2567),
    [sym_constant] = ACTIONS(2569),
    [sym_identifier] = ACTIONS(2569),
    [sym_instance_variable] = ACTIONS(2571),
    [sym_class_variable] = ACTIONS(2571),
    [sym_global_variable] = ACTIONS(2571),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(2569),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(2569),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11668] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11851),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11851),
    [sym_operator_assignment] = STATE(11851),
    [sym_conditional] = STATE(11851),
    [sym_range] = STATE(11851),
    [sym_binary] = STATE(11851),
    [sym_unary] = STATE(11851),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11669] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11852),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11852),
    [sym_operator_assignment] = STATE(11852),
    [sym_conditional] = STATE(11852),
    [sym_range] = STATE(11852),
    [sym_binary] = STATE(11852),
    [sym_unary] = STATE(11852),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11670] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11853),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11853),
    [sym_operator_assignment] = STATE(11853),
    [sym_conditional] = STATE(11853),
    [sym_range] = STATE(11853),
    [sym_binary] = STATE(11853),
    [sym_unary] = STATE(11853),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11671] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11854),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11854),
    [sym_operator_assignment] = STATE(11854),
    [sym_conditional] = STATE(11854),
    [sym_range] = STATE(11854),
    [sym_binary] = STATE(11854),
    [sym_unary] = STATE(11854),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11672] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11855),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11855),
    [sym_operator_assignment] = STATE(11855),
    [sym_conditional] = STATE(11855),
    [sym_range] = STATE(11855),
    [sym_binary] = STATE(11855),
    [sym_unary] = STATE(11855),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11673] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11856),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_splat_argument] = STATE(11857),
    [sym_assignment] = STATE(11856),
    [sym_operator_assignment] = STATE(11856),
    [sym_conditional] = STATE(11856),
    [sym_range] = STATE(11856),
    [sym_binary] = STATE(11856),
    [sym_unary] = STATE(11856),
    [sym_right_assignment_list] = STATE(9275),
    [sym__arg_or_splat_arg] = STATE(11857),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11674] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11858),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11858),
    [sym_operator_assignment] = STATE(11858),
    [sym_conditional] = STATE(11858),
    [sym_range] = STATE(11858),
    [sym_binary] = STATE(11858),
    [sym_unary] = STATE(11858),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11675] = {
    [sym_string] = STATE(11859),
    [aux_sym_chained_string_repeat1] = STATE(11859),
    [sym__string_start2] = ACTIONS(6369),
    [sym__heredoc_body_start2] = ACTIONS(2807),
    [sym__binary_minus2] = ACTIONS(2807),
    [sym__binary_star2] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2807),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_STAR_STAR] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_do] = ACTIONS(2807),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON_COLON2] = ACTIONS(2807),
    [anon_sym_AMP_DOT] = ACTIONS(2807),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_QMARK] = ACTIONS(2807),
    [anon_sym_DOT_DOT] = ACTIONS(2809),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(2807),
    [anon_sym_and] = ACTIONS(2807),
    [anon_sym_or] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2809),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ_GT] = ACTIONS(2807),
    [anon_sym_EQ_TILDE] = ACTIONS(2807),
    [anon_sym_BANG_TILDE] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [sym_comment] = ACTIONS(87),
  },
  [11676] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11677] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_EQ_GT] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11678] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_EQ_GT] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [11679] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11680] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [11681] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11682] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11683] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11684] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15296),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11685] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_EQ_GT] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11686] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11687] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11688] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11689] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_EQ_GT] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11690] = {
    [sym_heredoc_body] = STATE(11690),
    [aux_sym_call_repeat1] = STATE(11690),
    [sym__heredoc_body_start2] = ACTIONS(12491),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [11691] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(10470),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym__argument] = STATE(9286),
    [sym_splat_argument] = STATE(9286),
    [sym_hash_splat_argument] = STATE(9286),
    [sym_block_argument] = STATE(9286),
    [sym_assignment] = STATE(10470),
    [sym_operator_assignment] = STATE(10470),
    [sym_conditional] = STATE(10470),
    [sym_range] = STATE(10470),
    [sym_binary] = STATE(10470),
    [sym_unary] = STATE(10470),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(10476),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(9286),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(13673),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__identifier_hash_key2] = ACTIONS(13679),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15151),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13697),
    [sym_identifier] = ACTIONS(13697),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11692] = {
    [sym_heredoc_body] = STATE(11690),
    [aux_sym_call_repeat1] = STATE(11690),
    [sym__heredoc_body_start2] = ACTIONS(6485),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [11693] = {
    [aux_sym_argument_list_repeat1] = STATE(11693),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15298),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [11694] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_EQ_GT] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11695] = {
    [aux_sym_exceptions_repeat1] = STATE(11862),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_EQ_GT] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [11696] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_EQ_GT] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11697] = {
    [sym_string] = STATE(11697),
    [aux_sym_chained_string_repeat1] = STATE(11697),
    [sym__string_start2] = ACTIONS(10506),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_EQ_GT] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [11698] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(4204),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(4204),
    [anon_sym_or] = ACTIONS(4204),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11699] = {
    [sym_method] = STATE(470),
    [sym_singleton_method] = STATE(470),
    [sym_class] = STATE(470),
    [sym_singleton_class] = STATE(470),
    [sym_module] = STATE(470),
    [sym_return] = STATE(470),
    [sym_yield] = STATE(470),
    [sym_break] = STATE(470),
    [sym_next] = STATE(470),
    [sym_while] = STATE(470),
    [sym_until] = STATE(470),
    [sym_for] = STATE(470),
    [sym_case] = STATE(470),
    [sym_if] = STATE(470),
    [sym_unless] = STATE(470),
    [sym_begin] = STATE(470),
    [sym__arg] = STATE(11321),
    [sym__primary] = STATE(470),
    [sym_parenthesized_statements] = STATE(470),
    [sym_element_reference] = STATE(8922),
    [sym_scope_resolution] = STATE(8920),
    [sym_call] = STATE(8920),
    [sym_method_call] = STATE(8922),
    [sym_splat_argument] = STATE(7313),
    [sym_assignment] = STATE(11321),
    [sym_operator_assignment] = STATE(11321),
    [sym_conditional] = STATE(11321),
    [sym_range] = STATE(11321),
    [sym_binary] = STATE(11321),
    [sym_unary] = STATE(11321),
    [sym__arg_or_splat_arg] = STATE(7313),
    [sym_left_assignment_list] = STATE(8921),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(8922),
    [sym__variable] = STATE(8920),
    [sym_rational] = STATE(470),
    [sym_true] = STATE(8922),
    [sym_false] = STATE(8922),
    [sym_nil] = STATE(8922),
    [sym_chained_string] = STATE(470),
    [sym_string] = STATE(8923),
    [sym_subshell] = STATE(470),
    [sym_string_array] = STATE(470),
    [sym_symbol_array] = STATE(470),
    [sym_symbol] = STATE(470),
    [sym_regex] = STATE(470),
    [sym_array] = STATE(470),
    [sym_hash] = STATE(470),
    [sym_lambda] = STATE(470),
    [sym__simple_symbol2] = ACTIONS(137),
    [sym__string_start2] = ACTIONS(139),
    [sym__symbol_start2] = ACTIONS(141),
    [sym__subshell_start2] = ACTIONS(143),
    [sym__regex_start2] = ACTIONS(145),
    [sym__string_array_start2] = ACTIONS(147),
    [sym__symbol_array_start2] = ACTIONS(149),
    [sym_heredoc_beginning2] = ACTIONS(845),
    [sym__splat_star2] = ACTIONS(14618),
    [sym__unary_minus2] = ACTIONS(12045),
    [anon_sym_LBRACE] = ACTIONS(159),
    [anon_sym_def] = ACTIONS(163),
    [anon_sym_LPAREN] = ACTIONS(165),
    [anon_sym_COLON_COLON] = ACTIONS(849),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(173),
    [anon_sym_module] = ACTIONS(175),
    [anon_sym_return] = ACTIONS(12047),
    [anon_sym_yield] = ACTIONS(12049),
    [anon_sym_break] = ACTIONS(12051),
    [anon_sym_next] = ACTIONS(12053),
    [sym_redo] = ACTIONS(861),
    [sym_retry] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(187),
    [anon_sym_unless] = ACTIONS(189),
    [anon_sym_while] = ACTIONS(191),
    [anon_sym_until] = ACTIONS(193),
    [anon_sym_for] = ACTIONS(195),
    [anon_sym_case] = ACTIONS(197),
    [anon_sym_begin] = ACTIONS(199),
    [anon_sym_PLUS] = ACTIONS(12055),
    [anon_sym_defined_QMARK] = ACTIONS(12057),
    [anon_sym_not] = ACTIONS(12059),
    [anon_sym_BANG] = ACTIONS(12061),
    [anon_sym_TILDE] = ACTIONS(12061),
    [sym_constant] = ACTIONS(12063),
    [sym_identifier] = ACTIONS(12063),
    [sym_instance_variable] = ACTIONS(12065),
    [sym_class_variable] = ACTIONS(12065),
    [sym_global_variable] = ACTIONS(12065),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(213),
    [sym_float] = ACTIONS(861),
    [sym_complex] = ACTIONS(845),
    [sym_super] = ACTIONS(12063),
    [anon_sym_true] = ACTIONS(879),
    [anon_sym_TRUE] = ACTIONS(879),
    [anon_sym_false] = ACTIONS(881),
    [anon_sym_FALSE] = ACTIONS(881),
    [sym_self] = ACTIONS(12063),
    [anon_sym_nil] = ACTIONS(883),
    [anon_sym_NIL] = ACTIONS(883),
    [sym_character] = ACTIONS(845),
    [anon_sym_LBRACK2] = ACTIONS(223),
    [anon_sym_DASH_GT] = ACTIONS(225),
  },
  [11700] = {
    [aux_sym_exceptions_repeat1] = STATE(11863),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_COMMA] = ACTIONS(15301),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11701] = {
    [sym__simple_symbol2] = ACTIONS(15303),
    [sym__string_start2] = ACTIONS(15303),
    [sym__symbol_start2] = ACTIONS(15303),
    [sym__subshell_start2] = ACTIONS(15303),
    [sym__regex_start2] = ACTIONS(15303),
    [sym__string_array_start2] = ACTIONS(15303),
    [sym__symbol_array_start2] = ACTIONS(15303),
    [sym_heredoc_beginning2] = ACTIONS(15303),
    [sym__unary_minus2] = ACTIONS(15303),
    [anon_sym_BEGIN] = ACTIONS(15305),
    [anon_sym_LBRACE] = ACTIONS(15303),
    [anon_sym_RBRACE] = ACTIONS(15303),
    [anon_sym_END] = ACTIONS(15305),
    [anon_sym_def] = ACTIONS(15305),
    [anon_sym_LPAREN] = ACTIONS(15303),
    [anon_sym_COLON_COLON] = ACTIONS(15303),
    [anon_sym_SEMI] = ACTIONS(15303),
    [anon_sym_STAR] = ACTIONS(15303),
    [anon_sym_class] = ACTIONS(15305),
    [anon_sym_module] = ACTIONS(15305),
    [anon_sym_return] = ACTIONS(15305),
    [anon_sym_yield] = ACTIONS(15305),
    [anon_sym_break] = ACTIONS(15305),
    [anon_sym_next] = ACTIONS(15305),
    [sym_redo] = ACTIONS(15305),
    [sym_retry] = ACTIONS(15305),
    [anon_sym_if] = ACTIONS(15305),
    [anon_sym_unless] = ACTIONS(15305),
    [anon_sym_while] = ACTIONS(15305),
    [anon_sym_until] = ACTIONS(15305),
    [anon_sym_for] = ACTIONS(15305),
    [anon_sym_case] = ACTIONS(15305),
    [anon_sym_begin] = ACTIONS(15305),
    [anon_sym_PLUS] = ACTIONS(15305),
    [anon_sym_defined_QMARK] = ACTIONS(15303),
    [anon_sym_not] = ACTIONS(15305),
    [anon_sym_BANG] = ACTIONS(15303),
    [anon_sym_TILDE] = ACTIONS(15303),
    [sym_constant] = ACTIONS(15305),
    [sym_identifier] = ACTIONS(15305),
    [sym_instance_variable] = ACTIONS(15303),
    [sym_class_variable] = ACTIONS(15303),
    [sym_global_variable] = ACTIONS(15303),
    [anon_sym_undef] = ACTIONS(15305),
    [anon_sym_alias] = ACTIONS(15305),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15305),
    [sym_float] = ACTIONS(15305),
    [sym_complex] = ACTIONS(15303),
    [sym_super] = ACTIONS(15305),
    [anon_sym_true] = ACTIONS(15305),
    [anon_sym_TRUE] = ACTIONS(15305),
    [anon_sym_false] = ACTIONS(15305),
    [anon_sym_FALSE] = ACTIONS(15305),
    [sym_self] = ACTIONS(15305),
    [anon_sym_nil] = ACTIONS(15305),
    [anon_sym_NIL] = ACTIONS(15305),
    [sym_character] = ACTIONS(15303),
    [anon_sym_LBRACK2] = ACTIONS(15303),
    [anon_sym_DASH_GT] = ACTIONS(15303),
  },
  [11702] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15307),
    [sym_comment] = ACTIONS(87),
  },
  [11703] = {
    [sym__line_break2] = ACTIONS(15303),
    [sym__simple_symbol2] = ACTIONS(15303),
    [sym__string_start2] = ACTIONS(15303),
    [sym__symbol_start2] = ACTIONS(15303),
    [sym__subshell_start2] = ACTIONS(15303),
    [sym__regex_start2] = ACTIONS(15303),
    [sym__string_array_start2] = ACTIONS(15303),
    [sym__symbol_array_start2] = ACTIONS(15303),
    [sym__heredoc_body_start2] = ACTIONS(15303),
    [sym_heredoc_beginning2] = ACTIONS(15303),
    [sym__unary_minus2] = ACTIONS(15303),
    [anon_sym_BEGIN] = ACTIONS(15305),
    [anon_sym_LBRACE] = ACTIONS(15303),
    [anon_sym_END] = ACTIONS(15305),
    [anon_sym_def] = ACTIONS(15305),
    [anon_sym_LPAREN] = ACTIONS(15303),
    [anon_sym_COLON_COLON] = ACTIONS(15303),
    [anon_sym_SEMI] = ACTIONS(15303),
    [anon_sym_STAR] = ACTIONS(15303),
    [anon_sym_class] = ACTIONS(15305),
    [anon_sym_module] = ACTIONS(15305),
    [anon_sym_end] = ACTIONS(15305),
    [anon_sym_return] = ACTIONS(15305),
    [anon_sym_yield] = ACTIONS(15305),
    [anon_sym_break] = ACTIONS(15305),
    [anon_sym_next] = ACTIONS(15305),
    [sym_redo] = ACTIONS(15305),
    [sym_retry] = ACTIONS(15305),
    [anon_sym_if] = ACTIONS(15305),
    [anon_sym_unless] = ACTIONS(15305),
    [anon_sym_while] = ACTIONS(15305),
    [anon_sym_until] = ACTIONS(15305),
    [anon_sym_for] = ACTIONS(15305),
    [anon_sym_case] = ACTIONS(15305),
    [anon_sym_begin] = ACTIONS(15305),
    [anon_sym_PLUS] = ACTIONS(15305),
    [anon_sym_defined_QMARK] = ACTIONS(15303),
    [anon_sym_not] = ACTIONS(15305),
    [anon_sym_BANG] = ACTIONS(15303),
    [anon_sym_TILDE] = ACTIONS(15303),
    [sym_constant] = ACTIONS(15305),
    [sym_identifier] = ACTIONS(15305),
    [sym_instance_variable] = ACTIONS(15303),
    [sym_class_variable] = ACTIONS(15303),
    [sym_global_variable] = ACTIONS(15303),
    [anon_sym_undef] = ACTIONS(15305),
    [anon_sym_alias] = ACTIONS(15305),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15305),
    [sym_float] = ACTIONS(15305),
    [sym_complex] = ACTIONS(15303),
    [sym_super] = ACTIONS(15305),
    [anon_sym_true] = ACTIONS(15305),
    [anon_sym_TRUE] = ACTIONS(15305),
    [anon_sym_false] = ACTIONS(15305),
    [anon_sym_FALSE] = ACTIONS(15305),
    [sym_self] = ACTIONS(15305),
    [anon_sym_nil] = ACTIONS(15305),
    [anon_sym_NIL] = ACTIONS(15305),
    [sym_character] = ACTIONS(15303),
    [anon_sym_LBRACK2] = ACTIONS(15303),
    [anon_sym_DASH_GT] = ACTIONS(15303),
  },
  [11704] = {
    [aux_sym_block_parameters_repeat1] = STATE(10421),
    [anon_sym_COMMA] = ACTIONS(12041),
    [anon_sym_PIPE] = ACTIONS(15309),
    [sym_comment] = ACTIONS(87),
  },
  [11705] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12108),
    [sym__binary_star2] = ACTIONS(12110),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12112),
    [anon_sym_STAR_STAR] = ACTIONS(12114),
    [anon_sym_AMP] = ACTIONS(12116),
    [anon_sym_LT] = ACTIONS(12118),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12120),
    [anon_sym_COLON2] = ACTIONS(12839),
    [anon_sym_DOT_DOT] = ACTIONS(12122),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12124),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12126),
    [anon_sym_AMP_AMP] = ACTIONS(12126),
    [anon_sym_LT_LT] = ACTIONS(12128),
    [anon_sym_GT_GT] = ACTIONS(12128),
    [anon_sym_EQ_EQ] = ACTIONS(12130),
    [anon_sym_BANG_EQ] = ACTIONS(12126),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12126),
    [anon_sym_LT_EQ_GT] = ACTIONS(12126),
    [anon_sym_EQ_TILDE] = ACTIONS(12126),
    [anon_sym_BANG_TILDE] = ACTIONS(12126),
    [anon_sym_LT_EQ] = ACTIONS(12118),
    [anon_sym_GT] = ACTIONS(12118),
    [anon_sym_GT_EQ] = ACTIONS(12132),
    [anon_sym_CARET] = ACTIONS(12134),
    [anon_sym_PLUS] = ACTIONS(12136),
    [anon_sym_SLASH] = ACTIONS(12114),
    [anon_sym_PERCENT] = ACTIONS(12114),
    [sym_comment] = ACTIONS(87),
  },
  [11706] = {
    [aux_sym_exceptions_repeat1] = STATE(11706),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15311),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11707] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12168),
    [sym__binary_star2] = ACTIONS(12170),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12172),
    [anon_sym_STAR_STAR] = ACTIONS(12174),
    [anon_sym_AMP] = ACTIONS(12176),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(12178),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12180),
    [anon_sym_COLON2] = ACTIONS(12839),
    [anon_sym_DOT_DOT] = ACTIONS(12182),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12184),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12186),
    [anon_sym_AMP_AMP] = ACTIONS(12186),
    [anon_sym_LT_LT] = ACTIONS(12188),
    [anon_sym_GT_GT] = ACTIONS(12188),
    [anon_sym_EQ_EQ] = ACTIONS(12186),
    [anon_sym_BANG_EQ] = ACTIONS(12190),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12190),
    [anon_sym_LT_EQ_GT] = ACTIONS(12190),
    [anon_sym_EQ_TILDE] = ACTIONS(12190),
    [anon_sym_BANG_TILDE] = ACTIONS(12190),
    [anon_sym_LT_EQ] = ACTIONS(12178),
    [anon_sym_GT] = ACTIONS(12178),
    [anon_sym_GT_EQ] = ACTIONS(12192),
    [anon_sym_CARET] = ACTIONS(12172),
    [anon_sym_PLUS] = ACTIONS(12194),
    [anon_sym_SLASH] = ACTIONS(12174),
    [anon_sym_PERCENT] = ACTIONS(12174),
    [sym_comment] = ACTIONS(87),
  },
  [11708] = {
    [aux_sym_exceptions_repeat1] = STATE(11708),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15314),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_COLON2] = ACTIONS(12400),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11709] = {
    [sym__binary_minus2] = ACTIONS(12206),
    [sym__binary_star2] = ACTIONS(12208),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12210),
    [anon_sym_STAR_STAR] = ACTIONS(12212),
    [anon_sym_AMP] = ACTIONS(12214),
    [anon_sym_LT] = ACTIONS(12216),
    [anon_sym_QMARK] = ACTIONS(12218),
    [anon_sym_COLON2] = ACTIONS(12166),
    [anon_sym_DOT_DOT] = ACTIONS(12220),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12222),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12224),
    [anon_sym_AMP_AMP] = ACTIONS(12224),
    [anon_sym_LT_LT] = ACTIONS(12226),
    [anon_sym_GT_GT] = ACTIONS(12226),
    [anon_sym_EQ_EQ] = ACTIONS(12228),
    [anon_sym_BANG_EQ] = ACTIONS(12224),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12224),
    [anon_sym_LT_EQ_GT] = ACTIONS(12224),
    [anon_sym_EQ_TILDE] = ACTIONS(12224),
    [anon_sym_BANG_TILDE] = ACTIONS(12224),
    [anon_sym_LT_EQ] = ACTIONS(12216),
    [anon_sym_GT] = ACTIONS(12216),
    [anon_sym_GT_EQ] = ACTIONS(12230),
    [anon_sym_CARET] = ACTIONS(12232),
    [anon_sym_PLUS] = ACTIONS(12234),
    [anon_sym_SLASH] = ACTIONS(12212),
    [anon_sym_PERCENT] = ACTIONS(12212),
    [sym_comment] = ACTIONS(87),
  },
  [11710] = {
    [sym__line_break2] = ACTIONS(14122),
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [ts_builtin_sym_end] = ACTIONS(14122),
    [anon_sym___END__] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14124),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_end] = ACTIONS(14122),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_when] = ACTIONS(14122),
    [anon_sym_elsif] = ACTIONS(14122),
    [anon_sym_else] = ACTIONS(14122),
    [anon_sym_then] = ACTIONS(14122),
    [anon_sym_ensure] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_PLUS_EQ] = ACTIONS(14122),
    [anon_sym_DASH_EQ] = ACTIONS(14122),
    [anon_sym_STAR_EQ] = ACTIONS(14122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14122),
    [anon_sym_SLASH_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14122),
    [anon_sym_AMP_EQ] = ACTIONS(14122),
    [anon_sym_PERCENT_EQ] = ACTIONS(14122),
    [anon_sym_GT_GT_EQ] = ACTIONS(14122),
    [anon_sym_LT_LT_EQ] = ACTIONS(14122),
    [anon_sym_CARET_EQ] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14124),
    [anon_sym_AMP_AMP] = ACTIONS(14124),
    [anon_sym_LT_LT] = ACTIONS(14124),
    [anon_sym_GT_GT] = ACTIONS(14124),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14124),
    [anon_sym_PLUS] = ACTIONS(14124),
    [anon_sym_SLASH] = ACTIONS(14124),
    [anon_sym_PERCENT] = ACTIONS(14124),
    [sym_comment] = ACTIONS(87),
  },
  [11711] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12332),
    [sym__binary_star2] = ACTIONS(12334),
    [anon_sym_RBRACE] = ACTIONS(12166),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12336),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12338),
    [anon_sym_AMP] = ACTIONS(12340),
    [anon_sym_LT] = ACTIONS(12342),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12344),
    [anon_sym_DOT_DOT] = ACTIONS(12346),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12348),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12350),
    [anon_sym_AMP_AMP] = ACTIONS(12350),
    [anon_sym_LT_LT] = ACTIONS(12352),
    [anon_sym_GT_GT] = ACTIONS(12352),
    [anon_sym_EQ_EQ] = ACTIONS(12354),
    [anon_sym_BANG_EQ] = ACTIONS(12350),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12350),
    [anon_sym_LT_EQ_GT] = ACTIONS(12350),
    [anon_sym_EQ_TILDE] = ACTIONS(12350),
    [anon_sym_BANG_TILDE] = ACTIONS(12350),
    [anon_sym_LT_EQ] = ACTIONS(12342),
    [anon_sym_GT] = ACTIONS(12342),
    [anon_sym_GT_EQ] = ACTIONS(12356),
    [anon_sym_CARET] = ACTIONS(12358),
    [anon_sym_PLUS] = ACTIONS(12360),
    [anon_sym_SLASH] = ACTIONS(12338),
    [anon_sym_PERCENT] = ACTIONS(12338),
    [sym_comment] = ACTIONS(87),
  },
  [11712] = {
    [sym__heredoc_body_start2] = ACTIONS(12497),
    [sym__binary_minus2] = ACTIONS(12497),
    [sym__binary_star2] = ACTIONS(12497),
    [anon_sym_LBRACE] = ACTIONS(12497),
    [anon_sym_RBRACE] = ACTIONS(12497),
    [anon_sym_RPAREN] = ACTIONS(12497),
    [anon_sym_DOT] = ACTIONS(12499),
    [anon_sym_COMMA] = ACTIONS(12497),
    [anon_sym_PIPE] = ACTIONS(12499),
    [anon_sym_SEMI] = ACTIONS(12497),
    [anon_sym_STAR_STAR] = ACTIONS(12499),
    [anon_sym_AMP] = ACTIONS(12499),
    [anon_sym_EQ] = ACTIONS(12499),
    [anon_sym_LT] = ACTIONS(12499),
    [anon_sym_if] = ACTIONS(12497),
    [anon_sym_unless] = ACTIONS(12497),
    [anon_sym_while] = ACTIONS(12497),
    [anon_sym_until] = ACTIONS(12497),
    [anon_sym_rescue] = ACTIONS(12497),
    [anon_sym_in] = ACTIONS(12497),
    [anon_sym_do] = ACTIONS(12497),
    [anon_sym_LBRACK] = ACTIONS(12497),
    [anon_sym_RBRACK] = ACTIONS(12497),
    [anon_sym_COLON_COLON2] = ACTIONS(12497),
    [anon_sym_AMP_DOT] = ACTIONS(12497),
    [anon_sym_PLUS_EQ] = ACTIONS(12497),
    [anon_sym_DASH_EQ] = ACTIONS(12497),
    [anon_sym_STAR_EQ] = ACTIONS(12497),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12497),
    [anon_sym_SLASH_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_PIPE_EQ] = ACTIONS(12497),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12497),
    [anon_sym_AMP_EQ] = ACTIONS(12497),
    [anon_sym_PERCENT_EQ] = ACTIONS(12497),
    [anon_sym_GT_GT_EQ] = ACTIONS(12497),
    [anon_sym_LT_LT_EQ] = ACTIONS(12497),
    [anon_sym_CARET_EQ] = ACTIONS(12497),
    [anon_sym_QMARK] = ACTIONS(12497),
    [anon_sym_COLON2] = ACTIONS(12499),
    [anon_sym_DOT_DOT] = ACTIONS(12499),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12497),
    [anon_sym_and] = ACTIONS(12497),
    [anon_sym_or] = ACTIONS(12497),
    [anon_sym_PIPE_PIPE] = ACTIONS(12499),
    [anon_sym_AMP_AMP] = ACTIONS(12499),
    [anon_sym_LT_LT] = ACTIONS(12499),
    [anon_sym_GT_GT] = ACTIONS(12499),
    [anon_sym_EQ_EQ] = ACTIONS(12499),
    [anon_sym_BANG_EQ] = ACTIONS(12497),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12497),
    [anon_sym_LT_EQ_GT] = ACTIONS(12497),
    [anon_sym_EQ_TILDE] = ACTIONS(12497),
    [anon_sym_BANG_TILDE] = ACTIONS(12497),
    [anon_sym_LT_EQ] = ACTIONS(12499),
    [anon_sym_GT] = ACTIONS(12499),
    [anon_sym_GT_EQ] = ACTIONS(12497),
    [anon_sym_CARET] = ACTIONS(12499),
    [anon_sym_PLUS] = ACTIONS(12499),
    [anon_sym_SLASH] = ACTIONS(12499),
    [anon_sym_PERCENT] = ACTIONS(12499),
    [sym_comment] = ACTIONS(87),
  },
  [11713] = {
    [sym__heredoc_body_start2] = ACTIONS(12501),
    [sym__binary_minus2] = ACTIONS(12501),
    [sym__binary_star2] = ACTIONS(12501),
    [anon_sym_LBRACE] = ACTIONS(12501),
    [anon_sym_RBRACE] = ACTIONS(12501),
    [anon_sym_RPAREN] = ACTIONS(12501),
    [anon_sym_DOT] = ACTIONS(12503),
    [anon_sym_COMMA] = ACTIONS(12501),
    [anon_sym_PIPE] = ACTIONS(12503),
    [anon_sym_SEMI] = ACTIONS(12501),
    [anon_sym_STAR_STAR] = ACTIONS(12503),
    [anon_sym_AMP] = ACTIONS(12503),
    [anon_sym_EQ] = ACTIONS(12503),
    [anon_sym_LT] = ACTIONS(12503),
    [anon_sym_if] = ACTIONS(12501),
    [anon_sym_unless] = ACTIONS(12501),
    [anon_sym_while] = ACTIONS(12501),
    [anon_sym_until] = ACTIONS(12501),
    [anon_sym_rescue] = ACTIONS(12501),
    [anon_sym_in] = ACTIONS(12501),
    [anon_sym_do] = ACTIONS(12501),
    [anon_sym_LBRACK] = ACTIONS(12501),
    [anon_sym_RBRACK] = ACTIONS(12501),
    [anon_sym_COLON_COLON2] = ACTIONS(12501),
    [anon_sym_AMP_DOT] = ACTIONS(12501),
    [anon_sym_PLUS_EQ] = ACTIONS(12501),
    [anon_sym_DASH_EQ] = ACTIONS(12501),
    [anon_sym_STAR_EQ] = ACTIONS(12501),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12501),
    [anon_sym_SLASH_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_PIPE_EQ] = ACTIONS(12501),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12501),
    [anon_sym_AMP_EQ] = ACTIONS(12501),
    [anon_sym_PERCENT_EQ] = ACTIONS(12501),
    [anon_sym_GT_GT_EQ] = ACTIONS(12501),
    [anon_sym_LT_LT_EQ] = ACTIONS(12501),
    [anon_sym_CARET_EQ] = ACTIONS(12501),
    [anon_sym_QMARK] = ACTIONS(12501),
    [anon_sym_COLON2] = ACTIONS(12503),
    [anon_sym_DOT_DOT] = ACTIONS(12503),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12501),
    [anon_sym_and] = ACTIONS(12501),
    [anon_sym_or] = ACTIONS(12501),
    [anon_sym_PIPE_PIPE] = ACTIONS(12503),
    [anon_sym_AMP_AMP] = ACTIONS(12503),
    [anon_sym_LT_LT] = ACTIONS(12503),
    [anon_sym_GT_GT] = ACTIONS(12503),
    [anon_sym_EQ_EQ] = ACTIONS(12503),
    [anon_sym_BANG_EQ] = ACTIONS(12501),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12501),
    [anon_sym_LT_EQ_GT] = ACTIONS(12501),
    [anon_sym_EQ_TILDE] = ACTIONS(12501),
    [anon_sym_BANG_TILDE] = ACTIONS(12501),
    [anon_sym_LT_EQ] = ACTIONS(12503),
    [anon_sym_GT] = ACTIONS(12503),
    [anon_sym_GT_EQ] = ACTIONS(12501),
    [anon_sym_CARET] = ACTIONS(12503),
    [anon_sym_PLUS] = ACTIONS(12503),
    [anon_sym_SLASH] = ACTIONS(12503),
    [anon_sym_PERCENT] = ACTIONS(12503),
    [sym_comment] = ACTIONS(87),
  },
  [11714] = {
    [sym__heredoc_body_start2] = ACTIONS(12615),
    [sym__binary_minus2] = ACTIONS(12615),
    [sym__binary_star2] = ACTIONS(12615),
    [anon_sym_LBRACE] = ACTIONS(12615),
    [anon_sym_RBRACE] = ACTIONS(12615),
    [anon_sym_RPAREN] = ACTIONS(12615),
    [anon_sym_DOT] = ACTIONS(12617),
    [anon_sym_COMMA] = ACTIONS(12615),
    [anon_sym_PIPE] = ACTIONS(12617),
    [anon_sym_SEMI] = ACTIONS(12615),
    [anon_sym_STAR_STAR] = ACTIONS(12617),
    [anon_sym_AMP] = ACTIONS(12617),
    [anon_sym_EQ] = ACTIONS(12617),
    [anon_sym_LT] = ACTIONS(12617),
    [anon_sym_if] = ACTIONS(12615),
    [anon_sym_unless] = ACTIONS(12615),
    [anon_sym_while] = ACTIONS(12615),
    [anon_sym_until] = ACTIONS(12615),
    [anon_sym_rescue] = ACTIONS(12615),
    [anon_sym_in] = ACTIONS(12615),
    [anon_sym_do] = ACTIONS(12615),
    [anon_sym_LBRACK] = ACTIONS(12615),
    [anon_sym_RBRACK] = ACTIONS(12615),
    [anon_sym_COLON_COLON2] = ACTIONS(12615),
    [anon_sym_AMP_DOT] = ACTIONS(12615),
    [anon_sym_PLUS_EQ] = ACTIONS(12615),
    [anon_sym_DASH_EQ] = ACTIONS(12615),
    [anon_sym_STAR_EQ] = ACTIONS(12615),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12615),
    [anon_sym_SLASH_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_PIPE_EQ] = ACTIONS(12615),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12615),
    [anon_sym_AMP_EQ] = ACTIONS(12615),
    [anon_sym_PERCENT_EQ] = ACTIONS(12615),
    [anon_sym_GT_GT_EQ] = ACTIONS(12615),
    [anon_sym_LT_LT_EQ] = ACTIONS(12615),
    [anon_sym_CARET_EQ] = ACTIONS(12615),
    [anon_sym_QMARK] = ACTIONS(12615),
    [anon_sym_COLON2] = ACTIONS(12617),
    [anon_sym_DOT_DOT] = ACTIONS(12617),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12615),
    [anon_sym_and] = ACTIONS(12615),
    [anon_sym_or] = ACTIONS(12615),
    [anon_sym_PIPE_PIPE] = ACTIONS(12617),
    [anon_sym_AMP_AMP] = ACTIONS(12617),
    [anon_sym_LT_LT] = ACTIONS(12617),
    [anon_sym_GT_GT] = ACTIONS(12617),
    [anon_sym_EQ_EQ] = ACTIONS(12617),
    [anon_sym_BANG_EQ] = ACTIONS(12615),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12615),
    [anon_sym_LT_EQ_GT] = ACTIONS(12615),
    [anon_sym_EQ_TILDE] = ACTIONS(12615),
    [anon_sym_BANG_TILDE] = ACTIONS(12615),
    [anon_sym_LT_EQ] = ACTIONS(12617),
    [anon_sym_GT] = ACTIONS(12617),
    [anon_sym_GT_EQ] = ACTIONS(12615),
    [anon_sym_CARET] = ACTIONS(12617),
    [anon_sym_PLUS] = ACTIONS(12617),
    [anon_sym_SLASH] = ACTIONS(12617),
    [anon_sym_PERCENT] = ACTIONS(12617),
    [sym_comment] = ACTIONS(87),
  },
  [11715] = {
    [sym__heredoc_body_start2] = ACTIONS(12916),
    [sym__binary_minus2] = ACTIONS(12916),
    [sym__binary_star2] = ACTIONS(12916),
    [anon_sym_LBRACE] = ACTIONS(12916),
    [anon_sym_RBRACE] = ACTIONS(12916),
    [anon_sym_RPAREN] = ACTIONS(12916),
    [anon_sym_DOT] = ACTIONS(12918),
    [anon_sym_COMMA] = ACTIONS(12916),
    [anon_sym_PIPE] = ACTIONS(12918),
    [anon_sym_SEMI] = ACTIONS(12916),
    [anon_sym_STAR_STAR] = ACTIONS(12918),
    [anon_sym_AMP] = ACTIONS(12918),
    [anon_sym_EQ] = ACTIONS(12918),
    [anon_sym_LT] = ACTIONS(12918),
    [anon_sym_if] = ACTIONS(12916),
    [anon_sym_unless] = ACTIONS(12916),
    [anon_sym_while] = ACTIONS(12916),
    [anon_sym_until] = ACTIONS(12916),
    [anon_sym_rescue] = ACTIONS(12916),
    [anon_sym_in] = ACTIONS(12916),
    [anon_sym_do] = ACTIONS(12916),
    [anon_sym_LBRACK] = ACTIONS(12916),
    [anon_sym_RBRACK] = ACTIONS(12916),
    [anon_sym_COLON_COLON2] = ACTIONS(12916),
    [anon_sym_AMP_DOT] = ACTIONS(12916),
    [anon_sym_PLUS_EQ] = ACTIONS(12916),
    [anon_sym_DASH_EQ] = ACTIONS(12916),
    [anon_sym_STAR_EQ] = ACTIONS(12916),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12916),
    [anon_sym_SLASH_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_PIPE_EQ] = ACTIONS(12916),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12916),
    [anon_sym_AMP_EQ] = ACTIONS(12916),
    [anon_sym_PERCENT_EQ] = ACTIONS(12916),
    [anon_sym_GT_GT_EQ] = ACTIONS(12916),
    [anon_sym_LT_LT_EQ] = ACTIONS(12916),
    [anon_sym_CARET_EQ] = ACTIONS(12916),
    [anon_sym_QMARK] = ACTIONS(12916),
    [anon_sym_COLON2] = ACTIONS(12918),
    [anon_sym_DOT_DOT] = ACTIONS(12918),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12916),
    [anon_sym_and] = ACTIONS(12916),
    [anon_sym_or] = ACTIONS(12916),
    [anon_sym_PIPE_PIPE] = ACTIONS(12918),
    [anon_sym_AMP_AMP] = ACTIONS(12918),
    [anon_sym_LT_LT] = ACTIONS(12918),
    [anon_sym_GT_GT] = ACTIONS(12918),
    [anon_sym_EQ_EQ] = ACTIONS(12918),
    [anon_sym_BANG_EQ] = ACTIONS(12916),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12916),
    [anon_sym_LT_EQ_GT] = ACTIONS(12916),
    [anon_sym_EQ_TILDE] = ACTIONS(12916),
    [anon_sym_BANG_TILDE] = ACTIONS(12916),
    [anon_sym_LT_EQ] = ACTIONS(12918),
    [anon_sym_GT] = ACTIONS(12918),
    [anon_sym_GT_EQ] = ACTIONS(12916),
    [anon_sym_CARET] = ACTIONS(12918),
    [anon_sym_PLUS] = ACTIONS(12918),
    [anon_sym_SLASH] = ACTIONS(12918),
    [anon_sym_PERCENT] = ACTIONS(12918),
    [sym_comment] = ACTIONS(87),
  },
  [11716] = {
    [anon_sym_end] = ACTIONS(15317),
    [sym_comment] = ACTIONS(87),
  },
  [11717] = {
    [sym__heredoc_body_start2] = ACTIONS(13064),
    [sym__binary_minus2] = ACTIONS(13064),
    [sym__binary_star2] = ACTIONS(13064),
    [anon_sym_LBRACE] = ACTIONS(13064),
    [anon_sym_RBRACE] = ACTIONS(13064),
    [anon_sym_RPAREN] = ACTIONS(13064),
    [anon_sym_DOT] = ACTIONS(13066),
    [anon_sym_COMMA] = ACTIONS(13064),
    [anon_sym_PIPE] = ACTIONS(13066),
    [anon_sym_SEMI] = ACTIONS(13064),
    [anon_sym_STAR_STAR] = ACTIONS(13066),
    [anon_sym_AMP] = ACTIONS(13066),
    [anon_sym_EQ] = ACTIONS(13066),
    [anon_sym_LT] = ACTIONS(13066),
    [anon_sym_if] = ACTIONS(13064),
    [anon_sym_unless] = ACTIONS(13064),
    [anon_sym_while] = ACTIONS(13064),
    [anon_sym_until] = ACTIONS(13064),
    [anon_sym_rescue] = ACTIONS(13064),
    [anon_sym_in] = ACTIONS(13064),
    [anon_sym_do] = ACTIONS(13064),
    [anon_sym_LBRACK] = ACTIONS(13064),
    [anon_sym_RBRACK] = ACTIONS(13064),
    [anon_sym_COLON_COLON2] = ACTIONS(13064),
    [anon_sym_AMP_DOT] = ACTIONS(13064),
    [anon_sym_PLUS_EQ] = ACTIONS(13064),
    [anon_sym_DASH_EQ] = ACTIONS(13064),
    [anon_sym_STAR_EQ] = ACTIONS(13064),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13064),
    [anon_sym_SLASH_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_PIPE_EQ] = ACTIONS(13064),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13064),
    [anon_sym_AMP_EQ] = ACTIONS(13064),
    [anon_sym_PERCENT_EQ] = ACTIONS(13064),
    [anon_sym_GT_GT_EQ] = ACTIONS(13064),
    [anon_sym_LT_LT_EQ] = ACTIONS(13064),
    [anon_sym_CARET_EQ] = ACTIONS(13064),
    [anon_sym_QMARK] = ACTIONS(13064),
    [anon_sym_COLON2] = ACTIONS(13066),
    [anon_sym_DOT_DOT] = ACTIONS(13066),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13064),
    [anon_sym_and] = ACTIONS(13064),
    [anon_sym_or] = ACTIONS(13064),
    [anon_sym_PIPE_PIPE] = ACTIONS(13066),
    [anon_sym_AMP_AMP] = ACTIONS(13066),
    [anon_sym_LT_LT] = ACTIONS(13066),
    [anon_sym_GT_GT] = ACTIONS(13066),
    [anon_sym_EQ_EQ] = ACTIONS(13066),
    [anon_sym_BANG_EQ] = ACTIONS(13064),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13064),
    [anon_sym_LT_EQ_GT] = ACTIONS(13064),
    [anon_sym_EQ_TILDE] = ACTIONS(13064),
    [anon_sym_BANG_TILDE] = ACTIONS(13064),
    [anon_sym_LT_EQ] = ACTIONS(13066),
    [anon_sym_GT] = ACTIONS(13066),
    [anon_sym_GT_EQ] = ACTIONS(13064),
    [anon_sym_CARET] = ACTIONS(13066),
    [anon_sym_PLUS] = ACTIONS(13066),
    [anon_sym_SLASH] = ACTIONS(13066),
    [anon_sym_PERCENT] = ACTIONS(13066),
    [sym_comment] = ACTIONS(87),
  },
  [11718] = {
    [sym__heredoc_body_start2] = ACTIONS(13216),
    [sym__binary_minus2] = ACTIONS(13216),
    [sym__binary_star2] = ACTIONS(13216),
    [anon_sym_LBRACE] = ACTIONS(13216),
    [anon_sym_RBRACE] = ACTIONS(13216),
    [anon_sym_RPAREN] = ACTIONS(13216),
    [anon_sym_DOT] = ACTIONS(13218),
    [anon_sym_COMMA] = ACTIONS(13216),
    [anon_sym_PIPE] = ACTIONS(13218),
    [anon_sym_SEMI] = ACTIONS(13216),
    [anon_sym_STAR_STAR] = ACTIONS(13218),
    [anon_sym_AMP] = ACTIONS(13218),
    [anon_sym_EQ] = ACTIONS(13218),
    [anon_sym_LT] = ACTIONS(13218),
    [anon_sym_if] = ACTIONS(13216),
    [anon_sym_unless] = ACTIONS(13216),
    [anon_sym_while] = ACTIONS(13216),
    [anon_sym_until] = ACTIONS(13216),
    [anon_sym_rescue] = ACTIONS(13216),
    [anon_sym_in] = ACTIONS(13216),
    [anon_sym_do] = ACTIONS(13216),
    [anon_sym_LBRACK] = ACTIONS(13216),
    [anon_sym_RBRACK] = ACTIONS(13216),
    [anon_sym_COLON_COLON2] = ACTIONS(13216),
    [anon_sym_AMP_DOT] = ACTIONS(13216),
    [anon_sym_PLUS_EQ] = ACTIONS(13216),
    [anon_sym_DASH_EQ] = ACTIONS(13216),
    [anon_sym_STAR_EQ] = ACTIONS(13216),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13216),
    [anon_sym_SLASH_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_PIPE_EQ] = ACTIONS(13216),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13216),
    [anon_sym_AMP_EQ] = ACTIONS(13216),
    [anon_sym_PERCENT_EQ] = ACTIONS(13216),
    [anon_sym_GT_GT_EQ] = ACTIONS(13216),
    [anon_sym_LT_LT_EQ] = ACTIONS(13216),
    [anon_sym_CARET_EQ] = ACTIONS(13216),
    [anon_sym_QMARK] = ACTIONS(13216),
    [anon_sym_COLON2] = ACTIONS(13218),
    [anon_sym_DOT_DOT] = ACTIONS(13218),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13216),
    [anon_sym_and] = ACTIONS(13216),
    [anon_sym_or] = ACTIONS(13216),
    [anon_sym_PIPE_PIPE] = ACTIONS(13218),
    [anon_sym_AMP_AMP] = ACTIONS(13218),
    [anon_sym_LT_LT] = ACTIONS(13218),
    [anon_sym_GT_GT] = ACTIONS(13218),
    [anon_sym_EQ_EQ] = ACTIONS(13218),
    [anon_sym_BANG_EQ] = ACTIONS(13216),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13216),
    [anon_sym_LT_EQ_GT] = ACTIONS(13216),
    [anon_sym_EQ_TILDE] = ACTIONS(13216),
    [anon_sym_BANG_TILDE] = ACTIONS(13216),
    [anon_sym_LT_EQ] = ACTIONS(13218),
    [anon_sym_GT] = ACTIONS(13218),
    [anon_sym_GT_EQ] = ACTIONS(13216),
    [anon_sym_CARET] = ACTIONS(13218),
    [anon_sym_PLUS] = ACTIONS(13218),
    [anon_sym_SLASH] = ACTIONS(13218),
    [anon_sym_PERCENT] = ACTIONS(13218),
    [sym_comment] = ACTIONS(87),
  },
  [11719] = {
    [sym__heredoc_body_start2] = ACTIONS(13227),
    [sym__binary_minus2] = ACTIONS(13227),
    [sym__binary_star2] = ACTIONS(13227),
    [anon_sym_LBRACE] = ACTIONS(13227),
    [anon_sym_RBRACE] = ACTIONS(13227),
    [anon_sym_RPAREN] = ACTIONS(13227),
    [anon_sym_DOT] = ACTIONS(13229),
    [anon_sym_COMMA] = ACTIONS(13227),
    [anon_sym_PIPE] = ACTIONS(13229),
    [anon_sym_SEMI] = ACTIONS(13227),
    [anon_sym_STAR_STAR] = ACTIONS(13229),
    [anon_sym_AMP] = ACTIONS(13229),
    [anon_sym_EQ] = ACTIONS(13229),
    [anon_sym_LT] = ACTIONS(13229),
    [anon_sym_if] = ACTIONS(13227),
    [anon_sym_unless] = ACTIONS(13227),
    [anon_sym_while] = ACTIONS(13227),
    [anon_sym_until] = ACTIONS(13227),
    [anon_sym_rescue] = ACTIONS(13227),
    [anon_sym_in] = ACTIONS(13227),
    [anon_sym_do] = ACTIONS(13227),
    [anon_sym_LBRACK] = ACTIONS(13227),
    [anon_sym_RBRACK] = ACTIONS(13227),
    [anon_sym_COLON_COLON2] = ACTIONS(13227),
    [anon_sym_AMP_DOT] = ACTIONS(13227),
    [anon_sym_PLUS_EQ] = ACTIONS(13227),
    [anon_sym_DASH_EQ] = ACTIONS(13227),
    [anon_sym_STAR_EQ] = ACTIONS(13227),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13227),
    [anon_sym_SLASH_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_PIPE_EQ] = ACTIONS(13227),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13227),
    [anon_sym_AMP_EQ] = ACTIONS(13227),
    [anon_sym_PERCENT_EQ] = ACTIONS(13227),
    [anon_sym_GT_GT_EQ] = ACTIONS(13227),
    [anon_sym_LT_LT_EQ] = ACTIONS(13227),
    [anon_sym_CARET_EQ] = ACTIONS(13227),
    [anon_sym_QMARK] = ACTIONS(13227),
    [anon_sym_COLON2] = ACTIONS(13229),
    [anon_sym_DOT_DOT] = ACTIONS(13229),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13227),
    [anon_sym_and] = ACTIONS(13227),
    [anon_sym_or] = ACTIONS(13227),
    [anon_sym_PIPE_PIPE] = ACTIONS(13229),
    [anon_sym_AMP_AMP] = ACTIONS(13229),
    [anon_sym_LT_LT] = ACTIONS(13229),
    [anon_sym_GT_GT] = ACTIONS(13229),
    [anon_sym_EQ_EQ] = ACTIONS(13229),
    [anon_sym_BANG_EQ] = ACTIONS(13227),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13227),
    [anon_sym_LT_EQ_GT] = ACTIONS(13227),
    [anon_sym_EQ_TILDE] = ACTIONS(13227),
    [anon_sym_BANG_TILDE] = ACTIONS(13227),
    [anon_sym_LT_EQ] = ACTIONS(13229),
    [anon_sym_GT] = ACTIONS(13229),
    [anon_sym_GT_EQ] = ACTIONS(13227),
    [anon_sym_CARET] = ACTIONS(13229),
    [anon_sym_PLUS] = ACTIONS(13229),
    [anon_sym_SLASH] = ACTIONS(13229),
    [anon_sym_PERCENT] = ACTIONS(13229),
    [sym_comment] = ACTIONS(87),
  },
  [11720] = {
    [sym__heredoc_body_start2] = ACTIONS(13551),
    [sym__binary_minus2] = ACTIONS(13551),
    [sym__binary_star2] = ACTIONS(13551),
    [anon_sym_LBRACE] = ACTIONS(13551),
    [anon_sym_RBRACE] = ACTIONS(13551),
    [anon_sym_RPAREN] = ACTIONS(13551),
    [anon_sym_DOT] = ACTIONS(13553),
    [anon_sym_COMMA] = ACTIONS(13551),
    [anon_sym_PIPE] = ACTIONS(13553),
    [anon_sym_SEMI] = ACTIONS(13551),
    [anon_sym_STAR_STAR] = ACTIONS(13553),
    [anon_sym_AMP] = ACTIONS(13553),
    [anon_sym_EQ] = ACTIONS(13553),
    [anon_sym_LT] = ACTIONS(13553),
    [anon_sym_if] = ACTIONS(13551),
    [anon_sym_unless] = ACTIONS(13551),
    [anon_sym_while] = ACTIONS(13551),
    [anon_sym_until] = ACTIONS(13551),
    [anon_sym_rescue] = ACTIONS(13551),
    [anon_sym_in] = ACTIONS(13551),
    [anon_sym_do] = ACTIONS(13551),
    [anon_sym_LBRACK] = ACTIONS(13551),
    [anon_sym_RBRACK] = ACTIONS(13551),
    [anon_sym_COLON_COLON2] = ACTIONS(13551),
    [anon_sym_AMP_DOT] = ACTIONS(13551),
    [anon_sym_PLUS_EQ] = ACTIONS(13551),
    [anon_sym_DASH_EQ] = ACTIONS(13551),
    [anon_sym_STAR_EQ] = ACTIONS(13551),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(13551),
    [anon_sym_SLASH_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_PIPE_EQ] = ACTIONS(13551),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(13551),
    [anon_sym_AMP_EQ] = ACTIONS(13551),
    [anon_sym_PERCENT_EQ] = ACTIONS(13551),
    [anon_sym_GT_GT_EQ] = ACTIONS(13551),
    [anon_sym_LT_LT_EQ] = ACTIONS(13551),
    [anon_sym_CARET_EQ] = ACTIONS(13551),
    [anon_sym_QMARK] = ACTIONS(13551),
    [anon_sym_COLON2] = ACTIONS(13553),
    [anon_sym_DOT_DOT] = ACTIONS(13553),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13551),
    [anon_sym_and] = ACTIONS(13551),
    [anon_sym_or] = ACTIONS(13551),
    [anon_sym_PIPE_PIPE] = ACTIONS(13553),
    [anon_sym_AMP_AMP] = ACTIONS(13553),
    [anon_sym_LT_LT] = ACTIONS(13553),
    [anon_sym_GT_GT] = ACTIONS(13553),
    [anon_sym_EQ_EQ] = ACTIONS(13553),
    [anon_sym_BANG_EQ] = ACTIONS(13551),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13551),
    [anon_sym_LT_EQ_GT] = ACTIONS(13551),
    [anon_sym_EQ_TILDE] = ACTIONS(13551),
    [anon_sym_BANG_TILDE] = ACTIONS(13551),
    [anon_sym_LT_EQ] = ACTIONS(13553),
    [anon_sym_GT] = ACTIONS(13553),
    [anon_sym_GT_EQ] = ACTIONS(13551),
    [anon_sym_CARET] = ACTIONS(13553),
    [anon_sym_PLUS] = ACTIONS(13553),
    [anon_sym_SLASH] = ACTIONS(13553),
    [anon_sym_PERCENT] = ACTIONS(13553),
    [sym_comment] = ACTIONS(87),
  },
  [11721] = {
    [sym__line_break2] = ACTIONS(14626),
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14626),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_SEMI] = ACTIONS(14626),
    [anon_sym_then] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [11722] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12684),
    [sym__binary_star2] = ACTIONS(12686),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12688),
    [anon_sym_STAR_STAR] = ACTIONS(12690),
    [anon_sym_AMP] = ACTIONS(12692),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(12694),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12696),
    [anon_sym_DOT_DOT] = ACTIONS(12698),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12700),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12702),
    [anon_sym_AMP_AMP] = ACTIONS(12702),
    [anon_sym_LT_LT] = ACTIONS(12704),
    [anon_sym_GT_GT] = ACTIONS(12704),
    [anon_sym_EQ_EQ] = ACTIONS(12702),
    [anon_sym_BANG_EQ] = ACTIONS(12706),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12706),
    [anon_sym_LT_EQ_GT] = ACTIONS(12706),
    [anon_sym_EQ_TILDE] = ACTIONS(12706),
    [anon_sym_BANG_TILDE] = ACTIONS(12706),
    [anon_sym_LT_EQ] = ACTIONS(12694),
    [anon_sym_GT] = ACTIONS(12694),
    [anon_sym_GT_EQ] = ACTIONS(12708),
    [anon_sym_CARET] = ACTIONS(12688),
    [anon_sym_PLUS] = ACTIONS(12710),
    [anon_sym_SLASH] = ACTIONS(12690),
    [anon_sym_PERCENT] = ACTIONS(12690),
    [sym_comment] = ACTIONS(87),
  },
  [11723] = {
    [aux_sym_exceptions_repeat1] = STATE(11723),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15319),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11724] = {
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_STAR_STAR] = ACTIONS(14122),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14122),
    [anon_sym_AMP_AMP] = ACTIONS(14122),
    [anon_sym_LT_LT] = ACTIONS(14122),
    [anon_sym_GT_GT] = ACTIONS(14122),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14122),
    [anon_sym_PLUS] = ACTIONS(14122),
    [anon_sym_SLASH] = ACTIONS(14122),
    [anon_sym_PERCENT] = ACTIONS(14122),
    [sym_comment] = ACTIONS(87),
  },
  [11725] = {
    [sym__heredoc_body_start2] = ACTIONS(14626),
    [sym__binary_minus2] = ACTIONS(14626),
    [sym__binary_star2] = ACTIONS(14626),
    [anon_sym_LBRACE] = ACTIONS(14626),
    [anon_sym_RPAREN] = ACTIONS(14626),
    [anon_sym_DOT] = ACTIONS(14628),
    [anon_sym_COMMA] = ACTIONS(14626),
    [anon_sym_PIPE] = ACTIONS(14628),
    [anon_sym_STAR_STAR] = ACTIONS(14626),
    [anon_sym_AMP] = ACTIONS(14628),
    [anon_sym_EQ] = ACTIONS(14628),
    [anon_sym_LT] = ACTIONS(14628),
    [anon_sym_do] = ACTIONS(14626),
    [anon_sym_LBRACK] = ACTIONS(14626),
    [anon_sym_COLON_COLON2] = ACTIONS(14626),
    [anon_sym_AMP_DOT] = ACTIONS(14626),
    [anon_sym_QMARK] = ACTIONS(14626),
    [anon_sym_DOT_DOT] = ACTIONS(14628),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14626),
    [anon_sym_and] = ACTIONS(14626),
    [anon_sym_or] = ACTIONS(14626),
    [anon_sym_PIPE_PIPE] = ACTIONS(14626),
    [anon_sym_AMP_AMP] = ACTIONS(14626),
    [anon_sym_LT_LT] = ACTIONS(14626),
    [anon_sym_GT_GT] = ACTIONS(14626),
    [anon_sym_EQ_EQ] = ACTIONS(14628),
    [anon_sym_BANG_EQ] = ACTIONS(14626),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14626),
    [anon_sym_LT_EQ_GT] = ACTIONS(14626),
    [anon_sym_EQ_TILDE] = ACTIONS(14626),
    [anon_sym_BANG_TILDE] = ACTIONS(14626),
    [anon_sym_LT_EQ] = ACTIONS(14628),
    [anon_sym_GT] = ACTIONS(14628),
    [anon_sym_GT_EQ] = ACTIONS(14626),
    [anon_sym_CARET] = ACTIONS(14626),
    [anon_sym_PLUS] = ACTIONS(14626),
    [anon_sym_SLASH] = ACTIONS(14626),
    [anon_sym_PERCENT] = ACTIONS(14626),
    [sym_comment] = ACTIONS(87),
  },
  [11726] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12860),
    [sym__binary_star2] = ACTIONS(12862),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12864),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12866),
    [anon_sym_AMP] = ACTIONS(12868),
    [anon_sym_LT] = ACTIONS(12870),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12872),
    [anon_sym_DOT_DOT] = ACTIONS(12874),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12876),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12878),
    [anon_sym_AMP_AMP] = ACTIONS(12878),
    [anon_sym_LT_LT] = ACTIONS(12880),
    [anon_sym_GT_GT] = ACTIONS(12880),
    [anon_sym_EQ_EQ] = ACTIONS(12882),
    [anon_sym_BANG_EQ] = ACTIONS(12878),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12878),
    [anon_sym_LT_EQ_GT] = ACTIONS(12878),
    [anon_sym_EQ_TILDE] = ACTIONS(12878),
    [anon_sym_BANG_TILDE] = ACTIONS(12878),
    [anon_sym_LT_EQ] = ACTIONS(12870),
    [anon_sym_GT] = ACTIONS(12870),
    [anon_sym_GT_EQ] = ACTIONS(12884),
    [anon_sym_CARET] = ACTIONS(12886),
    [anon_sym_PLUS] = ACTIONS(12888),
    [anon_sym_SLASH] = ACTIONS(12866),
    [anon_sym_PERCENT] = ACTIONS(12866),
    [sym_comment] = ACTIONS(87),
  },
  [11727] = {
    [aux_sym_exceptions_repeat1] = STATE(11727),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15322),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11728] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12925),
    [sym__binary_star2] = ACTIONS(12927),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12929),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12931),
    [anon_sym_AMP] = ACTIONS(12933),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(12935),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12937),
    [anon_sym_DOT_DOT] = ACTIONS(12939),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12941),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12943),
    [anon_sym_AMP_AMP] = ACTIONS(12943),
    [anon_sym_LT_LT] = ACTIONS(12945),
    [anon_sym_GT_GT] = ACTIONS(12945),
    [anon_sym_EQ_EQ] = ACTIONS(12943),
    [anon_sym_BANG_EQ] = ACTIONS(12947),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12947),
    [anon_sym_LT_EQ_GT] = ACTIONS(12947),
    [anon_sym_EQ_TILDE] = ACTIONS(12947),
    [anon_sym_BANG_TILDE] = ACTIONS(12947),
    [anon_sym_LT_EQ] = ACTIONS(12935),
    [anon_sym_GT] = ACTIONS(12935),
    [anon_sym_GT_EQ] = ACTIONS(12949),
    [anon_sym_CARET] = ACTIONS(12929),
    [anon_sym_PLUS] = ACTIONS(12951),
    [anon_sym_SLASH] = ACTIONS(12931),
    [anon_sym_PERCENT] = ACTIONS(12931),
    [sym_comment] = ACTIONS(87),
  },
  [11729] = {
    [aux_sym_exceptions_repeat1] = STATE(11729),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15325),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_elsif] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11730] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(12961),
    [sym__binary_star2] = ACTIONS(12963),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(12965),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(12967),
    [anon_sym_AMP] = ACTIONS(12969),
    [anon_sym_LT] = ACTIONS(12971),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_elsif] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(12973),
    [anon_sym_DOT_DOT] = ACTIONS(12975),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(12977),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(12979),
    [anon_sym_AMP_AMP] = ACTIONS(12979),
    [anon_sym_LT_LT] = ACTIONS(12981),
    [anon_sym_GT_GT] = ACTIONS(12981),
    [anon_sym_EQ_EQ] = ACTIONS(12983),
    [anon_sym_BANG_EQ] = ACTIONS(12979),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(12979),
    [anon_sym_LT_EQ_GT] = ACTIONS(12979),
    [anon_sym_EQ_TILDE] = ACTIONS(12979),
    [anon_sym_BANG_TILDE] = ACTIONS(12979),
    [anon_sym_LT_EQ] = ACTIONS(12971),
    [anon_sym_GT] = ACTIONS(12971),
    [anon_sym_GT_EQ] = ACTIONS(12985),
    [anon_sym_CARET] = ACTIONS(12987),
    [anon_sym_PLUS] = ACTIONS(12989),
    [anon_sym_SLASH] = ACTIONS(12967),
    [anon_sym_PERCENT] = ACTIONS(12967),
    [sym_comment] = ACTIONS(87),
  },
  [11731] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13010),
    [sym__binary_star2] = ACTIONS(13012),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13014),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13016),
    [anon_sym_AMP] = ACTIONS(13018),
    [anon_sym_LT] = ACTIONS(13020),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13022),
    [anon_sym_DOT_DOT] = ACTIONS(13024),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13026),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13028),
    [anon_sym_AMP_AMP] = ACTIONS(13028),
    [anon_sym_LT_LT] = ACTIONS(13030),
    [anon_sym_GT_GT] = ACTIONS(13030),
    [anon_sym_EQ_EQ] = ACTIONS(13032),
    [anon_sym_BANG_EQ] = ACTIONS(13028),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13028),
    [anon_sym_LT_EQ_GT] = ACTIONS(13028),
    [anon_sym_EQ_TILDE] = ACTIONS(13028),
    [anon_sym_BANG_TILDE] = ACTIONS(13028),
    [anon_sym_LT_EQ] = ACTIONS(13020),
    [anon_sym_GT] = ACTIONS(13020),
    [anon_sym_GT_EQ] = ACTIONS(13034),
    [anon_sym_CARET] = ACTIONS(13036),
    [anon_sym_PLUS] = ACTIONS(13038),
    [anon_sym_SLASH] = ACTIONS(13016),
    [anon_sym_PERCENT] = ACTIONS(13016),
    [sym_comment] = ACTIONS(87),
  },
  [11732] = {
    [aux_sym_exceptions_repeat1] = STATE(11732),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15328),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11733] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13073),
    [sym__binary_star2] = ACTIONS(13075),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13077),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13079),
    [anon_sym_AMP] = ACTIONS(13081),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(13083),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13085),
    [anon_sym_DOT_DOT] = ACTIONS(13087),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13089),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13091),
    [anon_sym_AMP_AMP] = ACTIONS(13091),
    [anon_sym_LT_LT] = ACTIONS(13093),
    [anon_sym_GT_GT] = ACTIONS(13093),
    [anon_sym_EQ_EQ] = ACTIONS(13091),
    [anon_sym_BANG_EQ] = ACTIONS(13095),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13095),
    [anon_sym_LT_EQ_GT] = ACTIONS(13095),
    [anon_sym_EQ_TILDE] = ACTIONS(13095),
    [anon_sym_BANG_TILDE] = ACTIONS(13095),
    [anon_sym_LT_EQ] = ACTIONS(13083),
    [anon_sym_GT] = ACTIONS(13083),
    [anon_sym_GT_EQ] = ACTIONS(13097),
    [anon_sym_CARET] = ACTIONS(13077),
    [anon_sym_PLUS] = ACTIONS(13099),
    [anon_sym_SLASH] = ACTIONS(13079),
    [anon_sym_PERCENT] = ACTIONS(13079),
    [sym_comment] = ACTIONS(87),
  },
  [11734] = {
    [aux_sym_exceptions_repeat1] = STATE(11734),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15331),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11735] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13109),
    [sym__binary_star2] = ACTIONS(13111),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13113),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13115),
    [anon_sym_AMP] = ACTIONS(13117),
    [anon_sym_LT] = ACTIONS(13119),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13121),
    [anon_sym_DOT_DOT] = ACTIONS(13123),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13125),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13127),
    [anon_sym_AMP_AMP] = ACTIONS(13127),
    [anon_sym_LT_LT] = ACTIONS(13129),
    [anon_sym_GT_GT] = ACTIONS(13129),
    [anon_sym_EQ_EQ] = ACTIONS(13131),
    [anon_sym_BANG_EQ] = ACTIONS(13127),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13127),
    [anon_sym_LT_EQ_GT] = ACTIONS(13127),
    [anon_sym_EQ_TILDE] = ACTIONS(13127),
    [anon_sym_BANG_TILDE] = ACTIONS(13127),
    [anon_sym_LT_EQ] = ACTIONS(13119),
    [anon_sym_GT] = ACTIONS(13119),
    [anon_sym_GT_EQ] = ACTIONS(13133),
    [anon_sym_CARET] = ACTIONS(13135),
    [anon_sym_PLUS] = ACTIONS(13137),
    [anon_sym_SLASH] = ACTIONS(13115),
    [anon_sym_PERCENT] = ACTIONS(13115),
    [sym_comment] = ACTIONS(87),
  },
  [11736] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13170),
    [sym__binary_star2] = ACTIONS(13172),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13174),
    [anon_sym_STAR_STAR] = ACTIONS(13176),
    [anon_sym_AMP] = ACTIONS(13178),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(13180),
    [anon_sym_in] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13182),
    [anon_sym_DOT_DOT] = ACTIONS(13184),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13186),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13188),
    [anon_sym_AMP_AMP] = ACTIONS(13188),
    [anon_sym_LT_LT] = ACTIONS(13190),
    [anon_sym_GT_GT] = ACTIONS(13190),
    [anon_sym_EQ_EQ] = ACTIONS(13188),
    [anon_sym_BANG_EQ] = ACTIONS(13192),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13192),
    [anon_sym_LT_EQ_GT] = ACTIONS(13192),
    [anon_sym_EQ_TILDE] = ACTIONS(13192),
    [anon_sym_BANG_TILDE] = ACTIONS(13192),
    [anon_sym_LT_EQ] = ACTIONS(13180),
    [anon_sym_GT] = ACTIONS(13180),
    [anon_sym_GT_EQ] = ACTIONS(13194),
    [anon_sym_CARET] = ACTIONS(13174),
    [anon_sym_PLUS] = ACTIONS(13196),
    [anon_sym_SLASH] = ACTIONS(13176),
    [anon_sym_PERCENT] = ACTIONS(13176),
    [sym_comment] = ACTIONS(87),
  },
  [11737] = {
    [aux_sym_exceptions_repeat1] = STATE(11737),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15334),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_in] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11738] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13236),
    [sym__binary_star2] = ACTIONS(13238),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13240),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13242),
    [anon_sym_AMP] = ACTIONS(13244),
    [anon_sym_LT] = ACTIONS(13246),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13248),
    [anon_sym_DOT_DOT] = ACTIONS(13250),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13252),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13254),
    [anon_sym_AMP_AMP] = ACTIONS(13254),
    [anon_sym_LT_LT] = ACTIONS(13256),
    [anon_sym_GT_GT] = ACTIONS(13256),
    [anon_sym_EQ_EQ] = ACTIONS(13258),
    [anon_sym_BANG_EQ] = ACTIONS(13254),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13254),
    [anon_sym_LT_EQ_GT] = ACTIONS(13254),
    [anon_sym_EQ_TILDE] = ACTIONS(13254),
    [anon_sym_BANG_TILDE] = ACTIONS(13254),
    [anon_sym_LT_EQ] = ACTIONS(13246),
    [anon_sym_GT] = ACTIONS(13246),
    [anon_sym_GT_EQ] = ACTIONS(13260),
    [anon_sym_CARET] = ACTIONS(13262),
    [anon_sym_PLUS] = ACTIONS(13264),
    [anon_sym_SLASH] = ACTIONS(13242),
    [anon_sym_PERCENT] = ACTIONS(13242),
    [sym_comment] = ACTIONS(87),
  },
  [11739] = {
    [aux_sym_exceptions_repeat1] = STATE(11739),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15337),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11740] = {
    [sym_heredoc_body] = STATE(11867),
    [aux_sym_call_repeat1] = STATE(11867),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(4346),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11741] = {
    [sym_heredoc_body] = STATE(11868),
    [aux_sym_call_repeat1] = STATE(11868),
    [aux_sym_argument_list_repeat1] = STATE(11504),
    [sym__line_break2] = ACTIONS(4346),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(4346),
    [sym__binary_star2] = ACTIONS(4346),
    [anon_sym_DOT] = ACTIONS(4348),
    [anon_sym_COMMA] = ACTIONS(14248),
    [anon_sym_PIPE] = ACTIONS(4348),
    [anon_sym_SEMI] = ACTIONS(4346),
    [anon_sym_STAR_STAR] = ACTIONS(4346),
    [anon_sym_AMP] = ACTIONS(4348),
    [anon_sym_LT] = ACTIONS(4348),
    [anon_sym_end] = ACTIONS(4346),
    [anon_sym_if] = ACTIONS(4346),
    [anon_sym_unless] = ACTIONS(4346),
    [anon_sym_while] = ACTIONS(4346),
    [anon_sym_until] = ACTIONS(4346),
    [anon_sym_rescue] = ACTIONS(4346),
    [anon_sym_when] = ACTIONS(4346),
    [anon_sym_else] = ACTIONS(4346),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_COLON_COLON2] = ACTIONS(4346),
    [anon_sym_AMP_DOT] = ACTIONS(4346),
    [anon_sym_QMARK] = ACTIONS(4346),
    [anon_sym_DOT_DOT] = ACTIONS(4348),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(4346),
    [anon_sym_and] = ACTIONS(4346),
    [anon_sym_or] = ACTIONS(4346),
    [anon_sym_PIPE_PIPE] = ACTIONS(4346),
    [anon_sym_AMP_AMP] = ACTIONS(4346),
    [anon_sym_LT_LT] = ACTIONS(4346),
    [anon_sym_GT_GT] = ACTIONS(4346),
    [anon_sym_EQ_EQ] = ACTIONS(4348),
    [anon_sym_BANG_EQ] = ACTIONS(4346),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(4346),
    [anon_sym_LT_EQ_GT] = ACTIONS(4346),
    [anon_sym_EQ_TILDE] = ACTIONS(4346),
    [anon_sym_BANG_TILDE] = ACTIONS(4346),
    [anon_sym_LT_EQ] = ACTIONS(4348),
    [anon_sym_GT] = ACTIONS(4348),
    [anon_sym_GT_EQ] = ACTIONS(4346),
    [anon_sym_CARET] = ACTIONS(4346),
    [anon_sym_PLUS] = ACTIONS(4346),
    [anon_sym_SLASH] = ACTIONS(4346),
    [anon_sym_PERCENT] = ACTIONS(4346),
    [sym_comment] = ACTIONS(87),
  },
  [11742] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11743] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11744] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11745] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11746] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11747] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11748] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15340),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11749] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11750] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11751] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11752] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11753] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11754] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_when] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11755] = {
    [aux_sym_exceptions_repeat1] = STATE(11871),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11756] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11757] = {
    [sym_string] = STATE(11757),
    [aux_sym_chained_string_repeat1] = STATE(11757),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(6254),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_when] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11758] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_when] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11759] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_when] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11760] = {
    [sym_heredoc_body] = STATE(11760),
    [aux_sym_call_repeat1] = STATE(11760),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_when] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11761] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11005),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym__argument] = STATE(5236),
    [sym_splat_argument] = STATE(5236),
    [sym_hash_splat_argument] = STATE(5236),
    [sym_block_argument] = STATE(5236),
    [sym_assignment] = STATE(11005),
    [sym_operator_assignment] = STATE(11005),
    [sym_conditional] = STATE(11005),
    [sym_range] = STATE(11005),
    [sym_binary] = STATE(11005),
    [sym_unary] = STATE(11005),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(11008),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_pair] = STATE(5236),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__block_ampersand2] = ACTIONS(14198),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [sym__identifier_hash_key2] = ACTIONS(14202),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15245),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(14204),
    [sym_identifier] = ACTIONS(14204),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11762] = {
    [sym_heredoc_body] = STATE(11760),
    [aux_sym_call_repeat1] = STATE(11760),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_when] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11763] = {
    [aux_sym_argument_list_repeat1] = STATE(11763),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15342),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11764] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11872),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_assignment] = STATE(11872),
    [sym_operator_assignment] = STATE(11872),
    [sym_conditional] = STATE(11872),
    [sym_range] = STATE(11872),
    [sym_binary] = STATE(11872),
    [sym_unary] = STATE(11872),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11765] = {
    [sym__line_break2] = ACTIONS(6749),
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(6749),
    [anon_sym_if] = ACTIONS(6749),
    [anon_sym_unless] = ACTIONS(6749),
    [anon_sym_while] = ACTIONS(6749),
    [anon_sym_until] = ACTIONS(6749),
    [anon_sym_rescue] = ACTIONS(6749),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_when] = ACTIONS(6749),
    [anon_sym_else] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11766] = {
    [sym__line_break2] = ACTIONS(6969),
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(6969),
    [anon_sym_if] = ACTIONS(6969),
    [anon_sym_unless] = ACTIONS(6969),
    [anon_sym_while] = ACTIONS(6969),
    [anon_sym_until] = ACTIONS(6969),
    [anon_sym_rescue] = ACTIONS(6969),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_when] = ACTIONS(6969),
    [anon_sym_else] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11767] = {
    [sym_heredoc_body] = STATE(11767),
    [aux_sym_call_repeat1] = STATE(11767),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(10954),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_when] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [11768] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11029),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym__argument] = STATE(7805),
    [sym_splat_argument] = STATE(7805),
    [sym_hash_splat_argument] = STATE(7805),
    [sym_block_argument] = STATE(7805),
    [sym_assignment] = STATE(11029),
    [sym_operator_assignment] = STATE(11029),
    [sym_conditional] = STATE(11029),
    [sym_range] = STATE(11029),
    [sym_binary] = STATE(11029),
    [sym_unary] = STATE(11029),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11032),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_pair] = STATE(7805),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__block_ampersand2] = ACTIONS(14240),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [sym__identifier_hash_key2] = ACTIONS(14244),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15249),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(14246),
    [sym_identifier] = ACTIONS(14246),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11769] = {
    [sym_heredoc_body] = STATE(11767),
    [aux_sym_call_repeat1] = STATE(11767),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(4336),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_when] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [11770] = {
    [aux_sym_argument_list_repeat1] = STATE(11770),
    [sym__line_break2] = ACTIONS(7899),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15345),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_end] = ACTIONS(7899),
    [anon_sym_if] = ACTIONS(7899),
    [anon_sym_unless] = ACTIONS(7899),
    [anon_sym_while] = ACTIONS(7899),
    [anon_sym_until] = ACTIONS(7899),
    [anon_sym_rescue] = ACTIONS(7899),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_when] = ACTIONS(7899),
    [anon_sym_else] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [11771] = {
    [sym_method] = STATE(220),
    [sym_singleton_method] = STATE(220),
    [sym_class] = STATE(220),
    [sym_singleton_class] = STATE(220),
    [sym_module] = STATE(220),
    [sym_return] = STATE(220),
    [sym_yield] = STATE(220),
    [sym_break] = STATE(220),
    [sym_next] = STATE(220),
    [sym_while] = STATE(220),
    [sym_until] = STATE(220),
    [sym_for] = STATE(220),
    [sym_case] = STATE(220),
    [sym_if] = STATE(220),
    [sym_unless] = STATE(220),
    [sym_begin] = STATE(220),
    [sym__arg] = STATE(11505),
    [sym__primary] = STATE(220),
    [sym_parenthesized_statements] = STATE(220),
    [sym_element_reference] = STATE(10064),
    [sym_scope_resolution] = STATE(10060),
    [sym_call] = STATE(10060),
    [sym_method_call] = STATE(10064),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(11505),
    [sym_operator_assignment] = STATE(11505),
    [sym_conditional] = STATE(11505),
    [sym_range] = STATE(11505),
    [sym_binary] = STATE(11505),
    [sym_unary] = STATE(11505),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(10063),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10064),
    [sym__variable] = STATE(10060),
    [sym_rational] = STATE(220),
    [sym_true] = STATE(10064),
    [sym_false] = STATE(10064),
    [sym_nil] = STATE(10064),
    [sym_chained_string] = STATE(220),
    [sym_string] = STATE(10997),
    [sym_subshell] = STATE(220),
    [sym_string_array] = STATE(220),
    [sym_symbol_array] = STATE(220),
    [sym_symbol] = STATE(220),
    [sym_regex] = STATE(220),
    [sym_array] = STATE(220),
    [sym_hash] = STATE(220),
    [sym_lambda] = STATE(220),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(365),
    [sym__splat_star2] = ACTIONS(14200),
    [sym__unary_minus2] = ACTIONS(13280),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(13284),
    [anon_sym_yield] = ACTIONS(13286),
    [anon_sym_break] = ACTIONS(13288),
    [anon_sym_next] = ACTIONS(13290),
    [sym_redo] = ACTIONS(389),
    [sym_retry] = ACTIONS(389),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14194),
    [anon_sym_defined_QMARK] = ACTIONS(13292),
    [anon_sym_not] = ACTIONS(13294),
    [anon_sym_BANG] = ACTIONS(13298),
    [anon_sym_TILDE] = ACTIONS(13298),
    [sym_constant] = ACTIONS(13304),
    [sym_identifier] = ACTIONS(13304),
    [sym_instance_variable] = ACTIONS(13302),
    [sym_class_variable] = ACTIONS(13302),
    [sym_global_variable] = ACTIONS(13302),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(389),
    [sym_complex] = ACTIONS(365),
    [sym_super] = ACTIONS(13304),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13304),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(365),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11772] = {
    [aux_sym_exceptions_repeat1] = STATE(11873),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15348),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_when] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11773] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13322),
    [sym__binary_star2] = ACTIONS(13324),
    [anon_sym_PIPE] = ACTIONS(13326),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13328),
    [anon_sym_AMP] = ACTIONS(13330),
    [anon_sym_LT] = ACTIONS(13332),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13334),
    [anon_sym_DOT_DOT] = ACTIONS(13336),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13338),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13342),
    [anon_sym_AMP_AMP] = ACTIONS(13342),
    [anon_sym_LT_LT] = ACTIONS(13344),
    [anon_sym_GT_GT] = ACTIONS(13344),
    [anon_sym_EQ_EQ] = ACTIONS(13346),
    [anon_sym_BANG_EQ] = ACTIONS(13342),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13342),
    [anon_sym_LT_EQ_GT] = ACTIONS(13342),
    [anon_sym_EQ_TILDE] = ACTIONS(13342),
    [anon_sym_BANG_TILDE] = ACTIONS(13342),
    [anon_sym_LT_EQ] = ACTIONS(13332),
    [anon_sym_GT] = ACTIONS(13332),
    [anon_sym_GT_EQ] = ACTIONS(13348),
    [anon_sym_CARET] = ACTIONS(13350),
    [anon_sym_PLUS] = ACTIONS(13352),
    [anon_sym_SLASH] = ACTIONS(13328),
    [anon_sym_PERCENT] = ACTIONS(13328),
    [sym_comment] = ACTIONS(87),
  },
  [11774] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11775] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [11776] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11777] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [11778] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11779] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11780] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15350),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11781] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11782] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11783] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11784] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11785] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11786] = {
    [sym__line_break2] = ACTIONS(5104),
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(5104),
    [anon_sym_if] = ACTIONS(5104),
    [anon_sym_unless] = ACTIONS(5104),
    [anon_sym_while] = ACTIONS(5104),
    [anon_sym_until] = ACTIONS(5104),
    [anon_sym_rescue] = ACTIONS(5104),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_when] = ACTIONS(5104),
    [anon_sym_else] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11787] = {
    [aux_sym_exceptions_repeat1] = STATE(11876),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [11788] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11789] = {
    [sym_string] = STATE(11789),
    [aux_sym_chained_string_repeat1] = STATE(11789),
    [sym__line_break2] = ACTIONS(6252),
    [sym__string_start2] = ACTIONS(12323),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_end] = ACTIONS(6252),
    [anon_sym_if] = ACTIONS(6252),
    [anon_sym_unless] = ACTIONS(6252),
    [anon_sym_while] = ACTIONS(6252),
    [anon_sym_until] = ACTIONS(6252),
    [anon_sym_rescue] = ACTIONS(6252),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_when] = ACTIONS(6252),
    [anon_sym_else] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [11790] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11877),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_assignment] = STATE(11877),
    [sym_operator_assignment] = STATE(11877),
    [sym_conditional] = STATE(11877),
    [sym_range] = STATE(11877),
    [sym_binary] = STATE(11877),
    [sym_unary] = STATE(11877),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11791] = {
    [sym_method] = STATE(439),
    [sym_singleton_method] = STATE(439),
    [sym_class] = STATE(439),
    [sym_singleton_class] = STATE(439),
    [sym_module] = STATE(439),
    [sym_return] = STATE(439),
    [sym_yield] = STATE(439),
    [sym_break] = STATE(439),
    [sym_next] = STATE(439),
    [sym_while] = STATE(439),
    [sym_until] = STATE(439),
    [sym_for] = STATE(439),
    [sym_case] = STATE(439),
    [sym_if] = STATE(439),
    [sym_unless] = STATE(439),
    [sym_begin] = STATE(439),
    [sym__arg] = STATE(11548),
    [sym__primary] = STATE(439),
    [sym_parenthesized_statements] = STATE(439),
    [sym_element_reference] = STATE(10107),
    [sym_scope_resolution] = STATE(10103),
    [sym_call] = STATE(10103),
    [sym_method_call] = STATE(10107),
    [sym_splat_argument] = STATE(9179),
    [sym_assignment] = STATE(11548),
    [sym_operator_assignment] = STATE(11548),
    [sym_conditional] = STATE(11548),
    [sym_range] = STATE(11548),
    [sym_binary] = STATE(11548),
    [sym_unary] = STATE(11548),
    [sym__arg_or_splat_arg] = STATE(9179),
    [sym_left_assignment_list] = STATE(10106),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10107),
    [sym__variable] = STATE(10103),
    [sym_rational] = STATE(439),
    [sym_true] = STATE(10107),
    [sym_false] = STATE(10107),
    [sym_nil] = STATE(10107),
    [sym_chained_string] = STATE(439),
    [sym_string] = STATE(11074),
    [sym_subshell] = STATE(439),
    [sym_string_array] = STATE(439),
    [sym_symbol_array] = STATE(439),
    [sym_symbol] = STATE(439),
    [sym_regex] = STATE(439),
    [sym_array] = STATE(439),
    [sym_hash] = STATE(439),
    [sym_lambda] = STATE(439),
    [sym__simple_symbol2] = ACTIONS(751),
    [sym__string_start2] = ACTIONS(753),
    [sym__symbol_start2] = ACTIONS(755),
    [sym__subshell_start2] = ACTIONS(757),
    [sym__regex_start2] = ACTIONS(759),
    [sym__string_array_start2] = ACTIONS(761),
    [sym__symbol_array_start2] = ACTIONS(763),
    [sym_heredoc_beginning2] = ACTIONS(765),
    [sym__splat_star2] = ACTIONS(14242),
    [sym__unary_minus2] = ACTIONS(13358),
    [anon_sym_LBRACE] = ACTIONS(2673),
    [anon_sym_def] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(2675),
    [anon_sym_COLON_COLON] = ACTIONS(1589),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(783),
    [anon_sym_module] = ACTIONS(785),
    [anon_sym_return] = ACTIONS(13362),
    [anon_sym_yield] = ACTIONS(13364),
    [anon_sym_break] = ACTIONS(13366),
    [anon_sym_next] = ACTIONS(13368),
    [sym_redo] = ACTIONS(795),
    [sym_retry] = ACTIONS(795),
    [anon_sym_if] = ACTIONS(1933),
    [anon_sym_unless] = ACTIONS(1935),
    [anon_sym_while] = ACTIONS(1937),
    [anon_sym_until] = ACTIONS(1939),
    [anon_sym_for] = ACTIONS(797),
    [anon_sym_case] = ACTIONS(801),
    [anon_sym_begin] = ACTIONS(803),
    [anon_sym_PLUS] = ACTIONS(14284),
    [anon_sym_defined_QMARK] = ACTIONS(13370),
    [anon_sym_not] = ACTIONS(13372),
    [anon_sym_BANG] = ACTIONS(13376),
    [anon_sym_TILDE] = ACTIONS(13376),
    [sym_constant] = ACTIONS(13382),
    [sym_identifier] = ACTIONS(13382),
    [sym_instance_variable] = ACTIONS(13380),
    [sym_class_variable] = ACTIONS(13380),
    [sym_global_variable] = ACTIONS(13380),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(819),
    [sym_float] = ACTIONS(795),
    [sym_complex] = ACTIONS(765),
    [sym_super] = ACTIONS(13382),
    [anon_sym_true] = ACTIONS(407),
    [anon_sym_TRUE] = ACTIONS(407),
    [anon_sym_false] = ACTIONS(409),
    [anon_sym_FALSE] = ACTIONS(409),
    [sym_self] = ACTIONS(13382),
    [anon_sym_nil] = ACTIONS(411),
    [anon_sym_NIL] = ACTIONS(411),
    [sym_character] = ACTIONS(765),
    [anon_sym_LBRACK2] = ACTIONS(2679),
    [anon_sym_DASH_GT] = ACTIONS(825),
  },
  [11792] = {
    [aux_sym_exceptions_repeat1] = STATE(11878),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15352),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_when] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11793] = {
    [sym__line_break2] = ACTIONS(5852),
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_end] = ACTIONS(5852),
    [anon_sym_if] = ACTIONS(5852),
    [anon_sym_unless] = ACTIONS(5852),
    [anon_sym_while] = ACTIONS(5852),
    [anon_sym_until] = ACTIONS(5852),
    [anon_sym_rescue] = ACTIONS(5852),
    [anon_sym_when] = ACTIONS(5852),
    [anon_sym_else] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11794] = {
    [sym__line_break2] = ACTIONS(5856),
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_end] = ACTIONS(5856),
    [anon_sym_if] = ACTIONS(5856),
    [anon_sym_unless] = ACTIONS(5856),
    [anon_sym_while] = ACTIONS(5856),
    [anon_sym_until] = ACTIONS(5856),
    [anon_sym_rescue] = ACTIONS(5856),
    [anon_sym_when] = ACTIONS(5856),
    [anon_sym_else] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11795] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11796] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11797] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11798] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11799] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15354),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11800] = {
    [sym__line_break2] = ACTIONS(5966),
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(5966),
    [anon_sym_if] = ACTIONS(5966),
    [anon_sym_unless] = ACTIONS(5966),
    [anon_sym_while] = ACTIONS(5966),
    [anon_sym_until] = ACTIONS(5966),
    [anon_sym_rescue] = ACTIONS(5966),
    [anon_sym_when] = ACTIONS(5966),
    [anon_sym_else] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11801] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11802] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11803] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11804] = {
    [sym__line_break2] = ACTIONS(5860),
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_end] = ACTIONS(5860),
    [anon_sym_if] = ACTIONS(5860),
    [anon_sym_unless] = ACTIONS(5860),
    [anon_sym_while] = ACTIONS(5860),
    [anon_sym_until] = ACTIONS(5860),
    [anon_sym_rescue] = ACTIONS(5860),
    [anon_sym_when] = ACTIONS(5860),
    [anon_sym_else] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11805] = {
    [aux_sym_exceptions_repeat1] = STATE(11805),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(15356),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11806] = {
    [aux_sym_exceptions_repeat1] = STATE(11569),
    [sym__line_break2] = ACTIONS(6236),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_end] = ACTIONS(6236),
    [anon_sym_if] = ACTIONS(6236),
    [anon_sym_unless] = ACTIONS(6236),
    [anon_sym_while] = ACTIONS(6236),
    [anon_sym_until] = ACTIONS(6236),
    [anon_sym_rescue] = ACTIONS(6236),
    [anon_sym_when] = ACTIONS(6236),
    [anon_sym_else] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11807] = {
    [sym__line_break2] = ACTIONS(6250),
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(6250),
    [anon_sym_if] = ACTIONS(6250),
    [anon_sym_unless] = ACTIONS(6250),
    [anon_sym_while] = ACTIONS(6250),
    [anon_sym_until] = ACTIONS(6250),
    [anon_sym_rescue] = ACTIONS(6250),
    [anon_sym_when] = ACTIONS(6250),
    [anon_sym_else] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11808] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13397),
    [sym__binary_star2] = ACTIONS(13399),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13401),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13403),
    [anon_sym_AMP] = ACTIONS(13405),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(13407),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13409),
    [anon_sym_DOT_DOT] = ACTIONS(13411),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13413),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13415),
    [anon_sym_AMP_AMP] = ACTIONS(13415),
    [anon_sym_LT_LT] = ACTIONS(13417),
    [anon_sym_GT_GT] = ACTIONS(13417),
    [anon_sym_EQ_EQ] = ACTIONS(13415),
    [anon_sym_BANG_EQ] = ACTIONS(13419),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13419),
    [anon_sym_LT_EQ_GT] = ACTIONS(13419),
    [anon_sym_EQ_TILDE] = ACTIONS(13419),
    [anon_sym_BANG_TILDE] = ACTIONS(13419),
    [anon_sym_LT_EQ] = ACTIONS(13407),
    [anon_sym_GT] = ACTIONS(13407),
    [anon_sym_GT_EQ] = ACTIONS(13421),
    [anon_sym_CARET] = ACTIONS(13401),
    [anon_sym_PLUS] = ACTIONS(13423),
    [anon_sym_SLASH] = ACTIONS(13403),
    [anon_sym_PERCENT] = ACTIONS(13403),
    [sym_comment] = ACTIONS(87),
  },
  [11809] = {
    [aux_sym_exceptions_repeat1] = STATE(11809),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15359),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11810] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(13462),
    [sym__binary_star2] = ACTIONS(13464),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(13466),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13468),
    [anon_sym_AMP] = ACTIONS(13470),
    [anon_sym_LT] = ACTIONS(13472),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_then] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(13474),
    [anon_sym_DOT_DOT] = ACTIONS(13476),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13478),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13482),
    [anon_sym_AMP_AMP] = ACTIONS(13482),
    [anon_sym_LT_LT] = ACTIONS(13484),
    [anon_sym_GT_GT] = ACTIONS(13484),
    [anon_sym_EQ_EQ] = ACTIONS(13486),
    [anon_sym_BANG_EQ] = ACTIONS(13482),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13482),
    [anon_sym_LT_EQ_GT] = ACTIONS(13482),
    [anon_sym_EQ_TILDE] = ACTIONS(13482),
    [anon_sym_BANG_TILDE] = ACTIONS(13482),
    [anon_sym_LT_EQ] = ACTIONS(13472),
    [anon_sym_GT] = ACTIONS(13472),
    [anon_sym_GT_EQ] = ACTIONS(13488),
    [anon_sym_CARET] = ACTIONS(13490),
    [anon_sym_PLUS] = ACTIONS(13492),
    [anon_sym_SLASH] = ACTIONS(13468),
    [anon_sym_PERCENT] = ACTIONS(13468),
    [sym_comment] = ACTIONS(87),
  },
  [11811] = {
    [aux_sym_exceptions_repeat1] = STATE(11811),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15362),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_then] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11812] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5852),
    [anon_sym_AMP_AMP] = ACTIONS(5852),
    [anon_sym_LT_LT] = ACTIONS(5852),
    [anon_sym_GT_GT] = ACTIONS(5852),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5852),
    [anon_sym_PLUS] = ACTIONS(5852),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11813] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5856),
    [anon_sym_AMP_AMP] = ACTIONS(5856),
    [anon_sym_LT_LT] = ACTIONS(5856),
    [anon_sym_GT_GT] = ACTIONS(5856),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5856),
    [anon_sym_PLUS] = ACTIONS(5856),
    [anon_sym_SLASH] = ACTIONS(5856),
    [anon_sym_PERCENT] = ACTIONS(5856),
    [sym_comment] = ACTIONS(87),
  },
  [11814] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11815] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(5860),
    [anon_sym_PERCENT] = ACTIONS(5860),
    [sym_comment] = ACTIONS(87),
  },
  [11816] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11817] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11818] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15365),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11819] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11820] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11821] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11822] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11823] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5860),
    [anon_sym_AMP_AMP] = ACTIONS(5860),
    [anon_sym_LT_LT] = ACTIONS(5860),
    [anon_sym_GT_GT] = ACTIONS(5860),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5860),
    [anon_sym_PLUS] = ACTIONS(5860),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11824] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11825] = {
    [aux_sym_exceptions_repeat1] = STATE(11882),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6236),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6236),
    [anon_sym_AMP_AMP] = ACTIONS(6236),
    [anon_sym_LT_LT] = ACTIONS(6236),
    [anon_sym_GT_GT] = ACTIONS(6236),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6236),
    [anon_sym_PLUS] = ACTIONS(6236),
    [anon_sym_SLASH] = ACTIONS(6236),
    [anon_sym_PERCENT] = ACTIONS(6236),
    [sym_comment] = ACTIONS(87),
  },
  [11826] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11827] = {
    [sym_string] = STATE(11827),
    [aux_sym_chained_string_repeat1] = STATE(11827),
    [sym__string_start2] = ACTIONS(9467),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6252),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6252),
    [anon_sym_AMP_AMP] = ACTIONS(6252),
    [anon_sym_LT_LT] = ACTIONS(6252),
    [anon_sym_GT_GT] = ACTIONS(6252),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6252),
    [anon_sym_PLUS] = ACTIONS(6252),
    [anon_sym_SLASH] = ACTIONS(6252),
    [anon_sym_PERCENT] = ACTIONS(6252),
    [sym_comment] = ACTIONS(87),
  },
  [11828] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11829] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11830] = {
    [sym_heredoc_body] = STATE(11830),
    [aux_sym_call_repeat1] = STATE(11830),
    [sym__heredoc_body_start2] = ACTIONS(10396),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11831] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11235),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym__argument] = STATE(7228),
    [sym_splat_argument] = STATE(7228),
    [sym_hash_splat_argument] = STATE(7228),
    [sym_block_argument] = STATE(7228),
    [sym_assignment] = STATE(11235),
    [sym_operator_assignment] = STATE(11235),
    [sym_conditional] = STATE(11235),
    [sym_range] = STATE(11235),
    [sym_binary] = STATE(11235),
    [sym_unary] = STATE(11235),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11238),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_pair] = STATE(7228),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__block_ampersand2] = ACTIONS(14488),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [sym__identifier_hash_key2] = ACTIONS(14492),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15287),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(14494),
    [sym_identifier] = ACTIONS(14494),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11832] = {
    [sym_heredoc_body] = STATE(11830),
    [aux_sym_call_repeat1] = STATE(11830),
    [sym__heredoc_body_start2] = ACTIONS(3328),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11833] = {
    [aux_sym_argument_list_repeat1] = STATE(11833),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15367),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7899),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7899),
    [anon_sym_AMP_AMP] = ACTIONS(7899),
    [anon_sym_LT_LT] = ACTIONS(7899),
    [anon_sym_GT_GT] = ACTIONS(7899),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7899),
    [anon_sym_PLUS] = ACTIONS(7899),
    [anon_sym_SLASH] = ACTIONS(7899),
    [anon_sym_PERCENT] = ACTIONS(7899),
    [sym_comment] = ACTIONS(87),
  },
  [11834] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11883),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_assignment] = STATE(11883),
    [sym_operator_assignment] = STATE(11883),
    [sym_conditional] = STATE(11883),
    [sym_range] = STATE(11883),
    [sym_binary] = STATE(11883),
    [sym_unary] = STATE(11883),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11835] = {
    [sym__heredoc_body_start2] = ACTIONS(6749),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(6749),
    [anon_sym_DOT] = ACTIONS(7792),
    [anon_sym_COMMA] = ACTIONS(6749),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(6749),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(7792),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(6749),
    [anon_sym_EQ_GT] = ACTIONS(6749),
    [anon_sym_LBRACK] = ACTIONS(6749),
    [anon_sym_COLON_COLON2] = ACTIONS(6749),
    [anon_sym_AMP_DOT] = ACTIONS(6749),
    [anon_sym_PLUS_EQ] = ACTIONS(6749),
    [anon_sym_DASH_EQ] = ACTIONS(6749),
    [anon_sym_STAR_EQ] = ACTIONS(6749),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6749),
    [anon_sym_SLASH_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_PIPE_EQ] = ACTIONS(6749),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6749),
    [anon_sym_AMP_EQ] = ACTIONS(6749),
    [anon_sym_PERCENT_EQ] = ACTIONS(6749),
    [anon_sym_GT_GT_EQ] = ACTIONS(6749),
    [anon_sym_LT_LT_EQ] = ACTIONS(6749),
    [anon_sym_CARET_EQ] = ACTIONS(6749),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(6749),
    [anon_sym_or] = ACTIONS(6749),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11836] = {
    [sym__heredoc_body_start2] = ACTIONS(6969),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(6969),
    [anon_sym_DOT] = ACTIONS(7858),
    [anon_sym_COMMA] = ACTIONS(6969),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(6969),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(7858),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(6969),
    [anon_sym_EQ_GT] = ACTIONS(6969),
    [anon_sym_LBRACK] = ACTIONS(6969),
    [anon_sym_COLON_COLON2] = ACTIONS(6969),
    [anon_sym_AMP_DOT] = ACTIONS(6969),
    [anon_sym_PLUS_EQ] = ACTIONS(6969),
    [anon_sym_DASH_EQ] = ACTIONS(6969),
    [anon_sym_STAR_EQ] = ACTIONS(6969),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6969),
    [anon_sym_SLASH_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_PIPE_EQ] = ACTIONS(6969),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6969),
    [anon_sym_AMP_EQ] = ACTIONS(6969),
    [anon_sym_PERCENT_EQ] = ACTIONS(6969),
    [anon_sym_GT_GT_EQ] = ACTIONS(6969),
    [anon_sym_LT_LT_EQ] = ACTIONS(6969),
    [anon_sym_CARET_EQ] = ACTIONS(6969),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(6969),
    [anon_sym_or] = ACTIONS(6969),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11837] = {
    [sym_heredoc_body] = STATE(11837),
    [aux_sym_call_repeat1] = STATE(11837),
    [sym__heredoc_body_start2] = ACTIONS(10500),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_LBRACE] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7893),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_EQ] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_do] = ACTIONS(7888),
    [anon_sym_EQ_GT] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_PLUS_EQ] = ACTIONS(7888),
    [anon_sym_DASH_EQ] = ACTIONS(7888),
    [anon_sym_STAR_EQ] = ACTIONS(7888),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7888),
    [anon_sym_SLASH_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_PIPE_EQ] = ACTIONS(7888),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7888),
    [anon_sym_AMP_EQ] = ACTIONS(7888),
    [anon_sym_PERCENT_EQ] = ACTIONS(7888),
    [anon_sym_GT_GT_EQ] = ACTIONS(7888),
    [anon_sym_LT_LT_EQ] = ACTIONS(7888),
    [anon_sym_CARET_EQ] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7893),
    [anon_sym_AMP_AMP] = ACTIONS(7893),
    [anon_sym_LT_LT] = ACTIONS(7893),
    [anon_sym_GT_GT] = ACTIONS(7893),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7893),
    [anon_sym_PLUS] = ACTIONS(7893),
    [anon_sym_SLASH] = ACTIONS(7893),
    [anon_sym_PERCENT] = ACTIONS(7893),
    [sym_comment] = ACTIONS(87),
  },
  [11838] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11259),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym__argument] = STATE(7298),
    [sym_splat_argument] = STATE(7298),
    [sym_hash_splat_argument] = STATE(7298),
    [sym_block_argument] = STATE(7298),
    [sym_assignment] = STATE(11259),
    [sym_operator_assignment] = STATE(11259),
    [sym_conditional] = STATE(11259),
    [sym_range] = STATE(11259),
    [sym_binary] = STATE(11259),
    [sym_unary] = STATE(11259),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11262),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_pair] = STATE(7298),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__block_ampersand2] = ACTIONS(14530),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [sym__identifier_hash_key2] = ACTIONS(14534),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(169),
    [anon_sym_STAR_STAR] = ACTIONS(15291),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(14536),
    [sym_identifier] = ACTIONS(14536),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11839] = {
    [sym_heredoc_body] = STATE(11837),
    [aux_sym_call_repeat1] = STATE(11837),
    [sym__heredoc_body_start2] = ACTIONS(3472),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_LBRACE] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7905),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_EQ] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_do] = ACTIONS(7903),
    [anon_sym_EQ_GT] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_PLUS_EQ] = ACTIONS(7903),
    [anon_sym_DASH_EQ] = ACTIONS(7903),
    [anon_sym_STAR_EQ] = ACTIONS(7903),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7903),
    [anon_sym_SLASH_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_PIPE_EQ] = ACTIONS(7903),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7903),
    [anon_sym_AMP_EQ] = ACTIONS(7903),
    [anon_sym_PERCENT_EQ] = ACTIONS(7903),
    [anon_sym_GT_GT_EQ] = ACTIONS(7903),
    [anon_sym_LT_LT_EQ] = ACTIONS(7903),
    [anon_sym_CARET_EQ] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7905),
    [anon_sym_AMP_AMP] = ACTIONS(7905),
    [anon_sym_LT_LT] = ACTIONS(7905),
    [anon_sym_GT_GT] = ACTIONS(7905),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7905),
    [anon_sym_PLUS] = ACTIONS(7905),
    [anon_sym_SLASH] = ACTIONS(7905),
    [anon_sym_PERCENT] = ACTIONS(7905),
    [sym_comment] = ACTIONS(87),
  },
  [11840] = {
    [aux_sym_argument_list_repeat1] = STATE(11840),
    [sym__heredoc_body_start2] = ACTIONS(7899),
    [sym__binary_minus2] = ACTIONS(7899),
    [sym__binary_star2] = ACTIONS(7899),
    [anon_sym_LBRACE] = ACTIONS(7899),
    [anon_sym_DOT] = ACTIONS(7901),
    [anon_sym_COMMA] = ACTIONS(15370),
    [anon_sym_PIPE] = ACTIONS(7901),
    [anon_sym_SEMI] = ACTIONS(7899),
    [anon_sym_STAR_STAR] = ACTIONS(7901),
    [anon_sym_AMP] = ACTIONS(7901),
    [anon_sym_EQ] = ACTIONS(7901),
    [anon_sym_LT] = ACTIONS(7901),
    [anon_sym_do] = ACTIONS(7899),
    [anon_sym_EQ_GT] = ACTIONS(7899),
    [anon_sym_LBRACK] = ACTIONS(7899),
    [anon_sym_COLON_COLON2] = ACTIONS(7899),
    [anon_sym_AMP_DOT] = ACTIONS(7899),
    [anon_sym_PLUS_EQ] = ACTIONS(7899),
    [anon_sym_DASH_EQ] = ACTIONS(7899),
    [anon_sym_STAR_EQ] = ACTIONS(7899),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(7899),
    [anon_sym_SLASH_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_PIPE_EQ] = ACTIONS(7899),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(7899),
    [anon_sym_AMP_EQ] = ACTIONS(7899),
    [anon_sym_PERCENT_EQ] = ACTIONS(7899),
    [anon_sym_GT_GT_EQ] = ACTIONS(7899),
    [anon_sym_LT_LT_EQ] = ACTIONS(7899),
    [anon_sym_CARET_EQ] = ACTIONS(7899),
    [anon_sym_QMARK] = ACTIONS(7899),
    [anon_sym_DOT_DOT] = ACTIONS(7901),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7899),
    [anon_sym_and] = ACTIONS(7899),
    [anon_sym_or] = ACTIONS(7899),
    [anon_sym_PIPE_PIPE] = ACTIONS(7901),
    [anon_sym_AMP_AMP] = ACTIONS(7901),
    [anon_sym_LT_LT] = ACTIONS(7901),
    [anon_sym_GT_GT] = ACTIONS(7901),
    [anon_sym_EQ_EQ] = ACTIONS(7901),
    [anon_sym_BANG_EQ] = ACTIONS(7899),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7899),
    [anon_sym_LT_EQ_GT] = ACTIONS(7899),
    [anon_sym_EQ_TILDE] = ACTIONS(7899),
    [anon_sym_BANG_TILDE] = ACTIONS(7899),
    [anon_sym_LT_EQ] = ACTIONS(7901),
    [anon_sym_GT] = ACTIONS(7901),
    [anon_sym_GT_EQ] = ACTIONS(7899),
    [anon_sym_CARET] = ACTIONS(7901),
    [anon_sym_PLUS] = ACTIONS(7901),
    [anon_sym_SLASH] = ACTIONS(7901),
    [anon_sym_PERCENT] = ACTIONS(7901),
    [sym_comment] = ACTIONS(87),
  },
  [11841] = {
    [sym_method] = STATE(360),
    [sym_singleton_method] = STATE(360),
    [sym_class] = STATE(360),
    [sym_singleton_class] = STATE(360),
    [sym_module] = STATE(360),
    [sym_return] = STATE(360),
    [sym_yield] = STATE(360),
    [sym_break] = STATE(360),
    [sym_next] = STATE(360),
    [sym_while] = STATE(360),
    [sym_until] = STATE(360),
    [sym_for] = STATE(360),
    [sym_case] = STATE(360),
    [sym_if] = STATE(360),
    [sym_unless] = STATE(360),
    [sym_begin] = STATE(360),
    [sym__arg] = STATE(11653),
    [sym__primary] = STATE(360),
    [sym_parenthesized_statements] = STATE(360),
    [sym_element_reference] = STATE(10441),
    [sym_scope_resolution] = STATE(10437),
    [sym_call] = STATE(10437),
    [sym_method_call] = STATE(10441),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(11653),
    [sym_operator_assignment] = STATE(11653),
    [sym_conditional] = STATE(11653),
    [sym_range] = STATE(11653),
    [sym_binary] = STATE(11653),
    [sym_unary] = STATE(11653),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(10440),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10441),
    [sym__variable] = STATE(10437),
    [sym_rational] = STATE(360),
    [sym_true] = STATE(10441),
    [sym_false] = STATE(10441),
    [sym_nil] = STATE(10441),
    [sym_chained_string] = STATE(360),
    [sym_string] = STATE(11227),
    [sym_subshell] = STATE(360),
    [sym_string_array] = STATE(360),
    [sym_symbol_array] = STATE(360),
    [sym_symbol] = STATE(360),
    [sym_regex] = STATE(360),
    [sym_array] = STATE(360),
    [sym_hash] = STATE(360),
    [sym_lambda] = STATE(360),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(591),
    [sym__splat_star2] = ACTIONS(14490),
    [sym__unary_minus2] = ACTIONS(13615),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(13619),
    [anon_sym_yield] = ACTIONS(13621),
    [anon_sym_break] = ACTIONS(13623),
    [anon_sym_next] = ACTIONS(13625),
    [sym_redo] = ACTIONS(623),
    [sym_retry] = ACTIONS(623),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14484),
    [anon_sym_defined_QMARK] = ACTIONS(13627),
    [anon_sym_not] = ACTIONS(13629),
    [anon_sym_BANG] = ACTIONS(13633),
    [anon_sym_TILDE] = ACTIONS(13633),
    [sym_constant] = ACTIONS(13639),
    [sym_identifier] = ACTIONS(13639),
    [sym_instance_variable] = ACTIONS(13637),
    [sym_class_variable] = ACTIONS(13637),
    [sym_global_variable] = ACTIONS(13637),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(623),
    [sym_complex] = ACTIONS(591),
    [sym_super] = ACTIONS(13639),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13639),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(591),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11842] = {
    [aux_sym_exceptions_repeat1] = STATE(11884),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15373),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11843] = {
    [sym__binary_minus2] = ACTIONS(13641),
    [sym__binary_star2] = ACTIONS(13643),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14548),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(13647),
    [anon_sym_AMP] = ACTIONS(13649),
    [anon_sym_LT] = ACTIONS(13651),
    [anon_sym_QMARK] = ACTIONS(13653),
    [anon_sym_DOT_DOT] = ACTIONS(13655),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(13657),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(13661),
    [anon_sym_AMP_AMP] = ACTIONS(13661),
    [anon_sym_LT_LT] = ACTIONS(13663),
    [anon_sym_GT_GT] = ACTIONS(13663),
    [anon_sym_EQ_EQ] = ACTIONS(13665),
    [anon_sym_BANG_EQ] = ACTIONS(13661),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(13661),
    [anon_sym_LT_EQ_GT] = ACTIONS(13661),
    [anon_sym_EQ_TILDE] = ACTIONS(13661),
    [anon_sym_BANG_TILDE] = ACTIONS(13661),
    [anon_sym_LT_EQ] = ACTIONS(13651),
    [anon_sym_GT] = ACTIONS(13651),
    [anon_sym_GT_EQ] = ACTIONS(13667),
    [anon_sym_CARET] = ACTIONS(13669),
    [anon_sym_PLUS] = ACTIONS(13671),
    [anon_sym_SLASH] = ACTIONS(13647),
    [anon_sym_PERCENT] = ACTIONS(13647),
    [sym_comment] = ACTIONS(87),
  },
  [11844] = {
    [sym__heredoc_body_start2] = ACTIONS(5852),
    [sym__binary_minus2] = ACTIONS(5852),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5852),
    [anon_sym_DOT] = ACTIONS(5854),
    [anon_sym_COMMA] = ACTIONS(5852),
    [anon_sym_PIPE] = ACTIONS(5854),
    [anon_sym_SEMI] = ACTIONS(5852),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5854),
    [anon_sym_EQ] = ACTIONS(5854),
    [anon_sym_LT] = ACTIONS(5854),
    [anon_sym_do] = ACTIONS(5852),
    [anon_sym_LBRACK] = ACTIONS(5852),
    [anon_sym_COLON_COLON2] = ACTIONS(5852),
    [anon_sym_AMP_DOT] = ACTIONS(5852),
    [anon_sym_PLUS_EQ] = ACTIONS(5852),
    [anon_sym_DASH_EQ] = ACTIONS(5852),
    [anon_sym_STAR_EQ] = ACTIONS(5852),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5852),
    [anon_sym_SLASH_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_PIPE_EQ] = ACTIONS(5852),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5852),
    [anon_sym_AMP_EQ] = ACTIONS(5852),
    [anon_sym_PERCENT_EQ] = ACTIONS(5852),
    [anon_sym_GT_GT_EQ] = ACTIONS(5852),
    [anon_sym_LT_LT_EQ] = ACTIONS(5852),
    [anon_sym_CARET_EQ] = ACTIONS(5852),
    [anon_sym_QMARK] = ACTIONS(5852),
    [anon_sym_DOT_DOT] = ACTIONS(5854),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5852),
    [anon_sym_and] = ACTIONS(5852),
    [anon_sym_or] = ACTIONS(5852),
    [anon_sym_PIPE_PIPE] = ACTIONS(5854),
    [anon_sym_AMP_AMP] = ACTIONS(5854),
    [anon_sym_LT_LT] = ACTIONS(5854),
    [anon_sym_GT_GT] = ACTIONS(5854),
    [anon_sym_EQ_EQ] = ACTIONS(5854),
    [anon_sym_BANG_EQ] = ACTIONS(5852),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5852),
    [anon_sym_LT_EQ_GT] = ACTIONS(5852),
    [anon_sym_EQ_TILDE] = ACTIONS(5852),
    [anon_sym_BANG_TILDE] = ACTIONS(5852),
    [anon_sym_LT_EQ] = ACTIONS(5854),
    [anon_sym_GT] = ACTIONS(5854),
    [anon_sym_GT_EQ] = ACTIONS(5852),
    [anon_sym_CARET] = ACTIONS(5854),
    [anon_sym_PLUS] = ACTIONS(5854),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11845] = {
    [sym__heredoc_body_start2] = ACTIONS(5856),
    [sym__binary_minus2] = ACTIONS(5856),
    [sym__binary_star2] = ACTIONS(5856),
    [anon_sym_LBRACE] = ACTIONS(5856),
    [anon_sym_DOT] = ACTIONS(5858),
    [anon_sym_COMMA] = ACTIONS(5856),
    [anon_sym_PIPE] = ACTIONS(5858),
    [anon_sym_SEMI] = ACTIONS(5856),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5858),
    [anon_sym_EQ] = ACTIONS(5858),
    [anon_sym_LT] = ACTIONS(5858),
    [anon_sym_do] = ACTIONS(5856),
    [anon_sym_LBRACK] = ACTIONS(5856),
    [anon_sym_COLON_COLON2] = ACTIONS(5856),
    [anon_sym_AMP_DOT] = ACTIONS(5856),
    [anon_sym_PLUS_EQ] = ACTIONS(5856),
    [anon_sym_DASH_EQ] = ACTIONS(5856),
    [anon_sym_STAR_EQ] = ACTIONS(5856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5856),
    [anon_sym_SLASH_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_PIPE_EQ] = ACTIONS(5856),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5856),
    [anon_sym_AMP_EQ] = ACTIONS(5856),
    [anon_sym_PERCENT_EQ] = ACTIONS(5856),
    [anon_sym_GT_GT_EQ] = ACTIONS(5856),
    [anon_sym_LT_LT_EQ] = ACTIONS(5856),
    [anon_sym_CARET_EQ] = ACTIONS(5856),
    [anon_sym_QMARK] = ACTIONS(5856),
    [anon_sym_DOT_DOT] = ACTIONS(5858),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5856),
    [anon_sym_and] = ACTIONS(5856),
    [anon_sym_or] = ACTIONS(5856),
    [anon_sym_PIPE_PIPE] = ACTIONS(5858),
    [anon_sym_AMP_AMP] = ACTIONS(5858),
    [anon_sym_LT_LT] = ACTIONS(5858),
    [anon_sym_GT_GT] = ACTIONS(5858),
    [anon_sym_EQ_EQ] = ACTIONS(5858),
    [anon_sym_BANG_EQ] = ACTIONS(5856),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5856),
    [anon_sym_LT_EQ_GT] = ACTIONS(5856),
    [anon_sym_EQ_TILDE] = ACTIONS(5856),
    [anon_sym_BANG_TILDE] = ACTIONS(5856),
    [anon_sym_LT_EQ] = ACTIONS(5858),
    [anon_sym_GT] = ACTIONS(5858),
    [anon_sym_GT_EQ] = ACTIONS(5856),
    [anon_sym_CARET] = ACTIONS(5858),
    [anon_sym_PLUS] = ACTIONS(5858),
    [anon_sym_SLASH] = ACTIONS(5858),
    [anon_sym_PERCENT] = ACTIONS(5858),
    [sym_comment] = ACTIONS(87),
  },
  [11846] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11847] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(5860),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(5862),
    [anon_sym_PERCENT] = ACTIONS(5862),
    [sym_comment] = ACTIONS(87),
  },
  [11848] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11849] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11850] = {
    [sym__binary_minus2] = ACTIONS(5896),
    [sym__binary_star2] = ACTIONS(5898),
    [anon_sym_PIPE] = ACTIONS(5900),
    [anon_sym_STAR_STAR] = ACTIONS(5902),
    [anon_sym_AMP] = ACTIONS(5904),
    [anon_sym_LT] = ACTIONS(5906),
    [anon_sym_QMARK] = ACTIONS(5908),
    [anon_sym_COLON2] = ACTIONS(15375),
    [anon_sym_DOT_DOT] = ACTIONS(5912),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5914),
    [anon_sym_and] = ACTIONS(5916),
    [anon_sym_or] = ACTIONS(5916),
    [anon_sym_PIPE_PIPE] = ACTIONS(5918),
    [anon_sym_AMP_AMP] = ACTIONS(5918),
    [anon_sym_LT_LT] = ACTIONS(5920),
    [anon_sym_GT_GT] = ACTIONS(5920),
    [anon_sym_EQ_EQ] = ACTIONS(5922),
    [anon_sym_BANG_EQ] = ACTIONS(5918),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5918),
    [anon_sym_LT_EQ_GT] = ACTIONS(5918),
    [anon_sym_EQ_TILDE] = ACTIONS(5918),
    [anon_sym_BANG_TILDE] = ACTIONS(5918),
    [anon_sym_LT_EQ] = ACTIONS(5906),
    [anon_sym_GT] = ACTIONS(5906),
    [anon_sym_GT_EQ] = ACTIONS(5924),
    [anon_sym_CARET] = ACTIONS(5926),
    [anon_sym_PLUS] = ACTIONS(5928),
    [anon_sym_SLASH] = ACTIONS(5902),
    [anon_sym_PERCENT] = ACTIONS(5902),
    [sym_comment] = ACTIONS(87),
  },
  [11851] = {
    [sym__heredoc_body_start2] = ACTIONS(5966),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5966),
    [anon_sym_DOT] = ACTIONS(7862),
    [anon_sym_COMMA] = ACTIONS(5966),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(5966),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(7862),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(5966),
    [anon_sym_LBRACK] = ACTIONS(5966),
    [anon_sym_COLON_COLON2] = ACTIONS(5966),
    [anon_sym_AMP_DOT] = ACTIONS(5966),
    [anon_sym_PLUS_EQ] = ACTIONS(5966),
    [anon_sym_DASH_EQ] = ACTIONS(5966),
    [anon_sym_STAR_EQ] = ACTIONS(5966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5966),
    [anon_sym_SLASH_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_PIPE_EQ] = ACTIONS(5966),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5966),
    [anon_sym_AMP_EQ] = ACTIONS(5966),
    [anon_sym_PERCENT_EQ] = ACTIONS(5966),
    [anon_sym_GT_GT_EQ] = ACTIONS(5966),
    [anon_sym_LT_LT_EQ] = ACTIONS(5966),
    [anon_sym_CARET_EQ] = ACTIONS(5966),
    [anon_sym_QMARK] = ACTIONS(5966),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(5966),
    [anon_sym_or] = ACTIONS(5966),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11852] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11853] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11854] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11855] = {
    [sym__heredoc_body_start2] = ACTIONS(5860),
    [sym__binary_minus2] = ACTIONS(5860),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5860),
    [anon_sym_DOT] = ACTIONS(5862),
    [anon_sym_COMMA] = ACTIONS(5860),
    [anon_sym_PIPE] = ACTIONS(5862),
    [anon_sym_SEMI] = ACTIONS(5860),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(5862),
    [anon_sym_EQ] = ACTIONS(5862),
    [anon_sym_LT] = ACTIONS(5862),
    [anon_sym_do] = ACTIONS(5860),
    [anon_sym_LBRACK] = ACTIONS(5860),
    [anon_sym_COLON_COLON2] = ACTIONS(5860),
    [anon_sym_AMP_DOT] = ACTIONS(5860),
    [anon_sym_PLUS_EQ] = ACTIONS(5860),
    [anon_sym_DASH_EQ] = ACTIONS(5860),
    [anon_sym_STAR_EQ] = ACTIONS(5860),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5860),
    [anon_sym_SLASH_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_PIPE_EQ] = ACTIONS(5860),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5860),
    [anon_sym_AMP_EQ] = ACTIONS(5860),
    [anon_sym_PERCENT_EQ] = ACTIONS(5860),
    [anon_sym_GT_GT_EQ] = ACTIONS(5860),
    [anon_sym_LT_LT_EQ] = ACTIONS(5860),
    [anon_sym_CARET_EQ] = ACTIONS(5860),
    [anon_sym_QMARK] = ACTIONS(5860),
    [anon_sym_DOT_DOT] = ACTIONS(5862),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(5860),
    [anon_sym_and] = ACTIONS(5860),
    [anon_sym_or] = ACTIONS(5860),
    [anon_sym_PIPE_PIPE] = ACTIONS(5862),
    [anon_sym_AMP_AMP] = ACTIONS(5862),
    [anon_sym_LT_LT] = ACTIONS(5862),
    [anon_sym_GT_GT] = ACTIONS(5862),
    [anon_sym_EQ_EQ] = ACTIONS(5862),
    [anon_sym_BANG_EQ] = ACTIONS(5860),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(5860),
    [anon_sym_LT_EQ_GT] = ACTIONS(5860),
    [anon_sym_EQ_TILDE] = ACTIONS(5860),
    [anon_sym_BANG_TILDE] = ACTIONS(5860),
    [anon_sym_LT_EQ] = ACTIONS(5862),
    [anon_sym_GT] = ACTIONS(5862),
    [anon_sym_GT_EQ] = ACTIONS(5860),
    [anon_sym_CARET] = ACTIONS(5862),
    [anon_sym_PLUS] = ACTIONS(5862),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11856] = {
    [sym__heredoc_body_start2] = ACTIONS(5104),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(5104),
    [anon_sym_DOT] = ACTIONS(7910),
    [anon_sym_COMMA] = ACTIONS(5104),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(5104),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(7910),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(5104),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_COLON_COLON2] = ACTIONS(5104),
    [anon_sym_AMP_DOT] = ACTIONS(5104),
    [anon_sym_PLUS_EQ] = ACTIONS(5104),
    [anon_sym_DASH_EQ] = ACTIONS(5104),
    [anon_sym_STAR_EQ] = ACTIONS(5104),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(5104),
    [anon_sym_SLASH_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_PIPE_EQ] = ACTIONS(5104),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(5104),
    [anon_sym_AMP_EQ] = ACTIONS(5104),
    [anon_sym_PERCENT_EQ] = ACTIONS(5104),
    [anon_sym_GT_GT_EQ] = ACTIONS(5104),
    [anon_sym_LT_LT_EQ] = ACTIONS(5104),
    [anon_sym_CARET_EQ] = ACTIONS(5104),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(5104),
    [anon_sym_or] = ACTIONS(5104),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11857] = {
    [aux_sym_exceptions_repeat1] = STATE(11887),
    [sym__heredoc_body_start2] = ACTIONS(6236),
    [sym__binary_minus2] = ACTIONS(6236),
    [sym__binary_star2] = ACTIONS(6236),
    [anon_sym_LBRACE] = ACTIONS(6236),
    [anon_sym_DOT] = ACTIONS(6238),
    [anon_sym_COMMA] = ACTIONS(6236),
    [anon_sym_PIPE] = ACTIONS(6238),
    [anon_sym_SEMI] = ACTIONS(6236),
    [anon_sym_STAR_STAR] = ACTIONS(6238),
    [anon_sym_AMP] = ACTIONS(6238),
    [anon_sym_EQ] = ACTIONS(6238),
    [anon_sym_LT] = ACTIONS(6238),
    [anon_sym_do] = ACTIONS(6236),
    [anon_sym_LBRACK] = ACTIONS(6236),
    [anon_sym_COLON_COLON2] = ACTIONS(6236),
    [anon_sym_AMP_DOT] = ACTIONS(6236),
    [anon_sym_PLUS_EQ] = ACTIONS(6236),
    [anon_sym_DASH_EQ] = ACTIONS(6236),
    [anon_sym_STAR_EQ] = ACTIONS(6236),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6236),
    [anon_sym_SLASH_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_PIPE_EQ] = ACTIONS(6236),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6236),
    [anon_sym_AMP_EQ] = ACTIONS(6236),
    [anon_sym_PERCENT_EQ] = ACTIONS(6236),
    [anon_sym_GT_GT_EQ] = ACTIONS(6236),
    [anon_sym_LT_LT_EQ] = ACTIONS(6236),
    [anon_sym_CARET_EQ] = ACTIONS(6236),
    [anon_sym_QMARK] = ACTIONS(6236),
    [anon_sym_DOT_DOT] = ACTIONS(6238),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6236),
    [anon_sym_and] = ACTIONS(6236),
    [anon_sym_or] = ACTIONS(6236),
    [anon_sym_PIPE_PIPE] = ACTIONS(6238),
    [anon_sym_AMP_AMP] = ACTIONS(6238),
    [anon_sym_LT_LT] = ACTIONS(6238),
    [anon_sym_GT_GT] = ACTIONS(6238),
    [anon_sym_EQ_EQ] = ACTIONS(6238),
    [anon_sym_BANG_EQ] = ACTIONS(6236),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6236),
    [anon_sym_LT_EQ_GT] = ACTIONS(6236),
    [anon_sym_EQ_TILDE] = ACTIONS(6236),
    [anon_sym_BANG_TILDE] = ACTIONS(6236),
    [anon_sym_LT_EQ] = ACTIONS(6238),
    [anon_sym_GT] = ACTIONS(6238),
    [anon_sym_GT_EQ] = ACTIONS(6236),
    [anon_sym_CARET] = ACTIONS(6238),
    [anon_sym_PLUS] = ACTIONS(6238),
    [anon_sym_SLASH] = ACTIONS(6238),
    [anon_sym_PERCENT] = ACTIONS(6238),
    [sym_comment] = ACTIONS(87),
  },
  [11858] = {
    [sym__heredoc_body_start2] = ACTIONS(6250),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(6250),
    [anon_sym_DOT] = ACTIONS(7912),
    [anon_sym_COMMA] = ACTIONS(6250),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(6250),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(7912),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(6250),
    [anon_sym_LBRACK] = ACTIONS(6250),
    [anon_sym_COLON_COLON2] = ACTIONS(6250),
    [anon_sym_AMP_DOT] = ACTIONS(6250),
    [anon_sym_PLUS_EQ] = ACTIONS(6250),
    [anon_sym_DASH_EQ] = ACTIONS(6250),
    [anon_sym_STAR_EQ] = ACTIONS(6250),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6250),
    [anon_sym_SLASH_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_PIPE_EQ] = ACTIONS(6250),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6250),
    [anon_sym_AMP_EQ] = ACTIONS(6250),
    [anon_sym_PERCENT_EQ] = ACTIONS(6250),
    [anon_sym_GT_GT_EQ] = ACTIONS(6250),
    [anon_sym_LT_LT_EQ] = ACTIONS(6250),
    [anon_sym_CARET_EQ] = ACTIONS(6250),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(6250),
    [anon_sym_or] = ACTIONS(6250),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11859] = {
    [sym_string] = STATE(11859),
    [aux_sym_chained_string_repeat1] = STATE(11859),
    [sym__string_start2] = ACTIONS(13889),
    [sym__heredoc_body_start2] = ACTIONS(6252),
    [sym__binary_minus2] = ACTIONS(6252),
    [sym__binary_star2] = ACTIONS(6252),
    [anon_sym_LBRACE] = ACTIONS(6252),
    [anon_sym_DOT] = ACTIONS(6257),
    [anon_sym_COMMA] = ACTIONS(6252),
    [anon_sym_PIPE] = ACTIONS(6257),
    [anon_sym_SEMI] = ACTIONS(6252),
    [anon_sym_STAR_STAR] = ACTIONS(6257),
    [anon_sym_AMP] = ACTIONS(6257),
    [anon_sym_EQ] = ACTIONS(6257),
    [anon_sym_LT] = ACTIONS(6257),
    [anon_sym_do] = ACTIONS(6252),
    [anon_sym_LBRACK] = ACTIONS(6252),
    [anon_sym_COLON_COLON2] = ACTIONS(6252),
    [anon_sym_AMP_DOT] = ACTIONS(6252),
    [anon_sym_PLUS_EQ] = ACTIONS(6252),
    [anon_sym_DASH_EQ] = ACTIONS(6252),
    [anon_sym_STAR_EQ] = ACTIONS(6252),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(6252),
    [anon_sym_SLASH_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_PIPE_EQ] = ACTIONS(6252),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(6252),
    [anon_sym_AMP_EQ] = ACTIONS(6252),
    [anon_sym_PERCENT_EQ] = ACTIONS(6252),
    [anon_sym_GT_GT_EQ] = ACTIONS(6252),
    [anon_sym_LT_LT_EQ] = ACTIONS(6252),
    [anon_sym_CARET_EQ] = ACTIONS(6252),
    [anon_sym_QMARK] = ACTIONS(6252),
    [anon_sym_DOT_DOT] = ACTIONS(6257),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(6252),
    [anon_sym_and] = ACTIONS(6252),
    [anon_sym_or] = ACTIONS(6252),
    [anon_sym_PIPE_PIPE] = ACTIONS(6257),
    [anon_sym_AMP_AMP] = ACTIONS(6257),
    [anon_sym_LT_LT] = ACTIONS(6257),
    [anon_sym_GT_GT] = ACTIONS(6257),
    [anon_sym_EQ_EQ] = ACTIONS(6257),
    [anon_sym_BANG_EQ] = ACTIONS(6252),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(6252),
    [anon_sym_LT_EQ_GT] = ACTIONS(6252),
    [anon_sym_EQ_TILDE] = ACTIONS(6252),
    [anon_sym_BANG_TILDE] = ACTIONS(6252),
    [anon_sym_LT_EQ] = ACTIONS(6257),
    [anon_sym_GT] = ACTIONS(6257),
    [anon_sym_GT_EQ] = ACTIONS(6252),
    [anon_sym_CARET] = ACTIONS(6257),
    [anon_sym_PLUS] = ACTIONS(6257),
    [anon_sym_SLASH] = ACTIONS(6257),
    [anon_sym_PERCENT] = ACTIONS(6257),
    [sym_comment] = ACTIONS(87),
  },
  [11860] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11888),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_assignment] = STATE(11888),
    [sym_operator_assignment] = STATE(11888),
    [sym_conditional] = STATE(11888),
    [sym_range] = STATE(11888),
    [sym_binary] = STATE(11888),
    [sym_unary] = STATE(11888),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11861] = {
    [sym_method] = STATE(669),
    [sym_singleton_method] = STATE(669),
    [sym_class] = STATE(669),
    [sym_singleton_class] = STATE(669),
    [sym_module] = STATE(669),
    [sym_return] = STATE(669),
    [sym_yield] = STATE(669),
    [sym_break] = STATE(669),
    [sym_next] = STATE(669),
    [sym_while] = STATE(669),
    [sym_until] = STATE(669),
    [sym_for] = STATE(669),
    [sym_case] = STATE(669),
    [sym_if] = STATE(669),
    [sym_unless] = STATE(669),
    [sym_begin] = STATE(669),
    [sym__arg] = STATE(11694),
    [sym__primary] = STATE(669),
    [sym_parenthesized_statements] = STATE(669),
    [sym_element_reference] = STATE(10475),
    [sym_scope_resolution] = STATE(10471),
    [sym_call] = STATE(10471),
    [sym_method_call] = STATE(10475),
    [sym_splat_argument] = STATE(9461),
    [sym_assignment] = STATE(11694),
    [sym_operator_assignment] = STATE(11694),
    [sym_conditional] = STATE(11694),
    [sym_range] = STATE(11694),
    [sym_binary] = STATE(11694),
    [sym_unary] = STATE(11694),
    [sym__arg_or_splat_arg] = STATE(9461),
    [sym_left_assignment_list] = STATE(10474),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10475),
    [sym__variable] = STATE(10471),
    [sym_rational] = STATE(669),
    [sym_true] = STATE(10475),
    [sym_false] = STATE(10475),
    [sym_nil] = STATE(10475),
    [sym_chained_string] = STATE(669),
    [sym_string] = STATE(11296),
    [sym_subshell] = STATE(669),
    [sym_string_array] = STATE(669),
    [sym_symbol_array] = STATE(669),
    [sym_symbol] = STATE(669),
    [sym_regex] = STATE(669),
    [sym_array] = STATE(669),
    [sym_hash] = STATE(669),
    [sym_lambda] = STATE(669),
    [sym__simple_symbol2] = ACTIONS(1149),
    [sym__string_start2] = ACTIONS(1151),
    [sym__symbol_start2] = ACTIONS(1153),
    [sym__subshell_start2] = ACTIONS(1155),
    [sym__regex_start2] = ACTIONS(1157),
    [sym__string_array_start2] = ACTIONS(1159),
    [sym__symbol_array_start2] = ACTIONS(1161),
    [sym_heredoc_beginning2] = ACTIONS(1163),
    [sym__splat_star2] = ACTIONS(14532),
    [sym__unary_minus2] = ACTIONS(13677),
    [anon_sym_LBRACE] = ACTIONS(3394),
    [anon_sym_def] = ACTIONS(1175),
    [anon_sym_LPAREN] = ACTIONS(3396),
    [anon_sym_COLON_COLON] = ACTIONS(607),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(1179),
    [anon_sym_module] = ACTIONS(1181),
    [anon_sym_return] = ACTIONS(13681),
    [anon_sym_yield] = ACTIONS(13683),
    [anon_sym_break] = ACTIONS(13685),
    [anon_sym_next] = ACTIONS(13687),
    [sym_redo] = ACTIONS(1191),
    [sym_retry] = ACTIONS(1191),
    [anon_sym_if] = ACTIONS(1193),
    [anon_sym_unless] = ACTIONS(1195),
    [anon_sym_while] = ACTIONS(1197),
    [anon_sym_until] = ACTIONS(1199),
    [anon_sym_for] = ACTIONS(1201),
    [anon_sym_case] = ACTIONS(1205),
    [anon_sym_begin] = ACTIONS(1207),
    [anon_sym_PLUS] = ACTIONS(14572),
    [anon_sym_defined_QMARK] = ACTIONS(13689),
    [anon_sym_not] = ACTIONS(13691),
    [anon_sym_BANG] = ACTIONS(13695),
    [anon_sym_TILDE] = ACTIONS(13695),
    [sym_constant] = ACTIONS(13701),
    [sym_identifier] = ACTIONS(13701),
    [sym_instance_variable] = ACTIONS(13699),
    [sym_class_variable] = ACTIONS(13699),
    [sym_global_variable] = ACTIONS(13699),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(1223),
    [sym_float] = ACTIONS(1191),
    [sym_complex] = ACTIONS(1163),
    [sym_super] = ACTIONS(13701),
    [anon_sym_true] = ACTIONS(657),
    [anon_sym_TRUE] = ACTIONS(657),
    [anon_sym_false] = ACTIONS(659),
    [anon_sym_FALSE] = ACTIONS(659),
    [sym_self] = ACTIONS(13701),
    [anon_sym_nil] = ACTIONS(661),
    [anon_sym_NIL] = ACTIONS(661),
    [sym_character] = ACTIONS(1163),
    [anon_sym_LBRACK2] = ACTIONS(3400),
    [anon_sym_DASH_GT] = ACTIONS(1229),
  },
  [11862] = {
    [aux_sym_exceptions_repeat1] = STATE(11889),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15377),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_EQ_GT] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11863] = {
    [aux_sym_exceptions_repeat1] = STATE(11863),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_COMMA] = ACTIONS(15379),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11864] = {
    [sym__simple_symbol2] = ACTIONS(15382),
    [sym__string_start2] = ACTIONS(15382),
    [sym__symbol_start2] = ACTIONS(15382),
    [sym__subshell_start2] = ACTIONS(15382),
    [sym__regex_start2] = ACTIONS(15382),
    [sym__string_array_start2] = ACTIONS(15382),
    [sym__symbol_array_start2] = ACTIONS(15382),
    [sym_heredoc_beginning2] = ACTIONS(15382),
    [sym__unary_minus2] = ACTIONS(15382),
    [anon_sym_BEGIN] = ACTIONS(15384),
    [anon_sym_LBRACE] = ACTIONS(15382),
    [anon_sym_RBRACE] = ACTIONS(15382),
    [anon_sym_END] = ACTIONS(15384),
    [anon_sym_def] = ACTIONS(15384),
    [anon_sym_LPAREN] = ACTIONS(15382),
    [anon_sym_COLON_COLON] = ACTIONS(15382),
    [anon_sym_SEMI] = ACTIONS(15382),
    [anon_sym_STAR] = ACTIONS(15382),
    [anon_sym_class] = ACTIONS(15384),
    [anon_sym_module] = ACTIONS(15384),
    [anon_sym_return] = ACTIONS(15384),
    [anon_sym_yield] = ACTIONS(15384),
    [anon_sym_break] = ACTIONS(15384),
    [anon_sym_next] = ACTIONS(15384),
    [sym_redo] = ACTIONS(15384),
    [sym_retry] = ACTIONS(15384),
    [anon_sym_if] = ACTIONS(15384),
    [anon_sym_unless] = ACTIONS(15384),
    [anon_sym_while] = ACTIONS(15384),
    [anon_sym_until] = ACTIONS(15384),
    [anon_sym_for] = ACTIONS(15384),
    [anon_sym_case] = ACTIONS(15384),
    [anon_sym_begin] = ACTIONS(15384),
    [anon_sym_PLUS] = ACTIONS(15384),
    [anon_sym_defined_QMARK] = ACTIONS(15382),
    [anon_sym_not] = ACTIONS(15384),
    [anon_sym_BANG] = ACTIONS(15382),
    [anon_sym_TILDE] = ACTIONS(15382),
    [sym_constant] = ACTIONS(15384),
    [sym_identifier] = ACTIONS(15384),
    [sym_instance_variable] = ACTIONS(15382),
    [sym_class_variable] = ACTIONS(15382),
    [sym_global_variable] = ACTIONS(15382),
    [anon_sym_undef] = ACTIONS(15384),
    [anon_sym_alias] = ACTIONS(15384),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15384),
    [sym_float] = ACTIONS(15384),
    [sym_complex] = ACTIONS(15382),
    [sym_super] = ACTIONS(15384),
    [anon_sym_true] = ACTIONS(15384),
    [anon_sym_TRUE] = ACTIONS(15384),
    [anon_sym_false] = ACTIONS(15384),
    [anon_sym_FALSE] = ACTIONS(15384),
    [sym_self] = ACTIONS(15384),
    [anon_sym_nil] = ACTIONS(15384),
    [anon_sym_NIL] = ACTIONS(15384),
    [sym_character] = ACTIONS(15382),
    [anon_sym_LBRACK2] = ACTIONS(15382),
    [anon_sym_DASH_GT] = ACTIONS(15382),
  },
  [11865] = {
    [sym__line_break2] = ACTIONS(15382),
    [sym__simple_symbol2] = ACTIONS(15382),
    [sym__string_start2] = ACTIONS(15382),
    [sym__symbol_start2] = ACTIONS(15382),
    [sym__subshell_start2] = ACTIONS(15382),
    [sym__regex_start2] = ACTIONS(15382),
    [sym__string_array_start2] = ACTIONS(15382),
    [sym__symbol_array_start2] = ACTIONS(15382),
    [sym__heredoc_body_start2] = ACTIONS(15382),
    [sym_heredoc_beginning2] = ACTIONS(15382),
    [sym__unary_minus2] = ACTIONS(15382),
    [anon_sym_BEGIN] = ACTIONS(15384),
    [anon_sym_LBRACE] = ACTIONS(15382),
    [anon_sym_END] = ACTIONS(15384),
    [anon_sym_def] = ACTIONS(15384),
    [anon_sym_LPAREN] = ACTIONS(15382),
    [anon_sym_COLON_COLON] = ACTIONS(15382),
    [anon_sym_SEMI] = ACTIONS(15382),
    [anon_sym_STAR] = ACTIONS(15382),
    [anon_sym_class] = ACTIONS(15384),
    [anon_sym_module] = ACTIONS(15384),
    [anon_sym_end] = ACTIONS(15384),
    [anon_sym_return] = ACTIONS(15384),
    [anon_sym_yield] = ACTIONS(15384),
    [anon_sym_break] = ACTIONS(15384),
    [anon_sym_next] = ACTIONS(15384),
    [sym_redo] = ACTIONS(15384),
    [sym_retry] = ACTIONS(15384),
    [anon_sym_if] = ACTIONS(15384),
    [anon_sym_unless] = ACTIONS(15384),
    [anon_sym_while] = ACTIONS(15384),
    [anon_sym_until] = ACTIONS(15384),
    [anon_sym_for] = ACTIONS(15384),
    [anon_sym_case] = ACTIONS(15384),
    [anon_sym_begin] = ACTIONS(15384),
    [anon_sym_PLUS] = ACTIONS(15384),
    [anon_sym_defined_QMARK] = ACTIONS(15382),
    [anon_sym_not] = ACTIONS(15384),
    [anon_sym_BANG] = ACTIONS(15382),
    [anon_sym_TILDE] = ACTIONS(15382),
    [sym_constant] = ACTIONS(15384),
    [sym_identifier] = ACTIONS(15384),
    [sym_instance_variable] = ACTIONS(15382),
    [sym_class_variable] = ACTIONS(15382),
    [sym_global_variable] = ACTIONS(15382),
    [anon_sym_undef] = ACTIONS(15384),
    [anon_sym_alias] = ACTIONS(15384),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(15384),
    [sym_float] = ACTIONS(15384),
    [sym_complex] = ACTIONS(15382),
    [sym_super] = ACTIONS(15384),
    [anon_sym_true] = ACTIONS(15384),
    [anon_sym_TRUE] = ACTIONS(15384),
    [anon_sym_false] = ACTIONS(15384),
    [anon_sym_FALSE] = ACTIONS(15384),
    [sym_self] = ACTIONS(15384),
    [anon_sym_nil] = ACTIONS(15384),
    [anon_sym_NIL] = ACTIONS(15384),
    [sym_character] = ACTIONS(15382),
    [anon_sym_LBRACK2] = ACTIONS(15382),
    [anon_sym_DASH_GT] = ACTIONS(15382),
  },
  [11866] = {
    [sym__heredoc_body_start2] = ACTIONS(14122),
    [sym__binary_minus2] = ACTIONS(14122),
    [sym__binary_star2] = ACTIONS(14122),
    [anon_sym_LBRACE] = ACTIONS(14122),
    [anon_sym_RBRACE] = ACTIONS(14122),
    [anon_sym_RPAREN] = ACTIONS(14122),
    [anon_sym_DOT] = ACTIONS(14124),
    [anon_sym_COMMA] = ACTIONS(14122),
    [anon_sym_PIPE] = ACTIONS(14124),
    [anon_sym_SEMI] = ACTIONS(14122),
    [anon_sym_STAR_STAR] = ACTIONS(14124),
    [anon_sym_AMP] = ACTIONS(14124),
    [anon_sym_EQ] = ACTIONS(14124),
    [anon_sym_LT] = ACTIONS(14124),
    [anon_sym_if] = ACTIONS(14122),
    [anon_sym_unless] = ACTIONS(14122),
    [anon_sym_while] = ACTIONS(14122),
    [anon_sym_until] = ACTIONS(14122),
    [anon_sym_rescue] = ACTIONS(14122),
    [anon_sym_in] = ACTIONS(14122),
    [anon_sym_do] = ACTIONS(14122),
    [anon_sym_LBRACK] = ACTIONS(14122),
    [anon_sym_RBRACK] = ACTIONS(14122),
    [anon_sym_COLON_COLON2] = ACTIONS(14122),
    [anon_sym_AMP_DOT] = ACTIONS(14122),
    [anon_sym_PLUS_EQ] = ACTIONS(14122),
    [anon_sym_DASH_EQ] = ACTIONS(14122),
    [anon_sym_STAR_EQ] = ACTIONS(14122),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(14122),
    [anon_sym_SLASH_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_PIPE_EQ] = ACTIONS(14122),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(14122),
    [anon_sym_AMP_EQ] = ACTIONS(14122),
    [anon_sym_PERCENT_EQ] = ACTIONS(14122),
    [anon_sym_GT_GT_EQ] = ACTIONS(14122),
    [anon_sym_LT_LT_EQ] = ACTIONS(14122),
    [anon_sym_CARET_EQ] = ACTIONS(14122),
    [anon_sym_QMARK] = ACTIONS(14122),
    [anon_sym_COLON2] = ACTIONS(14124),
    [anon_sym_DOT_DOT] = ACTIONS(14124),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14122),
    [anon_sym_and] = ACTIONS(14122),
    [anon_sym_or] = ACTIONS(14122),
    [anon_sym_PIPE_PIPE] = ACTIONS(14124),
    [anon_sym_AMP_AMP] = ACTIONS(14124),
    [anon_sym_LT_LT] = ACTIONS(14124),
    [anon_sym_GT_GT] = ACTIONS(14124),
    [anon_sym_EQ_EQ] = ACTIONS(14124),
    [anon_sym_BANG_EQ] = ACTIONS(14122),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14122),
    [anon_sym_LT_EQ_GT] = ACTIONS(14122),
    [anon_sym_EQ_TILDE] = ACTIONS(14122),
    [anon_sym_BANG_TILDE] = ACTIONS(14122),
    [anon_sym_LT_EQ] = ACTIONS(14124),
    [anon_sym_GT] = ACTIONS(14124),
    [anon_sym_GT_EQ] = ACTIONS(14122),
    [anon_sym_CARET] = ACTIONS(14124),
    [anon_sym_PLUS] = ACTIONS(14124),
    [anon_sym_SLASH] = ACTIONS(14124),
    [anon_sym_PERCENT] = ACTIONS(14124),
    [sym_comment] = ACTIONS(87),
  },
  [11867] = {
    [sym_heredoc_body] = STATE(11867),
    [aux_sym_call_repeat1] = STATE(11867),
    [sym__line_break2] = ACTIONS(7888),
    [sym__heredoc_body_start2] = ACTIONS(7890),
    [sym__binary_minus2] = ACTIONS(7888),
    [sym__binary_star2] = ACTIONS(7888),
    [anon_sym_DOT] = ACTIONS(7893),
    [anon_sym_COMMA] = ACTIONS(7888),
    [anon_sym_PIPE] = ACTIONS(7893),
    [anon_sym_SEMI] = ACTIONS(7888),
    [anon_sym_STAR_STAR] = ACTIONS(7888),
    [anon_sym_AMP] = ACTIONS(7893),
    [anon_sym_LT] = ACTIONS(7893),
    [anon_sym_end] = ACTIONS(7888),
    [anon_sym_if] = ACTIONS(7888),
    [anon_sym_unless] = ACTIONS(7888),
    [anon_sym_while] = ACTIONS(7888),
    [anon_sym_until] = ACTIONS(7888),
    [anon_sym_rescue] = ACTIONS(7888),
    [anon_sym_when] = ACTIONS(7888),
    [anon_sym_else] = ACTIONS(7888),
    [anon_sym_LBRACK] = ACTIONS(7888),
    [anon_sym_COLON_COLON2] = ACTIONS(7888),
    [anon_sym_AMP_DOT] = ACTIONS(7888),
    [anon_sym_QMARK] = ACTIONS(7888),
    [anon_sym_DOT_DOT] = ACTIONS(7893),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7888),
    [anon_sym_and] = ACTIONS(7888),
    [anon_sym_or] = ACTIONS(7888),
    [anon_sym_PIPE_PIPE] = ACTIONS(7888),
    [anon_sym_AMP_AMP] = ACTIONS(7888),
    [anon_sym_LT_LT] = ACTIONS(7888),
    [anon_sym_GT_GT] = ACTIONS(7888),
    [anon_sym_EQ_EQ] = ACTIONS(7893),
    [anon_sym_BANG_EQ] = ACTIONS(7888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7888),
    [anon_sym_LT_EQ_GT] = ACTIONS(7888),
    [anon_sym_EQ_TILDE] = ACTIONS(7888),
    [anon_sym_BANG_TILDE] = ACTIONS(7888),
    [anon_sym_LT_EQ] = ACTIONS(7893),
    [anon_sym_GT] = ACTIONS(7893),
    [anon_sym_GT_EQ] = ACTIONS(7888),
    [anon_sym_CARET] = ACTIONS(7888),
    [anon_sym_PLUS] = ACTIONS(7888),
    [anon_sym_SLASH] = ACTIONS(7888),
    [anon_sym_PERCENT] = ACTIONS(7888),
    [sym_comment] = ACTIONS(87),
  },
  [11868] = {
    [sym_heredoc_body] = STATE(11867),
    [aux_sym_call_repeat1] = STATE(11867),
    [sym__line_break2] = ACTIONS(7903),
    [sym__heredoc_body_start2] = ACTIONS(1705),
    [sym__binary_minus2] = ACTIONS(7903),
    [sym__binary_star2] = ACTIONS(7903),
    [anon_sym_DOT] = ACTIONS(7905),
    [anon_sym_COMMA] = ACTIONS(7903),
    [anon_sym_PIPE] = ACTIONS(7905),
    [anon_sym_SEMI] = ACTIONS(7903),
    [anon_sym_STAR_STAR] = ACTIONS(7903),
    [anon_sym_AMP] = ACTIONS(7905),
    [anon_sym_LT] = ACTIONS(7905),
    [anon_sym_end] = ACTIONS(7903),
    [anon_sym_if] = ACTIONS(7903),
    [anon_sym_unless] = ACTIONS(7903),
    [anon_sym_while] = ACTIONS(7903),
    [anon_sym_until] = ACTIONS(7903),
    [anon_sym_rescue] = ACTIONS(7903),
    [anon_sym_when] = ACTIONS(7903),
    [anon_sym_else] = ACTIONS(7903),
    [anon_sym_LBRACK] = ACTIONS(7903),
    [anon_sym_COLON_COLON2] = ACTIONS(7903),
    [anon_sym_AMP_DOT] = ACTIONS(7903),
    [anon_sym_QMARK] = ACTIONS(7903),
    [anon_sym_DOT_DOT] = ACTIONS(7905),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(7903),
    [anon_sym_and] = ACTIONS(7903),
    [anon_sym_or] = ACTIONS(7903),
    [anon_sym_PIPE_PIPE] = ACTIONS(7903),
    [anon_sym_AMP_AMP] = ACTIONS(7903),
    [anon_sym_LT_LT] = ACTIONS(7903),
    [anon_sym_GT_GT] = ACTIONS(7903),
    [anon_sym_EQ_EQ] = ACTIONS(7905),
    [anon_sym_BANG_EQ] = ACTIONS(7903),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(7903),
    [anon_sym_LT_EQ_GT] = ACTIONS(7903),
    [anon_sym_EQ_TILDE] = ACTIONS(7903),
    [anon_sym_BANG_TILDE] = ACTIONS(7903),
    [anon_sym_LT_EQ] = ACTIONS(7905),
    [anon_sym_GT] = ACTIONS(7905),
    [anon_sym_GT_EQ] = ACTIONS(7903),
    [anon_sym_CARET] = ACTIONS(7903),
    [anon_sym_PLUS] = ACTIONS(7903),
    [anon_sym_SLASH] = ACTIONS(7903),
    [anon_sym_PERCENT] = ACTIONS(7903),
    [sym_comment] = ACTIONS(87),
  },
  [11869] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11890),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_assignment] = STATE(11890),
    [sym_operator_assignment] = STATE(11890),
    [sym_conditional] = STATE(11890),
    [sym_range] = STATE(11890),
    [sym_binary] = STATE(11890),
    [sym_unary] = STATE(11890),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11870] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11754),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(10993),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(10993),
    [sym_splat_argument] = STATE(7807),
    [sym_assignment] = STATE(11754),
    [sym_operator_assignment] = STATE(11754),
    [sym_conditional] = STATE(11754),
    [sym_range] = STATE(11754),
    [sym_binary] = STATE(11754),
    [sym_unary] = STATE(11754),
    [sym__arg_or_splat_arg] = STATE(7807),
    [sym_left_assignment_list] = STATE(10992),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(10993),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(10993),
    [sym_false] = STATE(10993),
    [sym_nil] = STATE(10993),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__splat_star2] = ACTIONS(13278),
    [sym__unary_minus2] = ACTIONS(14176),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14186),
    [anon_sym_defined_QMARK] = ACTIONS(14188),
    [anon_sym_not] = ACTIONS(14190),
    [anon_sym_BANG] = ACTIONS(14192),
    [anon_sym_TILDE] = ACTIONS(14192),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11871] = {
    [aux_sym_exceptions_repeat1] = STATE(11891),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15386),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_when] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11872] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14208),
    [sym__binary_star2] = ACTIONS(14210),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14212),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14214),
    [anon_sym_AMP] = ACTIONS(14216),
    [anon_sym_LT] = ACTIONS(14218),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14222),
    [anon_sym_DOT_DOT] = ACTIONS(14224),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14226),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14228),
    [anon_sym_AMP_AMP] = ACTIONS(14228),
    [anon_sym_LT_LT] = ACTIONS(14230),
    [anon_sym_GT_GT] = ACTIONS(14230),
    [anon_sym_EQ_EQ] = ACTIONS(14232),
    [anon_sym_BANG_EQ] = ACTIONS(14228),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14228),
    [anon_sym_LT_EQ_GT] = ACTIONS(14228),
    [anon_sym_EQ_TILDE] = ACTIONS(14228),
    [anon_sym_BANG_TILDE] = ACTIONS(14228),
    [anon_sym_LT_EQ] = ACTIONS(14218),
    [anon_sym_GT] = ACTIONS(14218),
    [anon_sym_GT_EQ] = ACTIONS(14234),
    [anon_sym_CARET] = ACTIONS(14236),
    [anon_sym_PLUS] = ACTIONS(14238),
    [anon_sym_SLASH] = ACTIONS(14214),
    [anon_sym_PERCENT] = ACTIONS(14214),
    [sym_comment] = ACTIONS(87),
  },
  [11873] = {
    [aux_sym_exceptions_repeat1] = STATE(11873),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15388),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11874] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11892),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_assignment] = STATE(11892),
    [sym_operator_assignment] = STATE(11892),
    [sym_conditional] = STATE(11892),
    [sym_range] = STATE(11892),
    [sym_binary] = STATE(11892),
    [sym_unary] = STATE(11892),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11875] = {
    [sym_method] = STATE(1563),
    [sym_singleton_method] = STATE(1563),
    [sym_class] = STATE(1563),
    [sym_singleton_class] = STATE(1563),
    [sym_module] = STATE(1563),
    [sym_return] = STATE(1563),
    [sym_yield] = STATE(1563),
    [sym_break] = STATE(1563),
    [sym_next] = STATE(1563),
    [sym_while] = STATE(1563),
    [sym_until] = STATE(1563),
    [sym_for] = STATE(1563),
    [sym_case] = STATE(1563),
    [sym_if] = STATE(1563),
    [sym_unless] = STATE(1563),
    [sym_begin] = STATE(1563),
    [sym__arg] = STATE(11786),
    [sym__primary] = STATE(1563),
    [sym_parenthesized_statements] = STATE(1563),
    [sym_element_reference] = STATE(11070),
    [sym_scope_resolution] = STATE(11068),
    [sym_call] = STATE(11068),
    [sym_method_call] = STATE(11070),
    [sym_splat_argument] = STATE(10588),
    [sym_assignment] = STATE(11786),
    [sym_operator_assignment] = STATE(11786),
    [sym_conditional] = STATE(11786),
    [sym_range] = STATE(11786),
    [sym_binary] = STATE(11786),
    [sym_unary] = STATE(11786),
    [sym__arg_or_splat_arg] = STATE(10588),
    [sym_left_assignment_list] = STATE(11069),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11070),
    [sym__variable] = STATE(11068),
    [sym_rational] = STATE(1563),
    [sym_true] = STATE(11070),
    [sym_false] = STATE(11070),
    [sym_nil] = STATE(11070),
    [sym_chained_string] = STATE(1563),
    [sym_string] = STATE(11071),
    [sym_subshell] = STATE(1563),
    [sym_string_array] = STATE(1563),
    [sym_symbol_array] = STATE(1563),
    [sym_symbol] = STATE(1563),
    [sym_regex] = STATE(1563),
    [sym_array] = STATE(1563),
    [sym_hash] = STATE(1563),
    [sym_lambda] = STATE(1563),
    [sym__simple_symbol2] = ACTIONS(2603),
    [sym__string_start2] = ACTIONS(2605),
    [sym__symbol_start2] = ACTIONS(2607),
    [sym__subshell_start2] = ACTIONS(2609),
    [sym__regex_start2] = ACTIONS(2611),
    [sym__string_array_start2] = ACTIONS(2613),
    [sym__symbol_array_start2] = ACTIONS(2615),
    [sym_heredoc_beginning2] = ACTIONS(2617),
    [sym__splat_star2] = ACTIONS(13356),
    [sym__unary_minus2] = ACTIONS(14262),
    [anon_sym_LBRACE] = ACTIONS(2621),
    [anon_sym_def] = ACTIONS(2623),
    [anon_sym_LPAREN] = ACTIONS(2625),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(2627),
    [anon_sym_module] = ACTIONS(2629),
    [anon_sym_return] = ACTIONS(14264),
    [anon_sym_yield] = ACTIONS(14266),
    [anon_sym_break] = ACTIONS(14268),
    [anon_sym_next] = ACTIONS(14270),
    [sym_redo] = ACTIONS(2639),
    [sym_retry] = ACTIONS(2639),
    [anon_sym_if] = ACTIONS(2641),
    [anon_sym_unless] = ACTIONS(2643),
    [anon_sym_while] = ACTIONS(2645),
    [anon_sym_until] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2649),
    [anon_sym_case] = ACTIONS(2651),
    [anon_sym_begin] = ACTIONS(2653),
    [anon_sym_PLUS] = ACTIONS(14272),
    [anon_sym_defined_QMARK] = ACTIONS(14274),
    [anon_sym_not] = ACTIONS(14276),
    [anon_sym_BANG] = ACTIONS(14278),
    [anon_sym_TILDE] = ACTIONS(14278),
    [sym_constant] = ACTIONS(14280),
    [sym_identifier] = ACTIONS(14280),
    [sym_instance_variable] = ACTIONS(14282),
    [sym_class_variable] = ACTIONS(14282),
    [sym_global_variable] = ACTIONS(14282),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2639),
    [sym_complex] = ACTIONS(2617),
    [sym_super] = ACTIONS(14280),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(14280),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(2617),
    [anon_sym_LBRACK2] = ACTIONS(2669),
    [anon_sym_DASH_GT] = ACTIONS(2671),
  },
  [11876] = {
    [aux_sym_exceptions_repeat1] = STATE(11893),
    [sym__line_break2] = ACTIONS(9929),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15391),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_end] = ACTIONS(9929),
    [anon_sym_if] = ACTIONS(9929),
    [anon_sym_unless] = ACTIONS(9929),
    [anon_sym_while] = ACTIONS(9929),
    [anon_sym_until] = ACTIONS(9929),
    [anon_sym_rescue] = ACTIONS(9929),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_when] = ACTIONS(9929),
    [anon_sym_else] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11877] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14290),
    [sym__binary_star2] = ACTIONS(14292),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14294),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14296),
    [anon_sym_AMP] = ACTIONS(14298),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(14300),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14304),
    [anon_sym_DOT_DOT] = ACTIONS(14306),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14308),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14310),
    [anon_sym_AMP_AMP] = ACTIONS(14310),
    [anon_sym_LT_LT] = ACTIONS(14312),
    [anon_sym_GT_GT] = ACTIONS(14312),
    [anon_sym_EQ_EQ] = ACTIONS(14310),
    [anon_sym_BANG_EQ] = ACTIONS(14314),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14314),
    [anon_sym_LT_EQ_GT] = ACTIONS(14314),
    [anon_sym_EQ_TILDE] = ACTIONS(14314),
    [anon_sym_BANG_TILDE] = ACTIONS(14314),
    [anon_sym_LT_EQ] = ACTIONS(14300),
    [anon_sym_GT] = ACTIONS(14300),
    [anon_sym_GT_EQ] = ACTIONS(14316),
    [anon_sym_CARET] = ACTIONS(14294),
    [anon_sym_PLUS] = ACTIONS(14318),
    [anon_sym_SLASH] = ACTIONS(14296),
    [anon_sym_PERCENT] = ACTIONS(14296),
    [sym_comment] = ACTIONS(87),
  },
  [11878] = {
    [aux_sym_exceptions_repeat1] = STATE(11878),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15393),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11879] = {
    [sym_method] = STATE(50),
    [sym_singleton_method] = STATE(50),
    [sym_class] = STATE(50),
    [sym_singleton_class] = STATE(50),
    [sym_module] = STATE(50),
    [sym_return] = STATE(50),
    [sym_yield] = STATE(50),
    [sym_break] = STATE(50),
    [sym_next] = STATE(50),
    [sym_while] = STATE(50),
    [sym_until] = STATE(50),
    [sym_for] = STATE(50),
    [sym_case] = STATE(50),
    [sym_if] = STATE(50),
    [sym_unless] = STATE(50),
    [sym_begin] = STATE(50),
    [sym__arg] = STATE(11894),
    [sym__primary] = STATE(50),
    [sym_parenthesized_statements] = STATE(50),
    [sym_element_reference] = STATE(11106),
    [sym_scope_resolution] = STATE(8349),
    [sym_call] = STATE(8349),
    [sym_method_call] = STATE(11106),
    [sym_assignment] = STATE(11894),
    [sym_operator_assignment] = STATE(11894),
    [sym_conditional] = STATE(11894),
    [sym_range] = STATE(11894),
    [sym_binary] = STATE(11894),
    [sym_unary] = STATE(11894),
    [sym_left_assignment_list] = STATE(11105),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11106),
    [sym__variable] = STATE(8349),
    [sym_rational] = STATE(50),
    [sym_true] = STATE(11106),
    [sym_false] = STATE(11106),
    [sym_nil] = STATE(11106),
    [sym_chained_string] = STATE(50),
    [sym_string] = STATE(10994),
    [sym_subshell] = STATE(50),
    [sym_string_array] = STATE(50),
    [sym_symbol_array] = STATE(50),
    [sym_symbol] = STATE(50),
    [sym_regex] = STATE(50),
    [sym_array] = STATE(50),
    [sym_hash] = STATE(50),
    [sym_lambda] = STATE(50),
    [sym__simple_symbol2] = ACTIONS(5),
    [sym__string_start2] = ACTIONS(7),
    [sym__symbol_start2] = ACTIONS(9),
    [sym__subshell_start2] = ACTIONS(11),
    [sym__regex_start2] = ACTIONS(13),
    [sym__string_array_start2] = ACTIONS(15),
    [sym__symbol_array_start2] = ACTIONS(17),
    [sym_heredoc_beginning2] = ACTIONS(19),
    [sym__unary_minus2] = ACTIONS(14332),
    [anon_sym_LBRACE] = ACTIONS(29),
    [anon_sym_def] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(35),
    [anon_sym_COLON_COLON] = ACTIONS(37),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(43),
    [anon_sym_module] = ACTIONS(45),
    [anon_sym_return] = ACTIONS(14178),
    [anon_sym_yield] = ACTIONS(14180),
    [anon_sym_break] = ACTIONS(14182),
    [anon_sym_next] = ACTIONS(14184),
    [sym_redo] = ACTIONS(55),
    [sym_retry] = ACTIONS(55),
    [anon_sym_if] = ACTIONS(57),
    [anon_sym_unless] = ACTIONS(59),
    [anon_sym_while] = ACTIONS(61),
    [anon_sym_until] = ACTIONS(63),
    [anon_sym_for] = ACTIONS(65),
    [anon_sym_case] = ACTIONS(67),
    [anon_sym_begin] = ACTIONS(69),
    [anon_sym_PLUS] = ACTIONS(14334),
    [anon_sym_defined_QMARK] = ACTIONS(14336),
    [anon_sym_not] = ACTIONS(14338),
    [anon_sym_BANG] = ACTIONS(14340),
    [anon_sym_TILDE] = ACTIONS(14340),
    [sym_constant] = ACTIONS(11454),
    [sym_identifier] = ACTIONS(11454),
    [sym_instance_variable] = ACTIONS(11456),
    [sym_class_variable] = ACTIONS(11456),
    [sym_global_variable] = ACTIONS(11456),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(89),
    [sym_float] = ACTIONS(55),
    [sym_complex] = ACTIONS(19),
    [sym_super] = ACTIONS(11454),
    [anon_sym_true] = ACTIONS(91),
    [anon_sym_TRUE] = ACTIONS(91),
    [anon_sym_false] = ACTIONS(93),
    [anon_sym_FALSE] = ACTIONS(93),
    [sym_self] = ACTIONS(11454),
    [anon_sym_nil] = ACTIONS(95),
    [anon_sym_NIL] = ACTIONS(95),
    [sym_character] = ACTIONS(19),
    [anon_sym_LBRACK2] = ACTIONS(97),
    [anon_sym_DASH_GT] = ACTIONS(99),
  },
  [11880] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11895),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_assignment] = STATE(11895),
    [sym_operator_assignment] = STATE(11895),
    [sym_conditional] = STATE(11895),
    [sym_range] = STATE(11895),
    [sym_binary] = STATE(11895),
    [sym_unary] = STATE(11895),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11881] = {
    [sym_method] = STATE(556),
    [sym_singleton_method] = STATE(556),
    [sym_class] = STATE(556),
    [sym_singleton_class] = STATE(556),
    [sym_module] = STATE(556),
    [sym_return] = STATE(556),
    [sym_yield] = STATE(556),
    [sym_break] = STATE(556),
    [sym_next] = STATE(556),
    [sym_while] = STATE(556),
    [sym_until] = STATE(556),
    [sym_for] = STATE(556),
    [sym_case] = STATE(556),
    [sym_if] = STATE(556),
    [sym_unless] = STATE(556),
    [sym_begin] = STATE(556),
    [sym__arg] = STATE(11824),
    [sym__primary] = STATE(556),
    [sym_parenthesized_statements] = STATE(556),
    [sym_element_reference] = STATE(11223),
    [sym_scope_resolution] = STATE(11221),
    [sym_call] = STATE(11221),
    [sym_method_call] = STATE(11223),
    [sym_splat_argument] = STATE(9425),
    [sym_assignment] = STATE(11824),
    [sym_operator_assignment] = STATE(11824),
    [sym_conditional] = STATE(11824),
    [sym_range] = STATE(11824),
    [sym_binary] = STATE(11824),
    [sym_unary] = STATE(11824),
    [sym__arg_or_splat_arg] = STATE(9425),
    [sym_left_assignment_list] = STATE(11222),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11223),
    [sym__variable] = STATE(11221),
    [sym_rational] = STATE(556),
    [sym_true] = STATE(11223),
    [sym_false] = STATE(11223),
    [sym_nil] = STATE(11223),
    [sym_chained_string] = STATE(556),
    [sym_string] = STATE(11224),
    [sym_subshell] = STATE(556),
    [sym_string_array] = STATE(556),
    [sym_symbol_array] = STATE(556),
    [sym_symbol] = STATE(556),
    [sym_regex] = STATE(556),
    [sym_array] = STATE(556),
    [sym_hash] = STATE(556),
    [sym_lambda] = STATE(556),
    [sym__simple_symbol2] = ACTIONS(577),
    [sym__string_start2] = ACTIONS(579),
    [sym__symbol_start2] = ACTIONS(581),
    [sym__subshell_start2] = ACTIONS(583),
    [sym__regex_start2] = ACTIONS(585),
    [sym__string_array_start2] = ACTIONS(587),
    [sym__symbol_array_start2] = ACTIONS(589),
    [sym_heredoc_beginning2] = ACTIONS(1009),
    [sym__splat_star2] = ACTIONS(13613),
    [sym__unary_minus2] = ACTIONS(14462),
    [anon_sym_LBRACE] = ACTIONS(601),
    [anon_sym_def] = ACTIONS(603),
    [anon_sym_LPAREN] = ACTIONS(605),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(611),
    [anon_sym_module] = ACTIONS(613),
    [anon_sym_return] = ACTIONS(14464),
    [anon_sym_yield] = ACTIONS(14466),
    [anon_sym_break] = ACTIONS(14468),
    [anon_sym_next] = ACTIONS(14470),
    [sym_redo] = ACTIONS(1023),
    [sym_retry] = ACTIONS(1023),
    [anon_sym_if] = ACTIONS(625),
    [anon_sym_unless] = ACTIONS(627),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_until] = ACTIONS(631),
    [anon_sym_for] = ACTIONS(633),
    [anon_sym_case] = ACTIONS(635),
    [anon_sym_begin] = ACTIONS(637),
    [anon_sym_PLUS] = ACTIONS(14472),
    [anon_sym_defined_QMARK] = ACTIONS(14474),
    [anon_sym_not] = ACTIONS(14476),
    [anon_sym_BANG] = ACTIONS(14478),
    [anon_sym_TILDE] = ACTIONS(14478),
    [sym_constant] = ACTIONS(14480),
    [sym_identifier] = ACTIONS(14480),
    [sym_instance_variable] = ACTIONS(14482),
    [sym_class_variable] = ACTIONS(14482),
    [sym_global_variable] = ACTIONS(14482),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(653),
    [sym_float] = ACTIONS(1023),
    [sym_complex] = ACTIONS(1009),
    [sym_super] = ACTIONS(14480),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14480),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(1009),
    [anon_sym_LBRACK2] = ACTIONS(663),
    [anon_sym_DASH_GT] = ACTIONS(665),
  },
  [11882] = {
    [aux_sym_exceptions_repeat1] = STATE(11896),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15396),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9929),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9929),
    [anon_sym_AMP_AMP] = ACTIONS(9929),
    [anon_sym_LT_LT] = ACTIONS(9929),
    [anon_sym_GT_GT] = ACTIONS(9929),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9929),
    [anon_sym_PLUS] = ACTIONS(9929),
    [anon_sym_SLASH] = ACTIONS(9929),
    [anon_sym_PERCENT] = ACTIONS(9929),
    [sym_comment] = ACTIONS(87),
  },
  [11883] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14498),
    [sym__binary_star2] = ACTIONS(14500),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14502),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14504),
    [anon_sym_AMP] = ACTIONS(14506),
    [anon_sym_LT] = ACTIONS(14508),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14512),
    [anon_sym_DOT_DOT] = ACTIONS(14514),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14516),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14518),
    [anon_sym_AMP_AMP] = ACTIONS(14518),
    [anon_sym_LT_LT] = ACTIONS(14520),
    [anon_sym_GT_GT] = ACTIONS(14520),
    [anon_sym_EQ_EQ] = ACTIONS(14522),
    [anon_sym_BANG_EQ] = ACTIONS(14518),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14518),
    [anon_sym_LT_EQ_GT] = ACTIONS(14518),
    [anon_sym_EQ_TILDE] = ACTIONS(14518),
    [anon_sym_BANG_TILDE] = ACTIONS(14518),
    [anon_sym_LT_EQ] = ACTIONS(14508),
    [anon_sym_GT] = ACTIONS(14508),
    [anon_sym_GT_EQ] = ACTIONS(14524),
    [anon_sym_CARET] = ACTIONS(14526),
    [anon_sym_PLUS] = ACTIONS(14528),
    [anon_sym_SLASH] = ACTIONS(14504),
    [anon_sym_PERCENT] = ACTIONS(14504),
    [sym_comment] = ACTIONS(87),
  },
  [11884] = {
    [aux_sym_exceptions_repeat1] = STATE(11884),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15398),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11885] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11897),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_assignment] = STATE(11897),
    [sym_operator_assignment] = STATE(11897),
    [sym_conditional] = STATE(11897),
    [sym_range] = STATE(11897),
    [sym_binary] = STATE(11897),
    [sym_unary] = STATE(11897),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11886] = {
    [sym_method] = STATE(4089),
    [sym_singleton_method] = STATE(4089),
    [sym_class] = STATE(4089),
    [sym_singleton_class] = STATE(4089),
    [sym_module] = STATE(4089),
    [sym_return] = STATE(4089),
    [sym_yield] = STATE(4089),
    [sym_break] = STATE(4089),
    [sym_next] = STATE(4089),
    [sym_while] = STATE(4089),
    [sym_until] = STATE(4089),
    [sym_for] = STATE(4089),
    [sym_case] = STATE(4089),
    [sym_if] = STATE(4089),
    [sym_unless] = STATE(4089),
    [sym_begin] = STATE(4089),
    [sym__arg] = STATE(11856),
    [sym__primary] = STATE(4089),
    [sym_parenthesized_statements] = STATE(4089),
    [sym_element_reference] = STATE(11292),
    [sym_scope_resolution] = STATE(11290),
    [sym_call] = STATE(11290),
    [sym_method_call] = STATE(11292),
    [sym_splat_argument] = STATE(11381),
    [sym_assignment] = STATE(11856),
    [sym_operator_assignment] = STATE(11856),
    [sym_conditional] = STATE(11856),
    [sym_range] = STATE(11856),
    [sym_binary] = STATE(11856),
    [sym_unary] = STATE(11856),
    [sym__arg_or_splat_arg] = STATE(11381),
    [sym_left_assignment_list] = STATE(11291),
    [sym__mlhs] = STATE(53),
    [sym__simple_mlhs] = STATE(54),
    [sym_destructured_left_assignment] = STATE(54),
    [sym_rest_assignment] = STATE(54),
    [sym__lhs] = STATE(11292),
    [sym__variable] = STATE(11290),
    [sym_rational] = STATE(4089),
    [sym_true] = STATE(11292),
    [sym_false] = STATE(11292),
    [sym_nil] = STATE(11292),
    [sym_chained_string] = STATE(4089),
    [sym_string] = STATE(11293),
    [sym_subshell] = STATE(4089),
    [sym_string_array] = STATE(4089),
    [sym_symbol_array] = STATE(4089),
    [sym_symbol] = STATE(4089),
    [sym_regex] = STATE(4089),
    [sym_array] = STATE(4089),
    [sym_hash] = STATE(4089),
    [sym_lambda] = STATE(4089),
    [sym__simple_symbol2] = ACTIONS(6367),
    [sym__string_start2] = ACTIONS(6369),
    [sym__symbol_start2] = ACTIONS(6371),
    [sym__subshell_start2] = ACTIONS(6373),
    [sym__regex_start2] = ACTIONS(6375),
    [sym__string_array_start2] = ACTIONS(6377),
    [sym__symbol_array_start2] = ACTIONS(6379),
    [sym_heredoc_beginning2] = ACTIONS(6381),
    [sym__splat_star2] = ACTIONS(13675),
    [sym__unary_minus2] = ACTIONS(14550),
    [anon_sym_LBRACE] = ACTIONS(6385),
    [anon_sym_def] = ACTIONS(6387),
    [anon_sym_LPAREN] = ACTIONS(6389),
    [anon_sym_COLON_COLON] = ACTIONS(1013),
    [anon_sym_STAR] = ACTIONS(41),
    [anon_sym_class] = ACTIONS(6391),
    [anon_sym_module] = ACTIONS(6393),
    [anon_sym_return] = ACTIONS(14552),
    [anon_sym_yield] = ACTIONS(14554),
    [anon_sym_break] = ACTIONS(14556),
    [anon_sym_next] = ACTIONS(14558),
    [sym_redo] = ACTIONS(6403),
    [sym_retry] = ACTIONS(6403),
    [anon_sym_if] = ACTIONS(6405),
    [anon_sym_unless] = ACTIONS(6407),
    [anon_sym_while] = ACTIONS(6409),
    [anon_sym_until] = ACTIONS(6411),
    [anon_sym_for] = ACTIONS(6413),
    [anon_sym_case] = ACTIONS(6415),
    [anon_sym_begin] = ACTIONS(6417),
    [anon_sym_PLUS] = ACTIONS(14560),
    [anon_sym_defined_QMARK] = ACTIONS(14562),
    [anon_sym_not] = ACTIONS(14564),
    [anon_sym_BANG] = ACTIONS(14566),
    [anon_sym_TILDE] = ACTIONS(14566),
    [sym_constant] = ACTIONS(14568),
    [sym_identifier] = ACTIONS(14568),
    [sym_instance_variable] = ACTIONS(14570),
    [sym_class_variable] = ACTIONS(14570),
    [sym_global_variable] = ACTIONS(14570),
    [sym_comment] = ACTIONS(87),
    [sym_integer] = ACTIONS(6431),
    [sym_float] = ACTIONS(6403),
    [sym_complex] = ACTIONS(6381),
    [sym_super] = ACTIONS(14568),
    [anon_sym_true] = ACTIONS(1037),
    [anon_sym_TRUE] = ACTIONS(1037),
    [anon_sym_false] = ACTIONS(1039),
    [anon_sym_FALSE] = ACTIONS(1039),
    [sym_self] = ACTIONS(14568),
    [anon_sym_nil] = ACTIONS(1041),
    [anon_sym_NIL] = ACTIONS(1041),
    [sym_character] = ACTIONS(6381),
    [anon_sym_LBRACK2] = ACTIONS(6433),
    [anon_sym_DASH_GT] = ACTIONS(6435),
  },
  [11887] = {
    [aux_sym_exceptions_repeat1] = STATE(11898),
    [sym__heredoc_body_start2] = ACTIONS(9929),
    [sym__binary_minus2] = ACTIONS(9929),
    [sym__binary_star2] = ACTIONS(9929),
    [anon_sym_LBRACE] = ACTIONS(9929),
    [anon_sym_DOT] = ACTIONS(9931),
    [anon_sym_COMMA] = ACTIONS(15401),
    [anon_sym_PIPE] = ACTIONS(9931),
    [anon_sym_SEMI] = ACTIONS(9929),
    [anon_sym_STAR_STAR] = ACTIONS(9931),
    [anon_sym_AMP] = ACTIONS(9931),
    [anon_sym_EQ] = ACTIONS(9931),
    [anon_sym_LT] = ACTIONS(9931),
    [anon_sym_do] = ACTIONS(9929),
    [anon_sym_LBRACK] = ACTIONS(9929),
    [anon_sym_COLON_COLON2] = ACTIONS(9929),
    [anon_sym_AMP_DOT] = ACTIONS(9929),
    [anon_sym_PLUS_EQ] = ACTIONS(9929),
    [anon_sym_DASH_EQ] = ACTIONS(9929),
    [anon_sym_STAR_EQ] = ACTIONS(9929),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(9929),
    [anon_sym_SLASH_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_PIPE_EQ] = ACTIONS(9929),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(9929),
    [anon_sym_AMP_EQ] = ACTIONS(9929),
    [anon_sym_PERCENT_EQ] = ACTIONS(9929),
    [anon_sym_GT_GT_EQ] = ACTIONS(9929),
    [anon_sym_LT_LT_EQ] = ACTIONS(9929),
    [anon_sym_CARET_EQ] = ACTIONS(9929),
    [anon_sym_QMARK] = ACTIONS(9929),
    [anon_sym_DOT_DOT] = ACTIONS(9931),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(9929),
    [anon_sym_and] = ACTIONS(9929),
    [anon_sym_or] = ACTIONS(9929),
    [anon_sym_PIPE_PIPE] = ACTIONS(9931),
    [anon_sym_AMP_AMP] = ACTIONS(9931),
    [anon_sym_LT_LT] = ACTIONS(9931),
    [anon_sym_GT_GT] = ACTIONS(9931),
    [anon_sym_EQ_EQ] = ACTIONS(9931),
    [anon_sym_BANG_EQ] = ACTIONS(9929),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(9929),
    [anon_sym_LT_EQ_GT] = ACTIONS(9929),
    [anon_sym_EQ_TILDE] = ACTIONS(9929),
    [anon_sym_BANG_TILDE] = ACTIONS(9929),
    [anon_sym_LT_EQ] = ACTIONS(9931),
    [anon_sym_GT] = ACTIONS(9931),
    [anon_sym_GT_EQ] = ACTIONS(9929),
    [anon_sym_CARET] = ACTIONS(9931),
    [anon_sym_PLUS] = ACTIONS(9931),
    [anon_sym_SLASH] = ACTIONS(9931),
    [anon_sym_PERCENT] = ACTIONS(9931),
    [sym_comment] = ACTIONS(87),
  },
  [11888] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14578),
    [sym__binary_star2] = ACTIONS(14580),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14582),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14584),
    [anon_sym_AMP] = ACTIONS(14586),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(14588),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_EQ_GT] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14592),
    [anon_sym_DOT_DOT] = ACTIONS(14594),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14596),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14598),
    [anon_sym_AMP_AMP] = ACTIONS(14598),
    [anon_sym_LT_LT] = ACTIONS(14600),
    [anon_sym_GT_GT] = ACTIONS(14600),
    [anon_sym_EQ_EQ] = ACTIONS(14598),
    [anon_sym_BANG_EQ] = ACTIONS(14602),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14602),
    [anon_sym_LT_EQ_GT] = ACTIONS(14602),
    [anon_sym_EQ_TILDE] = ACTIONS(14602),
    [anon_sym_BANG_TILDE] = ACTIONS(14602),
    [anon_sym_LT_EQ] = ACTIONS(14588),
    [anon_sym_GT] = ACTIONS(14588),
    [anon_sym_GT_EQ] = ACTIONS(14604),
    [anon_sym_CARET] = ACTIONS(14582),
    [anon_sym_PLUS] = ACTIONS(14606),
    [anon_sym_SLASH] = ACTIONS(14584),
    [anon_sym_PERCENT] = ACTIONS(14584),
    [sym_comment] = ACTIONS(87),
  },
  [11889] = {
    [aux_sym_exceptions_repeat1] = STATE(11889),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15403),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_EQ_GT] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11890] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14870),
    [sym__binary_star2] = ACTIONS(14872),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14874),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14876),
    [anon_sym_AMP] = ACTIONS(14878),
    [anon_sym_LT] = ACTIONS(14880),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14882),
    [anon_sym_DOT_DOT] = ACTIONS(14884),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14886),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14888),
    [anon_sym_AMP_AMP] = ACTIONS(14888),
    [anon_sym_LT_LT] = ACTIONS(14890),
    [anon_sym_GT_GT] = ACTIONS(14890),
    [anon_sym_EQ_EQ] = ACTIONS(14892),
    [anon_sym_BANG_EQ] = ACTIONS(14888),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14888),
    [anon_sym_LT_EQ_GT] = ACTIONS(14888),
    [anon_sym_EQ_TILDE] = ACTIONS(14888),
    [anon_sym_BANG_TILDE] = ACTIONS(14888),
    [anon_sym_LT_EQ] = ACTIONS(14880),
    [anon_sym_GT] = ACTIONS(14880),
    [anon_sym_GT_EQ] = ACTIONS(14894),
    [anon_sym_CARET] = ACTIONS(14896),
    [anon_sym_PLUS] = ACTIONS(14898),
    [anon_sym_SLASH] = ACTIONS(14876),
    [anon_sym_PERCENT] = ACTIONS(14876),
    [sym_comment] = ACTIONS(87),
  },
  [11891] = {
    [aux_sym_exceptions_repeat1] = STATE(11891),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15406),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11892] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14929),
    [sym__binary_star2] = ACTIONS(14931),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14933),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14935),
    [anon_sym_AMP] = ACTIONS(14937),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(14939),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14941),
    [anon_sym_DOT_DOT] = ACTIONS(14943),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14945),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14947),
    [anon_sym_AMP_AMP] = ACTIONS(14947),
    [anon_sym_LT_LT] = ACTIONS(14949),
    [anon_sym_GT_GT] = ACTIONS(14949),
    [anon_sym_EQ_EQ] = ACTIONS(14947),
    [anon_sym_BANG_EQ] = ACTIONS(14951),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14951),
    [anon_sym_LT_EQ_GT] = ACTIONS(14951),
    [anon_sym_EQ_TILDE] = ACTIONS(14951),
    [anon_sym_BANG_TILDE] = ACTIONS(14951),
    [anon_sym_LT_EQ] = ACTIONS(14939),
    [anon_sym_GT] = ACTIONS(14939),
    [anon_sym_GT_EQ] = ACTIONS(14953),
    [anon_sym_CARET] = ACTIONS(14933),
    [anon_sym_PLUS] = ACTIONS(14955),
    [anon_sym_SLASH] = ACTIONS(14935),
    [anon_sym_PERCENT] = ACTIONS(14935),
    [sym_comment] = ACTIONS(87),
  },
  [11893] = {
    [aux_sym_exceptions_repeat1] = STATE(11893),
    [sym__line_break2] = ACTIONS(11607),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15409),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_end] = ACTIONS(11607),
    [anon_sym_if] = ACTIONS(11607),
    [anon_sym_unless] = ACTIONS(11607),
    [anon_sym_while] = ACTIONS(11607),
    [anon_sym_until] = ACTIONS(11607),
    [anon_sym_rescue] = ACTIONS(11607),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_when] = ACTIONS(11607),
    [anon_sym_else] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
  [11894] = {
    [sym__line_break2] = ACTIONS(12166),
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(14965),
    [sym__binary_star2] = ACTIONS(14967),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(14969),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(14971),
    [anon_sym_AMP] = ACTIONS(14973),
    [anon_sym_LT] = ACTIONS(14975),
    [anon_sym_end] = ACTIONS(12166),
    [anon_sym_if] = ACTIONS(12166),
    [anon_sym_unless] = ACTIONS(12166),
    [anon_sym_while] = ACTIONS(12166),
    [anon_sym_until] = ACTIONS(12166),
    [anon_sym_rescue] = ACTIONS(12166),
    [anon_sym_when] = ACTIONS(12166),
    [anon_sym_else] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(14977),
    [anon_sym_DOT_DOT] = ACTIONS(14979),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(14981),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(14983),
    [anon_sym_AMP_AMP] = ACTIONS(14983),
    [anon_sym_LT_LT] = ACTIONS(14985),
    [anon_sym_GT_GT] = ACTIONS(14985),
    [anon_sym_EQ_EQ] = ACTIONS(14987),
    [anon_sym_BANG_EQ] = ACTIONS(14983),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(14983),
    [anon_sym_LT_EQ_GT] = ACTIONS(14983),
    [anon_sym_EQ_TILDE] = ACTIONS(14983),
    [anon_sym_BANG_TILDE] = ACTIONS(14983),
    [anon_sym_LT_EQ] = ACTIONS(14975),
    [anon_sym_GT] = ACTIONS(14975),
    [anon_sym_GT_EQ] = ACTIONS(14989),
    [anon_sym_CARET] = ACTIONS(14991),
    [anon_sym_PLUS] = ACTIONS(14993),
    [anon_sym_SLASH] = ACTIONS(14971),
    [anon_sym_PERCENT] = ACTIONS(14971),
    [sym_comment] = ACTIONS(87),
  },
  [11895] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(15061),
    [sym__binary_star2] = ACTIONS(15063),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(15065),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(15067),
    [anon_sym_AMP] = ACTIONS(15069),
    [anon_sym_LT] = ACTIONS(15071),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(15073),
    [anon_sym_DOT_DOT] = ACTIONS(15075),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15077),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(15079),
    [anon_sym_AMP_AMP] = ACTIONS(15079),
    [anon_sym_LT_LT] = ACTIONS(15081),
    [anon_sym_GT_GT] = ACTIONS(15081),
    [anon_sym_EQ_EQ] = ACTIONS(15083),
    [anon_sym_BANG_EQ] = ACTIONS(15079),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15079),
    [anon_sym_LT_EQ_GT] = ACTIONS(15079),
    [anon_sym_EQ_TILDE] = ACTIONS(15079),
    [anon_sym_BANG_TILDE] = ACTIONS(15079),
    [anon_sym_LT_EQ] = ACTIONS(15071),
    [anon_sym_GT] = ACTIONS(15071),
    [anon_sym_GT_EQ] = ACTIONS(15085),
    [anon_sym_CARET] = ACTIONS(15087),
    [anon_sym_PLUS] = ACTIONS(15089),
    [anon_sym_SLASH] = ACTIONS(15067),
    [anon_sym_PERCENT] = ACTIONS(15067),
    [sym_comment] = ACTIONS(87),
  },
  [11896] = {
    [aux_sym_exceptions_repeat1] = STATE(11896),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15412),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(11607),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(11607),
    [anon_sym_AMP_AMP] = ACTIONS(11607),
    [anon_sym_LT_LT] = ACTIONS(11607),
    [anon_sym_GT_GT] = ACTIONS(11607),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(11607),
    [anon_sym_PLUS] = ACTIONS(11607),
    [anon_sym_SLASH] = ACTIONS(11607),
    [anon_sym_PERCENT] = ACTIONS(11607),
    [sym_comment] = ACTIONS(87),
  },
  [11897] = {
    [sym__heredoc_body_start2] = ACTIONS(12166),
    [sym__binary_minus2] = ACTIONS(15117),
    [sym__binary_star2] = ACTIONS(15119),
    [anon_sym_LBRACE] = ACTIONS(12166),
    [anon_sym_DOT] = ACTIONS(12839),
    [anon_sym_COMMA] = ACTIONS(12166),
    [anon_sym_PIPE] = ACTIONS(15121),
    [anon_sym_SEMI] = ACTIONS(12166),
    [anon_sym_STAR_STAR] = ACTIONS(15123),
    [anon_sym_AMP] = ACTIONS(15125),
    [anon_sym_EQ] = ACTIONS(12839),
    [anon_sym_LT] = ACTIONS(15127),
    [anon_sym_do] = ACTIONS(12166),
    [anon_sym_LBRACK] = ACTIONS(12166),
    [anon_sym_COLON_COLON2] = ACTIONS(12166),
    [anon_sym_AMP_DOT] = ACTIONS(12166),
    [anon_sym_PLUS_EQ] = ACTIONS(12166),
    [anon_sym_DASH_EQ] = ACTIONS(12166),
    [anon_sym_STAR_EQ] = ACTIONS(12166),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(12166),
    [anon_sym_SLASH_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_PIPE_EQ] = ACTIONS(12166),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(12166),
    [anon_sym_AMP_EQ] = ACTIONS(12166),
    [anon_sym_PERCENT_EQ] = ACTIONS(12166),
    [anon_sym_GT_GT_EQ] = ACTIONS(12166),
    [anon_sym_LT_LT_EQ] = ACTIONS(12166),
    [anon_sym_CARET_EQ] = ACTIONS(12166),
    [anon_sym_QMARK] = ACTIONS(15129),
    [anon_sym_DOT_DOT] = ACTIONS(15131),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(15133),
    [anon_sym_and] = ACTIONS(12166),
    [anon_sym_or] = ACTIONS(12166),
    [anon_sym_PIPE_PIPE] = ACTIONS(15135),
    [anon_sym_AMP_AMP] = ACTIONS(15135),
    [anon_sym_LT_LT] = ACTIONS(15137),
    [anon_sym_GT_GT] = ACTIONS(15137),
    [anon_sym_EQ_EQ] = ACTIONS(15135),
    [anon_sym_BANG_EQ] = ACTIONS(15139),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(15139),
    [anon_sym_LT_EQ_GT] = ACTIONS(15139),
    [anon_sym_EQ_TILDE] = ACTIONS(15139),
    [anon_sym_BANG_TILDE] = ACTIONS(15139),
    [anon_sym_LT_EQ] = ACTIONS(15127),
    [anon_sym_GT] = ACTIONS(15127),
    [anon_sym_GT_EQ] = ACTIONS(15141),
    [anon_sym_CARET] = ACTIONS(15121),
    [anon_sym_PLUS] = ACTIONS(15143),
    [anon_sym_SLASH] = ACTIONS(15123),
    [anon_sym_PERCENT] = ACTIONS(15123),
    [sym_comment] = ACTIONS(87),
  },
  [11898] = {
    [aux_sym_exceptions_repeat1] = STATE(11898),
    [sym__heredoc_body_start2] = ACTIONS(11607),
    [sym__binary_minus2] = ACTIONS(11607),
    [sym__binary_star2] = ACTIONS(11607),
    [anon_sym_LBRACE] = ACTIONS(11607),
    [anon_sym_DOT] = ACTIONS(12400),
    [anon_sym_COMMA] = ACTIONS(15415),
    [anon_sym_PIPE] = ACTIONS(12400),
    [anon_sym_SEMI] = ACTIONS(11607),
    [anon_sym_STAR_STAR] = ACTIONS(12400),
    [anon_sym_AMP] = ACTIONS(12400),
    [anon_sym_EQ] = ACTIONS(12400),
    [anon_sym_LT] = ACTIONS(12400),
    [anon_sym_do] = ACTIONS(11607),
    [anon_sym_LBRACK] = ACTIONS(11607),
    [anon_sym_COLON_COLON2] = ACTIONS(11607),
    [anon_sym_AMP_DOT] = ACTIONS(11607),
    [anon_sym_PLUS_EQ] = ACTIONS(11607),
    [anon_sym_DASH_EQ] = ACTIONS(11607),
    [anon_sym_STAR_EQ] = ACTIONS(11607),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(11607),
    [anon_sym_SLASH_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_PIPE_EQ] = ACTIONS(11607),
    [anon_sym_AMP_AMP_EQ] = ACTIONS(11607),
    [anon_sym_AMP_EQ] = ACTIONS(11607),
    [anon_sym_PERCENT_EQ] = ACTIONS(11607),
    [anon_sym_GT_GT_EQ] = ACTIONS(11607),
    [anon_sym_LT_LT_EQ] = ACTIONS(11607),
    [anon_sym_CARET_EQ] = ACTIONS(11607),
    [anon_sym_QMARK] = ACTIONS(11607),
    [anon_sym_DOT_DOT] = ACTIONS(12400),
    [anon_sym_DOT_DOT_DOT] = ACTIONS(11607),
    [anon_sym_and] = ACTIONS(11607),
    [anon_sym_or] = ACTIONS(11607),
    [anon_sym_PIPE_PIPE] = ACTIONS(12400),
    [anon_sym_AMP_AMP] = ACTIONS(12400),
    [anon_sym_LT_LT] = ACTIONS(12400),
    [anon_sym_GT_GT] = ACTIONS(12400),
    [anon_sym_EQ_EQ] = ACTIONS(12400),
    [anon_sym_BANG_EQ] = ACTIONS(11607),
    [anon_sym_EQ_EQ_EQ] = ACTIONS(11607),
    [anon_sym_LT_EQ_GT] = ACTIONS(11607),
    [anon_sym_EQ_TILDE] = ACTIONS(11607),
    [anon_sym_BANG_TILDE] = ACTIONS(11607),
    [anon_sym_LT_EQ] = ACTIONS(12400),
    [anon_sym_GT] = ACTIONS(12400),
    [anon_sym_GT_EQ] = ACTIONS(11607),
    [anon_sym_CARET] = ACTIONS(12400),
    [anon_sym_PLUS] = ACTIONS(12400),
    [anon_sym_SLASH] = ACTIONS(12400),
    [anon_sym_PERCENT] = ACTIONS(12400),
    [sym_comment] = ACTIONS(87),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, SHIFT(4),
  [11] = {.count = 1, .reusable = true}, SHIFT(5),
  [13] = {.count = 1, .reusable = true}, SHIFT(6),
  [15] = {.count = 1, .reusable = true}, SHIFT(7),
  [17] = {.count = 1, .reusable = true}, SHIFT(8),
  [19] = {.count = 1, .reusable = true}, SHIFT(50),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = true}, REDUCE(sym_program, 0),
  [25] = {.count = 1, .reusable = false}, SHIFT(10),
  [27] = {.count = 1, .reusable = false}, SHIFT(11),
  [29] = {.count = 1, .reusable = true}, SHIFT(12),
  [31] = {.count = 1, .reusable = false}, SHIFT(13),
  [33] = {.count = 1, .reusable = false}, SHIFT(14),
  [35] = {.count = 1, .reusable = true}, SHIFT(15),
  [37] = {.count = 1, .reusable = true}, SHIFT(16),
  [39] = {.count = 1, .reusable = true}, SHIFT(17),
  [41] = {.count = 1, .reusable = true}, SHIFT(18),
  [43] = {.count = 1, .reusable = false}, SHIFT(19),
  [45] = {.count = 1, .reusable = false}, SHIFT(20),
  [47] = {.count = 1, .reusable = false}, SHIFT(21),
  [49] = {.count = 1, .reusable = false}, SHIFT(22),
  [51] = {.count = 1, .reusable = false}, SHIFT(23),
  [53] = {.count = 1, .reusable = false}, SHIFT(24),
  [55] = {.count = 1, .reusable = false}, SHIFT(50),
  [57] = {.count = 1, .reusable = false}, SHIFT(25),
  [59] = {.count = 1, .reusable = false}, SHIFT(26),
  [61] = {.count = 1, .reusable = false}, SHIFT(27),
  [63] = {.count = 1, .reusable = false}, SHIFT(28),
  [65] = {.count = 1, .reusable = false}, SHIFT(29),
  [67] = {.count = 1, .reusable = false}, SHIFT(30),
  [69] = {.count = 1, .reusable = false}, SHIFT(31),
  [71] = {.count = 1, .reusable = false}, SHIFT(32),
  [73] = {.count = 1, .reusable = true}, SHIFT(33),
  [75] = {.count = 1, .reusable = false}, SHIFT(33),
  [77] = {.count = 1, .reusable = true}, SHIFT(34),
  [79] = {.count = 1, .reusable = false}, SHIFT(51),
  [81] = {.count = 1, .reusable = true}, SHIFT(51),
  [83] = {.count = 1, .reusable = false}, SHIFT(35),
  [85] = {.count = 1, .reusable = false}, SHIFT(36),
  [87] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [89] = {.count = 1, .reusable = false}, SHIFT(37),
  [91] = {.count = 1, .reusable = false}, SHIFT(38),
  [93] = {.count = 1, .reusable = false}, SHIFT(39),
  [95] = {.count = 1, .reusable = false}, SHIFT(40),
  [97] = {.count = 1, .reusable = true}, SHIFT(41),
  [99] = {.count = 1, .reusable = true}, SHIFT(42),
  [101] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 1),
  [103] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 1),
  [105] = {.count = 1, .reusable = true}, SHIFT(60),
  [107] = {.count = 1, .reusable = true}, SHIFT(57),
  [109] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [111] = {.count = 1, .reusable = false}, SHIFT(58),
  [113] = {.count = 1, .reusable = true}, SHIFT(61),
  [115] = {.count = 1, .reusable = true}, SHIFT(63),
  [117] = {.count = 1, .reusable = true}, SHIFT(65),
  [119] = {.count = 1, .reusable = true}, SHIFT(71),
  [121] = {.count = 1, .reusable = true}, SHIFT(67),
  [123] = {.count = 1, .reusable = false}, SHIFT(68),
  [125] = {.count = 1, .reusable = false}, SHIFT(69),
  [127] = {.count = 1, .reusable = false}, SHIFT(71),
  [129] = {.count = 1, .reusable = true}, SHIFT(72),
  [131] = {.count = 1, .reusable = false}, SHIFT(73),
  [133] = {.count = 1, .reusable = true}, SHIFT(76),
  [135] = {.count = 1, .reusable = true}, SHIFT(77),
  [137] = {.count = 1, .reusable = true}, SHIFT(78),
  [139] = {.count = 1, .reusable = true}, SHIFT(79),
  [141] = {.count = 1, .reusable = true}, SHIFT(80),
  [143] = {.count = 1, .reusable = true}, SHIFT(81),
  [145] = {.count = 1, .reusable = true}, SHIFT(82),
  [147] = {.count = 1, .reusable = true}, SHIFT(83),
  [149] = {.count = 1, .reusable = true}, SHIFT(84),
  [151] = {.count = 1, .reusable = true}, SHIFT(85),
  [153] = {.count = 1, .reusable = true}, SHIFT(118),
  [155] = {.count = 1, .reusable = true}, SHIFT(86),
  [157] = {.count = 1, .reusable = true}, SHIFT(87),
  [159] = {.count = 1, .reusable = true}, SHIFT(88),
  [161] = {.count = 1, .reusable = true}, SHIFT(89),
  [163] = {.count = 1, .reusable = false}, SHIFT(90),
  [165] = {.count = 1, .reusable = true}, SHIFT(91),
  [167] = {.count = 1, .reusable = true}, SHIFT(92),
  [169] = {.count = 1, .reusable = false}, SHIFT(18),
  [171] = {.count = 1, .reusable = true}, SHIFT(93),
  [173] = {.count = 1, .reusable = false}, SHIFT(94),
  [175] = {.count = 1, .reusable = false}, SHIFT(95),
  [177] = {.count = 1, .reusable = false}, SHIFT(96),
  [179] = {.count = 1, .reusable = false}, SHIFT(97),
  [181] = {.count = 1, .reusable = false}, SHIFT(98),
  [183] = {.count = 1, .reusable = false}, SHIFT(99),
  [185] = {.count = 1, .reusable = false}, SHIFT(118),
  [187] = {.count = 1, .reusable = false}, SHIFT(100),
  [189] = {.count = 1, .reusable = false}, SHIFT(101),
  [191] = {.count = 1, .reusable = false}, SHIFT(102),
  [193] = {.count = 1, .reusable = false}, SHIFT(103),
  [195] = {.count = 1, .reusable = false}, SHIFT(104),
  [197] = {.count = 1, .reusable = false}, SHIFT(105),
  [199] = {.count = 1, .reusable = false}, SHIFT(106),
  [201] = {.count = 1, .reusable = false}, SHIFT(107),
  [203] = {.count = 1, .reusable = true}, SHIFT(108),
  [205] = {.count = 1, .reusable = false}, SHIFT(108),
  [207] = {.count = 1, .reusable = true}, SHIFT(109),
  [209] = {.count = 1, .reusable = false}, SHIFT(110),
  [211] = {.count = 1, .reusable = true}, SHIFT(119),
  [213] = {.count = 1, .reusable = false}, SHIFT(111),
  [215] = {.count = 1, .reusable = false}, SHIFT(119),
  [217] = {.count = 1, .reusable = false}, SHIFT(112),
  [219] = {.count = 1, .reusable = false}, SHIFT(113),
  [221] = {.count = 1, .reusable = false}, SHIFT(114),
  [223] = {.count = 1, .reusable = true}, SHIFT(115),
  [225] = {.count = 1, .reusable = true}, SHIFT(116),
  [227] = {.count = 1, .reusable = true}, SHIFT(127),
  [229] = {.count = 1, .reusable = true}, SHIFT(128),
  [231] = {.count = 1, .reusable = true}, SHIFT(129),
  [233] = {.count = 1, .reusable = true}, SHIFT(130),
  [235] = {.count = 1, .reusable = true}, SHIFT(131),
  [237] = {.count = 1, .reusable = false}, SHIFT(131),
  [239] = {.count = 1, .reusable = true}, SHIFT(132),
  [241] = {.count = 1, .reusable = false}, SHIFT(133),
  [243] = {.count = 1, .reusable = false}, SHIFT(135),
  [245] = {.count = 1, .reusable = true}, SHIFT(137),
  [247] = {.count = 1, .reusable = true}, SHIFT(138),
  [249] = {.count = 1, .reusable = true}, SHIFT(139),
  [251] = {.count = 1, .reusable = false}, SHIFT(140),
  [253] = {.count = 1, .reusable = false}, SHIFT(141),
  [255] = {.count = 1, .reusable = false}, SHIFT(142),
  [257] = {.count = 1, .reusable = false}, SHIFT(143),
  [259] = {.count = 1, .reusable = false}, SHIFT(144),
  [261] = {.count = 1, .reusable = true}, SHIFT(145),
  [263] = {.count = 1, .reusable = false}, SHIFT(145),
  [265] = {.count = 1, .reusable = true}, SHIFT(146),
  [267] = {.count = 1, .reusable = false}, SHIFT(152),
  [269] = {.count = 1, .reusable = true}, SHIFT(152),
  [271] = {.count = 1, .reusable = false}, SHIFT(147),
  [273] = {.count = 1, .reusable = true}, SHIFT(158),
  [275] = {.count = 1, .reusable = true}, REDUCE(sym_empty_statement, 1),
  [277] = {.count = 1, .reusable = true}, SHIFT(159),
  [279] = {.count = 1, .reusable = true}, SHIFT(160),
  [281] = {.count = 1, .reusable = true}, SHIFT(161),
  [283] = {.count = 1, .reusable = true}, SHIFT(162),
  [285] = {.count = 1, .reusable = true}, SHIFT(163),
  [287] = {.count = 1, .reusable = true}, SHIFT(164),
  [289] = {.count = 1, .reusable = true}, SHIFT(165),
  [291] = {.count = 1, .reusable = true}, SHIFT(189),
  [293] = {.count = 1, .reusable = true}, SHIFT(166),
  [295] = {.count = 1, .reusable = false}, SHIFT(167),
  [297] = {.count = 1, .reusable = true}, SHIFT(168),
  [299] = {.count = 1, .reusable = true}, SHIFT(169),
  [301] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 1),
  [303] = {.count = 1, .reusable = false}, SHIFT(170),
  [305] = {.count = 1, .reusable = false}, SHIFT(171),
  [307] = {.count = 1, .reusable = false}, SHIFT(172),
  [309] = {.count = 1, .reusable = false}, SHIFT(173),
  [311] = {.count = 1, .reusable = false}, SHIFT(174),
  [313] = {.count = 1, .reusable = false}, SHIFT(175),
  [315] = {.count = 1, .reusable = false}, SHIFT(189),
  [317] = {.count = 1, .reusable = false}, SHIFT(176),
  [319] = {.count = 1, .reusable = false}, SHIFT(177),
  [321] = {.count = 1, .reusable = false}, SHIFT(178),
  [323] = {.count = 1, .reusable = false}, SHIFT(179),
  [325] = {.count = 1, .reusable = false}, SHIFT(180),
  [327] = {.count = 1, .reusable = false}, SHIFT(181),
  [329] = {.count = 1, .reusable = false}, SHIFT(182),
  [331] = {.count = 1, .reusable = false}, SHIFT(190),
  [333] = {.count = 1, .reusable = true}, SHIFT(190),
  [335] = {.count = 1, .reusable = false}, SHIFT(183),
  [337] = {.count = 1, .reusable = false}, SHIFT(184),
  [339] = {.count = 1, .reusable = false}, SHIFT(185),
  [341] = {.count = 1, .reusable = false}, SHIFT(186),
  [343] = {.count = 1, .reusable = true}, SHIFT(187),
  [345] = {.count = 1, .reusable = true}, SHIFT(188),
  [347] = {.count = 1, .reusable = true}, SHIFT(196),
  [349] = {.count = 1, .reusable = true}, SHIFT(193),
  [351] = {.count = 1, .reusable = true}, SHIFT(194),
  [353] = {.count = 1, .reusable = false}, SHIFT(196),
  [355] = {.count = 1, .reusable = false}, SHIFT(195),
  [357] = {.count = 1, .reusable = false}, SHIFT(198),
  [359] = {.count = 1, .reusable = true}, SHIFT(198),
  [361] = {.count = 1, .reusable = false}, SHIFT(199),
  [363] = {.count = 1, .reusable = true}, REDUCE(sym_return, 1),
  [365] = {.count = 1, .reusable = true}, SHIFT(220),
  [367] = {.count = 1, .reusable = true}, SHIFT(201),
  [369] = {.count = 1, .reusable = true}, SHIFT(202),
  [371] = {.count = 1, .reusable = true}, SHIFT(203),
  [373] = {.count = 1, .reusable = true}, SHIFT(204),
  [375] = {.count = 1, .reusable = false}, REDUCE(sym_return, 1),
  [377] = {.count = 1, .reusable = false}, SHIFT(15),
  [379] = {.count = 1, .reusable = false}, SHIFT(205),
  [381] = {.count = 1, .reusable = false}, SHIFT(207),
  [383] = {.count = 1, .reusable = false}, SHIFT(208),
  [385] = {.count = 1, .reusable = false}, SHIFT(209),
  [387] = {.count = 1, .reusable = false}, SHIFT(210),
  [389] = {.count = 1, .reusable = false}, SHIFT(220),
  [391] = {.count = 1, .reusable = true}, SHIFT(211),
  [393] = {.count = 1, .reusable = true}, SHIFT(213),
  [395] = {.count = 1, .reusable = false}, SHIFT(213),
  [397] = {.count = 1, .reusable = false}, SHIFT(214),
  [399] = {.count = 1, .reusable = true}, SHIFT(214),
  [401] = {.count = 1, .reusable = false}, SHIFT(215),
  [403] = {.count = 1, .reusable = true}, SHIFT(221),
  [405] = {.count = 1, .reusable = false}, SHIFT(221),
  [407] = {.count = 1, .reusable = false}, SHIFT(216),
  [409] = {.count = 1, .reusable = false}, SHIFT(217),
  [411] = {.count = 1, .reusable = false}, SHIFT(218),
  [413] = {.count = 1, .reusable = false}, SHIFT(41),
  [415] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [417] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 1),
  [419] = {.count = 1, .reusable = true}, REDUCE(sym_break, 1),
  [421] = {.count = 1, .reusable = false}, REDUCE(sym_break, 1),
  [423] = {.count = 1, .reusable = true}, REDUCE(sym_next, 1),
  [425] = {.count = 1, .reusable = false}, REDUCE(sym_next, 1),
  [427] = {.count = 1, .reusable = true}, SHIFT(231),
  [429] = {.count = 1, .reusable = false}, SHIFT(232),
  [431] = {.count = 1, .reusable = false}, SHIFT(233),
  [433] = {.count = 1, .reusable = false}, SHIFT(234),
  [435] = {.count = 1, .reusable = false}, SHIFT(235),
  [437] = {.count = 1, .reusable = false}, SHIFT(236),
  [439] = {.count = 1, .reusable = true}, SHIFT(237),
  [441] = {.count = 1, .reusable = false}, SHIFT(237),
  [443] = {.count = 1, .reusable = true}, SHIFT(238),
  [445] = {.count = 1, .reusable = false}, SHIFT(242),
  [447] = {.count = 1, .reusable = true}, SHIFT(242),
  [449] = {.count = 1, .reusable = false}, SHIFT(239),
  [451] = {.count = 1, .reusable = true}, SHIFT(247),
  [453] = {.count = 1, .reusable = false}, SHIFT(248),
  [455] = {.count = 1, .reusable = false}, SHIFT(249),
  [457] = {.count = 1, .reusable = false}, SHIFT(250),
  [459] = {.count = 1, .reusable = false}, SHIFT(251),
  [461] = {.count = 1, .reusable = false}, SHIFT(252),
  [463] = {.count = 1, .reusable = true}, SHIFT(253),
  [465] = {.count = 1, .reusable = false}, SHIFT(253),
  [467] = {.count = 1, .reusable = true}, SHIFT(254),
  [469] = {.count = 1, .reusable = false}, SHIFT(256),
  [471] = {.count = 1, .reusable = true}, SHIFT(256),
  [473] = {.count = 1, .reusable = true}, SHIFT(261),
  [475] = {.count = 1, .reusable = true}, SHIFT(262),
  [477] = {.count = 1, .reusable = false}, SHIFT(263),
  [479] = {.count = 1, .reusable = true}, SHIFT(263),
  [481] = {.count = 1, .reusable = true}, SHIFT(280),
  [483] = {.count = 1, .reusable = true}, SHIFT(267),
  [485] = {.count = 1, .reusable = false}, SHIFT(268),
  [487] = {.count = 1, .reusable = false}, SHIFT(269),
  [489] = {.count = 1, .reusable = false}, SHIFT(270),
  [491] = {.count = 1, .reusable = false}, SHIFT(271),
  [493] = {.count = 1, .reusable = false}, SHIFT(272),
  [495] = {.count = 1, .reusable = true}, SHIFT(273),
  [497] = {.count = 1, .reusable = false}, SHIFT(273),
  [499] = {.count = 1, .reusable = true}, SHIFT(274),
  [501] = {.count = 1, .reusable = false}, SHIFT(276),
  [503] = {.count = 1, .reusable = true}, SHIFT(276),
  [505] = {.count = 1, .reusable = true}, SHIFT(307),
  [507] = {.count = 1, .reusable = true}, SHIFT(281),
  [509] = {.count = 1, .reusable = true}, SHIFT(282),
  [511] = {.count = 1, .reusable = true}, SHIFT(283),
  [513] = {.count = 1, .reusable = false}, SHIFT(301),
  [515] = {.count = 1, .reusable = false}, SHIFT(284),
  [517] = {.count = 1, .reusable = false}, SHIFT(285),
  [519] = {.count = 1, .reusable = false}, SHIFT(286),
  [521] = {.count = 1, .reusable = false}, SHIFT(287),
  [523] = {.count = 1, .reusable = false}, SHIFT(288),
  [525] = {.count = 1, .reusable = false}, SHIFT(289),
  [527] = {.count = 1, .reusable = false}, SHIFT(290),
  [529] = {.count = 1, .reusable = false}, SHIFT(291),
  [531] = {.count = 1, .reusable = true}, SHIFT(292),
  [533] = {.count = 1, .reusable = false}, SHIFT(292),
  [535] = {.count = 1, .reusable = true}, SHIFT(293),
  [537] = {.count = 1, .reusable = false}, SHIFT(303),
  [539] = {.count = 1, .reusable = true}, SHIFT(303),
  [541] = {.count = 1, .reusable = false}, SHIFT(294),
  [543] = {.count = 1, .reusable = true}, SHIFT(312),
  [545] = {.count = 1, .reusable = true}, SHIFT(311),
  [547] = {.count = 1, .reusable = true}, SHIFT(313),
  [549] = {.count = 1, .reusable = true}, SHIFT(314),
  [551] = {.count = 1, .reusable = true}, SHIFT(315),
  [553] = {.count = 1, .reusable = false}, SHIFT(315),
  [555] = {.count = 1, .reusable = true}, SHIFT(317),
  [557] = {.count = 1, .reusable = true}, SHIFT(316),
  [559] = {.count = 1, .reusable = true}, REDUCE(sym__primary, 1),
  [561] = {.count = 1, .reusable = false}, REDUCE(sym__primary, 1),
  [563] = {.count = 1, .reusable = false}, SHIFT(318),
  [565] = {.count = 1, .reusable = true}, REDUCE(sym_true, 1),
  [567] = {.count = 1, .reusable = false}, REDUCE(sym_true, 1),
  [569] = {.count = 1, .reusable = true}, REDUCE(sym_false, 1),
  [571] = {.count = 1, .reusable = false}, REDUCE(sym_false, 1),
  [573] = {.count = 1, .reusable = true}, REDUCE(sym_nil, 1),
  [575] = {.count = 1, .reusable = false}, REDUCE(sym_nil, 1),
  [577] = {.count = 1, .reusable = true}, SHIFT(319),
  [579] = {.count = 1, .reusable = true}, SHIFT(320),
  [581] = {.count = 1, .reusable = true}, SHIFT(321),
  [583] = {.count = 1, .reusable = true}, SHIFT(322),
  [585] = {.count = 1, .reusable = true}, SHIFT(323),
  [587] = {.count = 1, .reusable = true}, SHIFT(324),
  [589] = {.count = 1, .reusable = true}, SHIFT(325),
  [591] = {.count = 1, .reusable = true}, SHIFT(360),
  [593] = {.count = 1, .reusable = true}, SHIFT(326),
  [595] = {.count = 1, .reusable = true}, SHIFT(327),
  [597] = {.count = 1, .reusable = true}, SHIFT(328),
  [599] = {.count = 1, .reusable = true}, SHIFT(329),
  [601] = {.count = 1, .reusable = true}, SHIFT(330),
  [603] = {.count = 1, .reusable = false}, SHIFT(331),
  [605] = {.count = 1, .reusable = true}, SHIFT(332),
  [607] = {.count = 1, .reusable = true}, SHIFT(333),
  [609] = {.count = 1, .reusable = true}, SHIFT(334),
  [611] = {.count = 1, .reusable = false}, SHIFT(335),
  [613] = {.count = 1, .reusable = false}, SHIFT(336),
  [615] = {.count = 1, .reusable = false}, SHIFT(337),
  [617] = {.count = 1, .reusable = false}, SHIFT(338),
  [619] = {.count = 1, .reusable = false}, SHIFT(339),
  [621] = {.count = 1, .reusable = false}, SHIFT(340),
  [623] = {.count = 1, .reusable = false}, SHIFT(360),
  [625] = {.count = 1, .reusable = false}, SHIFT(341),
  [627] = {.count = 1, .reusable = false}, SHIFT(342),
  [629] = {.count = 1, .reusable = false}, SHIFT(343),
  [631] = {.count = 1, .reusable = false}, SHIFT(344),
  [633] = {.count = 1, .reusable = false}, SHIFT(345),
  [635] = {.count = 1, .reusable = false}, SHIFT(346),
  [637] = {.count = 1, .reusable = false}, SHIFT(347),
  [639] = {.count = 1, .reusable = true}, SHIFT(348),
  [641] = {.count = 1, .reusable = false}, SHIFT(349),
  [643] = {.count = 1, .reusable = true}, SHIFT(350),
  [645] = {.count = 1, .reusable = false}, SHIFT(350),
  [647] = {.count = 1, .reusable = true}, SHIFT(351),
  [649] = {.count = 1, .reusable = false}, SHIFT(352),
  [651] = {.count = 1, .reusable = true}, SHIFT(361),
  [653] = {.count = 1, .reusable = false}, SHIFT(353),
  [655] = {.count = 1, .reusable = false}, SHIFT(361),
  [657] = {.count = 1, .reusable = false}, SHIFT(354),
  [659] = {.count = 1, .reusable = false}, SHIFT(355),
  [661] = {.count = 1, .reusable = false}, SHIFT(356),
  [663] = {.count = 1, .reusable = true}, SHIFT(357),
  [665] = {.count = 1, .reusable = true}, SHIFT(358),
  [667] = {.count = 1, .reusable = true}, SHIFT(368),
  [669] = {.count = 1, .reusable = true}, SHIFT(369),
  [671] = {.count = 1, .reusable = false}, SHIFT(370),
  [673] = {.count = 1, .reusable = true}, SHIFT(371),
  [675] = {.count = 1, .reusable = true}, SHIFT(372),
  [677] = {.count = 1, .reusable = false}, SHIFT(373),
  [679] = {.count = 1, .reusable = false}, SHIFT(374),
  [681] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [683] = {.count = 1, .reusable = true}, REDUCE(sym_program, 1),
  [685] = {.count = 1, .reusable = true}, SHIFT(378),
  [687] = {.count = 1, .reusable = true}, SHIFT(379),
  [689] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 1),
  [691] = {.count = 1, .reusable = true}, REDUCE(sym__top_level_statement, 1),
  [693] = {.count = 1, .reusable = true}, SHIFT(381),
  [695] = {.count = 1, .reusable = true}, SHIFT(382),
  [697] = {.count = 1, .reusable = true}, SHIFT(383),
  [699] = {.count = 1, .reusable = true}, SHIFT(384),
  [701] = {.count = 1, .reusable = true}, SHIFT(385),
  [703] = {.count = 1, .reusable = true}, REDUCE(sym__statement, 1),
  [705] = {.count = 1, .reusable = true}, SHIFT(386),
  [707] = {.count = 1, .reusable = true}, SHIFT(387),
  [709] = {.count = 1, .reusable = false}, SHIFT(388),
  [711] = {.count = 1, .reusable = true}, SHIFT(389),
  [713] = {.count = 1, .reusable = false}, SHIFT(390),
  [715] = {.count = 1, .reusable = false}, SHIFT(391),
  [717] = {.count = 1, .reusable = true}, SHIFT(392),
  [719] = {.count = 1, .reusable = false}, SHIFT(393),
  [721] = {.count = 1, .reusable = true}, SHIFT(393),
  [723] = {.count = 1, .reusable = true}, SHIFT(394),
  [725] = {.count = 1, .reusable = true}, SHIFT(395),
  [727] = {.count = 1, .reusable = true}, SHIFT(396),
  [729] = {.count = 1, .reusable = false}, SHIFT(395),
  [731] = {.count = 1, .reusable = true}, SHIFT(391),
  [733] = {.count = 1, .reusable = true}, SHIFT(388),
  [735] = {.count = 1, .reusable = true}, SHIFT(397),
  [737] = {.count = 1, .reusable = true}, REDUCE(sym__arg, 1),
  [739] = {.count = 1, .reusable = false}, SHIFT(398),
  [741] = {.count = 1, .reusable = false}, REDUCE(sym__arg, 1),
  [743] = {.count = 1, .reusable = true}, SHIFT(399),
  [745] = {.count = 1, .reusable = true}, SHIFT(400),
  [747] = {.count = 1, .reusable = true}, SHIFT(398),
  [749] = {.count = 1, .reusable = true}, REDUCE(sym__lhs, 1),
  [751] = {.count = 1, .reusable = true}, SHIFT(401),
  [753] = {.count = 1, .reusable = true}, SHIFT(402),
  [755] = {.count = 1, .reusable = true}, SHIFT(403),
  [757] = {.count = 1, .reusable = true}, SHIFT(404),
  [759] = {.count = 1, .reusable = true}, SHIFT(405),
  [761] = {.count = 1, .reusable = true}, SHIFT(406),
  [763] = {.count = 1, .reusable = true}, SHIFT(407),
  [765] = {.count = 1, .reusable = true}, SHIFT(439),
  [767] = {.count = 1, .reusable = true}, SHIFT(408),
  [769] = {.count = 1, .reusable = true}, SHIFT(409),
  [771] = {.count = 1, .reusable = true}, SHIFT(410),
  [773] = {.count = 1, .reusable = true}, SHIFT(411),
  [775] = {.count = 1, .reusable = false}, REDUCE(sym__lhs, 1),
  [777] = {.count = 1, .reusable = true}, SHIFT(412),
  [779] = {.count = 1, .reusable = false}, SHIFT(413),
  [781] = {.count = 1, .reusable = false}, SHIFT(414),
  [783] = {.count = 1, .reusable = false}, SHIFT(416),
  [785] = {.count = 1, .reusable = false}, SHIFT(417),
  [787] = {.count = 1, .reusable = false}, SHIFT(418),
  [789] = {.count = 1, .reusable = false}, SHIFT(419),
  [791] = {.count = 1, .reusable = false}, SHIFT(420),
  [793] = {.count = 1, .reusable = false}, SHIFT(421),
  [795] = {.count = 1, .reusable = false}, SHIFT(439),
  [797] = {.count = 1, .reusable = false}, SHIFT(426),
  [799] = {.count = 1, .reusable = false}, SHIFT(427),
  [801] = {.count = 1, .reusable = false}, SHIFT(428),
  [803] = {.count = 1, .reusable = false}, SHIFT(429),
  [805] = {.count = 1, .reusable = true}, SHIFT(430),
  [807] = {.count = 1, .reusable = true}, SHIFT(432),
  [809] = {.count = 1, .reusable = false}, SHIFT(432),
  [811] = {.count = 1, .reusable = false}, SHIFT(433),
  [813] = {.count = 1, .reusable = true}, SHIFT(433),
  [815] = {.count = 1, .reusable = false}, SHIFT(434),
  [817] = {.count = 1, .reusable = true}, SHIFT(440),
  [819] = {.count = 1, .reusable = false}, SHIFT(435),
  [821] = {.count = 1, .reusable = false}, SHIFT(440),
  [823] = {.count = 1, .reusable = false}, SHIFT(436),
  [825] = {.count = 1, .reusable = true}, SHIFT(437),
  [827] = {.count = 1, .reusable = true}, SHIFT(448),
  [829] = {.count = 1, .reusable = true}, REDUCE(sym_left_assignment_list, 1),
  [831] = {.count = 1, .reusable = true}, SHIFT(449),
  [833] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 1),
  [835] = {.count = 1, .reusable = true}, REDUCE(sym__simple_mlhs, 1),
  [837] = {.count = 1, .reusable = false}, SHIFT(448),
  [839] = {.count = 1, .reusable = true}, SHIFT(450),
  [841] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [843] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2, .alias_sequence_id = 1),
  [845] = {.count = 1, .reusable = true}, SHIFT(470),
  [847] = {.count = 1, .reusable = true}, SHIFT(452),
  [849] = {.count = 1, .reusable = true}, SHIFT(453),
  [851] = {.count = 1, .reusable = true}, SHIFT(454),
  [853] = {.count = 1, .reusable = false}, SHIFT(455),
  [855] = {.count = 1, .reusable = false}, SHIFT(456),
  [857] = {.count = 1, .reusable = false}, SHIFT(457),
  [859] = {.count = 1, .reusable = false}, SHIFT(458),
  [861] = {.count = 1, .reusable = false}, SHIFT(470),
  [863] = {.count = 1, .reusable = false}, SHIFT(459),
  [865] = {.count = 1, .reusable = true}, SHIFT(460),
  [867] = {.count = 1, .reusable = false}, SHIFT(460),
  [869] = {.count = 1, .reusable = true}, SHIFT(461),
  [871] = {.count = 1, .reusable = false}, SHIFT(471),
  [873] = {.count = 1, .reusable = true}, SHIFT(471),
  [875] = {.count = 1, .reusable = false}, SHIFT(462),
  [877] = {.count = 1, .reusable = false}, SHIFT(463),
  [879] = {.count = 1, .reusable = false}, SHIFT(464),
  [881] = {.count = 1, .reusable = false}, SHIFT(465),
  [883] = {.count = 1, .reusable = false}, SHIFT(466),
  [885] = {.count = 1, .reusable = true}, SHIFT(475),
  [887] = {.count = 1, .reusable = true}, SHIFT(476),
  [889] = {.count = 1, .reusable = true}, REDUCE(sym__literal_contents, 1),
  [891] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 2, .alias_sequence_id = 2),
  [893] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 2, .alias_sequence_id = 2),
  [895] = {.count = 1, .reusable = true}, SHIFT(477),
  [897] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 2, .alias_sequence_id = 3),
  [899] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 2, .alias_sequence_id = 3),
  [901] = {.count = 1, .reusable = true}, SHIFT(478),
  [903] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 2, .alias_sequence_id = 4),
  [905] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 2, .alias_sequence_id = 4),
  [907] = {.count = 1, .reusable = true}, SHIFT(479),
  [909] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 2, .alias_sequence_id = 5),
  [911] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 2, .alias_sequence_id = 5),
  [913] = {.count = 1, .reusable = true}, SHIFT(481),
  [915] = {.count = 1, .reusable = false}, SHIFT(482),
  [917] = {.count = 1, .reusable = true}, SHIFT(484),
  [919] = {.count = 1, .reusable = true}, SHIFT(485),
  [921] = {.count = 1, .reusable = true}, SHIFT(487),
  [923] = {.count = 1, .reusable = false}, REDUCE(sym__literal_contents, 1),
  [925] = {.count = 1, .reusable = false}, SHIFT(487),
  [927] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 6),
  [929] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 2, .alias_sequence_id = 6),
  [931] = {.count = 1, .reusable = true}, SHIFT(488),
  [933] = {.count = 1, .reusable = false}, SHIFT(489),
  [935] = {.count = 1, .reusable = true}, SHIFT(491),
  [937] = {.count = 1, .reusable = true}, SHIFT(492),
  [939] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2, .alias_sequence_id = 7),
  [941] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2, .alias_sequence_id = 7),
  [943] = {.count = 1, .reusable = false}, SHIFT(494),
  [945] = {.count = 1, .reusable = true}, SHIFT(495),
  [947] = {.count = 1, .reusable = true}, SHIFT(496),
  [949] = {.count = 1, .reusable = false}, SHIFT(497),
  [951] = {.count = 1, .reusable = false}, SHIFT(498),
  [953] = {.count = 1, .reusable = false}, SHIFT(499),
  [955] = {.count = 1, .reusable = false}, SHIFT(500),
  [957] = {.count = 1, .reusable = false}, SHIFT(501),
  [959] = {.count = 1, .reusable = true}, SHIFT(502),
  [961] = {.count = 1, .reusable = false}, SHIFT(502),
  [963] = {.count = 1, .reusable = true}, SHIFT(503),
  [965] = {.count = 1, .reusable = false}, SHIFT(509),
  [967] = {.count = 1, .reusable = true}, SHIFT(509),
  [969] = {.count = 1, .reusable = false}, SHIFT(504),
  [971] = {.count = 1, .reusable = true}, SHIFT(513),
  [973] = {.count = 1, .reusable = true}, SHIFT(515),
  [975] = {.count = 1, .reusable = true}, SHIFT(517),
  [977] = {.count = 1, .reusable = true}, SHIFT(519),
  [979] = {.count = 1, .reusable = true}, SHIFT(521),
  [981] = {.count = 1, .reusable = false}, SHIFT(522),
  [983] = {.count = 1, .reusable = true}, SHIFT(524),
  [985] = {.count = 1, .reusable = false}, SHIFT(525),
  [987] = {.count = 1, .reusable = true}, SHIFT(529),
  [989] = {.count = 1, .reusable = true}, SHIFT(527),
  [991] = {.count = 1, .reusable = false}, SHIFT(528),
  [993] = {.count = 1, .reusable = true}, SHIFT(532),
  [995] = {.count = 1, .reusable = true}, SHIFT(533),
  [997] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 2),
  [999] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 2),
  [1001] = {.count = 1, .reusable = true}, SHIFT(536),
  [1003] = {.count = 1, .reusable = false}, SHIFT(538),
  [1005] = {.count = 1, .reusable = true}, SHIFT(540),
  [1007] = {.count = 1, .reusable = true}, SHIFT(542),
  [1009] = {.count = 1, .reusable = true}, SHIFT(556),
  [1011] = {.count = 1, .reusable = true}, SHIFT(543),
  [1013] = {.count = 1, .reusable = true}, SHIFT(544),
  [1015] = {.count = 1, .reusable = false}, SHIFT(545),
  [1017] = {.count = 1, .reusable = false}, SHIFT(546),
  [1019] = {.count = 1, .reusable = false}, SHIFT(547),
  [1021] = {.count = 1, .reusable = false}, SHIFT(548),
  [1023] = {.count = 1, .reusable = false}, SHIFT(556),
  [1025] = {.count = 1, .reusable = false}, SHIFT(549),
  [1027] = {.count = 1, .reusable = true}, SHIFT(550),
  [1029] = {.count = 1, .reusable = false}, SHIFT(550),
  [1031] = {.count = 1, .reusable = true}, SHIFT(551),
  [1033] = {.count = 1, .reusable = false}, SHIFT(557),
  [1035] = {.count = 1, .reusable = true}, SHIFT(557),
  [1037] = {.count = 1, .reusable = false}, SHIFT(552),
  [1039] = {.count = 1, .reusable = false}, SHIFT(553),
  [1041] = {.count = 1, .reusable = false}, SHIFT(554),
  [1043] = {.count = 1, .reusable = true}, SHIFT(561),
  [1045] = {.count = 1, .reusable = false}, SHIFT(562),
  [1047] = {.count = 1, .reusable = false}, SHIFT(564),
  [1049] = {.count = 1, .reusable = true}, SHIFT(566),
  [1051] = {.count = 1, .reusable = true}, SHIFT(567),
  [1053] = {.count = 1, .reusable = true}, SHIFT(568),
  [1055] = {.count = 1, .reusable = true}, SHIFT(569),
  [1057] = {.count = 1, .reusable = false}, SHIFT(332),
  [1059] = {.count = 1, .reusable = false}, SHIFT(333),
  [1061] = {.count = 1, .reusable = false}, SHIFT(571),
  [1063] = {.count = 1, .reusable = false}, SHIFT(572),
  [1065] = {.count = 1, .reusable = false}, SHIFT(573),
  [1067] = {.count = 1, .reusable = false}, SHIFT(574),
  [1069] = {.count = 1, .reusable = true}, SHIFT(575),
  [1071] = {.count = 1, .reusable = true}, SHIFT(577),
  [1073] = {.count = 1, .reusable = false}, SHIFT(577),
  [1075] = {.count = 1, .reusable = false}, SHIFT(578),
  [1077] = {.count = 1, .reusable = true}, SHIFT(578),
  [1079] = {.count = 1, .reusable = false}, SHIFT(579),
  [1081] = {.count = 1, .reusable = true}, SHIFT(581),
  [1083] = {.count = 1, .reusable = false}, SHIFT(581),
  [1085] = {.count = 1, .reusable = false}, SHIFT(357),
  [1087] = {.count = 1, .reusable = true}, SHIFT(597),
  [1089] = {.count = 1, .reusable = true}, SHIFT(603),
  [1091] = {.count = 1, .reusable = false}, SHIFT(602),
  [1093] = {.count = 1, .reusable = true}, REDUCE(sym__variable, 1),
  [1095] = {.count = 1, .reusable = false}, REDUCE(sym__variable, 1),
  [1097] = {.count = 1, .reusable = false}, SHIFT(532),
  [1099] = {.count = 1, .reusable = false}, SHIFT(607),
  [1101] = {.count = 1, .reusable = true}, SHIFT(608),
  [1103] = {.count = 1, .reusable = true}, SHIFT(611),
  [1105] = {.count = 1, .reusable = false}, SHIFT(612),
  [1107] = {.count = 1, .reusable = true}, SHIFT(615),
  [1109] = {.count = 1, .reusable = true}, SHIFT(616),
  [1111] = {.count = 1, .reusable = false}, SHIFT(617),
  [1113] = {.count = 1, .reusable = true}, SHIFT(618),
  [1115] = {.count = 1, .reusable = false}, SHIFT(619),
  [1117] = {.count = 1, .reusable = false}, SHIFT(620),
  [1119] = {.count = 1, .reusable = true}, SHIFT(621),
  [1121] = {.count = 1, .reusable = true}, SHIFT(622),
  [1123] = {.count = 1, .reusable = false}, SHIFT(623),
  [1125] = {.count = 1, .reusable = true}, SHIFT(623),
  [1127] = {.count = 1, .reusable = true}, SHIFT(624),
  [1129] = {.count = 1, .reusable = true}, SHIFT(625),
  [1131] = {.count = 1, .reusable = true}, SHIFT(626),
  [1133] = {.count = 1, .reusable = false}, SHIFT(625),
  [1135] = {.count = 1, .reusable = true}, SHIFT(620),
  [1137] = {.count = 1, .reusable = true}, SHIFT(617),
  [1139] = {.count = 1, .reusable = true}, SHIFT(627),
  [1141] = {.count = 1, .reusable = false}, SHIFT(628),
  [1143] = {.count = 1, .reusable = true}, SHIFT(629),
  [1145] = {.count = 1, .reusable = true}, SHIFT(630),
  [1147] = {.count = 1, .reusable = true}, SHIFT(628),
  [1149] = {.count = 1, .reusable = true}, SHIFT(631),
  [1151] = {.count = 1, .reusable = true}, SHIFT(632),
  [1153] = {.count = 1, .reusable = true}, SHIFT(633),
  [1155] = {.count = 1, .reusable = true}, SHIFT(634),
  [1157] = {.count = 1, .reusable = true}, SHIFT(635),
  [1159] = {.count = 1, .reusable = true}, SHIFT(636),
  [1161] = {.count = 1, .reusable = true}, SHIFT(637),
  [1163] = {.count = 1, .reusable = true}, SHIFT(669),
  [1165] = {.count = 1, .reusable = true}, SHIFT(638),
  [1167] = {.count = 1, .reusable = true}, SHIFT(639),
  [1169] = {.count = 1, .reusable = true}, SHIFT(640),
  [1171] = {.count = 1, .reusable = true}, SHIFT(641),
  [1173] = {.count = 1, .reusable = true}, SHIFT(642),
  [1175] = {.count = 1, .reusable = false}, SHIFT(643),
  [1177] = {.count = 1, .reusable = false}, SHIFT(644),
  [1179] = {.count = 1, .reusable = false}, SHIFT(646),
  [1181] = {.count = 1, .reusable = false}, SHIFT(647),
  [1183] = {.count = 1, .reusable = false}, SHIFT(648),
  [1185] = {.count = 1, .reusable = false}, SHIFT(649),
  [1187] = {.count = 1, .reusable = false}, SHIFT(650),
  [1189] = {.count = 1, .reusable = false}, SHIFT(651),
  [1191] = {.count = 1, .reusable = false}, SHIFT(669),
  [1193] = {.count = 1, .reusable = false}, SHIFT(652),
  [1195] = {.count = 1, .reusable = false}, SHIFT(653),
  [1197] = {.count = 1, .reusable = false}, SHIFT(654),
  [1199] = {.count = 1, .reusable = false}, SHIFT(655),
  [1201] = {.count = 1, .reusable = false}, SHIFT(656),
  [1203] = {.count = 1, .reusable = false}, SHIFT(657),
  [1205] = {.count = 1, .reusable = false}, SHIFT(658),
  [1207] = {.count = 1, .reusable = false}, SHIFT(659),
  [1209] = {.count = 1, .reusable = true}, SHIFT(660),
  [1211] = {.count = 1, .reusable = true}, SHIFT(662),
  [1213] = {.count = 1, .reusable = false}, SHIFT(662),
  [1215] = {.count = 1, .reusable = false}, SHIFT(663),
  [1217] = {.count = 1, .reusable = true}, SHIFT(663),
  [1219] = {.count = 1, .reusable = false}, SHIFT(664),
  [1221] = {.count = 1, .reusable = true}, SHIFT(670),
  [1223] = {.count = 1, .reusable = false}, SHIFT(665),
  [1225] = {.count = 1, .reusable = false}, SHIFT(670),
  [1227] = {.count = 1, .reusable = false}, SHIFT(666),
  [1229] = {.count = 1, .reusable = true}, SHIFT(667),
  [1231] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 1),
  [1233] = {.count = 1, .reusable = true}, SHIFT(678),
  [1235] = {.count = 1, .reusable = false}, SHIFT(678),
  [1237] = {.count = 1, .reusable = true}, SHIFT(679),
  [1239] = {.count = 1, .reusable = false}, SHIFT(621),
  [1241] = {.count = 1, .reusable = true}, SHIFT(681),
  [1243] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 1),
  [1245] = {.count = 1, .reusable = true}, SHIFT(683),
  [1247] = {.count = 1, .reusable = true}, SHIFT(684),
  [1249] = {.count = 1, .reusable = true}, SHIFT(686),
  [1251] = {.count = 1, .reusable = true}, SHIFT(688),
  [1253] = {.count = 1, .reusable = false}, SHIFT(689),
  [1255] = {.count = 1, .reusable = false}, SHIFT(690),
  [1257] = {.count = 1, .reusable = false}, SHIFT(691),
  [1259] = {.count = 1, .reusable = false}, SHIFT(692),
  [1261] = {.count = 1, .reusable = false}, SHIFT(693),
  [1263] = {.count = 1, .reusable = true}, SHIFT(694),
  [1265] = {.count = 1, .reusable = false}, SHIFT(694),
  [1267] = {.count = 1, .reusable = true}, SHIFT(695),
  [1269] = {.count = 1, .reusable = false}, SHIFT(697),
  [1271] = {.count = 1, .reusable = true}, SHIFT(697),
  [1273] = {.count = 1, .reusable = true}, REDUCE(sym_operator, 1),
  [1275] = {.count = 1, .reusable = false}, REDUCE(sym_operator, 1),
  [1277] = {.count = 1, .reusable = true}, REDUCE(sym__method_name, 1),
  [1279] = {.count = 1, .reusable = false}, REDUCE(sym__method_name, 1),
  [1281] = {.count = 1, .reusable = true}, SHIFT(701),
  [1283] = {.count = 1, .reusable = true}, REDUCE(sym_method, 2),
  [1285] = {.count = 1, .reusable = false}, REDUCE(sym_method, 2),
  [1287] = {.count = 1, .reusable = true}, SHIFT(702),
  [1289] = {.count = 1, .reusable = true}, SHIFT(708),
  [1291] = {.count = 1, .reusable = true}, SHIFT(703),
  [1293] = {.count = 1, .reusable = false}, SHIFT(704),
  [1295] = {.count = 1, .reusable = true}, SHIFT(705),
  [1297] = {.count = 1, .reusable = true}, SHIFT(706),
  [1299] = {.count = 1, .reusable = true}, SHIFT(707),
  [1301] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 2),
  [1303] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 2),
  [1305] = {.count = 1, .reusable = false}, SHIFT(711),
  [1307] = {.count = 1, .reusable = true}, SHIFT(711),
  [1309] = {.count = 1, .reusable = true}, SHIFT(712),
  [1311] = {.count = 1, .reusable = true}, SHIFT(713),
  [1313] = {.count = 1, .reusable = true}, SHIFT(714),
  [1315] = {.count = 1, .reusable = true}, SHIFT(715),
  [1317] = {.count = 1, .reusable = false}, SHIFT(717),
  [1319] = {.count = 1, .reusable = false}, SHIFT(718),
  [1321] = {.count = 1, .reusable = false}, SHIFT(719),
  [1323] = {.count = 1, .reusable = false}, SHIFT(720),
  [1325] = {.count = 1, .reusable = true}, SHIFT(722),
  [1327] = {.count = 1, .reusable = false}, SHIFT(722),
  [1329] = {.count = 1, .reusable = false}, SHIFT(723),
  [1331] = {.count = 1, .reusable = true}, SHIFT(723),
  [1333] = {.count = 1, .reusable = false}, SHIFT(724),
  [1335] = {.count = 1, .reusable = true}, SHIFT(726),
  [1337] = {.count = 1, .reusable = false}, SHIFT(726),
  [1339] = {.count = 1, .reusable = true}, SHIFT(734),
  [1341] = {.count = 1, .reusable = true}, SHIFT(735),
  [1343] = {.count = 1, .reusable = true}, SHIFT(736),
  [1345] = {.count = 1, .reusable = true}, SHIFT(738),
  [1347] = {.count = 1, .reusable = true}, SHIFT(739),
  [1349] = {.count = 1, .reusable = true}, SHIFT(740),
  [1351] = {.count = 1, .reusable = true}, SHIFT(741),
  [1353] = {.count = 1, .reusable = true}, SHIFT(742),
  [1355] = {.count = 1, .reusable = true}, SHIFT(743),
  [1357] = {.count = 1, .reusable = true}, SHIFT(744),
  [1359] = {.count = 1, .reusable = false}, SHIFT(745),
  [1361] = {.count = 1, .reusable = true}, SHIFT(746),
  [1363] = {.count = 1, .reusable = false}, SHIFT(747),
  [1365] = {.count = 1, .reusable = false}, SHIFT(748),
  [1367] = {.count = 1, .reusable = true}, SHIFT(749),
  [1369] = {.count = 1, .reusable = false}, SHIFT(750),
  [1371] = {.count = 1, .reusable = true}, SHIFT(750),
  [1373] = {.count = 1, .reusable = true}, SHIFT(751),
  [1375] = {.count = 1, .reusable = true}, SHIFT(752),
  [1377] = {.count = 1, .reusable = true}, SHIFT(753),
  [1379] = {.count = 1, .reusable = false}, SHIFT(752),
  [1381] = {.count = 1, .reusable = true}, SHIFT(748),
  [1383] = {.count = 1, .reusable = true}, SHIFT(745),
  [1385] = {.count = 1, .reusable = true}, SHIFT(754),
  [1387] = {.count = 1, .reusable = true}, SHIFT(755),
  [1389] = {.count = 1, .reusable = true}, SHIFT(756),
  [1391] = {.count = 1, .reusable = true}, SHIFT(757),
  [1393] = {.count = 1, .reusable = true}, SHIFT(758),
  [1395] = {.count = 1, .reusable = false}, SHIFT(760),
  [1397] = {.count = 1, .reusable = false}, SHIFT(761),
  [1399] = {.count = 1, .reusable = false}, SHIFT(762),
  [1401] = {.count = 1, .reusable = false}, SHIFT(763),
  [1403] = {.count = 1, .reusable = true}, SHIFT(765),
  [1405] = {.count = 1, .reusable = false}, SHIFT(765),
  [1407] = {.count = 1, .reusable = false}, SHIFT(766),
  [1409] = {.count = 1, .reusable = true}, SHIFT(766),
  [1411] = {.count = 1, .reusable = false}, SHIFT(767),
  [1413] = {.count = 1, .reusable = true}, SHIFT(769),
  [1415] = {.count = 1, .reusable = false}, SHIFT(769),
  [1417] = {.count = 1, .reusable = true}, SHIFT(775),
  [1419] = {.count = 1, .reusable = true}, SHIFT(776),
  [1421] = {.count = 1, .reusable = true}, SHIFT(777),
  [1423] = {.count = 1, .reusable = false}, SHIFT(775),
  [1425] = {.count = 1, .reusable = true}, SHIFT(778),
  [1427] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 2),
  [1429] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 2),
  [1431] = {.count = 1, .reusable = true}, SHIFT(780),
  [1433] = {.count = 1, .reusable = true}, SHIFT(782),
  [1435] = {.count = 1, .reusable = true}, SHIFT(784),
  [1437] = {.count = 1, .reusable = true}, SHIFT(786),
  [1439] = {.count = 1, .reusable = true}, SHIFT(788),
  [1441] = {.count = 1, .reusable = false}, SHIFT(789),
  [1443] = {.count = 1, .reusable = true}, SHIFT(791),
  [1445] = {.count = 1, .reusable = false}, SHIFT(792),
  [1447] = {.count = 1, .reusable = true}, SHIFT(794),
  [1449] = {.count = 1, .reusable = true}, SHIFT(797),
  [1451] = {.count = 1, .reusable = false}, SHIFT(799),
  [1453] = {.count = 1, .reusable = true}, SHIFT(801),
  [1455] = {.count = 1, .reusable = true}, SHIFT(803),
  [1457] = {.count = 1, .reusable = true}, SHIFT(804),
  [1459] = {.count = 1, .reusable = false}, SHIFT(805),
  [1461] = {.count = 1, .reusable = false}, SHIFT(807),
  [1463] = {.count = 1, .reusable = true}, SHIFT(809),
  [1465] = {.count = 1, .reusable = true}, SHIFT(810),
  [1467] = {.count = 1, .reusable = true}, SHIFT(811),
  [1469] = {.count = 1, .reusable = true}, SHIFT(812),
  [1471] = {.count = 1, .reusable = true}, SHIFT(813),
  [1473] = {.count = 1, .reusable = false}, SHIFT(576),
  [1475] = {.count = 1, .reusable = false}, SHIFT(814),
  [1477] = {.count = 1, .reusable = true}, SHIFT(829),
  [1479] = {.count = 1, .reusable = true}, SHIFT(835),
  [1481] = {.count = 1, .reusable = false}, SHIFT(834),
  [1483] = {.count = 1, .reusable = true}, SHIFT(836),
  [1485] = {.count = 1, .reusable = true}, SHIFT(837),
  [1487] = {.count = 1, .reusable = true}, SHIFT(840),
  [1489] = {.count = 1, .reusable = false}, SHIFT(841),
  [1491] = {.count = 1, .reusable = true}, SHIFT(844),
  [1493] = {.count = 1, .reusable = true}, SHIFT(845),
  [1495] = {.count = 1, .reusable = true}, SHIFT(846),
  [1497] = {.count = 1, .reusable = true}, SHIFT(847),
  [1499] = {.count = 1, .reusable = true}, SHIFT(848),
  [1501] = {.count = 1, .reusable = true}, SHIFT(849),
  [1503] = {.count = 1, .reusable = true}, SHIFT(850),
  [1505] = {.count = 1, .reusable = true}, SHIFT(851),
  [1507] = {.count = 1, .reusable = true}, SHIFT(852),
  [1509] = {.count = 1, .reusable = false}, SHIFT(853),
  [1511] = {.count = 1, .reusable = false}, SHIFT(854),
  [1513] = {.count = 1, .reusable = false}, SHIFT(855),
  [1515] = {.count = 1, .reusable = false}, SHIFT(856),
  [1517] = {.count = 1, .reusable = false}, SHIFT(857),
  [1519] = {.count = 1, .reusable = true}, SHIFT(858),
  [1521] = {.count = 1, .reusable = false}, SHIFT(858),
  [1523] = {.count = 1, .reusable = true}, SHIFT(859),
  [1525] = {.count = 1, .reusable = false}, SHIFT(860),
  [1527] = {.count = 1, .reusable = true}, REDUCE(sym_rest_assignment, 2),
  [1529] = {.count = 1, .reusable = true}, SHIFT(871),
  [1531] = {.count = 1, .reusable = true}, SHIFT(874),
  [1533] = {.count = 1, .reusable = true}, SHIFT(872),
  [1535] = {.count = 1, .reusable = true}, SHIFT(875),
  [1537] = {.count = 1, .reusable = true}, SHIFT(876),
  [1539] = {.count = 1, .reusable = true}, SHIFT(877),
  [1541] = {.count = 1, .reusable = true}, SHIFT(878),
  [1543] = {.count = 1, .reusable = true}, SHIFT(879),
  [1545] = {.count = 1, .reusable = true}, SHIFT(880),
  [1547] = {.count = 1, .reusable = true}, SHIFT(881),
  [1549] = {.count = 1, .reusable = false}, SHIFT(882),
  [1551] = {.count = 1, .reusable = false}, SHIFT(883),
  [1553] = {.count = 1, .reusable = false}, SHIFT(884),
  [1555] = {.count = 1, .reusable = false}, SHIFT(885),
  [1557] = {.count = 1, .reusable = false}, SHIFT(886),
  [1559] = {.count = 1, .reusable = true}, SHIFT(887),
  [1561] = {.count = 1, .reusable = false}, SHIFT(887),
  [1563] = {.count = 1, .reusable = true}, SHIFT(888),
  [1565] = {.count = 1, .reusable = false}, SHIFT(889),
  [1567] = {.count = 1, .reusable = true}, SHIFT(897),
  [1569] = {.count = 1, .reusable = false}, SHIFT(896),
  [1571] = {.count = 1, .reusable = true}, SHIFT(898),
  [1573] = {.count = 1, .reusable = false}, SHIFT(899),
  [1575] = {.count = 1, .reusable = false}, SHIFT(900),
  [1577] = {.count = 1, .reusable = false}, SHIFT(901),
  [1579] = {.count = 1, .reusable = false}, SHIFT(902),
  [1581] = {.count = 1, .reusable = false}, SHIFT(903),
  [1583] = {.count = 1, .reusable = true}, SHIFT(904),
  [1585] = {.count = 1, .reusable = false}, SHIFT(904),
  [1587] = {.count = 1, .reusable = true}, SHIFT(905),
  [1589] = {.count = 1, .reusable = true}, SHIFT(205),
  [1591] = {.count = 1, .reusable = false}, SHIFT(212),
  [1593] = {.count = 1, .reusable = true}, SHIFT(913),
  [1595] = {.count = 1, .reusable = true}, SHIFT(914),
  [1597] = {.count = 1, .reusable = true}, SHIFT(916),
  [1599] = {.count = 1, .reusable = true}, SHIFT(917),
  [1601] = {.count = 1, .reusable = true}, SHIFT(918),
  [1603] = {.count = 1, .reusable = false}, SHIFT(920),
  [1605] = {.count = 1, .reusable = true}, SHIFT(925),
  [1607] = {.count = 1, .reusable = true}, SHIFT(926),
  [1609] = {.count = 1, .reusable = true}, SHIFT(927),
  [1611] = {.count = 1, .reusable = true}, SHIFT(928),
  [1613] = {.count = 1, .reusable = true}, SHIFT(929),
  [1615] = {.count = 1, .reusable = true}, SHIFT(930),
  [1617] = {.count = 1, .reusable = false}, SHIFT(931),
  [1619] = {.count = 1, .reusable = false}, SHIFT(932),
  [1621] = {.count = 1, .reusable = false}, SHIFT(933),
  [1623] = {.count = 1, .reusable = false}, SHIFT(934),
  [1625] = {.count = 1, .reusable = false}, SHIFT(935),
  [1627] = {.count = 1, .reusable = true}, SHIFT(936),
  [1629] = {.count = 1, .reusable = false}, SHIFT(936),
  [1631] = {.count = 1, .reusable = true}, SHIFT(937),
  [1633] = {.count = 1, .reusable = false}, SHIFT(938),
  [1635] = {.count = 1, .reusable = true}, SHIFT(940),
  [1637] = {.count = 1, .reusable = false}, SHIFT(940),
  [1639] = {.count = 1, .reusable = false}, SHIFT(913),
  [1641] = {.count = 1, .reusable = true}, REDUCE(sym__argument, 1),
  [1643] = {.count = 1, .reusable = true}, SHIFT(950),
  [1645] = {.count = 1, .reusable = true}, SHIFT(951),
  [1647] = {.count = 1, .reusable = false}, REDUCE(sym__argument, 1),
  [1649] = {.count = 1, .reusable = false}, SHIFT(952),
  [1651] = {.count = 1, .reusable = true}, SHIFT(953),
  [1653] = {.count = 1, .reusable = false}, SHIFT(954),
  [1655] = {.count = 1, .reusable = false}, SHIFT(955),
  [1657] = {.count = 1, .reusable = true}, SHIFT(956),
  [1659] = {.count = 1, .reusable = true}, SHIFT(957),
  [1661] = {.count = 1, .reusable = false}, SHIFT(958),
  [1663] = {.count = 1, .reusable = true}, SHIFT(958),
  [1665] = {.count = 1, .reusable = true}, SHIFT(960),
  [1667] = {.count = 1, .reusable = true}, SHIFT(961),
  [1669] = {.count = 1, .reusable = false}, SHIFT(960),
  [1671] = {.count = 1, .reusable = true}, SHIFT(955),
  [1673] = {.count = 1, .reusable = true}, SHIFT(952),
  [1675] = {.count = 1, .reusable = true}, SHIFT(962),
  [1677] = {.count = 1, .reusable = false}, SHIFT(963),
  [1679] = {.count = 1, .reusable = true}, SHIFT(964),
  [1681] = {.count = 1, .reusable = true}, SHIFT(965),
  [1683] = {.count = 1, .reusable = true}, SHIFT(963),
  [1685] = {.count = 1, .reusable = true}, SHIFT(966),
  [1687] = {.count = 1, .reusable = true}, SHIFT(967),
  [1689] = {.count = 1, .reusable = true}, SHIFT(968),
  [1691] = {.count = 1, .reusable = true}, SHIFT(969),
  [1693] = {.count = 1, .reusable = false}, SHIFT(971),
  [1695] = {.count = 1, .reusable = true}, SHIFT(972),
  [1697] = {.count = 1, .reusable = false}, SHIFT(973),
  [1699] = {.count = 1, .reusable = true}, REDUCE(sym_return, 2),
  [1701] = {.count = 1, .reusable = false}, REDUCE(sym_return, 2),
  [1703] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 1),
  [1705] = {.count = 1, .reusable = true}, SHIFT(980),
  [1707] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 1),
  [1709] = {.count = 1, .reusable = true}, SHIFT(982),
  [1711] = {.count = 1, .reusable = true}, SHIFT(984),
  [1713] = {.count = 1, .reusable = false}, SHIFT(984),
  [1715] = {.count = 1, .reusable = true}, SHIFT(985),
  [1717] = {.count = 1, .reusable = false}, SHIFT(956),
  [1719] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [1721] = {.count = 1, .reusable = false}, REDUCE(sym_yield, 2),
  [1723] = {.count = 1, .reusable = true}, REDUCE(sym_break, 2),
  [1725] = {.count = 1, .reusable = false}, REDUCE(sym_break, 2),
  [1727] = {.count = 1, .reusable = true}, REDUCE(sym_next, 2),
  [1729] = {.count = 1, .reusable = false}, REDUCE(sym_next, 2),
  [1731] = {.count = 1, .reusable = true}, SHIFT(988),
  [1733] = {.count = 1, .reusable = true}, SHIFT(989),
  [1735] = {.count = 1, .reusable = true}, SHIFT(990),
  [1737] = {.count = 1, .reusable = true}, SHIFT(991),
  [1739] = {.count = 1, .reusable = false}, SHIFT(993),
  [1741] = {.count = 1, .reusable = false}, SHIFT(994),
  [1743] = {.count = 1, .reusable = false}, SHIFT(995),
  [1745] = {.count = 1, .reusable = false}, SHIFT(996),
  [1747] = {.count = 1, .reusable = true}, SHIFT(998),
  [1749] = {.count = 1, .reusable = false}, SHIFT(998),
  [1751] = {.count = 1, .reusable = false}, SHIFT(999),
  [1753] = {.count = 1, .reusable = true}, SHIFT(999),
  [1755] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1757] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1759] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1761] = {.count = 1, .reusable = true}, SHIFT(1010),
  [1763] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1765] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1767] = {.count = 1, .reusable = true}, SHIFT(1012),
  [1769] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1771] = {.count = 1, .reusable = true}, SHIFT(1014),
  [1773] = {.count = 1, .reusable = true}, SHIFT(1015),
  [1775] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1777] = {.count = 1, .reusable = true}, SHIFT(1017),
  [1779] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1781] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1783] = {.count = 1, .reusable = false}, SHIFT(1021),
  [1785] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1787] = {.count = 1, .reusable = false}, SHIFT(1023),
  [1789] = {.count = 1, .reusable = false}, SHIFT(1024),
  [1791] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1793] = {.count = 1, .reusable = false}, SHIFT(1026),
  [1795] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1797] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1799] = {.count = 1, .reusable = true}, SHIFT(1028),
  [1801] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1803] = {.count = 1, .reusable = false}, SHIFT(1028),
  [1805] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1807] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1809] = {.count = 1, .reusable = true}, SHIFT(1030),
  [1811] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1813] = {.count = 1, .reusable = true}, SHIFT(1032),
  [1815] = {.count = 1, .reusable = true}, SHIFT(1033),
  [1817] = {.count = 1, .reusable = true}, SHIFT(1034),
  [1819] = {.count = 1, .reusable = false}, SHIFT(1036),
  [1821] = {.count = 1, .reusable = false}, SHIFT(1037),
  [1823] = {.count = 1, .reusable = false}, SHIFT(1038),
  [1825] = {.count = 1, .reusable = false}, SHIFT(1039),
  [1827] = {.count = 1, .reusable = true}, SHIFT(1041),
  [1829] = {.count = 1, .reusable = false}, SHIFT(1041),
  [1831] = {.count = 1, .reusable = false}, SHIFT(1042),
  [1833] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1835] = {.count = 1, .reusable = false}, SHIFT(1043),
  [1837] = {.count = 1, .reusable = true}, SHIFT(1045),
  [1839] = {.count = 1, .reusable = false}, SHIFT(1045),
  [1841] = {.count = 1, .reusable = true}, SHIFT(1051),
  [1843] = {.count = 1, .reusable = false}, SHIFT(1051),
  [1845] = {.count = 1, .reusable = true}, SHIFT(1052),
  [1847] = {.count = 1, .reusable = true}, SHIFT(1055),
  [1849] = {.count = 1, .reusable = true}, SHIFT(1054),
  [1851] = {.count = 1, .reusable = true}, SHIFT(1057),
  [1853] = {.count = 1, .reusable = true}, SHIFT(1058),
  [1855] = {.count = 1, .reusable = true}, SHIFT(1059),
  [1857] = {.count = 1, .reusable = true}, SHIFT(1060),
  [1859] = {.count = 1, .reusable = false}, SHIFT(1062),
  [1861] = {.count = 1, .reusable = false}, SHIFT(1063),
  [1863] = {.count = 1, .reusable = false}, SHIFT(1064),
  [1865] = {.count = 1, .reusable = false}, SHIFT(1065),
  [1867] = {.count = 1, .reusable = true}, SHIFT(1067),
  [1869] = {.count = 1, .reusable = false}, SHIFT(1067),
  [1871] = {.count = 1, .reusable = false}, SHIFT(1068),
  [1873] = {.count = 1, .reusable = true}, SHIFT(1068),
  [1875] = {.count = 1, .reusable = false}, SHIFT(1069),
  [1877] = {.count = 1, .reusable = true}, SHIFT(1071),
  [1879] = {.count = 1, .reusable = false}, SHIFT(1071),
  [1881] = {.count = 1, .reusable = true}, SHIFT(1091),
  [1883] = {.count = 1, .reusable = true}, SHIFT(1079),
  [1885] = {.count = 1, .reusable = true}, SHIFT(1080),
  [1887] = {.count = 1, .reusable = false}, SHIFT(1081),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1082),
  [1891] = {.count = 1, .reusable = false}, SHIFT(1083),
  [1893] = {.count = 1, .reusable = false}, SHIFT(1084),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1085),
  [1897] = {.count = 1, .reusable = false}, SHIFT(1086),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1086),
  [1901] = {.count = 1, .reusable = true}, SHIFT(1087),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1088),
  [1905] = {.count = 1, .reusable = true}, SHIFT(1089),
  [1907] = {.count = 1, .reusable = false}, SHIFT(1088),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1084),
  [1911] = {.count = 1, .reusable = true}, SHIFT(1081),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1090),
  [1915] = {.count = 1, .reusable = true}, SHIFT(1092),
  [1917] = {.count = 1, .reusable = true}, SHIFT(1093),
  [1919] = {.count = 1, .reusable = true}, SHIFT(1094),
  [1921] = {.count = 1, .reusable = true}, SHIFT(1095),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1096),
  [1925] = {.count = 1, .reusable = false}, SHIFT(1098),
  [1927] = {.count = 1, .reusable = false}, SHIFT(1099),
  [1929] = {.count = 1, .reusable = false}, SHIFT(1100),
  [1931] = {.count = 1, .reusable = false}, SHIFT(1101),
  [1933] = {.count = 1, .reusable = false}, SHIFT(422),
  [1935] = {.count = 1, .reusable = false}, SHIFT(423),
  [1937] = {.count = 1, .reusable = false}, SHIFT(424),
  [1939] = {.count = 1, .reusable = false}, SHIFT(425),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1103),
  [1943] = {.count = 1, .reusable = false}, SHIFT(1103),
  [1945] = {.count = 1, .reusable = false}, SHIFT(1104),
  [1947] = {.count = 1, .reusable = true}, SHIFT(1104),
  [1949] = {.count = 1, .reusable = false}, SHIFT(1105),
  [1951] = {.count = 1, .reusable = true}, SHIFT(1107),
  [1953] = {.count = 1, .reusable = false}, SHIFT(1107),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1114),
  [1957] = {.count = 1, .reusable = false}, SHIFT(1114),
  [1959] = {.count = 1, .reusable = true}, SHIFT(1115),
  [1961] = {.count = 1, .reusable = true}, SHIFT(1117),
  [1963] = {.count = 1, .reusable = false}, REDUCE(sym_rest_assignment, 1),
  [1965] = {.count = 1, .reusable = true}, SHIFT(1118),
  [1967] = {.count = 1, .reusable = true}, SHIFT(1119),
  [1969] = {.count = 1, .reusable = true}, SHIFT(1120),
  [1971] = {.count = 1, .reusable = true}, SHIFT(1121),
  [1973] = {.count = 1, .reusable = true}, SHIFT(1122),
  [1975] = {.count = 1, .reusable = false}, SHIFT(1123),
  [1977] = {.count = 1, .reusable = false}, SHIFT(1124),
  [1979] = {.count = 1, .reusable = false}, SHIFT(1125),
  [1981] = {.count = 1, .reusable = false}, SHIFT(1126),
  [1983] = {.count = 1, .reusable = false}, SHIFT(1127),
  [1985] = {.count = 1, .reusable = true}, SHIFT(1128),
  [1987] = {.count = 1, .reusable = false}, SHIFT(1128),
  [1989] = {.count = 1, .reusable = true}, SHIFT(1129),
  [1991] = {.count = 1, .reusable = false}, SHIFT(1130),
  [1993] = {.count = 1, .reusable = true}, SHIFT(1132),
  [1995] = {.count = 1, .reusable = false}, SHIFT(1132),
  [1997] = {.count = 1, .reusable = true}, SHIFT(1138),
  [1999] = {.count = 1, .reusable = true}, SHIFT(1140),
  [2001] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2003] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2005] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2007] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2009] = {.count = 1, .reusable = false}, SHIFT(1147),
  [2011] = {.count = 1, .reusable = false}, SHIFT(1148),
  [2013] = {.count = 1, .reusable = false}, SHIFT(1149),
  [2015] = {.count = 1, .reusable = false}, SHIFT(1150),
  [2017] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2019] = {.count = 1, .reusable = false}, SHIFT(1152),
  [2021] = {.count = 1, .reusable = false}, SHIFT(1153),
  [2023] = {.count = 1, .reusable = true}, SHIFT(1153),
  [2025] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2027] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2029] = {.count = 1, .reusable = false}, SHIFT(1156),
  [2031] = {.count = 1, .reusable = true}, SHIFT(1176),
  [2033] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2035] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2037] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2039] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2041] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2043] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2045] = {.count = 1, .reusable = true}, SHIFT(1170),
  [2047] = {.count = 1, .reusable = false}, SHIFT(1171),
  [2049] = {.count = 1, .reusable = true}, SHIFT(1171),
  [2051] = {.count = 1, .reusable = true}, SHIFT(1172),
  [2053] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2055] = {.count = 1, .reusable = true}, SHIFT(1174),
  [2057] = {.count = 1, .reusable = false}, SHIFT(1173),
  [2059] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2061] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1177),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2071] = {.count = 1, .reusable = true}, SHIFT(1182),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1180),
  [2075] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1183),
  [2079] = {.count = 1, .reusable = true}, REDUCE(sym__terminator, 1),
  [2081] = {.count = 1, .reusable = false}, REDUCE(sym__terminator, 1),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1186),
  [2085] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2089] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2091] = {.count = 1, .reusable = false}, SHIFT(1191),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1192),
  [2095] = {.count = 1, .reusable = false}, SHIFT(1193),
  [2097] = {.count = 1, .reusable = false}, SHIFT(1194),
  [2099] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2101] = {.count = 1, .reusable = false}, SHIFT(1196),
  [2103] = {.count = 1, .reusable = false}, SHIFT(1197),
  [2105] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2107] = {.count = 1, .reusable = false}, SHIFT(1198),
  [2109] = {.count = 1, .reusable = true}, SHIFT(1200),
  [2111] = {.count = 1, .reusable = false}, SHIFT(1200),
  [2113] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2115] = {.count = 1, .reusable = true}, SHIFT(1207),
  [2117] = {.count = 1, .reusable = false}, SHIFT(1208),
  [2119] = {.count = 1, .reusable = false}, SHIFT(1209),
  [2121] = {.count = 1, .reusable = false}, SHIFT(1210),
  [2123] = {.count = 1, .reusable = false}, SHIFT(1211),
  [2125] = {.count = 1, .reusable = false}, SHIFT(1216),
  [2127] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2129] = {.count = 1, .reusable = false}, SHIFT(1213),
  [2131] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2133] = {.count = 1, .reusable = false}, SHIFT(1214),
  [2135] = {.count = 1, .reusable = true}, SHIFT(1215),
  [2137] = {.count = 1, .reusable = false}, SHIFT(1220),
  [2139] = {.count = 1, .reusable = true}, SHIFT(1220),
  [2141] = {.count = 1, .reusable = true}, SHIFT(1243),
  [2143] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2145] = {.count = 1, .reusable = true}, SHIFT(1226),
  [2147] = {.count = 1, .reusable = false}, REDUCE(sym_else, 1),
  [2149] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2151] = {.count = 1, .reusable = false}, SHIFT(1228),
  [2153] = {.count = 1, .reusable = false}, SHIFT(1229),
  [2155] = {.count = 1, .reusable = false}, SHIFT(1230),
  [2157] = {.count = 1, .reusable = false}, SHIFT(1231),
  [2159] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2161] = {.count = 1, .reusable = false}, SHIFT(1232),
  [2163] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2165] = {.count = 1, .reusable = false}, SHIFT(1239),
  [2167] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2169] = {.count = 1, .reusable = false}, SHIFT(1234),
  [2171] = {.count = 1, .reusable = true}, SHIFT(1244),
  [2173] = {.count = 1, .reusable = false}, REDUCE(sym_ensure, 1),
  [2175] = {.count = 1, .reusable = false}, SHIFT(1245),
  [2177] = {.count = 1, .reusable = false}, SHIFT(1246),
  [2179] = {.count = 1, .reusable = false}, SHIFT(1247),
  [2181] = {.count = 1, .reusable = false}, SHIFT(1248),
  [2183] = {.count = 1, .reusable = false}, SHIFT(1249),
  [2185] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2187] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2189] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2191] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2193] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2195] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2197] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2199] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2201] = {.count = 1, .reusable = true}, SHIFT(288),
  [2203] = {.count = 1, .reusable = true}, SHIFT(289),
  [2205] = {.count = 1, .reusable = true}, SHIFT(290),
  [2207] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2209] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2211] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2213] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2215] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2219] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 2),
  [2221] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 2),
  [2223] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1276),
  [2227] = {.count = 1, .reusable = false}, SHIFT(1277),
  [2229] = {.count = 1, .reusable = true}, SHIFT(1278),
  [2231] = {.count = 1, .reusable = false}, SHIFT(1279),
  [2233] = {.count = 1, .reusable = false}, SHIFT(1280),
  [2235] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2237] = {.count = 1, .reusable = false}, SHIFT(1282),
  [2239] = {.count = 1, .reusable = true}, SHIFT(1282),
  [2241] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2243] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2245] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2247] = {.count = 1, .reusable = false}, SHIFT(1284),
  [2249] = {.count = 1, .reusable = true}, SHIFT(1280),
  [2251] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2253] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2255] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2257] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2259] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2261] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2263] = {.count = 1, .reusable = false}, SHIFT(1292),
  [2265] = {.count = 1, .reusable = false}, SHIFT(1293),
  [2267] = {.count = 1, .reusable = false}, SHIFT(1294),
  [2269] = {.count = 1, .reusable = false}, SHIFT(1295),
  [2271] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2273] = {.count = 1, .reusable = false}, SHIFT(1297),
  [2275] = {.count = 1, .reusable = false}, SHIFT(1298),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1298),
  [2279] = {.count = 1, .reusable = false}, SHIFT(1299),
  [2281] = {.count = 1, .reusable = true}, SHIFT(1301),
  [2283] = {.count = 1, .reusable = false}, SHIFT(1301),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2287] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2289] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2291] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2293] = {.count = 1, .reusable = true}, REDUCE(sym_unary, 2),
  [2295] = {.count = 1, .reusable = false}, REDUCE(sym_unary, 2),
  [2297] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 2),
  [2299] = {.count = 1, .reusable = true}, SHIFT(1311),
  [2301] = {.count = 1, .reusable = true}, SHIFT(1313),
  [2303] = {.count = 1, .reusable = false}, SHIFT(1315),
  [2305] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2307] = {.count = 1, .reusable = true}, REDUCE(sym_rational, 2),
  [2309] = {.count = 1, .reusable = false}, REDUCE(sym_rational, 2),
  [2311] = {.count = 1, .reusable = true}, SHIFT(1317),
  [2313] = {.count = 1, .reusable = true}, SHIFT(1319),
  [2315] = {.count = 1, .reusable = true}, SHIFT(1321),
  [2317] = {.count = 1, .reusable = true}, SHIFT(1323),
  [2319] = {.count = 1, .reusable = true}, SHIFT(1325),
  [2321] = {.count = 1, .reusable = false}, SHIFT(1326),
  [2323] = {.count = 1, .reusable = true}, SHIFT(1328),
  [2325] = {.count = 1, .reusable = false}, SHIFT(1329),
  [2327] = {.count = 1, .reusable = true}, SHIFT(1331),
  [2329] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2331] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2333] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2335] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2337] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2339] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2341] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2343] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2345] = {.count = 1, .reusable = false}, SHIFT(1340),
  [2347] = {.count = 1, .reusable = true}, SHIFT(1340),
  [2349] = {.count = 1, .reusable = true}, SHIFT(1347),
  [2351] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2353] = {.count = 1, .reusable = true}, SHIFT(1351),
  [2355] = {.count = 1, .reusable = false}, SHIFT(1353),
  [2357] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2359] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2363] = {.count = 1, .reusable = false}, SHIFT(1360),
  [2365] = {.count = 1, .reusable = false}, SHIFT(1362),
  [2367] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2369] = {.count = 1, .reusable = true}, SHIFT(1365),
  [2371] = {.count = 1, .reusable = true}, SHIFT(1366),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1367),
  [2375] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2377] = {.count = 1, .reusable = false}, SHIFT(1370),
  [2379] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2381] = {.count = 1, .reusable = true}, SHIFT(1371),
  [2383] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2385] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2387] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2389] = {.count = 1, .reusable = false}, SHIFT(1394),
  [2391] = {.count = 1, .reusable = true}, REDUCE(sym_array, 2),
  [2393] = {.count = 1, .reusable = false}, REDUCE(sym_array, 2),
  [2395] = {.count = 1, .reusable = false}, SHIFT(1347),
  [2397] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2399] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2401] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2403] = {.count = 1, .reusable = false}, SHIFT(1404),
  [2405] = {.count = 1, .reusable = true}, SHIFT(1407),
  [2407] = {.count = 1, .reusable = true}, SHIFT(1408),
  [2409] = {.count = 1, .reusable = false}, SHIFT(1409),
  [2411] = {.count = 1, .reusable = true}, SHIFT(1410),
  [2413] = {.count = 1, .reusable = false}, SHIFT(1411),
  [2415] = {.count = 1, .reusable = false}, SHIFT(1412),
  [2417] = {.count = 1, .reusable = true}, SHIFT(1413),
  [2419] = {.count = 1, .reusable = true}, SHIFT(1414),
  [2421] = {.count = 1, .reusable = false}, SHIFT(1415),
  [2423] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2425] = {.count = 1, .reusable = true}, SHIFT(1416),
  [2427] = {.count = 1, .reusable = true}, SHIFT(1417),
  [2429] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2431] = {.count = 1, .reusable = false}, SHIFT(1417),
  [2433] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2435] = {.count = 1, .reusable = true}, SHIFT(1409),
  [2437] = {.count = 1, .reusable = true}, SHIFT(1419),
  [2439] = {.count = 1, .reusable = false}, SHIFT(1420),
  [2441] = {.count = 1, .reusable = true}, SHIFT(1421),
  [2443] = {.count = 1, .reusable = true}, SHIFT(1422),
  [2445] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2447] = {.count = 1, .reusable = true}, SHIFT(1423),
  [2449] = {.count = 1, .reusable = true}, SHIFT(1424),
  [2451] = {.count = 1, .reusable = true}, SHIFT(1425),
  [2453] = {.count = 1, .reusable = true}, SHIFT(1426),
  [2455] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2457] = {.count = 1, .reusable = false}, SHIFT(1429),
  [2459] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2461] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2463] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2465] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2467] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2469] = {.count = 1, .reusable = false}, SHIFT(1435),
  [2471] = {.count = 1, .reusable = false}, SHIFT(1436),
  [2473] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2475] = {.count = 1, .reusable = false}, SHIFT(1437),
  [2477] = {.count = 1, .reusable = true}, SHIFT(1439),
  [2479] = {.count = 1, .reusable = false}, SHIFT(1439),
  [2481] = {.count = 1, .reusable = true}, SHIFT(1447),
  [2483] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 1),
  [2485] = {.count = 1, .reusable = true}, SHIFT(1449),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1450),
  [2489] = {.count = 1, .reusable = false}, SHIFT(1450),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1451),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1413),
  [2495] = {.count = 1, .reusable = true}, SHIFT(1453),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1454),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1457),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1458),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1459),
  [2505] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 1),
  [2507] = {.count = 1, .reusable = false}, REDUCE(sym_splat_parameter, 1),
  [2509] = {.count = 1, .reusable = false}, SHIFT(1461),
  [2511] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 1),
  [2513] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_parameter, 1),
  [2515] = {.count = 1, .reusable = false}, SHIFT(1462),
  [2517] = {.count = 1, .reusable = true}, SHIFT(1463),
  [2519] = {.count = 1, .reusable = true}, SHIFT(1468),
  [2521] = {.count = 1, .reusable = true}, SHIFT(1464),
  [2523] = {.count = 1, .reusable = false}, SHIFT(1465),
  [2525] = {.count = 1, .reusable = true}, REDUCE(sym__simple_formal_parameter, 1),
  [2527] = {.count = 1, .reusable = true}, SHIFT(1469),
  [2529] = {.count = 1, .reusable = true}, SHIFT(1470),
  [2531] = {.count = 1, .reusable = true}, SHIFT(373),
  [2533] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [2535] = {.count = 1, .reusable = true}, SHIFT(1472),
  [2537] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 2),
  [2539] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 2),
  [2541] = {.count = 1, .reusable = true}, SHIFT(1474),
  [2543] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 2),
  [2545] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 2),
  [2547] = {.count = 1, .reusable = true}, SHIFT(1476),
  [2549] = {.count = 1, .reusable = true}, SHIFT(1489),
  [2551] = {.count = 1, .reusable = true}, SHIFT(1490),
  [2553] = {.count = 1, .reusable = false}, SHIFT(1491),
  [2555] = {.count = 1, .reusable = false}, SHIFT(1492),
  [2557] = {.count = 1, .reusable = false}, SHIFT(1493),
  [2559] = {.count = 1, .reusable = false}, SHIFT(1494),
  [2561] = {.count = 1, .reusable = false}, SHIFT(1495),
  [2563] = {.count = 1, .reusable = true}, SHIFT(1496),
  [2565] = {.count = 1, .reusable = false}, SHIFT(1496),
  [2567] = {.count = 1, .reusable = true}, SHIFT(1497),
  [2569] = {.count = 1, .reusable = false}, SHIFT(1499),
  [2571] = {.count = 1, .reusable = true}, SHIFT(1499),
  [2573] = {.count = 1, .reusable = true}, SHIFT(1508),
  [2575] = {.count = 1, .reusable = true}, SHIFT(1509),
  [2577] = {.count = 1, .reusable = false}, SHIFT(1509),
  [2579] = {.count = 1, .reusable = true}, SHIFT(1510),
  [2581] = {.count = 1, .reusable = true}, SHIFT(1511),
  [2583] = {.count = 1, .reusable = true}, SHIFT(1514),
  [2585] = {.count = 1, .reusable = true}, SHIFT(1517),
  [2587] = {.count = 1, .reusable = true}, SHIFT(1518),
  [2589] = {.count = 1, .reusable = true}, SHIFT(1520),
  [2591] = {.count = 1, .reusable = true}, SHIFT(1522),
  [2593] = {.count = 1, .reusable = true}, SHIFT(1524),
  [2595] = {.count = 1, .reusable = true}, SHIFT(1526),
  [2597] = {.count = 1, .reusable = false}, SHIFT(1527),
  [2599] = {.count = 1, .reusable = true}, SHIFT(1529),
  [2601] = {.count = 1, .reusable = false}, SHIFT(1530),
  [2603] = {.count = 1, .reusable = true}, SHIFT(1532),
  [2605] = {.count = 1, .reusable = true}, SHIFT(1533),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1534),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1535),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1536),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1537),
  [2615] = {.count = 1, .reusable = true}, SHIFT(1538),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1563),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1539),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1540),
  [2623] = {.count = 1, .reusable = false}, SHIFT(1541),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1542),
  [2627] = {.count = 1, .reusable = false}, SHIFT(1543),
  [2629] = {.count = 1, .reusable = false}, SHIFT(1544),
  [2631] = {.count = 1, .reusable = false}, SHIFT(1545),
  [2633] = {.count = 1, .reusable = false}, SHIFT(1546),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1547),
  [2637] = {.count = 1, .reusable = false}, SHIFT(1548),
  [2639] = {.count = 1, .reusable = false}, SHIFT(1563),
  [2641] = {.count = 1, .reusable = false}, SHIFT(1549),
  [2643] = {.count = 1, .reusable = false}, SHIFT(1550),
  [2645] = {.count = 1, .reusable = false}, SHIFT(1551),
  [2647] = {.count = 1, .reusable = false}, SHIFT(1552),
  [2649] = {.count = 1, .reusable = false}, SHIFT(1553),
  [2651] = {.count = 1, .reusable = false}, SHIFT(1554),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1555),
  [2655] = {.count = 1, .reusable = false}, SHIFT(1556),
  [2657] = {.count = 1, .reusable = true}, SHIFT(1557),
  [2659] = {.count = 1, .reusable = false}, SHIFT(1557),
  [2661] = {.count = 1, .reusable = true}, SHIFT(1558),
  [2663] = {.count = 1, .reusable = false}, SHIFT(1564),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1564),
  [2667] = {.count = 1, .reusable = false}, SHIFT(1559),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1560),
  [2671] = {.count = 1, .reusable = true}, SHIFT(1561),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1569),
  [2675] = {.count = 1, .reusable = true}, SHIFT(414),
  [2677] = {.count = 1, .reusable = false}, SHIFT(431),
  [2679] = {.count = 1, .reusable = true}, SHIFT(436),
  [2681] = {.count = 1, .reusable = true}, SHIFT(1572),
  [2683] = {.count = 1, .reusable = true}, SHIFT(1573),
  [2685] = {.count = 1, .reusable = true}, SHIFT(1574),
  [2687] = {.count = 1, .reusable = false}, SHIFT(1575),
  [2689] = {.count = 1, .reusable = false}, SHIFT(1576),
  [2691] = {.count = 1, .reusable = false}, SHIFT(1577),
  [2693] = {.count = 1, .reusable = false}, SHIFT(1578),
  [2695] = {.count = 1, .reusable = false}, SHIFT(1579),
  [2697] = {.count = 1, .reusable = true}, SHIFT(1580),
  [2699] = {.count = 1, .reusable = false}, SHIFT(1580),
  [2701] = {.count = 1, .reusable = true}, SHIFT(1581),
  [2703] = {.count = 1, .reusable = false}, SHIFT(1582),
  [2705] = {.count = 1, .reusable = true}, SHIFT(1586),
  [2707] = {.count = 1, .reusable = false}, SHIFT(1586),
  [2709] = {.count = 1, .reusable = true}, SHIFT(1592),
  [2711] = {.count = 1, .reusable = false}, SHIFT(1594),
  [2713] = {.count = 1, .reusable = true}, SHIFT(1596),
  [2715] = {.count = 1, .reusable = true}, SHIFT(1599),
  [2717] = {.count = 1, .reusable = false}, SHIFT(1600),
  [2719] = {.count = 1, .reusable = false}, SHIFT(1602),
  [2721] = {.count = 1, .reusable = true}, SHIFT(1616),
  [2723] = {.count = 1, .reusable = false}, SHIFT(1613),
  [2725] = {.count = 1, .reusable = true}, SHIFT(1618),
  [2727] = {.count = 1, .reusable = true}, SHIFT(1624),
  [2729] = {.count = 1, .reusable = false}, SHIFT(1623),
  [2731] = {.count = 1, .reusable = true}, SHIFT(1625),
  [2733] = {.count = 1, .reusable = false}, SHIFT(1572),
  [2735] = {.count = 1, .reusable = false}, SHIFT(1631),
  [2737] = {.count = 1, .reusable = true}, SHIFT(1632),
  [2739] = {.count = 1, .reusable = true}, SHIFT(1635),
  [2741] = {.count = 1, .reusable = true}, SHIFT(1638),
  [2743] = {.count = 1, .reusable = true}, SHIFT(1639),
  [2745] = {.count = 1, .reusable = false}, SHIFT(1640),
  [2747] = {.count = 1, .reusable = false}, SHIFT(1641),
  [2749] = {.count = 1, .reusable = false}, SHIFT(1642),
  [2751] = {.count = 1, .reusable = false}, SHIFT(1643),
  [2753] = {.count = 1, .reusable = true}, SHIFT(1644),
  [2755] = {.count = 1, .reusable = true}, SHIFT(1645),
  [2757] = {.count = 1, .reusable = false}, SHIFT(1646),
  [2759] = {.count = 1, .reusable = true}, SHIFT(1646),
  [2761] = {.count = 1, .reusable = false}, SHIFT(1648),
  [2763] = {.count = 1, .reusable = false}, SHIFT(1649),
  [2765] = {.count = 1, .reusable = true}, SHIFT(1648),
  [2767] = {.count = 1, .reusable = true}, SHIFT(1643),
  [2769] = {.count = 1, .reusable = false}, SHIFT(1650),
  [2771] = {.count = 1, .reusable = true}, SHIFT(1651),
  [2773] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 2),
  [2775] = {.count = 1, .reusable = true}, SHIFT(1653),
  [2777] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 2),
  [2779] = {.count = 1, .reusable = true}, SHIFT(427),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1655),
  [2783] = {.count = 1, .reusable = true}, SHIFT(1657),
  [2785] = {.count = 1, .reusable = true}, SHIFT(1659),
  [2787] = {.count = 1, .reusable = false}, SHIFT(1659),
  [2789] = {.count = 1, .reusable = true}, SHIFT(1660),
  [2791] = {.count = 1, .reusable = false}, SHIFT(1644),
  [2793] = {.count = 1, .reusable = true}, SHIFT(1662),
  [2795] = {.count = 1, .reusable = true}, SHIFT(1663),
  [2797] = {.count = 1, .reusable = false}, SHIFT(1664),
  [2799] = {.count = 1, .reusable = true}, SHIFT(1665),
  [2801] = {.count = 1, .reusable = false}, SHIFT(1665),
  [2803] = {.count = 1, .reusable = true}, SHIFT(1666),
  [2805] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 2),
  [2807] = {.count = 1, .reusable = true}, REDUCE(sym_chained_string, 2),
  [2809] = {.count = 1, .reusable = false}, REDUCE(sym_chained_string, 2),
  [2811] = {.count = 1, .reusable = true}, SHIFT(1676),
  [2813] = {.count = 1, .reusable = true}, SHIFT(1677),
  [2815] = {.count = 1, .reusable = true}, SHIFT(1678),
  [2817] = {.count = 1, .reusable = true}, SHIFT(1679),
  [2819] = {.count = 1, .reusable = true}, SHIFT(1680),
  [2821] = {.count = 1, .reusable = false}, SHIFT(1682),
  [2823] = {.count = 1, .reusable = false}, SHIFT(1683),
  [2825] = {.count = 1, .reusable = false}, SHIFT(1684),
  [2827] = {.count = 1, .reusable = false}, SHIFT(1685),
  [2829] = {.count = 1, .reusable = true}, SHIFT(1687),
  [2831] = {.count = 1, .reusable = false}, SHIFT(1687),
  [2833] = {.count = 1, .reusable = false}, SHIFT(1688),
  [2835] = {.count = 1, .reusable = true}, SHIFT(1688),
  [2837] = {.count = 1, .reusable = false}, SHIFT(1689),
  [2839] = {.count = 1, .reusable = true}, SHIFT(1691),
  [2841] = {.count = 1, .reusable = false}, SHIFT(1691),
  [2843] = {.count = 1, .reusable = true}, SHIFT(1699),
  [2845] = {.count = 1, .reusable = false}, SHIFT(1699),
  [2847] = {.count = 1, .reusable = true}, SHIFT(1701),
  [2849] = {.count = 1, .reusable = true}, SHIFT(1700),
  [2851] = {.count = 1, .reusable = true}, SHIFT(1702),
  [2853] = {.count = 1, .reusable = true}, SHIFT(1703),
  [2855] = {.count = 1, .reusable = true}, SHIFT(1704),
  [2857] = {.count = 1, .reusable = true}, SHIFT(1705),
  [2859] = {.count = 1, .reusable = true}, SHIFT(1706),
  [2861] = {.count = 1, .reusable = true}, SHIFT(1707),
  [2863] = {.count = 1, .reusable = true}, SHIFT(1708),
  [2865] = {.count = 1, .reusable = true}, SHIFT(1709),
  [2867] = {.count = 1, .reusable = true}, SHIFT(1710),
  [2869] = {.count = 1, .reusable = false}, SHIFT(1711),
  [2871] = {.count = 1, .reusable = true}, SHIFT(1712),
  [2873] = {.count = 1, .reusable = false}, SHIFT(1713),
  [2875] = {.count = 1, .reusable = false}, SHIFT(1714),
  [2877] = {.count = 1, .reusable = true}, SHIFT(1715),
  [2879] = {.count = 1, .reusable = false}, SHIFT(1716),
  [2881] = {.count = 1, .reusable = true}, SHIFT(1716),
  [2883] = {.count = 1, .reusable = true}, SHIFT(1717),
  [2885] = {.count = 1, .reusable = true}, SHIFT(1718),
  [2887] = {.count = 1, .reusable = true}, SHIFT(1719),
  [2889] = {.count = 1, .reusable = false}, SHIFT(1718),
  [2891] = {.count = 1, .reusable = true}, SHIFT(1714),
  [2893] = {.count = 1, .reusable = true}, SHIFT(1711),
  [2895] = {.count = 1, .reusable = true}, SHIFT(1720),
  [2897] = {.count = 1, .reusable = false}, SHIFT(1721),
  [2899] = {.count = 1, .reusable = true}, SHIFT(1722),
  [2901] = {.count = 1, .reusable = true}, SHIFT(1723),
  [2903] = {.count = 1, .reusable = true}, SHIFT(1721),
  [2905] = {.count = 1, .reusable = true}, SHIFT(1724),
  [2907] = {.count = 1, .reusable = true}, SHIFT(1725),
  [2909] = {.count = 1, .reusable = true}, SHIFT(1726),
  [2911] = {.count = 1, .reusable = true}, SHIFT(1727),
  [2913] = {.count = 1, .reusable = true}, SHIFT(1728),
  [2915] = {.count = 1, .reusable = false}, SHIFT(1730),
  [2917] = {.count = 1, .reusable = false}, SHIFT(1731),
  [2919] = {.count = 1, .reusable = false}, SHIFT(1732),
  [2921] = {.count = 1, .reusable = false}, SHIFT(1733),
  [2923] = {.count = 1, .reusable = false}, SHIFT(1734),
  [2925] = {.count = 1, .reusable = true}, SHIFT(1735),
  [2927] = {.count = 1, .reusable = true}, SHIFT(1737),
  [2929] = {.count = 1, .reusable = false}, SHIFT(1737),
  [2931] = {.count = 1, .reusable = false}, SHIFT(1738),
  [2933] = {.count = 1, .reusable = true}, SHIFT(1738),
  [2935] = {.count = 1, .reusable = false}, SHIFT(1739),
  [2937] = {.count = 1, .reusable = true}, SHIFT(1741),
  [2939] = {.count = 1, .reusable = false}, SHIFT(1741),
  [2941] = {.count = 1, .reusable = true}, SHIFT(1749),
  [2943] = {.count = 1, .reusable = false}, SHIFT(1749),
  [2945] = {.count = 1, .reusable = true}, SHIFT(1750),
  [2947] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3, .alias_sequence_id = 8),
  [2949] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3, .alias_sequence_id = 8),
  [2951] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(476),
  [2954] = {.count = 1, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [2956] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(58),
  [2959] = {.count = 1, .reusable = true}, REDUCE(sym_symbol, 3, .alias_sequence_id = 9),
  [2961] = {.count = 1, .reusable = false}, REDUCE(sym_symbol, 3, .alias_sequence_id = 9),
  [2963] = {.count = 1, .reusable = true}, REDUCE(sym_subshell, 3, .alias_sequence_id = 10),
  [2965] = {.count = 1, .reusable = false}, REDUCE(sym_subshell, 3, .alias_sequence_id = 10),
  [2967] = {.count = 1, .reusable = true}, REDUCE(sym_regex, 3, .alias_sequence_id = 11),
  [2969] = {.count = 1, .reusable = false}, REDUCE(sym_regex, 3, .alias_sequence_id = 11),
  [2971] = {.count = 1, .reusable = true}, SHIFT(1752),
  [2973] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 12),
  [2975] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 12),
  [2977] = {.count = 1, .reusable = true}, SHIFT(1753),
  [2979] = {.count = 1, .reusable = true}, SHIFT(1754),
  [2981] = {.count = 1, .reusable = true}, SHIFT(1755),
  [2983] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 3, .alias_sequence_id = 13),
  [2985] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 3, .alias_sequence_id = 13),
  [2987] = {.count = 1, .reusable = true}, SHIFT(1757),
  [2989] = {.count = 1, .reusable = true}, SHIFT(1759),
  [2991] = {.count = 2, .reusable = true}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(487),
  [2994] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(68),
  [2997] = {.count = 1, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2),
  [2999] = {.count = 2, .reusable = false}, REDUCE(aux_sym__literal_contents_repeat1, 2), SHIFT_REPEAT(487),
  [3002] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 14),
  [3004] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 14),
  [3006] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3008] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3010] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3012] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 15),
  [3014] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 3, .alias_sequence_id = 15),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3020] = {.count = 1, .reusable = true}, REDUCE(sym_program, 3),
  [3022] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 3),
  [3024] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3026] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3028] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3030] = {.count = 1, .reusable = true}, SHIFT(1773),
  [3032] = {.count = 1, .reusable = false}, SHIFT(1775),
  [3034] = {.count = 1, .reusable = false}, SHIFT(1776),
  [3036] = {.count = 1, .reusable = false}, SHIFT(1777),
  [3038] = {.count = 1, .reusable = false}, SHIFT(1778),
  [3040] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3042] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3044] = {.count = 1, .reusable = false}, SHIFT(1781),
  [3046] = {.count = 1, .reusable = true}, SHIFT(1781),
  [3048] = {.count = 1, .reusable = false}, SHIFT(1782),
  [3050] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3052] = {.count = 1, .reusable = true}, SHIFT(1792),
  [3054] = {.count = 1, .reusable = true}, SHIFT(1793),
  [3056] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3058] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3060] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3062] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3064] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3066] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3068] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3070] = {.count = 1, .reusable = false}, SHIFT(1802),
  [3072] = {.count = 1, .reusable = true}, SHIFT(1803),
  [3074] = {.count = 1, .reusable = false}, SHIFT(1804),
  [3076] = {.count = 1, .reusable = false}, SHIFT(1805),
  [3078] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3080] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3082] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3084] = {.count = 1, .reusable = true}, SHIFT(1808),
  [3086] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3088] = {.count = 1, .reusable = true}, SHIFT(1810),
  [3090] = {.count = 1, .reusable = false}, SHIFT(1809),
  [3092] = {.count = 1, .reusable = true}, SHIFT(1805),
  [3094] = {.count = 1, .reusable = true}, SHIFT(1802),
  [3096] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3098] = {.count = 1, .reusable = true}, SHIFT(1812),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1813),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1815),
  [3106] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3108] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3110] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3112] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3116] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3118] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3120] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3122] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1826),
  [3126] = {.count = 1, .reusable = false}, SHIFT(1826),
  [3128] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3130] = {.count = 1, .reusable = false}, SHIFT(1832),
  [3132] = {.count = 1, .reusable = true}, SHIFT(1833),
  [3134] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3136] = {.count = 1, .reusable = true}, SHIFT(1836),
  [3138] = {.count = 1, .reusable = true}, SHIFT(1837),
  [3140] = {.count = 1, .reusable = true}, SHIFT(1838),
  [3142] = {.count = 1, .reusable = true}, SHIFT(1839),
  [3144] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3146] = {.count = 1, .reusable = true}, SHIFT(1842),
  [3148] = {.count = 1, .reusable = true}, SHIFT(1843),
  [3150] = {.count = 1, .reusable = true}, SHIFT(1845),
  [3152] = {.count = 1, .reusable = false}, SHIFT(1846),
  [3154] = {.count = 1, .reusable = true}, SHIFT(1848),
  [3156] = {.count = 1, .reusable = true}, SHIFT(1849),
  [3158] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 2),
  [3160] = {.count = 1, .reusable = true}, SHIFT(1853),
  [3162] = {.count = 1, .reusable = true}, SHIFT(1852),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1855),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1858),
  [3168] = {.count = 1, .reusable = true}, SHIFT(1859),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1860),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1862),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1863),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1864),
  [3178] = {.count = 1, .reusable = true}, SHIFT(1865),
  [3180] = {.count = 1, .reusable = true}, SHIFT(1866),
  [3182] = {.count = 1, .reusable = false}, SHIFT(1868),
  [3184] = {.count = 1, .reusable = false}, SHIFT(1869),
  [3186] = {.count = 1, .reusable = false}, SHIFT(1870),
  [3188] = {.count = 1, .reusable = false}, SHIFT(1871),
  [3190] = {.count = 1, .reusable = true}, SHIFT(1873),
  [3192] = {.count = 1, .reusable = false}, SHIFT(1873),
  [3194] = {.count = 1, .reusable = false}, SHIFT(1874),
  [3196] = {.count = 1, .reusable = true}, SHIFT(1874),
  [3198] = {.count = 1, .reusable = false}, SHIFT(1875),
  [3200] = {.count = 1, .reusable = true}, SHIFT(1877),
  [3202] = {.count = 1, .reusable = false}, SHIFT(1877),
  [3204] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_argument, 2),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1885),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1886),
  [3210] = {.count = 1, .reusable = false}, SHIFT(1887),
  [3212] = {.count = 1, .reusable = true}, SHIFT(1888),
  [3214] = {.count = 1, .reusable = false}, SHIFT(1889),
  [3216] = {.count = 1, .reusable = false}, SHIFT(1890),
  [3218] = {.count = 1, .reusable = true}, SHIFT(1891),
  [3220] = {.count = 1, .reusable = false}, SHIFT(1892),
  [3222] = {.count = 1, .reusable = true}, SHIFT(1892),
  [3224] = {.count = 1, .reusable = true}, SHIFT(1893),
  [3226] = {.count = 1, .reusable = true}, SHIFT(1894),
  [3228] = {.count = 1, .reusable = true}, SHIFT(1895),
  [3230] = {.count = 1, .reusable = false}, SHIFT(1894),
  [3232] = {.count = 1, .reusable = true}, SHIFT(1890),
  [3234] = {.count = 1, .reusable = true}, SHIFT(1887),
  [3236] = {.count = 1, .reusable = true}, SHIFT(1896),
  [3238] = {.count = 1, .reusable = false}, SHIFT(1897),
  [3240] = {.count = 1, .reusable = true}, SHIFT(1898),
  [3242] = {.count = 1, .reusable = true}, SHIFT(1899),
  [3244] = {.count = 1, .reusable = true}, SHIFT(1897),
  [3246] = {.count = 1, .reusable = true}, SHIFT(1900),
  [3248] = {.count = 1, .reusable = true}, SHIFT(1901),
  [3250] = {.count = 1, .reusable = true}, SHIFT(1902),
  [3252] = {.count = 1, .reusable = true}, SHIFT(1903),
  [3254] = {.count = 1, .reusable = true}, SHIFT(1904),
  [3256] = {.count = 1, .reusable = false}, SHIFT(1906),
  [3258] = {.count = 1, .reusable = false}, SHIFT(1907),
  [3260] = {.count = 1, .reusable = false}, SHIFT(1908),
  [3262] = {.count = 1, .reusable = false}, SHIFT(1909),
  [3264] = {.count = 1, .reusable = false}, SHIFT(1910),
  [3266] = {.count = 1, .reusable = true}, SHIFT(1912),
  [3268] = {.count = 1, .reusable = false}, SHIFT(1912),
  [3270] = {.count = 1, .reusable = false}, SHIFT(1913),
  [3272] = {.count = 1, .reusable = true}, SHIFT(1913),
  [3274] = {.count = 1, .reusable = false}, SHIFT(1914),
  [3276] = {.count = 1, .reusable = true}, SHIFT(1916),
  [3278] = {.count = 1, .reusable = false}, SHIFT(1916),
  [3280] = {.count = 1, .reusable = true}, SHIFT(1924),
  [3282] = {.count = 1, .reusable = false}, SHIFT(1924),
  [3284] = {.count = 1, .reusable = true}, SHIFT(1925),
  [3286] = {.count = 1, .reusable = true}, SHIFT(1929),
  [3288] = {.count = 1, .reusable = true}, SHIFT(1931),
  [3290] = {.count = 1, .reusable = false}, SHIFT(1930),
  [3292] = {.count = 1, .reusable = true}, SHIFT(1936),
  [3294] = {.count = 1, .reusable = true}, SHIFT(1940),
  [3296] = {.count = 1, .reusable = false}, SHIFT(1936),
  [3298] = {.count = 1, .reusable = true}, SHIFT(1946),
  [3300] = {.count = 1, .reusable = true}, SHIFT(1947),
  [3302] = {.count = 1, .reusable = false}, SHIFT(1948),
  [3304] = {.count = 1, .reusable = true}, SHIFT(1949),
  [3306] = {.count = 1, .reusable = false}, SHIFT(1950),
  [3308] = {.count = 1, .reusable = false}, SHIFT(1951),
  [3310] = {.count = 1, .reusable = true}, SHIFT(1953),
  [3312] = {.count = 1, .reusable = false}, SHIFT(1954),
  [3314] = {.count = 1, .reusable = true}, SHIFT(1954),
  [3316] = {.count = 1, .reusable = true}, SHIFT(1956),
  [3318] = {.count = 1, .reusable = true}, SHIFT(1957),
  [3320] = {.count = 1, .reusable = false}, SHIFT(1956),
  [3322] = {.count = 1, .reusable = true}, SHIFT(1951),
  [3324] = {.count = 1, .reusable = true}, SHIFT(1948),
  [3326] = {.count = 1, .reusable = true}, SHIFT(1958),
  [3328] = {.count = 1, .reusable = true}, SHIFT(1959),
  [3330] = {.count = 1, .reusable = true}, SHIFT(1961),
  [3332] = {.count = 1, .reusable = true}, SHIFT(1963),
  [3334] = {.count = 1, .reusable = false}, SHIFT(1963),
  [3336] = {.count = 1, .reusable = true}, SHIFT(1964),
  [3338] = {.count = 1, .reusable = false}, SHIFT(1952),
  [3340] = {.count = 1, .reusable = true}, SHIFT(1966),
  [3342] = {.count = 1, .reusable = true}, SHIFT(1967),
  [3344] = {.count = 1, .reusable = true}, SHIFT(1968),
  [3346] = {.count = 1, .reusable = true}, SHIFT(1969),
  [3348] = {.count = 1, .reusable = true}, SHIFT(1971),
  [3350] = {.count = 1, .reusable = true}, SHIFT(1973),
  [3352] = {.count = 1, .reusable = true}, SHIFT(1974),
  [3354] = {.count = 1, .reusable = false}, SHIFT(1978),
  [3356] = {.count = 1, .reusable = true}, SHIFT(1979),
  [3358] = {.count = 1, .reusable = true}, SHIFT(1981),
  [3360] = {.count = 1, .reusable = true}, SHIFT(1987),
  [3362] = {.count = 1, .reusable = false}, SHIFT(1984),
  [3364] = {.count = 1, .reusable = true}, SHIFT(612),
  [3366] = {.count = 1, .reusable = true}, SHIFT(2002),
  [3368] = {.count = 1, .reusable = false}, SHIFT(2002),
  [3370] = {.count = 1, .reusable = true}, SHIFT(2003),
  [3372] = {.count = 1, .reusable = true}, SHIFT(2004),
  [3374] = {.count = 1, .reusable = true}, SHIFT(2007),
  [3376] = {.count = 1, .reusable = true}, SHIFT(2010),
  [3378] = {.count = 1, .reusable = true}, SHIFT(2011),
  [3380] = {.count = 1, .reusable = true}, SHIFT(2013),
  [3382] = {.count = 1, .reusable = true}, SHIFT(2015),
  [3384] = {.count = 1, .reusable = true}, SHIFT(2017),
  [3386] = {.count = 1, .reusable = true}, SHIFT(2019),
  [3388] = {.count = 1, .reusable = false}, SHIFT(2020),
  [3390] = {.count = 1, .reusable = true}, SHIFT(2022),
  [3392] = {.count = 1, .reusable = false}, SHIFT(2023),
  [3394] = {.count = 1, .reusable = true}, SHIFT(2025),
  [3396] = {.count = 1, .reusable = true}, SHIFT(644),
  [3398] = {.count = 1, .reusable = false}, SHIFT(661),
  [3400] = {.count = 1, .reusable = true}, SHIFT(666),
  [3402] = {.count = 1, .reusable = true}, SHIFT(2030),
  [3404] = {.count = 1, .reusable = true}, SHIFT(2031),
  [3406] = {.count = 1, .reusable = true}, SHIFT(2036),
  [3408] = {.count = 1, .reusable = false}, SHIFT(2038),
  [3410] = {.count = 1, .reusable = true}, SHIFT(2040),
  [3412] = {.count = 1, .reusable = true}, SHIFT(2043),
  [3414] = {.count = 1, .reusable = false}, SHIFT(2044),
  [3416] = {.count = 1, .reusable = false}, SHIFT(2046),
  [3418] = {.count = 1, .reusable = true}, SHIFT(2060),
  [3420] = {.count = 1, .reusable = false}, SHIFT(2057),
  [3422] = {.count = 1, .reusable = true}, SHIFT(2062),
  [3424] = {.count = 1, .reusable = true}, SHIFT(2068),
  [3426] = {.count = 1, .reusable = false}, SHIFT(2067),
  [3428] = {.count = 1, .reusable = true}, SHIFT(2069),
  [3430] = {.count = 1, .reusable = false}, SHIFT(2030),
  [3432] = {.count = 1, .reusable = false}, SHIFT(2075),
  [3434] = {.count = 1, .reusable = true}, SHIFT(2076),
  [3436] = {.count = 1, .reusable = true}, SHIFT(2079),
  [3438] = {.count = 1, .reusable = true}, SHIFT(2082),
  [3440] = {.count = 1, .reusable = true}, SHIFT(2083),
  [3442] = {.count = 1, .reusable = false}, SHIFT(2084),
  [3444] = {.count = 1, .reusable = false}, SHIFT(2085),
  [3446] = {.count = 1, .reusable = false}, SHIFT(2086),
  [3448] = {.count = 1, .reusable = false}, SHIFT(2087),
  [3450] = {.count = 1, .reusable = true}, SHIFT(2089),
  [3452] = {.count = 1, .reusable = false}, SHIFT(2090),
  [3454] = {.count = 1, .reusable = true}, SHIFT(2090),
  [3456] = {.count = 1, .reusable = false}, SHIFT(2092),
  [3458] = {.count = 1, .reusable = false}, SHIFT(2093),
  [3460] = {.count = 1, .reusable = true}, SHIFT(2092),
  [3462] = {.count = 1, .reusable = true}, SHIFT(2087),
  [3464] = {.count = 1, .reusable = false}, SHIFT(2094),
  [3466] = {.count = 1, .reusable = true}, SHIFT(2095),
  [3468] = {.count = 1, .reusable = true}, SHIFT(2097),
  [3470] = {.count = 1, .reusable = true}, SHIFT(657),
  [3472] = {.count = 1, .reusable = true}, SHIFT(2099),
  [3474] = {.count = 1, .reusable = true}, SHIFT(2101),
  [3476] = {.count = 1, .reusable = true}, SHIFT(2103),
  [3478] = {.count = 1, .reusable = false}, SHIFT(2103),
  [3480] = {.count = 1, .reusable = true}, SHIFT(2104),
  [3482] = {.count = 1, .reusable = false}, SHIFT(2088),
  [3484] = {.count = 1, .reusable = true}, SHIFT(2106),
  [3486] = {.count = 1, .reusable = true}, SHIFT(2107),
  [3488] = {.count = 1, .reusable = false}, SHIFT(2108),
  [3490] = {.count = 1, .reusable = false}, SHIFT(2109),
  [3492] = {.count = 1, .reusable = false}, SHIFT(2110),
  [3494] = {.count = 1, .reusable = false}, SHIFT(2111),
  [3496] = {.count = 1, .reusable = false}, SHIFT(2112),
  [3498] = {.count = 1, .reusable = true}, SHIFT(2113),
  [3500] = {.count = 1, .reusable = false}, SHIFT(2113),
  [3502] = {.count = 1, .reusable = true}, SHIFT(2114),
  [3504] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 3),
  [3506] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 3),
  [3508] = {.count = 1, .reusable = true}, SHIFT(2123),
  [3510] = {.count = 1, .reusable = true}, SHIFT(2124),
  [3512] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 2),
  [3514] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 3),
  [3516] = {.count = 1, .reusable = true}, SHIFT(2127),
  [3518] = {.count = 1, .reusable = true}, SHIFT(2128),
  [3520] = {.count = 1, .reusable = true}, SHIFT(2130),
  [3522] = {.count = 1, .reusable = true}, SHIFT(2131),
  [3524] = {.count = 1, .reusable = true}, SHIFT(2132),
  [3526] = {.count = 1, .reusable = true}, SHIFT(2133),
  [3528] = {.count = 1, .reusable = true}, SHIFT(2136),
  [3530] = {.count = 1, .reusable = false}, SHIFT(2136),
  [3532] = {.count = 1, .reusable = false}, SHIFT(2137),
  [3534] = {.count = 1, .reusable = true}, SHIFT(2137),
  [3536] = {.count = 1, .reusable = false}, SHIFT(2138),
  [3538] = {.count = 1, .reusable = true}, SHIFT(2147),
  [3540] = {.count = 1, .reusable = true}, SHIFT(2148),
  [3542] = {.count = 1, .reusable = true}, SHIFT(2149),
  [3544] = {.count = 1, .reusable = false}, SHIFT(2150),
  [3546] = {.count = 1, .reusable = true}, SHIFT(2151),
  [3548] = {.count = 1, .reusable = false}, SHIFT(2152),
  [3550] = {.count = 1, .reusable = false}, SHIFT(2153),
  [3552] = {.count = 1, .reusable = true}, SHIFT(2154),
  [3554] = {.count = 1, .reusable = false}, SHIFT(2155),
  [3556] = {.count = 1, .reusable = true}, SHIFT(2155),
  [3558] = {.count = 1, .reusable = true}, SHIFT(2156),
  [3560] = {.count = 1, .reusable = true}, SHIFT(2157),
  [3562] = {.count = 1, .reusable = true}, SHIFT(2158),
  [3564] = {.count = 1, .reusable = false}, SHIFT(2157),
  [3566] = {.count = 1, .reusable = true}, SHIFT(2153),
  [3568] = {.count = 1, .reusable = true}, SHIFT(2150),
  [3570] = {.count = 1, .reusable = true}, SHIFT(2159),
  [3572] = {.count = 1, .reusable = true}, SHIFT(2160),
  [3574] = {.count = 1, .reusable = true}, SHIFT(2161),
  [3576] = {.count = 1, .reusable = true}, SHIFT(2162),
  [3578] = {.count = 1, .reusable = true}, SHIFT(2163),
  [3580] = {.count = 1, .reusable = false}, SHIFT(2165),
  [3582] = {.count = 1, .reusable = false}, SHIFT(2166),
  [3584] = {.count = 1, .reusable = false}, SHIFT(2167),
  [3586] = {.count = 1, .reusable = false}, SHIFT(2168),
  [3588] = {.count = 1, .reusable = true}, SHIFT(2170),
  [3590] = {.count = 1, .reusable = false}, SHIFT(2170),
  [3592] = {.count = 1, .reusable = false}, SHIFT(2171),
  [3594] = {.count = 1, .reusable = true}, SHIFT(2171),
  [3596] = {.count = 1, .reusable = false}, SHIFT(2172),
  [3598] = {.count = 1, .reusable = true}, SHIFT(2174),
  [3600] = {.count = 1, .reusable = false}, SHIFT(2174),
  [3602] = {.count = 1, .reusable = true}, SHIFT(2180),
  [3604] = {.count = 1, .reusable = false}, SHIFT(2180),
  [3606] = {.count = 1, .reusable = true}, SHIFT(2181),
  [3608] = {.count = 1, .reusable = true}, REDUCE(sym_setter, 2),
  [3610] = {.count = 1, .reusable = false}, REDUCE(sym_setter, 2),
  [3612] = {.count = 1, .reusable = true}, SHIFT(136),
  [3614] = {.count = 1, .reusable = true}, SHIFT(2184),
  [3616] = {.count = 1, .reusable = true}, SHIFT(2186),
  [3618] = {.count = 1, .reusable = true}, SHIFT(2187),
  [3620] = {.count = 1, .reusable = true}, SHIFT(2188),
  [3622] = {.count = 1, .reusable = true}, SHIFT(2189),
  [3624] = {.count = 1, .reusable = true}, SHIFT(2190),
  [3626] = {.count = 1, .reusable = true}, SHIFT(2191),
  [3628] = {.count = 1, .reusable = false}, SHIFT(2192),
  [3630] = {.count = 1, .reusable = true}, SHIFT(2194),
  [3632] = {.count = 1, .reusable = true}, SHIFT(2193),
  [3634] = {.count = 1, .reusable = true}, SHIFT(2195),
  [3636] = {.count = 1, .reusable = true}, SHIFT(2196),
  [3638] = {.count = 1, .reusable = true}, SHIFT(2197),
  [3640] = {.count = 1, .reusable = true}, SHIFT(2198),
  [3642] = {.count = 1, .reusable = true}, SHIFT(2199),
  [3644] = {.count = 1, .reusable = false}, SHIFT(2200),
  [3646] = {.count = 1, .reusable = false}, SHIFT(2201),
  [3648] = {.count = 1, .reusable = false}, SHIFT(2202),
  [3650] = {.count = 1, .reusable = false}, SHIFT(2203),
  [3652] = {.count = 1, .reusable = false}, SHIFT(2204),
  [3654] = {.count = 1, .reusable = true}, SHIFT(2205),
  [3656] = {.count = 1, .reusable = false}, SHIFT(2205),
  [3658] = {.count = 1, .reusable = true}, SHIFT(2206),
  [3660] = {.count = 1, .reusable = false}, SHIFT(2207),
  [3662] = {.count = 1, .reusable = true}, SHIFT(2214),
  [3664] = {.count = 1, .reusable = false}, SHIFT(2215),
  [3666] = {.count = 1, .reusable = false}, SHIFT(2216),
  [3668] = {.count = 1, .reusable = false}, SHIFT(2217),
  [3670] = {.count = 1, .reusable = false}, SHIFT(2218),
  [3672] = {.count = 1, .reusable = false}, SHIFT(2219),
  [3674] = {.count = 1, .reusable = true}, SHIFT(2220),
  [3676] = {.count = 1, .reusable = false}, SHIFT(2220),
  [3678] = {.count = 1, .reusable = true}, SHIFT(2221),
  [3680] = {.count = 1, .reusable = false}, SHIFT(721),
  [3682] = {.count = 1, .reusable = true}, SHIFT(2229),
  [3684] = {.count = 1, .reusable = true}, SHIFT(2231),
  [3686] = {.count = 1, .reusable = true}, SHIFT(2232),
  [3688] = {.count = 1, .reusable = true}, SHIFT(2233),
  [3690] = {.count = 1, .reusable = false}, SHIFT(2235),
  [3692] = {.count = 1, .reusable = false}, SHIFT(2229),
  [3694] = {.count = 1, .reusable = true}, SHIFT(2242),
  [3696] = {.count = 1, .reusable = true}, SHIFT(2243),
  [3698] = {.count = 1, .reusable = false}, SHIFT(2244),
  [3700] = {.count = 1, .reusable = true}, SHIFT(2245),
  [3702] = {.count = 1, .reusable = false}, SHIFT(2246),
  [3704] = {.count = 1, .reusable = false}, SHIFT(2247),
  [3706] = {.count = 1, .reusable = true}, SHIFT(2248),
  [3708] = {.count = 1, .reusable = true}, SHIFT(2249),
  [3710] = {.count = 1, .reusable = false}, SHIFT(2250),
  [3712] = {.count = 1, .reusable = true}, SHIFT(2250),
  [3714] = {.count = 1, .reusable = true}, SHIFT(2252),
  [3716] = {.count = 1, .reusable = true}, SHIFT(2253),
  [3718] = {.count = 1, .reusable = false}, SHIFT(2252),
  [3720] = {.count = 1, .reusable = true}, SHIFT(2247),
  [3722] = {.count = 1, .reusable = true}, SHIFT(2244),
  [3724] = {.count = 1, .reusable = true}, SHIFT(2254),
  [3726] = {.count = 1, .reusable = true}, SHIFT(2255),
  [3728] = {.count = 1, .reusable = true}, SHIFT(2256),
  [3730] = {.count = 1, .reusable = true}, SHIFT(2257),
  [3732] = {.count = 1, .reusable = false}, SHIFT(2259),
  [3734] = {.count = 1, .reusable = true}, SHIFT(2265),
  [3736] = {.count = 1, .reusable = true}, SHIFT(2267),
  [3738] = {.count = 1, .reusable = false}, SHIFT(2267),
  [3740] = {.count = 1, .reusable = true}, SHIFT(2268),
  [3742] = {.count = 1, .reusable = false}, SHIFT(2248),
  [3744] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_statements, 3),
  [3746] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_statements, 3),
  [3748] = {.count = 1, .reusable = true}, SHIFT(2271),
  [3750] = {.count = 1, .reusable = true}, SHIFT(2290),
  [3752] = {.count = 1, .reusable = false}, SHIFT(2291),
  [3754] = {.count = 1, .reusable = false}, SHIFT(2292),
  [3756] = {.count = 1, .reusable = false}, SHIFT(2293),
  [3758] = {.count = 1, .reusable = false}, SHIFT(2294),
  [3760] = {.count = 1, .reusable = false}, SHIFT(2295),
  [3762] = {.count = 1, .reusable = true}, SHIFT(2296),
  [3764] = {.count = 1, .reusable = false}, SHIFT(2296),
  [3766] = {.count = 1, .reusable = true}, SHIFT(2297),
  [3768] = {.count = 1, .reusable = false}, SHIFT(2299),
  [3770] = {.count = 1, .reusable = true}, SHIFT(2299),
  [3772] = {.count = 1, .reusable = false}, SHIFT(764),
  [3774] = {.count = 1, .reusable = true}, SHIFT(2306),
  [3776] = {.count = 1, .reusable = false}, SHIFT(2306),
  [3778] = {.count = 1, .reusable = true}, SHIFT(2310),
  [3780] = {.count = 1, .reusable = true}, SHIFT(2311),
  [3782] = {.count = 1, .reusable = false}, SHIFT(2312),
  [3784] = {.count = 1, .reusable = false}, SHIFT(2313),
  [3786] = {.count = 1, .reusable = false}, SHIFT(2314),
  [3788] = {.count = 1, .reusable = false}, SHIFT(2315),
  [3790] = {.count = 1, .reusable = true}, SHIFT(2316),
  [3792] = {.count = 1, .reusable = true}, SHIFT(2317),
  [3794] = {.count = 1, .reusable = false}, SHIFT(2318),
  [3796] = {.count = 1, .reusable = true}, SHIFT(2318),
  [3798] = {.count = 1, .reusable = false}, SHIFT(2320),
  [3800] = {.count = 1, .reusable = false}, SHIFT(2321),
  [3802] = {.count = 1, .reusable = true}, SHIFT(2320),
  [3804] = {.count = 1, .reusable = true}, SHIFT(2315),
  [3806] = {.count = 1, .reusable = false}, SHIFT(2322),
  [3808] = {.count = 1, .reusable = true}, SHIFT(2324),
  [3810] = {.count = 1, .reusable = true}, SHIFT(2326),
  [3812] = {.count = 1, .reusable = false}, SHIFT(2326),
  [3814] = {.count = 1, .reusable = true}, SHIFT(2327),
  [3816] = {.count = 1, .reusable = false}, SHIFT(2316),
  [3818] = {.count = 1, .reusable = true}, SHIFT(2329),
  [3820] = {.count = 1, .reusable = true}, SHIFT(2330),
  [3822] = {.count = 1, .reusable = false}, SHIFT(2331),
  [3824] = {.count = 1, .reusable = true}, SHIFT(2332),
  [3826] = {.count = 1, .reusable = false}, SHIFT(2332),
  [3828] = {.count = 1, .reusable = true}, SHIFT(2333),
  [3830] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_left_assignment, 3),
  [3832] = {.count = 1, .reusable = true}, SHIFT(2340),
  [3834] = {.count = 1, .reusable = true}, SHIFT(2341),
  [3836] = {.count = 1, .reusable = true}, SHIFT(2342),
  [3838] = {.count = 1, .reusable = true}, SHIFT(2343),
  [3840] = {.count = 1, .reusable = true}, SHIFT(2344),
  [3842] = {.count = 1, .reusable = false}, SHIFT(2345),
  [3844] = {.count = 1, .reusable = true}, SHIFT(2347),
  [3846] = {.count = 1, .reusable = true}, SHIFT(2348),
  [3848] = {.count = 1, .reusable = true}, SHIFT(2350),
  [3850] = {.count = 1, .reusable = false}, SHIFT(2351),
  [3852] = {.count = 1, .reusable = true}, SHIFT(2353),
  [3854] = {.count = 1, .reusable = true}, SHIFT(2354),
  [3856] = {.count = 1, .reusable = true}, SHIFT(2356),
  [3858] = {.count = 1, .reusable = true}, SHIFT(2359),
  [3860] = {.count = 1, .reusable = true}, SHIFT(2360),
  [3862] = {.count = 1, .reusable = true}, SHIFT(2361),
  [3864] = {.count = 1, .reusable = true}, SHIFT(2364),
  [3866] = {.count = 1, .reusable = true}, SHIFT(2366),
  [3868] = {.count = 1, .reusable = false}, SHIFT(2365),
  [3870] = {.count = 1, .reusable = true}, SHIFT(2367),
  [3872] = {.count = 1, .reusable = false}, SHIFT(2368),
  [3874] = {.count = 1, .reusable = false}, SHIFT(2369),
  [3876] = {.count = 1, .reusable = false}, SHIFT(2370),
  [3878] = {.count = 1, .reusable = false}, SHIFT(2371),
  [3880] = {.count = 1, .reusable = false}, SHIFT(2372),
  [3882] = {.count = 1, .reusable = true}, SHIFT(2373),
  [3884] = {.count = 1, .reusable = false}, SHIFT(2373),
  [3886] = {.count = 1, .reusable = true}, SHIFT(2374),
  [3888] = {.count = 1, .reusable = false}, SHIFT(2376),
  [3890] = {.count = 1, .reusable = true}, SHIFT(2376),
  [3892] = {.count = 1, .reusable = true}, SHIFT(2381),
  [3894] = {.count = 1, .reusable = true}, SHIFT(2383),
  [3896] = {.count = 1, .reusable = false}, SHIFT(2381),
  [3898] = {.count = 1, .reusable = true}, SHIFT(2386),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1955),
  [3902] = {.count = 1, .reusable = true}, SHIFT(2387),
  [3904] = {.count = 1, .reusable = true}, SHIFT(2389),
  [3906] = {.count = 1, .reusable = false}, SHIFT(2386),
  [3908] = {.count = 1, .reusable = true}, SHIFT(2391),
  [3910] = {.count = 1, .reusable = true}, SHIFT(2392),
  [3912] = {.count = 1, .reusable = true}, SHIFT(2393),
  [3914] = {.count = 1, .reusable = true}, SHIFT(2394),
  [3916] = {.count = 1, .reusable = true}, SHIFT(2396),
  [3918] = {.count = 1, .reusable = true}, SHIFT(2398),
  [3920] = {.count = 1, .reusable = true}, SHIFT(2399),
  [3922] = {.count = 1, .reusable = false}, SHIFT(2403),
  [3924] = {.count = 1, .reusable = true}, SHIFT(2404),
  [3926] = {.count = 1, .reusable = true}, SHIFT(2406),
  [3928] = {.count = 1, .reusable = true}, SHIFT(2412),
  [3930] = {.count = 1, .reusable = false}, SHIFT(2409),
  [3932] = {.count = 1, .reusable = true}, SHIFT(841),
  [3934] = {.count = 1, .reusable = true}, SHIFT(2414),
  [3936] = {.count = 1, .reusable = false}, SHIFT(2414),
  [3938] = {.count = 1, .reusable = true}, SHIFT(2415),
  [3940] = {.count = 1, .reusable = true}, SHIFT(2416),
  [3942] = {.count = 1, .reusable = true}, SHIFT(2419),
  [3944] = {.count = 1, .reusable = true}, SHIFT(2422),
  [3946] = {.count = 1, .reusable = true}, SHIFT(2423),
  [3948] = {.count = 1, .reusable = true}, SHIFT(2424),
  [3950] = {.count = 1, .reusable = true}, SHIFT(2425),
  [3952] = {.count = 1, .reusable = true}, SHIFT(2426),
  [3954] = {.count = 1, .reusable = true}, SHIFT(2427),
  [3956] = {.count = 1, .reusable = true}, SHIFT(2428),
  [3958] = {.count = 1, .reusable = true}, SHIFT(2429),
  [3960] = {.count = 1, .reusable = true}, SHIFT(2430),
  [3962] = {.count = 1, .reusable = true}, SHIFT(2431),
  [3964] = {.count = 1, .reusable = false}, SHIFT(2432),
  [3966] = {.count = 1, .reusable = true}, SHIFT(2433),
  [3968] = {.count = 1, .reusable = false}, SHIFT(2434),
  [3970] = {.count = 1, .reusable = false}, SHIFT(2435),
  [3972] = {.count = 1, .reusable = false}, SHIFT(2436),
  [3974] = {.count = 1, .reusable = false}, SHIFT(2437),
  [3976] = {.count = 1, .reusable = false}, SHIFT(2438),
  [3978] = {.count = 1, .reusable = false}, SHIFT(2439),
  [3980] = {.count = 1, .reusable = false}, SHIFT(2440),
  [3982] = {.count = 1, .reusable = false}, SHIFT(2441),
  [3984] = {.count = 1, .reusable = false}, SHIFT(2442),
  [3986] = {.count = 1, .reusable = false}, SHIFT(2443),
  [3988] = {.count = 1, .reusable = false}, SHIFT(2444),
  [3990] = {.count = 1, .reusable = false}, SHIFT(2445),
  [3992] = {.count = 1, .reusable = false}, SHIFT(2446),
  [3994] = {.count = 1, .reusable = false}, SHIFT(2447),
  [3996] = {.count = 1, .reusable = true}, SHIFT(2448),
  [3998] = {.count = 1, .reusable = false}, SHIFT(2448),
  [4000] = {.count = 1, .reusable = true}, SHIFT(2449),
  [4002] = {.count = 1, .reusable = false}, SHIFT(2454),
  [4004] = {.count = 1, .reusable = true}, SHIFT(2454),
  [4006] = {.count = 1, .reusable = false}, SHIFT(2450),
  [4008] = {.count = 1, .reusable = true}, SHIFT(2451),
  [4010] = {.count = 1, .reusable = true}, SHIFT(2452),
  [4012] = {.count = 1, .reusable = true}, SHIFT(2461),
  [4014] = {.count = 1, .reusable = true}, SHIFT(2462),
  [4016] = {.count = 1, .reusable = true}, SHIFT(2464),
  [4018] = {.count = 1, .reusable = true}, SHIFT(2465),
  [4020] = {.count = 1, .reusable = true}, SHIFT(2466),
  [4022] = {.count = 1, .reusable = false}, SHIFT(859),
  [4024] = {.count = 1, .reusable = false}, SHIFT(2468),
  [4026] = {.count = 1, .reusable = false}, SHIFT(2461),
  [4028] = {.count = 1, .reusable = true}, SHIFT(2475),
  [4030] = {.count = 1, .reusable = true}, SHIFT(2476),
  [4032] = {.count = 1, .reusable = false}, SHIFT(2477),
  [4034] = {.count = 1, .reusable = true}, SHIFT(2478),
  [4036] = {.count = 1, .reusable = false}, SHIFT(2479),
  [4038] = {.count = 1, .reusable = false}, SHIFT(2480),
  [4040] = {.count = 1, .reusable = true}, SHIFT(2481),
  [4042] = {.count = 1, .reusable = true}, SHIFT(2482),
  [4044] = {.count = 1, .reusable = false}, SHIFT(2483),
  [4046] = {.count = 1, .reusable = true}, SHIFT(2483),
  [4048] = {.count = 1, .reusable = true}, SHIFT(2484),
  [4050] = {.count = 1, .reusable = true}, SHIFT(2485),
  [4052] = {.count = 1, .reusable = true}, SHIFT(2486),
  [4054] = {.count = 1, .reusable = false}, SHIFT(2485),
  [4056] = {.count = 1, .reusable = true}, SHIFT(2480),
  [4058] = {.count = 1, .reusable = true}, SHIFT(2477),
  [4060] = {.count = 1, .reusable = true}, SHIFT(2487),
  [4062] = {.count = 1, .reusable = true}, SHIFT(2490),
  [4064] = {.count = 1, .reusable = true}, SHIFT(2492),
  [4066] = {.count = 1, .reusable = false}, SHIFT(2492),
  [4068] = {.count = 1, .reusable = true}, SHIFT(2493),
  [4070] = {.count = 1, .reusable = false}, SHIFT(2481),
  [4072] = {.count = 1, .reusable = true}, SHIFT(2496),
  [4074] = {.count = 1, .reusable = true}, SHIFT(2498),
  [4076] = {.count = 1, .reusable = false}, SHIFT(2499),
  [4078] = {.count = 1, .reusable = true}, SHIFT(2500),
  [4080] = {.count = 1, .reusable = true}, SHIFT(2501),
  [4082] = {.count = 1, .reusable = false}, SHIFT(2502),
  [4084] = {.count = 1, .reusable = false}, SHIFT(2503),
  [4086] = {.count = 1, .reusable = false}, SHIFT(2504),
  [4088] = {.count = 1, .reusable = false}, SHIFT(2505),
  [4090] = {.count = 1, .reusable = false}, SHIFT(2506),
  [4092] = {.count = 1, .reusable = true}, SHIFT(2507),
  [4094] = {.count = 1, .reusable = false}, SHIFT(2507),
  [4096] = {.count = 1, .reusable = true}, SHIFT(2508),
  [4098] = {.count = 1, .reusable = true}, SHIFT(2516),
  [4100] = {.count = 1, .reusable = true}, SHIFT(2517),
  [4102] = {.count = 1, .reusable = true}, SHIFT(2519),
  [4104] = {.count = 1, .reusable = true}, SHIFT(2520),
  [4106] = {.count = 1, .reusable = true}, SHIFT(2521),
  [4108] = {.count = 1, .reusable = false}, SHIFT(888),
  [4110] = {.count = 1, .reusable = false}, SHIFT(2523),
  [4112] = {.count = 1, .reusable = false}, SHIFT(2516),
  [4114] = {.count = 1, .reusable = true}, SHIFT(2530),
  [4116] = {.count = 1, .reusable = true}, SHIFT(2531),
  [4118] = {.count = 1, .reusable = false}, SHIFT(2532),
  [4120] = {.count = 1, .reusable = true}, SHIFT(2533),
  [4122] = {.count = 1, .reusable = false}, SHIFT(2534),
  [4124] = {.count = 1, .reusable = false}, SHIFT(2535),
  [4126] = {.count = 1, .reusable = true}, SHIFT(2536),
  [4128] = {.count = 1, .reusable = true}, SHIFT(2537),
  [4130] = {.count = 1, .reusable = false}, SHIFT(2538),
  [4132] = {.count = 1, .reusable = true}, SHIFT(2538),
  [4134] = {.count = 1, .reusable = true}, SHIFT(2539),
  [4136] = {.count = 1, .reusable = true}, SHIFT(2540),
  [4138] = {.count = 1, .reusable = true}, SHIFT(2541),
  [4140] = {.count = 1, .reusable = false}, SHIFT(2540),
  [4142] = {.count = 1, .reusable = true}, SHIFT(2535),
  [4144] = {.count = 1, .reusable = true}, SHIFT(2532),
  [4146] = {.count = 1, .reusable = true}, SHIFT(2542),
  [4148] = {.count = 1, .reusable = true}, SHIFT(2544),
  [4150] = {.count = 1, .reusable = true}, SHIFT(2546),
  [4152] = {.count = 1, .reusable = false}, SHIFT(2546),
  [4154] = {.count = 1, .reusable = true}, SHIFT(2547),
  [4156] = {.count = 1, .reusable = false}, SHIFT(2536),
  [4158] = {.count = 1, .reusable = true}, REDUCE(sym_module, 3),
  [4160] = {.count = 1, .reusable = false}, REDUCE(sym_module, 3),
  [4162] = {.count = 1, .reusable = false}, SHIFT(2549),
  [4164] = {.count = 1, .reusable = true}, REDUCE(sym_block_argument, 2),
  [4166] = {.count = 1, .reusable = true}, SHIFT(2555),
  [4168] = {.count = 1, .reusable = true}, SHIFT(2556),
  [4170] = {.count = 1, .reusable = false}, REDUCE(sym_block_argument, 2),
  [4172] = {.count = 1, .reusable = false}, SHIFT(2557),
  [4174] = {.count = 1, .reusable = true}, SHIFT(2558),
  [4176] = {.count = 1, .reusable = false}, SHIFT(2559),
  [4178] = {.count = 1, .reusable = false}, SHIFT(2560),
  [4180] = {.count = 1, .reusable = true}, SHIFT(2561),
  [4182] = {.count = 1, .reusable = false}, SHIFT(2562),
  [4184] = {.count = 1, .reusable = true}, SHIFT(2562),
  [4186] = {.count = 1, .reusable = true}, SHIFT(2564),
  [4188] = {.count = 1, .reusable = true}, SHIFT(2565),
  [4190] = {.count = 1, .reusable = false}, SHIFT(2564),
  [4192] = {.count = 1, .reusable = true}, SHIFT(2560),
  [4194] = {.count = 1, .reusable = true}, SHIFT(2557),
  [4196] = {.count = 1, .reusable = true}, SHIFT(2566),
  [4198] = {.count = 1, .reusable = true}, SHIFT(2567),
  [4200] = {.count = 1, .reusable = false}, SHIFT(2567),
  [4202] = {.count = 1, .reusable = true}, SHIFT(2568),
  [4204] = {.count = 1, .reusable = true}, REDUCE(sym_splat_argument, 2),
  [4206] = {.count = 1, .reusable = false}, REDUCE(sym_splat_argument, 2),
  [4208] = {.count = 1, .reusable = false}, REDUCE(sym_hash_splat_argument, 2),
  [4210] = {.count = 1, .reusable = true}, SHIFT(2573),
  [4212] = {.count = 1, .reusable = false}, SHIFT(2573),
  [4214] = {.count = 1, .reusable = true}, SHIFT(2577),
  [4216] = {.count = 1, .reusable = false}, SHIFT(2575),
  [4218] = {.count = 1, .reusable = true}, SHIFT(2579),
  [4220] = {.count = 1, .reusable = false}, SHIFT(2580),
  [4222] = {.count = 1, .reusable = false}, SHIFT(2581),
  [4224] = {.count = 1, .reusable = false}, SHIFT(2582),
  [4226] = {.count = 1, .reusable = false}, SHIFT(2583),
  [4228] = {.count = 1, .reusable = false}, SHIFT(2584),
  [4230] = {.count = 1, .reusable = true}, SHIFT(2585),
  [4232] = {.count = 1, .reusable = false}, SHIFT(2585),
  [4234] = {.count = 1, .reusable = true}, SHIFT(2586),
  [4236] = {.count = 1, .reusable = false}, SHIFT(2588),
  [4238] = {.count = 1, .reusable = true}, SHIFT(2588),
  [4240] = {.count = 1, .reusable = true}, SHIFT(2595),
  [4242] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 2),
  [4244] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 2),
  [4246] = {.count = 1, .reusable = true}, SHIFT(2597),
  [4248] = {.count = 1, .reusable = true}, SHIFT(2598),
  [4250] = {.count = 1, .reusable = true}, SHIFT(2599),
  [4252] = {.count = 1, .reusable = false}, SHIFT(2601),
  [4254] = {.count = 1, .reusable = false}, SHIFT(2595),
  [4256] = {.count = 1, .reusable = true}, SHIFT(2608),
  [4258] = {.count = 1, .reusable = true}, SHIFT(2609),
  [4260] = {.count = 1, .reusable = false}, SHIFT(2610),
  [4262] = {.count = 1, .reusable = true}, SHIFT(2611),
  [4264] = {.count = 1, .reusable = false}, SHIFT(2612),
  [4266] = {.count = 1, .reusable = false}, SHIFT(2613),
  [4268] = {.count = 1, .reusable = true}, SHIFT(2614),
  [4270] = {.count = 1, .reusable = true}, SHIFT(2615),
  [4272] = {.count = 1, .reusable = false}, SHIFT(2616),
  [4274] = {.count = 1, .reusable = true}, SHIFT(2616),
  [4276] = {.count = 1, .reusable = true}, SHIFT(2617),
  [4278] = {.count = 1, .reusable = true}, SHIFT(2618),
  [4280] = {.count = 1, .reusable = true}, SHIFT(2619),
  [4282] = {.count = 1, .reusable = false}, SHIFT(2618),
  [4284] = {.count = 1, .reusable = true}, SHIFT(2613),
  [4286] = {.count = 1, .reusable = true}, SHIFT(2610),
  [4288] = {.count = 1, .reusable = true}, SHIFT(2620),
  [4290] = {.count = 1, .reusable = true}, SHIFT(2621),
  [4292] = {.count = 1, .reusable = true}, SHIFT(2622),
  [4294] = {.count = 1, .reusable = true}, SHIFT(2623),
  [4296] = {.count = 1, .reusable = false}, SHIFT(2625),
  [4298] = {.count = 1, .reusable = true}, SHIFT(2630),
  [4300] = {.count = 1, .reusable = true}, SHIFT(2632),
  [4302] = {.count = 1, .reusable = true}, SHIFT(2633),
  [4304] = {.count = 1, .reusable = false}, SHIFT(2633),
  [4306] = {.count = 1, .reusable = true}, SHIFT(2634),
  [4308] = {.count = 1, .reusable = false}, SHIFT(2614),
  [4310] = {.count = 1, .reusable = true}, SHIFT(2649),
  [4312] = {.count = 1, .reusable = false}, SHIFT(2649),
  [4314] = {.count = 1, .reusable = true}, SHIFT(2650),
  [4316] = {.count = 1, .reusable = true}, SHIFT(2651),
  [4318] = {.count = 1, .reusable = true}, SHIFT(2654),
  [4320] = {.count = 1, .reusable = true}, SHIFT(2657),
  [4322] = {.count = 1, .reusable = true}, SHIFT(2660),
  [4324] = {.count = 1, .reusable = true}, SHIFT(2661),
  [4326] = {.count = 1, .reusable = true}, SHIFT(2668),
  [4328] = {.count = 1, .reusable = false}, SHIFT(2665),
  [4330] = {.count = 1, .reusable = true}, SHIFT(2669),
  [4332] = {.count = 1, .reusable = false}, SHIFT(2660),
  [4334] = {.count = 1, .reusable = true}, SHIFT(971),
  [4336] = {.count = 1, .reusable = true}, SHIFT(2674),
  [4338] = {.count = 1, .reusable = true}, SHIFT(2676),
  [4340] = {.count = 1, .reusable = false}, SHIFT(2672),
  [4342] = {.count = 1, .reusable = true}, SHIFT(2679),
  [4344] = {.count = 1, .reusable = true}, SHIFT(2678),
  [4346] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [4348] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [4350] = {.count = 1, .reusable = true}, SHIFT(2681),
  [4352] = {.count = 1, .reusable = true}, SHIFT(206),
  [4354] = {.count = 1, .reusable = true}, SHIFT(2691),
  [4356] = {.count = 1, .reusable = false}, SHIFT(2692),
  [4358] = {.count = 1, .reusable = false}, SHIFT(2693),
  [4360] = {.count = 1, .reusable = false}, SHIFT(2694),
  [4362] = {.count = 1, .reusable = false}, SHIFT(2695),
  [4364] = {.count = 1, .reusable = false}, SHIFT(2696),
  [4366] = {.count = 1, .reusable = true}, SHIFT(2697),
  [4368] = {.count = 1, .reusable = false}, SHIFT(2697),
  [4370] = {.count = 1, .reusable = true}, SHIFT(2698),
  [4372] = {.count = 1, .reusable = false}, SHIFT(997),
  [4374] = {.count = 1, .reusable = true}, SHIFT(2706),
  [4376] = {.count = 1, .reusable = true}, SHIFT(2708),
  [4378] = {.count = 1, .reusable = true}, SHIFT(2709),
  [4380] = {.count = 1, .reusable = true}, SHIFT(2710),
  [4382] = {.count = 1, .reusable = false}, SHIFT(2712),
  [4384] = {.count = 1, .reusable = false}, SHIFT(2706),
  [4386] = {.count = 1, .reusable = true}, SHIFT(2719),
  [4388] = {.count = 1, .reusable = true}, SHIFT(2720),
  [4390] = {.count = 1, .reusable = false}, SHIFT(2721),
  [4392] = {.count = 1, .reusable = true}, SHIFT(2722),
  [4394] = {.count = 1, .reusable = false}, SHIFT(2723),
  [4396] = {.count = 1, .reusable = false}, SHIFT(2724),
  [4398] = {.count = 1, .reusable = true}, SHIFT(2725),
  [4400] = {.count = 1, .reusable = true}, SHIFT(2726),
  [4402] = {.count = 1, .reusable = false}, SHIFT(2727),
  [4404] = {.count = 1, .reusable = true}, SHIFT(2727),
  [4406] = {.count = 1, .reusable = true}, SHIFT(2729),
  [4408] = {.count = 1, .reusable = true}, SHIFT(2730),
  [4410] = {.count = 1, .reusable = false}, SHIFT(2729),
  [4412] = {.count = 1, .reusable = true}, SHIFT(2724),
  [4414] = {.count = 1, .reusable = true}, SHIFT(2721),
  [4416] = {.count = 1, .reusable = true}, SHIFT(2731),
  [4418] = {.count = 1, .reusable = true}, SHIFT(2732),
  [4420] = {.count = 1, .reusable = true}, SHIFT(2733),
  [4422] = {.count = 1, .reusable = true}, SHIFT(2734),
  [4424] = {.count = 1, .reusable = false}, SHIFT(2736),
  [4426] = {.count = 1, .reusable = true}, SHIFT(2742),
  [4428] = {.count = 1, .reusable = true}, SHIFT(2744),
  [4430] = {.count = 1, .reusable = false}, SHIFT(2744),
  [4432] = {.count = 1, .reusable = true}, SHIFT(2745),
  [4434] = {.count = 1, .reusable = false}, SHIFT(2725),
  [4436] = {.count = 1, .reusable = true}, SHIFT(2749),
  [4438] = {.count = 1, .reusable = true}, SHIFT(2748),
  [4440] = {.count = 1, .reusable = true}, SHIFT(2776),
  [4442] = {.count = 1, .reusable = true}, SHIFT(2755),
  [4444] = {.count = 1, .reusable = false}, SHIFT(2756),
  [4446] = {.count = 1, .reusable = false}, SHIFT(2757),
  [4448] = {.count = 1, .reusable = false}, SHIFT(2758),
  [4450] = {.count = 1, .reusable = false}, SHIFT(2759),
  [4452] = {.count = 1, .reusable = false}, SHIFT(2760),
  [4454] = {.count = 1, .reusable = false}, SHIFT(2761),
  [4456] = {.count = 1, .reusable = false}, SHIFT(2762),
  [4458] = {.count = 1, .reusable = false}, SHIFT(2763),
  [4460] = {.count = 1, .reusable = true}, SHIFT(2764),
  [4462] = {.count = 1, .reusable = false}, SHIFT(2764),
  [4464] = {.count = 1, .reusable = true}, SHIFT(2765),
  [4466] = {.count = 1, .reusable = false}, SHIFT(2772),
  [4468] = {.count = 1, .reusable = true}, SHIFT(2772),
  [4470] = {.count = 1, .reusable = false}, SHIFT(2766),
  [4472] = {.count = 1, .reusable = true}, REDUCE(sym__then, 1),
  [4474] = {.count = 1, .reusable = false}, REDUCE(sym__then, 1),
  [4476] = {.count = 1, .reusable = false}, SHIFT(2777),
  [4478] = {.count = 1, .reusable = true}, SHIFT(2790),
  [4480] = {.count = 1, .reusable = false}, SHIFT(2791),
  [4482] = {.count = 1, .reusable = false}, SHIFT(2792),
  [4484] = {.count = 1, .reusable = false}, SHIFT(2793),
  [4486] = {.count = 1, .reusable = false}, SHIFT(2794),
  [4488] = {.count = 1, .reusable = false}, SHIFT(2795),
  [4490] = {.count = 1, .reusable = true}, SHIFT(2796),
  [4492] = {.count = 1, .reusable = false}, SHIFT(2796),
  [4494] = {.count = 1, .reusable = true}, SHIFT(2797),
  [4496] = {.count = 1, .reusable = false}, SHIFT(2799),
  [4498] = {.count = 1, .reusable = true}, SHIFT(2799),
  [4500] = {.count = 1, .reusable = false}, SHIFT(1040),
  [4502] = {.count = 1, .reusable = true}, SHIFT(2806),
  [4504] = {.count = 1, .reusable = false}, SHIFT(2806),
  [4506] = {.count = 1, .reusable = true}, SHIFT(2810),
  [4508] = {.count = 1, .reusable = true}, SHIFT(2811),
  [4510] = {.count = 1, .reusable = false}, SHIFT(2812),
  [4512] = {.count = 1, .reusable = false}, SHIFT(2813),
  [4514] = {.count = 1, .reusable = false}, SHIFT(2814),
  [4516] = {.count = 1, .reusable = false}, SHIFT(2815),
  [4518] = {.count = 1, .reusable = true}, SHIFT(2816),
  [4520] = {.count = 1, .reusable = true}, SHIFT(2817),
  [4522] = {.count = 1, .reusable = false}, SHIFT(2818),
  [4524] = {.count = 1, .reusable = true}, SHIFT(2818),
  [4526] = {.count = 1, .reusable = false}, SHIFT(2820),
  [4528] = {.count = 1, .reusable = false}, SHIFT(2821),
  [4530] = {.count = 1, .reusable = true}, SHIFT(2820),
  [4532] = {.count = 1, .reusable = true}, SHIFT(2815),
  [4534] = {.count = 1, .reusable = false}, SHIFT(2822),
  [4536] = {.count = 1, .reusable = true}, SHIFT(2824),
  [4538] = {.count = 1, .reusable = true}, SHIFT(2826),
  [4540] = {.count = 1, .reusable = false}, SHIFT(2826),
  [4542] = {.count = 1, .reusable = true}, SHIFT(2827),
  [4544] = {.count = 1, .reusable = false}, SHIFT(2816),
  [4546] = {.count = 1, .reusable = true}, SHIFT(2829),
  [4548] = {.count = 1, .reusable = true}, SHIFT(2830),
  [4550] = {.count = 1, .reusable = false}, SHIFT(2831),
  [4552] = {.count = 1, .reusable = true}, SHIFT(2832),
  [4554] = {.count = 1, .reusable = false}, SHIFT(2832),
  [4556] = {.count = 1, .reusable = true}, SHIFT(2833),
  [4558] = {.count = 1, .reusable = true}, SHIFT(2840),
  [4560] = {.count = 1, .reusable = false}, SHIFT(2841),
  [4562] = {.count = 1, .reusable = false}, SHIFT(2842),
  [4564] = {.count = 1, .reusable = false}, SHIFT(2843),
  [4566] = {.count = 1, .reusable = false}, SHIFT(2844),
  [4568] = {.count = 1, .reusable = false}, SHIFT(2845),
  [4570] = {.count = 1, .reusable = false}, SHIFT(2846),
  [4572] = {.count = 1, .reusable = true}, SHIFT(2847),
  [4574] = {.count = 1, .reusable = false}, SHIFT(2847),
  [4576] = {.count = 1, .reusable = true}, SHIFT(2848),
  [4578] = {.count = 1, .reusable = false}, SHIFT(2855),
  [4580] = {.count = 1, .reusable = true}, SHIFT(2855),
  [4582] = {.count = 1, .reusable = false}, SHIFT(2849),
  [4584] = {.count = 1, .reusable = false}, SHIFT(2859),
  [4586] = {.count = 1, .reusable = true}, SHIFT(2860),
  [4588] = {.count = 1, .reusable = false}, SHIFT(2861),
  [4590] = {.count = 1, .reusable = false}, SHIFT(2862),
  [4592] = {.count = 1, .reusable = false}, SHIFT(2863),
  [4594] = {.count = 1, .reusable = false}, SHIFT(2864),
  [4596] = {.count = 1, .reusable = false}, SHIFT(2865),
  [4598] = {.count = 1, .reusable = true}, SHIFT(2866),
  [4600] = {.count = 1, .reusable = false}, SHIFT(2866),
  [4602] = {.count = 1, .reusable = true}, SHIFT(2867),
  [4604] = {.count = 1, .reusable = false}, SHIFT(1066),
  [4606] = {.count = 1, .reusable = true}, SHIFT(2875),
  [4608] = {.count = 1, .reusable = true}, SHIFT(2877),
  [4610] = {.count = 1, .reusable = true}, SHIFT(2878),
  [4612] = {.count = 1, .reusable = true}, SHIFT(2879),
  [4614] = {.count = 1, .reusable = false}, SHIFT(2881),
  [4616] = {.count = 1, .reusable = false}, SHIFT(2875),
  [4618] = {.count = 1, .reusable = true}, SHIFT(2888),
  [4620] = {.count = 1, .reusable = true}, SHIFT(2889),
  [4622] = {.count = 1, .reusable = false}, SHIFT(2890),
  [4624] = {.count = 1, .reusable = true}, SHIFT(2891),
  [4626] = {.count = 1, .reusable = false}, SHIFT(2892),
  [4628] = {.count = 1, .reusable = false}, SHIFT(2893),
  [4630] = {.count = 1, .reusable = true}, SHIFT(2894),
  [4632] = {.count = 1, .reusable = true}, SHIFT(2895),
  [4634] = {.count = 1, .reusable = false}, SHIFT(2896),
  [4636] = {.count = 1, .reusable = true}, SHIFT(2896),
  [4638] = {.count = 1, .reusable = true}, SHIFT(2898),
  [4640] = {.count = 1, .reusable = true}, SHIFT(2899),
  [4642] = {.count = 1, .reusable = false}, SHIFT(2898),
  [4644] = {.count = 1, .reusable = true}, SHIFT(2893),
  [4646] = {.count = 1, .reusable = true}, SHIFT(2890),
  [4648] = {.count = 1, .reusable = true}, SHIFT(2900),
  [4650] = {.count = 1, .reusable = true}, SHIFT(2901),
  [4652] = {.count = 1, .reusable = true}, SHIFT(2902),
  [4654] = {.count = 1, .reusable = true}, SHIFT(2903),
  [4656] = {.count = 1, .reusable = true}, SHIFT(2904),
  [4658] = {.count = 1, .reusable = false}, SHIFT(2906),
  [4660] = {.count = 1, .reusable = true}, SHIFT(2912),
  [4662] = {.count = 1, .reusable = true}, SHIFT(2914),
  [4664] = {.count = 1, .reusable = false}, SHIFT(2914),
  [4666] = {.count = 1, .reusable = true}, SHIFT(2915),
  [4668] = {.count = 1, .reusable = false}, SHIFT(2894),
  [4670] = {.count = 1, .reusable = false}, SHIFT(2929),
  [4672] = {.count = 1, .reusable = true}, SHIFT(2931),
  [4674] = {.count = 1, .reusable = false}, SHIFT(2932),
  [4676] = {.count = 1, .reusable = false}, SHIFT(2933),
  [4678] = {.count = 1, .reusable = false}, SHIFT(2934),
  [4680] = {.count = 1, .reusable = false}, SHIFT(2935),
  [4682] = {.count = 1, .reusable = false}, SHIFT(2936),
  [4684] = {.count = 1, .reusable = true}, SHIFT(2937),
  [4686] = {.count = 1, .reusable = false}, SHIFT(2937),
  [4688] = {.count = 1, .reusable = true}, SHIFT(2938),
  [4690] = {.count = 1, .reusable = false}, SHIFT(2940),
  [4692] = {.count = 1, .reusable = true}, SHIFT(2940),
  [4694] = {.count = 1, .reusable = false}, SHIFT(1102),
  [4696] = {.count = 1, .reusable = true}, SHIFT(2947),
  [4698] = {.count = 1, .reusable = true}, SHIFT(2948),
  [4700] = {.count = 1, .reusable = false}, SHIFT(2947),
  [4702] = {.count = 1, .reusable = true}, SHIFT(2952),
  [4704] = {.count = 1, .reusable = true}, SHIFT(2953),
  [4706] = {.count = 1, .reusable = false}, SHIFT(2954),
  [4708] = {.count = 1, .reusable = false}, SHIFT(2955),
  [4710] = {.count = 1, .reusable = false}, SHIFT(2956),
  [4712] = {.count = 1, .reusable = false}, SHIFT(2957),
  [4714] = {.count = 1, .reusable = true}, SHIFT(2958),
  [4716] = {.count = 1, .reusable = true}, SHIFT(2959),
  [4718] = {.count = 1, .reusable = false}, SHIFT(2960),
  [4720] = {.count = 1, .reusable = true}, SHIFT(2960),
  [4722] = {.count = 1, .reusable = false}, SHIFT(2962),
  [4724] = {.count = 1, .reusable = false}, SHIFT(2963),
  [4726] = {.count = 1, .reusable = true}, SHIFT(2962),
  [4728] = {.count = 1, .reusable = true}, SHIFT(2957),
  [4730] = {.count = 1, .reusable = false}, SHIFT(2964),
  [4732] = {.count = 1, .reusable = true}, SHIFT(2966),
  [4734] = {.count = 1, .reusable = true}, SHIFT(2968),
  [4736] = {.count = 1, .reusable = false}, SHIFT(2968),
  [4738] = {.count = 1, .reusable = true}, SHIFT(2969),
  [4740] = {.count = 1, .reusable = false}, SHIFT(2958),
  [4742] = {.count = 1, .reusable = true}, SHIFT(2971),
  [4744] = {.count = 1, .reusable = true}, SHIFT(2972),
  [4746] = {.count = 1, .reusable = false}, SHIFT(2973),
  [4748] = {.count = 1, .reusable = true}, SHIFT(2974),
  [4750] = {.count = 1, .reusable = false}, SHIFT(2974),
  [4752] = {.count = 1, .reusable = true}, SHIFT(2975),
  [4754] = {.count = 1, .reusable = false}, SHIFT(2982),
  [4756] = {.count = 1, .reusable = true}, SHIFT(2984),
  [4758] = {.count = 1, .reusable = false}, SHIFT(2985),
  [4760] = {.count = 1, .reusable = false}, SHIFT(2986),
  [4762] = {.count = 1, .reusable = false}, SHIFT(2987),
  [4764] = {.count = 1, .reusable = false}, SHIFT(2988),
  [4766] = {.count = 1, .reusable = false}, SHIFT(2989),
  [4768] = {.count = 1, .reusable = true}, SHIFT(2990),
  [4770] = {.count = 1, .reusable = false}, SHIFT(2990),
  [4772] = {.count = 1, .reusable = true}, SHIFT(2991),
  [4774] = {.count = 1, .reusable = false}, SHIFT(2993),
  [4776] = {.count = 1, .reusable = true}, SHIFT(2993),
  [4778] = {.count = 1, .reusable = true}, SHIFT(3000),
  [4780] = {.count = 1, .reusable = true}, SHIFT(3002),
  [4782] = {.count = 1, .reusable = true}, SHIFT(3003),
  [4784] = {.count = 1, .reusable = true}, SHIFT(3004),
  [4786] = {.count = 1, .reusable = false}, SHIFT(1129),
  [4788] = {.count = 1, .reusable = false}, SHIFT(3006),
  [4790] = {.count = 1, .reusable = false}, SHIFT(3000),
  [4792] = {.count = 1, .reusable = true}, SHIFT(3013),
  [4794] = {.count = 1, .reusable = true}, SHIFT(3014),
  [4796] = {.count = 1, .reusable = false}, SHIFT(3015),
  [4798] = {.count = 1, .reusable = true}, SHIFT(3016),
  [4800] = {.count = 1, .reusable = false}, SHIFT(3017),
  [4802] = {.count = 1, .reusable = false}, SHIFT(3018),
  [4804] = {.count = 1, .reusable = true}, SHIFT(3019),
  [4806] = {.count = 1, .reusable = true}, SHIFT(3020),
  [4808] = {.count = 1, .reusable = false}, SHIFT(3021),
  [4810] = {.count = 1, .reusable = true}, SHIFT(3021),
  [4812] = {.count = 1, .reusable = true}, SHIFT(3022),
  [4814] = {.count = 1, .reusable = true}, SHIFT(3023),
  [4816] = {.count = 1, .reusable = true}, SHIFT(3024),
  [4818] = {.count = 1, .reusable = false}, SHIFT(3023),
  [4820] = {.count = 1, .reusable = true}, SHIFT(3018),
  [4822] = {.count = 1, .reusable = true}, SHIFT(3015),
  [4824] = {.count = 1, .reusable = true}, SHIFT(3025),
  [4826] = {.count = 1, .reusable = true}, SHIFT(3026),
  [4828] = {.count = 1, .reusable = true}, SHIFT(3027),
  [4830] = {.count = 1, .reusable = true}, SHIFT(3028),
  [4832] = {.count = 1, .reusable = true}, SHIFT(3029),
  [4834] = {.count = 1, .reusable = false}, SHIFT(3031),
  [4836] = {.count = 1, .reusable = false}, SHIFT(3032),
  [4838] = {.count = 1, .reusable = false}, SHIFT(3033),
  [4840] = {.count = 1, .reusable = false}, SHIFT(3034),
  [4842] = {.count = 1, .reusable = true}, SHIFT(3036),
  [4844] = {.count = 1, .reusable = false}, SHIFT(3036),
  [4846] = {.count = 1, .reusable = false}, SHIFT(3037),
  [4848] = {.count = 1, .reusable = true}, SHIFT(3037),
  [4850] = {.count = 1, .reusable = false}, SHIFT(3038),
  [4852] = {.count = 1, .reusable = true}, SHIFT(3046),
  [4854] = {.count = 1, .reusable = true}, SHIFT(3048),
  [4856] = {.count = 1, .reusable = false}, SHIFT(3048),
  [4858] = {.count = 1, .reusable = true}, SHIFT(3049),
  [4860] = {.count = 1, .reusable = false}, SHIFT(3019),
  [4862] = {.count = 1, .reusable = true}, SHIFT(3052),
  [4864] = {.count = 1, .reusable = false}, REDUCE(sym__mlhs, 2),
  [4866] = {.count = 1, .reusable = true}, SHIFT(3053),
  [4868] = {.count = 1, .reusable = false}, SHIFT(3054),
  [4870] = {.count = 1, .reusable = false}, SHIFT(3055),
  [4872] = {.count = 1, .reusable = false}, SHIFT(3056),
  [4874] = {.count = 1, .reusable = false}, SHIFT(3057),
  [4876] = {.count = 1, .reusable = false}, SHIFT(3058),
  [4878] = {.count = 1, .reusable = true}, SHIFT(3059),
  [4880] = {.count = 1, .reusable = false}, SHIFT(3059),
  [4882] = {.count = 1, .reusable = true}, SHIFT(3060),
  [4884] = {.count = 1, .reusable = false}, SHIFT(1151),
  [4886] = {.count = 1, .reusable = true}, SHIFT(3068),
  [4888] = {.count = 1, .reusable = true}, SHIFT(3070),
  [4890] = {.count = 1, .reusable = true}, SHIFT(3071),
  [4892] = {.count = 1, .reusable = true}, SHIFT(3072),
  [4894] = {.count = 1, .reusable = false}, SHIFT(3074),
  [4896] = {.count = 1, .reusable = false}, SHIFT(3068),
  [4898] = {.count = 1, .reusable = true}, SHIFT(3081),
  [4900] = {.count = 1, .reusable = true}, SHIFT(3082),
  [4902] = {.count = 1, .reusable = false}, SHIFT(3083),
  [4904] = {.count = 1, .reusable = true}, SHIFT(3084),
  [4906] = {.count = 1, .reusable = false}, SHIFT(3085),
  [4908] = {.count = 1, .reusable = false}, SHIFT(3086),
  [4910] = {.count = 1, .reusable = true}, SHIFT(3087),
  [4912] = {.count = 1, .reusable = true}, SHIFT(3088),
  [4914] = {.count = 1, .reusable = false}, SHIFT(3089),
  [4916] = {.count = 1, .reusable = true}, SHIFT(3089),
  [4918] = {.count = 1, .reusable = true}, SHIFT(3091),
  [4920] = {.count = 1, .reusable = true}, SHIFT(3092),
  [4922] = {.count = 1, .reusable = false}, SHIFT(3091),
  [4924] = {.count = 1, .reusable = true}, SHIFT(3086),
  [4926] = {.count = 1, .reusable = true}, SHIFT(3083),
  [4928] = {.count = 1, .reusable = true}, SHIFT(3093),
  [4930] = {.count = 1, .reusable = true}, SHIFT(3095),
  [4932] = {.count = 1, .reusable = true}, SHIFT(3097),
  [4934] = {.count = 1, .reusable = false}, SHIFT(3097),
  [4936] = {.count = 1, .reusable = true}, SHIFT(3098),
  [4938] = {.count = 1, .reusable = false}, SHIFT(3087),
  [4940] = {.count = 1, .reusable = true}, SHIFT(3113),
  [4942] = {.count = 1, .reusable = true}, SHIFT(3114),
  [4944] = {.count = 1, .reusable = true}, SHIFT(3115),
  [4946] = {.count = 1, .reusable = false}, SHIFT(3116),
  [4948] = {.count = 1, .reusable = true}, SHIFT(3117),
  [4950] = {.count = 1, .reusable = false}, SHIFT(3117),
  [4952] = {.count = 1, .reusable = true}, SHIFT(3118),
  [4954] = {.count = 1, .reusable = true}, SHIFT(3125),
  [4956] = {.count = 1, .reusable = true}, SHIFT(3126),
  [4958] = {.count = 1, .reusable = false}, SHIFT(3127),
  [4960] = {.count = 1, .reusable = false}, SHIFT(3128),
  [4962] = {.count = 1, .reusable = false}, SHIFT(3129),
  [4964] = {.count = 1, .reusable = false}, SHIFT(3130),
  [4966] = {.count = 1, .reusable = false}, SHIFT(3131),
  [4968] = {.count = 1, .reusable = true}, SHIFT(3132),
  [4970] = {.count = 1, .reusable = false}, SHIFT(3132),
  [4972] = {.count = 1, .reusable = true}, SHIFT(3133),
  [4974] = {.count = 1, .reusable = false}, SHIFT(3136),
  [4976] = {.count = 1, .reusable = true}, SHIFT(3136),
  [4978] = {.count = 1, .reusable = true}, SHIFT(3141),
  [4980] = {.count = 1, .reusable = true}, SHIFT(3142),
  [4982] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 2),
  [4984] = {.count = 1, .reusable = true}, SHIFT(3143),
  [4986] = {.count = 1, .reusable = true}, SHIFT(3144),
  [4988] = {.count = 1, .reusable = false}, SHIFT(3145),
  [4990] = {.count = 1, .reusable = false}, SHIFT(3146),
  [4992] = {.count = 1, .reusable = false}, SHIFT(3147),
  [4994] = {.count = 1, .reusable = false}, SHIFT(3148),
  [4996] = {.count = 1, .reusable = false}, SHIFT(3149),
  [4998] = {.count = 1, .reusable = true}, SHIFT(3150),
  [5000] = {.count = 1, .reusable = false}, SHIFT(3150),
  [5002] = {.count = 1, .reusable = true}, SHIFT(3151),
  [5004] = {.count = 1, .reusable = false}, SHIFT(1195),
  [5006] = {.count = 1, .reusable = true}, SHIFT(3159),
  [5008] = {.count = 1, .reusable = true}, SHIFT(3161),
  [5010] = {.count = 1, .reusable = true}, SHIFT(3162),
  [5012] = {.count = 1, .reusable = true}, SHIFT(3163),
  [5014] = {.count = 1, .reusable = false}, SHIFT(3165),
  [5016] = {.count = 1, .reusable = false}, SHIFT(3159),
  [5018] = {.count = 1, .reusable = true}, SHIFT(3172),
  [5020] = {.count = 1, .reusable = true}, SHIFT(3173),
  [5022] = {.count = 1, .reusable = false}, SHIFT(3174),
  [5024] = {.count = 1, .reusable = true}, SHIFT(3175),
  [5026] = {.count = 1, .reusable = false}, SHIFT(3176),
  [5028] = {.count = 1, .reusable = false}, SHIFT(3177),
  [5030] = {.count = 1, .reusable = true}, SHIFT(3178),
  [5032] = {.count = 1, .reusable = true}, SHIFT(3179),
  [5034] = {.count = 1, .reusable = false}, SHIFT(3180),
  [5036] = {.count = 1, .reusable = true}, SHIFT(3180),
  [5038] = {.count = 1, .reusable = true}, SHIFT(3182),
  [5040] = {.count = 1, .reusable = true}, SHIFT(3183),
  [5042] = {.count = 1, .reusable = false}, SHIFT(3182),
  [5044] = {.count = 1, .reusable = true}, SHIFT(3177),
  [5046] = {.count = 1, .reusable = true}, SHIFT(3174),
  [5048] = {.count = 1, .reusable = true}, SHIFT(3184),
  [5050] = {.count = 1, .reusable = true}, SHIFT(3185),
  [5052] = {.count = 1, .reusable = true}, SHIFT(3186),
  [5054] = {.count = 1, .reusable = true}, SHIFT(3187),
  [5056] = {.count = 1, .reusable = false}, SHIFT(3189),
  [5058] = {.count = 1, .reusable = true}, SHIFT(3195),
  [5060] = {.count = 1, .reusable = true}, SHIFT(3197),
  [5062] = {.count = 1, .reusable = false}, SHIFT(3197),
  [5064] = {.count = 1, .reusable = true}, SHIFT(3198),
  [5066] = {.count = 1, .reusable = false}, SHIFT(3178),
  [5068] = {.count = 1, .reusable = true}, SHIFT(3202),
  [5070] = {.count = 1, .reusable = true}, SHIFT(3203),
  [5072] = {.count = 1, .reusable = true}, SHIFT(3204),
  [5074] = {.count = 1, .reusable = true}, SHIFT(3205),
  [5076] = {.count = 1, .reusable = true}, SHIFT(3208),
  [5078] = {.count = 1, .reusable = false}, SHIFT(3208),
  [5080] = {.count = 1, .reusable = false}, SHIFT(3209),
  [5082] = {.count = 1, .reusable = true}, SHIFT(3209),
  [5084] = {.count = 1, .reusable = false}, SHIFT(3210),
  [5086] = {.count = 1, .reusable = true}, SHIFT(3220),
  [5088] = {.count = 1, .reusable = false}, SHIFT(3220),
  [5090] = {.count = 1, .reusable = false}, SHIFT(3221),
  [5092] = {.count = 1, .reusable = true}, SHIFT(3221),
  [5094] = {.count = 1, .reusable = false}, SHIFT(3217),
  [5096] = {.count = 1, .reusable = false}, SHIFT(3218),
  [5098] = {.count = 1, .reusable = false}, SHIFT(3219),
  [5100] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 2),
  [5102] = {.count = 1, .reusable = true}, SHIFT(3227),
  [5104] = {.count = 1, .reusable = true}, REDUCE(sym__arg_or_splat_arg, 1),
  [5106] = {.count = 1, .reusable = true}, SHIFT(3229),
  [5108] = {.count = 1, .reusable = true}, SHIFT(3230),
  [5110] = {.count = 1, .reusable = false}, SHIFT(3231),
  [5112] = {.count = 1, .reusable = true}, SHIFT(3232),
  [5114] = {.count = 1, .reusable = false}, SHIFT(3233),
  [5116] = {.count = 1, .reusable = false}, SHIFT(3234),
  [5118] = {.count = 1, .reusable = true}, SHIFT(3235),
  [5120] = {.count = 1, .reusable = false}, SHIFT(3236),
  [5122] = {.count = 1, .reusable = true}, SHIFT(3236),
  [5124] = {.count = 1, .reusable = true}, SHIFT(3237),
  [5126] = {.count = 1, .reusable = true}, SHIFT(3238),
  [5128] = {.count = 1, .reusable = true}, SHIFT(3239),
  [5130] = {.count = 1, .reusable = false}, SHIFT(3238),
  [5132] = {.count = 1, .reusable = true}, SHIFT(3234),
  [5134] = {.count = 1, .reusable = true}, SHIFT(3231),
  [5136] = {.count = 1, .reusable = true}, SHIFT(3240),
  [5138] = {.count = 1, .reusable = true}, SHIFT(3241),
  [5140] = {.count = 1, .reusable = true}, SHIFT(3242),
  [5142] = {.count = 1, .reusable = true}, SHIFT(3243),
  [5144] = {.count = 1, .reusable = true}, SHIFT(3244),
  [5146] = {.count = 1, .reusable = false}, SHIFT(3246),
  [5148] = {.count = 1, .reusable = false}, SHIFT(3247),
  [5150] = {.count = 1, .reusable = false}, SHIFT(3248),
  [5152] = {.count = 1, .reusable = false}, SHIFT(3249),
  [5154] = {.count = 1, .reusable = true}, SHIFT(3251),
  [5156] = {.count = 1, .reusable = false}, SHIFT(3251),
  [5158] = {.count = 1, .reusable = false}, SHIFT(3252),
  [5160] = {.count = 1, .reusable = true}, SHIFT(3252),
  [5162] = {.count = 1, .reusable = false}, SHIFT(3253),
  [5164] = {.count = 1, .reusable = true}, SHIFT(3255),
  [5166] = {.count = 1, .reusable = false}, SHIFT(3255),
  [5168] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 1),
  [5170] = {.count = 1, .reusable = true}, SHIFT(3261),
  [5172] = {.count = 1, .reusable = true}, SHIFT(3263),
  [5174] = {.count = 1, .reusable = false}, SHIFT(3263),
  [5176] = {.count = 1, .reusable = true}, SHIFT(3264),
  [5178] = {.count = 1, .reusable = false}, REDUCE(sym_empty_statement, 1),
  [5180] = {.count = 1, .reusable = true}, SHIFT(3267),
  [5182] = {.count = 1, .reusable = true}, SHIFT(3268),
  [5184] = {.count = 1, .reusable = true}, SHIFT(3269),
  [5186] = {.count = 1, .reusable = true}, SHIFT(3270),
  [5188] = {.count = 1, .reusable = false}, SHIFT(3272),
  [5190] = {.count = 1, .reusable = false}, SHIFT(3273),
  [5192] = {.count = 1, .reusable = false}, SHIFT(3274),
  [5194] = {.count = 1, .reusable = false}, SHIFT(3275),
  [5196] = {.count = 1, .reusable = true}, SHIFT(3277),
  [5198] = {.count = 1, .reusable = false}, SHIFT(3277),
  [5200] = {.count = 1, .reusable = false}, SHIFT(3278),
  [5202] = {.count = 1, .reusable = true}, SHIFT(3278),
  [5204] = {.count = 1, .reusable = false}, SHIFT(3279),
  [5206] = {.count = 1, .reusable = true}, SHIFT(3281),
  [5208] = {.count = 1, .reusable = false}, SHIFT(3281),
  [5210] = {.count = 1, .reusable = true}, SHIFT(3289),
  [5212] = {.count = 1, .reusable = true}, REDUCE(sym_else, 2),
  [5214] = {.count = 1, .reusable = true}, SHIFT(3290),
  [5216] = {.count = 1, .reusable = true}, SHIFT(3292),
  [5218] = {.count = 1, .reusable = true}, SHIFT(3293),
  [5220] = {.count = 1, .reusable = true}, SHIFT(3294),
  [5222] = {.count = 1, .reusable = true}, SHIFT(3295),
  [5224] = {.count = 1, .reusable = true}, SHIFT(3296),
  [5226] = {.count = 1, .reusable = true}, SHIFT(3297),
  [5228] = {.count = 1, .reusable = true}, SHIFT(3298),
  [5230] = {.count = 1, .reusable = false}, SHIFT(3299),
  [5232] = {.count = 1, .reusable = true}, SHIFT(3300),
  [5234] = {.count = 1, .reusable = false}, SHIFT(3301),
  [5236] = {.count = 1, .reusable = false}, SHIFT(3302),
  [5238] = {.count = 1, .reusable = true}, SHIFT(3303),
  [5240] = {.count = 1, .reusable = false}, SHIFT(3304),
  [5242] = {.count = 1, .reusable = true}, SHIFT(3304),
  [5244] = {.count = 1, .reusable = true}, SHIFT(3305),
  [5246] = {.count = 1, .reusable = true}, SHIFT(3306),
  [5248] = {.count = 1, .reusable = true}, SHIFT(3307),
  [5250] = {.count = 1, .reusable = false}, SHIFT(3306),
  [5252] = {.count = 1, .reusable = true}, SHIFT(3302),
  [5254] = {.count = 1, .reusable = true}, SHIFT(3299),
  [5256] = {.count = 1, .reusable = true}, SHIFT(3308),
  [5258] = {.count = 1, .reusable = true}, SHIFT(3309),
  [5260] = {.count = 1, .reusable = true}, SHIFT(3310),
  [5262] = {.count = 1, .reusable = true}, SHIFT(3311),
  [5264] = {.count = 1, .reusable = true}, SHIFT(3312),
  [5266] = {.count = 1, .reusable = false}, SHIFT(3314),
  [5268] = {.count = 1, .reusable = false}, SHIFT(3315),
  [5270] = {.count = 1, .reusable = false}, SHIFT(3316),
  [5272] = {.count = 1, .reusable = false}, SHIFT(3317),
  [5274] = {.count = 1, .reusable = true}, SHIFT(3319),
  [5276] = {.count = 1, .reusable = false}, SHIFT(3319),
  [5278] = {.count = 1, .reusable = false}, SHIFT(3320),
  [5280] = {.count = 1, .reusable = true}, SHIFT(3320),
  [5282] = {.count = 1, .reusable = false}, SHIFT(3321),
  [5284] = {.count = 1, .reusable = true}, SHIFT(3323),
  [5286] = {.count = 1, .reusable = false}, SHIFT(3323),
  [5288] = {.count = 1, .reusable = true}, SHIFT(3329),
  [5290] = {.count = 1, .reusable = false}, SHIFT(3329),
  [5292] = {.count = 1, .reusable = true}, SHIFT(3330),
  [5294] = {.count = 1, .reusable = false}, REDUCE(sym_else, 2),
  [5296] = {.count = 1, .reusable = true}, SHIFT(3334),
  [5298] = {.count = 1, .reusable = true}, SHIFT(3335),
  [5300] = {.count = 1, .reusable = true}, SHIFT(3336),
  [5302] = {.count = 1, .reusable = true}, SHIFT(3337),
  [5304] = {.count = 1, .reusable = false}, SHIFT(3339),
  [5306] = {.count = 1, .reusable = false}, SHIFT(3340),
  [5308] = {.count = 1, .reusable = false}, SHIFT(3341),
  [5310] = {.count = 1, .reusable = false}, SHIFT(3342),
  [5312] = {.count = 1, .reusable = true}, SHIFT(3344),
  [5314] = {.count = 1, .reusable = false}, SHIFT(3344),
  [5316] = {.count = 1, .reusable = false}, SHIFT(3345),
  [5318] = {.count = 1, .reusable = true}, SHIFT(3345),
  [5320] = {.count = 1, .reusable = false}, SHIFT(3346),
  [5322] = {.count = 1, .reusable = true}, SHIFT(3348),
  [5324] = {.count = 1, .reusable = false}, SHIFT(3348),
  [5326] = {.count = 1, .reusable = true}, SHIFT(3356),
  [5328] = {.count = 1, .reusable = true}, REDUCE(sym_ensure, 2),
  [5330] = {.count = 1, .reusable = true}, SHIFT(3357),
  [5332] = {.count = 1, .reusable = true}, SHIFT(3359),
  [5334] = {.count = 1, .reusable = true}, SHIFT(3360),
  [5336] = {.count = 1, .reusable = true}, SHIFT(3361),
  [5338] = {.count = 1, .reusable = true}, SHIFT(3362),
  [5340] = {.count = 1, .reusable = true}, SHIFT(3363),
  [5342] = {.count = 1, .reusable = true}, SHIFT(3364),
  [5344] = {.count = 1, .reusable = true}, SHIFT(3365),
  [5346] = {.count = 1, .reusable = false}, SHIFT(3366),
  [5348] = {.count = 1, .reusable = true}, SHIFT(3367),
  [5350] = {.count = 1, .reusable = false}, SHIFT(3368),
  [5352] = {.count = 1, .reusable = false}, SHIFT(3369),
  [5354] = {.count = 1, .reusable = true}, SHIFT(3370),
  [5356] = {.count = 1, .reusable = false}, SHIFT(3371),
  [5358] = {.count = 1, .reusable = true}, SHIFT(3371),
  [5360] = {.count = 1, .reusable = true}, SHIFT(3372),
  [5362] = {.count = 1, .reusable = true}, SHIFT(3373),
  [5364] = {.count = 1, .reusable = true}, SHIFT(3374),
  [5366] = {.count = 1, .reusable = false}, SHIFT(3373),
  [5368] = {.count = 1, .reusable = true}, SHIFT(3369),
  [5370] = {.count = 1, .reusable = true}, SHIFT(3366),
  [5372] = {.count = 1, .reusable = true}, SHIFT(3375),
  [5374] = {.count = 1, .reusable = true}, SHIFT(3376),
  [5376] = {.count = 1, .reusable = true}, SHIFT(3377),
  [5378] = {.count = 1, .reusable = true}, SHIFT(3378),
  [5380] = {.count = 1, .reusable = true}, SHIFT(3379),
  [5382] = {.count = 1, .reusable = false}, SHIFT(3381),
  [5384] = {.count = 1, .reusable = false}, SHIFT(3382),
  [5386] = {.count = 1, .reusable = false}, SHIFT(3383),
  [5388] = {.count = 1, .reusable = false}, SHIFT(3384),
  [5390] = {.count = 1, .reusable = true}, SHIFT(3386),
  [5392] = {.count = 1, .reusable = false}, SHIFT(3386),
  [5394] = {.count = 1, .reusable = false}, SHIFT(3387),
  [5396] = {.count = 1, .reusable = true}, SHIFT(3387),
  [5398] = {.count = 1, .reusable = false}, SHIFT(3388),
  [5400] = {.count = 1, .reusable = true}, SHIFT(3390),
  [5402] = {.count = 1, .reusable = false}, SHIFT(3390),
  [5404] = {.count = 1, .reusable = true}, SHIFT(3396),
  [5406] = {.count = 1, .reusable = false}, SHIFT(3396),
  [5408] = {.count = 1, .reusable = true}, SHIFT(3397),
  [5410] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 2),
  [5412] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 2),
  [5414] = {.count = 1, .reusable = true}, SHIFT(3400),
  [5416] = {.count = 1, .reusable = true}, SHIFT(3403),
  [5418] = {.count = 1, .reusable = true}, SHIFT(3422),
  [5420] = {.count = 1, .reusable = false}, SHIFT(3423),
  [5422] = {.count = 1, .reusable = false}, SHIFT(3424),
  [5424] = {.count = 1, .reusable = false}, SHIFT(3425),
  [5426] = {.count = 1, .reusable = false}, SHIFT(3426),
  [5428] = {.count = 1, .reusable = false}, SHIFT(3427),
  [5430] = {.count = 1, .reusable = true}, SHIFT(3428),
  [5432] = {.count = 1, .reusable = false}, SHIFT(3428),
  [5434] = {.count = 1, .reusable = true}, SHIFT(3429),
  [5436] = {.count = 1, .reusable = false}, SHIFT(3431),
  [5438] = {.count = 1, .reusable = true}, SHIFT(3431),
  [5440] = {.count = 1, .reusable = false}, SHIFT(1296),
  [5442] = {.count = 1, .reusable = true}, SHIFT(3438),
  [5444] = {.count = 1, .reusable = false}, SHIFT(3438),
  [5446] = {.count = 1, .reusable = true}, SHIFT(3442),
  [5448] = {.count = 1, .reusable = true}, SHIFT(3443),
  [5450] = {.count = 1, .reusable = false}, SHIFT(3444),
  [5452] = {.count = 1, .reusable = false}, SHIFT(3445),
  [5454] = {.count = 1, .reusable = false}, SHIFT(3446),
  [5456] = {.count = 1, .reusable = false}, SHIFT(3447),
  [5458] = {.count = 1, .reusable = true}, SHIFT(3448),
  [5460] = {.count = 1, .reusable = true}, SHIFT(3449),
  [5462] = {.count = 1, .reusable = false}, SHIFT(3450),
  [5464] = {.count = 1, .reusable = true}, SHIFT(3450),
  [5466] = {.count = 1, .reusable = false}, SHIFT(3452),
  [5468] = {.count = 1, .reusable = false}, SHIFT(3453),
  [5470] = {.count = 1, .reusable = true}, SHIFT(3452),
  [5472] = {.count = 1, .reusable = true}, SHIFT(3447),
  [5474] = {.count = 1, .reusable = false}, SHIFT(3454),
  [5476] = {.count = 1, .reusable = true}, SHIFT(3456),
  [5478] = {.count = 1, .reusable = true}, SHIFT(3458),
  [5480] = {.count = 1, .reusable = false}, SHIFT(3458),
  [5482] = {.count = 1, .reusable = true}, SHIFT(3459),
  [5484] = {.count = 1, .reusable = false}, SHIFT(3448),
  [5486] = {.count = 1, .reusable = true}, SHIFT(3461),
  [5488] = {.count = 1, .reusable = true}, SHIFT(3462),
  [5490] = {.count = 1, .reusable = false}, SHIFT(3463),
  [5492] = {.count = 1, .reusable = true}, SHIFT(3464),
  [5494] = {.count = 1, .reusable = false}, SHIFT(3464),
  [5496] = {.count = 1, .reusable = true}, SHIFT(3465),
  [5498] = {.count = 1, .reusable = true}, REDUCE(sym_begin, 3),
  [5500] = {.count = 1, .reusable = false}, REDUCE(sym_begin, 3),
  [5502] = {.count = 1, .reusable = true}, SHIFT(3472),
  [5504] = {.count = 1, .reusable = true}, REDUCE(sym_undef, 3),
  [5506] = {.count = 1, .reusable = true}, SHIFT(3474),
  [5508] = {.count = 1, .reusable = true}, REDUCE(sym_alias, 3),
  [5510] = {.count = 1, .reusable = true}, SHIFT(3475),
  [5512] = {.count = 1, .reusable = true}, SHIFT(3476),
  [5514] = {.count = 1, .reusable = true}, SHIFT(3477),
  [5516] = {.count = 1, .reusable = true}, SHIFT(3478),
  [5518] = {.count = 1, .reusable = true}, SHIFT(3479),
  [5520] = {.count = 1, .reusable = false}, SHIFT(3480),
  [5522] = {.count = 1, .reusable = true}, SHIFT(3482),
  [5524] = {.count = 1, .reusable = true}, SHIFT(3483),
  [5526] = {.count = 1, .reusable = true}, SHIFT(3485),
  [5528] = {.count = 1, .reusable = false}, SHIFT(3486),
  [5530] = {.count = 1, .reusable = true}, SHIFT(3488),
  [5532] = {.count = 1, .reusable = true}, SHIFT(3489),
  [5534] = {.count = 1, .reusable = true}, SHIFT(3492),
  [5536] = {.count = 1, .reusable = true}, SHIFT(3493),
  [5538] = {.count = 1, .reusable = true}, SHIFT(3494),
  [5540] = {.count = 1, .reusable = false}, SHIFT(3496),
  [5542] = {.count = 1, .reusable = true}, SHIFT(3503),
  [5544] = {.count = 1, .reusable = true}, SHIFT(3504),
  [5546] = {.count = 1, .reusable = false}, SHIFT(3505),
  [5548] = {.count = 1, .reusable = true}, SHIFT(3506),
  [5550] = {.count = 1, .reusable = false}, SHIFT(3507),
  [5552] = {.count = 1, .reusable = false}, SHIFT(3508),
  [5554] = {.count = 1, .reusable = true}, SHIFT(3509),
  [5556] = {.count = 1, .reusable = false}, SHIFT(3510),
  [5558] = {.count = 1, .reusable = true}, SHIFT(3510),
  [5560] = {.count = 1, .reusable = true}, SHIFT(3511),
  [5562] = {.count = 1, .reusable = true}, SHIFT(3512),
  [5564] = {.count = 1, .reusable = true}, SHIFT(3513),
  [5566] = {.count = 1, .reusable = false}, SHIFT(3512),
  [5568] = {.count = 1, .reusable = true}, SHIFT(3508),
  [5570] = {.count = 1, .reusable = true}, SHIFT(3505),
  [5572] = {.count = 1, .reusable = true}, SHIFT(3514),
  [5574] = {.count = 1, .reusable = true}, SHIFT(3515),
  [5576] = {.count = 1, .reusable = true}, SHIFT(3516),
  [5578] = {.count = 1, .reusable = true}, SHIFT(3517),
  [5580] = {.count = 1, .reusable = false}, SHIFT(3519),
  [5582] = {.count = 1, .reusable = true}, SHIFT(3524),
  [5584] = {.count = 1, .reusable = false}, SHIFT(3524),
  [5586] = {.count = 1, .reusable = true}, SHIFT(3525),
  [5588] = {.count = 1, .reusable = true}, SHIFT(3528),
  [5590] = {.count = 1, .reusable = true}, SHIFT(3531),
  [5592] = {.count = 1, .reusable = true}, SHIFT(3532),
  [5594] = {.count = 1, .reusable = true}, SHIFT(3533),
  [5596] = {.count = 1, .reusable = true}, SHIFT(3536),
  [5598] = {.count = 1, .reusable = true}, SHIFT(3538),
  [5600] = {.count = 1, .reusable = false}, SHIFT(3537),
  [5602] = {.count = 1, .reusable = false}, SHIFT(1369),
  [5604] = {.count = 1, .reusable = true}, SHIFT(3542),
  [5606] = {.count = 1, .reusable = false}, SHIFT(3542),
  [5608] = {.count = 1, .reusable = true}, SHIFT(3546),
  [5610] = {.count = 1, .reusable = true}, SHIFT(3547),
  [5612] = {.count = 1, .reusable = false}, SHIFT(3548),
  [5614] = {.count = 1, .reusable = true}, SHIFT(3549),
  [5616] = {.count = 1, .reusable = false}, SHIFT(3550),
  [5618] = {.count = 1, .reusable = false}, SHIFT(3551),
  [5620] = {.count = 1, .reusable = true}, SHIFT(3553),
  [5622] = {.count = 1, .reusable = false}, SHIFT(3554),
  [5624] = {.count = 1, .reusable = true}, SHIFT(3554),
  [5626] = {.count = 1, .reusable = true}, SHIFT(3556),
  [5628] = {.count = 1, .reusable = true}, SHIFT(3557),
  [5630] = {.count = 1, .reusable = false}, SHIFT(3556),
  [5632] = {.count = 1, .reusable = true}, SHIFT(3551),
  [5634] = {.count = 1, .reusable = true}, SHIFT(3548),
  [5636] = {.count = 1, .reusable = true}, SHIFT(3558),
  [5638] = {.count = 1, .reusable = true}, SHIFT(3560),
  [5640] = {.count = 1, .reusable = true}, SHIFT(3562),
  [5642] = {.count = 1, .reusable = false}, SHIFT(3562),
  [5644] = {.count = 1, .reusable = true}, SHIFT(3563),
  [5646] = {.count = 1, .reusable = false}, SHIFT(3552),
  [5648] = {.count = 1, .reusable = true}, SHIFT(3564),
  [5650] = {.count = 1, .reusable = true}, SHIFT(3565),
  [5652] = {.count = 1, .reusable = true}, SHIFT(3566),
  [5654] = {.count = 1, .reusable = true}, SHIFT(3567),
  [5656] = {.count = 1, .reusable = true}, SHIFT(3569),
  [5658] = {.count = 1, .reusable = true}, SHIFT(3571),
  [5660] = {.count = 1, .reusable = true}, SHIFT(3572),
  [5662] = {.count = 1, .reusable = false}, SHIFT(3576),
  [5664] = {.count = 1, .reusable = true}, SHIFT(3577),
  [5666] = {.count = 1, .reusable = true}, SHIFT(3579),
  [5668] = {.count = 1, .reusable = true}, SHIFT(3585),
  [5670] = {.count = 1, .reusable = false}, SHIFT(3582),
  [5672] = {.count = 1, .reusable = true}, SHIFT(1404),
  [5674] = {.count = 1, .reusable = true}, SHIFT(3600),
  [5676] = {.count = 1, .reusable = false}, SHIFT(3600),
  [5678] = {.count = 1, .reusable = true}, SHIFT(3601),
  [5680] = {.count = 1, .reusable = true}, SHIFT(3602),
  [5682] = {.count = 1, .reusable = true}, SHIFT(3605),
  [5684] = {.count = 1, .reusable = true}, SHIFT(3608),
  [5686] = {.count = 1, .reusable = false}, SHIFT(1434),
  [5688] = {.count = 1, .reusable = true}, SHIFT(3613),
  [5690] = {.count = 1, .reusable = true}, SHIFT(3614),
  [5692] = {.count = 1, .reusable = true}, SHIFT(3621),
  [5694] = {.count = 1, .reusable = false}, SHIFT(3618),
  [5696] = {.count = 1, .reusable = false}, SHIFT(3613),
  [5698] = {.count = 1, .reusable = true}, SHIFT(3624),
  [5700] = {.count = 1, .reusable = true}, SHIFT(3625),
  [5702] = {.count = 1, .reusable = false}, SHIFT(3626),
  [5704] = {.count = 1, .reusable = false}, SHIFT(3627),
  [5706] = {.count = 1, .reusable = false}, SHIFT(3628),
  [5708] = {.count = 1, .reusable = false}, SHIFT(3629),
  [5710] = {.count = 1, .reusable = true}, SHIFT(3631),
  [5712] = {.count = 1, .reusable = false}, SHIFT(3632),
  [5714] = {.count = 1, .reusable = true}, SHIFT(3632),
  [5716] = {.count = 1, .reusable = false}, SHIFT(3634),
  [5718] = {.count = 1, .reusable = false}, SHIFT(3635),
  [5720] = {.count = 1, .reusable = true}, SHIFT(3634),
  [5722] = {.count = 1, .reusable = true}, SHIFT(3629),
  [5724] = {.count = 1, .reusable = false}, SHIFT(3636),
  [5726] = {.count = 1, .reusable = true}, SHIFT(1433),
  [5728] = {.count = 1, .reusable = true}, SHIFT(3639),
  [5730] = {.count = 1, .reusable = true}, SHIFT(3641),
  [5732] = {.count = 1, .reusable = false}, SHIFT(3641),
  [5734] = {.count = 1, .reusable = true}, SHIFT(3642),
  [5736] = {.count = 1, .reusable = false}, SHIFT(3630),
  [5738] = {.count = 1, .reusable = true}, REDUCE(sym_array, 3),
  [5740] = {.count = 1, .reusable = false}, REDUCE(sym_array, 3),
  [5742] = {.count = 1, .reusable = true}, SHIFT(3644),
  [5744] = {.count = 1, .reusable = true}, SHIFT(3645),
  [5746] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 2),
  [5748] = {.count = 1, .reusable = true}, SHIFT(3648),
  [5750] = {.count = 1, .reusable = true}, REDUCE(sym_block, 2),
  [5752] = {.count = 1, .reusable = false}, REDUCE(sym_block, 2),
  [5754] = {.count = 1, .reusable = true}, SHIFT(3654),
  [5756] = {.count = 1, .reusable = true}, SHIFT(3655),
  [5758] = {.count = 1, .reusable = true}, SHIFT(3656),
  [5760] = {.count = 1, .reusable = true}, SHIFT(3657),
  [5762] = {.count = 1, .reusable = true}, SHIFT(3659),
  [5764] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 2),
  [5766] = {.count = 1, .reusable = true}, SHIFT(3662),
  [5768] = {.count = 1, .reusable = true}, SHIFT(3663),
  [5770] = {.count = 1, .reusable = true}, SHIFT(3664),
  [5772] = {.count = 1, .reusable = true}, SHIFT(3665),
  [5774] = {.count = 1, .reusable = true}, REDUCE(sym_splat_parameter, 2),
  [5776] = {.count = 1, .reusable = true}, REDUCE(sym_hash_splat_parameter, 2),
  [5778] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameter, 2),
  [5780] = {.count = 1, .reusable = true}, SHIFT(3667),
  [5782] = {.count = 1, .reusable = true}, SHIFT(3668),
  [5784] = {.count = 1, .reusable = true}, SHIFT(3669),
  [5786] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 2),
  [5788] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 2),
  [5790] = {.count = 1, .reusable = true}, SHIFT(3671),
  [5792] = {.count = 1, .reusable = true}, SHIFT(3673),
  [5794] = {.count = 1, .reusable = false}, SHIFT(3671),
  [5796] = {.count = 1, .reusable = true}, SHIFT(3675),
  [5798] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 2),
  [5800] = {.count = 1, .reusable = false}, SHIFT(3676),
  [5802] = {.count = 1, .reusable = false}, SHIFT(3677),
  [5804] = {.count = 1, .reusable = false}, SHIFT(3678),
  [5806] = {.count = 1, .reusable = false}, SHIFT(3679),
  [5808] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 2),
  [5810] = {.count = 1, .reusable = false}, SHIFT(3680),
  [5812] = {.count = 1, .reusable = true}, SHIFT(3681),
  [5814] = {.count = 1, .reusable = false}, SHIFT(3681),
  [5816] = {.count = 1, .reusable = true}, SHIFT(3682),
  [5818] = {.count = 1, .reusable = false}, SHIFT(3684),
  [5820] = {.count = 1, .reusable = true}, SHIFT(3684),
  [5822] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [5824] = {.count = 1, .reusable = false}, REDUCE(sym_lambda, 3),
  [5826] = {.count = 1, .reusable = true}, SHIFT(374),
  [5828] = {.count = 1, .reusable = false}, SHIFT(3691),
  [5830] = {.count = 1, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2),
  [5832] = {.count = 1, .reusable = true}, REDUCE(sym__statements, 3),
  [5834] = {.count = 1, .reusable = false}, REDUCE(sym__statements, 3),
  [5836] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(3692),
  [5839] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(281),
  [5842] = {.count = 1, .reusable = true}, REDUCE(sym_if_modifier, 3),
  [5844] = {.count = 1, .reusable = true}, REDUCE(sym_unless_modifier, 3),
  [5846] = {.count = 1, .reusable = true}, REDUCE(sym_while_modifier, 3),
  [5848] = {.count = 1, .reusable = true}, REDUCE(sym_until_modifier, 3),
  [5850] = {.count = 1, .reusable = true}, REDUCE(sym_rescue_modifier, 3),
  [5852] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3, .alias_sequence_id = 16),
  [5854] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3, .alias_sequence_id = 16),
  [5856] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3, .alias_sequence_id = 17),
  [5858] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3, .alias_sequence_id = 17),
  [5860] = {.count = 1, .reusable = true}, REDUCE(sym_binary, 3),
  [5862] = {.count = 1, .reusable = false}, REDUCE(sym_binary, 3),
  [5864] = {.count = 1, .reusable = true}, SHIFT(3693),
  [5866] = {.count = 1, .reusable = true}, SHIFT(3696),
  [5868] = {.count = 1, .reusable = true}, SHIFT(3697),
  [5870] = {.count = 1, .reusable = true}, SHIFT(3698),
  [5872] = {.count = 1, .reusable = true}, SHIFT(3699),
  [5874] = {.count = 1, .reusable = false}, SHIFT(3701),
  [5876] = {.count = 1, .reusable = false}, SHIFT(3702),
  [5878] = {.count = 1, .reusable = false}, SHIFT(3703),
  [5880] = {.count = 1, .reusable = false}, SHIFT(3704),
  [5882] = {.count = 1, .reusable = true}, SHIFT(3706),
  [5884] = {.count = 1, .reusable = false}, SHIFT(3706),
  [5886] = {.count = 1, .reusable = false}, SHIFT(3707),
  [5888] = {.count = 1, .reusable = true}, SHIFT(3707),
  [5890] = {.count = 1, .reusable = false}, SHIFT(3708),
  [5892] = {.count = 1, .reusable = true}, SHIFT(3710),
  [5894] = {.count = 1, .reusable = false}, SHIFT(3710),
  [5896] = {.count = 1, .reusable = true}, SHIFT(3718),
  [5898] = {.count = 1, .reusable = true}, SHIFT(3719),
  [5900] = {.count = 1, .reusable = false}, SHIFT(3720),
  [5902] = {.count = 1, .reusable = true}, SHIFT(3721),
  [5904] = {.count = 1, .reusable = false}, SHIFT(3722),
  [5906] = {.count = 1, .reusable = false}, SHIFT(3723),
  [5908] = {.count = 1, .reusable = true}, SHIFT(3724),
  [5910] = {.count = 1, .reusable = true}, SHIFT(3725),
  [5912] = {.count = 1, .reusable = false}, SHIFT(3726),
  [5914] = {.count = 1, .reusable = true}, SHIFT(3726),
  [5916] = {.count = 1, .reusable = true}, SHIFT(3727),
  [5918] = {.count = 1, .reusable = true}, SHIFT(3728),
  [5920] = {.count = 1, .reusable = true}, SHIFT(3729),
  [5922] = {.count = 1, .reusable = false}, SHIFT(3728),
  [5924] = {.count = 1, .reusable = true}, SHIFT(3723),
  [5926] = {.count = 1, .reusable = true}, SHIFT(3720),
  [5928] = {.count = 1, .reusable = true}, SHIFT(3730),
  [5930] = {.count = 1, .reusable = true}, SHIFT(3731),
  [5932] = {.count = 1, .reusable = true}, SHIFT(3732),
  [5934] = {.count = 1, .reusable = true}, SHIFT(3733),
  [5936] = {.count = 1, .reusable = true}, SHIFT(3734),
  [5938] = {.count = 1, .reusable = false}, SHIFT(3736),
  [5940] = {.count = 1, .reusable = false}, SHIFT(3737),
  [5942] = {.count = 1, .reusable = false}, SHIFT(3738),
  [5944] = {.count = 1, .reusable = false}, SHIFT(3739),
  [5946] = {.count = 1, .reusable = true}, SHIFT(3741),
  [5948] = {.count = 1, .reusable = false}, SHIFT(3741),
  [5950] = {.count = 1, .reusable = false}, SHIFT(3742),
  [5952] = {.count = 1, .reusable = true}, SHIFT(3742),
  [5954] = {.count = 1, .reusable = false}, SHIFT(3743),
  [5956] = {.count = 1, .reusable = true}, SHIFT(3745),
  [5958] = {.count = 1, .reusable = false}, SHIFT(3745),
  [5960] = {.count = 1, .reusable = true}, SHIFT(3751),
  [5962] = {.count = 1, .reusable = false}, SHIFT(3751),
  [5964] = {.count = 1, .reusable = true}, SHIFT(3752),
  [5966] = {.count = 1, .reusable = true}, REDUCE(sym_range, 3),
  [5968] = {.count = 1, .reusable = true}, SHIFT(3755),
  [5970] = {.count = 1, .reusable = true}, SHIFT(3754),
  [5972] = {.count = 1, .reusable = true}, SHIFT(3756),
  [5974] = {.count = 1, .reusable = true}, REDUCE(sym_call, 3),
  [5976] = {.count = 1, .reusable = false}, REDUCE(sym_call, 3),
  [5978] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list_with_parens, 1),
  [5980] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list_with_parens, 1),
  [5982] = {.count = 1, .reusable = true}, SHIFT(3759),
  [5984] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 3),
  [5986] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 3),
  [5988] = {.count = 1, .reusable = true}, SHIFT(3761),
  [5990] = {.count = 1, .reusable = true}, REDUCE(sym_scope_resolution, 3),
  [5992] = {.count = 1, .reusable = false}, REDUCE(sym_scope_resolution, 3),
  [5994] = {.count = 1, .reusable = true}, SHIFT(3763),
  [5996] = {.count = 1, .reusable = true}, SHIFT(3764),
  [5998] = {.count = 1, .reusable = true}, SHIFT(3765),
  [6000] = {.count = 1, .reusable = true}, SHIFT(3766),
  [6002] = {.count = 1, .reusable = true}, SHIFT(3767),
  [6004] = {.count = 1, .reusable = false}, SHIFT(3768),
  [6006] = {.count = 1, .reusable = true}, SHIFT(3770),
  [6008] = {.count = 1, .reusable = true}, SHIFT(3771),
  [6010] = {.count = 1, .reusable = true}, SHIFT(3773),
  [6012] = {.count = 1, .reusable = false}, SHIFT(3774),
  [6014] = {.count = 1, .reusable = true}, SHIFT(3776),
  [6016] = {.count = 1, .reusable = true}, SHIFT(3777),
  [6018] = {.count = 1, .reusable = true}, SHIFT(3779),
  [6020] = {.count = 1, .reusable = true}, SHIFT(3781),
  [6022] = {.count = 1, .reusable = true}, SHIFT(3783),
  [6024] = {.count = 1, .reusable = true}, SHIFT(3785),
  [6026] = {.count = 1, .reusable = true}, SHIFT(3787),
  [6028] = {.count = 1, .reusable = false}, SHIFT(3788),
  [6030] = {.count = 1, .reusable = true}, SHIFT(3790),
  [6032] = {.count = 1, .reusable = false}, SHIFT(3791),
  [6034] = {.count = 1, .reusable = true}, SHIFT(3794),
  [6036] = {.count = 1, .reusable = true}, SHIFT(3797),
  [6038] = {.count = 1, .reusable = false}, SHIFT(3799),
  [6040] = {.count = 1, .reusable = true}, SHIFT(3801),
  [6042] = {.count = 1, .reusable = true}, SHIFT(3803),
  [6044] = {.count = 1, .reusable = false}, SHIFT(3804),
  [6046] = {.count = 1, .reusable = false}, SHIFT(3806),
  [6048] = {.count = 1, .reusable = true}, SHIFT(3818),
  [6050] = {.count = 1, .reusable = true}, SHIFT(3824),
  [6052] = {.count = 1, .reusable = false}, SHIFT(3823),
  [6054] = {.count = 1, .reusable = false}, SHIFT(3828),
  [6056] = {.count = 1, .reusable = true}, SHIFT(3829),
  [6058] = {.count = 1, .reusable = true}, SHIFT(3834),
  [6060] = {.count = 1, .reusable = true}, SHIFT(3835),
  [6062] = {.count = 1, .reusable = false}, SHIFT(3836),
  [6064] = {.count = 1, .reusable = false}, SHIFT(3837),
  [6066] = {.count = 1, .reusable = false}, SHIFT(3838),
  [6068] = {.count = 1, .reusable = false}, SHIFT(3839),
  [6070] = {.count = 1, .reusable = true}, SHIFT(3840),
  [6072] = {.count = 1, .reusable = false}, SHIFT(3841),
  [6074] = {.count = 1, .reusable = true}, SHIFT(3841),
  [6076] = {.count = 1, .reusable = false}, SHIFT(3843),
  [6078] = {.count = 1, .reusable = false}, SHIFT(3844),
  [6080] = {.count = 1, .reusable = true}, SHIFT(3843),
  [6082] = {.count = 1, .reusable = true}, SHIFT(3839),
  [6084] = {.count = 1, .reusable = false}, SHIFT(3845),
  [6086] = {.count = 1, .reusable = true}, SHIFT(3846),
  [6088] = {.count = 1, .reusable = true}, SHIFT(3847),
  [6090] = {.count = 1, .reusable = false}, SHIFT(3847),
  [6092] = {.count = 1, .reusable = true}, SHIFT(3848),
  [6094] = {.count = 1, .reusable = true}, SHIFT(3850),
  [6096] = {.count = 1, .reusable = true}, SHIFT(3854),
  [6098] = {.count = 1, .reusable = true}, SHIFT(3855),
  [6100] = {.count = 1, .reusable = true}, SHIFT(3856),
  [6102] = {.count = 1, .reusable = false}, SHIFT(3858),
  [6104] = {.count = 1, .reusable = true}, SHIFT(3865),
  [6106] = {.count = 1, .reusable = true}, SHIFT(3867),
  [6108] = {.count = 1, .reusable = true}, SHIFT(3868),
  [6110] = {.count = 1, .reusable = false}, SHIFT(3869),
  [6112] = {.count = 1, .reusable = true}, SHIFT(3870),
  [6114] = {.count = 1, .reusable = false}, SHIFT(3871),
  [6116] = {.count = 1, .reusable = false}, SHIFT(3872),
  [6118] = {.count = 1, .reusable = true}, SHIFT(3873),
  [6120] = {.count = 1, .reusable = false}, SHIFT(3874),
  [6122] = {.count = 1, .reusable = true}, SHIFT(3874),
  [6124] = {.count = 1, .reusable = true}, SHIFT(3875),
  [6126] = {.count = 1, .reusable = true}, SHIFT(3876),
  [6128] = {.count = 1, .reusable = true}, SHIFT(3877),
  [6130] = {.count = 1, .reusable = false}, SHIFT(3876),
  [6132] = {.count = 1, .reusable = true}, SHIFT(3872),
  [6134] = {.count = 1, .reusable = true}, SHIFT(3869),
  [6136] = {.count = 1, .reusable = true}, SHIFT(3878),
  [6138] = {.count = 1, .reusable = true}, SHIFT(3879),
  [6140] = {.count = 1, .reusable = true}, SHIFT(3880),
  [6142] = {.count = 1, .reusable = true}, SHIFT(3881),
  [6144] = {.count = 1, .reusable = false}, SHIFT(3883),
  [6146] = {.count = 1, .reusable = true}, SHIFT(3888),
  [6148] = {.count = 1, .reusable = false}, SHIFT(3888),
  [6150] = {.count = 1, .reusable = true}, SHIFT(3889),
  [6152] = {.count = 1, .reusable = true}, SHIFT(3891),
  [6154] = {.count = 1, .reusable = true}, SHIFT(3894),
  [6156] = {.count = 1, .reusable = true}, SHIFT(3895),
  [6158] = {.count = 1, .reusable = true}, SHIFT(3896),
  [6160] = {.count = 1, .reusable = true}, SHIFT(3899),
  [6162] = {.count = 1, .reusable = true}, SHIFT(3901),
  [6164] = {.count = 1, .reusable = false}, SHIFT(3900),
  [6166] = {.count = 1, .reusable = true}, SHIFT(3902),
  [6168] = {.count = 1, .reusable = true}, SHIFT(3903),
  [6170] = {.count = 1, .reusable = true}, SHIFT(3904),
  [6172] = {.count = 1, .reusable = true}, SHIFT(3905),
  [6174] = {.count = 1, .reusable = true}, SHIFT(3907),
  [6176] = {.count = 1, .reusable = true}, SHIFT(3909),
  [6178] = {.count = 1, .reusable = false}, SHIFT(3907),
  [6180] = {.count = 1, .reusable = true}, SHIFT(3911),
  [6182] = {.count = 1, .reusable = true}, SHIFT(3913),
  [6184] = {.count = 1, .reusable = true}, SHIFT(3914),
  [6186] = {.count = 1, .reusable = false}, SHIFT(3918),
  [6188] = {.count = 1, .reusable = true}, SHIFT(3919),
  [6190] = {.count = 1, .reusable = true}, SHIFT(3921),
  [6192] = {.count = 1, .reusable = true}, SHIFT(3923),
  [6194] = {.count = 1, .reusable = true}, SHIFT(3938),
  [6196] = {.count = 1, .reusable = true}, REDUCE(sym_method_call, 3),
  [6198] = {.count = 1, .reusable = false}, REDUCE(sym_method_call, 3),
  [6200] = {.count = 1, .reusable = true}, SHIFT(3940),
  [6202] = {.count = 1, .reusable = true}, SHIFT(3939),
  [6204] = {.count = 1, .reusable = true}, SHIFT(415),
  [6206] = {.count = 1, .reusable = true}, SHIFT(3955),
  [6208] = {.count = 1, .reusable = true}, SHIFT(3956),
  [6210] = {.count = 1, .reusable = false}, SHIFT(3957),
  [6212] = {.count = 1, .reusable = true}, SHIFT(3958),
  [6214] = {.count = 1, .reusable = false}, SHIFT(3959),
  [6216] = {.count = 1, .reusable = false}, SHIFT(3960),
  [6218] = {.count = 1, .reusable = true}, SHIFT(3961),
  [6220] = {.count = 1, .reusable = false}, SHIFT(3962),
  [6222] = {.count = 1, .reusable = true}, SHIFT(3962),
  [6224] = {.count = 1, .reusable = true}, SHIFT(3964),
  [6226] = {.count = 1, .reusable = true}, SHIFT(3965),
  [6228] = {.count = 1, .reusable = false}, SHIFT(3964),
  [6230] = {.count = 1, .reusable = true}, SHIFT(3960),
  [6232] = {.count = 1, .reusable = true}, SHIFT(3957),
  [6234] = {.count = 1, .reusable = true}, SHIFT(3966),
  [6236] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [6238] = {.count = 1, .reusable = false}, REDUCE(sym_assignment, 3),
  [6240] = {.count = 1, .reusable = true}, SHIFT(3967),
  [6242] = {.count = 1, .reusable = true}, SHIFT(3969),
  [6244] = {.count = 1, .reusable = false}, SHIFT(3969),
  [6246] = {.count = 1, .reusable = true}, SHIFT(3970),
  [6248] = {.count = 1, .reusable = true}, REDUCE(sym__mlhs, 3),
  [6250] = {.count = 1, .reusable = true}, REDUCE(sym_operator_assignment, 3),
  [6252] = {.count = 1, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6254] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(3),
  [6257] = {.count = 1, .reusable = false}, REDUCE(aux_sym_chained_string_repeat1, 2),
  [6259] = {.count = 1, .reusable = true}, SHIFT(3971),
  [6261] = {.count = 1, .reusable = false}, SHIFT(3972),
  [6263] = {.count = 1, .reusable = false}, SHIFT(3973),
  [6265] = {.count = 1, .reusable = false}, SHIFT(3974),
  [6267] = {.count = 1, .reusable = false}, SHIFT(3975),
  [6269] = {.count = 1, .reusable = false}, SHIFT(3976),
  [6271] = {.count = 1, .reusable = true}, SHIFT(3977),
  [6273] = {.count = 1, .reusable = false}, SHIFT(3977),
  [6275] = {.count = 1, .reusable = true}, SHIFT(3978),
  [6277] = {.count = 1, .reusable = false}, SHIFT(3980),
  [6279] = {.count = 1, .reusable = true}, SHIFT(3980),
  [6281] = {.count = 1, .reusable = false}, SHIFT(1686),
  [6283] = {.count = 1, .reusable = true}, SHIFT(3987),
  [6285] = {.count = 1, .reusable = true}, SHIFT(3989),
  [6287] = {.count = 1, .reusable = true}, SHIFT(3990),
  [6289] = {.count = 1, .reusable = true}, SHIFT(3991),
  [6291] = {.count = 1, .reusable = false}, SHIFT(3993),
  [6293] = {.count = 1, .reusable = false}, SHIFT(3987),
  [6295] = {.count = 1, .reusable = true}, SHIFT(4000),
  [6297] = {.count = 1, .reusable = true}, SHIFT(4001),
  [6299] = {.count = 1, .reusable = false}, SHIFT(4002),
  [6301] = {.count = 1, .reusable = true}, SHIFT(4003),
  [6303] = {.count = 1, .reusable = false}, SHIFT(4004),
  [6305] = {.count = 1, .reusable = false}, SHIFT(4005),
  [6307] = {.count = 1, .reusable = true}, SHIFT(4006),
  [6309] = {.count = 1, .reusable = true}, SHIFT(4007),
  [6311] = {.count = 1, .reusable = false}, SHIFT(4008),
  [6313] = {.count = 1, .reusable = true}, SHIFT(4008),
  [6315] = {.count = 1, .reusable = true}, SHIFT(4010),
  [6317] = {.count = 1, .reusable = true}, SHIFT(4011),
  [6319] = {.count = 1, .reusable = false}, SHIFT(4010),
  [6321] = {.count = 1, .reusable = true}, SHIFT(4005),
  [6323] = {.count = 1, .reusable = true}, SHIFT(4002),
  [6325] = {.count = 1, .reusable = true}, SHIFT(4012),
  [6327] = {.count = 1, .reusable = true}, SHIFT(4013),
  [6329] = {.count = 1, .reusable = true}, SHIFT(4014),
  [6331] = {.count = 1, .reusable = true}, SHIFT(4015),
  [6333] = {.count = 1, .reusable = false}, SHIFT(4017),
  [6335] = {.count = 1, .reusable = true}, SHIFT(4023),
  [6337] = {.count = 1, .reusable = true}, SHIFT(4025),
  [6339] = {.count = 1, .reusable = false}, SHIFT(4025),
  [6341] = {.count = 1, .reusable = true}, SHIFT(4026),
  [6343] = {.count = 1, .reusable = false}, SHIFT(4006),
  [6345] = {.count = 1, .reusable = true}, SHIFT(4028),
  [6347] = {.count = 1, .reusable = true}, SHIFT(4029),
  [6349] = {.count = 1, .reusable = true}, SHIFT(4031),
  [6351] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [6353] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [6355] = {.count = 1, .reusable = true}, SHIFT(4049),
  [6357] = {.count = 1, .reusable = false}, SHIFT(4049),
  [6359] = {.count = 1, .reusable = true}, SHIFT(4050),
  [6361] = {.count = 1, .reusable = true}, SHIFT(4051),
  [6363] = {.count = 1, .reusable = true}, SHIFT(4054),
  [6365] = {.count = 1, .reusable = true}, SHIFT(4057),
  [6367] = {.count = 1, .reusable = true}, SHIFT(4058),
  [6369] = {.count = 1, .reusable = true}, SHIFT(4059),
  [6371] = {.count = 1, .reusable = true}, SHIFT(4060),
  [6373] = {.count = 1, .reusable = true}, SHIFT(4061),
  [6375] = {.count = 1, .reusable = true}, SHIFT(4062),
  [6377] = {.count = 1, .reusable = true}, SHIFT(4063),
  [6379] = {.count = 1, .reusable = true}, SHIFT(4064),
  [6381] = {.count = 1, .reusable = true}, SHIFT(4089),
  [6383] = {.count = 1, .reusable = true}, SHIFT(4065),
  [6385] = {.count = 1, .reusable = true}, SHIFT(4066),
  [6387] = {.count = 1, .reusable = false}, SHIFT(4067),
  [6389] = {.count = 1, .reusable = true}, SHIFT(4068),
  [6391] = {.count = 1, .reusable = false}, SHIFT(4069),
  [6393] = {.count = 1, .reusable = false}, SHIFT(4070),
  [6395] = {.count = 1, .reusable = false}, SHIFT(4071),
  [6397] = {.count = 1, .reusable = false}, SHIFT(4072),
  [6399] = {.count = 1, .reusable = false}, SHIFT(4073),
  [6401] = {.count = 1, .reusable = false}, SHIFT(4074),
  [6403] = {.count = 1, .reusable = false}, SHIFT(4089),
  [6405] = {.count = 1, .reusable = false}, SHIFT(4075),
  [6407] = {.count = 1, .reusable = false}, SHIFT(4076),
  [6409] = {.count = 1, .reusable = false}, SHIFT(4077),
  [6411] = {.count = 1, .reusable = false}, SHIFT(4078),
  [6413] = {.count = 1, .reusable = false}, SHIFT(4079),
  [6415] = {.count = 1, .reusable = false}, SHIFT(4080),
  [6417] = {.count = 1, .reusable = false}, SHIFT(4081),
  [6419] = {.count = 1, .reusable = false}, SHIFT(4082),
  [6421] = {.count = 1, .reusable = true}, SHIFT(4083),
  [6423] = {.count = 1, .reusable = false}, SHIFT(4083),
  [6425] = {.count = 1, .reusable = true}, SHIFT(4084),
  [6427] = {.count = 1, .reusable = false}, SHIFT(4090),
  [6429] = {.count = 1, .reusable = true}, SHIFT(4090),
  [6431] = {.count = 1, .reusable = false}, SHIFT(4085),
  [6433] = {.count = 1, .reusable = true}, SHIFT(4086),
  [6435] = {.count = 1, .reusable = true}, SHIFT(4087),
  [6437] = {.count = 1, .reusable = false}, SHIFT(1736),
  [6439] = {.count = 1, .reusable = true}, SHIFT(4097),
  [6441] = {.count = 1, .reusable = true}, SHIFT(4098),
  [6443] = {.count = 1, .reusable = true}, SHIFT(4105),
  [6445] = {.count = 1, .reusable = false}, SHIFT(4102),
  [6447] = {.count = 1, .reusable = true}, SHIFT(4106),
  [6449] = {.count = 1, .reusable = false}, SHIFT(4097),
  [6451] = {.count = 1, .reusable = true}, SHIFT(4111),
  [6453] = {.count = 1, .reusable = true}, SHIFT(4112),
  [6455] = {.count = 1, .reusable = false}, SHIFT(4113),
  [6457] = {.count = 1, .reusable = false}, SHIFT(4114),
  [6459] = {.count = 1, .reusable = false}, SHIFT(4115),
  [6461] = {.count = 1, .reusable = false}, SHIFT(4116),
  [6463] = {.count = 1, .reusable = true}, SHIFT(4117),
  [6465] = {.count = 1, .reusable = true}, SHIFT(4118),
  [6467] = {.count = 1, .reusable = false}, SHIFT(4119),
  [6469] = {.count = 1, .reusable = true}, SHIFT(4119),
  [6471] = {.count = 1, .reusable = false}, SHIFT(4121),
  [6473] = {.count = 1, .reusable = false}, SHIFT(4122),
  [6475] = {.count = 1, .reusable = true}, SHIFT(4121),
  [6477] = {.count = 1, .reusable = true}, SHIFT(4116),
  [6479] = {.count = 1, .reusable = false}, SHIFT(4123),
  [6481] = {.count = 1, .reusable = true}, SHIFT(4124),
  [6483] = {.count = 1, .reusable = true}, SHIFT(1734),
  [6485] = {.count = 1, .reusable = true}, SHIFT(4126),
  [6487] = {.count = 1, .reusable = true}, SHIFT(4128),
  [6489] = {.count = 1, .reusable = true}, SHIFT(4130),
  [6491] = {.count = 1, .reusable = false}, SHIFT(4130),
  [6493] = {.count = 1, .reusable = true}, SHIFT(4131),
  [6495] = {.count = 1, .reusable = false}, SHIFT(4117),
  [6497] = {.count = 1, .reusable = true}, SHIFT(4133),
  [6499] = {.count = 1, .reusable = true}, SHIFT(4134),
  [6501] = {.count = 1, .reusable = false}, SHIFT(4135),
  [6503] = {.count = 1, .reusable = false}, SHIFT(4136),
  [6505] = {.count = 1, .reusable = false}, SHIFT(4137),
  [6507] = {.count = 1, .reusable = false}, SHIFT(4138),
  [6509] = {.count = 1, .reusable = false}, SHIFT(4139),
  [6511] = {.count = 1, .reusable = true}, SHIFT(4140),
  [6513] = {.count = 1, .reusable = false}, SHIFT(4140),
  [6515] = {.count = 1, .reusable = true}, SHIFT(4141),
  [6517] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 18),
  [6519] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 18),
  [6521] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 19),
  [6523] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 19),
  [6525] = {.count = 1, .reusable = true}, SHIFT(4149),
  [6527] = {.count = 1, .reusable = true}, SHIFT(4150),
  [6529] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 4, .alias_sequence_id = 20),
  [6531] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 4, .alias_sequence_id = 20),
  [6533] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2, .alias_sequence_id = 21),
  [6535] = {.count = 1, .reusable = true}, SHIFT(4151),
  [6537] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2),
  [6539] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_array_repeat1, 2), SHIFT_REPEAT(4152),
  [6542] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 22),
  [6544] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 22),
  [6546] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 23),
  [6548] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 23),
  [6550] = {.count = 1, .reusable = true}, SHIFT(4153),
  [6552] = {.count = 1, .reusable = true}, SHIFT(4154),
  [6554] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 24),
  [6556] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 4, .alias_sequence_id = 24),
  [6558] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2, .alias_sequence_id = 25),
  [6560] = {.count = 1, .reusable = true}, SHIFT(4155),
  [6562] = {.count = 1, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2),
  [6564] = {.count = 2, .reusable = true}, REDUCE(aux_sym_symbol_array_repeat1, 2), SHIFT_REPEAT(4156),
  [6567] = {.count = 1, .reusable = true}, SHIFT(4157),
  [6569] = {.count = 1, .reusable = false}, SHIFT(4158),
  [6571] = {.count = 1, .reusable = false}, SHIFT(4159),
  [6573] = {.count = 1, .reusable = false}, SHIFT(4160),
  [6575] = {.count = 1, .reusable = false}, SHIFT(4161),
  [6577] = {.count = 1, .reusable = false}, SHIFT(4162),
  [6579] = {.count = 1, .reusable = true}, SHIFT(4163),
  [6581] = {.count = 1, .reusable = false}, SHIFT(4163),
  [6583] = {.count = 1, .reusable = true}, SHIFT(4164),
  [6585] = {.count = 1, .reusable = false}, SHIFT(1779),
  [6587] = {.count = 1, .reusable = true}, SHIFT(4172),
  [6589] = {.count = 1, .reusable = false}, SHIFT(4172),
  [6591] = {.count = 1, .reusable = true}, SHIFT(4178),
  [6593] = {.count = 1, .reusable = true}, SHIFT(4179),
  [6595] = {.count = 1, .reusable = false}, SHIFT(4180),
  [6597] = {.count = 1, .reusable = true}, SHIFT(4181),
  [6599] = {.count = 1, .reusable = false}, SHIFT(4182),
  [6601] = {.count = 1, .reusable = false}, SHIFT(4183),
  [6603] = {.count = 1, .reusable = true}, SHIFT(4184),
  [6605] = {.count = 1, .reusable = true}, SHIFT(4185),
  [6607] = {.count = 1, .reusable = false}, SHIFT(4186),
  [6609] = {.count = 1, .reusable = true}, SHIFT(4186),
  [6611] = {.count = 1, .reusable = true}, SHIFT(4188),
  [6613] = {.count = 1, .reusable = true}, SHIFT(4189),
  [6615] = {.count = 1, .reusable = false}, SHIFT(4188),
  [6617] = {.count = 1, .reusable = true}, SHIFT(4183),
  [6619] = {.count = 1, .reusable = true}, SHIFT(4180),
  [6621] = {.count = 1, .reusable = true}, SHIFT(4190),
  [6623] = {.count = 1, .reusable = true}, SHIFT(4192),
  [6625] = {.count = 1, .reusable = true}, SHIFT(4194),
  [6627] = {.count = 1, .reusable = false}, SHIFT(4194),
  [6629] = {.count = 1, .reusable = true}, SHIFT(4195),
  [6631] = {.count = 1, .reusable = false}, SHIFT(4184),
  [6633] = {.count = 1, .reusable = true}, REDUCE(sym_begin_block, 4),
  [6635] = {.count = 1, .reusable = true}, SHIFT(4198),
  [6637] = {.count = 1, .reusable = true}, SHIFT(4217),
  [6639] = {.count = 1, .reusable = false}, SHIFT(4218),
  [6641] = {.count = 1, .reusable = false}, SHIFT(4219),
  [6643] = {.count = 1, .reusable = false}, SHIFT(4220),
  [6645] = {.count = 1, .reusable = false}, SHIFT(4221),
  [6647] = {.count = 1, .reusable = false}, SHIFT(4222),
  [6649] = {.count = 1, .reusable = true}, SHIFT(4223),
  [6651] = {.count = 1, .reusable = false}, SHIFT(4223),
  [6653] = {.count = 1, .reusable = true}, SHIFT(4224),
  [6655] = {.count = 1, .reusable = false}, SHIFT(4226),
  [6657] = {.count = 1, .reusable = true}, SHIFT(4226),
  [6659] = {.count = 1, .reusable = false}, SHIFT(1821),
  [6661] = {.count = 1, .reusable = true}, SHIFT(4233),
  [6663] = {.count = 1, .reusable = false}, SHIFT(4233),
  [6665] = {.count = 1, .reusable = true}, SHIFT(4237),
  [6667] = {.count = 1, .reusable = true}, SHIFT(4238),
  [6669] = {.count = 1, .reusable = false}, SHIFT(4239),
  [6671] = {.count = 1, .reusable = false}, SHIFT(4240),
  [6673] = {.count = 1, .reusable = false}, SHIFT(4241),
  [6675] = {.count = 1, .reusable = false}, SHIFT(4242),
  [6677] = {.count = 1, .reusable = true}, SHIFT(4243),
  [6679] = {.count = 1, .reusable = true}, SHIFT(4244),
  [6681] = {.count = 1, .reusable = false}, SHIFT(4245),
  [6683] = {.count = 1, .reusable = true}, SHIFT(4245),
  [6685] = {.count = 1, .reusable = false}, SHIFT(4247),
  [6687] = {.count = 1, .reusable = false}, SHIFT(4248),
  [6689] = {.count = 1, .reusable = true}, SHIFT(4247),
  [6691] = {.count = 1, .reusable = true}, SHIFT(4242),
  [6693] = {.count = 1, .reusable = false}, SHIFT(4249),
  [6695] = {.count = 1, .reusable = true}, SHIFT(4251),
  [6697] = {.count = 1, .reusable = true}, SHIFT(4253),
  [6699] = {.count = 1, .reusable = false}, SHIFT(4253),
  [6701] = {.count = 1, .reusable = true}, SHIFT(4254),
  [6703] = {.count = 1, .reusable = false}, SHIFT(4243),
  [6705] = {.count = 1, .reusable = true}, SHIFT(4256),
  [6707] = {.count = 1, .reusable = true}, SHIFT(4257),
  [6709] = {.count = 1, .reusable = false}, SHIFT(4258),
  [6711] = {.count = 1, .reusable = true}, SHIFT(4259),
  [6713] = {.count = 1, .reusable = false}, SHIFT(4259),
  [6715] = {.count = 1, .reusable = true}, SHIFT(4260),
  [6717] = {.count = 1, .reusable = true}, SHIFT(4267),
  [6719] = {.count = 1, .reusable = true}, SHIFT(4268),
  [6721] = {.count = 1, .reusable = true}, SHIFT(4269),
  [6723] = {.count = 1, .reusable = true}, SHIFT(4271),
  [6725] = {.count = 1, .reusable = true}, SHIFT(4272),
  [6727] = {.count = 1, .reusable = true}, SHIFT(4273),
  [6729] = {.count = 1, .reusable = true}, SHIFT(4274),
  [6731] = {.count = 1, .reusable = true}, SHIFT(4275),
  [6733] = {.count = 1, .reusable = true}, SHIFT(4277),
  [6735] = {.count = 1, .reusable = true}, SHIFT(4278),
  [6737] = {.count = 1, .reusable = true}, SHIFT(4279),
  [6739] = {.count = 1, .reusable = true}, REDUCE(sym_heredoc_body, 3),
  [6741] = {.count = 2, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(1853),
  [6744] = {.count = 1, .reusable = true}, REDUCE(aux_sym_heredoc_body_repeat1, 2),
  [6746] = {.count = 2, .reusable = false}, REDUCE(aux_sym_heredoc_body_repeat1, 2), SHIFT_REPEAT(528),
  [6749] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3, .alias_sequence_id = 26),
  [6751] = {.count = 1, .reusable = true}, SHIFT(4280),
  [6753] = {.count = 1, .reusable = true}, SHIFT(4281),
  [6755] = {.count = 1, .reusable = true}, SHIFT(539),
  [6757] = {.count = 1, .reusable = false}, SHIFT(4283),
  [6759] = {.count = 1, .reusable = true}, SHIFT(4284),
  [6761] = {.count = 1, .reusable = false}, SHIFT(4285),
  [6763] = {.count = 1, .reusable = true}, SHIFT(4286),
  [6765] = {.count = 1, .reusable = false}, SHIFT(4286),
  [6767] = {.count = 1, .reusable = true}, SHIFT(4287),
  [6769] = {.count = 1, .reusable = false}, SHIFT(1872),
  [6771] = {.count = 1, .reusable = true}, SHIFT(4294),
  [6773] = {.count = 1, .reusable = true}, SHIFT(4296),
  [6775] = {.count = 1, .reusable = true}, SHIFT(4297),
  [6777] = {.count = 1, .reusable = true}, SHIFT(4298),
  [6779] = {.count = 1, .reusable = false}, SHIFT(4300),
  [6781] = {.count = 1, .reusable = false}, SHIFT(4294),
  [6783] = {.count = 1, .reusable = true}, SHIFT(4307),
  [6785] = {.count = 1, .reusable = true}, SHIFT(4308),
  [6787] = {.count = 1, .reusable = false}, SHIFT(4309),
  [6789] = {.count = 1, .reusable = true}, SHIFT(4310),
  [6791] = {.count = 1, .reusable = false}, SHIFT(4311),
  [6793] = {.count = 1, .reusable = false}, SHIFT(4312),
  [6795] = {.count = 1, .reusable = true}, SHIFT(4313),
  [6797] = {.count = 1, .reusable = true}, SHIFT(4314),
  [6799] = {.count = 1, .reusable = false}, SHIFT(4315),
  [6801] = {.count = 1, .reusable = true}, SHIFT(4315),
  [6803] = {.count = 1, .reusable = true}, SHIFT(4317),
  [6805] = {.count = 1, .reusable = true}, SHIFT(4318),
  [6807] = {.count = 1, .reusable = false}, SHIFT(4317),
  [6809] = {.count = 1, .reusable = true}, SHIFT(4312),
  [6811] = {.count = 1, .reusable = true}, SHIFT(4309),
  [6813] = {.count = 1, .reusable = true}, SHIFT(4319),
  [6815] = {.count = 1, .reusable = true}, SHIFT(4320),
  [6817] = {.count = 1, .reusable = true}, SHIFT(4321),
  [6819] = {.count = 1, .reusable = true}, SHIFT(4322),
  [6821] = {.count = 1, .reusable = false}, SHIFT(4324),
  [6823] = {.count = 1, .reusable = true}, SHIFT(4330),
  [6825] = {.count = 1, .reusable = true}, SHIFT(4332),
  [6827] = {.count = 1, .reusable = false}, SHIFT(4332),
  [6829] = {.count = 1, .reusable = true}, SHIFT(4333),
  [6831] = {.count = 1, .reusable = false}, SHIFT(4313),
  [6833] = {.count = 1, .reusable = true}, SHIFT(4347),
  [6835] = {.count = 1, .reusable = false}, SHIFT(4347),
  [6837] = {.count = 1, .reusable = true}, SHIFT(4348),
  [6839] = {.count = 1, .reusable = true}, SHIFT(4349),
  [6841] = {.count = 1, .reusable = true}, SHIFT(4352),
  [6843] = {.count = 1, .reusable = true}, SHIFT(4355),
  [6845] = {.count = 1, .reusable = true}, SHIFT(4356),
  [6847] = {.count = 1, .reusable = false}, SHIFT(4357),
  [6849] = {.count = 1, .reusable = false}, SHIFT(4358),
  [6851] = {.count = 1, .reusable = false}, SHIFT(4359),
  [6853] = {.count = 1, .reusable = false}, SHIFT(4360),
  [6855] = {.count = 1, .reusable = false}, SHIFT(4361),
  [6857] = {.count = 1, .reusable = true}, SHIFT(4362),
  [6859] = {.count = 1, .reusable = false}, SHIFT(4362),
  [6861] = {.count = 1, .reusable = true}, SHIFT(4363),
  [6863] = {.count = 1, .reusable = false}, SHIFT(4365),
  [6865] = {.count = 1, .reusable = true}, SHIFT(4365),
  [6867] = {.count = 1, .reusable = false}, SHIFT(1911),
  [6869] = {.count = 1, .reusable = true}, SHIFT(4372),
  [6871] = {.count = 1, .reusable = true}, SHIFT(4373),
  [6873] = {.count = 1, .reusable = true}, SHIFT(4380),
  [6875] = {.count = 1, .reusable = false}, SHIFT(4377),
  [6877] = {.count = 1, .reusable = false}, SHIFT(4372),
  [6879] = {.count = 1, .reusable = true}, SHIFT(4383),
  [6881] = {.count = 1, .reusable = true}, SHIFT(4384),
  [6883] = {.count = 1, .reusable = false}, SHIFT(4385),
  [6885] = {.count = 1, .reusable = false}, SHIFT(4386),
  [6887] = {.count = 1, .reusable = false}, SHIFT(4387),
  [6889] = {.count = 1, .reusable = false}, SHIFT(4388),
  [6891] = {.count = 1, .reusable = true}, SHIFT(4389),
  [6893] = {.count = 1, .reusable = true}, SHIFT(4390),
  [6895] = {.count = 1, .reusable = false}, SHIFT(4391),
  [6897] = {.count = 1, .reusable = true}, SHIFT(4391),
  [6899] = {.count = 1, .reusable = false}, SHIFT(4393),
  [6901] = {.count = 1, .reusable = false}, SHIFT(4394),
  [6903] = {.count = 1, .reusable = true}, SHIFT(4393),
  [6905] = {.count = 1, .reusable = true}, SHIFT(4388),
  [6907] = {.count = 1, .reusable = false}, SHIFT(4395),
  [6909] = {.count = 1, .reusable = true}, SHIFT(4396),
  [6911] = {.count = 1, .reusable = true}, SHIFT(1910),
  [6913] = {.count = 1, .reusable = true}, SHIFT(4399),
  [6915] = {.count = 1, .reusable = true}, SHIFT(4401),
  [6917] = {.count = 1, .reusable = false}, SHIFT(4401),
  [6919] = {.count = 1, .reusable = true}, SHIFT(4402),
  [6921] = {.count = 1, .reusable = false}, SHIFT(4389),
  [6923] = {.count = 1, .reusable = true}, SHIFT(4404),
  [6925] = {.count = 1, .reusable = true}, SHIFT(4409),
  [6927] = {.count = 1, .reusable = true}, SHIFT(4410),
  [6929] = {.count = 1, .reusable = false}, SHIFT(4411),
  [6931] = {.count = 1, .reusable = false}, SHIFT(4412),
  [6933] = {.count = 1, .reusable = true}, SHIFT(4416),
  [6935] = {.count = 1, .reusable = true}, SHIFT(4432),
  [6937] = {.count = 1, .reusable = true}, SHIFT(4431),
  [6939] = {.count = 1, .reusable = true}, SHIFT(570),
  [6941] = {.count = 1, .reusable = true}, SHIFT(4446),
  [6943] = {.count = 1, .reusable = false}, SHIFT(4443),
  [6945] = {.count = 1, .reusable = false}, SHIFT(4447),
  [6947] = {.count = 1, .reusable = false}, SHIFT(4450),
  [6949] = {.count = 1, .reusable = false}, SHIFT(4452),
  [6951] = {.count = 1, .reusable = true}, SHIFT(4454),
  [6953] = {.count = 1, .reusable = true}, SHIFT(4456),
  [6955] = {.count = 1, .reusable = true}, SHIFT(4457),
  [6957] = {.count = 1, .reusable = true}, SHIFT(4458),
  [6959] = {.count = 1, .reusable = true}, SHIFT(4461),
  [6961] = {.count = 1, .reusable = true}, SHIFT(4462),
  [6963] = {.count = 1, .reusable = true}, SHIFT(4464),
  [6965] = {.count = 1, .reusable = true}, SHIFT(4466),
  [6967] = {.count = 1, .reusable = false}, SHIFT(4464),
  [6969] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [6971] = {.count = 1, .reusable = true}, SHIFT(4468),
  [6973] = {.count = 1, .reusable = true}, SHIFT(4469),
  [6975] = {.count = 1, .reusable = true}, SHIFT(4472),
  [6977] = {.count = 1, .reusable = true}, SHIFT(4473),
  [6979] = {.count = 1, .reusable = true}, SHIFT(4475),
  [6981] = {.count = 1, .reusable = true}, SHIFT(4476),
  [6983] = {.count = 1, .reusable = true}, SHIFT(4477),
  [6985] = {.count = 1, .reusable = true}, SHIFT(4478),
  [6987] = {.count = 1, .reusable = true}, SHIFT(4479),
  [6989] = {.count = 1, .reusable = false}, SHIFT(4480),
  [6991] = {.count = 1, .reusable = true}, SHIFT(4482),
  [6993] = {.count = 1, .reusable = true}, SHIFT(4483),
  [6995] = {.count = 1, .reusable = true}, SHIFT(4485),
  [6997] = {.count = 1, .reusable = false}, SHIFT(4486),
  [6999] = {.count = 1, .reusable = true}, SHIFT(4488),
  [7001] = {.count = 1, .reusable = true}, SHIFT(4489),
  [7003] = {.count = 1, .reusable = true}, SHIFT(4491),
  [7005] = {.count = 1, .reusable = true}, SHIFT(4493),
  [7007] = {.count = 1, .reusable = true}, SHIFT(4495),
  [7009] = {.count = 1, .reusable = true}, SHIFT(4498),
  [7011] = {.count = 1, .reusable = true}, SHIFT(4499),
  [7013] = {.count = 1, .reusable = true}, SHIFT(4500),
  [7015] = {.count = 1, .reusable = true}, SHIFT(4503),
  [7017] = {.count = 1, .reusable = true}, SHIFT(4505),
  [7019] = {.count = 1, .reusable = false}, SHIFT(4504),
  [7021] = {.count = 1, .reusable = true}, SHIFT(4506),
  [7023] = {.count = 1, .reusable = true}, SHIFT(4507),
  [7025] = {.count = 1, .reusable = true}, SHIFT(4508),
  [7027] = {.count = 1, .reusable = true}, SHIFT(4509),
  [7029] = {.count = 1, .reusable = true}, SHIFT(4511),
  [7031] = {.count = 1, .reusable = true}, SHIFT(4513),
  [7033] = {.count = 1, .reusable = false}, SHIFT(4511),
  [7035] = {.count = 1, .reusable = true}, SHIFT(4515),
  [7037] = {.count = 1, .reusable = true}, SHIFT(4517),
  [7039] = {.count = 1, .reusable = true}, SHIFT(4518),
  [7041] = {.count = 1, .reusable = false}, SHIFT(4522),
  [7043] = {.count = 1, .reusable = true}, SHIFT(4523),
  [7045] = {.count = 1, .reusable = true}, SHIFT(4525),
  [7047] = {.count = 1, .reusable = true}, SHIFT(4527),
  [7049] = {.count = 1, .reusable = true}, SHIFT(4542),
  [7051] = {.count = 1, .reusable = true}, SHIFT(4544),
  [7053] = {.count = 1, .reusable = true}, SHIFT(4543),
  [7055] = {.count = 1, .reusable = true}, SHIFT(645),
  [7057] = {.count = 1, .reusable = true}, SHIFT(4559),
  [7059] = {.count = 1, .reusable = true}, SHIFT(4560),
  [7061] = {.count = 1, .reusable = false}, SHIFT(4561),
  [7063] = {.count = 1, .reusable = true}, SHIFT(4562),
  [7065] = {.count = 1, .reusable = false}, SHIFT(4563),
  [7067] = {.count = 1, .reusable = false}, SHIFT(4564),
  [7069] = {.count = 1, .reusable = true}, SHIFT(4565),
  [7071] = {.count = 1, .reusable = false}, SHIFT(4566),
  [7073] = {.count = 1, .reusable = true}, SHIFT(4566),
  [7075] = {.count = 1, .reusable = true}, SHIFT(4568),
  [7077] = {.count = 1, .reusable = true}, SHIFT(4569),
  [7079] = {.count = 1, .reusable = false}, SHIFT(4568),
  [7081] = {.count = 1, .reusable = true}, SHIFT(4564),
  [7083] = {.count = 1, .reusable = true}, SHIFT(4561),
  [7085] = {.count = 1, .reusable = true}, SHIFT(4570),
  [7087] = {.count = 1, .reusable = true}, SHIFT(4571),
  [7089] = {.count = 1, .reusable = true}, SHIFT(4573),
  [7091] = {.count = 1, .reusable = false}, SHIFT(4573),
  [7093] = {.count = 1, .reusable = true}, SHIFT(4574),
  [7095] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(79),
  [7098] = {.count = 1, .reusable = true}, REDUCE(sym_hash, 4),
  [7100] = {.count = 1, .reusable = false}, REDUCE(sym_hash, 4),
  [7102] = {.count = 1, .reusable = true}, SHIFT(4577),
  [7104] = {.count = 1, .reusable = true}, SHIFT(4576),
  [7106] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 3),
  [7108] = {.count = 1, .reusable = true}, REDUCE(sym_end_block, 4),
  [7110] = {.count = 1, .reusable = true}, SHIFT(4579),
  [7112] = {.count = 1, .reusable = false}, SHIFT(4580),
  [7114] = {.count = 1, .reusable = true}, SHIFT(4581),
  [7116] = {.count = 1, .reusable = false}, SHIFT(4581),
  [7118] = {.count = 1, .reusable = true}, SHIFT(4582),
  [7120] = {.count = 1, .reusable = false}, SHIFT(2135),
  [7122] = {.count = 1, .reusable = true}, SHIFT(4588),
  [7124] = {.count = 1, .reusable = false}, SHIFT(4588),
  [7126] = {.count = 1, .reusable = true}, SHIFT(4592),
  [7128] = {.count = 1, .reusable = true}, SHIFT(4593),
  [7130] = {.count = 1, .reusable = false}, SHIFT(4594),
  [7132] = {.count = 1, .reusable = true}, SHIFT(4595),
  [7134] = {.count = 1, .reusable = false}, SHIFT(4596),
  [7136] = {.count = 1, .reusable = false}, SHIFT(4597),
  [7138] = {.count = 1, .reusable = true}, SHIFT(4598),
  [7140] = {.count = 1, .reusable = true}, SHIFT(4599),
  [7142] = {.count = 1, .reusable = false}, SHIFT(4600),
  [7144] = {.count = 1, .reusable = true}, SHIFT(4600),
  [7146] = {.count = 1, .reusable = true}, SHIFT(4602),
  [7148] = {.count = 1, .reusable = true}, SHIFT(4603),
  [7150] = {.count = 1, .reusable = false}, SHIFT(4602),
  [7152] = {.count = 1, .reusable = true}, SHIFT(4597),
  [7154] = {.count = 1, .reusable = true}, SHIFT(4594),
  [7156] = {.count = 1, .reusable = true}, SHIFT(4604),
  [7158] = {.count = 1, .reusable = true}, SHIFT(4606),
  [7160] = {.count = 1, .reusable = true}, SHIFT(4608),
  [7162] = {.count = 1, .reusable = false}, SHIFT(4608),
  [7164] = {.count = 1, .reusable = true}, SHIFT(4609),
  [7166] = {.count = 1, .reusable = false}, SHIFT(4598),
  [7168] = {.count = 1, .reusable = true}, SHIFT(4612),
  [7170] = {.count = 1, .reusable = true}, SHIFT(4623),
  [7172] = {.count = 1, .reusable = false}, SHIFT(4624),
  [7174] = {.count = 1, .reusable = false}, SHIFT(4625),
  [7176] = {.count = 1, .reusable = false}, SHIFT(4626),
  [7178] = {.count = 1, .reusable = false}, SHIFT(4627),
  [7180] = {.count = 1, .reusable = false}, SHIFT(4628),
  [7182] = {.count = 1, .reusable = true}, SHIFT(4629),
  [7184] = {.count = 1, .reusable = false}, SHIFT(4629),
  [7186] = {.count = 1, .reusable = true}, SHIFT(4630),
  [7188] = {.count = 1, .reusable = false}, SHIFT(4632),
  [7190] = {.count = 1, .reusable = true}, SHIFT(4632),
  [7192] = {.count = 1, .reusable = false}, SHIFT(2169),
  [7194] = {.count = 1, .reusable = true}, SHIFT(4639),
  [7196] = {.count = 1, .reusable = false}, SHIFT(4639),
  [7198] = {.count = 1, .reusable = true}, SHIFT(4643),
  [7200] = {.count = 1, .reusable = true}, SHIFT(4644),
  [7202] = {.count = 1, .reusable = false}, SHIFT(4645),
  [7204] = {.count = 1, .reusable = false}, SHIFT(4646),
  [7206] = {.count = 1, .reusable = false}, SHIFT(4647),
  [7208] = {.count = 1, .reusable = false}, SHIFT(4648),
  [7210] = {.count = 1, .reusable = true}, SHIFT(4649),
  [7212] = {.count = 1, .reusable = true}, SHIFT(4650),
  [7214] = {.count = 1, .reusable = false}, SHIFT(4651),
  [7216] = {.count = 1, .reusable = true}, SHIFT(4651),
  [7218] = {.count = 1, .reusable = false}, SHIFT(4653),
  [7220] = {.count = 1, .reusable = false}, SHIFT(4654),
  [7222] = {.count = 1, .reusable = true}, SHIFT(4653),
  [7224] = {.count = 1, .reusable = true}, SHIFT(4648),
  [7226] = {.count = 1, .reusable = false}, SHIFT(4655),
  [7228] = {.count = 1, .reusable = true}, SHIFT(4657),
  [7230] = {.count = 1, .reusable = true}, SHIFT(4659),
  [7232] = {.count = 1, .reusable = false}, SHIFT(4659),
  [7234] = {.count = 1, .reusable = true}, SHIFT(4660),
  [7236] = {.count = 1, .reusable = false}, SHIFT(4649),
  [7238] = {.count = 1, .reusable = true}, SHIFT(4662),
  [7240] = {.count = 1, .reusable = true}, SHIFT(4663),
  [7242] = {.count = 1, .reusable = false}, SHIFT(4664),
  [7244] = {.count = 1, .reusable = false}, SHIFT(4665),
  [7246] = {.count = 1, .reusable = false}, SHIFT(4666),
  [7248] = {.count = 1, .reusable = false}, SHIFT(4667),
  [7250] = {.count = 1, .reusable = false}, SHIFT(4668),
  [7252] = {.count = 1, .reusable = true}, SHIFT(4669),
  [7254] = {.count = 1, .reusable = false}, SHIFT(4669),
  [7256] = {.count = 1, .reusable = true}, SHIFT(4670),
  [7258] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 4),
  [7260] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 4),
  [7262] = {.count = 1, .reusable = true}, SHIFT(4678),
  [7264] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 2),
  [7266] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 2),
  [7268] = {.count = 1, .reusable = true}, SHIFT(4679),
  [7270] = {.count = 1, .reusable = true}, SHIFT(4681),
  [7272] = {.count = 1, .reusable = false}, SHIFT(4682),
  [7274] = {.count = 1, .reusable = true}, REDUCE(sym__method_rest, 3),
  [7276] = {.count = 1, .reusable = false}, REDUCE(sym__method_rest, 3),
  [7278] = {.count = 1, .reusable = true}, SHIFT(4687),
  [7280] = {.count = 1, .reusable = true}, SHIFT(4689),
  [7282] = {.count = 1, .reusable = false}, SHIFT(4690),
  [7284] = {.count = 1, .reusable = false}, SHIFT(4691),
  [7286] = {.count = 1, .reusable = false}, SHIFT(4692),
  [7288] = {.count = 1, .reusable = false}, SHIFT(4693),
  [7290] = {.count = 1, .reusable = false}, SHIFT(4694),
  [7292] = {.count = 1, .reusable = true}, SHIFT(4695),
  [7294] = {.count = 1, .reusable = false}, SHIFT(4695),
  [7296] = {.count = 1, .reusable = true}, SHIFT(4696),
  [7298] = {.count = 1, .reusable = true}, SHIFT(4704),
  [7300] = {.count = 1, .reusable = true}, SHIFT(4706),
  [7302] = {.count = 1, .reusable = true}, SHIFT(4707),
  [7304] = {.count = 1, .reusable = true}, SHIFT(4708),
  [7306] = {.count = 1, .reusable = false}, SHIFT(2206),
  [7308] = {.count = 1, .reusable = false}, SHIFT(4710),
  [7310] = {.count = 1, .reusable = false}, SHIFT(4704),
  [7312] = {.count = 1, .reusable = true}, SHIFT(4717),
  [7314] = {.count = 1, .reusable = true}, SHIFT(4718),
  [7316] = {.count = 1, .reusable = false}, SHIFT(4719),
  [7318] = {.count = 1, .reusable = true}, SHIFT(4720),
  [7320] = {.count = 1, .reusable = false}, SHIFT(4721),
  [7322] = {.count = 1, .reusable = false}, SHIFT(4722),
  [7324] = {.count = 1, .reusable = true}, SHIFT(4723),
  [7326] = {.count = 1, .reusable = true}, SHIFT(4724),
  [7328] = {.count = 1, .reusable = false}, SHIFT(4725),
  [7330] = {.count = 1, .reusable = true}, SHIFT(4725),
  [7332] = {.count = 1, .reusable = true}, SHIFT(4726),
  [7334] = {.count = 1, .reusable = true}, SHIFT(4727),
  [7336] = {.count = 1, .reusable = true}, SHIFT(4728),
  [7338] = {.count = 1, .reusable = false}, SHIFT(4727),
  [7340] = {.count = 1, .reusable = true}, SHIFT(4722),
  [7342] = {.count = 1, .reusable = true}, SHIFT(4719),
  [7344] = {.count = 1, .reusable = true}, SHIFT(4729),
  [7346] = {.count = 1, .reusable = true}, SHIFT(4731),
  [7348] = {.count = 1, .reusable = true}, SHIFT(4733),
  [7350] = {.count = 1, .reusable = false}, SHIFT(4733),
  [7352] = {.count = 1, .reusable = true}, SHIFT(4734),
  [7354] = {.count = 1, .reusable = false}, SHIFT(4723),
  [7356] = {.count = 1, .reusable = true}, SHIFT(4741),
  [7358] = {.count = 1, .reusable = true}, SHIFT(4742),
  [7360] = {.count = 1, .reusable = false}, SHIFT(4743),
  [7362] = {.count = 1, .reusable = true}, SHIFT(4744),
  [7364] = {.count = 1, .reusable = false}, SHIFT(4745),
  [7366] = {.count = 1, .reusable = false}, SHIFT(4746),
  [7368] = {.count = 1, .reusable = true}, SHIFT(4747),
  [7370] = {.count = 1, .reusable = false}, SHIFT(4748),
  [7372] = {.count = 1, .reusable = true}, SHIFT(4748),
  [7374] = {.count = 1, .reusable = true}, SHIFT(4750),
  [7376] = {.count = 1, .reusable = true}, SHIFT(4751),
  [7378] = {.count = 1, .reusable = false}, SHIFT(4750),
  [7380] = {.count = 1, .reusable = true}, SHIFT(4746),
  [7382] = {.count = 1, .reusable = true}, SHIFT(4743),
  [7384] = {.count = 1, .reusable = true}, SHIFT(4752),
  [7386] = {.count = 1, .reusable = true}, SHIFT(4753),
  [7388] = {.count = 1, .reusable = false}, SHIFT(4753),
  [7390] = {.count = 1, .reusable = true}, SHIFT(4754),
  [7392] = {.count = 1, .reusable = true}, SHIFT(4759),
  [7394] = {.count = 1, .reusable = false}, SHIFT(4759),
  [7396] = {.count = 1, .reusable = true}, SHIFT(4763),
  [7398] = {.count = 1, .reusable = false}, SHIFT(4761),
  [7400] = {.count = 1, .reusable = true}, SHIFT(4780),
  [7402] = {.count = 1, .reusable = false}, SHIFT(4780),
  [7404] = {.count = 1, .reusable = true}, SHIFT(4784),
  [7406] = {.count = 1, .reusable = false}, SHIFT(4782),
  [7408] = {.count = 1, .reusable = true}, SHIFT(716),
  [7410] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(4795),
  [7413] = {.count = 1, .reusable = true}, SHIFT(4796),
  [7415] = {.count = 1, .reusable = true}, SHIFT(4800),
  [7417] = {.count = 1, .reusable = true}, SHIFT(4801),
  [7419] = {.count = 1, .reusable = false}, SHIFT(4802),
  [7421] = {.count = 1, .reusable = false}, SHIFT(4803),
  [7423] = {.count = 1, .reusable = false}, SHIFT(4804),
  [7425] = {.count = 1, .reusable = false}, SHIFT(4805),
  [7427] = {.count = 1, .reusable = true}, SHIFT(4806),
  [7429] = {.count = 1, .reusable = false}, SHIFT(4807),
  [7431] = {.count = 1, .reusable = true}, SHIFT(4807),
  [7433] = {.count = 1, .reusable = false}, SHIFT(4809),
  [7435] = {.count = 1, .reusable = false}, SHIFT(4810),
  [7437] = {.count = 1, .reusable = true}, SHIFT(4809),
  [7439] = {.count = 1, .reusable = true}, SHIFT(4805),
  [7441] = {.count = 1, .reusable = false}, SHIFT(4811),
  [7443] = {.count = 1, .reusable = true}, SHIFT(4812),
  [7445] = {.count = 1, .reusable = false}, SHIFT(4812),
  [7447] = {.count = 1, .reusable = true}, SHIFT(4813),
  [7449] = {.count = 1, .reusable = true}, SHIFT(759),
  [7451] = {.count = 1, .reusable = true}, SHIFT(4841),
  [7453] = {.count = 1, .reusable = true}, SHIFT(4842),
  [7455] = {.count = 1, .reusable = false}, SHIFT(4843),
  [7457] = {.count = 1, .reusable = true}, SHIFT(4844),
  [7459] = {.count = 1, .reusable = false}, SHIFT(4845),
  [7461] = {.count = 1, .reusable = false}, SHIFT(4846),
  [7463] = {.count = 1, .reusable = true}, SHIFT(4847),
  [7465] = {.count = 1, .reusable = false}, SHIFT(4848),
  [7467] = {.count = 1, .reusable = true}, SHIFT(4848),
  [7469] = {.count = 1, .reusable = true}, SHIFT(4850),
  [7471] = {.count = 1, .reusable = true}, SHIFT(4851),
  [7473] = {.count = 1, .reusable = false}, SHIFT(4850),
  [7475] = {.count = 1, .reusable = true}, SHIFT(4846),
  [7477] = {.count = 1, .reusable = true}, SHIFT(4843),
  [7479] = {.count = 1, .reusable = true}, SHIFT(4852),
  [7481] = {.count = 1, .reusable = true}, SHIFT(4853),
  [7483] = {.count = 1, .reusable = true}, SHIFT(4855),
  [7485] = {.count = 1, .reusable = false}, SHIFT(4855),
  [7487] = {.count = 1, .reusable = true}, SHIFT(4856),
  [7489] = {.count = 1, .reusable = true}, SHIFT(4857),
  [7491] = {.count = 1, .reusable = true}, SHIFT(4858),
  [7493] = {.count = 1, .reusable = true}, SHIFT(4859),
  [7495] = {.count = 1, .reusable = true}, SHIFT(4861),
  [7497] = {.count = 1, .reusable = true}, SHIFT(4862),
  [7499] = {.count = 1, .reusable = true}, SHIFT(4863),
  [7501] = {.count = 1, .reusable = true}, SHIFT(4864),
  [7503] = {.count = 1, .reusable = true}, SHIFT(4865),
  [7505] = {.count = 1, .reusable = true}, SHIFT(4867),
  [7507] = {.count = 1, .reusable = true}, SHIFT(4868),
  [7509] = {.count = 1, .reusable = true}, SHIFT(4869),
  [7511] = {.count = 1, .reusable = true}, SHIFT(4870),
  [7513] = {.count = 1, .reusable = true}, SHIFT(800),
  [7515] = {.count = 1, .reusable = false}, SHIFT(4872),
  [7517] = {.count = 1, .reusable = true}, SHIFT(4873),
  [7519] = {.count = 1, .reusable = true}, SHIFT(4874),
  [7521] = {.count = 1, .reusable = false}, SHIFT(4875),
  [7523] = {.count = 1, .reusable = false}, SHIFT(4876),
  [7525] = {.count = 1, .reusable = true}, SHIFT(4878),
  [7527] = {.count = 1, .reusable = true}, SHIFT(4879),
  [7529] = {.count = 1, .reusable = true}, SHIFT(4880),
  [7531] = {.count = 1, .reusable = false}, SHIFT(4882),
  [7533] = {.count = 1, .reusable = true}, SHIFT(4889),
  [7535] = {.count = 1, .reusable = true}, SHIFT(4890),
  [7537] = {.count = 1, .reusable = false}, SHIFT(4891),
  [7539] = {.count = 1, .reusable = true}, SHIFT(4892),
  [7541] = {.count = 1, .reusable = false}, SHIFT(4893),
  [7543] = {.count = 1, .reusable = false}, SHIFT(4894),
  [7545] = {.count = 1, .reusable = true}, SHIFT(4895),
  [7547] = {.count = 1, .reusable = false}, SHIFT(4896),
  [7549] = {.count = 1, .reusable = true}, SHIFT(4896),
  [7551] = {.count = 1, .reusable = true}, SHIFT(4897),
  [7553] = {.count = 1, .reusable = true}, SHIFT(4898),
  [7555] = {.count = 1, .reusable = true}, SHIFT(4899),
  [7557] = {.count = 1, .reusable = false}, SHIFT(4898),
  [7559] = {.count = 1, .reusable = true}, SHIFT(4894),
  [7561] = {.count = 1, .reusable = true}, SHIFT(4891),
  [7563] = {.count = 1, .reusable = true}, SHIFT(4900),
  [7565] = {.count = 1, .reusable = true}, SHIFT(4901),
  [7567] = {.count = 1, .reusable = true}, SHIFT(4902),
  [7569] = {.count = 1, .reusable = true}, SHIFT(4903),
  [7571] = {.count = 1, .reusable = false}, SHIFT(4905),
  [7573] = {.count = 1, .reusable = true}, SHIFT(4910),
  [7575] = {.count = 1, .reusable = false}, SHIFT(4910),
  [7577] = {.count = 1, .reusable = true}, SHIFT(4911),
  [7579] = {.count = 1, .reusable = true}, SHIFT(4914),
  [7581] = {.count = 1, .reusable = true}, SHIFT(4918),
  [7583] = {.count = 1, .reusable = true}, SHIFT(4917),
  [7585] = {.count = 1, .reusable = true}, SHIFT(4927),
  [7587] = {.count = 1, .reusable = false}, SHIFT(4924),
  [7589] = {.count = 1, .reusable = false}, SHIFT(4928),
  [7591] = {.count = 1, .reusable = false}, SHIFT(4931),
  [7593] = {.count = 1, .reusable = false}, SHIFT(4933),
  [7595] = {.count = 1, .reusable = true}, SHIFT(4935),
  [7597] = {.count = 1, .reusable = true}, SHIFT(4937),
  [7599] = {.count = 1, .reusable = true}, SHIFT(4938),
  [7601] = {.count = 1, .reusable = true}, SHIFT(4939),
  [7603] = {.count = 1, .reusable = true}, SHIFT(4942),
  [7605] = {.count = 1, .reusable = true}, SHIFT(4943),
  [7607] = {.count = 1, .reusable = true}, SHIFT(4945),
  [7609] = {.count = 1, .reusable = true}, SHIFT(4947),
  [7611] = {.count = 1, .reusable = false}, SHIFT(4945),
  [7613] = {.count = 1, .reusable = true}, SHIFT(4949),
  [7615] = {.count = 1, .reusable = true}, SHIFT(4952),
  [7617] = {.count = 1, .reusable = true}, SHIFT(4953),
  [7619] = {.count = 1, .reusable = true}, SHIFT(4955),
  [7621] = {.count = 1, .reusable = true}, SHIFT(4957),
  [7623] = {.count = 1, .reusable = true}, SHIFT(4959),
  [7625] = {.count = 1, .reusable = true}, SHIFT(4961),
  [7627] = {.count = 1, .reusable = true}, SHIFT(4963),
  [7629] = {.count = 1, .reusable = false}, SHIFT(4964),
  [7631] = {.count = 1, .reusable = true}, SHIFT(4966),
  [7633] = {.count = 1, .reusable = false}, SHIFT(4967),
  [7635] = {.count = 1, .reusable = true}, SHIFT(4970),
  [7637] = {.count = 1, .reusable = true}, SHIFT(4973),
  [7639] = {.count = 1, .reusable = false}, SHIFT(4975),
  [7641] = {.count = 1, .reusable = true}, SHIFT(4977),
  [7643] = {.count = 1, .reusable = true}, SHIFT(4979),
  [7645] = {.count = 1, .reusable = false}, SHIFT(4980),
  [7647] = {.count = 1, .reusable = false}, SHIFT(4982),
  [7649] = {.count = 1, .reusable = true}, SHIFT(4984),
  [7651] = {.count = 1, .reusable = true}, SHIFT(4985),
  [7653] = {.count = 1, .reusable = true}, SHIFT(4986),
  [7655] = {.count = 1, .reusable = true}, SHIFT(4988),
  [7657] = {.count = 1, .reusable = false}, SHIFT(4989),
  [7659] = {.count = 1, .reusable = true}, SHIFT(5004),
  [7661] = {.count = 1, .reusable = true}, SHIFT(5010),
  [7663] = {.count = 1, .reusable = false}, SHIFT(5009),
  [7665] = {.count = 1, .reusable = true}, SHIFT(5014),
  [7667] = {.count = 1, .reusable = true}, SHIFT(5015),
  [7669] = {.count = 1, .reusable = true}, SHIFT(5018),
  [7671] = {.count = 1, .reusable = false}, SHIFT(5019),
  [7673] = {.count = 1, .reusable = true}, SHIFT(5022),
  [7675] = {.count = 1, .reusable = true}, SHIFT(5023),
  [7677] = {.count = 1, .reusable = false}, SHIFT(5024),
  [7679] = {.count = 1, .reusable = true}, SHIFT(5025),
  [7681] = {.count = 1, .reusable = false}, SHIFT(5026),
  [7683] = {.count = 1, .reusable = false}, SHIFT(5027),
  [7685] = {.count = 1, .reusable = true}, SHIFT(5028),
  [7687] = {.count = 1, .reusable = false}, SHIFT(5029),
  [7689] = {.count = 1, .reusable = true}, SHIFT(5029),
  [7691] = {.count = 1, .reusable = true}, SHIFT(5030),
  [7693] = {.count = 1, .reusable = true}, SHIFT(5031),
  [7695] = {.count = 1, .reusable = true}, SHIFT(5032),
  [7697] = {.count = 1, .reusable = false}, SHIFT(5031),
  [7699] = {.count = 1, .reusable = true}, SHIFT(5027),
  [7701] = {.count = 1, .reusable = true}, SHIFT(5024),
  [7703] = {.count = 1, .reusable = true}, SHIFT(5033),
  [7705] = {.count = 1, .reusable = true}, SHIFT(5034),
  [7707] = {.count = 1, .reusable = true}, SHIFT(5036),
  [7709] = {.count = 1, .reusable = false}, SHIFT(5036),
  [7711] = {.count = 1, .reusable = true}, SHIFT(5037),
  [7713] = {.count = 1, .reusable = true}, SHIFT(5042),
  [7715] = {.count = 1, .reusable = false}, SHIFT(5042),
  [7717] = {.count = 1, .reusable = true}, SHIFT(5046),
  [7719] = {.count = 1, .reusable = false}, SHIFT(5044),
  [7721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(160),
  [7724] = {.count = 1, .reusable = false}, SHIFT(5069),
  [7726] = {.count = 1, .reusable = true}, REDUCE(sym_superclass, 2),
  [7728] = {.count = 1, .reusable = false}, SHIFT(5070),
  [7730] = {.count = 1, .reusable = true}, REDUCE(sym_class, 4),
  [7732] = {.count = 1, .reusable = false}, REDUCE(sym_class, 4),
  [7734] = {.count = 1, .reusable = true}, SHIFT(5072),
  [7736] = {.count = 1, .reusable = true}, SHIFT(5073),
  [7738] = {.count = 1, .reusable = true}, SHIFT(5074),
  [7740] = {.count = 1, .reusable = false}, SHIFT(5076),
  [7742] = {.count = 1, .reusable = true}, SHIFT(5083),
  [7744] = {.count = 1, .reusable = true}, SHIFT(5084),
  [7746] = {.count = 1, .reusable = false}, SHIFT(5085),
  [7748] = {.count = 1, .reusable = true}, SHIFT(5086),
  [7750] = {.count = 1, .reusable = false}, SHIFT(5087),
  [7752] = {.count = 1, .reusable = false}, SHIFT(5088),
  [7754] = {.count = 1, .reusable = true}, SHIFT(5089),
  [7756] = {.count = 1, .reusable = false}, SHIFT(5090),
  [7758] = {.count = 1, .reusable = true}, SHIFT(5090),
  [7760] = {.count = 1, .reusable = true}, SHIFT(5091),
  [7762] = {.count = 1, .reusable = true}, SHIFT(5092),
  [7764] = {.count = 1, .reusable = true}, SHIFT(5093),
  [7766] = {.count = 1, .reusable = false}, SHIFT(5092),
  [7768] = {.count = 1, .reusable = true}, SHIFT(5088),
  [7770] = {.count = 1, .reusable = true}, SHIFT(5085),
  [7772] = {.count = 1, .reusable = true}, SHIFT(5094),
  [7774] = {.count = 1, .reusable = true}, SHIFT(5095),
  [7776] = {.count = 1, .reusable = false}, SHIFT(5095),
  [7778] = {.count = 1, .reusable = true}, SHIFT(5096),
  [7780] = {.count = 1, .reusable = true}, SHIFT(5101),
  [7782] = {.count = 1, .reusable = false}, SHIFT(5101),
  [7784] = {.count = 1, .reusable = true}, SHIFT(5105),
  [7786] = {.count = 1, .reusable = false}, SHIFT(5103),
  [7788] = {.count = 1, .reusable = true}, REDUCE(sym_module, 4),
  [7790] = {.count = 1, .reusable = false}, REDUCE(sym_module, 4),
  [7792] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3, .alias_sequence_id = 26),
  [7794] = {.count = 1, .reusable = true}, SHIFT(919),
  [7796] = {.count = 1, .reusable = true}, SHIFT(5157),
  [7798] = {.count = 1, .reusable = true}, SHIFT(5158),
  [7800] = {.count = 1, .reusable = false}, SHIFT(5159),
  [7802] = {.count = 1, .reusable = true}, SHIFT(5160),
  [7804] = {.count = 1, .reusable = false}, SHIFT(5161),
  [7806] = {.count = 1, .reusable = false}, SHIFT(5162),
  [7808] = {.count = 1, .reusable = true}, SHIFT(5163),
  [7810] = {.count = 1, .reusable = false}, SHIFT(5164),
  [7812] = {.count = 1, .reusable = true}, SHIFT(5164),
  [7814] = {.count = 1, .reusable = true}, SHIFT(5165),
  [7816] = {.count = 1, .reusable = true}, SHIFT(5166),
  [7818] = {.count = 1, .reusable = true}, SHIFT(5167),
  [7820] = {.count = 1, .reusable = false}, SHIFT(5166),
  [7822] = {.count = 1, .reusable = true}, SHIFT(5162),
  [7824] = {.count = 1, .reusable = true}, SHIFT(5159),
  [7826] = {.count = 1, .reusable = true}, SHIFT(5168),
  [7828] = {.count = 1, .reusable = true}, SHIFT(5169),
  [7830] = {.count = 1, .reusable = false}, SHIFT(5169),
  [7832] = {.count = 1, .reusable = true}, SHIFT(5170),
  [7834] = {.count = 1, .reusable = true}, SHIFT(5175),
  [7836] = {.count = 1, .reusable = false}, SHIFT(5175),
  [7838] = {.count = 1, .reusable = true}, SHIFT(5179),
  [7840] = {.count = 1, .reusable = false}, SHIFT(5177),
  [7842] = {.count = 1, .reusable = true}, SHIFT(5196),
  [7844] = {.count = 1, .reusable = false}, SHIFT(5196),
  [7846] = {.count = 1, .reusable = true}, SHIFT(5200),
  [7848] = {.count = 1, .reusable = false}, SHIFT(5198),
  [7850] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 3),
  [7852] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 3),
  [7854] = {.count = 1, .reusable = true}, SHIFT(5202),
  [7856] = {.count = 1, .reusable = true}, SHIFT(5204),
  [7858] = {.count = 1, .reusable = false}, REDUCE(sym_pair, 3),
  [7860] = {.count = 1, .reusable = true}, SHIFT(5209),
  [7862] = {.count = 1, .reusable = false}, REDUCE(sym_range, 3),
  [7864] = {.count = 1, .reusable = true}, SHIFT(5210),
  [7866] = {.count = 1, .reusable = true}, SHIFT(5213),
  [7868] = {.count = 1, .reusable = true}, SHIFT(5214),
  [7870] = {.count = 1, .reusable = true}, SHIFT(5217),
  [7872] = {.count = 1, .reusable = true}, SHIFT(5219),
  [7874] = {.count = 1, .reusable = true}, SHIFT(5221),
  [7876] = {.count = 1, .reusable = false}, SHIFT(5219),
  [7878] = {.count = 1, .reusable = true}, SHIFT(5223),
  [7880] = {.count = 1, .reusable = true}, SHIFT(5227),
  [7882] = {.count = 1, .reusable = true}, SHIFT(5226),
  [7884] = {.count = 1, .reusable = true}, SHIFT(970),
  [7886] = {.count = 1, .reusable = true}, SHIFT(5233),
  [7888] = {.count = 1, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2),
  [7890] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(980),
  [7893] = {.count = 1, .reusable = false}, REDUCE(aux_sym_call_repeat1, 2),
  [7895] = {.count = 1, .reusable = true}, SHIFT(5235),
  [7897] = {.count = 1, .reusable = true}, SHIFT(5234),
  [7899] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7901] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [7903] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [7905] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [7907] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(982),
  [7910] = {.count = 1, .reusable = false}, REDUCE(sym__arg_or_splat_arg, 1),
  [7912] = {.count = 1, .reusable = false}, REDUCE(sym_operator_assignment, 3),
  [7914] = {.count = 1, .reusable = true}, SHIFT(5244),
  [7916] = {.count = 1, .reusable = true}, SHIFT(5245),
  [7918] = {.count = 1, .reusable = false}, SHIFT(5246),
  [7920] = {.count = 1, .reusable = true}, SHIFT(5247),
  [7922] = {.count = 1, .reusable = false}, SHIFT(5248),
  [7924] = {.count = 1, .reusable = false}, SHIFT(5249),
  [7926] = {.count = 1, .reusable = true}, SHIFT(5250),
  [7928] = {.count = 1, .reusable = false}, SHIFT(5251),
  [7930] = {.count = 1, .reusable = true}, SHIFT(5251),
  [7932] = {.count = 1, .reusable = true}, SHIFT(5253),
  [7934] = {.count = 1, .reusable = true}, SHIFT(5254),
  [7936] = {.count = 1, .reusable = false}, SHIFT(5253),
  [7938] = {.count = 1, .reusable = true}, SHIFT(5249),
  [7940] = {.count = 1, .reusable = true}, SHIFT(5246),
  [7942] = {.count = 1, .reusable = true}, SHIFT(5255),
  [7944] = {.count = 1, .reusable = true}, SHIFT(5256),
  [7946] = {.count = 1, .reusable = false}, SHIFT(5256),
  [7948] = {.count = 1, .reusable = true}, SHIFT(5257),
  [7950] = {.count = 1, .reusable = true}, SHIFT(5262),
  [7952] = {.count = 1, .reusable = false}, SHIFT(5262),
  [7954] = {.count = 1, .reusable = true}, SHIFT(5266),
  [7956] = {.count = 1, .reusable = false}, SHIFT(5264),
  [7958] = {.count = 1, .reusable = true}, SHIFT(5283),
  [7960] = {.count = 1, .reusable = false}, SHIFT(5283),
  [7962] = {.count = 1, .reusable = true}, SHIFT(5287),
  [7964] = {.count = 1, .reusable = false}, SHIFT(5285),
  [7966] = {.count = 1, .reusable = true}, SHIFT(992),
  [7968] = {.count = 1, .reusable = true}, SHIFT(5298),
  [7970] = {.count = 1, .reusable = true}, REDUCE(sym_if, 4),
  [7972] = {.count = 1, .reusable = false}, REDUCE(sym_if, 4),
  [7974] = {.count = 1, .reusable = true}, SHIFT(5300),
  [7976] = {.count = 1, .reusable = true}, SHIFT(5301),
  [7978] = {.count = 1, .reusable = true}, SHIFT(5302),
  [7980] = {.count = 1, .reusable = true}, SHIFT(5303),
  [7982] = {.count = 1, .reusable = false}, SHIFT(5305),
  [7984] = {.count = 1, .reusable = false}, SHIFT(5306),
  [7986] = {.count = 1, .reusable = false}, SHIFT(5307),
  [7988] = {.count = 1, .reusable = false}, SHIFT(5308),
  [7990] = {.count = 1, .reusable = true}, SHIFT(5310),
  [7992] = {.count = 1, .reusable = false}, SHIFT(5310),
  [7994] = {.count = 1, .reusable = false}, SHIFT(5311),
  [7996] = {.count = 1, .reusable = true}, SHIFT(5311),
  [7998] = {.count = 1, .reusable = false}, SHIFT(5312),
  [8000] = {.count = 1, .reusable = true}, SHIFT(5314),
  [8002] = {.count = 1, .reusable = false}, SHIFT(5314),
  [8004] = {.count = 1, .reusable = true}, SHIFT(5321),
  [8006] = {.count = 1, .reusable = true}, SHIFT(5324),
  [8008] = {.count = 1, .reusable = true}, SHIFT(5325),
  [8010] = {.count = 1, .reusable = true}, SHIFT(2761),
  [8012] = {.count = 1, .reusable = true}, SHIFT(2762),
  [8014] = {.count = 1, .reusable = true}, SHIFT(5327),
  [8016] = {.count = 1, .reusable = true}, SHIFT(5329),
  [8018] = {.count = 1, .reusable = true}, SHIFT(5330),
  [8020] = {.count = 1, .reusable = true}, SHIFT(5331),
  [8022] = {.count = 1, .reusable = true}, SHIFT(5332),
  [8024] = {.count = 1, .reusable = true}, SHIFT(5333),
  [8026] = {.count = 1, .reusable = true}, SHIFT(5334),
  [8028] = {.count = 1, .reusable = true}, SHIFT(5335),
  [8030] = {.count = 1, .reusable = false}, SHIFT(5336),
  [8032] = {.count = 1, .reusable = true}, SHIFT(5337),
  [8034] = {.count = 1, .reusable = false}, SHIFT(5338),
  [8036] = {.count = 1, .reusable = false}, SHIFT(5339),
  [8038] = {.count = 1, .reusable = true}, SHIFT(5340),
  [8040] = {.count = 1, .reusable = false}, SHIFT(5341),
  [8042] = {.count = 1, .reusable = true}, SHIFT(5341),
  [8044] = {.count = 1, .reusable = true}, SHIFT(5342),
  [8046] = {.count = 1, .reusable = true}, SHIFT(5343),
  [8048] = {.count = 1, .reusable = true}, SHIFT(5344),
  [8050] = {.count = 1, .reusable = false}, SHIFT(5343),
  [8052] = {.count = 1, .reusable = true}, SHIFT(5339),
  [8054] = {.count = 1, .reusable = true}, SHIFT(5336),
  [8056] = {.count = 1, .reusable = true}, SHIFT(5345),
  [8058] = {.count = 1, .reusable = true}, SHIFT(5346),
  [8060] = {.count = 1, .reusable = true}, SHIFT(5347),
  [8062] = {.count = 1, .reusable = true}, SHIFT(5348),
  [8064] = {.count = 1, .reusable = true}, SHIFT(5349),
  [8066] = {.count = 1, .reusable = false}, SHIFT(5351),
  [8068] = {.count = 1, .reusable = false}, SHIFT(5352),
  [8070] = {.count = 1, .reusable = false}, SHIFT(5353),
  [8072] = {.count = 1, .reusable = false}, SHIFT(5354),
  [8074] = {.count = 1, .reusable = true}, SHIFT(5356),
  [8076] = {.count = 1, .reusable = false}, SHIFT(5356),
  [8078] = {.count = 1, .reusable = false}, SHIFT(5357),
  [8080] = {.count = 1, .reusable = true}, SHIFT(5357),
  [8082] = {.count = 1, .reusable = false}, SHIFT(5358),
  [8084] = {.count = 1, .reusable = true}, SHIFT(5360),
  [8086] = {.count = 1, .reusable = false}, SHIFT(5360),
  [8088] = {.count = 1, .reusable = true}, SHIFT(5366),
  [8090] = {.count = 1, .reusable = false}, SHIFT(5366),
  [8092] = {.count = 1, .reusable = true}, SHIFT(5367),
  [8094] = {.count = 1, .reusable = false}, SHIFT(5325),
  [8096] = {.count = 1, .reusable = true}, REDUCE(sym__then, 2),
  [8098] = {.count = 1, .reusable = false}, REDUCE(sym__then, 2),
  [8100] = {.count = 1, .reusable = true}, SHIFT(5370),
  [8102] = {.count = 1, .reusable = true}, SHIFT(5374),
  [8104] = {.count = 1, .reusable = true}, SHIFT(5375),
  [8106] = {.count = 1, .reusable = false}, SHIFT(5376),
  [8108] = {.count = 1, .reusable = false}, SHIFT(5377),
  [8110] = {.count = 1, .reusable = false}, SHIFT(5378),
  [8112] = {.count = 1, .reusable = false}, SHIFT(5379),
  [8114] = {.count = 1, .reusable = true}, SHIFT(5380),
  [8116] = {.count = 1, .reusable = false}, SHIFT(5381),
  [8118] = {.count = 1, .reusable = true}, SHIFT(5381),
  [8120] = {.count = 1, .reusable = false}, SHIFT(5383),
  [8122] = {.count = 1, .reusable = false}, SHIFT(5384),
  [8124] = {.count = 1, .reusable = true}, SHIFT(5383),
  [8126] = {.count = 1, .reusable = true}, SHIFT(5379),
  [8128] = {.count = 1, .reusable = false}, SHIFT(5385),
  [8130] = {.count = 1, .reusable = true}, SHIFT(5386),
  [8132] = {.count = 1, .reusable = false}, SHIFT(5386),
  [8134] = {.count = 1, .reusable = true}, SHIFT(5387),
  [8136] = {.count = 1, .reusable = true}, SHIFT(1035),
  [8138] = {.count = 1, .reusable = true}, SHIFT(5415),
  [8140] = {.count = 1, .reusable = true}, SHIFT(5416),
  [8142] = {.count = 1, .reusable = false}, SHIFT(5417),
  [8144] = {.count = 1, .reusable = true}, SHIFT(5418),
  [8146] = {.count = 1, .reusable = false}, SHIFT(5419),
  [8148] = {.count = 1, .reusable = false}, SHIFT(5420),
  [8150] = {.count = 1, .reusable = true}, SHIFT(5421),
  [8152] = {.count = 1, .reusable = false}, SHIFT(5422),
  [8154] = {.count = 1, .reusable = true}, SHIFT(5422),
  [8156] = {.count = 1, .reusable = true}, SHIFT(5424),
  [8158] = {.count = 1, .reusable = true}, SHIFT(5425),
  [8160] = {.count = 1, .reusable = false}, SHIFT(5424),
  [8162] = {.count = 1, .reusable = true}, SHIFT(5420),
  [8164] = {.count = 1, .reusable = true}, SHIFT(5417),
  [8166] = {.count = 1, .reusable = true}, SHIFT(5426),
  [8168] = {.count = 1, .reusable = true}, SHIFT(5427),
  [8170] = {.count = 1, .reusable = true}, SHIFT(5429),
  [8172] = {.count = 1, .reusable = false}, SHIFT(5429),
  [8174] = {.count = 1, .reusable = true}, SHIFT(5430),
  [8176] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 4),
  [8178] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 4),
  [8180] = {.count = 1, .reusable = true}, SHIFT(5432),
  [8182] = {.count = 1, .reusable = true}, SHIFT(5433),
  [8184] = {.count = 1, .reusable = true}, SHIFT(5434),
  [8186] = {.count = 1, .reusable = true}, SHIFT(5435),
  [8188] = {.count = 1, .reusable = false}, SHIFT(5437),
  [8190] = {.count = 1, .reusable = false}, SHIFT(5438),
  [8192] = {.count = 1, .reusable = false}, SHIFT(5439),
  [8194] = {.count = 1, .reusable = false}, SHIFT(5440),
  [8196] = {.count = 1, .reusable = true}, SHIFT(5442),
  [8198] = {.count = 1, .reusable = false}, SHIFT(5442),
  [8200] = {.count = 1, .reusable = false}, SHIFT(5443),
  [8202] = {.count = 1, .reusable = true}, SHIFT(5443),
  [8204] = {.count = 1, .reusable = false}, SHIFT(5444),
  [8206] = {.count = 1, .reusable = true}, SHIFT(5446),
  [8208] = {.count = 1, .reusable = false}, SHIFT(5446),
  [8210] = {.count = 1, .reusable = true}, SHIFT(5454),
  [8212] = {.count = 1, .reusable = true}, SHIFT(5455),
  [8214] = {.count = 1, .reusable = true}, SHIFT(5457),
  [8216] = {.count = 1, .reusable = true}, SHIFT(5459),
  [8218] = {.count = 1, .reusable = true}, SHIFT(5460),
  [8220] = {.count = 1, .reusable = true}, SHIFT(5461),
  [8222] = {.count = 1, .reusable = true}, SHIFT(5462),
  [8224] = {.count = 1, .reusable = true}, SHIFT(5463),
  [8226] = {.count = 1, .reusable = true}, SHIFT(5464),
  [8228] = {.count = 1, .reusable = true}, SHIFT(5465),
  [8230] = {.count = 1, .reusable = false}, SHIFT(5466),
  [8232] = {.count = 1, .reusable = true}, SHIFT(5467),
  [8234] = {.count = 1, .reusable = false}, SHIFT(5468),
  [8236] = {.count = 1, .reusable = false}, SHIFT(5469),
  [8238] = {.count = 1, .reusable = true}, SHIFT(5470),
  [8240] = {.count = 1, .reusable = false}, SHIFT(5471),
  [8242] = {.count = 1, .reusable = true}, SHIFT(5471),
  [8244] = {.count = 1, .reusable = true}, SHIFT(5472),
  [8246] = {.count = 1, .reusable = true}, SHIFT(5473),
  [8248] = {.count = 1, .reusable = true}, SHIFT(5474),
  [8250] = {.count = 1, .reusable = false}, SHIFT(5473),
  [8252] = {.count = 1, .reusable = true}, SHIFT(5469),
  [8254] = {.count = 1, .reusable = true}, SHIFT(5466),
  [8256] = {.count = 1, .reusable = true}, SHIFT(5475),
  [8258] = {.count = 1, .reusable = true}, SHIFT(5476),
  [8260] = {.count = 1, .reusable = true}, SHIFT(5477),
  [8262] = {.count = 1, .reusable = true}, SHIFT(5478),
  [8264] = {.count = 1, .reusable = true}, SHIFT(5479),
  [8266] = {.count = 1, .reusable = false}, SHIFT(5481),
  [8268] = {.count = 1, .reusable = false}, SHIFT(5482),
  [8270] = {.count = 1, .reusable = false}, SHIFT(5483),
  [8272] = {.count = 1, .reusable = false}, SHIFT(5484),
  [8274] = {.count = 1, .reusable = true}, SHIFT(5486),
  [8276] = {.count = 1, .reusable = false}, SHIFT(5486),
  [8278] = {.count = 1, .reusable = false}, SHIFT(5487),
  [8280] = {.count = 1, .reusable = true}, SHIFT(5487),
  [8282] = {.count = 1, .reusable = false}, SHIFT(5488),
  [8284] = {.count = 1, .reusable = true}, SHIFT(5490),
  [8286] = {.count = 1, .reusable = false}, SHIFT(5490),
  [8288] = {.count = 1, .reusable = true}, SHIFT(5496),
  [8290] = {.count = 1, .reusable = false}, SHIFT(5496),
  [8292] = {.count = 1, .reusable = true}, SHIFT(5497),
  [8294] = {.count = 1, .reusable = true}, SHIFT(5504),
  [8296] = {.count = 1, .reusable = true}, SHIFT(5505),
  [8298] = {.count = 1, .reusable = false}, SHIFT(5506),
  [8300] = {.count = 1, .reusable = true}, SHIFT(5507),
  [8302] = {.count = 1, .reusable = false}, SHIFT(5508),
  [8304] = {.count = 1, .reusable = false}, SHIFT(5509),
  [8306] = {.count = 1, .reusable = true}, SHIFT(5510),
  [8308] = {.count = 1, .reusable = false}, SHIFT(5511),
  [8310] = {.count = 1, .reusable = true}, SHIFT(5511),
  [8312] = {.count = 1, .reusable = true}, SHIFT(5513),
  [8314] = {.count = 1, .reusable = true}, SHIFT(5514),
  [8316] = {.count = 1, .reusable = false}, SHIFT(5513),
  [8318] = {.count = 1, .reusable = true}, SHIFT(5509),
  [8320] = {.count = 1, .reusable = true}, SHIFT(5506),
  [8322] = {.count = 1, .reusable = true}, SHIFT(5515),
  [8324] = {.count = 1, .reusable = true}, SHIFT(5516),
  [8326] = {.count = 1, .reusable = false}, SHIFT(5516),
  [8328] = {.count = 1, .reusable = true}, SHIFT(5517),
  [8330] = {.count = 1, .reusable = true}, SHIFT(5522),
  [8332] = {.count = 1, .reusable = false}, SHIFT(5522),
  [8334] = {.count = 1, .reusable = true}, SHIFT(5526),
  [8336] = {.count = 1, .reusable = false}, SHIFT(5524),
  [8338] = {.count = 1, .reusable = true}, SHIFT(5543),
  [8340] = {.count = 1, .reusable = true}, SHIFT(5544),
  [8342] = {.count = 1, .reusable = false}, SHIFT(5543),
  [8344] = {.count = 1, .reusable = true}, SHIFT(5548),
  [8346] = {.count = 1, .reusable = false}, SHIFT(5546),
  [8348] = {.count = 1, .reusable = true}, SHIFT(1061),
  [8350] = {.count = 1, .reusable = true}, SHIFT(5558),
  [8352] = {.count = 1, .reusable = true}, REDUCE(sym_while, 4),
  [8354] = {.count = 1, .reusable = false}, REDUCE(sym_while, 4),
  [8356] = {.count = 1, .reusable = true}, SHIFT(5559),
  [8358] = {.count = 1, .reusable = true}, SHIFT(5563),
  [8360] = {.count = 1, .reusable = true}, SHIFT(5564),
  [8362] = {.count = 1, .reusable = false}, SHIFT(5565),
  [8364] = {.count = 1, .reusable = false}, SHIFT(5566),
  [8366] = {.count = 1, .reusable = false}, SHIFT(5567),
  [8368] = {.count = 1, .reusable = false}, SHIFT(5568),
  [8370] = {.count = 1, .reusable = true}, SHIFT(5569),
  [8372] = {.count = 1, .reusable = false}, SHIFT(5570),
  [8374] = {.count = 1, .reusable = true}, SHIFT(5570),
  [8376] = {.count = 1, .reusable = false}, SHIFT(5572),
  [8378] = {.count = 1, .reusable = false}, SHIFT(5573),
  [8380] = {.count = 1, .reusable = true}, SHIFT(5572),
  [8382] = {.count = 1, .reusable = true}, SHIFT(5568),
  [8384] = {.count = 1, .reusable = false}, SHIFT(5574),
  [8386] = {.count = 1, .reusable = true}, SHIFT(5575),
  [8388] = {.count = 1, .reusable = false}, SHIFT(5575),
  [8390] = {.count = 1, .reusable = true}, SHIFT(5576),
  [8392] = {.count = 1, .reusable = true}, SHIFT(1097),
  [8394] = {.count = 1, .reusable = true}, SHIFT(5604),
  [8396] = {.count = 1, .reusable = true}, SHIFT(5605),
  [8398] = {.count = 1, .reusable = false}, SHIFT(5606),
  [8400] = {.count = 1, .reusable = true}, SHIFT(5607),
  [8402] = {.count = 1, .reusable = false}, SHIFT(5608),
  [8404] = {.count = 1, .reusable = false}, SHIFT(5609),
  [8406] = {.count = 1, .reusable = true}, SHIFT(5610),
  [8408] = {.count = 1, .reusable = false}, SHIFT(5611),
  [8410] = {.count = 1, .reusable = true}, SHIFT(5611),
  [8412] = {.count = 1, .reusable = true}, SHIFT(5613),
  [8414] = {.count = 1, .reusable = true}, SHIFT(5614),
  [8416] = {.count = 1, .reusable = false}, SHIFT(5613),
  [8418] = {.count = 1, .reusable = true}, SHIFT(5609),
  [8420] = {.count = 1, .reusable = true}, SHIFT(5606),
  [8422] = {.count = 1, .reusable = true}, SHIFT(5615),
  [8424] = {.count = 1, .reusable = true}, SHIFT(5616),
  [8426] = {.count = 1, .reusable = true}, SHIFT(5618),
  [8428] = {.count = 1, .reusable = false}, SHIFT(5618),
  [8430] = {.count = 1, .reusable = true}, SHIFT(5619),
  [8432] = {.count = 1, .reusable = true}, REDUCE(sym_until, 4),
  [8434] = {.count = 1, .reusable = false}, REDUCE(sym_until, 4),
  [8436] = {.count = 1, .reusable = true}, SHIFT(5620),
  [8438] = {.count = 1, .reusable = true}, SHIFT(5622),
  [8440] = {.count = 1, .reusable = true}, SHIFT(5623),
  [8442] = {.count = 1, .reusable = true}, SHIFT(5624),
  [8444] = {.count = 1, .reusable = false}, SHIFT(5626),
  [8446] = {.count = 1, .reusable = true}, SHIFT(5633),
  [8448] = {.count = 1, .reusable = true}, SHIFT(5634),
  [8450] = {.count = 1, .reusable = false}, SHIFT(5635),
  [8452] = {.count = 1, .reusable = true}, SHIFT(5636),
  [8454] = {.count = 1, .reusable = false}, SHIFT(5637),
  [8456] = {.count = 1, .reusable = false}, SHIFT(5638),
  [8458] = {.count = 1, .reusable = true}, SHIFT(5639),
  [8460] = {.count = 1, .reusable = false}, SHIFT(5640),
  [8462] = {.count = 1, .reusable = true}, SHIFT(5640),
  [8464] = {.count = 1, .reusable = true}, SHIFT(5641),
  [8466] = {.count = 1, .reusable = true}, SHIFT(5642),
  [8468] = {.count = 1, .reusable = true}, SHIFT(5643),
  [8470] = {.count = 1, .reusable = false}, SHIFT(5642),
  [8472] = {.count = 1, .reusable = true}, SHIFT(5638),
  [8474] = {.count = 1, .reusable = true}, SHIFT(5635),
  [8476] = {.count = 1, .reusable = true}, SHIFT(5644),
  [8478] = {.count = 1, .reusable = true}, SHIFT(5645),
  [8480] = {.count = 1, .reusable = true}, SHIFT(5646),
  [8482] = {.count = 1, .reusable = true}, SHIFT(5647),
  [8484] = {.count = 1, .reusable = false}, SHIFT(5649),
  [8486] = {.count = 1, .reusable = true}, SHIFT(5654),
  [8488] = {.count = 1, .reusable = false}, SHIFT(5654),
  [8490] = {.count = 1, .reusable = true}, SHIFT(5655),
  [8492] = {.count = 1, .reusable = true}, SHIFT(5660),
  [8494] = {.count = 1, .reusable = false}, SHIFT(5660),
  [8496] = {.count = 1, .reusable = true}, SHIFT(5664),
  [8498] = {.count = 1, .reusable = false}, SHIFT(5662),
  [8500] = {.count = 1, .reusable = false}, SHIFT(3035),
  [8502] = {.count = 1, .reusable = true}, SHIFT(5683),
  [8504] = {.count = 1, .reusable = false}, SHIFT(5683),
  [8506] = {.count = 1, .reusable = true}, SHIFT(5687),
  [8508] = {.count = 1, .reusable = true}, SHIFT(5688),
  [8510] = {.count = 1, .reusable = false}, SHIFT(5689),
  [8512] = {.count = 1, .reusable = false}, SHIFT(5690),
  [8514] = {.count = 1, .reusable = false}, SHIFT(5691),
  [8516] = {.count = 1, .reusable = false}, SHIFT(5692),
  [8518] = {.count = 1, .reusable = true}, SHIFT(5694),
  [8520] = {.count = 1, .reusable = false}, SHIFT(5695),
  [8522] = {.count = 1, .reusable = true}, SHIFT(5695),
  [8524] = {.count = 1, .reusable = false}, SHIFT(5697),
  [8526] = {.count = 1, .reusable = false}, SHIFT(5698),
  [8528] = {.count = 1, .reusable = true}, SHIFT(5697),
  [8530] = {.count = 1, .reusable = true}, SHIFT(5692),
  [8532] = {.count = 1, .reusable = false}, SHIFT(5699),
  [8534] = {.count = 1, .reusable = true}, SHIFT(5701),
  [8536] = {.count = 1, .reusable = true}, SHIFT(5703),
  [8538] = {.count = 1, .reusable = false}, SHIFT(5703),
  [8540] = {.count = 1, .reusable = true}, SHIFT(5704),
  [8542] = {.count = 1, .reusable = false}, SHIFT(5693),
  [8544] = {.count = 1, .reusable = true}, REDUCE(sym_in, 2),
  [8546] = {.count = 1, .reusable = false}, SHIFT(5714),
  [8548] = {.count = 1, .reusable = true}, SHIFT(5721),
  [8550] = {.count = 1, .reusable = true}, SHIFT(5722),
  [8552] = {.count = 1, .reusable = false}, SHIFT(5723),
  [8554] = {.count = 1, .reusable = true}, SHIFT(5724),
  [8556] = {.count = 1, .reusable = false}, SHIFT(5725),
  [8558] = {.count = 1, .reusable = false}, SHIFT(5726),
  [8560] = {.count = 1, .reusable = true}, SHIFT(5727),
  [8562] = {.count = 1, .reusable = false}, SHIFT(5728),
  [8564] = {.count = 1, .reusable = true}, SHIFT(5728),
  [8566] = {.count = 1, .reusable = true}, SHIFT(5730),
  [8568] = {.count = 1, .reusable = true}, SHIFT(5731),
  [8570] = {.count = 1, .reusable = false}, SHIFT(5730),
  [8572] = {.count = 1, .reusable = true}, SHIFT(5726),
  [8574] = {.count = 1, .reusable = true}, SHIFT(5723),
  [8576] = {.count = 1, .reusable = true}, SHIFT(5732),
  [8578] = {.count = 1, .reusable = true}, SHIFT(5733),
  [8580] = {.count = 1, .reusable = false}, SHIFT(5733),
  [8582] = {.count = 1, .reusable = true}, SHIFT(5734),
  [8584] = {.count = 1, .reusable = true}, SHIFT(5739),
  [8586] = {.count = 1, .reusable = false}, SHIFT(5739),
  [8588] = {.count = 1, .reusable = true}, SHIFT(5743),
  [8590] = {.count = 1, .reusable = false}, SHIFT(5741),
  [8592] = {.count = 1, .reusable = true}, SHIFT(1146),
  [8594] = {.count = 1, .reusable = true}, SHIFT(5766),
  [8596] = {.count = 1, .reusable = true}, SHIFT(5767),
  [8598] = {.count = 1, .reusable = true}, SHIFT(5773),
  [8600] = {.count = 1, .reusable = true}, SHIFT(5774),
  [8602] = {.count = 1, .reusable = false}, SHIFT(5775),
  [8604] = {.count = 1, .reusable = true}, SHIFT(5776),
  [8606] = {.count = 1, .reusable = false}, SHIFT(5777),
  [8608] = {.count = 1, .reusable = false}, SHIFT(5778),
  [8610] = {.count = 1, .reusable = true}, SHIFT(5779),
  [8612] = {.count = 1, .reusable = false}, SHIFT(5780),
  [8614] = {.count = 1, .reusable = true}, SHIFT(5780),
  [8616] = {.count = 1, .reusable = true}, SHIFT(5782),
  [8618] = {.count = 1, .reusable = true}, SHIFT(5783),
  [8620] = {.count = 1, .reusable = false}, SHIFT(5782),
  [8622] = {.count = 1, .reusable = true}, SHIFT(5778),
  [8624] = {.count = 1, .reusable = true}, SHIFT(5775),
  [8626] = {.count = 1, .reusable = true}, SHIFT(5784),
  [8628] = {.count = 1, .reusable = true}, SHIFT(5785),
  [8630] = {.count = 1, .reusable = true}, SHIFT(5787),
  [8632] = {.count = 1, .reusable = false}, SHIFT(5787),
  [8634] = {.count = 1, .reusable = true}, SHIFT(5788),
  [8636] = {.count = 1, .reusable = true}, SHIFT(5791),
  [8638] = {.count = 1, .reusable = true}, SHIFT(5792),
  [8640] = {.count = 1, .reusable = true}, SHIFT(5793),
  [8642] = {.count = 1, .reusable = false}, SHIFT(5795),
  [8644] = {.count = 1, .reusable = true}, SHIFT(5802),
  [8646] = {.count = 1, .reusable = true}, SHIFT(5803),
  [8648] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [8650] = {.count = 1, .reusable = true}, SHIFT(5805),
  [8652] = {.count = 1, .reusable = true}, SHIFT(5806),
  [8654] = {.count = 1, .reusable = false}, SHIFT(5807),
  [8656] = {.count = 1, .reusable = true}, SHIFT(5808),
  [8658] = {.count = 1, .reusable = false}, SHIFT(5809),
  [8660] = {.count = 1, .reusable = false}, SHIFT(5810),
  [8662] = {.count = 1, .reusable = true}, SHIFT(5811),
  [8664] = {.count = 1, .reusable = false}, SHIFT(5812),
  [8666] = {.count = 1, .reusable = true}, SHIFT(5812),
  [8668] = {.count = 1, .reusable = true}, SHIFT(5813),
  [8670] = {.count = 1, .reusable = true}, SHIFT(5814),
  [8672] = {.count = 1, .reusable = true}, SHIFT(5815),
  [8674] = {.count = 1, .reusable = false}, SHIFT(5814),
  [8676] = {.count = 1, .reusable = true}, SHIFT(5810),
  [8678] = {.count = 1, .reusable = true}, SHIFT(5807),
  [8680] = {.count = 1, .reusable = true}, SHIFT(5816),
  [8682] = {.count = 1, .reusable = true}, SHIFT(5817),
  [8684] = {.count = 1, .reusable = true}, SHIFT(5818),
  [8686] = {.count = 1, .reusable = true}, SHIFT(5819),
  [8688] = {.count = 1, .reusable = false}, SHIFT(5821),
  [8690] = {.count = 1, .reusable = true}, SHIFT(5826),
  [8692] = {.count = 1, .reusable = false}, SHIFT(5826),
  [8694] = {.count = 1, .reusable = true}, SHIFT(5827),
  [8696] = {.count = 1, .reusable = true}, REDUCE(sym_case, 4),
  [8698] = {.count = 1, .reusable = false}, REDUCE(sym_case, 4),
  [8700] = {.count = 2, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2), SHIFT_REPEAT(3142),
  [8703] = {.count = 1, .reusable = true}, REDUCE(aux_sym_case_repeat1, 2),
  [8705] = {.count = 1, .reusable = false}, REDUCE(sym_heredoc_body, 3),
  [8707] = {.count = 1, .reusable = true}, SHIFT(5834),
  [8709] = {.count = 1, .reusable = true}, SHIFT(5835),
  [8711] = {.count = 1, .reusable = false}, SHIFT(5836),
  [8713] = {.count = 1, .reusable = true}, SHIFT(5837),
  [8715] = {.count = 1, .reusable = false}, SHIFT(5838),
  [8717] = {.count = 1, .reusable = false}, SHIFT(5839),
  [8719] = {.count = 1, .reusable = true}, SHIFT(5840),
  [8721] = {.count = 1, .reusable = false}, SHIFT(5841),
  [8723] = {.count = 1, .reusable = true}, SHIFT(5841),
  [8725] = {.count = 1, .reusable = true}, SHIFT(5843),
  [8727] = {.count = 1, .reusable = true}, SHIFT(5844),
  [8729] = {.count = 1, .reusable = false}, SHIFT(5843),
  [8731] = {.count = 1, .reusable = true}, SHIFT(5839),
  [8733] = {.count = 1, .reusable = true}, SHIFT(5836),
  [8735] = {.count = 1, .reusable = true}, SHIFT(5845),
  [8737] = {.count = 1, .reusable = true}, SHIFT(5846),
  [8739] = {.count = 1, .reusable = false}, SHIFT(5846),
  [8741] = {.count = 1, .reusable = true}, SHIFT(5847),
  [8743] = {.count = 1, .reusable = true}, SHIFT(5852),
  [8745] = {.count = 1, .reusable = false}, SHIFT(5852),
  [8747] = {.count = 1, .reusable = true}, SHIFT(5856),
  [8749] = {.count = 1, .reusable = false}, SHIFT(5854),
  [8751] = {.count = 1, .reusable = true}, SHIFT(5873),
  [8753] = {.count = 1, .reusable = false}, SHIFT(5873),
  [8755] = {.count = 1, .reusable = true}, SHIFT(5877),
  [8757] = {.count = 1, .reusable = false}, SHIFT(5875),
  [8759] = {.count = 1, .reusable = true}, SHIFT(1190),
  [8761] = {.count = 1, .reusable = false}, SHIFT(3207),
  [8763] = {.count = 1, .reusable = true}, SHIFT(5890),
  [8765] = {.count = 1, .reusable = false}, SHIFT(5890),
  [8767] = {.count = 1, .reusable = true}, SHIFT(5894),
  [8769] = {.count = 1, .reusable = true}, SHIFT(5895),
  [8771] = {.count = 1, .reusable = false}, SHIFT(5896),
  [8773] = {.count = 1, .reusable = true}, SHIFT(5897),
  [8775] = {.count = 1, .reusable = false}, SHIFT(5898),
  [8777] = {.count = 1, .reusable = false}, SHIFT(5899),
  [8779] = {.count = 1, .reusable = true}, SHIFT(5901),
  [8781] = {.count = 1, .reusable = false}, SHIFT(5902),
  [8783] = {.count = 1, .reusable = true}, SHIFT(5902),
  [8785] = {.count = 1, .reusable = true}, SHIFT(5904),
  [8787] = {.count = 1, .reusable = true}, SHIFT(5905),
  [8789] = {.count = 1, .reusable = false}, SHIFT(5904),
  [8791] = {.count = 1, .reusable = true}, SHIFT(5899),
  [8793] = {.count = 1, .reusable = true}, SHIFT(5896),
  [8795] = {.count = 1, .reusable = true}, SHIFT(5906),
  [8797] = {.count = 1, .reusable = true}, SHIFT(5908),
  [8799] = {.count = 1, .reusable = true}, SHIFT(5910),
  [8801] = {.count = 1, .reusable = false}, SHIFT(5910),
  [8803] = {.count = 1, .reusable = true}, SHIFT(5911),
  [8805] = {.count = 1, .reusable = false}, SHIFT(5900),
  [8807] = {.count = 1, .reusable = true}, SHIFT(5912),
  [8809] = {.count = 1, .reusable = true}, SHIFT(5913),
  [8811] = {.count = 1, .reusable = true}, SHIFT(5914),
  [8813] = {.count = 1, .reusable = true}, SHIFT(5915),
  [8815] = {.count = 1, .reusable = true}, SHIFT(5916),
  [8817] = {.count = 1, .reusable = true}, SHIFT(5917),
  [8819] = {.count = 1, .reusable = true}, SHIFT(5918),
  [8821] = {.count = 1, .reusable = true}, SHIFT(5919),
  [8823] = {.count = 1, .reusable = false}, SHIFT(5920),
  [8825] = {.count = 1, .reusable = false}, SHIFT(5921),
  [8827] = {.count = 1, .reusable = false}, SHIFT(5922),
  [8829] = {.count = 1, .reusable = false}, SHIFT(5923),
  [8831] = {.count = 1, .reusable = true}, SHIFT(5924),
  [8833] = {.count = 1, .reusable = false}, SHIFT(5925),
  [8835] = {.count = 1, .reusable = true}, SHIFT(5926),
  [8837] = {.count = 1, .reusable = false}, SHIFT(5926),
  [8839] = {.count = 1, .reusable = true}, SHIFT(5927),
  [8841] = {.count = 1, .reusable = false}, SHIFT(5928),
  [8843] = {.count = 1, .reusable = true}, REDUCE(sym_exception_variable, 2),
  [8845] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 3),
  [8847] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 3),
  [8849] = {.count = 1, .reusable = true}, SHIFT(5939),
  [8851] = {.count = 1, .reusable = false}, SHIFT(3250),
  [8853] = {.count = 1, .reusable = true}, SHIFT(5956),
  [8855] = {.count = 1, .reusable = false}, SHIFT(5956),
  [8857] = {.count = 1, .reusable = true}, SHIFT(5960),
  [8859] = {.count = 1, .reusable = true}, SHIFT(5961),
  [8861] = {.count = 1, .reusable = false}, SHIFT(5962),
  [8863] = {.count = 1, .reusable = false}, SHIFT(5963),
  [8865] = {.count = 1, .reusable = false}, SHIFT(5964),
  [8867] = {.count = 1, .reusable = false}, SHIFT(5965),
  [8869] = {.count = 1, .reusable = true}, SHIFT(5967),
  [8871] = {.count = 1, .reusable = false}, SHIFT(5968),
  [8873] = {.count = 1, .reusable = true}, SHIFT(5968),
  [8875] = {.count = 1, .reusable = false}, SHIFT(5970),
  [8877] = {.count = 1, .reusable = false}, SHIFT(5971),
  [8879] = {.count = 1, .reusable = true}, SHIFT(5970),
  [8881] = {.count = 1, .reusable = true}, SHIFT(5965),
  [8883] = {.count = 1, .reusable = false}, SHIFT(5972),
  [8885] = {.count = 1, .reusable = true}, SHIFT(5974),
  [8887] = {.count = 1, .reusable = true}, SHIFT(5976),
  [8889] = {.count = 1, .reusable = false}, SHIFT(5976),
  [8891] = {.count = 1, .reusable = true}, SHIFT(5977),
  [8893] = {.count = 1, .reusable = false}, SHIFT(5966),
  [8895] = {.count = 1, .reusable = true}, REDUCE(sym_exceptions, 2),
  [8897] = {.count = 1, .reusable = true}, SHIFT(5981),
  [8899] = {.count = 1, .reusable = true}, SHIFT(5986),
  [8901] = {.count = 1, .reusable = false}, SHIFT(5987),
  [8903] = {.count = 1, .reusable = false}, SHIFT(5988),
  [8905] = {.count = 1, .reusable = false}, SHIFT(5989),
  [8907] = {.count = 1, .reusable = false}, SHIFT(5990),
  [8909] = {.count = 1, .reusable = false}, SHIFT(5991),
  [8911] = {.count = 1, .reusable = true}, SHIFT(5992),
  [8913] = {.count = 1, .reusable = false}, SHIFT(5992),
  [8915] = {.count = 1, .reusable = true}, SHIFT(5993),
  [8917] = {.count = 1, .reusable = false}, SHIFT(3276),
  [8919] = {.count = 1, .reusable = true}, SHIFT(6001),
  [8921] = {.count = 1, .reusable = true}, SHIFT(6003),
  [8923] = {.count = 1, .reusable = true}, SHIFT(6004),
  [8925] = {.count = 1, .reusable = true}, SHIFT(6005),
  [8927] = {.count = 1, .reusable = false}, SHIFT(6007),
  [8929] = {.count = 1, .reusable = false}, SHIFT(6001),
  [8931] = {.count = 1, .reusable = true}, SHIFT(6014),
  [8933] = {.count = 1, .reusable = true}, SHIFT(6015),
  [8935] = {.count = 1, .reusable = false}, SHIFT(6016),
  [8937] = {.count = 1, .reusable = true}, SHIFT(6017),
  [8939] = {.count = 1, .reusable = false}, SHIFT(6018),
  [8941] = {.count = 1, .reusable = false}, SHIFT(6019),
  [8943] = {.count = 1, .reusable = true}, SHIFT(6020),
  [8945] = {.count = 1, .reusable = true}, SHIFT(6021),
  [8947] = {.count = 1, .reusable = false}, SHIFT(6022),
  [8949] = {.count = 1, .reusable = true}, SHIFT(6022),
  [8951] = {.count = 1, .reusable = true}, SHIFT(6024),
  [8953] = {.count = 1, .reusable = true}, SHIFT(6025),
  [8955] = {.count = 1, .reusable = false}, SHIFT(6024),
  [8957] = {.count = 1, .reusable = true}, SHIFT(6019),
  [8959] = {.count = 1, .reusable = true}, SHIFT(6016),
  [8961] = {.count = 1, .reusable = true}, SHIFT(6026),
  [8963] = {.count = 1, .reusable = true}, SHIFT(6027),
  [8965] = {.count = 1, .reusable = true}, SHIFT(6028),
  [8967] = {.count = 1, .reusable = true}, SHIFT(6029),
  [8969] = {.count = 1, .reusable = false}, SHIFT(6031),
  [8971] = {.count = 1, .reusable = true}, SHIFT(6037),
  [8973] = {.count = 1, .reusable = true}, SHIFT(6039),
  [8975] = {.count = 1, .reusable = false}, SHIFT(6039),
  [8977] = {.count = 1, .reusable = true}, SHIFT(6040),
  [8979] = {.count = 1, .reusable = false}, SHIFT(6020),
  [8981] = {.count = 1, .reusable = true}, SHIFT(6043),
  [8983] = {.count = 1, .reusable = true}, SHIFT(6062),
  [8985] = {.count = 1, .reusable = false}, SHIFT(6063),
  [8987] = {.count = 1, .reusable = false}, SHIFT(6064),
  [8989] = {.count = 1, .reusable = false}, SHIFT(6065),
  [8991] = {.count = 1, .reusable = false}, SHIFT(6066),
  [8993] = {.count = 1, .reusable = false}, SHIFT(6067),
  [8995] = {.count = 1, .reusable = true}, SHIFT(6068),
  [8997] = {.count = 1, .reusable = false}, SHIFT(6068),
  [8999] = {.count = 1, .reusable = true}, SHIFT(6069),
  [9001] = {.count = 1, .reusable = false}, SHIFT(6071),
  [9003] = {.count = 1, .reusable = true}, SHIFT(6071),
  [9005] = {.count = 1, .reusable = false}, SHIFT(3318),
  [9007] = {.count = 1, .reusable = true}, SHIFT(6078),
  [9009] = {.count = 1, .reusable = false}, SHIFT(6078),
  [9011] = {.count = 1, .reusable = true}, SHIFT(6082),
  [9013] = {.count = 1, .reusable = true}, SHIFT(6083),
  [9015] = {.count = 1, .reusable = false}, SHIFT(6084),
  [9017] = {.count = 1, .reusable = false}, SHIFT(6085),
  [9019] = {.count = 1, .reusable = false}, SHIFT(6086),
  [9021] = {.count = 1, .reusable = false}, SHIFT(6087),
  [9023] = {.count = 1, .reusable = true}, SHIFT(6088),
  [9025] = {.count = 1, .reusable = true}, SHIFT(6089),
  [9027] = {.count = 1, .reusable = false}, SHIFT(6090),
  [9029] = {.count = 1, .reusable = true}, SHIFT(6090),
  [9031] = {.count = 1, .reusable = false}, SHIFT(6092),
  [9033] = {.count = 1, .reusable = false}, SHIFT(6093),
  [9035] = {.count = 1, .reusable = true}, SHIFT(6092),
  [9037] = {.count = 1, .reusable = true}, SHIFT(6087),
  [9039] = {.count = 1, .reusable = false}, SHIFT(6094),
  [9041] = {.count = 1, .reusable = true}, SHIFT(6096),
  [9043] = {.count = 1, .reusable = true}, SHIFT(6098),
  [9045] = {.count = 1, .reusable = false}, SHIFT(6098),
  [9047] = {.count = 1, .reusable = true}, SHIFT(6099),
  [9049] = {.count = 1, .reusable = false}, SHIFT(6088),
  [9051] = {.count = 1, .reusable = true}, SHIFT(6101),
  [9053] = {.count = 1, .reusable = true}, SHIFT(6102),
  [9055] = {.count = 1, .reusable = false}, SHIFT(6103),
  [9057] = {.count = 1, .reusable = true}, SHIFT(6104),
  [9059] = {.count = 1, .reusable = false}, SHIFT(6104),
  [9061] = {.count = 1, .reusable = true}, SHIFT(6105),
  [9063] = {.count = 1, .reusable = true}, REDUCE(sym_else, 3),
  [9065] = {.count = 1, .reusable = true}, SHIFT(6112),
  [9067] = {.count = 1, .reusable = false}, SHIFT(6113),
  [9069] = {.count = 1, .reusable = false}, SHIFT(6114),
  [9071] = {.count = 1, .reusable = false}, SHIFT(6115),
  [9073] = {.count = 1, .reusable = false}, SHIFT(6116),
  [9075] = {.count = 1, .reusable = false}, SHIFT(6117),
  [9077] = {.count = 1, .reusable = true}, SHIFT(6118),
  [9079] = {.count = 1, .reusable = false}, SHIFT(6118),
  [9081] = {.count = 1, .reusable = true}, SHIFT(6119),
  [9083] = {.count = 1, .reusable = false}, SHIFT(3343),
  [9085] = {.count = 1, .reusable = true}, SHIFT(6127),
  [9087] = {.count = 1, .reusable = true}, SHIFT(6129),
  [9089] = {.count = 1, .reusable = true}, SHIFT(6130),
  [9091] = {.count = 1, .reusable = true}, SHIFT(6131),
  [9093] = {.count = 1, .reusable = false}, SHIFT(6133),
  [9095] = {.count = 1, .reusable = false}, SHIFT(6127),
  [9097] = {.count = 1, .reusable = true}, SHIFT(6140),
  [9099] = {.count = 1, .reusable = true}, SHIFT(6141),
  [9101] = {.count = 1, .reusable = false}, SHIFT(6142),
  [9103] = {.count = 1, .reusable = true}, SHIFT(6143),
  [9105] = {.count = 1, .reusable = false}, SHIFT(6144),
  [9107] = {.count = 1, .reusable = false}, SHIFT(6145),
  [9109] = {.count = 1, .reusable = true}, SHIFT(6146),
  [9111] = {.count = 1, .reusable = true}, SHIFT(6147),
  [9113] = {.count = 1, .reusable = false}, SHIFT(6148),
  [9115] = {.count = 1, .reusable = true}, SHIFT(6148),
  [9117] = {.count = 1, .reusable = true}, SHIFT(6150),
  [9119] = {.count = 1, .reusable = true}, SHIFT(6151),
  [9121] = {.count = 1, .reusable = false}, SHIFT(6150),
  [9123] = {.count = 1, .reusable = true}, SHIFT(6145),
  [9125] = {.count = 1, .reusable = true}, SHIFT(6142),
  [9127] = {.count = 1, .reusable = true}, SHIFT(6152),
  [9129] = {.count = 1, .reusable = true}, SHIFT(6153),
  [9131] = {.count = 1, .reusable = true}, SHIFT(6154),
  [9133] = {.count = 1, .reusable = true}, SHIFT(6155),
  [9135] = {.count = 1, .reusable = false}, SHIFT(6157),
  [9137] = {.count = 1, .reusable = true}, SHIFT(6163),
  [9139] = {.count = 1, .reusable = true}, SHIFT(6165),
  [9141] = {.count = 1, .reusable = false}, SHIFT(6165),
  [9143] = {.count = 1, .reusable = true}, SHIFT(6166),
  [9145] = {.count = 1, .reusable = false}, SHIFT(6146),
  [9147] = {.count = 1, .reusable = true}, SHIFT(6169),
  [9149] = {.count = 1, .reusable = true}, SHIFT(6188),
  [9151] = {.count = 1, .reusable = false}, SHIFT(6189),
  [9153] = {.count = 1, .reusable = false}, SHIFT(6190),
  [9155] = {.count = 1, .reusable = false}, SHIFT(6191),
  [9157] = {.count = 1, .reusable = false}, SHIFT(6192),
  [9159] = {.count = 1, .reusable = false}, SHIFT(6193),
  [9161] = {.count = 1, .reusable = true}, SHIFT(6194),
  [9163] = {.count = 1, .reusable = false}, SHIFT(6194),
  [9165] = {.count = 1, .reusable = true}, SHIFT(6195),
  [9167] = {.count = 1, .reusable = false}, SHIFT(6197),
  [9169] = {.count = 1, .reusable = true}, SHIFT(6197),
  [9171] = {.count = 1, .reusable = false}, SHIFT(3385),
  [9173] = {.count = 1, .reusable = true}, SHIFT(6204),
  [9175] = {.count = 1, .reusable = false}, SHIFT(6204),
  [9177] = {.count = 1, .reusable = true}, SHIFT(6208),
  [9179] = {.count = 1, .reusable = true}, SHIFT(6209),
  [9181] = {.count = 1, .reusable = false}, SHIFT(6210),
  [9183] = {.count = 1, .reusable = false}, SHIFT(6211),
  [9185] = {.count = 1, .reusable = false}, SHIFT(6212),
  [9187] = {.count = 1, .reusable = false}, SHIFT(6213),
  [9189] = {.count = 1, .reusable = true}, SHIFT(6214),
  [9191] = {.count = 1, .reusable = true}, SHIFT(6215),
  [9193] = {.count = 1, .reusable = false}, SHIFT(6216),
  [9195] = {.count = 1, .reusable = true}, SHIFT(6216),
  [9197] = {.count = 1, .reusable = false}, SHIFT(6218),
  [9199] = {.count = 1, .reusable = false}, SHIFT(6219),
  [9201] = {.count = 1, .reusable = true}, SHIFT(6218),
  [9203] = {.count = 1, .reusable = true}, SHIFT(6213),
  [9205] = {.count = 1, .reusable = false}, SHIFT(6220),
  [9207] = {.count = 1, .reusable = true}, SHIFT(6222),
  [9209] = {.count = 1, .reusable = true}, SHIFT(6224),
  [9211] = {.count = 1, .reusable = false}, SHIFT(6224),
  [9213] = {.count = 1, .reusable = true}, SHIFT(6225),
  [9215] = {.count = 1, .reusable = false}, SHIFT(6214),
  [9217] = {.count = 1, .reusable = true}, SHIFT(6227),
  [9219] = {.count = 1, .reusable = true}, SHIFT(6228),
  [9221] = {.count = 1, .reusable = false}, SHIFT(6229),
  [9223] = {.count = 1, .reusable = true}, SHIFT(6230),
  [9225] = {.count = 1, .reusable = false}, SHIFT(6230),
  [9227] = {.count = 1, .reusable = true}, SHIFT(6231),
  [9229] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 3),
  [9231] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 3),
  [9233] = {.count = 1, .reusable = true}, SHIFT(6239),
  [9235] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(6241),
  [9238] = {.count = 1, .reusable = true}, SHIFT(6242),
  [9240] = {.count = 1, .reusable = true}, SHIFT(6246),
  [9242] = {.count = 1, .reusable = true}, SHIFT(6247),
  [9244] = {.count = 1, .reusable = false}, SHIFT(6248),
  [9246] = {.count = 1, .reusable = false}, SHIFT(6249),
  [9248] = {.count = 1, .reusable = false}, SHIFT(6250),
  [9250] = {.count = 1, .reusable = false}, SHIFT(6251),
  [9252] = {.count = 1, .reusable = true}, SHIFT(6252),
  [9254] = {.count = 1, .reusable = false}, SHIFT(6253),
  [9256] = {.count = 1, .reusable = true}, SHIFT(6253),
  [9258] = {.count = 1, .reusable = false}, SHIFT(6255),
  [9260] = {.count = 1, .reusable = false}, SHIFT(6256),
  [9262] = {.count = 1, .reusable = true}, SHIFT(6255),
  [9264] = {.count = 1, .reusable = true}, SHIFT(6251),
  [9266] = {.count = 1, .reusable = false}, SHIFT(6257),
  [9268] = {.count = 1, .reusable = true}, SHIFT(6258),
  [9270] = {.count = 1, .reusable = false}, SHIFT(6258),
  [9272] = {.count = 1, .reusable = true}, SHIFT(6259),
  [9274] = {.count = 1, .reusable = true}, SHIFT(1291),
  [9276] = {.count = 1, .reusable = true}, SHIFT(6287),
  [9278] = {.count = 1, .reusable = true}, SHIFT(6288),
  [9280] = {.count = 1, .reusable = false}, SHIFT(6289),
  [9282] = {.count = 1, .reusable = true}, SHIFT(6290),
  [9284] = {.count = 1, .reusable = false}, SHIFT(6291),
  [9286] = {.count = 1, .reusable = false}, SHIFT(6292),
  [9288] = {.count = 1, .reusable = true}, SHIFT(6293),
  [9290] = {.count = 1, .reusable = false}, SHIFT(6294),
  [9292] = {.count = 1, .reusable = true}, SHIFT(6294),
  [9294] = {.count = 1, .reusable = true}, SHIFT(6296),
  [9296] = {.count = 1, .reusable = true}, SHIFT(6297),
  [9298] = {.count = 1, .reusable = false}, SHIFT(6296),
  [9300] = {.count = 1, .reusable = true}, SHIFT(6292),
  [9302] = {.count = 1, .reusable = true}, SHIFT(6289),
  [9304] = {.count = 1, .reusable = true}, SHIFT(6298),
  [9306] = {.count = 1, .reusable = true}, SHIFT(6299),
  [9308] = {.count = 1, .reusable = true}, SHIFT(6301),
  [9310] = {.count = 1, .reusable = false}, SHIFT(6301),
  [9312] = {.count = 1, .reusable = true}, SHIFT(6302),
  [9314] = {.count = 1, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2),
  [9316] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(1311),
  [9319] = {.count = 1, .reusable = true}, SHIFT(6303),
  [9321] = {.count = 1, .reusable = true}, SHIFT(6304),
  [9323] = {.count = 1, .reusable = true}, SHIFT(6305),
  [9325] = {.count = 1, .reusable = true}, SHIFT(6307),
  [9327] = {.count = 1, .reusable = true}, SHIFT(6308),
  [9329] = {.count = 1, .reusable = true}, SHIFT(6309),
  [9331] = {.count = 1, .reusable = true}, SHIFT(6310),
  [9333] = {.count = 1, .reusable = true}, SHIFT(6311),
  [9335] = {.count = 1, .reusable = true}, SHIFT(6313),
  [9337] = {.count = 1, .reusable = true}, SHIFT(6314),
  [9339] = {.count = 1, .reusable = true}, SHIFT(6315),
  [9341] = {.count = 1, .reusable = false}, SHIFT(6316),
  [9343] = {.count = 1, .reusable = true}, SHIFT(6317),
  [9345] = {.count = 1, .reusable = false}, SHIFT(6317),
  [9347] = {.count = 1, .reusable = true}, SHIFT(6318),
  [9349] = {.count = 1, .reusable = true}, SHIFT(6323),
  [9351] = {.count = 1, .reusable = false}, SHIFT(6323),
  [9353] = {.count = 1, .reusable = true}, SHIFT(6325),
  [9355] = {.count = 1, .reusable = true}, SHIFT(6327),
  [9357] = {.count = 1, .reusable = false}, SHIFT(6325),
  [9359] = {.count = 1, .reusable = true}, SHIFT(6341),
  [9361] = {.count = 1, .reusable = false}, SHIFT(6342),
  [9363] = {.count = 1, .reusable = false}, SHIFT(6343),
  [9365] = {.count = 1, .reusable = false}, SHIFT(6344),
  [9367] = {.count = 1, .reusable = false}, SHIFT(6345),
  [9369] = {.count = 1, .reusable = false}, SHIFT(6346),
  [9371] = {.count = 1, .reusable = true}, SHIFT(6347),
  [9373] = {.count = 1, .reusable = false}, SHIFT(6347),
  [9375] = {.count = 1, .reusable = true}, SHIFT(6348),
  [9377] = {.count = 1, .reusable = false}, SHIFT(6350),
  [9379] = {.count = 1, .reusable = true}, SHIFT(6350),
  [9381] = {.count = 1, .reusable = true}, SHIFT(6355),
  [9383] = {.count = 1, .reusable = false}, SHIFT(6355),
  [9385] = {.count = 1, .reusable = true}, SHIFT(6357),
  [9387] = {.count = 1, .reusable = true}, SHIFT(6359),
  [9389] = {.count = 1, .reusable = false}, SHIFT(6357),
  [9391] = {.count = 1, .reusable = true}, SHIFT(6361),
  [9393] = {.count = 1, .reusable = true}, SHIFT(6366),
  [9395] = {.count = 1, .reusable = true}, SHIFT(6367),
  [9397] = {.count = 1, .reusable = true}, SHIFT(1354),
  [9399] = {.count = 1, .reusable = false}, SHIFT(6369),
  [9401] = {.count = 1, .reusable = true}, SHIFT(6370),
  [9403] = {.count = 1, .reusable = true}, SHIFT(6371),
  [9405] = {.count = 1, .reusable = false}, SHIFT(6372),
  [9407] = {.count = 1, .reusable = false}, SHIFT(6373),
  [9409] = {.count = 1, .reusable = true}, SHIFT(1368),
  [9411] = {.count = 1, .reusable = true}, SHIFT(6398),
  [9413] = {.count = 1, .reusable = false}, SHIFT(6395),
  [9415] = {.count = 1, .reusable = false}, SHIFT(6399),
  [9417] = {.count = 1, .reusable = false}, SHIFT(6402),
  [9419] = {.count = 1, .reusable = false}, SHIFT(6404),
  [9421] = {.count = 1, .reusable = true}, SHIFT(6406),
  [9423] = {.count = 1, .reusable = true}, SHIFT(6408),
  [9425] = {.count = 1, .reusable = true}, SHIFT(6409),
  [9427] = {.count = 1, .reusable = true}, SHIFT(6410),
  [9429] = {.count = 1, .reusable = true}, SHIFT(6413),
  [9431] = {.count = 1, .reusable = true}, SHIFT(6414),
  [9433] = {.count = 1, .reusable = true}, SHIFT(6416),
  [9435] = {.count = 1, .reusable = true}, SHIFT(6418),
  [9437] = {.count = 1, .reusable = false}, SHIFT(6416),
  [9439] = {.count = 1, .reusable = true}, SHIFT(6420),
  [9441] = {.count = 1, .reusable = true}, SHIFT(6421),
  [9443] = {.count = 1, .reusable = true}, SHIFT(6424),
  [9445] = {.count = 1, .reusable = true}, SHIFT(6425),
  [9447] = {.count = 1, .reusable = true}, SHIFT(6428),
  [9449] = {.count = 1, .reusable = true}, SHIFT(6430),
  [9451] = {.count = 1, .reusable = true}, SHIFT(6432),
  [9453] = {.count = 1, .reusable = false}, SHIFT(6430),
  [9455] = {.count = 1, .reusable = true}, SHIFT(1428),
  [9457] = {.count = 1, .reusable = true}, REDUCE(sym_array, 4),
  [9459] = {.count = 1, .reusable = false}, REDUCE(sym_array, 4),
  [9461] = {.count = 1, .reusable = true}, SHIFT(6456),
  [9463] = {.count = 1, .reusable = true}, SHIFT(6455),
  [9465] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 3),
  [9467] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(320),
  [9470] = {.count = 1, .reusable = true}, SHIFT(6461),
  [9472] = {.count = 1, .reusable = true}, SHIFT(6462),
  [9474] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 2),
  [9476] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 2),
  [9478] = {.count = 1, .reusable = true}, SHIFT(6463),
  [9480] = {.count = 1, .reusable = true}, SHIFT(6464),
  [9482] = {.count = 1, .reusable = true}, SHIFT(6465),
  [9484] = {.count = 1, .reusable = true}, SHIFT(6466),
  [9486] = {.count = 1, .reusable = true}, REDUCE(sym_block, 3),
  [9488] = {.count = 1, .reusable = false}, REDUCE(sym_block, 3),
  [9490] = {.count = 1, .reusable = true}, SHIFT(6468),
  [9492] = {.count = 1, .reusable = true}, SHIFT(6469),
  [9494] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 3),
  [9496] = {.count = 1, .reusable = true}, SHIFT(6474),
  [9498] = {.count = 1, .reusable = true}, SHIFT(6476),
  [9500] = {.count = 1, .reusable = true}, SHIFT(6477),
  [9502] = {.count = 1, .reusable = true}, SHIFT(6478),
  [9504] = {.count = 1, .reusable = true}, SHIFT(6479),
  [9506] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 3),
  [9508] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 3),
  [9510] = {.count = 1, .reusable = true}, SHIFT(6481),
  [9512] = {.count = 1, .reusable = false}, SHIFT(6481),
  [9514] = {.count = 1, .reusable = true}, SHIFT(6483),
  [9516] = {.count = 1, .reusable = true}, SHIFT(6487),
  [9518] = {.count = 1, .reusable = true}, SHIFT(6488),
  [9520] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_parameter, 3),
  [9522] = {.count = 1, .reusable = false}, SHIFT(6489),
  [9524] = {.count = 1, .reusable = true}, SHIFT(6490),
  [9526] = {.count = 1, .reusable = false}, SHIFT(6491),
  [9528] = {.count = 1, .reusable = false}, SHIFT(6492),
  [9530] = {.count = 1, .reusable = true}, SHIFT(6493),
  [9532] = {.count = 1, .reusable = false}, SHIFT(6494),
  [9534] = {.count = 1, .reusable = true}, SHIFT(6494),
  [9536] = {.count = 1, .reusable = true}, SHIFT(6495),
  [9538] = {.count = 1, .reusable = true}, SHIFT(6496),
  [9540] = {.count = 1, .reusable = true}, SHIFT(6497),
  [9542] = {.count = 1, .reusable = false}, SHIFT(6496),
  [9544] = {.count = 1, .reusable = true}, SHIFT(6492),
  [9546] = {.count = 1, .reusable = true}, SHIFT(6489),
  [9548] = {.count = 1, .reusable = true}, SHIFT(6498),
  [9550] = {.count = 1, .reusable = true}, SHIFT(6499),
  [9552] = {.count = 1, .reusable = true}, SHIFT(6501),
  [9554] = {.count = 1, .reusable = false}, SHIFT(6501),
  [9556] = {.count = 1, .reusable = true}, SHIFT(6502),
  [9558] = {.count = 1, .reusable = true}, REDUCE(sym_optional_parameter, 3),
  [9560] = {.count = 1, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2),
  [9562] = {.count = 2, .reusable = true}, REDUCE(aux_sym_lambda_parameters_repeat1, 2), SHIFT_REPEAT(1472),
  [9565] = {.count = 1, .reusable = true}, REDUCE(sym_program, 4),
  [9567] = {.count = 1, .reusable = true}, SHIFT(6504),
  [9569] = {.count = 1, .reusable = true}, SHIFT(6505),
  [9571] = {.count = 1, .reusable = false}, SHIFT(6506),
  [9573] = {.count = 1, .reusable = false}, SHIFT(6507),
  [9575] = {.count = 1, .reusable = false}, SHIFT(6508),
  [9577] = {.count = 1, .reusable = false}, SHIFT(6509),
  [9579] = {.count = 1, .reusable = false}, SHIFT(6510),
  [9581] = {.count = 1, .reusable = true}, SHIFT(6511),
  [9583] = {.count = 1, .reusable = false}, SHIFT(6511),
  [9585] = {.count = 1, .reusable = true}, SHIFT(6512),
  [9587] = {.count = 1, .reusable = false}, SHIFT(6514),
  [9589] = {.count = 1, .reusable = true}, SHIFT(6514),
  [9591] = {.count = 1, .reusable = true}, SHIFT(6519),
  [9593] = {.count = 1, .reusable = false}, SHIFT(3705),
  [9595] = {.count = 1, .reusable = true}, SHIFT(6522),
  [9597] = {.count = 1, .reusable = true}, SHIFT(6524),
  [9599] = {.count = 1, .reusable = true}, SHIFT(6525),
  [9601] = {.count = 1, .reusable = true}, SHIFT(6526),
  [9603] = {.count = 1, .reusable = false}, SHIFT(6528),
  [9605] = {.count = 1, .reusable = false}, SHIFT(6522),
  [9607] = {.count = 1, .reusable = true}, SHIFT(6535),
  [9609] = {.count = 1, .reusable = true}, SHIFT(6536),
  [9611] = {.count = 1, .reusable = false}, SHIFT(6537),
  [9613] = {.count = 1, .reusable = true}, SHIFT(6538),
  [9615] = {.count = 1, .reusable = false}, SHIFT(6539),
  [9617] = {.count = 1, .reusable = false}, SHIFT(6540),
  [9619] = {.count = 1, .reusable = true}, SHIFT(6541),
  [9621] = {.count = 1, .reusable = true}, SHIFT(6542),
  [9623] = {.count = 1, .reusable = false}, SHIFT(6543),
  [9625] = {.count = 1, .reusable = true}, SHIFT(6543),
  [9627] = {.count = 1, .reusable = true}, SHIFT(6545),
  [9629] = {.count = 1, .reusable = true}, SHIFT(6546),
  [9631] = {.count = 1, .reusable = false}, SHIFT(6545),
  [9633] = {.count = 1, .reusable = true}, SHIFT(6540),
  [9635] = {.count = 1, .reusable = true}, SHIFT(6537),
  [9637] = {.count = 1, .reusable = true}, SHIFT(6547),
  [9639] = {.count = 1, .reusable = true}, SHIFT(6548),
  [9641] = {.count = 1, .reusable = true}, SHIFT(6549),
  [9643] = {.count = 1, .reusable = true}, SHIFT(6550),
  [9645] = {.count = 1, .reusable = false}, SHIFT(6552),
  [9647] = {.count = 1, .reusable = true}, SHIFT(6558),
  [9649] = {.count = 1, .reusable = true}, SHIFT(6560),
  [9651] = {.count = 1, .reusable = false}, SHIFT(6560),
  [9653] = {.count = 1, .reusable = true}, SHIFT(6561),
  [9655] = {.count = 1, .reusable = false}, SHIFT(6541),
  [9657] = {.count = 1, .reusable = true}, SHIFT(6576),
  [9659] = {.count = 1, .reusable = false}, SHIFT(6577),
  [9661] = {.count = 1, .reusable = false}, SHIFT(6578),
  [9663] = {.count = 1, .reusable = false}, SHIFT(6579),
  [9665] = {.count = 1, .reusable = false}, SHIFT(6580),
  [9667] = {.count = 1, .reusable = false}, SHIFT(6581),
  [9669] = {.count = 1, .reusable = true}, SHIFT(6582),
  [9671] = {.count = 1, .reusable = false}, SHIFT(6582),
  [9673] = {.count = 1, .reusable = true}, SHIFT(6583),
  [9675] = {.count = 1, .reusable = false}, SHIFT(6585),
  [9677] = {.count = 1, .reusable = true}, SHIFT(6585),
  [9679] = {.count = 1, .reusable = true}, SHIFT(6590),
  [9681] = {.count = 1, .reusable = false}, SHIFT(3740),
  [9683] = {.count = 1, .reusable = true}, SHIFT(6593),
  [9685] = {.count = 1, .reusable = false}, SHIFT(6593),
  [9687] = {.count = 1, .reusable = true}, SHIFT(6597),
  [9689] = {.count = 1, .reusable = true}, SHIFT(6598),
  [9691] = {.count = 1, .reusable = false}, SHIFT(6599),
  [9693] = {.count = 1, .reusable = false}, SHIFT(6600),
  [9695] = {.count = 1, .reusable = false}, SHIFT(6601),
  [9697] = {.count = 1, .reusable = false}, SHIFT(6602),
  [9699] = {.count = 1, .reusable = true}, SHIFT(6603),
  [9701] = {.count = 1, .reusable = true}, SHIFT(6604),
  [9703] = {.count = 1, .reusable = false}, SHIFT(6605),
  [9705] = {.count = 1, .reusable = true}, SHIFT(6605),
  [9707] = {.count = 1, .reusable = false}, SHIFT(6607),
  [9709] = {.count = 1, .reusable = false}, SHIFT(6608),
  [9711] = {.count = 1, .reusable = true}, SHIFT(6607),
  [9713] = {.count = 1, .reusable = true}, SHIFT(6602),
  [9715] = {.count = 1, .reusable = false}, SHIFT(6609),
  [9717] = {.count = 1, .reusable = true}, SHIFT(6611),
  [9719] = {.count = 1, .reusable = true}, SHIFT(6613),
  [9721] = {.count = 1, .reusable = false}, SHIFT(6613),
  [9723] = {.count = 1, .reusable = true}, SHIFT(6614),
  [9725] = {.count = 1, .reusable = false}, SHIFT(6603),
  [9727] = {.count = 1, .reusable = true}, SHIFT(6616),
  [9729] = {.count = 1, .reusable = true}, SHIFT(6617),
  [9731] = {.count = 1, .reusable = false}, SHIFT(6618),
  [9733] = {.count = 1, .reusable = false}, SHIFT(6619),
  [9735] = {.count = 1, .reusable = false}, SHIFT(6620),
  [9737] = {.count = 1, .reusable = false}, SHIFT(6621),
  [9739] = {.count = 1, .reusable = false}, SHIFT(6622),
  [9741] = {.count = 1, .reusable = true}, SHIFT(6623),
  [9743] = {.count = 1, .reusable = false}, SHIFT(6623),
  [9745] = {.count = 1, .reusable = true}, SHIFT(6624),
  [9747] = {.count = 1, .reusable = true}, SHIFT(6632),
  [9749] = {.count = 1, .reusable = true}, SHIFT(6633),
  [9751] = {.count = 1, .reusable = true}, REDUCE(sym_call, 4),
  [9753] = {.count = 1, .reusable = false}, REDUCE(sym_call, 4),
  [9755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1508),
  [9758] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 4),
  [9760] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 4),
  [9762] = {.count = 1, .reusable = true}, SHIFT(6635),
  [9764] = {.count = 1, .reusable = true}, SHIFT(6636),
  [9766] = {.count = 1, .reusable = true}, SHIFT(6637),
  [9768] = {.count = 1, .reusable = true}, SHIFT(6638),
  [9770] = {.count = 1, .reusable = true}, SHIFT(6640),
  [9772] = {.count = 1, .reusable = true}, SHIFT(6641),
  [9774] = {.count = 1, .reusable = true}, SHIFT(6642),
  [9776] = {.count = 1, .reusable = true}, SHIFT(6643),
  [9778] = {.count = 1, .reusable = true}, SHIFT(6644),
  [9780] = {.count = 1, .reusable = true}, SHIFT(6646),
  [9782] = {.count = 1, .reusable = true}, SHIFT(6647),
  [9784] = {.count = 1, .reusable = true}, SHIFT(6648),
  [9786] = {.count = 1, .reusable = true}, SHIFT(6649),
  [9788] = {.count = 1, .reusable = true}, SHIFT(6650),
  [9790] = {.count = 1, .reusable = true}, SHIFT(6651),
  [9792] = {.count = 1, .reusable = true}, SHIFT(6652),
  [9794] = {.count = 1, .reusable = false}, SHIFT(6653),
  [9796] = {.count = 1, .reusable = true}, SHIFT(6655),
  [9798] = {.count = 1, .reusable = true}, SHIFT(6656),
  [9800] = {.count = 1, .reusable = true}, SHIFT(6658),
  [9802] = {.count = 1, .reusable = false}, SHIFT(6659),
  [9804] = {.count = 1, .reusable = true}, SHIFT(6661),
  [9806] = {.count = 1, .reusable = true}, SHIFT(6662),
  [9808] = {.count = 1, .reusable = true}, SHIFT(6664),
  [9810] = {.count = 1, .reusable = true}, SHIFT(6667),
  [9812] = {.count = 1, .reusable = true}, SHIFT(6668),
  [9814] = {.count = 1, .reusable = true}, SHIFT(6669),
  [9816] = {.count = 1, .reusable = true}, SHIFT(6672),
  [9818] = {.count = 1, .reusable = true}, SHIFT(6674),
  [9820] = {.count = 1, .reusable = false}, SHIFT(6673),
  [9822] = {.count = 1, .reusable = true}, SHIFT(6675),
  [9824] = {.count = 1, .reusable = true}, SHIFT(6676),
  [9826] = {.count = 1, .reusable = true}, SHIFT(6677),
  [9828] = {.count = 1, .reusable = true}, SHIFT(6678),
  [9830] = {.count = 1, .reusable = true}, SHIFT(6680),
  [9832] = {.count = 1, .reusable = true}, SHIFT(6682),
  [9834] = {.count = 1, .reusable = true}, SHIFT(6683),
  [9836] = {.count = 1, .reusable = false}, SHIFT(6687),
  [9838] = {.count = 1, .reusable = true}, SHIFT(6688),
  [9840] = {.count = 1, .reusable = true}, SHIFT(6703),
  [9842] = {.count = 1, .reusable = true}, SHIFT(6711),
  [9844] = {.count = 1, .reusable = false}, SHIFT(6711),
  [9846] = {.count = 1, .reusable = true}, SHIFT(6715),
  [9848] = {.count = 1, .reusable = false}, SHIFT(6713),
  [9850] = {.count = 1, .reusable = true}, SHIFT(6717),
  [9852] = {.count = 1, .reusable = true}, SHIFT(6732),
  [9854] = {.count = 1, .reusable = false}, SHIFT(6732),
  [9856] = {.count = 1, .reusable = true}, SHIFT(6736),
  [9858] = {.count = 1, .reusable = false}, SHIFT(6734),
  [9860] = {.count = 1, .reusable = true}, SHIFT(6738),
  [9862] = {.count = 1, .reusable = true}, SHIFT(6739),
  [9864] = {.count = 1, .reusable = false}, SHIFT(6740),
  [9866] = {.count = 1, .reusable = true}, SHIFT(6741),
  [9868] = {.count = 1, .reusable = false}, SHIFT(6741),
  [9870] = {.count = 1, .reusable = true}, SHIFT(6742),
  [9872] = {.count = 1, .reusable = true}, SHIFT(6749),
  [9874] = {.count = 1, .reusable = true}, SHIFT(6750),
  [9876] = {.count = 1, .reusable = true}, SHIFT(1595),
  [9878] = {.count = 1, .reusable = false}, SHIFT(6752),
  [9880] = {.count = 1, .reusable = true}, SHIFT(6753),
  [9882] = {.count = 1, .reusable = true}, SHIFT(6754),
  [9884] = {.count = 1, .reusable = false}, SHIFT(6755),
  [9886] = {.count = 1, .reusable = false}, SHIFT(6756),
  [9888] = {.count = 1, .reusable = true}, SHIFT(6760),
  [9890] = {.count = 1, .reusable = false}, SHIFT(6757),
  [9892] = {.count = 1, .reusable = false}, SHIFT(6761),
  [9894] = {.count = 1, .reusable = false}, SHIFT(6764),
  [9896] = {.count = 1, .reusable = false}, SHIFT(6766),
  [9898] = {.count = 1, .reusable = true}, SHIFT(6768),
  [9900] = {.count = 1, .reusable = true}, SHIFT(6769),
  [9902] = {.count = 1, .reusable = false}, SHIFT(6769),
  [9904] = {.count = 1, .reusable = true}, SHIFT(6771),
  [9906] = {.count = 1, .reusable = true}, SHIFT(6773),
  [9908] = {.count = 1, .reusable = true}, SHIFT(6774),
  [9910] = {.count = 1, .reusable = true}, SHIFT(6775),
  [9912] = {.count = 1, .reusable = true}, SHIFT(6778),
  [9914] = {.count = 1, .reusable = true}, SHIFT(6779),
  [9916] = {.count = 1, .reusable = true}, SHIFT(6780),
  [9918] = {.count = 1, .reusable = true}, SHIFT(6781),
  [9920] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1655),
  [9923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1657),
  [9926] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(402),
  [9929] = {.count = 1, .reusable = true}, REDUCE(sym_right_assignment_list, 2),
  [9931] = {.count = 1, .reusable = false}, REDUCE(sym_right_assignment_list, 2),
  [9933] = {.count = 1, .reusable = true}, SHIFT(6806),
  [9935] = {.count = 1, .reusable = true}, SHIFT(6807),
  [9937] = {.count = 1, .reusable = false}, SHIFT(6808),
  [9939] = {.count = 1, .reusable = true}, SHIFT(6809),
  [9941] = {.count = 1, .reusable = false}, SHIFT(6810),
  [9943] = {.count = 1, .reusable = false}, SHIFT(6811),
  [9945] = {.count = 1, .reusable = true}, SHIFT(6812),
  [9947] = {.count = 1, .reusable = false}, SHIFT(6813),
  [9949] = {.count = 1, .reusable = true}, SHIFT(6813),
  [9951] = {.count = 1, .reusable = true}, SHIFT(6815),
  [9953] = {.count = 1, .reusable = true}, SHIFT(6816),
  [9955] = {.count = 1, .reusable = false}, SHIFT(6815),
  [9957] = {.count = 1, .reusable = true}, SHIFT(6811),
  [9959] = {.count = 1, .reusable = true}, SHIFT(6808),
  [9961] = {.count = 1, .reusable = true}, SHIFT(6817),
  [9963] = {.count = 1, .reusable = true}, SHIFT(6818),
  [9965] = {.count = 1, .reusable = false}, SHIFT(6818),
  [9967] = {.count = 1, .reusable = true}, SHIFT(6819),
  [9969] = {.count = 1, .reusable = true}, SHIFT(6824),
  [9971] = {.count = 1, .reusable = false}, SHIFT(6824),
  [9973] = {.count = 1, .reusable = true}, SHIFT(6828),
  [9975] = {.count = 1, .reusable = false}, SHIFT(6826),
  [9977] = {.count = 1, .reusable = true}, SHIFT(6845),
  [9979] = {.count = 1, .reusable = false}, SHIFT(6845),
  [9981] = {.count = 1, .reusable = true}, SHIFT(6849),
  [9983] = {.count = 1, .reusable = false}, SHIFT(6847),
  [9985] = {.count = 1, .reusable = true}, SHIFT(1681),
  [9987] = {.count = 1, .reusable = true}, SHIFT(6859),
  [9989] = {.count = 1, .reusable = true}, SHIFT(6861),
  [9991] = {.count = 1, .reusable = true}, SHIFT(6862),
  [9993] = {.count = 1, .reusable = true}, SHIFT(6865),
  [9995] = {.count = 1, .reusable = true}, SHIFT(6866),
  [9997] = {.count = 1, .reusable = true}, SHIFT(6868),
  [9999] = {.count = 1, .reusable = true}, SHIFT(6870),
  [10001] = {.count = 1, .reusable = true}, SHIFT(6872),
  [10003] = {.count = 1, .reusable = true}, SHIFT(6874),
  [10005] = {.count = 1, .reusable = true}, SHIFT(6876),
  [10007] = {.count = 1, .reusable = false}, SHIFT(6877),
  [10009] = {.count = 1, .reusable = true}, SHIFT(6879),
  [10011] = {.count = 1, .reusable = false}, SHIFT(6880),
  [10013] = {.count = 1, .reusable = true}, SHIFT(6883),
  [10015] = {.count = 1, .reusable = true}, SHIFT(6886),
  [10017] = {.count = 1, .reusable = false}, SHIFT(6888),
  [10019] = {.count = 1, .reusable = true}, SHIFT(6890),
  [10021] = {.count = 1, .reusable = true}, SHIFT(6892),
  [10023] = {.count = 1, .reusable = false}, SHIFT(6893),
  [10025] = {.count = 1, .reusable = false}, SHIFT(6895),
  [10027] = {.count = 1, .reusable = true}, SHIFT(6907),
  [10029] = {.count = 1, .reusable = true}, SHIFT(6913),
  [10031] = {.count = 1, .reusable = false}, SHIFT(6912),
  [10033] = {.count = 1, .reusable = false}, SHIFT(6917),
  [10035] = {.count = 1, .reusable = true}, SHIFT(6918),
  [10037] = {.count = 1, .reusable = true}, SHIFT(6923),
  [10039] = {.count = 1, .reusable = true}, SHIFT(6924),
  [10041] = {.count = 1, .reusable = false}, SHIFT(6925),
  [10043] = {.count = 1, .reusable = false}, SHIFT(6926),
  [10045] = {.count = 1, .reusable = false}, SHIFT(6927),
  [10047] = {.count = 1, .reusable = false}, SHIFT(6928),
  [10049] = {.count = 1, .reusable = true}, SHIFT(6929),
  [10051] = {.count = 1, .reusable = false}, SHIFT(6930),
  [10053] = {.count = 1, .reusable = true}, SHIFT(6930),
  [10055] = {.count = 1, .reusable = false}, SHIFT(6932),
  [10057] = {.count = 1, .reusable = false}, SHIFT(6933),
  [10059] = {.count = 1, .reusable = true}, SHIFT(6932),
  [10061] = {.count = 1, .reusable = true}, SHIFT(6928),
  [10063] = {.count = 1, .reusable = false}, SHIFT(6934),
  [10065] = {.count = 1, .reusable = true}, SHIFT(6935),
  [10067] = {.count = 1, .reusable = false}, SHIFT(6935),
  [10069] = {.count = 1, .reusable = true}, SHIFT(6936),
  [10071] = {.count = 1, .reusable = true}, SHIFT(6939),
  [10073] = {.count = 1, .reusable = true}, SHIFT(6941),
  [10075] = {.count = 1, .reusable = true}, SHIFT(6943),
  [10077] = {.count = 1, .reusable = false}, SHIFT(6941),
  [10079] = {.count = 1, .reusable = true}, SHIFT(6945),
  [10081] = {.count = 1, .reusable = true}, SHIFT(6960),
  [10083] = {.count = 1, .reusable = true}, SHIFT(6962),
  [10085] = {.count = 1, .reusable = true}, SHIFT(6961),
  [10087] = {.count = 1, .reusable = true}, SHIFT(1729),
  [10089] = {.count = 1, .reusable = true}, SHIFT(6976),
  [10091] = {.count = 1, .reusable = true}, SHIFT(6977),
  [10093] = {.count = 1, .reusable = false}, SHIFT(6978),
  [10095] = {.count = 1, .reusable = true}, SHIFT(6979),
  [10097] = {.count = 1, .reusable = false}, SHIFT(6980),
  [10099] = {.count = 1, .reusable = false}, SHIFT(6981),
  [10101] = {.count = 1, .reusable = true}, SHIFT(6982),
  [10103] = {.count = 1, .reusable = false}, SHIFT(6983),
  [10105] = {.count = 1, .reusable = true}, SHIFT(6983),
  [10107] = {.count = 1, .reusable = true}, SHIFT(6985),
  [10109] = {.count = 1, .reusable = true}, SHIFT(6986),
  [10111] = {.count = 1, .reusable = false}, SHIFT(6985),
  [10113] = {.count = 1, .reusable = true}, SHIFT(6981),
  [10115] = {.count = 1, .reusable = true}, SHIFT(6978),
  [10117] = {.count = 1, .reusable = true}, SHIFT(6987),
  [10119] = {.count = 1, .reusable = true}, SHIFT(6988),
  [10121] = {.count = 1, .reusable = true}, SHIFT(6990),
  [10123] = {.count = 1, .reusable = false}, SHIFT(6990),
  [10125] = {.count = 1, .reusable = true}, SHIFT(6991),
  [10127] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 27),
  [10129] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 27),
  [10131] = {.count = 1, .reusable = true}, SHIFT(6993),
  [10133] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 5, .alias_sequence_id = 28),
  [10135] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 5, .alias_sequence_id = 28),
  [10137] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 29),
  [10139] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 29),
  [10141] = {.count = 1, .reusable = true}, SHIFT(6994),
  [10143] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 30),
  [10145] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 5, .alias_sequence_id = 30),
  [10147] = {.count = 1, .reusable = true}, SHIFT(7000),
  [10149] = {.count = 1, .reusable = true}, SHIFT(7001),
  [10151] = {.count = 1, .reusable = false}, SHIFT(7002),
  [10153] = {.count = 1, .reusable = true}, SHIFT(7003),
  [10155] = {.count = 1, .reusable = false}, SHIFT(7004),
  [10157] = {.count = 1, .reusable = false}, SHIFT(7005),
  [10159] = {.count = 1, .reusable = true}, SHIFT(7006),
  [10161] = {.count = 1, .reusable = false}, SHIFT(7007),
  [10163] = {.count = 1, .reusable = true}, SHIFT(7007),
  [10165] = {.count = 1, .reusable = true}, SHIFT(7009),
  [10167] = {.count = 1, .reusable = true}, SHIFT(7010),
  [10169] = {.count = 1, .reusable = false}, SHIFT(7009),
  [10171] = {.count = 1, .reusable = true}, SHIFT(7005),
  [10173] = {.count = 1, .reusable = true}, SHIFT(7002),
  [10175] = {.count = 1, .reusable = true}, SHIFT(7011),
  [10177] = {.count = 1, .reusable = true}, SHIFT(7012),
  [10179] = {.count = 1, .reusable = false}, SHIFT(7012),
  [10181] = {.count = 1, .reusable = true}, SHIFT(7013),
  [10183] = {.count = 1, .reusable = true}, SHIFT(1774),
  [10185] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(7040),
  [10188] = {.count = 1, .reusable = true}, SHIFT(7041),
  [10190] = {.count = 1, .reusable = true}, SHIFT(7045),
  [10192] = {.count = 1, .reusable = true}, SHIFT(7046),
  [10194] = {.count = 1, .reusable = false}, SHIFT(7047),
  [10196] = {.count = 1, .reusable = false}, SHIFT(7048),
  [10198] = {.count = 1, .reusable = false}, SHIFT(7049),
  [10200] = {.count = 1, .reusable = false}, SHIFT(7050),
  [10202] = {.count = 1, .reusable = true}, SHIFT(7051),
  [10204] = {.count = 1, .reusable = false}, SHIFT(7052),
  [10206] = {.count = 1, .reusable = true}, SHIFT(7052),
  [10208] = {.count = 1, .reusable = false}, SHIFT(7054),
  [10210] = {.count = 1, .reusable = false}, SHIFT(7055),
  [10212] = {.count = 1, .reusable = true}, SHIFT(7054),
  [10214] = {.count = 1, .reusable = true}, SHIFT(7050),
  [10216] = {.count = 1, .reusable = false}, SHIFT(7056),
  [10218] = {.count = 1, .reusable = true}, SHIFT(7057),
  [10220] = {.count = 1, .reusable = false}, SHIFT(7057),
  [10222] = {.count = 1, .reusable = true}, SHIFT(7058),
  [10224] = {.count = 1, .reusable = true}, SHIFT(1816),
  [10226] = {.count = 1, .reusable = true}, SHIFT(7086),
  [10228] = {.count = 1, .reusable = true}, SHIFT(7087),
  [10230] = {.count = 1, .reusable = false}, SHIFT(7088),
  [10232] = {.count = 1, .reusable = true}, SHIFT(7089),
  [10234] = {.count = 1, .reusable = false}, SHIFT(7090),
  [10236] = {.count = 1, .reusable = false}, SHIFT(7091),
  [10238] = {.count = 1, .reusable = true}, SHIFT(7092),
  [10240] = {.count = 1, .reusable = false}, SHIFT(7093),
  [10242] = {.count = 1, .reusable = true}, SHIFT(7093),
  [10244] = {.count = 1, .reusable = true}, SHIFT(7095),
  [10246] = {.count = 1, .reusable = true}, SHIFT(7096),
  [10248] = {.count = 1, .reusable = false}, SHIFT(7095),
  [10250] = {.count = 1, .reusable = true}, SHIFT(7091),
  [10252] = {.count = 1, .reusable = true}, SHIFT(7088),
  [10254] = {.count = 1, .reusable = true}, SHIFT(7097),
  [10256] = {.count = 1, .reusable = true}, SHIFT(7098),
  [10258] = {.count = 1, .reusable = true}, SHIFT(7100),
  [10260] = {.count = 1, .reusable = false}, SHIFT(7100),
  [10262] = {.count = 1, .reusable = true}, SHIFT(7101),
  [10264] = {.count = 1, .reusable = true}, SHIFT(7102),
  [10266] = {.count = 1, .reusable = true}, SHIFT(7103),
  [10268] = {.count = 1, .reusable = true}, SHIFT(7104),
  [10270] = {.count = 1, .reusable = true}, SHIFT(7105),
  [10272] = {.count = 1, .reusable = true}, SHIFT(7106),
  [10274] = {.count = 1, .reusable = true}, SHIFT(7107),
  [10276] = {.count = 1, .reusable = true}, SHIFT(7108),
  [10278] = {.count = 1, .reusable = true}, SHIFT(7112),
  [10280] = {.count = 1, .reusable = true}, SHIFT(7113),
  [10282] = {.count = 1, .reusable = false}, SHIFT(7114),
  [10284] = {.count = 1, .reusable = true}, SHIFT(7115),
  [10286] = {.count = 1, .reusable = false}, SHIFT(7116),
  [10288] = {.count = 1, .reusable = false}, SHIFT(7117),
  [10290] = {.count = 1, .reusable = true}, SHIFT(7118),
  [10292] = {.count = 1, .reusable = false}, SHIFT(7119),
  [10294] = {.count = 1, .reusable = true}, SHIFT(7119),
  [10296] = {.count = 1, .reusable = true}, SHIFT(7121),
  [10298] = {.count = 1, .reusable = true}, SHIFT(7122),
  [10300] = {.count = 1, .reusable = false}, SHIFT(7121),
  [10302] = {.count = 1, .reusable = true}, SHIFT(7117),
  [10304] = {.count = 1, .reusable = true}, SHIFT(7114),
  [10306] = {.count = 1, .reusable = true}, SHIFT(7123),
  [10308] = {.count = 1, .reusable = true}, SHIFT(7124),
  [10310] = {.count = 1, .reusable = false}, SHIFT(7124),
  [10312] = {.count = 1, .reusable = true}, SHIFT(7125),
  [10314] = {.count = 1, .reusable = true}, SHIFT(7129),
  [10316] = {.count = 1, .reusable = false}, SHIFT(7129),
  [10318] = {.count = 1, .reusable = true}, SHIFT(7133),
  [10320] = {.count = 1, .reusable = false}, SHIFT(7131),
  [10322] = {.count = 1, .reusable = true}, SHIFT(7150),
  [10324] = {.count = 1, .reusable = false}, SHIFT(7150),
  [10326] = {.count = 1, .reusable = true}, SHIFT(7154),
  [10328] = {.count = 1, .reusable = false}, SHIFT(7152),
  [10330] = {.count = 1, .reusable = true}, SHIFT(1867),
  [10332] = {.count = 1, .reusable = true}, SHIFT(7164),
  [10334] = {.count = 1, .reusable = true}, SHIFT(7165),
  [10336] = {.count = 1, .reusable = true}, SHIFT(7168),
  [10338] = {.count = 1, .reusable = true}, SHIFT(7169),
  [10340] = {.count = 1, .reusable = true}, SHIFT(7174),
  [10342] = {.count = 1, .reusable = true}, SHIFT(7175),
  [10344] = {.count = 1, .reusable = false}, SHIFT(7176),
  [10346] = {.count = 1, .reusable = false}, SHIFT(7177),
  [10348] = {.count = 1, .reusable = false}, SHIFT(7178),
  [10350] = {.count = 1, .reusable = false}, SHIFT(7179),
  [10352] = {.count = 1, .reusable = true}, SHIFT(7180),
  [10354] = {.count = 1, .reusable = false}, SHIFT(7181),
  [10356] = {.count = 1, .reusable = true}, SHIFT(7181),
  [10358] = {.count = 1, .reusable = false}, SHIFT(7183),
  [10360] = {.count = 1, .reusable = false}, SHIFT(7184),
  [10362] = {.count = 1, .reusable = true}, SHIFT(7183),
  [10364] = {.count = 1, .reusable = true}, SHIFT(7179),
  [10366] = {.count = 1, .reusable = false}, SHIFT(7185),
  [10368] = {.count = 1, .reusable = true}, SHIFT(7186),
  [10370] = {.count = 1, .reusable = false}, SHIFT(7186),
  [10372] = {.count = 1, .reusable = true}, SHIFT(7187),
  [10374] = {.count = 1, .reusable = true}, SHIFT(7190),
  [10376] = {.count = 1, .reusable = true}, SHIFT(7192),
  [10378] = {.count = 1, .reusable = true}, SHIFT(7194),
  [10380] = {.count = 1, .reusable = false}, SHIFT(7192),
  [10382] = {.count = 1, .reusable = true}, SHIFT(7209),
  [10384] = {.count = 1, .reusable = true}, SHIFT(1905),
  [10386] = {.count = 1, .reusable = false}, SHIFT(7221),
  [10388] = {.count = 1, .reusable = false}, SHIFT(7222),
  [10390] = {.count = 1, .reusable = true}, SHIFT(7225),
  [10392] = {.count = 1, .reusable = true}, SHIFT(7226),
  [10394] = {.count = 1, .reusable = true}, SHIFT(7227),
  [10396] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(1959),
  [10399] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1961),
  [10402] = {.count = 1, .reusable = true}, SHIFT(7231),
  [10404] = {.count = 1, .reusable = false}, SHIFT(7231),
  [10406] = {.count = 1, .reusable = true}, SHIFT(7234),
  [10408] = {.count = 1, .reusable = true}, SHIFT(7236),
  [10410] = {.count = 1, .reusable = true}, SHIFT(7237),
  [10412] = {.count = 1, .reusable = false}, SHIFT(7238),
  [10414] = {.count = 1, .reusable = true}, SHIFT(7240),
  [10416] = {.count = 1, .reusable = true}, SHIFT(7242),
  [10418] = {.count = 1, .reusable = true}, SHIFT(7244),
  [10420] = {.count = 1, .reusable = true}, SHIFT(7245),
  [10422] = {.count = 1, .reusable = false}, SHIFT(7245),
  [10424] = {.count = 1, .reusable = true}, SHIFT(7247),
  [10426] = {.count = 1, .reusable = true}, SHIFT(7249),
  [10428] = {.count = 1, .reusable = true}, SHIFT(7251),
  [10430] = {.count = 1, .reusable = true}, SHIFT(7252),
  [10432] = {.count = 1, .reusable = true}, SHIFT(7253),
  [10434] = {.count = 1, .reusable = true}, SHIFT(7254),
  [10436] = {.count = 1, .reusable = true}, SHIFT(7256),
  [10438] = {.count = 1, .reusable = true}, SHIFT(7257),
  [10440] = {.count = 1, .reusable = true}, SHIFT(7258),
  [10442] = {.count = 1, .reusable = true}, SHIFT(7259),
  [10444] = {.count = 1, .reusable = true}, SHIFT(7260),
  [10446] = {.count = 1, .reusable = true}, SHIFT(7262),
  [10448] = {.count = 1, .reusable = true}, SHIFT(7263),
  [10450] = {.count = 1, .reusable = true}, SHIFT(7264),
  [10452] = {.count = 1, .reusable = true}, SHIFT(7265),
  [10454] = {.count = 1, .reusable = true}, SHIFT(7266),
  [10456] = {.count = 1, .reusable = true}, SHIFT(2039),
  [10458] = {.count = 1, .reusable = false}, SHIFT(7268),
  [10460] = {.count = 1, .reusable = true}, SHIFT(7269),
  [10462] = {.count = 1, .reusable = true}, SHIFT(7270),
  [10464] = {.count = 1, .reusable = false}, SHIFT(7271),
  [10466] = {.count = 1, .reusable = false}, SHIFT(7272),
  [10468] = {.count = 1, .reusable = true}, SHIFT(7276),
  [10470] = {.count = 1, .reusable = false}, SHIFT(7273),
  [10472] = {.count = 1, .reusable = false}, SHIFT(7277),
  [10474] = {.count = 1, .reusable = false}, SHIFT(7280),
  [10476] = {.count = 1, .reusable = false}, SHIFT(7282),
  [10478] = {.count = 1, .reusable = true}, SHIFT(7284),
  [10480] = {.count = 1, .reusable = true}, SHIFT(7285),
  [10482] = {.count = 1, .reusable = false}, SHIFT(7285),
  [10484] = {.count = 1, .reusable = true}, SHIFT(7287),
  [10486] = {.count = 1, .reusable = true}, SHIFT(7289),
  [10488] = {.count = 1, .reusable = true}, SHIFT(7290),
  [10490] = {.count = 1, .reusable = true}, SHIFT(7291),
  [10492] = {.count = 1, .reusable = true}, SHIFT(7294),
  [10494] = {.count = 1, .reusable = true}, SHIFT(7295),
  [10496] = {.count = 1, .reusable = true}, SHIFT(7296),
  [10498] = {.count = 1, .reusable = true}, SHIFT(7297),
  [10500] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2099),
  [10503] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2101),
  [10506] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(632),
  [10509] = {.count = 1, .reusable = true}, SHIFT(7318),
  [10511] = {.count = 1, .reusable = true}, REDUCE(sym__hash_items, 4),
  [10513] = {.count = 1, .reusable = true}, SHIFT(7322),
  [10515] = {.count = 1, .reusable = true}, SHIFT(7323),
  [10517] = {.count = 1, .reusable = false}, SHIFT(7324),
  [10519] = {.count = 1, .reusable = true}, SHIFT(7325),
  [10521] = {.count = 1, .reusable = false}, SHIFT(7326),
  [10523] = {.count = 1, .reusable = false}, SHIFT(7327),
  [10525] = {.count = 1, .reusable = true}, SHIFT(7328),
  [10527] = {.count = 1, .reusable = false}, SHIFT(7329),
  [10529] = {.count = 1, .reusable = true}, SHIFT(7329),
  [10531] = {.count = 1, .reusable = true}, SHIFT(7331),
  [10533] = {.count = 1, .reusable = true}, SHIFT(7332),
  [10535] = {.count = 1, .reusable = false}, SHIFT(7331),
  [10537] = {.count = 1, .reusable = true}, SHIFT(7327),
  [10539] = {.count = 1, .reusable = true}, SHIFT(7324),
  [10541] = {.count = 1, .reusable = true}, SHIFT(7333),
  [10543] = {.count = 1, .reusable = true}, SHIFT(7334),
  [10545] = {.count = 1, .reusable = false}, SHIFT(7334),
  [10547] = {.count = 1, .reusable = true}, SHIFT(7335),
  [10549] = {.count = 1, .reusable = true}, SHIFT(2134),
  [10551] = {.count = 1, .reusable = true}, SHIFT(7358),
  [10553] = {.count = 1, .reusable = true}, SHIFT(7362),
  [10555] = {.count = 1, .reusable = true}, SHIFT(7363),
  [10557] = {.count = 1, .reusable = false}, SHIFT(7364),
  [10559] = {.count = 1, .reusable = false}, SHIFT(7365),
  [10561] = {.count = 1, .reusable = false}, SHIFT(7366),
  [10563] = {.count = 1, .reusable = false}, SHIFT(7367),
  [10565] = {.count = 1, .reusable = true}, SHIFT(7368),
  [10567] = {.count = 1, .reusable = false}, SHIFT(7369),
  [10569] = {.count = 1, .reusable = true}, SHIFT(7369),
  [10571] = {.count = 1, .reusable = false}, SHIFT(7371),
  [10573] = {.count = 1, .reusable = false}, SHIFT(7372),
  [10575] = {.count = 1, .reusable = true}, SHIFT(7371),
  [10577] = {.count = 1, .reusable = true}, SHIFT(7367),
  [10579] = {.count = 1, .reusable = false}, SHIFT(7373),
  [10581] = {.count = 1, .reusable = true}, SHIFT(7374),
  [10583] = {.count = 1, .reusable = false}, SHIFT(7374),
  [10585] = {.count = 1, .reusable = true}, SHIFT(7375),
  [10587] = {.count = 1, .reusable = true}, SHIFT(2164),
  [10589] = {.count = 1, .reusable = true}, SHIFT(7403),
  [10591] = {.count = 1, .reusable = true}, SHIFT(7404),
  [10593] = {.count = 1, .reusable = false}, SHIFT(7405),
  [10595] = {.count = 1, .reusable = true}, SHIFT(7406),
  [10597] = {.count = 1, .reusable = false}, SHIFT(7407),
  [10599] = {.count = 1, .reusable = false}, SHIFT(7408),
  [10601] = {.count = 1, .reusable = true}, SHIFT(7409),
  [10603] = {.count = 1, .reusable = false}, SHIFT(7410),
  [10605] = {.count = 1, .reusable = true}, SHIFT(7410),
  [10607] = {.count = 1, .reusable = true}, SHIFT(7412),
  [10609] = {.count = 1, .reusable = true}, SHIFT(7413),
  [10611] = {.count = 1, .reusable = false}, SHIFT(7412),
  [10613] = {.count = 1, .reusable = true}, SHIFT(7408),
  [10615] = {.count = 1, .reusable = true}, SHIFT(7405),
  [10617] = {.count = 1, .reusable = true}, SHIFT(7414),
  [10619] = {.count = 1, .reusable = true}, SHIFT(7415),
  [10621] = {.count = 1, .reusable = true}, SHIFT(7417),
  [10623] = {.count = 1, .reusable = false}, SHIFT(7417),
  [10625] = {.count = 1, .reusable = true}, SHIFT(7418),
  [10627] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 3),
  [10629] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 3),
  [10631] = {.count = 1, .reusable = true}, SHIFT(7420),
  [10633] = {.count = 1, .reusable = true}, SHIFT(7421),
  [10635] = {.count = 1, .reusable = true}, SHIFT(7422),
  [10637] = {.count = 1, .reusable = true}, SHIFT(7428),
  [10639] = {.count = 1, .reusable = false}, SHIFT(7425),
  [10641] = {.count = 1, .reusable = true}, SHIFT(4682),
  [10643] = {.count = 1, .reusable = true}, SHIFT(5781),
  [10645] = {.count = 1, .reusable = true}, SHIFT(7431),
  [10647] = {.count = 1, .reusable = true}, SHIFT(7434),
  [10649] = {.count = 1, .reusable = true}, SHIFT(7435),
  [10651] = {.count = 1, .reusable = true}, SHIFT(7436),
  [10653] = {.count = 1, .reusable = false}, SHIFT(7438),
  [10655] = {.count = 1, .reusable = true}, SHIFT(7445),
  [10657] = {.count = 1, .reusable = true}, SHIFT(7446),
  [10659] = {.count = 1, .reusable = false}, SHIFT(7447),
  [10661] = {.count = 1, .reusable = true}, SHIFT(7448),
  [10663] = {.count = 1, .reusable = false}, SHIFT(7449),
  [10665] = {.count = 1, .reusable = false}, SHIFT(7450),
  [10667] = {.count = 1, .reusable = true}, SHIFT(7451),
  [10669] = {.count = 1, .reusable = false}, SHIFT(7452),
  [10671] = {.count = 1, .reusable = true}, SHIFT(7452),
  [10673] = {.count = 1, .reusable = true}, SHIFT(7453),
  [10675] = {.count = 1, .reusable = true}, SHIFT(7454),
  [10677] = {.count = 1, .reusable = true}, SHIFT(7455),
  [10679] = {.count = 1, .reusable = false}, SHIFT(7454),
  [10681] = {.count = 1, .reusable = true}, SHIFT(7450),
  [10683] = {.count = 1, .reusable = true}, SHIFT(7447),
  [10685] = {.count = 1, .reusable = true}, SHIFT(7456),
  [10687] = {.count = 1, .reusable = true}, SHIFT(7457),
  [10689] = {.count = 1, .reusable = false}, SHIFT(7457),
  [10691] = {.count = 1, .reusable = true}, SHIFT(7458),
  [10693] = {.count = 1, .reusable = true}, SHIFT(7463),
  [10695] = {.count = 1, .reusable = false}, SHIFT(7463),
  [10697] = {.count = 1, .reusable = true}, SHIFT(7467),
  [10699] = {.count = 1, .reusable = false}, SHIFT(7465),
  [10701] = {.count = 1, .reusable = true}, SHIFT(2234),
  [10703] = {.count = 1, .reusable = true}, SHIFT(7514),
  [10705] = {.count = 1, .reusable = true}, SHIFT(2258),
  [10707] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2265),
  [10710] = {.count = 1, .reusable = true}, SHIFT(7540),
  [10712] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2324),
  [10715] = {.count = 1, .reusable = true}, SHIFT(7558),
  [10717] = {.count = 1, .reusable = true}, SHIFT(7559),
  [10719] = {.count = 1, .reusable = true}, SHIFT(7560),
  [10721] = {.count = 1, .reusable = true}, SHIFT(7561),
  [10723] = {.count = 1, .reusable = true}, SHIFT(7562),
  [10725] = {.count = 1, .reusable = true}, SHIFT(7563),
  [10727] = {.count = 1, .reusable = true}, SHIFT(7564),
  [10729] = {.count = 1, .reusable = false}, SHIFT(7565),
  [10731] = {.count = 1, .reusable = false}, SHIFT(7566),
  [10733] = {.count = 1, .reusable = true}, SHIFT(7569),
  [10735] = {.count = 1, .reusable = false}, SHIFT(7569),
  [10737] = {.count = 1, .reusable = true}, SHIFT(7571),
  [10739] = {.count = 1, .reusable = true}, SHIFT(7573),
  [10741] = {.count = 1, .reusable = false}, SHIFT(7571),
  [10743] = {.count = 1, .reusable = true}, SHIFT(7587),
  [10745] = {.count = 1, .reusable = false}, SHIFT(7588),
  [10747] = {.count = 1, .reusable = false}, SHIFT(7589),
  [10749] = {.count = 1, .reusable = false}, SHIFT(7590),
  [10751] = {.count = 1, .reusable = false}, SHIFT(7591),
  [10753] = {.count = 1, .reusable = false}, SHIFT(7592),
  [10755] = {.count = 1, .reusable = true}, SHIFT(7593),
  [10757] = {.count = 1, .reusable = false}, SHIFT(7593),
  [10759] = {.count = 1, .reusable = true}, SHIFT(7594),
  [10761] = {.count = 1, .reusable = true}, SHIFT(7600),
  [10763] = {.count = 1, .reusable = false}, SHIFT(7600),
  [10765] = {.count = 1, .reusable = true}, SHIFT(7602),
  [10767] = {.count = 1, .reusable = true}, SHIFT(7604),
  [10769] = {.count = 1, .reusable = false}, SHIFT(7602),
  [10771] = {.count = 1, .reusable = true}, SHIFT(7610),
  [10773] = {.count = 1, .reusable = true}, SHIFT(7611),
  [10775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2387),
  [10778] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2389),
  [10781] = {.count = 1, .reusable = true}, SHIFT(7613),
  [10783] = {.count = 1, .reusable = false}, SHIFT(7613),
  [10785] = {.count = 1, .reusable = true}, SHIFT(7616),
  [10787] = {.count = 1, .reusable = true}, SHIFT(7618),
  [10789] = {.count = 1, .reusable = true}, SHIFT(7619),
  [10791] = {.count = 1, .reusable = false}, SHIFT(7620),
  [10793] = {.count = 1, .reusable = true}, SHIFT(7622),
  [10795] = {.count = 1, .reusable = true}, SHIFT(7624),
  [10797] = {.count = 1, .reusable = true}, SHIFT(7626),
  [10799] = {.count = 1, .reusable = true}, SHIFT(7627),
  [10801] = {.count = 1, .reusable = false}, SHIFT(7627),
  [10803] = {.count = 1, .reusable = true}, SHIFT(7629),
  [10805] = {.count = 1, .reusable = true}, SHIFT(7630),
  [10807] = {.count = 1, .reusable = true}, SHIFT(7632),
  [10809] = {.count = 1, .reusable = true}, SHIFT(7633),
  [10811] = {.count = 1, .reusable = true}, SHIFT(7634),
  [10813] = {.count = 1, .reusable = true}, SHIFT(7635),
  [10815] = {.count = 1, .reusable = true}, SHIFT(7636),
  [10817] = {.count = 1, .reusable = true}, SHIFT(7637),
  [10819] = {.count = 1, .reusable = false}, SHIFT(7638),
  [10821] = {.count = 1, .reusable = true}, SHIFT(7640),
  [10823] = {.count = 1, .reusable = true}, SHIFT(7641),
  [10825] = {.count = 1, .reusable = true}, SHIFT(7643),
  [10827] = {.count = 1, .reusable = false}, SHIFT(7644),
  [10829] = {.count = 1, .reusable = true}, SHIFT(7646),
  [10831] = {.count = 1, .reusable = true}, SHIFT(7647),
  [10833] = {.count = 1, .reusable = true}, SHIFT(7649),
  [10835] = {.count = 1, .reusable = true}, SHIFT(7652),
  [10837] = {.count = 1, .reusable = true}, SHIFT(7653),
  [10839] = {.count = 1, .reusable = true}, SHIFT(7654),
  [10841] = {.count = 1, .reusable = true}, SHIFT(7657),
  [10843] = {.count = 1, .reusable = true}, SHIFT(7659),
  [10845] = {.count = 1, .reusable = false}, SHIFT(7658),
  [10847] = {.count = 1, .reusable = true}, SHIFT(7662),
  [10849] = {.count = 1, .reusable = true}, SHIFT(7664),
  [10851] = {.count = 1, .reusable = false}, SHIFT(7662),
  [10853] = {.count = 1, .reusable = true}, SHIFT(7667),
  [10855] = {.count = 1, .reusable = true}, SHIFT(7668),
  [10857] = {.count = 1, .reusable = true}, SHIFT(7670),
  [10859] = {.count = 1, .reusable = false}, SHIFT(7667),
  [10861] = {.count = 1, .reusable = true}, SHIFT(7672),
  [10863] = {.count = 1, .reusable = true}, SHIFT(7673),
  [10865] = {.count = 1, .reusable = true}, SHIFT(7674),
  [10867] = {.count = 1, .reusable = true}, SHIFT(7675),
  [10869] = {.count = 1, .reusable = true}, SHIFT(7677),
  [10871] = {.count = 1, .reusable = true}, SHIFT(7679),
  [10873] = {.count = 1, .reusable = true}, SHIFT(7680),
  [10875] = {.count = 1, .reusable = false}, SHIFT(7684),
  [10877] = {.count = 1, .reusable = true}, SHIFT(7685),
  [10879] = {.count = 1, .reusable = true}, SHIFT(7687),
  [10881] = {.count = 1, .reusable = true}, SHIFT(7693),
  [10883] = {.count = 1, .reusable = false}, SHIFT(7690),
  [10885] = {.count = 1, .reusable = true}, SHIFT(5019),
  [10887] = {.count = 1, .reusable = true}, SHIFT(7707),
  [10889] = {.count = 1, .reusable = true}, SHIFT(2467),
  [10891] = {.count = 1, .reusable = true}, SHIFT(7719),
  [10893] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2490),
  [10896] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_class, 5, .alias_sequence_id = 31),
  [10898] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_class, 5, .alias_sequence_id = 31),
  [10900] = {.count = 1, .reusable = true}, REDUCE(sym_class, 5),
  [10902] = {.count = 1, .reusable = false}, REDUCE(sym_class, 5),
  [10904] = {.count = 1, .reusable = true}, SHIFT(7724),
  [10906] = {.count = 1, .reusable = false}, SHIFT(7724),
  [10908] = {.count = 1, .reusable = true}, SHIFT(7726),
  [10910] = {.count = 1, .reusable = true}, SHIFT(7728),
  [10912] = {.count = 1, .reusable = false}, SHIFT(7726),
  [10914] = {.count = 1, .reusable = true}, SHIFT(2522),
  [10916] = {.count = 1, .reusable = true}, SHIFT(7752),
  [10918] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2544),
  [10921] = {.count = 1, .reusable = true}, SHIFT(7757),
  [10923] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2577),
  [10926] = {.count = 1, .reusable = true}, SHIFT(7774),
  [10928] = {.count = 1, .reusable = true}, SHIFT(2600),
  [10930] = {.count = 1, .reusable = true}, SHIFT(7785),
  [10932] = {.count = 1, .reusable = true}, SHIFT(2624),
  [10934] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_parens, 4),
  [10936] = {.count = 1, .reusable = false}, REDUCE(sym__argument_list_with_parens, 4),
  [10938] = {.count = 1, .reusable = true}, SHIFT(7796),
  [10940] = {.count = 1, .reusable = true}, SHIFT(7798),
  [10942] = {.count = 1, .reusable = true}, SHIFT(7799),
  [10944] = {.count = 1, .reusable = true}, SHIFT(7800),
  [10946] = {.count = 1, .reusable = false}, SHIFT(7800),
  [10948] = {.count = 1, .reusable = true}, SHIFT(7802),
  [10950] = {.count = 1, .reusable = true}, SHIFT(7803),
  [10952] = {.count = 1, .reusable = true}, SHIFT(7804),
  [10954] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(2674),
  [10957] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2676),
  [10960] = {.count = 1, .reusable = true}, SHIFT(7806),
  [10962] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10964] = {.count = 1, .reusable = false}, REDUCE(aux_sym_argument_list_repeat1, 3),
  [10966] = {.count = 1, .reusable = true}, SHIFT(5237),
  [10968] = {.count = 1, .reusable = true}, SHIFT(2711),
  [10970] = {.count = 1, .reusable = true}, SHIFT(7833),
  [10972] = {.count = 1, .reusable = true}, SHIFT(2735),
  [10974] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2742),
  [10977] = {.count = 1, .reusable = true}, SHIFT(7842),
  [10979] = {.count = 1, .reusable = false}, SHIFT(7843),
  [10981] = {.count = 1, .reusable = false}, SHIFT(7844),
  [10983] = {.count = 1, .reusable = false}, SHIFT(7845),
  [10985] = {.count = 1, .reusable = false}, SHIFT(7846),
  [10987] = {.count = 1, .reusable = false}, SHIFT(7847),
  [10989] = {.count = 1, .reusable = true}, SHIFT(7848),
  [10991] = {.count = 1, .reusable = false}, SHIFT(7848),
  [10993] = {.count = 1, .reusable = true}, SHIFT(7849),
  [10995] = {.count = 1, .reusable = false}, SHIFT(5309),
  [10997] = {.count = 1, .reusable = true}, SHIFT(7857),
  [10999] = {.count = 1, .reusable = true}, SHIFT(7859),
  [11001] = {.count = 1, .reusable = true}, SHIFT(7860),
  [11003] = {.count = 1, .reusable = true}, SHIFT(7861),
  [11005] = {.count = 1, .reusable = false}, SHIFT(7863),
  [11007] = {.count = 1, .reusable = false}, SHIFT(7857),
  [11009] = {.count = 1, .reusable = true}, SHIFT(7870),
  [11011] = {.count = 1, .reusable = true}, SHIFT(7871),
  [11013] = {.count = 1, .reusable = false}, SHIFT(7872),
  [11015] = {.count = 1, .reusable = true}, SHIFT(7873),
  [11017] = {.count = 1, .reusable = false}, SHIFT(7874),
  [11019] = {.count = 1, .reusable = false}, SHIFT(7875),
  [11021] = {.count = 1, .reusable = true}, SHIFT(7876),
  [11023] = {.count = 1, .reusable = true}, SHIFT(7877),
  [11025] = {.count = 1, .reusable = false}, SHIFT(7878),
  [11027] = {.count = 1, .reusable = true}, SHIFT(7878),
  [11029] = {.count = 1, .reusable = true}, SHIFT(7880),
  [11031] = {.count = 1, .reusable = true}, SHIFT(7881),
  [11033] = {.count = 1, .reusable = false}, SHIFT(7880),
  [11035] = {.count = 1, .reusable = true}, SHIFT(7875),
  [11037] = {.count = 1, .reusable = true}, SHIFT(7872),
  [11039] = {.count = 1, .reusable = true}, SHIFT(7882),
  [11041] = {.count = 1, .reusable = true}, SHIFT(7883),
  [11043] = {.count = 1, .reusable = true}, SHIFT(7884),
  [11045] = {.count = 1, .reusable = true}, SHIFT(7885),
  [11047] = {.count = 1, .reusable = false}, SHIFT(7887),
  [11049] = {.count = 1, .reusable = true}, SHIFT(7893),
  [11051] = {.count = 1, .reusable = true}, SHIFT(7895),
  [11053] = {.count = 1, .reusable = false}, SHIFT(7895),
  [11055] = {.count = 1, .reusable = true}, SHIFT(7896),
  [11057] = {.count = 1, .reusable = false}, SHIFT(7876),
  [11059] = {.count = 1, .reusable = true}, SHIFT(7898),
  [11061] = {.count = 1, .reusable = true}, REDUCE(sym_if, 5),
  [11063] = {.count = 1, .reusable = false}, REDUCE(sym_if, 5),
  [11065] = {.count = 1, .reusable = true}, SHIFT(7900),
  [11067] = {.count = 1, .reusable = true}, SHIFT(7901),
  [11069] = {.count = 1, .reusable = true}, SHIFT(7920),
  [11071] = {.count = 1, .reusable = false}, SHIFT(7921),
  [11073] = {.count = 1, .reusable = false}, SHIFT(7922),
  [11075] = {.count = 1, .reusable = false}, SHIFT(7923),
  [11077] = {.count = 1, .reusable = false}, SHIFT(7924),
  [11079] = {.count = 1, .reusable = false}, SHIFT(7925),
  [11081] = {.count = 1, .reusable = true}, SHIFT(7926),
  [11083] = {.count = 1, .reusable = false}, SHIFT(7926),
  [11085] = {.count = 1, .reusable = true}, SHIFT(7927),
  [11087] = {.count = 1, .reusable = false}, SHIFT(7929),
  [11089] = {.count = 1, .reusable = true}, SHIFT(7929),
  [11091] = {.count = 1, .reusable = false}, SHIFT(5355),
  [11093] = {.count = 1, .reusable = true}, SHIFT(7936),
  [11095] = {.count = 1, .reusable = false}, SHIFT(7936),
  [11097] = {.count = 1, .reusable = true}, SHIFT(7940),
  [11099] = {.count = 1, .reusable = true}, SHIFT(7941),
  [11101] = {.count = 1, .reusable = false}, SHIFT(7942),
  [11103] = {.count = 1, .reusable = false}, SHIFT(7943),
  [11105] = {.count = 1, .reusable = false}, SHIFT(7944),
  [11107] = {.count = 1, .reusable = false}, SHIFT(7945),
  [11109] = {.count = 1, .reusable = true}, SHIFT(7946),
  [11111] = {.count = 1, .reusable = true}, SHIFT(7947),
  [11113] = {.count = 1, .reusable = false}, SHIFT(7948),
  [11115] = {.count = 1, .reusable = true}, SHIFT(7948),
  [11117] = {.count = 1, .reusable = false}, SHIFT(7950),
  [11119] = {.count = 1, .reusable = false}, SHIFT(7951),
  [11121] = {.count = 1, .reusable = true}, SHIFT(7950),
  [11123] = {.count = 1, .reusable = true}, SHIFT(7945),
  [11125] = {.count = 1, .reusable = false}, SHIFT(7952),
  [11127] = {.count = 1, .reusable = true}, SHIFT(7954),
  [11129] = {.count = 1, .reusable = true}, SHIFT(7956),
  [11131] = {.count = 1, .reusable = false}, SHIFT(7956),
  [11133] = {.count = 1, .reusable = true}, SHIFT(7957),
  [11135] = {.count = 1, .reusable = false}, SHIFT(7946),
  [11137] = {.count = 1, .reusable = true}, SHIFT(7959),
  [11139] = {.count = 1, .reusable = true}, SHIFT(7960),
  [11141] = {.count = 1, .reusable = false}, SHIFT(7961),
  [11143] = {.count = 1, .reusable = true}, SHIFT(7962),
  [11145] = {.count = 1, .reusable = false}, SHIFT(7962),
  [11147] = {.count = 1, .reusable = true}, SHIFT(7963),
  [11149] = {.count = 1, .reusable = true}, SHIFT(7988),
  [11151] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2824),
  [11154] = {.count = 1, .reusable = true}, SHIFT(8006),
  [11156] = {.count = 1, .reusable = false}, SHIFT(8007),
  [11158] = {.count = 1, .reusable = false}, SHIFT(8008),
  [11160] = {.count = 1, .reusable = false}, SHIFT(8009),
  [11162] = {.count = 1, .reusable = false}, SHIFT(8010),
  [11164] = {.count = 1, .reusable = false}, SHIFT(8011),
  [11166] = {.count = 1, .reusable = true}, SHIFT(8012),
  [11168] = {.count = 1, .reusable = false}, SHIFT(8012),
  [11170] = {.count = 1, .reusable = true}, SHIFT(8013),
  [11172] = {.count = 1, .reusable = false}, SHIFT(5441),
  [11174] = {.count = 1, .reusable = true}, SHIFT(8021),
  [11176] = {.count = 1, .reusable = true}, SHIFT(8023),
  [11178] = {.count = 1, .reusable = true}, SHIFT(8024),
  [11180] = {.count = 1, .reusable = true}, SHIFT(8025),
  [11182] = {.count = 1, .reusable = false}, SHIFT(8027),
  [11184] = {.count = 1, .reusable = false}, SHIFT(8021),
  [11186] = {.count = 1, .reusable = true}, SHIFT(8034),
  [11188] = {.count = 1, .reusable = true}, SHIFT(8035),
  [11190] = {.count = 1, .reusable = false}, SHIFT(8036),
  [11192] = {.count = 1, .reusable = true}, SHIFT(8037),
  [11194] = {.count = 1, .reusable = false}, SHIFT(8038),
  [11196] = {.count = 1, .reusable = false}, SHIFT(8039),
  [11198] = {.count = 1, .reusable = true}, SHIFT(8040),
  [11200] = {.count = 1, .reusable = true}, SHIFT(8041),
  [11202] = {.count = 1, .reusable = false}, SHIFT(8042),
  [11204] = {.count = 1, .reusable = true}, SHIFT(8042),
  [11206] = {.count = 1, .reusable = true}, SHIFT(8044),
  [11208] = {.count = 1, .reusable = true}, SHIFT(8045),
  [11210] = {.count = 1, .reusable = false}, SHIFT(8044),
  [11212] = {.count = 1, .reusable = true}, SHIFT(8039),
  [11214] = {.count = 1, .reusable = true}, SHIFT(8036),
  [11216] = {.count = 1, .reusable = true}, SHIFT(8046),
  [11218] = {.count = 1, .reusable = true}, SHIFT(8047),
  [11220] = {.count = 1, .reusable = true}, SHIFT(8048),
  [11222] = {.count = 1, .reusable = true}, SHIFT(8049),
  [11224] = {.count = 1, .reusable = false}, SHIFT(8051),
  [11226] = {.count = 1, .reusable = true}, SHIFT(8057),
  [11228] = {.count = 1, .reusable = true}, SHIFT(8059),
  [11230] = {.count = 1, .reusable = false}, SHIFT(8059),
  [11232] = {.count = 1, .reusable = true}, SHIFT(8060),
  [11234] = {.count = 1, .reusable = false}, SHIFT(8040),
  [11236] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 5),
  [11238] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 5),
  [11240] = {.count = 1, .reusable = true}, SHIFT(8063),
  [11242] = {.count = 1, .reusable = true}, SHIFT(8064),
  [11244] = {.count = 1, .reusable = true}, SHIFT(8083),
  [11246] = {.count = 1, .reusable = false}, SHIFT(8084),
  [11248] = {.count = 1, .reusable = false}, SHIFT(8085),
  [11250] = {.count = 1, .reusable = false}, SHIFT(8086),
  [11252] = {.count = 1, .reusable = false}, SHIFT(8087),
  [11254] = {.count = 1, .reusable = false}, SHIFT(8088),
  [11256] = {.count = 1, .reusable = true}, SHIFT(8089),
  [11258] = {.count = 1, .reusable = false}, SHIFT(8089),
  [11260] = {.count = 1, .reusable = true}, SHIFT(8090),
  [11262] = {.count = 1, .reusable = false}, SHIFT(8092),
  [11264] = {.count = 1, .reusable = true}, SHIFT(8092),
  [11266] = {.count = 1, .reusable = false}, SHIFT(5485),
  [11268] = {.count = 1, .reusable = true}, SHIFT(8099),
  [11270] = {.count = 1, .reusable = false}, SHIFT(8099),
  [11272] = {.count = 1, .reusable = true}, SHIFT(8103),
  [11274] = {.count = 1, .reusable = true}, SHIFT(8104),
  [11276] = {.count = 1, .reusable = false}, SHIFT(8105),
  [11278] = {.count = 1, .reusable = false}, SHIFT(8106),
  [11280] = {.count = 1, .reusable = false}, SHIFT(8107),
  [11282] = {.count = 1, .reusable = false}, SHIFT(8108),
  [11284] = {.count = 1, .reusable = true}, SHIFT(8109),
  [11286] = {.count = 1, .reusable = true}, SHIFT(8110),
  [11288] = {.count = 1, .reusable = false}, SHIFT(8111),
  [11290] = {.count = 1, .reusable = true}, SHIFT(8111),
  [11292] = {.count = 1, .reusable = false}, SHIFT(8113),
  [11294] = {.count = 1, .reusable = false}, SHIFT(8114),
  [11296] = {.count = 1, .reusable = true}, SHIFT(8113),
  [11298] = {.count = 1, .reusable = true}, SHIFT(8108),
  [11300] = {.count = 1, .reusable = false}, SHIFT(8115),
  [11302] = {.count = 1, .reusable = true}, SHIFT(8117),
  [11304] = {.count = 1, .reusable = true}, SHIFT(8119),
  [11306] = {.count = 1, .reusable = false}, SHIFT(8119),
  [11308] = {.count = 1, .reusable = true}, SHIFT(8120),
  [11310] = {.count = 1, .reusable = false}, SHIFT(8109),
  [11312] = {.count = 1, .reusable = true}, SHIFT(8122),
  [11314] = {.count = 1, .reusable = true}, SHIFT(8123),
  [11316] = {.count = 1, .reusable = false}, SHIFT(8124),
  [11318] = {.count = 1, .reusable = true}, SHIFT(8125),
  [11320] = {.count = 1, .reusable = false}, SHIFT(8125),
  [11322] = {.count = 1, .reusable = true}, SHIFT(8126),
  [11324] = {.count = 1, .reusable = true}, SHIFT(2880),
  [11326] = {.count = 1, .reusable = true}, SHIFT(8157),
  [11328] = {.count = 1, .reusable = true}, SHIFT(2905),
  [11330] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2912),
  [11333] = {.count = 1, .reusable = true}, REDUCE(sym_while, 5),
  [11335] = {.count = 1, .reusable = false}, REDUCE(sym_while, 5),
  [11337] = {.count = 1, .reusable = true}, SHIFT(8183),
  [11339] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(2966),
  [11342] = {.count = 1, .reusable = true}, REDUCE(sym_until, 5),
  [11344] = {.count = 1, .reusable = false}, REDUCE(sym_until, 5),
  [11346] = {.count = 1, .reusable = true}, SHIFT(8203),
  [11348] = {.count = 1, .reusable = false}, SHIFT(8203),
  [11350] = {.count = 1, .reusable = true}, SHIFT(8205),
  [11352] = {.count = 1, .reusable = true}, SHIFT(8207),
  [11354] = {.count = 1, .reusable = false}, SHIFT(8205),
  [11356] = {.count = 1, .reusable = true}, SHIFT(8221),
  [11358] = {.count = 1, .reusable = false}, SHIFT(8222),
  [11360] = {.count = 1, .reusable = false}, SHIFT(8223),
  [11362] = {.count = 1, .reusable = false}, SHIFT(8224),
  [11364] = {.count = 1, .reusable = false}, SHIFT(8225),
  [11366] = {.count = 1, .reusable = false}, SHIFT(8226),
  [11368] = {.count = 1, .reusable = true}, SHIFT(8227),
  [11370] = {.count = 1, .reusable = false}, SHIFT(8227),
  [11372] = {.count = 1, .reusable = true}, SHIFT(8228),
  [11374] = {.count = 1, .reusable = true}, SHIFT(8234),
  [11376] = {.count = 1, .reusable = false}, SHIFT(8234),
  [11378] = {.count = 1, .reusable = true}, SHIFT(8236),
  [11380] = {.count = 1, .reusable = true}, SHIFT(8238),
  [11382] = {.count = 1, .reusable = false}, SHIFT(8236),
  [11384] = {.count = 1, .reusable = true}, SHIFT(3005),
  [11386] = {.count = 1, .reusable = true}, SHIFT(8250),
  [11388] = {.count = 1, .reusable = true}, SHIFT(3030),
  [11390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3046),
  [11393] = {.count = 1, .reusable = true}, REDUCE(sym_for, 5),
  [11395] = {.count = 1, .reusable = false}, REDUCE(sym_for, 5),
  [11397] = {.count = 1, .reusable = true}, SHIFT(8275),
  [11399] = {.count = 1, .reusable = true}, SHIFT(3073),
  [11401] = {.count = 1, .reusable = true}, SHIFT(8300),
  [11403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3095),
  [11406] = {.count = 1, .reusable = true}, REDUCE(sym_case, 5),
  [11408] = {.count = 1, .reusable = false}, REDUCE(sym_case, 5),
  [11410] = {.count = 1, .reusable = true}, SHIFT(8304),
  [11412] = {.count = 1, .reusable = true}, SHIFT(8320),
  [11414] = {.count = 1, .reusable = false}, SHIFT(8321),
  [11416] = {.count = 1, .reusable = true}, SHIFT(8322),
  [11418] = {.count = 1, .reusable = false}, SHIFT(8322),
  [11420] = {.count = 1, .reusable = true}, SHIFT(8323),
  [11422] = {.count = 1, .reusable = true}, SHIFT(8328),
  [11424] = {.count = 1, .reusable = false}, SHIFT(8328),
  [11426] = {.count = 1, .reusable = true}, SHIFT(8330),
  [11428] = {.count = 1, .reusable = true}, SHIFT(8332),
  [11430] = {.count = 1, .reusable = false}, SHIFT(8330),
  [11432] = {.count = 1, .reusable = true}, SHIFT(8335),
  [11434] = {.count = 1, .reusable = false}, REDUCE(sym_when, 3),
  [11436] = {.count = 1, .reusable = false}, SHIFT(8336),
  [11438] = {.count = 1, .reusable = false}, SHIFT(8337),
  [11440] = {.count = 1, .reusable = false}, SHIFT(8338),
  [11442] = {.count = 1, .reusable = false}, SHIFT(8339),
  [11444] = {.count = 1, .reusable = false}, SHIFT(1180),
  [11446] = {.count = 1, .reusable = false}, SHIFT(8340),
  [11448] = {.count = 1, .reusable = true}, SHIFT(8341),
  [11450] = {.count = 1, .reusable = false}, SHIFT(8341),
  [11452] = {.count = 1, .reusable = true}, SHIFT(8342),
  [11454] = {.count = 1, .reusable = false}, SHIFT(8349),
  [11456] = {.count = 1, .reusable = true}, SHIFT(8349),
  [11458] = {.count = 1, .reusable = false}, SHIFT(8343),
  [11460] = {.count = 1, .reusable = true}, SHIFT(8353),
  [11462] = {.count = 1, .reusable = true}, SHIFT(8367),
  [11464] = {.count = 1, .reusable = false}, SHIFT(8368),
  [11466] = {.count = 1, .reusable = false}, SHIFT(8369),
  [11468] = {.count = 1, .reusable = false}, SHIFT(8370),
  [11470] = {.count = 1, .reusable = false}, SHIFT(8371),
  [11472] = {.count = 1, .reusable = false}, SHIFT(8372),
  [11474] = {.count = 1, .reusable = true}, SHIFT(8373),
  [11476] = {.count = 1, .reusable = false}, SHIFT(8373),
  [11478] = {.count = 1, .reusable = true}, SHIFT(8374),
  [11480] = {.count = 1, .reusable = false}, SHIFT(8376),
  [11482] = {.count = 1, .reusable = true}, SHIFT(8376),
  [11484] = {.count = 1, .reusable = true}, SHIFT(8381),
  [11486] = {.count = 1, .reusable = false}, SHIFT(8381),
  [11488] = {.count = 1, .reusable = true}, SHIFT(8383),
  [11490] = {.count = 1, .reusable = true}, SHIFT(8385),
  [11492] = {.count = 1, .reusable = false}, SHIFT(8383),
  [11494] = {.count = 1, .reusable = true}, SHIFT(8387),
  [11496] = {.count = 1, .reusable = true}, SHIFT(3164),
  [11498] = {.count = 1, .reusable = true}, SHIFT(8416),
  [11500] = {.count = 1, .reusable = true}, SHIFT(3188),
  [11502] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3195),
  [11505] = {.count = 1, .reusable = true}, SHIFT(3206),
  [11507] = {.count = 1, .reusable = true}, SHIFT(8446),
  [11509] = {.count = 1, .reusable = false}, SHIFT(8446),
  [11511] = {.count = 1, .reusable = true}, SHIFT(8447),
  [11513] = {.count = 1, .reusable = true}, SHIFT(8448),
  [11515] = {.count = 1, .reusable = true}, SHIFT(8451),
  [11517] = {.count = 1, .reusable = true}, SHIFT(8454),
  [11519] = {.count = 1, .reusable = false}, SHIFT(8455),
  [11521] = {.count = 1, .reusable = false}, SHIFT(8456),
  [11523] = {.count = 1, .reusable = false}, SHIFT(8457),
  [11525] = {.count = 1, .reusable = false}, SHIFT(8458),
  [11527] = {.count = 1, .reusable = false}, SHIFT(8459),
  [11529] = {.count = 1, .reusable = true}, SHIFT(8460),
  [11531] = {.count = 1, .reusable = false}, SHIFT(8460),
  [11533] = {.count = 1, .reusable = true}, SHIFT(8461),
  [11535] = {.count = 1, .reusable = true}, SHIFT(8469),
  [11537] = {.count = 1, .reusable = true}, SHIFT(8470),
  [11539] = {.count = 1, .reusable = true}, SHIFT(8472),
  [11541] = {.count = 1, .reusable = true}, SHIFT(8473),
  [11543] = {.count = 1, .reusable = true}, SHIFT(8474),
  [11545] = {.count = 1, .reusable = false}, SHIFT(5927),
  [11547] = {.count = 1, .reusable = false}, SHIFT(8476),
  [11549] = {.count = 1, .reusable = true}, SHIFT(8481),
  [11551] = {.count = 1, .reusable = false}, SHIFT(8469),
  [11553] = {.count = 1, .reusable = true}, SHIFT(8486),
  [11555] = {.count = 1, .reusable = true}, SHIFT(8487),
  [11557] = {.count = 1, .reusable = false}, SHIFT(8488),
  [11559] = {.count = 1, .reusable = true}, SHIFT(8489),
  [11561] = {.count = 1, .reusable = false}, SHIFT(8490),
  [11563] = {.count = 1, .reusable = false}, SHIFT(8491),
  [11565] = {.count = 1, .reusable = true}, SHIFT(8492),
  [11567] = {.count = 1, .reusable = true}, SHIFT(8493),
  [11569] = {.count = 1, .reusable = false}, SHIFT(8494),
  [11571] = {.count = 1, .reusable = true}, SHIFT(8494),
  [11573] = {.count = 1, .reusable = true}, SHIFT(8495),
  [11575] = {.count = 1, .reusable = true}, SHIFT(8496),
  [11577] = {.count = 1, .reusable = true}, SHIFT(8497),
  [11579] = {.count = 1, .reusable = false}, SHIFT(8496),
  [11581] = {.count = 1, .reusable = true}, SHIFT(8491),
  [11583] = {.count = 1, .reusable = true}, SHIFT(8488),
  [11585] = {.count = 1, .reusable = true}, SHIFT(8498),
  [11587] = {.count = 1, .reusable = true}, SHIFT(8500),
  [11589] = {.count = 1, .reusable = true}, SHIFT(8502),
  [11591] = {.count = 1, .reusable = true}, SHIFT(8504),
  [11593] = {.count = 1, .reusable = false}, SHIFT(8504),
  [11595] = {.count = 1, .reusable = true}, SHIFT(8505),
  [11597] = {.count = 1, .reusable = false}, SHIFT(8492),
  [11599] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 4),
  [11601] = {.count = 1, .reusable = false}, REDUCE(sym_rescue, 4),
  [11603] = {.count = 1, .reusable = true}, SHIFT(8509),
  [11605] = {.count = 1, .reusable = true}, SHIFT(3245),
  [11607] = {.count = 1, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [11609] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3261),
  [11612] = {.count = 1, .reusable = true}, SHIFT(8540),
  [11614] = {.count = 1, .reusable = true}, SHIFT(8541),
  [11616] = {.count = 1, .reusable = false}, SHIFT(8542),
  [11618] = {.count = 1, .reusable = true}, SHIFT(8543),
  [11620] = {.count = 1, .reusable = false}, SHIFT(8544),
  [11622] = {.count = 1, .reusable = false}, SHIFT(8545),
  [11624] = {.count = 1, .reusable = true}, SHIFT(8546),
  [11626] = {.count = 1, .reusable = false}, SHIFT(8547),
  [11628] = {.count = 1, .reusable = true}, SHIFT(8547),
  [11630] = {.count = 1, .reusable = true}, SHIFT(8549),
  [11632] = {.count = 1, .reusable = true}, SHIFT(8550),
  [11634] = {.count = 1, .reusable = false}, SHIFT(8549),
  [11636] = {.count = 1, .reusable = true}, SHIFT(8545),
  [11638] = {.count = 1, .reusable = true}, SHIFT(8542),
  [11640] = {.count = 1, .reusable = true}, SHIFT(8551),
  [11642] = {.count = 1, .reusable = true}, SHIFT(8552),
  [11644] = {.count = 1, .reusable = false}, SHIFT(8552),
  [11646] = {.count = 1, .reusable = true}, SHIFT(8553),
  [11648] = {.count = 1, .reusable = true}, SHIFT(8558),
  [11650] = {.count = 1, .reusable = false}, SHIFT(8558),
  [11652] = {.count = 1, .reusable = true}, SHIFT(8562),
  [11654] = {.count = 1, .reusable = false}, SHIFT(8560),
  [11656] = {.count = 1, .reusable = true}, SHIFT(8579),
  [11658] = {.count = 1, .reusable = false}, SHIFT(8579),
  [11660] = {.count = 1, .reusable = true}, SHIFT(8583),
  [11662] = {.count = 1, .reusable = false}, SHIFT(8581),
  [11664] = {.count = 1, .reusable = true}, SHIFT(3271),
  [11666] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8594),
  [11669] = {.count = 1, .reusable = true}, SHIFT(8595),
  [11671] = {.count = 1, .reusable = true}, SHIFT(8599),
  [11673] = {.count = 1, .reusable = true}, SHIFT(8600),
  [11675] = {.count = 1, .reusable = false}, SHIFT(8601),
  [11677] = {.count = 1, .reusable = false}, SHIFT(8602),
  [11679] = {.count = 1, .reusable = false}, SHIFT(8603),
  [11681] = {.count = 1, .reusable = false}, SHIFT(8604),
  [11683] = {.count = 1, .reusable = true}, SHIFT(8605),
  [11685] = {.count = 1, .reusable = false}, SHIFT(8606),
  [11687] = {.count = 1, .reusable = true}, SHIFT(8606),
  [11689] = {.count = 1, .reusable = false}, SHIFT(8608),
  [11691] = {.count = 1, .reusable = false}, SHIFT(8609),
  [11693] = {.count = 1, .reusable = true}, SHIFT(8608),
  [11695] = {.count = 1, .reusable = true}, SHIFT(8604),
  [11697] = {.count = 1, .reusable = false}, SHIFT(8610),
  [11699] = {.count = 1, .reusable = true}, SHIFT(8611),
  [11701] = {.count = 1, .reusable = false}, SHIFT(8611),
  [11703] = {.count = 1, .reusable = true}, SHIFT(8612),
  [11705] = {.count = 1, .reusable = true}, SHIFT(3313),
  [11707] = {.count = 1, .reusable = true}, SHIFT(8640),
  [11709] = {.count = 1, .reusable = true}, SHIFT(8641),
  [11711] = {.count = 1, .reusable = false}, SHIFT(8642),
  [11713] = {.count = 1, .reusable = true}, SHIFT(8643),
  [11715] = {.count = 1, .reusable = false}, SHIFT(8644),
  [11717] = {.count = 1, .reusable = false}, SHIFT(8645),
  [11719] = {.count = 1, .reusable = true}, SHIFT(8646),
  [11721] = {.count = 1, .reusable = false}, SHIFT(8647),
  [11723] = {.count = 1, .reusable = true}, SHIFT(8647),
  [11725] = {.count = 1, .reusable = true}, SHIFT(8649),
  [11727] = {.count = 1, .reusable = true}, SHIFT(8650),
  [11729] = {.count = 1, .reusable = false}, SHIFT(8649),
  [11731] = {.count = 1, .reusable = true}, SHIFT(8645),
  [11733] = {.count = 1, .reusable = true}, SHIFT(8642),
  [11735] = {.count = 1, .reusable = true}, SHIFT(8651),
  [11737] = {.count = 1, .reusable = true}, SHIFT(8652),
  [11739] = {.count = 1, .reusable = true}, SHIFT(8654),
  [11741] = {.count = 1, .reusable = false}, SHIFT(8654),
  [11743] = {.count = 1, .reusable = true}, SHIFT(8655),
  [11745] = {.count = 1, .reusable = true}, SHIFT(8661),
  [11747] = {.count = 1, .reusable = true}, SHIFT(8662),
  [11749] = {.count = 1, .reusable = false}, SHIFT(8663),
  [11751] = {.count = 1, .reusable = true}, SHIFT(8664),
  [11753] = {.count = 1, .reusable = false}, SHIFT(8665),
  [11755] = {.count = 1, .reusable = false}, SHIFT(8666),
  [11757] = {.count = 1, .reusable = true}, SHIFT(8667),
  [11759] = {.count = 1, .reusable = false}, SHIFT(8668),
  [11761] = {.count = 1, .reusable = true}, SHIFT(8668),
  [11763] = {.count = 1, .reusable = true}, SHIFT(8670),
  [11765] = {.count = 1, .reusable = true}, SHIFT(8671),
  [11767] = {.count = 1, .reusable = false}, SHIFT(8670),
  [11769] = {.count = 1, .reusable = true}, SHIFT(8666),
  [11771] = {.count = 1, .reusable = true}, SHIFT(8663),
  [11773] = {.count = 1, .reusable = true}, SHIFT(8672),
  [11775] = {.count = 1, .reusable = true}, SHIFT(8673),
  [11777] = {.count = 1, .reusable = false}, SHIFT(8673),
  [11779] = {.count = 1, .reusable = true}, SHIFT(8674),
  [11781] = {.count = 1, .reusable = true}, SHIFT(8679),
  [11783] = {.count = 1, .reusable = false}, SHIFT(8679),
  [11785] = {.count = 1, .reusable = true}, SHIFT(8683),
  [11787] = {.count = 1, .reusable = false}, SHIFT(8681),
  [11789] = {.count = 1, .reusable = true}, SHIFT(8700),
  [11791] = {.count = 1, .reusable = false}, SHIFT(8700),
  [11793] = {.count = 1, .reusable = true}, SHIFT(8704),
  [11795] = {.count = 1, .reusable = false}, SHIFT(8702),
  [11797] = {.count = 1, .reusable = true}, SHIFT(3338),
  [11799] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(8715),
  [11802] = {.count = 1, .reusable = true}, SHIFT(8716),
  [11804] = {.count = 1, .reusable = true}, SHIFT(8720),
  [11806] = {.count = 1, .reusable = true}, SHIFT(8721),
  [11808] = {.count = 1, .reusable = false}, SHIFT(8722),
  [11810] = {.count = 1, .reusable = false}, SHIFT(8723),
  [11812] = {.count = 1, .reusable = false}, SHIFT(8724),
  [11814] = {.count = 1, .reusable = false}, SHIFT(8725),
  [11816] = {.count = 1, .reusable = true}, SHIFT(8726),
  [11818] = {.count = 1, .reusable = false}, SHIFT(8727),
  [11820] = {.count = 1, .reusable = true}, SHIFT(8727),
  [11822] = {.count = 1, .reusable = false}, SHIFT(8729),
  [11824] = {.count = 1, .reusable = false}, SHIFT(8730),
  [11826] = {.count = 1, .reusable = true}, SHIFT(8729),
  [11828] = {.count = 1, .reusable = true}, SHIFT(8725),
  [11830] = {.count = 1, .reusable = false}, SHIFT(8731),
  [11832] = {.count = 1, .reusable = true}, SHIFT(8732),
  [11834] = {.count = 1, .reusable = false}, SHIFT(8732),
  [11836] = {.count = 1, .reusable = true}, SHIFT(8733),
  [11838] = {.count = 1, .reusable = true}, SHIFT(3380),
  [11840] = {.count = 1, .reusable = true}, SHIFT(8761),
  [11842] = {.count = 1, .reusable = true}, SHIFT(8762),
  [11844] = {.count = 1, .reusable = false}, SHIFT(8763),
  [11846] = {.count = 1, .reusable = true}, SHIFT(8764),
  [11848] = {.count = 1, .reusable = false}, SHIFT(8765),
  [11850] = {.count = 1, .reusable = false}, SHIFT(8766),
  [11852] = {.count = 1, .reusable = true}, SHIFT(8767),
  [11854] = {.count = 1, .reusable = false}, SHIFT(8768),
  [11856] = {.count = 1, .reusable = true}, SHIFT(8768),
  [11858] = {.count = 1, .reusable = true}, SHIFT(8770),
  [11860] = {.count = 1, .reusable = true}, SHIFT(8771),
  [11862] = {.count = 1, .reusable = false}, SHIFT(8770),
  [11864] = {.count = 1, .reusable = true}, SHIFT(8766),
  [11866] = {.count = 1, .reusable = true}, SHIFT(8763),
  [11868] = {.count = 1, .reusable = true}, SHIFT(8772),
  [11870] = {.count = 1, .reusable = true}, SHIFT(8773),
  [11872] = {.count = 1, .reusable = true}, SHIFT(8775),
  [11874] = {.count = 1, .reusable = false}, SHIFT(8775),
  [11876] = {.count = 1, .reusable = true}, SHIFT(8776),
  [11878] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 4),
  [11880] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 4),
  [11882] = {.count = 1, .reusable = true}, SHIFT(8777),
  [11884] = {.count = 1, .reusable = true}, SHIFT(8795),
  [11886] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3456),
  [11889] = {.count = 1, .reusable = true}, SHIFT(8813),
  [11891] = {.count = 1, .reusable = true}, SHIFT(8814),
  [11893] = {.count = 1, .reusable = true}, SHIFT(8815),
  [11895] = {.count = 1, .reusable = true}, SHIFT(8816),
  [11897] = {.count = 1, .reusable = true}, SHIFT(8817),
  [11899] = {.count = 1, .reusable = true}, SHIFT(8818),
  [11901] = {.count = 1, .reusable = true}, SHIFT(8822),
  [11903] = {.count = 1, .reusable = true}, SHIFT(8823),
  [11905] = {.count = 1, .reusable = false}, SHIFT(8824),
  [11907] = {.count = 1, .reusable = true}, SHIFT(8825),
  [11909] = {.count = 1, .reusable = false}, SHIFT(8826),
  [11911] = {.count = 1, .reusable = false}, SHIFT(8827),
  [11913] = {.count = 1, .reusable = true}, SHIFT(8828),
  [11915] = {.count = 1, .reusable = false}, SHIFT(8829),
  [11917] = {.count = 1, .reusable = true}, SHIFT(8829),
  [11919] = {.count = 1, .reusable = true}, SHIFT(8831),
  [11921] = {.count = 1, .reusable = true}, SHIFT(8832),
  [11923] = {.count = 1, .reusable = false}, SHIFT(8831),
  [11925] = {.count = 1, .reusable = true}, SHIFT(8827),
  [11927] = {.count = 1, .reusable = true}, SHIFT(8824),
  [11929] = {.count = 1, .reusable = true}, SHIFT(8833),
  [11931] = {.count = 1, .reusable = true}, SHIFT(8834),
  [11933] = {.count = 1, .reusable = false}, SHIFT(8834),
  [11935] = {.count = 1, .reusable = true}, SHIFT(8835),
  [11937] = {.count = 1, .reusable = true}, SHIFT(3495),
  [11939] = {.count = 1, .reusable = true}, SHIFT(8842),
  [11941] = {.count = 1, .reusable = true}, SHIFT(8846),
  [11943] = {.count = 1, .reusable = true}, SHIFT(8847),
  [11945] = {.count = 1, .reusable = false}, SHIFT(8848),
  [11947] = {.count = 1, .reusable = false}, SHIFT(8849),
  [11949] = {.count = 1, .reusable = false}, SHIFT(8850),
  [11951] = {.count = 1, .reusable = false}, SHIFT(8851),
  [11953] = {.count = 1, .reusable = true}, SHIFT(8852),
  [11955] = {.count = 1, .reusable = false}, SHIFT(8853),
  [11957] = {.count = 1, .reusable = true}, SHIFT(8853),
  [11959] = {.count = 1, .reusable = false}, SHIFT(8855),
  [11961] = {.count = 1, .reusable = false}, SHIFT(8856),
  [11963] = {.count = 1, .reusable = true}, SHIFT(8855),
  [11965] = {.count = 1, .reusable = true}, SHIFT(8851),
  [11967] = {.count = 1, .reusable = false}, SHIFT(8857),
  [11969] = {.count = 1, .reusable = true}, SHIFT(8858),
  [11971] = {.count = 1, .reusable = false}, SHIFT(8858),
  [11973] = {.count = 1, .reusable = true}, SHIFT(8859),
  [11975] = {.count = 1, .reusable = true}, SHIFT(3518),
  [11977] = {.count = 1, .reusable = true}, SHIFT(8870),
  [11979] = {.count = 1, .reusable = false}, SHIFT(8871),
  [11981] = {.count = 1, .reusable = false}, SHIFT(8872),
  [11983] = {.count = 1, .reusable = true}, SHIFT(8873),
  [11985] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3560),
  [11988] = {.count = 1, .reusable = true}, SHIFT(8876),
  [11990] = {.count = 1, .reusable = false}, SHIFT(8876),
  [11992] = {.count = 1, .reusable = true}, SHIFT(8879),
  [11994] = {.count = 1, .reusable = true}, SHIFT(8881),
  [11996] = {.count = 1, .reusable = true}, SHIFT(8882),
  [11998] = {.count = 1, .reusable = false}, SHIFT(8883),
  [12000] = {.count = 1, .reusable = true}, SHIFT(8885),
  [12002] = {.count = 1, .reusable = true}, SHIFT(8887),
  [12004] = {.count = 1, .reusable = true}, SHIFT(8889),
  [12006] = {.count = 1, .reusable = true}, SHIFT(8890),
  [12008] = {.count = 1, .reusable = false}, SHIFT(8890),
  [12010] = {.count = 1, .reusable = true}, SHIFT(8892),
  [12012] = {.count = 1, .reusable = true}, SHIFT(8894),
  [12014] = {.count = 1, .reusable = true}, SHIFT(8896),
  [12016] = {.count = 1, .reusable = true}, SHIFT(8897),
  [12018] = {.count = 1, .reusable = true}, SHIFT(8898),
  [12020] = {.count = 1, .reusable = false}, SHIFT(8898),
  [12022] = {.count = 1, .reusable = true}, SHIFT(8900),
  [12024] = {.count = 1, .reusable = true}, SHIFT(8901),
  [12026] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(3639),
  [12029] = {.count = 1, .reusable = true}, SHIFT(8904),
  [12031] = {.count = 1, .reusable = true}, REDUCE(sym__argument_list_with_trailing_comma, 4),
  [12033] = {.count = 1, .reusable = true}, SHIFT(6459),
  [12035] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 3),
  [12037] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 3),
  [12039] = {.count = 1, .reusable = true}, SHIFT(8907),
  [12041] = {.count = 1, .reusable = true}, SHIFT(8908),
  [12043] = {.count = 1, .reusable = true}, SHIFT(8909),
  [12045] = {.count = 1, .reusable = true}, SHIFT(8911),
  [12047] = {.count = 1, .reusable = false}, SHIFT(8912),
  [12049] = {.count = 1, .reusable = false}, SHIFT(8913),
  [12051] = {.count = 1, .reusable = false}, SHIFT(8914),
  [12053] = {.count = 1, .reusable = false}, SHIFT(8915),
  [12055] = {.count = 1, .reusable = false}, SHIFT(8916),
  [12057] = {.count = 1, .reusable = true}, SHIFT(8917),
  [12059] = {.count = 1, .reusable = false}, SHIFT(8917),
  [12061] = {.count = 1, .reusable = true}, SHIFT(8918),
  [12063] = {.count = 1, .reusable = false}, SHIFT(8920),
  [12065] = {.count = 1, .reusable = true}, SHIFT(8920),
  [12067] = {.count = 1, .reusable = true}, SHIFT(8925),
  [12069] = {.count = 1, .reusable = true}, SHIFT(8926),
  [12071] = {.count = 1, .reusable = true}, REDUCE(sym_block, 4),
  [12073] = {.count = 1, .reusable = false}, REDUCE(sym_block, 4),
  [12075] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 3),
  [12077] = {.count = 1, .reusable = true}, SHIFT(8928),
  [12079] = {.count = 1, .reusable = true}, SHIFT(7411),
  [12081] = {.count = 1, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2),
  [12083] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 4),
  [12085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(3665),
  [12088] = {.count = 1, .reusable = true}, SHIFT(8929),
  [12090] = {.count = 1, .reusable = true}, SHIFT(8930),
  [12092] = {.count = 1, .reusable = true}, SHIFT(8932),
  [12094] = {.count = 1, .reusable = true}, SHIFT(8933),
  [12096] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 4),
  [12098] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 4),
  [12100] = {.count = 1, .reusable = true}, SHIFT(8934),
  [12102] = {.count = 1, .reusable = false}, SHIFT(8934),
  [12104] = {.count = 1, .reusable = true}, SHIFT(8948),
  [12106] = {.count = 1, .reusable = true}, SHIFT(8949),
  [12108] = {.count = 1, .reusable = true}, SHIFT(8959),
  [12110] = {.count = 1, .reusable = true}, SHIFT(8960),
  [12112] = {.count = 1, .reusable = false}, SHIFT(8961),
  [12114] = {.count = 1, .reusable = true}, SHIFT(8962),
  [12116] = {.count = 1, .reusable = false}, SHIFT(8963),
  [12118] = {.count = 1, .reusable = false}, SHIFT(8964),
  [12120] = {.count = 1, .reusable = true}, SHIFT(8965),
  [12122] = {.count = 1, .reusable = false}, SHIFT(8966),
  [12124] = {.count = 1, .reusable = true}, SHIFT(8966),
  [12126] = {.count = 1, .reusable = true}, SHIFT(8968),
  [12128] = {.count = 1, .reusable = true}, SHIFT(8969),
  [12130] = {.count = 1, .reusable = false}, SHIFT(8968),
  [12132] = {.count = 1, .reusable = true}, SHIFT(8964),
  [12134] = {.count = 1, .reusable = true}, SHIFT(8961),
  [12136] = {.count = 1, .reusable = true}, SHIFT(8970),
  [12138] = {.count = 1, .reusable = true}, SHIFT(8971),
  [12140] = {.count = 1, .reusable = false}, SHIFT(8971),
  [12142] = {.count = 1, .reusable = true}, SHIFT(8972),
  [12144] = {.count = 1, .reusable = true}, SHIFT(8974),
  [12146] = {.count = 1, .reusable = true}, SHIFT(8979),
  [12148] = {.count = 1, .reusable = false}, SHIFT(8979),
  [12150] = {.count = 1, .reusable = true}, SHIFT(8983),
  [12152] = {.count = 1, .reusable = false}, SHIFT(8981),
  [12154] = {.count = 1, .reusable = true}, SHIFT(9000),
  [12156] = {.count = 1, .reusable = false}, SHIFT(9000),
  [12158] = {.count = 1, .reusable = true}, SHIFT(9004),
  [12160] = {.count = 1, .reusable = false}, SHIFT(9002),
  [12162] = {.count = 1, .reusable = true}, SHIFT(3700),
  [12164] = {.count = 1, .reusable = true}, SHIFT(9014),
  [12166] = {.count = 1, .reusable = true}, REDUCE(sym_conditional, 5),
  [12168] = {.count = 1, .reusable = true}, SHIFT(9018),
  [12170] = {.count = 1, .reusable = true}, SHIFT(9019),
  [12172] = {.count = 1, .reusable = false}, SHIFT(9020),
  [12174] = {.count = 1, .reusable = false}, SHIFT(9021),
  [12176] = {.count = 1, .reusable = false}, SHIFT(9022),
  [12178] = {.count = 1, .reusable = false}, SHIFT(9023),
  [12180] = {.count = 1, .reusable = true}, SHIFT(9024),
  [12182] = {.count = 1, .reusable = false}, SHIFT(9025),
  [12184] = {.count = 1, .reusable = true}, SHIFT(9025),
  [12186] = {.count = 1, .reusable = false}, SHIFT(9027),
  [12188] = {.count = 1, .reusable = false}, SHIFT(9028),
  [12190] = {.count = 1, .reusable = true}, SHIFT(9027),
  [12192] = {.count = 1, .reusable = true}, SHIFT(9023),
  [12194] = {.count = 1, .reusable = false}, SHIFT(9029),
  [12196] = {.count = 1, .reusable = true}, SHIFT(9030),
  [12198] = {.count = 1, .reusable = false}, SHIFT(9030),
  [12200] = {.count = 1, .reusable = true}, SHIFT(9031),
  [12202] = {.count = 1, .reusable = true}, SHIFT(9033),
  [12204] = {.count = 1, .reusable = true}, SHIFT(3735),
  [12206] = {.count = 1, .reusable = true}, SHIFT(9061),
  [12208] = {.count = 1, .reusable = true}, SHIFT(9062),
  [12210] = {.count = 1, .reusable = false}, SHIFT(9063),
  [12212] = {.count = 1, .reusable = true}, SHIFT(9064),
  [12214] = {.count = 1, .reusable = false}, SHIFT(9065),
  [12216] = {.count = 1, .reusable = false}, SHIFT(9066),
  [12218] = {.count = 1, .reusable = true}, SHIFT(9067),
  [12220] = {.count = 1, .reusable = false}, SHIFT(9068),
  [12222] = {.count = 1, .reusable = true}, SHIFT(9068),
  [12224] = {.count = 1, .reusable = true}, SHIFT(9070),
  [12226] = {.count = 1, .reusable = true}, SHIFT(9071),
  [12228] = {.count = 1, .reusable = false}, SHIFT(9070),
  [12230] = {.count = 1, .reusable = true}, SHIFT(9066),
  [12232] = {.count = 1, .reusable = true}, SHIFT(9063),
  [12234] = {.count = 1, .reusable = true}, SHIFT(9072),
  [12236] = {.count = 1, .reusable = true}, SHIFT(9073),
  [12238] = {.count = 1, .reusable = true}, SHIFT(9075),
  [12240] = {.count = 1, .reusable = false}, SHIFT(9075),
  [12242] = {.count = 1, .reusable = true}, SHIFT(9076),
  [12244] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1489),
  [12247] = {.count = 1, .reusable = true}, SHIFT(9078),
  [12249] = {.count = 1, .reusable = true}, REDUCE(sym_element_reference, 5),
  [12251] = {.count = 1, .reusable = false}, REDUCE(sym_element_reference, 5),
  [12253] = {.count = 1, .reusable = true}, SHIFT(9079),
  [12255] = {.count = 1, .reusable = true}, SHIFT(9080),
  [12257] = {.count = 1, .reusable = true}, SHIFT(9081),
  [12259] = {.count = 1, .reusable = true}, SHIFT(9082),
  [12261] = {.count = 1, .reusable = true}, SHIFT(9083),
  [12263] = {.count = 1, .reusable = true}, SHIFT(9084),
  [12265] = {.count = 1, .reusable = true}, SHIFT(9085),
  [12267] = {.count = 1, .reusable = true}, SHIFT(9086),
  [12269] = {.count = 1, .reusable = true}, SHIFT(9087),
  [12271] = {.count = 1, .reusable = true}, SHIFT(9089),
  [12273] = {.count = 1, .reusable = true}, SHIFT(9090),
  [12275] = {.count = 1, .reusable = true}, SHIFT(9091),
  [12277] = {.count = 1, .reusable = true}, SHIFT(9092),
  [12279] = {.count = 1, .reusable = true}, SHIFT(9093),
  [12281] = {.count = 1, .reusable = true}, SHIFT(9095),
  [12283] = {.count = 1, .reusable = true}, SHIFT(9096),
  [12285] = {.count = 1, .reusable = true}, SHIFT(9097),
  [12287] = {.count = 1, .reusable = true}, SHIFT(9098),
  [12289] = {.count = 1, .reusable = true}, SHIFT(3800),
  [12291] = {.count = 1, .reusable = false}, SHIFT(9100),
  [12293] = {.count = 1, .reusable = true}, SHIFT(9101),
  [12295] = {.count = 1, .reusable = true}, SHIFT(9102),
  [12297] = {.count = 1, .reusable = false}, SHIFT(9103),
  [12299] = {.count = 1, .reusable = false}, SHIFT(9104),
  [12301] = {.count = 1, .reusable = true}, SHIFT(9108),
  [12303] = {.count = 1, .reusable = false}, SHIFT(9105),
  [12305] = {.count = 1, .reusable = false}, SHIFT(9109),
  [12307] = {.count = 1, .reusable = false}, SHIFT(9112),
  [12309] = {.count = 1, .reusable = false}, SHIFT(9114),
  [12311] = {.count = 1, .reusable = true}, SHIFT(9116),
  [12313] = {.count = 1, .reusable = true}, SHIFT(9118),
  [12315] = {.count = 1, .reusable = true}, SHIFT(9119),
  [12317] = {.count = 1, .reusable = true}, SHIFT(9120),
  [12319] = {.count = 1, .reusable = true}, SHIFT(9123),
  [12321] = {.count = 1, .reusable = true}, SHIFT(9124),
  [12323] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(1533),
  [12326] = {.count = 1, .reusable = true}, SHIFT(3857),
  [12328] = {.count = 1, .reusable = true}, SHIFT(9133),
  [12330] = {.count = 1, .reusable = true}, SHIFT(3882),
  [12332] = {.count = 1, .reusable = true}, SHIFT(9144),
  [12334] = {.count = 1, .reusable = true}, SHIFT(9145),
  [12336] = {.count = 1, .reusable = false}, SHIFT(9146),
  [12338] = {.count = 1, .reusable = true}, SHIFT(9147),
  [12340] = {.count = 1, .reusable = false}, SHIFT(9148),
  [12342] = {.count = 1, .reusable = false}, SHIFT(9149),
  [12344] = {.count = 1, .reusable = true}, SHIFT(9150),
  [12346] = {.count = 1, .reusable = false}, SHIFT(9151),
  [12348] = {.count = 1, .reusable = true}, SHIFT(9151),
  [12350] = {.count = 1, .reusable = true}, SHIFT(9153),
  [12352] = {.count = 1, .reusable = true}, SHIFT(9154),
  [12354] = {.count = 1, .reusable = false}, SHIFT(9153),
  [12356] = {.count = 1, .reusable = true}, SHIFT(9149),
  [12358] = {.count = 1, .reusable = true}, SHIFT(9146),
  [12360] = {.count = 1, .reusable = true}, SHIFT(9155),
  [12362] = {.count = 1, .reusable = true}, SHIFT(9156),
  [12364] = {.count = 1, .reusable = true}, SHIFT(9158),
  [12366] = {.count = 1, .reusable = false}, SHIFT(9158),
  [12368] = {.count = 1, .reusable = true}, SHIFT(9159),
  [12370] = {.count = 1, .reusable = true}, SHIFT(9160),
  [12372] = {.count = 1, .reusable = false}, SHIFT(9161),
  [12374] = {.count = 1, .reusable = false}, SHIFT(9162),
  [12376] = {.count = 1, .reusable = true}, SHIFT(9163),
  [12378] = {.count = 1, .reusable = false}, SHIFT(9163),
  [12380] = {.count = 1, .reusable = true}, SHIFT(9166),
  [12382] = {.count = 1, .reusable = true}, SHIFT(9168),
  [12384] = {.count = 1, .reusable = true}, SHIFT(9169),
  [12386] = {.count = 1, .reusable = false}, SHIFT(9170),
  [12388] = {.count = 1, .reusable = true}, SHIFT(9172),
  [12390] = {.count = 1, .reusable = false}, SHIFT(9172),
  [12392] = {.count = 1, .reusable = true}, SHIFT(9174),
  [12394] = {.count = 1, .reusable = true}, SHIFT(9176),
  [12396] = {.count = 1, .reusable = true}, SHIFT(6783),
  [12398] = {.count = 1, .reusable = true}, SHIFT(9181),
  [12400] = {.count = 1, .reusable = false}, REDUCE(aux_sym_exceptions_repeat1, 2),
  [12402] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(3967),
  [12405] = {.count = 1, .reusable = true}, SHIFT(3992),
  [12407] = {.count = 1, .reusable = true}, SHIFT(9206),
  [12409] = {.count = 1, .reusable = true}, SHIFT(4016),
  [12411] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4023),
  [12414] = {.count = 2, .reusable = true}, REDUCE(aux_sym_undef_repeat1, 2), SHIFT_REPEAT(4029),
  [12417] = {.count = 1, .reusable = true}, SHIFT(9216),
  [12419] = {.count = 1, .reusable = true}, SHIFT(9218),
  [12421] = {.count = 1, .reusable = true}, SHIFT(9219),
  [12423] = {.count = 1, .reusable = true}, SHIFT(9220),
  [12425] = {.count = 1, .reusable = true}, SHIFT(9221),
  [12427] = {.count = 1, .reusable = true}, SHIFT(9222),
  [12429] = {.count = 1, .reusable = true}, SHIFT(9223),
  [12431] = {.count = 1, .reusable = false}, SHIFT(9224),
  [12433] = {.count = 1, .reusable = true}, SHIFT(9226),
  [12435] = {.count = 1, .reusable = true}, SHIFT(9227),
  [12437] = {.count = 1, .reusable = true}, SHIFT(9229),
  [12439] = {.count = 1, .reusable = false}, SHIFT(9230),
  [12441] = {.count = 1, .reusable = true}, SHIFT(9232),
  [12443] = {.count = 1, .reusable = true}, SHIFT(9233),
  [12445] = {.count = 1, .reusable = true}, SHIFT(9235),
  [12447] = {.count = 1, .reusable = true}, SHIFT(9238),
  [12449] = {.count = 1, .reusable = true}, SHIFT(9239),
  [12451] = {.count = 1, .reusable = true}, SHIFT(9240),
  [12453] = {.count = 1, .reusable = true}, SHIFT(9243),
  [12455] = {.count = 1, .reusable = true}, SHIFT(9245),
  [12457] = {.count = 1, .reusable = false}, SHIFT(9244),
  [12459] = {.count = 1, .reusable = true}, SHIFT(9246),
  [12461] = {.count = 1, .reusable = true}, SHIFT(9247),
  [12463] = {.count = 1, .reusable = true}, SHIFT(9248),
  [12465] = {.count = 1, .reusable = true}, SHIFT(9249),
  [12467] = {.count = 1, .reusable = true}, SHIFT(9251),
  [12469] = {.count = 1, .reusable = true}, SHIFT(9253),
  [12471] = {.count = 1, .reusable = true}, SHIFT(9254),
  [12473] = {.count = 1, .reusable = false}, SHIFT(9258),
  [12475] = {.count = 1, .reusable = true}, SHIFT(9259),
  [12477] = {.count = 1, .reusable = true}, SHIFT(9279),
  [12479] = {.count = 1, .reusable = true}, SHIFT(9280),
  [12481] = {.count = 1, .reusable = false}, SHIFT(9280),
  [12483] = {.count = 1, .reusable = true}, SHIFT(9282),
  [12485] = {.count = 1, .reusable = true}, SHIFT(9283),
  [12487] = {.count = 1, .reusable = true}, SHIFT(9284),
  [12489] = {.count = 1, .reusable = true}, SHIFT(9285),
  [12491] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(4126),
  [12494] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4128),
  [12497] = {.count = 1, .reusable = true}, REDUCE(sym_string_array, 6, .alias_sequence_id = 32),
  [12499] = {.count = 1, .reusable = false}, REDUCE(sym_string_array, 6, .alias_sequence_id = 32),
  [12501] = {.count = 1, .reusable = true}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 33),
  [12503] = {.count = 1, .reusable = false}, REDUCE(sym_symbol_array, 6, .alias_sequence_id = 33),
  [12505] = {.count = 1, .reusable = true}, SHIFT(9325),
  [12507] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4192),
  [12510] = {.count = 1, .reusable = true}, SHIFT(9345),
  [12512] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4251),
  [12515] = {.count = 1, .reusable = true}, SHIFT(9363),
  [12517] = {.count = 1, .reusable = true}, SHIFT(9364),
  [12519] = {.count = 1, .reusable = true}, SHIFT(4299),
  [12521] = {.count = 1, .reusable = true}, SHIFT(9387),
  [12523] = {.count = 1, .reusable = true}, SHIFT(4323),
  [12525] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4330),
  [12528] = {.count = 1, .reusable = true}, SHIFT(9397),
  [12530] = {.count = 1, .reusable = true}, SHIFT(9399),
  [12532] = {.count = 1, .reusable = true}, SHIFT(9416),
  [12534] = {.count = 1, .reusable = true}, SHIFT(9417),
  [12536] = {.count = 1, .reusable = false}, SHIFT(9417),
  [12538] = {.count = 1, .reusable = true}, SHIFT(9419),
  [12540] = {.count = 1, .reusable = true}, SHIFT(9420),
  [12542] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4399),
  [12545] = {.count = 1, .reusable = true}, SHIFT(7219),
  [12547] = {.count = 1, .reusable = true}, SHIFT(7229),
  [12549] = {.count = 1, .reusable = true}, SHIFT(9427),
  [12551] = {.count = 1, .reusable = true}, SHIFT(9429),
  [12553] = {.count = 1, .reusable = true}, SHIFT(9430),
  [12555] = {.count = 1, .reusable = true}, SHIFT(9431),
  [12557] = {.count = 1, .reusable = true}, SHIFT(9432),
  [12559] = {.count = 1, .reusable = true}, SHIFT(9433),
  [12561] = {.count = 1, .reusable = false}, SHIFT(9433),
  [12563] = {.count = 1, .reusable = true}, SHIFT(9435),
  [12565] = {.count = 1, .reusable = true}, SHIFT(9436),
  [12567] = {.count = 1, .reusable = true}, SHIFT(9437),
  [12569] = {.count = 1, .reusable = true}, SHIFT(9438),
  [12571] = {.count = 1, .reusable = true}, SHIFT(9439),
  [12573] = {.count = 1, .reusable = true}, SHIFT(9440),
  [12575] = {.count = 1, .reusable = true}, SHIFT(9441),
  [12577] = {.count = 1, .reusable = true}, SHIFT(9442),
  [12579] = {.count = 1, .reusable = false}, SHIFT(9443),
  [12581] = {.count = 1, .reusable = false}, SHIFT(9444),
  [12583] = {.count = 1, .reusable = true}, SHIFT(9445),
  [12585] = {.count = 1, .reusable = false}, SHIFT(9445),
  [12587] = {.count = 1, .reusable = true}, SHIFT(9448),
  [12589] = {.count = 1, .reusable = true}, SHIFT(9450),
  [12591] = {.count = 1, .reusable = true}, SHIFT(9451),
  [12593] = {.count = 1, .reusable = false}, SHIFT(9452),
  [12595] = {.count = 1, .reusable = true}, SHIFT(9454),
  [12597] = {.count = 1, .reusable = false}, SHIFT(9454),
  [12599] = {.count = 1, .reusable = true}, SHIFT(9456),
  [12601] = {.count = 1, .reusable = true}, SHIFT(9458),
  [12603] = {.count = 1, .reusable = true}, SHIFT(7299),
  [12605] = {.count = 1, .reusable = true}, SHIFT(9463),
  [12607] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4571),
  [12610] = {.count = 1, .reusable = true}, SHIFT(9479),
  [12612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4606),
  [12615] = {.count = 1, .reusable = true}, REDUCE(sym_singleton_method, 6),
  [12617] = {.count = 1, .reusable = false}, REDUCE(sym_singleton_method, 6),
  [12619] = {.count = 1, .reusable = true}, SHIFT(9499),
  [12621] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4657),
  [12624] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 4),
  [12626] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 4),
  [12628] = {.count = 1, .reusable = true}, SHIFT(9518),
  [12630] = {.count = 1, .reusable = true}, SHIFT(9519),
  [12632] = {.count = 1, .reusable = true}, SHIFT(9521),
  [12634] = {.count = 1, .reusable = true}, SHIFT(9523),
  [12636] = {.count = 1, .reusable = false}, SHIFT(9521),
  [12638] = {.count = 1, .reusable = true}, SHIFT(9525),
  [12640] = {.count = 1, .reusable = true}, SHIFT(9531),
  [12642] = {.count = 1, .reusable = false}, SHIFT(9531),
  [12644] = {.count = 1, .reusable = true}, SHIFT(9533),
  [12646] = {.count = 1, .reusable = true}, SHIFT(9535),
  [12648] = {.count = 1, .reusable = false}, SHIFT(9533),
  [12650] = {.count = 1, .reusable = true}, SHIFT(4709),
  [12652] = {.count = 1, .reusable = true}, SHIFT(9559),
  [12654] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4731),
  [12657] = {.count = 1, .reusable = true}, SHIFT(9564),
  [12659] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4763),
  [12662] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(4784),
  [12665] = {.count = 1, .reusable = true}, SHIFT(7521),
  [12667] = {.count = 1, .reusable = true}, SHIFT(9569),
  [12669] = {.count = 1, .reusable = true}, SHIFT(7541),
  [12671] = {.count = 1, .reusable = true}, SHIFT(9574),
  [12673] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(4853),
  [12676] = {.count = 1, .reusable = true}, SHIFT(9575),
  [12678] = {.count = 1, .reusable = true}, SHIFT(9576),
  [12680] = {.count = 1, .reusable = true}, SHIFT(4881),
  [12682] = {.count = 1, .reusable = true}, SHIFT(9584),
  [12684] = {.count = 1, .reusable = true}, SHIFT(9588),
  [12686] = {.count = 1, .reusable = true}, SHIFT(9589),
  [12688] = {.count = 1, .reusable = false}, SHIFT(9590),
  [12690] = {.count = 1, .reusable = false}, SHIFT(9591),
  [12692] = {.count = 1, .reusable = false}, SHIFT(9592),
  [12694] = {.count = 1, .reusable = false}, SHIFT(9593),
  [12696] = {.count = 1, .reusable = true}, SHIFT(9594),
  [12698] = {.count = 1, .reusable = false}, SHIFT(9595),
  [12700] = {.count = 1, .reusable = true}, SHIFT(9595),
  [12702] = {.count = 1, .reusable = false}, SHIFT(9597),
  [12704] = {.count = 1, .reusable = false}, SHIFT(9598),
  [12706] = {.count = 1, .reusable = true}, SHIFT(9597),
  [12708] = {.count = 1, .reusable = true}, SHIFT(9593),
  [12710] = {.count = 1, .reusable = false}, SHIFT(9599),
  [12712] = {.count = 1, .reusable = true}, SHIFT(9600),
  [12714] = {.count = 1, .reusable = false}, SHIFT(9600),
  [12716] = {.count = 1, .reusable = true}, SHIFT(9601),
  [12718] = {.count = 1, .reusable = true}, SHIFT(4904),
  [12720] = {.count = 1, .reusable = true}, SHIFT(9611),
  [12722] = {.count = 1, .reusable = true}, SHIFT(9613),
  [12724] = {.count = 1, .reusable = true}, SHIFT(9614),
  [12726] = {.count = 1, .reusable = true}, SHIFT(9615),
  [12728] = {.count = 1, .reusable = true}, SHIFT(9616),
  [12730] = {.count = 1, .reusable = true}, SHIFT(9617),
  [12732] = {.count = 1, .reusable = false}, SHIFT(9617),
  [12734] = {.count = 1, .reusable = true}, SHIFT(9619),
  [12736] = {.count = 1, .reusable = true}, SHIFT(9620),
  [12738] = {.count = 1, .reusable = true}, SHIFT(9621),
  [12740] = {.count = 1, .reusable = true}, SHIFT(9622),
  [12742] = {.count = 1, .reusable = true}, SHIFT(9624),
  [12744] = {.count = 1, .reusable = true}, SHIFT(9625),
  [12746] = {.count = 1, .reusable = true}, SHIFT(9626),
  [12748] = {.count = 1, .reusable = true}, SHIFT(9627),
  [12750] = {.count = 1, .reusable = true}, SHIFT(9628),
  [12752] = {.count = 1, .reusable = true}, SHIFT(9630),
  [12754] = {.count = 1, .reusable = true}, SHIFT(9631),
  [12756] = {.count = 1, .reusable = true}, SHIFT(9632),
  [12758] = {.count = 1, .reusable = true}, SHIFT(9633),
  [12760] = {.count = 1, .reusable = true}, SHIFT(4976),
  [12762] = {.count = 1, .reusable = false}, SHIFT(9635),
  [12764] = {.count = 1, .reusable = true}, SHIFT(9636),
  [12766] = {.count = 1, .reusable = true}, SHIFT(9637),
  [12768] = {.count = 1, .reusable = false}, SHIFT(9638),
  [12770] = {.count = 1, .reusable = false}, SHIFT(9639),
  [12772] = {.count = 1, .reusable = true}, SHIFT(9641),
  [12774] = {.count = 1, .reusable = true}, SHIFT(9645),
  [12776] = {.count = 1, .reusable = true}, SHIFT(9644),
  [12778] = {.count = 1, .reusable = true}, SHIFT(4987),
  [12780] = {.count = 1, .reusable = true}, SHIFT(9654),
  [12782] = {.count = 1, .reusable = false}, SHIFT(9651),
  [12784] = {.count = 1, .reusable = false}, SHIFT(9655),
  [12786] = {.count = 1, .reusable = false}, SHIFT(9658),
  [12788] = {.count = 1, .reusable = false}, SHIFT(9660),
  [12790] = {.count = 1, .reusable = true}, SHIFT(9662),
  [12792] = {.count = 1, .reusable = true}, SHIFT(9664),
  [12794] = {.count = 1, .reusable = true}, SHIFT(9665),
  [12796] = {.count = 1, .reusable = true}, SHIFT(9666),
  [12798] = {.count = 1, .reusable = true}, SHIFT(9669),
  [12800] = {.count = 1, .reusable = true}, SHIFT(9670),
  [12802] = {.count = 1, .reusable = true}, SHIFT(9672),
  [12804] = {.count = 1, .reusable = true}, SHIFT(9674),
  [12806] = {.count = 1, .reusable = false}, SHIFT(9672),
  [12808] = {.count = 1, .reusable = true}, SHIFT(9676),
  [12810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(2424),
  [12813] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5046),
  [12816] = {.count = 1, .reusable = true}, SHIFT(7720),
  [12818] = {.count = 1, .reusable = true}, SHIFT(5075),
  [12820] = {.count = 1, .reusable = true}, SHIFT(9687),
  [12822] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5105),
  [12825] = {.count = 1, .reusable = true}, SHIFT(7753),
  [12827] = {.count = 1, .reusable = true}, SHIFT(7758),
  [12829] = {.count = 1, .reusable = true}, SHIFT(9696),
  [12831] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5179),
  [12834] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5200),
  [12837] = {.count = 1, .reusable = true}, SHIFT(7793),
  [12839] = {.count = 1, .reusable = false}, REDUCE(sym_conditional, 5),
  [12841] = {.count = 1, .reusable = true}, SHIFT(9702),
  [12843] = {.count = 1, .reusable = true}, SHIFT(9703),
  [12845] = {.count = 1, .reusable = false}, SHIFT(9703),
  [12847] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5237),
  [12850] = {.count = 1, .reusable = true}, SHIFT(9707),
  [12852] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5266),
  [12855] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5287),
  [12858] = {.count = 1, .reusable = true}, SHIFT(7840),
  [12860] = {.count = 1, .reusable = true}, SHIFT(9717),
  [12862] = {.count = 1, .reusable = true}, SHIFT(9718),
  [12864] = {.count = 1, .reusable = false}, SHIFT(9719),
  [12866] = {.count = 1, .reusable = true}, SHIFT(9720),
  [12868] = {.count = 1, .reusable = false}, SHIFT(9721),
  [12870] = {.count = 1, .reusable = false}, SHIFT(9722),
  [12872] = {.count = 1, .reusable = true}, SHIFT(9723),
  [12874] = {.count = 1, .reusable = false}, SHIFT(9724),
  [12876] = {.count = 1, .reusable = true}, SHIFT(9724),
  [12878] = {.count = 1, .reusable = true}, SHIFT(9726),
  [12880] = {.count = 1, .reusable = true}, SHIFT(9727),
  [12882] = {.count = 1, .reusable = false}, SHIFT(9726),
  [12884] = {.count = 1, .reusable = true}, SHIFT(9722),
  [12886] = {.count = 1, .reusable = true}, SHIFT(9719),
  [12888] = {.count = 1, .reusable = true}, SHIFT(9728),
  [12890] = {.count = 1, .reusable = true}, SHIFT(9729),
  [12892] = {.count = 1, .reusable = false}, SHIFT(9729),
  [12894] = {.count = 1, .reusable = true}, SHIFT(9730),
  [12896] = {.count = 1, .reusable = true}, SHIFT(9735),
  [12898] = {.count = 1, .reusable = false}, SHIFT(9735),
  [12900] = {.count = 1, .reusable = true}, SHIFT(9739),
  [12902] = {.count = 1, .reusable = false}, SHIFT(9737),
  [12904] = {.count = 1, .reusable = true}, SHIFT(9756),
  [12906] = {.count = 1, .reusable = false}, SHIFT(9756),
  [12908] = {.count = 1, .reusable = true}, SHIFT(9760),
  [12910] = {.count = 1, .reusable = false}, SHIFT(9758),
  [12912] = {.count = 1, .reusable = true}, SHIFT(5304),
  [12914] = {.count = 1, .reusable = false}, REDUCE(sym_elsif, 3),
  [12916] = {.count = 1, .reusable = true}, REDUCE(sym_if, 6),
  [12918] = {.count = 1, .reusable = false}, REDUCE(sym_if, 6),
  [12920] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9773),
  [12923] = {.count = 1, .reusable = true}, SHIFT(9774),
  [12925] = {.count = 1, .reusable = true}, SHIFT(9778),
  [12927] = {.count = 1, .reusable = true}, SHIFT(9779),
  [12929] = {.count = 1, .reusable = false}, SHIFT(9780),
  [12931] = {.count = 1, .reusable = false}, SHIFT(9781),
  [12933] = {.count = 1, .reusable = false}, SHIFT(9782),
  [12935] = {.count = 1, .reusable = false}, SHIFT(9783),
  [12937] = {.count = 1, .reusable = true}, SHIFT(9784),
  [12939] = {.count = 1, .reusable = false}, SHIFT(9785),
  [12941] = {.count = 1, .reusable = true}, SHIFT(9785),
  [12943] = {.count = 1, .reusable = false}, SHIFT(9787),
  [12945] = {.count = 1, .reusable = false}, SHIFT(9788),
  [12947] = {.count = 1, .reusable = true}, SHIFT(9787),
  [12949] = {.count = 1, .reusable = true}, SHIFT(9783),
  [12951] = {.count = 1, .reusable = false}, SHIFT(9789),
  [12953] = {.count = 1, .reusable = true}, SHIFT(9790),
  [12955] = {.count = 1, .reusable = false}, SHIFT(9790),
  [12957] = {.count = 1, .reusable = true}, SHIFT(9791),
  [12959] = {.count = 1, .reusable = true}, SHIFT(5350),
  [12961] = {.count = 1, .reusable = true}, SHIFT(9819),
  [12963] = {.count = 1, .reusable = true}, SHIFT(9820),
  [12965] = {.count = 1, .reusable = false}, SHIFT(9821),
  [12967] = {.count = 1, .reusable = true}, SHIFT(9822),
  [12969] = {.count = 1, .reusable = false}, SHIFT(9823),
  [12971] = {.count = 1, .reusable = false}, SHIFT(9824),
  [12973] = {.count = 1, .reusable = true}, SHIFT(9825),
  [12975] = {.count = 1, .reusable = false}, SHIFT(9826),
  [12977] = {.count = 1, .reusable = true}, SHIFT(9826),
  [12979] = {.count = 1, .reusable = true}, SHIFT(9828),
  [12981] = {.count = 1, .reusable = true}, SHIFT(9829),
  [12983] = {.count = 1, .reusable = false}, SHIFT(9828),
  [12985] = {.count = 1, .reusable = true}, SHIFT(9824),
  [12987] = {.count = 1, .reusable = true}, SHIFT(9821),
  [12989] = {.count = 1, .reusable = true}, SHIFT(9830),
  [12991] = {.count = 1, .reusable = true}, SHIFT(9831),
  [12993] = {.count = 1, .reusable = true}, SHIFT(9833),
  [12995] = {.count = 1, .reusable = false}, SHIFT(9833),
  [12997] = {.count = 1, .reusable = true}, SHIFT(9834),
  [12999] = {.count = 1, .reusable = true}, SHIFT(9835),
  [13001] = {.count = 1, .reusable = true}, SHIFT(9836),
  [13003] = {.count = 1, .reusable = true}, SHIFT(7989),
  [13005] = {.count = 1, .reusable = true}, SHIFT(9841),
  [13007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5427),
  [13010] = {.count = 1, .reusable = true}, SHIFT(9847),
  [13012] = {.count = 1, .reusable = true}, SHIFT(9848),
  [13014] = {.count = 1, .reusable = false}, SHIFT(9849),
  [13016] = {.count = 1, .reusable = true}, SHIFT(9850),
  [13018] = {.count = 1, .reusable = false}, SHIFT(9851),
  [13020] = {.count = 1, .reusable = false}, SHIFT(9852),
  [13022] = {.count = 1, .reusable = true}, SHIFT(9853),
  [13024] = {.count = 1, .reusable = false}, SHIFT(9854),
  [13026] = {.count = 1, .reusable = true}, SHIFT(9854),
  [13028] = {.count = 1, .reusable = true}, SHIFT(9856),
  [13030] = {.count = 1, .reusable = true}, SHIFT(9857),
  [13032] = {.count = 1, .reusable = false}, SHIFT(9856),
  [13034] = {.count = 1, .reusable = true}, SHIFT(9852),
  [13036] = {.count = 1, .reusable = true}, SHIFT(9849),
  [13038] = {.count = 1, .reusable = true}, SHIFT(9858),
  [13040] = {.count = 1, .reusable = true}, SHIFT(9859),
  [13042] = {.count = 1, .reusable = false}, SHIFT(9859),
  [13044] = {.count = 1, .reusable = true}, SHIFT(9860),
  [13046] = {.count = 1, .reusable = true}, SHIFT(9865),
  [13048] = {.count = 1, .reusable = false}, SHIFT(9865),
  [13050] = {.count = 1, .reusable = true}, SHIFT(9869),
  [13052] = {.count = 1, .reusable = false}, SHIFT(9867),
  [13054] = {.count = 1, .reusable = true}, SHIFT(9886),
  [13056] = {.count = 1, .reusable = false}, SHIFT(9886),
  [13058] = {.count = 1, .reusable = true}, SHIFT(9890),
  [13060] = {.count = 1, .reusable = false}, SHIFT(9888),
  [13062] = {.count = 1, .reusable = true}, SHIFT(5436),
  [13064] = {.count = 1, .reusable = true}, REDUCE(sym_unless, 6),
  [13066] = {.count = 1, .reusable = false}, REDUCE(sym_unless, 6),
  [13068] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(9901),
  [13071] = {.count = 1, .reusable = true}, SHIFT(9902),
  [13073] = {.count = 1, .reusable = true}, SHIFT(9906),
  [13075] = {.count = 1, .reusable = true}, SHIFT(9907),
  [13077] = {.count = 1, .reusable = false}, SHIFT(9908),
  [13079] = {.count = 1, .reusable = false}, SHIFT(9909),
  [13081] = {.count = 1, .reusable = false}, SHIFT(9910),
  [13083] = {.count = 1, .reusable = false}, SHIFT(9911),
  [13085] = {.count = 1, .reusable = true}, SHIFT(9912),
  [13087] = {.count = 1, .reusable = false}, SHIFT(9913),
  [13089] = {.count = 1, .reusable = true}, SHIFT(9913),
  [13091] = {.count = 1, .reusable = false}, SHIFT(9915),
  [13093] = {.count = 1, .reusable = false}, SHIFT(9916),
  [13095] = {.count = 1, .reusable = true}, SHIFT(9915),
  [13097] = {.count = 1, .reusable = true}, SHIFT(9911),
  [13099] = {.count = 1, .reusable = false}, SHIFT(9917),
  [13101] = {.count = 1, .reusable = true}, SHIFT(9918),
  [13103] = {.count = 1, .reusable = false}, SHIFT(9918),
  [13105] = {.count = 1, .reusable = true}, SHIFT(9919),
  [13107] = {.count = 1, .reusable = true}, SHIFT(5480),
  [13109] = {.count = 1, .reusable = true}, SHIFT(9947),
  [13111] = {.count = 1, .reusable = true}, SHIFT(9948),
  [13113] = {.count = 1, .reusable = false}, SHIFT(9949),
  [13115] = {.count = 1, .reusable = true}, SHIFT(9950),
  [13117] = {.count = 1, .reusable = false}, SHIFT(9951),
  [13119] = {.count = 1, .reusable = false}, SHIFT(9952),
  [13121] = {.count = 1, .reusable = true}, SHIFT(9953),
  [13123] = {.count = 1, .reusable = false}, SHIFT(9954),
  [13125] = {.count = 1, .reusable = true}, SHIFT(9954),
  [13127] = {.count = 1, .reusable = true}, SHIFT(9956),
  [13129] = {.count = 1, .reusable = true}, SHIFT(9957),
  [13131] = {.count = 1, .reusable = false}, SHIFT(9956),
  [13133] = {.count = 1, .reusable = true}, SHIFT(9952),
  [13135] = {.count = 1, .reusable = true}, SHIFT(9949),
  [13137] = {.count = 1, .reusable = true}, SHIFT(9958),
  [13139] = {.count = 1, .reusable = true}, SHIFT(9959),
  [13141] = {.count = 1, .reusable = true}, SHIFT(9961),
  [13143] = {.count = 1, .reusable = false}, SHIFT(9961),
  [13145] = {.count = 1, .reusable = true}, SHIFT(9962),
  [13147] = {.count = 1, .reusable = true}, SHIFT(9965),
  [13149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5526),
  [13152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5548),
  [13155] = {.count = 1, .reusable = true}, SHIFT(8164),
  [13157] = {.count = 1, .reusable = true}, SHIFT(9970),
  [13159] = {.count = 1, .reusable = true}, SHIFT(8184),
  [13161] = {.count = 1, .reusable = true}, SHIFT(9975),
  [13163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5616),
  [13166] = {.count = 1, .reusable = true}, SHIFT(5625),
  [13168] = {.count = 1, .reusable = true}, SHIFT(9982),
  [13170] = {.count = 1, .reusable = true}, SHIFT(9986),
  [13172] = {.count = 1, .reusable = true}, SHIFT(9987),
  [13174] = {.count = 1, .reusable = false}, SHIFT(9988),
  [13176] = {.count = 1, .reusable = false}, SHIFT(9989),
  [13178] = {.count = 1, .reusable = false}, SHIFT(9990),
  [13180] = {.count = 1, .reusable = false}, SHIFT(9991),
  [13182] = {.count = 1, .reusable = true}, SHIFT(9992),
  [13184] = {.count = 1, .reusable = false}, SHIFT(9993),
  [13186] = {.count = 1, .reusable = true}, SHIFT(9993),
  [13188] = {.count = 1, .reusable = false}, SHIFT(9995),
  [13190] = {.count = 1, .reusable = false}, SHIFT(9996),
  [13192] = {.count = 1, .reusable = true}, SHIFT(9995),
  [13194] = {.count = 1, .reusable = true}, SHIFT(9991),
  [13196] = {.count = 1, .reusable = false}, SHIFT(9997),
  [13198] = {.count = 1, .reusable = true}, SHIFT(9998),
  [13200] = {.count = 1, .reusable = false}, SHIFT(9998),
  [13202] = {.count = 1, .reusable = true}, SHIFT(9999),
  [13204] = {.count = 1, .reusable = true}, SHIFT(5648),
  [13206] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5664),
  [13209] = {.count = 1, .reusable = true}, SHIFT(10010),
  [13211] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5701),
  [13214] = {.count = 1, .reusable = true}, SHIFT(8273),
  [13216] = {.count = 1, .reusable = true}, REDUCE(sym_for, 6),
  [13218] = {.count = 1, .reusable = false}, REDUCE(sym_for, 6),
  [13220] = {.count = 1, .reusable = true}, SHIFT(10016),
  [13222] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5743),
  [13225] = {.count = 1, .reusable = true}, SHIFT(8301),
  [13227] = {.count = 1, .reusable = true}, REDUCE(sym_case, 6),
  [13229] = {.count = 1, .reusable = false}, REDUCE(sym_case, 6),
  [13231] = {.count = 1, .reusable = true}, SHIFT(10021),
  [13233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(5785),
  [13236] = {.count = 1, .reusable = true}, SHIFT(10025),
  [13238] = {.count = 1, .reusable = true}, SHIFT(10026),
  [13240] = {.count = 1, .reusable = false}, SHIFT(10027),
  [13242] = {.count = 1, .reusable = true}, SHIFT(10028),
  [13244] = {.count = 1, .reusable = false}, SHIFT(10029),
  [13246] = {.count = 1, .reusable = false}, SHIFT(10030),
  [13248] = {.count = 1, .reusable = true}, SHIFT(10031),
  [13250] = {.count = 1, .reusable = false}, SHIFT(10032),
  [13252] = {.count = 1, .reusable = true}, SHIFT(10032),
  [13254] = {.count = 1, .reusable = true}, SHIFT(10034),
  [13256] = {.count = 1, .reusable = true}, SHIFT(10035),
  [13258] = {.count = 1, .reusable = false}, SHIFT(10034),
  [13260] = {.count = 1, .reusable = true}, SHIFT(10030),
  [13262] = {.count = 1, .reusable = true}, SHIFT(10027),
  [13264] = {.count = 1, .reusable = true}, SHIFT(10036),
  [13266] = {.count = 1, .reusable = true}, SHIFT(10037),
  [13268] = {.count = 1, .reusable = false}, SHIFT(10037),
  [13270] = {.count = 1, .reusable = true}, SHIFT(10038),
  [13272] = {.count = 1, .reusable = true}, SHIFT(5794),
  [13274] = {.count = 1, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2),
  [13276] = {.count = 1, .reusable = true}, SHIFT(10046),
  [13278] = {.count = 1, .reusable = true}, SHIFT(10047),
  [13280] = {.count = 1, .reusable = true}, SHIFT(10048),
  [13282] = {.count = 1, .reusable = true}, SHIFT(10049),
  [13284] = {.count = 1, .reusable = false}, SHIFT(10051),
  [13286] = {.count = 1, .reusable = false}, SHIFT(10052),
  [13288] = {.count = 1, .reusable = false}, SHIFT(10053),
  [13290] = {.count = 1, .reusable = false}, SHIFT(10054),
  [13292] = {.count = 1, .reusable = true}, SHIFT(10056),
  [13294] = {.count = 1, .reusable = false}, SHIFT(10056),
  [13296] = {.count = 1, .reusable = false}, SHIFT(10057),
  [13298] = {.count = 1, .reusable = true}, SHIFT(10057),
  [13300] = {.count = 1, .reusable = false}, SHIFT(10058),
  [13302] = {.count = 1, .reusable = true}, SHIFT(10060),
  [13304] = {.count = 1, .reusable = false}, SHIFT(10060),
  [13306] = {.count = 1, .reusable = true}, SHIFT(10068),
  [13308] = {.count = 1, .reusable = true}, REDUCE(sym_when, 4),
  [13310] = {.count = 1, .reusable = true}, SHIFT(10070),
  [13312] = {.count = 1, .reusable = true}, SHIFT(10072),
  [13314] = {.count = 1, .reusable = true}, SHIFT(10073),
  [13316] = {.count = 1, .reusable = true}, SHIFT(10074),
  [13318] = {.count = 1, .reusable = true}, SHIFT(10075),
  [13320] = {.count = 1, .reusable = true}, SHIFT(10076),
  [13322] = {.count = 1, .reusable = true}, SHIFT(10077),
  [13324] = {.count = 1, .reusable = true}, SHIFT(10078),
  [13326] = {.count = 1, .reusable = false}, SHIFT(10079),
  [13328] = {.count = 1, .reusable = true}, SHIFT(10080),
  [13330] = {.count = 1, .reusable = false}, SHIFT(10081),
  [13332] = {.count = 1, .reusable = false}, SHIFT(10082),
  [13334] = {.count = 1, .reusable = true}, SHIFT(10083),
  [13336] = {.count = 1, .reusable = false}, SHIFT(10084),
  [13338] = {.count = 1, .reusable = true}, SHIFT(10084),
  [13340] = {.count = 1, .reusable = true}, SHIFT(10085),
  [13342] = {.count = 1, .reusable = true}, SHIFT(10086),
  [13344] = {.count = 1, .reusable = true}, SHIFT(10087),
  [13346] = {.count = 1, .reusable = false}, SHIFT(10086),
  [13348] = {.count = 1, .reusable = true}, SHIFT(10082),
  [13350] = {.count = 1, .reusable = true}, SHIFT(10079),
  [13352] = {.count = 1, .reusable = true}, SHIFT(10088),
  [13354] = {.count = 1, .reusable = true}, SHIFT(10089),
  [13356] = {.count = 1, .reusable = true}, SHIFT(10090),
  [13358] = {.count = 1, .reusable = true}, SHIFT(10091),
  [13360] = {.count = 1, .reusable = true}, SHIFT(10092),
  [13362] = {.count = 1, .reusable = false}, SHIFT(10094),
  [13364] = {.count = 1, .reusable = false}, SHIFT(10095),
  [13366] = {.count = 1, .reusable = false}, SHIFT(10096),
  [13368] = {.count = 1, .reusable = false}, SHIFT(10097),
  [13370] = {.count = 1, .reusable = true}, SHIFT(10099),
  [13372] = {.count = 1, .reusable = false}, SHIFT(10099),
  [13374] = {.count = 1, .reusable = false}, SHIFT(10100),
  [13376] = {.count = 1, .reusable = true}, SHIFT(10100),
  [13378] = {.count = 1, .reusable = false}, SHIFT(10101),
  [13380] = {.count = 1, .reusable = true}, SHIFT(10103),
  [13382] = {.count = 1, .reusable = false}, SHIFT(10103),
  [13384] = {.count = 1, .reusable = true}, SHIFT(10109),
  [13386] = {.count = 1, .reusable = false}, SHIFT(10109),
  [13388] = {.count = 1, .reusable = true}, SHIFT(10110),
  [13390] = {.count = 1, .reusable = false}, REDUCE(sym_when, 4),
  [13392] = {.count = 2, .reusable = true}, REDUCE(aux_sym_when_repeat1, 2), SHIFT_REPEAT(5802),
  [13395] = {.count = 1, .reusable = true}, SHIFT(10113),
  [13397] = {.count = 1, .reusable = true}, SHIFT(10117),
  [13399] = {.count = 1, .reusable = true}, SHIFT(10118),
  [13401] = {.count = 1, .reusable = false}, SHIFT(10119),
  [13403] = {.count = 1, .reusable = false}, SHIFT(10120),
  [13405] = {.count = 1, .reusable = false}, SHIFT(10121),
  [13407] = {.count = 1, .reusable = false}, SHIFT(10122),
  [13409] = {.count = 1, .reusable = true}, SHIFT(10123),
  [13411] = {.count = 1, .reusable = false}, SHIFT(10124),
  [13413] = {.count = 1, .reusable = true}, SHIFT(10124),
  [13415] = {.count = 1, .reusable = false}, SHIFT(10126),
  [13417] = {.count = 1, .reusable = false}, SHIFT(10127),
  [13419] = {.count = 1, .reusable = true}, SHIFT(10126),
  [13421] = {.count = 1, .reusable = true}, SHIFT(10122),
  [13423] = {.count = 1, .reusable = false}, SHIFT(10128),
  [13425] = {.count = 1, .reusable = true}, SHIFT(10129),
  [13427] = {.count = 1, .reusable = false}, SHIFT(10129),
  [13429] = {.count = 1, .reusable = true}, SHIFT(10130),
  [13431] = {.count = 1, .reusable = true}, SHIFT(5820),
  [13433] = {.count = 1, .reusable = true}, SHIFT(10143),
  [13435] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5856),
  [13438] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5877),
  [13441] = {.count = 1, .reusable = true}, SHIFT(8423),
  [13443] = {.count = 1, .reusable = true}, SHIFT(10148),
  [13445] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5908),
  [13448] = {.count = 1, .reusable = true}, SHIFT(10151),
  [13450] = {.count = 1, .reusable = true}, SHIFT(10154),
  [13452] = {.count = 1, .reusable = true}, SHIFT(10155),
  [13454] = {.count = 1, .reusable = true}, SHIFT(10158),
  [13456] = {.count = 1, .reusable = true}, SHIFT(10159),
  [13458] = {.count = 1, .reusable = true}, SHIFT(10160),
  [13460] = {.count = 1, .reusable = false}, SHIFT(10162),
  [13462] = {.count = 1, .reusable = true}, SHIFT(10169),
  [13464] = {.count = 1, .reusable = true}, SHIFT(10170),
  [13466] = {.count = 1, .reusable = false}, SHIFT(10171),
  [13468] = {.count = 1, .reusable = true}, SHIFT(10172),
  [13470] = {.count = 1, .reusable = false}, SHIFT(10173),
  [13472] = {.count = 1, .reusable = false}, SHIFT(10174),
  [13474] = {.count = 1, .reusable = true}, SHIFT(10175),
  [13476] = {.count = 1, .reusable = false}, SHIFT(10176),
  [13478] = {.count = 1, .reusable = true}, SHIFT(10176),
  [13480] = {.count = 1, .reusable = true}, SHIFT(10177),
  [13482] = {.count = 1, .reusable = true}, SHIFT(10178),
  [13484] = {.count = 1, .reusable = true}, SHIFT(10179),
  [13486] = {.count = 1, .reusable = false}, SHIFT(10178),
  [13488] = {.count = 1, .reusable = true}, SHIFT(10174),
  [13490] = {.count = 1, .reusable = true}, SHIFT(10171),
  [13492] = {.count = 1, .reusable = true}, SHIFT(10180),
  [13494] = {.count = 1, .reusable = true}, SHIFT(10181),
  [13496] = {.count = 1, .reusable = false}, SHIFT(10181),
  [13498] = {.count = 1, .reusable = true}, SHIFT(10182),
  [13500] = {.count = 1, .reusable = true}, SHIFT(10187),
  [13502] = {.count = 1, .reusable = false}, SHIFT(10187),
  [13504] = {.count = 1, .reusable = true}, SHIFT(10191),
  [13506] = {.count = 1, .reusable = false}, SHIFT(10189),
  [13508] = {.count = 1, .reusable = true}, SHIFT(10193),
  [13510] = {.count = 1, .reusable = true}, SHIFT(10209),
  [13512] = {.count = 1, .reusable = true}, SHIFT(10208),
  [13514] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 5),
  [13516] = {.count = 1, .reusable = true}, SHIFT(10221),
  [13518] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(5974),
  [13521] = {.count = 1, .reusable = true}, SHIFT(8533),
  [13523] = {.count = 1, .reusable = true}, SHIFT(6006),
  [13525] = {.count = 1, .reusable = true}, SHIFT(10249),
  [13527] = {.count = 1, .reusable = true}, SHIFT(6030),
  [13529] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6037),
  [13532] = {.count = 1, .reusable = true}, SHIFT(10275),
  [13534] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6096),
  [13537] = {.count = 1, .reusable = true}, SHIFT(6132),
  [13539] = {.count = 1, .reusable = true}, SHIFT(10317),
  [13541] = {.count = 1, .reusable = true}, SHIFT(6156),
  [13543] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6163),
  [13546] = {.count = 1, .reusable = true}, SHIFT(10343),
  [13548] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6222),
  [13551] = {.count = 1, .reusable = true}, REDUCE(sym__body_statement, 5),
  [13553] = {.count = 1, .reusable = false}, REDUCE(sym__body_statement, 5),
  [13555] = {.count = 1, .reusable = true}, SHIFT(10361),
  [13557] = {.count = 1, .reusable = true}, SHIFT(8796),
  [13559] = {.count = 1, .reusable = true}, SHIFT(10366),
  [13561] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6299),
  [13564] = {.count = 1, .reusable = true}, SHIFT(10367),
  [13566] = {.count = 1, .reusable = true}, SHIFT(10368),
  [13568] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6327),
  [13571] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6359),
  [13574] = {.count = 1, .reusable = true}, SHIFT(8868),
  [13576] = {.count = 1, .reusable = true}, SHIFT(8874),
  [13578] = {.count = 1, .reusable = true}, SHIFT(10405),
  [13580] = {.count = 1, .reusable = true}, SHIFT(10407),
  [13582] = {.count = 1, .reusable = true}, SHIFT(10408),
  [13584] = {.count = 1, .reusable = true}, SHIFT(10409),
  [13586] = {.count = 1, .reusable = true}, SHIFT(10410),
  [13588] = {.count = 1, .reusable = true}, SHIFT(10411),
  [13590] = {.count = 1, .reusable = false}, SHIFT(10411),
  [13592] = {.count = 1, .reusable = true}, SHIFT(10413),
  [13594] = {.count = 1, .reusable = true}, SHIFT(10414),
  [13596] = {.count = 1, .reusable = false}, SHIFT(10414),
  [13598] = {.count = 1, .reusable = true}, SHIFT(8902),
  [13600] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6459),
  [13603] = {.count = 1, .reusable = true}, SHIFT(10418),
  [13605] = {.count = 1, .reusable = true}, SHIFT(10420),
  [13607] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 4),
  [13609] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 4),
  [13611] = {.count = 1, .reusable = true}, SHIFT(10423),
  [13613] = {.count = 1, .reusable = true}, SHIFT(10424),
  [13615] = {.count = 1, .reusable = true}, SHIFT(10425),
  [13617] = {.count = 1, .reusable = true}, SHIFT(10426),
  [13619] = {.count = 1, .reusable = false}, SHIFT(10428),
  [13621] = {.count = 1, .reusable = false}, SHIFT(10429),
  [13623] = {.count = 1, .reusable = false}, SHIFT(10430),
  [13625] = {.count = 1, .reusable = false}, SHIFT(10431),
  [13627] = {.count = 1, .reusable = true}, SHIFT(10433),
  [13629] = {.count = 1, .reusable = false}, SHIFT(10433),
  [13631] = {.count = 1, .reusable = false}, SHIFT(10434),
  [13633] = {.count = 1, .reusable = true}, SHIFT(10434),
  [13635] = {.count = 1, .reusable = false}, SHIFT(10435),
  [13637] = {.count = 1, .reusable = true}, SHIFT(10437),
  [13639] = {.count = 1, .reusable = false}, SHIFT(10437),
  [13641] = {.count = 1, .reusable = true}, SHIFT(10445),
  [13643] = {.count = 1, .reusable = true}, SHIFT(10446),
  [13645] = {.count = 1, .reusable = false}, REDUCE(sym_keyword_parameter, 3),
  [13647] = {.count = 1, .reusable = true}, SHIFT(10448),
  [13649] = {.count = 1, .reusable = false}, SHIFT(10449),
  [13651] = {.count = 1, .reusable = false}, SHIFT(10450),
  [13653] = {.count = 1, .reusable = true}, SHIFT(10451),
  [13655] = {.count = 1, .reusable = false}, SHIFT(10452),
  [13657] = {.count = 1, .reusable = true}, SHIFT(10452),
  [13659] = {.count = 1, .reusable = true}, SHIFT(10453),
  [13661] = {.count = 1, .reusable = true}, SHIFT(10454),
  [13663] = {.count = 1, .reusable = true}, SHIFT(10455),
  [13665] = {.count = 1, .reusable = false}, SHIFT(10454),
  [13667] = {.count = 1, .reusable = true}, SHIFT(10450),
  [13669] = {.count = 1, .reusable = true}, SHIFT(10447),
  [13671] = {.count = 1, .reusable = true}, SHIFT(10456),
  [13673] = {.count = 1, .reusable = true}, SHIFT(10457),
  [13675] = {.count = 1, .reusable = true}, SHIFT(10458),
  [13677] = {.count = 1, .reusable = true}, SHIFT(10459),
  [13679] = {.count = 1, .reusable = true}, SHIFT(10460),
  [13681] = {.count = 1, .reusable = false}, SHIFT(10462),
  [13683] = {.count = 1, .reusable = false}, SHIFT(10463),
  [13685] = {.count = 1, .reusable = false}, SHIFT(10464),
  [13687] = {.count = 1, .reusable = false}, SHIFT(10465),
  [13689] = {.count = 1, .reusable = true}, SHIFT(10467),
  [13691] = {.count = 1, .reusable = false}, SHIFT(10467),
  [13693] = {.count = 1, .reusable = false}, SHIFT(10468),
  [13695] = {.count = 1, .reusable = true}, SHIFT(10468),
  [13697] = {.count = 1, .reusable = false}, SHIFT(10469),
  [13699] = {.count = 1, .reusable = true}, SHIFT(10471),
  [13701] = {.count = 1, .reusable = false}, SHIFT(10471),
  [13703] = {.count = 1, .reusable = true}, SHIFT(10477),
  [13705] = {.count = 1, .reusable = false}, SHIFT(10477),
  [13707] = {.count = 1, .reusable = true}, SHIFT(10478),
  [13709] = {.count = 1, .reusable = false}, REDUCE(sym_optional_parameter, 3),
  [13711] = {.count = 1, .reusable = true}, SHIFT(10480),
  [13713] = {.count = 1, .reusable = true}, SHIFT(10481),
  [13715] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(10482),
  [13718] = {.count = 1, .reusable = true}, REDUCE(sym_destructured_parameter, 4),
  [13720] = {.count = 1, .reusable = true}, SHIFT(10483),
  [13722] = {.count = 1, .reusable = true}, SHIFT(10485),
  [13724] = {.count = 1, .reusable = true}, SHIFT(10486),
  [13726] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 5),
  [13728] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 5),
  [13730] = {.count = 1, .reusable = true}, SHIFT(10487),
  [13732] = {.count = 1, .reusable = true}, SHIFT(10488),
  [13734] = {.count = 1, .reusable = true}, SHIFT(10510),
  [13736] = {.count = 1, .reusable = true}, SHIFT(6527),
  [13738] = {.count = 1, .reusable = true}, SHIFT(10517),
  [13740] = {.count = 1, .reusable = true}, SHIFT(6551),
  [13742] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6558),
  [13745] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6519),
  [13748] = {.count = 1, .reusable = true}, SHIFT(10543),
  [13750] = {.count = 1, .reusable = true}, SHIFT(10544),
  [13752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6611),
  [13755] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(6590),
  [13758] = {.count = 1, .reusable = true}, SHIFT(10563),
  [13760] = {.count = 1, .reusable = true}, SHIFT(10564),
  [13762] = {.count = 1, .reusable = true}, SHIFT(10565),
  [13764] = {.count = 1, .reusable = true}, SHIFT(10566),
  [13766] = {.count = 1, .reusable = true}, SHIFT(10567),
  [13768] = {.count = 1, .reusable = true}, SHIFT(10568),
  [13770] = {.count = 1, .reusable = true}, SHIFT(10569),
  [13772] = {.count = 1, .reusable = true}, SHIFT(10570),
  [13774] = {.count = 1, .reusable = true}, SHIFT(10571),
  [13776] = {.count = 1, .reusable = false}, SHIFT(10572),
  [13778] = {.count = 1, .reusable = false}, SHIFT(10573),
  [13780] = {.count = 1, .reusable = true}, SHIFT(10574),
  [13782] = {.count = 1, .reusable = false}, SHIFT(10574),
  [13784] = {.count = 1, .reusable = true}, SHIFT(10577),
  [13786] = {.count = 1, .reusable = true}, SHIFT(10579),
  [13788] = {.count = 1, .reusable = true}, SHIFT(10580),
  [13790] = {.count = 1, .reusable = false}, SHIFT(10581),
  [13792] = {.count = 1, .reusable = true}, SHIFT(10583),
  [13794] = {.count = 1, .reusable = true}, SHIFT(10585),
  [13796] = {.count = 1, .reusable = true}, SHIFT(9125),
  [13798] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6715),
  [13801] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6736),
  [13804] = {.count = 1, .reusable = true}, SHIFT(10607),
  [13806] = {.count = 1, .reusable = true}, SHIFT(10609),
  [13808] = {.count = 1, .reusable = true}, SHIFT(10610),
  [13810] = {.count = 1, .reusable = true}, SHIFT(10611),
  [13812] = {.count = 1, .reusable = true}, SHIFT(10612),
  [13814] = {.count = 1, .reusable = true}, SHIFT(10613),
  [13816] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6783),
  [13819] = {.count = 1, .reusable = true}, SHIFT(10617),
  [13821] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6828),
  [13824] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(6849),
  [13827] = {.count = 1, .reusable = true}, SHIFT(9213),
  [13829] = {.count = 1, .reusable = true}, SHIFT(10622),
  [13831] = {.count = 1, .reusable = true}, SHIFT(10623),
  [13833] = {.count = 1, .reusable = true}, SHIFT(10624),
  [13835] = {.count = 1, .reusable = true}, SHIFT(10625),
  [13837] = {.count = 1, .reusable = true}, SHIFT(10627),
  [13839] = {.count = 1, .reusable = true}, SHIFT(10628),
  [13841] = {.count = 1, .reusable = true}, SHIFT(10629),
  [13843] = {.count = 1, .reusable = true}, SHIFT(10630),
  [13845] = {.count = 1, .reusable = true}, SHIFT(10631),
  [13847] = {.count = 1, .reusable = true}, SHIFT(10633),
  [13849] = {.count = 1, .reusable = true}, SHIFT(10634),
  [13851] = {.count = 1, .reusable = true}, SHIFT(10635),
  [13853] = {.count = 1, .reusable = true}, SHIFT(10636),
  [13855] = {.count = 1, .reusable = true}, SHIFT(6889),
  [13857] = {.count = 1, .reusable = false}, SHIFT(10638),
  [13859] = {.count = 1, .reusable = true}, SHIFT(10639),
  [13861] = {.count = 1, .reusable = true}, SHIFT(10640),
  [13863] = {.count = 1, .reusable = false}, SHIFT(10641),
  [13865] = {.count = 1, .reusable = false}, SHIFT(10642),
  [13867] = {.count = 1, .reusable = true}, SHIFT(10646),
  [13869] = {.count = 1, .reusable = false}, SHIFT(10643),
  [13871] = {.count = 1, .reusable = false}, SHIFT(10647),
  [13873] = {.count = 1, .reusable = false}, SHIFT(10650),
  [13875] = {.count = 1, .reusable = false}, SHIFT(10652),
  [13877] = {.count = 1, .reusable = true}, SHIFT(10654),
  [13879] = {.count = 1, .reusable = true}, SHIFT(10656),
  [13881] = {.count = 1, .reusable = true}, SHIFT(10657),
  [13883] = {.count = 1, .reusable = true}, SHIFT(10658),
  [13885] = {.count = 1, .reusable = true}, SHIFT(10661),
  [13887] = {.count = 1, .reusable = true}, SHIFT(10662),
  [13889] = {.count = 2, .reusable = true}, REDUCE(aux_sym_chained_string_repeat1, 2), SHIFT_REPEAT(4059),
  [13892] = {.count = 1, .reusable = true}, SHIFT(10665),
  [13894] = {.count = 1, .reusable = false}, SHIFT(10665),
  [13896] = {.count = 1, .reusable = true}, SHIFT(9287),
  [13898] = {.count = 1, .reusable = true}, SHIFT(10669),
  [13900] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(6988),
  [13903] = {.count = 1, .reusable = true}, SHIFT(10672),
  [13905] = {.count = 1, .reusable = true}, SHIFT(9326),
  [13907] = {.count = 1, .reusable = true}, SHIFT(10677),
  [13909] = {.count = 1, .reusable = true}, SHIFT(9346),
  [13911] = {.count = 1, .reusable = true}, SHIFT(10682),
  [13913] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7098),
  [13916] = {.count = 1, .reusable = true}, SHIFT(10683),
  [13918] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7133),
  [13921] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7154),
  [13924] = {.count = 1, .reusable = true}, SHIFT(9394),
  [13926] = {.count = 1, .reusable = true}, SHIFT(10688),
  [13928] = {.count = 1, .reusable = true}, SHIFT(10689),
  [13930] = {.count = 1, .reusable = true}, SHIFT(10692),
  [13932] = {.count = 1, .reusable = false}, SHIFT(10692),
  [13934] = {.count = 1, .reusable = true}, SHIFT(9421),
  [13936] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7219),
  [13939] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7229),
  [13942] = {.count = 1, .reusable = true}, SHIFT(10696),
  [13944] = {.count = 1, .reusable = true}, SHIFT(10697),
  [13946] = {.count = 1, .reusable = true}, SHIFT(10698),
  [13948] = {.count = 1, .reusable = true}, SHIFT(10699),
  [13950] = {.count = 1, .reusable = true}, SHIFT(10701),
  [13952] = {.count = 1, .reusable = true}, SHIFT(10703),
  [13954] = {.count = 1, .reusable = true}, SHIFT(10704),
  [13956] = {.count = 1, .reusable = true}, SHIFT(10705),
  [13958] = {.count = 1, .reusable = true}, SHIFT(10706),
  [13960] = {.count = 1, .reusable = true}, SHIFT(10707),
  [13962] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7299),
  [13965] = {.count = 1, .reusable = true}, SHIFT(10709),
  [13967] = {.count = 1, .reusable = true}, SHIFT(9480),
  [13969] = {.count = 1, .reusable = true}, SHIFT(10714),
  [13971] = {.count = 1, .reusable = true}, SHIFT(9500),
  [13973] = {.count = 1, .reusable = true}, SHIFT(10719),
  [13975] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7415),
  [13978] = {.count = 1, .reusable = true}, REDUCE(sym_method_parameters, 5),
  [13980] = {.count = 1, .reusable = false}, REDUCE(sym_method_parameters, 5),
  [13982] = {.count = 1, .reusable = true}, SHIFT(10720),
  [13984] = {.count = 1, .reusable = true}, SHIFT(10721),
  [13986] = {.count = 1, .reusable = false}, SHIFT(10721),
  [13988] = {.count = 1, .reusable = true}, SHIFT(10723),
  [13990] = {.count = 1, .reusable = true}, SHIFT(10724),
  [13992] = {.count = 2, .reusable = true}, REDUCE(aux_sym_method_parameters_repeat1, 2), SHIFT_REPEAT(7431),
  [13995] = {.count = 1, .reusable = true}, SHIFT(7437),
  [13997] = {.count = 1, .reusable = true}, SHIFT(10731),
  [13999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7467),
  [14002] = {.count = 1, .reusable = true}, SHIFT(9560),
  [14004] = {.count = 1, .reusable = true}, SHIFT(9565),
  [14006] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7521),
  [14009] = {.count = 1, .reusable = true}, SHIFT(9570),
  [14011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7541),
  [14014] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7573),
  [14017] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7604),
  [14020] = {.count = 1, .reusable = true}, SHIFT(9609),
  [14022] = {.count = 1, .reusable = true}, SHIFT(10759),
  [14024] = {.count = 1, .reusable = true}, SHIFT(10760),
  [14026] = {.count = 1, .reusable = true}, SHIFT(10761),
  [14028] = {.count = 1, .reusable = true}, SHIFT(10762),
  [14030] = {.count = 1, .reusable = true}, SHIFT(10763),
  [14032] = {.count = 1, .reusable = true}, SHIFT(10764),
  [14034] = {.count = 1, .reusable = true}, SHIFT(10765),
  [14036] = {.count = 1, .reusable = true}, SHIFT(10766),
  [14038] = {.count = 1, .reusable = true}, SHIFT(10767),
  [14040] = {.count = 1, .reusable = false}, SHIFT(10768),
  [14042] = {.count = 1, .reusable = false}, SHIFT(10769),
  [14044] = {.count = 1, .reusable = true}, SHIFT(10770),
  [14046] = {.count = 1, .reusable = true}, SHIFT(10771),
  [14048] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(7668),
  [14051] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7670),
  [14054] = {.count = 1, .reusable = true}, SHIFT(10773),
  [14056] = {.count = 1, .reusable = false}, SHIFT(10773),
  [14058] = {.count = 1, .reusable = true}, SHIFT(10776),
  [14060] = {.count = 1, .reusable = true}, SHIFT(10778),
  [14062] = {.count = 1, .reusable = true}, SHIFT(10779),
  [14064] = {.count = 1, .reusable = false}, SHIFT(10780),
  [14066] = {.count = 1, .reusable = true}, SHIFT(10782),
  [14068] = {.count = 1, .reusable = true}, SHIFT(10784),
  [14070] = {.count = 1, .reusable = true}, SHIFT(10786),
  [14072] = {.count = 1, .reusable = true}, SHIFT(10787),
  [14074] = {.count = 1, .reusable = false}, SHIFT(10787),
  [14076] = {.count = 1, .reusable = true}, SHIFT(10789),
  [14078] = {.count = 1, .reusable = true}, SHIFT(9677),
  [14080] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7720),
  [14083] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7728),
  [14086] = {.count = 1, .reusable = true}, SHIFT(9688),
  [14088] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7753),
  [14091] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7758),
  [14094] = {.count = 1, .reusable = true}, SHIFT(9698),
  [14096] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7793),
  [14099] = {.count = 1, .reusable = true}, SHIFT(10797),
  [14101] = {.count = 1, .reusable = true}, SHIFT(9708),
  [14103] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7840),
  [14106] = {.count = 1, .reusable = true}, SHIFT(7862),
  [14108] = {.count = 1, .reusable = true}, SHIFT(10824),
  [14110] = {.count = 1, .reusable = true}, SHIFT(7886),
  [14112] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7893),
  [14115] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 4),
  [14117] = {.count = 1, .reusable = true}, SHIFT(10851),
  [14119] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(7954),
  [14122] = {.count = 1, .reusable = true}, REDUCE(sym_if, 7),
  [14124] = {.count = 1, .reusable = false}, REDUCE(sym_if, 7),
  [14126] = {.count = 1, .reusable = true}, SHIFT(9837),
  [14128] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(7989),
  [14131] = {.count = 1, .reusable = true}, SHIFT(8026),
  [14133] = {.count = 1, .reusable = true}, SHIFT(10896),
  [14135] = {.count = 1, .reusable = true}, SHIFT(8050),
  [14137] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8057),
  [14140] = {.count = 1, .reusable = true}, SHIFT(10922),
  [14142] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8117),
  [14145] = {.count = 1, .reusable = true}, SHIFT(9966),
  [14147] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8164),
  [14150] = {.count = 1, .reusable = true}, SHIFT(9971),
  [14152] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8184),
  [14155] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8207),
  [14158] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8238),
  [14161] = {.count = 1, .reusable = true}, SHIFT(10007),
  [14163] = {.count = 1, .reusable = true}, SHIFT(10011),
  [14165] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8273),
  [14168] = {.count = 1, .reusable = true}, SHIFT(10017),
  [14170] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8301),
  [14173] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8332),
  [14176] = {.count = 1, .reusable = true}, SHIFT(10983),
  [14178] = {.count = 1, .reusable = false}, SHIFT(10984),
  [14180] = {.count = 1, .reusable = false}, SHIFT(10985),
  [14182] = {.count = 1, .reusable = false}, SHIFT(10986),
  [14184] = {.count = 1, .reusable = false}, SHIFT(10987),
  [14186] = {.count = 1, .reusable = false}, SHIFT(10988),
  [14188] = {.count = 1, .reusable = true}, SHIFT(10989),
  [14190] = {.count = 1, .reusable = false}, SHIFT(10989),
  [14192] = {.count = 1, .reusable = true}, SHIFT(10990),
  [14194] = {.count = 1, .reusable = false}, SHIFT(10055),
  [14196] = {.count = 1, .reusable = true}, SHIFT(10998),
  [14198] = {.count = 1, .reusable = true}, SHIFT(11000),
  [14200] = {.count = 1, .reusable = true}, SHIFT(11001),
  [14202] = {.count = 1, .reusable = true}, SHIFT(11002),
  [14204] = {.count = 1, .reusable = false}, SHIFT(11004),
  [14206] = {.count = 1, .reusable = false}, SHIFT(10998),
  [14208] = {.count = 1, .reusable = true}, SHIFT(11011),
  [14210] = {.count = 1, .reusable = true}, SHIFT(11012),
  [14212] = {.count = 1, .reusable = false}, SHIFT(11013),
  [14214] = {.count = 1, .reusable = true}, SHIFT(11014),
  [14216] = {.count = 1, .reusable = false}, SHIFT(11015),
  [14218] = {.count = 1, .reusable = false}, SHIFT(11016),
  [14220] = {.count = 1, .reusable = true}, SHIFT(11017),
  [14222] = {.count = 1, .reusable = true}, SHIFT(11018),
  [14224] = {.count = 1, .reusable = false}, SHIFT(11019),
  [14226] = {.count = 1, .reusable = true}, SHIFT(11019),
  [14228] = {.count = 1, .reusable = true}, SHIFT(11021),
  [14230] = {.count = 1, .reusable = true}, SHIFT(11022),
  [14232] = {.count = 1, .reusable = false}, SHIFT(11021),
  [14234] = {.count = 1, .reusable = true}, SHIFT(11016),
  [14236] = {.count = 1, .reusable = true}, SHIFT(11013),
  [14238] = {.count = 1, .reusable = true}, SHIFT(11023),
  [14240] = {.count = 1, .reusable = true}, SHIFT(11024),
  [14242] = {.count = 1, .reusable = true}, SHIFT(11025),
  [14244] = {.count = 1, .reusable = true}, SHIFT(11026),
  [14246] = {.count = 1, .reusable = false}, SHIFT(11028),
  [14248] = {.count = 1, .reusable = true}, SHIFT(11034),
  [14250] = {.count = 1, .reusable = true}, SHIFT(11036),
  [14252] = {.count = 1, .reusable = false}, SHIFT(11036),
  [14254] = {.count = 1, .reusable = true}, SHIFT(11037),
  [14256] = {.count = 1, .reusable = false}, SHIFT(11017),
  [14258] = {.count = 1, .reusable = true}, REDUCE(sym_when, 5),
  [14260] = {.count = 1, .reusable = true}, SHIFT(11040),
  [14262] = {.count = 1, .reusable = true}, SHIFT(11059),
  [14264] = {.count = 1, .reusable = false}, SHIFT(11060),
  [14266] = {.count = 1, .reusable = false}, SHIFT(11061),
  [14268] = {.count = 1, .reusable = false}, SHIFT(11062),
  [14270] = {.count = 1, .reusable = false}, SHIFT(11063),
  [14272] = {.count = 1, .reusable = false}, SHIFT(11064),
  [14274] = {.count = 1, .reusable = true}, SHIFT(11065),
  [14276] = {.count = 1, .reusable = false}, SHIFT(11065),
  [14278] = {.count = 1, .reusable = true}, SHIFT(11066),
  [14280] = {.count = 1, .reusable = false}, SHIFT(11068),
  [14282] = {.count = 1, .reusable = true}, SHIFT(11068),
  [14284] = {.count = 1, .reusable = false}, SHIFT(10098),
  [14286] = {.count = 1, .reusable = true}, SHIFT(11075),
  [14288] = {.count = 1, .reusable = false}, SHIFT(11075),
  [14290] = {.count = 1, .reusable = true}, SHIFT(11079),
  [14292] = {.count = 1, .reusable = true}, SHIFT(11080),
  [14294] = {.count = 1, .reusable = false}, SHIFT(11081),
  [14296] = {.count = 1, .reusable = false}, SHIFT(11082),
  [14298] = {.count = 1, .reusable = false}, SHIFT(11083),
  [14300] = {.count = 1, .reusable = false}, SHIFT(11084),
  [14302] = {.count = 1, .reusable = true}, SHIFT(11085),
  [14304] = {.count = 1, .reusable = true}, SHIFT(11086),
  [14306] = {.count = 1, .reusable = false}, SHIFT(11087),
  [14308] = {.count = 1, .reusable = true}, SHIFT(11087),
  [14310] = {.count = 1, .reusable = false}, SHIFT(11089),
  [14312] = {.count = 1, .reusable = false}, SHIFT(11090),
  [14314] = {.count = 1, .reusable = true}, SHIFT(11089),
  [14316] = {.count = 1, .reusable = true}, SHIFT(11084),
  [14318] = {.count = 1, .reusable = false}, SHIFT(11091),
  [14320] = {.count = 1, .reusable = true}, SHIFT(11093),
  [14322] = {.count = 1, .reusable = true}, SHIFT(11095),
  [14324] = {.count = 1, .reusable = false}, SHIFT(11095),
  [14326] = {.count = 1, .reusable = true}, SHIFT(11096),
  [14328] = {.count = 1, .reusable = false}, SHIFT(11085),
  [14330] = {.count = 1, .reusable = true}, SHIFT(11098),
  [14332] = {.count = 1, .reusable = true}, SHIFT(11099),
  [14334] = {.count = 1, .reusable = false}, SHIFT(11100),
  [14336] = {.count = 1, .reusable = true}, SHIFT(11101),
  [14338] = {.count = 1, .reusable = false}, SHIFT(11101),
  [14340] = {.count = 1, .reusable = true}, SHIFT(11102),
  [14342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8385),
  [14345] = {.count = 1, .reusable = true}, SHIFT(10139),
  [14347] = {.count = 1, .reusable = true}, SHIFT(10144),
  [14349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8423),
  [14352] = {.count = 1, .reusable = true}, SHIFT(10149),
  [14354] = {.count = 1, .reusable = true}, SHIFT(11132),
  [14356] = {.count = 1, .reusable = true}, SHIFT(11134),
  [14358] = {.count = 1, .reusable = true}, SHIFT(11137),
  [14360] = {.count = 1, .reusable = false}, SHIFT(11137),
  [14362] = {.count = 1, .reusable = true}, SHIFT(11139),
  [14364] = {.count = 1, .reusable = true}, SHIFT(11141),
  [14366] = {.count = 1, .reusable = false}, SHIFT(11139),
  [14368] = {.count = 1, .reusable = true}, SHIFT(8475),
  [14370] = {.count = 1, .reusable = true}, SHIFT(11165),
  [14372] = {.count = 1, .reusable = true}, SHIFT(11166),
  [14374] = {.count = 1, .reusable = true}, SHIFT(11167),
  [14376] = {.count = 2, .reusable = true}, REDUCE(aux_sym_call_repeat1, 2), SHIFT_REPEAT(8500),
  [14379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8502),
  [14382] = {.count = 1, .reusable = true}, REDUCE(sym_rescue, 6),
  [14384] = {.count = 1, .reusable = true}, SHIFT(10222),
  [14386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8533),
  [14389] = {.count = 1, .reusable = true}, SHIFT(11175),
  [14391] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8562),
  [14394] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8583),
  [14397] = {.count = 1, .reusable = true}, SHIFT(10256),
  [14399] = {.count = 1, .reusable = true}, SHIFT(11180),
  [14401] = {.count = 1, .reusable = true}, SHIFT(10276),
  [14403] = {.count = 1, .reusable = true}, SHIFT(11185),
  [14405] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8652),
  [14408] = {.count = 1, .reusable = true}, SHIFT(11188),
  [14410] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8683),
  [14413] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8704),
  [14416] = {.count = 1, .reusable = true}, SHIFT(10324),
  [14418] = {.count = 1, .reusable = true}, SHIFT(11193),
  [14420] = {.count = 1, .reusable = true}, SHIFT(10344),
  [14422] = {.count = 1, .reusable = true}, SHIFT(11198),
  [14424] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8773),
  [14427] = {.count = 1, .reusable = true}, SHIFT(10362),
  [14429] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8796),
  [14432] = {.count = 1, .reusable = true}, SHIFT(11202),
  [14434] = {.count = 1, .reusable = true}, SHIFT(11205),
  [14436] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8868),
  [14439] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8874),
  [14442] = {.count = 1, .reusable = true}, SHIFT(11208),
  [14444] = {.count = 1, .reusable = true}, SHIFT(11209),
  [14446] = {.count = 1, .reusable = true}, SHIFT(11210),
  [14448] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(8902),
  [14451] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 5),
  [14453] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 5),
  [14455] = {.count = 1, .reusable = true}, SHIFT(11211),
  [14457] = {.count = 1, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2),
  [14459] = {.count = 2, .reusable = true}, REDUCE(aux_sym_block_parameters_repeat1, 2), SHIFT_REPEAT(8908),
  [14462] = {.count = 1, .reusable = true}, SHIFT(11212),
  [14464] = {.count = 1, .reusable = false}, SHIFT(11213),
  [14466] = {.count = 1, .reusable = false}, SHIFT(11214),
  [14468] = {.count = 1, .reusable = false}, SHIFT(11215),
  [14470] = {.count = 1, .reusable = false}, SHIFT(11216),
  [14472] = {.count = 1, .reusable = false}, SHIFT(11217),
  [14474] = {.count = 1, .reusable = true}, SHIFT(11218),
  [14476] = {.count = 1, .reusable = false}, SHIFT(11218),
  [14478] = {.count = 1, .reusable = true}, SHIFT(11219),
  [14480] = {.count = 1, .reusable = false}, SHIFT(11221),
  [14482] = {.count = 1, .reusable = true}, SHIFT(11221),
  [14484] = {.count = 1, .reusable = false}, SHIFT(10432),
  [14486] = {.count = 1, .reusable = true}, SHIFT(11228),
  [14488] = {.count = 1, .reusable = true}, SHIFT(11230),
  [14490] = {.count = 1, .reusable = true}, SHIFT(11231),
  [14492] = {.count = 1, .reusable = true}, SHIFT(11232),
  [14494] = {.count = 1, .reusable = false}, SHIFT(11234),
  [14496] = {.count = 1, .reusable = false}, SHIFT(11228),
  [14498] = {.count = 1, .reusable = true}, SHIFT(11241),
  [14500] = {.count = 1, .reusable = true}, SHIFT(11242),
  [14502] = {.count = 1, .reusable = false}, SHIFT(11243),
  [14504] = {.count = 1, .reusable = true}, SHIFT(11244),
  [14506] = {.count = 1, .reusable = false}, SHIFT(11245),
  [14508] = {.count = 1, .reusable = false}, SHIFT(11246),
  [14510] = {.count = 1, .reusable = true}, SHIFT(11247),
  [14512] = {.count = 1, .reusable = true}, SHIFT(11248),
  [14514] = {.count = 1, .reusable = false}, SHIFT(11249),
  [14516] = {.count = 1, .reusable = true}, SHIFT(11249),
  [14518] = {.count = 1, .reusable = true}, SHIFT(11251),
  [14520] = {.count = 1, .reusable = true}, SHIFT(11252),
  [14522] = {.count = 1, .reusable = false}, SHIFT(11251),
  [14524] = {.count = 1, .reusable = true}, SHIFT(11246),
  [14526] = {.count = 1, .reusable = true}, SHIFT(11243),
  [14528] = {.count = 1, .reusable = true}, SHIFT(11253),
  [14530] = {.count = 1, .reusable = true}, SHIFT(11254),
  [14532] = {.count = 1, .reusable = true}, SHIFT(11255),
  [14534] = {.count = 1, .reusable = true}, SHIFT(11256),
  [14536] = {.count = 1, .reusable = false}, SHIFT(11258),
  [14538] = {.count = 1, .reusable = true}, SHIFT(11264),
  [14540] = {.count = 1, .reusable = true}, SHIFT(11266),
  [14542] = {.count = 1, .reusable = false}, SHIFT(11266),
  [14544] = {.count = 1, .reusable = true}, SHIFT(11267),
  [14546] = {.count = 1, .reusable = false}, SHIFT(11247),
  [14548] = {.count = 1, .reusable = false}, SHIFT(10447),
  [14550] = {.count = 1, .reusable = true}, SHIFT(11281),
  [14552] = {.count = 1, .reusable = false}, SHIFT(11282),
  [14554] = {.count = 1, .reusable = false}, SHIFT(11283),
  [14556] = {.count = 1, .reusable = false}, SHIFT(11284),
  [14558] = {.count = 1, .reusable = false}, SHIFT(11285),
  [14560] = {.count = 1, .reusable = false}, SHIFT(11286),
  [14562] = {.count = 1, .reusable = true}, SHIFT(11287),
  [14564] = {.count = 1, .reusable = false}, SHIFT(11287),
  [14566] = {.count = 1, .reusable = true}, SHIFT(11288),
  [14568] = {.count = 1, .reusable = false}, SHIFT(11290),
  [14570] = {.count = 1, .reusable = true}, SHIFT(11290),
  [14572] = {.count = 1, .reusable = false}, SHIFT(10466),
  [14574] = {.count = 1, .reusable = true}, SHIFT(11297),
  [14576] = {.count = 1, .reusable = false}, SHIFT(11297),
  [14578] = {.count = 1, .reusable = true}, SHIFT(11301),
  [14580] = {.count = 1, .reusable = true}, SHIFT(11302),
  [14582] = {.count = 1, .reusable = false}, SHIFT(11303),
  [14584] = {.count = 1, .reusable = false}, SHIFT(11304),
  [14586] = {.count = 1, .reusable = false}, SHIFT(11305),
  [14588] = {.count = 1, .reusable = false}, SHIFT(11306),
  [14590] = {.count = 1, .reusable = true}, SHIFT(11307),
  [14592] = {.count = 1, .reusable = true}, SHIFT(11308),
  [14594] = {.count = 1, .reusable = false}, SHIFT(11309),
  [14596] = {.count = 1, .reusable = true}, SHIFT(11309),
  [14598] = {.count = 1, .reusable = false}, SHIFT(11311),
  [14600] = {.count = 1, .reusable = false}, SHIFT(11312),
  [14602] = {.count = 1, .reusable = true}, SHIFT(11311),
  [14604] = {.count = 1, .reusable = true}, SHIFT(11306),
  [14606] = {.count = 1, .reusable = false}, SHIFT(11313),
  [14608] = {.count = 1, .reusable = true}, SHIFT(11315),
  [14610] = {.count = 1, .reusable = true}, SHIFT(11317),
  [14612] = {.count = 1, .reusable = false}, SHIFT(11317),
  [14614] = {.count = 1, .reusable = true}, SHIFT(11318),
  [14616] = {.count = 1, .reusable = false}, SHIFT(11307),
  [14618] = {.count = 1, .reusable = true}, SHIFT(11320),
  [14620] = {.count = 1, .reusable = true}, SHIFT(11326),
  [14622] = {.count = 1, .reusable = true}, SHIFT(11327),
  [14624] = {.count = 1, .reusable = true}, SHIFT(11329),
  [14626] = {.count = 1, .reusable = true}, REDUCE(sym_do_block, 6),
  [14628] = {.count = 1, .reusable = false}, REDUCE(sym_do_block, 6),
  [14630] = {.count = 1, .reusable = true}, SHIFT(10490),
  [14632] = {.count = 1, .reusable = true}, SHIFT(11334),
  [14634] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(8983),
  [14637] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9004),
  [14640] = {.count = 1, .reusable = true}, SHIFT(10524),
  [14642] = {.count = 1, .reusable = true}, SHIFT(11339),
  [14644] = {.count = 1, .reusable = true}, SHIFT(10545),
  [14646] = {.count = 1, .reusable = true}, SHIFT(11344),
  [14648] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9073),
  [14651] = {.count = 1, .reusable = true}, SHIFT(11345),
  [14653] = {.count = 1, .reusable = true}, SHIFT(11346),
  [14655] = {.count = 1, .reusable = true}, SHIFT(11348),
  [14657] = {.count = 1, .reusable = true}, SHIFT(11350),
  [14659] = {.count = 1, .reusable = true}, SHIFT(11351),
  [14661] = {.count = 1, .reusable = true}, SHIFT(11352),
  [14663] = {.count = 1, .reusable = true}, SHIFT(11353),
  [14665] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9125),
  [14668] = {.count = 1, .reusable = true}, SHIFT(11354),
  [14670] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9156),
  [14673] = {.count = 1, .reusable = true}, SHIFT(11355),
  [14675] = {.count = 1, .reusable = true}, SHIFT(10618),
  [14677] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9213),
  [14680] = {.count = 1, .reusable = true}, SHIFT(11358),
  [14682] = {.count = 1, .reusable = true}, SHIFT(11359),
  [14684] = {.count = 1, .reusable = true}, SHIFT(11360),
  [14686] = {.count = 1, .reusable = true}, SHIFT(11361),
  [14688] = {.count = 1, .reusable = true}, SHIFT(11362),
  [14690] = {.count = 1, .reusable = true}, SHIFT(11363),
  [14692] = {.count = 1, .reusable = true}, SHIFT(11364),
  [14694] = {.count = 1, .reusable = false}, SHIFT(11365),
  [14696] = {.count = 1, .reusable = false}, SHIFT(11366),
  [14698] = {.count = 1, .reusable = true}, SHIFT(11367),
  [14700] = {.count = 1, .reusable = false}, SHIFT(11367),
  [14702] = {.count = 1, .reusable = true}, SHIFT(11370),
  [14704] = {.count = 1, .reusable = true}, SHIFT(11372),
  [14706] = {.count = 1, .reusable = true}, SHIFT(11373),
  [14708] = {.count = 1, .reusable = false}, SHIFT(11374),
  [14710] = {.count = 1, .reusable = true}, SHIFT(11376),
  [14712] = {.count = 1, .reusable = true}, SHIFT(11378),
  [14714] = {.count = 1, .reusable = true}, SHIFT(10663),
  [14716] = {.count = 1, .reusable = true}, SHIFT(11383),
  [14718] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9287),
  [14721] = {.count = 1, .reusable = true}, SHIFT(10673),
  [14723] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9326),
  [14726] = {.count = 1, .reusable = true}, SHIFT(10678),
  [14728] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9346),
  [14731] = {.count = 1, .reusable = true}, SHIFT(10684),
  [14733] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9394),
  [14736] = {.count = 1, .reusable = true}, SHIFT(10690),
  [14738] = {.count = 1, .reusable = true}, SHIFT(11394),
  [14740] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9421),
  [14743] = {.count = 1, .reusable = true}, SHIFT(11395),
  [14745] = {.count = 1, .reusable = true}, SHIFT(10710),
  [14747] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9480),
  [14750] = {.count = 1, .reusable = true}, SHIFT(10715),
  [14752] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9500),
  [14755] = {.count = 1, .reusable = true}, SHIFT(11401),
  [14757] = {.count = 1, .reusable = false}, SHIFT(11401),
  [14759] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9535),
  [14762] = {.count = 1, .reusable = true}, SHIFT(10732),
  [14764] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9560),
  [14767] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9565),
  [14770] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9570),
  [14773] = {.count = 1, .reusable = true}, SHIFT(11405),
  [14775] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9609),
  [14778] = {.count = 1, .reusable = true}, SHIFT(11408),
  [14780] = {.count = 1, .reusable = true}, SHIFT(11409),
  [14782] = {.count = 1, .reusable = true}, SHIFT(11411),
  [14784] = {.count = 1, .reusable = true}, SHIFT(11413),
  [14786] = {.count = 1, .reusable = true}, SHIFT(11414),
  [14788] = {.count = 1, .reusable = true}, SHIFT(11415),
  [14790] = {.count = 1, .reusable = true}, SHIFT(11416),
  [14792] = {.count = 1, .reusable = true}, SHIFT(11417),
  [14794] = {.count = 1, .reusable = false}, SHIFT(11417),
  [14796] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9677),
  [14799] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9688),
  [14802] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9698),
  [14805] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9708),
  [14808] = {.count = 1, .reusable = true}, SHIFT(11421),
  [14810] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9739),
  [14813] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9760),
  [14816] = {.count = 1, .reusable = true}, SHIFT(10831),
  [14818] = {.count = 1, .reusable = true}, REDUCE(sym_elsif, 5),
  [14820] = {.count = 1, .reusable = true}, SHIFT(11426),
  [14822] = {.count = 1, .reusable = true}, SHIFT(10852),
  [14824] = {.count = 1, .reusable = true}, SHIFT(11431),
  [14826] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9831),
  [14829] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9837),
  [14832] = {.count = 1, .reusable = true}, SHIFT(11434),
  [14834] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9869),
  [14837] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(9890),
  [14840] = {.count = 1, .reusable = true}, SHIFT(10903),
  [14842] = {.count = 1, .reusable = true}, SHIFT(11439),
  [14844] = {.count = 1, .reusable = true}, SHIFT(10923),
  [14846] = {.count = 1, .reusable = true}, SHIFT(11444),
  [14848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9959),
  [14851] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9966),
  [14854] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(9971),
  [14857] = {.count = 1, .reusable = true}, SHIFT(11445),
  [14859] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10007),
  [14862] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10011),
  [14865] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10017),
  [14868] = {.count = 1, .reusable = true}, SHIFT(11448),
  [14870] = {.count = 1, .reusable = true}, SHIFT(11456),
  [14872] = {.count = 1, .reusable = true}, SHIFT(11457),
  [14874] = {.count = 1, .reusable = false}, SHIFT(11458),
  [14876] = {.count = 1, .reusable = true}, SHIFT(11459),
  [14878] = {.count = 1, .reusable = false}, SHIFT(11460),
  [14880] = {.count = 1, .reusable = false}, SHIFT(11461),
  [14882] = {.count = 1, .reusable = true}, SHIFT(11462),
  [14884] = {.count = 1, .reusable = false}, SHIFT(11463),
  [14886] = {.count = 1, .reusable = true}, SHIFT(11463),
  [14888] = {.count = 1, .reusable = true}, SHIFT(11465),
  [14890] = {.count = 1, .reusable = true}, SHIFT(11466),
  [14892] = {.count = 1, .reusable = false}, SHIFT(11465),
  [14894] = {.count = 1, .reusable = true}, SHIFT(11461),
  [14896] = {.count = 1, .reusable = true}, SHIFT(11458),
  [14898] = {.count = 1, .reusable = true}, SHIFT(11467),
  [14900] = {.count = 1, .reusable = true}, SHIFT(11468),
  [14902] = {.count = 1, .reusable = false}, SHIFT(11468),
  [14904] = {.count = 1, .reusable = true}, SHIFT(11469),
  [14906] = {.count = 1, .reusable = true}, SHIFT(11474),
  [14908] = {.count = 1, .reusable = false}, SHIFT(11474),
  [14910] = {.count = 1, .reusable = true}, SHIFT(11478),
  [14912] = {.count = 1, .reusable = false}, SHIFT(11476),
  [14914] = {.count = 1, .reusable = true}, SHIFT(11495),
  [14916] = {.count = 1, .reusable = false}, SHIFT(11495),
  [14918] = {.count = 1, .reusable = true}, SHIFT(11499),
  [14920] = {.count = 1, .reusable = false}, SHIFT(11497),
  [14922] = {.count = 1, .reusable = true}, SHIFT(10050),
  [14924] = {.count = 2, .reusable = true}, REDUCE(aux_sym__statements_repeat1, 2), SHIFT_REPEAT(11510),
  [14927] = {.count = 1, .reusable = true}, SHIFT(11511),
  [14929] = {.count = 1, .reusable = true}, SHIFT(11515),
  [14931] = {.count = 1, .reusable = true}, SHIFT(11516),
  [14933] = {.count = 1, .reusable = false}, SHIFT(11517),
  [14935] = {.count = 1, .reusable = false}, SHIFT(11518),
  [14937] = {.count = 1, .reusable = false}, SHIFT(11519),
  [14939] = {.count = 1, .reusable = false}, SHIFT(11520),
  [14941] = {.count = 1, .reusable = true}, SHIFT(11521),
  [14943] = {.count = 1, .reusable = false}, SHIFT(11522),
  [14945] = {.count = 1, .reusable = true}, SHIFT(11522),
  [14947] = {.count = 1, .reusable = false}, SHIFT(11524),
  [14949] = {.count = 1, .reusable = false}, SHIFT(11525),
  [14951] = {.count = 1, .reusable = true}, SHIFT(11524),
  [14953] = {.count = 1, .reusable = true}, SHIFT(11520),
  [14955] = {.count = 1, .reusable = false}, SHIFT(11526),
  [14957] = {.count = 1, .reusable = true}, SHIFT(11527),
  [14959] = {.count = 1, .reusable = false}, SHIFT(11527),
  [14961] = {.count = 1, .reusable = true}, SHIFT(11528),
  [14963] = {.count = 1, .reusable = true}, SHIFT(10093),
  [14965] = {.count = 1, .reusable = true}, SHIFT(11556),
  [14967] = {.count = 1, .reusable = true}, SHIFT(11557),
  [14969] = {.count = 1, .reusable = false}, SHIFT(11558),
  [14971] = {.count = 1, .reusable = true}, SHIFT(11559),
  [14973] = {.count = 1, .reusable = false}, SHIFT(11560),
  [14975] = {.count = 1, .reusable = false}, SHIFT(11561),
  [14977] = {.count = 1, .reusable = true}, SHIFT(11562),
  [14979] = {.count = 1, .reusable = false}, SHIFT(11563),
  [14981] = {.count = 1, .reusable = true}, SHIFT(11563),
  [14983] = {.count = 1, .reusable = true}, SHIFT(11565),
  [14985] = {.count = 1, .reusable = true}, SHIFT(11566),
  [14987] = {.count = 1, .reusable = false}, SHIFT(11565),
  [14989] = {.count = 1, .reusable = true}, SHIFT(11561),
  [14991] = {.count = 1, .reusable = true}, SHIFT(11558),
  [14993] = {.count = 1, .reusable = true}, SHIFT(11567),
  [14995] = {.count = 1, .reusable = true}, SHIFT(11568),
  [14997] = {.count = 1, .reusable = true}, SHIFT(11570),
  [14999] = {.count = 1, .reusable = false}, SHIFT(11570),
  [15001] = {.count = 1, .reusable = true}, SHIFT(11571),
  [15003] = {.count = 1, .reusable = true}, REDUCE(sym_when, 6),
  [15005] = {.count = 1, .reusable = true}, SHIFT(11572),
  [15007] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10139),
  [15010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10144),
  [15013] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10149),
  [15016] = {.count = 1, .reusable = true}, SHIFT(11575),
  [15018] = {.count = 1, .reusable = true}, SHIFT(10161),
  [15020] = {.count = 1, .reusable = true}, SHIFT(11582),
  [15022] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(10191),
  [15025] = {.count = 1, .reusable = true}, SHIFT(11169),
  [15027] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10222),
  [15030] = {.count = 1, .reusable = true}, SHIFT(11176),
  [15032] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10256),
  [15035] = {.count = 1, .reusable = true}, SHIFT(11181),
  [15037] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10276),
  [15040] = {.count = 1, .reusable = true}, SHIFT(11189),
  [15042] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10324),
  [15045] = {.count = 1, .reusable = true}, SHIFT(11194),
  [15047] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10344),
  [15050] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10362),
  [15053] = {.count = 1, .reusable = true}, SHIFT(11203),
  [15055] = {.count = 1, .reusable = true}, SHIFT(11206),
  [15057] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 6),
  [15059] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 6),
  [15061] = {.count = 1, .reusable = true}, SHIFT(11604),
  [15063] = {.count = 1, .reusable = true}, SHIFT(11605),
  [15065] = {.count = 1, .reusable = false}, SHIFT(11606),
  [15067] = {.count = 1, .reusable = true}, SHIFT(11607),
  [15069] = {.count = 1, .reusable = false}, SHIFT(11608),
  [15071] = {.count = 1, .reusable = false}, SHIFT(11609),
  [15073] = {.count = 1, .reusable = true}, SHIFT(11610),
  [15075] = {.count = 1, .reusable = false}, SHIFT(11611),
  [15077] = {.count = 1, .reusable = true}, SHIFT(11611),
  [15079] = {.count = 1, .reusable = true}, SHIFT(11613),
  [15081] = {.count = 1, .reusable = true}, SHIFT(11614),
  [15083] = {.count = 1, .reusable = false}, SHIFT(11613),
  [15085] = {.count = 1, .reusable = true}, SHIFT(11609),
  [15087] = {.count = 1, .reusable = true}, SHIFT(11606),
  [15089] = {.count = 1, .reusable = true}, SHIFT(11615),
  [15091] = {.count = 1, .reusable = true}, SHIFT(11616),
  [15093] = {.count = 1, .reusable = false}, SHIFT(11616),
  [15095] = {.count = 1, .reusable = true}, SHIFT(11617),
  [15097] = {.count = 1, .reusable = true}, SHIFT(11622),
  [15099] = {.count = 1, .reusable = false}, SHIFT(11622),
  [15101] = {.count = 1, .reusable = true}, SHIFT(11626),
  [15103] = {.count = 1, .reusable = false}, SHIFT(11624),
  [15105] = {.count = 1, .reusable = true}, SHIFT(11643),
  [15107] = {.count = 1, .reusable = false}, SHIFT(11643),
  [15109] = {.count = 1, .reusable = true}, SHIFT(11647),
  [15111] = {.count = 1, .reusable = false}, SHIFT(11645),
  [15113] = {.count = 1, .reusable = true}, SHIFT(10427),
  [15115] = {.count = 1, .reusable = true}, SHIFT(11657),
  [15117] = {.count = 1, .reusable = true}, SHIFT(11661),
  [15119] = {.count = 1, .reusable = true}, SHIFT(11662),
  [15121] = {.count = 1, .reusable = false}, SHIFT(11663),
  [15123] = {.count = 1, .reusable = false}, SHIFT(11664),
  [15125] = {.count = 1, .reusable = false}, SHIFT(11665),
  [15127] = {.count = 1, .reusable = false}, SHIFT(11666),
  [15129] = {.count = 1, .reusable = true}, SHIFT(11667),
  [15131] = {.count = 1, .reusable = false}, SHIFT(11668),
  [15133] = {.count = 1, .reusable = true}, SHIFT(11668),
  [15135] = {.count = 1, .reusable = false}, SHIFT(11670),
  [15137] = {.count = 1, .reusable = false}, SHIFT(11671),
  [15139] = {.count = 1, .reusable = true}, SHIFT(11670),
  [15141] = {.count = 1, .reusable = true}, SHIFT(11666),
  [15143] = {.count = 1, .reusable = false}, SHIFT(11672),
  [15145] = {.count = 1, .reusable = true}, SHIFT(11673),
  [15147] = {.count = 1, .reusable = false}, SHIFT(11673),
  [15149] = {.count = 1, .reusable = true}, SHIFT(11674),
  [15151] = {.count = 1, .reusable = true}, SHIFT(10461),
  [15153] = {.count = 1, .reusable = true}, SHIFT(11701),
  [15155] = {.count = 1, .reusable = true}, SHIFT(11703),
  [15157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10490),
  [15160] = {.count = 1, .reusable = true}, SHIFT(11335),
  [15162] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10524),
  [15165] = {.count = 1, .reusable = true}, SHIFT(11340),
  [15167] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10545),
  [15170] = {.count = 1, .reusable = true}, SHIFT(11710),
  [15172] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10618),
  [15175] = {.count = 1, .reusable = true}, SHIFT(11712),
  [15177] = {.count = 1, .reusable = true}, SHIFT(11713),
  [15179] = {.count = 1, .reusable = true}, SHIFT(11715),
  [15181] = {.count = 1, .reusable = true}, SHIFT(11717),
  [15183] = {.count = 1, .reusable = true}, SHIFT(11718),
  [15185] = {.count = 1, .reusable = true}, SHIFT(11719),
  [15187] = {.count = 1, .reusable = true}, SHIFT(11720),
  [15189] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10663),
  [15192] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10673),
  [15195] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10678),
  [15198] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10684),
  [15201] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10690),
  [15204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10710),
  [15207] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10715),
  [15210] = {.count = 1, .reusable = true}, SHIFT(11721),
  [15212] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10732),
  [15215] = {.count = 1, .reusable = true}, SHIFT(11406),
  [15217] = {.count = 1, .reusable = true}, SHIFT(11724),
  [15219] = {.count = 1, .reusable = true}, SHIFT(11725),
  [15221] = {.count = 1, .reusable = true}, SHIFT(11422),
  [15223] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10831),
  [15226] = {.count = 1, .reusable = true}, SHIFT(11427),
  [15228] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10852),
  [15231] = {.count = 1, .reusable = true}, SHIFT(11435),
  [15233] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10903),
  [15236] = {.count = 1, .reusable = true}, SHIFT(11440),
  [15238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(10923),
  [15241] = {.count = 1, .reusable = true}, SHIFT(11446),
  [15243] = {.count = 1, .reusable = true}, SHIFT(11449),
  [15245] = {.count = 1, .reusable = true}, SHIFT(11003),
  [15247] = {.count = 1, .reusable = true}, SHIFT(11764),
  [15249] = {.count = 1, .reusable = true}, SHIFT(11027),
  [15251] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11034),
  [15254] = {.count = 1, .reusable = true}, SHIFT(11790),
  [15256] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11093),
  [15259] = {.count = 1, .reusable = true}, SHIFT(11573),
  [15261] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11141),
  [15264] = {.count = 1, .reusable = true}, SHIFT(11583),
  [15266] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11169),
  [15269] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11176),
  [15272] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11181),
  [15275] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11189),
  [15278] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11194),
  [15281] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11203),
  [15284] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11206),
  [15287] = {.count = 1, .reusable = true}, SHIFT(11233),
  [15289] = {.count = 1, .reusable = true}, SHIFT(11834),
  [15291] = {.count = 1, .reusable = true}, SHIFT(11257),
  [15293] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11264),
  [15296] = {.count = 1, .reusable = true}, SHIFT(11860),
  [15298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11315),
  [15301] = {.count = 1, .reusable = true}, SHIFT(11699),
  [15303] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 7),
  [15305] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 7),
  [15307] = {.count = 1, .reusable = true}, SHIFT(11864),
  [15309] = {.count = 1, .reusable = true}, SHIFT(11865),
  [15311] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11335),
  [15314] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11340),
  [15317] = {.count = 1, .reusable = true}, SHIFT(11866),
  [15319] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11406),
  [15322] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11422),
  [15325] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11427),
  [15328] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11435),
  [15331] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11440),
  [15334] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11446),
  [15337] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11449),
  [15340] = {.count = 1, .reusable = true}, SHIFT(11869),
  [15342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11478),
  [15345] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11499),
  [15348] = {.count = 1, .reusable = true}, SHIFT(11771),
  [15350] = {.count = 1, .reusable = true}, SHIFT(11874),
  [15352] = {.count = 1, .reusable = true}, SHIFT(11791),
  [15354] = {.count = 1, .reusable = true}, SHIFT(11879),
  [15356] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11568),
  [15359] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11573),
  [15362] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11583),
  [15365] = {.count = 1, .reusable = true}, SHIFT(11880),
  [15367] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11626),
  [15370] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(11647),
  [15373] = {.count = 1, .reusable = true}, SHIFT(11841),
  [15375] = {.count = 1, .reusable = true}, SHIFT(11885),
  [15377] = {.count = 1, .reusable = true}, SHIFT(11861),
  [15379] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11699),
  [15382] = {.count = 1, .reusable = true}, REDUCE(sym_block_parameters, 8),
  [15384] = {.count = 1, .reusable = false}, REDUCE(sym_block_parameters, 8),
  [15386] = {.count = 1, .reusable = true}, SHIFT(11870),
  [15388] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11771),
  [15391] = {.count = 1, .reusable = true}, SHIFT(11875),
  [15393] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11791),
  [15396] = {.count = 1, .reusable = true}, SHIFT(11881),
  [15398] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11841),
  [15401] = {.count = 1, .reusable = true}, SHIFT(11886),
  [15403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11861),
  [15406] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11870),
  [15409] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11875),
  [15412] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11881),
  [15415] = {.count = 2, .reusable = true}, REDUCE(aux_sym_exceptions_repeat1, 2), SHIFT_REPEAT(11886),
};

void *tree_sitter_ruby_external_scanner_create();
void tree_sitter_ruby_external_scanner_destroy(void *);
bool tree_sitter_ruby_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_ruby_external_scanner_serialize(void *, char *);
void tree_sitter_ruby_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_ruby() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_ruby_external_scanner_create,
      tree_sitter_ruby_external_scanner_destroy,
      tree_sitter_ruby_external_scanner_scan,
      tree_sitter_ruby_external_scanner_serialize,
      tree_sitter_ruby_external_scanner_deserialize,
    },
  };
  return &language;
}
